diff -pruN 2.10.0-1/NEWS 2.11.0-1/NEWS
--- 2.10.0-1/NEWS	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/NEWS	2024-06-25 12:36:50.000000000 +0000
@@ -1,5 +1,5 @@
 Copyright © 2009 CNRS
-Copyright © 2009-2023 Inria.  All rights reserved.
+Copyright © 2009-2024 Inria.  All rights reserved.
 Copyright © 2009-2013 Université Bordeaux
 Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.
 Copyright © 2020 Hewlett Packard Enterprise.  All rights reserved.
@@ -17,6 +17,47 @@ bug fixes (and other actions) for each v
 0.9.
 
 
+Version 2.11.0
+--------------
+* API
+  + Add HWLOC_MEMBIND_WEIGHTED_INTERLEAVE memory binding policy on
+    Linux 6.9+. Thanks to Honggyu Kim for the patch.
+    - weighted_interleave_membind is added to membind support bits.
+    - The "weighted" policy is added to the hwloc-bind tool.
+  + Add hwloc_obj_set_subtype(). Thanks to Hadrien Grasland for the report.
+* GPU support
+  + Don't hide the GPU NUMA node on NVIDIA Grace Hopper.
+  + Get Intel GPU OpenCL device locality.
+  + Add bandwidths between subdevices in the LevelZero XeLinkBandwidth
+    matrix.
+  + Fix PCI Gen4+ link speed of NVIDIA GPU obtained from NVML,
+    thanks to Akram Sbaih for the report.
+* Windows support
+  + Fix Windows support when UNICODE is enabled, several hwloc features
+    were missing, thanks to Martin for the report.
+  + Fix the enabling of CUDA in Windows CMake build,
+    Thanks to Moritz Kreutzer for the patch.
+  + Fix CUDA/OpenCL test source path in Windows CMake.
+* Tools
+  + Option --best-memattr may now return multiple nodes. Additional
+    configuration flags may be given to tweak its behavior.
+  + hwloc-info has a new --get-attr option to get a single attribute.
+  + hwloc-info now supports "levels", "support" and "topology"
+    special keywords for backward compatibility for hwloc 3.0.
+  + The --taskset command-line option is superseded by the new
+    --cpuset-output-format which also allows to export as list.
+  + hwloc-calc may now import bitmasks described as a list of bits
+    with the new "--cpuset-input-format list".
+* Misc
+  + The MemoryTiersNr info attribute in the root object now says how many
+    memory tiers were built. Thanks to Antoine Morvan for the report.
+  + Fix the management of infinite cpusets in the bitmap printf/sscanf
+    API as well as in command-line tools.
+  + Add section "Compiling software on top of hwloc's C API" in the
+    documentation with examples for GNU Make and CMake,
+    thanks to Florent Pruvost for the help.
+
+
 Version 2.10.0
 --------------
 * Heterogeneous Memory core improvements
diff -pruN 2.10.0-1/README 2.11.0-1/README
--- 2.10.0-1/README	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/README	2024-06-25 12:42:28.000000000 +0000
@@ -418,14 +418,8 @@ return 0;
 }
 
 hwloc provides a pkg-config executable to obtain relevant compiler and linker
-flags. For example, it can be used thusly to compile applications that utilize
-the hwloc library (assuming GNU Make):
-
-CFLAGS += $(shell pkg-config --cflags hwloc)
-LDLIBS += $(shell pkg-config --libs hwloc)
-
-hwloc-hello: hwloc-hello.c
-     $(CC) hwloc-hello.c $(CFLAGS) -o hwloc-hello $(LDLIBS)
+flags. See Compiling software on top of hwloc's C API for details on building
+program on top of hwloc's API using GNU Make or CMake.
 
 On a machine 2 processor packages -- each package of which has two processing
 cores -- the output from running hwloc-hello could be something like the
diff -pruN 2.10.0-1/VERSION 2.11.0-1/VERSION
--- 2.10.0-1/VERSION	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/VERSION	2024-06-25 12:41:50.000000000 +0000
@@ -8,7 +8,7 @@
 # Please update HWLOC_VERSION* in contrib/windows/hwloc_config.h too.
 
 major=2
-minor=10
+minor=11
 release=0
 
 # greek is used for alpha or beta release tags.  If it is non-empty,
@@ -22,7 +22,7 @@ greek=
 
 # The date when this release was created
 
-date="Dec 04, 2023"
+date="Jun 25, 2024"
 
 # If snapshot=1, then use the value from snapshot_version as the
 # entire hwloc version (i.e., ignore major, minor, release, and
@@ -41,6 +41,6 @@ snapshot_version=${major}.${minor}.${rel
 # 2. Version numbers are described in the Libtool current:revision:age
 # format.
 
-libhwloc_so_version=22:0:7
+libhwloc_so_version=23:0:8
 
 # Please also update the <TargetName> lines in contrib/windows/libhwloc.vcxproj
diff -pruN 2.10.0-1/aclocal.m4 2.11.0-1/aclocal.m4
--- 2.10.0-1/aclocal.m4	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/aclocal.m4	2024-06-25 12:41:53.000000000 +0000
@@ -14,8 +14,8 @@
 m4_ifndef([AC_CONFIG_MACRO_DIRS], [m4_defun([_AM_CONFIG_MACRO_DIRS], [])m4_defun([AC_CONFIG_MACRO_DIRS], [_AM_CONFIG_MACRO_DIRS($@)])])
 m4_ifndef([AC_AUTOCONF_VERSION],
   [m4_copy([m4_PACKAGE_VERSION], [AC_AUTOCONF_VERSION])])dnl
-m4_if(m4_defn([AC_AUTOCONF_VERSION]), [2.71],,
-[m4_warning([this file was generated for autoconf 2.71.
+m4_if(m4_defn([AC_AUTOCONF_VERSION]), [2.72],,
+[m4_warning([this file was generated for autoconf 2.72.
 You have another version of autoconf.  It may work, but is not guaranteed to.
 If you have problems, you may need to regenerate the build system entirely.
 To do so, use the procedure documented by the package, typically 'autoreconf'.])])
diff -pruN 2.10.0-1/config/config.guess 2.11.0-1/config/config.guess
--- 2.10.0-1/config/config.guess	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/config/config.guess	2024-06-25 12:41:55.000000000 +0000
@@ -1,14 +1,14 @@
 #! /bin/sh
 # Attempt to guess a canonical system name.
-#   Copyright 1992-2021 Free Software Foundation, Inc.
+#   Copyright 1992-2023 Free Software Foundation, Inc.
 
 # shellcheck disable=SC2006,SC2268 # see below for rationale
 
-timestamp='2021-06-03'
+timestamp='2023-08-22'
 
 # This file is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 3 of the License, or
+# the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful, but
@@ -47,7 +47,7 @@ me=`echo "$0" | sed -e 's,.*/,,'`
 usage="\
 Usage: $0 [OPTION]
 
-Output the configuration name of the system \`$me' is run on.
+Output the configuration name of the system '$me' is run on.
 
 Options:
   -h, --help         print this help, then exit
@@ -60,13 +60,13 @@ version="\
 GNU config.guess ($timestamp)
 
 Originally written by Per Bothner.
-Copyright 1992-2021 Free Software Foundation, Inc.
+Copyright 1992-2023 Free Software Foundation, Inc.
 
 This is free software; see the source for copying conditions.  There is NO
 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
 
 help="
-Try \`$me --help' for more information."
+Try '$me --help' for more information."
 
 # Parse command line
 while test $# -gt 0 ; do
@@ -102,8 +102,8 @@ GUESS=
 # temporary files to be created and, as you can see below, it is a
 # headache to deal with in a portable fashion.
 
-# Historically, `CC_FOR_BUILD' used to be named `HOST_CC'. We still
-# use `HOST_CC' if defined, but it is deprecated.
+# Historically, 'CC_FOR_BUILD' used to be named 'HOST_CC'. We still
+# use 'HOST_CC' if defined, but it is deprecated.
 
 # Portable tmp directory creation inspired by the Autoconf team.
 
@@ -155,6 +155,9 @@ Linux|GNU|GNU/*)
 
 	set_cc_for_build
 	cat <<-EOF > "$dummy.c"
+	#if defined(__ANDROID__)
+	LIBC=android
+	#else
 	#include <features.h>
 	#if defined(__UCLIBC__)
 	LIBC=uclibc
@@ -169,6 +172,7 @@ Linux|GNU|GNU/*)
 	LIBC=musl
 	#endif
 	#endif
+	#endif
 	EOF
 	cc_set_libc=`$CC_FOR_BUILD -E "$dummy.c" 2>/dev/null | grep '^LIBC' | sed 's, ,,g'`
 	eval "$cc_set_libc"
@@ -437,7 +441,7 @@ case $UNAME_MACHINE:$UNAME_SYSTEM:$UNAME
 	# This test works for both compilers.
 	if test "$CC_FOR_BUILD" != no_compiler_found; then
 	    if (echo '#ifdef __amd64'; echo IS_64BIT_ARCH; echo '#endif') | \
-		(CCOPTS="" $CC_FOR_BUILD -E - 2>/dev/null) | \
+		(CCOPTS="" $CC_FOR_BUILD -m64 -E - 2>/dev/null) | \
 		grep IS_64BIT_ARCH >/dev/null
 	    then
 		SUN_ARCH=x86_64
@@ -459,7 +463,7 @@ case $UNAME_MACHINE:$UNAME_SYSTEM:$UNAME
 		UNAME_RELEASE=`uname -v`
 		;;
 	esac
-	# Japanese Language versions have a version number like `4.1.3-JL'.
+	# Japanese Language versions have a version number like '4.1.3-JL'.
 	SUN_REL=`echo "$UNAME_RELEASE" | sed -e 's/-/_/'`
 	GUESS=sparc-sun-sunos$SUN_REL
 	;;
@@ -904,7 +908,7 @@ EOF
 	fi
 	;;
     *:FreeBSD:*:*)
-	UNAME_PROCESSOR=`/usr/bin/uname -p`
+	UNAME_PROCESSOR=`uname -p`
 	case $UNAME_PROCESSOR in
 	    amd64)
 		UNAME_PROCESSOR=x86_64 ;;
@@ -929,6 +933,9 @@ EOF
     i*:PW*:*)
 	GUESS=$UNAME_MACHINE-pc-pw32
 	;;
+    *:SerenityOS:*:*)
+        GUESS=$UNAME_MACHINE-pc-serenity
+        ;;
     *:Interix*:*)
 	case $UNAME_MACHINE in
 	    x86)
@@ -963,11 +970,37 @@ EOF
 	GNU_REL=`echo "$UNAME_RELEASE" | sed -e 's/[-(].*//'`
 	GUESS=$UNAME_MACHINE-unknown-$GNU_SYS$GNU_REL-$LIBC
 	;;
+    x86_64:[Mm]anagarm:*:*|i?86:[Mm]anagarm:*:*)
+	GUESS="$UNAME_MACHINE-pc-managarm-mlibc"
+	;;
+    *:[Mm]anagarm:*:*)
+	GUESS="$UNAME_MACHINE-unknown-managarm-mlibc"
+	;;
     *:Minix:*:*)
 	GUESS=$UNAME_MACHINE-unknown-minix
 	;;
     aarch64:Linux:*:*)
-	GUESS=$UNAME_MACHINE-unknown-linux-$LIBC
+	set_cc_for_build
+	CPU=$UNAME_MACHINE
+	LIBCABI=$LIBC
+	if test "$CC_FOR_BUILD" != no_compiler_found; then
+	    ABI=64
+	    sed 's/^	    //' << EOF > "$dummy.c"
+	    #ifdef __ARM_EABI__
+	    #ifdef __ARM_PCS_VFP
+	    ABI=eabihf
+	    #else
+	    ABI=eabi
+	    #endif
+	    #endif
+EOF
+	    cc_set_abi=`$CC_FOR_BUILD -E "$dummy.c" 2>/dev/null | grep '^ABI' | sed 's, ,,g'`
+	    eval "$cc_set_abi"
+	    case $ABI in
+		eabi | eabihf) CPU=armv8l; LIBCABI=$LIBC$ABI ;;
+	    esac
+	fi
+	GUESS=$CPU-unknown-linux-$LIBCABI
 	;;
     aarch64_be:Linux:*:*)
 	UNAME_MACHINE=aarch64_be
@@ -1033,7 +1066,16 @@ EOF
     k1om:Linux:*:*)
 	GUESS=$UNAME_MACHINE-unknown-linux-$LIBC
 	;;
-    loongarch32:Linux:*:* | loongarch64:Linux:*:* | loongarchx32:Linux:*:*)
+    kvx:Linux:*:*)
+	GUESS=$UNAME_MACHINE-unknown-linux-$LIBC
+	;;
+    kvx:cos:*:*)
+	GUESS=$UNAME_MACHINE-unknown-cos
+	;;
+    kvx:mbr:*:*)
+	GUESS=$UNAME_MACHINE-unknown-mbr
+	;;
+    loongarch32:Linux:*:* | loongarch64:Linux:*:*)
 	GUESS=$UNAME_MACHINE-unknown-linux-$LIBC
 	;;
     m32r*:Linux:*:*)
@@ -1148,16 +1190,27 @@ EOF
 	;;
     x86_64:Linux:*:*)
 	set_cc_for_build
+	CPU=$UNAME_MACHINE
 	LIBCABI=$LIBC
 	if test "$CC_FOR_BUILD" != no_compiler_found; then
-	    if (echo '#ifdef __ILP32__'; echo IS_X32; echo '#endif') | \
-		(CCOPTS="" $CC_FOR_BUILD -E - 2>/dev/null) | \
-		grep IS_X32 >/dev/null
-	    then
-		LIBCABI=${LIBC}x32
-	    fi
+	    ABI=64
+	    sed 's/^	    //' << EOF > "$dummy.c"
+	    #ifdef __i386__
+	    ABI=x86
+	    #else
+	    #ifdef __ILP32__
+	    ABI=x32
+	    #endif
+	    #endif
+EOF
+	    cc_set_abi=`$CC_FOR_BUILD -E "$dummy.c" 2>/dev/null | grep '^ABI' | sed 's, ,,g'`
+	    eval "$cc_set_abi"
+	    case $ABI in
+		x86) CPU=i686 ;;
+		x32) LIBCABI=${LIBC}x32 ;;
+	    esac
 	fi
-	GUESS=$UNAME_MACHINE-pc-linux-$LIBCABI
+	GUESS=$CPU-pc-linux-$LIBCABI
 	;;
     xtensa*:Linux:*:*)
 	GUESS=$UNAME_MACHINE-unknown-linux-$LIBC
@@ -1177,7 +1230,7 @@ EOF
 	GUESS=$UNAME_MACHINE-pc-sysv4.2uw$UNAME_VERSION
 	;;
     i*86:OS/2:*:*)
-	# If we were able to find `uname', then EMX Unix compatibility
+	# If we were able to find 'uname', then EMX Unix compatibility
 	# is probably installed.
 	GUESS=$UNAME_MACHINE-pc-os2-emx
 	;;
@@ -1318,7 +1371,7 @@ EOF
 		GUESS=ns32k-sni-sysv
 	fi
 	;;
-    PENTIUM:*:4.0*:*)	# Unisys `ClearPath HMP IX 4000' SVR4/MP effort
+    PENTIUM:*:4.0*:*)	# Unisys 'ClearPath HMP IX 4000' SVR4/MP effort
 			# says <Richard.M.Bartel@ccMail.Census.GOV>
 	GUESS=i586-unisys-sysv4
 	;;
@@ -1364,8 +1417,11 @@ EOF
     BePC:Haiku:*:*)	# Haiku running on Intel PC compatible.
 	GUESS=i586-pc-haiku
 	;;
-    x86_64:Haiku:*:*)
-	GUESS=x86_64-unknown-haiku
+    ppc:Haiku:*:*)	# Haiku running on Apple PowerPC
+	GUESS=powerpc-apple-haiku
+	;;
+    *:Haiku:*:*)	# Haiku modern gcc (not bound by BeOS compat)
+	GUESS=$UNAME_MACHINE-unknown-haiku
 	;;
     SX-4:SUPER-UX:*:*)
 	GUESS=sx4-nec-superux$UNAME_RELEASE
@@ -1522,6 +1578,9 @@ EOF
     i*86:rdos:*:*)
 	GUESS=$UNAME_MACHINE-pc-rdos
 	;;
+    i*86:Fiwix:*:*)
+	GUESS=$UNAME_MACHINE-pc-fiwix
+	;;
     *:AROS:*:*)
 	GUESS=$UNAME_MACHINE-unknown-aros
 	;;
diff -pruN 2.10.0-1/config/config.sub 2.11.0-1/config/config.sub
--- 2.10.0-1/config/config.sub	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/config/config.sub	2024-06-25 12:41:55.000000000 +0000
@@ -1,14 +1,14 @@
 #! /bin/sh
 # Configuration validation subroutine script.
-#   Copyright 1992-2021 Free Software Foundation, Inc.
+#   Copyright 1992-2023 Free Software Foundation, Inc.
 
 # shellcheck disable=SC2006,SC2268 # see below for rationale
 
-timestamp='2021-08-14'
+timestamp='2023-09-19'
 
 # This file is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 3 of the License, or
+# the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful, but
@@ -76,13 +76,13 @@ Report bugs and patches to <config-patch
 version="\
 GNU config.sub ($timestamp)
 
-Copyright 1992-2021 Free Software Foundation, Inc.
+Copyright 1992-2023 Free Software Foundation, Inc.
 
 This is free software; see the source for copying conditions.  There is NO
 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
 
 help="
-Try \`$me --help' for more information."
+Try '$me --help' for more information."
 
 # Parse command line
 while test $# -gt 0 ; do
@@ -130,7 +130,7 @@ IFS=$saved_IFS
 # Separate into logical components for further validation
 case $1 in
 	*-*-*-*-*)
-		echo Invalid configuration \`"$1"\': more than four components >&2
+		echo "Invalid configuration '$1': more than four components" >&2
 		exit 1
 		;;
 	*-*-*-*)
@@ -145,7 +145,8 @@ case $1 in
 			nto-qnx* | linux-* | uclinux-uclibc* \
 			| uclinux-gnu* | kfreebsd*-gnu* | knetbsd*-gnu* | netbsd*-gnu* \
 			| netbsd*-eabi* | kopensolaris*-gnu* | cloudabi*-eabi* \
-			| storm-chaos* | os2-emx* | rtmk-nova*)
+			| storm-chaos* | os2-emx* | rtmk-nova* | managarm-* \
+			| windows-* )
 				basic_machine=$field1
 				basic_os=$maybe_os
 				;;
@@ -943,7 +944,7 @@ $basic_machine
 EOF
 		IFS=$saved_IFS
 		;;
-	# We use `pc' rather than `unknown'
+	# We use 'pc' rather than 'unknown'
 	# because (1) that's what they normally are, and
 	# (2) the word "unknown" tends to confuse beginning users.
 	i*86 | x86_64)
@@ -1020,6 +1021,11 @@ case $cpu-$vendor in
 		;;
 
 	# Here we normalize CPU types with a missing or matching vendor
+	armh-unknown | armh-alt)
+		cpu=armv7l
+		vendor=alt
+		basic_os=${basic_os:-linux-gnueabihf}
+		;;
 	dpx20-unknown | dpx20-bull)
 		cpu=rs6000
 		vendor=bull
@@ -1070,7 +1076,7 @@ case $cpu-$vendor in
 	pentium-* | p5-* | k5-* | k6-* | nexgen-* | viac3-*)
 		cpu=i586
 		;;
-	pentiumpro-* | p6-* | 6x86-* | athlon-* | athalon_*-*)
+	pentiumpro-* | p6-* | 6x86-* | athlon-* | athlon_*-*)
 		cpu=i686
 		;;
 	pentiumii-* | pentium2-* | pentiumiii-* | pentium3-*)
@@ -1121,7 +1127,7 @@ case $cpu-$vendor in
 	xscale-* | xscalee[bl]-*)
 		cpu=`echo "$cpu" | sed 's/^xscale/arm/'`
 		;;
-	arm64-*)
+	arm64-* | aarch64le-*)
 		cpu=aarch64
 		;;
 
@@ -1175,7 +1181,7 @@ case $cpu-$vendor in
 		case $cpu in
 			1750a | 580 \
 			| a29k \
-			| aarch64 | aarch64_be \
+			| aarch64 | aarch64_be | aarch64c | arm64ec \
 			| abacus \
 			| alpha | alphaev[4-8] | alphaev56 | alphaev6[78] \
 			| alpha64 | alpha64ev[4-8] | alpha64ev56 | alpha64ev6[78] \
@@ -1194,45 +1200,23 @@ case $cpu-$vendor in
 			| d10v | d30v | dlx | dsp16xx \
 			| e2k | elxsi | epiphany \
 			| f30[01] | f700 | fido | fr30 | frv | ft32 | fx80 \
+			| javascript \
 			| h8300 | h8500 \
 			| hppa | hppa1.[01] | hppa2.0 | hppa2.0[nw] | hppa64 \
 			| hexagon \
 			| i370 | i*86 | i860 | i960 | ia16 | ia64 \
 			| ip2k | iq2000 \
 			| k1om \
+			| kvx \
 			| le32 | le64 \
 			| lm32 \
-			| loongarch32 | loongarch64 | loongarchx32 \
+			| loongarch32 | loongarch64 \
 			| m32c | m32r | m32rle \
 			| m5200 | m68000 | m680[012346]0 | m68360 | m683?2 | m68k \
 			| m6811 | m68hc11 | m6812 | m68hc12 | m68hcs12x \
 			| m88110 | m88k | maxq | mb | mcore | mep | metag \
 			| microblaze | microblazeel \
-			| mips | mipsbe | mipseb | mipsel | mipsle \
-			| mips16 \
-			| mips64 | mips64eb | mips64el \
-			| mips64octeon | mips64octeonel \
-			| mips64orion | mips64orionel \
-			| mips64r5900 | mips64r5900el \
-			| mips64vr | mips64vrel \
-			| mips64vr4100 | mips64vr4100el \
-			| mips64vr4300 | mips64vr4300el \
-			| mips64vr5000 | mips64vr5000el \
-			| mips64vr5900 | mips64vr5900el \
-			| mipsisa32 | mipsisa32el \
-			| mipsisa32r2 | mipsisa32r2el \
-			| mipsisa32r3 | mipsisa32r3el \
-			| mipsisa32r5 | mipsisa32r5el \
-			| mipsisa32r6 | mipsisa32r6el \
-			| mipsisa64 | mipsisa64el \
-			| mipsisa64r2 | mipsisa64r2el \
-			| mipsisa64r3 | mipsisa64r3el \
-			| mipsisa64r5 | mipsisa64r5el \
-			| mipsisa64r6 | mipsisa64r6el \
-			| mipsisa64sb1 | mipsisa64sb1el \
-			| mipsisa64sr71k | mipsisa64sr71kel \
-			| mipsr5900 | mipsr5900el \
-			| mipstx39 | mipstx39el \
+			| mips* \
 			| mmix \
 			| mn10200 | mn10300 \
 			| moxie \
@@ -1280,7 +1264,7 @@ case $cpu-$vendor in
 				;;
 
 			*)
-				echo Invalid configuration \`"$1"\': machine \`"$cpu-$vendor"\' not recognized 1>&2
+				echo "Invalid configuration '$1': machine '$cpu-$vendor' not recognized" 1>&2
 				exit 1
 				;;
 		esac
@@ -1301,11 +1285,12 @@ esac
 
 # Decode manufacturer-specific aliases for certain operating systems.
 
-if test x$basic_os != x
+if test x"$basic_os" != x
 then
 
-# First recognize some ad-hoc caes, or perhaps split kernel-os, or else just
+# First recognize some ad-hoc cases, or perhaps split kernel-os, or else just
 # set os.
+obj=
 case $basic_os in
 	gnu/linux*)
 		kernel=linux
@@ -1336,6 +1321,10 @@ EOF
 		kernel=linux
 		os=`echo "$basic_os" | sed -e 's|linux|gnu|'`
 		;;
+	managarm*)
+		kernel=managarm
+		os=`echo "$basic_os" | sed -e 's|managarm|mlibc|'`
+		;;
 	*)
 		kernel=
 		os=$basic_os
@@ -1501,10 +1490,16 @@ case $os in
 			os=eabi
 			;;
 		    *)
-			os=elf
+			os=
+			obj=elf
 			;;
 		esac
 		;;
+	aout* | coff* | elf* | pe*)
+		# These are machine code file formats, not OSes
+		obj=$os
+		os=
+		;;
 	*)
 		# No normalization, but not necessarily accepted, that comes below.
 		;;
@@ -1523,12 +1518,15 @@ else
 # system, and we'll never get to this point.
 
 kernel=
+obj=
 case $cpu-$vendor in
 	score-*)
-		os=elf
+		os=
+		obj=elf
 		;;
 	spu-*)
-		os=elf
+		os=
+		obj=elf
 		;;
 	*-acorn)
 		os=riscix1.2
@@ -1538,28 +1536,35 @@ case $cpu-$vendor in
 		os=gnu
 		;;
 	arm*-semi)
-		os=aout
+		os=
+		obj=aout
 		;;
 	c4x-* | tic4x-*)
-		os=coff
+		os=
+		obj=coff
 		;;
 	c8051-*)
-		os=elf
+		os=
+		obj=elf
 		;;
 	clipper-intergraph)
 		os=clix
 		;;
 	hexagon-*)
-		os=elf
+		os=
+		obj=elf
 		;;
 	tic54x-*)
-		os=coff
+		os=
+		obj=coff
 		;;
 	tic55x-*)
-		os=coff
+		os=
+		obj=coff
 		;;
 	tic6x-*)
-		os=coff
+		os=
+		obj=coff
 		;;
 	# This must come before the *-dec entry.
 	pdp10-*)
@@ -1581,19 +1586,24 @@ case $cpu-$vendor in
 		os=sunos3
 		;;
 	m68*-cisco)
-		os=aout
+		os=
+		obj=aout
 		;;
 	mep-*)
-		os=elf
+		os=
+		obj=elf
 		;;
 	mips*-cisco)
-		os=elf
+		os=
+		obj=elf
 		;;
 	mips*-*)
-		os=elf
+		os=
+		obj=elf
 		;;
 	or32-*)
-		os=coff
+		os=
+		obj=coff
 		;;
 	*-tti)	# must be before sparc entry or we get the wrong os.
 		os=sysv3
@@ -1602,7 +1612,8 @@ case $cpu-$vendor in
 		os=sunos4.1.1
 		;;
 	pru-*)
-		os=elf
+		os=
+		obj=elf
 		;;
 	*-be)
 		os=beos
@@ -1683,10 +1694,12 @@ case $cpu-$vendor in
 		os=uxpv
 		;;
 	*-rom68k)
-		os=coff
+		os=
+		obj=coff
 		;;
 	*-*bug)
-		os=coff
+		os=
+		obj=coff
 		;;
 	*-apple)
 		os=macos
@@ -1704,7 +1717,8 @@ esac
 
 fi
 
-# Now, validate our (potentially fixed-up) OS.
+# Now, validate our (potentially fixed-up) individual pieces (OS, OBJ).
+
 case $os in
 	# Sometimes we do "kernel-libc", so those need to count as OSes.
 	musl* | newlib* | relibc* | uclibc*)
@@ -1715,6 +1729,9 @@ case $os in
 	# VxWorks passes extra cpu info in the 4th filed.
 	simlinux | simwindows | spe)
 		;;
+	# See `case $cpu-$os` validation below
+	ghcjs)
+		;;
 	# Now accept the basic system types.
 	# The portable systems comes first.
 	# Each alternative MUST end in a * to match a version number.
@@ -1723,7 +1740,7 @@ case $os in
 	     | hpux* | unos* | osf* | luna* | dgux* | auroraux* | solaris* \
 	     | sym* |  plan9* | psp* | sim* | xray* | os68k* | v88r* \
 	     | hiux* | abug | nacl* | netware* | windows* \
-	     | os9* | macos* | osx* | ios* \
+	     | os9* | macos* | osx* | ios* | tvos* | watchos* \
 	     | mpw* | magic* | mmixware* | mon960* | lnews* \
 	     | amigaos* | amigados* | msdos* | newsos* | unicos* | aof* \
 	     | aos* | aros* | cloudabi* | sortix* | twizzler* \
@@ -1732,11 +1749,11 @@ case $os in
 	     | mirbsd* | netbsd* | dicos* | openedition* | ose* \
 	     | bitrig* | openbsd* | secbsd* | solidbsd* | libertybsd* | os108* \
 	     | ekkobsd* | freebsd* | riscix* | lynxos* | os400* \
-	     | bosx* | nextstep* | cxux* | aout* | elf* | oabi* \
-	     | ptx* | coff* | ecoff* | winnt* | domain* | vsta* \
+	     | bosx* | nextstep* | cxux* | oabi* \
+	     | ptx* | ecoff* | winnt* | domain* | vsta* \
 	     | udi* | lites* | ieee* | go32* | aux* | hcos* \
 	     | chorusrdb* | cegcc* | glidix* | serenity* \
-	     | cygwin* | msys* | pe* | moss* | proelf* | rtems* \
+	     | cygwin* | msys* | moss* | proelf* | rtems* \
 	     | midipix* | mingw32* | mingw64* | mint* \
 	     | uxpv* | beos* | mpeix* | udk* | moxiebox* \
 	     | interix* | uwin* | mks* | rhapsody* | darwin* \
@@ -1748,7 +1765,8 @@ case $os in
 	     | skyos* | haiku* | rdos* | toppers* | drops* | es* \
 	     | onefs* | tirtos* | phoenix* | fuchsia* | redox* | bme* \
 	     | midnightbsd* | amdhsa* | unleashed* | emscripten* | wasi* \
-	     | nsk* | powerunix* | genode* | zvmoe* | qnx* | emx* | zephyr*)
+	     | nsk* | powerunix* | genode* | zvmoe* | qnx* | emx* | zephyr* \
+	     | fiwix* | mlibc* | cos* | mbr* )
 		;;
 	# This one is extra strict with allowed versions
 	sco3.2v2 | sco3.2v[4-9]* | sco5v6*)
@@ -1756,41 +1774,99 @@ case $os in
 		;;
 	none)
 		;;
+	kernel* | msvc* )
+		# Restricted further below
+		;;
+	'')
+		if test x"$obj" = x
+		then
+			echo "Invalid configuration '$1': Blank OS only allowed with explicit machine code file format" 1>&2
+		fi
+		;;
 	*)
-		echo Invalid configuration \`"$1"\': OS \`"$os"\' not recognized 1>&2
+		echo "Invalid configuration '$1': OS '$os' not recognized" 1>&2
+		exit 1
+		;;
+esac
+
+case $obj in
+	aout* | coff* | elf* | pe*)
+		;;
+	'')
+		# empty is fine
+		;;
+	*)
+		echo "Invalid configuration '$1': Machine code format '$obj' not recognized" 1>&2
+		exit 1
+		;;
+esac
+
+# Here we handle the constraint that a (synthetic) cpu and os are
+# valid only in combination with each other and nowhere else.
+case $cpu-$os in
+	# The "javascript-unknown-ghcjs" triple is used by GHC; we
+	# accept it here in order to tolerate that, but reject any
+	# variations.
+	javascript-ghcjs)
+		;;
+	javascript-* | *-ghcjs)
+		echo "Invalid configuration '$1': cpu '$cpu' is not valid with os '$os$obj'" 1>&2
 		exit 1
 		;;
 esac
 
 # As a final step for OS-related things, validate the OS-kernel combination
 # (given a valid OS), if there is a kernel.
-case $kernel-$os in
-	linux-gnu* | linux-dietlibc* | linux-android* | linux-newlib* \
-		   | linux-musl* | linux-relibc* | linux-uclibc* )
+case $kernel-$os-$obj in
+	linux-gnu*- | linux-dietlibc*- | linux-android*- | linux-newlib*- \
+		   | linux-musl*- | linux-relibc*- | linux-uclibc*- | linux-mlibc*- )
+		;;
+	uclinux-uclibc*- )
+		;;
+	managarm-mlibc*- | managarm-kernel*- )
 		;;
-	uclinux-uclibc* )
+	windows*-msvc*-)
 		;;
-	-dietlibc* | -newlib* | -musl* | -relibc* | -uclibc* )
+	-dietlibc*- | -newlib*- | -musl*- | -relibc*- | -uclibc*- | -mlibc*- )
 		# These are just libc implementations, not actual OSes, and thus
 		# require a kernel.
-		echo "Invalid configuration \`$1': libc \`$os' needs explicit kernel." 1>&2
+		echo "Invalid configuration '$1': libc '$os' needs explicit kernel." 1>&2
 		exit 1
 		;;
-	kfreebsd*-gnu* | kopensolaris*-gnu*)
+	-kernel*- )
+		echo "Invalid configuration '$1': '$os' needs explicit kernel." 1>&2
+		exit 1
 		;;
-	vxworks-simlinux | vxworks-simwindows | vxworks-spe)
+	*-kernel*- )
+		echo "Invalid configuration '$1': '$kernel' does not support '$os'." 1>&2
+		exit 1
 		;;
-	nto-qnx*)
+	*-msvc*- )
+		echo "Invalid configuration '$1': '$os' needs 'windows'." 1>&2
+		exit 1
 		;;
-	os2-emx)
+	kfreebsd*-gnu*- | kopensolaris*-gnu*-)
+		;;
+	vxworks-simlinux- | vxworks-simwindows- | vxworks-spe-)
+		;;
+	nto-qnx*-)
+		;;
+	os2-emx-)
 		;;
-	*-eabi* | *-gnueabi*)
+	*-eabi*- | *-gnueabi*-)
 		;;
-	-*)
+	none--*)
+		# None (no kernel, i.e. freestanding / bare metal),
+		# can be paired with an machine code file format
+		;;
+	-*-)
 		# Blank kernel with real OS is always fine.
 		;;
-	*-*)
-		echo "Invalid configuration \`$1': Kernel \`$kernel' not known to work with OS \`$os'." 1>&2
+	--*)
+		# Blank kernel and OS with real machine code file format is always fine.
+		;;
+	*-*-*)
+		echo "Invalid configuration '$1': Kernel '$kernel' not known to work with OS '$os'." 1>&2
 		exit 1
 		;;
 esac
@@ -1873,7 +1949,7 @@ case $vendor in
 		;;
 esac
 
-echo "$cpu-$vendor-${kernel:+$kernel-}$os"
+echo "$cpu-$vendor${kernel:+-$kernel}${os:+-$os}${obj:+-$obj}"
 exit
 
 # Local variables:
diff -pruN 2.10.0-1/config/hwloc.m4 2.11.0-1/config/hwloc.m4
--- 2.10.0-1/config/hwloc.m4	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/config/hwloc.m4	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 dnl -*- Autoconf -*-
 dnl
-dnl Copyright © 2009-2023 Inria.  All rights reserved.
+dnl Copyright © 2009-2024 Inria.  All rights reserved.
 dnl Copyright © 2009-2012, 2015-2017, 2020, 2023 Université Bordeaux
 dnl Copyright © 2004-2005 The Trustees of Indiana University and Indiana
 dnl                         University Research and Technology
@@ -1228,7 +1228,8 @@ char nvmlInit ();
       if test "x$hwloc_nvml_happy" = "xyes"; then
         tmp_save_CPPFLAGS="$CPPFLAGS"
         CPPFLAGS="$CPPFLAGS $HWLOC_NVML_CPPFLAGS"
-        AC_CHECK_DECLS([nvmlDeviceGetMaxPcieLinkGeneration],,[:],[[#include <nvml.h>]])
+        AC_CHECK_DECLS([nvmlDeviceGetCurrPcieLinkGeneration],,[:],[[#include <nvml.h>]])
+        AC_CHECK_DECLS([nvmlDeviceGetNvLinkRemoteDeviceType],,[:],[[#include <nvml.h>]])
         CPPFLAGS="$tmp_save_CPPFLAGS"
       fi
 
diff -pruN 2.10.0-1/config/install-sh 2.11.0-1/config/install-sh
--- 2.10.0-1/config/install-sh	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/config/install-sh	2024-06-25 12:41:55.000000000 +0000
@@ -1,7 +1,7 @@
 #!/bin/sh
 # install - install a program, script, or datafile
 
-scriptversion=2020-11-14.01; # UTC
+scriptversion=2023-11-23.18; # UTC
 
 # This originates from X11R5 (mit/util/scripts/install.sh), which was
 # later released in X11R6 (xc/config/util/install.sh) with the
@@ -124,9 +124,9 @@ it's up to you to specify -f if you want
 
 If -S is not specified, no backups are attempted.
 
-Email bug reports to bug-automake@gnu.org.
-Automake home page: https://www.gnu.org/software/automake/
-"
+Report bugs to <bug-automake@gnu.org>.
+GNU Automake home page: <https://www.gnu.org/software/automake/>.
+General help using GNU software: <https://www.gnu.org/gethelp/>."
 
 while test $# -ne 0; do
   case $1 in
diff -pruN 2.10.0-1/configure 2.11.0-1/configure
--- 2.10.0-1/configure	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/configure	2024-06-25 12:41:54.000000000 +0000
@@ -1,11 +1,11 @@
 #! /bin/sh
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.71 for hwloc 2.10.0.
+# Generated by GNU Autoconf 2.72 for hwloc 2.11.0.
 #
 # Report bugs to <https://github.com/open-mpi/hwloc/issues>.
 #
 #
-# Copyright (C) 1992-1996, 1998-2017, 2020-2021 Free Software Foundation,
+# Copyright (C) 1992-1996, 1998-2017, 2020-2023 Free Software Foundation,
 # Inc.
 #
 #
@@ -17,7 +17,6 @@
 
 # Be more Bourne compatible
 DUALCASE=1; export DUALCASE # for MKS sh
-as_nop=:
 if test ${ZSH_VERSION+y} && (emulate sh) >/dev/null 2>&1
 then :
   emulate sh
@@ -26,12 +25,13 @@ then :
   # is contrary to our usage.  Disable this feature.
   alias -g '${1+"$@"}'='"$@"'
   setopt NO_GLOB_SUBST
-else $as_nop
-  case `(set -o) 2>/dev/null` in #(
+else case e in #(
+  e) case `(set -o) 2>/dev/null` in #(
   *posix*) :
     set -o posix ;; #(
   *) :
      ;;
+esac ;;
 esac
 fi
 
@@ -103,7 +103,7 @@ IFS=$as_save_IFS
 
      ;;
 esac
-# We did not find ourselves, most probably we were run as `sh COMMAND'
+# We did not find ourselves, most probably we were run as 'sh COMMAND'
 # in which case we are not to be found in the path.
 if test "x$as_myself" = x; then
   as_myself=$0
@@ -133,15 +133,14 @@ case $- in # ((((
 esac
 exec $CONFIG_SHELL $as_opts "$as_myself" ${1+"$@"}
 # Admittedly, this is quite paranoid, since all the known shells bail
-# out after a failed `exec'.
+# out after a failed 'exec'.
 printf "%s\n" "$0: could not re-execute with $CONFIG_SHELL" >&2
 exit 255
   fi
   # We don't want this to propagate to other subprocesses.
           { _as_can_reexec=; unset _as_can_reexec;}
 if test "x$CONFIG_SHELL" = x; then
-  as_bourne_compatible="as_nop=:
-if test \${ZSH_VERSION+y} && (emulate sh) >/dev/null 2>&1
+  as_bourne_compatible="if test \${ZSH_VERSION+y} && (emulate sh) >/dev/null 2>&1
 then :
   emulate sh
   NULLCMD=:
@@ -149,12 +148,13 @@ then :
   # is contrary to our usage.  Disable this feature.
   alias -g '\${1+\"\$@\"}'='\"\$@\"'
   setopt NO_GLOB_SUBST
-else \$as_nop
-  case \`(set -o) 2>/dev/null\` in #(
+else case e in #(
+  e) case \`(set -o) 2>/dev/null\` in #(
   *posix*) :
     set -o posix ;; #(
   *) :
      ;;
+esac ;;
 esac
 fi
 "
@@ -172,8 +172,9 @@ as_fn_ret_failure && { exitcode=1; echo
 if ( set x; as_fn_ret_success y && test x = \"\$1\" )
 then :
 
-else \$as_nop
-  exitcode=1; echo positional parameters were not saved.
+else case e in #(
+  e) exitcode=1; echo positional parameters were not saved. ;;
+esac
 fi
 test x\$exitcode = x0 || exit 1
 blah=\$(echo \$(echo blah))
@@ -195,14 +196,15 @@ test \$(( 1 + 1 )) = 2 || exit 1"
   if (eval "$as_required") 2>/dev/null
 then :
   as_have_required=yes
-else $as_nop
-  as_have_required=no
+else case e in #(
+  e) as_have_required=no ;;
+esac
 fi
   if test x$as_have_required = xyes && (eval "$as_suggested") 2>/dev/null
 then :
 
-else $as_nop
-  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
+else case e in #(
+  e) as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
 as_found=false
 for as_dir in /bin$PATH_SEPARATOR/usr/bin$PATH_SEPARATOR$PATH
 do
@@ -235,12 +237,13 @@ IFS=$as_save_IFS
 if $as_found
 then :
 
-else $as_nop
-  if { test -f "$SHELL" || test -f "$SHELL.exe"; } &&
+else case e in #(
+  e) if { test -f "$SHELL" || test -f "$SHELL.exe"; } &&
 	      as_run=a "$SHELL" -c "$as_bourne_compatible""$as_required" 2>/dev/null
 then :
   CONFIG_SHELL=$SHELL as_have_required=yes
-fi
+fi ;;
+esac
 fi
 
 
@@ -262,7 +265,7 @@ case $- in # ((((
 esac
 exec $CONFIG_SHELL $as_opts "$as_myself" ${1+"$@"}
 # Admittedly, this is quite paranoid, since all the known shells bail
-# out after a failed `exec'.
+# out after a failed 'exec'.
 printf "%s\n" "$0: could not re-execute with $CONFIG_SHELL" >&2
 exit 255
 fi
@@ -282,7 +285,8 @@ $0: message. Then install a modern shell
 $0: the script under such a shell if you do have one."
   fi
   exit 1
-fi
+fi ;;
+esac
 fi
 fi
 SHELL=${CONFIG_SHELL-/bin/sh}
@@ -321,14 +325,6 @@ as_fn_exit ()
   as_fn_set_status $1
   exit $1
 } # as_fn_exit
-# as_fn_nop
-# ---------
-# Do nothing but, unlike ":", preserve the value of $?.
-as_fn_nop ()
-{
-  return $?
-}
-as_nop=as_fn_nop
 
 # as_fn_mkdir_p
 # -------------
@@ -397,11 +393,12 @@ then :
   {
     eval $1+=\$2
   }'
-else $as_nop
-  as_fn_append ()
+else case e in #(
+  e) as_fn_append ()
   {
     eval $1=\$$1\$2
-  }
+  } ;;
+esac
 fi # as_fn_append
 
 # as_fn_arith ARG...
@@ -415,21 +412,14 @@ then :
   {
     as_val=$(( $* ))
   }'
-else $as_nop
-  as_fn_arith ()
+else case e in #(
+  e) as_fn_arith ()
   {
     as_val=`expr "$@" || test $? -eq 1`
-  }
+  } ;;
+esac
 fi # as_fn_arith
 
-# as_fn_nop
-# ---------
-# Do nothing but, unlike ":", preserve the value of $?.
-as_fn_nop ()
-{
-  return $?
-}
-as_nop=as_fn_nop
 
 # as_fn_error STATUS ERROR [LINENO LOG_FD]
 # ----------------------------------------
@@ -503,6 +493,8 @@ as_cr_alnum=$as_cr_Letters$as_cr_digits
     /[$]LINENO/=
   ' <$as_myself |
     sed '
+      t clear
+      :clear
       s/[$]LINENO.*/&-/
       t lineno
       b
@@ -551,7 +543,6 @@ esac
 as_echo='printf %s\n'
 as_echo_n='printf %s'
 
-
 rm -f conf$$ conf$$.exe conf$$.file
 if test -d conf$$.dir; then
   rm -f conf$$.dir/conf$$.file
@@ -563,9 +554,9 @@ if (echo >conf$$.file) 2>/dev/null; then
   if ln -s conf$$.file conf$$ 2>/dev/null; then
     as_ln_s='ln -s'
     # ... but there are two gotchas:
-    # 1) On MSYS, both `ln -s file dir' and `ln file dir' fail.
-    # 2) DJGPP < 2.04 has no symlinks; `ln -s' creates a wrapper executable.
-    # In both cases, we have to default to `cp -pR'.
+    # 1) On MSYS, both 'ln -s file dir' and 'ln file dir' fail.
+    # 2) DJGPP < 2.04 has no symlinks; 'ln -s' creates a wrapper executable.
+    # In both cases, we have to default to 'cp -pR'.
     ln -s conf$$.file conf$$.dir 2>/dev/null && test ! -f conf$$.exe ||
       as_ln_s='cp -pR'
   elif ln conf$$.file conf$$ 2>/dev/null; then
@@ -590,10 +581,12 @@ as_test_x='test -x'
 as_executable_p=as_fn_executable_p
 
 # Sed expression to map a string onto a valid CPP name.
-as_tr_cpp="eval sed 'y%*$as_cr_letters%P$as_cr_LETTERS%;s%[^_$as_cr_alnum]%_%g'"
+as_sed_cpp="y%*$as_cr_letters%P$as_cr_LETTERS%;s%[^_$as_cr_alnum]%_%g"
+as_tr_cpp="eval sed '$as_sed_cpp'" # deprecated
 
 # Sed expression to map a string onto a valid variable name.
-as_tr_sh="eval sed 'y%*+%pp%;s%[^_$as_cr_alnum]%_%g'"
+as_sed_sh="y%*+%pp%;s%[^_$as_cr_alnum]%_%g"
+as_tr_sh="eval sed '$as_sed_sh'" # deprecated
 
 SHELL=${CONFIG_SHELL-/bin/sh}
 
@@ -621,8 +614,8 @@ MAKEFLAGS=
 # Identity of this package.
 PACKAGE_NAME='hwloc'
 PACKAGE_TARNAME='hwloc'
-PACKAGE_VERSION='2.10.0'
-PACKAGE_STRING='hwloc 2.10.0'
+PACKAGE_VERSION='2.11.0'
+PACKAGE_STRING='hwloc 2.11.0'
 PACKAGE_BUGREPORT='https://github.com/open-mpi/hwloc/issues'
 PACKAGE_URL=''
 
@@ -1175,7 +1168,7 @@ do
     ac_useropt=`expr "x$ac_option" : 'x-*disable-\(.*\)'`
     # Reject names that are not valid shell variable names.
     expr "x$ac_useropt" : ".*[^-+._$as_cr_alnum]" >/dev/null &&
-      as_fn_error $? "invalid feature name: \`$ac_useropt'"
+      as_fn_error $? "invalid feature name: '$ac_useropt'"
     ac_useropt_orig=$ac_useropt
     ac_useropt=`printf "%s\n" "$ac_useropt" | sed 's/[-+.]/_/g'`
     case $ac_user_opts in
@@ -1201,7 +1194,7 @@ do
     ac_useropt=`expr "x$ac_option" : 'x-*enable-\([^=]*\)'`
     # Reject names that are not valid shell variable names.
     expr "x$ac_useropt" : ".*[^-+._$as_cr_alnum]" >/dev/null &&
-      as_fn_error $? "invalid feature name: \`$ac_useropt'"
+      as_fn_error $? "invalid feature name: '$ac_useropt'"
     ac_useropt_orig=$ac_useropt
     ac_useropt=`printf "%s\n" "$ac_useropt" | sed 's/[-+.]/_/g'`
     case $ac_user_opts in
@@ -1414,7 +1407,7 @@ do
     ac_useropt=`expr "x$ac_option" : 'x-*with-\([^=]*\)'`
     # Reject names that are not valid shell variable names.
     expr "x$ac_useropt" : ".*[^-+._$as_cr_alnum]" >/dev/null &&
-      as_fn_error $? "invalid package name: \`$ac_useropt'"
+      as_fn_error $? "invalid package name: '$ac_useropt'"
     ac_useropt_orig=$ac_useropt
     ac_useropt=`printf "%s\n" "$ac_useropt" | sed 's/[-+.]/_/g'`
     case $ac_user_opts in
@@ -1430,7 +1423,7 @@ do
     ac_useropt=`expr "x$ac_option" : 'x-*without-\(.*\)'`
     # Reject names that are not valid shell variable names.
     expr "x$ac_useropt" : ".*[^-+._$as_cr_alnum]" >/dev/null &&
-      as_fn_error $? "invalid package name: \`$ac_useropt'"
+      as_fn_error $? "invalid package name: '$ac_useropt'"
     ac_useropt_orig=$ac_useropt
     ac_useropt=`printf "%s\n" "$ac_useropt" | sed 's/[-+.]/_/g'`
     case $ac_user_opts in
@@ -1460,8 +1453,8 @@ do
   | --x-librar=* | --x-libra=* | --x-libr=* | --x-lib=* | --x-li=* | --x-l=*)
     x_libraries=$ac_optarg ;;
 
-  -*) as_fn_error $? "unrecognized option: \`$ac_option'
-Try \`$0 --help' for more information"
+  -*) as_fn_error $? "unrecognized option: '$ac_option'
+Try '$0 --help' for more information"
     ;;
 
   *=*)
@@ -1469,7 +1462,7 @@ Try \`$0 --help' for more information"
     # Reject names that are not valid shell variable names.
     case $ac_envvar in #(
       '' | [0-9]* | *[!_$as_cr_alnum]* )
-      as_fn_error $? "invalid variable name: \`$ac_envvar'" ;;
+      as_fn_error $? "invalid variable name: '$ac_envvar'" ;;
     esac
     eval $ac_envvar=\$ac_optarg
     export $ac_envvar ;;
@@ -1519,7 +1512,7 @@ do
   as_fn_error $? "expected an absolute directory name for --$ac_var: $ac_val"
 done
 
-# There might be people who depend on the old broken behavior: `$host'
+# There might be people who depend on the old broken behavior: '$host'
 # used to hold the argument of --host etc.
 # FIXME: To remove some day.
 build=$build_alias
@@ -1587,7 +1580,7 @@ if test ! -r "$srcdir/$ac_unique_file";
   test "$ac_srcdir_defaulted" = yes && srcdir="$ac_confdir or .."
   as_fn_error $? "cannot find sources ($ac_unique_file) in $srcdir"
 fi
-ac_msg="sources are in $srcdir, but \`cd $srcdir' does not work"
+ac_msg="sources are in $srcdir, but 'cd $srcdir' does not work"
 ac_abs_confdir=`(
 	cd "$srcdir" && test -r "./$ac_unique_file" || as_fn_error $? "$ac_msg"
 	pwd)`
@@ -1615,7 +1608,7 @@ if test "$ac_init_help" = "long"; then
   # Omit some internal or obsolete options to make the list less imposing.
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures hwloc 2.10.0 to adapt to many kinds of systems.
+'configure' configures hwloc 2.11.0 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
 
@@ -1629,11 +1622,11 @@ Configuration:
       --help=short        display options specific to this package
       --help=recursive    display the short help of all the included packages
   -V, --version           display version information and exit
-  -q, --quiet, --silent   do not print \`checking ...' messages
+  -q, --quiet, --silent   do not print 'checking ...' messages
       --cache-file=FILE   cache test results in FILE [disabled]
-  -C, --config-cache      alias for \`--cache-file=config.cache'
+  -C, --config-cache      alias for '--cache-file=config.cache'
   -n, --no-create         do not create output files
-      --srcdir=DIR        find the sources in DIR [configure dir or \`..']
+      --srcdir=DIR        find the sources in DIR [configure dir or '..']
 
 Installation directories:
   --prefix=PREFIX         install architecture-independent files in PREFIX
@@ -1641,10 +1634,10 @@ Installation directories:
   --exec-prefix=EPREFIX   install architecture-dependent files in EPREFIX
                           [PREFIX]
 
-By default, \`make install' will install all the files in
-\`$ac_default_prefix/bin', \`$ac_default_prefix/lib' etc.  You can specify
-an installation prefix other than \`$ac_default_prefix' using \`--prefix',
-for instance \`--prefix=\$HOME'.
+By default, 'make install' will install all the files in
+'$ac_default_prefix/bin', '$ac_default_prefix/lib' etc.  You can specify
+an installation prefix other than '$ac_default_prefix' using '--prefix',
+for instance '--prefix=\$HOME'.
 
 For better control, use the options below.
 
@@ -1691,7 +1684,7 @@ fi
 
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of hwloc 2.10.0:";;
+     short | recursive ) echo "Configuration of hwloc 2.11.0:";;
    esac
   cat <<\_ACEOF
 
@@ -1866,7 +1859,7 @@ Some influential environment variables:
   HWLOC_NUMA_LIBS
               linker flags for NUMA, overriding pkg-config
 
-Use these variables to override the choices made by `configure' or to help
+Use these variables to override the choices made by 'configure' or to help
 it to find libraries and programs with nonstandard names/locations.
 
 Report bugs to <https://github.com/open-mpi/hwloc/issues>.
@@ -1933,10 +1926,10 @@ fi
 test -n "$ac_init_help" && exit $ac_status
 if $ac_init_version; then
   cat <<\_ACEOF
-hwloc configure 2.10.0
-generated by GNU Autoconf 2.71
+hwloc configure 2.11.0
+generated by GNU Autoconf 2.72
 
-Copyright (C) 2021 Free Software Foundation, Inc.
+Copyright (C) 2023 Free Software Foundation, Inc.
 This configure script is free software; the Free Software Foundation
 gives unlimited permission to copy, distribute and modify it.
 _ACEOF
@@ -1975,11 +1968,12 @@ printf "%s\n" "$ac_try_echo"; } >&5
        } && test -s conftest.$ac_objext
 then :
   ac_retval=0
-else $as_nop
-  printf "%s\n" "$as_me: failed program was:" >&5
+else case e in #(
+  e) printf "%s\n" "$as_me: failed program was:" >&5
 sed 's/^/| /' conftest.$ac_ext >&5
 
-	ac_retval=1
+	ac_retval=1 ;;
+esac
 fi
   eval $as_lineno_stack; ${as_lineno_stack:+:} unset as_lineno
   as_fn_set_status $ac_retval
@@ -1998,8 +1992,8 @@ printf %s "checking for $2... " >&6; }
 if eval test \${$3+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 $4
 #include <$2>
@@ -2007,10 +2001,12 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   eval "$3=yes"
-else $as_nop
-  eval "$3=no"
+else case e in #(
+  e) eval "$3=no" ;;
+esac
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 eval ac_res=\$$3
 	       { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_res" >&5
@@ -2050,11 +2046,12 @@ printf "%s\n" "$ac_try_echo"; } >&5
        }
 then :
   ac_retval=0
-else $as_nop
-  printf "%s\n" "$as_me: failed program was:" >&5
+else case e in #(
+  e) printf "%s\n" "$as_me: failed program was:" >&5
 sed 's/^/| /' conftest.$ac_ext >&5
 
-	ac_retval=1
+	ac_retval=1 ;;
+esac
 fi
   # Delete the IPA/IPO (Inter Procedural Analysis/Optimization) information
   # created by the PGI compiler (conftest_ipa8_conftest.oo), as it would
@@ -2077,15 +2074,15 @@ printf %s "checking for $2... " >&6; }
 if eval test \${$3+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 /* Define $2 to an innocuous variant, in case <limits.h> declares $2.
    For example, HP-UX 11i <limits.h> declares gettimeofday.  */
 #define $2 innocuous_$2
 
 /* System header to define __stub macros and hopefully few prototypes,
-   which can conflict with char $2 (); below.  */
+   which can conflict with char $2 (void); below.  */
 
 #include <limits.h>
 #undef $2
@@ -2096,7 +2093,7 @@ else $as_nop
 #ifdef __cplusplus
 extern "C"
 #endif
-char $2 ();
+char $2 (void);
 /* The GNU C library defines this for functions which it implements
     to always fail with ENOSYS.  Some functions are actually named
     something starting with __ and the normal name is an alias.  */
@@ -2115,11 +2112,13 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   eval "$3=yes"
-else $as_nop
-  eval "$3=no"
+else case e in #(
+  e) eval "$3=no" ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
-    conftest$ac_exeext conftest.$ac_ext
+    conftest$ac_exeext conftest.$ac_ext ;;
+esac
 fi
 eval ac_res=\$$3
 	       { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_res" >&5
@@ -2156,11 +2155,12 @@ printf "%s\n" "$ac_try_echo"; } >&5
        } && test -s conftest.$ac_objext
 then :
   ac_retval=0
-else $as_nop
-  printf "%s\n" "$as_me: failed program was:" >&5
+else case e in #(
+  e) printf "%s\n" "$as_me: failed program was:" >&5
 sed 's/^/| /' conftest.$ac_ext >&5
 
-	ac_retval=1
+	ac_retval=1 ;;
+esac
 fi
   eval $as_lineno_stack; ${as_lineno_stack:+:} unset as_lineno
   as_fn_set_status $ac_retval
@@ -2194,11 +2194,12 @@ printf "%s\n" "$ac_try_echo"; } >&5
        }
 then :
   ac_retval=0
-else $as_nop
-  printf "%s\n" "$as_me: failed program was:" >&5
+else case e in #(
+  e) printf "%s\n" "$as_me: failed program was:" >&5
 sed 's/^/| /' conftest.$ac_ext >&5
 
-    ac_retval=1
+    ac_retval=1 ;;
+esac
 fi
   eval $as_lineno_stack; ${as_lineno_stack:+:} unset as_lineno
   as_fn_set_status $ac_retval
@@ -2236,11 +2237,12 @@ printf "%s\n" "$ac_try_echo"; } >&5
        }
 then :
   ac_retval=0
-else $as_nop
-  printf "%s\n" "$as_me: failed program was:" >&5
+else case e in #(
+  e) printf "%s\n" "$as_me: failed program was:" >&5
 sed 's/^/| /' conftest.$ac_ext >&5
 
-	ac_retval=1
+	ac_retval=1 ;;
+esac
 fi
   # Delete the IPA/IPO (Inter Procedural Analysis/Optimization) information
   # created by the PGI compiler (conftest_ipa8_conftest.oo), as it would
@@ -2282,12 +2284,13 @@ printf "%s\n" "$ac_try_echo"; } >&5
   test $ac_status = 0; }; }
 then :
   ac_retval=0
-else $as_nop
-  printf "%s\n" "$as_me: program exited with status $ac_status" >&5
+else case e in #(
+  e) printf "%s\n" "$as_me: program exited with status $ac_status" >&5
        printf "%s\n" "$as_me: failed program was:" >&5
 sed 's/^/| /' conftest.$ac_ext >&5
 
-       ac_retval=$ac_status
+       ac_retval=$ac_status ;;
+esac
 fi
   rm -rf conftest.dSYM conftest_ipa8_conftest.oo
   eval $as_lineno_stack; ${as_lineno_stack:+:} unset as_lineno
@@ -2340,18 +2343,19 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   ac_hi=$ac_mid; break
-else $as_nop
-  as_fn_arith $ac_mid + 1 && ac_lo=$as_val
+else case e in #(
+  e) as_fn_arith $ac_mid + 1 && ac_lo=$as_val
 			if test $ac_lo -le $ac_mid; then
 			  ac_lo= ac_hi=
 			  break
 			fi
-			as_fn_arith 2 '*' $ac_mid + 1 && ac_mid=$as_val
+			as_fn_arith 2 '*' $ac_mid + 1 && ac_mid=$as_val ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
   done
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 $4
 int
@@ -2386,20 +2390,23 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   ac_lo=$ac_mid; break
-else $as_nop
-  as_fn_arith '(' $ac_mid ')' - 1 && ac_hi=$as_val
+else case e in #(
+  e) as_fn_arith '(' $ac_mid ')' - 1 && ac_hi=$as_val
 			if test $ac_mid -le $ac_hi; then
 			  ac_lo= ac_hi=
 			  break
 			fi
-			as_fn_arith 2 '*' $ac_mid && ac_mid=$as_val
+			as_fn_arith 2 '*' $ac_mid && ac_mid=$as_val ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
   done
-else $as_nop
-  ac_lo= ac_hi=
+else case e in #(
+  e) ac_lo= ac_hi= ;;
+esac
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 # Binary search between lo and hi bounds.
@@ -2422,8 +2429,9 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   ac_hi=$ac_mid
-else $as_nop
-  as_fn_arith '(' $ac_mid ')' + 1 && ac_lo=$as_val
+else case e in #(
+  e) as_fn_arith '(' $ac_mid ')' + 1 && ac_lo=$as_val ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 done
@@ -2471,8 +2479,9 @@ _ACEOF
 if ac_fn_c_try_run "$LINENO"
 then :
   echo >>conftest.val; read $3 <conftest.val; ac_retval=0
-else $as_nop
-  ac_retval=1
+else case e in #(
+  e) ac_retval=1 ;;
+esac
 fi
 rm -f core *.core core.conftest.* gmon.out bb.out conftest$ac_exeext \
   conftest.$ac_objext conftest.beam conftest.$ac_ext
@@ -2497,8 +2506,8 @@ printf %s "checking whether $as_decl_nam
 if eval test \${$3+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  as_decl_use=`echo $2|sed -e 's/(/((/' -e 's/)/) 0&/' -e 's/,/) 0& (/g'`
+else case e in #(
+  e) as_decl_use=`echo $2|sed -e 's/(/((/' -e 's/)/) 0&/' -e 's/,/) 0& (/g'`
   eval ac_save_FLAGS=\$$6
   as_fn_append $6 " $5"
   cat confdefs.h - <<_ACEOF >conftest.$ac_ext
@@ -2522,12 +2531,14 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   eval "$3=yes"
-else $as_nop
-  eval "$3=no"
+else case e in #(
+  e) eval "$3=no" ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
   eval $6=\$ac_save_FLAGS
-
+ ;;
+esac
 fi
 eval ac_res=\$$3
 	       { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_res" >&5
@@ -2548,8 +2559,8 @@ printf %s "checking for $2... " >&6; }
 if eval test \${$3+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  eval "$3=no"
+else case e in #(
+  e) eval "$3=no"
   cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 $4
@@ -2579,12 +2590,14 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
 
-else $as_nop
-  eval "$3=yes"
+else case e in #(
+  e) eval "$3=yes" ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 eval ac_res=\$$3
 	       { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_res" >&5
@@ -2620,11 +2633,12 @@ printf "%s\n" "$ac_try_echo"; } >&5
        }
 then :
   ac_retval=0
-else $as_nop
-  printf "%s\n" "$as_me: failed program was:" >&5
+else case e in #(
+  e) printf "%s\n" "$as_me: failed program was:" >&5
 sed 's/^/| /' conftest.$ac_ext >&5
 
-    ac_retval=1
+    ac_retval=1 ;;
+esac
 fi
   eval $as_lineno_stack; ${as_lineno_stack:+:} unset as_lineno
   as_fn_set_status $ac_retval
@@ -2654,8 +2668,8 @@ cat >config.log <<_ACEOF
 This file contains any messages produced by compilers while
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by hwloc $as_me 2.10.0, which was
-generated by GNU Autoconf 2.71.  Invocation command line was
+It was created by hwloc $as_me 2.11.0, which was
+generated by GNU Autoconf 2.72.  Invocation command line was
 
   $ $0$ac_configure_args_raw
 
@@ -2901,10 +2915,10 @@ esac
 printf "%s\n" "$as_me: loading site script $ac_site_file" >&6;}
     sed 's/^/| /' "$ac_site_file" >&5
     . "$ac_site_file" \
-      || { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+      || { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error $? "failed to load site script $ac_site_file
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; }
   fi
 done
 
@@ -2941,9 +2955,7 @@ struct stat;
 /* Most of the following tests are stolen from RCS 5.7 src/conf.sh.  */
 struct buf { int x; };
 struct buf * (*rcsopen) (struct buf *, struct stat *, int);
-static char *e (p, i)
-     char **p;
-     int i;
+static char *e (char **p, int i)
 {
   return p[i];
 }
@@ -2957,6 +2969,21 @@ static char *f (char * (*g) (char **, in
   return s;
 }
 
+/* C89 style stringification. */
+#define noexpand_stringify(a) #a
+const char *stringified = noexpand_stringify(arbitrary+token=sequence);
+
+/* C89 style token pasting.  Exercises some of the corner cases that
+   e.g. old MSVC gets wrong, but not very hard. */
+#define noexpand_concat(a,b) a##b
+#define expand_concat(a,b) noexpand_concat(a,b)
+extern int vA;
+extern int vbee;
+#define aye A
+#define bee B
+int *pvA = &expand_concat(v,aye);
+int *pvbee = &noexpand_concat(v,bee);
+
 /* OSF 4.0 Compaq cc is some sort of almost-ANSI by default.  It has
    function prototypes and stuff, but not \xHH hex character constants.
    These do not provoke an error unfortunately, instead are silently treated
@@ -2984,16 +3011,19 @@ ok |= (argc == 0 || f (e, argv, 0) != ar
 
 # Test code for whether the C compiler supports C99 (global declarations)
 ac_c_conftest_c99_globals='
-// Does the compiler advertise C99 conformance?
+/* Does the compiler advertise C99 conformance? */
 #if !defined __STDC_VERSION__ || __STDC_VERSION__ < 199901L
 # error "Compiler does not advertise C99 conformance"
 #endif
 
+// See if C++-style comments work.
+
 #include <stdbool.h>
 extern int puts (const char *);
 extern int printf (const char *, ...);
 extern int dprintf (int, const char *, ...);
 extern void *malloc (size_t);
+extern void free (void *);
 
 // Check varargs macros.  These examples are taken from C99 6.10.3.5.
 // dprintf is used instead of fprintf to avoid needing to declare
@@ -3043,7 +3073,6 @@ typedef const char *ccp;
 static inline int
 test_restrict (ccp restrict text)
 {
-  // See if C++-style comments work.
   // Iterate through items via the restricted pointer.
   // Also check for declarations in for loops.
   for (unsigned int i = 0; *(text+i) != '\''\0'\''; ++i)
@@ -3109,6 +3138,8 @@ ac_c_conftest_c99_main='
   ia->datasize = 10;
   for (int i = 0; i < ia->datasize; ++i)
     ia->data[i] = i * 1.234;
+  // Work around memory leak warnings.
+  free (ia);
 
   // Check named initializers.
   struct named_init ni = {
@@ -3130,7 +3161,7 @@ ac_c_conftest_c99_main='
 
 # Test code for whether the C compiler supports C11 (global declarations)
 ac_c_conftest_c11_globals='
-// Does the compiler advertise C11 conformance?
+/* Does the compiler advertise C11 conformance? */
 #if !defined __STDC_VERSION__ || __STDC_VERSION__ < 201112L
 # error "Compiler does not advertise C11 conformance"
 #endif
@@ -3539,8 +3570,9 @@ IFS=$as_save_IFS
 if $as_found
 then :
 
-else $as_nop
-  as_fn_error $? "cannot find required auxiliary files:$ac_missing_aux_files" "$LINENO" 5
+else case e in #(
+  e) as_fn_error $? "cannot find required auxiliary files:$ac_missing_aux_files" "$LINENO" 5 ;;
+esac
 fi
 
 
@@ -3568,12 +3600,12 @@ for ac_var in $ac_precious_vars; do
   eval ac_new_val=\$ac_env_${ac_var}_value
   case $ac_old_set,$ac_new_set in
     set,)
-      { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: \`$ac_var' was set to \`$ac_old_val' in the previous run" >&5
-printf "%s\n" "$as_me: error: \`$ac_var' was set to \`$ac_old_val' in the previous run" >&2;}
+      { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: '$ac_var' was set to '$ac_old_val' in the previous run" >&5
+printf "%s\n" "$as_me: error: '$ac_var' was set to '$ac_old_val' in the previous run" >&2;}
       ac_cache_corrupted=: ;;
     ,set)
-      { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: \`$ac_var' was not set in the previous run" >&5
-printf "%s\n" "$as_me: error: \`$ac_var' was not set in the previous run" >&2;}
+      { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: '$ac_var' was not set in the previous run" >&5
+printf "%s\n" "$as_me: error: '$ac_var' was not set in the previous run" >&2;}
       ac_cache_corrupted=: ;;
     ,);;
     *)
@@ -3582,18 +3614,18 @@ printf "%s\n" "$as_me: error: \`$ac_var'
 	ac_old_val_w=`echo x $ac_old_val`
 	ac_new_val_w=`echo x $ac_new_val`
 	if test "$ac_old_val_w" != "$ac_new_val_w"; then
-	  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: \`$ac_var' has changed since the previous run:" >&5
-printf "%s\n" "$as_me: error: \`$ac_var' has changed since the previous run:" >&2;}
+	  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: '$ac_var' has changed since the previous run:" >&5
+printf "%s\n" "$as_me: error: '$ac_var' has changed since the previous run:" >&2;}
 	  ac_cache_corrupted=:
 	else
-	  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: warning: ignoring whitespace changes in \`$ac_var' since the previous run:" >&5
-printf "%s\n" "$as_me: warning: ignoring whitespace changes in \`$ac_var' since the previous run:" >&2;}
+	  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: warning: ignoring whitespace changes in '$ac_var' since the previous run:" >&5
+printf "%s\n" "$as_me: warning: ignoring whitespace changes in '$ac_var' since the previous run:" >&2;}
 	  eval $ac_var=\$ac_old_val
 	fi
-	{ printf "%s\n" "$as_me:${as_lineno-$LINENO}:   former value:  \`$ac_old_val'" >&5
-printf "%s\n" "$as_me:   former value:  \`$ac_old_val'" >&2;}
-	{ printf "%s\n" "$as_me:${as_lineno-$LINENO}:   current value: \`$ac_new_val'" >&5
-printf "%s\n" "$as_me:   current value: \`$ac_new_val'" >&2;}
+	{ printf "%s\n" "$as_me:${as_lineno-$LINENO}:   former value:  '$ac_old_val'" >&5
+printf "%s\n" "$as_me:   former value:  '$ac_old_val'" >&2;}
+	{ printf "%s\n" "$as_me:${as_lineno-$LINENO}:   current value: '$ac_new_val'" >&5
+printf "%s\n" "$as_me:   current value: '$ac_new_val'" >&2;}
       fi;;
   esac
   # Pass precious variables to config.status.
@@ -3609,11 +3641,11 @@ printf "%s\n" "$as_me:   current value:
   fi
 done
 if $ac_cache_corrupted; then
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: changes in the environment can compromise the build" >&5
 printf "%s\n" "$as_me: error: changes in the environment can compromise the build" >&2;}
-  as_fn_error $? "run \`${MAKE-make} distclean' and/or \`rm $cache_file'
+  as_fn_error $? "run '${MAKE-make} distclean' and/or 'rm $cache_file'
 	    and start over" "$LINENO" 5
 fi
 ## -------------------- ##
@@ -3654,15 +3686,16 @@ printf %s "checking build system type...
 if test ${ac_cv_build+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_build_alias=$build_alias
+else case e in #(
+  e) ac_build_alias=$build_alias
 test "x$ac_build_alias" = x &&
   ac_build_alias=`$SHELL "${ac_aux_dir}config.guess"`
 test "x$ac_build_alias" = x &&
   as_fn_error $? "cannot guess build type; you must specify one" "$LINENO" 5
 ac_cv_build=`$SHELL "${ac_aux_dir}config.sub" $ac_build_alias` ||
   as_fn_error $? "$SHELL ${ac_aux_dir}config.sub $ac_build_alias failed" "$LINENO" 5
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_build" >&5
 printf "%s\n" "$ac_cv_build" >&6; }
@@ -3689,14 +3722,15 @@ printf %s "checking host system type...
 if test ${ac_cv_host+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test "x$host_alias" = x; then
+else case e in #(
+  e) if test "x$host_alias" = x; then
   ac_cv_host=$ac_cv_build
 else
   ac_cv_host=`$SHELL "${ac_aux_dir}config.sub" $host_alias` ||
     as_fn_error $? "$SHELL ${ac_aux_dir}config.sub $host_alias failed" "$LINENO" 5
 fi
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_host" >&5
 printf "%s\n" "$ac_cv_host" >&6; }
@@ -3723,14 +3757,15 @@ printf %s "checking target system type..
 if test ${ac_cv_target+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test "x$target_alias" = x; then
+else case e in #(
+  e) if test "x$target_alias" = x; then
   ac_cv_target=$ac_cv_host
 else
   ac_cv_target=`$SHELL "${ac_aux_dir}config.sub" $target_alias` ||
     as_fn_error $? "$SHELL ${ac_aux_dir}config.sub $target_alias failed" "$LINENO" 5
 fi
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_target" >&5
 printf "%s\n" "$ac_cv_target" >&6; }
@@ -3783,8 +3818,8 @@ if test -z "$INSTALL"; then
 if test ${ac_cv_path_install+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
+else case e in #(
+  e) as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
 for as_dir in $PATH
 do
   IFS=$as_save_IFS
@@ -3838,7 +3873,8 @@ esac
 IFS=$as_save_IFS
 
 rm -rf conftest.one conftest.two conftest.dir
-
+ ;;
+esac
 fi
   if test ${ac_cv_path_install+y}; then
     INSTALL=$ac_cv_path_install
@@ -3934,7 +3970,7 @@ test "$program_prefix" != NONE &&
 test "$program_suffix" != NONE &&
   program_transform_name="s&\$&$program_suffix&;$program_transform_name"
 # Double any \ or $.
-# By default was `s,x,x', remove it if useless.
+# By default was 's,x,x', remove it if useless.
 ac_script='s/[\\$]/&&/g;s/;s,x,x,$//'
 program_transform_name=`printf "%s\n" "$program_transform_name" | sed "$ac_script"`
 
@@ -3977,8 +4013,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_STRIP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$STRIP"; then
+else case e in #(
+  e) if test -n "$STRIP"; then
   ac_cv_prog_STRIP="$STRIP" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -4000,7 +4036,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 STRIP=$ac_cv_prog_STRIP
 if test -n "$STRIP"; then
@@ -4022,8 +4059,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_STRIP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_STRIP"; then
+else case e in #(
+  e) if test -n "$ac_ct_STRIP"; then
   ac_cv_prog_ac_ct_STRIP="$ac_ct_STRIP" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -4045,7 +4082,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_STRIP=$ac_cv_prog_ac_ct_STRIP
 if test -n "$ac_ct_STRIP"; then
@@ -4081,8 +4119,8 @@ if test -z "$MKDIR_P"; then
   if test ${ac_cv_path_mkdir+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
+else case e in #(
+  e) as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
 for as_dir in $PATH$PATH_SEPARATOR/opt/sfw/bin
 do
   IFS=$as_save_IFS
@@ -4096,7 +4134,7 @@ do
 	   as_fn_executable_p "$as_dir$ac_prog$ac_exec_ext" || continue
 	   case `"$as_dir$ac_prog$ac_exec_ext" --version 2>&1` in #(
 	     'mkdir ('*'coreutils) '* | \
-	     'BusyBox '* | \
+	     *'BusyBox '* | \
 	     'mkdir (fileutils) '4.1*)
 	       ac_cv_path_mkdir=$as_dir$ac_prog$ac_exec_ext
 	       break 3;;
@@ -4105,18 +4143,17 @@ do
        done
   done
 IFS=$as_save_IFS
-
+ ;;
+esac
 fi
 
   test -d ./--version && rmdir ./--version
   if test ${ac_cv_path_mkdir+y}; then
     MKDIR_P="$ac_cv_path_mkdir -p"
   else
-    # As a last resort, use the slow shell script.  Don't cache a
-    # value for MKDIR_P within a source directory, because that will
-    # break other packages using the cache if that directory is
-    # removed, or if the value is a relative name.
-    MKDIR_P="$ac_install_sh -d"
+    # As a last resort, use plain mkdir -p,
+    # in the hope it doesn't have the bugs of ancient mkdir.
+    MKDIR_P='mkdir -p'
   fi
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $MKDIR_P" >&5
@@ -4131,8 +4168,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_AWK+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$AWK"; then
+else case e in #(
+  e) if test -n "$AWK"; then
   ac_cv_prog_AWK="$AWK" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -4154,7 +4191,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 AWK=$ac_cv_prog_AWK
 if test -n "$AWK"; then
@@ -4176,8 +4214,8 @@ ac_make=`printf "%s\n" "$2" | sed 's/+/p
 if eval test \${ac_cv_prog_make_${ac_make}_set+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat >conftest.make <<\_ACEOF
+else case e in #(
+  e) cat >conftest.make <<\_ACEOF
 SHELL = /bin/sh
 all:
 	@echo '@@@%%%=$(MAKE)=@@@%%%'
@@ -4189,7 +4227,8 @@ case `${MAKE-make} -f conftest.make 2>/d
   *)
     eval ac_cv_prog_make_${ac_make}_set=no;;
 esac
-rm -f conftest.make
+rm -f conftest.make ;;
+esac
 fi
 if eval test \$ac_cv_prog_make_${ac_make}_set = yes; then
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
@@ -4227,8 +4266,8 @@ printf %s "checking whether $am_make sup
 if test ${am_cv_make_support_nested_variables+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if printf "%s\n" 'TRUE=$(BAR$(V))
+else case e in #(
+  e) if printf "%s\n" 'TRUE=$(BAR$(V))
 BAR0=false
 BAR1=true
 V=1
@@ -4238,7 +4277,8 @@ am__doit:
   am_cv_make_support_nested_variables=yes
 else
   am_cv_make_support_nested_variables=no
-fi
+fi ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $am_cv_make_support_nested_variables" >&5
 printf "%s\n" "$am_cv_make_support_nested_variables" >&6; }
@@ -4273,7 +4313,7 @@ fi
 
 # Define the identity of the package.
  PACKAGE='hwloc'
- VERSION='2.10.0'
+ VERSION='2.11.0'
 
 
 printf "%s\n" "#define PACKAGE \"$PACKAGE\"" >>confdefs.h
@@ -4425,8 +4465,9 @@ printf %s "checking how to create a usta
   if test ${am_cv_prog_tar_ustar+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  am_cv_prog_tar_ustar=$_am_tool
+else case e in #(
+  e) am_cv_prog_tar_ustar=$_am_tool ;;
+esac
 fi
 
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $am_cv_prog_tar_ustar" >&5
@@ -4510,8 +4551,8 @@ printf %s "checking whether $am_make sup
 if test ${am_cv_make_support_nested_variables+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if printf "%s\n" 'TRUE=$(BAR$(V))
+else case e in #(
+  e) if printf "%s\n" 'TRUE=$(BAR$(V))
 BAR0=false
 BAR1=true
 V=1
@@ -4521,7 +4562,8 @@ am__doit:
   am_cv_make_support_nested_variables=yes
 else
   am_cv_make_support_nested_variables=no
-fi
+fi ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $am_cv_make_support_nested_variables" >&5
 printf "%s\n" "$am_cv_make_support_nested_variables" >&6; }
@@ -4627,8 +4669,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$CC"; then
+else case e in #(
+  e) if test -n "$CC"; then
   ac_cv_prog_CC="$CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -4650,7 +4692,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
@@ -4672,8 +4715,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_CC"; then
+else case e in #(
+  e) if test -n "$ac_ct_CC"; then
   ac_cv_prog_ac_ct_CC="$ac_ct_CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -4695,7 +4738,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_CC=$ac_cv_prog_ac_ct_CC
 if test -n "$ac_ct_CC"; then
@@ -4730,8 +4774,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$CC"; then
+else case e in #(
+  e) if test -n "$CC"; then
   ac_cv_prog_CC="$CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -4753,7 +4797,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
@@ -4775,8 +4820,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$CC"; then
+else case e in #(
+  e) if test -n "$CC"; then
   ac_cv_prog_CC="$CC" # Let the user override the test.
 else
   ac_prog_rejected=no
@@ -4815,7 +4860,8 @@ if test $ac_prog_rejected = yes; then
     ac_cv_prog_CC="$as_dir$ac_word${1+' '}$@"
   fi
 fi
-fi
+fi ;;
+esac
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
@@ -4839,8 +4885,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$CC"; then
+else case e in #(
+  e) if test -n "$CC"; then
   ac_cv_prog_CC="$CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -4862,7 +4908,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
@@ -4888,8 +4935,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_CC"; then
+else case e in #(
+  e) if test -n "$ac_ct_CC"; then
   ac_cv_prog_ac_ct_CC="$ac_ct_CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -4911,7 +4958,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_CC=$ac_cv_prog_ac_ct_CC
 if test -n "$ac_ct_CC"; then
@@ -4949,8 +4997,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$CC"; then
+else case e in #(
+  e) if test -n "$CC"; then
   ac_cv_prog_CC="$CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -4972,7 +5020,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
@@ -4994,8 +5043,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_CC"; then
+else case e in #(
+  e) if test -n "$ac_ct_CC"; then
   ac_cv_prog_ac_ct_CC="$ac_ct_CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -5017,7 +5066,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_CC=$ac_cv_prog_ac_ct_CC
 if test -n "$ac_ct_CC"; then
@@ -5046,10 +5096,10 @@ fi
 fi
 
 
-test -z "$CC" && { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+test -z "$CC" && { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error $? "no acceptable C compiler found in \$PATH
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; }
 
 # Provide some information about the compiler.
 printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for C compiler version" >&5
@@ -5121,8 +5171,8 @@ printf "%s\n" "$ac_try_echo"; } >&5
   printf "%s\n" "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
   test $ac_status = 0; }
 then :
-  # Autoconf-2.13 could set the ac_cv_exeext variable to `no'.
-# So ignore a value of `no', otherwise this would lead to `EXEEXT = no'
+  # Autoconf-2.13 could set the ac_cv_exeext variable to 'no'.
+# So ignore a value of 'no', otherwise this would lead to 'EXEEXT = no'
 # in a Makefile.  We should not override ac_cv_exeext if it was cached,
 # so that the user can short-circuit this test for compilers unknown to
 # Autoconf.
@@ -5142,7 +5192,7 @@ do
 	   ac_cv_exeext=`expr "$ac_file" : '[^.]*\(\..*\)'`
 	fi
 	# We set ac_cv_exeext here because the later test for it is not
-	# safe: cross compilers may not add the suffix if given an `-o'
+	# safe: cross compilers may not add the suffix if given an '-o'
 	# argument, so we may need to know it at that point already.
 	# Even if this section looks crufty: it has the advantage of
 	# actually working.
@@ -5153,8 +5203,9 @@ do
 done
 test "$ac_cv_exeext" = no && ac_cv_exeext=
 
-else $as_nop
-  ac_file=''
+else case e in #(
+  e) ac_file='' ;;
+esac
 fi
 if test -z "$ac_file"
 then :
@@ -5163,13 +5214,14 @@ printf "%s\n" "no" >&6; }
 printf "%s\n" "$as_me: failed program was:" >&5
 sed 's/^/| /' conftest.$ac_ext >&5
 
-{ { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+{ { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error 77 "C compiler cannot create executables
-See \`config.log' for more details" "$LINENO" 5; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
-printf "%s\n" "yes" >&6; }
+See 'config.log' for more details" "$LINENO" 5; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+printf "%s\n" "yes" >&6; } ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for C compiler default output file name" >&5
 printf %s "checking for C compiler default output file name... " >&6; }
@@ -5193,10 +5245,10 @@ printf "%s\n" "$ac_try_echo"; } >&5
   printf "%s\n" "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
   test $ac_status = 0; }
 then :
-  # If both `conftest.exe' and `conftest' are `present' (well, observable)
-# catch `conftest.exe'.  For instance with Cygwin, `ls conftest' will
-# work properly (i.e., refer to `conftest.exe'), while it won't with
-# `rm'.
+  # If both 'conftest.exe' and 'conftest' are 'present' (well, observable)
+# catch 'conftest.exe'.  For instance with Cygwin, 'ls conftest' will
+# work properly (i.e., refer to 'conftest.exe'), while it won't with
+# 'rm'.
 for ac_file in conftest.exe conftest conftest.*; do
   test -f "$ac_file" || continue
   case $ac_file in
@@ -5206,11 +5258,12 @@ for ac_file in conftest.exe conftest con
     * ) break;;
   esac
 done
-else $as_nop
-  { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+else case e in #(
+  e) { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error $? "cannot compute suffix of executables: cannot compile and link
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; } ;;
+esac
 fi
 rm -f conftest conftest$ac_cv_exeext
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_exeext" >&5
@@ -5226,6 +5279,8 @@ int
 main (void)
 {
 FILE *f = fopen ("conftest.out", "w");
+ if (!f)
+  return 1;
  return ferror (f) || fclose (f) != 0;
 
   ;
@@ -5265,26 +5320,27 @@ printf "%s\n" "$ac_try_echo"; } >&5
     if test "$cross_compiling" = maybe; then
 	cross_compiling=yes
     else
-	{ { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+	{ { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error 77 "cannot run C compiled programs.
-If you meant to cross compile, use \`--host'.
-See \`config.log' for more details" "$LINENO" 5; }
+If you meant to cross compile, use '--host'.
+See 'config.log' for more details" "$LINENO" 5; }
     fi
   fi
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $cross_compiling" >&5
 printf "%s\n" "$cross_compiling" >&6; }
 
-rm -f conftest.$ac_ext conftest$ac_cv_exeext conftest.out
+rm -f conftest.$ac_ext conftest$ac_cv_exeext \
+  conftest.o conftest.obj conftest.out
 ac_clean_files=$ac_clean_files_save
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for suffix of object files" >&5
 printf %s "checking for suffix of object files... " >&6; }
 if test ${ac_cv_objext+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 int
@@ -5316,16 +5372,18 @@ then :
        break;;
   esac
 done
-else $as_nop
-  printf "%s\n" "$as_me: failed program was:" >&5
+else case e in #(
+  e) printf "%s\n" "$as_me: failed program was:" >&5
 sed 's/^/| /' conftest.$ac_ext >&5
 
-{ { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+{ { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error $? "cannot compute suffix of object files: cannot compile
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; } ;;
+esac
 fi
-rm -f conftest.$ac_cv_objext conftest.$ac_ext
+rm -f conftest.$ac_cv_objext conftest.$ac_ext ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_objext" >&5
 printf "%s\n" "$ac_cv_objext" >&6; }
@@ -5336,8 +5394,8 @@ printf %s "checking whether the compiler
 if test ${ac_cv_c_compiler_gnu+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 int
@@ -5354,12 +5412,14 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   ac_compiler_gnu=yes
-else $as_nop
-  ac_compiler_gnu=no
+else case e in #(
+  e) ac_compiler_gnu=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 ac_cv_c_compiler_gnu=$ac_compiler_gnu
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_c_compiler_gnu" >&5
 printf "%s\n" "$ac_cv_c_compiler_gnu" >&6; }
@@ -5377,8 +5437,8 @@ printf %s "checking whether $CC accepts
 if test ${ac_cv_prog_cc_g+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_save_c_werror_flag=$ac_c_werror_flag
+else case e in #(
+  e) ac_save_c_werror_flag=$ac_c_werror_flag
    ac_c_werror_flag=yes
    ac_cv_prog_cc_g=no
    CFLAGS="-g"
@@ -5396,8 +5456,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   ac_cv_prog_cc_g=yes
-else $as_nop
-  CFLAGS=""
+else case e in #(
+  e) CFLAGS=""
       cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -5412,8 +5472,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
 
-else $as_nop
-  ac_c_werror_flag=$ac_save_c_werror_flag
+else case e in #(
+  e) ac_c_werror_flag=$ac_save_c_werror_flag
 	 CFLAGS="-g"
 	 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -5430,12 +5490,15 @@ if ac_fn_c_try_compile "$LINENO"
 then :
   ac_cv_prog_cc_g=yes
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
-   ac_c_werror_flag=$ac_save_c_werror_flag
+   ac_c_werror_flag=$ac_save_c_werror_flag ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_g" >&5
 printf "%s\n" "$ac_cv_prog_cc_g" >&6; }
@@ -5462,8 +5525,8 @@ printf %s "checking for $CC option to en
 if test ${ac_cv_prog_cc_c11+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_cv_prog_cc_c11=no
+else case e in #(
+  e) ac_cv_prog_cc_c11=no
 ac_save_CC=$CC
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -5480,25 +5543,28 @@ rm -f core conftest.err conftest.$ac_obj
   test "x$ac_cv_prog_cc_c11" != "xno" && break
 done
 rm -f conftest.$ac_ext
-CC=$ac_save_CC
+CC=$ac_save_CC ;;
+esac
 fi
 
 if test "x$ac_cv_prog_cc_c11" = xno
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: unsupported" >&5
 printf "%s\n" "unsupported" >&6; }
-else $as_nop
-  if test "x$ac_cv_prog_cc_c11" = x
+else case e in #(
+  e) if test "x$ac_cv_prog_cc_c11" = x
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: none needed" >&5
 printf "%s\n" "none needed" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c11" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c11" >&5
 printf "%s\n" "$ac_cv_prog_cc_c11" >&6; }
-     CC="$CC $ac_cv_prog_cc_c11"
+     CC="$CC $ac_cv_prog_cc_c11" ;;
+esac
 fi
   ac_cv_prog_cc_stdc=$ac_cv_prog_cc_c11
-  ac_prog_cc_stdc=c11
+  ac_prog_cc_stdc=c11 ;;
+esac
 fi
 fi
 if test x$ac_prog_cc_stdc = xno
@@ -5508,8 +5574,8 @@ printf %s "checking for $CC option to en
 if test ${ac_cv_prog_cc_c99+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_cv_prog_cc_c99=no
+else case e in #(
+  e) ac_cv_prog_cc_c99=no
 ac_save_CC=$CC
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -5526,25 +5592,28 @@ rm -f core conftest.err conftest.$ac_obj
   test "x$ac_cv_prog_cc_c99" != "xno" && break
 done
 rm -f conftest.$ac_ext
-CC=$ac_save_CC
+CC=$ac_save_CC ;;
+esac
 fi
 
 if test "x$ac_cv_prog_cc_c99" = xno
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: unsupported" >&5
 printf "%s\n" "unsupported" >&6; }
-else $as_nop
-  if test "x$ac_cv_prog_cc_c99" = x
+else case e in #(
+  e) if test "x$ac_cv_prog_cc_c99" = x
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: none needed" >&5
 printf "%s\n" "none needed" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c99" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c99" >&5
 printf "%s\n" "$ac_cv_prog_cc_c99" >&6; }
-     CC="$CC $ac_cv_prog_cc_c99"
+     CC="$CC $ac_cv_prog_cc_c99" ;;
+esac
 fi
   ac_cv_prog_cc_stdc=$ac_cv_prog_cc_c99
-  ac_prog_cc_stdc=c99
+  ac_prog_cc_stdc=c99 ;;
+esac
 fi
 fi
 if test x$ac_prog_cc_stdc = xno
@@ -5554,8 +5623,8 @@ printf %s "checking for $CC option to en
 if test ${ac_cv_prog_cc_c89+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_cv_prog_cc_c89=no
+else case e in #(
+  e) ac_cv_prog_cc_c89=no
 ac_save_CC=$CC
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -5572,25 +5641,28 @@ rm -f core conftest.err conftest.$ac_obj
   test "x$ac_cv_prog_cc_c89" != "xno" && break
 done
 rm -f conftest.$ac_ext
-CC=$ac_save_CC
+CC=$ac_save_CC ;;
+esac
 fi
 
 if test "x$ac_cv_prog_cc_c89" = xno
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: unsupported" >&5
 printf "%s\n" "unsupported" >&6; }
-else $as_nop
-  if test "x$ac_cv_prog_cc_c89" = x
+else case e in #(
+  e) if test "x$ac_cv_prog_cc_c89" = x
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: none needed" >&5
 printf "%s\n" "none needed" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c89" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c89" >&5
 printf "%s\n" "$ac_cv_prog_cc_c89" >&6; }
-     CC="$CC $ac_cv_prog_cc_c89"
+     CC="$CC $ac_cv_prog_cc_c89" ;;
+esac
 fi
   ac_cv_prog_cc_stdc=$ac_cv_prog_cc_c89
-  ac_prog_cc_stdc=c89
+  ac_prog_cc_stdc=c89 ;;
+esac
 fi
 fi
 
@@ -5611,8 +5683,8 @@ printf %s "checking whether $CC understa
 if test ${am_cv_prog_cc_c_o+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 int
@@ -5642,7 +5714,8 @@ _ACEOF
     fi
   done
   rm -f core conftest*
-  unset am_i
+  unset am_i ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $am_cv_prog_cc_c_o" >&5
 printf "%s\n" "$am_cv_prog_cc_c_o" >&6; }
@@ -5668,8 +5741,8 @@ printf %s "checking dependency style of
 if test ${am_cv_CC_dependencies_compiler_type+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -z "$AMDEP_TRUE" && test -f "$am_depcomp"; then
+else case e in #(
+  e) if test -z "$AMDEP_TRUE" && test -f "$am_depcomp"; then
   # We make a subdir and do the tests there.  Otherwise we can end up
   # making bogus files that we don't know about and never remove.  For
   # instance it was reported that on HP-UX the gcc test will end up
@@ -5773,7 +5846,8 @@ else $as_nop
 else
   am_cv_CC_dependencies_compiler_type=none
 fi
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $am_cv_CC_dependencies_compiler_type" >&5
 printf "%s\n" "$am_cv_CC_dependencies_compiler_type" >&6; }
@@ -5831,8 +5905,8 @@ printf %s "checking whether it is safe t
 if test ${ac_cv_safe_to_define___extensions__+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 #         define __EXTENSIONS__ 1
@@ -5848,10 +5922,12 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   ac_cv_safe_to_define___extensions__=yes
-else $as_nop
-  ac_cv_safe_to_define___extensions__=no
+else case e in #(
+  e) ac_cv_safe_to_define___extensions__=no ;;
+esac
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_safe_to_define___extensions__" >&5
 printf "%s\n" "$ac_cv_safe_to_define___extensions__" >&6; }
@@ -5861,8 +5937,8 @@ printf %s "checking whether _XOPEN_SOURC
 if test ${ac_cv_should_define__xopen_source+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_cv_should_define__xopen_source=no
+else case e in #(
+  e) ac_cv_should_define__xopen_source=no
     if test $ac_cv_header_wchar_h = yes
 then :
   cat confdefs.h - <<_ACEOF >conftest.$ac_ext
@@ -5881,8 +5957,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
 
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
             #define _XOPEN_SOURCE 500
@@ -5900,10 +5976,12 @@ if ac_fn_c_try_compile "$LINENO"
 then :
   ac_cv_should_define__xopen_source=yes
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
-fi
+fi ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_should_define__xopen_source" >&5
 printf "%s\n" "$ac_cv_should_define__xopen_source" >&6; }
@@ -5928,6 +6006,8 @@ printf "%s\n" "$ac_cv_should_define__xop
 
   printf "%s\n" "#define __STDC_WANT_IEC_60559_DFP_EXT__ 1" >>confdefs.h
 
+  printf "%s\n" "#define __STDC_WANT_IEC_60559_EXT__ 1" >>confdefs.h
+
   printf "%s\n" "#define __STDC_WANT_IEC_60559_FUNCS_EXT__ 1" >>confdefs.h
 
   printf "%s\n" "#define __STDC_WANT_IEC_60559_TYPES_EXT__ 1" >>confdefs.h
@@ -5947,8 +6027,9 @@ then :
 
     printf "%s\n" "#define _POSIX_1_SOURCE 2" >>confdefs.h
 
-else $as_nop
-  MINIX=
+else case e in #(
+  e) MINIX= ;;
+esac
 fi
   if test $ac_cv_safe_to_define___extensions__ = yes
 then :
@@ -5999,8 +6080,9 @@ then :
       IFS=$lt_save_ifs
       ;;
     esac
-else $as_nop
-  enable_shared=yes
+else case e in #(
+  e) enable_shared=yes ;;
+esac
 fi
 
 
@@ -6031,8 +6113,9 @@ then :
       IFS=$lt_save_ifs
       ;;
     esac
-else $as_nop
-  enable_static=no
+else case e in #(
+  e) enable_static=no ;;
+esac
 fi
 
 
@@ -6057,8 +6140,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_AR+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$AR"; then
+else case e in #(
+  e) if test -n "$AR"; then
   ac_cv_prog_AR="$AR" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -6080,7 +6163,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 AR=$ac_cv_prog_AR
 if test -n "$AR"; then
@@ -6106,8 +6190,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_AR+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_AR"; then
+else case e in #(
+  e) if test -n "$ac_ct_AR"; then
   ac_cv_prog_ac_ct_AR="$ac_ct_AR" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -6129,7 +6213,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_AR=$ac_cv_prog_ac_ct_AR
 if test -n "$ac_ct_AR"; then
@@ -6164,8 +6249,8 @@ printf %s "checking the archiver ($AR) i
 if test ${am_cv_ar_interface+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_ext=c
+else case e in #(
+  e) ac_ext=c
 ac_cpp='$CPP $CPPFLAGS'
 ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
 ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
@@ -6208,7 +6293,8 @@ ac_cpp='$CPP $CPPFLAGS'
 ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
 ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
 ac_compiler_gnu=$ac_cv_c_compiler_gnu
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $am_cv_ar_interface" >&5
 printf "%s\n" "$am_cv_ar_interface" >&6; }
@@ -6331,8 +6417,8 @@ printf %s "checking for a sed that does
 if test ${ac_cv_path_SED+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-            ac_script=s/aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa/bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb/
+else case e in #(
+  e)           ac_script=s/aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa/bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb/
      for ac_i in 1 2 3 4 5 6 7; do
        ac_script="$ac_script$as_nl$ac_script"
      done
@@ -6357,9 +6443,10 @@ do
       as_fn_executable_p "$ac_path_SED" || continue
 # Check for GNU ac_path_SED and select it if it is found.
   # Check for GNU $ac_path_SED
-case `"$ac_path_SED" --version 2>&1` in
+case `"$ac_path_SED" --version 2>&1` in #(
 *GNU*)
   ac_cv_path_SED="$ac_path_SED" ac_path_SED_found=:;;
+#(
 *)
   ac_count=0
   printf %s 0123456789 >"conftest.in"
@@ -6394,7 +6481,8 @@ IFS=$as_save_IFS
 else
   ac_cv_path_SED=$SED
 fi
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_path_SED" >&5
 printf "%s\n" "$ac_cv_path_SED" >&6; }
@@ -6419,8 +6507,8 @@ printf %s "checking for grep that handle
 if test ${ac_cv_path_GREP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -z "$GREP"; then
+else case e in #(
+  e) if test -z "$GREP"; then
   ac_path_GREP_found=false
   # Loop through the user's path and test for each of PROGNAME-LIST
   as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -6439,9 +6527,10 @@ do
       as_fn_executable_p "$ac_path_GREP" || continue
 # Check for GNU ac_path_GREP and select it if it is found.
   # Check for GNU $ac_path_GREP
-case `"$ac_path_GREP" --version 2>&1` in
+case `"$ac_path_GREP" --version 2>&1` in #(
 *GNU*)
   ac_cv_path_GREP="$ac_path_GREP" ac_path_GREP_found=:;;
+#(
 *)
   ac_count=0
   printf %s 0123456789 >"conftest.in"
@@ -6476,7 +6565,8 @@ IFS=$as_save_IFS
 else
   ac_cv_path_GREP=$GREP
 fi
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_path_GREP" >&5
 printf "%s\n" "$ac_cv_path_GREP" >&6; }
@@ -6488,8 +6578,8 @@ printf %s "checking for egrep... " >&6;
 if test ${ac_cv_path_EGREP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if echo a | $GREP -E '(a|b)' >/dev/null 2>&1
+else case e in #(
+  e) if echo a | $GREP -E '(a|b)' >/dev/null 2>&1
    then ac_cv_path_EGREP="$GREP -E"
    else
      if test -z "$EGREP"; then
@@ -6511,9 +6601,10 @@ do
       as_fn_executable_p "$ac_path_EGREP" || continue
 # Check for GNU ac_path_EGREP and select it if it is found.
   # Check for GNU $ac_path_EGREP
-case `"$ac_path_EGREP" --version 2>&1` in
+case `"$ac_path_EGREP" --version 2>&1` in #(
 *GNU*)
   ac_cv_path_EGREP="$ac_path_EGREP" ac_path_EGREP_found=:;;
+#(
 *)
   ac_count=0
   printf %s 0123456789 >"conftest.in"
@@ -6549,20 +6640,23 @@ else
   ac_cv_path_EGREP=$EGREP
 fi
 
-   fi
+   fi ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_path_EGREP" >&5
 printf "%s\n" "$ac_cv_path_EGREP" >&6; }
  EGREP="$ac_cv_path_EGREP"
 
+         EGREP_TRADITIONAL=$EGREP
+ ac_cv_path_EGREP_TRADITIONAL=$EGREP
 
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for fgrep" >&5
 printf %s "checking for fgrep... " >&6; }
 if test ${ac_cv_path_FGREP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if echo 'ab*c' | $GREP -F 'ab*c' >/dev/null 2>&1
+else case e in #(
+  e) if echo 'ab*c' | $GREP -F 'ab*c' >/dev/null 2>&1
    then ac_cv_path_FGREP="$GREP -F"
    else
      if test -z "$FGREP"; then
@@ -6584,9 +6678,10 @@ do
       as_fn_executable_p "$ac_path_FGREP" || continue
 # Check for GNU ac_path_FGREP and select it if it is found.
   # Check for GNU $ac_path_FGREP
-case `"$ac_path_FGREP" --version 2>&1` in
+case `"$ac_path_FGREP" --version 2>&1` in #(
 *GNU*)
   ac_cv_path_FGREP="$ac_path_FGREP" ac_path_FGREP_found=:;;
+#(
 *)
   ac_count=0
   printf %s 0123456789 >"conftest.in"
@@ -6622,7 +6717,8 @@ else
   ac_cv_path_FGREP=$FGREP
 fi
 
-   fi
+   fi ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_path_FGREP" >&5
 printf "%s\n" "$ac_cv_path_FGREP" >&6; }
@@ -6653,8 +6749,9 @@ test -z "$GREP" && GREP=grep
 if test ${with_gnu_ld+y}
 then :
   withval=$with_gnu_ld; test no = "$withval" || with_gnu_ld=yes
-else $as_nop
-  with_gnu_ld=no
+else case e in #(
+  e) with_gnu_ld=no ;;
+esac
 fi
 
 ac_prog=ld
@@ -6699,8 +6796,8 @@ fi
 if test ${lt_cv_path_LD+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -z "$LD"; then
+else case e in #(
+  e) if test -z "$LD"; then
   lt_save_ifs=$IFS; IFS=$PATH_SEPARATOR
   for ac_dir in $PATH; do
     IFS=$lt_save_ifs
@@ -6723,7 +6820,8 @@ else $as_nop
   IFS=$lt_save_ifs
 else
   lt_cv_path_LD=$LD # Let the user override the test with a path.
-fi
+fi ;;
+esac
 fi
 
 LD=$lt_cv_path_LD
@@ -6740,8 +6838,8 @@ printf %s "checking if the linker ($LD)
 if test ${lt_cv_prog_gnu_ld+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  # I'd rather use --version here, but apparently some GNU lds only accept -v.
+else case e in #(
+  e) # I'd rather use --version here, but apparently some GNU lds only accept -v.
 case `$LD -v 2>&1 </dev/null` in
 *GNU* | *'with BFD'*)
   lt_cv_prog_gnu_ld=yes
@@ -6749,6 +6847,7 @@ case `$LD -v 2>&1 </dev/null` in
 *)
   lt_cv_prog_gnu_ld=no
   ;;
+esac ;;
 esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_gnu_ld" >&5
@@ -6768,8 +6867,8 @@ printf %s "checking for BSD- or MS-compa
 if test ${lt_cv_path_NM+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$NM"; then
+else case e in #(
+  e) if test -n "$NM"; then
   # Let the user override the test.
   lt_cv_path_NM=$NM
 else
@@ -6816,7 +6915,8 @@ else
     IFS=$lt_save_ifs
   done
   : ${lt_cv_path_NM=no}
-fi
+fi ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_path_NM" >&5
 printf "%s\n" "$lt_cv_path_NM" >&6; }
@@ -6837,8 +6937,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_DUMPBIN+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$DUMPBIN"; then
+else case e in #(
+  e) if test -n "$DUMPBIN"; then
   ac_cv_prog_DUMPBIN="$DUMPBIN" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -6860,7 +6960,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 DUMPBIN=$ac_cv_prog_DUMPBIN
 if test -n "$DUMPBIN"; then
@@ -6886,8 +6987,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_DUMPBIN+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_DUMPBIN"; then
+else case e in #(
+  e) if test -n "$ac_ct_DUMPBIN"; then
   ac_cv_prog_ac_ct_DUMPBIN="$ac_ct_DUMPBIN" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -6909,7 +7010,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_DUMPBIN=$ac_cv_prog_ac_ct_DUMPBIN
 if test -n "$ac_ct_DUMPBIN"; then
@@ -6963,8 +7065,8 @@ printf %s "checking the name lister ($NM
 if test ${lt_cv_nm_interface+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_nm_interface="BSD nm"
+else case e in #(
+  e) lt_cv_nm_interface="BSD nm"
   echo "int some_variable = 0;" > conftest.$ac_ext
   (eval echo "\"\$as_me:$LINENO: $ac_compile\"" >&5)
   (eval "$ac_compile" 2>conftest.err)
@@ -6977,7 +7079,8 @@ else $as_nop
   if $GREP 'External.*some_variable' conftest.out > /dev/null; then
     lt_cv_nm_interface="MS dumpbin"
   fi
-  rm -f conftest*
+  rm -f conftest* ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_nm_interface" >&5
 printf "%s\n" "$lt_cv_nm_interface" >&6; }
@@ -6999,8 +7102,8 @@ printf %s "checking the maximum length o
 if test ${lt_cv_sys_max_cmd_len+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-    i=0
+else case e in #(
+  e)   i=0
   teststring=ABCD
 
   case $build_os in
@@ -7122,7 +7225,8 @@ else $as_nop
     fi
     ;;
   esac
-
+ ;;
+esac
 fi
 
 if test -n "$lt_cv_sys_max_cmd_len"; then
@@ -7179,8 +7283,8 @@ printf %s "checking how to convert $buil
 if test ${lt_cv_to_host_file_cmd+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $host in
+else case e in #(
+  e) case $host in
   *-*-mingw* )
     case $build in
       *-*-mingw* ) # actually msys
@@ -7211,7 +7315,8 @@ else $as_nop
     lt_cv_to_host_file_cmd=func_convert_file_noop
     ;;
 esac
-
+ ;;
+esac
 fi
 
 to_host_file_cmd=$lt_cv_to_host_file_cmd
@@ -7227,8 +7332,8 @@ printf %s "checking how to convert $buil
 if test ${lt_cv_to_tool_file_cmd+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  #assume ordinary cross tools, or native build.
+else case e in #(
+  e) #assume ordinary cross tools, or native build.
 lt_cv_to_tool_file_cmd=func_convert_file_noop
 case $host in
   *-*-mingw* )
@@ -7239,7 +7344,8 @@ case $host in
     esac
     ;;
 esac
-
+ ;;
+esac
 fi
 
 to_tool_file_cmd=$lt_cv_to_tool_file_cmd
@@ -7255,8 +7361,9 @@ printf %s "checking for $LD option to re
 if test ${lt_cv_ld_reload_flag+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_ld_reload_flag='-r'
+else case e in #(
+  e) lt_cv_ld_reload_flag='-r' ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_ld_reload_flag" >&5
 printf "%s\n" "$lt_cv_ld_reload_flag" >&6; }
@@ -7297,8 +7404,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_FILECMD+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$FILECMD"; then
+else case e in #(
+  e) if test -n "$FILECMD"; then
   ac_cv_prog_FILECMD="$FILECMD" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -7320,7 +7427,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 FILECMD=$ac_cv_prog_FILECMD
 if test -n "$FILECMD"; then
@@ -7342,8 +7450,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_FILECMD+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_FILECMD"; then
+else case e in #(
+  e) if test -n "$ac_ct_FILECMD"; then
   ac_cv_prog_ac_ct_FILECMD="$ac_ct_FILECMD" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -7365,7 +7473,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_FILECMD=$ac_cv_prog_ac_ct_FILECMD
 if test -n "$ac_ct_FILECMD"; then
@@ -7405,8 +7514,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_OBJDUMP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$OBJDUMP"; then
+else case e in #(
+  e) if test -n "$OBJDUMP"; then
   ac_cv_prog_OBJDUMP="$OBJDUMP" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -7428,7 +7537,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 OBJDUMP=$ac_cv_prog_OBJDUMP
 if test -n "$OBJDUMP"; then
@@ -7450,8 +7560,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_OBJDUMP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_OBJDUMP"; then
+else case e in #(
+  e) if test -n "$ac_ct_OBJDUMP"; then
   ac_cv_prog_ac_ct_OBJDUMP="$ac_ct_OBJDUMP" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -7473,7 +7583,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_OBJDUMP=$ac_cv_prog_ac_ct_OBJDUMP
 if test -n "$ac_ct_OBJDUMP"; then
@@ -7511,8 +7622,8 @@ printf %s "checking how to recognize dep
 if test ${lt_cv_deplibs_check_method+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_file_magic_cmd='$MAGIC_CMD'
+else case e in #(
+  e) lt_cv_file_magic_cmd='$MAGIC_CMD'
 lt_cv_file_magic_test_file=
 lt_cv_deplibs_check_method='unknown'
 # Need to set the preceding variable on all platforms that support
@@ -7705,7 +7816,8 @@ os2*)
   lt_cv_deplibs_check_method=pass_all
   ;;
 esac
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_deplibs_check_method" >&5
 printf "%s\n" "$lt_cv_deplibs_check_method" >&6; }
@@ -7757,8 +7869,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_DLLTOOL+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$DLLTOOL"; then
+else case e in #(
+  e) if test -n "$DLLTOOL"; then
   ac_cv_prog_DLLTOOL="$DLLTOOL" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -7780,7 +7892,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 DLLTOOL=$ac_cv_prog_DLLTOOL
 if test -n "$DLLTOOL"; then
@@ -7802,8 +7915,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_DLLTOOL+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_DLLTOOL"; then
+else case e in #(
+  e) if test -n "$ac_ct_DLLTOOL"; then
   ac_cv_prog_ac_ct_DLLTOOL="$ac_ct_DLLTOOL" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -7825,7 +7938,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_DLLTOOL=$ac_cv_prog_ac_ct_DLLTOOL
 if test -n "$ac_ct_DLLTOOL"; then
@@ -7864,8 +7978,8 @@ printf %s "checking how to associate run
 if test ${lt_cv_sharedlib_from_linklib_cmd+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_sharedlib_from_linklib_cmd='unknown'
+else case e in #(
+  e) lt_cv_sharedlib_from_linklib_cmd='unknown'
 
 case $host_os in
 cygwin* | mingw* | pw32* | cegcc*)
@@ -7885,7 +7999,8 @@ cygwin* | mingw* | pw32* | cegcc*)
   lt_cv_sharedlib_from_linklib_cmd=$ECHO
   ;;
 esac
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_sharedlib_from_linklib_cmd" >&5
 printf "%s\n" "$lt_cv_sharedlib_from_linklib_cmd" >&6; }
@@ -7908,8 +8023,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_AR+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$AR"; then
+else case e in #(
+  e) if test -n "$AR"; then
   ac_cv_prog_AR="$AR" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -7931,7 +8046,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 AR=$ac_cv_prog_AR
 if test -n "$AR"; then
@@ -7957,8 +8073,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_AR+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_AR"; then
+else case e in #(
+  e) if test -n "$ac_ct_AR"; then
   ac_cv_prog_ac_ct_AR="$ac_ct_AR" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -7980,7 +8096,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_AR=$ac_cv_prog_ac_ct_AR
 if test -n "$ac_ct_AR"; then
@@ -8042,8 +8159,8 @@ printf %s "checking for archiver @FILE s
 if test ${lt_cv_ar_at_file+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_ar_at_file=no
+else case e in #(
+  e) lt_cv_ar_at_file=no
    cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -8080,7 +8197,8 @@ then :
 
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
-
+   ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_ar_at_file" >&5
 printf "%s\n" "$lt_cv_ar_at_file" >&6; }
@@ -8105,8 +8223,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_STRIP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$STRIP"; then
+else case e in #(
+  e) if test -n "$STRIP"; then
   ac_cv_prog_STRIP="$STRIP" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -8128,7 +8246,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 STRIP=$ac_cv_prog_STRIP
 if test -n "$STRIP"; then
@@ -8150,8 +8269,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_STRIP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_STRIP"; then
+else case e in #(
+  e) if test -n "$ac_ct_STRIP"; then
   ac_cv_prog_ac_ct_STRIP="$ac_ct_STRIP" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -8173,7 +8292,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_STRIP=$ac_cv_prog_ac_ct_STRIP
 if test -n "$ac_ct_STRIP"; then
@@ -8214,8 +8334,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_RANLIB+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$RANLIB"; then
+else case e in #(
+  e) if test -n "$RANLIB"; then
   ac_cv_prog_RANLIB="$RANLIB" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -8237,7 +8357,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 RANLIB=$ac_cv_prog_RANLIB
 if test -n "$RANLIB"; then
@@ -8259,8 +8380,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_RANLIB+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_RANLIB"; then
+else case e in #(
+  e) if test -n "$ac_ct_RANLIB"; then
   ac_cv_prog_ac_ct_RANLIB="$ac_ct_RANLIB" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -8282,7 +8403,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_RANLIB=$ac_cv_prog_ac_ct_RANLIB
 if test -n "$ac_ct_RANLIB"; then
@@ -8393,8 +8515,8 @@ printf %s "checking command to parse $NM
 if test ${lt_cv_sys_global_symbol_pipe+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
 # These are sane defaults that work on at least a few old systems.
 # [They come from Ultrix.  What could be older than Ultrix?!! ;)]
 
@@ -8649,7 +8771,8 @@ _LT_EOF
     lt_cv_sys_global_symbol_pipe=
   fi
 done
-
+ ;;
+esac
 fi
 
 if test -z "$lt_cv_sys_global_symbol_pipe"; then
@@ -8713,8 +8836,9 @@ printf %s "checking for sysroot... " >&6
 if test ${with_sysroot+y}
 then :
   withval=$with_sysroot;
-else $as_nop
-  with_sysroot=no
+else case e in #(
+  e) with_sysroot=no ;;
+esac
 fi
 
 
@@ -8749,8 +8873,8 @@ printf %s "checking for a working dd...
 if test ${ac_cv_path_lt_DD+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  printf 0123456789abcdef0123456789abcdef >conftest.i
+else case e in #(
+  e) printf 0123456789abcdef0123456789abcdef >conftest.i
 cat conftest.i conftest.i >conftest2.i
 : ${lt_DD:=$DD}
 if test -z "$lt_DD"; then
@@ -8786,7 +8910,8 @@ else
   ac_cv_path_lt_DD=$lt_DD
 fi
 
-rm -f conftest.i conftest2.i conftest.out
+rm -f conftest.i conftest2.i conftest.out ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_path_lt_DD" >&5
 printf "%s\n" "$ac_cv_path_lt_DD" >&6; }
@@ -8797,8 +8922,8 @@ printf %s "checking how to truncate bina
 if test ${lt_cv_truncate_bin+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  printf 0123456789abcdef0123456789abcdef >conftest.i
+else case e in #(
+  e) printf 0123456789abcdef0123456789abcdef >conftest.i
 cat conftest.i conftest.i >conftest2.i
 lt_cv_truncate_bin=
 if "$ac_cv_path_lt_DD" bs=32 count=1 <conftest2.i >conftest.out 2>/dev/null; then
@@ -8806,7 +8931,8 @@ if "$ac_cv_path_lt_DD" bs=32 count=1 <co
   && lt_cv_truncate_bin="$ac_cv_path_lt_DD bs=4096 count=1"
 fi
 rm -f conftest.i conftest2.i conftest.out
-test -z "$lt_cv_truncate_bin" && lt_cv_truncate_bin="$SED -e 4q"
+test -z "$lt_cv_truncate_bin" && lt_cv_truncate_bin="$SED -e 4q" ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_truncate_bin" >&5
 printf "%s\n" "$lt_cv_truncate_bin" >&6; }
@@ -9016,8 +9142,8 @@ printf %s "checking whether the C compil
 if test ${lt_cv_cc_needs_belf+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_ext=c
+else case e in #(
+  e) ac_ext=c
 ac_cpp='$CPP $CPPFLAGS'
 ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
 ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
@@ -9037,8 +9163,9 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   lt_cv_cc_needs_belf=yes
-else $as_nop
-  lt_cv_cc_needs_belf=no
+else case e in #(
+  e) lt_cv_cc_needs_belf=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -9047,7 +9174,8 @@ ac_cpp='$CPP $CPPFLAGS'
 ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
 ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
 ac_compiler_gnu=$ac_cv_c_compiler_gnu
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_cc_needs_belf" >&5
 printf "%s\n" "$lt_cv_cc_needs_belf" >&6; }
@@ -9105,8 +9233,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_MANIFEST_TOOL+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$MANIFEST_TOOL"; then
+else case e in #(
+  e) if test -n "$MANIFEST_TOOL"; then
   ac_cv_prog_MANIFEST_TOOL="$MANIFEST_TOOL" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9128,7 +9256,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 MANIFEST_TOOL=$ac_cv_prog_MANIFEST_TOOL
 if test -n "$MANIFEST_TOOL"; then
@@ -9150,8 +9279,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_MANIFEST_TOOL+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_MANIFEST_TOOL"; then
+else case e in #(
+  e) if test -n "$ac_ct_MANIFEST_TOOL"; then
   ac_cv_prog_ac_ct_MANIFEST_TOOL="$ac_ct_MANIFEST_TOOL" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9173,7 +9302,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_MANIFEST_TOOL=$ac_cv_prog_ac_ct_MANIFEST_TOOL
 if test -n "$ac_ct_MANIFEST_TOOL"; then
@@ -9205,15 +9335,16 @@ printf %s "checking if $MANIFEST_TOOL is
 if test ${lt_cv_path_mainfest_tool+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_path_mainfest_tool=no
+else case e in #(
+  e) lt_cv_path_mainfest_tool=no
   echo "$as_me:$LINENO: $MANIFEST_TOOL '-?'" >&5
   $MANIFEST_TOOL '-?' 2>conftest.err > conftest.out
   cat conftest.err >&5
   if $GREP 'Manifest Tool' conftest.out > /dev/null; then
     lt_cv_path_mainfest_tool=yes
   fi
-  rm -f conftest*
+  rm -f conftest* ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_path_mainfest_tool" >&5
 printf "%s\n" "$lt_cv_path_mainfest_tool" >&6; }
@@ -9236,8 +9367,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_DSYMUTIL+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$DSYMUTIL"; then
+else case e in #(
+  e) if test -n "$DSYMUTIL"; then
   ac_cv_prog_DSYMUTIL="$DSYMUTIL" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9259,7 +9390,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 DSYMUTIL=$ac_cv_prog_DSYMUTIL
 if test -n "$DSYMUTIL"; then
@@ -9281,8 +9413,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_DSYMUTIL+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_DSYMUTIL"; then
+else case e in #(
+  e) if test -n "$ac_ct_DSYMUTIL"; then
   ac_cv_prog_ac_ct_DSYMUTIL="$ac_ct_DSYMUTIL" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9304,7 +9436,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_DSYMUTIL=$ac_cv_prog_ac_ct_DSYMUTIL
 if test -n "$ac_ct_DSYMUTIL"; then
@@ -9338,8 +9471,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_NMEDIT+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$NMEDIT"; then
+else case e in #(
+  e) if test -n "$NMEDIT"; then
   ac_cv_prog_NMEDIT="$NMEDIT" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9361,7 +9494,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 NMEDIT=$ac_cv_prog_NMEDIT
 if test -n "$NMEDIT"; then
@@ -9383,8 +9517,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_NMEDIT+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_NMEDIT"; then
+else case e in #(
+  e) if test -n "$ac_ct_NMEDIT"; then
   ac_cv_prog_ac_ct_NMEDIT="$ac_ct_NMEDIT" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9406,7 +9540,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_NMEDIT=$ac_cv_prog_ac_ct_NMEDIT
 if test -n "$ac_ct_NMEDIT"; then
@@ -9440,8 +9575,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_LIPO+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$LIPO"; then
+else case e in #(
+  e) if test -n "$LIPO"; then
   ac_cv_prog_LIPO="$LIPO" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9463,7 +9598,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 LIPO=$ac_cv_prog_LIPO
 if test -n "$LIPO"; then
@@ -9485,8 +9621,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_LIPO+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_LIPO"; then
+else case e in #(
+  e) if test -n "$ac_ct_LIPO"; then
   ac_cv_prog_ac_ct_LIPO="$ac_ct_LIPO" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9508,7 +9644,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_LIPO=$ac_cv_prog_ac_ct_LIPO
 if test -n "$ac_ct_LIPO"; then
@@ -9542,8 +9679,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_OTOOL+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$OTOOL"; then
+else case e in #(
+  e) if test -n "$OTOOL"; then
   ac_cv_prog_OTOOL="$OTOOL" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9565,7 +9702,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 OTOOL=$ac_cv_prog_OTOOL
 if test -n "$OTOOL"; then
@@ -9587,8 +9725,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_OTOOL+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_OTOOL"; then
+else case e in #(
+  e) if test -n "$ac_ct_OTOOL"; then
   ac_cv_prog_ac_ct_OTOOL="$ac_ct_OTOOL" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9610,7 +9748,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_OTOOL=$ac_cv_prog_ac_ct_OTOOL
 if test -n "$ac_ct_OTOOL"; then
@@ -9644,8 +9783,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_OTOOL64+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$OTOOL64"; then
+else case e in #(
+  e) if test -n "$OTOOL64"; then
   ac_cv_prog_OTOOL64="$OTOOL64" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9667,7 +9806,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 OTOOL64=$ac_cv_prog_OTOOL64
 if test -n "$OTOOL64"; then
@@ -9689,8 +9829,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_OTOOL64+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_OTOOL64"; then
+else case e in #(
+  e) if test -n "$ac_ct_OTOOL64"; then
   ac_cv_prog_ac_ct_OTOOL64="$ac_ct_OTOOL64" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9712,7 +9852,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_OTOOL64=$ac_cv_prog_ac_ct_OTOOL64
 if test -n "$ac_ct_OTOOL64"; then
@@ -9769,8 +9910,8 @@ printf %s "checking for -single_module l
 if test ${lt_cv_apple_cc_single_mod+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_apple_cc_single_mod=no
+else case e in #(
+  e) lt_cv_apple_cc_single_mod=no
       if test -z "$LT_MULTI_MODULE"; then
 	# By default we will add the -single_module flag. You can override
 	# by either setting the environment variable LT_MULTI_MODULE
@@ -9796,7 +9937,8 @@ else $as_nop
 	fi
 	rm -rf libconftest.dylib*
 	rm -f conftest.*
-      fi
+      fi ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_apple_cc_single_mod" >&5
 printf "%s\n" "$lt_cv_apple_cc_single_mod" >&6; }
@@ -9806,8 +9948,8 @@ printf %s "checking for -exported_symbol
 if test ${lt_cv_ld_exported_symbols_list+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_ld_exported_symbols_list=no
+else case e in #(
+  e) lt_cv_ld_exported_symbols_list=no
       save_LDFLAGS=$LDFLAGS
       echo "_main" > conftest.sym
       LDFLAGS="$LDFLAGS -Wl,-exported_symbols_list,conftest.sym"
@@ -9825,13 +9967,15 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   lt_cv_ld_exported_symbols_list=yes
-else $as_nop
-  lt_cv_ld_exported_symbols_list=no
+else case e in #(
+  e) lt_cv_ld_exported_symbols_list=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
 	LDFLAGS=$save_LDFLAGS
-
+     ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_ld_exported_symbols_list" >&5
 printf "%s\n" "$lt_cv_ld_exported_symbols_list" >&6; }
@@ -9841,8 +9985,8 @@ printf %s "checking for -force_load link
 if test ${lt_cv_ld_force_load+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_ld_force_load=no
+else case e in #(
+  e) lt_cv_ld_force_load=no
       cat > conftest.c << _LT_EOF
 int forced_loaded() { return 2;}
 _LT_EOF
@@ -9867,7 +10011,8 @@ _LT_EOF
       fi
         rm -f conftest.err libconftest.a conftest conftest.c
         rm -rf conftest.dSYM
-
+     ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_ld_force_load" >&5
 printf "%s\n" "$lt_cv_ld_force_load" >&6; }
@@ -9962,8 +10107,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_AS+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$AS"; then
+else case e in #(
+  e) if test -n "$AS"; then
   ac_cv_prog_AS="$AS" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -9985,7 +10130,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 AS=$ac_cv_prog_AS
 if test -n "$AS"; then
@@ -10007,8 +10153,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_AS+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_AS"; then
+else case e in #(
+  e) if test -n "$ac_ct_AS"; then
   ac_cv_prog_ac_ct_AS="$ac_ct_AS" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -10030,7 +10176,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_AS=$ac_cv_prog_ac_ct_AS
 if test -n "$ac_ct_AS"; then
@@ -10064,8 +10211,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_DLLTOOL+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$DLLTOOL"; then
+else case e in #(
+  e) if test -n "$DLLTOOL"; then
   ac_cv_prog_DLLTOOL="$DLLTOOL" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -10087,7 +10234,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 DLLTOOL=$ac_cv_prog_DLLTOOL
 if test -n "$DLLTOOL"; then
@@ -10109,8 +10257,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_DLLTOOL+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_DLLTOOL"; then
+else case e in #(
+  e) if test -n "$ac_ct_DLLTOOL"; then
   ac_cv_prog_ac_ct_DLLTOOL="$ac_ct_DLLTOOL" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -10132,7 +10280,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_DLLTOOL=$ac_cv_prog_ac_ct_DLLTOOL
 if test -n "$ac_ct_DLLTOOL"; then
@@ -10166,8 +10315,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_OBJDUMP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$OBJDUMP"; then
+else case e in #(
+  e) if test -n "$OBJDUMP"; then
   ac_cv_prog_OBJDUMP="$OBJDUMP" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -10189,7 +10338,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 OBJDUMP=$ac_cv_prog_OBJDUMP
 if test -n "$OBJDUMP"; then
@@ -10211,8 +10361,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_OBJDUMP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_OBJDUMP"; then
+else case e in #(
+  e) if test -n "$ac_ct_OBJDUMP"; then
   ac_cv_prog_ac_ct_OBJDUMP="$ac_ct_OBJDUMP" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -10234,7 +10384,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_OBJDUMP=$ac_cv_prog_ac_ct_OBJDUMP
 if test -n "$ac_ct_OBJDUMP"; then
@@ -10307,8 +10458,9 @@ then :
       IFS=$lt_save_ifs
       ;;
     esac
-else $as_nop
-  pic_mode=default
+else case e in #(
+  e) pic_mode=default ;;
+esac
 fi
 
 
@@ -10338,8 +10490,9 @@ then :
       IFS=$lt_save_ifs
       ;;
     esac
-else $as_nop
-  enable_fast_install=yes
+else case e in #(
+  e) enable_fast_install=yes ;;
+esac
 fi
 
 
@@ -10366,15 +10519,17 @@ then :
       ;;
     esac
     lt_cv_with_aix_soname=$with_aix_soname
-else $as_nop
-  if test ${lt_cv_with_aix_soname+y}
+else case e in #(
+  e) if test ${lt_cv_with_aix_soname+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_with_aix_soname=aix
+else case e in #(
+  e) lt_cv_with_aix_soname=aix ;;
+esac
 fi
 
-    with_aix_soname=$lt_cv_with_aix_soname
+    with_aix_soname=$lt_cv_with_aix_soname ;;
+esac
 fi
 
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $with_aix_soname" >&5
@@ -10465,8 +10620,8 @@ printf %s "checking for objdir... " >&6;
 if test ${lt_cv_objdir+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  rm -f .libs 2>/dev/null
+else case e in #(
+  e) rm -f .libs 2>/dev/null
 mkdir .libs 2>/dev/null
 if test -d .libs; then
   lt_cv_objdir=.libs
@@ -10474,7 +10629,8 @@ else
   # MS-DOS does not allow filenames that begin with a dot.
   lt_cv_objdir=_libs
 fi
-rmdir .libs 2>/dev/null
+rmdir .libs 2>/dev/null ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_objdir" >&5
 printf "%s\n" "$lt_cv_objdir" >&6; }
@@ -10535,8 +10691,8 @@ printf %s "checking for ${ac_tool_prefix
 if test ${lt_cv_path_MAGIC_CMD+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $MAGIC_CMD in
+else case e in #(
+  e) case $MAGIC_CMD in
 [\\/*] |  ?:[\\/]*)
   lt_cv_path_MAGIC_CMD=$MAGIC_CMD # Let the user override the test with a path.
   ;;
@@ -10579,6 +10735,7 @@ _LT_EOF
   IFS=$lt_save_ifs
   MAGIC_CMD=$lt_save_MAGIC_CMD
   ;;
+esac ;;
 esac
 fi
 
@@ -10602,8 +10759,8 @@ printf %s "checking for file... " >&6; }
 if test ${lt_cv_path_MAGIC_CMD+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $MAGIC_CMD in
+else case e in #(
+  e) case $MAGIC_CMD in
 [\\/*] |  ?:[\\/]*)
   lt_cv_path_MAGIC_CMD=$MAGIC_CMD # Let the user override the test with a path.
   ;;
@@ -10646,6 +10803,7 @@ _LT_EOF
   IFS=$lt_save_ifs
   MAGIC_CMD=$lt_save_MAGIC_CMD
   ;;
+esac ;;
 esac
 fi
 
@@ -10745,8 +10903,8 @@ printf %s "checking if $compiler support
 if test ${lt_cv_prog_compiler_rtti_exceptions+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler_rtti_exceptions=no
+else case e in #(
+  e) lt_cv_prog_compiler_rtti_exceptions=no
    ac_outfile=conftest.$ac_objext
    echo "$lt_simple_compile_test_code" > conftest.$ac_ext
    lt_compiler_flag="-fno-rtti -fno-exceptions"  ## exclude from sc_useless_quotes_in_assignment
@@ -10774,7 +10932,8 @@ else $as_nop
      fi
    fi
    $RM conftest*
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler_rtti_exceptions" >&5
 printf "%s\n" "$lt_cv_prog_compiler_rtti_exceptions" >&6; }
@@ -11139,8 +11298,9 @@ printf %s "checking for $compiler option
 if test ${lt_cv_prog_compiler_pic+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler_pic=$lt_prog_compiler_pic
+else case e in #(
+  e) lt_cv_prog_compiler_pic=$lt_prog_compiler_pic ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler_pic" >&5
 printf "%s\n" "$lt_cv_prog_compiler_pic" >&6; }
@@ -11155,8 +11315,8 @@ printf %s "checking if $compiler PIC fla
 if test ${lt_cv_prog_compiler_pic_works+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler_pic_works=no
+else case e in #(
+  e) lt_cv_prog_compiler_pic_works=no
    ac_outfile=conftest.$ac_objext
    echo "$lt_simple_compile_test_code" > conftest.$ac_ext
    lt_compiler_flag="$lt_prog_compiler_pic -DPIC"  ## exclude from sc_useless_quotes_in_assignment
@@ -11184,7 +11344,8 @@ else $as_nop
      fi
    fi
    $RM conftest*
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler_pic_works" >&5
 printf "%s\n" "$lt_cv_prog_compiler_pic_works" >&6; }
@@ -11220,8 +11381,8 @@ printf %s "checking if $compiler static
 if test ${lt_cv_prog_compiler_static_works+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler_static_works=no
+else case e in #(
+  e) lt_cv_prog_compiler_static_works=no
    save_LDFLAGS=$LDFLAGS
    LDFLAGS="$LDFLAGS $lt_tmp_static_flag"
    echo "$lt_simple_link_test_code" > conftest.$ac_ext
@@ -11242,7 +11403,8 @@ else $as_nop
    fi
    $RM -r conftest*
    LDFLAGS=$save_LDFLAGS
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler_static_works" >&5
 printf "%s\n" "$lt_cv_prog_compiler_static_works" >&6; }
@@ -11264,8 +11426,8 @@ printf %s "checking if $compiler support
 if test ${lt_cv_prog_compiler_c_o+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler_c_o=no
+else case e in #(
+  e) lt_cv_prog_compiler_c_o=no
    $RM -r conftest 2>/dev/null
    mkdir conftest
    cd conftest
@@ -11305,7 +11467,8 @@ else $as_nop
    cd ..
    $RM -r conftest
    $RM conftest*
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler_c_o" >&5
 printf "%s\n" "$lt_cv_prog_compiler_c_o" >&6; }
@@ -11320,8 +11483,8 @@ printf %s "checking if $compiler support
 if test ${lt_cv_prog_compiler_c_o+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler_c_o=no
+else case e in #(
+  e) lt_cv_prog_compiler_c_o=no
    $RM -r conftest 2>/dev/null
    mkdir conftest
    cd conftest
@@ -11361,7 +11524,8 @@ else $as_nop
    cd ..
    $RM -r conftest
    $RM conftest*
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler_c_o" >&5
 printf "%s\n" "$lt_cv_prog_compiler_c_o" >&6; }
@@ -11956,8 +12120,8 @@ else
   if test ${lt_cv_aix_libpath_+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 int
@@ -11989,7 +12153,8 @@ rm -f core conftest.err conftest.$ac_obj
   if test -z "$lt_cv_aix_libpath_"; then
     lt_cv_aix_libpath_=/usr/lib:/lib
   fi
-
+   ;;
+esac
 fi
 
   aix_libpath=$lt_cv_aix_libpath_
@@ -12011,8 +12176,8 @@ else
   if test ${lt_cv_aix_libpath_+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 int
@@ -12044,7 +12209,8 @@ rm -f core conftest.err conftest.$ac_obj
   if test -z "$lt_cv_aix_libpath_"; then
     lt_cv_aix_libpath_=/usr/lib:/lib
   fi
-
+   ;;
+esac
 fi
 
   aix_libpath=$lt_cv_aix_libpath_
@@ -12295,8 +12461,8 @@ printf %s "checking if $CC understands -
 if test ${lt_cv_prog_compiler__b+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler__b=no
+else case e in #(
+  e) lt_cv_prog_compiler__b=no
    save_LDFLAGS=$LDFLAGS
    LDFLAGS="$LDFLAGS -b"
    echo "$lt_simple_link_test_code" > conftest.$ac_ext
@@ -12317,7 +12483,8 @@ else $as_nop
    fi
    $RM -r conftest*
    LDFLAGS=$save_LDFLAGS
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler__b" >&5
 printf "%s\n" "$lt_cv_prog_compiler__b" >&6; }
@@ -12365,8 +12532,8 @@ printf %s "checking whether the $host_os
 if test ${lt_cv_irix_exported_symbol+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  save_LDFLAGS=$LDFLAGS
+else case e in #(
+  e) save_LDFLAGS=$LDFLAGS
 	   LDFLAGS="$LDFLAGS -shared $wl-exported_symbol ${wl}foo $wl-update_registry $wl/dev/null"
 	   cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -12375,12 +12542,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   lt_cv_irix_exported_symbol=yes
-else $as_nop
-  lt_cv_irix_exported_symbol=no
+else case e in #(
+  e) lt_cv_irix_exported_symbol=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-           LDFLAGS=$save_LDFLAGS
+           LDFLAGS=$save_LDFLAGS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_irix_exported_symbol" >&5
 printf "%s\n" "$lt_cv_irix_exported_symbol" >&6; }
@@ -12706,8 +12875,8 @@ printf %s "checking whether -lc should b
 if test ${lt_cv_archive_cmds_need_lc+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  $RM conftest*
+else case e in #(
+  e) $RM conftest*
 	echo "$lt_simple_compile_test_code" > conftest.$ac_ext
 
 	if { { eval echo "\"\$as_me\":${as_lineno-$LINENO}: \"$ac_compile\""; } >&5
@@ -12743,7 +12912,8 @@ else $as_nop
 	  cat conftest.err 1>&5
 	fi
 	$RM conftest*
-
+	 ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_archive_cmds_need_lc" >&5
 printf "%s\n" "$lt_cv_archive_cmds_need_lc" >&6; }
@@ -13470,8 +13640,8 @@ linux* | k*bsd*-gnu | kopensolaris*-gnu
   if test ${lt_cv_shlibpath_overrides_runpath+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_shlibpath_overrides_runpath=no
+else case e in #(
+  e) lt_cv_shlibpath_overrides_runpath=no
     save_LDFLAGS=$LDFLAGS
     save_libdir=$libdir
     eval "libdir=/foo; wl=\"$lt_prog_compiler_wl\"; \
@@ -13498,7 +13668,8 @@ rm -f core conftest.err conftest.$ac_obj
     conftest$ac_exeext conftest.$ac_ext
     LDFLAGS=$save_LDFLAGS
     libdir=$save_libdir
-
+     ;;
+esac
 fi
 
   shlibpath_overrides_runpath=$lt_cv_shlibpath_overrides_runpath
@@ -13923,16 +14094,22 @@ printf %s "checking for dlopen in -ldl..
 if test ${ac_cv_lib_dl_dlopen+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldl  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dlopen ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dlopen (void);
 int
 main (void)
 {
@@ -13944,24 +14121,27 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dl_dlopen=yes
-else $as_nop
-  ac_cv_lib_dl_dlopen=no
+else case e in #(
+  e) ac_cv_lib_dl_dlopen=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dl_dlopen" >&5
 printf "%s\n" "$ac_cv_lib_dl_dlopen" >&6; }
 if test "x$ac_cv_lib_dl_dlopen" = xyes
 then :
   lt_cv_dlopen=dlopen lt_cv_dlopen_libs=-ldl
-else $as_nop
-
+else case e in #(
+  e)
     lt_cv_dlopen=dyld
     lt_cv_dlopen_libs=
     lt_cv_dlopen_self=yes
-
+     ;;
+esac
 fi
 
     ;;
@@ -13979,22 +14159,28 @@ fi
 if test "x$ac_cv_func_shl_load" = xyes
 then :
   lt_cv_dlopen=shl_load
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for shl_load in -ldld" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for shl_load in -ldld" >&5
 printf %s "checking for shl_load in -ldld... " >&6; }
 if test ${ac_cv_lib_dld_shl_load+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldld  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char shl_load ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char shl_load (void);
 int
 main (void)
 {
@@ -14006,39 +14192,47 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dld_shl_load=yes
-else $as_nop
-  ac_cv_lib_dld_shl_load=no
+else case e in #(
+  e) ac_cv_lib_dld_shl_load=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dld_shl_load" >&5
 printf "%s\n" "$ac_cv_lib_dld_shl_load" >&6; }
 if test "x$ac_cv_lib_dld_shl_load" = xyes
 then :
   lt_cv_dlopen=shl_load lt_cv_dlopen_libs=-ldld
-else $as_nop
-  ac_fn_c_check_func "$LINENO" "dlopen" "ac_cv_func_dlopen"
+else case e in #(
+  e) ac_fn_c_check_func "$LINENO" "dlopen" "ac_cv_func_dlopen"
 if test "x$ac_cv_func_dlopen" = xyes
 then :
   lt_cv_dlopen=dlopen
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dlopen in -ldl" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dlopen in -ldl" >&5
 printf %s "checking for dlopen in -ldl... " >&6; }
 if test ${ac_cv_lib_dl_dlopen+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldl  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dlopen ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dlopen (void);
 int
 main (void)
 {
@@ -14050,34 +14244,42 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dl_dlopen=yes
-else $as_nop
-  ac_cv_lib_dl_dlopen=no
+else case e in #(
+  e) ac_cv_lib_dl_dlopen=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dl_dlopen" >&5
 printf "%s\n" "$ac_cv_lib_dl_dlopen" >&6; }
 if test "x$ac_cv_lib_dl_dlopen" = xyes
 then :
   lt_cv_dlopen=dlopen lt_cv_dlopen_libs=-ldl
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dlopen in -lsvld" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dlopen in -lsvld" >&5
 printf %s "checking for dlopen in -lsvld... " >&6; }
 if test ${ac_cv_lib_svld_dlopen+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lsvld  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dlopen ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dlopen (void);
 int
 main (void)
 {
@@ -14089,34 +14291,42 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_svld_dlopen=yes
-else $as_nop
-  ac_cv_lib_svld_dlopen=no
+else case e in #(
+  e) ac_cv_lib_svld_dlopen=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_svld_dlopen" >&5
 printf "%s\n" "$ac_cv_lib_svld_dlopen" >&6; }
 if test "x$ac_cv_lib_svld_dlopen" = xyes
 then :
   lt_cv_dlopen=dlopen lt_cv_dlopen_libs=-lsvld
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dld_link in -ldld" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dld_link in -ldld" >&5
 printf %s "checking for dld_link in -ldld... " >&6; }
 if test ${ac_cv_lib_dld_dld_link+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldld  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dld_link ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dld_link (void);
 int
 main (void)
 {
@@ -14128,12 +14338,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dld_dld_link=yes
-else $as_nop
-  ac_cv_lib_dld_dld_link=no
+else case e in #(
+  e) ac_cv_lib_dld_dld_link=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dld_dld_link" >&5
 printf "%s\n" "$ac_cv_lib_dld_dld_link" >&6; }
@@ -14142,19 +14354,24 @@ then :
   lt_cv_dlopen=dld_link lt_cv_dlopen_libs=-ldld
 fi
 
-
+	       ;;
+esac
 fi
 
-
+	     ;;
+esac
 fi
 
-
+	   ;;
+esac
 fi
 
-
+	 ;;
+esac
 fi
 
-
+       ;;
+esac
 fi
 
     ;;
@@ -14182,8 +14399,8 @@ printf %s "checking whether a program ca
 if test ${lt_cv_dlopen_self+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  	  if test yes = "$cross_compiling"; then :
+else case e in #(
+  e) 	  if test yes = "$cross_compiling"; then :
   lt_cv_dlopen_self=cross
 else
   lt_dlunknown=0; lt_dlno_uscore=1; lt_dlneed_uscore=2
@@ -14277,7 +14494,8 @@ _LT_EOF
 fi
 rm -fr conftest*
 
-
+     ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_dlopen_self" >&5
 printf "%s\n" "$lt_cv_dlopen_self" >&6; }
@@ -14289,8 +14507,8 @@ printf %s "checking whether a statically
 if test ${lt_cv_dlopen_self_static+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  	  if test yes = "$cross_compiling"; then :
+else case e in #(
+  e) 	  if test yes = "$cross_compiling"; then :
   lt_cv_dlopen_self_static=cross
 else
   lt_dlunknown=0; lt_dlno_uscore=1; lt_dlneed_uscore=2
@@ -14384,7 +14602,8 @@ _LT_EOF
 fi
 rm -fr conftest*
 
-
+       ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_dlopen_self_static" >&5
 printf "%s\n" "$lt_cv_dlopen_self_static" >&6; }
@@ -14576,8 +14795,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_CXX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$CXX"; then
+else case e in #(
+  e) if test -n "$CXX"; then
   ac_cv_prog_CXX="$CXX" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -14599,7 +14818,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 CXX=$ac_cv_prog_CXX
 if test -n "$CXX"; then
@@ -14625,8 +14845,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_CXX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_CXX"; then
+else case e in #(
+  e) if test -n "$ac_ct_CXX"; then
   ac_cv_prog_ac_ct_CXX="$ac_ct_CXX" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -14648,7 +14868,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_CXX=$ac_cv_prog_ac_ct_CXX
 if test -n "$ac_ct_CXX"; then
@@ -14708,8 +14929,8 @@ printf %s "checking whether the compiler
 if test ${ac_cv_cxx_compiler_gnu+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 int
@@ -14726,12 +14947,14 @@ _ACEOF
 if ac_fn_cxx_try_compile "$LINENO"
 then :
   ac_compiler_gnu=yes
-else $as_nop
-  ac_compiler_gnu=no
+else case e in #(
+  e) ac_compiler_gnu=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 ac_cv_cxx_compiler_gnu=$ac_compiler_gnu
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_cxx_compiler_gnu" >&5
 printf "%s\n" "$ac_cv_cxx_compiler_gnu" >&6; }
@@ -14749,8 +14972,8 @@ printf %s "checking whether $CXX accepts
 if test ${ac_cv_prog_cxx_g+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_save_cxx_werror_flag=$ac_cxx_werror_flag
+else case e in #(
+  e) ac_save_cxx_werror_flag=$ac_cxx_werror_flag
    ac_cxx_werror_flag=yes
    ac_cv_prog_cxx_g=no
    CXXFLAGS="-g"
@@ -14768,8 +14991,8 @@ _ACEOF
 if ac_fn_cxx_try_compile "$LINENO"
 then :
   ac_cv_prog_cxx_g=yes
-else $as_nop
-  CXXFLAGS=""
+else case e in #(
+  e) CXXFLAGS=""
       cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -14784,8 +15007,8 @@ _ACEOF
 if ac_fn_cxx_try_compile "$LINENO"
 then :
 
-else $as_nop
-  ac_cxx_werror_flag=$ac_save_cxx_werror_flag
+else case e in #(
+  e) ac_cxx_werror_flag=$ac_save_cxx_werror_flag
 	 CXXFLAGS="-g"
 	 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -14802,12 +15025,15 @@ if ac_fn_cxx_try_compile "$LINENO"
 then :
   ac_cv_prog_cxx_g=yes
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
-   ac_cxx_werror_flag=$ac_save_cxx_werror_flag
+   ac_cxx_werror_flag=$ac_save_cxx_werror_flag ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cxx_g" >&5
 printf "%s\n" "$ac_cv_prog_cxx_g" >&6; }
@@ -14831,11 +15057,11 @@ if test x$ac_prog_cxx_stdcxx = xno
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for $CXX option to enable C++11 features" >&5
 printf %s "checking for $CXX option to enable C++11 features... " >&6; }
-if test ${ac_cv_prog_cxx_11+y}
+if test ${ac_cv_prog_cxx_cxx11+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_cv_prog_cxx_11=no
+else case e in #(
+  e) ac_cv_prog_cxx_cxx11=no
 ac_save_CXX=$CXX
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -14852,36 +15078,39 @@ rm -f core conftest.err conftest.$ac_obj
   test "x$ac_cv_prog_cxx_cxx11" != "xno" && break
 done
 rm -f conftest.$ac_ext
-CXX=$ac_save_CXX
+CXX=$ac_save_CXX ;;
+esac
 fi
 
 if test "x$ac_cv_prog_cxx_cxx11" = xno
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: unsupported" >&5
 printf "%s\n" "unsupported" >&6; }
-else $as_nop
-  if test "x$ac_cv_prog_cxx_cxx11" = x
+else case e in #(
+  e) if test "x$ac_cv_prog_cxx_cxx11" = x
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: none needed" >&5
 printf "%s\n" "none needed" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cxx_cxx11" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cxx_cxx11" >&5
 printf "%s\n" "$ac_cv_prog_cxx_cxx11" >&6; }
-     CXX="$CXX $ac_cv_prog_cxx_cxx11"
+     CXX="$CXX $ac_cv_prog_cxx_cxx11" ;;
+esac
 fi
   ac_cv_prog_cxx_stdcxx=$ac_cv_prog_cxx_cxx11
-  ac_prog_cxx_stdcxx=cxx11
+  ac_prog_cxx_stdcxx=cxx11 ;;
+esac
 fi
 fi
 if test x$ac_prog_cxx_stdcxx = xno
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for $CXX option to enable C++98 features" >&5
 printf %s "checking for $CXX option to enable C++98 features... " >&6; }
-if test ${ac_cv_prog_cxx_98+y}
+if test ${ac_cv_prog_cxx_cxx98+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_cv_prog_cxx_98=no
+else case e in #(
+  e) ac_cv_prog_cxx_cxx98=no
 ac_save_CXX=$CXX
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -14898,25 +15127,28 @@ rm -f core conftest.err conftest.$ac_obj
   test "x$ac_cv_prog_cxx_cxx98" != "xno" && break
 done
 rm -f conftest.$ac_ext
-CXX=$ac_save_CXX
+CXX=$ac_save_CXX ;;
+esac
 fi
 
 if test "x$ac_cv_prog_cxx_cxx98" = xno
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: unsupported" >&5
 printf "%s\n" "unsupported" >&6; }
-else $as_nop
-  if test "x$ac_cv_prog_cxx_cxx98" = x
+else case e in #(
+  e) if test "x$ac_cv_prog_cxx_cxx98" = x
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: none needed" >&5
 printf "%s\n" "none needed" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cxx_cxx98" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cxx_cxx98" >&5
 printf "%s\n" "$ac_cv_prog_cxx_cxx98" >&6; }
-     CXX="$CXX $ac_cv_prog_cxx_cxx98"
+     CXX="$CXX $ac_cv_prog_cxx_cxx98" ;;
+esac
 fi
   ac_cv_prog_cxx_stdcxx=$ac_cv_prog_cxx_cxx98
-  ac_prog_cxx_stdcxx=cxx98
+  ac_prog_cxx_stdcxx=cxx98 ;;
+esac
 fi
 fi
 
@@ -14933,8 +15165,8 @@ printf %s "checking dependency style of
 if test ${am_cv_CXX_dependencies_compiler_type+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -z "$AMDEP_TRUE" && test -f "$am_depcomp"; then
+else case e in #(
+  e) if test -z "$AMDEP_TRUE" && test -f "$am_depcomp"; then
   # We make a subdir and do the tests there.  Otherwise we can end up
   # making bogus files that we don't know about and never remove.  For
   # instance it was reported that on HP-UX the gcc test will end up
@@ -15038,7 +15270,8 @@ else $as_nop
 else
   am_cv_CXX_dependencies_compiler_type=none
 fi
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $am_cv_CXX_dependencies_compiler_type" >&5
 printf "%s\n" "$am_cv_CXX_dependencies_compiler_type" >&6; }
@@ -15080,8 +15313,8 @@ if test -z "$CXXCPP"; then
   if test ${ac_cv_prog_CXXCPP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-      # Double quotes because $CXX needs to be expanded
+else case e in #(
+  e)     # Double quotes because $CXX needs to be expanded
     for CXXCPP in "$CXX -E" cpp /lib/cpp
     do
       ac_preproc_ok=false
@@ -15099,9 +15332,10 @@ _ACEOF
 if ac_fn_cxx_try_cpp "$LINENO"
 then :
 
-else $as_nop
-  # Broken: fails on valid input.
-continue
+else case e in #(
+  e) # Broken: fails on valid input.
+continue ;;
+esac
 fi
 rm -f conftest.err conftest.i conftest.$ac_ext
 
@@ -15115,15 +15349,16 @@ if ac_fn_cxx_try_cpp "$LINENO"
 then :
   # Broken: success on invalid input.
 continue
-else $as_nop
-  # Passes both tests.
+else case e in #(
+  e) # Passes both tests.
 ac_preproc_ok=:
-break
+break ;;
+esac
 fi
 rm -f conftest.err conftest.i conftest.$ac_ext
 
 done
-# Because of `break', _AC_PREPROC_IFELSE's cleaning code was skipped.
+# Because of 'break', _AC_PREPROC_IFELSE's cleaning code was skipped.
 rm -f conftest.i conftest.err conftest.$ac_ext
 if $ac_preproc_ok
 then :
@@ -15132,7 +15367,8 @@ fi
 
     done
     ac_cv_prog_CXXCPP=$CXXCPP
-
+   ;;
+esac
 fi
   CXXCPP=$ac_cv_prog_CXXCPP
 else
@@ -15155,9 +15391,10 @@ _ACEOF
 if ac_fn_cxx_try_cpp "$LINENO"
 then :
 
-else $as_nop
-  # Broken: fails on valid input.
-continue
+else case e in #(
+  e) # Broken: fails on valid input.
+continue ;;
+esac
 fi
 rm -f conftest.err conftest.i conftest.$ac_ext
 
@@ -15171,24 +15408,26 @@ if ac_fn_cxx_try_cpp "$LINENO"
 then :
   # Broken: success on invalid input.
 continue
-else $as_nop
-  # Passes both tests.
+else case e in #(
+  e) # Passes both tests.
 ac_preproc_ok=:
-break
+break ;;
+esac
 fi
 rm -f conftest.err conftest.i conftest.$ac_ext
 
 done
-# Because of `break', _AC_PREPROC_IFELSE's cleaning code was skipped.
+# Because of 'break', _AC_PREPROC_IFELSE's cleaning code was skipped.
 rm -f conftest.i conftest.err conftest.$ac_ext
 if $ac_preproc_ok
 then :
 
-else $as_nop
-  { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+else case e in #(
+  e) { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error $? "C++ preprocessor \"$CXXCPP\" fails sanity check
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; } ;;
+esac
 fi
 
 ac_ext=c
@@ -15325,8 +15564,9 @@ cc_basename=$func_cc_basename_result
 if test ${with_gnu_ld+y}
 then :
   withval=$with_gnu_ld; test no = "$withval" || with_gnu_ld=yes
-else $as_nop
-  with_gnu_ld=no
+else case e in #(
+  e) with_gnu_ld=no ;;
+esac
 fi
 
 ac_prog=ld
@@ -15371,8 +15611,8 @@ fi
 if test ${lt_cv_path_LD+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -z "$LD"; then
+else case e in #(
+  e) if test -z "$LD"; then
   lt_save_ifs=$IFS; IFS=$PATH_SEPARATOR
   for ac_dir in $PATH; do
     IFS=$lt_save_ifs
@@ -15395,7 +15635,8 @@ else $as_nop
   IFS=$lt_save_ifs
 else
   lt_cv_path_LD=$LD # Let the user override the test with a path.
-fi
+fi ;;
+esac
 fi
 
 LD=$lt_cv_path_LD
@@ -15412,8 +15653,8 @@ printf %s "checking if the linker ($LD)
 if test ${lt_cv_prog_gnu_ld+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  # I'd rather use --version here, but apparently some GNU lds only accept -v.
+else case e in #(
+  e) # I'd rather use --version here, but apparently some GNU lds only accept -v.
 case `$LD -v 2>&1 </dev/null` in
 *GNU* | *'with BFD'*)
   lt_cv_prog_gnu_ld=yes
@@ -15421,6 +15662,7 @@ case `$LD -v 2>&1 </dev/null` in
 *)
   lt_cv_prog_gnu_ld=no
   ;;
+esac ;;
 esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_gnu_ld" >&5
@@ -15620,8 +15862,8 @@ else
   if test ${lt_cv_aix_libpath__CXX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 int
@@ -15653,7 +15895,8 @@ rm -f core conftest.err conftest.$ac_obj
   if test -z "$lt_cv_aix_libpath__CXX"; then
     lt_cv_aix_libpath__CXX=/usr/lib:/lib
   fi
-
+   ;;
+esac
 fi
 
   aix_libpath=$lt_cv_aix_libpath__CXX
@@ -15676,8 +15919,8 @@ else
   if test ${lt_cv_aix_libpath__CXX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 int
@@ -15709,7 +15952,8 @@ rm -f core conftest.err conftest.$ac_obj
   if test -z "$lt_cv_aix_libpath__CXX"; then
     lt_cv_aix_libpath__CXX=/usr/lib:/lib
   fi
-
+   ;;
+esac
 fi
 
   aix_libpath=$lt_cv_aix_libpath__CXX
@@ -17081,8 +17325,9 @@ printf %s "checking for $compiler option
 if test ${lt_cv_prog_compiler_pic_CXX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler_pic_CXX=$lt_prog_compiler_pic_CXX
+else case e in #(
+  e) lt_cv_prog_compiler_pic_CXX=$lt_prog_compiler_pic_CXX ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler_pic_CXX" >&5
 printf "%s\n" "$lt_cv_prog_compiler_pic_CXX" >&6; }
@@ -17097,8 +17342,8 @@ printf %s "checking if $compiler PIC fla
 if test ${lt_cv_prog_compiler_pic_works_CXX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler_pic_works_CXX=no
+else case e in #(
+  e) lt_cv_prog_compiler_pic_works_CXX=no
    ac_outfile=conftest.$ac_objext
    echo "$lt_simple_compile_test_code" > conftest.$ac_ext
    lt_compiler_flag="$lt_prog_compiler_pic_CXX -DPIC"  ## exclude from sc_useless_quotes_in_assignment
@@ -17126,7 +17371,8 @@ else $as_nop
      fi
    fi
    $RM conftest*
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler_pic_works_CXX" >&5
 printf "%s\n" "$lt_cv_prog_compiler_pic_works_CXX" >&6; }
@@ -17156,8 +17402,8 @@ printf %s "checking if $compiler static
 if test ${lt_cv_prog_compiler_static_works_CXX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler_static_works_CXX=no
+else case e in #(
+  e) lt_cv_prog_compiler_static_works_CXX=no
    save_LDFLAGS=$LDFLAGS
    LDFLAGS="$LDFLAGS $lt_tmp_static_flag"
    echo "$lt_simple_link_test_code" > conftest.$ac_ext
@@ -17178,7 +17424,8 @@ else $as_nop
    fi
    $RM -r conftest*
    LDFLAGS=$save_LDFLAGS
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler_static_works_CXX" >&5
 printf "%s\n" "$lt_cv_prog_compiler_static_works_CXX" >&6; }
@@ -17197,8 +17444,8 @@ printf %s "checking if $compiler support
 if test ${lt_cv_prog_compiler_c_o_CXX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler_c_o_CXX=no
+else case e in #(
+  e) lt_cv_prog_compiler_c_o_CXX=no
    $RM -r conftest 2>/dev/null
    mkdir conftest
    cd conftest
@@ -17238,7 +17485,8 @@ else $as_nop
    cd ..
    $RM -r conftest
    $RM conftest*
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler_c_o_CXX" >&5
 printf "%s\n" "$lt_cv_prog_compiler_c_o_CXX" >&6; }
@@ -17250,8 +17498,8 @@ printf %s "checking if $compiler support
 if test ${lt_cv_prog_compiler_c_o_CXX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_prog_compiler_c_o_CXX=no
+else case e in #(
+  e) lt_cv_prog_compiler_c_o_CXX=no
    $RM -r conftest 2>/dev/null
    mkdir conftest
    cd conftest
@@ -17291,7 +17539,8 @@ else $as_nop
    cd ..
    $RM -r conftest
    $RM conftest*
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_prog_compiler_c_o_CXX" >&5
 printf "%s\n" "$lt_cv_prog_compiler_c_o_CXX" >&6; }
@@ -17396,8 +17645,8 @@ printf %s "checking whether -lc should b
 if test ${lt_cv_archive_cmds_need_lc_CXX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  $RM conftest*
+else case e in #(
+  e) $RM conftest*
 	echo "$lt_simple_compile_test_code" > conftest.$ac_ext
 
 	if { { eval echo "\"\$as_me\":${as_lineno-$LINENO}: \"$ac_compile\""; } >&5
@@ -17433,7 +17682,8 @@ else $as_nop
 	  cat conftest.err 1>&5
 	fi
 	$RM conftest*
-
+	 ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $lt_cv_archive_cmds_need_lc_CXX" >&5
 printf "%s\n" "$lt_cv_archive_cmds_need_lc_CXX" >&6; }
@@ -17997,8 +18247,8 @@ linux* | k*bsd*-gnu | kopensolaris*-gnu
   if test ${lt_cv_shlibpath_overrides_runpath+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  lt_cv_shlibpath_overrides_runpath=no
+else case e in #(
+  e) lt_cv_shlibpath_overrides_runpath=no
     save_LDFLAGS=$LDFLAGS
     save_libdir=$libdir
     eval "libdir=/foo; wl=\"$lt_prog_compiler_wl_CXX\"; \
@@ -18025,7 +18275,8 @@ rm -f core conftest.err conftest.$ac_obj
     conftest$ac_exeext conftest.$ac_ext
     LDFLAGS=$save_LDFLAGS
     libdir=$save_libdir
-
+     ;;
+esac
 fi
 
   shlibpath_overrides_runpath=$lt_cv_shlibpath_overrides_runpath
@@ -18402,8 +18653,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$CC"; then
+else case e in #(
+  e) if test -n "$CC"; then
   ac_cv_prog_CC="$CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -18425,7 +18676,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
@@ -18447,8 +18699,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_CC"; then
+else case e in #(
+  e) if test -n "$ac_ct_CC"; then
   ac_cv_prog_ac_ct_CC="$ac_ct_CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -18470,7 +18722,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_CC=$ac_cv_prog_ac_ct_CC
 if test -n "$ac_ct_CC"; then
@@ -18505,8 +18758,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$CC"; then
+else case e in #(
+  e) if test -n "$CC"; then
   ac_cv_prog_CC="$CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -18528,7 +18781,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
@@ -18550,8 +18804,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$CC"; then
+else case e in #(
+  e) if test -n "$CC"; then
   ac_cv_prog_CC="$CC" # Let the user override the test.
 else
   ac_prog_rejected=no
@@ -18590,7 +18844,8 @@ if test $ac_prog_rejected = yes; then
     ac_cv_prog_CC="$as_dir$ac_word${1+' '}$@"
   fi
 fi
-fi
+fi ;;
+esac
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
@@ -18614,8 +18869,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$CC"; then
+else case e in #(
+  e) if test -n "$CC"; then
   ac_cv_prog_CC="$CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -18637,7 +18892,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
@@ -18663,8 +18919,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_CC"; then
+else case e in #(
+  e) if test -n "$ac_ct_CC"; then
   ac_cv_prog_ac_ct_CC="$ac_ct_CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -18686,7 +18942,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_CC=$ac_cv_prog_ac_ct_CC
 if test -n "$ac_ct_CC"; then
@@ -18724,8 +18981,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$CC"; then
+else case e in #(
+  e) if test -n "$CC"; then
   ac_cv_prog_CC="$CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -18747,7 +19004,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 CC=$ac_cv_prog_CC
 if test -n "$CC"; then
@@ -18769,8 +19027,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_ac_ct_CC+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$ac_ct_CC"; then
+else case e in #(
+  e) if test -n "$ac_ct_CC"; then
   ac_cv_prog_ac_ct_CC="$ac_ct_CC" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -18792,7 +19050,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 ac_ct_CC=$ac_cv_prog_ac_ct_CC
 if test -n "$ac_ct_CC"; then
@@ -18821,10 +19080,10 @@ fi
 fi
 
 
-test -z "$CC" && { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+test -z "$CC" && { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error $? "no acceptable C compiler found in \$PATH
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; }
 
 # Provide some information about the compiler.
 printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for C compiler version" >&5
@@ -18856,8 +19115,8 @@ printf %s "checking whether the compiler
 if test ${ac_cv_c_compiler_gnu+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 int
@@ -18874,12 +19133,14 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   ac_compiler_gnu=yes
-else $as_nop
-  ac_compiler_gnu=no
+else case e in #(
+  e) ac_compiler_gnu=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 ac_cv_c_compiler_gnu=$ac_compiler_gnu
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_c_compiler_gnu" >&5
 printf "%s\n" "$ac_cv_c_compiler_gnu" >&6; }
@@ -18897,8 +19158,8 @@ printf %s "checking whether $CC accepts
 if test ${ac_cv_prog_cc_g+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_save_c_werror_flag=$ac_c_werror_flag
+else case e in #(
+  e) ac_save_c_werror_flag=$ac_c_werror_flag
    ac_c_werror_flag=yes
    ac_cv_prog_cc_g=no
    CFLAGS="-g"
@@ -18916,8 +19177,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   ac_cv_prog_cc_g=yes
-else $as_nop
-  CFLAGS=""
+else case e in #(
+  e) CFLAGS=""
       cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -18932,8 +19193,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
 
-else $as_nop
-  ac_c_werror_flag=$ac_save_c_werror_flag
+else case e in #(
+  e) ac_c_werror_flag=$ac_save_c_werror_flag
 	 CFLAGS="-g"
 	 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -18950,12 +19211,15 @@ if ac_fn_c_try_compile "$LINENO"
 then :
   ac_cv_prog_cc_g=yes
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
-   ac_c_werror_flag=$ac_save_c_werror_flag
+   ac_c_werror_flag=$ac_save_c_werror_flag ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_g" >&5
 printf "%s\n" "$ac_cv_prog_cc_g" >&6; }
@@ -18982,8 +19246,8 @@ printf %s "checking for $CC option to en
 if test ${ac_cv_prog_cc_c11+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_cv_prog_cc_c11=no
+else case e in #(
+  e) ac_cv_prog_cc_c11=no
 ac_save_CC=$CC
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -19000,25 +19264,28 @@ rm -f core conftest.err conftest.$ac_obj
   test "x$ac_cv_prog_cc_c11" != "xno" && break
 done
 rm -f conftest.$ac_ext
-CC=$ac_save_CC
+CC=$ac_save_CC ;;
+esac
 fi
 
 if test "x$ac_cv_prog_cc_c11" = xno
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: unsupported" >&5
 printf "%s\n" "unsupported" >&6; }
-else $as_nop
-  if test "x$ac_cv_prog_cc_c11" = x
+else case e in #(
+  e) if test "x$ac_cv_prog_cc_c11" = x
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: none needed" >&5
 printf "%s\n" "none needed" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c11" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c11" >&5
 printf "%s\n" "$ac_cv_prog_cc_c11" >&6; }
-     CC="$CC $ac_cv_prog_cc_c11"
+     CC="$CC $ac_cv_prog_cc_c11" ;;
+esac
 fi
   ac_cv_prog_cc_stdc=$ac_cv_prog_cc_c11
-  ac_prog_cc_stdc=c11
+  ac_prog_cc_stdc=c11 ;;
+esac
 fi
 fi
 if test x$ac_prog_cc_stdc = xno
@@ -19028,8 +19295,8 @@ printf %s "checking for $CC option to en
 if test ${ac_cv_prog_cc_c99+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_cv_prog_cc_c99=no
+else case e in #(
+  e) ac_cv_prog_cc_c99=no
 ac_save_CC=$CC
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -19046,25 +19313,28 @@ rm -f core conftest.err conftest.$ac_obj
   test "x$ac_cv_prog_cc_c99" != "xno" && break
 done
 rm -f conftest.$ac_ext
-CC=$ac_save_CC
+CC=$ac_save_CC ;;
+esac
 fi
 
 if test "x$ac_cv_prog_cc_c99" = xno
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: unsupported" >&5
 printf "%s\n" "unsupported" >&6; }
-else $as_nop
-  if test "x$ac_cv_prog_cc_c99" = x
+else case e in #(
+  e) if test "x$ac_cv_prog_cc_c99" = x
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: none needed" >&5
 printf "%s\n" "none needed" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c99" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c99" >&5
 printf "%s\n" "$ac_cv_prog_cc_c99" >&6; }
-     CC="$CC $ac_cv_prog_cc_c99"
+     CC="$CC $ac_cv_prog_cc_c99" ;;
+esac
 fi
   ac_cv_prog_cc_stdc=$ac_cv_prog_cc_c99
-  ac_prog_cc_stdc=c99
+  ac_prog_cc_stdc=c99 ;;
+esac
 fi
 fi
 if test x$ac_prog_cc_stdc = xno
@@ -19074,8 +19344,8 @@ printf %s "checking for $CC option to en
 if test ${ac_cv_prog_cc_c89+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_cv_prog_cc_c89=no
+else case e in #(
+  e) ac_cv_prog_cc_c89=no
 ac_save_CC=$CC
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -19092,25 +19362,28 @@ rm -f core conftest.err conftest.$ac_obj
   test "x$ac_cv_prog_cc_c89" != "xno" && break
 done
 rm -f conftest.$ac_ext
-CC=$ac_save_CC
+CC=$ac_save_CC ;;
+esac
 fi
 
 if test "x$ac_cv_prog_cc_c89" = xno
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: unsupported" >&5
 printf "%s\n" "unsupported" >&6; }
-else $as_nop
-  if test "x$ac_cv_prog_cc_c89" = x
+else case e in #(
+  e) if test "x$ac_cv_prog_cc_c89" = x
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: none needed" >&5
 printf "%s\n" "none needed" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c89" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c89" >&5
 printf "%s\n" "$ac_cv_prog_cc_c89" >&6; }
-     CC="$CC $ac_cv_prog_cc_c89"
+     CC="$CC $ac_cv_prog_cc_c89" ;;
+esac
 fi
   ac_cv_prog_cc_stdc=$ac_cv_prog_cc_c89
-  ac_prog_cc_stdc=c89
+  ac_prog_cc_stdc=c89 ;;
+esac
 fi
 fi
 
@@ -19131,8 +19404,8 @@ printf %s "checking whether $CC understa
 if test ${am_cv_prog_cc_c_o+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 int
@@ -19162,7 +19435,8 @@ _ACEOF
     fi
   done
   rm -f core conftest*
-  unset am_i
+  unset am_i ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $am_cv_prog_cc_c_o" >&5
 printf "%s\n" "$am_cv_prog_cc_c_o" >&6; }
@@ -19188,8 +19462,8 @@ printf %s "checking dependency style of
 if test ${am_cv_CC_dependencies_compiler_type+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -z "$AMDEP_TRUE" && test -f "$am_depcomp"; then
+else case e in #(
+  e) if test -z "$AMDEP_TRUE" && test -f "$am_depcomp"; then
   # We make a subdir and do the tests there.  Otherwise we can end up
   # making bogus files that we don't know about and never remove.  For
   # instance it was reported that on HP-UX the gcc test will end up
@@ -19293,7 +19567,8 @@ else $as_nop
 else
   am_cv_CC_dependencies_compiler_type=none
 fi
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $am_cv_CC_dependencies_compiler_type" >&5
 printf "%s\n" "$am_cv_CC_dependencies_compiler_type" >&6; }
@@ -19524,8 +19799,9 @@ fi
 if test ${with_hwloc_plugins_path+y}
 then :
   withval=$with_hwloc_plugins_path; HWLOC_PLUGINS_PATH="$with_hwloc_plugins_path"
-else $as_nop
-  HWLOC_PLUGINS_PATH="\$(libdir)/hwloc"
+else case e in #(
+  e) HWLOC_PLUGINS_PATH="\$(libdir)/hwloc" ;;
+esac
 fi
 
 
@@ -19567,10 +19843,11 @@ printf "%s\n" "$as_me: WARNING: build.
               { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: build?  Try using the --enable-embedded-mode switch." >&5
 printf "%s\n" "$as_me: WARNING: build?  Try using the --enable-embedded-mode switch." >&2;}
               as_fn_error $? "Cannot build standalone hwloc" "$LINENO" 5
-else $as_nop
-
+else case e in #(
+  e)
     hwloc_mode=standalone
-
+ ;;
+esac
 fi
 fi
 
@@ -19587,8 +19864,8 @@ printf %s "checking for $CC options need
 if test ${ac_cv_c_undeclared_builtin_options+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_save_CFLAGS=$CFLAGS
+else case e in #(
+  e) ac_save_CFLAGS=$CFLAGS
    ac_cv_c_undeclared_builtin_options='cannot detect'
    for ac_arg in '' -fno-builtin; do
      CFLAGS="$ac_save_CFLAGS $ac_arg"
@@ -19607,8 +19884,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
 
-else $as_nop
-  # This test program should compile successfully.
+else case e in #(
+  e) # This test program should compile successfully.
         # No library function is consistently available on
         # freestanding implementations, so test against a dummy
         # declaration.  Include always-available headers on the
@@ -19636,26 +19913,29 @@ then :
   if test x"$ac_arg" = x
 then :
   ac_cv_c_undeclared_builtin_options='none needed'
-else $as_nop
-  ac_cv_c_undeclared_builtin_options=$ac_arg
+else case e in #(
+  e) ac_cv_c_undeclared_builtin_options=$ac_arg ;;
+esac
 fi
           break
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
     done
     CFLAGS=$ac_save_CFLAGS
-
+   ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_c_undeclared_builtin_options" >&5
 printf "%s\n" "$ac_cv_c_undeclared_builtin_options" >&6; }
   case $ac_cv_c_undeclared_builtin_options in #(
   'cannot detect') :
-    { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+    { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error $? "cannot make $CC report undeclared builtins
-See \`config.log' for more details" "$LINENO" 5; } ;; #(
+See 'config.log' for more details" "$LINENO" 5; } ;; #(
   'none needed') :
     ac_c_undeclared_builtin_options='' ;; #(
   *) :
@@ -19674,8 +19954,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_PKG_CONFIG+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $PKG_CONFIG in
+else case e in #(
+  e) case $PKG_CONFIG in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_PKG_CONFIG="$PKG_CONFIG" # Let the user override the test with a path.
   ;;
@@ -19700,6 +19980,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 PKG_CONFIG=$ac_cv_path_PKG_CONFIG
@@ -19722,8 +20003,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_ac_pt_PKG_CONFIG+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $ac_pt_PKG_CONFIG in
+else case e in #(
+  e) case $ac_pt_PKG_CONFIG in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_ac_pt_PKG_CONFIG="$ac_pt_PKG_CONFIG" # Let the user override the test with a path.
   ;;
@@ -19748,6 +20029,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 ac_pt_PKG_CONFIG=$ac_cv_path_ac_pt_PKG_CONFIG
@@ -19804,8 +20086,8 @@ if test -z "$CPP"; then
   if test ${ac_cv_prog_CPP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-      # Double quotes because $CC needs to be expanded
+else case e in #(
+  e)     # Double quotes because $CC needs to be expanded
     for CPP in "$CC -E" "$CC -E -traditional-cpp" cpp /lib/cpp
     do
       ac_preproc_ok=false
@@ -19823,9 +20105,10 @@ _ACEOF
 if ac_fn_c_try_cpp "$LINENO"
 then :
 
-else $as_nop
-  # Broken: fails on valid input.
-continue
+else case e in #(
+  e) # Broken: fails on valid input.
+continue ;;
+esac
 fi
 rm -f conftest.err conftest.i conftest.$ac_ext
 
@@ -19839,15 +20122,16 @@ if ac_fn_c_try_cpp "$LINENO"
 then :
   # Broken: success on invalid input.
 continue
-else $as_nop
-  # Passes both tests.
+else case e in #(
+  e) # Passes both tests.
 ac_preproc_ok=:
-break
+break ;;
+esac
 fi
 rm -f conftest.err conftest.i conftest.$ac_ext
 
 done
-# Because of `break', _AC_PREPROC_IFELSE's cleaning code was skipped.
+# Because of 'break', _AC_PREPROC_IFELSE's cleaning code was skipped.
 rm -f conftest.i conftest.err conftest.$ac_ext
 if $ac_preproc_ok
 then :
@@ -19856,7 +20140,8 @@ fi
 
     done
     ac_cv_prog_CPP=$CPP
-
+   ;;
+esac
 fi
   CPP=$ac_cv_prog_CPP
 else
@@ -19879,9 +20164,10 @@ _ACEOF
 if ac_fn_c_try_cpp "$LINENO"
 then :
 
-else $as_nop
-  # Broken: fails on valid input.
-continue
+else case e in #(
+  e) # Broken: fails on valid input.
+continue ;;
+esac
 fi
 rm -f conftest.err conftest.i conftest.$ac_ext
 
@@ -19895,24 +20181,26 @@ if ac_fn_c_try_cpp "$LINENO"
 then :
   # Broken: success on invalid input.
 continue
-else $as_nop
-  # Passes both tests.
+else case e in #(
+  e) # Passes both tests.
 ac_preproc_ok=:
-break
+break ;;
+esac
 fi
 rm -f conftest.err conftest.i conftest.$ac_ext
 
 done
-# Because of `break', _AC_PREPROC_IFELSE's cleaning code was skipped.
+# Because of 'break', _AC_PREPROC_IFELSE's cleaning code was skipped.
 rm -f conftest.i conftest.err conftest.$ac_ext
 if $ac_preproc_ok
 then :
 
-else $as_nop
-  { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+else case e in #(
+  e) { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error $? "C preprocessor \"$CPP\" fails sanity check
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; } ;;
+esac
 fi
 
 ac_ext=c
@@ -19932,7 +20220,7 @@ then :
   withval=$with_x;
 fi
 
-# $have_x is `yes', `no', `disabled', or empty when we do not yet know.
+# $have_x is 'yes', 'no', 'disabled', or empty when we do not yet know.
 if test "x$with_x" = xno; then
   # The user explicitly disabled X.
   have_x=disabled
@@ -19942,8 +20230,8 @@ else
     *,NONE | NONE,*) if test ${ac_cv_have_x+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  # One or both of the vars are not set, and there is no cached value.
+else case e in #(
+  e) # One or both of the vars are not set, and there is no cached value.
 ac_x_includes=no
 ac_x_libraries=no
 # Do we need to do anything special at all?
@@ -20066,13 +20354,14 @@ if ac_fn_c_try_cpp "$LINENO"
 then :
   # We can compile using X headers with no special include directory.
 ac_x_includes=
-else $as_nop
-  for ac_dir in $ac_x_header_dirs; do
+else case e in #(
+  e) for ac_dir in $ac_x_header_dirs; do
   if test -r "$ac_dir/X11/Xlib.h"; then
     ac_x_includes=$ac_dir
     break
   fi
-done
+done ;;
+esac
 fi
 rm -f conftest.err conftest.i conftest.$ac_ext
 fi # $ac_x_includes = no
@@ -20099,8 +20388,8 @@ then :
   LIBS=$ac_save_LIBS
 # We can link X programs with no special library path.
 ac_x_libraries=
-else $as_nop
-  LIBS=$ac_save_LIBS
+else case e in #(
+  e) LIBS=$ac_save_LIBS
 for ac_dir in `printf "%s\n" "$ac_x_includes $ac_x_header_dirs" | sed s/include/lib/g`
 do
   # Don't even attempt the hair of trying to link an X program!
@@ -20110,7 +20399,8 @@ do
       break 2
     fi
   done
-done
+done ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -20127,6 +20417,7 @@ case $ac_x_includes,$ac_x_libraries in #
     ac_cv_have_x="have_x=yes\
 	ac_x_includes='$ac_x_includes'\
 	ac_x_libraries='$ac_x_libraries'" ;;
+esac ;;
 esac
 fi
 ;; #(
@@ -20310,8 +20601,9 @@ then :
   if test "$with_hwloc_symbol_prefix" = ""
 then :
   hwloc_symbol_prefix_value=hwloc_
-else $as_nop
-  hwloc_symbol_prefix_value=$with_hwloc_symbol_prefix
+else case e in #(
+  e) hwloc_symbol_prefix_value=$with_hwloc_symbol_prefix ;;
+esac
 fi
 fi
 
@@ -20333,9 +20625,10 @@ printf "%s\n" "$hwloc_symbol_prefix_valu
 then :
   printf "%s\n" "#define HWLOC_SYM_TRANSFORM 0" >>confdefs.h
 
-else $as_nop
-  printf "%s\n" "#define HWLOC_SYM_TRANSFORM 1" >>confdefs.h
-
+else case e in #(
+  e) printf "%s\n" "#define HWLOC_SYM_TRANSFORM 1" >>confdefs.h
+ ;;
+esac
 fi
 
     # hwloc 2.0+ requires a C99 compliant compiler
@@ -20357,8 +20650,8 @@ printf %s "checking for the C compiler v
 if test ${hwloc_cv_c_compiler_vendor+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_ext=c
+else case e in #(
+  e) ac_ext=c
 ac_cpp='$CPP $CPPFLAGS'
 ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
 ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
@@ -20501,8 +20794,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_check_compiler_vendor_result="compaq"
-else $as_nop
-
+else case e in #(
+  e)
     cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -20514,8 +20807,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_check_compiler_vendor_result="compaq"
-else $as_nop
-
+else case e in #(
+  e)
     cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -20528,9 +20821,11 @@ if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_check_compiler_vendor_result="compaq"
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -20626,8 +20921,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_check_compiler_vendor_result="ibm"
-else $as_nop
-
+else case e in #(
+  e)
     cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -20640,7 +20935,8 @@ if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_check_compiler_vendor_result="ibm"
 fi
-rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
+rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -20971,7 +21267,8 @@ ac_cpp='$CPP $CPPFLAGS'
 ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
 ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
 ac_compiler_gnu=$ac_cv_c_compiler_gnu
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $hwloc_cv_c_compiler_vendor" >&5
 printf "%s\n" "$hwloc_cv_c_compiler_vendor" >&6; }
@@ -21004,28 +21301,30 @@ ac_compiler_gnu=$ac_cv_c_compiler_gnu
     # though the $target may indicate something different.
     # The cast to long int works around a bug in the HP C Compiler
 # version HP92453-01 B.11.11.23709.GP, which incorrectly rejects
-# declarations like `int a3[[(sizeof (unsigned char)) >= 0]];'.
+# declarations like 'int a3[[(sizeof (unsigned char)) >= 0]];'.
 # This bug is HP SR number 8606223364.
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking size of void *" >&5
 printf %s "checking size of void *... " >&6; }
 if test ${ac_cv_sizeof_void_p+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if ac_fn_c_compute_int "$LINENO" "(long int) (sizeof (void *))" "ac_cv_sizeof_void_p"        "$ac_includes_default"
+else case e in #(
+  e) if ac_fn_c_compute_int "$LINENO" "(long int) (sizeof (void *))" "ac_cv_sizeof_void_p"        "$ac_includes_default"
 then :
 
-else $as_nop
-  if test "$ac_cv_type_void_p" = yes; then
-     { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+else case e in #(
+  e) if test "$ac_cv_type_void_p" = yes; then
+     { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error 77 "cannot compute sizeof (void *)
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; }
    else
      ac_cv_sizeof_void_p=0
-   fi
+   fi ;;
+esac
 fi
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_sizeof_void_p" >&5
 printf "%s\n" "$ac_cv_sizeof_void_p" >&6; }
@@ -21224,28 +21523,30 @@ printf "%s\n" "unknown" >&6; }
 
     # The cast to long int works around a bug in the HP C Compiler
 # version HP92453-01 B.11.11.23709.GP, which incorrectly rejects
-# declarations like `int a3[[(sizeof (unsigned char)) >= 0]];'.
+# declarations like 'int a3[[(sizeof (unsigned char)) >= 0]];'.
 # This bug is HP SR number 8606223364.
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking size of unsigned long" >&5
 printf %s "checking size of unsigned long... " >&6; }
 if test ${ac_cv_sizeof_unsigned_long+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if ac_fn_c_compute_int "$LINENO" "(long int) (sizeof (unsigned long))" "ac_cv_sizeof_unsigned_long"        "$ac_includes_default"
+else case e in #(
+  e) if ac_fn_c_compute_int "$LINENO" "(long int) (sizeof (unsigned long))" "ac_cv_sizeof_unsigned_long"        "$ac_includes_default"
 then :
 
-else $as_nop
-  if test "$ac_cv_type_unsigned_long" = yes; then
-     { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+else case e in #(
+  e) if test "$ac_cv_type_unsigned_long" = yes; then
+     { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error 77 "cannot compute sizeof (unsigned long)
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; }
    else
      ac_cv_sizeof_unsigned_long=0
-   fi
+   fi ;;
+esac
 fi
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_sizeof_unsigned_long" >&5
 printf "%s\n" "$ac_cv_sizeof_unsigned_long" >&6; }
@@ -21260,28 +21561,30 @@ printf "%s\n" "#define HWLOC_SIZEOF_UNSI
 
     # The cast to long int works around a bug in the HP C Compiler
 # version HP92453-01 B.11.11.23709.GP, which incorrectly rejects
-# declarations like `int a3[[(sizeof (unsigned char)) >= 0]];'.
+# declarations like 'int a3[[(sizeof (unsigned char)) >= 0]];'.
 # This bug is HP SR number 8606223364.
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking size of unsigned int" >&5
 printf %s "checking size of unsigned int... " >&6; }
 if test ${ac_cv_sizeof_unsigned_int+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if ac_fn_c_compute_int "$LINENO" "(long int) (sizeof (unsigned int))" "ac_cv_sizeof_unsigned_int"        "$ac_includes_default"
+else case e in #(
+  e) if ac_fn_c_compute_int "$LINENO" "(long int) (sizeof (unsigned int))" "ac_cv_sizeof_unsigned_int"        "$ac_includes_default"
 then :
 
-else $as_nop
-  if test "$ac_cv_type_unsigned_int" = yes; then
-     { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+else case e in #(
+  e) if test "$ac_cv_type_unsigned_int" = yes; then
+     { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error 77 "cannot compute sizeof (unsigned int)
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; }
    else
      ac_cv_sizeof_unsigned_int=0
-   fi
+   fi ;;
+esac
 fi
-
+ ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_sizeof_unsigned_int" >&5
 printf "%s\n" "$ac_cv_sizeof_unsigned_int" >&6; }
@@ -21305,8 +21608,8 @@ printf %s "checking for __attribute__...
   if test ${hwloc_cv___attribute__+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
     cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -21329,8 +21632,9 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
 
-else $as_nop
-  hwloc_cv___attribute__=1
+else case e in #(
+  e) hwloc_cv___attribute__=1 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -21357,12 +21661,14 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
 
-else $as_nop
-  hwloc_cv___attribute__=1
+else case e in #(
+  e) hwloc_cv___attribute__=1 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
     fi
-
+     ;;
+esac
 fi
 
 
@@ -21405,8 +21711,8 @@ printf %s "checking for __attribute__(al
     if test ${hwloc_cv___attribute__aligned+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -21445,8 +21751,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__aligned=0
+else case e in #(
+  e) hwloc_cv___attribute__aligned=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -21478,8 +21785,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__aligned=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -21500,14 +21807,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -21529,8 +21838,8 @@ printf %s "checking for __attribute__(al
     if test ${hwloc_cv___attribute__always_inline+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -21569,8 +21878,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__always_inline=0
+else case e in #(
+  e) hwloc_cv___attribute__always_inline=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -21602,8 +21912,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__always_inline=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -21624,14 +21934,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -21650,8 +21962,8 @@ printf %s "checking for __attribute__(co
     if test ${hwloc_cv___attribute__cold+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -21693,8 +22005,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__cold=0
+else case e in #(
+  e) hwloc_cv___attribute__cold=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -21726,8 +22039,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__cold=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -21748,14 +22061,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -21774,8 +22089,8 @@ printf %s "checking for __attribute__(co
     if test ${hwloc_cv___attribute__const+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -21817,8 +22132,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__const=0
+else case e in #(
+  e) hwloc_cv___attribute__const=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -21850,8 +22166,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__const=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -21872,14 +22188,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -21899,8 +22217,8 @@ printf %s "checking for __attribute__(de
     if test ${hwloc_cv___attribute__deprecated+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -21942,8 +22260,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__deprecated=0
+else case e in #(
+  e) hwloc_cv___attribute__deprecated=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -21975,8 +22294,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__deprecated=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -21997,14 +22316,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -22023,8 +22344,8 @@ printf %s "checking for __attribute__(co
     if test ${hwloc_cv___attribute__constructor+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -22066,8 +22387,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__constructor=0
+else case e in #(
+  e) hwloc_cv___attribute__constructor=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -22099,8 +22421,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__constructor=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -22121,14 +22443,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -22158,8 +22482,8 @@ printf %s "checking for __attribute__(fo
     if test ${hwloc_cv___attribute__format+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -22200,8 +22524,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__format=0
+else case e in #(
+  e) hwloc_cv___attribute__format=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -22251,8 +22576,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__format=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -22273,14 +22598,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -22299,8 +22626,8 @@ printf %s "checking for __attribute__(ho
     if test ${hwloc_cv___attribute__hot+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -22342,8 +22669,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__hot=0
+else case e in #(
+  e) hwloc_cv___attribute__hot=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -22375,8 +22703,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__hot=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -22397,14 +22725,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -22423,8 +22753,8 @@ printf %s "checking for __attribute__(ma
     if test ${hwloc_cv___attribute__malloc+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -22469,8 +22799,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__malloc=0
+else case e in #(
+  e) hwloc_cv___attribute__malloc=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -22502,8 +22833,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__malloc=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -22524,14 +22855,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -22557,8 +22890,8 @@ printf %s "checking for __attribute__(ma
     if test ${hwloc_cv___attribute__may_alias+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -22597,8 +22930,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__may_alias=0
+else case e in #(
+  e) hwloc_cv___attribute__may_alias=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -22630,8 +22964,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__may_alias=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -22652,14 +22986,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -22679,8 +23015,8 @@ printf %s "checking for __attribute__(no
     if test ${hwloc_cv___attribute__no_instrument_function+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -22719,8 +23055,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__no_instrument_function=0
+else case e in #(
+  e) hwloc_cv___attribute__no_instrument_function=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -22752,8 +23089,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__no_instrument_function=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -22774,14 +23111,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -22816,8 +23155,8 @@ printf %s "checking for __attribute__(no
     if test ${hwloc_cv___attribute__nonnull+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -22859,8 +23198,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__nonnull=0
+else case e in #(
+  e) hwloc_cv___attribute__nonnull=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -22912,8 +23252,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__nonnull=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -22934,14 +23274,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -22961,8 +23303,8 @@ printf %s "checking for __attribute__(no
     if test ${hwloc_cv___attribute__noreturn+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -23010,8 +23352,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__noreturn=0
+else case e in #(
+  e) hwloc_cv___attribute__noreturn=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -23043,8 +23386,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__noreturn=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -23065,14 +23408,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -23091,8 +23436,8 @@ printf %s "checking for __attribute__(pa
     if test ${hwloc_cv___attribute__packed+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -23136,8 +23481,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__packed=0
+else case e in #(
+  e) hwloc_cv___attribute__packed=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -23169,8 +23515,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__packed=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -23191,14 +23537,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -23217,8 +23565,8 @@ printf %s "checking for __attribute__(pu
     if test ${hwloc_cv___attribute__pure+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -23260,8 +23608,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__pure=0
+else case e in #(
+  e) hwloc_cv___attribute__pure=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -23293,8 +23642,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__pure=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -23315,14 +23664,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -23358,8 +23709,8 @@ printf %s "checking for __attribute__(se
     if test ${hwloc_cv___attribute__sentinel+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -23400,8 +23751,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__sentinel=0
+else case e in #(
+  e) hwloc_cv___attribute__sentinel=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -23453,8 +23805,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__sentinel=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -23475,14 +23827,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -23501,8 +23855,8 @@ printf %s "checking for __attribute__(un
     if test ${hwloc_cv___attribute__unused+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -23544,8 +23898,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__unused=0
+else case e in #(
+  e) hwloc_cv___attribute__unused=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -23577,8 +23932,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__unused=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -23599,14 +23954,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -23641,8 +23998,8 @@ printf %s "checking for __attribute__(wa
     if test ${hwloc_cv___attribute__warn_unused_result+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -23684,8 +24041,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__warn_unused_result=0
+else case e in #(
+  e) hwloc_cv___attribute__warn_unused_result=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -23741,8 +24099,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__warn_unused_result=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -23763,14 +24121,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -23790,8 +24150,8 @@ printf %s "checking for __attribute__(we
     if test ${hwloc_cv___attribute__weak_alias+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-
+else case e in #(
+  e)
         #
         # Try to compile using the C compiler
         #
@@ -23834,8 +24194,9 @@ then :
     fi
 
 
-else $as_nop
-  hwloc_cv___attribute__weak_alias=0
+else case e in #(
+  e) hwloc_cv___attribute__weak_alias=0 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
@@ -23867,8 +24228,8 @@ _ACEOF
 if ac_fn_c_try_compile "$LINENO"
 then :
   hwloc_cv___attribute__weak_alias=0
-else $as_nop
-
+else case e in #(
+  e)
                  #
                  # In case we did NOT succeed: Fine, but was this due to the
                  # attribute being ignored? Grep for IgNoRe in conftest.err
@@ -23889,14 +24250,16 @@ else $as_nop
         done
     fi
 
-
+                 ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 
             ac_c_werror_flag=$ac_c_werror_flag_safe
             CFLAGS=$CFLAGS_safe
         fi
-
+     ;;
+esac
 fi
 
 
@@ -24044,8 +24407,9 @@ then :
 fi
 fi
 
-else $as_nop
-  hwloc_add=
+else case e in #(
+  e) hwloc_add= ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -24053,9 +24417,10 @@ rm -f core conftest.err conftest.$ac_obj
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
-printf "%s\n" "yes" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+printf "%s\n" "yes" >&6; } ;;
+esac
 fi
 
         CFLAGS=$CFLAGS_orig
@@ -24113,10 +24478,11 @@ if ac_fn_c_try_compile "$LINENO"
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-else $as_nop
-  hwloc_args_check=1
+else case e in #(
+  e) hwloc_args_check=1
        { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
-printf "%s\n" "yes" >&6; }
+printf "%s\n" "yes" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
     { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking whether the C compiler rejects function calls with too few arguments" >&5
@@ -24139,10 +24505,11 @@ if ac_fn_c_try_compile "$LINENO"
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-else $as_nop
-  hwloc_args_check=`expr $hwloc_args_check + 1`
+else case e in #(
+  e) hwloc_args_check=`expr $hwloc_args_check + 1`
        { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
-printf "%s\n" "yes" >&6; }
+printf "%s\n" "yes" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
     if test "$hwloc_args_check" != "2"
@@ -24245,9 +24612,10 @@ then :
 printf "%s\n" "yes" >&6; }
 		       add="$add -Wdiscarded-qualifiers"
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
     CFLAGS="$tmp_save_CFLAGS"
@@ -24274,9 +24642,10 @@ then :
 printf "%s\n" "yes" >&6; }
 		       add="$add -Wvariadic-macros"
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
     CFLAGS="$tmp_save_CFLAGS"
@@ -24303,9 +24672,10 @@ then :
 printf "%s\n" "yes" >&6; }
 		       add="$add -Wtype-limits"
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
     CFLAGS="$tmp_save_CFLAGS"
@@ -24332,9 +24702,10 @@ then :
 printf "%s\n" "yes" >&6; }
 		       add="$add -Wstack-usage=262144"
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
     CFLAGS="$tmp_save_CFLAGS"
@@ -24365,9 +24736,10 @@ printf "%s\n" "yes" >&6; }
 
 printf "%s\n" "#define HWLOC_HAVE_GCC_W_MISSING_FIELD_INITIALIZERS 1" >>confdefs.h
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
     CFLAGS="$tmp_save_CFLAGS"
@@ -24396,9 +24768,10 @@ printf "%s\n" "yes" >&6; }
 
 printf "%s\n" "#define HWLOC_HAVE_GCC_W_CAST_FUNCTION_TYPE 1" >>confdefs.h
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
     CFLAGS="$tmp_save_CFLAGS"
@@ -24475,15 +24848,16 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 
 
 printf "%s\n" "#define HWLOC_HAVE_DECL_STRCASECMP 1" >>confdefs.h
 
 
-
+     ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -24525,15 +24899,16 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 
 
 printf "%s\n" "#define HWLOC_HAVE_DECL_STRNCASECMP 1" >>confdefs.h
 
 
-
+     ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -24788,8 +25163,9 @@ fi
 if test "x$ac_cv_have_decl_GetModuleFileName" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_GETMODULEFILENAME $ac_have_decl" >>confdefs.h
 
@@ -24799,8 +25175,8 @@ printf %s "checking for main in -lgdi32.
 if test ${ac_cv_lib_gdi32_main+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lgdi32  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -24817,12 +25193,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_gdi32_main=yes
-else $as_nop
-  ac_cv_lib_gdi32_main=no
+else case e in #(
+  e) ac_cv_lib_gdi32_main=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_gdi32_main" >&5
 printf "%s\n" "$ac_cv_lib_gdi32_main" >&6; }
@@ -24839,16 +25217,22 @@ printf %s "checking for PostQuitMessage
 if test ${ac_cv_lib_user32_PostQuitMessage+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-luser32  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char PostQuitMessage ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char PostQuitMessage (void);
 int
 main (void)
 {
@@ -24860,12 +25244,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_user32_PostQuitMessage=yes
-else $as_nop
-  ac_cv_lib_user32_PostQuitMessage=no
+else case e in #(
+  e) ac_cv_lib_user32_PostQuitMessage=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_user32_PostQuitMessage" >&5
 printf "%s\n" "$ac_cv_lib_user32_PostQuitMessage" >&6; }
@@ -24884,8 +25270,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_HWLOC_MS_LIB+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $HWLOC_MS_LIB in
+else case e in #(
+  e) case $HWLOC_MS_LIB in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_HWLOC_MS_LIB="$HWLOC_MS_LIB" # Let the user override the test with a path.
   ;;
@@ -24910,6 +25296,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 HWLOC_MS_LIB=$ac_cv_path_HWLOC_MS_LIB
@@ -24946,16 +25333,22 @@ printf %s "checking for lgrp_init in -ll
 if test ${ac_cv_lib_lgrp_lgrp_init+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-llgrp  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char lgrp_init ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char lgrp_init (void);
 int
 main (void)
 {
@@ -24967,12 +25360,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_lgrp_lgrp_init=yes
-else $as_nop
-  ac_cv_lib_lgrp_lgrp_init=no
+else case e in #(
+  e) ac_cv_lib_lgrp_lgrp_init=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_lgrp_lgrp_init" >&5
 printf "%s\n" "$ac_cv_lib_lgrp_lgrp_init" >&6; }
@@ -24987,8 +25382,9 @@ printf "%s\n" "#define HAVE_LIBLGRP 1" >
 if test "x$ac_cv_have_decl_lgrp_latency_cookie" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_LGRP_LATENCY_COOKIE $ac_have_decl" >>confdefs.h
 
@@ -25011,8 +25407,8 @@ printf %s "checking for main in -lkstat.
 if test ${ac_cv_lib_kstat_main+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lkstat  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
@@ -25029,12 +25425,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_kstat_main=yes
-else $as_nop
-  ac_cv_lib_kstat_main=no
+else case e in #(
+  e) ac_cv_lib_kstat_main=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_kstat_main" >&5
 printf "%s\n" "$ac_cv_lib_kstat_main" >&6; }
@@ -25063,16 +25461,22 @@ printf %s "checking for picl_initialize
 if test ${ac_cv_lib_picl_picl_initialize+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lpicl  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char picl_initialize ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char picl_initialize (void);
 int
 main (void)
 {
@@ -25084,12 +25488,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_picl_picl_initialize=yes
-else $as_nop
-  ac_cv_lib_picl_picl_initialize=no
+else case e in #(
+  e) ac_cv_lib_picl_picl_initialize=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_picl_picl_initialize" >&5
 printf "%s\n" "$ac_cv_lib_picl_picl_initialize" >&6; }
@@ -25115,15 +25521,21 @@ printf %s "checking for library containi
 if test ${ac_cv_search_pthread_getthrds_np+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_func_search_save_LIBS=$LIBS
+else case e in #(
+  e) ac_func_search_save_LIBS=$LIBS
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char pthread_getthrds_np ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char pthread_getthrds_np (void);
 int
 main (void)
 {
@@ -25154,11 +25566,13 @@ done
 if test ${ac_cv_search_pthread_getthrds_np+y}
 then :
 
-else $as_nop
-  ac_cv_search_pthread_getthrds_np=no
+else case e in #(
+  e) ac_cv_search_pthread_getthrds_np=no ;;
+esac
 fi
 rm conftest.$ac_ext
-LIBS=$ac_func_search_save_LIBS
+LIBS=$ac_func_search_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_search_pthread_getthrds_np" >&5
 printf "%s\n" "$ac_cv_search_pthread_getthrds_np" >&6; }
@@ -25210,9 +25624,10 @@ printf "%s\n" "yes" >&6; }
 
 printf "%s\n" "#define HWLOC_HAVE_DARWIN_FOUNDATION 1" >>confdefs.h
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -25246,9 +25661,10 @@ printf "%s\n" "yes" >&6; }
 
 printf "%s\n" "#define HWLOC_HAVE_DARWIN_IOKIT 1" >>confdefs.h
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -25274,15 +25690,17 @@ rm -f core conftest.err conftest.$ac_obj
 if test "x$ac_cv_have_decl_sched_getcpu" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_SCHED_GETCPU $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 
 
@@ -25324,8 +25742,8 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 
 	hwloc_have_sched_setaffinity=yes
@@ -25371,14 +25789,16 @@ printf "%s\n" "#define HWLOC_HAVE_OLD_SC
 
              { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
         CFLAGS=$hwloc_save_CFLAGS
 
-
+     ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -25408,9 +25828,10 @@ printf "%s\n" "#define HWLOC_HAVE_CPU_SE
 
          { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -25444,9 +25865,10 @@ printf "%s\n" "#define HWLOC_HAVE_CPU_SE
 
          { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -25475,9 +25897,10 @@ printf "%s\n" "#define HWLOC_HAVE_SYSCAL
 
          { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -25496,16 +25919,22 @@ printf %s "checking for udev_device_new_
 if test ${ac_cv_lib_udev_udev_device_new_from_subsystem_sysname+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ludev  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char udev_device_new_from_subsystem_sysname ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char udev_device_new_from_subsystem_sysname (void);
 int
 main (void)
 {
@@ -25517,12 +25946,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_udev_udev_device_new_from_subsystem_sysname=yes
-else $as_nop
-  ac_cv_lib_udev_udev_device_new_from_subsystem_sysname=no
+else case e in #(
+  e) ac_cv_lib_udev_udev_device_new_from_subsystem_sysname=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_udev_udev_device_new_from_subsystem_sysname" >&5
 printf "%s\n" "$ac_cv_lib_udev_udev_device_new_from_subsystem_sysname" >&6; }
@@ -25579,8 +26010,9 @@ then :
 if test "x$ac_cv_have_decl_CTL_HW" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_CTL_HW $ac_have_decl" >>confdefs.h
 ac_fn_check_decl "$LINENO" "HW_NCPU" "ac_cv_have_decl_HW_NCPU" "
@@ -25593,8 +26025,9 @@ ac_fn_check_decl "$LINENO" "HW_NCPU" "ac
 if test "x$ac_cv_have_decl_HW_NCPU" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_HW_NCPU $ac_have_decl" >>confdefs.h
 ac_fn_check_decl "$LINENO" "HW_REALMEM64" "ac_cv_have_decl_HW_REALMEM64" "
@@ -25607,8 +26040,9 @@ ac_fn_check_decl "$LINENO" "HW_REALMEM64
 if test "x$ac_cv_have_decl_HW_REALMEM64" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_HW_REALMEM64 $ac_have_decl" >>confdefs.h
 ac_fn_check_decl "$LINENO" "HW_MEMSIZE64" "ac_cv_have_decl_HW_MEMSIZE64" "
@@ -25621,8 +26055,9 @@ ac_fn_check_decl "$LINENO" "HW_MEMSIZE64
 if test "x$ac_cv_have_decl_HW_MEMSIZE64" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_HW_MEMSIZE64 $ac_have_decl" >>confdefs.h
 ac_fn_check_decl "$LINENO" "HW_PHYSMEM64" "ac_cv_have_decl_HW_PHYSMEM64" "
@@ -25635,8 +26070,9 @@ ac_fn_check_decl "$LINENO" "HW_PHYSMEM64
 if test "x$ac_cv_have_decl_HW_PHYSMEM64" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_HW_PHYSMEM64 $ac_have_decl" >>confdefs.h
 ac_fn_check_decl "$LINENO" "HW_USERMEM64" "ac_cv_have_decl_HW_USERMEM64" "
@@ -25649,8 +26085,9 @@ ac_fn_check_decl "$LINENO" "HW_USERMEM64
 if test "x$ac_cv_have_decl_HW_USERMEM64" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_HW_USERMEM64 $ac_have_decl" >>confdefs.h
 ac_fn_check_decl "$LINENO" "HW_REALMEM" "ac_cv_have_decl_HW_REALMEM" "
@@ -25663,8 +26100,9 @@ ac_fn_check_decl "$LINENO" "HW_REALMEM"
 if test "x$ac_cv_have_decl_HW_REALMEM" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_HW_REALMEM $ac_have_decl" >>confdefs.h
 ac_fn_check_decl "$LINENO" "HW_MEMSIZE" "ac_cv_have_decl_HW_MEMSIZE" "
@@ -25677,8 +26115,9 @@ ac_fn_check_decl "$LINENO" "HW_MEMSIZE"
 if test "x$ac_cv_have_decl_HW_MEMSIZE" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_HW_MEMSIZE $ac_have_decl" >>confdefs.h
 ac_fn_check_decl "$LINENO" "HW_PHYSMEM" "ac_cv_have_decl_HW_PHYSMEM" "
@@ -25691,8 +26130,9 @@ ac_fn_check_decl "$LINENO" "HW_PHYSMEM"
 if test "x$ac_cv_have_decl_HW_PHYSMEM" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_HW_PHYSMEM $ac_have_decl" >>confdefs.h
 ac_fn_check_decl "$LINENO" "HW_USERMEM" "ac_cv_have_decl_HW_USERMEM" "
@@ -25705,8 +26145,9 @@ ac_fn_check_decl "$LINENO" "HW_USERMEM"
 if test "x$ac_cv_have_decl_HW_USERMEM" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_HW_USERMEM $ac_have_decl" >>confdefs.h
 
@@ -25753,9 +26194,10 @@ printf "%s\n" "#define HAVE_SYSCTL 1" >>
 
          { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -25786,9 +26228,10 @@ printf "%s\n" "#define HAVE_SYSCTLBYNAME
 
          { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -25804,15 +26247,17 @@ rm -f core conftest.err conftest.$ac_obj
 if test "x$ac_cv_have_decl_pthread_setaffinity_np" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_PTHREAD_SETAFFINITY_NP $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 
     ac_fn_check_decl "$LINENO" "pthread_getaffinity_np" "ac_cv_have_decl_pthread_getaffinity_np" "
@@ -25825,15 +26270,17 @@ fi
 if test "x$ac_cv_have_decl_pthread_getaffinity_np" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_PTHREAD_GETAFFINITY_NP $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 
 
@@ -25842,8 +26289,9 @@ fi
 if test "x$ac_cv_have_decl_fabsf" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_FABSF $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
@@ -25854,16 +26302,22 @@ printf %s "checking for fabsf in -lm...
 if test ${ac_cv_lib_m_fabsf+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lm  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char fabsf ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char fabsf (void);
 int
 main (void)
 {
@@ -25875,12 +26329,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_m_fabsf=yes
-else $as_nop
-  ac_cv_lib_m_fabsf=no
+else case e in #(
+  e) ac_cv_lib_m_fabsf=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_m_fabsf" >&5
 printf "%s\n" "$ac_cv_lib_m_fabsf" >&6; }
@@ -25897,8 +26353,9 @@ fi
 if test "x$ac_cv_have_decl_modff" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_MODFF $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
@@ -25909,16 +26366,22 @@ printf %s "checking for modff in -lm...
 if test ${ac_cv_lib_m_modff+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lm  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char modff ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char modff (void);
 int
 main (void)
 {
@@ -25930,12 +26393,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_m_modff=yes
-else $as_nop
-  ac_cv_lib_m_modff=no
+else case e in #(
+  e) ac_cv_lib_m_modff=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_m_modff" >&5
 printf "%s\n" "$ac_cv_lib_m_modff" >&6; }
@@ -25956,105 +26421,119 @@ fi
 if test "x$ac_cv_have_decl__SC_NPROCESSORS_ONLN" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL__SC_NPROCESSORS_ONLN $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 ac_fn_check_decl "$LINENO" "_SC_NPROCESSORS_CONF" "ac_cv_have_decl__SC_NPROCESSORS_CONF" "#include <unistd.h>
 " "$ac_c_undeclared_builtin_options" "CFLAGS"
 if test "x$ac_cv_have_decl__SC_NPROCESSORS_CONF" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL__SC_NPROCESSORS_CONF $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 ac_fn_check_decl "$LINENO" "_SC_NPROC_ONLN" "ac_cv_have_decl__SC_NPROC_ONLN" "#include <unistd.h>
 " "$ac_c_undeclared_builtin_options" "CFLAGS"
 if test "x$ac_cv_have_decl__SC_NPROC_ONLN" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL__SC_NPROC_ONLN $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 ac_fn_check_decl "$LINENO" "_SC_NPROC_CONF" "ac_cv_have_decl__SC_NPROC_CONF" "#include <unistd.h>
 " "$ac_c_undeclared_builtin_options" "CFLAGS"
 if test "x$ac_cv_have_decl__SC_NPROC_CONF" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL__SC_NPROC_CONF $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 ac_fn_check_decl "$LINENO" "_SC_PAGESIZE" "ac_cv_have_decl__SC_PAGESIZE" "#include <unistd.h>
 " "$ac_c_undeclared_builtin_options" "CFLAGS"
 if test "x$ac_cv_have_decl__SC_PAGESIZE" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL__SC_PAGESIZE $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 ac_fn_check_decl "$LINENO" "_SC_PAGE_SIZE" "ac_cv_have_decl__SC_PAGE_SIZE" "#include <unistd.h>
 " "$ac_c_undeclared_builtin_options" "CFLAGS"
 if test "x$ac_cv_have_decl__SC_PAGE_SIZE" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL__SC_PAGE_SIZE $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 ac_fn_check_decl "$LINENO" "_SC_LARGE_PAGESIZE" "ac_cv_have_decl__SC_LARGE_PAGESIZE" "#include <unistd.h>
 " "$ac_c_undeclared_builtin_options" "CFLAGS"
 if test "x$ac_cv_have_decl__SC_LARGE_PAGESIZE" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL__SC_LARGE_PAGESIZE $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 
 
@@ -26096,21 +26575,23 @@ done
 if test "x$ac_cv_have_decl_strtoull" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_STRTOULL $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  ac_fn_c_check_func "$LINENO" "strtoull" "ac_cv_func_strtoull"
+else case e in #(
+  e) ac_fn_c_check_func "$LINENO" "strtoull" "ac_cv_func_strtoull"
 if test "x$ac_cv_func_strtoull" = xyes
 then :
   printf "%s\n" "#define HAVE_STRTOULL 1" >>confdefs.h
 
 fi
-
+ ;;
+esac
 fi
 
 
@@ -26129,8 +26610,9 @@ fi
 if test "x$ac_cv_have_decl_snprintf" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_SNPRINTF $ac_have_decl" >>confdefs.h
 
@@ -26140,8 +26622,9 @@ printf "%s\n" "#define HAVE_DECL_SNPRINT
 if test "x$ac_cv_have_decl__strdup" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL__STRDUP $ac_have_decl" >>confdefs.h
 
@@ -26150,8 +26633,9 @@ printf "%s\n" "#define HAVE_DECL__STRDUP
 if test "x$ac_cv_have_decl__putenv" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL__PUTENV $ac_have_decl" >>confdefs.h
 
@@ -26167,8 +26651,8 @@ then :
 printf "%s\n" "don't know (cross-compiling)" >&6; }
 	  broken_snprintf=maybe
 
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 
@@ -26196,15 +26680,17 @@ if ac_fn_c_try_run "$LINENO"
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
-else $as_nop
-
+else case e in #(
+  e)
 	  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
 	  broken_snprintf=yes
-
+	 ;;
+esac
 fi
 rm -f core *.core core.conftest.* gmon.out bb.out conftest$ac_exeext \
-  conftest.$ac_objext conftest.beam conftest.$ac_ext
+  conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 
 
@@ -26219,8 +26705,9 @@ printf "%s\n" "#define HWLOC_HAVE_CORREC
 if test "x$ac_cv_have_decl_getprogname" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_GETPROGNAME $ac_have_decl" >>confdefs.h
 
@@ -26229,8 +26716,9 @@ printf "%s\n" "#define HAVE_DECL_GETPROG
 if test "x$ac_cv_have_decl_getexecname" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_GETEXECNAME $ac_have_decl" >>confdefs.h
 
@@ -26266,9 +26754,10 @@ printf "%s\n" "#define HAVE_PROGRAM_INVO
        { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -26299,9 +26788,10 @@ printf "%s\n" "#define HAVE___PROGNAME 1
        { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -26321,8 +26811,9 @@ then :
 printf "%s\n" "#define HAVE_PTHREAD_T 1" >>confdefs.h
 
 hwloc_thread_t=pthread_t
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 
         ;;
@@ -26343,8 +26834,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_BASH+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $BASH in
+else case e in #(
+  e) case $BASH in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_BASH="$BASH" # Let the user override the test with a path.
   ;;
@@ -26369,6 +26860,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 BASH=$ac_cv_path_BASH
@@ -26415,15 +26907,16 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 
 
 printf "%s\n" "#define HWLOC_HAVE_DECL_FFS 1" >>confdefs.h
 
 
-
+     ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -26473,15 +26966,16 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 
 
 printf "%s\n" "#define HWLOC_HAVE_DECL_FFSL 1" >>confdefs.h
 
 
-
+     ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -26527,15 +27021,16 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 
 
 printf "%s\n" "#define HWLOC_HAVE_DECL_FLS 1" >>confdefs.h
 
 
-
+     ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -26580,15 +27075,16 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 
 
 printf "%s\n" "#define HWLOC_HAVE_DECL_FLSL 1" >>confdefs.h
 
 
-
+     ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -26634,15 +27130,16 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 
 
 printf "%s\n" "#define HWLOC_HAVE_DECL_CLZ 1" >>confdefs.h
 
 
-
+     ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -26687,15 +27184,16 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 
 
 printf "%s\n" "#define HWLOC_HAVE_DECL_CLZL 1" >>confdefs.h
 
 
-
+     ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -26774,8 +27272,8 @@ then :
   hwloc_pthread_mutex_happy=yes
        HWLOC_LIBS_PRIVATE="$HWLOC_LIBS_PRIVATE -lpthread"
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: trying again with -lpthread ..." >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: trying again with -lpthread ..." >&5
 printf "%s\n" "$as_me: trying again with -lpthread ..." >&6;}
        # Try again with explicit -lpthread
        $as_unset ac_cv_func_pthread_mutex_lock
@@ -26790,7 +27288,8 @@ then :
 fi
 
        LIBS="$tmp_save_LIBS"
-
+       ;;
+esac
 fi
 
     if test "x$hwloc_pthread_mutex_happy" = "xyes"
@@ -26823,24 +27322,27 @@ fi
 if test "x$ac_cv_have_decl_RUNNING_ON_VALGRIND" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_RUNNING_ON_VALGRIND $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
 fi
 
 
-else $as_nop
-
+else case e in #(
+  e)
 
 printf "%s\n" "#define HAVE_DECL_RUNNING_ON_VALGRIND 0" >>confdefs.h
 
-
+	 ;;
+esac
 fi
 
     if test "x$enable_32bits_pci_domain" = "xyes"
@@ -26960,13 +27462,15 @@ then :
 if test "x$ac_cv_func_pci_slot_match_iterator_create" = xyes
 then :
   hwloc_result=yes
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
         CFLAGS=$hwloc_cflags_save
@@ -26982,10 +27486,11 @@ then :
                { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
                :
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-               hwloc_pciaccess_happy=no
+               hwloc_pciaccess_happy=no ;;
+esac
 fi
     fi
 
@@ -27008,16 +27513,22 @@ printf %s "checking for pci_slot_match_i
 if test ${ac_cv_lib_pciaccess_pci_slot_match_iterator_create+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lpciaccess  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char pci_slot_match_iterator_create ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char pci_slot_match_iterator_create (void);
 int
 main (void)
 {
@@ -27029,12 +27540,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_pciaccess_pci_slot_match_iterator_create=yes
-else $as_nop
-  ac_cv_lib_pciaccess_pci_slot_match_iterator_create=no
+else case e in #(
+  e) ac_cv_lib_pciaccess_pci_slot_match_iterator_create=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_pciaccess_pci_slot_match_iterator_create" >&5
 printf "%s\n" "$ac_cv_lib_pciaccess_pci_slot_match_iterator_create" >&6; }
@@ -27277,8 +27790,8 @@ and HWLOC_CUDA_LIBS to avoid the need to
 See the pkg-config man page for more details.
 " "$LINENO" 5
     elif test $HWLOC_pkg_failed = untried; then
-        { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+        { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error $? "The pkg-config script could not be found or is too old.  Make sure it
 is in your PATH or set the PKG_CONFIG environment variable to the full
 path to pkg-config.
@@ -27288,7 +27801,7 @@ and HWLOC_CUDA_LIBS to avoid the need to
 See the pkg-config man page for more details.
 
 To get pkg-config, see <http://pkg-config.freedesktop.org/>.
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; }
     else
         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
@@ -27318,13 +27831,15 @@ then :
 if test "x$ac_cv_func_cuInit" = xyes
 then :
   hwloc_result=yes
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
         CFLAGS=$hwloc_cflags_save
@@ -27340,10 +27855,11 @@ then :
                { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
                hwloc_have_cuda=yes
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-               :
+               : ;;
+esac
 fi
     fi
       else
@@ -27388,16 +27904,22 @@ printf %s "checking for cuInit in -lcuda
 if test ${ac_cv_lib_cuda_cuInit+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lcuda  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char cuInit ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char cuInit (void);
 int
 main (void)
 {
@@ -27409,12 +27931,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_cuda_cuInit=yes
-else $as_nop
-  ac_cv_lib_cuda_cuInit=no
+else case e in #(
+  e) ac_cv_lib_cuda_cuInit=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_cuda_cuInit" >&5
 printf "%s\n" "$ac_cv_lib_cuda_cuInit" >&6; }
@@ -27427,9 +27951,10 @@ then :
 fi
 
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
 fi
@@ -27525,8 +28050,8 @@ and HWLOC_CUDART_LIBS to avoid the need
 See the pkg-config man page for more details.
 " "$LINENO" 5
     elif test $HWLOC_pkg_failed = untried; then
-        { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+        { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error $? "The pkg-config script could not be found or is too old.  Make sure it
 is in your PATH or set the PKG_CONFIG environment variable to the full
 path to pkg-config.
@@ -27536,7 +28061,7 @@ and HWLOC_CUDART_LIBS to avoid the need
 See the pkg-config man page for more details.
 
 To get pkg-config, see <http://pkg-config.freedesktop.org/>.
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; }
     else
         { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
@@ -27566,13 +28091,15 @@ then :
 if test "x$ac_cv_func_cudaGetDeviceProperties" = xyes
 then :
   hwloc_result=yes
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
         CFLAGS=$hwloc_cflags_save
@@ -27591,10 +28118,11 @@ printf "%s\n" "yes" >&6; }
           hwloc_have_cudart=yes
           HWLOC_CUDART_REQUIRES=$cudartpc
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-               :
+               : ;;
+esac
 fi
     fi
       else
@@ -27639,16 +28167,22 @@ printf %s "checking for cudaGetDevicePro
 if test ${ac_cv_lib_cudart_cudaGetDeviceProperties+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lcudart  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char cudaGetDeviceProperties ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char cudaGetDeviceProperties (void);
 int
 main (void)
 {
@@ -27660,12 +28194,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_cudart_cudaGetDeviceProperties=yes
-else $as_nop
-  ac_cv_lib_cudart_cudaGetDeviceProperties=no
+else case e in #(
+  e) ac_cv_lib_cudart_cudaGetDeviceProperties=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_cudart_cudaGetDeviceProperties" >&5
 printf "%s\n" "$ac_cv_lib_cudart_cudaGetDeviceProperties" >&6; }
@@ -27698,8 +28234,8 @@ printf %s "checking whether a program li
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: don't know (cross-compiling)" >&5
 printf "%s\n" "don't know (cross-compiling)" >&6; }
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 
@@ -27724,13 +28260,15 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
            hwloc_cuda_warning=no
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-           hwloc_cuda_warning=yes
+           hwloc_cuda_warning=yes ;;
+esac
 fi
 rm -f core *.core core.conftest.* gmon.out bb.out conftest$ac_exeext \
-  conftest.$ac_objext conftest.beam conftest.$ac_ext
+  conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 
 	LDFLAGS="$tmp_save_LDFLAGS"
@@ -27797,16 +28335,22 @@ printf %s "checking for nvmlInit in -lnv
 if test ${ac_cv_lib_nvidia_ml_nvmlInit+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lnvidia-ml  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char nvmlInit ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char nvmlInit (void);
 int
 main (void)
 {
@@ -27818,12 +28362,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_nvidia_ml_nvmlInit=yes
-else $as_nop
-  ac_cv_lib_nvidia_ml_nvmlInit=no
+else case e in #(
+  e) ac_cv_lib_nvidia_ml_nvmlInit=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_nvidia_ml_nvmlInit" >&5
 printf "%s\n" "$ac_cv_lib_nvidia_ml_nvmlInit" >&6; }
@@ -27838,8 +28384,8 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: don't know (cross-compiling)" >&5
 printf "%s\n" "don't know (cross-compiling)" >&6; }
                         hwloc_nvml_happy=maybe
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 
@@ -27862,22 +28408,26 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
                         hwloc_nvml_warning=no
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-                        hwloc_nvml_warning=yes
+                        hwloc_nvml_warning=yes ;;
+esac
 fi
 rm -f core *.core core.conftest.* gmon.out bb.out conftest$ac_exeext \
-  conftest.$ac_objext conftest.beam conftest.$ac_ext
+  conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 
-else $as_nop
-  hwloc_nvml_happy=no
+else case e in #(
+  e) hwloc_nvml_happy=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_nvml_happy=no
+else case e in #(
+  e) hwloc_nvml_happy=no ;;
+esac
 fi
 
 done
@@ -27888,20 +28438,40 @@ done
       if test "x$hwloc_nvml_happy" = "xyes"; then
         tmp_save_CPPFLAGS="$CPPFLAGS"
         CPPFLAGS="$CPPFLAGS $HWLOC_NVML_CPPFLAGS"
-        ac_fn_check_decl "$LINENO" "nvmlDeviceGetMaxPcieLinkGeneration" "ac_cv_have_decl_nvmlDeviceGetMaxPcieLinkGeneration" "#include <nvml.h>
+        ac_fn_check_decl "$LINENO" "nvmlDeviceGetCurrPcieLinkGeneration" "ac_cv_have_decl_nvmlDeviceGetCurrPcieLinkGeneration" "#include <nvml.h>
 " "$ac_c_undeclared_builtin_options" "CFLAGS"
-if test "x$ac_cv_have_decl_nvmlDeviceGetMaxPcieLinkGeneration" = xyes
+if test "x$ac_cv_have_decl_nvmlDeviceGetCurrPcieLinkGeneration" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
-printf "%s\n" "#define HAVE_DECL_NVMLDEVICEGETMAXPCIELINKGENERATION $ac_have_decl" >>confdefs.h
+printf "%s\n" "#define HAVE_DECL_NVMLDEVICEGETCURRPCIELINKGENERATION $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
 then :
 
-else $as_nop
-  :
+else case e in #(
+  e) : ;;
+esac
+fi
+
+        ac_fn_check_decl "$LINENO" "nvmlDeviceGetNvLinkRemoteDeviceType" "ac_cv_have_decl_nvmlDeviceGetNvLinkRemoteDeviceType" "#include <nvml.h>
+" "$ac_c_undeclared_builtin_options" "CFLAGS"
+if test "x$ac_cv_have_decl_nvmlDeviceGetNvLinkRemoteDeviceType" = xyes
+then :
+  ac_have_decl=1
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
+fi
+printf "%s\n" "#define HAVE_DECL_NVMLDEVICEGETNVLINKREMOTEDEVICETYPE $ac_have_decl" >>confdefs.h
+if test $ac_have_decl = 1
+then :
+
+else case e in #(
+  e) : ;;
+esac
 fi
 
         CPPFLAGS="$tmp_save_CPPFLAGS"
@@ -27992,16 +28562,22 @@ printf %s "checking for rsmi_init in -lr
 if test ${ac_cv_lib_rocm_smi64_rsmi_init+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lrocm_smi64  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char rsmi_init ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char rsmi_init (void);
 int
 main (void)
 {
@@ -28013,12 +28589,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_rocm_smi64_rsmi_init=yes
-else $as_nop
-  ac_cv_lib_rocm_smi64_rsmi_init=no
+else case e in #(
+  e) ac_cv_lib_rocm_smi64_rsmi_init=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_rocm_smi64_rsmi_init" >&5
 printf "%s\n" "$ac_cv_lib_rocm_smi64_rsmi_init" >&6; }
@@ -28032,8 +28610,8 @@ printf %s "checking whether a program li
 then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: don't know (cross-compiling)" >&5
 printf "%s\n" "don't know (cross-compiling)" >&6; }
-else $as_nop
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+else case e in #(
+  e) cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 
@@ -28056,24 +28634,28 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
                          hwloc_rsmi_warning=no
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-                         hwloc_rsmi_warning=yes
+                         hwloc_rsmi_warning=yes ;;
+esac
 fi
 rm -f core *.core core.conftest.* gmon.out bb.out conftest$ac_exeext \
-  conftest.$ac_objext conftest.beam conftest.$ac_ext
+  conftest.$ac_objext conftest.beam conftest.$ac_ext ;;
+esac
 fi
 
-else $as_nop
-  hwloc_rsmi_happy=no
+else case e in #(
+  e) hwloc_rsmi_happy=no ;;
+esac
 fi
 
         LDFLAGS="$LDFLAGS_save"
         LIBS="$LIBS_save"
 
-else $as_nop
-  hwloc_rsmi_happy=no
+else case e in #(
+  e) hwloc_rsmi_happy=no ;;
+esac
 fi
 
 done
@@ -28149,17 +28731,19 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 	   HWLOC_OPENCL_LDFLAGS="-framework OpenCL"
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-	   hwloc_opencl_happy=no
+	   hwloc_opencl_happy=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
           LDFLAGS="$tmp_save_LDFLAGS"
 
-else $as_nop
-  hwloc_opencl_happy=no
+else case e in #(
+  e) hwloc_opencl_happy=no ;;
+esac
 fi
 
 done
@@ -28194,16 +28778,22 @@ printf %s "checking for clGetDeviceIDs i
 if test ${ac_cv_lib_OpenCL_clGetDeviceIDs+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lOpenCL  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char clGetDeviceIDs ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char clGetDeviceIDs (void);
 int
 main (void)
 {
@@ -28215,25 +28805,29 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_OpenCL_clGetDeviceIDs=yes
-else $as_nop
-  ac_cv_lib_OpenCL_clGetDeviceIDs=no
+else case e in #(
+  e) ac_cv_lib_OpenCL_clGetDeviceIDs=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_OpenCL_clGetDeviceIDs" >&5
 printf "%s\n" "$ac_cv_lib_OpenCL_clGetDeviceIDs" >&6; }
 if test "x$ac_cv_lib_OpenCL_clGetDeviceIDs" = xyes
 then :
   HWLOC_OPENCL_LIBS="-lOpenCL"
-else $as_nop
-  hwloc_opencl_happy=no
+else case e in #(
+  e) hwloc_opencl_happy=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_opencl_happy=no
+else case e in #(
+  e) hwloc_opencl_happy=no ;;
+esac
 fi
 
 done
@@ -28375,13 +28969,15 @@ then :
 if test "x$ac_cv_func_zesDevicePciGetProperties" = xyes
 then :
   hwloc_result=yes
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
         CFLAGS=$hwloc_cflags_save
@@ -28403,16 +28999,22 @@ printf %s "checking for zesInit in -lze_
 if test ${ac_cv_lib_ze_loader_zesInit+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lze_loader  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char zesInit ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char zesInit (void);
 int
 main (void)
 {
@@ -28424,12 +29026,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ze_loader_zesInit=yes
-else $as_nop
-  ac_cv_lib_ze_loader_zesInit=no
+else case e in #(
+  e) ac_cv_lib_ze_loader_zesInit=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ze_loader_zesInit" >&5
 printf "%s\n" "$ac_cv_lib_ze_loader_zesInit" >&6; }
@@ -28445,16 +29049,22 @@ printf %s "checking for zeDevicePciGetPr
 if test ${ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lze_loader  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char zeDevicePciGetPropertiesExt ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char zeDevicePciGetPropertiesExt (void);
 int
 main (void)
 {
@@ -28466,12 +29076,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt=yes
-else $as_nop
-  ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt=no
+else case e in #(
+  e) ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt" >&5
 printf "%s\n" "$ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt" >&6; }
@@ -28483,10 +29095,11 @@ printf "%s\n" "#define HWLOC_HAVE_ZEDEVI
 fi
 
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-               hwloc_levelzero_happy=no
+               hwloc_levelzero_happy=no ;;
+esac
 fi
     fi
       if test x$hwloc_levelzero_happy = xno; then
@@ -28503,16 +29116,22 @@ printf %s "checking for zeInit in -lze_l
 if test ${ac_cv_lib_ze_loader_zeInit+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lze_loader  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char zeInit ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char zeInit (void);
 int
 main (void)
 {
@@ -28524,12 +29143,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ze_loader_zeInit=yes
-else $as_nop
-  ac_cv_lib_ze_loader_zeInit=no
+else case e in #(
+  e) ac_cv_lib_ze_loader_zeInit=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ze_loader_zeInit" >&5
 printf "%s\n" "$ac_cv_lib_ze_loader_zeInit" >&6; }
@@ -28548,16 +29169,22 @@ printf %s "checking for zesDevicePciGetP
 if test ${ac_cv_lib_ze_loader_zesDevicePciGetProperties+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lze_loader  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char zesDevicePciGetProperties ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char zesDevicePciGetProperties (void);
 int
 main (void)
 {
@@ -28569,12 +29196,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ze_loader_zesDevicePciGetProperties=yes
-else $as_nop
-  ac_cv_lib_ze_loader_zesDevicePciGetProperties=no
+else case e in #(
+  e) ac_cv_lib_ze_loader_zesDevicePciGetProperties=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ze_loader_zesDevicePciGetProperties" >&5
 printf "%s\n" "$ac_cv_lib_ze_loader_zesDevicePciGetProperties" >&6; }
@@ -28586,16 +29215,22 @@ printf %s "checking for zesInit in -lze_
 if test ${ac_cv_lib_ze_loader_zesInit+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lze_loader  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char zesInit ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char zesInit (void);
 int
 main (void)
 {
@@ -28607,12 +29242,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ze_loader_zesInit=yes
-else $as_nop
-  ac_cv_lib_ze_loader_zesInit=no
+else case e in #(
+  e) ac_cv_lib_ze_loader_zesInit=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ze_loader_zesInit" >&5
 printf "%s\n" "$ac_cv_lib_ze_loader_zesInit" >&6; }
@@ -28628,16 +29265,22 @@ printf %s "checking for zeDevicePciGetPr
 if test ${ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lze_loader  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char zeDevicePciGetPropertiesExt ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char zeDevicePciGetPropertiesExt (void);
 int
 main (void)
 {
@@ -28649,12 +29292,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt=yes
-else $as_nop
-  ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt=no
+else case e in #(
+  e) ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt" >&5
 printf "%s\n" "$ac_cv_lib_ze_loader_zeDevicePciGetPropertiesExt" >&6; }
@@ -28666,24 +29311,28 @@ printf "%s\n" "#define HWLOC_HAVE_ZEDEVI
 fi
 
 
-else $as_nop
-  hwloc_levelzero_happy=no
+else case e in #(
+  e) hwloc_levelzero_happy=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_levelzero_happy=no
+else case e in #(
+  e) hwloc_levelzero_happy=no ;;
+esac
 fi
 
 done
 
-else $as_nop
-  hwloc_levelzero_happy=no
+else case e in #(
+  e) hwloc_levelzero_happy=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_levelzero_happy=no
+else case e in #(
+  e) hwloc_levelzero_happy=no ;;
+esac
 fi
 
 done
@@ -28761,8 +29410,8 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
        X_LIBS="$X_LIBS -R$x_libraries"
-else $as_nop
-  LIBS="$ac_xsave_LIBS -R $x_libraries"
+else case e in #(
+  e) LIBS="$ac_xsave_LIBS -R $x_libraries"
        cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -28779,12 +29428,14 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 	  X_LIBS="$X_LIBS -R $x_libraries"
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: neither works" >&5
-printf "%s\n" "neither works" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: neither works" >&5
+printf "%s\n" "neither works" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
-    conftest$ac_exeext conftest.$ac_ext
+    conftest$ac_exeext conftest.$ac_ext ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -28808,8 +29459,14 @@ rm -f core conftest.err conftest.$ac_obj
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char XOpenDisplay ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char XOpenDisplay (void);
 int
 main (void)
 {
@@ -28821,22 +29478,28 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dnet_ntoa in -ldnet" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dnet_ntoa in -ldnet" >&5
 printf %s "checking for dnet_ntoa in -ldnet... " >&6; }
 if test ${ac_cv_lib_dnet_dnet_ntoa+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldnet  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dnet_ntoa ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dnet_ntoa (void);
 int
 main (void)
 {
@@ -28848,12 +29511,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dnet_dnet_ntoa=yes
-else $as_nop
-  ac_cv_lib_dnet_dnet_ntoa=no
+else case e in #(
+  e) ac_cv_lib_dnet_dnet_ntoa=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dnet_dnet_ntoa" >&5
 printf "%s\n" "$ac_cv_lib_dnet_dnet_ntoa" >&6; }
@@ -28868,16 +29533,22 @@ printf %s "checking for dnet_ntoa in -ld
 if test ${ac_cv_lib_dnet_stub_dnet_ntoa+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldnet_stub  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dnet_ntoa ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dnet_ntoa (void);
 int
 main (void)
 {
@@ -28889,12 +29560,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dnet_stub_dnet_ntoa=yes
-else $as_nop
-  ac_cv_lib_dnet_stub_dnet_ntoa=no
+else case e in #(
+  e) ac_cv_lib_dnet_stub_dnet_ntoa=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dnet_stub_dnet_ntoa" >&5
 printf "%s\n" "$ac_cv_lib_dnet_stub_dnet_ntoa" >&6; }
@@ -28903,7 +29576,8 @@ then :
   X_EXTRA_LIBS="$X_EXTRA_LIBS -ldnet_stub"
 fi
 
-    fi
+    fi ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -28929,16 +29603,22 @@ printf %s "checking for gethostbyname in
 if test ${ac_cv_lib_nsl_gethostbyname+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lnsl  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char gethostbyname ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char gethostbyname (void);
 int
 main (void)
 {
@@ -28950,12 +29630,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_nsl_gethostbyname=yes
-else $as_nop
-  ac_cv_lib_nsl_gethostbyname=no
+else case e in #(
+  e) ac_cv_lib_nsl_gethostbyname=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_nsl_gethostbyname" >&5
 printf "%s\n" "$ac_cv_lib_nsl_gethostbyname" >&6; }
@@ -28970,16 +29652,22 @@ printf %s "checking for gethostbyname in
 if test ${ac_cv_lib_bsd_gethostbyname+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lbsd  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char gethostbyname ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char gethostbyname (void);
 int
 main (void)
 {
@@ -28991,12 +29679,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_bsd_gethostbyname=yes
-else $as_nop
-  ac_cv_lib_bsd_gethostbyname=no
+else case e in #(
+  e) ac_cv_lib_bsd_gethostbyname=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_bsd_gethostbyname" >&5
 printf "%s\n" "$ac_cv_lib_bsd_gethostbyname" >&6; }
@@ -29027,16 +29717,22 @@ printf %s "checking for connect in -lsoc
 if test ${ac_cv_lib_socket_connect+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lsocket $X_EXTRA_LIBS $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char connect ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char connect (void);
 int
 main (void)
 {
@@ -29048,12 +29744,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_socket_connect=yes
-else $as_nop
-  ac_cv_lib_socket_connect=no
+else case e in #(
+  e) ac_cv_lib_socket_connect=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_socket_connect" >&5
 printf "%s\n" "$ac_cv_lib_socket_connect" >&6; }
@@ -29077,16 +29775,22 @@ printf %s "checking for remove in -lposi
 if test ${ac_cv_lib_posix_remove+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lposix  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char remove ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char remove (void);
 int
 main (void)
 {
@@ -29098,12 +29802,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_posix_remove=yes
-else $as_nop
-  ac_cv_lib_posix_remove=no
+else case e in #(
+  e) ac_cv_lib_posix_remove=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_posix_remove" >&5
 printf "%s\n" "$ac_cv_lib_posix_remove" >&6; }
@@ -29127,16 +29833,22 @@ printf %s "checking for shmat in -lipc..
 if test ${ac_cv_lib_ipc_shmat+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lipc  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char shmat ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char shmat (void);
 int
 main (void)
 {
@@ -29148,12 +29860,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ipc_shmat=yes
-else $as_nop
-  ac_cv_lib_ipc_shmat=no
+else case e in #(
+  e) ac_cv_lib_ipc_shmat=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ipc_shmat" >&5
 printf "%s\n" "$ac_cv_lib_ipc_shmat" >&6; }
@@ -29179,16 +29893,22 @@ printf %s "checking for IceConnectionNum
 if test ${ac_cv_lib_ICE_IceConnectionNumber+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lICE $X_EXTRA_LIBS $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char IceConnectionNumber ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char IceConnectionNumber (void);
 int
 main (void)
 {
@@ -29200,12 +29920,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ICE_IceConnectionNumber=yes
-else $as_nop
-  ac_cv_lib_ICE_IceConnectionNumber=no
+else case e in #(
+  e) ac_cv_lib_ICE_IceConnectionNumber=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ICE_IceConnectionNumber" >&5
 printf "%s\n" "$ac_cv_lib_ICE_IceConnectionNumber" >&6; }
@@ -29235,16 +29957,22 @@ printf %s "checking for XOpenDisplay in
 if test ${ac_cv_lib_X11_XOpenDisplay+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lX11  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char XOpenDisplay ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char XOpenDisplay (void);
 int
 main (void)
 {
@@ -29256,12 +29984,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_X11_XOpenDisplay=yes
-else $as_nop
-  ac_cv_lib_X11_XOpenDisplay=no
+else case e in #(
+  e) ac_cv_lib_X11_XOpenDisplay=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_X11_XOpenDisplay" >&5
 printf "%s\n" "$ac_cv_lib_X11_XOpenDisplay" >&6; }
@@ -29296,16 +30026,22 @@ printf %s "checking for XNVCTRLQueryTarg
 if test ${ac_cv_lib_XNVCtrl_XNVCTRLQueryTargetAttribute+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lXNVCtrl -lXext $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char XNVCTRLQueryTargetAttribute ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char XNVCTRLQueryTargetAttribute (void);
 int
 main (void)
 {
@@ -29317,25 +30053,29 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_XNVCtrl_XNVCTRLQueryTargetAttribute=yes
-else $as_nop
-  ac_cv_lib_XNVCtrl_XNVCTRLQueryTargetAttribute=no
+else case e in #(
+  e) ac_cv_lib_XNVCtrl_XNVCTRLQueryTargetAttribute=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_XNVCtrl_XNVCTRLQueryTargetAttribute" >&5
 printf "%s\n" "$ac_cv_lib_XNVCtrl_XNVCTRLQueryTargetAttribute" >&6; }
 if test "x$ac_cv_lib_XNVCtrl_XNVCTRLQueryTargetAttribute" = xyes
 then :
   :
-else $as_nop
-  hwloc_gl_happy=no
+else case e in #(
+  e) hwloc_gl_happy=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_gl_happy=no
+else case e in #(
+  e) hwloc_gl_happy=no ;;
+esac
 fi
 
 done
@@ -29474,13 +30214,15 @@ then :
 if test "x$ac_cv_func_xmlNewDoc" = xyes
 then :
   hwloc_result=yes
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
         CFLAGS=$hwloc_cflags_save
@@ -29496,10 +30238,11 @@ then :
                { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
                hwloc_libxml2_happy=yes
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-               hwloc_libxml2_happy=no
+               hwloc_libxml2_happy=no ;;
+esac
 fi
     fi
 
@@ -29583,9 +30326,10 @@ printf "%s\n" "#define HWLOC_HAVE_X86_CP
          HWLOC_HAVE_X86_CPUID=1
 
 	 hwloc_have_x86_cpuid=yes
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
-printf "%s\n" "no" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+printf "%s\n" "no" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -29675,8 +30419,8 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
      hwloc_dlopen_ready=yes
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
      ac_fn_c_check_header_compile "$LINENO" "dlfcn.h" "ac_cv_header_dlfcn_h" "$ac_includes_default"
 if test "x$ac_cv_header_dlfcn_h" = xyes
@@ -29686,16 +30430,22 @@ printf %s "checking for dlopen in -ldl..
 if test ${ac_cv_lib_dl_dlopen+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldl  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dlopen ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dlopen (void);
 int
 main (void)
 {
@@ -29707,12 +30457,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dl_dlopen=yes
-else $as_nop
-  ac_cv_lib_dl_dlopen=no
+else case e in #(
+  e) ac_cv_lib_dl_dlopen=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dl_dlopen" >&5
 printf "%s\n" "$ac_cv_lib_dl_dlopen" >&6; }
@@ -29725,7 +30477,8 @@ fi
 
 fi
 
-
+     ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -29743,16 +30496,22 @@ printf %s "checking for lt_dlopenext in
 if test ${ac_cv_lib_ltdl_lt_dlopenext+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lltdl  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char lt_dlopenext ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char lt_dlopenext (void);
 int
 main (void)
 {
@@ -29764,12 +30523,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ltdl_lt_dlopenext=yes
-else $as_nop
-  ac_cv_lib_ltdl_lt_dlopenext=no
+else case e in #(
+  e) ac_cv_lib_ltdl_lt_dlopenext=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ltdl_lt_dlopenext" >&5
 printf "%s\n" "$ac_cv_lib_ltdl_lt_dlopenext" >&6; }
@@ -29837,16 +30598,22 @@ printf %s "checking for dlopen in -ldl..
 if test ${ac_cv_lib_dl_dlopen+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldl  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dlopen ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dlopen (void);
 int
 main (void)
 {
@@ -29858,24 +30625,27 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dl_dlopen=yes
-else $as_nop
-  ac_cv_lib_dl_dlopen=no
+else case e in #(
+  e) ac_cv_lib_dl_dlopen=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dl_dlopen" >&5
 printf "%s\n" "$ac_cv_lib_dl_dlopen" >&6; }
 if test "x$ac_cv_lib_dl_dlopen" = xyes
 then :
   lt_cv_dlopen="dlopen" lt_cv_dlopen_libs="-ldl"
-else $as_nop
-
+else case e in #(
+  e)
     lt_cv_dlopen="dyld"
     lt_cv_dlopen_libs=
     lt_cv_dlopen_self=yes
-
+     ;;
+esac
 fi
 
     ;;
@@ -29885,22 +30655,28 @@ fi
 if test "x$ac_cv_func_shl_load" = xyes
 then :
   lt_cv_dlopen="shl_load"
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for shl_load in -ldld" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for shl_load in -ldld" >&5
 printf %s "checking for shl_load in -ldld... " >&6; }
 if test ${ac_cv_lib_dld_shl_load+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldld  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char shl_load ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char shl_load (void);
 int
 main (void)
 {
@@ -29912,39 +30688,47 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dld_shl_load=yes
-else $as_nop
-  ac_cv_lib_dld_shl_load=no
+else case e in #(
+  e) ac_cv_lib_dld_shl_load=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dld_shl_load" >&5
 printf "%s\n" "$ac_cv_lib_dld_shl_load" >&6; }
 if test "x$ac_cv_lib_dld_shl_load" = xyes
 then :
   lt_cv_dlopen="shl_load" lt_cv_dlopen_libs="-ldld"
-else $as_nop
-  ac_fn_c_check_func "$LINENO" "dlopen" "ac_cv_func_dlopen"
+else case e in #(
+  e) ac_fn_c_check_func "$LINENO" "dlopen" "ac_cv_func_dlopen"
 if test "x$ac_cv_func_dlopen" = xyes
 then :
   lt_cv_dlopen="dlopen"
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dlopen in -ldl" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dlopen in -ldl" >&5
 printf %s "checking for dlopen in -ldl... " >&6; }
 if test ${ac_cv_lib_dl_dlopen+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldl  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dlopen ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dlopen (void);
 int
 main (void)
 {
@@ -29956,34 +30740,42 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dl_dlopen=yes
-else $as_nop
-  ac_cv_lib_dl_dlopen=no
+else case e in #(
+  e) ac_cv_lib_dl_dlopen=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dl_dlopen" >&5
 printf "%s\n" "$ac_cv_lib_dl_dlopen" >&6; }
 if test "x$ac_cv_lib_dl_dlopen" = xyes
 then :
   lt_cv_dlopen="dlopen" lt_cv_dlopen_libs="-ldl"
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dlopen in -lsvld" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dlopen in -lsvld" >&5
 printf %s "checking for dlopen in -lsvld... " >&6; }
 if test ${ac_cv_lib_svld_dlopen+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lsvld  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dlopen ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dlopen (void);
 int
 main (void)
 {
@@ -29995,34 +30787,42 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_svld_dlopen=yes
-else $as_nop
-  ac_cv_lib_svld_dlopen=no
+else case e in #(
+  e) ac_cv_lib_svld_dlopen=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_svld_dlopen" >&5
 printf "%s\n" "$ac_cv_lib_svld_dlopen" >&6; }
 if test "x$ac_cv_lib_svld_dlopen" = xyes
 then :
   lt_cv_dlopen="dlopen" lt_cv_dlopen_libs="-lsvld"
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dld_link in -ldld" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dld_link in -ldld" >&5
 printf %s "checking for dld_link in -ldld... " >&6; }
 if test ${ac_cv_lib_dld_dld_link+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldld  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dld_link ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dld_link (void);
 int
 main (void)
 {
@@ -30034,12 +30834,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dld_dld_link=yes
-else $as_nop
-  ac_cv_lib_dld_dld_link=no
+else case e in #(
+  e) ac_cv_lib_dld_dld_link=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dld_dld_link" >&5
 printf "%s\n" "$ac_cv_lib_dld_dld_link" >&6; }
@@ -30048,19 +30850,24 @@ then :
   lt_cv_dlopen="dld_link" lt_cv_dlopen_libs="-ldld"
 fi
 
-
+               ;;
+esac
 fi
 
-
+             ;;
+esac
 fi
 
-
+           ;;
+esac
 fi
 
-
+         ;;
+esac
 fi
 
-
+       ;;
+esac
 fi
 
     ;;
@@ -30323,8 +31130,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_DIFF+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $DIFF in
+else case e in #(
+  e) case $DIFF in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_DIFF="$DIFF" # Let the user override the test with a path.
   ;;
@@ -30349,6 +31156,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 DIFF=$ac_cv_path_DIFF
@@ -30379,10 +31187,11 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no (doxygen generation is optional)" >&5
 printf "%s\n" "no (doxygen generation is optional)" >&6; }
 	   test "x$enable_doxygen" = x && enable_doxygen=no
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
-	   test "x$enable_doxygen" = x && enable_doxygen=yes
+	   test "x$enable_doxygen" = x && enable_doxygen=yes ;;
+esac
 fi
 
     # Generating the doxygen output requires a few tools.  If we
@@ -30396,8 +31205,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_DOXYGEN+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $DOXYGEN in
+else case e in #(
+  e) case $DOXYGEN in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_DOXYGEN="$DOXYGEN" # Let the user override the test with a path.
   ;;
@@ -30422,6 +31231,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 DOXYGEN=$ac_cv_path_DOXYGEN
@@ -30444,8 +31254,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_ac_pt_DOXYGEN+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $ac_pt_DOXYGEN in
+else case e in #(
+  e) case $ac_pt_DOXYGEN in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_ac_pt_DOXYGEN="$ac_pt_DOXYGEN" # Let the user override the test with a path.
   ;;
@@ -30470,6 +31280,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 ac_pt_DOXYGEN=$ac_cv_path_ac_pt_DOXYGEN
@@ -30507,8 +31318,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_PDFLATEX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $PDFLATEX in
+else case e in #(
+  e) case $PDFLATEX in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_PDFLATEX="$PDFLATEX" # Let the user override the test with a path.
   ;;
@@ -30533,6 +31344,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 PDFLATEX=$ac_cv_path_PDFLATEX
@@ -30555,8 +31367,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_ac_pt_PDFLATEX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $ac_pt_PDFLATEX in
+else case e in #(
+  e) case $ac_pt_PDFLATEX in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_ac_pt_PDFLATEX="$ac_pt_PDFLATEX" # Let the user override the test with a path.
   ;;
@@ -30581,6 +31393,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 ac_pt_PDFLATEX=$ac_cv_path_ac_pt_PDFLATEX
@@ -30617,8 +31430,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_MAKEINDEX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $MAKEINDEX in
+else case e in #(
+  e) case $MAKEINDEX in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_MAKEINDEX="$MAKEINDEX" # Let the user override the test with a path.
   ;;
@@ -30643,6 +31456,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 MAKEINDEX=$ac_cv_path_MAKEINDEX
@@ -30665,8 +31479,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_ac_pt_MAKEINDEX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $ac_pt_MAKEINDEX in
+else case e in #(
+  e) case $ac_pt_MAKEINDEX in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_ac_pt_MAKEINDEX="$ac_pt_MAKEINDEX" # Let the user override the test with a path.
   ;;
@@ -30691,6 +31505,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 ac_pt_MAKEINDEX=$ac_cv_path_ac_pt_MAKEINDEX
@@ -30727,8 +31542,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_FIG2DEV+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $FIG2DEV in
+else case e in #(
+  e) case $FIG2DEV in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_FIG2DEV="$FIG2DEV" # Let the user override the test with a path.
   ;;
@@ -30753,6 +31568,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 FIG2DEV=$ac_cv_path_FIG2DEV
@@ -30775,8 +31591,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_ac_pt_FIG2DEV+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $ac_pt_FIG2DEV in
+else case e in #(
+  e) case $ac_pt_FIG2DEV in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_ac_pt_FIG2DEV="$ac_pt_FIG2DEV" # Let the user override the test with a path.
   ;;
@@ -30801,6 +31617,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 ac_pt_FIG2DEV=$ac_cv_path_ac_pt_FIG2DEV
@@ -30837,8 +31654,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_GS+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $GS in
+else case e in #(
+  e) case $GS in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_GS="$GS" # Let the user override the test with a path.
   ;;
@@ -30863,6 +31680,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 GS=$ac_cv_path_GS
@@ -30885,8 +31703,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_ac_pt_GS+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $ac_pt_GS in
+else case e in #(
+  e) case $ac_pt_GS in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_ac_pt_GS="$ac_pt_GS" # Let the user override the test with a path.
   ;;
@@ -30911,6 +31729,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 ac_pt_GS=$ac_cv_path_ac_pt_GS
@@ -30947,8 +31766,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_EPSTOPDF+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $EPSTOPDF in
+else case e in #(
+  e) case $EPSTOPDF in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_EPSTOPDF="$EPSTOPDF" # Let the user override the test with a path.
   ;;
@@ -30973,6 +31792,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 EPSTOPDF=$ac_cv_path_EPSTOPDF
@@ -30995,8 +31815,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_ac_pt_EPSTOPDF+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $ac_pt_EPSTOPDF in
+else case e in #(
+  e) case $ac_pt_EPSTOPDF in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_ac_pt_EPSTOPDF="$ac_pt_EPSTOPDF" # Let the user override the test with a path.
   ;;
@@ -31021,6 +31841,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 ac_pt_EPSTOPDF=$ac_cv_path_ac_pt_EPSTOPDF
@@ -31053,8 +31874,9 @@ printf %s "checking if can build doxygen
     if test "x$DOXYGEN" != "x" -a "x$PDFLATEX" != "x" -a "x$MAKEINDEX" != "x" -a "x$FIG2DEV" != "x" -a "x$GS" != "x" -a "x$EPSTOPDF" != "x"
 then :
   hwloc_generate_doxs=yes
-else $as_nop
-  hwloc_generate_doxs=no
+else case e in #(
+  e) hwloc_generate_doxs=no ;;
+esac
 fi
     { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $hwloc_generate_doxs" >&5
 printf "%s\n" "$hwloc_generate_doxs" >&6; }
@@ -31084,8 +31906,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_W3M+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $W3M in
+else case e in #(
+  e) case $W3M in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_W3M="$W3M" # Let the user override the test with a path.
   ;;
@@ -31110,6 +31932,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 W3M=$ac_cv_path_W3M
@@ -31132,8 +31955,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_ac_pt_W3M+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $ac_pt_W3M in
+else case e in #(
+  e) case $ac_pt_W3M in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_ac_pt_W3M="$ac_pt_W3M" # Let the user override the test with a path.
   ;;
@@ -31158,6 +31981,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 ac_pt_W3M=$ac_cv_path_ac_pt_W3M
@@ -31193,8 +32017,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_LYNX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $LYNX in
+else case e in #(
+  e) case $LYNX in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_LYNX="$LYNX" # Let the user override the test with a path.
   ;;
@@ -31219,6 +32043,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 LYNX=$ac_cv_path_LYNX
@@ -31241,8 +32066,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_path_ac_pt_LYNX+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  case $ac_pt_LYNX in
+else case e in #(
+  e) case $ac_pt_LYNX in
   [\\/]* | ?:[\\/]*)
   ac_cv_path_ac_pt_LYNX="$ac_pt_LYNX" # Let the user override the test with a path.
   ;;
@@ -31267,6 +32092,7 @@ done
 IFS=$as_save_IFS
 
   ;;
+esac ;;
 esac
 fi
 ac_pt_LYNX=$ac_cv_path_ac_pt_LYNX
@@ -31300,23 +32126,26 @@ printf %s "checking if can build top-lev
 then :
   hwloc_generate_readme=yes
              HWLOC_W3_GENERATOR=$W3M
-else $as_nop
-  if test "x$LYNX" != "x"
+else case e in #(
+  e) if test "x$LYNX" != "x"
 then :
   hwloc_generate_readme=yes
                     HWLOC_W3_GENERATOR="$LYNX -dump -nolist"
-else $as_nop
-  hwloc_generate_readme=no
-fi
+else case e in #(
+  e) hwloc_generate_readme=no ;;
+esac
+fi ;;
+esac
 fi
 
       { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $hwloc_generate_readme" >&5
 printf "%s\n" "$hwloc_generate_readme" >&6; }
 
-else $as_nop
-
+else case e in #(
+  e)
       hwloc_generate_readme=no
-
+     ;;
+esac
 fi
     { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking if will build top-level README" >&5
 printf %s "checking if will build top-level README... " >&6; }
@@ -31329,8 +32158,9 @@ printf %s "checking if will build doxyge
     if test "x$hwloc_generate_doxs" = "xyes" -a "x$enable_doxygen" != "xno"
 then :
 
-else $as_nop
-  hwloc_generate_doxs=no
+else case e in #(
+  e) hwloc_generate_doxs=no ;;
+esac
 fi
     { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $hwloc_generate_doxs" >&5
 printf "%s\n" "$hwloc_generate_doxs" >&6; }
@@ -31344,8 +32174,9 @@ printf %s "checking if will install doxy
     	    -f "$srcdir/doc/doxygen-doc/hwloc-letter.pdf"
 then :
   hwloc_install_doxs=yes
-else $as_nop
-  hwloc_install_doxs=no
+else case e in #(
+  e) hwloc_install_doxs=no ;;
+esac
 fi
     { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $hwloc_install_doxs" >&5
 printf "%s\n" "$hwloc_install_doxs" >&6; }
@@ -31410,8 +32241,8 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
        X_LIBS="$X_LIBS -R$x_libraries"
-else $as_nop
-  LIBS="$ac_xsave_LIBS -R $x_libraries"
+else case e in #(
+  e) LIBS="$ac_xsave_LIBS -R $x_libraries"
        cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
@@ -31428,12 +32259,14 @@ then :
   { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
 	  X_LIBS="$X_LIBS -R $x_libraries"
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: neither works" >&5
-printf "%s\n" "neither works" >&6; }
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: neither works" >&5
+printf "%s\n" "neither works" >&6; } ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
-    conftest$ac_exeext conftest.$ac_ext
+    conftest$ac_exeext conftest.$ac_ext ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -31457,8 +32290,14 @@ rm -f core conftest.err conftest.$ac_obj
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char XOpenDisplay ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char XOpenDisplay (void);
 int
 main (void)
 {
@@ -31470,22 +32309,28 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
 
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dnet_ntoa in -ldnet" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: checking for dnet_ntoa in -ldnet" >&5
 printf %s "checking for dnet_ntoa in -ldnet... " >&6; }
 if test ${ac_cv_lib_dnet_dnet_ntoa+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldnet  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dnet_ntoa ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dnet_ntoa (void);
 int
 main (void)
 {
@@ -31497,12 +32342,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dnet_dnet_ntoa=yes
-else $as_nop
-  ac_cv_lib_dnet_dnet_ntoa=no
+else case e in #(
+  e) ac_cv_lib_dnet_dnet_ntoa=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dnet_dnet_ntoa" >&5
 printf "%s\n" "$ac_cv_lib_dnet_dnet_ntoa" >&6; }
@@ -31517,16 +32364,22 @@ printf %s "checking for dnet_ntoa in -ld
 if test ${ac_cv_lib_dnet_stub_dnet_ntoa+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-ldnet_stub  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char dnet_ntoa ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dnet_ntoa (void);
 int
 main (void)
 {
@@ -31538,12 +32391,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_dnet_stub_dnet_ntoa=yes
-else $as_nop
-  ac_cv_lib_dnet_stub_dnet_ntoa=no
+else case e in #(
+  e) ac_cv_lib_dnet_stub_dnet_ntoa=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dnet_stub_dnet_ntoa" >&5
 printf "%s\n" "$ac_cv_lib_dnet_stub_dnet_ntoa" >&6; }
@@ -31552,7 +32407,8 @@ then :
   X_EXTRA_LIBS="$X_EXTRA_LIBS -ldnet_stub"
 fi
 
-    fi
+    fi ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -31578,16 +32434,22 @@ printf %s "checking for gethostbyname in
 if test ${ac_cv_lib_nsl_gethostbyname+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lnsl  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char gethostbyname ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char gethostbyname (void);
 int
 main (void)
 {
@@ -31599,12 +32461,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_nsl_gethostbyname=yes
-else $as_nop
-  ac_cv_lib_nsl_gethostbyname=no
+else case e in #(
+  e) ac_cv_lib_nsl_gethostbyname=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_nsl_gethostbyname" >&5
 printf "%s\n" "$ac_cv_lib_nsl_gethostbyname" >&6; }
@@ -31619,16 +32483,22 @@ printf %s "checking for gethostbyname in
 if test ${ac_cv_lib_bsd_gethostbyname+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lbsd  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char gethostbyname ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char gethostbyname (void);
 int
 main (void)
 {
@@ -31640,12 +32510,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_bsd_gethostbyname=yes
-else $as_nop
-  ac_cv_lib_bsd_gethostbyname=no
+else case e in #(
+  e) ac_cv_lib_bsd_gethostbyname=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_bsd_gethostbyname" >&5
 printf "%s\n" "$ac_cv_lib_bsd_gethostbyname" >&6; }
@@ -31676,16 +32548,22 @@ printf %s "checking for connect in -lsoc
 if test ${ac_cv_lib_socket_connect+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lsocket $X_EXTRA_LIBS $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char connect ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char connect (void);
 int
 main (void)
 {
@@ -31697,12 +32575,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_socket_connect=yes
-else $as_nop
-  ac_cv_lib_socket_connect=no
+else case e in #(
+  e) ac_cv_lib_socket_connect=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_socket_connect" >&5
 printf "%s\n" "$ac_cv_lib_socket_connect" >&6; }
@@ -31726,16 +32606,22 @@ printf %s "checking for remove in -lposi
 if test ${ac_cv_lib_posix_remove+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lposix  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char remove ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char remove (void);
 int
 main (void)
 {
@@ -31747,12 +32633,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_posix_remove=yes
-else $as_nop
-  ac_cv_lib_posix_remove=no
+else case e in #(
+  e) ac_cv_lib_posix_remove=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_posix_remove" >&5
 printf "%s\n" "$ac_cv_lib_posix_remove" >&6; }
@@ -31776,16 +32664,22 @@ printf %s "checking for shmat in -lipc..
 if test ${ac_cv_lib_ipc_shmat+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lipc  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char shmat ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char shmat (void);
 int
 main (void)
 {
@@ -31797,12 +32691,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ipc_shmat=yes
-else $as_nop
-  ac_cv_lib_ipc_shmat=no
+else case e in #(
+  e) ac_cv_lib_ipc_shmat=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ipc_shmat" >&5
 printf "%s\n" "$ac_cv_lib_ipc_shmat" >&6; }
@@ -31828,16 +32724,22 @@ printf %s "checking for IceConnectionNum
 if test ${ac_cv_lib_ICE_IceConnectionNumber+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lICE $X_EXTRA_LIBS $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char IceConnectionNumber ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char IceConnectionNumber (void);
 int
 main (void)
 {
@@ -31849,12 +32751,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ICE_IceConnectionNumber=yes
-else $as_nop
-  ac_cv_lib_ICE_IceConnectionNumber=no
+else case e in #(
+  e) ac_cv_lib_ICE_IceConnectionNumber=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ICE_IceConnectionNumber" >&5
 printf "%s\n" "$ac_cv_lib_ICE_IceConnectionNumber" >&6; }
@@ -31884,16 +32788,22 @@ printf %s "checking for XOpenDisplay in
 if test ${ac_cv_lib_X11_XOpenDisplay+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lX11  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char XOpenDisplay ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char XOpenDisplay (void);
 int
 main (void)
 {
@@ -31905,12 +32815,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_X11_XOpenDisplay=yes
-else $as_nop
-  ac_cv_lib_X11_XOpenDisplay=no
+else case e in #(
+  e) ac_cv_lib_X11_XOpenDisplay=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_X11_XOpenDisplay" >&5
 printf "%s\n" "$ac_cv_lib_X11_XOpenDisplay" >&6; }
@@ -32056,13 +32968,15 @@ then :
 if test "x$ac_cv_func_cairo_fill" = xyes
 then :
   hwloc_result=yes
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
         CFLAGS=$hwloc_cflags_save
@@ -32078,10 +32992,11 @@ then :
                { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
                hwloc_cairo_happy=yes
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-               hwloc_cairo_happy=no
+               hwloc_cairo_happy=no ;;
+esac
 fi
     fi
     fi
@@ -32124,11 +33039,12 @@ printf "%s\n" "yes" >&6; }
 printf "%s\n" "#define LSTOPO_HAVE_X11 1" >>confdefs.h
 
 
-else $as_nop
-
+else case e in #(
+  e)
             { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no (missing CAIRO_HAS_XLIB_SURFACE)" >&5
 printf "%s\n" "no (missing CAIRO_HAS_XLIB_SURFACE)" >&6; }
-
+           ;;
+esac
 fi
 rm -f conftest.err conftest.i conftest.$ac_ext
           CPPFLAGS="$save_CPPFLAGS"
@@ -32167,12 +33083,12 @@ fi
     HWLOC_XML_LOCALIZED=1
            for ac_header in locale.h xlocale.h
 do :
-  as_ac_Header=`printf "%s\n" "ac_cv_header_$ac_header" | $as_tr_sh`
+  as_ac_Header=`printf "%s\n" "ac_cv_header_$ac_header" | sed "$as_sed_sh"`
 ac_fn_c_check_header_compile "$LINENO" "$ac_header" "$as_ac_Header" "$ac_includes_default"
 if eval test \"x\$"$as_ac_Header"\" = x"yes"
 then :
   cat >>confdefs.h <<_ACEOF
-#define `printf "%s\n" "HAVE_$ac_header" | $as_tr_cpp` 1
+#define `printf "%s\n" "HAVE_$ac_header" | sed "$as_sed_cpp"` 1
 _ACEOF
 
       ac_fn_c_check_func "$LINENO" "setlocale" "ac_cv_func_setlocale"
@@ -32251,11 +33167,12 @@ printf "%s\n" "#define HWLOC_HAVE_LIBTER
 
           chosen_curses=$curses
 
-else $as_nop
-
+else case e in #(
+  e)
           { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
-
+         ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
@@ -32311,8 +33228,9 @@ printf "%s\n" "no" >&6; }
 if test "x$ac_cv_have_decl_bind" = xyes
 then :
   ac_have_decl=1
-else $as_nop
-  ac_have_decl=0
+else case e in #(
+  e) ac_have_decl=0 ;;
+esac
 fi
 printf "%s\n" "#define HAVE_DECL_BIND $ac_have_decl" >>confdefs.h
 if test $ac_have_decl = 1
@@ -32323,16 +33241,22 @@ printf %s "checking for bind in -lsocket
 if test ${ac_cv_lib_socket_bind+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lsocket  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char bind ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char bind (void);
 int
 main (void)
 {
@@ -32344,12 +33268,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_socket_bind=yes
-else $as_nop
-  ac_cv_lib_socket_bind=no
+else case e in #(
+  e) ac_cv_lib_socket_bind=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_socket_bind" >&5
 printf "%s\n" "$ac_cv_lib_socket_bind" >&6; }
@@ -32418,16 +33344,22 @@ printf %s "checking for pthread_self in
 if test ${ac_cv_lib_pthread_pthread_self+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lpthread  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char pthread_self ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char pthread_self (void);
 int
 main (void)
 {
@@ -32439,12 +33371,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_pthread_pthread_self=yes
-else $as_nop
-  ac_cv_lib_pthread_pthread_self=no
+else case e in #(
+  e) ac_cv_lib_pthread_pthread_self=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_pthread_pthread_self" >&5
 printf "%s\n" "$ac_cv_lib_pthread_pthread_self" >&6; }
@@ -32526,16 +33460,22 @@ printf %s "checking for numa_available i
 if test ${ac_cv_lib_numa_numa_available+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lnuma  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char numa_available ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char numa_available (void);
 int
 main (void)
 {
@@ -32547,12 +33487,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_numa_numa_available=yes
-else $as_nop
-  ac_cv_lib_numa_numa_available=no
+else case e in #(
+  e) ac_cv_lib_numa_numa_available=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_numa_numa_available" >&5
 printf "%s\n" "$ac_cv_lib_numa_numa_available" >&6; }
@@ -32581,16 +33523,22 @@ printf %s "checking for numa_available i
 if test ${ac_cv_lib_numa_numa_available+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lnuma  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char numa_available ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char numa_available (void);
 int
 main (void)
 {
@@ -32602,12 +33550,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_numa_numa_available=yes
-else $as_nop
-  ac_cv_lib_numa_numa_available=no
+else case e in #(
+  e) ac_cv_lib_numa_numa_available=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_numa_numa_available" >&5
 printf "%s\n" "$ac_cv_lib_numa_numa_available" >&6; }
@@ -32655,13 +33605,15 @@ then :
 if test "x$ac_cv_func_numa_available" = xyes
 then :
   hwloc_result=yes
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
 
-else $as_nop
-  hwloc_result=no
+else case e in #(
+  e) hwloc_result=no ;;
+esac
 fi
 
         CFLAGS=$hwloc_cflags_save
@@ -32677,8 +33629,8 @@ then :
                { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: yes" >&5
 printf "%s\n" "yes" >&6; }
                hwloc_have_linux_libnuma=yes
-else $as_nop
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
+else case e in #(
+  e) { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: no" >&5
 printf "%s\n" "no" >&6; }
 
 			     # libnuma didn't have a .pc before 2.0.12, look for it manually.
@@ -32687,16 +33639,22 @@ printf %s "checking for numa_available i
 if test ${ac_cv_lib_numa_numa_available+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-lnuma  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char numa_available ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char numa_available (void);
 int
 main (void)
 {
@@ -32708,12 +33666,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_numa_numa_available=yes
-else $as_nop
-  ac_cv_lib_numa_numa_available=no
+else case e in #(
+  e) ac_cv_lib_numa_numa_available=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_numa_numa_available" >&5
 printf "%s\n" "$ac_cv_lib_numa_numa_available" >&6; }
@@ -32731,7 +33691,8 @@ then :
 fi
 
 fi
-
+ ;;
+esac
 fi
     fi
 
@@ -32766,16 +33727,22 @@ printf %s "checking for ibv_open_device
 if test ${ac_cv_lib_ibverbs_ibv_open_device+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  ac_check_lib_save_LIBS=$LIBS
+else case e in #(
+  e) ac_check_lib_save_LIBS=$LIBS
 LIBS="-libverbs  $LIBS"
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
 
 /* Override any GCC internal prototype to avoid an error.
    Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-char ibv_open_device ();
+   builtin and then its argument prototype would still apply.
+   The 'extern "C"' is for builds by C++ compilers;
+   although this is not generally supported in C code supporting it here
+   has little cost and some practical benefit (sr 110532).  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char ibv_open_device (void);
 int
 main (void)
 {
@@ -32787,12 +33754,14 @@ _ACEOF
 if ac_fn_c_try_link "$LINENO"
 then :
   ac_cv_lib_ibverbs_ibv_open_device=yes
-else $as_nop
-  ac_cv_lib_ibverbs_ibv_open_device=no
+else case e in #(
+  e) ac_cv_lib_ibverbs_ibv_open_device=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam \
     conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
+LIBS=$ac_check_lib_save_LIBS ;;
+esac
 fi
 { printf "%s\n" "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_ibverbs_ibv_open_device" >&5
 printf "%s\n" "$ac_cv_lib_ibverbs_ibv_open_device" >&6; }
@@ -32821,8 +33790,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_XMLLINT+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$XMLLINT"; then
+else case e in #(
+  e) if test -n "$XMLLINT"; then
   ac_cv_prog_XMLLINT="$XMLLINT" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -32844,7 +33813,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 XMLLINT=$ac_cv_prog_XMLLINT
 if test -n "$XMLLINT"; then
@@ -32869,8 +33839,8 @@ printf %s "checking for $ac_word... " >&
 if test ${ac_cv_prog_BUNZIPP+y}
 then :
   printf %s "(cached) " >&6
-else $as_nop
-  if test -n "$BUNZIPP"; then
+else case e in #(
+  e) if test -n "$BUNZIPP"; then
   ac_cv_prog_BUNZIPP="$BUNZIPP" # Let the user override the test.
 else
 as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
@@ -32892,7 +33862,8 @@ done
   done
 IFS=$as_save_IFS
 
-fi
+fi ;;
+esac
 fi
 BUNZIPP=$ac_cv_prog_BUNZIPP
 if test -n "$BUNZIPP"; then
@@ -32938,8 +33909,9 @@ _ACEOF
 if ac_fn_cxx_try_compile "$LINENO"
 then :
   hwloc_have_cxx=yes
-else $as_nop
-  hwloc_have_cxx=no
+else case e in #(
+  e) hwloc_have_cxx=no ;;
+esac
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.beam conftest.$ac_ext
     ac_ext=c
@@ -33430,8 +34402,8 @@ cat >confcache <<\_ACEOF
 # config.status only pays attention to the cache file if you give it
 # the --recheck option to rerun configure.
 #
-# `ac_cv_env_foo' variables (set or unset) will be overridden when
-# loading this file, other *unset* `ac_cv_foo' will be assigned the
+# 'ac_cv_env_foo' variables (set or unset) will be overridden when
+# loading this file, other *unset* 'ac_cv_foo' will be assigned the
 # following values.
 
 _ACEOF
@@ -33461,14 +34433,14 @@ printf "%s\n" "$as_me: WARNING: cache va
   (set) 2>&1 |
     case $as_nl`(ac_space=' '; set) 2>&1` in #(
     *${as_nl}ac_space=\ *)
-      # `set' does not quote correctly, so add quotes: double-quote
+      # 'set' does not quote correctly, so add quotes: double-quote
       # substitution turns \\\\ into \\, and sed turns \\ into \.
       sed -n \
 	"s/'/'\\\\''/g;
 	  s/^\\([_$as_cr_alnum]*_cv_[_$as_cr_alnum]*\\)=\\(.*\\)/\\1='\\2'/p"
       ;; #(
     *)
-      # `set' quotes correctly as required by POSIX, so do not add quotes.
+      # 'set' quotes correctly as required by POSIX, so do not add quotes.
       sed -n "/^[_$as_cr_alnum]*_cv_[_$as_cr_alnum]*=/p"
       ;;
     esac |
@@ -33790,7 +34762,6 @@ cat >>$CONFIG_STATUS <<\_ASEOF || as_wri
 
 # Be more Bourne compatible
 DUALCASE=1; export DUALCASE # for MKS sh
-as_nop=:
 if test ${ZSH_VERSION+y} && (emulate sh) >/dev/null 2>&1
 then :
   emulate sh
@@ -33799,12 +34770,13 @@ then :
   # is contrary to our usage.  Disable this feature.
   alias -g '${1+"$@"}'='"$@"'
   setopt NO_GLOB_SUBST
-else $as_nop
-  case `(set -o) 2>/dev/null` in #(
+else case e in #(
+  e) case `(set -o) 2>/dev/null` in #(
   *posix*) :
     set -o posix ;; #(
   *) :
      ;;
+esac ;;
 esac
 fi
 
@@ -33876,7 +34848,7 @@ IFS=$as_save_IFS
 
      ;;
 esac
-# We did not find ourselves, most probably we were run as `sh COMMAND'
+# We did not find ourselves, most probably we were run as 'sh COMMAND'
 # in which case we are not to be found in the path.
 if test "x$as_myself" = x; then
   as_myself=$0
@@ -33905,7 +34877,6 @@ as_fn_error ()
 } # as_fn_error
 
 
-
 # as_fn_set_status STATUS
 # -----------------------
 # Set $? to STATUS, without forking.
@@ -33945,11 +34916,12 @@ then :
   {
     eval $1+=\$2
   }'
-else $as_nop
-  as_fn_append ()
+else case e in #(
+  e) as_fn_append ()
   {
     eval $1=\$$1\$2
-  }
+  } ;;
+esac
 fi # as_fn_append
 
 # as_fn_arith ARG...
@@ -33963,11 +34935,12 @@ then :
   {
     as_val=$(( $* ))
   }'
-else $as_nop
-  as_fn_arith ()
+else case e in #(
+  e) as_fn_arith ()
   {
     as_val=`expr "$@" || test $? -eq 1`
-  }
+  } ;;
+esac
 fi # as_fn_arith
 
 
@@ -34050,9 +35023,9 @@ if (echo >conf$$.file) 2>/dev/null; then
   if ln -s conf$$.file conf$$ 2>/dev/null; then
     as_ln_s='ln -s'
     # ... but there are two gotchas:
-    # 1) On MSYS, both `ln -s file dir' and `ln file dir' fail.
-    # 2) DJGPP < 2.04 has no symlinks; `ln -s' creates a wrapper executable.
-    # In both cases, we have to default to `cp -pR'.
+    # 1) On MSYS, both 'ln -s file dir' and 'ln file dir' fail.
+    # 2) DJGPP < 2.04 has no symlinks; 'ln -s' creates a wrapper executable.
+    # In both cases, we have to default to 'cp -pR'.
     ln -s conf$$.file conf$$.dir 2>/dev/null && test ! -f conf$$.exe ||
       as_ln_s='cp -pR'
   elif ln conf$$.file conf$$ 2>/dev/null; then
@@ -34133,10 +35106,12 @@ as_test_x='test -x'
 as_executable_p=as_fn_executable_p
 
 # Sed expression to map a string onto a valid CPP name.
-as_tr_cpp="eval sed 'y%*$as_cr_letters%P$as_cr_LETTERS%;s%[^_$as_cr_alnum]%_%g'"
+as_sed_cpp="y%*$as_cr_letters%P$as_cr_LETTERS%;s%[^_$as_cr_alnum]%_%g"
+as_tr_cpp="eval sed '$as_sed_cpp'" # deprecated
 
 # Sed expression to map a string onto a valid variable name.
-as_tr_sh="eval sed 'y%*+%pp%;s%[^_$as_cr_alnum]%_%g'"
+as_sed_sh="y%*+%pp%;s%[^_$as_cr_alnum]%_%g"
+as_tr_sh="eval sed '$as_sed_sh'" # deprecated
 
 
 exec 6>&1
@@ -34151,8 +35126,8 @@ cat >>$CONFIG_STATUS <<\_ACEOF || ac_wri
 # report actual input values of CONFIG_FILES etc. instead of their
 # values after options handling.
 ac_log="
-This file was extended by hwloc $as_me 2.10.0, which was
-generated by GNU Autoconf 2.71.  Invocation command line was
+This file was extended by hwloc $as_me 2.11.0, which was
+generated by GNU Autoconf 2.72.  Invocation command line was
 
   CONFIG_FILES    = $CONFIG_FILES
   CONFIG_HEADERS  = $CONFIG_HEADERS
@@ -34185,7 +35160,7 @@ _ACEOF
 
 cat >>$CONFIG_STATUS <<\_ACEOF || ac_write_fail=1
 ac_cs_usage="\
-\`$as_me' instantiates files and other configuration actions
+'$as_me' instantiates files and other configuration actions
 from templates according to the current configuration.  Unless the files
 and actions are specified as TAGs, all are instantiated by default.
 
@@ -34223,11 +35198,11 @@ ac_cs_config_escaped=`printf "%s\n" "$ac
 cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
 ac_cs_config='$ac_cs_config_escaped'
 ac_cs_version="\\
-hwloc config.status 2.10.0
-configured by $0, generated by GNU Autoconf 2.71,
+hwloc config.status 2.11.0
+configured by $0, generated by GNU Autoconf 2.72,
   with options \\"\$ac_cs_config\\"
 
-Copyright (C) 2021 Free Software Foundation, Inc.
+Copyright (C) 2023 Free Software Foundation, Inc.
 This config.status script is free software; the Free Software Foundation
 gives unlimited permission to copy, distribute and modify it."
 
@@ -34289,8 +35264,8 @@ do
     ac_need_defaults=false;;
   --he | --h)
     # Conflict between --help and --header
-    as_fn_error $? "ambiguous option: \`$1'
-Try \`$0 --help' for more information.";;
+    as_fn_error $? "ambiguous option: '$1'
+Try '$0 --help' for more information.";;
   --help | --hel | -h )
     printf "%s\n" "$ac_cs_usage"; exit ;;
   -q | -quiet | --quiet | --quie | --qui | --qu | --q \
@@ -34298,8 +35273,8 @@ Try \`$0 --help' for more information.";
     ac_cs_silent=: ;;
 
   # This is an error.
-  -*) as_fn_error $? "unrecognized option: \`$1'
-Try \`$0 --help' for more information." ;;
+  -*) as_fn_error $? "unrecognized option: '$1'
+Try '$0 --help' for more information." ;;
 
   *) as_fn_append ac_config_targets " $1"
      ac_need_defaults=false ;;
@@ -34807,7 +35782,7 @@ do
     "tests/hwloc/ports/lstopo-windows.c") CONFIG_LINKS="$CONFIG_LINKS tests/hwloc/ports/lstopo-windows.c:utils/lstopo/lstopo-windows.c" ;;
     "tests/hwloc/ports/lstopo-android.c") CONFIG_LINKS="$CONFIG_LINKS tests/hwloc/ports/lstopo-android.c:utils/lstopo/lstopo-android.c" ;;
 
-  *) as_fn_error $? "invalid argument: \`$ac_config_target'" "$LINENO" 5;;
+  *) as_fn_error $? "invalid argument: '$ac_config_target'" "$LINENO" 5;;
   esac
 done
 
@@ -34828,7 +35803,7 @@ fi
 # creating and moving files from /tmp can sometimes cause problems.
 # Hook for its removal unless debugging.
 # Note that there is a small window in which the directory will not be cleaned:
-# after its creation but before its name has been assigned to `$tmp'.
+# after its creation but before its name has been assigned to '$tmp'.
 $debug ||
 {
   tmp= ac_tmp=
@@ -34852,7 +35827,7 @@ ac_tmp=$tmp
 
 # Set up the scripts for CONFIG_FILES section.
 # No need to generate them if there are no CONFIG_FILES.
-# This happens for instance with `./config.status config.h'.
+# This happens for instance with './config.status config.h'.
 if test -n "$CONFIG_FILES"; then
 
 
@@ -35010,13 +35985,13 @@ fi # test -n "$CONFIG_FILES"
 
 # Set up the scripts for CONFIG_HEADERS section.
 # No need to generate them if there are no CONFIG_HEADERS.
-# This happens for instance with `./config.status Makefile'.
+# This happens for instance with './config.status Makefile'.
 if test -n "$CONFIG_HEADERS"; then
 cat >"$ac_tmp/defines.awk" <<\_ACAWK ||
 BEGIN {
 _ACEOF
 
-# Transform confdefs.h into an awk script `defines.awk', embedded as
+# Transform confdefs.h into an awk script 'defines.awk', embedded as
 # here-document in config.status, that substitutes the proper values into
 # config.h.in to produce config.h.
 
@@ -35126,7 +36101,7 @@ do
   esac
   case $ac_mode$ac_tag in
   :[FHL]*:*);;
-  :L* | :C*:*) as_fn_error $? "invalid tag \`$ac_tag'" "$LINENO" 5;;
+  :L* | :C*:*) as_fn_error $? "invalid tag '$ac_tag'" "$LINENO" 5;;
   :[FH]-) ac_tag=-:-;;
   :[FH]*) ac_tag=$ac_tag:$ac_tag.in;;
   esac
@@ -35148,19 +36123,19 @@ do
       -) ac_f="$ac_tmp/stdin";;
       *) # Look for the file first in the build tree, then in the source tree
 	 # (if the path is not absolute).  The absolute path cannot be DOS-style,
-	 # because $ac_f cannot contain `:'.
+	 # because $ac_f cannot contain ':'.
 	 test -f "$ac_f" ||
 	   case $ac_f in
 	   [\\/$]*) false;;
 	   *) test -f "$srcdir/$ac_f" && ac_f="$srcdir/$ac_f";;
 	   esac ||
-	   as_fn_error 1 "cannot find input file: \`$ac_f'" "$LINENO" 5;;
+	   as_fn_error 1 "cannot find input file: '$ac_f'" "$LINENO" 5;;
       esac
       case $ac_f in *\'*) ac_f=`printf "%s\n" "$ac_f" | sed "s/'/'\\\\\\\\''/g"`;; esac
       as_fn_append ac_file_inputs " '$ac_f'"
     done
 
-    # Let's still pretend it is `configure' which instantiates (i.e., don't
+    # Let's still pretend it is 'configure' which instantiates (i.e., don't
     # use $as_me), people would be surprised to read:
     #    /* config.h.  Generated by config.status.  */
     configure_input='Generated from '`
@@ -35293,7 +36268,7 @@ cat >>$CONFIG_STATUS <<_ACEOF || ac_writ
 esac
 _ACEOF
 
-# Neutralize VPATH when `$srcdir' = `.'.
+# Neutralize VPATH when '$srcdir' = '.'.
 # Shell code in configure.ac might set extrasub.
 # FIXME: do we really want to maintain this feature?
 cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
@@ -35324,9 +36299,9 @@ test -z "$ac_datarootdir_hack$ac_dataroo
   { ac_out=`sed -n '/\${datarootdir}/p' "$ac_tmp/out"`; test -n "$ac_out"; } &&
   { ac_out=`sed -n '/^[	 ]*datarootdir[	 ]*:*=/p' \
       "$ac_tmp/out"`; test -z "$ac_out"; } &&
-  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: $ac_file contains a reference to the variable \`datarootdir'
+  { printf "%s\n" "$as_me:${as_lineno-$LINENO}: WARNING: $ac_file contains a reference to the variable 'datarootdir'
 which seems to be undefined.  Please make sure it is defined" >&5
-printf "%s\n" "$as_me: WARNING: $ac_file contains a reference to the variable \`datarootdir'
+printf "%s\n" "$as_me: WARNING: $ac_file contains a reference to the variable 'datarootdir'
 which seems to be undefined.  Please make sure it is defined" >&2;}
 
   rm -f "$ac_tmp/stdin"
@@ -35512,15 +36487,15 @@ printf "%s\n" X/"$am_mf" |
    (exit $ac_status); } || am_rc=$?
   done
   if test $am_rc -ne 0; then
-    { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-printf "%s\n" "$as_me: error: in \`$ac_pwd':" >&2;}
+    { { printf "%s\n" "$as_me:${as_lineno-$LINENO}: error: in '$ac_pwd':" >&5
+printf "%s\n" "$as_me: error: in '$ac_pwd':" >&2;}
 as_fn_error $? "Something went wrong bootstrapping makefile fragments
     for automatic dependency tracking.  If GNU make was not used, consider
     re-running the configure script with MAKE=\"gmake\" (or whatever is
     necessary).  You can also try re-running configure with the
     '--disable-dependency-tracking' option to at least be able to build
     the package (albeit without support for automatic dependency tracking).
-See \`config.log' for more details" "$LINENO" 5; }
+See 'config.log' for more details" "$LINENO" 5; }
   fi
   { am_dirpart=; unset am_dirpart;}
   { am_filepart=; unset am_filepart;}
@@ -36331,25 +37306,29 @@ fi
 if test "$enable_embedded_mode" = "yes"
 then :
   hwloc_graphical_lstopo_status="no (disabled in embedded mode)"
-else $as_nop
-  if test "$hwloc_windows" = "yes"
+else case e in #(
+  e) if test "$hwloc_windows" = "yes"
 then :
   hwloc_graphical_lstopo_status="yes (Windows)"
-else $as_nop
-  if test "$hwloc_cairo_happy" = "yes"
+else case e in #(
+  e) if test "$hwloc_cairo_happy" = "yes"
 then :
   if test "$lstopo_have_x11" = "yes"
 then :
   hwloc_graphical_lstopo_status="yes (Cairo)"
-else $as_nop
-  hwloc_graphical_lstopo_status="partial (Cairo, without X11)"
+else case e in #(
+  e) hwloc_graphical_lstopo_status="partial (Cairo, without X11)" ;;
+esac
 fi
-else $as_nop
-  hwloc_graphical_lstopo_status="no"
+else case e in #(
+  e) hwloc_graphical_lstopo_status="no" ;;
+esac
 fi
-
+              ;;
+esac
 fi
-
+       ;;
+esac
 fi
 
 # Prepare the I/O summary
diff -pruN 2.10.0-1/contrib/completion/bash/hwloc 2.11.0-1/contrib/completion/bash/hwloc
--- 2.10.0-1/contrib/completion/bash/hwloc	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/contrib/completion/bash/hwloc	2024-06-17 10:01:23.000000000 +0000
@@ -1,5 +1,5 @@
 #
-# Copyright © 2018-2023 Inria.  All rights reserved.
+# Copyright © 2018-2024 Inria.  All rights reserved.
 # See COPYING in top-level directory.
 #
 
@@ -31,7 +31,7 @@ _lstopo() {
 		   --windows-processor-groups
 		   -c --cpuset
 		   -C --cpuset-only
-		   --taskset
+		   --cpuset-output-format --cof
 		   --filter --ignore
 		   --no-caches
 		   --no-useless-caches
@@ -146,6 +146,9 @@ _lstopo() {
 	    --distances-transform)
 	        COMPREPLY=( `compgen -W "links merge-switch-ports transitive-closure" -- "$cur"` )
 		;;
+	    --cpuset-output-format | --cof)
+	        COMPREPLY=( "hwloc" "list" taskset" )
+		;;
 	esac
     fi
 }
@@ -162,6 +165,7 @@ _hwloc_info(){
 		   --support
 		   -v --verbose
 		   -q --quiet -s --silent
+		   --get-attr
 		   --ancestors
 		   --ancestor
 		   --children
@@ -226,6 +230,9 @@ _hwloc_info(){
 	    --best-memattr)
 		COMPREPLY=( "<memattr>" "" )
 		;;
+	    --get-attr)
+		COMPREPLY=( "<name>" "" )
+		;;
 	esac
     fi
 }
@@ -246,7 +253,7 @@ _hwloc_bind(){
 		   --nodeset
 		   --pid
 		   --tid
-		   --taskset
+		   --cpuset-output-format --cof
 		   --restrict
 		   --restrict-flags
 		   --disallowed --whole-system
@@ -284,6 +291,9 @@ _hwloc_bind(){
 	    --best-memattr)
 		COMPREPLY=( "<memattr>" "" )
 		;;
+	    --cpuset-output-format | --cof)
+	        COMPREPLY=( "hwloc" "list" taskset" )
+		;;
 	esac
     fi
 }
@@ -310,7 +320,7 @@ _hwloc_calc(){
 		   --no --nodeset-output
                    --oo --object-output
 		   --sep
-		   --taskset
+		   --cpuset-input-format --cif --cpuset-output-format --cof
 		   --single
 		   --restrict
 		   --restrict-flags
@@ -361,6 +371,9 @@ _hwloc_calc(){
 	    --cpukind)
 		COMPREPLY=( "<name>=<value>" "<n>" "" )
 		;;
+	    --cpuset-input-format | --cif | --cpuset-output-format | --cof)
+	        COMPREPLY=( "hwloc" "list" taskset" )
+		;;
 	esac
     fi
 }
@@ -446,7 +459,7 @@ _hwloc_distrib(){
 		   --input -i
 		   --input-format --if
 		   --single
-		   --taskset
+		   --cpuset-output-format --cof
 		   -v --verbose
 		   --version
 		   -h --help
@@ -473,6 +486,9 @@ _hwloc_distrib(){
 	    --restrict-flags)
 		COMPREPLY=( "<integer>" "" )
 		;;
+	    --cpuset-output-format | --cof)
+	        COMPREPLY=( "hwloc" "list" taskset" )
+		;;
 	esac
     fi
 }
diff -pruN 2.10.0-1/contrib/windows/hwloc_config.h 2.11.0-1/contrib/windows/hwloc_config.h
--- 2.10.0-1/contrib/windows/hwloc_config.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/contrib/windows/hwloc_config.h	2024-06-25 12:41:50.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2012 Université Bordeaux
  * Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -11,9 +11,9 @@
 #ifndef HWLOC_CONFIG_H
 #define HWLOC_CONFIG_H
 
-#define HWLOC_VERSION "2.10.0"
+#define HWLOC_VERSION "2.11.0"
 #define HWLOC_VERSION_MAJOR 2
-#define HWLOC_VERSION_MINOR 10
+#define HWLOC_VERSION_MINOR 11
 #define HWLOC_VERSION_RELEASE 0
 #define HWLOC_VERSION_GREEK ""
 
diff -pruN 2.10.0-1/contrib/windows-cmake/CMakeLists.txt 2.11.0-1/contrib/windows-cmake/CMakeLists.txt
--- 2.10.0-1/contrib/windows-cmake/CMakeLists.txt	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/contrib/windows-cmake/CMakeLists.txt	2024-06-25 12:41:50.000000000 +0000
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.15)
 project(hwloc
     LANGUAGES C
-    VERSION 2.10.0)
+    VERSION 2.11.0)
 
 enable_testing()
 
diff -pruN 2.10.0-1/contrib/windows-cmake/static-components.h.in 2.11.0-1/contrib/windows-cmake/static-components.h.in
--- 2.10.0-1/contrib/windows-cmake/static-components.h.in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/contrib/windows-cmake/static-components.h.in	2024-06-17 10:01:23.000000000 +0000
@@ -12,6 +12,9 @@ HWLOC_DECLSPEC extern const struct hwloc
 #ifdef HWLOC_HAVE_OPENCL
 HWLOC_DECLSPEC extern const struct hwloc_component hwloc_opencl_component;
 #endif
+#ifdef HWLOC_HAVE_CUDART
+HWLOC_DECLSPEC extern const struct hwloc_component hwloc_cuda_component;
+#endif
 
 static const struct hwloc_component * hwloc_static_components[] = {
   &hwloc_noos_component,
@@ -25,6 +28,9 @@ static const struct hwloc_component * hw
 #ifdef HWLOC_HAVE_OPENCL
   &hwloc_opencl_component,
 #endif
+#ifdef HWLOC_HAVE_CUDART
+  &hwloc_cuda_component,
+#endif
 #ifdef HWLOC_HAVE_LIBXML2
   &hwloc_xml_libxml_component,
 #endif
diff -pruN 2.10.0-1/contrib/windows-cmake/tests/CMakeLists.txt 2.11.0-1/contrib/windows-cmake/tests/CMakeLists.txt
--- 2.10.0-1/contrib/windows-cmake/tests/CMakeLists.txt	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/contrib/windows-cmake/tests/CMakeLists.txt	2024-06-17 10:01:23.000000000 +0000
@@ -52,7 +52,7 @@ TIMEOUT 10
 # --- optional tests
 
 if(HWLOC_HAVE_OPENCL)
-  add_executable(test_opencl opencl.c)
+  add_executable(test_opencl ${TOPDIR}/tests/hwloc/opencl.c)
   target_link_libraries(test_opencl PRIVATE hwloc OpenCL::OpenCL)
 
   add_test(NAME OpenCL COMMAND test_opencl)
@@ -60,7 +60,7 @@ if(HWLOC_HAVE_OPENCL)
 endif()
 
 if(HAVE_CUDA)
-  add_executable(test_cuda cuda.c)
+  add_executable(test_cuda ${TOPDIR}/tests/hwloc/cuda.c)
   target_link_libraries(test_cuda PRIVATE hwloc CUDA::cudart CUDA::cuda_driver)
 
   add_test(NAME CUDA COMMAND test_cuda)
diff -pruN 2.10.0-1/debian/changelog 2.11.0-1/debian/changelog
--- 2.10.0-1/debian/changelog	2023-12-05 12:32:39.000000000 +0000
+++ 2.11.0-1/debian/changelog	2024-06-25 19:56:11.000000000 +0000
@@ -1,3 +1,17 @@
+hwloc-contrib (2.11.0-1) unstable; urgency=medium
+
+  * New upstream release.
+
+ -- Samuel Thibault <sthibault@debian.org>  Tue, 25 Jun 2024 21:56:11 +0200
+
+hwloc-contrib (2.11.0~rc1-1) experimental; urgency=medium
+
+  * New upstream RC release.
+  * watch: Track 2.11.
+  * control: Replace pkg-config build-dep with pkgconf.
+
+ -- Samuel Thibault <sthibault@debian.org>  Mon, 17 Jun 2024 14:56:52 +0200
+
 hwloc-contrib (2.10.0-1) unstable; urgency=medium
 
   * New upstream release.
diff -pruN 2.10.0-1/debian/control 2.11.0-1/debian/control
--- 2.10.0-1/debian/control	2023-12-05 12:32:39.000000000 +0000
+++ 2.11.0-1/debian/control	2024-06-25 19:56:11.000000000 +0000
@@ -11,7 +11,7 @@ Build-Depends: debhelper-compat (= 12),
   libxnvctrl-dev <!pkg.hwloc.minimum>,
   nvidia-cuda-dev <!pkg.hwloc.minimum>,
   libpciaccess-dev <!pkg.hwloc.minimum>, libudev-dev [linux-any] <!pkg.hwloc.minimum>,
-  pkg-config,
+  pkgconf,
   ocl-icd-opencl-dev [!hurd-any] <!pkg.hwloc.minimum> | opencl-dev <!pkg.hwloc.minimum>, opencl-headers <!pkg.hwloc.minimum>,
   autoconf (>= 2.63),
 # w3m, if we ever need to update README
diff -pruN 2.10.0-1/debian/watch 2.11.0-1/debian/watch
--- 2.10.0-1/debian/watch	2023-12-05 12:32:39.000000000 +0000
+++ 2.11.0-1/debian/watch	2024-06-25 19:56:11.000000000 +0000
@@ -1,4 +1,4 @@
 version=3
 opts=dversionmangle=s/\+dfsg\d*$//,uversionmangle=s/(\d)(rc\d*)$/$1~$2/ \
-https://www.open-mpi.org/software/hwloc/v2.10 \
-https://download.open-mpi.org/release/hwloc/v2.10/hwloc(?:[_\-]v?|)@ANY_VERSION@@ARCHIVE_EXT@
+https://www.open-mpi.org/software/hwloc/v2.11 \
+https://download.open-mpi.org/release/hwloc/v2.11/hwloc(?:[_\-]v?|)@ANY_VERSION@@ARCHIVE_EXT@
diff -pruN 2.10.0-1/doc/Makefile.am 2.11.0-1/doc/Makefile.am
--- 2.10.0-1/doc/Makefile.am	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/doc/Makefile.am	2024-06-25 12:38:31.000000000 +0000
@@ -1,4 +1,4 @@
-# Copyright © 2009-2021 Inria.  All rights reserved.
+# Copyright © 2009-2024 Inria.  All rights reserved.
 # Copyright © 2009-2013, 2021 Université Bordeaux
 # Copyright © 2009-2016 Cisco Systems, Inc.  All rights reserved.
 # See COPYING in top-level directory.
@@ -26,7 +26,7 @@ DOX_TAG = $(DOX_DIR)/$(PACKAGE).tag
 #
 
 # images already available in repository
-PREBUILT_IMAGES = images/dudley.png images/emmett.png images/hagrid.png \
+PREBUILT_IMAGES = images/dudley.png images/emmett.png images/hagrid.png images/heteromem.png \
         images/ppc64-with-smt.png images/ppc64-without-smt.png images/ppc64-full-with-smt.png \
         images/devel09-pci.png
 # images built from repository before inclusion in make dist
@@ -350,7 +350,8 @@ man3_object_info_attrsdir = $(man3dir)
 man3_object_info_attrs_DATA = \
         $(DOX_MAN_DIR)/man3/hwlocality_info_attr.3 \
         $(DOX_MAN_DIR)/man3/hwloc_obj_get_info_by_name.3 \
-        $(DOX_MAN_DIR)/man3/hwloc_obj_add_info.3
+        $(DOX_MAN_DIR)/man3/hwloc_obj_add_info.3 \
+        $(DOX_MAN_DIR)/man3/hwloc_obj_set_subtype.3
 
 man3_cpubindingdir = $(man3dir)
 man3_cpubinding_DATA = \
@@ -376,6 +377,7 @@ man3_membinding_DATA = \
         $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_DEFAULT.3 \
         $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_FIRSTTOUCH.3 \
         $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_INTERLEAVE.3 \
+        $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_WEIGHTED_INTERLEAVE.3 \
         $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_MIGRATE.3 \
         $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_MIXED.3 \
         $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_NEXTTOUCH.3 \
diff -pruN 2.10.0-1/doc/Makefile.in 2.11.0-1/doc/Makefile.in
--- 2.10.0-1/doc/Makefile.in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/doc/Makefile.in	2024-06-25 12:41:55.000000000 +0000
@@ -14,7 +14,7 @@
 
 @SET_MAKE@
 
-# Copyright © 2009-2021 Inria.  All rights reserved.
+# Copyright © 2009-2024 Inria.  All rights reserved.
 # Copyright © 2009-2013, 2021 Université Bordeaux
 # Copyright © 2009-2016 Cisco Systems, Inc.  All rights reserved.
 # See COPYING in top-level directory.
@@ -518,7 +518,7 @@ DOX_TAG = $(DOX_DIR)/$(PACKAGE).tag
 #
 
 # images already available in repository
-PREBUILT_IMAGES = images/dudley.png images/emmett.png images/hagrid.png \
+PREBUILT_IMAGES = images/dudley.png images/emmett.png images/hagrid.png images/heteromem.png \
         images/ppc64-with-smt.png images/ppc64-without-smt.png images/ppc64-full-with-smt.png \
         images/devel09-pci.png
 
@@ -727,7 +727,8 @@ EXTRA_DIST = \
 @HWLOC_INSTALL_DOXYGEN_TRUE@man3_object_info_attrs_DATA = \
 @HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/hwlocality_info_attr.3 \
 @HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/hwloc_obj_get_info_by_name.3 \
-@HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/hwloc_obj_add_info.3
+@HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/hwloc_obj_add_info.3 \
+@HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/hwloc_obj_set_subtype.3
 
 @HWLOC_INSTALL_DOXYGEN_TRUE@man3_cpubindingdir = $(man3dir)
 @HWLOC_INSTALL_DOXYGEN_TRUE@man3_cpubinding_DATA = \
@@ -753,6 +754,7 @@ EXTRA_DIST = \
 @HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_DEFAULT.3 \
 @HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_FIRSTTOUCH.3 \
 @HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_INTERLEAVE.3 \
+@HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_WEIGHTED_INTERLEAVE.3 \
 @HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_MIGRATE.3 \
 @HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_MIXED.3 \
 @HWLOC_INSTALL_DOXYGEN_TRUE@        $(DOX_MAN_DIR)/man3/HWLOC_MEMBIND_NEXTTOUCH.3 \
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00104_source.html 2.11.0-1/doc/doxygen-doc/html/a00104_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00104_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00104_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,1024 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">hwloc.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2009 CNRS</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2009-2024 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * Copyright © 2009-2012 Université Bordeaux</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * Copyright © 2009-2020 Cisco Systems, Inc.  All rights reserved.</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span> </div>
+<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment">/*=====================================================================</span></div>
+<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *                 PLEASE GO READ THE DOCUMENTATION!</span></div>
+<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment"> *         ------------------------------------------------</span></div>
+<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment"> *               $tarball_directory/doc/doxygen-doc/</span></div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment"> *                                or</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment"> *           https://www.open-mpi.org/projects/hwloc/doc/</span></div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="comment"> *=====================================================================</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="comment"> *</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="comment"> * FAIR WARNING: Do NOT expect to be able to figure out all the</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="comment"> * subtleties of hwloc by simply reading function prototypes and</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="comment"> * constant descrptions here in this file.</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="comment"> *</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="comment"> * Hwloc has wonderful documentation in both PDF and HTML formats for</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="comment"> * your reading pleasure.  The formal documentation explains a LOT of</span></div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="comment"> * hwloc-specific concepts, provides definitions, and discusses the</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="comment"> * &quot;big picture&quot; for many of the things that you&#39;ll find here in this</span></div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="comment"> * header file.</span></div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span><span class="comment"> *</span></div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="comment"> * The PDF/HTML documentation was generated via Doxygen; much of what</span></div>
+<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span><span class="comment"> * you&#39;ll see in there is also here in this file.  BUT THERE IS A LOT</span></div>
+<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span><span class="comment"> * THAT IS IN THE PDF/HTML THAT IS ***NOT*** IN hwloc.h!</span></div>
+<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span><span class="comment"> *</span></div>
+<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span><span class="comment"> * There are entire paragraph-length descriptions, discussions, and</span></div>
+<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span><span class="comment"> * pretty pictures to explain subtle corner cases, provide concrete</span></div>
+<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span><span class="comment"> * examples, etc.</span></div>
+<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span><span class="comment"> *</span></div>
+<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span><span class="comment"> * Please, go read the documentation.  :-)</span></div>
+<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span><span class="comment"> *</span></div>
+<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span><span class="comment"> * Moreover there are several examples of hwloc use under doc/examples</span></div>
+<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span><span class="comment"> * in the source tree.</span></div>
+<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span><span class="comment"> *</span></div>
+<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span><span class="comment"> *=====================================================================*/</span></div>
+<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span> </div>
+<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span><span class="preprocessor">#ifndef HWLOC_H</span></div>
+<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span><span class="preprocessor">#define HWLOC_H</span></div>
+<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span> </div>
+<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span><span class="preprocessor">#include &quot;hwloc/autogen/config.h&quot;</span></div>
+<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span> </div>
+<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span><span class="preprocessor">#include &lt;sys/types.h&gt;</span></div>
+<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span><span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
+<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span><span class="preprocessor">#include &lt;string.h&gt;</span></div>
+<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span><span class="preprocessor">#include &lt;limits.h&gt;</span></div>
+<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span> </div>
+<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span><span class="comment"> * Symbol transforms</span></div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span><span class="preprocessor">#include &quot;hwloc/rename.h&quot;</span></div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span> </div>
+<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span><span class="comment"> * Bitmap definitions</span></div>
+<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span> </div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span><span class="preprocessor">#include &quot;hwloc/bitmap.h&quot;</span></div>
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span> </div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span> </div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span> </div>
+<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno"><a class="line" href="a00171.html#ga8f4dfb8eef138af55dd1a0fa802e5476">  115</a></span><span class="preprocessor">#define HWLOC_API_VERSION 0x00020b00</span></div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span> </div>
+<div class="line"><a id="l00123" name="l00123"></a><span class="lineno"><a class="line" href="a00171.html#ga9c0b50c98add1adf57ed1ce85bb5190d">  123</a></span>HWLOC_DECLSPEC <span class="keywordtype">unsigned</span> <a class="code hl_function" href="a00171.html#ga9c0b50c98add1adf57ed1ce85bb5190d">hwloc_get_api_version</a>(<span class="keywordtype">void</span>);</div>
+<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span> </div>
+<div class="line"><a id="l00126" name="l00126"></a><span class="lineno"><a class="line" href="a00171.html#gaac5bc1f46f55e10ef0141a68ce70e21f">  126</a></span><span class="preprocessor">#define HWLOC_COMPONENT_ABI 7</span></div>
+<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span> </div>
+<div class="line"><a id="l00161" name="l00161"></a><span class="lineno"><a class="line" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">  161</a></span><span class="keyword">typedef</span> <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>;</div>
+<div class="line"><a id="l00163" name="l00163"></a><span class="lineno"><a class="line" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">  163</a></span><span class="keyword">typedef</span> <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>;</div>
+<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span> </div>
+<div class="line"><a id="l00178" name="l00178"></a><span class="lineno"><a class="line" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">  178</a></span><span class="keyword">typedef</span> <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> <a class="code hl_typedef" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a>;</div>
+<div class="line"><a id="l00181" name="l00181"></a><span class="lineno"><a class="line" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">  181</a></span><span class="keyword">typedef</span> <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> <a class="code hl_typedef" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a>;</div>
+<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span> </div>
+<div class="foldopen" id="foldopen00197" data-start="{" data-end="};">
+<div class="line"><a id="l00197" name="l00197"></a><span class="lineno"><a class="line" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">  197</a></span><span class="keyword">typedef</span> <span class="keyword">enum</span> {</div>
+<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span> </div>
+<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span><span class="preprocessor">#define HWLOC_OBJ_TYPE_MIN HWLOC_OBJ_MACHINE </span><span class="comment">/* Sentinel value */</span><span class="preprocessor"></span></div>
+<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a3f4e83ffc4a259354959ae8a9eaa2a80">HWLOC_OBJ_MACHINE</a>,    </div>
+<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ab16ab8c0dbffc234921d86f3dfb63129">HWLOC_OBJ_PACKAGE</a>,    </div>
+<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ac793958f330bca371aa1535de8aff45f">HWLOC_OBJ_CORE</a>,       </div>
+<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661">HWLOC_OBJ_PU</a>,         </div>
+<div class="line"><a id="l00234" name="l00234"></a><span class="lineno"><a class="line" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a56389b8eb2e2f74f288bb657c4e72140">  234</a></span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a56389b8eb2e2f74f288bb657c4e72140">HWLOC_OBJ_L1CACHE</a>,    </div>
+<div class="line"><a id="l00235" name="l00235"></a><span class="lineno"><a class="line" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a18f61d19fe9f4bcea978fcc68bc078fb">  235</a></span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a18f61d19fe9f4bcea978fcc68bc078fb">HWLOC_OBJ_L2CACHE</a>,    </div>
+<div class="line"><a id="l00236" name="l00236"></a><span class="lineno"><a class="line" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a25fae0e0514c90e3973a29866a5a837d">  236</a></span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a25fae0e0514c90e3973a29866a5a837d">HWLOC_OBJ_L3CACHE</a>,    </div>
+<div class="line"><a id="l00237" name="l00237"></a><span class="lineno"><a class="line" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a54923bfa13df9d7e6d6dd0d5baff5f72">  237</a></span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a54923bfa13df9d7e6d6dd0d5baff5f72">HWLOC_OBJ_L4CACHE</a>,    </div>
+<div class="line"><a id="l00238" name="l00238"></a><span class="lineno"><a class="line" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a67194c9de5e3e581c64c11d2eb1c109d">  238</a></span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a67194c9de5e3e581c64c11d2eb1c109d">HWLOC_OBJ_L5CACHE</a>,    </div>
+<div class="line"><a id="l00240" name="l00240"></a><span class="lineno"><a class="line" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55afa834a85d9e53836cf0db6d0bd8329b4">  240</a></span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55afa834a85d9e53836cf0db6d0bd8329b4">HWLOC_OBJ_L1ICACHE</a>,   </div>
+<div class="line"><a id="l00241" name="l00241"></a><span class="lineno"><a class="line" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a10713b7e561b8cc32544cd31b1c17f8d">  241</a></span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a10713b7e561b8cc32544cd31b1c17f8d">HWLOC_OBJ_L2ICACHE</a>,   </div>
+<div class="line"><a id="l00242" name="l00242"></a><span class="lineno"><a class="line" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ac22850c717f07bf7ffb316fadd08d218">  242</a></span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ac22850c717f07bf7ffb316fadd08d218">HWLOC_OBJ_L3ICACHE</a>,   </div>
+<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56">HWLOC_OBJ_GROUP</a>,      </div>
+<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>,   </div>
+<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0">HWLOC_OBJ_BRIDGE</a>,     </div>
+<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a>, </div>
+<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075">HWLOC_OBJ_OS_DEVICE</a>,  </div>
+<div class="line"><a id="l00316" name="l00316"></a><span class="lineno">  316</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d">HWLOC_OBJ_MISC</a>,       </div>
+<div class="line"><a id="l00331" name="l00331"></a><span class="lineno">  331</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a0ed5bd98974729a0c476c39e917dabd6">HWLOC_OBJ_MEMCACHE</a>,   </div>
+<div class="line"><a id="l00344" name="l00344"></a><span class="lineno">  344</span>  <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55af78bb6cde53aaaaa162a7dc420c409da">HWLOC_OBJ_DIE</a>,        </div>
+<div class="line"><a id="l00354" name="l00354"></a><span class="lineno">  354</span>  HWLOC_OBJ_TYPE_MAX    </div>
+<div class="line"><a id="l00355" name="l00355"></a><span class="lineno">  355</span>} <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>;</div>
+</div>
+<div class="line"><a id="l00356" name="l00356"></a><span class="lineno">  356</span> </div>
+<div class="foldopen" id="foldopen00358" data-start="{" data-end="};">
+<div class="line"><a id="l00358" name="l00358"></a><span class="lineno"><a class="line" href="a00173.html#ga791c9875c8fe20f3e1e5871e0657e59b">  358</a></span><span class="keyword">typedef</span> <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00173.html#ga791c9875c8fe20f3e1e5871e0657e59b">hwloc_obj_cache_type_e</a> {</div>
+<div class="line"><a id="l00359" name="l00359"></a><span class="lineno"><a class="line" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a">  359</a></span>  <a class="code hl_enumvalue" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a">HWLOC_OBJ_CACHE_UNIFIED</a>,      </div>
+<div class="line"><a id="l00360" name="l00360"></a><span class="lineno"><a class="line" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59bacac60ecad4206f85aeb79bef1604b488">  360</a></span>  <a class="code hl_enumvalue" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59bacac60ecad4206f85aeb79bef1604b488">HWLOC_OBJ_CACHE_DATA</a>,         </div>
+<div class="line"><a id="l00361" name="l00361"></a><span class="lineno">  361</span>  <a class="code hl_enumvalue" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba6f98b0d422b38ba90c5f5c79a11b0658">HWLOC_OBJ_CACHE_INSTRUCTION</a>   </div>
+<div class="line"><a id="l00362" name="l00362"></a><span class="lineno"><a class="line" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba6f98b0d422b38ba90c5f5c79a11b0658">  362</a></span>} <a class="code hl_typedef" href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a>;</div>
+</div>
+<div class="line"><a id="l00363" name="l00363"></a><span class="lineno">  363</span> </div>
+<div class="foldopen" id="foldopen00365" data-start="{" data-end="};">
+<div class="line"><a id="l00365" name="l00365"></a><span class="lineno"><a class="line" href="a00173.html#ga48a4803c72574191d7ead1c62aaf9860">  365</a></span><span class="keyword">typedef</span> <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00173.html#ga48a4803c72574191d7ead1c62aaf9860">hwloc_obj_bridge_type_e</a> {</div>
+<div class="line"><a id="l00366" name="l00366"></a><span class="lineno"><a class="line" href="a00173.html#gga48a4803c72574191d7ead1c62aaf9860a2c7660f3864ad2810c1e72aad285e574">  366</a></span>  <a class="code hl_enumvalue" href="a00173.html#gga48a4803c72574191d7ead1c62aaf9860a2c7660f3864ad2810c1e72aad285e574">HWLOC_OBJ_BRIDGE_HOST</a>,        </div>
+<div class="line"><a id="l00367" name="l00367"></a><span class="lineno">  367</span>  <a class="code hl_enumvalue" href="a00173.html#gga48a4803c72574191d7ead1c62aaf9860a8f3b4cecf3dab6073d74696d10863c60">HWLOC_OBJ_BRIDGE_PCI</a>          </div>
+<div class="line"><a id="l00368" name="l00368"></a><span class="lineno"><a class="line" href="a00173.html#gga48a4803c72574191d7ead1c62aaf9860a8f3b4cecf3dab6073d74696d10863c60">  368</a></span>} <a class="code hl_typedef" href="a00173.html#gab34362c7a23296c3f12c5756747abda3">hwloc_obj_bridge_type_t</a>;</div>
+</div>
+<div class="line"><a id="l00369" name="l00369"></a><span class="lineno">  369</span> </div>
+<div class="foldopen" id="foldopen00371" data-start="{" data-end="};">
+<div class="line"><a id="l00371" name="l00371"></a><span class="lineno"><a class="line" href="a00173.html#ga64f5d539df299c97ae80ce53fc4b56c0">  371</a></span><span class="keyword">typedef</span> <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00173.html#ga64f5d539df299c97ae80ce53fc4b56c0">hwloc_obj_osdev_type_e</a> {</div>
+<div class="line"><a id="l00372" name="l00372"></a><span class="lineno">  372</span>  <a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a689b0488c3c0d08d116751c6b9cb8871">HWLOC_OBJ_OSDEV_BLOCK</a>,        </div>
+<div class="line"><a id="l00374" name="l00374"></a><span class="lineno">  374</span>  <a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90">HWLOC_OBJ_OSDEV_GPU</a>,          </div>
+<div class="line"><a id="l00377" name="l00377"></a><span class="lineno">  377</span>  <a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0ab715d81155f771573c8682dffc65021b">HWLOC_OBJ_OSDEV_NETWORK</a>,      </div>
+<div class="line"><a id="l00379" name="l00379"></a><span class="lineno">  379</span>  <a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a52157d03694fdae82dddd57ca8c973b6">HWLOC_OBJ_OSDEV_OPENFABRICS</a>,  </div>
+<div class="line"><a id="l00383" name="l00383"></a><span class="lineno">  383</span>  <a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a827ad1643360711a8b6c6af671366791">HWLOC_OBJ_OSDEV_DMA</a>,          </div>
+<div class="line"><a id="l00385" name="l00385"></a><span class="lineno">  385</span>  <a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83">HWLOC_OBJ_OSDEV_COPROC</a>        </div>
+<div class="line"><a id="l00388" name="l00388"></a><span class="lineno"><a class="line" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83">  388</a></span>} <a class="code hl_typedef" href="a00173.html#gaa9a6941ef7b1c169412518d7ef71b3d2">hwloc_obj_osdev_type_t</a>;</div>
+</div>
+<div class="line"><a id="l00389" name="l00389"></a><span class="lineno">  389</span> </div>
+<div class="line"><a id="l00412" name="l00412"></a><span class="lineno"><a class="line" href="a00173.html#ga1820ea0dfd8e9dca28f9ea7624df5ae2">  412</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00173.html#ga1820ea0dfd8e9dca28f9ea7624df5ae2">hwloc_compare_types</a> (<a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type1, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type2) __hwloc_attribute_const;</div>
+<div class="line"><a id="l00413" name="l00413"></a><span class="lineno">  413</span> </div>
+<div class="line"><a id="l00415" name="l00415"></a><span class="lineno"><a class="line" href="a00173.html#ga3b6e4128e9fe773863b123fa6e4a080b">  415</a></span><span class="preprocessor">#define HWLOC_TYPE_UNORDERED INT_MAX</span></div>
+<div class="line"><a id="l00416" name="l00416"></a><span class="lineno">  416</span> </div>
+<div class="line"><a id="l00425" name="l00425"></a><span class="lineno">  425</span><span class="keyword">union </span><a class="code hl_union" href="a00233.html">hwloc_obj_attr_u</a>;</div>
+<div class="line"><a id="l00426" name="l00426"></a><span class="lineno">  426</span> </div>
+<div class="foldopen" id="foldopen00431" data-start="{" data-end="};">
+<div class="line"><a id="l00431" name="l00431"></a><span class="lineno"><a class="line" href="a00229.html">  431</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> {</div>
+<div class="line"><a id="l00432" name="l00432"></a><span class="lineno">  432</span>  <span class="comment">/* physical information */</span></div>
+<div class="line"><a id="l00433" name="l00433"></a><span class="lineno"><a class="line" href="a00229.html#acc4f0803f244867e68fe0036800be5de">  433</a></span>  <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> <a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>;                </div>
+<div class="line"><a id="l00434" name="l00434"></a><span class="lineno"><a class="line" href="a00229.html#a5d4f97e76723a9ec8d38046f19e00d33">  434</a></span>  <span class="keywordtype">char</span> *<a class="code hl_variable" href="a00229.html#a5d4f97e76723a9ec8d38046f19e00d33">subtype</a>;                        </div>
+<div class="line"><a id="l00436" name="l00436"></a><span class="lineno"><a class="line" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">  436</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>;                    </div>
+<div class="line"><a id="l00441" name="l00441"></a><span class="lineno">  441</span><span class="preprocessor">#define HWLOC_UNKNOWN_INDEX (unsigned)-1</span></div>
+<div class="line"><a id="l00442" name="l00442"></a><span class="lineno">  442</span> </div>
+<div class="line"><a id="l00443" name="l00443"></a><span class="lineno"><a class="line" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">  443</a></span>  <span class="keywordtype">char</span> *<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>;                           </div>
+<div class="line"><a id="l00448" name="l00448"></a><span class="lineno"><a class="line" href="a00229.html#a75603fc36c9284ba48ce814b772a58b6">  448</a></span>  hwloc_uint64_t <a class="code hl_variable" href="a00229.html#a75603fc36c9284ba48ce814b772a58b6">total_memory</a>; </div>
+<div class="line"><a id="l00450" name="l00450"></a><span class="lineno"><a class="line" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">  450</a></span>  <span class="keyword">union </span><a class="code hl_union" href="a00233.html">hwloc_obj_attr_u</a> *<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>;         </div>
+<div class="line"><a id="l00453" name="l00453"></a><span class="lineno">  453</span>  <span class="comment">/* global position */</span></div>
+<div class="line"><a id="l00454" name="l00454"></a><span class="lineno"><a class="line" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">  454</a></span>  <span class="keywordtype">int</span> <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>;                            </div>
+<div class="line"><a id="l00469" name="l00469"></a><span class="lineno"><a class="line" href="a00229.html#a0d07fb7b8935e137c94d75a3eb492ae9">  469</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#a0d07fb7b8935e137c94d75a3eb492ae9">logical_index</a>;               </div>
+<div class="line"><a id="l00476" name="l00476"></a><span class="lineno">  476</span>  <span class="comment">/* cousins are all objects of the same type (and depth) across the entire topology */</span></div>
+<div class="line"><a id="l00477" name="l00477"></a><span class="lineno"><a class="line" href="a00229.html#a85a788017457129589318b6c39451acf">  477</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> *<a class="code hl_variable" href="a00229.html#a85a788017457129589318b6c39451acf">next_cousin</a>;        </div>
+<div class="line"><a id="l00478" name="l00478"></a><span class="lineno"><a class="line" href="a00229.html#ac715989f55ff5a0eb6be2969ee477ec0">  478</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> *<a class="code hl_variable" href="a00229.html#ac715989f55ff5a0eb6be2969ee477ec0">prev_cousin</a>;        </div>
+<div class="line"><a id="l00480" name="l00480"></a><span class="lineno">  480</span>  <span class="comment">/* children of the same parent are siblings, even if they may have different type and depth */</span></div>
+<div class="line"><a id="l00481" name="l00481"></a><span class="lineno"><a class="line" href="a00229.html#adc494f6aed939992be1c55cca5822900">  481</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> *<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;             </div>
+<div class="line"><a id="l00482" name="l00482"></a><span class="lineno"><a class="line" href="a00229.html#aaa6043eee6f55869933c1d974efd9acd">  482</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#aaa6043eee6f55869933c1d974efd9acd">sibling_rank</a>;                </div>
+<div class="line"><a id="l00483" name="l00483"></a><span class="lineno"><a class="line" href="a00229.html#a7f2343ed476fe4942e6fffd4cade1b40">  483</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> *<a class="code hl_variable" href="a00229.html#a7f2343ed476fe4942e6fffd4cade1b40">next_sibling</a>;       </div>
+<div class="line"><a id="l00484" name="l00484"></a><span class="lineno"><a class="line" href="a00229.html#a7b89e8c189876c0158a9282aaaf17f50">  484</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> *<a class="code hl_variable" href="a00229.html#a7b89e8c189876c0158a9282aaaf17f50">prev_sibling</a>;       </div>
+<div class="line"><a id="l00487" name="l00487"></a><span class="lineno"><a class="line" href="a00229.html#aac3f6da35c9b57599909a44ce2b716c1">  487</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#aac3f6da35c9b57599909a44ce2b716c1">arity</a>;                       </div>
+<div class="line"><a id="l00491" name="l00491"></a><span class="lineno"><a class="line" href="a00229.html#a04d05403da37bfe17cd63b7c7dd07b1f">  491</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> **<a class="code hl_variable" href="a00229.html#a04d05403da37bfe17cd63b7c7dd07b1f">children</a>;          </div>
+<div class="line"><a id="l00492" name="l00492"></a><span class="lineno"><a class="line" href="a00229.html#af51d08a0a79dba517c06c5afedc8d2dc">  492</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> *<a class="code hl_variable" href="a00229.html#af51d08a0a79dba517c06c5afedc8d2dc">first_child</a>;        </div>
+<div class="line"><a id="l00493" name="l00493"></a><span class="lineno"><a class="line" href="a00229.html#a84bd65634dbc55f4158b74443a9bd04f">  493</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> *<a class="code hl_variable" href="a00229.html#a84bd65634dbc55f4158b74443a9bd04f">last_child</a>;         </div>
+<div class="line"><a id="l00496" name="l00496"></a><span class="lineno"><a class="line" href="a00229.html#a0f41a1d67dc6b661906f2217563637f3">  496</a></span>  <span class="keywordtype">int</span> <a class="code hl_variable" href="a00229.html#a0f41a1d67dc6b661906f2217563637f3">symmetric_subtree</a>;                </div>
+<div class="line"><a id="l00507" name="l00507"></a><span class="lineno"><a class="line" href="a00229.html#a6f834ea4dd26553cdea601d2fae6d3b7">  507</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#a6f834ea4dd26553cdea601d2fae6d3b7">memory_arity</a>;                </div>
+<div class="line"><a id="l00510" name="l00510"></a><span class="lineno"><a class="line" href="a00229.html#ac0e8200dba25b90d5954bd4ec61f97d3">  510</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> *<a class="code hl_variable" href="a00229.html#ac0e8200dba25b90d5954bd4ec61f97d3">memory_first_child</a>; </div>
+<div class="line"><a id="l00525" name="l00525"></a><span class="lineno"><a class="line" href="a00229.html#a7b3b29f0be377c7d2d52262019fc7d11">  525</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#a7b3b29f0be377c7d2d52262019fc7d11">io_arity</a>;                    </div>
+<div class="line"><a id="l00528" name="l00528"></a><span class="lineno"><a class="line" href="a00229.html#a8d14c88e1ebc4ae67cc69f9e928558b3">  528</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> *<a class="code hl_variable" href="a00229.html#a8d14c88e1ebc4ae67cc69f9e928558b3">io_first_child</a>;     </div>
+<div class="line"><a id="l00537" name="l00537"></a><span class="lineno"><a class="line" href="a00229.html#a2bb7862ce722d7ceda23cfa153da165a">  537</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#a2bb7862ce722d7ceda23cfa153da165a">misc_arity</a>;                  </div>
+<div class="line"><a id="l00540" name="l00540"></a><span class="lineno"><a class="line" href="a00229.html#a57812a313fe9b1a9500489f47c3011cc">  540</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> *<a class="code hl_variable" href="a00229.html#a57812a313fe9b1a9500489f47c3011cc">misc_first_child</a>;   </div>
+<div class="line"><a id="l00546" name="l00546"></a><span class="lineno">  546</span>  <span class="comment">/* cpusets and nodesets */</span></div>
+<div class="line"><a id="l00547" name="l00547"></a><span class="lineno"><a class="line" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">  547</a></span>  <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> <a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>;                </div>
+<div class="line"><a id="l00562" name="l00562"></a><span class="lineno"><a class="line" href="a00229.html#a91788a9da687beb7224cc1fd7b75208c">  562</a></span>  <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> <a class="code hl_variable" href="a00229.html#a91788a9da687beb7224cc1fd7b75208c">complete_cpuset</a>;       </div>
+<div class="line"><a id="l00575" name="l00575"></a><span class="lineno"><a class="line" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">  575</a></span>  <a class="code hl_typedef" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a> <a class="code hl_variable" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">nodeset</a>;              </div>
+<div class="line"><a id="l00597" name="l00597"></a><span class="lineno"><a class="line" href="a00229.html#ac38c4012127525ef74c5615c526f4c2e">  597</a></span>  <a class="code hl_typedef" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a> <a class="code hl_variable" href="a00229.html#ac38c4012127525ef74c5615c526f4c2e">complete_nodeset</a>;     </div>
+<div class="line"><a id="l00613" name="l00613"></a><span class="lineno"><a class="line" href="a00229.html#a8604654c38b7a720efae5025d3a96ee6">  613</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00277.html">hwloc_info_s</a> *<a class="code hl_variable" href="a00229.html#a8604654c38b7a720efae5025d3a96ee6">infos</a>;           </div>
+<div class="line"><a id="l00614" name="l00614"></a><span class="lineno"><a class="line" href="a00229.html#a9843acc28cfbba903b63ea14b137ff70">  614</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#a9843acc28cfbba903b63ea14b137ff70">infos_count</a>;                 </div>
+<div class="line"><a id="l00616" name="l00616"></a><span class="lineno">  616</span>  <span class="comment">/* misc */</span></div>
+<div class="line"><a id="l00617" name="l00617"></a><span class="lineno"><a class="line" href="a00229.html#a76fd3ac94401cf32dfccc3a3a8de68a5">  617</a></span>  <span class="keywordtype">void</span> *<a class="code hl_variable" href="a00229.html#a76fd3ac94401cf32dfccc3a3a8de68a5">userdata</a>;                       </div>
+<div class="line"><a id="l00622" name="l00622"></a><span class="lineno"><a class="line" href="a00229.html#a957984a355fa61c85f46605c336e7551">  622</a></span>  hwloc_uint64_t <a class="code hl_variable" href="a00229.html#a957984a355fa61c85f46605c336e7551">gp_index</a>;                      </div>
+<div class="line"><a id="l00627" name="l00627"></a><span class="lineno">  627</span>};</div>
+</div>
+<div class="line"><a id="l00631" name="l00631"></a><span class="lineno"><a class="line" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">  631</a></span><span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> * <a class="code hl_typedef" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>;</div>
+<div class="line"><a id="l00632" name="l00632"></a><span class="lineno">  632</span> </div>
+<div class="foldopen" id="foldopen00634" data-start="{" data-end="};">
+<div class="line"><a id="l00634" name="l00634"></a><span class="lineno"><a class="line" href="a00233.html">  634</a></span><span class="keyword">union </span><a class="code hl_union" href="a00233.html">hwloc_obj_attr_u</a> {</div>
+<div class="foldopen" id="foldopen00636" data-start="{" data-end="};">
+<div class="line"><a id="l00636" name="l00636"></a><span class="lineno"><a class="line" href="a00237.html">  636</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00237.html">hwloc_numanode_attr_s</a> {</div>
+<div class="line"><a id="l00637" name="l00637"></a><span class="lineno"><a class="line" href="a00237.html#a6703cbf2afbf63c9d60c5ff4dc0c73aa">  637</a></span>    hwloc_uint64_t <a class="code hl_variable" href="a00237.html#a6703cbf2afbf63c9d60c5ff4dc0c73aa">local_memory</a>; </div>
+<div class="line"><a id="l00638" name="l00638"></a><span class="lineno"><a class="line" href="a00237.html#a513078122d403904e16723d30f583cb2">  638</a></span>    <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00237.html#a513078122d403904e16723d30f583cb2">page_types_len</a>; </div>
+<div class="foldopen" id="foldopen00644" data-start="{" data-end="};">
+<div class="line"><a id="l00644" name="l00644"></a><span class="lineno"><a class="line" href="a00241.html">  644</a></span>    <span class="keyword">struct </span><a class="code hl_struct" href="a00241.html">hwloc_memory_page_type_s</a> {</div>
+<div class="line"><a id="l00645" name="l00645"></a><span class="lineno"><a class="line" href="a00241.html#a8ea7ebe9d91c7378bba03da57efc25cb">  645</a></span>      hwloc_uint64_t <a class="code hl_variable" href="a00241.html#a8ea7ebe9d91c7378bba03da57efc25cb">size</a>;      </div>
+<div class="line"><a id="l00646" name="l00646"></a><span class="lineno"><a class="line" href="a00241.html#a98514e37d57a325b78e21ffd8d7419e0">  646</a></span>      hwloc_uint64_t <a class="code hl_variable" href="a00241.html#a98514e37d57a325b78e21ffd8d7419e0">count</a>;     </div>
+<div class="line"><a id="l00647" name="l00647"></a><span class="lineno"><a class="line" href="a00237.html#a7e53c5024da2d7741a5cc1e7016bb8d2">  647</a></span>    } * <a class="code hl_variable" href="a00237.html#a7e53c5024da2d7741a5cc1e7016bb8d2">page_types</a>;</div>
+</div>
+<div class="line"><a id="l00648" name="l00648"></a><span class="lineno"><a class="line" href="a00233.html#ad066b9612802ffa01e132dc3a8e6cc86">  648</a></span>  } <a class="code hl_variable" href="a00233.html#ad066b9612802ffa01e132dc3a8e6cc86">numanode</a>;</div>
+</div>
+<div class="line"><a id="l00649" name="l00649"></a><span class="lineno">  649</span> </div>
+<div class="foldopen" id="foldopen00651" data-start="{" data-end="};">
+<div class="line"><a id="l00651" name="l00651"></a><span class="lineno"><a class="line" href="a00245.html">  651</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00245.html">hwloc_cache_attr_s</a> {</div>
+<div class="line"><a id="l00652" name="l00652"></a><span class="lineno"><a class="line" href="a00245.html#abe5e788943ed04302976740c829674c0">  652</a></span>    hwloc_uint64_t <a class="code hl_variable" href="a00245.html#abe5e788943ed04302976740c829674c0">size</a>;                  </div>
+<div class="line"><a id="l00653" name="l00653"></a><span class="lineno"><a class="line" href="a00245.html#a5c8f7f39193736c2187ed626940835d5">  653</a></span>    <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00245.html#a5c8f7f39193736c2187ed626940835d5">depth</a>;                       </div>
+<div class="line"><a id="l00654" name="l00654"></a><span class="lineno"><a class="line" href="a00245.html#a801e8a668e28caf06c8b88e9ae5c10db">  654</a></span>    <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00245.html#a801e8a668e28caf06c8b88e9ae5c10db">linesize</a>;                    </div>
+<div class="line"><a id="l00655" name="l00655"></a><span class="lineno"><a class="line" href="a00245.html#ad06525e474d1e2d1423ed71bb998592d">  655</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="a00245.html#ad06525e474d1e2d1423ed71bb998592d">associativity</a>;                    </div>
+<div class="line"><a id="l00657" name="l00657"></a><span class="lineno"><a class="line" href="a00245.html#ad8edc8ded2b7a70d6abbc874801930f4">  657</a></span>    <a class="code hl_typedef" href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a> <a class="code hl_variable" href="a00245.html#ad8edc8ded2b7a70d6abbc874801930f4">type</a>;          </div>
+<div class="line"><a id="l00658" name="l00658"></a><span class="lineno"><a class="line" href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">  658</a></span>  } <a class="code hl_variable" href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">cache</a>;</div>
+</div>
+<div class="foldopen" id="foldopen00660" data-start="{" data-end="};">
+<div class="line"><a id="l00660" name="l00660"></a><span class="lineno"><a class="line" href="a00249.html">  660</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00249.html">hwloc_group_attr_s</a> {</div>
+<div class="line"><a id="l00661" name="l00661"></a><span class="lineno"><a class="line" href="a00249.html#ad914eac61c77481e1b7037877bcc5579">  661</a></span>    <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00249.html#ad914eac61c77481e1b7037877bcc5579">depth</a>;                       </div>
+<div class="line"><a id="l00663" name="l00663"></a><span class="lineno"><a class="line" href="a00249.html#a3229f269c4cc7e63492c168535e4f0c1">  663</a></span>    <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00249.html#a3229f269c4cc7e63492c168535e4f0c1">kind</a>;                        </div>
+<div class="line"><a id="l00664" name="l00664"></a><span class="lineno"><a class="line" href="a00249.html#ad514d943960a4036ed5e44dc187c74ed">  664</a></span>    <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00249.html#ad514d943960a4036ed5e44dc187c74ed">subkind</a>;                     </div>
+<div class="line"><a id="l00665" name="l00665"></a><span class="lineno"><a class="line" href="a00249.html#afa253d4b70f92e940c226d61f192054f">  665</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00249.html#afa253d4b70f92e940c226d61f192054f">dont_merge</a>;             </div>
+<div class="line"><a id="l00666" name="l00666"></a><span class="lineno"><a class="line" href="a00233.html#a9eddbd69e34cd2ef6af6d2ac31b6eff3">  666</a></span>  } <a class="code hl_variable" href="a00233.html#a9eddbd69e34cd2ef6af6d2ac31b6eff3">group</a>;</div>
+</div>
+<div class="foldopen" id="foldopen00668" data-start="{" data-end="};">
+<div class="line"><a id="l00668" name="l00668"></a><span class="lineno"><a class="line" href="a00253.html">  668</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00253.html">hwloc_pcidev_attr_s</a> {</div>
+<div class="line"><a id="l00669" name="l00669"></a><span class="lineno">  669</span><span class="preprocessor">#ifndef HWLOC_HAVE_32BITS_PCI_DOMAIN</span></div>
+<div class="line"><a id="l00670" name="l00670"></a><span class="lineno"><a class="line" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">  670</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code hl_variable" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">domain</a>; </div>
+<div class="line"><a id="l00672" name="l00672"></a><span class="lineno">  672</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00673" name="l00673"></a><span class="lineno">  673</span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code hl_variable" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">domain</a>; </div>
+<div class="line"><a id="l00675" name="l00675"></a><span class="lineno">  675</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00676" name="l00676"></a><span class="lineno"><a class="line" href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">  676</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">bus</a>;   </div>
+<div class="line"><a id="l00677" name="l00677"></a><span class="lineno"><a class="line" href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">  677</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">dev</a>;   </div>
+<div class="line"><a id="l00678" name="l00678"></a><span class="lineno"><a class="line" href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">  678</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">func</a>;  </div>
+<div class="line"><a id="l00679" name="l00679"></a><span class="lineno"><a class="line" href="a00253.html#aee735352d9f1686fd290fc6d6397c334">  679</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code hl_variable" href="a00253.html#aee735352d9f1686fd290fc6d6397c334">class_id</a>;  </div>
+<div class="line"><a id="l00680" name="l00680"></a><span class="lineno"><a class="line" href="a00253.html#aad970ad19b62eb2d5df30e4802da4f4c">  680</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code hl_variable" href="a00253.html#aad970ad19b62eb2d5df30e4802da4f4c">vendor_id</a>;    </div>
+<div class="line"><a id="l00681" name="l00681"></a><span class="lineno"><a class="line" href="a00253.html#a35b66064ab7d768caf7154e410caf0fa">  681</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code hl_variable" href="a00253.html#a35b66064ab7d768caf7154e410caf0fa">device_id</a>;    </div>
+<div class="line"><a id="l00682" name="l00682"></a><span class="lineno"><a class="line" href="a00253.html#a499db3d8cc89eaba04fcaef3df1cba97">  682</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code hl_variable" href="a00253.html#a499db3d8cc89eaba04fcaef3df1cba97">subvendor_id</a>; </div>
+<div class="line"><a id="l00683" name="l00683"></a><span class="lineno"><a class="line" href="a00253.html#acac741aecd7a6db64f33409427e3971f">  683</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code hl_variable" href="a00253.html#acac741aecd7a6db64f33409427e3971f">subdevice_id</a>; </div>
+<div class="line"><a id="l00684" name="l00684"></a><span class="lineno"><a class="line" href="a00253.html#a13ad54c93d08d8ac808e4de9674c5ee7">  684</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00253.html#a13ad54c93d08d8ac808e4de9674c5ee7">revision</a>;   </div>
+<div class="line"><a id="l00685" name="l00685"></a><span class="lineno"><a class="line" href="a00253.html#a59b2fce35f7cbde86c4fd305d0ccda5f">  685</a></span>    <span class="keywordtype">float</span> <a class="code hl_variable" href="a00253.html#a59b2fce35f7cbde86c4fd305d0ccda5f">linkspeed</a>; </div>
+<div class="line"><a id="l00691" name="l00691"></a><span class="lineno"><a class="line" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">  691</a></span>  } <a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>;</div>
+</div>
+<div class="foldopen" id="foldopen00693" data-start="{" data-end="};">
+<div class="line"><a id="l00693" name="l00693"></a><span class="lineno"><a class="line" href="a00257.html">  693</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00257.html">hwloc_bridge_attr_s</a> {</div>
+<div class="line"><a id="l00694" name="l00694"></a><span class="lineno">  694</span>    <span class="keyword">union </span>{</div>
+<div class="line"><a id="l00695" name="l00695"></a><span class="lineno"><a class="line" href="a00257.html#ab5c564e7c95b747dae9eb84ec0a2c31e">  695</a></span>      <span class="keyword">struct </span><a class="code hl_struct" href="a00253.html">hwloc_pcidev_attr_s</a> <a class="code hl_variable" href="a00257.html#ab5c564e7c95b747dae9eb84ec0a2c31e">pci</a>; </div>
+<div class="line"><a id="l00696" name="l00696"></a><span class="lineno"><a class="line" href="a00257.html#a94647ccf58afd32602f584b47a0321ce">  696</a></span>    } <a class="code hl_variable" href="a00257.html#a94647ccf58afd32602f584b47a0321ce">upstream</a>;</div>
+<div class="line"><a id="l00697" name="l00697"></a><span class="lineno"><a class="line" href="a00257.html#a265dd2164aa2df4972e25a029da72125">  697</a></span>    <a class="code hl_typedef" href="a00173.html#gab34362c7a23296c3f12c5756747abda3">hwloc_obj_bridge_type_t</a> <a class="code hl_variable" href="a00257.html#a265dd2164aa2df4972e25a029da72125">upstream_type</a>; </div>
+<div class="line"><a id="l00698" name="l00698"></a><span class="lineno">  698</span>    <span class="keyword">union </span>{</div>
+<div class="line"><a id="l00699" name="l00699"></a><span class="lineno">  699</span>      <span class="keyword">struct </span>{</div>
+<div class="line"><a id="l00700" name="l00700"></a><span class="lineno">  700</span><span class="preprocessor">#ifndef HWLOC_HAVE_32BITS_PCI_DOMAIN</span></div>
+<div class="line"><a id="l00701" name="l00701"></a><span class="lineno"><a class="line" href="a00257.html#a2c31e565a5f0d23d0a0a3dd3ec8f4b17">  701</a></span>        <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code hl_variable" href="a00257.html#a2c31e565a5f0d23d0a0a3dd3ec8f4b17">domain</a>; </div>
+<div class="line"><a id="l00703" name="l00703"></a><span class="lineno">  703</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00704" name="l00704"></a><span class="lineno">  704</span>        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> domain;   </div>
+<div class="line"><a id="l00706" name="l00706"></a><span class="lineno">  706</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00707" name="l00707"></a><span class="lineno"><a class="line" href="a00257.html#ae2d9dd73ef1d32045c584a8e66d2f83f">  707</a></span>        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00257.html#ae2d9dd73ef1d32045c584a8e66d2f83f">secondary_bus</a>;   </div>
+<div class="line"><a id="l00708" name="l00708"></a><span class="lineno"><a class="line" href="a00257.html#af3f3f7d76bf03e8d2afa721c2b8d6771">  708</a></span>        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00257.html#af3f3f7d76bf03e8d2afa721c2b8d6771">subordinate_bus</a>; </div>
+<div class="line"><a id="l00709" name="l00709"></a><span class="lineno"><a class="line" href="a00257.html#ac83cbe90209860113e54d86f90b71307">  709</a></span>      } pci;</div>
+<div class="line"><a id="l00710" name="l00710"></a><span class="lineno"><a class="line" href="a00257.html#abe1e38eb5ac8dc59829c8dc045f0d747">  710</a></span>    } <a class="code hl_variable" href="a00257.html#abe1e38eb5ac8dc59829c8dc045f0d747">downstream</a>;</div>
+<div class="line"><a id="l00711" name="l00711"></a><span class="lineno"><a class="line" href="a00257.html#ac6a169b672d0e9f75756fd5665828b93">  711</a></span>    <a class="code hl_typedef" href="a00173.html#gab34362c7a23296c3f12c5756747abda3">hwloc_obj_bridge_type_t</a> <a class="code hl_variable" href="a00257.html#ac6a169b672d0e9f75756fd5665828b93">downstream_type</a>; </div>
+<div class="line"><a id="l00712" name="l00712"></a><span class="lineno"><a class="line" href="a00257.html#a336c8b22893d5d734d8c9dfca4066b46">  712</a></span>    <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00257.html#a336c8b22893d5d734d8c9dfca4066b46">depth</a>;</div>
+<div class="line"><a id="l00713" name="l00713"></a><span class="lineno"><a class="line" href="a00233.html#a207e6359497b7116d6f4baa9e8bbeb43">  713</a></span>  } <a class="code hl_variable" href="a00233.html#a207e6359497b7116d6f4baa9e8bbeb43">bridge</a>;</div>
+</div>
+<div class="foldopen" id="foldopen00715" data-start="{" data-end="};">
+<div class="line"><a id="l00715" name="l00715"></a><span class="lineno"><a class="line" href="a00273.html">  715</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00273.html">hwloc_osdev_attr_s</a> {</div>
+<div class="line"><a id="l00716" name="l00716"></a><span class="lineno"><a class="line" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">  716</a></span>    <a class="code hl_typedef" href="a00173.html#gaa9a6941ef7b1c169412518d7ef71b3d2">hwloc_obj_osdev_type_t</a> <a class="code hl_variable" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a>;</div>
+<div class="line"><a id="l00717" name="l00717"></a><span class="lineno"><a class="line" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">  717</a></span>  } <a class="code hl_variable" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a>;</div>
+</div>
+<div class="line"><a id="l00718" name="l00718"></a><span class="lineno">  718</span>};</div>
+</div>
+<div class="line"><a id="l00719" name="l00719"></a><span class="lineno">  719</span> </div>
+<div class="foldopen" id="foldopen00724" data-start="{" data-end="};">
+<div class="line"><a id="l00724" name="l00724"></a><span class="lineno"><a class="line" href="a00277.html">  724</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00277.html">hwloc_info_s</a> {</div>
+<div class="line"><a id="l00725" name="l00725"></a><span class="lineno"><a class="line" href="a00277.html#a12ce1309e4381ae38b5c15d242a47124">  725</a></span>  <span class="keywordtype">char</span> *<a class="code hl_variable" href="a00277.html#a12ce1309e4381ae38b5c15d242a47124">name</a>;   </div>
+<div class="line"><a id="l00726" name="l00726"></a><span class="lineno"><a class="line" href="a00277.html#a788a0073bafe660645e7b69f31a43bbb">  726</a></span>  <span class="keywordtype">char</span> *<a class="code hl_variable" href="a00277.html#a788a0073bafe660645e7b69f31a43bbb">value</a>;  </div>
+<div class="line"><a id="l00727" name="l00727"></a><span class="lineno">  727</span>};</div>
+</div>
+<div class="line"><a id="l00728" name="l00728"></a><span class="lineno">  728</span> </div>
+<div class="line"><a id="l00737" name="l00737"></a><span class="lineno">  737</span><span class="keyword">struct </span>hwloc_topology;</div>
+<div class="line"><a id="l00742" name="l00742"></a><span class="lineno"><a class="line" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">  742</a></span><span class="keyword">typedef</span> <span class="keyword">struct </span>hwloc_topology * <a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>;</div>
+<div class="line"><a id="l00743" name="l00743"></a><span class="lineno">  743</span> </div>
+<div class="line"><a id="l00750" name="l00750"></a><span class="lineno"><a class="line" href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa">  750</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa">hwloc_topology_init</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> *topologyp);</div>
+<div class="line"><a id="l00751" name="l00751"></a><span class="lineno">  751</span> </div>
+<div class="line"><a id="l00772" name="l00772"></a><span class="lineno"><a class="line" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826">  772</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826">hwloc_topology_load</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology);</div>
+<div class="line"><a id="l00773" name="l00773"></a><span class="lineno">  773</span> </div>
+<div class="line"><a id="l00778" name="l00778"></a><span class="lineno"><a class="line" href="a00175.html#ga9f34a640b6fd28d23699d4d084667b15">  778</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> <a class="code hl_function" href="a00175.html#ga9f34a640b6fd28d23699d4d084667b15">hwloc_topology_destroy</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology);</div>
+<div class="line"><a id="l00779" name="l00779"></a><span class="lineno">  779</span> </div>
+<div class="line"><a id="l00792" name="l00792"></a><span class="lineno"><a class="line" href="a00175.html#ga62a161fc5e6f120344dc69a7bee4e587">  792</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00175.html#ga62a161fc5e6f120344dc69a7bee4e587">hwloc_topology_dup</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> *newtopology, <a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> oldtopology);</div>
+<div class="line"><a id="l00793" name="l00793"></a><span class="lineno">  793</span> </div>
+<div class="line"><a id="l00811" name="l00811"></a><span class="lineno"><a class="line" href="a00175.html#ga0647ae66458fe68172eb5a320042f870">  811</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00175.html#ga0647ae66458fe68172eb5a320042f870">hwloc_topology_abi_check</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology);</div>
+<div class="line"><a id="l00812" name="l00812"></a><span class="lineno">  812</span> </div>
+<div class="line"><a id="l00824" name="l00824"></a><span class="lineno"><a class="line" href="a00175.html#gaf6746bc3a558ef1ac8348b4491d091b5">  824</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> <a class="code hl_function" href="a00175.html#gaf6746bc3a558ef1ac8348b4491d091b5">hwloc_topology_check</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology);</div>
+<div class="line"><a id="l00825" name="l00825"></a><span class="lineno">  825</span> </div>
+<div class="line"><a id="l00848" name="l00848"></a><span class="lineno"><a class="line" href="a00176.html#gae54d1782ca9b54bea915f5c18a9158fa">  848</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00176.html#gae54d1782ca9b54bea915f5c18a9158fa">hwloc_topology_get_depth</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> __hwloc_restrict topology) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00849" name="l00849"></a><span class="lineno">  849</span> </div>
+<div class="line"><a id="l00876" name="l00876"></a><span class="lineno"><a class="line" href="a00176.html#ga8bec782e21be313750da70cf7428b374">  876</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type);</div>
+<div class="line"><a id="l00877" name="l00877"></a><span class="lineno">  877</span> </div>
+<div class="foldopen" id="foldopen00878" data-start="{" data-end="};">
+<div class="line"><a id="l00878" name="l00878"></a><span class="lineno"><a class="line" href="a00176.html#gaf4e663cf42bbe20756b849c6293ef575">  878</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00176.html#gaf4e663cf42bbe20756b849c6293ef575">hwloc_get_type_depth_e</a> {</div>
+<div class="line"><a id="l00879" name="l00879"></a><span class="lineno"><a class="line" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">  879</a></span>    <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a> = -1,    </div>
+<div class="line"><a id="l00880" name="l00880"></a><span class="lineno"><a class="line" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">  880</a></span>    <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">HWLOC_TYPE_DEPTH_MULTIPLE</a> = -2,   </div>
+<div class="line"><a id="l00881" name="l00881"></a><span class="lineno"><a class="line" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a245c34ec9884c2cf5de5049b2153ed9c">  881</a></span>    <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a245c34ec9884c2cf5de5049b2153ed9c">HWLOC_TYPE_DEPTH_NUMANODE</a> = -3,   </div>
+<div class="line"><a id="l00882" name="l00882"></a><span class="lineno"><a class="line" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575af93b50182973e4a718d9d4db9e253a90">  882</a></span>    <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575af93b50182973e4a718d9d4db9e253a90">HWLOC_TYPE_DEPTH_BRIDGE</a> = -4,     </div>
+<div class="line"><a id="l00883" name="l00883"></a><span class="lineno"><a class="line" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ad8b1516e699b57ce1c8d107fbd2f674c">  883</a></span>    <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ad8b1516e699b57ce1c8d107fbd2f674c">HWLOC_TYPE_DEPTH_PCI_DEVICE</a> = -5, </div>
+<div class="line"><a id="l00884" name="l00884"></a><span class="lineno"><a class="line" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575afe9a2131073eebbe129d4aa2928d3f46">  884</a></span>    <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575afe9a2131073eebbe129d4aa2928d3f46">HWLOC_TYPE_DEPTH_OS_DEVICE</a> = -6,  </div>
+<div class="line"><a id="l00885" name="l00885"></a><span class="lineno"><a class="line" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a96436a392b4cdcaa1a29bc65351b373f">  885</a></span>    <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a96436a392b4cdcaa1a29bc65351b373f">HWLOC_TYPE_DEPTH_MISC</a> = -7,       </div>
+<div class="line"><a id="l00886" name="l00886"></a><span class="lineno">  886</span>    <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a8b8d7d300c018c0eb65e6c9a9f162101">HWLOC_TYPE_DEPTH_MEMCACHE</a> = -8    </div>
+<div class="line"><a id="l00887" name="l00887"></a><span class="lineno"><a class="line" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a8b8d7d300c018c0eb65e6c9a9f162101">  887</a></span>};</div>
+</div>
+<div class="line"><a id="l00888" name="l00888"></a><span class="lineno">  888</span> </div>
+<div class="line"><a id="l00908" name="l00908"></a><span class="lineno"><a class="line" href="a00176.html#gae85786340b88e24835f8c403a1e2e54b">  908</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00176.html#gae85786340b88e24835f8c403a1e2e54b">hwloc_get_memory_parents_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology);</div>
+<div class="line"><a id="l00909" name="l00909"></a><span class="lineno">  909</span> </div>
+<div class="line"><a id="l00923" name="l00923"></a><span class="lineno">  923</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00924" name="l00924"></a><span class="lineno"><a class="line" href="a00176.html#ga8125328e69eba709c33ea8055c12589b">  924</a></span><a class="code hl_function" href="a00176.html#ga8125328e69eba709c33ea8055c12589b">hwloc_get_type_or_below_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00925" name="l00925"></a><span class="lineno">  925</span> </div>
+<div class="line"><a id="l00939" name="l00939"></a><span class="lineno">  939</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00940" name="l00940"></a><span class="lineno"><a class="line" href="a00176.html#ga8a9ee573b7d2190272095d10712a7cca">  940</a></span><a class="code hl_function" href="a00176.html#ga8a9ee573b7d2190272095d10712a7cca">hwloc_get_type_or_above_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00941" name="l00941"></a><span class="lineno">  941</span> </div>
+<div class="line"><a id="l00950" name="l00950"></a><span class="lineno"><a class="line" href="a00176.html#ga506b0682b98aa264d53e934d2e9badb0">  950</a></span>HWLOC_DECLSPEC <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> <a class="code hl_function" href="a00176.html#ga506b0682b98aa264d53e934d2e9badb0">hwloc_get_depth_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">int</span> depth) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00951" name="l00951"></a><span class="lineno">  951</span> </div>
+<div class="line"><a id="l00957" name="l00957"></a><span class="lineno"><a class="line" href="a00176.html#ga1d5ceafe8130fe6e8657bf0bc666ba50">  957</a></span>HWLOC_DECLSPEC <span class="keywordtype">unsigned</span> <a class="code hl_function" href="a00176.html#ga1d5ceafe8130fe6e8657bf0bc666ba50">hwloc_get_nbobjs_by_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">int</span> depth) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00958" name="l00958"></a><span class="lineno">  958</span> </div>
+<div class="line"><a id="l00965" name="l00965"></a><span class="lineno">  965</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00966" name="l00966"></a><span class="lineno"><a class="line" href="a00176.html#ga789a3f65aedff644be64a18526a03065">  966</a></span><a class="code hl_function" href="a00176.html#ga789a3f65aedff644be64a18526a03065">hwloc_get_nbobjs_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00967" name="l00967"></a><span class="lineno">  967</span> </div>
+<div class="line"><a id="l00974" name="l00974"></a><span class="lineno">  974</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00975" name="l00975"></a><span class="lineno"><a class="line" href="a00176.html#ga2d4b12fc187dfc53b35f2fa21d21044d">  975</a></span><a class="code hl_function" href="a00176.html#ga2d4b12fc187dfc53b35f2fa21d21044d">hwloc_get_root_obj</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00976" name="l00976"></a><span class="lineno">  976</span> </div>
+<div class="line"><a id="l00982" name="l00982"></a><span class="lineno"><a class="line" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0">  982</a></span>HWLOC_DECLSPEC <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> <a class="code hl_function" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0">hwloc_get_obj_by_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">int</span> depth, <span class="keywordtype">unsigned</span> idx) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00983" name="l00983"></a><span class="lineno">  983</span> </div>
+<div class="line"><a id="l00991" name="l00991"></a><span class="lineno">  991</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00992" name="l00992"></a><span class="lineno"><a class="line" href="a00176.html#ga6f414dd80a2b943967a0ac92da3181a2">  992</a></span><a class="code hl_function" href="a00176.html#ga6f414dd80a2b943967a0ac92da3181a2">hwloc_get_obj_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, <span class="keywordtype">unsigned</span> idx) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00993" name="l00993"></a><span class="lineno">  993</span> </div>
+<div class="line"><a id="l01000" name="l01000"></a><span class="lineno"> 1000</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l01001" name="l01001"></a><span class="lineno"><a class="line" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656"> 1001</a></span><a class="code hl_function" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">int</span> depth, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> prev);</div>
+<div class="line"><a id="l01002" name="l01002"></a><span class="lineno"> 1002</span> </div>
+<div class="line"><a id="l01011" name="l01011"></a><span class="lineno"> 1011</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l01012" name="l01012"></a><span class="lineno"><a class="line" href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735"> 1012</a></span><a class="code hl_function" href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735">hwloc_get_next_obj_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type,</div>
+<div class="line"><a id="l01013" name="l01013"></a><span class="lineno"> 1013</span>                            <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> prev);</div>
+<div class="line"><a id="l01014" name="l01014"></a><span class="lineno"> 1014</span> </div>
+<div class="line"><a id="l01033" name="l01033"></a><span class="lineno"><a class="line" href="a00177.html#ga6a38b931e5d45e8af4323a169482fe39"> 1033</a></span>HWLOC_DECLSPEC <span class="keyword">const</span> <span class="keywordtype">char</span> * <a class="code hl_function" href="a00177.html#ga6a38b931e5d45e8af4323a169482fe39">hwloc_obj_type_string</a> (<a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type) __hwloc_attribute_const;</div>
+<div class="line"><a id="l01034" name="l01034"></a><span class="lineno"> 1034</span> </div>
+<div class="line"><a id="l01052" name="l01052"></a><span class="lineno"><a class="line" href="a00177.html#gadb8765c260edea80c52cd06a76639ba4"> 1052</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00177.html#gadb8765c260edea80c52cd06a76639ba4">hwloc_obj_type_snprintf</a>(<span class="keywordtype">char</span> * __hwloc_restrict <span class="keywordtype">string</span>, <span class="keywordtype">size_t</span> size,</div>
+<div class="line"><a id="l01053" name="l01053"></a><span class="lineno"> 1053</span>                                           <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj,</div>
+<div class="line"><a id="l01054" name="l01054"></a><span class="lineno"> 1054</span>                                           <span class="keywordtype">int</span> verbose);</div>
+<div class="line"><a id="l01055" name="l01055"></a><span class="lineno"> 1055</span> </div>
+<div class="line"><a id="l01067" name="l01067"></a><span class="lineno"><a class="line" href="a00177.html#ga870e876931c282a1c7aee2f031912ce3"> 1067</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00177.html#ga870e876931c282a1c7aee2f031912ce3">hwloc_obj_attr_snprintf</a>(<span class="keywordtype">char</span> * __hwloc_restrict <span class="keywordtype">string</span>, <span class="keywordtype">size_t</span> size,</div>
+<div class="line"><a id="l01068" name="l01068"></a><span class="lineno"> 1068</span>                                           <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj, <span class="keyword">const</span> <span class="keywordtype">char</span> * __hwloc_restrict separator,</div>
+<div class="line"><a id="l01069" name="l01069"></a><span class="lineno"> 1069</span>                                           <span class="keywordtype">int</span> verbose);</div>
+<div class="line"><a id="l01070" name="l01070"></a><span class="lineno"> 1070</span> </div>
+<div class="line"><a id="l01094" name="l01094"></a><span class="lineno"><a class="line" href="a00177.html#ga510f21b066fba2dab12b8c9b173b1dfd"> 1094</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00177.html#ga510f21b066fba2dab12b8c9b173b1dfd">hwloc_type_sscanf</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *<span class="keywordtype">string</span>,</div>
+<div class="line"><a id="l01095" name="l01095"></a><span class="lineno"> 1095</span>                                     <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> *typep,</div>
+<div class="line"><a id="l01096" name="l01096"></a><span class="lineno"> 1096</span>                                     <span class="keyword">union</span> <a class="code hl_union" href="a00233.html">hwloc_obj_attr_u</a> *attrp, <span class="keywordtype">size_t</span> attrsize);</div>
+<div class="line"><a id="l01097" name="l01097"></a><span class="lineno"> 1097</span> </div>
+<div class="line"><a id="l01119" name="l01119"></a><span class="lineno"><a class="line" href="a00177.html#ga52c63cd7203e55b804c1314affc9bd12"> 1119</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00177.html#ga52c63cd7203e55b804c1314affc9bd12">hwloc_type_sscanf_as_depth</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *<span class="keywordtype">string</span>,</div>
+<div class="line"><a id="l01120" name="l01120"></a><span class="lineno"> 1120</span>                                              <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> *typep,</div>
+<div class="line"><a id="l01121" name="l01121"></a><span class="lineno"> 1121</span>                                              <a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">int</span> *depthp);</div>
+<div class="line"><a id="l01122" name="l01122"></a><span class="lineno"> 1122</span> </div>
+<div class="line"><a id="l01141" name="l01141"></a><span class="lineno"> 1141</span><span class="keyword">static</span> __hwloc_inline <span class="keyword">const</span> <span class="keywordtype">char</span> *</div>
+<div class="line"><a id="l01142" name="l01142"></a><span class="lineno"><a class="line" href="a00178.html#ga415c4e44beada7ea34cd4bad9944b170"> 1142</a></span><a class="code hl_function" href="a00178.html#ga415c4e44beada7ea34cd4bad9944b170">hwloc_obj_get_info_by_name</a>(<a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj, <span class="keyword">const</span> <span class="keywordtype">char</span> *name) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l01143" name="l01143"></a><span class="lineno"> 1143</span> </div>
+<div class="line"><a id="l01160" name="l01160"></a><span class="lineno"><a class="line" href="a00178.html#gace7654bb8a9002caae1a4b8a59e7452e"> 1160</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00178.html#gace7654bb8a9002caae1a4b8a59e7452e">hwloc_obj_add_info</a>(<a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj, <span class="keyword">const</span> <span class="keywordtype">char</span> *name, <span class="keyword">const</span> <span class="keywordtype">char</span> *value);</div>
+<div class="line"><a id="l01161" name="l01161"></a><span class="lineno"> 1161</span> </div>
+<div class="line"><a id="l01176" name="l01176"></a><span class="lineno"><a class="line" href="a00178.html#ga6a07031b69bc7466b6fc4d13d610d47a"> 1176</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00178.html#ga6a07031b69bc7466b6fc4d13d610d47a">hwloc_obj_set_subtype</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj, <span class="keyword">const</span> <span class="keywordtype">char</span> *subtype);</div>
+<div class="line"><a id="l01177" name="l01177"></a><span class="lineno"> 1177</span> </div>
+<div class="foldopen" id="foldopen01249" data-start="{" data-end="};">
+<div class="line"><a id="l01249" name="l01249"></a><span class="lineno"><a class="line" href="a00179.html#ga217dc8d373f8958cc93c154ebce1c71c"> 1249</a></span><span class="keyword">typedef</span> <span class="keyword">enum</span> {</div>
+<div class="line"><a id="l01252" name="l01252"></a><span class="lineno"><a class="line" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca2e0dd0128dac6b03408c7dd170477fdc"> 1252</a></span>  <a class="code hl_enumvalue" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca2e0dd0128dac6b03408c7dd170477fdc">HWLOC_CPUBIND_PROCESS</a> = (1&lt;&lt;0),</div>
+<div class="line"><a id="l01253" name="l01253"></a><span class="lineno"> 1253</span> </div>
+<div class="line"><a id="l01256" name="l01256"></a><span class="lineno"><a class="line" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421"> 1256</a></span>  <a class="code hl_enumvalue" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421">HWLOC_CPUBIND_THREAD</a> = (1&lt;&lt;1),</div>
+<div class="line"><a id="l01257" name="l01257"></a><span class="lineno"> 1257</span> </div>
+<div class="line"><a id="l01281" name="l01281"></a><span class="lineno"><a class="line" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca679a7e0f0c7ee06b123565f90d98e7fa"> 1281</a></span>  <a class="code hl_enumvalue" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca679a7e0f0c7ee06b123565f90d98e7fa">HWLOC_CPUBIND_STRICT</a> = (1&lt;&lt;2),</div>
+<div class="line"><a id="l01282" name="l01282"></a><span class="lineno"> 1282</span> </div>
+<div class="line"><a id="l01298" name="l01298"></a><span class="lineno"> 1298</span>  <a class="code hl_enumvalue" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca41ce440443cc3087caed95ab60edcad6">HWLOC_CPUBIND_NOMEMBIND</a> = (1&lt;&lt;3)</div>
+<div class="line"><a id="l01299" name="l01299"></a><span class="lineno"><a class="line" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca41ce440443cc3087caed95ab60edcad6"> 1299</a></span>} <a class="code hl_enumeration" href="a00179.html#ga217dc8d373f8958cc93c154ebce1c71c">hwloc_cpubind_flags_t</a>;</div>
+</div>
+<div class="line"><a id="l01300" name="l01300"></a><span class="lineno"> 1300</span> </div>
+<div class="line"><a id="l01307" name="l01307"></a><span class="lineno"><a class="line" href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48"> 1307</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48">hwloc_set_cpubind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01308" name="l01308"></a><span class="lineno"> 1308</span> </div>
+<div class="line"><a id="l01317" name="l01317"></a><span class="lineno"><a class="line" href="a00179.html#gacba7ecb979baf824d5240fa2cb2a8be6"> 1317</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00179.html#gacba7ecb979baf824d5240fa2cb2a8be6">hwloc_get_cpubind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01318" name="l01318"></a><span class="lineno"> 1318</span> </div>
+<div class="line"><a id="l01332" name="l01332"></a><span class="lineno"><a class="line" href="a00179.html#ga296db8a3c6d49b51fb83d6f3e45c02a6"> 1332</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00179.html#ga296db8a3c6d49b51fb83d6f3e45c02a6">hwloc_set_proc_cpubind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_pid_t pid, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01333" name="l01333"></a><span class="lineno"> 1333</span> </div>
+<div class="line"><a id="l01351" name="l01351"></a><span class="lineno"><a class="line" href="a00179.html#gac82de91f788fa82dacf99c6e0d4b7158"> 1351</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00179.html#gac82de91f788fa82dacf99c6e0d4b7158">hwloc_get_proc_cpubind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_pid_t pid, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01352" name="l01352"></a><span class="lineno"> 1352</span> </div>
+<div class="line"><a id="l01353" name="l01353"></a><span class="lineno"> 1353</span><span class="preprocessor">#ifdef hwloc_thread_t</span></div>
+<div class="line"><a id="l01363" name="l01363"></a><span class="lineno"><a class="line" href="a00179.html#gae42c01b2addcfbf6048b9a516dd7a906"> 1363</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00179.html#gae42c01b2addcfbf6048b9a516dd7a906">hwloc_set_thread_cpubind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_thread_t thread, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01364" name="l01364"></a><span class="lineno"> 1364</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l01365" name="l01365"></a><span class="lineno"> 1365</span> </div>
+<div class="line"><a id="l01366" name="l01366"></a><span class="lineno"> 1366</span><span class="preprocessor">#ifdef hwloc_thread_t</span></div>
+<div class="line"><a id="l01380" name="l01380"></a><span class="lineno"><a class="line" href="a00179.html#gaf13f765642b5d0d9a9813e6bb043671b"> 1380</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00179.html#gaf13f765642b5d0d9a9813e6bb043671b">hwloc_get_thread_cpubind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_thread_t thread, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01381" name="l01381"></a><span class="lineno"> 1381</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l01382" name="l01382"></a><span class="lineno"> 1382</span> </div>
+<div class="line"><a id="l01402" name="l01402"></a><span class="lineno"><a class="line" href="a00179.html#gafdb374627358bf09203b5a4215b13032"> 1402</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00179.html#gafdb374627358bf09203b5a4215b13032">hwloc_get_last_cpu_location</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01403" name="l01403"></a><span class="lineno"> 1403</span> </div>
+<div class="line"><a id="l01426" name="l01426"></a><span class="lineno"><a class="line" href="a00179.html#ga910a05c2d47f68a3155bf176b50fa555"> 1426</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00179.html#ga910a05c2d47f68a3155bf176b50fa555">hwloc_get_proc_last_cpu_location</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_pid_t pid, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01427" name="l01427"></a><span class="lineno"> 1427</span> </div>
+<div class="foldopen" id="foldopen01507" data-start="{" data-end="};">
+<div class="line"><a id="l01507" name="l01507"></a><span class="lineno"><a class="line" href="a00180.html#gac9764f79505775d06407b40f5e4661e8"> 1507</a></span><span class="keyword">typedef</span> <span class="keyword">enum</span> {</div>
+<div class="line"><a id="l01515" name="l01515"></a><span class="lineno"><a class="line" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a18675bb80ebc1bce5b652e9de8f3998c"> 1515</a></span>  <a class="code hl_enumvalue" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a18675bb80ebc1bce5b652e9de8f3998c">HWLOC_MEMBIND_DEFAULT</a> =       0,</div>
+<div class="line"><a id="l01516" name="l01516"></a><span class="lineno"> 1516</span> </div>
+<div class="line"><a id="l01526" name="l01526"></a><span class="lineno"><a class="line" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a979c7aa78dd32780858f30f47a72cca0"> 1526</a></span>  <a class="code hl_enumvalue" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a979c7aa78dd32780858f30f47a72cca0">HWLOC_MEMBIND_FIRSTTOUCH</a> =    1,</div>
+<div class="line"><a id="l01527" name="l01527"></a><span class="lineno"> 1527</span> </div>
+<div class="line"><a id="l01536" name="l01536"></a><span class="lineno"><a class="line" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c"> 1536</a></span>  <a class="code hl_enumvalue" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c">HWLOC_MEMBIND_BIND</a> =          2,</div>
+<div class="line"><a id="l01537" name="l01537"></a><span class="lineno"> 1537</span> </div>
+<div class="line"><a id="l01545" name="l01545"></a><span class="lineno"><a class="line" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ae370075e5af016d42310f87ea5af236b"> 1545</a></span>  <a class="code hl_enumvalue" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ae370075e5af016d42310f87ea5af236b">HWLOC_MEMBIND_INTERLEAVE</a> =    3,</div>
+<div class="line"><a id="l01546" name="l01546"></a><span class="lineno"> 1546</span> </div>
+<div class="line"><a id="l01555" name="l01555"></a><span class="lineno"><a class="line" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8aa091c40c9557b69a26b69a0e8b84dafe"> 1555</a></span>  <a class="code hl_enumvalue" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8aa091c40c9557b69a26b69a0e8b84dafe">HWLOC_MEMBIND_WEIGHTED_INTERLEAVE</a> = 5,</div>
+<div class="line"><a id="l01556" name="l01556"></a><span class="lineno"> 1556</span> </div>
+<div class="line"><a id="l01562" name="l01562"></a><span class="lineno"><a class="line" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8aecdd4164d647708fbb51a00d98dbb138"> 1562</a></span>  <a class="code hl_enumvalue" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8aecdd4164d647708fbb51a00d98dbb138">HWLOC_MEMBIND_NEXTTOUCH</a> =     4,</div>
+<div class="line"><a id="l01563" name="l01563"></a><span class="lineno"> 1563</span> </div>
+<div class="line"><a id="l01570" name="l01570"></a><span class="lineno"> 1570</span>  <a class="code hl_enumvalue" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a3185bd869b67817fb2bd5164bf360402">HWLOC_MEMBIND_MIXED</a> = -1</div>
+<div class="line"><a id="l01571" name="l01571"></a><span class="lineno"><a class="line" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a3185bd869b67817fb2bd5164bf360402"> 1571</a></span>} <a class="code hl_enumeration" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a>;</div>
+</div>
+<div class="line"><a id="l01572" name="l01572"></a><span class="lineno"> 1572</span> </div>
+<div class="foldopen" id="foldopen01586" data-start="{" data-end="};">
+<div class="line"><a id="l01586" name="l01586"></a><span class="lineno"><a class="line" href="a00180.html#gab00475fd98815bf4fb9aaf752030e7d2"> 1586</a></span><span class="keyword">typedef</span> <span class="keyword">enum</span> {</div>
+<div class="line"><a id="l01591" name="l01591"></a><span class="lineno"><a class="line" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4"> 1591</a></span>  <a class="code hl_enumvalue" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4">HWLOC_MEMBIND_PROCESS</a> =       (1&lt;&lt;0),</div>
+<div class="line"><a id="l01592" name="l01592"></a><span class="lineno"> 1592</span> </div>
+<div class="line"><a id="l01596" name="l01596"></a><span class="lineno"><a class="line" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298"> 1596</a></span>  <a class="code hl_enumvalue" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298">HWLOC_MEMBIND_THREAD</a> =        (1&lt;&lt;1),</div>
+<div class="line"><a id="l01597" name="l01597"></a><span class="lineno"> 1597</span> </div>
+<div class="line"><a id="l01604" name="l01604"></a><span class="lineno"><a class="line" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6"> 1604</a></span>  <a class="code hl_enumvalue" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a> =        (1&lt;&lt;2),</div>
+<div class="line"><a id="l01605" name="l01605"></a><span class="lineno"> 1605</span> </div>
+<div class="line"><a id="l01610" name="l01610"></a><span class="lineno"><a class="line" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2aa6e49e54f52827cb143cc869cfd748af"> 1610</a></span>  <a class="code hl_enumvalue" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2aa6e49e54f52827cb143cc869cfd748af">HWLOC_MEMBIND_MIGRATE</a> =       (1&lt;&lt;3),</div>
+<div class="line"><a id="l01611" name="l01611"></a><span class="lineno"> 1611</span> </div>
+<div class="line"><a id="l01623" name="l01623"></a><span class="lineno"><a class="line" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2aad6b9eaf2ee324ca58dc8f58094b9997"> 1623</a></span>  <a class="code hl_enumvalue" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2aad6b9eaf2ee324ca58dc8f58094b9997">HWLOC_MEMBIND_NOCPUBIND</a> =     (1&lt;&lt;4),</div>
+<div class="line"><a id="l01624" name="l01624"></a><span class="lineno"> 1624</span> </div>
+<div class="line"><a id="l01634" name="l01634"></a><span class="lineno"> 1634</span>  <a class="code hl_enumvalue" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256">HWLOC_MEMBIND_BYNODESET</a> =     (1&lt;&lt;5)</div>
+<div class="line"><a id="l01635" name="l01635"></a><span class="lineno"><a class="line" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256"> 1635</a></span>} <a class="code hl_enumeration" href="a00180.html#gab00475fd98815bf4fb9aaf752030e7d2">hwloc_membind_flags_t</a>;</div>
+</div>
+<div class="line"><a id="l01636" name="l01636"></a><span class="lineno"> 1636</span> </div>
+<div class="line"><a id="l01653" name="l01653"></a><span class="lineno"><a class="line" href="a00180.html#ga020951efa0ce3862bd4faec295501a7f"> 1653</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00180.html#ga020951efa0ce3862bd4faec295501a7f">hwloc_set_membind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, <a class="code hl_enumeration" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> policy, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01654" name="l01654"></a><span class="lineno"> 1654</span> </div>
+<div class="line"><a id="l01704" name="l01704"></a><span class="lineno"><a class="line" href="a00180.html#gae21f0a1a884929c784bebf070252aa56"> 1704</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00180.html#gae21f0a1a884929c784bebf070252aa56">hwloc_get_membind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set, <a class="code hl_enumeration" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> * policy, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01705" name="l01705"></a><span class="lineno"> 1705</span> </div>
+<div class="line"><a id="l01719" name="l01719"></a><span class="lineno"><a class="line" href="a00180.html#gabc91ff16f7e41047924e3a4ae6d9da7e"> 1719</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00180.html#gabc91ff16f7e41047924e3a4ae6d9da7e">hwloc_set_proc_membind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_pid_t pid, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, <a class="code hl_enumeration" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> policy, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01720" name="l01720"></a><span class="lineno"> 1720</span> </div>
+<div class="line"><a id="l01765" name="l01765"></a><span class="lineno"><a class="line" href="a00180.html#ga1730ceb18ec6ee3b7bd3d0db81f07dc8"> 1765</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00180.html#ga1730ceb18ec6ee3b7bd3d0db81f07dc8">hwloc_get_proc_membind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_pid_t pid, <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set, <a class="code hl_enumeration" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> * policy, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01766" name="l01766"></a><span class="lineno"> 1766</span> </div>
+<div class="line"><a id="l01777" name="l01777"></a><span class="lineno"><a class="line" href="a00180.html#gaf881faefe20701229f07dd7dbd0125ed"> 1777</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00180.html#gaf881faefe20701229f07dd7dbd0125ed">hwloc_set_area_membind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">const</span> <span class="keywordtype">void</span> *addr, <span class="keywordtype">size_t</span> len, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, <a class="code hl_enumeration" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> policy, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01778" name="l01778"></a><span class="lineno"> 1778</span> </div>
+<div class="line"><a id="l01810" name="l01810"></a><span class="lineno"><a class="line" href="a00180.html#gaa87e0a6946ff145914fdf0b1c60567f8"> 1810</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00180.html#gaa87e0a6946ff145914fdf0b1c60567f8">hwloc_get_area_membind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">const</span> <span class="keywordtype">void</span> *addr, <span class="keywordtype">size_t</span> len, <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set, <a class="code hl_enumeration" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> * policy, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01811" name="l01811"></a><span class="lineno"> 1811</span> </div>
+<div class="line"><a id="l01834" name="l01834"></a><span class="lineno"><a class="line" href="a00180.html#ga537c7508a4e2d1db05673ec5be6e805c"> 1834</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00180.html#ga537c7508a4e2d1db05673ec5be6e805c">hwloc_get_area_memlocation</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">const</span> <span class="keywordtype">void</span> *addr, <span class="keywordtype">size_t</span> len, <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set, <span class="keywordtype">int</span> flags);</div>
+<div class="line"><a id="l01835" name="l01835"></a><span class="lineno"> 1835</span> </div>
+<div class="line"><a id="l01845" name="l01845"></a><span class="lineno"><a class="line" href="a00180.html#ga95856d8f13357f247d5fce142d443ae3"> 1845</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> *<a class="code hl_function" href="a00180.html#ga95856d8f13357f247d5fce142d443ae3">hwloc_alloc</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">size_t</span> len);</div>
+<div class="line"><a id="l01846" name="l01846"></a><span class="lineno"> 1846</span> </div>
+<div class="line"><a id="l01862" name="l01862"></a><span class="lineno"><a class="line" href="a00180.html#gadf87089ef533db40460ccc24b5bc0d65"> 1862</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> *<a class="code hl_function" href="a00180.html#gadf87089ef533db40460ccc24b5bc0d65">hwloc_alloc_membind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">size_t</span> len, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, <a class="code hl_enumeration" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> policy, <span class="keywordtype">int</span> flags) __hwloc_attribute_malloc;</div>
+<div class="line"><a id="l01863" name="l01863"></a><span class="lineno"> 1863</span> </div>
+<div class="line"><a id="l01878" name="l01878"></a><span class="lineno"> 1878</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">void</span> *</div>
+<div class="line"><a id="l01879" name="l01879"></a><span class="lineno"><a class="line" href="a00180.html#ga64e5f75165ea52930f67b17ef4aed2e8"> 1879</a></span><a class="code hl_function" href="a00180.html#ga64e5f75165ea52930f67b17ef4aed2e8">hwloc_alloc_membind_policy</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">size_t</span> len, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, <a class="code hl_enumeration" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> policy, <span class="keywordtype">int</span> flags) __hwloc_attribute_malloc;</div>
+<div class="line"><a id="l01880" name="l01880"></a><span class="lineno"> 1880</span> </div>
+<div class="line"><a id="l01886" name="l01886"></a><span class="lineno"><a class="line" href="a00180.html#ga32dbd4f54e9e4a7179f2dde37ffe6ad7"> 1886</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00180.html#ga32dbd4f54e9e4a7179f2dde37ffe6ad7">hwloc_free</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">void</span> *addr, <span class="keywordtype">size_t</span> len);</div>
+<div class="line"><a id="l01887" name="l01887"></a><span class="lineno"> 1887</span> </div>
+<div class="line"><a id="l01933" name="l01933"></a><span class="lineno"><a class="line" href="a00181.html#ga341fc17b5867a4715570baab131f68cd"> 1933</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00181.html#ga341fc17b5867a4715570baab131f68cd">hwloc_topology_set_pid</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> __hwloc_restrict topology, hwloc_pid_t pid);</div>
+<div class="line"><a id="l01934" name="l01934"></a><span class="lineno"> 1934</span> </div>
+<div class="line"><a id="l01966" name="l01966"></a><span class="lineno"><a class="line" href="a00181.html#ga4fab186bb6181a00bcf585825fddd38d"> 1966</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00181.html#ga4fab186bb6181a00bcf585825fddd38d">hwloc_topology_set_synthetic</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> __hwloc_restrict topology, <span class="keyword">const</span> <span class="keywordtype">char</span> * __hwloc_restrict description);</div>
+<div class="line"><a id="l01967" name="l01967"></a><span class="lineno"> 1967</span> </div>
+<div class="line"><a id="l01999" name="l01999"></a><span class="lineno"><a class="line" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e"> 1999</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e">hwloc_topology_set_xml</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> __hwloc_restrict topology, <span class="keyword">const</span> <span class="keywordtype">char</span> * __hwloc_restrict xmlpath);</div>
+<div class="line"><a id="l02000" name="l02000"></a><span class="lineno"> 2000</span> </div>
+<div class="line"><a id="l02033" name="l02033"></a><span class="lineno"><a class="line" href="a00181.html#ga2745616b65595e1c1e579ecc7e461fa8"> 2033</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00181.html#ga2745616b65595e1c1e579ecc7e461fa8">hwloc_topology_set_xmlbuffer</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> __hwloc_restrict topology, <span class="keyword">const</span> <span class="keywordtype">char</span> * __hwloc_restrict buffer, <span class="keywordtype">int</span> size);</div>
+<div class="line"><a id="l02034" name="l02034"></a><span class="lineno"> 2034</span> </div>
+<div class="foldopen" id="foldopen02037" data-start="{" data-end="};">
+<div class="line"><a id="l02037" name="l02037"></a><span class="lineno"><a class="line" href="a00181.html#ga949f656c779208a36790feba24048b7e"> 2037</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00181.html#ga949f656c779208a36790feba24048b7e">hwloc_topology_components_flag_e</a> {</div>
+<div class="line"><a id="l02041" name="l02041"></a><span class="lineno"> 2041</span>  <a class="code hl_enumvalue" href="a00181.html#gga949f656c779208a36790feba24048b7ea33eec25d29253a2aba21dd3c731b416e">HWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST</a> = (1UL&lt;&lt;0)</div>
+<div class="line"><a id="l02042" name="l02042"></a><span class="lineno"><a class="line" href="a00181.html#gga949f656c779208a36790feba24048b7ea33eec25d29253a2aba21dd3c731b416e"> 2042</a></span>};</div>
+</div>
+<div class="line"><a id="l02043" name="l02043"></a><span class="lineno"> 2043</span> </div>
+<div class="line"><a id="l02061" name="l02061"></a><span class="lineno"><a class="line" href="a00181.html#ga9ad41adf418cee1c0ee32ba9bd4a3d36"> 2061</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00181.html#ga9ad41adf418cee1c0ee32ba9bd4a3d36">hwloc_topology_set_components</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> __hwloc_restrict topology, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags, <span class="keyword">const</span> <span class="keywordtype">char</span> * __hwloc_restrict name);</div>
+<div class="line"><a id="l02062" name="l02062"></a><span class="lineno"> 2062</span> </div>
+<div class="foldopen" id="foldopen02081" data-start="{" data-end="};">
+<div class="line"><a id="l02081" name="l02081"></a><span class="lineno"><a class="line" href="a00182.html#gada025d3ec20b4b420f8038d23d6e7bde"> 2081</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00182.html#gada025d3ec20b4b420f8038d23d6e7bde">hwloc_topology_flags_e</a> {</div>
+<div class="line"><a id="l02103" name="l02103"></a><span class="lineno"><a class="line" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258"> 2103</a></span>  <a class="code hl_enumvalue" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a> = (1UL&lt;&lt;0),</div>
+<div class="line"><a id="l02104" name="l02104"></a><span class="lineno"> 2104</span> </div>
+<div class="line"><a id="l02123" name="l02123"></a><span class="lineno"><a class="line" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b"> 2123</a></span>  <a class="code hl_enumvalue" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a> = (1UL&lt;&lt;1),</div>
+<div class="line"><a id="l02124" name="l02124"></a><span class="lineno"> 2124</span> </div>
+<div class="line"><a id="l02144" name="l02144"></a><span class="lineno"><a class="line" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea1b66bbd66e900e5c837f71defb32ad89"> 2144</a></span>  <a class="code hl_enumvalue" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea1b66bbd66e900e5c837f71defb32ad89">HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES</a> = (1UL&lt;&lt;2),</div>
+<div class="line"><a id="l02145" name="l02145"></a><span class="lineno"> 2145</span> </div>
+<div class="line"><a id="l02168" name="l02168"></a><span class="lineno"><a class="line" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdead93e82b8668ee90e4f9354e201a2ed9c"> 2168</a></span>  <a class="code hl_enumvalue" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdead93e82b8668ee90e4f9354e201a2ed9c">HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT</a> = (1UL&lt;&lt;3),</div>
+<div class="line"><a id="l02169" name="l02169"></a><span class="lineno"> 2169</span> </div>
+<div class="line"><a id="l02193" name="l02193"></a><span class="lineno"><a class="line" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdeaa595aed197779012acf43e8ca4a2658d"> 2193</a></span>  <a class="code hl_enumvalue" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdeaa595aed197779012acf43e8ca4a2658d">HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING</a> = (1UL&lt;&lt;4),</div>
+<div class="line"><a id="l02194" name="l02194"></a><span class="lineno"> 2194</span> </div>
+<div class="line"><a id="l02215" name="l02215"></a><span class="lineno"><a class="line" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea368d7741135fe309f3782c59644d3caa"> 2215</a></span>  <a class="code hl_enumvalue" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea368d7741135fe309f3782c59644d3caa">HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING</a> = (1UL&lt;&lt;5),</div>
+<div class="line"><a id="l02216" name="l02216"></a><span class="lineno"> 2216</span> </div>
+<div class="line"><a id="l02230" name="l02230"></a><span class="lineno"><a class="line" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdeae7a792e3db4360360a10f9160b10e631"> 2230</a></span>  <a class="code hl_enumvalue" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdeae7a792e3db4360360a10f9160b10e631">HWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING</a> = (1UL&lt;&lt;6),</div>
+<div class="line"><a id="l02231" name="l02231"></a><span class="lineno"> 2231</span> </div>
+<div class="line"><a id="l02237" name="l02237"></a><span class="lineno"><a class="line" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea5796b4909eba80f9727b66d07d3a7a05"> 2237</a></span>  <a class="code hl_enumvalue" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea5796b4909eba80f9727b66d07d3a7a05">HWLOC_TOPOLOGY_FLAG_NO_DISTANCES</a> = (1UL&lt;&lt;7),</div>
+<div class="line"><a id="l02238" name="l02238"></a><span class="lineno"> 2238</span> </div>
+<div class="line"><a id="l02244" name="l02244"></a><span class="lineno"><a class="line" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdead5636766a6603f24486f79c48899c1c3"> 2244</a></span>  <a class="code hl_enumvalue" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdead5636766a6603f24486f79c48899c1c3">HWLOC_TOPOLOGY_FLAG_NO_MEMATTRS</a> = (1UL&lt;&lt;8),</div>
+<div class="line"><a id="l02245" name="l02245"></a><span class="lineno"> 2245</span> </div>
+<div class="line"><a id="l02250" name="l02250"></a><span class="lineno"> 2250</span>  <a class="code hl_enumvalue" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea3497cd4c2f8b1d842dd49b3aaae56a24">HWLOC_TOPOLOGY_FLAG_NO_CPUKINDS</a> = (1UL&lt;&lt;9)</div>
+<div class="line"><a id="l02251" name="l02251"></a><span class="lineno"><a class="line" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea3497cd4c2f8b1d842dd49b3aaae56a24"> 2251</a></span>};</div>
+</div>
+<div class="line"><a id="l02252" name="l02252"></a><span class="lineno"> 2252</span> </div>
+<div class="line"><a id="l02267" name="l02267"></a><span class="lineno"><a class="line" href="a00182.html#gaaeed4df656979e5f16befea9d29b814b"> 2267</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00182.html#gaaeed4df656979e5f16befea9d29b814b">hwloc_topology_set_flags</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l02268" name="l02268"></a><span class="lineno"> 2268</span> </div>
+<div class="line"><a id="l02280" name="l02280"></a><span class="lineno"><a class="line" href="a00182.html#ga09318f81c1d4713be907d64748a6f93c"> 2280</a></span>HWLOC_DECLSPEC <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code hl_function" href="a00182.html#ga09318f81c1d4713be907d64748a6f93c">hwloc_topology_get_flags</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology);</div>
+<div class="line"><a id="l02281" name="l02281"></a><span class="lineno"> 2281</span> </div>
+<div class="line"><a id="l02291" name="l02291"></a><span class="lineno"><a class="line" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017"> 2291</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>  __hwloc_restrict topology) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l02292" name="l02292"></a><span class="lineno"> 2292</span> </div>
+<div class="foldopen" id="foldopen02294" data-start="{" data-end="};">
+<div class="line"><a id="l02294" name="l02294"></a><span class="lineno"><a class="line" href="a00281.html"> 2294</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00281.html">hwloc_topology_discovery_support</a> {</div>
+<div class="line"><a id="l02296" name="l02296"></a><span class="lineno"><a class="line" href="a00281.html#ad7bb4ecf7a82f5a04fc632e9592ad3ab"> 2296</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00281.html#ad7bb4ecf7a82f5a04fc632e9592ad3ab">pu</a>;</div>
+<div class="line"><a id="l02298" name="l02298"></a><span class="lineno"><a class="line" href="a00281.html#a955f96066cb9e4cd34e2a3710ad43e80"> 2298</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00281.html#a955f96066cb9e4cd34e2a3710ad43e80">numa</a>;</div>
+<div class="line"><a id="l02300" name="l02300"></a><span class="lineno"><a class="line" href="a00281.html#af193eb858e40e12ef4923f5ed0e1f11a"> 2300</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00281.html#af193eb858e40e12ef4923f5ed0e1f11a">numa_memory</a>;</div>
+<div class="line"><a id="l02302" name="l02302"></a><span class="lineno"><a class="line" href="a00281.html#af3c97b28781a2972cf8eaaf94a6617da"> 2302</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00281.html#af3c97b28781a2972cf8eaaf94a6617da">disallowed_pu</a>;</div>
+<div class="line"><a id="l02304" name="l02304"></a><span class="lineno"><a class="line" href="a00281.html#a970e65235873bcdb9669a9805161ce03"> 2304</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00281.html#a970e65235873bcdb9669a9805161ce03">disallowed_numa</a>;</div>
+<div class="line"><a id="l02306" name="l02306"></a><span class="lineno"><a class="line" href="a00281.html#aba80d6f9c15e2395f9ed61db9ff3b75d"> 2306</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00281.html#aba80d6f9c15e2395f9ed61db9ff3b75d">cpukind_efficiency</a>;</div>
+<div class="line"><a id="l02307" name="l02307"></a><span class="lineno"> 2307</span>};</div>
+</div>
+<div class="line"><a id="l02308" name="l02308"></a><span class="lineno"> 2308</span> </div>
+<div class="foldopen" id="foldopen02314" data-start="{" data-end="};">
+<div class="line"><a id="l02314" name="l02314"></a><span class="lineno"><a class="line" href="a00285.html"> 2314</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00285.html">hwloc_topology_cpubind_support</a> {</div>
+<div class="line"><a id="l02316" name="l02316"></a><span class="lineno"><a class="line" href="a00285.html#a9403d51657a4d546b3ea9553a2973a27"> 2316</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00285.html#a9403d51657a4d546b3ea9553a2973a27">set_thisproc_cpubind</a>;</div>
+<div class="line"><a id="l02318" name="l02318"></a><span class="lineno"><a class="line" href="a00285.html#a77a09ddd78ee3e9ff5f532a6ac74f7eb"> 2318</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00285.html#a77a09ddd78ee3e9ff5f532a6ac74f7eb">get_thisproc_cpubind</a>;</div>
+<div class="line"><a id="l02320" name="l02320"></a><span class="lineno"><a class="line" href="a00285.html#aa166223d1c2a6de7256ab2d8b675a87e"> 2320</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00285.html#aa166223d1c2a6de7256ab2d8b675a87e">set_proc_cpubind</a>;</div>
+<div class="line"><a id="l02322" name="l02322"></a><span class="lineno"><a class="line" href="a00285.html#aae705bc447adc163ead377362c4dfe9f"> 2322</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00285.html#aae705bc447adc163ead377362c4dfe9f">get_proc_cpubind</a>;</div>
+<div class="line"><a id="l02324" name="l02324"></a><span class="lineno"><a class="line" href="a00285.html#a57a89a4b5f1f74fa6cfe176f1e8b0798"> 2324</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00285.html#a57a89a4b5f1f74fa6cfe176f1e8b0798">set_thisthread_cpubind</a>;</div>
+<div class="line"><a id="l02326" name="l02326"></a><span class="lineno"><a class="line" href="a00285.html#a80d762e532d677dff262d83cc7bb1c60"> 2326</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00285.html#a80d762e532d677dff262d83cc7bb1c60">get_thisthread_cpubind</a>;</div>
+<div class="line"><a id="l02328" name="l02328"></a><span class="lineno"><a class="line" href="a00285.html#a46fba33e307909ce256624687799dd6d"> 2328</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00285.html#a46fba33e307909ce256624687799dd6d">set_thread_cpubind</a>;</div>
+<div class="line"><a id="l02330" name="l02330"></a><span class="lineno"><a class="line" href="a00285.html#a8dd4d8531ed2eebdce1507e7d104154e"> 2330</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00285.html#a8dd4d8531ed2eebdce1507e7d104154e">get_thread_cpubind</a>;</div>
+<div class="line"><a id="l02332" name="l02332"></a><span class="lineno"><a class="line" href="a00285.html#ad2d5c94b738d92b7d2ede87e4e96321d"> 2332</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00285.html#ad2d5c94b738d92b7d2ede87e4e96321d">get_thisproc_last_cpu_location</a>;</div>
+<div class="line"><a id="l02334" name="l02334"></a><span class="lineno"><a class="line" href="a00285.html#a2554620148b7992a5093f338f5ae254f"> 2334</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00285.html#a2554620148b7992a5093f338f5ae254f">get_proc_last_cpu_location</a>;</div>
+<div class="line"><a id="l02336" name="l02336"></a><span class="lineno"><a class="line" href="a00285.html#a6be1f042fdce6bf41b4ea39f6f193808"> 2336</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00285.html#a6be1f042fdce6bf41b4ea39f6f193808">get_thisthread_last_cpu_location</a>;</div>
+<div class="line"><a id="l02337" name="l02337"></a><span class="lineno"> 2337</span>};</div>
+</div>
+<div class="line"><a id="l02338" name="l02338"></a><span class="lineno"> 2338</span> </div>
+<div class="foldopen" id="foldopen02344" data-start="{" data-end="};">
+<div class="line"><a id="l02344" name="l02344"></a><span class="lineno"><a class="line" href="a00289.html"> 2344</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00289.html">hwloc_topology_membind_support</a> {</div>
+<div class="line"><a id="l02346" name="l02346"></a><span class="lineno"><a class="line" href="a00289.html#a36b3e388df9c6a249427cab7e3724749"> 2346</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a36b3e388df9c6a249427cab7e3724749">set_thisproc_membind</a>;</div>
+<div class="line"><a id="l02348" name="l02348"></a><span class="lineno"><a class="line" href="a00289.html#a3fd51e6fa5f0dd800322301b46b08559"> 2348</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a3fd51e6fa5f0dd800322301b46b08559">get_thisproc_membind</a>;</div>
+<div class="line"><a id="l02350" name="l02350"></a><span class="lineno"><a class="line" href="a00289.html#a756f44912894b176bf979a1b65f12aac"> 2350</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a756f44912894b176bf979a1b65f12aac">set_proc_membind</a>;</div>
+<div class="line"><a id="l02352" name="l02352"></a><span class="lineno"><a class="line" href="a00289.html#a9880cd2d605e316fc020167c49ca69ad"> 2352</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a9880cd2d605e316fc020167c49ca69ad">get_proc_membind</a>;</div>
+<div class="line"><a id="l02354" name="l02354"></a><span class="lineno"><a class="line" href="a00289.html#a0697af2e41f2e82b8ce71e3cc13f7eac"> 2354</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a0697af2e41f2e82b8ce71e3cc13f7eac">set_thisthread_membind</a>;</div>
+<div class="line"><a id="l02356" name="l02356"></a><span class="lineno"><a class="line" href="a00289.html#a63b0b2e26157b472f5717ee93cc7c535"> 2356</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a63b0b2e26157b472f5717ee93cc7c535">get_thisthread_membind</a>;</div>
+<div class="line"><a id="l02358" name="l02358"></a><span class="lineno"><a class="line" href="a00289.html#a476c06f96b65c08b287cf2369966123b"> 2358</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a476c06f96b65c08b287cf2369966123b">set_area_membind</a>;</div>
+<div class="line"><a id="l02360" name="l02360"></a><span class="lineno"><a class="line" href="a00289.html#a0a84e24a06f2fa487fe8c9605c6f68b3"> 2360</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a0a84e24a06f2fa487fe8c9605c6f68b3">get_area_membind</a>;</div>
+<div class="line"><a id="l02362" name="l02362"></a><span class="lineno"><a class="line" href="a00289.html#ae551abb27d2aa9ce008583488b845b98"> 2362</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#ae551abb27d2aa9ce008583488b845b98">alloc_membind</a>;</div>
+<div class="line"><a id="l02364" name="l02364"></a><span class="lineno"><a class="line" href="a00289.html#a221098c339dbfab27bd2c9f5d32f123b"> 2364</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a221098c339dbfab27bd2c9f5d32f123b">firsttouch_membind</a>;</div>
+<div class="line"><a id="l02366" name="l02366"></a><span class="lineno"><a class="line" href="a00289.html#ae7cdb1f1b5f0242a69f85b5a5538c764"> 2366</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#ae7cdb1f1b5f0242a69f85b5a5538c764">bind_membind</a>;</div>
+<div class="line"><a id="l02368" name="l02368"></a><span class="lineno"><a class="line" href="a00289.html#a3c44c6012860bbeba8a0f4c19710858d"> 2368</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a3c44c6012860bbeba8a0f4c19710858d">interleave_membind</a>;</div>
+<div class="line"><a id="l02370" name="l02370"></a><span class="lineno"><a class="line" href="a00289.html#ab0921af6e0cd6975812a80b8e5c7435c"> 2370</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#ab0921af6e0cd6975812a80b8e5c7435c">nexttouch_membind</a>;</div>
+<div class="line"><a id="l02372" name="l02372"></a><span class="lineno"><a class="line" href="a00289.html#aafa7683871a6a760246f9b35209caec5"> 2372</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#aafa7683871a6a760246f9b35209caec5">migrate_membind</a>;</div>
+<div class="line"><a id="l02374" name="l02374"></a><span class="lineno"><a class="line" href="a00289.html#a30173553a68e0a4dd1672d26f8e892b1"> 2374</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a30173553a68e0a4dd1672d26f8e892b1">get_area_memlocation</a>;</div>
+<div class="line"><a id="l02376" name="l02376"></a><span class="lineno"><a class="line" href="a00289.html#a48e8c0eee48e83e72edde293e2f52464"> 2376</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00289.html#a48e8c0eee48e83e72edde293e2f52464">weighted_interleave_membind</a>;</div>
+<div class="line"><a id="l02377" name="l02377"></a><span class="lineno"> 2377</span>};</div>
+</div>
+<div class="line"><a id="l02378" name="l02378"></a><span class="lineno"> 2378</span> </div>
+<div class="foldopen" id="foldopen02381" data-start="{" data-end="};">
+<div class="line"><a id="l02381" name="l02381"></a><span class="lineno"><a class="line" href="a00293.html"> 2381</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00293.html">hwloc_topology_misc_support</a> {</div>
+<div class="line"><a id="l02383" name="l02383"></a><span class="lineno"><a class="line" href="a00293.html#adf54a6dbe8e9dd5033dfe9c93df726c4"> 2383</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code hl_variable" href="a00293.html#adf54a6dbe8e9dd5033dfe9c93df726c4">imported_support</a>;</div>
+<div class="line"><a id="l02384" name="l02384"></a><span class="lineno"> 2384</span>};</div>
+</div>
+<div class="line"><a id="l02385" name="l02385"></a><span class="lineno"> 2385</span> </div>
+<div class="foldopen" id="foldopen02392" data-start="{" data-end="};">
+<div class="line"><a id="l02392" name="l02392"></a><span class="lineno"><a class="line" href="a00297.html"> 2392</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00297.html">hwloc_topology_support</a> {</div>
+<div class="line"><a id="l02393" name="l02393"></a><span class="lineno"><a class="line" href="a00297.html#aea3fbd7653d987d81f848636c420504d"> 2393</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00281.html">hwloc_topology_discovery_support</a> *<a class="code hl_variable" href="a00297.html#aea3fbd7653d987d81f848636c420504d">discovery</a>;</div>
+<div class="line"><a id="l02394" name="l02394"></a><span class="lineno"><a class="line" href="a00297.html#adef2bb91f74c3e70a2a071393caf5f56"> 2394</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00285.html">hwloc_topology_cpubind_support</a> *<a class="code hl_variable" href="a00297.html#adef2bb91f74c3e70a2a071393caf5f56">cpubind</a>;</div>
+<div class="line"><a id="l02395" name="l02395"></a><span class="lineno"><a class="line" href="a00297.html#ac6eb62ae8bc0a68dce679a7107a36194"> 2395</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00289.html">hwloc_topology_membind_support</a> *<a class="code hl_variable" href="a00297.html#ac6eb62ae8bc0a68dce679a7107a36194">membind</a>;</div>
+<div class="line"><a id="l02396" name="l02396"></a><span class="lineno"><a class="line" href="a00297.html#ab9d08df4b0b03994f21b893ece826e78"> 2396</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00293.html">hwloc_topology_misc_support</a> *<a class="code hl_variable" href="a00297.html#ab9d08df4b0b03994f21b893ece826e78">misc</a>;</div>
+<div class="line"><a id="l02397" name="l02397"></a><span class="lineno"> 2397</span>};</div>
+</div>
+<div class="line"><a id="l02398" name="l02398"></a><span class="lineno"> 2398</span> </div>
+<div class="line"><a id="l02428" name="l02428"></a><span class="lineno"><a class="line" href="a00182.html#gac0927e93a9b962143be08a48bbff2e19"> 2428</a></span>HWLOC_DECLSPEC <span class="keyword">const</span> <span class="keyword">struct </span><a class="code hl_struct" href="a00297.html">hwloc_topology_support</a> *<a class="code hl_function" href="a00182.html#gac0927e93a9b962143be08a48bbff2e19">hwloc_topology_get_support</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> __hwloc_restrict topology);</div>
+<div class="line"><a id="l02429" name="l02429"></a><span class="lineno"> 2429</span> </div>
+<div class="foldopen" id="foldopen02439" data-start="{" data-end="};">
+<div class="line"><a id="l02439" name="l02439"></a><span class="lineno"><a class="line" href="a00182.html#ga9a5a1f0140cd1952544477833733195b"> 2439</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> {</div>
+<div class="line"><a id="l02445" name="l02445"></a><span class="lineno"><a class="line" href="a00182.html#gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e"> 2445</a></span>  <a class="code hl_enumvalue" href="a00182.html#gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e">HWLOC_TYPE_FILTER_KEEP_ALL</a> = 0,</div>
+<div class="line"><a id="l02446" name="l02446"></a><span class="lineno"> 2446</span> </div>
+<div class="line"><a id="l02453" name="l02453"></a><span class="lineno"><a class="line" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a"> 2453</a></span>  <a class="code hl_enumvalue" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a">HWLOC_TYPE_FILTER_KEEP_NONE</a> = 1,</div>
+<div class="line"><a id="l02454" name="l02454"></a><span class="lineno"> 2454</span> </div>
+<div class="line"><a id="l02467" name="l02467"></a><span class="lineno"><a class="line" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4"> 2467</a></span>  <a class="code hl_enumvalue" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4">HWLOC_TYPE_FILTER_KEEP_STRUCTURE</a> = 2,</div>
+<div class="line"><a id="l02468" name="l02468"></a><span class="lineno"> 2468</span> </div>
+<div class="line"><a id="l02482" name="l02482"></a><span class="lineno"> 2482</span>  <a class="code hl_enumvalue" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5">HWLOC_TYPE_FILTER_KEEP_IMPORTANT</a> = 3</div>
+<div class="line"><a id="l02483" name="l02483"></a><span class="lineno"><a class="line" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5"> 2483</a></span>};</div>
+</div>
+<div class="line"><a id="l02484" name="l02484"></a><span class="lineno"> 2484</span> </div>
+<div class="line"><a id="l02489" name="l02489"></a><span class="lineno"><a class="line" href="a00182.html#gad894e70f15f8d4aada7be8d1aba38b7e"> 2489</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00182.html#gad894e70f15f8d4aada7be8d1aba38b7e">hwloc_topology_set_type_filter</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter);</div>
+<div class="line"><a id="l02490" name="l02490"></a><span class="lineno"> 2490</span> </div>
+<div class="line"><a id="l02495" name="l02495"></a><span class="lineno"><a class="line" href="a00182.html#ga137ad1178f7a79f2383974d983083401"> 2495</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00182.html#ga137ad1178f7a79f2383974d983083401">hwloc_topology_get_type_filter</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> *filter);</div>
+<div class="line"><a id="l02496" name="l02496"></a><span class="lineno"> 2496</span> </div>
+<div class="line"><a id="l02503" name="l02503"></a><span class="lineno"><a class="line" href="a00182.html#ga9eb8dc3b106f84921bf5789101e97e24"> 2503</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00182.html#ga9eb8dc3b106f84921bf5789101e97e24">hwloc_topology_set_all_types_filter</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter);</div>
+<div class="line"><a id="l02504" name="l02504"></a><span class="lineno"> 2504</span> </div>
+<div class="line"><a id="l02511" name="l02511"></a><span class="lineno"><a class="line" href="a00182.html#ga30bd6d330fe3c8f0cbaad724d114ee20"> 2511</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00182.html#ga30bd6d330fe3c8f0cbaad724d114ee20">hwloc_topology_set_cache_types_filter</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter);</div>
+<div class="line"><a id="l02512" name="l02512"></a><span class="lineno"> 2512</span> </div>
+<div class="line"><a id="l02519" name="l02519"></a><span class="lineno"><a class="line" href="a00182.html#ga37c7b2e599ed3cd76ad9164630024f30"> 2519</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00182.html#ga37c7b2e599ed3cd76ad9164630024f30">hwloc_topology_set_icache_types_filter</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter);</div>
+<div class="line"><a id="l02520" name="l02520"></a><span class="lineno"> 2520</span> </div>
+<div class="line"><a id="l02525" name="l02525"></a><span class="lineno"><a class="line" href="a00182.html#ga0ab38705357bc1203abe829da8a12ad3"> 2525</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00182.html#ga0ab38705357bc1203abe829da8a12ad3">hwloc_topology_set_io_types_filter</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter);</div>
+<div class="line"><a id="l02526" name="l02526"></a><span class="lineno"> 2526</span> </div>
+<div class="line"><a id="l02537" name="l02537"></a><span class="lineno"><a class="line" href="a00182.html#ga2cc7b7b155cba58dda203e54f1637b9c"> 2537</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> <a class="code hl_function" href="a00182.html#ga2cc7b7b155cba58dda203e54f1637b9c">hwloc_topology_set_userdata</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">const</span> <span class="keywordtype">void</span> *userdata);</div>
+<div class="line"><a id="l02538" name="l02538"></a><span class="lineno"> 2538</span> </div>
+<div class="line"><a id="l02547" name="l02547"></a><span class="lineno"><a class="line" href="a00182.html#gad47dee1a30f4b00486b54872af030b43"> 2547</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> * <a class="code hl_function" href="a00182.html#gad47dee1a30f4b00486b54872af030b43">hwloc_topology_get_userdata</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology);</div>
+<div class="line"><a id="l02548" name="l02548"></a><span class="lineno"> 2548</span> </div>
+<div class="foldopen" id="foldopen02558" data-start="{" data-end="};">
+<div class="line"><a id="l02558" name="l02558"></a><span class="lineno"><a class="line" href="a00183.html#ga9d80f08eb25b7ac22f1b998dc8bf521f"> 2558</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00183.html#ga9d80f08eb25b7ac22f1b998dc8bf521f">hwloc_restrict_flags_e</a> {</div>
+<div class="line"><a id="l02564" name="l02564"></a><span class="lineno"><a class="line" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fa80eeb9cbba401ab050f8fb4573725891"> 2564</a></span>  <a class="code hl_enumvalue" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fa80eeb9cbba401ab050f8fb4573725891">HWLOC_RESTRICT_FLAG_REMOVE_CPULESS</a> = (1UL&lt;&lt;0),</div>
+<div class="line"><a id="l02565" name="l02565"></a><span class="lineno"> 2565</span> </div>
+<div class="line"><a id="l02570" name="l02570"></a><span class="lineno"><a class="line" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fae4c5b1b87232f2d8a60559e77ac65a68"> 2570</a></span>  <a class="code hl_enumvalue" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fae4c5b1b87232f2d8a60559e77ac65a68">HWLOC_RESTRICT_FLAG_BYNODESET</a> =  (1UL&lt;&lt;3),</div>
+<div class="line"><a id="l02571" name="l02571"></a><span class="lineno"> 2571</span> </div>
+<div class="line"><a id="l02577" name="l02577"></a><span class="lineno"><a class="line" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521faf5ba49808855704bfe9cb9fe7347f93b"> 2577</a></span>  <a class="code hl_enumvalue" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521faf5ba49808855704bfe9cb9fe7347f93b">HWLOC_RESTRICT_FLAG_REMOVE_MEMLESS</a> = (1UL&lt;&lt;4),</div>
+<div class="line"><a id="l02578" name="l02578"></a><span class="lineno"> 2578</span> </div>
+<div class="line"><a id="l02583" name="l02583"></a><span class="lineno"><a class="line" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fa699969227a09bbc1a7de51dc9fb7be4b"> 2583</a></span>  <a class="code hl_enumvalue" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fa699969227a09bbc1a7de51dc9fb7be4b">HWLOC_RESTRICT_FLAG_ADAPT_MISC</a> = (1UL&lt;&lt;1),</div>
+<div class="line"><a id="l02584" name="l02584"></a><span class="lineno"> 2584</span> </div>
+<div class="line"><a id="l02589" name="l02589"></a><span class="lineno"> 2589</span>  <a class="code hl_enumvalue" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521faa95d6985e36ec1e55f68b210297a85cb">HWLOC_RESTRICT_FLAG_ADAPT_IO</a> = (1UL&lt;&lt;2)</div>
+<div class="line"><a id="l02590" name="l02590"></a><span class="lineno"><a class="line" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521faa95d6985e36ec1e55f68b210297a85cb"> 2590</a></span>};</div>
+</div>
+<div class="line"><a id="l02591" name="l02591"></a><span class="lineno"> 2591</span> </div>
+<div class="line"><a id="l02627" name="l02627"></a><span class="lineno"><a class="line" href="a00183.html#ga6db81ed13ac0a9d70cc80372ab537815"> 2627</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00183.html#ga6db81ed13ac0a9d70cc80372ab537815">hwloc_topology_restrict</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> __hwloc_restrict topology, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l02628" name="l02628"></a><span class="lineno"> 2628</span> </div>
+<div class="foldopen" id="foldopen02630" data-start="{" data-end="};">
+<div class="line"><a id="l02630" name="l02630"></a><span class="lineno"><a class="line" href="a00183.html#ga38b1be3922094d880f6e76bf56c973d6"> 2630</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00183.html#ga38b1be3922094d880f6e76bf56c973d6">hwloc_allow_flags_e</a> {</div>
+<div class="line"><a id="l02635" name="l02635"></a><span class="lineno"><a class="line" href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6aca107692455774f9d323d21b8abfce72"> 2635</a></span>  <a class="code hl_enumvalue" href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6aca107692455774f9d323d21b8abfce72">HWLOC_ALLOW_FLAG_ALL</a> = (1UL&lt;&lt;0),</div>
+<div class="line"><a id="l02636" name="l02636"></a><span class="lineno"> 2636</span> </div>
+<div class="line"><a id="l02644" name="l02644"></a><span class="lineno"><a class="line" href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6a88c50088c09dcf1e1a496c0817556fb9"> 2644</a></span>  <a class="code hl_enumvalue" href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6a88c50088c09dcf1e1a496c0817556fb9">HWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS</a> = (1UL&lt;&lt;1),</div>
+<div class="line"><a id="l02645" name="l02645"></a><span class="lineno"> 2645</span> </div>
+<div class="line"><a id="l02648" name="l02648"></a><span class="lineno"> 2648</span>  <a class="code hl_enumvalue" href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6a489c8c1b67ce7e0b8cf7a665852760e1">HWLOC_ALLOW_FLAG_CUSTOM</a> = (1UL&lt;&lt;2)</div>
+<div class="line"><a id="l02649" name="l02649"></a><span class="lineno"><a class="line" href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6a489c8c1b67ce7e0b8cf7a665852760e1"> 2649</a></span>};</div>
+</div>
+<div class="line"><a id="l02650" name="l02650"></a><span class="lineno"> 2650</span> </div>
+<div class="line"><a id="l02668" name="l02668"></a><span class="lineno"><a class="line" href="a00183.html#gaf955b190c0299dcfb5bc985d777f92a1"> 2668</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00183.html#gaf955b190c0299dcfb5bc985d777f92a1">hwloc_topology_allow</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> __hwloc_restrict topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> cpuset, <a class="code hl_typedef" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> nodeset, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l02669" name="l02669"></a><span class="lineno"> 2669</span> </div>
+<div class="line"><a id="l02694" name="l02694"></a><span class="lineno"><a class="line" href="a00183.html#gad980782ade737900c5cf208946768c30"> 2694</a></span>HWLOC_DECLSPEC <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> <a class="code hl_function" href="a00183.html#gad980782ade737900c5cf208946768c30">hwloc_topology_insert_misc_object</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> parent, <span class="keyword">const</span> <span class="keywordtype">char</span> *name);</div>
+<div class="line"><a id="l02695" name="l02695"></a><span class="lineno"> 2695</span> </div>
+<div class="line"><a id="l02713" name="l02713"></a><span class="lineno"><a class="line" href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7"> 2713</a></span>HWLOC_DECLSPEC <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> <a class="code hl_function" href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7">hwloc_topology_alloc_group_object</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology);</div>
+<div class="line"><a id="l02714" name="l02714"></a><span class="lineno"> 2714</span> </div>
+<div class="line"><a id="l02726" name="l02726"></a><span class="lineno"><a class="line" href="a00183.html#gac09117be24a8fc5f5dea6acac34e8843"> 2726</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00183.html#gac09117be24a8fc5f5dea6acac34e8843">hwloc_topology_free_group_object</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> group);</div>
+<div class="line"><a id="l02727" name="l02727"></a><span class="lineno"> 2727</span> </div>
+<div class="line"><a id="l02804" name="l02804"></a><span class="lineno"><a class="line" href="a00183.html#ga1fc6012b3e1c249b83f48cb7bcacaa5b"> 2804</a></span>HWLOC_DECLSPEC <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> <a class="code hl_function" href="a00183.html#ga1fc6012b3e1c249b83f48cb7bcacaa5b">hwloc_topology_insert_group_object</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> group);</div>
+<div class="line"><a id="l02805" name="l02805"></a><span class="lineno"> 2805</span> </div>
+<div class="line"><a id="l02818" name="l02818"></a><span class="lineno"><a class="line" href="a00183.html#gad458715d3335df44849216cc123d1055"> 2818</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00183.html#gad458715d3335df44849216cc123d1055">hwloc_obj_add_other_obj_sets</a>(<a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> dst, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> src);</div>
+<div class="line"><a id="l02819" name="l02819"></a><span class="lineno"> 2819</span> </div>
+<div class="line"><a id="l02837" name="l02837"></a><span class="lineno"><a class="line" href="a00183.html#ga698ecd640d2b76742bba3829a145cd9a"> 2837</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00183.html#ga698ecd640d2b76742bba3829a145cd9a">hwloc_topology_refresh</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology);</div>
+<div class="line"><a id="l02838" name="l02838"></a><span class="lineno"> 2838</span> </div>
+<div class="line"><a id="l02843" name="l02843"></a><span class="lineno"> 2843</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l02844" name="l02844"></a><span class="lineno"> 2844</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l02845" name="l02845"></a><span class="lineno"> 2845</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l02846" name="l02846"></a><span class="lineno"> 2846</span> </div>
+<div class="line"><a id="l02847" name="l02847"></a><span class="lineno"> 2847</span> </div>
+<div class="line"><a id="l02848" name="l02848"></a><span class="lineno"> 2848</span><span class="comment">/* high-level helpers */</span></div>
+<div class="line"><a id="l02849" name="l02849"></a><span class="lineno"> 2849</span><span class="preprocessor">#include &quot;hwloc/helper.h&quot;</span></div>
+<div class="line"><a id="l02850" name="l02850"></a><span class="lineno"> 2850</span> </div>
+<div class="line"><a id="l02851" name="l02851"></a><span class="lineno"> 2851</span><span class="comment">/* inline code of some functions above */</span></div>
+<div class="line"><a id="l02852" name="l02852"></a><span class="lineno"> 2852</span><span class="preprocessor">#include &quot;hwloc/inlines.h&quot;</span></div>
+<div class="line"><a id="l02853" name="l02853"></a><span class="lineno"> 2853</span> </div>
+<div class="line"><a id="l02854" name="l02854"></a><span class="lineno"> 2854</span><span class="comment">/* memory attributes */</span></div>
+<div class="line"><a id="l02855" name="l02855"></a><span class="lineno"> 2855</span><span class="preprocessor">#include &quot;hwloc/memattrs.h&quot;</span></div>
+<div class="line"><a id="l02856" name="l02856"></a><span class="lineno"> 2856</span> </div>
+<div class="line"><a id="l02857" name="l02857"></a><span class="lineno"> 2857</span><span class="comment">/* kinds of CPU cores */</span></div>
+<div class="line"><a id="l02858" name="l02858"></a><span class="lineno"> 2858</span><span class="preprocessor">#include &quot;hwloc/cpukinds.h&quot;</span></div>
+<div class="line"><a id="l02859" name="l02859"></a><span class="lineno"> 2859</span> </div>
+<div class="line"><a id="l02860" name="l02860"></a><span class="lineno"> 2860</span><span class="comment">/* exporting to XML or synthetic */</span></div>
+<div class="line"><a id="l02861" name="l02861"></a><span class="lineno"> 2861</span><span class="preprocessor">#include &quot;hwloc/export.h&quot;</span></div>
+<div class="line"><a id="l02862" name="l02862"></a><span class="lineno"> 2862</span> </div>
+<div class="line"><a id="l02863" name="l02863"></a><span class="lineno"> 2863</span><span class="comment">/* distances */</span></div>
+<div class="line"><a id="l02864" name="l02864"></a><span class="lineno"> 2864</span><span class="preprocessor">#include &quot;hwloc/distances.h&quot;</span></div>
+<div class="line"><a id="l02865" name="l02865"></a><span class="lineno"> 2865</span> </div>
+<div class="line"><a id="l02866" name="l02866"></a><span class="lineno"> 2866</span><span class="comment">/* topology diffs */</span></div>
+<div class="line"><a id="l02867" name="l02867"></a><span class="lineno"> 2867</span><span class="preprocessor">#include &quot;hwloc/diff.h&quot;</span></div>
+<div class="line"><a id="l02868" name="l02868"></a><span class="lineno"> 2868</span> </div>
+<div class="line"><a id="l02869" name="l02869"></a><span class="lineno"> 2869</span><span class="comment">/* deprecated headers */</span></div>
+<div class="line"><a id="l02870" name="l02870"></a><span class="lineno"> 2870</span><span class="preprocessor">#include &quot;hwloc/deprecated.h&quot;</span></div>
+<div class="line"><a id="l02871" name="l02871"></a><span class="lineno"> 2871</span> </div>
+<div class="line"><a id="l02872" name="l02872"></a><span class="lineno"> 2872</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00171_html_ga9c0b50c98add1adf57ed1ce85bb5190d"><div class="ttname"><a href="a00171.html#ga9c0b50c98add1adf57ed1ce85bb5190d">hwloc_get_api_version</a></div><div class="ttdeci">unsigned hwloc_get_api_version(void)</div><div class="ttdoc">Indicate at runtime which hwloc API version was used at build time.</div></div>
+<div class="ttc" id="aa00172_html_ga1f784433e9b606261f62d1134f6a3b25"><div class="ttname"><a href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a></div><div class="ttdeci">hwloc_const_bitmap_t hwloc_const_cpuset_t</div><div class="ttdoc">A non-modifiable hwloc_cpuset_t.</div><div class="ttdef"><b>Definition</b> hwloc.h:163</div></div>
+<div class="ttc" id="aa00172_html_ga2f5276235841ad66a79bedad16a5a10c"><div class="ttname"><a href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a></div><div class="ttdeci">hwloc_const_bitmap_t hwloc_const_nodeset_t</div><div class="ttdoc">A non-modifiable hwloc_nodeset_t.</div><div class="ttdef"><b>Definition</b> hwloc.h:181</div></div>
+<div class="ttc" id="aa00172_html_ga37e35730fa7e775b5bb0afe893d6d508"><div class="ttname"><a href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_nodeset_t</div><div class="ttdoc">A node set is a bitmap whose bits are set according to NUMA memory node physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:178</div></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00173_html_ga1820ea0dfd8e9dca28f9ea7624df5ae2"><div class="ttname"><a href="a00173.html#ga1820ea0dfd8e9dca28f9ea7624df5ae2">hwloc_compare_types</a></div><div class="ttdeci">int hwloc_compare_types(hwloc_obj_type_t type1, hwloc_obj_type_t type2)</div><div class="ttdoc">Compare the depth of two object types.</div></div>
+<div class="ttc" id="aa00173_html_ga48a4803c72574191d7ead1c62aaf9860"><div class="ttname"><a href="a00173.html#ga48a4803c72574191d7ead1c62aaf9860">hwloc_obj_bridge_type_e</a></div><div class="ttdeci">hwloc_obj_bridge_type_e</div><div class="ttdoc">Type of one side (upstream or downstream) of an I/O bridge.</div><div class="ttdef"><b>Definition</b> hwloc.h:365</div></div>
+<div class="ttc" id="aa00173_html_ga552ec74296a024237f474acec98694c0"><div class="ttname"><a href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a></div><div class="ttdeci">enum hwloc_obj_cache_type_e hwloc_obj_cache_type_t</div><div class="ttdoc">Cache type.</div></div>
+<div class="ttc" id="aa00173_html_ga64f5d539df299c97ae80ce53fc4b56c0"><div class="ttname"><a href="a00173.html#ga64f5d539df299c97ae80ce53fc4b56c0">hwloc_obj_osdev_type_e</a></div><div class="ttdeci">hwloc_obj_osdev_type_e</div><div class="ttdoc">Type of a OS device.</div><div class="ttdef"><b>Definition</b> hwloc.h:371</div></div>
+<div class="ttc" id="aa00173_html_ga791c9875c8fe20f3e1e5871e0657e59b"><div class="ttname"><a href="a00173.html#ga791c9875c8fe20f3e1e5871e0657e59b">hwloc_obj_cache_type_e</a></div><div class="ttdeci">hwloc_obj_cache_type_e</div><div class="ttdoc">Cache type.</div><div class="ttdef"><b>Definition</b> hwloc.h:358</div></div>
+<div class="ttc" id="aa00173_html_gaa9a6941ef7b1c169412518d7ef71b3d2"><div class="ttname"><a href="a00173.html#gaa9a6941ef7b1c169412518d7ef71b3d2">hwloc_obj_osdev_type_t</a></div><div class="ttdeci">enum hwloc_obj_osdev_type_e hwloc_obj_osdev_type_t</div><div class="ttdoc">Type of a OS device.</div></div>
+<div class="ttc" id="aa00173_html_gab34362c7a23296c3f12c5756747abda3"><div class="ttname"><a href="a00173.html#gab34362c7a23296c3f12c5756747abda3">hwloc_obj_bridge_type_t</a></div><div class="ttdeci">enum hwloc_obj_bridge_type_e hwloc_obj_bridge_type_t</div><div class="ttdoc">Type of one side (upstream or downstream) of an I/O bridge.</div></div>
+<div class="ttc" id="aa00173_html_gacd37bb612667dc437d66bfb175a8dc55"><div class="ttname"><a href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a></div><div class="ttdeci">hwloc_obj_type_t</div><div class="ttdoc">Type of topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:197</div></div>
+<div class="ttc" id="aa00173_html_gga48a4803c72574191d7ead1c62aaf9860a2c7660f3864ad2810c1e72aad285e574"><div class="ttname"><a href="a00173.html#gga48a4803c72574191d7ead1c62aaf9860a2c7660f3864ad2810c1e72aad285e574">HWLOC_OBJ_BRIDGE_HOST</a></div><div class="ttdeci">@ HWLOC_OBJ_BRIDGE_HOST</div><div class="ttdoc">Host-side of a bridge, only possible upstream.</div><div class="ttdef"><b>Definition</b> hwloc.h:366</div></div>
+<div class="ttc" id="aa00173_html_gga48a4803c72574191d7ead1c62aaf9860a8f3b4cecf3dab6073d74696d10863c60"><div class="ttname"><a href="a00173.html#gga48a4803c72574191d7ead1c62aaf9860a8f3b4cecf3dab6073d74696d10863c60">HWLOC_OBJ_BRIDGE_PCI</a></div><div class="ttdeci">@ HWLOC_OBJ_BRIDGE_PCI</div><div class="ttdoc">PCI-side of a bridge.</div><div class="ttdef"><b>Definition</b> hwloc.h:367</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83">HWLOC_OBJ_OSDEV_COPROC</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_COPROC</div><div class="ttdoc">Operating system co-processor device. For instance &quot;opencl0d0&quot; for a OpenCL device,...</div><div class="ttdef"><b>Definition</b> hwloc.h:385</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0a52157d03694fdae82dddd57ca8c973b6"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a52157d03694fdae82dddd57ca8c973b6">HWLOC_OBJ_OSDEV_OPENFABRICS</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_OPENFABRICS</div><div class="ttdoc">Operating system openfabrics device. For instance the &quot;mlx4_0&quot; InfiniBand HCA, &quot;hfi1_0&quot; Omni-Path int...</div><div class="ttdef"><b>Definition</b> hwloc.h:379</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0a689b0488c3c0d08d116751c6b9cb8871"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a689b0488c3c0d08d116751c6b9cb8871">HWLOC_OBJ_OSDEV_BLOCK</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_BLOCK</div><div class="ttdoc">Operating system block device, or non-volatile memory device. For instance &quot;sda&quot; or &quot;dax2....</div><div class="ttdef"><b>Definition</b> hwloc.h:372</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0a827ad1643360711a8b6c6af671366791"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a827ad1643360711a8b6c6af671366791">HWLOC_OBJ_OSDEV_DMA</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_DMA</div><div class="ttdoc">Operating system dma engine device. For instance the &quot;dma0chan0&quot; DMA channel on Linux.</div><div class="ttdef"><b>Definition</b> hwloc.h:383</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90">HWLOC_OBJ_OSDEV_GPU</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_GPU</div><div class="ttdoc">Operating system GPU device. For instance &quot;:0.0&quot; for a GL display, &quot;card0&quot; for a Linux DRM device.</div><div class="ttdef"><b>Definition</b> hwloc.h:374</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0ab715d81155f771573c8682dffc65021b"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0ab715d81155f771573c8682dffc65021b">HWLOC_OBJ_OSDEV_NETWORK</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_NETWORK</div><div class="ttdoc">Operating system network device. For instance the &quot;eth0&quot; interface on Linux.</div><div class="ttdef"><b>Definition</b> hwloc.h:377</div></div>
+<div class="ttc" id="aa00173_html_gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a"><div class="ttname"><a href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a">HWLOC_OBJ_CACHE_UNIFIED</a></div><div class="ttdeci">@ HWLOC_OBJ_CACHE_UNIFIED</div><div class="ttdoc">Unified cache.</div><div class="ttdef"><b>Definition</b> hwloc.h:359</div></div>
+<div class="ttc" id="aa00173_html_gga791c9875c8fe20f3e1e5871e0657e59ba6f98b0d422b38ba90c5f5c79a11b0658"><div class="ttname"><a href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba6f98b0d422b38ba90c5f5c79a11b0658">HWLOC_OBJ_CACHE_INSTRUCTION</a></div><div class="ttdeci">@ HWLOC_OBJ_CACHE_INSTRUCTION</div><div class="ttdoc">Instruction cache (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:361</div></div>
+<div class="ttc" id="aa00173_html_gga791c9875c8fe20f3e1e5871e0657e59bacac60ecad4206f85aeb79bef1604b488"><div class="ttname"><a href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59bacac60ecad4206f85aeb79bef1604b488">HWLOC_OBJ_CACHE_DATA</a></div><div class="ttdeci">@ HWLOC_OBJ_CACHE_DATA</div><div class="ttdoc">Data cache.</div><div class="ttdef"><b>Definition</b> hwloc.h:360</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a0ed5bd98974729a0c476c39e917dabd6"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a0ed5bd98974729a0c476c39e917dabd6">HWLOC_OBJ_MEMCACHE</a></div><div class="ttdeci">@ HWLOC_OBJ_MEMCACHE</div><div class="ttdoc">Memory-side cache (filtered out by default). A cache in front of a specific NUMA node.</div><div class="ttdef"><b>Definition</b> hwloc.h:331</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a10713b7e561b8cc32544cd31b1c17f8d"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a10713b7e561b8cc32544cd31b1c17f8d">HWLOC_OBJ_L2ICACHE</a></div><div class="ttdeci">@ HWLOC_OBJ_L2ICACHE</div><div class="ttdoc">Level 2 instruction Cache (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:241</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a18f61d19fe9f4bcea978fcc68bc078fb"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a18f61d19fe9f4bcea978fcc68bc078fb">HWLOC_OBJ_L2CACHE</a></div><div class="ttdeci">@ HWLOC_OBJ_L2CACHE</div><div class="ttdoc">Level 2 Data (or Unified) Cache.</div><div class="ttdef"><b>Definition</b> hwloc.h:235</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d">HWLOC_OBJ_MISC</a></div><div class="ttdeci">@ HWLOC_OBJ_MISC</div><div class="ttdoc">Miscellaneous objects (filtered out by default). Objects without particular meaning,...</div><div class="ttdef"><b>Definition</b> hwloc.h:316</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a25fae0e0514c90e3973a29866a5a837d"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a25fae0e0514c90e3973a29866a5a837d">HWLOC_OBJ_L3CACHE</a></div><div class="ttdeci">@ HWLOC_OBJ_L3CACHE</div><div class="ttdoc">Level 3 Data (or Unified) Cache.</div><div class="ttdef"><b>Definition</b> hwloc.h:236</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a3f4e83ffc4a259354959ae8a9eaa2a80"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a3f4e83ffc4a259354959ae8a9eaa2a80">HWLOC_OBJ_MACHINE</a></div><div class="ttdeci">@ HWLOC_OBJ_MACHINE</div><div class="ttdoc">Machine. A set of processors and memory with cache coherency.</div><div class="ttdef"><b>Definition</b> hwloc.h:203</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075">HWLOC_OBJ_OS_DEVICE</a></div><div class="ttdeci">@ HWLOC_OBJ_OS_DEVICE</div><div class="ttdoc">Operating system device (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:305</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56">HWLOC_OBJ_GROUP</a></div><div class="ttdeci">@ HWLOC_OBJ_GROUP</div><div class="ttdoc">Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take...</div><div class="ttdef"><b>Definition</b> hwloc.h:244</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a54923bfa13df9d7e6d6dd0d5baff5f72"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a54923bfa13df9d7e6d6dd0d5baff5f72">HWLOC_OBJ_L4CACHE</a></div><div class="ttdeci">@ HWLOC_OBJ_L4CACHE</div><div class="ttdoc">Level 4 Data (or Unified) Cache.</div><div class="ttdef"><b>Definition</b> hwloc.h:237</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a56389b8eb2e2f74f288bb657c4e72140"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a56389b8eb2e2f74f288bb657c4e72140">HWLOC_OBJ_L1CACHE</a></div><div class="ttdeci">@ HWLOC_OBJ_L1CACHE</div><div class="ttdoc">Level 1 Data (or Unified) Cache.</div><div class="ttdef"><b>Definition</b> hwloc.h:234</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div><div class="ttdeci">@ HWLOC_OBJ_PCI_DEVICE</div><div class="ttdoc">PCI device (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:295</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a67194c9de5e3e581c64c11d2eb1c109d"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a67194c9de5e3e581c64c11d2eb1c109d">HWLOC_OBJ_L5CACHE</a></div><div class="ttdeci">@ HWLOC_OBJ_L5CACHE</div><div class="ttdoc">Level 5 Data (or Unified) Cache.</div><div class="ttdef"><b>Definition</b> hwloc.h:238</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0">HWLOC_OBJ_BRIDGE</a></div><div class="ttdeci">@ HWLOC_OBJ_BRIDGE</div><div class="ttdoc">Bridge (filtered out by default). Any bridge (or PCI switch) that connects the host or an I/O bus,...</div><div class="ttdef"><b>Definition</b> hwloc.h:283</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a></div><div class="ttdeci">@ HWLOC_OBJ_NUMANODE</div><div class="ttdoc">NUMA node. An object that contains memory that is directly and byte-accessible to the host processors...</div><div class="ttdef"><b>Definition</b> hwloc.h:257</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55ab16ab8c0dbffc234921d86f3dfb63129"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ab16ab8c0dbffc234921d86f3dfb63129">HWLOC_OBJ_PACKAGE</a></div><div class="ttdeci">@ HWLOC_OBJ_PACKAGE</div><div class="ttdoc">Physical package. The physical package that usually gets inserted into a socket on the motherboard....</div><div class="ttdef"><b>Definition</b> hwloc.h:212</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661">HWLOC_OBJ_PU</a></div><div class="ttdeci">@ HWLOC_OBJ_PU</div><div class="ttdoc">Processing Unit, or (Logical) Processor. An execution unit (may share a core with some other logical ...</div><div class="ttdef"><b>Definition</b> hwloc.h:222</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55ac22850c717f07bf7ffb316fadd08d218"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ac22850c717f07bf7ffb316fadd08d218">HWLOC_OBJ_L3ICACHE</a></div><div class="ttdeci">@ HWLOC_OBJ_L3ICACHE</div><div class="ttdoc">Level 3 instruction Cache (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:242</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55ac793958f330bca371aa1535de8aff45f"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ac793958f330bca371aa1535de8aff45f">HWLOC_OBJ_CORE</a></div><div class="ttdeci">@ HWLOC_OBJ_CORE</div><div class="ttdoc">Core. A computation unit (may be shared by several PUs, aka logical processors).</div><div class="ttdef"><b>Definition</b> hwloc.h:218</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55af78bb6cde53aaaaa162a7dc420c409da"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55af78bb6cde53aaaaa162a7dc420c409da">HWLOC_OBJ_DIE</a></div><div class="ttdeci">@ HWLOC_OBJ_DIE</div><div class="ttdoc">Die within a physical package. A subpart of the physical package, that contains multiple cores.</div><div class="ttdef"><b>Definition</b> hwloc.h:344</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55afa834a85d9e53836cf0db6d0bd8329b4"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55afa834a85d9e53836cf0db6d0bd8329b4">HWLOC_OBJ_L1ICACHE</a></div><div class="ttdeci">@ HWLOC_OBJ_L1ICACHE</div><div class="ttdoc">Level 1 instruction Cache (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:240</div></div>
+<div class="ttc" id="aa00174_html_ga79b8ab56877ef99ac59b833203391c7d"><div class="ttname"><a href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a></div><div class="ttdeci">struct hwloc_obj * hwloc_obj_t</div><div class="ttdoc">Convenience typedef; a pointer to a struct hwloc_obj.</div><div class="ttdef"><b>Definition</b> hwloc.h:631</div></div>
+<div class="ttc" id="aa00175_html_ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa"><div class="ttname"><a href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa">hwloc_topology_init</a></div><div class="ttdeci">int hwloc_topology_init(hwloc_topology_t *topologyp)</div><div class="ttdoc">Allocate a topology context.</div></div>
+<div class="ttc" id="aa00175_html_ga0647ae66458fe68172eb5a320042f870"><div class="ttname"><a href="a00175.html#ga0647ae66458fe68172eb5a320042f870">hwloc_topology_abi_check</a></div><div class="ttdeci">int hwloc_topology_abi_check(hwloc_topology_t topology)</div><div class="ttdoc">Verify that the topology is compatible with the current hwloc library.</div></div>
+<div class="ttc" id="aa00175_html_ga62a161fc5e6f120344dc69a7bee4e587"><div class="ttname"><a href="a00175.html#ga62a161fc5e6f120344dc69a7bee4e587">hwloc_topology_dup</a></div><div class="ttdeci">int hwloc_topology_dup(hwloc_topology_t *newtopology, hwloc_topology_t oldtopology)</div><div class="ttdoc">Duplicate a topology.</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00175_html_ga9f34a640b6fd28d23699d4d084667b15"><div class="ttname"><a href="a00175.html#ga9f34a640b6fd28d23699d4d084667b15">hwloc_topology_destroy</a></div><div class="ttdeci">void hwloc_topology_destroy(hwloc_topology_t topology)</div><div class="ttdoc">Terminate and free a topology context.</div></div>
+<div class="ttc" id="aa00175_html_gabdf58d87ad77f6615fccdfe0535ff826"><div class="ttname"><a href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826">hwloc_topology_load</a></div><div class="ttdeci">int hwloc_topology_load(hwloc_topology_t topology)</div><div class="ttdoc">Build the actual topology.</div></div>
+<div class="ttc" id="aa00175_html_gaf6746bc3a558ef1ac8348b4491d091b5"><div class="ttname"><a href="a00175.html#gaf6746bc3a558ef1ac8348b4491d091b5">hwloc_topology_check</a></div><div class="ttdeci">void hwloc_topology_check(hwloc_topology_t topology)</div><div class="ttdoc">Run internal checks on a topology structure.</div></div>
+<div class="ttc" id="aa00176_html_ga1d5ceafe8130fe6e8657bf0bc666ba50"><div class="ttname"><a href="a00176.html#ga1d5ceafe8130fe6e8657bf0bc666ba50">hwloc_get_nbobjs_by_depth</a></div><div class="ttdeci">unsigned hwloc_get_nbobjs_by_depth(hwloc_topology_t topology, int depth)</div><div class="ttdoc">Returns the width of level at depth depth.</div></div>
+<div class="ttc" id="aa00176_html_ga2d4b12fc187dfc53b35f2fa21d21044d"><div class="ttname"><a href="a00176.html#ga2d4b12fc187dfc53b35f2fa21d21044d">hwloc_get_root_obj</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_root_obj(hwloc_topology_t topology)</div><div class="ttdoc">Returns the top-object of the topology-tree.</div></div>
+<div class="ttc" id="aa00176_html_ga391f6b2613f0065673eaa4069b93d4e0"><div class="ttname"><a href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0">hwloc_get_obj_by_depth</a></div><div class="ttdeci">hwloc_obj_t hwloc_get_obj_by_depth(hwloc_topology_t topology, int depth, unsigned idx)</div><div class="ttdoc">Returns the topology object at logical index idx from depth depth.</div></div>
+<div class="ttc" id="aa00176_html_ga506b0682b98aa264d53e934d2e9badb0"><div class="ttname"><a href="a00176.html#ga506b0682b98aa264d53e934d2e9badb0">hwloc_get_depth_type</a></div><div class="ttdeci">hwloc_obj_type_t hwloc_get_depth_type(hwloc_topology_t topology, int depth)</div><div class="ttdoc">Returns the type of objects at depth depth.</div></div>
+<div class="ttc" id="aa00176_html_ga6f414dd80a2b943967a0ac92da3181a2"><div class="ttname"><a href="a00176.html#ga6f414dd80a2b943967a0ac92da3181a2">hwloc_get_obj_by_type</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_obj_by_type(hwloc_topology_t topology, hwloc_obj_type_t type, unsigned idx)</div><div class="ttdoc">Returns the topology object at logical index idx with type type.</div></div>
+<div class="ttc" id="aa00176_html_ga759e88eaf5a230ad283e9d4c42486735"><div class="ttname"><a href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735">hwloc_get_next_obj_by_type</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_obj_by_type(hwloc_topology_t topology, hwloc_obj_type_t type, hwloc_obj_t prev)</div><div class="ttdoc">Returns the next object of type type.</div></div>
+<div class="ttc" id="aa00176_html_ga789a3f65aedff644be64a18526a03065"><div class="ttname"><a href="a00176.html#ga789a3f65aedff644be64a18526a03065">hwloc_get_nbobjs_by_type</a></div><div class="ttdeci">static int hwloc_get_nbobjs_by_type(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Returns the width of level type type.</div></div>
+<div class="ttc" id="aa00176_html_ga8125328e69eba709c33ea8055c12589b"><div class="ttname"><a href="a00176.html#ga8125328e69eba709c33ea8055c12589b">hwloc_get_type_or_below_depth</a></div><div class="ttdeci">static int hwloc_get_type_or_below_depth(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Returns the depth of objects of type type or below.</div></div>
+<div class="ttc" id="aa00176_html_ga8a9ee573b7d2190272095d10712a7cca"><div class="ttname"><a href="a00176.html#ga8a9ee573b7d2190272095d10712a7cca">hwloc_get_type_or_above_depth</a></div><div class="ttdeci">static int hwloc_get_type_or_above_depth(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Returns the depth of objects of type type or above.</div></div>
+<div class="ttc" id="aa00176_html_ga8bec782e21be313750da70cf7428b374"><div class="ttname"><a href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a></div><div class="ttdeci">int hwloc_get_type_depth(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Returns the depth of objects of type type.</div></div>
+<div class="ttc" id="aa00176_html_gac140a9b939d9fa0b30c4a910efcb0656"><div class="ttname"><a href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_obj_by_depth(hwloc_topology_t topology, int depth, hwloc_obj_t prev)</div><div class="ttdoc">Returns the next object at depth depth.</div></div>
+<div class="ttc" id="aa00176_html_gae54d1782ca9b54bea915f5c18a9158fa"><div class="ttname"><a href="a00176.html#gae54d1782ca9b54bea915f5c18a9158fa">hwloc_topology_get_depth</a></div><div class="ttdeci">int hwloc_topology_get_depth(hwloc_topology_t restrict topology)</div><div class="ttdoc">Get the depth of the hierarchical tree of objects.</div></div>
+<div class="ttc" id="aa00176_html_gae85786340b88e24835f8c403a1e2e54b"><div class="ttname"><a href="a00176.html#gae85786340b88e24835f8c403a1e2e54b">hwloc_get_memory_parents_depth</a></div><div class="ttdeci">int hwloc_get_memory_parents_depth(hwloc_topology_t topology)</div><div class="ttdoc">Return the depth of parents where memory objects are attached.</div></div>
+<div class="ttc" id="aa00176_html_gaf4e663cf42bbe20756b849c6293ef575"><div class="ttname"><a href="a00176.html#gaf4e663cf42bbe20756b849c6293ef575">hwloc_get_type_depth_e</a></div><div class="ttdeci">hwloc_get_type_depth_e</div><div class="ttdef"><b>Definition</b> hwloc.h:878</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_UNKNOWN</div><div class="ttdoc">No object of given type exists in the topology.</div><div class="ttdef"><b>Definition</b> hwloc.h:879</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575a245c34ec9884c2cf5de5049b2153ed9c"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a245c34ec9884c2cf5de5049b2153ed9c">HWLOC_TYPE_DEPTH_NUMANODE</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_NUMANODE</div><div class="ttdoc">Virtual depth for NUMA nodes.</div><div class="ttdef"><b>Definition</b> hwloc.h:881</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575a8b8d7d300c018c0eb65e6c9a9f162101"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a8b8d7d300c018c0eb65e6c9a9f162101">HWLOC_TYPE_DEPTH_MEMCACHE</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_MEMCACHE</div><div class="ttdoc">Virtual depth for MemCache object.</div><div class="ttdef"><b>Definition</b> hwloc.h:886</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575a96436a392b4cdcaa1a29bc65351b373f"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a96436a392b4cdcaa1a29bc65351b373f">HWLOC_TYPE_DEPTH_MISC</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_MISC</div><div class="ttdoc">Virtual depth for Misc object.</div><div class="ttdef"><b>Definition</b> hwloc.h:885</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575ad8b1516e699b57ce1c8d107fbd2f674c"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ad8b1516e699b57ce1c8d107fbd2f674c">HWLOC_TYPE_DEPTH_PCI_DEVICE</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_PCI_DEVICE</div><div class="ttdoc">Virtual depth for PCI device object level.</div><div class="ttdef"><b>Definition</b> hwloc.h:883</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">HWLOC_TYPE_DEPTH_MULTIPLE</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_MULTIPLE</div><div class="ttdoc">Objects of given type exist at different depth in the topology (only for Groups).</div><div class="ttdef"><b>Definition</b> hwloc.h:880</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575af93b50182973e4a718d9d4db9e253a90"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575af93b50182973e4a718d9d4db9e253a90">HWLOC_TYPE_DEPTH_BRIDGE</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_BRIDGE</div><div class="ttdoc">Virtual depth for bridge object level.</div><div class="ttdef"><b>Definition</b> hwloc.h:882</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575afe9a2131073eebbe129d4aa2928d3f46"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575afe9a2131073eebbe129d4aa2928d3f46">HWLOC_TYPE_DEPTH_OS_DEVICE</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_OS_DEVICE</div><div class="ttdoc">Virtual depth for software device object level.</div><div class="ttdef"><b>Definition</b> hwloc.h:884</div></div>
+<div class="ttc" id="aa00177_html_ga510f21b066fba2dab12b8c9b173b1dfd"><div class="ttname"><a href="a00177.html#ga510f21b066fba2dab12b8c9b173b1dfd">hwloc_type_sscanf</a></div><div class="ttdeci">int hwloc_type_sscanf(const char *string, hwloc_obj_type_t *typep, union hwloc_obj_attr_u *attrp, size_t attrsize)</div><div class="ttdoc">Return an object type and attributes from a type string.</div></div>
+<div class="ttc" id="aa00177_html_ga52c63cd7203e55b804c1314affc9bd12"><div class="ttname"><a href="a00177.html#ga52c63cd7203e55b804c1314affc9bd12">hwloc_type_sscanf_as_depth</a></div><div class="ttdeci">int hwloc_type_sscanf_as_depth(const char *string, hwloc_obj_type_t *typep, hwloc_topology_t topology, int *depthp)</div><div class="ttdoc">Return an object type and its level depth from a type string.</div></div>
+<div class="ttc" id="aa00177_html_ga6a38b931e5d45e8af4323a169482fe39"><div class="ttname"><a href="a00177.html#ga6a38b931e5d45e8af4323a169482fe39">hwloc_obj_type_string</a></div><div class="ttdeci">const char * hwloc_obj_type_string(hwloc_obj_type_t type)</div><div class="ttdoc">Return a constant stringified object type.</div></div>
+<div class="ttc" id="aa00177_html_ga870e876931c282a1c7aee2f031912ce3"><div class="ttname"><a href="a00177.html#ga870e876931c282a1c7aee2f031912ce3">hwloc_obj_attr_snprintf</a></div><div class="ttdeci">int hwloc_obj_attr_snprintf(char *restrict string, size_t size, hwloc_obj_t obj, const char *restrict separator, int verbose)</div><div class="ttdoc">Stringify the attributes of a given topology object into a human-readable form.</div></div>
+<div class="ttc" id="aa00177_html_gadb8765c260edea80c52cd06a76639ba4"><div class="ttname"><a href="a00177.html#gadb8765c260edea80c52cd06a76639ba4">hwloc_obj_type_snprintf</a></div><div class="ttdeci">int hwloc_obj_type_snprintf(char *restrict string, size_t size, hwloc_obj_t obj, int verbose)</div><div class="ttdoc">Stringify the type of a given topology object into a human-readable form.</div></div>
+<div class="ttc" id="aa00178_html_ga415c4e44beada7ea34cd4bad9944b170"><div class="ttname"><a href="a00178.html#ga415c4e44beada7ea34cd4bad9944b170">hwloc_obj_get_info_by_name</a></div><div class="ttdeci">static const char * hwloc_obj_get_info_by_name(hwloc_obj_t obj, const char *name)</div><div class="ttdoc">Search the given name in object infos and return the corresponding value.</div></div>
+<div class="ttc" id="aa00178_html_ga6a07031b69bc7466b6fc4d13d610d47a"><div class="ttname"><a href="a00178.html#ga6a07031b69bc7466b6fc4d13d610d47a">hwloc_obj_set_subtype</a></div><div class="ttdeci">int hwloc_obj_set_subtype(hwloc_topology_t topology, hwloc_obj_t obj, const char *subtype)</div><div class="ttdoc">Set (or replace) the subtype of an object.</div></div>
+<div class="ttc" id="aa00178_html_gace7654bb8a9002caae1a4b8a59e7452e"><div class="ttname"><a href="a00178.html#gace7654bb8a9002caae1a4b8a59e7452e">hwloc_obj_add_info</a></div><div class="ttdeci">int hwloc_obj_add_info(hwloc_obj_t obj, const char *name, const char *value)</div><div class="ttdoc">Add the given name and value pair to the given object info attributes.</div></div>
+<div class="ttc" id="aa00179_html_ga217dc8d373f8958cc93c154ebce1c71c"><div class="ttname"><a href="a00179.html#ga217dc8d373f8958cc93c154ebce1c71c">hwloc_cpubind_flags_t</a></div><div class="ttdeci">hwloc_cpubind_flags_t</div><div class="ttdoc">Process/Thread binding flags.</div><div class="ttdef"><b>Definition</b> hwloc.h:1249</div></div>
+<div class="ttc" id="aa00179_html_ga296db8a3c6d49b51fb83d6f3e45c02a6"><div class="ttname"><a href="a00179.html#ga296db8a3c6d49b51fb83d6f3e45c02a6">hwloc_set_proc_cpubind</a></div><div class="ttdeci">int hwloc_set_proc_cpubind(hwloc_topology_t topology, hwloc_pid_t pid, hwloc_const_cpuset_t set, int flags)</div><div class="ttdoc">Bind a process pid on CPUs given in physical bitmap set.</div></div>
+<div class="ttc" id="aa00179_html_ga80bc07473a8edf840cae17bd7ec21d48"><div class="ttname"><a href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48">hwloc_set_cpubind</a></div><div class="ttdeci">int hwloc_set_cpubind(hwloc_topology_t topology, hwloc_const_cpuset_t set, int flags)</div><div class="ttdoc">Bind current process or thread on CPUs given in physical bitmap set.</div></div>
+<div class="ttc" id="aa00179_html_ga910a05c2d47f68a3155bf176b50fa555"><div class="ttname"><a href="a00179.html#ga910a05c2d47f68a3155bf176b50fa555">hwloc_get_proc_last_cpu_location</a></div><div class="ttdeci">int hwloc_get_proc_last_cpu_location(hwloc_topology_t topology, hwloc_pid_t pid, hwloc_cpuset_t set, int flags)</div><div class="ttdoc">Get the last physical CPU where a process ran.</div></div>
+<div class="ttc" id="aa00179_html_gac82de91f788fa82dacf99c6e0d4b7158"><div class="ttname"><a href="a00179.html#gac82de91f788fa82dacf99c6e0d4b7158">hwloc_get_proc_cpubind</a></div><div class="ttdeci">int hwloc_get_proc_cpubind(hwloc_topology_t topology, hwloc_pid_t pid, hwloc_cpuset_t set, int flags)</div><div class="ttdoc">Get the current physical binding of process pid.</div></div>
+<div class="ttc" id="aa00179_html_gacba7ecb979baf824d5240fa2cb2a8be6"><div class="ttname"><a href="a00179.html#gacba7ecb979baf824d5240fa2cb2a8be6">hwloc_get_cpubind</a></div><div class="ttdeci">int hwloc_get_cpubind(hwloc_topology_t topology, hwloc_cpuset_t set, int flags)</div><div class="ttdoc">Get current process or thread binding.</div></div>
+<div class="ttc" id="aa00179_html_gae42c01b2addcfbf6048b9a516dd7a906"><div class="ttname"><a href="a00179.html#gae42c01b2addcfbf6048b9a516dd7a906">hwloc_set_thread_cpubind</a></div><div class="ttdeci">int hwloc_set_thread_cpubind(hwloc_topology_t topology, hwloc_thread_t thread, hwloc_const_cpuset_t set, int flags)</div><div class="ttdoc">Bind a thread thread on CPUs given in physical bitmap set.</div></div>
+<div class="ttc" id="aa00179_html_gaf13f765642b5d0d9a9813e6bb043671b"><div class="ttname"><a href="a00179.html#gaf13f765642b5d0d9a9813e6bb043671b">hwloc_get_thread_cpubind</a></div><div class="ttdeci">int hwloc_get_thread_cpubind(hwloc_topology_t topology, hwloc_thread_t thread, hwloc_cpuset_t set, int flags)</div><div class="ttdoc">Get the current physical binding of thread tid.</div></div>
+<div class="ttc" id="aa00179_html_gafdb374627358bf09203b5a4215b13032"><div class="ttname"><a href="a00179.html#gafdb374627358bf09203b5a4215b13032">hwloc_get_last_cpu_location</a></div><div class="ttdeci">int hwloc_get_last_cpu_location(hwloc_topology_t topology, hwloc_cpuset_t set, int flags)</div><div class="ttdoc">Get the last physical CPU where the current process or thread ran.</div></div>
+<div class="ttc" id="aa00179_html_gga217dc8d373f8958cc93c154ebce1c71ca2e0dd0128dac6b03408c7dd170477fdc"><div class="ttname"><a href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca2e0dd0128dac6b03408c7dd170477fdc">HWLOC_CPUBIND_PROCESS</a></div><div class="ttdeci">@ HWLOC_CPUBIND_PROCESS</div><div class="ttdoc">Bind all threads of the current (possibly) multithreaded process.</div><div class="ttdef"><b>Definition</b> hwloc.h:1252</div></div>
+<div class="ttc" id="aa00179_html_gga217dc8d373f8958cc93c154ebce1c71ca41ce440443cc3087caed95ab60edcad6"><div class="ttname"><a href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca41ce440443cc3087caed95ab60edcad6">HWLOC_CPUBIND_NOMEMBIND</a></div><div class="ttdeci">@ HWLOC_CPUBIND_NOMEMBIND</div><div class="ttdoc">Avoid any effect on memory binding.</div><div class="ttdef"><b>Definition</b> hwloc.h:1298</div></div>
+<div class="ttc" id="aa00179_html_gga217dc8d373f8958cc93c154ebce1c71ca679a7e0f0c7ee06b123565f90d98e7fa"><div class="ttname"><a href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca679a7e0f0c7ee06b123565f90d98e7fa">HWLOC_CPUBIND_STRICT</a></div><div class="ttdeci">@ HWLOC_CPUBIND_STRICT</div><div class="ttdoc">Request for strict binding from the OS.</div><div class="ttdef"><b>Definition</b> hwloc.h:1281</div></div>
+<div class="ttc" id="aa00179_html_gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421"><div class="ttname"><a href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421">HWLOC_CPUBIND_THREAD</a></div><div class="ttdeci">@ HWLOC_CPUBIND_THREAD</div><div class="ttdoc">Bind current thread of current process.</div><div class="ttdef"><b>Definition</b> hwloc.h:1256</div></div>
+<div class="ttc" id="aa00180_html_ga020951efa0ce3862bd4faec295501a7f"><div class="ttname"><a href="a00180.html#ga020951efa0ce3862bd4faec295501a7f">hwloc_set_membind</a></div><div class="ttdeci">int hwloc_set_membind(hwloc_topology_t topology, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</div><div class="ttdoc">Set the default memory binding policy of the current process or thread to prefer the NUMA node(s) spe...</div></div>
+<div class="ttc" id="aa00180_html_ga1730ceb18ec6ee3b7bd3d0db81f07dc8"><div class="ttname"><a href="a00180.html#ga1730ceb18ec6ee3b7bd3d0db81f07dc8">hwloc_get_proc_membind</a></div><div class="ttdeci">int hwloc_get_proc_membind(hwloc_topology_t topology, hwloc_pid_t pid, hwloc_bitmap_t set, hwloc_membind_policy_t *policy, int flags)</div><div class="ttdoc">Query the default memory binding policy and physical locality of the specified process.</div></div>
+<div class="ttc" id="aa00180_html_ga32dbd4f54e9e4a7179f2dde37ffe6ad7"><div class="ttname"><a href="a00180.html#ga32dbd4f54e9e4a7179f2dde37ffe6ad7">hwloc_free</a></div><div class="ttdeci">int hwloc_free(hwloc_topology_t topology, void *addr, size_t len)</div><div class="ttdoc">Free memory that was previously allocated by hwloc_alloc() or hwloc_alloc_membind().</div></div>
+<div class="ttc" id="aa00180_html_ga537c7508a4e2d1db05673ec5be6e805c"><div class="ttname"><a href="a00180.html#ga537c7508a4e2d1db05673ec5be6e805c">hwloc_get_area_memlocation</a></div><div class="ttdeci">int hwloc_get_area_memlocation(hwloc_topology_t topology, const void *addr, size_t len, hwloc_bitmap_t set, int flags)</div><div class="ttdoc">Get the NUMA nodes where memory identified by (addr, len ) is physically allocated.</div></div>
+<div class="ttc" id="aa00180_html_ga64e5f75165ea52930f67b17ef4aed2e8"><div class="ttname"><a href="a00180.html#ga64e5f75165ea52930f67b17ef4aed2e8">hwloc_alloc_membind_policy</a></div><div class="ttdeci">static void * hwloc_alloc_membind_policy(hwloc_topology_t topology, size_t len, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</div><div class="ttdoc">Allocate some memory on NUMA memory nodes specified by set.</div></div>
+<div class="ttc" id="aa00180_html_ga95856d8f13357f247d5fce142d443ae3"><div class="ttname"><a href="a00180.html#ga95856d8f13357f247d5fce142d443ae3">hwloc_alloc</a></div><div class="ttdeci">void * hwloc_alloc(hwloc_topology_t topology, size_t len)</div><div class="ttdoc">Allocate some memory.</div></div>
+<div class="ttc" id="aa00180_html_gaa87e0a6946ff145914fdf0b1c60567f8"><div class="ttname"><a href="a00180.html#gaa87e0a6946ff145914fdf0b1c60567f8">hwloc_get_area_membind</a></div><div class="ttdeci">int hwloc_get_area_membind(hwloc_topology_t topology, const void *addr, size_t len, hwloc_bitmap_t set, hwloc_membind_policy_t *policy, int flags)</div><div class="ttdoc">Query the CPUs near the physical NUMA node(s) and binding policy of the memory identified by (addr,...</div></div>
+<div class="ttc" id="aa00180_html_gab00475fd98815bf4fb9aaf752030e7d2"><div class="ttname"><a href="a00180.html#gab00475fd98815bf4fb9aaf752030e7d2">hwloc_membind_flags_t</a></div><div class="ttdeci">hwloc_membind_flags_t</div><div class="ttdoc">Memory binding flags.</div><div class="ttdef"><b>Definition</b> hwloc.h:1586</div></div>
+<div class="ttc" id="aa00180_html_gabc91ff16f7e41047924e3a4ae6d9da7e"><div class="ttname"><a href="a00180.html#gabc91ff16f7e41047924e3a4ae6d9da7e">hwloc_set_proc_membind</a></div><div class="ttdeci">int hwloc_set_proc_membind(hwloc_topology_t topology, hwloc_pid_t pid, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</div><div class="ttdoc">Set the default memory binding policy of the specified process to prefer the NUMA node(s) specified b...</div></div>
+<div class="ttc" id="aa00180_html_gac9764f79505775d06407b40f5e4661e8"><div class="ttname"><a href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a></div><div class="ttdeci">hwloc_membind_policy_t</div><div class="ttdoc">Memory binding policy.</div><div class="ttdef"><b>Definition</b> hwloc.h:1507</div></div>
+<div class="ttc" id="aa00180_html_gadf87089ef533db40460ccc24b5bc0d65"><div class="ttname"><a href="a00180.html#gadf87089ef533db40460ccc24b5bc0d65">hwloc_alloc_membind</a></div><div class="ttdeci">void * hwloc_alloc_membind(hwloc_topology_t topology, size_t len, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</div><div class="ttdoc">Allocate some memory on NUMA memory nodes specified by set.</div></div>
+<div class="ttc" id="aa00180_html_gae21f0a1a884929c784bebf070252aa56"><div class="ttname"><a href="a00180.html#gae21f0a1a884929c784bebf070252aa56">hwloc_get_membind</a></div><div class="ttdeci">int hwloc_get_membind(hwloc_topology_t topology, hwloc_bitmap_t set, hwloc_membind_policy_t *policy, int flags)</div><div class="ttdoc">Query the default memory binding policy and physical locality of the current process or thread.</div></div>
+<div class="ttc" id="aa00180_html_gaf881faefe20701229f07dd7dbd0125ed"><div class="ttname"><a href="a00180.html#gaf881faefe20701229f07dd7dbd0125ed">hwloc_set_area_membind</a></div><div class="ttdeci">int hwloc_set_area_membind(hwloc_topology_t topology, const void *addr, size_t len, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</div><div class="ttdoc">Bind the already-allocated memory identified by (addr, len) to the NUMA node(s) specified by set.</div></div>
+<div class="ttc" id="aa00180_html_ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6"><div class="ttname"><a href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a></div><div class="ttdeci">@ HWLOC_MEMBIND_STRICT</div><div class="ttdef"><b>Definition</b> hwloc.h:1604</div></div>
+<div class="ttc" id="aa00180_html_ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4"><div class="ttname"><a href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4">HWLOC_MEMBIND_PROCESS</a></div><div class="ttdeci">@ HWLOC_MEMBIND_PROCESS</div><div class="ttdoc">Set policy for all threads of the specified (possibly multithreaded) process. This flag is mutually e...</div><div class="ttdef"><b>Definition</b> hwloc.h:1591</div></div>
+<div class="ttc" id="aa00180_html_ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298"><div class="ttname"><a href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298">HWLOC_MEMBIND_THREAD</a></div><div class="ttdeci">@ HWLOC_MEMBIND_THREAD</div><div class="ttdoc">Set policy for a specific thread of the current process. This flag is mutually exclusive with HWLOC_M...</div><div class="ttdef"><b>Definition</b> hwloc.h:1596</div></div>
+<div class="ttc" id="aa00180_html_ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256"><div class="ttname"><a href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256">HWLOC_MEMBIND_BYNODESET</a></div><div class="ttdeci">@ HWLOC_MEMBIND_BYNODESET</div><div class="ttdoc">Consider the bitmap argument as a nodeset.</div><div class="ttdef"><b>Definition</b> hwloc.h:1634</div></div>
+<div class="ttc" id="aa00180_html_ggab00475fd98815bf4fb9aaf752030e7d2aa6e49e54f52827cb143cc869cfd748af"><div class="ttname"><a href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2aa6e49e54f52827cb143cc869cfd748af">HWLOC_MEMBIND_MIGRATE</a></div><div class="ttdeci">@ HWLOC_MEMBIND_MIGRATE</div><div class="ttdoc">Migrate existing allocated memory. If the memory cannot be migrated and the HWLOC_MEMBIND_STRICT flag...</div><div class="ttdef"><b>Definition</b> hwloc.h:1610</div></div>
+<div class="ttc" id="aa00180_html_ggab00475fd98815bf4fb9aaf752030e7d2aad6b9eaf2ee324ca58dc8f58094b9997"><div class="ttname"><a href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2aad6b9eaf2ee324ca58dc8f58094b9997">HWLOC_MEMBIND_NOCPUBIND</a></div><div class="ttdeci">@ HWLOC_MEMBIND_NOCPUBIND</div><div class="ttdoc">Avoid any effect on CPU binding.</div><div class="ttdef"><b>Definition</b> hwloc.h:1623</div></div>
+<div class="ttc" id="aa00180_html_ggac9764f79505775d06407b40f5e4661e8a18675bb80ebc1bce5b652e9de8f3998c"><div class="ttname"><a href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a18675bb80ebc1bce5b652e9de8f3998c">HWLOC_MEMBIND_DEFAULT</a></div><div class="ttdeci">@ HWLOC_MEMBIND_DEFAULT</div><div class="ttdoc">Reset the memory allocation policy to the system default. Depending on the operating system,...</div><div class="ttdef"><b>Definition</b> hwloc.h:1515</div></div>
+<div class="ttc" id="aa00180_html_ggac9764f79505775d06407b40f5e4661e8a3185bd869b67817fb2bd5164bf360402"><div class="ttname"><a href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a3185bd869b67817fb2bd5164bf360402">HWLOC_MEMBIND_MIXED</a></div><div class="ttdeci">@ HWLOC_MEMBIND_MIXED</div><div class="ttdoc">Returned by get_membind() functions when multiple threads or parts of a memory area have differing me...</div><div class="ttdef"><b>Definition</b> hwloc.h:1570</div></div>
+<div class="ttc" id="aa00180_html_ggac9764f79505775d06407b40f5e4661e8a979c7aa78dd32780858f30f47a72cca0"><div class="ttname"><a href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a979c7aa78dd32780858f30f47a72cca0">HWLOC_MEMBIND_FIRSTTOUCH</a></div><div class="ttdeci">@ HWLOC_MEMBIND_FIRSTTOUCH</div><div class="ttdoc">Allocate each memory page individually on the local NUMA node of the thread that touches it.</div><div class="ttdef"><b>Definition</b> hwloc.h:1526</div></div>
+<div class="ttc" id="aa00180_html_ggac9764f79505775d06407b40f5e4661e8aa091c40c9557b69a26b69a0e8b84dafe"><div class="ttname"><a href="a00180.html#ggac9764f79505775d06407b40f5e4661e8aa091c40c9557b69a26b69a0e8b84dafe">HWLOC_MEMBIND_WEIGHTED_INTERLEAVE</a></div><div class="ttdeci">@ HWLOC_MEMBIND_WEIGHTED_INTERLEAVE</div><div class="ttdoc">Allocate memory on the given nodes in an interleaved / weighted manner. The precise layout of the mem...</div><div class="ttdef"><b>Definition</b> hwloc.h:1555</div></div>
+<div class="ttc" id="aa00180_html_ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c"><div class="ttname"><a href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c">HWLOC_MEMBIND_BIND</a></div><div class="ttdeci">@ HWLOC_MEMBIND_BIND</div><div class="ttdoc">Allocate memory on the specified nodes.</div><div class="ttdef"><b>Definition</b> hwloc.h:1536</div></div>
+<div class="ttc" id="aa00180_html_ggac9764f79505775d06407b40f5e4661e8ae370075e5af016d42310f87ea5af236b"><div class="ttname"><a href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ae370075e5af016d42310f87ea5af236b">HWLOC_MEMBIND_INTERLEAVE</a></div><div class="ttdeci">@ HWLOC_MEMBIND_INTERLEAVE</div><div class="ttdoc">Allocate memory on the given nodes in an interleaved / round-robin manner. The precise layout of the ...</div><div class="ttdef"><b>Definition</b> hwloc.h:1545</div></div>
+<div class="ttc" id="aa00180_html_ggac9764f79505775d06407b40f5e4661e8aecdd4164d647708fbb51a00d98dbb138"><div class="ttname"><a href="a00180.html#ggac9764f79505775d06407b40f5e4661e8aecdd4164d647708fbb51a00d98dbb138">HWLOC_MEMBIND_NEXTTOUCH</a></div><div class="ttdeci">@ HWLOC_MEMBIND_NEXTTOUCH</div><div class="ttdoc">For each page bound with this policy, by next time it is touched (and next time only),...</div><div class="ttdef"><b>Definition</b> hwloc.h:1562</div></div>
+<div class="ttc" id="aa00181_html_ga2745616b65595e1c1e579ecc7e461fa8"><div class="ttname"><a href="a00181.html#ga2745616b65595e1c1e579ecc7e461fa8">hwloc_topology_set_xmlbuffer</a></div><div class="ttdeci">int hwloc_topology_set_xmlbuffer(hwloc_topology_t restrict topology, const char *restrict buffer, int size)</div><div class="ttdoc">Enable XML based topology using a memory buffer (instead of a file, as with hwloc_topology_set_xml())...</div></div>
+<div class="ttc" id="aa00181_html_ga341fc17b5867a4715570baab131f68cd"><div class="ttname"><a href="a00181.html#ga341fc17b5867a4715570baab131f68cd">hwloc_topology_set_pid</a></div><div class="ttdeci">int hwloc_topology_set_pid(hwloc_topology_t restrict topology, hwloc_pid_t pid)</div><div class="ttdoc">Change which process the topology is viewed from.</div></div>
+<div class="ttc" id="aa00181_html_ga4fab186bb6181a00bcf585825fddd38d"><div class="ttname"><a href="a00181.html#ga4fab186bb6181a00bcf585825fddd38d">hwloc_topology_set_synthetic</a></div><div class="ttdeci">int hwloc_topology_set_synthetic(hwloc_topology_t restrict topology, const char *restrict description)</div><div class="ttdoc">Enable synthetic topology.</div></div>
+<div class="ttc" id="aa00181_html_ga879439b7ee99407ee911b3ac64e9a25e"><div class="ttname"><a href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e">hwloc_topology_set_xml</a></div><div class="ttdeci">int hwloc_topology_set_xml(hwloc_topology_t restrict topology, const char *restrict xmlpath)</div><div class="ttdoc">Enable XML-file based topology.</div></div>
+<div class="ttc" id="aa00181_html_ga949f656c779208a36790feba24048b7e"><div class="ttname"><a href="a00181.html#ga949f656c779208a36790feba24048b7e">hwloc_topology_components_flag_e</a></div><div class="ttdeci">hwloc_topology_components_flag_e</div><div class="ttdoc">Flags to be passed to hwloc_topology_set_components()</div><div class="ttdef"><b>Definition</b> hwloc.h:2037</div></div>
+<div class="ttc" id="aa00181_html_ga9ad41adf418cee1c0ee32ba9bd4a3d36"><div class="ttname"><a href="a00181.html#ga9ad41adf418cee1c0ee32ba9bd4a3d36">hwloc_topology_set_components</a></div><div class="ttdeci">int hwloc_topology_set_components(hwloc_topology_t restrict topology, unsigned long flags, const char *restrict name)</div><div class="ttdoc">Prevent a discovery component from being used for a topology.</div></div>
+<div class="ttc" id="aa00181_html_gga949f656c779208a36790feba24048b7ea33eec25d29253a2aba21dd3c731b416e"><div class="ttname"><a href="a00181.html#gga949f656c779208a36790feba24048b7ea33eec25d29253a2aba21dd3c731b416e">HWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST</div><div class="ttdoc">Blacklist the target component from being used.</div><div class="ttdef"><b>Definition</b> hwloc.h:2041</div></div>
+<div class="ttc" id="aa00182_html_ga09318f81c1d4713be907d64748a6f93c"><div class="ttname"><a href="a00182.html#ga09318f81c1d4713be907d64748a6f93c">hwloc_topology_get_flags</a></div><div class="ttdeci">unsigned long hwloc_topology_get_flags(hwloc_topology_t topology)</div><div class="ttdoc">Get OR'ed flags of a topology.</div></div>
+<div class="ttc" id="aa00182_html_ga0ab38705357bc1203abe829da8a12ad3"><div class="ttname"><a href="a00182.html#ga0ab38705357bc1203abe829da8a12ad3">hwloc_topology_set_io_types_filter</a></div><div class="ttdeci">int hwloc_topology_set_io_types_filter(hwloc_topology_t topology, enum hwloc_type_filter_e filter)</div><div class="ttdoc">Set the filtering for all I/O object types.</div></div>
+<div class="ttc" id="aa00182_html_ga137ad1178f7a79f2383974d983083401"><div class="ttname"><a href="a00182.html#ga137ad1178f7a79f2383974d983083401">hwloc_topology_get_type_filter</a></div><div class="ttdeci">int hwloc_topology_get_type_filter(hwloc_topology_t topology, hwloc_obj_type_t type, enum hwloc_type_filter_e *filter)</div><div class="ttdoc">Get the current filtering for the given object type.</div></div>
+<div class="ttc" id="aa00182_html_ga2cc7b7b155cba58dda203e54f1637b9c"><div class="ttname"><a href="a00182.html#ga2cc7b7b155cba58dda203e54f1637b9c">hwloc_topology_set_userdata</a></div><div class="ttdeci">void hwloc_topology_set_userdata(hwloc_topology_t topology, const void *userdata)</div><div class="ttdoc">Set the topology-specific userdata pointer.</div></div>
+<div class="ttc" id="aa00182_html_ga30bd6d330fe3c8f0cbaad724d114ee20"><div class="ttname"><a href="a00182.html#ga30bd6d330fe3c8f0cbaad724d114ee20">hwloc_topology_set_cache_types_filter</a></div><div class="ttdeci">int hwloc_topology_set_cache_types_filter(hwloc_topology_t topology, enum hwloc_type_filter_e filter)</div><div class="ttdoc">Set the filtering for all CPU cache object types.</div></div>
+<div class="ttc" id="aa00182_html_ga37c7b2e599ed3cd76ad9164630024f30"><div class="ttname"><a href="a00182.html#ga37c7b2e599ed3cd76ad9164630024f30">hwloc_topology_set_icache_types_filter</a></div><div class="ttdeci">int hwloc_topology_set_icache_types_filter(hwloc_topology_t topology, enum hwloc_type_filter_e filter)</div><div class="ttdoc">Set the filtering for all CPU instruction cache object types.</div></div>
+<div class="ttc" id="aa00182_html_ga68ffdcfd9175cdf40709801092f18017"><div class="ttname"><a href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a></div><div class="ttdeci">int hwloc_topology_is_thissystem(hwloc_topology_t restrict topology)</div><div class="ttdoc">Does the topology context come from this system?</div></div>
+<div class="ttc" id="aa00182_html_ga9a5a1f0140cd1952544477833733195b"><div class="ttname"><a href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a></div><div class="ttdeci">hwloc_type_filter_e</div><div class="ttdoc">Type filtering flags.</div><div class="ttdef"><b>Definition</b> hwloc.h:2439</div></div>
+<div class="ttc" id="aa00182_html_ga9eb8dc3b106f84921bf5789101e97e24"><div class="ttname"><a href="a00182.html#ga9eb8dc3b106f84921bf5789101e97e24">hwloc_topology_set_all_types_filter</a></div><div class="ttdeci">int hwloc_topology_set_all_types_filter(hwloc_topology_t topology, enum hwloc_type_filter_e filter)</div><div class="ttdoc">Set the filtering for all object types.</div></div>
+<div class="ttc" id="aa00182_html_gaaeed4df656979e5f16befea9d29b814b"><div class="ttname"><a href="a00182.html#gaaeed4df656979e5f16befea9d29b814b">hwloc_topology_set_flags</a></div><div class="ttdeci">int hwloc_topology_set_flags(hwloc_topology_t topology, unsigned long flags)</div><div class="ttdoc">Set OR'ed flags to non-yet-loaded topology.</div></div>
+<div class="ttc" id="aa00182_html_gac0927e93a9b962143be08a48bbff2e19"><div class="ttname"><a href="a00182.html#gac0927e93a9b962143be08a48bbff2e19">hwloc_topology_get_support</a></div><div class="ttdeci">const struct hwloc_topology_support * hwloc_topology_get_support(hwloc_topology_t restrict topology)</div><div class="ttdoc">Retrieve the topology support.</div></div>
+<div class="ttc" id="aa00182_html_gad47dee1a30f4b00486b54872af030b43"><div class="ttname"><a href="a00182.html#gad47dee1a30f4b00486b54872af030b43">hwloc_topology_get_userdata</a></div><div class="ttdeci">void * hwloc_topology_get_userdata(hwloc_topology_t topology)</div><div class="ttdoc">Retrieve the topology-specific userdata pointer.</div></div>
+<div class="ttc" id="aa00182_html_gad894e70f15f8d4aada7be8d1aba38b7e"><div class="ttname"><a href="a00182.html#gad894e70f15f8d4aada7be8d1aba38b7e">hwloc_topology_set_type_filter</a></div><div class="ttdeci">int hwloc_topology_set_type_filter(hwloc_topology_t topology, hwloc_obj_type_t type, enum hwloc_type_filter_e filter)</div><div class="ttdoc">Set the filtering for the given object type.</div></div>
+<div class="ttc" id="aa00182_html_gada025d3ec20b4b420f8038d23d6e7bde"><div class="ttname"><a href="a00182.html#gada025d3ec20b4b420f8038d23d6e7bde">hwloc_topology_flags_e</a></div><div class="ttdeci">hwloc_topology_flags_e</div><div class="ttdoc">Flags to be set onto a topology context before load.</div><div class="ttdef"><b>Definition</b> hwloc.h:2081</div></div>
+<div class="ttc" id="aa00182_html_gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a"><div class="ttname"><a href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a">HWLOC_TYPE_FILTER_KEEP_NONE</a></div><div class="ttdeci">@ HWLOC_TYPE_FILTER_KEEP_NONE</div><div class="ttdoc">Ignore all objects of this type.</div><div class="ttdef"><b>Definition</b> hwloc.h:2453</div></div>
+<div class="ttc" id="aa00182_html_gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5"><div class="ttname"><a href="a00182.html#gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5">HWLOC_TYPE_FILTER_KEEP_IMPORTANT</a></div><div class="ttdeci">@ HWLOC_TYPE_FILTER_KEEP_IMPORTANT</div><div class="ttdoc">Only keep likely-important objects of the given type.</div><div class="ttdef"><b>Definition</b> hwloc.h:2482</div></div>
+<div class="ttc" id="aa00182_html_gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4"><div class="ttname"><a href="a00182.html#gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4">HWLOC_TYPE_FILTER_KEEP_STRUCTURE</a></div><div class="ttdeci">@ HWLOC_TYPE_FILTER_KEEP_STRUCTURE</div><div class="ttdoc">Only ignore objects if their entire level does not bring any structure.</div><div class="ttdef"><b>Definition</b> hwloc.h:2467</div></div>
+<div class="ttc" id="aa00182_html_gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e"><div class="ttname"><a href="a00182.html#gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e">HWLOC_TYPE_FILTER_KEEP_ALL</a></div><div class="ttdeci">@ HWLOC_TYPE_FILTER_KEEP_ALL</div><div class="ttdoc">Keep all objects of this type.</div><div class="ttdef"><b>Definition</b> hwloc.h:2445</div></div>
+<div class="ttc" id="aa00182_html_ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258"><div class="ttname"><a href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</div><div class="ttdoc">Detect the whole system, ignore reservations, include disallowed objects.</div><div class="ttdef"><b>Definition</b> hwloc.h:2103</div></div>
+<div class="ttc" id="aa00182_html_ggada025d3ec20b4b420f8038d23d6e7bdea1b66bbd66e900e5c837f71defb32ad89"><div class="ttname"><a href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea1b66bbd66e900e5c837f71defb32ad89">HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES</div><div class="ttdoc">Get the set of allowed resources from the local operating system even if the topology was loaded from...</div><div class="ttdef"><b>Definition</b> hwloc.h:2144</div></div>
+<div class="ttc" id="aa00182_html_ggada025d3ec20b4b420f8038d23d6e7bdea3497cd4c2f8b1d842dd49b3aaae56a24"><div class="ttname"><a href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea3497cd4c2f8b1d842dd49b3aaae56a24">HWLOC_TOPOLOGY_FLAG_NO_CPUKINDS</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_FLAG_NO_CPUKINDS</div><div class="ttdoc">Ignore CPU Kinds.</div><div class="ttdef"><b>Definition</b> hwloc.h:2250</div></div>
+<div class="ttc" id="aa00182_html_ggada025d3ec20b4b420f8038d23d6e7bdea368d7741135fe309f3782c59644d3caa"><div class="ttname"><a href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea368d7741135fe309f3782c59644d3caa">HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING</div><div class="ttdoc">Do not consider resources outside of the process memory binding.</div><div class="ttdef"><b>Definition</b> hwloc.h:2215</div></div>
+<div class="ttc" id="aa00182_html_ggada025d3ec20b4b420f8038d23d6e7bdea5796b4909eba80f9727b66d07d3a7a05"><div class="ttname"><a href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea5796b4909eba80f9727b66d07d3a7a05">HWLOC_TOPOLOGY_FLAG_NO_DISTANCES</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_FLAG_NO_DISTANCES</div><div class="ttdoc">Ignore distances.</div><div class="ttdef"><b>Definition</b> hwloc.h:2237</div></div>
+<div class="ttc" id="aa00182_html_ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b"><div class="ttname"><a href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</div><div class="ttdoc">Assume that the selected backend provides the topology for the system on which we are running.</div><div class="ttdef"><b>Definition</b> hwloc.h:2123</div></div>
+<div class="ttc" id="aa00182_html_ggada025d3ec20b4b420f8038d23d6e7bdeaa595aed197779012acf43e8ca4a2658d"><div class="ttname"><a href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdeaa595aed197779012acf43e8ca4a2658d">HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING</div><div class="ttdoc">Do not consider resources outside of the process CPU binding.</div><div class="ttdef"><b>Definition</b> hwloc.h:2193</div></div>
+<div class="ttc" id="aa00182_html_ggada025d3ec20b4b420f8038d23d6e7bdead5636766a6603f24486f79c48899c1c3"><div class="ttname"><a href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdead5636766a6603f24486f79c48899c1c3">HWLOC_TOPOLOGY_FLAG_NO_MEMATTRS</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_FLAG_NO_MEMATTRS</div><div class="ttdoc">Ignore memory attributes and tiers.</div><div class="ttdef"><b>Definition</b> hwloc.h:2244</div></div>
+<div class="ttc" id="aa00182_html_ggada025d3ec20b4b420f8038d23d6e7bdead93e82b8668ee90e4f9354e201a2ed9c"><div class="ttname"><a href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdead93e82b8668ee90e4f9354e201a2ed9c">HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT</div><div class="ttdoc">Import support from the imported topology.</div><div class="ttdef"><b>Definition</b> hwloc.h:2168</div></div>
+<div class="ttc" id="aa00182_html_ggada025d3ec20b4b420f8038d23d6e7bdeae7a792e3db4360360a10f9160b10e631"><div class="ttname"><a href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdeae7a792e3db4360360a10f9160b10e631">HWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING</div><div class="ttdoc">Do not ever modify the process or thread binding during discovery.</div><div class="ttdef"><b>Definition</b> hwloc.h:2230</div></div>
+<div class="ttc" id="aa00183_html_ga1fc6012b3e1c249b83f48cb7bcacaa5b"><div class="ttname"><a href="a00183.html#ga1fc6012b3e1c249b83f48cb7bcacaa5b">hwloc_topology_insert_group_object</a></div><div class="ttdeci">hwloc_obj_t hwloc_topology_insert_group_object(hwloc_topology_t topology, hwloc_obj_t group)</div><div class="ttdoc">Add more structure to the topology by adding an intermediate Group.</div></div>
+<div class="ttc" id="aa00183_html_ga38b1be3922094d880f6e76bf56c973d6"><div class="ttname"><a href="a00183.html#ga38b1be3922094d880f6e76bf56c973d6">hwloc_allow_flags_e</a></div><div class="ttdeci">hwloc_allow_flags_e</div><div class="ttdoc">Flags to be given to hwloc_topology_allow().</div><div class="ttdef"><b>Definition</b> hwloc.h:2630</div></div>
+<div class="ttc" id="aa00183_html_ga4cea4741165faf5323931a9ed8786ef7"><div class="ttname"><a href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7">hwloc_topology_alloc_group_object</a></div><div class="ttdeci">hwloc_obj_t hwloc_topology_alloc_group_object(hwloc_topology_t topology)</div><div class="ttdoc">Allocate a Group object to insert later with hwloc_topology_insert_group_object().</div></div>
+<div class="ttc" id="aa00183_html_ga698ecd640d2b76742bba3829a145cd9a"><div class="ttname"><a href="a00183.html#ga698ecd640d2b76742bba3829a145cd9a">hwloc_topology_refresh</a></div><div class="ttdeci">int hwloc_topology_refresh(hwloc_topology_t topology)</div><div class="ttdoc">Refresh internal structures after topology modification.</div></div>
+<div class="ttc" id="aa00183_html_ga6db81ed13ac0a9d70cc80372ab537815"><div class="ttname"><a href="a00183.html#ga6db81ed13ac0a9d70cc80372ab537815">hwloc_topology_restrict</a></div><div class="ttdeci">int hwloc_topology_restrict(hwloc_topology_t restrict topology, hwloc_const_bitmap_t set, unsigned long flags)</div><div class="ttdoc">Restrict the topology to the given CPU set or nodeset.</div></div>
+<div class="ttc" id="aa00183_html_ga9d80f08eb25b7ac22f1b998dc8bf521f"><div class="ttname"><a href="a00183.html#ga9d80f08eb25b7ac22f1b998dc8bf521f">hwloc_restrict_flags_e</a></div><div class="ttdeci">hwloc_restrict_flags_e</div><div class="ttdoc">Flags to be given to hwloc_topology_restrict().</div><div class="ttdef"><b>Definition</b> hwloc.h:2558</div></div>
+<div class="ttc" id="aa00183_html_gac09117be24a8fc5f5dea6acac34e8843"><div class="ttname"><a href="a00183.html#gac09117be24a8fc5f5dea6acac34e8843">hwloc_topology_free_group_object</a></div><div class="ttdeci">int hwloc_topology_free_group_object(hwloc_topology_t topology, hwloc_obj_t group)</div><div class="ttdoc">Free a group object allocated with hwloc_topology_alloc_group_object().</div></div>
+<div class="ttc" id="aa00183_html_gad458715d3335df44849216cc123d1055"><div class="ttname"><a href="a00183.html#gad458715d3335df44849216cc123d1055">hwloc_obj_add_other_obj_sets</a></div><div class="ttdeci">int hwloc_obj_add_other_obj_sets(hwloc_obj_t dst, hwloc_obj_t src)</div><div class="ttdoc">Setup object cpusets/nodesets by OR'ing another object's sets.</div></div>
+<div class="ttc" id="aa00183_html_gad980782ade737900c5cf208946768c30"><div class="ttname"><a href="a00183.html#gad980782ade737900c5cf208946768c30">hwloc_topology_insert_misc_object</a></div><div class="ttdeci">hwloc_obj_t hwloc_topology_insert_misc_object(hwloc_topology_t topology, hwloc_obj_t parent, const char *name)</div><div class="ttdoc">Add a MISC object as a leaf of the topology.</div></div>
+<div class="ttc" id="aa00183_html_gaf955b190c0299dcfb5bc985d777f92a1"><div class="ttname"><a href="a00183.html#gaf955b190c0299dcfb5bc985d777f92a1">hwloc_topology_allow</a></div><div class="ttdeci">int hwloc_topology_allow(hwloc_topology_t restrict topology, hwloc_const_cpuset_t cpuset, hwloc_const_nodeset_t nodeset, unsigned long flags)</div><div class="ttdoc">Change the sets of allowed PUs and NUMA nodes in the topology.</div></div>
+<div class="ttc" id="aa00183_html_gga38b1be3922094d880f6e76bf56c973d6a489c8c1b67ce7e0b8cf7a665852760e1"><div class="ttname"><a href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6a489c8c1b67ce7e0b8cf7a665852760e1">HWLOC_ALLOW_FLAG_CUSTOM</a></div><div class="ttdeci">@ HWLOC_ALLOW_FLAG_CUSTOM</div><div class="ttdoc">Allow a custom set of objects, given to hwloc_topology_allow() as cpuset and/or nodeset parameters.</div><div class="ttdef"><b>Definition</b> hwloc.h:2648</div></div>
+<div class="ttc" id="aa00183_html_gga38b1be3922094d880f6e76bf56c973d6a88c50088c09dcf1e1a496c0817556fb9"><div class="ttname"><a href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6a88c50088c09dcf1e1a496c0817556fb9">HWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS</a></div><div class="ttdeci">@ HWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS</div><div class="ttdoc">Only allow objects that are available to the current process.</div><div class="ttdef"><b>Definition</b> hwloc.h:2644</div></div>
+<div class="ttc" id="aa00183_html_gga38b1be3922094d880f6e76bf56c973d6aca107692455774f9d323d21b8abfce72"><div class="ttname"><a href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6aca107692455774f9d323d21b8abfce72">HWLOC_ALLOW_FLAG_ALL</a></div><div class="ttdeci">@ HWLOC_ALLOW_FLAG_ALL</div><div class="ttdoc">Mark all objects as allowed in the topology.</div><div class="ttdef"><b>Definition</b> hwloc.h:2635</div></div>
+<div class="ttc" id="aa00183_html_gga9d80f08eb25b7ac22f1b998dc8bf521fa699969227a09bbc1a7de51dc9fb7be4b"><div class="ttname"><a href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fa699969227a09bbc1a7de51dc9fb7be4b">HWLOC_RESTRICT_FLAG_ADAPT_MISC</a></div><div class="ttdeci">@ HWLOC_RESTRICT_FLAG_ADAPT_MISC</div><div class="ttdoc">Move Misc objects to ancestors if their parents are removed during restriction. If this flag is not s...</div><div class="ttdef"><b>Definition</b> hwloc.h:2583</div></div>
+<div class="ttc" id="aa00183_html_gga9d80f08eb25b7ac22f1b998dc8bf521fa80eeb9cbba401ab050f8fb4573725891"><div class="ttname"><a href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fa80eeb9cbba401ab050f8fb4573725891">HWLOC_RESTRICT_FLAG_REMOVE_CPULESS</a></div><div class="ttdeci">@ HWLOC_RESTRICT_FLAG_REMOVE_CPULESS</div><div class="ttdoc">Remove all objects that became CPU-less. By default, only objects that contain no PU and no memory ar...</div><div class="ttdef"><b>Definition</b> hwloc.h:2564</div></div>
+<div class="ttc" id="aa00183_html_gga9d80f08eb25b7ac22f1b998dc8bf521faa95d6985e36ec1e55f68b210297a85cb"><div class="ttname"><a href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521faa95d6985e36ec1e55f68b210297a85cb">HWLOC_RESTRICT_FLAG_ADAPT_IO</a></div><div class="ttdeci">@ HWLOC_RESTRICT_FLAG_ADAPT_IO</div><div class="ttdoc">Move I/O objects to ancestors if their parents are removed during restriction. If this flag is not se...</div><div class="ttdef"><b>Definition</b> hwloc.h:2589</div></div>
+<div class="ttc" id="aa00183_html_gga9d80f08eb25b7ac22f1b998dc8bf521fae4c5b1b87232f2d8a60559e77ac65a68"><div class="ttname"><a href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fae4c5b1b87232f2d8a60559e77ac65a68">HWLOC_RESTRICT_FLAG_BYNODESET</a></div><div class="ttdeci">@ HWLOC_RESTRICT_FLAG_BYNODESET</div><div class="ttdoc">Restrict by nodeset instead of CPU set. Only keep objects whose nodeset is included or partially incl...</div><div class="ttdef"><b>Definition</b> hwloc.h:2570</div></div>
+<div class="ttc" id="aa00183_html_gga9d80f08eb25b7ac22f1b998dc8bf521faf5ba49808855704bfe9cb9fe7347f93b"><div class="ttname"><a href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521faf5ba49808855704bfe9cb9fe7347f93b">HWLOC_RESTRICT_FLAG_REMOVE_MEMLESS</a></div><div class="ttdeci">@ HWLOC_RESTRICT_FLAG_REMOVE_MEMLESS</div><div class="ttdoc">Remove all objects that became Memory-less. By default, only objects that contain no PU and no memory...</div><div class="ttdef"><b>Definition</b> hwloc.h:2577</div></div>
+<div class="ttc" id="aa00194_html_gaa3c2bf4c776d603dcebbb61b0c923d84"><div class="ttname"><a href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a></div><div class="ttdeci">struct hwloc_bitmap_s * hwloc_bitmap_t</div><div class="ttdoc">Set of bits represented as an opaque pointer to an internal bitmap.</div><div class="ttdef"><b>Definition</b> bitmap.h:69</div></div>
+<div class="ttc" id="aa00194_html_gae991a108af01d408be2776c5b2c467b2"><div class="ttname"><a href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a></div><div class="ttdeci">const struct hwloc_bitmap_s * hwloc_const_bitmap_t</div><div class="ttdoc">a non-modifiable hwloc_bitmap_t</div><div class="ttdef"><b>Definition</b> bitmap.h:71</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_a04d05403da37bfe17cd63b7c7dd07b1f"><div class="ttname"><a href="a00229.html#a04d05403da37bfe17cd63b7c7dd07b1f">hwloc_obj::children</a></div><div class="ttdeci">struct hwloc_obj ** children</div><div class="ttdoc">Normal children, children[0 .. arity -1].</div><div class="ttdef"><b>Definition</b> hwloc.h:491</div></div>
+<div class="ttc" id="aa00229_html_a08f0d0e16c619a6e653526cbee4ffea3"><div class="ttname"><a href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">hwloc_obj::nodeset</a></div><div class="ttdeci">hwloc_nodeset_t nodeset</div><div class="ttdoc">NUMA nodes covered by this object or containing this object.</div><div class="ttdef"><b>Definition</b> hwloc.h:575</div></div>
+<div class="ttc" id="aa00229_html_a0d07fb7b8935e137c94d75a3eb492ae9"><div class="ttname"><a href="a00229.html#a0d07fb7b8935e137c94d75a3eb492ae9">hwloc_obj::logical_index</a></div><div class="ttdeci">unsigned logical_index</div><div class="ttdoc">Horizontal index in the whole list of similar objects, hence guaranteed unique across the entire mach...</div><div class="ttdef"><b>Definition</b> hwloc.h:469</div></div>
+<div class="ttc" id="aa00229_html_a0f41a1d67dc6b661906f2217563637f3"><div class="ttname"><a href="a00229.html#a0f41a1d67dc6b661906f2217563637f3">hwloc_obj::symmetric_subtree</a></div><div class="ttdeci">int symmetric_subtree</div><div class="ttdoc">Set if the subtree of normal objects below this object is symmetric, which means all normal children ...</div><div class="ttdef"><b>Definition</b> hwloc.h:496</div></div>
+<div class="ttc" id="aa00229_html_a2bb7862ce722d7ceda23cfa153da165a"><div class="ttname"><a href="a00229.html#a2bb7862ce722d7ceda23cfa153da165a">hwloc_obj::misc_arity</a></div><div class="ttdeci">unsigned misc_arity</div><div class="ttdoc">Number of Misc children. These children are listed in misc_first_child.</div><div class="ttdef"><b>Definition</b> hwloc.h:537</div></div>
+<div class="ttc" id="aa00229_html_a4876fd165b4fff35521f07ebd85355ed"><div class="ttname"><a href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">hwloc_obj::depth</a></div><div class="ttdeci">int depth</div><div class="ttdoc">Vertical index in the hierarchy.</div><div class="ttdef"><b>Definition</b> hwloc.h:454</div></div>
+<div class="ttc" id="aa00229_html_a57812a313fe9b1a9500489f47c3011cc"><div class="ttname"><a href="a00229.html#a57812a313fe9b1a9500489f47c3011cc">hwloc_obj::misc_first_child</a></div><div class="ttdeci">struct hwloc_obj * misc_first_child</div><div class="ttdoc">First Misc child. Misc objects are listed here (misc_arity and misc_first_child) instead of in the no...</div><div class="ttdef"><b>Definition</b> hwloc.h:540</div></div>
+<div class="ttc" id="aa00229_html_a5d4f97e76723a9ec8d38046f19e00d33"><div class="ttname"><a href="a00229.html#a5d4f97e76723a9ec8d38046f19e00d33">hwloc_obj::subtype</a></div><div class="ttdeci">char * subtype</div><div class="ttdoc">Subtype string to better describe the type field.</div><div class="ttdef"><b>Definition</b> hwloc.h:434</div></div>
+<div class="ttc" id="aa00229_html_a61a7a80a68eaccbaaa28269e678c81a9"><div class="ttname"><a href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">hwloc_obj::os_index</a></div><div class="ttdeci">unsigned os_index</div><div class="ttdoc">OS-provided physical index number. It is not guaranteed unique across the entire machine,...</div><div class="ttdef"><b>Definition</b> hwloc.h:436</div></div>
+<div class="ttc" id="aa00229_html_a67925e0f2c47f50408fbdb9bddd0790f"><div class="ttname"><a href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">hwloc_obj::cpuset</a></div><div class="ttdeci">hwloc_cpuset_t cpuset</div><div class="ttdoc">CPUs covered by this object.</div><div class="ttdef"><b>Definition</b> hwloc.h:547</div></div>
+<div class="ttc" id="aa00229_html_a6f834ea4dd26553cdea601d2fae6d3b7"><div class="ttname"><a href="a00229.html#a6f834ea4dd26553cdea601d2fae6d3b7">hwloc_obj::memory_arity</a></div><div class="ttdeci">unsigned memory_arity</div><div class="ttdoc">Number of Memory children. These children are listed in memory_first_child.</div><div class="ttdef"><b>Definition</b> hwloc.h:507</div></div>
+<div class="ttc" id="aa00229_html_a75603fc36c9284ba48ce814b772a58b6"><div class="ttname"><a href="a00229.html#a75603fc36c9284ba48ce814b772a58b6">hwloc_obj::total_memory</a></div><div class="ttdeci">hwloc_uint64_t total_memory</div><div class="ttdoc">Total memory (in bytes) in NUMA nodes below this object.</div><div class="ttdef"><b>Definition</b> hwloc.h:448</div></div>
+<div class="ttc" id="aa00229_html_a76fd3ac94401cf32dfccc3a3a8de68a5"><div class="ttname"><a href="a00229.html#a76fd3ac94401cf32dfccc3a3a8de68a5">hwloc_obj::userdata</a></div><div class="ttdeci">void * userdata</div><div class="ttdoc">Application-given private data pointer, initialized to NULL, use it as you wish. See hwloc_topology_s...</div><div class="ttdef"><b>Definition</b> hwloc.h:617</div></div>
+<div class="ttc" id="aa00229_html_a7b3b29f0be377c7d2d52262019fc7d11"><div class="ttname"><a href="a00229.html#a7b3b29f0be377c7d2d52262019fc7d11">hwloc_obj::io_arity</a></div><div class="ttdeci">unsigned io_arity</div><div class="ttdoc">Number of I/O children. These children are listed in io_first_child.</div><div class="ttdef"><b>Definition</b> hwloc.h:525</div></div>
+<div class="ttc" id="aa00229_html_a7b89e8c189876c0158a9282aaaf17f50"><div class="ttname"><a href="a00229.html#a7b89e8c189876c0158a9282aaaf17f50">hwloc_obj::prev_sibling</a></div><div class="ttdeci">struct hwloc_obj * prev_sibling</div><div class="ttdoc">Previous object below the same parent (inside the same list of children).</div><div class="ttdef"><b>Definition</b> hwloc.h:484</div></div>
+<div class="ttc" id="aa00229_html_a7f2343ed476fe4942e6fffd4cade1b40"><div class="ttname"><a href="a00229.html#a7f2343ed476fe4942e6fffd4cade1b40">hwloc_obj::next_sibling</a></div><div class="ttdeci">struct hwloc_obj * next_sibling</div><div class="ttdoc">Next object below the same parent (inside the same list of children).</div><div class="ttdef"><b>Definition</b> hwloc.h:483</div></div>
+<div class="ttc" id="aa00229_html_a84bd65634dbc55f4158b74443a9bd04f"><div class="ttname"><a href="a00229.html#a84bd65634dbc55f4158b74443a9bd04f">hwloc_obj::last_child</a></div><div class="ttdeci">struct hwloc_obj * last_child</div><div class="ttdoc">Last normal child.</div><div class="ttdef"><b>Definition</b> hwloc.h:493</div></div>
+<div class="ttc" id="aa00229_html_a85a788017457129589318b6c39451acf"><div class="ttname"><a href="a00229.html#a85a788017457129589318b6c39451acf">hwloc_obj::next_cousin</a></div><div class="ttdeci">struct hwloc_obj * next_cousin</div><div class="ttdoc">Next object of same type and depth.</div><div class="ttdef"><b>Definition</b> hwloc.h:477</div></div>
+<div class="ttc" id="aa00229_html_a8604654c38b7a720efae5025d3a96ee6"><div class="ttname"><a href="a00229.html#a8604654c38b7a720efae5025d3a96ee6">hwloc_obj::infos</a></div><div class="ttdeci">struct hwloc_info_s * infos</div><div class="ttdoc">Array of info attributes (name and value strings).</div><div class="ttdef"><b>Definition</b> hwloc.h:613</div></div>
+<div class="ttc" id="aa00229_html_a8d14c88e1ebc4ae67cc69f9e928558b3"><div class="ttname"><a href="a00229.html#a8d14c88e1ebc4ae67cc69f9e928558b3">hwloc_obj::io_first_child</a></div><div class="ttdeci">struct hwloc_obj * io_first_child</div><div class="ttdoc">First I/O child. Bridges, PCI and OS devices are listed here (io_arity and io_first_child) instead of...</div><div class="ttdef"><b>Definition</b> hwloc.h:528</div></div>
+<div class="ttc" id="aa00229_html_a91788a9da687beb7224cc1fd7b75208c"><div class="ttname"><a href="a00229.html#a91788a9da687beb7224cc1fd7b75208c">hwloc_obj::complete_cpuset</a></div><div class="ttdeci">hwloc_cpuset_t complete_cpuset</div><div class="ttdoc">The complete CPU set of processors of this object,.</div><div class="ttdef"><b>Definition</b> hwloc.h:562</div></div>
+<div class="ttc" id="aa00229_html_a957984a355fa61c85f46605c336e7551"><div class="ttname"><a href="a00229.html#a957984a355fa61c85f46605c336e7551">hwloc_obj::gp_index</a></div><div class="ttdeci">hwloc_uint64_t gp_index</div><div class="ttdoc">Global persistent index. Generated by hwloc, unique across the topology (contrary to os_index) and pe...</div><div class="ttdef"><b>Definition</b> hwloc.h:622</div></div>
+<div class="ttc" id="aa00229_html_a9843acc28cfbba903b63ea14b137ff70"><div class="ttname"><a href="a00229.html#a9843acc28cfbba903b63ea14b137ff70">hwloc_obj::infos_count</a></div><div class="ttdeci">unsigned infos_count</div><div class="ttdoc">Size of infos array.</div><div class="ttdef"><b>Definition</b> hwloc.h:614</div></div>
+<div class="ttc" id="aa00229_html_aaa6043eee6f55869933c1d974efd9acd"><div class="ttname"><a href="a00229.html#aaa6043eee6f55869933c1d974efd9acd">hwloc_obj::sibling_rank</a></div><div class="ttdeci">unsigned sibling_rank</div><div class="ttdoc">Index in parent's children[] array. Or the index in parent's Memory, I/O or Misc children list.</div><div class="ttdef"><b>Definition</b> hwloc.h:482</div></div>
+<div class="ttc" id="aa00229_html_aac3f6da35c9b57599909a44ce2b716c1"><div class="ttname"><a href="a00229.html#aac3f6da35c9b57599909a44ce2b716c1">hwloc_obj::arity</a></div><div class="ttdeci">unsigned arity</div><div class="ttdoc">Number of normal children. Memory, Misc and I/O children are not listed here but rather in their dedi...</div><div class="ttdef"><b>Definition</b> hwloc.h:487</div></div>
+<div class="ttc" id="aa00229_html_abb709ec38f2970677e4e57d1d30be96d"><div class="ttname"><a href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj::name</a></div><div class="ttdeci">char * name</div><div class="ttdoc">Object-specific name if any. Mostly used for identifying OS devices and Misc objects where a name str...</div><div class="ttdef"><b>Definition</b> hwloc.h:443</div></div>
+<div class="ttc" id="aa00229_html_ac0e8200dba25b90d5954bd4ec61f97d3"><div class="ttname"><a href="a00229.html#ac0e8200dba25b90d5954bd4ec61f97d3">hwloc_obj::memory_first_child</a></div><div class="ttdeci">struct hwloc_obj * memory_first_child</div><div class="ttdoc">First Memory child. NUMA nodes and Memory-side caches are listed here (memory_arity and memory_first_...</div><div class="ttdef"><b>Definition</b> hwloc.h:510</div></div>
+<div class="ttc" id="aa00229_html_ac38c4012127525ef74c5615c526f4c2e"><div class="ttname"><a href="a00229.html#ac38c4012127525ef74c5615c526f4c2e">hwloc_obj::complete_nodeset</a></div><div class="ttdeci">hwloc_nodeset_t complete_nodeset</div><div class="ttdoc">The complete NUMA node set of this object,.</div><div class="ttdef"><b>Definition</b> hwloc.h:597</div></div>
+<div class="ttc" id="aa00229_html_ac715989f55ff5a0eb6be2969ee477ec0"><div class="ttname"><a href="a00229.html#ac715989f55ff5a0eb6be2969ee477ec0">hwloc_obj::prev_cousin</a></div><div class="ttdeci">struct hwloc_obj * prev_cousin</div><div class="ttdoc">Previous object of same type and depth.</div><div class="ttdef"><b>Definition</b> hwloc.h:478</div></div>
+<div class="ttc" id="aa00229_html_acc4f0803f244867e68fe0036800be5de"><div class="ttname"><a href="a00229.html#acc4f0803f244867e68fe0036800be5de">hwloc_obj::type</a></div><div class="ttdeci">hwloc_obj_type_t type</div><div class="ttdoc">Type of object.</div><div class="ttdef"><b>Definition</b> hwloc.h:433</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00229_html_adc494f6aed939992be1c55cca5822900"><div class="ttname"><a href="a00229.html#adc494f6aed939992be1c55cca5822900">hwloc_obj::parent</a></div><div class="ttdeci">struct hwloc_obj * parent</div><div class="ttdoc">Parent, NULL if root (Machine object)</div><div class="ttdef"><b>Definition</b> hwloc.h:481</div></div>
+<div class="ttc" id="aa00229_html_af51d08a0a79dba517c06c5afedc8d2dc"><div class="ttname"><a href="a00229.html#af51d08a0a79dba517c06c5afedc8d2dc">hwloc_obj::first_child</a></div><div class="ttdeci">struct hwloc_obj * first_child</div><div class="ttdoc">First normal child.</div><div class="ttdef"><b>Definition</b> hwloc.h:492</div></div>
+<div class="ttc" id="aa00233_html"><div class="ttname"><a href="a00233.html">hwloc_obj_attr_u</a></div><div class="ttdoc">Object type-specific Attributes.</div><div class="ttdef"><b>Definition</b> hwloc.h:634</div></div>
+<div class="ttc" id="aa00233_html_a0b66da7ab072f7c016f8ed86701f5a7c"><div class="ttname"><a href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">hwloc_obj_attr_u::pcidev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_pcidev_attr_s pcidev</div></div>
+<div class="ttc" id="aa00233_html_a207e6359497b7116d6f4baa9e8bbeb43"><div class="ttname"><a href="a00233.html#a207e6359497b7116d6f4baa9e8bbeb43">hwloc_obj_attr_u::bridge</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_bridge_attr_s bridge</div></div>
+<div class="ttc" id="aa00233_html_a23f553f3252c9d13f2338231cd354ea9"><div class="ttname"><a href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">hwloc_obj_attr_u::cache</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_cache_attr_s cache</div></div>
+<div class="ttc" id="aa00233_html_a9eddbd69e34cd2ef6af6d2ac31b6eff3"><div class="ttname"><a href="a00233.html#a9eddbd69e34cd2ef6af6d2ac31b6eff3">hwloc_obj_attr_u::group</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_group_attr_s group</div></div>
+<div class="ttc" id="aa00233_html_aaf7a5c38b5185703ff18c46ad2761dcf"><div class="ttname"><a href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">hwloc_obj_attr_u::osdev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_osdev_attr_s osdev</div></div>
+<div class="ttc" id="aa00233_html_ad066b9612802ffa01e132dc3a8e6cc86"><div class="ttname"><a href="a00233.html#ad066b9612802ffa01e132dc3a8e6cc86">hwloc_obj_attr_u::numanode</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_numanode_attr_s numanode</div></div>
+<div class="ttc" id="aa00237_html"><div class="ttname"><a href="a00237.html">hwloc_obj_attr_u::hwloc_numanode_attr_s</a></div><div class="ttdoc">NUMA node-specific Object Attributes.</div><div class="ttdef"><b>Definition</b> hwloc.h:636</div></div>
+<div class="ttc" id="aa00237_html_a513078122d403904e16723d30f583cb2"><div class="ttname"><a href="a00237.html#a513078122d403904e16723d30f583cb2">hwloc_obj_attr_u::hwloc_numanode_attr_s::page_types_len</a></div><div class="ttdeci">unsigned page_types_len</div><div class="ttdoc">Size of array page_types.</div><div class="ttdef"><b>Definition</b> hwloc.h:638</div></div>
+<div class="ttc" id="aa00237_html_a6703cbf2afbf63c9d60c5ff4dc0c73aa"><div class="ttname"><a href="a00237.html#a6703cbf2afbf63c9d60c5ff4dc0c73aa">hwloc_obj_attr_u::hwloc_numanode_attr_s::local_memory</a></div><div class="ttdeci">hwloc_uint64_t local_memory</div><div class="ttdoc">Local memory (in bytes)</div><div class="ttdef"><b>Definition</b> hwloc.h:637</div></div>
+<div class="ttc" id="aa00237_html_a7e53c5024da2d7741a5cc1e7016bb8d2"><div class="ttname"><a href="a00237.html#a7e53c5024da2d7741a5cc1e7016bb8d2">hwloc_obj_attr_u::hwloc_numanode_attr_s::page_types</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s * page_types</div></div>
+<div class="ttc" id="aa00241_html"><div class="ttname"><a href="a00241.html">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s</a></div><div class="ttdoc">Array of local memory page types, NULL if no local memory and page_types is 0.</div><div class="ttdef"><b>Definition</b> hwloc.h:644</div></div>
+<div class="ttc" id="aa00241_html_a8ea7ebe9d91c7378bba03da57efc25cb"><div class="ttname"><a href="a00241.html#a8ea7ebe9d91c7378bba03da57efc25cb">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s::size</a></div><div class="ttdeci">hwloc_uint64_t size</div><div class="ttdoc">Size of pages.</div><div class="ttdef"><b>Definition</b> hwloc.h:645</div></div>
+<div class="ttc" id="aa00241_html_a98514e37d57a325b78e21ffd8d7419e0"><div class="ttname"><a href="a00241.html#a98514e37d57a325b78e21ffd8d7419e0">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s::count</a></div><div class="ttdeci">hwloc_uint64_t count</div><div class="ttdoc">Number of pages of this size.</div><div class="ttdef"><b>Definition</b> hwloc.h:646</div></div>
+<div class="ttc" id="aa00245_html"><div class="ttname"><a href="a00245.html">hwloc_obj_attr_u::hwloc_cache_attr_s</a></div><div class="ttdoc">Cache-specific Object Attributes.</div><div class="ttdef"><b>Definition</b> hwloc.h:651</div></div>
+<div class="ttc" id="aa00245_html_a5c8f7f39193736c2187ed626940835d5"><div class="ttname"><a href="a00245.html#a5c8f7f39193736c2187ed626940835d5">hwloc_obj_attr_u::hwloc_cache_attr_s::depth</a></div><div class="ttdeci">unsigned depth</div><div class="ttdoc">Depth of cache (e.g., L1, L2, ...etc.)</div><div class="ttdef"><b>Definition</b> hwloc.h:653</div></div>
+<div class="ttc" id="aa00245_html_a801e8a668e28caf06c8b88e9ae5c10db"><div class="ttname"><a href="a00245.html#a801e8a668e28caf06c8b88e9ae5c10db">hwloc_obj_attr_u::hwloc_cache_attr_s::linesize</a></div><div class="ttdeci">unsigned linesize</div><div class="ttdoc">Cache-line size in bytes. 0 if unknown.</div><div class="ttdef"><b>Definition</b> hwloc.h:654</div></div>
+<div class="ttc" id="aa00245_html_abe5e788943ed04302976740c829674c0"><div class="ttname"><a href="a00245.html#abe5e788943ed04302976740c829674c0">hwloc_obj_attr_u::hwloc_cache_attr_s::size</a></div><div class="ttdeci">hwloc_uint64_t size</div><div class="ttdoc">Size of cache in bytes.</div><div class="ttdef"><b>Definition</b> hwloc.h:652</div></div>
+<div class="ttc" id="aa00245_html_ad06525e474d1e2d1423ed71bb998592d"><div class="ttname"><a href="a00245.html#ad06525e474d1e2d1423ed71bb998592d">hwloc_obj_attr_u::hwloc_cache_attr_s::associativity</a></div><div class="ttdeci">int associativity</div><div class="ttdoc">Ways of associativity, -1 if fully associative, 0 if unknown.</div><div class="ttdef"><b>Definition</b> hwloc.h:655</div></div>
+<div class="ttc" id="aa00245_html_ad8edc8ded2b7a70d6abbc874801930f4"><div class="ttname"><a href="a00245.html#ad8edc8ded2b7a70d6abbc874801930f4">hwloc_obj_attr_u::hwloc_cache_attr_s::type</a></div><div class="ttdeci">hwloc_obj_cache_type_t type</div><div class="ttdoc">Cache type.</div><div class="ttdef"><b>Definition</b> hwloc.h:657</div></div>
+<div class="ttc" id="aa00249_html"><div class="ttname"><a href="a00249.html">hwloc_obj_attr_u::hwloc_group_attr_s</a></div><div class="ttdoc">Group-specific Object Attributes.</div><div class="ttdef"><b>Definition</b> hwloc.h:660</div></div>
+<div class="ttc" id="aa00249_html_a3229f269c4cc7e63492c168535e4f0c1"><div class="ttname"><a href="a00249.html#a3229f269c4cc7e63492c168535e4f0c1">hwloc_obj_attr_u::hwloc_group_attr_s::kind</a></div><div class="ttdeci">unsigned kind</div><div class="ttdoc">Internally-used kind of group.</div><div class="ttdef"><b>Definition</b> hwloc.h:663</div></div>
+<div class="ttc" id="aa00249_html_ad514d943960a4036ed5e44dc187c74ed"><div class="ttname"><a href="a00249.html#ad514d943960a4036ed5e44dc187c74ed">hwloc_obj_attr_u::hwloc_group_attr_s::subkind</a></div><div class="ttdeci">unsigned subkind</div><div class="ttdoc">Internally-used subkind to distinguish different levels of groups with same kind.</div><div class="ttdef"><b>Definition</b> hwloc.h:664</div></div>
+<div class="ttc" id="aa00249_html_ad914eac61c77481e1b7037877bcc5579"><div class="ttname"><a href="a00249.html#ad914eac61c77481e1b7037877bcc5579">hwloc_obj_attr_u::hwloc_group_attr_s::depth</a></div><div class="ttdeci">unsigned depth</div><div class="ttdoc">Depth of group object. It may change if intermediate Group objects are added.</div><div class="ttdef"><b>Definition</b> hwloc.h:661</div></div>
+<div class="ttc" id="aa00249_html_afa253d4b70f92e940c226d61f192054f"><div class="ttname"><a href="a00249.html#afa253d4b70f92e940c226d61f192054f">hwloc_obj_attr_u::hwloc_group_attr_s::dont_merge</a></div><div class="ttdeci">unsigned char dont_merge</div><div class="ttdoc">Flag preventing groups from being automatically merged with identical parent or children.</div><div class="ttdef"><b>Definition</b> hwloc.h:665</div></div>
+<div class="ttc" id="aa00253_html"><div class="ttname"><a href="a00253.html">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></div><div class="ttdoc">PCI Device specific Object Attributes.</div><div class="ttdef"><b>Definition</b> hwloc.h:668</div></div>
+<div class="ttc" id="aa00253_html_a13ad54c93d08d8ac808e4de9674c5ee7"><div class="ttname"><a href="a00253.html#a13ad54c93d08d8ac808e4de9674c5ee7">hwloc_obj_attr_u::hwloc_pcidev_attr_s::revision</a></div><div class="ttdeci">unsigned char revision</div><div class="ttdoc">Revision number.</div><div class="ttdef"><b>Definition</b> hwloc.h:684</div></div>
+<div class="ttc" id="aa00253_html_a35b66064ab7d768caf7154e410caf0fa"><div class="ttname"><a href="a00253.html#a35b66064ab7d768caf7154e410caf0fa">hwloc_obj_attr_u::hwloc_pcidev_attr_s::device_id</a></div><div class="ttdeci">unsigned short device_id</div><div class="ttdoc">Device ID (yyyy in [xxxx:yyyy]).</div><div class="ttdef"><b>Definition</b> hwloc.h:681</div></div>
+<div class="ttc" id="aa00253_html_a3d70c84a12f7e93d14c8d47bf4fd9dc5"><div class="ttname"><a href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">hwloc_obj_attr_u::hwloc_pcidev_attr_s::dev</a></div><div class="ttdeci">unsigned char dev</div><div class="ttdoc">Device number (zz in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:677</div></div>
+<div class="ttc" id="aa00253_html_a499db3d8cc89eaba04fcaef3df1cba97"><div class="ttname"><a href="a00253.html#a499db3d8cc89eaba04fcaef3df1cba97">hwloc_obj_attr_u::hwloc_pcidev_attr_s::subvendor_id</a></div><div class="ttdeci">unsigned short subvendor_id</div><div class="ttdoc">Sub-Vendor ID.</div><div class="ttdef"><b>Definition</b> hwloc.h:682</div></div>
+<div class="ttc" id="aa00253_html_a59b2fce35f7cbde86c4fd305d0ccda5f"><div class="ttname"><a href="a00253.html#a59b2fce35f7cbde86c4fd305d0ccda5f">hwloc_obj_attr_u::hwloc_pcidev_attr_s::linkspeed</a></div><div class="ttdeci">float linkspeed</div><div class="ttdoc">Link speed in GB/s. This datarate is the currently configured speed of the entire PCI link (sum of th...</div><div class="ttdef"><b>Definition</b> hwloc.h:685</div></div>
+<div class="ttc" id="aa00253_html_a695f32df53f4ef728670bfcf31b74e0f"><div class="ttname"><a href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">hwloc_obj_attr_u::hwloc_pcidev_attr_s::func</a></div><div class="ttdeci">unsigned char func</div><div class="ttdoc">Function number (t in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:678</div></div>
+<div class="ttc" id="aa00253_html_a8fba44988deb98613c1505a4019a34dc"><div class="ttname"><a href="a00253.html#a8fba44988deb98613c1505a4019a34dc">hwloc_obj_attr_u::hwloc_pcidev_attr_s::domain</a></div><div class="ttdeci">unsigned short domain</div><div class="ttdoc">Domain number (xxxx in the PCI BDF notation xxxx:yy:zz.t). Only 16bits PCI domains are supported by d...</div><div class="ttdef"><b>Definition</b> hwloc.h:670</div></div>
+<div class="ttc" id="aa00253_html_aad970ad19b62eb2d5df30e4802da4f4c"><div class="ttname"><a href="a00253.html#aad970ad19b62eb2d5df30e4802da4f4c">hwloc_obj_attr_u::hwloc_pcidev_attr_s::vendor_id</a></div><div class="ttdeci">unsigned short vendor_id</div><div class="ttdoc">Vendor ID (xxxx in [xxxx:yyyy]).</div><div class="ttdef"><b>Definition</b> hwloc.h:680</div></div>
+<div class="ttc" id="aa00253_html_aae99e035e8d1387d7b8768aaa8eceb0a"><div class="ttname"><a href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">hwloc_obj_attr_u::hwloc_pcidev_attr_s::bus</a></div><div class="ttdeci">unsigned char bus</div><div class="ttdoc">Bus number (yy in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:676</div></div>
+<div class="ttc" id="aa00253_html_acac741aecd7a6db64f33409427e3971f"><div class="ttname"><a href="a00253.html#acac741aecd7a6db64f33409427e3971f">hwloc_obj_attr_u::hwloc_pcidev_attr_s::subdevice_id</a></div><div class="ttdeci">unsigned short subdevice_id</div><div class="ttdoc">Sub-Device ID.</div><div class="ttdef"><b>Definition</b> hwloc.h:683</div></div>
+<div class="ttc" id="aa00253_html_aee735352d9f1686fd290fc6d6397c334"><div class="ttname"><a href="a00253.html#aee735352d9f1686fd290fc6d6397c334">hwloc_obj_attr_u::hwloc_pcidev_attr_s::class_id</a></div><div class="ttdeci">unsigned short class_id</div><div class="ttdoc">The class number (first two bytes, without the prog_if).</div><div class="ttdef"><b>Definition</b> hwloc.h:679</div></div>
+<div class="ttc" id="aa00257_html"><div class="ttname"><a href="a00257.html">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></div><div class="ttdoc">Bridge specific Object Attributes.</div><div class="ttdef"><b>Definition</b> hwloc.h:693</div></div>
+<div class="ttc" id="aa00257_html_a265dd2164aa2df4972e25a029da72125"><div class="ttname"><a href="a00257.html#a265dd2164aa2df4972e25a029da72125">hwloc_obj_attr_u::hwloc_bridge_attr_s::upstream_type</a></div><div class="ttdeci">hwloc_obj_bridge_type_t upstream_type</div><div class="ttdoc">Upstream Bridge type.</div><div class="ttdef"><b>Definition</b> hwloc.h:697</div></div>
+<div class="ttc" id="aa00257_html_a2c31e565a5f0d23d0a0a3dd3ec8f4b17"><div class="ttname"><a href="a00257.html#a2c31e565a5f0d23d0a0a3dd3ec8f4b17">hwloc_obj_attr_u::hwloc_bridge_attr_s::domain</a></div><div class="ttdeci">unsigned short domain</div><div class="ttdoc">Domain number the downstream PCI buses. Only 16bits PCI domains are supported by default.</div><div class="ttdef"><b>Definition</b> hwloc.h:701</div></div>
+<div class="ttc" id="aa00257_html_a336c8b22893d5d734d8c9dfca4066b46"><div class="ttname"><a href="a00257.html#a336c8b22893d5d734d8c9dfca4066b46">hwloc_obj_attr_u::hwloc_bridge_attr_s::depth</a></div><div class="ttdeci">unsigned depth</div><div class="ttdef"><b>Definition</b> hwloc.h:712</div></div>
+<div class="ttc" id="aa00257_html_a94647ccf58afd32602f584b47a0321ce"><div class="ttname"><a href="a00257.html#a94647ccf58afd32602f584b47a0321ce">hwloc_obj_attr_u::hwloc_bridge_attr_s::upstream</a></div><div class="ttdeci">union hwloc_obj_attr_u::hwloc_bridge_attr_s::@2 upstream</div></div>
+<div class="ttc" id="aa00257_html_ab5c564e7c95b747dae9eb84ec0a2c31e"><div class="ttname"><a href="a00257.html#ab5c564e7c95b747dae9eb84ec0a2c31e">hwloc_obj_attr_u::hwloc_bridge_attr_s::pci</a></div><div class="ttdeci">struct hwloc_pcidev_attr_s pci</div><div class="ttdoc">PCI attribute of the upstream part as a PCI device.</div><div class="ttdef"><b>Definition</b> hwloc.h:695</div></div>
+<div class="ttc" id="aa00257_html_abe1e38eb5ac8dc59829c8dc045f0d747"><div class="ttname"><a href="a00257.html#abe1e38eb5ac8dc59829c8dc045f0d747">hwloc_obj_attr_u::hwloc_bridge_attr_s::downstream</a></div><div class="ttdeci">union hwloc_obj_attr_u::hwloc_bridge_attr_s::@3 downstream</div></div>
+<div class="ttc" id="aa00257_html_ac6a169b672d0e9f75756fd5665828b93"><div class="ttname"><a href="a00257.html#ac6a169b672d0e9f75756fd5665828b93">hwloc_obj_attr_u::hwloc_bridge_attr_s::downstream_type</a></div><div class="ttdeci">hwloc_obj_bridge_type_t downstream_type</div><div class="ttdoc">Downstream Bridge type.</div><div class="ttdef"><b>Definition</b> hwloc.h:711</div></div>
+<div class="ttc" id="aa00257_html_ae2d9dd73ef1d32045c584a8e66d2f83f"><div class="ttname"><a href="a00257.html#ae2d9dd73ef1d32045c584a8e66d2f83f">hwloc_obj_attr_u::hwloc_bridge_attr_s::secondary_bus</a></div><div class="ttdeci">unsigned char secondary_bus</div><div class="ttdoc">First PCI bus number below the bridge.</div><div class="ttdef"><b>Definition</b> hwloc.h:707</div></div>
+<div class="ttc" id="aa00257_html_af3f3f7d76bf03e8d2afa721c2b8d6771"><div class="ttname"><a href="a00257.html#af3f3f7d76bf03e8d2afa721c2b8d6771">hwloc_obj_attr_u::hwloc_bridge_attr_s::subordinate_bus</a></div><div class="ttdeci">unsigned char subordinate_bus</div><div class="ttdoc">Highest PCI bus number below the bridge.</div><div class="ttdef"><b>Definition</b> hwloc.h:708</div></div>
+<div class="ttc" id="aa00273_html"><div class="ttname"><a href="a00273.html">hwloc_obj_attr_u::hwloc_osdev_attr_s</a></div><div class="ttdoc">OS Device specific Object Attributes.</div><div class="ttdef"><b>Definition</b> hwloc.h:715</div></div>
+<div class="ttc" id="aa00273_html_a31e019e27e54ac6138d04be639bb96f9"><div class="ttname"><a href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">hwloc_obj_attr_u::hwloc_osdev_attr_s::type</a></div><div class="ttdeci">hwloc_obj_osdev_type_t type</div><div class="ttdef"><b>Definition</b> hwloc.h:716</div></div>
+<div class="ttc" id="aa00277_html"><div class="ttname"><a href="a00277.html">hwloc_info_s</a></div><div class="ttdoc">Object info attribute (name and value strings)</div><div class="ttdef"><b>Definition</b> hwloc.h:724</div></div>
+<div class="ttc" id="aa00277_html_a12ce1309e4381ae38b5c15d242a47124"><div class="ttname"><a href="a00277.html#a12ce1309e4381ae38b5c15d242a47124">hwloc_info_s::name</a></div><div class="ttdeci">char * name</div><div class="ttdoc">Info name.</div><div class="ttdef"><b>Definition</b> hwloc.h:725</div></div>
+<div class="ttc" id="aa00277_html_a788a0073bafe660645e7b69f31a43bbb"><div class="ttname"><a href="a00277.html#a788a0073bafe660645e7b69f31a43bbb">hwloc_info_s::value</a></div><div class="ttdeci">char * value</div><div class="ttdoc">Info value.</div><div class="ttdef"><b>Definition</b> hwloc.h:726</div></div>
+<div class="ttc" id="aa00281_html"><div class="ttname"><a href="a00281.html">hwloc_topology_discovery_support</a></div><div class="ttdoc">Flags describing actual discovery support for this topology.</div><div class="ttdef"><b>Definition</b> hwloc.h:2294</div></div>
+<div class="ttc" id="aa00281_html_a955f96066cb9e4cd34e2a3710ad43e80"><div class="ttname"><a href="a00281.html#a955f96066cb9e4cd34e2a3710ad43e80">hwloc_topology_discovery_support::numa</a></div><div class="ttdeci">unsigned char numa</div><div class="ttdoc">Detecting the number of NUMA nodes is supported.</div><div class="ttdef"><b>Definition</b> hwloc.h:2298</div></div>
+<div class="ttc" id="aa00281_html_a970e65235873bcdb9669a9805161ce03"><div class="ttname"><a href="a00281.html#a970e65235873bcdb9669a9805161ce03">hwloc_topology_discovery_support::disallowed_numa</a></div><div class="ttdeci">unsigned char disallowed_numa</div><div class="ttdoc">Detecting and identifying NUMA nodes that are not available to the current process is supported.</div><div class="ttdef"><b>Definition</b> hwloc.h:2304</div></div>
+<div class="ttc" id="aa00281_html_aba80d6f9c15e2395f9ed61db9ff3b75d"><div class="ttname"><a href="a00281.html#aba80d6f9c15e2395f9ed61db9ff3b75d">hwloc_topology_discovery_support::cpukind_efficiency</a></div><div class="ttdeci">unsigned char cpukind_efficiency</div><div class="ttdoc">Detecting the efficiency of CPU kinds is supported, see Kinds of CPU cores.</div><div class="ttdef"><b>Definition</b> hwloc.h:2306</div></div>
+<div class="ttc" id="aa00281_html_ad7bb4ecf7a82f5a04fc632e9592ad3ab"><div class="ttname"><a href="a00281.html#ad7bb4ecf7a82f5a04fc632e9592ad3ab">hwloc_topology_discovery_support::pu</a></div><div class="ttdeci">unsigned char pu</div><div class="ttdoc">Detecting the number of PU objects is supported.</div><div class="ttdef"><b>Definition</b> hwloc.h:2296</div></div>
+<div class="ttc" id="aa00281_html_af193eb858e40e12ef4923f5ed0e1f11a"><div class="ttname"><a href="a00281.html#af193eb858e40e12ef4923f5ed0e1f11a">hwloc_topology_discovery_support::numa_memory</a></div><div class="ttdeci">unsigned char numa_memory</div><div class="ttdoc">Detecting the amount of memory in NUMA nodes is supported.</div><div class="ttdef"><b>Definition</b> hwloc.h:2300</div></div>
+<div class="ttc" id="aa00281_html_af3c97b28781a2972cf8eaaf94a6617da"><div class="ttname"><a href="a00281.html#af3c97b28781a2972cf8eaaf94a6617da">hwloc_topology_discovery_support::disallowed_pu</a></div><div class="ttdeci">unsigned char disallowed_pu</div><div class="ttdoc">Detecting and identifying PU objects that are not available to the current process is supported.</div><div class="ttdef"><b>Definition</b> hwloc.h:2302</div></div>
+<div class="ttc" id="aa00285_html"><div class="ttname"><a href="a00285.html">hwloc_topology_cpubind_support</a></div><div class="ttdoc">Flags describing actual PU binding support for this topology.</div><div class="ttdef"><b>Definition</b> hwloc.h:2314</div></div>
+<div class="ttc" id="aa00285_html_a2554620148b7992a5093f338f5ae254f"><div class="ttname"><a href="a00285.html#a2554620148b7992a5093f338f5ae254f">hwloc_topology_cpubind_support::get_proc_last_cpu_location</a></div><div class="ttdeci">unsigned char get_proc_last_cpu_location</div><div class="ttdef"><b>Definition</b> hwloc.h:2334</div></div>
+<div class="ttc" id="aa00285_html_a46fba33e307909ce256624687799dd6d"><div class="ttname"><a href="a00285.html#a46fba33e307909ce256624687799dd6d">hwloc_topology_cpubind_support::set_thread_cpubind</a></div><div class="ttdeci">unsigned char set_thread_cpubind</div><div class="ttdef"><b>Definition</b> hwloc.h:2328</div></div>
+<div class="ttc" id="aa00285_html_a57a89a4b5f1f74fa6cfe176f1e8b0798"><div class="ttname"><a href="a00285.html#a57a89a4b5f1f74fa6cfe176f1e8b0798">hwloc_topology_cpubind_support::set_thisthread_cpubind</a></div><div class="ttdeci">unsigned char set_thisthread_cpubind</div><div class="ttdef"><b>Definition</b> hwloc.h:2324</div></div>
+<div class="ttc" id="aa00285_html_a6be1f042fdce6bf41b4ea39f6f193808"><div class="ttname"><a href="a00285.html#a6be1f042fdce6bf41b4ea39f6f193808">hwloc_topology_cpubind_support::get_thisthread_last_cpu_location</a></div><div class="ttdeci">unsigned char get_thisthread_last_cpu_location</div><div class="ttdef"><b>Definition</b> hwloc.h:2336</div></div>
+<div class="ttc" id="aa00285_html_a77a09ddd78ee3e9ff5f532a6ac74f7eb"><div class="ttname"><a href="a00285.html#a77a09ddd78ee3e9ff5f532a6ac74f7eb">hwloc_topology_cpubind_support::get_thisproc_cpubind</a></div><div class="ttdeci">unsigned char get_thisproc_cpubind</div><div class="ttdef"><b>Definition</b> hwloc.h:2318</div></div>
+<div class="ttc" id="aa00285_html_a80d762e532d677dff262d83cc7bb1c60"><div class="ttname"><a href="a00285.html#a80d762e532d677dff262d83cc7bb1c60">hwloc_topology_cpubind_support::get_thisthread_cpubind</a></div><div class="ttdeci">unsigned char get_thisthread_cpubind</div><div class="ttdef"><b>Definition</b> hwloc.h:2326</div></div>
+<div class="ttc" id="aa00285_html_a8dd4d8531ed2eebdce1507e7d104154e"><div class="ttname"><a href="a00285.html#a8dd4d8531ed2eebdce1507e7d104154e">hwloc_topology_cpubind_support::get_thread_cpubind</a></div><div class="ttdeci">unsigned char get_thread_cpubind</div><div class="ttdef"><b>Definition</b> hwloc.h:2330</div></div>
+<div class="ttc" id="aa00285_html_a9403d51657a4d546b3ea9553a2973a27"><div class="ttname"><a href="a00285.html#a9403d51657a4d546b3ea9553a2973a27">hwloc_topology_cpubind_support::set_thisproc_cpubind</a></div><div class="ttdeci">unsigned char set_thisproc_cpubind</div><div class="ttdef"><b>Definition</b> hwloc.h:2316</div></div>
+<div class="ttc" id="aa00285_html_aa166223d1c2a6de7256ab2d8b675a87e"><div class="ttname"><a href="a00285.html#aa166223d1c2a6de7256ab2d8b675a87e">hwloc_topology_cpubind_support::set_proc_cpubind</a></div><div class="ttdeci">unsigned char set_proc_cpubind</div><div class="ttdef"><b>Definition</b> hwloc.h:2320</div></div>
+<div class="ttc" id="aa00285_html_aae705bc447adc163ead377362c4dfe9f"><div class="ttname"><a href="a00285.html#aae705bc447adc163ead377362c4dfe9f">hwloc_topology_cpubind_support::get_proc_cpubind</a></div><div class="ttdeci">unsigned char get_proc_cpubind</div><div class="ttdef"><b>Definition</b> hwloc.h:2322</div></div>
+<div class="ttc" id="aa00285_html_ad2d5c94b738d92b7d2ede87e4e96321d"><div class="ttname"><a href="a00285.html#ad2d5c94b738d92b7d2ede87e4e96321d">hwloc_topology_cpubind_support::get_thisproc_last_cpu_location</a></div><div class="ttdeci">unsigned char get_thisproc_last_cpu_location</div><div class="ttdef"><b>Definition</b> hwloc.h:2332</div></div>
+<div class="ttc" id="aa00289_html"><div class="ttname"><a href="a00289.html">hwloc_topology_membind_support</a></div><div class="ttdoc">Flags describing actual memory binding support for this topology.</div><div class="ttdef"><b>Definition</b> hwloc.h:2344</div></div>
+<div class="ttc" id="aa00289_html_a0697af2e41f2e82b8ce71e3cc13f7eac"><div class="ttname"><a href="a00289.html#a0697af2e41f2e82b8ce71e3cc13f7eac">hwloc_topology_membind_support::set_thisthread_membind</a></div><div class="ttdeci">unsigned char set_thisthread_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2354</div></div>
+<div class="ttc" id="aa00289_html_a0a84e24a06f2fa487fe8c9605c6f68b3"><div class="ttname"><a href="a00289.html#a0a84e24a06f2fa487fe8c9605c6f68b3">hwloc_topology_membind_support::get_area_membind</a></div><div class="ttdeci">unsigned char get_area_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2360</div></div>
+<div class="ttc" id="aa00289_html_a221098c339dbfab27bd2c9f5d32f123b"><div class="ttname"><a href="a00289.html#a221098c339dbfab27bd2c9f5d32f123b">hwloc_topology_membind_support::firsttouch_membind</a></div><div class="ttdeci">unsigned char firsttouch_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2364</div></div>
+<div class="ttc" id="aa00289_html_a30173553a68e0a4dd1672d26f8e892b1"><div class="ttname"><a href="a00289.html#a30173553a68e0a4dd1672d26f8e892b1">hwloc_topology_membind_support::get_area_memlocation</a></div><div class="ttdeci">unsigned char get_area_memlocation</div><div class="ttdef"><b>Definition</b> hwloc.h:2374</div></div>
+<div class="ttc" id="aa00289_html_a36b3e388df9c6a249427cab7e3724749"><div class="ttname"><a href="a00289.html#a36b3e388df9c6a249427cab7e3724749">hwloc_topology_membind_support::set_thisproc_membind</a></div><div class="ttdeci">unsigned char set_thisproc_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2346</div></div>
+<div class="ttc" id="aa00289_html_a3c44c6012860bbeba8a0f4c19710858d"><div class="ttname"><a href="a00289.html#a3c44c6012860bbeba8a0f4c19710858d">hwloc_topology_membind_support::interleave_membind</a></div><div class="ttdeci">unsigned char interleave_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2368</div></div>
+<div class="ttc" id="aa00289_html_a3fd51e6fa5f0dd800322301b46b08559"><div class="ttname"><a href="a00289.html#a3fd51e6fa5f0dd800322301b46b08559">hwloc_topology_membind_support::get_thisproc_membind</a></div><div class="ttdeci">unsigned char get_thisproc_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2348</div></div>
+<div class="ttc" id="aa00289_html_a476c06f96b65c08b287cf2369966123b"><div class="ttname"><a href="a00289.html#a476c06f96b65c08b287cf2369966123b">hwloc_topology_membind_support::set_area_membind</a></div><div class="ttdeci">unsigned char set_area_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2358</div></div>
+<div class="ttc" id="aa00289_html_a48e8c0eee48e83e72edde293e2f52464"><div class="ttname"><a href="a00289.html#a48e8c0eee48e83e72edde293e2f52464">hwloc_topology_membind_support::weighted_interleave_membind</a></div><div class="ttdeci">unsigned char weighted_interleave_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2376</div></div>
+<div class="ttc" id="aa00289_html_a63b0b2e26157b472f5717ee93cc7c535"><div class="ttname"><a href="a00289.html#a63b0b2e26157b472f5717ee93cc7c535">hwloc_topology_membind_support::get_thisthread_membind</a></div><div class="ttdeci">unsigned char get_thisthread_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2356</div></div>
+<div class="ttc" id="aa00289_html_a756f44912894b176bf979a1b65f12aac"><div class="ttname"><a href="a00289.html#a756f44912894b176bf979a1b65f12aac">hwloc_topology_membind_support::set_proc_membind</a></div><div class="ttdeci">unsigned char set_proc_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2350</div></div>
+<div class="ttc" id="aa00289_html_a9880cd2d605e316fc020167c49ca69ad"><div class="ttname"><a href="a00289.html#a9880cd2d605e316fc020167c49ca69ad">hwloc_topology_membind_support::get_proc_membind</a></div><div class="ttdeci">unsigned char get_proc_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2352</div></div>
+<div class="ttc" id="aa00289_html_aafa7683871a6a760246f9b35209caec5"><div class="ttname"><a href="a00289.html#aafa7683871a6a760246f9b35209caec5">hwloc_topology_membind_support::migrate_membind</a></div><div class="ttdeci">unsigned char migrate_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2372</div></div>
+<div class="ttc" id="aa00289_html_ab0921af6e0cd6975812a80b8e5c7435c"><div class="ttname"><a href="a00289.html#ab0921af6e0cd6975812a80b8e5c7435c">hwloc_topology_membind_support::nexttouch_membind</a></div><div class="ttdeci">unsigned char nexttouch_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2370</div></div>
+<div class="ttc" id="aa00289_html_ae551abb27d2aa9ce008583488b845b98"><div class="ttname"><a href="a00289.html#ae551abb27d2aa9ce008583488b845b98">hwloc_topology_membind_support::alloc_membind</a></div><div class="ttdeci">unsigned char alloc_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2362</div></div>
+<div class="ttc" id="aa00289_html_ae7cdb1f1b5f0242a69f85b5a5538c764"><div class="ttname"><a href="a00289.html#ae7cdb1f1b5f0242a69f85b5a5538c764">hwloc_topology_membind_support::bind_membind</a></div><div class="ttdeci">unsigned char bind_membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2366</div></div>
+<div class="ttc" id="aa00293_html"><div class="ttname"><a href="a00293.html">hwloc_topology_misc_support</a></div><div class="ttdoc">Flags describing miscellaneous features.</div><div class="ttdef"><b>Definition</b> hwloc.h:2381</div></div>
+<div class="ttc" id="aa00293_html_adf54a6dbe8e9dd5033dfe9c93df726c4"><div class="ttname"><a href="a00293.html#adf54a6dbe8e9dd5033dfe9c93df726c4">hwloc_topology_misc_support::imported_support</a></div><div class="ttdeci">unsigned char imported_support</div><div class="ttdef"><b>Definition</b> hwloc.h:2383</div></div>
+<div class="ttc" id="aa00297_html"><div class="ttname"><a href="a00297.html">hwloc_topology_support</a></div><div class="ttdoc">Set of flags describing actual support for this topology.</div><div class="ttdef"><b>Definition</b> hwloc.h:2392</div></div>
+<div class="ttc" id="aa00297_html_ab9d08df4b0b03994f21b893ece826e78"><div class="ttname"><a href="a00297.html#ab9d08df4b0b03994f21b893ece826e78">hwloc_topology_support::misc</a></div><div class="ttdeci">struct hwloc_topology_misc_support * misc</div><div class="ttdef"><b>Definition</b> hwloc.h:2396</div></div>
+<div class="ttc" id="aa00297_html_ac6eb62ae8bc0a68dce679a7107a36194"><div class="ttname"><a href="a00297.html#ac6eb62ae8bc0a68dce679a7107a36194">hwloc_topology_support::membind</a></div><div class="ttdeci">struct hwloc_topology_membind_support * membind</div><div class="ttdef"><b>Definition</b> hwloc.h:2395</div></div>
+<div class="ttc" id="aa00297_html_adef2bb91f74c3e70a2a071393caf5f56"><div class="ttname"><a href="a00297.html#adef2bb91f74c3e70a2a071393caf5f56">hwloc_topology_support::cpubind</a></div><div class="ttdeci">struct hwloc_topology_cpubind_support * cpubind</div><div class="ttdef"><b>Definition</b> hwloc.h:2394</div></div>
+<div class="ttc" id="aa00297_html_aea3fbd7653d987d81f848636c420504d"><div class="ttname"><a href="a00297.html#aea3fbd7653d987d81f848636c420504d">hwloc_topology_support::discovery</a></div><div class="ttdeci">struct hwloc_topology_discovery_support * discovery</div><div class="ttdef"><b>Definition</b> hwloc.h:2393</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00107_source.html 2.11.0-1/doc/doxygen-doc/html/a00107_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00107_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00107_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,885 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): helper.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">helper.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2009 CNRS</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2009-2024 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * Copyright © 2009-2012 Université Bordeaux</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * Copyright © 2009-2010 Cisco Systems, Inc.  All rights reserved.</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span> </div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#ifndef HWLOC_HELPER_H</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#define HWLOC_HELPER_H</span></div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#ifndef HWLOC_H</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#error Please include the main hwloc.h instead</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &lt;stdlib.h&gt;</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &lt;errno.h&gt;</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
+<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
+<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00054" name="l00054"></a><span class="lineno"><a class="line" href="a00184.html#ga52ef38431eba383b048b98c669b59a16">   54</a></span><a class="code hl_function" href="a00184.html#ga52ef38431eba383b048b98c669b59a16">hwloc_obj_type_is_normal</a>(<a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type);</div>
+<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span> </div>
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno"><a class="line" href="a00184.html#gac8a954ed37a4376097234c828068cbef">   65</a></span><a class="code hl_function" href="a00184.html#gac8a954ed37a4376097234c828068cbef">hwloc_obj_type_is_io</a>(<a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type);</div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span> </div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00076" name="l00076"></a><span class="lineno"><a class="line" href="a00184.html#ga1d074390c8a3dc3088d84f73fb73f966">   76</a></span><a class="code hl_function" href="a00184.html#ga1d074390c8a3dc3088d84f73fb73f966">hwloc_obj_type_is_memory</a>(<a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type);</div>
+<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span> </div>
+<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno"><a class="line" href="a00184.html#ga2ed589bea28711e80b92066510a5607d">   85</a></span><a class="code hl_function" href="a00184.html#ga2ed589bea28711e80b92066510a5607d">hwloc_obj_type_is_cache</a>(<a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type);</div>
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span> </div>
+<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno"><a class="line" href="a00184.html#ga395e48cd221d107e5891689624e1aec4">   94</a></span><a class="code hl_function" href="a00184.html#ga395e48cd221d107e5891689624e1aec4">hwloc_obj_type_is_dcache</a>(<a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type);</div>
+<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span> </div>
+<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00103" name="l00103"></a><span class="lineno"><a class="line" href="a00184.html#ga8abcee67b9b074332c1866405a3648a9">  103</a></span><a class="code hl_function" href="a00184.html#ga8abcee67b9b074332c1866405a3648a9">hwloc_obj_type_is_icache</a>(<a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type);</div>
+<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span> </div>
+<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00123" data-start="{" data-end="}">
+<div class="line"><a id="l00123" name="l00123"></a><span class="lineno"><a class="line" href="a00185.html#ga547325a4193dbc215d07c23097519d79">  123</a></span><a class="code hl_function" href="a00185.html#ga547325a4193dbc215d07c23097519d79">hwloc_get_first_largest_obj_inside_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set)</div>
+<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>{</div>
+<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj = <a class="code hl_function" href="a00176.html#ga2d4b12fc187dfc53b35f2fa21d21044d">hwloc_get_root_obj</a>(topology);</div>
+<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>  <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00194.html#gaefa070f9232857ba5a57297ea9a08ea2">hwloc_bitmap_intersects</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, set))</div>
+<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>  <span class="keywordflow">while</span> (!<a class="code hl_function" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, set)) {</div>
+<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>    <span class="comment">/* while the object intersects without being included, look at its children */</span></div>
+<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>    <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> child = obj-&gt;<a class="code hl_variable" href="a00229.html#af51d08a0a79dba517c06c5afedc8d2dc">first_child</a>;</div>
+<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>    <span class="keywordflow">while</span> (child) {</div>
+<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>      <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#gaefa070f9232857ba5a57297ea9a08ea2">hwloc_bitmap_intersects</a>(child-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, set))</div>
+<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>        <span class="keywordflow">break</span>;</div>
+<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>      child = child-&gt;<a class="code hl_variable" href="a00229.html#a7f2343ed476fe4942e6fffd4cade1b40">next_sibling</a>;</div>
+<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>    }</div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>    <span class="keywordflow">if</span> (!child)</div>
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>      <span class="comment">/* no child intersects, return their father */</span></div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>      <span class="keywordflow">return</span> obj;</div>
+<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>    <span class="comment">/* found one intersecting child, look at its children */</span></div>
+<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>    obj = child;</div>
+<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>  }</div>
+<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>  <span class="comment">/* obj is included, return it */</span></div>
+<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>  <span class="keywordflow">return</span> obj;</div>
+<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>}</div>
+</div>
+<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span> </div>
+<div class="line"><a id="l00151" name="l00151"></a><span class="lineno"><a class="line" href="a00185.html#ga34ca563fa3a6a4e05268f36a87668511">  151</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00185.html#ga34ca563fa3a6a4e05268f36a87668511">hwloc_get_largest_objs_inside_cpuset</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>                                                 <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> * __hwloc_restrict objs, <span class="keywordtype">int</span> max);</div>
+<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span> </div>
+<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00170" data-start="{" data-end="}">
+<div class="line"><a id="l00170" name="l00170"></a><span class="lineno"><a class="line" href="a00185.html#ga63e3784e7c60fbae5073428cb98ac787">  170</a></span><a class="code hl_function" href="a00185.html#ga63e3784e7c60fbae5073428cb98ac787">hwloc_get_next_obj_inside_cpuset_by_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>                                           <span class="keywordtype">int</span> depth, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> prev)</div>
+<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>{</div>
+<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> next = <a class="code hl_function" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a>(topology, depth, prev);</div>
+<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>  <span class="keywordflow">if</span> (!next)</div>
+<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>  <span class="keywordflow">while</span> (next &amp;&amp; (<a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(next-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>) || !<a class="code hl_function" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a>(next-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, set)))</div>
+<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>    next = next-&gt;<a class="code hl_variable" href="a00229.html#a85a788017457129589318b6c39451acf">next_cousin</a>;</div>
+<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>  <span class="keywordflow">return</span> next;</div>
+<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>}</div>
+</div>
+<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span> </div>
+<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00200" data-start="{" data-end="}">
+<div class="line"><a id="l00200" name="l00200"></a><span class="lineno"><a class="line" href="a00185.html#gafe859176cf9233f215fea0e87cef47e7">  200</a></span><a class="code hl_function" href="a00185.html#gafe859176cf9233f215fea0e87cef47e7">hwloc_get_next_obj_inside_cpuset_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>                                          <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> prev)</div>
+<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>{</div>
+<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, type);</div>
+<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>  <span class="keywordflow">if</span> (depth == <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a> || depth == <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">HWLOC_TYPE_DEPTH_MULTIPLE</a>)</div>
+<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>  <span class="keywordflow">return</span> <a class="code hl_function" href="a00185.html#ga63e3784e7c60fbae5073428cb98ac787">hwloc_get_next_obj_inside_cpuset_by_depth</a>(topology, set, depth, prev);</div>
+<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>}</div>
+</div>
+<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span> </div>
+<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span><a class="code hl_function" href="a00185.html#gaec86f1f88832836e3f9338e246ea5862">hwloc_get_obj_inside_cpuset_by_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>                                      <span class="keywordtype">int</span> depth, <span class="keywordtype">unsigned</span> idx) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00223" data-start="{" data-end="}">
+<div class="line"><a id="l00223" name="l00223"></a><span class="lineno"><a class="line" href="a00185.html#gaec86f1f88832836e3f9338e246ea5862">  223</a></span><a class="code hl_function" href="a00185.html#gaec86f1f88832836e3f9338e246ea5862">hwloc_get_obj_inside_cpuset_by_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>                                      <span class="keywordtype">int</span> depth, <span class="keywordtype">unsigned</span> idx)</div>
+<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>{</div>
+<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj = <a class="code hl_function" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0">hwloc_get_obj_by_depth</a> (topology, depth, 0);</div>
+<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>  <span class="keywordtype">unsigned</span> count = 0;</div>
+<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>  <span class="keywordflow">if</span> (!obj)</div>
+<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>  <span class="keywordflow">while</span> (obj) {</div>
+<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>    <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>) &amp;&amp; <a class="code hl_function" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, set)) {</div>
+<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>      <span class="keywordflow">if</span> (count == idx)</div>
+<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>        <span class="keywordflow">return</span> obj;</div>
+<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>      count++;</div>
+<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>    }</div>
+<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span>    obj = obj-&gt;<a class="code hl_variable" href="a00229.html#a85a788017457129589318b6c39451acf">next_cousin</a>;</div>
+<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>  }</div>
+<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>  <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span>}</div>
+</div>
+<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span> </div>
+<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span><a class="code hl_function" href="a00185.html#ga2edf924e5a0cca9cb22f65cc77c6ddb5">hwloc_get_obj_inside_cpuset_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>                                     <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, <span class="keywordtype">unsigned</span> idx) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00259" data-start="{" data-end="}">
+<div class="line"><a id="l00259" name="l00259"></a><span class="lineno"><a class="line" href="a00185.html#ga2edf924e5a0cca9cb22f65cc77c6ddb5">  259</a></span><a class="code hl_function" href="a00185.html#ga2edf924e5a0cca9cb22f65cc77c6ddb5">hwloc_get_obj_inside_cpuset_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>                                     <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, <span class="keywordtype">unsigned</span> idx)</div>
+<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>{</div>
+<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, type);</div>
+<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>  <span class="keywordflow">if</span> (depth == <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a> || depth == <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">HWLOC_TYPE_DEPTH_MULTIPLE</a>)</div>
+<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>  <span class="keywordflow">return</span> <a class="code hl_function" href="a00185.html#gaec86f1f88832836e3f9338e246ea5862">hwloc_get_obj_inside_cpuset_by_depth</a>(topology, set, depth, idx);</div>
+<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>}</div>
+</div>
+<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span> </div>
+<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">unsigned</span></div>
+<div class="line"><a id="l00280" name="l00280"></a><span class="lineno">  280</span><a class="code hl_function" href="a00185.html#gaa43c64512ddb33fd181990c4261cec7d">hwloc_get_nbobjs_inside_cpuset_by_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span>                                         <span class="keywordtype">int</span> depth) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">unsigned</span></div>
+<div class="foldopen" id="foldopen00283" data-start="{" data-end="}">
+<div class="line"><a id="l00283" name="l00283"></a><span class="lineno"><a class="line" href="a00185.html#gaa43c64512ddb33fd181990c4261cec7d">  283</a></span><a class="code hl_function" href="a00185.html#gaa43c64512ddb33fd181990c4261cec7d">hwloc_get_nbobjs_inside_cpuset_by_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span>                                         <span class="keywordtype">int</span> depth)</div>
+<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span>{</div>
+<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj = <a class="code hl_function" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0">hwloc_get_obj_by_depth</a> (topology, depth, 0);</div>
+<div class="line"><a id="l00287" name="l00287"></a><span class="lineno">  287</span>  <span class="keywordtype">unsigned</span> count = 0;</div>
+<div class="line"><a id="l00288" name="l00288"></a><span class="lineno">  288</span>  <span class="keywordflow">if</span> (!obj)</div>
+<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span>    <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span>  <span class="keywordflow">while</span> (obj) {</div>
+<div class="line"><a id="l00291" name="l00291"></a><span class="lineno">  291</span>    <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>) &amp;&amp; <a class="code hl_function" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, set))</div>
+<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span>      count++;</div>
+<div class="line"><a id="l00293" name="l00293"></a><span class="lineno">  293</span>    obj = obj-&gt;<a class="code hl_variable" href="a00229.html#a85a788017457129589318b6c39451acf">next_cousin</a>;</div>
+<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span>  }</div>
+<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span>  <span class="keywordflow">return</span> count;</div>
+<div class="line"><a id="l00296" name="l00296"></a><span class="lineno">  296</span>}</div>
+</div>
+<div class="line"><a id="l00297" name="l00297"></a><span class="lineno">  297</span> </div>
+<div class="line"><a id="l00311" name="l00311"></a><span class="lineno">  311</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00312" name="l00312"></a><span class="lineno">  312</span><a class="code hl_function" href="a00185.html#ga133c40415de008518608f8bff52a5ab9">hwloc_get_nbobjs_inside_cpuset_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00313" name="l00313"></a><span class="lineno">  313</span>                                        <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00314" name="l00314"></a><span class="lineno">  314</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00315" data-start="{" data-end="}">
+<div class="line"><a id="l00315" name="l00315"></a><span class="lineno"><a class="line" href="a00185.html#ga133c40415de008518608f8bff52a5ab9">  315</a></span><a class="code hl_function" href="a00185.html#ga133c40415de008518608f8bff52a5ab9">hwloc_get_nbobjs_inside_cpuset_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00316" name="l00316"></a><span class="lineno">  316</span>                                        <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</div>
+<div class="line"><a id="l00317" name="l00317"></a><span class="lineno">  317</span>{</div>
+<div class="line"><a id="l00318" name="l00318"></a><span class="lineno">  318</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, type);</div>
+<div class="line"><a id="l00319" name="l00319"></a><span class="lineno">  319</span>  <span class="keywordflow">if</span> (depth == <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a>)</div>
+<div class="line"><a id="l00320" name="l00320"></a><span class="lineno">  320</span>    <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00321" name="l00321"></a><span class="lineno">  321</span>  <span class="keywordflow">if</span> (depth == <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">HWLOC_TYPE_DEPTH_MULTIPLE</a>)</div>
+<div class="line"><a id="l00322" name="l00322"></a><span class="lineno">  322</span>    <span class="keywordflow">return</span> -1; <span class="comment">/* FIXME: agregate nbobjs from different levels? */</span></div>
+<div class="line"><a id="l00323" name="l00323"></a><span class="lineno">  323</span>  <span class="keywordflow">return</span> (<span class="keywordtype">int</span>) <a class="code hl_function" href="a00185.html#gaa43c64512ddb33fd181990c4261cec7d">hwloc_get_nbobjs_inside_cpuset_by_depth</a>(topology, set, depth);</div>
+<div class="line"><a id="l00324" name="l00324"></a><span class="lineno">  324</span>}</div>
+</div>
+<div class="line"><a id="l00325" name="l00325"></a><span class="lineno">  325</span> </div>
+<div class="line"><a id="l00342" name="l00342"></a><span class="lineno">  342</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00343" name="l00343"></a><span class="lineno">  343</span><a class="code hl_function" href="a00185.html#ga4c3a20d61e9beb06c667b21688c772c5">hwloc_get_obj_index_inside_cpuset</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00344" name="l00344"></a><span class="lineno">  344</span>                                   <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00345" name="l00345"></a><span class="lineno">  345</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00346" data-start="{" data-end="}">
+<div class="line"><a id="l00346" name="l00346"></a><span class="lineno"><a class="line" href="a00185.html#ga4c3a20d61e9beb06c667b21688c772c5">  346</a></span><a class="code hl_function" href="a00185.html#ga4c3a20d61e9beb06c667b21688c772c5">hwloc_get_obj_index_inside_cpuset</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00347" name="l00347"></a><span class="lineno">  347</span>                                   <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj)</div>
+<div class="line"><a id="l00348" name="l00348"></a><span class="lineno">  348</span>{</div>
+<div class="line"><a id="l00349" name="l00349"></a><span class="lineno">  349</span>  <span class="keywordtype">int</span> idx = 0;</div>
+<div class="line"><a id="l00350" name="l00350"></a><span class="lineno">  350</span>  <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, set))</div>
+<div class="line"><a id="l00351" name="l00351"></a><span class="lineno">  351</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00352" name="l00352"></a><span class="lineno">  352</span>  <span class="comment">/* count how many objects are inside the cpuset on the way from us to the beginning of the level */</span></div>
+<div class="line"><a id="l00353" name="l00353"></a><span class="lineno">  353</span>  <span class="keywordflow">while</span> ((obj = obj-&gt;<a class="code hl_variable" href="a00229.html#ac715989f55ff5a0eb6be2969ee477ec0">prev_cousin</a>) != NULL)</div>
+<div class="line"><a id="l00354" name="l00354"></a><span class="lineno">  354</span>    <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>) &amp;&amp; <a class="code hl_function" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, set))</div>
+<div class="line"><a id="l00355" name="l00355"></a><span class="lineno">  355</span>      idx++;</div>
+<div class="line"><a id="l00356" name="l00356"></a><span class="lineno">  356</span>  <span class="keywordflow">return</span> idx;</div>
+<div class="line"><a id="l00357" name="l00357"></a><span class="lineno">  357</span>}</div>
+</div>
+<div class="line"><a id="l00358" name="l00358"></a><span class="lineno">  358</span> </div>
+<div class="line"><a id="l00374" name="l00374"></a><span class="lineno">  374</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00375" name="l00375"></a><span class="lineno">  375</span><a class="code hl_function" href="a00186.html#ga0e66aa2dc6b2527cfd10723af646c9d7">hwloc_get_child_covering_cpuset</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00376" name="l00376"></a><span class="lineno">  376</span>                                <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> parent) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00377" name="l00377"></a><span class="lineno">  377</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00378" data-start="{" data-end="}">
+<div class="line"><a id="l00378" name="l00378"></a><span class="lineno"><a class="line" href="a00186.html#ga0e66aa2dc6b2527cfd10723af646c9d7">  378</a></span><a class="code hl_function" href="a00186.html#ga0e66aa2dc6b2527cfd10723af646c9d7">hwloc_get_child_covering_cpuset</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00379" name="l00379"></a><span class="lineno">  379</span>                                <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> parent)</div>
+<div class="line"><a id="l00380" name="l00380"></a><span class="lineno">  380</span>{</div>
+<div class="line"><a id="l00381" name="l00381"></a><span class="lineno">  381</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> child;</div>
+<div class="line"><a id="l00382" name="l00382"></a><span class="lineno">  382</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(set))</div>
+<div class="line"><a id="l00383" name="l00383"></a><span class="lineno">  383</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00384" name="l00384"></a><span class="lineno">  384</span>  child = parent-&gt;<a class="code hl_variable" href="a00229.html#af51d08a0a79dba517c06c5afedc8d2dc">first_child</a>;</div>
+<div class="line"><a id="l00385" name="l00385"></a><span class="lineno">  385</span>  <span class="keywordflow">while</span> (child) {</div>
+<div class="line"><a id="l00386" name="l00386"></a><span class="lineno">  386</span>    <span class="keywordflow">if</span> (child-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a> &amp;&amp; <a class="code hl_function" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a>(set, child-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>))</div>
+<div class="line"><a id="l00387" name="l00387"></a><span class="lineno">  387</span>      <span class="keywordflow">return</span> child;</div>
+<div class="line"><a id="l00388" name="l00388"></a><span class="lineno">  388</span>    child = child-&gt;<a class="code hl_variable" href="a00229.html#a7f2343ed476fe4942e6fffd4cade1b40">next_sibling</a>;</div>
+<div class="line"><a id="l00389" name="l00389"></a><span class="lineno">  389</span>  }</div>
+<div class="line"><a id="l00390" name="l00390"></a><span class="lineno">  390</span>  <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00391" name="l00391"></a><span class="lineno">  391</span>}</div>
+</div>
+<div class="line"><a id="l00392" name="l00392"></a><span class="lineno">  392</span> </div>
+<div class="line"><a id="l00398" name="l00398"></a><span class="lineno">  398</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00399" name="l00399"></a><span class="lineno">  399</span><a class="code hl_function" href="a00186.html#ga41acdcdbb8b95d70ecf6c572a3f67dca">hwloc_get_obj_covering_cpuset</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00400" name="l00400"></a><span class="lineno">  400</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00401" data-start="{" data-end="}">
+<div class="line"><a id="l00401" name="l00401"></a><span class="lineno"><a class="line" href="a00186.html#ga41acdcdbb8b95d70ecf6c572a3f67dca">  401</a></span><a class="code hl_function" href="a00186.html#ga41acdcdbb8b95d70ecf6c572a3f67dca">hwloc_get_obj_covering_cpuset</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set)</div>
+<div class="line"><a id="l00402" name="l00402"></a><span class="lineno">  402</span>{</div>
+<div class="line"><a id="l00403" name="l00403"></a><span class="lineno">  403</span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> *current = <a class="code hl_function" href="a00176.html#ga2d4b12fc187dfc53b35f2fa21d21044d">hwloc_get_root_obj</a>(topology);</div>
+<div class="line"><a id="l00404" name="l00404"></a><span class="lineno">  404</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(set) || !<a class="code hl_function" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a>(set, current-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>))</div>
+<div class="line"><a id="l00405" name="l00405"></a><span class="lineno">  405</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00406" name="l00406"></a><span class="lineno">  406</span>  <span class="keywordflow">while</span> (1) {</div>
+<div class="line"><a id="l00407" name="l00407"></a><span class="lineno">  407</span>    <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> child = <a class="code hl_function" href="a00186.html#ga0e66aa2dc6b2527cfd10723af646c9d7">hwloc_get_child_covering_cpuset</a>(topology, set, current);</div>
+<div class="line"><a id="l00408" name="l00408"></a><span class="lineno">  408</span>    <span class="keywordflow">if</span> (!child)</div>
+<div class="line"><a id="l00409" name="l00409"></a><span class="lineno">  409</span>      <span class="keywordflow">return</span> current;</div>
+<div class="line"><a id="l00410" name="l00410"></a><span class="lineno">  410</span>    current = child;</div>
+<div class="line"><a id="l00411" name="l00411"></a><span class="lineno">  411</span>  }</div>
+<div class="line"><a id="l00412" name="l00412"></a><span class="lineno">  412</span>}</div>
+</div>
+<div class="line"><a id="l00413" name="l00413"></a><span class="lineno">  413</span> </div>
+<div class="line"><a id="l00427" name="l00427"></a><span class="lineno">  427</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00428" data-start="{" data-end="}">
+<div class="line"><a id="l00428" name="l00428"></a><span class="lineno"><a class="line" href="a00186.html#gaba4b6d86eba1169ced4b0e941d2bb5f0">  428</a></span><a class="code hl_function" href="a00186.html#gaba4b6d86eba1169ced4b0e941d2bb5f0">hwloc_get_next_obj_covering_cpuset_by_depth</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00429" name="l00429"></a><span class="lineno">  429</span>                                            <span class="keywordtype">int</span> <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> prev)</div>
+<div class="line"><a id="l00430" name="l00430"></a><span class="lineno">  430</span>{</div>
+<div class="line"><a id="l00431" name="l00431"></a><span class="lineno">  431</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> next = <a class="code hl_function" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a>(topology, <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>, prev);</div>
+<div class="line"><a id="l00432" name="l00432"></a><span class="lineno">  432</span>  <span class="keywordflow">if</span> (!next)</div>
+<div class="line"><a id="l00433" name="l00433"></a><span class="lineno">  433</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00434" name="l00434"></a><span class="lineno">  434</span>  <span class="keywordflow">while</span> (next &amp;&amp; !<a class="code hl_function" href="a00194.html#gaefa070f9232857ba5a57297ea9a08ea2">hwloc_bitmap_intersects</a>(set, next-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>))</div>
+<div class="line"><a id="l00435" name="l00435"></a><span class="lineno">  435</span>    next = next-&gt;<a class="code hl_variable" href="a00229.html#a85a788017457129589318b6c39451acf">next_cousin</a>;</div>
+<div class="line"><a id="l00436" name="l00436"></a><span class="lineno">  436</span>  <span class="keywordflow">return</span> next;</div>
+<div class="line"><a id="l00437" name="l00437"></a><span class="lineno">  437</span>}</div>
+</div>
+<div class="line"><a id="l00438" name="l00438"></a><span class="lineno">  438</span> </div>
+<div class="line"><a id="l00455" name="l00455"></a><span class="lineno">  455</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00456" data-start="{" data-end="}">
+<div class="line"><a id="l00456" name="l00456"></a><span class="lineno"><a class="line" href="a00186.html#ga91cfae08b092e7966002e15d1e987213">  456</a></span><a class="code hl_function" href="a00186.html#ga91cfae08b092e7966002e15d1e987213">hwloc_get_next_obj_covering_cpuset_by_type</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set,</div>
+<div class="line"><a id="l00457" name="l00457"></a><span class="lineno">  457</span>                                           <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> <a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> prev)</div>
+<div class="line"><a id="l00458" name="l00458"></a><span class="lineno">  458</span>{</div>
+<div class="line"><a id="l00459" name="l00459"></a><span class="lineno">  459</span>  <span class="keywordtype">int</span> <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>);</div>
+<div class="line"><a id="l00460" name="l00460"></a><span class="lineno">  460</span>  <span class="keywordflow">if</span> (<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> == <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a> || <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> == <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">HWLOC_TYPE_DEPTH_MULTIPLE</a>)</div>
+<div class="line"><a id="l00461" name="l00461"></a><span class="lineno">  461</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00462" name="l00462"></a><span class="lineno">  462</span>  <span class="keywordflow">return</span> <a class="code hl_function" href="a00186.html#gaba4b6d86eba1169ced4b0e941d2bb5f0">hwloc_get_next_obj_covering_cpuset_by_depth</a>(topology, set, <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>, prev);</div>
+<div class="line"><a id="l00463" name="l00463"></a><span class="lineno">  463</span>}</div>
+</div>
+<div class="line"><a id="l00464" name="l00464"></a><span class="lineno">  464</span> </div>
+<div class="line"><a id="l00488" name="l00488"></a><span class="lineno">  488</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00489" name="l00489"></a><span class="lineno">  489</span><a class="code hl_function" href="a00187.html#ga9f8c93fde236e9642a96957af01a11cb">hwloc_get_ancestor_obj_by_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <span class="keywordtype">int</span> <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00490" name="l00490"></a><span class="lineno">  490</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00491" data-start="{" data-end="}">
+<div class="line"><a id="l00491" name="l00491"></a><span class="lineno"><a class="line" href="a00187.html#ga9f8c93fde236e9642a96957af01a11cb">  491</a></span><a class="code hl_function" href="a00187.html#ga9f8c93fde236e9642a96957af01a11cb">hwloc_get_ancestor_obj_by_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <span class="keywordtype">int</span> <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj)</div>
+<div class="line"><a id="l00492" name="l00492"></a><span class="lineno">  492</span>{</div>
+<div class="line"><a id="l00493" name="l00493"></a><span class="lineno">  493</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> ancestor = obj;</div>
+<div class="line"><a id="l00494" name="l00494"></a><span class="lineno">  494</span>  <span class="keywordflow">if</span> (obj-&gt;<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> &lt; <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>)</div>
+<div class="line"><a id="l00495" name="l00495"></a><span class="lineno">  495</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00496" name="l00496"></a><span class="lineno">  496</span>  <span class="keywordflow">while</span> (ancestor &amp;&amp; ancestor-&gt;<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> &gt; <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>)</div>
+<div class="line"><a id="l00497" name="l00497"></a><span class="lineno">  497</span>    ancestor = ancestor-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00498" name="l00498"></a><span class="lineno">  498</span>  <span class="keywordflow">return</span> ancestor;</div>
+<div class="line"><a id="l00499" name="l00499"></a><span class="lineno">  499</span>}</div>
+</div>
+<div class="line"><a id="l00500" name="l00500"></a><span class="lineno">  500</span> </div>
+<div class="line"><a id="l00514" name="l00514"></a><span class="lineno">  514</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00515" name="l00515"></a><span class="lineno">  515</span><a class="code hl_function" href="a00187.html#ga70f0c7583291da707c15ae4daa850f41">hwloc_get_ancestor_obj_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> <a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00516" name="l00516"></a><span class="lineno">  516</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00517" data-start="{" data-end="}">
+<div class="line"><a id="l00517" name="l00517"></a><span class="lineno"><a class="line" href="a00187.html#ga70f0c7583291da707c15ae4daa850f41">  517</a></span><a class="code hl_function" href="a00187.html#ga70f0c7583291da707c15ae4daa850f41">hwloc_get_ancestor_obj_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> <a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj)</div>
+<div class="line"><a id="l00518" name="l00518"></a><span class="lineno">  518</span>{</div>
+<div class="line"><a id="l00519" name="l00519"></a><span class="lineno">  519</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> ancestor = obj-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00520" name="l00520"></a><span class="lineno">  520</span>  <span class="keywordflow">while</span> (ancestor &amp;&amp; ancestor-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a> != <a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>)</div>
+<div class="line"><a id="l00521" name="l00521"></a><span class="lineno">  521</span>    ancestor = ancestor-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00522" name="l00522"></a><span class="lineno">  522</span>  <span class="keywordflow">return</span> ancestor;</div>
+<div class="line"><a id="l00523" name="l00523"></a><span class="lineno">  523</span>}</div>
+</div>
+<div class="line"><a id="l00524" name="l00524"></a><span class="lineno">  524</span> </div>
+<div class="line"><a id="l00531" name="l00531"></a><span class="lineno">  531</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00532" name="l00532"></a><span class="lineno">  532</span><a class="code hl_function" href="a00187.html#gab1fa883021928b5c476911c4102e9be3">hwloc_get_common_ancestor_obj</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj1, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj2) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00533" name="l00533"></a><span class="lineno">  533</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00534" data-start="{" data-end="}">
+<div class="line"><a id="l00534" name="l00534"></a><span class="lineno"><a class="line" href="a00187.html#gab1fa883021928b5c476911c4102e9be3">  534</a></span><a class="code hl_function" href="a00187.html#gab1fa883021928b5c476911c4102e9be3">hwloc_get_common_ancestor_obj</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj1, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj2)</div>
+<div class="line"><a id="l00535" name="l00535"></a><span class="lineno">  535</span>{</div>
+<div class="line"><a id="l00536" name="l00536"></a><span class="lineno">  536</span>  <span class="comment">/* the loop isn&#39;t so easy since intermediate ancestors may have</span></div>
+<div class="line"><a id="l00537" name="l00537"></a><span class="lineno">  537</span><span class="comment">   * different depth, causing us to alternate between using obj1-&gt;parent</span></div>
+<div class="line"><a id="l00538" name="l00538"></a><span class="lineno">  538</span><span class="comment">   * and obj2-&gt;parent. Also, even if at some point we find ancestors of</span></div>
+<div class="line"><a id="l00539" name="l00539"></a><span class="lineno">  539</span><span class="comment">   * of the same depth, their ancestors may have different depth again.</span></div>
+<div class="line"><a id="l00540" name="l00540"></a><span class="lineno">  540</span><span class="comment">   */</span></div>
+<div class="line"><a id="l00541" name="l00541"></a><span class="lineno">  541</span>  <span class="keywordflow">while</span> (obj1 != obj2) {</div>
+<div class="line"><a id="l00542" name="l00542"></a><span class="lineno">  542</span>    <span class="keywordflow">while</span> (obj1-&gt;<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> &gt; obj2-&gt;<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>)</div>
+<div class="line"><a id="l00543" name="l00543"></a><span class="lineno">  543</span>      obj1 = obj1-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00544" name="l00544"></a><span class="lineno">  544</span>    <span class="keywordflow">while</span> (obj2-&gt;<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> &gt; obj1-&gt;<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>)</div>
+<div class="line"><a id="l00545" name="l00545"></a><span class="lineno">  545</span>      obj2 = obj2-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00546" name="l00546"></a><span class="lineno">  546</span>    <span class="keywordflow">if</span> (obj1 != obj2 &amp;&amp; obj1-&gt;<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> == obj2-&gt;<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>) {</div>
+<div class="line"><a id="l00547" name="l00547"></a><span class="lineno">  547</span>      obj1 = obj1-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00548" name="l00548"></a><span class="lineno">  548</span>      obj2 = obj2-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00549" name="l00549"></a><span class="lineno">  549</span>    }</div>
+<div class="line"><a id="l00550" name="l00550"></a><span class="lineno">  550</span>  }</div>
+<div class="line"><a id="l00551" name="l00551"></a><span class="lineno">  551</span>  <span class="keywordflow">return</span> obj1;</div>
+<div class="line"><a id="l00552" name="l00552"></a><span class="lineno">  552</span>}</div>
+</div>
+<div class="line"><a id="l00553" name="l00553"></a><span class="lineno">  553</span> </div>
+<div class="line"><a id="l00561" name="l00561"></a><span class="lineno">  561</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00562" name="l00562"></a><span class="lineno">  562</span><a class="code hl_function" href="a00187.html#ga408cf74f5bf9ed497911a320c7f8cc56">hwloc_obj_is_in_subtree</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> subtree_root) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00563" name="l00563"></a><span class="lineno">  563</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00564" data-start="{" data-end="}">
+<div class="line"><a id="l00564" name="l00564"></a><span class="lineno"><a class="line" href="a00187.html#ga408cf74f5bf9ed497911a320c7f8cc56">  564</a></span><a class="code hl_function" href="a00187.html#ga408cf74f5bf9ed497911a320c7f8cc56">hwloc_obj_is_in_subtree</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> subtree_root)</div>
+<div class="line"><a id="l00565" name="l00565"></a><span class="lineno">  565</span>{</div>
+<div class="line"><a id="l00566" name="l00566"></a><span class="lineno">  566</span>  <span class="keywordflow">return</span> obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a> &amp;&amp; subtree_root-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a> &amp;&amp; <a class="code hl_function" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, subtree_root-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>);</div>
+<div class="line"><a id="l00567" name="l00567"></a><span class="lineno">  567</span>}</div>
+</div>
+<div class="line"><a id="l00568" name="l00568"></a><span class="lineno">  568</span> </div>
+<div class="line"><a id="l00579" name="l00579"></a><span class="lineno">  579</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00580" data-start="{" data-end="}">
+<div class="line"><a id="l00580" name="l00580"></a><span class="lineno"><a class="line" href="a00187.html#ga12d8565a3436c565e791ed02a0353621">  580</a></span><a class="code hl_function" href="a00187.html#ga12d8565a3436c565e791ed02a0353621">hwloc_get_next_child</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> <a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> prev)</div>
+<div class="line"><a id="l00581" name="l00581"></a><span class="lineno">  581</span>{</div>
+<div class="line"><a id="l00582" name="l00582"></a><span class="lineno">  582</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj;</div>
+<div class="line"><a id="l00583" name="l00583"></a><span class="lineno">  583</span>  <span class="keywordtype">int</span> state = 0;</div>
+<div class="line"><a id="l00584" name="l00584"></a><span class="lineno">  584</span>  <span class="keywordflow">if</span> (prev) {</div>
+<div class="line"><a id="l00585" name="l00585"></a><span class="lineno">  585</span>    <span class="keywordflow">if</span> (prev-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a> == <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d">HWLOC_OBJ_MISC</a>)</div>
+<div class="line"><a id="l00586" name="l00586"></a><span class="lineno">  586</span>      state = 3;</div>
+<div class="line"><a id="l00587" name="l00587"></a><span class="lineno">  587</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code hl_function" href="a00184.html#gac8a954ed37a4376097234c828068cbef">hwloc_obj_type_is_io</a>(prev-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>))</div>
+<div class="line"><a id="l00588" name="l00588"></a><span class="lineno">  588</span>      state = 2;</div>
+<div class="line"><a id="l00589" name="l00589"></a><span class="lineno">  589</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code hl_function" href="a00184.html#ga1d074390c8a3dc3088d84f73fb73f966">hwloc_obj_type_is_memory</a>(prev-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>))</div>
+<div class="line"><a id="l00590" name="l00590"></a><span class="lineno">  590</span>      state = 1;</div>
+<div class="line"><a id="l00591" name="l00591"></a><span class="lineno">  591</span>    obj = prev-&gt;<a class="code hl_variable" href="a00229.html#a7f2343ed476fe4942e6fffd4cade1b40">next_sibling</a>;</div>
+<div class="line"><a id="l00592" name="l00592"></a><span class="lineno">  592</span>  } <span class="keywordflow">else</span> {</div>
+<div class="line"><a id="l00593" name="l00593"></a><span class="lineno">  593</span>    obj = <a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>-&gt;<a class="code hl_variable" href="a00229.html#af51d08a0a79dba517c06c5afedc8d2dc">first_child</a>;</div>
+<div class="line"><a id="l00594" name="l00594"></a><span class="lineno">  594</span>  }</div>
+<div class="line"><a id="l00595" name="l00595"></a><span class="lineno">  595</span>  <span class="keywordflow">if</span> (!obj &amp;&amp; state == 0) {</div>
+<div class="line"><a id="l00596" name="l00596"></a><span class="lineno">  596</span>    obj = <a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>-&gt;<a class="code hl_variable" href="a00229.html#ac0e8200dba25b90d5954bd4ec61f97d3">memory_first_child</a>;</div>
+<div class="line"><a id="l00597" name="l00597"></a><span class="lineno">  597</span>    state = 1;</div>
+<div class="line"><a id="l00598" name="l00598"></a><span class="lineno">  598</span>  }</div>
+<div class="line"><a id="l00599" name="l00599"></a><span class="lineno">  599</span>  <span class="keywordflow">if</span> (!obj &amp;&amp; state == 1) {</div>
+<div class="line"><a id="l00600" name="l00600"></a><span class="lineno">  600</span>    obj = <a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>-&gt;<a class="code hl_variable" href="a00229.html#a8d14c88e1ebc4ae67cc69f9e928558b3">io_first_child</a>;</div>
+<div class="line"><a id="l00601" name="l00601"></a><span class="lineno">  601</span>    state = 2;</div>
+<div class="line"><a id="l00602" name="l00602"></a><span class="lineno">  602</span>  }</div>
+<div class="line"><a id="l00603" name="l00603"></a><span class="lineno">  603</span>  <span class="keywordflow">if</span> (!obj &amp;&amp; state == 2) {</div>
+<div class="line"><a id="l00604" name="l00604"></a><span class="lineno">  604</span>    obj = <a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>-&gt;<a class="code hl_variable" href="a00229.html#a57812a313fe9b1a9500489f47c3011cc">misc_first_child</a>;</div>
+<div class="line"><a id="l00605" name="l00605"></a><span class="lineno">  605</span>    state = 3;</div>
+<div class="line"><a id="l00606" name="l00606"></a><span class="lineno">  606</span>  }</div>
+<div class="line"><a id="l00607" name="l00607"></a><span class="lineno">  607</span>  <span class="keywordflow">return</span> obj;</div>
+<div class="line"><a id="l00608" name="l00608"></a><span class="lineno">  608</span>}</div>
+</div>
+<div class="line"><a id="l00609" name="l00609"></a><span class="lineno">  609</span> </div>
+<div class="line"><a id="l00641" name="l00641"></a><span class="lineno">  641</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00642" data-start="{" data-end="}">
+<div class="line"><a id="l00642" name="l00642"></a><span class="lineno"><a class="line" href="a00188.html#gad108a09ce400222fe45545257d575489">  642</a></span><a class="code hl_function" href="a00188.html#gad108a09ce400222fe45545257d575489">hwloc_get_cache_type_depth</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00643" name="l00643"></a><span class="lineno">  643</span>                            <span class="keywordtype">unsigned</span> cachelevel, <a class="code hl_typedef" href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a> cachetype)</div>
+<div class="line"><a id="l00644" name="l00644"></a><span class="lineno">  644</span>{</div>
+<div class="line"><a id="l00645" name="l00645"></a><span class="lineno">  645</span>  <span class="keywordtype">int</span> <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>;</div>
+<div class="line"><a id="l00646" name="l00646"></a><span class="lineno">  646</span>  <span class="keywordtype">int</span> found = <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a>;</div>
+<div class="line"><a id="l00647" name="l00647"></a><span class="lineno">  647</span>  <span class="keywordflow">for</span> (<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>=0; ; <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>++) {</div>
+<div class="line"><a id="l00648" name="l00648"></a><span class="lineno">  648</span>    <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj = <a class="code hl_function" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0">hwloc_get_obj_by_depth</a>(topology, <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>, 0);</div>
+<div class="line"><a id="l00649" name="l00649"></a><span class="lineno">  649</span>    <span class="keywordflow">if</span> (!obj)</div>
+<div class="line"><a id="l00650" name="l00650"></a><span class="lineno">  650</span>      <span class="keywordflow">break</span>;</div>
+<div class="line"><a id="l00651" name="l00651"></a><span class="lineno">  651</span>    <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00184.html#ga395e48cd221d107e5891689624e1aec4">hwloc_obj_type_is_dcache</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>) || obj-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">cache</a>.<a class="code hl_variable" href="a00245.html#a5c8f7f39193736c2187ed626940835d5">depth</a> != cachelevel)</div>
+<div class="line"><a id="l00652" name="l00652"></a><span class="lineno">  652</span>      <span class="comment">/* doesn&#39;t match, try next depth */</span></div>
+<div class="line"><a id="l00653" name="l00653"></a><span class="lineno">  653</span>      <span class="keywordflow">continue</span>;</div>
+<div class="line"><a id="l00654" name="l00654"></a><span class="lineno">  654</span>    <span class="keywordflow">if</span> (cachetype == (<a class="code hl_typedef" href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a>) -1) {</div>
+<div class="line"><a id="l00655" name="l00655"></a><span class="lineno">  655</span>      <span class="keywordflow">if</span> (found != <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a>) {</div>
+<div class="line"><a id="l00656" name="l00656"></a><span class="lineno">  656</span>        <span class="comment">/* second match, return MULTIPLE */</span></div>
+<div class="line"><a id="l00657" name="l00657"></a><span class="lineno">  657</span>        <span class="keywordflow">return</span> <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">HWLOC_TYPE_DEPTH_MULTIPLE</a>;</div>
+<div class="line"><a id="l00658" name="l00658"></a><span class="lineno">  658</span>      }</div>
+<div class="line"><a id="l00659" name="l00659"></a><span class="lineno">  659</span>      <span class="comment">/* first match, mark it as found */</span></div>
+<div class="line"><a id="l00660" name="l00660"></a><span class="lineno">  660</span>      found = <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>;</div>
+<div class="line"><a id="l00661" name="l00661"></a><span class="lineno">  661</span>      <span class="keywordflow">continue</span>;</div>
+<div class="line"><a id="l00662" name="l00662"></a><span class="lineno">  662</span>    }</div>
+<div class="line"><a id="l00663" name="l00663"></a><span class="lineno">  663</span>    <span class="keywordflow">if</span> (obj-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">cache</a>.<a class="code hl_variable" href="a00245.html#ad8edc8ded2b7a70d6abbc874801930f4">type</a> == cachetype || obj-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">cache</a>.<a class="code hl_variable" href="a00245.html#ad8edc8ded2b7a70d6abbc874801930f4">type</a> == <a class="code hl_enumvalue" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a">HWLOC_OBJ_CACHE_UNIFIED</a>)</div>
+<div class="line"><a id="l00664" name="l00664"></a><span class="lineno">  664</span>      <span class="comment">/* exact match (either unified is alone, or we match instruction or data), return immediately */</span></div>
+<div class="line"><a id="l00665" name="l00665"></a><span class="lineno">  665</span>      <span class="keywordflow">return</span> <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>;</div>
+<div class="line"><a id="l00666" name="l00666"></a><span class="lineno">  666</span>  }</div>
+<div class="line"><a id="l00667" name="l00667"></a><span class="lineno">  667</span>  <span class="comment">/* went to the bottom, return what we found */</span></div>
+<div class="line"><a id="l00668" name="l00668"></a><span class="lineno">  668</span>  <span class="keywordflow">return</span> found;</div>
+<div class="line"><a id="l00669" name="l00669"></a><span class="lineno">  669</span>}</div>
+</div>
+<div class="line"><a id="l00670" name="l00670"></a><span class="lineno">  670</span> </div>
+<div class="line"><a id="l00675" name="l00675"></a><span class="lineno">  675</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00676" name="l00676"></a><span class="lineno">  676</span><a class="code hl_function" href="a00188.html#gac4cd480a5deaa4ada047fdd11ae4c070">hwloc_get_cache_covering_cpuset</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00677" name="l00677"></a><span class="lineno">  677</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00678" data-start="{" data-end="}">
+<div class="line"><a id="l00678" name="l00678"></a><span class="lineno"><a class="line" href="a00188.html#gac4cd480a5deaa4ada047fdd11ae4c070">  678</a></span><a class="code hl_function" href="a00188.html#gac4cd480a5deaa4ada047fdd11ae4c070">hwloc_get_cache_covering_cpuset</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set)</div>
+<div class="line"><a id="l00679" name="l00679"></a><span class="lineno">  679</span>{</div>
+<div class="line"><a id="l00680" name="l00680"></a><span class="lineno">  680</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> current = <a class="code hl_function" href="a00186.html#ga41acdcdbb8b95d70ecf6c572a3f67dca">hwloc_get_obj_covering_cpuset</a>(topology, set);</div>
+<div class="line"><a id="l00681" name="l00681"></a><span class="lineno">  681</span>  <span class="keywordflow">while</span> (current) {</div>
+<div class="line"><a id="l00682" name="l00682"></a><span class="lineno">  682</span>    <span class="keywordflow">if</span> (<a class="code hl_function" href="a00184.html#ga395e48cd221d107e5891689624e1aec4">hwloc_obj_type_is_dcache</a>(current-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>))</div>
+<div class="line"><a id="l00683" name="l00683"></a><span class="lineno">  683</span>      <span class="keywordflow">return</span> current;</div>
+<div class="line"><a id="l00684" name="l00684"></a><span class="lineno">  684</span>    current = current-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00685" name="l00685"></a><span class="lineno">  685</span>  }</div>
+<div class="line"><a id="l00686" name="l00686"></a><span class="lineno">  686</span>  <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00687" name="l00687"></a><span class="lineno">  687</span>}</div>
+</div>
+<div class="line"><a id="l00688" name="l00688"></a><span class="lineno">  688</span> </div>
+<div class="line"><a id="l00694" name="l00694"></a><span class="lineno">  694</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00695" name="l00695"></a><span class="lineno">  695</span><a class="code hl_function" href="a00188.html#ga36f48c32837c7a70b424706e213dcd71">hwloc_get_shared_cache_covering_obj</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00696" name="l00696"></a><span class="lineno">  696</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00697" data-start="{" data-end="}">
+<div class="line"><a id="l00697" name="l00697"></a><span class="lineno"><a class="line" href="a00188.html#ga36f48c32837c7a70b424706e213dcd71">  697</a></span><a class="code hl_function" href="a00188.html#ga36f48c32837c7a70b424706e213dcd71">hwloc_get_shared_cache_covering_obj</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj)</div>
+<div class="line"><a id="l00698" name="l00698"></a><span class="lineno">  698</span>{</div>
+<div class="line"><a id="l00699" name="l00699"></a><span class="lineno">  699</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> current = obj-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00700" name="l00700"></a><span class="lineno">  700</span>  <span class="keywordflow">if</span> (!obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>)</div>
+<div class="line"><a id="l00701" name="l00701"></a><span class="lineno">  701</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00702" name="l00702"></a><span class="lineno">  702</span>  <span class="keywordflow">while</span> (current) {</div>
+<div class="line"><a id="l00703" name="l00703"></a><span class="lineno">  703</span>    <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00194.html#ga32376b1405e57472b73c3aa53bb39663">hwloc_bitmap_isequal</a>(current-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>)</div>
+<div class="line"><a id="l00704" name="l00704"></a><span class="lineno">  704</span>        &amp;&amp; <a class="code hl_function" href="a00184.html#ga395e48cd221d107e5891689624e1aec4">hwloc_obj_type_is_dcache</a>(current-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>))</div>
+<div class="line"><a id="l00705" name="l00705"></a><span class="lineno">  705</span>      <span class="keywordflow">return</span> current;</div>
+<div class="line"><a id="l00706" name="l00706"></a><span class="lineno">  706</span>    current = current-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00707" name="l00707"></a><span class="lineno">  707</span>  }</div>
+<div class="line"><a id="l00708" name="l00708"></a><span class="lineno">  708</span>  <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00709" name="l00709"></a><span class="lineno">  709</span>}</div>
+</div>
+<div class="line"><a id="l00710" name="l00710"></a><span class="lineno">  710</span> </div>
+<div class="line"><a id="l00742" name="l00742"></a><span class="lineno"><a class="line" href="a00189.html#ga050646458efc8ca1120d9f124c5ad861">  742</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00189.html#ga050646458efc8ca1120d9f124c5ad861">hwloc_bitmap_singlify_per_core</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> <a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, <span class="keywordtype">unsigned</span> which);</div>
+<div class="line"><a id="l00743" name="l00743"></a><span class="lineno">  743</span> </div>
+<div class="line"><a id="l00755" name="l00755"></a><span class="lineno">  755</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00756" name="l00756"></a><span class="lineno">  756</span><a class="code hl_function" href="a00189.html#ga751c238a4931db5cc0ca3181b7dd7479">hwloc_get_pu_obj_by_os_index</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00757" name="l00757"></a><span class="lineno">  757</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00758" data-start="{" data-end="}">
+<div class="line"><a id="l00758" name="l00758"></a><span class="lineno"><a class="line" href="a00189.html#ga751c238a4931db5cc0ca3181b7dd7479">  758</a></span><a class="code hl_function" href="a00189.html#ga751c238a4931db5cc0ca3181b7dd7479">hwloc_get_pu_obj_by_os_index</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>)</div>
+<div class="line"><a id="l00759" name="l00759"></a><span class="lineno">  759</span>{</div>
+<div class="line"><a id="l00760" name="l00760"></a><span class="lineno">  760</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj = NULL;</div>
+<div class="line"><a id="l00761" name="l00761"></a><span class="lineno">  761</span>  <span class="keywordflow">while</span> ((obj = <a class="code hl_function" href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735">hwloc_get_next_obj_by_type</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661">HWLOC_OBJ_PU</a>, obj)) != NULL)</div>
+<div class="line"><a id="l00762" name="l00762"></a><span class="lineno">  762</span>    <span class="keywordflow">if</span> (obj-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a> == <a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>)</div>
+<div class="line"><a id="l00763" name="l00763"></a><span class="lineno">  763</span>      <span class="keywordflow">return</span> obj;</div>
+<div class="line"><a id="l00764" name="l00764"></a><span class="lineno">  764</span>  <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00765" name="l00765"></a><span class="lineno">  765</span>}</div>
+</div>
+<div class="line"><a id="l00766" name="l00766"></a><span class="lineno">  766</span> </div>
+<div class="line"><a id="l00778" name="l00778"></a><span class="lineno">  778</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00779" name="l00779"></a><span class="lineno">  779</span><a class="code hl_function" href="a00189.html#gab89d9ed9edfaa3dd526fb6ee1a1618ea">hwloc_get_numanode_obj_by_os_index</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00780" name="l00780"></a><span class="lineno">  780</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00781" data-start="{" data-end="}">
+<div class="line"><a id="l00781" name="l00781"></a><span class="lineno"><a class="line" href="a00189.html#gab89d9ed9edfaa3dd526fb6ee1a1618ea">  781</a></span><a class="code hl_function" href="a00189.html#gab89d9ed9edfaa3dd526fb6ee1a1618ea">hwloc_get_numanode_obj_by_os_index</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>)</div>
+<div class="line"><a id="l00782" name="l00782"></a><span class="lineno">  782</span>{</div>
+<div class="line"><a id="l00783" name="l00783"></a><span class="lineno">  783</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj = NULL;</div>
+<div class="line"><a id="l00784" name="l00784"></a><span class="lineno">  784</span>  <span class="keywordflow">while</span> ((obj = <a class="code hl_function" href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735">hwloc_get_next_obj_by_type</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>, obj)) != NULL)</div>
+<div class="line"><a id="l00785" name="l00785"></a><span class="lineno">  785</span>    <span class="keywordflow">if</span> (obj-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a> == <a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>)</div>
+<div class="line"><a id="l00786" name="l00786"></a><span class="lineno">  786</span>      <span class="keywordflow">return</span> obj;</div>
+<div class="line"><a id="l00787" name="l00787"></a><span class="lineno">  787</span>  <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00788" name="l00788"></a><span class="lineno">  788</span>}</div>
+</div>
+<div class="line"><a id="l00789" name="l00789"></a><span class="lineno">  789</span> </div>
+<div class="line"><a id="l00801" name="l00801"></a><span class="lineno">  801</span><span class="comment">/* TODO: rather provide an iterator? Provide a way to know how much should be allocated? By returning the total number of objects instead? */</span></div>
+<div class="line"><a id="l00802" name="l00802"></a><span class="lineno"><a class="line" href="a00189.html#ga2cd22a34360643f7f5bad09576dec205">  802</a></span>HWLOC_DECLSPEC <span class="keywordtype">unsigned</span> <a class="code hl_function" href="a00189.html#ga2cd22a34360643f7f5bad09576dec205">hwloc_get_closest_objs</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> src, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> * __hwloc_restrict objs, <span class="keywordtype">unsigned</span> max);</div>
+<div class="line"><a id="l00803" name="l00803"></a><span class="lineno">  803</span> </div>
+<div class="line"><a id="l00818" name="l00818"></a><span class="lineno">  818</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00819" name="l00819"></a><span class="lineno">  819</span><a class="code hl_function" href="a00189.html#ga7a0c1046851f7a88bd52f5a1d4ba0a97">hwloc_get_obj_below_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00820" name="l00820"></a><span class="lineno">  820</span>                             <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type1, <span class="keywordtype">unsigned</span> idx1,</div>
+<div class="line"><a id="l00821" name="l00821"></a><span class="lineno">  821</span>                             <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type2, <span class="keywordtype">unsigned</span> idx2) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00822" name="l00822"></a><span class="lineno">  822</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00823" data-start="{" data-end="}">
+<div class="line"><a id="l00823" name="l00823"></a><span class="lineno"><a class="line" href="a00189.html#ga7a0c1046851f7a88bd52f5a1d4ba0a97">  823</a></span><a class="code hl_function" href="a00189.html#ga7a0c1046851f7a88bd52f5a1d4ba0a97">hwloc_get_obj_below_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00824" name="l00824"></a><span class="lineno">  824</span>                             <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type1, <span class="keywordtype">unsigned</span> idx1,</div>
+<div class="line"><a id="l00825" name="l00825"></a><span class="lineno">  825</span>                             <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type2, <span class="keywordtype">unsigned</span> idx2)</div>
+<div class="line"><a id="l00826" name="l00826"></a><span class="lineno">  826</span>{</div>
+<div class="line"><a id="l00827" name="l00827"></a><span class="lineno">  827</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj;</div>
+<div class="line"><a id="l00828" name="l00828"></a><span class="lineno">  828</span>  obj = <a class="code hl_function" href="a00176.html#ga6f414dd80a2b943967a0ac92da3181a2">hwloc_get_obj_by_type</a> (topology, type1, idx1);</div>
+<div class="line"><a id="l00829" name="l00829"></a><span class="lineno">  829</span>  <span class="keywordflow">if</span> (!obj)</div>
+<div class="line"><a id="l00830" name="l00830"></a><span class="lineno">  830</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00831" name="l00831"></a><span class="lineno">  831</span>  <span class="keywordflow">return</span> <a class="code hl_function" href="a00185.html#ga2edf924e5a0cca9cb22f65cc77c6ddb5">hwloc_get_obj_inside_cpuset_by_type</a>(topology, obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, type2, idx2);</div>
+<div class="line"><a id="l00832" name="l00832"></a><span class="lineno">  832</span>}</div>
+</div>
+<div class="line"><a id="l00833" name="l00833"></a><span class="lineno">  833</span> </div>
+<div class="line"><a id="l00854" name="l00854"></a><span class="lineno">  854</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00855" name="l00855"></a><span class="lineno">  855</span><a class="code hl_function" href="a00189.html#gacb51295ff3fbd3a96f990f20c6492b1d">hwloc_get_obj_below_array_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">int</span> nr, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> *typev, <span class="keywordtype">unsigned</span> *idxv) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00856" name="l00856"></a><span class="lineno">  856</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00857" data-start="{" data-end="}">
+<div class="line"><a id="l00857" name="l00857"></a><span class="lineno"><a class="line" href="a00189.html#gacb51295ff3fbd3a96f990f20c6492b1d">  857</a></span><a class="code hl_function" href="a00189.html#gacb51295ff3fbd3a96f990f20c6492b1d">hwloc_get_obj_below_array_by_type</a> (<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">int</span> nr, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> *typev, <span class="keywordtype">unsigned</span> *idxv)</div>
+<div class="line"><a id="l00858" name="l00858"></a><span class="lineno">  858</span>{</div>
+<div class="line"><a id="l00859" name="l00859"></a><span class="lineno">  859</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj = <a class="code hl_function" href="a00176.html#ga2d4b12fc187dfc53b35f2fa21d21044d">hwloc_get_root_obj</a>(topology);</div>
+<div class="line"><a id="l00860" name="l00860"></a><span class="lineno">  860</span>  <span class="keywordtype">int</span> i;</div>
+<div class="line"><a id="l00861" name="l00861"></a><span class="lineno">  861</span>  <span class="keywordflow">for</span>(i=0; i&lt;nr; i++) {</div>
+<div class="line"><a id="l00862" name="l00862"></a><span class="lineno">  862</span>    <span class="keywordflow">if</span> (!obj)</div>
+<div class="line"><a id="l00863" name="l00863"></a><span class="lineno">  863</span>      <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00864" name="l00864"></a><span class="lineno">  864</span>    obj = <a class="code hl_function" href="a00185.html#ga2edf924e5a0cca9cb22f65cc77c6ddb5">hwloc_get_obj_inside_cpuset_by_type</a>(topology, obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, typev[i], idxv[i]);</div>
+<div class="line"><a id="l00865" name="l00865"></a><span class="lineno">  865</span>  }</div>
+<div class="line"><a id="l00866" name="l00866"></a><span class="lineno">  866</span>  <span class="keywordflow">return</span> obj;</div>
+<div class="line"><a id="l00867" name="l00867"></a><span class="lineno">  867</span>}</div>
+</div>
+<div class="line"><a id="l00868" name="l00868"></a><span class="lineno">  868</span> </div>
+<div class="line"><a id="l00907" name="l00907"></a><span class="lineno">  907</span>HWLOC_DECLSPEC <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00908" name="l00908"></a><span class="lineno"><a class="line" href="a00189.html#gab5df3ad1e8565ea0c2cf06412f6f6233">  908</a></span><a class="code hl_function" href="a00189.html#gab5df3ad1e8565ea0c2cf06412f6f6233">hwloc_get_obj_with_same_locality</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> src,</div>
+<div class="line"><a id="l00909" name="l00909"></a><span class="lineno">  909</span>                                 <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> <a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>, <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code hl_variable" href="a00229.html#a5d4f97e76723a9ec8d38046f19e00d33">subtype</a>, <span class="keyword">const</span> <span class="keywordtype">char</span> *nameprefix,</div>
+<div class="line"><a id="l00910" name="l00910"></a><span class="lineno">  910</span>                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00911" name="l00911"></a><span class="lineno">  911</span> </div>
+<div class="foldopen" id="foldopen00922" data-start="{" data-end="};">
+<div class="line"><a id="l00922" name="l00922"></a><span class="lineno"><a class="line" href="a00190.html#ga8b835295a52b6768a5e6c8abb1f9c54d">  922</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00190.html#ga8b835295a52b6768a5e6c8abb1f9c54d">hwloc_distrib_flags_e</a> {</div>
+<div class="line"><a id="l00926" name="l00926"></a><span class="lineno">  926</span>  <a class="code hl_enumvalue" href="a00190.html#gga8b835295a52b6768a5e6c8abb1f9c54da2ca08404bfbebe9ed5f34c3d7635425a">HWLOC_DISTRIB_FLAG_REVERSE</a> = (1UL&lt;&lt;0)</div>
+<div class="line"><a id="l00927" name="l00927"></a><span class="lineno"><a class="line" href="a00190.html#gga8b835295a52b6768a5e6c8abb1f9c54da2ca08404bfbebe9ed5f34c3d7635425a">  927</a></span>};</div>
+</div>
+<div class="line"><a id="l00928" name="l00928"></a><span class="lineno">  928</span> </div>
+<div class="line"><a id="l00959" name="l00959"></a><span class="lineno">  959</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00960" data-start="{" data-end="}">
+<div class="line"><a id="l00960" name="l00960"></a><span class="lineno"><a class="line" href="a00190.html#ga7b0c28f797c2ff17fa2f244ebbd55b33">  960</a></span><a class="code hl_function" href="a00190.html#ga7b0c28f797c2ff17fa2f244ebbd55b33">hwloc_distrib</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00961" name="l00961"></a><span class="lineno">  961</span>              <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> *roots, <span class="keywordtype">unsigned</span> n_roots,</div>
+<div class="line"><a id="l00962" name="l00962"></a><span class="lineno">  962</span>              <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> *set,</div>
+<div class="line"><a id="l00963" name="l00963"></a><span class="lineno">  963</span>              <span class="keywordtype">unsigned</span> n,</div>
+<div class="line"><a id="l00964" name="l00964"></a><span class="lineno">  964</span>              <span class="keywordtype">int</span> until, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags)</div>
+<div class="line"><a id="l00965" name="l00965"></a><span class="lineno">  965</span>{</div>
+<div class="line"><a id="l00966" name="l00966"></a><span class="lineno">  966</span>  <span class="keywordtype">unsigned</span> i;</div>
+<div class="line"><a id="l00967" name="l00967"></a><span class="lineno">  967</span>  <span class="keywordtype">unsigned</span> tot_weight;</div>
+<div class="line"><a id="l00968" name="l00968"></a><span class="lineno">  968</span>  <span class="keywordtype">unsigned</span> given, givenweight;</div>
+<div class="line"><a id="l00969" name="l00969"></a><span class="lineno">  969</span>  <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> *cpusetp = set;</div>
+<div class="line"><a id="l00970" name="l00970"></a><span class="lineno">  970</span> </div>
+<div class="line"><a id="l00971" name="l00971"></a><span class="lineno">  971</span>  <span class="keywordflow">if</span> (flags &amp; ~<a class="code hl_enumvalue" href="a00190.html#gga8b835295a52b6768a5e6c8abb1f9c54da2ca08404bfbebe9ed5f34c3d7635425a">HWLOC_DISTRIB_FLAG_REVERSE</a>) {</div>
+<div class="line"><a id="l00972" name="l00972"></a><span class="lineno">  972</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00973" name="l00973"></a><span class="lineno">  973</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00974" name="l00974"></a><span class="lineno">  974</span>  }</div>
+<div class="line"><a id="l00975" name="l00975"></a><span class="lineno">  975</span> </div>
+<div class="line"><a id="l00976" name="l00976"></a><span class="lineno">  976</span>  tot_weight = 0;</div>
+<div class="line"><a id="l00977" name="l00977"></a><span class="lineno">  977</span>  <span class="keywordflow">for</span> (i = 0; i &lt; n_roots; i++)</div>
+<div class="line"><a id="l00978" name="l00978"></a><span class="lineno">  978</span>    tot_weight += (<span class="keywordtype">unsigned</span>) <a class="code hl_function" href="a00194.html#ga0200466842c0e1f5da75e84dde460b10">hwloc_bitmap_weight</a>(roots[i]-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>);</div>
+<div class="line"><a id="l00979" name="l00979"></a><span class="lineno">  979</span> </div>
+<div class="line"><a id="l00980" name="l00980"></a><span class="lineno">  980</span>  <span class="keywordflow">for</span> (i = 0, given = 0, givenweight = 0; i &lt; n_roots; i++) {</div>
+<div class="line"><a id="l00981" name="l00981"></a><span class="lineno">  981</span>    <span class="keywordtype">unsigned</span> chunk, weight;</div>
+<div class="line"><a id="l00982" name="l00982"></a><span class="lineno">  982</span>    <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> root = roots[flags &amp; <a class="code hl_enumvalue" href="a00190.html#gga8b835295a52b6768a5e6c8abb1f9c54da2ca08404bfbebe9ed5f34c3d7635425a">HWLOC_DISTRIB_FLAG_REVERSE</a> ? n_roots-1-i : i];</div>
+<div class="line"><a id="l00983" name="l00983"></a><span class="lineno">  983</span>    <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> <a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a> = root-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>;</div>
+<div class="line"><a id="l00984" name="l00984"></a><span class="lineno">  984</span>    <span class="keywordflow">while</span> (!<a class="code hl_function" href="a00184.html#ga52ef38431eba383b048b98c669b59a16">hwloc_obj_type_is_normal</a>(root-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>))</div>
+<div class="line"><a id="l00985" name="l00985"></a><span class="lineno">  985</span>      <span class="comment">/* If memory/io/misc, walk up to normal parent */</span></div>
+<div class="line"><a id="l00986" name="l00986"></a><span class="lineno">  986</span>      root = root-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00987" name="l00987"></a><span class="lineno">  987</span>    weight = (unsigned) <a class="code hl_function" href="a00194.html#ga0200466842c0e1f5da75e84dde460b10">hwloc_bitmap_weight</a>(<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>);</div>
+<div class="line"><a id="l00988" name="l00988"></a><span class="lineno">  988</span>    <span class="keywordflow">if</span> (!weight)</div>
+<div class="line"><a id="l00989" name="l00989"></a><span class="lineno">  989</span>      <span class="keywordflow">continue</span>;</div>
+<div class="line"><a id="l00990" name="l00990"></a><span class="lineno">  990</span>    <span class="comment">/* Give to root a chunk proportional to its weight.</span></div>
+<div class="line"><a id="l00991" name="l00991"></a><span class="lineno">  991</span><span class="comment">     * If previous chunks got rounded-up, we may get a bit less. */</span></div>
+<div class="line"><a id="l00992" name="l00992"></a><span class="lineno">  992</span>    chunk = (( (givenweight+weight) * n  + tot_weight-1) / tot_weight)</div>
+<div class="line"><a id="l00993" name="l00993"></a><span class="lineno">  993</span>          - ((  givenweight         * n  + tot_weight-1) / tot_weight);</div>
+<div class="line"><a id="l00994" name="l00994"></a><span class="lineno">  994</span>    <span class="keywordflow">if</span> (!root-&gt;<a class="code hl_variable" href="a00229.html#aac3f6da35c9b57599909a44ce2b716c1">arity</a> || chunk &lt;= 1 || root-&gt;<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> &gt;= until) {</div>
+<div class="line"><a id="l00995" name="l00995"></a><span class="lineno">  995</span>      <span class="comment">/* We can&#39;t split any more, put everything there.  */</span></div>
+<div class="line"><a id="l00996" name="l00996"></a><span class="lineno">  996</span>      <span class="keywordflow">if</span> (chunk) {</div>
+<div class="line"><a id="l00997" name="l00997"></a><span class="lineno">  997</span>        <span class="comment">/* Fill cpusets with ours */</span></div>
+<div class="line"><a id="l00998" name="l00998"></a><span class="lineno">  998</span>        <span class="keywordtype">unsigned</span> j;</div>
+<div class="line"><a id="l00999" name="l00999"></a><span class="lineno">  999</span>        <span class="keywordflow">for</span> (j=0; j &lt; chunk; j++)</div>
+<div class="line"><a id="l01000" name="l01000"></a><span class="lineno"> 1000</span>          cpusetp[j] = <a class="code hl_function" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee">hwloc_bitmap_dup</a>(<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>);</div>
+<div class="line"><a id="l01001" name="l01001"></a><span class="lineno"> 1001</span>      } <span class="keywordflow">else</span> {</div>
+<div class="line"><a id="l01002" name="l01002"></a><span class="lineno"> 1002</span>        <span class="comment">/* We got no chunk, just merge our cpuset to a previous one</span></div>
+<div class="line"><a id="l01003" name="l01003"></a><span class="lineno"> 1003</span><span class="comment">         * (the first chunk cannot be empty)</span></div>
+<div class="line"><a id="l01004" name="l01004"></a><span class="lineno"> 1004</span><span class="comment">         * so that this root doesn&#39;t get ignored.</span></div>
+<div class="line"><a id="l01005" name="l01005"></a><span class="lineno"> 1005</span><span class="comment">         */</span></div>
+<div class="line"><a id="l01006" name="l01006"></a><span class="lineno"> 1006</span>        assert(given);</div>
+<div class="line"><a id="l01007" name="l01007"></a><span class="lineno"> 1007</span>        <a class="code hl_function" href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">hwloc_bitmap_or</a>(cpusetp[-1], cpusetp[-1], <a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>);</div>
+<div class="line"><a id="l01008" name="l01008"></a><span class="lineno"> 1008</span>      }</div>
+<div class="line"><a id="l01009" name="l01009"></a><span class="lineno"> 1009</span>    } <span class="keywordflow">else</span> {</div>
+<div class="line"><a id="l01010" name="l01010"></a><span class="lineno"> 1010</span>      <span class="comment">/* Still more to distribute, recurse into children */</span></div>
+<div class="line"><a id="l01011" name="l01011"></a><span class="lineno"> 1011</span>      <a class="code hl_function" href="a00190.html#ga7b0c28f797c2ff17fa2f244ebbd55b33">hwloc_distrib</a>(topology, root-&gt;<a class="code hl_variable" href="a00229.html#a04d05403da37bfe17cd63b7c7dd07b1f">children</a>, root-&gt;<a class="code hl_variable" href="a00229.html#aac3f6da35c9b57599909a44ce2b716c1">arity</a>, cpusetp, chunk, until, flags);</div>
+<div class="line"><a id="l01012" name="l01012"></a><span class="lineno"> 1012</span>    }</div>
+<div class="line"><a id="l01013" name="l01013"></a><span class="lineno"> 1013</span>    cpusetp += chunk;</div>
+<div class="line"><a id="l01014" name="l01014"></a><span class="lineno"> 1014</span>    given += chunk;</div>
+<div class="line"><a id="l01015" name="l01015"></a><span class="lineno"> 1015</span>    givenweight += weight;</div>
+<div class="line"><a id="l01016" name="l01016"></a><span class="lineno"> 1016</span>  }</div>
+<div class="line"><a id="l01017" name="l01017"></a><span class="lineno"> 1017</span> </div>
+<div class="line"><a id="l01018" name="l01018"></a><span class="lineno"> 1018</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l01019" name="l01019"></a><span class="lineno"> 1019</span>}</div>
+</div>
+<div class="line"><a id="l01020" name="l01020"></a><span class="lineno"> 1020</span> </div>
+<div class="line"><a id="l01040" name="l01040"></a><span class="lineno"> 1040</span>HWLOC_DECLSPEC <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a></div>
+<div class="line"><a id="l01041" name="l01041"></a><span class="lineno"><a class="line" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033"> 1041</a></span><a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l01042" name="l01042"></a><span class="lineno"> 1042</span> </div>
+<div class="line"><a id="l01056" name="l01056"></a><span class="lineno"> 1056</span>HWLOC_DECLSPEC <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a></div>
+<div class="line"><a id="l01057" name="l01057"></a><span class="lineno"><a class="line" href="a00191.html#ga79212faa07b70dd26588941b17d9fa82"> 1057</a></span><a class="code hl_function" href="a00191.html#ga79212faa07b70dd26588941b17d9fa82">hwloc_topology_get_topology_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l01058" name="l01058"></a><span class="lineno"> 1058</span> </div>
+<div class="line"><a id="l01077" name="l01077"></a><span class="lineno"> 1077</span>HWLOC_DECLSPEC <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a></div>
+<div class="line"><a id="l01078" name="l01078"></a><span class="lineno"><a class="line" href="a00191.html#ga517d5d68ec9f24583d8933aab713be8e"> 1078</a></span><a class="code hl_function" href="a00191.html#ga517d5d68ec9f24583d8933aab713be8e">hwloc_topology_get_allowed_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l01079" name="l01079"></a><span class="lineno"> 1079</span> </div>
+<div class="line"><a id="l01091" name="l01091"></a><span class="lineno"> 1091</span>HWLOC_DECLSPEC <a class="code hl_typedef" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a></div>
+<div class="line"><a id="l01092" name="l01092"></a><span class="lineno"><a class="line" href="a00191.html#ga773fd98949461ef4c1e3170bb0c0418f"> 1092</a></span><a class="code hl_function" href="a00191.html#ga773fd98949461ef4c1e3170bb0c0418f">hwloc_topology_get_complete_nodeset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l01093" name="l01093"></a><span class="lineno"> 1093</span> </div>
+<div class="line"><a id="l01107" name="l01107"></a><span class="lineno"> 1107</span>HWLOC_DECLSPEC <a class="code hl_typedef" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a></div>
+<div class="line"><a id="l01108" name="l01108"></a><span class="lineno"><a class="line" href="a00191.html#ga3fd37303e99ace8b0d0ea03f95f8c514"> 1108</a></span><a class="code hl_function" href="a00191.html#ga3fd37303e99ace8b0d0ea03f95f8c514">hwloc_topology_get_topology_nodeset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l01109" name="l01109"></a><span class="lineno"> 1109</span> </div>
+<div class="line"><a id="l01128" name="l01128"></a><span class="lineno"> 1128</span>HWLOC_DECLSPEC <a class="code hl_typedef" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a></div>
+<div class="line"><a id="l01129" name="l01129"></a><span class="lineno"><a class="line" href="a00191.html#ga21a4d7237a11e76b912ed4524ab78cbd"> 1129</a></span><a class="code hl_function" href="a00191.html#ga21a4d7237a11e76b912ed4524ab78cbd">hwloc_topology_get_allowed_nodeset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l01130" name="l01130"></a><span class="lineno"> 1130</span> </div>
+<div class="line"><a id="l01154" name="l01154"></a><span class="lineno"> 1154</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen01155" data-start="{" data-end="}">
+<div class="line"><a id="l01155" name="l01155"></a><span class="lineno"><a class="line" href="a00192.html#ga185751c1653fedbeb7cc480840f38cde"> 1155</a></span><a class="code hl_function" href="a00192.html#ga185751c1653fedbeb7cc480840f38cde">hwloc_cpuset_to_nodeset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> _cpuset, <a class="code hl_typedef" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a> <a class="code hl_variable" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">nodeset</a>)</div>
+<div class="line"><a id="l01156" name="l01156"></a><span class="lineno"> 1156</span>{</div>
+<div class="line"><a id="l01157" name="l01157"></a><span class="lineno"> 1157</span>        <span class="keywordtype">int</span> <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>);</div>
+<div class="line"><a id="l01158" name="l01158"></a><span class="lineno"> 1158</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj = NULL;</div>
+<div class="line"><a id="l01159" name="l01159"></a><span class="lineno"> 1159</span>        assert(<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> != <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a>);</div>
+<div class="line"><a id="l01160" name="l01160"></a><span class="lineno"> 1160</span>        <a class="code hl_function" href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a>(<a class="code hl_variable" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">nodeset</a>);</div>
+<div class="line"><a id="l01161" name="l01161"></a><span class="lineno"> 1161</span>        <span class="keywordflow">while</span> ((obj = <a class="code hl_function" href="a00186.html#gaba4b6d86eba1169ced4b0e941d2bb5f0">hwloc_get_next_obj_covering_cpuset_by_depth</a>(topology, _cpuset, <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>, obj)) != NULL)</div>
+<div class="line"><a id="l01162" name="l01162"></a><span class="lineno"> 1162</span>                <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga062dbff93baeff3b425a7260c5463646">hwloc_bitmap_set</a>(<a class="code hl_variable" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">nodeset</a>, obj-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>) &lt; 0)</div>
+<div class="line"><a id="l01163" name="l01163"></a><span class="lineno"> 1163</span>                        <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l01164" name="l01164"></a><span class="lineno"> 1164</span>        <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l01165" name="l01165"></a><span class="lineno"> 1165</span>}</div>
+</div>
+<div class="line"><a id="l01166" name="l01166"></a><span class="lineno"> 1166</span> </div>
+<div class="line"><a id="l01181" name="l01181"></a><span class="lineno"> 1181</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen01182" data-start="{" data-end="}">
+<div class="line"><a id="l01182" name="l01182"></a><span class="lineno"><a class="line" href="a00192.html#gad5ee8691e08a3538ea7633344c00456d"> 1182</a></span><a class="code hl_function" href="a00192.html#gad5ee8691e08a3538ea7633344c00456d">hwloc_cpuset_from_nodeset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> _cpuset, <a class="code hl_typedef" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> <a class="code hl_variable" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">nodeset</a>)</div>
+<div class="line"><a id="l01183" name="l01183"></a><span class="lineno"> 1183</span>{</div>
+<div class="line"><a id="l01184" name="l01184"></a><span class="lineno"> 1184</span>        <span class="keywordtype">int</span> <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>);</div>
+<div class="line"><a id="l01185" name="l01185"></a><span class="lineno"> 1185</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj = NULL;</div>
+<div class="line"><a id="l01186" name="l01186"></a><span class="lineno"> 1186</span>        assert(<a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a> != <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a>);</div>
+<div class="line"><a id="l01187" name="l01187"></a><span class="lineno"> 1187</span>        <a class="code hl_function" href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a>(_cpuset);</div>
+<div class="line"><a id="l01188" name="l01188"></a><span class="lineno"> 1188</span>        <span class="keywordflow">while</span> ((obj = <a class="code hl_function" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a>(topology, <a class="code hl_variable" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a>, obj)) != NULL) {</div>
+<div class="line"><a id="l01189" name="l01189"></a><span class="lineno"> 1189</span>                <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga11340dd487f110bb84f0a6e4ae90bd06">hwloc_bitmap_isset</a>(<a class="code hl_variable" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">nodeset</a>, obj-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>))</div>
+<div class="line"><a id="l01190" name="l01190"></a><span class="lineno"> 1190</span>                        <span class="comment">/* no need to check obj-&gt;cpuset because objects in levels always have a cpuset */</span></div>
+<div class="line"><a id="l01191" name="l01191"></a><span class="lineno"> 1191</span>                        <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">hwloc_bitmap_or</a>(_cpuset, _cpuset, obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>) &lt; 0)</div>
+<div class="line"><a id="l01192" name="l01192"></a><span class="lineno"> 1192</span>                                <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l01193" name="l01193"></a><span class="lineno"> 1193</span>        }</div>
+<div class="line"><a id="l01194" name="l01194"></a><span class="lineno"> 1194</span>        <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l01195" name="l01195"></a><span class="lineno"> 1195</span>}</div>
+</div>
+<div class="line"><a id="l01196" name="l01196"></a><span class="lineno"> 1196</span> </div>
+<div class="line"><a id="l01220" name="l01220"></a><span class="lineno"> 1220</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen01221" data-start="{" data-end="}">
+<div class="line"><a id="l01221" name="l01221"></a><span class="lineno"><a class="line" href="a00193.html#gaf139bb61375178e90cc3f1835b452ab6"> 1221</a></span><a class="code hl_function" href="a00193.html#gaf139bb61375178e90cc3f1835b452ab6">hwloc_get_non_io_ancestor_obj</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l01222" name="l01222"></a><span class="lineno"> 1222</span>                              <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> ioobj)</div>
+<div class="line"><a id="l01223" name="l01223"></a><span class="lineno"> 1223</span>{</div>
+<div class="line"><a id="l01224" name="l01224"></a><span class="lineno"> 1224</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj = ioobj;</div>
+<div class="line"><a id="l01225" name="l01225"></a><span class="lineno"> 1225</span>  <span class="keywordflow">while</span> (obj &amp;&amp; !obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>) {</div>
+<div class="line"><a id="l01226" name="l01226"></a><span class="lineno"> 1226</span>    obj = obj-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l01227" name="l01227"></a><span class="lineno"> 1227</span>  }</div>
+<div class="line"><a id="l01228" name="l01228"></a><span class="lineno"> 1228</span>  <span class="keywordflow">return</span> obj;</div>
+<div class="line"><a id="l01229" name="l01229"></a><span class="lineno"> 1229</span>}</div>
+</div>
+<div class="line"><a id="l01230" name="l01230"></a><span class="lineno"> 1230</span> </div>
+<div class="line"><a id="l01237" name="l01237"></a><span class="lineno"> 1237</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen01238" data-start="{" data-end="}">
+<div class="line"><a id="l01238" name="l01238"></a><span class="lineno"><a class="line" href="a00193.html#ga66470dabce9db19a57c5940a909d0baa"> 1238</a></span><a class="code hl_function" href="a00193.html#ga66470dabce9db19a57c5940a909d0baa">hwloc_get_next_pcidev</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> prev)</div>
+<div class="line"><a id="l01239" name="l01239"></a><span class="lineno"> 1239</span>{</div>
+<div class="line"><a id="l01240" name="l01240"></a><span class="lineno"> 1240</span>  <span class="keywordflow">return</span> <a class="code hl_function" href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735">hwloc_get_next_obj_by_type</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a>, prev);</div>
+<div class="line"><a id="l01241" name="l01241"></a><span class="lineno"> 1241</span>}</div>
+</div>
+<div class="line"><a id="l01242" name="l01242"></a><span class="lineno"> 1242</span> </div>
+<div class="line"><a id="l01248" name="l01248"></a><span class="lineno"> 1248</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen01249" data-start="{" data-end="}">
+<div class="line"><a id="l01249" name="l01249"></a><span class="lineno"><a class="line" href="a00193.html#gacdbaf0db98872e224b7883a84bfb0455"> 1249</a></span><a class="code hl_function" href="a00193.html#gacdbaf0db98872e224b7883a84bfb0455">hwloc_get_pcidev_by_busid</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l01250" name="l01250"></a><span class="lineno"> 1250</span>                          <span class="keywordtype">unsigned</span> domain, <span class="keywordtype">unsigned</span> bus, <span class="keywordtype">unsigned</span> dev, <span class="keywordtype">unsigned</span> func)</div>
+<div class="line"><a id="l01251" name="l01251"></a><span class="lineno"> 1251</span>{</div>
+<div class="line"><a id="l01252" name="l01252"></a><span class="lineno"> 1252</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj = NULL;</div>
+<div class="line"><a id="l01253" name="l01253"></a><span class="lineno"> 1253</span>  <span class="keywordflow">while</span> ((obj = <a class="code hl_function" href="a00193.html#ga66470dabce9db19a57c5940a909d0baa">hwloc_get_next_pcidev</a>(topology, obj)) != NULL) {</div>
+<div class="line"><a id="l01254" name="l01254"></a><span class="lineno"> 1254</span>    <span class="keywordflow">if</span> (obj-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">domain</a> == domain</div>
+<div class="line"><a id="l01255" name="l01255"></a><span class="lineno"> 1255</span>        &amp;&amp; obj-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">bus</a> == bus</div>
+<div class="line"><a id="l01256" name="l01256"></a><span class="lineno"> 1256</span>        &amp;&amp; obj-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">dev</a> == dev</div>
+<div class="line"><a id="l01257" name="l01257"></a><span class="lineno"> 1257</span>        &amp;&amp; obj-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">func</a> == func)</div>
+<div class="line"><a id="l01258" name="l01258"></a><span class="lineno"> 1258</span>      <span class="keywordflow">return</span> obj;</div>
+<div class="line"><a id="l01259" name="l01259"></a><span class="lineno"> 1259</span>  }</div>
+<div class="line"><a id="l01260" name="l01260"></a><span class="lineno"> 1260</span>  <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l01261" name="l01261"></a><span class="lineno"> 1261</span>}</div>
+</div>
+<div class="line"><a id="l01262" name="l01262"></a><span class="lineno"> 1262</span> </div>
+<div class="line"><a id="l01268" name="l01268"></a><span class="lineno"> 1268</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen01269" data-start="{" data-end="}">
+<div class="line"><a id="l01269" name="l01269"></a><span class="lineno"><a class="line" href="a00193.html#ga23a978469353134b3104b846fe2efceb"> 1269</a></span><a class="code hl_function" href="a00193.html#ga23a978469353134b3104b846fe2efceb">hwloc_get_pcidev_by_busidstring</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">const</span> <span class="keywordtype">char</span> *busid)</div>
+<div class="line"><a id="l01270" name="l01270"></a><span class="lineno"> 1270</span>{</div>
+<div class="line"><a id="l01271" name="l01271"></a><span class="lineno"> 1271</span>  <span class="keywordtype">unsigned</span> domain = 0; <span class="comment">/* default */</span></div>
+<div class="line"><a id="l01272" name="l01272"></a><span class="lineno"> 1272</span>  <span class="keywordtype">unsigned</span> bus, dev, func;</div>
+<div class="line"><a id="l01273" name="l01273"></a><span class="lineno"> 1273</span> </div>
+<div class="line"><a id="l01274" name="l01274"></a><span class="lineno"> 1274</span>  <span class="keywordflow">if</span> (sscanf(busid, <span class="stringliteral">&quot;%x:%x.%x&quot;</span>, &amp;bus, &amp;dev, &amp;func) != 3</div>
+<div class="line"><a id="l01275" name="l01275"></a><span class="lineno"> 1275</span>      &amp;&amp; sscanf(busid, <span class="stringliteral">&quot;%x:%x:%x.%x&quot;</span>, &amp;domain, &amp;bus, &amp;dev, &amp;func) != 4) {</div>
+<div class="line"><a id="l01276" name="l01276"></a><span class="lineno"> 1276</span>    errno = EINVAL;</div>
+<div class="line"><a id="l01277" name="l01277"></a><span class="lineno"> 1277</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l01278" name="l01278"></a><span class="lineno"> 1278</span>  }</div>
+<div class="line"><a id="l01279" name="l01279"></a><span class="lineno"> 1279</span> </div>
+<div class="line"><a id="l01280" name="l01280"></a><span class="lineno"> 1280</span>  <span class="keywordflow">return</span> <a class="code hl_function" href="a00193.html#gacdbaf0db98872e224b7883a84bfb0455">hwloc_get_pcidev_by_busid</a>(topology, domain, bus, dev, func);</div>
+<div class="line"><a id="l01281" name="l01281"></a><span class="lineno"> 1281</span>}</div>
+</div>
+<div class="line"><a id="l01282" name="l01282"></a><span class="lineno"> 1282</span> </div>
+<div class="line"><a id="l01289" name="l01289"></a><span class="lineno"> 1289</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen01290" data-start="{" data-end="}">
+<div class="line"><a id="l01290" name="l01290"></a><span class="lineno"><a class="line" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145"> 1290</a></span><a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> prev)</div>
+<div class="line"><a id="l01291" name="l01291"></a><span class="lineno"> 1291</span>{</div>
+<div class="line"><a id="l01292" name="l01292"></a><span class="lineno"> 1292</span>  <span class="keywordflow">return</span> <a class="code hl_function" href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735">hwloc_get_next_obj_by_type</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075">HWLOC_OBJ_OS_DEVICE</a>, prev);</div>
+<div class="line"><a id="l01293" name="l01293"></a><span class="lineno"> 1293</span>}</div>
+</div>
+<div class="line"><a id="l01294" name="l01294"></a><span class="lineno"> 1294</span> </div>
+<div class="line"><a id="l01301" name="l01301"></a><span class="lineno"> 1301</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen01302" data-start="{" data-end="}">
+<div class="line"><a id="l01302" name="l01302"></a><span class="lineno"><a class="line" href="a00193.html#ga9dba22a3f4f701f2a46780ba9a0bbbe7"> 1302</a></span><a class="code hl_function" href="a00193.html#ga9dba22a3f4f701f2a46780ba9a0bbbe7">hwloc_get_next_bridge</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> prev)</div>
+<div class="line"><a id="l01303" name="l01303"></a><span class="lineno"> 1303</span>{</div>
+<div class="line"><a id="l01304" name="l01304"></a><span class="lineno"> 1304</span>  <span class="keywordflow">return</span> <a class="code hl_function" href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735">hwloc_get_next_obj_by_type</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0">HWLOC_OBJ_BRIDGE</a>, prev);</div>
+<div class="line"><a id="l01305" name="l01305"></a><span class="lineno"> 1305</span>}</div>
+</div>
+<div class="line"><a id="l01306" name="l01306"></a><span class="lineno"> 1306</span> </div>
+<div class="line"><a id="l01307" name="l01307"></a><span class="lineno"> 1307</span><span class="comment">/* \brief Checks whether a given bridge covers a given PCI bus.</span></div>
+<div class="line"><a id="l01308" name="l01308"></a><span class="lineno"> 1308</span><span class="comment"> *</span></div>
+<div class="line"><a id="l01309" name="l01309"></a><span class="lineno"> 1309</span><span class="comment"> * \return 1 if it covers, 0 if not.</span></div>
+<div class="line"><a id="l01310" name="l01310"></a><span class="lineno"> 1310</span><span class="comment"> */</span></div>
+<div class="line"><a id="l01311" name="l01311"></a><span class="lineno"> 1311</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen01312" data-start="{" data-end="}">
+<div class="line"><a id="l01312" name="l01312"></a><span class="lineno"><a class="line" href="a00193.html#ga0d92a9462a3d317f29ecb4442a307fb1"> 1312</a></span><a class="code hl_function" href="a00193.html#ga0d92a9462a3d317f29ecb4442a307fb1">hwloc_bridge_covers_pcibus</a>(<a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> bridge,</div>
+<div class="line"><a id="l01313" name="l01313"></a><span class="lineno"> 1313</span>                           <span class="keywordtype">unsigned</span> domain, <span class="keywordtype">unsigned</span> bus)</div>
+<div class="line"><a id="l01314" name="l01314"></a><span class="lineno"> 1314</span>{</div>
+<div class="line"><a id="l01315" name="l01315"></a><span class="lineno"> 1315</span>  <span class="keywordflow">return</span> bridge-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a> == <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0">HWLOC_OBJ_BRIDGE</a></div>
+<div class="line"><a id="l01316" name="l01316"></a><span class="lineno"> 1316</span>    &amp;&amp; bridge-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a207e6359497b7116d6f4baa9e8bbeb43">bridge</a>.<a class="code hl_variable" href="a00257.html#ac6a169b672d0e9f75756fd5665828b93">downstream_type</a> == <a class="code hl_enumvalue" href="a00173.html#gga48a4803c72574191d7ead1c62aaf9860a8f3b4cecf3dab6073d74696d10863c60">HWLOC_OBJ_BRIDGE_PCI</a></div>
+<div class="line"><a id="l01317" name="l01317"></a><span class="lineno"> 1317</span>    &amp;&amp; bridge-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a207e6359497b7116d6f4baa9e8bbeb43">bridge</a>.<a class="code hl_variable" href="a00257.html#abe1e38eb5ac8dc59829c8dc045f0d747">downstream</a>.<a class="code hl_variable" href="a00257.html#ab5c564e7c95b747dae9eb84ec0a2c31e">pci</a>.<a class="code hl_variable" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">domain</a> == domain</div>
+<div class="line"><a id="l01318" name="l01318"></a><span class="lineno"> 1318</span>    &amp;&amp; bridge-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a207e6359497b7116d6f4baa9e8bbeb43">bridge</a>.<a class="code hl_variable" href="a00257.html#abe1e38eb5ac8dc59829c8dc045f0d747">downstream</a>.<a class="code hl_variable" href="a00257.html#ab5c564e7c95b747dae9eb84ec0a2c31e">pci</a>.secondary_bus &lt;= bus</div>
+<div class="line"><a id="l01319" name="l01319"></a><span class="lineno"> 1319</span>    &amp;&amp; bridge-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a207e6359497b7116d6f4baa9e8bbeb43">bridge</a>.<a class="code hl_variable" href="a00257.html#abe1e38eb5ac8dc59829c8dc045f0d747">downstream</a>.<a class="code hl_variable" href="a00257.html#ab5c564e7c95b747dae9eb84ec0a2c31e">pci</a>.subordinate_bus &gt;= bus;</div>
+<div class="line"><a id="l01320" name="l01320"></a><span class="lineno"> 1320</span>}</div>
+</div>
+<div class="line"><a id="l01321" name="l01321"></a><span class="lineno"> 1321</span> </div>
+<div class="line"><a id="l01326" name="l01326"></a><span class="lineno"> 1326</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l01327" name="l01327"></a><span class="lineno"> 1327</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l01328" name="l01328"></a><span class="lineno"> 1328</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l01329" name="l01329"></a><span class="lineno"> 1329</span> </div>
+<div class="line"><a id="l01330" name="l01330"></a><span class="lineno"> 1330</span> </div>
+<div class="line"><a id="l01331" name="l01331"></a><span class="lineno"> 1331</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_HELPER_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga1f784433e9b606261f62d1134f6a3b25"><div class="ttname"><a href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a></div><div class="ttdeci">hwloc_const_bitmap_t hwloc_const_cpuset_t</div><div class="ttdoc">A non-modifiable hwloc_cpuset_t.</div><div class="ttdef"><b>Definition</b> hwloc.h:163</div></div>
+<div class="ttc" id="aa00172_html_ga2f5276235841ad66a79bedad16a5a10c"><div class="ttname"><a href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a></div><div class="ttdeci">hwloc_const_bitmap_t hwloc_const_nodeset_t</div><div class="ttdoc">A non-modifiable hwloc_nodeset_t.</div><div class="ttdef"><b>Definition</b> hwloc.h:181</div></div>
+<div class="ttc" id="aa00172_html_ga37e35730fa7e775b5bb0afe893d6d508"><div class="ttname"><a href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_nodeset_t</div><div class="ttdoc">A node set is a bitmap whose bits are set according to NUMA memory node physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:178</div></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00173_html_ga552ec74296a024237f474acec98694c0"><div class="ttname"><a href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a></div><div class="ttdeci">enum hwloc_obj_cache_type_e hwloc_obj_cache_type_t</div><div class="ttdoc">Cache type.</div></div>
+<div class="ttc" id="aa00173_html_gacd37bb612667dc437d66bfb175a8dc55"><div class="ttname"><a href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a></div><div class="ttdeci">hwloc_obj_type_t</div><div class="ttdoc">Type of topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:197</div></div>
+<div class="ttc" id="aa00173_html_gga48a4803c72574191d7ead1c62aaf9860a8f3b4cecf3dab6073d74696d10863c60"><div class="ttname"><a href="a00173.html#gga48a4803c72574191d7ead1c62aaf9860a8f3b4cecf3dab6073d74696d10863c60">HWLOC_OBJ_BRIDGE_PCI</a></div><div class="ttdeci">@ HWLOC_OBJ_BRIDGE_PCI</div><div class="ttdoc">PCI-side of a bridge.</div><div class="ttdef"><b>Definition</b> hwloc.h:367</div></div>
+<div class="ttc" id="aa00173_html_gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a"><div class="ttname"><a href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a">HWLOC_OBJ_CACHE_UNIFIED</a></div><div class="ttdeci">@ HWLOC_OBJ_CACHE_UNIFIED</div><div class="ttdoc">Unified cache.</div><div class="ttdef"><b>Definition</b> hwloc.h:359</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d">HWLOC_OBJ_MISC</a></div><div class="ttdeci">@ HWLOC_OBJ_MISC</div><div class="ttdoc">Miscellaneous objects (filtered out by default). Objects without particular meaning,...</div><div class="ttdef"><b>Definition</b> hwloc.h:316</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075">HWLOC_OBJ_OS_DEVICE</a></div><div class="ttdeci">@ HWLOC_OBJ_OS_DEVICE</div><div class="ttdoc">Operating system device (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:305</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div><div class="ttdeci">@ HWLOC_OBJ_PCI_DEVICE</div><div class="ttdoc">PCI device (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:295</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0">HWLOC_OBJ_BRIDGE</a></div><div class="ttdeci">@ HWLOC_OBJ_BRIDGE</div><div class="ttdoc">Bridge (filtered out by default). Any bridge (or PCI switch) that connects the host or an I/O bus,...</div><div class="ttdef"><b>Definition</b> hwloc.h:283</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a></div><div class="ttdeci">@ HWLOC_OBJ_NUMANODE</div><div class="ttdoc">NUMA node. An object that contains memory that is directly and byte-accessible to the host processors...</div><div class="ttdef"><b>Definition</b> hwloc.h:257</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661">HWLOC_OBJ_PU</a></div><div class="ttdeci">@ HWLOC_OBJ_PU</div><div class="ttdoc">Processing Unit, or (Logical) Processor. An execution unit (may share a core with some other logical ...</div><div class="ttdef"><b>Definition</b> hwloc.h:222</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00176_html_ga2d4b12fc187dfc53b35f2fa21d21044d"><div class="ttname"><a href="a00176.html#ga2d4b12fc187dfc53b35f2fa21d21044d">hwloc_get_root_obj</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_root_obj(hwloc_topology_t topology)</div><div class="ttdoc">Returns the top-object of the topology-tree.</div></div>
+<div class="ttc" id="aa00176_html_ga391f6b2613f0065673eaa4069b93d4e0"><div class="ttname"><a href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0">hwloc_get_obj_by_depth</a></div><div class="ttdeci">hwloc_obj_t hwloc_get_obj_by_depth(hwloc_topology_t topology, int depth, unsigned idx)</div><div class="ttdoc">Returns the topology object at logical index idx from depth depth.</div></div>
+<div class="ttc" id="aa00176_html_ga6f414dd80a2b943967a0ac92da3181a2"><div class="ttname"><a href="a00176.html#ga6f414dd80a2b943967a0ac92da3181a2">hwloc_get_obj_by_type</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_obj_by_type(hwloc_topology_t topology, hwloc_obj_type_t type, unsigned idx)</div><div class="ttdoc">Returns the topology object at logical index idx with type type.</div></div>
+<div class="ttc" id="aa00176_html_ga759e88eaf5a230ad283e9d4c42486735"><div class="ttname"><a href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735">hwloc_get_next_obj_by_type</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_obj_by_type(hwloc_topology_t topology, hwloc_obj_type_t type, hwloc_obj_t prev)</div><div class="ttdoc">Returns the next object of type type.</div></div>
+<div class="ttc" id="aa00176_html_ga8bec782e21be313750da70cf7428b374"><div class="ttname"><a href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a></div><div class="ttdeci">int hwloc_get_type_depth(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Returns the depth of objects of type type.</div></div>
+<div class="ttc" id="aa00176_html_gac140a9b939d9fa0b30c4a910efcb0656"><div class="ttname"><a href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_obj_by_depth(hwloc_topology_t topology, int depth, hwloc_obj_t prev)</div><div class="ttdoc">Returns the next object at depth depth.</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_UNKNOWN</div><div class="ttdoc">No object of given type exists in the topology.</div><div class="ttdef"><b>Definition</b> hwloc.h:879</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">HWLOC_TYPE_DEPTH_MULTIPLE</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_MULTIPLE</div><div class="ttdoc">Objects of given type exist at different depth in the topology (only for Groups).</div><div class="ttdef"><b>Definition</b> hwloc.h:880</div></div>
+<div class="ttc" id="aa00184_html_ga1d074390c8a3dc3088d84f73fb73f966"><div class="ttname"><a href="a00184.html#ga1d074390c8a3dc3088d84f73fb73f966">hwloc_obj_type_is_memory</a></div><div class="ttdeci">int hwloc_obj_type_is_memory(hwloc_obj_type_t type)</div><div class="ttdoc">Check whether an object type is Memory.</div></div>
+<div class="ttc" id="aa00184_html_ga2ed589bea28711e80b92066510a5607d"><div class="ttname"><a href="a00184.html#ga2ed589bea28711e80b92066510a5607d">hwloc_obj_type_is_cache</a></div><div class="ttdeci">int hwloc_obj_type_is_cache(hwloc_obj_type_t type)</div><div class="ttdoc">Check whether an object type is a CPU Cache (Data, Unified or Instruction).</div></div>
+<div class="ttc" id="aa00184_html_ga395e48cd221d107e5891689624e1aec4"><div class="ttname"><a href="a00184.html#ga395e48cd221d107e5891689624e1aec4">hwloc_obj_type_is_dcache</a></div><div class="ttdeci">int hwloc_obj_type_is_dcache(hwloc_obj_type_t type)</div><div class="ttdoc">Check whether an object type is a CPU Data or Unified Cache.</div></div>
+<div class="ttc" id="aa00184_html_ga52ef38431eba383b048b98c669b59a16"><div class="ttname"><a href="a00184.html#ga52ef38431eba383b048b98c669b59a16">hwloc_obj_type_is_normal</a></div><div class="ttdeci">int hwloc_obj_type_is_normal(hwloc_obj_type_t type)</div><div class="ttdoc">Check whether an object type is Normal.</div></div>
+<div class="ttc" id="aa00184_html_ga8abcee67b9b074332c1866405a3648a9"><div class="ttname"><a href="a00184.html#ga8abcee67b9b074332c1866405a3648a9">hwloc_obj_type_is_icache</a></div><div class="ttdeci">int hwloc_obj_type_is_icache(hwloc_obj_type_t type)</div><div class="ttdoc">Check whether an object type is a CPU Instruction Cache,.</div></div>
+<div class="ttc" id="aa00184_html_gac8a954ed37a4376097234c828068cbef"><div class="ttname"><a href="a00184.html#gac8a954ed37a4376097234c828068cbef">hwloc_obj_type_is_io</a></div><div class="ttdeci">int hwloc_obj_type_is_io(hwloc_obj_type_t type)</div><div class="ttdoc">Check whether an object type is I/O.</div></div>
+<div class="ttc" id="aa00185_html_ga133c40415de008518608f8bff52a5ab9"><div class="ttname"><a href="a00185.html#ga133c40415de008518608f8bff52a5ab9">hwloc_get_nbobjs_inside_cpuset_by_type</a></div><div class="ttdeci">static int hwloc_get_nbobjs_inside_cpuset_by_type(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_type_t type)</div><div class="ttdoc">Return the number of objects of type type included in CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:315</div></div>
+<div class="ttc" id="aa00185_html_ga2edf924e5a0cca9cb22f65cc77c6ddb5"><div class="ttname"><a href="a00185.html#ga2edf924e5a0cca9cb22f65cc77c6ddb5">hwloc_get_obj_inside_cpuset_by_type</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_obj_inside_cpuset_by_type(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_type_t type, unsigned idx)</div><div class="ttdoc">Return the idx -th object of type type included in CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:259</div></div>
+<div class="ttc" id="aa00185_html_ga34ca563fa3a6a4e05268f36a87668511"><div class="ttname"><a href="a00185.html#ga34ca563fa3a6a4e05268f36a87668511">hwloc_get_largest_objs_inside_cpuset</a></div><div class="ttdeci">int hwloc_get_largest_objs_inside_cpuset(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_t *restrict objs, int max)</div><div class="ttdoc">Get the set of largest objects covering exactly a given cpuset set.</div></div>
+<div class="ttc" id="aa00185_html_ga4c3a20d61e9beb06c667b21688c772c5"><div class="ttname"><a href="a00185.html#ga4c3a20d61e9beb06c667b21688c772c5">hwloc_get_obj_index_inside_cpuset</a></div><div class="ttdeci">static int hwloc_get_obj_index_inside_cpuset(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_t obj)</div><div class="ttdoc">Return the logical index among the objects included in CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:346</div></div>
+<div class="ttc" id="aa00185_html_ga547325a4193dbc215d07c23097519d79"><div class="ttname"><a href="a00185.html#ga547325a4193dbc215d07c23097519d79">hwloc_get_first_largest_obj_inside_cpuset</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_first_largest_obj_inside_cpuset(hwloc_topology_t topology, hwloc_const_cpuset_t set)</div><div class="ttdoc">Get the first largest object included in the given cpuset set.</div><div class="ttdef"><b>Definition</b> helper.h:123</div></div>
+<div class="ttc" id="aa00185_html_ga63e3784e7c60fbae5073428cb98ac787"><div class="ttname"><a href="a00185.html#ga63e3784e7c60fbae5073428cb98ac787">hwloc_get_next_obj_inside_cpuset_by_depth</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_obj_inside_cpuset_by_depth(hwloc_topology_t topology, hwloc_const_cpuset_t set, int depth, hwloc_obj_t prev)</div><div class="ttdoc">Return the next object at depth depth included in CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:170</div></div>
+<div class="ttc" id="aa00185_html_gaa43c64512ddb33fd181990c4261cec7d"><div class="ttname"><a href="a00185.html#gaa43c64512ddb33fd181990c4261cec7d">hwloc_get_nbobjs_inside_cpuset_by_depth</a></div><div class="ttdeci">static unsigned hwloc_get_nbobjs_inside_cpuset_by_depth(hwloc_topology_t topology, hwloc_const_cpuset_t set, int depth)</div><div class="ttdoc">Return the number of objects at depth depth included in CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:283</div></div>
+<div class="ttc" id="aa00185_html_gaec86f1f88832836e3f9338e246ea5862"><div class="ttname"><a href="a00185.html#gaec86f1f88832836e3f9338e246ea5862">hwloc_get_obj_inside_cpuset_by_depth</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_obj_inside_cpuset_by_depth(hwloc_topology_t topology, hwloc_const_cpuset_t set, int depth, unsigned idx)</div><div class="ttdoc">Return the (logically) idx -th object at depth depth included in CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:223</div></div>
+<div class="ttc" id="aa00185_html_gafe859176cf9233f215fea0e87cef47e7"><div class="ttname"><a href="a00185.html#gafe859176cf9233f215fea0e87cef47e7">hwloc_get_next_obj_inside_cpuset_by_type</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_obj_inside_cpuset_by_type(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_type_t type, hwloc_obj_t prev)</div><div class="ttdoc">Return the next object of type type included in CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:200</div></div>
+<div class="ttc" id="aa00186_html_ga0e66aa2dc6b2527cfd10723af646c9d7"><div class="ttname"><a href="a00186.html#ga0e66aa2dc6b2527cfd10723af646c9d7">hwloc_get_child_covering_cpuset</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_child_covering_cpuset(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_t parent)</div><div class="ttdoc">Get the child covering at least CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:378</div></div>
+<div class="ttc" id="aa00186_html_ga41acdcdbb8b95d70ecf6c572a3f67dca"><div class="ttname"><a href="a00186.html#ga41acdcdbb8b95d70ecf6c572a3f67dca">hwloc_get_obj_covering_cpuset</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_obj_covering_cpuset(hwloc_topology_t topology, hwloc_const_cpuset_t set)</div><div class="ttdoc">Get the lowest object covering at least CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:401</div></div>
+<div class="ttc" id="aa00186_html_ga91cfae08b092e7966002e15d1e987213"><div class="ttname"><a href="a00186.html#ga91cfae08b092e7966002e15d1e987213">hwloc_get_next_obj_covering_cpuset_by_type</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_obj_covering_cpuset_by_type(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_type_t type, hwloc_obj_t prev)</div><div class="ttdoc">Iterate through same-type objects covering at least CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:456</div></div>
+<div class="ttc" id="aa00186_html_gaba4b6d86eba1169ced4b0e941d2bb5f0"><div class="ttname"><a href="a00186.html#gaba4b6d86eba1169ced4b0e941d2bb5f0">hwloc_get_next_obj_covering_cpuset_by_depth</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_obj_covering_cpuset_by_depth(hwloc_topology_t topology, hwloc_const_cpuset_t set, int depth, hwloc_obj_t prev)</div><div class="ttdoc">Iterate through same-depth objects covering at least CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:428</div></div>
+<div class="ttc" id="aa00187_html_ga12d8565a3436c565e791ed02a0353621"><div class="ttname"><a href="a00187.html#ga12d8565a3436c565e791ed02a0353621">hwloc_get_next_child</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_child(hwloc_topology_t topology, hwloc_obj_t parent, hwloc_obj_t prev)</div><div class="ttdoc">Return the next child.</div><div class="ttdef"><b>Definition</b> helper.h:580</div></div>
+<div class="ttc" id="aa00187_html_ga408cf74f5bf9ed497911a320c7f8cc56"><div class="ttname"><a href="a00187.html#ga408cf74f5bf9ed497911a320c7f8cc56">hwloc_obj_is_in_subtree</a></div><div class="ttdeci">static int hwloc_obj_is_in_subtree(hwloc_topology_t topology, hwloc_obj_t obj, hwloc_obj_t subtree_root)</div><div class="ttdoc">Returns true if obj is inside the subtree beginning with ancestor object subtree_root.</div><div class="ttdef"><b>Definition</b> helper.h:564</div></div>
+<div class="ttc" id="aa00187_html_ga70f0c7583291da707c15ae4daa850f41"><div class="ttname"><a href="a00187.html#ga70f0c7583291da707c15ae4daa850f41">hwloc_get_ancestor_obj_by_type</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_ancestor_obj_by_type(hwloc_topology_t topology, hwloc_obj_type_t type, hwloc_obj_t obj)</div><div class="ttdoc">Returns the ancestor object of obj with type type.</div><div class="ttdef"><b>Definition</b> helper.h:517</div></div>
+<div class="ttc" id="aa00187_html_ga9f8c93fde236e9642a96957af01a11cb"><div class="ttname"><a href="a00187.html#ga9f8c93fde236e9642a96957af01a11cb">hwloc_get_ancestor_obj_by_depth</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_ancestor_obj_by_depth(hwloc_topology_t topology, int depth, hwloc_obj_t obj)</div><div class="ttdoc">Returns the ancestor object of obj at depth depth.</div><div class="ttdef"><b>Definition</b> helper.h:491</div></div>
+<div class="ttc" id="aa00187_html_gab1fa883021928b5c476911c4102e9be3"><div class="ttname"><a href="a00187.html#gab1fa883021928b5c476911c4102e9be3">hwloc_get_common_ancestor_obj</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_common_ancestor_obj(hwloc_topology_t topology, hwloc_obj_t obj1, hwloc_obj_t obj2)</div><div class="ttdoc">Returns the common parent object to objects obj1 and obj2.</div><div class="ttdef"><b>Definition</b> helper.h:534</div></div>
+<div class="ttc" id="aa00188_html_ga36f48c32837c7a70b424706e213dcd71"><div class="ttname"><a href="a00188.html#ga36f48c32837c7a70b424706e213dcd71">hwloc_get_shared_cache_covering_obj</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_shared_cache_covering_obj(hwloc_topology_t topology, hwloc_obj_t obj)</div><div class="ttdoc">Get the first data (or unified) cache shared between an object and somebody else.</div><div class="ttdef"><b>Definition</b> helper.h:697</div></div>
+<div class="ttc" id="aa00188_html_gac4cd480a5deaa4ada047fdd11ae4c070"><div class="ttname"><a href="a00188.html#gac4cd480a5deaa4ada047fdd11ae4c070">hwloc_get_cache_covering_cpuset</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_cache_covering_cpuset(hwloc_topology_t topology, hwloc_const_cpuset_t set)</div><div class="ttdoc">Get the first data (or unified) cache covering a cpuset set.</div><div class="ttdef"><b>Definition</b> helper.h:678</div></div>
+<div class="ttc" id="aa00188_html_gad108a09ce400222fe45545257d575489"><div class="ttname"><a href="a00188.html#gad108a09ce400222fe45545257d575489">hwloc_get_cache_type_depth</a></div><div class="ttdeci">static int hwloc_get_cache_type_depth(hwloc_topology_t topology, unsigned cachelevel, hwloc_obj_cache_type_t cachetype)</div><div class="ttdoc">Find the depth of cache objects matching cache level and type.</div><div class="ttdef"><b>Definition</b> helper.h:642</div></div>
+<div class="ttc" id="aa00189_html_ga050646458efc8ca1120d9f124c5ad861"><div class="ttname"><a href="a00189.html#ga050646458efc8ca1120d9f124c5ad861">hwloc_bitmap_singlify_per_core</a></div><div class="ttdeci">int hwloc_bitmap_singlify_per_core(hwloc_topology_t topology, hwloc_bitmap_t cpuset, unsigned which)</div><div class="ttdoc">Remove simultaneous multithreading PUs from a CPU set.</div></div>
+<div class="ttc" id="aa00189_html_ga2cd22a34360643f7f5bad09576dec205"><div class="ttname"><a href="a00189.html#ga2cd22a34360643f7f5bad09576dec205">hwloc_get_closest_objs</a></div><div class="ttdeci">unsigned hwloc_get_closest_objs(hwloc_topology_t topology, hwloc_obj_t src, hwloc_obj_t *restrict objs, unsigned max)</div><div class="ttdoc">Do a depth-first traversal of the topology to find and sort.</div></div>
+<div class="ttc" id="aa00189_html_ga751c238a4931db5cc0ca3181b7dd7479"><div class="ttname"><a href="a00189.html#ga751c238a4931db5cc0ca3181b7dd7479">hwloc_get_pu_obj_by_os_index</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_pu_obj_by_os_index(hwloc_topology_t topology, unsigned os_index)</div><div class="ttdoc">Returns the object of type HWLOC_OBJ_PU with os_index.</div><div class="ttdef"><b>Definition</b> helper.h:758</div></div>
+<div class="ttc" id="aa00189_html_ga7a0c1046851f7a88bd52f5a1d4ba0a97"><div class="ttname"><a href="a00189.html#ga7a0c1046851f7a88bd52f5a1d4ba0a97">hwloc_get_obj_below_by_type</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_obj_below_by_type(hwloc_topology_t topology, hwloc_obj_type_t type1, unsigned idx1, hwloc_obj_type_t type2, unsigned idx2)</div><div class="ttdoc">Find an object below another object, both specified by types and indexes.</div><div class="ttdef"><b>Definition</b> helper.h:823</div></div>
+<div class="ttc" id="aa00189_html_gab5df3ad1e8565ea0c2cf06412f6f6233"><div class="ttname"><a href="a00189.html#gab5df3ad1e8565ea0c2cf06412f6f6233">hwloc_get_obj_with_same_locality</a></div><div class="ttdeci">hwloc_obj_t hwloc_get_obj_with_same_locality(hwloc_topology_t topology, hwloc_obj_t src, hwloc_obj_type_t type, const char *subtype, const char *nameprefix, unsigned long flags)</div><div class="ttdoc">Return an object of a different type with same locality.</div></div>
+<div class="ttc" id="aa00189_html_gab89d9ed9edfaa3dd526fb6ee1a1618ea"><div class="ttname"><a href="a00189.html#gab89d9ed9edfaa3dd526fb6ee1a1618ea">hwloc_get_numanode_obj_by_os_index</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_numanode_obj_by_os_index(hwloc_topology_t topology, unsigned os_index)</div><div class="ttdoc">Returns the object of type HWLOC_OBJ_NUMANODE with os_index.</div><div class="ttdef"><b>Definition</b> helper.h:781</div></div>
+<div class="ttc" id="aa00189_html_gacb51295ff3fbd3a96f990f20c6492b1d"><div class="ttname"><a href="a00189.html#gacb51295ff3fbd3a96f990f20c6492b1d">hwloc_get_obj_below_array_by_type</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_obj_below_array_by_type(hwloc_topology_t topology, int nr, hwloc_obj_type_t *typev, unsigned *idxv)</div><div class="ttdoc">Find an object below a chain of objects specified by types and indexes.</div><div class="ttdef"><b>Definition</b> helper.h:857</div></div>
+<div class="ttc" id="aa00190_html_ga7b0c28f797c2ff17fa2f244ebbd55b33"><div class="ttname"><a href="a00190.html#ga7b0c28f797c2ff17fa2f244ebbd55b33">hwloc_distrib</a></div><div class="ttdeci">static int hwloc_distrib(hwloc_topology_t topology, hwloc_obj_t *roots, unsigned n_roots, hwloc_cpuset_t *set, unsigned n, int until, unsigned long flags)</div><div class="ttdoc">Distribute n items over the topology under roots.</div><div class="ttdef"><b>Definition</b> helper.h:960</div></div>
+<div class="ttc" id="aa00190_html_ga8b835295a52b6768a5e6c8abb1f9c54d"><div class="ttname"><a href="a00190.html#ga8b835295a52b6768a5e6c8abb1f9c54d">hwloc_distrib_flags_e</a></div><div class="ttdeci">hwloc_distrib_flags_e</div><div class="ttdoc">Flags to be given to hwloc_distrib().</div><div class="ttdef"><b>Definition</b> helper.h:922</div></div>
+<div class="ttc" id="aa00190_html_gga8b835295a52b6768a5e6c8abb1f9c54da2ca08404bfbebe9ed5f34c3d7635425a"><div class="ttname"><a href="a00190.html#gga8b835295a52b6768a5e6c8abb1f9c54da2ca08404bfbebe9ed5f34c3d7635425a">HWLOC_DISTRIB_FLAG_REVERSE</a></div><div class="ttdeci">@ HWLOC_DISTRIB_FLAG_REVERSE</div><div class="ttdoc">Distrib in reverse order, starting from the last objects.</div><div class="ttdef"><b>Definition</b> helper.h:926</div></div>
+<div class="ttc" id="aa00191_html_ga21a4d7237a11e76b912ed4524ab78cbd"><div class="ttname"><a href="a00191.html#ga21a4d7237a11e76b912ed4524ab78cbd">hwloc_topology_get_allowed_nodeset</a></div><div class="ttdeci">hwloc_const_nodeset_t hwloc_topology_get_allowed_nodeset(hwloc_topology_t topology)</div><div class="ttdoc">Get allowed node set.</div></div>
+<div class="ttc" id="aa00191_html_ga3fd37303e99ace8b0d0ea03f95f8c514"><div class="ttname"><a href="a00191.html#ga3fd37303e99ace8b0d0ea03f95f8c514">hwloc_topology_get_topology_nodeset</a></div><div class="ttdeci">hwloc_const_nodeset_t hwloc_topology_get_topology_nodeset(hwloc_topology_t topology)</div><div class="ttdoc">Get topology node set.</div></div>
+<div class="ttc" id="aa00191_html_ga517d5d68ec9f24583d8933aab713be8e"><div class="ttname"><a href="a00191.html#ga517d5d68ec9f24583d8933aab713be8e">hwloc_topology_get_allowed_cpuset</a></div><div class="ttdeci">hwloc_const_cpuset_t hwloc_topology_get_allowed_cpuset(hwloc_topology_t topology)</div><div class="ttdoc">Get allowed CPU set.</div></div>
+<div class="ttc" id="aa00191_html_ga773fd98949461ef4c1e3170bb0c0418f"><div class="ttname"><a href="a00191.html#ga773fd98949461ef4c1e3170bb0c0418f">hwloc_topology_get_complete_nodeset</a></div><div class="ttdeci">hwloc_const_nodeset_t hwloc_topology_get_complete_nodeset(hwloc_topology_t topology)</div><div class="ttdoc">Get complete node set.</div></div>
+<div class="ttc" id="aa00191_html_ga79212faa07b70dd26588941b17d9fa82"><div class="ttname"><a href="a00191.html#ga79212faa07b70dd26588941b17d9fa82">hwloc_topology_get_topology_cpuset</a></div><div class="ttdeci">hwloc_const_cpuset_t hwloc_topology_get_topology_cpuset(hwloc_topology_t topology)</div><div class="ttdoc">Get topology CPU set.</div></div>
+<div class="ttc" id="aa00191_html_gaee30e03391c1ed7dfd617fb5c7bbb033"><div class="ttname"><a href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a></div><div class="ttdeci">hwloc_const_cpuset_t hwloc_topology_get_complete_cpuset(hwloc_topology_t topology)</div><div class="ttdoc">Get complete CPU set.</div></div>
+<div class="ttc" id="aa00192_html_ga185751c1653fedbeb7cc480840f38cde"><div class="ttname"><a href="a00192.html#ga185751c1653fedbeb7cc480840f38cde">hwloc_cpuset_to_nodeset</a></div><div class="ttdeci">static int hwloc_cpuset_to_nodeset(hwloc_topology_t topology, hwloc_const_cpuset_t _cpuset, hwloc_nodeset_t nodeset)</div><div class="ttdoc">Convert a CPU set into a NUMA node set.</div><div class="ttdef"><b>Definition</b> helper.h:1155</div></div>
+<div class="ttc" id="aa00192_html_gad5ee8691e08a3538ea7633344c00456d"><div class="ttname"><a href="a00192.html#gad5ee8691e08a3538ea7633344c00456d">hwloc_cpuset_from_nodeset</a></div><div class="ttdeci">static int hwloc_cpuset_from_nodeset(hwloc_topology_t topology, hwloc_cpuset_t _cpuset, hwloc_const_nodeset_t nodeset)</div><div class="ttdoc">Convert a NUMA node set into a CPU set.</div><div class="ttdef"><b>Definition</b> helper.h:1182</div></div>
+<div class="ttc" id="aa00193_html_ga0d92a9462a3d317f29ecb4442a307fb1"><div class="ttname"><a href="a00193.html#ga0d92a9462a3d317f29ecb4442a307fb1">hwloc_bridge_covers_pcibus</a></div><div class="ttdeci">static int hwloc_bridge_covers_pcibus(hwloc_obj_t bridge, unsigned domain, unsigned bus)</div><div class="ttdef"><b>Definition</b> helper.h:1312</div></div>
+<div class="ttc" id="aa00193_html_ga23a978469353134b3104b846fe2efceb"><div class="ttname"><a href="a00193.html#ga23a978469353134b3104b846fe2efceb">hwloc_get_pcidev_by_busidstring</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_pcidev_by_busidstring(hwloc_topology_t topology, const char *busid)</div><div class="ttdoc">Find the PCI device object matching the PCI bus id given as a string xxxx:yy:zz.t or yy:zz....</div><div class="ttdef"><b>Definition</b> helper.h:1269</div></div>
+<div class="ttc" id="aa00193_html_ga66470dabce9db19a57c5940a909d0baa"><div class="ttname"><a href="a00193.html#ga66470dabce9db19a57c5940a909d0baa">hwloc_get_next_pcidev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_pcidev(hwloc_topology_t topology, hwloc_obj_t prev)</div><div class="ttdoc">Get the next PCI device in the system.</div><div class="ttdef"><b>Definition</b> helper.h:1238</div></div>
+<div class="ttc" id="aa00193_html_ga8b4584c8949e2c5f1c97ba7fe92b8145"><div class="ttname"><a href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_osdev(hwloc_topology_t topology, hwloc_obj_t prev)</div><div class="ttdoc">Get the next OS device in the system.</div><div class="ttdef"><b>Definition</b> helper.h:1290</div></div>
+<div class="ttc" id="aa00193_html_ga9dba22a3f4f701f2a46780ba9a0bbbe7"><div class="ttname"><a href="a00193.html#ga9dba22a3f4f701f2a46780ba9a0bbbe7">hwloc_get_next_bridge</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_bridge(hwloc_topology_t topology, hwloc_obj_t prev)</div><div class="ttdoc">Get the next bridge in the system.</div><div class="ttdef"><b>Definition</b> helper.h:1302</div></div>
+<div class="ttc" id="aa00193_html_gacdbaf0db98872e224b7883a84bfb0455"><div class="ttname"><a href="a00193.html#gacdbaf0db98872e224b7883a84bfb0455">hwloc_get_pcidev_by_busid</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_pcidev_by_busid(hwloc_topology_t topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)</div><div class="ttdoc">Find the PCI device object matching the PCI bus id given domain, bus device and function PCI bus id.</div><div class="ttdef"><b>Definition</b> helper.h:1249</div></div>
+<div class="ttc" id="aa00193_html_gaf139bb61375178e90cc3f1835b452ab6"><div class="ttname"><a href="a00193.html#gaf139bb61375178e90cc3f1835b452ab6">hwloc_get_non_io_ancestor_obj</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_non_io_ancestor_obj(hwloc_topology_t topology, hwloc_obj_t ioobj)</div><div class="ttdoc">Get the first non-I/O ancestor object.</div><div class="ttdef"><b>Definition</b> helper.h:1221</div></div>
+<div class="ttc" id="aa00194_html_ga0200466842c0e1f5da75e84dde460b10"><div class="ttname"><a href="a00194.html#ga0200466842c0e1f5da75e84dde460b10">hwloc_bitmap_weight</a></div><div class="ttdeci">int hwloc_bitmap_weight(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Compute the &quot;weight&quot; of bitmap bitmap (i.e., number of indexes that are in the bitmap).</div></div>
+<div class="ttc" id="aa00194_html_ga0526e03db81956fb02acc8260b66d6a4"><div class="ttname"><a href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a></div><div class="ttdeci">int hwloc_bitmap_isincluded(hwloc_const_bitmap_t sub_bitmap, hwloc_const_bitmap_t super_bitmap)</div><div class="ttdoc">Test whether bitmap sub_bitmap is part of bitmap super_bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga062dbff93baeff3b425a7260c5463646"><div class="ttname"><a href="a00194.html#ga062dbff93baeff3b425a7260c5463646">hwloc_bitmap_set</a></div><div class="ttdeci">int hwloc_bitmap_set(hwloc_bitmap_t bitmap, unsigned id)</div><div class="ttdoc">Add index id in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga11340dd487f110bb84f0a6e4ae90bd06"><div class="ttname"><a href="a00194.html#ga11340dd487f110bb84f0a6e4ae90bd06">hwloc_bitmap_isset</a></div><div class="ttdeci">int hwloc_bitmap_isset(hwloc_const_bitmap_t bitmap, unsigned id)</div><div class="ttdoc">Test whether index id is part of bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga120b8aefb9ce7ef349929656359b1859"><div class="ttname"><a href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">hwloc_bitmap_or</a></div><div class="ttdeci">int hwloc_bitmap_or(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">Or bitmaps bitmap1 and bitmap2 and store the result in bitmap res.</div></div>
+<div class="ttc" id="aa00194_html_ga32376b1405e57472b73c3aa53bb39663"><div class="ttname"><a href="a00194.html#ga32376b1405e57472b73c3aa53bb39663">hwloc_bitmap_isequal</a></div><div class="ttdeci">int hwloc_bitmap_isequal(hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">Test whether bitmap bitmap1 is equal to bitmap bitmap2.</div></div>
+<div class="ttc" id="aa00194_html_ga5b64be28f5a7176ed8ad0d6a90bdf108"><div class="ttname"><a href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a></div><div class="ttdeci">int hwloc_bitmap_iszero(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Test whether bitmap bitmap is empty.</div></div>
+<div class="ttc" id="aa00194_html_gaa3c2bf4c776d603dcebbb61b0c923d84"><div class="ttname"><a href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a></div><div class="ttdeci">struct hwloc_bitmap_s * hwloc_bitmap_t</div><div class="ttdoc">Set of bits represented as an opaque pointer to an internal bitmap.</div><div class="ttdef"><b>Definition</b> bitmap.h:69</div></div>
+<div class="ttc" id="aa00194_html_gaa97c5217613c8cae9862287170ea2132"><div class="ttname"><a href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a></div><div class="ttdeci">void hwloc_bitmap_zero(hwloc_bitmap_t bitmap)</div><div class="ttdoc">Empty the bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_gae679434c1a5f41d3560a8a7e2c1b0dee"><div class="ttname"><a href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee">hwloc_bitmap_dup</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_bitmap_dup(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.</div></div>
+<div class="ttc" id="aa00194_html_gaefa070f9232857ba5a57297ea9a08ea2"><div class="ttname"><a href="a00194.html#gaefa070f9232857ba5a57297ea9a08ea2">hwloc_bitmap_intersects</a></div><div class="ttdeci">int hwloc_bitmap_intersects(hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">Test whether bitmaps bitmap1 and bitmap2 intersects.</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_a04d05403da37bfe17cd63b7c7dd07b1f"><div class="ttname"><a href="a00229.html#a04d05403da37bfe17cd63b7c7dd07b1f">hwloc_obj::children</a></div><div class="ttdeci">struct hwloc_obj ** children</div><div class="ttdoc">Normal children, children[0 .. arity -1].</div><div class="ttdef"><b>Definition</b> hwloc.h:491</div></div>
+<div class="ttc" id="aa00229_html_a08f0d0e16c619a6e653526cbee4ffea3"><div class="ttname"><a href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">hwloc_obj::nodeset</a></div><div class="ttdeci">hwloc_nodeset_t nodeset</div><div class="ttdoc">NUMA nodes covered by this object or containing this object.</div><div class="ttdef"><b>Definition</b> hwloc.h:575</div></div>
+<div class="ttc" id="aa00229_html_a4876fd165b4fff35521f07ebd85355ed"><div class="ttname"><a href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">hwloc_obj::depth</a></div><div class="ttdeci">int depth</div><div class="ttdoc">Vertical index in the hierarchy.</div><div class="ttdef"><b>Definition</b> hwloc.h:454</div></div>
+<div class="ttc" id="aa00229_html_a57812a313fe9b1a9500489f47c3011cc"><div class="ttname"><a href="a00229.html#a57812a313fe9b1a9500489f47c3011cc">hwloc_obj::misc_first_child</a></div><div class="ttdeci">struct hwloc_obj * misc_first_child</div><div class="ttdoc">First Misc child. Misc objects are listed here (misc_arity and misc_first_child) instead of in the no...</div><div class="ttdef"><b>Definition</b> hwloc.h:540</div></div>
+<div class="ttc" id="aa00229_html_a5d4f97e76723a9ec8d38046f19e00d33"><div class="ttname"><a href="a00229.html#a5d4f97e76723a9ec8d38046f19e00d33">hwloc_obj::subtype</a></div><div class="ttdeci">char * subtype</div><div class="ttdoc">Subtype string to better describe the type field.</div><div class="ttdef"><b>Definition</b> hwloc.h:434</div></div>
+<div class="ttc" id="aa00229_html_a61a7a80a68eaccbaaa28269e678c81a9"><div class="ttname"><a href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">hwloc_obj::os_index</a></div><div class="ttdeci">unsigned os_index</div><div class="ttdoc">OS-provided physical index number. It is not guaranteed unique across the entire machine,...</div><div class="ttdef"><b>Definition</b> hwloc.h:436</div></div>
+<div class="ttc" id="aa00229_html_a67925e0f2c47f50408fbdb9bddd0790f"><div class="ttname"><a href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">hwloc_obj::cpuset</a></div><div class="ttdeci">hwloc_cpuset_t cpuset</div><div class="ttdoc">CPUs covered by this object.</div><div class="ttdef"><b>Definition</b> hwloc.h:547</div></div>
+<div class="ttc" id="aa00229_html_a7f2343ed476fe4942e6fffd4cade1b40"><div class="ttname"><a href="a00229.html#a7f2343ed476fe4942e6fffd4cade1b40">hwloc_obj::next_sibling</a></div><div class="ttdeci">struct hwloc_obj * next_sibling</div><div class="ttdoc">Next object below the same parent (inside the same list of children).</div><div class="ttdef"><b>Definition</b> hwloc.h:483</div></div>
+<div class="ttc" id="aa00229_html_a85a788017457129589318b6c39451acf"><div class="ttname"><a href="a00229.html#a85a788017457129589318b6c39451acf">hwloc_obj::next_cousin</a></div><div class="ttdeci">struct hwloc_obj * next_cousin</div><div class="ttdoc">Next object of same type and depth.</div><div class="ttdef"><b>Definition</b> hwloc.h:477</div></div>
+<div class="ttc" id="aa00229_html_a8d14c88e1ebc4ae67cc69f9e928558b3"><div class="ttname"><a href="a00229.html#a8d14c88e1ebc4ae67cc69f9e928558b3">hwloc_obj::io_first_child</a></div><div class="ttdeci">struct hwloc_obj * io_first_child</div><div class="ttdoc">First I/O child. Bridges, PCI and OS devices are listed here (io_arity and io_first_child) instead of...</div><div class="ttdef"><b>Definition</b> hwloc.h:528</div></div>
+<div class="ttc" id="aa00229_html_aac3f6da35c9b57599909a44ce2b716c1"><div class="ttname"><a href="a00229.html#aac3f6da35c9b57599909a44ce2b716c1">hwloc_obj::arity</a></div><div class="ttdeci">unsigned arity</div><div class="ttdoc">Number of normal children. Memory, Misc and I/O children are not listed here but rather in their dedi...</div><div class="ttdef"><b>Definition</b> hwloc.h:487</div></div>
+<div class="ttc" id="aa00229_html_ac0e8200dba25b90d5954bd4ec61f97d3"><div class="ttname"><a href="a00229.html#ac0e8200dba25b90d5954bd4ec61f97d3">hwloc_obj::memory_first_child</a></div><div class="ttdeci">struct hwloc_obj * memory_first_child</div><div class="ttdoc">First Memory child. NUMA nodes and Memory-side caches are listed here (memory_arity and memory_first_...</div><div class="ttdef"><b>Definition</b> hwloc.h:510</div></div>
+<div class="ttc" id="aa00229_html_ac715989f55ff5a0eb6be2969ee477ec0"><div class="ttname"><a href="a00229.html#ac715989f55ff5a0eb6be2969ee477ec0">hwloc_obj::prev_cousin</a></div><div class="ttdeci">struct hwloc_obj * prev_cousin</div><div class="ttdoc">Previous object of same type and depth.</div><div class="ttdef"><b>Definition</b> hwloc.h:478</div></div>
+<div class="ttc" id="aa00229_html_acc4f0803f244867e68fe0036800be5de"><div class="ttname"><a href="a00229.html#acc4f0803f244867e68fe0036800be5de">hwloc_obj::type</a></div><div class="ttdeci">hwloc_obj_type_t type</div><div class="ttdoc">Type of object.</div><div class="ttdef"><b>Definition</b> hwloc.h:433</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00229_html_adc494f6aed939992be1c55cca5822900"><div class="ttname"><a href="a00229.html#adc494f6aed939992be1c55cca5822900">hwloc_obj::parent</a></div><div class="ttdeci">struct hwloc_obj * parent</div><div class="ttdoc">Parent, NULL if root (Machine object)</div><div class="ttdef"><b>Definition</b> hwloc.h:481</div></div>
+<div class="ttc" id="aa00229_html_af51d08a0a79dba517c06c5afedc8d2dc"><div class="ttname"><a href="a00229.html#af51d08a0a79dba517c06c5afedc8d2dc">hwloc_obj::first_child</a></div><div class="ttdeci">struct hwloc_obj * first_child</div><div class="ttdoc">First normal child.</div><div class="ttdef"><b>Definition</b> hwloc.h:492</div></div>
+<div class="ttc" id="aa00233_html_a0b66da7ab072f7c016f8ed86701f5a7c"><div class="ttname"><a href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">hwloc_obj_attr_u::pcidev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_pcidev_attr_s pcidev</div></div>
+<div class="ttc" id="aa00233_html_a207e6359497b7116d6f4baa9e8bbeb43"><div class="ttname"><a href="a00233.html#a207e6359497b7116d6f4baa9e8bbeb43">hwloc_obj_attr_u::bridge</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_bridge_attr_s bridge</div></div>
+<div class="ttc" id="aa00233_html_a23f553f3252c9d13f2338231cd354ea9"><div class="ttname"><a href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">hwloc_obj_attr_u::cache</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_cache_attr_s cache</div></div>
+<div class="ttc" id="aa00245_html_a5c8f7f39193736c2187ed626940835d5"><div class="ttname"><a href="a00245.html#a5c8f7f39193736c2187ed626940835d5">hwloc_obj_attr_u::hwloc_cache_attr_s::depth</a></div><div class="ttdeci">unsigned depth</div><div class="ttdoc">Depth of cache (e.g., L1, L2, ...etc.)</div><div class="ttdef"><b>Definition</b> hwloc.h:653</div></div>
+<div class="ttc" id="aa00245_html_ad8edc8ded2b7a70d6abbc874801930f4"><div class="ttname"><a href="a00245.html#ad8edc8ded2b7a70d6abbc874801930f4">hwloc_obj_attr_u::hwloc_cache_attr_s::type</a></div><div class="ttdeci">hwloc_obj_cache_type_t type</div><div class="ttdoc">Cache type.</div><div class="ttdef"><b>Definition</b> hwloc.h:657</div></div>
+<div class="ttc" id="aa00253_html_a3d70c84a12f7e93d14c8d47bf4fd9dc5"><div class="ttname"><a href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">hwloc_obj_attr_u::hwloc_pcidev_attr_s::dev</a></div><div class="ttdeci">unsigned char dev</div><div class="ttdoc">Device number (zz in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:677</div></div>
+<div class="ttc" id="aa00253_html_a695f32df53f4ef728670bfcf31b74e0f"><div class="ttname"><a href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">hwloc_obj_attr_u::hwloc_pcidev_attr_s::func</a></div><div class="ttdeci">unsigned char func</div><div class="ttdoc">Function number (t in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:678</div></div>
+<div class="ttc" id="aa00253_html_a8fba44988deb98613c1505a4019a34dc"><div class="ttname"><a href="a00253.html#a8fba44988deb98613c1505a4019a34dc">hwloc_obj_attr_u::hwloc_pcidev_attr_s::domain</a></div><div class="ttdeci">unsigned short domain</div><div class="ttdoc">Domain number (xxxx in the PCI BDF notation xxxx:yy:zz.t). Only 16bits PCI domains are supported by d...</div><div class="ttdef"><b>Definition</b> hwloc.h:670</div></div>
+<div class="ttc" id="aa00253_html_aae99e035e8d1387d7b8768aaa8eceb0a"><div class="ttname"><a href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">hwloc_obj_attr_u::hwloc_pcidev_attr_s::bus</a></div><div class="ttdeci">unsigned char bus</div><div class="ttdoc">Bus number (yy in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:676</div></div>
+<div class="ttc" id="aa00257_html_ab5c564e7c95b747dae9eb84ec0a2c31e"><div class="ttname"><a href="a00257.html#ab5c564e7c95b747dae9eb84ec0a2c31e">hwloc_obj_attr_u::hwloc_bridge_attr_s::pci</a></div><div class="ttdeci">struct hwloc_pcidev_attr_s pci</div><div class="ttdoc">PCI attribute of the upstream part as a PCI device.</div><div class="ttdef"><b>Definition</b> hwloc.h:695</div></div>
+<div class="ttc" id="aa00257_html_abe1e38eb5ac8dc59829c8dc045f0d747"><div class="ttname"><a href="a00257.html#abe1e38eb5ac8dc59829c8dc045f0d747">hwloc_obj_attr_u::hwloc_bridge_attr_s::downstream</a></div><div class="ttdeci">union hwloc_obj_attr_u::hwloc_bridge_attr_s::@3 downstream</div></div>
+<div class="ttc" id="aa00257_html_ac6a169b672d0e9f75756fd5665828b93"><div class="ttname"><a href="a00257.html#ac6a169b672d0e9f75756fd5665828b93">hwloc_obj_attr_u::hwloc_bridge_attr_s::downstream_type</a></div><div class="ttdeci">hwloc_obj_bridge_type_t downstream_type</div><div class="ttdoc">Downstream Bridge type.</div><div class="ttdef"><b>Definition</b> hwloc.h:711</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00110_source.html 2.11.0-1/doc/doxygen-doc/html/a00110_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00110_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00110_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,295 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): bitmap.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">bitmap.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2009 CNRS</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2009-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * Copyright © 2009-2012 Université Bordeaux</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span> </div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#ifndef HWLOC_BITMAP_H</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#define HWLOC_BITMAP_H</span></div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#include &quot;hwloc/autogen/config.h&quot;</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;assert.h&gt;</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span> </div>
+<div class="line"><a id="l00069" name="l00069"></a><span class="lineno"><a class="line" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">   69</a></span><span class="keyword">typedef</span> <span class="keyword">struct </span>hwloc_bitmap_s * <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>;</div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno"><a class="line" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">   71</a></span><span class="keyword">typedef</span> <span class="keyword">const</span> <span class="keyword">struct </span>hwloc_bitmap_s * <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>;</div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span> </div>
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span> </div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span><span class="comment"> * Bitmap allocation, freeing and copying.</span></div>
+<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span> </div>
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno"><a class="line" href="a00194.html#gadece3d1eb5199fc2fb99bc7dcf1ccc05">   85</a></span>HWLOC_DECLSPEC <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> <a class="code hl_function" href="a00194.html#gadece3d1eb5199fc2fb99bc7dcf1ccc05">hwloc_bitmap_alloc</a>(<span class="keywordtype">void</span>) __hwloc_attribute_malloc;</div>
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span> </div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno"><a class="line" href="a00194.html#ga02853b4a224970587b9d7a0e20d857c0">   94</a></span>HWLOC_DECLSPEC <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> <a class="code hl_function" href="a00194.html#ga02853b4a224970587b9d7a0e20d857c0">hwloc_bitmap_alloc_full</a>(<span class="keywordtype">void</span>) __hwloc_attribute_malloc;</div>
+<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span> </div>
+<div class="line"><a id="l00100" name="l00100"></a><span class="lineno"><a class="line" href="a00194.html#ga156130d85b3a0674d6e0e6770fe68fbe">  100</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> <a class="code hl_function" href="a00194.html#ga156130d85b3a0674d6e0e6770fe68fbe">hwloc_bitmap_free</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap);</div>
+<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span> </div>
+<div class="line"><a id="l00106" name="l00106"></a><span class="lineno"><a class="line" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee">  106</a></span>HWLOC_DECLSPEC <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> <a class="code hl_function" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee">hwloc_bitmap_dup</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap) __hwloc_attribute_malloc;</div>
+<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span> </div>
+<div class="line"><a id="l00109" name="l00109"></a><span class="lineno"><a class="line" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">  109</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> dst, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> src);</div>
+<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span> </div>
+<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span> </div>
+<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span><span class="comment"> * Bitmap/String Conversion</span></div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span> </div>
+<div class="line"><a id="l00125" name="l00125"></a><span class="lineno"><a class="line" href="a00194.html#ga9511644657030a021dce9941e3cda583">  125</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga9511644657030a021dce9941e3cda583">hwloc_bitmap_snprintf</a>(<span class="keywordtype">char</span> * __hwloc_restrict buf, <span class="keywordtype">size_t</span> buflen, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap);</div>
+<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span> </div>
+<div class="line"><a id="l00131" name="l00131"></a><span class="lineno"><a class="line" href="a00194.html#ga0fece972134fdecf2da9bc7a11dd827e">  131</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga0fece972134fdecf2da9bc7a11dd827e">hwloc_bitmap_asprintf</a>(<span class="keywordtype">char</span> ** strp, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap);</div>
+<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span> </div>
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno"><a class="line" href="a00194.html#ga064a85c643a364b60acbfa0f3663fc18">  137</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga064a85c643a364b60acbfa0f3663fc18">hwloc_bitmap_sscanf</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keyword">const</span> <span class="keywordtype">char</span> * __hwloc_restrict <span class="keywordtype">string</span>);</div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span> </div>
+<div class="line"><a id="l00152" name="l00152"></a><span class="lineno"><a class="line" href="a00194.html#ga3d06e6447edeb61e56a9ad83f31f0a37">  152</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga3d06e6447edeb61e56a9ad83f31f0a37">hwloc_bitmap_list_snprintf</a>(<span class="keywordtype">char</span> * __hwloc_restrict buf, <span class="keywordtype">size_t</span> buflen, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap);</div>
+<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span> </div>
+<div class="line"><a id="l00158" name="l00158"></a><span class="lineno"><a class="line" href="a00194.html#ga39c0f1b02053de66d205c9f8260b3665">  158</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga39c0f1b02053de66d205c9f8260b3665">hwloc_bitmap_list_asprintf</a>(<span class="keywordtype">char</span> ** strp, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap);</div>
+<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span> </div>
+<div class="line"><a id="l00164" name="l00164"></a><span class="lineno"><a class="line" href="a00194.html#gaf9314311d482c621e17c6a53a9fe993e">  164</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#gaf9314311d482c621e17c6a53a9fe993e">hwloc_bitmap_list_sscanf</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keyword">const</span> <span class="keywordtype">char</span> * __hwloc_restrict <span class="keywordtype">string</span>);</div>
+<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span> </div>
+<div class="line"><a id="l00178" name="l00178"></a><span class="lineno"><a class="line" href="a00194.html#ga5beb68a987fe48e5c5edef06ab260e14">  178</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga5beb68a987fe48e5c5edef06ab260e14">hwloc_bitmap_taskset_snprintf</a>(<span class="keywordtype">char</span> * __hwloc_restrict buf, <span class="keywordtype">size_t</span> buflen, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap);</div>
+<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span> </div>
+<div class="line"><a id="l00184" name="l00184"></a><span class="lineno"><a class="line" href="a00194.html#ga391312513f17c985d871f18367c59512">  184</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga391312513f17c985d871f18367c59512">hwloc_bitmap_taskset_asprintf</a>(<span class="keywordtype">char</span> ** strp, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap);</div>
+<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span> </div>
+<div class="line"><a id="l00190" name="l00190"></a><span class="lineno"><a class="line" href="a00194.html#ga4f23db5041240e03e348752f8bd6ec2d">  190</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga4f23db5041240e03e348752f8bd6ec2d">hwloc_bitmap_taskset_sscanf</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keyword">const</span> <span class="keywordtype">char</span> * __hwloc_restrict <span class="keywordtype">string</span>);</div>
+<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span> </div>
+<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span> </div>
+<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span><span class="comment"> * Building bitmaps.</span></div>
+<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span> </div>
+<div class="line"><a id="l00198" name="l00198"></a><span class="lineno"><a class="line" href="a00194.html#gaa97c5217613c8cae9862287170ea2132">  198</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> <a class="code hl_function" href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap);</div>
+<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span> </div>
+<div class="line"><a id="l00201" name="l00201"></a><span class="lineno"><a class="line" href="a00194.html#ga07b2de8786b3cdb22f21d9dd42588275">  201</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> <a class="code hl_function" href="a00194.html#ga07b2de8786b3cdb22f21d9dd42588275">hwloc_bitmap_fill</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap);</div>
+<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span> </div>
+<div class="line"><a id="l00204" name="l00204"></a><span class="lineno"><a class="line" href="a00194.html#ga10be0840cdeb7ce26d862819dd303baa">  204</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga10be0840cdeb7ce26d862819dd303baa">hwloc_bitmap_only</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> <span class="keywordtype">id</span>);</div>
+<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span> </div>
+<div class="line"><a id="l00207" name="l00207"></a><span class="lineno"><a class="line" href="a00194.html#ga06d505f8a1c0a536614f65f503ee6d93">  207</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga06d505f8a1c0a536614f65f503ee6d93">hwloc_bitmap_allbut</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> <span class="keywordtype">id</span>);</div>
+<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span> </div>
+<div class="line"><a id="l00210" name="l00210"></a><span class="lineno"><a class="line" href="a00194.html#gad59b0ebeb29c1bfabbb2a379e55c1159">  210</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#gad59b0ebeb29c1bfabbb2a379e55c1159">hwloc_bitmap_from_ulong</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> mask);</div>
+<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span> </div>
+<div class="line"><a id="l00213" name="l00213"></a><span class="lineno"><a class="line" href="a00194.html#ga4947c46d47bcfcd3faf3f59569be3e37">  213</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga4947c46d47bcfcd3faf3f59569be3e37">hwloc_bitmap_from_ith_ulong</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> i, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> mask);</div>
+<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span> </div>
+<div class="line"><a id="l00216" name="l00216"></a><span class="lineno"><a class="line" href="a00194.html#gabcfef22f6fc4d4b33f068dd91a1c38f5">  216</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#gabcfef22f6fc4d4b33f068dd91a1c38f5">hwloc_bitmap_from_ulongs</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> nr, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *masks);</div>
+<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span> </div>
+<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span> </div>
+<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span><span class="comment"> * Modifying bitmaps.</span></div>
+<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span> </div>
+<div class="line"><a id="l00224" name="l00224"></a><span class="lineno"><a class="line" href="a00194.html#ga062dbff93baeff3b425a7260c5463646">  224</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga062dbff93baeff3b425a7260c5463646">hwloc_bitmap_set</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> <span class="keywordtype">id</span>);</div>
+<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span> </div>
+<div class="line"><a id="l00230" name="l00230"></a><span class="lineno"><a class="line" href="a00194.html#ga9c9a8433732fb9f24899e7aa4c014d7e">  230</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga9c9a8433732fb9f24899e7aa4c014d7e">hwloc_bitmap_set_range</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> begin, <span class="keywordtype">int</span> end);</div>
+<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span> </div>
+<div class="line"><a id="l00233" name="l00233"></a><span class="lineno"><a class="line" href="a00194.html#ga3daeed965c35c6d2fd4820a318219985">  233</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga3daeed965c35c6d2fd4820a318219985">hwloc_bitmap_set_ith_ulong</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> i, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> mask);</div>
+<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span> </div>
+<div class="line"><a id="l00236" name="l00236"></a><span class="lineno"><a class="line" href="a00194.html#gaf20bb350b6844d08931a064a73f86743">  236</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#gaf20bb350b6844d08931a064a73f86743">hwloc_bitmap_clr</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> <span class="keywordtype">id</span>);</div>
+<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span> </div>
+<div class="line"><a id="l00242" name="l00242"></a><span class="lineno"><a class="line" href="a00194.html#ga833776709df94d727f8c22304b3388cf">  242</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga833776709df94d727f8c22304b3388cf">hwloc_bitmap_clr_range</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> begin, <span class="keywordtype">int</span> end);</div>
+<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span> </div>
+<div class="line"><a id="l00263" name="l00263"></a><span class="lineno"><a class="line" href="a00194.html#gaa611a77c092e679246afdf9a60d5db8b">  263</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#gaa611a77c092e679246afdf9a60d5db8b">hwloc_bitmap_singlify</a>(<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap);</div>
+<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span> </div>
+<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span> </div>
+<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span><span class="comment"> * Consulting bitmaps.</span></div>
+<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span> </div>
+<div class="line"><a id="l00271" name="l00271"></a><span class="lineno"><a class="line" href="a00194.html#gab6a6bae22a33ec6adfc169a953c13e6c">  271</a></span>HWLOC_DECLSPEC <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code hl_function" href="a00194.html#gab6a6bae22a33ec6adfc169a953c13e6c">hwloc_bitmap_to_ulong</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span> </div>
+<div class="line"><a id="l00274" name="l00274"></a><span class="lineno"><a class="line" href="a00194.html#gac92e6404f648d6b99d2c626b05b2ffa4">  274</a></span>HWLOC_DECLSPEC <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code hl_function" href="a00194.html#gac92e6404f648d6b99d2c626b05b2ffa4">hwloc_bitmap_to_ith_ulong</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> i) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span> </div>
+<div class="line"><a id="l00282" name="l00282"></a><span class="lineno"><a class="line" href="a00194.html#gacd215a2348732de25d94a4ecd76d528c">  282</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#gacd215a2348732de25d94a4ecd76d528c">hwloc_bitmap_to_ulongs</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> nr, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *masks);</div>
+<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span> </div>
+<div class="line"><a id="l00298" name="l00298"></a><span class="lineno"><a class="line" href="a00194.html#gac0744734d761d65c977aece565364908">  298</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#gac0744734d761d65c977aece565364908">hwloc_bitmap_nr_ulongs</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00299" name="l00299"></a><span class="lineno">  299</span> </div>
+<div class="line"><a id="l00304" name="l00304"></a><span class="lineno"><a class="line" href="a00194.html#ga11340dd487f110bb84f0a6e4ae90bd06">  304</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga11340dd487f110bb84f0a6e4ae90bd06">hwloc_bitmap_isset</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap, <span class="keywordtype">unsigned</span> <span class="keywordtype">id</span>) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span> </div>
+<div class="line"><a id="l00310" name="l00310"></a><span class="lineno"><a class="line" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">  310</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00311" name="l00311"></a><span class="lineno">  311</span> </div>
+<div class="line"><a id="l00318" name="l00318"></a><span class="lineno"><a class="line" href="a00194.html#ga5fdcb8c19c336511c37076d649e74af4">  318</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga5fdcb8c19c336511c37076d649e74af4">hwloc_bitmap_isfull</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00319" name="l00319"></a><span class="lineno">  319</span> </div>
+<div class="line"><a id="l00325" name="l00325"></a><span class="lineno"><a class="line" href="a00194.html#ga3ec1ced43afadf8c0a7197320bc016ed">  325</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga3ec1ced43afadf8c0a7197320bc016ed">hwloc_bitmap_first</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00326" name="l00326"></a><span class="lineno">  326</span> </div>
+<div class="line"><a id="l00333" name="l00333"></a><span class="lineno"><a class="line" href="a00194.html#gaab7240b4b644693b775dad17b44ffd68">  333</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#gaab7240b4b644693b775dad17b44ffd68">hwloc_bitmap_next</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap, <span class="keywordtype">int</span> prev) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00334" name="l00334"></a><span class="lineno">  334</span> </div>
+<div class="line"><a id="l00340" name="l00340"></a><span class="lineno"><a class="line" href="a00194.html#ga3d9b08b060a59bbab5a4ea6d0a1ed7a6">  340</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga3d9b08b060a59bbab5a4ea6d0a1ed7a6">hwloc_bitmap_last</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00341" name="l00341"></a><span class="lineno">  341</span> </div>
+<div class="line"><a id="l00348" name="l00348"></a><span class="lineno"><a class="line" href="a00194.html#ga0200466842c0e1f5da75e84dde460b10">  348</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga0200466842c0e1f5da75e84dde460b10">hwloc_bitmap_weight</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00349" name="l00349"></a><span class="lineno">  349</span> </div>
+<div class="line"><a id="l00355" name="l00355"></a><span class="lineno"><a class="line" href="a00194.html#gae408841487b288e148a478ba0465c99e">  355</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#gae408841487b288e148a478ba0465c99e">hwloc_bitmap_first_unset</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00356" name="l00356"></a><span class="lineno">  356</span> </div>
+<div class="line"><a id="l00363" name="l00363"></a><span class="lineno"><a class="line" href="a00194.html#ga9653af34d1460ef106b7df25af4cdca8">  363</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga9653af34d1460ef106b7df25af4cdca8">hwloc_bitmap_next_unset</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap, <span class="keywordtype">int</span> prev) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00364" name="l00364"></a><span class="lineno">  364</span> </div>
+<div class="line"><a id="l00370" name="l00370"></a><span class="lineno"><a class="line" href="a00194.html#ga45d49aeb45c7da631b1480a93dc3fc92">  370</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga45d49aeb45c7da631b1480a93dc3fc92">hwloc_bitmap_last_unset</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00371" name="l00371"></a><span class="lineno">  371</span> </div>
+<div class="foldopen" id="foldopen00387" data-start="" data-end="">
+<div class="line"><a id="l00387" name="l00387"></a><span class="lineno"><a class="line" href="a00194.html#ga3f6861045a8029ade373510ffa727d2a">  387</a></span><span class="preprocessor">#define hwloc_bitmap_foreach_begin(id, bitmap) \</span></div>
+<div class="line"><a id="l00388" name="l00388"></a><span class="lineno">  388</span><span class="preprocessor">do { \</span></div>
+<div class="line"><a id="l00389" name="l00389"></a><span class="lineno">  389</span><span class="preprocessor">        assert(hwloc_bitmap_weight(bitmap) != -1); \</span></div>
+<div class="line"><a id="l00390" name="l00390"></a><span class="lineno">  390</span><span class="preprocessor">        for (id = hwloc_bitmap_first(bitmap); \</span></div>
+<div class="line"><a id="l00391" name="l00391"></a><span class="lineno">  391</span><span class="preprocessor">             (unsigned) id != (unsigned) -1; \</span></div>
+<div class="line"><a id="l00392" name="l00392"></a><span class="lineno">  392</span><span class="preprocessor">             id = hwloc_bitmap_next(bitmap, id)) {</span></div>
+</div>
+<div class="line"><a id="l00393" name="l00393"></a><span class="lineno">  393</span> </div>
+<div class="foldopen" id="foldopen00401" data-start="" data-end="">
+<div class="line"><a id="l00401" name="l00401"></a><span class="lineno"><a class="line" href="a00194.html#gafcf3246db406218d4e155735b3fa6528">  401</a></span><span class="preprocessor">#define hwloc_bitmap_foreach_end()              \</span></div>
+<div class="line"><a id="l00402" name="l00402"></a><span class="lineno">  402</span><span class="preprocessor">        } \</span></div>
+<div class="line"><a id="l00403" name="l00403"></a><span class="lineno">  403</span><span class="preprocessor">} while (0)</span></div>
+</div>
+<div class="line"><a id="l00404" name="l00404"></a><span class="lineno">  404</span> </div>
+<div class="line"><a id="l00405" name="l00405"></a><span class="lineno">  405</span> </div>
+<div class="line"><a id="l00406" name="l00406"></a><span class="lineno">  406</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00407" name="l00407"></a><span class="lineno">  407</span><span class="comment"> * Combining bitmaps.</span></div>
+<div class="line"><a id="l00408" name="l00408"></a><span class="lineno">  408</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00409" name="l00409"></a><span class="lineno">  409</span> </div>
+<div class="line"><a id="l00414" name="l00414"></a><span class="lineno"><a class="line" href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">  414</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">hwloc_bitmap_or</a> (<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> res, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2);</div>
+<div class="line"><a id="l00415" name="l00415"></a><span class="lineno">  415</span> </div>
+<div class="line"><a id="l00420" name="l00420"></a><span class="lineno"><a class="line" href="a00194.html#ga674533016ffed922a28b4f0b49b82cd4">  420</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga674533016ffed922a28b4f0b49b82cd4">hwloc_bitmap_and</a> (<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> res, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2);</div>
+<div class="line"><a id="l00421" name="l00421"></a><span class="lineno">  421</span> </div>
+<div class="line"><a id="l00426" name="l00426"></a><span class="lineno"><a class="line" href="a00194.html#ga7ca5c72db65406b85aca032c8a990f9e">  426</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga7ca5c72db65406b85aca032c8a990f9e">hwloc_bitmap_andnot</a> (<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> res, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2);</div>
+<div class="line"><a id="l00427" name="l00427"></a><span class="lineno">  427</span> </div>
+<div class="line"><a id="l00432" name="l00432"></a><span class="lineno"><a class="line" href="a00194.html#ga205508218e09cb9befd0687f16409f09">  432</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga205508218e09cb9befd0687f16409f09">hwloc_bitmap_xor</a> (<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> res, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2);</div>
+<div class="line"><a id="l00433" name="l00433"></a><span class="lineno">  433</span> </div>
+<div class="line"><a id="l00438" name="l00438"></a><span class="lineno"><a class="line" href="a00194.html#ga84cfdb4f8ab8c1f7e097728e613a2a3f">  438</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga84cfdb4f8ab8c1f7e097728e613a2a3f">hwloc_bitmap_not</a> (<a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> res, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap);</div>
+<div class="line"><a id="l00439" name="l00439"></a><span class="lineno">  439</span> </div>
+<div class="line"><a id="l00440" name="l00440"></a><span class="lineno">  440</span> </div>
+<div class="line"><a id="l00441" name="l00441"></a><span class="lineno">  441</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00442" name="l00442"></a><span class="lineno">  442</span><span class="comment"> * Comparing bitmaps.</span></div>
+<div class="line"><a id="l00443" name="l00443"></a><span class="lineno">  443</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00444" name="l00444"></a><span class="lineno">  444</span> </div>
+<div class="line"><a id="l00451" name="l00451"></a><span class="lineno"><a class="line" href="a00194.html#gaefa070f9232857ba5a57297ea9a08ea2">  451</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#gaefa070f9232857ba5a57297ea9a08ea2">hwloc_bitmap_intersects</a> (<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00452" name="l00452"></a><span class="lineno">  452</span> </div>
+<div class="line"><a id="l00459" name="l00459"></a><span class="lineno"><a class="line" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">  459</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a> (<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> sub_bitmap, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> super_bitmap) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00460" name="l00460"></a><span class="lineno">  460</span> </div>
+<div class="line"><a id="l00465" name="l00465"></a><span class="lineno"><a class="line" href="a00194.html#ga32376b1405e57472b73c3aa53bb39663">  465</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga32376b1405e57472b73c3aa53bb39663">hwloc_bitmap_isequal</a> (<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00466" name="l00466"></a><span class="lineno">  466</span> </div>
+<div class="line"><a id="l00484" name="l00484"></a><span class="lineno"><a class="line" href="a00194.html#gaa39cda1510ab721b5c012c76ead72365">  484</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#gaa39cda1510ab721b5c012c76ead72365">hwloc_bitmap_compare_first</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00485" name="l00485"></a><span class="lineno">  485</span> </div>
+<div class="line"><a id="l00503" name="l00503"></a><span class="lineno"><a class="line" href="a00194.html#ga14cdbc0ef0a705e84999bd48a2e649f3">  503</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00194.html#ga14cdbc0ef0a705e84999bd48a2e649f3">hwloc_bitmap_compare</a>(<a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2) __hwloc_attribute_pure;</div>
+<div class="line"><a id="l00504" name="l00504"></a><span class="lineno">  504</span> </div>
+<div class="line"><a id="l00508" name="l00508"></a><span class="lineno">  508</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00509" name="l00509"></a><span class="lineno">  509</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00510" name="l00510"></a><span class="lineno">  510</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00511" name="l00511"></a><span class="lineno">  511</span> </div>
+<div class="line"><a id="l00512" name="l00512"></a><span class="lineno">  512</span> </div>
+<div class="line"><a id="l00513" name="l00513"></a><span class="lineno">  513</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_BITMAP_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00194_html_ga0200466842c0e1f5da75e84dde460b10"><div class="ttname"><a href="a00194.html#ga0200466842c0e1f5da75e84dde460b10">hwloc_bitmap_weight</a></div><div class="ttdeci">int hwloc_bitmap_weight(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Compute the &quot;weight&quot; of bitmap bitmap (i.e., number of indexes that are in the bitmap).</div></div>
+<div class="ttc" id="aa00194_html_ga02853b4a224970587b9d7a0e20d857c0"><div class="ttname"><a href="a00194.html#ga02853b4a224970587b9d7a0e20d857c0">hwloc_bitmap_alloc_full</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_bitmap_alloc_full(void)</div><div class="ttdoc">Allocate a new full bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga0526e03db81956fb02acc8260b66d6a4"><div class="ttname"><a href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a></div><div class="ttdeci">int hwloc_bitmap_isincluded(hwloc_const_bitmap_t sub_bitmap, hwloc_const_bitmap_t super_bitmap)</div><div class="ttdoc">Test whether bitmap sub_bitmap is part of bitmap super_bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga062dbff93baeff3b425a7260c5463646"><div class="ttname"><a href="a00194.html#ga062dbff93baeff3b425a7260c5463646">hwloc_bitmap_set</a></div><div class="ttdeci">int hwloc_bitmap_set(hwloc_bitmap_t bitmap, unsigned id)</div><div class="ttdoc">Add index id in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga064a85c643a364b60acbfa0f3663fc18"><div class="ttname"><a href="a00194.html#ga064a85c643a364b60acbfa0f3663fc18">hwloc_bitmap_sscanf</a></div><div class="ttdeci">int hwloc_bitmap_sscanf(hwloc_bitmap_t bitmap, const char *restrict string)</div><div class="ttdoc">Parse a bitmap string and stores it in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga06d505f8a1c0a536614f65f503ee6d93"><div class="ttname"><a href="a00194.html#ga06d505f8a1c0a536614f65f503ee6d93">hwloc_bitmap_allbut</a></div><div class="ttdeci">int hwloc_bitmap_allbut(hwloc_bitmap_t bitmap, unsigned id)</div><div class="ttdoc">Fill the bitmap and clear the index id.</div></div>
+<div class="ttc" id="aa00194_html_ga07b2de8786b3cdb22f21d9dd42588275"><div class="ttname"><a href="a00194.html#ga07b2de8786b3cdb22f21d9dd42588275">hwloc_bitmap_fill</a></div><div class="ttdeci">void hwloc_bitmap_fill(hwloc_bitmap_t bitmap)</div><div class="ttdoc">Fill bitmap bitmap with all possible indexes (even if those objects don't exist or are otherwise unav...</div></div>
+<div class="ttc" id="aa00194_html_ga0fece972134fdecf2da9bc7a11dd827e"><div class="ttname"><a href="a00194.html#ga0fece972134fdecf2da9bc7a11dd827e">hwloc_bitmap_asprintf</a></div><div class="ttdeci">int hwloc_bitmap_asprintf(char **strp, hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Stringify a bitmap into a newly allocated string.</div></div>
+<div class="ttc" id="aa00194_html_ga10be0840cdeb7ce26d862819dd303baa"><div class="ttname"><a href="a00194.html#ga10be0840cdeb7ce26d862819dd303baa">hwloc_bitmap_only</a></div><div class="ttdeci">int hwloc_bitmap_only(hwloc_bitmap_t bitmap, unsigned id)</div><div class="ttdoc">Empty the bitmap bitmap and add bit id.</div></div>
+<div class="ttc" id="aa00194_html_ga11340dd487f110bb84f0a6e4ae90bd06"><div class="ttname"><a href="a00194.html#ga11340dd487f110bb84f0a6e4ae90bd06">hwloc_bitmap_isset</a></div><div class="ttdeci">int hwloc_bitmap_isset(hwloc_const_bitmap_t bitmap, unsigned id)</div><div class="ttdoc">Test whether index id is part of bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga120b8aefb9ce7ef349929656359b1859"><div class="ttname"><a href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">hwloc_bitmap_or</a></div><div class="ttdeci">int hwloc_bitmap_or(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">Or bitmaps bitmap1 and bitmap2 and store the result in bitmap res.</div></div>
+<div class="ttc" id="aa00194_html_ga14cdbc0ef0a705e84999bd48a2e649f3"><div class="ttname"><a href="a00194.html#ga14cdbc0ef0a705e84999bd48a2e649f3">hwloc_bitmap_compare</a></div><div class="ttdeci">int hwloc_bitmap_compare(hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">Compare bitmaps bitmap1 and bitmap2 in lexicographic order.</div></div>
+<div class="ttc" id="aa00194_html_ga156130d85b3a0674d6e0e6770fe68fbe"><div class="ttname"><a href="a00194.html#ga156130d85b3a0674d6e0e6770fe68fbe">hwloc_bitmap_free</a></div><div class="ttdeci">void hwloc_bitmap_free(hwloc_bitmap_t bitmap)</div><div class="ttdoc">Free bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga205508218e09cb9befd0687f16409f09"><div class="ttname"><a href="a00194.html#ga205508218e09cb9befd0687f16409f09">hwloc_bitmap_xor</a></div><div class="ttdeci">int hwloc_bitmap_xor(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">Xor bitmaps bitmap1 and bitmap2 and store the result in bitmap res.</div></div>
+<div class="ttc" id="aa00194_html_ga32376b1405e57472b73c3aa53bb39663"><div class="ttname"><a href="a00194.html#ga32376b1405e57472b73c3aa53bb39663">hwloc_bitmap_isequal</a></div><div class="ttdeci">int hwloc_bitmap_isequal(hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">Test whether bitmap bitmap1 is equal to bitmap bitmap2.</div></div>
+<div class="ttc" id="aa00194_html_ga391312513f17c985d871f18367c59512"><div class="ttname"><a href="a00194.html#ga391312513f17c985d871f18367c59512">hwloc_bitmap_taskset_asprintf</a></div><div class="ttdeci">int hwloc_bitmap_taskset_asprintf(char **strp, hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Stringify a bitmap into a newly allocated taskset-specific string.</div></div>
+<div class="ttc" id="aa00194_html_ga39c0f1b02053de66d205c9f8260b3665"><div class="ttname"><a href="a00194.html#ga39c0f1b02053de66d205c9f8260b3665">hwloc_bitmap_list_asprintf</a></div><div class="ttdeci">int hwloc_bitmap_list_asprintf(char **strp, hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Stringify a bitmap into a newly allocated list string.</div></div>
+<div class="ttc" id="aa00194_html_ga3d06e6447edeb61e56a9ad83f31f0a37"><div class="ttname"><a href="a00194.html#ga3d06e6447edeb61e56a9ad83f31f0a37">hwloc_bitmap_list_snprintf</a></div><div class="ttdeci">int hwloc_bitmap_list_snprintf(char *restrict buf, size_t buflen, hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Stringify a bitmap in the list format.</div></div>
+<div class="ttc" id="aa00194_html_ga3d9b08b060a59bbab5a4ea6d0a1ed7a6"><div class="ttname"><a href="a00194.html#ga3d9b08b060a59bbab5a4ea6d0a1ed7a6">hwloc_bitmap_last</a></div><div class="ttdeci">int hwloc_bitmap_last(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Compute the last index (most significant bit) in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga3daeed965c35c6d2fd4820a318219985"><div class="ttname"><a href="a00194.html#ga3daeed965c35c6d2fd4820a318219985">hwloc_bitmap_set_ith_ulong</a></div><div class="ttdeci">int hwloc_bitmap_set_ith_ulong(hwloc_bitmap_t bitmap, unsigned i, unsigned long mask)</div><div class="ttdoc">Replace i -th subset of bitmap bitmap with unsigned long mask.</div></div>
+<div class="ttc" id="aa00194_html_ga3ec1ced43afadf8c0a7197320bc016ed"><div class="ttname"><a href="a00194.html#ga3ec1ced43afadf8c0a7197320bc016ed">hwloc_bitmap_first</a></div><div class="ttdeci">int hwloc_bitmap_first(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Compute the first index (least significant bit) in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga45d49aeb45c7da631b1480a93dc3fc92"><div class="ttname"><a href="a00194.html#ga45d49aeb45c7da631b1480a93dc3fc92">hwloc_bitmap_last_unset</a></div><div class="ttdeci">int hwloc_bitmap_last_unset(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Compute the last unset index (most significant bit) in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga4947c46d47bcfcd3faf3f59569be3e37"><div class="ttname"><a href="a00194.html#ga4947c46d47bcfcd3faf3f59569be3e37">hwloc_bitmap_from_ith_ulong</a></div><div class="ttdeci">int hwloc_bitmap_from_ith_ulong(hwloc_bitmap_t bitmap, unsigned i, unsigned long mask)</div><div class="ttdoc">Setup bitmap bitmap from unsigned long mask used as i -th subset.</div></div>
+<div class="ttc" id="aa00194_html_ga4f23db5041240e03e348752f8bd6ec2d"><div class="ttname"><a href="a00194.html#ga4f23db5041240e03e348752f8bd6ec2d">hwloc_bitmap_taskset_sscanf</a></div><div class="ttdeci">int hwloc_bitmap_taskset_sscanf(hwloc_bitmap_t bitmap, const char *restrict string)</div><div class="ttdoc">Parse a taskset-specific bitmap string and stores it in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga5b64be28f5a7176ed8ad0d6a90bdf108"><div class="ttname"><a href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a></div><div class="ttdeci">int hwloc_bitmap_iszero(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Test whether bitmap bitmap is empty.</div></div>
+<div class="ttc" id="aa00194_html_ga5beb68a987fe48e5c5edef06ab260e14"><div class="ttname"><a href="a00194.html#ga5beb68a987fe48e5c5edef06ab260e14">hwloc_bitmap_taskset_snprintf</a></div><div class="ttdeci">int hwloc_bitmap_taskset_snprintf(char *restrict buf, size_t buflen, hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Stringify a bitmap in the taskset-specific format.</div></div>
+<div class="ttc" id="aa00194_html_ga5fdcb8c19c336511c37076d649e74af4"><div class="ttname"><a href="a00194.html#ga5fdcb8c19c336511c37076d649e74af4">hwloc_bitmap_isfull</a></div><div class="ttdeci">int hwloc_bitmap_isfull(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Test whether bitmap bitmap is completely full.</div></div>
+<div class="ttc" id="aa00194_html_ga674533016ffed922a28b4f0b49b82cd4"><div class="ttname"><a href="a00194.html#ga674533016ffed922a28b4f0b49b82cd4">hwloc_bitmap_and</a></div><div class="ttdeci">int hwloc_bitmap_and(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">And bitmaps bitmap1 and bitmap2 and store the result in bitmap res.</div></div>
+<div class="ttc" id="aa00194_html_ga72a29824798b48784b8217471ec8f14c"><div class="ttname"><a href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a></div><div class="ttdeci">int hwloc_bitmap_copy(hwloc_bitmap_t dst, hwloc_const_bitmap_t src)</div><div class="ttdoc">Copy the contents of bitmap src into the already allocated bitmap dst.</div></div>
+<div class="ttc" id="aa00194_html_ga7ca5c72db65406b85aca032c8a990f9e"><div class="ttname"><a href="a00194.html#ga7ca5c72db65406b85aca032c8a990f9e">hwloc_bitmap_andnot</a></div><div class="ttdeci">int hwloc_bitmap_andnot(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">And bitmap bitmap1 and the negation of bitmap2 and store the result in bitmap res.</div></div>
+<div class="ttc" id="aa00194_html_ga833776709df94d727f8c22304b3388cf"><div class="ttname"><a href="a00194.html#ga833776709df94d727f8c22304b3388cf">hwloc_bitmap_clr_range</a></div><div class="ttdeci">int hwloc_bitmap_clr_range(hwloc_bitmap_t bitmap, unsigned begin, int end)</div><div class="ttdoc">Remove indexes from begin to end in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga84cfdb4f8ab8c1f7e097728e613a2a3f"><div class="ttname"><a href="a00194.html#ga84cfdb4f8ab8c1f7e097728e613a2a3f">hwloc_bitmap_not</a></div><div class="ttdeci">int hwloc_bitmap_not(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Negate bitmap bitmap and store the result in bitmap res.</div></div>
+<div class="ttc" id="aa00194_html_ga9511644657030a021dce9941e3cda583"><div class="ttname"><a href="a00194.html#ga9511644657030a021dce9941e3cda583">hwloc_bitmap_snprintf</a></div><div class="ttdeci">int hwloc_bitmap_snprintf(char *restrict buf, size_t buflen, hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Stringify a bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga9653af34d1460ef106b7df25af4cdca8"><div class="ttname"><a href="a00194.html#ga9653af34d1460ef106b7df25af4cdca8">hwloc_bitmap_next_unset</a></div><div class="ttdeci">int hwloc_bitmap_next_unset(hwloc_const_bitmap_t bitmap, int prev)</div><div class="ttdoc">Compute the next unset index in bitmap bitmap which is after index prev.</div></div>
+<div class="ttc" id="aa00194_html_ga9c9a8433732fb9f24899e7aa4c014d7e"><div class="ttname"><a href="a00194.html#ga9c9a8433732fb9f24899e7aa4c014d7e">hwloc_bitmap_set_range</a></div><div class="ttdeci">int hwloc_bitmap_set_range(hwloc_bitmap_t bitmap, unsigned begin, int end)</div><div class="ttdoc">Add indexes from begin to end in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_gaa39cda1510ab721b5c012c76ead72365"><div class="ttname"><a href="a00194.html#gaa39cda1510ab721b5c012c76ead72365">hwloc_bitmap_compare_first</a></div><div class="ttdeci">int hwloc_bitmap_compare_first(hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">Compare bitmaps bitmap1 and bitmap2 using their lowest index.</div></div>
+<div class="ttc" id="aa00194_html_gaa3c2bf4c776d603dcebbb61b0c923d84"><div class="ttname"><a href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a></div><div class="ttdeci">struct hwloc_bitmap_s * hwloc_bitmap_t</div><div class="ttdoc">Set of bits represented as an opaque pointer to an internal bitmap.</div><div class="ttdef"><b>Definition</b> bitmap.h:69</div></div>
+<div class="ttc" id="aa00194_html_gaa611a77c092e679246afdf9a60d5db8b"><div class="ttname"><a href="a00194.html#gaa611a77c092e679246afdf9a60d5db8b">hwloc_bitmap_singlify</a></div><div class="ttdeci">int hwloc_bitmap_singlify(hwloc_bitmap_t bitmap)</div><div class="ttdoc">Keep a single index among those set in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_gaa97c5217613c8cae9862287170ea2132"><div class="ttname"><a href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a></div><div class="ttdeci">void hwloc_bitmap_zero(hwloc_bitmap_t bitmap)</div><div class="ttdoc">Empty the bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_gaab7240b4b644693b775dad17b44ffd68"><div class="ttname"><a href="a00194.html#gaab7240b4b644693b775dad17b44ffd68">hwloc_bitmap_next</a></div><div class="ttdeci">int hwloc_bitmap_next(hwloc_const_bitmap_t bitmap, int prev)</div><div class="ttdoc">Compute the next index in bitmap bitmap which is after index prev.</div></div>
+<div class="ttc" id="aa00194_html_gab6a6bae22a33ec6adfc169a953c13e6c"><div class="ttname"><a href="a00194.html#gab6a6bae22a33ec6adfc169a953c13e6c">hwloc_bitmap_to_ulong</a></div><div class="ttdeci">unsigned long hwloc_bitmap_to_ulong(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Convert the beginning part of bitmap bitmap into unsigned long mask.</div></div>
+<div class="ttc" id="aa00194_html_gabcfef22f6fc4d4b33f068dd91a1c38f5"><div class="ttname"><a href="a00194.html#gabcfef22f6fc4d4b33f068dd91a1c38f5">hwloc_bitmap_from_ulongs</a></div><div class="ttdeci">int hwloc_bitmap_from_ulongs(hwloc_bitmap_t bitmap, unsigned nr, const unsigned long *masks)</div><div class="ttdoc">Setup bitmap bitmap from unsigned longs masks used as first nr subsets.</div></div>
+<div class="ttc" id="aa00194_html_gac0744734d761d65c977aece565364908"><div class="ttname"><a href="a00194.html#gac0744734d761d65c977aece565364908">hwloc_bitmap_nr_ulongs</a></div><div class="ttdeci">int hwloc_bitmap_nr_ulongs(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Return the number of unsigned longs required for storing bitmap bitmap entirely.</div></div>
+<div class="ttc" id="aa00194_html_gac92e6404f648d6b99d2c626b05b2ffa4"><div class="ttname"><a href="a00194.html#gac92e6404f648d6b99d2c626b05b2ffa4">hwloc_bitmap_to_ith_ulong</a></div><div class="ttdeci">unsigned long hwloc_bitmap_to_ith_ulong(hwloc_const_bitmap_t bitmap, unsigned i)</div><div class="ttdoc">Convert the i -th subset of bitmap bitmap into unsigned long mask.</div></div>
+<div class="ttc" id="aa00194_html_gacd215a2348732de25d94a4ecd76d528c"><div class="ttname"><a href="a00194.html#gacd215a2348732de25d94a4ecd76d528c">hwloc_bitmap_to_ulongs</a></div><div class="ttdeci">int hwloc_bitmap_to_ulongs(hwloc_const_bitmap_t bitmap, unsigned nr, unsigned long *masks)</div><div class="ttdoc">Convert the first nr subsets of bitmap bitmap into the array of nr unsigned long masks.</div></div>
+<div class="ttc" id="aa00194_html_gad59b0ebeb29c1bfabbb2a379e55c1159"><div class="ttname"><a href="a00194.html#gad59b0ebeb29c1bfabbb2a379e55c1159">hwloc_bitmap_from_ulong</a></div><div class="ttdeci">int hwloc_bitmap_from_ulong(hwloc_bitmap_t bitmap, unsigned long mask)</div><div class="ttdoc">Setup bitmap bitmap from unsigned long mask.</div></div>
+<div class="ttc" id="aa00194_html_gadece3d1eb5199fc2fb99bc7dcf1ccc05"><div class="ttname"><a href="a00194.html#gadece3d1eb5199fc2fb99bc7dcf1ccc05">hwloc_bitmap_alloc</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_bitmap_alloc(void)</div><div class="ttdoc">Allocate a new empty bitmap.</div></div>
+<div class="ttc" id="aa00194_html_gae408841487b288e148a478ba0465c99e"><div class="ttname"><a href="a00194.html#gae408841487b288e148a478ba0465c99e">hwloc_bitmap_first_unset</a></div><div class="ttdeci">int hwloc_bitmap_first_unset(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Compute the first unset index (least significant bit) in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_gae679434c1a5f41d3560a8a7e2c1b0dee"><div class="ttname"><a href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee">hwloc_bitmap_dup</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_bitmap_dup(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.</div></div>
+<div class="ttc" id="aa00194_html_gae991a108af01d408be2776c5b2c467b2"><div class="ttname"><a href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a></div><div class="ttdeci">const struct hwloc_bitmap_s * hwloc_const_bitmap_t</div><div class="ttdoc">a non-modifiable hwloc_bitmap_t</div><div class="ttdef"><b>Definition</b> bitmap.h:71</div></div>
+<div class="ttc" id="aa00194_html_gaefa070f9232857ba5a57297ea9a08ea2"><div class="ttname"><a href="a00194.html#gaefa070f9232857ba5a57297ea9a08ea2">hwloc_bitmap_intersects</a></div><div class="ttdeci">int hwloc_bitmap_intersects(hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">Test whether bitmaps bitmap1 and bitmap2 intersects.</div></div>
+<div class="ttc" id="aa00194_html_gaf20bb350b6844d08931a064a73f86743"><div class="ttname"><a href="a00194.html#gaf20bb350b6844d08931a064a73f86743">hwloc_bitmap_clr</a></div><div class="ttdeci">int hwloc_bitmap_clr(hwloc_bitmap_t bitmap, unsigned id)</div><div class="ttdoc">Remove index id from bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_gaf9314311d482c621e17c6a53a9fe993e"><div class="ttname"><a href="a00194.html#gaf9314311d482c621e17c6a53a9fe993e">hwloc_bitmap_list_sscanf</a></div><div class="ttdeci">int hwloc_bitmap_list_sscanf(hwloc_bitmap_t bitmap, const char *restrict string)</div><div class="ttdoc">Parse a list string and stores it in bitmap bitmap.</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00113_source.html 2.11.0-1/doc/doxygen-doc/html/a00113_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00113_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00113_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,141 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): export.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">export.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2009-2018 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2009-2012 Université Bordeaux</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
+<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="preprocessor">#ifndef HWLOC_EXPORT_H</span></div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#define HWLOC_EXPORT_H</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span> </div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#ifndef HWLOC_H</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#error Please include the main hwloc.h instead</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#elif 0</span></div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>}</div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span> </div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
+<div class="foldopen" id="foldopen00035" data-start="{" data-end="};">
+<div class="line"><a id="l00035" name="l00035"></a><span class="lineno"><a class="line" href="a00195.html#ga0eb99636aff71fe2704e1fa0ffe8c18d">   35</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00195.html#ga0eb99636aff71fe2704e1fa0ffe8c18d">hwloc_topology_export_xml_flags_e</a> {</div>
+<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span> <a class="code hl_enumvalue" href="a00195.html#gga0eb99636aff71fe2704e1fa0ffe8c18dae7d6d96546131ef0043867b836b02e0f">HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1</a> = (1UL&lt;&lt;0)</div>
+<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="a00195.html#gga0eb99636aff71fe2704e1fa0ffe8c18dae7d6d96546131ef0043867b836b02e0f">   41</a></span>};</div>
+</div>
+<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span> </div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno"><a class="line" href="a00195.html#ga333f79975b4eeb28a3d8fad3373583ce">   71</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00195.html#ga333f79975b4eeb28a3d8fad3373583ce">hwloc_topology_export_xml</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">const</span> <span class="keywordtype">char</span> *xmlpath, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span> </div>
+<div class="line"><a id="l00105" name="l00105"></a><span class="lineno"><a class="line" href="a00195.html#gad33b7f7c11db10459505a3b1634fd3f1">  105</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00195.html#gad33b7f7c11db10459505a3b1634fd3f1">hwloc_topology_export_xmlbuffer</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">char</span> **xmlbuffer, <span class="keywordtype">int</span> *buflen, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span> </div>
+<div class="line"><a id="l00108" name="l00108"></a><span class="lineno"><a class="line" href="a00195.html#ga293e4a6489f15fd16ad22a5734561cf1">  108</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> <a class="code hl_function" href="a00195.html#ga293e4a6489f15fd16ad22a5734561cf1">hwloc_free_xmlbuffer</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">char</span> *xmlbuffer);</div>
+<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span> </div>
+<div class="line"><a id="l00128" name="l00128"></a><span class="lineno"><a class="line" href="a00195.html#ga9d6ff0f7a8dd45be9aa8575ef31978cc">  128</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> <a class="code hl_function" href="a00195.html#ga9d6ff0f7a8dd45be9aa8575ef31978cc">hwloc_topology_set_userdata_export_callback</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>                                                                <span class="keywordtype">void</span> (*export_cb)(<span class="keywordtype">void</span> *reserved, <a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj));</div>
+<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span> </div>
+<div class="line"><a id="l00158" name="l00158"></a><span class="lineno"><a class="line" href="a00195.html#gaa541bdd628416dbbe97d0df69d3de958">  158</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00195.html#gaa541bdd628416dbbe97d0df69d3de958">hwloc_export_obj_userdata</a>(<span class="keywordtype">void</span> *reserved, <a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj, <span class="keyword">const</span> <span class="keywordtype">char</span> *name, <span class="keyword">const</span> <span class="keywordtype">void</span> *buffer, <span class="keywordtype">size_t</span> length);</div>
+<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span> </div>
+<div class="line"><a id="l00179" name="l00179"></a><span class="lineno"><a class="line" href="a00195.html#ga1b7358137cec27bd073f58a606ecbaba">  179</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00195.html#ga1b7358137cec27bd073f58a606ecbaba">hwloc_export_obj_userdata_base64</a>(<span class="keywordtype">void</span> *reserved, <a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj, <span class="keyword">const</span> <span class="keywordtype">char</span> *name, <span class="keyword">const</span> <span class="keywordtype">void</span> *buffer, <span class="keywordtype">size_t</span> length);</div>
+<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span> </div>
+<div class="line"><a id="l00203" name="l00203"></a><span class="lineno"><a class="line" href="a00195.html#ga5ac6917ea7289955fb1ffda4353af9b0">  203</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> <a class="code hl_function" href="a00195.html#ga5ac6917ea7289955fb1ffda4353af9b0">hwloc_topology_set_userdata_import_callback</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>                                                                <span class="keywordtype">void</span> (*import_cb)(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj, <span class="keyword">const</span> <span class="keywordtype">char</span> *name, <span class="keyword">const</span> <span class="keywordtype">void</span> *buffer, <span class="keywordtype">size_t</span> length));</div>
+<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span> </div>
+<div class="foldopen" id="foldopen00217" data-start="{" data-end="};">
+<div class="line"><a id="l00217" name="l00217"></a><span class="lineno"><a class="line" href="a00196.html#ga7ac6f97cc40bd50c40285084f869ba63">  217</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00196.html#ga7ac6f97cc40bd50c40285084f869ba63">hwloc_topology_export_synthetic_flags_e</a> {</div>
+<div class="line"><a id="l00223" name="l00223"></a><span class="lineno"><a class="line" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a3b3bd4ba2ef9990810865e561034ccc9">  223</a></span> <a class="code hl_enumvalue" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a3b3bd4ba2ef9990810865e561034ccc9">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES</a> = (1UL&lt;&lt;0),</div>
+<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span> </div>
+<div class="line"><a id="l00231" name="l00231"></a><span class="lineno"><a class="line" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63aaa2702ffba050bab079b3041aec737d4">  231</a></span> <a class="code hl_enumvalue" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63aaa2702ffba050bab079b3041aec737d4">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS</a> = (1UL&lt;&lt;1),</div>
+<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span> </div>
+<div class="line"><a id="l00241" name="l00241"></a><span class="lineno"><a class="line" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a7896bdf4ccfcdcd09a9f76c0f5e3a5b8">  241</a></span> <a class="code hl_enumvalue" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a7896bdf4ccfcdcd09a9f76c0f5e3a5b8">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1</a> = (1UL&lt;&lt;2),</div>
+<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span> </div>
+<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span> <a class="code hl_enumvalue" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a22c57cf18e1da4a6c584fb783b552f9f">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY</a> = (1UL&lt;&lt;3)</div>
+<div class="line"><a id="l00252" name="l00252"></a><span class="lineno"><a class="line" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a22c57cf18e1da4a6c584fb783b552f9f">  252</a></span>};</div>
+</div>
+<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span> </div>
+<div class="line"><a id="l00275" name="l00275"></a><span class="lineno"><a class="line" href="a00196.html#ga24b7864a1c588309c4749f621f03b4c7">  275</a></span>  HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00196.html#ga24b7864a1c588309c4749f621f03b4c7">hwloc_topology_export_synthetic</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">char</span> *buffer, <span class="keywordtype">size_t</span> buflen, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span> </div>
+<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span> </div>
+<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span> </div>
+<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_EXPORT_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00195_html_ga0eb99636aff71fe2704e1fa0ffe8c18d"><div class="ttname"><a href="a00195.html#ga0eb99636aff71fe2704e1fa0ffe8c18d">hwloc_topology_export_xml_flags_e</a></div><div class="ttdeci">hwloc_topology_export_xml_flags_e</div><div class="ttdoc">Flags for exporting XML topologies.</div><div class="ttdef"><b>Definition</b> export.h:35</div></div>
+<div class="ttc" id="aa00195_html_ga1b7358137cec27bd073f58a606ecbaba"><div class="ttname"><a href="a00195.html#ga1b7358137cec27bd073f58a606ecbaba">hwloc_export_obj_userdata_base64</a></div><div class="ttdeci">int hwloc_export_obj_userdata_base64(void *reserved, hwloc_topology_t topology, hwloc_obj_t obj, const char *name, const void *buffer, size_t length)</div><div class="ttdoc">Encode and export some object userdata to XML.</div></div>
+<div class="ttc" id="aa00195_html_ga293e4a6489f15fd16ad22a5734561cf1"><div class="ttname"><a href="a00195.html#ga293e4a6489f15fd16ad22a5734561cf1">hwloc_free_xmlbuffer</a></div><div class="ttdeci">void hwloc_free_xmlbuffer(hwloc_topology_t topology, char *xmlbuffer)</div><div class="ttdoc">Free a buffer allocated by hwloc_topology_export_xmlbuffer()</div></div>
+<div class="ttc" id="aa00195_html_ga333f79975b4eeb28a3d8fad3373583ce"><div class="ttname"><a href="a00195.html#ga333f79975b4eeb28a3d8fad3373583ce">hwloc_topology_export_xml</a></div><div class="ttdeci">int hwloc_topology_export_xml(hwloc_topology_t topology, const char *xmlpath, unsigned long flags)</div><div class="ttdoc">Export the topology into an XML file.</div></div>
+<div class="ttc" id="aa00195_html_ga5ac6917ea7289955fb1ffda4353af9b0"><div class="ttname"><a href="a00195.html#ga5ac6917ea7289955fb1ffda4353af9b0">hwloc_topology_set_userdata_import_callback</a></div><div class="ttdeci">void hwloc_topology_set_userdata_import_callback(hwloc_topology_t topology, void(*import_cb)(hwloc_topology_t topology, hwloc_obj_t obj, const char *name, const void *buffer, size_t length))</div><div class="ttdoc">Set the application-specific callback for importing userdata.</div></div>
+<div class="ttc" id="aa00195_html_ga9d6ff0f7a8dd45be9aa8575ef31978cc"><div class="ttname"><a href="a00195.html#ga9d6ff0f7a8dd45be9aa8575ef31978cc">hwloc_topology_set_userdata_export_callback</a></div><div class="ttdeci">void hwloc_topology_set_userdata_export_callback(hwloc_topology_t topology, void(*export_cb)(void *reserved, hwloc_topology_t topology, hwloc_obj_t obj))</div><div class="ttdoc">Set the application-specific callback for exporting object userdata.</div></div>
+<div class="ttc" id="aa00195_html_gaa541bdd628416dbbe97d0df69d3de958"><div class="ttname"><a href="a00195.html#gaa541bdd628416dbbe97d0df69d3de958">hwloc_export_obj_userdata</a></div><div class="ttdeci">int hwloc_export_obj_userdata(void *reserved, hwloc_topology_t topology, hwloc_obj_t obj, const char *name, const void *buffer, size_t length)</div><div class="ttdoc">Export some object userdata to XML.</div></div>
+<div class="ttc" id="aa00195_html_gad33b7f7c11db10459505a3b1634fd3f1"><div class="ttname"><a href="a00195.html#gad33b7f7c11db10459505a3b1634fd3f1">hwloc_topology_export_xmlbuffer</a></div><div class="ttdeci">int hwloc_topology_export_xmlbuffer(hwloc_topology_t topology, char **xmlbuffer, int *buflen, unsigned long flags)</div><div class="ttdoc">Export the topology into a newly-allocated XML memory buffer.</div></div>
+<div class="ttc" id="aa00195_html_gga0eb99636aff71fe2704e1fa0ffe8c18dae7d6d96546131ef0043867b836b02e0f"><div class="ttname"><a href="a00195.html#gga0eb99636aff71fe2704e1fa0ffe8c18dae7d6d96546131ef0043867b836b02e0f">HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1</div><div class="ttdoc">Export XML that is loadable by hwloc v1.x. However, the export may miss some details about the topolo...</div><div class="ttdef"><b>Definition</b> export.h:40</div></div>
+<div class="ttc" id="aa00196_html_ga24b7864a1c588309c4749f621f03b4c7"><div class="ttname"><a href="a00196.html#ga24b7864a1c588309c4749f621f03b4c7">hwloc_topology_export_synthetic</a></div><div class="ttdeci">int hwloc_topology_export_synthetic(hwloc_topology_t topology, char *buffer, size_t buflen, unsigned long flags)</div><div class="ttdoc">Export the topology as a synthetic string.</div></div>
+<div class="ttc" id="aa00196_html_ga7ac6f97cc40bd50c40285084f869ba63"><div class="ttname"><a href="a00196.html#ga7ac6f97cc40bd50c40285084f869ba63">hwloc_topology_export_synthetic_flags_e</a></div><div class="ttdeci">hwloc_topology_export_synthetic_flags_e</div><div class="ttdoc">Flags for exporting synthetic topologies.</div><div class="ttdef"><b>Definition</b> export.h:217</div></div>
+<div class="ttc" id="aa00196_html_gga7ac6f97cc40bd50c40285084f869ba63a22c57cf18e1da4a6c584fb783b552f9f"><div class="ttname"><a href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a22c57cf18e1da4a6c584fb783b552f9f">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY</div><div class="ttdoc">Do not export memory information.</div><div class="ttdef"><b>Definition</b> export.h:251</div></div>
+<div class="ttc" id="aa00196_html_gga7ac6f97cc40bd50c40285084f869ba63a3b3bd4ba2ef9990810865e561034ccc9"><div class="ttname"><a href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a3b3bd4ba2ef9990810865e561034ccc9">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES</div><div class="ttdoc">Export extended types such as L2dcache as basic types such as Cache.</div><div class="ttdef"><b>Definition</b> export.h:223</div></div>
+<div class="ttc" id="aa00196_html_gga7ac6f97cc40bd50c40285084f869ba63a7896bdf4ccfcdcd09a9f76c0f5e3a5b8"><div class="ttname"><a href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a7896bdf4ccfcdcd09a9f76c0f5e3a5b8">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1</div><div class="ttdoc">Export the memory hierarchy as expected in hwloc 1.x.</div><div class="ttdef"><b>Definition</b> export.h:241</div></div>
+<div class="ttc" id="aa00196_html_gga7ac6f97cc40bd50c40285084f869ba63aaa2702ffba050bab079b3041aec737d4"><div class="ttname"><a href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63aaa2702ffba050bab079b3041aec737d4">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS</div><div class="ttdoc">Do not export level attributes.</div><div class="ttdef"><b>Definition</b> export.h:231</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00116_source.html 2.11.0-1/doc/doxygen-doc/html/a00116_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00116_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00116_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,261 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): distances.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">distances.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2010-2024 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span> </div>
+<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="preprocessor">#ifndef HWLOC_DISTANCES_H</span></div>
+<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="preprocessor">#define HWLOC_DISTANCES_H</span></div>
+<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#ifndef HWLOC_H</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#error Please include the main hwloc.h instead</span></div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span> </div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#elif 0</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>}</div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
+<div class="foldopen" id="foldopen00053" data-start="{" data-end="};">
+<div class="line"><a id="l00053" name="l00053"></a><span class="lineno"><a class="line" href="a00301.html">   53</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00301.html">hwloc_distances_s</a> {</div>
+<div class="line"><a id="l00054" name="l00054"></a><span class="lineno"><a class="line" href="a00301.html#a4ca2af858cebbce7324ec49903d09474">   54</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00301.html#a4ca2af858cebbce7324ec49903d09474">nbobjs</a>;              </div>
+<div class="line"><a id="l00055" name="l00055"></a><span class="lineno"><a class="line" href="a00301.html#af1e78b2d628d191fa6cae3fbfe891078">   55</a></span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> *<a class="code hl_variable" href="a00301.html#af1e78b2d628d191fa6cae3fbfe891078">objs</a>;            </div>
+<div class="line"><a id="l00060" name="l00060"></a><span class="lineno"><a class="line" href="a00301.html#aef9c83cf467da1b1fa4c36493febb3b5">   60</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code hl_variable" href="a00301.html#aef9c83cf467da1b1fa4c36493febb3b5">kind</a>;           </div>
+<div class="line"><a id="l00061" name="l00061"></a><span class="lineno"><a class="line" href="a00301.html#ae43e19b2c743de05c93d71a30beaca75">   61</a></span>  hwloc_uint64_t *<a class="code hl_variable" href="a00301.html#ae43e19b2c743de05c93d71a30beaca75">values</a>;       </div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>};</div>
+</div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span> </div>
+<div class="foldopen" id="foldopen00078" data-start="{" data-end="};">
+<div class="line"><a id="l00078" name="l00078"></a><span class="lineno"><a class="line" href="a00197.html#gab1bb10d3adb85b52cdc6fe5a7f74f108">   78</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00197.html#gab1bb10d3adb85b52cdc6fe5a7f74f108">hwloc_distances_kind_e</a> {</div>
+<div class="line"><a id="l00082" name="l00082"></a><span class="lineno"><a class="line" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a90dc38248c8d5392d4dd3e88f391e984">   82</a></span>  <a class="code hl_enumvalue" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a90dc38248c8d5392d4dd3e88f391e984">HWLOC_DISTANCES_KIND_FROM_OS</a> = (1UL&lt;&lt;0),</div>
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno"><a class="line" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a0148d7f9be833a04f5a55455437c227b">   86</a></span>  <a class="code hl_enumvalue" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a0148d7f9be833a04f5a55455437c227b">HWLOC_DISTANCES_KIND_FROM_USER</a> = (1UL&lt;&lt;1),</div>
+<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span> </div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno"><a class="line" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108afd6a3503fbc8f7c1a31235373cefc4c6">   94</a></span>  <a class="code hl_enumvalue" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108afd6a3503fbc8f7c1a31235373cefc4c6">HWLOC_DISTANCES_KIND_MEANS_LATENCY</a> = (1UL&lt;&lt;2),</div>
+<div class="line"><a id="l00101" name="l00101"></a><span class="lineno"><a class="line" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a41b19f141a3c0ffe85f9affaca4b0293">  101</a></span>  <a class="code hl_enumvalue" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a41b19f141a3c0ffe85f9affaca4b0293">HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH</a> = (1UL&lt;&lt;3),</div>
+<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span> </div>
+<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>  <a class="code hl_enumvalue" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108aa6cf2b6dfcf148b65952f811814efbe1">HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES</a> = (1UL&lt;&lt;4)</div>
+<div class="line"><a id="l00109" name="l00109"></a><span class="lineno"><a class="line" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108aa6cf2b6dfcf148b65952f811814efbe1">  109</a></span>};</div>
+</div>
+<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span> </div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno"><a class="line" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691">  137</a></span><a class="code hl_function" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691">hwloc_distances_get</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>                    <span class="keywordtype">unsigned</span> *nr, <span class="keyword">struct</span> <a class="code hl_struct" href="a00301.html">hwloc_distances_s</a> **distances,</div>
+<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>                    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> kind, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span> </div>
+<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00148" name="l00148"></a><span class="lineno"><a class="line" href="a00197.html#ga5d1d35eccfcc2ebcef71a10972ce9b03">  148</a></span><a class="code hl_function" href="a00197.html#ga5d1d35eccfcc2ebcef71a10972ce9b03">hwloc_distances_get_by_depth</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">int</span> depth,</div>
+<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>                             <span class="keywordtype">unsigned</span> *nr, <span class="keyword">struct</span> <a class="code hl_struct" href="a00301.html">hwloc_distances_s</a> **distances,</div>
+<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>                             <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> kind, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span> </div>
+<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00159" name="l00159"></a><span class="lineno"><a class="line" href="a00197.html#gaaa6bfbc20072a4f4de132eec859067f6">  159</a></span><a class="code hl_function" href="a00197.html#gaaa6bfbc20072a4f4de132eec859067f6">hwloc_distances_get_by_type</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type,</div>
+<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>                            <span class="keywordtype">unsigned</span> *nr, <span class="keyword">struct</span> <a class="code hl_struct" href="a00301.html">hwloc_distances_s</a> **distances,</div>
+<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>                            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> kind, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span> </div>
+<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00174" name="l00174"></a><span class="lineno"><a class="line" href="a00197.html#gaa457f35b8745ca41ec17797c0d7b20f0">  174</a></span><a class="code hl_function" href="a00197.html#gaa457f35b8745ca41ec17797c0d7b20f0">hwloc_distances_get_by_name</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">const</span> <span class="keywordtype">char</span> *name,</div>
+<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>                            <span class="keywordtype">unsigned</span> *nr, <span class="keyword">struct</span> <a class="code hl_struct" href="a00301.html">hwloc_distances_s</a> **distances,</div>
+<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>                            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span> </div>
+<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>HWLOC_DECLSPEC <span class="keyword">const</span> <span class="keywordtype">char</span> *</div>
+<div class="line"><a id="l00189" name="l00189"></a><span class="lineno"><a class="line" href="a00197.html#gaff5366e26178f77d5e8dc3ac8863f2ed">  189</a></span><a class="code hl_function" href="a00197.html#gaff5366e26178f77d5e8dc3ac8863f2ed">hwloc_distances_get_name</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">struct</span> <a class="code hl_struct" href="a00301.html">hwloc_distances_s</a> *distances);</div>
+<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span> </div>
+<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>HWLOC_DECLSPEC <span class="keywordtype">void</span></div>
+<div class="line"><a id="l00196" name="l00196"></a><span class="lineno"><a class="line" href="a00197.html#ga1dd78c1f9acd54f26aba0e284e97e51d">  196</a></span><a class="code hl_function" href="a00197.html#ga1dd78c1f9acd54f26aba0e284e97e51d">hwloc_distances_release</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">struct</span> <a class="code hl_struct" href="a00301.html">hwloc_distances_s</a> *distances);</div>
+<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span> </div>
+<div class="foldopen" id="foldopen00199" data-start="{" data-end="};">
+<div class="line"><a id="l00199" name="l00199"></a><span class="lineno"><a class="line" href="a00197.html#ga42859b651adec5ef0aaacb53ff220b00">  199</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00197.html#ga42859b651adec5ef0aaacb53ff220b00">hwloc_distances_transform_e</a> {</div>
+<div class="line"><a id="l00213" name="l00213"></a><span class="lineno"><a class="line" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a4b7bdb7e3ccca30e03b7ae671e7f6dc1">  213</a></span>  <a class="code hl_enumvalue" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a4b7bdb7e3ccca30e03b7ae671e7f6dc1">HWLOC_DISTANCES_TRANSFORM_REMOVE_NULL</a> = 0,</div>
+<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span> </div>
+<div class="line"><a id="l00227" name="l00227"></a><span class="lineno"><a class="line" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a441e6bb393558319af3bb1f89f51f44d">  227</a></span>  <a class="code hl_enumvalue" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a441e6bb393558319af3bb1f89f51f44d">HWLOC_DISTANCES_TRANSFORM_LINKS</a> = 1,</div>
+<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span> </div>
+<div class="line"><a id="l00236" name="l00236"></a><span class="lineno"><a class="line" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a3d2aaf03e17be54eddbb94aab327fded">  236</a></span>  <a class="code hl_enumvalue" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a3d2aaf03e17be54eddbb94aab327fded">HWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS</a> = 2,</div>
+<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span> </div>
+<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>  <a class="code hl_enumvalue" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a1264abf9b9463f252995f37eb1057047">HWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE</a> = 3</div>
+<div class="line"><a id="l00244" name="l00244"></a><span class="lineno"><a class="line" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a1264abf9b9463f252995f37eb1057047">  244</a></span>};</div>
+</div>
+<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span> </div>
+<div class="line"><a id="l00274" name="l00274"></a><span class="lineno"><a class="line" href="a00197.html#gabcadd041f3072999d68f2d94e38670f7">  274</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00197.html#gabcadd041f3072999d68f2d94e38670f7">hwloc_distances_transform</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">struct</span> <a class="code hl_struct" href="a00301.html">hwloc_distances_s</a> *distances,</div>
+<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span>                                             <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00197.html#ga42859b651adec5ef0aaacb53ff220b00">hwloc_distances_transform_e</a> transform,</div>
+<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span>                                             <span class="keywordtype">void</span> *transform_attr,</div>
+<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span>                                             <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span> </div>
+<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00293" data-start="{" data-end="}">
+<div class="line"><a id="l00293" name="l00293"></a><span class="lineno"><a class="line" href="a00198.html#gab9e770c7d56c5d6040f26bd1dc8854cd">  293</a></span><a class="code hl_function" href="a00198.html#gab9e770c7d56c5d6040f26bd1dc8854cd">hwloc_distances_obj_index</a>(<span class="keyword">struct</span> <a class="code hl_struct" href="a00301.html">hwloc_distances_s</a> *distances, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj)</div>
+<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span>{</div>
+<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span>  <span class="keywordtype">unsigned</span> i;</div>
+<div class="line"><a id="l00296" name="l00296"></a><span class="lineno">  296</span>  <span class="keywordflow">for</span>(i=0; i&lt;distances-&gt;<a class="code hl_variable" href="a00301.html#a4ca2af858cebbce7324ec49903d09474">nbobjs</a>; i++)</div>
+<div class="line"><a id="l00297" name="l00297"></a><span class="lineno">  297</span>    <span class="keywordflow">if</span> (distances-&gt;<a class="code hl_variable" href="a00301.html#af1e78b2d628d191fa6cae3fbfe891078">objs</a>[i] == obj)</div>
+<div class="line"><a id="l00298" name="l00298"></a><span class="lineno">  298</span>      <span class="keywordflow">return</span> (<span class="keywordtype">int</span>)i;</div>
+<div class="line"><a id="l00299" name="l00299"></a><span class="lineno">  299</span>  <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00300" name="l00300"></a><span class="lineno">  300</span>}</div>
+</div>
+<div class="line"><a id="l00301" name="l00301"></a><span class="lineno">  301</span> </div>
+<div class="line"><a id="l00310" name="l00310"></a><span class="lineno">  310</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00311" data-start="{" data-end="}">
+<div class="line"><a id="l00311" name="l00311"></a><span class="lineno"><a class="line" href="a00198.html#ga3c665b23056e3269f777b21a67148c82">  311</a></span><a class="code hl_function" href="a00198.html#ga3c665b23056e3269f777b21a67148c82">hwloc_distances_obj_pair_values</a>(<span class="keyword">struct</span> <a class="code hl_struct" href="a00301.html">hwloc_distances_s</a> *distances,</div>
+<div class="line"><a id="l00312" name="l00312"></a><span class="lineno">  312</span>                                <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj1, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj2,</div>
+<div class="line"><a id="l00313" name="l00313"></a><span class="lineno">  313</span>                                hwloc_uint64_t *value1to2, hwloc_uint64_t *value2to1)</div>
+<div class="line"><a id="l00314" name="l00314"></a><span class="lineno">  314</span>{</div>
+<div class="line"><a id="l00315" name="l00315"></a><span class="lineno">  315</span>  <span class="keywordtype">int</span> i1 = <a class="code hl_function" href="a00198.html#gab9e770c7d56c5d6040f26bd1dc8854cd">hwloc_distances_obj_index</a>(distances, obj1);</div>
+<div class="line"><a id="l00316" name="l00316"></a><span class="lineno">  316</span>  <span class="keywordtype">int</span> i2 = <a class="code hl_function" href="a00198.html#gab9e770c7d56c5d6040f26bd1dc8854cd">hwloc_distances_obj_index</a>(distances, obj2);</div>
+<div class="line"><a id="l00317" name="l00317"></a><span class="lineno">  317</span>  <span class="keywordflow">if</span> (i1 &lt; 0 || i2 &lt; 0)</div>
+<div class="line"><a id="l00318" name="l00318"></a><span class="lineno">  318</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00319" name="l00319"></a><span class="lineno">  319</span>  *value1to2 = distances-&gt;<a class="code hl_variable" href="a00301.html#ae43e19b2c743de05c93d71a30beaca75">values</a>[i1 * distances-&gt;<a class="code hl_variable" href="a00301.html#a4ca2af858cebbce7324ec49903d09474">nbobjs</a> + i2];</div>
+<div class="line"><a id="l00320" name="l00320"></a><span class="lineno">  320</span>  *value2to1 = distances-&gt;<a class="code hl_variable" href="a00301.html#ae43e19b2c743de05c93d71a30beaca75">values</a>[i2 * distances-&gt;<a class="code hl_variable" href="a00301.html#a4ca2af858cebbce7324ec49903d09474">nbobjs</a> + i1];</div>
+<div class="line"><a id="l00321" name="l00321"></a><span class="lineno">  321</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00322" name="l00322"></a><span class="lineno">  322</span>}</div>
+</div>
+<div class="line"><a id="l00323" name="l00323"></a><span class="lineno">  323</span> </div>
+<div class="line"><a id="l00347" name="l00347"></a><span class="lineno"><a class="line" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">  347</a></span><span class="keyword">typedef</span> <span class="keywordtype">void</span> * <a class="code hl_typedef" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a>;</div>
+<div class="line"><a id="l00348" name="l00348"></a><span class="lineno">  348</span> </div>
+<div class="line"><a id="l00371" name="l00371"></a><span class="lineno">  371</span>HWLOC_DECLSPEC <a class="code hl_typedef" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a></div>
+<div class="line"><a id="l00372" name="l00372"></a><span class="lineno"><a class="line" href="a00199.html#ga823d38fa8d21dc338497fb0f79c96704">  372</a></span><a class="code hl_function" href="a00199.html#ga823d38fa8d21dc338497fb0f79c96704">hwloc_distances_add_create</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00373" name="l00373"></a><span class="lineno">  373</span>                           <span class="keyword">const</span> <span class="keywordtype">char</span> *name, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> kind,</div>
+<div class="line"><a id="l00374" name="l00374"></a><span class="lineno">  374</span>                           <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00375" name="l00375"></a><span class="lineno">  375</span> </div>
+<div class="line"><a id="l00398" name="l00398"></a><span class="lineno"><a class="line" href="a00199.html#ga8c9715481b0bce344c8a33c6e6a56469">  398</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00199.html#ga8c9715481b0bce344c8a33c6e6a56469">hwloc_distances_add_values</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00399" name="l00399"></a><span class="lineno">  399</span>                                              <a class="code hl_typedef" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a> handle,</div>
+<div class="line"><a id="l00400" name="l00400"></a><span class="lineno">  400</span>                                              <span class="keywordtype">unsigned</span> nbobjs, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> *objs,</div>
+<div class="line"><a id="l00401" name="l00401"></a><span class="lineno">  401</span>                                              hwloc_uint64_t *values,</div>
+<div class="line"><a id="l00402" name="l00402"></a><span class="lineno">  402</span>                                              <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00403" name="l00403"></a><span class="lineno">  403</span> </div>
+<div class="foldopen" id="foldopen00405" data-start="{" data-end="};">
+<div class="line"><a id="l00405" name="l00405"></a><span class="lineno"><a class="line" href="a00199.html#ga22428b6bab271411e3834e6b4ca22e37">  405</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00199.html#ga22428b6bab271411e3834e6b4ca22e37">hwloc_distances_add_flag_e</a> {</div>
+<div class="line"><a id="l00411" name="l00411"></a><span class="lineno"><a class="line" href="a00199.html#gga22428b6bab271411e3834e6b4ca22e37a7f6baba797d70538d03c9d13052c62ab">  411</a></span>  <a class="code hl_enumvalue" href="a00199.html#gga22428b6bab271411e3834e6b4ca22e37a7f6baba797d70538d03c9d13052c62ab">HWLOC_DISTANCES_ADD_FLAG_GROUP</a> = (1UL&lt;&lt;0),</div>
+<div class="line"><a id="l00417" name="l00417"></a><span class="lineno">  417</span>  <a class="code hl_enumvalue" href="a00199.html#gga22428b6bab271411e3834e6b4ca22e37a5233ccf631c3bc53dd5c3e7a5d5c9b77">HWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE</a> = (1UL&lt;&lt;1)</div>
+<div class="line"><a id="l00418" name="l00418"></a><span class="lineno"><a class="line" href="a00199.html#gga22428b6bab271411e3834e6b4ca22e37a5233ccf631c3bc53dd5c3e7a5d5c9b77">  418</a></span>};</div>
+</div>
+<div class="line"><a id="l00419" name="l00419"></a><span class="lineno">  419</span> </div>
+<div class="line"><a id="l00436" name="l00436"></a><span class="lineno"><a class="line" href="a00199.html#ga1f5a29760ebb8f9af831e645315f553c">  436</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00199.html#ga1f5a29760ebb8f9af831e645315f553c">hwloc_distances_add_commit</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00437" name="l00437"></a><span class="lineno">  437</span>                                              <a class="code hl_typedef" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a> handle,</div>
+<div class="line"><a id="l00438" name="l00438"></a><span class="lineno">  438</span>                                              <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00439" name="l00439"></a><span class="lineno">  439</span> </div>
+<div class="line"><a id="l00458" name="l00458"></a><span class="lineno"><a class="line" href="a00200.html#gac188d9b64d9560255ce5f6d0a20f9c0a">  458</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00200.html#gac188d9b64d9560255ce5f6d0a20f9c0a">hwloc_distances_remove</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology);</div>
+<div class="line"><a id="l00459" name="l00459"></a><span class="lineno">  459</span> </div>
+<div class="line"><a id="l00466" name="l00466"></a><span class="lineno"><a class="line" href="a00200.html#gaa642a4c1a21c84f38ae23fca8a27845d">  466</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00200.html#gaa642a4c1a21c84f38ae23fca8a27845d">hwloc_distances_remove_by_depth</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">int</span> depth);</div>
+<div class="line"><a id="l00467" name="l00467"></a><span class="lineno">  467</span> </div>
+<div class="line"><a id="l00474" name="l00474"></a><span class="lineno">  474</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00475" data-start="{" data-end="}">
+<div class="line"><a id="l00475" name="l00475"></a><span class="lineno"><a class="line" href="a00200.html#ga93db53773c96f5b83815e8441e2ebb93">  475</a></span><a class="code hl_function" href="a00200.html#ga93db53773c96f5b83815e8441e2ebb93">hwloc_distances_remove_by_type</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</div>
+<div class="line"><a id="l00476" name="l00476"></a><span class="lineno">  476</span>{</div>
+<div class="line"><a id="l00477" name="l00477"></a><span class="lineno">  477</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, type);</div>
+<div class="line"><a id="l00478" name="l00478"></a><span class="lineno">  478</span>  <span class="keywordflow">if</span> (depth == <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a> || depth == <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">HWLOC_TYPE_DEPTH_MULTIPLE</a>)</div>
+<div class="line"><a id="l00479" name="l00479"></a><span class="lineno">  479</span>    <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00480" name="l00480"></a><span class="lineno">  480</span>  <span class="keywordflow">return</span> <a class="code hl_function" href="a00200.html#gaa642a4c1a21c84f38ae23fca8a27845d">hwloc_distances_remove_by_depth</a>(topology, depth);</div>
+<div class="line"><a id="l00481" name="l00481"></a><span class="lineno">  481</span>}</div>
+</div>
+<div class="line"><a id="l00482" name="l00482"></a><span class="lineno">  482</span> </div>
+<div class="line"><a id="l00489" name="l00489"></a><span class="lineno"><a class="line" href="a00200.html#ga80bbf6f0db9af48c61780dd5152664c2">  489</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00200.html#ga80bbf6f0db9af48c61780dd5152664c2">hwloc_distances_release_remove</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keyword">struct</span> <a class="code hl_struct" href="a00301.html">hwloc_distances_s</a> *distances);</div>
+<div class="line"><a id="l00490" name="l00490"></a><span class="lineno">  490</span> </div>
+<div class="line"><a id="l00494" name="l00494"></a><span class="lineno">  494</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00495" name="l00495"></a><span class="lineno">  495</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00496" name="l00496"></a><span class="lineno">  496</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00497" name="l00497"></a><span class="lineno">  497</span> </div>
+<div class="line"><a id="l00498" name="l00498"></a><span class="lineno">  498</span> </div>
+<div class="line"><a id="l00499" name="l00499"></a><span class="lineno">  499</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_DISTANCES_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00173_html_gacd37bb612667dc437d66bfb175a8dc55"><div class="ttname"><a href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a></div><div class="ttdeci">hwloc_obj_type_t</div><div class="ttdoc">Type of topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:197</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00176_html_ga8bec782e21be313750da70cf7428b374"><div class="ttname"><a href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a></div><div class="ttdeci">int hwloc_get_type_depth(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Returns the depth of objects of type type.</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_UNKNOWN</div><div class="ttdoc">No object of given type exists in the topology.</div><div class="ttdef"><b>Definition</b> hwloc.h:879</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">HWLOC_TYPE_DEPTH_MULTIPLE</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_MULTIPLE</div><div class="ttdoc">Objects of given type exist at different depth in the topology (only for Groups).</div><div class="ttdef"><b>Definition</b> hwloc.h:880</div></div>
+<div class="ttc" id="aa00197_html_ga1dd78c1f9acd54f26aba0e284e97e51d"><div class="ttname"><a href="a00197.html#ga1dd78c1f9acd54f26aba0e284e97e51d">hwloc_distances_release</a></div><div class="ttdeci">void hwloc_distances_release(hwloc_topology_t topology, struct hwloc_distances_s *distances)</div><div class="ttdoc">Release a distance matrix structure previously returned by hwloc_distances_get().</div></div>
+<div class="ttc" id="aa00197_html_ga42859b651adec5ef0aaacb53ff220b00"><div class="ttname"><a href="a00197.html#ga42859b651adec5ef0aaacb53ff220b00">hwloc_distances_transform_e</a></div><div class="ttdeci">hwloc_distances_transform_e</div><div class="ttdoc">Transformations of distances structures.</div><div class="ttdef"><b>Definition</b> distances.h:199</div></div>
+<div class="ttc" id="aa00197_html_ga5d1d35eccfcc2ebcef71a10972ce9b03"><div class="ttname"><a href="a00197.html#ga5d1d35eccfcc2ebcef71a10972ce9b03">hwloc_distances_get_by_depth</a></div><div class="ttdeci">int hwloc_distances_get_by_depth(hwloc_topology_t topology, int depth, unsigned *nr, struct hwloc_distances_s **distances, unsigned long kind, unsigned long flags)</div><div class="ttdoc">Retrieve distance matrices for object at a specific depth in the topology.</div></div>
+<div class="ttc" id="aa00197_html_ga613e6b2a5d0f06626ee8d0c12fa46691"><div class="ttname"><a href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691">hwloc_distances_get</a></div><div class="ttdeci">int hwloc_distances_get(hwloc_topology_t topology, unsigned *nr, struct hwloc_distances_s **distances, unsigned long kind, unsigned long flags)</div><div class="ttdoc">Retrieve distance matrices.</div></div>
+<div class="ttc" id="aa00197_html_gaa457f35b8745ca41ec17797c0d7b20f0"><div class="ttname"><a href="a00197.html#gaa457f35b8745ca41ec17797c0d7b20f0">hwloc_distances_get_by_name</a></div><div class="ttdeci">int hwloc_distances_get_by_name(hwloc_topology_t topology, const char *name, unsigned *nr, struct hwloc_distances_s **distances, unsigned long flags)</div><div class="ttdoc">Retrieve a distance matrix with the given name.</div></div>
+<div class="ttc" id="aa00197_html_gaaa6bfbc20072a4f4de132eec859067f6"><div class="ttname"><a href="a00197.html#gaaa6bfbc20072a4f4de132eec859067f6">hwloc_distances_get_by_type</a></div><div class="ttdeci">int hwloc_distances_get_by_type(hwloc_topology_t topology, hwloc_obj_type_t type, unsigned *nr, struct hwloc_distances_s **distances, unsigned long kind, unsigned long flags)</div><div class="ttdoc">Retrieve distance matrices for object of a specific type.</div></div>
+<div class="ttc" id="aa00197_html_gab1bb10d3adb85b52cdc6fe5a7f74f108"><div class="ttname"><a href="a00197.html#gab1bb10d3adb85b52cdc6fe5a7f74f108">hwloc_distances_kind_e</a></div><div class="ttdeci">hwloc_distances_kind_e</div><div class="ttdoc">Kinds of distance matrices.</div><div class="ttdef"><b>Definition</b> distances.h:78</div></div>
+<div class="ttc" id="aa00197_html_gabcadd041f3072999d68f2d94e38670f7"><div class="ttname"><a href="a00197.html#gabcadd041f3072999d68f2d94e38670f7">hwloc_distances_transform</a></div><div class="ttdeci">int hwloc_distances_transform(hwloc_topology_t topology, struct hwloc_distances_s *distances, enum hwloc_distances_transform_e transform, void *transform_attr, unsigned long flags)</div><div class="ttdoc">Apply a transformation to a distances structure.</div></div>
+<div class="ttc" id="aa00197_html_gaff5366e26178f77d5e8dc3ac8863f2ed"><div class="ttname"><a href="a00197.html#gaff5366e26178f77d5e8dc3ac8863f2ed">hwloc_distances_get_name</a></div><div class="ttdeci">const char * hwloc_distances_get_name(hwloc_topology_t topology, struct hwloc_distances_s *distances)</div><div class="ttdoc">Get a description of what a distances structure contains.</div></div>
+<div class="ttc" id="aa00197_html_gga42859b651adec5ef0aaacb53ff220b00a1264abf9b9463f252995f37eb1057047"><div class="ttname"><a href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a1264abf9b9463f252995f37eb1057047">HWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE</a></div><div class="ttdeci">@ HWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE</div><div class="ttdoc">Apply a transitive closure to the matrix to connect objects across switches. This currently only appl...</div><div class="ttdef"><b>Definition</b> distances.h:243</div></div>
+<div class="ttc" id="aa00197_html_gga42859b651adec5ef0aaacb53ff220b00a3d2aaf03e17be54eddbb94aab327fded"><div class="ttname"><a href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a3d2aaf03e17be54eddbb94aab327fded">HWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS</a></div><div class="ttdeci">@ HWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS</div><div class="ttdoc">Merge switches with multiple ports into a single object. This currently only applies to NVSwitches wh...</div><div class="ttdef"><b>Definition</b> distances.h:236</div></div>
+<div class="ttc" id="aa00197_html_gga42859b651adec5ef0aaacb53ff220b00a441e6bb393558319af3bb1f89f51f44d"><div class="ttname"><a href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a441e6bb393558319af3bb1f89f51f44d">HWLOC_DISTANCES_TRANSFORM_LINKS</a></div><div class="ttdeci">@ HWLOC_DISTANCES_TRANSFORM_LINKS</div><div class="ttdoc">Replace bandwidth values with a number of links.</div><div class="ttdef"><b>Definition</b> distances.h:227</div></div>
+<div class="ttc" id="aa00197_html_gga42859b651adec5ef0aaacb53ff220b00a4b7bdb7e3ccca30e03b7ae671e7f6dc1"><div class="ttname"><a href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a4b7bdb7e3ccca30e03b7ae671e7f6dc1">HWLOC_DISTANCES_TRANSFORM_REMOVE_NULL</a></div><div class="ttdeci">@ HWLOC_DISTANCES_TRANSFORM_REMOVE_NULL</div><div class="ttdoc">Remove NULL objects from the distances structure.</div><div class="ttdef"><b>Definition</b> distances.h:213</div></div>
+<div class="ttc" id="aa00197_html_ggab1bb10d3adb85b52cdc6fe5a7f74f108a0148d7f9be833a04f5a55455437c227b"><div class="ttname"><a href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a0148d7f9be833a04f5a55455437c227b">HWLOC_DISTANCES_KIND_FROM_USER</a></div><div class="ttdeci">@ HWLOC_DISTANCES_KIND_FROM_USER</div><div class="ttdoc">These distances were provided by the user.</div><div class="ttdef"><b>Definition</b> distances.h:86</div></div>
+<div class="ttc" id="aa00197_html_ggab1bb10d3adb85b52cdc6fe5a7f74f108a41b19f141a3c0ffe85f9affaca4b0293"><div class="ttname"><a href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a41b19f141a3c0ffe85f9affaca4b0293">HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH</a></div><div class="ttdeci">@ HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH</div><div class="ttdoc">Distance values are similar to bandwidths between objects. Values are higher for closer objects,...</div><div class="ttdef"><b>Definition</b> distances.h:101</div></div>
+<div class="ttc" id="aa00197_html_ggab1bb10d3adb85b52cdc6fe5a7f74f108a90dc38248c8d5392d4dd3e88f391e984"><div class="ttname"><a href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a90dc38248c8d5392d4dd3e88f391e984">HWLOC_DISTANCES_KIND_FROM_OS</a></div><div class="ttdeci">@ HWLOC_DISTANCES_KIND_FROM_OS</div><div class="ttdoc">These distances were obtained from the operating system or hardware.</div><div class="ttdef"><b>Definition</b> distances.h:82</div></div>
+<div class="ttc" id="aa00197_html_ggab1bb10d3adb85b52cdc6fe5a7f74f108aa6cf2b6dfcf148b65952f811814efbe1"><div class="ttname"><a href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108aa6cf2b6dfcf148b65952f811814efbe1">HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES</a></div><div class="ttdeci">@ HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES</div><div class="ttdoc">This distances structure covers objects of different types. This may apply to the &quot;NVLinkBandwidth&quot; s...</div><div class="ttdef"><b>Definition</b> distances.h:108</div></div>
+<div class="ttc" id="aa00197_html_ggab1bb10d3adb85b52cdc6fe5a7f74f108afd6a3503fbc8f7c1a31235373cefc4c6"><div class="ttname"><a href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108afd6a3503fbc8f7c1a31235373cefc4c6">HWLOC_DISTANCES_KIND_MEANS_LATENCY</a></div><div class="ttdeci">@ HWLOC_DISTANCES_KIND_MEANS_LATENCY</div><div class="ttdoc">Distance values are similar to latencies between objects. Values are smaller for closer objects,...</div><div class="ttdef"><b>Definition</b> distances.h:94</div></div>
+<div class="ttc" id="aa00198_html_ga3c665b23056e3269f777b21a67148c82"><div class="ttname"><a href="a00198.html#ga3c665b23056e3269f777b21a67148c82">hwloc_distances_obj_pair_values</a></div><div class="ttdeci">static int hwloc_distances_obj_pair_values(struct hwloc_distances_s *distances, hwloc_obj_t obj1, hwloc_obj_t obj2, hwloc_uint64_t *value1to2, hwloc_uint64_t *value2to1)</div><div class="ttdoc">Find the values between two objects in a distance matrices.</div><div class="ttdef"><b>Definition</b> distances.h:311</div></div>
+<div class="ttc" id="aa00198_html_gab9e770c7d56c5d6040f26bd1dc8854cd"><div class="ttname"><a href="a00198.html#gab9e770c7d56c5d6040f26bd1dc8854cd">hwloc_distances_obj_index</a></div><div class="ttdeci">static int hwloc_distances_obj_index(struct hwloc_distances_s *distances, hwloc_obj_t obj)</div><div class="ttdoc">Find the index of an object in a distances structure.</div><div class="ttdef"><b>Definition</b> distances.h:293</div></div>
+<div class="ttc" id="aa00199_html_ga1f5a29760ebb8f9af831e645315f553c"><div class="ttname"><a href="a00199.html#ga1f5a29760ebb8f9af831e645315f553c">hwloc_distances_add_commit</a></div><div class="ttdeci">int hwloc_distances_add_commit(hwloc_topology_t topology, hwloc_distances_add_handle_t handle, unsigned long flags)</div><div class="ttdoc">Commit a new distances structure.</div></div>
+<div class="ttc" id="aa00199_html_ga22428b6bab271411e3834e6b4ca22e37"><div class="ttname"><a href="a00199.html#ga22428b6bab271411e3834e6b4ca22e37">hwloc_distances_add_flag_e</a></div><div class="ttdeci">hwloc_distances_add_flag_e</div><div class="ttdoc">Flags for adding a new distances to a topology.</div><div class="ttdef"><b>Definition</b> distances.h:405</div></div>
+<div class="ttc" id="aa00199_html_ga554a4c1e315265f961830e2b616e4989"><div class="ttname"><a href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a></div><div class="ttdeci">void * hwloc_distances_add_handle_t</div><div class="ttdoc">Handle to a new distances structure during its addition to the topology.</div><div class="ttdef"><b>Definition</b> distances.h:347</div></div>
+<div class="ttc" id="aa00199_html_ga823d38fa8d21dc338497fb0f79c96704"><div class="ttname"><a href="a00199.html#ga823d38fa8d21dc338497fb0f79c96704">hwloc_distances_add_create</a></div><div class="ttdeci">hwloc_distances_add_handle_t hwloc_distances_add_create(hwloc_topology_t topology, const char *name, unsigned long kind, unsigned long flags)</div><div class="ttdoc">Create a new empty distances structure.</div></div>
+<div class="ttc" id="aa00199_html_ga8c9715481b0bce344c8a33c6e6a56469"><div class="ttname"><a href="a00199.html#ga8c9715481b0bce344c8a33c6e6a56469">hwloc_distances_add_values</a></div><div class="ttdeci">int hwloc_distances_add_values(hwloc_topology_t topology, hwloc_distances_add_handle_t handle, unsigned nbobjs, hwloc_obj_t *objs, hwloc_uint64_t *values, unsigned long flags)</div><div class="ttdoc">Specify the objects and values in a new empty distances structure.</div></div>
+<div class="ttc" id="aa00199_html_gga22428b6bab271411e3834e6b4ca22e37a5233ccf631c3bc53dd5c3e7a5d5c9b77"><div class="ttname"><a href="a00199.html#gga22428b6bab271411e3834e6b4ca22e37a5233ccf631c3bc53dd5c3e7a5d5c9b77">HWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE</a></div><div class="ttdeci">@ HWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE</div><div class="ttdoc">If grouping, consider the distance values as inaccurate and relax the comparisons during the grouping...</div><div class="ttdef"><b>Definition</b> distances.h:417</div></div>
+<div class="ttc" id="aa00199_html_gga22428b6bab271411e3834e6b4ca22e37a7f6baba797d70538d03c9d13052c62ab"><div class="ttname"><a href="a00199.html#gga22428b6bab271411e3834e6b4ca22e37a7f6baba797d70538d03c9d13052c62ab">HWLOC_DISTANCES_ADD_FLAG_GROUP</a></div><div class="ttdeci">@ HWLOC_DISTANCES_ADD_FLAG_GROUP</div><div class="ttdoc">Try to group objects based on the newly provided distance information. Grouping is only performed whe...</div><div class="ttdef"><b>Definition</b> distances.h:411</div></div>
+<div class="ttc" id="aa00200_html_ga80bbf6f0db9af48c61780dd5152664c2"><div class="ttname"><a href="a00200.html#ga80bbf6f0db9af48c61780dd5152664c2">hwloc_distances_release_remove</a></div><div class="ttdeci">int hwloc_distances_release_remove(hwloc_topology_t topology, struct hwloc_distances_s *distances)</div><div class="ttdoc">Release and remove the given distance matrice from the topology.</div></div>
+<div class="ttc" id="aa00200_html_ga93db53773c96f5b83815e8441e2ebb93"><div class="ttname"><a href="a00200.html#ga93db53773c96f5b83815e8441e2ebb93">hwloc_distances_remove_by_type</a></div><div class="ttdeci">static int hwloc_distances_remove_by_type(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Remove distance matrices for objects of a specific type in the topology.</div><div class="ttdef"><b>Definition</b> distances.h:475</div></div>
+<div class="ttc" id="aa00200_html_gaa642a4c1a21c84f38ae23fca8a27845d"><div class="ttname"><a href="a00200.html#gaa642a4c1a21c84f38ae23fca8a27845d">hwloc_distances_remove_by_depth</a></div><div class="ttdeci">int hwloc_distances_remove_by_depth(hwloc_topology_t topology, int depth)</div><div class="ttdoc">Remove distance matrices for objects at a specific depth in the topology.</div></div>
+<div class="ttc" id="aa00200_html_gac188d9b64d9560255ce5f6d0a20f9c0a"><div class="ttname"><a href="a00200.html#gac188d9b64d9560255ce5f6d0a20f9c0a">hwloc_distances_remove</a></div><div class="ttdeci">int hwloc_distances_remove(hwloc_topology_t topology)</div><div class="ttdoc">Remove all distance matrices from a topology.</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00301_html"><div class="ttname"><a href="a00301.html">hwloc_distances_s</a></div><div class="ttdoc">Matrix of distances between a set of objects.</div><div class="ttdef"><b>Definition</b> distances.h:53</div></div>
+<div class="ttc" id="aa00301_html_a4ca2af858cebbce7324ec49903d09474"><div class="ttname"><a href="a00301.html#a4ca2af858cebbce7324ec49903d09474">hwloc_distances_s::nbobjs</a></div><div class="ttdeci">unsigned nbobjs</div><div class="ttdoc">Number of objects described by the distance matrix.</div><div class="ttdef"><b>Definition</b> distances.h:54</div></div>
+<div class="ttc" id="aa00301_html_ae43e19b2c743de05c93d71a30beaca75"><div class="ttname"><a href="a00301.html#ae43e19b2c743de05c93d71a30beaca75">hwloc_distances_s::values</a></div><div class="ttdeci">hwloc_uint64_t * values</div><div class="ttdoc">Matrix of distances between objects, stored as a one-dimension array.</div><div class="ttdef"><b>Definition</b> distances.h:61</div></div>
+<div class="ttc" id="aa00301_html_aef9c83cf467da1b1fa4c36493febb3b5"><div class="ttname"><a href="a00301.html#aef9c83cf467da1b1fa4c36493febb3b5">hwloc_distances_s::kind</a></div><div class="ttdeci">unsigned long kind</div><div class="ttdoc">OR'ed set of hwloc_distances_kind_e.</div><div class="ttdef"><b>Definition</b> distances.h:60</div></div>
+<div class="ttc" id="aa00301_html_af1e78b2d628d191fa6cae3fbfe891078"><div class="ttname"><a href="a00301.html#af1e78b2d628d191fa6cae3fbfe891078">hwloc_distances_s::objs</a></div><div class="ttdeci">hwloc_obj_t * objs</div><div class="ttdoc">Array of objects described by the distance matrix. These objects are not in any particular order,...</div><div class="ttdef"><b>Definition</b> distances.h:55</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00119_source.html 2.11.0-1/doc/doxygen-doc/html/a00119_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00119_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00119_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,261 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): memattrs.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">memattrs.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2019-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span> </div>
+<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="preprocessor">#ifndef HWLOC_MEMATTR_H</span></div>
+<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="preprocessor">#define HWLOC_MEMATTR_H</span></div>
+<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span> </div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#elif 0</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>}</div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
+<div class="foldopen" id="foldopen00073" data-start="{" data-end="};">
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno"><a class="line" href="a00201.html#gab4bde745db676fc2ea4b47011cd9a80e">   73</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00201.html#gab4bde745db676fc2ea4b47011cd9a80e">hwloc_memattr_id_e</a> {</div>
+<div class="line"><a id="l00083" name="l00083"></a><span class="lineno"><a class="line" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eaa1cfa3ff3d56ff00ecabf7da4f5642cc">   83</a></span>  <a class="code hl_enumvalue" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eaa1cfa3ff3d56ff00ecabf7da4f5642cc">HWLOC_MEMATTR_ID_CAPACITY</a> = 0,</div>
+<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span> </div>
+<div class="line"><a id="l00098" name="l00098"></a><span class="lineno"><a class="line" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea9334e3a4c30a67f491c6523255134efe">   98</a></span>  <a class="code hl_enumvalue" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea9334e3a4c30a67f491c6523255134efe">HWLOC_MEMATTR_ID_LOCALITY</a> = 1,</div>
+<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span> </div>
+<div class="line"><a id="l00113" name="l00113"></a><span class="lineno"><a class="line" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea25fe3c7376ae6f9b584bacdb039f8c0f">  113</a></span>  <a class="code hl_enumvalue" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea25fe3c7376ae6f9b584bacdb039f8c0f">HWLOC_MEMATTR_ID_BANDWIDTH</a> = 2,</div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span> </div>
+<div class="line"><a id="l00124" name="l00124"></a><span class="lineno"><a class="line" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eac34dce925d3dadb7e255391d142b4828">  124</a></span>  <a class="code hl_enumvalue" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eac34dce925d3dadb7e255391d142b4828">HWLOC_MEMATTR_ID_READ_BANDWIDTH</a> = 4,</div>
+<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span> </div>
+<div class="line"><a id="l00135" name="l00135"></a><span class="lineno"><a class="line" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea44762e8ebe327cfe665cccf1f58f7530">  135</a></span>  <a class="code hl_enumvalue" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea44762e8ebe327cfe665cccf1f58f7530">HWLOC_MEMATTR_ID_WRITE_BANDWIDTH</a> = 5,</div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span> </div>
+<div class="line"><a id="l00150" name="l00150"></a><span class="lineno"><a class="line" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ead1796413759b8b87b61ad195a9349b19">  150</a></span>  <a class="code hl_enumvalue" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ead1796413759b8b87b61ad195a9349b19">HWLOC_MEMATTR_ID_LATENCY</a> = 3,</div>
+<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span> </div>
+<div class="line"><a id="l00161" name="l00161"></a><span class="lineno"><a class="line" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea52cab56571c7fafea42a694d80ad3dd0">  161</a></span>  <a class="code hl_enumvalue" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea52cab56571c7fafea42a694d80ad3dd0">HWLOC_MEMATTR_ID_READ_LATENCY</a> = 6,</div>
+<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span> </div>
+<div class="line"><a id="l00172" name="l00172"></a><span class="lineno"><a class="line" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eaaf6cd383da87dc9f5e3a608a535a768e">  172</a></span>  <a class="code hl_enumvalue" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eaaf6cd383da87dc9f5e3a608a535a768e">HWLOC_MEMATTR_ID_WRITE_LATENCY</a> = 7,</div>
+<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span> </div>
+<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>  <span class="comment">/* TODO persistence? */</span></div>
+<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span> </div>
+<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>  HWLOC_MEMATTR_ID_MAX </div>
+<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>};</div>
+</div>
+<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span> </div>
+<div class="line"><a id="l00182" name="l00182"></a><span class="lineno"><a class="line" href="a00201.html#gacc82003a8610be554615995f0996c888">  182</a></span><span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <a class="code hl_typedef" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a>;</div>
+<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span> </div>
+<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00190" name="l00190"></a><span class="lineno"><a class="line" href="a00201.html#ga79f44f8e1cfd2f97a19171417a75a137">  190</a></span><a class="code hl_function" href="a00201.html#ga79f44f8e1cfd2f97a19171417a75a137">hwloc_memattr_get_by_name</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>                          <span class="keyword">const</span> <span class="keywordtype">char</span> *name,</div>
+<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span>                          <a class="code hl_typedef" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> *<span class="keywordtype">id</span>);</div>
+<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span> </div>
+<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span> </div>
+<div class="foldopen" id="foldopen00196" data-start="{" data-end="};">
+<div class="line"><a id="l00196" name="l00196"></a><span class="lineno"><a class="line" href="a00201.html#ga33099ba58f607fc70925da3777688586">  196</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00201.html#ga33099ba58f607fc70925da3777688586">hwloc_location_type_e</a> {</div>
+<div class="line"><a id="l00198" name="l00198"></a><span class="lineno"><a class="line" href="a00201.html#gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174">  198</a></span>  <a class="code hl_enumvalue" href="a00201.html#gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174">HWLOC_LOCATION_TYPE_CPUSET</a> = 1,</div>
+<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>  <a class="code hl_enumvalue" href="a00201.html#gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84">HWLOC_LOCATION_TYPE_OBJECT</a> = 0</div>
+<div class="line"><a id="l00201" name="l00201"></a><span class="lineno"><a class="line" href="a00201.html#gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84">  201</a></span>};</div>
+</div>
+<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span> </div>
+<div class="foldopen" id="foldopen00204" data-start="{" data-end="};">
+<div class="line"><a id="l00204" name="l00204"></a><span class="lineno"><a class="line" href="a00305.html">  204</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00305.html">hwloc_location</a> {</div>
+<div class="line"><a id="l00206" name="l00206"></a><span class="lineno"><a class="line" href="a00305.html#aeb9c0ab74a7d3506a76d0b82600a28a7">  206</a></span>  <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00201.html#ga33099ba58f607fc70925da3777688586">hwloc_location_type_e</a> <a class="code hl_variable" href="a00305.html#aeb9c0ab74a7d3506a76d0b82600a28a7">type</a>;</div>
+<div class="foldopen" id="foldopen00208" data-start="{" data-end="};">
+<div class="line"><a id="l00208" name="l00208"></a><span class="lineno"><a class="line" href="a00309.html">  208</a></span>  <span class="keyword">union </span><a class="code hl_union" href="a00309.html">hwloc_location_u</a> {</div>
+<div class="line"><a id="l00210" name="l00210"></a><span class="lineno"><a class="line" href="a00309.html#a033bad8f6b891992f0c18b85a88c5561">  210</a></span>    <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> <a class="code hl_variable" href="a00309.html#a033bad8f6b891992f0c18b85a88c5561">cpuset</a>;</div>
+<div class="line"><a id="l00212" name="l00212"></a><span class="lineno"><a class="line" href="a00309.html#acf2ebf75869f0a53a884ac2ab3374122">  212</a></span>    <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> <a class="code hl_variable" href="a00309.html#acf2ebf75869f0a53a884ac2ab3374122">object</a>;</div>
+<div class="line"><a id="l00213" name="l00213"></a><span class="lineno"><a class="line" href="a00305.html#a707a25a5b65177e4d081be49aa0777a2">  213</a></span>  } <a class="code hl_variable" href="a00305.html#a707a25a5b65177e4d081be49aa0777a2">location</a>;</div>
+</div>
+<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>};</div>
+</div>
+<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span> </div>
+<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span> </div>
+<div class="foldopen" id="foldopen00218" data-start="{" data-end="};">
+<div class="line"><a id="l00218" name="l00218"></a><span class="lineno"><a class="line" href="a00201.html#gab9c963ca37255da71b00d94e1b106f9d">  218</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00201.html#gab9c963ca37255da71b00d94e1b106f9d">hwloc_local_numanode_flag_e</a> {</div>
+<div class="line"><a id="l00224" name="l00224"></a><span class="lineno"><a class="line" href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9da200c6c133bb2125ba36d77ce9ca268cc">  224</a></span>  <a class="code hl_enumvalue" href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9da200c6c133bb2125ba36d77ce9ca268cc">HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY</a> = (1UL&lt;&lt;0),</div>
+<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span> </div>
+<div class="line"><a id="l00231" name="l00231"></a><span class="lineno"><a class="line" href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9daac9c5e3a2cfb1b193e4acfceaf3bad57">  231</a></span>  <a class="code hl_enumvalue" href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9daac9c5e3a2cfb1b193e4acfceaf3bad57">HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY</a> = (1UL&lt;&lt;1),</div>
+<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span> </div>
+<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>  <a class="code hl_enumvalue" href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9dab5778b34c961a5d56f98f1549edeaed0">HWLOC_LOCAL_NUMANODE_FLAG_ALL</a> = (1UL&lt;&lt;2)</div>
+<div class="line"><a id="l00238" name="l00238"></a><span class="lineno"><a class="line" href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9dab5778b34c961a5d56f98f1549edeaed0">  238</a></span>};</div>
+</div>
+<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span> </div>
+<div class="line"><a id="l00271" name="l00271"></a><span class="lineno">  271</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00272" name="l00272"></a><span class="lineno"><a class="line" href="a00201.html#ga569e80c5be7ef27649b0ef5aa52ffcdc">  272</a></span><a class="code hl_function" href="a00201.html#ga569e80c5be7ef27649b0ef5aa52ffcdc">hwloc_get_local_numanode_objs</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>                              <span class="keyword">struct</span> <a class="code hl_struct" href="a00305.html">hwloc_location</a> *location,</div>
+<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>                              <span class="keywordtype">unsigned</span> *nr,</div>
+<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span>                              <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> *nodes,</div>
+<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span>                              <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span> </div>
+<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span> </div>
+<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span> </div>
+<div class="line"><a id="l00298" name="l00298"></a><span class="lineno">  298</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00299" name="l00299"></a><span class="lineno"><a class="line" href="a00201.html#ga297e4a9adc2272446a4c7449dacef0df">  299</a></span><a class="code hl_function" href="a00201.html#ga297e4a9adc2272446a4c7449dacef0df">hwloc_memattr_get_value</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00300" name="l00300"></a><span class="lineno">  300</span>                        <a class="code hl_typedef" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute,</div>
+<div class="line"><a id="l00301" name="l00301"></a><span class="lineno">  301</span>                        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> target_node,</div>
+<div class="line"><a id="l00302" name="l00302"></a><span class="lineno">  302</span>                        <span class="keyword">struct</span> <a class="code hl_struct" href="a00305.html">hwloc_location</a> *initiator,</div>
+<div class="line"><a id="l00303" name="l00303"></a><span class="lineno">  303</span>                        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags,</div>
+<div class="line"><a id="l00304" name="l00304"></a><span class="lineno">  304</span>                        hwloc_uint64_t *value);</div>
+<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span> </div>
+<div class="line"><a id="l00334" name="l00334"></a><span class="lineno">  334</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00335" name="l00335"></a><span class="lineno"><a class="line" href="a00201.html#ga884d1f2ad745c2fa69c1583c82d28f10">  335</a></span><a class="code hl_function" href="a00201.html#ga884d1f2ad745c2fa69c1583c82d28f10">hwloc_memattr_get_best_target</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00336" name="l00336"></a><span class="lineno">  336</span>                              <a class="code hl_typedef" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute,</div>
+<div class="line"><a id="l00337" name="l00337"></a><span class="lineno">  337</span>                              <span class="keyword">struct</span> <a class="code hl_struct" href="a00305.html">hwloc_location</a> *initiator,</div>
+<div class="line"><a id="l00338" name="l00338"></a><span class="lineno">  338</span>                              <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags,</div>
+<div class="line"><a id="l00339" name="l00339"></a><span class="lineno">  339</span>                              <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> *best_target, hwloc_uint64_t *value);</div>
+<div class="line"><a id="l00340" name="l00340"></a><span class="lineno">  340</span> </div>
+<div class="line"><a id="l00362" name="l00362"></a><span class="lineno">  362</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00363" name="l00363"></a><span class="lineno"><a class="line" href="a00201.html#ga9a453879892893cf8a3fcd431ade84cd">  363</a></span><a class="code hl_function" href="a00201.html#ga9a453879892893cf8a3fcd431ade84cd">hwloc_memattr_get_best_initiator</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00364" name="l00364"></a><span class="lineno">  364</span>                                 <a class="code hl_typedef" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute,</div>
+<div class="line"><a id="l00365" name="l00365"></a><span class="lineno">  365</span>                                 <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> target,</div>
+<div class="line"><a id="l00366" name="l00366"></a><span class="lineno">  366</span>                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags,</div>
+<div class="line"><a id="l00367" name="l00367"></a><span class="lineno">  367</span>                                 <span class="keyword">struct</span> <a class="code hl_struct" href="a00305.html">hwloc_location</a> *best_initiator, hwloc_uint64_t *value);</div>
+<div class="line"><a id="l00368" name="l00368"></a><span class="lineno">  368</span> </div>
+<div class="line"><a id="l00381" name="l00381"></a><span class="lineno">  381</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00382" name="l00382"></a><span class="lineno"><a class="line" href="a00202.html#ga5300e9be1abdea2e00c18492148aecd0">  382</a></span><a class="code hl_function" href="a00202.html#ga5300e9be1abdea2e00c18492148aecd0">hwloc_memattr_get_name</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00383" name="l00383"></a><span class="lineno">  383</span>                       <a class="code hl_typedef" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute,</div>
+<div class="line"><a id="l00384" name="l00384"></a><span class="lineno">  384</span>                       <span class="keyword">const</span> <span class="keywordtype">char</span> **name);</div>
+<div class="line"><a id="l00385" name="l00385"></a><span class="lineno">  385</span> </div>
+<div class="line"><a id="l00393" name="l00393"></a><span class="lineno">  393</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00394" name="l00394"></a><span class="lineno"><a class="line" href="a00202.html#ga4c62b626085adeaffb233e5f2a03a5eb">  394</a></span><a class="code hl_function" href="a00202.html#ga4c62b626085adeaffb233e5f2a03a5eb">hwloc_memattr_get_flags</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00395" name="l00395"></a><span class="lineno">  395</span>                        <a class="code hl_typedef" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute,</div>
+<div class="line"><a id="l00396" name="l00396"></a><span class="lineno">  396</span>                        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *flags);</div>
+<div class="line"><a id="l00397" name="l00397"></a><span class="lineno">  397</span> </div>
+<div class="foldopen" id="foldopen00401" data-start="{" data-end="};">
+<div class="line"><a id="l00401" name="l00401"></a><span class="lineno"><a class="line" href="a00202.html#ga78aceb4cac4d614c0f5e82dbfeb779e5">  401</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00202.html#ga78aceb4cac4d614c0f5e82dbfeb779e5">hwloc_memattr_flag_e</a> {</div>
+<div class="line"><a id="l00405" name="l00405"></a><span class="lineno"><a class="line" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815">  405</a></span>  <a class="code hl_enumvalue" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815">HWLOC_MEMATTR_FLAG_HIGHER_FIRST</a> = (1UL&lt;&lt;0),</div>
+<div class="line"><a id="l00409" name="l00409"></a><span class="lineno"><a class="line" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf">  409</a></span>  <a class="code hl_enumvalue" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf">HWLOC_MEMATTR_FLAG_LOWER_FIRST</a> = (1UL&lt;&lt;1),</div>
+<div class="line"><a id="l00413" name="l00413"></a><span class="lineno">  413</span>  <a class="code hl_enumvalue" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a> = (1UL&lt;&lt;2)</div>
+<div class="line"><a id="l00414" name="l00414"></a><span class="lineno"><a class="line" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96">  414</a></span>};</div>
+</div>
+<div class="line"><a id="l00415" name="l00415"></a><span class="lineno">  415</span> </div>
+<div class="line"><a id="l00425" name="l00425"></a><span class="lineno">  425</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00426" name="l00426"></a><span class="lineno"><a class="line" href="a00202.html#ga770657d1e44b09e93e09f623936c1e5f">  426</a></span><a class="code hl_function" href="a00202.html#ga770657d1e44b09e93e09f623936c1e5f">hwloc_memattr_register</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00427" name="l00427"></a><span class="lineno">  427</span>                       <span class="keyword">const</span> <span class="keywordtype">char</span> *name,</div>
+<div class="line"><a id="l00428" name="l00428"></a><span class="lineno">  428</span>                       <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags,</div>
+<div class="line"><a id="l00429" name="l00429"></a><span class="lineno">  429</span>                       <a class="code hl_typedef" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> *<span class="keywordtype">id</span>);</div>
+<div class="line"><a id="l00430" name="l00430"></a><span class="lineno">  430</span> </div>
+<div class="line"><a id="l00451" name="l00451"></a><span class="lineno">  451</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00452" name="l00452"></a><span class="lineno"><a class="line" href="a00202.html#ga960529c08b25cf15825e0f72ecceb504">  452</a></span><a class="code hl_function" href="a00202.html#ga960529c08b25cf15825e0f72ecceb504">hwloc_memattr_set_value</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00453" name="l00453"></a><span class="lineno">  453</span>                        <a class="code hl_typedef" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute,</div>
+<div class="line"><a id="l00454" name="l00454"></a><span class="lineno">  454</span>                        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> target_node,</div>
+<div class="line"><a id="l00455" name="l00455"></a><span class="lineno">  455</span>                        <span class="keyword">struct</span> <a class="code hl_struct" href="a00305.html">hwloc_location</a> *initiator,</div>
+<div class="line"><a id="l00456" name="l00456"></a><span class="lineno">  456</span>                        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags,</div>
+<div class="line"><a id="l00457" name="l00457"></a><span class="lineno">  457</span>                        hwloc_uint64_t value);</div>
+<div class="line"><a id="l00458" name="l00458"></a><span class="lineno">  458</span> </div>
+<div class="line"><a id="l00497" name="l00497"></a><span class="lineno">  497</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00498" name="l00498"></a><span class="lineno"><a class="line" href="a00202.html#gac8c06c1c89ab352c5db8e04a75033513">  498</a></span><a class="code hl_function" href="a00202.html#gac8c06c1c89ab352c5db8e04a75033513">hwloc_memattr_get_targets</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00499" name="l00499"></a><span class="lineno">  499</span>                          <a class="code hl_typedef" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute,</div>
+<div class="line"><a id="l00500" name="l00500"></a><span class="lineno">  500</span>                          <span class="keyword">struct</span> <a class="code hl_struct" href="a00305.html">hwloc_location</a> *initiator,</div>
+<div class="line"><a id="l00501" name="l00501"></a><span class="lineno">  501</span>                          <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags,</div>
+<div class="line"><a id="l00502" name="l00502"></a><span class="lineno">  502</span>                          <span class="keywordtype">unsigned</span> *nr, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> *targets, hwloc_uint64_t *values);</div>
+<div class="line"><a id="l00503" name="l00503"></a><span class="lineno">  503</span> </div>
+<div class="line"><a id="l00535" name="l00535"></a><span class="lineno">  535</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00536" name="l00536"></a><span class="lineno"><a class="line" href="a00202.html#ga049aaa860dcbbf0792f0fd4251a99ec0">  536</a></span><a class="code hl_function" href="a00202.html#ga049aaa860dcbbf0792f0fd4251a99ec0">hwloc_memattr_get_initiators</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00537" name="l00537"></a><span class="lineno">  537</span>                             <a class="code hl_typedef" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute,</div>
+<div class="line"><a id="l00538" name="l00538"></a><span class="lineno">  538</span>                             <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> target_node,</div>
+<div class="line"><a id="l00539" name="l00539"></a><span class="lineno">  539</span>                             <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags,</div>
+<div class="line"><a id="l00540" name="l00540"></a><span class="lineno">  540</span>                             <span class="keywordtype">unsigned</span> *nr, <span class="keyword">struct</span> <a class="code hl_struct" href="a00305.html">hwloc_location</a> *initiators, hwloc_uint64_t *values);</div>
+<div class="line"><a id="l00543" name="l00543"></a><span class="lineno">  543</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00544" name="l00544"></a><span class="lineno">  544</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00545" name="l00545"></a><span class="lineno">  545</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00546" name="l00546"></a><span class="lineno">  546</span> </div>
+<div class="line"><a id="l00547" name="l00547"></a><span class="lineno">  547</span> </div>
+<div class="line"><a id="l00548" name="l00548"></a><span class="lineno">  548</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_MEMATTR_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00201_html_ga297e4a9adc2272446a4c7449dacef0df"><div class="ttname"><a href="a00201.html#ga297e4a9adc2272446a4c7449dacef0df">hwloc_memattr_get_value</a></div><div class="ttdeci">int hwloc_memattr_get_value(hwloc_topology_t topology, hwloc_memattr_id_t attribute, hwloc_obj_t target_node, struct hwloc_location *initiator, unsigned long flags, hwloc_uint64_t *value)</div><div class="ttdoc">Return an attribute value for a specific target NUMA node.</div></div>
+<div class="ttc" id="aa00201_html_ga33099ba58f607fc70925da3777688586"><div class="ttname"><a href="a00201.html#ga33099ba58f607fc70925da3777688586">hwloc_location_type_e</a></div><div class="ttdeci">hwloc_location_type_e</div><div class="ttdoc">Type of location.</div><div class="ttdef"><b>Definition</b> memattrs.h:196</div></div>
+<div class="ttc" id="aa00201_html_ga569e80c5be7ef27649b0ef5aa52ffcdc"><div class="ttname"><a href="a00201.html#ga569e80c5be7ef27649b0ef5aa52ffcdc">hwloc_get_local_numanode_objs</a></div><div class="ttdeci">int hwloc_get_local_numanode_objs(hwloc_topology_t topology, struct hwloc_location *location, unsigned *nr, hwloc_obj_t *nodes, unsigned long flags)</div><div class="ttdoc">Return an array of local NUMA nodes.</div></div>
+<div class="ttc" id="aa00201_html_ga79f44f8e1cfd2f97a19171417a75a137"><div class="ttname"><a href="a00201.html#ga79f44f8e1cfd2f97a19171417a75a137">hwloc_memattr_get_by_name</a></div><div class="ttdeci">int hwloc_memattr_get_by_name(hwloc_topology_t topology, const char *name, hwloc_memattr_id_t *id)</div><div class="ttdoc">Return the identifier of the memory attribute with the given name.</div></div>
+<div class="ttc" id="aa00201_html_ga884d1f2ad745c2fa69c1583c82d28f10"><div class="ttname"><a href="a00201.html#ga884d1f2ad745c2fa69c1583c82d28f10">hwloc_memattr_get_best_target</a></div><div class="ttdeci">int hwloc_memattr_get_best_target(hwloc_topology_t topology, hwloc_memattr_id_t attribute, struct hwloc_location *initiator, unsigned long flags, hwloc_obj_t *best_target, hwloc_uint64_t *value)</div><div class="ttdoc">Return the best target NUMA node for the given attribute and initiator.</div></div>
+<div class="ttc" id="aa00201_html_ga9a453879892893cf8a3fcd431ade84cd"><div class="ttname"><a href="a00201.html#ga9a453879892893cf8a3fcd431ade84cd">hwloc_memattr_get_best_initiator</a></div><div class="ttdeci">int hwloc_memattr_get_best_initiator(hwloc_topology_t topology, hwloc_memattr_id_t attribute, hwloc_obj_t target, unsigned long flags, struct hwloc_location *best_initiator, hwloc_uint64_t *value)</div><div class="ttdoc">Return the best initiator for the given attribute and target NUMA node.</div></div>
+<div class="ttc" id="aa00201_html_gab4bde745db676fc2ea4b47011cd9a80e"><div class="ttname"><a href="a00201.html#gab4bde745db676fc2ea4b47011cd9a80e">hwloc_memattr_id_e</a></div><div class="ttdeci">hwloc_memattr_id_e</div><div class="ttdoc">Memory node attributes.</div><div class="ttdef"><b>Definition</b> memattrs.h:73</div></div>
+<div class="ttc" id="aa00201_html_gab9c963ca37255da71b00d94e1b106f9d"><div class="ttname"><a href="a00201.html#gab9c963ca37255da71b00d94e1b106f9d">hwloc_local_numanode_flag_e</a></div><div class="ttdeci">hwloc_local_numanode_flag_e</div><div class="ttdoc">Flags for selecting target NUMA nodes.</div><div class="ttdef"><b>Definition</b> memattrs.h:218</div></div>
+<div class="ttc" id="aa00201_html_gacc82003a8610be554615995f0996c888"><div class="ttname"><a href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a></div><div class="ttdeci">unsigned hwloc_memattr_id_t</div><div class="ttdoc">A memory attribute identifier. May be either one of hwloc_memattr_id_e or a new id returned by hwloc_...</div><div class="ttdef"><b>Definition</b> memattrs.h:182</div></div>
+<div class="ttc" id="aa00201_html_gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174"><div class="ttname"><a href="a00201.html#gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174">HWLOC_LOCATION_TYPE_CPUSET</a></div><div class="ttdeci">@ HWLOC_LOCATION_TYPE_CPUSET</div><div class="ttdoc">Location is given as a cpuset, in the location cpuset union field.</div><div class="ttdef"><b>Definition</b> memattrs.h:198</div></div>
+<div class="ttc" id="aa00201_html_gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84"><div class="ttname"><a href="a00201.html#gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84">HWLOC_LOCATION_TYPE_OBJECT</a></div><div class="ttdeci">@ HWLOC_LOCATION_TYPE_OBJECT</div><div class="ttdoc">Location is given as an object, in the location object union field.</div><div class="ttdef"><b>Definition</b> memattrs.h:200</div></div>
+<div class="ttc" id="aa00201_html_ggab4bde745db676fc2ea4b47011cd9a80ea25fe3c7376ae6f9b584bacdb039f8c0f"><div class="ttname"><a href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea25fe3c7376ae6f9b584bacdb039f8c0f">HWLOC_MEMATTR_ID_BANDWIDTH</a></div><div class="ttdeci">@ HWLOC_MEMATTR_ID_BANDWIDTH</div><div class="ttdoc">The &quot;Bandwidth&quot; is returned in MiB/s, as seen from the given initiator location.</div><div class="ttdef"><b>Definition</b> memattrs.h:113</div></div>
+<div class="ttc" id="aa00201_html_ggab4bde745db676fc2ea4b47011cd9a80ea44762e8ebe327cfe665cccf1f58f7530"><div class="ttname"><a href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea44762e8ebe327cfe665cccf1f58f7530">HWLOC_MEMATTR_ID_WRITE_BANDWIDTH</a></div><div class="ttdeci">@ HWLOC_MEMATTR_ID_WRITE_BANDWIDTH</div><div class="ttdoc">The &quot;WriteBandwidth&quot; is returned in MiB/s, as seen from the given initiator location.</div><div class="ttdef"><b>Definition</b> memattrs.h:135</div></div>
+<div class="ttc" id="aa00201_html_ggab4bde745db676fc2ea4b47011cd9a80ea52cab56571c7fafea42a694d80ad3dd0"><div class="ttname"><a href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea52cab56571c7fafea42a694d80ad3dd0">HWLOC_MEMATTR_ID_READ_LATENCY</a></div><div class="ttdeci">@ HWLOC_MEMATTR_ID_READ_LATENCY</div><div class="ttdoc">The &quot;ReadLatency&quot; is returned as nanoseconds, as seen from the given initiator location.</div><div class="ttdef"><b>Definition</b> memattrs.h:161</div></div>
+<div class="ttc" id="aa00201_html_ggab4bde745db676fc2ea4b47011cd9a80ea9334e3a4c30a67f491c6523255134efe"><div class="ttname"><a href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea9334e3a4c30a67f491c6523255134efe">HWLOC_MEMATTR_ID_LOCALITY</a></div><div class="ttdeci">@ HWLOC_MEMATTR_ID_LOCALITY</div><div class="ttdoc">The &quot;Locality&quot; is returned as the number of PUs in that locality (e.g. the weight of its cpuset).</div><div class="ttdef"><b>Definition</b> memattrs.h:98</div></div>
+<div class="ttc" id="aa00201_html_ggab4bde745db676fc2ea4b47011cd9a80eaa1cfa3ff3d56ff00ecabf7da4f5642cc"><div class="ttname"><a href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eaa1cfa3ff3d56ff00ecabf7da4f5642cc">HWLOC_MEMATTR_ID_CAPACITY</a></div><div class="ttdeci">@ HWLOC_MEMATTR_ID_CAPACITY</div><div class="ttdoc">The &quot;Capacity&quot; is returned in bytes (local_memory attribute in objects).</div><div class="ttdef"><b>Definition</b> memattrs.h:83</div></div>
+<div class="ttc" id="aa00201_html_ggab4bde745db676fc2ea4b47011cd9a80eaaf6cd383da87dc9f5e3a608a535a768e"><div class="ttname"><a href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eaaf6cd383da87dc9f5e3a608a535a768e">HWLOC_MEMATTR_ID_WRITE_LATENCY</a></div><div class="ttdeci">@ HWLOC_MEMATTR_ID_WRITE_LATENCY</div><div class="ttdoc">The &quot;WriteLatency&quot; is returned as nanoseconds, as seen from the given initiator location.</div><div class="ttdef"><b>Definition</b> memattrs.h:172</div></div>
+<div class="ttc" id="aa00201_html_ggab4bde745db676fc2ea4b47011cd9a80eac34dce925d3dadb7e255391d142b4828"><div class="ttname"><a href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eac34dce925d3dadb7e255391d142b4828">HWLOC_MEMATTR_ID_READ_BANDWIDTH</a></div><div class="ttdeci">@ HWLOC_MEMATTR_ID_READ_BANDWIDTH</div><div class="ttdoc">The &quot;ReadBandwidth&quot; is returned in MiB/s, as seen from the given initiator location.</div><div class="ttdef"><b>Definition</b> memattrs.h:124</div></div>
+<div class="ttc" id="aa00201_html_ggab4bde745db676fc2ea4b47011cd9a80ead1796413759b8b87b61ad195a9349b19"><div class="ttname"><a href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ead1796413759b8b87b61ad195a9349b19">HWLOC_MEMATTR_ID_LATENCY</a></div><div class="ttdeci">@ HWLOC_MEMATTR_ID_LATENCY</div><div class="ttdoc">The &quot;Latency&quot; is returned as nanoseconds, as seen from the given initiator location.</div><div class="ttdef"><b>Definition</b> memattrs.h:150</div></div>
+<div class="ttc" id="aa00201_html_ggab9c963ca37255da71b00d94e1b106f9da200c6c133bb2125ba36d77ce9ca268cc"><div class="ttname"><a href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9da200c6c133bb2125ba36d77ce9ca268cc">HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY</a></div><div class="ttdeci">@ HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY</div><div class="ttdoc">Select NUMA nodes whose locality is larger than the given cpuset. For instance, if a single PU (or it...</div><div class="ttdef"><b>Definition</b> memattrs.h:224</div></div>
+<div class="ttc" id="aa00201_html_ggab9c963ca37255da71b00d94e1b106f9daac9c5e3a2cfb1b193e4acfceaf3bad57"><div class="ttname"><a href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9daac9c5e3a2cfb1b193e4acfceaf3bad57">HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY</a></div><div class="ttdeci">@ HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY</div><div class="ttdoc">Select NUMA nodes whose locality is smaller than the given cpuset. For instance, if a package (or its...</div><div class="ttdef"><b>Definition</b> memattrs.h:231</div></div>
+<div class="ttc" id="aa00201_html_ggab9c963ca37255da71b00d94e1b106f9dab5778b34c961a5d56f98f1549edeaed0"><div class="ttname"><a href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9dab5778b34c961a5d56f98f1549edeaed0">HWLOC_LOCAL_NUMANODE_FLAG_ALL</a></div><div class="ttdeci">@ HWLOC_LOCAL_NUMANODE_FLAG_ALL</div><div class="ttdoc">Select all NUMA nodes in the topology. The initiator initiator is ignored.</div><div class="ttdef"><b>Definition</b> memattrs.h:237</div></div>
+<div class="ttc" id="aa00202_html_ga049aaa860dcbbf0792f0fd4251a99ec0"><div class="ttname"><a href="a00202.html#ga049aaa860dcbbf0792f0fd4251a99ec0">hwloc_memattr_get_initiators</a></div><div class="ttdeci">int hwloc_memattr_get_initiators(hwloc_topology_t topology, hwloc_memattr_id_t attribute, hwloc_obj_t target_node, unsigned long flags, unsigned *nr, struct hwloc_location *initiators, hwloc_uint64_t *values)</div><div class="ttdoc">Return the initiators that have values for a given attribute for a specific target NUMA node.</div></div>
+<div class="ttc" id="aa00202_html_ga4c62b626085adeaffb233e5f2a03a5eb"><div class="ttname"><a href="a00202.html#ga4c62b626085adeaffb233e5f2a03a5eb">hwloc_memattr_get_flags</a></div><div class="ttdeci">int hwloc_memattr_get_flags(hwloc_topology_t topology, hwloc_memattr_id_t attribute, unsigned long *flags)</div><div class="ttdoc">Return the flags of the given attribute.</div></div>
+<div class="ttc" id="aa00202_html_ga5300e9be1abdea2e00c18492148aecd0"><div class="ttname"><a href="a00202.html#ga5300e9be1abdea2e00c18492148aecd0">hwloc_memattr_get_name</a></div><div class="ttdeci">int hwloc_memattr_get_name(hwloc_topology_t topology, hwloc_memattr_id_t attribute, const char **name)</div><div class="ttdoc">Return the name of a memory attribute.</div></div>
+<div class="ttc" id="aa00202_html_ga770657d1e44b09e93e09f623936c1e5f"><div class="ttname"><a href="a00202.html#ga770657d1e44b09e93e09f623936c1e5f">hwloc_memattr_register</a></div><div class="ttdeci">int hwloc_memattr_register(hwloc_topology_t topology, const char *name, unsigned long flags, hwloc_memattr_id_t *id)</div><div class="ttdoc">Register a new memory attribute.</div></div>
+<div class="ttc" id="aa00202_html_ga78aceb4cac4d614c0f5e82dbfeb779e5"><div class="ttname"><a href="a00202.html#ga78aceb4cac4d614c0f5e82dbfeb779e5">hwloc_memattr_flag_e</a></div><div class="ttdeci">hwloc_memattr_flag_e</div><div class="ttdoc">Memory attribute flags. Given to hwloc_memattr_register() and returned by hwloc_memattr_get_flags().</div><div class="ttdef"><b>Definition</b> memattrs.h:401</div></div>
+<div class="ttc" id="aa00202_html_ga960529c08b25cf15825e0f72ecceb504"><div class="ttname"><a href="a00202.html#ga960529c08b25cf15825e0f72ecceb504">hwloc_memattr_set_value</a></div><div class="ttdeci">int hwloc_memattr_set_value(hwloc_topology_t topology, hwloc_memattr_id_t attribute, hwloc_obj_t target_node, struct hwloc_location *initiator, unsigned long flags, hwloc_uint64_t value)</div><div class="ttdoc">Set an attribute value for a specific target NUMA node.</div></div>
+<div class="ttc" id="aa00202_html_gac8c06c1c89ab352c5db8e04a75033513"><div class="ttname"><a href="a00202.html#gac8c06c1c89ab352c5db8e04a75033513">hwloc_memattr_get_targets</a></div><div class="ttdeci">int hwloc_memattr_get_targets(hwloc_topology_t topology, hwloc_memattr_id_t attribute, struct hwloc_location *initiator, unsigned long flags, unsigned *nr, hwloc_obj_t *targets, hwloc_uint64_t *values)</div><div class="ttdoc">Return the target NUMA nodes that have some values for a given attribute.</div></div>
+<div class="ttc" id="aa00202_html_gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf"><div class="ttname"><a href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf">HWLOC_MEMATTR_FLAG_LOWER_FIRST</a></div><div class="ttdeci">@ HWLOC_MEMATTR_FLAG_LOWER_FIRST</div><div class="ttdoc">The best nodes for this memory attribute are those with the lower values. For instance Latency.</div><div class="ttdef"><b>Definition</b> memattrs.h:409</div></div>
+<div class="ttc" id="aa00202_html_gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96"><div class="ttname"><a href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a></div><div class="ttdeci">@ HWLOC_MEMATTR_FLAG_NEED_INITIATOR</div><div class="ttdoc">The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...</div><div class="ttdef"><b>Definition</b> memattrs.h:413</div></div>
+<div class="ttc" id="aa00202_html_gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815"><div class="ttname"><a href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815">HWLOC_MEMATTR_FLAG_HIGHER_FIRST</a></div><div class="ttdeci">@ HWLOC_MEMATTR_FLAG_HIGHER_FIRST</div><div class="ttdoc">The best nodes for this memory attribute are those with the higher values. For instance Bandwidth.</div><div class="ttdef"><b>Definition</b> memattrs.h:405</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00305_html"><div class="ttname"><a href="a00305.html">hwloc_location</a></div><div class="ttdoc">Where to measure attributes from.</div><div class="ttdef"><b>Definition</b> memattrs.h:204</div></div>
+<div class="ttc" id="aa00305_html_a707a25a5b65177e4d081be49aa0777a2"><div class="ttname"><a href="a00305.html#a707a25a5b65177e4d081be49aa0777a2">hwloc_location::location</a></div><div class="ttdeci">union hwloc_location::hwloc_location_u location</div></div>
+<div class="ttc" id="aa00305_html_aeb9c0ab74a7d3506a76d0b82600a28a7"><div class="ttname"><a href="a00305.html#aeb9c0ab74a7d3506a76d0b82600a28a7">hwloc_location::type</a></div><div class="ttdeci">enum hwloc_location_type_e type</div><div class="ttdoc">Type of location.</div><div class="ttdef"><b>Definition</b> memattrs.h:206</div></div>
+<div class="ttc" id="aa00309_html"><div class="ttname"><a href="a00309.html">hwloc_location::hwloc_location_u</a></div><div class="ttdoc">Actual location.</div><div class="ttdef"><b>Definition</b> memattrs.h:208</div></div>
+<div class="ttc" id="aa00309_html_a033bad8f6b891992f0c18b85a88c5561"><div class="ttname"><a href="a00309.html#a033bad8f6b891992f0c18b85a88c5561">hwloc_location::hwloc_location_u::cpuset</a></div><div class="ttdeci">hwloc_cpuset_t cpuset</div><div class="ttdoc">Location as a cpuset, when the location type is HWLOC_LOCATION_TYPE_CPUSET.</div><div class="ttdef"><b>Definition</b> memattrs.h:210</div></div>
+<div class="ttc" id="aa00309_html_acf2ebf75869f0a53a884ac2ab3374122"><div class="ttname"><a href="a00309.html#acf2ebf75869f0a53a884ac2ab3374122">hwloc_location::hwloc_location_u::object</a></div><div class="ttdeci">hwloc_obj_t object</div><div class="ttdoc">Location as an object, when the location type is HWLOC_LOCATION_TYPE_OBJECT.</div><div class="ttdef"><b>Definition</b> memattrs.h:212</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00122_source.html 2.11.0-1/doc/doxygen-doc/html/a00122_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00122_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00122_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,114 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): cpukinds.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">cpukinds.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2020-2021 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span> </div>
+<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="preprocessor">#ifndef HWLOC_CPUKINDS_H</span></div>
+<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="preprocessor">#define HWLOC_CPUKINDS_H</span></div>
+<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span> </div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#elif 0</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>}</div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
+<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00082" name="l00082"></a><span class="lineno"><a class="line" href="a00203.html#ga7553f7c6d3920b169f3fc18dfe6a33e3">   82</a></span><a class="code hl_function" href="a00203.html#ga7553f7c6d3920b169f3fc18dfe6a33e3">hwloc_cpukinds_get_nr</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>                      <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span> </div>
+<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00097" name="l00097"></a><span class="lineno"><a class="line" href="a00203.html#gaf979833aab18d2e7f4b17c932cbcf5d8">   97</a></span><a class="code hl_function" href="a00203.html#gaf979833aab18d2e7f4b17c932cbcf5d8">hwloc_cpukinds_get_by_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>                             <a class="code hl_typedef" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> cpuset,</div>
+<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>                             <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span> </div>
+<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00135" name="l00135"></a><span class="lineno"><a class="line" href="a00203.html#gae1b38fbe9c645583fc16052ce6fbb275">  135</a></span><a class="code hl_function" href="a00203.html#gae1b38fbe9c645583fc16052ce6fbb275">hwloc_cpukinds_get_info</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>                        <span class="keywordtype">unsigned</span> kind_index,</div>
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>                        <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> cpuset,</div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>                        <span class="keywordtype">int</span> *efficiency,</div>
+<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>                        <span class="keywordtype">unsigned</span> *nr_infos, <span class="keyword">struct</span> <a class="code hl_struct" href="a00277.html">hwloc_info_s</a> **infos,</div>
+<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>                        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span> </div>
+<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00180" name="l00180"></a><span class="lineno"><a class="line" href="a00203.html#ga6164ba92cfd06f530ec2c4a18a0dd5a9">  180</a></span><a class="code hl_function" href="a00203.html#ga6164ba92cfd06f530ec2c4a18a0dd5a9">hwloc_cpukinds_register</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>                        <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> cpuset,</div>
+<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>                        <span class="keywordtype">int</span> forced_efficiency,</div>
+<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>                        <span class="keywordtype">unsigned</span> nr_infos, <span class="keyword">struct</span> <a class="code hl_struct" href="a00277.html">hwloc_info_s</a> *infos,</div>
+<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>                        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span> </div>
+<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span> </div>
+<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span> </div>
+<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_CPUKINDS_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00194_html_gaa3c2bf4c776d603dcebbb61b0c923d84"><div class="ttname"><a href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a></div><div class="ttdeci">struct hwloc_bitmap_s * hwloc_bitmap_t</div><div class="ttdoc">Set of bits represented as an opaque pointer to an internal bitmap.</div><div class="ttdef"><b>Definition</b> bitmap.h:69</div></div>
+<div class="ttc" id="aa00194_html_gae991a108af01d408be2776c5b2c467b2"><div class="ttname"><a href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a></div><div class="ttdeci">const struct hwloc_bitmap_s * hwloc_const_bitmap_t</div><div class="ttdoc">a non-modifiable hwloc_bitmap_t</div><div class="ttdef"><b>Definition</b> bitmap.h:71</div></div>
+<div class="ttc" id="aa00203_html_ga6164ba92cfd06f530ec2c4a18a0dd5a9"><div class="ttname"><a href="a00203.html#ga6164ba92cfd06f530ec2c4a18a0dd5a9">hwloc_cpukinds_register</a></div><div class="ttdeci">int hwloc_cpukinds_register(hwloc_topology_t topology, hwloc_bitmap_t cpuset, int forced_efficiency, unsigned nr_infos, struct hwloc_info_s *infos, unsigned long flags)</div><div class="ttdoc">Register a kind of CPU in the topology.</div></div>
+<div class="ttc" id="aa00203_html_ga7553f7c6d3920b169f3fc18dfe6a33e3"><div class="ttname"><a href="a00203.html#ga7553f7c6d3920b169f3fc18dfe6a33e3">hwloc_cpukinds_get_nr</a></div><div class="ttdeci">int hwloc_cpukinds_get_nr(hwloc_topology_t topology, unsigned long flags)</div><div class="ttdoc">Get the number of different kinds of CPU cores in the topology.</div></div>
+<div class="ttc" id="aa00203_html_gae1b38fbe9c645583fc16052ce6fbb275"><div class="ttname"><a href="a00203.html#gae1b38fbe9c645583fc16052ce6fbb275">hwloc_cpukinds_get_info</a></div><div class="ttdeci">int hwloc_cpukinds_get_info(hwloc_topology_t topology, unsigned kind_index, hwloc_bitmap_t cpuset, int *efficiency, unsigned *nr_infos, struct hwloc_info_s **infos, unsigned long flags)</div><div class="ttdoc">Get the CPU set and infos about a CPU kind in the topology.</div></div>
+<div class="ttc" id="aa00203_html_gaf979833aab18d2e7f4b17c932cbcf5d8"><div class="ttname"><a href="a00203.html#gaf979833aab18d2e7f4b17c932cbcf5d8">hwloc_cpukinds_get_by_cpuset</a></div><div class="ttdeci">int hwloc_cpukinds_get_by_cpuset(hwloc_topology_t topology, hwloc_const_bitmap_t cpuset, unsigned long flags)</div><div class="ttdoc">Get the index of the CPU kind that contains CPUs listed in cpuset.</div></div>
+<div class="ttc" id="aa00277_html"><div class="ttname"><a href="a00277.html">hwloc_info_s</a></div><div class="ttdoc">Object info attribute (name and value strings)</div><div class="ttdef"><b>Definition</b> hwloc.h:724</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00125_source.html 2.11.0-1/doc/doxygen-doc/html/a00125_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00125_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00125_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,102 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): linux.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">linux.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2009 CNRS</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2009-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * Copyright © 2009-2011 Université Bordeaux</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#ifndef HWLOC_LINUX_H</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#define HWLOC_LINUX_H</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
+<div class="line"><a id="l00046" name="l00046"></a><span class="lineno"><a class="line" href="a00204.html#ga630e699c56b5f3d2e534b475944c216e">   46</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00204.html#ga630e699c56b5f3d2e534b475944c216e">hwloc_linux_set_tid_cpubind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, pid_t tid, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set);</div>
+<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span> </div>
+<div class="line"><a id="l00062" name="l00062"></a><span class="lineno"><a class="line" href="a00204.html#gaddcb985cb56337a4d6693cee72e7bf94">   62</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00204.html#gaddcb985cb56337a4d6693cee72e7bf94">hwloc_linux_get_tid_cpubind</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, pid_t tid, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set);</div>
+<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span> </div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno"><a class="line" href="a00204.html#gacc7945c2d06c6db1e58f8fd953009134">   74</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00204.html#gacc7945c2d06c6db1e58f8fd953009134">hwloc_linux_get_tid_last_cpu_location</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, pid_t tid, <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set);</div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span> </div>
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno"><a class="line" href="a00204.html#gaf72d83e273803226ce772973e37b85de">   85</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *path, <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set);</div>
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span> </div>
+<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span> </div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span> </div>
+<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_LINUX_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga1f784433e9b606261f62d1134f6a3b25"><div class="ttname"><a href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a></div><div class="ttdeci">hwloc_const_bitmap_t hwloc_const_cpuset_t</div><div class="ttdoc">A non-modifiable hwloc_cpuset_t.</div><div class="ttdef"><b>Definition</b> hwloc.h:163</div></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00194_html_gaa3c2bf4c776d603dcebbb61b0c923d84"><div class="ttname"><a href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a></div><div class="ttdeci">struct hwloc_bitmap_s * hwloc_bitmap_t</div><div class="ttdoc">Set of bits represented as an opaque pointer to an internal bitmap.</div><div class="ttdef"><b>Definition</b> bitmap.h:69</div></div>
+<div class="ttc" id="aa00204_html_ga630e699c56b5f3d2e534b475944c216e"><div class="ttname"><a href="a00204.html#ga630e699c56b5f3d2e534b475944c216e">hwloc_linux_set_tid_cpubind</a></div><div class="ttdeci">int hwloc_linux_set_tid_cpubind(hwloc_topology_t topology, pid_t tid, hwloc_const_cpuset_t set)</div><div class="ttdoc">Bind a thread tid on cpus given in cpuset set.</div></div>
+<div class="ttc" id="aa00204_html_gacc7945c2d06c6db1e58f8fd953009134"><div class="ttname"><a href="a00204.html#gacc7945c2d06c6db1e58f8fd953009134">hwloc_linux_get_tid_last_cpu_location</a></div><div class="ttdeci">int hwloc_linux_get_tid_last_cpu_location(hwloc_topology_t topology, pid_t tid, hwloc_bitmap_t set)</div><div class="ttdoc">Get the last physical CPU where thread tid ran.</div></div>
+<div class="ttc" id="aa00204_html_gaddcb985cb56337a4d6693cee72e7bf94"><div class="ttname"><a href="a00204.html#gaddcb985cb56337a4d6693cee72e7bf94">hwloc_linux_get_tid_cpubind</a></div><div class="ttdeci">int hwloc_linux_get_tid_cpubind(hwloc_topology_t topology, pid_t tid, hwloc_cpuset_t set)</div><div class="ttdoc">Get the current binding of thread tid.</div></div>
+<div class="ttc" id="aa00204_html_gaf72d83e273803226ce772973e37b85de"><div class="ttname"><a href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a></div><div class="ttdeci">int hwloc_linux_read_path_as_cpumask(const char *path, hwloc_bitmap_t set)</div><div class="ttdoc">Convert a linux kernel cpumask file path into a hwloc bitmap set.</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00128_source.html 2.11.0-1/doc/doxygen-doc/html/a00128_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00128_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00128_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,269 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): linux-libnuma.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">linux-libnuma.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2009 CNRS</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2009-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * Copyright © 2009-2010, 2012 Université Bordeaux</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#ifndef HWLOC_LINUX_LIBNUMA_H</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#define HWLOC_LINUX_LIBNUMA_H</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &lt;numa.h&gt;</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
+<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00057" data-start="{" data-end="}">
+<div class="line"><a id="l00057" name="l00057"></a><span class="lineno"><a class="line" href="a00205.html#gae577962390f84b0b12f503314ab0f972">   57</a></span><a class="code hl_function" href="a00205.html#gae577962390f84b0b12f503314ab0f972">hwloc_cpuset_to_linux_libnuma_ulongs</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> cpuset,</div>
+<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *mask, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *maxnode)</div>
+<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>{</div>
+<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>);</div>
+<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> outmaxnode = -1;</div>
+<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> node = NULL;</div>
+<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span> </div>
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>  <span class="comment">/* round-up to the next ulong and clear all bytes */</span></div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>  *maxnode = (*maxnode + 8*<span class="keyword">sizeof</span>(*mask) - 1) &amp; ~(8*<span class="keyword">sizeof</span>(*mask) - 1);</div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>  memset(mask, 0, *maxnode/8);</div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span> </div>
+<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>  <span class="keywordflow">while</span> ((node = <a class="code hl_function" href="a00186.html#gaba4b6d86eba1169ced4b0e941d2bb5f0">hwloc_get_next_obj_covering_cpuset_by_depth</a>(topology, cpuset, depth, node)) != NULL) {</div>
+<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>    <span class="keywordflow">if</span> (node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a> &gt;= *maxnode)</div>
+<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>      <span class="keywordflow">continue</span>;</div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    mask[node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>/<span class="keyword">sizeof</span>(*mask)/8] |= 1UL &lt;&lt; (node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a> % (<span class="keyword">sizeof</span>(*mask)*8));</div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>    <span class="keywordflow">if</span> (outmaxnode == (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span>) -1 || outmaxnode &lt; node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>)</div>
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>      outmaxnode = node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>;</div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>  }</div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span> </div>
+<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>  *maxnode = outmaxnode+1;</div>
+<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>}</div>
+</div>
+<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
+<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00093" data-start="{" data-end="}">
+<div class="line"><a id="l00093" name="l00093"></a><span class="lineno"><a class="line" href="a00205.html#ga585ccf818d2f217f4e53f9c6506c3128">   93</a></span><a class="code hl_function" href="a00205.html#ga585ccf818d2f217f4e53f9c6506c3128">hwloc_nodeset_to_linux_libnuma_ulongs</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> nodeset,</div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>                                      <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *mask, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *maxnode)</div>
+<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>{</div>
+<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>);</div>
+<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> outmaxnode = -1;</div>
+<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> node = NULL;</div>
+<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span> </div>
+<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>  <span class="comment">/* round-up to the next ulong and clear all bytes */</span></div>
+<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>  *maxnode = (*maxnode + 8*<span class="keyword">sizeof</span>(*mask) - 1) &amp; ~(8*<span class="keyword">sizeof</span>(*mask) - 1);</div>
+<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>  memset(mask, 0, *maxnode/8);</div>
+<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span> </div>
+<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>  <span class="keywordflow">while</span> ((node = <a class="code hl_function" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a>(topology, depth, node)) != NULL) {</div>
+<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>    <span class="keywordflow">if</span> (node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a> &gt;= *maxnode)</div>
+<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>      <span class="keywordflow">continue</span>;</div>
+<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>    <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00194.html#ga11340dd487f110bb84f0a6e4ae90bd06">hwloc_bitmap_isset</a>(nodeset, node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>))</div>
+<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>      <span class="keywordflow">continue</span>;</div>
+<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>    mask[node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>/<span class="keyword">sizeof</span>(*mask)/8] |= 1UL &lt;&lt; (node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a> % (<span class="keyword">sizeof</span>(*mask)*8));</div>
+<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>    <span class="keywordflow">if</span> (outmaxnode == (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span>) -1 || outmaxnode &lt; node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>)</div>
+<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>      outmaxnode = node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>;</div>
+<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>  }</div>
+<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span> </div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>  *maxnode = outmaxnode+1;</div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>}</div>
+</div>
+<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span> </div>
+<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00131" data-start="{" data-end="}">
+<div class="line"><a id="l00131" name="l00131"></a><span class="lineno"><a class="line" href="a00205.html#ga0e9d051e068940f722f6fdc61814149d">  131</a></span><a class="code hl_function" href="a00205.html#ga0e9d051e068940f722f6fdc61814149d">hwloc_cpuset_from_linux_libnuma_ulongs</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> cpuset,</div>
+<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *mask, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> maxnode)</div>
+<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>{</div>
+<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>);</div>
+<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> node = NULL;</div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>  <a class="code hl_function" href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a>(cpuset);</div>
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>  <span class="keywordflow">while</span> ((node = <a class="code hl_function" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a>(topology, depth, node)) != NULL)</div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>    <span class="keywordflow">if</span> (node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a> &lt; maxnode</div>
+<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>        &amp;&amp; (mask[node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>/<span class="keyword">sizeof</span>(*mask)/8] &amp; (1UL &lt;&lt; (node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a> % (<span class="keyword">sizeof</span>(*mask)*8)))))</div>
+<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>      <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">hwloc_bitmap_or</a>(cpuset, cpuset, node-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>) &lt; 0)</div>
+<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>        <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>}</div>
+</div>
+<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span> </div>
+<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00158" data-start="{" data-end="}">
+<div class="line"><a id="l00158" name="l00158"></a><span class="lineno"><a class="line" href="a00205.html#gad8491c672eb2594cc5e7b0a026867192">  158</a></span><a class="code hl_function" href="a00205.html#gad8491c672eb2594cc5e7b0a026867192">hwloc_nodeset_from_linux_libnuma_ulongs</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a> nodeset,</div>
+<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *mask, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> maxnode)</div>
+<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>{</div>
+<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>);</div>
+<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> node = NULL;</div>
+<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>  <a class="code hl_function" href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a>(nodeset);</div>
+<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>  <span class="keywordflow">while</span> ((node = <a class="code hl_function" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a>(topology, depth, node)) != NULL)</div>
+<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>    <span class="keywordflow">if</span> (node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a> &lt; maxnode</div>
+<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        &amp;&amp; (mask[node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>/<span class="keyword">sizeof</span>(*mask)/8] &amp; (1UL &lt;&lt; (node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a> % (<span class="keyword">sizeof</span>(*mask)*8)))))</div>
+<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>      <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga062dbff93baeff3b425a7260c5463646">hwloc_bitmap_set</a>(nodeset, node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>) &lt; 0)</div>
+<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>        <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>}</div>
+</div>
+<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span> </div>
+<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span><span class="keyword">static</span> __hwloc_inline <span class="keyword">struct </span>bitmask *</div>
+<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span><a class="code hl_function" href="a00206.html#gad8769b4544c0aeef154fc8223144e343">hwloc_cpuset_to_linux_libnuma_bitmask</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> cpuset) __hwloc_attribute_malloc;</div>
+<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span><span class="keyword">static</span> __hwloc_inline <span class="keyword">struct </span>bitmask *</div>
+<div class="foldopen" id="foldopen00204" data-start="{" data-end="}">
+<div class="line"><a id="l00204" name="l00204"></a><span class="lineno"><a class="line" href="a00206.html#gad8769b4544c0aeef154fc8223144e343">  204</a></span><a class="code hl_function" href="a00206.html#gad8769b4544c0aeef154fc8223144e343">hwloc_cpuset_to_linux_libnuma_bitmask</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> cpuset)</div>
+<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>{</div>
+<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>);</div>
+<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> node = NULL;</div>
+<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>  <span class="keyword">struct </span>bitmask *bitmask = numa_allocate_cpumask();</div>
+<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>  <span class="keywordflow">if</span> (!bitmask)</div>
+<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>  <span class="keywordflow">while</span> ((node = <a class="code hl_function" href="a00186.html#gaba4b6d86eba1169ced4b0e941d2bb5f0">hwloc_get_next_obj_covering_cpuset_by_depth</a>(topology, cpuset, depth, node)) != NULL)</div>
+<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>    <span class="keywordflow">if</span> (node-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#ad066b9612802ffa01e132dc3a8e6cc86">numanode</a>.<a class="code hl_variable" href="a00237.html#a6703cbf2afbf63c9d60c5ff4dc0c73aa">local_memory</a>)</div>
+<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>      numa_bitmask_setbit(bitmask, node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>);</div>
+<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>  <span class="keywordflow">return</span> bitmask;</div>
+<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>}</div>
+</div>
+<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span> </div>
+<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span><span class="keyword">static</span> __hwloc_inline <span class="keyword">struct </span>bitmask *</div>
+<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span><a class="code hl_function" href="a00206.html#gadfaa14c1bec76965ac2e05f0c3f3473b">hwloc_nodeset_to_linux_libnuma_bitmask</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> nodeset) __hwloc_attribute_malloc;</div>
+<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span><span class="keyword">static</span> __hwloc_inline <span class="keyword">struct </span>bitmask *</div>
+<div class="foldopen" id="foldopen00229" data-start="{" data-end="}">
+<div class="line"><a id="l00229" name="l00229"></a><span class="lineno"><a class="line" href="a00206.html#gadfaa14c1bec76965ac2e05f0c3f3473b">  229</a></span><a class="code hl_function" href="a00206.html#gadfaa14c1bec76965ac2e05f0c3f3473b">hwloc_nodeset_to_linux_libnuma_bitmask</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> nodeset)</div>
+<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>{</div>
+<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>);</div>
+<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> node = NULL;</div>
+<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>  <span class="keyword">struct </span>bitmask *bitmask = numa_allocate_cpumask();</div>
+<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>  <span class="keywordflow">if</span> (!bitmask)</div>
+<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span>  <span class="keywordflow">while</span> ((node = <a class="code hl_function" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a>(topology, depth, node)) != NULL)</div>
+<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>    <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga11340dd487f110bb84f0a6e4ae90bd06">hwloc_bitmap_isset</a>(nodeset, node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>) &amp;&amp; node-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#ad066b9612802ffa01e132dc3a8e6cc86">numanode</a>.<a class="code hl_variable" href="a00237.html#a6703cbf2afbf63c9d60c5ff4dc0c73aa">local_memory</a>)</div>
+<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>      numa_bitmask_setbit(bitmask, node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>);</div>
+<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span>  <span class="keywordflow">return</span> bitmask;</div>
+<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span>}</div>
+</div>
+<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span> </div>
+<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00251" data-start="{" data-end="}">
+<div class="line"><a id="l00251" name="l00251"></a><span class="lineno"><a class="line" href="a00206.html#ga37c8421110b1842414809019098794ef">  251</a></span><a class="code hl_function" href="a00206.html#ga37c8421110b1842414809019098794ef">hwloc_cpuset_from_linux_libnuma_bitmask</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> cpuset,</div>
+<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>                                        <span class="keyword">const</span> <span class="keyword">struct</span> bitmask *bitmask)</div>
+<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>{</div>
+<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>);</div>
+<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> node = NULL;</div>
+<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span>  <a class="code hl_function" href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a>(cpuset);</div>
+<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>  <span class="keywordflow">while</span> ((node = <a class="code hl_function" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a>(topology, depth, node)) != NULL)</div>
+<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span>    <span class="keywordflow">if</span> (numa_bitmask_isbitset(bitmask, node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>))</div>
+<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span>      <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">hwloc_bitmap_or</a>(cpuset, cpuset, node-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>) &lt; 0)</div>
+<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>        <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span>}</div>
+</div>
+<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span> </div>
+<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00273" data-start="{" data-end="}">
+<div class="line"><a id="l00273" name="l00273"></a><span class="lineno"><a class="line" href="a00206.html#gaaca6bff3086aad5bdbd2f4c5f0ad14cc">  273</a></span><a class="code hl_function" href="a00206.html#gaaca6bff3086aad5bdbd2f4c5f0ad14cc">hwloc_nodeset_from_linux_libnuma_bitmask</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a> nodeset,</div>
+<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>                                         <span class="keyword">const</span> <span class="keyword">struct</span> bitmask *bitmask)</div>
+<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span>{</div>
+<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span>  <span class="keywordtype">int</span> depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>);</div>
+<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> node = NULL;</div>
+<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span>  <a class="code hl_function" href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a>(nodeset);</div>
+<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span>  <span class="keywordflow">while</span> ((node = <a class="code hl_function" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a>(topology, depth, node)) != NULL)</div>
+<div class="line"><a id="l00280" name="l00280"></a><span class="lineno">  280</span>    <span class="keywordflow">if</span> (numa_bitmask_isbitset(bitmask, node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>))</div>
+<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span>      <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga062dbff93baeff3b425a7260c5463646">hwloc_bitmap_set</a>(nodeset, node-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>) &lt; 0)</div>
+<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>        <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span>}</div>
+</div>
+<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span> </div>
+<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00291" name="l00291"></a><span class="lineno">  291</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span> </div>
+<div class="line"><a id="l00293" name="l00293"></a><span class="lineno">  293</span> </div>
+<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_LINUX_NUMA_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga1f784433e9b606261f62d1134f6a3b25"><div class="ttname"><a href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a></div><div class="ttdeci">hwloc_const_bitmap_t hwloc_const_cpuset_t</div><div class="ttdoc">A non-modifiable hwloc_cpuset_t.</div><div class="ttdef"><b>Definition</b> hwloc.h:163</div></div>
+<div class="ttc" id="aa00172_html_ga2f5276235841ad66a79bedad16a5a10c"><div class="ttname"><a href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a></div><div class="ttdeci">hwloc_const_bitmap_t hwloc_const_nodeset_t</div><div class="ttdoc">A non-modifiable hwloc_nodeset_t.</div><div class="ttdef"><b>Definition</b> hwloc.h:181</div></div>
+<div class="ttc" id="aa00172_html_ga37e35730fa7e775b5bb0afe893d6d508"><div class="ttname"><a href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_nodeset_t</div><div class="ttdoc">A node set is a bitmap whose bits are set according to NUMA memory node physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:178</div></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a></div><div class="ttdeci">@ HWLOC_OBJ_NUMANODE</div><div class="ttdoc">NUMA node. An object that contains memory that is directly and byte-accessible to the host processors...</div><div class="ttdef"><b>Definition</b> hwloc.h:257</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00176_html_ga8bec782e21be313750da70cf7428b374"><div class="ttname"><a href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a></div><div class="ttdeci">int hwloc_get_type_depth(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Returns the depth of objects of type type.</div></div>
+<div class="ttc" id="aa00176_html_gac140a9b939d9fa0b30c4a910efcb0656"><div class="ttname"><a href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_obj_by_depth(hwloc_topology_t topology, int depth, hwloc_obj_t prev)</div><div class="ttdoc">Returns the next object at depth depth.</div></div>
+<div class="ttc" id="aa00186_html_gaba4b6d86eba1169ced4b0e941d2bb5f0"><div class="ttname"><a href="a00186.html#gaba4b6d86eba1169ced4b0e941d2bb5f0">hwloc_get_next_obj_covering_cpuset_by_depth</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_obj_covering_cpuset_by_depth(hwloc_topology_t topology, hwloc_const_cpuset_t set, int depth, hwloc_obj_t prev)</div><div class="ttdoc">Iterate through same-depth objects covering at least CPU set set.</div><div class="ttdef"><b>Definition</b> helper.h:428</div></div>
+<div class="ttc" id="aa00194_html_ga062dbff93baeff3b425a7260c5463646"><div class="ttname"><a href="a00194.html#ga062dbff93baeff3b425a7260c5463646">hwloc_bitmap_set</a></div><div class="ttdeci">int hwloc_bitmap_set(hwloc_bitmap_t bitmap, unsigned id)</div><div class="ttdoc">Add index id in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga11340dd487f110bb84f0a6e4ae90bd06"><div class="ttname"><a href="a00194.html#ga11340dd487f110bb84f0a6e4ae90bd06">hwloc_bitmap_isset</a></div><div class="ttdeci">int hwloc_bitmap_isset(hwloc_const_bitmap_t bitmap, unsigned id)</div><div class="ttdoc">Test whether index id is part of bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga120b8aefb9ce7ef349929656359b1859"><div class="ttname"><a href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">hwloc_bitmap_or</a></div><div class="ttdeci">int hwloc_bitmap_or(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">Or bitmaps bitmap1 and bitmap2 and store the result in bitmap res.</div></div>
+<div class="ttc" id="aa00194_html_gaa97c5217613c8cae9862287170ea2132"><div class="ttname"><a href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a></div><div class="ttdeci">void hwloc_bitmap_zero(hwloc_bitmap_t bitmap)</div><div class="ttdoc">Empty the bitmap bitmap.</div></div>
+<div class="ttc" id="aa00205_html_ga0e9d051e068940f722f6fdc61814149d"><div class="ttname"><a href="a00205.html#ga0e9d051e068940f722f6fdc61814149d">hwloc_cpuset_from_linux_libnuma_ulongs</a></div><div class="ttdeci">static int hwloc_cpuset_from_linux_libnuma_ulongs(hwloc_topology_t topology, hwloc_cpuset_t cpuset, const unsigned long *mask, unsigned long maxnode)</div><div class="ttdoc">Convert the array of unsigned long mask into hwloc CPU set.</div><div class="ttdef"><b>Definition</b> linux-libnuma.h:131</div></div>
+<div class="ttc" id="aa00205_html_ga585ccf818d2f217f4e53f9c6506c3128"><div class="ttname"><a href="a00205.html#ga585ccf818d2f217f4e53f9c6506c3128">hwloc_nodeset_to_linux_libnuma_ulongs</a></div><div class="ttdeci">static int hwloc_nodeset_to_linux_libnuma_ulongs(hwloc_topology_t topology, hwloc_const_nodeset_t nodeset, unsigned long *mask, unsigned long *maxnode)</div><div class="ttdoc">Convert hwloc NUMA node set nodeset into the array of unsigned long mask.</div><div class="ttdef"><b>Definition</b> linux-libnuma.h:93</div></div>
+<div class="ttc" id="aa00205_html_gad8491c672eb2594cc5e7b0a026867192"><div class="ttname"><a href="a00205.html#gad8491c672eb2594cc5e7b0a026867192">hwloc_nodeset_from_linux_libnuma_ulongs</a></div><div class="ttdeci">static int hwloc_nodeset_from_linux_libnuma_ulongs(hwloc_topology_t topology, hwloc_nodeset_t nodeset, const unsigned long *mask, unsigned long maxnode)</div><div class="ttdoc">Convert the array of unsigned long mask into hwloc NUMA node set.</div><div class="ttdef"><b>Definition</b> linux-libnuma.h:158</div></div>
+<div class="ttc" id="aa00205_html_gae577962390f84b0b12f503314ab0f972"><div class="ttname"><a href="a00205.html#gae577962390f84b0b12f503314ab0f972">hwloc_cpuset_to_linux_libnuma_ulongs</a></div><div class="ttdeci">static int hwloc_cpuset_to_linux_libnuma_ulongs(hwloc_topology_t topology, hwloc_const_cpuset_t cpuset, unsigned long *mask, unsigned long *maxnode)</div><div class="ttdoc">Convert hwloc CPU set cpuset into the array of unsigned long mask.</div><div class="ttdef"><b>Definition</b> linux-libnuma.h:57</div></div>
+<div class="ttc" id="aa00206_html_ga37c8421110b1842414809019098794ef"><div class="ttname"><a href="a00206.html#ga37c8421110b1842414809019098794ef">hwloc_cpuset_from_linux_libnuma_bitmask</a></div><div class="ttdeci">static int hwloc_cpuset_from_linux_libnuma_bitmask(hwloc_topology_t topology, hwloc_cpuset_t cpuset, const struct bitmask *bitmask)</div><div class="ttdoc">Convert libnuma bitmask bitmask into hwloc CPU set cpuset.</div><div class="ttdef"><b>Definition</b> linux-libnuma.h:251</div></div>
+<div class="ttc" id="aa00206_html_gaaca6bff3086aad5bdbd2f4c5f0ad14cc"><div class="ttname"><a href="a00206.html#gaaca6bff3086aad5bdbd2f4c5f0ad14cc">hwloc_nodeset_from_linux_libnuma_bitmask</a></div><div class="ttdeci">static int hwloc_nodeset_from_linux_libnuma_bitmask(hwloc_topology_t topology, hwloc_nodeset_t nodeset, const struct bitmask *bitmask)</div><div class="ttdoc">Convert libnuma bitmask bitmask into hwloc NUMA node set nodeset.</div><div class="ttdef"><b>Definition</b> linux-libnuma.h:273</div></div>
+<div class="ttc" id="aa00206_html_gad8769b4544c0aeef154fc8223144e343"><div class="ttname"><a href="a00206.html#gad8769b4544c0aeef154fc8223144e343">hwloc_cpuset_to_linux_libnuma_bitmask</a></div><div class="ttdeci">static struct bitmask * hwloc_cpuset_to_linux_libnuma_bitmask(hwloc_topology_t topology, hwloc_const_cpuset_t cpuset)</div><div class="ttdoc">Convert hwloc CPU set cpuset into the returned libnuma bitmask.</div><div class="ttdef"><b>Definition</b> linux-libnuma.h:204</div></div>
+<div class="ttc" id="aa00206_html_gadfaa14c1bec76965ac2e05f0c3f3473b"><div class="ttname"><a href="a00206.html#gadfaa14c1bec76965ac2e05f0c3f3473b">hwloc_nodeset_to_linux_libnuma_bitmask</a></div><div class="ttdeci">static struct bitmask * hwloc_nodeset_to_linux_libnuma_bitmask(hwloc_topology_t topology, hwloc_const_nodeset_t nodeset)</div><div class="ttdoc">Convert hwloc NUMA node set nodeset into the returned libnuma bitmask.</div><div class="ttdef"><b>Definition</b> linux-libnuma.h:229</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_a61a7a80a68eaccbaaa28269e678c81a9"><div class="ttname"><a href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">hwloc_obj::os_index</a></div><div class="ttdeci">unsigned os_index</div><div class="ttdoc">OS-provided physical index number. It is not guaranteed unique across the entire machine,...</div><div class="ttdef"><b>Definition</b> hwloc.h:436</div></div>
+<div class="ttc" id="aa00229_html_a67925e0f2c47f50408fbdb9bddd0790f"><div class="ttname"><a href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">hwloc_obj::cpuset</a></div><div class="ttdeci">hwloc_cpuset_t cpuset</div><div class="ttdoc">CPUs covered by this object.</div><div class="ttdef"><b>Definition</b> hwloc.h:547</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00233_html_ad066b9612802ffa01e132dc3a8e6cc86"><div class="ttname"><a href="a00233.html#ad066b9612802ffa01e132dc3a8e6cc86">hwloc_obj_attr_u::numanode</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_numanode_attr_s numanode</div></div>
+<div class="ttc" id="aa00237_html_a6703cbf2afbf63c9d60c5ff4dc0c73aa"><div class="ttname"><a href="a00237.html#a6703cbf2afbf63c9d60c5ff4dc0c73aa">hwloc_obj_attr_u::hwloc_numanode_attr_s::local_memory</a></div><div class="ttdeci">hwloc_uint64_t local_memory</div><div class="ttdoc">Local memory (in bytes)</div><div class="ttdef"><b>Definition</b> hwloc.h:637</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00131_source.html 2.11.0-1/doc/doxygen-doc/html/a00131_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00131_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00131_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,90 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): windows.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">windows.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2021 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span> </div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#ifndef HWLOC_WINDOWS_H</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#define HWLOC_WINDOWS_H</span></div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
+<div class="line"><a id="l00050" name="l00050"></a><span class="lineno"><a class="line" href="a00207.html#gaa4376a1969660a344911d117f645d3dd">   50</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00207.html#gaa4376a1969660a344911d117f645d3dd">hwloc_windows_get_nr_processor_groups</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span> </div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno"><a class="line" href="a00207.html#ga167d1f28d3bd9defe1ffa940c14e8dd1">   66</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00207.html#ga167d1f28d3bd9defe1ffa940c14e8dd1">hwloc_windows_get_processor_group_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">unsigned</span> pg_index, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> cpuset, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span> </div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span> </div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span> </div>
+<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_WINDOWS_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00207_html_ga167d1f28d3bd9defe1ffa940c14e8dd1"><div class="ttname"><a href="a00207.html#ga167d1f28d3bd9defe1ffa940c14e8dd1">hwloc_windows_get_processor_group_cpuset</a></div><div class="ttdeci">int hwloc_windows_get_processor_group_cpuset(hwloc_topology_t topology, unsigned pg_index, hwloc_cpuset_t cpuset, unsigned long flags)</div><div class="ttdoc">Get the CPU-set of a Windows processor group.</div></div>
+<div class="ttc" id="aa00207_html_gaa4376a1969660a344911d117f645d3dd"><div class="ttname"><a href="a00207.html#gaa4376a1969660a344911d117f645d3dd">hwloc_windows_get_nr_processor_groups</a></div><div class="ttdeci">int hwloc_windows_get_nr_processor_groups(hwloc_topology_t topology, unsigned long flags)</div><div class="ttdoc">Get the number of Windows processor groups.</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00134_source.html 2.11.0-1/doc/doxygen-doc/html/a00134_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00134_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00134_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,165 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): glibc-sched.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">glibc-sched.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2009 CNRS</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2009-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * Copyright © 2009-2011 Université Bordeaux</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * Copyright © 2011 Cisco Systems, Inc.  All rights reserved.</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span> </div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#ifndef HWLOC_GLIBC_SCHED_H</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#define HWLOC_GLIBC_SCHED_H</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &quot;hwloc/helper.h&quot;</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &lt;assert.h&gt;</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#if !defined _GNU_SOURCE || (!defined _SCHED_H &amp;&amp; !defined _SCHED_H_) || (!defined CPU_SETSIZE &amp;&amp; !defined sched_priority)</span></div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span><span class="preprocessor">#error Please make sure to include sched.h before including glibc-sched.h, and define _GNU_SOURCE before any inclusion of sched.h</span></div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
+<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span> </div>
+<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
+<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span> </div>
+<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span><span class="preprocessor">#ifdef HWLOC_HAVE_CPU_SET</span></div>
+<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span> </div>
+<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span> </div>
+<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00059" data-start="{" data-end="}">
+<div class="line"><a id="l00059" name="l00059"></a><span class="lineno"><a class="line" href="a00208.html#ga88699a0c86c66a9b7baa3468cd9d24c3">   59</a></span><a class="code hl_function" href="a00208.html#ga88699a0c86c66a9b7baa3468cd9d24c3">hwloc_cpuset_to_glibc_sched_affinity</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_typedef" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> hwlocset,</div>
+<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>                                    cpu_set_t *schedset, <span class="keywordtype">size_t</span> schedsetsize)</div>
+<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>{</div>
+<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span><span class="preprocessor">#ifdef CPU_ZERO_S</span></div>
+<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>  <span class="keywordtype">unsigned</span> cpu;</div>
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>  CPU_ZERO_S(schedsetsize, schedset);</div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>  <a class="code hl_define" href="a00194.html#ga3f6861045a8029ade373510ffa727d2a">hwloc_bitmap_foreach_begin</a>(cpu, hwlocset)</div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    CPU_SET_S(cpu, schedsetsize, schedset);</div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>  <a class="code hl_define" href="a00194.html#gafcf3246db406218d4e155735b3fa6528">hwloc_bitmap_foreach_end</a>();</div>
+<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span><span class="preprocessor">#else </span><span class="comment">/* !CPU_ZERO_S */</span><span class="preprocessor"></span></div>
+<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>  <span class="keywordtype">unsigned</span> cpu;</div>
+<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>  CPU_ZERO(schedset);</div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>  assert(schedsetsize == <span class="keyword">sizeof</span>(cpu_set_t));</div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>  <a class="code hl_define" href="a00194.html#ga3f6861045a8029ade373510ffa727d2a">hwloc_bitmap_foreach_begin</a>(cpu, hwlocset)</div>
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>    CPU_SET(cpu, schedset);</div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>  <a class="code hl_define" href="a00194.html#gafcf3246db406218d4e155735b3fa6528">hwloc_bitmap_foreach_end</a>();</div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span><span class="preprocessor">#endif </span><span class="comment">/* !CPU_ZERO_S */</span><span class="preprocessor"></span></div>
+<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>}</div>
+</div>
+<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span> </div>
+<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00090" data-start="{" data-end="}">
+<div class="line"><a id="l00090" name="l00090"></a><span class="lineno"><a class="line" href="a00208.html#ga8ec807ec17de57fa77aa5cfd6c8e4bfb">   90</a></span><a class="code hl_function" href="a00208.html#ga8ec807ec17de57fa77aa5cfd6c8e4bfb">hwloc_cpuset_from_glibc_sched_affinity</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> hwlocset,</div>
+<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>                                       <span class="keyword">const</span> cpu_set_t *schedset, <span class="keywordtype">size_t</span> schedsetsize)</div>
+<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>{</div>
+<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>  <span class="keywordtype">int</span> cpu;</div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span><span class="preprocessor">#ifdef CPU_ZERO_S</span></div>
+<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>  <span class="keywordtype">int</span> count;</div>
+<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>  <a class="code hl_function" href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a>(hwlocset);</div>
+<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span><span class="preprocessor">#ifdef CPU_ZERO_S</span></div>
+<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>  count = CPU_COUNT_S(schedsetsize, schedset);</div>
+<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>  cpu = 0;</div>
+<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>  <span class="keywordflow">while</span> (count) {</div>
+<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>    <span class="keywordflow">if</span> (CPU_ISSET_S(cpu, schedsetsize, schedset)) {</div>
+<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>      <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga062dbff93baeff3b425a7260c5463646">hwloc_bitmap_set</a>(hwlocset, cpu) &lt; 0)</div>
+<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>        <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>      count--;</div>
+<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>    }</div>
+<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>    cpu++;</div>
+<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>  }</div>
+<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span><span class="preprocessor">#else </span><span class="comment">/* !CPU_ZERO_S */</span><span class="preprocessor"></span></div>
+<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>  <span class="comment">/* sched.h does not support dynamic cpu_set_t (introduced in glibc 2.7),</span></div>
+<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span><span class="comment">   * assume we have a very old interface without CPU_COUNT (added in 2.6)</span></div>
+<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span><span class="comment">   */</span></div>
+<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>  assert(schedsetsize == <span class="keyword">sizeof</span>(cpu_set_t));</div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>  <span class="keywordflow">for</span>(cpu=0; cpu&lt;CPU_SETSIZE; cpu++)</div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>    <span class="keywordflow">if</span> (CPU_ISSET(cpu, schedset))</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>      <span class="keywordflow">if</span> (<a class="code hl_function" href="a00194.html#ga062dbff93baeff3b425a7260c5463646">hwloc_bitmap_set</a>(hwlocset, cpu) &lt; 0)</div>
+<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span><span class="preprocessor">#endif </span><span class="comment">/* !CPU_ZERO_S */</span><span class="preprocessor"></span></div>
+<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>}</div>
+</div>
+<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span> </div>
+<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span><span class="preprocessor">#endif </span><span class="comment">/* CPU_SET */</span><span class="preprocessor"></span></div>
+<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span> </div>
+<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span> </div>
+<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span> </div>
+<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span> </div>
+<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_GLIBC_SCHED_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga1f784433e9b606261f62d1134f6a3b25"><div class="ttname"><a href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a></div><div class="ttdeci">hwloc_const_bitmap_t hwloc_const_cpuset_t</div><div class="ttdoc">A non-modifiable hwloc_cpuset_t.</div><div class="ttdef"><b>Definition</b> hwloc.h:163</div></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00194_html_ga062dbff93baeff3b425a7260c5463646"><div class="ttname"><a href="a00194.html#ga062dbff93baeff3b425a7260c5463646">hwloc_bitmap_set</a></div><div class="ttdeci">int hwloc_bitmap_set(hwloc_bitmap_t bitmap, unsigned id)</div><div class="ttdoc">Add index id in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_ga3f6861045a8029ade373510ffa727d2a"><div class="ttname"><a href="a00194.html#ga3f6861045a8029ade373510ffa727d2a">hwloc_bitmap_foreach_begin</a></div><div class="ttdeci">#define hwloc_bitmap_foreach_begin(id, bitmap)</div><div class="ttdoc">Loop macro iterating on bitmap bitmap.</div><div class="ttdef"><b>Definition</b> bitmap.h:387</div></div>
+<div class="ttc" id="aa00194_html_gaa97c5217613c8cae9862287170ea2132"><div class="ttname"><a href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a></div><div class="ttdeci">void hwloc_bitmap_zero(hwloc_bitmap_t bitmap)</div><div class="ttdoc">Empty the bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_gafcf3246db406218d4e155735b3fa6528"><div class="ttname"><a href="a00194.html#gafcf3246db406218d4e155735b3fa6528">hwloc_bitmap_foreach_end</a></div><div class="ttdeci">#define hwloc_bitmap_foreach_end()</div><div class="ttdoc">End of loop macro iterating on a bitmap.</div><div class="ttdef"><b>Definition</b> bitmap.h:401</div></div>
+<div class="ttc" id="aa00208_html_ga88699a0c86c66a9b7baa3468cd9d24c3"><div class="ttname"><a href="a00208.html#ga88699a0c86c66a9b7baa3468cd9d24c3">hwloc_cpuset_to_glibc_sched_affinity</a></div><div class="ttdeci">static int hwloc_cpuset_to_glibc_sched_affinity(hwloc_topology_t topology, hwloc_const_cpuset_t hwlocset, cpu_set_t *schedset, size_t schedsetsize)</div><div class="ttdoc">Convert hwloc CPU set toposet into glibc sched affinity CPU set schedset.</div><div class="ttdef"><b>Definition</b> glibc-sched.h:59</div></div>
+<div class="ttc" id="aa00208_html_ga8ec807ec17de57fa77aa5cfd6c8e4bfb"><div class="ttname"><a href="a00208.html#ga8ec807ec17de57fa77aa5cfd6c8e4bfb">hwloc_cpuset_from_glibc_sched_affinity</a></div><div class="ttdeci">static int hwloc_cpuset_from_glibc_sched_affinity(hwloc_topology_t topology, hwloc_cpuset_t hwlocset, const cpu_set_t *schedset, size_t schedsetsize)</div><div class="ttdoc">Convert glibc sched affinity CPU set schedset into hwloc CPU set.</div><div class="ttdef"><b>Definition</b> glibc-sched.h:90</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00137_source.html 2.11.0-1/doc/doxygen-doc/html/a00137_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00137_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00137_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,303 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): opencl.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">opencl.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2012-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2013, 2018 Université Bordeaux.  All right reserved.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span> </div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#ifndef HWLOC_OPENCL_H</span></div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#define HWLOC_OPENCL_H</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span> </div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &quot;hwloc/autogen/config.h&quot;</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &quot;hwloc/helper.h&quot;</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &quot;hwloc/linux.h&quot;</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">#ifdef __APPLE__</span></div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#include &lt;OpenCL/cl.h&gt;</span></div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="preprocessor">#include &lt;CL/cl.h&gt;</span></div>
+<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span> </div>
+<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span><span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
+<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
+<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
+<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span> </div>
+<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span> </div>
+<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span><span class="comment">/* OpenCL extensions aren&#39;t always shipped with default headers, and</span></div>
+<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span><span class="comment"> * they don&#39;t always reflect what the installed implementations support.</span></div>
+<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span><span class="comment"> * Try everything and let the implementation return errors when non supported.</span></div>
+<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span><span class="comment">/* Copyright (c) 2008-2018 The Khronos Group Inc. */</span></div>
+<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span> </div>
+<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span><span class="comment">/* needs &quot;cl_khr_pci_bus_info&quot; device extension, but not strictly required for clGetDeviceInfo() */</span></div>
+<div class="foldopen" id="foldopen00045" data-start="{" data-end="};">
+<div class="line"><a id="l00045" name="l00045"></a><span class="lineno"><a class="line" href="a00313.html">   45</a></span><span class="keyword">typedef</span> <span class="keyword">struct </span>{</div>
+<div class="line"><a id="l00046" name="l00046"></a><span class="lineno"><a class="line" href="a00313.html#a5bdfbcb0dee610f9f6f7f95ace89e298">   46</a></span>    cl_uint <a class="code hl_variable" href="a00313.html#a5bdfbcb0dee610f9f6f7f95ace89e298">pci_domain</a>;</div>
+<div class="line"><a id="l00047" name="l00047"></a><span class="lineno"><a class="line" href="a00313.html#a0e4d316b01eee00c3750d1c853be9c01">   47</a></span>    cl_uint <a class="code hl_variable" href="a00313.html#a0e4d316b01eee00c3750d1c853be9c01">pci_bus</a>;</div>
+<div class="line"><a id="l00048" name="l00048"></a><span class="lineno"><a class="line" href="a00313.html#a328717bdaeb2d117c550927cf41e6f72">   48</a></span>    cl_uint <a class="code hl_variable" href="a00313.html#a328717bdaeb2d117c550927cf41e6f72">pci_device</a>;</div>
+<div class="line"><a id="l00049" name="l00049"></a><span class="lineno"><a class="line" href="a00313.html#ab4032f46a44cf9ffc7b2ddc25001e3f0">   49</a></span>    cl_uint <a class="code hl_variable" href="a00313.html#ab4032f46a44cf9ffc7b2ddc25001e3f0">pci_function</a>;</div>
+<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>} <a class="code hl_struct" href="a00313.html">hwloc_cl_device_pci_bus_info_khr</a>;</div>
+</div>
+<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span><span class="preprocessor">#define HWLOC_CL_DEVICE_PCI_BUS_INFO_KHR 0x410F</span></div>
+<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span> </div>
+<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span><span class="comment">/* needs &quot;cl_amd_device_attribute_query&quot; device extension, but not strictly required for clGetDeviceInfo() */</span></div>
+<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span><span class="preprocessor">#define HWLOC_CL_DEVICE_TOPOLOGY_AMD 0x4037</span></div>
+<div class="foldopen" id="foldopen00055" data-start="{" data-end="};">
+<div class="line"><a id="l00055" name="l00055"></a><span class="lineno"><a class="line" href="a00317.html">   55</a></span><span class="keyword">typedef</span> <span class="keyword">union </span>{</div>
+<div class="line"><a id="l00056" name="l00056"></a><span class="lineno"><a class="line" href="a00317.html#afbd6b814607b06fc5b2f36ad14420398">   56</a></span>    <span class="keyword">struct </span>{ cl_uint type; cl_uint data[5]; } raw;</div>
+<div class="line"><a id="l00057" name="l00057"></a><span class="lineno"><a class="line" href="a00317.html#a4a23e3cc034b7ab105cab0e863dcab69">   57</a></span>    <span class="keyword">struct </span>{ cl_uint type; cl_char unused[17]; cl_char <a class="code hl_variable" href="a00317.html#a4a23e3cc034b7ab105cab0e863dcab69">bus</a>; cl_char device; cl_char function; } pcie;</div>
+<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>} <a class="code hl_union" href="a00317.html">hwloc_cl_device_topology_amd</a>;</div>
+</div>
+<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span><span class="preprocessor">#define HWLOC_CL_DEVICE_TOPOLOGY_TYPE_PCIE_AMD 1</span></div>
+<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span> </div>
+<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span><span class="comment">/* needs &quot;cl_nv_device_attribute_query&quot; device extension, but not strictly required for clGetDeviceInfo() */</span></div>
+<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span><span class="preprocessor">#define HWLOC_CL_DEVICE_PCI_BUS_ID_NV 0x4008</span></div>
+<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span><span class="preprocessor">#define HWLOC_CL_DEVICE_PCI_SLOT_ID_NV 0x4009</span></div>
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span><span class="preprocessor">#define HWLOC_CL_DEVICE_PCI_DOMAIN_ID_NV 0x400A</span></div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span> </div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span> </div>
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00086" data-start="{" data-end="}">
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno"><a class="line" href="a00209.html#gab89e4d20f8a353299351b41849e35ac9">   86</a></span><a class="code hl_function" href="a00209.html#gab89e4d20f8a353299351b41849e35ac9">hwloc_opencl_get_device_pci_busid</a>(cl_device_id device,</div>
+<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>                               <span class="keywordtype">unsigned</span> *domain, <span class="keywordtype">unsigned</span> *bus, <span class="keywordtype">unsigned</span> *dev, <span class="keywordtype">unsigned</span> *func)</div>
+<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>{</div>
+<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        <a class="code hl_union" href="a00317.html">hwloc_cl_device_topology_amd</a> amdtopo;</div>
+<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>        <a class="code hl_struct" href="a00313.html">hwloc_cl_device_pci_bus_info_khr</a> khrbusinfo;</div>
+<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>        cl_uint nvbus, nvslot, nvdomain;</div>
+<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>        cl_int clret;</div>
+<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span> </div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        clret = clGetDeviceInfo(device, HWLOC_CL_DEVICE_PCI_BUS_INFO_KHR, <span class="keyword">sizeof</span>(khrbusinfo), &amp;khrbusinfo, NULL);</div>
+<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        <span class="keywordflow">if</span> (CL_SUCCESS == clret) {</div>
+<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>                *domain = (unsigned) khrbusinfo.<a class="code hl_variable" href="a00313.html#a5bdfbcb0dee610f9f6f7f95ace89e298">pci_domain</a>;</div>
+<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>                *bus = (unsigned) khrbusinfo.<a class="code hl_variable" href="a00313.html#a0e4d316b01eee00c3750d1c853be9c01">pci_bus</a>;</div>
+<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>                *dev = (unsigned) khrbusinfo.<a class="code hl_variable" href="a00313.html#a328717bdaeb2d117c550927cf41e6f72">pci_device</a>;</div>
+<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>                *func = (unsigned) khrbusinfo.<a class="code hl_variable" href="a00313.html#ab4032f46a44cf9ffc7b2ddc25001e3f0">pci_function</a>;</div>
+<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>                <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>        }</div>
+<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span> </div>
+<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>        clret = clGetDeviceInfo(device, HWLOC_CL_DEVICE_TOPOLOGY_AMD, <span class="keyword">sizeof</span>(amdtopo), &amp;amdtopo, NULL);</div>
+<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>        <span class="keywordflow">if</span> (CL_SUCCESS == clret</div>
+<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>            &amp;&amp; HWLOC_CL_DEVICE_TOPOLOGY_TYPE_PCIE_AMD == amdtopo.<a class="code hl_variable" href="a00317.html#aeb5e5d12bf653f750dafedae6e225c3a">raw</a>.<a class="code hl_variable" href="a00317.html#a8ec4ea89b862bb271845b48063f332b4">type</a>) {</div>
+<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>                *domain = 0; <span class="comment">/* can&#39;t do anything better */</span></div>
+<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>                <span class="comment">/* cl_device_topology_amd stores bus ID in cl_char, dont convert those signed char directly to unsigned int */</span></div>
+<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>                *bus = (unsigned) (<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>) amdtopo.<a class="code hl_variable" href="a00317.html#aef8560f6c359be0c5bdbd2840580d79c">pcie</a>.<a class="code hl_variable" href="a00317.html#a4a23e3cc034b7ab105cab0e863dcab69">bus</a>;</div>
+<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>                *dev = (unsigned) (<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>) amdtopo.<a class="code hl_variable" href="a00317.html#aef8560f6c359be0c5bdbd2840580d79c">pcie</a>.<a class="code hl_variable" href="a00317.html#a017033a953d71455b067007cabb92e9c">device</a>;</div>
+<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>                *func = (unsigned) (<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>) amdtopo.<a class="code hl_variable" href="a00317.html#aef8560f6c359be0c5bdbd2840580d79c">pcie</a>.<a class="code hl_variable" href="a00317.html#a77a67ac73cff98d330ef7258b240bac3">function</a>;</div>
+<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>                <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        }</div>
+<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span> </div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>        clret = clGetDeviceInfo(device, HWLOC_CL_DEVICE_PCI_BUS_ID_NV, <span class="keyword">sizeof</span>(nvbus), &amp;nvbus, NULL);</div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>        <span class="keywordflow">if</span> (CL_SUCCESS == clret) {</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>                clret = clGetDeviceInfo(device, HWLOC_CL_DEVICE_PCI_SLOT_ID_NV, <span class="keyword">sizeof</span>(nvslot), &amp;nvslot, NULL);</div>
+<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>                <span class="keywordflow">if</span> (CL_SUCCESS == clret) {</div>
+<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>                        clret = clGetDeviceInfo(device, HWLOC_CL_DEVICE_PCI_DOMAIN_ID_NV, <span class="keyword">sizeof</span>(nvdomain), &amp;nvdomain, NULL);</div>
+<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>                        <span class="keywordflow">if</span> (CL_SUCCESS == clret) { <span class="comment">/* available since CUDA 10.2 */</span></div>
+<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>                                *domain = nvdomain;</div>
+<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>                        } <span class="keywordflow">else</span> {</div>
+<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>                                *domain = 0;</div>
+<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>                        }</div>
+<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>                        *bus = nvbus &amp; 0xff;</div>
+<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>                        <span class="comment">/* non-documented but used in many other projects */</span></div>
+<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>                        *dev = nvslot &gt;&gt; 3;</div>
+<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>                        *func = nvslot &amp; 0x7;</div>
+<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>                        <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>                }</div>
+<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>        }</div>
+<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span> </div>
+<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>        <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>}</div>
+</div>
+<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span> </div>
+<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00156" data-start="{" data-end="}">
+<div class="line"><a id="l00156" name="l00156"></a><span class="lineno"><a class="line" href="a00209.html#gacc32737d4648d16b0d292438f210ec90">  156</a></span><a class="code hl_function" href="a00209.html#gacc32737d4648d16b0d292438f210ec90">hwloc_opencl_get_device_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>                               cl_device_id device __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>                               <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</div>
+<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>{</div>
+<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span><span class="preprocessor">#if (defined HWLOC_LINUX_SYS)</span></div>
+<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>        <span class="comment">/* If we&#39;re on Linux, try AMD/NVIDIA extensions + the sysfs mechanism to get the local cpus */</span></div>
+<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span><span class="preprocessor">#define HWLOC_OPENCL_DEVICE_SYSFS_PATH_MAX 128</span></div>
+<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>        <span class="keywordtype">char</span> path[HWLOC_OPENCL_DEVICE_SYSFS_PATH_MAX];</div>
+<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>        <span class="keywordtype">unsigned</span> pcidomain, pcibus, pcidev, pcifunc;</div>
+<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span> </div>
+<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(topology)) {</div>
+<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>                errno = EINVAL;</div>
+<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>                <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>        }</div>
+<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span> </div>
+<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="a00209.html#gab89e4d20f8a353299351b41849e35ac9">hwloc_opencl_get_device_pci_busid</a>(device, &amp;pcidomain, &amp;pcibus, &amp;pcidev, &amp;pcifunc) &lt; 0) {</div>
+<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>                <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>                <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>        }</div>
+<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span> </div>
+<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>        sprintf(path, <span class="stringliteral">&quot;/sys/bus/pci/devices/%04x:%02x:%02x.%01x/local_cpus&quot;</span>, pcidomain, pcibus, pcidev, pcifunc);</div>
+<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a>(path, set) &lt; 0</div>
+<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>            || <a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(set))</div>
+<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>                <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>        <span class="comment">/* Non-Linux systems simply get a full cpuset */</span></div>
+<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>        <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>}</div>
+</div>
+<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span> </div>
+<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00203" data-start="{" data-end="}">
+<div class="line"><a id="l00203" name="l00203"></a><span class="lineno"><a class="line" href="a00209.html#gae39352d124cb330eb37b84b418ed6cc5">  203</a></span><a class="code hl_function" href="a00209.html#gae39352d124cb330eb37b84b418ed6cc5">hwloc_opencl_get_device_osdev_by_index</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>                                       <span class="keywordtype">unsigned</span> platform_index, <span class="keywordtype">unsigned</span> device_index)</div>
+<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>{</div>
+<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>        <span class="keywordtype">unsigned</span> x = (unsigned) -1, y = (<span class="keywordtype">unsigned</span>) -1;</div>
+<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev = NULL;</div>
+<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>        <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>                <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83">HWLOC_OBJ_OSDEV_COPROC</a> == osdev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a>.<a class="code hl_variable" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a></div>
+<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>                    &amp;&amp; osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a></div>
+<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>                    &amp;&amp; sscanf(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, <span class="stringliteral">&quot;opencl%ud%u&quot;</span>, &amp;x, &amp;y) == 2</div>
+<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>                    &amp;&amp; platform_index == x &amp;&amp; device_index == y)</div>
+<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>                        <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>        }</div>
+<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>        <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>}</div>
+</div>
+<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span> </div>
+<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00240" data-start="{" data-end="}">
+<div class="line"><a id="l00240" name="l00240"></a><span class="lineno"><a class="line" href="a00209.html#gadabfa6516aa12e5d8f79b9b4dd9f3cf8">  240</a></span><a class="code hl_function" href="a00209.html#gadabfa6516aa12e5d8f79b9b4dd9f3cf8">hwloc_opencl_get_device_osdev</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span>                              cl_device_id device __hwloc_attribute_unused)</div>
+<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>{</div>
+<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev;</div>
+<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>        <span class="keywordtype">unsigned</span> pcidomain, pcibus, pcidevice, pcifunc;</div>
+<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span> </div>
+<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="a00209.html#gab89e4d20f8a353299351b41849e35ac9">hwloc_opencl_get_device_pci_busid</a>(device, &amp;pcidomain, &amp;pcibus, &amp;pcidevice, &amp;pcifunc) &lt; 0) {</div>
+<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span>                errno = EINVAL;</div>
+<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>                <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>        }</div>
+<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span> </div>
+<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span>        osdev = NULL;</div>
+<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>        <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>                <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> pcidev = osdev-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>                <span class="keywordflow">if</span> (strncmp(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, <span class="stringliteral">&quot;opencl&quot;</span>, 6))</div>
+<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>                        <span class="keywordflow">continue</span>;</div>
+<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span>                <span class="keywordflow">if</span> (pcidev</div>
+<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a> == <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div>
+<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">domain</a> == pcidomain</div>
+<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">bus</a> == pcibus</div>
+<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">dev</a> == pcidevice</div>
+<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">func</a> == pcifunc)</div>
+<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span>                        <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>                <span class="comment">/* if PCI are filtered out, we need a info attr to match on */</span></div>
+<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>        }</div>
+<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span> </div>
+<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>        <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span>}</div>
+</div>
+<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span> </div>
+<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span> </div>
+<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span> </div>
+<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_OPENCL_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83">HWLOC_OBJ_OSDEV_COPROC</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_COPROC</div><div class="ttdoc">Operating system co-processor device. For instance &quot;opencl0d0&quot; for a OpenCL device,...</div><div class="ttdef"><b>Definition</b> hwloc.h:385</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div><div class="ttdeci">@ HWLOC_OBJ_PCI_DEVICE</div><div class="ttdoc">PCI device (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:295</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00182_html_ga68ffdcfd9175cdf40709801092f18017"><div class="ttname"><a href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a></div><div class="ttdeci">int hwloc_topology_is_thissystem(hwloc_topology_t restrict topology)</div><div class="ttdoc">Does the topology context come from this system?</div></div>
+<div class="ttc" id="aa00191_html_gaee30e03391c1ed7dfd617fb5c7bbb033"><div class="ttname"><a href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a></div><div class="ttdeci">hwloc_const_cpuset_t hwloc_topology_get_complete_cpuset(hwloc_topology_t topology)</div><div class="ttdoc">Get complete CPU set.</div></div>
+<div class="ttc" id="aa00193_html_ga8b4584c8949e2c5f1c97ba7fe92b8145"><div class="ttname"><a href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_osdev(hwloc_topology_t topology, hwloc_obj_t prev)</div><div class="ttdoc">Get the next OS device in the system.</div><div class="ttdef"><b>Definition</b> helper.h:1290</div></div>
+<div class="ttc" id="aa00194_html_ga5b64be28f5a7176ed8ad0d6a90bdf108"><div class="ttname"><a href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a></div><div class="ttdeci">int hwloc_bitmap_iszero(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Test whether bitmap bitmap is empty.</div></div>
+<div class="ttc" id="aa00194_html_ga72a29824798b48784b8217471ec8f14c"><div class="ttname"><a href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a></div><div class="ttdeci">int hwloc_bitmap_copy(hwloc_bitmap_t dst, hwloc_const_bitmap_t src)</div><div class="ttdoc">Copy the contents of bitmap src into the already allocated bitmap dst.</div></div>
+<div class="ttc" id="aa00204_html_gaf72d83e273803226ce772973e37b85de"><div class="ttname"><a href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a></div><div class="ttdeci">int hwloc_linux_read_path_as_cpumask(const char *path, hwloc_bitmap_t set)</div><div class="ttdoc">Convert a linux kernel cpumask file path into a hwloc bitmap set.</div></div>
+<div class="ttc" id="aa00209_html_gab89e4d20f8a353299351b41849e35ac9"><div class="ttname"><a href="a00209.html#gab89e4d20f8a353299351b41849e35ac9">hwloc_opencl_get_device_pci_busid</a></div><div class="ttdeci">static int hwloc_opencl_get_device_pci_busid(cl_device_id device, unsigned *domain, unsigned *bus, unsigned *dev, unsigned *func)</div><div class="ttdoc">Return the domain, bus and device IDs of the OpenCL device device.</div><div class="ttdef"><b>Definition</b> opencl.h:86</div></div>
+<div class="ttc" id="aa00209_html_gacc32737d4648d16b0d292438f210ec90"><div class="ttname"><a href="a00209.html#gacc32737d4648d16b0d292438f210ec90">hwloc_opencl_get_device_cpuset</a></div><div class="ttdeci">static int hwloc_opencl_get_device_cpuset(hwloc_topology_t topology, cl_device_id device, hwloc_cpuset_t set)</div><div class="ttdoc">Get the CPU set of processors that are physically close to OpenCL device device.</div><div class="ttdef"><b>Definition</b> opencl.h:156</div></div>
+<div class="ttc" id="aa00209_html_gadabfa6516aa12e5d8f79b9b4dd9f3cf8"><div class="ttname"><a href="a00209.html#gadabfa6516aa12e5d8f79b9b4dd9f3cf8">hwloc_opencl_get_device_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_opencl_get_device_osdev(hwloc_topology_t topology, cl_device_id device)</div><div class="ttdoc">Get the hwloc OS device object corresponding to OpenCL device deviceX.</div><div class="ttdef"><b>Definition</b> opencl.h:240</div></div>
+<div class="ttc" id="aa00209_html_gae39352d124cb330eb37b84b418ed6cc5"><div class="ttname"><a href="a00209.html#gae39352d124cb330eb37b84b418ed6cc5">hwloc_opencl_get_device_osdev_by_index</a></div><div class="ttdeci">static hwloc_obj_t hwloc_opencl_get_device_osdev_by_index(hwloc_topology_t topology, unsigned platform_index, unsigned device_index)</div><div class="ttdoc">Get the hwloc OS device object corresponding to the OpenCL device for the given indexes.</div><div class="ttdef"><b>Definition</b> opencl.h:203</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_abb709ec38f2970677e4e57d1d30be96d"><div class="ttname"><a href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj::name</a></div><div class="ttdeci">char * name</div><div class="ttdoc">Object-specific name if any. Mostly used for identifying OS devices and Misc objects where a name str...</div><div class="ttdef"><b>Definition</b> hwloc.h:443</div></div>
+<div class="ttc" id="aa00229_html_acc4f0803f244867e68fe0036800be5de"><div class="ttname"><a href="a00229.html#acc4f0803f244867e68fe0036800be5de">hwloc_obj::type</a></div><div class="ttdeci">hwloc_obj_type_t type</div><div class="ttdoc">Type of object.</div><div class="ttdef"><b>Definition</b> hwloc.h:433</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00229_html_adc494f6aed939992be1c55cca5822900"><div class="ttname"><a href="a00229.html#adc494f6aed939992be1c55cca5822900">hwloc_obj::parent</a></div><div class="ttdeci">struct hwloc_obj * parent</div><div class="ttdoc">Parent, NULL if root (Machine object)</div><div class="ttdef"><b>Definition</b> hwloc.h:481</div></div>
+<div class="ttc" id="aa00233_html_a0b66da7ab072f7c016f8ed86701f5a7c"><div class="ttname"><a href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">hwloc_obj_attr_u::pcidev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_pcidev_attr_s pcidev</div></div>
+<div class="ttc" id="aa00233_html_aaf7a5c38b5185703ff18c46ad2761dcf"><div class="ttname"><a href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">hwloc_obj_attr_u::osdev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_osdev_attr_s osdev</div></div>
+<div class="ttc" id="aa00253_html_a3d70c84a12f7e93d14c8d47bf4fd9dc5"><div class="ttname"><a href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">hwloc_obj_attr_u::hwloc_pcidev_attr_s::dev</a></div><div class="ttdeci">unsigned char dev</div><div class="ttdoc">Device number (zz in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:677</div></div>
+<div class="ttc" id="aa00253_html_a695f32df53f4ef728670bfcf31b74e0f"><div class="ttname"><a href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">hwloc_obj_attr_u::hwloc_pcidev_attr_s::func</a></div><div class="ttdeci">unsigned char func</div><div class="ttdoc">Function number (t in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:678</div></div>
+<div class="ttc" id="aa00253_html_a8fba44988deb98613c1505a4019a34dc"><div class="ttname"><a href="a00253.html#a8fba44988deb98613c1505a4019a34dc">hwloc_obj_attr_u::hwloc_pcidev_attr_s::domain</a></div><div class="ttdeci">unsigned short domain</div><div class="ttdoc">Domain number (xxxx in the PCI BDF notation xxxx:yy:zz.t). Only 16bits PCI domains are supported by d...</div><div class="ttdef"><b>Definition</b> hwloc.h:670</div></div>
+<div class="ttc" id="aa00253_html_aae99e035e8d1387d7b8768aaa8eceb0a"><div class="ttname"><a href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">hwloc_obj_attr_u::hwloc_pcidev_attr_s::bus</a></div><div class="ttdeci">unsigned char bus</div><div class="ttdoc">Bus number (yy in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:676</div></div>
+<div class="ttc" id="aa00273_html_a31e019e27e54ac6138d04be639bb96f9"><div class="ttname"><a href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">hwloc_obj_attr_u::hwloc_osdev_attr_s::type</a></div><div class="ttdeci">hwloc_obj_osdev_type_t type</div><div class="ttdef"><b>Definition</b> hwloc.h:716</div></div>
+<div class="ttc" id="aa00313_html"><div class="ttname"><a href="a00313.html">hwloc_cl_device_pci_bus_info_khr</a></div><div class="ttdef"><b>Definition</b> opencl.h:45</div></div>
+<div class="ttc" id="aa00313_html_a0e4d316b01eee00c3750d1c853be9c01"><div class="ttname"><a href="a00313.html#a0e4d316b01eee00c3750d1c853be9c01">hwloc_cl_device_pci_bus_info_khr::pci_bus</a></div><div class="ttdeci">cl_uint pci_bus</div><div class="ttdef"><b>Definition</b> opencl.h:47</div></div>
+<div class="ttc" id="aa00313_html_a328717bdaeb2d117c550927cf41e6f72"><div class="ttname"><a href="a00313.html#a328717bdaeb2d117c550927cf41e6f72">hwloc_cl_device_pci_bus_info_khr::pci_device</a></div><div class="ttdeci">cl_uint pci_device</div><div class="ttdef"><b>Definition</b> opencl.h:48</div></div>
+<div class="ttc" id="aa00313_html_a5bdfbcb0dee610f9f6f7f95ace89e298"><div class="ttname"><a href="a00313.html#a5bdfbcb0dee610f9f6f7f95ace89e298">hwloc_cl_device_pci_bus_info_khr::pci_domain</a></div><div class="ttdeci">cl_uint pci_domain</div><div class="ttdef"><b>Definition</b> opencl.h:46</div></div>
+<div class="ttc" id="aa00313_html_ab4032f46a44cf9ffc7b2ddc25001e3f0"><div class="ttname"><a href="a00313.html#ab4032f46a44cf9ffc7b2ddc25001e3f0">hwloc_cl_device_pci_bus_info_khr::pci_function</a></div><div class="ttdeci">cl_uint pci_function</div><div class="ttdef"><b>Definition</b> opencl.h:49</div></div>
+<div class="ttc" id="aa00317_html"><div class="ttname"><a href="a00317.html">hwloc_cl_device_topology_amd</a></div><div class="ttdef"><b>Definition</b> opencl.h:55</div></div>
+<div class="ttc" id="aa00317_html_a017033a953d71455b067007cabb92e9c"><div class="ttname"><a href="a00317.html#a017033a953d71455b067007cabb92e9c">hwloc_cl_device_topology_amd::device</a></div><div class="ttdeci">cl_char device</div><div class="ttdef"><b>Definition</b> opencl.h:57</div></div>
+<div class="ttc" id="aa00317_html_a4a23e3cc034b7ab105cab0e863dcab69"><div class="ttname"><a href="a00317.html#a4a23e3cc034b7ab105cab0e863dcab69">hwloc_cl_device_topology_amd::bus</a></div><div class="ttdeci">cl_char bus</div><div class="ttdef"><b>Definition</b> opencl.h:57</div></div>
+<div class="ttc" id="aa00317_html_a77a67ac73cff98d330ef7258b240bac3"><div class="ttname"><a href="a00317.html#a77a67ac73cff98d330ef7258b240bac3">hwloc_cl_device_topology_amd::function</a></div><div class="ttdeci">cl_char function</div><div class="ttdef"><b>Definition</b> opencl.h:57</div></div>
+<div class="ttc" id="aa00317_html_a8ec4ea89b862bb271845b48063f332b4"><div class="ttname"><a href="a00317.html#a8ec4ea89b862bb271845b48063f332b4">hwloc_cl_device_topology_amd::type</a></div><div class="ttdeci">cl_uint type</div><div class="ttdef"><b>Definition</b> opencl.h:56</div></div>
+<div class="ttc" id="aa00317_html_aeb5e5d12bf653f750dafedae6e225c3a"><div class="ttname"><a href="a00317.html#aeb5e5d12bf653f750dafedae6e225c3a">hwloc_cl_device_topology_amd::raw</a></div><div class="ttdeci">struct hwloc_cl_device_topology_amd::@0 raw</div></div>
+<div class="ttc" id="aa00317_html_aef8560f6c359be0c5bdbd2840580d79c"><div class="ttname"><a href="a00317.html#aef8560f6c359be0c5bdbd2840580d79c">hwloc_cl_device_topology_amd::pcie</a></div><div class="ttdeci">struct hwloc_cl_device_topology_amd::@1 pcie</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00140_source.html 2.11.0-1/doc/doxygen-doc/html/a00140_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00140_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00140_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,239 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): cuda.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">cuda.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2010-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2010-2011 Université Bordeaux</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * Copyright © 2011 Cisco Systems, Inc.  All rights reserved.</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#ifndef HWLOC_CUDA_H</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#define HWLOC_CUDA_H</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &quot;hwloc/autogen/config.h&quot;</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &quot;hwloc/helper.h&quot;</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &quot;hwloc/linux.h&quot;</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span> </div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span><span class="preprocessor">#include &lt;cuda.h&gt;</span></div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
+<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
+<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
+<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
+<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00050" data-start="{" data-end="}">
+<div class="line"><a id="l00050" name="l00050"></a><span class="lineno"><a class="line" href="a00210.html#ga1084285e8ff8b7df91c28917637481c6">   50</a></span><a class="code hl_function" href="a00210.html#ga1084285e8ff8b7df91c28917637481c6">hwloc_cuda_get_device_pci_ids</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>                              CUdevice cudevice, <span class="keywordtype">int</span> *domain, <span class="keywordtype">int</span> *bus, <span class="keywordtype">int</span> *dev)</div>
+<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>{</div>
+<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>  CUresult cres;</div>
+<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span> </div>
+<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span><span class="preprocessor">#if CUDA_VERSION &gt;= 4000</span></div>
+<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>  cres = cuDeviceGetAttribute(domain, CU_DEVICE_ATTRIBUTE_PCI_DOMAIN_ID, cudevice);</div>
+<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>  <span class="keywordflow">if</span> (cres != CUDA_SUCCESS) {</div>
+<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>    errno = ENOSYS;</div>
+<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>  }</div>
+<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>  *domain = 0;</div>
+<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>  cres = cuDeviceGetAttribute(bus, CU_DEVICE_ATTRIBUTE_PCI_BUS_ID, cudevice);</div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>  <span class="keywordflow">if</span> (cres != CUDA_SUCCESS) {</div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    errno = ENOSYS;</div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>  }</div>
+<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>  cres = cuDeviceGetAttribute(dev, CU_DEVICE_ATTRIBUTE_PCI_DEVICE_ID, cudevice);</div>
+<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>  <span class="keywordflow">if</span> (cres != CUDA_SUCCESS) {</div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    errno = ENOSYS;</div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>  }</div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span> </div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>}</div>
+</div>
+<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span> </div>
+<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00098" data-start="{" data-end="}">
+<div class="line"><a id="l00098" name="l00098"></a><span class="lineno"><a class="line" href="a00210.html#gaec41c6b4dc3361156beb7dea2a74f5a3">   98</a></span><a class="code hl_function" href="a00210.html#gaec41c6b4dc3361156beb7dea2a74f5a3">hwloc_cuda_get_device_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>                             CUdevice cudevice, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</div>
+<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>{</div>
+<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>  <span class="comment">/* If we&#39;re on Linux, use the sysfs mechanism to get the local cpus */</span></div>
+<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span><span class="preprocessor">#define HWLOC_CUDA_DEVICE_SYSFS_PATH_MAX 128</span></div>
+<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>  <span class="keywordtype">char</span> path[HWLOC_CUDA_DEVICE_SYSFS_PATH_MAX];</div>
+<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>  <span class="keywordtype">int</span> domainid, busid, deviceid;</div>
+<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span> </div>
+<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00210.html#ga1084285e8ff8b7df91c28917637481c6">hwloc_cuda_get_device_pci_ids</a>(topology, cudevice, &amp;domainid, &amp;busid, &amp;deviceid))</div>
+<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span> </div>
+<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>  <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(topology)) {</div>
+<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>  }</div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span> </div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>  sprintf(path, <span class="stringliteral">&quot;/sys/bus/pci/devices/%04x:%02x:%02x.0/local_cpus&quot;</span>, domainid, busid, deviceid);</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a>(path, set) &lt; 0</div>
+<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>      || <a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(set))</div>
+<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>    <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>  <span class="comment">/* Non-Linux systems simply get a full cpuset */</span></div>
+<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>  <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>}</div>
+</div>
+<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span> </div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00137" data-start="{" data-end="}">
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno"><a class="line" href="a00210.html#ga11fed607fa404e29e8da010f3ec128e4">  137</a></span><a class="code hl_function" href="a00210.html#ga11fed607fa404e29e8da010f3ec128e4">hwloc_cuda_get_device_pcidev</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, CUdevice cudevice)</div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>{</div>
+<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>  <span class="keywordtype">int</span> domain, bus, dev;</div>
+<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span> </div>
+<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00210.html#ga1084285e8ff8b7df91c28917637481c6">hwloc_cuda_get_device_pci_ids</a>(topology, cudevice, &amp;domain, &amp;bus, &amp;dev))</div>
+<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span> </div>
+<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>  <span class="keywordflow">return</span> <a class="code hl_function" href="a00193.html#gacdbaf0db98872e224b7883a84bfb0455">hwloc_get_pcidev_by_busid</a>(topology, domain, bus, dev, 0);</div>
+<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>}</div>
+</div>
+<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span> </div>
+<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00163" data-start="{" data-end="}">
+<div class="line"><a id="l00163" name="l00163"></a><span class="lineno"><a class="line" href="a00210.html#ga252cb72175f1a2d682f883a0add80a66">  163</a></span><a class="code hl_function" href="a00210.html#ga252cb72175f1a2d682f883a0add80a66">hwloc_cuda_get_device_osdev</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, CUdevice cudevice)</div>
+<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>{</div>
+<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev = NULL;</div>
+<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        <span class="keywordtype">int</span> domain, bus, dev;</div>
+<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span> </div>
+<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="a00210.html#ga1084285e8ff8b7df91c28917637481c6">hwloc_cuda_get_device_pci_ids</a>(topology, cudevice, &amp;domain, &amp;bus, &amp;dev))</div>
+<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>                <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span> </div>
+<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        osdev = NULL;</div>
+<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>        <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>                <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> pcidev = osdev-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>                <span class="keywordflow">if</span> (strncmp(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, <span class="stringliteral">&quot;cuda&quot;</span>, 4))</div>
+<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>                        <span class="keywordflow">continue</span>;</div>
+<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>                <span class="keywordflow">if</span> (pcidev</div>
+<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a> == <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div>
+<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>                    &amp;&amp; (<span class="keywordtype">int</span>) pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">domain</a> == domain</div>
+<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>                    &amp;&amp; (<span class="keywordtype">int</span>) pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">bus</a> == bus</div>
+<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span>                    &amp;&amp; (<span class="keywordtype">int</span>) pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">dev</a> == dev</div>
+<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">func</a> == 0)</div>
+<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>                        <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>                <span class="comment">/* if PCI are filtered out, we need a info attr to match on */</span></div>
+<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>        }</div>
+<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span> </div>
+<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>        <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>}</div>
+</div>
+<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span> </div>
+<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00205" data-start="{" data-end="}">
+<div class="line"><a id="l00205" name="l00205"></a><span class="lineno"><a class="line" href="a00210.html#ga12ee892994ed037e8f64bbffda02cf2e">  205</a></span><a class="code hl_function" href="a00210.html#ga12ee892994ed037e8f64bbffda02cf2e">hwloc_cuda_get_device_osdev_by_index</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">unsigned</span> idx)</div>
+<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>{</div>
+<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev = NULL;</div>
+<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>        <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>                <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83">HWLOC_OBJ_OSDEV_COPROC</a> == osdev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a>.<a class="code hl_variable" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a></div>
+<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>                    &amp;&amp; osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a></div>
+<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>                    &amp;&amp; !strncmp(<span class="stringliteral">&quot;cuda&quot;</span>, osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, 4)</div>
+<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>                    &amp;&amp; atoi(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a> + 4) == (<span class="keywordtype">int</span>) idx)</div>
+<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>                        <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>        }</div>
+<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>        <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>}</div>
+</div>
+<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span> </div>
+<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span> </div>
+<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span> </div>
+<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_CUDA_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83">HWLOC_OBJ_OSDEV_COPROC</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_COPROC</div><div class="ttdoc">Operating system co-processor device. For instance &quot;opencl0d0&quot; for a OpenCL device,...</div><div class="ttdef"><b>Definition</b> hwloc.h:385</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div><div class="ttdeci">@ HWLOC_OBJ_PCI_DEVICE</div><div class="ttdoc">PCI device (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:295</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00182_html_ga68ffdcfd9175cdf40709801092f18017"><div class="ttname"><a href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a></div><div class="ttdeci">int hwloc_topology_is_thissystem(hwloc_topology_t restrict topology)</div><div class="ttdoc">Does the topology context come from this system?</div></div>
+<div class="ttc" id="aa00191_html_gaee30e03391c1ed7dfd617fb5c7bbb033"><div class="ttname"><a href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a></div><div class="ttdeci">hwloc_const_cpuset_t hwloc_topology_get_complete_cpuset(hwloc_topology_t topology)</div><div class="ttdoc">Get complete CPU set.</div></div>
+<div class="ttc" id="aa00193_html_ga8b4584c8949e2c5f1c97ba7fe92b8145"><div class="ttname"><a href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_osdev(hwloc_topology_t topology, hwloc_obj_t prev)</div><div class="ttdoc">Get the next OS device in the system.</div><div class="ttdef"><b>Definition</b> helper.h:1290</div></div>
+<div class="ttc" id="aa00193_html_gacdbaf0db98872e224b7883a84bfb0455"><div class="ttname"><a href="a00193.html#gacdbaf0db98872e224b7883a84bfb0455">hwloc_get_pcidev_by_busid</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_pcidev_by_busid(hwloc_topology_t topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)</div><div class="ttdoc">Find the PCI device object matching the PCI bus id given domain, bus device and function PCI bus id.</div><div class="ttdef"><b>Definition</b> helper.h:1249</div></div>
+<div class="ttc" id="aa00194_html_ga5b64be28f5a7176ed8ad0d6a90bdf108"><div class="ttname"><a href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a></div><div class="ttdeci">int hwloc_bitmap_iszero(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Test whether bitmap bitmap is empty.</div></div>
+<div class="ttc" id="aa00194_html_ga72a29824798b48784b8217471ec8f14c"><div class="ttname"><a href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a></div><div class="ttdeci">int hwloc_bitmap_copy(hwloc_bitmap_t dst, hwloc_const_bitmap_t src)</div><div class="ttdoc">Copy the contents of bitmap src into the already allocated bitmap dst.</div></div>
+<div class="ttc" id="aa00204_html_gaf72d83e273803226ce772973e37b85de"><div class="ttname"><a href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a></div><div class="ttdeci">int hwloc_linux_read_path_as_cpumask(const char *path, hwloc_bitmap_t set)</div><div class="ttdoc">Convert a linux kernel cpumask file path into a hwloc bitmap set.</div></div>
+<div class="ttc" id="aa00210_html_ga1084285e8ff8b7df91c28917637481c6"><div class="ttname"><a href="a00210.html#ga1084285e8ff8b7df91c28917637481c6">hwloc_cuda_get_device_pci_ids</a></div><div class="ttdeci">static int hwloc_cuda_get_device_pci_ids(hwloc_topology_t topology, CUdevice cudevice, int *domain, int *bus, int *dev)</div><div class="ttdoc">Return the domain, bus and device IDs of the CUDA device cudevice.</div><div class="ttdef"><b>Definition</b> cuda.h:50</div></div>
+<div class="ttc" id="aa00210_html_ga11fed607fa404e29e8da010f3ec128e4"><div class="ttname"><a href="a00210.html#ga11fed607fa404e29e8da010f3ec128e4">hwloc_cuda_get_device_pcidev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_cuda_get_device_pcidev(hwloc_topology_t topology, CUdevice cudevice)</div><div class="ttdoc">Get the hwloc PCI device object corresponding to the CUDA device cudevice.</div><div class="ttdef"><b>Definition</b> cuda.h:137</div></div>
+<div class="ttc" id="aa00210_html_ga12ee892994ed037e8f64bbffda02cf2e"><div class="ttname"><a href="a00210.html#ga12ee892994ed037e8f64bbffda02cf2e">hwloc_cuda_get_device_osdev_by_index</a></div><div class="ttdeci">static hwloc_obj_t hwloc_cuda_get_device_osdev_by_index(hwloc_topology_t topology, unsigned idx)</div><div class="ttdoc">Get the hwloc OS device object corresponding to the CUDA device whose index is idx.</div><div class="ttdef"><b>Definition</b> cuda.h:205</div></div>
+<div class="ttc" id="aa00210_html_ga252cb72175f1a2d682f883a0add80a66"><div class="ttname"><a href="a00210.html#ga252cb72175f1a2d682f883a0add80a66">hwloc_cuda_get_device_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_cuda_get_device_osdev(hwloc_topology_t topology, CUdevice cudevice)</div><div class="ttdoc">Get the hwloc OS device object corresponding to CUDA device cudevice.</div><div class="ttdef"><b>Definition</b> cuda.h:163</div></div>
+<div class="ttc" id="aa00210_html_gaec41c6b4dc3361156beb7dea2a74f5a3"><div class="ttname"><a href="a00210.html#gaec41c6b4dc3361156beb7dea2a74f5a3">hwloc_cuda_get_device_cpuset</a></div><div class="ttdeci">static int hwloc_cuda_get_device_cpuset(hwloc_topology_t topology, CUdevice cudevice, hwloc_cpuset_t set)</div><div class="ttdoc">Get the CPU set of processors that are physically close to device cudevice.</div><div class="ttdef"><b>Definition</b> cuda.h:98</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_abb709ec38f2970677e4e57d1d30be96d"><div class="ttname"><a href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj::name</a></div><div class="ttdeci">char * name</div><div class="ttdoc">Object-specific name if any. Mostly used for identifying OS devices and Misc objects where a name str...</div><div class="ttdef"><b>Definition</b> hwloc.h:443</div></div>
+<div class="ttc" id="aa00229_html_acc4f0803f244867e68fe0036800be5de"><div class="ttname"><a href="a00229.html#acc4f0803f244867e68fe0036800be5de">hwloc_obj::type</a></div><div class="ttdeci">hwloc_obj_type_t type</div><div class="ttdoc">Type of object.</div><div class="ttdef"><b>Definition</b> hwloc.h:433</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00229_html_adc494f6aed939992be1c55cca5822900"><div class="ttname"><a href="a00229.html#adc494f6aed939992be1c55cca5822900">hwloc_obj::parent</a></div><div class="ttdeci">struct hwloc_obj * parent</div><div class="ttdoc">Parent, NULL if root (Machine object)</div><div class="ttdef"><b>Definition</b> hwloc.h:481</div></div>
+<div class="ttc" id="aa00233_html_a0b66da7ab072f7c016f8ed86701f5a7c"><div class="ttname"><a href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">hwloc_obj_attr_u::pcidev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_pcidev_attr_s pcidev</div></div>
+<div class="ttc" id="aa00233_html_aaf7a5c38b5185703ff18c46ad2761dcf"><div class="ttname"><a href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">hwloc_obj_attr_u::osdev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_osdev_attr_s osdev</div></div>
+<div class="ttc" id="aa00253_html_a3d70c84a12f7e93d14c8d47bf4fd9dc5"><div class="ttname"><a href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">hwloc_obj_attr_u::hwloc_pcidev_attr_s::dev</a></div><div class="ttdeci">unsigned char dev</div><div class="ttdoc">Device number (zz in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:677</div></div>
+<div class="ttc" id="aa00253_html_a695f32df53f4ef728670bfcf31b74e0f"><div class="ttname"><a href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">hwloc_obj_attr_u::hwloc_pcidev_attr_s::func</a></div><div class="ttdeci">unsigned char func</div><div class="ttdoc">Function number (t in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:678</div></div>
+<div class="ttc" id="aa00253_html_a8fba44988deb98613c1505a4019a34dc"><div class="ttname"><a href="a00253.html#a8fba44988deb98613c1505a4019a34dc">hwloc_obj_attr_u::hwloc_pcidev_attr_s::domain</a></div><div class="ttdeci">unsigned short domain</div><div class="ttdoc">Domain number (xxxx in the PCI BDF notation xxxx:yy:zz.t). Only 16bits PCI domains are supported by d...</div><div class="ttdef"><b>Definition</b> hwloc.h:670</div></div>
+<div class="ttc" id="aa00253_html_aae99e035e8d1387d7b8768aaa8eceb0a"><div class="ttname"><a href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">hwloc_obj_attr_u::hwloc_pcidev_attr_s::bus</a></div><div class="ttdeci">unsigned char bus</div><div class="ttdoc">Bus number (yy in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:676</div></div>
+<div class="ttc" id="aa00273_html_a31e019e27e54ac6138d04be639bb96f9"><div class="ttname"><a href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">hwloc_obj_attr_u::hwloc_osdev_attr_s::type</a></div><div class="ttdeci">hwloc_obj_osdev_type_t type</div><div class="ttdef"><b>Definition</b> hwloc.h:716</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00143_source.html 2.11.0-1/doc/doxygen-doc/html/a00143_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00143_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00143_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,198 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): cudart.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">cudart.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2010-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2010-2011 Université Bordeaux</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * Copyright © 2011 Cisco Systems, Inc.  All rights reserved.</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#ifndef HWLOC_CUDART_H</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#define HWLOC_CUDART_H</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &quot;hwloc/autogen/config.h&quot;</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &quot;hwloc/helper.h&quot;</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &quot;hwloc/linux.h&quot;</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span> </div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span><span class="preprocessor">#include &lt;cuda.h&gt;</span> <span class="comment">/* for CUDA_VERSION */</span></div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="preprocessor">#include &lt;cuda_runtime_api.h&gt;</span></div>
+<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
+<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span> </div>
+<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
+<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span> </div>
+<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00051" data-start="{" data-end="}">
+<div class="line"><a id="l00051" name="l00051"></a><span class="lineno"><a class="line" href="a00211.html#gad8b701d9a34923e34bd58defd4c1e704">   51</a></span><a class="code hl_function" href="a00211.html#gad8b701d9a34923e34bd58defd4c1e704">hwloc_cudart_get_device_pci_ids</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>                                <span class="keywordtype">int</span> idx, <span class="keywordtype">int</span> *domain, <span class="keywordtype">int</span> *bus, <span class="keywordtype">int</span> *dev)</div>
+<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>{</div>
+<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>  cudaError_t cerr;</div>
+<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>  <span class="keyword">struct </span>cudaDeviceProp prop;</div>
+<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span> </div>
+<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>  cerr = cudaGetDeviceProperties(&amp;prop, idx);</div>
+<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>  <span class="keywordflow">if</span> (cerr) {</div>
+<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>    errno = ENOSYS;</div>
+<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>  }</div>
+<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span> </div>
+<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span><span class="preprocessor">#if CUDA_VERSION &gt;= 4000</span></div>
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>  *domain = prop.pciDomainID;</div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>  *domain = 0;</div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span> </div>
+<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>  *bus = prop.pciBusID;</div>
+<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>  *dev = prop.pciDeviceID;</div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span> </div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>}</div>
+</div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span> </div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00095" data-start="{" data-end="}">
+<div class="line"><a id="l00095" name="l00095"></a><span class="lineno"><a class="line" href="a00211.html#ga187ca00c6e12800a25151ce331620980">   95</a></span><a class="code hl_function" href="a00211.html#ga187ca00c6e12800a25151ce331620980">hwloc_cudart_get_device_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>                               <span class="keywordtype">int</span> idx, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</div>
+<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>{</div>
+<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>  <span class="comment">/* If we&#39;re on Linux, use the sysfs mechanism to get the local cpus */</span></div>
+<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span><span class="preprocessor">#define HWLOC_CUDART_DEVICE_SYSFS_PATH_MAX 128</span></div>
+<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>  <span class="keywordtype">char</span> path[HWLOC_CUDART_DEVICE_SYSFS_PATH_MAX];</div>
+<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>  <span class="keywordtype">int</span> domain, bus, dev;</div>
+<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span> </div>
+<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00211.html#gad8b701d9a34923e34bd58defd4c1e704">hwloc_cudart_get_device_pci_ids</a>(topology, idx, &amp;domain, &amp;bus, &amp;dev))</div>
+<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span> </div>
+<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>  <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(topology)) {</div>
+<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>  }</div>
+<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span> </div>
+<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>  sprintf(path, <span class="stringliteral">&quot;/sys/bus/pci/devices/%04x:%02x:%02x.0/local_cpus&quot;</span>, (<span class="keywordtype">unsigned</span>) domain, (<span class="keywordtype">unsigned</span>) bus, (<span class="keywordtype">unsigned</span>) dev);</div>
+<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a>(path, set) &lt; 0</div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>      || <a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(set))</div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>    <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>  <span class="comment">/* Non-Linux systems simply get a full cpuset */</span></div>
+<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>  <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>}</div>
+</div>
+<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span> </div>
+<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00134" data-start="{" data-end="}">
+<div class="line"><a id="l00134" name="l00134"></a><span class="lineno"><a class="line" href="a00211.html#gaeda4e6efbb36b518b2c286434ad23bb2">  134</a></span><a class="code hl_function" href="a00211.html#gaeda4e6efbb36b518b2c286434ad23bb2">hwloc_cudart_get_device_pcidev</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">int</span> idx)</div>
+<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>{</div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>  <span class="keywordtype">int</span> domain, bus, dev;</div>
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span> </div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00211.html#gad8b701d9a34923e34bd58defd4c1e704">hwloc_cudart_get_device_pci_ids</a>(topology, idx, &amp;domain, &amp;bus, &amp;dev))</div>
+<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span> </div>
+<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>  <span class="keywordflow">return</span> <a class="code hl_function" href="a00193.html#gacdbaf0db98872e224b7883a84bfb0455">hwloc_get_pcidev_by_busid</a>(topology, domain, bus, dev, 0);</div>
+<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>}</div>
+</div>
+<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span> </div>
+<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00162" data-start="{" data-end="}">
+<div class="line"><a id="l00162" name="l00162"></a><span class="lineno"><a class="line" href="a00211.html#gac0f3eeaf7712919f298097b1a21307b0">  162</a></span><a class="code hl_function" href="a00211.html#gac0f3eeaf7712919f298097b1a21307b0">hwloc_cudart_get_device_osdev_by_index</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">unsigned</span> idx)</div>
+<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>{</div>
+<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev = NULL;</div>
+<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>        <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>                <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83">HWLOC_OBJ_OSDEV_COPROC</a> == osdev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a>.<a class="code hl_variable" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a></div>
+<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>                    &amp;&amp; osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a></div>
+<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>                    &amp;&amp; !strncmp(<span class="stringliteral">&quot;cuda&quot;</span>, osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, 4)</div>
+<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>                    &amp;&amp; atoi(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a> + 4) == (<span class="keywordtype">int</span>) idx)</div>
+<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>                        <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        }</div>
+<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>        <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>}</div>
+</div>
+<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span> </div>
+<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span> </div>
+<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span> </div>
+<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_CUDART_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83">HWLOC_OBJ_OSDEV_COPROC</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_COPROC</div><div class="ttdoc">Operating system co-processor device. For instance &quot;opencl0d0&quot; for a OpenCL device,...</div><div class="ttdef"><b>Definition</b> hwloc.h:385</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00182_html_ga68ffdcfd9175cdf40709801092f18017"><div class="ttname"><a href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a></div><div class="ttdeci">int hwloc_topology_is_thissystem(hwloc_topology_t restrict topology)</div><div class="ttdoc">Does the topology context come from this system?</div></div>
+<div class="ttc" id="aa00191_html_gaee30e03391c1ed7dfd617fb5c7bbb033"><div class="ttname"><a href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a></div><div class="ttdeci">hwloc_const_cpuset_t hwloc_topology_get_complete_cpuset(hwloc_topology_t topology)</div><div class="ttdoc">Get complete CPU set.</div></div>
+<div class="ttc" id="aa00193_html_ga8b4584c8949e2c5f1c97ba7fe92b8145"><div class="ttname"><a href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_osdev(hwloc_topology_t topology, hwloc_obj_t prev)</div><div class="ttdoc">Get the next OS device in the system.</div><div class="ttdef"><b>Definition</b> helper.h:1290</div></div>
+<div class="ttc" id="aa00193_html_gacdbaf0db98872e224b7883a84bfb0455"><div class="ttname"><a href="a00193.html#gacdbaf0db98872e224b7883a84bfb0455">hwloc_get_pcidev_by_busid</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_pcidev_by_busid(hwloc_topology_t topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)</div><div class="ttdoc">Find the PCI device object matching the PCI bus id given domain, bus device and function PCI bus id.</div><div class="ttdef"><b>Definition</b> helper.h:1249</div></div>
+<div class="ttc" id="aa00194_html_ga5b64be28f5a7176ed8ad0d6a90bdf108"><div class="ttname"><a href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a></div><div class="ttdeci">int hwloc_bitmap_iszero(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Test whether bitmap bitmap is empty.</div></div>
+<div class="ttc" id="aa00194_html_ga72a29824798b48784b8217471ec8f14c"><div class="ttname"><a href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a></div><div class="ttdeci">int hwloc_bitmap_copy(hwloc_bitmap_t dst, hwloc_const_bitmap_t src)</div><div class="ttdoc">Copy the contents of bitmap src into the already allocated bitmap dst.</div></div>
+<div class="ttc" id="aa00204_html_gaf72d83e273803226ce772973e37b85de"><div class="ttname"><a href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a></div><div class="ttdeci">int hwloc_linux_read_path_as_cpumask(const char *path, hwloc_bitmap_t set)</div><div class="ttdoc">Convert a linux kernel cpumask file path into a hwloc bitmap set.</div></div>
+<div class="ttc" id="aa00211_html_ga187ca00c6e12800a25151ce331620980"><div class="ttname"><a href="a00211.html#ga187ca00c6e12800a25151ce331620980">hwloc_cudart_get_device_cpuset</a></div><div class="ttdeci">static int hwloc_cudart_get_device_cpuset(hwloc_topology_t topology, int idx, hwloc_cpuset_t set)</div><div class="ttdoc">Get the CPU set of processors that are physically close to device idx.</div><div class="ttdef"><b>Definition</b> cudart.h:95</div></div>
+<div class="ttc" id="aa00211_html_gac0f3eeaf7712919f298097b1a21307b0"><div class="ttname"><a href="a00211.html#gac0f3eeaf7712919f298097b1a21307b0">hwloc_cudart_get_device_osdev_by_index</a></div><div class="ttdeci">static hwloc_obj_t hwloc_cudart_get_device_osdev_by_index(hwloc_topology_t topology, unsigned idx)</div><div class="ttdoc">Get the hwloc OS device object corresponding to the CUDA device whose index is idx.</div><div class="ttdef"><b>Definition</b> cudart.h:162</div></div>
+<div class="ttc" id="aa00211_html_gad8b701d9a34923e34bd58defd4c1e704"><div class="ttname"><a href="a00211.html#gad8b701d9a34923e34bd58defd4c1e704">hwloc_cudart_get_device_pci_ids</a></div><div class="ttdeci">static int hwloc_cudart_get_device_pci_ids(hwloc_topology_t topology, int idx, int *domain, int *bus, int *dev)</div><div class="ttdoc">Return the domain, bus and device IDs of the CUDA device whose index is idx.</div><div class="ttdef"><b>Definition</b> cudart.h:51</div></div>
+<div class="ttc" id="aa00211_html_gaeda4e6efbb36b518b2c286434ad23bb2"><div class="ttname"><a href="a00211.html#gaeda4e6efbb36b518b2c286434ad23bb2">hwloc_cudart_get_device_pcidev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_cudart_get_device_pcidev(hwloc_topology_t topology, int idx)</div><div class="ttdoc">Get the hwloc PCI device object corresponding to the CUDA device whose index is idx.</div><div class="ttdef"><b>Definition</b> cudart.h:134</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_abb709ec38f2970677e4e57d1d30be96d"><div class="ttname"><a href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj::name</a></div><div class="ttdeci">char * name</div><div class="ttdoc">Object-specific name if any. Mostly used for identifying OS devices and Misc objects where a name str...</div><div class="ttdef"><b>Definition</b> hwloc.h:443</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00233_html_aaf7a5c38b5185703ff18c46ad2761dcf"><div class="ttname"><a href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">hwloc_obj_attr_u::osdev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_osdev_attr_s osdev</div></div>
+<div class="ttc" id="aa00273_html_a31e019e27e54ac6138d04be639bb96f9"><div class="ttname"><a href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">hwloc_obj_attr_u::hwloc_osdev_attr_s::type</a></div><div class="ttdeci">hwloc_obj_osdev_type_t type</div><div class="ttdef"><b>Definition</b> hwloc.h:716</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00146_source.html 2.11.0-1/doc/doxygen-doc/html/a00146_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00146_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00146_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,213 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): nvml.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">nvml.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2012-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span> </div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#ifndef HWLOC_NVML_H</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#define HWLOC_NVML_H</span></div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#include &quot;hwloc/autogen/config.h&quot;</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &quot;hwloc/helper.h&quot;</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &quot;hwloc/linux.h&quot;</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &lt;nvml.h&gt;</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span> </div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span> </div>
+<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
+<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00059" data-start="{" data-end="}">
+<div class="line"><a id="l00059" name="l00059"></a><span class="lineno"><a class="line" href="a00212.html#ga26cf0036d09ec4d7cb692380fac9659d">   59</a></span><a class="code hl_function" href="a00212.html#ga26cf0036d09ec4d7cb692380fac9659d">hwloc_nvml_get_device_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>                             nvmlDevice_t device, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</div>
+<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>{</div>
+<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>  <span class="comment">/* If we&#39;re on Linux, use the sysfs mechanism to get the local cpus */</span></div>
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span><span class="preprocessor">#define HWLOC_NVML_DEVICE_SYSFS_PATH_MAX 128</span></div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>  <span class="keywordtype">char</span> path[HWLOC_NVML_DEVICE_SYSFS_PATH_MAX];</div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>  nvmlReturn_t nvres;</div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>  nvmlPciInfo_t pci;</div>
+<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span> </div>
+<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>  <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(topology)) {</div>
+<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>  }</div>
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span> </div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>  nvres = nvmlDeviceGetPciInfo(device, &amp;pci);</div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>  <span class="keywordflow">if</span> (NVML_SUCCESS != nvres) {</div>
+<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>  }</div>
+<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
+<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>  sprintf(path, <span class="stringliteral">&quot;/sys/bus/pci/devices/%04x:%02x:%02x.0/local_cpus&quot;</span>, pci.domain, pci.bus, pci.device);</div>
+<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a>(path, set) &lt; 0</div>
+<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>      || <a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(set))</div>
+<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>    <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>  <span class="comment">/* Non-Linux systems simply get a full cpuset */</span></div>
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>  <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>}</div>
+</div>
+<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span> </div>
+<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00105" data-start="{" data-end="}">
+<div class="line"><a id="l00105" name="l00105"></a><span class="lineno"><a class="line" href="a00212.html#gacd50fd0e2766ee05bc13234b46714756">  105</a></span><a class="code hl_function" href="a00212.html#gacd50fd0e2766ee05bc13234b46714756">hwloc_nvml_get_device_osdev_by_index</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">unsigned</span> idx)</div>
+<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>{</div>
+<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev = NULL;</div>
+<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>                <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90">HWLOC_OBJ_OSDEV_GPU</a> == osdev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a>.<a class="code hl_variable" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a></div>
+<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>                    &amp;&amp; osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a></div>
+<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>                    &amp;&amp; !strncmp(<span class="stringliteral">&quot;nvml&quot;</span>, osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, 4)</div>
+<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>                    &amp;&amp; atoi(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a> + 4) == (<span class="keywordtype">int</span>) idx)</div>
+<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>                        <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>        }</div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>        <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>}</div>
+</div>
+<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span> </div>
+<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00132" data-start="{" data-end="}">
+<div class="line"><a id="l00132" name="l00132"></a><span class="lineno"><a class="line" href="a00212.html#gaf176159b5760a191871eff23f5a69ee9">  132</a></span><a class="code hl_function" href="a00212.html#gaf176159b5760a191871eff23f5a69ee9">hwloc_nvml_get_device_osdev</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, nvmlDevice_t device)</div>
+<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>{</div>
+<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev;</div>
+<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>        nvmlReturn_t nvres;</div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>        nvmlPciInfo_t pci;</div>
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>        <span class="keywordtype">char</span> uuid[64];</div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span> </div>
+<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>        <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(topology)) {</div>
+<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>                errno = EINVAL;</div>
+<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>                <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>        }</div>
+<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span> </div>
+<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>        nvres = nvmlDeviceGetPciInfo(device, &amp;pci);</div>
+<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>        <span class="keywordflow">if</span> (NVML_SUCCESS != nvres)</div>
+<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>                <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span> </div>
+<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>        nvres = nvmlDeviceGetUUID(device, uuid, <span class="keyword">sizeof</span>(uuid));</div>
+<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>        <span class="keywordflow">if</span> (NVML_SUCCESS != nvres)</div>
+<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>                uuid[0] = <span class="charliteral">&#39;\0&#39;</span>;</div>
+<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span> </div>
+<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>        osdev = NULL;</div>
+<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>        <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>                <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> pcidev = osdev-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>                <span class="keyword">const</span> <span class="keywordtype">char</span> *info;</div>
+<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span> </div>
+<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>                <span class="keywordflow">if</span> (strncmp(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, <span class="stringliteral">&quot;nvml&quot;</span>, 4))</div>
+<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>                        <span class="keywordflow">continue</span>;</div>
+<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span> </div>
+<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>                <span class="keywordflow">if</span> (pcidev</div>
+<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a> == <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div>
+<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">domain</a> == pci.domain</div>
+<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">bus</a> == pci.bus</div>
+<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">dev</a> == pci.device</div>
+<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>                    &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">func</a> == 0)</div>
+<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>                        <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span> </div>
+<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>                info = <a class="code hl_function" href="a00178.html#ga415c4e44beada7ea34cd4bad9944b170">hwloc_obj_get_info_by_name</a>(osdev, <span class="stringliteral">&quot;NVIDIAUUID&quot;</span>);</div>
+<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>                <span class="keywordflow">if</span> (info &amp;&amp; !strcmp(info, uuid))</div>
+<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>                        <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        }</div>
+<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span> </div>
+<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>        <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>}</div>
+</div>
+<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span> </div>
+<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span> </div>
+<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span> </div>
+<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_NVML_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90">HWLOC_OBJ_OSDEV_GPU</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_GPU</div><div class="ttdoc">Operating system GPU device. For instance &quot;:0.0&quot; for a GL display, &quot;card0&quot; for a Linux DRM device.</div><div class="ttdef"><b>Definition</b> hwloc.h:374</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div><div class="ttdeci">@ HWLOC_OBJ_PCI_DEVICE</div><div class="ttdoc">PCI device (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:295</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00178_html_ga415c4e44beada7ea34cd4bad9944b170"><div class="ttname"><a href="a00178.html#ga415c4e44beada7ea34cd4bad9944b170">hwloc_obj_get_info_by_name</a></div><div class="ttdeci">static const char * hwloc_obj_get_info_by_name(hwloc_obj_t obj, const char *name)</div><div class="ttdoc">Search the given name in object infos and return the corresponding value.</div></div>
+<div class="ttc" id="aa00182_html_ga68ffdcfd9175cdf40709801092f18017"><div class="ttname"><a href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a></div><div class="ttdeci">int hwloc_topology_is_thissystem(hwloc_topology_t restrict topology)</div><div class="ttdoc">Does the topology context come from this system?</div></div>
+<div class="ttc" id="aa00191_html_gaee30e03391c1ed7dfd617fb5c7bbb033"><div class="ttname"><a href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a></div><div class="ttdeci">hwloc_const_cpuset_t hwloc_topology_get_complete_cpuset(hwloc_topology_t topology)</div><div class="ttdoc">Get complete CPU set.</div></div>
+<div class="ttc" id="aa00193_html_ga8b4584c8949e2c5f1c97ba7fe92b8145"><div class="ttname"><a href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_osdev(hwloc_topology_t topology, hwloc_obj_t prev)</div><div class="ttdoc">Get the next OS device in the system.</div><div class="ttdef"><b>Definition</b> helper.h:1290</div></div>
+<div class="ttc" id="aa00194_html_ga5b64be28f5a7176ed8ad0d6a90bdf108"><div class="ttname"><a href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a></div><div class="ttdeci">int hwloc_bitmap_iszero(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Test whether bitmap bitmap is empty.</div></div>
+<div class="ttc" id="aa00194_html_ga72a29824798b48784b8217471ec8f14c"><div class="ttname"><a href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a></div><div class="ttdeci">int hwloc_bitmap_copy(hwloc_bitmap_t dst, hwloc_const_bitmap_t src)</div><div class="ttdoc">Copy the contents of bitmap src into the already allocated bitmap dst.</div></div>
+<div class="ttc" id="aa00204_html_gaf72d83e273803226ce772973e37b85de"><div class="ttname"><a href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a></div><div class="ttdeci">int hwloc_linux_read_path_as_cpumask(const char *path, hwloc_bitmap_t set)</div><div class="ttdoc">Convert a linux kernel cpumask file path into a hwloc bitmap set.</div></div>
+<div class="ttc" id="aa00212_html_ga26cf0036d09ec4d7cb692380fac9659d"><div class="ttname"><a href="a00212.html#ga26cf0036d09ec4d7cb692380fac9659d">hwloc_nvml_get_device_cpuset</a></div><div class="ttdeci">static int hwloc_nvml_get_device_cpuset(hwloc_topology_t topology, nvmlDevice_t device, hwloc_cpuset_t set)</div><div class="ttdoc">Get the CPU set of processors that are physically close to NVML device device.</div><div class="ttdef"><b>Definition</b> nvml.h:59</div></div>
+<div class="ttc" id="aa00212_html_gacd50fd0e2766ee05bc13234b46714756"><div class="ttname"><a href="a00212.html#gacd50fd0e2766ee05bc13234b46714756">hwloc_nvml_get_device_osdev_by_index</a></div><div class="ttdeci">static hwloc_obj_t hwloc_nvml_get_device_osdev_by_index(hwloc_topology_t topology, unsigned idx)</div><div class="ttdoc">Get the hwloc OS device object corresponding to the NVML device whose index is idx.</div><div class="ttdef"><b>Definition</b> nvml.h:105</div></div>
+<div class="ttc" id="aa00212_html_gaf176159b5760a191871eff23f5a69ee9"><div class="ttname"><a href="a00212.html#gaf176159b5760a191871eff23f5a69ee9">hwloc_nvml_get_device_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_nvml_get_device_osdev(hwloc_topology_t topology, nvmlDevice_t device)</div><div class="ttdoc">Get the hwloc OS device object corresponding to NVML device device.</div><div class="ttdef"><b>Definition</b> nvml.h:132</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_abb709ec38f2970677e4e57d1d30be96d"><div class="ttname"><a href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj::name</a></div><div class="ttdeci">char * name</div><div class="ttdoc">Object-specific name if any. Mostly used for identifying OS devices and Misc objects where a name str...</div><div class="ttdef"><b>Definition</b> hwloc.h:443</div></div>
+<div class="ttc" id="aa00229_html_acc4f0803f244867e68fe0036800be5de"><div class="ttname"><a href="a00229.html#acc4f0803f244867e68fe0036800be5de">hwloc_obj::type</a></div><div class="ttdeci">hwloc_obj_type_t type</div><div class="ttdoc">Type of object.</div><div class="ttdef"><b>Definition</b> hwloc.h:433</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00229_html_adc494f6aed939992be1c55cca5822900"><div class="ttname"><a href="a00229.html#adc494f6aed939992be1c55cca5822900">hwloc_obj::parent</a></div><div class="ttdeci">struct hwloc_obj * parent</div><div class="ttdoc">Parent, NULL if root (Machine object)</div><div class="ttdef"><b>Definition</b> hwloc.h:481</div></div>
+<div class="ttc" id="aa00233_html_a0b66da7ab072f7c016f8ed86701f5a7c"><div class="ttname"><a href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">hwloc_obj_attr_u::pcidev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_pcidev_attr_s pcidev</div></div>
+<div class="ttc" id="aa00233_html_aaf7a5c38b5185703ff18c46ad2761dcf"><div class="ttname"><a href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">hwloc_obj_attr_u::osdev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_osdev_attr_s osdev</div></div>
+<div class="ttc" id="aa00253_html_a3d70c84a12f7e93d14c8d47bf4fd9dc5"><div class="ttname"><a href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">hwloc_obj_attr_u::hwloc_pcidev_attr_s::dev</a></div><div class="ttdeci">unsigned char dev</div><div class="ttdoc">Device number (zz in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:677</div></div>
+<div class="ttc" id="aa00253_html_a695f32df53f4ef728670bfcf31b74e0f"><div class="ttname"><a href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">hwloc_obj_attr_u::hwloc_pcidev_attr_s::func</a></div><div class="ttdeci">unsigned char func</div><div class="ttdoc">Function number (t in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:678</div></div>
+<div class="ttc" id="aa00253_html_a8fba44988deb98613c1505a4019a34dc"><div class="ttname"><a href="a00253.html#a8fba44988deb98613c1505a4019a34dc">hwloc_obj_attr_u::hwloc_pcidev_attr_s::domain</a></div><div class="ttdeci">unsigned short domain</div><div class="ttdoc">Domain number (xxxx in the PCI BDF notation xxxx:yy:zz.t). Only 16bits PCI domains are supported by d...</div><div class="ttdef"><b>Definition</b> hwloc.h:670</div></div>
+<div class="ttc" id="aa00253_html_aae99e035e8d1387d7b8768aaa8eceb0a"><div class="ttname"><a href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">hwloc_obj_attr_u::hwloc_pcidev_attr_s::bus</a></div><div class="ttdeci">unsigned char bus</div><div class="ttdoc">Bus number (yy in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:676</div></div>
+<div class="ttc" id="aa00273_html_a31e019e27e54ac6138d04be639bb96f9"><div class="ttname"><a href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">hwloc_obj_attr_u::hwloc_osdev_attr_s::type</a></div><div class="ttdeci">hwloc_obj_osdev_type_t type</div><div class="ttdef"><b>Definition</b> hwloc.h:716</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00149_source.html 2.11.0-1/doc/doxygen-doc/html/a00149_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00149_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00149_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,229 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): rsmi.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">rsmi.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2012-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright (c) 2020, Advanced Micro Devices, Inc. All rights reserved.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * Written by Advanced Micro Devices,</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#ifndef HWLOC_RSMI_H</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#define HWLOC_RSMI_H</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &quot;hwloc/autogen/config.h&quot;</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &quot;hwloc/helper.h&quot;</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#include &quot;hwloc/linux.h&quot;</span></div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#include &lt;rocm_smi/rocm_smi.h&gt;</span></div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
+<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
+<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
+<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00063" data-start="{" data-end="}">
+<div class="line"><a id="l00063" name="l00063"></a><span class="lineno"><a class="line" href="a00213.html#gaf939e697e3769c3524255318262b9c29">   63</a></span><a class="code hl_function" href="a00213.html#gaf939e697e3769c3524255318262b9c29">hwloc_rsmi_get_device_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>                             uint32_t dv_ind, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>{</div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>  <span class="comment">/* If we&#39;re on Linux, use the sysfs mechanism to get the local cpus */</span></div>
+<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span><span class="preprocessor">#define HWLOC_RSMI_DEVICE_SYSFS_PATH_MAX 128</span></div>
+<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>  <span class="keywordtype">char</span> path[HWLOC_RSMI_DEVICE_SYSFS_PATH_MAX];</div>
+<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>  rsmi_status_t ret;</div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>  uint64_t bdfid = 0;</div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>  <span class="keywordtype">unsigned</span> domain, device, bus;</div>
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span> </div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>  <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(topology)) {</div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>  }</div>
+<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span> </div>
+<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>  ret = rsmi_dev_pci_id_get(dv_ind, &amp;bdfid);</div>
+<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>  <span class="keywordflow">if</span> (RSMI_STATUS_SUCCESS != ret) {</div>
+<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>  }</div>
+<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>  domain = (bdfid&gt;&gt;32) &amp; 0xffffffff;</div>
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>  bus = ((bdfid &amp; 0xffff)&gt;&gt;8) &amp; 0xff;</div>
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>  device = ((bdfid &amp; 0xff)&gt;&gt;3) &amp; 0x1f;</div>
+<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span> </div>
+<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>  sprintf(path, <span class="stringliteral">&quot;/sys/bus/pci/devices/%04x:%02x:%02x.0/local_cpus&quot;</span>, domain, bus, device);</div>
+<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a>(path, set) &lt; 0</div>
+<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>      || <a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(set))</div>
+<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>    <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>  <span class="comment">/* Non-Linux systems simply get a full cpuset */</span></div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>  <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>}</div>
+</div>
+<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span> </div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00115" data-start="{" data-end="}">
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno"><a class="line" href="a00213.html#ga507d0acdd5e9ac374a8d120d59604c80">  115</a></span><a class="code hl_function" href="a00213.html#ga507d0acdd5e9ac374a8d120d59604c80">hwloc_rsmi_get_device_osdev_by_index</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, uint32_t dv_ind)</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>{</div>
+<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev = NULL;</div>
+<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>  <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>    <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90">HWLOC_OBJ_OSDEV_GPU</a> == osdev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a>.<a class="code hl_variable" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a></div>
+<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>      &amp;&amp; osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a></div>
+<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>      &amp;&amp; !strncmp(<span class="stringliteral">&quot;rsmi&quot;</span>, osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, 4)</div>
+<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>      &amp;&amp; atoi(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a> + 4) == (<span class="keywordtype">int</span>) dv_ind)</div>
+<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>      <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>  }</div>
+<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>  <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>}</div>
+</div>
+<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span> </div>
+<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00144" data-start="{" data-end="}">
+<div class="line"><a id="l00144" name="l00144"></a><span class="lineno"><a class="line" href="a00213.html#gaba05bf9710655bb5b1439bee654340ba">  144</a></span><a class="code hl_function" href="a00213.html#gaba05bf9710655bb5b1439bee654340ba">hwloc_rsmi_get_device_osdev</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, uint32_t dv_ind)</div>
+<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>{</div>
+<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev;</div>
+<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>  rsmi_status_t ret;</div>
+<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>  uint64_t bdfid = 0;</div>
+<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>  <span class="keywordtype">unsigned</span> domain, device, bus, func;</div>
+<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>  uint64_t id;</div>
+<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>  <span class="keywordtype">char</span> uuid[64];</div>
+<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span> </div>
+<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>  <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(topology)) {</div>
+<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>  }</div>
+<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span> </div>
+<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>  ret = rsmi_dev_pci_id_get(dv_ind, &amp;bdfid);</div>
+<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>  <span class="keywordflow">if</span> (RSMI_STATUS_SUCCESS != ret) {</div>
+<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>  }</div>
+<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>  domain = (bdfid&gt;&gt;32) &amp; 0xffffffff;</div>
+<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>  bus = ((bdfid &amp; 0xffff)&gt;&gt;8) &amp; 0xff;</div>
+<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>  device = ((bdfid &amp; 0xff)&gt;&gt;3) &amp; 0x1f;</div>
+<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>  func = bdfid &amp; 0x7;</div>
+<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span> </div>
+<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>  ret = rsmi_dev_unique_id_get(dv_ind, &amp;<span class="keywordtype">id</span>);</div>
+<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>  <span class="keywordflow">if</span> (RSMI_STATUS_SUCCESS != ret)</div>
+<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>    uuid[0] = <span class="charliteral">&#39;\0&#39;</span>;</div>
+<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>  <span class="keywordflow">else</span></div>
+<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>    sprintf(uuid, <span class="stringliteral">&quot;%lx&quot;</span>, <span class="keywordtype">id</span>);</div>
+<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span> </div>
+<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>  osdev = NULL;</div>
+<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>  <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>    <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> pcidev = osdev-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>    <span class="keyword">const</span> <span class="keywordtype">char</span> *info;</div>
+<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span> </div>
+<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>    <span class="keywordflow">if</span> (strncmp(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, <span class="stringliteral">&quot;rsmi&quot;</span>, 4))</div>
+<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span>      <span class="keywordflow">continue</span>;</div>
+<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span> </div>
+<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>    <span class="keywordflow">if</span> (pcidev</div>
+<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>      &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a> == <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div>
+<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>      &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">domain</a> == domain</div>
+<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>      &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">bus</a> == bus</div>
+<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>      &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">dev</a> == device</div>
+<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>      &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">func</a> == func)</div>
+<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>      <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span> </div>
+<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>    info = <a class="code hl_function" href="a00178.html#ga415c4e44beada7ea34cd4bad9944b170">hwloc_obj_get_info_by_name</a>(osdev, <span class="stringliteral">&quot;AMDUUID&quot;</span>);</div>
+<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>    <span class="keywordflow">if</span> (info &amp;&amp; !strcmp(info, uuid))</div>
+<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span>      <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>  }</div>
+<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span> </div>
+<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>  <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>}</div>
+</div>
+<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span> </div>
+<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span> </div>
+<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span> </div>
+<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_RSMI_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90">HWLOC_OBJ_OSDEV_GPU</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_GPU</div><div class="ttdoc">Operating system GPU device. For instance &quot;:0.0&quot; for a GL display, &quot;card0&quot; for a Linux DRM device.</div><div class="ttdef"><b>Definition</b> hwloc.h:374</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div><div class="ttdeci">@ HWLOC_OBJ_PCI_DEVICE</div><div class="ttdoc">PCI device (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:295</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00178_html_ga415c4e44beada7ea34cd4bad9944b170"><div class="ttname"><a href="a00178.html#ga415c4e44beada7ea34cd4bad9944b170">hwloc_obj_get_info_by_name</a></div><div class="ttdeci">static const char * hwloc_obj_get_info_by_name(hwloc_obj_t obj, const char *name)</div><div class="ttdoc">Search the given name in object infos and return the corresponding value.</div></div>
+<div class="ttc" id="aa00182_html_ga68ffdcfd9175cdf40709801092f18017"><div class="ttname"><a href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a></div><div class="ttdeci">int hwloc_topology_is_thissystem(hwloc_topology_t restrict topology)</div><div class="ttdoc">Does the topology context come from this system?</div></div>
+<div class="ttc" id="aa00191_html_gaee30e03391c1ed7dfd617fb5c7bbb033"><div class="ttname"><a href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a></div><div class="ttdeci">hwloc_const_cpuset_t hwloc_topology_get_complete_cpuset(hwloc_topology_t topology)</div><div class="ttdoc">Get complete CPU set.</div></div>
+<div class="ttc" id="aa00193_html_ga8b4584c8949e2c5f1c97ba7fe92b8145"><div class="ttname"><a href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_osdev(hwloc_topology_t topology, hwloc_obj_t prev)</div><div class="ttdoc">Get the next OS device in the system.</div><div class="ttdef"><b>Definition</b> helper.h:1290</div></div>
+<div class="ttc" id="aa00194_html_ga5b64be28f5a7176ed8ad0d6a90bdf108"><div class="ttname"><a href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a></div><div class="ttdeci">int hwloc_bitmap_iszero(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Test whether bitmap bitmap is empty.</div></div>
+<div class="ttc" id="aa00194_html_ga72a29824798b48784b8217471ec8f14c"><div class="ttname"><a href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a></div><div class="ttdeci">int hwloc_bitmap_copy(hwloc_bitmap_t dst, hwloc_const_bitmap_t src)</div><div class="ttdoc">Copy the contents of bitmap src into the already allocated bitmap dst.</div></div>
+<div class="ttc" id="aa00204_html_gaf72d83e273803226ce772973e37b85de"><div class="ttname"><a href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a></div><div class="ttdeci">int hwloc_linux_read_path_as_cpumask(const char *path, hwloc_bitmap_t set)</div><div class="ttdoc">Convert a linux kernel cpumask file path into a hwloc bitmap set.</div></div>
+<div class="ttc" id="aa00213_html_ga507d0acdd5e9ac374a8d120d59604c80"><div class="ttname"><a href="a00213.html#ga507d0acdd5e9ac374a8d120d59604c80">hwloc_rsmi_get_device_osdev_by_index</a></div><div class="ttdeci">static hwloc_obj_t hwloc_rsmi_get_device_osdev_by_index(hwloc_topology_t topology, uint32_t dv_ind)</div><div class="ttdoc">Get the hwloc OS device object corresponding to the AMD GPU device whose index is dv_ind.</div><div class="ttdef"><b>Definition</b> rsmi.h:115</div></div>
+<div class="ttc" id="aa00213_html_gaba05bf9710655bb5b1439bee654340ba"><div class="ttname"><a href="a00213.html#gaba05bf9710655bb5b1439bee654340ba">hwloc_rsmi_get_device_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_rsmi_get_device_osdev(hwloc_topology_t topology, uint32_t dv_ind)</div><div class="ttdoc">Get the hwloc OS device object corresponding to AMD GPU device, whose index is dv_ind.</div><div class="ttdef"><b>Definition</b> rsmi.h:144</div></div>
+<div class="ttc" id="aa00213_html_gaf939e697e3769c3524255318262b9c29"><div class="ttname"><a href="a00213.html#gaf939e697e3769c3524255318262b9c29">hwloc_rsmi_get_device_cpuset</a></div><div class="ttdeci">static int hwloc_rsmi_get_device_cpuset(hwloc_topology_t topology, uint32_t dv_ind, hwloc_cpuset_t set)</div><div class="ttdoc">Get the CPU set of logical processors that are physically close to AMD GPU device whose index is dv_i...</div><div class="ttdef"><b>Definition</b> rsmi.h:63</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_abb709ec38f2970677e4e57d1d30be96d"><div class="ttname"><a href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj::name</a></div><div class="ttdeci">char * name</div><div class="ttdoc">Object-specific name if any. Mostly used for identifying OS devices and Misc objects where a name str...</div><div class="ttdef"><b>Definition</b> hwloc.h:443</div></div>
+<div class="ttc" id="aa00229_html_acc4f0803f244867e68fe0036800be5de"><div class="ttname"><a href="a00229.html#acc4f0803f244867e68fe0036800be5de">hwloc_obj::type</a></div><div class="ttdeci">hwloc_obj_type_t type</div><div class="ttdoc">Type of object.</div><div class="ttdef"><b>Definition</b> hwloc.h:433</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00229_html_adc494f6aed939992be1c55cca5822900"><div class="ttname"><a href="a00229.html#adc494f6aed939992be1c55cca5822900">hwloc_obj::parent</a></div><div class="ttdeci">struct hwloc_obj * parent</div><div class="ttdoc">Parent, NULL if root (Machine object)</div><div class="ttdef"><b>Definition</b> hwloc.h:481</div></div>
+<div class="ttc" id="aa00233_html_a0b66da7ab072f7c016f8ed86701f5a7c"><div class="ttname"><a href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">hwloc_obj_attr_u::pcidev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_pcidev_attr_s pcidev</div></div>
+<div class="ttc" id="aa00233_html_aaf7a5c38b5185703ff18c46ad2761dcf"><div class="ttname"><a href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">hwloc_obj_attr_u::osdev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_osdev_attr_s osdev</div></div>
+<div class="ttc" id="aa00253_html_a3d70c84a12f7e93d14c8d47bf4fd9dc5"><div class="ttname"><a href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">hwloc_obj_attr_u::hwloc_pcidev_attr_s::dev</a></div><div class="ttdeci">unsigned char dev</div><div class="ttdoc">Device number (zz in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:677</div></div>
+<div class="ttc" id="aa00253_html_a695f32df53f4ef728670bfcf31b74e0f"><div class="ttname"><a href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">hwloc_obj_attr_u::hwloc_pcidev_attr_s::func</a></div><div class="ttdeci">unsigned char func</div><div class="ttdoc">Function number (t in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:678</div></div>
+<div class="ttc" id="aa00253_html_a8fba44988deb98613c1505a4019a34dc"><div class="ttname"><a href="a00253.html#a8fba44988deb98613c1505a4019a34dc">hwloc_obj_attr_u::hwloc_pcidev_attr_s::domain</a></div><div class="ttdeci">unsigned short domain</div><div class="ttdoc">Domain number (xxxx in the PCI BDF notation xxxx:yy:zz.t). Only 16bits PCI domains are supported by d...</div><div class="ttdef"><b>Definition</b> hwloc.h:670</div></div>
+<div class="ttc" id="aa00253_html_aae99e035e8d1387d7b8768aaa8eceb0a"><div class="ttname"><a href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">hwloc_obj_attr_u::hwloc_pcidev_attr_s::bus</a></div><div class="ttdeci">unsigned char bus</div><div class="ttdoc">Bus number (yy in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:676</div></div>
+<div class="ttc" id="aa00273_html_a31e019e27e54ac6138d04be639bb96f9"><div class="ttname"><a href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">hwloc_obj_attr_u::hwloc_osdev_attr_s::type</a></div><div class="ttdeci">hwloc_obj_osdev_type_t type</div><div class="ttdef"><b>Definition</b> hwloc.h:716</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00152_source.html 2.11.0-1/doc/doxygen-doc/html/a00152_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00152_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00152_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,191 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): levelzero.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">levelzero.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2021-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span> </div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#ifndef HWLOC_LEVELZERO_H</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#define HWLOC_LEVELZERO_H</span></div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#include &quot;hwloc/autogen/config.h&quot;</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &quot;hwloc/helper.h&quot;</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &quot;hwloc/linux.h&quot;</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &lt;level_zero/ze_api.h&gt;</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">#include &lt;level_zero/zes_api.h&gt;</span></div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span> </div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
+<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
+<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00064" data-start="{" data-end="}">
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno"><a class="line" href="a00214.html#ga66281a9ba621357b1c7070b4fa19b5b8">   64</a></span><a class="code hl_function" href="a00214.html#ga66281a9ba621357b1c7070b4fa19b5b8">hwloc_levelzero_get_device_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>                                  ze_device_handle_t device, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>{</div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>  <span class="comment">/* If we&#39;re on Linux, use the sysfs mechanism to get the local cpus */</span></div>
+<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span><span class="preprocessor">#define HWLOC_LEVELZERO_DEVICE_SYSFS_PATH_MAX 128</span></div>
+<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>  <span class="keywordtype">char</span> path[HWLOC_LEVELZERO_DEVICE_SYSFS_PATH_MAX];</div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>  zes_pci_properties_t pci;</div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>  zes_device_handle_t sdevice = device;</div>
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>  ze_result_t res;</div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span> </div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>  <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(topology)) {</div>
+<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>  }</div>
+<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
+<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>  res = zesDevicePciGetProperties(sdevice, &amp;pci);</div>
+<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>  <span class="keywordflow">if</span> (res != ZE_RESULT_SUCCESS) {</div>
+<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>  }</div>
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span> </div>
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>  sprintf(path, <span class="stringliteral">&quot;/sys/bus/pci/devices/%04x:%02x:%02x.%01x/local_cpus&quot;</span>,</div>
+<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>          pci.address.domain, pci.address.bus, pci.address.device, pci.address.function);</div>
+<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a>(path, set) &lt; 0</div>
+<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>      || <a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(set))</div>
+<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>    <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>  <span class="comment">/* Non-Linux systems simply get a full cpuset */</span></div>
+<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>  <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>}</div>
+</div>
+<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
+<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00113" data-start="{" data-end="}">
+<div class="line"><a id="l00113" name="l00113"></a><span class="lineno"><a class="line" href="a00214.html#gaf06cb737abcd2dc6db894c8914302d85">  113</a></span><a class="code hl_function" href="a00214.html#gaf06cb737abcd2dc6db894c8914302d85">hwloc_levelzero_get_device_osdev</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, ze_device_handle_t device)</div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>{</div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>  zes_device_handle_t sdevice = device;</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>  zes_pci_properties_t pci;</div>
+<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>  ze_result_t res;</div>
+<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>  <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev;</div>
+<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span> </div>
+<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>  <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(topology)) {</div>
+<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>  }</div>
+<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span> </div>
+<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>  res = zesDevicePciGetProperties(sdevice, &amp;pci);</div>
+<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>  <span class="keywordflow">if</span> (res != ZE_RESULT_SUCCESS) {</div>
+<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>    <span class="comment">/* L0 was likely initialized without sysman, don&#39;t bother */</span></div>
+<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>    <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>  }</div>
+<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span> </div>
+<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>  osdev = NULL;</div>
+<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>  <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>    <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> pcidev = osdev-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>;</div>
+<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span> </div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>    <span class="keywordflow">if</span> (strncmp(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, <span class="stringliteral">&quot;ze&quot;</span>, 2))</div>
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>      <span class="keywordflow">continue</span>;</div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span> </div>
+<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>    <span class="keywordflow">if</span> (pcidev</div>
+<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>      &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a> == <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div>
+<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>      &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">domain</a> == pci.address.domain</div>
+<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>      &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">bus</a> == pci.address.bus</div>
+<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>      &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">dev</a> == pci.address.device</div>
+<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>      &amp;&amp; pcidev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">func</a> == pci.address.function)</div>
+<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>      <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span> </div>
+<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>    <span class="comment">/* FIXME: when we&#39;ll have serialnumber, try it in case PCI is filtered-out */</span></div>
+<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>  }</div>
+<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span> </div>
+<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>  <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>}</div>
+</div>
+<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span> </div>
+<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span> </div>
+<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span> </div>
+<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_LEVELZERO_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div><div class="ttdeci">@ HWLOC_OBJ_PCI_DEVICE</div><div class="ttdoc">PCI device (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:295</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00182_html_ga68ffdcfd9175cdf40709801092f18017"><div class="ttname"><a href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a></div><div class="ttdeci">int hwloc_topology_is_thissystem(hwloc_topology_t restrict topology)</div><div class="ttdoc">Does the topology context come from this system?</div></div>
+<div class="ttc" id="aa00191_html_gaee30e03391c1ed7dfd617fb5c7bbb033"><div class="ttname"><a href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a></div><div class="ttdeci">hwloc_const_cpuset_t hwloc_topology_get_complete_cpuset(hwloc_topology_t topology)</div><div class="ttdoc">Get complete CPU set.</div></div>
+<div class="ttc" id="aa00193_html_ga8b4584c8949e2c5f1c97ba7fe92b8145"><div class="ttname"><a href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_osdev(hwloc_topology_t topology, hwloc_obj_t prev)</div><div class="ttdoc">Get the next OS device in the system.</div><div class="ttdef"><b>Definition</b> helper.h:1290</div></div>
+<div class="ttc" id="aa00194_html_ga5b64be28f5a7176ed8ad0d6a90bdf108"><div class="ttname"><a href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a></div><div class="ttdeci">int hwloc_bitmap_iszero(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Test whether bitmap bitmap is empty.</div></div>
+<div class="ttc" id="aa00194_html_ga72a29824798b48784b8217471ec8f14c"><div class="ttname"><a href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a></div><div class="ttdeci">int hwloc_bitmap_copy(hwloc_bitmap_t dst, hwloc_const_bitmap_t src)</div><div class="ttdoc">Copy the contents of bitmap src into the already allocated bitmap dst.</div></div>
+<div class="ttc" id="aa00204_html_gaf72d83e273803226ce772973e37b85de"><div class="ttname"><a href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a></div><div class="ttdeci">int hwloc_linux_read_path_as_cpumask(const char *path, hwloc_bitmap_t set)</div><div class="ttdoc">Convert a linux kernel cpumask file path into a hwloc bitmap set.</div></div>
+<div class="ttc" id="aa00214_html_ga66281a9ba621357b1c7070b4fa19b5b8"><div class="ttname"><a href="a00214.html#ga66281a9ba621357b1c7070b4fa19b5b8">hwloc_levelzero_get_device_cpuset</a></div><div class="ttdeci">static int hwloc_levelzero_get_device_cpuset(hwloc_topology_t topology, ze_device_handle_t device, hwloc_cpuset_t set)</div><div class="ttdoc">Get the CPU set of logical processors that are physically close to the Level Zero device device.</div><div class="ttdef"><b>Definition</b> levelzero.h:64</div></div>
+<div class="ttc" id="aa00214_html_gaf06cb737abcd2dc6db894c8914302d85"><div class="ttname"><a href="a00214.html#gaf06cb737abcd2dc6db894c8914302d85">hwloc_levelzero_get_device_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_levelzero_get_device_osdev(hwloc_topology_t topology, ze_device_handle_t device)</div><div class="ttdoc">Get the hwloc OS device object corresponding to Level Zero device device.</div><div class="ttdef"><b>Definition</b> levelzero.h:113</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_abb709ec38f2970677e4e57d1d30be96d"><div class="ttname"><a href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj::name</a></div><div class="ttdeci">char * name</div><div class="ttdoc">Object-specific name if any. Mostly used for identifying OS devices and Misc objects where a name str...</div><div class="ttdef"><b>Definition</b> hwloc.h:443</div></div>
+<div class="ttc" id="aa00229_html_acc4f0803f244867e68fe0036800be5de"><div class="ttname"><a href="a00229.html#acc4f0803f244867e68fe0036800be5de">hwloc_obj::type</a></div><div class="ttdeci">hwloc_obj_type_t type</div><div class="ttdoc">Type of object.</div><div class="ttdef"><b>Definition</b> hwloc.h:433</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00229_html_adc494f6aed939992be1c55cca5822900"><div class="ttname"><a href="a00229.html#adc494f6aed939992be1c55cca5822900">hwloc_obj::parent</a></div><div class="ttdeci">struct hwloc_obj * parent</div><div class="ttdoc">Parent, NULL if root (Machine object)</div><div class="ttdef"><b>Definition</b> hwloc.h:481</div></div>
+<div class="ttc" id="aa00233_html_a0b66da7ab072f7c016f8ed86701f5a7c"><div class="ttname"><a href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">hwloc_obj_attr_u::pcidev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_pcidev_attr_s pcidev</div></div>
+<div class="ttc" id="aa00253_html_a3d70c84a12f7e93d14c8d47bf4fd9dc5"><div class="ttname"><a href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">hwloc_obj_attr_u::hwloc_pcidev_attr_s::dev</a></div><div class="ttdeci">unsigned char dev</div><div class="ttdoc">Device number (zz in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:677</div></div>
+<div class="ttc" id="aa00253_html_a695f32df53f4ef728670bfcf31b74e0f"><div class="ttname"><a href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">hwloc_obj_attr_u::hwloc_pcidev_attr_s::func</a></div><div class="ttdeci">unsigned char func</div><div class="ttdoc">Function number (t in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:678</div></div>
+<div class="ttc" id="aa00253_html_a8fba44988deb98613c1505a4019a34dc"><div class="ttname"><a href="a00253.html#a8fba44988deb98613c1505a4019a34dc">hwloc_obj_attr_u::hwloc_pcidev_attr_s::domain</a></div><div class="ttdeci">unsigned short domain</div><div class="ttdoc">Domain number (xxxx in the PCI BDF notation xxxx:yy:zz.t). Only 16bits PCI domains are supported by d...</div><div class="ttdef"><b>Definition</b> hwloc.h:670</div></div>
+<div class="ttc" id="aa00253_html_aae99e035e8d1387d7b8768aaa8eceb0a"><div class="ttname"><a href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">hwloc_obj_attr_u::hwloc_pcidev_attr_s::bus</a></div><div class="ttdeci">unsigned char bus</div><div class="ttdoc">Bus number (yy in the PCI BDF notation xxxx:yy:zz.t).</div><div class="ttdef"><b>Definition</b> hwloc.h:676</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00155_source.html 2.11.0-1/doc/doxygen-doc/html/a00155_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00155_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00155_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,152 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): gl.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">gl.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2012 Blue Brain Project, EPFL. All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2012-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span> </div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#ifndef HWLOC_GL_H</span></div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#define HWLOC_GL_H</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span> </div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &lt;string.h&gt;</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
+<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00054" data-start="{" data-end="}">
+<div class="line"><a id="l00054" name="l00054"></a><span class="lineno"><a class="line" href="a00215.html#ga4d66a77e4fe4051d6e5b772c1b8fcec5">   54</a></span><a class="code hl_function" href="a00215.html#ga4d66a77e4fe4051d6e5b772c1b8fcec5">hwloc_gl_get_display_osdev_by_port_device</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>                                          <span class="keywordtype">unsigned</span> port, <span class="keywordtype">unsigned</span> device)</div>
+<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>{</div>
+<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>        <span class="keywordtype">unsigned</span> x = (unsigned) -1, y = (<span class="keywordtype">unsigned</span>) -1;</div>
+<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev = NULL;</div>
+<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>        <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>                <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90">HWLOC_OBJ_OSDEV_GPU</a> == osdev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a>.<a class="code hl_variable" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a></div>
+<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>                    &amp;&amp; osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a></div>
+<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>                    &amp;&amp; sscanf(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, <span class="stringliteral">&quot;:%u.%u&quot;</span>, &amp;x, &amp;y) == 2</div>
+<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>                    &amp;&amp; port == x &amp;&amp; device == y)</div>
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>                        <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>        }</div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>        errno = EINVAL;</div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>        <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>}</div>
+</div>
+<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span> </div>
+<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00085" data-start="{" data-end="}">
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno"><a class="line" href="a00215.html#ga2d36ef441d1dfddf49cfb5c01bd58d8e">   85</a></span><a class="code hl_function" href="a00215.html#ga2d36ef441d1dfddf49cfb5c01bd58d8e">hwloc_gl_get_display_osdev_by_name</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>                                   <span class="keyword">const</span> <span class="keywordtype">char</span> *name)</div>
+<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>{</div>
+<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev = NULL;</div>
+<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>                <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90">HWLOC_OBJ_OSDEV_GPU</a> == osdev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a>.<a class="code hl_variable" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a></div>
+<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>                    &amp;&amp; osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a></div>
+<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>                    &amp;&amp; !strcmp(name, osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>))</div>
+<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>                        <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        }</div>
+<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        errno = EINVAL;</div>
+<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>        <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>}</div>
+</div>
+<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span> </div>
+<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00113" data-start="{" data-end="}">
+<div class="line"><a id="l00113" name="l00113"></a><span class="lineno"><a class="line" href="a00215.html#ga936665ab5f0d29a081c4b78d11f4ad07">  113</a></span><a class="code hl_function" href="a00215.html#ga936665ab5f0d29a081c4b78d11f4ad07">hwloc_gl_get_display_by_osdev</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>                              <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev,</div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>                              <span class="keywordtype">unsigned</span> *port, <span class="keywordtype">unsigned</span> *device)</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>{</div>
+<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        <span class="keywordtype">unsigned</span> x = -1, y = -1;</div>
+<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>        <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90">HWLOC_OBJ_OSDEV_GPU</a> == osdev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a>.<a class="code hl_variable" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a></div>
+<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>            &amp;&amp; sscanf(osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, <span class="stringliteral">&quot;:%u.%u&quot;</span>, &amp;x, &amp;y) == 2) {</div>
+<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>                *port = x;</div>
+<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>                *device = y;</div>
+<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>                <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>        }</div>
+<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>        errno = EINVAL;</div>
+<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>        <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>}</div>
+</div>
+<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span> </div>
+<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span> </div>
+<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span> </div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_GL_H */</span><span class="preprocessor"></span></div>
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span> </div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90">HWLOC_OBJ_OSDEV_GPU</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_GPU</div><div class="ttdoc">Operating system GPU device. For instance &quot;:0.0&quot; for a GL display, &quot;card0&quot; for a Linux DRM device.</div><div class="ttdef"><b>Definition</b> hwloc.h:374</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00193_html_ga8b4584c8949e2c5f1c97ba7fe92b8145"><div class="ttname"><a href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_osdev(hwloc_topology_t topology, hwloc_obj_t prev)</div><div class="ttdoc">Get the next OS device in the system.</div><div class="ttdef"><b>Definition</b> helper.h:1290</div></div>
+<div class="ttc" id="aa00215_html_ga2d36ef441d1dfddf49cfb5c01bd58d8e"><div class="ttname"><a href="a00215.html#ga2d36ef441d1dfddf49cfb5c01bd58d8e">hwloc_gl_get_display_osdev_by_name</a></div><div class="ttdeci">static hwloc_obj_t hwloc_gl_get_display_osdev_by_name(hwloc_topology_t topology, const char *name)</div><div class="ttdoc">Get the hwloc OS device object corresponding to the OpenGL display given by name.</div><div class="ttdef"><b>Definition</b> gl.h:85</div></div>
+<div class="ttc" id="aa00215_html_ga4d66a77e4fe4051d6e5b772c1b8fcec5"><div class="ttname"><a href="a00215.html#ga4d66a77e4fe4051d6e5b772c1b8fcec5">hwloc_gl_get_display_osdev_by_port_device</a></div><div class="ttdeci">static hwloc_obj_t hwloc_gl_get_display_osdev_by_port_device(hwloc_topology_t topology, unsigned port, unsigned device)</div><div class="ttdoc">Get the hwloc OS device object corresponding to the OpenGL display given by port and device index.</div><div class="ttdef"><b>Definition</b> gl.h:54</div></div>
+<div class="ttc" id="aa00215_html_ga936665ab5f0d29a081c4b78d11f4ad07"><div class="ttname"><a href="a00215.html#ga936665ab5f0d29a081c4b78d11f4ad07">hwloc_gl_get_display_by_osdev</a></div><div class="ttdeci">static int hwloc_gl_get_display_by_osdev(hwloc_topology_t topology, hwloc_obj_t osdev, unsigned *port, unsigned *device)</div><div class="ttdoc">Get the OpenGL display port and device corresponding to the given hwloc OS object.</div><div class="ttdef"><b>Definition</b> gl.h:113</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_abb709ec38f2970677e4e57d1d30be96d"><div class="ttname"><a href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj::name</a></div><div class="ttdeci">char * name</div><div class="ttdoc">Object-specific name if any. Mostly used for identifying OS devices and Misc objects where a name str...</div><div class="ttdef"><b>Definition</b> hwloc.h:443</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00233_html_aaf7a5c38b5185703ff18c46ad2761dcf"><div class="ttname"><a href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">hwloc_obj_attr_u::osdev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_osdev_attr_s osdev</div></div>
+<div class="ttc" id="aa00273_html_a31e019e27e54ac6138d04be639bb96f9"><div class="ttname"><a href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">hwloc_obj_attr_u::hwloc_osdev_attr_s::type</a></div><div class="ttdeci">hwloc_obj_osdev_type_t type</div><div class="ttdef"><b>Definition</b> hwloc.h:716</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00158_source.html 2.11.0-1/doc/doxygen-doc/html/a00158_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00158_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00158_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,165 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): openfabrics-verbs.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">openfabrics-verbs.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2009 CNRS</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2009-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * Copyright © 2009-2010 Université Bordeaux</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span> </div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#ifndef HWLOC_OPENFABRICS_VERBS_H</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#define HWLOC_OPENFABRICS_VERBS_H</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &quot;hwloc/autogen/config.h&quot;</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#include &quot;hwloc/linux.h&quot;</span></div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
+<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span><span class="preprocessor">#include &lt;infiniband/verbs.h&gt;</span></div>
+<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span> </div>
+<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
+<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span> </div>
+<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span> </div>
+<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00065" data-start="{" data-end="}">
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno"><a class="line" href="a00216.html#ga3ea0d838c1e7f1671b35687aae2da6ae">   65</a></span><a class="code hl_function" href="a00216.html#ga3ea0d838c1e7f1671b35687aae2da6ae">hwloc_ibv_get_device_cpuset</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology __hwloc_attribute_unused,</div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>                            <span class="keyword">struct</span> ibv_device *ibdev, <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>{</div>
+<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span><span class="preprocessor">#ifdef HWLOC_LINUX_SYS</span></div>
+<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>  <span class="comment">/* If we&#39;re on Linux, use the verbs-provided sysfs mechanism to</span></div>
+<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span><span class="comment">     get the local cpus */</span></div>
+<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span><span class="preprocessor">#define HWLOC_OPENFABRICS_VERBS_SYSFS_PATH_MAX 128</span></div>
+<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>  <span class="keywordtype">char</span> path[HWLOC_OPENFABRICS_VERBS_SYSFS_PATH_MAX];</div>
+<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span> </div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>  <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(topology)) {</div>
+<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>    errno = EINVAL;</div>
+<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>  }</div>
+<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span> </div>
+<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>  sprintf(path, <span class="stringliteral">&quot;/sys/class/infiniband/%s/device/local_cpus&quot;</span>,</div>
+<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>          ibv_get_device_name(ibdev));</div>
+<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>  <span class="keywordflow">if</span> (<a class="code hl_function" href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a>(path, set) &lt; 0</div>
+<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>      || <a class="code hl_function" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a>(set))</div>
+<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>    <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>  <span class="comment">/* Non-Linux systems simply get a full cpuset */</span></div>
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>  <a class="code hl_function" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a>(set, <a class="code hl_function" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a>(topology));</div>
+<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>}</div>
+</div>
+<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span> </div>
+<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00109" data-start="{" data-end="}">
+<div class="line"><a id="l00109" name="l00109"></a><span class="lineno"><a class="line" href="a00216.html#ga31d794567f4420bbdc8baa7bf8bf6138">  109</a></span><a class="code hl_function" href="a00216.html#ga31d794567f4420bbdc8baa7bf8bf6138">hwloc_ibv_get_device_osdev_by_name</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>                                   <span class="keyword">const</span> <span class="keywordtype">char</span> *ibname)</div>
+<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>{</div>
+<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> osdev = NULL;</div>
+<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>        <span class="keywordflow">while</span> ((osdev = <a class="code hl_function" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a>(topology, osdev)) != NULL) {</div>
+<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>                <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a52157d03694fdae82dddd57ca8c973b6">HWLOC_OBJ_OSDEV_OPENFABRICS</a> == osdev-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a>.<a class="code hl_variable" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a></div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>                    &amp;&amp; osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a> &amp;&amp; !strcmp(ibname, osdev-&gt;<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>))</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>                        <span class="keywordflow">return</span> osdev;</div>
+<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        }</div>
+<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>        <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>}</div>
+</div>
+<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span> </div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span><span class="keyword">static</span> __hwloc_inline <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="foldopen" id="foldopen00137" data-start="{" data-end="}">
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno"><a class="line" href="a00216.html#ga7324cdfd5db6ed2669c051ef7e1b64e1">  137</a></span><a class="code hl_function" href="a00216.html#ga7324cdfd5db6ed2669c051ef7e1b64e1">hwloc_ibv_get_device_osdev</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>                           <span class="keyword">struct</span> ibv_device *ibdev)</div>
+<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>{</div>
+<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>        <span class="keywordflow">if</span> (!<a class="code hl_function" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a>(topology)) {</div>
+<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>                errno = EINVAL;</div>
+<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>                <span class="keywordflow">return</span> NULL;</div>
+<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        }</div>
+<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>        <span class="keywordflow">return</span> <a class="code hl_function" href="a00216.html#ga31d794567f4420bbdc8baa7bf8bf6138">hwloc_ibv_get_device_osdev_by_name</a>(topology, ibv_get_device_name(ibdev));</div>
+<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>}</div>
+</div>
+<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span> </div>
+<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span> </div>
+<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span> </div>
+<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_OPENFABRICS_VERBS_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0a52157d03694fdae82dddd57ca8c973b6"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a52157d03694fdae82dddd57ca8c973b6">HWLOC_OBJ_OSDEV_OPENFABRICS</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_OPENFABRICS</div><div class="ttdoc">Operating system openfabrics device. For instance the &quot;mlx4_0&quot; InfiniBand HCA, &quot;hfi1_0&quot; Omni-Path int...</div><div class="ttdef"><b>Definition</b> hwloc.h:379</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00182_html_ga68ffdcfd9175cdf40709801092f18017"><div class="ttname"><a href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a></div><div class="ttdeci">int hwloc_topology_is_thissystem(hwloc_topology_t restrict topology)</div><div class="ttdoc">Does the topology context come from this system?</div></div>
+<div class="ttc" id="aa00191_html_gaee30e03391c1ed7dfd617fb5c7bbb033"><div class="ttname"><a href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a></div><div class="ttdeci">hwloc_const_cpuset_t hwloc_topology_get_complete_cpuset(hwloc_topology_t topology)</div><div class="ttdoc">Get complete CPU set.</div></div>
+<div class="ttc" id="aa00193_html_ga8b4584c8949e2c5f1c97ba7fe92b8145"><div class="ttname"><a href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_next_osdev(hwloc_topology_t topology, hwloc_obj_t prev)</div><div class="ttdoc">Get the next OS device in the system.</div><div class="ttdef"><b>Definition</b> helper.h:1290</div></div>
+<div class="ttc" id="aa00194_html_ga5b64be28f5a7176ed8ad0d6a90bdf108"><div class="ttname"><a href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a></div><div class="ttdeci">int hwloc_bitmap_iszero(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Test whether bitmap bitmap is empty.</div></div>
+<div class="ttc" id="aa00194_html_ga72a29824798b48784b8217471ec8f14c"><div class="ttname"><a href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a></div><div class="ttdeci">int hwloc_bitmap_copy(hwloc_bitmap_t dst, hwloc_const_bitmap_t src)</div><div class="ttdoc">Copy the contents of bitmap src into the already allocated bitmap dst.</div></div>
+<div class="ttc" id="aa00204_html_gaf72d83e273803226ce772973e37b85de"><div class="ttname"><a href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a></div><div class="ttdeci">int hwloc_linux_read_path_as_cpumask(const char *path, hwloc_bitmap_t set)</div><div class="ttdoc">Convert a linux kernel cpumask file path into a hwloc bitmap set.</div></div>
+<div class="ttc" id="aa00216_html_ga31d794567f4420bbdc8baa7bf8bf6138"><div class="ttname"><a href="a00216.html#ga31d794567f4420bbdc8baa7bf8bf6138">hwloc_ibv_get_device_osdev_by_name</a></div><div class="ttdeci">static hwloc_obj_t hwloc_ibv_get_device_osdev_by_name(hwloc_topology_t topology, const char *ibname)</div><div class="ttdoc">Get the hwloc OS device object corresponding to the OpenFabrics device named ibname.</div><div class="ttdef"><b>Definition</b> openfabrics-verbs.h:109</div></div>
+<div class="ttc" id="aa00216_html_ga3ea0d838c1e7f1671b35687aae2da6ae"><div class="ttname"><a href="a00216.html#ga3ea0d838c1e7f1671b35687aae2da6ae">hwloc_ibv_get_device_cpuset</a></div><div class="ttdeci">static int hwloc_ibv_get_device_cpuset(hwloc_topology_t topology, struct ibv_device *ibdev, hwloc_cpuset_t set)</div><div class="ttdoc">Get the CPU set of processors that are physically close to device ibdev.</div><div class="ttdef"><b>Definition</b> openfabrics-verbs.h:65</div></div>
+<div class="ttc" id="aa00216_html_ga7324cdfd5db6ed2669c051ef7e1b64e1"><div class="ttname"><a href="a00216.html#ga7324cdfd5db6ed2669c051ef7e1b64e1">hwloc_ibv_get_device_osdev</a></div><div class="ttdeci">static hwloc_obj_t hwloc_ibv_get_device_osdev(hwloc_topology_t topology, struct ibv_device *ibdev)</div><div class="ttdoc">Get the hwloc OS device object corresponding to the OpenFabrics device ibdev.</div><div class="ttdef"><b>Definition</b> openfabrics-verbs.h:137</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_abb709ec38f2970677e4e57d1d30be96d"><div class="ttname"><a href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj::name</a></div><div class="ttdeci">char * name</div><div class="ttdoc">Object-specific name if any. Mostly used for identifying OS devices and Misc objects where a name str...</div><div class="ttdef"><b>Definition</b> hwloc.h:443</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00233_html_aaf7a5c38b5185703ff18c46ad2761dcf"><div class="ttname"><a href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">hwloc_obj_attr_u::osdev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_osdev_attr_s osdev</div></div>
+<div class="ttc" id="aa00273_html_a31e019e27e54ac6138d04be639bb96f9"><div class="ttname"><a href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">hwloc_obj_attr_u::hwloc_osdev_attr_s::type</a></div><div class="ttdeci">hwloc_obj_osdev_type_t type</div><div class="ttdef"><b>Definition</b> hwloc.h:716</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00161_source.html 2.11.0-1/doc/doxygen-doc/html/a00161_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00161_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00161_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,241 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): diff.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">diff.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2013-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span> </div>
+<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="preprocessor">#ifndef HWLOC_DIFF_H</span></div>
+<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="preprocessor">#define HWLOC_DIFF_H</span></div>
+<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#ifndef HWLOC_H</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#error Please include the main hwloc.h instead</span></div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span> </div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#elif 0</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>}</div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
+<div class="foldopen" id="foldopen00062" data-start="{" data-end="};">
+<div class="line"><a id="l00062" name="l00062"></a><span class="lineno"><a class="line" href="a00217.html#ga86f044210b0a9e9fa83acbdbbf7e05fd">   62</a></span><span class="keyword">typedef</span> <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00217.html#ga86f044210b0a9e9fa83acbdbbf7e05fd">hwloc_topology_diff_obj_attr_type_e</a> {</div>
+<div class="line"><a id="l00067" name="l00067"></a><span class="lineno"><a class="line" href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fdabc7f0c7ed0b6864e902f4b70f2c7bc94">   67</a></span>  <a class="code hl_enumvalue" href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fdabc7f0c7ed0b6864e902f4b70f2c7bc94">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE</a>,</div>
+<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span> </div>
+<div class="line"><a id="l00074" name="l00074"></a><span class="lineno"><a class="line" href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fda94a8f37c51d62d15ac6192665dd49310">   74</a></span>  <a class="code hl_enumvalue" href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fda94a8f37c51d62d15ac6192665dd49310">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME</a>,</div>
+<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>  <a class="code hl_enumvalue" href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fda63430bf932434bc456282f636d39c2c2">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO</a></div>
+<div class="line"><a id="l00079" name="l00079"></a><span class="lineno"><a class="line" href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fda63430bf932434bc456282f636d39c2c2">   79</a></span>} <a class="code hl_typedef" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a>;</div>
+</div>
+<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span> </div>
+<div class="foldopen" id="foldopen00083" data-start="{" data-end="};">
+<div class="line"><a id="l00083" name="l00083"></a><span class="lineno"><a class="line" href="a00329.html">   83</a></span><span class="keyword">union </span><a class="code hl_union" href="a00329.html">hwloc_topology_diff_obj_attr_u</a> {</div>
+<div class="foldopen" id="foldopen00084" data-start="{" data-end="};">
+<div class="line"><a id="l00084" name="l00084"></a><span class="lineno"><a class="line" href="a00333.html">   84</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00333.html">hwloc_topology_diff_obj_attr_generic_s</a> {</div>
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>    <span class="comment">/* each part of the union must start with these */</span></div>
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno"><a class="line" href="a00333.html#a43f8133b7c30129b002c2d295e6580fc">   86</a></span>    <a class="code hl_typedef" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a> <a class="code hl_variable" href="a00333.html#a43f8133b7c30129b002c2d295e6580fc">type</a>;</div>
+<div class="line"><a id="l00087" name="l00087"></a><span class="lineno"><a class="line" href="a00329.html#aeb449c0e04b14ebf8c3126756b6364f9">   87</a></span>  } <span class="keyword">generic</span>;</div>
+</div>
+<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span> </div>
+<div class="foldopen" id="foldopen00090" data-start="{" data-end="};">
+<div class="line"><a id="l00090" name="l00090"></a><span class="lineno"><a class="line" href="a00337.html">   90</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00337.html">hwloc_topology_diff_obj_attr_uint64_s</a> {</div>
+<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>    <span class="comment">/* used for storing integer attributes */</span></div>
+<div class="line"><a id="l00092" name="l00092"></a><span class="lineno"><a class="line" href="a00337.html#afe262b9aa558fe7bfecbd37a7a129197">   92</a></span>    <a class="code hl_typedef" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a> <a class="code hl_variable" href="a00337.html#afe262b9aa558fe7bfecbd37a7a129197">type</a>;</div>
+<div class="line"><a id="l00093" name="l00093"></a><span class="lineno"><a class="line" href="a00337.html#adb772c3f1761ecadf496c80ae14afce3">   93</a></span>    hwloc_uint64_t <a class="code hl_variable" href="a00337.html#adb772c3f1761ecadf496c80ae14afce3">index</a>; <span class="comment">/* not used for SIZE */</span></div>
+<div class="line"><a id="l00094" name="l00094"></a><span class="lineno"><a class="line" href="a00337.html#a44c0894dce563335d347fde6595c49c9">   94</a></span>    hwloc_uint64_t <a class="code hl_variable" href="a00337.html#a44c0894dce563335d347fde6595c49c9">oldvalue</a>;</div>
+<div class="line"><a id="l00095" name="l00095"></a><span class="lineno"><a class="line" href="a00337.html#ae63aa59ad65aa783b730a4f213304eb4">   95</a></span>    hwloc_uint64_t <a class="code hl_variable" href="a00337.html#ae63aa59ad65aa783b730a4f213304eb4">newvalue</a>;</div>
+<div class="line"><a id="l00096" name="l00096"></a><span class="lineno"><a class="line" href="a00329.html#a4608ade88460f5f208887775e5a69a0a">   96</a></span>  } <a class="code hl_variable" href="a00329.html#a4608ade88460f5f208887775e5a69a0a">uint64</a>;</div>
+</div>
+<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
+<div class="foldopen" id="foldopen00099" data-start="{" data-end="};">
+<div class="line"><a id="l00099" name="l00099"></a><span class="lineno"><a class="line" href="a00341.html">   99</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00341.html">hwloc_topology_diff_obj_attr_string_s</a> {</div>
+<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>    <span class="comment">/* used for storing name and info pairs */</span></div>
+<div class="line"><a id="l00101" name="l00101"></a><span class="lineno"><a class="line" href="a00341.html#a784ab5827c1bf531b86d1f02f199d04d">  101</a></span>    <a class="code hl_typedef" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a> <a class="code hl_variable" href="a00341.html#a784ab5827c1bf531b86d1f02f199d04d">type</a>;</div>
+<div class="line"><a id="l00102" name="l00102"></a><span class="lineno"><a class="line" href="a00341.html#a7ef48c66ccddf34d90edb4e4314b41c6">  102</a></span>    <span class="keywordtype">char</span> *<a class="code hl_variable" href="a00341.html#a7ef48c66ccddf34d90edb4e4314b41c6">name</a>; <span class="comment">/* not used for NAME */</span></div>
+<div class="line"><a id="l00103" name="l00103"></a><span class="lineno"><a class="line" href="a00341.html#a33cc281d4417129064295a6ae7b79818">  103</a></span>    <span class="keywordtype">char</span> *<a class="code hl_variable" href="a00341.html#a33cc281d4417129064295a6ae7b79818">oldvalue</a>;</div>
+<div class="line"><a id="l00104" name="l00104"></a><span class="lineno"><a class="line" href="a00341.html#a75f37f4add21cece50fee2701c3b77db">  104</a></span>    <span class="keywordtype">char</span> *<a class="code hl_variable" href="a00341.html#a75f37f4add21cece50fee2701c3b77db">newvalue</a>;</div>
+<div class="line"><a id="l00105" name="l00105"></a><span class="lineno"><a class="line" href="a00329.html#a42fa15c37f1f59ef638066c4c62c3154">  105</a></span>  } <a class="code hl_variable" href="a00329.html#a42fa15c37f1f59ef638066c4c62c3154">string</a>;</div>
+</div>
+<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>};</div>
+</div>
+<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span> </div>
+<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span> </div>
+<div class="foldopen" id="foldopen00111" data-start="{" data-end="};">
+<div class="line"><a id="l00111" name="l00111"></a><span class="lineno"><a class="line" href="a00217.html#ga38b28b7423b85a3321e6d0062d5f83d0">  111</a></span><span class="keyword">typedef</span> <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00217.html#ga38b28b7423b85a3321e6d0062d5f83d0">hwloc_topology_diff_type_e</a> {</div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno"><a class="line" href="a00217.html#gga38b28b7423b85a3321e6d0062d5f83d0accbcaee230f79989debb284c8626f0c0">  115</a></span>  <a class="code hl_enumvalue" href="a00217.html#gga38b28b7423b85a3321e6d0062d5f83d0accbcaee230f79989debb284c8626f0c0">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR</a>,</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span> </div>
+<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>  <a class="code hl_enumvalue" href="a00217.html#gga38b28b7423b85a3321e6d0062d5f83d0a3dc01fdeff355efe3fb2516bb454a147">HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX</a></div>
+<div class="line"><a id="l00125" name="l00125"></a><span class="lineno"><a class="line" href="a00217.html#gga38b28b7423b85a3321e6d0062d5f83d0a3dc01fdeff355efe3fb2516bb454a147">  125</a></span>} <a class="code hl_typedef" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a>;</div>
+</div>
+<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span> </div>
+<div class="foldopen" id="foldopen00129" data-start="{" data-end="};">
+<div class="line"><a id="l00129" name="l00129"></a><span class="lineno"><a class="line" href="a00345.html">  129</a></span><span class="keyword">typedef</span> <span class="keyword">union </span><a class="code hl_union" href="a00345.html">hwloc_topology_diff_u</a> {</div>
+<div class="foldopen" id="foldopen00130" data-start="{" data-end="};">
+<div class="line"><a id="l00130" name="l00130"></a><span class="lineno"><a class="line" href="a00349.html">  130</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00349.html">hwloc_topology_diff_generic_s</a> {</div>
+<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>    <span class="comment">/* each part of the union must start with these */</span></div>
+<div class="line"><a id="l00132" name="l00132"></a><span class="lineno"><a class="line" href="a00349.html#a373005489fcddeba6319163e60263ae8">  132</a></span>    <a class="code hl_typedef" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a> <a class="code hl_variable" href="a00349.html#a373005489fcddeba6319163e60263ae8">type</a>;</div>
+<div class="line"><a id="l00133" name="l00133"></a><span class="lineno"><a class="line" href="a00349.html#a720aa94eb73cddfd8d6bf9fcbbfc035e">  133</a></span>    <span class="keyword">union </span><a class="code hl_union" href="a00345.html">hwloc_topology_diff_u</a> * <a class="code hl_variable" href="a00349.html#a720aa94eb73cddfd8d6bf9fcbbfc035e">next</a>; <span class="comment">/* pointer to the next element of the list, or NULL */</span></div>
+<div class="line"><a id="l00134" name="l00134"></a><span class="lineno"><a class="line" href="a00345.html#a0dd2cbfba0eca2fc7a2645668bcae0f8">  134</a></span>  } <span class="keyword">generic</span>;</div>
+</div>
+<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span> </div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>  <span class="comment">/* A difference in an object attribute. */</span></div>
+<div class="foldopen" id="foldopen00137" data-start="{" data-end="};">
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno"><a class="line" href="a00353.html">  137</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00353.html">hwloc_topology_diff_obj_attr_s</a> {</div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno"><a class="line" href="a00353.html#a70a118ad288bd98f18c8ce6dc52e2d10">  138</a></span>    <a class="code hl_typedef" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a> <a class="code hl_variable" href="a00353.html#a70a118ad288bd98f18c8ce6dc52e2d10">type</a>; <span class="comment">/* must be ::HWLOC_TOPOLOGY_DIFF_OBJ_ATTR */</span></div>
+<div class="line"><a id="l00139" name="l00139"></a><span class="lineno"><a class="line" href="a00353.html#acb9170a8eb3392656d70f7f3ef3e3eed">  139</a></span>    <span class="keyword">union </span><a class="code hl_union" href="a00345.html">hwloc_topology_diff_u</a> * <a class="code hl_variable" href="a00353.html#acb9170a8eb3392656d70f7f3ef3e3eed">next</a>;</div>
+<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>    <span class="comment">/* List of attribute differences for a single object */</span></div>
+<div class="line"><a id="l00141" name="l00141"></a><span class="lineno"><a class="line" href="a00353.html#a82c1d4bab80b9e0bf301a9d8291893e0">  141</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="a00353.html#a82c1d4bab80b9e0bf301a9d8291893e0">obj_depth</a>;</div>
+<div class="line"><a id="l00142" name="l00142"></a><span class="lineno"><a class="line" href="a00353.html#adb9f4d414470b6670cde8d90759a6c1c">  142</a></span>    <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00353.html#adb9f4d414470b6670cde8d90759a6c1c">obj_index</a>;</div>
+<div class="line"><a id="l00143" name="l00143"></a><span class="lineno"><a class="line" href="a00353.html#a91f0645f9062e892652357cd141c8ebb">  143</a></span>    <span class="keyword">union </span><a class="code hl_union" href="a00329.html">hwloc_topology_diff_obj_attr_u</a> <a class="code hl_variable" href="a00353.html#a91f0645f9062e892652357cd141c8ebb">diff</a>;</div>
+<div class="line"><a id="l00144" name="l00144"></a><span class="lineno"><a class="line" href="a00345.html#a01dca644feea48448b36baa60cf4c07f">  144</a></span>  } obj_attr;</div>
+</div>
+<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span> </div>
+<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>  <span class="comment">/* A difference that is too complex. */</span></div>
+<div class="foldopen" id="foldopen00147" data-start="{" data-end="};">
+<div class="line"><a id="l00147" name="l00147"></a><span class="lineno"><a class="line" href="a00357.html">  147</a></span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00357.html">hwloc_topology_diff_too_complex_s</a> {</div>
+<div class="line"><a id="l00148" name="l00148"></a><span class="lineno"><a class="line" href="a00357.html#a92084295a4d6faf17a95a7eea526ddbd">  148</a></span>    <a class="code hl_typedef" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a> <a class="code hl_variable" href="a00357.html#a92084295a4d6faf17a95a7eea526ddbd">type</a>; <span class="comment">/* must be ::HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX */</span></div>
+<div class="line"><a id="l00149" name="l00149"></a><span class="lineno"><a class="line" href="a00357.html#a375afbaa043b109be689a7d9a3c7d153">  149</a></span>    <span class="keyword">union </span><a class="code hl_union" href="a00345.html">hwloc_topology_diff_u</a> * <a class="code hl_variable" href="a00357.html#a375afbaa043b109be689a7d9a3c7d153">next</a>;</div>
+<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>    <span class="comment">/* Where we had to stop computing the diff in the first topology */</span></div>
+<div class="line"><a id="l00151" name="l00151"></a><span class="lineno"><a class="line" href="a00357.html#a94c6498caeaafbb79927395d918d6cb3">  151</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="a00357.html#a94c6498caeaafbb79927395d918d6cb3">obj_depth</a>;</div>
+<div class="line"><a id="l00152" name="l00152"></a><span class="lineno"><a class="line" href="a00357.html#a6dc6b3c4adb10db74d993e37afaa0580">  152</a></span>    <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00357.html#a6dc6b3c4adb10db74d993e37afaa0580">obj_index</a>;</div>
+<div class="line"><a id="l00153" name="l00153"></a><span class="lineno"><a class="line" href="a00345.html#af7dc1148eb656c56e9678218cafd027b">  153</a></span>  } too_complex;</div>
+</div>
+<div class="line"><a id="l00154" name="l00154"></a><span class="lineno"><a class="line" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">  154</a></span>} * <a class="code hl_typedef" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a>;</div>
+</div>
+<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span> </div>
+<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span> </div>
+<div class="line"><a id="l00194" name="l00194"></a><span class="lineno"><a class="line" href="a00217.html#ga8a1754f69fbb31364ea3ea2c39827c9f">  194</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00217.html#ga8a1754f69fbb31364ea3ea2c39827c9f">hwloc_topology_diff_build</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> newtopology, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags, <a class="code hl_union" href="a00345.html">hwloc_topology_diff_t</a> *diff);</div>
+<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span> </div>
+<div class="foldopen" id="foldopen00198" data-start="{" data-end="};">
+<div class="line"><a id="l00198" name="l00198"></a><span class="lineno"><a class="line" href="a00217.html#gada4c1273ce020afaf02b649496f7edf5">  198</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00217.html#gada4c1273ce020afaf02b649496f7edf5">hwloc_topology_diff_apply_flags_e</a> {</div>
+<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>  <a class="code hl_enumvalue" href="a00217.html#ggada4c1273ce020afaf02b649496f7edf5a821a160512d67ea0dd05dab873d2fc54">HWLOC_TOPOLOGY_DIFF_APPLY_REVERSE</a> = (1UL&lt;&lt;0)</div>
+<div class="line"><a id="l00203" name="l00203"></a><span class="lineno"><a class="line" href="a00217.html#ggada4c1273ce020afaf02b649496f7edf5a821a160512d67ea0dd05dab873d2fc54">  203</a></span>};</div>
+</div>
+<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span> </div>
+<div class="line"><a id="l00222" name="l00222"></a><span class="lineno"><a class="line" href="a00217.html#gae7b350d7e7478a4c6047b08aa6544f40">  222</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00217.html#gae7b350d7e7478a4c6047b08aa6544f40">hwloc_topology_diff_apply</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_union" href="a00345.html">hwloc_topology_diff_t</a> diff, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span> </div>
+<div class="line"><a id="l00228" name="l00228"></a><span class="lineno"><a class="line" href="a00217.html#ga5dcff18f80583ac6505a94ba2877fd1b">  228</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00217.html#ga5dcff18f80583ac6505a94ba2877fd1b">hwloc_topology_diff_destroy</a>(<a class="code hl_union" href="a00345.html">hwloc_topology_diff_t</a> diff);</div>
+<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span> </div>
+<div class="line"><a id="l00243" name="l00243"></a><span class="lineno"><a class="line" href="a00217.html#ga2cd902ce8766e90d4f2523a8e87640e9">  243</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00217.html#ga2cd902ce8766e90d4f2523a8e87640e9">hwloc_topology_diff_load_xml</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *xmlpath, <a class="code hl_union" href="a00345.html">hwloc_topology_diff_t</a> *diff, <span class="keywordtype">char</span> **refname);</div>
+<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span> </div>
+<div class="line"><a id="l00256" name="l00256"></a><span class="lineno"><a class="line" href="a00217.html#ga8a14dd7d01efbdd97af7fe85e8b84b20">  256</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00217.html#ga8a14dd7d01efbdd97af7fe85e8b84b20">hwloc_topology_diff_export_xml</a>(<a class="code hl_union" href="a00345.html">hwloc_topology_diff_t</a> diff, <span class="keyword">const</span> <span class="keywordtype">char</span> *refname, <span class="keyword">const</span> <span class="keywordtype">char</span> *xmlpath);</div>
+<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span> </div>
+<div class="line"><a id="l00276" name="l00276"></a><span class="lineno"><a class="line" href="a00217.html#gad693810a5c51628529b9dd56f040fb81">  276</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00217.html#gad693810a5c51628529b9dd56f040fb81">hwloc_topology_diff_load_xmlbuffer</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *xmlbuffer, <span class="keywordtype">int</span> buflen, <a class="code hl_union" href="a00345.html">hwloc_topology_diff_t</a> *diff, <span class="keywordtype">char</span> **refname);</div>
+<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span> </div>
+<div class="line"><a id="l00294" name="l00294"></a><span class="lineno"><a class="line" href="a00217.html#gaa2f0918df60c1c4a0bef9411f7d92a13">  294</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00217.html#gaa2f0918df60c1c4a0bef9411f7d92a13">hwloc_topology_diff_export_xmlbuffer</a>(<a class="code hl_union" href="a00345.html">hwloc_topology_diff_t</a> diff, <span class="keyword">const</span> <span class="keywordtype">char</span> *refname, <span class="keywordtype">char</span> **xmlbuffer, <span class="keywordtype">int</span> *buflen);</div>
+<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span> </div>
+<div class="line"><a id="l00299" name="l00299"></a><span class="lineno">  299</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00300" name="l00300"></a><span class="lineno">  300</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00301" name="l00301"></a><span class="lineno">  301</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00302" name="l00302"></a><span class="lineno">  302</span> </div>
+<div class="line"><a id="l00303" name="l00303"></a><span class="lineno">  303</span> </div>
+<div class="line"><a id="l00304" name="l00304"></a><span class="lineno">  304</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_DIFF_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00217_html_ga1bd6363f26f7961f83153aaa484a9b85"><div class="ttname"><a href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a></div><div class="ttdeci">union hwloc_topology_diff_u * hwloc_topology_diff_t</div><div class="ttdoc">One element of a difference list between two topologies.</div></div>
+<div class="ttc" id="aa00217_html_ga2cd902ce8766e90d4f2523a8e87640e9"><div class="ttname"><a href="a00217.html#ga2cd902ce8766e90d4f2523a8e87640e9">hwloc_topology_diff_load_xml</a></div><div class="ttdeci">int hwloc_topology_diff_load_xml(const char *xmlpath, hwloc_topology_diff_t *diff, char **refname)</div><div class="ttdoc">Load a list of topology differences from a XML file.</div></div>
+<div class="ttc" id="aa00217_html_ga38b28b7423b85a3321e6d0062d5f83d0"><div class="ttname"><a href="a00217.html#ga38b28b7423b85a3321e6d0062d5f83d0">hwloc_topology_diff_type_e</a></div><div class="ttdeci">hwloc_topology_diff_type_e</div><div class="ttdoc">Type of one element of a difference list.</div><div class="ttdef"><b>Definition</b> diff.h:111</div></div>
+<div class="ttc" id="aa00217_html_ga5dcff18f80583ac6505a94ba2877fd1b"><div class="ttname"><a href="a00217.html#ga5dcff18f80583ac6505a94ba2877fd1b">hwloc_topology_diff_destroy</a></div><div class="ttdeci">int hwloc_topology_diff_destroy(hwloc_topology_diff_t diff)</div><div class="ttdoc">Destroy a list of topology differences.</div></div>
+<div class="ttc" id="aa00217_html_ga74a3fefbaa17582fea86d76b312d6254"><div class="ttname"><a href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a></div><div class="ttdeci">enum hwloc_topology_diff_obj_attr_type_e hwloc_topology_diff_obj_attr_type_t</div><div class="ttdoc">Type of one object attribute difference.</div></div>
+<div class="ttc" id="aa00217_html_ga8470f631b7365c839d3e40d38c5b6291"><div class="ttname"><a href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a></div><div class="ttdeci">enum hwloc_topology_diff_type_e hwloc_topology_diff_type_t</div><div class="ttdoc">Type of one element of a difference list.</div></div>
+<div class="ttc" id="aa00217_html_ga86f044210b0a9e9fa83acbdbbf7e05fd"><div class="ttname"><a href="a00217.html#ga86f044210b0a9e9fa83acbdbbf7e05fd">hwloc_topology_diff_obj_attr_type_e</a></div><div class="ttdeci">hwloc_topology_diff_obj_attr_type_e</div><div class="ttdoc">Type of one object attribute difference.</div><div class="ttdef"><b>Definition</b> diff.h:62</div></div>
+<div class="ttc" id="aa00217_html_ga8a14dd7d01efbdd97af7fe85e8b84b20"><div class="ttname"><a href="a00217.html#ga8a14dd7d01efbdd97af7fe85e8b84b20">hwloc_topology_diff_export_xml</a></div><div class="ttdeci">int hwloc_topology_diff_export_xml(hwloc_topology_diff_t diff, const char *refname, const char *xmlpath)</div><div class="ttdoc">Export a list of topology differences to a XML file.</div></div>
+<div class="ttc" id="aa00217_html_ga8a1754f69fbb31364ea3ea2c39827c9f"><div class="ttname"><a href="a00217.html#ga8a1754f69fbb31364ea3ea2c39827c9f">hwloc_topology_diff_build</a></div><div class="ttdeci">int hwloc_topology_diff_build(hwloc_topology_t topology, hwloc_topology_t newtopology, unsigned long flags, hwloc_topology_diff_t *diff)</div><div class="ttdoc">Compute the difference between 2 topologies.</div></div>
+<div class="ttc" id="aa00217_html_gaa2f0918df60c1c4a0bef9411f7d92a13"><div class="ttname"><a href="a00217.html#gaa2f0918df60c1c4a0bef9411f7d92a13">hwloc_topology_diff_export_xmlbuffer</a></div><div class="ttdeci">int hwloc_topology_diff_export_xmlbuffer(hwloc_topology_diff_t diff, const char *refname, char **xmlbuffer, int *buflen)</div><div class="ttdoc">Export a list of topology differences to a XML buffer.</div></div>
+<div class="ttc" id="aa00217_html_gad693810a5c51628529b9dd56f040fb81"><div class="ttname"><a href="a00217.html#gad693810a5c51628529b9dd56f040fb81">hwloc_topology_diff_load_xmlbuffer</a></div><div class="ttdeci">int hwloc_topology_diff_load_xmlbuffer(const char *xmlbuffer, int buflen, hwloc_topology_diff_t *diff, char **refname)</div><div class="ttdoc">Load a list of topology differences from a XML buffer.</div></div>
+<div class="ttc" id="aa00217_html_gada4c1273ce020afaf02b649496f7edf5"><div class="ttname"><a href="a00217.html#gada4c1273ce020afaf02b649496f7edf5">hwloc_topology_diff_apply_flags_e</a></div><div class="ttdeci">hwloc_topology_diff_apply_flags_e</div><div class="ttdoc">Flags to be given to hwloc_topology_diff_apply().</div><div class="ttdef"><b>Definition</b> diff.h:198</div></div>
+<div class="ttc" id="aa00217_html_gae7b350d7e7478a4c6047b08aa6544f40"><div class="ttname"><a href="a00217.html#gae7b350d7e7478a4c6047b08aa6544f40">hwloc_topology_diff_apply</a></div><div class="ttdeci">int hwloc_topology_diff_apply(hwloc_topology_t topology, hwloc_topology_diff_t diff, unsigned long flags)</div><div class="ttdoc">Apply a topology diff to an existing topology.</div></div>
+<div class="ttc" id="aa00217_html_gga38b28b7423b85a3321e6d0062d5f83d0a3dc01fdeff355efe3fb2516bb454a147"><div class="ttname"><a href="a00217.html#gga38b28b7423b85a3321e6d0062d5f83d0a3dc01fdeff355efe3fb2516bb454a147">HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX</div><div class="ttdoc">The difference is too complex, it cannot be represented. The difference below this object has not bee...</div><div class="ttdef"><b>Definition</b> diff.h:124</div></div>
+<div class="ttc" id="aa00217_html_gga38b28b7423b85a3321e6d0062d5f83d0accbcaee230f79989debb284c8626f0c0"><div class="ttname"><a href="a00217.html#gga38b28b7423b85a3321e6d0062d5f83d0accbcaee230f79989debb284c8626f0c0">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_DIFF_OBJ_ATTR</div><div class="ttdoc">An object attribute was changed. The union is a hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s...</div><div class="ttdef"><b>Definition</b> diff.h:115</div></div>
+<div class="ttc" id="aa00217_html_gga86f044210b0a9e9fa83acbdbbf7e05fda63430bf932434bc456282f636d39c2c2"><div class="ttname"><a href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fda63430bf932434bc456282f636d39c2c2">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO</div><div class="ttdoc">the value of an info attribute is modified. The union is a hwloc_topology_diff_obj_attr_u::hwloc_topo...</div><div class="ttdef"><b>Definition</b> diff.h:78</div></div>
+<div class="ttc" id="aa00217_html_gga86f044210b0a9e9fa83acbdbbf7e05fda94a8f37c51d62d15ac6192665dd49310"><div class="ttname"><a href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fda94a8f37c51d62d15ac6192665dd49310">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME</div><div class="ttdoc">The object name is modified. The union is a hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_a...</div><div class="ttdef"><b>Definition</b> diff.h:74</div></div>
+<div class="ttc" id="aa00217_html_gga86f044210b0a9e9fa83acbdbbf7e05fdabc7f0c7ed0b6864e902f4b70f2c7bc94"><div class="ttname"><a href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fdabc7f0c7ed0b6864e902f4b70f2c7bc94">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE</div><div class="ttdoc">The object local memory is modified. The union is a hwloc_topology_diff_obj_attr_u::hwloc_topology_di...</div><div class="ttdef"><b>Definition</b> diff.h:67</div></div>
+<div class="ttc" id="aa00217_html_ggada4c1273ce020afaf02b649496f7edf5a821a160512d67ea0dd05dab873d2fc54"><div class="ttname"><a href="a00217.html#ggada4c1273ce020afaf02b649496f7edf5a821a160512d67ea0dd05dab873d2fc54">HWLOC_TOPOLOGY_DIFF_APPLY_REVERSE</a></div><div class="ttdeci">@ HWLOC_TOPOLOGY_DIFF_APPLY_REVERSE</div><div class="ttdoc">Apply topology diff in reverse direction.</div><div class="ttdef"><b>Definition</b> diff.h:202</div></div>
+<div class="ttc" id="aa00329_html"><div class="ttname"><a href="a00329.html">hwloc_topology_diff_obj_attr_u</a></div><div class="ttdoc">One object attribute difference.</div><div class="ttdef"><b>Definition</b> diff.h:83</div></div>
+<div class="ttc" id="aa00329_html_a42fa15c37f1f59ef638066c4c62c3154"><div class="ttname"><a href="a00329.html#a42fa15c37f1f59ef638066c4c62c3154">hwloc_topology_diff_obj_attr_u::string</a></div><div class="ttdeci">struct hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s string</div></div>
+<div class="ttc" id="aa00329_html_a4608ade88460f5f208887775e5a69a0a"><div class="ttname"><a href="a00329.html#a4608ade88460f5f208887775e5a69a0a">hwloc_topology_diff_obj_attr_u::uint64</a></div><div class="ttdeci">struct hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s uint64</div></div>
+<div class="ttc" id="aa00333_html"><div class="ttname"><a href="a00333.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s</a></div><div class="ttdef"><b>Definition</b> diff.h:84</div></div>
+<div class="ttc" id="aa00333_html_a43f8133b7c30129b002c2d295e6580fc"><div class="ttname"><a href="a00333.html#a43f8133b7c30129b002c2d295e6580fc">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s::type</a></div><div class="ttdeci">hwloc_topology_diff_obj_attr_type_t type</div><div class="ttdef"><b>Definition</b> diff.h:86</div></div>
+<div class="ttc" id="aa00337_html"><div class="ttname"><a href="a00337.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a></div><div class="ttdoc">Integer attribute modification with an optional index.</div><div class="ttdef"><b>Definition</b> diff.h:90</div></div>
+<div class="ttc" id="aa00337_html_a44c0894dce563335d347fde6595c49c9"><div class="ttname"><a href="a00337.html#a44c0894dce563335d347fde6595c49c9">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::oldvalue</a></div><div class="ttdeci">hwloc_uint64_t oldvalue</div><div class="ttdef"><b>Definition</b> diff.h:94</div></div>
+<div class="ttc" id="aa00337_html_adb772c3f1761ecadf496c80ae14afce3"><div class="ttname"><a href="a00337.html#adb772c3f1761ecadf496c80ae14afce3">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::index</a></div><div class="ttdeci">hwloc_uint64_t index</div><div class="ttdef"><b>Definition</b> diff.h:93</div></div>
+<div class="ttc" id="aa00337_html_ae63aa59ad65aa783b730a4f213304eb4"><div class="ttname"><a href="a00337.html#ae63aa59ad65aa783b730a4f213304eb4">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::newvalue</a></div><div class="ttdeci">hwloc_uint64_t newvalue</div><div class="ttdef"><b>Definition</b> diff.h:95</div></div>
+<div class="ttc" id="aa00337_html_afe262b9aa558fe7bfecbd37a7a129197"><div class="ttname"><a href="a00337.html#afe262b9aa558fe7bfecbd37a7a129197">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::type</a></div><div class="ttdeci">hwloc_topology_diff_obj_attr_type_t type</div><div class="ttdef"><b>Definition</b> diff.h:92</div></div>
+<div class="ttc" id="aa00341_html"><div class="ttname"><a href="a00341.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a></div><div class="ttdoc">String attribute modification with an optional name.</div><div class="ttdef"><b>Definition</b> diff.h:99</div></div>
+<div class="ttc" id="aa00341_html_a33cc281d4417129064295a6ae7b79818"><div class="ttname"><a href="a00341.html#a33cc281d4417129064295a6ae7b79818">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::oldvalue</a></div><div class="ttdeci">char * oldvalue</div><div class="ttdef"><b>Definition</b> diff.h:103</div></div>
+<div class="ttc" id="aa00341_html_a75f37f4add21cece50fee2701c3b77db"><div class="ttname"><a href="a00341.html#a75f37f4add21cece50fee2701c3b77db">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::newvalue</a></div><div class="ttdeci">char * newvalue</div><div class="ttdef"><b>Definition</b> diff.h:104</div></div>
+<div class="ttc" id="aa00341_html_a784ab5827c1bf531b86d1f02f199d04d"><div class="ttname"><a href="a00341.html#a784ab5827c1bf531b86d1f02f199d04d">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::type</a></div><div class="ttdeci">hwloc_topology_diff_obj_attr_type_t type</div><div class="ttdef"><b>Definition</b> diff.h:101</div></div>
+<div class="ttc" id="aa00341_html_a7ef48c66ccddf34d90edb4e4314b41c6"><div class="ttname"><a href="a00341.html#a7ef48c66ccddf34d90edb4e4314b41c6">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::name</a></div><div class="ttdeci">char * name</div><div class="ttdef"><b>Definition</b> diff.h:102</div></div>
+<div class="ttc" id="aa00345_html"><div class="ttname"><a href="a00345.html">hwloc_topology_diff_u</a></div><div class="ttdoc">One element of a difference list between two topologies.</div><div class="ttdef"><b>Definition</b> diff.h:129</div></div>
+<div class="ttc" id="aa00349_html"><div class="ttname"><a href="a00349.html">hwloc_topology_diff_u::hwloc_topology_diff_generic_s</a></div><div class="ttdef"><b>Definition</b> diff.h:130</div></div>
+<div class="ttc" id="aa00349_html_a373005489fcddeba6319163e60263ae8"><div class="ttname"><a href="a00349.html#a373005489fcddeba6319163e60263ae8">hwloc_topology_diff_u::hwloc_topology_diff_generic_s::type</a></div><div class="ttdeci">hwloc_topology_diff_type_t type</div><div class="ttdef"><b>Definition</b> diff.h:132</div></div>
+<div class="ttc" id="aa00349_html_a720aa94eb73cddfd8d6bf9fcbbfc035e"><div class="ttname"><a href="a00349.html#a720aa94eb73cddfd8d6bf9fcbbfc035e">hwloc_topology_diff_u::hwloc_topology_diff_generic_s::next</a></div><div class="ttdeci">union hwloc_topology_diff_u * next</div><div class="ttdef"><b>Definition</b> diff.h:133</div></div>
+<div class="ttc" id="aa00353_html"><div class="ttname"><a href="a00353.html">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a></div><div class="ttdef"><b>Definition</b> diff.h:137</div></div>
+<div class="ttc" id="aa00353_html_a70a118ad288bd98f18c8ce6dc52e2d10"><div class="ttname"><a href="a00353.html#a70a118ad288bd98f18c8ce6dc52e2d10">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::type</a></div><div class="ttdeci">hwloc_topology_diff_type_t type</div><div class="ttdef"><b>Definition</b> diff.h:138</div></div>
+<div class="ttc" id="aa00353_html_a82c1d4bab80b9e0bf301a9d8291893e0"><div class="ttname"><a href="a00353.html#a82c1d4bab80b9e0bf301a9d8291893e0">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::obj_depth</a></div><div class="ttdeci">int obj_depth</div><div class="ttdef"><b>Definition</b> diff.h:141</div></div>
+<div class="ttc" id="aa00353_html_a91f0645f9062e892652357cd141c8ebb"><div class="ttname"><a href="a00353.html#a91f0645f9062e892652357cd141c8ebb">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::diff</a></div><div class="ttdeci">union hwloc_topology_diff_obj_attr_u diff</div><div class="ttdef"><b>Definition</b> diff.h:143</div></div>
+<div class="ttc" id="aa00353_html_acb9170a8eb3392656d70f7f3ef3e3eed"><div class="ttname"><a href="a00353.html#acb9170a8eb3392656d70f7f3ef3e3eed">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::next</a></div><div class="ttdeci">union hwloc_topology_diff_u * next</div><div class="ttdef"><b>Definition</b> diff.h:139</div></div>
+<div class="ttc" id="aa00353_html_adb9f4d414470b6670cde8d90759a6c1c"><div class="ttname"><a href="a00353.html#adb9f4d414470b6670cde8d90759a6c1c">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::obj_index</a></div><div class="ttdeci">unsigned obj_index</div><div class="ttdef"><b>Definition</b> diff.h:142</div></div>
+<div class="ttc" id="aa00357_html"><div class="ttname"><a href="a00357.html">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a></div><div class="ttdef"><b>Definition</b> diff.h:147</div></div>
+<div class="ttc" id="aa00357_html_a375afbaa043b109be689a7d9a3c7d153"><div class="ttname"><a href="a00357.html#a375afbaa043b109be689a7d9a3c7d153">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::next</a></div><div class="ttdeci">union hwloc_topology_diff_u * next</div><div class="ttdef"><b>Definition</b> diff.h:149</div></div>
+<div class="ttc" id="aa00357_html_a6dc6b3c4adb10db74d993e37afaa0580"><div class="ttname"><a href="a00357.html#a6dc6b3c4adb10db74d993e37afaa0580">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::obj_index</a></div><div class="ttdeci">unsigned obj_index</div><div class="ttdef"><b>Definition</b> diff.h:152</div></div>
+<div class="ttc" id="aa00357_html_a92084295a4d6faf17a95a7eea526ddbd"><div class="ttname"><a href="a00357.html#a92084295a4d6faf17a95a7eea526ddbd">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::type</a></div><div class="ttdeci">hwloc_topology_diff_type_t type</div><div class="ttdef"><b>Definition</b> diff.h:148</div></div>
+<div class="ttc" id="aa00357_html_a94c6498caeaafbb79927395d918d6cb3"><div class="ttname"><a href="a00357.html#a94c6498caeaafbb79927395d918d6cb3">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::obj_depth</a></div><div class="ttdeci">int obj_depth</div><div class="ttdef"><b>Definition</b> diff.h:151</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00164_source.html 2.11.0-1/doc/doxygen-doc/html/a00164_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00164_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00164_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,100 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): shmem.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">shmem.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2013-2023 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span> </div>
+<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="preprocessor">#ifndef HWLOC_SHMEM_H</span></div>
+<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="preprocessor">#define HWLOC_SHMEM_H</span></div>
+<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
+<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span> </div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#elif 0</span></div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>}</div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
+<div class="line"><a id="l00055" name="l00055"></a><span class="lineno"><a class="line" href="a00218.html#ga772ab52750cdd0eec85128df24888001">   55</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00218.html#ga772ab52750cdd0eec85128df24888001">hwloc_shmem_topology_get_length</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>                                                   <span class="keywordtype">size_t</span> *lengthp,</div>
+<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>                                                   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno"><a class="line" href="a00218.html#ga61b20e346fc76f76420e3a88cc80a671">   85</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00218.html#ga61b20e346fc76f76420e3a88cc80a671">hwloc_shmem_topology_write</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>                                              <span class="keywordtype">int</span> fd, hwloc_uint64_t fileoffset,</div>
+<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>                                              <span class="keywordtype">void</span> *mmap_address, <span class="keywordtype">size_t</span> length,</div>
+<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>                                              <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span> </div>
+<div class="line"><a id="l00130" name="l00130"></a><span class="lineno"><a class="line" href="a00218.html#ga21545bd0f09d9b554c8e60a630e0e629">  130</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00218.html#ga21545bd0f09d9b554c8e60a630e0e629">hwloc_shmem_topology_adopt</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> *topologyp,</div>
+<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>                                              <span class="keywordtype">int</span> fd, hwloc_uint64_t fileoffset,</div>
+<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>                                              <span class="keywordtype">void</span> *mmap_address, <span class="keywordtype">size_t</span> length,</div>
+<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>                                              <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span><span class="preprocessor">#ifdef __cplusplus</span></div>
+<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>} <span class="comment">/* extern &quot;C&quot; */</span></div>
+<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span> </div>
+<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span> </div>
+<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_SHMEM_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00218_html_ga21545bd0f09d9b554c8e60a630e0e629"><div class="ttname"><a href="a00218.html#ga21545bd0f09d9b554c8e60a630e0e629">hwloc_shmem_topology_adopt</a></div><div class="ttdeci">int hwloc_shmem_topology_adopt(hwloc_topology_t *topologyp, int fd, hwloc_uint64_t fileoffset, void *mmap_address, size_t length, unsigned long flags)</div><div class="ttdoc">Adopt a shared memory topology stored in a file.</div></div>
+<div class="ttc" id="aa00218_html_ga61b20e346fc76f76420e3a88cc80a671"><div class="ttname"><a href="a00218.html#ga61b20e346fc76f76420e3a88cc80a671">hwloc_shmem_topology_write</a></div><div class="ttdeci">int hwloc_shmem_topology_write(hwloc_topology_t topology, int fd, hwloc_uint64_t fileoffset, void *mmap_address, size_t length, unsigned long flags)</div><div class="ttdoc">Duplicate a topology to a shared memory file.</div></div>
+<div class="ttc" id="aa00218_html_ga772ab52750cdd0eec85128df24888001"><div class="ttname"><a href="a00218.html#ga772ab52750cdd0eec85128df24888001">hwloc_shmem_topology_get_length</a></div><div class="ttdeci">int hwloc_shmem_topology_get_length(hwloc_topology_t topology, size_t *lengthp, unsigned long flags)</div><div class="ttdoc">Get the required shared memory length for storing a topology.</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00167_source.html 2.11.0-1/doc/doxygen-doc/html/a00167_source.html
--- 2.10.0-1/doc/doxygen-doc/html/a00167_source.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00167_source.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,423 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): plugins.h Source File</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(document).ready(function() { init_codefold(0); });
+/* @license-end */
+</script>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">plugins.h</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/*</span></div>
+<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright © 2013-2022 Inria.  All rights reserved.</span></div>
+<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * Copyright © 2016 Cisco Systems, Inc.  All rights reserved.</span></div>
+<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> */</span></div>
+<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span> </div>
+<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="preprocessor">#ifndef HWLOC_PLUGINS_H</span></div>
+<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="preprocessor">#define HWLOC_PLUGINS_H</span></div>
+<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span> </div>
+<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="keyword">struct </span><a class="code hl_struct" href="a00369.html">hwloc_backend</a>;</div>
+<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
+<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
+<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#ifdef HWLOC_INSIDE_PLUGIN</span></div>
+<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="comment">/* needed for hwloc_plugin_check_namespace() */</span></div>
+<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#ifdef HWLOC_HAVE_LTDL</span></div>
+<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &lt;ltdl.h&gt;</span></div>
+<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &lt;dlfcn.h&gt;</span></div>
+<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
+<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
+<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
+<div class="foldopen" id="foldopen00041" data-start="{" data-end="};">
+<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="a00361.html">   41</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00361.html">hwloc_disc_component</a> {</div>
+<div class="line"><a id="l00045" name="l00045"></a><span class="lineno"><a class="line" href="a00361.html#a4064c3b5d9213027e87caebef380a840">   45</a></span>  <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code hl_variable" href="a00361.html#a4064c3b5d9213027e87caebef380a840">name</a>;</div>
+<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span> </div>
+<div class="line"><a id="l00050" name="l00050"></a><span class="lineno"><a class="line" href="a00361.html#a61ad3151efa02e3dbad5d919758f9c90">   50</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00361.html#a61ad3151efa02e3dbad5d919758f9c90">phases</a>;</div>
+<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span> </div>
+<div class="line"><a id="l00060" name="l00060"></a><span class="lineno"><a class="line" href="a00361.html#acbb9957914dbf7b8f504215aa0c8d3fe">   60</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00361.html#acbb9957914dbf7b8f504215aa0c8d3fe">excluded_phases</a>;</div>
+<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span> </div>
+<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00369.html">hwloc_backend</a> * (*instantiate)(<span class="keyword">struct </span>hwloc_topology *topology, <span class="keyword">struct </span><a class="code hl_struct" href="a00361.html">hwloc_disc_component</a> *component, <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00361.html#acbb9957914dbf7b8f504215aa0c8d3fe">excluded_phases</a>, <span class="keyword">const</span> <span class="keywordtype">void</span> *data1, <span class="keyword">const</span> <span class="keywordtype">void</span> *data2, <span class="keyword">const</span> <span class="keywordtype">void</span> *data3);</div>
+<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span> </div>
+<div class="line"><a id="l00079" name="l00079"></a><span class="lineno"><a class="line" href="a00361.html#ae86d283c272c5ae24073a235efbf6b59">   79</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00361.html#ae86d283c272c5ae24073a235efbf6b59">priority</a>;</div>
+<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span> </div>
+<div class="line"><a id="l00084" name="l00084"></a><span class="lineno"><a class="line" href="a00361.html#ace80cafe2b1732b047b3fc3da47e6517">   84</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00361.html#ace80cafe2b1732b047b3fc3da47e6517">enabled_by_default</a>;</div>
+<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span> </div>
+<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00361.html">hwloc_disc_component</a> * next;</div>
+<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>};</div>
+</div>
+<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span> </div>
+<div class="foldopen" id="foldopen00106" data-start="{" data-end="};">
+<div class="line"><a id="l00106" name="l00106"></a><span class="lineno"><a class="line" href="a00220.html#ga8c314121c2fc478161bcce758688b9a1">  106</a></span><span class="keyword">typedef</span> <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00220.html#ga8c314121c2fc478161bcce758688b9a1">hwloc_disc_phase_e</a> {</div>
+<div class="line"><a id="l00111" name="l00111"></a><span class="lineno"><a class="line" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1ab41c626c79e9ccb1e7d41e7076972283">  111</a></span>  <a class="code hl_enumvalue" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1ab41c626c79e9ccb1e7d41e7076972283">HWLOC_DISC_PHASE_GLOBAL</a> = (1U&lt;&lt;0),</div>
+<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span> </div>
+<div class="line"><a id="l00115" name="l00115"></a><span class="lineno"><a class="line" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a6360474df197027761a69bd5fc620250">  115</a></span>  <a class="code hl_enumvalue" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a6360474df197027761a69bd5fc620250">HWLOC_DISC_PHASE_CPU</a> = (1U&lt;&lt;1),</div>
+<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span> </div>
+<div class="line"><a id="l00119" name="l00119"></a><span class="lineno"><a class="line" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1ac4264a243844c5fbbff495cdb1b4d51d">  119</a></span>  <a class="code hl_enumvalue" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1ac4264a243844c5fbbff495cdb1b4d51d">HWLOC_DISC_PHASE_MEMORY</a> = (1U&lt;&lt;2),</div>
+<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span> </div>
+<div class="line"><a id="l00123" name="l00123"></a><span class="lineno"><a class="line" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a677c52064dd987af4988346319b3675a">  123</a></span>  <a class="code hl_enumvalue" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a677c52064dd987af4988346319b3675a">HWLOC_DISC_PHASE_PCI</a> = (1U&lt;&lt;3),</div>
+<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span> </div>
+<div class="line"><a id="l00127" name="l00127"></a><span class="lineno"><a class="line" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1aa8e10626cba9af72f5605a1acbdc0015">  127</a></span>  <a class="code hl_enumvalue" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1aa8e10626cba9af72f5605a1acbdc0015">HWLOC_DISC_PHASE_IO</a> = (1U&lt;&lt;4),</div>
+<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span> </div>
+<div class="line"><a id="l00131" name="l00131"></a><span class="lineno"><a class="line" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a8a7cde9bff0ab0d085b102a3e934939b">  131</a></span>  <a class="code hl_enumvalue" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a8a7cde9bff0ab0d085b102a3e934939b">HWLOC_DISC_PHASE_MISC</a> = (1U&lt;&lt;5),</div>
+<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span> </div>
+<div class="line"><a id="l00135" name="l00135"></a><span class="lineno"><a class="line" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a68ca5c7ad75a6d9e5355689411621773">  135</a></span>  <a class="code hl_enumvalue" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a68ca5c7ad75a6d9e5355689411621773">HWLOC_DISC_PHASE_ANNOTATE</a> = (1U&lt;&lt;6),</div>
+<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span> </div>
+<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>  <a class="code hl_enumvalue" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1ada3ed3f00e74909353d6ea4a96cde5ad">HWLOC_DISC_PHASE_TWEAK</a> = (1U&lt;&lt;7)</div>
+<div class="line"><a id="l00143" name="l00143"></a><span class="lineno"><a class="line" href="a00220.html#ga600bba1a62022d5f516800649b1edb61">  143</a></span>} <a class="code hl_typedef" href="a00220.html#ga600bba1a62022d5f516800649b1edb61">hwloc_disc_phase_t</a>;</div>
+</div>
+<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span> </div>
+<div class="foldopen" id="foldopen00146" data-start="{" data-end="};">
+<div class="line"><a id="l00146" name="l00146"></a><span class="lineno"><a class="line" href="a00220.html#gaae1b38cf9b12e489884ce2a07275964b">  146</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="a00220.html#gaae1b38cf9b12e489884ce2a07275964b">hwloc_disc_status_flag_e</a> {</div>
+<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>  <a class="code hl_enumvalue" href="a00220.html#ggaae1b38cf9b12e489884ce2a07275964ba205d644d54a0840bd9165fce7d19e6b1">HWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES</a> = (1UL&lt;&lt;1)</div>
+<div class="line"><a id="l00149" name="l00149"></a><span class="lineno"><a class="line" href="a00220.html#ggaae1b38cf9b12e489884ce2a07275964ba205d644d54a0840bd9165fce7d19e6b1">  149</a></span>};</div>
+</div>
+<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span> </div>
+<div class="foldopen" id="foldopen00156" data-start="{" data-end="};">
+<div class="line"><a id="l00156" name="l00156"></a><span class="lineno"><a class="line" href="a00365.html">  156</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00365.html">hwloc_disc_status</a> {</div>
+<div class="line"><a id="l00160" name="l00160"></a><span class="lineno"><a class="line" href="a00365.html#abaf7c8c082d43e133171f0723dbf824b">  160</a></span>  <a class="code hl_typedef" href="a00220.html#ga600bba1a62022d5f516800649b1edb61">hwloc_disc_phase_t</a> <a class="code hl_variable" href="a00365.html#abaf7c8c082d43e133171f0723dbf824b">phase</a>;</div>
+<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span> </div>
+<div class="line"><a id="l00165" name="l00165"></a><span class="lineno"><a class="line" href="a00365.html#a0f95fa42d46a6e7cf8dee8af12afee3a">  165</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00365.html#a0f95fa42d46a6e7cf8dee8af12afee3a">excluded_phases</a>;</div>
+<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span> </div>
+<div class="line"><a id="l00168" name="l00168"></a><span class="lineno"><a class="line" href="a00365.html#ad8b123cecb945a9182eb824ccf8ef9d7">  168</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code hl_variable" href="a00365.html#ad8b123cecb945a9182eb824ccf8ef9d7">flags</a>;</div>
+<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>};</div>
+</div>
+<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span> </div>
+<div class="foldopen" id="foldopen00189" data-start="{" data-end="};">
+<div class="line"><a id="l00189" name="l00189"></a><span class="lineno"><a class="line" href="a00369.html">  189</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00369.html">hwloc_backend</a> {</div>
+<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00361.html">hwloc_disc_component</a> * component;</div>
+<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>  <span class="keyword">struct </span>hwloc_topology * topology;</div>
+<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>  <span class="keywordtype">int</span> envvar_forced;</div>
+<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>  <span class="keyword">struct </span><a class="code hl_struct" href="a00369.html">hwloc_backend</a> * next;</div>
+<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span> </div>
+<div class="line"><a id="l00202" name="l00202"></a><span class="lineno"><a class="line" href="a00369.html#aeca769840a6ff03e96462a9533adbccd">  202</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00369.html#aeca769840a6ff03e96462a9533adbccd">phases</a>;</div>
+<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span> </div>
+<div class="line"><a id="l00205" name="l00205"></a><span class="lineno"><a class="line" href="a00369.html#aaa8eafe495aadd81c2e3c4ec527c10ba">  205</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code hl_variable" href="a00369.html#aaa8eafe495aadd81c2e3c4ec527c10ba">flags</a>;</div>
+<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span> </div>
+<div class="line"><a id="l00213" name="l00213"></a><span class="lineno"><a class="line" href="a00369.html#ab8806f6db077f1bb2e9d63ec99223f7a">  213</a></span>  <span class="keywordtype">int</span> <a class="code hl_variable" href="a00369.html#ab8806f6db077f1bb2e9d63ec99223f7a">is_thissystem</a>;</div>
+<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span> </div>
+<div class="line"><a id="l00216" name="l00216"></a><span class="lineno"><a class="line" href="a00369.html#a2ea5bd36b7f06efdb65b98b32af16c68">  216</a></span>  <span class="keywordtype">void</span> * <a class="code hl_variable" href="a00369.html#a2ea5bd36b7f06efdb65b98b32af16c68">private_data</a>;</div>
+<div class="line"><a id="l00220" name="l00220"></a><span class="lineno"><a class="line" href="a00369.html#a36c4fa86350525b46340c67b802c69c7">  220</a></span>  void (*<a class="code hl_variable" href="a00369.html#a36c4fa86350525b46340c67b802c69c7">disable</a>)(<span class="keyword">struct </span><a class="code hl_struct" href="a00369.html">hwloc_backend</a> *backend);</div>
+<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span> </div>
+<div class="line"><a id="l00227" name="l00227"></a><span class="lineno"><a class="line" href="a00369.html#accff2cd8404be43c3b44cec05e6f609b">  227</a></span>  int (*<a class="code hl_variable" href="a00369.html#accff2cd8404be43c3b44cec05e6f609b">discover</a>)(<span class="keyword">struct </span><a class="code hl_struct" href="a00369.html">hwloc_backend</a> *backend, <span class="keyword">struct </span><a class="code hl_struct" href="a00365.html">hwloc_disc_status</a> *status);</div>
+<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span> </div>
+<div class="line"><a id="l00233" name="l00233"></a><span class="lineno"><a class="line" href="a00369.html#aaac253491264c20930f44817270bc502">  233</a></span>  int (*<a class="code hl_variable" href="a00369.html#aaac253491264c20930f44817270bc502">get_pci_busid_cpuset</a>)(<span class="keyword">struct </span><a class="code hl_struct" href="a00369.html">hwloc_backend</a> *backend, <span class="keyword">struct </span>hwloc_pcidev_attr_s *busid, <a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> cpuset);</div>
+<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>};</div>
+</div>
+<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span> </div>
+<div class="line"><a id="l00239" name="l00239"></a><span class="lineno"><a class="line" href="a00220.html#ga6118a1009aa390c13255a330ccf253cf">  239</a></span>HWLOC_DECLSPEC <span class="keyword">struct </span><a class="code hl_struct" href="a00369.html">hwloc_backend</a> * <a class="code hl_function" href="a00220.html#ga6118a1009aa390c13255a330ccf253cf">hwloc_backend_alloc</a>(<span class="keyword">struct</span> hwloc_topology *topology, <span class="keyword">struct</span> <a class="code hl_struct" href="a00361.html">hwloc_disc_component</a> *component);</div>
+<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span> </div>
+<div class="line"><a id="l00242" name="l00242"></a><span class="lineno"><a class="line" href="a00220.html#ga4715779d7191833e9b1a7490989a7497">  242</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00220.html#ga4715779d7191833e9b1a7490989a7497">hwloc_backend_enable</a>(<span class="keyword">struct</span> <a class="code hl_struct" href="a00369.html">hwloc_backend</a> *backend);</div>
+<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span> </div>
+<div class="foldopen" id="foldopen00257" data-start="{" data-end="};">
+<div class="line"><a id="l00257" name="l00257"></a><span class="lineno"><a class="line" href="a00221.html#ga397a1bf7d21dd073320ad0045340f463">  257</a></span><span class="keyword">typedef</span> <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00221.html#ga397a1bf7d21dd073320ad0045340f463">hwloc_component_type_e</a> {</div>
+<div class="line"><a id="l00259" name="l00259"></a><span class="lineno"><a class="line" href="a00221.html#gga397a1bf7d21dd073320ad0045340f463a5d6e561f467fe9795a29e7368b613900">  259</a></span>  <a class="code hl_enumvalue" href="a00221.html#gga397a1bf7d21dd073320ad0045340f463a5d6e561f467fe9795a29e7368b613900">HWLOC_COMPONENT_TYPE_DISC</a>,</div>
+<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span> </div>
+<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span>  <a class="code hl_enumvalue" href="a00221.html#gga397a1bf7d21dd073320ad0045340f463adea00cd839c2141c032e1569fd5592bd">HWLOC_COMPONENT_TYPE_XML</a></div>
+<div class="line"><a id="l00263" name="l00263"></a><span class="lineno"><a class="line" href="a00221.html#ga31a5a455f4e666b936f0a9e8fb9a0f47">  263</a></span>} <a class="code hl_typedef" href="a00221.html#ga31a5a455f4e666b936f0a9e8fb9a0f47">hwloc_component_type_t</a>;</div>
+</div>
+<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span> </div>
+<div class="foldopen" id="foldopen00270" data-start="{" data-end="};">
+<div class="line"><a id="l00270" name="l00270"></a><span class="lineno"><a class="line" href="a00373.html">  270</a></span><span class="keyword">struct </span><a class="code hl_struct" href="a00373.html">hwloc_component</a> {</div>
+<div class="line"><a id="l00272" name="l00272"></a><span class="lineno"><a class="line" href="a00373.html#a3250bd6fc9713946991d805e48091b2e">  272</a></span>  <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="a00373.html#a3250bd6fc9713946991d805e48091b2e">abi</a>;</div>
+<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span> </div>
+<div class="line"><a id="l00291" name="l00291"></a><span class="lineno"><a class="line" href="a00373.html#aea613546886d9b8221cadba920fe3ebc">  291</a></span>  int (*<a class="code hl_variable" href="a00373.html#aea613546886d9b8221cadba920fe3ebc">init</a>)(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code hl_variable" href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">flags</a>);</div>
+<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span> </div>
+<div class="line"><a id="l00304" name="l00304"></a><span class="lineno"><a class="line" href="a00373.html#a4612015451a1c706e8ba19114cb8baae">  304</a></span>  void (*<a class="code hl_variable" href="a00373.html#a4612015451a1c706e8ba19114cb8baae">finalize</a>)(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code hl_variable" href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">flags</a>);</div>
+<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span> </div>
+<div class="line"><a id="l00307" name="l00307"></a><span class="lineno"><a class="line" href="a00373.html#a789208ada7e17492cfd3a5a88a6bb0ee">  307</a></span>  <a class="code hl_typedef" href="a00221.html#ga31a5a455f4e666b936f0a9e8fb9a0f47">hwloc_component_type_t</a> <a class="code hl_variable" href="a00373.html#a789208ada7e17492cfd3a5a88a6bb0ee">type</a>;</div>
+<div class="line"><a id="l00308" name="l00308"></a><span class="lineno">  308</span> </div>
+<div class="line"><a id="l00310" name="l00310"></a><span class="lineno"><a class="line" href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">  310</a></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code hl_variable" href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">flags</a>;</div>
+<div class="line"><a id="l00311" name="l00311"></a><span class="lineno">  311</span> </div>
+<div class="line"><a id="l00313" name="l00313"></a><span class="lineno"><a class="line" href="a00373.html#a4b8cffd1d943c29fdc102b841b8598d4">  313</a></span>  <span class="keywordtype">void</span> * <a class="code hl_variable" href="a00373.html#a4b8cffd1d943c29fdc102b841b8598d4">data</a>;</div>
+<div class="line"><a id="l00314" name="l00314"></a><span class="lineno">  314</span>};</div>
+</div>
+<div class="line"><a id="l00315" name="l00315"></a><span class="lineno">  315</span> </div>
+<div class="line"><a id="l00345" name="l00345"></a><span class="lineno"><a class="line" href="a00222.html#gab527c1e0f243f057d31a724794ad9f88">  345</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00222.html#gab527c1e0f243f057d31a724794ad9f88">hwloc_hide_errors</a>(<span class="keywordtype">void</span>);</div>
+<div class="line"><a id="l00346" name="l00346"></a><span class="lineno">  346</span> </div>
+<div class="line"><a id="l00347" name="l00347"></a><span class="lineno"><a class="line" href="a00222.html#gafce07a2a959190a6c7126b321bef202f">  347</a></span><span class="preprocessor">#define HWLOC_SHOW_CRITICAL_ERRORS() (hwloc_hide_errors() &lt; 2)</span></div>
+<div class="line"><a id="l00348" name="l00348"></a><span class="lineno"><a class="line" href="a00222.html#ga3e48b6ac00ed6a40aea975e23eddcdbb">  348</a></span><span class="preprocessor">#define HWLOC_SHOW_ALL_ERRORS() (hwloc_hide_errors() == 0)</span></div>
+<div class="line"><a id="l00349" name="l00349"></a><span class="lineno">  349</span> </div>
+<div class="line"><a id="l00378" name="l00378"></a><span class="lineno">  378</span>HWLOC_DECLSPEC <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a></div>
+<div class="line"><a id="l00379" name="l00379"></a><span class="lineno"><a class="line" href="a00222.html#ga1e105cfe3c8e77f34cc6df3841deebbc">  379</a></span><a class="code hl_function" href="a00222.html#ga1e105cfe3c8e77f34cc6df3841deebbc">hwloc__insert_object_by_cpuset</a>(<span class="keyword">struct</span> hwloc_topology *topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> root,</div>
+<div class="line"><a id="l00380" name="l00380"></a><span class="lineno">  380</span>                               <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj, <span class="keyword">const</span> <span class="keywordtype">char</span> *reason);</div>
+<div class="line"><a id="l00381" name="l00381"></a><span class="lineno">  381</span> </div>
+<div class="line"><a id="l00398" name="l00398"></a><span class="lineno"><a class="line" href="a00222.html#ga0ef97debde503b56367689b07bb3e901">  398</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> <a class="code hl_function" href="a00222.html#ga0ef97debde503b56367689b07bb3e901">hwloc_insert_object_by_parent</a>(<span class="keyword">struct</span> hwloc_topology *topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> parent, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj);</div>
+<div class="line"><a id="l00399" name="l00399"></a><span class="lineno">  399</span> </div>
+<div class="line"><a id="l00404" name="l00404"></a><span class="lineno"><a class="line" href="a00222.html#ga0b5c75b2dc37cea2e8a29c4812baf4b3">  404</a></span>HWLOC_DECLSPEC <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> <a class="code hl_function" href="a00222.html#ga0b5c75b2dc37cea2e8a29c4812baf4b3">hwloc_alloc_setup_object</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, <span class="keywordtype">unsigned</span> os_index);</div>
+<div class="line"><a id="l00405" name="l00405"></a><span class="lineno">  405</span> </div>
+<div class="line"><a id="l00414" name="l00414"></a><span class="lineno"><a class="line" href="a00222.html#ga754b61041ceee9685534a2c5d3cd0156">  414</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00222.html#ga754b61041ceee9685534a2c5d3cd0156">hwloc_obj_add_children_sets</a>(<a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj);</div>
+<div class="line"><a id="l00415" name="l00415"></a><span class="lineno">  415</span> </div>
+<div class="line"><a id="l00423" name="l00423"></a><span class="lineno"><a class="line" href="a00222.html#ga120d8bd74922e1030b621409a6b0be61">  423</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00222.html#ga120d8bd74922e1030b621409a6b0be61">hwloc_topology_reconnect</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags __hwloc_attribute_unused);</div>
+<div class="line"><a id="l00424" name="l00424"></a><span class="lineno">  424</span> </div>
+<div class="line"><a id="l00446" name="l00446"></a><span class="lineno">  446</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00447" data-start="{" data-end="}">
+<div class="line"><a id="l00447" name="l00447"></a><span class="lineno"><a class="line" href="a00222.html#gac2eaed287bb215cf0bd33014e9e1d374">  447</a></span><a class="code hl_function" href="a00222.html#gac2eaed287bb215cf0bd33014e9e1d374">hwloc_plugin_check_namespace</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *pluginname __hwloc_attribute_unused, <span class="keyword">const</span> <span class="keywordtype">char</span> *symbol __hwloc_attribute_unused)</div>
+<div class="line"><a id="l00448" name="l00448"></a><span class="lineno">  448</span>{</div>
+<div class="line"><a id="l00449" name="l00449"></a><span class="lineno">  449</span><span class="preprocessor">#ifdef HWLOC_INSIDE_PLUGIN</span></div>
+<div class="line"><a id="l00450" name="l00450"></a><span class="lineno">  450</span>  <span class="keywordtype">void</span> *sym;</div>
+<div class="line"><a id="l00451" name="l00451"></a><span class="lineno">  451</span><span class="preprocessor">#ifdef HWLOC_HAVE_LTDL</span></div>
+<div class="line"><a id="l00452" name="l00452"></a><span class="lineno">  452</span>  lt_dlhandle handle = lt_dlopen(NULL);</div>
+<div class="line"><a id="l00453" name="l00453"></a><span class="lineno">  453</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00454" name="l00454"></a><span class="lineno">  454</span>  <span class="keywordtype">void</span> *handle = dlopen(NULL, RTLD_NOW|RTLD_LOCAL);</div>
+<div class="line"><a id="l00455" name="l00455"></a><span class="lineno">  455</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00456" name="l00456"></a><span class="lineno">  456</span>  <span class="keywordflow">if</span> (!handle)</div>
+<div class="line"><a id="l00457" name="l00457"></a><span class="lineno">  457</span>    <span class="comment">/* cannot check, assume things will work */</span></div>
+<div class="line"><a id="l00458" name="l00458"></a><span class="lineno">  458</span>    <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00459" name="l00459"></a><span class="lineno">  459</span><span class="preprocessor">#ifdef HWLOC_HAVE_LTDL</span></div>
+<div class="line"><a id="l00460" name="l00460"></a><span class="lineno">  460</span>  sym = lt_dlsym(handle, symbol);</div>
+<div class="line"><a id="l00461" name="l00461"></a><span class="lineno">  461</span>  lt_dlclose(handle);</div>
+<div class="line"><a id="l00462" name="l00462"></a><span class="lineno">  462</span><span class="preprocessor">#else</span></div>
+<div class="line"><a id="l00463" name="l00463"></a><span class="lineno">  463</span>  sym = dlsym(handle, symbol);</div>
+<div class="line"><a id="l00464" name="l00464"></a><span class="lineno">  464</span>  dlclose(handle);</div>
+<div class="line"><a id="l00465" name="l00465"></a><span class="lineno">  465</span><span class="preprocessor">#endif</span></div>
+<div class="line"><a id="l00466" name="l00466"></a><span class="lineno">  466</span>  <span class="keywordflow">if</span> (!sym) {</div>
+<div class="line"><a id="l00467" name="l00467"></a><span class="lineno">  467</span>    <span class="keyword">static</span> <span class="keywordtype">int</span> verboseenv_checked = 0;</div>
+<div class="line"><a id="l00468" name="l00468"></a><span class="lineno">  468</span>    <span class="keyword">static</span> <span class="keywordtype">int</span> verboseenv_value = 0;</div>
+<div class="line"><a id="l00469" name="l00469"></a><span class="lineno">  469</span>    <span class="keywordflow">if</span> (!verboseenv_checked) {</div>
+<div class="line"><a id="l00470" name="l00470"></a><span class="lineno">  470</span>      <span class="keyword">const</span> <span class="keywordtype">char</span> *verboseenv = getenv(<span class="stringliteral">&quot;HWLOC_PLUGINS_VERBOSE&quot;</span>);</div>
+<div class="line"><a id="l00471" name="l00471"></a><span class="lineno">  471</span>      verboseenv_value = verboseenv ? atoi(verboseenv) : 0;</div>
+<div class="line"><a id="l00472" name="l00472"></a><span class="lineno">  472</span>      verboseenv_checked = 1;</div>
+<div class="line"><a id="l00473" name="l00473"></a><span class="lineno">  473</span>    }</div>
+<div class="line"><a id="l00474" name="l00474"></a><span class="lineno">  474</span>    <span class="keywordflow">if</span> (verboseenv_value)</div>
+<div class="line"><a id="l00475" name="l00475"></a><span class="lineno">  475</span>      fprintf(stderr, <span class="stringliteral">&quot;Plugin `%s&#39; disabling itself because it cannot find the `%s&#39; core symbol.\n&quot;</span>,</div>
+<div class="line"><a id="l00476" name="l00476"></a><span class="lineno">  476</span>              pluginname, symbol);</div>
+<div class="line"><a id="l00477" name="l00477"></a><span class="lineno">  477</span>    <span class="keywordflow">return</span> -1;</div>
+<div class="line"><a id="l00478" name="l00478"></a><span class="lineno">  478</span>  }</div>
+<div class="line"><a id="l00479" name="l00479"></a><span class="lineno">  479</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_INSIDE_PLUGIN */</span><span class="preprocessor"></span></div>
+<div class="line"><a id="l00480" name="l00480"></a><span class="lineno">  480</span>  <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00481" name="l00481"></a><span class="lineno">  481</span>}</div>
+</div>
+<div class="line"><a id="l00482" name="l00482"></a><span class="lineno">  482</span> </div>
+<div class="line"><a id="l00499" name="l00499"></a><span class="lineno">  499</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00500" data-start="{" data-end="}">
+<div class="line"><a id="l00500" name="l00500"></a><span class="lineno"><a class="line" href="a00223.html#ga60203db6459ebf275bf48c40a37661a0">  500</a></span><a class="code hl_function" href="a00223.html#ga60203db6459ebf275bf48c40a37661a0">hwloc_filter_check_pcidev_subtype_important</a>(<span class="keywordtype">unsigned</span> classid)</div>
+<div class="line"><a id="l00501" name="l00501"></a><span class="lineno">  501</span>{</div>
+<div class="line"><a id="l00502" name="l00502"></a><span class="lineno">  502</span>  <span class="keywordtype">unsigned</span> baseclass = classid &gt;&gt; 8;</div>
+<div class="line"><a id="l00503" name="l00503"></a><span class="lineno">  503</span>  <span class="keywordflow">return</span> (baseclass == 0x03 <span class="comment">/* PCI_BASE_CLASS_DISPLAY */</span></div>
+<div class="line"><a id="l00504" name="l00504"></a><span class="lineno">  504</span>          || baseclass == 0x02 <span class="comment">/* PCI_BASE_CLASS_NETWORK */</span></div>
+<div class="line"><a id="l00505" name="l00505"></a><span class="lineno">  505</span>          || baseclass == 0x01 <span class="comment">/* PCI_BASE_CLASS_STORAGE */</span></div>
+<div class="line"><a id="l00506" name="l00506"></a><span class="lineno">  506</span>          || baseclass == 0x00 <span class="comment">/* Unclassified, for Atos/Bull BXI */</span></div>
+<div class="line"><a id="l00507" name="l00507"></a><span class="lineno">  507</span>          || baseclass == 0x0b <span class="comment">/* PCI_BASE_CLASS_PROCESSOR */</span></div>
+<div class="line"><a id="l00508" name="l00508"></a><span class="lineno">  508</span>          || classid == 0x0c04 <span class="comment">/* PCI_CLASS_SERIAL_FIBER */</span></div>
+<div class="line"><a id="l00509" name="l00509"></a><span class="lineno">  509</span>          || classid == 0x0c06 <span class="comment">/* PCI_CLASS_SERIAL_INFINIBAND */</span></div>
+<div class="line"><a id="l00510" name="l00510"></a><span class="lineno">  510</span>          || classid == 0x0502 <span class="comment">/* PCI_CLASS_MEMORY_CXL */</span></div>
+<div class="line"><a id="l00511" name="l00511"></a><span class="lineno">  511</span>          || baseclass == 0x06 <span class="comment">/* PCI_BASE_CLASS_BRIDGE with non-PCI downstream. the core will drop the useless ones later */</span></div>
+<div class="line"><a id="l00512" name="l00512"></a><span class="lineno">  512</span>          || baseclass == 0x12 <span class="comment">/* Processing Accelerators */</span>);</div>
+<div class="line"><a id="l00513" name="l00513"></a><span class="lineno">  513</span>}</div>
+</div>
+<div class="line"><a id="l00514" name="l00514"></a><span class="lineno">  514</span> </div>
+<div class="line"><a id="l00519" name="l00519"></a><span class="lineno">  519</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00520" data-start="{" data-end="}">
+<div class="line"><a id="l00520" name="l00520"></a><span class="lineno"><a class="line" href="a00223.html#gac7d57a6d669820f360cf2a070a396560">  520</a></span><a class="code hl_function" href="a00223.html#gac7d57a6d669820f360cf2a070a396560">hwloc_filter_check_osdev_subtype_important</a>(<a class="code hl_typedef" href="a00173.html#gaa9a6941ef7b1c169412518d7ef71b3d2">hwloc_obj_osdev_type_t</a> subtype)</div>
+<div class="line"><a id="l00521" name="l00521"></a><span class="lineno">  521</span>{</div>
+<div class="line"><a id="l00522" name="l00522"></a><span class="lineno">  522</span>  <span class="keywordflow">return</span> (subtype != <a class="code hl_enumvalue" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a827ad1643360711a8b6c6af671366791">HWLOC_OBJ_OSDEV_DMA</a>);</div>
+<div class="line"><a id="l00523" name="l00523"></a><span class="lineno">  523</span>}</div>
+</div>
+<div class="line"><a id="l00524" name="l00524"></a><span class="lineno">  524</span> </div>
+<div class="line"><a id="l00531" name="l00531"></a><span class="lineno">  531</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00532" data-start="{" data-end="}">
+<div class="line"><a id="l00532" name="l00532"></a><span class="lineno"><a class="line" href="a00223.html#ga2f402a43025a8a91e8513be1a15e4635">  532</a></span><a class="code hl_function" href="a00223.html#ga2f402a43025a8a91e8513be1a15e4635">hwloc_filter_check_keep_object_type</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</div>
+<div class="line"><a id="l00533" name="l00533"></a><span class="lineno">  533</span>{</div>
+<div class="line"><a id="l00534" name="l00534"></a><span class="lineno">  534</span>  <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter = <a class="code hl_enumvalue" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a">HWLOC_TYPE_FILTER_KEEP_NONE</a>;</div>
+<div class="line"><a id="l00535" name="l00535"></a><span class="lineno">  535</span>  <a class="code hl_function" href="a00182.html#ga137ad1178f7a79f2383974d983083401">hwloc_topology_get_type_filter</a>(topology, type, &amp;filter);</div>
+<div class="line"><a id="l00536" name="l00536"></a><span class="lineno">  536</span>  assert(filter != <a class="code hl_enumvalue" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5">HWLOC_TYPE_FILTER_KEEP_IMPORTANT</a>); <span class="comment">/* IMPORTANT only used for I/O */</span></div>
+<div class="line"><a id="l00537" name="l00537"></a><span class="lineno">  537</span>  <span class="keywordflow">return</span> filter == <a class="code hl_enumvalue" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a">HWLOC_TYPE_FILTER_KEEP_NONE</a> ? 0 : 1;</div>
+<div class="line"><a id="l00538" name="l00538"></a><span class="lineno">  538</span>}</div>
+</div>
+<div class="line"><a id="l00539" name="l00539"></a><span class="lineno">  539</span> </div>
+<div class="line"><a id="l00544" name="l00544"></a><span class="lineno">  544</span><span class="keyword">static</span> __hwloc_inline <span class="keywordtype">int</span></div>
+<div class="foldopen" id="foldopen00545" data-start="{" data-end="}">
+<div class="line"><a id="l00545" name="l00545"></a><span class="lineno"><a class="line" href="a00223.html#ga4d2fdce071e5646ef147c9ff1539d1c9">  545</a></span><a class="code hl_function" href="a00223.html#ga4d2fdce071e5646ef147c9ff1539d1c9">hwloc_filter_check_keep_object</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj)</div>
+<div class="line"><a id="l00546" name="l00546"></a><span class="lineno">  546</span>{</div>
+<div class="line"><a id="l00547" name="l00547"></a><span class="lineno">  547</span>  <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type = obj-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>;</div>
+<div class="line"><a id="l00548" name="l00548"></a><span class="lineno">  548</span>  <span class="keyword">enum</span> <a class="code hl_enumeration" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter = <a class="code hl_enumvalue" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a">HWLOC_TYPE_FILTER_KEEP_NONE</a>;</div>
+<div class="line"><a id="l00549" name="l00549"></a><span class="lineno">  549</span>  <a class="code hl_function" href="a00182.html#ga137ad1178f7a79f2383974d983083401">hwloc_topology_get_type_filter</a>(topology, type, &amp;filter);</div>
+<div class="line"><a id="l00550" name="l00550"></a><span class="lineno">  550</span>  <span class="keywordflow">if</span> (filter == <a class="code hl_enumvalue" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a">HWLOC_TYPE_FILTER_KEEP_NONE</a>)</div>
+<div class="line"><a id="l00551" name="l00551"></a><span class="lineno">  551</span>    <span class="keywordflow">return</span> 0;</div>
+<div class="line"><a id="l00552" name="l00552"></a><span class="lineno">  552</span>  <span class="keywordflow">if</span> (filter == <a class="code hl_enumvalue" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5">HWLOC_TYPE_FILTER_KEEP_IMPORTANT</a>) {</div>
+<div class="line"><a id="l00553" name="l00553"></a><span class="lineno">  553</span>    <span class="keywordflow">if</span> (type == <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a>)</div>
+<div class="line"><a id="l00554" name="l00554"></a><span class="lineno">  554</span>      <span class="keywordflow">return</span> <a class="code hl_function" href="a00223.html#ga60203db6459ebf275bf48c40a37661a0">hwloc_filter_check_pcidev_subtype_important</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a>.<a class="code hl_variable" href="a00253.html#aee735352d9f1686fd290fc6d6397c334">class_id</a>);</div>
+<div class="line"><a id="l00555" name="l00555"></a><span class="lineno">  555</span>    <span class="keywordflow">if</span> (type == <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075">HWLOC_OBJ_OS_DEVICE</a>)</div>
+<div class="line"><a id="l00556" name="l00556"></a><span class="lineno">  556</span>      <span class="keywordflow">return</span> <a class="code hl_function" href="a00223.html#gac7d57a6d669820f360cf2a070a396560">hwloc_filter_check_osdev_subtype_important</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a>.<a class="code hl_variable" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a>);</div>
+<div class="line"><a id="l00557" name="l00557"></a><span class="lineno">  557</span>  }</div>
+<div class="line"><a id="l00558" name="l00558"></a><span class="lineno">  558</span>  <span class="keywordflow">return</span> 1;</div>
+<div class="line"><a id="l00559" name="l00559"></a><span class="lineno">  559</span>}</div>
+</div>
+<div class="line"><a id="l00560" name="l00560"></a><span class="lineno">  560</span> </div>
+<div class="line"><a id="l00577" name="l00577"></a><span class="lineno"><a class="line" href="a00224.html#ga706f71cfea09d547d2cbafa642d6e03b">  577</a></span>HWLOC_DECLSPEC <span class="keywordtype">unsigned</span> <a class="code hl_function" href="a00224.html#ga706f71cfea09d547d2cbafa642d6e03b">hwloc_pcidisc_find_cap</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> *config, <span class="keywordtype">unsigned</span> cap);</div>
+<div class="line"><a id="l00578" name="l00578"></a><span class="lineno">  578</span> </div>
+<div class="line"><a id="l00584" name="l00584"></a><span class="lineno"><a class="line" href="a00224.html#ga51d1ebcbf9729987c9d17df3aa57d209">  584</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00224.html#ga51d1ebcbf9729987c9d17df3aa57d209">hwloc_pcidisc_find_linkspeed</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> *config, <span class="keywordtype">unsigned</span> offset, <span class="keywordtype">float</span> *linkspeed);</div>
+<div class="line"><a id="l00585" name="l00585"></a><span class="lineno">  585</span> </div>
+<div class="line"><a id="l00590" name="l00590"></a><span class="lineno"><a class="line" href="a00224.html#ga6c55fb80c3d0c8c8e61078b3f38adde8">  590</a></span>HWLOC_DECLSPEC <a class="code hl_enumeration" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> <a class="code hl_function" href="a00224.html#ga6c55fb80c3d0c8c8e61078b3f38adde8">hwloc_pcidisc_check_bridge_type</a>(<span class="keywordtype">unsigned</span> device_class, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> *config);</div>
+<div class="line"><a id="l00591" name="l00591"></a><span class="lineno">  591</span> </div>
+<div class="line"><a id="l00598" name="l00598"></a><span class="lineno"><a class="line" href="a00224.html#ga95acf6822a49447c11067d0b843965ba">  598</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00224.html#ga95acf6822a49447c11067d0b843965ba">hwloc_pcidisc_find_bridge_buses</a>(<span class="keywordtype">unsigned</span> domain, <span class="keywordtype">unsigned</span> bus, <span class="keywordtype">unsigned</span> dev, <span class="keywordtype">unsigned</span> func,</div>
+<div class="line"><a id="l00599" name="l00599"></a><span class="lineno">  599</span>                                                   <span class="keywordtype">unsigned</span> *secondary_busp, <span class="keywordtype">unsigned</span> *subordinate_busp,</div>
+<div class="line"><a id="l00600" name="l00600"></a><span class="lineno">  600</span>                                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> *config);</div>
+<div class="line"><a id="l00601" name="l00601"></a><span class="lineno">  601</span> </div>
+<div class="line"><a id="l00606" name="l00606"></a><span class="lineno"><a class="line" href="a00224.html#gab76ddc4f55db8101ef0d44317965128c">  606</a></span>HWLOC_DECLSPEC <span class="keywordtype">void</span> <a class="code hl_function" href="a00224.html#gab76ddc4f55db8101ef0d44317965128c">hwloc_pcidisc_tree_insert_by_busid</a>(<span class="keyword">struct</span> <a class="code hl_struct" href="a00229.html">hwloc_obj</a> **treep, <span class="keyword">struct</span> <a class="code hl_struct" href="a00229.html">hwloc_obj</a> *obj);</div>
+<div class="line"><a id="l00607" name="l00607"></a><span class="lineno">  607</span> </div>
+<div class="line"><a id="l00613" name="l00613"></a><span class="lineno"><a class="line" href="a00224.html#gabda1d6c1799e50b9226f8a4da9bd29ea">  613</a></span>HWLOC_DECLSPEC <span class="keywordtype">int</span> <a class="code hl_function" href="a00224.html#gabda1d6c1799e50b9226f8a4da9bd29ea">hwloc_pcidisc_tree_attach</a>(<span class="keyword">struct</span> hwloc_topology *topology, <span class="keyword">struct</span> <a class="code hl_struct" href="a00229.html">hwloc_obj</a> *tree);</div>
+<div class="line"><a id="l00614" name="l00614"></a><span class="lineno">  614</span> </div>
+<div class="line"><a id="l00638" name="l00638"></a><span class="lineno"><a class="line" href="a00225.html#ga5062f8cb07418b9cb01657d363d0f969">  638</a></span>HWLOC_DECLSPEC <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> * <a class="code hl_function" href="a00225.html#ga5062f8cb07418b9cb01657d363d0f969">hwloc_pci_find_parent_by_busid</a>(<span class="keyword">struct</span> hwloc_topology *topology, <span class="keywordtype">unsigned</span> domain, <span class="keywordtype">unsigned</span> bus, <span class="keywordtype">unsigned</span> dev, <span class="keywordtype">unsigned</span> func);</div>
+<div class="line"><a id="l00639" name="l00639"></a><span class="lineno">  639</span> </div>
+<div class="line"><a id="l00646" name="l00646"></a><span class="lineno"><a class="line" href="a00225.html#ga1779bc839369b3edcea1545a04ea123c">  646</a></span>HWLOC_DECLSPEC <span class="keyword">struct </span><a class="code hl_struct" href="a00229.html">hwloc_obj</a> * <a class="code hl_function" href="a00225.html#ga1779bc839369b3edcea1545a04ea123c">hwloc_pci_find_by_busid</a>(<span class="keyword">struct</span> hwloc_topology *topology, <span class="keywordtype">unsigned</span> domain, <span class="keywordtype">unsigned</span> bus, <span class="keywordtype">unsigned</span> dev, <span class="keywordtype">unsigned</span> func);</div>
+<div class="line"><a id="l00647" name="l00647"></a><span class="lineno">  647</span> </div>
+<div class="line"><a id="l00649" name="l00649"></a><span class="lineno"><a class="line" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">  649</a></span><span class="keyword">typedef</span> <span class="keywordtype">void</span> * <a class="code hl_typedef" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a>;</div>
+<div class="line"><a id="l00650" name="l00650"></a><span class="lineno">  650</span> </div>
+<div class="line"><a id="l00657" name="l00657"></a><span class="lineno">  657</span>HWLOC_DECLSPEC <a class="code hl_typedef" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a></div>
+<div class="line"><a id="l00658" name="l00658"></a><span class="lineno"><a class="line" href="a00225.html#gaa66a0bd519a5b1183a3e9b0c35a7f6cc">  658</a></span><a class="code hl_function" href="a00225.html#gaa66a0bd519a5b1183a3e9b0c35a7f6cc">hwloc_backend_distances_add_create</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00659" name="l00659"></a><span class="lineno">  659</span>                                   <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code hl_variable" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a>, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> kind,</div>
+<div class="line"><a id="l00660" name="l00660"></a><span class="lineno">  660</span>                                   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00661" name="l00661"></a><span class="lineno">  661</span> </div>
+<div class="line"><a id="l00673" name="l00673"></a><span class="lineno">  673</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00674" name="l00674"></a><span class="lineno"><a class="line" href="a00225.html#gaa27036bd83102f8e406f1051d560da6c">  674</a></span><a class="code hl_function" href="a00225.html#gaa27036bd83102f8e406f1051d560da6c">hwloc_backend_distances_add_values</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00675" name="l00675"></a><span class="lineno">  675</span>                                   <a class="code hl_typedef" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a> handle,</div>
+<div class="line"><a id="l00676" name="l00676"></a><span class="lineno">  676</span>                                   <span class="keywordtype">unsigned</span> nbobjs, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> *objs,</div>
+<div class="line"><a id="l00677" name="l00677"></a><span class="lineno">  677</span>                                   hwloc_uint64_t *values,</div>
+<div class="line"><a id="l00678" name="l00678"></a><span class="lineno">  678</span>                                   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00679" name="l00679"></a><span class="lineno">  679</span> </div>
+<div class="line"><a id="l00686" name="l00686"></a><span class="lineno">  686</span>HWLOC_DECLSPEC <span class="keywordtype">int</span></div>
+<div class="line"><a id="l00687" name="l00687"></a><span class="lineno"><a class="line" href="a00225.html#ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3">  687</a></span><a class="code hl_function" href="a00225.html#ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3">hwloc_backend_distances_add_commit</a>(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology,</div>
+<div class="line"><a id="l00688" name="l00688"></a><span class="lineno">  688</span>                                   <a class="code hl_typedef" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a> handle,</div>
+<div class="line"><a id="l00689" name="l00689"></a><span class="lineno">  689</span>                                   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);</div>
+<div class="line"><a id="l00690" name="l00690"></a><span class="lineno">  690</span> </div>
+<div class="line"><a id="l00696" name="l00696"></a><span class="lineno">  696</span><span class="preprocessor">#endif </span><span class="comment">/* HWLOC_PLUGINS_H */</span><span class="preprocessor"></span></div>
+<div class="ttc" id="aa00173_html_gaa9a6941ef7b1c169412518d7ef71b3d2"><div class="ttname"><a href="a00173.html#gaa9a6941ef7b1c169412518d7ef71b3d2">hwloc_obj_osdev_type_t</a></div><div class="ttdeci">enum hwloc_obj_osdev_type_e hwloc_obj_osdev_type_t</div><div class="ttdoc">Type of a OS device.</div></div>
+<div class="ttc" id="aa00173_html_gacd37bb612667dc437d66bfb175a8dc55"><div class="ttname"><a href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a></div><div class="ttdeci">hwloc_obj_type_t</div><div class="ttdoc">Type of topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:197</div></div>
+<div class="ttc" id="aa00173_html_gga64f5d539df299c97ae80ce53fc4b56c0a827ad1643360711a8b6c6af671366791"><div class="ttname"><a href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a827ad1643360711a8b6c6af671366791">HWLOC_OBJ_OSDEV_DMA</a></div><div class="ttdeci">@ HWLOC_OBJ_OSDEV_DMA</div><div class="ttdoc">Operating system dma engine device. For instance the &quot;dma0chan0&quot; DMA channel on Linux.</div><div class="ttdef"><b>Definition</b> hwloc.h:383</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075">HWLOC_OBJ_OS_DEVICE</a></div><div class="ttdeci">@ HWLOC_OBJ_OS_DEVICE</div><div class="ttdoc">Operating system device (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:305</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a></div><div class="ttdeci">@ HWLOC_OBJ_PCI_DEVICE</div><div class="ttdoc">PCI device (filtered out by default).</div><div class="ttdef"><b>Definition</b> hwloc.h:295</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00182_html_ga137ad1178f7a79f2383974d983083401"><div class="ttname"><a href="a00182.html#ga137ad1178f7a79f2383974d983083401">hwloc_topology_get_type_filter</a></div><div class="ttdeci">int hwloc_topology_get_type_filter(hwloc_topology_t topology, hwloc_obj_type_t type, enum hwloc_type_filter_e *filter)</div><div class="ttdoc">Get the current filtering for the given object type.</div></div>
+<div class="ttc" id="aa00182_html_ga9a5a1f0140cd1952544477833733195b"><div class="ttname"><a href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a></div><div class="ttdeci">hwloc_type_filter_e</div><div class="ttdoc">Type filtering flags.</div><div class="ttdef"><b>Definition</b> hwloc.h:2439</div></div>
+<div class="ttc" id="aa00182_html_gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a"><div class="ttname"><a href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a">HWLOC_TYPE_FILTER_KEEP_NONE</a></div><div class="ttdeci">@ HWLOC_TYPE_FILTER_KEEP_NONE</div><div class="ttdoc">Ignore all objects of this type.</div><div class="ttdef"><b>Definition</b> hwloc.h:2453</div></div>
+<div class="ttc" id="aa00182_html_gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5"><div class="ttname"><a href="a00182.html#gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5">HWLOC_TYPE_FILTER_KEEP_IMPORTANT</a></div><div class="ttdeci">@ HWLOC_TYPE_FILTER_KEEP_IMPORTANT</div><div class="ttdoc">Only keep likely-important objects of the given type.</div><div class="ttdef"><b>Definition</b> hwloc.h:2482</div></div>
+<div class="ttc" id="aa00194_html_gaa3c2bf4c776d603dcebbb61b0c923d84"><div class="ttname"><a href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a></div><div class="ttdeci">struct hwloc_bitmap_s * hwloc_bitmap_t</div><div class="ttdoc">Set of bits represented as an opaque pointer to an internal bitmap.</div><div class="ttdef"><b>Definition</b> bitmap.h:69</div></div>
+<div class="ttc" id="aa00220_html_ga4715779d7191833e9b1a7490989a7497"><div class="ttname"><a href="a00220.html#ga4715779d7191833e9b1a7490989a7497">hwloc_backend_enable</a></div><div class="ttdeci">int hwloc_backend_enable(struct hwloc_backend *backend)</div><div class="ttdoc">Enable a previously allocated and setup backend.</div></div>
+<div class="ttc" id="aa00220_html_ga600bba1a62022d5f516800649b1edb61"><div class="ttname"><a href="a00220.html#ga600bba1a62022d5f516800649b1edb61">hwloc_disc_phase_t</a></div><div class="ttdeci">enum hwloc_disc_phase_e hwloc_disc_phase_t</div><div class="ttdoc">Discovery phase.</div></div>
+<div class="ttc" id="aa00220_html_ga6118a1009aa390c13255a330ccf253cf"><div class="ttname"><a href="a00220.html#ga6118a1009aa390c13255a330ccf253cf">hwloc_backend_alloc</a></div><div class="ttdeci">struct hwloc_backend * hwloc_backend_alloc(struct hwloc_topology *topology, struct hwloc_disc_component *component)</div><div class="ttdoc">Allocate a backend structure, set good default values, initialize backend-&gt;component and topology,...</div></div>
+<div class="ttc" id="aa00220_html_ga8c314121c2fc478161bcce758688b9a1"><div class="ttname"><a href="a00220.html#ga8c314121c2fc478161bcce758688b9a1">hwloc_disc_phase_e</a></div><div class="ttdeci">hwloc_disc_phase_e</div><div class="ttdoc">Discovery phase.</div><div class="ttdef"><b>Definition</b> plugins.h:106</div></div>
+<div class="ttc" id="aa00220_html_gaae1b38cf9b12e489884ce2a07275964b"><div class="ttname"><a href="a00220.html#gaae1b38cf9b12e489884ce2a07275964b">hwloc_disc_status_flag_e</a></div><div class="ttdeci">hwloc_disc_status_flag_e</div><div class="ttdoc">Discovery status flags.</div><div class="ttdef"><b>Definition</b> plugins.h:146</div></div>
+<div class="ttc" id="aa00220_html_gga8c314121c2fc478161bcce758688b9a1a6360474df197027761a69bd5fc620250"><div class="ttname"><a href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a6360474df197027761a69bd5fc620250">HWLOC_DISC_PHASE_CPU</a></div><div class="ttdeci">@ HWLOC_DISC_PHASE_CPU</div><div class="ttdoc">CPU discovery.</div><div class="ttdef"><b>Definition</b> plugins.h:115</div></div>
+<div class="ttc" id="aa00220_html_gga8c314121c2fc478161bcce758688b9a1a677c52064dd987af4988346319b3675a"><div class="ttname"><a href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a677c52064dd987af4988346319b3675a">HWLOC_DISC_PHASE_PCI</a></div><div class="ttdeci">@ HWLOC_DISC_PHASE_PCI</div><div class="ttdoc">Attach PCI devices and bridges to existing CPU objects.</div><div class="ttdef"><b>Definition</b> plugins.h:123</div></div>
+<div class="ttc" id="aa00220_html_gga8c314121c2fc478161bcce758688b9a1a68ca5c7ad75a6d9e5355689411621773"><div class="ttname"><a href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a68ca5c7ad75a6d9e5355689411621773">HWLOC_DISC_PHASE_ANNOTATE</a></div><div class="ttdeci">@ HWLOC_DISC_PHASE_ANNOTATE</div><div class="ttdoc">Annotating existing objects, adding distances, etc.</div><div class="ttdef"><b>Definition</b> plugins.h:135</div></div>
+<div class="ttc" id="aa00220_html_gga8c314121c2fc478161bcce758688b9a1a8a7cde9bff0ab0d085b102a3e934939b"><div class="ttname"><a href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a8a7cde9bff0ab0d085b102a3e934939b">HWLOC_DISC_PHASE_MISC</a></div><div class="ttdeci">@ HWLOC_DISC_PHASE_MISC</div><div class="ttdoc">Misc objects that gets added below anything else.</div><div class="ttdef"><b>Definition</b> plugins.h:131</div></div>
+<div class="ttc" id="aa00220_html_gga8c314121c2fc478161bcce758688b9a1aa8e10626cba9af72f5605a1acbdc0015"><div class="ttname"><a href="a00220.html#gga8c314121c2fc478161bcce758688b9a1aa8e10626cba9af72f5605a1acbdc0015">HWLOC_DISC_PHASE_IO</a></div><div class="ttdeci">@ HWLOC_DISC_PHASE_IO</div><div class="ttdoc">I/O discovery that requires PCI devices (OS devices such as OpenCL, CUDA, etc.).</div><div class="ttdef"><b>Definition</b> plugins.h:127</div></div>
+<div class="ttc" id="aa00220_html_gga8c314121c2fc478161bcce758688b9a1ab41c626c79e9ccb1e7d41e7076972283"><div class="ttname"><a href="a00220.html#gga8c314121c2fc478161bcce758688b9a1ab41c626c79e9ccb1e7d41e7076972283">HWLOC_DISC_PHASE_GLOBAL</a></div><div class="ttdeci">@ HWLOC_DISC_PHASE_GLOBAL</div><div class="ttdoc">xml or synthetic, platform-specific components such as bgq. Discovers everything including CPU,...</div><div class="ttdef"><b>Definition</b> plugins.h:111</div></div>
+<div class="ttc" id="aa00220_html_gga8c314121c2fc478161bcce758688b9a1ac4264a243844c5fbbff495cdb1b4d51d"><div class="ttname"><a href="a00220.html#gga8c314121c2fc478161bcce758688b9a1ac4264a243844c5fbbff495cdb1b4d51d">HWLOC_DISC_PHASE_MEMORY</a></div><div class="ttdeci">@ HWLOC_DISC_PHASE_MEMORY</div><div class="ttdoc">Attach memory to existing CPU objects.</div><div class="ttdef"><b>Definition</b> plugins.h:119</div></div>
+<div class="ttc" id="aa00220_html_gga8c314121c2fc478161bcce758688b9a1ada3ed3f00e74909353d6ea4a96cde5ad"><div class="ttname"><a href="a00220.html#gga8c314121c2fc478161bcce758688b9a1ada3ed3f00e74909353d6ea4a96cde5ad">HWLOC_DISC_PHASE_TWEAK</a></div><div class="ttdeci">@ HWLOC_DISC_PHASE_TWEAK</div><div class="ttdoc">Final tweaks to a ready-to-use topology. This phase runs once the topology is loaded,...</div><div class="ttdef"><b>Definition</b> plugins.h:142</div></div>
+<div class="ttc" id="aa00220_html_ggaae1b38cf9b12e489884ce2a07275964ba205d644d54a0840bd9165fce7d19e6b1"><div class="ttname"><a href="a00220.html#ggaae1b38cf9b12e489884ce2a07275964ba205d644d54a0840bd9165fce7d19e6b1">HWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES</a></div><div class="ttdeci">@ HWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES</div><div class="ttdoc">The sets of allowed resources were already retrieved.</div><div class="ttdef"><b>Definition</b> plugins.h:148</div></div>
+<div class="ttc" id="aa00221_html_ga31a5a455f4e666b936f0a9e8fb9a0f47"><div class="ttname"><a href="a00221.html#ga31a5a455f4e666b936f0a9e8fb9a0f47">hwloc_component_type_t</a></div><div class="ttdeci">enum hwloc_component_type_e hwloc_component_type_t</div><div class="ttdoc">Generic component type.</div></div>
+<div class="ttc" id="aa00221_html_ga397a1bf7d21dd073320ad0045340f463"><div class="ttname"><a href="a00221.html#ga397a1bf7d21dd073320ad0045340f463">hwloc_component_type_e</a></div><div class="ttdeci">hwloc_component_type_e</div><div class="ttdoc">Generic component type.</div><div class="ttdef"><b>Definition</b> plugins.h:257</div></div>
+<div class="ttc" id="aa00221_html_gga397a1bf7d21dd073320ad0045340f463a5d6e561f467fe9795a29e7368b613900"><div class="ttname"><a href="a00221.html#gga397a1bf7d21dd073320ad0045340f463a5d6e561f467fe9795a29e7368b613900">HWLOC_COMPONENT_TYPE_DISC</a></div><div class="ttdeci">@ HWLOC_COMPONENT_TYPE_DISC</div><div class="ttdoc">The data field must point to a struct hwloc_disc_component.</div><div class="ttdef"><b>Definition</b> plugins.h:259</div></div>
+<div class="ttc" id="aa00221_html_gga397a1bf7d21dd073320ad0045340f463adea00cd839c2141c032e1569fd5592bd"><div class="ttname"><a href="a00221.html#gga397a1bf7d21dd073320ad0045340f463adea00cd839c2141c032e1569fd5592bd">HWLOC_COMPONENT_TYPE_XML</a></div><div class="ttdeci">@ HWLOC_COMPONENT_TYPE_XML</div><div class="ttdoc">The data field must point to a struct hwloc_xml_component.</div><div class="ttdef"><b>Definition</b> plugins.h:262</div></div>
+<div class="ttc" id="aa00222_html_ga0b5c75b2dc37cea2e8a29c4812baf4b3"><div class="ttname"><a href="a00222.html#ga0b5c75b2dc37cea2e8a29c4812baf4b3">hwloc_alloc_setup_object</a></div><div class="ttdeci">hwloc_obj_t hwloc_alloc_setup_object(hwloc_topology_t topology, hwloc_obj_type_t type, unsigned os_index)</div><div class="ttdoc">Allocate and initialize an object of the given type and physical index.</div></div>
+<div class="ttc" id="aa00222_html_ga0ef97debde503b56367689b07bb3e901"><div class="ttname"><a href="a00222.html#ga0ef97debde503b56367689b07bb3e901">hwloc_insert_object_by_parent</a></div><div class="ttdeci">void hwloc_insert_object_by_parent(struct hwloc_topology *topology, hwloc_obj_t parent, hwloc_obj_t obj)</div><div class="ttdoc">Insert an object somewhere in the topology.</div></div>
+<div class="ttc" id="aa00222_html_ga120d8bd74922e1030b621409a6b0be61"><div class="ttname"><a href="a00222.html#ga120d8bd74922e1030b621409a6b0be61">hwloc_topology_reconnect</a></div><div class="ttdeci">int hwloc_topology_reconnect(hwloc_topology_t topology, unsigned long flags)</div><div class="ttdoc">Request a reconnection of children and levels in the topology.</div></div>
+<div class="ttc" id="aa00222_html_ga1e105cfe3c8e77f34cc6df3841deebbc"><div class="ttname"><a href="a00222.html#ga1e105cfe3c8e77f34cc6df3841deebbc">hwloc__insert_object_by_cpuset</a></div><div class="ttdeci">hwloc_obj_t hwloc__insert_object_by_cpuset(struct hwloc_topology *topology, hwloc_obj_t root, hwloc_obj_t obj, const char *reason)</div><div class="ttdoc">Add an object to the topology.</div></div>
+<div class="ttc" id="aa00222_html_ga754b61041ceee9685534a2c5d3cd0156"><div class="ttname"><a href="a00222.html#ga754b61041ceee9685534a2c5d3cd0156">hwloc_obj_add_children_sets</a></div><div class="ttdeci">int hwloc_obj_add_children_sets(hwloc_obj_t obj)</div><div class="ttdoc">Setup object cpusets/nodesets by OR'ing its children.</div></div>
+<div class="ttc" id="aa00222_html_gab527c1e0f243f057d31a724794ad9f88"><div class="ttname"><a href="a00222.html#gab527c1e0f243f057d31a724794ad9f88">hwloc_hide_errors</a></div><div class="ttdeci">int hwloc_hide_errors(void)</div><div class="ttdoc">Check whether error messages are hidden.</div></div>
+<div class="ttc" id="aa00222_html_gac2eaed287bb215cf0bd33014e9e1d374"><div class="ttname"><a href="a00222.html#gac2eaed287bb215cf0bd33014e9e1d374">hwloc_plugin_check_namespace</a></div><div class="ttdeci">static int hwloc_plugin_check_namespace(const char *pluginname, const char *symbol)</div><div class="ttdoc">Make sure that plugins can lookup core symbols.</div><div class="ttdef"><b>Definition</b> plugins.h:447</div></div>
+<div class="ttc" id="aa00223_html_ga2f402a43025a8a91e8513be1a15e4635"><div class="ttname"><a href="a00223.html#ga2f402a43025a8a91e8513be1a15e4635">hwloc_filter_check_keep_object_type</a></div><div class="ttdeci">static int hwloc_filter_check_keep_object_type(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Check whether a non-I/O object type should be filtered-out.</div><div class="ttdef"><b>Definition</b> plugins.h:532</div></div>
+<div class="ttc" id="aa00223_html_ga4d2fdce071e5646ef147c9ff1539d1c9"><div class="ttname"><a href="a00223.html#ga4d2fdce071e5646ef147c9ff1539d1c9">hwloc_filter_check_keep_object</a></div><div class="ttdeci">static int hwloc_filter_check_keep_object(hwloc_topology_t topology, hwloc_obj_t obj)</div><div class="ttdoc">Check whether the given object should be filtered-out.</div><div class="ttdef"><b>Definition</b> plugins.h:545</div></div>
+<div class="ttc" id="aa00223_html_ga60203db6459ebf275bf48c40a37661a0"><div class="ttname"><a href="a00223.html#ga60203db6459ebf275bf48c40a37661a0">hwloc_filter_check_pcidev_subtype_important</a></div><div class="ttdeci">static int hwloc_filter_check_pcidev_subtype_important(unsigned classid)</div><div class="ttdoc">Check whether the given PCI device classid is important.</div><div class="ttdef"><b>Definition</b> plugins.h:500</div></div>
+<div class="ttc" id="aa00223_html_gac7d57a6d669820f360cf2a070a396560"><div class="ttname"><a href="a00223.html#gac7d57a6d669820f360cf2a070a396560">hwloc_filter_check_osdev_subtype_important</a></div><div class="ttdeci">static int hwloc_filter_check_osdev_subtype_important(hwloc_obj_osdev_type_t subtype)</div><div class="ttdoc">Check whether the given OS device subtype is important.</div><div class="ttdef"><b>Definition</b> plugins.h:520</div></div>
+<div class="ttc" id="aa00224_html_ga51d1ebcbf9729987c9d17df3aa57d209"><div class="ttname"><a href="a00224.html#ga51d1ebcbf9729987c9d17df3aa57d209">hwloc_pcidisc_find_linkspeed</a></div><div class="ttdeci">int hwloc_pcidisc_find_linkspeed(const unsigned char *config, unsigned offset, float *linkspeed)</div><div class="ttdoc">Fill linkspeed by reading the PCI config space where PCI_CAP_ID_EXP is at position offset.</div></div>
+<div class="ttc" id="aa00224_html_ga6c55fb80c3d0c8c8e61078b3f38adde8"><div class="ttname"><a href="a00224.html#ga6c55fb80c3d0c8c8e61078b3f38adde8">hwloc_pcidisc_check_bridge_type</a></div><div class="ttdeci">hwloc_obj_type_t hwloc_pcidisc_check_bridge_type(unsigned device_class, const unsigned char *config)</div><div class="ttdoc">Return the hwloc object type (PCI device or Bridge) for the given class and configuration space.</div></div>
+<div class="ttc" id="aa00224_html_ga706f71cfea09d547d2cbafa642d6e03b"><div class="ttname"><a href="a00224.html#ga706f71cfea09d547d2cbafa642d6e03b">hwloc_pcidisc_find_cap</a></div><div class="ttdeci">unsigned hwloc_pcidisc_find_cap(const unsigned char *config, unsigned cap)</div><div class="ttdoc">Return the offset of the given capability in the PCI config space buffer.</div></div>
+<div class="ttc" id="aa00224_html_ga95acf6822a49447c11067d0b843965ba"><div class="ttname"><a href="a00224.html#ga95acf6822a49447c11067d0b843965ba">hwloc_pcidisc_find_bridge_buses</a></div><div class="ttdeci">int hwloc_pcidisc_find_bridge_buses(unsigned domain, unsigned bus, unsigned dev, unsigned func, unsigned *secondary_busp, unsigned *subordinate_busp, const unsigned char *config)</div><div class="ttdoc">Fills the attributes of the given PCI bridge using the given PCI config space.</div></div>
+<div class="ttc" id="aa00224_html_gab76ddc4f55db8101ef0d44317965128c"><div class="ttname"><a href="a00224.html#gab76ddc4f55db8101ef0d44317965128c">hwloc_pcidisc_tree_insert_by_busid</a></div><div class="ttdeci">void hwloc_pcidisc_tree_insert_by_busid(struct hwloc_obj **treep, struct hwloc_obj *obj)</div><div class="ttdoc">Insert a PCI object in the given PCI tree by looking at PCI bus IDs.</div></div>
+<div class="ttc" id="aa00224_html_gabda1d6c1799e50b9226f8a4da9bd29ea"><div class="ttname"><a href="a00224.html#gabda1d6c1799e50b9226f8a4da9bd29ea">hwloc_pcidisc_tree_attach</a></div><div class="ttdeci">int hwloc_pcidisc_tree_attach(struct hwloc_topology *topology, struct hwloc_obj *tree)</div><div class="ttdoc">Add some hostbridges on top of the given tree of PCI objects and attach them to the topology.</div></div>
+<div class="ttc" id="aa00225_html_ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3"><div class="ttname"><a href="a00225.html#ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3">hwloc_backend_distances_add_commit</a></div><div class="ttdeci">int hwloc_backend_distances_add_commit(hwloc_topology_t topology, hwloc_backend_distances_add_handle_t handle, unsigned long flags)</div><div class="ttdoc">Commit a new distances structure.</div></div>
+<div class="ttc" id="aa00225_html_ga1779bc839369b3edcea1545a04ea123c"><div class="ttname"><a href="a00225.html#ga1779bc839369b3edcea1545a04ea123c">hwloc_pci_find_by_busid</a></div><div class="ttdeci">struct hwloc_obj * hwloc_pci_find_by_busid(struct hwloc_topology *topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)</div><div class="ttdoc">Find the PCI device or bridge matching a PCI bus ID exactly.</div></div>
+<div class="ttc" id="aa00225_html_ga5062f8cb07418b9cb01657d363d0f969"><div class="ttname"><a href="a00225.html#ga5062f8cb07418b9cb01657d363d0f969">hwloc_pci_find_parent_by_busid</a></div><div class="ttdeci">struct hwloc_obj * hwloc_pci_find_parent_by_busid(struct hwloc_topology *topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)</div><div class="ttdoc">Find the object or a parent of a PCI bus ID.</div></div>
+<div class="ttc" id="aa00225_html_gaa27036bd83102f8e406f1051d560da6c"><div class="ttname"><a href="a00225.html#gaa27036bd83102f8e406f1051d560da6c">hwloc_backend_distances_add_values</a></div><div class="ttdeci">int hwloc_backend_distances_add_values(hwloc_topology_t topology, hwloc_backend_distances_add_handle_t handle, unsigned nbobjs, hwloc_obj_t *objs, hwloc_uint64_t *values, unsigned long flags)</div><div class="ttdoc">Specify the objects and values in a new empty distances structure.</div></div>
+<div class="ttc" id="aa00225_html_gaa66a0bd519a5b1183a3e9b0c35a7f6cc"><div class="ttname"><a href="a00225.html#gaa66a0bd519a5b1183a3e9b0c35a7f6cc">hwloc_backend_distances_add_create</a></div><div class="ttdeci">hwloc_backend_distances_add_handle_t hwloc_backend_distances_add_create(hwloc_topology_t topology, const char *name, unsigned long kind, unsigned long flags)</div><div class="ttdoc">Create a new empty distances structure.</div></div>
+<div class="ttc" id="aa00225_html_gafe5e49d32dd0a28ead94b6e31048e042"><div class="ttname"><a href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a></div><div class="ttdeci">void * hwloc_backend_distances_add_handle_t</div><div class="ttdoc">Handle to a new distances structure during its addition to the topology.</div><div class="ttdef"><b>Definition</b> plugins.h:649</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_abb709ec38f2970677e4e57d1d30be96d"><div class="ttname"><a href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj::name</a></div><div class="ttdeci">char * name</div><div class="ttdoc">Object-specific name if any. Mostly used for identifying OS devices and Misc objects where a name str...</div><div class="ttdef"><b>Definition</b> hwloc.h:443</div></div>
+<div class="ttc" id="aa00229_html_acc4f0803f244867e68fe0036800be5de"><div class="ttname"><a href="a00229.html#acc4f0803f244867e68fe0036800be5de">hwloc_obj::type</a></div><div class="ttdeci">hwloc_obj_type_t type</div><div class="ttdoc">Type of object.</div><div class="ttdef"><b>Definition</b> hwloc.h:433</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00233_html_a0b66da7ab072f7c016f8ed86701f5a7c"><div class="ttname"><a href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">hwloc_obj_attr_u::pcidev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_pcidev_attr_s pcidev</div></div>
+<div class="ttc" id="aa00233_html_aaf7a5c38b5185703ff18c46ad2761dcf"><div class="ttname"><a href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">hwloc_obj_attr_u::osdev</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_osdev_attr_s osdev</div></div>
+<div class="ttc" id="aa00253_html_aee735352d9f1686fd290fc6d6397c334"><div class="ttname"><a href="a00253.html#aee735352d9f1686fd290fc6d6397c334">hwloc_obj_attr_u::hwloc_pcidev_attr_s::class_id</a></div><div class="ttdeci">unsigned short class_id</div><div class="ttdoc">The class number (first two bytes, without the prog_if).</div><div class="ttdef"><b>Definition</b> hwloc.h:679</div></div>
+<div class="ttc" id="aa00273_html_a31e019e27e54ac6138d04be639bb96f9"><div class="ttname"><a href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">hwloc_obj_attr_u::hwloc_osdev_attr_s::type</a></div><div class="ttdeci">hwloc_obj_osdev_type_t type</div><div class="ttdef"><b>Definition</b> hwloc.h:716</div></div>
+<div class="ttc" id="aa00361_html"><div class="ttname"><a href="a00361.html">hwloc_disc_component</a></div><div class="ttdoc">Discovery component structure.</div><div class="ttdef"><b>Definition</b> plugins.h:41</div></div>
+<div class="ttc" id="aa00361_html_a4064c3b5d9213027e87caebef380a840"><div class="ttname"><a href="a00361.html#a4064c3b5d9213027e87caebef380a840">hwloc_disc_component::name</a></div><div class="ttdeci">const char * name</div><div class="ttdoc">Name. If this component is built as a plugin, this name does not have to match the plugin filename.</div><div class="ttdef"><b>Definition</b> plugins.h:45</div></div>
+<div class="ttc" id="aa00361_html_a61ad3151efa02e3dbad5d919758f9c90"><div class="ttname"><a href="a00361.html#a61ad3151efa02e3dbad5d919758f9c90">hwloc_disc_component::phases</a></div><div class="ttdeci">unsigned phases</div><div class="ttdoc">Discovery phases performed by this component. OR'ed set of hwloc_disc_phase_t.</div><div class="ttdef"><b>Definition</b> plugins.h:50</div></div>
+<div class="ttc" id="aa00361_html_acbb9957914dbf7b8f504215aa0c8d3fe"><div class="ttname"><a href="a00361.html#acbb9957914dbf7b8f504215aa0c8d3fe">hwloc_disc_component::excluded_phases</a></div><div class="ttdeci">unsigned excluded_phases</div><div class="ttdoc">Component phases to exclude, as an OR'ed set of hwloc_disc_phase_t.</div><div class="ttdef"><b>Definition</b> plugins.h:60</div></div>
+<div class="ttc" id="aa00361_html_ace80cafe2b1732b047b3fc3da47e6517"><div class="ttname"><a href="a00361.html#ace80cafe2b1732b047b3fc3da47e6517">hwloc_disc_component::enabled_by_default</a></div><div class="ttdeci">unsigned enabled_by_default</div><div class="ttdoc">Enabled by default. If unset, if will be disabled unless explicitly requested.</div><div class="ttdef"><b>Definition</b> plugins.h:84</div></div>
+<div class="ttc" id="aa00361_html_ae86d283c272c5ae24073a235efbf6b59"><div class="ttname"><a href="a00361.html#ae86d283c272c5ae24073a235efbf6b59">hwloc_disc_component::priority</a></div><div class="ttdeci">unsigned priority</div><div class="ttdoc">Component priority. Used to sort topology-&gt;components, higher priority first. Also used to decide bet...</div><div class="ttdef"><b>Definition</b> plugins.h:79</div></div>
+<div class="ttc" id="aa00365_html"><div class="ttname"><a href="a00365.html">hwloc_disc_status</a></div><div class="ttdoc">Discovery status structure.</div><div class="ttdef"><b>Definition</b> plugins.h:156</div></div>
+<div class="ttc" id="aa00365_html_a0f95fa42d46a6e7cf8dee8af12afee3a"><div class="ttname"><a href="a00365.html#a0f95fa42d46a6e7cf8dee8af12afee3a">hwloc_disc_status::excluded_phases</a></div><div class="ttdeci">unsigned excluded_phases</div><div class="ttdoc">Dynamically excluded phases. If a component decides during discovery that some phases are no longer n...</div><div class="ttdef"><b>Definition</b> plugins.h:165</div></div>
+<div class="ttc" id="aa00365_html_abaf7c8c082d43e133171f0723dbf824b"><div class="ttname"><a href="a00365.html#abaf7c8c082d43e133171f0723dbf824b">hwloc_disc_status::phase</a></div><div class="ttdeci">hwloc_disc_phase_t phase</div><div class="ttdoc">The current discovery phase that is performed. Must match one of the phases in the component phases f...</div><div class="ttdef"><b>Definition</b> plugins.h:160</div></div>
+<div class="ttc" id="aa00365_html_ad8b123cecb945a9182eb824ccf8ef9d7"><div class="ttname"><a href="a00365.html#ad8b123cecb945a9182eb824ccf8ef9d7">hwloc_disc_status::flags</a></div><div class="ttdeci">unsigned long flags</div><div class="ttdoc">OR'ed set of hwloc_disc_status_flag_e.</div><div class="ttdef"><b>Definition</b> plugins.h:168</div></div>
+<div class="ttc" id="aa00369_html"><div class="ttname"><a href="a00369.html">hwloc_backend</a></div><div class="ttdoc">Discovery backend structure.</div><div class="ttdef"><b>Definition</b> plugins.h:189</div></div>
+<div class="ttc" id="aa00369_html_a2ea5bd36b7f06efdb65b98b32af16c68"><div class="ttname"><a href="a00369.html#a2ea5bd36b7f06efdb65b98b32af16c68">hwloc_backend::private_data</a></div><div class="ttdeci">void * private_data</div><div class="ttdoc">Backend private data, or NULL if none.</div><div class="ttdef"><b>Definition</b> plugins.h:216</div></div>
+<div class="ttc" id="aa00369_html_a36c4fa86350525b46340c67b802c69c7"><div class="ttname"><a href="a00369.html#a36c4fa86350525b46340c67b802c69c7">hwloc_backend::disable</a></div><div class="ttdeci">void(* disable)(struct hwloc_backend *backend)</div><div class="ttdoc">Callback for freeing the private_data. May be NULL.</div><div class="ttdef"><b>Definition</b> plugins.h:220</div></div>
+<div class="ttc" id="aa00369_html_aaa8eafe495aadd81c2e3c4ec527c10ba"><div class="ttname"><a href="a00369.html#aaa8eafe495aadd81c2e3c4ec527c10ba">hwloc_backend::flags</a></div><div class="ttdeci">unsigned long flags</div><div class="ttdoc">Backend flags, currently always 0.</div><div class="ttdef"><b>Definition</b> plugins.h:205</div></div>
+<div class="ttc" id="aa00369_html_aaac253491264c20930f44817270bc502"><div class="ttname"><a href="a00369.html#aaac253491264c20930f44817270bc502">hwloc_backend::get_pci_busid_cpuset</a></div><div class="ttdeci">int(* get_pci_busid_cpuset)(struct hwloc_backend *backend, struct hwloc_pcidev_attr_s *busid, hwloc_bitmap_t cpuset)</div><div class="ttdoc">Callback to retrieve the locality of a PCI object. Called by the PCI core when attaching PCI hierarch...</div><div class="ttdef"><b>Definition</b> plugins.h:233</div></div>
+<div class="ttc" id="aa00369_html_ab8806f6db077f1bb2e9d63ec99223f7a"><div class="ttname"><a href="a00369.html#ab8806f6db077f1bb2e9d63ec99223f7a">hwloc_backend::is_thissystem</a></div><div class="ttdeci">int is_thissystem</div><div class="ttdoc">Backend-specific 'is_thissystem' property. Set to 0 if the backend disables the thissystem flag for t...</div><div class="ttdef"><b>Definition</b> plugins.h:213</div></div>
+<div class="ttc" id="aa00369_html_accff2cd8404be43c3b44cec05e6f609b"><div class="ttname"><a href="a00369.html#accff2cd8404be43c3b44cec05e6f609b">hwloc_backend::discover</a></div><div class="ttdeci">int(* discover)(struct hwloc_backend *backend, struct hwloc_disc_status *status)</div><div class="ttdoc">Main discovery callback. returns -1 on error, either because it couldn't add its objects ot the exist...</div><div class="ttdef"><b>Definition</b> plugins.h:227</div></div>
+<div class="ttc" id="aa00369_html_aeca769840a6ff03e96462a9533adbccd"><div class="ttname"><a href="a00369.html#aeca769840a6ff03e96462a9533adbccd">hwloc_backend::phases</a></div><div class="ttdeci">unsigned phases</div><div class="ttdoc">Discovery phases performed by this component, possibly without some of them if excluded by other comp...</div><div class="ttdef"><b>Definition</b> plugins.h:202</div></div>
+<div class="ttc" id="aa00373_html"><div class="ttname"><a href="a00373.html">hwloc_component</a></div><div class="ttdoc">Generic component structure.</div><div class="ttdef"><b>Definition</b> plugins.h:270</div></div>
+<div class="ttc" id="aa00373_html_a3250bd6fc9713946991d805e48091b2e"><div class="ttname"><a href="a00373.html#a3250bd6fc9713946991d805e48091b2e">hwloc_component::abi</a></div><div class="ttdeci">unsigned abi</div><div class="ttdoc">Component ABI version, set to HWLOC_COMPONENT_ABI.</div><div class="ttdef"><b>Definition</b> plugins.h:272</div></div>
+<div class="ttc" id="aa00373_html_a4612015451a1c706e8ba19114cb8baae"><div class="ttname"><a href="a00373.html#a4612015451a1c706e8ba19114cb8baae">hwloc_component::finalize</a></div><div class="ttdeci">void(* finalize)(unsigned long flags)</div><div class="ttdoc">Process-wide component termination callback.</div><div class="ttdef"><b>Definition</b> plugins.h:304</div></div>
+<div class="ttc" id="aa00373_html_a4b8cffd1d943c29fdc102b841b8598d4"><div class="ttname"><a href="a00373.html#a4b8cffd1d943c29fdc102b841b8598d4">hwloc_component::data</a></div><div class="ttdeci">void * data</div><div class="ttdoc">Component data, pointing to a struct hwloc_disc_component or struct hwloc_xml_component.</div><div class="ttdef"><b>Definition</b> plugins.h:313</div></div>
+<div class="ttc" id="aa00373_html_a789208ada7e17492cfd3a5a88a6bb0ee"><div class="ttname"><a href="a00373.html#a789208ada7e17492cfd3a5a88a6bb0ee">hwloc_component::type</a></div><div class="ttdeci">hwloc_component_type_t type</div><div class="ttdoc">Component type.</div><div class="ttdef"><b>Definition</b> plugins.h:307</div></div>
+<div class="ttc" id="aa00373_html_ab8043c5b4cc0e81aabba586ccb194335"><div class="ttname"><a href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">hwloc_component::flags</a></div><div class="ttdeci">unsigned long flags</div><div class="ttdoc">Component flags, unused for now.</div><div class="ttdef"><b>Definition</b> plugins.h:310</div></div>
+<div class="ttc" id="aa00373_html_aea613546886d9b8221cadba920fe3ebc"><div class="ttname"><a href="a00373.html#aea613546886d9b8221cadba920fe3ebc">hwloc_component::init</a></div><div class="ttdeci">int(* init)(unsigned long flags)</div><div class="ttdoc">Process-wide component initialization callback.</div><div class="ttdef"><b>Definition</b> plugins.h:291</div></div>
+</div><!-- fragment --></div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00170.html 2.11.0-1/doc/doxygen-doc/html/a00170.html
--- 2.10.0-1/doc/doxygen-doc/html/a00170.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00170.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,54 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Error reporting in the API</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">Error reporting in the API</div></div>
+</div><!--header-->
+<div class="contents">
+<p>Most functions in the hwloc API return an integer value. Unless documentated differently, they return 0 on success and -1 on error. Functions that return a pointer type return <code>NULL</code> on error.</p>
+<p><code>errno</code> will be set to a meaningful value whenever possible. This includes the usual <code>EINVAL</code> when invalid function parameters are passed or <code>ENOMEM</code> when an internal allocation fails. Some specific <code>errno</code> value are also used, for instance for binding errors as documented in <a class="el" href="a00179.html">CPU binding</a>.</p>
+<p>Some modules describe return values of their functions in their introduction, for instance in <a class="el" href="a00194.html">The bitmap API</a>. </p>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00171.html 2.11.0-1/doc/doxygen-doc/html/a00171.html
--- 2.10.0-1/doc/doxygen-doc/html/a00171.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00171.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,127 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): API version</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#define-members">Macros</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">API version</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="define-members" name="define-members"></a>
+Macros</h2></td></tr>
+<tr class="memitem:ga8f4dfb8eef138af55dd1a0fa802e5476" id="r_ga8f4dfb8eef138af55dd1a0fa802e5476"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00171.html#ga8f4dfb8eef138af55dd1a0fa802e5476">HWLOC_API_VERSION</a>&#160;&#160;&#160;0x00020b00</td></tr>
+<tr class="separator:ga8f4dfb8eef138af55dd1a0fa802e5476"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaac5bc1f46f55e10ef0141a68ce70e21f" id="r_gaac5bc1f46f55e10ef0141a68ce70e21f"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00171.html#gaac5bc1f46f55e10ef0141a68ce70e21f">HWLOC_COMPONENT_ABI</a>&#160;&#160;&#160;7</td></tr>
+<tr class="separator:gaac5bc1f46f55e10ef0141a68ce70e21f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga9c0b50c98add1adf57ed1ce85bb5190d" id="r_ga9c0b50c98add1adf57ed1ce85bb5190d"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00171.html#ga9c0b50c98add1adf57ed1ce85bb5190d">hwloc_get_api_version</a> (void)</td></tr>
+<tr class="separator:ga9c0b50c98add1adf57ed1ce85bb5190d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Macro Definition Documentation</h2>
+<a id="ga8f4dfb8eef138af55dd1a0fa802e5476" name="ga8f4dfb8eef138af55dd1a0fa802e5476"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8f4dfb8eef138af55dd1a0fa802e5476">&#9670;&#160;</a></span>HWLOC_API_VERSION</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">#define HWLOC_API_VERSION&#160;&#160;&#160;0x00020b00</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Indicate at build time which hwloc API version is being used. </p>
+<p>This number is updated to (X&lt;&lt;16)+(Y&lt;&lt;8)+Z when a new release X.Y.Z actually modifies the API.</p>
+<p>Users may check for available features at build time using this number (see <a class="el" href="a00391.html#faq_version_api">How do I handle API changes?</a>).</p>
+<dl class="section note"><dt>Note</dt><dd>This should not be confused with HWLOC_VERSION, the library version. Two stable releases of the same series usually have the same <a class="el" href="a00171.html#ga8f4dfb8eef138af55dd1a0fa802e5476" title="Indicate at build time which hwloc API version is being used.">HWLOC_API_VERSION</a> even if their HWLOC_VERSION are different. </dd></dl>
+
+</div>
+</div>
+<a id="gaac5bc1f46f55e10ef0141a68ce70e21f" name="gaac5bc1f46f55e10ef0141a68ce70e21f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaac5bc1f46f55e10ef0141a68ce70e21f">&#9670;&#160;</a></span>HWLOC_COMPONENT_ABI</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">#define HWLOC_COMPONENT_ABI&#160;&#160;&#160;7</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Current component and plugin ABI version (see <a class="el" href="a00167_source.html">hwloc/plugins.h</a>) </p>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga9c0b50c98add1adf57ed1ce85bb5190d" name="ga9c0b50c98add1adf57ed1ce85bb5190d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9c0b50c98add1adf57ed1ce85bb5190d">&#9670;&#160;</a></span>hwloc_get_api_version()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_get_api_version </td>
+          <td>(</td>
+          <td class="paramtype">void&#160;</td>
+          <td class="paramname"></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Indicate at runtime which hwloc API version was used at build time. </p>
+<p>Should be <a class="el" href="a00171.html#ga8f4dfb8eef138af55dd1a0fa802e5476" title="Indicate at build time which hwloc API version is being used.">HWLOC_API_VERSION</a> if running on the same version.</p>
+<dl class="section return"><dt>Returns</dt><dd>the build-time version number. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00172.html 2.11.0-1/doc/doxygen-doc/html/a00172.html
--- 2.10.0-1/doc/doxygen-doc/html/a00172.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00172.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,138 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Object Sets (hwloc_cpuset_t and hwloc_nodeset_t)</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#typedef-members">Typedefs</a>  </div>
+  <div class="headertitle"><div class="title">Object Sets (hwloc_cpuset_t and hwloc_nodeset_t)</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="typedef-members" name="typedef-members"></a>
+Typedefs</h2></td></tr>
+<tr class="memitem:ga4bbf39b68b6f568fb92739e7c0ea7801" id="r_ga4bbf39b68b6f568fb92739e7c0ea7801"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></td></tr>
+<tr class="separator:ga4bbf39b68b6f568fb92739e7c0ea7801"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1f784433e9b606261f62d1134f6a3b25" id="r_ga1f784433e9b606261f62d1134f6a3b25"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a></td></tr>
+<tr class="separator:ga1f784433e9b606261f62d1134f6a3b25"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga37e35730fa7e775b5bb0afe893d6d508" id="r_ga37e35730fa7e775b5bb0afe893d6d508"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a></td></tr>
+<tr class="separator:ga37e35730fa7e775b5bb0afe893d6d508"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga2f5276235841ad66a79bedad16a5a10c" id="r_ga2f5276235841ad66a79bedad16a5a10c"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a></td></tr>
+<tr class="separator:ga2f5276235841ad66a79bedad16a5a10c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>Hwloc uses bitmaps to represent two distinct kinds of object sets: CPU sets (<a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801" title="A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.">hwloc_cpuset_t</a>) and NUMA node sets (<a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508" title="A node set is a bitmap whose bits are set according to NUMA memory node physical OS indexes.">hwloc_nodeset_t</a>). These types are both typedefs to a common back end type (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84" title="Set of bits represented as an opaque pointer to an internal bitmap.">hwloc_bitmap_t</a>), and therefore all the hwloc bitmap functions are applicable to both <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801" title="A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.">hwloc_cpuset_t</a> and <a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508" title="A node set is a bitmap whose bits are set according to NUMA memory node physical OS indexes.">hwloc_nodeset_t</a> (see <a class="el" href="a00194.html">The bitmap API</a>).</p>
+<p>The rationale for having two different types is that even though the actions one wants to perform on these types are the same (e.g., enable and disable individual items in the set/mask), they're used in very different contexts: one for specifying which processors to use and one for specifying which NUMA nodes to use. Hence, the name difference is really just to reflect the intent of where the type is used. </p>
+<h2 class="groupheader">Typedef Documentation</h2>
+<a id="ga1f784433e9b606261f62d1134f6a3b25" name="ga1f784433e9b606261f62d1134f6a3b25"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1f784433e9b606261f62d1134f6a3b25">&#9670;&#160;</a></span>hwloc_const_cpuset_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>A non-modifiable <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801" title="A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.">hwloc_cpuset_t</a>. </p>
+
+</div>
+</div>
+<a id="ga2f5276235841ad66a79bedad16a5a10c" name="ga2f5276235841ad66a79bedad16a5a10c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga2f5276235841ad66a79bedad16a5a10c">&#9670;&#160;</a></span>hwloc_const_nodeset_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> <a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>A non-modifiable <a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508" title="A node set is a bitmap whose bits are set according to NUMA memory node physical OS indexes.">hwloc_nodeset_t</a>. </p>
+
+</div>
+</div>
+<a id="ga4bbf39b68b6f568fb92739e7c0ea7801" name="ga4bbf39b68b6f568fb92739e7c0ea7801"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga4bbf39b68b6f568fb92739e7c0ea7801">&#9670;&#160;</a></span>hwloc_cpuset_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>A CPU set is a bitmap whose bits are set according to CPU physical OS indexes. </p>
+<p>It may be consulted and modified with the bitmap API as any <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84" title="Set of bits represented as an opaque pointer to an internal bitmap.">hwloc_bitmap_t</a> (see <a class="el" href="a00110_source.html">hwloc/bitmap.h</a>).</p>
+<p>Each bit may be converted into a PU object using <a class="el" href="a00189.html#ga751c238a4931db5cc0ca3181b7dd7479" title="Returns the object of type HWLOC_OBJ_PU with os_index.">hwloc_get_pu_obj_by_os_index()</a>. </p>
+
+</div>
+</div>
+<a id="ga37e35730fa7e775b5bb0afe893d6d508" name="ga37e35730fa7e775b5bb0afe893d6d508"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga37e35730fa7e775b5bb0afe893d6d508">&#9670;&#160;</a></span>hwloc_nodeset_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> <a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>A node set is a bitmap whose bits are set according to NUMA memory node physical OS indexes. </p>
+<p>It may be consulted and modified with the bitmap API as any <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84" title="Set of bits represented as an opaque pointer to an internal bitmap.">hwloc_bitmap_t</a> (see <a class="el" href="a00110_source.html">hwloc/bitmap.h</a>). Each bit may be converted into a NUMA node object using <a class="el" href="a00189.html#gab89d9ed9edfaa3dd526fb6ee1a1618ea" title="Returns the object of type HWLOC_OBJ_NUMANODE with os_index.">hwloc_get_numanode_obj_by_os_index()</a>.</p>
+<p>When binding memory on a system without any NUMA node, the single main memory bank is considered as NUMA node #0.</p>
+<p>See also <a class="el" href="a00192.html">Converting between CPU sets and node sets</a>. </p>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00173.html 2.11.0-1/doc/doxygen-doc/html/a00173.html
--- 2.10.0-1/doc/doxygen-doc/html/a00173.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00173.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,397 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Object Types</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#define-members">Macros</a> &#124;
+<a href="#typedef-members">Typedefs</a> &#124;
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Object Types</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="define-members" name="define-members"></a>
+Macros</h2></td></tr>
+<tr class="memitem:ga3b6e4128e9fe773863b123fa6e4a080b" id="r_ga3b6e4128e9fe773863b123fa6e4a080b"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00173.html#ga3b6e4128e9fe773863b123fa6e4a080b">HWLOC_TYPE_UNORDERED</a></td></tr>
+<tr class="separator:ga3b6e4128e9fe773863b123fa6e4a080b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="typedef-members" name="typedef-members"></a>
+Typedefs</h2></td></tr>
+<tr class="memitem:ga552ec74296a024237f474acec98694c0" id="r_ga552ec74296a024237f474acec98694c0"><td class="memItemLeft" align="right" valign="top">typedef enum <a class="el" href="a00173.html#ga791c9875c8fe20f3e1e5871e0657e59b">hwloc_obj_cache_type_e</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a></td></tr>
+<tr class="separator:ga552ec74296a024237f474acec98694c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gab34362c7a23296c3f12c5756747abda3" id="r_gab34362c7a23296c3f12c5756747abda3"><td class="memItemLeft" align="right" valign="top">typedef enum <a class="el" href="a00173.html#ga48a4803c72574191d7ead1c62aaf9860">hwloc_obj_bridge_type_e</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00173.html#gab34362c7a23296c3f12c5756747abda3">hwloc_obj_bridge_type_t</a></td></tr>
+<tr class="separator:gab34362c7a23296c3f12c5756747abda3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa9a6941ef7b1c169412518d7ef71b3d2" id="r_gaa9a6941ef7b1c169412518d7ef71b3d2"><td class="memItemLeft" align="right" valign="top">typedef enum <a class="el" href="a00173.html#ga64f5d539df299c97ae80ce53fc4b56c0">hwloc_obj_osdev_type_e</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00173.html#gaa9a6941ef7b1c169412518d7ef71b3d2">hwloc_obj_osdev_type_t</a></td></tr>
+<tr class="separator:gaa9a6941ef7b1c169412518d7ef71b3d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:gacd37bb612667dc437d66bfb175a8dc55" id="r_gacd37bb612667dc437d66bfb175a8dc55"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> { <br />
+&#160;&#160;<a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a3f4e83ffc4a259354959ae8a9eaa2a80">HWLOC_OBJ_MACHINE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ab16ab8c0dbffc234921d86f3dfb63129">HWLOC_OBJ_PACKAGE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ac793958f330bca371aa1535de8aff45f">HWLOC_OBJ_CORE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661">HWLOC_OBJ_PU</a>
+, <br />
+&#160;&#160;<a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a56389b8eb2e2f74f288bb657c4e72140">HWLOC_OBJ_L1CACHE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a18f61d19fe9f4bcea978fcc68bc078fb">HWLOC_OBJ_L2CACHE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a25fae0e0514c90e3973a29866a5a837d">HWLOC_OBJ_L3CACHE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a54923bfa13df9d7e6d6dd0d5baff5f72">HWLOC_OBJ_L4CACHE</a>
+, <br />
+&#160;&#160;<a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a67194c9de5e3e581c64c11d2eb1c109d">HWLOC_OBJ_L5CACHE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55afa834a85d9e53836cf0db6d0bd8329b4">HWLOC_OBJ_L1ICACHE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a10713b7e561b8cc32544cd31b1c17f8d">HWLOC_OBJ_L2ICACHE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ac22850c717f07bf7ffb316fadd08d218">HWLOC_OBJ_L3ICACHE</a>
+, <br />
+&#160;&#160;<a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56">HWLOC_OBJ_GROUP</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0">HWLOC_OBJ_BRIDGE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9">HWLOC_OBJ_PCI_DEVICE</a>
+, <br />
+&#160;&#160;<a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075">HWLOC_OBJ_OS_DEVICE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d">HWLOC_OBJ_MISC</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a0ed5bd98974729a0c476c39e917dabd6">HWLOC_OBJ_MEMCACHE</a>
+, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55af78bb6cde53aaaaa162a7dc420c409da">HWLOC_OBJ_DIE</a>
+, <br />
+&#160;&#160;<b>HWLOC_OBJ_TYPE_MAX</b>
+<br />
+ }</td></tr>
+<tr class="separator:gacd37bb612667dc437d66bfb175a8dc55"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga791c9875c8fe20f3e1e5871e0657e59b" id="r_ga791c9875c8fe20f3e1e5871e0657e59b"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00173.html#ga791c9875c8fe20f3e1e5871e0657e59b">hwloc_obj_cache_type_e</a> { <a class="el" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a">HWLOC_OBJ_CACHE_UNIFIED</a>
+, <a class="el" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59bacac60ecad4206f85aeb79bef1604b488">HWLOC_OBJ_CACHE_DATA</a>
+, <a class="el" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba6f98b0d422b38ba90c5f5c79a11b0658">HWLOC_OBJ_CACHE_INSTRUCTION</a>
+ }</td></tr>
+<tr class="separator:ga791c9875c8fe20f3e1e5871e0657e59b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga48a4803c72574191d7ead1c62aaf9860" id="r_ga48a4803c72574191d7ead1c62aaf9860"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00173.html#ga48a4803c72574191d7ead1c62aaf9860">hwloc_obj_bridge_type_e</a> { <a class="el" href="a00173.html#gga48a4803c72574191d7ead1c62aaf9860a2c7660f3864ad2810c1e72aad285e574">HWLOC_OBJ_BRIDGE_HOST</a>
+, <a class="el" href="a00173.html#gga48a4803c72574191d7ead1c62aaf9860a8f3b4cecf3dab6073d74696d10863c60">HWLOC_OBJ_BRIDGE_PCI</a>
+ }</td></tr>
+<tr class="separator:ga48a4803c72574191d7ead1c62aaf9860"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga64f5d539df299c97ae80ce53fc4b56c0" id="r_ga64f5d539df299c97ae80ce53fc4b56c0"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00173.html#ga64f5d539df299c97ae80ce53fc4b56c0">hwloc_obj_osdev_type_e</a> { <br />
+&#160;&#160;<a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a689b0488c3c0d08d116751c6b9cb8871">HWLOC_OBJ_OSDEV_BLOCK</a>
+, <a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90">HWLOC_OBJ_OSDEV_GPU</a>
+, <a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0ab715d81155f771573c8682dffc65021b">HWLOC_OBJ_OSDEV_NETWORK</a>
+, <a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a52157d03694fdae82dddd57ca8c973b6">HWLOC_OBJ_OSDEV_OPENFABRICS</a>
+, <br />
+&#160;&#160;<a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a827ad1643360711a8b6c6af671366791">HWLOC_OBJ_OSDEV_DMA</a>
+, <a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83">HWLOC_OBJ_OSDEV_COPROC</a>
+<br />
+ }</td></tr>
+<tr class="separator:ga64f5d539df299c97ae80ce53fc4b56c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga1820ea0dfd8e9dca28f9ea7624df5ae2" id="r_ga1820ea0dfd8e9dca28f9ea7624df5ae2"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00173.html#ga1820ea0dfd8e9dca28f9ea7624df5ae2">hwloc_compare_types</a> (<a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type1, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type2)</td></tr>
+<tr class="separator:ga1820ea0dfd8e9dca28f9ea7624df5ae2"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Macro Definition Documentation</h2>
+<a id="ga3b6e4128e9fe773863b123fa6e4a080b" name="ga3b6e4128e9fe773863b123fa6e4a080b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga3b6e4128e9fe773863b123fa6e4a080b">&#9670;&#160;</a></span>HWLOC_TYPE_UNORDERED</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">#define HWLOC_TYPE_UNORDERED</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Value returned by <a class="el" href="a00173.html#ga1820ea0dfd8e9dca28f9ea7624df5ae2" title="Compare the depth of two object types.">hwloc_compare_types()</a> when types can not be compared. </p>
+
+</div>
+</div>
+<h2 class="groupheader">Typedef Documentation</h2>
+<a id="gab34362c7a23296c3f12c5756747abda3" name="gab34362c7a23296c3f12c5756747abda3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab34362c7a23296c3f12c5756747abda3">&#9670;&#160;</a></span>hwloc_obj_bridge_type_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef enum <a class="el" href="a00173.html#ga48a4803c72574191d7ead1c62aaf9860">hwloc_obj_bridge_type_e</a> <a class="el" href="a00173.html#gab34362c7a23296c3f12c5756747abda3">hwloc_obj_bridge_type_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of one side (upstream or downstream) of an I/O bridge. </p>
+
+</div>
+</div>
+<a id="ga552ec74296a024237f474acec98694c0" name="ga552ec74296a024237f474acec98694c0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga552ec74296a024237f474acec98694c0">&#9670;&#160;</a></span>hwloc_obj_cache_type_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef enum <a class="el" href="a00173.html#ga791c9875c8fe20f3e1e5871e0657e59b">hwloc_obj_cache_type_e</a> <a class="el" href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Cache type. </p>
+
+</div>
+</div>
+<a id="gaa9a6941ef7b1c169412518d7ef71b3d2" name="gaa9a6941ef7b1c169412518d7ef71b3d2"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa9a6941ef7b1c169412518d7ef71b3d2">&#9670;&#160;</a></span>hwloc_obj_osdev_type_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef enum <a class="el" href="a00173.html#ga64f5d539df299c97ae80ce53fc4b56c0">hwloc_obj_osdev_type_e</a> <a class="el" href="a00173.html#gaa9a6941ef7b1c169412518d7ef71b3d2">hwloc_obj_osdev_type_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of a OS device. </p>
+
+</div>
+</div>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="ga48a4803c72574191d7ead1c62aaf9860" name="ga48a4803c72574191d7ead1c62aaf9860"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga48a4803c72574191d7ead1c62aaf9860">&#9670;&#160;</a></span>hwloc_obj_bridge_type_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00173.html#ga48a4803c72574191d7ead1c62aaf9860">hwloc_obj_bridge_type_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of one side (upstream or downstream) of an I/O bridge. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga48a4803c72574191d7ead1c62aaf9860a2c7660f3864ad2810c1e72aad285e574" name="gga48a4803c72574191d7ead1c62aaf9860a2c7660f3864ad2810c1e72aad285e574"></a>HWLOC_OBJ_BRIDGE_HOST&#160;</td><td class="fielddoc"><p>Host-side of a bridge, only possible upstream. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga48a4803c72574191d7ead1c62aaf9860a8f3b4cecf3dab6073d74696d10863c60" name="gga48a4803c72574191d7ead1c62aaf9860a8f3b4cecf3dab6073d74696d10863c60"></a>HWLOC_OBJ_BRIDGE_PCI&#160;</td><td class="fielddoc"><p>PCI-side of a bridge. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="ga791c9875c8fe20f3e1e5871e0657e59b" name="ga791c9875c8fe20f3e1e5871e0657e59b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga791c9875c8fe20f3e1e5871e0657e59b">&#9670;&#160;</a></span>hwloc_obj_cache_type_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00173.html#ga791c9875c8fe20f3e1e5871e0657e59b">hwloc_obj_cache_type_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Cache type. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a" name="gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a"></a>HWLOC_OBJ_CACHE_UNIFIED&#160;</td><td class="fielddoc"><p>Unified cache. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga791c9875c8fe20f3e1e5871e0657e59bacac60ecad4206f85aeb79bef1604b488" name="gga791c9875c8fe20f3e1e5871e0657e59bacac60ecad4206f85aeb79bef1604b488"></a>HWLOC_OBJ_CACHE_DATA&#160;</td><td class="fielddoc"><p>Data cache. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga791c9875c8fe20f3e1e5871e0657e59ba6f98b0d422b38ba90c5f5c79a11b0658" name="gga791c9875c8fe20f3e1e5871e0657e59ba6f98b0d422b38ba90c5f5c79a11b0658"></a>HWLOC_OBJ_CACHE_INSTRUCTION&#160;</td><td class="fielddoc"><p>Instruction cache (filtered out by default). </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="ga64f5d539df299c97ae80ce53fc4b56c0" name="ga64f5d539df299c97ae80ce53fc4b56c0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga64f5d539df299c97ae80ce53fc4b56c0">&#9670;&#160;</a></span>hwloc_obj_osdev_type_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00173.html#ga64f5d539df299c97ae80ce53fc4b56c0">hwloc_obj_osdev_type_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of a OS device. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga64f5d539df299c97ae80ce53fc4b56c0a689b0488c3c0d08d116751c6b9cb8871" name="gga64f5d539df299c97ae80ce53fc4b56c0a689b0488c3c0d08d116751c6b9cb8871"></a>HWLOC_OBJ_OSDEV_BLOCK&#160;</td><td class="fielddoc"><p>Operating system block device, or non-volatile memory device. For instance "sda" or "dax2.0" on Linux. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90" name="gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90"></a>HWLOC_OBJ_OSDEV_GPU&#160;</td><td class="fielddoc"><p>Operating system GPU device. For instance ":0.0" for a GL display, "card0" for a Linux DRM device. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga64f5d539df299c97ae80ce53fc4b56c0ab715d81155f771573c8682dffc65021b" name="gga64f5d539df299c97ae80ce53fc4b56c0ab715d81155f771573c8682dffc65021b"></a>HWLOC_OBJ_OSDEV_NETWORK&#160;</td><td class="fielddoc"><p>Operating system network device. For instance the "eth0" interface on Linux. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga64f5d539df299c97ae80ce53fc4b56c0a52157d03694fdae82dddd57ca8c973b6" name="gga64f5d539df299c97ae80ce53fc4b56c0a52157d03694fdae82dddd57ca8c973b6"></a>HWLOC_OBJ_OSDEV_OPENFABRICS&#160;</td><td class="fielddoc"><p>Operating system openfabrics device. For instance the "mlx4_0" InfiniBand HCA, "hfi1_0" Omni-Path interface, or "bxi0" Atos/Bull BXI HCA on Linux. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga64f5d539df299c97ae80ce53fc4b56c0a827ad1643360711a8b6c6af671366791" name="gga64f5d539df299c97ae80ce53fc4b56c0a827ad1643360711a8b6c6af671366791"></a>HWLOC_OBJ_OSDEV_DMA&#160;</td><td class="fielddoc"><p>Operating system dma engine device. For instance the "dma0chan0" DMA channel on Linux. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83" name="gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83"></a>HWLOC_OBJ_OSDEV_COPROC&#160;</td><td class="fielddoc"><p>Operating system co-processor device. For instance "opencl0d0" for a OpenCL device, "cuda0" for a CUDA device. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="gacd37bb612667dc437d66bfb175a8dc55" name="gacd37bb612667dc437d66bfb175a8dc55"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gacd37bb612667dc437d66bfb175a8dc55">&#9670;&#160;</a></span>hwloc_obj_type_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of topology object. </p>
+<dl class="section note"><dt>Note</dt><dd>Do not rely on the ordering or completeness of the values as new ones may be defined in the future! If you need to compare types, use <a class="el" href="a00173.html#ga1820ea0dfd8e9dca28f9ea7624df5ae2" title="Compare the depth of two object types.">hwloc_compare_types()</a> instead. </dd></dl>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a3f4e83ffc4a259354959ae8a9eaa2a80" name="ggacd37bb612667dc437d66bfb175a8dc55a3f4e83ffc4a259354959ae8a9eaa2a80"></a>HWLOC_OBJ_MACHINE&#160;</td><td class="fielddoc"><p>Machine. A set of processors and memory with cache coherency. </p>
+<p>This type is always used for the root object of a topology, and never used anywhere else. Hence its parent is always <code>NULL</code>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55ab16ab8c0dbffc234921d86f3dfb63129" name="ggacd37bb612667dc437d66bfb175a8dc55ab16ab8c0dbffc234921d86f3dfb63129"></a>HWLOC_OBJ_PACKAGE&#160;</td><td class="fielddoc"><p>Physical package. The physical package that usually gets inserted into a socket on the motherboard. A processor package usually contains multiple cores, and possibly some dies. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55ac793958f330bca371aa1535de8aff45f" name="ggacd37bb612667dc437d66bfb175a8dc55ac793958f330bca371aa1535de8aff45f"></a>HWLOC_OBJ_CORE&#160;</td><td class="fielddoc"><p>Core. A computation unit (may be shared by several PUs, aka logical processors). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661" name="ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661"></a>HWLOC_OBJ_PU&#160;</td><td class="fielddoc"><p>Processing Unit, or (Logical) Processor. An execution unit (may share a core with some other logical processors, e.g. in the case of an SMT core). </p>
+<p>This is the smallest object representing CPU resources, it cannot have any child except Misc objects.</p>
+<p>Objects of this kind are always reported and can thus be used as fallback when others are not. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a56389b8eb2e2f74f288bb657c4e72140" name="ggacd37bb612667dc437d66bfb175a8dc55a56389b8eb2e2f74f288bb657c4e72140"></a>HWLOC_OBJ_L1CACHE&#160;</td><td class="fielddoc"><p>Level 1 Data (or Unified) Cache. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a18f61d19fe9f4bcea978fcc68bc078fb" name="ggacd37bb612667dc437d66bfb175a8dc55a18f61d19fe9f4bcea978fcc68bc078fb"></a>HWLOC_OBJ_L2CACHE&#160;</td><td class="fielddoc"><p>Level 2 Data (or Unified) Cache. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a25fae0e0514c90e3973a29866a5a837d" name="ggacd37bb612667dc437d66bfb175a8dc55a25fae0e0514c90e3973a29866a5a837d"></a>HWLOC_OBJ_L3CACHE&#160;</td><td class="fielddoc"><p>Level 3 Data (or Unified) Cache. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a54923bfa13df9d7e6d6dd0d5baff5f72" name="ggacd37bb612667dc437d66bfb175a8dc55a54923bfa13df9d7e6d6dd0d5baff5f72"></a>HWLOC_OBJ_L4CACHE&#160;</td><td class="fielddoc"><p>Level 4 Data (or Unified) Cache. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a67194c9de5e3e581c64c11d2eb1c109d" name="ggacd37bb612667dc437d66bfb175a8dc55a67194c9de5e3e581c64c11d2eb1c109d"></a>HWLOC_OBJ_L5CACHE&#160;</td><td class="fielddoc"><p>Level 5 Data (or Unified) Cache. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55afa834a85d9e53836cf0db6d0bd8329b4" name="ggacd37bb612667dc437d66bfb175a8dc55afa834a85d9e53836cf0db6d0bd8329b4"></a>HWLOC_OBJ_L1ICACHE&#160;</td><td class="fielddoc"><p>Level 1 instruction Cache (filtered out by default). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a10713b7e561b8cc32544cd31b1c17f8d" name="ggacd37bb612667dc437d66bfb175a8dc55a10713b7e561b8cc32544cd31b1c17f8d"></a>HWLOC_OBJ_L2ICACHE&#160;</td><td class="fielddoc"><p>Level 2 instruction Cache (filtered out by default). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55ac22850c717f07bf7ffb316fadd08d218" name="ggacd37bb612667dc437d66bfb175a8dc55ac22850c717f07bf7ffb316fadd08d218"></a>HWLOC_OBJ_L3ICACHE&#160;</td><td class="fielddoc"><p>Level 3 instruction Cache (filtered out by default). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56" name="ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56"></a>HWLOC_OBJ_GROUP&#160;</td><td class="fielddoc"><p>Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take into account for affinity. For instance, some operating systems expose their arbitrary processors aggregation this way. And hwloc may insert such objects to group NUMA nodes according to their distances. See also <a class="el" href="a00391.html#faq_groups">What are these Group objects in my topology?</a>. </p>
+<p>These objects are removed when they do not bring any structure (see <a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4" title="Only ignore objects if their entire level does not bring any structure.">HWLOC_TYPE_FILTER_KEEP_STRUCTURE</a>). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a" name="ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a"></a>HWLOC_OBJ_NUMANODE&#160;</td><td class="fielddoc"><p>NUMA node. An object that contains memory that is directly and byte-accessible to the host processors. It is usually close to some cores (the corresponding objects are descendants of the NUMA node object in the hwloc tree). </p>
+<p>This is the smallest object representing Memory resources, it cannot have any child except Misc objects. However it may have Memory-side cache parents.</p>
+<p>NUMA nodes may correspond to different kinds of memory (DRAM, HBM, CXL-DRAM, etc.). When hwloc is able to guess that kind, it is specified in the subtype field of the object. See also <a class="el" href="a00382.html#attributes_normal">Normal attributes</a> in the main documentation.</p>
+<p>There is always at least one such object in the topology even if the machine is not NUMA.</p>
+<p>Memory objects are not listed in the main children list, but rather in the dedicated Memory children list.</p>
+<p>NUMA nodes have a special depth <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a245c34ec9884c2cf5de5049b2153ed9c" title="Virtual depth for NUMA nodes.">HWLOC_TYPE_DEPTH_NUMANODE</a> instead of a normal depth just like other objects in the main tree. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0" name="ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0"></a>HWLOC_OBJ_BRIDGE&#160;</td><td class="fielddoc"><p>Bridge (filtered out by default). Any bridge (or PCI switch) that connects the host or an I/O bus, to another I/O bus. </p>
+<p>Bridges are not added to the topology unless their filtering is changed (see <a class="el" href="a00182.html#gad894e70f15f8d4aada7be8d1aba38b7e" title="Set the filtering for the given object type.">hwloc_topology_set_type_filter()</a> and <a class="el" href="a00182.html#ga0ab38705357bc1203abe829da8a12ad3" title="Set the filtering for all I/O object types.">hwloc_topology_set_io_types_filter()</a>).</p>
+<p>I/O objects are not listed in the main children list, but rather in the dedicated io children list. I/O objects have NULL CPU and node sets. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9" name="ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9"></a>HWLOC_OBJ_PCI_DEVICE&#160;</td><td class="fielddoc"><p>PCI device (filtered out by default). </p>
+<p>PCI devices are not added to the topology unless their filtering is changed (see <a class="el" href="a00182.html#gad894e70f15f8d4aada7be8d1aba38b7e" title="Set the filtering for the given object type.">hwloc_topology_set_type_filter()</a> and <a class="el" href="a00182.html#ga0ab38705357bc1203abe829da8a12ad3" title="Set the filtering for all I/O object types.">hwloc_topology_set_io_types_filter()</a>).</p>
+<p>I/O objects are not listed in the main children list, but rather in the dedicated io children list. I/O objects have NULL CPU and node sets. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075" name="ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075"></a>HWLOC_OBJ_OS_DEVICE&#160;</td><td class="fielddoc"><p>Operating system device (filtered out by default). </p>
+<p>OS devices are not added to the topology unless their filtering is changed (see <a class="el" href="a00182.html#gad894e70f15f8d4aada7be8d1aba38b7e" title="Set the filtering for the given object type.">hwloc_topology_set_type_filter()</a> and <a class="el" href="a00182.html#ga0ab38705357bc1203abe829da8a12ad3" title="Set the filtering for all I/O object types.">hwloc_topology_set_io_types_filter()</a>).</p>
+<p>I/O objects are not listed in the main children list, but rather in the dedicated io children list. I/O objects have NULL CPU and node sets. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d" name="ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d"></a>HWLOC_OBJ_MISC&#160;</td><td class="fielddoc"><p>Miscellaneous objects (filtered out by default). Objects without particular meaning, that can e.g. be added by the application for its own use, or by hwloc for miscellaneous objects such as MemoryModule (DIMMs). </p>
+<p>They are not added to the topology unless their filtering is changed (see <a class="el" href="a00182.html#gad894e70f15f8d4aada7be8d1aba38b7e" title="Set the filtering for the given object type.">hwloc_topology_set_type_filter()</a>).</p>
+<p>These objects are not listed in the main children list, but rather in the dedicated misc children list. Misc objects may only have Misc objects as children, and those are in the dedicated misc children list as well. Misc objects have NULL CPU and node sets. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55a0ed5bd98974729a0c476c39e917dabd6" name="ggacd37bb612667dc437d66bfb175a8dc55a0ed5bd98974729a0c476c39e917dabd6"></a>HWLOC_OBJ_MEMCACHE&#160;</td><td class="fielddoc"><p>Memory-side cache (filtered out by default). A cache in front of a specific NUMA node. </p>
+<p>This object always has at least one NUMA node as a memory child.</p>
+<p>Memory objects are not listed in the main children list, but rather in the dedicated Memory children list.</p>
+<p>Memory-side cache have a special depth <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a8b8d7d300c018c0eb65e6c9a9f162101" title="Virtual depth for MemCache object.">HWLOC_TYPE_DEPTH_MEMCACHE</a> instead of a normal depth just like other objects in the main tree. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggacd37bb612667dc437d66bfb175a8dc55af78bb6cde53aaaaa162a7dc420c409da" name="ggacd37bb612667dc437d66bfb175a8dc55af78bb6cde53aaaaa162a7dc420c409da"></a>HWLOC_OBJ_DIE&#160;</td><td class="fielddoc"><p>Die within a physical package. A subpart of the physical package, that contains multiple cores. </p>
+<p>Some operating systems (e.g. Linux) may expose a single die per package even if the hardware does not support dies at all. To avoid showing such non-existing dies, the corresponding hwloc backend may filter them out. This is functionally equivalent to <a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4" title="Only ignore objects if their entire level does not bring any structure.">HWLOC_TYPE_FILTER_KEEP_STRUCTURE</a> being enforced. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga1820ea0dfd8e9dca28f9ea7624df5ae2" name="ga1820ea0dfd8e9dca28f9ea7624df5ae2"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1820ea0dfd8e9dca28f9ea7624df5ae2">&#9670;&#160;</a></span>hwloc_compare_types()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_compare_types </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type2</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Compare the depth of two object types. </p>
+<p>Types shouldn't be compared as they are, since newer ones may be added in the future.</p>
+<dl class="section return"><dt>Returns</dt><dd>A negative integer if <code>type1</code> objects usually include <code>type2</code> objects. </dd>
+<dd>
+A positive integer if <code>type1</code> objects are usually included in <code>type2</code> objects. </dd>
+<dd>
+0 if <code>type1</code> and <code>type2</code> objects are the same. </dd>
+<dd>
+<a class="el" href="a00173.html#ga3b6e4128e9fe773863b123fa6e4a080b" title="Value returned by hwloc_compare_types() when types can not be compared.">HWLOC_TYPE_UNORDERED</a> if objects cannot be compared (because neither is usually contained in the other).</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Object types containing CPUs can always be compared (usually, a machine contains packages, which contain caches, which contain cores, which contain PUs).</dd>
+<dd>
+<a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661" title="Processing Unit, or (Logical) Processor. An execution unit (may share a core with some other logical ...">HWLOC_OBJ_PU</a> will always be the deepest, while <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a3f4e83ffc4a259354959ae8a9eaa2a80" title="Machine. A set of processors and memory with cache coherency.">HWLOC_OBJ_MACHINE</a> is always the highest.</dd>
+<dd>
+This does not mean that the actual topology will respect that order: e.g. as of today cores may also contain caches, and packages may also contain nodes. This is thus just to be seen as a fallback comparison method. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00174.html 2.11.0-1/doc/doxygen-doc/html/a00174.html
--- 2.10.0-1/doc/doxygen-doc/html/a00174.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00174.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,87 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Object Structure and Attributes</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#typedef-members">Typedefs</a>  </div>
+  <div class="headertitle"><div class="title">Object Structure and Attributes</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html">hwloc_obj</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">union &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00233.html">hwloc_obj_attr_u</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00277.html">hwloc_info_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="typedef-members" name="typedef-members"></a>
+Typedefs</h2></td></tr>
+<tr class="memitem:ga79b8ab56877ef99ac59b833203391c7d" id="r_ga79b8ab56877ef99ac59b833203391c7d"><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a></td></tr>
+<tr class="separator:ga79b8ab56877ef99ac59b833203391c7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Typedef Documentation</h2>
+<a id="ga79b8ab56877ef99ac59b833203391c7d" name="ga79b8ab56877ef99ac59b833203391c7d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga79b8ab56877ef99ac59b833203391c7d">&#9670;&#160;</a></span>hwloc_obj_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef struct <a class="el" href="a00229.html">hwloc_obj</a>* <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Convenience typedef; a pointer to a struct <a class="el" href="a00229.html" title="Structure of a topology object.">hwloc_obj</a>. </p>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00175.html 2.11.0-1/doc/doxygen-doc/html/a00175.html
--- 2.10.0-1/doc/doxygen-doc/html/a00175.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00175.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,272 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Topology Creation and Destruction</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#typedef-members">Typedefs</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Topology Creation and Destruction</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="typedef-members" name="typedef-members"></a>
+Typedefs</h2></td></tr>
+<tr class="memitem:ga9d1e76ee15a7dee158b786c30b6a6e38" id="r_ga9d1e76ee15a7dee158b786c30b6a6e38"><td class="memItemLeft" align="right" valign="top">typedef struct hwloc_topology *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></td></tr>
+<tr class="separator:ga9d1e76ee15a7dee158b786c30b6a6e38"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa" id="r_ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa">hwloc_topology_init</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> *topologyp)</td></tr>
+<tr class="separator:ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gabdf58d87ad77f6615fccdfe0535ff826" id="r_gabdf58d87ad77f6615fccdfe0535ff826"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826">hwloc_topology_load</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:gabdf58d87ad77f6615fccdfe0535ff826"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga9f34a640b6fd28d23699d4d084667b15" id="r_ga9f34a640b6fd28d23699d4d084667b15"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00175.html#ga9f34a640b6fd28d23699d4d084667b15">hwloc_topology_destroy</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:ga9f34a640b6fd28d23699d4d084667b15"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga62a161fc5e6f120344dc69a7bee4e587" id="r_ga62a161fc5e6f120344dc69a7bee4e587"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00175.html#ga62a161fc5e6f120344dc69a7bee4e587">hwloc_topology_dup</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> *newtopology, <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> oldtopology)</td></tr>
+<tr class="separator:ga62a161fc5e6f120344dc69a7bee4e587"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga0647ae66458fe68172eb5a320042f870" id="r_ga0647ae66458fe68172eb5a320042f870"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00175.html#ga0647ae66458fe68172eb5a320042f870">hwloc_topology_abi_check</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:ga0647ae66458fe68172eb5a320042f870"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaf6746bc3a558ef1ac8348b4491d091b5" id="r_gaf6746bc3a558ef1ac8348b4491d091b5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00175.html#gaf6746bc3a558ef1ac8348b4491d091b5">hwloc_topology_check</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:gaf6746bc3a558ef1ac8348b4491d091b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Typedef Documentation</h2>
+<a id="ga9d1e76ee15a7dee158b786c30b6a6e38" name="ga9d1e76ee15a7dee158b786c30b6a6e38"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9d1e76ee15a7dee158b786c30b6a6e38">&#9670;&#160;</a></span>hwloc_topology_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef struct hwloc_topology* <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Topology context. </p>
+<p>To be initialized with <a class="el" href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa" title="Allocate a topology context.">hwloc_topology_init()</a> and built with <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>. </p>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga0647ae66458fe68172eb5a320042f870" name="ga0647ae66458fe68172eb5a320042f870"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga0647ae66458fe68172eb5a320042f870">&#9670;&#160;</a></span>hwloc_topology_abi_check()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_abi_check </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Verify that the topology is compatible with the current hwloc library. </p>
+<p>This is useful when using the same topology structure (in memory) in different libraries that may use different hwloc installations (for instance if one library embeds a specific version of hwloc, while another library uses a default system-wide hwloc installation).</p>
+<p>If all libraries/programs use the same hwloc installation, this function always returns success.</p>
+<dl class="section return"><dt>Returns</dt><dd><code>0</code> on success.</dd>
+<dd>
+<code>-1</code> with <code>errno</code> set to <code>EINVAL</code> if incompatible.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>If sharing between processes with <a class="el" href="a00218.html#ga61b20e346fc76f76420e3a88cc80a671" title="Duplicate a topology to a shared memory file.">hwloc_shmem_topology_write()</a>, the relevant check is already performed inside <a class="el" href="a00218.html#ga21545bd0f09d9b554c8e60a630e0e629" title="Adopt a shared memory topology stored in a file.">hwloc_shmem_topology_adopt()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="gaf6746bc3a558ef1ac8348b4491d091b5" name="gaf6746bc3a558ef1ac8348b4491d091b5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf6746bc3a558ef1ac8348b4491d091b5">&#9670;&#160;</a></span>hwloc_topology_check()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_topology_check </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Run internal checks on a topology structure. </p>
+<p>The program aborts if an inconsistency is detected in the given topology.</p>
+<dl class="params"><dt>Parameters</dt><dd>
+  <table class="params">
+    <tr><td class="paramname">topology</td><td>is the topology to be checked</td></tr>
+  </table>
+  </dd>
+</dl>
+<dl class="section note"><dt>Note</dt><dd>This routine is only useful to developers.</dd>
+<dd>
+The input topology should have been previously loaded with <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="ga9f34a640b6fd28d23699d4d084667b15" name="ga9f34a640b6fd28d23699d4d084667b15"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9f34a640b6fd28d23699d4d084667b15">&#9670;&#160;</a></span>hwloc_topology_destroy()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_topology_destroy </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Terminate and free a topology context. </p>
+<dl class="params"><dt>Parameters</dt><dd>
+  <table class="params">
+    <tr><td class="paramname">topology</td><td>is the topology to be freed </td></tr>
+  </table>
+  </dd>
+</dl>
+
+</div>
+</div>
+<a id="ga62a161fc5e6f120344dc69a7bee4e587" name="ga62a161fc5e6f120344dc69a7bee4e587"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga62a161fc5e6f120344dc69a7bee4e587">&#9670;&#160;</a></span>hwloc_topology_dup()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_dup </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> *&#160;</td>
+          <td class="paramname"><em>newtopology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>oldtopology</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Duplicate a topology. </p>
+<p>The entire topology structure as well as its objects are duplicated into a new one.</p>
+<p>This is useful for keeping a backup while modifying a topology.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Object userdata is not duplicated since hwloc does not know what it point to. The objects of both old and new topologies will point to the same userdata. </dd></dl>
+
+</div>
+</div>
+<a id="ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa" name="ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa">&#9670;&#160;</a></span>hwloc_topology_init()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_init </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> *&#160;</td>
+          <td class="paramname"><em>topologyp</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Allocate a topology context. </p>
+<dl class="params"><dt>Parameters</dt><dd>
+  <table class="params">
+    <tr><td class="paramdir">[out]</td><td class="paramname">topologyp</td><td>is assigned a pointer to the new allocated context.</td></tr>
+  </table>
+  </dd>
+</dl>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gabdf58d87ad77f6615fccdfe0535ff826" name="gabdf58d87ad77f6615fccdfe0535ff826"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gabdf58d87ad77f6615fccdfe0535ff826">&#9670;&#160;</a></span>hwloc_topology_load()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_load </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Build the actual topology. </p>
+<p>Build the actual topology once initialized with <a class="el" href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa" title="Allocate a topology context.">hwloc_topology_init()</a> and tuned with <a class="el" href="a00182.html">Topology Detection Configuration and Query</a> and <a class="el" href="a00181.html">Changing the Source of Topology Discovery</a> routines. No other routine may be called earlier using this topology context.</p>
+<dl class="params"><dt>Parameters</dt><dd>
+  <table class="params">
+    <tr><td class="paramname">topology</td><td>is the topology to be loaded with objects.</td></tr>
+  </table>
+  </dd>
+</dl>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>On failure, the topology is reinitialized. It should be either destroyed with <a class="el" href="a00175.html#ga9f34a640b6fd28d23699d4d084667b15" title="Terminate and free a topology context.">hwloc_topology_destroy()</a> or configured and loaded again.</dd>
+<dd>
+This function may be called only once per topology.</dd>
+<dd>
+The binding of the current thread or process may temporarily change during this call but it will be restored before it returns.</dd></dl>
+<dl class="section see"><dt>See also</dt><dd><a class="el" href="a00182.html">Topology Detection Configuration and Query</a> and <a class="el" href="a00181.html">Changing the Source of Topology Discovery</a> </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00176.html 2.11.0-1/doc/doxygen-doc/html/a00176.html
--- 2.10.0-1/doc/doxygen-doc/html/a00176.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00176.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,635 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Object levels, depths and types</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Object levels, depths and types</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:gaf4e663cf42bbe20756b849c6293ef575" id="r_gaf4e663cf42bbe20756b849c6293ef575"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#gaf4e663cf42bbe20756b849c6293ef575">hwloc_get_type_depth_e</a> { <br />
+&#160;&#160;<a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a>
+, <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c">HWLOC_TYPE_DEPTH_MULTIPLE</a>
+, <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a245c34ec9884c2cf5de5049b2153ed9c">HWLOC_TYPE_DEPTH_NUMANODE</a>
+, <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575af93b50182973e4a718d9d4db9e253a90">HWLOC_TYPE_DEPTH_BRIDGE</a>
+, <br />
+&#160;&#160;<a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ad8b1516e699b57ce1c8d107fbd2f674c">HWLOC_TYPE_DEPTH_PCI_DEVICE</a>
+, <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575afe9a2131073eebbe129d4aa2928d3f46">HWLOC_TYPE_DEPTH_OS_DEVICE</a>
+, <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a96436a392b4cdcaa1a29bc65351b373f">HWLOC_TYPE_DEPTH_MISC</a>
+, <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a8b8d7d300c018c0eb65e6c9a9f162101">HWLOC_TYPE_DEPTH_MEMCACHE</a>
+<br />
+ }</td></tr>
+<tr class="separator:gaf4e663cf42bbe20756b849c6293ef575"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gae54d1782ca9b54bea915f5c18a9158fa" id="r_gae54d1782ca9b54bea915f5c18a9158fa"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#gae54d1782ca9b54bea915f5c18a9158fa">hwloc_topology_get_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict topology)</td></tr>
+<tr class="separator:gae54d1782ca9b54bea915f5c18a9158fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga8bec782e21be313750da70cf7428b374" id="r_ga8bec782e21be313750da70cf7428b374"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga8bec782e21be313750da70cf7428b374"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gae85786340b88e24835f8c403a1e2e54b" id="r_gae85786340b88e24835f8c403a1e2e54b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#gae85786340b88e24835f8c403a1e2e54b">hwloc_get_memory_parents_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:gae85786340b88e24835f8c403a1e2e54b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga8125328e69eba709c33ea8055c12589b" id="r_ga8125328e69eba709c33ea8055c12589b"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#ga8125328e69eba709c33ea8055c12589b">hwloc_get_type_or_below_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga8125328e69eba709c33ea8055c12589b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga8a9ee573b7d2190272095d10712a7cca" id="r_ga8a9ee573b7d2190272095d10712a7cca"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#ga8a9ee573b7d2190272095d10712a7cca">hwloc_get_type_or_above_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga8a9ee573b7d2190272095d10712a7cca"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga506b0682b98aa264d53e934d2e9badb0" id="r_ga506b0682b98aa264d53e934d2e9badb0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#ga506b0682b98aa264d53e934d2e9badb0">hwloc_get_depth_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int depth)</td></tr>
+<tr class="separator:ga506b0682b98aa264d53e934d2e9badb0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1d5ceafe8130fe6e8657bf0bc666ba50" id="r_ga1d5ceafe8130fe6e8657bf0bc666ba50"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#ga1d5ceafe8130fe6e8657bf0bc666ba50">hwloc_get_nbobjs_by_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int depth)</td></tr>
+<tr class="separator:ga1d5ceafe8130fe6e8657bf0bc666ba50"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga789a3f65aedff644be64a18526a03065" id="r_ga789a3f65aedff644be64a18526a03065"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#ga789a3f65aedff644be64a18526a03065">hwloc_get_nbobjs_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga789a3f65aedff644be64a18526a03065"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga2d4b12fc187dfc53b35f2fa21d21044d" id="r_ga2d4b12fc187dfc53b35f2fa21d21044d"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#ga2d4b12fc187dfc53b35f2fa21d21044d">hwloc_get_root_obj</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:ga2d4b12fc187dfc53b35f2fa21d21044d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga391f6b2613f0065673eaa4069b93d4e0" id="r_ga391f6b2613f0065673eaa4069b93d4e0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0">hwloc_get_obj_by_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int depth, unsigned idx)</td></tr>
+<tr class="separator:ga391f6b2613f0065673eaa4069b93d4e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga6f414dd80a2b943967a0ac92da3181a2" id="r_ga6f414dd80a2b943967a0ac92da3181a2"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#ga6f414dd80a2b943967a0ac92da3181a2">hwloc_get_obj_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, unsigned idx)</td></tr>
+<tr class="separator:ga6f414dd80a2b943967a0ac92da3181a2"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac140a9b939d9fa0b30c4a910efcb0656" id="r_gac140a9b939d9fa0b30c4a910efcb0656"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#gac140a9b939d9fa0b30c4a910efcb0656">hwloc_get_next_obj_by_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int depth, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> prev)</td></tr>
+<tr class="separator:gac140a9b939d9fa0b30c4a910efcb0656"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga759e88eaf5a230ad283e9d4c42486735" id="r_ga759e88eaf5a230ad283e9d4c42486735"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735">hwloc_get_next_obj_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> prev)</td></tr>
+<tr class="separator:ga759e88eaf5a230ad283e9d4c42486735"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>Be sure to see the figure in <a class="el" href="a00376.html">Terms and Definitions</a> that shows a complete topology tree, including depths, child/sibling/cousin relationships, and an example of an asymmetric topology where one package has fewer caches than its peers. </p>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="gaf4e663cf42bbe20756b849c6293ef575" name="gaf4e663cf42bbe20756b849c6293ef575"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf4e663cf42bbe20756b849c6293ef575">&#9670;&#160;</a></span>hwloc_get_type_depth_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00176.html#gaf4e663cf42bbe20756b849c6293ef575">hwloc_get_type_depth_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad" name="ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad"></a>HWLOC_TYPE_DEPTH_UNKNOWN&#160;</td><td class="fielddoc"><p>No object of given type exists in the topology. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c" name="ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c"></a>HWLOC_TYPE_DEPTH_MULTIPLE&#160;</td><td class="fielddoc"><p>Objects of given type exist at different depth in the topology (only for Groups). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggaf4e663cf42bbe20756b849c6293ef575a245c34ec9884c2cf5de5049b2153ed9c" name="ggaf4e663cf42bbe20756b849c6293ef575a245c34ec9884c2cf5de5049b2153ed9c"></a>HWLOC_TYPE_DEPTH_NUMANODE&#160;</td><td class="fielddoc"><p>Virtual depth for NUMA nodes. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggaf4e663cf42bbe20756b849c6293ef575af93b50182973e4a718d9d4db9e253a90" name="ggaf4e663cf42bbe20756b849c6293ef575af93b50182973e4a718d9d4db9e253a90"></a>HWLOC_TYPE_DEPTH_BRIDGE&#160;</td><td class="fielddoc"><p>Virtual depth for bridge object level. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggaf4e663cf42bbe20756b849c6293ef575ad8b1516e699b57ce1c8d107fbd2f674c" name="ggaf4e663cf42bbe20756b849c6293ef575ad8b1516e699b57ce1c8d107fbd2f674c"></a>HWLOC_TYPE_DEPTH_PCI_DEVICE&#160;</td><td class="fielddoc"><p>Virtual depth for PCI device object level. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggaf4e663cf42bbe20756b849c6293ef575afe9a2131073eebbe129d4aa2928d3f46" name="ggaf4e663cf42bbe20756b849c6293ef575afe9a2131073eebbe129d4aa2928d3f46"></a>HWLOC_TYPE_DEPTH_OS_DEVICE&#160;</td><td class="fielddoc"><p>Virtual depth for software device object level. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggaf4e663cf42bbe20756b849c6293ef575a96436a392b4cdcaa1a29bc65351b373f" name="ggaf4e663cf42bbe20756b849c6293ef575a96436a392b4cdcaa1a29bc65351b373f"></a>HWLOC_TYPE_DEPTH_MISC&#160;</td><td class="fielddoc"><p>Virtual depth for Misc object. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggaf4e663cf42bbe20756b849c6293ef575a8b8d7d300c018c0eb65e6c9a9f162101" name="ggaf4e663cf42bbe20756b849c6293ef575a8b8d7d300c018c0eb65e6c9a9f162101"></a>HWLOC_TYPE_DEPTH_MEMCACHE&#160;</td><td class="fielddoc"><p>Virtual depth for MemCache object. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga506b0682b98aa264d53e934d2e9badb0" name="ga506b0682b98aa264d53e934d2e9badb0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga506b0682b98aa264d53e934d2e9badb0">&#9670;&#160;</a></span>hwloc_get_depth_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> hwloc_get_depth_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>depth</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Returns the type of objects at depth <code>depth</code>. </p>
+<p><code>depth</code> should between 0 and <a class="el" href="a00176.html#gae54d1782ca9b54bea915f5c18a9158fa" title="Get the depth of the hierarchical tree of objects.">hwloc_topology_get_depth()</a>-1, or a virtual depth such as <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a245c34ec9884c2cf5de5049b2153ed9c" title="Virtual depth for NUMA nodes.">HWLOC_TYPE_DEPTH_NUMANODE</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>The type of objects at depth <code>depth</code>. </dd>
+<dd>
+(hwloc_obj_type_t)-1 if depth <code>depth</code> does not exist. </dd></dl>
+
+</div>
+</div>
+<a id="gae85786340b88e24835f8c403a1e2e54b" name="gae85786340b88e24835f8c403a1e2e54b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gae85786340b88e24835f8c403a1e2e54b">&#9670;&#160;</a></span>hwloc_get_memory_parents_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_memory_parents_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return the depth of parents where memory objects are attached. </p>
+<p>Memory objects have virtual negative depths because they are not part of the main CPU-side hierarchy of objects. This depth should not be compared with other level depths.</p>
+<p>If all Memory objects are attached to Normal parents at the same depth, this parent depth may be compared to other as usual, for instance for knowing whether NUMA nodes is attached above or below Packages.</p>
+<dl class="section return"><dt>Returns</dt><dd>The depth of Normal parents of all memory children if all these parents have the same depth. For instance the depth of the Package level if all NUMA nodes are attached to Package objects.</dd>
+<dd>
+<a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c" title="Objects of given type exist at different depth in the topology (only for Groups).">HWLOC_TYPE_DEPTH_MULTIPLE</a> if Normal parents of all memory children do not have the same depth. For instance if some NUMA nodes are attached to Packages while others are attached to Groups. </dd></dl>
+
+</div>
+</div>
+<a id="ga1d5ceafe8130fe6e8657bf0bc666ba50" name="ga1d5ceafe8130fe6e8657bf0bc666ba50"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1d5ceafe8130fe6e8657bf0bc666ba50">&#9670;&#160;</a></span>hwloc_get_nbobjs_by_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_get_nbobjs_by_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>depth</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Returns the width of level at depth <code>depth</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The number of objects at topology depth <code>depth</code>. </dd>
+<dd>
+0 if there are no objects at depth <code>depth</code>. </dd></dl>
+
+</div>
+</div>
+<a id="ga789a3f65aedff644be64a18526a03065" name="ga789a3f65aedff644be64a18526a03065"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga789a3f65aedff644be64a18526a03065">&#9670;&#160;</a></span>hwloc_get_nbobjs_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_get_nbobjs_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the width of level type <code>type</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The number of objects of type <code>type</code>. </dd>
+<dd>
+-1 if there are multiple levels with objects of that type, e.g. <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56" title="Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take...">HWLOC_OBJ_GROUP</a>. </dd>
+<dd>
+0 if there are no objects at depth <code>depth</code>. </dd></dl>
+
+</div>
+</div>
+<a id="gac140a9b939d9fa0b30c4a910efcb0656" name="gac140a9b939d9fa0b30c4a910efcb0656"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac140a9b939d9fa0b30c4a910efcb0656">&#9670;&#160;</a></span>hwloc_get_next_obj_by_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_next_obj_by_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>depth</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the next object at depth <code>depth</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The first object at depth <code>depth</code> if <code>prev</code> is <code>NULL</code>. </dd>
+<dd>
+The object after <code>prev</code> at depth <code>depth</code> if <code>prev</code> is not <code>NULL</code>. </dd>
+<dd>
+<code>NULL</code> if there is no such object. </dd></dl>
+
+</div>
+</div>
+<a id="ga759e88eaf5a230ad283e9d4c42486735" name="ga759e88eaf5a230ad283e9d4c42486735"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga759e88eaf5a230ad283e9d4c42486735">&#9670;&#160;</a></span>hwloc_get_next_obj_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_next_obj_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the next object of type <code>type</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The first object of type <code>type</code> if <code>prev</code> is <code>NULL</code>. </dd>
+<dd>
+The object after <code>prev</code> of type <code>type</code> if <code>prev</code> is not <code>NULL</code>. </dd>
+<dd>
+<code>NULL</code> if there is no such object. </dd>
+<dd>
+<code>NULL</code> if there are multiple levels with objects of that type (e.g. <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56" title="Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take...">HWLOC_OBJ_GROUP</a>), the caller may fallback to <a class="el" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0" title="Returns the topology object at logical index idx from depth depth.">hwloc_get_obj_by_depth()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="ga391f6b2613f0065673eaa4069b93d4e0" name="ga391f6b2613f0065673eaa4069b93d4e0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga391f6b2613f0065673eaa4069b93d4e0">&#9670;&#160;</a></span>hwloc_get_obj_by_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_obj_by_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>depth</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>idx</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Returns the topology object at logical index <code>idx</code> from depth <code>depth</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The object if it exists. </dd>
+<dd>
+<code>NULL</code> if there is no object with this index and depth. </dd></dl>
+
+</div>
+</div>
+<a id="ga6f414dd80a2b943967a0ac92da3181a2" name="ga6f414dd80a2b943967a0ac92da3181a2"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga6f414dd80a2b943967a0ac92da3181a2">&#9670;&#160;</a></span>hwloc_get_obj_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_obj_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>idx</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the topology object at logical index <code>idx</code> with type <code>type</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The object if it exists. </dd>
+<dd>
+<code>NULL</code> if there is no object with this index and type. </dd>
+<dd>
+<code>NULL</code> if there are multiple levels with objects of that type (e.g. <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56" title="Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take...">HWLOC_OBJ_GROUP</a>), the caller may fallback to <a class="el" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0" title="Returns the topology object at logical index idx from depth depth.">hwloc_get_obj_by_depth()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="ga2d4b12fc187dfc53b35f2fa21d21044d" name="ga2d4b12fc187dfc53b35f2fa21d21044d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga2d4b12fc187dfc53b35f2fa21d21044d">&#9670;&#160;</a></span>hwloc_get_root_obj()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_root_obj </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the top-object of the topology-tree. </p>
+<p>Its type is <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a3f4e83ffc4a259354959ae8a9eaa2a80" title="Machine. A set of processors and memory with cache coherency.">HWLOC_OBJ_MACHINE</a>.</p>
+<p>This function cannot return <code>NULL</code>. </p>
+
+</div>
+</div>
+<a id="ga8bec782e21be313750da70cf7428b374" name="ga8bec782e21be313750da70cf7428b374"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8bec782e21be313750da70cf7428b374">&#9670;&#160;</a></span>hwloc_get_type_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_type_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Returns the depth of objects of type <code>type</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The depth of objects of type <code>type</code>.</dd>
+<dd>
+A negative virtual depth if a NUMA node, I/O or Misc object type is given. These objects are stored in special levels that are not CPU-related. This virtual depth may be passed to other hwloc functions such as <a class="el" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0" title="Returns the topology object at logical index idx from depth depth.">hwloc_get_obj_by_depth()</a> but it should not be considered as an actual depth by the application. In particular, it should not be compared with any other object depth or with the entire topology depth.</dd>
+<dd>
+<a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad" title="No object of given type exists in the topology.">HWLOC_TYPE_DEPTH_UNKNOWN</a> if no object of this type is present on the underlying architecture, or if the OS doesn't provide this kind of information.</dd>
+<dd>
+<a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c" title="Objects of given type exist at different depth in the topology (only for Groups).">HWLOC_TYPE_DEPTH_MULTIPLE</a> if type <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56" title="Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take...">HWLOC_OBJ_GROUP</a> is given and multiple levels of Groups exist.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>If the type is absent but a similar type is acceptable, see also <a class="el" href="a00176.html#ga8125328e69eba709c33ea8055c12589b" title="Returns the depth of objects of type type or below.">hwloc_get_type_or_below_depth()</a> and <a class="el" href="a00176.html#ga8a9ee573b7d2190272095d10712a7cca" title="Returns the depth of objects of type type or above.">hwloc_get_type_or_above_depth()</a>.</dd></dl>
+<dl class="section see"><dt>See also</dt><dd><a class="el" href="a00176.html#gae85786340b88e24835f8c403a1e2e54b" title="Return the depth of parents where memory objects are attached.">hwloc_get_memory_parents_depth()</a> for managing the depth of memory objects.</dd>
+<dd>
+<a class="el" href="a00177.html#ga52c63cd7203e55b804c1314affc9bd12" title="Return an object type and its level depth from a type string.">hwloc_type_sscanf_as_depth()</a> for returning the depth of objects whose type is given as a string. </dd></dl>
+
+</div>
+</div>
+<a id="ga8a9ee573b7d2190272095d10712a7cca" name="ga8a9ee573b7d2190272095d10712a7cca"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8a9ee573b7d2190272095d10712a7cca">&#9670;&#160;</a></span>hwloc_get_type_or_above_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_get_type_or_above_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the depth of objects of type <code>type</code> or above. </p>
+<p>If no object of this type is present on the underlying architecture, the function returns the depth of the first "present" object typically containing <code>type</code>.</p>
+<p>This function is only meaningful for normal object types. If a memory, I/O or Misc object type is given, the corresponding virtual depth is always returned (see <a class="el" href="a00176.html#ga8bec782e21be313750da70cf7428b374" title="Returns the depth of objects of type type.">hwloc_get_type_depth()</a>).</p>
+<p>May return <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c" title="Objects of given type exist at different depth in the topology (only for Groups).">HWLOC_TYPE_DEPTH_MULTIPLE</a> for <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56" title="Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take...">HWLOC_OBJ_GROUP</a> just like <a class="el" href="a00176.html#ga8bec782e21be313750da70cf7428b374" title="Returns the depth of objects of type type.">hwloc_get_type_depth()</a>. </p>
+
+</div>
+</div>
+<a id="ga8125328e69eba709c33ea8055c12589b" name="ga8125328e69eba709c33ea8055c12589b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8125328e69eba709c33ea8055c12589b">&#9670;&#160;</a></span>hwloc_get_type_or_below_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_get_type_or_below_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the depth of objects of type <code>type</code> or below. </p>
+<p>If no object of this type is present on the underlying architecture, the function returns the depth of the first "present" object typically found inside <code>type</code>.</p>
+<p>This function is only meaningful for normal object types. If a memory, I/O or Misc object type is given, the corresponding virtual depth is always returned (see <a class="el" href="a00176.html#ga8bec782e21be313750da70cf7428b374" title="Returns the depth of objects of type type.">hwloc_get_type_depth()</a>).</p>
+<p>May return <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c" title="Objects of given type exist at different depth in the topology (only for Groups).">HWLOC_TYPE_DEPTH_MULTIPLE</a> for <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56" title="Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take...">HWLOC_OBJ_GROUP</a> just like <a class="el" href="a00176.html#ga8bec782e21be313750da70cf7428b374" title="Returns the depth of objects of type type.">hwloc_get_type_depth()</a>. </p>
+
+</div>
+</div>
+<a id="gae54d1782ca9b54bea915f5c18a9158fa" name="gae54d1782ca9b54bea915f5c18a9158fa"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gae54d1782ca9b54bea915f5c18a9158fa">&#9670;&#160;</a></span>hwloc_topology_get_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_get_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the depth of the hierarchical tree of objects. </p>
+<p>This is the depth of <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661" title="Processing Unit, or (Logical) Processor. An execution unit (may share a core with some other logical ...">HWLOC_OBJ_PU</a> objects plus one.</p>
+<dl class="section return"><dt>Returns</dt><dd>the depth of the object tree.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>NUMA nodes, I/O and Misc objects are ignored when computing the depth of the tree (they are placed on special levels). </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00177.html 2.11.0-1/doc/doxygen-doc/html/a00177.html
--- 2.10.0-1/doc/doxygen-doc/html/a00177.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00177.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,291 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Converting between Object Types and Attributes, and Strings</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Converting between Object Types and Attributes, and Strings</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga6a38b931e5d45e8af4323a169482fe39" id="r_ga6a38b931e5d45e8af4323a169482fe39"><td class="memItemLeft" align="right" valign="top">const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00177.html#ga6a38b931e5d45e8af4323a169482fe39">hwloc_obj_type_string</a> (<a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga6a38b931e5d45e8af4323a169482fe39"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gadb8765c260edea80c52cd06a76639ba4" id="r_gadb8765c260edea80c52cd06a76639ba4"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00177.html#gadb8765c260edea80c52cd06a76639ba4">hwloc_obj_type_snprintf</a> (char *restrict string, size_t size, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj, int verbose)</td></tr>
+<tr class="separator:gadb8765c260edea80c52cd06a76639ba4"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga870e876931c282a1c7aee2f031912ce3" id="r_ga870e876931c282a1c7aee2f031912ce3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00177.html#ga870e876931c282a1c7aee2f031912ce3">hwloc_obj_attr_snprintf</a> (char *restrict string, size_t size, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj, const char *restrict separator, int verbose)</td></tr>
+<tr class="separator:ga870e876931c282a1c7aee2f031912ce3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga510f21b066fba2dab12b8c9b173b1dfd" id="r_ga510f21b066fba2dab12b8c9b173b1dfd"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00177.html#ga510f21b066fba2dab12b8c9b173b1dfd">hwloc_type_sscanf</a> (const char *string, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> *typep, union <a class="el" href="a00233.html">hwloc_obj_attr_u</a> *attrp, size_t attrsize)</td></tr>
+<tr class="separator:ga510f21b066fba2dab12b8c9b173b1dfd"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga52c63cd7203e55b804c1314affc9bd12" id="r_ga52c63cd7203e55b804c1314affc9bd12"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00177.html#ga52c63cd7203e55b804c1314affc9bd12">hwloc_type_sscanf_as_depth</a> (const char *string, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> *typep, <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int *depthp)</td></tr>
+<tr class="separator:ga52c63cd7203e55b804c1314affc9bd12"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga870e876931c282a1c7aee2f031912ce3" name="ga870e876931c282a1c7aee2f031912ce3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga870e876931c282a1c7aee2f031912ce3">&#9670;&#160;</a></span>hwloc_obj_attr_snprintf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_attr_snprintf </td>
+          <td>(</td>
+          <td class="paramtype">char *restrict&#160;</td>
+          <td class="paramname"><em>string</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>size</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *restrict&#160;</td>
+          <td class="paramname"><em>separator</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>verbose</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Stringify the attributes of a given topology object into a human-readable form. </p>
+<p>Attribute values are separated by <code>separator</code>.</p>
+<p>Only the major attributes are printed in non-verbose mode.</p>
+<p>If <code>size</code> is 0, <code>string</code> may safely be <code>NULL</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>the number of characters that were actually written if not truncating, or that would have been written (not including the ending \0). </dd></dl>
+
+</div>
+</div>
+<a id="gadb8765c260edea80c52cd06a76639ba4" name="gadb8765c260edea80c52cd06a76639ba4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gadb8765c260edea80c52cd06a76639ba4">&#9670;&#160;</a></span>hwloc_obj_type_snprintf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_type_snprintf </td>
+          <td>(</td>
+          <td class="paramtype">char *restrict&#160;</td>
+          <td class="paramname"><em>string</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>size</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>verbose</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Stringify the type of a given topology object into a human-readable form. </p>
+<p>Contrary to <a class="el" href="a00177.html#ga6a38b931e5d45e8af4323a169482fe39" title="Return a constant stringified object type.">hwloc_obj_type_string()</a>, this function includes object-specific attributes (such as the Group depth, the Bridge type, or OS device type) in the output, and it requires the caller to provide the output buffer.</p>
+<p>The output is guaranteed to be the same for all objects of a same topology level.</p>
+<p>If <code>verbose</code> is 1, longer type names are used, e.g. L1Cache instead of L1.</p>
+<p>The output string may be parsed back by <a class="el" href="a00177.html#ga510f21b066fba2dab12b8c9b173b1dfd" title="Return an object type and attributes from a type string.">hwloc_type_sscanf()</a>.</p>
+<p>If <code>size</code> is 0, <code>string</code> may safely be <code>NULL</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>the number of characters that were actually written if not truncating, or that would have been written (not including the ending \0). </dd></dl>
+
+</div>
+</div>
+<a id="ga6a38b931e5d45e8af4323a169482fe39" name="ga6a38b931e5d45e8af4323a169482fe39"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga6a38b931e5d45e8af4323a169482fe39">&#9670;&#160;</a></span>hwloc_obj_type_string()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">const char * hwloc_obj_type_string </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return a constant stringified object type. </p>
+<p>This function is the basic way to convert a generic type into a string. The output string may be parsed back by <a class="el" href="a00177.html#ga510f21b066fba2dab12b8c9b173b1dfd" title="Return an object type and attributes from a type string.">hwloc_type_sscanf()</a>.</p>
+<p><a class="el" href="a00177.html#gadb8765c260edea80c52cd06a76639ba4" title="Stringify the type of a given topology object into a human-readable form.">hwloc_obj_type_snprintf()</a> may return a more precise output for a specific object, but it requires the caller to provide the output buffer.</p>
+<dl class="section return"><dt>Returns</dt><dd>A constant string containing the object type name or <code>"Unknown"</code>. </dd></dl>
+
+</div>
+</div>
+<a id="ga510f21b066fba2dab12b8c9b173b1dfd" name="ga510f21b066fba2dab12b8c9b173b1dfd"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga510f21b066fba2dab12b8c9b173b1dfd">&#9670;&#160;</a></span>hwloc_type_sscanf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_type_sscanf </td>
+          <td>(</td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>string</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> *&#160;</td>
+          <td class="paramname"><em>typep</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">union <a class="el" href="a00233.html">hwloc_obj_attr_u</a> *&#160;</td>
+          <td class="paramname"><em>attrp</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>attrsize</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return an object type and attributes from a type string. </p>
+<p>Convert strings such as "Package" or "L1iCache" into the corresponding types. Matching is case-insensitive, and only the first letters are actually required to match.</p>
+<p>The matched object type is set in <code>typep</code> (which cannot be <code>NULL</code>).</p>
+<p>Type-specific attributes, for instance Cache type, Cache depth, Group depth, Bridge type or OS Device type may be returned in <code>attrp</code>. Attributes that are not specified in the string (for instance "Group" without a depth, or "L2Cache" without a cache type) are set to -1.</p>
+<p><code>attrp</code> is only filled if not <code>NULL</code> and if its size specified in <code>attrsize</code> is large enough. It should be at least as large as union <a class="el" href="a00233.html" title="Object type-specific Attributes.">hwloc_obj_attr_u</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 if a type was correctly identified, otherwise -1.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function is guaranteed to match any string returned by <a class="el" href="a00177.html#ga6a38b931e5d45e8af4323a169482fe39" title="Return a constant stringified object type.">hwloc_obj_type_string()</a> or <a class="el" href="a00177.html#gadb8765c260edea80c52cd06a76639ba4" title="Stringify the type of a given topology object into a human-readable form.">hwloc_obj_type_snprintf()</a>.</dd>
+<dd>
+This is an extended version of the now deprecated hwloc_obj_type_sscanf(). </dd></dl>
+
+</div>
+</div>
+<a id="ga52c63cd7203e55b804c1314affc9bd12" name="ga52c63cd7203e55b804c1314affc9bd12"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga52c63cd7203e55b804c1314affc9bd12">&#9670;&#160;</a></span>hwloc_type_sscanf_as_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_type_sscanf_as_depth </td>
+          <td>(</td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>string</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> *&#160;</td>
+          <td class="paramname"><em>typep</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int *&#160;</td>
+          <td class="paramname"><em>depthp</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return an object type and its level depth from a type string. </p>
+<p>Convert strings such as "Package" or "L1iCache" into the corresponding types and return in <code>depthp</code> the depth of the corresponding level in the topology <code>topology</code>.</p>
+<p>If no object of this type is present on the underlying architecture, <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad" title="No object of given type exists in the topology.">HWLOC_TYPE_DEPTH_UNKNOWN</a> is returned.</p>
+<p>If multiple such levels exist (for instance if giving Group without any depth), the function may return <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c" title="Objects of given type exist at different depth in the topology (only for Groups).">HWLOC_TYPE_DEPTH_MULTIPLE</a> instead.</p>
+<p>The matched object type is set in <code>typep</code> if <code>typep</code> is non <code>NULL</code>.</p>
+<dl class="section note"><dt>Note</dt><dd>This function is similar to <a class="el" href="a00177.html#ga510f21b066fba2dab12b8c9b173b1dfd" title="Return an object type and attributes from a type string.">hwloc_type_sscanf()</a> followed by <a class="el" href="a00176.html#ga8bec782e21be313750da70cf7428b374" title="Returns the depth of objects of type type.">hwloc_get_type_depth()</a> but it also automatically disambiguates multiple group levels etc.</dd>
+<dd>
+This function is guaranteed to match any string returned by <a class="el" href="a00177.html#ga6a38b931e5d45e8af4323a169482fe39" title="Return a constant stringified object type.">hwloc_obj_type_string()</a> or <a class="el" href="a00177.html#gadb8765c260edea80c52cd06a76639ba4" title="Stringify the type of a given topology object into a human-readable form.">hwloc_obj_type_snprintf()</a>. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00178.html 2.11.0-1/doc/doxygen-doc/html/a00178.html
--- 2.10.0-1/doc/doxygen-doc/html/a00178.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00178.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,192 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Consulting and Adding Info Attributes</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Consulting and Adding Info Attributes</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga415c4e44beada7ea34cd4bad9944b170" id="r_ga415c4e44beada7ea34cd4bad9944b170"><td class="memItemLeft" align="right" valign="top">static const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00178.html#ga415c4e44beada7ea34cd4bad9944b170">hwloc_obj_get_info_by_name</a> (<a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj, const char *name)</td></tr>
+<tr class="separator:ga415c4e44beada7ea34cd4bad9944b170"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gace7654bb8a9002caae1a4b8a59e7452e" id="r_gace7654bb8a9002caae1a4b8a59e7452e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00178.html#gace7654bb8a9002caae1a4b8a59e7452e">hwloc_obj_add_info</a> (<a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj, const char *name, const char *value)</td></tr>
+<tr class="separator:gace7654bb8a9002caae1a4b8a59e7452e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga6a07031b69bc7466b6fc4d13d610d47a" id="r_ga6a07031b69bc7466b6fc4d13d610d47a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00178.html#ga6a07031b69bc7466b6fc4d13d610d47a">hwloc_obj_set_subtype</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj, const char *subtype)</td></tr>
+<tr class="separator:ga6a07031b69bc7466b6fc4d13d610d47a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gace7654bb8a9002caae1a4b8a59e7452e" name="gace7654bb8a9002caae1a4b8a59e7452e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gace7654bb8a9002caae1a4b8a59e7452e">&#9670;&#160;</a></span>hwloc_obj_add_info()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_add_info </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>name</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>value</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Add the given name and value pair to the given object info attributes. </p>
+<p>The info pair is appended to the existing info array even if another pair with the same name already exists.</p>
+<p>The input strings are copied before being added in the object infos.</p>
+<dl class="section return"><dt>Returns</dt><dd><code>0</code> on success, <code>-1</code> on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function may be used to enforce object colors in the lstopo graphical output by adding "lstopoStyle" as a name and "Background=#rrggbb" as a value. See CUSTOM COLORS in the lstopo(1) manpage for details.</dd>
+<dd>
+If <code>name</code> or <code>value</code> contain some non-printable characters, they will be dropped when exporting to XML, see <a class="el" href="a00195.html#ga333f79975b4eeb28a3d8fad3373583ce" title="Export the topology into an XML file.">hwloc_topology_export_xml()</a> in <a class="el" href="a00113_source.html">hwloc/export.h</a>. </dd></dl>
+
+</div>
+</div>
+<a id="ga415c4e44beada7ea34cd4bad9944b170" name="ga415c4e44beada7ea34cd4bad9944b170"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga415c4e44beada7ea34cd4bad9944b170">&#9670;&#160;</a></span>hwloc_obj_get_info_by_name()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static const char * hwloc_obj_get_info_by_name </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>name</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Search the given name in object infos and return the corresponding value. </p>
+<p>If multiple info attributes match the given name, only the first one is returned.</p>
+<dl class="section return"><dt>Returns</dt><dd>A pointer to the value string if it exists. </dd>
+<dd>
+<code>NULL</code> if no such info attribute exists.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>The string should not be freed by the caller, it belongs to the hwloc library. </dd></dl>
+
+</div>
+</div>
+<a id="ga6a07031b69bc7466b6fc4d13d610d47a" name="ga6a07031b69bc7466b6fc4d13d610d47a"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga6a07031b69bc7466b6fc4d13d610d47a">&#9670;&#160;</a></span>hwloc_obj_set_subtype()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_set_subtype </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>subtype</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set (or replace) the subtype of an object. </p>
+<p>The given <code>subtype</code> is copied internally, the caller is responsible for freeing the original <code>subtype</code> if needed.</p>
+<p>If another subtype already exists in <code>object</code>, it is replaced. The given <code>subtype</code> may be <code>NULL</code> to remove the existing subtype.</p>
+<dl class="section note"><dt>Note</dt><dd>This function is mostly meant to initialize the subtype of user-added objects such as groups with <a class="el" href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7" title="Allocate a Group object to insert later with hwloc_topology_insert_group_object().">hwloc_topology_alloc_group_object()</a>.</dd></dl>
+<dl class="section return"><dt>Returns</dt><dd><code>0</code> on success. </dd>
+<dd>
+<code>-1</code> with <code>errno</code> set to <code>ENOMEM</code> on failure to allocate memory. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00179.html 2.11.0-1/doc/doxygen-doc/html/a00179.html
--- 2.10.0-1/doc/doxygen-doc/html/a00179.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00179.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,496 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): CPU binding</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">CPU binding</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:ga217dc8d373f8958cc93c154ebce1c71c" id="r_ga217dc8d373f8958cc93c154ebce1c71c"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00179.html#ga217dc8d373f8958cc93c154ebce1c71c">hwloc_cpubind_flags_t</a> { <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca2e0dd0128dac6b03408c7dd170477fdc">HWLOC_CPUBIND_PROCESS</a>
+, <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421">HWLOC_CPUBIND_THREAD</a>
+, <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca679a7e0f0c7ee06b123565f90d98e7fa">HWLOC_CPUBIND_STRICT</a>
+, <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca41ce440443cc3087caed95ab60edcad6">HWLOC_CPUBIND_NOMEMBIND</a>
+ }</td></tr>
+<tr class="separator:ga217dc8d373f8958cc93c154ebce1c71c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga80bc07473a8edf840cae17bd7ec21d48" id="r_ga80bc07473a8edf840cae17bd7ec21d48"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48">hwloc_set_cpubind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, int flags)</td></tr>
+<tr class="separator:ga80bc07473a8edf840cae17bd7ec21d48"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gacba7ecb979baf824d5240fa2cb2a8be6" id="r_gacba7ecb979baf824d5240fa2cb2a8be6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00179.html#gacba7ecb979baf824d5240fa2cb2a8be6">hwloc_get_cpubind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set, int flags)</td></tr>
+<tr class="separator:gacba7ecb979baf824d5240fa2cb2a8be6"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga296db8a3c6d49b51fb83d6f3e45c02a6" id="r_ga296db8a3c6d49b51fb83d6f3e45c02a6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00179.html#ga296db8a3c6d49b51fb83d6f3e45c02a6">hwloc_set_proc_cpubind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_pid_t pid, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, int flags)</td></tr>
+<tr class="separator:ga296db8a3c6d49b51fb83d6f3e45c02a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac82de91f788fa82dacf99c6e0d4b7158" id="r_gac82de91f788fa82dacf99c6e0d4b7158"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00179.html#gac82de91f788fa82dacf99c6e0d4b7158">hwloc_get_proc_cpubind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_pid_t pid, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set, int flags)</td></tr>
+<tr class="separator:gac82de91f788fa82dacf99c6e0d4b7158"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gae42c01b2addcfbf6048b9a516dd7a906" id="r_gae42c01b2addcfbf6048b9a516dd7a906"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00179.html#gae42c01b2addcfbf6048b9a516dd7a906">hwloc_set_thread_cpubind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_thread_t thread, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, int flags)</td></tr>
+<tr class="separator:gae42c01b2addcfbf6048b9a516dd7a906"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaf13f765642b5d0d9a9813e6bb043671b" id="r_gaf13f765642b5d0d9a9813e6bb043671b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00179.html#gaf13f765642b5d0d9a9813e6bb043671b">hwloc_get_thread_cpubind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_thread_t thread, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set, int flags)</td></tr>
+<tr class="separator:gaf13f765642b5d0d9a9813e6bb043671b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gafdb374627358bf09203b5a4215b13032" id="r_gafdb374627358bf09203b5a4215b13032"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00179.html#gafdb374627358bf09203b5a4215b13032">hwloc_get_last_cpu_location</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set, int flags)</td></tr>
+<tr class="separator:gafdb374627358bf09203b5a4215b13032"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga910a05c2d47f68a3155bf176b50fa555" id="r_ga910a05c2d47f68a3155bf176b50fa555"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00179.html#ga910a05c2d47f68a3155bf176b50fa555">hwloc_get_proc_last_cpu_location</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_pid_t pid, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set, int flags)</td></tr>
+<tr class="separator:ga910a05c2d47f68a3155bf176b50fa555"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>Some operating systems only support binding threads or processes to a single PU. Others allow binding to larger sets such as entire Cores or Packages or even random sets of individual PUs. In such operating system, the scheduler is free to run the task on one of these PU, then migrate it to another PU, etc. It is often useful to call <a class="el" href="a00194.html#gaa611a77c092e679246afdf9a60d5db8b" title="Keep a single index among those set in bitmap bitmap.">hwloc_bitmap_singlify()</a> on the target CPU set before passing it to the binding function to avoid these expensive migrations. See the documentation of <a class="el" href="a00194.html#gaa611a77c092e679246afdf9a60d5db8b" title="Keep a single index among those set in bitmap bitmap.">hwloc_bitmap_singlify()</a> for details.</p>
+<p>Some operating systems do not provide all hwloc-supported mechanisms to bind processes, threads, etc. <a class="el" href="a00182.html#gac0927e93a9b962143be08a48bbff2e19" title="Retrieve the topology support.">hwloc_topology_get_support()</a> may be used to query about the actual CPU binding support in the currently used operating system.</p>
+<p>When the requested binding operation is not available and the <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca679a7e0f0c7ee06b123565f90d98e7fa" title="Request for strict binding from the OS.">HWLOC_CPUBIND_STRICT</a> flag was passed, the function returns -1. <code>errno</code> is set to <code>ENOSYS</code> when it is not possible to bind the requested kind of object processes/threads. errno is set to <code>EXDEV</code> when the requested cpuset can not be enforced (e.g. some systems only allow one CPU, and some other systems only allow one NUMA node).</p>
+<p>If <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca679a7e0f0c7ee06b123565f90d98e7fa" title="Request for strict binding from the OS.">HWLOC_CPUBIND_STRICT</a> was not passed, the function may fail as well, or the operating system may use a slightly different operation (with side-effects, smaller binding set, etc.) when the requested operation is not exactly supported.</p>
+<p>The most portable version that should be preferred over the others, whenever possible, is the following one which just binds the current program, assuming it is single-threaded:</p>
+<div class="fragment"><div class="line"><a class="code hl_function" href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48">hwloc_set_cpubind</a>(topology, set, 0),</div>
+<div class="ttc" id="aa00179_html_ga80bc07473a8edf840cae17bd7ec21d48"><div class="ttname"><a href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48">hwloc_set_cpubind</a></div><div class="ttdeci">int hwloc_set_cpubind(hwloc_topology_t topology, hwloc_const_cpuset_t set, int flags)</div><div class="ttdoc">Bind current process or thread on CPUs given in physical bitmap set.</div></div>
+</div><!-- fragment --><p>If the program may be multithreaded, the following one should be preferred to only bind the current thread:</p>
+<div class="fragment"><div class="line"><a class="code hl_function" href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48">hwloc_set_cpubind</a>(topology, set, <a class="code hl_enumvalue" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421">HWLOC_CPUBIND_THREAD</a>),</div>
+<div class="ttc" id="aa00179_html_gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421"><div class="ttname"><a href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421">HWLOC_CPUBIND_THREAD</a></div><div class="ttdeci">@ HWLOC_CPUBIND_THREAD</div><div class="ttdoc">Bind current thread of current process.</div><div class="ttdef"><b>Definition</b> hwloc.h:1256</div></div>
+</div><!-- fragment --><dl class="section see"><dt>See also</dt><dd>Some example codes are available under doc/examples/ in the source tree.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>To unbind, just call the binding function with either a full cpuset or a cpuset equal to the system cpuset.</dd>
+<dd>
+On some operating systems, CPU binding may have effects on memory binding, see <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca41ce440443cc3087caed95ab60edcad6" title="Avoid any effect on memory binding.">HWLOC_CPUBIND_NOMEMBIND</a></dd>
+<dd>
+Running lstopo --top or hwloc-ps can be a very convenient tool to check how binding actually happened. </dd></dl>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="ga217dc8d373f8958cc93c154ebce1c71c" name="ga217dc8d373f8958cc93c154ebce1c71c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga217dc8d373f8958cc93c154ebce1c71c">&#9670;&#160;</a></span>hwloc_cpubind_flags_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00179.html#ga217dc8d373f8958cc93c154ebce1c71c">hwloc_cpubind_flags_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Process/Thread binding flags. </p>
+<p>These bit flags can be used to refine the binding policy.</p>
+<p>The default (0) is to bind the current process, assumed to be single-threaded, in a non-strict way. This is the most portable way to bind as all operating systems usually provide it.</p>
+<dl class="section note"><dt>Note</dt><dd>Not all systems support all kinds of binding. See the "Detailed Description" section of <a class="el" href="a00179.html">CPU binding</a> for a description of errors that can occur. </dd></dl>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga217dc8d373f8958cc93c154ebce1c71ca2e0dd0128dac6b03408c7dd170477fdc" name="gga217dc8d373f8958cc93c154ebce1c71ca2e0dd0128dac6b03408c7dd170477fdc"></a>HWLOC_CPUBIND_PROCESS&#160;</td><td class="fielddoc"><p>Bind all threads of the current (possibly) multithreaded process. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421" name="gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421"></a>HWLOC_CPUBIND_THREAD&#160;</td><td class="fielddoc"><p>Bind current thread of current process. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga217dc8d373f8958cc93c154ebce1c71ca679a7e0f0c7ee06b123565f90d98e7fa" name="gga217dc8d373f8958cc93c154ebce1c71ca679a7e0f0c7ee06b123565f90d98e7fa"></a>HWLOC_CPUBIND_STRICT&#160;</td><td class="fielddoc"><p>Request for strict binding from the OS. </p>
+<p>By default, when the designated CPUs are all busy while other CPUs are idle, operating systems may execute the thread/process on those other CPUs instead of the designated CPUs, to let them progress anyway. Strict binding means that the thread/process will _never_ execute on other CPUs than the designated CPUs, even when those are busy with other tasks and other CPUs are idle.</p>
+<dl class="section note"><dt>Note</dt><dd>Depending on the operating system, strict binding may not be possible (e.g., the OS does not implement it) or not allowed (e.g., for an administrative reasons), and the function will fail in that case.</dd></dl>
+<p>When retrieving the binding of a process, this flag checks whether all its threads actually have the same binding. If the flag is not given, the binding of each thread will be accumulated.</p>
+<dl class="section note"><dt>Note</dt><dd>This flag is meaningless when retrieving the binding of a thread. </dd></dl>
+</td></tr>
+<tr><td class="fieldname"><a id="gga217dc8d373f8958cc93c154ebce1c71ca41ce440443cc3087caed95ab60edcad6" name="gga217dc8d373f8958cc93c154ebce1c71ca41ce440443cc3087caed95ab60edcad6"></a>HWLOC_CPUBIND_NOMEMBIND&#160;</td><td class="fielddoc"><p>Avoid any effect on memory binding. </p>
+<p>On some operating systems, some CPU binding function would also bind the memory on the corresponding NUMA node. It is often not a problem for the application, but if it is, setting this flag will make hwloc avoid using OS functions that would also bind memory. This will however reduce the support of CPU bindings, i.e. potentially return -1 with errno set to <code>ENOSYS</code> in some cases.</p>
+<p>This flag is only meaningful when used with functions that set the CPU binding. It is ignored when used with functions that get CPU binding information. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gacba7ecb979baf824d5240fa2cb2a8be6" name="gacba7ecb979baf824d5240fa2cb2a8be6"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gacba7ecb979baf824d5240fa2cb2a8be6">&#9670;&#160;</a></span>hwloc_get_cpubind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_cpubind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get current process or thread binding. </p>
+<p>The CPU-set <code>set</code> (previously allocated by the caller) is filled with the list of PUs which the process or thread (according to <em>flags</em>) was last bound to.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gafdb374627358bf09203b5a4215b13032" name="gafdb374627358bf09203b5a4215b13032"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gafdb374627358bf09203b5a4215b13032">&#9670;&#160;</a></span>hwloc_get_last_cpu_location()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_last_cpu_location </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the last physical CPU where the current process or thread ran. </p>
+<p>The CPU-set <code>set</code> (previously allocated by the caller) is filled with the list of PUs which the process or thread (according to <em>flags</em>) last ran on.</p>
+<p>The operating system may move some tasks from one processor to another at any time according to their binding, so this function may return something that is already outdated.</p>
+<p><code>flags</code> can include either <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca2e0dd0128dac6b03408c7dd170477fdc" title="Bind all threads of the current (possibly) multithreaded process.">HWLOC_CPUBIND_PROCESS</a> or <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421" title="Bind current thread of current process.">HWLOC_CPUBIND_THREAD</a> to specify whether the query should be for the whole process (union of all CPUs on which all threads are running), or only the current thread. If the process is single-threaded, flags can be set to zero to let hwloc use whichever method is available on the underlying OS.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gac82de91f788fa82dacf99c6e0d4b7158" name="gac82de91f788fa82dacf99c6e0d4b7158"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac82de91f788fa82dacf99c6e0d4b7158">&#9670;&#160;</a></span>hwloc_get_proc_cpubind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_proc_cpubind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_pid_t&#160;</td>
+          <td class="paramname"><em>pid</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the current physical binding of process <code>pid</code>. </p>
+<p>The CPU-set <code>set</code> (previously allocated by the caller) is filled with the list of PUs which the process was last bound to.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd><code>hwloc_pid_t</code> is <code>pid_t</code> on Unix platforms, and <code>HANDLE</code> on native Windows platforms.</dd>
+<dd>
+As a special case on Linux, if a tid (thread ID) is supplied instead of a pid (process ID) and HWLOC_CPUBIND_THREAD is passed in flags, the binding for that specific thread is returned.</dd>
+<dd>
+On non-Linux systems, HWLOC_CPUBIND_THREAD can not be used in <code>flags</code>. </dd></dl>
+
+</div>
+</div>
+<a id="ga910a05c2d47f68a3155bf176b50fa555" name="ga910a05c2d47f68a3155bf176b50fa555"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga910a05c2d47f68a3155bf176b50fa555">&#9670;&#160;</a></span>hwloc_get_proc_last_cpu_location()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_proc_last_cpu_location </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_pid_t&#160;</td>
+          <td class="paramname"><em>pid</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the last physical CPU where a process ran. </p>
+<p>The CPU-set <code>set</code> (previously allocated by the caller) is filled with the list of PUs which the process last ran on.</p>
+<p>The operating system may move some tasks from one processor to another at any time according to their binding, so this function may return something that is already outdated.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd><code>hwloc_pid_t</code> is <code>pid_t</code> on Unix platforms, and <code>HANDLE</code> on native Windows platforms.</dd>
+<dd>
+As a special case on Linux, if a tid (thread ID) is supplied instead of a pid (process ID) and <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421" title="Bind current thread of current process.">HWLOC_CPUBIND_THREAD</a> is passed in flags, the last CPU location of that specific thread is returned.</dd>
+<dd>
+On non-Linux systems, <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421" title="Bind current thread of current process.">HWLOC_CPUBIND_THREAD</a> can not be used in <code>flags</code>. </dd></dl>
+
+</div>
+</div>
+<a id="gaf13f765642b5d0d9a9813e6bb043671b" name="gaf13f765642b5d0d9a9813e6bb043671b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf13f765642b5d0d9a9813e6bb043671b">&#9670;&#160;</a></span>hwloc_get_thread_cpubind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_thread_cpubind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_thread_t&#160;</td>
+          <td class="paramname"><em>thread</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the current physical binding of thread <code>tid</code>. </p>
+<p>The CPU-set <code>set</code> (previously allocated by the caller) is filled with the list of PUs which the thread was last bound to.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd><code>hwloc_thread_t</code> is <code>pthread_t</code> on Unix platforms, and <code>HANDLE</code> on native Windows platforms.</dd>
+<dd>
+<a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca2e0dd0128dac6b03408c7dd170477fdc" title="Bind all threads of the current (possibly) multithreaded process.">HWLOC_CPUBIND_PROCESS</a> can not be used in <code>flags</code>. </dd></dl>
+
+</div>
+</div>
+<a id="ga80bc07473a8edf840cae17bd7ec21d48" name="ga80bc07473a8edf840cae17bd7ec21d48"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga80bc07473a8edf840cae17bd7ec21d48">&#9670;&#160;</a></span>hwloc_set_cpubind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_set_cpubind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Bind current process or thread on CPUs given in physical bitmap <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOSYS</code> if the action is not supported. </dd>
+<dd>
+-1 with errno set to <code>EXDEV</code> if the binding cannot be enforced. </dd></dl>
+
+</div>
+</div>
+<a id="ga296db8a3c6d49b51fb83d6f3e45c02a6" name="ga296db8a3c6d49b51fb83d6f3e45c02a6"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga296db8a3c6d49b51fb83d6f3e45c02a6">&#9670;&#160;</a></span>hwloc_set_proc_cpubind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_set_proc_cpubind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_pid_t&#160;</td>
+          <td class="paramname"><em>pid</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Bind a process <code>pid</code> on CPUs given in physical bitmap <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd><code>hwloc_pid_t</code> is <code>pid_t</code> on Unix platforms, and <code>HANDLE</code> on native Windows platforms.</dd>
+<dd>
+As a special case on Linux, if a tid (thread ID) is supplied instead of a pid (process ID) and <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421" title="Bind current thread of current process.">HWLOC_CPUBIND_THREAD</a> is passed in flags, the binding is applied to that specific thread.</dd>
+<dd>
+On non-Linux systems, <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421" title="Bind current thread of current process.">HWLOC_CPUBIND_THREAD</a> can not be used in <code>flags</code>. </dd></dl>
+
+</div>
+</div>
+<a id="gae42c01b2addcfbf6048b9a516dd7a906" name="gae42c01b2addcfbf6048b9a516dd7a906"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gae42c01b2addcfbf6048b9a516dd7a906">&#9670;&#160;</a></span>hwloc_set_thread_cpubind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_set_thread_cpubind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_thread_t&#160;</td>
+          <td class="paramname"><em>thread</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Bind a thread <code>thread</code> on CPUs given in physical bitmap <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd><code>hwloc_thread_t</code> is <code>pthread_t</code> on Unix platforms, and <code>HANDLE</code> on native Windows platforms.</dd>
+<dd>
+<a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca2e0dd0128dac6b03408c7dd170477fdc" title="Bind all threads of the current (possibly) multithreaded process.">HWLOC_CPUBIND_PROCESS</a> can not be used in <code>flags</code>. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00180.html 2.11.0-1/doc/doxygen-doc/html/a00180.html
--- 2.10.0-1/doc/doxygen-doc/html/a00180.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00180.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,777 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Memory binding</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Memory binding</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:gac9764f79505775d06407b40f5e4661e8" id="r_gac9764f79505775d06407b40f5e4661e8"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> { <br />
+&#160;&#160;<a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a18675bb80ebc1bce5b652e9de8f3998c">HWLOC_MEMBIND_DEFAULT</a>
+, <a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a979c7aa78dd32780858f30f47a72cca0">HWLOC_MEMBIND_FIRSTTOUCH</a>
+, <a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c">HWLOC_MEMBIND_BIND</a>
+, <a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ae370075e5af016d42310f87ea5af236b">HWLOC_MEMBIND_INTERLEAVE</a>
+, <br />
+&#160;&#160;<a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8aa091c40c9557b69a26b69a0e8b84dafe">HWLOC_MEMBIND_WEIGHTED_INTERLEAVE</a>
+, <a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8aecdd4164d647708fbb51a00d98dbb138">HWLOC_MEMBIND_NEXTTOUCH</a>
+, <a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a3185bd869b67817fb2bd5164bf360402">HWLOC_MEMBIND_MIXED</a>
+<br />
+ }</td></tr>
+<tr class="separator:gac9764f79505775d06407b40f5e4661e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gab00475fd98815bf4fb9aaf752030e7d2" id="r_gab00475fd98815bf4fb9aaf752030e7d2"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#gab00475fd98815bf4fb9aaf752030e7d2">hwloc_membind_flags_t</a> { <br />
+&#160;&#160;<a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4">HWLOC_MEMBIND_PROCESS</a>
+, <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298">HWLOC_MEMBIND_THREAD</a>
+, <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a>
+, <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2aa6e49e54f52827cb143cc869cfd748af">HWLOC_MEMBIND_MIGRATE</a>
+, <br />
+&#160;&#160;<a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2aad6b9eaf2ee324ca58dc8f58094b9997">HWLOC_MEMBIND_NOCPUBIND</a>
+, <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256">HWLOC_MEMBIND_BYNODESET</a>
+<br />
+ }</td></tr>
+<tr class="separator:gab00475fd98815bf4fb9aaf752030e7d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga020951efa0ce3862bd4faec295501a7f" id="r_ga020951efa0ce3862bd4faec295501a7f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#ga020951efa0ce3862bd4faec295501a7f">hwloc_set_membind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, <a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> policy, int flags)</td></tr>
+<tr class="separator:ga020951efa0ce3862bd4faec295501a7f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gae21f0a1a884929c784bebf070252aa56" id="r_gae21f0a1a884929c784bebf070252aa56"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#gae21f0a1a884929c784bebf070252aa56">hwloc_get_membind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set, <a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> *policy, int flags)</td></tr>
+<tr class="separator:gae21f0a1a884929c784bebf070252aa56"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gabc91ff16f7e41047924e3a4ae6d9da7e" id="r_gabc91ff16f7e41047924e3a4ae6d9da7e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#gabc91ff16f7e41047924e3a4ae6d9da7e">hwloc_set_proc_membind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_pid_t pid, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, <a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> policy, int flags)</td></tr>
+<tr class="separator:gabc91ff16f7e41047924e3a4ae6d9da7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1730ceb18ec6ee3b7bd3d0db81f07dc8" id="r_ga1730ceb18ec6ee3b7bd3d0db81f07dc8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#ga1730ceb18ec6ee3b7bd3d0db81f07dc8">hwloc_get_proc_membind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, hwloc_pid_t pid, <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set, <a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> *policy, int flags)</td></tr>
+<tr class="separator:ga1730ceb18ec6ee3b7bd3d0db81f07dc8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaf881faefe20701229f07dd7dbd0125ed" id="r_gaf881faefe20701229f07dd7dbd0125ed"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#gaf881faefe20701229f07dd7dbd0125ed">hwloc_set_area_membind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const void *addr, size_t len, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, <a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> policy, int flags)</td></tr>
+<tr class="separator:gaf881faefe20701229f07dd7dbd0125ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa87e0a6946ff145914fdf0b1c60567f8" id="r_gaa87e0a6946ff145914fdf0b1c60567f8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#gaa87e0a6946ff145914fdf0b1c60567f8">hwloc_get_area_membind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const void *addr, size_t len, <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set, <a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> *policy, int flags)</td></tr>
+<tr class="separator:gaa87e0a6946ff145914fdf0b1c60567f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga537c7508a4e2d1db05673ec5be6e805c" id="r_ga537c7508a4e2d1db05673ec5be6e805c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#ga537c7508a4e2d1db05673ec5be6e805c">hwloc_get_area_memlocation</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const void *addr, size_t len, <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set, int flags)</td></tr>
+<tr class="separator:ga537c7508a4e2d1db05673ec5be6e805c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga95856d8f13357f247d5fce142d443ae3" id="r_ga95856d8f13357f247d5fce142d443ae3"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#ga95856d8f13357f247d5fce142d443ae3">hwloc_alloc</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, size_t len)</td></tr>
+<tr class="separator:ga95856d8f13357f247d5fce142d443ae3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gadf87089ef533db40460ccc24b5bc0d65" id="r_gadf87089ef533db40460ccc24b5bc0d65"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#gadf87089ef533db40460ccc24b5bc0d65">hwloc_alloc_membind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, size_t len, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, <a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> policy, int flags)</td></tr>
+<tr class="separator:gadf87089ef533db40460ccc24b5bc0d65"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga64e5f75165ea52930f67b17ef4aed2e8" id="r_ga64e5f75165ea52930f67b17ef4aed2e8"><td class="memItemLeft" align="right" valign="top">static void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#ga64e5f75165ea52930f67b17ef4aed2e8">hwloc_alloc_membind_policy</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, size_t len, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, <a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> policy, int flags)</td></tr>
+<tr class="separator:ga64e5f75165ea52930f67b17ef4aed2e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga32dbd4f54e9e4a7179f2dde37ffe6ad7" id="r_ga32dbd4f54e9e4a7179f2dde37ffe6ad7"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00180.html#ga32dbd4f54e9e4a7179f2dde37ffe6ad7">hwloc_free</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, void *addr, size_t len)</td></tr>
+<tr class="separator:ga32dbd4f54e9e4a7179f2dde37ffe6ad7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>Memory binding can be done three ways:</p>
+<ul>
+<li>explicit memory allocation thanks to <a class="el" href="a00180.html#gadf87089ef533db40460ccc24b5bc0d65" title="Allocate some memory on NUMA memory nodes specified by set.">hwloc_alloc_membind()</a> and friends: the binding will have effect on the memory allocated by these functions.</li>
+<li>implicit memory binding through binding policy: <a class="el" href="a00180.html#ga020951efa0ce3862bd4faec295501a7f" title="Set the default memory binding policy of the current process or thread to prefer the NUMA node(s) spe...">hwloc_set_membind()</a> and friends only define the current policy of the process, which will be applied to the subsequent calls to malloc() and friends.</li>
+<li>migration of existing memory ranges, thanks to <a class="el" href="a00180.html#gaf881faefe20701229f07dd7dbd0125ed" title="Bind the already-allocated memory identified by (addr, len) to the NUMA node(s) specified by set.">hwloc_set_area_membind()</a> and friends, which move already-allocated data.</li>
+</ul>
+<p>Not all operating systems support all three ways. <a class="el" href="a00182.html#gac0927e93a9b962143be08a48bbff2e19" title="Retrieve the topology support.">hwloc_topology_get_support()</a> may be used to query about the actual memory binding support in the currently used operating system.</p>
+<p>When the requested binding operation is not available and the <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a> flag was passed, the function returns -1. <code>errno</code> will be set to <code>ENOSYS</code> when the system does support the specified action or policy (e.g., some systems only allow binding memory on a per-thread basis, whereas other systems only allow binding memory for all threads in a process). <code>errno</code> will be set to <code>EXDEV</code> when the requested set can not be enforced (e.g., some systems only allow binding memory to a single NUMA node).</p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a> was not passed, the function may fail as well, or the operating system may use a slightly different operation (with side-effects, smaller binding set, etc.) when the requested operation is not exactly supported.</p>
+<p>The most portable form that should be preferred over the others whenever possible is as follows. It allocates some memory hopefully bound to the specified set. To do so, hwloc will possibly have to change the current memory binding policy in order to actually get the memory bound, if the OS does not provide any other way to simply allocate bound memory without changing the policy for all allocations. That is the difference with <a class="el" href="a00180.html#gadf87089ef533db40460ccc24b5bc0d65" title="Allocate some memory on NUMA memory nodes specified by set.">hwloc_alloc_membind()</a>, which will never change the current memory binding policy.</p>
+<div class="fragment"><div class="line"><a class="code hl_function" href="a00180.html#ga64e5f75165ea52930f67b17ef4aed2e8">hwloc_alloc_membind_policy</a>(topology, size, set,</div>
+<div class="line">                           <a class="code hl_enumvalue" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c">HWLOC_MEMBIND_BIND</a>, 0);</div>
+<div class="ttc" id="aa00180_html_ga64e5f75165ea52930f67b17ef4aed2e8"><div class="ttname"><a href="a00180.html#ga64e5f75165ea52930f67b17ef4aed2e8">hwloc_alloc_membind_policy</a></div><div class="ttdeci">static void * hwloc_alloc_membind_policy(hwloc_topology_t topology, size_t len, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</div><div class="ttdoc">Allocate some memory on NUMA memory nodes specified by set.</div></div>
+<div class="ttc" id="aa00180_html_ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c"><div class="ttname"><a href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c">HWLOC_MEMBIND_BIND</a></div><div class="ttdeci">@ HWLOC_MEMBIND_BIND</div><div class="ttdoc">Allocate memory on the specified nodes.</div><div class="ttdef"><b>Definition</b> hwloc.h:1536</div></div>
+</div><!-- fragment --><p>Each hwloc memory binding function takes a bitmap argument that is a CPU set by default, or a NUMA memory node set if the flag <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" title="Consider the bitmap argument as a nodeset.">HWLOC_MEMBIND_BYNODESET</a> is specified. See <a class="el" href="a00172.html">Object Sets (hwloc_cpuset_t and hwloc_nodeset_t)</a> and <a class="el" href="a00194.html">The bitmap API</a> for a discussion of CPU sets and NUMA memory node sets. It is also possible to convert between CPU set and node set using <a class="el" href="a00192.html#ga185751c1653fedbeb7cc480840f38cde" title="Convert a CPU set into a NUMA node set.">hwloc_cpuset_to_nodeset()</a> or <a class="el" href="a00192.html#gad5ee8691e08a3538ea7633344c00456d" title="Convert a NUMA node set into a CPU set.">hwloc_cpuset_from_nodeset()</a>.</p>
+<p>Memory binding by CPU set cannot work for CPU-less NUMA memory nodes. Binding by nodeset should therefore be preferred whenever possible.</p>
+<dl class="section see"><dt>See also</dt><dd>Some example codes are available under doc/examples/ in the source tree.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>On some operating systems, memory binding affects the CPU binding; see <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2aad6b9eaf2ee324ca58dc8f58094b9997" title="Avoid any effect on CPU binding.">HWLOC_MEMBIND_NOCPUBIND</a> </dd></dl>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="gab00475fd98815bf4fb9aaf752030e7d2" name="gab00475fd98815bf4fb9aaf752030e7d2"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab00475fd98815bf4fb9aaf752030e7d2">&#9670;&#160;</a></span>hwloc_membind_flags_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00180.html#gab00475fd98815bf4fb9aaf752030e7d2">hwloc_membind_flags_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Memory binding flags. </p>
+<p>These flags can be used to refine the binding policy. All flags can be logically OR'ed together with the exception of <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4" title="Set policy for all threads of the specified (possibly multithreaded) process. This flag is mutually e...">HWLOC_MEMBIND_PROCESS</a> and <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298" title="Set policy for a specific thread of the current process. This flag is mutually exclusive with HWLOC_M...">HWLOC_MEMBIND_THREAD</a>; these two flags are mutually exclusive.</p>
+<p>Not all systems support all kinds of binding. <a class="el" href="a00182.html#gac0927e93a9b962143be08a48bbff2e19" title="Retrieve the topology support.">hwloc_topology_get_support()</a> may be used to query about the actual memory binding support in the currently used operating system. See the "Detailed Description" section of <a class="el" href="a00180.html">Memory binding</a> for a description of errors that can occur. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4" name="ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4"></a>HWLOC_MEMBIND_PROCESS&#160;</td><td class="fielddoc"><p>Set policy for all threads of the specified (possibly multithreaded) process. This flag is mutually exclusive with <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298" title="Set policy for a specific thread of the current process. This flag is mutually exclusive with HWLOC_M...">HWLOC_MEMBIND_THREAD</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298" name="ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298"></a>HWLOC_MEMBIND_THREAD&#160;</td><td class="fielddoc"><p>Set policy for a specific thread of the current process. This flag is mutually exclusive with <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4" title="Set policy for all threads of the specified (possibly multithreaded) process. This flag is mutually e...">HWLOC_MEMBIND_PROCESS</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6" name="ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6"></a>HWLOC_MEMBIND_STRICT&#160;</td><td class="fielddoc"><p>Request strict binding from the OS. The function will fail if the binding can not be guaranteed / completely enforced.</p>
+<p>This flag has slightly different meanings depending on which function it is used with. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab00475fd98815bf4fb9aaf752030e7d2aa6e49e54f52827cb143cc869cfd748af" name="ggab00475fd98815bf4fb9aaf752030e7d2aa6e49e54f52827cb143cc869cfd748af"></a>HWLOC_MEMBIND_MIGRATE&#160;</td><td class="fielddoc"><p>Migrate existing allocated memory. If the memory cannot be migrated and the <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a> flag is passed, an error will be returned. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab00475fd98815bf4fb9aaf752030e7d2aad6b9eaf2ee324ca58dc8f58094b9997" name="ggab00475fd98815bf4fb9aaf752030e7d2aad6b9eaf2ee324ca58dc8f58094b9997"></a>HWLOC_MEMBIND_NOCPUBIND&#160;</td><td class="fielddoc"><p>Avoid any effect on CPU binding. </p>
+<p>On some operating systems, some underlying memory binding functions also bind the application to the corresponding CPU(s). Using this flag will cause hwloc to avoid using OS functions that could potentially affect CPU bindings. Note, however, that using NOCPUBIND may reduce hwloc's overall memory binding support. Specifically: some of hwloc's memory binding functions may fail with errno set to <code>ENOSYS</code> when used with NOCPUBIND. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" name="ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256"></a>HWLOC_MEMBIND_BYNODESET&#160;</td><td class="fielddoc"><p>Consider the bitmap argument as a nodeset. </p>
+<p>The bitmap argument is considered a nodeset if this flag is given, or a cpuset otherwise by default.</p>
+<p>Memory binding by CPU set cannot work for CPU-less NUMA memory nodes. Binding by nodeset should therefore be preferred whenever possible. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="gac9764f79505775d06407b40f5e4661e8" name="gac9764f79505775d06407b40f5e4661e8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac9764f79505775d06407b40f5e4661e8">&#9670;&#160;</a></span>hwloc_membind_policy_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Memory binding policy. </p>
+<p>These constants can be used to choose the binding policy. Only one policy can be used at a time (i.e., the values cannot be OR'ed together).</p>
+<p>Not all systems support all kinds of binding. <a class="el" href="a00182.html#gac0927e93a9b962143be08a48bbff2e19" title="Retrieve the topology support.">hwloc_topology_get_support()</a> may be used to query about the actual memory binding policy support in the currently used operating system. See the "Detailed Description" section of <a class="el" href="a00180.html">Memory binding</a> for a description of errors that can occur. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ggac9764f79505775d06407b40f5e4661e8a18675bb80ebc1bce5b652e9de8f3998c" name="ggac9764f79505775d06407b40f5e4661e8a18675bb80ebc1bce5b652e9de8f3998c"></a>HWLOC_MEMBIND_DEFAULT&#160;</td><td class="fielddoc"><p>Reset the memory allocation policy to the system default. Depending on the operating system, this may correspond to <a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a979c7aa78dd32780858f30f47a72cca0" title="Allocate each memory page individually on the local NUMA node of the thread that touches it.">HWLOC_MEMBIND_FIRSTTOUCH</a> (Linux, FreeBSD), or <a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c" title="Allocate memory on the specified nodes.">HWLOC_MEMBIND_BIND</a> (AIX, HP-UX, Solaris, Windows). This policy is never returned by get membind functions. The nodeset argument is ignored. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggac9764f79505775d06407b40f5e4661e8a979c7aa78dd32780858f30f47a72cca0" name="ggac9764f79505775d06407b40f5e4661e8a979c7aa78dd32780858f30f47a72cca0"></a>HWLOC_MEMBIND_FIRSTTOUCH&#160;</td><td class="fielddoc"><p>Allocate each memory page individually on the local NUMA node of the thread that touches it. </p>
+<p>The given nodeset should usually be <a class="el" href="a00191.html#ga3fd37303e99ace8b0d0ea03f95f8c514" title="Get topology node set.">hwloc_topology_get_topology_nodeset()</a> so that the touching thread may run and allocate on any node in the system.</p>
+<p>On AIX, if the nodeset is smaller, pages are allocated locally (if the local node is in the nodeset) or from a random non-local node (otherwise). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c" name="ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c"></a>HWLOC_MEMBIND_BIND&#160;</td><td class="fielddoc"><p>Allocate memory on the specified nodes. </p>
+<p>The actual behavior may slightly vary between operating systems, especially when (some of) the requested nodes are full. On Linux, by default, the MPOL_PREFERRED_MANY (or MPOL_PREFERRED) policy is used. However, if the hwloc strict flag is also given, the Linux MPOL_BIND policy is rather used. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggac9764f79505775d06407b40f5e4661e8ae370075e5af016d42310f87ea5af236b" name="ggac9764f79505775d06407b40f5e4661e8ae370075e5af016d42310f87ea5af236b"></a>HWLOC_MEMBIND_INTERLEAVE&#160;</td><td class="fielddoc"><p>Allocate memory on the given nodes in an interleaved / round-robin manner. The precise layout of the memory across multiple NUMA nodes is OS/system specific. Interleaving can be useful when threads distributed across the specified NUMA nodes will all be accessing the whole memory range concurrently, since the interleave will then balance the memory references. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggac9764f79505775d06407b40f5e4661e8aa091c40c9557b69a26b69a0e8b84dafe" name="ggac9764f79505775d06407b40f5e4661e8aa091c40c9557b69a26b69a0e8b84dafe"></a>HWLOC_MEMBIND_WEIGHTED_INTERLEAVE&#160;</td><td class="fielddoc"><p>Allocate memory on the given nodes in an interleaved / weighted manner. The precise layout of the memory across multiple NUMA nodes is OS/system specific. Weighted interleaving can be useful when threads distributed across the specified NUMA nodes with different bandwidth capabilities will all be accessing the whole memory range concurrently, since the interleave will then balance the memory references. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggac9764f79505775d06407b40f5e4661e8aecdd4164d647708fbb51a00d98dbb138" name="ggac9764f79505775d06407b40f5e4661e8aecdd4164d647708fbb51a00d98dbb138"></a>HWLOC_MEMBIND_NEXTTOUCH&#160;</td><td class="fielddoc"><p>For each page bound with this policy, by next time it is touched (and next time only), it is moved from its current location to the local NUMA node of the thread where the memory reference occurred (if it needs to be moved at all). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggac9764f79505775d06407b40f5e4661e8a3185bd869b67817fb2bd5164bf360402" name="ggac9764f79505775d06407b40f5e4661e8a3185bd869b67817fb2bd5164bf360402"></a>HWLOC_MEMBIND_MIXED&#160;</td><td class="fielddoc"><p>Returned by get_membind() functions when multiple threads or parts of a memory area have differing memory binding policies. Also returned when binding is unknown because binding hooks are empty when the topology is loaded from XML without HWLOC_THISSYSTEM=1, etc. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga95856d8f13357f247d5fce142d443ae3" name="ga95856d8f13357f247d5fce142d443ae3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga95856d8f13357f247d5fce142d443ae3">&#9670;&#160;</a></span>hwloc_alloc()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void * hwloc_alloc </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>len</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Allocate some memory. </p>
+<p>This is equivalent to malloc(), except that it tries to allocate page-aligned memory from the OS.</p>
+<dl class="section return"><dt>Returns</dt><dd>a pointer to the allocated area, or <code>NULL</code> on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>The allocated memory should be freed with <a class="el" href="a00180.html#ga32dbd4f54e9e4a7179f2dde37ffe6ad7" title="Free memory that was previously allocated by hwloc_alloc() or hwloc_alloc_membind().">hwloc_free()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="gadf87089ef533db40460ccc24b5bc0d65" name="gadf87089ef533db40460ccc24b5bc0d65"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gadf87089ef533db40460ccc24b5bc0d65">&#9670;&#160;</a></span>hwloc_alloc_membind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void * hwloc_alloc_membind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>len</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a>&#160;</td>
+          <td class="paramname"><em>policy</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Allocate some memory on NUMA memory nodes specified by <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>a pointer to the allocated area. </dd>
+<dd>
+NULL with errno set to <code>ENOSYS</code> if the action is not supported and <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a> is given. </dd>
+<dd>
+NULL with errno set to <code>EXDEV</code> if the binding cannot be enforced and <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a> is given. </dd>
+<dd>
+NULL with errno set to <code>ENOMEM</code> if the memory allocation failed even before trying to bind.</dd></dl>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" title="Consider the bitmap argument as a nodeset.">HWLOC_MEMBIND_BYNODESET</a> is specified, set is considered a nodeset. Otherwise it's a cpuset.</p>
+<dl class="section note"><dt>Note</dt><dd>The allocated memory should be freed with <a class="el" href="a00180.html#ga32dbd4f54e9e4a7179f2dde37ffe6ad7" title="Free memory that was previously allocated by hwloc_alloc() or hwloc_alloc_membind().">hwloc_free()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="ga64e5f75165ea52930f67b17ef4aed2e8" name="ga64e5f75165ea52930f67b17ef4aed2e8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga64e5f75165ea52930f67b17ef4aed2e8">&#9670;&#160;</a></span>hwloc_alloc_membind_policy()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static void * hwloc_alloc_membind_policy </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>len</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a>&#160;</td>
+          <td class="paramname"><em>policy</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Allocate some memory on NUMA memory nodes specified by <code>set</code>. </p>
+<p>First, try to allocate properly with <a class="el" href="a00180.html#gadf87089ef533db40460ccc24b5bc0d65" title="Allocate some memory on NUMA memory nodes specified by set.">hwloc_alloc_membind()</a>. On failure, the current process or thread memory binding policy is changed with <a class="el" href="a00180.html#ga020951efa0ce3862bd4faec295501a7f" title="Set the default memory binding policy of the current process or thread to prefer the NUMA node(s) spe...">hwloc_set_membind()</a> before allocating memory. Thus this function works in more cases, at the expense of changing the current state (possibly affecting future allocations that would not specify any policy).</p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" title="Consider the bitmap argument as a nodeset.">HWLOC_MEMBIND_BYNODESET</a> is specified, set is considered a nodeset. Otherwise it's a cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>a pointer to the allocated area, or <code>NULL</code> on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga32dbd4f54e9e4a7179f2dde37ffe6ad7" name="ga32dbd4f54e9e4a7179f2dde37ffe6ad7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga32dbd4f54e9e4a7179f2dde37ffe6ad7">&#9670;&#160;</a></span>hwloc_free()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_free </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">void *&#160;</td>
+          <td class="paramname"><em>addr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>len</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Free memory that was previously allocated by <a class="el" href="a00180.html#ga95856d8f13357f247d5fce142d443ae3" title="Allocate some memory.">hwloc_alloc()</a> or <a class="el" href="a00180.html#gadf87089ef533db40460ccc24b5bc0d65" title="Allocate some memory on NUMA memory nodes specified by set.">hwloc_alloc_membind()</a>. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gaa87e0a6946ff145914fdf0b1c60567f8" name="gaa87e0a6946ff145914fdf0b1c60567f8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa87e0a6946ff145914fdf0b1c60567f8">&#9670;&#160;</a></span>hwloc_get_area_membind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_area_membind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const void *&#160;</td>
+          <td class="paramname"><em>addr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>len</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> *&#160;</td>
+          <td class="paramname"><em>policy</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Query the CPUs near the physical NUMA node(s) and binding policy of the memory identified by (<code>addr</code>, <code>len</code> ). </p>
+<p>The bitmap <code>set</code> (previously allocated by the caller) is filled with the memory area binding.</p>
+<p>This function has two output parameters: <code>set</code> and <code>policy</code>. The values returned in these parameters depend on both the <code>flags</code> passed in and the memory binding policies and nodesets of the pages in the address range.</p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a> is specified, the target pages are first checked to see if they all have the same memory binding policy and nodeset. If they do not, -1 is returned and errno is set to <code>EXDEV</code>. If they are identical across all pages, the set and policy are returned in <code>set</code> and <code>policy</code>, respectively.</p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a> is not specified, the union of all NUMA node(s) containing pages in the address range is calculated. If all pages in the target have the same policy, it is returned in <code>policy</code>. Otherwise, <code>policy</code> is set to <a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a3185bd869b67817fb2bd5164bf360402" title="Returned by get_membind() functions when multiple threads or parts of a memory area have differing me...">HWLOC_MEMBIND_MIXED</a>.</p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" title="Consider the bitmap argument as a nodeset.">HWLOC_MEMBIND_BYNODESET</a> is specified, set is considered a nodeset. Otherwise it's a cpuset.</p>
+<p>If any other flags are specified, -1 is returned and errno is set to <code>EINVAL</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if <code>len</code> is 0. </dd></dl>
+
+</div>
+</div>
+<a id="ga537c7508a4e2d1db05673ec5be6e805c" name="ga537c7508a4e2d1db05673ec5be6e805c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga537c7508a4e2d1db05673ec5be6e805c">&#9670;&#160;</a></span>hwloc_get_area_memlocation()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_area_memlocation </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const void *&#160;</td>
+          <td class="paramname"><em>addr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>len</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the NUMA nodes where memory identified by (<code>addr</code>, <code>len</code> ) is physically allocated. </p>
+<p>The bitmap <code>set</code> (previously allocated by the caller) is filled according to the NUMA nodes where the memory area pages are physically allocated. If no page is actually allocated yet, <code>set</code> may be empty.</p>
+<p>If pages spread to multiple nodes, it is not specified whether they spread equitably, or whether most of them are on a single node, etc.</p>
+<p>The operating system may move memory pages from one processor to another at any time according to their binding, so this function may return something that is already outdated.</p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" title="Consider the bitmap argument as a nodeset.">HWLOC_MEMBIND_BYNODESET</a> is specified in <code>flags</code>, set is considered a nodeset. Otherwise it's a cpuset.</p>
+<p>If <code>len</code> is 0, <code>set</code> is emptied.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gae21f0a1a884929c784bebf070252aa56" name="gae21f0a1a884929c784bebf070252aa56"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gae21f0a1a884929c784bebf070252aa56">&#9670;&#160;</a></span>hwloc_get_membind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_membind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> *&#160;</td>
+          <td class="paramname"><em>policy</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Query the default memory binding policy and physical locality of the current process or thread. </p>
+<p>The bitmap <code>set</code> (previously allocated by the caller) is filled with the process or thread memory binding.</p>
+<p>This function has two output parameters: <code>set</code> and <code>policy</code>. The values returned in these parameters depend on both the <code>flags</code> passed in and the current memory binding policies and nodesets in the queried target.</p>
+<p>Passing the <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4" title="Set policy for all threads of the specified (possibly multithreaded) process. This flag is mutually e...">HWLOC_MEMBIND_PROCESS</a> flag specifies that the query target is the current policies and nodesets for all the threads in the current process. Passing <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298" title="Set policy for a specific thread of the current process. This flag is mutually exclusive with HWLOC_M...">HWLOC_MEMBIND_THREAD</a> specifies that the query target is the current policy and nodeset for only the thread invoking this function.</p>
+<p>If neither of these flags are passed (which is the most portable method), the process is assumed to be single threaded. This allows hwloc to use either process-based OS functions or thread-based OS functions, depending on which are available.</p>
+<p><a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a> is only meaningful when <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4" title="Set policy for all threads of the specified (possibly multithreaded) process. This flag is mutually e...">HWLOC_MEMBIND_PROCESS</a> is also specified. In this case, hwloc will check the default memory policies and nodesets for all threads in the process. If they are not identical, -1 is returned and errno is set to <code>EXDEV</code>. If they are identical, the values are returned in <code>set</code> and <code>policy</code>.</p>
+<p>Otherwise, if <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4" title="Set policy for all threads of the specified (possibly multithreaded) process. This flag is mutually e...">HWLOC_MEMBIND_PROCESS</a> is specified (and <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a> is <em>not</em> specified), the default set from each thread is logically OR'ed together. If all threads' default policies are the same, <code>policy</code> is set to that policy. If they are different, <code>policy</code> is set to <a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a3185bd869b67817fb2bd5164bf360402" title="Returned by get_membind() functions when multiple threads or parts of a memory area have differing me...">HWLOC_MEMBIND_MIXED</a>.</p>
+<p>In the <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298" title="Set policy for a specific thread of the current process. This flag is mutually exclusive with HWLOC_M...">HWLOC_MEMBIND_THREAD</a> case (or when neither <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4" title="Set policy for all threads of the specified (possibly multithreaded) process. This flag is mutually e...">HWLOC_MEMBIND_PROCESS</a> or <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298" title="Set policy for a specific thread of the current process. This flag is mutually exclusive with HWLOC_M...">HWLOC_MEMBIND_THREAD</a> is specified), there is only one set and policy; they are returned in <code>set</code> and <code>policy</code>, respectively.</p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" title="Consider the bitmap argument as a nodeset.">HWLOC_MEMBIND_BYNODESET</a> is specified, set is considered a nodeset. Otherwise it's a cpuset.</p>
+<p>If any other flags are specified, -1 is returned and errno is set to <code>EINVAL</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga1730ceb18ec6ee3b7bd3d0db81f07dc8" name="ga1730ceb18ec6ee3b7bd3d0db81f07dc8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1730ceb18ec6ee3b7bd3d0db81f07dc8">&#9670;&#160;</a></span>hwloc_get_proc_membind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_proc_membind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_pid_t&#160;</td>
+          <td class="paramname"><em>pid</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a> *&#160;</td>
+          <td class="paramname"><em>policy</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Query the default memory binding policy and physical locality of the specified process. </p>
+<p>The bitmap <code>set</code> (previously allocated by the caller) is filled with the process memory binding.</p>
+<p>This function has two output parameters: <code>set</code> and <code>policy</code>. The values returned in these parameters depend on both the <code>flags</code> passed in and the current memory binding policies and nodesets in the queried target.</p>
+<p>Passing the <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4" title="Set policy for all threads of the specified (possibly multithreaded) process. This flag is mutually e...">HWLOC_MEMBIND_PROCESS</a> flag specifies that the query target is the current policies and nodesets for all the threads in the specified process. If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4" title="Set policy for all threads of the specified (possibly multithreaded) process. This flag is mutually e...">HWLOC_MEMBIND_PROCESS</a> is not specified (which is the most portable method), the process is assumed to be single threaded. This allows hwloc to use either process-based OS functions or thread-based OS functions, depending on which are available.</p>
+<p>Note that it does not make sense to pass <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298" title="Set policy for a specific thread of the current process. This flag is mutually exclusive with HWLOC_M...">HWLOC_MEMBIND_THREAD</a> to this function.</p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a> is specified, hwloc will check the default memory policies and nodesets for all threads in the specified process. If they are not identical, -1 is returned and errno is set to <code>EXDEV</code>. If they are identical, the values are returned in <code>set</code> and <code>policy</code>.</p>
+<p>Otherwise, <code>set</code> is set to the logical OR of all threads' default set. If all threads' default policies are the same, <code>policy</code> is set to that policy. If they are different, <code>policy</code> is set to <a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8a3185bd869b67817fb2bd5164bf360402" title="Returned by get_membind() functions when multiple threads or parts of a memory area have differing me...">HWLOC_MEMBIND_MIXED</a>.</p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" title="Consider the bitmap argument as a nodeset.">HWLOC_MEMBIND_BYNODESET</a> is specified, set is considered a nodeset. Otherwise it's a cpuset.</p>
+<p>If any other flags are specified, -1 is returned and errno is set to <code>EINVAL</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd><code>hwloc_pid_t</code> is <code>pid_t</code> on Unix platforms, and <code>HANDLE</code> on native Windows platforms. </dd></dl>
+
+</div>
+</div>
+<a id="gaf881faefe20701229f07dd7dbd0125ed" name="gaf881faefe20701229f07dd7dbd0125ed"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf881faefe20701229f07dd7dbd0125ed">&#9670;&#160;</a></span>hwloc_set_area_membind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_set_area_membind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const void *&#160;</td>
+          <td class="paramname"><em>addr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>len</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a>&#160;</td>
+          <td class="paramname"><em>policy</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Bind the already-allocated memory identified by (addr, len) to the NUMA node(s) specified by <code>set</code>. </p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" title="Consider the bitmap argument as a nodeset.">HWLOC_MEMBIND_BYNODESET</a> is specified, set is considered a nodeset. Otherwise it's a cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success or if <code>len</code> is 0. </dd>
+<dd>
+-1 with errno set to <code>ENOSYS</code> if the action is not supported. </dd>
+<dd>
+-1 with errno set to <code>EXDEV</code> if the binding cannot be enforced. </dd></dl>
+
+</div>
+</div>
+<a id="ga020951efa0ce3862bd4faec295501a7f" name="ga020951efa0ce3862bd4faec295501a7f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga020951efa0ce3862bd4faec295501a7f">&#9670;&#160;</a></span>hwloc_set_membind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_set_membind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a>&#160;</td>
+          <td class="paramname"><em>policy</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set the default memory binding policy of the current process or thread to prefer the NUMA node(s) specified by <code>set</code>. </p>
+<p>If neither <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4" title="Set policy for all threads of the specified (possibly multithreaded) process. This flag is mutually e...">HWLOC_MEMBIND_PROCESS</a> nor <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298" title="Set policy for a specific thread of the current process. This flag is mutually exclusive with HWLOC_M...">HWLOC_MEMBIND_THREAD</a> is specified, the current process is assumed to be single-threaded. This is the most portable form as it permits hwloc to use either process-based OS functions or thread-based OS functions, depending on which are available.</p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" title="Consider the bitmap argument as a nodeset.">HWLOC_MEMBIND_BYNODESET</a> is specified, set is considered a nodeset. Otherwise it's a cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOSYS</code> if the action is not supported. </dd>
+<dd>
+-1 with errno set to <code>EXDEV</code> if the binding cannot be enforced. </dd></dl>
+
+</div>
+</div>
+<a id="gabc91ff16f7e41047924e3a4ae6d9da7e" name="gabc91ff16f7e41047924e3a4ae6d9da7e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gabc91ff16f7e41047924e3a4ae6d9da7e">&#9670;&#160;</a></span>hwloc_set_proc_membind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_set_proc_membind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_pid_t&#160;</td>
+          <td class="paramname"><em>pid</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00180.html#gac9764f79505775d06407b40f5e4661e8">hwloc_membind_policy_t</a>&#160;</td>
+          <td class="paramname"><em>policy</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set the default memory binding policy of the specified process to prefer the NUMA node(s) specified by <code>set</code>. </p>
+<p>If <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" title="Consider the bitmap argument as a nodeset.">HWLOC_MEMBIND_BYNODESET</a> is specified, set is considered a nodeset. Otherwise it's a cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOSYS</code> if the action is not supported. </dd>
+<dd>
+-1 with errno set to <code>EXDEV</code> if the binding cannot be enforced.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd><code>hwloc_pid_t</code> is <code>pid_t</code> on Unix platforms, and <code>HANDLE</code> on native Windows platforms. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00181.html 2.11.0-1/doc/doxygen-doc/html/a00181.html
--- 2.10.0-1/doc/doxygen-doc/html/a00181.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00181.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,311 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Changing the Source of Topology Discovery</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Changing the Source of Topology Discovery</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:ga949f656c779208a36790feba24048b7e" id="r_ga949f656c779208a36790feba24048b7e"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00181.html#ga949f656c779208a36790feba24048b7e">hwloc_topology_components_flag_e</a> { <a class="el" href="a00181.html#gga949f656c779208a36790feba24048b7ea33eec25d29253a2aba21dd3c731b416e">HWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST</a>
+ }</td></tr>
+<tr class="separator:ga949f656c779208a36790feba24048b7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga341fc17b5867a4715570baab131f68cd" id="r_ga341fc17b5867a4715570baab131f68cd"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00181.html#ga341fc17b5867a4715570baab131f68cd">hwloc_topology_set_pid</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict topology, hwloc_pid_t pid)</td></tr>
+<tr class="separator:ga341fc17b5867a4715570baab131f68cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga4fab186bb6181a00bcf585825fddd38d" id="r_ga4fab186bb6181a00bcf585825fddd38d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00181.html#ga4fab186bb6181a00bcf585825fddd38d">hwloc_topology_set_synthetic</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict topology, const char *restrict description)</td></tr>
+<tr class="separator:ga4fab186bb6181a00bcf585825fddd38d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga879439b7ee99407ee911b3ac64e9a25e" id="r_ga879439b7ee99407ee911b3ac64e9a25e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e">hwloc_topology_set_xml</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict topology, const char *restrict xmlpath)</td></tr>
+<tr class="separator:ga879439b7ee99407ee911b3ac64e9a25e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga2745616b65595e1c1e579ecc7e461fa8" id="r_ga2745616b65595e1c1e579ecc7e461fa8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00181.html#ga2745616b65595e1c1e579ecc7e461fa8">hwloc_topology_set_xmlbuffer</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict topology, const char *restrict buffer, int size)</td></tr>
+<tr class="separator:ga2745616b65595e1c1e579ecc7e461fa8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga9ad41adf418cee1c0ee32ba9bd4a3d36" id="r_ga9ad41adf418cee1c0ee32ba9bd4a3d36"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00181.html#ga9ad41adf418cee1c0ee32ba9bd4a3d36">hwloc_topology_set_components</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict topology, unsigned long flags, const char *restrict name)</td></tr>
+<tr class="separator:ga9ad41adf418cee1c0ee32ba9bd4a3d36"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>These functions must be called between <a class="el" href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa" title="Allocate a topology context.">hwloc_topology_init()</a> and <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>. Otherwise, they will return -1 with errno set to <code>EBUSY</code>.</p>
+<p>If none of the functions below is called, the default is to detect all the objects of the machine that the caller is allowed to access.</p>
+<p>This default behavior may also be modified through environment variables if the application did not modify it already. Setting HWLOC_XMLFILE in the environment enforces the discovery from a XML file as if <a class="el" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e" title="Enable XML-file based topology.">hwloc_topology_set_xml()</a> had been called. Setting HWLOC_SYNTHETIC enforces a synthetic topology as if <a class="el" href="a00181.html#ga4fab186bb6181a00bcf585825fddd38d" title="Enable synthetic topology.">hwloc_topology_set_synthetic()</a> had been called.</p>
+<p>Finally, HWLOC_THISSYSTEM enforces the return value of <a class="el" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017" title="Does the topology context come from this system?">hwloc_topology_is_thissystem()</a>. </p>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="ga949f656c779208a36790feba24048b7e" name="ga949f656c779208a36790feba24048b7e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga949f656c779208a36790feba24048b7e">&#9670;&#160;</a></span>hwloc_topology_components_flag_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00181.html#ga949f656c779208a36790feba24048b7e">hwloc_topology_components_flag_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Flags to be passed to <a class="el" href="a00181.html#ga9ad41adf418cee1c0ee32ba9bd4a3d36" title="Prevent a discovery component from being used for a topology.">hwloc_topology_set_components()</a> </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga949f656c779208a36790feba24048b7ea33eec25d29253a2aba21dd3c731b416e" name="gga949f656c779208a36790feba24048b7ea33eec25d29253a2aba21dd3c731b416e"></a>HWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST&#160;</td><td class="fielddoc"><p>Blacklist the target component from being used. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga9ad41adf418cee1c0ee32ba9bd4a3d36" name="ga9ad41adf418cee1c0ee32ba9bd4a3d36"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9ad41adf418cee1c0ee32ba9bd4a3d36">&#9670;&#160;</a></span>hwloc_topology_set_components()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_set_components </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *restrict&#160;</td>
+          <td class="paramname"><em>name</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Prevent a discovery component from being used for a topology. </p>
+<p><code>name</code> is the name of the discovery component that should not be used when loading topology <code>topology</code>. The name is a string such as "cuda".</p>
+<p>For components with multiple phases, it may also be suffixed with the name of a phase, for instance "linux:io".</p>
+<p><code>flags</code> should be <a class="el" href="a00181.html#gga949f656c779208a36790feba24048b7ea33eec25d29253a2aba21dd3c731b416e" title="Blacklist the target component from being used.">HWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST</a>.</p>
+<p>This may be used to avoid expensive parts of the discovery process. For instance, CUDA-specific discovery may be expensive and unneeded while generic I/O discovery could still be useful.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if flags are invalid. </dd></dl>
+
+</div>
+</div>
+<a id="ga341fc17b5867a4715570baab131f68cd" name="ga341fc17b5867a4715570baab131f68cd"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga341fc17b5867a4715570baab131f68cd">&#9670;&#160;</a></span>hwloc_topology_set_pid()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_set_pid </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_pid_t&#160;</td>
+          <td class="paramname"><em>pid</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Change which process the topology is viewed from. </p>
+<p>On some systems, processes may have different views of the machine, for instance the set of allowed CPUs. By default, hwloc exposes the view from the current process. Calling <a class="el" href="a00181.html#ga341fc17b5867a4715570baab131f68cd" title="Change which process the topology is viewed from.">hwloc_topology_set_pid()</a> permits to make it expose the topology of the machine from the point of view of another process.</p>
+<dl class="section note"><dt>Note</dt><dd><code>hwloc_pid_t</code> is <code>pid_t</code> on Unix platforms, and <code>HANDLE</code> on native Windows platforms.</dd>
+<dd>
+-1 is returned and errno is set to <code>ENOSYS</code> on platforms that do not support this feature.</dd>
+<dd>
+The PID will not actually be used until <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>. If the corresponding process exits in the meantime, hwloc will ignore the PID. If another process reuses the PID, the view of that process will be used.</dd></dl>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga4fab186bb6181a00bcf585825fddd38d" name="ga4fab186bb6181a00bcf585825fddd38d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga4fab186bb6181a00bcf585825fddd38d">&#9670;&#160;</a></span>hwloc_topology_set_synthetic()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_set_synthetic </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *restrict&#160;</td>
+          <td class="paramname"><em>description</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Enable synthetic topology. </p>
+<p>Gather topology information from the given <code>description</code>, a space-separated string of &lt;type:number&gt; describing the object type and arity at each level. All types may be omitted (space-separated string of numbers) so that hwloc chooses all types according to usual topologies. See also the <a class="el" href="a00386.html">Synthetic topologies</a>.</p>
+<p>Setting the environment variable HWLOC_SYNTHETIC may also result in this behavior.</p>
+<p>If <code>description</code> was properly parsed and describes a valid topology configuration, this function returns 0. Otherwise -1 is returned and errno is set to <code>EINVAL</code>.</p>
+<p>Note that this function does not actually load topology information; it just tells hwloc where to load it from. You'll still need to invoke <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a> to actually load the topology information.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if the description was invalid.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>For convenience, this backend provides empty binding hooks which just return success.</dd>
+<dd>
+On success, the synthetic component replaces the previously enabled component (if any), but the topology is not actually modified until <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="ga879439b7ee99407ee911b3ac64e9a25e" name="ga879439b7ee99407ee911b3ac64e9a25e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga879439b7ee99407ee911b3ac64e9a25e">&#9670;&#160;</a></span>hwloc_topology_set_xml()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_set_xml </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *restrict&#160;</td>
+          <td class="paramname"><em>xmlpath</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Enable XML-file based topology. </p>
+<p>Gather topology information from the XML file given at <code>xmlpath</code>. Setting the environment variable HWLOC_XMLFILE may also result in this behavior. This file may have been generated earlier with <a class="el" href="a00195.html#ga333f79975b4eeb28a3d8fad3373583ce" title="Export the topology into an XML file.">hwloc_topology_export_xml()</a> in <a class="el" href="a00113_source.html">hwloc/export.h</a>, or lstopo file.xml.</p>
+<p>Note that this function does not actually load topology information; it just tells hwloc where to load it from. You'll still need to invoke <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a> to actually load the topology information.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> on failure to read the XML file.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>See also <a class="el" href="a00195.html#ga5ac6917ea7289955fb1ffda4353af9b0" title="Set the application-specific callback for importing userdata.">hwloc_topology_set_userdata_import_callback()</a> for importing application-specific object userdata.</dd>
+<dd>
+For convenience, this backend provides empty binding hooks which just return success. To have hwloc still actually call OS-specific hooks, the <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" title="Assume that the selected backend provides the topology for the system on which we are running.">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a> has to be set to assert that the loaded file is really the underlying system.</dd>
+<dd>
+On success, the XML component replaces the previously enabled component (if any), but the topology is not actually modified until <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>.</dd>
+<dd>
+If an invalid XML input file is given, the error may be reported either here or later by <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a> depending on the XML library used by hwloc. </dd></dl>
+
+</div>
+</div>
+<a id="ga2745616b65595e1c1e579ecc7e461fa8" name="ga2745616b65595e1c1e579ecc7e461fa8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga2745616b65595e1c1e579ecc7e461fa8">&#9670;&#160;</a></span>hwloc_topology_set_xmlbuffer()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_set_xmlbuffer </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *restrict&#160;</td>
+          <td class="paramname"><em>buffer</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>size</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Enable XML based topology using a memory buffer (instead of a file, as with <a class="el" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e" title="Enable XML-file based topology.">hwloc_topology_set_xml()</a>). </p>
+<p>Gather topology information from the XML memory buffer given at <code>buffer</code> and of length <code>size</code> (including an ending \0). This buffer may have been filled earlier with <a class="el" href="a00195.html#gad33b7f7c11db10459505a3b1634fd3f1" title="Export the topology into a newly-allocated XML memory buffer.">hwloc_topology_export_xmlbuffer()</a> in <a class="el" href="a00113_source.html">hwloc/export.h</a>.</p>
+<p>Note that this function does not actually load topology information; it just tells hwloc where to load it from. You'll still need to invoke <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a> to actually load the topology information.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> on failure to read the XML buffer.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>See also <a class="el" href="a00195.html#ga5ac6917ea7289955fb1ffda4353af9b0" title="Set the application-specific callback for importing userdata.">hwloc_topology_set_userdata_import_callback()</a> for importing application-specific object userdata.</dd>
+<dd>
+For convenience, this backend provides empty binding hooks which just return success. To have hwloc still actually call OS-specific hooks, the <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" title="Assume that the selected backend provides the topology for the system on which we are running.">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a> has to be set to assert that the loaded file is really the underlying system.</dd>
+<dd>
+On success, the XML component replaces the previously enabled component (if any), but the topology is not actually modified until <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>.</dd>
+<dd>
+If an invalid XML input file is given, the error may be reported either here or later by <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a> depending on the XML library used by hwloc. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00182.html 2.11.0-1/doc/doxygen-doc/html/a00182.html
--- 2.10.0-1/doc/doxygen-doc/html/a00182.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00182.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,603 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Topology Detection Configuration and Query</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Topology Detection Configuration and Query</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00281.html">hwloc_topology_discovery_support</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html">hwloc_topology_cpubind_support</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html">hwloc_topology_membind_support</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00293.html">hwloc_topology_misc_support</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00297.html">hwloc_topology_support</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:gada025d3ec20b4b420f8038d23d6e7bde" id="r_gada025d3ec20b4b420f8038d23d6e7bde"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#gada025d3ec20b4b420f8038d23d6e7bde">hwloc_topology_flags_e</a> { <br />
+&#160;&#160;<a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a>
+, <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a>
+, <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea1b66bbd66e900e5c837f71defb32ad89">HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES</a>
+, <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdead93e82b8668ee90e4f9354e201a2ed9c">HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT</a> = (1UL&lt;&lt;3)
+, <br />
+&#160;&#160;<a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdeaa595aed197779012acf43e8ca4a2658d">HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING</a> = (1UL&lt;&lt;4)
+, <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea368d7741135fe309f3782c59644d3caa">HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING</a> = (1UL&lt;&lt;5)
+, <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdeae7a792e3db4360360a10f9160b10e631">HWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING</a> = (1UL&lt;&lt;6)
+, <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea5796b4909eba80f9727b66d07d3a7a05">HWLOC_TOPOLOGY_FLAG_NO_DISTANCES</a> = (1UL&lt;&lt;7)
+, <br />
+&#160;&#160;<a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdead5636766a6603f24486f79c48899c1c3">HWLOC_TOPOLOGY_FLAG_NO_MEMATTRS</a> = (1UL&lt;&lt;8)
+, <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea3497cd4c2f8b1d842dd49b3aaae56a24">HWLOC_TOPOLOGY_FLAG_NO_CPUKINDS</a> = (1UL&lt;&lt;9)
+<br />
+ }</td></tr>
+<tr class="separator:gada025d3ec20b4b420f8038d23d6e7bde"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga9a5a1f0140cd1952544477833733195b" id="r_ga9a5a1f0140cd1952544477833733195b"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> { <a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e">HWLOC_TYPE_FILTER_KEEP_ALL</a>
+, <a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a">HWLOC_TYPE_FILTER_KEEP_NONE</a>
+, <a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4">HWLOC_TYPE_FILTER_KEEP_STRUCTURE</a>
+, <a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5">HWLOC_TYPE_FILTER_KEEP_IMPORTANT</a>
+ }</td></tr>
+<tr class="separator:ga9a5a1f0140cd1952544477833733195b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gaaeed4df656979e5f16befea9d29b814b" id="r_gaaeed4df656979e5f16befea9d29b814b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#gaaeed4df656979e5f16befea9d29b814b">hwloc_topology_set_flags</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned long flags)</td></tr>
+<tr class="separator:gaaeed4df656979e5f16befea9d29b814b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga09318f81c1d4713be907d64748a6f93c" id="r_ga09318f81c1d4713be907d64748a6f93c"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#ga09318f81c1d4713be907d64748a6f93c">hwloc_topology_get_flags</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:ga09318f81c1d4713be907d64748a6f93c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga68ffdcfd9175cdf40709801092f18017" id="r_ga68ffdcfd9175cdf40709801092f18017"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017">hwloc_topology_is_thissystem</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict topology)</td></tr>
+<tr class="separator:ga68ffdcfd9175cdf40709801092f18017"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac0927e93a9b962143be08a48bbff2e19" id="r_gac0927e93a9b962143be08a48bbff2e19"><td class="memItemLeft" align="right" valign="top">const struct <a class="el" href="a00297.html">hwloc_topology_support</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#gac0927e93a9b962143be08a48bbff2e19">hwloc_topology_get_support</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict topology)</td></tr>
+<tr class="separator:gac0927e93a9b962143be08a48bbff2e19"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gad894e70f15f8d4aada7be8d1aba38b7e" id="r_gad894e70f15f8d4aada7be8d1aba38b7e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#gad894e70f15f8d4aada7be8d1aba38b7e">hwloc_topology_set_type_filter</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter)</td></tr>
+<tr class="separator:gad894e70f15f8d4aada7be8d1aba38b7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga137ad1178f7a79f2383974d983083401" id="r_ga137ad1178f7a79f2383974d983083401"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#ga137ad1178f7a79f2383974d983083401">hwloc_topology_get_type_filter</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> *filter)</td></tr>
+<tr class="separator:ga137ad1178f7a79f2383974d983083401"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga9eb8dc3b106f84921bf5789101e97e24" id="r_ga9eb8dc3b106f84921bf5789101e97e24"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#ga9eb8dc3b106f84921bf5789101e97e24">hwloc_topology_set_all_types_filter</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter)</td></tr>
+<tr class="separator:ga9eb8dc3b106f84921bf5789101e97e24"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga30bd6d330fe3c8f0cbaad724d114ee20" id="r_ga30bd6d330fe3c8f0cbaad724d114ee20"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#ga30bd6d330fe3c8f0cbaad724d114ee20">hwloc_topology_set_cache_types_filter</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter)</td></tr>
+<tr class="separator:ga30bd6d330fe3c8f0cbaad724d114ee20"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga37c7b2e599ed3cd76ad9164630024f30" id="r_ga37c7b2e599ed3cd76ad9164630024f30"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#ga37c7b2e599ed3cd76ad9164630024f30">hwloc_topology_set_icache_types_filter</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter)</td></tr>
+<tr class="separator:ga37c7b2e599ed3cd76ad9164630024f30"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga0ab38705357bc1203abe829da8a12ad3" id="r_ga0ab38705357bc1203abe829da8a12ad3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#ga0ab38705357bc1203abe829da8a12ad3">hwloc_topology_set_io_types_filter</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> filter)</td></tr>
+<tr class="separator:ga0ab38705357bc1203abe829da8a12ad3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga2cc7b7b155cba58dda203e54f1637b9c" id="r_ga2cc7b7b155cba58dda203e54f1637b9c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#ga2cc7b7b155cba58dda203e54f1637b9c">hwloc_topology_set_userdata</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const void *userdata)</td></tr>
+<tr class="separator:ga2cc7b7b155cba58dda203e54f1637b9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gad47dee1a30f4b00486b54872af030b43" id="r_gad47dee1a30f4b00486b54872af030b43"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00182.html#gad47dee1a30f4b00486b54872af030b43">hwloc_topology_get_userdata</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:gad47dee1a30f4b00486b54872af030b43"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>Several functions can optionally be called between <a class="el" href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa" title="Allocate a topology context.">hwloc_topology_init()</a> and <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a> to configure how the detection should be performed, e.g. to ignore some objects types, define a synthetic topology, etc. </p>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="gada025d3ec20b4b420f8038d23d6e7bde" name="gada025d3ec20b4b420f8038d23d6e7bde"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gada025d3ec20b4b420f8038d23d6e7bde">&#9670;&#160;</a></span>hwloc_topology_flags_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00182.html#gada025d3ec20b4b420f8038d23d6e7bde">hwloc_topology_flags_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Flags to be set onto a topology context before load. </p>
+<p>Flags should be given to <a class="el" href="a00182.html#gaaeed4df656979e5f16befea9d29b814b" title="Set OR&#39;ed flags to non-yet-loaded topology.">hwloc_topology_set_flags()</a>. They may also be returned by <a class="el" href="a00182.html#ga09318f81c1d4713be907d64748a6f93c" title="Get OR&#39;ed flags of a topology.">hwloc_topology_get_flags()</a>. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258" name="ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258"></a>HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED&#160;</td><td class="fielddoc"><p>Detect the whole system, ignore reservations, include disallowed objects. </p>
+<p>Gather all online resources, even if some were disabled by the administrator. For instance, ignore Linux Cgroup/Cpusets and gather all processors and memory nodes. However offline PUs and NUMA nodes are still ignored.</p>
+<p>When this flag is not set, PUs and NUMA nodes that are disallowed are not added to the topology. Parent objects (package, core, cache, etc.) are added only if some of their children are allowed. All existing PUs and NUMA nodes in the topology are allowed. <a class="el" href="a00191.html#ga517d5d68ec9f24583d8933aab713be8e" title="Get allowed CPU set.">hwloc_topology_get_allowed_cpuset()</a> and <a class="el" href="a00191.html#ga21a4d7237a11e76b912ed4524ab78cbd" title="Get allowed node set.">hwloc_topology_get_allowed_nodeset()</a> are equal to the root object cpuset and nodeset.</p>
+<p>When this flag is set, the actual sets of allowed PUs and NUMA nodes are given by <a class="el" href="a00191.html#ga517d5d68ec9f24583d8933aab713be8e" title="Get allowed CPU set.">hwloc_topology_get_allowed_cpuset()</a> and <a class="el" href="a00191.html#ga21a4d7237a11e76b912ed4524ab78cbd" title="Get allowed node set.">hwloc_topology_get_allowed_nodeset()</a>. They may be smaller than the root object cpuset and nodeset.</p>
+<p>If the current topology is exported to XML and reimported later, this flag should be set again in the reimported topology so that disallowed resources are reimported as well. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" name="ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b"></a>HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM&#160;</td><td class="fielddoc"><p>Assume that the selected backend provides the topology for the system on which we are running. </p>
+<p>This forces <a class="el" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017" title="Does the topology context come from this system?">hwloc_topology_is_thissystem()</a> to return 1, i.e. makes hwloc assume that the selected backend provides the topology for the system on which we are running, even if it is not the OS-specific backend but the XML backend for instance. This means making the binding functions actually call the OS-specific system calls and really do binding, while the XML backend would otherwise provide empty hooks just returning success.</p>
+<p>Setting the environment variable HWLOC_THISSYSTEM may also result in the same behavior.</p>
+<p>This can be used for efficiency reasons to first detect the topology once, save it to an XML file, and quickly reload it later through the XML backend, but still having binding functions actually do bind. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggada025d3ec20b4b420f8038d23d6e7bdea1b66bbd66e900e5c837f71defb32ad89" name="ggada025d3ec20b4b420f8038d23d6e7bdea1b66bbd66e900e5c837f71defb32ad89"></a>HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES&#160;</td><td class="fielddoc"><p>Get the set of allowed resources from the local operating system even if the topology was loaded from XML or synthetic description. </p>
+<p>If the topology was loaded from XML or from a synthetic string, restrict it by applying the current process restrictions such as Linux Cgroup/Cpuset.</p>
+<p>This is useful when the topology is not loaded directly from the local machine (e.g. for performance reason) and it comes with all resources, while the running process is restricted to only parts of the machine.</p>
+<p>This flag is ignored unless <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" title="Assume that the selected backend provides the topology for the system on which we are running.">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a> is also set since the loaded topology must match the underlying machine where restrictions will be gathered from.</p>
+<p>Setting the environment variable HWLOC_THISSYSTEM_ALLOWED_RESOURCES would result in the same behavior. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggada025d3ec20b4b420f8038d23d6e7bdead93e82b8668ee90e4f9354e201a2ed9c" name="ggada025d3ec20b4b420f8038d23d6e7bdead93e82b8668ee90e4f9354e201a2ed9c"></a>HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT&#160;</td><td class="fielddoc"><p>Import support from the imported topology. </p>
+<p>When importing a XML topology from a remote machine, binding is disabled by default (see <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" title="Assume that the selected backend provides the topology for the system on which we are running.">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a>). This disabling is also marked by putting zeroes in the corresponding supported feature bits reported by <a class="el" href="a00182.html#gac0927e93a9b962143be08a48bbff2e19" title="Retrieve the topology support.">hwloc_topology_get_support()</a>.</p>
+<p>The flag <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdead93e82b8668ee90e4f9354e201a2ed9c" title="Import support from the imported topology.">HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT</a> actually imports support bits from the remote machine. It also sets the flag <code>imported_support</code> in the struct <a class="el" href="a00293.html" title="Flags describing miscellaneous features.">hwloc_topology_misc_support</a> array. If the imported XML did not contain any support information (exporter hwloc is too old), this flag is not set.</p>
+<p>Note that these supported features are only relevant for the hwloc installation that actually exported the XML topology (it may vary with the operating system, or with how hwloc was compiled).</p>
+<p>Note that setting this flag however does not enable binding for the locally imported hwloc topology, it only reports what the remote hwloc and machine support. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggada025d3ec20b4b420f8038d23d6e7bdeaa595aed197779012acf43e8ca4a2658d" name="ggada025d3ec20b4b420f8038d23d6e7bdeaa595aed197779012acf43e8ca4a2658d"></a>HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING&#160;</td><td class="fielddoc"><p>Do not consider resources outside of the process CPU binding. </p>
+<p>If the binding of the process is limited to a subset of cores, ignore the other cores during discovery.</p>
+<p>The resulting topology is identical to what a call to <a class="el" href="a00183.html#ga6db81ed13ac0a9d70cc80372ab537815" title="Restrict the topology to the given CPU set or nodeset.">hwloc_topology_restrict()</a> would generate, but this flag also prevents hwloc from ever touching other resources during the discovery.</p>
+<p>This flag especially tells the x86 backend to never temporarily rebind a thread on any excluded core. This is useful on Windows because such temporary rebinding can change the process binding. Another use-case is to avoid cores that would not be able to perform the hwloc discovery anytime soon because they are busy executing some high-priority real-time tasks.</p>
+<p>If process CPU binding is not supported, the thread CPU binding is considered instead if supported, or the flag is ignored.</p>
+<p>This flag requires <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" title="Assume that the selected backend provides the topology for the system on which we are running.">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a> as well since binding support is required. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggada025d3ec20b4b420f8038d23d6e7bdea368d7741135fe309f3782c59644d3caa" name="ggada025d3ec20b4b420f8038d23d6e7bdea368d7741135fe309f3782c59644d3caa"></a>HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING&#160;</td><td class="fielddoc"><p>Do not consider resources outside of the process memory binding. </p>
+<p>If the binding of the process is limited to a subset of NUMA nodes, ignore the other NUMA nodes during discovery.</p>
+<p>The resulting topology is identical to what a call to <a class="el" href="a00183.html#ga6db81ed13ac0a9d70cc80372ab537815" title="Restrict the topology to the given CPU set or nodeset.">hwloc_topology_restrict()</a> would generate, but this flag also prevents hwloc from ever touching other resources during the discovery.</p>
+<p>This flag is meant to be used together with <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdeaa595aed197779012acf43e8ca4a2658d" title="Do not consider resources outside of the process CPU binding.">HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING</a> when both cores and NUMA nodes should be ignored outside of the process binding.</p>
+<p>If process memory binding is not supported, the thread memory binding is considered instead if supported, or the flag is ignored.</p>
+<p>This flag requires <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" title="Assume that the selected backend provides the topology for the system on which we are running.">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a> as well since binding support is required. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggada025d3ec20b4b420f8038d23d6e7bdeae7a792e3db4360360a10f9160b10e631" name="ggada025d3ec20b4b420f8038d23d6e7bdeae7a792e3db4360360a10f9160b10e631"></a>HWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING&#160;</td><td class="fielddoc"><p>Do not ever modify the process or thread binding during discovery. </p>
+<p>This flag disables all hwloc discovery steps that require a change of the process or thread binding. This currently only affects the x86 backend which gets entirely disabled.</p>
+<p>This is useful when <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a> is called while the application also creates additional threads or modifies the binding.</p>
+<p>This flag is also a strict way to make sure the process binding will not change to due thread binding changes on Windows (see <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdeaa595aed197779012acf43e8ca4a2658d" title="Do not consider resources outside of the process CPU binding.">HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING</a>). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggada025d3ec20b4b420f8038d23d6e7bdea5796b4909eba80f9727b66d07d3a7a05" name="ggada025d3ec20b4b420f8038d23d6e7bdea5796b4909eba80f9727b66d07d3a7a05"></a>HWLOC_TOPOLOGY_FLAG_NO_DISTANCES&#160;</td><td class="fielddoc"><p>Ignore distances. </p>
+<p>Ignore distance information from the operating systems (and from XML) and hence do not use distances for grouping. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggada025d3ec20b4b420f8038d23d6e7bdead5636766a6603f24486f79c48899c1c3" name="ggada025d3ec20b4b420f8038d23d6e7bdead5636766a6603f24486f79c48899c1c3"></a>HWLOC_TOPOLOGY_FLAG_NO_MEMATTRS&#160;</td><td class="fielddoc"><p>Ignore memory attributes and tiers. </p>
+<p>Ignore memory attribues from the operating systems (and from XML) Hence also do not try to build memory tiers. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggada025d3ec20b4b420f8038d23d6e7bdea3497cd4c2f8b1d842dd49b3aaae56a24" name="ggada025d3ec20b4b420f8038d23d6e7bdea3497cd4c2f8b1d842dd49b3aaae56a24"></a>HWLOC_TOPOLOGY_FLAG_NO_CPUKINDS&#160;</td><td class="fielddoc"><p>Ignore CPU Kinds. </p>
+<p>Ignore CPU kind information from the operating systems (and from XML). </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="ga9a5a1f0140cd1952544477833733195b" name="ga9a5a1f0140cd1952544477833733195b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9a5a1f0140cd1952544477833733195b">&#9670;&#160;</a></span>hwloc_type_filter_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type filtering flags. </p>
+<p>By default, most objects are kept (<a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e" title="Keep all objects of this type.">HWLOC_TYPE_FILTER_KEEP_ALL</a>). Instruction caches, memory-side caches, I/O and Misc objects are ignored by default (<a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a" title="Ignore all objects of this type.">HWLOC_TYPE_FILTER_KEEP_NONE</a>). Group levels are ignored unless they bring structure (<a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4" title="Only ignore objects if their entire level does not bring any structure.">HWLOC_TYPE_FILTER_KEEP_STRUCTURE</a>).</p>
+<p>Note that group objects are also ignored individually (without the entire level) when they do not bring structure. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e" name="gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e"></a>HWLOC_TYPE_FILTER_KEEP_ALL&#160;</td><td class="fielddoc"><p>Keep all objects of this type. </p>
+<p>Cannot be set for <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56" title="Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take...">HWLOC_OBJ_GROUP</a> (groups are designed only to add more structure to the topology). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a" name="gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a"></a>HWLOC_TYPE_FILTER_KEEP_NONE&#160;</td><td class="fielddoc"><p>Ignore all objects of this type. </p>
+<p>The bottom-level type <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661" title="Processing Unit, or (Logical) Processor. An execution unit (may share a core with some other logical ...">HWLOC_OBJ_PU</a>, the <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a" title="NUMA node. An object that contains memory that is directly and byte-accessible to the host processors...">HWLOC_OBJ_NUMANODE</a> type, and the top-level type <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a3f4e83ffc4a259354959ae8a9eaa2a80" title="Machine. A set of processors and memory with cache coherency.">HWLOC_OBJ_MACHINE</a> may not be ignored. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4" name="gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4"></a>HWLOC_TYPE_FILTER_KEEP_STRUCTURE&#160;</td><td class="fielddoc"><p>Only ignore objects if their entire level does not bring any structure. </p>
+<p>Keep the entire level of objects if at least one of these objects adds structure to the topology. An object brings structure when it has multiple children and it is not the only child of its parent.</p>
+<p>If all objects in the level are the only child of their parent, and if none of them has multiple children, the entire level is removed.</p>
+<p>Cannot be set for I/O and Misc objects since the topology structure does not matter there. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5" name="gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5"></a>HWLOC_TYPE_FILTER_KEEP_IMPORTANT&#160;</td><td class="fielddoc"><p>Only keep likely-important objects of the given type. </p>
+<p>It is only useful for I/O object types. For <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9" title="PCI device (filtered out by default).">HWLOC_OBJ_PCI_DEVICE</a> and <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075" title="Operating system device (filtered out by default).">HWLOC_OBJ_OS_DEVICE</a>, it means that only objects of major/common kinds are kept (storage, network, OpenFabrics, CUDA, OpenCL, RSMI, NVML, and displays). Also, only OS devices directly attached on PCI (e.g. no USB) are reported. For <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0" title="Bridge (filtered out by default). Any bridge (or PCI switch) that connects the host or an I/O bus,...">HWLOC_OBJ_BRIDGE</a>, it means that bridges are kept only if they have children.</p>
+<p>This flag equivalent to <a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e" title="Keep all objects of this type.">HWLOC_TYPE_FILTER_KEEP_ALL</a> for Normal, Memory and Misc types since they are likely important. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga09318f81c1d4713be907d64748a6f93c" name="ga09318f81c1d4713be907d64748a6f93c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga09318f81c1d4713be907d64748a6f93c">&#9670;&#160;</a></span>hwloc_topology_get_flags()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned long hwloc_topology_get_flags </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get OR'ed flags of a topology. </p>
+<p>Get the OR'ed set of <a class="el" href="a00182.html#gada025d3ec20b4b420f8038d23d6e7bde" title="Flags to be set onto a topology context before load.">hwloc_topology_flags_e</a> of a topology.</p>
+<p>If <a class="el" href="a00182.html#gaaeed4df656979e5f16befea9d29b814b" title="Set OR&#39;ed flags to non-yet-loaded topology.">hwloc_topology_set_flags()</a> was not called earlier, no flags are set (<code>0</code> is returned).</p>
+<dl class="section return"><dt>Returns</dt><dd>the flags previously set with <a class="el" href="a00182.html#gaaeed4df656979e5f16befea9d29b814b" title="Set OR&#39;ed flags to non-yet-loaded topology.">hwloc_topology_set_flags()</a>.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function may also be called after <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="gac0927e93a9b962143be08a48bbff2e19" name="gac0927e93a9b962143be08a48bbff2e19"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac0927e93a9b962143be08a48bbff2e19">&#9670;&#160;</a></span>hwloc_topology_get_support()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">const struct <a class="el" href="a00297.html">hwloc_topology_support</a> * hwloc_topology_get_support </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Retrieve the topology support. </p>
+<p>Each flag indicates whether a feature is supported. If set to 0, the feature is not supported. If set to 1, the feature is supported, but the corresponding call may still fail in some corner cases.</p>
+<p>These features are also listed by hwloc-info --support</p>
+<p>The reported features are what the current topology supports on the current machine. If the topology was exported to XML from another machine and later imported here, support still describes what is supported for this imported topology after import. By default, binding will be reported as unsupported in this case (see <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" title="Assume that the selected backend provides the topology for the system on which we are running.">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a>).</p>
+<p>Topology flag <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdead93e82b8668ee90e4f9354e201a2ed9c" title="Import support from the imported topology.">HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT</a> may be used to report the supported features of the original remote machine instead. If it was successfully imported, <code>imported_support</code> will be set in the struct <a class="el" href="a00293.html" title="Flags describing miscellaneous features.">hwloc_topology_misc_support</a> array.</p>
+<dl class="section return"><dt>Returns</dt><dd>A pointer to a support structure.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>The function cannot return <code>NULL</code>. </dd>
+<dd>
+The returned pointer should not be freed, it belongs to the hwloc library.</dd>
+<dd>
+This function may be called before or after <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a> but the support structure only contains valid information after. </dd></dl>
+
+</div>
+</div>
+<a id="ga137ad1178f7a79f2383974d983083401" name="ga137ad1178f7a79f2383974d983083401"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga137ad1178f7a79f2383974d983083401">&#9670;&#160;</a></span>hwloc_topology_get_type_filter()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_get_type_filter </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a> *&#160;</td>
+          <td class="paramname"><em>filter</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the current filtering for the given object type. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gad47dee1a30f4b00486b54872af030b43" name="gad47dee1a30f4b00486b54872af030b43"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad47dee1a30f4b00486b54872af030b43">&#9670;&#160;</a></span>hwloc_topology_get_userdata()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void * hwloc_topology_get_userdata </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Retrieve the topology-specific userdata pointer. </p>
+<p>Retrieve the application-given private data pointer that was previously set with <a class="el" href="a00182.html#ga2cc7b7b155cba58dda203e54f1637b9c" title="Set the topology-specific userdata pointer.">hwloc_topology_set_userdata()</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>A pointer to the private-data if any. </dd>
+<dd>
+<code>NULL</code> if no private-data was previoulsy set. </dd></dl>
+
+</div>
+</div>
+<a id="ga68ffdcfd9175cdf40709801092f18017" name="ga68ffdcfd9175cdf40709801092f18017"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga68ffdcfd9175cdf40709801092f18017">&#9670;&#160;</a></span>hwloc_topology_is_thissystem()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_is_thissystem </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Does the topology context come from this system? </p>
+<dl class="section return"><dt>Returns</dt><dd>1 if this topology context was built using the system running this program. </dd>
+<dd>
+0 instead (for instance if using another file-system root, a XML topology file, or a synthetic topology).</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function may also be called after <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="ga9eb8dc3b106f84921bf5789101e97e24" name="ga9eb8dc3b106f84921bf5789101e97e24"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9eb8dc3b106f84921bf5789101e97e24">&#9670;&#160;</a></span>hwloc_topology_set_all_types_filter()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_set_all_types_filter </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a>&#160;</td>
+          <td class="paramname"><em>filter</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set the filtering for all object types. </p>
+<p>If some types do not support this filtering, they are silently ignored.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga30bd6d330fe3c8f0cbaad724d114ee20" name="ga30bd6d330fe3c8f0cbaad724d114ee20"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga30bd6d330fe3c8f0cbaad724d114ee20">&#9670;&#160;</a></span>hwloc_topology_set_cache_types_filter()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_set_cache_types_filter </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a>&#160;</td>
+          <td class="paramname"><em>filter</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set the filtering for all CPU cache object types. </p>
+<p>Memory-side caches are not involved since they are not CPU caches.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gaaeed4df656979e5f16befea9d29b814b" name="gaaeed4df656979e5f16befea9d29b814b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaaeed4df656979e5f16befea9d29b814b">&#9670;&#160;</a></span>hwloc_topology_set_flags()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_set_flags </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set OR'ed flags to non-yet-loaded topology. </p>
+<p>Set a OR'ed set of <a class="el" href="a00182.html#gada025d3ec20b4b420f8038d23d6e7bde" title="Flags to be set onto a topology context before load.">hwloc_topology_flags_e</a> onto a topology that was not yet loaded.</p>
+<p>If this function is called multiple times, the last invocation will erase and replace the set of flags that was previously set.</p>
+<p>By default, no flags are set (<code>0</code>).</p>
+<p>The flags set in a topology may be retrieved with <a class="el" href="a00182.html#ga09318f81c1d4713be907d64748a6f93c" title="Get OR&#39;ed flags of a topology.">hwloc_topology_get_flags()</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if flags are invalid. </dd></dl>
+
+</div>
+</div>
+<a id="ga37c7b2e599ed3cd76ad9164630024f30" name="ga37c7b2e599ed3cd76ad9164630024f30"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga37c7b2e599ed3cd76ad9164630024f30">&#9670;&#160;</a></span>hwloc_topology_set_icache_types_filter()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_set_icache_types_filter </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a>&#160;</td>
+          <td class="paramname"><em>filter</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set the filtering for all CPU instruction cache object types. </p>
+<p>Memory-side caches are not involved since they are not CPU caches.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga0ab38705357bc1203abe829da8a12ad3" name="ga0ab38705357bc1203abe829da8a12ad3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga0ab38705357bc1203abe829da8a12ad3">&#9670;&#160;</a></span>hwloc_topology_set_io_types_filter()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_set_io_types_filter </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a>&#160;</td>
+          <td class="paramname"><em>filter</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set the filtering for all I/O object types. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gad894e70f15f8d4aada7be8d1aba38b7e" name="gad894e70f15f8d4aada7be8d1aba38b7e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad894e70f15f8d4aada7be8d1aba38b7e">&#9670;&#160;</a></span>hwloc_topology_set_type_filter()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_set_type_filter </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">enum <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b">hwloc_type_filter_e</a>&#160;</td>
+          <td class="paramname"><em>filter</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set the filtering for the given object type. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga2cc7b7b155cba58dda203e54f1637b9c" name="ga2cc7b7b155cba58dda203e54f1637b9c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga2cc7b7b155cba58dda203e54f1637b9c">&#9670;&#160;</a></span>hwloc_topology_set_userdata()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_topology_set_userdata </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const void *&#160;</td>
+          <td class="paramname"><em>userdata</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set the topology-specific userdata pointer. </p>
+<p>Each topology may store one application-given private data pointer. It is initialized to <code>NULL</code>. hwloc will never modify it.</p>
+<p>Use it as you wish, after <a class="el" href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa" title="Allocate a topology context.">hwloc_topology_init()</a> and until hwloc_topolog_destroy().</p>
+<p>This pointer is not exported to XML. </p>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00183.html 2.11.0-1/doc/doxygen-doc/html/a00183.html
--- 2.10.0-1/doc/doxygen-doc/html/a00183.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00183.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,466 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Modifying a loaded Topology</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Modifying a loaded Topology</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:ga9d80f08eb25b7ac22f1b998dc8bf521f" id="r_ga9d80f08eb25b7ac22f1b998dc8bf521f"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00183.html#ga9d80f08eb25b7ac22f1b998dc8bf521f">hwloc_restrict_flags_e</a> { <br />
+&#160;&#160;<a class="el" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fa80eeb9cbba401ab050f8fb4573725891">HWLOC_RESTRICT_FLAG_REMOVE_CPULESS</a>
+, <a class="el" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fae4c5b1b87232f2d8a60559e77ac65a68">HWLOC_RESTRICT_FLAG_BYNODESET</a> = (1UL&lt;&lt;3)
+, <a class="el" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521faf5ba49808855704bfe9cb9fe7347f93b">HWLOC_RESTRICT_FLAG_REMOVE_MEMLESS</a>
+, <a class="el" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fa699969227a09bbc1a7de51dc9fb7be4b">HWLOC_RESTRICT_FLAG_ADAPT_MISC</a>
+, <br />
+&#160;&#160;<a class="el" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521faa95d6985e36ec1e55f68b210297a85cb">HWLOC_RESTRICT_FLAG_ADAPT_IO</a>
+<br />
+ }</td></tr>
+<tr class="separator:ga9d80f08eb25b7ac22f1b998dc8bf521f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga38b1be3922094d880f6e76bf56c973d6" id="r_ga38b1be3922094d880f6e76bf56c973d6"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00183.html#ga38b1be3922094d880f6e76bf56c973d6">hwloc_allow_flags_e</a> { <a class="el" href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6aca107692455774f9d323d21b8abfce72">HWLOC_ALLOW_FLAG_ALL</a>
+, <a class="el" href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6a88c50088c09dcf1e1a496c0817556fb9">HWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS</a>
+, <a class="el" href="a00183.html#gga38b1be3922094d880f6e76bf56c973d6a489c8c1b67ce7e0b8cf7a665852760e1">HWLOC_ALLOW_FLAG_CUSTOM</a>
+ }</td></tr>
+<tr class="separator:ga38b1be3922094d880f6e76bf56c973d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga6db81ed13ac0a9d70cc80372ab537815" id="r_ga6db81ed13ac0a9d70cc80372ab537815"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00183.html#ga6db81ed13ac0a9d70cc80372ab537815">hwloc_topology_restrict</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict topology, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> set, unsigned long flags)</td></tr>
+<tr class="separator:ga6db81ed13ac0a9d70cc80372ab537815"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaf955b190c0299dcfb5bc985d777f92a1" id="r_gaf955b190c0299dcfb5bc985d777f92a1"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00183.html#gaf955b190c0299dcfb5bc985d777f92a1">hwloc_topology_allow</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> cpuset, <a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> nodeset, unsigned long flags)</td></tr>
+<tr class="separator:gaf955b190c0299dcfb5bc985d777f92a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gad980782ade737900c5cf208946768c30" id="r_gad980782ade737900c5cf208946768c30"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00183.html#gad980782ade737900c5cf208946768c30">hwloc_topology_insert_misc_object</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> parent, const char *name)</td></tr>
+<tr class="separator:gad980782ade737900c5cf208946768c30"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga4cea4741165faf5323931a9ed8786ef7" id="r_ga4cea4741165faf5323931a9ed8786ef7"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7">hwloc_topology_alloc_group_object</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:ga4cea4741165faf5323931a9ed8786ef7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac09117be24a8fc5f5dea6acac34e8843" id="r_gac09117be24a8fc5f5dea6acac34e8843"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00183.html#gac09117be24a8fc5f5dea6acac34e8843">hwloc_topology_free_group_object</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> group)</td></tr>
+<tr class="separator:gac09117be24a8fc5f5dea6acac34e8843"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1fc6012b3e1c249b83f48cb7bcacaa5b" id="r_ga1fc6012b3e1c249b83f48cb7bcacaa5b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00183.html#ga1fc6012b3e1c249b83f48cb7bcacaa5b">hwloc_topology_insert_group_object</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> group)</td></tr>
+<tr class="separator:ga1fc6012b3e1c249b83f48cb7bcacaa5b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gad458715d3335df44849216cc123d1055" id="r_gad458715d3335df44849216cc123d1055"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00183.html#gad458715d3335df44849216cc123d1055">hwloc_obj_add_other_obj_sets</a> (<a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> dst, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> src)</td></tr>
+<tr class="separator:gad458715d3335df44849216cc123d1055"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga698ecd640d2b76742bba3829a145cd9a" id="r_ga698ecd640d2b76742bba3829a145cd9a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00183.html#ga698ecd640d2b76742bba3829a145cd9a">hwloc_topology_refresh</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:ga698ecd640d2b76742bba3829a145cd9a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="ga38b1be3922094d880f6e76bf56c973d6" name="ga38b1be3922094d880f6e76bf56c973d6"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga38b1be3922094d880f6e76bf56c973d6">&#9670;&#160;</a></span>hwloc_allow_flags_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00183.html#ga38b1be3922094d880f6e76bf56c973d6">hwloc_allow_flags_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Flags to be given to <a class="el" href="a00183.html#gaf955b190c0299dcfb5bc985d777f92a1" title="Change the sets of allowed PUs and NUMA nodes in the topology.">hwloc_topology_allow()</a>. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga38b1be3922094d880f6e76bf56c973d6aca107692455774f9d323d21b8abfce72" name="gga38b1be3922094d880f6e76bf56c973d6aca107692455774f9d323d21b8abfce72"></a>HWLOC_ALLOW_FLAG_ALL&#160;</td><td class="fielddoc"><p>Mark all objects as allowed in the topology. </p>
+<p><code>cpuset</code> and <code>nođeset</code> given to <a class="el" href="a00183.html#gaf955b190c0299dcfb5bc985d777f92a1" title="Change the sets of allowed PUs and NUMA nodes in the topology.">hwloc_topology_allow()</a> must be <code>NULL</code>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga38b1be3922094d880f6e76bf56c973d6a88c50088c09dcf1e1a496c0817556fb9" name="gga38b1be3922094d880f6e76bf56c973d6a88c50088c09dcf1e1a496c0817556fb9"></a>HWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS&#160;</td><td class="fielddoc"><p>Only allow objects that are available to the current process. </p>
+<p>The topology must have <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" title="Assume that the selected backend provides the topology for the system on which we are running.">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a> so that the set of available resources can actually be retrieved from the operating system.</p>
+<p><code>cpuset</code> and <code>nođeset</code> given to <a class="el" href="a00183.html#gaf955b190c0299dcfb5bc985d777f92a1" title="Change the sets of allowed PUs and NUMA nodes in the topology.">hwloc_topology_allow()</a> must be <code>NULL</code>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga38b1be3922094d880f6e76bf56c973d6a489c8c1b67ce7e0b8cf7a665852760e1" name="gga38b1be3922094d880f6e76bf56c973d6a489c8c1b67ce7e0b8cf7a665852760e1"></a>HWLOC_ALLOW_FLAG_CUSTOM&#160;</td><td class="fielddoc"><p>Allow a custom set of objects, given to <a class="el" href="a00183.html#gaf955b190c0299dcfb5bc985d777f92a1" title="Change the sets of allowed PUs and NUMA nodes in the topology.">hwloc_topology_allow()</a> as <code>cpuset</code> and/or <code>nodeset</code> parameters. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="ga9d80f08eb25b7ac22f1b998dc8bf521f" name="ga9d80f08eb25b7ac22f1b998dc8bf521f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9d80f08eb25b7ac22f1b998dc8bf521f">&#9670;&#160;</a></span>hwloc_restrict_flags_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00183.html#ga9d80f08eb25b7ac22f1b998dc8bf521f">hwloc_restrict_flags_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Flags to be given to <a class="el" href="a00183.html#ga6db81ed13ac0a9d70cc80372ab537815" title="Restrict the topology to the given CPU set or nodeset.">hwloc_topology_restrict()</a>. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga9d80f08eb25b7ac22f1b998dc8bf521fa80eeb9cbba401ab050f8fb4573725891" name="gga9d80f08eb25b7ac22f1b998dc8bf521fa80eeb9cbba401ab050f8fb4573725891"></a>HWLOC_RESTRICT_FLAG_REMOVE_CPULESS&#160;</td><td class="fielddoc"><p>Remove all objects that became CPU-less. By default, only objects that contain no PU and no memory are removed. This flag may not be used with <a class="el" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fae4c5b1b87232f2d8a60559e77ac65a68" title="Restrict by nodeset instead of CPU set. Only keep objects whose nodeset is included or partially incl...">HWLOC_RESTRICT_FLAG_BYNODESET</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga9d80f08eb25b7ac22f1b998dc8bf521fae4c5b1b87232f2d8a60559e77ac65a68" name="gga9d80f08eb25b7ac22f1b998dc8bf521fae4c5b1b87232f2d8a60559e77ac65a68"></a>HWLOC_RESTRICT_FLAG_BYNODESET&#160;</td><td class="fielddoc"><p>Restrict by nodeset instead of CPU set. Only keep objects whose nodeset is included or partially included in the given set. This flag may not be used with <a class="el" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fa80eeb9cbba401ab050f8fb4573725891" title="Remove all objects that became CPU-less. By default, only objects that contain no PU and no memory ar...">HWLOC_RESTRICT_FLAG_REMOVE_CPULESS</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga9d80f08eb25b7ac22f1b998dc8bf521faf5ba49808855704bfe9cb9fe7347f93b" name="gga9d80f08eb25b7ac22f1b998dc8bf521faf5ba49808855704bfe9cb9fe7347f93b"></a>HWLOC_RESTRICT_FLAG_REMOVE_MEMLESS&#160;</td><td class="fielddoc"><p>Remove all objects that became Memory-less. By default, only objects that contain no PU and no memory are removed. This flag may only be used with <a class="el" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fae4c5b1b87232f2d8a60559e77ac65a68" title="Restrict by nodeset instead of CPU set. Only keep objects whose nodeset is included or partially incl...">HWLOC_RESTRICT_FLAG_BYNODESET</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga9d80f08eb25b7ac22f1b998dc8bf521fa699969227a09bbc1a7de51dc9fb7be4b" name="gga9d80f08eb25b7ac22f1b998dc8bf521fa699969227a09bbc1a7de51dc9fb7be4b"></a>HWLOC_RESTRICT_FLAG_ADAPT_MISC&#160;</td><td class="fielddoc"><p>Move Misc objects to ancestors if their parents are removed during restriction. If this flag is not set, Misc objects are removed when their parents are removed. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga9d80f08eb25b7ac22f1b998dc8bf521faa95d6985e36ec1e55f68b210297a85cb" name="gga9d80f08eb25b7ac22f1b998dc8bf521faa95d6985e36ec1e55f68b210297a85cb"></a>HWLOC_RESTRICT_FLAG_ADAPT_IO&#160;</td><td class="fielddoc"><p>Move I/O objects to ancestors if their parents are removed during restriction. If this flag is not set, I/O devices and bridges are removed when their parents are removed. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gad458715d3335df44849216cc123d1055" name="gad458715d3335df44849216cc123d1055"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad458715d3335df44849216cc123d1055">&#9670;&#160;</a></span>hwloc_obj_add_other_obj_sets()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_add_other_obj_sets </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>dst</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>src</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Setup object cpusets/nodesets by OR'ing another object's sets. </p>
+<p>For each defined cpuset or nodeset in <code>src</code>, allocate the corresponding set in <code>dst</code> and add <code>src</code> to it by OR'ing sets.</p>
+<p>This function is convenient between <a class="el" href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7" title="Allocate a Group object to insert later with hwloc_topology_insert_group_object().">hwloc_topology_alloc_group_object()</a> and <a class="el" href="a00183.html#ga1fc6012b3e1c249b83f48cb7bcacaa5b" title="Add more structure to the topology by adding an intermediate Group.">hwloc_topology_insert_group_object()</a>. It builds the sets of the new Group that will be inserted as a new intermediate parent of several objects.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOMEM</code> if some internal reallocation failed. </dd></dl>
+
+</div>
+</div>
+<a id="ga4cea4741165faf5323931a9ed8786ef7" name="ga4cea4741165faf5323931a9ed8786ef7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga4cea4741165faf5323931a9ed8786ef7">&#9670;&#160;</a></span>hwloc_topology_alloc_group_object()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_topology_alloc_group_object </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Allocate a Group object to insert later with <a class="el" href="a00183.html#ga1fc6012b3e1c249b83f48cb7bcacaa5b" title="Add more structure to the topology by adding an intermediate Group.">hwloc_topology_insert_group_object()</a>. </p>
+<p>This function returns a new Group object.</p>
+<p>The caller should (at least) initialize its sets before inserting the object in the topology, see <a class="el" href="a00183.html#ga1fc6012b3e1c249b83f48cb7bcacaa5b" title="Add more structure to the topology by adding an intermediate Group.">hwloc_topology_insert_group_object()</a>. Or it may decide not to insert and just free the group object by calling <a class="el" href="a00183.html#gac09117be24a8fc5f5dea6acac34e8843" title="Free a group object allocated with hwloc_topology_alloc_group_object().">hwloc_topology_free_group_object()</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>The allocated object on success. </dd>
+<dd>
+<code>NULL</code> on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>If successfully inserted by <a class="el" href="a00183.html#ga1fc6012b3e1c249b83f48cb7bcacaa5b" title="Add more structure to the topology by adding an intermediate Group.">hwloc_topology_insert_group_object()</a>, the object will be freed when the entire topology is freed. If insertion failed (e.g. <code>NULL</code> or empty CPU and node-sets), it is freed before returning the error. </dd></dl>
+
+</div>
+</div>
+<a id="gaf955b190c0299dcfb5bc985d777f92a1" name="gaf955b190c0299dcfb5bc985d777f92a1"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf955b190c0299dcfb5bc985d777f92a1">&#9670;&#160;</a></span>hwloc_topology_allow()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_allow </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>cpuset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a>&#160;</td>
+          <td class="paramname"><em>nodeset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Change the sets of allowed PUs and NUMA nodes in the topology. </p>
+<p>This function only works if the <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258" title="Detect the whole system, ignore reservations, include disallowed objects.">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a> was set on the topology. It does not modify any object, it only changes the sets returned by <a class="el" href="a00191.html#ga517d5d68ec9f24583d8933aab713be8e" title="Get allowed CPU set.">hwloc_topology_get_allowed_cpuset()</a> and <a class="el" href="a00191.html#ga21a4d7237a11e76b912ed4524ab78cbd" title="Get allowed node set.">hwloc_topology_get_allowed_nodeset()</a>.</p>
+<p>It is notably useful when importing a topology from another process running in a different Linux Cgroup.</p>
+<p><code>flags</code> must be set to one flag among <a class="el" href="a00183.html#ga38b1be3922094d880f6e76bf56c973d6" title="Flags to be given to hwloc_topology_allow().">hwloc_allow_flags_e</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Removing objects from a topology should rather be performed with <a class="el" href="a00183.html#ga6db81ed13ac0a9d70cc80372ab537815" title="Restrict the topology to the given CPU set or nodeset.">hwloc_topology_restrict()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="gac09117be24a8fc5f5dea6acac34e8843" name="gac09117be24a8fc5f5dea6acac34e8843"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac09117be24a8fc5f5dea6acac34e8843">&#9670;&#160;</a></span>hwloc_topology_free_group_object()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_free_group_object </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>group</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Free a group object allocated with <a class="el" href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7" title="Allocate a Group object to insert later with hwloc_topology_insert_group_object().">hwloc_topology_alloc_group_object()</a>. </p>
+<p>This function is only useful if the group object was not given to <a class="el" href="a00183.html#ga1fc6012b3e1c249b83f48cb7bcacaa5b" title="Add more structure to the topology by adding an intermediate Group.">hwloc_topology_insert_group_object()</a> as planned.</p>
+<dl class="section note"><dt>Note</dt><dd><code>topology</code> must be the same as the one previously passed to <a class="el" href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7" title="Allocate a Group object to insert later with hwloc_topology_insert_group_object().">hwloc_topology_alloc_group_object()</a>.</dd></dl>
+<dl class="section return"><dt>Returns</dt><dd><code>0</code> on success. </dd>
+<dd>
+<code>-1</code> on error, for instance if an invalid topology is given. </dd></dl>
+
+</div>
+</div>
+<a id="ga1fc6012b3e1c249b83f48cb7bcacaa5b" name="ga1fc6012b3e1c249b83f48cb7bcacaa5b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1fc6012b3e1c249b83f48cb7bcacaa5b">&#9670;&#160;</a></span>hwloc_topology_insert_group_object()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_topology_insert_group_object </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>group</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Add more structure to the topology by adding an intermediate Group. </p>
+<p>The caller should first allocate a new Group object with <a class="el" href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7" title="Allocate a Group object to insert later with hwloc_topology_insert_group_object().">hwloc_topology_alloc_group_object()</a>. Then it must setup at least one of its CPU or node sets to specify the final location of the Group in the topology. Then the object can be passed to this function for actual insertion in the topology.</p>
+<p>The main use case for this function is to group a subset of siblings among the list of children below a single parent. For instance, if grouping 4 cores out of a 8-core socket, the logical list of cores will be reordered so that the 4 grouped ones are consecutive. Then, if needed, a new depth is added between the parent and those children, and the Group is inserted there. At the end, the 4 grouped cores are now children of the Group, which replaces them as a child of the original parent.</p>
+<p>In practice, the grouped objects are specified through cpusets and/or nodesets, for instance using <a class="el" href="a00183.html#gad458715d3335df44849216cc123d1055" title="Setup object cpusets/nodesets by OR&#39;ing another object&#39;s sets.">hwloc_obj_add_other_obj_sets()</a> iteratively. Hence it is possible to group objects that are not children of the same parent, for instance some PUs below the 4 cores in example above. However this general case may fail if the expected Group conflicts with the existing hierarchy. For instance if each core has two PUs, it is not possible to insert a Group containing a single PU of each core.</p>
+<p>To specify the objects to group, either the cpuset or nodeset field (or both, if compatible) must be set to a non-empty bitmap. The complete_cpuset or complete_nodeset may be set instead if inserting with respect to the complete topology (including disallowed, offline or unknown objects). These sets cannot be larger than the current topology, or they would get restricted silently. The core will setup the other sets after actual insertion.</p>
+<p>The <code>subtype</code> object attribute may be defined with <a class="el" href="a00178.html#ga6a07031b69bc7466b6fc4d13d610d47a" title="Set (or replace) the subtype of an object.">hwloc_obj_set_subtype()</a> to display something else than "Group" as the type name for this object in lstopo. Custom name-value info pairs may be added with <a class="el" href="a00178.html#gace7654bb8a9002caae1a4b8a59e7452e" title="Add the given name and value pair to the given object info attributes.">hwloc_obj_add_info()</a> after insertion.</p>
+<p>The group <code>dont_merge</code> attribute may be set to <code>1</code> to prevent the hwloc core from ever merging this object with another hierarchically-identical object. This is useful when the Group itself describes an important feature that cannot be exposed anywhere else in the hierarchy.</p>
+<p>The group <code>kind</code> attribute may be set to a high value such as <code>0xffffffff</code> to tell hwloc that this new Group should always be discarded in favor of any existing Group with the same locality.</p>
+<dl class="section note"><dt>Note</dt><dd>Inserting a group adds some locality information to the topology, hence the existing objects may get reordered (including PUs and NUMA nodes), and their logical indexes may change.</dd>
+<dd>
+If the insertion fails, the input group object is freed.</dd>
+<dd>
+If the group object should be discarded instead of inserted, it may be passed to <a class="el" href="a00183.html#gac09117be24a8fc5f5dea6acac34e8843" title="Free a group object allocated with hwloc_topology_alloc_group_object().">hwloc_topology_free_group_object()</a> instead.</dd>
+<dd>
+<code>topology</code> must be the same as the one previously passed to <a class="el" href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7" title="Allocate a Group object to insert later with hwloc_topology_insert_group_object().">hwloc_topology_alloc_group_object()</a>.</dd></dl>
+<dl class="section return"><dt>Returns</dt><dd>The inserted object if it was properly inserted.</dd>
+<dd>
+An existing object if the Group was merged or discarded because the topology already contained an object at the same location (the Group did not add any hierarchy information).</dd>
+<dd>
+<code>NULL</code> if the insertion failed because of conflicting sets in topology tree.</dd>
+<dd>
+<code>NULL</code> if Group objects are filtered-out of the topology (<a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a" title="Ignore all objects of this type.">HWLOC_TYPE_FILTER_KEEP_NONE</a>).</dd>
+<dd>
+<code>NULL</code> if the object was discarded because no set was initialized in the Group before insert, or all of them were empty. </dd></dl>
+
+</div>
+</div>
+<a id="gad980782ade737900c5cf208946768c30" name="gad980782ade737900c5cf208946768c30"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad980782ade737900c5cf208946768c30">&#9670;&#160;</a></span>hwloc_topology_insert_misc_object()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_topology_insert_misc_object </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>parent</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>name</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Add a MISC object as a leaf of the topology. </p>
+<p>A new MISC object will be created and inserted into the topology at the position given by parent. It is appended to the list of existing Misc children, without ever adding any intermediate hierarchy level. This is useful for annotating the topology without actually changing the hierarchy.</p>
+<p><code>name</code> is supposed to be unique across all Misc objects in the topology. It will be duplicated to setup the new object attributes.</p>
+<p>The new leaf object will not have any <code>cpuset</code>.</p>
+<p>The <code>subtype</code> object attribute may be defined with <a class="el" href="a00178.html#ga6a07031b69bc7466b6fc4d13d610d47a" title="Set (or replace) the subtype of an object.">hwloc_obj_set_subtype()</a> after successful insertion.</p>
+<dl class="section return"><dt>Returns</dt><dd>the newly-created object</dd>
+<dd>
+<code>NULL</code> on error.</dd>
+<dd>
+<code>NULL</code> if Misc objects are filtered-out of the topology (<a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a" title="Ignore all objects of this type.">HWLOC_TYPE_FILTER_KEEP_NONE</a>).</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>If <code>name</code> contains some non-printable characters, they will be dropped when exporting to XML, see <a class="el" href="a00195.html#ga333f79975b4eeb28a3d8fad3373583ce" title="Export the topology into an XML file.">hwloc_topology_export_xml()</a> in <a class="el" href="a00113_source.html">hwloc/export.h</a>. </dd></dl>
+
+</div>
+</div>
+<a id="ga698ecd640d2b76742bba3829a145cd9a" name="ga698ecd640d2b76742bba3829a145cd9a"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga698ecd640d2b76742bba3829a145cd9a">&#9670;&#160;</a></span>hwloc_topology_refresh()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_refresh </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Refresh internal structures after topology modification. </p>
+<p>Modifying the topology (by restricting, adding objects, modifying structures such as distances or memory attributes, etc.) may cause some internal caches to become invalid. These caches are automatically refreshed when accessed but this refreshing is not thread-safe.</p>
+<p>This function is not thread-safe either, but it is a good way to end a non-thread-safe phase of topology modification. Once this refresh is done, multiple threads may concurrently consult the topology, objects, distances, attributes, etc.</p>
+<p>See also <a class="el" href="a00388.html">Thread Safety</a></p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if some internal reallocation failed. </dd></dl>
+
+</div>
+</div>
+<a id="ga6db81ed13ac0a9d70cc80372ab537815" name="ga6db81ed13ac0a9d70cc80372ab537815"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga6db81ed13ac0a9d70cc80372ab537815">&#9670;&#160;</a></span>hwloc_topology_restrict()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_restrict </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> restrict&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Restrict the topology to the given CPU set or nodeset. </p>
+<p>Topology <code>topology</code> is modified so as to remove all objects that are not included (or partially included) in the CPU set <code>set</code>. All objects CPU and node sets are restricted accordingly.</p>
+<p>By default, <code>set</code> is a CPU set. It means that the set of PUs in the topology is restricted. Once some PUs got removed, their parents may also get removed recursively if they became child-less.</p>
+<p>If <a class="el" href="a00183.html#gga9d80f08eb25b7ac22f1b998dc8bf521fae4c5b1b87232f2d8a60559e77ac65a68" title="Restrict by nodeset instead of CPU set. Only keep objects whose nodeset is included or partially incl...">HWLOC_RESTRICT_FLAG_BYNODESET</a> is passed in <code>flags</code>, <code>set</code> is considered a nodeset instead of a CPU set. It means that the set of NUMA nodes in the topology is restricted (instead of PUs). Once some NUMA nodes got removed, their parents may also get removed recursively if they became child-less.</p>
+<p><code>flags</code> is a OR'ed set of <a class="el" href="a00183.html#ga9d80f08eb25b7ac22f1b998dc8bf521f" title="Flags to be given to hwloc_topology_restrict().">hwloc_restrict_flags_e</a>.</p>
+<dl class="section note"><dt>Note</dt><dd>Restricting the topology removes some locality information, hence the remaining objects may get reordered (including PUs and NUMA nodes), and their logical indexes may change.</dd>
+<dd>
+This call may not be reverted by restricting back to a larger set. Once dropped during restriction, objects may not be brought back, except by loading another topology with <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>.</dd></dl>
+<dl class="section return"><dt>Returns</dt><dd>0 on success.</dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if the input set is invalid. The topology is not modified in this case.</dd>
+<dd>
+-1 with errno set to <code>ENOMEM</code> on failure to allocate internal data. The topology is reinitialized in this case. It should be either destroyed with <a class="el" href="a00175.html#ga9f34a640b6fd28d23699d4d084667b15" title="Terminate and free a topology context.">hwloc_topology_destroy()</a> or configured and loaded again. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00184.html 2.11.0-1/doc/doxygen-doc/html/a00184.html
--- 2.10.0-1/doc/doxygen-doc/html/a00184.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00184.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,206 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Kinds of object Type</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Kinds of object Type</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga52ef38431eba383b048b98c669b59a16" id="r_ga52ef38431eba383b048b98c669b59a16"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00184.html#ga52ef38431eba383b048b98c669b59a16">hwloc_obj_type_is_normal</a> (<a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga52ef38431eba383b048b98c669b59a16"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac8a954ed37a4376097234c828068cbef" id="r_gac8a954ed37a4376097234c828068cbef"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00184.html#gac8a954ed37a4376097234c828068cbef">hwloc_obj_type_is_io</a> (<a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:gac8a954ed37a4376097234c828068cbef"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1d074390c8a3dc3088d84f73fb73f966" id="r_ga1d074390c8a3dc3088d84f73fb73f966"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00184.html#ga1d074390c8a3dc3088d84f73fb73f966">hwloc_obj_type_is_memory</a> (<a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga1d074390c8a3dc3088d84f73fb73f966"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga2ed589bea28711e80b92066510a5607d" id="r_ga2ed589bea28711e80b92066510a5607d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00184.html#ga2ed589bea28711e80b92066510a5607d">hwloc_obj_type_is_cache</a> (<a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga2ed589bea28711e80b92066510a5607d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga395e48cd221d107e5891689624e1aec4" id="r_ga395e48cd221d107e5891689624e1aec4"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00184.html#ga395e48cd221d107e5891689624e1aec4">hwloc_obj_type_is_dcache</a> (<a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga395e48cd221d107e5891689624e1aec4"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga8abcee67b9b074332c1866405a3648a9" id="r_ga8abcee67b9b074332c1866405a3648a9"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00184.html#ga8abcee67b9b074332c1866405a3648a9">hwloc_obj_type_is_icache</a> (<a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga8abcee67b9b074332c1866405a3648a9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>Each object type is either Normal (i.e. <a class="el" href="a00184.html#ga52ef38431eba383b048b98c669b59a16" title="Check whether an object type is Normal.">hwloc_obj_type_is_normal()</a> returns 1), or Memory (i.e. <a class="el" href="a00184.html#ga1d074390c8a3dc3088d84f73fb73f966" title="Check whether an object type is Memory.">hwloc_obj_type_is_memory()</a> returns 1) or I/O (i.e. <a class="el" href="a00184.html#gac8a954ed37a4376097234c828068cbef" title="Check whether an object type is I/O.">hwloc_obj_type_is_io()</a> returns 1) or Misc (i.e. equal to <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d" title="Miscellaneous objects (filtered out by default). Objects without particular meaning,...">HWLOC_OBJ_MISC</a>). It cannot be of more than one of these kinds.</p>
+<p>See also Object Kind in <a class="el" href="a00376.html">Terms and Definitions</a>. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga2ed589bea28711e80b92066510a5607d" name="ga2ed589bea28711e80b92066510a5607d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga2ed589bea28711e80b92066510a5607d">&#9670;&#160;</a></span>hwloc_obj_type_is_cache()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_type_is_cache </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Check whether an object type is a CPU Cache (Data, Unified or Instruction). </p>
+<p>Memory-side caches are not CPU caches.</p>
+<dl class="section return"><dt>Returns</dt><dd>1 if an object of type <code>type</code> is a Cache, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="ga395e48cd221d107e5891689624e1aec4" name="ga395e48cd221d107e5891689624e1aec4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga395e48cd221d107e5891689624e1aec4">&#9670;&#160;</a></span>hwloc_obj_type_is_dcache()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_type_is_dcache </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Check whether an object type is a CPU Data or Unified Cache. </p>
+<p>Memory-side caches are not CPU caches.</p>
+<dl class="section return"><dt>Returns</dt><dd>1 if an object of type <code>type</code> is a CPU Data or Unified Cache, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="ga8abcee67b9b074332c1866405a3648a9" name="ga8abcee67b9b074332c1866405a3648a9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8abcee67b9b074332c1866405a3648a9">&#9670;&#160;</a></span>hwloc_obj_type_is_icache()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_type_is_icache </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Check whether an object type is a CPU Instruction Cache,. </p>
+<p>Memory-side caches are not CPU caches.</p>
+<dl class="section return"><dt>Returns</dt><dd>1 if an object of type <code>type</code> is a CPU Instruction Cache, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="gac8a954ed37a4376097234c828068cbef" name="gac8a954ed37a4376097234c828068cbef"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac8a954ed37a4376097234c828068cbef">&#9670;&#160;</a></span>hwloc_obj_type_is_io()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_type_is_io </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Check whether an object type is I/O. </p>
+<p>I/O objects are objects attached to their parents in the I/O children list. This current includes Bridges, PCI and OS devices.</p>
+<dl class="section return"><dt>Returns</dt><dd>1 if an object of type <code>type</code> is a I/O object, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="ga1d074390c8a3dc3088d84f73fb73f966" name="ga1d074390c8a3dc3088d84f73fb73f966"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1d074390c8a3dc3088d84f73fb73f966">&#9670;&#160;</a></span>hwloc_obj_type_is_memory()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_type_is_memory </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Check whether an object type is Memory. </p>
+<p>Memory objects are objects attached to their parents in the Memory children list. This current includes NUMA nodes and Memory-side caches.</p>
+<dl class="section return"><dt>Returns</dt><dd>1 if an object of type <code>type</code> is a Memory object, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="ga52ef38431eba383b048b98c669b59a16" name="ga52ef38431eba383b048b98c669b59a16"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga52ef38431eba383b048b98c669b59a16">&#9670;&#160;</a></span>hwloc_obj_type_is_normal()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_type_is_normal </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Check whether an object type is Normal. </p>
+<p>Normal objects are objects of the main CPU hierarchy (Machine, Package, Core, PU, CPU caches, etc.), but they are not NUMA nodes, I/O devices or Misc objects.</p>
+<p>They are attached to parent as Normal children, not as Memory, I/O or Misc children.</p>
+<dl class="section return"><dt>Returns</dt><dd>1 if an object of type <code>type</code> is a Normal object, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00185.html 2.11.0-1/doc/doxygen-doc/html/a00185.html
--- 2.10.0-1/doc/doxygen-doc/html/a00185.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00185.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,553 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Finding Objects inside a CPU set</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Finding Objects inside a CPU set</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga547325a4193dbc215d07c23097519d79" id="r_ga547325a4193dbc215d07c23097519d79"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00185.html#ga547325a4193dbc215d07c23097519d79">hwloc_get_first_largest_obj_inside_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set)</td></tr>
+<tr class="separator:ga547325a4193dbc215d07c23097519d79"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga34ca563fa3a6a4e05268f36a87668511" id="r_ga34ca563fa3a6a4e05268f36a87668511"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00185.html#ga34ca563fa3a6a4e05268f36a87668511">hwloc_get_largest_objs_inside_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *restrict objs, int max)</td></tr>
+<tr class="separator:ga34ca563fa3a6a4e05268f36a87668511"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga63e3784e7c60fbae5073428cb98ac787" id="r_ga63e3784e7c60fbae5073428cb98ac787"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00185.html#ga63e3784e7c60fbae5073428cb98ac787">hwloc_get_next_obj_inside_cpuset_by_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, int depth, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> prev)</td></tr>
+<tr class="separator:ga63e3784e7c60fbae5073428cb98ac787"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gafe859176cf9233f215fea0e87cef47e7" id="r_gafe859176cf9233f215fea0e87cef47e7"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00185.html#gafe859176cf9233f215fea0e87cef47e7">hwloc_get_next_obj_inside_cpuset_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> prev)</td></tr>
+<tr class="separator:gafe859176cf9233f215fea0e87cef47e7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaec86f1f88832836e3f9338e246ea5862" id="r_gaec86f1f88832836e3f9338e246ea5862"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00185.html#gaec86f1f88832836e3f9338e246ea5862">hwloc_get_obj_inside_cpuset_by_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, int depth, unsigned idx)</td></tr>
+<tr class="separator:gaec86f1f88832836e3f9338e246ea5862"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga2edf924e5a0cca9cb22f65cc77c6ddb5" id="r_ga2edf924e5a0cca9cb22f65cc77c6ddb5"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00185.html#ga2edf924e5a0cca9cb22f65cc77c6ddb5">hwloc_get_obj_inside_cpuset_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, unsigned idx)</td></tr>
+<tr class="separator:ga2edf924e5a0cca9cb22f65cc77c6ddb5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa43c64512ddb33fd181990c4261cec7d" id="r_gaa43c64512ddb33fd181990c4261cec7d"><td class="memItemLeft" align="right" valign="top">static unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00185.html#gaa43c64512ddb33fd181990c4261cec7d">hwloc_get_nbobjs_inside_cpuset_by_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, int depth)</td></tr>
+<tr class="separator:gaa43c64512ddb33fd181990c4261cec7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga133c40415de008518608f8bff52a5ab9" id="r_ga133c40415de008518608f8bff52a5ab9"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00185.html#ga133c40415de008518608f8bff52a5ab9">hwloc_get_nbobjs_inside_cpuset_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga133c40415de008518608f8bff52a5ab9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga4c3a20d61e9beb06c667b21688c772c5" id="r_ga4c3a20d61e9beb06c667b21688c772c5"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00185.html#ga4c3a20d61e9beb06c667b21688c772c5">hwloc_get_obj_index_inside_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj)</td></tr>
+<tr class="separator:ga4c3a20d61e9beb06c667b21688c772c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga547325a4193dbc215d07c23097519d79" name="ga547325a4193dbc215d07c23097519d79"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga547325a4193dbc215d07c23097519d79">&#9670;&#160;</a></span>hwloc_get_first_largest_obj_inside_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_first_largest_obj_inside_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the first largest object included in the given cpuset <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the first object that is included in <code>set</code> and whose parent is not. </dd>
+<dd>
+<code>NULL</code> if no such object exists.</dd></dl>
+<p>This is convenient for iterating over all largest objects within a CPU set by doing a loop getting the first largest object and clearing its CPU set from the remaining CPU set. </p>
+
+</div>
+</div>
+<a id="ga34ca563fa3a6a4e05268f36a87668511" name="ga34ca563fa3a6a4e05268f36a87668511"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga34ca563fa3a6a4e05268f36a87668511">&#9670;&#160;</a></span>hwloc_get_largest_objs_inside_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_largest_objs_inside_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *restrict&#160;</td>
+          <td class="paramname"><em>objs</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>max</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the set of largest objects covering exactly a given cpuset <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the number of objects returned in <code>objs</code>. </dd>
+<dd>
+-1 if no set of objects may cover that cpuset. </dd></dl>
+
+</div>
+</div>
+<a id="gaa43c64512ddb33fd181990c4261cec7d" name="gaa43c64512ddb33fd181990c4261cec7d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa43c64512ddb33fd181990c4261cec7d">&#9670;&#160;</a></span>hwloc_get_nbobjs_inside_cpuset_by_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static unsigned hwloc_get_nbobjs_inside_cpuset_by_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>depth</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Return the number of objects at depth <code>depth</code> included in CPU set <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the number of objects. </dd>
+<dd>
+0 if the depth is invalid.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set).</dd>
+<dd>
+This function cannot work if objects at the given depth do not have CPU sets (I/O or Misc objects). </dd></dl>
+
+</div>
+</div>
+<a id="ga133c40415de008518608f8bff52a5ab9" name="ga133c40415de008518608f8bff52a5ab9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga133c40415de008518608f8bff52a5ab9">&#9670;&#160;</a></span>hwloc_get_nbobjs_inside_cpuset_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_get_nbobjs_inside_cpuset_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Return the number of objects of type <code>type</code> included in CPU set <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the number of objects. </dd>
+<dd>
+0 if there are no objects of that type in the topology. </dd>
+<dd>
+-1 if there are multiple levels of objects of that type, the caller should fallback to <a class="el" href="a00185.html#gaa43c64512ddb33fd181990c4261cec7d" title="Return the number of objects at depth depth included in CPU set set.">hwloc_get_nbobjs_inside_cpuset_by_depth()</a>.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set).</dd>
+<dd>
+This function cannot work if objects of the given type do not have CPU sets (I/O objects). </dd></dl>
+
+</div>
+</div>
+<a id="ga63e3784e7c60fbae5073428cb98ac787" name="ga63e3784e7c60fbae5073428cb98ac787"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga63e3784e7c60fbae5073428cb98ac787">&#9670;&#160;</a></span>hwloc_get_next_obj_inside_cpuset_by_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_next_obj_inside_cpuset_by_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>depth</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Return the next object at depth <code>depth</code> included in CPU set <code>set</code>. </p>
+<p>The next invokation should pass the previous return value in <code>prev</code> so as to obtain the next object in <code>set</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>the first object at depth <code>depth</code> included in <code>set</code> if <code>prev</code> is <code>NULL</code>. </dd>
+<dd>
+the next object at depth <code>depth</code> included in <code>set</code> if <code>prev</code> is not <code>NULL</code>. </dd>
+<dd>
+<code>NULL</code> if there is no next object.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set).</dd>
+<dd>
+This function cannot work if objects at the given depth do not have CPU sets (I/O or Misc objects). </dd></dl>
+
+</div>
+</div>
+<a id="gafe859176cf9233f215fea0e87cef47e7" name="gafe859176cf9233f215fea0e87cef47e7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gafe859176cf9233f215fea0e87cef47e7">&#9670;&#160;</a></span>hwloc_get_next_obj_inside_cpuset_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_next_obj_inside_cpuset_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Return the next object of type <code>type</code> included in CPU set <code>set</code>. </p>
+<p>The next invokation should pass the previous return value in <code>prev</code> so as to obtain the next object in <code>set</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>the first object of type <code>type</code> included in <code>set</code> if <code>prev</code> is <code>NULL</code>. </dd>
+<dd>
+the next object of type <code>type</code> included in <code>set</code> if <code>prev</code> is not <code>NULL</code>. </dd>
+<dd>
+<code>NULL</code> if there is no next object. </dd>
+<dd>
+<code>NULL</code> if there is no depth for the given type. </dd>
+<dd>
+<code>NULL</code> if there are multiple depths for the given type, the caller should fallback to <a class="el" href="a00185.html#ga63e3784e7c60fbae5073428cb98ac787" title="Return the next object at depth depth included in CPU set set.">hwloc_get_next_obj_inside_cpuset_by_depth()</a>.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set).</dd>
+<dd>
+This function cannot work if objects of the given type do not have CPU sets (I/O or Misc objects). </dd></dl>
+
+</div>
+</div>
+<a id="ga4c3a20d61e9beb06c667b21688c772c5" name="ga4c3a20d61e9beb06c667b21688c772c5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga4c3a20d61e9beb06c667b21688c772c5">&#9670;&#160;</a></span>hwloc_get_obj_index_inside_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_get_obj_index_inside_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Return the logical index among the objects included in CPU set <code>set</code>. </p>
+<p>Consult all objects in the same level as <code>obj</code> and inside CPU set <code>set</code> in the logical order, and return the index of <code>obj</code> within them. If <code>set</code> covers the entire topology, this is the logical index of <code>obj</code>. Otherwise, this is similar to a logical index within the part of the topology defined by CPU set <code>set</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>the logical index among the objects included in the set if any. </dd>
+<dd>
+-1 if the object is not included in the set.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set).</dd>
+<dd>
+This function cannot work if obj does not have CPU sets (I/O objects). </dd></dl>
+
+</div>
+</div>
+<a id="gaec86f1f88832836e3f9338e246ea5862" name="gaec86f1f88832836e3f9338e246ea5862"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaec86f1f88832836e3f9338e246ea5862">&#9670;&#160;</a></span>hwloc_get_obj_inside_cpuset_by_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_obj_inside_cpuset_by_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>depth</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>idx</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Return the (logically) <code>idx</code> -th object at depth <code>depth</code> included in CPU set <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the object if any, <code>NULL</code> otherwise.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set).</dd>
+<dd>
+This function cannot work if objects at the given depth do not have CPU sets (I/O or Misc objects). </dd></dl>
+
+</div>
+</div>
+<a id="ga2edf924e5a0cca9cb22f65cc77c6ddb5" name="ga2edf924e5a0cca9cb22f65cc77c6ddb5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga2edf924e5a0cca9cb22f65cc77c6ddb5">&#9670;&#160;</a></span>hwloc_get_obj_inside_cpuset_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_obj_inside_cpuset_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>idx</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Return the <code>idx</code> -th object of type <code>type</code> included in CPU set <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the object if any. </dd>
+<dd>
+<code>NULL</code> if there is no such object. </dd>
+<dd>
+<code>NULL</code> if there is no depth for given type. </dd>
+<dd>
+<code>NULL</code> if there are multiple depths for given type, the caller should fallback to <a class="el" href="a00185.html#gaec86f1f88832836e3f9338e246ea5862" title="Return the (logically) idx -th object at depth depth included in CPU set set.">hwloc_get_obj_inside_cpuset_by_depth()</a>.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set).</dd>
+<dd>
+This function cannot work if objects of the given type do not have CPU sets (I/O or Misc objects). </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00186.html 2.11.0-1/doc/doxygen-doc/html/a00186.html
--- 2.10.0-1/doc/doxygen-doc/html/a00186.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00186.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,274 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Finding Objects covering at least CPU set</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Finding Objects covering at least CPU set</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga0e66aa2dc6b2527cfd10723af646c9d7" id="r_ga0e66aa2dc6b2527cfd10723af646c9d7"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00186.html#ga0e66aa2dc6b2527cfd10723af646c9d7">hwloc_get_child_covering_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> parent)</td></tr>
+<tr class="separator:ga0e66aa2dc6b2527cfd10723af646c9d7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga41acdcdbb8b95d70ecf6c572a3f67dca" id="r_ga41acdcdbb8b95d70ecf6c572a3f67dca"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00186.html#ga41acdcdbb8b95d70ecf6c572a3f67dca">hwloc_get_obj_covering_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set)</td></tr>
+<tr class="separator:ga41acdcdbb8b95d70ecf6c572a3f67dca"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaba4b6d86eba1169ced4b0e941d2bb5f0" id="r_gaba4b6d86eba1169ced4b0e941d2bb5f0"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00186.html#gaba4b6d86eba1169ced4b0e941d2bb5f0">hwloc_get_next_obj_covering_cpuset_by_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, int depth, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> prev)</td></tr>
+<tr class="separator:gaba4b6d86eba1169ced4b0e941d2bb5f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga91cfae08b092e7966002e15d1e987213" id="r_ga91cfae08b092e7966002e15d1e987213"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00186.html#ga91cfae08b092e7966002e15d1e987213">hwloc_get_next_obj_covering_cpuset_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> prev)</td></tr>
+<tr class="separator:ga91cfae08b092e7966002e15d1e987213"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga0e66aa2dc6b2527cfd10723af646c9d7" name="ga0e66aa2dc6b2527cfd10723af646c9d7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga0e66aa2dc6b2527cfd10723af646c9d7">&#9670;&#160;</a></span>hwloc_get_child_covering_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_child_covering_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>parent</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the child covering at least CPU set <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the child that covers the set entirely. </dd>
+<dd>
+<code>NULL</code> if no child matches or if <code>set</code> is empty.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot work if parent does not have a CPU set (I/O or Misc objects). </dd></dl>
+
+</div>
+</div>
+<a id="gaba4b6d86eba1169ced4b0e941d2bb5f0" name="gaba4b6d86eba1169ced4b0e941d2bb5f0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaba4b6d86eba1169ced4b0e941d2bb5f0">&#9670;&#160;</a></span>hwloc_get_next_obj_covering_cpuset_by_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_next_obj_covering_cpuset_by_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>depth</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Iterate through same-depth objects covering at least CPU set <code>set</code>. </p>
+<p>The next invokation should pass the previous return value in <code>prev</code> so as to obtain the next object covering at least another part of <code>set</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>the first object at depth <code>depth</code> covering at least part of CPU set <code>set</code> if object <code>prev</code> is <code>NULL</code>. </dd>
+<dd>
+the next one if <code>prev</code> is not <code>NULL</code>. </dd>
+<dd>
+<code>NULL</code> if there is no next object.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot work if objects at the given depth do not have CPU sets (I/O or Misc objects). </dd></dl>
+
+</div>
+</div>
+<a id="ga91cfae08b092e7966002e15d1e987213" name="ga91cfae08b092e7966002e15d1e987213"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga91cfae08b092e7966002e15d1e987213">&#9670;&#160;</a></span>hwloc_get_next_obj_covering_cpuset_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_next_obj_covering_cpuset_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Iterate through same-type objects covering at least CPU set <code>set</code>. </p>
+<p>The next invokation should pass the previous return value in <code>prev</code> so as to obtain the next object of type <code>type</code> covering at least another part of <code>set</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>the first object of type <code>type</code> covering at least part of CPU set <code>set</code> if object <code>prev</code> is <code>NULL</code>. </dd>
+<dd>
+the next one if <code>prev</code> is not <code>NULL</code>. </dd>
+<dd>
+<code>NULL</code> if there is no next object. </dd>
+<dd>
+<code>NULL</code> if there is no depth for the given type. </dd>
+<dd>
+<code>NULL</code> if there are multiple depths for the given type, the caller should fallback to <a class="el" href="a00186.html#gaba4b6d86eba1169ced4b0e941d2bb5f0" title="Iterate through same-depth objects covering at least CPU set set.">hwloc_get_next_obj_covering_cpuset_by_depth()</a>.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot work if objects of the given type do not have CPU sets (I/O or Misc objects). </dd></dl>
+
+</div>
+</div>
+<a id="ga41acdcdbb8b95d70ecf6c572a3f67dca" name="ga41acdcdbb8b95d70ecf6c572a3f67dca"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga41acdcdbb8b95d70ecf6c572a3f67dca">&#9670;&#160;</a></span>hwloc_get_obj_covering_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_obj_covering_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the lowest object covering at least CPU set <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the lowest object covering the set entirely. </dd>
+<dd>
+<code>NULL</code> if no object matches or if <code>set</code> is empty. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00187.html 2.11.0-1/doc/doxygen-doc/html/a00187.html
--- 2.10.0-1/doc/doxygen-doc/html/a00187.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00187.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,310 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Looking at Ancestor and Child Objects</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Looking at Ancestor and Child Objects</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga9f8c93fde236e9642a96957af01a11cb" id="r_ga9f8c93fde236e9642a96957af01a11cb"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00187.html#ga9f8c93fde236e9642a96957af01a11cb">hwloc_get_ancestor_obj_by_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int depth, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj)</td></tr>
+<tr class="separator:ga9f8c93fde236e9642a96957af01a11cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga70f0c7583291da707c15ae4daa850f41" id="r_ga70f0c7583291da707c15ae4daa850f41"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00187.html#ga70f0c7583291da707c15ae4daa850f41">hwloc_get_ancestor_obj_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj)</td></tr>
+<tr class="separator:ga70f0c7583291da707c15ae4daa850f41"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gab1fa883021928b5c476911c4102e9be3" id="r_gab1fa883021928b5c476911c4102e9be3"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00187.html#gab1fa883021928b5c476911c4102e9be3">hwloc_get_common_ancestor_obj</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj1, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj2)</td></tr>
+<tr class="separator:gab1fa883021928b5c476911c4102e9be3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga408cf74f5bf9ed497911a320c7f8cc56" id="r_ga408cf74f5bf9ed497911a320c7f8cc56"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00187.html#ga408cf74f5bf9ed497911a320c7f8cc56">hwloc_obj_is_in_subtree</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> subtree_root)</td></tr>
+<tr class="separator:ga408cf74f5bf9ed497911a320c7f8cc56"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga12d8565a3436c565e791ed02a0353621" id="r_ga12d8565a3436c565e791ed02a0353621"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00187.html#ga12d8565a3436c565e791ed02a0353621">hwloc_get_next_child</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> parent, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> prev)</td></tr>
+<tr class="separator:ga12d8565a3436c565e791ed02a0353621"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>Be sure to see the figure in <a class="el" href="a00376.html">Terms and Definitions</a> that shows a complete topology tree, including depths, child/sibling/cousin relationships, and an example of an asymmetric topology where one package has fewer caches than its peers. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga9f8c93fde236e9642a96957af01a11cb" name="ga9f8c93fde236e9642a96957af01a11cb"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9f8c93fde236e9642a96957af01a11cb">&#9670;&#160;</a></span>hwloc_get_ancestor_obj_by_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_ancestor_obj_by_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>depth</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the ancestor object of <code>obj</code> at depth <code>depth</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the ancestor if any. </dd>
+<dd>
+<code>NULL</code> if no such ancestor exists.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd><code>depth</code> should not be the depth of PU or NUMA objects since they are ancestors of no objects (except Misc or I/O). This function rather expects an intermediate level depth, such as the depth of Packages, Cores, or Caches. </dd></dl>
+
+</div>
+</div>
+<a id="ga70f0c7583291da707c15ae4daa850f41" name="ga70f0c7583291da707c15ae4daa850f41"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga70f0c7583291da707c15ae4daa850f41">&#9670;&#160;</a></span>hwloc_get_ancestor_obj_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_ancestor_obj_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the ancestor object of <code>obj</code> with type <code>type</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the ancestor if any. </dd>
+<dd>
+<code>NULL</code> if no such ancestor exists.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>if multiple matching ancestors exist (e.g. multiple levels of <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56" title="Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take...">HWLOC_OBJ_GROUP</a>) the lowest one is returned.</dd>
+<dd>
+<code>type</code> should not be <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661" title="Processing Unit, or (Logical) Processor. An execution unit (may share a core with some other logical ...">HWLOC_OBJ_PU</a> or <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a" title="NUMA node. An object that contains memory that is directly and byte-accessible to the host processors...">HWLOC_OBJ_NUMANODE</a> since these objects are ancestors of no objects (except Misc or I/O). This function rather expects an intermediate object type, such as <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ab16ab8c0dbffc234921d86f3dfb63129" title="Physical package. The physical package that usually gets inserted into a socket on the motherboard....">HWLOC_OBJ_PACKAGE</a>, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ac793958f330bca371aa1535de8aff45f" title="Core. A computation unit (may be shared by several PUs, aka logical processors).">HWLOC_OBJ_CORE</a>, etc. </dd></dl>
+
+</div>
+</div>
+<a id="gab1fa883021928b5c476911c4102e9be3" name="gab1fa883021928b5c476911c4102e9be3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab1fa883021928b5c476911c4102e9be3">&#9670;&#160;</a></span>hwloc_get_common_ancestor_obj()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_common_ancestor_obj </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj2</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the common parent object to objects <code>obj1</code> and <code>obj2</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the common ancestor.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot return <code>NULL</code>. </dd></dl>
+
+</div>
+</div>
+<a id="ga12d8565a3436c565e791ed02a0353621" name="ga12d8565a3436c565e791ed02a0353621"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga12d8565a3436c565e791ed02a0353621">&#9670;&#160;</a></span>hwloc_get_next_child()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_next_child </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>parent</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Return the next child. </p>
+<p>Return the next child among the normal children list, then among the memory children list, then among the I/O children list, then among the Misc children list.</p>
+<dl class="section return"><dt>Returns</dt><dd>the first child if <code>prev</code> is <code>NULL</code>. </dd>
+<dd>
+the next child if <code>prev</code> is not <code>NULL</code>. </dd>
+<dd>
+<code>NULL</code> when there is no next child. </dd></dl>
+
+</div>
+</div>
+<a id="ga408cf74f5bf9ed497911a320c7f8cc56" name="ga408cf74f5bf9ed497911a320c7f8cc56"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga408cf74f5bf9ed497911a320c7f8cc56">&#9670;&#160;</a></span>hwloc_obj_is_in_subtree()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_obj_is_in_subtree </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>subtree_root</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns true if <code>obj</code> is inside the subtree beginning with ancestor object <code>subtree_root</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>1 is the object is in the subtree, 0 otherwise.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot work if <code>obj</code> and <code>subtree_root</code> objects do not have CPU sets (I/O or Misc objects). </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00188.html 2.11.0-1/doc/doxygen-doc/html/a00188.html
--- 2.10.0-1/doc/doxygen-doc/html/a00188.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00188.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,200 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Looking at Cache Objects</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Looking at Cache Objects</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gad108a09ce400222fe45545257d575489" id="r_gad108a09ce400222fe45545257d575489"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00188.html#gad108a09ce400222fe45545257d575489">hwloc_get_cache_type_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned cachelevel, <a class="el" href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a> cachetype)</td></tr>
+<tr class="separator:gad108a09ce400222fe45545257d575489"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac4cd480a5deaa4ada047fdd11ae4c070" id="r_gac4cd480a5deaa4ada047fdd11ae4c070"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00188.html#gac4cd480a5deaa4ada047fdd11ae4c070">hwloc_get_cache_covering_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set)</td></tr>
+<tr class="separator:gac4cd480a5deaa4ada047fdd11ae4c070"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga36f48c32837c7a70b424706e213dcd71" id="r_ga36f48c32837c7a70b424706e213dcd71"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00188.html#ga36f48c32837c7a70b424706e213dcd71">hwloc_get_shared_cache_covering_obj</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj)</td></tr>
+<tr class="separator:ga36f48c32837c7a70b424706e213dcd71"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gac4cd480a5deaa4ada047fdd11ae4c070" name="gac4cd480a5deaa4ada047fdd11ae4c070"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac4cd480a5deaa4ada047fdd11ae4c070">&#9670;&#160;</a></span>hwloc_get_cache_covering_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_cache_covering_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the first data (or unified) cache covering a cpuset <code>set</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>a covering cache, or <code>NULL</code> if no cache matches. </dd></dl>
+
+</div>
+</div>
+<a id="gad108a09ce400222fe45545257d575489" name="gad108a09ce400222fe45545257d575489"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad108a09ce400222fe45545257d575489">&#9670;&#160;</a></span>hwloc_get_cache_type_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_get_cache_type_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>cachelevel</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a>&#160;</td>
+          <td class="paramname"><em>cachetype</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Find the depth of cache objects matching cache level and type. </p>
+<p>Return the depth of the topology level that contains cache objects whose attributes match <code>cachelevel</code> and <code>cachetype</code>.</p>
+<p>This function is identical to calling <a class="el" href="a00176.html#ga8bec782e21be313750da70cf7428b374" title="Returns the depth of objects of type type.">hwloc_get_type_depth()</a> with the corresponding type such as <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55afa834a85d9e53836cf0db6d0bd8329b4" title="Level 1 instruction Cache (filtered out by default).">HWLOC_OBJ_L1ICACHE</a>, except that it may also return a Unified cache when looking for an instruction cache.</p>
+<dl class="section return"><dt>Returns</dt><dd>the depth of the unique matching unified cache level is returned if <code>cachetype</code> is <a class="el" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a" title="Unified cache.">HWLOC_OBJ_CACHE_UNIFIED</a>.</dd>
+<dd>
+the depth of either a matching cache level or a unified cache level if <code>cachetype</code> is <a class="el" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59bacac60ecad4206f85aeb79bef1604b488" title="Data cache.">HWLOC_OBJ_CACHE_DATA</a> or <a class="el" href="a00173.html#gga791c9875c8fe20f3e1e5871e0657e59ba6f98b0d422b38ba90c5f5c79a11b0658" title="Instruction cache (filtered out by default).">HWLOC_OBJ_CACHE_INSTRUCTION</a>.</dd>
+<dd>
+the depth of the matching level if <code>cachetype</code> is <code>-1</code> but only one level matches.</dd>
+<dd>
+<a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c" title="Objects of given type exist at different depth in the topology (only for Groups).">HWLOC_TYPE_DEPTH_MULTIPLE</a> if <code>cachetype</code> is <code>-1</code> but multiple levels match.</dd>
+<dd>
+<a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad" title="No object of given type exists in the topology.">HWLOC_TYPE_DEPTH_UNKNOWN</a> if no cache level matches. </dd></dl>
+
+</div>
+</div>
+<a id="ga36f48c32837c7a70b424706e213dcd71" name="ga36f48c32837c7a70b424706e213dcd71"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga36f48c32837c7a70b424706e213dcd71">&#9670;&#160;</a></span>hwloc_get_shared_cache_covering_obj()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_shared_cache_covering_obj </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the first data (or unified) cache shared between an object and somebody else. </p>
+<dl class="section return"><dt>Returns</dt><dd>a shared cache. </dd>
+<dd>
+<code>NULL</code> if no cache matches or if an invalid object is given (e.g. I/O object). </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00189.html 2.11.0-1/doc/doxygen-doc/html/a00189.html
--- 2.10.0-1/doc/doxygen-doc/html/a00189.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00189.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,422 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Finding objects, miscellaneous helpers</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Finding objects, miscellaneous helpers</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga050646458efc8ca1120d9f124c5ad861" id="r_ga050646458efc8ca1120d9f124c5ad861"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00189.html#ga050646458efc8ca1120d9f124c5ad861">hwloc_bitmap_singlify_per_core</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> cpuset, unsigned which)</td></tr>
+<tr class="separator:ga050646458efc8ca1120d9f124c5ad861"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga751c238a4931db5cc0ca3181b7dd7479" id="r_ga751c238a4931db5cc0ca3181b7dd7479"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00189.html#ga751c238a4931db5cc0ca3181b7dd7479">hwloc_get_pu_obj_by_os_index</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned os_index)</td></tr>
+<tr class="separator:ga751c238a4931db5cc0ca3181b7dd7479"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gab89d9ed9edfaa3dd526fb6ee1a1618ea" id="r_gab89d9ed9edfaa3dd526fb6ee1a1618ea"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00189.html#gab89d9ed9edfaa3dd526fb6ee1a1618ea">hwloc_get_numanode_obj_by_os_index</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned os_index)</td></tr>
+<tr class="separator:gab89d9ed9edfaa3dd526fb6ee1a1618ea"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga2cd22a34360643f7f5bad09576dec205" id="r_ga2cd22a34360643f7f5bad09576dec205"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00189.html#ga2cd22a34360643f7f5bad09576dec205">hwloc_get_closest_objs</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> src, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *restrict objs, unsigned max)</td></tr>
+<tr class="separator:ga2cd22a34360643f7f5bad09576dec205"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga7a0c1046851f7a88bd52f5a1d4ba0a97" id="r_ga7a0c1046851f7a88bd52f5a1d4ba0a97"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00189.html#ga7a0c1046851f7a88bd52f5a1d4ba0a97">hwloc_get_obj_below_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type1, unsigned idx1, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type2, unsigned idx2)</td></tr>
+<tr class="separator:ga7a0c1046851f7a88bd52f5a1d4ba0a97"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gacb51295ff3fbd3a96f990f20c6492b1d" id="r_gacb51295ff3fbd3a96f990f20c6492b1d"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00189.html#gacb51295ff3fbd3a96f990f20c6492b1d">hwloc_get_obj_below_array_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int nr, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> *typev, unsigned *idxv)</td></tr>
+<tr class="separator:gacb51295ff3fbd3a96f990f20c6492b1d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gab5df3ad1e8565ea0c2cf06412f6f6233" id="r_gab5df3ad1e8565ea0c2cf06412f6f6233"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00189.html#gab5df3ad1e8565ea0c2cf06412f6f6233">hwloc_get_obj_with_same_locality</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> src, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, const char *subtype, const char *nameprefix, unsigned long flags)</td></tr>
+<tr class="separator:gab5df3ad1e8565ea0c2cf06412f6f6233"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>Be sure to see the figure in <a class="el" href="a00376.html">Terms and Definitions</a> that shows a complete topology tree, including depths, child/sibling/cousin relationships, and an example of an asymmetric topology where one package has fewer caches than its peers. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga050646458efc8ca1120d9f124c5ad861" name="ga050646458efc8ca1120d9f124c5ad861"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga050646458efc8ca1120d9f124c5ad861">&#9670;&#160;</a></span>hwloc_bitmap_singlify_per_core()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_singlify_per_core </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>cpuset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>which</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Remove simultaneous multithreading PUs from a CPU set. </p>
+<p>For each core in <code>topology</code>, if <code>cpuset</code> contains some PUs of that core, modify <code>cpuset</code> to only keep a single PU for that core.</p>
+<p><code>which</code> specifies which PU will be kept. PU are considered in physical index order. If 0, for each core, the function keeps the first PU that was originally set in <code>cpuset</code>.</p>
+<p>If <code>which</code> is larger than the number of PUs in a core there were originally set in <code>cpuset</code>, no PU is kept for that core.</p>
+<dl class="section return"><dt>Returns</dt><dd>0.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>PUs that are not below a Core object are ignored (for instance if the topology does not contain any Core object). None of them is removed from <code>cpuset</code>. </dd></dl>
+
+</div>
+</div>
+<a id="ga2cd22a34360643f7f5bad09576dec205" name="ga2cd22a34360643f7f5bad09576dec205"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga2cd22a34360643f7f5bad09576dec205">&#9670;&#160;</a></span>hwloc_get_closest_objs()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_get_closest_objs </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>src</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *restrict&#160;</td>
+          <td class="paramname"><em>objs</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>max</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Do a depth-first traversal of the topology to find and sort. </p>
+<p>all objects that are at the same depth than <code>src</code>. Report in <code>objs</code> up to <code>max</code> physically closest ones to <code>src</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>the number of objects returned in <code>objs</code>.</dd>
+<dd>
+0 if <code>src</code> is an I/O object.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function requires the <code>src</code> object to have a CPU set. </dd></dl>
+
+</div>
+</div>
+<a id="gab89d9ed9edfaa3dd526fb6ee1a1618ea" name="gab89d9ed9edfaa3dd526fb6ee1a1618ea"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab89d9ed9edfaa3dd526fb6ee1a1618ea">&#9670;&#160;</a></span>hwloc_get_numanode_obj_by_os_index()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_numanode_obj_by_os_index </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>os_index</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the object of type <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a" title="NUMA node. An object that contains memory that is directly and byte-accessible to the host processors...">HWLOC_OBJ_NUMANODE</a> with <code>os_index</code>. </p>
+<p>This function is useful for converting a nodeset into the NUMA node objects it contains. When retrieving the current binding (e.g. with <a class="el" href="a00180.html#gae21f0a1a884929c784bebf070252aa56" title="Query the default memory binding policy and physical locality of the current process or thread.">hwloc_get_membind()</a> with HWLOC_MEMBIND_BYNODESET), one may iterate over the bits of the resulting nodeset with <a class="el" href="a00194.html#ga3f6861045a8029ade373510ffa727d2a" title="Loop macro iterating on bitmap bitmap.">hwloc_bitmap_foreach_begin()</a>, and find the corresponding NUMA nodes with this function.</p>
+<dl class="section return"><dt>Returns</dt><dd>the NUMA node object, or <code>NULL</code> if none matches. </dd></dl>
+
+</div>
+</div>
+<a id="gacb51295ff3fbd3a96f990f20c6492b1d" name="gacb51295ff3fbd3a96f990f20c6492b1d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gacb51295ff3fbd3a96f990f20c6492b1d">&#9670;&#160;</a></span>hwloc_get_obj_below_array_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_obj_below_array_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>nr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> *&#160;</td>
+          <td class="paramname"><em>typev</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>idxv</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Find an object below a chain of objects specified by types and indexes. </p>
+<p>This is a generalized version of <a class="el" href="a00189.html#ga7a0c1046851f7a88bd52f5a1d4ba0a97" title="Find an object below another object, both specified by types and indexes.">hwloc_get_obj_below_by_type()</a>.</p>
+<p>Arrays <code>typev</code> and <code>idxv</code> must contain <code>nr</code> types and indexes.</p>
+<p>Start from the top system object and walk the arrays <code>typev</code> and <code>idxv</code>. For each type and logical index couple in the arrays, look under the previously found object to find the index-th object of the given type. Indexes are specified within the parent, not withing the entire system.</p>
+<p>For instance, if nr is 3, typev contains NODE, PACKAGE and CORE, and idxv contains 0, 1 and 2, return the third core object below the second package below the first NUMA node.</p>
+<dl class="section return"><dt>Returns</dt><dd>a matching object if any, <code>NULL</code> otherwise.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function requires all these objects and the root object to have a CPU set. </dd></dl>
+
+</div>
+</div>
+<a id="ga7a0c1046851f7a88bd52f5a1d4ba0a97" name="ga7a0c1046851f7a88bd52f5a1d4ba0a97"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga7a0c1046851f7a88bd52f5a1d4ba0a97">&#9670;&#160;</a></span>hwloc_get_obj_below_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_obj_below_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>idx1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type2</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>idx2</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Find an object below another object, both specified by types and indexes. </p>
+<p>Start from the top system object and find object of type <code>type1</code> and logical index <code>idx1</code>. Then look below this object and find another object of type <code>type2</code> and logical index <code>idx2</code>. Indexes are specified within the parent, not withing the entire system.</p>
+<p>For instance, if type1 is PACKAGE, idx1 is 2, type2 is CORE and idx2 is 3, return the fourth core object below the third package.</p>
+<dl class="section return"><dt>Returns</dt><dd>a matching object if any, <code>NULL</code> otherwise.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function requires these objects to have a CPU set. </dd></dl>
+
+</div>
+</div>
+<a id="gab5df3ad1e8565ea0c2cf06412f6f6233" name="gab5df3ad1e8565ea0c2cf06412f6f6233"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab5df3ad1e8565ea0c2cf06412f6f6233">&#9670;&#160;</a></span>hwloc_get_obj_with_same_locality()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_obj_with_same_locality </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>src</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>subtype</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>nameprefix</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return an object of a different type with same locality. </p>
+<p>If the source object <code>src</code> is a normal or memory type, this function returns an object of type <code>type</code> with same CPU and node sets, either below or above in the hierarchy.</p>
+<p>If the source object <code>src</code> is a PCI or an OS device within a PCI device, the function may either return that PCI device, or another OS device in the same PCI parent. This may for instance be useful for converting between OS devices such as "nvml0" or "rsmi1" used in distance structures into the the PCI device, or the CUDA or OpenCL OS device that correspond to the same physical card.</p>
+<p>If not <code>NULL</code>, parameter <code>subtype</code> only select objects whose subtype attribute exists and is <code>subtype</code> (case-insensitively), for instance "OpenCL" or "CUDA".</p>
+<p>If not <code>NULL</code>, parameter <code>nameprefix</code> only selects objects whose name attribute exists and starts with <code>nameprefix</code> (case-insensitively), for instance "rsmi" for matching "rsmi0".</p>
+<p>If multiple objects match, the first one is returned.</p>
+<p>This function will not walk the hierarchy across bridges since the PCI locality may become different. This function cannot also convert between normal/memory objects and I/O or Misc objects.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section return"><dt>Returns</dt><dd>An object with identical locality, matching <code>subtype</code> and <code>nameprefix</code> if any.</dd>
+<dd>
+<code>NULL</code> if no matching object could be found, or if the source object and target type are incompatible, for instance if converting between CPU and I/O objects. </dd></dl>
+
+</div>
+</div>
+<a id="ga751c238a4931db5cc0ca3181b7dd7479" name="ga751c238a4931db5cc0ca3181b7dd7479"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga751c238a4931db5cc0ca3181b7dd7479">&#9670;&#160;</a></span>hwloc_get_pu_obj_by_os_index()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_pu_obj_by_os_index </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>os_index</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Returns the object of type <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661" title="Processing Unit, or (Logical) Processor. An execution unit (may share a core with some other logical ...">HWLOC_OBJ_PU</a> with <code>os_index</code>. </p>
+<p>This function is useful for converting a CPU set into the PU objects it contains. When retrieving the current binding (e.g. with <a class="el" href="a00179.html#gacba7ecb979baf824d5240fa2cb2a8be6" title="Get current process or thread binding.">hwloc_get_cpubind()</a>), one may iterate over the bits of the resulting CPU set with <a class="el" href="a00194.html#ga3f6861045a8029ade373510ffa727d2a" title="Loop macro iterating on bitmap bitmap.">hwloc_bitmap_foreach_begin()</a>, and find the corresponding PUs with this function.</p>
+<dl class="section return"><dt>Returns</dt><dd>the PU object, or <code>NULL</code> if none matches. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00190.html 2.11.0-1/doc/doxygen-doc/html/a00190.html
--- 2.10.0-1/doc/doxygen-doc/html/a00190.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00190.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,166 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Distributing items over a topology</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Distributing items over a topology</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:ga8b835295a52b6768a5e6c8abb1f9c54d" id="r_ga8b835295a52b6768a5e6c8abb1f9c54d"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00190.html#ga8b835295a52b6768a5e6c8abb1f9c54d">hwloc_distrib_flags_e</a> { <a class="el" href="a00190.html#gga8b835295a52b6768a5e6c8abb1f9c54da2ca08404bfbebe9ed5f34c3d7635425a">HWLOC_DISTRIB_FLAG_REVERSE</a>
+ }</td></tr>
+<tr class="separator:ga8b835295a52b6768a5e6c8abb1f9c54d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga7b0c28f797c2ff17fa2f244ebbd55b33" id="r_ga7b0c28f797c2ff17fa2f244ebbd55b33"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00190.html#ga7b0c28f797c2ff17fa2f244ebbd55b33">hwloc_distrib</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *roots, unsigned n_roots, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> *set, unsigned n, int until, unsigned long flags)</td></tr>
+<tr class="separator:ga7b0c28f797c2ff17fa2f244ebbd55b33"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="ga8b835295a52b6768a5e6c8abb1f9c54d" name="ga8b835295a52b6768a5e6c8abb1f9c54d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8b835295a52b6768a5e6c8abb1f9c54d">&#9670;&#160;</a></span>hwloc_distrib_flags_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00190.html#ga8b835295a52b6768a5e6c8abb1f9c54d">hwloc_distrib_flags_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Flags to be given to <a class="el" href="a00190.html#ga7b0c28f797c2ff17fa2f244ebbd55b33" title="Distribute n items over the topology under roots.">hwloc_distrib()</a>. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga8b835295a52b6768a5e6c8abb1f9c54da2ca08404bfbebe9ed5f34c3d7635425a" name="gga8b835295a52b6768a5e6c8abb1f9c54da2ca08404bfbebe9ed5f34c3d7635425a"></a>HWLOC_DISTRIB_FLAG_REVERSE&#160;</td><td class="fielddoc"><p>Distrib in reverse order, starting from the last objects. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga7b0c28f797c2ff17fa2f244ebbd55b33" name="ga7b0c28f797c2ff17fa2f244ebbd55b33"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga7b0c28f797c2ff17fa2f244ebbd55b33">&#9670;&#160;</a></span>hwloc_distrib()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_distrib </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *&#160;</td>
+          <td class="paramname"><em>roots</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>n_roots</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> *&#160;</td>
+          <td class="paramname"><em>set</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>n</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>until</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Distribute <code>n</code> items over the topology under <code>roots</code>. </p>
+<p>Array <code>set</code> will be filled with <code>n</code> cpusets recursively distributed linearly over the topology under objects <code>roots</code>, down to depth <code>until</code> (which can be INT_MAX to distribute down to the finest level).</p>
+<p><code>n_roots</code> is usually 1 and <code>roots</code> only contains the topology root object so as to distribute over the entire topology.</p>
+<p>This is typically useful when an application wants to distribute <code>n</code> threads over a machine, giving each of them as much private cache as possible and keeping them locally in number order.</p>
+<p>The caller may typically want to also call <a class="el" href="a00194.html#gaa611a77c092e679246afdf9a60d5db8b" title="Keep a single index among those set in bitmap bitmap.">hwloc_bitmap_singlify()</a> before binding a thread so that it does not move at all.</p>
+<p><code>flags</code> should be 0 or a OR'ed set of <a class="el" href="a00190.html#ga8b835295a52b6768a5e6c8abb1f9c54d" title="Flags to be given to hwloc_distrib().">hwloc_distrib_flags_e</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>On hybrid CPUs (or asymmetric platforms), distribution may be suboptimal since the number of cores or PUs inside packages or below caches may vary (the top-down recursive partitioning ignores these numbers until reaching their levels). Hence it is recommended to distribute only inside a single homogeneous domain. For instance on a CPU with energy-efficient E-cores and high-performance P-cores, one should distribute separately N tasks on E-cores and M tasks on P-cores instead of trying to distribute directly M+N tasks on the entire CPUs.</dd>
+<dd>
+This function requires the <code>roots</code> objects to have a CPU set. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00191.html 2.11.0-1/doc/doxygen-doc/html/a00191.html
--- 2.10.0-1/doc/doxygen-doc/html/a00191.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00191.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,231 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): CPU and node sets of entire topologies</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">CPU and node sets of entire topologies</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gaee30e03391c1ed7dfd617fb5c7bbb033" id="r_gaee30e03391c1ed7dfd617fb5c7bbb033"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00191.html#gaee30e03391c1ed7dfd617fb5c7bbb033">hwloc_topology_get_complete_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:gaee30e03391c1ed7dfd617fb5c7bbb033"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga79212faa07b70dd26588941b17d9fa82" id="r_ga79212faa07b70dd26588941b17d9fa82"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00191.html#ga79212faa07b70dd26588941b17d9fa82">hwloc_topology_get_topology_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:ga79212faa07b70dd26588941b17d9fa82"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga517d5d68ec9f24583d8933aab713be8e" id="r_ga517d5d68ec9f24583d8933aab713be8e"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00191.html#ga517d5d68ec9f24583d8933aab713be8e">hwloc_topology_get_allowed_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:ga517d5d68ec9f24583d8933aab713be8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga773fd98949461ef4c1e3170bb0c0418f" id="r_ga773fd98949461ef4c1e3170bb0c0418f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00191.html#ga773fd98949461ef4c1e3170bb0c0418f">hwloc_topology_get_complete_nodeset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:ga773fd98949461ef4c1e3170bb0c0418f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga3fd37303e99ace8b0d0ea03f95f8c514" id="r_ga3fd37303e99ace8b0d0ea03f95f8c514"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00191.html#ga3fd37303e99ace8b0d0ea03f95f8c514">hwloc_topology_get_topology_nodeset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:ga3fd37303e99ace8b0d0ea03f95f8c514"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga21a4d7237a11e76b912ed4524ab78cbd" id="r_ga21a4d7237a11e76b912ed4524ab78cbd"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00191.html#ga21a4d7237a11e76b912ed4524ab78cbd">hwloc_topology_get_allowed_nodeset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:ga21a4d7237a11e76b912ed4524ab78cbd"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga517d5d68ec9f24583d8933aab713be8e" name="ga517d5d68ec9f24583d8933aab713be8e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga517d5d68ec9f24583d8933aab713be8e">&#9670;&#160;</a></span>hwloc_topology_get_allowed_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> hwloc_topology_get_allowed_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get allowed CPU set. </p>
+<dl class="section return"><dt>Returns</dt><dd>the CPU set of allowed processors of the system.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot return <code>NULL</code>.</dd>
+<dd>
+If the topology flag <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258" title="Detect the whole system, ignore reservations, include disallowed objects.">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a> was not set, this is identical to <a class="el" href="a00191.html#ga79212faa07b70dd26588941b17d9fa82" title="Get topology CPU set.">hwloc_topology_get_topology_cpuset()</a>, which means all PUs are allowed.</dd>
+<dd>
+If <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258" title="Detect the whole system, ignore reservations, include disallowed objects.">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a> was set, applying <a class="el" href="a00194.html#gaefa070f9232857ba5a57297ea9a08ea2" title="Test whether bitmaps bitmap1 and bitmap2 intersects.">hwloc_bitmap_intersects()</a> on the result of this function and on an object cpuset checks whether there are allowed PUs inside that object. Applying <a class="el" href="a00194.html#ga674533016ffed922a28b4f0b49b82cd4" title="And bitmaps bitmap1 and bitmap2 and store the result in bitmap res.">hwloc_bitmap_and()</a> returns the list of these allowed PUs.</dd>
+<dd>
+The returned cpuset is not newly allocated and should thus not be changed or freed, <a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee" title="Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.">hwloc_bitmap_dup()</a> must be used to obtain a local copy. </dd></dl>
+
+</div>
+</div>
+<a id="ga21a4d7237a11e76b912ed4524ab78cbd" name="ga21a4d7237a11e76b912ed4524ab78cbd"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga21a4d7237a11e76b912ed4524ab78cbd">&#9670;&#160;</a></span>hwloc_topology_get_allowed_nodeset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> hwloc_topology_get_allowed_nodeset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get allowed node set. </p>
+<dl class="section return"><dt>Returns</dt><dd>the node set of allowed memory of the system.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot return <code>NULL</code>.</dd>
+<dd>
+If the topology flag <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258" title="Detect the whole system, ignore reservations, include disallowed objects.">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a> was not set, this is identical to <a class="el" href="a00191.html#ga3fd37303e99ace8b0d0ea03f95f8c514" title="Get topology node set.">hwloc_topology_get_topology_nodeset()</a>, which means all NUMA nodes are allowed.</dd>
+<dd>
+If <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258" title="Detect the whole system, ignore reservations, include disallowed objects.">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a> was set, applying <a class="el" href="a00194.html#gaefa070f9232857ba5a57297ea9a08ea2" title="Test whether bitmaps bitmap1 and bitmap2 intersects.">hwloc_bitmap_intersects()</a> on the result of this function and on an object nodeset checks whether there are allowed NUMA nodes inside that object. Applying <a class="el" href="a00194.html#ga674533016ffed922a28b4f0b49b82cd4" title="And bitmaps bitmap1 and bitmap2 and store the result in bitmap res.">hwloc_bitmap_and()</a> returns the list of these allowed NUMA nodes.</dd>
+<dd>
+The returned nodeset is not newly allocated and should thus not be changed or freed, <a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee" title="Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.">hwloc_bitmap_dup()</a> must be used to obtain a local copy. </dd></dl>
+
+</div>
+</div>
+<a id="gaee30e03391c1ed7dfd617fb5c7bbb033" name="gaee30e03391c1ed7dfd617fb5c7bbb033"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaee30e03391c1ed7dfd617fb5c7bbb033">&#9670;&#160;</a></span>hwloc_topology_get_complete_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> hwloc_topology_get_complete_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get complete CPU set. </p>
+<dl class="section return"><dt>Returns</dt><dd>the complete CPU set of processors of the system.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot return <code>NULL</code>.</dd>
+<dd>
+The returned cpuset is not newly allocated and should thus not be changed or freed; <a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee" title="Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.">hwloc_bitmap_dup()</a> must be used to obtain a local copy.</dd>
+<dd>
+This is equivalent to retrieving the root object complete CPU-set. </dd></dl>
+
+</div>
+</div>
+<a id="ga773fd98949461ef4c1e3170bb0c0418f" name="ga773fd98949461ef4c1e3170bb0c0418f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga773fd98949461ef4c1e3170bb0c0418f">&#9670;&#160;</a></span>hwloc_topology_get_complete_nodeset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> hwloc_topology_get_complete_nodeset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get complete node set. </p>
+<dl class="section return"><dt>Returns</dt><dd>the complete node set of memory of the system.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot return <code>NULL</code>.</dd>
+<dd>
+The returned nodeset is not newly allocated and should thus not be changed or freed; <a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee" title="Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.">hwloc_bitmap_dup()</a> must be used to obtain a local copy.</dd>
+<dd>
+This is equivalent to retrieving the root object complete nodeset. </dd></dl>
+
+</div>
+</div>
+<a id="ga79212faa07b70dd26588941b17d9fa82" name="ga79212faa07b70dd26588941b17d9fa82"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga79212faa07b70dd26588941b17d9fa82">&#9670;&#160;</a></span>hwloc_topology_get_topology_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> hwloc_topology_get_topology_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get topology CPU set. </p>
+<dl class="section return"><dt>Returns</dt><dd>the CPU set of processors of the system for which hwloc provides topology information. This is equivalent to the cpuset of the system object.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot return <code>NULL</code>.</dd>
+<dd>
+The returned cpuset is not newly allocated and should thus not be changed or freed; <a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee" title="Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.">hwloc_bitmap_dup()</a> must be used to obtain a local copy.</dd>
+<dd>
+This is equivalent to retrieving the root object CPU-set. </dd></dl>
+
+</div>
+</div>
+<a id="ga3fd37303e99ace8b0d0ea03f95f8c514" name="ga3fd37303e99ace8b0d0ea03f95f8c514"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga3fd37303e99ace8b0d0ea03f95f8c514">&#9670;&#160;</a></span>hwloc_topology_get_topology_nodeset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> hwloc_topology_get_topology_nodeset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get topology node set. </p>
+<dl class="section return"><dt>Returns</dt><dd>the node set of memory of the system for which hwloc provides topology information. This is equivalent to the nodeset of the system object.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot return <code>NULL</code>.</dd>
+<dd>
+The returned nodeset is not newly allocated and should thus not be changed or freed; <a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee" title="Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.">hwloc_bitmap_dup()</a> must be used to obtain a local copy.</dd>
+<dd>
+This is equivalent to retrieving the root object nodeset. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00192.html 2.11.0-1/doc/doxygen-doc/html/a00192.html
--- 2.10.0-1/doc/doxygen-doc/html/a00192.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00192.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,163 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Converting between CPU sets and node sets</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Converting between CPU sets and node sets</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga185751c1653fedbeb7cc480840f38cde" id="r_ga185751c1653fedbeb7cc480840f38cde"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00192.html#ga185751c1653fedbeb7cc480840f38cde">hwloc_cpuset_to_nodeset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> _cpuset, <a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a> nodeset)</td></tr>
+<tr class="separator:ga185751c1653fedbeb7cc480840f38cde"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gad5ee8691e08a3538ea7633344c00456d" id="r_gad5ee8691e08a3538ea7633344c00456d"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00192.html#gad5ee8691e08a3538ea7633344c00456d">hwloc_cpuset_from_nodeset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> _cpuset, <a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> nodeset)</td></tr>
+<tr class="separator:gad5ee8691e08a3538ea7633344c00456d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gad5ee8691e08a3538ea7633344c00456d" name="gad5ee8691e08a3538ea7633344c00456d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad5ee8691e08a3538ea7633344c00456d">&#9670;&#160;</a></span>hwloc_cpuset_from_nodeset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_cpuset_from_nodeset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>_cpuset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a>&#160;</td>
+          <td class="paramname"><em>nodeset</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert a NUMA node set into a CPU set. </p>
+<p>For each NUMA node included in the input <code>nodeset</code>, set the corresponding local PUs in the output <code>_cpuset</code>.</p>
+<p>If some CPUs have no local NUMA nodes, this function never sets their indexes in the output CPU set, even if a full node set is given in input.</p>
+<p>Hence the entire topology node set is converted into the set of all CPUs that have some local NUMA nodes.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOMEM</code> on internal reallocation failure. </dd></dl>
+
+</div>
+</div>
+<a id="ga185751c1653fedbeb7cc480840f38cde" name="ga185751c1653fedbeb7cc480840f38cde"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga185751c1653fedbeb7cc480840f38cde">&#9670;&#160;</a></span>hwloc_cpuset_to_nodeset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_cpuset_to_nodeset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>_cpuset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a>&#160;</td>
+          <td class="paramname"><em>nodeset</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert a CPU set into a NUMA node set. </p>
+<p>For each PU included in the input <code>_cpuset</code>, set the corresponding local NUMA node(s) in the output <code>nodeset</code>.</p>
+<p>If some NUMA nodes have no CPUs at all, this function never sets their indexes in the output node set, even if a full CPU set is given in input.</p>
+<p>Hence the entire topology CPU set is converted into the set of all nodes that have some local CPUs.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOMEM</code> on internal reallocation failure. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00193.html 2.11.0-1/doc/doxygen-doc/html/a00193.html
--- 2.10.0-1/doc/doxygen-doc/html/a00193.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00193.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,383 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Finding I/O objects</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Finding I/O objects</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gaf139bb61375178e90cc3f1835b452ab6" id="r_gaf139bb61375178e90cc3f1835b452ab6"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00193.html#gaf139bb61375178e90cc3f1835b452ab6">hwloc_get_non_io_ancestor_obj</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> ioobj)</td></tr>
+<tr class="separator:gaf139bb61375178e90cc3f1835b452ab6"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga66470dabce9db19a57c5940a909d0baa" id="r_ga66470dabce9db19a57c5940a909d0baa"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00193.html#ga66470dabce9db19a57c5940a909d0baa">hwloc_get_next_pcidev</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> prev)</td></tr>
+<tr class="separator:ga66470dabce9db19a57c5940a909d0baa"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gacdbaf0db98872e224b7883a84bfb0455" id="r_gacdbaf0db98872e224b7883a84bfb0455"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00193.html#gacdbaf0db98872e224b7883a84bfb0455">hwloc_get_pcidev_by_busid</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)</td></tr>
+<tr class="separator:gacdbaf0db98872e224b7883a84bfb0455"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga23a978469353134b3104b846fe2efceb" id="r_ga23a978469353134b3104b846fe2efceb"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00193.html#ga23a978469353134b3104b846fe2efceb">hwloc_get_pcidev_by_busidstring</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const char *busid)</td></tr>
+<tr class="separator:ga23a978469353134b3104b846fe2efceb"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga8b4584c8949e2c5f1c97ba7fe92b8145" id="r_ga8b4584c8949e2c5f1c97ba7fe92b8145"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145">hwloc_get_next_osdev</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> prev)</td></tr>
+<tr class="separator:ga8b4584c8949e2c5f1c97ba7fe92b8145"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga9dba22a3f4f701f2a46780ba9a0bbbe7" id="r_ga9dba22a3f4f701f2a46780ba9a0bbbe7"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00193.html#ga9dba22a3f4f701f2a46780ba9a0bbbe7">hwloc_get_next_bridge</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> prev)</td></tr>
+<tr class="separator:ga9dba22a3f4f701f2a46780ba9a0bbbe7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga0d92a9462a3d317f29ecb4442a307fb1" id="r_ga0d92a9462a3d317f29ecb4442a307fb1"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00193.html#ga0d92a9462a3d317f29ecb4442a307fb1">hwloc_bridge_covers_pcibus</a> (<a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> bridge, unsigned domain, unsigned bus)</td></tr>
+<tr class="separator:ga0d92a9462a3d317f29ecb4442a307fb1"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga0d92a9462a3d317f29ecb4442a307fb1" name="ga0d92a9462a3d317f29ecb4442a307fb1"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga0d92a9462a3d317f29ecb4442a307fb1">&#9670;&#160;</a></span>hwloc_bridge_covers_pcibus()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_bridge_covers_pcibus </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>bridge</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>domain</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>bus</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="ga9dba22a3f4f701f2a46780ba9a0bbbe7" name="ga9dba22a3f4f701f2a46780ba9a0bbbe7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9dba22a3f4f701f2a46780ba9a0bbbe7">&#9670;&#160;</a></span>hwloc_get_next_bridge()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_next_bridge </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the next bridge in the system. </p>
+<dl class="section return"><dt>Returns</dt><dd>the first bridge if <code>prev</code> is <code>NULL</code>. </dd>
+<dd>
+the next bridge if <code>prev</code> is not <code>NULL</code>. </dd>
+<dd>
+<code>NULL</code> if there is no next bridge. </dd></dl>
+
+</div>
+</div>
+<a id="ga8b4584c8949e2c5f1c97ba7fe92b8145" name="ga8b4584c8949e2c5f1c97ba7fe92b8145"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8b4584c8949e2c5f1c97ba7fe92b8145">&#9670;&#160;</a></span>hwloc_get_next_osdev()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_next_osdev </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the next OS device in the system. </p>
+<dl class="section return"><dt>Returns</dt><dd>the first OS device if <code>prev</code> is <code>NULL</code>. </dd>
+<dd>
+the next OS device if <code>prev</code> is not <code>NULL</code>. </dd>
+<dd>
+<code>NULL</code> if there is no next OS device. </dd></dl>
+
+</div>
+</div>
+<a id="ga66470dabce9db19a57c5940a909d0baa" name="ga66470dabce9db19a57c5940a909d0baa"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga66470dabce9db19a57c5940a909d0baa">&#9670;&#160;</a></span>hwloc_get_next_pcidev()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_next_pcidev </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the next PCI device in the system. </p>
+<dl class="section return"><dt>Returns</dt><dd>the first PCI device if <code>prev</code> is <code>NULL</code>. </dd>
+<dd>
+the next PCI device if <code>prev</code> is not <code>NULL</code>. </dd>
+<dd>
+<code>NULL</code> if there is no next PCI device. </dd></dl>
+
+</div>
+</div>
+<a id="gaf139bb61375178e90cc3f1835b452ab6" name="gaf139bb61375178e90cc3f1835b452ab6"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf139bb61375178e90cc3f1835b452ab6">&#9670;&#160;</a></span>hwloc_get_non_io_ancestor_obj()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_non_io_ancestor_obj </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>ioobj</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the first non-I/O ancestor object. </p>
+<p>Given the I/O object <code>ioobj</code>, find the smallest non-I/O ancestor object. This object (normal or memory) may then be used for binding because it has non-NULL CPU and node sets and because its locality is the same as <code>ioobj</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>a non-I/O object.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function cannot return <code>NULL</code>.</dd>
+<dd>
+The resulting object is usually a normal object but it could also be a memory object (e.g. NUMA node) in future platforms if I/O objects ever get attached to memory instead of CPUs. </dd></dl>
+
+</div>
+</div>
+<a id="gacdbaf0db98872e224b7883a84bfb0455" name="gacdbaf0db98872e224b7883a84bfb0455"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gacdbaf0db98872e224b7883a84bfb0455">&#9670;&#160;</a></span>hwloc_get_pcidev_by_busid()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_pcidev_by_busid </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>domain</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>bus</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>dev</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>func</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Find the PCI device object matching the PCI bus id given domain, bus device and function PCI bus id. </p>
+<dl class="section return"><dt>Returns</dt><dd>a matching PCI device object if any, <code>NULL</code> otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="ga23a978469353134b3104b846fe2efceb" name="ga23a978469353134b3104b846fe2efceb"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga23a978469353134b3104b846fe2efceb">&#9670;&#160;</a></span>hwloc_get_pcidev_by_busidstring()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_get_pcidev_by_busidstring </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>busid</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Find the PCI device object matching the PCI bus id given as a string xxxx:yy:zz.t or yy:zz.t. </p>
+<dl class="section return"><dt>Returns</dt><dd>a matching PCI device object if any, <code>NULL</code> otherwise. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00194.html 2.11.0-1/doc/doxygen-doc/html/a00194.html
--- 2.10.0-1/doc/doxygen-doc/html/a00194.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00194.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,1820 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): The bitmap API</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#define-members">Macros</a> &#124;
+<a href="#typedef-members">Typedefs</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">The bitmap API</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="define-members" name="define-members"></a>
+Macros</h2></td></tr>
+<tr class="memitem:ga3f6861045a8029ade373510ffa727d2a" id="r_ga3f6861045a8029ade373510ffa727d2a"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga3f6861045a8029ade373510ffa727d2a">hwloc_bitmap_foreach_begin</a>(id,  bitmap)</td></tr>
+<tr class="separator:ga3f6861045a8029ade373510ffa727d2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gafcf3246db406218d4e155735b3fa6528" id="r_gafcf3246db406218d4e155735b3fa6528"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gafcf3246db406218d4e155735b3fa6528">hwloc_bitmap_foreach_end</a>()</td></tr>
+<tr class="separator:gafcf3246db406218d4e155735b3fa6528"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="typedef-members" name="typedef-members"></a>
+Typedefs</h2></td></tr>
+<tr class="memitem:gaa3c2bf4c776d603dcebbb61b0c923d84" id="r_gaa3c2bf4c776d603dcebbb61b0c923d84"><td class="memItemLeft" align="right" valign="top">typedef struct hwloc_bitmap_s *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a></td></tr>
+<tr class="separator:gaa3c2bf4c776d603dcebbb61b0c923d84"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gae991a108af01d408be2776c5b2c467b2" id="r_gae991a108af01d408be2776c5b2c467b2"><td class="memItemLeft" align="right" valign="top">typedef const struct hwloc_bitmap_s *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a></td></tr>
+<tr class="separator:gae991a108af01d408be2776c5b2c467b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gadece3d1eb5199fc2fb99bc7dcf1ccc05" id="r_gadece3d1eb5199fc2fb99bc7dcf1ccc05"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gadece3d1eb5199fc2fb99bc7dcf1ccc05">hwloc_bitmap_alloc</a> (void)</td></tr>
+<tr class="separator:gadece3d1eb5199fc2fb99bc7dcf1ccc05"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga02853b4a224970587b9d7a0e20d857c0" id="r_ga02853b4a224970587b9d7a0e20d857c0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga02853b4a224970587b9d7a0e20d857c0">hwloc_bitmap_alloc_full</a> (void)</td></tr>
+<tr class="separator:ga02853b4a224970587b9d7a0e20d857c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga156130d85b3a0674d6e0e6770fe68fbe" id="r_ga156130d85b3a0674d6e0e6770fe68fbe"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga156130d85b3a0674d6e0e6770fe68fbe">hwloc_bitmap_free</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga156130d85b3a0674d6e0e6770fe68fbe"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gae679434c1a5f41d3560a8a7e2c1b0dee" id="r_gae679434c1a5f41d3560a8a7e2c1b0dee"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee">hwloc_bitmap_dup</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:gae679434c1a5f41d3560a8a7e2c1b0dee"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga72a29824798b48784b8217471ec8f14c" id="r_ga72a29824798b48784b8217471ec8f14c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga72a29824798b48784b8217471ec8f14c">hwloc_bitmap_copy</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> dst, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> src)</td></tr>
+<tr class="separator:ga72a29824798b48784b8217471ec8f14c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga9511644657030a021dce9941e3cda583" id="r_ga9511644657030a021dce9941e3cda583"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga9511644657030a021dce9941e3cda583">hwloc_bitmap_snprintf</a> (char *restrict buf, size_t buflen, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga9511644657030a021dce9941e3cda583"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga0fece972134fdecf2da9bc7a11dd827e" id="r_ga0fece972134fdecf2da9bc7a11dd827e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga0fece972134fdecf2da9bc7a11dd827e">hwloc_bitmap_asprintf</a> (char **strp, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga0fece972134fdecf2da9bc7a11dd827e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga064a85c643a364b60acbfa0f3663fc18" id="r_ga064a85c643a364b60acbfa0f3663fc18"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga064a85c643a364b60acbfa0f3663fc18">hwloc_bitmap_sscanf</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, const char *restrict string)</td></tr>
+<tr class="separator:ga064a85c643a364b60acbfa0f3663fc18"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga3d06e6447edeb61e56a9ad83f31f0a37" id="r_ga3d06e6447edeb61e56a9ad83f31f0a37"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga3d06e6447edeb61e56a9ad83f31f0a37">hwloc_bitmap_list_snprintf</a> (char *restrict buf, size_t buflen, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga3d06e6447edeb61e56a9ad83f31f0a37"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga39c0f1b02053de66d205c9f8260b3665" id="r_ga39c0f1b02053de66d205c9f8260b3665"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga39c0f1b02053de66d205c9f8260b3665">hwloc_bitmap_list_asprintf</a> (char **strp, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga39c0f1b02053de66d205c9f8260b3665"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaf9314311d482c621e17c6a53a9fe993e" id="r_gaf9314311d482c621e17c6a53a9fe993e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gaf9314311d482c621e17c6a53a9fe993e">hwloc_bitmap_list_sscanf</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, const char *restrict string)</td></tr>
+<tr class="separator:gaf9314311d482c621e17c6a53a9fe993e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga5beb68a987fe48e5c5edef06ab260e14" id="r_ga5beb68a987fe48e5c5edef06ab260e14"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga5beb68a987fe48e5c5edef06ab260e14">hwloc_bitmap_taskset_snprintf</a> (char *restrict buf, size_t buflen, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga5beb68a987fe48e5c5edef06ab260e14"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga391312513f17c985d871f18367c59512" id="r_ga391312513f17c985d871f18367c59512"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga391312513f17c985d871f18367c59512">hwloc_bitmap_taskset_asprintf</a> (char **strp, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga391312513f17c985d871f18367c59512"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga4f23db5041240e03e348752f8bd6ec2d" id="r_ga4f23db5041240e03e348752f8bd6ec2d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga4f23db5041240e03e348752f8bd6ec2d">hwloc_bitmap_taskset_sscanf</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, const char *restrict string)</td></tr>
+<tr class="separator:ga4f23db5041240e03e348752f8bd6ec2d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa97c5217613c8cae9862287170ea2132" id="r_gaa97c5217613c8cae9862287170ea2132"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gaa97c5217613c8cae9862287170ea2132">hwloc_bitmap_zero</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:gaa97c5217613c8cae9862287170ea2132"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga07b2de8786b3cdb22f21d9dd42588275" id="r_ga07b2de8786b3cdb22f21d9dd42588275"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga07b2de8786b3cdb22f21d9dd42588275">hwloc_bitmap_fill</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga07b2de8786b3cdb22f21d9dd42588275"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga10be0840cdeb7ce26d862819dd303baa" id="r_ga10be0840cdeb7ce26d862819dd303baa"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga10be0840cdeb7ce26d862819dd303baa">hwloc_bitmap_only</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, unsigned id)</td></tr>
+<tr class="separator:ga10be0840cdeb7ce26d862819dd303baa"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga06d505f8a1c0a536614f65f503ee6d93" id="r_ga06d505f8a1c0a536614f65f503ee6d93"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga06d505f8a1c0a536614f65f503ee6d93">hwloc_bitmap_allbut</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, unsigned id)</td></tr>
+<tr class="separator:ga06d505f8a1c0a536614f65f503ee6d93"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gad59b0ebeb29c1bfabbb2a379e55c1159" id="r_gad59b0ebeb29c1bfabbb2a379e55c1159"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gad59b0ebeb29c1bfabbb2a379e55c1159">hwloc_bitmap_from_ulong</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, unsigned long mask)</td></tr>
+<tr class="separator:gad59b0ebeb29c1bfabbb2a379e55c1159"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga4947c46d47bcfcd3faf3f59569be3e37" id="r_ga4947c46d47bcfcd3faf3f59569be3e37"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga4947c46d47bcfcd3faf3f59569be3e37">hwloc_bitmap_from_ith_ulong</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, unsigned i, unsigned long mask)</td></tr>
+<tr class="separator:ga4947c46d47bcfcd3faf3f59569be3e37"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gabcfef22f6fc4d4b33f068dd91a1c38f5" id="r_gabcfef22f6fc4d4b33f068dd91a1c38f5"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gabcfef22f6fc4d4b33f068dd91a1c38f5">hwloc_bitmap_from_ulongs</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, unsigned nr, const unsigned long *masks)</td></tr>
+<tr class="separator:gabcfef22f6fc4d4b33f068dd91a1c38f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga062dbff93baeff3b425a7260c5463646" id="r_ga062dbff93baeff3b425a7260c5463646"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga062dbff93baeff3b425a7260c5463646">hwloc_bitmap_set</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, unsigned id)</td></tr>
+<tr class="separator:ga062dbff93baeff3b425a7260c5463646"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga9c9a8433732fb9f24899e7aa4c014d7e" id="r_ga9c9a8433732fb9f24899e7aa4c014d7e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga9c9a8433732fb9f24899e7aa4c014d7e">hwloc_bitmap_set_range</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, unsigned begin, int end)</td></tr>
+<tr class="separator:ga9c9a8433732fb9f24899e7aa4c014d7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga3daeed965c35c6d2fd4820a318219985" id="r_ga3daeed965c35c6d2fd4820a318219985"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga3daeed965c35c6d2fd4820a318219985">hwloc_bitmap_set_ith_ulong</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, unsigned i, unsigned long mask)</td></tr>
+<tr class="separator:ga3daeed965c35c6d2fd4820a318219985"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaf20bb350b6844d08931a064a73f86743" id="r_gaf20bb350b6844d08931a064a73f86743"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gaf20bb350b6844d08931a064a73f86743">hwloc_bitmap_clr</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, unsigned id)</td></tr>
+<tr class="separator:gaf20bb350b6844d08931a064a73f86743"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga833776709df94d727f8c22304b3388cf" id="r_ga833776709df94d727f8c22304b3388cf"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga833776709df94d727f8c22304b3388cf">hwloc_bitmap_clr_range</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap, unsigned begin, int end)</td></tr>
+<tr class="separator:ga833776709df94d727f8c22304b3388cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa611a77c092e679246afdf9a60d5db8b" id="r_gaa611a77c092e679246afdf9a60d5db8b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gaa611a77c092e679246afdf9a60d5db8b">hwloc_bitmap_singlify</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:gaa611a77c092e679246afdf9a60d5db8b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gab6a6bae22a33ec6adfc169a953c13e6c" id="r_gab6a6bae22a33ec6adfc169a953c13e6c"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gab6a6bae22a33ec6adfc169a953c13e6c">hwloc_bitmap_to_ulong</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:gab6a6bae22a33ec6adfc169a953c13e6c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac92e6404f648d6b99d2c626b05b2ffa4" id="r_gac92e6404f648d6b99d2c626b05b2ffa4"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gac92e6404f648d6b99d2c626b05b2ffa4">hwloc_bitmap_to_ith_ulong</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap, unsigned i)</td></tr>
+<tr class="separator:gac92e6404f648d6b99d2c626b05b2ffa4"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gacd215a2348732de25d94a4ecd76d528c" id="r_gacd215a2348732de25d94a4ecd76d528c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gacd215a2348732de25d94a4ecd76d528c">hwloc_bitmap_to_ulongs</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap, unsigned nr, unsigned long *masks)</td></tr>
+<tr class="separator:gacd215a2348732de25d94a4ecd76d528c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac0744734d761d65c977aece565364908" id="r_gac0744734d761d65c977aece565364908"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gac0744734d761d65c977aece565364908">hwloc_bitmap_nr_ulongs</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:gac0744734d761d65c977aece565364908"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga11340dd487f110bb84f0a6e4ae90bd06" id="r_ga11340dd487f110bb84f0a6e4ae90bd06"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga11340dd487f110bb84f0a6e4ae90bd06">hwloc_bitmap_isset</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap, unsigned id)</td></tr>
+<tr class="separator:ga11340dd487f110bb84f0a6e4ae90bd06"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga5b64be28f5a7176ed8ad0d6a90bdf108" id="r_ga5b64be28f5a7176ed8ad0d6a90bdf108"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga5b64be28f5a7176ed8ad0d6a90bdf108">hwloc_bitmap_iszero</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga5b64be28f5a7176ed8ad0d6a90bdf108"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga5fdcb8c19c336511c37076d649e74af4" id="r_ga5fdcb8c19c336511c37076d649e74af4"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga5fdcb8c19c336511c37076d649e74af4">hwloc_bitmap_isfull</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga5fdcb8c19c336511c37076d649e74af4"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga3ec1ced43afadf8c0a7197320bc016ed" id="r_ga3ec1ced43afadf8c0a7197320bc016ed"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga3ec1ced43afadf8c0a7197320bc016ed">hwloc_bitmap_first</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga3ec1ced43afadf8c0a7197320bc016ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaab7240b4b644693b775dad17b44ffd68" id="r_gaab7240b4b644693b775dad17b44ffd68"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gaab7240b4b644693b775dad17b44ffd68">hwloc_bitmap_next</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap, int prev)</td></tr>
+<tr class="separator:gaab7240b4b644693b775dad17b44ffd68"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga3d9b08b060a59bbab5a4ea6d0a1ed7a6" id="r_ga3d9b08b060a59bbab5a4ea6d0a1ed7a6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga3d9b08b060a59bbab5a4ea6d0a1ed7a6">hwloc_bitmap_last</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga3d9b08b060a59bbab5a4ea6d0a1ed7a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga0200466842c0e1f5da75e84dde460b10" id="r_ga0200466842c0e1f5da75e84dde460b10"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga0200466842c0e1f5da75e84dde460b10">hwloc_bitmap_weight</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga0200466842c0e1f5da75e84dde460b10"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gae408841487b288e148a478ba0465c99e" id="r_gae408841487b288e148a478ba0465c99e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gae408841487b288e148a478ba0465c99e">hwloc_bitmap_first_unset</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:gae408841487b288e148a478ba0465c99e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga9653af34d1460ef106b7df25af4cdca8" id="r_ga9653af34d1460ef106b7df25af4cdca8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga9653af34d1460ef106b7df25af4cdca8">hwloc_bitmap_next_unset</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap, int prev)</td></tr>
+<tr class="separator:ga9653af34d1460ef106b7df25af4cdca8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga45d49aeb45c7da631b1480a93dc3fc92" id="r_ga45d49aeb45c7da631b1480a93dc3fc92"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga45d49aeb45c7da631b1480a93dc3fc92">hwloc_bitmap_last_unset</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga45d49aeb45c7da631b1480a93dc3fc92"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga120b8aefb9ce7ef349929656359b1859" id="r_ga120b8aefb9ce7ef349929656359b1859"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">hwloc_bitmap_or</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> res, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2)</td></tr>
+<tr class="separator:ga120b8aefb9ce7ef349929656359b1859"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga674533016ffed922a28b4f0b49b82cd4" id="r_ga674533016ffed922a28b4f0b49b82cd4"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga674533016ffed922a28b4f0b49b82cd4">hwloc_bitmap_and</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> res, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2)</td></tr>
+<tr class="separator:ga674533016ffed922a28b4f0b49b82cd4"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga7ca5c72db65406b85aca032c8a990f9e" id="r_ga7ca5c72db65406b85aca032c8a990f9e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga7ca5c72db65406b85aca032c8a990f9e">hwloc_bitmap_andnot</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> res, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2)</td></tr>
+<tr class="separator:ga7ca5c72db65406b85aca032c8a990f9e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga205508218e09cb9befd0687f16409f09" id="r_ga205508218e09cb9befd0687f16409f09"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga205508218e09cb9befd0687f16409f09">hwloc_bitmap_xor</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> res, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2)</td></tr>
+<tr class="separator:ga205508218e09cb9befd0687f16409f09"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga84cfdb4f8ab8c1f7e097728e613a2a3f" id="r_ga84cfdb4f8ab8c1f7e097728e613a2a3f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga84cfdb4f8ab8c1f7e097728e613a2a3f">hwloc_bitmap_not</a> (<a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> res, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap)</td></tr>
+<tr class="separator:ga84cfdb4f8ab8c1f7e097728e613a2a3f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaefa070f9232857ba5a57297ea9a08ea2" id="r_gaefa070f9232857ba5a57297ea9a08ea2"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gaefa070f9232857ba5a57297ea9a08ea2">hwloc_bitmap_intersects</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2)</td></tr>
+<tr class="separator:gaefa070f9232857ba5a57297ea9a08ea2"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga0526e03db81956fb02acc8260b66d6a4" id="r_ga0526e03db81956fb02acc8260b66d6a4"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga0526e03db81956fb02acc8260b66d6a4">hwloc_bitmap_isincluded</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> sub_bitmap, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> super_bitmap)</td></tr>
+<tr class="separator:ga0526e03db81956fb02acc8260b66d6a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga32376b1405e57472b73c3aa53bb39663" id="r_ga32376b1405e57472b73c3aa53bb39663"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga32376b1405e57472b73c3aa53bb39663">hwloc_bitmap_isequal</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2)</td></tr>
+<tr class="separator:ga32376b1405e57472b73c3aa53bb39663"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa39cda1510ab721b5c012c76ead72365" id="r_gaa39cda1510ab721b5c012c76ead72365"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#gaa39cda1510ab721b5c012c76ead72365">hwloc_bitmap_compare_first</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2)</td></tr>
+<tr class="separator:gaa39cda1510ab721b5c012c76ead72365"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga14cdbc0ef0a705e84999bd48a2e649f3" id="r_ga14cdbc0ef0a705e84999bd48a2e649f3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00194.html#ga14cdbc0ef0a705e84999bd48a2e649f3">hwloc_bitmap_compare</a> (<a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap1, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> bitmap2)</td></tr>
+<tr class="separator:ga14cdbc0ef0a705e84999bd48a2e649f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>The <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84" title="Set of bits represented as an opaque pointer to an internal bitmap.">hwloc_bitmap_t</a> type represents a set of integers (positive or null). A bitmap may be of infinite size (all bits are set after some point). A bitmap may even be full if all bits are set.</p>
+<p>Bitmaps are used by hwloc for sets of OS processors (which may actually be hardware threads) as by <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801" title="A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.">hwloc_cpuset_t</a> (a typedef for <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84" title="Set of bits represented as an opaque pointer to an internal bitmap.">hwloc_bitmap_t</a>), or sets of NUMA memory nodes as <a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508" title="A node set is a bitmap whose bits are set according to NUMA memory node physical OS indexes.">hwloc_nodeset_t</a> (also a typedef for <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84" title="Set of bits represented as an opaque pointer to an internal bitmap.">hwloc_bitmap_t</a>). Those are used for cpuset and nodeset fields in the <a class="el" href="a00229.html" title="Structure of a topology object.">hwloc_obj</a> structure, see <a class="el" href="a00172.html">Object Sets (hwloc_cpuset_t and hwloc_nodeset_t)</a>.</p>
+<p><em>Both CPU and node sets are always indexed by OS physical number.</em> However users should usually not build CPU and node sets manually (e.g. with <a class="el" href="a00194.html#ga062dbff93baeff3b425a7260c5463646" title="Add index id in bitmap bitmap.">hwloc_bitmap_set()</a>). One should rather use existing object sets and combine them with <a class="el" href="a00194.html#ga120b8aefb9ce7ef349929656359b1859" title="Or bitmaps bitmap1 and bitmap2 and store the result in bitmap res.">hwloc_bitmap_or()</a>, etc. For instance, binding the current thread on a pair of cores may be performed with: </p><div class="fragment"><div class="line"><a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> core1 = ... , core2 = ... ;</div>
+<div class="line"><a class="code hl_typedef" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set = <a class="code hl_function" href="a00194.html#gadece3d1eb5199fc2fb99bc7dcf1ccc05">hwloc_bitmap_alloc</a>();</div>
+<div class="line"><a class="code hl_function" href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">hwloc_bitmap_or</a>(set, core1-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>, core2-&gt;cpuset);</div>
+<div class="line"><a class="code hl_function" href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48">hwloc_set_cpubind</a>(topology, set, <a class="code hl_enumvalue" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421">HWLOC_CPUBIND_THREAD</a>);</div>
+<div class="line"><a class="code hl_function" href="a00194.html#ga156130d85b3a0674d6e0e6770fe68fbe">hwloc_bitmap_free</a>(set);</div>
+<div class="ttc" id="aa00179_html_ga80bc07473a8edf840cae17bd7ec21d48"><div class="ttname"><a href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48">hwloc_set_cpubind</a></div><div class="ttdeci">int hwloc_set_cpubind(hwloc_topology_t topology, hwloc_const_cpuset_t set, int flags)</div><div class="ttdoc">Bind current process or thread on CPUs given in physical bitmap set.</div></div>
+<div class="ttc" id="aa00179_html_gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421"><div class="ttname"><a href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421">HWLOC_CPUBIND_THREAD</a></div><div class="ttdeci">@ HWLOC_CPUBIND_THREAD</div><div class="ttdoc">Bind current thread of current process.</div><div class="ttdef"><b>Definition</b> hwloc.h:1256</div></div>
+<div class="ttc" id="aa00194_html_ga120b8aefb9ce7ef349929656359b1859"><div class="ttname"><a href="a00194.html#ga120b8aefb9ce7ef349929656359b1859">hwloc_bitmap_or</a></div><div class="ttdeci">int hwloc_bitmap_or(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</div><div class="ttdoc">Or bitmaps bitmap1 and bitmap2 and store the result in bitmap res.</div></div>
+<div class="ttc" id="aa00194_html_ga156130d85b3a0674d6e0e6770fe68fbe"><div class="ttname"><a href="a00194.html#ga156130d85b3a0674d6e0e6770fe68fbe">hwloc_bitmap_free</a></div><div class="ttdeci">void hwloc_bitmap_free(hwloc_bitmap_t bitmap)</div><div class="ttdoc">Free bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_gaa3c2bf4c776d603dcebbb61b0c923d84"><div class="ttname"><a href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a></div><div class="ttdeci">struct hwloc_bitmap_s * hwloc_bitmap_t</div><div class="ttdoc">Set of bits represented as an opaque pointer to an internal bitmap.</div><div class="ttdef"><b>Definition</b> bitmap.h:69</div></div>
+<div class="ttc" id="aa00194_html_gadece3d1eb5199fc2fb99bc7dcf1ccc05"><div class="ttname"><a href="a00194.html#gadece3d1eb5199fc2fb99bc7dcf1ccc05">hwloc_bitmap_alloc</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_bitmap_alloc(void)</div><div class="ttdoc">Allocate a new empty bitmap.</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_a67925e0f2c47f50408fbdb9bddd0790f"><div class="ttname"><a href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">hwloc_obj::cpuset</a></div><div class="ttdeci">hwloc_cpuset_t cpuset</div><div class="ttdoc">CPUs covered by this object.</div><div class="ttdef"><b>Definition</b> hwloc.h:547</div></div>
+</div><!-- fragment --><dl class="section note"><dt>Note</dt><dd>Most functions below return 0 on success and -1 on error. The usual error case would be an internal failure to realloc/extend the storage of the bitmap (<code>errno</code> would be set to <code>ENOMEM</code>). See also <a class="el" href="a00170.html">Error reporting in the API</a>.</dd>
+<dd>
+Several examples of using the bitmap API are available under the doc/examples/ directory in the source tree. Regression tests such as tests/hwloc/hwloc_bitmap*.c also make intensive use of this API. </dd></dl>
+<h2 class="groupheader">Macro Definition Documentation</h2>
+<a id="ga3f6861045a8029ade373510ffa727d2a" name="ga3f6861045a8029ade373510ffa727d2a"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga3f6861045a8029ade373510ffa727d2a">&#9670;&#160;</a></span>hwloc_bitmap_foreach_begin</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">#define hwloc_bitmap_foreach_begin</td>
+          <td>(</td>
+          <td class="paramtype">&#160;</td>
+          <td class="paramname">id, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">&#160;</td>
+          <td class="paramname">bitmap&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Loop macro iterating on bitmap <code>bitmap</code>. </p>
+<p>The loop must start with <a class="el" href="a00194.html#ga3f6861045a8029ade373510ffa727d2a" title="Loop macro iterating on bitmap bitmap.">hwloc_bitmap_foreach_begin()</a> and end with <a class="el" href="a00194.html#gafcf3246db406218d4e155735b3fa6528" title="End of loop macro iterating on a bitmap.">hwloc_bitmap_foreach_end()</a> followed by a terminating ';'.</p>
+<p><code>id</code> is the loop variable; it should be an unsigned int. The first iteration will set <code>id</code> to the lowest index in the bitmap. Successive iterations will iterate through, in order, all remaining indexes set in the bitmap. To be specific: each iteration will return a value for <code>id</code> such that hwloc_bitmap_isset(bitmap, id) is true.</p>
+<p>The assert prevents the loop from being infinite if the bitmap is infinitely set. </p>
+
+</div>
+</div>
+<a id="gafcf3246db406218d4e155735b3fa6528" name="gafcf3246db406218d4e155735b3fa6528"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gafcf3246db406218d4e155735b3fa6528">&#9670;&#160;</a></span>hwloc_bitmap_foreach_end</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">#define hwloc_bitmap_foreach_end</td>
+          <td>(</td>
+          <td class="paramname"></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>End of loop macro iterating on a bitmap. </p>
+<p>Needs a terminating ';'.</p>
+<dl class="section see"><dt>See also</dt><dd><a class="el" href="a00194.html#ga3f6861045a8029ade373510ffa727d2a" title="Loop macro iterating on bitmap bitmap.">hwloc_bitmap_foreach_begin()</a> </dd></dl>
+
+</div>
+</div>
+<h2 class="groupheader">Typedef Documentation</h2>
+<a id="gaa3c2bf4c776d603dcebbb61b0c923d84" name="gaa3c2bf4c776d603dcebbb61b0c923d84"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa3c2bf4c776d603dcebbb61b0c923d84">&#9670;&#160;</a></span>hwloc_bitmap_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef struct hwloc_bitmap_s* <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set of bits represented as an opaque pointer to an internal bitmap. </p>
+
+</div>
+</div>
+<a id="gae991a108af01d408be2776c5b2c467b2" name="gae991a108af01d408be2776c5b2c467b2"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gae991a108af01d408be2776c5b2c467b2">&#9670;&#160;</a></span>hwloc_const_bitmap_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef const struct hwloc_bitmap_s* <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>a non-modifiable <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84" title="Set of bits represented as an opaque pointer to an internal bitmap.">hwloc_bitmap_t</a> </p>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga06d505f8a1c0a536614f65f503ee6d93" name="ga06d505f8a1c0a536614f65f503ee6d93"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga06d505f8a1c0a536614f65f503ee6d93">&#9670;&#160;</a></span>hwloc_bitmap_allbut()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_allbut </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>id</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Fill the bitmap <code>and</code> clear the index <code>id</code>. </p>
+
+</div>
+</div>
+<a id="gadece3d1eb5199fc2fb99bc7dcf1ccc05" name="gadece3d1eb5199fc2fb99bc7dcf1ccc05"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gadece3d1eb5199fc2fb99bc7dcf1ccc05">&#9670;&#160;</a></span>hwloc_bitmap_alloc()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> hwloc_bitmap_alloc </td>
+          <td>(</td>
+          <td class="paramtype">void&#160;</td>
+          <td class="paramname"></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Allocate a new empty bitmap. </p>
+<dl class="section return"><dt>Returns</dt><dd>A valid bitmap or <code>NULL</code>.</dd></dl>
+<p>The bitmap should be freed by a corresponding call to <a class="el" href="a00194.html#ga156130d85b3a0674d6e0e6770fe68fbe" title="Free bitmap bitmap.">hwloc_bitmap_free()</a>. </p>
+
+</div>
+</div>
+<a id="ga02853b4a224970587b9d7a0e20d857c0" name="ga02853b4a224970587b9d7a0e20d857c0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga02853b4a224970587b9d7a0e20d857c0">&#9670;&#160;</a></span>hwloc_bitmap_alloc_full()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> hwloc_bitmap_alloc_full </td>
+          <td>(</td>
+          <td class="paramtype">void&#160;</td>
+          <td class="paramname"></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Allocate a new full bitmap. </p>
+<dl class="section return"><dt>Returns</dt><dd>A valid bitmap or <code>NULL</code>.</dd></dl>
+<p>The bitmap should be freed by a corresponding call to <a class="el" href="a00194.html#ga156130d85b3a0674d6e0e6770fe68fbe" title="Free bitmap bitmap.">hwloc_bitmap_free()</a>. </p>
+
+</div>
+</div>
+<a id="ga674533016ffed922a28b4f0b49b82cd4" name="ga674533016ffed922a28b4f0b49b82cd4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga674533016ffed922a28b4f0b49b82cd4">&#9670;&#160;</a></span>hwloc_bitmap_and()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_and </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>res</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap2</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>And bitmaps <code>bitmap1</code> and <code>bitmap2</code> and store the result in bitmap <code>res</code>. </p>
+<p><code>res</code> can be the same as <code>bitmap1</code> or <code>bitmap2</code> </p>
+
+</div>
+</div>
+<a id="ga7ca5c72db65406b85aca032c8a990f9e" name="ga7ca5c72db65406b85aca032c8a990f9e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga7ca5c72db65406b85aca032c8a990f9e">&#9670;&#160;</a></span>hwloc_bitmap_andnot()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_andnot </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>res</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap2</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>And bitmap <code>bitmap1</code> and the negation of <code>bitmap2</code> and store the result in bitmap <code>res</code>. </p>
+<p><code>res</code> can be the same as <code>bitmap1</code> or <code>bitmap2</code> </p>
+
+</div>
+</div>
+<a id="ga0fece972134fdecf2da9bc7a11dd827e" name="ga0fece972134fdecf2da9bc7a11dd827e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga0fece972134fdecf2da9bc7a11dd827e">&#9670;&#160;</a></span>hwloc_bitmap_asprintf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_asprintf </td>
+          <td>(</td>
+          <td class="paramtype">char **&#160;</td>
+          <td class="paramname"><em>strp</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Stringify a bitmap into a newly allocated string. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gaf20bb350b6844d08931a064a73f86743" name="gaf20bb350b6844d08931a064a73f86743"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf20bb350b6844d08931a064a73f86743">&#9670;&#160;</a></span>hwloc_bitmap_clr()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_clr </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>id</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Remove index <code>id</code> from bitmap <code>bitmap</code>. </p>
+
+</div>
+</div>
+<a id="ga833776709df94d727f8c22304b3388cf" name="ga833776709df94d727f8c22304b3388cf"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga833776709df94d727f8c22304b3388cf">&#9670;&#160;</a></span>hwloc_bitmap_clr_range()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_clr_range </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>begin</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>end</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Remove indexes from <code>begin</code> to <code>end</code> in bitmap <code>bitmap</code>. </p>
+<p>If <code>end</code> is <code>-1</code>, the range is infinite. </p>
+
+</div>
+</div>
+<a id="ga14cdbc0ef0a705e84999bd48a2e649f3" name="ga14cdbc0ef0a705e84999bd48a2e649f3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga14cdbc0ef0a705e84999bd48a2e649f3">&#9670;&#160;</a></span>hwloc_bitmap_compare()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_compare </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap2</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Compare bitmaps <code>bitmap1</code> and <code>bitmap2</code> in lexicographic order. </p>
+<p>Lexicographic comparison of bitmaps, starting for their highest indexes. Compare last indexes first, then second, etc. The empty bitmap is considered lower than anything.</p>
+<dl class="section return"><dt>Returns</dt><dd>-1 if <code>bitmap1</code> is considered smaller than <code>bitmap2</code>. </dd>
+<dd>
+1 if <code>bitmap1</code> is considered larger than <code>bitmap2</code>. </dd>
+<dd>
+0 if bitmaps are equal (contrary to <a class="el" href="a00194.html#gaa39cda1510ab721b5c012c76ead72365" title="Compare bitmaps bitmap1 and bitmap2 using their lowest index.">hwloc_bitmap_compare_first()</a>).</dd></dl>
+<p>For instance comparing binary bitmaps 0011 and 0110 returns -1 (hence 0011 is considered smaller than 0110). Comparing 00101 and 01010 returns -1 too.</p>
+<dl class="section note"><dt>Note</dt><dd>This is different from the non-existing hwloc_bitmap_compare_last() which would only compare the highest index of each bitmap. </dd></dl>
+
+</div>
+</div>
+<a id="gaa39cda1510ab721b5c012c76ead72365" name="gaa39cda1510ab721b5c012c76ead72365"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa39cda1510ab721b5c012c76ead72365">&#9670;&#160;</a></span>hwloc_bitmap_compare_first()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_compare_first </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap2</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Compare bitmaps <code>bitmap1</code> and <code>bitmap2</code> using their lowest index. </p>
+<p>A bitmap is considered smaller if its least significant bit is smaller. The empty bitmap is considered higher than anything (because its least significant bit does not exist).</p>
+<dl class="section return"><dt>Returns</dt><dd>-1 if <code>bitmap1</code> is considered smaller than <code>bitmap2</code>. </dd>
+<dd>
+1 if <code>bitmap1</code> is considered larger than <code>bitmap2</code>.</dd></dl>
+<p>For instance comparing binary bitmaps 0011 and 0110 returns -1 (hence 0011 is considered smaller than 0110) because least significant bit of 0011 (0001) is smaller than least significant bit of 0110 (0010). Comparing 01001 and 00110 would also return -1 for the same reason.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 if bitmaps are considered equal, even if they are not strictly equal. They just need to have the same least significant bit. For instance, comparing binary bitmaps 0010 and 0110 returns 0 because they have the same least significant bit. </dd></dl>
+
+</div>
+</div>
+<a id="ga72a29824798b48784b8217471ec8f14c" name="ga72a29824798b48784b8217471ec8f14c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga72a29824798b48784b8217471ec8f14c">&#9670;&#160;</a></span>hwloc_bitmap_copy()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_copy </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>dst</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>src</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Copy the contents of bitmap <code>src</code> into the already allocated bitmap <code>dst</code>. </p>
+
+</div>
+</div>
+<a id="gae679434c1a5f41d3560a8a7e2c1b0dee" name="gae679434c1a5f41d3560a8a7e2c1b0dee"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gae679434c1a5f41d3560a8a7e2c1b0dee">&#9670;&#160;</a></span>hwloc_bitmap_dup()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> hwloc_bitmap_dup </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Duplicate bitmap <code>bitmap</code> by allocating a new bitmap and copying <code>bitmap</code> contents. </p>
+<p>If <code>bitmap</code> is <code>NULL</code>, <code>NULL</code> is returned. </p>
+
+</div>
+</div>
+<a id="ga07b2de8786b3cdb22f21d9dd42588275" name="ga07b2de8786b3cdb22f21d9dd42588275"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga07b2de8786b3cdb22f21d9dd42588275">&#9670;&#160;</a></span>hwloc_bitmap_fill()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_bitmap_fill </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Fill bitmap <code>bitmap</code> with all possible indexes (even if those objects don't exist or are otherwise unavailable) </p>
+
+</div>
+</div>
+<a id="ga3ec1ced43afadf8c0a7197320bc016ed" name="ga3ec1ced43afadf8c0a7197320bc016ed"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga3ec1ced43afadf8c0a7197320bc016ed">&#9670;&#160;</a></span>hwloc_bitmap_first()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_first </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Compute the first index (least significant bit) in bitmap <code>bitmap</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the first index set in <code>bitmap</code>. </dd>
+<dd>
+-1 if <code>bitmap</code> is empty. </dd></dl>
+
+</div>
+</div>
+<a id="gae408841487b288e148a478ba0465c99e" name="gae408841487b288e148a478ba0465c99e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gae408841487b288e148a478ba0465c99e">&#9670;&#160;</a></span>hwloc_bitmap_first_unset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_first_unset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Compute the first unset index (least significant bit) in bitmap <code>bitmap</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the first unset index in <code>bitmap</code>. </dd>
+<dd>
+-1 if <code>bitmap</code> is full. </dd></dl>
+
+</div>
+</div>
+<a id="ga156130d85b3a0674d6e0e6770fe68fbe" name="ga156130d85b3a0674d6e0e6770fe68fbe"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga156130d85b3a0674d6e0e6770fe68fbe">&#9670;&#160;</a></span>hwloc_bitmap_free()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_bitmap_free </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Free bitmap <code>bitmap</code>. </p>
+<p>If <code>bitmap</code> is <code>NULL</code>, no operation is performed. </p>
+
+</div>
+</div>
+<a id="ga4947c46d47bcfcd3faf3f59569be3e37" name="ga4947c46d47bcfcd3faf3f59569be3e37"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga4947c46d47bcfcd3faf3f59569be3e37">&#9670;&#160;</a></span>hwloc_bitmap_from_ith_ulong()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_from_ith_ulong </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>i</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>mask</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Setup bitmap <code>bitmap</code> from unsigned long <code>mask</code> used as <code>i</code> -th subset. </p>
+
+</div>
+</div>
+<a id="gad59b0ebeb29c1bfabbb2a379e55c1159" name="gad59b0ebeb29c1bfabbb2a379e55c1159"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad59b0ebeb29c1bfabbb2a379e55c1159">&#9670;&#160;</a></span>hwloc_bitmap_from_ulong()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_from_ulong </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>mask</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Setup bitmap <code>bitmap</code> from unsigned long <code>mask</code>. </p>
+
+</div>
+</div>
+<a id="gabcfef22f6fc4d4b33f068dd91a1c38f5" name="gabcfef22f6fc4d4b33f068dd91a1c38f5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gabcfef22f6fc4d4b33f068dd91a1c38f5">&#9670;&#160;</a></span>hwloc_bitmap_from_ulongs()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_from_ulongs </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>nr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const unsigned long *&#160;</td>
+          <td class="paramname"><em>masks</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Setup bitmap <code>bitmap</code> from unsigned longs <code>masks</code> used as first <code>nr</code> subsets. </p>
+
+</div>
+</div>
+<a id="gaefa070f9232857ba5a57297ea9a08ea2" name="gaefa070f9232857ba5a57297ea9a08ea2"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaefa070f9232857ba5a57297ea9a08ea2">&#9670;&#160;</a></span>hwloc_bitmap_intersects()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_intersects </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap2</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Test whether bitmaps <code>bitmap1</code> and <code>bitmap2</code> intersects. </p>
+<dl class="section return"><dt>Returns</dt><dd>1 if bitmaps intersect, 0 otherwise.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>The empty bitmap does not intersect any other bitmap. </dd></dl>
+
+</div>
+</div>
+<a id="ga32376b1405e57472b73c3aa53bb39663" name="ga32376b1405e57472b73c3aa53bb39663"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga32376b1405e57472b73c3aa53bb39663">&#9670;&#160;</a></span>hwloc_bitmap_isequal()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_isequal </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap2</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Test whether bitmap <code>bitmap1</code> is equal to bitmap <code>bitmap2</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>1 if bitmaps are equal, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="ga5fdcb8c19c336511c37076d649e74af4" name="ga5fdcb8c19c336511c37076d649e74af4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga5fdcb8c19c336511c37076d649e74af4">&#9670;&#160;</a></span>hwloc_bitmap_isfull()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_isfull </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Test whether bitmap <code>bitmap</code> is completely full. </p>
+<dl class="section return"><dt>Returns</dt><dd>1 if bitmap is full, 0 otherwise.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>A full bitmap is always infinitely set. </dd></dl>
+
+</div>
+</div>
+<a id="ga0526e03db81956fb02acc8260b66d6a4" name="ga0526e03db81956fb02acc8260b66d6a4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga0526e03db81956fb02acc8260b66d6a4">&#9670;&#160;</a></span>hwloc_bitmap_isincluded()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_isincluded </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>sub_bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>super_bitmap</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Test whether bitmap <code>sub_bitmap</code> is part of bitmap <code>super_bitmap</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>1 if <code>sub_bitmap</code> is included in <code>super_bitmap</code>, 0 otherwise.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>The empty bitmap is considered included in any other bitmap. </dd></dl>
+
+</div>
+</div>
+<a id="ga11340dd487f110bb84f0a6e4ae90bd06" name="ga11340dd487f110bb84f0a6e4ae90bd06"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga11340dd487f110bb84f0a6e4ae90bd06">&#9670;&#160;</a></span>hwloc_bitmap_isset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_isset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>id</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Test whether index <code>id</code> is part of bitmap <code>bitmap</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>1 if the bit at index <code>id</code> is set in bitmap <code>bitmap</code>, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="ga5b64be28f5a7176ed8ad0d6a90bdf108" name="ga5b64be28f5a7176ed8ad0d6a90bdf108"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga5b64be28f5a7176ed8ad0d6a90bdf108">&#9670;&#160;</a></span>hwloc_bitmap_iszero()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_iszero </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Test whether bitmap <code>bitmap</code> is empty. </p>
+<dl class="section return"><dt>Returns</dt><dd>1 if bitmap is empty, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="ga3d9b08b060a59bbab5a4ea6d0a1ed7a6" name="ga3d9b08b060a59bbab5a4ea6d0a1ed7a6"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga3d9b08b060a59bbab5a4ea6d0a1ed7a6">&#9670;&#160;</a></span>hwloc_bitmap_last()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_last </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Compute the last index (most significant bit) in bitmap <code>bitmap</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the last index set in <code>bitmap</code>. </dd>
+<dd>
+-1 if <code>bitmap</code> is empty, or if <code>bitmap</code> is infinitely set. </dd></dl>
+
+</div>
+</div>
+<a id="ga45d49aeb45c7da631b1480a93dc3fc92" name="ga45d49aeb45c7da631b1480a93dc3fc92"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga45d49aeb45c7da631b1480a93dc3fc92">&#9670;&#160;</a></span>hwloc_bitmap_last_unset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_last_unset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Compute the last unset index (most significant bit) in bitmap <code>bitmap</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the last index unset in <code>bitmap</code>. </dd>
+<dd>
+-1 if <code>bitmap</code> is full, or if <code>bitmap</code> is not infinitely set. </dd></dl>
+
+</div>
+</div>
+<a id="ga39c0f1b02053de66d205c9f8260b3665" name="ga39c0f1b02053de66d205c9f8260b3665"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga39c0f1b02053de66d205c9f8260b3665">&#9670;&#160;</a></span>hwloc_bitmap_list_asprintf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_list_asprintf </td>
+          <td>(</td>
+          <td class="paramtype">char **&#160;</td>
+          <td class="paramname"><em>strp</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Stringify a bitmap into a newly allocated list string. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga3d06e6447edeb61e56a9ad83f31f0a37" name="ga3d06e6447edeb61e56a9ad83f31f0a37"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga3d06e6447edeb61e56a9ad83f31f0a37">&#9670;&#160;</a></span>hwloc_bitmap_list_snprintf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_list_snprintf </td>
+          <td>(</td>
+          <td class="paramtype">char *restrict&#160;</td>
+          <td class="paramname"><em>buf</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>buflen</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Stringify a bitmap in the list format. </p>
+<p>Lists are comma-separated indexes or ranges. Ranges are dash separated indexes. The last range may not have an ending indexes if the bitmap is infinitely set.</p>
+<p>Up to <code>buflen</code> characters may be written in buffer <code>buf</code>.</p>
+<p>If <code>buflen</code> is 0, <code>buf</code> may safely be <code>NULL</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>the number of characters that were actually written if not truncating, or that would have been written (not including the ending \0). </dd></dl>
+
+</div>
+</div>
+<a id="gaf9314311d482c621e17c6a53a9fe993e" name="gaf9314311d482c621e17c6a53a9fe993e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf9314311d482c621e17c6a53a9fe993e">&#9670;&#160;</a></span>hwloc_bitmap_list_sscanf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_list_sscanf </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *restrict&#160;</td>
+          <td class="paramname"><em>string</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Parse a list string and stores it in bitmap <code>bitmap</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gaab7240b4b644693b775dad17b44ffd68" name="gaab7240b4b644693b775dad17b44ffd68"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaab7240b4b644693b775dad17b44ffd68">&#9670;&#160;</a></span>hwloc_bitmap_next()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_next </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Compute the next index in bitmap <code>bitmap</code> which is after index <code>prev</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the first index set in <code>bitmap</code> if <code>prev</code> is <code>-1</code>. </dd>
+<dd>
+the next index set in <code>bitmap</code> if <code>prev</code> is not <code>-1</code>. </dd>
+<dd>
+-1 if no index with higher index is set in <code>bitmap</code>. </dd></dl>
+
+</div>
+</div>
+<a id="ga9653af34d1460ef106b7df25af4cdca8" name="ga9653af34d1460ef106b7df25af4cdca8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9653af34d1460ef106b7df25af4cdca8">&#9670;&#160;</a></span>hwloc_bitmap_next_unset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_next_unset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>prev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Compute the next unset index in bitmap <code>bitmap</code> which is after index <code>prev</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>the first index unset in <code>bitmap</code> if <code>prev</code> is <code>-1</code>. </dd>
+<dd>
+the next index unset in <code>bitmap</code> if <code>prev</code> is not <code>-1</code>. </dd>
+<dd>
+-1 if no index with higher index is unset in <code>bitmap</code>. </dd></dl>
+
+</div>
+</div>
+<a id="ga84cfdb4f8ab8c1f7e097728e613a2a3f" name="ga84cfdb4f8ab8c1f7e097728e613a2a3f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga84cfdb4f8ab8c1f7e097728e613a2a3f">&#9670;&#160;</a></span>hwloc_bitmap_not()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_not </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>res</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Negate bitmap <code>bitmap</code> and store the result in bitmap <code>res</code>. </p>
+<p><code>res</code> can be the same as <code>bitmap</code> </p>
+
+</div>
+</div>
+<a id="gac0744734d761d65c977aece565364908" name="gac0744734d761d65c977aece565364908"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac0744734d761d65c977aece565364908">&#9670;&#160;</a></span>hwloc_bitmap_nr_ulongs()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_nr_ulongs </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return the number of unsigned longs required for storing bitmap <code>bitmap</code> entirely. </p>
+<p>This is the number of contiguous unsigned longs from the very first bit of the bitmap (even if unset) up to the last set bit. This is useful for knowing the <code>nr</code> parameter to pass to <a class="el" href="a00194.html#gacd215a2348732de25d94a4ecd76d528c" title="Convert the first nr subsets of bitmap bitmap into the array of nr unsigned long masks.">hwloc_bitmap_to_ulongs()</a> (or which calls to <a class="el" href="a00194.html#gac92e6404f648d6b99d2c626b05b2ffa4" title="Convert the i -th subset of bitmap bitmap into unsigned long mask.">hwloc_bitmap_to_ith_ulong()</a> are needed) to entirely convert a bitmap into multiple unsigned longs.</p>
+<p>When called on the output of <a class="el" href="a00191.html#ga79212faa07b70dd26588941b17d9fa82" title="Get topology CPU set.">hwloc_topology_get_topology_cpuset()</a>, the returned number is large enough for all cpusets of the topology.</p>
+<dl class="section return"><dt>Returns</dt><dd>the number of unsigned longs required. </dd>
+<dd>
+-1 if <code>bitmap</code> is infinite. </dd></dl>
+
+</div>
+</div>
+<a id="ga10be0840cdeb7ce26d862819dd303baa" name="ga10be0840cdeb7ce26d862819dd303baa"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga10be0840cdeb7ce26d862819dd303baa">&#9670;&#160;</a></span>hwloc_bitmap_only()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_only </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>id</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Empty the bitmap <code>bitmap</code> and add bit <code>id</code>. </p>
+
+</div>
+</div>
+<a id="ga120b8aefb9ce7ef349929656359b1859" name="ga120b8aefb9ce7ef349929656359b1859"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga120b8aefb9ce7ef349929656359b1859">&#9670;&#160;</a></span>hwloc_bitmap_or()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_or </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>res</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap2</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Or bitmaps <code>bitmap1</code> and <code>bitmap2</code> and store the result in bitmap <code>res</code>. </p>
+<p><code>res</code> can be the same as <code>bitmap1</code> or <code>bitmap2</code> </p>
+
+</div>
+</div>
+<a id="ga062dbff93baeff3b425a7260c5463646" name="ga062dbff93baeff3b425a7260c5463646"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga062dbff93baeff3b425a7260c5463646">&#9670;&#160;</a></span>hwloc_bitmap_set()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_set </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>id</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Add index <code>id</code> in bitmap <code>bitmap</code>. </p>
+
+</div>
+</div>
+<a id="ga3daeed965c35c6d2fd4820a318219985" name="ga3daeed965c35c6d2fd4820a318219985"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga3daeed965c35c6d2fd4820a318219985">&#9670;&#160;</a></span>hwloc_bitmap_set_ith_ulong()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_set_ith_ulong </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>i</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>mask</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Replace <code>i</code> -th subset of bitmap <code>bitmap</code> with unsigned long <code>mask</code>. </p>
+
+</div>
+</div>
+<a id="ga9c9a8433732fb9f24899e7aa4c014d7e" name="ga9c9a8433732fb9f24899e7aa4c014d7e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9c9a8433732fb9f24899e7aa4c014d7e">&#9670;&#160;</a></span>hwloc_bitmap_set_range()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_set_range </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>begin</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>end</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Add indexes from <code>begin</code> to <code>end</code> in bitmap <code>bitmap</code>. </p>
+<p>If <code>end</code> is <code>-1</code>, the range is infinite. </p>
+
+</div>
+</div>
+<a id="gaa611a77c092e679246afdf9a60d5db8b" name="gaa611a77c092e679246afdf9a60d5db8b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa611a77c092e679246afdf9a60d5db8b">&#9670;&#160;</a></span>hwloc_bitmap_singlify()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_singlify </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Keep a single index among those set in bitmap <code>bitmap</code>. </p>
+<p>May be useful before binding so that the process does not have a chance of migrating between multiple processors in the original mask. Instead of running the task on any PU inside the given CPU set, the operating system scheduler will be forced to run it on a single of these PUs. It avoids a migration overhead and cache-line ping-pongs between PUs.</p>
+<dl class="section note"><dt>Note</dt><dd>This function is NOT meant to distribute multiple processes within a single CPU set. It always return the same single bit when called multiple times on the same input set. <a class="el" href="a00190.html#ga7b0c28f797c2ff17fa2f244ebbd55b33" title="Distribute n items over the topology under roots.">hwloc_distrib()</a> may be used for generating CPU sets to distribute multiple tasks below a single multi-PU object.</dd>
+<dd>
+This function cannot be applied to an object set directly. It should be applied to a copy (which may be obtained with <a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee" title="Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.">hwloc_bitmap_dup()</a>). </dd></dl>
+
+</div>
+</div>
+<a id="ga9511644657030a021dce9941e3cda583" name="ga9511644657030a021dce9941e3cda583"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9511644657030a021dce9941e3cda583">&#9670;&#160;</a></span>hwloc_bitmap_snprintf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_snprintf </td>
+          <td>(</td>
+          <td class="paramtype">char *restrict&#160;</td>
+          <td class="paramname"><em>buf</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>buflen</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Stringify a bitmap. </p>
+<p>Up to <code>buflen</code> characters may be written in buffer <code>buf</code>.</p>
+<p>If <code>buflen</code> is 0, <code>buf</code> may safely be <code>NULL</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>the number of characters that were actually written if not truncating, or that would have been written (not including the ending \0). </dd></dl>
+
+</div>
+</div>
+<a id="ga064a85c643a364b60acbfa0f3663fc18" name="ga064a85c643a364b60acbfa0f3663fc18"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga064a85c643a364b60acbfa0f3663fc18">&#9670;&#160;</a></span>hwloc_bitmap_sscanf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_sscanf </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *restrict&#160;</td>
+          <td class="paramname"><em>string</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Parse a bitmap string and stores it in bitmap <code>bitmap</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga391312513f17c985d871f18367c59512" name="ga391312513f17c985d871f18367c59512"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga391312513f17c985d871f18367c59512">&#9670;&#160;</a></span>hwloc_bitmap_taskset_asprintf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_taskset_asprintf </td>
+          <td>(</td>
+          <td class="paramtype">char **&#160;</td>
+          <td class="paramname"><em>strp</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Stringify a bitmap into a newly allocated taskset-specific string. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga5beb68a987fe48e5c5edef06ab260e14" name="ga5beb68a987fe48e5c5edef06ab260e14"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga5beb68a987fe48e5c5edef06ab260e14">&#9670;&#160;</a></span>hwloc_bitmap_taskset_snprintf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_taskset_snprintf </td>
+          <td>(</td>
+          <td class="paramtype">char *restrict&#160;</td>
+          <td class="paramname"><em>buf</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>buflen</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Stringify a bitmap in the taskset-specific format. </p>
+<p>The taskset command manipulates bitmap strings that contain a single (possible very long) hexadecimal number starting with 0x.</p>
+<p>Up to <code>buflen</code> characters may be written in buffer <code>buf</code>.</p>
+<p>If <code>buflen</code> is 0, <code>buf</code> may safely be <code>NULL</code>.</p>
+<dl class="section return"><dt>Returns</dt><dd>the number of characters that were actually written if not truncating, or that would have been written (not including the ending \0). </dd></dl>
+
+</div>
+</div>
+<a id="ga4f23db5041240e03e348752f8bd6ec2d" name="ga4f23db5041240e03e348752f8bd6ec2d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga4f23db5041240e03e348752f8bd6ec2d">&#9670;&#160;</a></span>hwloc_bitmap_taskset_sscanf()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_taskset_sscanf </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *restrict&#160;</td>
+          <td class="paramname"><em>string</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Parse a taskset-specific bitmap string and stores it in bitmap <code>bitmap</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gac92e6404f648d6b99d2c626b05b2ffa4" name="gac92e6404f648d6b99d2c626b05b2ffa4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac92e6404f648d6b99d2c626b05b2ffa4">&#9670;&#160;</a></span>hwloc_bitmap_to_ith_ulong()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned long hwloc_bitmap_to_ith_ulong </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>i</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Convert the <code>i</code> -th subset of bitmap <code>bitmap</code> into unsigned long mask. </p>
+
+</div>
+</div>
+<a id="gab6a6bae22a33ec6adfc169a953c13e6c" name="gab6a6bae22a33ec6adfc169a953c13e6c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab6a6bae22a33ec6adfc169a953c13e6c">&#9670;&#160;</a></span>hwloc_bitmap_to_ulong()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned long hwloc_bitmap_to_ulong </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Convert the beginning part of bitmap <code>bitmap</code> into unsigned long <code>mask</code>. </p>
+
+</div>
+</div>
+<a id="gacd215a2348732de25d94a4ecd76d528c" name="gacd215a2348732de25d94a4ecd76d528c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gacd215a2348732de25d94a4ecd76d528c">&#9670;&#160;</a></span>hwloc_bitmap_to_ulongs()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_to_ulongs </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>nr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long *&#160;</td>
+          <td class="paramname"><em>masks</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Convert the first <code>nr</code> subsets of bitmap <code>bitmap</code> into the array of <code>nr</code> unsigned long <code>masks</code>. </p>
+<p><code>nr</code> may be determined earlier with <a class="el" href="a00194.html#gac0744734d761d65c977aece565364908" title="Return the number of unsigned longs required for storing bitmap bitmap entirely.">hwloc_bitmap_nr_ulongs()</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 </dd></dl>
+
+</div>
+</div>
+<a id="ga0200466842c0e1f5da75e84dde460b10" name="ga0200466842c0e1f5da75e84dde460b10"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga0200466842c0e1f5da75e84dde460b10">&#9670;&#160;</a></span>hwloc_bitmap_weight()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_weight </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Compute the "weight" of bitmap <code>bitmap</code> (i.e., number of indexes that are in the bitmap). </p>
+<dl class="section return"><dt>Returns</dt><dd>the number of indexes that are in the bitmap. </dd>
+<dd>
+-1 if <code>bitmap</code> is infinitely set. </dd></dl>
+
+</div>
+</div>
+<a id="ga205508218e09cb9befd0687f16409f09" name="ga205508218e09cb9befd0687f16409f09"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga205508218e09cb9befd0687f16409f09">&#9670;&#160;</a></span>hwloc_bitmap_xor()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_bitmap_xor </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>res</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap2</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Xor bitmaps <code>bitmap1</code> and <code>bitmap2</code> and store the result in bitmap <code>res</code>. </p>
+<p><code>res</code> can be the same as <code>bitmap1</code> or <code>bitmap2</code> </p>
+
+</div>
+</div>
+<a id="gaa97c5217613c8cae9862287170ea2132" name="gaa97c5217613c8cae9862287170ea2132"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa97c5217613c8cae9862287170ea2132">&#9670;&#160;</a></span>hwloc_bitmap_zero()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_bitmap_zero </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>bitmap</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Empty the bitmap <code>bitmap</code>. </p>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00195.html 2.11.0-1/doc/doxygen-doc/html/a00195.html
--- 2.10.0-1/doc/doxygen-doc/html/a00195.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00195.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,429 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Exporting Topologies to XML</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Exporting Topologies to XML</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:ga0eb99636aff71fe2704e1fa0ffe8c18d" id="r_ga0eb99636aff71fe2704e1fa0ffe8c18d"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00195.html#ga0eb99636aff71fe2704e1fa0ffe8c18d">hwloc_topology_export_xml_flags_e</a> { <a class="el" href="a00195.html#gga0eb99636aff71fe2704e1fa0ffe8c18dae7d6d96546131ef0043867b836b02e0f">HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1</a>
+ }</td></tr>
+<tr class="separator:ga0eb99636aff71fe2704e1fa0ffe8c18d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga333f79975b4eeb28a3d8fad3373583ce" id="r_ga333f79975b4eeb28a3d8fad3373583ce"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00195.html#ga333f79975b4eeb28a3d8fad3373583ce">hwloc_topology_export_xml</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const char *xmlpath, unsigned long flags)</td></tr>
+<tr class="separator:ga333f79975b4eeb28a3d8fad3373583ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gad33b7f7c11db10459505a3b1634fd3f1" id="r_gad33b7f7c11db10459505a3b1634fd3f1"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00195.html#gad33b7f7c11db10459505a3b1634fd3f1">hwloc_topology_export_xmlbuffer</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, char **xmlbuffer, int *buflen, unsigned long flags)</td></tr>
+<tr class="separator:gad33b7f7c11db10459505a3b1634fd3f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga293e4a6489f15fd16ad22a5734561cf1" id="r_ga293e4a6489f15fd16ad22a5734561cf1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00195.html#ga293e4a6489f15fd16ad22a5734561cf1">hwloc_free_xmlbuffer</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, char *xmlbuffer)</td></tr>
+<tr class="separator:ga293e4a6489f15fd16ad22a5734561cf1"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga9d6ff0f7a8dd45be9aa8575ef31978cc" id="r_ga9d6ff0f7a8dd45be9aa8575ef31978cc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00195.html#ga9d6ff0f7a8dd45be9aa8575ef31978cc">hwloc_topology_set_userdata_export_callback</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, void(*export_cb)(void *reserved, <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj))</td></tr>
+<tr class="separator:ga9d6ff0f7a8dd45be9aa8575ef31978cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa541bdd628416dbbe97d0df69d3de958" id="r_gaa541bdd628416dbbe97d0df69d3de958"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00195.html#gaa541bdd628416dbbe97d0df69d3de958">hwloc_export_obj_userdata</a> (void *reserved, <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj, const char *name, const void *buffer, size_t length)</td></tr>
+<tr class="separator:gaa541bdd628416dbbe97d0df69d3de958"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1b7358137cec27bd073f58a606ecbaba" id="r_ga1b7358137cec27bd073f58a606ecbaba"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00195.html#ga1b7358137cec27bd073f58a606ecbaba">hwloc_export_obj_userdata_base64</a> (void *reserved, <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj, const char *name, const void *buffer, size_t length)</td></tr>
+<tr class="separator:ga1b7358137cec27bd073f58a606ecbaba"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga5ac6917ea7289955fb1ffda4353af9b0" id="r_ga5ac6917ea7289955fb1ffda4353af9b0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00195.html#ga5ac6917ea7289955fb1ffda4353af9b0">hwloc_topology_set_userdata_import_callback</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, void(*import_cb)(<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj, const char *name, const void *buffer, size_t length))</td></tr>
+<tr class="separator:ga5ac6917ea7289955fb1ffda4353af9b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="ga0eb99636aff71fe2704e1fa0ffe8c18d" name="ga0eb99636aff71fe2704e1fa0ffe8c18d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga0eb99636aff71fe2704e1fa0ffe8c18d">&#9670;&#160;</a></span>hwloc_topology_export_xml_flags_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00195.html#ga0eb99636aff71fe2704e1fa0ffe8c18d">hwloc_topology_export_xml_flags_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Flags for exporting XML topologies. </p>
+<p>Flags to be given as a OR'ed set to <a class="el" href="a00195.html#ga333f79975b4eeb28a3d8fad3373583ce" title="Export the topology into an XML file.">hwloc_topology_export_xml()</a>. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga0eb99636aff71fe2704e1fa0ffe8c18dae7d6d96546131ef0043867b836b02e0f" name="gga0eb99636aff71fe2704e1fa0ffe8c18dae7d6d96546131ef0043867b836b02e0f"></a>HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1&#160;</td><td class="fielddoc"><p>Export XML that is loadable by hwloc v1.x. However, the export may miss some details about the topology. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gaa541bdd628416dbbe97d0df69d3de958" name="gaa541bdd628416dbbe97d0df69d3de958"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa541bdd628416dbbe97d0df69d3de958">&#9670;&#160;</a></span>hwloc_export_obj_userdata()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_export_obj_userdata </td>
+          <td>(</td>
+          <td class="paramtype">void *&#160;</td>
+          <td class="paramname"><em>reserved</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>name</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const void *&#160;</td>
+          <td class="paramname"><em>buffer</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>length</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Export some object userdata to XML. </p>
+<p>This function may only be called from within the export() callback passed to <a class="el" href="a00195.html#ga9d6ff0f7a8dd45be9aa8575ef31978cc" title="Set the application-specific callback for exporting object userdata.">hwloc_topology_set_userdata_export_callback()</a>. It may be invoked one of multiple times to export some userdata to XML. The <code>buffer</code> content of length <code>length</code> is stored with optional name <code>name</code>.</p>
+<p>When importing this XML file, the import() callback (if set) will be called exactly as many times as <a class="el" href="a00195.html#gaa541bdd628416dbbe97d0df69d3de958" title="Export some object userdata to XML.">hwloc_export_obj_userdata()</a> was called during export(). It will receive the corresponding <code>name</code>, <code>buffer</code> and <code>length</code> arguments.</p>
+<p><code>reserved</code>, <code>topology</code> and <code>obj</code> must be the first three parameters that were given to the export callback.</p>
+<p>Only printable characters may be exported to XML string attributes.</p>
+<p>If exporting binary data, the application should first encode into printable characters only (or use <a class="el" href="a00195.html#ga1b7358137cec27bd073f58a606ecbaba" title="Encode and export some object userdata to XML.">hwloc_export_obj_userdata_base64()</a>). It should also take care of portability issues if the export may be reimported on a different architecture.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if a non-printable character is passed in <code>name</code> or <b>buffer</b>. </dd></dl>
+
+</div>
+</div>
+<a id="ga1b7358137cec27bd073f58a606ecbaba" name="ga1b7358137cec27bd073f58a606ecbaba"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1b7358137cec27bd073f58a606ecbaba">&#9670;&#160;</a></span>hwloc_export_obj_userdata_base64()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_export_obj_userdata_base64 </td>
+          <td>(</td>
+          <td class="paramtype">void *&#160;</td>
+          <td class="paramname"><em>reserved</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>name</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const void *&#160;</td>
+          <td class="paramname"><em>buffer</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>length</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Encode and export some object userdata to XML. </p>
+<p>This function is similar to <a class="el" href="a00195.html#gaa541bdd628416dbbe97d0df69d3de958" title="Export some object userdata to XML.">hwloc_export_obj_userdata()</a> but it encodes the input buffer into printable characters before exporting. On import, decoding is automatically performed before the data is given to the import() callback if any.</p>
+<p>This function may only be called from within the export() callback passed to <a class="el" href="a00195.html#ga9d6ff0f7a8dd45be9aa8575ef31978cc" title="Set the application-specific callback for exporting object userdata.">hwloc_topology_set_userdata_export_callback()</a>.</p>
+<p>The name must be made of printable characters for export to XML string attributes.</p>
+<p>The function does not take care of portability issues if the export may be reimported on a different architecture.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if a non-printable character is passed in <code>name</code>. </dd></dl>
+
+</div>
+</div>
+<a id="ga293e4a6489f15fd16ad22a5734561cf1" name="ga293e4a6489f15fd16ad22a5734561cf1"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga293e4a6489f15fd16ad22a5734561cf1">&#9670;&#160;</a></span>hwloc_free_xmlbuffer()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_free_xmlbuffer </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">char *&#160;</td>
+          <td class="paramname"><em>xmlbuffer</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Free a buffer allocated by <a class="el" href="a00195.html#gad33b7f7c11db10459505a3b1634fd3f1" title="Export the topology into a newly-allocated XML memory buffer.">hwloc_topology_export_xmlbuffer()</a> </p>
+
+</div>
+</div>
+<a id="ga333f79975b4eeb28a3d8fad3373583ce" name="ga333f79975b4eeb28a3d8fad3373583ce"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga333f79975b4eeb28a3d8fad3373583ce">&#9670;&#160;</a></span>hwloc_topology_export_xml()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_export_xml </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>xmlpath</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Export the topology into an XML file. </p>
+<p>This file may be loaded later through <a class="el" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e" title="Enable XML-file based topology.">hwloc_topology_set_xml()</a>.</p>
+<p>By default, the latest export format is used, which means older hwloc releases (e.g. v1.x) will not be able to import it. Exporting to v1.x specific XML format is possible using flag <a class="el" href="a00195.html#gga0eb99636aff71fe2704e1fa0ffe8c18dae7d6d96546131ef0043867b836b02e0f" title="Export XML that is loadable by hwloc v1.x. However, the export may miss some details about the topolo...">HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1</a> but it may miss some details about the topology. If there is any chance that the exported file may ever be imported back by a process using hwloc 1.x, one should consider detecting it at runtime and using the corresponding export format.</p>
+<p><code>flags</code> is a OR'ed set of <a class="el" href="a00195.html#ga0eb99636aff71fe2704e1fa0ffe8c18d" title="Flags for exporting XML topologies.">hwloc_topology_export_xml_flags_e</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, or -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>See also <a class="el" href="a00195.html#ga9d6ff0f7a8dd45be9aa8575ef31978cc" title="Set the application-specific callback for exporting object userdata.">hwloc_topology_set_userdata_export_callback()</a> for exporting application-specific object userdata.</dd>
+<dd>
+The topology-specific userdata pointer is ignored when exporting to XML.</dd>
+<dd>
+Only printable characters may be exported to XML string attributes. Any other character, especially any non-ASCII character, will be silently dropped.</dd>
+<dd>
+If <code>name</code> is "-", the XML output is sent to the standard output. </dd></dl>
+
+</div>
+</div>
+<a id="gad33b7f7c11db10459505a3b1634fd3f1" name="gad33b7f7c11db10459505a3b1634fd3f1"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad33b7f7c11db10459505a3b1634fd3f1">&#9670;&#160;</a></span>hwloc_topology_export_xmlbuffer()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_export_xmlbuffer </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">char **&#160;</td>
+          <td class="paramname"><em>xmlbuffer</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int *&#160;</td>
+          <td class="paramname"><em>buflen</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Export the topology into a newly-allocated XML memory buffer. </p>
+<p><code>xmlbuffer</code> is allocated by the callee and should be freed with <a class="el" href="a00195.html#ga293e4a6489f15fd16ad22a5734561cf1" title="Free a buffer allocated by hwloc_topology_export_xmlbuffer()">hwloc_free_xmlbuffer()</a> later in the caller.</p>
+<p>This memory buffer may be loaded later through <a class="el" href="a00181.html#ga2745616b65595e1c1e579ecc7e461fa8" title="Enable XML based topology using a memory buffer (instead of a file, as with hwloc_topology_set_xml())...">hwloc_topology_set_xmlbuffer()</a>.</p>
+<p>By default, the latest export format is used, which means older hwloc releases (e.g. v1.x) will not be able to import it. Exporting to v1.x specific XML format is possible using flag <a class="el" href="a00195.html#gga0eb99636aff71fe2704e1fa0ffe8c18dae7d6d96546131ef0043867b836b02e0f" title="Export XML that is loadable by hwloc v1.x. However, the export may miss some details about the topolo...">HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1</a> but it may miss some details about the topology. If there is any chance that the exported buffer may ever be imported back by a process using hwloc 1.x, one should consider detecting it at runtime and using the corresponding export format.</p>
+<p>The returned buffer ends with a \0 that is included in the returned length.</p>
+<p><code>flags</code> is a OR'ed set of <a class="el" href="a00195.html#ga0eb99636aff71fe2704e1fa0ffe8c18d" title="Flags for exporting XML topologies.">hwloc_topology_export_xml_flags_e</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, or -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>See also <a class="el" href="a00195.html#ga9d6ff0f7a8dd45be9aa8575ef31978cc" title="Set the application-specific callback for exporting object userdata.">hwloc_topology_set_userdata_export_callback()</a> for exporting application-specific object userdata.</dd>
+<dd>
+The topology-specific userdata pointer is ignored when exporting to XML.</dd>
+<dd>
+Only printable characters may be exported to XML string attributes. Any other character, especially any non-ASCII character, will be silently dropped. </dd></dl>
+
+</div>
+</div>
+<a id="ga9d6ff0f7a8dd45be9aa8575ef31978cc" name="ga9d6ff0f7a8dd45be9aa8575ef31978cc"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9d6ff0f7a8dd45be9aa8575ef31978cc">&#9670;&#160;</a></span>hwloc_topology_set_userdata_export_callback()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_topology_set_userdata_export_callback </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">void(*)(void *reserved, <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj)&#160;</td>
+          <td class="paramname"><em>export_cb</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set the application-specific callback for exporting object userdata. </p>
+<p>The object userdata pointer is not exported to XML by default because hwloc does not know what it contains.</p>
+<p>This function lets applications set <code>export_cb</code> to a callback function that converts this opaque userdata into an exportable string.</p>
+<p><code>export_cb</code> is invoked during XML export for each object whose <code>userdata</code> pointer is not <code>NULL</code>. The callback should use <a class="el" href="a00195.html#gaa541bdd628416dbbe97d0df69d3de958" title="Export some object userdata to XML.">hwloc_export_obj_userdata()</a> or <a class="el" href="a00195.html#ga1b7358137cec27bd073f58a606ecbaba" title="Encode and export some object userdata to XML.">hwloc_export_obj_userdata_base64()</a> to actually export something to XML (possibly multiple times per object).</p>
+<p><code>export_cb</code> may be set to <code>NULL</code> if userdata should not be exported to XML.</p>
+<dl class="section note"><dt>Note</dt><dd>The topology-specific userdata pointer is ignored when exporting to XML. </dd></dl>
+
+</div>
+</div>
+<a id="ga5ac6917ea7289955fb1ffda4353af9b0" name="ga5ac6917ea7289955fb1ffda4353af9b0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga5ac6917ea7289955fb1ffda4353af9b0">&#9670;&#160;</a></span>hwloc_topology_set_userdata_import_callback()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_topology_set_userdata_import_callback </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">void(*)(<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj, const char *name, const void *buffer, size_t length)&#160;</td>
+          <td class="paramname"><em>import_cb</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set the application-specific callback for importing userdata. </p>
+<p>On XML import, userdata is ignored by default because hwloc does not know how to store it in memory.</p>
+<p>This function lets applications set <code>import_cb</code> to a callback function that will get the XML-stored userdata and store it in the object as expected by the application.</p>
+<p><code>import_cb</code> is called during <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a> as many times as <a class="el" href="a00195.html#gaa541bdd628416dbbe97d0df69d3de958" title="Export some object userdata to XML.">hwloc_export_obj_userdata()</a> was called during export. The topology is not entirely setup yet. Object attributes are ready to consult, but links between objects are not.</p>
+<p><code>import_cb</code> may be <code>NULL</code> if userdata should be ignored during import.</p>
+<dl class="section note"><dt>Note</dt><dd><code>buffer</code> contains <code>length</code> characters followed by a null byte ('\0').</dd>
+<dd>
+This function should be called before <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>.</dd>
+<dd>
+The topology-specific userdata pointer is ignored when importing from XML. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00196.html 2.11.0-1/doc/doxygen-doc/html/a00196.html
--- 2.10.0-1/doc/doxygen-doc/html/a00196.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00196.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,154 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Exporting Topologies to Synthetic</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Exporting Topologies to Synthetic</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:ga7ac6f97cc40bd50c40285084f869ba63" id="r_ga7ac6f97cc40bd50c40285084f869ba63"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00196.html#ga7ac6f97cc40bd50c40285084f869ba63">hwloc_topology_export_synthetic_flags_e</a> { <a class="el" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a3b3bd4ba2ef9990810865e561034ccc9">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES</a>
+, <a class="el" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63aaa2702ffba050bab079b3041aec737d4">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS</a>
+, <a class="el" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a7896bdf4ccfcdcd09a9f76c0f5e3a5b8">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1</a>
+, <a class="el" href="a00196.html#gga7ac6f97cc40bd50c40285084f869ba63a22c57cf18e1da4a6c584fb783b552f9f">HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY</a>
+ }</td></tr>
+<tr class="separator:ga7ac6f97cc40bd50c40285084f869ba63"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga24b7864a1c588309c4749f621f03b4c7" id="r_ga24b7864a1c588309c4749f621f03b4c7"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00196.html#ga24b7864a1c588309c4749f621f03b4c7">hwloc_topology_export_synthetic</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, char *buffer, size_t buflen, unsigned long flags)</td></tr>
+<tr class="separator:ga24b7864a1c588309c4749f621f03b4c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="ga7ac6f97cc40bd50c40285084f869ba63" name="ga7ac6f97cc40bd50c40285084f869ba63"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga7ac6f97cc40bd50c40285084f869ba63">&#9670;&#160;</a></span>hwloc_topology_export_synthetic_flags_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00196.html#ga7ac6f97cc40bd50c40285084f869ba63">hwloc_topology_export_synthetic_flags_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Flags for exporting synthetic topologies. </p>
+<p>Flags to be given as a OR'ed set to <a class="el" href="a00196.html#ga24b7864a1c588309c4749f621f03b4c7" title="Export the topology as a synthetic string.">hwloc_topology_export_synthetic()</a>. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga7ac6f97cc40bd50c40285084f869ba63a3b3bd4ba2ef9990810865e561034ccc9" name="gga7ac6f97cc40bd50c40285084f869ba63a3b3bd4ba2ef9990810865e561034ccc9"></a>HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES&#160;</td><td class="fielddoc"><p>Export extended types such as L2dcache as basic types such as Cache. </p>
+<p>This is required if loading the synthetic description with hwloc &lt; 1.9. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga7ac6f97cc40bd50c40285084f869ba63aaa2702ffba050bab079b3041aec737d4" name="gga7ac6f97cc40bd50c40285084f869ba63aaa2702ffba050bab079b3041aec737d4"></a>HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS&#160;</td><td class="fielddoc"><p>Do not export level attributes. </p>
+<p>Ignore level attributes such as memory/cache sizes or PU indexes. This is required if loading the synthetic description with hwloc &lt; 1.10. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga7ac6f97cc40bd50c40285084f869ba63a7896bdf4ccfcdcd09a9f76c0f5e3a5b8" name="gga7ac6f97cc40bd50c40285084f869ba63a7896bdf4ccfcdcd09a9f76c0f5e3a5b8"></a>HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1&#160;</td><td class="fielddoc"><p>Export the memory hierarchy as expected in hwloc 1.x. </p>
+<p>Instead of attaching memory children to levels, export single NUMA node child as normal intermediate levels, when possible. This is required if loading the synthetic description with hwloc 1.x. However this may fail if some objects have multiple local NUMA nodes. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga7ac6f97cc40bd50c40285084f869ba63a22c57cf18e1da4a6c584fb783b552f9f" name="gga7ac6f97cc40bd50c40285084f869ba63a22c57cf18e1da4a6c584fb783b552f9f"></a>HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY&#160;</td><td class="fielddoc"><p>Do not export memory information. </p>
+<p>Only export the actual hierarchy of normal CPU-side objects and ignore where memory is attached. This is useful for when the hierarchy of CPUs is what really matters, but it behaves as if there was a single machine-wide NUMA node. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga24b7864a1c588309c4749f621f03b4c7" name="ga24b7864a1c588309c4749f621f03b4c7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga24b7864a1c588309c4749f621f03b4c7">&#9670;&#160;</a></span>hwloc_topology_export_synthetic()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_export_synthetic </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">char *&#160;</td>
+          <td class="paramname"><em>buffer</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>buflen</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Export the topology as a synthetic string. </p>
+<p>At most <code>buflen</code> characters will be written in <code>buffer</code>, including the terminating \0.</p>
+<p>This exported string may be given back to <a class="el" href="a00181.html#ga4fab186bb6181a00bcf585825fddd38d" title="Enable synthetic topology.">hwloc_topology_set_synthetic()</a>.</p>
+<p><code>flags</code> is a OR'ed set of <a class="el" href="a00196.html#ga7ac6f97cc40bd50c40285084f869ba63" title="Flags for exporting synthetic topologies.">hwloc_topology_export_synthetic_flags_e</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>The number of characters that were written, not including the terminating \0.</dd>
+<dd>
+-1 if the topology could not be exported, for instance if it is not symmetric.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>I/O and Misc children are ignored, the synthetic string only describes normal children.</dd>
+<dd>
+A 1024-byte buffer should be large enough for exporting topologies in the vast majority of cases. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00197.html 2.11.0-1/doc/doxygen-doc/html/a00197.html
--- 2.10.0-1/doc/doxygen-doc/html/a00197.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00197.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,499 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Retrieve distances between objects</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Retrieve distances between objects</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00301.html">hwloc_distances_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:gab1bb10d3adb85b52cdc6fe5a7f74f108" id="r_gab1bb10d3adb85b52cdc6fe5a7f74f108"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00197.html#gab1bb10d3adb85b52cdc6fe5a7f74f108">hwloc_distances_kind_e</a> { <br />
+&#160;&#160;<a class="el" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a90dc38248c8d5392d4dd3e88f391e984">HWLOC_DISTANCES_KIND_FROM_OS</a>
+, <a class="el" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a0148d7f9be833a04f5a55455437c227b">HWLOC_DISTANCES_KIND_FROM_USER</a>
+, <a class="el" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108afd6a3503fbc8f7c1a31235373cefc4c6">HWLOC_DISTANCES_KIND_MEANS_LATENCY</a>
+, <a class="el" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a41b19f141a3c0ffe85f9affaca4b0293">HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH</a>
+, <br />
+&#160;&#160;<a class="el" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108aa6cf2b6dfcf148b65952f811814efbe1">HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES</a>
+<br />
+ }</td></tr>
+<tr class="separator:gab1bb10d3adb85b52cdc6fe5a7f74f108"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga42859b651adec5ef0aaacb53ff220b00" id="r_ga42859b651adec5ef0aaacb53ff220b00"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00197.html#ga42859b651adec5ef0aaacb53ff220b00">hwloc_distances_transform_e</a> { <a class="el" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a4b7bdb7e3ccca30e03b7ae671e7f6dc1">HWLOC_DISTANCES_TRANSFORM_REMOVE_NULL</a>
+, <a class="el" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a441e6bb393558319af3bb1f89f51f44d">HWLOC_DISTANCES_TRANSFORM_LINKS</a>
+, <a class="el" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a3d2aaf03e17be54eddbb94aab327fded">HWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS</a>
+, <a class="el" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a1264abf9b9463f252995f37eb1057047">HWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE</a>
+ }</td></tr>
+<tr class="separator:ga42859b651adec5ef0aaacb53ff220b00"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga613e6b2a5d0f06626ee8d0c12fa46691" id="r_ga613e6b2a5d0f06626ee8d0c12fa46691"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691">hwloc_distances_get</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned *nr, struct <a class="el" href="a00301.html">hwloc_distances_s</a> **distances, unsigned long kind, unsigned long flags)</td></tr>
+<tr class="separator:ga613e6b2a5d0f06626ee8d0c12fa46691"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga5d1d35eccfcc2ebcef71a10972ce9b03" id="r_ga5d1d35eccfcc2ebcef71a10972ce9b03"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00197.html#ga5d1d35eccfcc2ebcef71a10972ce9b03">hwloc_distances_get_by_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int depth, unsigned *nr, struct <a class="el" href="a00301.html">hwloc_distances_s</a> **distances, unsigned long kind, unsigned long flags)</td></tr>
+<tr class="separator:ga5d1d35eccfcc2ebcef71a10972ce9b03"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaaa6bfbc20072a4f4de132eec859067f6" id="r_gaaa6bfbc20072a4f4de132eec859067f6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00197.html#gaaa6bfbc20072a4f4de132eec859067f6">hwloc_distances_get_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, unsigned *nr, struct <a class="el" href="a00301.html">hwloc_distances_s</a> **distances, unsigned long kind, unsigned long flags)</td></tr>
+<tr class="separator:gaaa6bfbc20072a4f4de132eec859067f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa457f35b8745ca41ec17797c0d7b20f0" id="r_gaa457f35b8745ca41ec17797c0d7b20f0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00197.html#gaa457f35b8745ca41ec17797c0d7b20f0">hwloc_distances_get_by_name</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const char *name, unsigned *nr, struct <a class="el" href="a00301.html">hwloc_distances_s</a> **distances, unsigned long flags)</td></tr>
+<tr class="separator:gaa457f35b8745ca41ec17797c0d7b20f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaff5366e26178f77d5e8dc3ac8863f2ed" id="r_gaff5366e26178f77d5e8dc3ac8863f2ed"><td class="memItemLeft" align="right" valign="top">const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00197.html#gaff5366e26178f77d5e8dc3ac8863f2ed">hwloc_distances_get_name</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, struct <a class="el" href="a00301.html">hwloc_distances_s</a> *distances)</td></tr>
+<tr class="separator:gaff5366e26178f77d5e8dc3ac8863f2ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1dd78c1f9acd54f26aba0e284e97e51d" id="r_ga1dd78c1f9acd54f26aba0e284e97e51d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00197.html#ga1dd78c1f9acd54f26aba0e284e97e51d">hwloc_distances_release</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, struct <a class="el" href="a00301.html">hwloc_distances_s</a> *distances)</td></tr>
+<tr class="separator:ga1dd78c1f9acd54f26aba0e284e97e51d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gabcadd041f3072999d68f2d94e38670f7" id="r_gabcadd041f3072999d68f2d94e38670f7"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00197.html#gabcadd041f3072999d68f2d94e38670f7">hwloc_distances_transform</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, struct <a class="el" href="a00301.html">hwloc_distances_s</a> *distances, enum <a class="el" href="a00197.html#ga42859b651adec5ef0aaacb53ff220b00">hwloc_distances_transform_e</a> transform, void *transform_attr, unsigned long flags)</td></tr>
+<tr class="separator:gabcadd041f3072999d68f2d94e38670f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="gab1bb10d3adb85b52cdc6fe5a7f74f108" name="gab1bb10d3adb85b52cdc6fe5a7f74f108"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab1bb10d3adb85b52cdc6fe5a7f74f108">&#9670;&#160;</a></span>hwloc_distances_kind_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00197.html#gab1bb10d3adb85b52cdc6fe5a7f74f108">hwloc_distances_kind_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Kinds of distance matrices. </p>
+<p>The <code>kind</code> attribute of struct <a class="el" href="a00301.html" title="Matrix of distances between a set of objects.">hwloc_distances_s</a> is a OR'ed set of kinds.</p>
+<p>Each distance matrix may have only one kind among HWLOC_DISTANCES_KIND_FROM_* specifying where distance information comes from, and one kind among HWLOC_DISTANCES_KIND_MEANS_* specifying whether values are latencies or bandwidths. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ggab1bb10d3adb85b52cdc6fe5a7f74f108a90dc38248c8d5392d4dd3e88f391e984" name="ggab1bb10d3adb85b52cdc6fe5a7f74f108a90dc38248c8d5392d4dd3e88f391e984"></a>HWLOC_DISTANCES_KIND_FROM_OS&#160;</td><td class="fielddoc"><p>These distances were obtained from the operating system or hardware. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab1bb10d3adb85b52cdc6fe5a7f74f108a0148d7f9be833a04f5a55455437c227b" name="ggab1bb10d3adb85b52cdc6fe5a7f74f108a0148d7f9be833a04f5a55455437c227b"></a>HWLOC_DISTANCES_KIND_FROM_USER&#160;</td><td class="fielddoc"><p>These distances were provided by the user. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab1bb10d3adb85b52cdc6fe5a7f74f108afd6a3503fbc8f7c1a31235373cefc4c6" name="ggab1bb10d3adb85b52cdc6fe5a7f74f108afd6a3503fbc8f7c1a31235373cefc4c6"></a>HWLOC_DISTANCES_KIND_MEANS_LATENCY&#160;</td><td class="fielddoc"><p>Distance values are similar to latencies between objects. Values are smaller for closer objects, hence minimal on the diagonal of the matrix (distance between an object and itself). It could also be the number of network hops between objects, etc. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab1bb10d3adb85b52cdc6fe5a7f74f108a41b19f141a3c0ffe85f9affaca4b0293" name="ggab1bb10d3adb85b52cdc6fe5a7f74f108a41b19f141a3c0ffe85f9affaca4b0293"></a>HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH&#160;</td><td class="fielddoc"><p>Distance values are similar to bandwidths between objects. Values are higher for closer objects, hence maximal on the diagonal of the matrix (distance between an object and itself). Such values are currently ignored for distance-based grouping. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab1bb10d3adb85b52cdc6fe5a7f74f108aa6cf2b6dfcf148b65952f811814efbe1" name="ggab1bb10d3adb85b52cdc6fe5a7f74f108aa6cf2b6dfcf148b65952f811814efbe1"></a>HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES&#160;</td><td class="fielddoc"><p>This distances structure covers objects of different types. This may apply to the "NVLinkBandwidth" structure in presence of a NVSwitch or POWER processor NVLink port. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="ga42859b651adec5ef0aaacb53ff220b00" name="ga42859b651adec5ef0aaacb53ff220b00"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga42859b651adec5ef0aaacb53ff220b00">&#9670;&#160;</a></span>hwloc_distances_transform_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00197.html#ga42859b651adec5ef0aaacb53ff220b00">hwloc_distances_transform_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Transformations of distances structures. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga42859b651adec5ef0aaacb53ff220b00a4b7bdb7e3ccca30e03b7ae671e7f6dc1" name="gga42859b651adec5ef0aaacb53ff220b00a4b7bdb7e3ccca30e03b7ae671e7f6dc1"></a>HWLOC_DISTANCES_TRANSFORM_REMOVE_NULL&#160;</td><td class="fielddoc"><p>Remove <code>NULL</code> objects from the distances structure. </p>
+<p>Every object that was replaced with <code>NULL</code> in the <code>objs</code> array is removed and the <code>values</code> array is updated accordingly.</p>
+<p>At least <code>2</code> objects must remain, otherwise <a class="el" href="a00197.html#gabcadd041f3072999d68f2d94e38670f7" title="Apply a transformation to a distances structure.">hwloc_distances_transform()</a> will return <code>-1</code> with <code>errno</code> set to <code>EINVAL</code>.</p>
+<p><code>kind</code> will be updated with or without <a class="el" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108aa6cf2b6dfcf148b65952f811814efbe1" title="This distances structure covers objects of different types. This may apply to the &quot;NVLinkBandwidth&quot; s...">HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES</a> according to the remaining objects. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga42859b651adec5ef0aaacb53ff220b00a441e6bb393558319af3bb1f89f51f44d" name="gga42859b651adec5ef0aaacb53ff220b00a441e6bb393558319af3bb1f89f51f44d"></a>HWLOC_DISTANCES_TRANSFORM_LINKS&#160;</td><td class="fielddoc"><p>Replace bandwidth values with a number of links. </p>
+<p>Usually all values will be either <code>0</code> (no link) or <code>1</code> (one link). However some matrices could get larger values if some pairs of peers are connected by different numbers of links.</p>
+<p>Values on the diagonal are set to <code>0</code>.</p>
+<p>This transformation only applies to bandwidth matrices. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga42859b651adec5ef0aaacb53ff220b00a3d2aaf03e17be54eddbb94aab327fded" name="gga42859b651adec5ef0aaacb53ff220b00a3d2aaf03e17be54eddbb94aab327fded"></a>HWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS&#160;</td><td class="fielddoc"><p>Merge switches with multiple ports into a single object. This currently only applies to NVSwitches where GPUs seem connected to different separate switch ports in the NVLinkBandwidth matrix. This transformation will replace all of them with the same port connected to all GPUs. Other ports are removed by applying <a class="el" href="a00197.html#gga42859b651adec5ef0aaacb53ff220b00a4b7bdb7e3ccca30e03b7ae671e7f6dc1" title="Remove NULL objects from the distances structure.">HWLOC_DISTANCES_TRANSFORM_REMOVE_NULL</a> internally. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga42859b651adec5ef0aaacb53ff220b00a1264abf9b9463f252995f37eb1057047" name="gga42859b651adec5ef0aaacb53ff220b00a1264abf9b9463f252995f37eb1057047"></a>HWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE&#160;</td><td class="fielddoc"><p>Apply a transitive closure to the matrix to connect objects across switches. This currently only applies to GPUs and NVSwitches in the NVLinkBandwidth matrix. All pairs of GPUs will be reported as directly connected. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga613e6b2a5d0f06626ee8d0c12fa46691" name="ga613e6b2a5d0f06626ee8d0c12fa46691"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga613e6b2a5d0f06626ee8d0c12fa46691">&#9670;&#160;</a></span>hwloc_distances_get()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_distances_get </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>nr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00301.html">hwloc_distances_s</a> **&#160;</td>
+          <td class="paramname"><em>distances</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>kind</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Retrieve distance matrices. </p>
+<p>Retrieve distance matrices from the topology into the <code>distances</code> array.</p>
+<p><code>flags</code> is currently unused, should be <code>0</code>.</p>
+<p><code>kind</code> serves as a filter. If <code>0</code>, all distance matrices are returned. If it contains some HWLOC_DISTANCES_KIND_FROM_*, only distance matrices whose kind matches one of these are returned. If it contains some HWLOC_DISTANCES_KIND_MEANS_*, only distance matrices whose kind matches one of these are returned.</p>
+<p>On input, <code>nr</code> points to the number of distance matrices that may be stored in <code>distances</code>. On output, <code>nr</code> points to the number of distance matrices that were actually found, even if some of them couldn't be stored in <code>distances</code>. Distance matrices that couldn't be stored are ignored, but the function still returns success (<code>0</code>). The caller may find out by comparing the value pointed by <code>nr</code> before and after the function call.</p>
+<p>Each distance matrix returned in the <code>distances</code> array should be released by the caller using <a class="el" href="a00197.html#ga1dd78c1f9acd54f26aba0e284e97e51d" title="Release a distance matrix structure previously returned by hwloc_distances_get().">hwloc_distances_release()</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga5d1d35eccfcc2ebcef71a10972ce9b03" name="ga5d1d35eccfcc2ebcef71a10972ce9b03"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga5d1d35eccfcc2ebcef71a10972ce9b03">&#9670;&#160;</a></span>hwloc_distances_get_by_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_distances_get_by_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>depth</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>nr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00301.html">hwloc_distances_s</a> **&#160;</td>
+          <td class="paramname"><em>distances</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>kind</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Retrieve distance matrices for object at a specific depth in the topology. </p>
+<p>Identical to <a class="el" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691" title="Retrieve distance matrices.">hwloc_distances_get()</a> with the additional <code>depth</code> filter.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gaa457f35b8745ca41ec17797c0d7b20f0" name="gaa457f35b8745ca41ec17797c0d7b20f0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa457f35b8745ca41ec17797c0d7b20f0">&#9670;&#160;</a></span>hwloc_distances_get_by_name()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_distances_get_by_name </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>name</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>nr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00301.html">hwloc_distances_s</a> **&#160;</td>
+          <td class="paramname"><em>distances</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Retrieve a distance matrix with the given name. </p>
+<p>Usually only one distances structure may match a given name.</p>
+<p>The name of the most common structure is "NUMALatency". Others include "XGMIBandwidth", "XGMIHops", "XeLinkBandwidth", and "NVLinkBandwidth".</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gaaa6bfbc20072a4f4de132eec859067f6" name="gaaa6bfbc20072a4f4de132eec859067f6"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaaa6bfbc20072a4f4de132eec859067f6">&#9670;&#160;</a></span>hwloc_distances_get_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_distances_get_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>nr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00301.html">hwloc_distances_s</a> **&#160;</td>
+          <td class="paramname"><em>distances</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>kind</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Retrieve distance matrices for object of a specific type. </p>
+<p>Identical to <a class="el" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691" title="Retrieve distance matrices.">hwloc_distances_get()</a> with the additional <code>type</code> filter.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gaff5366e26178f77d5e8dc3ac8863f2ed" name="gaff5366e26178f77d5e8dc3ac8863f2ed"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaff5366e26178f77d5e8dc3ac8863f2ed">&#9670;&#160;</a></span>hwloc_distances_get_name()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">const char * hwloc_distances_get_name </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00301.html">hwloc_distances_s</a> *&#160;</td>
+          <td class="paramname"><em>distances</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get a description of what a distances structure contains. </p>
+<p>For instance "NUMALatency" for hardware-provided NUMA distances (ACPI SLIT), or <code>NULL</code> if unknown.</p>
+<dl class="section return"><dt>Returns</dt><dd>the constant string with the name of the distance structure.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>The returned name should not be freed by the caller, it belongs to the hwloc library. </dd></dl>
+
+</div>
+</div>
+<a id="ga1dd78c1f9acd54f26aba0e284e97e51d" name="ga1dd78c1f9acd54f26aba0e284e97e51d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1dd78c1f9acd54f26aba0e284e97e51d">&#9670;&#160;</a></span>hwloc_distances_release()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_distances_release </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00301.html">hwloc_distances_s</a> *&#160;</td>
+          <td class="paramname"><em>distances</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Release a distance matrix structure previously returned by <a class="el" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691" title="Retrieve distance matrices.">hwloc_distances_get()</a>. </p>
+<dl class="section note"><dt>Note</dt><dd>This function is not required if the structure is removed with <a class="el" href="a00200.html#ga80bbf6f0db9af48c61780dd5152664c2" title="Release and remove the given distance matrice from the topology.">hwloc_distances_release_remove()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="gabcadd041f3072999d68f2d94e38670f7" name="gabcadd041f3072999d68f2d94e38670f7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gabcadd041f3072999d68f2d94e38670f7">&#9670;&#160;</a></span>hwloc_distances_transform()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_distances_transform </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00301.html">hwloc_distances_s</a> *&#160;</td>
+          <td class="paramname"><em>distances</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">enum <a class="el" href="a00197.html#ga42859b651adec5ef0aaacb53ff220b00">hwloc_distances_transform_e</a>&#160;</td>
+          <td class="paramname"><em>transform</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">void *&#160;</td>
+          <td class="paramname"><em>transform_attr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Apply a transformation to a distances structure. </p>
+<p>Modify a distances structure that was previously obtained with <a class="el" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691" title="Retrieve distance matrices.">hwloc_distances_get()</a> or one of its variants.</p>
+<p>This modifies the local copy of the distances structures but does not modify the distances information stored inside the topology (retrieved by another call to <a class="el" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691" title="Retrieve distance matrices.">hwloc_distances_get()</a> or exported to XML). To do so, one should add a new distances structure with same name, kind, objects and values (see <a class="el" href="a00199.html">Add distances between objects</a>) and then remove this old one with <a class="el" href="a00200.html#ga80bbf6f0db9af48c61780dd5152664c2" title="Release and remove the given distance matrice from the topology.">hwloc_distances_release_remove()</a>.</p>
+<p><code>transform</code> must be one of the transformations listed in <a class="el" href="a00197.html#ga42859b651adec5ef0aaacb53ff220b00" title="Transformations of distances structures.">hwloc_distances_transform_e</a>.</p>
+<p>These transformations may modify the contents of the <code>objs</code> or <code>values</code> arrays.</p>
+<p><code>transform_attr</code> must be <code>NULL</code> for now.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error for instance if flags are invalid.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Objects in distances array <code>objs</code> may be directly modified in place without using <a class="el" href="a00197.html#gabcadd041f3072999d68f2d94e38670f7" title="Apply a transformation to a distances structure.">hwloc_distances_transform()</a>. One may use <a class="el" href="a00189.html#gab5df3ad1e8565ea0c2cf06412f6f6233" title="Return an object of a different type with same locality.">hwloc_get_obj_with_same_locality()</a> to easily convert between similar objects of different types. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00198.html 2.11.0-1/doc/doxygen-doc/html/a00198.html
--- 2.10.0-1/doc/doxygen-doc/html/a00198.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00198.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,164 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Helpers for consulting distance matrices</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Helpers for consulting distance matrices</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gab9e770c7d56c5d6040f26bd1dc8854cd" id="r_gab9e770c7d56c5d6040f26bd1dc8854cd"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00198.html#gab9e770c7d56c5d6040f26bd1dc8854cd">hwloc_distances_obj_index</a> (struct <a class="el" href="a00301.html">hwloc_distances_s</a> *distances, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj)</td></tr>
+<tr class="separator:gab9e770c7d56c5d6040f26bd1dc8854cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga3c665b23056e3269f777b21a67148c82" id="r_ga3c665b23056e3269f777b21a67148c82"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00198.html#ga3c665b23056e3269f777b21a67148c82">hwloc_distances_obj_pair_values</a> (struct <a class="el" href="a00301.html">hwloc_distances_s</a> *distances, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj1, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj2, hwloc_uint64_t *value1to2, hwloc_uint64_t *value2to1)</td></tr>
+<tr class="separator:ga3c665b23056e3269f777b21a67148c82"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gab9e770c7d56c5d6040f26bd1dc8854cd" name="gab9e770c7d56c5d6040f26bd1dc8854cd"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab9e770c7d56c5d6040f26bd1dc8854cd">&#9670;&#160;</a></span>hwloc_distances_obj_index()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_distances_obj_index </td>
+          <td>(</td>
+          <td class="paramtype">struct <a class="el" href="a00301.html">hwloc_distances_s</a> *&#160;</td>
+          <td class="paramname"><em>distances</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Find the index of an object in a distances structure. </p>
+<dl class="section return"><dt>Returns</dt><dd>the index of the object in the distances structure if any. </dd>
+<dd>
+-1 if object <code>obj</code> is not involved in structure <code>distances</code>. </dd></dl>
+
+</div>
+</div>
+<a id="ga3c665b23056e3269f777b21a67148c82" name="ga3c665b23056e3269f777b21a67148c82"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga3c665b23056e3269f777b21a67148c82">&#9670;&#160;</a></span>hwloc_distances_obj_pair_values()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_distances_obj_pair_values </td>
+          <td>(</td>
+          <td class="paramtype">struct <a class="el" href="a00301.html">hwloc_distances_s</a> *&#160;</td>
+          <td class="paramname"><em>distances</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj1</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj2</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t *&#160;</td>
+          <td class="paramname"><em>value1to2</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t *&#160;</td>
+          <td class="paramname"><em>value2to1</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Find the values between two objects in a distance matrices. </p>
+<p>The distance from <code>obj1</code> to <code>obj2</code> is stored in the value pointed by <code>value1to2</code> and reciprocally.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 if object <code>obj1</code> or <code>obj2</code> is not involved in structure <code>distances</code>. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00199.html 2.11.0-1/doc/doxygen-doc/html/a00199.html
--- 2.10.0-1/doc/doxygen-doc/html/a00199.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00199.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,287 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Add distances between objects</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#typedef-members">Typedefs</a> &#124;
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Add distances between objects</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="typedef-members" name="typedef-members"></a>
+Typedefs</h2></td></tr>
+<tr class="memitem:ga554a4c1e315265f961830e2b616e4989" id="r_ga554a4c1e315265f961830e2b616e4989"><td class="memItemLeft" align="right" valign="top">typedef void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a></td></tr>
+<tr class="separator:ga554a4c1e315265f961830e2b616e4989"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:ga22428b6bab271411e3834e6b4ca22e37" id="r_ga22428b6bab271411e3834e6b4ca22e37"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00199.html#ga22428b6bab271411e3834e6b4ca22e37">hwloc_distances_add_flag_e</a> { <a class="el" href="a00199.html#gga22428b6bab271411e3834e6b4ca22e37a7f6baba797d70538d03c9d13052c62ab">HWLOC_DISTANCES_ADD_FLAG_GROUP</a>
+, <a class="el" href="a00199.html#gga22428b6bab271411e3834e6b4ca22e37a5233ccf631c3bc53dd5c3e7a5d5c9b77">HWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE</a>
+ }</td></tr>
+<tr class="separator:ga22428b6bab271411e3834e6b4ca22e37"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga823d38fa8d21dc338497fb0f79c96704" id="r_ga823d38fa8d21dc338497fb0f79c96704"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00199.html#ga823d38fa8d21dc338497fb0f79c96704">hwloc_distances_add_create</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const char *name, unsigned long kind, unsigned long flags)</td></tr>
+<tr class="separator:ga823d38fa8d21dc338497fb0f79c96704"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga8c9715481b0bce344c8a33c6e6a56469" id="r_ga8c9715481b0bce344c8a33c6e6a56469"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00199.html#ga8c9715481b0bce344c8a33c6e6a56469">hwloc_distances_add_values</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a> handle, unsigned nbobjs, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *objs, hwloc_uint64_t *values, unsigned long flags)</td></tr>
+<tr class="separator:ga8c9715481b0bce344c8a33c6e6a56469"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1f5a29760ebb8f9af831e645315f553c" id="r_ga1f5a29760ebb8f9af831e645315f553c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00199.html#ga1f5a29760ebb8f9af831e645315f553c">hwloc_distances_add_commit</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a> handle, unsigned long flags)</td></tr>
+<tr class="separator:ga1f5a29760ebb8f9af831e645315f553c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>The usual way to add distances is: </p><div class="fragment"><div class="line"><a class="code hl_typedef" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a> handle;</div>
+<div class="line"><span class="keywordtype">int</span> err = -1;</div>
+<div class="line">handle = <a class="code hl_function" href="a00199.html#ga823d38fa8d21dc338497fb0f79c96704">hwloc_distances_add_create</a>(topology, <span class="stringliteral">&quot;name&quot;</span>, kind, 0);</div>
+<div class="line"><span class="keywordflow">if</span> (handle) {</div>
+<div class="line">  err = <a class="code hl_function" href="a00199.html#ga8c9715481b0bce344c8a33c6e6a56469">hwloc_distances_add_values</a>(topology, handle, nbobjs, objs, values, 0);</div>
+<div class="line">  <span class="keywordflow">if</span> (!err)</div>
+<div class="line">    err = <a class="code hl_function" href="a00199.html#ga1f5a29760ebb8f9af831e645315f553c">hwloc_distances_add_commit</a>(topology, handle, flags);</div>
+<div class="line">}</div>
+<div class="ttc" id="aa00199_html_ga1f5a29760ebb8f9af831e645315f553c"><div class="ttname"><a href="a00199.html#ga1f5a29760ebb8f9af831e645315f553c">hwloc_distances_add_commit</a></div><div class="ttdeci">int hwloc_distances_add_commit(hwloc_topology_t topology, hwloc_distances_add_handle_t handle, unsigned long flags)</div><div class="ttdoc">Commit a new distances structure.</div></div>
+<div class="ttc" id="aa00199_html_ga554a4c1e315265f961830e2b616e4989"><div class="ttname"><a href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a></div><div class="ttdeci">void * hwloc_distances_add_handle_t</div><div class="ttdoc">Handle to a new distances structure during its addition to the topology.</div><div class="ttdef"><b>Definition</b> distances.h:347</div></div>
+<div class="ttc" id="aa00199_html_ga823d38fa8d21dc338497fb0f79c96704"><div class="ttname"><a href="a00199.html#ga823d38fa8d21dc338497fb0f79c96704">hwloc_distances_add_create</a></div><div class="ttdeci">hwloc_distances_add_handle_t hwloc_distances_add_create(hwloc_topology_t topology, const char *name, unsigned long kind, unsigned long flags)</div><div class="ttdoc">Create a new empty distances structure.</div></div>
+<div class="ttc" id="aa00199_html_ga8c9715481b0bce344c8a33c6e6a56469"><div class="ttname"><a href="a00199.html#ga8c9715481b0bce344c8a33c6e6a56469">hwloc_distances_add_values</a></div><div class="ttdeci">int hwloc_distances_add_values(hwloc_topology_t topology, hwloc_distances_add_handle_t handle, unsigned nbobjs, hwloc_obj_t *objs, hwloc_uint64_t *values, unsigned long flags)</div><div class="ttdoc">Specify the objects and values in a new empty distances structure.</div></div>
+</div><!-- fragment --><p> If <code>err</code> is <code>0</code> at the end, then addition was successful. </p>
+<h2 class="groupheader">Typedef Documentation</h2>
+<a id="ga554a4c1e315265f961830e2b616e4989" name="ga554a4c1e315265f961830e2b616e4989"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga554a4c1e315265f961830e2b616e4989">&#9670;&#160;</a></span>hwloc_distances_add_handle_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef void* <a class="el" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Handle to a new distances structure during its addition to the topology. </p>
+
+</div>
+</div>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="ga22428b6bab271411e3834e6b4ca22e37" name="ga22428b6bab271411e3834e6b4ca22e37"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga22428b6bab271411e3834e6b4ca22e37">&#9670;&#160;</a></span>hwloc_distances_add_flag_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00199.html#ga22428b6bab271411e3834e6b4ca22e37">hwloc_distances_add_flag_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Flags for adding a new distances to a topology. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga22428b6bab271411e3834e6b4ca22e37a7f6baba797d70538d03c9d13052c62ab" name="gga22428b6bab271411e3834e6b4ca22e37a7f6baba797d70538d03c9d13052c62ab"></a>HWLOC_DISTANCES_ADD_FLAG_GROUP&#160;</td><td class="fielddoc"><p>Try to group objects based on the newly provided distance information. Grouping is only performed when the distances structure contains latencies, and when all objects are of the same type. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga22428b6bab271411e3834e6b4ca22e37a5233ccf631c3bc53dd5c3e7a5d5c9b77" name="gga22428b6bab271411e3834e6b4ca22e37a5233ccf631c3bc53dd5c3e7a5d5c9b77"></a>HWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE&#160;</td><td class="fielddoc"><p>If grouping, consider the distance values as inaccurate and relax the comparisons during the grouping algorithms. The actual accuracy may be modified through the HWLOC_GROUPING_ACCURACY environment variable (see <a class="el" href="a00378.html">Environment Variables</a>). </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga1f5a29760ebb8f9af831e645315f553c" name="ga1f5a29760ebb8f9af831e645315f553c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1f5a29760ebb8f9af831e645315f553c">&#9670;&#160;</a></span>hwloc_distances_add_commit()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_distances_add_commit </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a>&#160;</td>
+          <td class="paramname"><em>handle</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Commit a new distances structure. </p>
+<p>This function finalizes the distances structure and inserts in it the topology.</p>
+<p>Parameter <code>handle</code> was previously returned by <a class="el" href="a00199.html#ga823d38fa8d21dc338497fb0f79c96704" title="Create a new empty distances structure.">hwloc_distances_add_create()</a>. Then objects and values were specified with <a class="el" href="a00199.html#ga8c9715481b0bce344c8a33c6e6a56469" title="Specify the objects and values in a new empty distances structure.">hwloc_distances_add_values()</a>.</p>
+<p><code>flags</code> configures the behavior of the function using an optional OR'ed set of <a class="el" href="a00199.html#ga22428b6bab271411e3834e6b4ca22e37" title="Flags for adding a new distances to a topology.">hwloc_distances_add_flag_e</a>. It may be used to request the grouping of existing objects based on distances.</p>
+<p>On error, the temporary distances structure and its content are destroyed.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga823d38fa8d21dc338497fb0f79c96704" name="ga823d38fa8d21dc338497fb0f79c96704"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga823d38fa8d21dc338497fb0f79c96704">&#9670;&#160;</a></span>hwloc_distances_add_create()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a> hwloc_distances_add_create </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>name</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>kind</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Create a new empty distances structure. </p>
+<p>Create an empty distances structure to be filled with <a class="el" href="a00199.html#ga8c9715481b0bce344c8a33c6e6a56469" title="Specify the objects and values in a new empty distances structure.">hwloc_distances_add_values()</a> and then committed with <a class="el" href="a00199.html#ga1f5a29760ebb8f9af831e645315f553c" title="Commit a new distances structure.">hwloc_distances_add_commit()</a>.</p>
+<p>Parameter <code>name</code> is optional, it may be <code>NULL</code>. Otherwise, it will be copied internally and may later be freed by the caller.</p>
+<p><code>kind</code> specifies the kind of distance as a OR'ed set of <a class="el" href="a00197.html#gab1bb10d3adb85b52cdc6fe5a7f74f108" title="Kinds of distance matrices.">hwloc_distances_kind_e</a>. Only one kind of meaning and one kind of provenance may be given if appropriate (e.g. <a class="el" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a41b19f141a3c0ffe85f9affaca4b0293" title="Distance values are similar to bandwidths between objects. Values are higher for closer objects,...">HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH</a> and <a class="el" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a0148d7f9be833a04f5a55455437c227b" title="These distances were provided by the user.">HWLOC_DISTANCES_KIND_FROM_USER</a>). Kind <a class="el" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108aa6cf2b6dfcf148b65952f811814efbe1" title="This distances structure covers objects of different types. This may apply to the &quot;NVLinkBandwidth&quot; s...">HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES</a> will be automatically set according to objects having different types in <a class="el" href="a00199.html#ga8c9715481b0bce344c8a33c6e6a56469" title="Specify the objects and values in a new empty distances structure.">hwloc_distances_add_values()</a>.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section return"><dt>Returns</dt><dd>A hwloc_distances_add_handle_t that should then be passed to <a class="el" href="a00199.html#ga8c9715481b0bce344c8a33c6e6a56469" title="Specify the objects and values in a new empty distances structure.">hwloc_distances_add_values()</a> and <a class="el" href="a00199.html#ga1f5a29760ebb8f9af831e645315f553c" title="Commit a new distances structure.">hwloc_distances_add_commit()</a>.</dd>
+<dd>
+<code>NULL</code> on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga8c9715481b0bce344c8a33c6e6a56469" name="ga8c9715481b0bce344c8a33c6e6a56469"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8c9715481b0bce344c8a33c6e6a56469">&#9670;&#160;</a></span>hwloc_distances_add_values()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_distances_add_values </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00199.html#ga554a4c1e315265f961830e2b616e4989">hwloc_distances_add_handle_t</a>&#160;</td>
+          <td class="paramname"><em>handle</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>nbobjs</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *&#160;</td>
+          <td class="paramname"><em>objs</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t *&#160;</td>
+          <td class="paramname"><em>values</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Specify the objects and values in a new empty distances structure. </p>
+<p>Specify the objects and values for a new distances structure that was returned as a handle by <a class="el" href="a00199.html#ga823d38fa8d21dc338497fb0f79c96704" title="Create a new empty distances structure.">hwloc_distances_add_create()</a>. The structure must then be committed with <a class="el" href="a00199.html#ga1f5a29760ebb8f9af831e645315f553c" title="Commit a new distances structure.">hwloc_distances_add_commit()</a>.</p>
+<p>The number of objects is <code>nbobjs</code> and the array of objects is <code>objs</code>. Distance values are stored as a one-dimension array in <code>values</code>. The distance from object i to object j is in slot i*nbobjs+j.</p>
+<p><code>nbobjs</code> must be at least 2.</p>
+<p>Arrays <code>objs</code> and <code>values</code> will be copied internally, they may later be freed by the caller.</p>
+<p>On error, the temporary distances structure and its content are destroyed.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00200.html 2.11.0-1/doc/doxygen-doc/html/a00200.html
--- 2.10.0-1/doc/doxygen-doc/html/a00200.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00200.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,194 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Remove distances between objects</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Remove distances between objects</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gac188d9b64d9560255ce5f6d0a20f9c0a" id="r_gac188d9b64d9560255ce5f6d0a20f9c0a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00200.html#gac188d9b64d9560255ce5f6d0a20f9c0a">hwloc_distances_remove</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology)</td></tr>
+<tr class="separator:gac188d9b64d9560255ce5f6d0a20f9c0a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa642a4c1a21c84f38ae23fca8a27845d" id="r_gaa642a4c1a21c84f38ae23fca8a27845d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00200.html#gaa642a4c1a21c84f38ae23fca8a27845d">hwloc_distances_remove_by_depth</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int depth)</td></tr>
+<tr class="separator:gaa642a4c1a21c84f38ae23fca8a27845d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga93db53773c96f5b83815e8441e2ebb93" id="r_ga93db53773c96f5b83815e8441e2ebb93"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00200.html#ga93db53773c96f5b83815e8441e2ebb93">hwloc_distances_remove_by_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga93db53773c96f5b83815e8441e2ebb93"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga80bbf6f0db9af48c61780dd5152664c2" id="r_ga80bbf6f0db9af48c61780dd5152664c2"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00200.html#ga80bbf6f0db9af48c61780dd5152664c2">hwloc_distances_release_remove</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, struct <a class="el" href="a00301.html">hwloc_distances_s</a> *distances)</td></tr>
+<tr class="separator:ga80bbf6f0db9af48c61780dd5152664c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga80bbf6f0db9af48c61780dd5152664c2" name="ga80bbf6f0db9af48c61780dd5152664c2"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga80bbf6f0db9af48c61780dd5152664c2">&#9670;&#160;</a></span>hwloc_distances_release_remove()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_distances_release_remove </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00301.html">hwloc_distances_s</a> *&#160;</td>
+          <td class="paramname"><em>distances</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Release and remove the given distance matrice from the topology. </p>
+<p>This function includes a call to <a class="el" href="a00197.html#ga1dd78c1f9acd54f26aba0e284e97e51d" title="Release a distance matrix structure previously returned by hwloc_distances_get().">hwloc_distances_release()</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gac188d9b64d9560255ce5f6d0a20f9c0a" name="gac188d9b64d9560255ce5f6d0a20f9c0a"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac188d9b64d9560255ce5f6d0a20f9c0a">&#9670;&#160;</a></span>hwloc_distances_remove()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_distances_remove </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Remove all distance matrices from a topology. </p>
+<p>Remove all distance matrices, either provided by the user or gathered through the OS.</p>
+<p>If these distances were used to group objects, these additional Group objects are not removed from the topology.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gaa642a4c1a21c84f38ae23fca8a27845d" name="gaa642a4c1a21c84f38ae23fca8a27845d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa642a4c1a21c84f38ae23fca8a27845d">&#9670;&#160;</a></span>hwloc_distances_remove_by_depth()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_distances_remove_by_depth </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>depth</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Remove distance matrices for objects at a specific depth in the topology. </p>
+<p>Identical to <a class="el" href="a00200.html#gac188d9b64d9560255ce5f6d0a20f9c0a" title="Remove all distance matrices from a topology.">hwloc_distances_remove()</a> but only applies to one level of the topology.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="ga93db53773c96f5b83815e8441e2ebb93" name="ga93db53773c96f5b83815e8441e2ebb93"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga93db53773c96f5b83815e8441e2ebb93">&#9670;&#160;</a></span>hwloc_distances_remove_by_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_distances_remove_by_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Remove distance matrices for objects of a specific type in the topology. </p>
+<p>Identical to <a class="el" href="a00200.html#gac188d9b64d9560255ce5f6d0a20f9c0a" title="Remove all distance matrices from a topology.">hwloc_distances_remove()</a> but only applies to one level of the topology.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00201.html 2.11.0-1/doc/doxygen-doc/html/a00201.html
--- 2.10.0-1/doc/doxygen-doc/html/a00201.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00201.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,518 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Comparing memory node attributes for finding where to allocate on</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#typedef-members">Typedefs</a> &#124;
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Comparing memory node attributes for finding where to allocate on</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00305.html">hwloc_location</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="typedef-members" name="typedef-members"></a>
+Typedefs</h2></td></tr>
+<tr class="memitem:gacc82003a8610be554615995f0996c888" id="r_gacc82003a8610be554615995f0996c888"><td class="memItemLeft" align="right" valign="top">typedef unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a></td></tr>
+<tr class="separator:gacc82003a8610be554615995f0996c888"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:gab4bde745db676fc2ea4b47011cd9a80e" id="r_gab4bde745db676fc2ea4b47011cd9a80e"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00201.html#gab4bde745db676fc2ea4b47011cd9a80e">hwloc_memattr_id_e</a> { <br />
+&#160;&#160;<a class="el" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eaa1cfa3ff3d56ff00ecabf7da4f5642cc">HWLOC_MEMATTR_ID_CAPACITY</a>
+, <a class="el" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea9334e3a4c30a67f491c6523255134efe">HWLOC_MEMATTR_ID_LOCALITY</a>
+, <a class="el" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea25fe3c7376ae6f9b584bacdb039f8c0f">HWLOC_MEMATTR_ID_BANDWIDTH</a>
+, <a class="el" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eac34dce925d3dadb7e255391d142b4828">HWLOC_MEMATTR_ID_READ_BANDWIDTH</a>
+, <br />
+&#160;&#160;<a class="el" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea44762e8ebe327cfe665cccf1f58f7530">HWLOC_MEMATTR_ID_WRITE_BANDWIDTH</a>
+, <a class="el" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ead1796413759b8b87b61ad195a9349b19">HWLOC_MEMATTR_ID_LATENCY</a>
+, <a class="el" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80ea52cab56571c7fafea42a694d80ad3dd0">HWLOC_MEMATTR_ID_READ_LATENCY</a>
+, <a class="el" href="a00201.html#ggab4bde745db676fc2ea4b47011cd9a80eaaf6cd383da87dc9f5e3a608a535a768e">HWLOC_MEMATTR_ID_WRITE_LATENCY</a>
+, <br />
+&#160;&#160;<b>HWLOC_MEMATTR_ID_MAX</b>
+<br />
+ }</td></tr>
+<tr class="separator:gab4bde745db676fc2ea4b47011cd9a80e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga33099ba58f607fc70925da3777688586" id="r_ga33099ba58f607fc70925da3777688586"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00201.html#ga33099ba58f607fc70925da3777688586">hwloc_location_type_e</a> { <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174">HWLOC_LOCATION_TYPE_CPUSET</a>
+, <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84">HWLOC_LOCATION_TYPE_OBJECT</a>
+ }</td></tr>
+<tr class="separator:ga33099ba58f607fc70925da3777688586"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gab9c963ca37255da71b00d94e1b106f9d" id="r_gab9c963ca37255da71b00d94e1b106f9d"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00201.html#gab9c963ca37255da71b00d94e1b106f9d">hwloc_local_numanode_flag_e</a> { <a class="el" href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9da200c6c133bb2125ba36d77ce9ca268cc">HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY</a>
+, <a class="el" href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9daac9c5e3a2cfb1b193e4acfceaf3bad57">HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY</a>
+, <a class="el" href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9dab5778b34c961a5d56f98f1549edeaed0">HWLOC_LOCAL_NUMANODE_FLAG_ALL</a>
+ }</td></tr>
+<tr class="separator:gab9c963ca37255da71b00d94e1b106f9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga79f44f8e1cfd2f97a19171417a75a137" id="r_ga79f44f8e1cfd2f97a19171417a75a137"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00201.html#ga79f44f8e1cfd2f97a19171417a75a137">hwloc_memattr_get_by_name</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const char *name, <a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> *id)</td></tr>
+<tr class="separator:ga79f44f8e1cfd2f97a19171417a75a137"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga569e80c5be7ef27649b0ef5aa52ffcdc" id="r_ga569e80c5be7ef27649b0ef5aa52ffcdc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00201.html#ga569e80c5be7ef27649b0ef5aa52ffcdc">hwloc_get_local_numanode_objs</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, struct <a class="el" href="a00305.html">hwloc_location</a> *location, unsigned *nr, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *nodes, unsigned long flags)</td></tr>
+<tr class="separator:ga569e80c5be7ef27649b0ef5aa52ffcdc"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga297e4a9adc2272446a4c7449dacef0df" id="r_ga297e4a9adc2272446a4c7449dacef0df"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00201.html#ga297e4a9adc2272446a4c7449dacef0df">hwloc_memattr_get_value</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> target_node, struct <a class="el" href="a00305.html">hwloc_location</a> *initiator, unsigned long flags, hwloc_uint64_t *value)</td></tr>
+<tr class="separator:ga297e4a9adc2272446a4c7449dacef0df"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga884d1f2ad745c2fa69c1583c82d28f10" id="r_ga884d1f2ad745c2fa69c1583c82d28f10"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00201.html#ga884d1f2ad745c2fa69c1583c82d28f10">hwloc_memattr_get_best_target</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute, struct <a class="el" href="a00305.html">hwloc_location</a> *initiator, unsigned long flags, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *best_target, hwloc_uint64_t *value)</td></tr>
+<tr class="separator:ga884d1f2ad745c2fa69c1583c82d28f10"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga9a453879892893cf8a3fcd431ade84cd" id="r_ga9a453879892893cf8a3fcd431ade84cd"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00201.html#ga9a453879892893cf8a3fcd431ade84cd">hwloc_memattr_get_best_initiator</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> target, unsigned long flags, struct <a class="el" href="a00305.html">hwloc_location</a> *best_initiator, hwloc_uint64_t *value)</td></tr>
+<tr class="separator:ga9a453879892893cf8a3fcd431ade84cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>Platforms with heterogeneous memory require ways to decide whether a buffer should be allocated on "fast" memory (such as HBM), "normal" memory (DDR) or even "slow" but large-capacity memory (non-volatile memory). These memory nodes are called "Targets" while the CPU accessing them is called the "Initiator". Access performance depends on their locality (NUMA platforms) as well as the intrinsic performance of the targets (heterogeneous platforms).</p>
+<p>The following attributes describe the performance of memory accesses from an Initiator to a memory Target, for instance their latency or bandwidth. Initiators performing these memory accesses are usually some PUs or Cores (described as a CPU set). Hence a Core may choose where to allocate a memory buffer by comparing the attributes of different target memory nodes nearby.</p>
+<p>There are also some attributes that are system-wide. Their value does not depend on a specific initiator performing an access. The memory node Capacity is an example of such attribute without initiator.</p>
+<p>One way to use this API is to start with a cpuset describing the Cores where a program is bound. The best target NUMA node for allocating memory in this program on these Cores may be obtained by passing this cpuset as an initiator to <a class="el" href="a00201.html#ga884d1f2ad745c2fa69c1583c82d28f10" title="Return the best target NUMA node for the given attribute and initiator.">hwloc_memattr_get_best_target()</a> with the relevant memory attribute. For instance, if the code is latency limited, use the Latency attribute.</p>
+<p>A more flexible approach consists in getting the list of local NUMA nodes by passing this cpuset to <a class="el" href="a00201.html#ga569e80c5be7ef27649b0ef5aa52ffcdc" title="Return an array of local NUMA nodes.">hwloc_get_local_numanode_objs()</a>. Attribute values for these nodes, if any, may then be obtained with <a class="el" href="a00201.html#ga297e4a9adc2272446a4c7449dacef0df" title="Return an attribute value for a specific target NUMA node.">hwloc_memattr_get_value()</a> and manually compared with the desired criteria.</p>
+<p>Memory attributes are also used internally to build Memory Tiers which provide an easy way to distinguish NUMA nodes of different kinds, as explained in <a class="el" href="a00384.html">Heterogeneous Memory</a>.</p>
+<dl class="section see"><dt>See also</dt><dd>An example is available in doc/examples/memory-attributes.c in the source tree.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>The API also supports specific objects as initiator, but it is currently not used internally by hwloc. Users may for instance use it to provide custom performance values for host memory accesses performed by GPUs.</dd>
+<dd>
+The interface actually also accepts targets that are not NUMA nodes. </dd></dl>
+<h2 class="groupheader">Typedef Documentation</h2>
+<a id="gacc82003a8610be554615995f0996c888" name="gacc82003a8610be554615995f0996c888"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gacc82003a8610be554615995f0996c888">&#9670;&#160;</a></span>hwloc_memattr_id_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef unsigned <a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>A memory attribute identifier. May be either one of <a class="el" href="a00201.html#gab4bde745db676fc2ea4b47011cd9a80e" title="Memory node attributes.">hwloc_memattr_id_e</a> or a new id returned by <a class="el" href="a00202.html#ga770657d1e44b09e93e09f623936c1e5f" title="Register a new memory attribute.">hwloc_memattr_register()</a>. </p>
+
+</div>
+</div>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="gab9c963ca37255da71b00d94e1b106f9d" name="gab9c963ca37255da71b00d94e1b106f9d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab9c963ca37255da71b00d94e1b106f9d">&#9670;&#160;</a></span>hwloc_local_numanode_flag_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00201.html#gab9c963ca37255da71b00d94e1b106f9d">hwloc_local_numanode_flag_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Flags for selecting target NUMA nodes. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ggab9c963ca37255da71b00d94e1b106f9da200c6c133bb2125ba36d77ce9ca268cc" name="ggab9c963ca37255da71b00d94e1b106f9da200c6c133bb2125ba36d77ce9ca268cc"></a>HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY&#160;</td><td class="fielddoc"><p>Select NUMA nodes whose locality is larger than the given cpuset. For instance, if a single PU (or its cpuset) is given in <code>initiator</code>, select all nodes close to the package that contains this PU. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab9c963ca37255da71b00d94e1b106f9daac9c5e3a2cfb1b193e4acfceaf3bad57" name="ggab9c963ca37255da71b00d94e1b106f9daac9c5e3a2cfb1b193e4acfceaf3bad57"></a>HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY&#160;</td><td class="fielddoc"><p>Select NUMA nodes whose locality is smaller than the given cpuset. For instance, if a package (or its cpuset) is given in <code>initiator</code>, also select nodes that are attached to only a half of that package. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab9c963ca37255da71b00d94e1b106f9dab5778b34c961a5d56f98f1549edeaed0" name="ggab9c963ca37255da71b00d94e1b106f9dab5778b34c961a5d56f98f1549edeaed0"></a>HWLOC_LOCAL_NUMANODE_FLAG_ALL&#160;</td><td class="fielddoc"><p>Select all NUMA nodes in the topology. The initiator <code>initiator</code> is ignored. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="ga33099ba58f607fc70925da3777688586" name="ga33099ba58f607fc70925da3777688586"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga33099ba58f607fc70925da3777688586">&#9670;&#160;</a></span>hwloc_location_type_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00201.html#ga33099ba58f607fc70925da3777688586">hwloc_location_type_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of location. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174" name="gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174"></a>HWLOC_LOCATION_TYPE_CPUSET&#160;</td><td class="fielddoc"><p>Location is given as a cpuset, in the location cpuset union field. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84" name="gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84"></a>HWLOC_LOCATION_TYPE_OBJECT&#160;</td><td class="fielddoc"><p>Location is given as an object, in the location object union field. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="gab4bde745db676fc2ea4b47011cd9a80e" name="gab4bde745db676fc2ea4b47011cd9a80e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab4bde745db676fc2ea4b47011cd9a80e">&#9670;&#160;</a></span>hwloc_memattr_id_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00201.html#gab4bde745db676fc2ea4b47011cd9a80e">hwloc_memattr_id_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Memory node attributes. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ggab4bde745db676fc2ea4b47011cd9a80eaa1cfa3ff3d56ff00ecabf7da4f5642cc" name="ggab4bde745db676fc2ea4b47011cd9a80eaa1cfa3ff3d56ff00ecabf7da4f5642cc"></a>HWLOC_MEMATTR_ID_CAPACITY&#160;</td><td class="fielddoc"><p>The "Capacity" is returned in bytes (local_memory attribute in objects). </p>
+<p>Best capacity nodes are nodes with <b>higher capacity</b>.</p>
+<p>No initiator is involved when looking at this attribute. The corresponding attribute flags are <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815" title="The best nodes for this memory attribute are those with the higher values. For instance Bandwidth.">HWLOC_MEMATTR_FLAG_HIGHER_FIRST</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab4bde745db676fc2ea4b47011cd9a80ea9334e3a4c30a67f491c6523255134efe" name="ggab4bde745db676fc2ea4b47011cd9a80ea9334e3a4c30a67f491c6523255134efe"></a>HWLOC_MEMATTR_ID_LOCALITY&#160;</td><td class="fielddoc"><p>The "Locality" is returned as the number of PUs in that locality (e.g. the weight of its cpuset). </p>
+<p>Best locality nodes are nodes with <b>smaller locality</b> (nodes that are local to very few PUs). Poor locality nodes are nodes with larger locality (nodes that are local to the entire machine).</p>
+<p>No initiator is involved when looking at this attribute. The corresponding attribute flags are <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815" title="The best nodes for this memory attribute are those with the higher values. For instance Bandwidth.">HWLOC_MEMATTR_FLAG_HIGHER_FIRST</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab4bde745db676fc2ea4b47011cd9a80ea25fe3c7376ae6f9b584bacdb039f8c0f" name="ggab4bde745db676fc2ea4b47011cd9a80ea25fe3c7376ae6f9b584bacdb039f8c0f"></a>HWLOC_MEMATTR_ID_BANDWIDTH&#160;</td><td class="fielddoc"><p>The "Bandwidth" is returned in MiB/s, as seen from the given initiator location. </p>
+<p>Best bandwidth nodes are nodes with <b>higher bandwidth</b>.</p>
+<p>The corresponding attribute flags are <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815" title="The best nodes for this memory attribute are those with the higher values. For instance Bandwidth.">HWLOC_MEMATTR_FLAG_HIGHER_FIRST</a> and <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>.</p>
+<p>This is the average bandwidth for read and write accesses. If the platform provides individual read and write bandwidths but no explicit average value, hwloc computes and returns the average. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab4bde745db676fc2ea4b47011cd9a80eac34dce925d3dadb7e255391d142b4828" name="ggab4bde745db676fc2ea4b47011cd9a80eac34dce925d3dadb7e255391d142b4828"></a>HWLOC_MEMATTR_ID_READ_BANDWIDTH&#160;</td><td class="fielddoc"><p>The "ReadBandwidth" is returned in MiB/s, as seen from the given initiator location. </p>
+<p>Best bandwidth nodes are nodes with <b>higher bandwidth</b>.</p>
+<p>The corresponding attribute flags are <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815" title="The best nodes for this memory attribute are those with the higher values. For instance Bandwidth.">HWLOC_MEMATTR_FLAG_HIGHER_FIRST</a> and <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab4bde745db676fc2ea4b47011cd9a80ea44762e8ebe327cfe665cccf1f58f7530" name="ggab4bde745db676fc2ea4b47011cd9a80ea44762e8ebe327cfe665cccf1f58f7530"></a>HWLOC_MEMATTR_ID_WRITE_BANDWIDTH&#160;</td><td class="fielddoc"><p>The "WriteBandwidth" is returned in MiB/s, as seen from the given initiator location. </p>
+<p>Best bandwidth nodes are nodes with <b>higher bandwidth</b>.</p>
+<p>The corresponding attribute flags are <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815" title="The best nodes for this memory attribute are those with the higher values. For instance Bandwidth.">HWLOC_MEMATTR_FLAG_HIGHER_FIRST</a> and <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab4bde745db676fc2ea4b47011cd9a80ead1796413759b8b87b61ad195a9349b19" name="ggab4bde745db676fc2ea4b47011cd9a80ead1796413759b8b87b61ad195a9349b19"></a>HWLOC_MEMATTR_ID_LATENCY&#160;</td><td class="fielddoc"><p>The "Latency" is returned as nanoseconds, as seen from the given initiator location. </p>
+<p>Best latency nodes are nodes with <b>smaller latency</b>.</p>
+<p>The corresponding attribute flags are <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf" title="The best nodes for this memory attribute are those with the lower values. For instance Latency.">HWLOC_MEMATTR_FLAG_LOWER_FIRST</a> and <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>.</p>
+<p>This is the average latency for read and write accesses. If the platform provides individual read and write latencies but no explicit average value, hwloc computes and returns the average. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab4bde745db676fc2ea4b47011cd9a80ea52cab56571c7fafea42a694d80ad3dd0" name="ggab4bde745db676fc2ea4b47011cd9a80ea52cab56571c7fafea42a694d80ad3dd0"></a>HWLOC_MEMATTR_ID_READ_LATENCY&#160;</td><td class="fielddoc"><p>The "ReadLatency" is returned as nanoseconds, as seen from the given initiator location. </p>
+<p>Best latency nodes are nodes with <b>smaller latency</b>.</p>
+<p>The corresponding attribute flags are <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf" title="The best nodes for this memory attribute are those with the lower values. For instance Latency.">HWLOC_MEMATTR_FLAG_LOWER_FIRST</a> and <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="ggab4bde745db676fc2ea4b47011cd9a80eaaf6cd383da87dc9f5e3a608a535a768e" name="ggab4bde745db676fc2ea4b47011cd9a80eaaf6cd383da87dc9f5e3a608a535a768e"></a>HWLOC_MEMATTR_ID_WRITE_LATENCY&#160;</td><td class="fielddoc"><p>The "WriteLatency" is returned as nanoseconds, as seen from the given initiator location. </p>
+<p>Best latency nodes are nodes with <b>smaller latency</b>.</p>
+<p>The corresponding attribute flags are <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf" title="The best nodes for this memory attribute are those with the lower values. For instance Latency.">HWLOC_MEMATTR_FLAG_LOWER_FIRST</a> and <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga569e80c5be7ef27649b0ef5aa52ffcdc" name="ga569e80c5be7ef27649b0ef5aa52ffcdc"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga569e80c5be7ef27649b0ef5aa52ffcdc">&#9670;&#160;</a></span>hwloc_get_local_numanode_objs()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_get_local_numanode_objs </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00305.html">hwloc_location</a> *&#160;</td>
+          <td class="paramname"><em>location</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>nr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *&#160;</td>
+          <td class="paramname"><em>nodes</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return an array of local NUMA nodes. </p>
+<p>By default only select the NUMA nodes whose locality is exactly the given <code>location</code>. More nodes may be selected if additional flags are given as a OR'ed set of <a class="el" href="a00201.html#gab9c963ca37255da71b00d94e1b106f9d" title="Flags for selecting target NUMA nodes.">hwloc_local_numanode_flag_e</a>.</p>
+<p>If <code>location</code> is given as an explicit object, its CPU set is used to find NUMA nodes with the corresponding locality. If the object does not have a CPU set (e.g. I/O object), the CPU parent (where the I/O object is attached) is used.</p>
+<p>On input, <code>nr</code> points to the number of nodes that may be stored in the <code>nodes</code> array. On output, <code>nr</code> will be changed to the number of stored nodes, or the number of nodes that would have been stored if there were enough room.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success or -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Some of these NUMA nodes may not have any memory attribute values and hence not be reported as actual targets in other functions.</dd>
+<dd>
+The number of NUMA nodes in the topology (obtained by <a class="el" href="a00194.html#ga0200466842c0e1f5da75e84dde460b10" title="Compute the &quot;weight&quot; of bitmap bitmap (i.e., number of indexes that are in the bitmap).">hwloc_bitmap_weight()</a> on the root object nodeset) may be used to allocate the <code>nodes</code> array.</dd>
+<dd>
+When an object CPU set is given as locality, for instance a Package, and when flags contain both <a class="el" href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9da200c6c133bb2125ba36d77ce9ca268cc" title="Select NUMA nodes whose locality is larger than the given cpuset. For instance, if a single PU (or it...">HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY</a> and <a class="el" href="a00201.html#ggab9c963ca37255da71b00d94e1b106f9daac9c5e3a2cfb1b193e4acfceaf3bad57" title="Select NUMA nodes whose locality is smaller than the given cpuset. For instance, if a package (or its...">HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY</a>, the returned array corresponds to the nodeset of that object. </dd></dl>
+
+</div>
+</div>
+<a id="ga9a453879892893cf8a3fcd431ade84cd" name="ga9a453879892893cf8a3fcd431ade84cd"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga9a453879892893cf8a3fcd431ade84cd">&#9670;&#160;</a></span>hwloc_memattr_get_best_initiator()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_memattr_get_best_initiator </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a>&#160;</td>
+          <td class="paramname"><em>attribute</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>target</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00305.html">hwloc_location</a> *&#160;</td>
+          <td class="paramname"><em>best_initiator</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t *&#160;</td>
+          <td class="paramname"><em>value</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return the best initiator for the given attribute and target NUMA node. </p>
+<p>If <code>value</code> is non <code>NULL</code>, the corresponding value is returned there.</p>
+<p>If multiple initiators have the same attribute values, only one is returned (and there is no way to clarify how that one is chosen). Applications that want to detect initiators with identical/similar values, or that want to look at values for multiple attributes, should rather get all values using <a class="el" href="a00201.html#ga297e4a9adc2272446a4c7449dacef0df" title="Return an attribute value for a specific target NUMA node.">hwloc_memattr_get_value()</a> and manually select the initiator they consider the best.</p>
+<p>The returned initiator should not be modified or freed, it belongs to the topology.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOENT</code> if there are no matching initiators. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if the attribute does not relate to a specific initiator (it does not have the flag <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>). </dd></dl>
+
+</div>
+</div>
+<a id="ga884d1f2ad745c2fa69c1583c82d28f10" name="ga884d1f2ad745c2fa69c1583c82d28f10"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga884d1f2ad745c2fa69c1583c82d28f10">&#9670;&#160;</a></span>hwloc_memattr_get_best_target()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_memattr_get_best_target </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a>&#160;</td>
+          <td class="paramname"><em>attribute</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00305.html">hwloc_location</a> *&#160;</td>
+          <td class="paramname"><em>initiator</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *&#160;</td>
+          <td class="paramname"><em>best_target</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t *&#160;</td>
+          <td class="paramname"><em>value</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return the best target NUMA node for the given attribute and initiator. </p>
+<p>If the attribute does not relate to a specific initiator (it does not have the flag <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>), location <code>initiator</code> is ignored and may be <code>NULL</code>.</p>
+<p>If <code>value</code> is non <code>NULL</code>, the corresponding value is returned there.</p>
+<p>If multiple targets have the same attribute values, only one is returned (and there is no way to clarify how that one is chosen). Applications that want to detect targets with identical/similar values, or that want to look at values for multiple attributes, should rather get all values using <a class="el" href="a00201.html#ga297e4a9adc2272446a4c7449dacef0df" title="Return an attribute value for a specific target NUMA node.">hwloc_memattr_get_value()</a> and manually select the target they consider the best.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOENT</code> if there are no matching targets. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if flags are invalid, or no such attribute exists.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>The initiator <code>initiator</code> should be of type <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174" title="Location is given as a cpuset, in the location cpuset union field.">HWLOC_LOCATION_TYPE_CPUSET</a> when refering to accesses performed by CPU cores. <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84" title="Location is given as an object, in the location object union field.">HWLOC_LOCATION_TYPE_OBJECT</a> is currently unused internally by hwloc, but users may for instance use it to provide custom information about host memory accesses performed by GPUs. </dd></dl>
+
+</div>
+</div>
+<a id="ga79f44f8e1cfd2f97a19171417a75a137" name="ga79f44f8e1cfd2f97a19171417a75a137"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga79f44f8e1cfd2f97a19171417a75a137">&#9670;&#160;</a></span>hwloc_memattr_get_by_name()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_memattr_get_by_name </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>name</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> *&#160;</td>
+          <td class="paramname"><em>id</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return the identifier of the memory attribute with the given name. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if no such attribute exists. </dd></dl>
+
+</div>
+</div>
+<a id="ga297e4a9adc2272446a4c7449dacef0df" name="ga297e4a9adc2272446a4c7449dacef0df"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga297e4a9adc2272446a4c7449dacef0df">&#9670;&#160;</a></span>hwloc_memattr_get_value()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_memattr_get_value </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a>&#160;</td>
+          <td class="paramname"><em>attribute</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>target_node</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00305.html">hwloc_location</a> *&#160;</td>
+          <td class="paramname"><em>initiator</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t *&#160;</td>
+          <td class="paramname"><em>value</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return an attribute value for a specific target NUMA node. </p>
+<p>If the attribute does not relate to a specific initiator (it does not have the flag <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>), location <code>initiator</code> is ignored and may be <code>NULL</code>.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance with errno set to <code>EINVAL</code> if flags are invalid or no such attribute exists.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>The initiator <code>initiator</code> should be of type <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174" title="Location is given as a cpuset, in the location cpuset union field.">HWLOC_LOCATION_TYPE_CPUSET</a> when refering to accesses performed by CPU cores. <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84" title="Location is given as an object, in the location object union field.">HWLOC_LOCATION_TYPE_OBJECT</a> is currently unused internally by hwloc, but users may for instance use it to provide custom information about host memory accesses performed by GPUs. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00202.html 2.11.0-1/doc/doxygen-doc/html/a00202.html
--- 2.10.0-1/doc/doxygen-doc/html/a00202.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00202.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,424 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Managing memory attributes</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Managing memory attributes</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:ga78aceb4cac4d614c0f5e82dbfeb779e5" id="r_ga78aceb4cac4d614c0f5e82dbfeb779e5"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00202.html#ga78aceb4cac4d614c0f5e82dbfeb779e5">hwloc_memattr_flag_e</a> { <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815">HWLOC_MEMATTR_FLAG_HIGHER_FIRST</a> = (1UL&lt;&lt;0)
+, <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf">HWLOC_MEMATTR_FLAG_LOWER_FIRST</a> = (1UL&lt;&lt;1)
+, <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a> = (1UL&lt;&lt;2)
+ }</td></tr>
+<tr class="separator:ga78aceb4cac4d614c0f5e82dbfeb779e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga5300e9be1abdea2e00c18492148aecd0" id="r_ga5300e9be1abdea2e00c18492148aecd0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00202.html#ga5300e9be1abdea2e00c18492148aecd0">hwloc_memattr_get_name</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute, const char **name)</td></tr>
+<tr class="separator:ga5300e9be1abdea2e00c18492148aecd0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga4c62b626085adeaffb233e5f2a03a5eb" id="r_ga4c62b626085adeaffb233e5f2a03a5eb"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00202.html#ga4c62b626085adeaffb233e5f2a03a5eb">hwloc_memattr_get_flags</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute, unsigned long *flags)</td></tr>
+<tr class="separator:ga4c62b626085adeaffb233e5f2a03a5eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga770657d1e44b09e93e09f623936c1e5f" id="r_ga770657d1e44b09e93e09f623936c1e5f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00202.html#ga770657d1e44b09e93e09f623936c1e5f">hwloc_memattr_register</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const char *name, unsigned long flags, <a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> *id)</td></tr>
+<tr class="separator:ga770657d1e44b09e93e09f623936c1e5f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga960529c08b25cf15825e0f72ecceb504" id="r_ga960529c08b25cf15825e0f72ecceb504"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00202.html#ga960529c08b25cf15825e0f72ecceb504">hwloc_memattr_set_value</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> target_node, struct <a class="el" href="a00305.html">hwloc_location</a> *initiator, unsigned long flags, hwloc_uint64_t value)</td></tr>
+<tr class="separator:ga960529c08b25cf15825e0f72ecceb504"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac8c06c1c89ab352c5db8e04a75033513" id="r_gac8c06c1c89ab352c5db8e04a75033513"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00202.html#gac8c06c1c89ab352c5db8e04a75033513">hwloc_memattr_get_targets</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute, struct <a class="el" href="a00305.html">hwloc_location</a> *initiator, unsigned long flags, unsigned *nr, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *targets, hwloc_uint64_t *values)</td></tr>
+<tr class="separator:gac8c06c1c89ab352c5db8e04a75033513"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga049aaa860dcbbf0792f0fd4251a99ec0" id="r_ga049aaa860dcbbf0792f0fd4251a99ec0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00202.html#ga049aaa860dcbbf0792f0fd4251a99ec0">hwloc_memattr_get_initiators</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> attribute, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> target_node, unsigned long flags, unsigned *nr, struct <a class="el" href="a00305.html">hwloc_location</a> *initiators, hwloc_uint64_t *values)</td></tr>
+<tr class="separator:ga049aaa860dcbbf0792f0fd4251a99ec0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="ga78aceb4cac4d614c0f5e82dbfeb779e5" name="ga78aceb4cac4d614c0f5e82dbfeb779e5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga78aceb4cac4d614c0f5e82dbfeb779e5">&#9670;&#160;</a></span>hwloc_memattr_flag_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00202.html#ga78aceb4cac4d614c0f5e82dbfeb779e5">hwloc_memattr_flag_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Memory attribute flags. Given to <a class="el" href="a00202.html#ga770657d1e44b09e93e09f623936c1e5f" title="Register a new memory attribute.">hwloc_memattr_register()</a> and returned by <a class="el" href="a00202.html#ga4c62b626085adeaffb233e5f2a03a5eb" title="Return the flags of the given attribute.">hwloc_memattr_get_flags()</a>. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815" name="gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815"></a>HWLOC_MEMATTR_FLAG_HIGHER_FIRST&#160;</td><td class="fielddoc"><p>The best nodes for this memory attribute are those with the higher values. For instance Bandwidth. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf" name="gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf"></a>HWLOC_MEMATTR_FLAG_LOWER_FIRST&#160;</td><td class="fielddoc"><p>The best nodes for this memory attribute are those with the lower values. For instance Latency. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" name="gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96"></a>HWLOC_MEMATTR_FLAG_NEED_INITIATOR&#160;</td><td class="fielddoc"><p>The value returned for this memory attribute depends on the given initiator. For instance Bandwidth and Latency, but not Capacity. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga4c62b626085adeaffb233e5f2a03a5eb" name="ga4c62b626085adeaffb233e5f2a03a5eb"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga4c62b626085adeaffb233e5f2a03a5eb">&#9670;&#160;</a></span>hwloc_memattr_get_flags()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_memattr_get_flags </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a>&#160;</td>
+          <td class="paramname"><em>attribute</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long *&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return the flags of the given attribute. </p>
+<p>Flags are a OR'ed set of <a class="el" href="a00202.html#ga78aceb4cac4d614c0f5e82dbfeb779e5" title="Memory attribute flags. Given to hwloc_memattr_register() and returned by hwloc_memattr_get_flags().">hwloc_memattr_flag_e</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if the attribute does not exist. </dd></dl>
+
+</div>
+</div>
+<a id="ga049aaa860dcbbf0792f0fd4251a99ec0" name="ga049aaa860dcbbf0792f0fd4251a99ec0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga049aaa860dcbbf0792f0fd4251a99ec0">&#9670;&#160;</a></span>hwloc_memattr_get_initiators()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_memattr_get_initiators </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a>&#160;</td>
+          <td class="paramname"><em>attribute</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>target_node</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>nr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00305.html">hwloc_location</a> *&#160;</td>
+          <td class="paramname"><em>initiators</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t *&#160;</td>
+          <td class="paramname"><em>values</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return the initiators that have values for a given attribute for a specific target NUMA node. </p>
+<p>Return initiators for the given attribute and target node in the <code>initiators</code> array. If <code>values</code> is not <code>NULL</code>, the corresponding attribute values are stored in the array it points to.</p>
+<p>On input, <code>nr</code> points to the number of initiators that may be stored in the array <code>initiators</code> (and <code>values</code>). On output, <code>nr</code> points to the number of initiators (and values) that were actually found, even if some of them couldn't be stored in the array. Initiators that couldn't be stored are ignored, but the function still returns success (<code>0</code>). The caller may find out by comparing the value pointed by <code>nr</code> before and after the function call.</p>
+<p>The returned initiators should not be modified or freed, they belong to the topology.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<p>If the attribute does not relate to a specific initiator (it does not have the flag <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>), no initiator is returned.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success or -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function is meant for tools and debugging (listing internal information) rather than for application queries. Applications should rather select useful NUMA nodes with <a class="el" href="a00201.html#ga569e80c5be7ef27649b0ef5aa52ffcdc" title="Return an array of local NUMA nodes.">hwloc_get_local_numanode_objs()</a> and then look at their attribute values for some relevant initiators. </dd></dl>
+
+</div>
+</div>
+<a id="ga5300e9be1abdea2e00c18492148aecd0" name="ga5300e9be1abdea2e00c18492148aecd0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga5300e9be1abdea2e00c18492148aecd0">&#9670;&#160;</a></span>hwloc_memattr_get_name()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_memattr_get_name </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a>&#160;</td>
+          <td class="paramname"><em>attribute</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char **&#160;</td>
+          <td class="paramname"><em>name</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return the name of a memory attribute. </p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if the attribute does not exist. </dd></dl>
+
+</div>
+</div>
+<a id="gac8c06c1c89ab352c5db8e04a75033513" name="gac8c06c1c89ab352c5db8e04a75033513"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac8c06c1c89ab352c5db8e04a75033513">&#9670;&#160;</a></span>hwloc_memattr_get_targets()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_memattr_get_targets </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a>&#160;</td>
+          <td class="paramname"><em>attribute</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00305.html">hwloc_location</a> *&#160;</td>
+          <td class="paramname"><em>initiator</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>nr</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *&#160;</td>
+          <td class="paramname"><em>targets</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t *&#160;</td>
+          <td class="paramname"><em>values</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return the target NUMA nodes that have some values for a given attribute. </p>
+<p>Return targets for the given attribute in the <code>targets</code> array (for the given initiator if any). If <code>values</code> is not <code>NULL</code>, the corresponding attribute values are stored in the array it points to.</p>
+<p>On input, <code>nr</code> points to the number of targets that may be stored in the array <code>targets</code> (and <code>values</code>). On output, <code>nr</code> points to the number of targets (and values) that were actually found, even if some of them couldn't be stored in the array. Targets that couldn't be stored are ignored, but the function still returns success (<code>0</code>). The caller may find out by comparing the value pointed by <code>nr</code> before and after the function call.</p>
+<p>The returned targets should not be modified or freed, they belong to the topology.</p>
+<p>Argument <code>initiator</code> is ignored if the attribute does not relate to a specific initiator (it does not have the flag <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>). Otherwise <code>initiator</code> may be non <code>NULL</code> to report only targets that have a value for that initiator.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section note"><dt>Note</dt><dd>This function is meant for tools and debugging (listing internal information) rather than for application queries. Applications should rather select useful NUMA nodes with <a class="el" href="a00201.html#ga569e80c5be7ef27649b0ef5aa52ffcdc" title="Return an array of local NUMA nodes.">hwloc_get_local_numanode_objs()</a> and then look at their attribute values.</dd></dl>
+<dl class="section return"><dt>Returns</dt><dd>0 on success or -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>The initiator <code>initiator</code> should be of type <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174" title="Location is given as a cpuset, in the location cpuset union field.">HWLOC_LOCATION_TYPE_CPUSET</a> when referring to accesses performed by CPU cores. <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84" title="Location is given as an object, in the location object union field.">HWLOC_LOCATION_TYPE_OBJECT</a> is currently unused internally by hwloc, but users may for instance use it to provide custom information about host memory accesses performed by GPUs. </dd></dl>
+
+</div>
+</div>
+<a id="ga770657d1e44b09e93e09f623936c1e5f" name="ga770657d1e44b09e93e09f623936c1e5f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga770657d1e44b09e93e09f623936c1e5f">&#9670;&#160;</a></span>hwloc_memattr_register()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_memattr_register </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>name</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a> *&#160;</td>
+          <td class="paramname"><em>id</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Register a new memory attribute. </p>
+<p>Add a specific memory attribute that is not defined in <a class="el" href="a00201.html#gab4bde745db676fc2ea4b47011cd9a80e" title="Memory node attributes.">hwloc_memattr_id_e</a>. Flags are a OR'ed set of <a class="el" href="a00202.html#ga78aceb4cac4d614c0f5e82dbfeb779e5" title="Memory attribute flags. Given to hwloc_memattr_register() and returned by hwloc_memattr_get_flags().">hwloc_memattr_flag_e</a>. It must contain at least one of <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815" title="The best nodes for this memory attribute are those with the higher values. For instance Bandwidth.">HWLOC_MEMATTR_FLAG_HIGHER_FIRST</a> or <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf" title="The best nodes for this memory attribute are those with the lower values. For instance Latency.">HWLOC_MEMATTR_FLAG_LOWER_FIRST</a>.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>EBUSY</code> if another attribute already uses this name. </dd></dl>
+
+</div>
+</div>
+<a id="ga960529c08b25cf15825e0f72ecceb504" name="ga960529c08b25cf15825e0f72ecceb504"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga960529c08b25cf15825e0f72ecceb504">&#9670;&#160;</a></span>hwloc_memattr_set_value()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_memattr_set_value </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00201.html#gacc82003a8610be554615995f0996c888">hwloc_memattr_id_t</a>&#160;</td>
+          <td class="paramname"><em>attribute</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>target_node</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00305.html">hwloc_location</a> *&#160;</td>
+          <td class="paramname"><em>initiator</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t&#160;</td>
+          <td class="paramname"><em>value</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set an attribute value for a specific target NUMA node. </p>
+<p>If the attribute does not relate to a specific initiator (it does not have the flag <a class="el" href="a00202.html#gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96" title="The value returned for this memory attribute depends on the given initiator. For instance Bandwidth a...">HWLOC_MEMATTR_FLAG_NEED_INITIATOR</a>), location <code>initiator</code> is ignored and may be <code>NULL</code>.</p>
+<p>The initiator will be copied into the topology, the caller should free anything allocated to store the initiator, for instance the cpuset.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section note"><dt>Note</dt><dd>The initiator <code>initiator</code> should be of type <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174" title="Location is given as a cpuset, in the location cpuset union field.">HWLOC_LOCATION_TYPE_CPUSET</a> when referring to accesses performed by CPU cores. <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84" title="Location is given as an object, in the location object union field.">HWLOC_LOCATION_TYPE_OBJECT</a> is currently unused internally by hwloc, but users may for instance use it to provide custom information about host memory accesses performed by GPUs.</dd></dl>
+<dl class="section return"><dt>Returns</dt><dd>0 on success or -1 on error. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00203.html 2.11.0-1/doc/doxygen-doc/html/a00203.html
--- 2.10.0-1/doc/doxygen-doc/html/a00203.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00203.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,292 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Kinds of CPU cores</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Kinds of CPU cores</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga7553f7c6d3920b169f3fc18dfe6a33e3" id="r_ga7553f7c6d3920b169f3fc18dfe6a33e3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00203.html#ga7553f7c6d3920b169f3fc18dfe6a33e3">hwloc_cpukinds_get_nr</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned long flags)</td></tr>
+<tr class="separator:ga7553f7c6d3920b169f3fc18dfe6a33e3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaf979833aab18d2e7f4b17c932cbcf5d8" id="r_gaf979833aab18d2e7f4b17c932cbcf5d8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00203.html#gaf979833aab18d2e7f4b17c932cbcf5d8">hwloc_cpukinds_get_by_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a> cpuset, unsigned long flags)</td></tr>
+<tr class="separator:gaf979833aab18d2e7f4b17c932cbcf5d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gae1b38fbe9c645583fc16052ce6fbb275" id="r_gae1b38fbe9c645583fc16052ce6fbb275"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00203.html#gae1b38fbe9c645583fc16052ce6fbb275">hwloc_cpukinds_get_info</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned kind_index, <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> cpuset, int *efficiency, unsigned *nr_infos, struct <a class="el" href="a00277.html">hwloc_info_s</a> **infos, unsigned long flags)</td></tr>
+<tr class="separator:gae1b38fbe9c645583fc16052ce6fbb275"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga6164ba92cfd06f530ec2c4a18a0dd5a9" id="r_ga6164ba92cfd06f530ec2c4a18a0dd5a9"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00203.html#ga6164ba92cfd06f530ec2c4a18a0dd5a9">hwloc_cpukinds_register</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> cpuset, int forced_efficiency, unsigned nr_infos, struct <a class="el" href="a00277.html">hwloc_info_s</a> *infos, unsigned long flags)</td></tr>
+<tr class="separator:ga6164ba92cfd06f530ec2c4a18a0dd5a9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>Platforms with heterogeneous CPUs may have some cores with different features or frequencies. This API exposes identical PUs in sets called CPU kinds. Each PU of the topology may only be in a single kind.</p>
+<p>The number of kinds may be obtained with <a class="el" href="a00203.html#ga7553f7c6d3920b169f3fc18dfe6a33e3" title="Get the number of different kinds of CPU cores in the topology.">hwloc_cpukinds_get_nr()</a>. If the platform is homogeneous, there may be a single kind with all PUs. If the platform or operating system does not expose any information about CPU cores, there may be no kind at all.</p>
+<p>The index of the kind that describes a given CPU set (if any, and not partially) may be obtained with <a class="el" href="a00203.html#gaf979833aab18d2e7f4b17c932cbcf5d8" title="Get the index of the CPU kind that contains CPUs listed in cpuset.">hwloc_cpukinds_get_by_cpuset()</a>.</p>
+<p>From the index of a kind, it is possible to retrieve information with <a class="el" href="a00203.html#gae1b38fbe9c645583fc16052ce6fbb275" title="Get the CPU set and infos about a CPU kind in the topology.">hwloc_cpukinds_get_info()</a>: an abstracted efficiency value, and an array of info attributes (for instance the "CoreType" and "FrequencyMaxMHz", see <a class="el" href="a00383.html#topoattrs_cpukinds">CPU Kinds</a>).</p>
+<p>A higher efficiency value means greater intrinsic performance (and possibly less performance/power efficiency). Kinds with lower efficiency values are ranked first: Passing 0 as <code>kind_index</code> to <a class="el" href="a00203.html#gae1b38fbe9c645583fc16052ce6fbb275" title="Get the CPU set and infos about a CPU kind in the topology.">hwloc_cpukinds_get_info()</a> will return information about the CPU kind with lower performance but higher energy-efficiency. Higher <code>kind_index</code> values would rather return information about power-hungry high-performance cores.</p>
+<p>When available, efficiency values are gathered from the operating system. If so, <code>cpukind_efficiency</code> is set in the struct <a class="el" href="a00281.html" title="Flags describing actual discovery support for this topology.">hwloc_topology_discovery_support</a> array. This is currently available on Windows 10, Mac OS X (Darwin), and on some Linux platforms where core "capacity" is exposed in sysfs.</p>
+<p>If the operating system does not expose core efficiencies natively, hwloc tries to compute efficiencies by comparing CPU kinds using frequencies (on ARM), or core types and frequencies (on other architectures). The environment variable HWLOC_CPUKINDS_RANKING may be used to change this heuristics, see <a class="el" href="a00378.html">Environment Variables</a>.</p>
+<p>If hwloc fails to rank any kind, for instance because the operating system does not expose efficiencies and core frequencies, all kinds will have an unknown efficiency (<code>-1</code>), and they are not indexed/ordered in any specific way. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gaf979833aab18d2e7f4b17c932cbcf5d8" name="gaf979833aab18d2e7f4b17c932cbcf5d8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf979833aab18d2e7f4b17c932cbcf5d8">&#9670;&#160;</a></span>hwloc_cpukinds_get_by_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_cpukinds_get_by_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gae991a108af01d408be2776c5b2c467b2">hwloc_const_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>cpuset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the index of the CPU kind that contains CPUs listed in <code>cpuset</code>. </p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section return"><dt>Returns</dt><dd>The index of the CPU kind (positive integer or 0) on success. </dd>
+<dd>
+<code>-1</code> with <code>errno</code> set to <code>EXDEV</code> if <code>cpuset</code> is only partially included in the some kind. </dd>
+<dd>
+<code>-1</code> with <code>errno</code> set to <code>ENOENT</code> if <code>cpuset</code> is not included in any kind, even partially. </dd>
+<dd>
+<code>-1</code> with <code>errno</code> set to <code>EINVAL</code> if parameters are invalid. </dd></dl>
+
+</div>
+</div>
+<a id="gae1b38fbe9c645583fc16052ce6fbb275" name="gae1b38fbe9c645583fc16052ce6fbb275"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gae1b38fbe9c645583fc16052ce6fbb275">&#9670;&#160;</a></span>hwloc_cpukinds_get_info()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_cpukinds_get_info </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>kind_index</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>cpuset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int *&#160;</td>
+          <td class="paramname"><em>efficiency</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>nr_infos</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00277.html">hwloc_info_s</a> **&#160;</td>
+          <td class="paramname"><em>infos</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the CPU set and infos about a CPU kind in the topology. </p>
+<p><code>kind_index</code> identifies one kind of CPU between 0 and the number of kinds returned by <a class="el" href="a00203.html#ga7553f7c6d3920b169f3fc18dfe6a33e3" title="Get the number of different kinds of CPU cores in the topology.">hwloc_cpukinds_get_nr()</a> minus 1.</p>
+<p>If not <code>NULL</code>, the bitmap <code>cpuset</code> will be filled with the set of PUs of this kind.</p>
+<p>The integer pointed by <code>efficiency</code>, if not <code>NULL</code> will, be filled with the ranking of this kind of CPU in term of efficiency (see above). It ranges from <code>0</code> to the number of kinds (as reported by <a class="el" href="a00203.html#ga7553f7c6d3920b169f3fc18dfe6a33e3" title="Get the number of different kinds of CPU cores in the topology.">hwloc_cpukinds_get_nr()</a>) minus 1.</p>
+<p>Kinds with lower efficiency are reported first.</p>
+<p>If there is a single kind in the topology, its efficiency <code>0</code>. If the efficiency of some kinds of cores is unknown, the efficiency of all kinds is set to <code>-1</code>, and kinds are reported in no specific order.</p>
+<p>The array of info attributes (for instance the "CoreType", "FrequencyMaxMHz" or "FrequencyBaseMHz", see <a class="el" href="a00383.html#topoattrs_cpukinds">CPU Kinds</a>) and its length are returned in <code>infos</code> or <code>nr_infos</code>. The array belongs to the topology, it should not be freed or modified.</p>
+<p>If <code>nr_infos</code> or <code>infos</code> is <code>NULL</code>, no info is returned.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section return"><dt>Returns</dt><dd><code>0</code> on success. </dd>
+<dd>
+<code>-1</code> with <code>errno</code> set to <code>ENOENT</code> if <code>kind_index</code> does not match any CPU kind. </dd>
+<dd>
+<code>-1</code> with <code>errno</code> set to <code>EINVAL</code> if parameters are invalid. </dd></dl>
+
+</div>
+</div>
+<a id="ga7553f7c6d3920b169f3fc18dfe6a33e3" name="ga7553f7c6d3920b169f3fc18dfe6a33e3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga7553f7c6d3920b169f3fc18dfe6a33e3">&#9670;&#160;</a></span>hwloc_cpukinds_get_nr()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_cpukinds_get_nr </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the number of different kinds of CPU cores in the topology. </p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<dl class="section return"><dt>Returns</dt><dd>The number of CPU kinds (positive integer) on success. </dd>
+<dd>
+<code>0</code> if no information about kinds was found. </dd>
+<dd>
+<code>-1</code> with <code>errno</code> set to <code>EINVAL</code> if <code>flags</code> is invalid. </dd></dl>
+
+</div>
+</div>
+<a id="ga6164ba92cfd06f530ec2c4a18a0dd5a9" name="ga6164ba92cfd06f530ec2c4a18a0dd5a9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga6164ba92cfd06f530ec2c4a18a0dd5a9">&#9670;&#160;</a></span>hwloc_cpukinds_register()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_cpukinds_register </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>cpuset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>forced_efficiency</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>nr_infos</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00277.html">hwloc_info_s</a> *&#160;</td>
+          <td class="paramname"><em>infos</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Register a kind of CPU in the topology. </p>
+<p>Mark the PUs listed in <code>cpuset</code> as being of the same kind with respect to the given attributes.</p>
+<p><code>forced_efficiency</code> should be <code>-1</code> if unknown. Otherwise it is an abstracted efficiency value to enforce the ranking of all kinds if all of them have valid (and different) efficiencies.</p>
+<p>The array <code>infos</code> of size <code>nr_infos</code> may be used to provide info names and values describing this kind of PUs.</p>
+<p><code>flags</code> must be <code>0</code> for now.</p>
+<p>Parameters <code>cpuset</code> and <code>infos</code> will be duplicated internally, the caller is responsible for freeing them.</p>
+<p>If <code>cpuset</code> overlaps with some existing kinds, those might get modified or split. For instance if existing kind A contains PUs 0 and 1, and one registers another kind for PU 1 and 2, there will be 3 resulting kinds: existing kind A is restricted to only PU 0; new kind B contains only PU 1 and combines information from A and from the newly-registered kind; new kind C contains only PU 2 and only gets information from the newly-registered kind.</p>
+<dl class="section note"><dt>Note</dt><dd>The efficiency <code>forced_efficiency</code> provided to this function may be different from the one reported later by <a class="el" href="a00203.html#gae1b38fbe9c645583fc16052ce6fbb275" title="Get the CPU set and infos about a CPU kind in the topology.">hwloc_cpukinds_get_info()</a> because hwloc will scale efficiency values down to between 0 and the number of kinds minus 1.</dd></dl>
+<dl class="section return"><dt>Returns</dt><dd><code>0</code> on success. </dd>
+<dd>
+<code>-1</code> with <code>errno</code> set to <code>EINVAL</code> if some parameters are invalid, for instance if <code>cpuset</code> is <code>NULL</code> or empty. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00204.html 2.11.0-1/doc/doxygen-doc/html/a00204.html
--- 2.10.0-1/doc/doxygen-doc/html/a00204.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00204.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,219 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Linux-specific helpers</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Linux-specific helpers</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga630e699c56b5f3d2e534b475944c216e" id="r_ga630e699c56b5f3d2e534b475944c216e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00204.html#ga630e699c56b5f3d2e534b475944c216e">hwloc_linux_set_tid_cpubind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, pid_t tid, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> set)</td></tr>
+<tr class="separator:ga630e699c56b5f3d2e534b475944c216e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaddcb985cb56337a4d6693cee72e7bf94" id="r_gaddcb985cb56337a4d6693cee72e7bf94"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00204.html#gaddcb985cb56337a4d6693cee72e7bf94">hwloc_linux_get_tid_cpubind</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, pid_t tid, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</td></tr>
+<tr class="separator:gaddcb985cb56337a4d6693cee72e7bf94"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gacc7945c2d06c6db1e58f8fd953009134" id="r_gacc7945c2d06c6db1e58f8fd953009134"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00204.html#gacc7945c2d06c6db1e58f8fd953009134">hwloc_linux_get_tid_last_cpu_location</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, pid_t tid, <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set)</td></tr>
+<tr class="separator:gacc7945c2d06c6db1e58f8fd953009134"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaf72d83e273803226ce772973e37b85de" id="r_gaf72d83e273803226ce772973e37b85de"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00204.html#gaf72d83e273803226ce772973e37b85de">hwloc_linux_read_path_as_cpumask</a> (const char *path, <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> set)</td></tr>
+<tr class="separator:gaf72d83e273803226ce772973e37b85de"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This includes helpers for manipulating Linux kernel cpumap files, and hwloc equivalents of the Linux sched_setaffinity and sched_getaffinity system calls. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gaddcb985cb56337a4d6693cee72e7bf94" name="gaddcb985cb56337a4d6693cee72e7bf94"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaddcb985cb56337a4d6693cee72e7bf94">&#9670;&#160;</a></span>hwloc_linux_get_tid_cpubind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_linux_get_tid_cpubind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">pid_t&#160;</td>
+          <td class="paramname"><em>tid</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the current binding of thread <code>tid</code>. </p>
+<p>The CPU-set <code>set</code> (previously allocated by the caller) is filled with the list of PUs which the thread was last bound to.</p>
+<p>The behavior is exactly the same as the Linux sched_getaffinity system call, but uses a hwloc cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This is equivalent to calling <a class="el" href="a00179.html#gac82de91f788fa82dacf99c6e0d4b7158" title="Get the current physical binding of process pid.">hwloc_get_proc_cpubind()</a> with <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421" title="Bind current thread of current process.">HWLOC_CPUBIND_THREAD</a> as flags. </dd></dl>
+
+</div>
+</div>
+<a id="gacc7945c2d06c6db1e58f8fd953009134" name="gacc7945c2d06c6db1e58f8fd953009134"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gacc7945c2d06c6db1e58f8fd953009134">&#9670;&#160;</a></span>hwloc_linux_get_tid_last_cpu_location()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_linux_get_tid_last_cpu_location </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">pid_t&#160;</td>
+          <td class="paramname"><em>tid</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the last physical CPU where thread <code>tid</code> ran. </p>
+<p>The CPU-set <code>set</code> (previously allocated by the caller) is filled with the PU which the thread last ran on.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This is equivalent to calling <a class="el" href="a00179.html#ga910a05c2d47f68a3155bf176b50fa555" title="Get the last physical CPU where a process ran.">hwloc_get_proc_last_cpu_location()</a> with <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421" title="Bind current thread of current process.">HWLOC_CPUBIND_THREAD</a> as flags. </dd></dl>
+
+</div>
+</div>
+<a id="gaf72d83e273803226ce772973e37b85de" name="gaf72d83e273803226ce772973e37b85de"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf72d83e273803226ce772973e37b85de">&#9670;&#160;</a></span>hwloc_linux_read_path_as_cpumask()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_linux_read_path_as_cpumask </td>
+          <td>(</td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>path</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Convert a linux kernel cpumask file <code>path</code> into a hwloc bitmap <code>set</code>. </p>
+<p>Might be used when reading CPU set from sysfs attributes such as topology and caches for processors, or local_cpus for devices.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This function ignores the HWLOC_FSROOT environment variable. </dd></dl>
+
+</div>
+</div>
+<a id="ga630e699c56b5f3d2e534b475944c216e" name="ga630e699c56b5f3d2e534b475944c216e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga630e699c56b5f3d2e534b475944c216e">&#9670;&#160;</a></span>hwloc_linux_set_tid_cpubind()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_linux_set_tid_cpubind </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">pid_t&#160;</td>
+          <td class="paramname"><em>tid</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Bind a thread <code>tid</code> on cpus given in cpuset <code>set</code>. </p>
+<p>The behavior is exactly the same as the Linux sched_setaffinity system call, but uses a hwloc cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>This is equivalent to calling <a class="el" href="a00179.html#ga296db8a3c6d49b51fb83d6f3e45c02a6" title="Bind a process pid on CPUs given in physical bitmap set.">hwloc_set_proc_cpubind()</a> with HWLOC_CPUBIND_THREAD as flags. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00205.html 2.11.0-1/doc/doxygen-doc/html/a00205.html
--- 2.10.0-1/doc/doxygen-doc/html/a00205.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00205.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,287 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability with Linux libnuma unsigned long masks</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Interoperability with Linux libnuma unsigned long masks</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gae577962390f84b0b12f503314ab0f972" id="r_gae577962390f84b0b12f503314ab0f972"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00205.html#gae577962390f84b0b12f503314ab0f972">hwloc_cpuset_to_linux_libnuma_ulongs</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> cpuset, unsigned long *mask, unsigned long *maxnode)</td></tr>
+<tr class="separator:gae577962390f84b0b12f503314ab0f972"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga585ccf818d2f217f4e53f9c6506c3128" id="r_ga585ccf818d2f217f4e53f9c6506c3128"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00205.html#ga585ccf818d2f217f4e53f9c6506c3128">hwloc_nodeset_to_linux_libnuma_ulongs</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> nodeset, unsigned long *mask, unsigned long *maxnode)</td></tr>
+<tr class="separator:ga585ccf818d2f217f4e53f9c6506c3128"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga0e9d051e068940f722f6fdc61814149d" id="r_ga0e9d051e068940f722f6fdc61814149d"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00205.html#ga0e9d051e068940f722f6fdc61814149d">hwloc_cpuset_from_linux_libnuma_ulongs</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> cpuset, const unsigned long *mask, unsigned long maxnode)</td></tr>
+<tr class="separator:ga0e9d051e068940f722f6fdc61814149d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gad8491c672eb2594cc5e7b0a026867192" id="r_gad8491c672eb2594cc5e7b0a026867192"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00205.html#gad8491c672eb2594cc5e7b0a026867192">hwloc_nodeset_from_linux_libnuma_ulongs</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a> nodeset, const unsigned long *mask, unsigned long maxnode)</td></tr>
+<tr class="separator:gad8491c672eb2594cc5e7b0a026867192"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This interface helps converting between Linux libnuma unsigned long masks and hwloc cpusets and nodesets.</p>
+<dl class="section note"><dt>Note</dt><dd>Topology <code>topology</code> must match the current machine.</dd>
+<dd>
+The behavior of libnuma is undefined if the kernel is not NUMA-aware. (when CONFIG_NUMA is not set in the kernel configuration). This helper and libnuma may thus not be strictly compatible in this case, which may be detected by checking whether numa_available() returns -1. </dd></dl>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga0e9d051e068940f722f6fdc61814149d" name="ga0e9d051e068940f722f6fdc61814149d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga0e9d051e068940f722f6fdc61814149d">&#9670;&#160;</a></span>hwloc_cpuset_from_linux_libnuma_ulongs()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_cpuset_from_linux_libnuma_ulongs </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>cpuset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const unsigned long *&#160;</td>
+          <td class="paramname"><em>mask</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>maxnode</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert the array of unsigned long <code>mask</code> into hwloc CPU set. </p>
+<p><code>mask</code> is a array of unsigned long that will be read. <code>maxnode</code> contains the maximal node number that may be read in <code>mask</code>.</p>
+<p>This function may be used after calling get_mempolicy or any other function that takes an array of unsigned long as output parameter (and possibly a maximal node number as input parameter).</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if failing an internal reallocation. </dd></dl>
+
+</div>
+</div>
+<a id="gae577962390f84b0b12f503314ab0f972" name="gae577962390f84b0b12f503314ab0f972"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gae577962390f84b0b12f503314ab0f972">&#9670;&#160;</a></span>hwloc_cpuset_to_linux_libnuma_ulongs()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_cpuset_to_linux_libnuma_ulongs </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>cpuset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long *&#160;</td>
+          <td class="paramname"><em>mask</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long *&#160;</td>
+          <td class="paramname"><em>maxnode</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert hwloc CPU set <code>cpuset</code> into the array of unsigned long <code>mask</code>. </p>
+<p><code>mask</code> is the array of unsigned long that will be filled. <code>maxnode</code> contains the maximal node number that may be stored in <code>mask</code>. <code>maxnode</code> will be set to the maximal node number that was found, plus one.</p>
+<p>This function may be used before calling set_mempolicy, mbind, migrate_pages or any other function that takes an array of unsigned long and a maximal node number as input parameter.</p>
+<dl class="section return"><dt>Returns</dt><dd>0. </dd></dl>
+
+</div>
+</div>
+<a id="gad8491c672eb2594cc5e7b0a026867192" name="gad8491c672eb2594cc5e7b0a026867192"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad8491c672eb2594cc5e7b0a026867192">&#9670;&#160;</a></span>hwloc_nodeset_from_linux_libnuma_ulongs()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_nodeset_from_linux_libnuma_ulongs </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a>&#160;</td>
+          <td class="paramname"><em>nodeset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const unsigned long *&#160;</td>
+          <td class="paramname"><em>mask</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>maxnode</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert the array of unsigned long <code>mask</code> into hwloc NUMA node set. </p>
+<p><code>mask</code> is a array of unsigned long that will be read. <code>maxnode</code> contains the maximal node number that may be read in <code>mask</code>.</p>
+<p>This function may be used after calling get_mempolicy or any other function that takes an array of unsigned long as output parameter (and possibly a maximal node number as input parameter).</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOMEM</code> if some internal reallocation failed. </dd></dl>
+
+</div>
+</div>
+<a id="ga585ccf818d2f217f4e53f9c6506c3128" name="ga585ccf818d2f217f4e53f9c6506c3128"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga585ccf818d2f217f4e53f9c6506c3128">&#9670;&#160;</a></span>hwloc_nodeset_to_linux_libnuma_ulongs()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_nodeset_to_linux_libnuma_ulongs </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a>&#160;</td>
+          <td class="paramname"><em>nodeset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long *&#160;</td>
+          <td class="paramname"><em>mask</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long *&#160;</td>
+          <td class="paramname"><em>maxnode</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert hwloc NUMA node set <code>nodeset</code> into the array of unsigned long <code>mask</code>. </p>
+<p><code>mask</code> is the array of unsigned long that will be filled. <code>maxnode</code> contains the maximal node number that may be stored in <code>mask</code>. <code>maxnode</code> will be set to the maximal node number that was found, plus one.</p>
+<p>This function may be used before calling set_mempolicy, mbind, migrate_pages or any other function that takes an array of unsigned long and a maximal node number as input parameter.</p>
+<dl class="section return"><dt>Returns</dt><dd>0. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00206.html 2.11.0-1/doc/doxygen-doc/html/a00206.html
--- 2.10.0-1/doc/doxygen-doc/html/a00206.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00206.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,249 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability with Linux libnuma bitmask</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Interoperability with Linux libnuma bitmask</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gad8769b4544c0aeef154fc8223144e343" id="r_gad8769b4544c0aeef154fc8223144e343"><td class="memItemLeft" align="right" valign="top">static struct bitmask *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00206.html#gad8769b4544c0aeef154fc8223144e343">hwloc_cpuset_to_linux_libnuma_bitmask</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> cpuset)</td></tr>
+<tr class="separator:gad8769b4544c0aeef154fc8223144e343"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gadfaa14c1bec76965ac2e05f0c3f3473b" id="r_gadfaa14c1bec76965ac2e05f0c3f3473b"><td class="memItemLeft" align="right" valign="top">static struct bitmask *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00206.html#gadfaa14c1bec76965ac2e05f0c3f3473b">hwloc_nodeset_to_linux_libnuma_bitmask</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a> nodeset)</td></tr>
+<tr class="separator:gadfaa14c1bec76965ac2e05f0c3f3473b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga37c8421110b1842414809019098794ef" id="r_ga37c8421110b1842414809019098794ef"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00206.html#ga37c8421110b1842414809019098794ef">hwloc_cpuset_from_linux_libnuma_bitmask</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> cpuset, const struct bitmask *bitmask)</td></tr>
+<tr class="separator:ga37c8421110b1842414809019098794ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaaca6bff3086aad5bdbd2f4c5f0ad14cc" id="r_gaaca6bff3086aad5bdbd2f4c5f0ad14cc"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00206.html#gaaca6bff3086aad5bdbd2f4c5f0ad14cc">hwloc_nodeset_from_linux_libnuma_bitmask</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a> nodeset, const struct bitmask *bitmask)</td></tr>
+<tr class="separator:gaaca6bff3086aad5bdbd2f4c5f0ad14cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This interface helps converting between Linux libnuma bitmasks and hwloc cpusets and nodesets.</p>
+<dl class="section note"><dt>Note</dt><dd>Topology <code>topology</code> must match the current machine.</dd>
+<dd>
+The behavior of libnuma is undefined if the kernel is not NUMA-aware. (when CONFIG_NUMA is not set in the kernel configuration). This helper and libnuma may thus not be strictly compatible in this case, which may be detected by checking whether numa_available() returns -1. </dd></dl>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga37c8421110b1842414809019098794ef" name="ga37c8421110b1842414809019098794ef"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga37c8421110b1842414809019098794ef">&#9670;&#160;</a></span>hwloc_cpuset_from_linux_libnuma_bitmask()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_cpuset_from_linux_libnuma_bitmask </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>cpuset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const struct bitmask *&#160;</td>
+          <td class="paramname"><em>bitmask</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert libnuma bitmask <code>bitmask</code> into hwloc CPU set <code>cpuset</code>. </p>
+<p>This function may be used after calling many numa_ functions that use a struct bitmask as an output parameter.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOMEM</code> if some internal reallocation failed. </dd></dl>
+
+</div>
+</div>
+<a id="gad8769b4544c0aeef154fc8223144e343" name="gad8769b4544c0aeef154fc8223144e343"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad8769b4544c0aeef154fc8223144e343">&#9670;&#160;</a></span>hwloc_cpuset_to_linux_libnuma_bitmask()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static struct bitmask * hwloc_cpuset_to_linux_libnuma_bitmask </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>cpuset</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert hwloc CPU set <code>cpuset</code> into the returned libnuma bitmask. </p>
+<p>The returned bitmask should later be freed with numa_bitmask_free.</p>
+<p>This function may be used before calling many numa_ functions that use a struct bitmask as an input parameter.</p>
+<dl class="section return"><dt>Returns</dt><dd>newly allocated struct bitmask, or <code>NULL</code> on error. </dd></dl>
+
+</div>
+</div>
+<a id="gaaca6bff3086aad5bdbd2f4c5f0ad14cc" name="gaaca6bff3086aad5bdbd2f4c5f0ad14cc"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaaca6bff3086aad5bdbd2f4c5f0ad14cc">&#9670;&#160;</a></span>hwloc_nodeset_from_linux_libnuma_bitmask()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_nodeset_from_linux_libnuma_bitmask </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a>&#160;</td>
+          <td class="paramname"><em>nodeset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const struct bitmask *&#160;</td>
+          <td class="paramname"><em>bitmask</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert libnuma bitmask <code>bitmask</code> into hwloc NUMA node set <code>nodeset</code>. </p>
+<p>This function may be used after calling many numa_ functions that use a struct bitmask as an output parameter.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOMEM</code> if some internal reallocation failed. </dd></dl>
+
+</div>
+</div>
+<a id="gadfaa14c1bec76965ac2e05f0c3f3473b" name="gadfaa14c1bec76965ac2e05f0c3f3473b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gadfaa14c1bec76965ac2e05f0c3f3473b">&#9670;&#160;</a></span>hwloc_nodeset_to_linux_libnuma_bitmask()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static struct bitmask * hwloc_nodeset_to_linux_libnuma_bitmask </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga2f5276235841ad66a79bedad16a5a10c">hwloc_const_nodeset_t</a>&#160;</td>
+          <td class="paramname"><em>nodeset</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert hwloc NUMA node set <code>nodeset</code> into the returned libnuma bitmask. </p>
+<p>The returned bitmask should later be freed with numa_bitmask_free.</p>
+<p>This function may be used before calling many numa_ functions that use a struct bitmask as an input parameter.</p>
+<dl class="section return"><dt>Returns</dt><dd>newly allocated struct bitmask, or <code>NULL</code> on error. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00207.html 2.11.0-1/doc/doxygen-doc/html/a00207.html
--- 2.10.0-1/doc/doxygen-doc/html/a00207.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00207.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,145 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Windows-specific helpers</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Windows-specific helpers</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gaa4376a1969660a344911d117f645d3dd" id="r_gaa4376a1969660a344911d117f645d3dd"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00207.html#gaa4376a1969660a344911d117f645d3dd">hwloc_windows_get_nr_processor_groups</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned long flags)</td></tr>
+<tr class="separator:gaa4376a1969660a344911d117f645d3dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga167d1f28d3bd9defe1ffa940c14e8dd1" id="r_ga167d1f28d3bd9defe1ffa940c14e8dd1"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00207.html#ga167d1f28d3bd9defe1ffa940c14e8dd1">hwloc_windows_get_processor_group_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned pg_index, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> cpuset, unsigned long flags)</td></tr>
+<tr class="separator:ga167d1f28d3bd9defe1ffa940c14e8dd1"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>These functions query Windows processor groups. These groups partition the operating system into virtual sets of up to 64 neighbor PUs. Threads and processes may only be bound inside a single group. Although Windows processor groups may be exposed in the hwloc hierarchy as hwloc Groups, they are also often merged into existing hwloc objects such as NUMA nodes or Packages. This API provides explicit information about Windows processor groups so that applications know whether binding to a large set of PUs may fail because it spans over multiple Windows processor groups. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gaa4376a1969660a344911d117f645d3dd" name="gaa4376a1969660a344911d117f645d3dd"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa4376a1969660a344911d117f645d3dd">&#9670;&#160;</a></span>hwloc_windows_get_nr_processor_groups()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_windows_get_nr_processor_groups </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the number of Windows processor groups. </p>
+<p><code>flags</code> must be 0 for now.</p>
+<dl class="section return"><dt>Returns</dt><dd>at least <code>1</code> on success. </dd>
+<dd>
+-1 on error, for instance if the topology does not match the current system (e.g. loaded from another machine through XML). </dd></dl>
+
+</div>
+</div>
+<a id="ga167d1f28d3bd9defe1ffa940c14e8dd1" name="ga167d1f28d3bd9defe1ffa940c14e8dd1"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga167d1f28d3bd9defe1ffa940c14e8dd1">&#9670;&#160;</a></span>hwloc_windows_get_processor_group_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_windows_get_processor_group_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>pg_index</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>cpuset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the CPU-set of a Windows processor group. </p>
+<p>Get the set of PU included in the processor group specified by <code>pg_index</code>. <code>pg_index</code> must be between <code>0</code> and the value returned by <a class="el" href="a00207.html#gaa4376a1969660a344911d117f645d3dd" title="Get the number of Windows processor groups.">hwloc_windows_get_nr_processor_groups()</a> minus 1.</p>
+<p><code>flags</code> must be 0 for now.</p>
+<dl class="section return"><dt>Returns</dt><dd><code>0</code> on success. </dd>
+<dd>
+<code>-1</code> on error, for instance if <code>pg_index</code> is invalid, or if the topology does not match the current system (e.g. loaded from another machine through XML). </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00208.html 2.11.0-1/doc/doxygen-doc/html/a00208.html
--- 2.10.0-1/doc/doxygen-doc/html/a00208.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00208.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,173 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability with glibc sched affinity</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Interoperability with glibc sched affinity</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga88699a0c86c66a9b7baa3468cd9d24c3" id="r_ga88699a0c86c66a9b7baa3468cd9d24c3"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00208.html#ga88699a0c86c66a9b7baa3468cd9d24c3">hwloc_cpuset_to_glibc_sched_affinity</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a> hwlocset, cpu_set_t *schedset, size_t schedsetsize)</td></tr>
+<tr class="separator:ga88699a0c86c66a9b7baa3468cd9d24c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga8ec807ec17de57fa77aa5cfd6c8e4bfb" id="r_ga8ec807ec17de57fa77aa5cfd6c8e4bfb"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00208.html#ga8ec807ec17de57fa77aa5cfd6c8e4bfb">hwloc_cpuset_from_glibc_sched_affinity</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> hwlocset, const cpu_set_t *schedset, size_t schedsetsize)</td></tr>
+<tr class="separator:ga8ec807ec17de57fa77aa5cfd6c8e4bfb"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This interface offers ways to convert between hwloc cpusets and glibc cpusets such as those manipulated by sched_getaffinity() or pthread_attr_setaffinity_np().</p>
+<dl class="section note"><dt>Note</dt><dd>Topology <code>topology</code> must match the current machine. </dd></dl>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga8ec807ec17de57fa77aa5cfd6c8e4bfb" name="ga8ec807ec17de57fa77aa5cfd6c8e4bfb"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8ec807ec17de57fa77aa5cfd6c8e4bfb">&#9670;&#160;</a></span>hwloc_cpuset_from_glibc_sched_affinity()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_cpuset_from_glibc_sched_affinity </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>hwlocset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const cpu_set_t *&#160;</td>
+          <td class="paramname"><em>schedset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>schedsetsize</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert glibc sched affinity CPU set <code>schedset</code> into hwloc CPU set. </p>
+<p>This function may be used before calling sched_setaffinity or any other function that takes a cpu_set_t as input parameter.</p>
+<p><code>schedsetsize</code> should be sizeof(cpu_set_t) unless <code>schedset</code> was dynamically allocated with CPU_ALLOC</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>ENOMEM</code> if some internal reallocation failed. </dd></dl>
+
+</div>
+</div>
+<a id="ga88699a0c86c66a9b7baa3468cd9d24c3" name="ga88699a0c86c66a9b7baa3468cd9d24c3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga88699a0c86c66a9b7baa3468cd9d24c3">&#9670;&#160;</a></span>hwloc_cpuset_to_glibc_sched_affinity()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_cpuset_to_glibc_sched_affinity </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga1f784433e9b606261f62d1134f6a3b25">hwloc_const_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>hwlocset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">cpu_set_t *&#160;</td>
+          <td class="paramname"><em>schedset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>schedsetsize</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Convert hwloc CPU set <code>toposet</code> into glibc sched affinity CPU set <code>schedset</code>. </p>
+<p>This function may be used before calling sched_setaffinity or any other function that takes a cpu_set_t as input parameter.</p>
+<p><code>schedsetsize</code> should be sizeof(cpu_set_t) unless <code>schedset</code> was dynamically allocated with CPU_ALLOC</p>
+<dl class="section return"><dt>Returns</dt><dd>0. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00209.html 2.11.0-1/doc/doxygen-doc/html/a00209.html
--- 2.10.0-1/doc/doxygen-doc/html/a00209.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00209.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,275 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability with OpenCL</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Interoperability with OpenCL</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gab89e4d20f8a353299351b41849e35ac9" id="r_gab89e4d20f8a353299351b41849e35ac9"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00209.html#gab89e4d20f8a353299351b41849e35ac9">hwloc_opencl_get_device_pci_busid</a> (cl_device_id device, unsigned *domain, unsigned *bus, unsigned *dev, unsigned *func)</td></tr>
+<tr class="separator:gab89e4d20f8a353299351b41849e35ac9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gacc32737d4648d16b0d292438f210ec90" id="r_gacc32737d4648d16b0d292438f210ec90"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00209.html#gacc32737d4648d16b0d292438f210ec90">hwloc_opencl_get_device_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, cl_device_id device, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</td></tr>
+<tr class="separator:gacc32737d4648d16b0d292438f210ec90"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gae39352d124cb330eb37b84b418ed6cc5" id="r_gae39352d124cb330eb37b84b418ed6cc5"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00209.html#gae39352d124cb330eb37b84b418ed6cc5">hwloc_opencl_get_device_osdev_by_index</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned platform_index, unsigned device_index)</td></tr>
+<tr class="separator:gae39352d124cb330eb37b84b418ed6cc5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gadabfa6516aa12e5d8f79b9b4dd9f3cf8" id="r_gadabfa6516aa12e5d8f79b9b4dd9f3cf8"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00209.html#gadabfa6516aa12e5d8f79b9b4dd9f3cf8">hwloc_opencl_get_device_osdev</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, cl_device_id device)</td></tr>
+<tr class="separator:gadabfa6516aa12e5d8f79b9b4dd9f3cf8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This interface offers ways to retrieve topology information about OpenCL devices.</p>
+<p>Only AMD and NVIDIA OpenCL implementations currently offer useful locality information about their devices. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gacc32737d4648d16b0d292438f210ec90" name="gacc32737d4648d16b0d292438f210ec90"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gacc32737d4648d16b0d292438f210ec90">&#9670;&#160;</a></span>hwloc_opencl_get_device_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_opencl_get_device_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">cl_device_id&#160;</td>
+          <td class="paramname"><em>device</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the CPU set of processors that are physically close to OpenCL device <code>device</code>. </p>
+<p>Store in <code>set</code> the CPU-set describing the locality of the OpenCL device <code>device</code>.</p>
+<p>Topology <code>topology</code> and device <code>device</code> must match the local machine. I/O devices detection and the OpenCL component are not needed in the topology.</p>
+<p>The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see <a class="el" href="a00209.html#gadabfa6516aa12e5d8f79b9b4dd9f3cf8" title="Get the hwloc OS device object corresponding to OpenCL device deviceX.">hwloc_opencl_get_device_osdev()</a> and <a class="el" href="a00209.html#gae39352d124cb330eb37b84b418ed6cc5" title="Get the hwloc OS device object corresponding to the OpenCL device for the given indexes.">hwloc_opencl_get_device_osdev_by_index()</a>.</p>
+<p>This function is currently only implemented in a meaningful way for Linux with the AMD or NVIDIA OpenCL implementation; other systems will simply get a full cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if the device could not be found. </dd></dl>
+
+</div>
+</div>
+<a id="gadabfa6516aa12e5d8f79b9b4dd9f3cf8" name="gadabfa6516aa12e5d8f79b9b4dd9f3cf8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gadabfa6516aa12e5d8f79b9b4dd9f3cf8">&#9670;&#160;</a></span>hwloc_opencl_get_device_osdev()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_opencl_get_device_osdev </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">cl_device_id&#160;</td>
+          <td class="paramname"><em>device</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to OpenCL device <code>deviceX</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object corresponding to the given OpenCL device <code>device</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found, for instance if required OpenCL attributes are not available.</dd></dl>
+<p>This function currently only works on AMD and NVIDIA OpenCL devices that support relevant OpenCL extensions. <a class="el" href="a00209.html#gae39352d124cb330eb37b84b418ed6cc5" title="Get the hwloc OS device object corresponding to the OpenCL device for the given indexes.">hwloc_opencl_get_device_osdev_by_index()</a> should be preferred whenever possible, i.e. when platform and device index are known.</p>
+<p>Topology <code>topology</code> and device <code>device</code> must match the local machine. I/O devices detection and the OpenCL component must be enabled in the topology. If not, the locality of the object may still be found using <a class="el" href="a00209.html#gacc32737d4648d16b0d292438f210ec90" title="Get the CPU set of processors that are physically close to OpenCL device device.">hwloc_opencl_get_device_cpuset()</a>.</p>
+<dl class="section note"><dt>Note</dt><dd>This function cannot work if PCI devices are filtered out.</dd>
+<dd>
+The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out). </dd></dl>
+
+</div>
+</div>
+<a id="gae39352d124cb330eb37b84b418ed6cc5" name="gae39352d124cb330eb37b84b418ed6cc5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gae39352d124cb330eb37b84b418ed6cc5">&#9670;&#160;</a></span>hwloc_opencl_get_device_osdev_by_index()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_opencl_get_device_osdev_by_index </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>platform_index</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>device_index</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to the OpenCL device for the given indexes. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object describing the OpenCL device whose platform index is <code>platform_index</code>, and whose device index within this platform if <code>device_index</code>. </dd>
+<dd>
+<code>NULL</code> if there is none.</dd></dl>
+<p>The topology <code>topology</code> does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the OpenCL component must be enabled in the topology.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out). </dd></dl>
+
+</div>
+</div>
+<a id="gab89e4d20f8a353299351b41849e35ac9" name="gab89e4d20f8a353299351b41849e35ac9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab89e4d20f8a353299351b41849e35ac9">&#9670;&#160;</a></span>hwloc_opencl_get_device_pci_busid()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_opencl_get_device_pci_busid </td>
+          <td>(</td>
+          <td class="paramtype">cl_device_id&#160;</td>
+          <td class="paramname"><em>device</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>domain</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>bus</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>dev</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>func</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Return the domain, bus and device IDs of the OpenCL device <code>device</code>. </p>
+<p>Device <code>device</code> must match the local machine.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if device information could not be found. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00210.html 2.11.0-1/doc/doxygen-doc/html/a00210.html
--- 2.10.0-1/doc/doxygen-doc/html/a00210.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00210.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,313 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability with the CUDA Driver API</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Interoperability with the CUDA Driver API</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga1084285e8ff8b7df91c28917637481c6" id="r_ga1084285e8ff8b7df91c28917637481c6"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00210.html#ga1084285e8ff8b7df91c28917637481c6">hwloc_cuda_get_device_pci_ids</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, CUdevice cudevice, int *domain, int *bus, int *dev)</td></tr>
+<tr class="separator:ga1084285e8ff8b7df91c28917637481c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaec41c6b4dc3361156beb7dea2a74f5a3" id="r_gaec41c6b4dc3361156beb7dea2a74f5a3"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00210.html#gaec41c6b4dc3361156beb7dea2a74f5a3">hwloc_cuda_get_device_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, CUdevice cudevice, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</td></tr>
+<tr class="separator:gaec41c6b4dc3361156beb7dea2a74f5a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga11fed607fa404e29e8da010f3ec128e4" id="r_ga11fed607fa404e29e8da010f3ec128e4"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00210.html#ga11fed607fa404e29e8da010f3ec128e4">hwloc_cuda_get_device_pcidev</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, CUdevice cudevice)</td></tr>
+<tr class="separator:ga11fed607fa404e29e8da010f3ec128e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga252cb72175f1a2d682f883a0add80a66" id="r_ga252cb72175f1a2d682f883a0add80a66"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00210.html#ga252cb72175f1a2d682f883a0add80a66">hwloc_cuda_get_device_osdev</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, CUdevice cudevice)</td></tr>
+<tr class="separator:ga252cb72175f1a2d682f883a0add80a66"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga12ee892994ed037e8f64bbffda02cf2e" id="r_ga12ee892994ed037e8f64bbffda02cf2e"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00210.html#ga12ee892994ed037e8f64bbffda02cf2e">hwloc_cuda_get_device_osdev_by_index</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned idx)</td></tr>
+<tr class="separator:ga12ee892994ed037e8f64bbffda02cf2e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This interface offers ways to retrieve topology information about CUDA devices when using the CUDA Driver API. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gaec41c6b4dc3361156beb7dea2a74f5a3" name="gaec41c6b4dc3361156beb7dea2a74f5a3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaec41c6b4dc3361156beb7dea2a74f5a3">&#9670;&#160;</a></span>hwloc_cuda_get_device_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_cuda_get_device_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">CUdevice&#160;</td>
+          <td class="paramname"><em>cudevice</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the CPU set of processors that are physically close to device <code>cudevice</code>. </p>
+<p>Store in <code>set</code> the CPU-set describing the locality of the CUDA device <code>cudevice</code>.</p>
+<p>Topology <code>topology</code> and device <code>cudevice</code> must match the local machine. I/O devices detection and the CUDA component are not needed in the topology.</p>
+<p>The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see <a class="el" href="a00210.html#ga252cb72175f1a2d682f883a0add80a66" title="Get the hwloc OS device object corresponding to CUDA device cudevice.">hwloc_cuda_get_device_osdev()</a> and <a class="el" href="a00210.html#ga12ee892994ed037e8f64bbffda02cf2e" title="Get the hwloc OS device object corresponding to the CUDA device whose index is idx.">hwloc_cuda_get_device_osdev_by_index()</a>.</p>
+<p>This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if device information could not be found. </dd></dl>
+
+</div>
+</div>
+<a id="ga252cb72175f1a2d682f883a0add80a66" name="ga252cb72175f1a2d682f883a0add80a66"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga252cb72175f1a2d682f883a0add80a66">&#9670;&#160;</a></span>hwloc_cuda_get_device_osdev()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_cuda_get_device_osdev </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">CUdevice&#160;</td>
+          <td class="paramname"><em>cudevice</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to CUDA device <code>cudevice</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object that describes the given CUDA device <code>cudevice</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>Topology <code>topology</code> and device <code>cudevice</code> must match the local machine. I/O devices detection and the CUDA component must be enabled in the topology. If not, the locality of the object may still be found using <a class="el" href="a00210.html#gaec41c6b4dc3361156beb7dea2a74f5a3" title="Get the CPU set of processors that are physically close to device cudevice.">hwloc_cuda_get_device_cpuset()</a>.</p>
+<dl class="section note"><dt>Note</dt><dd>This function cannot work if PCI devices are filtered out.</dd>
+<dd>
+The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out). </dd></dl>
+
+</div>
+</div>
+<a id="ga12ee892994ed037e8f64bbffda02cf2e" name="ga12ee892994ed037e8f64bbffda02cf2e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga12ee892994ed037e8f64bbffda02cf2e">&#9670;&#160;</a></span>hwloc_cuda_get_device_osdev_by_index()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_cuda_get_device_osdev_by_index </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>idx</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to the CUDA device whose index is <code>idx</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object describing the CUDA device whose index is <code>idx</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>The topology <code>topology</code> does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the CUDA component must be enabled in the topology.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out).</dd>
+<dd>
+This function is identical to <a class="el" href="a00211.html#gac0f3eeaf7712919f298097b1a21307b0" title="Get the hwloc OS device object corresponding to the CUDA device whose index is idx.">hwloc_cudart_get_device_osdev_by_index()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="ga1084285e8ff8b7df91c28917637481c6" name="ga1084285e8ff8b7df91c28917637481c6"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1084285e8ff8b7df91c28917637481c6">&#9670;&#160;</a></span>hwloc_cuda_get_device_pci_ids()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_cuda_get_device_pci_ids </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">CUdevice&#160;</td>
+          <td class="paramname"><em>cudevice</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int *&#160;</td>
+          <td class="paramname"><em>domain</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int *&#160;</td>
+          <td class="paramname"><em>bus</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int *&#160;</td>
+          <td class="paramname"><em>dev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Return the domain, bus and device IDs of the CUDA device <code>cudevice</code>. </p>
+<p>Device <code>cudevice</code> must match the local machine.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if device information could not be found. </dd></dl>
+
+</div>
+</div>
+<a id="ga11fed607fa404e29e8da010f3ec128e4" name="ga11fed607fa404e29e8da010f3ec128e4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga11fed607fa404e29e8da010f3ec128e4">&#9670;&#160;</a></span>hwloc_cuda_get_device_pcidev()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_cuda_get_device_pcidev </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">CUdevice&#160;</td>
+          <td class="paramname"><em>cudevice</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc PCI device object corresponding to the CUDA device <code>cudevice</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc PCI device object describing the CUDA device <code>cudevice</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>Topology <code>topology</code> and device <code>cudevice</code> must match the local machine. I/O devices detection must be enabled in topology <code>topology</code>. The CUDA component is not needed in the topology. </p>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00211.html 2.11.0-1/doc/doxygen-doc/html/a00211.html
--- 2.10.0-1/doc/doxygen-doc/html/a00211.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00211.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,266 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability with the CUDA Runtime API</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Interoperability with the CUDA Runtime API</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gad8b701d9a34923e34bd58defd4c1e704" id="r_gad8b701d9a34923e34bd58defd4c1e704"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00211.html#gad8b701d9a34923e34bd58defd4c1e704">hwloc_cudart_get_device_pci_ids</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int idx, int *domain, int *bus, int *dev)</td></tr>
+<tr class="separator:gad8b701d9a34923e34bd58defd4c1e704"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga187ca00c6e12800a25151ce331620980" id="r_ga187ca00c6e12800a25151ce331620980"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00211.html#ga187ca00c6e12800a25151ce331620980">hwloc_cudart_get_device_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int idx, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</td></tr>
+<tr class="separator:ga187ca00c6e12800a25151ce331620980"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaeda4e6efbb36b518b2c286434ad23bb2" id="r_gaeda4e6efbb36b518b2c286434ad23bb2"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00211.html#gaeda4e6efbb36b518b2c286434ad23bb2">hwloc_cudart_get_device_pcidev</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int idx)</td></tr>
+<tr class="separator:gaeda4e6efbb36b518b2c286434ad23bb2"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac0f3eeaf7712919f298097b1a21307b0" id="r_gac0f3eeaf7712919f298097b1a21307b0"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00211.html#gac0f3eeaf7712919f298097b1a21307b0">hwloc_cudart_get_device_osdev_by_index</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned idx)</td></tr>
+<tr class="separator:gac0f3eeaf7712919f298097b1a21307b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This interface offers ways to retrieve topology information about CUDA devices when using the CUDA Runtime API. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga187ca00c6e12800a25151ce331620980" name="ga187ca00c6e12800a25151ce331620980"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga187ca00c6e12800a25151ce331620980">&#9670;&#160;</a></span>hwloc_cudart_get_device_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_cudart_get_device_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>idx</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the CPU set of processors that are physically close to device <code>idx</code>. </p>
+<p>Store in <code>set</code> the CPU-set describing the locality of the CUDA device whose index is <code>idx</code>.</p>
+<p>Topology <code>topology</code> and device <code>idx</code> must match the local machine. I/O devices detection and the CUDA component are not needed in the topology.</p>
+<p>The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see <a class="el" href="a00211.html#gac0f3eeaf7712919f298097b1a21307b0" title="Get the hwloc OS device object corresponding to the CUDA device whose index is idx.">hwloc_cudart_get_device_osdev_by_index()</a>.</p>
+<p>This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if device information could not be found. </dd></dl>
+
+</div>
+</div>
+<a id="gac0f3eeaf7712919f298097b1a21307b0" name="gac0f3eeaf7712919f298097b1a21307b0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac0f3eeaf7712919f298097b1a21307b0">&#9670;&#160;</a></span>hwloc_cudart_get_device_osdev_by_index()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_cudart_get_device_osdev_by_index </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>idx</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to the CUDA device whose index is <code>idx</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object describing the CUDA device whose index is <code>idx</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>The topology <code>topology</code> does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the CUDA component must be enabled in the topology. If not, the locality of the object may still be found using <a class="el" href="a00211.html#ga187ca00c6e12800a25151ce331620980" title="Get the CPU set of processors that are physically close to device idx.">hwloc_cudart_get_device_cpuset()</a>.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out).</dd>
+<dd>
+This function is identical to <a class="el" href="a00210.html#ga12ee892994ed037e8f64bbffda02cf2e" title="Get the hwloc OS device object corresponding to the CUDA device whose index is idx.">hwloc_cuda_get_device_osdev_by_index()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="gad8b701d9a34923e34bd58defd4c1e704" name="gad8b701d9a34923e34bd58defd4c1e704"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad8b701d9a34923e34bd58defd4c1e704">&#9670;&#160;</a></span>hwloc_cudart_get_device_pci_ids()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_cudart_get_device_pci_ids </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>idx</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int *&#160;</td>
+          <td class="paramname"><em>domain</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int *&#160;</td>
+          <td class="paramname"><em>bus</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int *&#160;</td>
+          <td class="paramname"><em>dev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Return the domain, bus and device IDs of the CUDA device whose index is <code>idx</code>. </p>
+<p>Device index <code>idx</code> must match the local machine.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if device information could not be found. </dd></dl>
+
+</div>
+</div>
+<a id="gaeda4e6efbb36b518b2c286434ad23bb2" name="gaeda4e6efbb36b518b2c286434ad23bb2"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaeda4e6efbb36b518b2c286434ad23bb2">&#9670;&#160;</a></span>hwloc_cudart_get_device_pcidev()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_cudart_get_device_pcidev </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>idx</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc PCI device object corresponding to the CUDA device whose index is <code>idx</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc PCI device object describing the CUDA device whose index is <code>idx</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>Topology <code>topology</code> and device <code>idx</code> must match the local machine. I/O devices detection must be enabled in topology <code>topology</code>. The CUDA component is not needed in the topology. </p>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00212.html 2.11.0-1/doc/doxygen-doc/html/a00212.html
--- 2.10.0-1/doc/doxygen-doc/html/a00212.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00212.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,203 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability with the NVIDIA Management Library</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Interoperability with the NVIDIA Management Library</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga26cf0036d09ec4d7cb692380fac9659d" id="r_ga26cf0036d09ec4d7cb692380fac9659d"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00212.html#ga26cf0036d09ec4d7cb692380fac9659d">hwloc_nvml_get_device_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, nvmlDevice_t device, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</td></tr>
+<tr class="separator:ga26cf0036d09ec4d7cb692380fac9659d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gacd50fd0e2766ee05bc13234b46714756" id="r_gacd50fd0e2766ee05bc13234b46714756"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00212.html#gacd50fd0e2766ee05bc13234b46714756">hwloc_nvml_get_device_osdev_by_index</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned idx)</td></tr>
+<tr class="separator:gacd50fd0e2766ee05bc13234b46714756"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaf176159b5760a191871eff23f5a69ee9" id="r_gaf176159b5760a191871eff23f5a69ee9"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00212.html#gaf176159b5760a191871eff23f5a69ee9">hwloc_nvml_get_device_osdev</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, nvmlDevice_t device)</td></tr>
+<tr class="separator:gaf176159b5760a191871eff23f5a69ee9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This interface offers ways to retrieve topology information about devices managed by the NVIDIA Management Library (NVML). </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga26cf0036d09ec4d7cb692380fac9659d" name="ga26cf0036d09ec4d7cb692380fac9659d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga26cf0036d09ec4d7cb692380fac9659d">&#9670;&#160;</a></span>hwloc_nvml_get_device_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_nvml_get_device_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">nvmlDevice_t&#160;</td>
+          <td class="paramname"><em>device</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the CPU set of processors that are physically close to NVML device <code>device</code>. </p>
+<p>Store in <code>set</code> the CPU-set describing the locality of the NVML device <code>device</code>.</p>
+<p>Topology <code>topology</code> and device <code>device</code> must match the local machine. I/O devices detection and the NVML component are not needed in the topology.</p>
+<p>The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see <a class="el" href="a00212.html#gaf176159b5760a191871eff23f5a69ee9" title="Get the hwloc OS device object corresponding to NVML device device.">hwloc_nvml_get_device_osdev()</a> and <a class="el" href="a00212.html#gacd50fd0e2766ee05bc13234b46714756" title="Get the hwloc OS device object corresponding to the NVML device whose index is idx.">hwloc_nvml_get_device_osdev_by_index()</a>.</p>
+<p>This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if device information could not be found. </dd></dl>
+
+</div>
+</div>
+<a id="gaf176159b5760a191871eff23f5a69ee9" name="gaf176159b5760a191871eff23f5a69ee9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf176159b5760a191871eff23f5a69ee9">&#9670;&#160;</a></span>hwloc_nvml_get_device_osdev()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_nvml_get_device_osdev </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">nvmlDevice_t&#160;</td>
+          <td class="paramname"><em>device</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to NVML device <code>device</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object that describes the given NVML device <code>device</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>Topology <code>topology</code> and device <code>device</code> must match the local machine. I/O devices detection and the NVML component must be enabled in the topology. If not, the locality of the object may still be found using <a class="el" href="a00212.html#ga26cf0036d09ec4d7cb692380fac9659d" title="Get the CPU set of processors that are physically close to NVML device device.">hwloc_nvml_get_device_cpuset()</a>.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out). </dd></dl>
+
+</div>
+</div>
+<a id="gacd50fd0e2766ee05bc13234b46714756" name="gacd50fd0e2766ee05bc13234b46714756"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gacd50fd0e2766ee05bc13234b46714756">&#9670;&#160;</a></span>hwloc_nvml_get_device_osdev_by_index()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_nvml_get_device_osdev_by_index </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>idx</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to the NVML device whose index is <code>idx</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object describing the NVML device whose index is <code>idx</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>The topology <code>topology</code> does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the NVML component must be enabled in the topology.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out). </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00213.html 2.11.0-1/doc/doxygen-doc/html/a00213.html
--- 2.10.0-1/doc/doxygen-doc/html/a00213.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00213.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,203 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability with the ROCm SMI Management Library</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Interoperability with the ROCm SMI Management Library</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gaf939e697e3769c3524255318262b9c29" id="r_gaf939e697e3769c3524255318262b9c29"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00213.html#gaf939e697e3769c3524255318262b9c29">hwloc_rsmi_get_device_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, uint32_t dv_ind, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</td></tr>
+<tr class="separator:gaf939e697e3769c3524255318262b9c29"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga507d0acdd5e9ac374a8d120d59604c80" id="r_ga507d0acdd5e9ac374a8d120d59604c80"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00213.html#ga507d0acdd5e9ac374a8d120d59604c80">hwloc_rsmi_get_device_osdev_by_index</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, uint32_t dv_ind)</td></tr>
+<tr class="separator:ga507d0acdd5e9ac374a8d120d59604c80"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaba05bf9710655bb5b1439bee654340ba" id="r_gaba05bf9710655bb5b1439bee654340ba"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00213.html#gaba05bf9710655bb5b1439bee654340ba">hwloc_rsmi_get_device_osdev</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, uint32_t dv_ind)</td></tr>
+<tr class="separator:gaba05bf9710655bb5b1439bee654340ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This interface offers ways to retrieve topology information about devices managed by the ROCm SMI Management Library. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gaf939e697e3769c3524255318262b9c29" name="gaf939e697e3769c3524255318262b9c29"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf939e697e3769c3524255318262b9c29">&#9670;&#160;</a></span>hwloc_rsmi_get_device_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_rsmi_get_device_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">uint32_t&#160;</td>
+          <td class="paramname"><em>dv_ind</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the CPU set of logical processors that are physically close to AMD GPU device whose index is <code>dv_ind</code>. </p>
+<p>Store in <code>set</code> the CPU-set describing the locality of the AMD GPU device whose index is <code>dv_ind</code>.</p>
+<p>Topology <code>topology</code> and device <code>dv_ind</code> must match the local machine. I/O devices detection and the ROCm SMI component are not needed in the topology.</p>
+<p>The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see <a class="el" href="a00213.html#gaba05bf9710655bb5b1439bee654340ba" title="Get the hwloc OS device object corresponding to AMD GPU device, whose index is dv_ind.">hwloc_rsmi_get_device_osdev()</a> and <a class="el" href="a00213.html#ga507d0acdd5e9ac374a8d120d59604c80" title="Get the hwloc OS device object corresponding to the AMD GPU device whose index is dv_ind.">hwloc_rsmi_get_device_osdev_by_index()</a>.</p>
+<p>This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if device information could not be found. </dd></dl>
+
+</div>
+</div>
+<a id="gaba05bf9710655bb5b1439bee654340ba" name="gaba05bf9710655bb5b1439bee654340ba"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaba05bf9710655bb5b1439bee654340ba">&#9670;&#160;</a></span>hwloc_rsmi_get_device_osdev()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_rsmi_get_device_osdev </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">uint32_t&#160;</td>
+          <td class="paramname"><em>dv_ind</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to AMD GPU device, whose index is <code>dv_ind</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object that describes the given AMD GPU, whose index is <code>dv_ind</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>Topology <code>topology</code> and device <code>dv_ind</code> must match the local machine. I/O devices detection and the ROCm SMI component must be enabled in the topology. If not, the locality of the object may still be found using <a class="el" href="a00213.html#gaf939e697e3769c3524255318262b9c29" title="Get the CPU set of logical processors that are physically close to AMD GPU device whose index is dv_i...">hwloc_rsmi_get_device_cpuset()</a>.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out). </dd></dl>
+
+</div>
+</div>
+<a id="ga507d0acdd5e9ac374a8d120d59604c80" name="ga507d0acdd5e9ac374a8d120d59604c80"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga507d0acdd5e9ac374a8d120d59604c80">&#9670;&#160;</a></span>hwloc_rsmi_get_device_osdev_by_index()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_rsmi_get_device_osdev_by_index </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">uint32_t&#160;</td>
+          <td class="paramname"><em>dv_ind</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to the AMD GPU device whose index is <code>dv_ind</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object describing the AMD GPU device whose index is <code>dv_ind</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>The topology <code>topology</code> does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the ROCm SMI component must be enabled in the topology.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out). </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00214.html 2.11.0-1/doc/doxygen-doc/html/a00214.html
--- 2.10.0-1/doc/doxygen-doc/html/a00214.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00214.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,158 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability with the oneAPI Level Zero interface.</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Interoperability with the oneAPI Level Zero interface.</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga66281a9ba621357b1c7070b4fa19b5b8" id="r_ga66281a9ba621357b1c7070b4fa19b5b8"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00214.html#ga66281a9ba621357b1c7070b4fa19b5b8">hwloc_levelzero_get_device_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, ze_device_handle_t device, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</td></tr>
+<tr class="separator:ga66281a9ba621357b1c7070b4fa19b5b8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaf06cb737abcd2dc6db894c8914302d85" id="r_gaf06cb737abcd2dc6db894c8914302d85"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00214.html#gaf06cb737abcd2dc6db894c8914302d85">hwloc_levelzero_get_device_osdev</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, ze_device_handle_t device)</td></tr>
+<tr class="separator:gaf06cb737abcd2dc6db894c8914302d85"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This interface offers ways to retrieve topology information about devices managed by the Level Zero API. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga66281a9ba621357b1c7070b4fa19b5b8" name="ga66281a9ba621357b1c7070b4fa19b5b8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga66281a9ba621357b1c7070b4fa19b5b8">&#9670;&#160;</a></span>hwloc_levelzero_get_device_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_levelzero_get_device_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">ze_device_handle_t&#160;</td>
+          <td class="paramname"><em>device</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the CPU set of logical processors that are physically close to the Level Zero device <code>device</code>. </p>
+<p>Store in <code>set</code> the CPU-set describing the locality of the Level Zero device <code>device</code>.</p>
+<p>Topology <code>topology</code> and device <code>device</code> must match the local machine. The Level Zero library must have been initialized with Sysman enabled (by calling zesInit(0) if supported, or by setting ZES_ENABLE_SYSMAN=1 in the environment). I/O devices detection and the Level Zero component are not needed in the topology.</p>
+<p>The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see <a class="el" href="a00214.html#gaf06cb737abcd2dc6db894c8914302d85" title="Get the hwloc OS device object corresponding to Level Zero device device.">hwloc_levelzero_get_device_osdev()</a>.</p>
+<p>This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if device information could not be found. </dd></dl>
+
+</div>
+</div>
+<a id="gaf06cb737abcd2dc6db894c8914302d85" name="gaf06cb737abcd2dc6db894c8914302d85"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaf06cb737abcd2dc6db894c8914302d85">&#9670;&#160;</a></span>hwloc_levelzero_get_device_osdev()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_levelzero_get_device_osdev </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">ze_device_handle_t&#160;</td>
+          <td class="paramname"><em>device</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to Level Zero device <code>device</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object that describes the given Level Zero device <code>device</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>Topology <code>topology</code> and device <code>dv_ind</code> must match the local machine. I/O devices detection and the Level Zero component must be enabled in the topology. If not, the locality of the object may still be found using <a class="el" href="a00214.html#ga66281a9ba621357b1c7070b4fa19b5b8" title="Get the CPU set of logical processors that are physically close to the Level Zero device device.">hwloc_levelzero_get_device_cpuset()</a>.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out). </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00215.html 2.11.0-1/doc/doxygen-doc/html/a00215.html
--- 2.10.0-1/doc/doxygen-doc/html/a00215.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00215.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,214 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability with OpenGL displays</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Interoperability with OpenGL displays</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga4d66a77e4fe4051d6e5b772c1b8fcec5" id="r_ga4d66a77e4fe4051d6e5b772c1b8fcec5"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00215.html#ga4d66a77e4fe4051d6e5b772c1b8fcec5">hwloc_gl_get_display_osdev_by_port_device</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned port, unsigned device)</td></tr>
+<tr class="separator:ga4d66a77e4fe4051d6e5b772c1b8fcec5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga2d36ef441d1dfddf49cfb5c01bd58d8e" id="r_ga2d36ef441d1dfddf49cfb5c01bd58d8e"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00215.html#ga2d36ef441d1dfddf49cfb5c01bd58d8e">hwloc_gl_get_display_osdev_by_name</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const char *name)</td></tr>
+<tr class="separator:ga2d36ef441d1dfddf49cfb5c01bd58d8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga936665ab5f0d29a081c4b78d11f4ad07" id="r_ga936665ab5f0d29a081c4b78d11f4ad07"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00215.html#ga936665ab5f0d29a081c4b78d11f4ad07">hwloc_gl_get_display_by_osdev</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> osdev, unsigned *port, unsigned *device)</td></tr>
+<tr class="separator:ga936665ab5f0d29a081c4b78d11f4ad07"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This interface offers ways to retrieve topology information about OpenGL displays.</p>
+<p>Only the NVIDIA display locality information is currently available, using the NV-CONTROL X11 extension and the NVCtrl library. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga936665ab5f0d29a081c4b78d11f4ad07" name="ga936665ab5f0d29a081c4b78d11f4ad07"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga936665ab5f0d29a081c4b78d11f4ad07">&#9670;&#160;</a></span>hwloc_gl_get_display_by_osdev()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_gl_get_display_by_osdev </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>osdev</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>port</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>device</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the OpenGL display port and device corresponding to the given hwloc OS object. </p>
+<p>Retrieves the OpenGL display port (server) in <code>port</code> and device (screen) in <code>screen</code> that correspond to the given hwloc OS device object.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 if none could be found.</dd></dl>
+<p>The topology <code>topology</code> does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the GL component must be enabled in the topology. </p>
+
+</div>
+</div>
+<a id="ga2d36ef441d1dfddf49cfb5c01bd58d8e" name="ga2d36ef441d1dfddf49cfb5c01bd58d8e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga2d36ef441d1dfddf49cfb5c01bd58d8e">&#9670;&#160;</a></span>hwloc_gl_get_display_osdev_by_name()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_gl_get_display_osdev_by_name </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>name</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to the OpenGL display given by name. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object describing the OpenGL display whose name is <code>name</code>, built as ":port.device" such as ":0.0" . </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>The topology <code>topology</code> does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the GL component must be enabled in the topology.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out). </dd></dl>
+
+</div>
+</div>
+<a id="ga4d66a77e4fe4051d6e5b772c1b8fcec5" name="ga4d66a77e4fe4051d6e5b772c1b8fcec5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga4d66a77e4fe4051d6e5b772c1b8fcec5">&#9670;&#160;</a></span>hwloc_gl_get_display_osdev_by_port_device()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_gl_get_display_osdev_by_port_device </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>port</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>device</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to the OpenGL display given by port and device index. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object describing the OpenGL display whose port (server) is <code>port</code> and device (screen) is <code>device</code>. </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>The topology <code>topology</code> does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the GL component must be enabled in the topology.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out). </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00216.html 2.11.0-1/doc/doxygen-doc/html/a00216.html
--- 2.10.0-1/doc/doxygen-doc/html/a00216.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00216.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,204 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability with OpenFabrics</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Interoperability with OpenFabrics</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga3ea0d838c1e7f1671b35687aae2da6ae" id="r_ga3ea0d838c1e7f1671b35687aae2da6ae"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00216.html#ga3ea0d838c1e7f1671b35687aae2da6ae">hwloc_ibv_get_device_cpuset</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, struct ibv_device *ibdev, <a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> set)</td></tr>
+<tr class="separator:ga3ea0d838c1e7f1671b35687aae2da6ae"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga31d794567f4420bbdc8baa7bf8bf6138" id="r_ga31d794567f4420bbdc8baa7bf8bf6138"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00216.html#ga31d794567f4420bbdc8baa7bf8bf6138">hwloc_ibv_get_device_osdev_by_name</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const char *ibname)</td></tr>
+<tr class="separator:ga31d794567f4420bbdc8baa7bf8bf6138"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga7324cdfd5db6ed2669c051ef7e1b64e1" id="r_ga7324cdfd5db6ed2669c051ef7e1b64e1"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00216.html#ga7324cdfd5db6ed2669c051ef7e1b64e1">hwloc_ibv_get_device_osdev</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, struct ibv_device *ibdev)</td></tr>
+<tr class="separator:ga7324cdfd5db6ed2669c051ef7e1b64e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>This interface offers ways to retrieve topology information about OpenFabrics devices (InfiniBand, Omni-Path, usNIC, etc). </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga3ea0d838c1e7f1671b35687aae2da6ae" name="ga3ea0d838c1e7f1671b35687aae2da6ae"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga3ea0d838c1e7f1671b35687aae2da6ae">&#9670;&#160;</a></span>hwloc_ibv_get_device_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_ibv_get_device_cpuset </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct ibv_device *&#160;</td>
+          <td class="paramname"><em>ibdev</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td>
+          <td class="paramname"><em>set</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the CPU set of processors that are physically close to device <code>ibdev</code>. </p>
+<p>Store in <code>set</code> the CPU-set describing the locality of the OpenFabrics device <code>ibdev</code> (InfiniBand, etc).</p>
+<p>Topology <code>topology</code> and device <code>ibdev</code> must match the local machine. I/O devices detection is not needed in the topology.</p>
+<p>The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see <a class="el" href="a00216.html#ga7324cdfd5db6ed2669c051ef7e1b64e1" title="Get the hwloc OS device object corresponding to the OpenFabrics device ibdev.">hwloc_ibv_get_device_osdev()</a> and <a class="el" href="a00216.html#ga31d794567f4420bbdc8baa7bf8bf6138" title="Get the hwloc OS device object corresponding to the OpenFabrics device named ibname.">hwloc_ibv_get_device_osdev_by_name()</a>.</p>
+<p>This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 on error, for instance if device information could not be found. </dd></dl>
+
+</div>
+</div>
+<a id="ga7324cdfd5db6ed2669c051ef7e1b64e1" name="ga7324cdfd5db6ed2669c051ef7e1b64e1"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga7324cdfd5db6ed2669c051ef7e1b64e1">&#9670;&#160;</a></span>hwloc_ibv_get_device_osdev()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_ibv_get_device_osdev </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct ibv_device *&#160;</td>
+          <td class="paramname"><em>ibdev</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to the OpenFabrics device <code>ibdev</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object describing the OpenFabrics device <code>ibdev</code> (InfiniBand, etc). </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>Topology <code>topology</code> and device <code>ibdev</code> must match the local machine. I/O devices detection must be enabled in the topology. If not, the locality of the object may still be found using <a class="el" href="a00216.html#ga3ea0d838c1e7f1671b35687aae2da6ae" title="Get the CPU set of processors that are physically close to device ibdev.">hwloc_ibv_get_device_cpuset()</a>.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding PCI device object can be obtained by looking at the OS device parent object. </dd></dl>
+
+</div>
+</div>
+<a id="ga31d794567f4420bbdc8baa7bf8bf6138" name="ga31d794567f4420bbdc8baa7bf8bf6138"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga31d794567f4420bbdc8baa7bf8bf6138">&#9670;&#160;</a></span>hwloc_ibv_get_device_osdev_by_name()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_ibv_get_device_osdev_by_name </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>ibname</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Get the hwloc OS device object corresponding to the OpenFabrics device named <code>ibname</code>. </p>
+<dl class="section return"><dt>Returns</dt><dd>The hwloc OS device object describing the OpenFabrics device (InfiniBand, Omni-Path, usNIC, etc) whose name is <code>ibname</code> (mlx5_0, hfi1_0, usnic_0, qib0, etc). </dd>
+<dd>
+<code>NULL</code> if none could be found.</dd></dl>
+<p>The name <code>ibname</code> is usually obtained from ibv_get_device_name().</p>
+<p>The topology <code>topology</code> does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection must be enabled in the topology.</p>
+<dl class="section note"><dt>Note</dt><dd>The corresponding PCI device object can be obtained by looking at the OS device parent object. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00217.html 2.11.0-1/doc/doxygen-doc/html/a00217.html
--- 2.10.0-1/doc/doxygen-doc/html/a00217.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00217.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,518 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Topology differences</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#typedef-members">Typedefs</a> &#124;
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Topology differences</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">union &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00329.html">hwloc_topology_diff_obj_attr_u</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">union &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00345.html">hwloc_topology_diff_u</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="typedef-members" name="typedef-members"></a>
+Typedefs</h2></td></tr>
+<tr class="memitem:ga74a3fefbaa17582fea86d76b312d6254" id="r_ga74a3fefbaa17582fea86d76b312d6254"><td class="memItemLeft" align="right" valign="top">typedef enum <a class="el" href="a00217.html#ga86f044210b0a9e9fa83acbdbbf7e05fd">hwloc_topology_diff_obj_attr_type_e</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a></td></tr>
+<tr class="separator:ga74a3fefbaa17582fea86d76b312d6254"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga8470f631b7365c839d3e40d38c5b6291" id="r_ga8470f631b7365c839d3e40d38c5b6291"><td class="memItemLeft" align="right" valign="top">typedef enum <a class="el" href="a00217.html#ga38b28b7423b85a3321e6d0062d5f83d0">hwloc_topology_diff_type_e</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a></td></tr>
+<tr class="separator:ga8470f631b7365c839d3e40d38c5b6291"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1bd6363f26f7961f83153aaa484a9b85" id="r_ga1bd6363f26f7961f83153aaa484a9b85"><td class="memItemLeft" align="right" valign="top">typedef union <a class="el" href="a00345.html">hwloc_topology_diff_u</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a></td></tr>
+<tr class="separator:ga1bd6363f26f7961f83153aaa484a9b85"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:ga86f044210b0a9e9fa83acbdbbf7e05fd" id="r_ga86f044210b0a9e9fa83acbdbbf7e05fd"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#ga86f044210b0a9e9fa83acbdbbf7e05fd">hwloc_topology_diff_obj_attr_type_e</a> { <a class="el" href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fdabc7f0c7ed0b6864e902f4b70f2c7bc94">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE</a>
+, <a class="el" href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fda94a8f37c51d62d15ac6192665dd49310">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME</a>
+, <a class="el" href="a00217.html#gga86f044210b0a9e9fa83acbdbbf7e05fda63430bf932434bc456282f636d39c2c2">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO</a>
+ }</td></tr>
+<tr class="separator:ga86f044210b0a9e9fa83acbdbbf7e05fd"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga38b28b7423b85a3321e6d0062d5f83d0" id="r_ga38b28b7423b85a3321e6d0062d5f83d0"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#ga38b28b7423b85a3321e6d0062d5f83d0">hwloc_topology_diff_type_e</a> { <a class="el" href="a00217.html#gga38b28b7423b85a3321e6d0062d5f83d0accbcaee230f79989debb284c8626f0c0">HWLOC_TOPOLOGY_DIFF_OBJ_ATTR</a>
+, <a class="el" href="a00217.html#gga38b28b7423b85a3321e6d0062d5f83d0a3dc01fdeff355efe3fb2516bb454a147">HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX</a>
+ }</td></tr>
+<tr class="separator:ga38b28b7423b85a3321e6d0062d5f83d0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gada4c1273ce020afaf02b649496f7edf5" id="r_gada4c1273ce020afaf02b649496f7edf5"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#gada4c1273ce020afaf02b649496f7edf5">hwloc_topology_diff_apply_flags_e</a> { <a class="el" href="a00217.html#ggada4c1273ce020afaf02b649496f7edf5a821a160512d67ea0dd05dab873d2fc54">HWLOC_TOPOLOGY_DIFF_APPLY_REVERSE</a>
+ }</td></tr>
+<tr class="separator:gada4c1273ce020afaf02b649496f7edf5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga8a1754f69fbb31364ea3ea2c39827c9f" id="r_ga8a1754f69fbb31364ea3ea2c39827c9f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#ga8a1754f69fbb31364ea3ea2c39827c9f">hwloc_topology_diff_build</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> newtopology, unsigned long flags, <a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a> *diff)</td></tr>
+<tr class="separator:ga8a1754f69fbb31364ea3ea2c39827c9f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gae7b350d7e7478a4c6047b08aa6544f40" id="r_gae7b350d7e7478a4c6047b08aa6544f40"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#gae7b350d7e7478a4c6047b08aa6544f40">hwloc_topology_diff_apply</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a> diff, unsigned long flags)</td></tr>
+<tr class="separator:gae7b350d7e7478a4c6047b08aa6544f40"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga5dcff18f80583ac6505a94ba2877fd1b" id="r_ga5dcff18f80583ac6505a94ba2877fd1b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#ga5dcff18f80583ac6505a94ba2877fd1b">hwloc_topology_diff_destroy</a> (<a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a> diff)</td></tr>
+<tr class="separator:ga5dcff18f80583ac6505a94ba2877fd1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga2cd902ce8766e90d4f2523a8e87640e9" id="r_ga2cd902ce8766e90d4f2523a8e87640e9"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#ga2cd902ce8766e90d4f2523a8e87640e9">hwloc_topology_diff_load_xml</a> (const char *xmlpath, <a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a> *diff, char **refname)</td></tr>
+<tr class="separator:ga2cd902ce8766e90d4f2523a8e87640e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga8a14dd7d01efbdd97af7fe85e8b84b20" id="r_ga8a14dd7d01efbdd97af7fe85e8b84b20"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#ga8a14dd7d01efbdd97af7fe85e8b84b20">hwloc_topology_diff_export_xml</a> (<a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a> diff, const char *refname, const char *xmlpath)</td></tr>
+<tr class="separator:ga8a14dd7d01efbdd97af7fe85e8b84b20"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gad693810a5c51628529b9dd56f040fb81" id="r_gad693810a5c51628529b9dd56f040fb81"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#gad693810a5c51628529b9dd56f040fb81">hwloc_topology_diff_load_xmlbuffer</a> (const char *xmlbuffer, int buflen, <a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a> *diff, char **refname)</td></tr>
+<tr class="separator:gad693810a5c51628529b9dd56f040fb81"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa2f0918df60c1c4a0bef9411f7d92a13" id="r_gaa2f0918df60c1c4a0bef9411f7d92a13"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00217.html#gaa2f0918df60c1c4a0bef9411f7d92a13">hwloc_topology_diff_export_xmlbuffer</a> (<a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a> diff, const char *refname, char **xmlbuffer, int *buflen)</td></tr>
+<tr class="separator:gaa2f0918df60c1c4a0bef9411f7d92a13"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>Applications that manipulate many similar topologies, for instance one for each node of a homogeneous cluster, may want to compress topologies to reduce the memory footprint.</p>
+<p>This file offers a way to manipulate the difference between topologies and export/import it to/from XML. Compression may therefore be achieved by storing one topology entirely while the others are only described by their differences with the former. The actual topology can be reconstructed when actually needed by applying the precomputed difference to the reference topology.</p>
+<p>This interface targets very similar nodes. Only very simple differences between topologies are actually supported, for instance a change in the memory size, the name of the object, or some info attribute. More complex differences such as adding or removing objects cannot be represented in the difference structures and therefore return errors. Differences between object sets or topology-wide allowed sets, cannot be represented either.</p>
+<p>It means that there is no need to apply the difference when looking at the tree organization (how many levels, how many objects per level, what kind of objects, CPU and node sets, etc) and when binding to objects. However the difference must be applied when looking at object attributes such as the name, the memory size or info attributes. </p>
+<h2 class="groupheader">Typedef Documentation</h2>
+<a id="ga74a3fefbaa17582fea86d76b312d6254" name="ga74a3fefbaa17582fea86d76b312d6254"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga74a3fefbaa17582fea86d76b312d6254">&#9670;&#160;</a></span>hwloc_topology_diff_obj_attr_type_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef enum <a class="el" href="a00217.html#ga86f044210b0a9e9fa83acbdbbf7e05fd">hwloc_topology_diff_obj_attr_type_e</a> <a class="el" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of one object attribute difference. </p>
+
+</div>
+</div>
+<a id="ga1bd6363f26f7961f83153aaa484a9b85" name="ga1bd6363f26f7961f83153aaa484a9b85"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1bd6363f26f7961f83153aaa484a9b85">&#9670;&#160;</a></span>hwloc_topology_diff_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef union <a class="el" href="a00345.html">hwloc_topology_diff_u</a> * <a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>One element of a difference list between two topologies. </p>
+
+</div>
+</div>
+<a id="ga8470f631b7365c839d3e40d38c5b6291" name="ga8470f631b7365c839d3e40d38c5b6291"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8470f631b7365c839d3e40d38c5b6291">&#9670;&#160;</a></span>hwloc_topology_diff_type_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef enum <a class="el" href="a00217.html#ga38b28b7423b85a3321e6d0062d5f83d0">hwloc_topology_diff_type_e</a> <a class="el" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of one element of a difference list. </p>
+
+</div>
+</div>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="gada4c1273ce020afaf02b649496f7edf5" name="gada4c1273ce020afaf02b649496f7edf5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gada4c1273ce020afaf02b649496f7edf5">&#9670;&#160;</a></span>hwloc_topology_diff_apply_flags_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00217.html#gada4c1273ce020afaf02b649496f7edf5">hwloc_topology_diff_apply_flags_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Flags to be given to <a class="el" href="a00217.html#gae7b350d7e7478a4c6047b08aa6544f40" title="Apply a topology diff to an existing topology.">hwloc_topology_diff_apply()</a>. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ggada4c1273ce020afaf02b649496f7edf5a821a160512d67ea0dd05dab873d2fc54" name="ggada4c1273ce020afaf02b649496f7edf5a821a160512d67ea0dd05dab873d2fc54"></a>HWLOC_TOPOLOGY_DIFF_APPLY_REVERSE&#160;</td><td class="fielddoc"><p>Apply topology diff in reverse direction. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="ga86f044210b0a9e9fa83acbdbbf7e05fd" name="ga86f044210b0a9e9fa83acbdbbf7e05fd"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga86f044210b0a9e9fa83acbdbbf7e05fd">&#9670;&#160;</a></span>hwloc_topology_diff_obj_attr_type_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00217.html#ga86f044210b0a9e9fa83acbdbbf7e05fd">hwloc_topology_diff_obj_attr_type_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of one object attribute difference. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga86f044210b0a9e9fa83acbdbbf7e05fdabc7f0c7ed0b6864e902f4b70f2c7bc94" name="gga86f044210b0a9e9fa83acbdbbf7e05fdabc7f0c7ed0b6864e902f4b70f2c7bc94"></a>HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE&#160;</td><td class="fielddoc"><p>The object local memory is modified. The union is a <a class="el" href="a00337.html" title="Integer attribute modification with an optional index.">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a> (and the index field is ignored). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga86f044210b0a9e9fa83acbdbbf7e05fda94a8f37c51d62d15ac6192665dd49310" name="gga86f044210b0a9e9fa83acbdbbf7e05fda94a8f37c51d62d15ac6192665dd49310"></a>HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME&#160;</td><td class="fielddoc"><p>The object name is modified. The union is a <a class="el" href="a00341.html" title="String attribute modification with an optional name.">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a> (and the name field is ignored). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga86f044210b0a9e9fa83acbdbbf7e05fda63430bf932434bc456282f636d39c2c2" name="gga86f044210b0a9e9fa83acbdbbf7e05fda63430bf932434bc456282f636d39c2c2"></a>HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO&#160;</td><td class="fielddoc"><p>the value of an info attribute is modified. The union is a <a class="el" href="a00341.html" title="String attribute modification with an optional name.">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a>. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="ga38b28b7423b85a3321e6d0062d5f83d0" name="ga38b28b7423b85a3321e6d0062d5f83d0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga38b28b7423b85a3321e6d0062d5f83d0">&#9670;&#160;</a></span>hwloc_topology_diff_type_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00217.html#ga38b28b7423b85a3321e6d0062d5f83d0">hwloc_topology_diff_type_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of one element of a difference list. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga38b28b7423b85a3321e6d0062d5f83d0accbcaee230f79989debb284c8626f0c0" name="gga38b28b7423b85a3321e6d0062d5f83d0accbcaee230f79989debb284c8626f0c0"></a>HWLOC_TOPOLOGY_DIFF_OBJ_ATTR&#160;</td><td class="fielddoc"><p>An object attribute was changed. The union is a <a class="el" href="a00353.html">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga38b28b7423b85a3321e6d0062d5f83d0a3dc01fdeff355efe3fb2516bb454a147" name="gga38b28b7423b85a3321e6d0062d5f83d0a3dc01fdeff355efe3fb2516bb454a147"></a>HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX&#160;</td><td class="fielddoc"><p>The difference is too complex, it cannot be represented. The difference below this object has not been checked. <a class="el" href="a00217.html#ga8a1754f69fbb31364ea3ea2c39827c9f" title="Compute the difference between 2 topologies.">hwloc_topology_diff_build()</a> will return 1. </p>
+<p>The union is a <a class="el" href="a00357.html">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a>. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="gae7b350d7e7478a4c6047b08aa6544f40" name="gae7b350d7e7478a4c6047b08aa6544f40"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gae7b350d7e7478a4c6047b08aa6544f40">&#9670;&#160;</a></span>hwloc_topology_diff_apply()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_diff_apply </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a>&#160;</td>
+          <td class="paramname"><em>diff</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Apply a topology diff to an existing topology. </p>
+<p><code>flags</code> is an OR'ed set of <a class="el" href="a00217.html#gada4c1273ce020afaf02b649496f7edf5" title="Flags to be given to hwloc_topology_diff_apply().">hwloc_topology_diff_apply_flags_e</a>.</p>
+<p>The new topology is modified in place. <a class="el" href="a00175.html#ga62a161fc5e6f120344dc69a7bee4e587" title="Duplicate a topology.">hwloc_topology_dup()</a> may be used to duplicate it before patching.</p>
+<p>If the difference cannot be applied entirely, all previous applied elements are unapplied before returning.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success.</dd>
+<dd>
+-N if applying the difference failed while trying to apply the N-th part of the difference. For instance -1 is returned if the very first difference element could not be applied. </dd></dl>
+
+</div>
+</div>
+<a id="ga8a1754f69fbb31364ea3ea2c39827c9f" name="ga8a1754f69fbb31364ea3ea2c39827c9f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8a1754f69fbb31364ea3ea2c39827c9f">&#9670;&#160;</a></span>hwloc_topology_diff_build()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_diff_build </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>newtopology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a> *&#160;</td>
+          <td class="paramname"><em>diff</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Compute the difference between 2 topologies. </p>
+<p>The difference is stored as a list of <a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85" title="One element of a difference list between two topologies.">hwloc_topology_diff_t</a> entries starting at <code>diff</code>. It is computed by doing a depth-first traversal of both topology trees simultaneously.</p>
+<p>If the difference between 2 objects is too complex to be represented (for instance if some objects have different types, or different numbers of children), a special diff entry of type <a class="el" href="a00217.html#gga38b28b7423b85a3321e6d0062d5f83d0a3dc01fdeff355efe3fb2516bb454a147" title="The difference is too complex, it cannot be represented. The difference below this object has not bee...">HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX</a> is queued. The computation of the diff does not continue below these objects. So each such diff entry means that the difference between two subtrees could not be computed.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 if the difference can be represented properly.</dd>
+<dd>
+0 with <code>diff</code> pointing to NULL if there is no difference between the topologies.</dd>
+<dd>
+1 if the difference is too complex (see above). Some entries in the list will be of type <a class="el" href="a00217.html#gga38b28b7423b85a3321e6d0062d5f83d0a3dc01fdeff355efe3fb2516bb454a147" title="The difference is too complex, it cannot be represented. The difference below this object has not bee...">HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX</a>.</dd>
+<dd>
+-1 on any other error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd><code>flags</code> is currently not used. It should be 0.</dd>
+<dd>
+The output diff has to be freed with <a class="el" href="a00217.html#ga5dcff18f80583ac6505a94ba2877fd1b" title="Destroy a list of topology differences.">hwloc_topology_diff_destroy()</a>.</dd>
+<dd>
+The output diff can only be exported to XML or passed to <a class="el" href="a00217.html#gae7b350d7e7478a4c6047b08aa6544f40" title="Apply a topology diff to an existing topology.">hwloc_topology_diff_apply()</a> if 0 was returned, i.e. if no entry of type <a class="el" href="a00217.html#gga38b28b7423b85a3321e6d0062d5f83d0a3dc01fdeff355efe3fb2516bb454a147" title="The difference is too complex, it cannot be represented. The difference below this object has not bee...">HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX</a> is listed.</dd>
+<dd>
+The output diff may be modified by removing some entries from the list. The removed entries should be freed by passing them to to <a class="el" href="a00217.html#ga5dcff18f80583ac6505a94ba2877fd1b" title="Destroy a list of topology differences.">hwloc_topology_diff_destroy()</a> (possible as another list). </dd></dl>
+
+</div>
+</div>
+<a id="ga5dcff18f80583ac6505a94ba2877fd1b" name="ga5dcff18f80583ac6505a94ba2877fd1b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga5dcff18f80583ac6505a94ba2877fd1b">&#9670;&#160;</a></span>hwloc_topology_diff_destroy()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_diff_destroy </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a>&#160;</td>
+          <td class="paramname"><em>diff</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Destroy a list of topology differences. </p>
+<dl class="section return"><dt>Returns</dt><dd>0. </dd></dl>
+
+</div>
+</div>
+<a id="ga8a14dd7d01efbdd97af7fe85e8b84b20" name="ga8a14dd7d01efbdd97af7fe85e8b84b20"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8a14dd7d01efbdd97af7fe85e8b84b20">&#9670;&#160;</a></span>hwloc_topology_diff_export_xml()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_diff_export_xml </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a>&#160;</td>
+          <td class="paramname"><em>diff</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>refname</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>xmlpath</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Export a list of topology differences to a XML file. </p>
+<p>If not <code>NULL</code>, <code>refname</code> defines an identifier string for the reference topology which was used as a base when computing this difference. This identifier is usually the name of the other XML file that contains the reference topology. This attribute is given back when reading the diff from XML.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error. </dd></dl>
+
+</div>
+</div>
+<a id="gaa2f0918df60c1c4a0bef9411f7d92a13" name="gaa2f0918df60c1c4a0bef9411f7d92a13"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa2f0918df60c1c4a0bef9411f7d92a13">&#9670;&#160;</a></span>hwloc_topology_diff_export_xmlbuffer()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_diff_export_xmlbuffer </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a>&#160;</td>
+          <td class="paramname"><em>diff</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>refname</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">char **&#160;</td>
+          <td class="paramname"><em>xmlbuffer</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int *&#160;</td>
+          <td class="paramname"><em>buflen</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Export a list of topology differences to a XML buffer. </p>
+<p>If not <code>NULL</code>, <code>refname</code> defines an identifier string for the reference topology which was used as a base when computing this difference. This identifier is usually the name of the other XML file that contains the reference topology. This attribute is given back when reading the diff from XML.</p>
+<p>The returned buffer ends with a \0 that is included in the returned length.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>The XML buffer should later be freed with <a class="el" href="a00195.html#ga293e4a6489f15fd16ad22a5734561cf1" title="Free a buffer allocated by hwloc_topology_export_xmlbuffer()">hwloc_free_xmlbuffer()</a>. </dd></dl>
+
+</div>
+</div>
+<a id="ga2cd902ce8766e90d4f2523a8e87640e9" name="ga2cd902ce8766e90d4f2523a8e87640e9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga2cd902ce8766e90d4f2523a8e87640e9">&#9670;&#160;</a></span>hwloc_topology_diff_load_xml()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_diff_load_xml </td>
+          <td>(</td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>xmlpath</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a> *&#160;</td>
+          <td class="paramname"><em>diff</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">char **&#160;</td>
+          <td class="paramname"><em>refname</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Load a list of topology differences from a XML file. </p>
+<p>If not <code>NULL</code>, <code>refname</code> will be filled with the identifier string of the reference topology for the difference file, if any was specified in the XML file. This identifier is usually the name of the other XML file that contains the reference topology.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>the pointer returned in refname should later be freed by the caller. </dd></dl>
+
+</div>
+</div>
+<a id="gad693810a5c51628529b9dd56f040fb81" name="gad693810a5c51628529b9dd56f040fb81"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gad693810a5c51628529b9dd56f040fb81">&#9670;&#160;</a></span>hwloc_topology_diff_load_xmlbuffer()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_diff_load_xmlbuffer </td>
+          <td>(</td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>xmlbuffer</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>buflen</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00217.html#ga1bd6363f26f7961f83153aaa484a9b85">hwloc_topology_diff_t</a> *&#160;</td>
+          <td class="paramname"><em>diff</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">char **&#160;</td>
+          <td class="paramname"><em>refname</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Load a list of topology differences from a XML buffer. </p>
+<p>Build a list of differences from the XML memory buffer given at <code>xmlbuffer</code> and of length <code>buflen</code> (including an ending \0). This buffer may have been filled earlier with <a class="el" href="a00217.html#gaa2f0918df60c1c4a0bef9411f7d92a13" title="Export a list of topology differences to a XML buffer.">hwloc_topology_diff_export_xmlbuffer()</a>.</p>
+<p>If not <code>NULL</code>, <code>refname</code> will be filled with the identifier string of the reference topology for the difference file, if any was specified in the XML file. This identifier is usually the name of the other XML file that contains the reference topology.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>the pointer returned in refname should later be freed by the caller. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00218.html 2.11.0-1/doc/doxygen-doc/html/a00218.html
--- 2.10.0-1/doc/doxygen-doc/html/a00218.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00218.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,245 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Sharing topologies between processes</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Sharing topologies between processes</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga772ab52750cdd0eec85128df24888001" id="r_ga772ab52750cdd0eec85128df24888001"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00218.html#ga772ab52750cdd0eec85128df24888001">hwloc_shmem_topology_get_length</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, size_t *lengthp, unsigned long flags)</td></tr>
+<tr class="separator:ga772ab52750cdd0eec85128df24888001"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga61b20e346fc76f76420e3a88cc80a671" id="r_ga61b20e346fc76f76420e3a88cc80a671"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00218.html#ga61b20e346fc76f76420e3a88cc80a671">hwloc_shmem_topology_write</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, int fd, hwloc_uint64_t fileoffset, void *mmap_address, size_t length, unsigned long flags)</td></tr>
+<tr class="separator:ga61b20e346fc76f76420e3a88cc80a671"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga21545bd0f09d9b554c8e60a630e0e629" id="r_ga21545bd0f09d9b554c8e60a630e0e629"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00218.html#ga21545bd0f09d9b554c8e60a630e0e629">hwloc_shmem_topology_adopt</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> *topologyp, int fd, hwloc_uint64_t fileoffset, void *mmap_address, size_t length, unsigned long flags)</td></tr>
+<tr class="separator:ga21545bd0f09d9b554c8e60a630e0e629"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<p>These functions are used to share a topology between processes by duplicating it into a file-backed shared-memory buffer.</p>
+<p>The master process must first get the required shared-memory size for storing this topology with <a class="el" href="a00218.html#ga772ab52750cdd0eec85128df24888001" title="Get the required shared memory length for storing a topology.">hwloc_shmem_topology_get_length()</a>.</p>
+<p>Then it must find a virtual memory area of that size that is available in all processes (identical virtual addresses in all processes). On Linux, this can be done by comparing holes found in /proc/&lt;pid&gt;/maps for each process.</p>
+<p>Once found, it must open a destination file for storing the buffer, and pass it to <a class="el" href="a00218.html#ga61b20e346fc76f76420e3a88cc80a671" title="Duplicate a topology to a shared memory file.">hwloc_shmem_topology_write()</a> together with virtual memory address and length obtained above.</p>
+<p>Other processes may then adopt this shared topology by opening the same file and passing it to <a class="el" href="a00218.html#ga21545bd0f09d9b554c8e60a630e0e629" title="Adopt a shared memory topology stored in a file.">hwloc_shmem_topology_adopt()</a> with the exact same virtual memory address and length. </p>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga21545bd0f09d9b554c8e60a630e0e629" name="ga21545bd0f09d9b554c8e60a630e0e629"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga21545bd0f09d9b554c8e60a630e0e629">&#9670;&#160;</a></span>hwloc_shmem_topology_adopt()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_shmem_topology_adopt </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> *&#160;</td>
+          <td class="paramname"><em>topologyp</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>fd</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t&#160;</td>
+          <td class="paramname"><em>fileoffset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">void *&#160;</td>
+          <td class="paramname"><em>mmap_address</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>length</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Adopt a shared memory topology stored in a file. </p>
+<p>Map a file in virtual memory and adopt the topology that was previously stored there with <a class="el" href="a00218.html#ga61b20e346fc76f76420e3a88cc80a671" title="Duplicate a topology to a shared memory file.">hwloc_shmem_topology_write()</a>.</p>
+<p>The returned adopted topology in <code>topologyp</code> can be used just like any topology. And it must be destroyed with <a class="el" href="a00175.html#ga9f34a640b6fd28d23699d4d084667b15" title="Terminate and free a topology context.">hwloc_topology_destroy()</a> as usual.</p>
+<p>However the topology is read-only. For instance, it cannot be modified with <a class="el" href="a00183.html#ga6db81ed13ac0a9d70cc80372ab537815" title="Restrict the topology to the given CPU set or nodeset.">hwloc_topology_restrict()</a> and object userdata pointers cannot be changed.</p>
+<p>The segment of the file pointed by descriptor <code>fd</code>, starting at offset <code>fileoffset</code>, and of length <code>length</code> (in bytes), will be mapped at virtual address <code>mmap_address</code>.</p>
+<p>The file pointed by descriptor <code>fd</code>, the offset <code>fileoffset</code>, the requested mapping virtual address <code>mmap_address</code> and the length <code>length</code> must be identical to what was given to <a class="el" href="a00218.html#ga61b20e346fc76f76420e3a88cc80a671" title="Duplicate a topology to a shared memory file.">hwloc_shmem_topology_write()</a> earlier.</p>
+<dl class="section note"><dt>Note</dt><dd>Flags <code>flags</code> are currently unused, must be 0.</dd>
+<dd>
+The object userdata pointer should not be used unless the process that created the shared topology also placed userdata-pointed buffers in shared memory.</dd>
+<dd>
+This function takes care of calling <a class="el" href="a00175.html#ga0647ae66458fe68172eb5a320042f870" title="Verify that the topology is compatible with the current hwloc library.">hwloc_topology_abi_check()</a>.</dd></dl>
+<dl class="section return"><dt>Returns</dt><dd>0 on success.</dd>
+<dd>
+-1 with errno set to <code>EBUSY</code> if the virtual memory mapping defined by <code>mmap_address</code> and <code>length</code> isn't available in the process.</dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if <code>fileoffset</code>, <code>mmap_address</code> or <code>length</code> aren't page-aligned, or do not match what was given to <a class="el" href="a00218.html#ga61b20e346fc76f76420e3a88cc80a671" title="Duplicate a topology to a shared memory file.">hwloc_shmem_topology_write()</a> earlier.</dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if the layout of the topology structure is different between the writer process and the adopter process. </dd></dl>
+
+</div>
+</div>
+<a id="ga772ab52750cdd0eec85128df24888001" name="ga772ab52750cdd0eec85128df24888001"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga772ab52750cdd0eec85128df24888001">&#9670;&#160;</a></span>hwloc_shmem_topology_get_length()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_shmem_topology_get_length </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t *&#160;</td>
+          <td class="paramname"><em>lengthp</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Get the required shared memory length for storing a topology. </p>
+<p>This length (in bytes) must be used in <a class="el" href="a00218.html#ga61b20e346fc76f76420e3a88cc80a671" title="Duplicate a topology to a shared memory file.">hwloc_shmem_topology_write()</a> and <a class="el" href="a00218.html#ga21545bd0f09d9b554c8e60a630e0e629" title="Adopt a shared memory topology stored in a file.">hwloc_shmem_topology_adopt()</a> later.</p>
+<dl class="section return"><dt>Returns</dt><dd>the length, or -1 on error, for instance if flags are invalid.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>Flags <code>flags</code> are currently unused, must be 0. </dd></dl>
+
+</div>
+</div>
+<a id="ga61b20e346fc76f76420e3a88cc80a671" name="ga61b20e346fc76f76420e3a88cc80a671"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga61b20e346fc76f76420e3a88cc80a671">&#9670;&#160;</a></span>hwloc_shmem_topology_write()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_shmem_topology_write </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">int&#160;</td>
+          <td class="paramname"><em>fd</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t&#160;</td>
+          <td class="paramname"><em>fileoffset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">void *&#160;</td>
+          <td class="paramname"><em>mmap_address</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">size_t&#160;</td>
+          <td class="paramname"><em>length</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Duplicate a topology to a shared memory file. </p>
+<p>Temporarily map a file in virtual memory and duplicate the topology <code>topology</code> by allocating duplicates in there.</p>
+<p>The segment of the file pointed by descriptor <code>fd</code>, starting at offset <code>fileoffset</code>, and of length <code>length</code> (in bytes), will be temporarily mapped at virtual address <code>mmap_address</code> during the duplication.</p>
+<p>The mapping length <code>length</code> must have been previously obtained with <a class="el" href="a00218.html#ga772ab52750cdd0eec85128df24888001" title="Get the required shared memory length for storing a topology.">hwloc_shmem_topology_get_length()</a> and the topology must not have been modified in the meantime.</p>
+<dl class="section note"><dt>Note</dt><dd>Flags <code>flags</code> are currently unused, must be 0.</dd>
+<dd>
+The object userdata pointer is duplicated but the pointed buffer is not. However the caller may also allocate it manually in shared memory to share it as well.</dd></dl>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 with errno set to <code>EBUSY</code> if the virtual memory mapping defined by <code>mmap_address</code> and <code>length</code> isn't available in the process. </dd>
+<dd>
+-1 with errno set to <code>EINVAL</code> if <code>fileoffset</code>, <code>mmap_address</code> or <code>length</code> aren't page-aligned. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00219.html 2.11.0-1/doc/doxygen-doc/html/a00219.html
--- 2.10.0-1/doc/doxygen-doc/html/a00219.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00219.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,61 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Components and Plugins: Discovery components</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a>  </div>
+  <div class="headertitle"><div class="title">Components and Plugins: Discovery components</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00361.html">hwloc_disc_component</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<dl class="section note"><dt>Note</dt><dd>These structures and functions may change when <a class="el" href="a00171.html#gaac5bc1f46f55e10ef0141a68ce70e21f" title="Current component and plugin ABI version (see hwloc/plugins.h)">HWLOC_COMPONENT_ABI</a> is modified. </dd></dl>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00220.html 2.11.0-1/doc/doxygen-doc/html/a00220.html
--- 2.10.0-1/doc/doxygen-doc/html/a00220.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00220.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,220 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Components and Plugins: Discovery backends</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#typedef-members">Typedefs</a> &#124;
+<a href="#enum-members">Enumerations</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Components and Plugins: Discovery backends</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00365.html">hwloc_disc_status</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00369.html">hwloc_backend</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="typedef-members" name="typedef-members"></a>
+Typedefs</h2></td></tr>
+<tr class="memitem:ga600bba1a62022d5f516800649b1edb61" id="r_ga600bba1a62022d5f516800649b1edb61"><td class="memItemLeft" align="right" valign="top">typedef enum <a class="el" href="a00220.html#ga8c314121c2fc478161bcce758688b9a1">hwloc_disc_phase_e</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00220.html#ga600bba1a62022d5f516800649b1edb61">hwloc_disc_phase_t</a></td></tr>
+<tr class="separator:ga600bba1a62022d5f516800649b1edb61"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:ga8c314121c2fc478161bcce758688b9a1" id="r_ga8c314121c2fc478161bcce758688b9a1"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00220.html#ga8c314121c2fc478161bcce758688b9a1">hwloc_disc_phase_e</a> { <br />
+&#160;&#160;<a class="el" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1ab41c626c79e9ccb1e7d41e7076972283">HWLOC_DISC_PHASE_GLOBAL</a>
+, <a class="el" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a6360474df197027761a69bd5fc620250">HWLOC_DISC_PHASE_CPU</a>
+, <a class="el" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1ac4264a243844c5fbbff495cdb1b4d51d">HWLOC_DISC_PHASE_MEMORY</a>
+, <a class="el" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a677c52064dd987af4988346319b3675a">HWLOC_DISC_PHASE_PCI</a>
+, <br />
+&#160;&#160;<a class="el" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1aa8e10626cba9af72f5605a1acbdc0015">HWLOC_DISC_PHASE_IO</a>
+, <a class="el" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a8a7cde9bff0ab0d085b102a3e934939b">HWLOC_DISC_PHASE_MISC</a>
+, <a class="el" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1a68ca5c7ad75a6d9e5355689411621773">HWLOC_DISC_PHASE_ANNOTATE</a>
+, <a class="el" href="a00220.html#gga8c314121c2fc478161bcce758688b9a1ada3ed3f00e74909353d6ea4a96cde5ad">HWLOC_DISC_PHASE_TWEAK</a>
+<br />
+ }</td></tr>
+<tr class="separator:ga8c314121c2fc478161bcce758688b9a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaae1b38cf9b12e489884ce2a07275964b" id="r_gaae1b38cf9b12e489884ce2a07275964b"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00220.html#gaae1b38cf9b12e489884ce2a07275964b">hwloc_disc_status_flag_e</a> { <a class="el" href="a00220.html#ggaae1b38cf9b12e489884ce2a07275964ba205d644d54a0840bd9165fce7d19e6b1">HWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES</a>
+ }</td></tr>
+<tr class="separator:gaae1b38cf9b12e489884ce2a07275964b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga6118a1009aa390c13255a330ccf253cf" id="r_ga6118a1009aa390c13255a330ccf253cf"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00369.html">hwloc_backend</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00220.html#ga6118a1009aa390c13255a330ccf253cf">hwloc_backend_alloc</a> (struct hwloc_topology *topology, struct <a class="el" href="a00361.html">hwloc_disc_component</a> *component)</td></tr>
+<tr class="separator:ga6118a1009aa390c13255a330ccf253cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga4715779d7191833e9b1a7490989a7497" id="r_ga4715779d7191833e9b1a7490989a7497"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00220.html#ga4715779d7191833e9b1a7490989a7497">hwloc_backend_enable</a> (struct <a class="el" href="a00369.html">hwloc_backend</a> *backend)</td></tr>
+<tr class="separator:ga4715779d7191833e9b1a7490989a7497"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<dl class="section note"><dt>Note</dt><dd>These structures and functions may change when <a class="el" href="a00171.html#gaac5bc1f46f55e10ef0141a68ce70e21f" title="Current component and plugin ABI version (see hwloc/plugins.h)">HWLOC_COMPONENT_ABI</a> is modified. </dd></dl>
+<h2 class="groupheader">Typedef Documentation</h2>
+<a id="ga600bba1a62022d5f516800649b1edb61" name="ga600bba1a62022d5f516800649b1edb61"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga600bba1a62022d5f516800649b1edb61">&#9670;&#160;</a></span>hwloc_disc_phase_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef enum <a class="el" href="a00220.html#ga8c314121c2fc478161bcce758688b9a1">hwloc_disc_phase_e</a> <a class="el" href="a00220.html#ga600bba1a62022d5f516800649b1edb61">hwloc_disc_phase_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Discovery phase. </p>
+
+</div>
+</div>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="ga8c314121c2fc478161bcce758688b9a1" name="ga8c314121c2fc478161bcce758688b9a1"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga8c314121c2fc478161bcce758688b9a1">&#9670;&#160;</a></span>hwloc_disc_phase_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00220.html#ga8c314121c2fc478161bcce758688b9a1">hwloc_disc_phase_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Discovery phase. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga8c314121c2fc478161bcce758688b9a1ab41c626c79e9ccb1e7d41e7076972283" name="gga8c314121c2fc478161bcce758688b9a1ab41c626c79e9ccb1e7d41e7076972283"></a>HWLOC_DISC_PHASE_GLOBAL&#160;</td><td class="fielddoc"><p>xml or synthetic, platform-specific components such as bgq. Discovers everything including CPU, memory, I/O and everything else. A component with a Global phase usually excludes all other phases. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga8c314121c2fc478161bcce758688b9a1a6360474df197027761a69bd5fc620250" name="gga8c314121c2fc478161bcce758688b9a1a6360474df197027761a69bd5fc620250"></a>HWLOC_DISC_PHASE_CPU&#160;</td><td class="fielddoc"><p>CPU discovery. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga8c314121c2fc478161bcce758688b9a1ac4264a243844c5fbbff495cdb1b4d51d" name="gga8c314121c2fc478161bcce758688b9a1ac4264a243844c5fbbff495cdb1b4d51d"></a>HWLOC_DISC_PHASE_MEMORY&#160;</td><td class="fielddoc"><p>Attach memory to existing CPU objects. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga8c314121c2fc478161bcce758688b9a1a677c52064dd987af4988346319b3675a" name="gga8c314121c2fc478161bcce758688b9a1a677c52064dd987af4988346319b3675a"></a>HWLOC_DISC_PHASE_PCI&#160;</td><td class="fielddoc"><p>Attach PCI devices and bridges to existing CPU objects. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga8c314121c2fc478161bcce758688b9a1aa8e10626cba9af72f5605a1acbdc0015" name="gga8c314121c2fc478161bcce758688b9a1aa8e10626cba9af72f5605a1acbdc0015"></a>HWLOC_DISC_PHASE_IO&#160;</td><td class="fielddoc"><p>I/O discovery that requires PCI devices (OS devices such as OpenCL, CUDA, etc.). </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga8c314121c2fc478161bcce758688b9a1a8a7cde9bff0ab0d085b102a3e934939b" name="gga8c314121c2fc478161bcce758688b9a1a8a7cde9bff0ab0d085b102a3e934939b"></a>HWLOC_DISC_PHASE_MISC&#160;</td><td class="fielddoc"><p>Misc objects that gets added below anything else. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga8c314121c2fc478161bcce758688b9a1a68ca5c7ad75a6d9e5355689411621773" name="gga8c314121c2fc478161bcce758688b9a1a68ca5c7ad75a6d9e5355689411621773"></a>HWLOC_DISC_PHASE_ANNOTATE&#160;</td><td class="fielddoc"><p>Annotating existing objects, adding distances, etc. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga8c314121c2fc478161bcce758688b9a1ada3ed3f00e74909353d6ea4a96cde5ad" name="gga8c314121c2fc478161bcce758688b9a1ada3ed3f00e74909353d6ea4a96cde5ad"></a>HWLOC_DISC_PHASE_TWEAK&#160;</td><td class="fielddoc"><p>Final tweaks to a ready-to-use topology. This phase runs once the topology is loaded, before it is returned to the topology. Hence it may only use the main hwloc API for modifying the topology, for instance by restricting it, adding info attributes, etc. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<a id="gaae1b38cf9b12e489884ce2a07275964b" name="gaae1b38cf9b12e489884ce2a07275964b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaae1b38cf9b12e489884ce2a07275964b">&#9670;&#160;</a></span>hwloc_disc_status_flag_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00220.html#gaae1b38cf9b12e489884ce2a07275964b">hwloc_disc_status_flag_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Discovery status flags. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ggaae1b38cf9b12e489884ce2a07275964ba205d644d54a0840bd9165fce7d19e6b1" name="ggaae1b38cf9b12e489884ce2a07275964ba205d644d54a0840bd9165fce7d19e6b1"></a>HWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES&#160;</td><td class="fielddoc"><p>The sets of allowed resources were already retrieved. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga6118a1009aa390c13255a330ccf253cf" name="ga6118a1009aa390c13255a330ccf253cf"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga6118a1009aa390c13255a330ccf253cf">&#9670;&#160;</a></span>hwloc_backend_alloc()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00369.html">hwloc_backend</a> * hwloc_backend_alloc </td>
+          <td>(</td>
+          <td class="paramtype">struct hwloc_topology *&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00361.html">hwloc_disc_component</a> *&#160;</td>
+          <td class="paramname"><em>component</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Allocate a backend structure, set good default values, initialize backend-&gt;component and topology, etc. The caller will then modify whatever needed, and call <a class="el" href="a00220.html#ga4715779d7191833e9b1a7490989a7497" title="Enable a previously allocated and setup backend.">hwloc_backend_enable()</a>. </p>
+
+</div>
+</div>
+<a id="ga4715779d7191833e9b1a7490989a7497" name="ga4715779d7191833e9b1a7490989a7497"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga4715779d7191833e9b1a7490989a7497">&#9670;&#160;</a></span>hwloc_backend_enable()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_backend_enable </td>
+          <td>(</td>
+          <td class="paramtype">struct <a class="el" href="a00369.html">hwloc_backend</a> *&#160;</td>
+          <td class="paramname"><em>backend</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Enable a previously allocated and setup backend. </p>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00221.html 2.11.0-1/doc/doxygen-doc/html/a00221.html
--- 2.10.0-1/doc/doxygen-doc/html/a00221.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00221.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,115 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Components and Plugins: Generic components</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#typedef-members">Typedefs</a> &#124;
+<a href="#enum-members">Enumerations</a>  </div>
+  <div class="headertitle"><div class="title">Components and Plugins: Generic components</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00373.html">hwloc_component</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="typedef-members" name="typedef-members"></a>
+Typedefs</h2></td></tr>
+<tr class="memitem:ga31a5a455f4e666b936f0a9e8fb9a0f47" id="r_ga31a5a455f4e666b936f0a9e8fb9a0f47"><td class="memItemLeft" align="right" valign="top">typedef enum <a class="el" href="a00221.html#ga397a1bf7d21dd073320ad0045340f463">hwloc_component_type_e</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00221.html#ga31a5a455f4e666b936f0a9e8fb9a0f47">hwloc_component_type_t</a></td></tr>
+<tr class="separator:ga31a5a455f4e666b936f0a9e8fb9a0f47"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
+Enumerations</h2></td></tr>
+<tr class="memitem:ga397a1bf7d21dd073320ad0045340f463" id="r_ga397a1bf7d21dd073320ad0045340f463"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00221.html#ga397a1bf7d21dd073320ad0045340f463">hwloc_component_type_e</a> { <a class="el" href="a00221.html#gga397a1bf7d21dd073320ad0045340f463a5d6e561f467fe9795a29e7368b613900">HWLOC_COMPONENT_TYPE_DISC</a>
+, <a class="el" href="a00221.html#gga397a1bf7d21dd073320ad0045340f463adea00cd839c2141c032e1569fd5592bd">HWLOC_COMPONENT_TYPE_XML</a>
+ }</td></tr>
+<tr class="separator:ga397a1bf7d21dd073320ad0045340f463"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<dl class="section note"><dt>Note</dt><dd>These structures and functions may change when <a class="el" href="a00171.html#gaac5bc1f46f55e10ef0141a68ce70e21f" title="Current component and plugin ABI version (see hwloc/plugins.h)">HWLOC_COMPONENT_ABI</a> is modified. </dd></dl>
+<h2 class="groupheader">Typedef Documentation</h2>
+<a id="ga31a5a455f4e666b936f0a9e8fb9a0f47" name="ga31a5a455f4e666b936f0a9e8fb9a0f47"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga31a5a455f4e666b936f0a9e8fb9a0f47">&#9670;&#160;</a></span>hwloc_component_type_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef enum <a class="el" href="a00221.html#ga397a1bf7d21dd073320ad0045340f463">hwloc_component_type_e</a> <a class="el" href="a00221.html#ga31a5a455f4e666b936f0a9e8fb9a0f47">hwloc_component_type_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Generic component type. </p>
+
+</div>
+</div>
+<h2 class="groupheader">Enumeration Type Documentation</h2>
+<a id="ga397a1bf7d21dd073320ad0045340f463" name="ga397a1bf7d21dd073320ad0045340f463"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga397a1bf7d21dd073320ad0045340f463">&#9670;&#160;</a></span>hwloc_component_type_e</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00221.html#ga397a1bf7d21dd073320ad0045340f463">hwloc_component_type_e</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Generic component type. </p>
+<table class="fieldtable">
+<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="gga397a1bf7d21dd073320ad0045340f463a5d6e561f467fe9795a29e7368b613900" name="gga397a1bf7d21dd073320ad0045340f463a5d6e561f467fe9795a29e7368b613900"></a>HWLOC_COMPONENT_TYPE_DISC&#160;</td><td class="fielddoc"><p>The data field must point to a struct <a class="el" href="a00361.html" title="Discovery component structure.">hwloc_disc_component</a>. </p>
+</td></tr>
+<tr><td class="fieldname"><a id="gga397a1bf7d21dd073320ad0045340f463adea00cd839c2141c032e1569fd5592bd" name="gga397a1bf7d21dd073320ad0045340f463adea00cd839c2141c032e1569fd5592bd"></a>HWLOC_COMPONENT_TYPE_XML&#160;</td><td class="fielddoc"><p>The data field must point to a struct hwloc_xml_component. </p>
+</td></tr>
+</table>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00222.html 2.11.0-1/doc/doxygen-doc/html/a00222.html
--- 2.10.0-1/doc/doxygen-doc/html/a00222.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00222.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,372 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Components and Plugins: Core functions to be used by components</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#define-members">Macros</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Components and Plugins: Core functions to be used by components</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="define-members" name="define-members"></a>
+Macros</h2></td></tr>
+<tr class="memitem:gafce07a2a959190a6c7126b321bef202f" id="r_gafce07a2a959190a6c7126b321bef202f"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00222.html#gafce07a2a959190a6c7126b321bef202f">HWLOC_SHOW_CRITICAL_ERRORS</a>()&#160;&#160;&#160;(<a class="el" href="a00222.html#gab527c1e0f243f057d31a724794ad9f88">hwloc_hide_errors</a>() &lt; 2)</td></tr>
+<tr class="separator:gafce07a2a959190a6c7126b321bef202f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga3e48b6ac00ed6a40aea975e23eddcdbb" id="r_ga3e48b6ac00ed6a40aea975e23eddcdbb"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00222.html#ga3e48b6ac00ed6a40aea975e23eddcdbb">HWLOC_SHOW_ALL_ERRORS</a>()&#160;&#160;&#160;(<a class="el" href="a00222.html#gab527c1e0f243f057d31a724794ad9f88">hwloc_hide_errors</a>() == 0)</td></tr>
+<tr class="separator:ga3e48b6ac00ed6a40aea975e23eddcdbb"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:gab527c1e0f243f057d31a724794ad9f88" id="r_gab527c1e0f243f057d31a724794ad9f88"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00222.html#gab527c1e0f243f057d31a724794ad9f88">hwloc_hide_errors</a> (void)</td></tr>
+<tr class="separator:gab527c1e0f243f057d31a724794ad9f88"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1e105cfe3c8e77f34cc6df3841deebbc" id="r_ga1e105cfe3c8e77f34cc6df3841deebbc"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00222.html#ga1e105cfe3c8e77f34cc6df3841deebbc">hwloc__insert_object_by_cpuset</a> (struct hwloc_topology *topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> root, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj, const char *reason)</td></tr>
+<tr class="separator:ga1e105cfe3c8e77f34cc6df3841deebbc"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga0ef97debde503b56367689b07bb3e901" id="r_ga0ef97debde503b56367689b07bb3e901"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00222.html#ga0ef97debde503b56367689b07bb3e901">hwloc_insert_object_by_parent</a> (struct hwloc_topology *topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> parent, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj)</td></tr>
+<tr class="separator:ga0ef97debde503b56367689b07bb3e901"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga0b5c75b2dc37cea2e8a29c4812baf4b3" id="r_ga0b5c75b2dc37cea2e8a29c4812baf4b3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00222.html#ga0b5c75b2dc37cea2e8a29c4812baf4b3">hwloc_alloc_setup_object</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type, unsigned os_index)</td></tr>
+<tr class="separator:ga0b5c75b2dc37cea2e8a29c4812baf4b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga754b61041ceee9685534a2c5d3cd0156" id="r_ga754b61041ceee9685534a2c5d3cd0156"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00222.html#ga754b61041ceee9685534a2c5d3cd0156">hwloc_obj_add_children_sets</a> (<a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj)</td></tr>
+<tr class="separator:ga754b61041ceee9685534a2c5d3cd0156"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga120d8bd74922e1030b621409a6b0be61" id="r_ga120d8bd74922e1030b621409a6b0be61"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00222.html#ga120d8bd74922e1030b621409a6b0be61">hwloc_topology_reconnect</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, unsigned long flags)</td></tr>
+<tr class="separator:ga120d8bd74922e1030b621409a6b0be61"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac2eaed287bb215cf0bd33014e9e1d374" id="r_gac2eaed287bb215cf0bd33014e9e1d374"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00222.html#gac2eaed287bb215cf0bd33014e9e1d374">hwloc_plugin_check_namespace</a> (const char *pluginname, const char *symbol)</td></tr>
+<tr class="separator:gac2eaed287bb215cf0bd33014e9e1d374"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<dl class="section note"><dt>Note</dt><dd>These structures and functions may change when <a class="el" href="a00171.html#gaac5bc1f46f55e10ef0141a68ce70e21f" title="Current component and plugin ABI version (see hwloc/plugins.h)">HWLOC_COMPONENT_ABI</a> is modified. </dd></dl>
+<h2 class="groupheader">Macro Definition Documentation</h2>
+<a id="ga3e48b6ac00ed6a40aea975e23eddcdbb" name="ga3e48b6ac00ed6a40aea975e23eddcdbb"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga3e48b6ac00ed6a40aea975e23eddcdbb">&#9670;&#160;</a></span>HWLOC_SHOW_ALL_ERRORS</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">#define HWLOC_SHOW_ALL_ERRORS</td>
+          <td>(</td>
+          <td class="paramname"></td><td>)</td>
+          <td>&#160;&#160;&#160;(<a class="el" href="a00222.html#gab527c1e0f243f057d31a724794ad9f88">hwloc_hide_errors</a>() == 0)</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="gafce07a2a959190a6c7126b321bef202f" name="gafce07a2a959190a6c7126b321bef202f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gafce07a2a959190a6c7126b321bef202f">&#9670;&#160;</a></span>HWLOC_SHOW_CRITICAL_ERRORS</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">#define HWLOC_SHOW_CRITICAL_ERRORS</td>
+          <td>(</td>
+          <td class="paramname"></td><td>)</td>
+          <td>&#160;&#160;&#160;(<a class="el" href="a00222.html#gab527c1e0f243f057d31a724794ad9f88">hwloc_hide_errors</a>() &lt; 2)</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga1e105cfe3c8e77f34cc6df3841deebbc" name="ga1e105cfe3c8e77f34cc6df3841deebbc"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1e105cfe3c8e77f34cc6df3841deebbc">&#9670;&#160;</a></span>hwloc__insert_object_by_cpuset()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc__insert_object_by_cpuset </td>
+          <td>(</td>
+          <td class="paramtype">struct hwloc_topology *&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>root</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>reason</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Add an object to the topology. </p>
+<p>Insert new object <code>obj</code> in the topology starting under existing object <code>root</code> (if <code>NULL</code>, the topology root object is used).</p>
+<p>It is sorted along the tree of other objects according to the inclusion of cpusets, to eventually be added as a child of the smallest object including this object.</p>
+<p>If the cpuset is empty, the type of the object (and maybe some attributes) must be enough to find where to insert the object. This is especially true for NUMA nodes with memory and no CPUs.</p>
+<p>The given object should not have children.</p>
+<p>This shall only be called before levels are built.</p>
+<p>The caller should check whether the object type is filtered-out before calling this function.</p>
+<p>The topology cpuset/nodesets will be enlarged to include the object sets.</p>
+<p><code>reason</code> is a unique string identifying where and why this insertion call was performed (it will be displayed in case of internal insertion error).</p>
+<p>Returns the object on success. Returns NULL and frees obj on error. Returns another object and frees obj if it was merged with an identical pre-existing object. </p>
+
+</div>
+</div>
+<a id="ga0b5c75b2dc37cea2e8a29c4812baf4b3" name="ga0b5c75b2dc37cea2e8a29c4812baf4b3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga0b5c75b2dc37cea2e8a29c4812baf4b3">&#9670;&#160;</a></span>hwloc_alloc_setup_object()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_alloc_setup_object </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>os_index</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Allocate and initialize an object of the given type and physical index. </p>
+<p>If <code>os_index</code> is unknown or irrelevant, use <code>HWLOC_UNKNOWN_INDEX</code>. </p>
+
+</div>
+</div>
+<a id="gab527c1e0f243f057d31a724794ad9f88" name="gab527c1e0f243f057d31a724794ad9f88"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab527c1e0f243f057d31a724794ad9f88">&#9670;&#160;</a></span>hwloc_hide_errors()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_hide_errors </td>
+          <td>(</td>
+          <td class="paramtype">void&#160;</td>
+          <td class="paramname"></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Check whether error messages are hidden. </p>
+<p>Callers should print critical error messages (e.g. invalid hw topo info, invalid config) only if this function returns strictly less than 2.</p>
+<p>Callers should print non-critical error messages (e.g. failure to initialize CUDA) if this function returns 0.</p>
+<p>This function return 1 by default (show critical only), 0 in lstopo (show all), or anything set in HWLOC_HIDE_ERRORS in the environment.</p>
+<p>Use macros <a class="el" href="a00222.html#gafce07a2a959190a6c7126b321bef202f">HWLOC_SHOW_CRITICAL_ERRORS()</a> and <a class="el" href="a00222.html#ga3e48b6ac00ed6a40aea975e23eddcdbb">HWLOC_SHOW_ALL_ERRORS()</a> for clarity. </p>
+
+</div>
+</div>
+<a id="ga0ef97debde503b56367689b07bb3e901" name="ga0ef97debde503b56367689b07bb3e901"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga0ef97debde503b56367689b07bb3e901">&#9670;&#160;</a></span>hwloc_insert_object_by_parent()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_insert_object_by_parent </td>
+          <td>(</td>
+          <td class="paramtype">struct hwloc_topology *&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>parent</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Insert an object somewhere in the topology. </p>
+<p>It is added as the last child of the given parent. The cpuset is completely ignored, so strange objects such as I/O devices should preferably be inserted with this.</p>
+<p>When used for "normal" children with cpusets (when importing from XML when duplicating a topology), the caller should make sure that:</p><ul>
+<li>children are inserted in order,</li>
+<li>children cpusets do not intersect.</li>
+</ul>
+<p>The given object may have normal, I/O or Misc children, as long as they are in order as well. These children must have valid parent and next_sibling pointers.</p>
+<p>The caller should check whether the object type is filtered-out before calling this function. </p>
+
+</div>
+</div>
+<a id="ga754b61041ceee9685534a2c5d3cd0156" name="ga754b61041ceee9685534a2c5d3cd0156"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga754b61041ceee9685534a2c5d3cd0156">&#9670;&#160;</a></span>hwloc_obj_add_children_sets()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_add_children_sets </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Setup object cpusets/nodesets by OR'ing its children. </p>
+<p>Used when adding an object late in the topology. Will update the new object by OR'ing all its new children sets.</p>
+<p>Used when PCI backend adds a hostbridge parent, when distances add a new Group, etc. </p>
+
+</div>
+</div>
+<a id="gac2eaed287bb215cf0bd33014e9e1d374" name="gac2eaed287bb215cf0bd33014e9e1d374"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac2eaed287bb215cf0bd33014e9e1d374">&#9670;&#160;</a></span>hwloc_plugin_check_namespace()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_plugin_check_namespace </td>
+          <td>(</td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>pluginname</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>symbol</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Make sure that plugins can lookup core symbols. </p>
+<p>This is a sanity check to avoid lazy-lookup failures when libhwloc is loaded within a plugin, and later tries to load its own plugins. This may fail (and abort the program) if libhwloc symbols are in a private namespace.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success. </dd>
+<dd>
+-1 if the plugin cannot be successfully loaded. The caller plugin init() callback should return a negative error code as well.</dd></dl>
+<p>Plugins should call this function in their init() callback to avoid later crashes if lazy symbol resolution is used by the upper layer that loaded hwloc (e.g. OpenCL implementations using dlopen with RTLD_LAZY).</p>
+<dl class="section note"><dt>Note</dt><dd>The build system must define HWLOC_INSIDE_PLUGIN if and only if building the caller as a plugin.</dd>
+<dd>
+This function should remain inline so plugins can call it even when they cannot find libhwloc symbols. </dd></dl>
+
+</div>
+</div>
+<a id="ga120d8bd74922e1030b621409a6b0be61" name="ga120d8bd74922e1030b621409a6b0be61"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga120d8bd74922e1030b621409a6b0be61">&#9670;&#160;</a></span>hwloc_topology_reconnect()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_reconnect </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Request a reconnection of children and levels in the topology. </p>
+<p>May be used by backends during discovery if they need arrays or lists of object within levels or children to be fully connected.</p>
+<p><code>flags</code> is currently unused, must 0. </p>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00223.html 2.11.0-1/doc/doxygen-doc/html/a00223.html
--- 2.10.0-1/doc/doxygen-doc/html/a00223.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00223.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,205 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Components and Plugins: Filtering objects</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Components and Plugins: Filtering objects</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga60203db6459ebf275bf48c40a37661a0" id="r_ga60203db6459ebf275bf48c40a37661a0"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00223.html#ga60203db6459ebf275bf48c40a37661a0">hwloc_filter_check_pcidev_subtype_important</a> (unsigned classid)</td></tr>
+<tr class="separator:ga60203db6459ebf275bf48c40a37661a0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gac7d57a6d669820f360cf2a070a396560" id="r_gac7d57a6d669820f360cf2a070a396560"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00223.html#gac7d57a6d669820f360cf2a070a396560">hwloc_filter_check_osdev_subtype_important</a> (<a class="el" href="a00173.html#gaa9a6941ef7b1c169412518d7ef71b3d2">hwloc_obj_osdev_type_t</a> subtype)</td></tr>
+<tr class="separator:gac7d57a6d669820f360cf2a070a396560"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga2f402a43025a8a91e8513be1a15e4635" id="r_ga2f402a43025a8a91e8513be1a15e4635"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00223.html#ga2f402a43025a8a91e8513be1a15e4635">hwloc_filter_check_keep_object_type</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> type)</td></tr>
+<tr class="separator:ga2f402a43025a8a91e8513be1a15e4635"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga4d2fdce071e5646ef147c9ff1539d1c9" id="r_ga4d2fdce071e5646ef147c9ff1539d1c9"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00223.html#ga4d2fdce071e5646ef147c9ff1539d1c9">hwloc_filter_check_keep_object</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> obj)</td></tr>
+<tr class="separator:ga4d2fdce071e5646ef147c9ff1539d1c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<dl class="section note"><dt>Note</dt><dd>These structures and functions may change when <a class="el" href="a00171.html#gaac5bc1f46f55e10ef0141a68ce70e21f" title="Current component and plugin ABI version (see hwloc/plugins.h)">HWLOC_COMPONENT_ABI</a> is modified. </dd></dl>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga4d2fdce071e5646ef147c9ff1539d1c9" name="ga4d2fdce071e5646ef147c9ff1539d1c9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga4d2fdce071e5646ef147c9ff1539d1c9">&#9670;&#160;</a></span>hwloc_filter_check_keep_object()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_filter_check_keep_object </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td>
+          <td class="paramname"><em>obj</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Check whether the given object should be filtered-out. </p>
+<dl class="section return"><dt>Returns</dt><dd>1 if the object type should be kept, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="ga2f402a43025a8a91e8513be1a15e4635" name="ga2f402a43025a8a91e8513be1a15e4635"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga2f402a43025a8a91e8513be1a15e4635">&#9670;&#160;</a></span>hwloc_filter_check_keep_object_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_filter_check_keep_object_type </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td>
+          <td class="paramname"><em>type</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Check whether a non-I/O object type should be filtered-out. </p>
+<p>Cannot be used for I/O objects.</p>
+<dl class="section return"><dt>Returns</dt><dd>1 if the object type should be kept, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="gac7d57a6d669820f360cf2a070a396560" name="gac7d57a6d669820f360cf2a070a396560"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gac7d57a6d669820f360cf2a070a396560">&#9670;&#160;</a></span>hwloc_filter_check_osdev_subtype_important()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_filter_check_osdev_subtype_important </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00173.html#gaa9a6941ef7b1c169412518d7ef71b3d2">hwloc_obj_osdev_type_t</a>&#160;</td>
+          <td class="paramname"><em>subtype</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Check whether the given OS device subtype is important. </p>
+<dl class="section return"><dt>Returns</dt><dd>1 if important, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+<a id="ga60203db6459ebf275bf48c40a37661a0" name="ga60203db6459ebf275bf48c40a37661a0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga60203db6459ebf275bf48c40a37661a0">&#9670;&#160;</a></span>hwloc_filter_check_pcidev_subtype_important()</h2>
+
+<div class="memitem">
+<div class="memproto">
+<table class="mlabels">
+  <tr>
+  <td class="mlabels-left">
+      <table class="memname">
+        <tr>
+          <td class="memname">static int hwloc_filter_check_pcidev_subtype_important </td>
+          <td>(</td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>classid</em></td><td>)</td>
+          <td></td>
+        </tr>
+      </table>
+  </td>
+  <td class="mlabels-right">
+<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
+  </tr>
+</table>
+</div><div class="memdoc">
+
+<p>Check whether the given PCI device classid is important. </p>
+<dl class="section return"><dt>Returns</dt><dd>1 if important, 0 otherwise. </dd></dl>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00224.html 2.11.0-1/doc/doxygen-doc/html/a00224.html
--- 2.10.0-1/doc/doxygen-doc/html/a00224.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00224.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,295 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Components and Plugins: helpers for PCI discovery</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Components and Plugins: helpers for PCI discovery</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga706f71cfea09d547d2cbafa642d6e03b" id="r_ga706f71cfea09d547d2cbafa642d6e03b"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00224.html#ga706f71cfea09d547d2cbafa642d6e03b">hwloc_pcidisc_find_cap</a> (const unsigned char *config, unsigned cap)</td></tr>
+<tr class="separator:ga706f71cfea09d547d2cbafa642d6e03b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga51d1ebcbf9729987c9d17df3aa57d209" id="r_ga51d1ebcbf9729987c9d17df3aa57d209"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00224.html#ga51d1ebcbf9729987c9d17df3aa57d209">hwloc_pcidisc_find_linkspeed</a> (const unsigned char *config, unsigned offset, float *linkspeed)</td></tr>
+<tr class="separator:ga51d1ebcbf9729987c9d17df3aa57d209"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga6c55fb80c3d0c8c8e61078b3f38adde8" id="r_ga6c55fb80c3d0c8c8e61078b3f38adde8"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00224.html#ga6c55fb80c3d0c8c8e61078b3f38adde8">hwloc_pcidisc_check_bridge_type</a> (unsigned device_class, const unsigned char *config)</td></tr>
+<tr class="separator:ga6c55fb80c3d0c8c8e61078b3f38adde8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga95acf6822a49447c11067d0b843965ba" id="r_ga95acf6822a49447c11067d0b843965ba"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00224.html#ga95acf6822a49447c11067d0b843965ba">hwloc_pcidisc_find_bridge_buses</a> (unsigned domain, unsigned bus, unsigned dev, unsigned func, unsigned *secondary_busp, unsigned *subordinate_busp, const unsigned char *config)</td></tr>
+<tr class="separator:ga95acf6822a49447c11067d0b843965ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gab76ddc4f55db8101ef0d44317965128c" id="r_gab76ddc4f55db8101ef0d44317965128c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00224.html#gab76ddc4f55db8101ef0d44317965128c">hwloc_pcidisc_tree_insert_by_busid</a> (struct <a class="el" href="a00229.html">hwloc_obj</a> **treep, struct <a class="el" href="a00229.html">hwloc_obj</a> *obj)</td></tr>
+<tr class="separator:gab76ddc4f55db8101ef0d44317965128c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gabda1d6c1799e50b9226f8a4da9bd29ea" id="r_gabda1d6c1799e50b9226f8a4da9bd29ea"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00224.html#gabda1d6c1799e50b9226f8a4da9bd29ea">hwloc_pcidisc_tree_attach</a> (struct hwloc_topology *topology, struct <a class="el" href="a00229.html">hwloc_obj</a> *tree)</td></tr>
+<tr class="separator:gabda1d6c1799e50b9226f8a4da9bd29ea"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<dl class="section note"><dt>Note</dt><dd>These structures and functions may change when <a class="el" href="a00171.html#gaac5bc1f46f55e10ef0141a68ce70e21f" title="Current component and plugin ABI version (see hwloc/plugins.h)">HWLOC_COMPONENT_ABI</a> is modified. </dd></dl>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga6c55fb80c3d0c8c8e61078b3f38adde8" name="ga6c55fb80c3d0c8c8e61078b3f38adde8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga6c55fb80c3d0c8c8e61078b3f38adde8">&#9670;&#160;</a></span>hwloc_pcidisc_check_bridge_type()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> hwloc_pcidisc_check_bridge_type </td>
+          <td>(</td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>device_class</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const unsigned char *&#160;</td>
+          <td class="paramname"><em>config</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return the hwloc object type (PCI device or Bridge) for the given class and configuration space. </p>
+<p>This function requires 16 bytes of common configuration header at the beginning of config. </p>
+
+</div>
+</div>
+<a id="ga95acf6822a49447c11067d0b843965ba" name="ga95acf6822a49447c11067d0b843965ba"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga95acf6822a49447c11067d0b843965ba">&#9670;&#160;</a></span>hwloc_pcidisc_find_bridge_buses()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_pcidisc_find_bridge_buses </td>
+          <td>(</td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>domain</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>bus</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>dev</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>func</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>secondary_busp</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned *&#160;</td>
+          <td class="paramname"><em>subordinate_busp</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const unsigned char *&#160;</td>
+          <td class="paramname"><em>config</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Fills the attributes of the given PCI bridge using the given PCI config space. </p>
+<p>This function requires 32 bytes of common configuration header at the beginning of config.</p>
+<p>Returns -1 and destroys /p obj if bridge fields are invalid. </p>
+
+</div>
+</div>
+<a id="ga706f71cfea09d547d2cbafa642d6e03b" name="ga706f71cfea09d547d2cbafa642d6e03b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga706f71cfea09d547d2cbafa642d6e03b">&#9670;&#160;</a></span>hwloc_pcidisc_find_cap()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_pcidisc_find_cap </td>
+          <td>(</td>
+          <td class="paramtype">const unsigned char *&#160;</td>
+          <td class="paramname"><em>config</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>cap</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Return the offset of the given capability in the PCI config space buffer. </p>
+<p>This function requires a 256-bytes config space. Unknown/unavailable bytes should be set to 0xff. </p>
+
+</div>
+</div>
+<a id="ga51d1ebcbf9729987c9d17df3aa57d209" name="ga51d1ebcbf9729987c9d17df3aa57d209"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga51d1ebcbf9729987c9d17df3aa57d209">&#9670;&#160;</a></span>hwloc_pcidisc_find_linkspeed()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_pcidisc_find_linkspeed </td>
+          <td>(</td>
+          <td class="paramtype">const unsigned char *&#160;</td>
+          <td class="paramname"><em>config</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>offset</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">float *&#160;</td>
+          <td class="paramname"><em>linkspeed</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Fill linkspeed by reading the PCI config space where PCI_CAP_ID_EXP is at position offset. </p>
+<p>Needs 20 bytes of EXP capability block starting at offset in the config space for registers up to link status. </p>
+
+</div>
+</div>
+<a id="gabda1d6c1799e50b9226f8a4da9bd29ea" name="gabda1d6c1799e50b9226f8a4da9bd29ea"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gabda1d6c1799e50b9226f8a4da9bd29ea">&#9670;&#160;</a></span>hwloc_pcidisc_tree_attach()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_pcidisc_tree_attach </td>
+          <td>(</td>
+          <td class="paramtype">struct hwloc_topology *&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td>
+          <td class="paramname"><em>tree</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Add some hostbridges on top of the given tree of PCI objects and attach them to the topology. </p>
+<p>Other backends may lookup PCI objects or localities (for instance to attach OS devices) by using hwloc_pcidisc_find_by_busid() or hwloc_pcidisc_find_busid_parent(). </p>
+
+</div>
+</div>
+<a id="gab76ddc4f55db8101ef0d44317965128c" name="gab76ddc4f55db8101ef0d44317965128c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gab76ddc4f55db8101ef0d44317965128c">&#9670;&#160;</a></span>hwloc_pcidisc_tree_insert_by_busid()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void hwloc_pcidisc_tree_insert_by_busid </td>
+          <td>(</td>
+          <td class="paramtype">struct <a class="el" href="a00229.html">hwloc_obj</a> **&#160;</td>
+          <td class="paramname"><em>treep</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td>
+          <td class="paramname"><em>obj</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Insert a PCI object in the given PCI tree by looking at PCI bus IDs. </p>
+<p>If <code>treep</code> points to <code>NULL</code>, the new object is inserted there. </p>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00225.html 2.11.0-1/doc/doxygen-doc/html/a00225.html
--- 2.10.0-1/doc/doxygen-doc/html/a00225.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00225.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,328 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Components and Plugins: finding PCI objects during other discoveries</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#typedef-members">Typedefs</a> &#124;
+<a href="#func-members">Functions</a>  </div>
+  <div class="headertitle"><div class="title">Components and Plugins: finding PCI objects during other discoveries</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="typedef-members" name="typedef-members"></a>
+Typedefs</h2></td></tr>
+<tr class="memitem:gafe5e49d32dd0a28ead94b6e31048e042" id="r_gafe5e49d32dd0a28ead94b6e31048e042"><td class="memItemLeft" align="right" valign="top">typedef void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a></td></tr>
+<tr class="separator:gafe5e49d32dd0a28ead94b6e31048e042"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
+Functions</h2></td></tr>
+<tr class="memitem:ga5062f8cb07418b9cb01657d363d0f969" id="r_ga5062f8cb07418b9cb01657d363d0f969"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00225.html#ga5062f8cb07418b9cb01657d363d0f969">hwloc_pci_find_parent_by_busid</a> (struct hwloc_topology *topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)</td></tr>
+<tr class="separator:ga5062f8cb07418b9cb01657d363d0f969"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1779bc839369b3edcea1545a04ea123c" id="r_ga1779bc839369b3edcea1545a04ea123c"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00225.html#ga1779bc839369b3edcea1545a04ea123c">hwloc_pci_find_by_busid</a> (struct hwloc_topology *topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)</td></tr>
+<tr class="separator:ga1779bc839369b3edcea1545a04ea123c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa66a0bd519a5b1183a3e9b0c35a7f6cc" id="r_gaa66a0bd519a5b1183a3e9b0c35a7f6cc"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00225.html#gaa66a0bd519a5b1183a3e9b0c35a7f6cc">hwloc_backend_distances_add_create</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, const char *name, unsigned long kind, unsigned long flags)</td></tr>
+<tr class="separator:gaa66a0bd519a5b1183a3e9b0c35a7f6cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:gaa27036bd83102f8e406f1051d560da6c" id="r_gaa27036bd83102f8e406f1051d560da6c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00225.html#gaa27036bd83102f8e406f1051d560da6c">hwloc_backend_distances_add_values</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a> handle, unsigned nbobjs, <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *objs, hwloc_uint64_t *values, unsigned long flags)</td></tr>
+<tr class="separator:gaa27036bd83102f8e406f1051d560da6c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3" id="r_ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00225.html#ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3">hwloc_backend_distances_add_commit</a> (<a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="el" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a> handle, unsigned long flags)</td></tr>
+<tr class="separator:ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<dl class="section note"><dt>Note</dt><dd>These structures and functions may change when <a class="el" href="a00171.html#gaac5bc1f46f55e10ef0141a68ce70e21f" title="Current component and plugin ABI version (see hwloc/plugins.h)">HWLOC_COMPONENT_ABI</a> is modified. </dd></dl>
+<h2 class="groupheader">Typedef Documentation</h2>
+<a id="gafe5e49d32dd0a28ead94b6e31048e042" name="gafe5e49d32dd0a28ead94b6e31048e042"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gafe5e49d32dd0a28ead94b6e31048e042">&#9670;&#160;</a></span>hwloc_backend_distances_add_handle_t</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">typedef void* <a class="el" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Handle to a new distances structure during its addition to the topology. </p>
+
+</div>
+</div>
+<h2 class="groupheader">Function Documentation</h2>
+<a id="ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3" name="ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3">&#9670;&#160;</a></span>hwloc_backend_distances_add_commit()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_backend_distances_add_commit </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a>&#160;</td>
+          <td class="paramname"><em>handle</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Commit a new distances structure. </p>
+<p>This is similar to <a class="el" href="a00199.html#ga1f5a29760ebb8f9af831e645315f553c" title="Commit a new distances structure.">hwloc_distances_add_commit()</a> but this variant is designed for backend inserting distances during topology discovery. </p>
+
+</div>
+</div>
+<a id="gaa66a0bd519a5b1183a3e9b0c35a7f6cc" name="gaa66a0bd519a5b1183a3e9b0c35a7f6cc"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa66a0bd519a5b1183a3e9b0c35a7f6cc">&#9670;&#160;</a></span>hwloc_backend_distances_add_create()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a> hwloc_backend_distances_add_create </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">const char *&#160;</td>
+          <td class="paramname"><em>name</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>kind</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Create a new empty distances structure. </p>
+<p>This is identical to <a class="el" href="a00199.html#ga823d38fa8d21dc338497fb0f79c96704" title="Create a new empty distances structure.">hwloc_distances_add_create()</a> but this variant is designed for backend inserting distances during topology discovery. </p>
+
+</div>
+</div>
+<a id="gaa27036bd83102f8e406f1051d560da6c" name="gaa27036bd83102f8e406f1051d560da6c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#gaa27036bd83102f8e406f1051d560da6c">&#9670;&#160;</a></span>hwloc_backend_distances_add_values()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_backend_distances_add_values </td>
+          <td>(</td>
+          <td class="paramtype"><a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a>&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00225.html#gafe5e49d32dd0a28ead94b6e31048e042">hwloc_backend_distances_add_handle_t</a>&#160;</td>
+          <td class="paramname"><em>handle</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>nbobjs</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *&#160;</td>
+          <td class="paramname"><em>objs</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">hwloc_uint64_t *&#160;</td>
+          <td class="paramname"><em>values</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned long&#160;</td>
+          <td class="paramname"><em>flags</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Specify the objects and values in a new empty distances structure. </p>
+<p>This is similar to <a class="el" href="a00199.html#ga8c9715481b0bce344c8a33c6e6a56469" title="Specify the objects and values in a new empty distances structure.">hwloc_distances_add_values()</a> but this variant is designed for backend inserting distances during topology discovery.</p>
+<p>The only semantical difference is that <code>objs</code> and <code>values</code> are not duplicated, but directly attached to the topology. On success, these arrays are given to the core and should not ever be freed by the caller anymore. </p>
+
+</div>
+</div>
+<a id="ga1779bc839369b3edcea1545a04ea123c" name="ga1779bc839369b3edcea1545a04ea123c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga1779bc839369b3edcea1545a04ea123c">&#9670;&#160;</a></span>hwloc_pci_find_by_busid()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a> * hwloc_pci_find_by_busid </td>
+          <td>(</td>
+          <td class="paramtype">struct hwloc_topology *&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>domain</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>bus</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>dev</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>func</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Find the PCI device or bridge matching a PCI bus ID exactly. </p>
+<p>This is useful for adding specific information about some objects based on their PCI id. When it comes to attaching objects based on PCI locality, <a class="el" href="a00225.html#ga5062f8cb07418b9cb01657d363d0f969" title="Find the object or a parent of a PCI bus ID.">hwloc_pci_find_parent_by_busid()</a> should be preferred. </p>
+
+</div>
+</div>
+<a id="ga5062f8cb07418b9cb01657d363d0f969" name="ga5062f8cb07418b9cb01657d363d0f969"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ga5062f8cb07418b9cb01657d363d0f969">&#9670;&#160;</a></span>hwloc_pci_find_parent_by_busid()</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a> * hwloc_pci_find_parent_by_busid </td>
+          <td>(</td>
+          <td class="paramtype">struct hwloc_topology *&#160;</td>
+          <td class="paramname"><em>topology</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>domain</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>bus</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>dev</em>, </td>
+        </tr>
+        <tr>
+          <td class="paramkey"></td>
+          <td></td>
+          <td class="paramtype">unsigned&#160;</td>
+          <td class="paramname"><em>func</em>&#160;</td>
+        </tr>
+        <tr>
+          <td></td>
+          <td>)</td>
+          <td></td><td></td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Find the object or a parent of a PCI bus ID. </p>
+<p>When attaching a new object (typically an OS device) whose locality is specified by PCI bus ID, this function returns the PCI object to use as a parent for attaching.</p>
+<p>If the exact PCI device with this bus ID exists, it is returned. Otherwise (for instance if it was filtered out), the function returns another object with similar locality (for instance a parent bridge, or the local CPU Package). </p>
+
+</div>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00229.html 2.11.0-1/doc/doxygen-doc/html/a00229.html
--- 2.10.0-1/doc/doxygen-doc/html/a00229.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00229.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,686 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_obj Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_obj Struct Reference<div class="ingroups"><a class="el" href="a00174.html">Object Structure and Attributes</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:acc4f0803f244867e68fe0036800be5de" id="r_acc4f0803f244867e68fe0036800be5de"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a></td></tr>
+<tr class="separator:acc4f0803f244867e68fe0036800be5de"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a5d4f97e76723a9ec8d38046f19e00d33" id="r_a5d4f97e76723a9ec8d38046f19e00d33"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a5d4f97e76723a9ec8d38046f19e00d33">subtype</a></td></tr>
+<tr class="separator:a5d4f97e76723a9ec8d38046f19e00d33"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a61a7a80a68eaccbaaa28269e678c81a9" id="r_a61a7a80a68eaccbaaa28269e678c81a9"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a></td></tr>
+<tr class="separator:a61a7a80a68eaccbaaa28269e678c81a9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:abb709ec38f2970677e4e57d1d30be96d" id="r_abb709ec38f2970677e4e57d1d30be96d"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">name</a></td></tr>
+<tr class="separator:abb709ec38f2970677e4e57d1d30be96d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a75603fc36c9284ba48ce814b772a58b6" id="r_a75603fc36c9284ba48ce814b772a58b6"><td class="memItemLeft" align="right" valign="top">hwloc_uint64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a75603fc36c9284ba48ce814b772a58b6">total_memory</a></td></tr>
+<tr class="separator:a75603fc36c9284ba48ce814b772a58b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:accd40e29f71f19e88db62ea3df02adc8" id="r_accd40e29f71f19e88db62ea3df02adc8"><td class="memItemLeft" align="right" valign="top">union <a class="el" href="a00233.html">hwloc_obj_attr_u</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a></td></tr>
+<tr class="separator:accd40e29f71f19e88db62ea3df02adc8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a4876fd165b4fff35521f07ebd85355ed" id="r_a4876fd165b4fff35521f07ebd85355ed"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">depth</a></td></tr>
+<tr class="separator:a4876fd165b4fff35521f07ebd85355ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a0d07fb7b8935e137c94d75a3eb492ae9" id="r_a0d07fb7b8935e137c94d75a3eb492ae9"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a0d07fb7b8935e137c94d75a3eb492ae9">logical_index</a></td></tr>
+<tr class="separator:a0d07fb7b8935e137c94d75a3eb492ae9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a85a788017457129589318b6c39451acf" id="r_a85a788017457129589318b6c39451acf"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a85a788017457129589318b6c39451acf">next_cousin</a></td></tr>
+<tr class="separator:a85a788017457129589318b6c39451acf"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ac715989f55ff5a0eb6be2969ee477ec0" id="r_ac715989f55ff5a0eb6be2969ee477ec0"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#ac715989f55ff5a0eb6be2969ee477ec0">prev_cousin</a></td></tr>
+<tr class="separator:ac715989f55ff5a0eb6be2969ee477ec0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:adc494f6aed939992be1c55cca5822900" id="r_adc494f6aed939992be1c55cca5822900"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a></td></tr>
+<tr class="separator:adc494f6aed939992be1c55cca5822900"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aaa6043eee6f55869933c1d974efd9acd" id="r_aaa6043eee6f55869933c1d974efd9acd"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#aaa6043eee6f55869933c1d974efd9acd">sibling_rank</a></td></tr>
+<tr class="separator:aaa6043eee6f55869933c1d974efd9acd"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a7f2343ed476fe4942e6fffd4cade1b40" id="r_a7f2343ed476fe4942e6fffd4cade1b40"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a7f2343ed476fe4942e6fffd4cade1b40">next_sibling</a></td></tr>
+<tr class="separator:a7f2343ed476fe4942e6fffd4cade1b40"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a7b89e8c189876c0158a9282aaaf17f50" id="r_a7b89e8c189876c0158a9282aaaf17f50"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a7b89e8c189876c0158a9282aaaf17f50">prev_sibling</a></td></tr>
+<tr class="separator:a7b89e8c189876c0158a9282aaaf17f50"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a0f41a1d67dc6b661906f2217563637f3" id="r_a0f41a1d67dc6b661906f2217563637f3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a0f41a1d67dc6b661906f2217563637f3">symmetric_subtree</a></td></tr>
+<tr class="separator:a0f41a1d67dc6b661906f2217563637f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a67925e0f2c47f50408fbdb9bddd0790f" id="r_a67925e0f2c47f50408fbdb9bddd0790f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a></td></tr>
+<tr class="separator:a67925e0f2c47f50408fbdb9bddd0790f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a91788a9da687beb7224cc1fd7b75208c" id="r_a91788a9da687beb7224cc1fd7b75208c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a91788a9da687beb7224cc1fd7b75208c">complete_cpuset</a></td></tr>
+<tr class="separator:a91788a9da687beb7224cc1fd7b75208c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a08f0d0e16c619a6e653526cbee4ffea3" id="r_a08f0d0e16c619a6e653526cbee4ffea3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">nodeset</a></td></tr>
+<tr class="separator:a08f0d0e16c619a6e653526cbee4ffea3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ac38c4012127525ef74c5615c526f4c2e" id="r_ac38c4012127525ef74c5615c526f4c2e"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#ac38c4012127525ef74c5615c526f4c2e">complete_nodeset</a></td></tr>
+<tr class="separator:ac38c4012127525ef74c5615c526f4c2e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a8604654c38b7a720efae5025d3a96ee6" id="r_a8604654c38b7a720efae5025d3a96ee6"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00277.html">hwloc_info_s</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a8604654c38b7a720efae5025d3a96ee6">infos</a></td></tr>
+<tr class="separator:a8604654c38b7a720efae5025d3a96ee6"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a9843acc28cfbba903b63ea14b137ff70" id="r_a9843acc28cfbba903b63ea14b137ff70"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a9843acc28cfbba903b63ea14b137ff70">infos_count</a></td></tr>
+<tr class="separator:a9843acc28cfbba903b63ea14b137ff70"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a76fd3ac94401cf32dfccc3a3a8de68a5" id="r_a76fd3ac94401cf32dfccc3a3a8de68a5"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a76fd3ac94401cf32dfccc3a3a8de68a5">userdata</a></td></tr>
+<tr class="separator:a76fd3ac94401cf32dfccc3a3a8de68a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a957984a355fa61c85f46605c336e7551" id="r_a957984a355fa61c85f46605c336e7551"><td class="memItemLeft" align="right" valign="top">hwloc_uint64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a957984a355fa61c85f46605c336e7551">gp_index</a></td></tr>
+<tr class="separator:a957984a355fa61c85f46605c336e7551"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr><td colspan="2"><div class="groupHeader">List and array of normal children below this object (except Memory, I/O and Misc children).</div></td></tr>
+<tr class="memitem:aac3f6da35c9b57599909a44ce2b716c1" id="r_aac3f6da35c9b57599909a44ce2b716c1"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#aac3f6da35c9b57599909a44ce2b716c1">arity</a></td></tr>
+<tr class="separator:aac3f6da35c9b57599909a44ce2b716c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a04d05403da37bfe17cd63b7c7dd07b1f" id="r_a04d05403da37bfe17cd63b7c7dd07b1f"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> **&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a04d05403da37bfe17cd63b7c7dd07b1f">children</a></td></tr>
+<tr class="separator:a04d05403da37bfe17cd63b7c7dd07b1f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:af51d08a0a79dba517c06c5afedc8d2dc" id="r_af51d08a0a79dba517c06c5afedc8d2dc"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#af51d08a0a79dba517c06c5afedc8d2dc">first_child</a></td></tr>
+<tr class="separator:af51d08a0a79dba517c06c5afedc8d2dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a84bd65634dbc55f4158b74443a9bd04f" id="r_a84bd65634dbc55f4158b74443a9bd04f"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a84bd65634dbc55f4158b74443a9bd04f">last_child</a></td></tr>
+<tr class="separator:a84bd65634dbc55f4158b74443a9bd04f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr><td colspan="2"><div class="groupHeader">List of Memory children below this object.</div></td></tr>
+<tr class="memitem:a6f834ea4dd26553cdea601d2fae6d3b7" id="r_a6f834ea4dd26553cdea601d2fae6d3b7"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a6f834ea4dd26553cdea601d2fae6d3b7">memory_arity</a></td></tr>
+<tr class="separator:a6f834ea4dd26553cdea601d2fae6d3b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ac0e8200dba25b90d5954bd4ec61f97d3" id="r_ac0e8200dba25b90d5954bd4ec61f97d3"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#ac0e8200dba25b90d5954bd4ec61f97d3">memory_first_child</a></td></tr>
+<tr class="separator:ac0e8200dba25b90d5954bd4ec61f97d3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr><td colspan="2"><div class="groupHeader">List of I/O children below this object.</div></td></tr>
+<tr class="memitem:a7b3b29f0be377c7d2d52262019fc7d11" id="r_a7b3b29f0be377c7d2d52262019fc7d11"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a7b3b29f0be377c7d2d52262019fc7d11">io_arity</a></td></tr>
+<tr class="separator:a7b3b29f0be377c7d2d52262019fc7d11"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a8d14c88e1ebc4ae67cc69f9e928558b3" id="r_a8d14c88e1ebc4ae67cc69f9e928558b3"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a8d14c88e1ebc4ae67cc69f9e928558b3">io_first_child</a></td></tr>
+<tr class="separator:a8d14c88e1ebc4ae67cc69f9e928558b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr><td colspan="2"><div class="groupHeader">List of Misc children below this object.</div></td></tr>
+<tr class="memitem:a2bb7862ce722d7ceda23cfa153da165a" id="r_a2bb7862ce722d7ceda23cfa153da165a"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a2bb7862ce722d7ceda23cfa153da165a">misc_arity</a></td></tr>
+<tr class="separator:a2bb7862ce722d7ceda23cfa153da165a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a57812a313fe9b1a9500489f47c3011cc" id="r_a57812a313fe9b1a9500489f47c3011cc"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00229.html">hwloc_obj</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00229.html#a57812a313fe9b1a9500489f47c3011cc">misc_first_child</a></td></tr>
+<tr class="separator:a57812a313fe9b1a9500489f47c3011cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Structure of a topology object. </p>
+<p>Applications must not modify any field except <code><a class="el" href="a00229.html#a76fd3ac94401cf32dfccc3a3a8de68a5" title="Application-given private data pointer, initialized to NULL, use it as you wish. See hwloc_topology_s...">hwloc_obj.userdata</a></code>. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="aac3f6da35c9b57599909a44ce2b716c1" name="aac3f6da35c9b57599909a44ce2b716c1"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aac3f6da35c9b57599909a44ce2b716c1">&#9670;&#160;</a></span>arity</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj::arity</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Number of normal children. Memory, Misc and I/O children are not listed here but rather in their dedicated children list. </p>
+
+</div>
+</div>
+<a id="accd40e29f71f19e88db62ea3df02adc8" name="accd40e29f71f19e88db62ea3df02adc8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#accd40e29f71f19e88db62ea3df02adc8">&#9670;&#160;</a></span>attr</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">union <a class="el" href="a00233.html">hwloc_obj_attr_u</a>* hwloc_obj::attr</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Object type-specific Attributes, may be <code>NULL</code> if no attribute value was found. </p>
+
+</div>
+</div>
+<a id="a04d05403da37bfe17cd63b7c7dd07b1f" name="a04d05403da37bfe17cd63b7c7dd07b1f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a04d05403da37bfe17cd63b7c7dd07b1f">&#9670;&#160;</a></span>children</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a>** hwloc_obj::children</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Normal children, <code>children</code>[0 .. arity -1]. </p>
+
+</div>
+</div>
+<a id="a91788a9da687beb7224cc1fd7b75208c" name="a91788a9da687beb7224cc1fd7b75208c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a91788a9da687beb7224cc1fd7b75208c">&#9670;&#160;</a></span>complete_cpuset</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> hwloc_obj::complete_cpuset</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>The complete CPU set of processors of this object,. </p>
+<p>This may include not only the same as the cpuset field, but also some CPUs for which topology information is unknown or incomplete, some offlines CPUs, and the CPUs that are ignored when the <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258" title="Detect the whole system, ignore reservations, include disallowed objects.">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a> flag is not set. Thus no corresponding PU object may be found in the topology, because the precise position is undefined. It is however known that it would be somewhere under this object.</p>
+<dl class="section note"><dt>Note</dt><dd>Its value must not be changed, <a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee" title="Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.">hwloc_bitmap_dup()</a> must be used instead. </dd></dl>
+
+</div>
+</div>
+<a id="ac38c4012127525ef74c5615c526f4c2e" name="ac38c4012127525ef74c5615c526f4c2e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ac38c4012127525ef74c5615c526f4c2e">&#9670;&#160;</a></span>complete_nodeset</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a> hwloc_obj::complete_nodeset</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>The complete NUMA node set of this object,. </p>
+<p>This may include not only the same as the nodeset field, but also some NUMA nodes for which topology information is unknown or incomplete, some offlines nodes, and the nodes that are ignored when the <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258" title="Detect the whole system, ignore reservations, include disallowed objects.">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a> flag is not set. Thus no corresponding NUMA node object may be found in the topology, because the precise position is undefined. It is however known that it would be somewhere under this object.</p>
+<p>If there are no NUMA nodes in the machine, all the memory is close to this object, so only the first bit is set in <code>complete_nodeset</code>.</p>
+<dl class="section note"><dt>Note</dt><dd>Its value must not be changed, <a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee" title="Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.">hwloc_bitmap_dup()</a> must be used instead. </dd></dl>
+
+</div>
+</div>
+<a id="a67925e0f2c47f50408fbdb9bddd0790f" name="a67925e0f2c47f50408fbdb9bddd0790f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a67925e0f2c47f50408fbdb9bddd0790f">&#9670;&#160;</a></span>cpuset</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> hwloc_obj::cpuset</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>CPUs covered by this object. </p>
+<p>This is the set of CPUs for which there are PU objects in the topology under this object, i.e. which are known to be physically contained in this object and known how (the children path between this object and the PU objects).</p>
+<p>If the <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258" title="Detect the whole system, ignore reservations, include disallowed objects.">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a> configuration flag is set, some of these CPUs may be online but not allowed for binding, see <a class="el" href="a00191.html#ga517d5d68ec9f24583d8933aab713be8e" title="Get allowed CPU set.">hwloc_topology_get_allowed_cpuset()</a>.</p>
+<dl class="section note"><dt>Note</dt><dd>All objects have non-NULL CPU and node sets except Misc and I/O objects.</dd>
+<dd>
+Its value must not be changed, <a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee" title="Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.">hwloc_bitmap_dup()</a> must be used instead. </dd></dl>
+
+</div>
+</div>
+<a id="a4876fd165b4fff35521f07ebd85355ed" name="a4876fd165b4fff35521f07ebd85355ed"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a4876fd165b4fff35521f07ebd85355ed">&#9670;&#160;</a></span>depth</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj::depth</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Vertical index in the hierarchy. </p>
+<p>For normal objects, this is the depth of the horizontal level that contains this object and its cousins of the same type. If the topology is symmetric, this is equal to the parent depth plus one, and also equal to the number of parent/child links from the root object to here.</p>
+<p>For special objects (NUMA nodes, I/O and Misc) that are not in the main tree, this is a special negative value that corresponds to their dedicated level, see <a class="el" href="a00176.html#ga8bec782e21be313750da70cf7428b374" title="Returns the depth of objects of type type.">hwloc_get_type_depth()</a> and <a class="el" href="a00176.html#gaf4e663cf42bbe20756b849c6293ef575">hwloc_get_type_depth_e</a>. Those special values can be passed to hwloc functions such <a class="el" href="a00176.html#ga1d5ceafe8130fe6e8657bf0bc666ba50" title="Returns the width of level at depth depth.">hwloc_get_nbobjs_by_depth()</a> as usual. </p>
+
+</div>
+</div>
+<a id="af51d08a0a79dba517c06c5afedc8d2dc" name="af51d08a0a79dba517c06c5afedc8d2dc"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#af51d08a0a79dba517c06c5afedc8d2dc">&#9670;&#160;</a></span>first_child</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a>* hwloc_obj::first_child</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>First normal child. </p>
+
+</div>
+</div>
+<a id="a957984a355fa61c85f46605c336e7551" name="a957984a355fa61c85f46605c336e7551"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a957984a355fa61c85f46605c336e7551">&#9670;&#160;</a></span>gp_index</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">hwloc_uint64_t hwloc_obj::gp_index</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Global persistent index. Generated by hwloc, unique across the topology (contrary to os_index) and persistent across topology changes (contrary to logical_index). Mostly used internally, but could also be used by application to identify objects. </p>
+
+</div>
+</div>
+<a id="a8604654c38b7a720efae5025d3a96ee6" name="a8604654c38b7a720efae5025d3a96ee6"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a8604654c38b7a720efae5025d3a96ee6">&#9670;&#160;</a></span>infos</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00277.html">hwloc_info_s</a>* hwloc_obj::infos</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Array of info attributes (name and value strings). </p>
+
+</div>
+</div>
+<a id="a9843acc28cfbba903b63ea14b137ff70" name="a9843acc28cfbba903b63ea14b137ff70"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a9843acc28cfbba903b63ea14b137ff70">&#9670;&#160;</a></span>infos_count</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj::infos_count</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Size of infos array. </p>
+
+</div>
+</div>
+<a id="a7b3b29f0be377c7d2d52262019fc7d11" name="a7b3b29f0be377c7d2d52262019fc7d11"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a7b3b29f0be377c7d2d52262019fc7d11">&#9670;&#160;</a></span>io_arity</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj::io_arity</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Number of I/O children. These children are listed in <code>io_first_child</code>. </p>
+
+</div>
+</div>
+<a id="a8d14c88e1ebc4ae67cc69f9e928558b3" name="a8d14c88e1ebc4ae67cc69f9e928558b3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a8d14c88e1ebc4ae67cc69f9e928558b3">&#9670;&#160;</a></span>io_first_child</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a>* hwloc_obj::io_first_child</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>First I/O child. Bridges, PCI and OS devices are listed here (<code>io_arity</code> and <code>io_first_child</code>) instead of in the normal children list. See also <a class="el" href="a00184.html#gac8a954ed37a4376097234c828068cbef" title="Check whether an object type is I/O.">hwloc_obj_type_is_io()</a>. </p>
+
+</div>
+</div>
+<a id="a84bd65634dbc55f4158b74443a9bd04f" name="a84bd65634dbc55f4158b74443a9bd04f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a84bd65634dbc55f4158b74443a9bd04f">&#9670;&#160;</a></span>last_child</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a>* hwloc_obj::last_child</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Last normal child. </p>
+
+</div>
+</div>
+<a id="a0d07fb7b8935e137c94d75a3eb492ae9" name="a0d07fb7b8935e137c94d75a3eb492ae9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a0d07fb7b8935e137c94d75a3eb492ae9">&#9670;&#160;</a></span>logical_index</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj::logical_index</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Horizontal index in the whole list of similar objects, hence guaranteed unique across the entire machine. Could be a "cousin_rank" since it's the rank within the "cousin" list below Note that this index may change when restricting the topology or when inserting a group. </p>
+
+</div>
+</div>
+<a id="a6f834ea4dd26553cdea601d2fae6d3b7" name="a6f834ea4dd26553cdea601d2fae6d3b7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a6f834ea4dd26553cdea601d2fae6d3b7">&#9670;&#160;</a></span>memory_arity</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj::memory_arity</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Number of Memory children. These children are listed in <code>memory_first_child</code>. </p>
+
+</div>
+</div>
+<a id="ac0e8200dba25b90d5954bd4ec61f97d3" name="ac0e8200dba25b90d5954bd4ec61f97d3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ac0e8200dba25b90d5954bd4ec61f97d3">&#9670;&#160;</a></span>memory_first_child</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a>* hwloc_obj::memory_first_child</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>First Memory child. NUMA nodes and Memory-side caches are listed here (<code>memory_arity</code> and <code>memory_first_child</code>) instead of in the normal children list. See also <a class="el" href="a00184.html#ga1d074390c8a3dc3088d84f73fb73f966" title="Check whether an object type is Memory.">hwloc_obj_type_is_memory()</a>. </p>
+<p>A memory hierarchy starts from a normal CPU-side object (e.g. Package) and ends with NUMA nodes as leaves. There might exist some memory-side caches between them in the middle of the memory subtree. </p>
+
+</div>
+</div>
+<a id="a2bb7862ce722d7ceda23cfa153da165a" name="a2bb7862ce722d7ceda23cfa153da165a"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a2bb7862ce722d7ceda23cfa153da165a">&#9670;&#160;</a></span>misc_arity</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj::misc_arity</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Number of Misc children. These children are listed in <code>misc_first_child</code>. </p>
+
+</div>
+</div>
+<a id="a57812a313fe9b1a9500489f47c3011cc" name="a57812a313fe9b1a9500489f47c3011cc"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a57812a313fe9b1a9500489f47c3011cc">&#9670;&#160;</a></span>misc_first_child</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a>* hwloc_obj::misc_first_child</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>First Misc child. Misc objects are listed here (<code>misc_arity</code> and <code>misc_first_child</code>) instead of in the normal children list. </p>
+
+</div>
+</div>
+<a id="abb709ec38f2970677e4e57d1d30be96d" name="abb709ec38f2970677e4e57d1d30be96d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#abb709ec38f2970677e4e57d1d30be96d">&#9670;&#160;</a></span>name</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">char* hwloc_obj::name</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Object-specific name if any. Mostly used for identifying OS devices and Misc objects where a name string is more useful than numerical indexes. </p>
+
+</div>
+</div>
+<a id="a85a788017457129589318b6c39451acf" name="a85a788017457129589318b6c39451acf"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a85a788017457129589318b6c39451acf">&#9670;&#160;</a></span>next_cousin</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a>* hwloc_obj::next_cousin</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Next object of same type and depth. </p>
+
+</div>
+</div>
+<a id="a7f2343ed476fe4942e6fffd4cade1b40" name="a7f2343ed476fe4942e6fffd4cade1b40"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a7f2343ed476fe4942e6fffd4cade1b40">&#9670;&#160;</a></span>next_sibling</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a>* hwloc_obj::next_sibling</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Next object below the same parent (inside the same list of children). </p>
+
+</div>
+</div>
+<a id="a08f0d0e16c619a6e653526cbee4ffea3" name="a08f0d0e16c619a6e653526cbee4ffea3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a08f0d0e16c619a6e653526cbee4ffea3">&#9670;&#160;</a></span>nodeset</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00172.html#ga37e35730fa7e775b5bb0afe893d6d508">hwloc_nodeset_t</a> hwloc_obj::nodeset</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>NUMA nodes covered by this object or containing this object. </p>
+<p>This is the set of NUMA nodes for which there are NUMA node objects in the topology under or above this object, i.e. which are known to be physically contained in this object or containing it and known how (the children path between this object and the NUMA node objects).</p>
+<p>In the end, these nodes are those that are close to the current object. Function <a class="el" href="a00201.html#ga569e80c5be7ef27649b0ef5aa52ffcdc" title="Return an array of local NUMA nodes.">hwloc_get_local_numanode_objs()</a> may be used to list those NUMA nodes more precisely.</p>
+<p>If the <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258" title="Detect the whole system, ignore reservations, include disallowed objects.">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a> configuration flag is set, some of these nodes may be online but not allowed for allocation, see <a class="el" href="a00191.html#ga21a4d7237a11e76b912ed4524ab78cbd" title="Get allowed node set.">hwloc_topology_get_allowed_nodeset()</a>.</p>
+<p>If there are no NUMA nodes in the machine, all the memory is close to this object, so only the first bit may be set in <code>nodeset</code>.</p>
+<dl class="section note"><dt>Note</dt><dd>All objects have non-NULL CPU and node sets except Misc and I/O objects.</dd>
+<dd>
+Its value must not be changed, <a class="el" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee" title="Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.">hwloc_bitmap_dup()</a> must be used instead. </dd></dl>
+
+</div>
+</div>
+<a id="a61a7a80a68eaccbaaa28269e678c81a9" name="a61a7a80a68eaccbaaa28269e678c81a9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a61a7a80a68eaccbaaa28269e678c81a9">&#9670;&#160;</a></span>os_index</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj::os_index</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>OS-provided physical index number. It is not guaranteed unique across the entire machine, except for PUs and NUMA nodes. Set to HWLOC_UNKNOWN_INDEX if unknown or irrelevant for this object. </p>
+
+</div>
+</div>
+<a id="adc494f6aed939992be1c55cca5822900" name="adc494f6aed939992be1c55cca5822900"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#adc494f6aed939992be1c55cca5822900">&#9670;&#160;</a></span>parent</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a>* hwloc_obj::parent</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Parent, <code>NULL</code> if root (Machine object) </p>
+
+</div>
+</div>
+<a id="ac715989f55ff5a0eb6be2969ee477ec0" name="ac715989f55ff5a0eb6be2969ee477ec0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ac715989f55ff5a0eb6be2969ee477ec0">&#9670;&#160;</a></span>prev_cousin</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a>* hwloc_obj::prev_cousin</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Previous object of same type and depth. </p>
+
+</div>
+</div>
+<a id="a7b89e8c189876c0158a9282aaaf17f50" name="a7b89e8c189876c0158a9282aaaf17f50"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a7b89e8c189876c0158a9282aaaf17f50">&#9670;&#160;</a></span>prev_sibling</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00229.html">hwloc_obj</a>* hwloc_obj::prev_sibling</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Previous object below the same parent (inside the same list of children). </p>
+
+</div>
+</div>
+<a id="aaa6043eee6f55869933c1d974efd9acd" name="aaa6043eee6f55869933c1d974efd9acd"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aaa6043eee6f55869933c1d974efd9acd">&#9670;&#160;</a></span>sibling_rank</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj::sibling_rank</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Index in parent's <code>children</code>[] array. Or the index in parent's Memory, I/O or Misc children list. </p>
+
+</div>
+</div>
+<a id="a5d4f97e76723a9ec8d38046f19e00d33" name="a5d4f97e76723a9ec8d38046f19e00d33"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a5d4f97e76723a9ec8d38046f19e00d33">&#9670;&#160;</a></span>subtype</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">char* hwloc_obj::subtype</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Subtype string to better describe the type field. </p>
+
+</div>
+</div>
+<a id="a0f41a1d67dc6b661906f2217563637f3" name="a0f41a1d67dc6b661906f2217563637f3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a0f41a1d67dc6b661906f2217563637f3">&#9670;&#160;</a></span>symmetric_subtree</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj::symmetric_subtree</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Set if the subtree of normal objects below this object is symmetric, which means all normal children and their children have identical subtrees. </p>
+<p>Memory, I/O and Misc children are ignored.</p>
+<p>If set in the topology root object, lstopo may export the topology as a synthetic string. </p>
+
+</div>
+</div>
+<a id="a75603fc36c9284ba48ce814b772a58b6" name="a75603fc36c9284ba48ce814b772a58b6"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a75603fc36c9284ba48ce814b772a58b6">&#9670;&#160;</a></span>total_memory</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">hwloc_uint64_t hwloc_obj::total_memory</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Total memory (in bytes) in NUMA nodes below this object. </p>
+
+</div>
+</div>
+<a id="acc4f0803f244867e68fe0036800be5de" name="acc4f0803f244867e68fe0036800be5de"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#acc4f0803f244867e68fe0036800be5de">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55">hwloc_obj_type_t</a> hwloc_obj::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of object. </p>
+
+</div>
+</div>
+<a id="a76fd3ac94401cf32dfccc3a3a8de68a5" name="a76fd3ac94401cf32dfccc3a3a8de68a5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a76fd3ac94401cf32dfccc3a3a8de68a5">&#9670;&#160;</a></span>userdata</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void* hwloc_obj::userdata</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Application-given private data pointer, initialized to <code>NULL</code>, use it as you wish. See <a class="el" href="a00195.html#ga9d6ff0f7a8dd45be9aa8575ef31978cc" title="Set the application-specific callback for exporting object userdata.">hwloc_topology_set_userdata_export_callback()</a> in <a class="el" href="a00113_source.html">hwloc/export.h</a> if you wish to export this field to XML. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00233.html 2.11.0-1/doc/doxygen-doc/html/a00233.html
--- 2.10.0-1/doc/doxygen-doc/html/a00233.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00233.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,177 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_obj_attr_u Union Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_obj_attr_u Union Reference<div class="ingroups"><a class="el" href="a00174.html">Object Structure and Attributes</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00257.html">hwloc_bridge_attr_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00245.html">hwloc_cache_attr_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00249.html">hwloc_group_attr_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00237.html">hwloc_numanode_attr_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00273.html">hwloc_osdev_attr_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html">hwloc_pcidev_attr_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:ad066b9612802ffa01e132dc3a8e6cc86" id="r_ad066b9612802ffa01e132dc3a8e6cc86"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00237.html">hwloc_obj_attr_u::hwloc_numanode_attr_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00233.html#ad066b9612802ffa01e132dc3a8e6cc86">numanode</a></td></tr>
+<tr class="separator:ad066b9612802ffa01e132dc3a8e6cc86"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a23f553f3252c9d13f2338231cd354ea9" id="r_a23f553f3252c9d13f2338231cd354ea9"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00245.html">hwloc_obj_attr_u::hwloc_cache_attr_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">cache</a></td></tr>
+<tr class="separator:a23f553f3252c9d13f2338231cd354ea9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a9eddbd69e34cd2ef6af6d2ac31b6eff3" id="r_a9eddbd69e34cd2ef6af6d2ac31b6eff3"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00249.html">hwloc_obj_attr_u::hwloc_group_attr_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00233.html#a9eddbd69e34cd2ef6af6d2ac31b6eff3">group</a></td></tr>
+<tr class="separator:a9eddbd69e34cd2ef6af6d2ac31b6eff3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a0b66da7ab072f7c016f8ed86701f5a7c" id="r_a0b66da7ab072f7c016f8ed86701f5a7c"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00253.html">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">pcidev</a></td></tr>
+<tr class="separator:a0b66da7ab072f7c016f8ed86701f5a7c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a207e6359497b7116d6f4baa9e8bbeb43" id="r_a207e6359497b7116d6f4baa9e8bbeb43"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00257.html">hwloc_obj_attr_u::hwloc_bridge_attr_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00233.html#a207e6359497b7116d6f4baa9e8bbeb43">bridge</a></td></tr>
+<tr class="separator:a207e6359497b7116d6f4baa9e8bbeb43"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aaf7a5c38b5185703ff18c46ad2761dcf" id="r_aaf7a5c38b5185703ff18c46ad2761dcf"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00273.html">hwloc_obj_attr_u::hwloc_osdev_attr_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">osdev</a></td></tr>
+<tr class="separator:aaf7a5c38b5185703ff18c46ad2761dcf"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Object type-specific Attributes. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a207e6359497b7116d6f4baa9e8bbeb43" name="a207e6359497b7116d6f4baa9e8bbeb43"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a207e6359497b7116d6f4baa9e8bbeb43">&#9670;&#160;</a></span>bridge</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00257.html">hwloc_obj_attr_u::hwloc_bridge_attr_s</a> hwloc_obj_attr_u::bridge</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a23f553f3252c9d13f2338231cd354ea9" name="a23f553f3252c9d13f2338231cd354ea9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a23f553f3252c9d13f2338231cd354ea9">&#9670;&#160;</a></span>cache</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00245.html">hwloc_obj_attr_u::hwloc_cache_attr_s</a> hwloc_obj_attr_u::cache</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a9eddbd69e34cd2ef6af6d2ac31b6eff3" name="a9eddbd69e34cd2ef6af6d2ac31b6eff3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a9eddbd69e34cd2ef6af6d2ac31b6eff3">&#9670;&#160;</a></span>group</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00249.html">hwloc_obj_attr_u::hwloc_group_attr_s</a> hwloc_obj_attr_u::group</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="ad066b9612802ffa01e132dc3a8e6cc86" name="ad066b9612802ffa01e132dc3a8e6cc86"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ad066b9612802ffa01e132dc3a8e6cc86">&#9670;&#160;</a></span>numanode</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00237.html">hwloc_obj_attr_u::hwloc_numanode_attr_s</a> hwloc_obj_attr_u::numanode</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="aaf7a5c38b5185703ff18c46ad2761dcf" name="aaf7a5c38b5185703ff18c46ad2761dcf"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aaf7a5c38b5185703ff18c46ad2761dcf">&#9670;&#160;</a></span>osdev</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00273.html">hwloc_obj_attr_u::hwloc_osdev_attr_s</a> hwloc_obj_attr_u::osdev</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a0b66da7ab072f7c016f8ed86701f5a7c" name="a0b66da7ab072f7c016f8ed86701f5a7c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a0b66da7ab072f7c016f8ed86701f5a7c">&#9670;&#160;</a></span>pcidev</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00253.html">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a> hwloc_obj_attr_u::pcidev</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this union was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00237.html 2.11.0-1/doc/doxygen-doc/html/a00237.html
--- 2.10.0-1/doc/doxygen-doc/html/a00237.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00237.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,127 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_obj_attr_u::hwloc_numanode_attr_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00233.html">hwloc_obj_attr_u</a></li><li class="navelem"><a class="el" href="a00237.html">hwloc_numanode_attr_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_obj_attr_u::hwloc_numanode_attr_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00241.html">hwloc_memory_page_type_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a6703cbf2afbf63c9d60c5ff4dc0c73aa" id="r_a6703cbf2afbf63c9d60c5ff4dc0c73aa"><td class="memItemLeft" align="right" valign="top">hwloc_uint64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00237.html#a6703cbf2afbf63c9d60c5ff4dc0c73aa">local_memory</a></td></tr>
+<tr class="separator:a6703cbf2afbf63c9d60c5ff4dc0c73aa"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a513078122d403904e16723d30f583cb2" id="r_a513078122d403904e16723d30f583cb2"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00237.html#a513078122d403904e16723d30f583cb2">page_types_len</a></td></tr>
+<tr class="separator:a513078122d403904e16723d30f583cb2"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a7e53c5024da2d7741a5cc1e7016bb8d2" id="r_a7e53c5024da2d7741a5cc1e7016bb8d2"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00241.html">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00237.html#a7e53c5024da2d7741a5cc1e7016bb8d2">page_types</a></td></tr>
+<tr class="separator:a7e53c5024da2d7741a5cc1e7016bb8d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>NUMA node-specific Object Attributes. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a6703cbf2afbf63c9d60c5ff4dc0c73aa" name="a6703cbf2afbf63c9d60c5ff4dc0c73aa"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a6703cbf2afbf63c9d60c5ff4dc0c73aa">&#9670;&#160;</a></span>local_memory</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">hwloc_uint64_t hwloc_obj_attr_u::hwloc_numanode_attr_s::local_memory</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Local memory (in bytes) </p>
+
+</div>
+</div>
+<a id="a7e53c5024da2d7741a5cc1e7016bb8d2" name="a7e53c5024da2d7741a5cc1e7016bb8d2"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a7e53c5024da2d7741a5cc1e7016bb8d2">&#9670;&#160;</a></span>page_types</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00241.html">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s</a> * hwloc_obj_attr_u::hwloc_numanode_attr_s::page_types</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a513078122d403904e16723d30f583cb2" name="a513078122d403904e16723d30f583cb2"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a513078122d403904e16723d30f583cb2">&#9670;&#160;</a></span>page_types_len</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj_attr_u::hwloc_numanode_attr_s::page_types_len</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Size of array <code>page_types</code>. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00241.html 2.11.0-1/doc/doxygen-doc/html/a00241.html
--- 2.10.0-1/doc/doxygen-doc/html/a00241.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00241.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,106 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00233.html">hwloc_obj_attr_u</a></li><li class="navelem"><a class="el" href="a00237.html">hwloc_numanode_attr_s</a></li><li class="navelem"><a class="el" href="a00241.html">hwloc_memory_page_type_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a8ea7ebe9d91c7378bba03da57efc25cb" id="r_a8ea7ebe9d91c7378bba03da57efc25cb"><td class="memItemLeft" align="right" valign="top">hwloc_uint64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00241.html#a8ea7ebe9d91c7378bba03da57efc25cb">size</a></td></tr>
+<tr class="separator:a8ea7ebe9d91c7378bba03da57efc25cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a98514e37d57a325b78e21ffd8d7419e0" id="r_a98514e37d57a325b78e21ffd8d7419e0"><td class="memItemLeft" align="right" valign="top">hwloc_uint64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00241.html#a98514e37d57a325b78e21ffd8d7419e0">count</a></td></tr>
+<tr class="separator:a98514e37d57a325b78e21ffd8d7419e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Array of local memory page types, <code>NULL</code> if no local memory and <code>page_types</code> is 0. </p>
+<p>The array is sorted by increasing <code>size</code> fields. It contains <code>page_types_len</code> slots. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a98514e37d57a325b78e21ffd8d7419e0" name="a98514e37d57a325b78e21ffd8d7419e0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a98514e37d57a325b78e21ffd8d7419e0">&#9670;&#160;</a></span>count</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">hwloc_uint64_t hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s::count</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Number of pages of this size. </p>
+
+</div>
+</div>
+<a id="a8ea7ebe9d91c7378bba03da57efc25cb" name="a8ea7ebe9d91c7378bba03da57efc25cb"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a8ea7ebe9d91c7378bba03da57efc25cb">&#9670;&#160;</a></span>size</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">hwloc_uint64_t hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s::size</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Size of pages. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00245.html 2.11.0-1/doc/doxygen-doc/html/a00245.html
--- 2.10.0-1/doc/doxygen-doc/html/a00245.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00245.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,159 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_obj_attr_u::hwloc_cache_attr_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00233.html">hwloc_obj_attr_u</a></li><li class="navelem"><a class="el" href="a00245.html">hwloc_cache_attr_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_obj_attr_u::hwloc_cache_attr_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:abe5e788943ed04302976740c829674c0" id="r_abe5e788943ed04302976740c829674c0"><td class="memItemLeft" align="right" valign="top">hwloc_uint64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00245.html#abe5e788943ed04302976740c829674c0">size</a></td></tr>
+<tr class="separator:abe5e788943ed04302976740c829674c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a5c8f7f39193736c2187ed626940835d5" id="r_a5c8f7f39193736c2187ed626940835d5"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00245.html#a5c8f7f39193736c2187ed626940835d5">depth</a></td></tr>
+<tr class="separator:a5c8f7f39193736c2187ed626940835d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a801e8a668e28caf06c8b88e9ae5c10db" id="r_a801e8a668e28caf06c8b88e9ae5c10db"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00245.html#a801e8a668e28caf06c8b88e9ae5c10db">linesize</a></td></tr>
+<tr class="separator:a801e8a668e28caf06c8b88e9ae5c10db"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ad06525e474d1e2d1423ed71bb998592d" id="r_ad06525e474d1e2d1423ed71bb998592d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00245.html#ad06525e474d1e2d1423ed71bb998592d">associativity</a></td></tr>
+<tr class="separator:ad06525e474d1e2d1423ed71bb998592d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ad8edc8ded2b7a70d6abbc874801930f4" id="r_ad8edc8ded2b7a70d6abbc874801930f4"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00245.html#ad8edc8ded2b7a70d6abbc874801930f4">type</a></td></tr>
+<tr class="separator:ad8edc8ded2b7a70d6abbc874801930f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Cache-specific Object Attributes. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="ad06525e474d1e2d1423ed71bb998592d" name="ad06525e474d1e2d1423ed71bb998592d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ad06525e474d1e2d1423ed71bb998592d">&#9670;&#160;</a></span>associativity</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_obj_attr_u::hwloc_cache_attr_s::associativity</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Ways of associativity, -1 if fully associative, 0 if unknown. </p>
+
+</div>
+</div>
+<a id="a5c8f7f39193736c2187ed626940835d5" name="a5c8f7f39193736c2187ed626940835d5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a5c8f7f39193736c2187ed626940835d5">&#9670;&#160;</a></span>depth</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj_attr_u::hwloc_cache_attr_s::depth</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Depth of cache (e.g., L1, L2, ...etc.) </p>
+
+</div>
+</div>
+<a id="a801e8a668e28caf06c8b88e9ae5c10db" name="a801e8a668e28caf06c8b88e9ae5c10db"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a801e8a668e28caf06c8b88e9ae5c10db">&#9670;&#160;</a></span>linesize</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj_attr_u::hwloc_cache_attr_s::linesize</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Cache-line size in bytes. 0 if unknown. </p>
+
+</div>
+</div>
+<a id="abe5e788943ed04302976740c829674c0" name="abe5e788943ed04302976740c829674c0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#abe5e788943ed04302976740c829674c0">&#9670;&#160;</a></span>size</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">hwloc_uint64_t hwloc_obj_attr_u::hwloc_cache_attr_s::size</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Size of cache in bytes. </p>
+
+</div>
+</div>
+<a id="ad8edc8ded2b7a70d6abbc874801930f4" name="ad8edc8ded2b7a70d6abbc874801930f4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ad8edc8ded2b7a70d6abbc874801930f4">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00173.html#ga552ec74296a024237f474acec98694c0">hwloc_obj_cache_type_t</a> hwloc_obj_attr_u::hwloc_cache_attr_s::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Cache type. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00249.html 2.11.0-1/doc/doxygen-doc/html/a00249.html
--- 2.10.0-1/doc/doxygen-doc/html/a00249.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00249.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,141 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_obj_attr_u::hwloc_group_attr_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00233.html">hwloc_obj_attr_u</a></li><li class="navelem"><a class="el" href="a00249.html">hwloc_group_attr_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_obj_attr_u::hwloc_group_attr_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:ad914eac61c77481e1b7037877bcc5579" id="r_ad914eac61c77481e1b7037877bcc5579"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00249.html#ad914eac61c77481e1b7037877bcc5579">depth</a></td></tr>
+<tr class="separator:ad914eac61c77481e1b7037877bcc5579"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a3229f269c4cc7e63492c168535e4f0c1" id="r_a3229f269c4cc7e63492c168535e4f0c1"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00249.html#a3229f269c4cc7e63492c168535e4f0c1">kind</a></td></tr>
+<tr class="separator:a3229f269c4cc7e63492c168535e4f0c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ad514d943960a4036ed5e44dc187c74ed" id="r_ad514d943960a4036ed5e44dc187c74ed"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00249.html#ad514d943960a4036ed5e44dc187c74ed">subkind</a></td></tr>
+<tr class="separator:ad514d943960a4036ed5e44dc187c74ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:afa253d4b70f92e940c226d61f192054f" id="r_afa253d4b70f92e940c226d61f192054f"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00249.html#afa253d4b70f92e940c226d61f192054f">dont_merge</a></td></tr>
+<tr class="separator:afa253d4b70f92e940c226d61f192054f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Group-specific Object Attributes. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="ad914eac61c77481e1b7037877bcc5579" name="ad914eac61c77481e1b7037877bcc5579"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ad914eac61c77481e1b7037877bcc5579">&#9670;&#160;</a></span>depth</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj_attr_u::hwloc_group_attr_s::depth</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Depth of group object. It may change if intermediate Group objects are added. </p>
+
+</div>
+</div>
+<a id="afa253d4b70f92e940c226d61f192054f" name="afa253d4b70f92e940c226d61f192054f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#afa253d4b70f92e940c226d61f192054f">&#9670;&#160;</a></span>dont_merge</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_obj_attr_u::hwloc_group_attr_s::dont_merge</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Flag preventing groups from being automatically merged with identical parent or children. </p>
+
+</div>
+</div>
+<a id="a3229f269c4cc7e63492c168535e4f0c1" name="a3229f269c4cc7e63492c168535e4f0c1"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a3229f269c4cc7e63492c168535e4f0c1">&#9670;&#160;</a></span>kind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj_attr_u::hwloc_group_attr_s::kind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Internally-used kind of group. </p>
+
+</div>
+</div>
+<a id="ad514d943960a4036ed5e44dc187c74ed" name="ad514d943960a4036ed5e44dc187c74ed"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ad514d943960a4036ed5e44dc187c74ed">&#9670;&#160;</a></span>subkind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj_attr_u::hwloc_group_attr_s::subkind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Internally-used subkind to distinguish different levels of groups with same kind. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00253.html 2.11.0-1/doc/doxygen-doc/html/a00253.html
--- 2.10.0-1/doc/doxygen-doc/html/a00253.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00253.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,267 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_obj_attr_u::hwloc_pcidev_attr_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00233.html">hwloc_obj_attr_u</a></li><li class="navelem"><a class="el" href="a00253.html">hwloc_pcidev_attr_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_obj_attr_u::hwloc_pcidev_attr_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a8fba44988deb98613c1505a4019a34dc" id="r_a8fba44988deb98613c1505a4019a34dc"><td class="memItemLeft" align="right" valign="top">unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">domain</a></td></tr>
+<tr class="separator:a8fba44988deb98613c1505a4019a34dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aae99e035e8d1387d7b8768aaa8eceb0a" id="r_aae99e035e8d1387d7b8768aaa8eceb0a"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">bus</a></td></tr>
+<tr class="separator:aae99e035e8d1387d7b8768aaa8eceb0a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a3d70c84a12f7e93d14c8d47bf4fd9dc5" id="r_a3d70c84a12f7e93d14c8d47bf4fd9dc5"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">dev</a></td></tr>
+<tr class="separator:a3d70c84a12f7e93d14c8d47bf4fd9dc5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a695f32df53f4ef728670bfcf31b74e0f" id="r_a695f32df53f4ef728670bfcf31b74e0f"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">func</a></td></tr>
+<tr class="separator:a695f32df53f4ef728670bfcf31b74e0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aee735352d9f1686fd290fc6d6397c334" id="r_aee735352d9f1686fd290fc6d6397c334"><td class="memItemLeft" align="right" valign="top">unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html#aee735352d9f1686fd290fc6d6397c334">class_id</a></td></tr>
+<tr class="separator:aee735352d9f1686fd290fc6d6397c334"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aad970ad19b62eb2d5df30e4802da4f4c" id="r_aad970ad19b62eb2d5df30e4802da4f4c"><td class="memItemLeft" align="right" valign="top">unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html#aad970ad19b62eb2d5df30e4802da4f4c">vendor_id</a></td></tr>
+<tr class="separator:aad970ad19b62eb2d5df30e4802da4f4c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a35b66064ab7d768caf7154e410caf0fa" id="r_a35b66064ab7d768caf7154e410caf0fa"><td class="memItemLeft" align="right" valign="top">unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html#a35b66064ab7d768caf7154e410caf0fa">device_id</a></td></tr>
+<tr class="separator:a35b66064ab7d768caf7154e410caf0fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a499db3d8cc89eaba04fcaef3df1cba97" id="r_a499db3d8cc89eaba04fcaef3df1cba97"><td class="memItemLeft" align="right" valign="top">unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html#a499db3d8cc89eaba04fcaef3df1cba97">subvendor_id</a></td></tr>
+<tr class="separator:a499db3d8cc89eaba04fcaef3df1cba97"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:acac741aecd7a6db64f33409427e3971f" id="r_acac741aecd7a6db64f33409427e3971f"><td class="memItemLeft" align="right" valign="top">unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html#acac741aecd7a6db64f33409427e3971f">subdevice_id</a></td></tr>
+<tr class="separator:acac741aecd7a6db64f33409427e3971f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a13ad54c93d08d8ac808e4de9674c5ee7" id="r_a13ad54c93d08d8ac808e4de9674c5ee7"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html#a13ad54c93d08d8ac808e4de9674c5ee7">revision</a></td></tr>
+<tr class="separator:a13ad54c93d08d8ac808e4de9674c5ee7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a59b2fce35f7cbde86c4fd305d0ccda5f" id="r_a59b2fce35f7cbde86c4fd305d0ccda5f"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00253.html#a59b2fce35f7cbde86c4fd305d0ccda5f">linkspeed</a></td></tr>
+<tr class="separator:a59b2fce35f7cbde86c4fd305d0ccda5f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>PCI Device specific Object Attributes. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="aae99e035e8d1387d7b8768aaa8eceb0a" name="aae99e035e8d1387d7b8768aaa8eceb0a"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aae99e035e8d1387d7b8768aaa8eceb0a">&#9670;&#160;</a></span>bus</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_obj_attr_u::hwloc_pcidev_attr_s::bus</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Bus number (yy in the PCI BDF notation xxxx:yy:zz.t). </p>
+
+</div>
+</div>
+<a id="aee735352d9f1686fd290fc6d6397c334" name="aee735352d9f1686fd290fc6d6397c334"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aee735352d9f1686fd290fc6d6397c334">&#9670;&#160;</a></span>class_id</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::class_id</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>The class number (first two bytes, without the prog_if). </p>
+
+</div>
+</div>
+<a id="a3d70c84a12f7e93d14c8d47bf4fd9dc5" name="a3d70c84a12f7e93d14c8d47bf4fd9dc5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a3d70c84a12f7e93d14c8d47bf4fd9dc5">&#9670;&#160;</a></span>dev</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_obj_attr_u::hwloc_pcidev_attr_s::dev</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Device number (zz in the PCI BDF notation xxxx:yy:zz.t). </p>
+
+</div>
+</div>
+<a id="a35b66064ab7d768caf7154e410caf0fa" name="a35b66064ab7d768caf7154e410caf0fa"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a35b66064ab7d768caf7154e410caf0fa">&#9670;&#160;</a></span>device_id</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::device_id</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Device ID (yyyy in [xxxx:yyyy]). </p>
+
+</div>
+</div>
+<a id="a8fba44988deb98613c1505a4019a34dc" name="a8fba44988deb98613c1505a4019a34dc"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a8fba44988deb98613c1505a4019a34dc">&#9670;&#160;</a></span>domain</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::domain</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Domain number (xxxx in the PCI BDF notation xxxx:yy:zz.t). Only 16bits PCI domains are supported by default. </p>
+
+</div>
+</div>
+<a id="a695f32df53f4ef728670bfcf31b74e0f" name="a695f32df53f4ef728670bfcf31b74e0f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a695f32df53f4ef728670bfcf31b74e0f">&#9670;&#160;</a></span>func</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_obj_attr_u::hwloc_pcidev_attr_s::func</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Function number (t in the PCI BDF notation xxxx:yy:zz.t). </p>
+
+</div>
+</div>
+<a id="a59b2fce35f7cbde86c4fd305d0ccda5f" name="a59b2fce35f7cbde86c4fd305d0ccda5f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a59b2fce35f7cbde86c4fd305d0ccda5f">&#9670;&#160;</a></span>linkspeed</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">float hwloc_obj_attr_u::hwloc_pcidev_attr_s::linkspeed</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Link speed in GB/s. This datarate is the currently configured speed of the entire PCI link (sum of the bandwidth of all PCI lanes in that link). It may change during execution since some devices are able to slow their PCI links down when idle. </p>
+
+</div>
+</div>
+<a id="a13ad54c93d08d8ac808e4de9674c5ee7" name="a13ad54c93d08d8ac808e4de9674c5ee7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a13ad54c93d08d8ac808e4de9674c5ee7">&#9670;&#160;</a></span>revision</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_obj_attr_u::hwloc_pcidev_attr_s::revision</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Revision number. </p>
+
+</div>
+</div>
+<a id="acac741aecd7a6db64f33409427e3971f" name="acac741aecd7a6db64f33409427e3971f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#acac741aecd7a6db64f33409427e3971f">&#9670;&#160;</a></span>subdevice_id</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::subdevice_id</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Sub-Device ID. </p>
+
+</div>
+</div>
+<a id="a499db3d8cc89eaba04fcaef3df1cba97" name="a499db3d8cc89eaba04fcaef3df1cba97"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a499db3d8cc89eaba04fcaef3df1cba97">&#9670;&#160;</a></span>subvendor_id</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::subvendor_id</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Sub-Vendor ID. </p>
+
+</div>
+</div>
+<a id="aad970ad19b62eb2d5df30e4802da4f4c" name="aad970ad19b62eb2d5df30e4802da4f4c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aad970ad19b62eb2d5df30e4802da4f4c">&#9670;&#160;</a></span>vendor_id</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::vendor_id</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Vendor ID (xxxx in [xxxx:yyyy]). </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00257.html 2.11.0-1/doc/doxygen-doc/html/a00257.html
--- 2.10.0-1/doc/doxygen-doc/html/a00257.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00257.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,247 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_obj_attr_u::hwloc_bridge_attr_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00233.html">hwloc_obj_attr_u</a></li><li class="navelem"><a class="el" href="a00257.html">hwloc_bridge_attr_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_obj_attr_u::hwloc_bridge_attr_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a94647ccf58afd32602f584b47a0321ce" id="r_a94647ccf58afd32602f584b47a0321ce"><td class="memItemLeft" >union {&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a437d61b901e99118f509472c08705e66" id="r_a437d61b901e99118f509472c08705e66"><td class="memItemLeft" >&#160;&#160;&#160;struct <a class="el" href="a00253.html">hwloc_pcidev_attr_s</a>&#160;&#160;&#160;<a class="el" href="a00257.html#ab5c564e7c95b747dae9eb84ec0a2c31e">pci</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:a437d61b901e99118f509472c08705e66"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a94647ccf58afd32602f584b47a0321ce" id="r_a94647ccf58afd32602f584b47a0321ce"><td class="memItemLeft" valign="top">}&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00257.html#a94647ccf58afd32602f584b47a0321ce">upstream</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:a94647ccf58afd32602f584b47a0321ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a265dd2164aa2df4972e25a029da72125" id="r_a265dd2164aa2df4972e25a029da72125"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00173.html#gab34362c7a23296c3f12c5756747abda3">hwloc_obj_bridge_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00257.html#a265dd2164aa2df4972e25a029da72125">upstream_type</a></td></tr>
+<tr class="separator:a265dd2164aa2df4972e25a029da72125"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:abe1e38eb5ac8dc59829c8dc045f0d747" id="r_abe1e38eb5ac8dc59829c8dc045f0d747"><td class="memItemLeft" >union {&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a5fd227dacdc56f819425d2ff14250cdf" id="r_a5fd227dacdc56f819425d2ff14250cdf"><td class="memItemLeft" >&#160;&#160;&#160;struct {&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:ac83cbe90209860113e54d86f90b71307"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a5f2e1614bc9b3de631ea2dc1dd984b6a" id="r_a5f2e1614bc9b3de631ea2dc1dd984b6a"><td class="memItemLeft" >&#160;&#160;&#160;&#160;&#160;&#160;unsigned short&#160;&#160;&#160;<a class="el" href="a00257.html#a2c31e565a5f0d23d0a0a3dd3ec8f4b17">domain</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:a5f2e1614bc9b3de631ea2dc1dd984b6a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aca58baa85ea2ea9db10b4f9b7965ca27" id="r_aca58baa85ea2ea9db10b4f9b7965ca27"><td class="memItemLeft" >&#160;&#160;&#160;&#160;&#160;&#160;unsigned char&#160;&#160;&#160;<a class="el" href="a00257.html#ae2d9dd73ef1d32045c584a8e66d2f83f">secondary_bus</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:aca58baa85ea2ea9db10b4f9b7965ca27"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a78500e2a7d47ea9411c992ca63c305de" id="r_a78500e2a7d47ea9411c992ca63c305de"><td class="memItemLeft" >&#160;&#160;&#160;&#160;&#160;&#160;unsigned char&#160;&#160;&#160;<a class="el" href="a00257.html#af3f3f7d76bf03e8d2afa721c2b8d6771">subordinate_bus</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:a78500e2a7d47ea9411c992ca63c305de"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a5fd227dacdc56f819425d2ff14250cdf" id="r_a5fd227dacdc56f819425d2ff14250cdf"><td class="memItemLeft" valign="top">&#160;&#160;&#160;}&#160;&#160;&#160;<a class="el" href="a00257.html#ac83cbe90209860113e54d86f90b71307">pci</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:a5fd227dacdc56f819425d2ff14250cdf"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:abe1e38eb5ac8dc59829c8dc045f0d747" id="r_abe1e38eb5ac8dc59829c8dc045f0d747"><td class="memItemLeft" valign="top">}&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00257.html#abe1e38eb5ac8dc59829c8dc045f0d747">downstream</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:abe1e38eb5ac8dc59829c8dc045f0d747"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ac6a169b672d0e9f75756fd5665828b93" id="r_ac6a169b672d0e9f75756fd5665828b93"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00173.html#gab34362c7a23296c3f12c5756747abda3">hwloc_obj_bridge_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00257.html#ac6a169b672d0e9f75756fd5665828b93">downstream_type</a></td></tr>
+<tr class="separator:ac6a169b672d0e9f75756fd5665828b93"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a336c8b22893d5d734d8c9dfca4066b46" id="r_a336c8b22893d5d734d8c9dfca4066b46"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00257.html#a336c8b22893d5d734d8c9dfca4066b46">depth</a></td></tr>
+<tr class="separator:a336c8b22893d5d734d8c9dfca4066b46"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Bridge specific Object Attributes. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a336c8b22893d5d734d8c9dfca4066b46" name="a336c8b22893d5d734d8c9dfca4066b46"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a336c8b22893d5d734d8c9dfca4066b46">&#9670;&#160;</a></span>depth</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_obj_attr_u::hwloc_bridge_attr_s::depth</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a2c31e565a5f0d23d0a0a3dd3ec8f4b17" name="a2c31e565a5f0d23d0a0a3dd3ec8f4b17"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a2c31e565a5f0d23d0a0a3dd3ec8f4b17">&#9670;&#160;</a></span>domain</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned short hwloc_obj_attr_u::hwloc_bridge_attr_s::domain</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Domain number the downstream PCI buses. Only 16bits PCI domains are supported by default. </p>
+
+</div>
+</div>
+<a id="abe1e38eb5ac8dc59829c8dc045f0d747" name="abe1e38eb5ac8dc59829c8dc045f0d747"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#abe1e38eb5ac8dc59829c8dc045f0d747">&#9670;&#160;</a></span>[union]</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">union  { ... }  hwloc_obj_attr_u::hwloc_bridge_attr_s::downstream</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="ac6a169b672d0e9f75756fd5665828b93" name="ac6a169b672d0e9f75756fd5665828b93"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ac6a169b672d0e9f75756fd5665828b93">&#9670;&#160;</a></span>downstream_type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00173.html#gab34362c7a23296c3f12c5756747abda3">hwloc_obj_bridge_type_t</a> hwloc_obj_attr_u::hwloc_bridge_attr_s::downstream_type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Downstream Bridge type. </p>
+
+</div>
+</div>
+<a id="ab5c564e7c95b747dae9eb84ec0a2c31e" name="ab5c564e7c95b747dae9eb84ec0a2c31e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ab5c564e7c95b747dae9eb84ec0a2c31e">&#9670;&#160;</a></span>pci <span class="overload">[1/2]</span></h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00253.html">hwloc_pcidev_attr_s</a> hwloc_obj_attr_u::hwloc_bridge_attr_s::pci</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>PCI attribute of the upstream part as a PCI device. </p>
+
+</div>
+</div>
+<a id="ac83cbe90209860113e54d86f90b71307" name="ac83cbe90209860113e54d86f90b71307"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ac83cbe90209860113e54d86f90b71307">&#9670;&#160;</a></span>[struct] <span class="overload">[2/2]</span></h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct  { ... }  hwloc_obj_attr_u::hwloc_bridge_attr_s::pci</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="ae2d9dd73ef1d32045c584a8e66d2f83f" name="ae2d9dd73ef1d32045c584a8e66d2f83f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ae2d9dd73ef1d32045c584a8e66d2f83f">&#9670;&#160;</a></span>secondary_bus</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_obj_attr_u::hwloc_bridge_attr_s::secondary_bus</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>First PCI bus number below the bridge. </p>
+
+</div>
+</div>
+<a id="af3f3f7d76bf03e8d2afa721c2b8d6771" name="af3f3f7d76bf03e8d2afa721c2b8d6771"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#af3f3f7d76bf03e8d2afa721c2b8d6771">&#9670;&#160;</a></span>subordinate_bus</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_obj_attr_u::hwloc_bridge_attr_s::subordinate_bus</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Highest PCI bus number below the bridge. </p>
+
+</div>
+</div>
+<a id="a94647ccf58afd32602f584b47a0321ce" name="a94647ccf58afd32602f584b47a0321ce"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a94647ccf58afd32602f584b47a0321ce">&#9670;&#160;</a></span>[union]</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">union  { ... }  hwloc_obj_attr_u::hwloc_bridge_attr_s::upstream</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a265dd2164aa2df4972e25a029da72125" name="a265dd2164aa2df4972e25a029da72125"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a265dd2164aa2df4972e25a029da72125">&#9670;&#160;</a></span>upstream_type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00173.html#gab34362c7a23296c3f12c5756747abda3">hwloc_obj_bridge_type_t</a> hwloc_obj_attr_u::hwloc_bridge_attr_s::upstream_type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Upstream Bridge type. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00273.html 2.11.0-1/doc/doxygen-doc/html/a00273.html
--- 2.10.0-1/doc/doxygen-doc/html/a00273.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00273.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,85 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_obj_attr_u::hwloc_osdev_attr_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00233.html">hwloc_obj_attr_u</a></li><li class="navelem"><a class="el" href="a00273.html">hwloc_osdev_attr_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_obj_attr_u::hwloc_osdev_attr_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a31e019e27e54ac6138d04be639bb96f9" id="r_a31e019e27e54ac6138d04be639bb96f9"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00173.html#gaa9a6941ef7b1c169412518d7ef71b3d2">hwloc_obj_osdev_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">type</a></td></tr>
+<tr class="separator:a31e019e27e54ac6138d04be639bb96f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>OS Device specific Object Attributes. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a31e019e27e54ac6138d04be639bb96f9" name="a31e019e27e54ac6138d04be639bb96f9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a31e019e27e54ac6138d04be639bb96f9">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00173.html#gaa9a6941ef7b1c169412518d7ef71b3d2">hwloc_obj_osdev_type_t</a> hwloc_obj_attr_u::hwloc_osdev_attr_s::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00277.html 2.11.0-1/doc/doxygen-doc/html/a00277.html
--- 2.10.0-1/doc/doxygen-doc/html/a00277.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00277.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,102 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_info_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_info_s Struct Reference<div class="ingroups"><a class="el" href="a00174.html">Object Structure and Attributes</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a12ce1309e4381ae38b5c15d242a47124" id="r_a12ce1309e4381ae38b5c15d242a47124"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00277.html#a12ce1309e4381ae38b5c15d242a47124">name</a></td></tr>
+<tr class="separator:a12ce1309e4381ae38b5c15d242a47124"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a788a0073bafe660645e7b69f31a43bbb" id="r_a788a0073bafe660645e7b69f31a43bbb"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00277.html#a788a0073bafe660645e7b69f31a43bbb">value</a></td></tr>
+<tr class="separator:a788a0073bafe660645e7b69f31a43bbb"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Object info attribute (name and value strings) </p>
+<dl class="section see"><dt>See also</dt><dd><a class="el" href="a00178.html">Consulting and Adding Info Attributes</a> </dd></dl>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a12ce1309e4381ae38b5c15d242a47124" name="a12ce1309e4381ae38b5c15d242a47124"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a12ce1309e4381ae38b5c15d242a47124">&#9670;&#160;</a></span>name</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">char* hwloc_info_s::name</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Info name. </p>
+
+</div>
+</div>
+<a id="a788a0073bafe660645e7b69f31a43bbb" name="a788a0073bafe660645e7b69f31a43bbb"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a788a0073bafe660645e7b69f31a43bbb">&#9670;&#160;</a></span>value</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">char* hwloc_info_s::value</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Info value. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00281.html 2.11.0-1/doc/doxygen-doc/html/a00281.html
--- 2.10.0-1/doc/doxygen-doc/html/a00281.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00281.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,173 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_discovery_support Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_discovery_support Struct Reference<div class="ingroups"><a class="el" href="a00182.html">Topology Detection Configuration and Query</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:ad7bb4ecf7a82f5a04fc632e9592ad3ab" id="r_ad7bb4ecf7a82f5a04fc632e9592ad3ab"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00281.html#ad7bb4ecf7a82f5a04fc632e9592ad3ab">pu</a></td></tr>
+<tr class="separator:ad7bb4ecf7a82f5a04fc632e9592ad3ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a955f96066cb9e4cd34e2a3710ad43e80" id="r_a955f96066cb9e4cd34e2a3710ad43e80"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00281.html#a955f96066cb9e4cd34e2a3710ad43e80">numa</a></td></tr>
+<tr class="separator:a955f96066cb9e4cd34e2a3710ad43e80"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:af193eb858e40e12ef4923f5ed0e1f11a" id="r_af193eb858e40e12ef4923f5ed0e1f11a"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00281.html#af193eb858e40e12ef4923f5ed0e1f11a">numa_memory</a></td></tr>
+<tr class="separator:af193eb858e40e12ef4923f5ed0e1f11a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:af3c97b28781a2972cf8eaaf94a6617da" id="r_af3c97b28781a2972cf8eaaf94a6617da"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00281.html#af3c97b28781a2972cf8eaaf94a6617da">disallowed_pu</a></td></tr>
+<tr class="separator:af3c97b28781a2972cf8eaaf94a6617da"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a970e65235873bcdb9669a9805161ce03" id="r_a970e65235873bcdb9669a9805161ce03"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00281.html#a970e65235873bcdb9669a9805161ce03">disallowed_numa</a></td></tr>
+<tr class="separator:a970e65235873bcdb9669a9805161ce03"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aba80d6f9c15e2395f9ed61db9ff3b75d" id="r_aba80d6f9c15e2395f9ed61db9ff3b75d"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00281.html#aba80d6f9c15e2395f9ed61db9ff3b75d">cpukind_efficiency</a></td></tr>
+<tr class="separator:aba80d6f9c15e2395f9ed61db9ff3b75d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Flags describing actual discovery support for this topology. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="aba80d6f9c15e2395f9ed61db9ff3b75d" name="aba80d6f9c15e2395f9ed61db9ff3b75d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aba80d6f9c15e2395f9ed61db9ff3b75d">&#9670;&#160;</a></span>cpukind_efficiency</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_discovery_support::cpukind_efficiency</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Detecting the efficiency of CPU kinds is supported, see <a class="el" href="a00203.html">Kinds of CPU cores</a>. </p>
+
+</div>
+</div>
+<a id="a970e65235873bcdb9669a9805161ce03" name="a970e65235873bcdb9669a9805161ce03"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a970e65235873bcdb9669a9805161ce03">&#9670;&#160;</a></span>disallowed_numa</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_discovery_support::disallowed_numa</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Detecting and identifying NUMA nodes that are not available to the current process is supported. </p>
+
+</div>
+</div>
+<a id="af3c97b28781a2972cf8eaaf94a6617da" name="af3c97b28781a2972cf8eaaf94a6617da"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#af3c97b28781a2972cf8eaaf94a6617da">&#9670;&#160;</a></span>disallowed_pu</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_discovery_support::disallowed_pu</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Detecting and identifying PU objects that are not available to the current process is supported. </p>
+
+</div>
+</div>
+<a id="a955f96066cb9e4cd34e2a3710ad43e80" name="a955f96066cb9e4cd34e2a3710ad43e80"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a955f96066cb9e4cd34e2a3710ad43e80">&#9670;&#160;</a></span>numa</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_discovery_support::numa</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Detecting the number of NUMA nodes is supported. </p>
+
+</div>
+</div>
+<a id="af193eb858e40e12ef4923f5ed0e1f11a" name="af193eb858e40e12ef4923f5ed0e1f11a"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#af193eb858e40e12ef4923f5ed0e1f11a">&#9670;&#160;</a></span>numa_memory</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_discovery_support::numa_memory</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Detecting the amount of memory in NUMA nodes is supported. </p>
+
+</div>
+</div>
+<a id="ad7bb4ecf7a82f5a04fc632e9592ad3ab" name="ad7bb4ecf7a82f5a04fc632e9592ad3ab"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ad7bb4ecf7a82f5a04fc632e9592ad3ab">&#9670;&#160;</a></span>pu</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_discovery_support::pu</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Detecting the number of PU objects is supported. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00285.html 2.11.0-1/doc/doxygen-doc/html/a00285.html
--- 2.10.0-1/doc/doxygen-doc/html/a00285.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00285.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,253 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_cpubind_support Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_cpubind_support Struct Reference<div class="ingroups"><a class="el" href="a00182.html">Topology Detection Configuration and Query</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a9403d51657a4d546b3ea9553a2973a27" id="r_a9403d51657a4d546b3ea9553a2973a27"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html#a9403d51657a4d546b3ea9553a2973a27">set_thisproc_cpubind</a></td></tr>
+<tr class="separator:a9403d51657a4d546b3ea9553a2973a27"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a77a09ddd78ee3e9ff5f532a6ac74f7eb" id="r_a77a09ddd78ee3e9ff5f532a6ac74f7eb"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html#a77a09ddd78ee3e9ff5f532a6ac74f7eb">get_thisproc_cpubind</a></td></tr>
+<tr class="separator:a77a09ddd78ee3e9ff5f532a6ac74f7eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aa166223d1c2a6de7256ab2d8b675a87e" id="r_aa166223d1c2a6de7256ab2d8b675a87e"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html#aa166223d1c2a6de7256ab2d8b675a87e">set_proc_cpubind</a></td></tr>
+<tr class="separator:aa166223d1c2a6de7256ab2d8b675a87e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aae705bc447adc163ead377362c4dfe9f" id="r_aae705bc447adc163ead377362c4dfe9f"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html#aae705bc447adc163ead377362c4dfe9f">get_proc_cpubind</a></td></tr>
+<tr class="separator:aae705bc447adc163ead377362c4dfe9f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a57a89a4b5f1f74fa6cfe176f1e8b0798" id="r_a57a89a4b5f1f74fa6cfe176f1e8b0798"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html#a57a89a4b5f1f74fa6cfe176f1e8b0798">set_thisthread_cpubind</a></td></tr>
+<tr class="separator:a57a89a4b5f1f74fa6cfe176f1e8b0798"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a80d762e532d677dff262d83cc7bb1c60" id="r_a80d762e532d677dff262d83cc7bb1c60"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html#a80d762e532d677dff262d83cc7bb1c60">get_thisthread_cpubind</a></td></tr>
+<tr class="separator:a80d762e532d677dff262d83cc7bb1c60"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a46fba33e307909ce256624687799dd6d" id="r_a46fba33e307909ce256624687799dd6d"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html#a46fba33e307909ce256624687799dd6d">set_thread_cpubind</a></td></tr>
+<tr class="separator:a46fba33e307909ce256624687799dd6d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a8dd4d8531ed2eebdce1507e7d104154e" id="r_a8dd4d8531ed2eebdce1507e7d104154e"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html#a8dd4d8531ed2eebdce1507e7d104154e">get_thread_cpubind</a></td></tr>
+<tr class="separator:a8dd4d8531ed2eebdce1507e7d104154e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ad2d5c94b738d92b7d2ede87e4e96321d" id="r_ad2d5c94b738d92b7d2ede87e4e96321d"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html#ad2d5c94b738d92b7d2ede87e4e96321d">get_thisproc_last_cpu_location</a></td></tr>
+<tr class="separator:ad2d5c94b738d92b7d2ede87e4e96321d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a2554620148b7992a5093f338f5ae254f" id="r_a2554620148b7992a5093f338f5ae254f"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html#a2554620148b7992a5093f338f5ae254f">get_proc_last_cpu_location</a></td></tr>
+<tr class="separator:a2554620148b7992a5093f338f5ae254f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a6be1f042fdce6bf41b4ea39f6f193808" id="r_a6be1f042fdce6bf41b4ea39f6f193808"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00285.html#a6be1f042fdce6bf41b4ea39f6f193808">get_thisthread_last_cpu_location</a></td></tr>
+<tr class="separator:a6be1f042fdce6bf41b4ea39f6f193808"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Flags describing actual PU binding support for this topology. </p>
+<p>A flag may be set even if the feature isn't supported in all cases (e.g. binding to random sets of non-contiguous objects). </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="aae705bc447adc163ead377362c4dfe9f" name="aae705bc447adc163ead377362c4dfe9f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aae705bc447adc163ead377362c4dfe9f">&#9670;&#160;</a></span>get_proc_cpubind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_cpubind_support::get_proc_cpubind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the binding of a whole given process is supported. </p>
+
+</div>
+</div>
+<a id="a2554620148b7992a5093f338f5ae254f" name="a2554620148b7992a5093f338f5ae254f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a2554620148b7992a5093f338f5ae254f">&#9670;&#160;</a></span>get_proc_last_cpu_location</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_cpubind_support::get_proc_last_cpu_location</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the last processors where a whole process ran is supported </p>
+
+</div>
+</div>
+<a id="a77a09ddd78ee3e9ff5f532a6ac74f7eb" name="a77a09ddd78ee3e9ff5f532a6ac74f7eb"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a77a09ddd78ee3e9ff5f532a6ac74f7eb">&#9670;&#160;</a></span>get_thisproc_cpubind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_cpubind_support::get_thisproc_cpubind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the binding of the whole current process is supported. </p>
+
+</div>
+</div>
+<a id="ad2d5c94b738d92b7d2ede87e4e96321d" name="ad2d5c94b738d92b7d2ede87e4e96321d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ad2d5c94b738d92b7d2ede87e4e96321d">&#9670;&#160;</a></span>get_thisproc_last_cpu_location</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_cpubind_support::get_thisproc_last_cpu_location</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the last processors where the whole current process ran is supported </p>
+
+</div>
+</div>
+<a id="a80d762e532d677dff262d83cc7bb1c60" name="a80d762e532d677dff262d83cc7bb1c60"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a80d762e532d677dff262d83cc7bb1c60">&#9670;&#160;</a></span>get_thisthread_cpubind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_cpubind_support::get_thisthread_cpubind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the binding of the current thread only is supported. </p>
+
+</div>
+</div>
+<a id="a6be1f042fdce6bf41b4ea39f6f193808" name="a6be1f042fdce6bf41b4ea39f6f193808"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a6be1f042fdce6bf41b4ea39f6f193808">&#9670;&#160;</a></span>get_thisthread_last_cpu_location</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_cpubind_support::get_thisthread_last_cpu_location</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the last processors where the current thread ran is supported </p>
+
+</div>
+</div>
+<a id="a8dd4d8531ed2eebdce1507e7d104154e" name="a8dd4d8531ed2eebdce1507e7d104154e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a8dd4d8531ed2eebdce1507e7d104154e">&#9670;&#160;</a></span>get_thread_cpubind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_cpubind_support::get_thread_cpubind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the binding of a given thread only is supported. </p>
+
+</div>
+</div>
+<a id="aa166223d1c2a6de7256ab2d8b675a87e" name="aa166223d1c2a6de7256ab2d8b675a87e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aa166223d1c2a6de7256ab2d8b675a87e">&#9670;&#160;</a></span>set_proc_cpubind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_cpubind_support::set_proc_cpubind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Binding a whole given process is supported. </p>
+
+</div>
+</div>
+<a id="a9403d51657a4d546b3ea9553a2973a27" name="a9403d51657a4d546b3ea9553a2973a27"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a9403d51657a4d546b3ea9553a2973a27">&#9670;&#160;</a></span>set_thisproc_cpubind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_cpubind_support::set_thisproc_cpubind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Binding the whole current process is supported. </p>
+
+</div>
+</div>
+<a id="a57a89a4b5f1f74fa6cfe176f1e8b0798" name="a57a89a4b5f1f74fa6cfe176f1e8b0798"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a57a89a4b5f1f74fa6cfe176f1e8b0798">&#9670;&#160;</a></span>set_thisthread_cpubind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_cpubind_support::set_thisthread_cpubind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Binding the current thread only is supported. </p>
+
+</div>
+</div>
+<a id="a46fba33e307909ce256624687799dd6d" name="a46fba33e307909ce256624687799dd6d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a46fba33e307909ce256624687799dd6d">&#9670;&#160;</a></span>set_thread_cpubind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_cpubind_support::set_thread_cpubind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Binding a given thread only is supported. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00289.html 2.11.0-1/doc/doxygen-doc/html/a00289.html
--- 2.10.0-1/doc/doxygen-doc/html/a00289.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00289.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,338 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_membind_support Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_membind_support Struct Reference<div class="ingroups"><a class="el" href="a00182.html">Topology Detection Configuration and Query</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a36b3e388df9c6a249427cab7e3724749" id="r_a36b3e388df9c6a249427cab7e3724749"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a36b3e388df9c6a249427cab7e3724749">set_thisproc_membind</a></td></tr>
+<tr class="separator:a36b3e388df9c6a249427cab7e3724749"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a3fd51e6fa5f0dd800322301b46b08559" id="r_a3fd51e6fa5f0dd800322301b46b08559"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a3fd51e6fa5f0dd800322301b46b08559">get_thisproc_membind</a></td></tr>
+<tr class="separator:a3fd51e6fa5f0dd800322301b46b08559"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a756f44912894b176bf979a1b65f12aac" id="r_a756f44912894b176bf979a1b65f12aac"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a756f44912894b176bf979a1b65f12aac">set_proc_membind</a></td></tr>
+<tr class="separator:a756f44912894b176bf979a1b65f12aac"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a9880cd2d605e316fc020167c49ca69ad" id="r_a9880cd2d605e316fc020167c49ca69ad"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a9880cd2d605e316fc020167c49ca69ad">get_proc_membind</a></td></tr>
+<tr class="separator:a9880cd2d605e316fc020167c49ca69ad"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a0697af2e41f2e82b8ce71e3cc13f7eac" id="r_a0697af2e41f2e82b8ce71e3cc13f7eac"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a0697af2e41f2e82b8ce71e3cc13f7eac">set_thisthread_membind</a></td></tr>
+<tr class="separator:a0697af2e41f2e82b8ce71e3cc13f7eac"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a63b0b2e26157b472f5717ee93cc7c535" id="r_a63b0b2e26157b472f5717ee93cc7c535"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a63b0b2e26157b472f5717ee93cc7c535">get_thisthread_membind</a></td></tr>
+<tr class="separator:a63b0b2e26157b472f5717ee93cc7c535"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a476c06f96b65c08b287cf2369966123b" id="r_a476c06f96b65c08b287cf2369966123b"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a476c06f96b65c08b287cf2369966123b">set_area_membind</a></td></tr>
+<tr class="separator:a476c06f96b65c08b287cf2369966123b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a0a84e24a06f2fa487fe8c9605c6f68b3" id="r_a0a84e24a06f2fa487fe8c9605c6f68b3"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a0a84e24a06f2fa487fe8c9605c6f68b3">get_area_membind</a></td></tr>
+<tr class="separator:a0a84e24a06f2fa487fe8c9605c6f68b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ae551abb27d2aa9ce008583488b845b98" id="r_ae551abb27d2aa9ce008583488b845b98"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#ae551abb27d2aa9ce008583488b845b98">alloc_membind</a></td></tr>
+<tr class="separator:ae551abb27d2aa9ce008583488b845b98"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a221098c339dbfab27bd2c9f5d32f123b" id="r_a221098c339dbfab27bd2c9f5d32f123b"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a221098c339dbfab27bd2c9f5d32f123b">firsttouch_membind</a></td></tr>
+<tr class="separator:a221098c339dbfab27bd2c9f5d32f123b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ae7cdb1f1b5f0242a69f85b5a5538c764" id="r_ae7cdb1f1b5f0242a69f85b5a5538c764"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#ae7cdb1f1b5f0242a69f85b5a5538c764">bind_membind</a></td></tr>
+<tr class="separator:ae7cdb1f1b5f0242a69f85b5a5538c764"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a3c44c6012860bbeba8a0f4c19710858d" id="r_a3c44c6012860bbeba8a0f4c19710858d"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a3c44c6012860bbeba8a0f4c19710858d">interleave_membind</a></td></tr>
+<tr class="separator:a3c44c6012860bbeba8a0f4c19710858d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ab0921af6e0cd6975812a80b8e5c7435c" id="r_ab0921af6e0cd6975812a80b8e5c7435c"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#ab0921af6e0cd6975812a80b8e5c7435c">nexttouch_membind</a></td></tr>
+<tr class="separator:ab0921af6e0cd6975812a80b8e5c7435c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aafa7683871a6a760246f9b35209caec5" id="r_aafa7683871a6a760246f9b35209caec5"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#aafa7683871a6a760246f9b35209caec5">migrate_membind</a></td></tr>
+<tr class="separator:aafa7683871a6a760246f9b35209caec5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a30173553a68e0a4dd1672d26f8e892b1" id="r_a30173553a68e0a4dd1672d26f8e892b1"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a30173553a68e0a4dd1672d26f8e892b1">get_area_memlocation</a></td></tr>
+<tr class="separator:a30173553a68e0a4dd1672d26f8e892b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a48e8c0eee48e83e72edde293e2f52464" id="r_a48e8c0eee48e83e72edde293e2f52464"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00289.html#a48e8c0eee48e83e72edde293e2f52464">weighted_interleave_membind</a></td></tr>
+<tr class="separator:a48e8c0eee48e83e72edde293e2f52464"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Flags describing actual memory binding support for this topology. </p>
+<p>A flag may be set even if the feature isn't supported in all cases (e.g. binding to random sets of non-contiguous objects). </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="ae551abb27d2aa9ce008583488b845b98" name="ae551abb27d2aa9ce008583488b845b98"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ae551abb27d2aa9ce008583488b845b98">&#9670;&#160;</a></span>alloc_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::alloc_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Allocating a bound memory area is supported. </p>
+
+</div>
+</div>
+<a id="ae7cdb1f1b5f0242a69f85b5a5538c764" name="ae7cdb1f1b5f0242a69f85b5a5538c764"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ae7cdb1f1b5f0242a69f85b5a5538c764">&#9670;&#160;</a></span>bind_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::bind_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Bind policy is supported. </p>
+
+</div>
+</div>
+<a id="a221098c339dbfab27bd2c9f5d32f123b" name="a221098c339dbfab27bd2c9f5d32f123b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a221098c339dbfab27bd2c9f5d32f123b">&#9670;&#160;</a></span>firsttouch_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::firsttouch_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>First-touch policy is supported. </p>
+
+</div>
+</div>
+<a id="a0a84e24a06f2fa487fe8c9605c6f68b3" name="a0a84e24a06f2fa487fe8c9605c6f68b3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a0a84e24a06f2fa487fe8c9605c6f68b3">&#9670;&#160;</a></span>get_area_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::get_area_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the binding of a given memory area is supported. </p>
+
+</div>
+</div>
+<a id="a30173553a68e0a4dd1672d26f8e892b1" name="a30173553a68e0a4dd1672d26f8e892b1"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a30173553a68e0a4dd1672d26f8e892b1">&#9670;&#160;</a></span>get_area_memlocation</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::get_area_memlocation</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the last NUMA nodes where a memory area was allocated is supported </p>
+
+</div>
+</div>
+<a id="a9880cd2d605e316fc020167c49ca69ad" name="a9880cd2d605e316fc020167c49ca69ad"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a9880cd2d605e316fc020167c49ca69ad">&#9670;&#160;</a></span>get_proc_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::get_proc_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the binding of a whole given process is supported. </p>
+
+</div>
+</div>
+<a id="a3fd51e6fa5f0dd800322301b46b08559" name="a3fd51e6fa5f0dd800322301b46b08559"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a3fd51e6fa5f0dd800322301b46b08559">&#9670;&#160;</a></span>get_thisproc_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::get_thisproc_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the binding of the whole current process is supported. </p>
+
+</div>
+</div>
+<a id="a63b0b2e26157b472f5717ee93cc7c535" name="a63b0b2e26157b472f5717ee93cc7c535"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a63b0b2e26157b472f5717ee93cc7c535">&#9670;&#160;</a></span>get_thisthread_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::get_thisthread_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Getting the binding of the current thread only is supported. </p>
+
+</div>
+</div>
+<a id="a3c44c6012860bbeba8a0f4c19710858d" name="a3c44c6012860bbeba8a0f4c19710858d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a3c44c6012860bbeba8a0f4c19710858d">&#9670;&#160;</a></span>interleave_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::interleave_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Interleave policy is supported. </p>
+
+</div>
+</div>
+<a id="aafa7683871a6a760246f9b35209caec5" name="aafa7683871a6a760246f9b35209caec5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aafa7683871a6a760246f9b35209caec5">&#9670;&#160;</a></span>migrate_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::migrate_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Migration flags is supported. </p>
+
+</div>
+</div>
+<a id="ab0921af6e0cd6975812a80b8e5c7435c" name="ab0921af6e0cd6975812a80b8e5c7435c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ab0921af6e0cd6975812a80b8e5c7435c">&#9670;&#160;</a></span>nexttouch_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::nexttouch_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Next-touch migration policy is supported. </p>
+
+</div>
+</div>
+<a id="a476c06f96b65c08b287cf2369966123b" name="a476c06f96b65c08b287cf2369966123b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a476c06f96b65c08b287cf2369966123b">&#9670;&#160;</a></span>set_area_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::set_area_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Binding a given memory area is supported. </p>
+
+</div>
+</div>
+<a id="a756f44912894b176bf979a1b65f12aac" name="a756f44912894b176bf979a1b65f12aac"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a756f44912894b176bf979a1b65f12aac">&#9670;&#160;</a></span>set_proc_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::set_proc_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Binding a whole given process is supported. </p>
+
+</div>
+</div>
+<a id="a36b3e388df9c6a249427cab7e3724749" name="a36b3e388df9c6a249427cab7e3724749"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a36b3e388df9c6a249427cab7e3724749">&#9670;&#160;</a></span>set_thisproc_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::set_thisproc_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Binding the whole current process is supported. </p>
+
+</div>
+</div>
+<a id="a0697af2e41f2e82b8ce71e3cc13f7eac" name="a0697af2e41f2e82b8ce71e3cc13f7eac"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a0697af2e41f2e82b8ce71e3cc13f7eac">&#9670;&#160;</a></span>set_thisthread_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::set_thisthread_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Binding the current thread only is supported. </p>
+
+</div>
+</div>
+<a id="a48e8c0eee48e83e72edde293e2f52464" name="a48e8c0eee48e83e72edde293e2f52464"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a48e8c0eee48e83e72edde293e2f52464">&#9670;&#160;</a></span>weighted_interleave_membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_membind_support::weighted_interleave_membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Weighted interleave policy is supported. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00293.html 2.11.0-1/doc/doxygen-doc/html/a00293.html
--- 2.10.0-1/doc/doxygen-doc/html/a00293.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00293.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,82 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_misc_support Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_misc_support Struct Reference<div class="ingroups"><a class="el" href="a00182.html">Topology Detection Configuration and Query</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:adf54a6dbe8e9dd5033dfe9c93df726c4" id="r_adf54a6dbe8e9dd5033dfe9c93df726c4"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00293.html#adf54a6dbe8e9dd5033dfe9c93df726c4">imported_support</a></td></tr>
+<tr class="separator:adf54a6dbe8e9dd5033dfe9c93df726c4"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Flags describing miscellaneous features. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="adf54a6dbe8e9dd5033dfe9c93df726c4" name="adf54a6dbe8e9dd5033dfe9c93df726c4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#adf54a6dbe8e9dd5033dfe9c93df726c4">&#9670;&#160;</a></span>imported_support</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned char hwloc_topology_misc_support::imported_support</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+<p>Support was imported when importing another topology, see <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdead93e82b8668ee90e4f9354e201a2ed9c" title="Import support from the imported topology.">HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT</a>. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00297.html 2.11.0-1/doc/doxygen-doc/html/a00297.html
--- 2.10.0-1/doc/doxygen-doc/html/a00297.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00297.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,130 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_support Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_support Struct Reference<div class="ingroups"><a class="el" href="a00182.html">Topology Detection Configuration and Query</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00104_source.html">hwloc.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:aea3fbd7653d987d81f848636c420504d" id="r_aea3fbd7653d987d81f848636c420504d"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00281.html">hwloc_topology_discovery_support</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00297.html#aea3fbd7653d987d81f848636c420504d">discovery</a></td></tr>
+<tr class="separator:aea3fbd7653d987d81f848636c420504d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:adef2bb91f74c3e70a2a071393caf5f56" id="r_adef2bb91f74c3e70a2a071393caf5f56"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00285.html">hwloc_topology_cpubind_support</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00297.html#adef2bb91f74c3e70a2a071393caf5f56">cpubind</a></td></tr>
+<tr class="separator:adef2bb91f74c3e70a2a071393caf5f56"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ac6eb62ae8bc0a68dce679a7107a36194" id="r_ac6eb62ae8bc0a68dce679a7107a36194"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00289.html">hwloc_topology_membind_support</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00297.html#ac6eb62ae8bc0a68dce679a7107a36194">membind</a></td></tr>
+<tr class="separator:ac6eb62ae8bc0a68dce679a7107a36194"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ab9d08df4b0b03994f21b893ece826e78" id="r_ab9d08df4b0b03994f21b893ece826e78"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00293.html">hwloc_topology_misc_support</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00297.html#ab9d08df4b0b03994f21b893ece826e78">misc</a></td></tr>
+<tr class="separator:ab9d08df4b0b03994f21b893ece826e78"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Set of flags describing actual support for this topology. </p>
+<p>This is retrieved with <a class="el" href="a00182.html#gac0927e93a9b962143be08a48bbff2e19" title="Retrieve the topology support.">hwloc_topology_get_support()</a> and will be valid until the topology object is destroyed. Note: the values are correct only after discovery. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="adef2bb91f74c3e70a2a071393caf5f56" name="adef2bb91f74c3e70a2a071393caf5f56"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#adef2bb91f74c3e70a2a071393caf5f56">&#9670;&#160;</a></span>cpubind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00285.html">hwloc_topology_cpubind_support</a>* hwloc_topology_support::cpubind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="aea3fbd7653d987d81f848636c420504d" name="aea3fbd7653d987d81f848636c420504d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aea3fbd7653d987d81f848636c420504d">&#9670;&#160;</a></span>discovery</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00281.html">hwloc_topology_discovery_support</a>* hwloc_topology_support::discovery</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="ac6eb62ae8bc0a68dce679a7107a36194" name="ac6eb62ae8bc0a68dce679a7107a36194"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ac6eb62ae8bc0a68dce679a7107a36194">&#9670;&#160;</a></span>membind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00289.html">hwloc_topology_membind_support</a>* hwloc_topology_support::membind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="ab9d08df4b0b03994f21b893ece826e78" name="ab9d08df4b0b03994f21b893ece826e78"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ab9d08df4b0b03994f21b893ece826e78">&#9670;&#160;</a></span>misc</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00293.html">hwloc_topology_misc_support</a>* hwloc_topology_support::misc</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00104_source.html">hwloc.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00301.html 2.11.0-1/doc/doxygen-doc/html/a00301.html
--- 2.10.0-1/doc/doxygen-doc/html/a00301.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00301.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,141 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_distances_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_distances_s Struct Reference<div class="ingroups"><a class="el" href="a00197.html">Retrieve distances between objects</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00116_source.html">distances.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a4ca2af858cebbce7324ec49903d09474" id="r_a4ca2af858cebbce7324ec49903d09474"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00301.html#a4ca2af858cebbce7324ec49903d09474">nbobjs</a></td></tr>
+<tr class="separator:a4ca2af858cebbce7324ec49903d09474"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:af1e78b2d628d191fa6cae3fbfe891078" id="r_af1e78b2d628d191fa6cae3fbfe891078"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00301.html#af1e78b2d628d191fa6cae3fbfe891078">objs</a></td></tr>
+<tr class="separator:af1e78b2d628d191fa6cae3fbfe891078"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aef9c83cf467da1b1fa4c36493febb3b5" id="r_aef9c83cf467da1b1fa4c36493febb3b5"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00301.html#aef9c83cf467da1b1fa4c36493febb3b5">kind</a></td></tr>
+<tr class="separator:aef9c83cf467da1b1fa4c36493febb3b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ae43e19b2c743de05c93d71a30beaca75" id="r_ae43e19b2c743de05c93d71a30beaca75"><td class="memItemLeft" align="right" valign="top">hwloc_uint64_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00301.html#ae43e19b2c743de05c93d71a30beaca75">values</a></td></tr>
+<tr class="separator:ae43e19b2c743de05c93d71a30beaca75"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Matrix of distances between a set of objects. </p>
+<p>The most common matrix contains latencies between NUMA nodes (as reported in the System Locality Distance Information Table (SLIT) in the ACPI specification), which may or may not be physically accurate. It corresponds to the latency for accessing the memory of one node from a core in another node. The corresponding kind is <a class="el" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108afd6a3503fbc8f7c1a31235373cefc4c6" title="Distance values are similar to latencies between objects. Values are smaller for closer objects,...">HWLOC_DISTANCES_KIND_MEANS_LATENCY</a> | <a class="el" href="a00197.html#ggab1bb10d3adb85b52cdc6fe5a7f74f108a0148d7f9be833a04f5a55455437c227b" title="These distances were provided by the user.">HWLOC_DISTANCES_KIND_FROM_USER</a>. The name of this distances structure is "NUMALatency".</p>
+<p>The matrix may also contain bandwidths between random sets of objects, possibly provided by the user, as specified in the <code>kind</code> attribute. Others common distance structures include and "XGMIBandwidth", "XGMIHops", "XeLinkBandwidth" and "NVLinkBandwidth".</p>
+<p>Pointers <code>objs</code> and <code>values</code> should not be replaced, reallocated, freed, etc. However callers are allowed to modify <code>kind</code> as well as the contents of <code>objs</code> and <code>values</code> arrays. For instance, if there is a single NUMA node per Package, <a class="el" href="a00189.html#gab5df3ad1e8565ea0c2cf06412f6f6233" title="Return an object of a different type with same locality.">hwloc_get_obj_with_same_locality()</a> may be used to convert between them and replace NUMA nodes in the <code>objs</code> array with the corresponding Packages. See also <a class="el" href="a00197.html#gabcadd041f3072999d68f2d94e38670f7" title="Apply a transformation to a distances structure.">hwloc_distances_transform()</a> for applying some transformations to the structure. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="aef9c83cf467da1b1fa4c36493febb3b5" name="aef9c83cf467da1b1fa4c36493febb3b5"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aef9c83cf467da1b1fa4c36493febb3b5">&#9670;&#160;</a></span>kind</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned long hwloc_distances_s::kind</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>OR'ed set of <a class="el" href="a00197.html#gab1bb10d3adb85b52cdc6fe5a7f74f108" title="Kinds of distance matrices.">hwloc_distances_kind_e</a>. </p>
+
+</div>
+</div>
+<a id="a4ca2af858cebbce7324ec49903d09474" name="a4ca2af858cebbce7324ec49903d09474"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a4ca2af858cebbce7324ec49903d09474">&#9670;&#160;</a></span>nbobjs</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_distances_s::nbobjs</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Number of objects described by the distance matrix. </p>
+
+</div>
+</div>
+<a id="af1e78b2d628d191fa6cae3fbfe891078" name="af1e78b2d628d191fa6cae3fbfe891078"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#af1e78b2d628d191fa6cae3fbfe891078">&#9670;&#160;</a></span>objs</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>* hwloc_distances_s::objs</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Array of objects described by the distance matrix. These objects are not in any particular order, see <a class="el" href="a00198.html#gab9e770c7d56c5d6040f26bd1dc8854cd" title="Find the index of an object in a distances structure.">hwloc_distances_obj_index()</a> and <a class="el" href="a00198.html#ga3c665b23056e3269f777b21a67148c82" title="Find the values between two objects in a distance matrices.">hwloc_distances_obj_pair_values()</a> for easy ways to find objects in this array and their corresponding values. </p>
+
+</div>
+</div>
+<a id="ae43e19b2c743de05c93d71a30beaca75" name="ae43e19b2c743de05c93d71a30beaca75"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ae43e19b2c743de05c93d71a30beaca75">&#9670;&#160;</a></span>values</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">hwloc_uint64_t* hwloc_distances_s::values</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Matrix of distances between objects, stored as a one-dimension array. </p>
+<p>Distance from i-th to j-th object is stored in slot i*nbobjs+j. The meaning of the value depends on the <code>kind</code> attribute. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00116_source.html">distances.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00305.html 2.11.0-1/doc/doxygen-doc/html/a00305.html
--- 2.10.0-1/doc/doxygen-doc/html/a00305.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00305.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,105 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_location Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_location Struct Reference<div class="ingroups"><a class="el" href="a00201.html">Comparing memory node attributes for finding where to allocate on</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00119_source.html">memattrs.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">union &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00309.html">hwloc_location_u</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:aeb9c0ab74a7d3506a76d0b82600a28a7" id="r_aeb9c0ab74a7d3506a76d0b82600a28a7"><td class="memItemLeft" align="right" valign="top">enum <a class="el" href="a00201.html#ga33099ba58f607fc70925da3777688586">hwloc_location_type_e</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00305.html#aeb9c0ab74a7d3506a76d0b82600a28a7">type</a></td></tr>
+<tr class="separator:aeb9c0ab74a7d3506a76d0b82600a28a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a707a25a5b65177e4d081be49aa0777a2" id="r_a707a25a5b65177e4d081be49aa0777a2"><td class="memItemLeft" align="right" valign="top">union <a class="el" href="a00309.html">hwloc_location::hwloc_location_u</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00305.html#a707a25a5b65177e4d081be49aa0777a2">location</a></td></tr>
+<tr class="separator:a707a25a5b65177e4d081be49aa0777a2"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Where to measure attributes from. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a707a25a5b65177e4d081be49aa0777a2" name="a707a25a5b65177e4d081be49aa0777a2"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a707a25a5b65177e4d081be49aa0777a2">&#9670;&#160;</a></span>location</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">union <a class="el" href="a00309.html">hwloc_location::hwloc_location_u</a> hwloc_location::location</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="aeb9c0ab74a7d3506a76d0b82600a28a7" name="aeb9c0ab74a7d3506a76d0b82600a28a7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aeb9c0ab74a7d3506a76d0b82600a28a7">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">enum <a class="el" href="a00201.html#ga33099ba58f607fc70925da3777688586">hwloc_location_type_e</a> hwloc_location::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Type of location. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00119_source.html">memattrs.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00309.html 2.11.0-1/doc/doxygen-doc/html/a00309.html
--- 2.10.0-1/doc/doxygen-doc/html/a00309.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00309.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,105 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_location::hwloc_location_u Union Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00305.html">hwloc_location</a></li><li class="navelem"><a class="el" href="a00309.html">hwloc_location_u</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_location::hwloc_location_u Union Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00119_source.html">memattrs.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a033bad8f6b891992f0c18b85a88c5561" id="r_a033bad8f6b891992f0c18b85a88c5561"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00309.html#a033bad8f6b891992f0c18b85a88c5561">cpuset</a></td></tr>
+<tr class="separator:a033bad8f6b891992f0c18b85a88c5561"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:acf2ebf75869f0a53a884ac2ab3374122" id="r_acf2ebf75869f0a53a884ac2ab3374122"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00309.html#acf2ebf75869f0a53a884ac2ab3374122">object</a></td></tr>
+<tr class="separator:acf2ebf75869f0a53a884ac2ab3374122"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Actual location. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a033bad8f6b891992f0c18b85a88c5561" name="a033bad8f6b891992f0c18b85a88c5561"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a033bad8f6b891992f0c18b85a88c5561">&#9670;&#160;</a></span>cpuset</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> hwloc_location::hwloc_location_u::cpuset</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Location as a cpuset, when the location type is <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174" title="Location is given as a cpuset, in the location cpuset union field.">HWLOC_LOCATION_TYPE_CPUSET</a>. </p>
+
+</div>
+</div>
+<a id="acf2ebf75869f0a53a884ac2ab3374122" name="acf2ebf75869f0a53a884ac2ab3374122"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#acf2ebf75869f0a53a884ac2ab3374122">&#9670;&#160;</a></span>object</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d">hwloc_obj_t</a> hwloc_location::hwloc_location_u::object</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Location as an object, when the location type is <a class="el" href="a00201.html#gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84" title="Location is given as an object, in the location object union field.">HWLOC_LOCATION_TYPE_OBJECT</a>. </p>
+
+</div>
+</div>
+<hr/>The documentation for this union was generated from the following file:<ul>
+<li><a class="el" href="a00119_source.html">memattrs.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00313.html 2.11.0-1/doc/doxygen-doc/html/a00313.html
--- 2.10.0-1/doc/doxygen-doc/html/a00313.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00313.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,127 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_cl_device_pci_bus_info_khr Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_cl_device_pci_bus_info_khr Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00137_source.html">opencl.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a5bdfbcb0dee610f9f6f7f95ace89e298" id="r_a5bdfbcb0dee610f9f6f7f95ace89e298"><td class="memItemLeft" align="right" valign="top">cl_uint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00313.html#a5bdfbcb0dee610f9f6f7f95ace89e298">pci_domain</a></td></tr>
+<tr class="separator:a5bdfbcb0dee610f9f6f7f95ace89e298"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a0e4d316b01eee00c3750d1c853be9c01" id="r_a0e4d316b01eee00c3750d1c853be9c01"><td class="memItemLeft" align="right" valign="top">cl_uint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00313.html#a0e4d316b01eee00c3750d1c853be9c01">pci_bus</a></td></tr>
+<tr class="separator:a0e4d316b01eee00c3750d1c853be9c01"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a328717bdaeb2d117c550927cf41e6f72" id="r_a328717bdaeb2d117c550927cf41e6f72"><td class="memItemLeft" align="right" valign="top">cl_uint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00313.html#a328717bdaeb2d117c550927cf41e6f72">pci_device</a></td></tr>
+<tr class="separator:a328717bdaeb2d117c550927cf41e6f72"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ab4032f46a44cf9ffc7b2ddc25001e3f0" id="r_ab4032f46a44cf9ffc7b2ddc25001e3f0"><td class="memItemLeft" align="right" valign="top">cl_uint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00313.html#ab4032f46a44cf9ffc7b2ddc25001e3f0">pci_function</a></td></tr>
+<tr class="separator:ab4032f46a44cf9ffc7b2ddc25001e3f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<h2 class="groupheader">Field Documentation</h2>
+<a id="a0e4d316b01eee00c3750d1c853be9c01" name="a0e4d316b01eee00c3750d1c853be9c01"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a0e4d316b01eee00c3750d1c853be9c01">&#9670;&#160;</a></span>pci_bus</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">cl_uint hwloc_cl_device_pci_bus_info_khr::pci_bus</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a328717bdaeb2d117c550927cf41e6f72" name="a328717bdaeb2d117c550927cf41e6f72"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a328717bdaeb2d117c550927cf41e6f72">&#9670;&#160;</a></span>pci_device</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">cl_uint hwloc_cl_device_pci_bus_info_khr::pci_device</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a5bdfbcb0dee610f9f6f7f95ace89e298" name="a5bdfbcb0dee610f9f6f7f95ace89e298"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a5bdfbcb0dee610f9f6f7f95ace89e298">&#9670;&#160;</a></span>pci_domain</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">cl_uint hwloc_cl_device_pci_bus_info_khr::pci_domain</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="ab4032f46a44cf9ffc7b2ddc25001e3f0" name="ab4032f46a44cf9ffc7b2ddc25001e3f0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ab4032f46a44cf9ffc7b2ddc25001e3f0">&#9670;&#160;</a></span>pci_function</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">cl_uint hwloc_cl_device_pci_bus_info_khr::pci_function</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00137_source.html">opencl.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00317.html 2.11.0-1/doc/doxygen-doc/html/a00317.html
--- 2.10.0-1/doc/doxygen-doc/html/a00317.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00317.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,197 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_cl_device_topology_amd Union Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_cl_device_topology_amd Union Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00137_source.html">opencl.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:aeb5e5d12bf653f750dafedae6e225c3a" id="r_aeb5e5d12bf653f750dafedae6e225c3a"><td class="memItemLeft" >struct {&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ae4f50174106f26c89ca82b387d01f7fd" id="r_ae4f50174106f26c89ca82b387d01f7fd"><td class="memItemLeft" >&#160;&#160;&#160;cl_uint&#160;&#160;&#160;<a class="el" href="a00317.html#a8ec4ea89b862bb271845b48063f332b4">type</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:ae4f50174106f26c89ca82b387d01f7fd"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ae0abb91c2ab87b89429c4903c6f69eee" id="r_ae0abb91c2ab87b89429c4903c6f69eee"><td class="memItemLeft" >&#160;&#160;&#160;cl_uint&#160;&#160;&#160;<a class="el" href="a00317.html#afbd6b814607b06fc5b2f36ad14420398">data</a> [5]&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:ae0abb91c2ab87b89429c4903c6f69eee"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aeb5e5d12bf653f750dafedae6e225c3a" id="r_aeb5e5d12bf653f750dafedae6e225c3a"><td class="memItemLeft" valign="top">}&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00317.html#aeb5e5d12bf653f750dafedae6e225c3a">raw</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:aeb5e5d12bf653f750dafedae6e225c3a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aef8560f6c359be0c5bdbd2840580d79c" id="r_aef8560f6c359be0c5bdbd2840580d79c"><td class="memItemLeft" >struct {&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ab079315367f7f7cb8a69c4ff53967fea" id="r_ab079315367f7f7cb8a69c4ff53967fea"><td class="memItemLeft" >&#160;&#160;&#160;cl_uint&#160;&#160;&#160;<a class="el" href="a00317.html#a8ec4ea89b862bb271845b48063f332b4">type</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:ab079315367f7f7cb8a69c4ff53967fea"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a85ae1ff4970abb397847b1c6c81d9e19" id="r_a85ae1ff4970abb397847b1c6c81d9e19"><td class="memItemLeft" >&#160;&#160;&#160;cl_char&#160;&#160;&#160;<a class="el" href="a00317.html#ac8650d7eea96eef290481fee980d1d47">unused</a> [17]&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:a85ae1ff4970abb397847b1c6c81d9e19"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ac20bb4b4bfdf14ecc03ae6e9242e7614" id="r_ac20bb4b4bfdf14ecc03ae6e9242e7614"><td class="memItemLeft" >&#160;&#160;&#160;cl_char&#160;&#160;&#160;<a class="el" href="a00317.html#a4a23e3cc034b7ab105cab0e863dcab69">bus</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:ac20bb4b4bfdf14ecc03ae6e9242e7614"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a1da9f6682d38789c2816725255afc710" id="r_a1da9f6682d38789c2816725255afc710"><td class="memItemLeft" >&#160;&#160;&#160;cl_char&#160;&#160;&#160;<a class="el" href="a00317.html#a017033a953d71455b067007cabb92e9c">device</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:a1da9f6682d38789c2816725255afc710"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a69239c249c50aa544d6bbcc326b45c69" id="r_a69239c249c50aa544d6bbcc326b45c69"><td class="memItemLeft" >&#160;&#160;&#160;cl_char&#160;&#160;&#160;<a class="el" href="a00317.html#a77a67ac73cff98d330ef7258b240bac3">function</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:a69239c249c50aa544d6bbcc326b45c69"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aef8560f6c359be0c5bdbd2840580d79c" id="r_aef8560f6c359be0c5bdbd2840580d79c"><td class="memItemLeft" valign="top">}&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00317.html#aef8560f6c359be0c5bdbd2840580d79c">pcie</a>&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
+<tr class="separator:aef8560f6c359be0c5bdbd2840580d79c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<h2 class="groupheader">Field Documentation</h2>
+<a id="a4a23e3cc034b7ab105cab0e863dcab69" name="a4a23e3cc034b7ab105cab0e863dcab69"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a4a23e3cc034b7ab105cab0e863dcab69">&#9670;&#160;</a></span>bus</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">cl_char hwloc_cl_device_topology_amd::bus</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="afbd6b814607b06fc5b2f36ad14420398" name="afbd6b814607b06fc5b2f36ad14420398"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#afbd6b814607b06fc5b2f36ad14420398">&#9670;&#160;</a></span>data</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">cl_uint hwloc_cl_device_topology_amd::data[5]</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a017033a953d71455b067007cabb92e9c" name="a017033a953d71455b067007cabb92e9c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a017033a953d71455b067007cabb92e9c">&#9670;&#160;</a></span>device</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">cl_char hwloc_cl_device_topology_amd::device</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a77a67ac73cff98d330ef7258b240bac3" name="a77a67ac73cff98d330ef7258b240bac3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a77a67ac73cff98d330ef7258b240bac3">&#9670;&#160;</a></span>function</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">cl_char hwloc_cl_device_topology_amd::function</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="aef8560f6c359be0c5bdbd2840580d79c" name="aef8560f6c359be0c5bdbd2840580d79c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aef8560f6c359be0c5bdbd2840580d79c">&#9670;&#160;</a></span>[struct]</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct  { ... }  hwloc_cl_device_topology_amd::pcie</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="aeb5e5d12bf653f750dafedae6e225c3a" name="aeb5e5d12bf653f750dafedae6e225c3a"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aeb5e5d12bf653f750dafedae6e225c3a">&#9670;&#160;</a></span>[struct]</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct  { ... }  hwloc_cl_device_topology_amd::raw</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a8ec4ea89b862bb271845b48063f332b4" name="a8ec4ea89b862bb271845b48063f332b4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a8ec4ea89b862bb271845b48063f332b4">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">cl_uint hwloc_cl_device_topology_amd::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="ac8650d7eea96eef290481fee980d1d47" name="ac8650d7eea96eef290481fee980d1d47"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ac8650d7eea96eef290481fee980d1d47">&#9670;&#160;</a></span>unused</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">cl_char hwloc_cl_device_topology_amd::unused[17]</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this union was generated from the following file:<ul>
+<li><a class="el" href="a00137_source.html">opencl.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00329.html 2.11.0-1/doc/doxygen-doc/html/a00329.html
--- 2.10.0-1/doc/doxygen-doc/html/a00329.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00329.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,123 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_diff_obj_attr_u Union Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_diff_obj_attr_u Union Reference<div class="ingroups"><a class="el" href="a00217.html">Topology differences</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00161_source.html">diff.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00333.html">hwloc_topology_diff_obj_attr_generic_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00341.html">hwloc_topology_diff_obj_attr_string_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00337.html">hwloc_topology_diff_obj_attr_uint64_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:aeb449c0e04b14ebf8c3126756b6364f9" id="r_aeb449c0e04b14ebf8c3126756b6364f9"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00333.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00329.html#aeb449c0e04b14ebf8c3126756b6364f9">generic</a></td></tr>
+<tr class="separator:aeb449c0e04b14ebf8c3126756b6364f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a4608ade88460f5f208887775e5a69a0a" id="r_a4608ade88460f5f208887775e5a69a0a"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00337.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00329.html#a4608ade88460f5f208887775e5a69a0a">uint64</a></td></tr>
+<tr class="separator:a4608ade88460f5f208887775e5a69a0a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a42fa15c37f1f59ef638066c4c62c3154" id="r_a42fa15c37f1f59ef638066c4c62c3154"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00341.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00329.html#a42fa15c37f1f59ef638066c4c62c3154">string</a></td></tr>
+<tr class="separator:a42fa15c37f1f59ef638066c4c62c3154"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>One object attribute difference. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="aeb449c0e04b14ebf8c3126756b6364f9" name="aeb449c0e04b14ebf8c3126756b6364f9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aeb449c0e04b14ebf8c3126756b6364f9">&#9670;&#160;</a></span>generic</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00333.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s</a> hwloc_topology_diff_obj_attr_u::generic</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a42fa15c37f1f59ef638066c4c62c3154" name="a42fa15c37f1f59ef638066c4c62c3154"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a42fa15c37f1f59ef638066c4c62c3154">&#9670;&#160;</a></span>string</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00341.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a> hwloc_topology_diff_obj_attr_u::string</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a4608ade88460f5f208887775e5a69a0a" name="a4608ade88460f5f208887775e5a69a0a"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a4608ade88460f5f208887775e5a69a0a">&#9670;&#160;</a></span>uint64</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00337.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a> hwloc_topology_diff_obj_attr_u::uint64</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this union was generated from the following file:<ul>
+<li><a class="el" href="a00161_source.html">diff.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00333.html 2.11.0-1/doc/doxygen-doc/html/a00333.html
--- 2.10.0-1/doc/doxygen-doc/html/a00333.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00333.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,83 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00329.html">hwloc_topology_diff_obj_attr_u</a></li><li class="navelem"><a class="el" href="a00333.html">hwloc_topology_diff_obj_attr_generic_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00161_source.html">diff.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a43f8133b7c30129b002c2d295e6580fc" id="r_a43f8133b7c30129b002c2d295e6580fc"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00333.html#a43f8133b7c30129b002c2d295e6580fc">type</a></td></tr>
+<tr class="separator:a43f8133b7c30129b002c2d295e6580fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<h2 class="groupheader">Field Documentation</h2>
+<a id="a43f8133b7c30129b002c2d295e6580fc" name="a43f8133b7c30129b002c2d295e6580fc"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a43f8133b7c30129b002c2d295e6580fc">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a> hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00161_source.html">diff.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00337.html 2.11.0-1/doc/doxygen-doc/html/a00337.html
--- 2.10.0-1/doc/doxygen-doc/html/a00337.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00337.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,133 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00329.html">hwloc_topology_diff_obj_attr_u</a></li><li class="navelem"><a class="el" href="a00337.html">hwloc_topology_diff_obj_attr_uint64_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00161_source.html">diff.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:afe262b9aa558fe7bfecbd37a7a129197" id="r_afe262b9aa558fe7bfecbd37a7a129197"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00337.html#afe262b9aa558fe7bfecbd37a7a129197">type</a></td></tr>
+<tr class="separator:afe262b9aa558fe7bfecbd37a7a129197"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:adb772c3f1761ecadf496c80ae14afce3" id="r_adb772c3f1761ecadf496c80ae14afce3"><td class="memItemLeft" align="right" valign="top">hwloc_uint64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00337.html#adb772c3f1761ecadf496c80ae14afce3">index</a></td></tr>
+<tr class="separator:adb772c3f1761ecadf496c80ae14afce3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a44c0894dce563335d347fde6595c49c9" id="r_a44c0894dce563335d347fde6595c49c9"><td class="memItemLeft" align="right" valign="top">hwloc_uint64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00337.html#a44c0894dce563335d347fde6595c49c9">oldvalue</a></td></tr>
+<tr class="separator:a44c0894dce563335d347fde6595c49c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ae63aa59ad65aa783b730a4f213304eb4" id="r_ae63aa59ad65aa783b730a4f213304eb4"><td class="memItemLeft" align="right" valign="top">hwloc_uint64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00337.html#ae63aa59ad65aa783b730a4f213304eb4">newvalue</a></td></tr>
+<tr class="separator:ae63aa59ad65aa783b730a4f213304eb4"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Integer attribute modification with an optional index. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="adb772c3f1761ecadf496c80ae14afce3" name="adb772c3f1761ecadf496c80ae14afce3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#adb772c3f1761ecadf496c80ae14afce3">&#9670;&#160;</a></span>index</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">hwloc_uint64_t hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::index</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="ae63aa59ad65aa783b730a4f213304eb4" name="ae63aa59ad65aa783b730a4f213304eb4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ae63aa59ad65aa783b730a4f213304eb4">&#9670;&#160;</a></span>newvalue</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">hwloc_uint64_t hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::newvalue</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a44c0894dce563335d347fde6595c49c9" name="a44c0894dce563335d347fde6595c49c9"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a44c0894dce563335d347fde6595c49c9">&#9670;&#160;</a></span>oldvalue</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">hwloc_uint64_t hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::oldvalue</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="afe262b9aa558fe7bfecbd37a7a129197" name="afe262b9aa558fe7bfecbd37a7a129197"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#afe262b9aa558fe7bfecbd37a7a129197">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a> hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00161_source.html">diff.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00341.html 2.11.0-1/doc/doxygen-doc/html/a00341.html
--- 2.10.0-1/doc/doxygen-doc/html/a00341.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00341.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,133 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00329.html">hwloc_topology_diff_obj_attr_u</a></li><li class="navelem"><a class="el" href="a00341.html">hwloc_topology_diff_obj_attr_string_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00161_source.html">diff.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a784ab5827c1bf531b86d1f02f199d04d" id="r_a784ab5827c1bf531b86d1f02f199d04d"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00341.html#a784ab5827c1bf531b86d1f02f199d04d">type</a></td></tr>
+<tr class="separator:a784ab5827c1bf531b86d1f02f199d04d"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a7ef48c66ccddf34d90edb4e4314b41c6" id="r_a7ef48c66ccddf34d90edb4e4314b41c6"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00341.html#a7ef48c66ccddf34d90edb4e4314b41c6">name</a></td></tr>
+<tr class="separator:a7ef48c66ccddf34d90edb4e4314b41c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a33cc281d4417129064295a6ae7b79818" id="r_a33cc281d4417129064295a6ae7b79818"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00341.html#a33cc281d4417129064295a6ae7b79818">oldvalue</a></td></tr>
+<tr class="separator:a33cc281d4417129064295a6ae7b79818"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a75f37f4add21cece50fee2701c3b77db" id="r_a75f37f4add21cece50fee2701c3b77db"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00341.html#a75f37f4add21cece50fee2701c3b77db">newvalue</a></td></tr>
+<tr class="separator:a75f37f4add21cece50fee2701c3b77db"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>String attribute modification with an optional name. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a7ef48c66ccddf34d90edb4e4314b41c6" name="a7ef48c66ccddf34d90edb4e4314b41c6"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a7ef48c66ccddf34d90edb4e4314b41c6">&#9670;&#160;</a></span>name</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">char* hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::name</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a75f37f4add21cece50fee2701c3b77db" name="a75f37f4add21cece50fee2701c3b77db"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a75f37f4add21cece50fee2701c3b77db">&#9670;&#160;</a></span>newvalue</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">char* hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::newvalue</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a33cc281d4417129064295a6ae7b79818" name="a33cc281d4417129064295a6ae7b79818"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a33cc281d4417129064295a6ae7b79818">&#9670;&#160;</a></span>oldvalue</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">char* hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::oldvalue</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a784ab5827c1bf531b86d1f02f199d04d" name="a784ab5827c1bf531b86d1f02f199d04d"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a784ab5827c1bf531b86d1f02f199d04d">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00217.html#ga74a3fefbaa17582fea86d76b312d6254">hwloc_topology_diff_obj_attr_type_t</a> hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00161_source.html">diff.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00345.html 2.11.0-1/doc/doxygen-doc/html/a00345.html
--- 2.10.0-1/doc/doxygen-doc/html/a00345.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00345.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,123 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_diff_u Union Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#nested-classes">Data Structures</a> &#124;
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_diff_u Union Reference<div class="ingroups"><a class="el" href="a00217.html">Topology differences</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00161_source.html">diff.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
+Data Structures</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00349.html">hwloc_topology_diff_generic_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00353.html">hwloc_topology_diff_obj_attr_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00357.html">hwloc_topology_diff_too_complex_s</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a0dd2cbfba0eca2fc7a2645668bcae0f8" id="r_a0dd2cbfba0eca2fc7a2645668bcae0f8"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00349.html">hwloc_topology_diff_u::hwloc_topology_diff_generic_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00345.html#a0dd2cbfba0eca2fc7a2645668bcae0f8">generic</a></td></tr>
+<tr class="separator:a0dd2cbfba0eca2fc7a2645668bcae0f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a01dca644feea48448b36baa60cf4c07f" id="r_a01dca644feea48448b36baa60cf4c07f"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00353.html">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00345.html#a01dca644feea48448b36baa60cf4c07f">obj_attr</a></td></tr>
+<tr class="separator:a01dca644feea48448b36baa60cf4c07f"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:af7dc1148eb656c56e9678218cafd027b" id="r_af7dc1148eb656c56e9678218cafd027b"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00357.html">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00345.html#af7dc1148eb656c56e9678218cafd027b">too_complex</a></td></tr>
+<tr class="separator:af7dc1148eb656c56e9678218cafd027b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>One element of a difference list between two topologies. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a0dd2cbfba0eca2fc7a2645668bcae0f8" name="a0dd2cbfba0eca2fc7a2645668bcae0f8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a0dd2cbfba0eca2fc7a2645668bcae0f8">&#9670;&#160;</a></span>generic</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00349.html">hwloc_topology_diff_u::hwloc_topology_diff_generic_s</a> hwloc_topology_diff_u::generic</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a01dca644feea48448b36baa60cf4c07f" name="a01dca644feea48448b36baa60cf4c07f"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a01dca644feea48448b36baa60cf4c07f">&#9670;&#160;</a></span>obj_attr</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00353.html">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a> hwloc_topology_diff_u::obj_attr</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="af7dc1148eb656c56e9678218cafd027b" name="af7dc1148eb656c56e9678218cafd027b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#af7dc1148eb656c56e9678218cafd027b">&#9670;&#160;</a></span>too_complex</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00357.html">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a> hwloc_topology_diff_u::too_complex</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this union was generated from the following file:<ul>
+<li><a class="el" href="a00161_source.html">diff.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00349.html 2.11.0-1/doc/doxygen-doc/html/a00349.html
--- 2.10.0-1/doc/doxygen-doc/html/a00349.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00349.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,99 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_diff_u::hwloc_topology_diff_generic_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00345.html">hwloc_topology_diff_u</a></li><li class="navelem"><a class="el" href="a00349.html">hwloc_topology_diff_generic_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_diff_u::hwloc_topology_diff_generic_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00161_source.html">diff.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a373005489fcddeba6319163e60263ae8" id="r_a373005489fcddeba6319163e60263ae8"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00349.html#a373005489fcddeba6319163e60263ae8">type</a></td></tr>
+<tr class="separator:a373005489fcddeba6319163e60263ae8"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a720aa94eb73cddfd8d6bf9fcbbfc035e" id="r_a720aa94eb73cddfd8d6bf9fcbbfc035e"><td class="memItemLeft" align="right" valign="top">union <a class="el" href="a00345.html">hwloc_topology_diff_u</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00349.html#a720aa94eb73cddfd8d6bf9fcbbfc035e">next</a></td></tr>
+<tr class="separator:a720aa94eb73cddfd8d6bf9fcbbfc035e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<h2 class="groupheader">Field Documentation</h2>
+<a id="a720aa94eb73cddfd8d6bf9fcbbfc035e" name="a720aa94eb73cddfd8d6bf9fcbbfc035e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a720aa94eb73cddfd8d6bf9fcbbfc035e">&#9670;&#160;</a></span>next</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">union <a class="el" href="a00345.html">hwloc_topology_diff_u</a>* hwloc_topology_diff_u::hwloc_topology_diff_generic_s::next</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a373005489fcddeba6319163e60263ae8" name="a373005489fcddeba6319163e60263ae8"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a373005489fcddeba6319163e60263ae8">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a> hwloc_topology_diff_u::hwloc_topology_diff_generic_s::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00161_source.html">diff.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00353.html 2.11.0-1/doc/doxygen-doc/html/a00353.html
--- 2.10.0-1/doc/doxygen-doc/html/a00353.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00353.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,147 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00345.html">hwloc_topology_diff_u</a></li><li class="navelem"><a class="el" href="a00353.html">hwloc_topology_diff_obj_attr_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00161_source.html">diff.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a70a118ad288bd98f18c8ce6dc52e2d10" id="r_a70a118ad288bd98f18c8ce6dc52e2d10"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00353.html#a70a118ad288bd98f18c8ce6dc52e2d10">type</a></td></tr>
+<tr class="separator:a70a118ad288bd98f18c8ce6dc52e2d10"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:acb9170a8eb3392656d70f7f3ef3e3eed" id="r_acb9170a8eb3392656d70f7f3ef3e3eed"><td class="memItemLeft" align="right" valign="top">union <a class="el" href="a00345.html">hwloc_topology_diff_u</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00353.html#acb9170a8eb3392656d70f7f3ef3e3eed">next</a></td></tr>
+<tr class="separator:acb9170a8eb3392656d70f7f3ef3e3eed"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a82c1d4bab80b9e0bf301a9d8291893e0" id="r_a82c1d4bab80b9e0bf301a9d8291893e0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00353.html#a82c1d4bab80b9e0bf301a9d8291893e0">obj_depth</a></td></tr>
+<tr class="separator:a82c1d4bab80b9e0bf301a9d8291893e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:adb9f4d414470b6670cde8d90759a6c1c" id="r_adb9f4d414470b6670cde8d90759a6c1c"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00353.html#adb9f4d414470b6670cde8d90759a6c1c">obj_index</a></td></tr>
+<tr class="separator:adb9f4d414470b6670cde8d90759a6c1c"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a91f0645f9062e892652357cd141c8ebb" id="r_a91f0645f9062e892652357cd141c8ebb"><td class="memItemLeft" align="right" valign="top">union <a class="el" href="a00329.html">hwloc_topology_diff_obj_attr_u</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00353.html#a91f0645f9062e892652357cd141c8ebb">diff</a></td></tr>
+<tr class="separator:a91f0645f9062e892652357cd141c8ebb"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<h2 class="groupheader">Field Documentation</h2>
+<a id="a91f0645f9062e892652357cd141c8ebb" name="a91f0645f9062e892652357cd141c8ebb"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a91f0645f9062e892652357cd141c8ebb">&#9670;&#160;</a></span>diff</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">union <a class="el" href="a00329.html">hwloc_topology_diff_obj_attr_u</a> hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::diff</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="acb9170a8eb3392656d70f7f3ef3e3eed" name="acb9170a8eb3392656d70f7f3ef3e3eed"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#acb9170a8eb3392656d70f7f3ef3e3eed">&#9670;&#160;</a></span>next</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">union <a class="el" href="a00345.html">hwloc_topology_diff_u</a>* hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::next</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a82c1d4bab80b9e0bf301a9d8291893e0" name="a82c1d4bab80b9e0bf301a9d8291893e0"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a82c1d4bab80b9e0bf301a9d8291893e0">&#9670;&#160;</a></span>obj_depth</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::obj_depth</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="adb9f4d414470b6670cde8d90759a6c1c" name="adb9f4d414470b6670cde8d90759a6c1c"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#adb9f4d414470b6670cde8d90759a6c1c">&#9670;&#160;</a></span>obj_index</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::obj_index</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a70a118ad288bd98f18c8ce6dc52e2d10" name="a70a118ad288bd98f18c8ce6dc52e2d10"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a70a118ad288bd98f18c8ce6dc52e2d10">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a> hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00161_source.html">diff.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00357.html 2.11.0-1/doc/doxygen-doc/html/a00357.html
--- 2.10.0-1/doc/doxygen-doc/html/a00357.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00357.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,131 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="a00345.html">hwloc_topology_diff_u</a></li><li class="navelem"><a class="el" href="a00357.html">hwloc_topology_diff_too_complex_s</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s Struct Reference</div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00161_source.html">diff.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a92084295a4d6faf17a95a7eea526ddbd" id="r_a92084295a4d6faf17a95a7eea526ddbd"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00357.html#a92084295a4d6faf17a95a7eea526ddbd">type</a></td></tr>
+<tr class="separator:a92084295a4d6faf17a95a7eea526ddbd"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a375afbaa043b109be689a7d9a3c7d153" id="r_a375afbaa043b109be689a7d9a3c7d153"><td class="memItemLeft" align="right" valign="top">union <a class="el" href="a00345.html">hwloc_topology_diff_u</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00357.html#a375afbaa043b109be689a7d9a3c7d153">next</a></td></tr>
+<tr class="separator:a375afbaa043b109be689a7d9a3c7d153"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a94c6498caeaafbb79927395d918d6cb3" id="r_a94c6498caeaafbb79927395d918d6cb3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00357.html#a94c6498caeaafbb79927395d918d6cb3">obj_depth</a></td></tr>
+<tr class="separator:a94c6498caeaafbb79927395d918d6cb3"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a6dc6b3c4adb10db74d993e37afaa0580" id="r_a6dc6b3c4adb10db74d993e37afaa0580"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00357.html#a6dc6b3c4adb10db74d993e37afaa0580">obj_index</a></td></tr>
+<tr class="separator:a6dc6b3c4adb10db74d993e37afaa0580"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<h2 class="groupheader">Field Documentation</h2>
+<a id="a375afbaa043b109be689a7d9a3c7d153" name="a375afbaa043b109be689a7d9a3c7d153"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a375afbaa043b109be689a7d9a3c7d153">&#9670;&#160;</a></span>next</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">union <a class="el" href="a00345.html">hwloc_topology_diff_u</a>* hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::next</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a94c6498caeaafbb79927395d918d6cb3" name="a94c6498caeaafbb79927395d918d6cb3"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a94c6498caeaafbb79927395d918d6cb3">&#9670;&#160;</a></span>obj_depth</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::obj_depth</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a6dc6b3c4adb10db74d993e37afaa0580" name="a6dc6b3c4adb10db74d993e37afaa0580"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a6dc6b3c4adb10db74d993e37afaa0580">&#9670;&#160;</a></span>obj_index</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::obj_index</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<a id="a92084295a4d6faf17a95a7eea526ddbd" name="a92084295a4d6faf17a95a7eea526ddbd"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a92084295a4d6faf17a95a7eea526ddbd">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00217.html#ga8470f631b7365c839d3e40d38c5b6291">hwloc_topology_diff_type_t</a> hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00161_source.html">diff.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00361.html 2.11.0-1/doc/doxygen-doc/html/a00361.html
--- 2.10.0-1/doc/doxygen-doc/html/a00361.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00361.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,177 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_disc_component Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_disc_component Struct Reference<div class="ingroups"><a class="el" href="a00219.html">Components and Plugins: Discovery components</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00167_source.html">plugins.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a4064c3b5d9213027e87caebef380a840" id="r_a4064c3b5d9213027e87caebef380a840"><td class="memItemLeft" align="right" valign="top">const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00361.html#a4064c3b5d9213027e87caebef380a840">name</a></td></tr>
+<tr class="separator:a4064c3b5d9213027e87caebef380a840"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a61ad3151efa02e3dbad5d919758f9c90" id="r_a61ad3151efa02e3dbad5d919758f9c90"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00361.html#a61ad3151efa02e3dbad5d919758f9c90">phases</a></td></tr>
+<tr class="separator:a61ad3151efa02e3dbad5d919758f9c90"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:acbb9957914dbf7b8f504215aa0c8d3fe" id="r_acbb9957914dbf7b8f504215aa0c8d3fe"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00361.html#acbb9957914dbf7b8f504215aa0c8d3fe">excluded_phases</a></td></tr>
+<tr class="separator:acbb9957914dbf7b8f504215aa0c8d3fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a12e780d0acf89da7a8c8e37e51a3abcb" id="r_a12e780d0acf89da7a8c8e37e51a3abcb"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="a00369.html">hwloc_backend</a> *(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00361.html#a12e780d0acf89da7a8c8e37e51a3abcb">instantiate</a> )(struct hwloc_topology *topology, struct <a class="el" href="a00361.html">hwloc_disc_component</a> *component, unsigned <a class="el" href="a00361.html#acbb9957914dbf7b8f504215aa0c8d3fe">excluded_phases</a>, const void *data1, const void *data2, const void *data3)</td></tr>
+<tr class="separator:a12e780d0acf89da7a8c8e37e51a3abcb"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ae86d283c272c5ae24073a235efbf6b59" id="r_ae86d283c272c5ae24073a235efbf6b59"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00361.html#ae86d283c272c5ae24073a235efbf6b59">priority</a></td></tr>
+<tr class="separator:ae86d283c272c5ae24073a235efbf6b59"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ace80cafe2b1732b047b3fc3da47e6517" id="r_ace80cafe2b1732b047b3fc3da47e6517"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00361.html#ace80cafe2b1732b047b3fc3da47e6517">enabled_by_default</a></td></tr>
+<tr class="separator:ace80cafe2b1732b047b3fc3da47e6517"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Discovery component structure. </p>
+<p>This is the major kind of components, taking care of the discovery. They are registered by generic components, either statically-built or as plugins. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="ace80cafe2b1732b047b3fc3da47e6517" name="ace80cafe2b1732b047b3fc3da47e6517"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ace80cafe2b1732b047b3fc3da47e6517">&#9670;&#160;</a></span>enabled_by_default</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_disc_component::enabled_by_default</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Enabled by default. If unset, if will be disabled unless explicitly requested. </p>
+
+</div>
+</div>
+<a id="acbb9957914dbf7b8f504215aa0c8d3fe" name="acbb9957914dbf7b8f504215aa0c8d3fe"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#acbb9957914dbf7b8f504215aa0c8d3fe">&#9670;&#160;</a></span>excluded_phases</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_disc_component::excluded_phases</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Component phases to exclude, as an OR'ed set of <a class="el" href="a00220.html#ga600bba1a62022d5f516800649b1edb61" title="Discovery phase.">hwloc_disc_phase_t</a>. </p>
+<p>For a GLOBAL component, this usually includes all other phases (<code>~UL</code>).</p>
+<p>Other components only exclude types that may bring conflicting topology information. MISC components should likely not be excluded since they usually bring non-primary additional information. </p>
+
+</div>
+</div>
+<a id="a12e780d0acf89da7a8c8e37e51a3abcb" name="a12e780d0acf89da7a8c8e37e51a3abcb"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a12e780d0acf89da7a8c8e37e51a3abcb">&#9670;&#160;</a></span>instantiate</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">struct <a class="el" href="a00369.html">hwloc_backend</a> *(* hwloc_disc_component::instantiate) (struct hwloc_topology *topology, struct <a class="el" href="a00361.html">hwloc_disc_component</a> *component, unsigned <a class="el" href="a00361.html#acbb9957914dbf7b8f504215aa0c8d3fe">excluded_phases</a>, const void *data1, const void *data2, const void *data3)</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Instantiate callback to create a backend from the component. Parameters data1, data2, data3 are NULL except for components that have special enabling routines such as <a class="el" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e" title="Enable XML-file based topology.">hwloc_topology_set_xml()</a>. </p>
+
+</div>
+</div>
+<a id="a4064c3b5d9213027e87caebef380a840" name="a4064c3b5d9213027e87caebef380a840"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a4064c3b5d9213027e87caebef380a840">&#9670;&#160;</a></span>name</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">const char* hwloc_disc_component::name</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Name. If this component is built as a plugin, this name does not have to match the plugin filename. </p>
+
+</div>
+</div>
+<a id="a61ad3151efa02e3dbad5d919758f9c90" name="a61ad3151efa02e3dbad5d919758f9c90"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a61ad3151efa02e3dbad5d919758f9c90">&#9670;&#160;</a></span>phases</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_disc_component::phases</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Discovery phases performed by this component. OR'ed set of <a class="el" href="a00220.html#ga600bba1a62022d5f516800649b1edb61" title="Discovery phase.">hwloc_disc_phase_t</a>. </p>
+
+</div>
+</div>
+<a id="ae86d283c272c5ae24073a235efbf6b59" name="ae86d283c272c5ae24073a235efbf6b59"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ae86d283c272c5ae24073a235efbf6b59">&#9670;&#160;</a></span>priority</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_disc_component::priority</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Component priority. Used to sort topology-&gt;components, higher priority first. Also used to decide between two components with the same name. </p>
+<p>Usual values are 50 for native OS (or platform) components, 45 for x86, 40 for no-OS fallback, 30 for global components (xml, synthetic), 20 for pci, 10 for other misc components (opencl etc.). </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00167_source.html">plugins.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00365.html 2.11.0-1/doc/doxygen-doc/html/a00365.html
--- 2.10.0-1/doc/doxygen-doc/html/a00365.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00365.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,120 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_disc_status Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_disc_status Struct Reference<div class="ingroups"><a class="el" href="a00220.html">Components and Plugins: Discovery backends</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00167_source.html">plugins.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:abaf7c8c082d43e133171f0723dbf824b" id="r_abaf7c8c082d43e133171f0723dbf824b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00220.html#ga600bba1a62022d5f516800649b1edb61">hwloc_disc_phase_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00365.html#abaf7c8c082d43e133171f0723dbf824b">phase</a></td></tr>
+<tr class="separator:abaf7c8c082d43e133171f0723dbf824b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a0f95fa42d46a6e7cf8dee8af12afee3a" id="r_a0f95fa42d46a6e7cf8dee8af12afee3a"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00365.html#a0f95fa42d46a6e7cf8dee8af12afee3a">excluded_phases</a></td></tr>
+<tr class="separator:a0f95fa42d46a6e7cf8dee8af12afee3a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ad8b123cecb945a9182eb824ccf8ef9d7" id="r_ad8b123cecb945a9182eb824ccf8ef9d7"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00365.html#ad8b123cecb945a9182eb824ccf8ef9d7">flags</a></td></tr>
+<tr class="separator:ad8b123cecb945a9182eb824ccf8ef9d7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Discovery status structure. </p>
+<p>Used by the core and backends to inform about what has been/is being done during the discovery process. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a0f95fa42d46a6e7cf8dee8af12afee3a" name="a0f95fa42d46a6e7cf8dee8af12afee3a"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a0f95fa42d46a6e7cf8dee8af12afee3a">&#9670;&#160;</a></span>excluded_phases</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_disc_status::excluded_phases</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Dynamically excluded phases. If a component decides during discovery that some phases are no longer needed. </p>
+
+</div>
+</div>
+<a id="ad8b123cecb945a9182eb824ccf8ef9d7" name="ad8b123cecb945a9182eb824ccf8ef9d7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ad8b123cecb945a9182eb824ccf8ef9d7">&#9670;&#160;</a></span>flags</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned long hwloc_disc_status::flags</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>OR'ed set of <a class="el" href="a00220.html#gaae1b38cf9b12e489884ce2a07275964b" title="Discovery status flags.">hwloc_disc_status_flag_e</a>. </p>
+
+</div>
+</div>
+<a id="abaf7c8c082d43e133171f0723dbf824b" name="abaf7c8c082d43e133171f0723dbf824b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#abaf7c8c082d43e133171f0723dbf824b">&#9670;&#160;</a></span>phase</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00220.html#ga600bba1a62022d5f516800649b1edb61">hwloc_disc_phase_t</a> hwloc_disc_status::phase</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>The current discovery phase that is performed. Must match one of the phases in the component phases field. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00167_source.html">plugins.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00369.html 2.11.0-1/doc/doxygen-doc/html/a00369.html
--- 2.10.0-1/doc/doxygen-doc/html/a00369.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00369.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,194 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_backend Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_backend Struct Reference<div class="ingroups"><a class="el" href="a00220.html">Components and Plugins: Discovery backends</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00167_source.html">plugins.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:aeca769840a6ff03e96462a9533adbccd" id="r_aeca769840a6ff03e96462a9533adbccd"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00369.html#aeca769840a6ff03e96462a9533adbccd">phases</a></td></tr>
+<tr class="separator:aeca769840a6ff03e96462a9533adbccd"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aaa8eafe495aadd81c2e3c4ec527c10ba" id="r_aaa8eafe495aadd81c2e3c4ec527c10ba"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00369.html#aaa8eafe495aadd81c2e3c4ec527c10ba">flags</a></td></tr>
+<tr class="separator:aaa8eafe495aadd81c2e3c4ec527c10ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ab8806f6db077f1bb2e9d63ec99223f7a" id="r_ab8806f6db077f1bb2e9d63ec99223f7a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00369.html#ab8806f6db077f1bb2e9d63ec99223f7a">is_thissystem</a></td></tr>
+<tr class="separator:ab8806f6db077f1bb2e9d63ec99223f7a"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a2ea5bd36b7f06efdb65b98b32af16c68" id="r_a2ea5bd36b7f06efdb65b98b32af16c68"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00369.html#a2ea5bd36b7f06efdb65b98b32af16c68">private_data</a></td></tr>
+<tr class="separator:a2ea5bd36b7f06efdb65b98b32af16c68"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a36c4fa86350525b46340c67b802c69c7" id="r_a36c4fa86350525b46340c67b802c69c7"><td class="memItemLeft" align="right" valign="top">void(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00369.html#a36c4fa86350525b46340c67b802c69c7">disable</a> )(struct <a class="el" href="a00369.html">hwloc_backend</a> *backend)</td></tr>
+<tr class="separator:a36c4fa86350525b46340c67b802c69c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:accff2cd8404be43c3b44cec05e6f609b" id="r_accff2cd8404be43c3b44cec05e6f609b"><td class="memItemLeft" align="right" valign="top">int(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00369.html#accff2cd8404be43c3b44cec05e6f609b">discover</a> )(struct <a class="el" href="a00369.html">hwloc_backend</a> *backend, struct <a class="el" href="a00365.html">hwloc_disc_status</a> *status)</td></tr>
+<tr class="separator:accff2cd8404be43c3b44cec05e6f609b"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aaac253491264c20930f44817270bc502" id="r_aaac253491264c20930f44817270bc502"><td class="memItemLeft" align="right" valign="top">int(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00369.html#aaac253491264c20930f44817270bc502">get_pci_busid_cpuset</a> )(struct <a class="el" href="a00369.html">hwloc_backend</a> *backend, struct hwloc_pcidev_attr_s *busid, <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> cpuset)</td></tr>
+<tr class="separator:aaac253491264c20930f44817270bc502"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Discovery backend structure. </p>
+<p>A backend is the instantiation of a discovery component. When a component gets enabled for a topology, its instantiate() callback creates a backend.</p>
+<p><a class="el" href="a00220.html#ga6118a1009aa390c13255a330ccf253cf" title="Allocate a backend structure, set good default values, initialize backend-&gt;component and topology,...">hwloc_backend_alloc()</a> initializes all fields to default values that the component may change (except "component" and "next") before enabling the backend with <a class="el" href="a00220.html#ga4715779d7191833e9b1a7490989a7497" title="Enable a previously allocated and setup backend.">hwloc_backend_enable()</a>.</p>
+<p>Most backends assume that the topology is_thissystem flag is set because they talk to the underlying operating system. However they may still be used in topologies without the is_thissystem flag for debugging reasons. In practice, they are usually auto-disabled in such cases (excluded by xml or synthetic backends, or by environment variables when changing the Linux fsroot or the x86 cpuid path). </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a36c4fa86350525b46340c67b802c69c7" name="a36c4fa86350525b46340c67b802c69c7"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a36c4fa86350525b46340c67b802c69c7">&#9670;&#160;</a></span>disable</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void(* hwloc_backend::disable) (struct <a class="el" href="a00369.html">hwloc_backend</a> *backend)</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Callback for freeing the private_data. May be NULL. </p>
+
+</div>
+</div>
+<a id="accff2cd8404be43c3b44cec05e6f609b" name="accff2cd8404be43c3b44cec05e6f609b"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#accff2cd8404be43c3b44cec05e6f609b">&#9670;&#160;</a></span>discover</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int(* hwloc_backend::discover) (struct <a class="el" href="a00369.html">hwloc_backend</a> *backend, struct <a class="el" href="a00365.html">hwloc_disc_status</a> *status)</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Main discovery callback. returns -1 on error, either because it couldn't add its objects ot the existing topology, or because of an actual discovery/gathering failure. May be NULL. </p>
+
+</div>
+</div>
+<a id="aaa8eafe495aadd81c2e3c4ec527c10ba" name="aaa8eafe495aadd81c2e3c4ec527c10ba"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aaa8eafe495aadd81c2e3c4ec527c10ba">&#9670;&#160;</a></span>flags</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned long hwloc_backend::flags</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Backend flags, currently always 0. </p>
+
+</div>
+</div>
+<a id="aaac253491264c20930f44817270bc502" name="aaac253491264c20930f44817270bc502"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aaac253491264c20930f44817270bc502">&#9670;&#160;</a></span>get_pci_busid_cpuset</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int(* hwloc_backend::get_pci_busid_cpuset) (struct <a class="el" href="a00369.html">hwloc_backend</a> *backend, struct hwloc_pcidev_attr_s *busid, <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84">hwloc_bitmap_t</a> cpuset)</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Callback to retrieve the locality of a PCI object. Called by the PCI core when attaching PCI hierarchy to CPU objects. May be NULL. </p>
+
+</div>
+</div>
+<a id="ab8806f6db077f1bb2e9d63ec99223f7a" name="ab8806f6db077f1bb2e9d63ec99223f7a"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ab8806f6db077f1bb2e9d63ec99223f7a">&#9670;&#160;</a></span>is_thissystem</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int hwloc_backend::is_thissystem</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Backend-specific 'is_thissystem' property. Set to 0 if the backend disables the thissystem flag for this topology (e.g. loading from xml or synthetic string, or using a different fsroot on Linux, or a x86 CPUID dump). Set to -1 if the backend doesn't care (default). </p>
+
+</div>
+</div>
+<a id="aeca769840a6ff03e96462a9533adbccd" name="aeca769840a6ff03e96462a9533adbccd"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aeca769840a6ff03e96462a9533adbccd">&#9670;&#160;</a></span>phases</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_backend::phases</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Discovery phases performed by this component, possibly without some of them if excluded by other components. OR'ed set of <a class="el" href="a00220.html#ga600bba1a62022d5f516800649b1edb61" title="Discovery phase.">hwloc_disc_phase_t</a>. </p>
+
+</div>
+</div>
+<a id="a2ea5bd36b7f06efdb65b98b32af16c68" name="a2ea5bd36b7f06efdb65b98b32af16c68"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a2ea5bd36b7f06efdb65b98b32af16c68">&#9670;&#160;</a></span>private_data</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void* hwloc_backend::private_data</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Backend private data, or NULL if none. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00167_source.html">plugins.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00373.html 2.11.0-1/doc/doxygen-doc/html/a00373.html
--- 2.10.0-1/doc/doxygen-doc/html/a00373.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00373.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,182 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc_component Struct Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="summary">
+<a href="#pub-attribs">Data Fields</a>  </div>
+  <div class="headertitle"><div class="title">hwloc_component Struct Reference<div class="ingroups"><a class="el" href="a00221.html">Components and Plugins: Generic components</a></div></div></div>
+</div><!--header-->
+<div class="contents">
+
+<p><code>#include &lt;<a class="el" href="a00167_source.html">plugins.h</a>&gt;</code></p>
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
+Data Fields</h2></td></tr>
+<tr class="memitem:a3250bd6fc9713946991d805e48091b2e" id="r_a3250bd6fc9713946991d805e48091b2e"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00373.html#a3250bd6fc9713946991d805e48091b2e">abi</a></td></tr>
+<tr class="separator:a3250bd6fc9713946991d805e48091b2e"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:aea613546886d9b8221cadba920fe3ebc" id="r_aea613546886d9b8221cadba920fe3ebc"><td class="memItemLeft" align="right" valign="top">int(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00373.html#aea613546886d9b8221cadba920fe3ebc">init</a> )(unsigned long <a class="el" href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">flags</a>)</td></tr>
+<tr class="separator:aea613546886d9b8221cadba920fe3ebc"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a4612015451a1c706e8ba19114cb8baae" id="r_a4612015451a1c706e8ba19114cb8baae"><td class="memItemLeft" align="right" valign="top">void(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00373.html#a4612015451a1c706e8ba19114cb8baae">finalize</a> )(unsigned long <a class="el" href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">flags</a>)</td></tr>
+<tr class="separator:a4612015451a1c706e8ba19114cb8baae"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a789208ada7e17492cfd3a5a88a6bb0ee" id="r_a789208ada7e17492cfd3a5a88a6bb0ee"><td class="memItemLeft" align="right" valign="top"><a class="el" href="a00221.html#ga31a5a455f4e666b936f0a9e8fb9a0f47">hwloc_component_type_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00373.html#a789208ada7e17492cfd3a5a88a6bb0ee">type</a></td></tr>
+<tr class="separator:a789208ada7e17492cfd3a5a88a6bb0ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:ab8043c5b4cc0e81aabba586ccb194335" id="r_ab8043c5b4cc0e81aabba586ccb194335"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">flags</a></td></tr>
+<tr class="separator:ab8043c5b4cc0e81aabba586ccb194335"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:a4b8cffd1d943c29fdc102b841b8598d4" id="r_a4b8cffd1d943c29fdc102b841b8598d4"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="a00373.html#a4b8cffd1d943c29fdc102b841b8598d4">data</a></td></tr>
+<tr class="separator:a4b8cffd1d943c29fdc102b841b8598d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
+<div class="textblock"><p>Generic component structure. </p>
+<p>Generic components structure, either statically listed by configure in static-components.h or dynamically loaded as a plugin. </p>
+</div><h2 class="groupheader">Field Documentation</h2>
+<a id="a3250bd6fc9713946991d805e48091b2e" name="a3250bd6fc9713946991d805e48091b2e"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a3250bd6fc9713946991d805e48091b2e">&#9670;&#160;</a></span>abi</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned hwloc_component::abi</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Component ABI version, set to <a class="el" href="a00171.html#gaac5bc1f46f55e10ef0141a68ce70e21f" title="Current component and plugin ABI version (see hwloc/plugins.h)">HWLOC_COMPONENT_ABI</a>. </p>
+
+</div>
+</div>
+<a id="a4b8cffd1d943c29fdc102b841b8598d4" name="a4b8cffd1d943c29fdc102b841b8598d4"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a4b8cffd1d943c29fdc102b841b8598d4">&#9670;&#160;</a></span>data</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void* hwloc_component::data</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Component data, pointing to a struct <a class="el" href="a00361.html" title="Discovery component structure.">hwloc_disc_component</a> or struct hwloc_xml_component. </p>
+
+</div>
+</div>
+<a id="a4612015451a1c706e8ba19114cb8baae" name="a4612015451a1c706e8ba19114cb8baae"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a4612015451a1c706e8ba19114cb8baae">&#9670;&#160;</a></span>finalize</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void(* hwloc_component::finalize) (unsigned long <a class="el" href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">flags</a>)</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Process-wide component termination callback. </p>
+<p>This optional callback is called after unregistering the component from the hwloc core (before unloading the plugin).</p>
+<p><code>flags</code> is always 0 for now.</p>
+<dl class="section note"><dt>Note</dt><dd>If the component uses ltdl for loading its own plugins, it should load/unload them only in <a class="el" href="a00373.html#aea613546886d9b8221cadba920fe3ebc" title="Process-wide component initialization callback.">init()</a> and <a class="el" href="a00373.html#a4612015451a1c706e8ba19114cb8baae" title="Process-wide component termination callback.">finalize()</a>, to avoid race conditions with hwloc's use of ltdl. </dd></dl>
+
+</div>
+</div>
+<a id="ab8043c5b4cc0e81aabba586ccb194335" name="ab8043c5b4cc0e81aabba586ccb194335"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#ab8043c5b4cc0e81aabba586ccb194335">&#9670;&#160;</a></span>flags</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">unsigned long hwloc_component::flags</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Component flags, unused for now. </p>
+
+</div>
+</div>
+<a id="aea613546886d9b8221cadba920fe3ebc" name="aea613546886d9b8221cadba920fe3ebc"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#aea613546886d9b8221cadba920fe3ebc">&#9670;&#160;</a></span>init</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">int(* hwloc_component::init) (unsigned long <a class="el" href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">flags</a>)</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Process-wide component initialization callback. </p>
+<p>This optional callback is called when the component is registered to the hwloc core (after loading the plugin).</p>
+<p>When the component is built as a plugin, this callback should call hwloc_check_plugin_namespace() and return an negative error code on error.</p>
+<p><code>flags</code> is always 0 for now.</p>
+<dl class="section return"><dt>Returns</dt><dd>0 on success, or a negative code on error.</dd></dl>
+<dl class="section note"><dt>Note</dt><dd>If the component uses ltdl for loading its own plugins, it should load/unload them only in <a class="el" href="a00373.html#aea613546886d9b8221cadba920fe3ebc" title="Process-wide component initialization callback.">init()</a> and <a class="el" href="a00373.html#a4612015451a1c706e8ba19114cb8baae" title="Process-wide component termination callback.">finalize()</a>, to avoid race conditions with hwloc's use of ltdl. </dd></dl>
+
+</div>
+</div>
+<a id="a789208ada7e17492cfd3a5a88a6bb0ee" name="a789208ada7e17492cfd3a5a88a6bb0ee"></a>
+<h2 class="memtitle"><span class="permalink"><a href="#a789208ada7e17492cfd3a5a88a6bb0ee">&#9670;&#160;</a></span>type</h2>
+
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname"><a class="el" href="a00221.html#ga31a5a455f4e666b936f0a9e8fb9a0f47">hwloc_component_type_t</a> hwloc_component::type</td>
+        </tr>
+      </table>
+</div><div class="memdoc">
+
+<p>Component type. </p>
+
+</div>
+</div>
+<hr/>The documentation for this struct was generated from the following file:<ul>
+<li><a class="el" href="a00167_source.html">plugins.h</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00374.html 2.11.0-1/doc/doxygen-doc/html/a00374.html
--- 2.10.0-1/doc/doxygen-doc/html/a00374.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00374.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,99 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Installation</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Installation</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>hwloc (<a href="https://www.open-mpi.org/projects/hwloc/">https://www.open-mpi.org/projects/hwloc/</a>) is available under the BSD license. It is hosted as a sub-project of the overall Open MPI project (<a href="https://www.open-mpi.org/">https://www.open-mpi.org/</a>). Note that hwloc does not require any functionality from Open MPI &ndash; it is a wholly separate (and much smaller!) project and code base. It just happens to be hosted as part of the overall Open MPI project.</p>
+<h1><a class="anchor" id="basic_installation"></a>
+Basic Installation</h1>
+<p>Installation is the fairly common GNU-based process:</p>
+<pre class="fragment">shell$ ./configure --prefix=...
+shell$ make
+shell$ make install
+</pre><p>The hwloc command-line tool "lstopo" produces human-readable topology maps, as mentioned above. Running the "lstopo" tool is a good way to check as a graphical output whether hwloc properly detected the architecture of your node.</p>
+<h1><a class="anchor" id="optional_dependencies"></a>
+Optional Dependencies</h1>
+<p>lstopo may also export graphics to the SVG and "fig" file formats. Support for PDF, Postscript, and PNG exporting is provided if the "Cairo" development package (usually <code>cairo-devel</code> or <code>libcairo2-dev</code>) can be found in "lstopo" when hwloc is configured and build. <br  />
+</p>
+<p>The hwloc core may also benefit from the following development packages: </p><ul>
+<li>
+libpciaccess for full I/O device discovery (<code>libpciaccess-devel</code> or <code>libpciaccess-dev</code> package). On Linux, PCI discovery may still be performed (without vendor/device names) even if libpciaccess cannot be used.  </li>
+<li>
+AMD or NVIDIA OpenCL implementations for OpenCL device discovery.  </li>
+<li>
+the NVIDIA CUDA Toolkit for CUDA device discovery. See <a class="el" href="a00391.html#faq_cuda_build">How do I enable CUDA and select which CUDA version to use?</a>.  </li>
+<li>
+the NVIDIA Management Library (NVML) for NVML device discovery. It is included in CUDA since version 8.0. Older NVML releases were available within the NVIDIA GPU Deployment Kit from <a href="https://developer.nvidia.com/gpu-deployment-kit">https://developer.nvidia.com/gpu-deployment-kit</a> .  </li>
+<li>
+the NV-CONTROL X extension library (NVCtrl) for NVIDIA display discovery. The relevant development package is usually <code>libXNVCtrl-devel</code> or <code>libxnvctrl-dev</code>. It is also available within nvidia-settings from <a href="ftp://download.nvidia.com/XFree86/nvidia-settings/">ftp://download.nvidia.com/XFree86/nvidia-settings/</a> and <a href="https://github.com/NVIDIA/nvidia-settings/">https://github.com/NVIDIA/nvidia-settings/</a> .  </li>
+<li>
+the AMD ROCm SMI library for RSMI device discovery. The relevant development package is usually <code>rocm-smi-lib64</code> or <code>librocm-smi-dev</code>. See <a class="el" href="a00391.html#faq_rocm_build">How do I enable ROCm SMI and select which version to use?</a>.  </li>
+<li>
+the oneAPI Level Zero library. The relevant development package is usually <code>level-zero-dev</code> or <code>level-zero-devel</code>.  </li>
+<li>
+libxml2 for full XML import/export support (otherwise, the internal minimalistic parser will only be able to import XML files that were exported by the same hwloc release). See <a class="el" href="a00385.html">Importing and exporting topologies from/to XML files</a> for details. The relevant development package is usually <code>libxml2-devel</code> or <code>libxml2-dev</code>.  </li>
+<li>
+libudev on Linux for easier discovery of OS device information (otherwise hwloc will try to manually parse udev raw files). The relevant development package is usually <code>libudev-devel</code> or <code>libudev-dev</code>.  </li>
+<li>
+libtool's ltdl library for dynamic plugin loading if the native dlopen cannot be used. The relevant development package is usually <code>libtool-ltdl-devel</code> or <code>libltdl-dev</code>.  </li>
+</ul>
+<p>PCI and XML support may be statically built inside the main hwloc library, or as separate dynamically-loaded plugins (see the <a class="el" href="a00389.html">Components and plugins</a> section).</p>
+<p>Also note that if you install supplemental libraries in non-standard locations, hwloc's configure script may not be able to find them without some help. You may need to specify additional CPPFLAGS, LDFLAGS, or PKG_CONFIG_PATH values on the configure command line.</p>
+<p>For example, if libpciaccess was installed into /opt/pciaccess, hwloc's configure script may not find it by default. Try adding PKG_CONFIG_PATH to the ./configure command line, like this:</p>
+<pre class="fragment">./configure PKG_CONFIG_PATH=/opt/pciaccess/lib/pkgconfig ...
+</pre><p>Note that because of the possibility of GPL taint, the <code>pciutils</code> library <code>libpci</code> will not be used (remember that hwloc is BSD-licensed).</p>
+<h1><a class="anchor" id="gitclone_installation"></a>
+Installing from a Git clone</h1>
+<p>Additionally, the code can be directly cloned from Git:</p>
+<pre class="fragment">shell$ git clone https://github.com/open-mpi/hwloc.git
+shell$ cd hwloc
+shell$ ./autogen.sh
+</pre><p>Note that GNU Autoconf &gt;=2.63, Automake &gt;=1.11 and Libtool &gt;=2.2.6 are required when building from a Git clone.</p>
+<p>Nightly development snapshots are available on the web site, they can be configured and built without any need for Git or GNU Autotools. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00375.html 2.11.0-1/doc/doxygen-doc/html/a00375.html
--- 2.10.0-1/doc/doxygen-doc/html/a00375.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00375.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,94 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Compiling software on top of hwloc&#39;s C API</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Compiling software on top of hwloc's C API</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>A program using the hwloc C API (for instance with <code>hwloc-hello.c</code> presented in <a class="el" href="index.html#interface_example">API Example</a>) may be built with standard development tools. <code>pkg-config</code> provides easy ways to retrieve the required compiler and linker flags as described below, but it is not mandatory.</p>
+<h1><a class="anchor" id="useapi_gnumake"></a>
+Compiling on top of hwloc's C API with GNU Make</h1>
+<p>Here's an example of Makefile for building <code>hwloc-hello.c</code> with GNU Make:</p>
+<pre class="fragment">CFLAGS += $(shell pkg-config --cflags hwloc)
+LDLIBS += $(shell pkg-config --libs hwloc)
+
+hwloc-hello: hwloc-hello.c
+        $(CC) hwloc-hello.c $(CFLAGS) -o hwloc-hello $(LDLIBS)
+</pre><h1><a class="anchor" id="useapi_cmake"></a>
+Compiling on top of hwloc's C API with CMake</h1>
+<p>Here's an example de <code>CMakeLists.txt</code> which shows variables obtained from <code>pkg-config</code> and how to use them:</p>
+<pre class="fragment">cmake_minimum_required(VERSION 3.5)
+project(TEST_HWLOC C)
+include(FindPkgConfig)
+if(PKG_CONFIG_EXECUTABLE)
+  unset(HWLOC_FOUND CACHE)
+  pkg_search_module(HWLOC hwloc)
+  if(HWLOC_FOUND)
+    message(STATUS "HWLOC_LIBRARIES=${HWLOC_LIBRARIES}")
+    message(STATUS "HWLOC_LINK_LIBRARIES=${HWLOC_LINK_LIBRARIES}")
+    message(STATUS "HWLOC_LIBRARY_DIRS=${HWLOC_LIBRARY_DIRS}")
+    message(STATUS "HWLOC_LDFLAGS=${HWLOC_LDFLAGS}")
+    message(STATUS "HWLOC_LDFLAGS_OTHERS=${HWLOC_LDFLAGS_OTHERS}")
+    message(STATUS "HWLOC_INCLUDE_DIRS=${HWLOC_INCLUDE_DIRS}")
+    message(STATUS "HWLOC_CFLAGS=${HWLOC_CFLAGS}")
+    message(STATUS "HWLOC_CFLAGS_OTHER=${HWLOC_CFLAGS_OTHER}")
+  else()
+    message(FATAL_ERROR "HWLOC not found with pkg-config, add the path to hwloc.pc in PKG_CONFIG_PATH.")
+  endif()
+else()
+  message(FATAL_ERROR "PKG_CONFIG_EXECUTABLE: not found.")
+endif()
+
+add_executable(hwloc-hello hwloc-hello.c)
+target_include_directories(hwloc-hello PRIVATE ${HWLOC_INCLUDE_DIRS})
+target_compile_options(hwloc-hello PRIVATE ${HWLOC_CFLAGS})
+target_link_libraries(hwloc-hello PRIVATE ${HWLOC_LINK_LIBRARIES})
+target_link_options(hwloc-hello PRIVATE ${HWLOC_LDFLAGS})
+</pre><p>The project may be built with: </p><pre class="fragment">cmake -B build
+cmake --build build --verbose
+</pre><p>The built binary is then available under <code>build/hwloc-hello</code>. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00376.html 2.11.0-1/doc/doxygen-doc/html/a00376.html
--- 2.10.0-1/doc/doxygen-doc/html/a00376.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00376.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,159 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Terms and Definitions</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Terms and Definitions</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><h1><a class="anchor" id="termsanddefs_objects"></a>
+Objects</h1>
+<dl>
+<dt>Object </dt>
+<dd><p class="startdd">Interesting kind of part of the system, such as a Core, a L2Cache, a NUMA memory node, etc. The different types detected by hwloc are detailed in the <a class="el" href="a00173.html#gacd37bb612667dc437d66bfb175a8dc55" title="Type of topology object.">hwloc_obj_type_t</a> enumeration.</p>
+<p class="interdd">Objects are topologically sorted by locality (CPU and node sets) into a tree (see <a class="el" href="a00376.html#termsanddefs_tree">Hierarchy, Tree and Levels</a>). </p>
+<p class="enddd"></p>
+</dd>
+<dt>Object Kind </dt>
+<dd><p class="startdd">There are four kinds of Objects: Memory (NUMA nodes and Memory-side caches), I/O (Bridges, PCI and OS devices), Misc, and Normal (everything else, including Machine, Package, Die, Core, PU, CPU Caches, etc.). Normal and Memory objects have (non-NULL) CPU sets and nodesets, while I/O and Misc don't.</p>
+<dl class="section see"><dt>See also</dt><dd><a class="el" href="a00184.html">Kinds of object Type</a>. </dd></dl>
+</dd>
+<dt>Processing Unit (PU) </dt>
+<dd><p class="startdd">The smallest processing element that can be represented by a hwloc object. It may be a single-core processor, a core of a multicore processor, or a single thread in a SMT processor (also sometimes called "Logical processor", not to be confused with "Logical index of a processor"). hwloc's PU acronym stands for Processing Unit. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Package </dt>
+<dd><p class="startdd">A processor Package is the physical package that usually gets inserted into a socket on the motherboard. It is also often called a physical processor or a CPU even if these names bring confusion with respect to cores and processing units. A processor package usually contains multiple cores (and may also be composed of multiple dies). hwloc Package objects were called Sockets up to hwloc 1.10. </p>
+<p class="enddd"></p>
+</dd>
+<dt>NUMA Node </dt>
+<dd><p class="startdd">An object that contains memory that is directly and byte-accessible to the host processors. It is usually close to some cores as specified by its CPU set. Hence it is attached as a memory child of the object that groups those cores together, for instance a Package objects with 4 Core children (see <a class="el" href="a00376.html#termsanddefs_tree">Hierarchy, Tree and Levels</a>). </p>
+<p class="enddd"></p>
+</dd>
+<dt>Memory-side Cache </dt>
+<dd><p class="startdd">A cache in front of a specific memory region (e.g. a range of physical addresses). It caches all accesses to that region without caring about which core issued the request. This is the opposite of usual CPU caches where only accesses from the local cores are cached, without caring about the target memory.</p>
+<p class="enddd">In hwloc, memory-side caches are memory objects placed between their local CPU objects (parent) and the target NUMA node memory (child).  </p>
+</dd>
+</dl>
+<h1><a class="anchor" id="termsanddefs_indexes"></a>
+Indexes and Sets</h1>
+<dl>
+<dt>OS or physical index </dt>
+<dd><p class="startdd">The index that the operating system (OS) uses to identify the object. This may be completely arbitrary, non-unique, non-contiguous, not representative of logical proximity, and may depend on the BIOS configuration. That is why hwloc almost never uses them, only in the default lstopo output (<code>P#x</code>) and cpuset masks. See also <a class="el" href="a00391.html#faq_indexes">Should I use logical or physical/OS indexes? and how?</a>.</p>
+<p class="enddd"></p>
+</dd>
+<dt>Logical index </dt>
+<dd><p class="startdd">Index to uniquely identify objects of the same type and depth, automatically computed by hwloc according to the topology. It expresses logical proximity in a generic way, i.e. objects which have adjacent logical indexes are adjacent in the topology. That is why hwloc almost always uses it in its API, since it expresses logical proximity. They can be shown (as <code>L#x</code>) by <code>lstopo</code> thanks to the <code>-l</code> option. This index is always linear and in the range [0, num_objs_same_type_same_level-1]. Think of it as ``cousin rank.'' The ordering is based on topology first, and then on OS CPU numbers, so it is stable across everything except firmware CPU renumbering. "Logical index" should not be confused with "Logical processor". A "Logical
+  processor" (which in hwloc we rather call "processing unit" to avoid the confusion) has both a physical index (as chosen arbitrarily by BIOS/OS) and a logical index (as computed according to logical proximity by hwloc). See also <a class="el" href="a00391.html#faq_indexes">Should I use logical or physical/OS indexes? and how?</a>.</p>
+<p class="enddd"></p>
+</dd>
+<dt>CPU set </dt>
+<dd><p class="startdd">The set of processing units (PU) logically included in an object (if it makes sense). They are always expressed using physical processor numbers (as announced by the OS). They are implemented as the <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84" title="Set of bits represented as an opaque pointer to an internal bitmap.">hwloc_bitmap_t</a> opaque structure. hwloc CPU sets are just masks, they do <em>not</em> have any relation with an operating system actual binding notion like Linux' cpusets. I/O and Misc objects do not have CPU sets while all Normal and Memory objects have non-NULL CPU sets.</p>
+<p class="enddd"></p>
+</dd>
+<dt>Node set </dt>
+<dd><p class="startdd">The set of NUMA memory nodes logically included in an object (if it makes sense). They are always expressed using physical node numbers (as announced by the OS). They are implemented with the <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84" title="Set of bits represented as an opaque pointer to an internal bitmap.">hwloc_bitmap_t</a> opaque structure. as bitmaps. I/O and Misc objects do not have Node sets while all Normal and Memory objects have non-NULL nodesets.</p>
+<p class="enddd"></p>
+</dd>
+<dt>Bitmap </dt>
+<dd><p class="startdd">A possibly-infinite set of bits used for describing sets of objects such as CPUs (CPU sets) or memory nodes (Node sets). They are implemented with the <a class="el" href="a00194.html#gaa3c2bf4c776d603dcebbb61b0c923d84" title="Set of bits represented as an opaque pointer to an internal bitmap.">hwloc_bitmap_t</a> opaque structure. </p>
+<p class="enddd"></p>
+</dd>
+</dl>
+<h1><a class="anchor" id="termsanddefs_tree"></a>
+Hierarchy, Tree and Levels</h1>
+<dl>
+<dt>Parent object </dt>
+<dd><p class="startdd">The object logically containing the current object, for example because its CPU set includes the CPU set of the current object. All objects have a non-NULL parent, except the root of the topology (Machine object). </p>
+<p class="enddd"></p>
+</dd>
+<dt>Ancestor object </dt>
+<dd><p class="startdd">The parent object, or its own parent, and so on.</p>
+<p class="enddd"></p>
+</dd>
+<dt>Children object(s) </dt>
+<dd><p class="startdd">The object (or objects) contained in the current object because their CPU set is included in the CPU set of the current object. Each object may also contain separated lists for Memory, I/O and Misc object children. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Arity </dt>
+<dd><p class="startdd">The number of normal children of an object. There are also specific arities for Memory, I/O and Misc children. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Sibling objects </dt>
+<dd><p class="startdd">Objects in the same children list, which all of them are normal children of the same parent, or all of them are Memory children of the same parent, or I/O children, or Misc. They usually have the same type (and hence are cousins, as well). But they may not if the topology is asymmetric. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Sibling rank </dt>
+<dd><p class="startdd">Index to uniquely identify objects which have the same parent, and is always in the range [0, arity-1] (respectively memory_arity, io_arity or misc_arity for Memory, I/O and Misc children of a parent).</p>
+<p class="enddd"></p>
+</dd>
+<dt>Cousin objects </dt>
+<dd><p class="startdd">Objects of the same type (and depth) as the current object, even if they do not have the same parent.</p>
+<p class="enddd"></p>
+</dd>
+<dt>Level </dt>
+<dd><p class="startdd">Set of objects of the same type and depth. All these objects are cousins.</p>
+<p class="interdd">Memory, I/O and Misc objects also have their own specific levels and (virtual) depth. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Depth </dt>
+<dd><p class="startdd">Nesting level in the object tree, starting from the root object. If the topology is symmetric, the depth of a child is equal to the parent depth plus one, and an object depth is also equal to the number of parent/child links between the root object and the given object. If the topology is asymmetric, the difference between some parent and child depths may be larger than one when some intermediate levels (for instance groups) are missing in only some parts of the machine.</p>
+<p class="interdd">The depth of the Machine object is always 0 since it is always the root of the topology. The depth of PU objects is equal to the number of levels in the topology minus one.</p>
+<p class="interdd">Memory, I/O and Misc objects also have their own specific levels and depth. </p>
+<p class="enddd"></p>
+</dd>
+</dl>
+<p>The following diagram can help to understand the vocabulary of the relationships by showing the example of a machine with two dual core packages (with no hardware threads); thus, a topology with 5 levels. Each box with rounded corner corresponds to one <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d" title="Convenience typedef; a pointer to a struct hwloc_obj.">hwloc_obj_t</a>, containing the values of the different integer fields (depth, logical_index, etc.), and arrows show to which other <a class="el" href="a00174.html#ga79b8ab56877ef99ac59b833203391c7d" title="Convenience typedef; a pointer to a struct hwloc_obj.">hwloc_obj_t</a> pointers point to (first_child, parent, etc.).</p>
+<p>The topology always starts with a Machine object as root (depth 0) and ends with PU objects at the bottom (depth 4 here).</p>
+<p>Objects of the same level (cousins) are listed in red boxes and linked with red arrows. Children of the same parent (siblings) are linked with blue arrows.</p>
+<p>The L2 cache of the last core is intentionally missing to show how asymmetric topologies are handled. See <a class="el" href="a00391.html#faq_asymmetric">What happens if my topology is asymmetric?</a> for more information about such strange topologies.</p>
+<div class="image">
+<img src="diagram.png" alt=""/>
+</div>
+ <p>It should be noted that for PU objects, the logical index &ndash; as computed linearly by hwloc &ndash; is not the same as the OS index.</p>
+<p>The NUMA node is on the side because it is not part of the main tree but rather attached to the object that corresponds to its locality (the entire machine here, hence the root object). It is attached as a <em>Memory</em> child (in green) and has a virtual depth (negative). It could also have siblings if there were multiple local NUMA nodes, or cousins if other NUMA nodes were attached somewhere else in the machine.</p>
+<p>I/O or Misc objects could be attached in a similar manner. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00377.html 2.11.0-1/doc/doxygen-doc/html/a00377.html
--- 2.10.0-1/doc/doxygen-doc/html/a00377.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00377.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,105 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Command-Line Tools</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Command-Line Tools</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>hwloc comes with an extensive C programming interface and several command line utilities. Each of them is fully documented in its own manual page; the following is a summary of the available command line tools.</p>
+<h1><a class="anchor" id="cli_lstopo"></a>
+lstopo and lstopo-no-graphics</h1>
+<p>lstopo (also known as hwloc-ls) displays the hierarchical topology map of the current system. The output may be graphical, ascii-art or textual, and can also be exported to numerous file formats such as PDF, PNG, XML, and others. Advanced graphical outputs require the "Cairo" development package (usually <code>cairo-devel</code> or <code>libcairo2-dev</code>).</p>
+<p>lstopo and lstopo-no-graphics accept the same command-line options. However, graphical outputs are only available in lstopo. Textual outputs (those that do not depend on heavy external libraries such as Cairo) are supported in both lstopo and lstopo-no-graphics.</p>
+<p>This command can also display the processes currently bound to a part of the machine (via the <code>--ps</code> option).</p>
+<p>Note that lstopo can read XML files and/or alternate chroot filesystems and display topological maps representing those systems (e.g., use lstopo to output an XML file on one system, and then use lstopo to read in that XML file and display it on a different system).</p>
+<h1><a class="anchor" id="cli_hwloc_bind"></a>
+hwloc-bind</h1>
+<p>hwloc-bind binds processes to specific hardware objects through a flexible syntax. A simple example is binding an executable to specific cores (or packages or bitmaps or ...). The hwloc-bind(1) man page provides much more detail on what is possible.</p>
+<p>hwloc-bind can also be used to retrieve the current process' binding, or retrieve the last CPU(s) where a process ran, or operate on memory binding.</p>
+<p>Just like hwloc-calc, the input locations given to hwloc-bind may be either objects or cpusets (bitmaps as reported by hwloc-calc or hwloc-distrib).</p>
+<h1><a class="anchor" id="cli_hwloc_calc"></a>
+hwloc-calc</h1>
+<p>hwloc-calc is hwloc's Swiss Army Knife command-line tool for converting things. The input may be either objects or cpusets (bitmaps as reported by another hwloc-calc instance or by hwloc-distrib), that may be combined by addition, intersection or subtraction. The output may be expressed as: </p><ul>
+<li>
+a cpuset bitmap: This compact opaque representation of objects is useful for shell scripts etc. It may passed to hwloc command-line tools such as hwloc-calc or hwloc-bind, or to hwloc command-line options such as <code>lstopo --restrict</code>. </li>
+<li>
+a nodeset bitmap: Another opaque representation that represents memory locality more precisely, especially if some NUMA nodes are CPU less or if multiple NUMA nodes are local to the same CPUs. </li>
+<li>
+the amount of the equivalent hwloc objects from a specific type, or the list of their indexes. This is useful for iterating over all similar objects (for instance all cores) within a given part of a platform. </li>
+<li>
+a hierarchical description of objects, for instance a thread index within a core within a package. This gives a better view of the actual location of an object. </li>
+</ul>
+<p>Moreover, input and/or output may be use either physical/OS object indexes or as hwloc's logical object indexes. It eases cooperation with external tools such as taskset or numactl by exporting hwloc specifications into list of processor or NUMA node physical indexes. See also <a class="el" href="a00391.html#faq_indexes">Should I use logical or physical/OS indexes? and how?</a>.</p>
+<h1><a class="anchor" id="cli_hwloc_info"></a>
+hwloc-info</h1>
+<p>hwloc-info dumps information about the given objects, as well as all its specific attributes. It is intended to be used with tools such as grep for filtering certain attribute lines. When no object is specified, or when <code>--topology</code> is passed, hwloc-info prints a summary of the topology. When <code>--support</code> is passed, hwloc-info lists the supported features for the topology.</p>
+<h1><a class="anchor" id="cli_hwloc_distrib"></a>
+hwloc-distrib</h1>
+<p>hwloc-distrib generates a set of cpuset bitmaps that are uniformly distributed across the machine for the given number of processes. These strings may be used with hwloc-bind to run processes to maximize their memory bandwidth by properly distributing them across the machine.</p>
+<h1><a class="anchor" id="cli_hwloc_ps"></a>
+hwloc-ps</h1>
+<p>hwloc-ps is a tool to display the bindings of processes that are currently running on the local machine. By default, hwloc-ps only lists processes that are bound; unbound process (and Linux kernel threads) are not displayed.</p>
+<h1><a class="anchor" id="cli_hwloc_annotate"></a>
+hwloc-annotate</h1>
+<p>hwloc-annotate may modify object (and topology) attributes such as string information (see <a class="el" href="a00382.html#attributes_info">Custom string infos</a> for details) or Misc children objects. It may also add distances, memory attributes, etc. to the topology. It reads an input topology from a XML file and outputs the annotated topology as another XML file.</p>
+<h1><a class="anchor" id="cli_hwloc_diffpatchcompress"></a>
+hwloc-diff, hwloc-patch and hwloc-compress-dir</h1>
+<p>hwloc-diff computes the difference between two topologies and outputs it to another XML file.</p>
+<p>hwloc-patch reads such a difference file and applies to another topology.</p>
+<p>hwloc-compress-dir compresses an entire directory of XML files by using hwloc-diff to save the differences between topologies instead of entire topologies.</p>
+<h1><a class="anchor" id="cli_hwloc_dump_hwdata"></a>
+hwloc-dump-hwdata</h1>
+<p>hwloc-dump-hwdata is a Linux and x86-specific tool that dumps (during boot, privileged) some topology and locality information from raw hardware files (SMBIOS and ACPI tables) to human-readable and world-accessible files that the hwloc library will later reuse.</p>
+<p>Currently only used on Intel Xeon Phi processor platforms. See <a class="el" href="a00391.html#faq_knl_dump">Why do I need hwloc-dump-hwdata for memory on Intel Xeon Phi processor?</a>.</p>
+<p>See <code>HWLOC_DUMPED_HWDATA_DIR</code> in <a class="el" href="a00378.html">Environment Variables</a> for details about the location of dumped files.</p>
+<h1><a class="anchor" id="cli_hwloc_gather"></a>
+hwloc-gather-topology and hwloc-gather-cpuid</h1>
+<p>hwloc-gather-topology is a Linux-specific tool that saves the relevant topology files of the current machine into a tarball (and the corresponding lstopo outputs).</p>
+<p>hwloc-gather-cpuid is a x86-specific tool that dumps the result of CPUID instructions on the current machine into a directory.</p>
+<p>The output of hwloc-gather-cpuid is included in the tarball saved by hwloc-gather-topology when running on Linux/x86.</p>
+<p>These files may be used later (possibly offline) for simulating or debugging a machine without actually running on it. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00378.html 2.11.0-1/doc/doxygen-doc/html/a00378.html
--- 2.10.0-1/doc/doxygen-doc/html/a00378.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00378.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,218 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Environment Variables</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Environment Variables</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>The behavior of the hwloc library and tools may be tuned thanks to the following environment variables.</p>
+<dl>
+<dt>HWLOC_XMLFILE=/path/to/file.xml </dt>
+<dd><p class="startdd">enforces the discovery from the given XML file as if <a class="el" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e" title="Enable XML-file based topology.">hwloc_topology_set_xml()</a> had been called. This file may have been generated earlier with lstopo file.xml. For convenience, this backend provides empty binding hooks which just return success. To have hwloc still actually call OS-specific hooks, HWLOC_THISSYSTEM should be set 1 in the environment too, to assert that the loaded file is really the underlying system. See also <a class="el" href="a00385.html">Importing and exporting topologies from/to XML files</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_SYNTHETIC=synthetic_description </dt>
+<dd><p class="startdd">enforces the discovery through a synthetic description string as if <a class="el" href="a00181.html#ga4fab186bb6181a00bcf585825fddd38d" title="Enable synthetic topology.">hwloc_topology_set_synthetic()</a> had been called. For convenience, this backend provides empty binding hooks which just return success. See also <a class="el" href="a00386.html">Synthetic topologies</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_XML_VERBOSE=1 </dt>
+<dd></dd>
+<dt>HWLOC_SYNTHETIC_VERBOSE=1 </dt>
+<dd><p class="startdd">enables verbose messages in the XML or synthetic topology backends. hwloc XML backends (see <a class="el" href="a00385.html">Importing and exporting topologies from/to XML files</a>) can emit some error messages to the error output stream. Enabling these verbose messages within hwloc can be useful for understanding failures to parse input XML topologies. Similarly, enabling verbose messages in the synthetic topology backend can help understand why the description string is invalid. See also <a class="el" href="a00386.html">Synthetic topologies</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_THISSYSTEM=1 </dt>
+<dd><p class="startdd">enforces the return value of <a class="el" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017" title="Does the topology context come from this system?">hwloc_topology_is_thissystem()</a>, as if <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" title="Assume that the selected backend provides the topology for the system on which we are running.">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a> was set with <a class="el" href="a00182.html#gaaeed4df656979e5f16befea9d29b814b" title="Set OR&#39;ed flags to non-yet-loaded topology.">hwloc_topology_set_flags()</a>. It means that it makes hwloc assume that the selected backend provides the topology for the system on which we are running, even if it is not the OS-specific backend but the XML backend for instance. This means making the binding functions actually call the OS-specific system calls and really do binding, while the XML backend would otherwise provide empty hooks just returning success. This can be used for efficiency reasons to first detect the topology once, save it to a XML file, and quickly reload it later through the XML backend, but still having binding functions actually do bind. This also enables support for the variable HWLOC_THISSYSTEM_ALLOWED_RESOURCES. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_THISSYSTEM_ALLOWED_RESOURCES=1 </dt>
+<dd><p class="startdd">Get the set of allowed resources from the native operating system even if the topology was loaded from XML or synthetic description, as if <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea1b66bbd66e900e5c837f71defb32ad89" title="Get the set of allowed resources from the local operating system even if the topology was loaded from...">HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES</a> was set with <a class="el" href="a00182.html#gaaeed4df656979e5f16befea9d29b814b" title="Set OR&#39;ed flags to non-yet-loaded topology.">hwloc_topology_set_flags()</a>. This variable requires the topology to match the current system (see the variable HWLOC_THISSYSTEM). This is useful when the topology is not loaded directly from the local machine (e.g. for performance reason) and it comes with all resources, but the running process is restricted to only a part of the machine (for instance because of Linux Cgroup/Cpuset). </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_ALLOW=all </dt>
+<dd><p class="startdd">Totally ignore administrative restrictions such as Linux Cgroups and consider all resources (PUs and NUMA nodes) as allowed. This is different from setting HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED which gathers all resources but marks the unavailable ones as disallowed. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_HIDE_ERRORS=1 </dt>
+<dd><p class="startdd">enables or disables verbose reporting of errors. The hwloc library may issue warnings to the standard error stream when it detects a problem during topology discovery, for instance if the operating system (or user) gives contradictory topology information.</p>
+<p class="interdd">By default (1), hwloc only shows critical errors such as invalid hardware topology information or invalid configuration. If set to 0 (default in lstopo), more errors are displayed, for instance a failure to initialize CUDA or NVML. If set to 2, no hwloc error messages are shown.</p>
+<p class="interdd">Note that additional verbose messages may be enabled with other variables such as HWLOC_GROUPING_VERBOSE. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_USE_NUMA_DISTANCES=7 </dt>
+<dd><p class="startdd">enables or disables the use of NUMA distances. NUMA distances and memory target/initiator information may be used to improve the locality of NUMA nodes, especially CPU-less nodes. Bits in the value of this environment variable enable different features: Bit 0 enables the gathering of NUMA distances from the operating system. Bit 1 further enables the use of NUMA distances to improve the locality of CPU-less nodes. Bit 2 enables the use of target/initiator information. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_MEMTIERS_GUESS=none </dt>
+<dd></dd>
+<dt>HWLOC_MEMTIERS_GUESS=all </dt>
+<dd><p class="startdd">Disable or enable all heuristics to guess memory subtypes and tiers. By default, hwloc only uses heuristics that are likely correct and disables those that are unlikely. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_MEMTIERS=0x0f=HBM;0xf=DRAM </dt>
+<dd><p class="startdd">Enforce the memory tiers from the given semi-colon separated list. Each entry specifies a bitmask (nodeset) of NUMA nodes and their subtype. Nodes not listed in any entry are not placed in any tier.</p>
+<p class="interdd">If an empty value or <code>none</code> is given, tiers are entirely disabled. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_MEMTIERS_REFRESH=1 </dt>
+<dd><p class="startdd">Force the rebuilding of memory tiers. This is mostly useful when importing a XML topology from an old hwloc version which was not able to guess memory subtypes and tiers. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_GROUPING=1 </dt>
+<dd><p class="startdd">enables or disables objects grouping based on distances. By default, hwloc uses distance matrices between objects (either read from the OS or given by the user) to find groups of close objects. These groups are described by adding intermediate Group objects in the topology. Setting this environment variable to 0 will disable this grouping. This variable supersedes the obsolete HWLOC_IGNORE_DISTANCES variable. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_GROUPING_ACCURACY=0.05 </dt>
+<dd><p class="startdd">relaxes distance comparison during grouping. By default, objects may be grouped if their distances form a minimal distance graph. When setting this variable to 0.02, and when <a class="el" href="a00199.html#gga22428b6bab271411e3834e6b4ca22e37a5233ccf631c3bc53dd5c3e7a5d5c9b77" title="If grouping, consider the distance values as inaccurate and relax the comparisons during the grouping...">HWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE</a> is given, these distances do not have to be strictly equal anymore, they may just be equal with a 2% error. If set to <code>try</code> instead of a numerical value, hwloc will try to group with perfect accuracy (0, the default), then with 0.01, 0.02, 0.05 and finally 0.1. Numbers given in this environment variable should always use a dot as a decimal mark (for instance 0.01 instead of 0,01).</p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_GROUPING_VERBOSE=0 </dt>
+<dd><p class="startdd">enables or disables some verbose messages during grouping. If this variable is set to 1, some debug messages will be displayed during distance-based grouping of objects even if debug was not specific at configure time. This is useful when trying to find an interesting distance grouping accuracy.</p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_CPUKINDS_RANKING=default </dt>
+<dd><p class="startdd">change the ranking policy for CPU kinds. hwloc tries to rank CPU kinds that are energy efficiency first, and then CPUs that are rather high-performance and power hungry. <br  />
+ By default, if available, the OS-provided efficiency is used for ranking. Otherwise, the frequency and/or core types are used when available. <br  />
+ This environment variable may be set to <code>coretype+frequency</code>, <code>coretype+frequency_strict</code>, <code>coretype</code>, <code>frequency</code>, <code>frequency_base</code>, <code>frequency_max</code>, <code>forced_efficiency</code>, <code>no_forced_efficiency</code>, <code>default</code>, or <code>none</code>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_CPUKINDS_MAXFREQ=adjust=10 </dt>
+<dd><p class="startdd">change the use of the max frequency in the Linux backend. hwloc tries to read the base and max frequencies of each core on Linux. Some hardware features such as Intel Turbo Boost Max 3.0 make some cores report slightly higher max frequencies than others in the same CPU package. Despite having slightly different frequencies, these cores are considered identical instead of exposing an hybrid CPU. Hence, by default, hwloc uniformizes the max frequencies of cores that have the same base frequency (higher values are downgraded by up to 10%).</p>
+<p class="interdd">If this environment variable is set to <code>adjust=X</code>, the 10% threshold is replaced with X. If set to 1, max frequencies are not adjusted anymore, some homogeneous processors may appear hybrid because of this. If set to 0, max frequencies are entirely ignored. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_CPUKINDS_HOMOGENEOUS=0 </dt>
+<dd><p class="startdd">uniformize max frequency, base frequency and Linux capacity to force a single homogeneous kind of CPUs. This is enabled by default on NVIDIA Grace but may be disabled if set to 0 (or enabled on other platforms if set to 1). </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_PCI_LOCALITY=&lt;domain/bus&gt; &lt;cpuset&gt;;... </dt>
+<dd></dd>
+<dt>HWLOC_PCI_LOCALITY=/path/to/pci/locality/file </dt>
+<dd><p class="startdd">changes the locality of I/O devices behing the specified PCI buses. If no I/O locality information is available or if the BIOS reports incorrect information, it is possible to move a I/O device tree (OS and/or PCI devices with optional bridges) near a custom set of processors. <br  />
+ Localities are given either inside the environment variable itself, or in the pointed file. They may be separated either by semi-colons or by line-breaks. Invalid localities are silently ignored, hence it is possible to insert comments between actual localities. <br  />
+ Each locality contains a domain/bus specification (in hexadecimal numbers as usual) followed by a whitespace and a cpuset: </p><ul>
+<li>
+<code>0001 &lt;cpuset&gt;</code> specifies the locality of all buses in PCI domain 0000. </li>
+<li>
+<code>0000:0f &lt;cpuset&gt;</code> specifies only PCI bus 0f in domain 0000. </li>
+<li>
+<code>0002:04-0a &lt;cpuset&gt;</code> specifies a range of buses (from 04 to 0a) within domain 0002. </li>
+</ul>
+<p>Domain/bus specifications should usually match entire hierarchies of buses behind a bridge (including primary, secondary and subordinate buses). For instance, if hostbridge 0000:00 is above other bridges/switches with buses 0000:01 to 0000:09, the variable should be HWLOC_PCI_LOCALITY="0000:00-09 &lt;cpuset&gt;". It supersedes the old HWLOC_PCI_0000_00_LOCALCPUS=&lt;cpuset&gt; which only works when hostbridges exist in the topology. <br  />
+ If the variable is defined to empty or invalid, no forced PCI locality is applied but hwloc's internal automatic locality quirks are disabled, which means the exact PCI locality reported by the platform is used. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_X86_TOPOEXT_NUMANODES=0 </dt>
+<dd><p class="startdd">use AMD topoext CPUID leaf in the x86 backend to detect NUMA nodes. When using the x86 backend, setting this variable to 1 enables the building of NUMA nodes from AMD processor CPUID instructions. However this strategy does not always reflect BIOS configuration such as NUMA interleaving. And node indexes may be different from those of the operating system. Hence this should only be used when OS backends are wrong and the user is sure that CPUID returns correct NUMA information. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_KEEP_NVIDIA_GPU_NUMA_NODES=0 </dt>
+<dd><p class="startdd">show or hide NUMA nodes that correspond to NVIDIA GPU memory. By default they are ignored on POWER platforms to avoid interleaved memory being allocated on GPU by mistake.</p>
+<p class="interdd">Setting this environment variable to 0 hides the NUMA nodes (default on POWER). Setting to 1 exposes these NUMA nodes (default on non-POWER platforms such as NVIDIA Grace Hopper).</p>
+<p class="interdd">These NUMA nodes may be recognized by the <em>GPUMemory</em> subtype. They also have a <em>PCIBusID</em> info attribute to identify the corresponding GPU. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_KNL_MSCACHE_L3=0 </dt>
+<dd><p class="startdd">Expose the KNL MCDRAM in cache mode as a Memory-side Cache instead of a L3. hwloc releases prior to 2.1 exposed the MCDRAM cache as a CPU-side L3 cache. Now that Memory-side caches are supported by hwloc, it is still exposed as a L3 by default to avoid breaking existing applications. Setting this environment variable to 1 will expose it as a proper Memory-side cache. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_WINDOWS_PROCESSOR_GROUP_OBJS=0 </dt>
+<dd><p class="startdd">Expose Windows processor groups as hwloc Group objects. By default, these groups are disabled because they may be incompatible with the hierarchy of resources that hwloc builds (leading to warnings). Setting this variable to 1 reenables the addition of these groups to the topology.</p>
+<p class="interdd">This variable does not impact the querying of Windows processor groups using the dedicated API in <a class="el" href="a00131_source.html">hwloc/windows.h</a>, this feature is always supported. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_ANNOTATE_GLOBAL_COMPONENTS=0 </dt>
+<dd><p class="startdd">Allow components to annotate the topology even if they are usually excluded by global components by default. Setting this variable to 1 and also setting <code>HWLOC_COMPONENTS=xml,pci,stop</code> enables the addition of PCI vendor and model info attributes to a XML topology that was generated without those names (if pciaccess was missing). </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_FSROOT=/path/to/linux/filesystem-root/ </dt>
+<dd><p class="startdd">switches to reading the topology from the specified Linux filesystem root instead of the main file-system root. This directory may have been saved previously from another machine with <code>hwloc-gather-topology</code>. <br  />
+ One should likely also set <code>HWLOC_COMPONENTS=linux,stop</code> so that non-Linux backends are disabled (the <code>-i</code> option of command-line tools takes care of both). <br  />
+ Not using the main file-system root causes <a class="el" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017" title="Does the topology context come from this system?">hwloc_topology_is_thissystem()</a> to return 0. For convenience, this backend provides empty binding hooks which just return success. To have hwloc still actually call OS-specific hooks, HWLOC_THISSYSTEM should be set 1 in the environment too, to assert that the loaded file is really the underlying system. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_CPUID_PATH=/path/to/cpuid/ </dt>
+<dd><p class="startdd">forces the x86 backend to read dumped CPUIDs from the given directory instead of executing actual x86 CPUID instructions. This directory may have been saved previously from another machine with <code>hwloc-gather-cpuid</code>. <br  />
+ One should likely also set <code>HWLOC_COMPONENTS=x86,stop</code> so that non-x86 backends are disabled (the <code>-i</code> option of command-line tools takes care of both). <br  />
+ It causes <a class="el" href="a00182.html#ga68ffdcfd9175cdf40709801092f18017" title="Does the topology context come from this system?">hwloc_topology_is_thissystem()</a> to return 0. For convenience, this backend provides empty binding hooks which just return success. To have hwloc still actually call OS-specific hooks, HWLOC_THISSYSTEM should be set 1 in the environment too, to assert that the loaded CPUID dump is really the underlying system. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_DUMPED_HWDATA_DIR=/path/to/dumped/files/ </dt>
+<dd><p class="startdd">loads files dumped by <code>hwloc-dump-hwdata</code> (on Linux) from the given directory. The default dump/load directory is configured during build based on --runstatedir, --localstatedir, and --prefix options. It usually points to <code>/var/run/hwloc/</code> in Linux distribution packages, but it may also point to <code>$prefix/var/run/hwloc/</code> when manually installing and only specifying --prefix. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_COMPONENTS=list,of,components </dt>
+<dd><p class="startdd">forces a list of components to enable or disable. Enable or disable the given comma-separated list of components (if they do not conflict with each other). Component names prefixed with <code>-</code> are disabled (a single phase may also be disabled).</p>
+<p class="interdd">Once the end of the list is reached, hwloc falls back to enabling the remaining components (sorted by priority) that do not conflict with the already enabled ones, and unless explicitly disabled in the list. If <code>stop</code> is met, the enabling loop immediately stops, no more component is enabled.</p>
+<p class="interdd">If <code>xml</code> or <code>synthetic</code> components are selected, the corresponding XML filename or synthetic description string should be pass in <code>HWLOC_XMLFILE</code> or <code>HWLOC_SYNTHETIC</code> respectively.</p>
+<p class="interdd">Since this variable is the low-level and more generic way to select components, it takes precedence over environment variables for selecting components.</p>
+<p class="interdd">If the variable is set to an empty string (or set to a single comma), no specific component is loaded first, all components are loaded in priority order.</p>
+<p class="interdd">See <a class="el" href="a00389.html#plugins_select">Selecting which components to use</a> for details. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_COMPONENTS_VERBOSE=1 </dt>
+<dd><p class="startdd">displays verbose information about components. Display messages when components are registered or enabled. This is the recommended way to list the available components with their priority (all of them are <em>registered</em> at startup). </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_PLUGINS_PATH=/path/to/hwloc/plugins/:... </dt>
+<dd><p class="startdd">changes the default search directory for plugins. By default, <code>$libdir/hwloc</code> is used. The variable may contain several colon-separated directories. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_PLUGINS_VERBOSE=1 </dt>
+<dd><p class="startdd">displays verbose information about plugins. List which directories are scanned, which files are loaded, and which components are successfully loaded. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_PLUGINS_BLACKLIST=filename1,filename2,... </dt>
+<dd><p class="startdd">prevents plugins from being loaded if their filename (without path) is listed. Plugin filenames may be found in verbose messages outputted when HWLOC_PLUGINS_VERBOSE=1. </p>
+<p class="enddd"></p>
+</dd>
+<dt>HWLOC_DEBUG_VERBOSE=0 </dt>
+<dd><p class="startdd">disables all verbose messages that are enabled by default when <code>&ndash;enable-debug</code> is passed to configure. When set to more than 1, even more verbose messages are displayed. The default is 1. </p>
+<p class="enddd"></p>
+</dd>
+</dl>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00379.html 2.11.0-1/doc/doxygen-doc/html/a00379.html
--- 2.10.0-1/doc/doxygen-doc/html/a00379.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00379.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,76 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): CPU and Memory Binding Overview</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">CPU and Memory Binding Overview</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>Binding tasks and data buffers is hwloc's second main goal after discovering and exposing the hardware topology. hwloc defines APIs to bind threads and processes to cores and processing units (see <a class="el" href="a00179.html">CPU binding</a>), and to bind memory buffers to NUMA nodes (see <a class="el" href="a00180.html">Memory binding</a>). Some examples are available under doc/examples/ in the source tree.</p>
+<p>Sections below provide high-level insights on how these APIs work.</p>
+<h1><a class="anchor" id="cpu_mem_bind_portability"></a>
+Binding Policies and Portability</h1>
+<p>hwloc binding APIs are portable to multiple operating systems. However operating systems sometimes define slightly different policies, which means hwloc's behavior might slightly differ.</p>
+<p>On the CPU binding side, OSes have different constraints of which sets of PUs can be used for binding (only full cores, random sets of PUs, etc.). Moreover the <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca679a7e0f0c7ee06b123565f90d98e7fa" title="Request for strict binding from the OS.">HWLOC_CPUBIND_STRICT</a> may be given to clarify what to do in some corner cases. It is recommended to read <a class="el" href="a00179.html">CPU binding</a> for details.</p>
+<p>On the memory binding side, things are more complicated. First, there are multiple API for binding existing memory buffers, allocating new ones, etc. Second, multiple policies exist (first-touch, bind, interleave, etc.) but some of them are not implemented by all operating systems. Third, some of these policies have slightly different meanings. For instance, hwloc's <b>bind</b> (<a class="el" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c" title="Allocate memory on the specified nodes.">HWLOC_MEMBIND_BIND</a>) uses Linux' <b>MPOL_PREFERRED_MANY</b> (or <b>MPOL_PREFERRED</b>) by default, but it switches to <b>MPOL_BIND</b> when strict binding is requested (<a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6">HWLOC_MEMBIND_STRICT</a>). Reading <a class="el" href="a00180.html">Memory binding</a> is strongly recommended.</p>
+<h1><a class="anchor" id="cpu_mem_bind_joint"></a>
+Joint CPU and Memory Binding (or not)</h1>
+<p>Some operating systems do not systematically provide separate functions for CPU and memory binding. This means that CPU binding functions may have have effects on the memory binding policy. Likewise, changing the memory binding policy may change the CPU binding of the current thread. This is often not a problem for applications, so by default hwloc will make use of these functions when they provide better binding support.</p>
+<p>If the application does not want the CPU binding to change when changing the memory policy, it needs to use the <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2aad6b9eaf2ee324ca58dc8f58094b9997" title="Avoid any effect on CPU binding.">HWLOC_MEMBIND_NOCPUBIND</a> flag to prevent hwloc from using OS functions which would change the CPU binding. Additionally, <a class="el" href="a00179.html#gga217dc8d373f8958cc93c154ebce1c71ca41ce440443cc3087caed95ab60edcad6" title="Avoid any effect on memory binding.">HWLOC_CPUBIND_NOMEMBIND</a> can be passed to CPU binding function to prevent hwloc from using OS functions would change the memory binding policy. Of course, using these flags will reduce hwloc's overall support for binding, so their use is discouraged.</p>
+<p>One can avoid using these flags but still closely control both memory and CPU binding by allocating memory, touching each page in the allocated memory, and then changing the CPU binding. The already-really-allocated memory will then be "locked" to physical memory and will not be migrated. Thus, even if the memory binding policy gets changed by the CPU binding order, the already-allocated memory will not change with it. When binding and allocating further memory, the CPU binding should be performed again in case the memory binding altered the previously-selected CPU binding.</p>
+<h1><a class="anchor" id="cpu_mem_bind_current_membind"></a>
+Current Memory Binding Policy</h1>
+<p>Not all operating systems support the notion of a "current" memory binding policy for the current process, but such operating systems often still provide a way to allocate data on a given node set. Conversely, some operating systems support the notion of a "current" memory binding policy and do not permit allocating data on a specific node set without changing the current policy and allocate the data. To provide the most powerful coverage of these facilities, hwloc provides:</p>
+<ul>
+<li>
+functions that set/get the current memory binding policies (if supported): <a class="el" href="a00180.html#ga020951efa0ce3862bd4faec295501a7f" title="Set the default memory binding policy of the current process or thread to prefer the NUMA node(s) spe...">hwloc_set_membind()</a>, <a class="el" href="a00180.html#gae21f0a1a884929c784bebf070252aa56" title="Query the default memory binding policy and physical locality of the current process or thread.">hwloc_get_membind()</a>, <a class="el" href="a00180.html#gabc91ff16f7e41047924e3a4ae6d9da7e" title="Set the default memory binding policy of the specified process to prefer the NUMA node(s) specified b...">hwloc_set_proc_membind()</a> and <a class="el" href="a00180.html#ga1730ceb18ec6ee3b7bd3d0db81f07dc8" title="Query the default memory binding policy and physical locality of the specified process.">hwloc_get_proc_membind()</a> </li>
+<li>
+a function that allocates memory bound to specific node set without changing the current memory binding policy (if supported): <a class="el" href="a00180.html#gadf87089ef533db40460ccc24b5bc0d65" title="Allocate some memory on NUMA memory nodes specified by set.">hwloc_alloc_membind()</a>. </li>
+<li>
+a helper which, if needed, changes the current memory binding policy of the process in order to obtain memory binding: <a class="el" href="a00180.html#ga64e5f75165ea52930f67b17ef4aed2e8" title="Allocate some memory on NUMA memory nodes specified by set.">hwloc_alloc_membind_policy()</a>. </li>
+</ul>
+<p>An application can thus use the two first sets of functions if it wants to manage separately the global process binding policy and directed allocation, or use the third set of functions if it does not care about the process memory binding policy. Again, reading <a class="el" href="a00180.html">Memory binding</a> is strongly recommended. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00380.html 2.11.0-1/doc/doxygen-doc/html/a00380.html
--- 2.10.0-1/doc/doxygen-doc/html/a00380.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00380.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,185 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): I/O Devices</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">I/O Devices</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>hwloc usually manipulates processing units and memory but it can also discover I/O devices and report their locality as well. This is useful for placing I/O intensive applications on cores near the I/O devices they use, or for gathering information about all platform components.</p>
+<h1><a class="anchor" id="iodevices_enabling"></a>
+Enabling and requirements</h1>
+<p>I/O discovery is disabled by default (except in lstopo) for performance reasons. It can be enabled by changing the filtering of I/O object types to <code><a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5" title="Only keep likely-important objects of the given type.">HWLOC_TYPE_FILTER_KEEP_IMPORTANT</a></code> or <code><a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e" title="Keep all objects of this type.">HWLOC_TYPE_FILTER_KEEP_ALL</a></code> before loading the topology, for instance with <code><a class="el" href="a00182.html#ga0ab38705357bc1203abe829da8a12ad3" title="Set the filtering for all I/O object types.">hwloc_topology_set_io_types_filter()</a></code>.</p>
+<p>Note that I/O discovery requires significant help from the operating system. The pciaccess library (the development package is usually <code>libpciaccess-devel</code> or <code>libpciaccess-dev</code>) is needed to fully detect PCI devices and bridges/switches. On Linux, PCI discovery may still be performed even if <code>libpciaccess</code> cannot be used. But it misses PCI device names. Moreover, some operating systems require privileges for probing PCI devices, see <a class="el" href="a00391.html#faq_privileged">Does hwloc require privileged access?</a> for details.</p>
+<p>The actual locality of I/O devices is only currently detected on Linux. Other operating system will just report I/O devices as being attached to the topology root object.</p>
+<h1><a class="anchor" id="iodevices_objects"></a>
+I/O objects</h1>
+<p>When I/O discovery is enabled and supported, some additional objects are added to the topology. The corresponding I/O object types are: </p><ul>
+<li>
+<code><a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075" title="Operating system device (filtered out by default).">HWLOC_OBJ_OS_DEVICE</a></code> describes an operating-system-specific handle such as the <em>sda</em> drive or the <em>eth0</em> network interface. See <a class="el" href="a00380.html#iodevices_osdev">OS devices</a>. </li>
+<li>
+<code><a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9" title="PCI device (filtered out by default).">HWLOC_OBJ_PCI_DEVICE</a></code> and <code><a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0" title="Bridge (filtered out by default). Any bridge (or PCI switch) that connects the host or an I/O bus,...">HWLOC_OBJ_BRIDGE</a></code> build up a PCI hierarchy made of bridges (that may be actually be switches) and devices. See <a class="el" href="a00380.html#iodevices_pci">PCI devices and bridges</a>. </li>
+</ul>
+<p>Any of these types may be filtered individually with <code><a class="el" href="a00182.html#gad894e70f15f8d4aada7be8d1aba38b7e" title="Set the filtering for the given object type.">hwloc_topology_set_type_filter()</a></code>.</p>
+<p>hwloc tries to attach these new objects to normal objects (usually NUMA nodes) to match their actual physical location. For instance, if a I/O hub (or root complex) is physically connected to a package, the corresponding hwloc bridge object (and its PCI bridges and devices children) is inserted as a child of the corresponding hwloc Package object. <b>These children are not in the normal children list but rather in the I/O-specific children list.</b></p>
+<p>I/O objects also have neither CPU sets nor node sets (NULL pointers) because they are not directly usable by the user applications for binding. Moreover I/O hierarchies may be highly complex (asymmetric trees of bridges). So I/O objects are placed in specific levels with custom depths. Their lists may still be traversed with regular helpers such as <a class="el" href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735" title="Returns the next object of type type.">hwloc_get_next_obj_by_type()</a>. However, hwloc offers some dedicated helpers such as <a class="el" href="a00193.html#ga66470dabce9db19a57c5940a909d0baa" title="Get the next PCI device in the system.">hwloc_get_next_pcidev()</a> and <a class="el" href="a00193.html#ga8b4584c8949e2c5f1c97ba7fe92b8145" title="Get the next OS device in the system.">hwloc_get_next_osdev()</a> for convenience (see <a class="el" href="a00193.html">Finding I/O objects</a>).</p>
+<h1><a class="anchor" id="iodevices_osdev"></a>
+OS devices</h1>
+<p>Although each PCI device is uniquely identified by its bus ID (e.g. 0000:01:02.3), a user-space application can hardly find out which PCI device it is actually using. Applications rather use software handles (such as the <em>eth0</em> network interface, the <em>sda</em> hard drive, or the <em>mlx4_0</em> OpenFabrics HCA). Therefore hwloc tries to add software devices (<code><a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075" title="Operating system device (filtered out by default).">HWLOC_OBJ_OS_DEVICE</a></code>, also known as OS devices).</p>
+<p>OS devices may be attached below PCI devices, but they may also be attached directly to normal objects. Indeed some OS devices are not related to PCI. For instance, NVDIMM block devices (such as <em>pmem0s</em> on Linux) are directly attached near their NUMA node (I/O child of the parent whose memory child is the NUMA node). Also, if hwloc could not discover PCI for some reason, PCI-related OS devices may also be attached directly to normal objects.</p>
+<p>Finally, OS <em>subdevices</em> may be exposed as OS devices children of another OS device. This is the case of LevelZero subdevices for instance.</p>
+<p>hwloc first tries to discover OS devices from the operating system, e.g. <em>eth0</em>, <em>sda</em> or <em>mlx4_0</em>. However, this ability is currently only available on Linux for some classes of devices.</p>
+<p>hwloc then tries to discover software devices through additional I/O components using external libraries. For instance proprietary graphics drivers do not expose any named OS device, but hwloc may still create one OS object per software handle when supported. For instance the <code>opencl</code> and <code>cuda</code> components may add some <em>opencl0d0</em> and <em>cuda0</em> OS device objects.</p>
+<p>Here is a list of OS device objects commonly created by hwloc components when I/O discovery is enabled and supported.</p>
+<ul>
+<li>
+Hard disks or non-volatile memory devices (<a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a689b0488c3c0d08d116751c6b9cb8871" title="Operating system block device, or non-volatile memory device. For instance &quot;sda&quot; or &quot;dax2....">HWLOC_OBJ_OSDEV_BLOCK</a>) <ul>
+<li>
+<em>sda</em> or <em>dax2.0</em> (Linux component) </li>
+</ul>
+</li>
+<li>
+Network interfaces (<a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0ab715d81155f771573c8682dffc65021b" title="Operating system network device. For instance the &quot;eth0&quot; interface on Linux.">HWLOC_OBJ_OSDEV_NETWORK</a>) <ul>
+<li>
+<em>eth0</em>, <em>wlan0</em>, <em>ib0</em> (Linux component) </li>
+<li>
+<em>hsn0</em> with "Slingshot" subtype for HPE Cray HSNs (Linux component). </li>
+</ul>
+</li>
+<li>
+OpenFabrics (InfiniBand, Omni-Path, usNIC, etc) HCAs (<a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a52157d03694fdae82dddd57ca8c973b6" title="Operating system openfabrics device. For instance the &quot;mlx4_0&quot; InfiniBand HCA, &quot;hfi1_0&quot; Omni-Path int...">HWLOC_OBJ_OSDEV_OPENFABRICS</a>) <ul>
+<li>
+<em>mlx5_0</em>, <em>hfi1_0</em>, <em>qib0</em>, <em>usnic_0</em> (Linux component) </li>
+<li>
+<em>bxi0</em> with "BXI" subtype for Atos/Bull BXI HCAs (Linux component) even if those are not really OpenFabrics. </li>
+</ul>
+</li>
+<li>
+GPUs (<a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90" title="Operating system GPU device. For instance &quot;:0.0&quot; for a GL display, &quot;card0&quot; for a Linux DRM device.">HWLOC_OBJ_OSDEV_GPU</a>) <ul>
+<li>
+<em>rsmi0</em> for the first RSMI device ("RSMI" subtype, from the RSMI component, using the AMD ROCm SMI library) </li>
+<li>
+<em>nvml0</em> for the first NVML device ("NVML" subtype, from the NVML component, using the NVIDIA Management Library) </li>
+<li>
+<em>:0.0</em> for the first display ("Display" subtype, from the GL component, using the NV-CONTROL X extension library, NVCtrl) </li>
+<li>
+<em>card0</em> and <em>renderD128</em> for DRM device files (from the Linux component, filtered-out by default because considered non-important) </li>
+</ul>
+</li>
+<li>
+Co-Processors (<a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83" title="Operating system co-processor device. For instance &quot;opencl0d0&quot; for a OpenCL device,...">HWLOC_OBJ_OSDEV_COPROC</a>) <ul>
+<li>
+<em>opencl0d0</em> for the first device of the first OpenCL platform, <em>opencl1d3</em> for the fourth device of the second OpenCL platform ("OpenCL" subtype, from the OpenCL component) </li>
+<li>
+<em>ze0</em> for the first Level Zero device ("LevelZero" subtype, from the levelzero component, using the oneAPI Level Zero library), and <em>ze0.1</em> for its second subdevice (if any). </li>
+<li>
+<em>cuda0</em> for the first NVIDIA CUDA device ("CUDA" subtype, from the CUDA component, using the NVIDIA CUDA Library) </li>
+<li>
+<em>ve0</em> for the first NEC Vector Engine device ("VectorEngine" subtype, from the Linux component) </li>
+</ul>
+</li>
+<li>
+DMA engine channel (<a class="el" href="a00173.html#gga64f5d539df299c97ae80ce53fc4b56c0a827ad1643360711a8b6c6af671366791" title="Operating system dma engine device. For instance the &quot;dma0chan0&quot; DMA channel on Linux.">HWLOC_OBJ_OSDEV_DMA</a>) <ul>
+<li>
+<em>dma0chan0</em> (Linux component) when all OS devices are enabled (<a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e" title="Keep all objects of this type.">HWLOC_TYPE_FILTER_KEEP_ALL</a>) </li>
+</ul>
+</li>
+</ul>
+<p>Note that some PCI devices may contain multiple software devices (see the example below).</p>
+<p>See also <a class="el" href="a00387.html">Interoperability With Other Software</a> for managing these devices without considering them as hwloc objects.</p>
+<h1><a class="anchor" id="iodevices_pci"></a>
+PCI devices and bridges</h1>
+<p>A PCI hierarchy is usually organized as follows: A hostbridge object ( <code><a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0" title="Bridge (filtered out by default). Any bridge (or PCI switch) that connects the host or an I/O bus,...">HWLOC_OBJ_BRIDGE</a></code> object with upstream type <em>Host</em> and downstream type <em>PCI</em>) is attached below a normal object (usually the entire machine or a NUMA node). There may be multiple hostbridges in the machine, attached to different places, but all PCI devices are below one of them (unless the Bridge object type is filtered-out).</p>
+<p>Each hostbridge contains one or several children, either other bridges (usually PCI to PCI switches) or PCI devices (<code><a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9" title="PCI device (filtered out by default).">HWLOC_OBJ_PCI_DEVICE</a></code>). The number of bridges between the hostbridge and a PCI device depends on the machine.</p>
+<h1><a class="anchor" id="iodevices_consult"></a>
+Consulting I/O devices and binding</h1>
+<p>I/O devices may be consulted by traversing the topology manually (with usual routines such as <a class="el" href="a00176.html#ga6f414dd80a2b943967a0ac92da3181a2" title="Returns the topology object at logical index idx with type type.">hwloc_get_obj_by_type()</a>) or by using dedicated helpers (such as <a class="el" href="a00193.html#gacdbaf0db98872e224b7883a84bfb0455" title="Find the PCI device object matching the PCI bus id given domain, bus device and function PCI bus id.">hwloc_get_pcidev_by_busid()</a>, see <a class="el" href="a00193.html">Finding I/O objects</a>).</p>
+<p>I/O objects do not actually contain any locality information because their CPU sets and node sets are NULL. Their locality must be retrieved by walking up the object tree (through the <code>parent</code> link) until a non-I/O object is found (see <a class="el" href="a00193.html#gaf139bb61375178e90cc3f1835b452ab6" title="Get the first non-I/O ancestor object.">hwloc_get_non_io_ancestor_obj()</a>). This normal object should have non-NULL CPU sets and node sets which describe the processing units and memory that are immediately close to the I/O device. For instance the path from a OS device to its locality may go across a PCI device parent, one or several bridges, up to a Package node with the same locality.</p>
+<p>Command-line tools are also aware of I/O devices. lstopo displays the interesting ones by default (passing <code>--no-io</code> disables it).</p>
+<p>hwloc-calc and hwloc-bind may manipulate I/O devices specified by PCI bus ID or by OS device name. </p><ul>
+<li>
+<code>pci=0000:02:03.0</code> is replaced by the set of CPUs that are close to the PCI device whose bus ID is given.  </li>
+<li>
+<code>os=eth0</code> is replaced by CPUs that are close to the I/O device whose software handle is called <code>eth0</code>.  </li>
+</ul>
+<p>This enables easy binding of I/O-intensive applications near the device they use.</p>
+<h1><a class="anchor" id="iodevices_examples"></a>
+Examples</h1>
+<p>The following picture shows a dual-package dual-core host whose PCI bus is connected to the first package and NUMA node.</p>
+<div class="image">
+<img src="devel09-pci.png" alt=""/>
+</div>
+ <p>Six interesting PCI devices were discovered (dark green boxes). However, hwloc found some corresponding software devices (<em>eth0</em>, <em>eth1</em>, <em>sda</em>, <em>mlx4_0</em>, <em>ib0</em>, and <em>ib1</em> light grey boxes) for only four of these physical devices. The other ones (<em>PCI 04:03.0</em> and <em>PCI 00:1f.2</em>) are an unused IDE controller (no disk attached) and a graphic card (no corresponding software device reported to the user by the operating system).</p>
+<p>On the contrary, it should be noted that three different software devices were found for the last PCI device (<em>PCI 51:00.0</em>). Indeed this OpenFabrics HCA PCI device object contains one OpenFabrics software device (<em>mlx4_0</em>) and two virtual network interfaces (<em>ib0</em> and <em>ib1</em>).</p>
+<p>Here is the corresponding textual output:</p>
+<pre class="fragment">Machine (24GB total)
+  Package L#0
+    NUMANode L#0 (P#0 12GB)
+    L3 L#0 (8192KB)
+      L2 L#0 (256KB) + L1 L#0 (32KB) + Core L#0 + PU L#0 (P#0)
+      L2 L#1 (256KB) + L1 L#1 (32KB) + Core L#1 + PU L#1 (P#2)
+    HostBridge
+      PCIBridge
+        PCI 01:00.0 (Ethernet)
+          Net "eth0"
+        PCI 01:00.1 (Ethernet)
+          Net "eth1"
+      PCIBridge
+        PCI 03:00.0 (RAID)
+          Block "sda"
+      PCIBridge
+        PCI 04:03.0 (VGA)
+      PCI 00:1f.2 (IDE)
+      PCI 51:00.0 (InfiniBand)
+        Net "ib0"
+        Net "ib1"
+        Net "mlx4_0"
+  Package L#1
+    NUMANode L#1 (P#1 12GB)
+    L3 L#1 (8192KB)
+      L2 L#2 (256KB) + L1 L#2 (32KB) + Core L#2 + PU L#2 (P#1)
+      L2 L#3 (256KB) + L1 L#3 (32KB) + Core L#3 + PU L#3 (P#3)
+</pre> </div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00381.html 2.11.0-1/doc/doxygen-doc/html/a00381.html
--- 2.10.0-1/doc/doxygen-doc/html/a00381.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00381.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,68 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Miscellaneous objects</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Miscellaneous objects</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>hwloc topologies may be annotated with Misc objects (of type <code><a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d" title="Miscellaneous objects (filtered out by default). Objects without particular meaning,...">HWLOC_OBJ_MISC</a></code>) either automatically or by the user. This is a flexible way to annotate topologies with large sets of information since Misc objects may be inserted anywhere in the topology (to annotate specific objects or parts of the topology), even below other Misc objects, and each of them may contain multiple attributes (see also <a class="el" href="a00391.html#faq_annotate">How do I annotate the topology with private notes?</a>).</p>
+<p>These Misc objects may have a <code>subtype</code> field to replace <code>Misc</code> with something else in the lstopo output.</p>
+<h1><a class="anchor" id="miscobjs_auto"></a>
+Misc objects added by hwloc</h1>
+<p>hwloc only uses Misc objects when other object types are not sufficient, and when the Misc object type is not filtered-out anymore. This currently includes: </p><ul>
+<li>
+Memory modules (DIMMs), on Linux when privileged and when <code>dmi-sysfs</code> is supported by the kernel. These objects have a <code>subtype</code> field of value <code>MemoryModule</code>. They are currently always attached to the root object. Their attributes describe the DIMM vendor, model, etc. <code>lstopo -v</code> displays them as: <div class="fragment"><div class="line">Misc(MemoryModule) (P#1 DeviceLocation=<span class="stringliteral">&quot;Bottom-Slot 2(right)&quot;</span> BankLocation=<span class="stringliteral">&quot;BANK 2&quot;</span> Vendor=Elpida SerialNumber=21733667 AssetTag=9876543210 PartNumber=<span class="stringliteral">&quot;EBJ81UG8EFU0-GN-F &quot;</span>)</div>
+</div><!-- fragment -->  </li>
+<li>
+Displaying process binding in <code>lstopo --top</code>. These objects have a <code>subtype</code> field of value <code>Process</code> and a name attribute made of their PID and program name. They are attached below the object they are bound to. The textual <code>lstopo</code> displays them as: <div class="fragment"><div class="line">PU L#0 (P#0)</div>
+<div class="line">  Misc(Process) 4445 myprogram</div>
+</div><!-- fragment -->  </li>
+</ul>
+<h1><a class="anchor" id="miscobjs_annotate"></a>
+Annotating topologies with Misc objects</h1>
+<p>The user may annotate hwloc topologies with its own Misc objects. This can be achieved with <code><a class="el" href="a00183.html#gad980782ade737900c5cf208946768c30" title="Add a MISC object as a leaf of the topology.">hwloc_topology_insert_misc_object()</a></code> as well as hwloc-annotate command-line tool. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00382.html 2.11.0-1/doc/doxygen-doc/html/a00382.html
--- 2.10.0-1/doc/doxygen-doc/html/a00382.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00382.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,253 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Object attributes</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Object attributes</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><h1><a class="anchor" id="attributes_normal"></a>
+Normal attributes</h1>
+<p>hwloc objects have many generic attributes in the <a class="el" href="a00229.html" title="Structure of a topology object.">hwloc_obj</a> structure, for instance their <code>logical_index</code> or <code>os_index</code> (see <a class="el" href="a00391.html#faq_indexes">Should I use logical or physical/OS indexes? and how?</a>), <code>depth</code> or <code>name</code>.</p>
+<p>The kind of object is first described by the <code>obj-&gt;type</code> generic attribute (an integer). OS devices also have a specific <code>obj-&gt;attr-&gt;osdev.type</code> integer for distinguishing between NICs, GPUs, etc.</p>
+<p>Objects may also have an optional <code>obj-&gt;subtype</code> pointing to a better description string (displayed by lstopo either in place or after the main <code>obj-&gt;type</code> attribute): </p><ul>
+<li>
+NUMA nodes: subtype <code>DRAM</code> (for usual main memory), <code>HBM</code> (high-bandwidth memory), <code>SPM</code> (specific-purpose memory, usually reserved for some custom applications), <code>NVM</code> (non-volatile memory when used as main memory), <code>MCDRAM</code> (on KNL), <code>GPUMemory</code> (on POWER architecture with NVIDIA GPU memory shared over NVLink), <code>CXL-DRAM</code> or <code>CXL-NVM</code> for CXL DRAM or non-volatile memory. Note that some of these subtypes are guessed by the library, they might be missing or slightly wrong in some corner cases. See <a class="el" href="a00384.html">Heterogeneous Memory</a> for details, and HWLOC_MEMTIERS and HWLOC_MEMTIERS_GUESS in <a class="el" href="a00378.html">Environment Variables</a> for tuning these.  </li>
+<li>
+Groups: subtype <code>Cluster</code>, <code>Module</code>, <code>Tile</code>, <code>Compute Unit</code>, <code>Book</code> or <code>Drawer</code> for different architecture-specific groups of CPUs (see also <a class="el" href="a00391.html#faq_groups">What are these Group objects in my topology?</a>).  </li>
+<li>
+OS devices (see also <a class="el" href="a00380.html#iodevices_osdev">OS devices</a>): <ul>
+<li>
+Co-processor: subtype <code>OpenCL</code>, <code>LevelZero</code>, <code>CUDA</code>, or <code>VectorEngine</code>. </li>
+<li>
+GPU: subtype <code>RSMI</code> (AMD GPU) or <code>NVML</code> (NVIDIA GPU). </li>
+<li>
+OpenFabrics: subtype <code>BXI</code> (Bull/Atos BXI HCA). </li>
+<li>
+Network: subtype <code>Slingshot</code> (HPE Cray Slingshot Cassini HSN). </li>
+<li>
+Block: subtype <code>Disk</code>, <code>NVM</code> (non-volatile memory), <code>SPM</code> (specific-purpose memory), <code>CXLMem</code> (CXL volatile ou persistent memory), <code>Tape</code>, or <code>Removable Media Device</code>. </li>
+</ul>
+</li>
+<li>
+L3 Caches: subtype <code>MemorySideCache</code> when hwloc is configured to expose the KNL MCDRAM in Cache mode as a L3.  </li>
+<li>
+PCI devices: subtype <code>NVSwitch</code> for NVLink switches (see also NVLinkBandwidth in <a class="el" href="a00383.html#topoattrs_distances">Distances</a>).  </li>
+<li>
+Misc devices: subtype <code>MemoryModule</code> (see also <a class="el" href="a00381.html#miscobjs_auto">Misc objects added by hwloc</a>)  </li>
+</ul>
+<p>Each object also contains an <code>attr</code> field that, if non NULL, points to a union <a class="el" href="a00233.html" title="Object type-specific Attributes.">hwloc_obj_attr_u</a> of type-specific attribute structures. For instance, a L2Cache object <code>obj</code> contains cache-specific information in <code>obj-&gt;attr-&gt;cache</code>, such as its size and associativity, cache type. See <a class="el" href="a00233.html" title="Object type-specific Attributes.">hwloc_obj_attr_u</a> for details.</p>
+<h1><a class="anchor" id="attributes_info"></a>
+Custom string infos</h1>
+<p>Aside of these generic attribute fields, hwloc annotates many objects with info attributes made of name and value strings. Each object contains a list of such pairs that may be consulted manually (looking at the object <code>infos</code> array field) or using the <a class="el" href="a00178.html#ga415c4e44beada7ea34cd4bad9944b170" title="Search the given name in object infos and return the corresponding value.">hwloc_obj_get_info_by_name()</a>. The user may additionally add new name-value pairs to any object using <a class="el" href="a00178.html#gace7654bb8a9002caae1a4b8a59e7452e" title="Add the given name and value pair to the given object info attributes.">hwloc_obj_add_info()</a> or the <a class="el" href="a00377.html#cli_hwloc_annotate">hwloc-annotate</a> program.</p>
+<p>Here is a non-exhaustive list of attributes that may be automatically added by hwloc. Note that these attributes heavily depend on the ability of the operating system to report them. Many of them will therefore be missing on some OS.</p>
+<h2><a class="anchor" id="attributes_info_platform"></a>
+Hardware Platform Information</h2>
+<p>These info attributes are attached to the root object (Machine).</p>
+<dl>
+<dt>PlatformName, PlatformModel, PlatformVendor, PlatformBoardID, PlatformRevision, </dt>
+<dd></dd>
+<dt>SystemVersionRegister, ProcessorVersionRegister (Machine) </dt>
+<dd>Some POWER/PowerPC-specific attributes describing the platform and processor. Currently only available on Linux. Usually added to Package objects, but can be in Machine instead if hwloc failed to discover any package.  </dd>
+<dt>DMIBoardVendor, DMIBoardName, etc. </dt>
+<dd>DMI hardware information such as the motherboard and chassis models and vendors, the BIOS revision, etc., as reported by Linux under <code>/sys/class/dmi/id/</code>.  </dd>
+<dt>SoC0ID, SoC0Family, SoC1Revision, etc. </dt>
+<dd>The ID, family and revision of the first system-on-chip (<code>SoC0</code>), second (<code>SoC1</code>), etc.  </dd>
+<dt>MemoryMode, ClusterMode </dt>
+<dd><p class="startdd">Intel Xeon Phi processor configuration modes. Available if hwloc-dump-hwdata was used (see <a class="el" href="a00391.html#faq_knl_dump">Why do I need hwloc-dump-hwdata for memory on Intel Xeon Phi processor?</a>) or if hwloc managed to guess them from the NUMA configuration.</p>
+<p class="enddd">The memory mode may be <em>Cache</em>, <em>Flat</em>, <em>Hybrid50</em> (half the MCDRAM is used as a cache) or <em>Hybrid25</em> (25% of MCDRAM as cache). The cluster mode may be <em>Quadrant</em>, <em>Hemisphere</em>, <em>All2All</em>, <em>SNC2</em> or <em>SNC4</em>. See doc/examples/get-knl-modes.c in the source directory for an example of retrieving these attributes.  </p>
+</dd>
+</dl>
+<h2><a class="anchor" id="attributes_info_os"></a>
+Operating System Information</h2>
+<p>These info attributes are attached to the root object (Machine).</p>
+<dl>
+<dt>OSName, OSRelease, OSVersion, HostName, Architecture </dt>
+<dd>The operating system name, release, version, the hostname and the architecture name, as reported by the Unix <code>uname</code> command.  </dd>
+<dt>LinuxCgroup </dt>
+<dd>The name the Linux control group where the calling process is placed.  </dd>
+<dt>WindowsBuildEnvironment </dt>
+<dd>Either MinGW or Cygwin when one of these environments was used during build.  </dd>
+</dl>
+<h2><a class="anchor" id="attributes_info_hwloc"></a>
+hwloc Information</h2>
+<p>Unless specified, these info attributes are attached to the root object (Machine).</p>
+<dl>
+<dt>Backend (topology root, or specific object added by that backend) </dt>
+<dd>The name of the hwloc backend/component that filled the topology. If several components were combined, multiple Backend pairs may exist, with different values, for instance <code>x86</code> and <code>Linux</code> in the root object and <code>CUDA</code> in CUDA OS device objects.  </dd>
+<dt>MemoryTiersNr </dt>
+<dd>The number of different memory tiers in the topology, if any. See <a class="el" href="a00384.html">Heterogeneous Memory</a>.  </dd>
+<dt>SyntheticDescription </dt>
+<dd>The description string that was given to hwloc to build this synthetic topology.  </dd>
+<dt>hwlocVersion </dt>
+<dd>The version number of the hwloc library that was used to generate the topology. If the topology was loaded from XML, this is not the hwloc version that loaded it, but rather the first hwloc instance that exported the topology to XML earlier.  </dd>
+<dt>ProcessName </dt>
+<dd>The name of the process that contains the hwloc library that was used to generate the topology. If the topology was from XML, this is not the hwloc process that loaded it, but rather the first process that exported the topology to XML earlier.  </dd>
+</dl>
+<h2><a class="anchor" id="attributes_info_cpu"></a>
+CPU Information</h2>
+<p>These info attributes are attached to Package objects, or to the root object (Machine) if package locality information is missing.</p>
+<dl>
+<dt>CPUModel </dt>
+<dd>The processor model name. </dd>
+<dt>CPUVendor, CPUModelNumber, CPUFamilyNumber, CPUStepping </dt>
+<dd>The processor vendor name, model number, family number, and stepping number. Currently available for x86 and Xeon Phi processors on most systems, and for ia64 processors on Linux (except CPUStepping).  </dd>
+<dt>CPUFamily </dt>
+<dd>The family of the CPU, currently only available on Linux on LoongArch platforms.  </dd>
+<dt>CPURevision </dt>
+<dd>A POWER/PowerPC-specific general processor revision number, currently only available on Linux.  </dd>
+<dt>CPUType </dt>
+<dd>A Solaris-specific general processor type name, such as "i86pc".  </dd>
+</dl>
+<h2><a class="anchor" id="attributes_info_osdev"></a>
+OS Device Information</h2>
+<p>These info attributes are attached to OS device objects specified in parentheses.</p>
+<dl>
+<dt>Vendor, Model, Revision, Size, SectorSize (Block OS devices) </dt>
+<dd>The vendor and model names, revision, size (in KiB = 1024 bytes) and SectorSize (in bytes).  </dd>
+<dt>LinuxDeviceID (Block OS devices) </dt>
+<dd>The major/minor device number such as 8:0 of Linux device.  </dd>
+<dt>SerialNumber (Block and CXL Memory OS devices) </dt>
+<dd>The serial number of the device.  </dd>
+<dt>CXLRAMSize, CXLPMEMSize (CXL Memory Block OS devices) </dt>
+<dd>The size of the volatile (RAM) or persistent (PMEM) memory in a CXL Type-3 device. Sizes are in KiB (1024 bytes).  </dd>
+<dt>GPUVendor, GPUModel (GPU or Co-Processor OS devices) </dt>
+<dd>The vendor and model names of the GPU device.  </dd>
+<dt>OpenCLDeviceType, OpenCLPlatformIndex, </dt>
+<dd></dd>
+<dt>OpenCLPlatformName, OpenCLPlatformDeviceIndex (OpenCL OS devices) </dt>
+<dd>The type of OpenCL device, the OpenCL platform index and name, and the index of the device within the platform.  </dd>
+<dt>OpenCLComputeUnits, OpenCLGlobalMemorySize (OpenCL OS devices) </dt>
+<dd>The number of compute units and global memory size of an OpenCL device. Sizes are in KiB (1024 bytes).  </dd>
+<dt>LevelZeroVendor, LevelZeroModel, LevelZeroBrand, </dt>
+<dd></dd>
+<dt>LevelZeroSerialNumber, LevelZeroBoardNumber (LevelZero OS devices) </dt>
+<dd>The name of the vendor, device model, brand of a Level Zero device, and its serial and board numbers.  </dd>
+<dt>LevelZeroDriverIndex, LevelZeroDriverDeviceIndex (LevelZero OS devices) </dt>
+<dd>The index of the Level Zero driver within the list of drivers, and the index of the device within the list of devices managed by this driver.  </dd>
+<dt>LevelZeroUUID (LevelZero OS devices or subdevices) </dt>
+<dd>The UUID of the device or subdevice.  </dd>
+<dt>LevelZeroSubdevices (LevelZero OS devices) </dt>
+<dd>The number of subdevices below this OS device.  </dd>
+<dt>LevelZeroSubdeviceID (LevelZero OS subdevices) </dt>
+<dd>The index of this subdevice within its parent.  </dd>
+<dt>LevelZeroDeviceType (LevelZero OS devices or subdevices) </dt>
+<dd>A string describing the type of device, for instance "GPU", "CPU", "FPGA", etc.  </dd>
+<dt>LevelZeroNumSlices, LevelZeroNumSubslicesPerSlice, </dt>
+<dd></dd>
+<dt>LevelZeroNumEUsPerSubslice, LevelZeroNumThreadsPerEU (LevelZero OS devices or subdevices) </dt>
+<dd>The number of slices in the device, of subslices per slice, of execution units (EU) per subslice, and of threads per EU.  </dd>
+<dt>LevelZeroHBMSize, LevelZeroDDRSize, LevelZeroMemorySize (LevelZero OS devices or subdevices) </dt>
+<dd>The amount of HBM or DDR memory of a LevelZero device or subdevice. Sizes are in KiB (1024 bytes). If the type of memory could not be determined, the generic name LevelZeroMemorySize is used. For devices that contain subdevices, the amount reported in the root device includes the memories of all its subdevices.  </dd>
+<dt>LevelZeroCQGroups, LevelZeroCQGroup2 (LevelZero OS devices or subdevices) </dt>
+<dd>The number of completion queue groups, and the description of the third group (as <code>N*0xX</code> where <code>N</code> is the number of queues in the group, and <code>0xX</code> is the hexadecimal bitmask of <code>ze_command_queue_group_property_flag_t</code> listing properties of those queues).  </dd>
+<dt>AMDUUID, AMDSerial (RSMI GPU OS devices) </dt>
+<dd>The UUID and serial number of AMD GPUs.  </dd>
+<dt>RSMIVRAMSize, RSMIVisibleVRAMSize, RSMIGTTSize (RSMI GPU OS devices) </dt>
+<dd>The amount of GPU memory (VRAM), of GPU memory that is visible from the host (Visible VRAM), and of system memory that is usable by the GPU (Graphics Translation Table). Sizes are in KiB (1024 bytes).  </dd>
+<dt>XGMIHiveID (RSMI GPU OS devices) </dt>
+<dd>The ID of the group of GPUs (Hive) interconnected by XGMI links  </dd>
+<dt>XGMIPeers (RSMI GPU OS devices) </dt>
+<dd>The list of RSMI OS devices that are directly connected to the current device through XGMI links. They are given as a space-separated list of object names, for instance <em>rsmi2 rsmi3</em>.  </dd>
+<dt>NVIDIAUUID, NVIDIASerial (NVML GPU OS devices) </dt>
+<dd>The UUID and serial number of NVIDIA GPUs.  </dd>
+<dt>CUDAMultiProcessors, CUDACoresPerMP, </dt>
+<dd></dd>
+<dt>CUDAGlobalMemorySize, CUDAL2CacheSize, CUDASharedMemorySizePerMP (CUDA OS devices) </dt>
+<dd>The number of shared multiprocessors, the number of cores per multiprocessor, the global memory size, the (global) L2 cache size, and size of the shared memory in each multiprocessor of a CUDA device. Sizes are in KiB (1024 bytes).  </dd>
+<dt>VectorEngineModel, VectorEngineSerialNumber (VectorEngine OS devices) </dt>
+<dd>The model and serial number of a VectorEngine device.  </dd>
+<dt>VectorEngineCores, VectorEngineMemorySize, VectorEngineLLCSize, </dt>
+<dd></dd>
+<dt>VectorEngineL2Size, VectorEngineL1dSize, VectorEngineL1iSize (VectorEngine OS devices) </dt>
+<dd>The number of cores, memory size, and the sizes of the (global) last level cache and of L2, L1d and L1i caches of a VectorEngine device. Sizes are in KiB (1024 bytes).  </dd>
+<dt>VectorEngineNUMAPartitioned (VectorEngine OS devices) </dt>
+<dd>If this attribute exists, the VectorEngine device is configured in partitioned mode with multiple NUMA nodes.  </dd>
+<dt>Address, Port (Network interface OS devices) </dt>
+<dd>The MAC address and the port number of a software network interface, such as <code>eth4</code> on Linux.  </dd>
+<dt>NodeGUID, SysImageGUID, Port1State, Port2LID, Port2LMC, Port3GID1 (OpenFabrics OS devices) </dt>
+<dd>The node GUID and GUID mask, the state of a port #1 (value is 4 when active), the LID and LID mask count of port #2, and GID #1 of port #3.  </dd>
+<dt>BXIUUID (OpenFabrics BXI OS devices) </dt>
+<dd>The UUID of an Atos/Bull BXI HCA.  </dd>
+</dl>
+<h2><a class="anchor" id="attributes_info_otherobjs"></a>
+Other Object-specific Information</h2>
+<p>These info attributes are attached to objects specified in parentheses.</p>
+<dl>
+<dt>MemoryTier (NUMA Nodes) </dt>
+<dd>The rank of the memory tier of this node. Ranks start from 0 for highest bandwidth nodes. The attribute is only set if multiple tiers are found. See <a class="el" href="a00384.html">Heterogeneous Memory</a>.  </dd>
+<dt>CXLDevice (NUMA Nodes or DAX Memory OS devices) </dt>
+<dd>The PCI/CXL bus ID of a device whose CXL Type-3 memory is exposed here. If multiple devices are interleaved, their bus IDs are separated by commas, and the number of devices in reported in CXLDeviceInterleaveWays.  </dd>
+<dt>CXLDeviceInterleaveWays (NUMA Nodes or DAX Memory OS devices) </dt>
+<dd>If multiple CXL devices are interleaved, this attribute shows the number of devices (and the number of bus IDs in the CXLDevice attributes).  </dd>
+<dt>DAXDevice (NUMA Nodes) </dt>
+<dd>The name of the Linux DAX device that was used to expose a non-volatile memory region as a volatile NUMA node.  </dd>
+<dt>DAXType (NUMA Nodes or DAX OS devices) </dt>
+<dd>The type of memory exposed in a Linux DAX device or in the corresponding NUMA node, either "NVM" (non-volatile memory) or "SPM" (specific-purpose memory).  </dd>
+<dt>DAXParent (NUMA Nodes or DAX OS devices) </dt>
+<dd>A string describing the Linux sysfs hierarchy that exposes the DAX device, for instance containing "hmem1" for specific-purpose memory or "ndbus0" for NVDIMMs.  </dd>
+<dt></dt>
+<dd></dd>
+<dt>PCIBusID (GPUMemory NUMA Nodes) </dt>
+<dd>The PCI bus ID of the GPU whose memory is exposed in this NUMA node.  </dd>
+<dt>Inclusive (Caches) </dt>
+<dd>The inclusiveness of a cache (1 if inclusive, 0 otherwise). Currently only available on x86 processors.  </dd>
+<dt>SolarisProcessorGroup (Group) </dt>
+<dd>The Solaris kstat processor group name that was used to build this Group object.  </dd>
+<dt>PCIVendor, PCIDevice (PCI devices and bridges) </dt>
+<dd>The vendor and device names of the PCI device.  </dd>
+<dt>PCISlot (PCI devices or Bridges) </dt>
+<dd>The name/number of the physical slot where the device is plugged. If the physical device contains PCI bridges above the actual PCI device, the attribute may be attached to the highest bridge (i.e. the first object that actually appears below the physical slot).  </dd>
+<dt>Vendor, AssetTag, PartNumber, DeviceLocation, BankLocation, FormFactor, Type, Size, Rank (MemoryModule Misc objects) </dt>
+<dd>Information about memory modules (DIMMs) extracted from SMBIOS. Size is in KiB.  </dd>
+</dl>
+<h2><a class="anchor" id="attributes_info_user"></a>
+User-Given Information</h2>
+<p>Here is a non-exhaustive list of user-provided info attributes that have a special meaning: </p><dl>
+<dt>lstopoStyle </dt>
+<dd>Enforces the style of an object (background and text colors) in the graphical output of lstopo. See CUSTOM COLORS in the lstopo(1) manpage for details.  </dd>
+</dl>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00383.html 2.11.0-1/doc/doxygen-doc/html/a00383.html
--- 2.10.0-1/doc/doxygen-doc/html/a00383.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00383.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,110 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Topology Attributes: Distances, Memory Attributes and CPU Kinds</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Topology Attributes: Distances, Memory Attributes and CPU Kinds</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>Besides the hierarchy of objects and individual object attributes (see <a class="el" href="a00382.html">Object attributes</a>), hwloc may also expose finer information about the hardware organization.</p>
+<h1><a class="anchor" id="topoattrs_distances"></a>
+Distances</h1>
+<p>A machine with 4 CPUs may have identical links between every pairs of CPUs, or those CPUs could also only be connected through a ring. In the ring case, accessing the memory of nearby CPUs is slower than local memory, but it is also faster than accessing the memory of CPU on the opposite side of the ring. These deep details cannot be exposed in the hwloc hierarchy, that is why hwloc also exposes distances.</p>
+<p>Distances are matrices of values between sets of objects, usually latencies or bandwidths. By default, hwloc tries to get a matrix of relative latencies between NUMA nodes when exposed by the hardware.</p>
+<p>In the aforementioned ring case, the matrix could report 10 for latency between a NUMA node and itself, 20 for nearby nodes, and 30 for nodes that are opposites on the ring. Those are theoretical values exposed by hardware vendors (in the System Locality Distance Information Table (SLIT) in the ACPI) rather than physical latencies. They are mostly meant for comparing node relative distances.</p>
+<p>Distances structures currently created by hwloc are: </p><dl>
+<dt>NUMALatency (Linux, Solaris, FreeBSD) </dt>
+<dd>This is the matrix of theoretical latencies described above.  </dd>
+<dt>XGMIBandwidth (RSMI) </dt>
+<dd><p class="startdd">This is the matrix of unidirectional XGMI bandwidths between AMD GPUs (in MB/s). It contains 0 when there is no direct XGMI link between objects. Values on the diagonal are artificially set to very high so that local access always appears faster than remote access.</p>
+<p class="interdd">GPUs are identified by RSMI OS devices such as "rsmi0". They may be converted into the corresponding OpenCL or PCI devices using <a class="el" href="a00189.html#gab5df3ad1e8565ea0c2cf06412f6f6233" title="Return an object of a different type with same locality.">hwloc_get_obj_with_same_locality()</a> or the hwloc-annotate tool.</p>
+<p class="enddd"><a class="el" href="a00197.html#gabcadd041f3072999d68f2d94e38670f7" title="Apply a transformation to a distances structure.">hwloc_distances_transform()</a> or hwloc-annotate may also be used to transform this matrix into something more convenient, for instance by replacing bandwidths with numbers of links between peers.  </p>
+</dd>
+<dt>XGMIHops (RSMI) </dt>
+<dd>This matrix lists the number of XGMI hops between AMD GPUs. It reports 1 when there is a direct link between two distinct GPUs. If there is no XGMI route between them, the value is 0. The number of hops between a GPU and itself (on the diagonal) is 0 as well.  </dd>
+<dt>XeLinkBandwidth (LevelZero) </dt>
+<dd><p class="startdd">This is the matrix of unidirectional XeLink bandwidths between Intel GPUs (in MB/s). It contains 0 when there is no direct XeLink between objects. When there are multiple links, their bandwidth is aggregated.</p>
+<p class="interdd">Values on the diagonal are artificially set to very high so that local access always appears faster than remote access. This includes bandwidths between a (sub)device and itself, between a subdevice and its parent device, or between two subdevices of the same parent.</p>
+<p class="interdd">The matrix interconnects all LevelZero devices and subdevices (if any), even if some of them may have no link at all.</p>
+<p class="enddd">The bandwidths of links between subdevices are accumulated in the bandwidth between their parents.  </p>
+</dd>
+<dt>NVLinkBandwidth (NVML) </dt>
+<dd><p class="startdd">This is the matrix of unidirectional NVLink bandwidths between NVIDIA GPUs (in MB/s). It contains 0 when there is no direct NVLink between objects. When there are multiple links, their bandwidth is aggregated. Values on the diagonal are artificially set to very high so that local access always appears faster than remote access.</p>
+<p class="interdd">On POWER platforms, NVLinks may also connects GPUs to CPUs. On NVIDIA platforms such as DGX-2, a NVSwitch may interconnect GPUs through NVLinks. In these cases, the distances structure is heterogeneous. GPUs always appear first in the matrix (as NVML OS devices such as "nvml0"), and non-GPU objects may appear at the end (Package for POWER processors, PCI device for NVSwitch).</p>
+<p class="interdd">NVML OS devices may be converted into the corresponding CUDA, OpenCL or PCI devices using <a class="el" href="a00189.html#gab5df3ad1e8565ea0c2cf06412f6f6233" title="Return an object of a different type with same locality.">hwloc_get_obj_with_same_locality()</a> or the hwloc-annotate tool.</p>
+<p class="interdd"><a class="el" href="a00197.html#gabcadd041f3072999d68f2d94e38670f7" title="Apply a transformation to a distances structure.">hwloc_distances_transform()</a> or hwloc-annotate may also be used to transform this matrix into something more convenient, for instance by removing switches or CPU ports, or by replacing bandwidths with numbers of links between peers.</p>
+<p class="enddd">When a NVSwitch interconnects GPUs, only links between one GPU and different NVSwitch ports are reported. They may be merged into a single switch port with <a class="el" href="a00197.html#gabcadd041f3072999d68f2d94e38670f7" title="Apply a transformation to a distances structure.">hwloc_distances_transform()</a> or hwloc-annotate. Or a transitive closure may also be applied to report the bandwidth between GPUs across the NVSwitch. </p>
+</dd>
+</dl>
+<p>Users may also specify their own matrices between any set of objects, even if these objects are of different types (e.g. bandwidths between GPUs and CPUs).</p>
+<p>The entire API is located in <a class="el" href="a00116_source.html">hwloc/distances.h</a>. See also <a class="el" href="a00197.html">Retrieve distances between objects</a>, as well as <a class="el" href="a00198.html">Helpers for consulting distance matrices</a> and <a class="el" href="a00199.html">Add distances between objects</a>.</p>
+<h1><a class="anchor" id="topoattrs_memattrs"></a>
+Memory Attributes</h1>
+<p>Machines with heterogeneous memory, for instance high-bandwidth memory (HBM), normal memory (DDR), and/or high-capacity slow memory (such as non-volatile memory DIMMs, NVDIMMs) require applications to allocate buffers in the appropriate target memory depending on performance and capacity needs. Those target nodes may be exposed in the hwloc hierarchy as different memory children but there is a need for performance information to select the appropriate one.</p>
+<p>hwloc memory attributes are designed to expose memory information such as latency, bandwidth, etc. Users may also specify their own attributes and values.</p>
+<p>The memory attributes API is located in <a class="el" href="a00119_source.html">hwloc/memattrs.h</a>, see <a class="el" href="a00201.html">Comparing memory node attributes for finding where to allocate on</a> and <a class="el" href="a00202.html">Managing memory attributes</a> for details. See also an example in doc/examples/memory-attributes.c in the source tree.</p>
+<p>Memory attributes are the low-level solution to selecting target memory. hwloc uses them internally to build Memory Tiers which provide an easy way to distinguish NUMA nodes of different kinds, as explained in <a class="el" href="a00384.html">Heterogeneous Memory</a>.</p>
+<h1><a class="anchor" id="topoattrs_cpukinds"></a>
+CPU Kinds</h1>
+<p>Hybrid CPUs may contain different kinds of cores. The CPU kinds API in <a class="el" href="a00122_source.html">hwloc/cpukinds.h</a> provides a way to list the sets of PUs in each kind and get some optional information about their hardware characteristics and efficiency.</p>
+<p>If the operating system provides efficiency information (e.g. Windows 10, MacOS X / Darwin and some Linux kernels), it is used to rank hwloc CPU kinds by efficiency. Otherwise, hwloc implements several heuristics based on frequencies and core types (see HWLOC_CPUKINDS_RANKING in <a class="el" href="a00378.html">Environment Variables</a>).</p>
+<p>The ranking shows energy-efficient CPUs first, and high-performance power-hungry cores last.</p>
+<p>These CPU kinds may be annotated with the following native attributes: </p><dl>
+<dt>FrequencyMaxMHz (Linux) </dt>
+<dd>The maximal operating frequency of the core, as reported by <code>cpufreq</code> drivers on Linux.  </dd>
+<dt>FrequencyBaseMHz (Linux) </dt>
+<dd>The base operating frequency of the core, as reported by some <code>cpufreq</code> drivers on Linux (e.g. <code>intel_pstate</code>).  </dd>
+<dt>CoreType (x86) </dt>
+<dd>A string describing the kind of core, currently <code>IntelAtom</code> or <code>IntelCore</code>, as reported by the x86 CPUID instruction and Linux PMU on some Intel processors.  </dd>
+<dt>LinuxCapacity (Linux) </dt>
+<dd>The Linux-specific CPU capacity found in sysfs, as reported by the Linux kernel on some recent platforms. Higher values usually mean that the Linux scheduler considers the core as high-performance rather than energy-efficient.  </dd>
+<dt>LinuxCPUType (Linux) </dt>
+<dd>The Linux-specific CPU type found in sysfs, such as <code>intel_atom_0</code>, as reported by future Linux kernels on some Intel processors.  </dd>
+<dt>DarwinCompatible (Darwin / Mac OS X) </dt>
+<dd>The compatibility attribute of the CPUs as found in the IO registry on Darwin / Mac OS X. For instance <code>apple,icestorm;ARM,v8</code> for energy-efficient cores and <code>apple,firestorm;ARM,v8</code> on performance cores on Apple M1 CPU.  </dd>
+</dl>
+<p>See <a class="el" href="a00203.html">Kinds of CPU cores</a> for details. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00384.html 2.11.0-1/doc/doxygen-doc/html/a00384.html
--- 2.10.0-1/doc/doxygen-doc/html/a00384.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00384.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,112 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Heterogeneous Memory</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Heterogeneous Memory</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>Heterogeneous memory hardware exposes different NUMA nodes for different memory technologies. On the image below, a dual-socket server has both HBM (high bandwidth memory) and usual DRAM connected to each socket, as well as some CXL memory connected to the entire machine.</p>
+<div class="image">
+<img src="heteromem.png" alt=""/>
+</div>
+ <p>The hardware usually exposes "normal" memory first because it is where "normal" data buffers should be allocated by default. However there is no guarantee about whether HBM, NVM, CXL will appear second. Hence there is a need to explicit memory technologies and performance to help users decide where to allocate.</p>
+<h1><a class="anchor" id="heteromem_memtiers"></a>
+Memory Tiers</h1>
+<p>hwloc builds <em>Memory Tiers</em> to identify different kinds of NUMA nodes. On the above machine, the first tier would contain both HBM NUMA nodes (L#1 and L#3), while the second tier would contain both DRAM nodes (L#0 and L#2), and the CXL memory (L#4) would be in the third tier. NUMA nodes are then annotated accordingly: </p><ul>
+<li>
+Each node object has its <code>subtype</code> field set to <code>HBM</code>, <code>DRAM</code> or <code>CXL-DRAM</code> (see other possible values in <a class="el" href="a00382.html#attributes_normal">Normal attributes</a>). </li>
+<li>
+Each node also has a string info attribute with name <code>MemoryTier</code> and value <code>0</code> for the first tier, <code>1</code> for the second, etc. </li>
+</ul>
+<p>Tiers are built using two kinds of information: </p><ul>
+<li>
+First hwloc looks into operating system information to find out whether a node is non-volatile, CXL, special-purpose, etc. </li>
+<li>
+Then it combines that knowledge with performance metrics exposed by the hardware to guess what's actually DRAM, HBM, etc. These metrics are also exposed in hwloc Memory Attributes, for instance bandwidth and latency, for read and write. See <a class="el" href="a00383.html#topoattrs_memattrs">Memory Attributes</a> and <a class="el" href="a00201.html">Comparing memory node attributes for finding where to allocate on</a> for more details. </li>
+</ul>
+<p>Once nodes with similar or different characteristics are identified, they are placed in tiers. Tiers are then sorted by bandwidth so that the highest bandwidth is ranked first, etc.</p>
+<p>If hwloc fails to build tiers properly, see <code>HWLOC_MEMTIERS</code> and <code>HWLOC_MEMTIERS_GUESS</code> in <a class="el" href="a00378.html">Environment Variables</a>.</p>
+<h1><a class="anchor" id="heteromem_use_cli"></a>
+Using Heterogeneous Memory from the command-line</h1>
+<p>Tiers may be specified in location filters when using NUMA nodes in hwloc command-line tools. For instance, binding memory on the first HBM node (<code>numa[hbm]:0</code>) is actually equivalent to binding on the second node (<code>numa:1</code>) on our example platform: </p><pre class="fragment">$ hwloc-bind --membind 'numa[hbm]:0' -- myprogram
+$ hwloc-bind --membind 'numa:1' -- myprogram
+</pre><p> To count DRAM nodes in the first CPU package, or all nodes: </p><pre class="fragment">$ hwloc-calc -N 'numa[dram]' package:0
+1
+$ hwloc-calc -N 'numa' package:0
+2
+</pre><p> To list all the physical indexes of Tier-0 NUMA nodes (HBM P#2 and P#3 not shown on the figure): </p><pre class="fragment">$ hwloc-calc -I 'numa[tier=0]' -p all
+2,3
+</pre><p>The number of tiers may be retrieved by looking at topology attributes in the root object: </p><pre class="fragment">$ hwloc-info --get-attr "info MemoryTiersNr" topology
+2
+</pre><p>hwloc-calc and hwloc-bind also have options such as <code>--local-memory</code> and <code>--best-memattr</code> to select the best NUMA node among the local ones. For instance, the following command-lines say that, among nodes near node:0 (DRAM L#0), the best one for latency is itself while the best one for bandwidth is node:1 (HBM L#1). </p><pre class="fragment">$ hwloc-calc --best-memattr latency node:0
+0
+$ hwloc-calc --best-memattr bandwidth node:0
+1
+</pre><h1><a class="anchor" id="heteromem_use_api"></a>
+Using Heterogeneous Memory from the C API</h1>
+<p>There are two major changes introduced by heterogeneous memory when looking at the hierarchical tree of objects. </p><ul>
+<li>
+First, there may be multiple memory children attached at the same place. For instance, each Package in the above image has two memory children, one for the DRAM NUMA node, and another one for the HBM node. </li>
+<li>
+Second, memory children may be attached at different levels. In the above image, CXL memory is attached to the root Machine object instead of below a Package. </li>
+</ul>
+<p>Hence, one may have to rethink the way it selects NUMA nodes.</p>
+<h2><a class="anchor" id="heteromem_use_api_iterate"></a>
+Iterating over the list of (heterogeneous) NUMA nodes</h2>
+<p>A common need consists in iterating over the list of NUMA nodes (e.g. using <a class="el" href="a00176.html#ga759e88eaf5a230ad283e9d4c42486735" title="Returns the next object of type type.">hwloc_get_next_obj_by_type()</a>). This is useful for counting some domains before partitioning a job, or for finding a node that is local to some objects. With heterogeneous memory, one should remember that multiple nodes may now have the same locality (HBM and DRAM above) or overlapping localities (e.g. DRAM and CXL above). Checking NUMA node subtype or tier attributes is a good way to avoid this issue by ignoring nodes of different kinds.</p>
+<p>Another solution consists in ignoring nodes whose cpuset overlap the previously selected ones. For instance, in the above example, one could first select DRAM L#0 but ignore HBM L#1 (because it overlaps with DRAM L#0), then select DRAM L#2 but ignore HBM L#3 and CXL L#4 (overlap wih DRAM L#2).</p>
+<p><br  />
+</p>
+<p>It is also possible to iterate over the memory parents (e.g. Packages in our example) and select only one memory child for each of them. <a class="el" href="a00176.html#gae85786340b88e24835f8c403a1e2e54b" title="Return the depth of parents where memory objects are attached.">hwloc_get_memory_parents_depth()</a> may be used to find the depth of these parents. However this method only works if all memory parents are at the same level. It would fail in our example: the root Machine object also has a memory child (CXL), hence <a class="el" href="a00176.html#gae85786340b88e24835f8c403a1e2e54b" title="Return the depth of parents where memory objects are attached.">hwloc_get_memory_parents_depth()</a> would returns <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c" title="Objects of given type exist at different depth in the topology (only for Groups).">HWLOC_TYPE_DEPTH_MULTIPLE</a>.</p>
+<h2><a class="anchor" id="heteromem_use_api_vertical"></a>
+Iterating over local (heterogeneous) NUMA nodes</h2>
+<p>Another common need is to find NUMA nodes that are local to some objects (e.g. a Core). A basic solution consists in looking at the Core nodeset and iterating over NUMA nodes to select those whose nodeset are included. A nicer solution is to walk up the tree to find ancestors with a memory child. With heterogeneous memory, multiple such ancestors may exist (Package and Machine in our example) and they may have multiple memory children.</p>
+<p>Both these methods may be replaced with <a class="el" href="a00201.html#ga569e80c5be7ef27649b0ef5aa52ffcdc" title="Return an array of local NUMA nodes.">hwloc_get_local_numanode_objs()</a> which provides a convenient and flexible way to retrieve local NUMA nodes. One may then iterate over the returned array to select the appropriate one(s) depending on their subtype, tier or performance attributes.</p>
+<p><br  />
+</p>
+<p><a class="el" href="a00201.html#ga884d1f2ad745c2fa69c1583c82d28f10" title="Return the best target NUMA node for the given attribute and initiator.">hwloc_memattr_get_best_target()</a> is also a convenient way to select the best local NUMA node according to performance metrics. See also <a class="el" href="a00201.html">Comparing memory node attributes for finding where to allocate on</a>. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00385.html 2.11.0-1/doc/doxygen-doc/html/a00385.html
--- 2.10.0-1/doc/doxygen-doc/html/a00385.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00385.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,75 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Importing and exporting topologies from/to XML files</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Importing and exporting topologies from/to XML files</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>hwloc offers the ability to export topologies to XML files and reload them later. This is for instance useful for loading topologies faster (see <a class="el" href="a00391.html#faq_xml">I do not want hwloc to rediscover my enormous machine topology every time I rerun a process</a>), manipulating other nodes' topology, or avoiding the need for privileged processes (see <a class="el" href="a00391.html#faq_privileged">Does hwloc require privileged access?</a>).</p>
+<p>Topologies may be exported to XML files thanks to <a class="el" href="a00195.html#ga333f79975b4eeb28a3d8fad3373583ce" title="Export the topology into an XML file.">hwloc_topology_export_xml()</a>, or to a XML memory buffer with <a class="el" href="a00195.html#gad33b7f7c11db10459505a3b1634fd3f1" title="Export the topology into a newly-allocated XML memory buffer.">hwloc_topology_export_xmlbuffer()</a>. The lstopo program can also serve as a XML topology export tool.</p>
+<p>XML topologies may then be reloaded later with <a class="el" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e" title="Enable XML-file based topology.">hwloc_topology_set_xml()</a> and <a class="el" href="a00181.html#ga2745616b65595e1c1e579ecc7e461fa8" title="Enable XML based topology using a memory buffer (instead of a file, as with hwloc_topology_set_xml())...">hwloc_topology_set_xmlbuffer()</a>. The HWLOC_XMLFILE environment variable also tells hwloc to load the topology from the given XML file (see <a class="el" href="a00378.html">Environment Variables</a>).</p>
+<dl class="section note"><dt>Note</dt><dd>Loading XML topologies disables binding because the loaded topology may not correspond to the physical machine that loads it. This behavior may be reverted by asserting that loaded file really matches the underlying system with the HWLOC_THISSYSTEM environment variable or the <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" title="Assume that the selected backend provides the topology for the system on which we are running.">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a> topology flag.</dd>
+<dd>
+The topology flag <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea1b66bbd66e900e5c837f71defb32ad89" title="Get the set of allowed resources from the local operating system even if the topology was loaded from...">HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES</a> may be used to load a XML topology that contains the entire machine and restrict it to the part that is actually available to the current process (e.g. when Linux Cgroup/Cpuset are used to restrict the set of resources).</dd>
+<dd>
+hwloc also offers the ability to export/import <a class="el" href="a00217.html">Topology differences</a>.</dd>
+<dd>
+XML topology files are not localized. They use a dot as a decimal separator. Therefore any exported topology can be reloaded on any other machine without requiring to change the locale.</dd>
+<dd>
+XML exports contain all details about the platform. It means that two very similar nodes still have different XML exports (e.g. some serial numbers or MAC addresses are different). If a less precise exporting/importing is required, one may want to look at <a class="el" href="a00386.html">Synthetic topologies</a> instead.</dd></dl>
+<h1><a class="anchor" id="xml_backends"></a>
+libxml2 and minimalistic XML backends</h1>
+<p>hwloc offers two backends for importing/exporting XML.</p>
+<p>First, it can use the libxml2 library for importing/exporting XML files. It features full XML support, for instance when those files have to be manipulated by non-hwloc software (e.g. a XSLT parser). The libxml2 backend is enabled by default if libxml2 development headers are available (the relevant development package is usually <code>libxml2-devel</code> or <code>libxml2-dev</code>).</p>
+<p>If libxml2 is not available at configure time, or if <code>--disable-libxml2</code> is passed, hwloc falls back to a custom backend. Contrary to the aforementioned full XML backend with libxml2, this minimalistic XML backend cannot be guaranteed to work with external programs. It should only be assumed to be compatible with the same hwloc release (even if using the libxml2 backend). Its advantage is, however, to always be available without requiring any external dependency.</p>
+<p>If libxml2 is available but the core hwloc library should not directly depend on it, the libxml2 support may be built as a dynamicall-loaded plugin. One should pass <code>--enable-plugins</code> to enable plugin support (when supported) and build as plugins all component that support it. Or pass <code>--enable-plugins=xml_libxml</code> to only build this libxml2 support as a plugin.</p>
+<h1><a class="anchor" id="xml_errors"></a>
+XML import error management</h1>
+<p>Importing XML files can fail at least because of file access errors, invalid XML syntax, non-hwloc-valid XML contents, or incompatibilities between hwloc releases (see <a class="el" href="a00391.html#faq_version_xml">Are XML topology files compatible between hwloc releases?</a>).</p>
+<p>Both backend cannot detect all these errors when the input XML file or buffer is selected (when <a class="el" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e" title="Enable XML-file based topology.">hwloc_topology_set_xml()</a> or <a class="el" href="a00181.html#ga2745616b65595e1c1e579ecc7e461fa8" title="Enable XML based topology using a memory buffer (instead of a file, as with hwloc_topology_set_xml())...">hwloc_topology_set_xmlbuffer()</a> is called). Some errors such non-hwloc-valid contents can only be detected later when loading the topology with <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>.</p>
+<p>It is therefore strongly recommended to check the return value of both <a class="el" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e" title="Enable XML-file based topology.">hwloc_topology_set_xml()</a> (or <a class="el" href="a00181.html#ga2745616b65595e1c1e579ecc7e461fa8" title="Enable XML based topology using a memory buffer (instead of a file, as with hwloc_topology_set_xml())...">hwloc_topology_set_xmlbuffer()</a>) and <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a> to handle all these errors. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00386.html 2.11.0-1/doc/doxygen-doc/html/a00386.html
--- 2.10.0-1/doc/doxygen-doc/html/a00386.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00386.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,103 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Synthetic topologies</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Synthetic topologies</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>hwloc may load fake or remote topologies so as to consult them without having the underlying hardware available. Aside from loading XML topologies, hwloc also enables the building of <em>synthetic</em> topologies that are described by a single string listing the arity of each levels.</p>
+<p>For instance, lstopo may create a topology made of 2 packages, containing a single NUMA node and a L2 cache above two single-threaded cores:</p>
+<pre class="fragment">$ lstopo -i "pack:2 node:1 l2:1 core:2 pu:1" -
+Machine (2048MB)
+  Package L#0
+    NUMANode L#0 (P#0 1024MB)
+    L2 L#0 (4096KB)
+      Core L#0 + PU L#0 (P#0)
+      Core L#1 + PU L#1 (P#1)
+  Package L#1
+    NUMANode L#1 (P#1 1024MB)
+    L2 L#1 (4096KB)
+      Core L#2 + PU L#2 (P#2)
+      Core L#3 + PU L#3 (P#3)
+</pre><p>Replacing <code>-</code> with <code>file.xml</code> in this command line will export this topology to XML as usual.</p>
+<dl class="section note"><dt>Note</dt><dd>Synthetic topologies offer a very basic way to export a topology and reimport it on another machine. It is a lot less precise than XML but may still be enough when only the hierarchy of resources matters.</dd></dl>
+<h1><a class="anchor" id="synthetic_string"></a>
+Synthetic description string</h1>
+<p>Each item in the description string gives the type of the level and the number of such children under each object of the previous level. That is why the above topology contains 4 cores (2 cores times 2 nodes).</p>
+<p>These type names must be written as <code>numanode</code>, <code>package</code>, <code>core</code>, <code>l2u</code>, <code>l1i</code>, <code>pu</code>, <code>group</code> (hwloc_obj_type_sscanf() is used for parsing the type names). They do not need to be written case-sensitively, nor entirely (as long as there is no ambiguity, 2 characters such as <code>ma</code> select a Machine level). Note that I/O and Misc objects are not available.</p>
+<p>Instead of specifying the type of each level, it is possible to just specify the arities and let hwloc choose all types according to usual topologies. The following examples are therefore equivalent: </p><pre class="fragment">$ lstopo -i "2 3 4 5 6"
+$ lstopo -i "Package:2 NUMANode:3 L2Cache:4 Core:5 PU:6"
+</pre><p>NUMA nodes are handled in a special way since they are not part of the main CPU hierarchy but rather attached below it as memory children. Thus, <code>NUMANode:3</code> actually means <code>Group:3</code> where one NUMA node is attached below each group. These groups are merged back into the parent when possible (typically when a single NUMA node is requested below each parent).</p>
+<p>It is also possible the explicitly attach NUMA nodes to specific levels. For instance, a topology similar to a Intel Xeon Phi processor (with 2 NUMA nodes per 16-core group) may be created with: </p><pre class="fragment">$ lstopo -i "package:1 group:4 [numa] [numa] core:16 pu:4"
+</pre><p>The root object does not appear in the synthetic description string since it is always a Machine object. Therefore the Machine type is disallowed in the description as well.</p>
+<p>A NUMA level (with a single NUMA node) is automatically added if needed.</p>
+<p>Each item may be followed parentheses containing a list of space-separated attributes. For instance: </p><ul>
+<li>
+<code>L2iCache:2(size=32kB)</code> specifies 2 children of 32kB level-2 instruction caches. The size may be specified in bytes (without any unit suffix) or as kB, KiB, MB, MiB, etc.  </li>
+<li>
+<code>NUMANode:3(memory=16MB)</code> specifies 3 NUMA nodes with 16MB each. The size may be specified in bytes (without any unit suffix) or as GB, GiB, TB, TiB, etc.  </li>
+<li>
+<code>PU:2(indexes=0,2,1,3)</code> specifies 2 PU children and the full list of OS indexes among the entire set of 4 PU objects.  </li>
+<li>
+<code>PU:2(indexes=numa:core)</code> specifies 2 PU children whose OS indexes are interleaved by NUMA node first and then by package.  </li>
+<li>
+Attributes in parentheses at the very beginning of the description apply to the root object.  </li>
+</ul>
+<p>hwloc command-line tools may modify a synthetic topology, for instance to customize object attributes, or to remove some objects to make the topology heterogeneous or asymmetric. See many examples in <a class="el" href="a00391.html#faq_create_asymmetric">How do I create a custom heterogeneous and asymmetric topology?</a>.</p>
+<h1><a class="anchor" id="synthetic_use"></a>
+Loading a synthetic topology</h1>
+<p>Aside from lstopo, the hwloc programming interface offers the same ability by passing the synthetic description string to <a class="el" href="a00181.html#ga4fab186bb6181a00bcf585825fddd38d" title="Enable synthetic topology.">hwloc_topology_set_synthetic()</a> before <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>.</p>
+<p>Synthetic topologies are created by the <code>synthetic</code> component. This component may be enabled by force by setting the HWLOC_SYNTHETIC environment variable to something such as <code>node:2 core:3 pu:4</code>.</p>
+<p>Loading a synthetic topology disables binding support since the topology usually does not match the underlying hardware. Binding may be reenabled as usual by setting HWLOC_THISSYSTEM=1 in the environment or by setting the <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b" title="Assume that the selected backend provides the topology for the system on which we are running.">HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</a> topology flag.</p>
+<h1><a class="anchor" id="synthetic_export"></a>
+Exporting a topology as a synthetic string</h1>
+<p>The function <a class="el" href="a00196.html#ga24b7864a1c588309c4749f621f03b4c7" title="Export the topology as a synthetic string.">hwloc_topology_export_synthetic()</a> may export a topology as a synthetic string. It offers a convenient way to quickly describe the contents of a machine. The lstopo tool may also perform such an export by forcing the output format.</p>
+<pre class="fragment">$ lstopo --of synthetic --no-io
+Package:1 L3Cache:1 L2Cache:2 L1dCache:1 L1iCache:1 Core:1 PU:2
+</pre><p>The exported string may be passed back to hwloc for recreating another similar topology (see also <a class="el" href="a00391.html#faq_version_synthetic">Are synthetic strings compatible between hwloc releases?</a>). The entire tree will be similar, but some attributes such as the processor model will be missing.</p>
+<p>Such an export is only possible if the topology is totally symmetric. It means that the <code>symmetric_subtree</code> field of the root object is set. Also memory children should be attached in a symmetric way (e.g. the same number of memory children below each Package object, etc.). However, I/O devices and Misc objects are ignored when looking at symmetry and exporting the string. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00387.html 2.11.0-1/doc/doxygen-doc/html/a00387.html
--- 2.10.0-1/doc/doxygen-doc/html/a00387.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00387.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,106 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Interoperability With Other Software</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Interoperability With Other Software</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>Although hwloc offers its own portable interface, it still may have to interoperate with specific or non-portable libraries that manipulate similar kinds of objects. hwloc therefore offers several specific "helpers" to assist converting between those specific interfaces and hwloc.</p>
+<p>Some external libraries may be specific to a particular OS; others may not always be available. The hwloc core therefore generally does not explicitly depend on these types of libraries. However, when a custom application uses or otherwise depends on such a library, it may optionally include the corresponding hwloc helper to extend the hwloc interface with dedicated helpers.</p>
+<p>Most of these helpers use structures that are specific to these external libraries and only meaningful on the local machine. If so, the helper requires the input topology to match the current machine. Some helpers also require I/O device discovery to be supported and enabled for the current topology.</p>
+<dl>
+<dt>Linux specific features </dt>
+<dd><p class="startdd"><a class="el" href="a00125_source.html">hwloc/linux.h</a> offers Linux-specific helpers that utilize some non-portable features of the Linux system, such as binding threads through their thread ID ("tid") or parsing kernel CPU mask files. See <a class="el" href="a00204.html">Linux-specific helpers</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Windows specific features </dt>
+<dd><p class="startdd"><a class="el" href="a00131_source.html">hwloc/windows.h</a> offers Windows-specific helpers to query information about Windows processor groups. See <a class="el" href="a00207.html">Windows-specific helpers</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Linux libnuma </dt>
+<dd><p class="startdd"><a class="el" href="a00128_source.html">hwloc/linux-libnuma.h</a> provides conversion helpers between hwloc CPU sets and libnuma-specific types, such as bitmasks. It helps you use libnuma memory-binding functions with hwloc CPU sets. See <a class="el" href="a00206.html">Interoperability with Linux libnuma bitmask</a> and <a class="el" href="a00205.html">Interoperability with Linux libnuma unsigned long masks</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Glibc </dt>
+<dd><p class="startdd"><a class="el" href="a00134_source.html">hwloc/glibc-sched.h</a> offers conversion routines between Glibc and hwloc CPU sets in order to use hwloc with functions such as sched_getaffinity() or pthread_attr_setaffinity_np(). See <a class="el" href="a00208.html">Interoperability with glibc sched affinity</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>OpenFabrics Verbs </dt>
+<dd><p class="startdd"><a class="el" href="a00158_source.html">hwloc/openfabrics-verbs.h</a> helps interoperability with the OpenFabrics Verbs interface. For example, it can return a list of processors near an OpenFabrics device. It may also return the corresponding OS device hwloc object for further information (if I/O device discovery is enabled). See <a class="el" href="a00216.html">Interoperability with OpenFabrics</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>OpenCL </dt>
+<dd><p class="startdd"><a class="el" href="a00137_source.html">hwloc/opencl.h</a> enables interoperability with the OpenCL interface. Only the AMD and NVIDIA implementations currently offer locality information. It may return the list of processors near a GPU given as a <code>cl_device_id</code>. It may also return the corresponding OS device hwloc object for further information (if I/O device discovery is enabled). See <a class="el" href="a00209.html">Interoperability with OpenCL</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>oneAPI Level Zero </dt>
+<dd><p class="startdd"><a class="el" href="a00152_source.html">hwloc/levelzero.h</a> enables interoperability with the oneAPI Level Zero interface. It may return the list of processors near an accelerator or GPU. It may also return the corresponding OS device hwloc object for further information (if I/O device discovery is enabled). See <a class="el" href="a00214.html">Interoperability with the oneAPI Level Zero interface.</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>AMD ROCm SMI Library (RSMI) </dt>
+<dd><p class="startdd"><a class="el" href="a00149_source.html">hwloc/rsmi.h</a> enables interoperability with the AMD ROCm SMI interface. It may return the list of processors near an AMD GPU. It may also return the corresponding OS device hwloc object for further information (if I/O device discovery is enabled). See <a class="el" href="a00213.html">Interoperability with the ROCm SMI Management Library</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>NVIDIA CUDA </dt>
+<dd><p class="startdd"><a class="el" href="a00140_source.html">hwloc/cuda.h</a> and <a class="el" href="a00143_source.html">hwloc/cudart.h</a> enable interoperability with NVIDIA CUDA Driver and Runtime interfaces. For instance, it may return the list of processors near NVIDIA GPUs. It may also return the corresponding OS device hwloc object for further information (if I/O device discovery is enabled). See <a class="el" href="a00210.html">Interoperability with the CUDA Driver API</a> and <a class="el" href="a00211.html">Interoperability with the CUDA Runtime API</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>NVIDIA Management Library (NVML) </dt>
+<dd><p class="startdd"><a class="el" href="a00146_source.html">hwloc/nvml.h</a> enables interoperability with the NVIDIA NVML interface. It may return the list of processors near a NVIDIA GPU given as a <code>nvmlDevice_t</code>. It may also return the corresponding OS device hwloc object for further information (if I/O device discovery is enabled). See <a class="el" href="a00212.html">Interoperability with the NVIDIA Management Library</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>NVIDIA displays </dt>
+<dd><p class="startdd"><a class="el" href="a00155_source.html">hwloc/gl.h</a> enables interoperability with NVIDIA displays using the NV-CONTROL X extension (NVCtrl library). If I/O device discovery is enabled, it may return the OS device hwloc object that corresponds to a display given as a name such as <em>:0.0</em> or given as a port/device pair (server/screen). See <a class="el" href="a00215.html">Interoperability with OpenGL displays</a>. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Taskset command-line tool </dt>
+<dd><p class="startdd">The taskset command-line tool is widely used for binding processes. It manipulates CPU set strings in a format that is slightly different from hwloc's one (it does not divide the string in fixed-size subsets and separates them with commas). To ease interoperability, hwloc offers routines to convert hwloc CPU sets from/to taskset-specific string format. See for instance <a class="el" href="a00194.html#ga5beb68a987fe48e5c5edef06ab260e14" title="Stringify a bitmap in the taskset-specific format.">hwloc_bitmap_taskset_snprintf()</a> in <a class="el" href="a00194.html">The bitmap API</a>.</p>
+<p class="interdd">Most hwloc command-line tools also support the option <code>--cpuset-output-format taskset</code> to manipulate taskset-specific strings. </p>
+<p class="enddd"></p>
+</dd>
+</dl>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00388.html 2.11.0-1/doc/doxygen-doc/html/a00388.html
--- 2.10.0-1/doc/doxygen-doc/html/a00388.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00388.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,87 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Thread Safety</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Thread Safety</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>Like most libraries that mainly fill data structures, hwloc is not thread safe but rather reentrant: all state is held in a <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38" title="Topology context.">hwloc_topology_t</a> instance without mutex protection. That means, for example, that two threads can safely operate on and modify two different <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38" title="Topology context.">hwloc_topology_t</a> instances, but they should not simultaneously invoke functions that modify the <em>same</em> instance. Similarly, one thread should not modify a <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38" title="Topology context.">hwloc_topology_t</a> instance while another thread is reading or traversing it. However, two threads can safely read or traverse the same <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38" title="Topology context.">hwloc_topology_t</a> instance concurrently.</p>
+<p>When running in multiprocessor environments, be aware that proper thread synchronization and/or memory coherency protection is needed to pass hwloc data (such as <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38" title="Topology context.">hwloc_topology_t</a> pointers) from one processor to another (e.g., a mutex, semaphore, or a memory barrier). Note that this is not a hwloc-specific requirement, but it is worth mentioning.</p>
+<p>For reference, <a class="el" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38" title="Topology context.">hwloc_topology_t</a> modification operations include (but may not be limited to):</p>
+<dl>
+<dt>Creation and destruction </dt>
+<dd><p class="startdd"><code><a class="el" href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa" title="Allocate a topology context.">hwloc_topology_init()</a>, <a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a>, <a class="el" href="a00175.html#ga9f34a640b6fd28d23699d4d084667b15" title="Terminate and free a topology context.">hwloc_topology_destroy()</a></code> (see <a class="el" href="a00175.html">Topology Creation and Destruction</a>) imply major modifications of the structure, including freeing some objects. No other thread cannot access the topology or any of its objects at the same time.</p>
+<p class="interdd">Also references to objects inside the topology are not valid anymore after these functions return. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Runtime topology modifications </dt>
+<dd><p class="startdd"><code><a class="el" href="a00183.html#gad980782ade737900c5cf208946768c30" title="Add a MISC object as a leaf of the topology.">hwloc_topology_insert_misc_object()</a></code>, <code><a class="el" href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7" title="Allocate a Group object to insert later with hwloc_topology_insert_group_object().">hwloc_topology_alloc_group_object()</a></code>, and <code><a class="el" href="a00183.html#ga1fc6012b3e1c249b83f48cb7bcacaa5b" title="Add more structure to the topology by adding an intermediate Group.">hwloc_topology_insert_group_object()</a></code> (see <a class="el" href="a00183.html">Modifying a loaded Topology</a>) may modify the topology significantly by adding objects inside the tree, changing the topology depth, etc.</p>
+<p class="interdd"><code><a class="el" href="a00199.html#ga1f5a29760ebb8f9af831e645315f553c" title="Commit a new distances structure.">hwloc_distances_add_commit()</a></code> and <code><a class="el" href="a00200.html#gac188d9b64d9560255ce5f6d0a20f9c0a" title="Remove all distance matrices from a topology.">hwloc_distances_remove()</a></code> (see <a class="el" href="a00199.html">Add distances between objects</a>) modify the list of distance structures in the topology, and the former may even insert new Group objects.</p>
+<p class="interdd"><code><a class="el" href="a00202.html#ga770657d1e44b09e93e09f623936c1e5f" title="Register a new memory attribute.">hwloc_memattr_register()</a></code> and <code><a class="el" href="a00202.html#ga960529c08b25cf15825e0f72ecceb504" title="Set an attribute value for a specific target NUMA node.">hwloc_memattr_set_value()</a></code> (see <a class="el" href="a00202.html">Managing memory attributes</a>) modify the memory attributes of the topology.</p>
+<p class="interdd"><code><a class="el" href="a00183.html#ga6db81ed13ac0a9d70cc80372ab537815" title="Restrict the topology to the given CPU set or nodeset.">hwloc_topology_restrict()</a></code> modifies the topology even more dramatically by removing some objects.</p>
+<p class="interdd"><code><a class="el" href="a00183.html#ga698ecd640d2b76742bba3829a145cd9a" title="Refresh internal structures after topology modification.">hwloc_topology_refresh()</a></code> updates some internal cached structures. (see below).</p>
+<p class="interdd">Although references to former objects <em>may</em> still be valid after insertion or restriction, it is strongly advised to not rely on any such guarantee and always re-consult the topology to reacquire new instances of objects. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Consulting distances </dt>
+<dd><p class="startdd"><code><a class="el" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691" title="Retrieve distance matrices.">hwloc_distances_get()</a></code> and its variants are thread-safe except if the topology was recently modified (because distances may involve objects that were removed).</p>
+<p class="interdd">Whenever the topology is modified (see above), <code><a class="el" href="a00183.html#ga698ecd640d2b76742bba3829a145cd9a" title="Refresh internal structures after topology modification.">hwloc_topology_refresh()</a></code> should be called in the same thread-safe context to force the refresh of internal distances structures. A call to <code><a class="el" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691" title="Retrieve distance matrices.">hwloc_distances_get()</a></code> may also refresh distances-related structures.</p>
+<p class="interdd">Once this refresh has been performed, multiple <code><a class="el" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691" title="Retrieve distance matrices.">hwloc_distances_get()</a></code> may then be performed concurrently by multiple threads. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Consulting memory attributes </dt>
+<dd><p class="startdd">Functions consulting memory attributes in <a class="el" href="a00119_source.html">hwloc/memattrs.h</a> are thread-safe except if the topology was recently modified (because memory attributes may involve objects that were removed).</p>
+<p class="interdd">Whenever the topology is modified (see above), <code><a class="el" href="a00183.html#ga698ecd640d2b76742bba3829a145cd9a" title="Refresh internal structures after topology modification.">hwloc_topology_refresh()</a></code> should be called in the same thread-safe context to force the refresh of internal memory attribute structures. A call to <code><a class="el" href="a00201.html#ga297e4a9adc2272446a4c7449dacef0df" title="Return an attribute value for a specific target NUMA node.">hwloc_memattr_get_value()</a></code> or <code><a class="el" href="a00202.html#gac8c06c1c89ab352c5db8e04a75033513" title="Return the target NUMA nodes that have some values for a given attribute.">hwloc_memattr_get_targets()</a></code> may also refresh internal structures for a given memory attribute.</p>
+<p class="interdd">Once this refresh has been performed, multiple functions consulting memory attributes may then be performed concurrently by multiple threads. </p>
+<p class="enddd"></p>
+</dd>
+<dt>Locating topologies  </dt>
+<dd><p class="startdd"><code>hwloc_topology_set_*</code> (see <a class="el" href="a00182.html">Topology Detection Configuration and Query</a>) do not modify the topology directly, but they do modify internal structures describing the behavior of the upcoming invocation of <code><a class="el" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826" title="Build the actual topology.">hwloc_topology_load()</a></code>. Hence, all of these functions should not be used concurrently. </p>
+<p class="enddd"></p>
+</dd>
+</dl>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00389.html 2.11.0-1/doc/doxygen-doc/html/a00389.html
--- 2.10.0-1/doc/doxygen-doc/html/a00389.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00389.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,119 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Components and plugins</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Components and plugins</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>hwloc is organized in <b>components</b> that are responsible for discovering objects. Depending on the topology configuration, some components will be used (once enabled, they create a <b>backend</b>), some will be ignored.</p>
+<p>The usual default is to enable the native operating system component, (e.g. <code>linux</code> or <code>solaris</code>) and the <code>pci</code> one. If available, an architecture-specific component (such as <code>x86</code>) may also improve the topology detection. Finally, some hardware-specific components (such as <code>cuda</code> or <code>rsmi</code>) may add information about GPUs, accelerators, etc.</p>
+<p>If a XML topology is loaded, the <code>xml</code> discovery component will be used instead of all other components.</p>
+<h1><a class="anchor" id="plugins_default"></a>
+Components enabled by default</h1>
+<p>The hwloc core contains a list of components sorted by priority. Each one is enabled as long as it does not conflict with the previously enabled ones. This includes native operating system components, architecture-specific ones, and if available, I/O components such as <code>pci</code>.</p>
+<p>Usually the native operating system component (when it exists, e.g. <code>linux</code> or <code>aix</code>) is enabled first. Then hwloc looks for an architecture specific component (e.g. <code>x86</code>). Finally there also exist a basic component (<code>no_os</code>) that just tries to discover the number of PUs in the system.</p>
+<p>Each component discovers as much topology information as possible. Most of them, including most native OS components, do nothing unless the topology is still empty. Some others, such as <code>x86</code> and <code>pci</code>, can complete and annotate what other backends found earlier. Discovery is performed by phases: CPUs are first discovered, then memory is attached, then PCI, etc.</p>
+<p>Default priorities ensure that clever components are invoked first. Native operating system components have higher priorities, and are therefore invoked first, because they likely offer very detailed topology information. If needed, it will be later extended by architecture-specific information (e.g. from the <code>x86</code> component).</p>
+<p>If any configuration function such as <a class="el" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e" title="Enable XML-file based topology.">hwloc_topology_set_xml()</a> is used before loading the topology, the corresponding component is enabled first. Then, as usual, hwloc enables any other component (based on priorities) that does not conflict.</p>
+<p>Certain components that manage a virtual topology, for instance XML topology import or synthetic topology description, conflict with all other components. Therefore, they may only be loaded (e.g. with <code><a class="el" href="a00181.html#ga879439b7ee99407ee911b3ac64e9a25e" title="Enable XML-file based topology.">hwloc_topology_set_xml()</a></code>) if no other component is enabled.</p>
+<p>The environment variable <code>HWLOC_COMPONENTS_VERBOSE</code> may be set to get verbose messages about available components (including their priority) and enabling as backends.</p>
+<h1><a class="anchor" id="plugins_select"></a>
+Selecting which components to use</h1>
+<p>If no topology configuration functions such as <code><a class="el" href="a00181.html#ga4fab186bb6181a00bcf585825fddd38d" title="Enable synthetic topology.">hwloc_topology_set_synthetic()</a></code> have been called, components may be selected with environment variables such as <code>HWLOC_XMLFILE</code>, <code>HWLOC_SYNTHETIC</code>, <code>HWLOC_FSROOT</code>, or <code>HWLOC_CPUID_PATH</code> (see <a class="el" href="a00378.html">Environment Variables</a>).</p>
+<p>Finally, the environment variable <code>HWLOC_COMPONENTS</code> resets the list of selected components. If the variable is set and empty (or set to a single comma separating nothing, since some operating systems do not accept empty variables), the normal component priority order is used.</p>
+<p>If the variable is set to <code>x86</code> in this variable will cause the <code>x86</code> component to take precedence over any other component, including the native operating system component. It is therefore loaded first, before hwloc tries to load all remaining non-conflicting components. In this case, <code>x86</code> would take care of discovering everything it supports, instead of only completing what the native OS information. This may be useful if the native component is buggy on some platforms.</p>
+<p>It is possible to prevent some components from being loaded by prefixing their name with <code>-</code> in the list. For instance <code>x86,-pci</code> will load the <code>x86</code> component, then let hwloc load all the usual components except <code>pci</code>. A single component phase may also be blacklisted, for instance with <code>-linux:io</code>.</p>
+<p>It is possible to prevent all remaining components from being loaded by placing <code>stop</code> in the environment variable. Only the components listed before this keyword will be enabled.</p>
+<p><a class="el" href="a00181.html#ga9ad41adf418cee1c0ee32ba9bd4a3d36" title="Prevent a discovery component from being used for a topology.">hwloc_topology_set_components()</a> may also be used inside the program to prevent the loading of a specific component (or phases) for the target topology.</p>
+<h1><a class="anchor" id="plugins_load"></a>
+Loading components from plugins</h1>
+<p>Components may optionally be built as <b>plugins</b> so that the hwloc core library does not directly depend on their dependencies (for instance the <code>libpciaccess</code> library). Plugin support may be enabled with the <code>--enable-plugins</code> configure option. All components buildable as plugins will then be built as plugins. The configure option may be given a comma-separated list of component names to specify the exact list of components to build as plugins.</p>
+<p>Plugins are built as independent dynamic libraries that are installed in <code>$libdir/hwloc</code>. All plugins found in this directory are loaded during <code>topology_init()</code> (unless blacklisted in <code>HWLOC_PLUGINS_BLACKLIST</code>, see <a class="el" href="a00378.html">Environment Variables</a>). A specific list of directories (colon-separated) to scan may be specified in the <code>HWLOC_PLUGINS_PATH</code> environment variable.</p>
+<p>Note that loading a plugin just means that the corresponding component is registered to the hwloc core. Components are then only enabled (as a <b>backend</b>) if the topology configuration requests it, as explained in the previous sections.</p>
+<p>Also note that plugins should carefully be enabled and used when embedding hwloc in another project, see <a class="el" href="a00390.html">Embedding hwloc in Other Software</a> for details.</p>
+<h1><a class="anchor" id="plugins_list"></a>
+Existing components and plugins</h1>
+<p>All components distributed within hwloc are listed below. The list of actually available components may be listed at running with the <code>HWLOC_COMPONENTS_VERBOSE</code> environment variable (see <a class="el" href="a00378.html">Environment Variables</a>).</p>
+<dl>
+<dt>linux </dt>
+<dd>The official component for discovering CPU, memory and I/O devices on Linux. It discovers PCI devices without the help of external libraries such as libpciaccess, but requires the pci component for adding vendor/device names to PCI objects. It also discovers many kinds of Linux-specific OS devices.  </dd>
+<dt>aix, darwin, freebsd, hpux, netbsd, solaris, windows </dt>
+<dd>Each officially supported operating system has its own native component, which is statically built when supported, and which is used by default.  </dd>
+<dt>x86 </dt>
+<dd>The x86 architecture (either 32 or 64 bits) has its own component that may complete or replace the previously-found CPU information. It is statically built when supported.  </dd>
+<dt>bgq </dt>
+<dd>This component is specific to IBM BlueGene/Q compute node (running CNK). It is built and enabled by default when <code>--host=powerpc64-bgq-linux</code> is passed to configure (see <a class="el" href="a00391.html#faq_bgq">How do I build hwloc for BlueGene/Q?</a>).  </dd>
+<dt>no_os </dt>
+<dd>A basic component that just tries to detect the number of processing units in the system. It mostly serves on operating systems that are not natively supported. It is always statically built.  </dd>
+<dt>pci </dt>
+<dd>PCI object discovery uses the external libpciaccess library; see <a class="el" href="a00380.html">I/O Devices</a>. It may also annotate existing PCI devices with vendor and device names. <b>It may be built as a plugin</b>.  </dd>
+<dt>opencl </dt>
+<dd>The OpenCL component creates co-processor OS device objects such as <em>opencl0d0</em> (first device of the first OpenCL platform) or <em>opencl1d3</em> (fourth device of the second platform). Only the AMD and NVIDIA OpenCL implementations currently offer locality information. <b>It may be built as a plugin</b>.  </dd>
+<dt>rsmi </dt>
+<dd>This component creates GPU OS device objects such as <em>rsmi0</em> for describing AMD GPUs. <b>It may be built as a plugin</b>.  </dd>
+<dt>levelzero </dt>
+<dd>This component creates co-processor OS device objects such as <em>ze0</em> for describing oneAPI Level Zero devices. It may also create sub-OS-devices such as <em>ze0.0</em> inside those devices. <b>It may be built as a plugin</b>.  </dd>
+<dt>cuda </dt>
+<dd>This component creates co-processor OS device objects such as <em>cuda0</em> that correspond to NVIDIA GPUs used with CUDA library. <b>It may be built as a plugin</b>.  </dd>
+<dt>nvml </dt>
+<dd>Probing the NVIDIA Management Library creates OS device objects such as <em>nvml0</em> that are useful for batch schedulers. It also detects the actual PCIe link bandwidth without depending on power management state and without requiring administrator privileges. <b>It may be built as a plugin</b>.  </dd>
+<dt>gl </dt>
+<dd>Probing the NV-CONTROL X extension (NVCtrl library) creates OS device objects such as <em>:0.0</em> corresponding to NVIDIA displays. They are useful for graphical applications that need to place computation and/or data near a rendering GPU. <b>It may be built as a plugin</b>.  </dd>
+<dt>synthetic </dt>
+<dd>Synthetic topology support (see <a class="el" href="a00386.html">Synthetic topologies</a>) is always built statically.  </dd>
+<dt>xml </dt>
+<dd>XML topology import (see <a class="el" href="a00385.html">Importing and exporting topologies from/to XML files</a>) is always built statically. It internally uses a specific class of components for the actual XML import/export routines (see <a class="el" href="a00385.html#xml_backends">libxml2 and minimalistic XML backends</a> for details). <ul>
+<li>
+<b>xml_nolibxml</b> is a basic and hwloc-specific XML import/export. It is always statically built.  </li>
+<li>
+<b>xml_libxml</b> relies on the external libxml2 library for provinding a feature-complete XML import/export. <b>It may be built as a plugin</b>.   </li>
+</ul>
+</dd>
+<dt>fake </dt>
+<dd>A dummy plugin that does nothing but is used for debugging plugin support.  </dd>
+</dl>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00390.html 2.11.0-1/doc/doxygen-doc/html/a00390.html
--- 2.10.0-1/doc/doxygen-doc/html/a00390.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00390.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,107 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Embedding hwloc in Other Software</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Embedding hwloc in Other Software</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>It can be desirable to include hwloc in a larger software package (be sure to check out the LICENSE file) so that users don't have to separately download and install it before installing your software. This can be advantageous to ensure that your software uses a known-tested/good version of hwloc, or for use on systems that do not have hwloc pre-installed.</p>
+<p>When used in "embedded" mode, hwloc will:</p>
+<ul>
+<li>not install any header files</li>
+<li>not build any documentation files</li>
+<li>not build or install any executables or tests</li>
+<li>not build <code>libhwloc.*</code> &ndash; instead, it will build <code>libhwloc_embedded.*</code></li>
+</ul>
+<p>There are two ways to put hwloc into "embedded" mode. The first is directly from the configure command line:</p>
+<pre class="fragment">shell$ ./configure --enable-embedded-mode ...
+</pre><p>The second requires that your software project uses the GNU Autoconf / Automake / Libtool tool chain to build your software. If you do this, you can directly integrate hwloc's m4 configure macro into your configure script. You can then invoke hwloc's configuration tests and build setup by calling a m4 macro (see below).</p>
+<p>Although hwloc dynamic shared object plugins may be used in embedded mode, the embedder project will have to manually setup dlopen or libltdl in its build system so that hwloc can load its plugins at run time. Also, embedders should be aware of complications that can arise due to public and private linker namespaces (e.g., if the embedder project is loaded into a private namespace and then hwloc tries to dynamically load its plugins, such loading may fail since the hwloc plugins can't find the hwloc symbols they need). The embedder project is <b>strongly</b> advised not to use hwloc's dynamically loading plugins / dlopen / libltdl capability.</p>
+<h1><a class="anchor" id="embedding_m4"></a>
+Using hwloc's M4 Embedding Capabilities</h1>
+<p>Every project is different, and there are many different ways of integrating hwloc into yours. What follows is <em>one</em> example of how to do it.</p>
+<p>If your project uses recent versions Autoconf, Automake, and Libtool to build, you can use hwloc's embedded m4 capabilities. We have tested the embedded m4 with projects that use Autoconf 2.65, Automake 1.11.1, and Libtool 2.2.6b. Slightly earlier versions of may also work but are untested. Autoconf versions prior to 2.65 are almost certain to not work.</p>
+<p>You can either copy all the config/hwloc*m4 files from the hwloc source tree to the directory where your project's m4 files reside, or you can tell aclocal to find more m4 files in the embedded hwloc's "config" subdirectory (e.g., add "-Ipath/to/embedded/hwloc/config" to your Makefile.am's ACLOCAL_AMFLAGS).</p>
+<p>The following macros can then be used from your configure script (only HWLOC_SETUP_CORE <em>must</em> be invoked if using the m4 macros):</p>
+<ul>
+<li><p class="startli">HWLOC_SETUP_CORE(config-dir-prefix, action-upon-success, action-upon-failure, print_banner_or_not): Invoke the hwloc configuration tests and setup the hwloc tree to build. The first argument is the prefix to use for AC_OUTPUT files &ndash; it's where the hwloc tree is located relative to <code>$top_srcdir</code>. Hence, if your embedded hwloc is located in the source tree at contrib/hwloc, you should pass <code>[contrib/hwloc]</code> as the first argument. If HWLOC_SETUP_CORE and the rest of <code>configure</code> completes successfully, then "make" traversals of the hwloc tree with standard Automake targets (all, clean, install, etc.) should behave as expected. For example, it is safe to list the hwloc directory in the SUBDIRS of a higher-level Makefile.am. The last argument, if not empty, will cause the macro to display an announcement banner that it is starting the hwloc core configuration tests.</p>
+<p class="startli">HWLOC_SETUP_CORE will set the following environment variables and AC_SUBST them: HWLOC_EMBEDDED_CFLAGS, HWLOC_EMBEDDED_CPPFLAGS, and HWLOC_EMBEDDED_LIBS. These flags are filled with the values discovered in the hwloc-specific m4 tests, and can be used in your build process as relevant. The _CFLAGS, _CPPFLAGS, and _LIBS variables are necessary to build libhwloc (or libhwloc_embedded) itself.</p>
+<p class="startli">HWLOC_SETUP_CORE also sets HWLOC_EMBEDDED_LDADD environment variable (and AC_SUBSTs it) to contain the location of the libhwloc_embedded.la convenience Libtool archive. It can be used in your build process to link an application or other library against the embedded hwloc library.</p>
+<p class="startli"><b>NOTE: If the HWLOC_SET_SYMBOL_PREFIX macro is used, it must be invoked <em>before</em> HWLOC_SETUP_CORE.</b></p>
+</li>
+<li>HWLOC_BUILD_STANDALONE: HWLOC_SETUP_CORE defaults to building hwloc in an "embedded" mode (described above). If HWLOC_BUILD_STANDALONE is invoked *before* HWLOC_SETUP_CORE, the embedded definitions will not apply (e.g., libhwloc.la will be built, not libhwloc_embedded.la).</li>
+<li>HWLOC_SET_SYMBOL_PREFIX(foo_): Tells the hwloc to prefix all of hwloc's types and public symbols with "foo_"; meaning that function hwloc_init() becomes foo_hwloc_init(). Enum values are prefixed with an upper-case translation if the prefix supplied; HWLOC_OBJ_CORE becomes FOO_hwloc_OBJ_CORE. This is recommended behavior if you are including hwloc in middleware &ndash; it is possible that your software will be combined with other software that links to another copy of hwloc. If both uses of hwloc utilize different symbol prefixes, there will be no type/symbol clashes, and everything will compile, link, and run successfully. If you both embed hwloc without changing the symbol prefix and also link against an external hwloc, you may get multiple symbol definitions when linking your final library or application.</li>
+<li>HWLOC_SETUP_DOCS, HWLOC_SETUP_UTILS, HWLOC_SETUP_TESTS: These three macros only apply when hwloc is built in "standalone" mode (i.e., they should NOT be invoked unless HWLOC_BUILD_STANDALONE has already been invoked).</li>
+<li>HWLOC_DO_AM_CONDITIONALS: If you embed hwloc in a larger project and build it conditionally with Automake (e.g., if HWLOC_SETUP_CORE is invoked conditionally), you must unconditionally invoke HWLOC_DO_AM_CONDITIONALS to avoid warnings from Automake (for the cases where hwloc is not selected to be built). This macro is necessary because hwloc uses some AM_CONDITIONALs to build itself, and AM_CONDITIONALs cannot be defined conditionally. Note that it is safe (but unnecessary) to call HWLOC_DO_AM_CONDITIONALS even if HWLOC_SETUP_CORE is invoked unconditionally. If you are not using Automake to build hwloc, this macro is unnecessary (and will actually cause errors because it invoked AM_* macros that will be undefined).</li>
+</ul>
+<p><b>NOTE:</b> When using the HWLOC_SETUP_CORE m4 macro, it may be necessary to explicitly invoke AC_CANONICAL_TARGET (which requires config.sub and config.guess) and/or AC_USE_SYSTEM_EXTENSIONS macros early in the configure script (e.g., after AC_INIT but before AM_INIT_AUTOMAKE). See the Autoconf documentation for further information.</p>
+<p>Also note that hwloc's top-level configure.ac script uses exactly the macros described above to build hwloc in a standalone mode (by default). You may want to examine it for one example of how these macros are used.</p>
+<h1><a class="anchor" id="embedding_example"></a>
+Example Embedding hwloc</h1>
+<p>Here's an example of integrating with a larger project named sandbox that already uses Autoconf, Automake, and Libtool to build itself:</p>
+<pre class="fragment"># First, cd into the sandbox project source tree
+shell$ cd sandbox
+shell$ cp -r /somewhere/else/hwloc-&lt;version&gt; my-embedded-hwloc
+shell$ edit Makefile.am
+  1. Add "-Imy-embedded-hwloc/config" to ACLOCAL_AMFLAGS
+  2. Add "my-embedded-hwloc" to SUBDIRS
+  3. Add "$(HWLOC_EMBEDDED_LDADD)" and "$(HWLOC_EMBEDDED_LIBS)" to 
+     sandbox's executable's LDADD line.  The former is the name of the 
+     Libtool convenience library that hwloc will generate.  The latter 
+     is any dependent support libraries that may be needed by 
+     $(HWLOC_EMBEDDED_LDADD).
+  4. Add "$(HWLOC_EMBEDDED_CFLAGS)" to AM_CFLAGS
+  5. Add "$(HWLOC_EMBEDDED_CPPFLAGS)" to AM_CPPFLAGS
+shell$ edit configure.ac
+  1. Add "HWLOC_SET_SYMBOL_PREFIX(sandbox_hwloc_)" line
+  2. Add "HWLOC_SETUP_CORE([my-embedded-hwloc], [happy=yes], [happy=no])" line
+  3. Add error checking for happy=no case
+shell$ edit sandbox.c
+  1. Add #include &lt;hwloc.h&gt;
+  2. Add calls to sandbox_hwloc_init() and other hwloc API functions
+</pre><p>Now you can bootstrap, configure, build, and run the sandbox as normal &ndash; all calls to "sandbox_hwloc_*" will use the embedded hwloc rather than any system-provided copy of hwloc. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00391.html 2.11.0-1/doc/doxygen-doc/html/a00391.html
--- 2.10.0-1/doc/doxygen-doc/html/a00391.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00391.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,412 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Frequently Asked Questions (FAQ)</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Frequently Asked Questions (FAQ)</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><h1><a class="anchor" id="faq1"></a>
+Concepts</h1>
+<h2><a class="anchor" id="faq_why"></a>
+I only need binding, or the number of cores, why should I use hwloc ?</h2>
+<p>hwloc is its portable API that works on a variety of operating systems. It supports binding of threads, processes and memory buffers (see <a class="el" href="a00179.html">CPU binding</a> and <a class="el" href="a00180.html">Memory binding</a>). Even if some features are not supported on some systems, using hwloc is much easier than reimplementing your own portability layer.</p>
+<p>Moreover, hwloc provides knowledge of cores and hardware threads. It offers easy ways to bind tasks to individual hardware threads, or to entire multithreaded cores, etc. See <a class="el" href="a00391.html#faq_smt">How may I ignore symmetric multithreading, hyper-threading, etc. in hwloc?</a>. Most alternative software for binding do not even know whether each core is single-threaded, multithreaded or hyper-threaded. They would bind to individual threads without any way to know whether multiple tasks are in the same physical core.</p>
+<p>However, using hwloc comes with an overhead since a topology must be loaded before gathering information and binding tasks or memory. Fortunately this overhead may be significantly reduced by filtering non-interesting information out of the topology, see <a class="el" href="a00391.html#faq_disable_faster">What may I disable to make hwloc faster?</a> below.</p>
+<h2><a class="anchor" id="faq_disable_faster"></a>
+What may I disable to make hwloc faster?</h2>
+<p>Building a hwloc topology on a large machine may be slow because the discovery of hundreds of hardware cores or threads takes time (especially when reading thousands of sysfs files on Linux). Ignoring some objects (for instance caches) that aren't useful to the current application may improve this overhead. One should also consider using XML (see <a class="el" href="a00391.html#faq_xml">I do not want hwloc to rediscover my enormous machine topology every time I rerun a process</a>) to work around such issues.</p>
+<p>Contrary to lstopo which enables most features (see <a class="el" href="a00391.html#faq_slow_lstopo">Why is lstopo slow?</a>), the default hwloc configuration is to keep all objects enabled except I/Os and instruction caches. This usually builds a very precise view of the CPU and memory subsystems, which may be reduced if some information is unneeded.</p>
+<p><br  />
+ The following code tells hwloc to build a much smaller topology that only contains Cores (explicitly filtered-in below), hardware threads (PUs, cannot be filtered-out), NUMA nodes (cannot be filtered-out), and the root object (usually a Machine; the root cannot be removed without breaking the tree):</p>
+<pre class="fragment">hwloc_topology_t topology;
+hwloc_topology_init(&amp;topology);
+/* filter everything out */
+hwloc_topology_set_all_types_filter(topology, HWLOC_TYPE_FILTER_KEEP_NONE);
+/* filter Cores back in */
+hwloc_topology_set_type_filter(topology, HWLOC_OBJ_CORE, HWLOC_TYPE_FILTER_KEEP_ALL);
+hwloc_topology_load(topology);
+</pre><p>However, one should remember that filtering such objects out removes locality information from the hwloc tree. For instance, we may not know anymore which PU is close to which NUMA node. This would be useful to applications that explicitly want to place specific memory buffers close to specific tasks. To ignore useless objects but keep those that bring locality/hierarchy information, applications may replace <a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a" title="Ignore all objects of this type.">HWLOC_TYPE_FILTER_KEEP_NONE</a> with <a class="el" href="a00182.html#gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4" title="Only ignore objects if their entire level does not bring any structure.">HWLOC_TYPE_FILTER_KEEP_STRUCTURE</a> above.</p>
+<p><br  />
+ Starting with hwloc 2.8, it is also possible to ignore distances between objects, memory performance attributes, and kinds of CPU cores, by setting topology flags before load: </p><pre class="fragment">[...]
+/* disable distances, memory attributes and CPU kinds */
+hwloc_topology_set_flags(topology, HWLOC_TOPOLOGY_FLAG_NO_DISTANCES
+                                   |HWLOC_TOPOLOGY_FLAG_NO_MEMATTRS
+                                   |HWLOC_TOPOLOGY_FLAG_NO_CPUKINDS);
+[...]
+hwloc_topology_load(topology);
+</pre><p><br  />
+ Finally it is possible to prevent some hwloc components from being loaded and queried. If you are sure that the Linux (or x86) component is enough to discover everything you need, you may ask hwloc to disable all other components by setting something like <code>HWLOC_COMPONENTS=linux,stop</code> in the environment. See <a class="el" href="a00389.html">Components and plugins</a> for details.</p>
+<h2><a class="anchor" id="faq_indexes"></a>
+Should I use logical or physical/OS indexes? and how?</h2>
+<p>One of the original reasons why hwloc was created is that <b>physical/OS indexes</b> (<code>obj-&gt;os_index</code>) are often crazy and unpredictable: processors numbers are usually non-contiguous (processors 0 and 1 are not physically close), they vary from one machine to another, and may even change after a BIOS or system update. These numbers make task placement hardly portable. Moreover some objects have no physical/OS numbers (caches), and some objects have non-unique numbers (core numbers are only unique within a socket). Physical/OS indexes are only guaranteed to exist and be unique for PU and NUMA nodes.</p>
+<p>hwloc therefore introduces <b>logical indexes</b> (<code>obj-&gt;logical_index</code>) which are portable, contiguous and logically ordered (based on the resource organization in the locality tree). In general, one should only use logical indexes and just let hwloc do the internal conversion when really needed (when talking to the OS and hardware).</p>
+<p>hwloc developers recommends that users do not use physical/OS indexes unless they really know what they are doing. The main reason for still using physical/OS indexes is when interacting with non-hwloc tools such as numactl or taskset, or when reading hardware information from raw sources such as /proc/cpuinfo.</p>
+<p>lstopo options <code>-l</code> and <code>-p</code> may be used to switch between logical indexes (prefixed with <code>L#</code>) and physical/OS indexes (<code>P#</code>). Converting one into the other may also be achieved with hwloc-calc which may manipulate either logical or physical indexes as input or output. See also <a class="el" href="a00377.html#cli_hwloc_calc">hwloc-calc</a>.</p>
+<pre class="fragment"># Convert PU with physical number 3 into logical number
+$ hwloc-calc -I pu --physical-input --logical-output pu:3
+5
+
+# Convert a set of NUMA nodes from logical to physical
+# (beware that the output order may not match the input order)
+$ hwloc-calc -I numa --logical-input --physical-output numa:2-3 numa:7
+0,2,5
+</pre><h2><a class="anchor" id="faq_structural"></a>
+hwloc is only a structural model, it ignores performance models, memory bandwidth, etc.?</h2>
+<p>hwloc is indeed designed to provide applications with a structural model of the platform. This is an orthogonal approach to describing the machine with performance models, for instance using memory bandwidth or latencies measured by benchmarks. We believe that both approaches are important for helping application make the most of the hardware.</p>
+<p>For instance, on a dual-processor host with four cores each, hwloc clearly shows which four cores are together. Latencies between all pairs of cores of the same processor are likely identical, and also likely lower than the latency between cores of different processors. However, the structural model cannot guarantee such implementation details. On the other side, performance models would reveal such details without always clearly identifying which cores are in the same processor.</p>
+<p>The focus of hwloc is mainly of the structural modeling side. However, hwloc lets user adds performance information to the topology through distances (see <a class="el" href="a00383.html#topoattrs_distances">Distances</a>), memory attributes (see <a class="el" href="a00383.html#topoattrs_memattrs">Memory Attributes</a>) or even custom annotations (see <a class="el" href="a00391.html#faq_annotate">How do I annotate the topology with private notes?</a>). hwloc may also use such distance information for grouping objects together (see <a class="el" href="a00391.html#faq_onedim">hwloc only has a one-dimensional view of the architecture, it ignores distances?</a> and <a class="el" href="a00391.html#faq_groups">What are these Group objects in my topology?</a>).</p>
+<h2><a class="anchor" id="faq_onedim"></a>
+hwloc only has a one-dimensional view of the architecture, it ignores distances?</h2>
+<p>hwloc places all objects in a tree. Each level is a one-dimensional view of a set of similar objects. All children of the same object (siblings) are assumed to be equally interconnected (same distance between any of them), while the distance between children of different objects (cousins) is supposed to be larger.</p>
+<p>Modern machines exhibit complex hardware interconnects, so this tree may miss some information about the actual physical distances between objects. The hwloc topology may therefore be annotated with distance information that may be used to build a more realistic representation (multi-dimensional) of each level. For instance, there can be a distance matrix that representing the latencies between any pair of NUMA nodes if the BIOS and/or operating system reports them.</p>
+<p>For more information about the hwloc distances, see <a class="el" href="a00383.html#topoattrs_distances">Distances</a>.</p>
+<h2><a class="anchor" id="faq_groups"></a>
+What are these Group objects in my topology?</h2>
+<p>hwloc comes with a set of predefined object types (Core, Package, NUMA node, Caches) that match the vast majority of hardware platforms. The <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56" title="Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take...">HWLOC_OBJ_GROUP</a> type was designed for cases where this set is not sufficient. Groups may be used anywhere to add more structure information to the topology, for instance to show that 2 out of 4 NUMA nodes are actually closer than the others. When applicable, the <code>subtype</code> field describes why a Group was actually added (see also <a class="el" href="a00382.html#attributes_normal">Normal attributes</a>).</p>
+<p>hwloc currently uses Groups for the following reasons: </p><ul>
+<li>
+NUMA parents when memory locality does not match any existing object. </li>
+<li>
+I/O parents when I/O locality does not match any existing object. </li>
+<li>
+Distance-based groups made of close objects. </li>
+<li>
+AMD Core Complex (CCX) (<code>subtype</code> is <code>Complex</code>, in the x86 backend), but these objects are usually merged with the L3 caches or Dies. </li>
+<li>
+AMD Bulldozer dual-core compute units (<code>subtype</code> is <code>ComputeUnit</code>, in the x86 backend), but these objects are usually merged with the L2 caches. </li>
+<li>
+Intel Extended Topology Enumeration levels (in the x86 backend). </li>
+<li>
+Windows processor groups when HWLOC_WINDOWS_PROCESSOR_GROUP_OBJS=1 is set in the environment (except if they contain exactly a single NUMA node, or a single Package, etc.). </li>
+<li>
+IBM S/390 "Books" on Linux (<code>subtype</code> is <code>Book</code>). </li>
+<li>
+Linux Clusters of CPUs (<code>subtype</code> is <code>Cluster</code>), for instance for ARM cores sharing of some internal cache or bus, or x86 cores sharing a L2 cache (since Linux kernel 5.16). <code>HWLOC_DONT_MERGE_CLUSTER_GROUPS=1</code> may be set in the environment to disable the automerging of these groups with identical caches, etc.  </li>
+<li>
+AIX unknown hierarchy levels. </li>
+</ul>
+<p>hwloc Groups are only kept if no other object has the same locality information. It means that a Group containing a single child is merged into that child. And a Group is merged into its parent if it is its only child. For instance a Windows processor group containing a single NUMA node would be merged with that NUMA node since it already contains the relevant hierarchy information.</p>
+<p>When inserting a custom Group with hwloc_hwloc_topology_insert_group_object(), this merging may be disabled by setting its <code>dont_merge</code> attribute.</p>
+<h2><a class="anchor" id="faq_asymmetric"></a>
+What happens if my topology is asymmetric?</h2>
+<p>hwloc supports asymmetric topologies even if most platforms are usually symmetric. For example, there could be different types of processors in a single machine, each with different numbers of cores, symmetric multithreading, or levels of caches.</p>
+<p>In practice, asymmetric topologies are rare but occur for at least two reasons: </p><ul>
+<li>
+Intermediate groups may added for I/O affinity: on a 4-package machine, an I/O bus may be connected to 2 packages. These packages are below an additional Group object, while the other packages are not (see also <a class="el" href="a00391.html#faq_groups">What are these Group objects in my topology?</a>). </li>
+<li>
+If only part of a node is available to the current process, for instance because the resource manager uses Linux Cgroups to restrict process resources, some cores (or NUMA nodes) will disappear from the topology (unless flag <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258" title="Detect the whole system, ignore reservations, include disallowed objects.">HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</a> was passed). On a 32-core machine where 12 cores were allocated to the process, this may lead to one CPU package with 8 cores, another one with only 4 cores, and two missing packages.  </li>
+</ul>
+<p>To understand how hwloc manages such cases, one should first remember the meaning of levels and cousin objects. All objects of the same type are gathered as horizontal levels with a given depth. They are also connected through the cousin pointers of the <a class="el" href="a00229.html" title="Structure of a topology object.">hwloc_obj</a> structure. Object attribute (cache depth and type, group depth) are also taken in account when gathering objects as horizontal levels. To be clear: there will be one level for L1i caches, another level for L1d caches, another one for L2, etc.</p>
+<p>If the topology is asymmetric (e.g., if a group is missing above some processors), a given horizontal level will still exist if there exist any objects of that type. However, some branches of the overall tree may not have an object located in that horizontal level. Note that this specific hole within one horizontal level does not imply anything for other levels. All objects of the same type are gathered in horizontal levels even if their parents or children have different depths and types.</p>
+<p>See the diagram in <a class="el" href="a00376.html">Terms and Definitions</a> for a graphical representation of such topologies.</p>
+<p>Moreover, it is important to understand that a same parent object may have children of different types (and therefore, different depths). <b>These children are therefore siblings (because they have the same parent), but they are <em>not</em> cousins (because they do not belong to the same horizontal level).</b></p>
+<h2><a class="anchor" id="faq_nosmt"></a>
+What happens to my topology if I disable symmetric multithreading, hyper-threading, etc. in the system?</h2>
+<p>hwloc creates one PU (processing unit) object per hardware thread. If your machine supports symmetric multithreading, for instance Hyper-Threading, each Core object may contain multiple PU objects: </p><pre class="fragment">$ lstopo -
+...
+  Core L#0
+    PU L#0 (P#0)
+    PU L#1 (P#2)
+  Core L#1
+    PU L#2 (P#1)
+    PU L#3 (P#3)
+</pre><p>x86 machines usually offer the ability to disable hyper-threading in the BIOS. Or it can be disabled on the Linux kernel command-line at boot time, or later by writing in sysfs virtual files.</p>
+<p>If you do so, the hwloc topology structure does not significantly change, but some PU objects will not appear anymore. No level will disappear, you will see the same number of Core objects, but each of them will contain a single PU now. The PU level does not disappear either (remember that hwloc topologies always contain a PU level at the bottom of the topology) even if there is a single PU object per Core parent. </p><pre class="fragment">$ lstopo -
+...
+  Core L#0
+    PU L#0 (P#0)
+  Core L#1
+    PU L#1 (P#1)
+</pre><h2><a class="anchor" id="faq_smt"></a>
+How may I ignore symmetric multithreading, hyper-threading, etc. in hwloc?</h2>
+<p>First, see <a class="el" href="a00391.html#faq_nosmt">What happens to my topology if I disable symmetric multithreading, hyper-threading, etc. in the system?</a> for more information about multithreading.</p>
+<p>If you need to ignore symmetric multithreading in software, you should likely manipulate hwloc Core objects directly: </p><pre class="fragment">/* get the number of cores */
+unsigned nbcores = hwloc_get_nbobjs_by_type(topology, HWLOC_OBJ_CORE);
+...
+/* get the third core below the first package */
+hwloc_obj_t package, core;
+package = hwloc_get_obj_by_type(topology, HWLOC_OBJ_PACKAGE, 0);
+core = hwloc_get_obj_inside_cpuset_by_type(topology, package-&gt;cpuset,
+                                           HWLOC_OBJ_CORE, 2);
+</pre><p>Whenever you want to bind a process or thread to a core, make sure you singlify its cpuset first, so that the task is actually bound to a single thread within this core (to avoid useless migrations). </p><pre class="fragment">/* bind on the second core */
+hwloc_obj_t core = hwloc_get_obj_by_type(topology, HWLOC_OBJ_CORE, 1);
+hwloc_cpuset_t set = hwloc_bitmap_dup(core-&gt;cpuset);
+hwloc_bitmap_singlify(set);
+hwloc_set_cpubind(topology, set, 0);
+hwloc_bitmap_free(set);
+</pre><p>With hwloc-calc or hwloc-bind command-line tools, you may specify that you only want a single-thread within each core by asking for their first PU object: </p><pre class="fragment">$ hwloc-calc core:4-7
+0x0000ff00
+$ hwloc-calc core:4-7.pu:0
+0x00005500
+</pre><p>When binding a process on the command-line, you may either specify the exact thread that you want to use, or ask hwloc-bind to singlify the cpuset before binding </p><pre class="fragment">$ hwloc-bind core:3.pu:0 -- echo "hello from first thread on core #3"
+hello from first thread on core #3
+...
+$ hwloc-bind core:3 --single -- echo "hello from a single thread on core #3"
+hello from a single thread on core #3
+</pre><h1><a class="anchor" id="faq2"></a>
+Advanced</h1>
+<h2><a class="anchor" id="faq_xml"></a>
+I do not want hwloc to rediscover my enormous machine topology every time I rerun a process</h2>
+<p>Although the topology discovery is not expensive on common machines, its overhead may become significant when multiple processes repeat the discovery on large machines (for instance when starting one process per core in a parallel application). The machine topology usually does not vary much, except if some cores are stopped/restarted or if the administrator restrictions are modified. Thus rediscovering the whole topology again and again may look useless.</p>
+<p>For this purpose, hwloc offers XML import/export and shared memory features.</p>
+<p>XML lets you save the discovered topology to a file (for instance with the lstopo program) and reload it later by setting the HWLOC_XMLFILE environment variable. The HWLOC_THISSYSTEM environment variable should also be set to 1 to assert that loaded file is really the underlying system.</p>
+<p>Loading a XML topology is usually much faster than querying multiple files or calling multiple functions of the operating system. It is also possible to manipulate such XML files with the C programming interface, and the import/export may also be directed to memory buffer (that may for instance be transmitted between applications through a package). See also <a class="el" href="a00385.html">Importing and exporting topologies from/to XML files</a>.</p>
+<dl class="section note"><dt>Note</dt><dd>The environment variable HWLOC_THISSYSTEM_ALLOWED_RESOURCES may be used to load a XML topology that contains the entire machine and restrict it to the part that is actually available to the current process (e.g. when Linux Cgroup/Cpuset are used to restrict the set of resources). See <a class="el" href="a00378.html">Environment Variables</a>.</dd></dl>
+<p>Shared-memory topologies consist in one process exposing its topology in a shared-memory buffer so that other processes (running on the same machine) may use it directly. This has the advantage of reducing the memory footprint since a single topology is stored in physical memory for multiple processes. However, it requires all processes to map this shared-memory buffer at the same virtual address, which may be difficult in some cases. This API is described in <a class="el" href="a00218.html">Sharing topologies between processes</a>.</p>
+<h2><a class="anchor" id="faq_multitopo"></a>
+How many topologies may I use in my program?</h2>
+<p>hwloc lets you manipulate multiple topologies at the same time. However, these topologies consume memory and system resources (for instance file descriptors) until they are destroyed. It is therefore discouraged to open the same topology multiple times.</p>
+<p>Sharing a single topology between threads is easy (see <a class="el" href="a00388.html">Thread Safety</a>) since the vast majority of accesses are read-only.</p>
+<p>If multiple topologies of different (but similar) nodes are needed in your program, have a look at <a class="el" href="a00391.html#faq_diff">How to avoid memory waste when manipulating multiple similar topologies?</a>.</p>
+<h2><a class="anchor" id="faq_diff"></a>
+How to avoid memory waste when manipulating multiple similar topologies?</h2>
+<p>hwloc does not share information between topologies. If multiple similar topologies are loaded in memory, for instance the topologies of different identical nodes of a cluster, lots of information will be duplicated.</p>
+<p><a class="el" href="a00161_source.html">hwloc/diff.h</a> (see also <a class="el" href="a00217.html">Topology differences</a>) offers the ability to compute topology differences, apply or unapply them, or export/import to/from XML. However, this feature is limited to basic differences such as attribute changes. It does not support complex modifications such as adding or removing some objects.</p>
+<h2><a class="anchor" id="faq_annotate"></a>
+How do I annotate the topology with private notes?</h2>
+<p>Each hwloc object contains a <code>userdata</code> field that may be used by applications to store private pointers. This field is only valid during the lifetime of these container object and topology. It becomes invalid as soon the topology is destroyed, or as soon as the object disappears, for instance when restricting the topology. The userdata field is not exported/imported to/from XML by default since hwloc does not know what it contains. This behavior may be changed by specifying application-specific callbacks with <code><a class="el" href="a00195.html#ga9d6ff0f7a8dd45be9aa8575ef31978cc" title="Set the application-specific callback for exporting object userdata.">hwloc_topology_set_userdata_export_callback()</a></code> and <code><a class="el" href="a00195.html#ga5ac6917ea7289955fb1ffda4353af9b0" title="Set the application-specific callback for importing userdata.">hwloc_topology_set_userdata_import_callback()</a></code>.</p>
+<p>Each object may also contain some <em>info</em> attributes (name and value strings) that are setup by hwloc during discovery and that may be extended by the user with <code><a class="el" href="a00178.html#gace7654bb8a9002caae1a4b8a59e7452e" title="Add the given name and value pair to the given object info attributes.">hwloc_obj_add_info()</a></code> (see also <a class="el" href="a00382.html">Object attributes</a>). Contrary to the <code>userdata</code> field which is unique, multiple info attributes may exist for each object, even with the same name. These attributes are always exported to XML. However, only character strings may be used as names and values.</p>
+<p>It is also possible to insert Misc objects with a custom name anywhere as a leaf of the topology (see <a class="el" href="a00381.html">Miscellaneous objects</a>). And Misc objects may have their own userdata and info attributes just like any other object.</p>
+<p>The hwloc-annotate command-line tool may be used for adding Misc objects and info attributes.</p>
+<p>There is also a topology-specific userdata pointer that can be used to recognize different topologies by storing a custom pointer. It may be manipulated with <code><a class="el" href="a00182.html#ga2cc7b7b155cba58dda203e54f1637b9c" title="Set the topology-specific userdata pointer.">hwloc_topology_set_userdata()</a></code> and <code><a class="el" href="a00182.html#gad47dee1a30f4b00486b54872af030b43" title="Retrieve the topology-specific userdata pointer.">hwloc_topology_get_userdata()</a></code>.</p>
+<h2><a class="anchor" id="faq_create_asymmetric"></a>
+How do I create a custom heterogeneous and asymmetric topology?</h2>
+<p>Synthetic topologies (see <a class="el" href="a00386.html">Synthetic topologies</a>) allow to create custom topologies but they are always symmetric: same numbers of cores in each package, same local NUMA nodes, same shared cache, etc. To create an asymmetric topology, for instance to simulate hybrid CPUs, one may want to start from a larger symmetric topology and restrict it. <br  />
+</p>
+<p>Assuming we want two packages, one with 4 dual-threaded cores, and one with 8 single-threaded cores, first we create a topology with two identical packages, each with 8 dual-threaded cores: </p><pre class="fragment">$ lstopo -i "pack:2 core:8 pu:2" topo.xml
+</pre><p> Then create the bitmask representing the PUs that we wish to keep and pass it to lstopo's restrict option: </p><pre class="fragment">$ hwloc-calc -i topo.xml pack:0.core:0-3.pu:0-1 pack:1.core:0-7.pu:0
+0x555500ff
+$ lstopo -i topo.xml --restrict 0x555500ff topo2.xml
+$ mv -f topo2.xml topo.xml
+</pre><p> To mark the cores of first package as Big (power hungry) and those of second package as Little (energy efficient), define CPU kinds: </p><pre class="fragment">$ hwloc-annotate topo.xml topo.xml -- none -- cpukind $(hwloc-calc -i topo.xml pack:0) 1 0 CoreType Big
+$ hwloc-annotate topo.xml topo.xml -- none -- cpukind $(hwloc-calc -i topo.xml pack:1) 0 0 CoreType Little
+</pre><p> <br  />
+</p>
+<p>A similar method may be used for heterogeneous memory. First we specify 2 NUMA nodes per package in our synthetic description: </p><pre class="fragment">$ lstopo -i "pack:2 [numa(memory=100GB)] [numa(memory=10GB)] core:8 pu:2" topo.xml
+</pre><p> Then remove the second node of first package: </p><pre class="fragment">$ hwloc-calc -i topo.xml --nodeset node:all ~pack:0.node:1
+0x0000000e
+$ lstopo -i topo.xml --restrict nodeset=0xe topo2.xml
+$ mv -f topo2.xml topo.xml
+</pre><p> Then make one large node even bigger: </p><pre class="fragment">$ hwloc-annotate topo.xml topo.xml -- pack:0.numa:0 -- size 200GB
+</pre><p> Now we have 200GB in first package, and 100GB+10GB in second package. <br  />
+</p>
+<p>Next we may specify that the small NUMA node (second of second package) is HBM while the large ones are DRAM: </p><pre class="fragment">$ hwloc-annotate topo.xml topo.xml -- pack:0.numa:0 pack:1.numa:0 -- subtype DRAM
+$ hwloc-annotate topo.xml topo.xml -- pack:1.numa:1 -- subtype HBM
+</pre><p> Finally we may define memory performance attributes to specify that the HBM bandwidth (200GB/s) from local cores is higher than the DRAM bandwidth (50GB/s): </p><pre class="fragment">$ hwloc-annotate topo.xml topo.xml -- pack:0.numa:0 -- memattr Bandwidth pack:0 50000
+$ hwloc-annotate topo.xml topo.xml -- pack:1.numa:0 -- memattr Bandwidth pack:1 50000
+$ hwloc-annotate topo.xml topo.xml -- pack:1.numa:1 -- memattr Bandwidth pack:1 200000
+</pre><p> <br  />
+</p>
+<p>There is currently no way to create or modify I/O devices attached to such fake topologies. There is also no way to have some <em>partial levels</em>, e.g. a L3 cache in one package but not in the other. <br  />
+</p>
+<p>More changes may obviously be performed by manually modifying the XML export file. Simple operations such as modifying object attributes (cache size, memory size, name-value info attributes, etc.), moving I/O subtrees, moving Misc objects, or removing objects are easy to perform.</p>
+<p>However, modifying CPU and Memory objects requires care since cpusets and nodesets are supposed to remain consistent between parents and children. Similarly, PCI bus IDs should remain consistent between bridges and children within an I/O subtree.</p>
+<h1><a class="anchor" id="faq3"></a>
+Caveats</h1>
+<h2><a class="anchor" id="faq_slow_lstopo"></a>
+Why is lstopo slow?</h2>
+<p>lstopo enables most hwloc objects and discovery flags by default so that the output topology is as precise as possible (while hwloc disables many of them by default). This includes I/O device discovery through PCI libraries as well as external libraries such as NVML. To speed up lstopo, you may disable such features with command-line options such as <code>--no-io</code>.</p>
+<p>When NVIDIA GPU probing is enabled (e.g. with CUDA or NVML), one may enable the <em>Persistent</em> mode (with <code>nvidia-smi -pm 1</code>) to avoid significant GPU wakeup and initialization overhead.</p>
+<p>When AMD GPU discovery is enabled with OpenCL and hwloc is used remotely over ssh, some spurious round-trips on the network may significantly increase the discovery time. Forcing the <code>DISPLAY</code> environment variable to the remote X server display (usually <code>:0</code>) instead of only setting the <code>COMPUTE</code> variable may avoid this.</p>
+<p>Also remember that these hwloc components may be disabled. At build-time, one may pass configure flags such as <code>--disable-opencl</code>, <code>--disable-cuda</code>, <code>--disable-nvml</code>, <code>--disable-rsmi</code>, and <code>--disable-levelzero</code>. At runtime, one may set the environment variable <code>HWLOC_COMPONENTS=-opencl,-cuda,-nvml,-rsmi,-levelzero</code> or call <a class="el" href="a00181.html#ga9ad41adf418cee1c0ee32ba9bd4a3d36" title="Prevent a discovery component from being used for a topology.">hwloc_topology_set_components()</a>.</p>
+<p>Remember that these backends are disabled by default, except in lstopo. If hwloc itself is still too slow even after disabling all the I/O devices as explained above, see also <a class="el" href="a00391.html#faq_disable_faster">What may I disable to make hwloc faster?</a> for disabling even more features.</p>
+<h2><a class="anchor" id="faq_privileged"></a>
+Does hwloc require privileged access?</h2>
+<p>hwloc discovers the topology by querying the operating system. Some minor features may require privileged access to the operation system. For instance memory module discovery on Linux is reserved to root, and the entire PCI discovery on Solaris and BSDs requires access to some special files that are usually restricted to root (/dev/pci* or /devices/pci*).</p>
+<p>To workaround this limitation, it is recommended to export the topology as a XML file generated by the administrator (with the lstopo program) and make it available to all users (see <a class="el" href="a00385.html">Importing and exporting topologies from/to XML files</a>). It will offer all discovery information to any application without requiring any privileged access anymore. Only the necessary hardware characteristics will be exported, no sensitive information will be disclosed through this XML export.</p>
+<p>This XML-based model also has the advantage of speeding up the discovery because reading a XML topology is usually much faster than querying the operating system again.</p>
+<p>The utility <code>hwloc-dump-hwdata</code> is also involved in gathering privileged information at boot time and making it available to non-privileged users (note that this may require a specific SELinux MLS policy module). However, it only applies to Intel Xeon Phi processors for now (see <a class="el" href="a00391.html#faq_knl_dump">Why do I need hwloc-dump-hwdata for memory on Intel Xeon Phi processor?</a>). See also <code>HWLOC_DUMPED_HWDATA_DIR</code> in <a class="el" href="a00378.html">Environment Variables</a> for details about the location of dumped files.</p>
+<h2><a class="anchor" id="faq_os_error"></a>
+What should I do when hwloc reports "operating system" warnings?</h2>
+<p>When the operating system reports invalid locality information (because of either software or hardware bugs), hwloc may fail to insert some objects in the topology because they cannot fit in the already built tree of resources. If so, hwloc will report a warning like the following. The object causing this error is ignored, the discovery continues but the resulting topology will miss some objects and may be asymmetric (see also <a class="el" href="a00391.html#faq_asymmetric">What happens if my topology is asymmetric?</a>).</p>
+<pre class="fragment">****************************************************************************
+* hwloc received invalid information from the operating system.
+*
+* L3 (cpuset 0x000003f0) intersects with NUMANode (P#0 cpuset 0x0000003f) without inclusion!
+* Error occurred in topology.c line 940
+*
+* Please report this error message to the hwloc user's mailing list,
+* along with the files generated by the hwloc-gather-topology script.
+*
+* hwloc will now ignore this invalid topology information and continue.
+****************************************************************************
+</pre><p>These errors are common on large AMD platforms because of BIOS and/or Linux kernel bugs causing invalid L3 cache information. In the above example, the hardware reports a L3 cache that is shared by 2 cores in the first NUMA node and 4 cores in the second NUMA node. That's wrong, it should actually be shared by all 6 cores in a single NUMA node. The resulting topology will miss some L3 caches.</p>
+<p>If your application does not care about cache sharing, or if you do not plan to request cache-aware binding in your process launcher, you may likely ignore this error (and hide it by setting HWLOC_HIDE_ERRORS=1 in your environment).</p>
+<p>Some platforms report similar warnings about conflicting Packages and NUMANodes.</p>
+<p>On x86 hosts, passing <code>HWLOC_COMPONENTS=x86</code> in the environment may workaround some of these issues by switching to a different way to discover the topology.</p>
+<p>Upgrading the BIOS and/or the operating system may help. Otherwise, as explained in the message, reporting this issue to the hwloc developers (by sending the tarball that is generated by the hwloc-gather-topology script on this platform) is a good way to make sure that this is a software (operating system) or hardware bug (BIOS, etc).</p>
+<p>See also <a class="el" href="index.html#bugs">Questions and Bugs</a>. Opening an issue on GitHub automatically displays hints on what information you should provide when reporting such bugs.</p>
+<h2><a class="anchor" id="faq_valgrind"></a>
+Why does Valgrind complain about hwloc memory leaks?</h2>
+<p>If you are debugging your application with Valgrind, you want to avoid memory leak reports that are caused by hwloc and not by your program.</p>
+<p>hwloc itself is often checked with Valgrind to make sure it does not leak memory. However, some global variables in hwloc dependencies are never freed. For instance libz allocates its global state once at startup and never frees it so that it may be reused later. Some libxml2 global state is also never freed because hwloc does not know whether it can safely ask libxml2 to free it (the application may also be using libxml2 outside of hwloc).</p>
+<p>These unfreed variables cause leak reports in Valgrind. hwloc installs a Valgrind <em>suppressions</em> file to hide them. You should pass the following command-line option to Valgrind to use it: </p><pre class="fragment">  --suppressions=/path/to/hwloc-valgrind.supp
+</pre><h1><a class="anchor" id="faq4"></a>
+Platform-specific</h1>
+<h2><a class="anchor" id="faq_rocm_build"></a>
+How do I enable ROCm SMI and select which version to use?</h2>
+<p>hwloc enables ROCm SMI as soon as it finds its development headers and libraries on the system. This detection consists in looking in <code>/opt/rocm</code> by default. If a ROCm version was specified with <code>--with-rocm-version=4.4.0</code> or in the <code>ROCM_VERSION</code> environment variable, then <code>/opt/rocm-&lt;version&gt;</code> is used instead. Finally, a specific installation path may be specified with <code>--with-rocm=/path/to/rocm</code>.</p>
+<p>As usual, developer header and library paths may also be set through environment variables such as <code>LIBRARY_PATH</code> and <code>C_INCLUDE_PATH</code>.</p>
+<p>To find out whether ROCm SMI was detected and enabled, look in <em>Probe / display I/O devices</em> at the end of the configure script output. Passing <code>--enable-rsmi</code> will also cause configure to fail if RSMI could not be found and enabled in hwloc.</p>
+<h2><a class="anchor" id="faq_cuda_build"></a>
+How do I enable CUDA and select which CUDA version to use?</h2>
+<p>hwloc enables CUDA as soon as it finds CUDA development headers and libraries on the system. This detection may be performed thanks to <code>pkg-config</code> but it requires hwloc to know which CUDA version to look for. This may be done by passing <code>--with-cuda-version=11.0</code> to the configure script. Otherwise hwloc will also look for the <code>CUDA_VERSION</code> environment variable.</p>
+<p>If <code>pkg-config</code> does not work, passing <code>--with-cuda=/path/to/cuda</code> to the configure script is another way to define the corresponding library and header paths. Finally, these paths may also be set through environment variables such as <code>LIBRARY_PATH</code> and <code>C_INCLUDE_PATH</code>.</p>
+<p>These paths, either detected by <code>pkg-config</code> or given manually, will also be used to detect NVML and OpenCL libraries and enable their hwloc backends.</p>
+<p>To find out whether CUDA was detected and enabled, look in <em>Probe / display I/O devices</em> at the end of the configure script output. Passing <code>--enable-cuda</code> will also cause configure to fail if CUDA could not be found and enabled in hwloc.</p>
+<p>Note that <code>--with-cuda=/nonexisting</code> may be used to disable all dependencies that are installed by CUDA, i.e. the CUDA, NVML and NVIDIA OpenCL backends, since the given directory does not exist.</p>
+<h2><a class="anchor" id="faq_knl_numa"></a>
+How do I find the local MCDRAM NUMA node on Intel Xeon Phi processor?</h2>
+<p>Intel Xeon Phi processors introduced a new memory architecture by possibly having two distinct local memories: some normal memory (DDR) and some high-bandwidth on-package memory (MCDRAM). Processors can be configured in various clustering modes to have up to 4 <em>Clusters</em>. Moreover, each <em>Cluster</em> (quarter, half or whole processor) of the processor may have its own local parts of the DDR and of the MCDRAM. This memory and clustering configuration may be probed by looking at MemoryMode and ClusterMode attributes, see <a class="el" href="a00382.html#attributes_info_platform">Hardware Platform Information</a> and doc/examples/get-knl-modes.c in the source directory.</p>
+<p>Starting with version 2.0, hwloc properly exposes this memory configuration. DDR and MCDRAM are attached as two memory children of the same parent, DDR first, and MCDRAM second if any. Depending on the processor configuration, that parent may be a Package, a Cache, or a Group object of type <code>Cluster</code>.</p>
+<p>Hence cores may have one or two local NUMA nodes, listed by the core nodeset. An application may allocate local memory from a core by using that nodeset. The operating system will actually allocate from the DDR when possible, or fallback to the MCDRAM.</p>
+<p>To allocate specifically on one of these memories, one should walk up the parent pointers until finding an object with some memory children. Looking at these memory children will give the DDR first, then the MCDRAM if any. Their nodeset may then be used for allocating or binding memory buffers.</p>
+<p>One may also traverse the list of NUMA nodes until finding some whose cpuset matches the target core or PUs. The MCDRAM NUMA nodes may be identified thanks to the <code>subtype</code> field which is set to <code>MCDRAM</code>.</p>
+<p>Command-line tools such as <code>hwloc-bind</code> may bind memory on the MCDRAM by using the <em>hbm</em> keyword. For instance, to bind on the first MCDRAM NUMA node:</p>
+<pre class="fragment">$ hwloc-bind --membind --hbm numa:0 -- myprogram
+$ hwloc-bind --membind numa:0 -- myprogram
+</pre><h2><a class="anchor" id="faq_knl_dump"></a>
+Why do I need hwloc-dump-hwdata for memory on Intel Xeon Phi processor?</h2>
+<p>Intel Xeon Phi processors may use the on-package memory (MCDRAM) as either memory or a memory-side cache (reported as a L3 cache by hwloc by default, see <code>HWLOC_KNL_MSCACHE_L3</code> in <a class="el" href="a00378.html">Environment Variables</a>). There are also several clustering modes that significantly affect the memory organization (see <a class="el" href="a00391.html#faq_knl_numa">How do I find the local MCDRAM NUMA node on Intel Xeon Phi processor?</a> for more information about these modes). Details about these are currently only available to privileged users. Without them, hwloc relies on a heuristic for guessing the modes.</p>
+<p>The hwloc-dump-hwdata utility may be used to dump this privileged binary information into human-readable and world-accessible files that the hwloc library will later load. The utility should usually run as root once during boot, in order to update dumped information (stored under /var/run/hwloc by default) in case the MCDRAM or clustering configuration changed between reboots.</p>
+<p>When SELinux MLS policy is enabled, a specific hwloc policy module may be required so that all users get access to the dumped files (in /var/run/hwloc by default). One may use hwloc policy files from the SELinux Reference Policy at <a href="https://github.com/TresysTechnology/refpolicy-contrib">https://github.com/TresysTechnology/refpolicy-contrib</a> (see also the documentation at <a href="https://github.com/TresysTechnology/refpolicy/wiki/GettingStarted">https://github.com/TresysTechnology/refpolicy/wiki/GettingStarted</a>).</p>
+<p>hwloc-dump-hwdata requires <code>dmi-sysfs</code> kernel module loaded.</p>
+<p>The utility is currently unneeded on platforms without Intel Xeon Phi processors.</p>
+<p>See <code>HWLOC_DUMPED_HWDATA_DIR</code> in <a class="el" href="a00378.html">Environment Variables</a> for details about the location of dumped files.</p>
+<h2><a class="anchor" id="faq_bgq"></a>
+How do I build hwloc for BlueGene/Q?</h2>
+<p>IBM BlueGene/Q machines run a standard Linux on the login/frontend nodes and a custom CNK (<em>Compute Node Kernel</em>) on the compute nodes.</p>
+<p>To discover the topology of a login/frontend node, hwloc should be configured as usual, without any BlueGene/Q-specific option.</p>
+<p>However, one would likely rather discover the topology of the compute nodes where parallel jobs are actually running. If so, hwloc must be cross-compiled with the following configuration line: </p><pre class="fragment">./configure --host=powerpc64-bgq-linux --disable-shared --enable-static \
+  CPPFLAGS='-I/bgsys/drivers/ppcfloor -I/bgsys/drivers/ppcfloor/spi/include/kernel/cnk/'
+</pre><p>CPPFLAGS may have to be updated if your platform headers are installed in a different directory.</p>
+<h2><a class="anchor" id="faq_windows"></a>
+How do I build hwloc for Windows?</h2>
+<p><b>hwloc binary releases for Windows are available on the website download pages</b> (as pre-built ZIPs for both 32bits and 64bits x86 platforms). However hwloc also offers several ways to build on Windows:</p>
+<ul>
+<li>
+The usual Unix build steps (<code>configure</code>, <code>make</code> and <code>make install</code>) work on the <b>MSYS2/MinGW</b> environment on Windows (the official hwloc binary releases are built this way). Some environment variables and options must be configured, see <code>contrib/ci.inria.fr/job-3-mingw.sh</code> in the hwloc repository for an example (used for nightly testing).  </li>
+<li>
+hwloc also supports such Unix-like builds in <b>Cygwin</b> (environment for porting Unix code to Windows).  </li>
+<li>
+Windows build is also possible with <b>CMake</b> (<code>CMakeLists.txt</code> available under <code>contrib/windows-cmake/</code>).  </li>
+<li>
+hwloc also comes with an example of <b>Microsoft Visual Studio solution</b> (under <code>contrib/windows/</code>) that may serve as a base for custom builds.  </li>
+</ul>
+<h2><a class="anchor" id="faq_netbsd_bind"></a>
+How to get useful topology information on NetBSD?</h2>
+<p>The NetBSD (and FreeBSD) backend uses x86-specific topology discovery (through the x86 component). This implementation requires CPU binding so as to query topology information from each individual processor. This means that hwloc cannot find any useful topology information unless user-level process binding is allowed by the NetBSD kernel. The <code>security.models.extensions.user_set_cpu_affinity</code> sysctl variable must be set to 1 to do so. Otherwise, only the number of processors will be detected.</p>
+<h2><a class="anchor" id="faq_aix_bind"></a>
+Why does binding fail on AIX?</h2>
+<p>The AIX operating system requires specific user capabilities for attaching processes to resource sets (CAP_NUMA_ATTACH). Otherwise functions such as <a class="el" href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48" title="Bind current process or thread on CPUs given in physical bitmap set.">hwloc_set_cpubind()</a> fail (return -1 with errno set to EPERM).</p>
+<p>This capability must also be inherited (through the additional CAP_PROPAGATE capability) if you plan to bind a process before forking another process, for instance with <code>hwloc-bind</code>.</p>
+<p>These capabilities may be given by the administrator with: </p><pre class="fragment">chuser "capabilities=CAP_PROPAGATE,CAP_NUMA_ATTACH" &lt;username&gt;
+</pre><h1><a class="anchor" id="faq5"></a>
+Compatibility between hwloc versions</h1>
+<h2><a class="anchor" id="faq_version_api"></a>
+How do I handle API changes?</h2>
+<p>The hwloc interface is extended with every new major release. Any application using the hwloc API should be prepared to check at compile-time whether some features are available in the currently installed hwloc distribution.</p>
+<p>For instance, to check whether the hwloc version is at least 2.0, you should use: </p><pre class="fragment">#include &lt;hwloc.h&gt;
+#if HWLOC_API_VERSION &gt;= 0x00020000
+...
+#endif
+</pre><p>To check for the API of release X.Y.Z at build time, you may compare <a class="el" href="a00171.html#ga8f4dfb8eef138af55dd1a0fa802e5476" title="Indicate at build time which hwloc API version is being used.">HWLOC_API_VERSION</a> with <code>(X&lt;&lt;16)+(Y&lt;&lt;8)+Z</code>.</p>
+<p>For supporting older releases that do not have <code>HWLOC_OBJ_NUMANODE</code> and <code>HWLOC_OBJ_PACKAGE</code> yet, you may use:</p>
+<pre class="fragment">#include &lt;hwloc.h&gt;
+#if HWLOC_API_VERSION &lt; 0x00010b00
+#define HWLOC_OBJ_NUMANODE HWLOC_OBJ_NODE
+#define HWLOC_OBJ_PACKAGE HWLOC_OBJ_SOCKET
+#endif
+</pre><p>Once a program is built against a hwloc library, it may also dynamically link with compatible libraries from other hwloc releases. The version of that runtime library may be queried with <a class="el" href="a00171.html#ga9c0b50c98add1adf57ed1ce85bb5190d" title="Indicate at runtime which hwloc API version was used at build time.">hwloc_get_api_version()</a>. For instance, the following code enables the topology flag <a class="el" href="a00182.html#ggada025d3ec20b4b420f8038d23d6e7bdea5796b4909eba80f9727b66d07d3a7a05" title="Ignore distances.">HWLOC_TOPOLOGY_FLAG_NO_DISTANCES</a> when compiling on hwloc 2.8 or later, but it disables it at runtime if running on an older hwloc (otherwise <a class="el" href="a00182.html#gaaeed4df656979e5f16befea9d29b814b" title="Set OR&#39;ed flags to non-yet-loaded topology.">hwloc_topology_set_flags()</a> would fail).</p>
+<pre class="fragment">unsigned long topology_flags = ...; /* wanted flags that were supported before 2.8 */
+#if HWLOC_API_VERSION &gt;= 0x20800
+if (hwloc_get_api_version() &gt;= 0x20800)
+  topology_flags |= HWLOC_TOPOLOGY_FLAG_NO_DISTANCES; /* wanted flags only supported in 2.8+ */
+#endif
+hwloc_topology_set_flags(topology, topology_flags);
+</pre><p>See also <a class="el" href="a00391.html#faq_version_abi">How do I handle ABI breaks?</a> for using <a class="el" href="a00171.html#ga9c0b50c98add1adf57ed1ce85bb5190d" title="Indicate at runtime which hwloc API version was used at build time.">hwloc_get_api_version()</a> for testing ABI compatibility.</p>
+<h2><a class="anchor" id="faq_version"></a>
+What is the difference between API and library version numbers?</h2>
+<p><a class="el" href="a00171.html#ga8f4dfb8eef138af55dd1a0fa802e5476" title="Indicate at build time which hwloc API version is being used.">HWLOC_API_VERSION</a> is the version of the API. It changes when functions are added, modified, etc. However it does not necessarily change from one release to another. For instance, two releases of the same series (e.g. 2.0.3 and 2.0.4) usually have the same <a class="el" href="a00171.html#ga8f4dfb8eef138af55dd1a0fa802e5476" title="Indicate at build time which hwloc API version is being used.">HWLOC_API_VERSION</a> (<code>0x00020000</code>). However their HWLOC_VERSION strings are different (<code>"2.0.3"</code> and <code>"2.0.4"</code> respectively).</p>
+<h2><a class="anchor" id="faq_version_abi"></a>
+How do I handle ABI breaks?</h2>
+<p>The hwloc interface was deeply modified in release 2.0 to fix several issues of the 1.x interface (see <a class="el" href="a00392.html">Upgrading to the hwloc 2.0 API</a> and the NEWS file in the source directory for details). The ABI was broken, which means <b>applications must be recompiled against the new 2.0 interface</b>.</p>
+<p>To check that you are not mixing old/recent headers with a recent/old runtime library, check the major revision number in the API version: </p><pre class="fragment">#include &lt;hwloc.h&gt;
+  unsigned version = hwloc_get_api_version();
+  if ((version &gt;&gt; 16) != (HWLOC_API_VERSION &gt;&gt; 16)) {
+    fprintf(stderr,
+           "%s compiled for hwloc API 0x%x but running on library API 0x%x.\n"
+           "You may need to point LD_LIBRARY_PATH to the right hwloc library.\n"
+           "Aborting since the new ABI is not backward compatible.\n",
+           callname, HWLOC_API_VERSION, version);
+    exit(EXIT_FAILURE);
+  }
+</pre><p> To specifically detect v2.0 issues: </p><pre class="fragment">#include &lt;hwloc.h&gt;
+#if HWLOC_API_VERSION &gt;= 0x00020000
+  /* headers are recent */
+  if (hwloc_get_api_version() &lt; 0x20000)
+    ... error out, the hwloc runtime library is older than 2.0 ...
+#else
+  /* headers are pre-2.0 */
+  if (hwloc_get_api_version() &gt;= 0x20000)
+    ... error out, the hwloc runtime library is more recent than 2.0 ...
+#endif
+</pre><p>In theory, library sonames prevent linking with incompatible libraries. However custom hwloc installations or improperly configured build environments may still lead to such issues. Hence running one of the above (cheap) checks before initializing hwloc topology may be useful.</p>
+<h2><a class="anchor" id="faq_version_xml"></a>
+Are XML topology files compatible between hwloc releases?</h2>
+<p>XML topology files are forward-compatible: a XML file may be loaded by a hwloc library that is more recent than the hwloc release that exported that file.</p>
+<p>However, hwloc XMLs are not always backward-compatible: Topologies exported by hwloc 2.x cannot be imported by 1.x by default (see <a class="el" href="a00392.html#upgrade_to_api_2x_xml">XML changes</a> for working around such issues). There are also some corner cases where backward compatibility is not guaranteed because of changes between major releases (for instance 1.11 XMLs could not be imported in 1.10).</p>
+<p>XMLs are exchanged at runtime between some components of the HPC software stack (for instance the resource managers and MPI processes). Building all these components on the same (cluster-wide) hwloc installation is a good way to avoid such incompatibilities.</p>
+<h2><a class="anchor" id="faq_version_synthetic"></a>
+Are synthetic strings compatible between hwloc releases?</h2>
+<p>Synthetic strings (see <a class="el" href="a00386.html">Synthetic topologies</a>) are forward-compatible: a synthetic string generated by a release may be imported by future hwloc libraries.</p>
+<p>However they are often not backward-compatible because new details may have been added to synthetic descriptions in recent releases. Some flags may be given to <a class="el" href="a00196.html#ga24b7864a1c588309c4749f621f03b4c7" title="Export the topology as a synthetic string.">hwloc_topology_export_synthetic()</a> to avoid such details and stay backward compatible.</p>
+<h2><a class="anchor" id="faq_version_shmem"></a>
+Is it possible to share a shared-memory topology between different hwloc releases?</h2>
+<p>Shared-memory topologies (see <a class="el" href="a00218.html">Sharing topologies between processes</a>) have strong requirements on compatibility between hwloc libraries. Adopting a shared-memory topology fails if it was exported by a non-compatible hwloc release. Releases with same major revision are usually compatible (e.g. hwloc 2.0.4 may adopt a topology exported by 2.0.3) but different major revisions may be incompatible (e.g. hwloc 2.1.0 cannot adopt from 2.0.x).</p>
+<p>Topologies are shared at runtime between some components of the HPC software stack (for instance the resource managers and MPI processes). Building all these components on the same (system-wide) hwloc installation is a good way to avoid such incompatibilities. </p>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/a00392.html 2.11.0-1/doc/doxygen-doc/html/a00392.html
--- 2.10.0-1/doc/doxygen-doc/html/a00392.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/a00392.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,309 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Upgrading to the hwloc 2.0 API</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Upgrading to the hwloc 2.0 API</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><p>See <a class="el" href="a00391.html#faq5">Compatibility between hwloc versions</a> for detecting the hwloc version that you are compiling and/or running against.</p>
+<h1><a class="anchor" id="upgrade_to_api_2x_memory"></a>
+New Organization of NUMA nodes and Memory</h1>
+<h2><a class="anchor" id="upgrade_to_api_2x_memory_children"></a>
+Memory children</h2>
+<p>In hwloc v1.x, NUMA nodes were inside the tree, for instance Packages contained 2 NUMA nodes which contained a L3 and several cache.</p>
+<p>Starting with hwloc v2.0, NUMA nodes are not in the main tree anymore. They are attached under objects as <em>Memory Children</em> on the side of normal children. This memory children list starts at <code>obj-&gt;memory_first_child</code> and its size is <code>obj-&gt;memory_arity</code>. Hence there can now exist two local NUMA nodes, for instance on Intel Xeon Phi processors.</p>
+<p>The normal list of children (starting at <code>obj-&gt;first_child</code>, ending at <code>obj-&gt;last_child</code>, of size <code>obj-&gt;arity</code>, and available as the array <code>obj-&gt;children</code>) now only contains CPU-side objects: PUs, Cores, Packages, Caches, Groups, Machine and System. <a class="el" href="a00187.html#ga12d8565a3436c565e791ed02a0353621" title="Return the next child.">hwloc_get_next_child()</a> may still be used to iterate over all children of all lists.</p>
+<p>Hence the CPU-side hierarchy is built using normal children, while memory is attached to that hierarchy depending on its affinity.</p>
+<h2><a class="anchor" id="upgrade_to_api_2x_memory_examples"></a>
+Examples</h2>
+<ul>
+<li>
+<p class="startli">a UMA machine with 2 packages and a single NUMA node is now modeled as a "Machine" object with two "Package" children and one "NUMANode" memory children (displayed first in lstopo below): </p><pre class="fragment">Machine (1024MB total)
+  NUMANode L#0 (P#0 1024MB)
+  Package L#0
+    Core L#0 + PU L#0 (P#0)
+    Core L#1 + PU L#1 (P#1)
+  Package L#1
+    Core L#2 + PU L#2 (P#2)
+    Core L#3 + PU L#3 (P#3)
+</pre> <p class="endli"></p>
+</li>
+<li>
+<p class="startli">a machine with 2 packages with one NUMA node and 2 cores in each is now: </p><pre class="fragment">Machine (2048MB total)
+  Package L#0
+    NUMANode L#0 (P#0 1024MB)
+    Core L#0 + PU L#0 (P#0)
+    Core L#1 + PU L#1 (P#1)
+  Package L#1
+    NUMANode L#1 (P#1 1024MB)
+    Core L#2 + PU L#2 (P#2)
+    Core L#3 + PU L#3 (P#3)
+</pre> <p class="endli"></p>
+</li>
+<li>
+<p class="startli">if there are two NUMA nodes per package, a Group object may be added to keep cores together with their local NUMA node: </p><pre class="fragment">Machine (4096MB total)
+  Package L#0
+    Group0 L#0
+      NUMANode L#0 (P#0 1024MB)
+      Core L#0 + PU L#0 (P#0)
+      Core L#1 + PU L#1 (P#1)
+    Group0 L#1
+      NUMANode L#1 (P#1 1024MB)
+      Core L#2 + PU L#2 (P#2)
+      Core L#3 + PU L#3 (P#3)
+  Package L#1
+    [...]
+</pre> <p class="endli"></p>
+</li>
+<li>
+if the platform has L3 caches whose localities are identical to NUMA nodes, Groups aren't needed: <pre class="fragment">Machine (4096MB total)
+  Package L#0
+    L3 L#0 (16MB)
+      NUMANode L#0 (P#0 1024MB)
+      Core L#0 + PU L#0 (P#0)
+      Core L#1 + PU L#1 (P#1)
+    L3 L#1 (16MB)
+      NUMANode L#1 (P#1 1024MB)
+      Core L#2 + PU L#2 (P#2)
+      Core L#3 + PU L#3 (P#3)
+  Package L#1
+    [...]
+</pre>  </li>
+</ul>
+<h2><a class="anchor" id="upgrade_to_api_2x_numa_level"></a>
+NUMA level and depth</h2>
+<p>NUMA nodes are not in "main" tree of normal objects anymore. Hence, they don't have a meaningful depth anymore (like I/O and Misc objects). They have a virtual (negative) depth (<a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a245c34ec9884c2cf5de5049b2153ed9c" title="Virtual depth for NUMA nodes.">HWLOC_TYPE_DEPTH_NUMANODE</a>) so that functions manipulating depths and level still work, and so that we can still iterate over the level of NUMA nodes just like for any other level.</p>
+<p>For instance we can still use lines such as </p><pre class="fragment">int depth = hwloc_get_type_depth(topology, HWLOC_OBJ_NUMANODE);
+hwloc_obj_t obj = hwloc_get_obj_by_type(topology, HWLOC_OBJ_NUMANODE, 4);
+hwloc_obj_t node = hwloc_get_next_obj_by_depth(topology, HWLOC_TYPE_DEPTH_NUMANODE, prev);
+</pre><p>The NUMA depth should not be compared with others. An unmodified code that still compares NUMA and Package depths (to find out whether Packages contain NUMA or the contrary) would now always assume Packages contain NUMA (because the NUMA depth is negative).</p>
+<p>However, the depth of the Normal parents of NUMA nodes may be used instead. In the last example above, NUMA nodes are attached to L3 caches, hence one may compare the depth of Packages and L3 to find out that NUMA nodes are contained in Packages. This depth of parents may be retrieved with <a class="el" href="a00176.html#gae85786340b88e24835f8c403a1e2e54b" title="Return the depth of parents where memory objects are attached.">hwloc_get_memory_parents_depth()</a>. However, this function may return <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c" title="Objects of given type exist at different depth in the topology (only for Groups).">HWLOC_TYPE_DEPTH_MULTIPLE</a> on future platforms if NUMA nodes are attached to different levels.</p>
+<h2><a class="anchor" id="upgrade_to_api_2x_memory_find"></a>
+Finding Local NUMA nodes and looking at Children and Parents</h2>
+<p>Applications that walked up/down to find NUMANode parent/children must now be updated. Instead of looking directly for a NUMA node, one should now look for an object that has some memory children. NUMA node(s) will be attached there. For instance, when looking for a NUMA node above a given core <code>core</code>: </p><pre class="fragment">hwloc_obj_t parent = core-&gt;parent;
+while (parent &amp;&amp; !parent-&gt;memory_arity)
+  parent = parent-&gt;parent; /* no memory child, walk up */
+if (parent)
+  /* use parent-&gt;memory_first_child (and its siblings if there are multiple local NUMA nodes) */
+</pre><p>The list of local NUMA nodes (usually a single one) is also described by the <code>nodeset</code> attribute of each object (which contains the physical indexes of these nodes). Iterating over the NUMA level is also an easy way to find local NUMA nodes: </p><pre class="fragment">hwloc_obj_t tmp = NULL;
+while ((tmp = hwloc_get_next_obj_by_type(topology, HWLOC_OBJ_NUMANODE, tmp)) != NULL) {
+  if (hwloc_bitmap_isset(obj-&gt;nodeset, tmp-&gt;os_index))
+    /* tmp is a NUMA node local to obj, use it */
+}
+</pre><p>Similarly finding objects that are close to a given NUMA nodes should be updated too. Instead of looking at the NUMA node parents/children, one should now find a Normal parent above that NUMA node, and then look at its parents/children as usual: </p><pre class="fragment">hwloc_obj_t tmp = obj-&gt;parent;
+while (hwloc_obj_type_is_memory(tmp))
+  tmp = tmp-&gt;parent;
+/* now use tmp instead of obj */
+</pre><p>To avoid such hwloc v2.x-specific and NUMA-specific cases in the code, a <b>generic lookup for any kind of object, including NUMA nodes</b>, might also be implemented by iterating over a level. For instance finding an object of type <code>type</code> which either contains or is included in object <code>obj</code> can be performed by traversing the level of that type and comparing CPU sets: </p><pre class="fragment">hwloc_obj_t tmp = NULL;
+while ((tmp = hwloc_get_next_obj_by_type(topology, type, tmp)) != NULL) {
+  if (hwloc_bitmap_intersects(tmp-&gt;cpuset, obj-&gt;cpuset))
+    /* tmp matches, use it */
+}
+</pre><p> <b> This generic lookup works whenever <code>type</code> or <code>obj</code> are Normal or Memory objects since both have CPU sets. Moreover, it is compatible with the hwloc v1.x API. </b></p>
+<h1><a class="anchor" id="upgrade_to_api_2x_children"></a>
+4 Kinds of Objects and Children</h1>
+<h2><a class="anchor" id="upgrade_to_api_2x_io_misc_children"></a>
+I/O and Misc children</h2>
+<p>I/O children are not in the main object children list anymore either. They are in the list starting at <code>obj-&gt;io_first_child</code> and its size is <code>obj-&gt;io_arity</code>.</p>
+<p>Misc children are not in the main object children list anymore. They are in the list starting at <code>obj-&gt;misc_first_child</code> and its size is <code>obj-&gt;misc_arity</code>.</p>
+<p>See <a class="el" href="a00229.html" title="Structure of a topology object.">hwloc_obj</a> for details about children lists.</p>
+<p><a class="el" href="a00187.html#ga12d8565a3436c565e791ed02a0353621" title="Return the next child.">hwloc_get_next_child()</a> may still be used to iterate over all children of all lists.</p>
+<h2><a class="anchor" id="upgrade_to_api_2x_kinds_subsec"></a>
+Kinds of objects</h2>
+<p>Given the above, objects may now be of 4 kinds: </p><ul>
+<li>
+Normal (everything not listed below, including Machine, Package, Core, PU, CPU Caches, etc); </li>
+<li>
+Memory (currently NUMA nodes or Memory-side Caches), attached to parents as Memory children; </li>
+<li>
+I/O (Bridges, PCI and OS devices), attached to parents as I/O children; </li>
+<li>
+Misc objects, attached to parents as Misc children. </li>
+</ul>
+<p>See <a class="el" href="a00229.html" title="Structure of a topology object.">hwloc_obj</a> for details about children lists.</p>
+<p>For a given object type, the kind may be found with <a class="el" href="a00184.html#ga52ef38431eba383b048b98c669b59a16" title="Check whether an object type is Normal.">hwloc_obj_type_is_normal()</a>, <a class="el" href="a00184.html#ga1d074390c8a3dc3088d84f73fb73f966" title="Check whether an object type is Memory.">hwloc_obj_type_is_memory()</a>, <a class="el" href="a00184.html#ga52ef38431eba383b048b98c669b59a16" title="Check whether an object type is Normal.">hwloc_obj_type_is_normal()</a>, or comparing with <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d" title="Miscellaneous objects (filtered out by default). Objects without particular meaning,...">HWLOC_OBJ_MISC</a>.</p>
+<p>Normal and Memory objects have (non-NULL) CPU sets and nodesets, while I/O and Misc objects don't have any sets (they are NULL).</p>
+<h1><a class="anchor" id="upgrade_to_api_2x_cache"></a>
+HWLOC_OBJ_CACHE replaced</h1>
+<p>Instead of a single HWLOC_OBJ_CACHE, there are now 8 types <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a56389b8eb2e2f74f288bb657c4e72140" title="Level 1 Data (or Unified) Cache.">HWLOC_OBJ_L1CACHE</a>, ..., <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a67194c9de5e3e581c64c11d2eb1c109d" title="Level 5 Data (or Unified) Cache.">HWLOC_OBJ_L5CACHE</a>, <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55afa834a85d9e53836cf0db6d0bd8329b4" title="Level 1 instruction Cache (filtered out by default).">HWLOC_OBJ_L1ICACHE</a>, ..., <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ac22850c717f07bf7ffb316fadd08d218" title="Level 3 instruction Cache (filtered out by default).">HWLOC_OBJ_L3ICACHE</a>.</p>
+<p>Cache object attributes are unchanged.</p>
+<p><a class="el" href="a00188.html#gad108a09ce400222fe45545257d575489" title="Find the depth of cache objects matching cache level and type.">hwloc_get_cache_type_depth()</a> is not needed to disambiguate cache types anymore since new types can be passed to <a class="el" href="a00176.html#ga8bec782e21be313750da70cf7428b374" title="Returns the depth of objects of type type.">hwloc_get_type_depth()</a> without ever getting <a class="el" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c" title="Objects of given type exist at different depth in the topology (only for Groups).">HWLOC_TYPE_DEPTH_MULTIPLE</a> anymore.</p>
+<p><a class="el" href="a00184.html#ga2ed589bea28711e80b92066510a5607d" title="Check whether an object type is a CPU Cache (Data, Unified or Instruction).">hwloc_obj_type_is_cache()</a>, <a class="el" href="a00184.html#ga395e48cd221d107e5891689624e1aec4" title="Check whether an object type is a CPU Data or Unified Cache.">hwloc_obj_type_is_dcache()</a> and <a class="el" href="a00184.html#ga8abcee67b9b074332c1866405a3648a9" title="Check whether an object type is a CPU Instruction Cache,.">hwloc_obj_type_is_icache()</a> may be used to check whether a given type is a cache, data/unified cache or instruction cache.</p>
+<h1><a class="anchor" id="upgrade_to_api_2x_allowed"></a>
+allowed_cpuset and allowed_nodeset only in the main topology</h1>
+<p>Objects do not have <code>allowed_cpuset</code> and <code>allowed_nodeset</code> anymore. They are only available for the entire topology using <a class="el" href="a00191.html#ga517d5d68ec9f24583d8933aab713be8e" title="Get allowed CPU set.">hwloc_topology_get_allowed_cpuset()</a> and <a class="el" href="a00191.html#ga21a4d7237a11e76b912ed4524ab78cbd" title="Get allowed node set.">hwloc_topology_get_allowed_nodeset()</a>.</p>
+<p>As usual, those are only needed when the INCLUDE_DISALLOWED topology flag is given, which means disallowed objects are kept in the topology. If so, one may find out whether some PUs inside an object is allowed by checking </p><pre class="fragment">hwloc_bitmap_intersects(obj-&gt;cpuset, hwloc_topology_get_allowed_cpuset(topology))
+</pre><p> Replace cpusets with nodesets for NUMA nodes. To find out which ones, replace intersects() with and() to get the actual intersection.</p>
+<h1><a class="anchor" id="upgrade_to_api_2x_depth"></a>
+Object depths are now signed int</h1>
+<p><code>obj-&gt;depth</code> as well as depths given to functions such as <a class="el" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0" title="Returns the topology object at logical index idx from depth depth.">hwloc_get_obj_by_depth()</a> or returned by <a class="el" href="a00176.html#gae54d1782ca9b54bea915f5c18a9158fa" title="Get the depth of the hierarchical tree of objects.">hwloc_topology_get_depth()</a> are now <b>signed int</b>.</p>
+<p>Other depth such as cache-specific depth attribute are still unsigned.</p>
+<h1><a class="anchor" id="upgrade_to_api_2x_memory_attrs"></a>
+Memory attributes become NUMANode-specific</h1>
+<p>Memory attributes such as <code>obj-&gt;memory.local_memory</code> are now only available in NUMANode-specific attributes in <code>obj-&gt;attr-&gt;numanode.local_memory</code>.</p>
+<p><code>obj-&gt;memory.total_memory</code> is available in all objects as <code>obj-&gt;total_memory</code>.</p>
+<p>See <a class="el" href="a00237.html" title="NUMA node-specific Object Attributes.">hwloc_obj_attr_u::hwloc_numanode_attr_s</a> and <a class="el" href="a00229.html" title="Structure of a topology object.">hwloc_obj</a> for details.</p>
+<h1><a class="anchor" id="upgrade_to_api_2x_config"></a>
+Topology configuration changes</h1>
+<p>The old ignoring API as well as several configuration flags are replaced with the new filtering API, see <a class="el" href="a00182.html#gad894e70f15f8d4aada7be8d1aba38b7e" title="Set the filtering for the given object type.">hwloc_topology_set_type_filter()</a> and its variants, and <a class="el" href="a00182.html#ga9a5a1f0140cd1952544477833733195b" title="Type filtering flags.">hwloc_type_filter_e</a> for details.</p>
+<ul>
+<li>
+<p class="startli">hwloc_topology_ignore_type(), hwloc_topology_ignore_type_keep_structure() and hwloc_topology_ignore_all_keep_structure() are respectively superseded by </p><pre class="fragment">hwloc_topology_set_type_filter(topology, type, HWLOC_TYPE_FILTER_KEEP_NONE);
+hwloc_topology_set_type_filter(topology, type, HWLOC_TYPE_FILTER_KEEP_STRUCTURE);
+hwloc_topology_set_all_types_filter(topology, HWLOC_TYPE_FILTER_KEEP_STRUCTURE);
+</pre><p class="interli">Also, the meaning of KEEP_STRUCTURE has changed (only entire levels may be ignored, instead of single objects), the old behavior is not available anymore. </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli">HWLOC_TOPOLOGY_FLAG_ICACHES is superseded by </p><pre class="fragment">hwloc_topology_set_icache_types_filter(topology, HWLOC_TYPE_FILTER_KEEP_ALL);
+</pre> <p class="endli"></p>
+</li>
+<li>
+<p class="startli">HWLOC_TOPOLOGY_FLAG_WHOLE_IO, HWLOC_TOPOLOGY_FLAG_IO_DEVICES and HWLOC_TOPOLOGY_FLAG_IO_BRIDGES replaced.</p>
+<p class="interli">To keep all I/O devices (PCI, Bridges, and OS devices), use: </p><pre class="fragment">hwloc_topology_set_io_types_filter(topology, HWLOC_TYPE_FILTER_KEEP_ALL);
+</pre><p class="interli">To only keep important devices (Bridges with children, common PCI devices and OS devices): </p><pre class="fragment">hwloc_topology_set_io_types_filter(topology, HWLOC_TYPE_FILTER_KEEP_IMPORTANT);
+</pre> <p class="endli"></p>
+</li>
+</ul>
+<h1><a class="anchor" id="upgrade_to_api_2x_xml"></a>
+XML changes</h1>
+<p>2.0 XML files are not compatible with 1.x</p>
+<p>2.0 can load 1.x files, but only NUMA distances are imported. Other distance matrices are ignored (they were never used by default anyway).</p>
+<p>2.0 can export 1.x-compatible files, but only distances attached to the root object are exported (i.e. distances that cover the entire machine). Other distance matrices are dropped (they were never used by default anyway).</p>
+<p><b>Users are advised to negociate hwloc versions between exporter and importer:</b> If the importer isn't 2.x, the exporter should export to 1.x. Otherwise, things should work by default.</p>
+<p>Hence <a class="el" href="a00195.html#ga333f79975b4eeb28a3d8fad3373583ce" title="Export the topology into an XML file.">hwloc_topology_export_xml()</a> and <a class="el" href="a00195.html#gad33b7f7c11db10459505a3b1634fd3f1" title="Export the topology into a newly-allocated XML memory buffer.">hwloc_topology_export_xmlbuffer()</a> have a new flags argument. to force a hwloc-1.x-compatible XML export. </p><ul>
+<li>
+If both always support 2.0, don't pass any flag.  </li>
+<li>
+When the importer uses hwloc 1.x, export with <a class="el" href="a00195.html#gga0eb99636aff71fe2704e1fa0ffe8c18dae7d6d96546131ef0043867b836b02e0f" title="Export XML that is loadable by hwloc v1.x. However, the export may miss some details about the topolo...">HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1</a>. Otherwise the importer will fail to import.  </li>
+<li>
+When the exporter uses hwloc 1.x, it cannot pass any flag, and a 2.0 importer can import without problem.  </li>
+</ul>
+<pre class="fragment">#if HWLOC_API_VERSION &gt;= 0x20000
+   if (need 1.x compatible XML export)
+      hwloc_topology_export_xml(...., HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1);
+   else /* need 2.x compatible XML export */
+      hwloc_topology_export_xml(...., 0);
+#else
+   hwloc_topology_export_xml(....);
+#endif
+</pre><p>Additionally, <a class="el" href="a00217.html#ga2cd902ce8766e90d4f2523a8e87640e9" title="Load a list of topology differences from a XML file.">hwloc_topology_diff_load_xml()</a>, <a class="el" href="a00217.html#gad693810a5c51628529b9dd56f040fb81" title="Load a list of topology differences from a XML buffer.">hwloc_topology_diff_load_xmlbuffer()</a>, <a class="el" href="a00217.html#ga8a14dd7d01efbdd97af7fe85e8b84b20" title="Export a list of topology differences to a XML file.">hwloc_topology_diff_export_xml()</a>, <a class="el" href="a00217.html#gaa2f0918df60c1c4a0bef9411f7d92a13" title="Export a list of topology differences to a XML buffer.">hwloc_topology_diff_export_xmlbuffer()</a> and <a class="el" href="a00217.html#ga5dcff18f80583ac6505a94ba2877fd1b" title="Destroy a list of topology differences.">hwloc_topology_diff_destroy()</a> lost the topology argument: The first argument (topology) isn't needed anymore.</p>
+<h1><a class="anchor" id="upgrade_to_api_2x_distances"></a>
+Distances API totally rewritten</h1>
+<p>The new distances API is in <a class="el" href="a00116_source.html">hwloc/distances.h</a>.</p>
+<p>Distances are not accessible directly from objects anymore. One should first call <a class="el" href="a00197.html#ga613e6b2a5d0f06626ee8d0c12fa46691" title="Retrieve distance matrices.">hwloc_distances_get()</a> (or a variant) to retrieve distances (possibly with one call to get the number of available distances structures, and another call to actually get them). Then it may consult these structures, and finally release them.</p>
+<p>The set of object involved in a distances structure is specified by an array of objects, it may not always cover the entire machine or so.</p>
+<h1><a class="anchor" id="upgrade_to_api_2x_return"></a>
+Return values of functions</h1>
+<p>Bitmap functions (and a couple other functions) can return errors (in theory).</p>
+<p>Most bitmap functions may have to reallocate the internal bitmap storage. In v1.x, they would silently crash if realloc failed. In v2.0, they now return an int that can be negative on error. However, the preallocated storage is 512 bits, hence realloc will not even be used unless you run hwloc on machines with larger PU or NUMAnode indexes.</p>
+<p><a class="el" href="a00178.html#gace7654bb8a9002caae1a4b8a59e7452e" title="Add the given name and value pair to the given object info attributes.">hwloc_obj_add_info()</a>, <a class="el" href="a00192.html#gad5ee8691e08a3538ea7633344c00456d" title="Convert a NUMA node set into a CPU set.">hwloc_cpuset_from_nodeset()</a> and <a class="el" href="a00192.html#gad5ee8691e08a3538ea7633344c00456d" title="Convert a NUMA node set into a CPU set.">hwloc_cpuset_from_nodeset()</a> also return an int, which would be -1 in case of allocation errors.</p>
+<h1><a class="anchor" id="upgrade_to_api_2x_misc"></a>
+Misc API changes</h1>
+<ul>
+<li>
+<p class="startli"><a class="el" href="a00177.html#ga510f21b066fba2dab12b8c9b173b1dfd" title="Return an object type and attributes from a type string.">hwloc_type_sscanf()</a> extends hwloc_obj_type_sscanf() by passing a union <a class="el" href="a00233.html" title="Object type-specific Attributes.">hwloc_obj_attr_u</a> which may receive Cache, Group, Bridge or OS device attributes. </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli"><a class="el" href="a00177.html#ga52c63cd7203e55b804c1314affc9bd12" title="Return an object type and its level depth from a type string.">hwloc_type_sscanf_as_depth()</a> is also added to directly return the corresponding level depth within a topology. </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli">hwloc_topology_insert_misc_object_by_cpuset() is replaced with <a class="el" href="a00183.html#ga4cea4741165faf5323931a9ed8786ef7" title="Allocate a Group object to insert later with hwloc_topology_insert_group_object().">hwloc_topology_alloc_group_object()</a> and <a class="el" href="a00183.html#ga1fc6012b3e1c249b83f48cb7bcacaa5b" title="Add more structure to the topology by adding an intermediate Group.">hwloc_topology_insert_group_object()</a>. </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli">hwloc_topology_insert_misc_object_by_parent() is replaced with <a class="el" href="a00183.html#gad980782ade737900c5cf208946768c30" title="Add a MISC object as a leaf of the topology.">hwloc_topology_insert_misc_object()</a>. </p>
+<p class="endli"></p>
+</li>
+</ul>
+<h1><a class="anchor" id="upgrade_to_api_2x_removals"></a>
+API removals and deprecations</h1>
+<ul>
+<li>
+<p class="startli">HWLOC_OBJ_SYSTEM removed: The root object is always <a class="el" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a3f4e83ffc4a259354959ae8a9eaa2a80" title="Machine. A set of processors and memory with cache coherency.">HWLOC_OBJ_MACHINE</a> </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli">_membind_nodeset() memory binding interfaces deprecated: One should use the variant without _nodeset suffix and pass the <a class="el" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256" title="Consider the bitmap argument as a nodeset.">HWLOC_MEMBIND_BYNODESET</a> flag. </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli">HWLOC_MEMBIND_REPLICATE removed: no supported operating system supports it anymore. </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli">hwloc_obj_snprintf() removed because it was long-deprecated by <a class="el" href="a00177.html#gadb8765c260edea80c52cd06a76639ba4" title="Stringify the type of a given topology object into a human-readable form.">hwloc_obj_type_snprintf()</a> and <a class="el" href="a00177.html#ga870e876931c282a1c7aee2f031912ce3" title="Stringify the attributes of a given topology object into a human-readable form.">hwloc_obj_attr_snprintf()</a>. </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli">hwloc_obj_type_sscanf() deprecated, hwloc_obj_type_of_string() removed. </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli">hwloc_cpuset_from/to_nodeset_strict() deprecated: Now useless since all topologies are NUMA. Use the variant without the _strict suffix </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli">hwloc_distribute() and hwloc_distributev() removed, deprecated by <a class="el" href="a00190.html#ga7b0c28f797c2ff17fa2f244ebbd55b33" title="Distribute n items over the topology under roots.">hwloc_distrib()</a>. </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli">The Custom interface (hwloc_topology_set_custom(), etc.) was removed, as well as the corresponding command-line tools (hwloc-assembler, etc.). Topologies always start with object with valid cpusets and nodesets. </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli"><code>obj-&gt;online_cpuset</code> removed: Offline PUs are simply listed in the <code>complete_cpuset</code> as previously. </p>
+<p class="endli"></p>
+</li>
+<li>
+<p class="startli"><code>obj-&gt;os_level</code> removed. </p>
+<p class="endli"></p>
+</li>
+</ul>
+</div></div><!-- contents -->
+</div><!-- PageDoc -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/annotated.html 2.11.0-1/doc/doxygen-doc/html/annotated.html
--- 2.10.0-1/doc/doxygen-doc/html/annotated.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/annotated.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,87 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Data Structures</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">Data Structures</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock">Here are the data structures with brief descriptions:</div><div class="directory">
+<div class="levels">[detail level <span onclick="javascript:toggleLevel(1);">1</span><span onclick="javascript:toggleLevel(2);">2</span><span onclick="javascript:toggleLevel(3);">3</span>]</div><table class="directory">
+<tr id="row_0_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00369.html" target="_self">hwloc_backend</a></td><td class="desc">Discovery backend structure </td></tr>
+<tr id="row_1_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00313.html" target="_self">hwloc_cl_device_pci_bus_info_khr</a></td><td class="desc"></td></tr>
+<tr id="row_2_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00317.html" target="_self">hwloc_cl_device_topology_amd</a></td><td class="desc"></td></tr>
+<tr id="row_3_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00373.html" target="_self">hwloc_component</a></td><td class="desc">Generic component structure </td></tr>
+<tr id="row_4_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00361.html" target="_self">hwloc_disc_component</a></td><td class="desc">Discovery component structure </td></tr>
+<tr id="row_5_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00365.html" target="_self">hwloc_disc_status</a></td><td class="desc">Discovery status structure </td></tr>
+<tr id="row_6_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00301.html" target="_self">hwloc_distances_s</a></td><td class="desc">Matrix of distances between a set of objects </td></tr>
+<tr id="row_7_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00277.html" target="_self">hwloc_info_s</a></td><td class="desc">Object info attribute (name and value strings) </td></tr>
+<tr id="row_8_" class="even"><td class="entry"><span style="width:0px;display:inline-block;">&#160;</span><span id="arr_8_" class="arrow" onclick="toggleFolder('8_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00305.html" target="_self">hwloc_location</a></td><td class="desc">Where to measure attributes from </td></tr>
+<tr id="row_8_0_" class="odd"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00309.html" target="_self">hwloc_location_u</a></td><td class="desc">Actual location </td></tr>
+<tr id="row_9_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00229.html" target="_self">hwloc_obj</a></td><td class="desc">Structure of a topology object </td></tr>
+<tr id="row_10_" class="odd"><td class="entry"><span style="width:0px;display:inline-block;">&#160;</span><span id="arr_10_" class="arrow" onclick="toggleFolder('10_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00233.html" target="_self">hwloc_obj_attr_u</a></td><td class="desc">Object type-specific Attributes </td></tr>
+<tr id="row_10_0_" class="even"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00257.html" target="_self">hwloc_bridge_attr_s</a></td><td class="desc">Bridge specific Object Attributes </td></tr>
+<tr id="row_10_1_" class="odd"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00245.html" target="_self">hwloc_cache_attr_s</a></td><td class="desc">Cache-specific Object Attributes </td></tr>
+<tr id="row_10_2_" class="even"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00249.html" target="_self">hwloc_group_attr_s</a></td><td class="desc">Group-specific Object Attributes </td></tr>
+<tr id="row_10_3_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span id="arr_10_3_" class="arrow" onclick="toggleFolder('10_3_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00237.html" target="_self">hwloc_numanode_attr_s</a></td><td class="desc">NUMA node-specific Object Attributes </td></tr>
+<tr id="row_10_3_0_" class="even"><td class="entry"><span style="width:48px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00241.html" target="_self">hwloc_memory_page_type_s</a></td><td class="desc">Array of local memory page types, <code>NULL</code> if no local memory and <code>page_types</code> is 0 </td></tr>
+<tr id="row_10_4_" class="odd"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00273.html" target="_self">hwloc_osdev_attr_s</a></td><td class="desc">OS Device specific Object Attributes </td></tr>
+<tr id="row_10_5_" class="even"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00253.html" target="_self">hwloc_pcidev_attr_s</a></td><td class="desc">PCI Device specific Object Attributes </td></tr>
+<tr id="row_11_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00285.html" target="_self">hwloc_topology_cpubind_support</a></td><td class="desc">Flags describing actual PU binding support for this topology </td></tr>
+<tr id="row_12_" class="even"><td class="entry"><span style="width:0px;display:inline-block;">&#160;</span><span id="arr_12_" class="arrow" onclick="toggleFolder('12_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00329.html" target="_self">hwloc_topology_diff_obj_attr_u</a></td><td class="desc">One object attribute difference </td></tr>
+<tr id="row_12_0_" class="odd"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00333.html" target="_self">hwloc_topology_diff_obj_attr_generic_s</a></td><td class="desc"></td></tr>
+<tr id="row_12_1_" class="even"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00341.html" target="_self">hwloc_topology_diff_obj_attr_string_s</a></td><td class="desc">String attribute modification with an optional name </td></tr>
+<tr id="row_12_2_" class="odd"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00337.html" target="_self">hwloc_topology_diff_obj_attr_uint64_s</a></td><td class="desc">Integer attribute modification with an optional index </td></tr>
+<tr id="row_13_" class="even"><td class="entry"><span style="width:0px;display:inline-block;">&#160;</span><span id="arr_13_" class="arrow" onclick="toggleFolder('13_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00345.html" target="_self">hwloc_topology_diff_u</a></td><td class="desc">One element of a difference list between two topologies </td></tr>
+<tr id="row_13_0_" class="odd"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00349.html" target="_self">hwloc_topology_diff_generic_s</a></td><td class="desc"></td></tr>
+<tr id="row_13_1_" class="even"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00353.html" target="_self">hwloc_topology_diff_obj_attr_s</a></td><td class="desc"></td></tr>
+<tr id="row_13_2_" class="odd"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00357.html" target="_self">hwloc_topology_diff_too_complex_s</a></td><td class="desc"></td></tr>
+<tr id="row_14_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00281.html" target="_self">hwloc_topology_discovery_support</a></td><td class="desc">Flags describing actual discovery support for this topology </td></tr>
+<tr id="row_15_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00289.html" target="_self">hwloc_topology_membind_support</a></td><td class="desc">Flags describing actual memory binding support for this topology </td></tr>
+<tr id="row_16_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00293.html" target="_self">hwloc_topology_misc_support</a></td><td class="desc">Flags describing miscellaneous features </td></tr>
+<tr id="row_17_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="a00297.html" target="_self">hwloc_topology_support</a></td><td class="desc">Set of flags describing actual support for this topology </td></tr>
+</table>
+</div><!-- directory -->
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
Binary files 2.10.0-1/doc/doxygen-doc/html/bc_s.png and 2.11.0-1/doc/doxygen-doc/html/bc_s.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/bc_sd.png and 2.11.0-1/doc/doxygen-doc/html/bc_sd.png differ
diff -pruN 2.10.0-1/doc/doxygen-doc/html/classes.html 2.11.0-1/doc/doxygen-doc/html/classes.html
--- 2.10.0-1/doc/doxygen-doc/html/classes.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/classes.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,57 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Data Structure Index</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">Data Structure Index</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="qindex"><a class="qindex" href="#letter_H">H</a></div>
+<div class="classindex">
+<dl class="classindex even">
+<dt class="alphachar"><a id="letter_H" name="letter_H">H</a></dt>
+<dd><a class="el" href="a00369.html">hwloc_backend</a></dd><dd><a class="el" href="a00257.html">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></dd><dd><a class="el" href="a00245.html">hwloc_obj_attr_u::hwloc_cache_attr_s</a></dd><dd><a class="el" href="a00313.html">hwloc_cl_device_pci_bus_info_khr</a></dd><dd><a class="el" href="a00317.html">hwloc_cl_device_topology_amd</a></dd><dd><a class="el" href="a00373.html">hwloc_component</a></dd><dd><a class="el" href="a00361.html">hwloc_disc_component</a></dd><dd><a class="el" href="a00365.html">hwloc_disc_status</a></dd><dd><a class="el" href="a00301.html">hwloc_distances_s</a></dd><dd><a class="el" href="a00249.html">hwloc_obj_attr_u::hwloc_group_attr_s</a></dd><dd><a class="el" href="a00277.html">hwloc_info_s</a></dd><dd><a class="el" href="a00305.html">hwloc_location</a></dd><dd><a class="el" href="a00309.html">hwloc_location::hwloc_location_u</a></dd><dd><a class="el" href="a00241.html">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s</a></dd><dd><a class="el" href="a00237.html">hwloc_obj_attr_u::hwloc_numanode_attr_s</a></dd><dd><a class="el" href="a00229.html">hwloc_obj</a></dd><dd><a class="el" href="a00233.html">hwloc_obj_attr_u</a></dd><dd><a class="el" href="a00273.html">hwloc_obj_attr_u::hwloc_osdev_attr_s</a></dd><dd><a class="el" href="a00253.html">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></dd><dd><a class="el" href="a00285.html">hwloc_topology_cpubind_support</a></dd><dd><a class="el" href="a00349.html">hwloc_topology_diff_u::hwloc_topology_diff_generic_s</a></dd><dd><a class="el" href="a00333.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s</a></dd><dd><a class="el" href="a00353.html">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a></dd><dd><a class="el" href="a00341.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a></dd><dd><a class="el" href="a00329.html">hwloc_topology_diff_obj_attr_u</a></dd><dd><a class="el" href="a00337.html">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a></dd><dd><a class="el" href="a00357.html">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a></dd><dd><a class="el" href="a00345.html">hwloc_topology_diff_u</a></dd><dd><a class="el" href="a00281.html">hwloc_topology_discovery_support</a></dd><dd><a class="el" href="a00289.html">hwloc_topology_membind_support</a></dd><dd><a class="el" href="a00293.html">hwloc_topology_misc_support</a></dd><dd><a class="el" href="a00297.html">hwloc_topology_support</a></dd></dl>
+</div>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
Binary files 2.10.0-1/doc/doxygen-doc/html/closed.png and 2.11.0-1/doc/doxygen-doc/html/closed.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/devel09-pci.png and 2.11.0-1/doc/doxygen-doc/html/devel09-pci.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/diagram.png and 2.11.0-1/doc/doxygen-doc/html/diagram.png differ
diff -pruN 2.10.0-1/doc/doxygen-doc/html/dir_5cb306d949c7931a3b6c77517393dd34.html 2.11.0-1/doc/doxygen-doc/html/dir_5cb306d949c7931a3b6c77517393dd34.html
--- 2.10.0-1/doc/doxygen-doc/html/dir_5cb306d949c7931a3b6c77517393dd34.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/dir_5cb306d949c7931a3b6c77517393dd34.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,101 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): hwloc Directory Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">hwloc Directory Reference</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="files" name="files"></a>
+Files</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00110_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>bitmap.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00122_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>cpukinds.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00140_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>cuda.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00143_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>cudart.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00161_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>diff.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00116_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>distances.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00113_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>export.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00155_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>gl.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00134_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>glibc-sched.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00107_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>helper.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00152_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>levelzero.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00128_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>linux-libnuma.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00125_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>linux.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00119_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>memattrs.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00146_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>nvml.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00137_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>opencl.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00158_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>openfabrics-verbs.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00167_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>plugins.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00149_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>rsmi.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00164_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>shmem.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00131_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>windows.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/dir_d44c64559bbebec7f509842c48db8b23.html 2.11.0-1/doc/doxygen-doc/html/dir_d44c64559bbebec7f509842c48db8b23.html
--- 2.10.0-1/doc/doxygen-doc/html/dir_d44c64559bbebec7f509842c48db8b23.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/dir_d44c64559bbebec7f509842c48db8b23.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,66 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): include Directory Reference</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+<div id="nav-path" class="navpath">
+  <ul>
+<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
+</div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">include Directory Reference</div></div>
+</div><!--header-->
+<div class="contents">
+<table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="subdirs" name="subdirs"></a>
+Directories</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><span class="iconfclosed"></span>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="dir_5cb306d949c7931a3b6c77517393dd34.html">hwloc</a></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table><table class="memberdecls">
+<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="files" name="files"></a>
+Files</h2></td></tr>
+<tr class="memitem:"><td class="memItemLeft" align="right" valign="top"><a href="a00104_source.html"><span class="icondoc"></span></a>&#160;</td><td class="memItemRight" valign="bottom"><b>hwloc.h</b></td></tr>
+<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
+</table>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/doc.svg 2.11.0-1/doc/doxygen-doc/html/doc.svg
--- 2.10.0-1/doc/doxygen-doc/html/doc.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/doc.svg	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,12 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
+ "https://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
+<svg version="1.1" width="16" height="24" viewBox="0 0 80 60" id="doc" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xml:space="preserve">
+<g style="fill:#4665A2">
+<path d="m 14,-1.1445312 c -2.824372,0 -5.1445313,2.320159 -5.1445312,5.1445312 v 72 c 0,2.824372 2.3201592,5.144531 5.1445312,5.144531 h 52 c 2.824372,0 5.144531,-2.320159 5.144531,-5.144531 V 23.699219 a 1.1447968,1.1447968 0 0 0 -0.01563,-0.1875 C 70.977847,22.605363 70.406495,21.99048 70.007812,21.591797 L 48.208984,-0.20898438 C 47.606104,-0.81186474 46.804652,-1.1445313 46,-1.1445312 Z m 1.144531,6.2890624 H 42.855469 V 24 c 0,1.724372 1.420159,3.144531 3.144531,3.144531 H 64.855469 V 74.855469 H 15.144531 Z m 34,4.4179688 L 60.4375,20.855469 H 49.144531 Z"/>
+</g>
+<g style="fill:#D8DFEE;stroke-width:0">
+<path d="M 3.0307167,13.993174 V 7.0307167 h 2.7576792 2.7576792 v 1.8826151 c 0,1.2578262 0.0099,1.9287572 0.029818,2.0216512 0.03884,0.181105 0.168631,0.348218 0.33827,0.43554 l 0.1355017,0.06975 1.9598092,0.0079 1.959809,0.0078 v 4.749829 4.749829 H 8 3.0307167 Z" transform="matrix(5,0,0,5,0,-30)" />
+<path d="M 9.8293515,9.0581469 V 7.9456453 l 1.1058025,1.1055492 c 0.608191,0.6080521 1.105802,1.1086775 1.105802,1.1125015 0,0.0038 -0.497611,0.007 -1.105802,0.007 H 9.8293515 Z" transform="matrix(5,0,0,5,0,-30)" />
+</g>
+</svg>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/docd.svg 2.11.0-1/doc/doxygen-doc/html/docd.svg
--- 2.10.0-1/doc/doxygen-doc/html/docd.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/docd.svg	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,12 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
+ "https://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
+<svg version="1.1" width="16" height="24" viewBox="0 0 80 60" id="doc" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xml:space="preserve">
+<g style="fill:#C4CFE5">
+<path d="m 14,-1.1445312 c -2.824372,0 -5.1445313,2.320159 -5.1445312,5.1445312 v 72 c 0,2.824372 2.3201592,5.144531 5.1445312,5.144531 h 52 c 2.824372,0 5.144531,-2.320159 5.144531,-5.144531 V 23.699219 a 1.1447968,1.1447968 0 0 0 -0.01563,-0.1875 C 70.977847,22.605363 70.406495,21.99048 70.007812,21.591797 L 48.208984,-0.20898438 C 47.606104,-0.81186474 46.804652,-1.1445313 46,-1.1445312 Z m 1.144531,6.2890624 H 42.855469 V 24 c 0,1.724372 1.420159,3.144531 3.144531,3.144531 H 64.855469 V 74.855469 H 15.144531 Z m 34,4.4179688 L 60.4375,20.855469 H 49.144531 Z"/>
+</g>
+<g style="fill:#4665A2;stroke-width:0">
+<path d="M 3.0307167,13.993174 V 7.0307167 h 2.7576792 2.7576792 v 1.8826151 c 0,1.2578262 0.0099,1.9287572 0.029818,2.0216512 0.03884,0.181105 0.168631,0.348218 0.33827,0.43554 l 0.1355017,0.06975 1.9598092,0.0079 1.959809,0.0078 v 4.749829 4.749829 H 8 3.0307167 Z" transform="matrix(5,0,0,5,0,-30)" />
+<path d="M 9.8293515,9.0581469 V 7.9456453 l 1.1058025,1.1055492 c 0.608191,0.6080521 1.105802,1.1086775 1.105802,1.1125015 0,0.0038 -0.497611,0.007 -1.105802,0.007 H 9.8293515 Z" transform="matrix(5,0,0,5,0,-30)" />
+</g>
+</svg>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/doxygen.css 2.11.0-1/doc/doxygen-doc/html/doxygen.css
--- 2.10.0-1/doc/doxygen-doc/html/doxygen.css	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/doxygen.css	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,2045 @@
+/* The standard CSS for doxygen 1.9.8*/
+
+html {
+/* page base colors */
+--page-background-color: white;
+--page-foreground-color: black;
+--page-link-color: #3D578C;
+--page-visited-link-color: #4665A2;
+
+/* index */
+--index-odd-item-bg-color: #F8F9FC;
+--index-even-item-bg-color: white;
+--index-header-color: black;
+--index-separator-color: #A0A0A0;
+
+/* header */
+--header-background-color: #F9FAFC;
+--header-separator-color: #C4CFE5;
+--header-gradient-image: url('nav_h.png');
+--group-header-separator-color: #879ECB;
+--group-header-color: #354C7B;
+--inherit-header-color: gray;
+
+--footer-foreground-color: #2A3D61;
+--footer-logo-width: 104px;
+--citation-label-color: #334975;
+--glow-color: cyan;
+
+--title-background-color: white;
+--title-separator-color: #5373B4;
+--directory-separator-color: #9CAFD4;
+--separator-color: #4A6AAA;
+
+--blockquote-background-color: #F7F8FB;
+--blockquote-border-color: #9CAFD4;
+
+--scrollbar-thumb-color: #9CAFD4;
+--scrollbar-background-color: #F9FAFC;
+
+--icon-background-color: #728DC1;
+--icon-foreground-color: white;
+--icon-doc-image: url('doc.svg');
+--icon-folder-open-image: url('folderopen.svg');
+--icon-folder-closed-image: url('folderclosed.svg');
+
+/* brief member declaration list */
+--memdecl-background-color: #F9FAFC;
+--memdecl-separator-color: #DEE4F0;
+--memdecl-foreground-color: #555;
+--memdecl-template-color: #4665A2;
+
+/* detailed member list */
+--memdef-border-color: #A8B8D9;
+--memdef-title-background-color: #E2E8F2;
+--memdef-title-gradient-image: url('nav_f.png');
+--memdef-proto-background-color: #DFE5F1;
+--memdef-proto-text-color: #253555;
+--memdef-proto-text-shadow: 0px 1px 1px rgba(255, 255, 255, 0.9);
+--memdef-doc-background-color: white;
+--memdef-param-name-color: #602020;
+--memdef-template-color: #4665A2;
+
+/* tables */
+--table-cell-border-color: #2D4068;
+--table-header-background-color: #374F7F;
+--table-header-foreground-color: #FFFFFF;
+
+/* labels */
+--label-background-color: #728DC1;
+--label-left-top-border-color: #5373B4;
+--label-right-bottom-border-color: #C4CFE5;
+--label-foreground-color: white;
+
+/** navigation bar/tree/menu */
+--nav-background-color: #F9FAFC;
+--nav-foreground-color: #364D7C;
+--nav-gradient-image: url('tab_b.png');
+--nav-gradient-hover-image: url('tab_h.png');
+--nav-gradient-active-image: url('tab_a.png');
+--nav-gradient-active-image-parent: url("../tab_a.png");
+--nav-separator-image: url('tab_s.png');
+--nav-breadcrumb-image: url('bc_s.png');
+--nav-breadcrumb-border-color: #C2CDE4;
+--nav-splitbar-image: url('splitbar.png');
+--nav-font-size-level1: 13px;
+--nav-font-size-level2: 10px;
+--nav-font-size-level3: 9px;
+--nav-text-normal-color: #283A5D;
+--nav-text-hover-color: white;
+--nav-text-active-color: white;
+--nav-text-normal-shadow: 0px 1px 1px rgba(255, 255, 255, 0.9);
+--nav-text-hover-shadow: 0px 1px 1px rgba(0, 0, 0, 1.0);
+--nav-text-active-shadow: 0px 1px 1px rgba(0, 0, 0, 1.0);
+--nav-menu-button-color: #364D7C;
+--nav-menu-background-color: white;
+--nav-menu-foreground-color: #555555;
+--nav-menu-toggle-color: rgba(255, 255, 255, 0.5);
+--nav-arrow-color: #9CAFD4;
+--nav-arrow-selected-color: #9CAFD4;
+
+/* table of contents */
+--toc-background-color: #F4F6FA;
+--toc-border-color: #D8DFEE;
+--toc-header-color: #4665A2;
+--toc-down-arrow-image: url("data:image/svg+xml;utf8,<svg xmlns='http://www.w3.org/2000/svg' version='1.1' height='10px' width='5px' fill='grey'><text x='0' y='5' font-size='10'>&%238595;</text></svg>");
+
+/** search field */
+--search-background-color: white;
+--search-foreground-color: #909090;
+--search-magnification-image: url('mag.svg');
+--search-magnification-select-image: url('mag_sel.svg');
+--search-active-color: black;
+--search-filter-background-color: #F9FAFC;
+--search-filter-foreground-color: black;
+--search-filter-border-color: #90A5CE;
+--search-filter-highlight-text-color: white;
+--search-filter-highlight-bg-color: #3D578C;
+--search-results-foreground-color: #425E97;
+--search-results-background-color: #EEF1F7;
+--search-results-border-color: black;
+--search-box-shadow: inset 0.5px 0.5px 3px 0px #555;
+
+/** code fragments */
+--code-keyword-color: #008000;
+--code-type-keyword-color: #604020;
+--code-flow-keyword-color: #E08000;
+--code-comment-color: #800000;
+--code-preprocessor-color: #806020;
+--code-string-literal-color: #002080;
+--code-char-literal-color: #008080;
+--code-xml-cdata-color: black;
+--code-vhdl-digit-color: #FF00FF;
+--code-vhdl-char-color: #000000;
+--code-vhdl-keyword-color: #700070;
+--code-vhdl-logic-color: #FF0000;
+--code-link-color: #4665A2;
+--code-external-link-color: #4665A2;
+--fragment-foreground-color: black;
+--fragment-background-color: #FBFCFD;
+--fragment-border-color: #C4CFE5;
+--fragment-lineno-border-color: #00FF00;
+--fragment-lineno-background-color: #E8E8E8;
+--fragment-lineno-foreground-color: black;
+--fragment-lineno-link-fg-color: #4665A2;
+--fragment-lineno-link-bg-color: #D8D8D8;
+--fragment-lineno-link-hover-fg-color: #4665A2;
+--fragment-lineno-link-hover-bg-color: #C8C8C8;
+--tooltip-foreground-color: black;
+--tooltip-background-color: white;
+--tooltip-border-color: gray;
+--tooltip-doc-color: grey;
+--tooltip-declaration-color: #006318;
+--tooltip-link-color: #4665A2;
+--tooltip-shadow: 1px 1px 7px gray;
+--fold-line-color: #808080;
+--fold-minus-image: url('minus.svg');
+--fold-plus-image: url('plus.svg');
+--fold-minus-image-relpath: url('../../minus.svg');
+--fold-plus-image-relpath: url('../../plus.svg');
+
+/** font-family */
+--font-family-normal: Roboto,sans-serif;
+--font-family-monospace: 'JetBrains Mono',Consolas,Monaco,'Andale Mono','Ubuntu Mono',monospace,fixed;
+--font-family-nav: 'Lucida Grande',Geneva,Helvetica,Arial,sans-serif;
+--font-family-title: Tahoma,Arial,sans-serif;
+--font-family-toc: Verdana,'DejaVu Sans',Geneva,sans-serif;
+--font-family-search: Arial,Verdana,sans-serif;
+--font-family-icon: Arial,Helvetica;
+--font-family-tooltip: Roboto,sans-serif;
+
+}
+
+@media (prefers-color-scheme: dark) {
+  html:not(.dark-mode) {
+    color-scheme: dark;
+
+/* page base colors */
+--page-background-color: black;
+--page-foreground-color: #C9D1D9;
+--page-link-color: #90A5CE;
+--page-visited-link-color: #A3B4D7;
+
+/* index */
+--index-odd-item-bg-color: #0B101A;
+--index-even-item-bg-color: black;
+--index-header-color: #C4CFE5;
+--index-separator-color: #334975;
+
+/* header */
+--header-background-color: #070B11;
+--header-separator-color: #141C2E;
+--header-gradient-image: url('nav_hd.png');
+--group-header-separator-color: #283A5D;
+--group-header-color: #90A5CE;
+--inherit-header-color: #A0A0A0;
+
+--footer-foreground-color: #5B7AB7;
+--footer-logo-width: 60px;
+--citation-label-color: #90A5CE;
+--glow-color: cyan;
+
+--title-background-color: #090D16;
+--title-separator-color: #354C79;
+--directory-separator-color: #283A5D;
+--separator-color: #283A5D;
+
+--blockquote-background-color: #101826;
+--blockquote-border-color: #283A5D;
+
+--scrollbar-thumb-color: #283A5D;
+--scrollbar-background-color: #070B11;
+
+--icon-background-color: #334975;
+--icon-foreground-color: #C4CFE5;
+--icon-doc-image: url('docd.svg');
+--icon-folder-open-image: url('folderopend.svg');
+--icon-folder-closed-image: url('folderclosedd.svg');
+
+/* brief member declaration list */
+--memdecl-background-color: #0B101A;
+--memdecl-separator-color: #2C3F65;
+--memdecl-foreground-color: #BBB;
+--memdecl-template-color: #7C95C6;
+
+/* detailed member list */
+--memdef-border-color: #233250;
+--memdef-title-background-color: #1B2840;
+--memdef-title-gradient-image: url('nav_fd.png');
+--memdef-proto-background-color: #19243A;
+--memdef-proto-text-color: #9DB0D4;
+--memdef-proto-text-shadow: 0px 1px 1px rgba(0, 0, 0, 0.9);
+--memdef-doc-background-color: black;
+--memdef-param-name-color: #D28757;
+--memdef-template-color: #7C95C6;
+
+/* tables */
+--table-cell-border-color: #283A5D;
+--table-header-background-color: #283A5D;
+--table-header-foreground-color: #C4CFE5;
+
+/* labels */
+--label-background-color: #354C7B;
+--label-left-top-border-color: #4665A2;
+--label-right-bottom-border-color: #283A5D;
+--label-foreground-color: #CCCCCC;
+
+/** navigation bar/tree/menu */
+--nav-background-color: #101826;
+--nav-foreground-color: #364D7C;
+--nav-gradient-image: url('tab_bd.png');
+--nav-gradient-hover-image: url('tab_hd.png');
+--nav-gradient-active-image: url('tab_ad.png');
+--nav-gradient-active-image-parent: url("../tab_ad.png");
+--nav-separator-image: url('tab_sd.png');
+--nav-breadcrumb-image: url('bc_sd.png');
+--nav-breadcrumb-border-color: #2A3D61;
+--nav-splitbar-image: url('splitbard.png');
+--nav-font-size-level1: 13px;
+--nav-font-size-level2: 10px;
+--nav-font-size-level3: 9px;
+--nav-text-normal-color: #B6C4DF;
+--nav-text-hover-color: #DCE2EF;
+--nav-text-active-color: #DCE2EF;
+--nav-text-normal-shadow: 0px 1px 1px black;
+--nav-text-hover-shadow: 0px 1px 1px rgba(0, 0, 0, 1.0);
+--nav-text-active-shadow: 0px 1px 1px rgba(0, 0, 0, 1.0);
+--nav-menu-button-color: #B6C4DF;
+--nav-menu-background-color: #05070C;
+--nav-menu-foreground-color: #BBBBBB;
+--nav-menu-toggle-color: rgba(255, 255, 255, 0.2);
+--nav-arrow-color: #334975;
+--nav-arrow-selected-color: #90A5CE;
+
+/* table of contents */
+--toc-background-color: #151E30;
+--toc-border-color: #202E4A;
+--toc-header-color: #A3B4D7;
+--toc-down-arrow-image: url("data:image/svg+xml;utf8,<svg xmlns='http://www.w3.org/2000/svg' version='1.1' height='10px' width='5px'><text x='0' y='5' font-size='10' fill='grey'>&%238595;</text></svg>");
+
+/** search field */
+--search-background-color: black;
+--search-foreground-color: #C5C5C5;
+--search-magnification-image: url('mag_d.svg');
+--search-magnification-select-image: url('mag_seld.svg');
+--search-active-color: #C5C5C5;
+--search-filter-background-color: #101826;
+--search-filter-foreground-color: #90A5CE;
+--search-filter-border-color: #7C95C6;
+--search-filter-highlight-text-color: #BCC9E2;
+--search-filter-highlight-bg-color: #283A5D;
+--search-results-background-color: #101826;
+--search-results-foreground-color: #90A5CE;
+--search-results-border-color: #7C95C6;
+--search-box-shadow: inset 0.5px 0.5px 3px 0px #2F436C;
+
+/** code fragments */
+--code-keyword-color: #CC99CD;
+--code-type-keyword-color: #AB99CD;
+--code-flow-keyword-color: #E08000;
+--code-comment-color: #717790;
+--code-preprocessor-color: #65CABE;
+--code-string-literal-color: #7EC699;
+--code-char-literal-color: #00E0F0;
+--code-xml-cdata-color: #C9D1D9;
+--code-vhdl-digit-color: #FF00FF;
+--code-vhdl-char-color: #C0C0C0;
+--code-vhdl-keyword-color: #CF53C9;
+--code-vhdl-logic-color: #FF0000;
+--code-link-color: #79C0FF;
+--code-external-link-color: #79C0FF;
+--fragment-foreground-color: #C9D1D9;
+--fragment-background-color: black;
+--fragment-border-color: #30363D;
+--fragment-lineno-border-color: #30363D;
+--fragment-lineno-background-color: black;
+--fragment-lineno-foreground-color: #6E7681;
+--fragment-lineno-link-fg-color: #6E7681;
+--fragment-lineno-link-bg-color: #303030;
+--fragment-lineno-link-hover-fg-color: #8E96A1;
+--fragment-lineno-link-hover-bg-color: #505050;
+--tooltip-foreground-color: #C9D1D9;
+--tooltip-background-color: #202020;
+--tooltip-border-color: #C9D1D9;
+--tooltip-doc-color: #D9E1E9;
+--tooltip-declaration-color: #20C348;
+--tooltip-link-color: #79C0FF;
+--tooltip-shadow: none;
+--fold-line-color: #808080;
+--fold-minus-image: url('minusd.svg');
+--fold-plus-image: url('plusd.svg');
+--fold-minus-image-relpath: url('../../minusd.svg');
+--fold-plus-image-relpath: url('../../plusd.svg');
+
+/** font-family */
+--font-family-normal: Roboto,sans-serif;
+--font-family-monospace: 'JetBrains Mono',Consolas,Monaco,'Andale Mono','Ubuntu Mono',monospace,fixed;
+--font-family-nav: 'Lucida Grande',Geneva,Helvetica,Arial,sans-serif;
+--font-family-title: Tahoma,Arial,sans-serif;
+--font-family-toc: Verdana,'DejaVu Sans',Geneva,sans-serif;
+--font-family-search: Arial,Verdana,sans-serif;
+--font-family-icon: Arial,Helvetica;
+--font-family-tooltip: Roboto,sans-serif;
+
+}}
+body {
+    background-color: var(--page-background-color);
+    color: var(--page-foreground-color);
+}
+
+body, table, div, p, dl {
+	font-weight: 400;
+	font-size: 14px;
+	font-family: var(--font-family-normal);
+	line-height: 22px;
+}
+
+/* @group Heading Levels */
+
+.title {
+	font-weight: 400;
+	font-size: 14px;
+	font-family: var(--font-family-normal);
+	line-height: 28px;
+	font-size: 150%;
+	font-weight: bold;
+	margin: 10px 2px;
+}
+
+h1.groupheader {
+	font-size: 150%;
+}
+
+h2.groupheader {
+	border-bottom: 1px solid var(--group-header-separator-color);
+	color: var(--group-header-color);
+	font-size: 150%;
+	font-weight: normal;
+	margin-top: 1.75em;
+	padding-top: 8px;
+	padding-bottom: 4px;
+	width: 100%;
+}
+
+h3.groupheader {
+	font-size: 100%;
+}
+
+h1, h2, h3, h4, h5, h6 {
+	-webkit-transition: text-shadow 0.5s linear;
+	-moz-transition: text-shadow 0.5s linear;
+	-ms-transition: text-shadow 0.5s linear;
+	-o-transition: text-shadow 0.5s linear;
+	transition: text-shadow 0.5s linear;
+	margin-right: 15px;
+}
+
+h1.glow, h2.glow, h3.glow, h4.glow, h5.glow, h6.glow {
+	text-shadow: 0 0 15px var(--glow-color);
+}
+
+dt {
+	font-weight: bold;
+}
+
+p.startli, p.startdd {
+	margin-top: 2px;
+}
+
+th p.starttd, th p.intertd, th p.endtd {
+        font-size: 100%;
+        font-weight: 700;
+}
+
+p.starttd {
+	margin-top: 0px;
+}
+
+p.endli {
+	margin-bottom: 0px;
+}
+
+p.enddd {
+	margin-bottom: 4px;
+}
+
+p.endtd {
+	margin-bottom: 2px;
+}
+
+p.interli {
+}
+
+p.interdd {
+}
+
+p.intertd {
+}
+
+/* @end */
+
+caption {
+	font-weight: bold;
+}
+
+span.legend {
+	font-size: 70%;
+	text-align: center;
+}
+
+h3.version {
+	font-size: 90%;
+	text-align: center;
+}
+
+div.navtab {
+	padding-right: 15px;
+	text-align: right;
+	line-height: 110%;
+}
+
+div.navtab table {
+	border-spacing: 0;
+}
+
+td.navtab {
+	padding-right: 6px;
+	padding-left: 6px;
+}
+
+td.navtabHL {
+	background-image: var(--nav-gradient-active-image);
+	background-repeat:repeat-x;
+	padding-right: 6px;
+	padding-left: 6px;
+}
+
+td.navtabHL a, td.navtabHL a:visited {
+	color: var(--nav-text-hover-color);
+	text-shadow: var(--nav-text-hover-shadow);
+}
+
+a.navtab {
+	font-weight: bold;
+}
+
+div.qindex{
+	text-align: center;
+	width: 100%;
+	line-height: 140%;
+	font-size: 130%;
+	color: var(--index-separator-color);
+}
+
+#main-menu a:focus {
+	outline: auto;
+	z-index: 10;
+	position: relative;
+}
+
+dt.alphachar{
+	font-size: 180%;
+	font-weight: bold;
+}
+
+.alphachar a{
+	color: var(--index-header-color);
+}
+
+.alphachar a:hover, .alphachar a:visited{
+	text-decoration: none;
+}
+
+.classindex dl {
+	padding: 25px;
+	column-count:1
+}
+
+.classindex dd {
+	display:inline-block;
+	margin-left: 50px;
+	width: 90%;
+	line-height: 1.15em;
+}
+
+.classindex dl.even {
+	background-color: var(--index-even-item-bg-color);
+}
+
+.classindex dl.odd {
+	background-color: var(--index-odd-item-bg-color);
+}
+
+@media(min-width: 1120px) {
+	.classindex dl {
+		column-count:2
+	}
+}
+
+@media(min-width: 1320px) {
+	.classindex dl {
+		column-count:3
+	}
+}
+
+
+/* @group Link Styling */
+
+a {
+	color: var(--page-link-color);
+	font-weight: normal;
+	text-decoration: none;
+}
+
+.contents a:visited {
+	color: var(--page-visited-link-color);
+}
+
+a:hover {
+	text-decoration: underline;
+}
+
+a.el {
+	font-weight: bold;
+}
+
+a.elRef {
+}
+
+a.code, a.code:visited, a.line, a.line:visited {
+	color: var(--code-link-color);
+}
+
+a.codeRef, a.codeRef:visited, a.lineRef, a.lineRef:visited {
+	color: var(--code-external-link-color);
+}
+
+a.code.hl_class { /* style for links to class names in code snippets */ }
+a.code.hl_struct { /* style for links to struct names in code snippets */ }
+a.code.hl_union { /* style for links to union names in code snippets */ }
+a.code.hl_interface { /* style for links to interface names in code snippets */ }
+a.code.hl_protocol { /* style for links to protocol names in code snippets */ }
+a.code.hl_category { /* style for links to category names in code snippets */ }
+a.code.hl_exception { /* style for links to exception names in code snippets */ }
+a.code.hl_service { /* style for links to service names in code snippets */ }
+a.code.hl_singleton { /* style for links to singleton names in code snippets */ }
+a.code.hl_concept { /* style for links to concept names in code snippets */ }
+a.code.hl_namespace { /* style for links to namespace names in code snippets */ }
+a.code.hl_package { /* style for links to package names in code snippets */ }
+a.code.hl_define { /* style for links to macro names in code snippets */ }
+a.code.hl_function { /* style for links to function names in code snippets */ }
+a.code.hl_variable { /* style for links to variable names in code snippets */ }
+a.code.hl_typedef { /* style for links to typedef names in code snippets */ }
+a.code.hl_enumvalue { /* style for links to enum value names in code snippets */ }
+a.code.hl_enumeration { /* style for links to enumeration names in code snippets */ }
+a.code.hl_signal { /* style for links to Qt signal names in code snippets */ }
+a.code.hl_slot { /* style for links to Qt slot names in code snippets */ }
+a.code.hl_friend { /* style for links to friend names in code snippets */ }
+a.code.hl_dcop { /* style for links to KDE3 DCOP names in code snippets */ }
+a.code.hl_property { /* style for links to property names in code snippets */ }
+a.code.hl_event { /* style for links to event names in code snippets */ }
+a.code.hl_sequence { /* style for links to sequence names in code snippets */ }
+a.code.hl_dictionary { /* style for links to dictionary names in code snippets */ }
+
+/* @end */
+
+dl.el {
+	margin-left: -1cm;
+}
+
+ul {
+  overflow: visible;
+}
+
+ul.multicol {
+        -moz-column-gap: 1em;
+        -webkit-column-gap: 1em;
+        column-gap: 1em;
+        -moz-column-count: 3;
+        -webkit-column-count: 3;
+        column-count: 3;
+        list-style-type: none;
+}
+
+#side-nav ul {
+  overflow: visible; /* reset ul rule for scroll bar in GENERATE_TREEVIEW window */
+}
+
+#main-nav ul {
+  overflow: visible; /* reset ul rule for the navigation bar drop down lists */
+}
+
+.fragment {
+  text-align: left;
+  direction: ltr;
+  overflow-x: auto; /*Fixed: fragment lines overlap floating elements*/
+  overflow-y: hidden;
+}
+
+pre.fragment {
+        border: 1px solid var(--fragment-border-color);
+        background-color: var(--fragment-background-color);
+	color: var(--fragment-foreground-color);
+        padding: 4px 6px;
+        margin: 4px 8px 4px 2px;
+        overflow: auto;
+        word-wrap: break-word;
+        font-size:  9pt;
+        line-height: 125%;
+        font-family: var(--font-family-monospace);
+        font-size: 105%;
+}
+
+div.fragment {
+	padding: 0 0 1px 0; /*Fixed: last line underline overlap border*/
+	margin: 4px 8px 4px 2px;
+	color: var(--fragment-foreground-color);
+	background-color: var(--fragment-background-color);
+	border: 1px solid var(--fragment-border-color);
+}
+
+div.line {
+	font-family: var(--font-family-monospace);
+        font-size: 13px;
+	min-height: 13px;
+	line-height: 1.2;
+	text-wrap: unrestricted;
+	white-space: -moz-pre-wrap; /* Moz */
+	white-space: -pre-wrap;     /* Opera 4-6 */
+	white-space: -o-pre-wrap;   /* Opera 7 */
+	white-space: pre-wrap;      /* CSS3  */
+	word-wrap: break-word;      /* IE 5.5+ */
+	text-indent: -53px;
+	padding-left: 53px;
+	padding-bottom: 0px;
+	margin: 0px;
+	-webkit-transition-property: background-color, box-shadow;
+	-webkit-transition-duration: 0.5s;
+	-moz-transition-property: background-color, box-shadow;
+	-moz-transition-duration: 0.5s;
+	-ms-transition-property: background-color, box-shadow;
+	-ms-transition-duration: 0.5s;
+	-o-transition-property: background-color, box-shadow;
+	-o-transition-duration: 0.5s;
+	transition-property: background-color, box-shadow;
+	transition-duration: 0.5s;
+}
+
+div.line:after {
+    content:"\000A";
+    white-space: pre;
+}
+
+div.line.glow {
+	background-color: var(--glow-color);
+	box-shadow: 0 0 10px var(--glow-color);
+}
+
+span.fold {
+        margin-left: 5px;
+        margin-right: 1px;
+        margin-top: 0px;
+        margin-bottom: 0px;
+        padding: 0px;
+	display: inline-block;
+	width: 12px;
+	height: 12px;
+	background-repeat:no-repeat;
+        background-position:center;
+}
+
+span.lineno {
+	padding-right: 4px;
+        margin-right: 9px;
+	text-align: right;
+	border-right: 2px solid var(--fragment-lineno-border-color);
+	color: var(--fragment-lineno-foreground-color);
+	background-color: var(--fragment-lineno-background-color);
+        white-space: pre;
+}
+span.lineno a, span.lineno a:visited {
+	color: var(--fragment-lineno-link-fg-color);
+	background-color: var(--fragment-lineno-link-bg-color);
+}
+
+span.lineno a:hover {
+	color: var(--fragment-lineno-link-hover-fg-color);
+	background-color: var(--fragment-lineno-link-hover-bg-color);
+}
+
+.lineno {
+	-webkit-touch-callout: none;
+	-webkit-user-select: none;
+	-khtml-user-select: none;
+	-moz-user-select: none;
+	-ms-user-select: none;
+	user-select: none;
+}
+
+div.classindex ul {
+        list-style: none;
+        padding-left: 0;
+}
+
+div.classindex span.ai {
+        display: inline-block;
+}
+
+div.groupHeader {
+	margin-left: 16px;
+	margin-top: 12px;
+	font-weight: bold;
+}
+
+div.groupText {
+	margin-left: 16px;
+	font-style: italic;
+}
+
+body {
+	color: var(--page-foreground-color);
+        margin: 0;
+}
+
+div.contents {
+	margin-top: 10px;
+	margin-left: 12px;
+	margin-right: 8px;
+}
+
+p.formulaDsp {
+	text-align: center;
+}
+
+img.dark-mode-visible {
+	display: none;
+}
+img.light-mode-visible {
+	display: none;
+}
+
+img.formulaDsp {
+	
+}
+
+img.formulaInl, img.inline {
+	vertical-align: middle;
+}
+
+div.center {
+	text-align: center;
+        margin-top: 0px;
+        margin-bottom: 0px;
+        padding: 0px;
+}
+
+div.center img {
+	border: 0px;
+}
+
+address.footer {
+	text-align: right;
+	padding-right: 12px;
+}
+
+img.footer {
+	border: 0px;
+	vertical-align: middle;
+	width: var(--footer-logo-width);
+}
+
+.compoundTemplParams {
+	color: var(--memdecl-template-color);
+	font-size: 80%;
+	line-height: 120%;
+}
+
+/* @group Code Colorization */
+
+span.keyword {
+	color: var(--code-keyword-color);
+}
+
+span.keywordtype {
+	color: var(--code-type-keyword-color);
+}
+
+span.keywordflow {
+	color: var(--code-flow-keyword-color);
+}
+
+span.comment {
+	color: var(--code-comment-color);
+}
+
+span.preprocessor {
+	color: var(--code-preprocessor-color);
+}
+
+span.stringliteral {
+	color: var(--code-string-literal-color);
+}
+
+span.charliteral {
+	color: var(--code-char-literal-color);
+}
+
+span.xmlcdata {
+	color: var(--code-xml-cdata-color);
+}
+
+span.vhdldigit { 
+	color: var(--code-vhdl-digit-color);
+}
+
+span.vhdlchar { 
+	color: var(--code-vhdl-char-color);
+}
+
+span.vhdlkeyword { 
+	color: var(--code-vhdl-keyword-color);
+}
+
+span.vhdllogic { 
+	color: var(--code-vhdl-logic-color);
+}
+
+blockquote {
+        background-color: var(--blockquote-background-color);
+        border-left: 2px solid var(--blockquote-border-color);
+        margin: 0 24px 0 4px;
+        padding: 0 12px 0 16px;
+}
+
+/* @end */
+
+td.tiny {
+	font-size: 75%;
+}
+
+.dirtab {
+	padding: 4px;
+	border-collapse: collapse;
+	border: 1px solid var(--table-cell-border-color);
+}
+
+th.dirtab {
+	background-color: var(--table-header-background-color);
+	color: var(--table-header-foreground-color);
+	font-weight: bold;
+}
+
+hr {
+	height: 0px;
+	border: none;
+	border-top: 1px solid var(--separator-color);
+}
+
+hr.footer {
+	height: 1px;
+}
+
+/* @group Member Descriptions */
+
+table.memberdecls {
+	border-spacing: 0px;
+	padding: 0px;
+}
+
+.memberdecls td, .fieldtable tr {
+	-webkit-transition-property: background-color, box-shadow;
+	-webkit-transition-duration: 0.5s;
+	-moz-transition-property: background-color, box-shadow;
+	-moz-transition-duration: 0.5s;
+	-ms-transition-property: background-color, box-shadow;
+	-ms-transition-duration: 0.5s;
+	-o-transition-property: background-color, box-shadow;
+	-o-transition-duration: 0.5s;
+	transition-property: background-color, box-shadow;
+	transition-duration: 0.5s;
+}
+
+.memberdecls td.glow, .fieldtable tr.glow {
+	background-color: var(--glow-color);
+	box-shadow: 0 0 15px var(--glow-color);
+}
+
+.mdescLeft, .mdescRight,
+.memItemLeft, .memItemRight,
+.memTemplItemLeft, .memTemplItemRight, .memTemplParams {
+	background-color: var(--memdecl-background-color);
+	border: none;
+	margin: 4px;
+	padding: 1px 0 0 8px;
+}
+
+.mdescLeft, .mdescRight {
+	padding: 0px 8px 4px 8px;
+	color: var(--memdecl-foreground-color);
+}
+
+.memSeparator {
+        border-bottom: 1px solid var(--memdecl-separator-color);
+        line-height: 1px;
+        margin: 0px;
+        padding: 0px;
+}
+
+.memItemLeft, .memTemplItemLeft {
+        white-space: nowrap;
+}
+
+.memItemRight, .memTemplItemRight {
+	width: 100%;
+}
+
+.memTemplParams {
+	color: var(--memdecl-template-color);
+        white-space: nowrap;
+	font-size: 80%;
+}
+
+/* @end */
+
+/* @group Member Details */
+
+/* Styles for detailed member documentation */
+
+.memtitle {
+	padding: 8px;
+	border-top: 1px solid var(--memdef-border-color);
+	border-left: 1px solid var(--memdef-border-color);
+	border-right: 1px solid var(--memdef-border-color);
+	border-top-right-radius: 4px;
+	border-top-left-radius: 4px;
+	margin-bottom: -1px;
+	background-image: var(--memdef-title-gradient-image);
+	background-repeat: repeat-x;
+	background-color: var(--memdef-title-background-color);
+	line-height: 1.25;
+	font-weight: 300;
+	float:left;
+}
+
+.permalink
+{
+        font-size: 65%;
+        display: inline-block;
+        vertical-align: middle;
+}
+
+.memtemplate {
+	font-size: 80%;
+	color: var(--memdef-template-color);
+	font-weight: normal;
+	margin-left: 9px;
+}
+
+.mempage {
+	width: 100%;
+}
+
+.memitem {
+	padding: 0;
+	margin-bottom: 10px;
+	margin-right: 5px;
+        -webkit-transition: box-shadow 0.5s linear;
+        -moz-transition: box-shadow 0.5s linear;
+        -ms-transition: box-shadow 0.5s linear;
+        -o-transition: box-shadow 0.5s linear;
+        transition: box-shadow 0.5s linear;
+        display: table !important;
+        width: 100%;
+}
+
+.memitem.glow {
+         box-shadow: 0 0 15px var(--glow-color);
+}
+
+.memname {
+        font-weight: 400;
+        margin-left: 6px;
+}
+
+.memname td {
+	vertical-align: bottom;
+}
+
+.memproto, dl.reflist dt {
+        border-top: 1px solid var(--memdef-border-color);
+        border-left: 1px solid var(--memdef-border-color);
+        border-right: 1px solid var(--memdef-border-color);
+        padding: 6px 0px 6px 0px;
+        color: var(--memdef-proto-text-color);
+        font-weight: bold;
+        text-shadow: var(--memdef-proto-text-shadow);
+        background-color: var(--memdef-proto-background-color);
+        box-shadow: 5px 5px 5px rgba(0, 0, 0, 0.15);
+        border-top-right-radius: 4px;
+}
+
+.overload {
+        font-family: var(--font-family-monospace);
+	font-size: 65%;
+}
+
+.memdoc, dl.reflist dd {
+        border-bottom: 1px solid var(--memdef-border-color);
+        border-left: 1px solid var(--memdef-border-color);
+        border-right: 1px solid var(--memdef-border-color);
+        padding: 6px 10px 2px 10px;
+        border-top-width: 0;
+        background-image:url('nav_g.png');
+        background-repeat:repeat-x;
+        background-color: var(--memdef-doc-background-color);
+        /* opera specific markup */
+        border-bottom-left-radius: 4px;
+        border-bottom-right-radius: 4px;
+        box-shadow: 5px 5px 5px rgba(0, 0, 0, 0.15);
+        /* firefox specific markup */
+        -moz-border-radius-bottomleft: 4px;
+        -moz-border-radius-bottomright: 4px;
+        -moz-box-shadow: rgba(0, 0, 0, 0.15) 5px 5px 5px;
+        /* webkit specific markup */
+        -webkit-border-bottom-left-radius: 4px;
+        -webkit-border-bottom-right-radius: 4px;
+        -webkit-box-shadow: 5px 5px 5px rgba(0, 0, 0, 0.15);
+}
+
+dl.reflist dt {
+        padding: 5px;
+}
+
+dl.reflist dd {
+        margin: 0px 0px 10px 0px;
+        padding: 5px;
+}
+
+.paramkey {
+	text-align: right;
+}
+
+.paramtype {
+	white-space: nowrap;
+}
+
+.paramname {
+	color: var(--memdef-param-name-color);
+	white-space: nowrap;
+}
+.paramname em {
+	font-style: normal;
+}
+.paramname code {
+        line-height: 14px;
+}
+
+.params, .retval, .exception, .tparams {
+        margin-left: 0px;
+        padding-left: 0px;
+}
+
+.params .paramname, .retval .paramname, .tparams .paramname, .exception .paramname {
+        font-weight: bold;
+        vertical-align: top;
+}
+
+.params .paramtype, .tparams .paramtype {
+        font-style: italic;
+        vertical-align: top;
+}
+
+.params .paramdir, .tparams .paramdir {
+        font-family: var(--font-family-monospace);
+        vertical-align: top;
+}
+
+table.mlabels {
+	border-spacing: 0px;
+}
+
+td.mlabels-left {
+	width: 100%;
+	padding: 0px;
+}
+
+td.mlabels-right {
+	vertical-align: bottom;
+	padding: 0px;
+	white-space: nowrap;
+}
+
+span.mlabels {
+        margin-left: 8px;
+}
+
+span.mlabel {
+        background-color: var(--label-background-color);
+        border-top:1px solid var(--label-left-top-border-color);
+        border-left:1px solid var(--label-left-top-border-color);
+        border-right:1px solid var(--label-right-bottom-border-color);
+        border-bottom:1px solid var(--label-right-bottom-border-color);
+	text-shadow: none;
+	color: var(--label-foreground-color);
+	margin-right: 4px;
+	padding: 2px 3px;
+	border-radius: 3px;
+	font-size: 7pt;
+	white-space: nowrap;
+	vertical-align: middle;
+}
+
+
+
+/* @end */
+
+/* these are for tree view inside a (index) page */
+
+div.directory {
+        margin: 10px 0px;
+        border-top: 1px solid var(--directory-separator-color);
+        border-bottom: 1px solid var(--directory-separator-color);
+        width: 100%;
+}
+
+.directory table {
+        border-collapse:collapse;
+}
+
+.directory td {
+        margin: 0px;
+        padding: 0px;
+	vertical-align: top;
+}
+
+.directory td.entry {
+        white-space: nowrap;
+        padding-right: 6px;
+	padding-top: 3px;
+}
+
+.directory td.entry a {
+        outline:none;
+}
+
+.directory td.entry a img {
+        border: none;
+}
+
+.directory td.desc {
+        width: 100%;
+        padding-left: 6px;
+	padding-right: 6px;
+	padding-top: 3px;
+	border-left: 1px solid rgba(0,0,0,0.05);
+}
+
+.directory tr.odd {
+	padding-left: 6px;
+	background-color: var(--index-odd-item-bg-color);
+}
+
+.directory tr.even {
+	padding-left: 6px;
+	background-color: var(--index-even-item-bg-color);
+}
+
+.directory img {
+	vertical-align: -30%;
+}
+
+.directory .levels {
+        white-space: nowrap;
+        width: 100%;
+        text-align: right;
+        font-size: 9pt;
+}
+
+.directory .levels span {
+        cursor: pointer;
+        padding-left: 2px;
+        padding-right: 2px;
+	color: var(--page-link-color);
+}
+
+.arrow {
+    color: var(--nav-arrow-color);
+    -webkit-user-select: none;
+    -khtml-user-select: none;
+    -moz-user-select: none;
+    -ms-user-select: none;
+    user-select: none;
+    cursor: pointer;
+    font-size: 80%;
+    display: inline-block;
+    width: 16px;
+    height: 22px;
+}
+
+.icon {
+    font-family: var(--font-family-icon);
+    line-height: normal;
+    font-weight: bold;
+    font-size: 12px;
+    height: 14px;
+    width: 16px;
+    display: inline-block;
+    background-color: var(--icon-background-color);
+    color: var(--icon-foreground-color);
+    text-align: center;
+    border-radius: 4px;
+    margin-left: 2px;
+    margin-right: 2px;
+}
+
+.icona {
+    width: 24px;
+    height: 22px;
+    display: inline-block;
+}
+
+.iconfopen {
+    width: 24px;
+    height: 18px;
+    margin-bottom: 4px;
+    background-image:var(--icon-folder-open-image);
+    background-repeat: repeat-y;
+    vertical-align:top;
+    display: inline-block;
+}
+
+.iconfclosed {
+    width: 24px;
+    height: 18px;
+    margin-bottom: 4px;
+    background-image:var(--icon-folder-closed-image);
+    background-repeat: repeat-y;
+    vertical-align:top;
+    display: inline-block;
+}
+
+.icondoc {
+    width: 24px;
+    height: 18px;
+    margin-bottom: 4px;
+    background-image:var(--icon-doc-image);
+    background-position: 0px -4px;
+    background-repeat: repeat-y;
+    vertical-align:top;
+    display: inline-block;
+}
+
+/* @end */
+
+div.dynheader {
+        margin-top: 8px;
+	-webkit-touch-callout: none;
+	-webkit-user-select: none;
+	-khtml-user-select: none;
+	-moz-user-select: none;
+	-ms-user-select: none;
+	user-select: none;
+}
+
+address {
+	font-style: normal;
+	color: var(--footer-foreground-color);
+}
+
+table.doxtable caption {
+	caption-side: top;
+}
+
+table.doxtable {
+	border-collapse:collapse;
+        margin-top: 4px;
+        margin-bottom: 4px;
+}
+
+table.doxtable td, table.doxtable th {
+	border: 1px solid var(--table-cell-border-color);
+	padding: 3px 7px 2px;
+}
+
+table.doxtable th {
+	background-color: var(--table-header-background-color);
+	color: var(--table-header-foreground-color);
+	font-size: 110%;
+	padding-bottom: 4px;
+	padding-top: 5px;
+}
+
+table.fieldtable {
+        margin-bottom: 10px;
+        border: 1px solid var(--memdef-border-color);
+        border-spacing: 0px;
+        border-radius: 4px;
+        box-shadow: 2px 2px 2px rgba(0, 0, 0, 0.15);
+}
+
+.fieldtable td, .fieldtable th {
+        padding: 3px 7px 2px;
+}
+
+.fieldtable td.fieldtype, .fieldtable td.fieldname {
+        white-space: nowrap;
+        border-right: 1px solid var(--memdef-border-color);
+        border-bottom: 1px solid var(--memdef-border-color);
+        vertical-align: top;
+}
+
+.fieldtable td.fieldname {
+        padding-top: 3px;
+}
+
+.fieldtable td.fielddoc {
+        border-bottom: 1px solid var(--memdef-border-color);
+}
+
+.fieldtable td.fielddoc p:first-child {
+        margin-top: 0px;
+}
+
+.fieldtable td.fielddoc p:last-child {
+        margin-bottom: 2px;
+}
+
+.fieldtable tr:last-child td {
+        border-bottom: none;
+}
+
+.fieldtable th {
+        background-image: var(--memdef-title-gradient-image);
+        background-repeat:repeat-x;
+        background-color: var(--memdef-title-background-color);
+        font-size: 90%;
+        color: var(--memdef-proto-text-color);
+        padding-bottom: 4px;
+        padding-top: 5px;
+        text-align:left;
+        font-weight: 400;
+        border-top-left-radius: 4px;
+        border-top-right-radius: 4px;
+        border-bottom: 1px solid var(--memdef-border-color);
+}
+
+
+.tabsearch {
+	top: 0px;
+	left: 10px;
+	height: 36px;
+	background-image: var(--nav-gradient-image);
+	z-index: 101;
+	overflow: hidden;
+	font-size: 13px;
+}
+
+.navpath ul
+{
+	font-size: 11px;
+	background-image: var(--nav-gradient-image);
+	background-repeat:repeat-x;
+	background-position: 0 -5px;
+	height:30px;
+	line-height:30px;
+	color:var(--nav-text-normal-color);
+	border:solid 1px var(--nav-breadcrumb-border-color);
+	overflow:hidden;
+	margin:0px;
+	padding:0px;
+}
+
+.navpath li
+{
+	list-style-type:none;
+	float:left;
+	padding-left:10px;
+	padding-right:15px;
+	background-image:var(--nav-breadcrumb-image);
+	background-repeat:no-repeat;
+	background-position:right;
+	color: var(--nav-foreground-color);
+}
+
+.navpath li.navelem a
+{
+	height:32px;
+	display:block;
+	text-decoration: none;
+	outline: none;
+	color: var(--nav-text-normal-color);
+	font-family: var(--font-family-nav);
+	text-shadow: var(--nav-text-normal-shadow);
+	text-decoration: none;
+}
+
+.navpath li.navelem a:hover
+{
+	color: var(--nav-text-hover-color);
+	text-shadow: var(--nav-text-hover-shadow);
+}
+
+.navpath li.footer
+{
+        list-style-type:none;
+        float:right;
+        padding-left:10px;
+        padding-right:15px;
+        background-image:none;
+        background-repeat:no-repeat;
+        background-position:right;
+        color: var(--footer-foreground-color);
+        font-size: 8pt;
+}
+
+
+div.summary
+{
+	float: right;
+	font-size: 8pt;
+	padding-right: 5px;
+	width: 50%;
+	text-align: right;
+}
+
+div.summary a
+{
+	white-space: nowrap;
+}
+
+table.classindex
+{
+        margin: 10px;
+        white-space: nowrap;
+        margin-left: 3%;
+        margin-right: 3%;
+        width: 94%;
+        border: 0;
+        border-spacing: 0;
+        padding: 0;
+}
+
+div.ingroups
+{
+	font-size: 8pt;
+	width: 50%;
+	text-align: left;
+}
+
+div.ingroups a
+{
+	white-space: nowrap;
+}
+
+div.header
+{
+        background-image: var(--header-gradient-image);
+        background-repeat:repeat-x;
+	background-color: var(--header-background-color);
+	margin:  0px;
+	border-bottom: 1px solid var(--header-separator-color);
+}
+
+div.headertitle
+{
+	padding: 5px 5px 5px 10px;
+}
+
+.PageDocRTL-title div.headertitle {
+  text-align: right;
+  direction: rtl;
+}
+
+dl {
+        padding: 0 0 0 0;
+}
+
+/* dl.note, dl.warning, dl.attention, dl.pre, dl.post, dl.invariant, dl.deprecated, dl.todo, dl.test, dl.bug, dl.examples */
+dl.section {
+	margin-left: 0px;
+	padding-left: 0px;
+}
+
+dl.note {
+  margin-left: -7px;
+  padding-left: 3px;
+  border-left: 4px solid;
+  border-color: #D0C000;
+}
+
+dl.warning, dl.attention {
+  margin-left: -7px;
+  padding-left: 3px;
+  border-left: 4px solid;
+  border-color: #FF0000;
+}
+
+dl.pre, dl.post, dl.invariant {
+  margin-left: -7px;
+  padding-left: 3px;
+  border-left: 4px solid;
+  border-color: #00D000;
+}
+
+dl.deprecated {
+  margin-left: -7px;
+  padding-left: 3px;
+  border-left: 4px solid;
+  border-color: #505050;
+}
+
+dl.todo {
+  margin-left: -7px;
+  padding-left: 3px;
+  border-left: 4px solid;
+  border-color: #00C0E0;
+}
+
+dl.test {
+  margin-left: -7px;
+  padding-left: 3px;
+  border-left: 4px solid;
+  border-color: #3030E0;
+}
+
+dl.bug {
+  margin-left: -7px;
+  padding-left: 3px;
+  border-left: 4px solid;
+  border-color: #C08050;
+}
+
+dl.section dd {
+	margin-bottom: 6px;
+}
+
+
+#projectrow
+{
+	height: 56px;
+}
+
+#projectlogo
+{
+	text-align: center;
+	vertical-align: bottom;
+	border-collapse: separate;
+}
+ 
+#projectlogo img
+{ 
+	border: 0px none;
+}
+ 
+#projectalign
+{
+        vertical-align: middle;
+        padding-left: 0.5em;
+}
+
+#projectname
+{
+	font-size: 200%;
+	font-family: var(--font-family-title);
+	margin: 0px;
+	padding: 2px 0px;
+}
+
+#projectbrief
+{
+	font-size: 90%;
+        font-family: var(--font-family-title);
+	margin: 0px;
+	padding: 0px;
+}
+
+#projectnumber
+{
+	font-size: 50%;
+	font-family: 50% var(--font-family-title);
+	margin: 0px;
+	padding: 0px;
+}
+
+#titlearea
+{
+	padding: 0px;
+	margin: 0px;
+	width: 100%;
+	border-bottom: 1px solid var(--title-separator-color);
+	background-color: var(--title-background-color);
+}
+
+.image
+{
+        text-align: center;
+}
+
+.dotgraph
+{
+        text-align: center;
+}
+
+.mscgraph
+{
+        text-align: center;
+}
+
+.plantumlgraph
+{
+        text-align: center;
+}
+
+.diagraph
+{
+        text-align: center;
+}
+
+.caption
+{
+	font-weight: bold;
+}
+
+dl.citelist {
+        margin-bottom:50px;
+}
+
+dl.citelist dt {
+        color:var(--citation-label-color);
+        float:left;
+        font-weight:bold;
+        margin-right:10px;
+        padding:5px;
+        text-align:right;
+        width:52px;
+}
+
+dl.citelist dd {
+        margin:2px 0 2px 72px;
+        padding:5px 0;
+}
+
+div.toc {
+        padding: 14px 25px;
+        background-color: var(--toc-background-color);
+        border: 1px solid var(--toc-border-color);
+        border-radius: 7px 7px 7px 7px;
+        float: right;
+        height: auto;
+        margin: 0 8px 10px 10px;
+        width: 200px;
+}
+
+div.toc li {
+        background: var(--toc-down-arrow-image) no-repeat scroll 0 5px transparent;
+        font: 10px/1.2 var(--font-family-toc);
+        margin-top: 5px;
+        padding-left: 10px;
+        padding-top: 2px;
+}
+
+div.toc h3 {
+        font: bold 12px/1.2 var(--font-family-toc);
+	color: var(--toc-header-color);
+        border-bottom: 0 none;
+        margin: 0;
+}
+
+div.toc ul {
+        list-style: none outside none;
+        border: medium none;
+        padding: 0px;
+}
+
+div.toc li.level1 {
+        margin-left: 0px;
+}
+
+div.toc li.level2 {
+        margin-left: 15px;
+}
+
+div.toc li.level3 {
+        margin-left: 15px;
+}
+
+div.toc li.level4 {
+        margin-left: 15px;
+}
+
+span.emoji {
+        /* font family used at the site: https://unicode.org/emoji/charts/full-emoji-list.html
+         * font-family: "Noto Color Emoji", "Apple Color Emoji", "Segoe UI Emoji", Times, Symbola, Aegyptus, Code2000, Code2001, Code2002, Musica, serif, LastResort;
+         */
+}
+
+span.obfuscator {
+  display: none;
+}
+
+.inherit_header {
+        font-weight: bold;
+        color: var(--inherit-header-color);
+        cursor: pointer;
+	-webkit-touch-callout: none;
+	-webkit-user-select: none;
+	-khtml-user-select: none;
+	-moz-user-select: none;
+	-ms-user-select: none;
+	user-select: none;
+}
+
+.inherit_header td {
+        padding: 6px 0px 2px 5px;
+}
+
+.inherit {
+        display: none;
+}
+
+tr.heading h2 {
+        margin-top: 12px;
+        margin-bottom: 4px;
+}
+
+/* tooltip related style info */
+
+.ttc {
+        position: absolute;
+        display: none;
+}
+
+#powerTip {
+	cursor: default;
+	/*white-space: nowrap;*/
+        color: var(--tooltip-foreground-color);
+	background-color: var(--tooltip-background-color);
+	border: 1px solid var(--tooltip-border-color);
+	border-radius: 4px 4px 4px 4px;
+	box-shadow: var(--tooltip-shadow);
+	display: none;
+	font-size: smaller;
+	max-width: 80%;
+	opacity: 0.9;
+	padding: 1ex 1em 1em;
+	position: absolute;
+	z-index: 2147483647;
+}
+
+#powerTip div.ttdoc {
+        color: var(--tooltip-doc-color);
+	font-style: italic;
+}
+
+#powerTip div.ttname a {
+        font-weight: bold;
+}
+
+#powerTip a {
+	color: var(--tooltip-link-color);
+}
+
+#powerTip div.ttname {
+        font-weight: bold;
+}
+
+#powerTip div.ttdeci {
+        color: var(--tooltip-declaration-color);
+}
+
+#powerTip div {
+        margin: 0px;
+        padding: 0px;
+        font-size: 12px;
+       	font-family: var(--font-family-tooltip);
+	line-height: 16px;
+}
+
+#powerTip:before, #powerTip:after {
+	content: "";
+	position: absolute;
+	margin: 0px;
+}
+
+#powerTip.n:after,  #powerTip.n:before,
+#powerTip.s:after,  #powerTip.s:before,
+#powerTip.w:after,  #powerTip.w:before,
+#powerTip.e:after,  #powerTip.e:before,
+#powerTip.ne:after, #powerTip.ne:before,
+#powerTip.se:after, #powerTip.se:before,
+#powerTip.nw:after, #powerTip.nw:before,
+#powerTip.sw:after, #powerTip.sw:before {
+	border: solid transparent;
+	content: " ";
+	height: 0;
+	width: 0;
+	position: absolute;
+}
+
+#powerTip.n:after,  #powerTip.s:after,
+#powerTip.w:after,  #powerTip.e:after,
+#powerTip.nw:after, #powerTip.ne:after,
+#powerTip.sw:after, #powerTip.se:after {
+	border-color: rgba(255, 255, 255, 0);
+}
+
+#powerTip.n:before,  #powerTip.s:before,
+#powerTip.w:before,  #powerTip.e:before,
+#powerTip.nw:before, #powerTip.ne:before,
+#powerTip.sw:before, #powerTip.se:before {
+	border-color: rgba(128, 128, 128, 0);
+}
+
+#powerTip.n:after,  #powerTip.n:before,
+#powerTip.ne:after, #powerTip.ne:before,
+#powerTip.nw:after, #powerTip.nw:before {
+	top: 100%;
+}
+
+#powerTip.n:after, #powerTip.ne:after, #powerTip.nw:after {
+	border-top-color: var(--tooltip-background-color);
+	border-width: 10px;
+	margin: 0px -10px;
+}
+#powerTip.n:before, #powerTip.ne:before, #powerTip.nw:before {
+	border-top-color: var(--tooltip-border-color);
+	border-width: 11px;
+	margin: 0px -11px;
+}
+#powerTip.n:after, #powerTip.n:before {
+	left: 50%;
+}
+
+#powerTip.nw:after, #powerTip.nw:before {
+	right: 14px;
+}
+
+#powerTip.ne:after, #powerTip.ne:before {
+	left: 14px;
+}
+
+#powerTip.s:after,  #powerTip.s:before,
+#powerTip.se:after, #powerTip.se:before,
+#powerTip.sw:after, #powerTip.sw:before {
+	bottom: 100%;
+}
+
+#powerTip.s:after, #powerTip.se:after, #powerTip.sw:after {
+	border-bottom-color: var(--tooltip-background-color);
+	border-width: 10px;
+	margin: 0px -10px;
+}
+
+#powerTip.s:before, #powerTip.se:before, #powerTip.sw:before {
+	border-bottom-color: var(--tooltip-border-color);
+	border-width: 11px;
+	margin: 0px -11px;
+}
+
+#powerTip.s:after, #powerTip.s:before {
+	left: 50%;
+}
+
+#powerTip.sw:after, #powerTip.sw:before {
+	right: 14px;
+}
+
+#powerTip.se:after, #powerTip.se:before {
+	left: 14px;
+}
+
+#powerTip.e:after, #powerTip.e:before {
+	left: 100%;
+}
+#powerTip.e:after {
+	border-left-color: var(--tooltip-border-color);
+	border-width: 10px;
+	top: 50%;
+	margin-top: -10px;
+}
+#powerTip.e:before {
+	border-left-color: var(--tooltip-border-color);
+	border-width: 11px;
+	top: 50%;
+	margin-top: -11px;
+}
+
+#powerTip.w:after, #powerTip.w:before {
+	right: 100%;
+}
+#powerTip.w:after {
+	border-right-color: var(--tooltip-border-color);
+	border-width: 10px;
+	top: 50%;
+	margin-top: -10px;
+}
+#powerTip.w:before {
+	border-right-color: var(--tooltip-border-color);
+	border-width: 11px;
+	top: 50%;
+	margin-top: -11px;
+}
+
+@media print
+{
+  #top { display: none; }
+  #side-nav { display: none; }
+  #nav-path { display: none; }
+  body { overflow:visible; }
+  h1, h2, h3, h4, h5, h6 { page-break-after: avoid; }
+  .summary { display: none; }
+  .memitem { page-break-inside: avoid; }
+  #doc-content
+  {
+    margin-left:0 !important;
+    height:auto !important;
+    width:auto !important;
+    overflow:inherit;
+    display:inline;
+  }
+}
+
+/* @group Markdown */
+
+table.markdownTable {
+	border-collapse:collapse;
+        margin-top: 4px;
+        margin-bottom: 4px;
+}
+
+table.markdownTable td, table.markdownTable th {
+	border: 1px solid var(--table-cell-border-color);
+	padding: 3px 7px 2px;
+}
+
+table.markdownTable tr {
+}
+
+th.markdownTableHeadLeft, th.markdownTableHeadRight, th.markdownTableHeadCenter, th.markdownTableHeadNone {
+	background-color: var(--table-header-background-color);
+	color: var(--table-header-foreground-color);
+	font-size: 110%;
+	padding-bottom: 4px;
+	padding-top: 5px;
+}
+
+th.markdownTableHeadLeft, td.markdownTableBodyLeft {
+	text-align: left
+}
+
+th.markdownTableHeadRight, td.markdownTableBodyRight {
+	text-align: right
+}
+
+th.markdownTableHeadCenter, td.markdownTableBodyCenter {
+	text-align: center
+}
+
+tt, code, kbd, samp
+{
+  display: inline-block;
+}
+/* @end */
+
+u {
+	text-decoration: underline;
+}
+
+details>summary {
+  list-style-type: none;
+}
+
+details > summary::-webkit-details-marker {
+    display: none;
+}
+
+details>summary::before {
+    content: "\25ba";
+    padding-right:4px;
+    font-size: 80%;
+}
+
+details[open]>summary::before {
+    content: "\25bc";
+    padding-right:4px;
+    font-size: 80%;
+}
+
+body {
+    scrollbar-color: var(--scrollbar-thumb-color) var(--scrollbar-background-color);
+}
+
+::-webkit-scrollbar {
+        background-color: var(--scrollbar-background-color);
+        height: 12px;
+        width: 12px;
+}
+::-webkit-scrollbar-thumb {
+        border-radius: 6px;
+        box-shadow: inset 0 0 12px 12px var(--scrollbar-thumb-color);
+        border: solid 2px transparent;
+}
+::-webkit-scrollbar-corner {
+        background-color: var(--scrollbar-background-color);
+}
+
diff -pruN 2.10.0-1/doc/doxygen-doc/html/doxygen.svg 2.11.0-1/doc/doxygen-doc/html/doxygen.svg
--- 2.10.0-1/doc/doxygen-doc/html/doxygen.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/doxygen.svg	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,28 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
+ "https://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
+<svg version="1.1" viewBox="0 0 104 31" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
+ <defs>
+  <linearGradient id="a">
+   <stop stop-color="#5373B4" offset="0"/>
+   <stop stop-color="#7C95C6" offset="1"/>
+  </linearGradient>
+  <linearGradient id="d" x1="31.474" x2="31.474" y1="24.821" y2="26.773" gradientUnits="userSpaceOnUse" xlink:href="#a"/>
+  <linearGradient id="c" x1="31.474" x2="31.474" y1="24.821" y2="26.773" gradientTransform="matrix(.6816 0 0 1.0248 72.391 -.91809)" gradientUnits="userSpaceOnUse" xlink:href="#a"/>
+  <linearGradient id="b" x1="56.295" x2="56.295" y1="24.622" y2="26.574" gradientUnits="userSpaceOnUse" xlink:href="#a"/>
+  <linearGradient id="e" x1="49.067" x2="48.956" y1="19.719" y2="9.5227" gradientTransform="matrix(.97968 0 0 1.0207 -.25579 -.25579)" gradientUnits="userSpaceOnUse">
+   <stop stop-color="#C0CCE3" offset="0"/>
+   <stop stop-color="#EEF1F7" offset="1"/>
+  </linearGradient>
+  <filter id="f" x="-.010676" y="-.045304" width="1.0214" height="1.0906" color-interpolation-filters="sRGB">
+   <feGaussianBlur stdDeviation="0.45293203"/>
+  </filter>
+ </defs>
+ <g>
+  <path transform="translate(-2.5759 -27.848)" d="m13.609 32.203v6.8633h-0.05078c-0.40533-0.66867-0.96254-1.1715-1.6719-1.5059-0.69244-0.35193-1.4282-0.52734-2.2051-0.52734-0.96267 0-1.807 0.2027-2.5332 0.60742-0.72622 0.38713-1.3344 0.90556-1.8242 1.5566-0.47289 0.65108-0.83456 1.4092-1.0879 2.2715-0.23644 0.84464-0.35547 1.7236-0.35547 2.6387 0 0.95022 0.11902 1.8643 0.35547 2.7441 0.25333 0.87983 0.615 1.6633 1.0879 2.3496 0.48978 0.66867 1.1065 1.2066 1.8496 1.6113 0.74311 0.38713 1.6044 0.58008 2.584 0.58008 0.86133 0 1.6311-0.15787 2.3066-0.47461 0.69244-0.33434 1.2497-0.87227 1.6719-1.6113h0.05078v1.7422h3.4199v-18.846zm12.875 4.8301c-1.0302 0-1.9596 0.17541-2.7871 0.52734-0.82756 0.33434-1.5358 0.81965-2.127 1.4531-0.59111 0.61588-1.0483 1.3721-1.3691 2.2695-0.32089 0.87983-0.48047 1.866-0.48047 2.957s0.15958 2.0752 0.48047 2.9551c0.32089 0.87983 0.77803 1.6361 1.3691 2.2695 0.59111 0.61588 1.2994 1.0914 2.127 1.4258 0.82756 0.33434 1.7569 0.50195 2.7871 0.50195 1.0302 0 1.9596-0.16762 2.7871-0.50195 0.84444-0.33434 1.5612-0.8099 2.1523-1.4258 0.59111-0.63348 1.0483-1.3897 1.3691-2.2695 0.32089-0.87983 0.48047-1.8641 0.48047-2.9551s-0.15958-2.0772-0.48047-2.957c-0.32089-0.89743-0.77803-1.6536-1.3691-2.2695-0.59111-0.63348-1.3079-1.1188-2.1523-1.4531-0.82756-0.35193-1.7569-0.52734-2.7871-0.52734zm41.715 0c-0.912 0-1.7223 0.18516-2.4316 0.55469-0.69244 0.36953-1.2752 0.87043-1.748 1.5039-0.47289 0.61588-0.83651 1.337-1.0898 2.1641-0.23645 0.80944-0.35352 1.6553-0.35352 2.5352 0 0.93262 0.10007 1.8214 0.30273 2.666 0.21956 0.82704 0.55767 1.556 1.0137 2.1895 0.456 0.61588 1.0387 1.109 1.748 1.4785 0.70933 0.35193 1.5536 0.5293 2.5332 0.5293 0.79378 0 1.5446-0.16762 2.2539-0.50195 0.72622-0.35193 1.2834-0.88986 1.6719-1.6113h0.05078v1.7949c0.01689 0.96782-0.21071 1.7689-0.68359 2.4023-0.456 0.63348-1.1898 0.95117-2.2031 0.95117-0.64178 0-1.2075-0.14228-1.6973-0.42383-0.48978-0.26395-0.81939-0.74731-0.98828-1.4512h-3.5723c0.05067 0.77425 0.25276 1.435 0.60742 1.9805 0.37156 0.56309 0.8287 1.0192 1.3691 1.3711 0.55733 0.35193 1.1656 0.60726 1.8242 0.76562 0.67556 0.17597 1.3328 0.26562 1.9746 0.26562 1.5031 0 2.7025-0.21245 3.5977-0.63477 0.89511-0.42232 1.5798-0.94076 2.0527-1.5566 0.47289-0.59829 0.777-1.2493 0.91211-1.9531 0.152-0.70386 0.22656-1.3295 0.22656-1.875v-12.775h-3.4199v1.8223h-0.05078c-0.43911-0.79185-0.98782-1.3551-1.6465-1.6895-0.64178-0.33434-1.3926-0.50195-2.2539-0.50195zm16.523 0c-0.99644 0-1.9088 0.18516-2.7363 0.55469-0.81067 0.36953-1.5124 0.88018-2.1035 1.5312-0.59111 0.63348-1.0463 1.3897-1.3672 2.2695s-0.48047 1.831-0.48047 2.8516c0 1.0558 0.15108 2.0225 0.45508 2.9023 0.32089 0.87983 0.76758 1.6361 1.3418 2.2695 0.57422 0.63348 1.276 1.1266 2.1035 1.4785 0.82756 0.33434 1.7569 0.50195 2.7871 0.50195 1.4862 0 2.7517-0.35277 3.7988-1.0566 1.0471-0.70387 1.8254-1.8733 2.332-3.5098h-3.168c-0.11822 0.42232-0.43934 0.82772-0.96289 1.2148-0.52355 0.36953-1.1468 0.55274-1.873 0.55273-1.0133 0-1.7916-0.27286-2.332-0.81836-0.54044-0.5455-0.83605-1.4245-0.88672-2.6387h9.4492c0.06756-1.0558-0.01551-2.0673-0.25195-3.0352-0.23644-0.96782-0.62557-1.8293-1.166-2.5859-0.52356-0.75666-1.1998-1.355-2.0273-1.7949-0.82756-0.45751-1.7974-0.6875-2.9121-0.6875zm16.189 0c-0.76 0-1.5023 0.18516-2.2285 0.55469-0.72622 0.35193-1.3174 0.92299-1.7734 1.7148h-0.07617v-1.9004h-3.4199v13.646h3.5977v-7.1523c0-1.3901 0.21909-2.3841 0.6582-2.9824 0.43911-0.61588 1.1494-0.92383 2.1289-0.92383 0.86133 0 1.4611 0.28066 1.7988 0.84375 0.33777 0.5455 0.50586 1.3816 0.50586 2.5078v7.707h3.5976v-8.3926c0-0.84464-0.0765-1.6106-0.22851-2.2969-0.13511-0.70387-0.37971-1.2925-0.73438-1.7676-0.35466-0.49271-0.84386-0.87277-1.4688-1.1367-0.608-0.28155-1.3948-0.42188-2.3574-0.42188zm-66.063 0.36914 4.3066 6.4668-4.7129 7.1797h4.0293l2.7363-4.3027 2.7344 4.3027h4.1055l-4.8398-7.2578 4.3066-6.3887h-3.9766l-2.2793 3.5645-2.3066-3.5645zm13.275 0 4.584 12.803c0.10133 0.26395 0.15234 0.54461 0.15234 0.84375 0 0.40472-0.11707 0.77504-0.35352 1.1094-0.21956 0.33434-0.56617 0.52729-1.0391 0.58008-0.35467 0.0176-0.70979 0.0098-1.0645-0.02539-0.35467-0.03519-0.70128-0.07028-1.0391-0.10547v3.0879c0.37156 0.03519 0.73518 0.06051 1.0898 0.07813 0.37156 0.03519 0.74368 0.05273 1.1152 0.05273 1.2329 0 2.1943-0.23778 2.8867-0.71289 0.69244-0.47511 1.2326-1.2664 1.6211-2.375l5.4727-15.336h-3.7246l-2.8613 9.3438h-0.05078l-2.9648-9.3438zm-37.48 2.4551c0.59111 0 1.0823 0.12279 1.4707 0.36914 0.38844 0.24635 0.6991 0.57184 0.93555 0.97656 0.25333 0.38713 0.43187 0.84515 0.5332 1.373 0.10133 0.5103 0.15234 1.0482 0.15234 1.6113 0 0.56309-0.05101 1.1069-0.15234 1.6348-0.10133 0.5279-0.27137 1.0035-0.50781 1.4258-0.23644 0.40472-0.5556 0.73021-0.96094 0.97656-0.38844 0.24635-0.87959 0.36914-1.4707 0.36914-0.55733 0-1.038-0.12279-1.4434-0.36914-0.38844-0.26395-0.71806-0.59723-0.98828-1.002-0.25333-0.42232-0.43842-0.89788-0.55664-1.4258s-0.17773-1.0561-0.17773-1.584c-1e-7 -0.56309 0.05101-1.0991 0.15234-1.6094 0.11822-0.5279 0.29481-0.99567 0.53125-1.4004 0.25333-0.40472 0.58295-0.73021 0.98828-0.97656 0.40533-0.24635 0.90303-0.36914 1.4941-0.36914zm15.84 0c0.608 0 1.1142 0.13253 1.5195 0.39648 0.42222 0.24635 0.75184 0.57184 0.98828 0.97656 0.25333 0.40472 0.42992 0.87054 0.53125 1.3984 0.10133 0.5279 0.15234 1.0658 0.15234 1.6113 0 0.5455-0.05101 1.0815-0.15234 1.6094-0.10134 0.5103-0.27792 0.97612-0.53125 1.3984-0.23644 0.40472-0.56606 0.73021-0.98828 0.97656-0.40533 0.24635-0.91153 0.36914-1.5195 0.36914-0.608 0-1.1142-0.12279-1.5195-0.36914s-0.73495-0.57184-0.98828-0.97656c-0.23644-0.42232-0.40648-0.88814-0.50781-1.3984-0.10133-0.5279-0.15234-1.0639-0.15234-1.6094 0-0.5455 0.05101-1.0834 0.15234-1.6113 0.10133-0.5279 0.27137-0.99371 0.50781-1.3984 0.25333-0.40472 0.58295-0.73021 0.98828-0.97656 0.40533-0.26395 0.91153-0.39648 1.5195-0.39648zm42.602 0c0.59111 0 1.0803 0.11499 1.4688 0.34375 0.38844 0.22876 0.70105 0.5367 0.9375 0.92383 0.23644 0.38713 0.40648 0.8354 0.50781 1.3457 0.10133 0.49271 0.15039 1.0209 0.15039 1.584 0 0.4927-0.06606 0.96827-0.20117 1.4258-0.11822 0.43992-0.30526 0.83557-0.55859 1.1875-0.25333 0.35193-0.57445 0.63259-0.96289 0.84375-0.38844 0.21116-0.83513 0.31836-1.3418 0.31836-0.55733 0-1.021-0.12474-1.3926-0.37109-0.37156-0.24635-0.67566-0.56209-0.91211-0.94922-0.21956-0.38713-0.38109-0.81786-0.48242-1.293-0.08444-0.49271-0.12695-0.98581-0.12695-1.4785 0-0.5103 0.05101-0.99366 0.15234-1.4512 0.11822-0.47511 0.29676-0.89025 0.5332-1.2422 0.25333-0.36953 0.55744-0.65993 0.91211-0.87109 0.37156-0.21116 0.80974-0.31641 1.3164-0.31641zm15.535 0c0.87822 0 1.529 0.24753 1.9512 0.74023 0.43911 0.49271 0.74322 1.2138 0.91211 2.1641h-5.8535c0.01689-0.26395 0.0679-0.5641 0.15234-0.89844 0.10133-0.33434 0.26287-0.65008 0.48242-0.94922 0.23644-0.29914 0.54055-0.54667 0.91211-0.74023 0.38845-0.21116 0.86914-0.31641 1.4434-0.31641z" filter="url(#f)" opacity=".3" stroke="#969696"/>
+  <path d="m0.97202 24.161 43.605-0.0019 0.0508 3.3061-43.6 0.04174z" fill="url(#d)" stroke="#000" stroke-width=".5"/>
+  <path d="m10.283 3.5547v6.8633h-0.05078c-0.40533-0.66867-0.96254-1.1715-1.6719-1.5059-0.69244-0.35193-1.4282-0.52734-2.2051-0.52734-0.96267 0-1.807 0.2027-2.5332 0.60742-0.72622 0.38713-1.3344 0.90556-1.8242 1.5566-0.47289 0.65108-0.83456 1.4092-1.0879 2.2715-0.23644 0.84464-0.35547 1.7236-0.35547 2.6387 0 0.95022 0.11902 1.8643 0.35547 2.7441 0.25333 0.87983 0.615 1.6633 1.0879 2.3496 0.48978 0.66867 1.1065 1.2066 1.8496 1.6113 0.74311 0.38713 1.6044 0.58008 2.584 0.58008 0.86133 0 1.6311-0.15787 2.3066-0.47461 0.69244-0.33434 1.2497-0.87227 1.6719-1.6113h0.05078v1.7422h3.4199v-18.846zm12.875 4.8301c-1.0302 0-1.9596 0.17541-2.7871 0.52734-0.82756 0.33434-1.5358 0.81965-2.127 1.4531-0.59111 0.61588-1.0483 1.3721-1.3691 2.2695-0.32089 0.87983-0.48047 1.866-0.48047 2.957s0.15958 2.0752 0.48047 2.9551c0.32089 0.87983 0.77803 1.6361 1.3691 2.2695 0.59111 0.61588 1.2994 1.0914 2.127 1.4258 0.82756 0.33434 1.7569 0.50195 2.7871 0.50195 1.0302 0 1.9596-0.16762 2.7871-0.50195 0.84444-0.33434 1.5612-0.8099 2.1523-1.4258 0.59111-0.63348 1.0483-1.3897 1.3691-2.2695 0.32089-0.87983 0.48047-1.8641 0.48047-2.9551s-0.15958-2.0772-0.48047-2.957c-0.32089-0.89743-0.77803-1.6536-1.3691-2.2695-0.59111-0.63348-1.3079-1.1188-2.1523-1.4531-0.82756-0.35193-1.7569-0.52734-2.7871-0.52734zm41.715 0c-0.912 0-1.7223 0.18516-2.4316 0.55469-0.69244 0.36953-1.2752 0.87043-1.748 1.5039-0.47289 0.61588-0.83651 1.337-1.0898 2.1641-0.23644 0.80944-0.35352 1.6553-0.35352 2.5352 0 0.93262 0.10007 1.8214 0.30273 2.666 0.21956 0.82704 0.55767 1.556 1.0137 2.1895 0.456 0.61588 1.0387 1.109 1.748 1.4785 0.70933 0.35193 1.5536 0.5293 2.5332 0.5293 0.79378 0 1.5446-0.16762 2.2539-0.50195 0.72622-0.35193 1.2834-0.88986 1.6719-1.6113h0.05078v1.7949c0.01689 0.96782-0.21071 1.7689-0.68359 2.4023-0.456 0.63348-1.1898 0.95117-2.2031 0.95117-0.64178 0-1.2075-0.14228-1.6973-0.42383-0.48978-0.26395-0.81939-0.74731-0.98828-1.4512h-3.5723c0.05067 0.77425 0.25276 1.435 0.60742 1.9805 0.37156 0.56309 0.8287 1.0192 1.3691 1.3711 0.55733 0.35193 1.1656 0.60726 1.8242 0.76562 0.67556 0.17597 1.3328 0.26562 1.9746 0.26562 1.5031 0 2.7025-0.21245 3.5977-0.63477 0.89511-0.42232 1.5798-0.94076 2.0527-1.5566 0.47289-0.59829 0.777-1.2493 0.91211-1.9531 0.152-0.70386 0.22656-1.3295 0.22656-1.875v-12.775h-3.4199v1.8223h-0.05078c-0.43911-0.79185-0.98782-1.3551-1.6465-1.6895-0.64178-0.33434-1.3926-0.50195-2.2539-0.50195zm16.523 0c-0.99644 0-1.9088 0.18516-2.7363 0.55469-0.81067 0.36953-1.5124 0.88017-2.1035 1.5312-0.59111 0.63348-1.0463 1.3897-1.3672 2.2695s-0.48047 1.831-0.48047 2.8516c0 1.0558 0.15108 2.0225 0.45508 2.9023 0.32089 0.87983 0.76758 1.6361 1.3418 2.2695 0.57422 0.63348 1.276 1.1266 2.1035 1.4785 0.82756 0.33434 1.7569 0.50195 2.7871 0.50195 1.4862 0 2.7517-0.35278 3.7988-1.0566 1.0471-0.70386 1.8254-1.8733 2.332-3.5098h-3.168c-0.11822 0.42232-0.43934 0.82772-0.96289 1.2148-0.52355 0.36953-1.1468 0.55274-1.873 0.55273-1.0133 0-1.7916-0.27286-2.332-0.81836-0.54044-0.5455-0.83605-1.4245-0.88672-2.6387h9.4492c0.06756-1.0558-0.01551-2.0673-0.25195-3.0352-0.23644-0.96782-0.62557-1.8293-1.166-2.5859-0.52356-0.75666-1.1998-1.355-2.0273-1.7949-0.82756-0.45751-1.7974-0.6875-2.9121-0.6875zm16.189 0c-0.76 0-1.5023 0.18516-2.2285 0.55469-0.72622 0.35193-1.3174 0.923-1.7734 1.7148h-0.07617v-1.9004h-3.4199v13.646h3.5977v-7.1523c0-1.3901 0.21909-2.3841 0.6582-2.9824 0.43911-0.61588 1.1494-0.92383 2.1289-0.92383 0.86133 0 1.461 0.28066 1.7988 0.84375 0.33778 0.5455 0.50586 1.3816 0.50586 2.5078v7.707h3.5977v-8.3926c0-0.84464-0.0765-1.6106-0.22852-2.2969-0.13511-0.70387-0.3797-1.2925-0.73437-1.7676-0.35466-0.49271-0.84386-0.87277-1.4688-1.1367-0.608-0.28155-1.3948-0.42188-2.3574-0.42188zm-66.062 0.36914 4.3066 6.4668-4.7129 7.1797h4.0293l2.7363-4.3027 2.7344 4.3027h4.1055l-4.8398-7.2578 4.3066-6.3887h-3.9766l-2.2793 3.5645-2.3066-3.5645zm13.275 0 4.584 12.803c0.10133 0.26395 0.15234 0.54461 0.15234 0.84375 0 0.40472-0.11707 0.77504-0.35352 1.1094-0.21956 0.33434-0.56617 0.52729-1.0391 0.58008-0.35467 0.0176-0.70979 0.0098-1.0645-0.02539-0.35467-0.03519-0.70128-0.07027-1.0391-0.10547v3.0879c0.37156 0.03519 0.73518 0.06052 1.0898 0.07813 0.37156 0.03519 0.74368 0.05273 1.1152 0.05273 1.2329 0 2.1943-0.23778 2.8867-0.71289 0.69244-0.47511 1.2326-1.2664 1.6211-2.375l5.4727-15.336h-3.7246l-2.8613 9.3437h-0.05078l-2.9648-9.3437zm-37.48 2.4551c0.59111 0 1.0823 0.12279 1.4707 0.36914s0.6991 0.57184 0.93555 0.97656c0.25333 0.38713 0.43187 0.84515 0.5332 1.373 0.10133 0.5103 0.15234 1.0482 0.15234 1.6113 0 0.56309-0.05101 1.1069-0.15234 1.6348-0.10133 0.5279-0.27137 1.0035-0.50781 1.4258-0.23644 0.40472-0.5556 0.73021-0.96094 0.97656-0.38844 0.24635-0.87959 0.36914-1.4707 0.36914-0.55733 0-1.038-0.12279-1.4434-0.36914-0.38844-0.26395-0.71806-0.59723-0.98828-1.002-0.25333-0.42232-0.43842-0.89788-0.55664-1.4258s-0.17773-1.0561-0.17773-1.584c-1e-7 -0.56309 0.05101-1.0991 0.15234-1.6094 0.11822-0.5279 0.29481-0.99567 0.53125-1.4004 0.25333-0.40472 0.58295-0.73021 0.98828-0.97656 0.40533-0.24635 0.90303-0.36914 1.4941-0.36914zm15.84 0c0.608 0 1.1142 0.13254 1.5195 0.39648 0.42222 0.24635 0.75184 0.57184 0.98828 0.97656 0.25333 0.40472 0.42992 0.87054 0.53125 1.3984 0.10133 0.5279 0.15234 1.0658 0.15234 1.6113 0 0.5455-0.05101 1.0815-0.15234 1.6094-0.10133 0.5103-0.27792 0.97612-0.53125 1.3984-0.23644 0.40472-0.56606 0.73021-0.98828 0.97656-0.40533 0.24635-0.91153 0.36914-1.5195 0.36914-0.608 0-1.1142-0.12279-1.5195-0.36914s-0.73495-0.57184-0.98828-0.97656c-0.23644-0.42232-0.40648-0.88813-0.50781-1.3984-0.10133-0.5279-0.15234-1.0639-0.15234-1.6094 0-0.5455 0.05101-1.0834 0.15234-1.6113 0.10133-0.5279 0.27137-0.99371 0.50781-1.3984 0.25333-0.40472 0.58295-0.73021 0.98828-0.97656 0.40533-0.26395 0.91153-0.39648 1.5195-0.39648zm42.602 0c0.59111 0 1.0803 0.11499 1.4688 0.34375 0.38844 0.22876 0.70106 0.5367 0.9375 0.92383 0.23644 0.38713 0.40648 0.8354 0.50781 1.3457 0.10133 0.49271 0.15039 1.0209 0.15039 1.584 0 0.49271-0.06606 0.96827-0.20117 1.4258-0.11822 0.43992-0.30526 0.83557-0.55859 1.1875-0.25333 0.35193-0.57445 0.63259-0.96289 0.84375-0.38844 0.21116-0.83513 0.31836-1.3418 0.31836-0.55733 0-1.021-0.12474-1.3926-0.37109-0.37156-0.24635-0.67566-0.56209-0.91211-0.94922-0.21956-0.38713-0.38109-0.81786-0.48242-1.293-0.08444-0.49271-0.12695-0.98581-0.12695-1.4785 0-0.5103 0.05101-0.99366 0.15234-1.4512 0.11822-0.47511 0.29676-0.89026 0.5332-1.2422 0.25333-0.36953 0.55744-0.65993 0.91211-0.87109 0.37156-0.21116 0.80974-0.31641 1.3164-0.31641zm15.535 0c0.87822 0 1.529 0.24753 1.9512 0.74024 0.43911 0.49271 0.74322 1.2138 0.91211 2.1641h-5.8535c0.01689-0.26395 0.0679-0.5641 0.15234-0.89844 0.10133-0.33434 0.26287-0.65008 0.48242-0.94922 0.23644-0.29914 0.54055-0.54667 0.91211-0.74023 0.38845-0.21116 0.86914-0.31641 1.4434-0.31641z" fill="url(#e)" stroke="#4665A2" stroke-width=".7"/>
+  <path d="m52.988 27.291c0.99602-1.0359 1.3944-1.8725 1.7928-3.1076l3.8247-0.03984c0.3113 1.6096 0.82413 2.5137 1.6335 3.1474z" fill="url(#b)" stroke="#000" stroke-width=".5"/>
+  <path d="m73.89 24.04 28.885-0.2011-0.12476 3.3879-31.033 0.16229c1.2621-1.0234 1.9665-2.2859 2.2724-3.3491z" fill="url(#c)" stroke="#000" stroke-width=".41788"/>
+ </g>
+</svg>
Binary files 2.10.0-1/doc/doxygen-doc/html/dudley.png and 2.11.0-1/doc/doxygen-doc/html/dudley.png differ
diff -pruN 2.10.0-1/doc/doxygen-doc/html/dynsections.js 2.11.0-1/doc/doxygen-doc/html/dynsections.js
--- 2.10.0-1/doc/doxygen-doc/html/dynsections.js	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/dynsections.js	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,192 @@
+/*
+ @licstart  The following is the entire license notice for the JavaScript code in this file.
+
+ The MIT License (MIT)
+
+ Copyright (C) 1997-2020 by Dimitri van Heesch
+
+ Permission is hereby granted, free of charge, to any person obtaining a copy of this software
+ and associated documentation files (the "Software"), to deal in the Software without restriction,
+ including without limitation the rights to use, copy, modify, merge, publish, distribute,
+ sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
+ furnished to do so, subject to the following conditions:
+
+ The above copyright notice and this permission notice shall be included in all copies or
+ substantial portions of the Software.
+
+ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
+ BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
+ DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+
+ @licend  The above is the entire license notice for the JavaScript code in this file
+ */
+function toggleVisibility(linkObj)
+{
+ var base = $(linkObj).attr('id');
+ var summary = $('#'+base+'-summary');
+ var content = $('#'+base+'-content');
+ var trigger = $('#'+base+'-trigger');
+ var src=$(trigger).attr('src');
+ if (content.is(':visible')===true) {
+   content.hide();
+   summary.show();
+   $(linkObj).addClass('closed').removeClass('opened');
+   $(trigger).attr('src',src.substring(0,src.length-8)+'closed.png');
+ } else {
+   content.show();
+   summary.hide();
+   $(linkObj).removeClass('closed').addClass('opened');
+   $(trigger).attr('src',src.substring(0,src.length-10)+'open.png');
+ }
+ return false;
+}
+
+function updateStripes()
+{
+  $('table.directory tr').
+       removeClass('even').filter(':visible:even').addClass('even');
+  $('table.directory tr').
+       removeClass('odd').filter(':visible:odd').addClass('odd');
+}
+
+function toggleLevel(level)
+{
+  $('table.directory tr').each(function() {
+    var l = this.id.split('_').length-1;
+    var i = $('#img'+this.id.substring(3));
+    var a = $('#arr'+this.id.substring(3));
+    if (l<level+1) {
+      i.removeClass('iconfopen iconfclosed').addClass('iconfopen');
+      a.html('&#9660;');
+      $(this).show();
+    } else if (l==level+1) {
+      i.removeClass('iconfclosed iconfopen').addClass('iconfclosed');
+      a.html('&#9658;');
+      $(this).show();
+    } else {
+      $(this).hide();
+    }
+  });
+  updateStripes();
+}
+
+function toggleFolder(id)
+{
+  // the clicked row
+  var currentRow = $('#row_'+id);
+
+  // all rows after the clicked row
+  var rows = currentRow.nextAll("tr");
+
+  var re = new RegExp('^row_'+id+'\\d+_$', "i"); //only one sub
+
+  // only match elements AFTER this one (can't hide elements before)
+  var childRows = rows.filter(function() { return this.id.match(re); });
+
+  // first row is visible we are HIDING
+  if (childRows.filter(':first').is(':visible')===true) {
+    // replace down arrow by right arrow for current row
+    var currentRowSpans = currentRow.find("span");
+    currentRowSpans.filter(".iconfopen").removeClass("iconfopen").addClass("iconfclosed");
+    currentRowSpans.filter(".arrow").html('&#9658;');
+    rows.filter("[id^=row_"+id+"]").hide(); // hide all children
+  } else { // we are SHOWING
+    // replace right arrow by down arrow for current row
+    var currentRowSpans = currentRow.find("span");
+    currentRowSpans.filter(".iconfclosed").removeClass("iconfclosed").addClass("iconfopen");
+    currentRowSpans.filter(".arrow").html('&#9660;');
+    // replace down arrows by right arrows for child rows
+    var childRowsSpans = childRows.find("span");
+    childRowsSpans.filter(".iconfopen").removeClass("iconfopen").addClass("iconfclosed");
+    childRowsSpans.filter(".arrow").html('&#9658;');
+    childRows.show(); //show all children
+  }
+  updateStripes();
+}
+
+
+function toggleInherit(id)
+{
+  var rows = $('tr.inherit.'+id);
+  var img = $('tr.inherit_header.'+id+' img');
+  var src = $(img).attr('src');
+  if (rows.filter(':first').is(':visible')===true) {
+    rows.css('display','none');
+    $(img).attr('src',src.substring(0,src.length-8)+'closed.png');
+  } else {
+    rows.css('display','table-row'); // using show() causes jump in firefox
+    $(img).attr('src',src.substring(0,src.length-10)+'open.png');
+  }
+}
+
+var opened=true;
+// in case HTML_COLORSTYLE is LIGHT or DARK the vars will be replaced, so we write them out explicitly and use double quotes
+var plusImg  = [ "var(--fold-plus-image)",  "var(--fold-plus-image-relpath)" ];
+var minusImg = [ "var(--fold-minus-image)", "var(--fold-minus-image-relpath)" ];
+
+// toggle all folding blocks
+function codefold_toggle_all(relPath) {
+ if (opened) {
+   $('#fold_all').css('background-image',plusImg[relPath]);
+   $('div[id^=foldopen]').hide();
+   $('div[id^=foldclosed]').show();
+ } else {
+   $('#fold_all').css('background-image',minusImg[relPath]);
+   $('div[id^=foldopen]').show();
+   $('div[id^=foldclosed]').hide();
+ }
+ opened=!opened;
+}
+
+// toggle single folding block
+function codefold_toggle(id) {
+  $('#foldopen'+id).toggle();
+  $('#foldclosed'+id).toggle();
+}
+function init_codefold(relPath) {
+  $('span[class=lineno]').css(
+    {'padding-right':'4px',
+     'margin-right':'2px',
+     'display':'inline-block',
+     'width':'54px',
+     'background':'linear-gradient(var(--fold-line-color),var(--fold-line-color)) no-repeat 46px/2px 100%'
+    });
+  // add global toggle to first line
+  $('span[class=lineno]:first').append('<span class="fold" id="fold_all" '+
+                                             'onclick="javascript:codefold_toggle_all('+relPath+');" '+
+                                             'style="background-image:'+minusImg[relPath]+';"></span>');
+  // add vertical lines to other rows
+  $('span[class=lineno]').not(':eq(0)').append('<span class="fold"></span>');
+  // add toggle controls to lines with fold divs
+  $('div[class=foldopen]').each(function() {
+    // extract specific id to use
+    var id    = $(this).attr('id').replace('foldopen','');
+    // extract start and end foldable fragment attributes
+    var start = $(this).attr('data-start');
+    var end   = $(this).attr('data-end');
+    // replace normal fold span with controls for the first line of a foldable fragment
+    $(this).find('span[class=fold]:first').replaceWith('<span class="fold" '+
+                                                       'onclick="javascript:codefold_toggle(\''+id+'\');" '+
+                                                       'style="background-image:'+minusImg[relPath]+';"></span>');
+    // append div for folded (closed) representation
+    $(this).after('<div id="foldclosed'+id+'" class="foldclosed" style="display:none;"></div>');
+    // extract the first line from the "open" section to represent closed content
+    var line = $(this).children().first().clone();
+    // remove any glow that might still be active on the original line
+    $(line).removeClass('glow');
+    if (start) {
+      // if line already ends with a start marker (e.g. trailing {), remove it
+      $(line).html($(line).html().replace(new RegExp('\\s*'+start+'\\s*$','g'),''));
+    }
+    // replace minus with plus symbol
+    $(line).find('span[class=fold]').css('background-image',plusImg[relPath]);
+    // append ellipsis
+    $(line).append(' '+start+'<a href="javascript:codefold_toggle(\''+id+'\')">&#8230;</a>'+end);
+    // insert constructed line into closed div
+    $('#foldclosed'+id).html(line);
+  });
+}
+
+/* @license-end */
Binary files 2.10.0-1/doc/doxygen-doc/html/emmett.png and 2.11.0-1/doc/doxygen-doc/html/emmett.png differ
diff -pruN 2.10.0-1/doc/doxygen-doc/html/folderclosed.svg 2.11.0-1/doc/doxygen-doc/html/folderclosed.svg
--- 2.10.0-1/doc/doxygen-doc/html/folderclosed.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/folderclosed.svg	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,11 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
+ "https://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
+<svg version="1.1" width="16" height="24" viewBox="0 0 32 32" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xml:space="preserve">
+<g style="fill:#4665A2;">
+<path d="M1,5.998l-0,16.002c-0,1.326 0.527,2.598 1.464,3.536c0.938,0.937 2.21,1.464 3.536,1.464c5.322,0 14.678,-0 20,0c1.326,0 2.598,-0.527 3.536,-1.464c0.937,-0.938 1.464,-2.21 1.464,-3.536c0,-3.486 0,-8.514 0,-12c0,-1.326 -0.527,-2.598 -1.464,-3.536c-0.938,-0.937 -2.21,-1.464 -3.536,-1.464c-0,0 -10.586,0 -10.586,0c0,-0 -3.707,-3.707 -3.707,-3.707c-0.187,-0.188 -0.442,-0.293 -0.707,-0.293l-5.002,0c-2.76,0 -4.998,2.238 -4.998,4.998Zm2,-0l-0,16.002c-0,0.796 0.316,1.559 0.879,2.121c0.562,0.563 1.325,0.879 2.121,0.879l20,0c0.796,0 1.559,-0.316 2.121,-0.879c0.563,-0.562 0.879,-1.325 0.879,-2.121c0,-3.486 0,-8.514 0,-12c0,-0.796 -0.316,-1.559 -0.879,-2.121c-0.562,-0.563 -1.325,-0.879 -2.121,-0.879c-7.738,0 -11,0 -11,0c-0.265,0 -0.52,-0.105 -0.707,-0.293c-0,0 -3.707,-3.707 -3.707,-3.707c-0,0 -4.588,0 -4.588,0c-1.656,0 -2.998,1.342 -2.998,2.998Z"/>
+</g>
+<g style="fill:#D8DFEE;stroke-width:0;">
+<path d="M 5.6063709,24.951908 C 4.3924646,24.775461 3.4197129,23.899792 3.1031586,22.698521 L 3.0216155,22.389078 V 13.997725 5.6063709 L 3.1037477,5.2982247 C 3.3956682,4.2029881 4.1802788,3.412126 5.2787258,3.105917 5.5646428,3.0262132 5.6154982,3.0244963 8.0611641,3.0119829 l 2.4911989,-0.012746 1.932009,1.9300342 c 1.344142,1.3427669 1.976319,1.9498819 2.07763,1.9952626 0.137456,0.061571 0.474218,0.066269 6.006826,0.083795 l 5.861206,0.018568 0.29124,0.081916 c 1.094895,0.3079569 1.890116,1.109428 2.175567,2.192667 l 0.08154,0.3094425 V 16 22.389078 l -0.08154,0.309443 c -0.28446,1.079482 -1.086411,1.888085 -2.175567,2.193614 l -0.29124,0.0817 -10.302616,0.0049 c -5.700217,0.0027 -10.4001945,-0.0093 -10.5210471,-0.02684 z"/>
+</g>
+</svg>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/folderclosedd.svg 2.11.0-1/doc/doxygen-doc/html/folderclosedd.svg
--- 2.10.0-1/doc/doxygen-doc/html/folderclosedd.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/folderclosedd.svg	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,11 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
+ "https://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
+<svg version="1.1" width="16" height="24" viewBox="0 0 32 32" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xml:space="preserve">
+<g style="fill:#C4CFE5;">
+<path d="M1,5.998l-0,16.002c-0,1.326 0.527,2.598 1.464,3.536c0.938,0.937 2.21,1.464 3.536,1.464c5.322,0 14.678,-0 20,0c1.326,0 2.598,-0.527 3.536,-1.464c0.937,-0.938 1.464,-2.21 1.464,-3.536c0,-3.486 0,-8.514 0,-12c0,-1.326 -0.527,-2.598 -1.464,-3.536c-0.938,-0.937 -2.21,-1.464 -3.536,-1.464c-0,0 -10.586,0 -10.586,0c0,-0 -3.707,-3.707 -3.707,-3.707c-0.187,-0.188 -0.442,-0.293 -0.707,-0.293l-5.002,0c-2.76,0 -4.998,2.238 -4.998,4.998Zm2,-0l-0,16.002c-0,0.796 0.316,1.559 0.879,2.121c0.562,0.563 1.325,0.879 2.121,0.879l20,0c0.796,0 1.559,-0.316 2.121,-0.879c0.563,-0.562 0.879,-1.325 0.879,-2.121c0,-3.486 0,-8.514 0,-12c0,-0.796 -0.316,-1.559 -0.879,-2.121c-0.562,-0.563 -1.325,-0.879 -2.121,-0.879c-7.738,0 -11,0 -11,0c-0.265,0 -0.52,-0.105 -0.707,-0.293c-0,0 -3.707,-3.707 -3.707,-3.707c-0,0 -4.588,0 -4.588,0c-1.656,0 -2.998,1.342 -2.998,2.998Z"/>
+</g>
+<g style="fill:#4665A2;stroke-width:0;">
+<path d="M 5.6063709,24.951908 C 4.3924646,24.775461 3.4197129,23.899792 3.1031586,22.698521 L 3.0216155,22.389078 V 13.997725 5.6063709 L 3.1037477,5.2982247 C 3.3956682,4.2029881 4.1802788,3.412126 5.2787258,3.105917 5.5646428,3.0262132 5.6154982,3.0244963 8.0611641,3.0119829 l 2.4911989,-0.012746 1.932009,1.9300342 c 1.344142,1.3427669 1.976319,1.9498819 2.07763,1.9952626 0.137456,0.061571 0.474218,0.066269 6.006826,0.083795 l 5.861206,0.018568 0.29124,0.081916 c 1.094895,0.3079569 1.890116,1.109428 2.175567,2.192667 l 0.08154,0.3094425 V 16 22.389078 l -0.08154,0.309443 c -0.28446,1.079482 -1.086411,1.888085 -2.175567,2.193614 l -0.29124,0.0817 -10.302616,0.0049 c -5.700217,0.0027 -10.4001945,-0.0093 -10.5210471,-0.02684 z"/>
+</g>
+</svg>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/folderopen.svg 2.11.0-1/doc/doxygen-doc/html/folderopen.svg
--- 2.10.0-1/doc/doxygen-doc/html/folderopen.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/folderopen.svg	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
+ "https://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
+<svg version="1.1" width="16" height="24" viewBox="0 0 32 32" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xml:space="preserve">
+<g style="fill:#4665A2;">
+<path
+   d="M1,5.998l0,16.002c-0,1.326 0.527,2.598 1.464,3.536c0.938,0.937 2.21,1.464 3.536,1.464c5.322,0 14.678,-0 20,0c1.326,0 2.598,-0.527 3.536,-1.464c0.937,-0.938 1.464,-2.21 1.464,-3.536c0,-3.486 0,-8.514 0,-12c0,-1.326 -0.527,-2.598 -1.464,-3.536c-0.938,-0.937 -2.21,-1.464 -3.536,-1.464c-0,0 -10.586,0 -10.586,0c0,-0 -3.707,-3.707 -3.707,-3.707c-0.187,-0.188 -0.442,-0.293 -0.707,-0.293l-5.002,0c-2.76,0 -4.998,2.238 -4.998,4.998Zm28,14.415l-3.456,-5.925c-0.538,-0.921 -1.524,-1.488 -2.591,-1.488c-0,0 -12.905,0 -12.906,0c-1.067,0 -2.053,0.567 -2.591,1.488l-4.453,7.635c0.03,0.751 0.342,1.465 0.876,1.998c0.562,0.563 1.325,0.879 2.121,0.879l20,0c0.796,0 1.559,-0.316 2.121,-0.879c0.563,-0.562 0.879,-1.325 0.879,-2.121l0,-1.587Zm0,-3.969l0,-6.444c0,-0.796 -0.316,-1.559 -0.879,-2.121c-0.562,-0.563 -1.325,-0.879 -2.121,-0.879c-7.738,0 -11,0 -11,0c-0.265,0 -0.52,-0.105 -0.707,-0.293c-0,0 -3.707,-3.707 -3.707,-3.707c-0,0 -4.588,0 -4.588,0c-1.656,0 -2.998,1.342 -2.998,2.998l0,12.16l2.729,-4.677c0.896,-1.536 2.54,-2.481 4.318,-2.481c3.354,0 9.552,0 12.906,0c1.778,0 3.422,0.945 4.318,2.481l1.729,2.963Z"
+   id="path2" />
+</g>
+<g style="fill:#D8DFEE;stroke-width:0;">
+<path
+   d="M 5.3879408,24.913408 C 4.1598821,24.650818 3.1571088,23.558656 3.053503,22.370876 L 3.0312746,22.116041 5.2606813,18.293515 C 6.486855,16.191126 7.5598351,14.372696 7.6450818,14.25256 8.0043056,13.746312 8.5423079,13.363007 9.2104664,13.137285 l 0.2548351,-0.08609 6.9294785,-0.0097 c 6.805096,-0.0095 6.934944,-0.0084 7.234011,0.06267 0.695577,0.165199 1.290483,0.557253 1.714887,1.130141 0.08158,0.110125 0.938747,1.556711 1.90481,3.214634 l 1.756479,3.014406 -0.0186,0.971942 c -0.01387,0.724723 -0.03365,1.032131 -0.07778,1.208575 -0.242792,0.970733 -0.88732,1.735415 -1.772382,2.102793 -0.58835,0.244217 0.247209,0.227436 -11.161974,0.224159 -9.0281537,-0.0026 -10.3636023,-0.0098 -10.5862902,-0.05746 z"
+   id="path199" /><path
+   d="M 3.0126385,11.849829 3.0235061,5.5881684 3.1020974,5.2969283 C 3.3478146,4.3863605 3.93576,3.6757372 4.756668,3.2971229 5.3293315,3.0330025 5.1813272,3.0450949 8.0130385,3.0310668 l 2.5522875,-0.012644 1.918693,1.9107086 c 1.404146,1.3983023 1.964459,1.9332518 2.089351,1.9947704 l 0.170657,0.084062 5.897611,0.019367 c 5.553257,0.018236 5.910365,0.023213 6.116041,0.085231 1.102257,0.3323708 1.857042,1.1184422 2.154229,2.2435244 0.05645,0.2137228 0.06373,0.5643981 0.07519,3.6220748 0.0076,2.032169 -5.42e-4,3.370979 -0.02041,3.349261 -0.0182,-0.0199 -0.414296,-0.691472 -0.880217,-1.492382 -0.46592,-0.80091 -0.93093,-1.577954 -1.033354,-1.726764 -0.735716,-1.0689 -1.983568,-1.844244 -3.315972,-2.060353 -0.280375,-0.04548 -1.345158,-0.05334 -7.238708,-0.05347 -4.713933,-1.09e-4 -6.9931825,0.01221 -7.1717862,0.03874 -1.3002273,0.193134 -2.4770512,0.889916 -3.283628,1.944192 -0.1076466,0.140705 -0.8359664,1.353438 -1.6184885,2.694963 L 3.0017709,18.11149 Z"
+   id="path201" />
+</g>
+</svg>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/folderopend.svg 2.11.0-1/doc/doxygen-doc/html/folderopend.svg
--- 2.10.0-1/doc/doxygen-doc/html/folderopend.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/folderopend.svg	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,12 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
+ "https://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
+<svg version="1.1" width="16" height="24" viewBox="0 0 32 32" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xml:space="preserve">
+<g style="fill:#C4CFE5;">
+<path d="M1,5.998l0,16.002c-0,1.326 0.527,2.598 1.464,3.536c0.938,0.937 2.21,1.464 3.536,1.464c5.322,0 14.678,-0 20,0c1.326,0 2.598,-0.527 3.536,-1.464c0.937,-0.938 1.464,-2.21 1.464,-3.536c0,-3.486 0,-8.514 0,-12c0,-1.326 -0.527,-2.598 -1.464,-3.536c-0.938,-0.937 -2.21,-1.464 -3.536,-1.464c-0,0 -10.586,0 -10.586,0c0,-0 -3.707,-3.707 -3.707,-3.707c-0.187,-0.188 -0.442,-0.293 -0.707,-0.293l-5.002,0c-2.76,0 -4.998,2.238 -4.998,4.998Zm28,14.415l-3.456,-5.925c-0.538,-0.921 -1.524,-1.488 -2.591,-1.488c-0,0 -12.905,0 -12.906,0c-1.067,0 -2.053,0.567 -2.591,1.488l-4.453,7.635c0.03,0.751 0.342,1.465 0.876,1.998c0.562,0.563 1.325,0.879 2.121,0.879l20,0c0.796,0 1.559,-0.316 2.121,-0.879c0.563,-0.562 0.879,-1.325 0.879,-2.121l0,-1.587Zm0,-3.969l0,-6.444c0,-0.796 -0.316,-1.559 -0.879,-2.121c-0.562,-0.563 -1.325,-0.879 -2.121,-0.879c-7.738,0 -11,0 -11,0c-0.265,0 -0.52,-0.105 -0.707,-0.293c-0,0 -3.707,-3.707 -3.707,-3.707c-0,0 -4.588,0 -4.588,0c-1.656,0 -2.998,1.342 -2.998,2.998l0,12.16l2.729,-4.677c0.896,-1.536 2.54,-2.481 4.318,-2.481c3.354,0 9.552,0 12.906,0c1.778,0 3.422,0.945 4.318,2.481l1.729,2.963Z"/>
+</g>
+<g style="fill:#4665A2;stroke-width:0;">
+<path d="M 5.3879408,24.913408 C 4.1598821,24.650818 3.1571088,23.558656 3.053503,22.370876 L 3.0312746,22.116041 5.2606813,18.293515 C 6.486855,16.191126 7.5598351,14.372696 7.6450818,14.25256 8.0043056,13.746312 8.5423079,13.363007 9.2104664,13.137285 l 0.2548351,-0.08609 6.9294785,-0.0097 c 6.805096,-0.0095 6.934944,-0.0084 7.234011,0.06267 0.695577,0.165199 1.290483,0.557253 1.714887,1.130141 0.08158,0.110125 0.938747,1.556711 1.90481,3.214634 l 1.756479,3.014406 -0.0186,0.971942 c -0.01387,0.724723 -0.03365,1.032131 -0.07778,1.208575 -0.242792,0.970733 -0.88732,1.735415 -1.772382,2.102793 -0.58835,0.244217 0.247209,0.227436 -11.161974,0.224159 -9.0281537,-0.0026 -10.3636023,-0.0098 -10.5862902,-0.05746 z" />
+<path d="M 3.0126385,11.849829 3.0235061,5.5881684 3.1020974,5.2969283 C 3.3478146,4.3863605 3.93576,3.6757372 4.756668,3.2971229 5.3293315,3.0330025 5.1813272,3.0450949 8.0130385,3.0310668 l 2.5522875,-0.012644 1.918693,1.9107086 c 1.404146,1.3983023 1.964459,1.9332518 2.089351,1.9947704 l 0.170657,0.084062 5.897611,0.019367 c 5.553257,0.018236 5.910365,0.023213 6.116041,0.085231 1.102257,0.3323708 1.857042,1.1184422 2.154229,2.2435244 0.05645,0.2137228 0.06373,0.5643981 0.07519,3.6220748 0.0076,2.032169 -5.42e-4,3.370979 -0.02041,3.349261 -0.0182,-0.0199 -0.414296,-0.691472 -0.880217,-1.492382 -0.46592,-0.80091 -0.93093,-1.577954 -1.033354,-1.726764 -0.735716,-1.0689 -1.983568,-1.844244 -3.315972,-2.060353 -0.280375,-0.04548 -1.345158,-0.05334 -7.238708,-0.05347 -4.713933,-1.09e-4 -6.9931825,0.01221 -7.1717862,0.03874 -1.3002273,0.193134 -2.4770512,0.889916 -3.283628,1.944192 -0.1076466,0.140705 -0.8359664,1.353438 -1.6184885,2.694963 L 3.0017709,18.11149 Z" />
+</g>
+</svg>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/functions.html 2.11.0-1/doc/doxygen-doc/html/functions.html
--- 2.10.0-1/doc/doxygen-doc/html/functions.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/functions.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,276 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Data Fields</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="contents">
+<div class="textblock">Here is a list of all struct and union fields with links to the structures/unions they belong to:</div>
+
+<h3><a id="index_a" name="index_a"></a>- a -</h3><ul>
+<li>abi&#160;:&#160;<a class="el" href="a00373.html#a3250bd6fc9713946991d805e48091b2e">hwloc_component</a></li>
+<li>alloc_membind&#160;:&#160;<a class="el" href="a00289.html#ae551abb27d2aa9ce008583488b845b98">hwloc_topology_membind_support</a></li>
+<li>arity&#160;:&#160;<a class="el" href="a00229.html#aac3f6da35c9b57599909a44ce2b716c1">hwloc_obj</a></li>
+<li>associativity&#160;:&#160;<a class="el" href="a00245.html#ad06525e474d1e2d1423ed71bb998592d">hwloc_obj_attr_u::hwloc_cache_attr_s</a></li>
+<li>attr&#160;:&#160;<a class="el" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_b" name="index_b"></a>- b -</h3><ul>
+<li>bind_membind&#160;:&#160;<a class="el" href="a00289.html#ae7cdb1f1b5f0242a69f85b5a5538c764">hwloc_topology_membind_support</a></li>
+<li>bridge&#160;:&#160;<a class="el" href="a00233.html#a207e6359497b7116d6f4baa9e8bbeb43">hwloc_obj_attr_u</a></li>
+<li>bus&#160;:&#160;<a class="el" href="a00317.html#a4a23e3cc034b7ab105cab0e863dcab69">hwloc_cl_device_topology_amd</a>, <a class="el" href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+</ul>
+
+
+<h3><a id="index_c" name="index_c"></a>- c -</h3><ul>
+<li>cache&#160;:&#160;<a class="el" href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">hwloc_obj_attr_u</a></li>
+<li>children&#160;:&#160;<a class="el" href="a00229.html#a04d05403da37bfe17cd63b7c7dd07b1f">hwloc_obj</a></li>
+<li>class_id&#160;:&#160;<a class="el" href="a00253.html#aee735352d9f1686fd290fc6d6397c334">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>complete_cpuset&#160;:&#160;<a class="el" href="a00229.html#a91788a9da687beb7224cc1fd7b75208c">hwloc_obj</a></li>
+<li>complete_nodeset&#160;:&#160;<a class="el" href="a00229.html#ac38c4012127525ef74c5615c526f4c2e">hwloc_obj</a></li>
+<li>count&#160;:&#160;<a class="el" href="a00241.html#a98514e37d57a325b78e21ffd8d7419e0">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s</a></li>
+<li>cpubind&#160;:&#160;<a class="el" href="a00297.html#adef2bb91f74c3e70a2a071393caf5f56">hwloc_topology_support</a></li>
+<li>cpukind_efficiency&#160;:&#160;<a class="el" href="a00281.html#aba80d6f9c15e2395f9ed61db9ff3b75d">hwloc_topology_discovery_support</a></li>
+<li>cpuset&#160;:&#160;<a class="el" href="a00309.html#a033bad8f6b891992f0c18b85a88c5561">hwloc_location::hwloc_location_u</a>, <a class="el" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_d" name="index_d"></a>- d -</h3><ul>
+<li>data&#160;:&#160;<a class="el" href="a00317.html#afbd6b814607b06fc5b2f36ad14420398">hwloc_cl_device_topology_amd</a>, <a class="el" href="a00373.html#a4b8cffd1d943c29fdc102b841b8598d4">hwloc_component</a></li>
+<li>depth&#160;:&#160;<a class="el" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">hwloc_obj</a>, <a class="el" href="a00257.html#a336c8b22893d5d734d8c9dfca4066b46">hwloc_obj_attr_u::hwloc_bridge_attr_s</a>, <a class="el" href="a00245.html#a5c8f7f39193736c2187ed626940835d5">hwloc_obj_attr_u::hwloc_cache_attr_s</a>, <a class="el" href="a00249.html#ad914eac61c77481e1b7037877bcc5579">hwloc_obj_attr_u::hwloc_group_attr_s</a></li>
+<li>dev&#160;:&#160;<a class="el" href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>device&#160;:&#160;<a class="el" href="a00317.html#a017033a953d71455b067007cabb92e9c">hwloc_cl_device_topology_amd</a></li>
+<li>device_id&#160;:&#160;<a class="el" href="a00253.html#a35b66064ab7d768caf7154e410caf0fa">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>diff&#160;:&#160;<a class="el" href="a00353.html#a91f0645f9062e892652357cd141c8ebb">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a></li>
+<li>disable&#160;:&#160;<a class="el" href="a00369.html#a36c4fa86350525b46340c67b802c69c7">hwloc_backend</a></li>
+<li>disallowed_numa&#160;:&#160;<a class="el" href="a00281.html#a970e65235873bcdb9669a9805161ce03">hwloc_topology_discovery_support</a></li>
+<li>disallowed_pu&#160;:&#160;<a class="el" href="a00281.html#af3c97b28781a2972cf8eaaf94a6617da">hwloc_topology_discovery_support</a></li>
+<li>discover&#160;:&#160;<a class="el" href="a00369.html#accff2cd8404be43c3b44cec05e6f609b">hwloc_backend</a></li>
+<li>discovery&#160;:&#160;<a class="el" href="a00297.html#aea3fbd7653d987d81f848636c420504d">hwloc_topology_support</a></li>
+<li>domain&#160;:&#160;<a class="el" href="a00257.html#a2c31e565a5f0d23d0a0a3dd3ec8f4b17">hwloc_obj_attr_u::hwloc_bridge_attr_s</a>, <a class="el" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>dont_merge&#160;:&#160;<a class="el" href="a00249.html#afa253d4b70f92e940c226d61f192054f">hwloc_obj_attr_u::hwloc_group_attr_s</a></li>
+<li>downstream&#160;:&#160;<a class="el" href="a00257.html#abe1e38eb5ac8dc59829c8dc045f0d747">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>downstream_type&#160;:&#160;<a class="el" href="a00257.html#ac6a169b672d0e9f75756fd5665828b93">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+</ul>
+
+
+<h3><a id="index_e" name="index_e"></a>- e -</h3><ul>
+<li>enabled_by_default&#160;:&#160;<a class="el" href="a00361.html#ace80cafe2b1732b047b3fc3da47e6517">hwloc_disc_component</a></li>
+<li>excluded_phases&#160;:&#160;<a class="el" href="a00361.html#acbb9957914dbf7b8f504215aa0c8d3fe">hwloc_disc_component</a>, <a class="el" href="a00365.html#a0f95fa42d46a6e7cf8dee8af12afee3a">hwloc_disc_status</a></li>
+</ul>
+
+
+<h3><a id="index_f" name="index_f"></a>- f -</h3><ul>
+<li>finalize&#160;:&#160;<a class="el" href="a00373.html#a4612015451a1c706e8ba19114cb8baae">hwloc_component</a></li>
+<li>first_child&#160;:&#160;<a class="el" href="a00229.html#af51d08a0a79dba517c06c5afedc8d2dc">hwloc_obj</a></li>
+<li>firsttouch_membind&#160;:&#160;<a class="el" href="a00289.html#a221098c339dbfab27bd2c9f5d32f123b">hwloc_topology_membind_support</a></li>
+<li>flags&#160;:&#160;<a class="el" href="a00369.html#aaa8eafe495aadd81c2e3c4ec527c10ba">hwloc_backend</a>, <a class="el" href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">hwloc_component</a>, <a class="el" href="a00365.html#ad8b123cecb945a9182eb824ccf8ef9d7">hwloc_disc_status</a></li>
+<li>func&#160;:&#160;<a class="el" href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>function&#160;:&#160;<a class="el" href="a00317.html#a77a67ac73cff98d330ef7258b240bac3">hwloc_cl_device_topology_amd</a></li>
+</ul>
+
+
+<h3><a id="index_g" name="index_g"></a>- g -</h3><ul>
+<li>generic&#160;:&#160;<a class="el" href="a00329.html#aeb449c0e04b14ebf8c3126756b6364f9">hwloc_topology_diff_obj_attr_u</a>, <a class="el" href="a00345.html#a0dd2cbfba0eca2fc7a2645668bcae0f8">hwloc_topology_diff_u</a></li>
+<li>get_area_membind&#160;:&#160;<a class="el" href="a00289.html#a0a84e24a06f2fa487fe8c9605c6f68b3">hwloc_topology_membind_support</a></li>
+<li>get_area_memlocation&#160;:&#160;<a class="el" href="a00289.html#a30173553a68e0a4dd1672d26f8e892b1">hwloc_topology_membind_support</a></li>
+<li>get_pci_busid_cpuset&#160;:&#160;<a class="el" href="a00369.html#aaac253491264c20930f44817270bc502">hwloc_backend</a></li>
+<li>get_proc_cpubind&#160;:&#160;<a class="el" href="a00285.html#aae705bc447adc163ead377362c4dfe9f">hwloc_topology_cpubind_support</a></li>
+<li>get_proc_last_cpu_location&#160;:&#160;<a class="el" href="a00285.html#a2554620148b7992a5093f338f5ae254f">hwloc_topology_cpubind_support</a></li>
+<li>get_proc_membind&#160;:&#160;<a class="el" href="a00289.html#a9880cd2d605e316fc020167c49ca69ad">hwloc_topology_membind_support</a></li>
+<li>get_thisproc_cpubind&#160;:&#160;<a class="el" href="a00285.html#a77a09ddd78ee3e9ff5f532a6ac74f7eb">hwloc_topology_cpubind_support</a></li>
+<li>get_thisproc_last_cpu_location&#160;:&#160;<a class="el" href="a00285.html#ad2d5c94b738d92b7d2ede87e4e96321d">hwloc_topology_cpubind_support</a></li>
+<li>get_thisproc_membind&#160;:&#160;<a class="el" href="a00289.html#a3fd51e6fa5f0dd800322301b46b08559">hwloc_topology_membind_support</a></li>
+<li>get_thisthread_cpubind&#160;:&#160;<a class="el" href="a00285.html#a80d762e532d677dff262d83cc7bb1c60">hwloc_topology_cpubind_support</a></li>
+<li>get_thisthread_last_cpu_location&#160;:&#160;<a class="el" href="a00285.html#a6be1f042fdce6bf41b4ea39f6f193808">hwloc_topology_cpubind_support</a></li>
+<li>get_thisthread_membind&#160;:&#160;<a class="el" href="a00289.html#a63b0b2e26157b472f5717ee93cc7c535">hwloc_topology_membind_support</a></li>
+<li>get_thread_cpubind&#160;:&#160;<a class="el" href="a00285.html#a8dd4d8531ed2eebdce1507e7d104154e">hwloc_topology_cpubind_support</a></li>
+<li>gp_index&#160;:&#160;<a class="el" href="a00229.html#a957984a355fa61c85f46605c336e7551">hwloc_obj</a></li>
+<li>group&#160;:&#160;<a class="el" href="a00233.html#a9eddbd69e34cd2ef6af6d2ac31b6eff3">hwloc_obj_attr_u</a></li>
+</ul>
+
+
+<h3><a id="index_i" name="index_i"></a>- i -</h3><ul>
+<li>imported_support&#160;:&#160;<a class="el" href="a00293.html#adf54a6dbe8e9dd5033dfe9c93df726c4">hwloc_topology_misc_support</a></li>
+<li>index&#160;:&#160;<a class="el" href="a00337.html#adb772c3f1761ecadf496c80ae14afce3">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a></li>
+<li>infos&#160;:&#160;<a class="el" href="a00229.html#a8604654c38b7a720efae5025d3a96ee6">hwloc_obj</a></li>
+<li>infos_count&#160;:&#160;<a class="el" href="a00229.html#a9843acc28cfbba903b63ea14b137ff70">hwloc_obj</a></li>
+<li>init&#160;:&#160;<a class="el" href="a00373.html#aea613546886d9b8221cadba920fe3ebc">hwloc_component</a></li>
+<li>instantiate&#160;:&#160;<a class="el" href="a00361.html#a12e780d0acf89da7a8c8e37e51a3abcb">hwloc_disc_component</a></li>
+<li>interleave_membind&#160;:&#160;<a class="el" href="a00289.html#a3c44c6012860bbeba8a0f4c19710858d">hwloc_topology_membind_support</a></li>
+<li>io_arity&#160;:&#160;<a class="el" href="a00229.html#a7b3b29f0be377c7d2d52262019fc7d11">hwloc_obj</a></li>
+<li>io_first_child&#160;:&#160;<a class="el" href="a00229.html#a8d14c88e1ebc4ae67cc69f9e928558b3">hwloc_obj</a></li>
+<li>is_thissystem&#160;:&#160;<a class="el" href="a00369.html#ab8806f6db077f1bb2e9d63ec99223f7a">hwloc_backend</a></li>
+</ul>
+
+
+<h3><a id="index_k" name="index_k"></a>- k -</h3><ul>
+<li>kind&#160;:&#160;<a class="el" href="a00301.html#aef9c83cf467da1b1fa4c36493febb3b5">hwloc_distances_s</a>, <a class="el" href="a00249.html#a3229f269c4cc7e63492c168535e4f0c1">hwloc_obj_attr_u::hwloc_group_attr_s</a></li>
+</ul>
+
+
+<h3><a id="index_l" name="index_l"></a>- l -</h3><ul>
+<li>last_child&#160;:&#160;<a class="el" href="a00229.html#a84bd65634dbc55f4158b74443a9bd04f">hwloc_obj</a></li>
+<li>linesize&#160;:&#160;<a class="el" href="a00245.html#a801e8a668e28caf06c8b88e9ae5c10db">hwloc_obj_attr_u::hwloc_cache_attr_s</a></li>
+<li>linkspeed&#160;:&#160;<a class="el" href="a00253.html#a59b2fce35f7cbde86c4fd305d0ccda5f">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>local_memory&#160;:&#160;<a class="el" href="a00237.html#a6703cbf2afbf63c9d60c5ff4dc0c73aa">hwloc_obj_attr_u::hwloc_numanode_attr_s</a></li>
+<li>location&#160;:&#160;<a class="el" href="a00305.html#a707a25a5b65177e4d081be49aa0777a2">hwloc_location</a></li>
+<li>logical_index&#160;:&#160;<a class="el" href="a00229.html#a0d07fb7b8935e137c94d75a3eb492ae9">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_m" name="index_m"></a>- m -</h3><ul>
+<li>membind&#160;:&#160;<a class="el" href="a00297.html#ac6eb62ae8bc0a68dce679a7107a36194">hwloc_topology_support</a></li>
+<li>memory_arity&#160;:&#160;<a class="el" href="a00229.html#a6f834ea4dd26553cdea601d2fae6d3b7">hwloc_obj</a></li>
+<li>memory_first_child&#160;:&#160;<a class="el" href="a00229.html#ac0e8200dba25b90d5954bd4ec61f97d3">hwloc_obj</a></li>
+<li>migrate_membind&#160;:&#160;<a class="el" href="a00289.html#aafa7683871a6a760246f9b35209caec5">hwloc_topology_membind_support</a></li>
+<li>misc&#160;:&#160;<a class="el" href="a00297.html#ab9d08df4b0b03994f21b893ece826e78">hwloc_topology_support</a></li>
+<li>misc_arity&#160;:&#160;<a class="el" href="a00229.html#a2bb7862ce722d7ceda23cfa153da165a">hwloc_obj</a></li>
+<li>misc_first_child&#160;:&#160;<a class="el" href="a00229.html#a57812a313fe9b1a9500489f47c3011cc">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_n" name="index_n"></a>- n -</h3><ul>
+<li>name&#160;:&#160;<a class="el" href="a00361.html#a4064c3b5d9213027e87caebef380a840">hwloc_disc_component</a>, <a class="el" href="a00277.html#a12ce1309e4381ae38b5c15d242a47124">hwloc_info_s</a>, <a class="el" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj</a>, <a class="el" href="a00341.html#a7ef48c66ccddf34d90edb4e4314b41c6">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a></li>
+<li>nbobjs&#160;:&#160;<a class="el" href="a00301.html#a4ca2af858cebbce7324ec49903d09474">hwloc_distances_s</a></li>
+<li>newvalue&#160;:&#160;<a class="el" href="a00341.html#a75f37f4add21cece50fee2701c3b77db">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a>, <a class="el" href="a00337.html#ae63aa59ad65aa783b730a4f213304eb4">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a></li>
+<li>next&#160;:&#160;<a class="el" href="a00349.html#a720aa94eb73cddfd8d6bf9fcbbfc035e">hwloc_topology_diff_u::hwloc_topology_diff_generic_s</a>, <a class="el" href="a00353.html#acb9170a8eb3392656d70f7f3ef3e3eed">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a>, <a class="el" href="a00357.html#a375afbaa043b109be689a7d9a3c7d153">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a></li>
+<li>next_cousin&#160;:&#160;<a class="el" href="a00229.html#a85a788017457129589318b6c39451acf">hwloc_obj</a></li>
+<li>next_sibling&#160;:&#160;<a class="el" href="a00229.html#a7f2343ed476fe4942e6fffd4cade1b40">hwloc_obj</a></li>
+<li>nexttouch_membind&#160;:&#160;<a class="el" href="a00289.html#ab0921af6e0cd6975812a80b8e5c7435c">hwloc_topology_membind_support</a></li>
+<li>nodeset&#160;:&#160;<a class="el" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">hwloc_obj</a></li>
+<li>numa&#160;:&#160;<a class="el" href="a00281.html#a955f96066cb9e4cd34e2a3710ad43e80">hwloc_topology_discovery_support</a></li>
+<li>numa_memory&#160;:&#160;<a class="el" href="a00281.html#af193eb858e40e12ef4923f5ed0e1f11a">hwloc_topology_discovery_support</a></li>
+<li>numanode&#160;:&#160;<a class="el" href="a00233.html#ad066b9612802ffa01e132dc3a8e6cc86">hwloc_obj_attr_u</a></li>
+</ul>
+
+
+<h3><a id="index_o" name="index_o"></a>- o -</h3><ul>
+<li>obj_attr&#160;:&#160;<a class="el" href="a00345.html#a01dca644feea48448b36baa60cf4c07f">hwloc_topology_diff_u</a></li>
+<li>obj_depth&#160;:&#160;<a class="el" href="a00353.html#a82c1d4bab80b9e0bf301a9d8291893e0">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a>, <a class="el" href="a00357.html#a94c6498caeaafbb79927395d918d6cb3">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a></li>
+<li>obj_index&#160;:&#160;<a class="el" href="a00353.html#adb9f4d414470b6670cde8d90759a6c1c">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a>, <a class="el" href="a00357.html#a6dc6b3c4adb10db74d993e37afaa0580">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a></li>
+<li>object&#160;:&#160;<a class="el" href="a00309.html#acf2ebf75869f0a53a884ac2ab3374122">hwloc_location::hwloc_location_u</a></li>
+<li>objs&#160;:&#160;<a class="el" href="a00301.html#af1e78b2d628d191fa6cae3fbfe891078">hwloc_distances_s</a></li>
+<li>oldvalue&#160;:&#160;<a class="el" href="a00341.html#a33cc281d4417129064295a6ae7b79818">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a>, <a class="el" href="a00337.html#a44c0894dce563335d347fde6595c49c9">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a></li>
+<li>os_index&#160;:&#160;<a class="el" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">hwloc_obj</a></li>
+<li>osdev&#160;:&#160;<a class="el" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">hwloc_obj_attr_u</a></li>
+</ul>
+
+
+<h3><a id="index_p" name="index_p"></a>- p -</h3><ul>
+<li>page_types&#160;:&#160;<a class="el" href="a00237.html#a7e53c5024da2d7741a5cc1e7016bb8d2">hwloc_obj_attr_u::hwloc_numanode_attr_s</a></li>
+<li>page_types_len&#160;:&#160;<a class="el" href="a00237.html#a513078122d403904e16723d30f583cb2">hwloc_obj_attr_u::hwloc_numanode_attr_s</a></li>
+<li>parent&#160;:&#160;<a class="el" href="a00229.html#adc494f6aed939992be1c55cca5822900">hwloc_obj</a></li>
+<li>pci&#160;:&#160;<a class="el" href="a00257.html#ab5c564e7c95b747dae9eb84ec0a2c31e">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>pci_bus&#160;:&#160;<a class="el" href="a00313.html#a0e4d316b01eee00c3750d1c853be9c01">hwloc_cl_device_pci_bus_info_khr</a></li>
+<li>pci_device&#160;:&#160;<a class="el" href="a00313.html#a328717bdaeb2d117c550927cf41e6f72">hwloc_cl_device_pci_bus_info_khr</a></li>
+<li>pci_domain&#160;:&#160;<a class="el" href="a00313.html#a5bdfbcb0dee610f9f6f7f95ace89e298">hwloc_cl_device_pci_bus_info_khr</a></li>
+<li>pci_function&#160;:&#160;<a class="el" href="a00313.html#ab4032f46a44cf9ffc7b2ddc25001e3f0">hwloc_cl_device_pci_bus_info_khr</a></li>
+<li>pcidev&#160;:&#160;<a class="el" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">hwloc_obj_attr_u</a></li>
+<li>pcie&#160;:&#160;<a class="el" href="a00317.html#aef8560f6c359be0c5bdbd2840580d79c">hwloc_cl_device_topology_amd</a></li>
+<li>phase&#160;:&#160;<a class="el" href="a00365.html#abaf7c8c082d43e133171f0723dbf824b">hwloc_disc_status</a></li>
+<li>phases&#160;:&#160;<a class="el" href="a00369.html#aeca769840a6ff03e96462a9533adbccd">hwloc_backend</a>, <a class="el" href="a00361.html#a61ad3151efa02e3dbad5d919758f9c90">hwloc_disc_component</a></li>
+<li>prev_cousin&#160;:&#160;<a class="el" href="a00229.html#ac715989f55ff5a0eb6be2969ee477ec0">hwloc_obj</a></li>
+<li>prev_sibling&#160;:&#160;<a class="el" href="a00229.html#a7b89e8c189876c0158a9282aaaf17f50">hwloc_obj</a></li>
+<li>priority&#160;:&#160;<a class="el" href="a00361.html#ae86d283c272c5ae24073a235efbf6b59">hwloc_disc_component</a></li>
+<li>private_data&#160;:&#160;<a class="el" href="a00369.html#a2ea5bd36b7f06efdb65b98b32af16c68">hwloc_backend</a></li>
+<li>pu&#160;:&#160;<a class="el" href="a00281.html#ad7bb4ecf7a82f5a04fc632e9592ad3ab">hwloc_topology_discovery_support</a></li>
+</ul>
+
+
+<h3><a id="index_r" name="index_r"></a>- r -</h3><ul>
+<li>raw&#160;:&#160;<a class="el" href="a00317.html#aeb5e5d12bf653f750dafedae6e225c3a">hwloc_cl_device_topology_amd</a></li>
+<li>revision&#160;:&#160;<a class="el" href="a00253.html#a13ad54c93d08d8ac808e4de9674c5ee7">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+</ul>
+
+
+<h3><a id="index_s" name="index_s"></a>- s -</h3><ul>
+<li>secondary_bus&#160;:&#160;<a class="el" href="a00257.html#ae2d9dd73ef1d32045c584a8e66d2f83f">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>set_area_membind&#160;:&#160;<a class="el" href="a00289.html#a476c06f96b65c08b287cf2369966123b">hwloc_topology_membind_support</a></li>
+<li>set_proc_cpubind&#160;:&#160;<a class="el" href="a00285.html#aa166223d1c2a6de7256ab2d8b675a87e">hwloc_topology_cpubind_support</a></li>
+<li>set_proc_membind&#160;:&#160;<a class="el" href="a00289.html#a756f44912894b176bf979a1b65f12aac">hwloc_topology_membind_support</a></li>
+<li>set_thisproc_cpubind&#160;:&#160;<a class="el" href="a00285.html#a9403d51657a4d546b3ea9553a2973a27">hwloc_topology_cpubind_support</a></li>
+<li>set_thisproc_membind&#160;:&#160;<a class="el" href="a00289.html#a36b3e388df9c6a249427cab7e3724749">hwloc_topology_membind_support</a></li>
+<li>set_thisthread_cpubind&#160;:&#160;<a class="el" href="a00285.html#a57a89a4b5f1f74fa6cfe176f1e8b0798">hwloc_topology_cpubind_support</a></li>
+<li>set_thisthread_membind&#160;:&#160;<a class="el" href="a00289.html#a0697af2e41f2e82b8ce71e3cc13f7eac">hwloc_topology_membind_support</a></li>
+<li>set_thread_cpubind&#160;:&#160;<a class="el" href="a00285.html#a46fba33e307909ce256624687799dd6d">hwloc_topology_cpubind_support</a></li>
+<li>sibling_rank&#160;:&#160;<a class="el" href="a00229.html#aaa6043eee6f55869933c1d974efd9acd">hwloc_obj</a></li>
+<li>size&#160;:&#160;<a class="el" href="a00245.html#abe5e788943ed04302976740c829674c0">hwloc_obj_attr_u::hwloc_cache_attr_s</a>, <a class="el" href="a00241.html#a8ea7ebe9d91c7378bba03da57efc25cb">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s</a></li>
+<li>string&#160;:&#160;<a class="el" href="a00329.html#a42fa15c37f1f59ef638066c4c62c3154">hwloc_topology_diff_obj_attr_u</a></li>
+<li>subdevice_id&#160;:&#160;<a class="el" href="a00253.html#acac741aecd7a6db64f33409427e3971f">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>subkind&#160;:&#160;<a class="el" href="a00249.html#ad514d943960a4036ed5e44dc187c74ed">hwloc_obj_attr_u::hwloc_group_attr_s</a></li>
+<li>subordinate_bus&#160;:&#160;<a class="el" href="a00257.html#af3f3f7d76bf03e8d2afa721c2b8d6771">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>subtype&#160;:&#160;<a class="el" href="a00229.html#a5d4f97e76723a9ec8d38046f19e00d33">hwloc_obj</a></li>
+<li>subvendor_id&#160;:&#160;<a class="el" href="a00253.html#a499db3d8cc89eaba04fcaef3df1cba97">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>symmetric_subtree&#160;:&#160;<a class="el" href="a00229.html#a0f41a1d67dc6b661906f2217563637f3">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_t" name="index_t"></a>- t -</h3><ul>
+<li>too_complex&#160;:&#160;<a class="el" href="a00345.html#af7dc1148eb656c56e9678218cafd027b">hwloc_topology_diff_u</a></li>
+<li>total_memory&#160;:&#160;<a class="el" href="a00229.html#a75603fc36c9284ba48ce814b772a58b6">hwloc_obj</a></li>
+<li>type&#160;:&#160;<a class="el" href="a00317.html#a8ec4ea89b862bb271845b48063f332b4">hwloc_cl_device_topology_amd</a>, <a class="el" href="a00373.html#a789208ada7e17492cfd3a5a88a6bb0ee">hwloc_component</a>, <a class="el" href="a00305.html#aeb9c0ab74a7d3506a76d0b82600a28a7">hwloc_location</a>, <a class="el" href="a00229.html#acc4f0803f244867e68fe0036800be5de">hwloc_obj</a>, <a class="el" href="a00245.html#ad8edc8ded2b7a70d6abbc874801930f4">hwloc_obj_attr_u::hwloc_cache_attr_s</a>, <a class="el" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">hwloc_obj_attr_u::hwloc_osdev_attr_s</a>, <a class="el" href="a00333.html#a43f8133b7c30129b002c2d295e6580fc">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s</a>, <a class="el" href="a00341.html#a784ab5827c1bf531b86d1f02f199d04d">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a>, <a class="el" href="a00337.html#afe262b9aa558fe7bfecbd37a7a129197">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a>, <a class="el" href="a00349.html#a373005489fcddeba6319163e60263ae8">hwloc_topology_diff_u::hwloc_topology_diff_generic_s</a>, <a class="el" href="a00353.html#a70a118ad288bd98f18c8ce6dc52e2d10">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a>, <a class="el" href="a00357.html#a92084295a4d6faf17a95a7eea526ddbd">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a></li>
+</ul>
+
+
+<h3><a id="index_u" name="index_u"></a>- u -</h3><ul>
+<li>uint64&#160;:&#160;<a class="el" href="a00329.html#a4608ade88460f5f208887775e5a69a0a">hwloc_topology_diff_obj_attr_u</a></li>
+<li>unused&#160;:&#160;<a class="el" href="a00317.html#ac8650d7eea96eef290481fee980d1d47">hwloc_cl_device_topology_amd</a></li>
+<li>upstream&#160;:&#160;<a class="el" href="a00257.html#a94647ccf58afd32602f584b47a0321ce">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>upstream_type&#160;:&#160;<a class="el" href="a00257.html#a265dd2164aa2df4972e25a029da72125">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>userdata&#160;:&#160;<a class="el" href="a00229.html#a76fd3ac94401cf32dfccc3a3a8de68a5">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_v" name="index_v"></a>- v -</h3><ul>
+<li>value&#160;:&#160;<a class="el" href="a00277.html#a788a0073bafe660645e7b69f31a43bbb">hwloc_info_s</a></li>
+<li>values&#160;:&#160;<a class="el" href="a00301.html#ae43e19b2c743de05c93d71a30beaca75">hwloc_distances_s</a></li>
+<li>vendor_id&#160;:&#160;<a class="el" href="a00253.html#aad970ad19b62eb2d5df30e4802da4f4c">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+</ul>
+
+
+<h3><a id="index_w" name="index_w"></a>- w -</h3><ul>
+<li>weighted_interleave_membind&#160;:&#160;<a class="el" href="a00289.html#a48e8c0eee48e83e72edde293e2f52464">hwloc_topology_membind_support</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/functions_vars.html 2.11.0-1/doc/doxygen-doc/html/functions_vars.html
--- 2.10.0-1/doc/doxygen-doc/html/functions_vars.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/functions_vars.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,276 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Data Fields - Variables</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="contents">
+<div class="textblock">Here is a list of all variables with links to the structures/unions they belong to:</div>
+
+<h3><a id="index_a" name="index_a"></a>- a -</h3><ul>
+<li>abi&#160;:&#160;<a class="el" href="a00373.html#a3250bd6fc9713946991d805e48091b2e">hwloc_component</a></li>
+<li>alloc_membind&#160;:&#160;<a class="el" href="a00289.html#ae551abb27d2aa9ce008583488b845b98">hwloc_topology_membind_support</a></li>
+<li>arity&#160;:&#160;<a class="el" href="a00229.html#aac3f6da35c9b57599909a44ce2b716c1">hwloc_obj</a></li>
+<li>associativity&#160;:&#160;<a class="el" href="a00245.html#ad06525e474d1e2d1423ed71bb998592d">hwloc_obj_attr_u::hwloc_cache_attr_s</a></li>
+<li>attr&#160;:&#160;<a class="el" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_b" name="index_b"></a>- b -</h3><ul>
+<li>bind_membind&#160;:&#160;<a class="el" href="a00289.html#ae7cdb1f1b5f0242a69f85b5a5538c764">hwloc_topology_membind_support</a></li>
+<li>bridge&#160;:&#160;<a class="el" href="a00233.html#a207e6359497b7116d6f4baa9e8bbeb43">hwloc_obj_attr_u</a></li>
+<li>bus&#160;:&#160;<a class="el" href="a00317.html#a4a23e3cc034b7ab105cab0e863dcab69">hwloc_cl_device_topology_amd</a>, <a class="el" href="a00253.html#aae99e035e8d1387d7b8768aaa8eceb0a">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+</ul>
+
+
+<h3><a id="index_c" name="index_c"></a>- c -</h3><ul>
+<li>cache&#160;:&#160;<a class="el" href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">hwloc_obj_attr_u</a></li>
+<li>children&#160;:&#160;<a class="el" href="a00229.html#a04d05403da37bfe17cd63b7c7dd07b1f">hwloc_obj</a></li>
+<li>class_id&#160;:&#160;<a class="el" href="a00253.html#aee735352d9f1686fd290fc6d6397c334">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>complete_cpuset&#160;:&#160;<a class="el" href="a00229.html#a91788a9da687beb7224cc1fd7b75208c">hwloc_obj</a></li>
+<li>complete_nodeset&#160;:&#160;<a class="el" href="a00229.html#ac38c4012127525ef74c5615c526f4c2e">hwloc_obj</a></li>
+<li>count&#160;:&#160;<a class="el" href="a00241.html#a98514e37d57a325b78e21ffd8d7419e0">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s</a></li>
+<li>cpubind&#160;:&#160;<a class="el" href="a00297.html#adef2bb91f74c3e70a2a071393caf5f56">hwloc_topology_support</a></li>
+<li>cpukind_efficiency&#160;:&#160;<a class="el" href="a00281.html#aba80d6f9c15e2395f9ed61db9ff3b75d">hwloc_topology_discovery_support</a></li>
+<li>cpuset&#160;:&#160;<a class="el" href="a00309.html#a033bad8f6b891992f0c18b85a88c5561">hwloc_location::hwloc_location_u</a>, <a class="el" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_d" name="index_d"></a>- d -</h3><ul>
+<li>data&#160;:&#160;<a class="el" href="a00317.html#afbd6b814607b06fc5b2f36ad14420398">hwloc_cl_device_topology_amd</a>, <a class="el" href="a00373.html#a4b8cffd1d943c29fdc102b841b8598d4">hwloc_component</a></li>
+<li>depth&#160;:&#160;<a class="el" href="a00229.html#a4876fd165b4fff35521f07ebd85355ed">hwloc_obj</a>, <a class="el" href="a00257.html#a336c8b22893d5d734d8c9dfca4066b46">hwloc_obj_attr_u::hwloc_bridge_attr_s</a>, <a class="el" href="a00245.html#a5c8f7f39193736c2187ed626940835d5">hwloc_obj_attr_u::hwloc_cache_attr_s</a>, <a class="el" href="a00249.html#ad914eac61c77481e1b7037877bcc5579">hwloc_obj_attr_u::hwloc_group_attr_s</a></li>
+<li>dev&#160;:&#160;<a class="el" href="a00253.html#a3d70c84a12f7e93d14c8d47bf4fd9dc5">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>device&#160;:&#160;<a class="el" href="a00317.html#a017033a953d71455b067007cabb92e9c">hwloc_cl_device_topology_amd</a></li>
+<li>device_id&#160;:&#160;<a class="el" href="a00253.html#a35b66064ab7d768caf7154e410caf0fa">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>diff&#160;:&#160;<a class="el" href="a00353.html#a91f0645f9062e892652357cd141c8ebb">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a></li>
+<li>disable&#160;:&#160;<a class="el" href="a00369.html#a36c4fa86350525b46340c67b802c69c7">hwloc_backend</a></li>
+<li>disallowed_numa&#160;:&#160;<a class="el" href="a00281.html#a970e65235873bcdb9669a9805161ce03">hwloc_topology_discovery_support</a></li>
+<li>disallowed_pu&#160;:&#160;<a class="el" href="a00281.html#af3c97b28781a2972cf8eaaf94a6617da">hwloc_topology_discovery_support</a></li>
+<li>discover&#160;:&#160;<a class="el" href="a00369.html#accff2cd8404be43c3b44cec05e6f609b">hwloc_backend</a></li>
+<li>discovery&#160;:&#160;<a class="el" href="a00297.html#aea3fbd7653d987d81f848636c420504d">hwloc_topology_support</a></li>
+<li>domain&#160;:&#160;<a class="el" href="a00257.html#a2c31e565a5f0d23d0a0a3dd3ec8f4b17">hwloc_obj_attr_u::hwloc_bridge_attr_s</a>, <a class="el" href="a00253.html#a8fba44988deb98613c1505a4019a34dc">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>dont_merge&#160;:&#160;<a class="el" href="a00249.html#afa253d4b70f92e940c226d61f192054f">hwloc_obj_attr_u::hwloc_group_attr_s</a></li>
+<li>downstream&#160;:&#160;<a class="el" href="a00257.html#abe1e38eb5ac8dc59829c8dc045f0d747">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>downstream_type&#160;:&#160;<a class="el" href="a00257.html#ac6a169b672d0e9f75756fd5665828b93">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+</ul>
+
+
+<h3><a id="index_e" name="index_e"></a>- e -</h3><ul>
+<li>enabled_by_default&#160;:&#160;<a class="el" href="a00361.html#ace80cafe2b1732b047b3fc3da47e6517">hwloc_disc_component</a></li>
+<li>excluded_phases&#160;:&#160;<a class="el" href="a00361.html#acbb9957914dbf7b8f504215aa0c8d3fe">hwloc_disc_component</a>, <a class="el" href="a00365.html#a0f95fa42d46a6e7cf8dee8af12afee3a">hwloc_disc_status</a></li>
+</ul>
+
+
+<h3><a id="index_f" name="index_f"></a>- f -</h3><ul>
+<li>finalize&#160;:&#160;<a class="el" href="a00373.html#a4612015451a1c706e8ba19114cb8baae">hwloc_component</a></li>
+<li>first_child&#160;:&#160;<a class="el" href="a00229.html#af51d08a0a79dba517c06c5afedc8d2dc">hwloc_obj</a></li>
+<li>firsttouch_membind&#160;:&#160;<a class="el" href="a00289.html#a221098c339dbfab27bd2c9f5d32f123b">hwloc_topology_membind_support</a></li>
+<li>flags&#160;:&#160;<a class="el" href="a00369.html#aaa8eafe495aadd81c2e3c4ec527c10ba">hwloc_backend</a>, <a class="el" href="a00373.html#ab8043c5b4cc0e81aabba586ccb194335">hwloc_component</a>, <a class="el" href="a00365.html#ad8b123cecb945a9182eb824ccf8ef9d7">hwloc_disc_status</a></li>
+<li>func&#160;:&#160;<a class="el" href="a00253.html#a695f32df53f4ef728670bfcf31b74e0f">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>function&#160;:&#160;<a class="el" href="a00317.html#a77a67ac73cff98d330ef7258b240bac3">hwloc_cl_device_topology_amd</a></li>
+</ul>
+
+
+<h3><a id="index_g" name="index_g"></a>- g -</h3><ul>
+<li>generic&#160;:&#160;<a class="el" href="a00329.html#aeb449c0e04b14ebf8c3126756b6364f9">hwloc_topology_diff_obj_attr_u</a>, <a class="el" href="a00345.html#a0dd2cbfba0eca2fc7a2645668bcae0f8">hwloc_topology_diff_u</a></li>
+<li>get_area_membind&#160;:&#160;<a class="el" href="a00289.html#a0a84e24a06f2fa487fe8c9605c6f68b3">hwloc_topology_membind_support</a></li>
+<li>get_area_memlocation&#160;:&#160;<a class="el" href="a00289.html#a30173553a68e0a4dd1672d26f8e892b1">hwloc_topology_membind_support</a></li>
+<li>get_pci_busid_cpuset&#160;:&#160;<a class="el" href="a00369.html#aaac253491264c20930f44817270bc502">hwloc_backend</a></li>
+<li>get_proc_cpubind&#160;:&#160;<a class="el" href="a00285.html#aae705bc447adc163ead377362c4dfe9f">hwloc_topology_cpubind_support</a></li>
+<li>get_proc_last_cpu_location&#160;:&#160;<a class="el" href="a00285.html#a2554620148b7992a5093f338f5ae254f">hwloc_topology_cpubind_support</a></li>
+<li>get_proc_membind&#160;:&#160;<a class="el" href="a00289.html#a9880cd2d605e316fc020167c49ca69ad">hwloc_topology_membind_support</a></li>
+<li>get_thisproc_cpubind&#160;:&#160;<a class="el" href="a00285.html#a77a09ddd78ee3e9ff5f532a6ac74f7eb">hwloc_topology_cpubind_support</a></li>
+<li>get_thisproc_last_cpu_location&#160;:&#160;<a class="el" href="a00285.html#ad2d5c94b738d92b7d2ede87e4e96321d">hwloc_topology_cpubind_support</a></li>
+<li>get_thisproc_membind&#160;:&#160;<a class="el" href="a00289.html#a3fd51e6fa5f0dd800322301b46b08559">hwloc_topology_membind_support</a></li>
+<li>get_thisthread_cpubind&#160;:&#160;<a class="el" href="a00285.html#a80d762e532d677dff262d83cc7bb1c60">hwloc_topology_cpubind_support</a></li>
+<li>get_thisthread_last_cpu_location&#160;:&#160;<a class="el" href="a00285.html#a6be1f042fdce6bf41b4ea39f6f193808">hwloc_topology_cpubind_support</a></li>
+<li>get_thisthread_membind&#160;:&#160;<a class="el" href="a00289.html#a63b0b2e26157b472f5717ee93cc7c535">hwloc_topology_membind_support</a></li>
+<li>get_thread_cpubind&#160;:&#160;<a class="el" href="a00285.html#a8dd4d8531ed2eebdce1507e7d104154e">hwloc_topology_cpubind_support</a></li>
+<li>gp_index&#160;:&#160;<a class="el" href="a00229.html#a957984a355fa61c85f46605c336e7551">hwloc_obj</a></li>
+<li>group&#160;:&#160;<a class="el" href="a00233.html#a9eddbd69e34cd2ef6af6d2ac31b6eff3">hwloc_obj_attr_u</a></li>
+</ul>
+
+
+<h3><a id="index_i" name="index_i"></a>- i -</h3><ul>
+<li>imported_support&#160;:&#160;<a class="el" href="a00293.html#adf54a6dbe8e9dd5033dfe9c93df726c4">hwloc_topology_misc_support</a></li>
+<li>index&#160;:&#160;<a class="el" href="a00337.html#adb772c3f1761ecadf496c80ae14afce3">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a></li>
+<li>infos&#160;:&#160;<a class="el" href="a00229.html#a8604654c38b7a720efae5025d3a96ee6">hwloc_obj</a></li>
+<li>infos_count&#160;:&#160;<a class="el" href="a00229.html#a9843acc28cfbba903b63ea14b137ff70">hwloc_obj</a></li>
+<li>init&#160;:&#160;<a class="el" href="a00373.html#aea613546886d9b8221cadba920fe3ebc">hwloc_component</a></li>
+<li>instantiate&#160;:&#160;<a class="el" href="a00361.html#a12e780d0acf89da7a8c8e37e51a3abcb">hwloc_disc_component</a></li>
+<li>interleave_membind&#160;:&#160;<a class="el" href="a00289.html#a3c44c6012860bbeba8a0f4c19710858d">hwloc_topology_membind_support</a></li>
+<li>io_arity&#160;:&#160;<a class="el" href="a00229.html#a7b3b29f0be377c7d2d52262019fc7d11">hwloc_obj</a></li>
+<li>io_first_child&#160;:&#160;<a class="el" href="a00229.html#a8d14c88e1ebc4ae67cc69f9e928558b3">hwloc_obj</a></li>
+<li>is_thissystem&#160;:&#160;<a class="el" href="a00369.html#ab8806f6db077f1bb2e9d63ec99223f7a">hwloc_backend</a></li>
+</ul>
+
+
+<h3><a id="index_k" name="index_k"></a>- k -</h3><ul>
+<li>kind&#160;:&#160;<a class="el" href="a00301.html#aef9c83cf467da1b1fa4c36493febb3b5">hwloc_distances_s</a>, <a class="el" href="a00249.html#a3229f269c4cc7e63492c168535e4f0c1">hwloc_obj_attr_u::hwloc_group_attr_s</a></li>
+</ul>
+
+
+<h3><a id="index_l" name="index_l"></a>- l -</h3><ul>
+<li>last_child&#160;:&#160;<a class="el" href="a00229.html#a84bd65634dbc55f4158b74443a9bd04f">hwloc_obj</a></li>
+<li>linesize&#160;:&#160;<a class="el" href="a00245.html#a801e8a668e28caf06c8b88e9ae5c10db">hwloc_obj_attr_u::hwloc_cache_attr_s</a></li>
+<li>linkspeed&#160;:&#160;<a class="el" href="a00253.html#a59b2fce35f7cbde86c4fd305d0ccda5f">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>local_memory&#160;:&#160;<a class="el" href="a00237.html#a6703cbf2afbf63c9d60c5ff4dc0c73aa">hwloc_obj_attr_u::hwloc_numanode_attr_s</a></li>
+<li>location&#160;:&#160;<a class="el" href="a00305.html#a707a25a5b65177e4d081be49aa0777a2">hwloc_location</a></li>
+<li>logical_index&#160;:&#160;<a class="el" href="a00229.html#a0d07fb7b8935e137c94d75a3eb492ae9">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_m" name="index_m"></a>- m -</h3><ul>
+<li>membind&#160;:&#160;<a class="el" href="a00297.html#ac6eb62ae8bc0a68dce679a7107a36194">hwloc_topology_support</a></li>
+<li>memory_arity&#160;:&#160;<a class="el" href="a00229.html#a6f834ea4dd26553cdea601d2fae6d3b7">hwloc_obj</a></li>
+<li>memory_first_child&#160;:&#160;<a class="el" href="a00229.html#ac0e8200dba25b90d5954bd4ec61f97d3">hwloc_obj</a></li>
+<li>migrate_membind&#160;:&#160;<a class="el" href="a00289.html#aafa7683871a6a760246f9b35209caec5">hwloc_topology_membind_support</a></li>
+<li>misc&#160;:&#160;<a class="el" href="a00297.html#ab9d08df4b0b03994f21b893ece826e78">hwloc_topology_support</a></li>
+<li>misc_arity&#160;:&#160;<a class="el" href="a00229.html#a2bb7862ce722d7ceda23cfa153da165a">hwloc_obj</a></li>
+<li>misc_first_child&#160;:&#160;<a class="el" href="a00229.html#a57812a313fe9b1a9500489f47c3011cc">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_n" name="index_n"></a>- n -</h3><ul>
+<li>name&#160;:&#160;<a class="el" href="a00361.html#a4064c3b5d9213027e87caebef380a840">hwloc_disc_component</a>, <a class="el" href="a00277.html#a12ce1309e4381ae38b5c15d242a47124">hwloc_info_s</a>, <a class="el" href="a00229.html#abb709ec38f2970677e4e57d1d30be96d">hwloc_obj</a>, <a class="el" href="a00341.html#a7ef48c66ccddf34d90edb4e4314b41c6">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a></li>
+<li>nbobjs&#160;:&#160;<a class="el" href="a00301.html#a4ca2af858cebbce7324ec49903d09474">hwloc_distances_s</a></li>
+<li>newvalue&#160;:&#160;<a class="el" href="a00341.html#a75f37f4add21cece50fee2701c3b77db">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a>, <a class="el" href="a00337.html#ae63aa59ad65aa783b730a4f213304eb4">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a></li>
+<li>next&#160;:&#160;<a class="el" href="a00349.html#a720aa94eb73cddfd8d6bf9fcbbfc035e">hwloc_topology_diff_u::hwloc_topology_diff_generic_s</a>, <a class="el" href="a00353.html#acb9170a8eb3392656d70f7f3ef3e3eed">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a>, <a class="el" href="a00357.html#a375afbaa043b109be689a7d9a3c7d153">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a></li>
+<li>next_cousin&#160;:&#160;<a class="el" href="a00229.html#a85a788017457129589318b6c39451acf">hwloc_obj</a></li>
+<li>next_sibling&#160;:&#160;<a class="el" href="a00229.html#a7f2343ed476fe4942e6fffd4cade1b40">hwloc_obj</a></li>
+<li>nexttouch_membind&#160;:&#160;<a class="el" href="a00289.html#ab0921af6e0cd6975812a80b8e5c7435c">hwloc_topology_membind_support</a></li>
+<li>nodeset&#160;:&#160;<a class="el" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">hwloc_obj</a></li>
+<li>numa&#160;:&#160;<a class="el" href="a00281.html#a955f96066cb9e4cd34e2a3710ad43e80">hwloc_topology_discovery_support</a></li>
+<li>numa_memory&#160;:&#160;<a class="el" href="a00281.html#af193eb858e40e12ef4923f5ed0e1f11a">hwloc_topology_discovery_support</a></li>
+<li>numanode&#160;:&#160;<a class="el" href="a00233.html#ad066b9612802ffa01e132dc3a8e6cc86">hwloc_obj_attr_u</a></li>
+</ul>
+
+
+<h3><a id="index_o" name="index_o"></a>- o -</h3><ul>
+<li>obj_attr&#160;:&#160;<a class="el" href="a00345.html#a01dca644feea48448b36baa60cf4c07f">hwloc_topology_diff_u</a></li>
+<li>obj_depth&#160;:&#160;<a class="el" href="a00353.html#a82c1d4bab80b9e0bf301a9d8291893e0">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a>, <a class="el" href="a00357.html#a94c6498caeaafbb79927395d918d6cb3">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a></li>
+<li>obj_index&#160;:&#160;<a class="el" href="a00353.html#adb9f4d414470b6670cde8d90759a6c1c">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a>, <a class="el" href="a00357.html#a6dc6b3c4adb10db74d993e37afaa0580">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a></li>
+<li>object&#160;:&#160;<a class="el" href="a00309.html#acf2ebf75869f0a53a884ac2ab3374122">hwloc_location::hwloc_location_u</a></li>
+<li>objs&#160;:&#160;<a class="el" href="a00301.html#af1e78b2d628d191fa6cae3fbfe891078">hwloc_distances_s</a></li>
+<li>oldvalue&#160;:&#160;<a class="el" href="a00341.html#a33cc281d4417129064295a6ae7b79818">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a>, <a class="el" href="a00337.html#a44c0894dce563335d347fde6595c49c9">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a></li>
+<li>os_index&#160;:&#160;<a class="el" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">hwloc_obj</a></li>
+<li>osdev&#160;:&#160;<a class="el" href="a00233.html#aaf7a5c38b5185703ff18c46ad2761dcf">hwloc_obj_attr_u</a></li>
+</ul>
+
+
+<h3><a id="index_p" name="index_p"></a>- p -</h3><ul>
+<li>page_types&#160;:&#160;<a class="el" href="a00237.html#a7e53c5024da2d7741a5cc1e7016bb8d2">hwloc_obj_attr_u::hwloc_numanode_attr_s</a></li>
+<li>page_types_len&#160;:&#160;<a class="el" href="a00237.html#a513078122d403904e16723d30f583cb2">hwloc_obj_attr_u::hwloc_numanode_attr_s</a></li>
+<li>parent&#160;:&#160;<a class="el" href="a00229.html#adc494f6aed939992be1c55cca5822900">hwloc_obj</a></li>
+<li>pci&#160;:&#160;<a class="el" href="a00257.html#ab5c564e7c95b747dae9eb84ec0a2c31e">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>pci_bus&#160;:&#160;<a class="el" href="a00313.html#a0e4d316b01eee00c3750d1c853be9c01">hwloc_cl_device_pci_bus_info_khr</a></li>
+<li>pci_device&#160;:&#160;<a class="el" href="a00313.html#a328717bdaeb2d117c550927cf41e6f72">hwloc_cl_device_pci_bus_info_khr</a></li>
+<li>pci_domain&#160;:&#160;<a class="el" href="a00313.html#a5bdfbcb0dee610f9f6f7f95ace89e298">hwloc_cl_device_pci_bus_info_khr</a></li>
+<li>pci_function&#160;:&#160;<a class="el" href="a00313.html#ab4032f46a44cf9ffc7b2ddc25001e3f0">hwloc_cl_device_pci_bus_info_khr</a></li>
+<li>pcidev&#160;:&#160;<a class="el" href="a00233.html#a0b66da7ab072f7c016f8ed86701f5a7c">hwloc_obj_attr_u</a></li>
+<li>pcie&#160;:&#160;<a class="el" href="a00317.html#aef8560f6c359be0c5bdbd2840580d79c">hwloc_cl_device_topology_amd</a></li>
+<li>phase&#160;:&#160;<a class="el" href="a00365.html#abaf7c8c082d43e133171f0723dbf824b">hwloc_disc_status</a></li>
+<li>phases&#160;:&#160;<a class="el" href="a00369.html#aeca769840a6ff03e96462a9533adbccd">hwloc_backend</a>, <a class="el" href="a00361.html#a61ad3151efa02e3dbad5d919758f9c90">hwloc_disc_component</a></li>
+<li>prev_cousin&#160;:&#160;<a class="el" href="a00229.html#ac715989f55ff5a0eb6be2969ee477ec0">hwloc_obj</a></li>
+<li>prev_sibling&#160;:&#160;<a class="el" href="a00229.html#a7b89e8c189876c0158a9282aaaf17f50">hwloc_obj</a></li>
+<li>priority&#160;:&#160;<a class="el" href="a00361.html#ae86d283c272c5ae24073a235efbf6b59">hwloc_disc_component</a></li>
+<li>private_data&#160;:&#160;<a class="el" href="a00369.html#a2ea5bd36b7f06efdb65b98b32af16c68">hwloc_backend</a></li>
+<li>pu&#160;:&#160;<a class="el" href="a00281.html#ad7bb4ecf7a82f5a04fc632e9592ad3ab">hwloc_topology_discovery_support</a></li>
+</ul>
+
+
+<h3><a id="index_r" name="index_r"></a>- r -</h3><ul>
+<li>raw&#160;:&#160;<a class="el" href="a00317.html#aeb5e5d12bf653f750dafedae6e225c3a">hwloc_cl_device_topology_amd</a></li>
+<li>revision&#160;:&#160;<a class="el" href="a00253.html#a13ad54c93d08d8ac808e4de9674c5ee7">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+</ul>
+
+
+<h3><a id="index_s" name="index_s"></a>- s -</h3><ul>
+<li>secondary_bus&#160;:&#160;<a class="el" href="a00257.html#ae2d9dd73ef1d32045c584a8e66d2f83f">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>set_area_membind&#160;:&#160;<a class="el" href="a00289.html#a476c06f96b65c08b287cf2369966123b">hwloc_topology_membind_support</a></li>
+<li>set_proc_cpubind&#160;:&#160;<a class="el" href="a00285.html#aa166223d1c2a6de7256ab2d8b675a87e">hwloc_topology_cpubind_support</a></li>
+<li>set_proc_membind&#160;:&#160;<a class="el" href="a00289.html#a756f44912894b176bf979a1b65f12aac">hwloc_topology_membind_support</a></li>
+<li>set_thisproc_cpubind&#160;:&#160;<a class="el" href="a00285.html#a9403d51657a4d546b3ea9553a2973a27">hwloc_topology_cpubind_support</a></li>
+<li>set_thisproc_membind&#160;:&#160;<a class="el" href="a00289.html#a36b3e388df9c6a249427cab7e3724749">hwloc_topology_membind_support</a></li>
+<li>set_thisthread_cpubind&#160;:&#160;<a class="el" href="a00285.html#a57a89a4b5f1f74fa6cfe176f1e8b0798">hwloc_topology_cpubind_support</a></li>
+<li>set_thisthread_membind&#160;:&#160;<a class="el" href="a00289.html#a0697af2e41f2e82b8ce71e3cc13f7eac">hwloc_topology_membind_support</a></li>
+<li>set_thread_cpubind&#160;:&#160;<a class="el" href="a00285.html#a46fba33e307909ce256624687799dd6d">hwloc_topology_cpubind_support</a></li>
+<li>sibling_rank&#160;:&#160;<a class="el" href="a00229.html#aaa6043eee6f55869933c1d974efd9acd">hwloc_obj</a></li>
+<li>size&#160;:&#160;<a class="el" href="a00245.html#abe5e788943ed04302976740c829674c0">hwloc_obj_attr_u::hwloc_cache_attr_s</a>, <a class="el" href="a00241.html#a8ea7ebe9d91c7378bba03da57efc25cb">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s</a></li>
+<li>string&#160;:&#160;<a class="el" href="a00329.html#a42fa15c37f1f59ef638066c4c62c3154">hwloc_topology_diff_obj_attr_u</a></li>
+<li>subdevice_id&#160;:&#160;<a class="el" href="a00253.html#acac741aecd7a6db64f33409427e3971f">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>subkind&#160;:&#160;<a class="el" href="a00249.html#ad514d943960a4036ed5e44dc187c74ed">hwloc_obj_attr_u::hwloc_group_attr_s</a></li>
+<li>subordinate_bus&#160;:&#160;<a class="el" href="a00257.html#af3f3f7d76bf03e8d2afa721c2b8d6771">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>subtype&#160;:&#160;<a class="el" href="a00229.html#a5d4f97e76723a9ec8d38046f19e00d33">hwloc_obj</a></li>
+<li>subvendor_id&#160;:&#160;<a class="el" href="a00253.html#a499db3d8cc89eaba04fcaef3df1cba97">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+<li>symmetric_subtree&#160;:&#160;<a class="el" href="a00229.html#a0f41a1d67dc6b661906f2217563637f3">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_t" name="index_t"></a>- t -</h3><ul>
+<li>too_complex&#160;:&#160;<a class="el" href="a00345.html#af7dc1148eb656c56e9678218cafd027b">hwloc_topology_diff_u</a></li>
+<li>total_memory&#160;:&#160;<a class="el" href="a00229.html#a75603fc36c9284ba48ce814b772a58b6">hwloc_obj</a></li>
+<li>type&#160;:&#160;<a class="el" href="a00317.html#a8ec4ea89b862bb271845b48063f332b4">hwloc_cl_device_topology_amd</a>, <a class="el" href="a00373.html#a789208ada7e17492cfd3a5a88a6bb0ee">hwloc_component</a>, <a class="el" href="a00305.html#aeb9c0ab74a7d3506a76d0b82600a28a7">hwloc_location</a>, <a class="el" href="a00229.html#acc4f0803f244867e68fe0036800be5de">hwloc_obj</a>, <a class="el" href="a00245.html#ad8edc8ded2b7a70d6abbc874801930f4">hwloc_obj_attr_u::hwloc_cache_attr_s</a>, <a class="el" href="a00273.html#a31e019e27e54ac6138d04be639bb96f9">hwloc_obj_attr_u::hwloc_osdev_attr_s</a>, <a class="el" href="a00333.html#a43f8133b7c30129b002c2d295e6580fc">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s</a>, <a class="el" href="a00341.html#a784ab5827c1bf531b86d1f02f199d04d">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</a>, <a class="el" href="a00337.html#afe262b9aa558fe7bfecbd37a7a129197">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</a>, <a class="el" href="a00349.html#a373005489fcddeba6319163e60263ae8">hwloc_topology_diff_u::hwloc_topology_diff_generic_s</a>, <a class="el" href="a00353.html#a70a118ad288bd98f18c8ce6dc52e2d10">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</a>, <a class="el" href="a00357.html#a92084295a4d6faf17a95a7eea526ddbd">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</a></li>
+</ul>
+
+
+<h3><a id="index_u" name="index_u"></a>- u -</h3><ul>
+<li>uint64&#160;:&#160;<a class="el" href="a00329.html#a4608ade88460f5f208887775e5a69a0a">hwloc_topology_diff_obj_attr_u</a></li>
+<li>unused&#160;:&#160;<a class="el" href="a00317.html#ac8650d7eea96eef290481fee980d1d47">hwloc_cl_device_topology_amd</a></li>
+<li>upstream&#160;:&#160;<a class="el" href="a00257.html#a94647ccf58afd32602f584b47a0321ce">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>upstream_type&#160;:&#160;<a class="el" href="a00257.html#a265dd2164aa2df4972e25a029da72125">hwloc_obj_attr_u::hwloc_bridge_attr_s</a></li>
+<li>userdata&#160;:&#160;<a class="el" href="a00229.html#a76fd3ac94401cf32dfccc3a3a8de68a5">hwloc_obj</a></li>
+</ul>
+
+
+<h3><a id="index_v" name="index_v"></a>- v -</h3><ul>
+<li>value&#160;:&#160;<a class="el" href="a00277.html#a788a0073bafe660645e7b69f31a43bbb">hwloc_info_s</a></li>
+<li>values&#160;:&#160;<a class="el" href="a00301.html#ae43e19b2c743de05c93d71a30beaca75">hwloc_distances_s</a></li>
+<li>vendor_id&#160;:&#160;<a class="el" href="a00253.html#aad970ad19b62eb2d5df30e4802da4f4c">hwloc_obj_attr_u::hwloc_pcidev_attr_s</a></li>
+</ul>
+
+
+<h3><a id="index_w" name="index_w"></a>- w -</h3><ul>
+<li>weighted_interleave_membind&#160;:&#160;<a class="el" href="a00289.html#a48e8c0eee48e83e72edde293e2f52464">hwloc_topology_membind_support</a></li>
+</ul>
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
Binary files 2.10.0-1/doc/doxygen-doc/html/hagrid.png and 2.11.0-1/doc/doxygen-doc/html/hagrid.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/heteromem.png and 2.11.0-1/doc/doxygen-doc/html/heteromem.png differ
diff -pruN 2.10.0-1/doc/doxygen-doc/html/index.html 2.11.0-1/doc/doxygen-doc/html/index.html
--- 2.10.0-1/doc/doxygen-doc/html/index.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/index.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,531 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Hardware Locality</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div><div class="header">
+  <div class="headertitle"><div class="title">Hardware Locality </div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock"><h1 class="sub">Portable abstraction of hierarchical architectures for high-performance computing</h1>
+<hr  />
+<p> <br  />
+</p>
+<h1><a class="anchor" id="toc"></a>
+Table of Contents</h1>
+<ul>
+<li>
+Introduction <ul>
+<li>
+<a class="el" href="index.html#overview">hwloc Overview</a> </li>
+<li>
+<a class="el" href="index.html#cli_examples">Command-line Examples</a> </li>
+<li>
+<a class="el" href="index.html#interface">Programming Interface</a> </li>
+<li>
+<a class="el" href="index.html#bugs">Questions and Bugs</a> </li>
+<li>
+<a class="el" href="index.html#history">History / Credits</a> </li>
+</ul>
+</li>
+<li>
+Chapters <ul>
+<li>
+<a class="el" href="a00374.html">Installation</a> </li>
+<li>
+<a class="el" href="a00375.html">Compiling software on top of hwloc's C API</a> </li>
+<li>
+<a class="el" href="a00376.html">Terms and Definitions</a> </li>
+<li>
+<a class="el" href="a00377.html">Command-Line Tools</a> </li>
+<li>
+<a class="el" href="a00378.html">Environment Variables</a> </li>
+<li>
+<a class="el" href="a00379.html">CPU and Memory Binding Overview</a> </li>
+<li>
+<a class="el" href="a00380.html">I/O Devices</a> </li>
+<li>
+<a class="el" href="a00381.html">Miscellaneous objects</a> </li>
+<li>
+<a class="el" href="a00382.html">Object attributes</a> </li>
+<li>
+<a class="el" href="a00383.html">Topology Attributes: Distances, Memory Attributes and CPU Kinds</a> </li>
+<li>
+<a class="el" href="a00384.html">Heterogeneous Memory</a> </li>
+<li>
+<a class="el" href="a00385.html">Importing and exporting topologies from/to XML files</a> </li>
+<li>
+<a class="el" href="a00386.html">Synthetic topologies</a> </li>
+<li>
+<a class="el" href="a00387.html">Interoperability With Other Software</a> </li>
+<li>
+<a class="el" href="a00388.html">Thread Safety</a> </li>
+<li>
+<a class="el" href="a00389.html">Components and plugins</a> </li>
+<li>
+<a class="el" href="a00390.html">Embedding hwloc in Other Software</a> </li>
+<li>
+<a class="el" href="a00391.html">Frequently Asked Questions (FAQ)</a> </li>
+<li>
+<a class="el" href="a00392.html">Upgrading to the hwloc 2.0 API</a> </li>
+</ul>
+</li>
+</ul>
+<p> 
+This page contains all the <i>Introduction</i> sections.
+Chapters are also available from the <i>Related Pages</i> tab above.
+</p>
+<h1><a class="anchor" id="overview"></a>
+hwloc Overview</h1>
+<p>The Hardware Locality (hwloc) software project aims at easing the process of discovering hardware resources in parallel architectures. It offers command-line tools and a C API for consulting these resources, their locality, attributes, and interconnection. hwloc primarily aims at helping high-performance computing (HPC) applications, but is also applicable to any project seeking to exploit code and/or data locality on modern computing platforms.</p>
+<p>hwloc provides command line tools and a C API to obtain the hierarchical map of key computing elements within a node, such as: NUMA memory nodes, shared caches, processor packages, dies and cores, processing units (logical processors or "threads") and even I/O devices. hwloc also gathers various attributes such as cache and memory information, and is portable across a variety of different operating systems and platforms.</p>
+<p>hwloc primarily aims at helping high-performance computing (HPC) applications, but is also applicable to any project seeking to exploit code and/or data locality on modern computing platforms.</p>
+<p>hwloc supports the following operating systems:</p>
+<ul>
+<li>
+Linux (with knowledge of cgroups and cpusets, memory targets/initiators, etc.) on all supported hardware, including Intel Xeon Phi, ScaleMP vSMP, and NumaScale NumaConnect. </li>
+<li>
+Solaris (with support for processor sets and logical domains) </li>
+<li>
+AIX </li>
+<li>
+Darwin / OS X </li>
+<li>
+FreeBSD and its variants (such as kFreeBSD/GNU) </li>
+<li>
+NetBSD </li>
+<li>
+HP-UX </li>
+<li>
+Microsoft Windows </li>
+<li>
+IBM BlueGene/Q Compute Node Kernel (CNK) </li>
+</ul>
+<p>Since it uses standard Operating System information, hwloc's support is mostly independant from the processor type (x86, powerpc, ...) and just relies on the Operating System support. The main exception is BSD operating systems (NetBSD, FreeBSD, etc.) because they do not provide support topology information, hence hwloc uses an x86-only CPUID-based backend (which can be used for other OSes too, see the <a class="el" href="a00389.html">Components and plugins</a> section).</p>
+<p>To check whether hwloc works on a particular machine, just try to build it and run <code>lstopo</code> or <code>lstopo-no-graphics</code>. If some things do not look right (e.g. bogus or missing cache information), see <a class="el" href="index.html#bugs">Questions and Bugs</a>.</p>
+<p>hwloc only reports the number of processors on unsupported operating systems; no topology information is available.</p>
+<p>For development and debugging purposes, hwloc also offers the ability to work on "fake" topologies:</p>
+<ul>
+<li>
+Symmetrical tree of resources generated from a list of level arities, see <a class="el" href="a00386.html">Synthetic topologies</a>. </li>
+<li>
+Remote machine simulation through the gathering of topology as XML files, see <a class="el" href="a00385.html">Importing and exporting topologies from/to XML files</a>. </li>
+</ul>
+<p>hwloc can display the topology in a human-readable format, either in graphical mode (X11), or by exporting in one of several different formats, including: plain text, LaTeX tikzpicture, PDF, PNG, and FIG (see <a class="el" href="index.html#cli_examples">Command-line Examples</a> below). Note that some of the export formats require additional support libraries.</p>
+<p>hwloc offers a programming interface for manipulating topologies and objects. It also brings a powerful CPU bitmap API that is used to describe topology objects location on physical/logical processors. See the <a class="el" href="index.html#interface">Programming Interface</a> below. It may also be used to binding applications onto certain cores or memory nodes. Several utility programs are also provided to ease command-line manipulation of topology objects, binding of processes, and so on.</p>
+<p>Bindings for several other languages are available from the <a href="https://www.open-mpi.org/projects/hwloc/#language_bindings">project website</a>.</p>
+<h1><a class="anchor" id="cli_examples"></a>
+Command-line Examples</h1>
+<p>On a 4-package 2-core machine with hyper-threading, the <code>lstopo</code> tool may show the following graphical output:</p>
+<div class="image">
+<img src="dudley.png" alt=""/>
+</div>
+ <p>Here's the equivalent output in textual form:</p>
+<pre class="fragment">Machine
+  NUMANode L#0 (P#0)
+  Package L#0 + L3 L#0 (4096KB)
+    L2 L#0 (1024KB) + L1 L#0 (16KB) + Core L#0
+      PU L#0 (P#0)
+      PU L#1 (P#8)
+    L2 L#1 (1024KB) + L1 L#1 (16KB) + Core L#1
+      PU L#2 (P#4)
+      PU L#3 (P#12)
+  Package L#1 + L3 L#1 (4096KB)
+    L2 L#2 (1024KB) + L1 L#2 (16KB) + Core L#2
+      PU L#4 (P#1)
+      PU L#5 (P#9)
+    L2 L#3 (1024KB) + L1 L#3 (16KB) + Core L#3
+      PU L#6 (P#5)
+      PU L#7 (P#13)
+  Package L#2 + L3 L#2 (4096KB)
+    L2 L#4 (1024KB) + L1 L#4 (16KB) + Core L#4
+      PU L#8 (P#2)
+      PU L#9 (P#10)
+    L2 L#5 (1024KB) + L1 L#5 (16KB) + Core L#5
+      PU L#10 (P#6)
+      PU L#11 (P#14)
+  Package L#3 + L3 L#3 (4096KB)
+    L2 L#6 (1024KB) + L1 L#6 (16KB) + Core L#6
+      PU L#12 (P#3)
+      PU L#13 (P#11)
+    L2 L#7 (1024KB) + L1 L#7 (16KB) + Core L#7
+      PU L#14 (P#7)
+      PU L#15 (P#15)
+</pre><p>Note that there is also an equivalent output in XML that is meant for exporting/importing topologies but it is hardly readable to human-beings (see <a class="el" href="a00385.html">Importing and exporting topologies from/to XML files</a> for details).</p>
+<p>On a 4-package 2-core Opteron NUMA machine (with two core cores disallowed by the administrator), the <code>lstopo</code> tool may show the following graphical output (with <code>--disallowed</code> for displaying disallowed objects):</p>
+<div class="image">
+<img src="hagrid.png" alt=""/>
+</div>
+ <p>Here's the equivalent output in textual form:</p>
+<pre class="fragment">Machine (32GB total)
+  Package L#0
+    NUMANode L#0 (P#0 8190MB)
+    L2 L#0 (1024KB) + L1 L#0 (64KB) + Core L#0 + PU L#0 (P#0)
+    L2 L#1 (1024KB) + L1 L#1 (64KB) + Core L#1 + PU L#1 (P#1)
+  Package L#1
+    NUMANode L#1 (P#1 8192MB)
+    L2 L#2 (1024KB) + L1 L#2 (64KB) + Core L#2 + PU L#2 (P#2)
+    L2 L#3 (1024KB) + L1 L#3 (64KB) + Core L#3 + PU L#3 (P#3)
+  Package L#2
+    NUMANode L#2 (P#2 8192MB)
+    L2 L#4 (1024KB) + L1 L#4 (64KB) + Core L#4 + PU L#4 (P#4)
+    L2 L#5 (1024KB) + L1 L#5 (64KB) + Core L#5 + PU L#5 (P#5)
+  Package L#3
+    NUMANode L#3 (P#3 8192MB)
+    L2 L#6 (1024KB) + L1 L#6 (64KB) + Core L#6 + PU L#6 (P#6)
+    L2 L#7 (1024KB) + L1 L#7 (64KB) + Core L#7 + PU L#7 (P#7)
+</pre><p>On a 2-package quad-core Xeon (pre-Nehalem, with 2 dual-core dies into each package):</p>
+<div class="image">
+<img src="emmett.png" alt=""/>
+</div>
+ <p>Here's the same output in textual form:</p>
+<pre class="fragment">Machine (total 16GB)
+  NUMANode L#0 (P#0 16GB)
+  Package L#0
+    L2 L#0 (4096KB)
+      L1 L#0 (32KB) + Core L#0 + PU L#0 (P#0)
+      L1 L#1 (32KB) + Core L#1 + PU L#1 (P#4)
+    L2 L#1 (4096KB)
+      L1 L#2 (32KB) + Core L#2 + PU L#2 (P#2)
+      L1 L#3 (32KB) + Core L#3 + PU L#3 (P#6)
+  Package L#1
+    L2 L#2 (4096KB)
+      L1 L#4 (32KB) + Core L#4 + PU L#4 (P#1)
+      L1 L#5 (32KB) + Core L#5 + PU L#5 (P#5)
+    L2 L#3 (4096KB)
+      L1 L#6 (32KB) + Core L#6 + PU L#6 (P#3)
+      L1 L#7 (32KB) + Core L#7 + PU L#7 (P#7)
+</pre><h1><a class="anchor" id="interface"></a>
+Programming Interface</h1>
+<p>The basic interface is available in <a class="el" href="a00104_source.html">hwloc.h</a>. Some higher-level functions are available in <a class="el" href="a00107_source.html">hwloc/helper.h</a> to reduce the need to manually manipulate objects and follow links between them. Documentation for all these is provided later in this document. Developers may also want to look at hwloc/inlines.h which contains the actual inline code of some <a class="el" href="a00104_source.html">hwloc.h</a> routines, and at this document, which provides good higher-level topology traversal examples.</p>
+<p>To precisely define the vocabulary used by hwloc, a <a class="el" href="a00376.html">Terms and Definitions</a> section is available and should probably be read first.</p>
+<p>Each hwloc object contains a cpuset describing the list of processing units that it contains. These bitmaps may be used for <a class="el" href="a00179.html">CPU binding</a> and <a class="el" href="a00180.html">Memory binding</a>. hwloc offers an extensive bitmap manipulation interface in <a class="el" href="a00110_source.html">hwloc/bitmap.h</a>.</p>
+<p>Moreover, hwloc also comes with additional helpers for interoperability with several commonly used environments. See the <a class="el" href="a00387.html">Interoperability With Other Software</a> section for details.</p>
+<p>The complete API documentation is available in a full set of HTML pages, man pages, and self-contained PDF files (formatted for both both US letter and A4 formats) in the source tarball in doc/doxygen-doc/.</p>
+<p><b>NOTE:</b> If you are building the documentation from a Git clone, you will need to have Doxygen and pdflatex installed &ndash; the documentation will be built during the normal "make" process. The documentation is installed during "make install" to $prefix/share/doc/hwloc/ and your systems default man page tree (under $prefix, of course).</p>
+<h2><a class="anchor" id="portability"></a>
+Portability</h2>
+<p>Operating System have varying support for CPU and memory binding, e.g. while some Operating Systems provide interfaces for all kinds of CPU and memory bindings, some others provide only interfaces for a limited number of kinds of CPU and memory binding, and some do not provide any binding interface at all. Hwloc's binding functions would then simply return the ENOSYS error (Function not implemented), meaning that the underlying Operating System does not provide any interface for them. <a class="el" href="a00179.html">CPU binding</a> and <a class="el" href="a00180.html">Memory binding</a> provide more information on which hwloc binding functions should be preferred because interfaces for them are usually available on the supported Operating Systems.</p>
+<p>Similarly, the ability of reporting topology information varies from one platform to another. As shown in <a class="el" href="index.html#cli_examples">Command-line Examples</a>, hwloc can obtain information on a wide variety of hardware topologies. However, some platforms and/or operating system versions will only report a subset of this information. For example, on an PPC64-based system with 8 cores (each with 2 hardware threads) running a default 2.6.18-based kernel from RHEL 5.4, hwloc is only able to glean information about NUMA nodes and processor units (PUs). No information about caches, packages, or cores is available.</p>
+<p>Here's the graphical output from lstopo on this platform when Simultaneous Multi-Threading (SMT) is enabled:</p>
+<div class="image">
+<img src="ppc64-with-smt.png" alt=""/>
+</div>
+ <p>And here's the graphical output from lstopo on this platform when SMT is disabled:</p>
+<div class="image">
+<img src="ppc64-without-smt.png" alt=""/>
+</div>
+ <p>Notice that hwloc only sees half the PUs when SMT is disabled. PU L#6, for example, seems to change location from NUMA node #0 to #1. In reality, no PUs "moved" &ndash; they were simply re-numbered when hwloc only saw half as many (see also Logical index in <a class="el" href="a00376.html#termsanddefs_indexes">Indexes and Sets</a>). Hence, PU L#6 in the SMT-disabled picture probably corresponds to PU L#12 in the SMT-enabled picture.</p>
+<p>This same "PUs have disappeared" effect can be seen on other platforms &ndash; even platforms / OSs that provide much more information than the above PPC64 system. This is an unfortunate side-effect of how operating systems report information to hwloc.</p>
+<p>Note that upgrading the Linux kernel on the same PPC64 system mentioned above to 2.6.34, hwloc is able to discover all the topology information. The following picture shows the entire topology layout when SMT is enabled:</p>
+<div class="image">
+<img src="ppc64-full-with-smt.png" alt=""/>
+</div>
+ <p>Developers using the hwloc API or XML output for portable applications should therefore be extremely careful to not make any assumptions about the structure of data that is returned. For example, per the above reported PPC topology, it is not safe to assume that PUs will always be descendants of cores.</p>
+<p>Additionally, future hardware may insert new topology elements that are not available in this version of hwloc. Long-lived applications that are meant to span multiple different hardware platforms should also be careful about making structure assumptions. For example, a new element may someday exist between a core and a PU.</p>
+<h2><a class="anchor" id="interface_example"></a>
+API Example</h2>
+<p>The following small C example (available in the source tree as ``doc/examples/hwloc-hello.c'') prints the topology of the machine and performs some thread and memory binding. More examples are available in the doc/examples/ directory of the source tree.</p>
+<div class="fragment"><div class="line"><span class="comment">/* Example hwloc API program.</span></div>
+<div class="line"><span class="comment"> *</span></div>
+<div class="line"><span class="comment"> * See other examples under doc/examples/ in the source tree</span></div>
+<div class="line"><span class="comment"> * for more details.</span></div>
+<div class="line"><span class="comment"> *</span></div>
+<div class="line"><span class="comment"> * Copyright © 2009-2016 Inria.  All rights reserved.</span></div>
+<div class="line"><span class="comment"> * Copyright © 2009-2011 Université Bordeaux</span></div>
+<div class="line"><span class="comment"> * Copyright © 2009-2010 Cisco Systems, Inc.  All rights reserved.</span></div>
+<div class="line"><span class="comment"> * See COPYING in top-level directory.</span></div>
+<div class="line"><span class="comment"> *</span></div>
+<div class="line"><span class="comment"> * hwloc-hello.c</span></div>
+<div class="line"><span class="comment"> */</span></div>
+<div class="line"> </div>
+<div class="line"><span class="preprocessor">#include &quot;hwloc.h&quot;</span></div>
+<div class="line"> </div>
+<div class="line"><span class="preprocessor">#include &lt;errno.h&gt;</span></div>
+<div class="line"><span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
+<div class="line"><span class="preprocessor">#include &lt;string.h&gt;</span></div>
+<div class="line"> </div>
+<div class="line"><span class="keyword">static</span> <span class="keywordtype">void</span> print_children(<a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology, <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj,</div>
+<div class="line">                           <span class="keywordtype">int</span> depth)</div>
+<div class="line">{</div>
+<div class="line">    <span class="keywordtype">char</span> type[32], attr[1024];</div>
+<div class="line">    <span class="keywordtype">unsigned</span> i;</div>
+<div class="line"> </div>
+<div class="line">    <a class="code hl_function" href="a00177.html#gadb8765c260edea80c52cd06a76639ba4">hwloc_obj_type_snprintf</a>(type, <span class="keyword">sizeof</span>(type), obj, 0);</div>
+<div class="line">    printf(<span class="stringliteral">&quot;%*s%s&quot;</span>, 2*depth, <span class="stringliteral">&quot;&quot;</span>, type);</div>
+<div class="line">    <span class="keywordflow">if</span> (obj-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a> != (<span class="keywordtype">unsigned</span>) -1)</div>
+<div class="line">      printf(<span class="stringliteral">&quot;#%u&quot;</span>, obj-&gt;<a class="code hl_variable" href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">os_index</a>);</div>
+<div class="line">    <a class="code hl_function" href="a00177.html#ga870e876931c282a1c7aee2f031912ce3">hwloc_obj_attr_snprintf</a>(attr, <span class="keyword">sizeof</span>(attr), obj, <span class="stringliteral">&quot; &quot;</span>, 0);</div>
+<div class="line">    <span class="keywordflow">if</span> (*attr)</div>
+<div class="line">      printf(<span class="stringliteral">&quot;(%s)&quot;</span>, attr);</div>
+<div class="line">    printf(<span class="stringliteral">&quot;\n&quot;</span>);</div>
+<div class="line">    <span class="keywordflow">for</span> (i = 0; i &lt; obj-&gt;<a class="code hl_variable" href="a00229.html#aac3f6da35c9b57599909a44ce2b716c1">arity</a>; i++) {</div>
+<div class="line">        print_children(topology, obj-&gt;<a class="code hl_variable" href="a00229.html#a04d05403da37bfe17cd63b7c7dd07b1f">children</a>[i], depth + 1);</div>
+<div class="line">    }</div>
+<div class="line">}</div>
+<div class="line"> </div>
+<div class="line"><span class="keywordtype">int</span> main(<span class="keywordtype">void</span>)</div>
+<div class="line">{</div>
+<div class="line">    <span class="keywordtype">int</span> depth;</div>
+<div class="line">    <span class="keywordtype">unsigned</span> i, n;</div>
+<div class="line">    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> size;</div>
+<div class="line">    <span class="keywordtype">int</span> levels;</div>
+<div class="line">    <span class="keywordtype">char</span> <span class="keywordtype">string</span>[128];</div>
+<div class="line">    <span class="keywordtype">int</span> topodepth;</div>
+<div class="line">    <span class="keywordtype">void</span> *m;</div>
+<div class="line">    <a class="code hl_typedef" href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a> topology;</div>
+<div class="line">    <a class="code hl_typedef" href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a> cpuset;</div>
+<div class="line">    <a class="code hl_struct" href="a00229.html">hwloc_obj_t</a> obj;</div>
+<div class="line"> </div>
+<div class="line">    <span class="comment">/* Allocate and initialize topology object. */</span></div>
+<div class="line">    <a class="code hl_function" href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa">hwloc_topology_init</a>(&amp;topology);</div>
+<div class="line"> </div>
+<div class="line">    <span class="comment">/* ... Optionally, put detection configuration here to ignore</span></div>
+<div class="line"><span class="comment">       some objects types, define a synthetic topology, etc....</span></div>
+<div class="line"><span class="comment"></span> </div>
+<div class="line"><span class="comment">       The default is to detect all the objects of the machine that</span></div>
+<div class="line"><span class="comment">       the caller is allowed to access.  See Configure Topology</span></div>
+<div class="line"><span class="comment">       Detection. */</span></div>
+<div class="line"> </div>
+<div class="line">    <span class="comment">/* Perform the topology detection. */</span></div>
+<div class="line">    <a class="code hl_function" href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826">hwloc_topology_load</a>(topology);</div>
+<div class="line"> </div>
+<div class="line">    <span class="comment">/* Optionally, get some additional topology information</span></div>
+<div class="line"><span class="comment">       in case we need the topology depth later. */</span></div>
+<div class="line">    topodepth = <a class="code hl_function" href="a00176.html#gae54d1782ca9b54bea915f5c18a9158fa">hwloc_topology_get_depth</a>(topology);</div>
+<div class="line"> </div>
+<div class="line"><span class="comment">    /*****************************************************************</span></div>
+<div class="line"><span class="comment">     * First example:</span></div>
+<div class="line"><span class="comment">     * Walk the topology with an array style, from level 0 (always</span></div>
+<div class="line"><span class="comment">     * the system level) to the lowest level (always the proc level).</span></div>
+<div class="line"><span class="comment">     *****************************************************************/</span></div>
+<div class="line">    <span class="keywordflow">for</span> (depth = 0; depth &lt; topodepth; depth++) {</div>
+<div class="line">        printf(<span class="stringliteral">&quot;*** Objects at level %d\n&quot;</span>, depth);</div>
+<div class="line">        <span class="keywordflow">for</span> (i = 0; i &lt; <a class="code hl_function" href="a00176.html#ga1d5ceafe8130fe6e8657bf0bc666ba50">hwloc_get_nbobjs_by_depth</a>(topology, depth);</div>
+<div class="line">             i++) {</div>
+<div class="line">            <a class="code hl_function" href="a00177.html#gadb8765c260edea80c52cd06a76639ba4">hwloc_obj_type_snprintf</a>(<span class="keywordtype">string</span>, <span class="keyword">sizeof</span>(<span class="keywordtype">string</span>),</div>
+<div class="line">                                    <a class="code hl_function" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0">hwloc_get_obj_by_depth</a>(topology, depth, i), 0);</div>
+<div class="line">            printf(<span class="stringliteral">&quot;Index %u: %s\n&quot;</span>, i, <span class="keywordtype">string</span>);</div>
+<div class="line">        }</div>
+<div class="line">    }</div>
+<div class="line"> </div>
+<div class="line"><span class="comment">    /*****************************************************************</span></div>
+<div class="line"><span class="comment">     * Second example:</span></div>
+<div class="line"><span class="comment">     * Walk the topology with a tree style.</span></div>
+<div class="line"><span class="comment">     *****************************************************************/</span></div>
+<div class="line">    printf(<span class="stringliteral">&quot;*** Printing overall tree\n&quot;</span>);</div>
+<div class="line">    print_children(topology, <a class="code hl_function" href="a00176.html#ga2d4b12fc187dfc53b35f2fa21d21044d">hwloc_get_root_obj</a>(topology), 0);</div>
+<div class="line"> </div>
+<div class="line"><span class="comment">    /*****************************************************************</span></div>
+<div class="line"><span class="comment">     * Third example:</span></div>
+<div class="line"><span class="comment">     * Print the number of packages.</span></div>
+<div class="line"><span class="comment">     *****************************************************************/</span></div>
+<div class="line">    depth = <a class="code hl_function" href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ab16ab8c0dbffc234921d86f3dfb63129">HWLOC_OBJ_PACKAGE</a>);</div>
+<div class="line">    <span class="keywordflow">if</span> (depth == <a class="code hl_enumvalue" href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a>) {</div>
+<div class="line">        printf(<span class="stringliteral">&quot;*** The number of packages is unknown\n&quot;</span>);</div>
+<div class="line">    } <span class="keywordflow">else</span> {</div>
+<div class="line">        printf(<span class="stringliteral">&quot;*** %u package(s)\n&quot;</span>,</div>
+<div class="line">               <a class="code hl_function" href="a00176.html#ga1d5ceafe8130fe6e8657bf0bc666ba50">hwloc_get_nbobjs_by_depth</a>(topology, depth));</div>
+<div class="line">    }</div>
+<div class="line"> </div>
+<div class="line"><span class="comment">    /*****************************************************************</span></div>
+<div class="line"><span class="comment">     * Fourth example:</span></div>
+<div class="line"><span class="comment">     * Compute the amount of cache that the first logical processor</span></div>
+<div class="line"><span class="comment">     * has above it.</span></div>
+<div class="line"><span class="comment">     *****************************************************************/</span></div>
+<div class="line">    levels = 0;</div>
+<div class="line">    size = 0;</div>
+<div class="line">    <span class="keywordflow">for</span> (obj = <a class="code hl_function" href="a00176.html#ga6f414dd80a2b943967a0ac92da3181a2">hwloc_get_obj_by_type</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661">HWLOC_OBJ_PU</a>, 0);</div>
+<div class="line">         obj;</div>
+<div class="line">         obj = obj-&gt;<a class="code hl_variable" href="a00229.html#adc494f6aed939992be1c55cca5822900">parent</a>)</div>
+<div class="line">      <span class="keywordflow">if</span> (<a class="code hl_function" href="a00184.html#ga2ed589bea28711e80b92066510a5607d">hwloc_obj_type_is_cache</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#acc4f0803f244867e68fe0036800be5de">type</a>)) {</div>
+<div class="line">        levels++;</div>
+<div class="line">        size += obj-&gt;<a class="code hl_variable" href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">attr</a>-&gt;<a class="code hl_variable" href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">cache</a>.<a class="code hl_variable" href="a00245.html#abe5e788943ed04302976740c829674c0">size</a>;</div>
+<div class="line">      }</div>
+<div class="line">    printf(<span class="stringliteral">&quot;*** Logical processor 0 has %d caches totaling %luKB\n&quot;</span>,</div>
+<div class="line">           levels, size / 1024);</div>
+<div class="line"> </div>
+<div class="line"><span class="comment">    /*****************************************************************</span></div>
+<div class="line"><span class="comment">     * Fifth example:</span></div>
+<div class="line"><span class="comment">     * Bind to only one thread of the last core of the machine.</span></div>
+<div class="line"><span class="comment">     *</span></div>
+<div class="line"><span class="comment">     * First find out where cores are, or else smaller sets of CPUs if</span></div>
+<div class="line"><span class="comment">     * the OS doesn&#39;t have the notion of a &quot;core&quot;.</span></div>
+<div class="line"><span class="comment">     *****************************************************************/</span></div>
+<div class="line">    depth = <a class="code hl_function" href="a00176.html#ga8125328e69eba709c33ea8055c12589b">hwloc_get_type_or_below_depth</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ac793958f330bca371aa1535de8aff45f">HWLOC_OBJ_CORE</a>);</div>
+<div class="line"> </div>
+<div class="line">    <span class="comment">/* Get last core. */</span></div>
+<div class="line">    obj = <a class="code hl_function" href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0">hwloc_get_obj_by_depth</a>(topology, depth,</div>
+<div class="line">                   <a class="code hl_function" href="a00176.html#ga1d5ceafe8130fe6e8657bf0bc666ba50">hwloc_get_nbobjs_by_depth</a>(topology, depth) - 1);</div>
+<div class="line">    <span class="keywordflow">if</span> (obj) {</div>
+<div class="line">        <span class="comment">/* Get a copy of its cpuset that we may modify. */</span></div>
+<div class="line">        cpuset = <a class="code hl_function" href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee">hwloc_bitmap_dup</a>(obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>);</div>
+<div class="line"> </div>
+<div class="line">        <span class="comment">/* Get only one logical processor (in case the core is</span></div>
+<div class="line"><span class="comment">           SMT/hyper-threaded). */</span></div>
+<div class="line">        <a class="code hl_function" href="a00194.html#gaa611a77c092e679246afdf9a60d5db8b">hwloc_bitmap_singlify</a>(cpuset);</div>
+<div class="line"> </div>
+<div class="line">        <span class="comment">/* And try to bind ourself there. */</span></div>
+<div class="line">        <span class="keywordflow">if</span> (<a class="code hl_function" href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48">hwloc_set_cpubind</a>(topology, cpuset, 0)) {</div>
+<div class="line">            <span class="keywordtype">char</span> *str;</div>
+<div class="line">            <span class="keywordtype">int</span> error = errno;</div>
+<div class="line">            <a class="code hl_function" href="a00194.html#ga0fece972134fdecf2da9bc7a11dd827e">hwloc_bitmap_asprintf</a>(&amp;str, obj-&gt;<a class="code hl_variable" href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">cpuset</a>);</div>
+<div class="line">            printf(<span class="stringliteral">&quot;Couldn&#39;t bind to cpuset %s: %s\n&quot;</span>, str, strerror(error));</div>
+<div class="line">            free(str);</div>
+<div class="line">        }</div>
+<div class="line"> </div>
+<div class="line">        <span class="comment">/* Free our cpuset copy */</span></div>
+<div class="line">        <a class="code hl_function" href="a00194.html#ga156130d85b3a0674d6e0e6770fe68fbe">hwloc_bitmap_free</a>(cpuset);</div>
+<div class="line">    }</div>
+<div class="line"> </div>
+<div class="line"><span class="comment">    /*****************************************************************</span></div>
+<div class="line"><span class="comment">     * Sixth example:</span></div>
+<div class="line"><span class="comment">     * Allocate some memory on the last NUMA node, bind some existing</span></div>
+<div class="line"><span class="comment">     * memory to the last NUMA node.</span></div>
+<div class="line"><span class="comment">     *****************************************************************/</span></div>
+<div class="line">    <span class="comment">/* Get last node. There&#39;s always at least one. */</span></div>
+<div class="line">    n = <a class="code hl_function" href="a00176.html#ga789a3f65aedff644be64a18526a03065">hwloc_get_nbobjs_by_type</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>);</div>
+<div class="line">    obj = <a class="code hl_function" href="a00176.html#ga6f414dd80a2b943967a0ac92da3181a2">hwloc_get_obj_by_type</a>(topology, <a class="code hl_enumvalue" href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a>, n - 1);</div>
+<div class="line"> </div>
+<div class="line">    size = 1024*1024;</div>
+<div class="line">    m = <a class="code hl_function" href="a00180.html#gadf87089ef533db40460ccc24b5bc0d65">hwloc_alloc_membind</a>(topology, size, obj-&gt;<a class="code hl_variable" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">nodeset</a>,</div>
+<div class="line">                            <a class="code hl_enumvalue" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c">HWLOC_MEMBIND_BIND</a>, <a class="code hl_enumvalue" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256">HWLOC_MEMBIND_BYNODESET</a>);</div>
+<div class="line">    <a class="code hl_function" href="a00180.html#ga32dbd4f54e9e4a7179f2dde37ffe6ad7">hwloc_free</a>(topology, m, size);</div>
+<div class="line"> </div>
+<div class="line">    m = malloc(size);</div>
+<div class="line">    <a class="code hl_function" href="a00180.html#gaf881faefe20701229f07dd7dbd0125ed">hwloc_set_area_membind</a>(topology, m, size, obj-&gt;<a class="code hl_variable" href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">nodeset</a>,</div>
+<div class="line">                           <a class="code hl_enumvalue" href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c">HWLOC_MEMBIND_BIND</a>, <a class="code hl_enumvalue" href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256">HWLOC_MEMBIND_BYNODESET</a>);</div>
+<div class="line">    free(m);</div>
+<div class="line"> </div>
+<div class="line">    <span class="comment">/* Destroy topology object. */</span></div>
+<div class="line">    <a class="code hl_function" href="a00175.html#ga9f34a640b6fd28d23699d4d084667b15">hwloc_topology_destroy</a>(topology);</div>
+<div class="line"> </div>
+<div class="line">    <span class="keywordflow">return</span> 0;</div>
+<div class="line">}</div>
+<div class="ttc" id="aa00172_html_ga4bbf39b68b6f568fb92739e7c0ea7801"><div class="ttname"><a href="a00172.html#ga4bbf39b68b6f568fb92739e7c0ea7801">hwloc_cpuset_t</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_cpuset_t</div><div class="ttdoc">A CPU set is a bitmap whose bits are set according to CPU physical OS indexes.</div><div class="ttdef"><b>Definition</b> hwloc.h:161</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a">HWLOC_OBJ_NUMANODE</a></div><div class="ttdeci">@ HWLOC_OBJ_NUMANODE</div><div class="ttdoc">NUMA node. An object that contains memory that is directly and byte-accessible to the host processors...</div><div class="ttdef"><b>Definition</b> hwloc.h:257</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55ab16ab8c0dbffc234921d86f3dfb63129"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ab16ab8c0dbffc234921d86f3dfb63129">HWLOC_OBJ_PACKAGE</a></div><div class="ttdeci">@ HWLOC_OBJ_PACKAGE</div><div class="ttdoc">Physical package. The physical package that usually gets inserted into a socket on the motherboard....</div><div class="ttdef"><b>Definition</b> hwloc.h:212</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661">HWLOC_OBJ_PU</a></div><div class="ttdeci">@ HWLOC_OBJ_PU</div><div class="ttdoc">Processing Unit, or (Logical) Processor. An execution unit (may share a core with some other logical ...</div><div class="ttdef"><b>Definition</b> hwloc.h:222</div></div>
+<div class="ttc" id="aa00173_html_ggacd37bb612667dc437d66bfb175a8dc55ac793958f330bca371aa1535de8aff45f"><div class="ttname"><a href="a00173.html#ggacd37bb612667dc437d66bfb175a8dc55ac793958f330bca371aa1535de8aff45f">HWLOC_OBJ_CORE</a></div><div class="ttdeci">@ HWLOC_OBJ_CORE</div><div class="ttdoc">Core. A computation unit (may be shared by several PUs, aka logical processors).</div><div class="ttdef"><b>Definition</b> hwloc.h:218</div></div>
+<div class="ttc" id="aa00175_html_ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa"><div class="ttname"><a href="a00175.html#ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa">hwloc_topology_init</a></div><div class="ttdeci">int hwloc_topology_init(hwloc_topology_t *topologyp)</div><div class="ttdoc">Allocate a topology context.</div></div>
+<div class="ttc" id="aa00175_html_ga9d1e76ee15a7dee158b786c30b6a6e38"><div class="ttname"><a href="a00175.html#ga9d1e76ee15a7dee158b786c30b6a6e38">hwloc_topology_t</a></div><div class="ttdeci">struct hwloc_topology * hwloc_topology_t</div><div class="ttdoc">Topology context.</div><div class="ttdef"><b>Definition</b> hwloc.h:742</div></div>
+<div class="ttc" id="aa00175_html_ga9f34a640b6fd28d23699d4d084667b15"><div class="ttname"><a href="a00175.html#ga9f34a640b6fd28d23699d4d084667b15">hwloc_topology_destroy</a></div><div class="ttdeci">void hwloc_topology_destroy(hwloc_topology_t topology)</div><div class="ttdoc">Terminate and free a topology context.</div></div>
+<div class="ttc" id="aa00175_html_gabdf58d87ad77f6615fccdfe0535ff826"><div class="ttname"><a href="a00175.html#gabdf58d87ad77f6615fccdfe0535ff826">hwloc_topology_load</a></div><div class="ttdeci">int hwloc_topology_load(hwloc_topology_t topology)</div><div class="ttdoc">Build the actual topology.</div></div>
+<div class="ttc" id="aa00176_html_ga1d5ceafe8130fe6e8657bf0bc666ba50"><div class="ttname"><a href="a00176.html#ga1d5ceafe8130fe6e8657bf0bc666ba50">hwloc_get_nbobjs_by_depth</a></div><div class="ttdeci">unsigned hwloc_get_nbobjs_by_depth(hwloc_topology_t topology, int depth)</div><div class="ttdoc">Returns the width of level at depth depth.</div></div>
+<div class="ttc" id="aa00176_html_ga2d4b12fc187dfc53b35f2fa21d21044d"><div class="ttname"><a href="a00176.html#ga2d4b12fc187dfc53b35f2fa21d21044d">hwloc_get_root_obj</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_root_obj(hwloc_topology_t topology)</div><div class="ttdoc">Returns the top-object of the topology-tree.</div></div>
+<div class="ttc" id="aa00176_html_ga391f6b2613f0065673eaa4069b93d4e0"><div class="ttname"><a href="a00176.html#ga391f6b2613f0065673eaa4069b93d4e0">hwloc_get_obj_by_depth</a></div><div class="ttdeci">hwloc_obj_t hwloc_get_obj_by_depth(hwloc_topology_t topology, int depth, unsigned idx)</div><div class="ttdoc">Returns the topology object at logical index idx from depth depth.</div></div>
+<div class="ttc" id="aa00176_html_ga6f414dd80a2b943967a0ac92da3181a2"><div class="ttname"><a href="a00176.html#ga6f414dd80a2b943967a0ac92da3181a2">hwloc_get_obj_by_type</a></div><div class="ttdeci">static hwloc_obj_t hwloc_get_obj_by_type(hwloc_topology_t topology, hwloc_obj_type_t type, unsigned idx)</div><div class="ttdoc">Returns the topology object at logical index idx with type type.</div></div>
+<div class="ttc" id="aa00176_html_ga789a3f65aedff644be64a18526a03065"><div class="ttname"><a href="a00176.html#ga789a3f65aedff644be64a18526a03065">hwloc_get_nbobjs_by_type</a></div><div class="ttdeci">static int hwloc_get_nbobjs_by_type(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Returns the width of level type type.</div></div>
+<div class="ttc" id="aa00176_html_ga8125328e69eba709c33ea8055c12589b"><div class="ttname"><a href="a00176.html#ga8125328e69eba709c33ea8055c12589b">hwloc_get_type_or_below_depth</a></div><div class="ttdeci">static int hwloc_get_type_or_below_depth(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Returns the depth of objects of type type or below.</div></div>
+<div class="ttc" id="aa00176_html_ga8bec782e21be313750da70cf7428b374"><div class="ttname"><a href="a00176.html#ga8bec782e21be313750da70cf7428b374">hwloc_get_type_depth</a></div><div class="ttdeci">int hwloc_get_type_depth(hwloc_topology_t topology, hwloc_obj_type_t type)</div><div class="ttdoc">Returns the depth of objects of type type.</div></div>
+<div class="ttc" id="aa00176_html_gae54d1782ca9b54bea915f5c18a9158fa"><div class="ttname"><a href="a00176.html#gae54d1782ca9b54bea915f5c18a9158fa">hwloc_topology_get_depth</a></div><div class="ttdeci">int hwloc_topology_get_depth(hwloc_topology_t restrict topology)</div><div class="ttdoc">Get the depth of the hierarchical tree of objects.</div></div>
+<div class="ttc" id="aa00176_html_ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad"><div class="ttname"><a href="a00176.html#ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad">HWLOC_TYPE_DEPTH_UNKNOWN</a></div><div class="ttdeci">@ HWLOC_TYPE_DEPTH_UNKNOWN</div><div class="ttdoc">No object of given type exists in the topology.</div><div class="ttdef"><b>Definition</b> hwloc.h:879</div></div>
+<div class="ttc" id="aa00177_html_ga870e876931c282a1c7aee2f031912ce3"><div class="ttname"><a href="a00177.html#ga870e876931c282a1c7aee2f031912ce3">hwloc_obj_attr_snprintf</a></div><div class="ttdeci">int hwloc_obj_attr_snprintf(char *restrict string, size_t size, hwloc_obj_t obj, const char *restrict separator, int verbose)</div><div class="ttdoc">Stringify the attributes of a given topology object into a human-readable form.</div></div>
+<div class="ttc" id="aa00177_html_gadb8765c260edea80c52cd06a76639ba4"><div class="ttname"><a href="a00177.html#gadb8765c260edea80c52cd06a76639ba4">hwloc_obj_type_snprintf</a></div><div class="ttdeci">int hwloc_obj_type_snprintf(char *restrict string, size_t size, hwloc_obj_t obj, int verbose)</div><div class="ttdoc">Stringify the type of a given topology object into a human-readable form.</div></div>
+<div class="ttc" id="aa00179_html_ga80bc07473a8edf840cae17bd7ec21d48"><div class="ttname"><a href="a00179.html#ga80bc07473a8edf840cae17bd7ec21d48">hwloc_set_cpubind</a></div><div class="ttdeci">int hwloc_set_cpubind(hwloc_topology_t topology, hwloc_const_cpuset_t set, int flags)</div><div class="ttdoc">Bind current process or thread on CPUs given in physical bitmap set.</div></div>
+<div class="ttc" id="aa00180_html_ga32dbd4f54e9e4a7179f2dde37ffe6ad7"><div class="ttname"><a href="a00180.html#ga32dbd4f54e9e4a7179f2dde37ffe6ad7">hwloc_free</a></div><div class="ttdeci">int hwloc_free(hwloc_topology_t topology, void *addr, size_t len)</div><div class="ttdoc">Free memory that was previously allocated by hwloc_alloc() or hwloc_alloc_membind().</div></div>
+<div class="ttc" id="aa00180_html_gadf87089ef533db40460ccc24b5bc0d65"><div class="ttname"><a href="a00180.html#gadf87089ef533db40460ccc24b5bc0d65">hwloc_alloc_membind</a></div><div class="ttdeci">void * hwloc_alloc_membind(hwloc_topology_t topology, size_t len, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</div><div class="ttdoc">Allocate some memory on NUMA memory nodes specified by set.</div></div>
+<div class="ttc" id="aa00180_html_gaf881faefe20701229f07dd7dbd0125ed"><div class="ttname"><a href="a00180.html#gaf881faefe20701229f07dd7dbd0125ed">hwloc_set_area_membind</a></div><div class="ttdeci">int hwloc_set_area_membind(hwloc_topology_t topology, const void *addr, size_t len, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</div><div class="ttdoc">Bind the already-allocated memory identified by (addr, len) to the NUMA node(s) specified by set.</div></div>
+<div class="ttc" id="aa00180_html_ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256"><div class="ttname"><a href="a00180.html#ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256">HWLOC_MEMBIND_BYNODESET</a></div><div class="ttdeci">@ HWLOC_MEMBIND_BYNODESET</div><div class="ttdoc">Consider the bitmap argument as a nodeset.</div><div class="ttdef"><b>Definition</b> hwloc.h:1634</div></div>
+<div class="ttc" id="aa00180_html_ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c"><div class="ttname"><a href="a00180.html#ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c">HWLOC_MEMBIND_BIND</a></div><div class="ttdeci">@ HWLOC_MEMBIND_BIND</div><div class="ttdoc">Allocate memory on the specified nodes.</div><div class="ttdef"><b>Definition</b> hwloc.h:1536</div></div>
+<div class="ttc" id="aa00184_html_ga2ed589bea28711e80b92066510a5607d"><div class="ttname"><a href="a00184.html#ga2ed589bea28711e80b92066510a5607d">hwloc_obj_type_is_cache</a></div><div class="ttdeci">int hwloc_obj_type_is_cache(hwloc_obj_type_t type)</div><div class="ttdoc">Check whether an object type is a CPU Cache (Data, Unified or Instruction).</div></div>
+<div class="ttc" id="aa00194_html_ga0fece972134fdecf2da9bc7a11dd827e"><div class="ttname"><a href="a00194.html#ga0fece972134fdecf2da9bc7a11dd827e">hwloc_bitmap_asprintf</a></div><div class="ttdeci">int hwloc_bitmap_asprintf(char **strp, hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Stringify a bitmap into a newly allocated string.</div></div>
+<div class="ttc" id="aa00194_html_ga156130d85b3a0674d6e0e6770fe68fbe"><div class="ttname"><a href="a00194.html#ga156130d85b3a0674d6e0e6770fe68fbe">hwloc_bitmap_free</a></div><div class="ttdeci">void hwloc_bitmap_free(hwloc_bitmap_t bitmap)</div><div class="ttdoc">Free bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_gaa611a77c092e679246afdf9a60d5db8b"><div class="ttname"><a href="a00194.html#gaa611a77c092e679246afdf9a60d5db8b">hwloc_bitmap_singlify</a></div><div class="ttdeci">int hwloc_bitmap_singlify(hwloc_bitmap_t bitmap)</div><div class="ttdoc">Keep a single index among those set in bitmap bitmap.</div></div>
+<div class="ttc" id="aa00194_html_gae679434c1a5f41d3560a8a7e2c1b0dee"><div class="ttname"><a href="a00194.html#gae679434c1a5f41d3560a8a7e2c1b0dee">hwloc_bitmap_dup</a></div><div class="ttdeci">hwloc_bitmap_t hwloc_bitmap_dup(hwloc_const_bitmap_t bitmap)</div><div class="ttdoc">Duplicate bitmap bitmap by allocating a new bitmap and copying bitmap contents.</div></div>
+<div class="ttc" id="aa00229_html"><div class="ttname"><a href="a00229.html">hwloc_obj</a></div><div class="ttdoc">Structure of a topology object.</div><div class="ttdef"><b>Definition</b> hwloc.h:431</div></div>
+<div class="ttc" id="aa00229_html_a04d05403da37bfe17cd63b7c7dd07b1f"><div class="ttname"><a href="a00229.html#a04d05403da37bfe17cd63b7c7dd07b1f">hwloc_obj::children</a></div><div class="ttdeci">struct hwloc_obj ** children</div><div class="ttdoc">Normal children, children[0 .. arity -1].</div><div class="ttdef"><b>Definition</b> hwloc.h:491</div></div>
+<div class="ttc" id="aa00229_html_a08f0d0e16c619a6e653526cbee4ffea3"><div class="ttname"><a href="a00229.html#a08f0d0e16c619a6e653526cbee4ffea3">hwloc_obj::nodeset</a></div><div class="ttdeci">hwloc_nodeset_t nodeset</div><div class="ttdoc">NUMA nodes covered by this object or containing this object.</div><div class="ttdef"><b>Definition</b> hwloc.h:575</div></div>
+<div class="ttc" id="aa00229_html_a61a7a80a68eaccbaaa28269e678c81a9"><div class="ttname"><a href="a00229.html#a61a7a80a68eaccbaaa28269e678c81a9">hwloc_obj::os_index</a></div><div class="ttdeci">unsigned os_index</div><div class="ttdoc">OS-provided physical index number. It is not guaranteed unique across the entire machine,...</div><div class="ttdef"><b>Definition</b> hwloc.h:436</div></div>
+<div class="ttc" id="aa00229_html_a67925e0f2c47f50408fbdb9bddd0790f"><div class="ttname"><a href="a00229.html#a67925e0f2c47f50408fbdb9bddd0790f">hwloc_obj::cpuset</a></div><div class="ttdeci">hwloc_cpuset_t cpuset</div><div class="ttdoc">CPUs covered by this object.</div><div class="ttdef"><b>Definition</b> hwloc.h:547</div></div>
+<div class="ttc" id="aa00229_html_aac3f6da35c9b57599909a44ce2b716c1"><div class="ttname"><a href="a00229.html#aac3f6da35c9b57599909a44ce2b716c1">hwloc_obj::arity</a></div><div class="ttdeci">unsigned arity</div><div class="ttdoc">Number of normal children. Memory, Misc and I/O children are not listed here but rather in their dedi...</div><div class="ttdef"><b>Definition</b> hwloc.h:487</div></div>
+<div class="ttc" id="aa00229_html_acc4f0803f244867e68fe0036800be5de"><div class="ttname"><a href="a00229.html#acc4f0803f244867e68fe0036800be5de">hwloc_obj::type</a></div><div class="ttdeci">hwloc_obj_type_t type</div><div class="ttdoc">Type of object.</div><div class="ttdef"><b>Definition</b> hwloc.h:433</div></div>
+<div class="ttc" id="aa00229_html_accd40e29f71f19e88db62ea3df02adc8"><div class="ttname"><a href="a00229.html#accd40e29f71f19e88db62ea3df02adc8">hwloc_obj::attr</a></div><div class="ttdeci">union hwloc_obj_attr_u * attr</div><div class="ttdoc">Object type-specific Attributes, may be NULL if no attribute value was found.</div><div class="ttdef"><b>Definition</b> hwloc.h:450</div></div>
+<div class="ttc" id="aa00229_html_adc494f6aed939992be1c55cca5822900"><div class="ttname"><a href="a00229.html#adc494f6aed939992be1c55cca5822900">hwloc_obj::parent</a></div><div class="ttdeci">struct hwloc_obj * parent</div><div class="ttdoc">Parent, NULL if root (Machine object)</div><div class="ttdef"><b>Definition</b> hwloc.h:481</div></div>
+<div class="ttc" id="aa00233_html_a23f553f3252c9d13f2338231cd354ea9"><div class="ttname"><a href="a00233.html#a23f553f3252c9d13f2338231cd354ea9">hwloc_obj_attr_u::cache</a></div><div class="ttdeci">struct hwloc_obj_attr_u::hwloc_cache_attr_s cache</div></div>
+<div class="ttc" id="aa00245_html_abe5e788943ed04302976740c829674c0"><div class="ttname"><a href="a00245.html#abe5e788943ed04302976740c829674c0">hwloc_obj_attr_u::hwloc_cache_attr_s::size</a></div><div class="ttdeci">hwloc_uint64_t size</div><div class="ttdoc">Size of cache in bytes.</div><div class="ttdef"><b>Definition</b> hwloc.h:652</div></div>
+</div><!-- fragment --><p>hwloc provides a <code>pkg-config</code> executable to obtain relevant compiler and linker flags. See <a class="el" href="a00375.html">Compiling software on top of hwloc's C API</a> for details on building program on top of hwloc's API using GNU Make or CMake.</p>
+<p>On a machine 2 processor packages &ndash; each package of which has two processing cores &ndash; the output from running <code>hwloc-hello</code> could be something like the following:</p>
+<pre class="fragment">shell$ ./hwloc-hello
+*** Objects at level 0
+Index 0: Machine
+*** Objects at level 1
+Index 0: Package#0
+Index 1: Package#1
+*** Objects at level 2
+Index 0: Core#0
+Index 1: Core#1
+Index 2: Core#3
+Index 3: Core#2
+*** Objects at level 3
+Index 0: PU#0
+Index 1: PU#1
+Index 2: PU#2
+Index 3: PU#3
+*** Printing overall tree
+Machine
+  Package#0
+    Core#0
+      PU#0
+    Core#1
+      PU#1
+  Package#1
+    Core#3
+      PU#2
+    Core#2
+      PU#3
+*** 2 package(s)
+*** Logical processor 0 has 0 caches totaling 0KB
+shell$ 
+</pre><h1><a class="anchor" id="bugs"></a>
+Questions and Bugs</h1>
+<p>Bugs should be reported in the tracker (<a href="https://github.com/open-mpi/hwloc/issues">https://github.com/open-mpi/hwloc/issues</a>). Opening a new issue automatically displays lots of hints about how to debug and report issues.</p>
+<p>Questions may be sent to the users or developers mailing lists (<a href="https://www.open-mpi.org/community/lists/hwloc.php">https://www.open-mpi.org/community/lists/hwloc.php</a>).</p>
+<p>There is also a <code>#hwloc</code> IRC channel on Libera Chat (<code>irc.libera.chat</code>).</p>
+<h1><a class="anchor" id="history"></a>
+History / Credits</h1>
+<p>hwloc is the evolution and merger of the libtopology project and the Portable Linux Processor Affinity (PLPA) (<a href="https://www.open-mpi.org/projects/plpa/">https://www.open-mpi.org/projects/plpa/</a>) project. Because of functional and ideological overlap, these two code bases and ideas were merged and released under the name "hwloc" as an Open MPI sub-project.</p>
+<p>libtopology was initially developed by the Inria Runtime Team-Project. PLPA was initially developed by the Open MPI development team as a sub-project. Both are now deprecated in favor of hwloc, which is distributed as an Open MPI sub-project. </p>
+</div></div><!-- PageDoc -->
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/jquery.js 2.11.0-1/doc/doxygen-doc/html/jquery.js
--- 2.10.0-1/doc/doxygen-doc/html/jquery.js	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/jquery.js	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,34 @@
+/*! jQuery v3.6.0 | (c) OpenJS Foundation and other contributors | jquery.org/license */
+!function(e,t){"use strict";"object"==typeof module&&"object"==typeof module.exports?module.exports=e.document?t(e,!0):function(e){if(!e.document)throw new Error("jQuery requires a window with a document");return t(e)}:t(e)}("undefined"!=typeof window?window:this,function(C,e){"use strict";var t=[],r=Object.getPrototypeOf,s=t.slice,g=t.flat?function(e){return t.flat.call(e)}:function(e){return t.concat.apply([],e)},u=t.push,i=t.indexOf,n={},o=n.toString,v=n.hasOwnProperty,a=v.toString,l=a.call(Object),y={},m=function(e){return"function"==typeof e&&"number"!=typeof e.nodeType&&"function"!=typeof e.item},x=function(e){return null!=e&&e===e.window},E=C.document,c={type:!0,src:!0,nonce:!0,noModule:!0};function b(e,t,n){var r,i,o=(n=n||E).createElement("script");if(o.text=e,t)for(r in c)(i=t[r]||t.getAttribute&&t.getAttribute(r))&&o.setAttribute(r,i);n.head.appendChild(o).parentNode.removeChild(o)}function w(e){return null==e?e+"":"object"==typeof e||"function"==typeof e?n[o.call(e)]||"object":typeof e}var f="3.6.0",S=function(e,t){return new S.fn.init(e,t)};function p(e){var t=!!e&&"length"in e&&e.length,n=w(e);return!m(e)&&!x(e)&&("array"===n||0===t||"number"==typeof t&&0<t&&t-1 in e)}S.fn=S.prototype={jquery:f,constructor:S,length:0,toArray:function(){return s.call(this)},get:function(e){return null==e?s.call(this):e<0?this[e+this.length]:this[e]},pushStack:function(e){var t=S.merge(this.constructor(),e);return t.prevObject=this,t},each:function(e){return S.each(this,e)},map:function(n){return this.pushStack(S.map(this,function(e,t){return n.call(e,t,e)}))},slice:function(){return this.pushStack(s.apply(this,arguments))},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},even:function(){return this.pushStack(S.grep(this,function(e,t){return(t+1)%2}))},odd:function(){return this.pushStack(S.grep(this,function(e,t){return t%2}))},eq:function(e){var t=this.length,n=+e+(e<0?t:0);return this.pushStack(0<=n&&n<t?[this[n]]:[])},end:function(){return this.prevObject||this.constructor()},push:u,sort:t.sort,splice:t.splice},S.extend=S.fn.extend=function(){var e,t,n,r,i,o,a=arguments[0]||{},s=1,u=arguments.length,l=!1;for("boolean"==typeof a&&(l=a,a=arguments[s]||{},s++),"object"==typeof a||m(a)||(a={}),s===u&&(a=this,s--);s<u;s++)if(null!=(e=arguments[s]))for(t in e)r=e[t],"__proto__"!==t&&a!==r&&(l&&r&&(S.isPlainObject(r)||(i=Array.isArray(r)))?(n=a[t],o=i&&!Array.isArray(n)?[]:i||S.isPlainObject(n)?n:{},i=!1,a[t]=S.extend(l,o,r)):void 0!==r&&(a[t]=r));return a},S.extend({expando:"jQuery"+(f+Math.random()).replace(/\D/g,""),isReady:!0,error:function(e){throw new Error(e)},noop:function(){},isPlainObject:function(e){var t,n;return!(!e||"[object Object]"!==o.call(e))&&(!(t=r(e))||"function"==typeof(n=v.call(t,"constructor")&&t.constructor)&&a.call(n)===l)},isEmptyObject:function(e){var t;for(t in e)return!1;return!0},globalEval:function(e,t,n){b(e,{nonce:t&&t.nonce},n)},each:function(e,t){var n,r=0;if(p(e)){for(n=e.length;r<n;r++)if(!1===t.call(e[r],r,e[r]))break}else for(r in e)if(!1===t.call(e[r],r,e[r]))break;return e},makeArray:function(e,t){var n=t||[];return null!=e&&(p(Object(e))?S.merge(n,"string"==typeof e?[e]:e):u.call(n,e)),n},inArray:function(e,t,n){return null==t?-1:i.call(t,e,n)},merge:function(e,t){for(var n=+t.length,r=0,i=e.length;r<n;r++)e[i++]=t[r];return e.length=i,e},grep:function(e,t,n){for(var r=[],i=0,o=e.length,a=!n;i<o;i++)!t(e[i],i)!==a&&r.push(e[i]);return r},map:function(e,t,n){var r,i,o=0,a=[];if(p(e))for(r=e.length;o<r;o++)null!=(i=t(e[o],o,n))&&a.push(i);else for(o in e)null!=(i=t(e[o],o,n))&&a.push(i);return g(a)},guid:1,support:y}),"function"==typeof Symbol&&(S.fn[Symbol.iterator]=t[Symbol.iterator]),S.each("Boolean Number String Function Array Date RegExp Object Error Symbol".split(" "),function(e,t){n["[object "+t+"]"]=t.toLowerCase()});var d=function(n){var e,d,b,o,i,h,f,g,w,u,l,T,C,a,E,v,s,c,y,S="sizzle"+1*new Date,p=n.document,k=0,r=0,m=ue(),x=ue(),A=ue(),N=ue(),j=function(e,t){return e===t&&(l=!0),0},D={}.hasOwnProperty,t=[],q=t.pop,L=t.push,H=t.push,O=t.slice,P=function(e,t){for(var n=0,r=e.length;n<r;n++)if(e[n]===t)return n;return-1},R="checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped",M="[\\x20\\t\\r\\n\\f]",I="(?:\\\\[\\da-fA-F]{1,6}"+M+"?|\\\\[^\\r\\n\\f]|[\\w-]|[^\0-\\x7f])+",W="\\["+M+"*("+I+")(?:"+M+"*([*^$|!~]?=)"+M+"*(?:'((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\"|("+I+"))|)"+M+"*\\]",F=":("+I+")(?:\\((('((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\")|((?:\\\\.|[^\\\\()[\\]]|"+W+")*)|.*)\\)|)",B=new RegExp(M+"+","g"),$=new RegExp("^"+M+"+|((?:^|[^\\\\])(?:\\\\.)*)"+M+"+$","g"),_=new RegExp("^"+M+"*,"+M+"*"),z=new RegExp("^"+M+"*([>+~]|"+M+")"+M+"*"),U=new RegExp(M+"|>"),X=new RegExp(F),V=new RegExp("^"+I+"$"),G={ID:new RegExp("^#("+I+")"),CLASS:new RegExp("^\\.("+I+")"),TAG:new RegExp("^("+I+"|[*])"),ATTR:new RegExp("^"+W),PSEUDO:new RegExp("^"+F),CHILD:new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\("+M+"*(even|odd|(([+-]|)(\\d*)n|)"+M+"*(?:([+-]|)"+M+"*(\\d+)|))"+M+"*\\)|)","i"),bool:new RegExp("^(?:"+R+")$","i"),needsContext:new RegExp("^"+M+"*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\("+M+"*((?:-\\d)?\\d*)"+M+"*\\)|)(?=[^-]|$)","i")},Y=/HTML$/i,Q=/^(?:input|select|textarea|button)$/i,J=/^h\d$/i,K=/^[^{]+\{\s*\[native \w/,Z=/^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,ee=/[+~]/,te=new RegExp("\\\\[\\da-fA-F]{1,6}"+M+"?|\\\\([^\\r\\n\\f])","g"),ne=function(e,t){var n="0x"+e.slice(1)-65536;return t||(n<0?String.fromCharCode(n+65536):String.fromCharCode(n>>10|55296,1023&n|56320))},re=/([\0-\x1f\x7f]|^-?\d)|^-$|[^\0-\x1f\x7f-\uFFFF\w-]/g,ie=function(e,t){return t?"\0"===e?"\ufffd":e.slice(0,-1)+"\\"+e.charCodeAt(e.length-1).toString(16)+" ":"\\"+e},oe=function(){T()},ae=be(function(e){return!0===e.disabled&&"fieldset"===e.nodeName.toLowerCase()},{dir:"parentNode",next:"legend"});try{H.apply(t=O.call(p.childNodes),p.childNodes),t[p.childNodes.length].nodeType}catch(e){H={apply:t.length?function(e,t){L.apply(e,O.call(t))}:function(e,t){var n=e.length,r=0;while(e[n++]=t[r++]);e.length=n-1}}}function se(t,e,n,r){var i,o,a,s,u,l,c,f=e&&e.ownerDocument,p=e?e.nodeType:9;if(n=n||[],"string"!=typeof t||!t||1!==p&&9!==p&&11!==p)return n;if(!r&&(T(e),e=e||C,E)){if(11!==p&&(u=Z.exec(t)))if(i=u[1]){if(9===p){if(!(a=e.getElementById(i)))return n;if(a.id===i)return n.push(a),n}else if(f&&(a=f.getElementById(i))&&y(e,a)&&a.id===i)return n.push(a),n}else{if(u[2])return H.apply(n,e.getElementsByTagName(t)),n;if((i=u[3])&&d.getElementsByClassName&&e.getElementsByClassName)return H.apply(n,e.getElementsByClassName(i)),n}if(d.qsa&&!N[t+" "]&&(!v||!v.test(t))&&(1!==p||"object"!==e.nodeName.toLowerCase())){if(c=t,f=e,1===p&&(U.test(t)||z.test(t))){(f=ee.test(t)&&ye(e.parentNode)||e)===e&&d.scope||((s=e.getAttribute("id"))?s=s.replace(re,ie):e.setAttribute("id",s=S)),o=(l=h(t)).length;while(o--)l[o]=(s?"#"+s:":scope")+" "+xe(l[o]);c=l.join(",")}try{return H.apply(n,f.querySelectorAll(c)),n}catch(e){N(t,!0)}finally{s===S&&e.removeAttribute("id")}}}return g(t.replace($,"$1"),e,n,r)}function ue(){var r=[];return function e(t,n){return r.push(t+" ")>b.cacheLength&&delete e[r.shift()],e[t+" "]=n}}function le(e){return e[S]=!0,e}function ce(e){var t=C.createElement("fieldset");try{return!!e(t)}catch(e){return!1}finally{t.parentNode&&t.parentNode.removeChild(t),t=null}}function fe(e,t){var n=e.split("|"),r=n.length;while(r--)b.attrHandle[n[r]]=t}function pe(e,t){var n=t&&e,r=n&&1===e.nodeType&&1===t.nodeType&&e.sourceIndex-t.sourceIndex;if(r)return r;if(n)while(n=n.nextSibling)if(n===t)return-1;return e?1:-1}function de(t){return function(e){return"input"===e.nodeName.toLowerCase()&&e.type===t}}function he(n){return function(e){var t=e.nodeName.toLowerCase();return("input"===t||"button"===t)&&e.type===n}}function ge(t){return function(e){return"form"in e?e.parentNode&&!1===e.disabled?"label"in e?"label"in e.parentNode?e.parentNode.disabled===t:e.disabled===t:e.isDisabled===t||e.isDisabled!==!t&&ae(e)===t:e.disabled===t:"label"in e&&e.disabled===t}}function ve(a){return le(function(o){return o=+o,le(function(e,t){var n,r=a([],e.length,o),i=r.length;while(i--)e[n=r[i]]&&(e[n]=!(t[n]=e[n]))})})}function ye(e){return e&&"undefined"!=typeof e.getElementsByTagName&&e}for(e in d=se.support={},i=se.isXML=function(e){var t=e&&e.namespaceURI,n=e&&(e.ownerDocument||e).documentElement;return!Y.test(t||n&&n.nodeName||"HTML")},T=se.setDocument=function(e){var t,n,r=e?e.ownerDocument||e:p;return r!=C&&9===r.nodeType&&r.documentElement&&(a=(C=r).documentElement,E=!i(C),p!=C&&(n=C.defaultView)&&n.top!==n&&(n.addEventListener?n.addEventListener("unload",oe,!1):n.attachEvent&&n.attachEvent("onunload",oe)),d.scope=ce(function(e){return a.appendChild(e).appendChild(C.createElement("div")),"undefined"!=typeof e.querySelectorAll&&!e.querySelectorAll(":scope fieldset div").length}),d.attributes=ce(function(e){return e.className="i",!e.getAttribute("className")}),d.getElementsByTagName=ce(function(e){return e.appendChild(C.createComment("")),!e.getElementsByTagName("*").length}),d.getElementsByClassName=K.test(C.getElementsByClassName),d.getById=ce(function(e){return a.appendChild(e).id=S,!C.getElementsByName||!C.getElementsByName(S).length}),d.getById?(b.filter.ID=function(e){var t=e.replace(te,ne);return function(e){return e.getAttribute("id")===t}},b.find.ID=function(e,t){if("undefined"!=typeof t.getElementById&&E){var n=t.getElementById(e);return n?[n]:[]}}):(b.filter.ID=function(e){var n=e.replace(te,ne);return function(e){var t="undefined"!=typeof e.getAttributeNode&&e.getAttributeNode("id");return t&&t.value===n}},b.find.ID=function(e,t){if("undefined"!=typeof t.getElementById&&E){var n,r,i,o=t.getElementById(e);if(o){if((n=o.getAttributeNode("id"))&&n.value===e)return[o];i=t.getElementsByName(e),r=0;while(o=i[r++])if((n=o.getAttributeNode("id"))&&n.value===e)return[o]}return[]}}),b.find.TAG=d.getElementsByTagName?function(e,t){return"undefined"!=typeof t.getElementsByTagName?t.getElementsByTagName(e):d.qsa?t.querySelectorAll(e):void 0}:function(e,t){var n,r=[],i=0,o=t.getElementsByTagName(e);if("*"===e){while(n=o[i++])1===n.nodeType&&r.push(n);return r}return o},b.find.CLASS=d.getElementsByClassName&&function(e,t){if("undefined"!=typeof t.getElementsByClassName&&E)return t.getElementsByClassName(e)},s=[],v=[],(d.qsa=K.test(C.querySelectorAll))&&(ce(function(e){var t;a.appendChild(e).innerHTML="<a id='"+S+"'></a><select id='"+S+"-\r\\' msallowcapture=''><option selected=''></option></select>",e.querySelectorAll("[msallowcapture^='']").length&&v.push("[*^$]="+M+"*(?:''|\"\")"),e.querySelectorAll("[selected]").length||v.push("\\["+M+"*(?:value|"+R+")"),e.querySelectorAll("[id~="+S+"-]").length||v.push("~="),(t=C.createElement("input")).setAttribute("name",""),e.appendChild(t),e.querySelectorAll("[name='']").length||v.push("\\["+M+"*name"+M+"*="+M+"*(?:''|\"\")"),e.querySelectorAll(":checked").length||v.push(":checked"),e.querySelectorAll("a#"+S+"+*").length||v.push(".#.+[+~]"),e.querySelectorAll("\\\f"),v.push("[\\r\\n\\f]")}),ce(function(e){e.innerHTML="<a href='' disabled='disabled'></a><select disabled='disabled'><option/></select>";var t=C.createElement("input");t.setAttribute("type","hidden"),e.appendChild(t).setAttribute("name","D"),e.querySelectorAll("[name=d]").length&&v.push("name"+M+"*[*^$|!~]?="),2!==e.querySelectorAll(":enabled").length&&v.push(":enabled",":disabled"),a.appendChild(e).disabled=!0,2!==e.querySelectorAll(":disabled").length&&v.push(":enabled",":disabled"),e.querySelectorAll("*,:x"),v.push(",.*:")})),(d.matchesSelector=K.test(c=a.matches||a.webkitMatchesSelector||a.mozMatchesSelector||a.oMatchesSelector||a.msMatchesSelector))&&ce(function(e){d.disconnectedMatch=c.call(e,"*"),c.call(e,"[s!='']:x"),s.push("!=",F)}),v=v.length&&new RegExp(v.join("|")),s=s.length&&new RegExp(s.join("|")),t=K.test(a.compareDocumentPosition),y=t||K.test(a.contains)?function(e,t){var n=9===e.nodeType?e.documentElement:e,r=t&&t.parentNode;return e===r||!(!r||1!==r.nodeType||!(n.contains?n.contains(r):e.compareDocumentPosition&&16&e.compareDocumentPosition(r)))}:function(e,t){if(t)while(t=t.parentNode)if(t===e)return!0;return!1},j=t?function(e,t){if(e===t)return l=!0,0;var n=!e.compareDocumentPosition-!t.compareDocumentPosition;return n||(1&(n=(e.ownerDocument||e)==(t.ownerDocument||t)?e.compareDocumentPosition(t):1)||!d.sortDetached&&t.compareDocumentPosition(e)===n?e==C||e.ownerDocument==p&&y(p,e)?-1:t==C||t.ownerDocument==p&&y(p,t)?1:u?P(u,e)-P(u,t):0:4&n?-1:1)}:function(e,t){if(e===t)return l=!0,0;var n,r=0,i=e.parentNode,o=t.parentNode,a=[e],s=[t];if(!i||!o)return e==C?-1:t==C?1:i?-1:o?1:u?P(u,e)-P(u,t):0;if(i===o)return pe(e,t);n=e;while(n=n.parentNode)a.unshift(n);n=t;while(n=n.parentNode)s.unshift(n);while(a[r]===s[r])r++;return r?pe(a[r],s[r]):a[r]==p?-1:s[r]==p?1:0}),C},se.matches=function(e,t){return se(e,null,null,t)},se.matchesSelector=function(e,t){if(T(e),d.matchesSelector&&E&&!N[t+" "]&&(!s||!s.test(t))&&(!v||!v.test(t)))try{var n=c.call(e,t);if(n||d.disconnectedMatch||e.document&&11!==e.document.nodeType)return n}catch(e){N(t,!0)}return 0<se(t,C,null,[e]).length},se.contains=function(e,t){return(e.ownerDocument||e)!=C&&T(e),y(e,t)},se.attr=function(e,t){(e.ownerDocument||e)!=C&&T(e);var n=b.attrHandle[t.toLowerCase()],r=n&&D.call(b.attrHandle,t.toLowerCase())?n(e,t,!E):void 0;return void 0!==r?r:d.attributes||!E?e.getAttribute(t):(r=e.getAttributeNode(t))&&r.specified?r.value:null},se.escape=function(e){return(e+"").replace(re,ie)},se.error=function(e){throw new Error("Syntax error, unrecognized expression: "+e)},se.uniqueSort=function(e){var t,n=[],r=0,i=0;if(l=!d.detectDuplicates,u=!d.sortStable&&e.slice(0),e.sort(j),l){while(t=e[i++])t===e[i]&&(r=n.push(i));while(r--)e.splice(n[r],1)}return u=null,e},o=se.getText=function(e){var t,n="",r=0,i=e.nodeType;if(i){if(1===i||9===i||11===i){if("string"==typeof e.textContent)return e.textContent;for(e=e.firstChild;e;e=e.nextSibling)n+=o(e)}else if(3===i||4===i)return e.nodeValue}else while(t=e[r++])n+=o(t);return n},(b=se.selectors={cacheLength:50,createPseudo:le,match:G,attrHandle:{},find:{},relative:{">":{dir:"parentNode",first:!0}," ":{dir:"parentNode"},"+":{dir:"previousSibling",first:!0},"~":{dir:"previousSibling"}},preFilter:{ATTR:function(e){return e[1]=e[1].replace(te,ne),e[3]=(e[3]||e[4]||e[5]||"").replace(te,ne),"~="===e[2]&&(e[3]=" "+e[3]+" "),e.slice(0,4)},CHILD:function(e){return e[1]=e[1].toLowerCase(),"nth"===e[1].slice(0,3)?(e[3]||se.error(e[0]),e[4]=+(e[4]?e[5]+(e[6]||1):2*("even"===e[3]||"odd"===e[3])),e[5]=+(e[7]+e[8]||"odd"===e[3])):e[3]&&se.error(e[0]),e},PSEUDO:function(e){var t,n=!e[6]&&e[2];return G.CHILD.test(e[0])?null:(e[3]?e[2]=e[4]||e[5]||"":n&&X.test(n)&&(t=h(n,!0))&&(t=n.indexOf(")",n.length-t)-n.length)&&(e[0]=e[0].slice(0,t),e[2]=n.slice(0,t)),e.slice(0,3))}},filter:{TAG:function(e){var t=e.replace(te,ne).toLowerCase();return"*"===e?function(){return!0}:function(e){return e.nodeName&&e.nodeName.toLowerCase()===t}},CLASS:function(e){var t=m[e+" "];return t||(t=new RegExp("(^|"+M+")"+e+"("+M+"|$)"))&&m(e,function(e){return t.test("string"==typeof e.className&&e.className||"undefined"!=typeof e.getAttribute&&e.getAttribute("class")||"")})},ATTR:function(n,r,i){return function(e){var t=se.attr(e,n);return null==t?"!="===r:!r||(t+="","="===r?t===i:"!="===r?t!==i:"^="===r?i&&0===t.indexOf(i):"*="===r?i&&-1<t.indexOf(i):"$="===r?i&&t.slice(-i.length)===i:"~="===r?-1<(" "+t.replace(B," ")+" ").indexOf(i):"|="===r&&(t===i||t.slice(0,i.length+1)===i+"-"))}},CHILD:function(h,e,t,g,v){var y="nth"!==h.slice(0,3),m="last"!==h.slice(-4),x="of-type"===e;return 1===g&&0===v?function(e){return!!e.parentNode}:function(e,t,n){var r,i,o,a,s,u,l=y!==m?"nextSibling":"previousSibling",c=e.parentNode,f=x&&e.nodeName.toLowerCase(),p=!n&&!x,d=!1;if(c){if(y){while(l){a=e;while(a=a[l])if(x?a.nodeName.toLowerCase()===f:1===a.nodeType)return!1;u=l="only"===h&&!u&&"nextSibling"}return!0}if(u=[m?c.firstChild:c.lastChild],m&&p){d=(s=(r=(i=(o=(a=c)[S]||(a[S]={}))[a.uniqueID]||(o[a.uniqueID]={}))[h]||[])[0]===k&&r[1])&&r[2],a=s&&c.childNodes[s];while(a=++s&&a&&a[l]||(d=s=0)||u.pop())if(1===a.nodeType&&++d&&a===e){i[h]=[k,s,d];break}}else if(p&&(d=s=(r=(i=(o=(a=e)[S]||(a[S]={}))[a.uniqueID]||(o[a.uniqueID]={}))[h]||[])[0]===k&&r[1]),!1===d)while(a=++s&&a&&a[l]||(d=s=0)||u.pop())if((x?a.nodeName.toLowerCase()===f:1===a.nodeType)&&++d&&(p&&((i=(o=a[S]||(a[S]={}))[a.uniqueID]||(o[a.uniqueID]={}))[h]=[k,d]),a===e))break;return(d-=v)===g||d%g==0&&0<=d/g}}},PSEUDO:function(e,o){var t,a=b.pseudos[e]||b.setFilters[e.toLowerCase()]||se.error("unsupported pseudo: "+e);return a[S]?a(o):1<a.length?(t=[e,e,"",o],b.setFilters.hasOwnProperty(e.toLowerCase())?le(function(e,t){var n,r=a(e,o),i=r.length;while(i--)e[n=P(e,r[i])]=!(t[n]=r[i])}):function(e){return a(e,0,t)}):a}},pseudos:{not:le(function(e){var r=[],i=[],s=f(e.replace($,"$1"));return s[S]?le(function(e,t,n,r){var i,o=s(e,null,r,[]),a=e.length;while(a--)(i=o[a])&&(e[a]=!(t[a]=i))}):function(e,t,n){return r[0]=e,s(r,null,n,i),r[0]=null,!i.pop()}}),has:le(function(t){return function(e){return 0<se(t,e).length}}),contains:le(function(t){return t=t.replace(te,ne),function(e){return-1<(e.textContent||o(e)).indexOf(t)}}),lang:le(function(n){return V.test(n||"")||se.error("unsupported lang: "+n),n=n.replace(te,ne).toLowerCase(),function(e){var t;do{if(t=E?e.lang:e.getAttribute("xml:lang")||e.getAttribute("lang"))return(t=t.toLowerCase())===n||0===t.indexOf(n+"-")}while((e=e.parentNode)&&1===e.nodeType);return!1}}),target:function(e){var t=n.location&&n.location.hash;return t&&t.slice(1)===e.id},root:function(e){return e===a},focus:function(e){return e===C.activeElement&&(!C.hasFocus||C.hasFocus())&&!!(e.type||e.href||~e.tabIndex)},enabled:ge(!1),disabled:ge(!0),checked:function(e){var t=e.nodeName.toLowerCase();return"input"===t&&!!e.checked||"option"===t&&!!e.selected},selected:function(e){return e.parentNode&&e.parentNode.selectedIndex,!0===e.selected},empty:function(e){for(e=e.firstChild;e;e=e.nextSibling)if(e.nodeType<6)return!1;return!0},parent:function(e){return!b.pseudos.empty(e)},header:function(e){return J.test(e.nodeName)},input:function(e){return Q.test(e.nodeName)},button:function(e){var t=e.nodeName.toLowerCase();return"input"===t&&"button"===e.type||"button"===t},text:function(e){var t;return"input"===e.nodeName.toLowerCase()&&"text"===e.type&&(null==(t=e.getAttribute("type"))||"text"===t.toLowerCase())},first:ve(function(){return[0]}),last:ve(function(e,t){return[t-1]}),eq:ve(function(e,t,n){return[n<0?n+t:n]}),even:ve(function(e,t){for(var n=0;n<t;n+=2)e.push(n);return e}),odd:ve(function(e,t){for(var n=1;n<t;n+=2)e.push(n);return e}),lt:ve(function(e,t,n){for(var r=n<0?n+t:t<n?t:n;0<=--r;)e.push(r);return e}),gt:ve(function(e,t,n){for(var r=n<0?n+t:n;++r<t;)e.push(r);return e})}}).pseudos.nth=b.pseudos.eq,{radio:!0,checkbox:!0,file:!0,password:!0,image:!0})b.pseudos[e]=de(e);for(e in{submit:!0,reset:!0})b.pseudos[e]=he(e);function me(){}function xe(e){for(var t=0,n=e.length,r="";t<n;t++)r+=e[t].value;return r}function be(s,e,t){var u=e.dir,l=e.next,c=l||u,f=t&&"parentNode"===c,p=r++;return e.first?function(e,t,n){while(e=e[u])if(1===e.nodeType||f)return s(e,t,n);return!1}:function(e,t,n){var r,i,o,a=[k,p];if(n){while(e=e[u])if((1===e.nodeType||f)&&s(e,t,n))return!0}else while(e=e[u])if(1===e.nodeType||f)if(i=(o=e[S]||(e[S]={}))[e.uniqueID]||(o[e.uniqueID]={}),l&&l===e.nodeName.toLowerCase())e=e[u]||e;else{if((r=i[c])&&r[0]===k&&r[1]===p)return a[2]=r[2];if((i[c]=a)[2]=s(e,t,n))return!0}return!1}}function we(i){return 1<i.length?function(e,t,n){var r=i.length;while(r--)if(!i[r](e,t,n))return!1;return!0}:i[0]}function Te(e,t,n,r,i){for(var o,a=[],s=0,u=e.length,l=null!=t;s<u;s++)(o=e[s])&&(n&&!n(o,r,i)||(a.push(o),l&&t.push(s)));return a}function Ce(d,h,g,v,y,e){return v&&!v[S]&&(v=Ce(v)),y&&!y[S]&&(y=Ce(y,e)),le(function(e,t,n,r){var i,o,a,s=[],u=[],l=t.length,c=e||function(e,t,n){for(var r=0,i=t.length;r<i;r++)se(e,t[r],n);return n}(h||"*",n.nodeType?[n]:n,[]),f=!d||!e&&h?c:Te(c,s,d,n,r),p=g?y||(e?d:l||v)?[]:t:f;if(g&&g(f,p,n,r),v){i=Te(p,u),v(i,[],n,r),o=i.length;while(o--)(a=i[o])&&(p[u[o]]=!(f[u[o]]=a))}if(e){if(y||d){if(y){i=[],o=p.length;while(o--)(a=p[o])&&i.push(f[o]=a);y(null,p=[],i,r)}o=p.length;while(o--)(a=p[o])&&-1<(i=y?P(e,a):s[o])&&(e[i]=!(t[i]=a))}}else p=Te(p===t?p.splice(l,p.length):p),y?y(null,t,p,r):H.apply(t,p)})}function Ee(e){for(var i,t,n,r=e.length,o=b.relative[e[0].type],a=o||b.relative[" "],s=o?1:0,u=be(function(e){return e===i},a,!0),l=be(function(e){return-1<P(i,e)},a,!0),c=[function(e,t,n){var r=!o&&(n||t!==w)||((i=t).nodeType?u(e,t,n):l(e,t,n));return i=null,r}];s<r;s++)if(t=b.relative[e[s].type])c=[be(we(c),t)];else{if((t=b.filter[e[s].type].apply(null,e[s].matches))[S]){for(n=++s;n<r;n++)if(b.relative[e[n].type])break;return Ce(1<s&&we(c),1<s&&xe(e.slice(0,s-1).concat({value:" "===e[s-2].type?"*":""})).replace($,"$1"),t,s<n&&Ee(e.slice(s,n)),n<r&&Ee(e=e.slice(n)),n<r&&xe(e))}c.push(t)}return we(c)}return me.prototype=b.filters=b.pseudos,b.setFilters=new me,h=se.tokenize=function(e,t){var n,r,i,o,a,s,u,l=x[e+" "];if(l)return t?0:l.slice(0);a=e,s=[],u=b.preFilter;while(a){for(o in n&&!(r=_.exec(a))||(r&&(a=a.slice(r[0].length)||a),s.push(i=[])),n=!1,(r=z.exec(a))&&(n=r.shift(),i.push({value:n,type:r[0].replace($," ")}),a=a.slice(n.length)),b.filter)!(r=G[o].exec(a))||u[o]&&!(r=u[o](r))||(n=r.shift(),i.push({value:n,type:o,matches:r}),a=a.slice(n.length));if(!n)break}return t?a.length:a?se.error(e):x(e,s).slice(0)},f=se.compile=function(e,t){var n,v,y,m,x,r,i=[],o=[],a=A[e+" "];if(!a){t||(t=h(e)),n=t.length;while(n--)(a=Ee(t[n]))[S]?i.push(a):o.push(a);(a=A(e,(v=o,m=0<(y=i).length,x=0<v.length,r=function(e,t,n,r,i){var o,a,s,u=0,l="0",c=e&&[],f=[],p=w,d=e||x&&b.find.TAG("*",i),h=k+=null==p?1:Math.random()||.1,g=d.length;for(i&&(w=t==C||t||i);l!==g&&null!=(o=d[l]);l++){if(x&&o){a=0,t||o.ownerDocument==C||(T(o),n=!E);while(s=v[a++])if(s(o,t||C,n)){r.push(o);break}i&&(k=h)}m&&((o=!s&&o)&&u--,e&&c.push(o))}if(u+=l,m&&l!==u){a=0;while(s=y[a++])s(c,f,t,n);if(e){if(0<u)while(l--)c[l]||f[l]||(f[l]=q.call(r));f=Te(f)}H.apply(r,f),i&&!e&&0<f.length&&1<u+y.length&&se.uniqueSort(r)}return i&&(k=h,w=p),c},m?le(r):r))).selector=e}return a},g=se.select=function(e,t,n,r){var i,o,a,s,u,l="function"==typeof e&&e,c=!r&&h(e=l.selector||e);if(n=n||[],1===c.length){if(2<(o=c[0]=c[0].slice(0)).length&&"ID"===(a=o[0]).type&&9===t.nodeType&&E&&b.relative[o[1].type]){if(!(t=(b.find.ID(a.matches[0].replace(te,ne),t)||[])[0]))return n;l&&(t=t.parentNode),e=e.slice(o.shift().value.length)}i=G.needsContext.test(e)?0:o.length;while(i--){if(a=o[i],b.relative[s=a.type])break;if((u=b.find[s])&&(r=u(a.matches[0].replace(te,ne),ee.test(o[0].type)&&ye(t.parentNode)||t))){if(o.splice(i,1),!(e=r.length&&xe(o)))return H.apply(n,r),n;break}}}return(l||f(e,c))(r,t,!E,n,!t||ee.test(e)&&ye(t.parentNode)||t),n},d.sortStable=S.split("").sort(j).join("")===S,d.detectDuplicates=!!l,T(),d.sortDetached=ce(function(e){return 1&e.compareDocumentPosition(C.createElement("fieldset"))}),ce(function(e){return e.innerHTML="<a href='#'></a>","#"===e.firstChild.getAttribute("href")})||fe("type|href|height|width",function(e,t,n){if(!n)return e.getAttribute(t,"type"===t.toLowerCase()?1:2)}),d.attributes&&ce(function(e){return e.innerHTML="<input/>",e.firstChild.setAttribute("value",""),""===e.firstChild.getAttribute("value")})||fe("value",function(e,t,n){if(!n&&"input"===e.nodeName.toLowerCase())return e.defaultValue}),ce(function(e){return null==e.getAttribute("disabled")})||fe(R,function(e,t,n){var r;if(!n)return!0===e[t]?t.toLowerCase():(r=e.getAttributeNode(t))&&r.specified?r.value:null}),se}(C);S.find=d,S.expr=d.selectors,S.expr[":"]=S.expr.pseudos,S.uniqueSort=S.unique=d.uniqueSort,S.text=d.getText,S.isXMLDoc=d.isXML,S.contains=d.contains,S.escapeSelector=d.escape;var h=function(e,t,n){var r=[],i=void 0!==n;while((e=e[t])&&9!==e.nodeType)if(1===e.nodeType){if(i&&S(e).is(n))break;r.push(e)}return r},T=function(e,t){for(var n=[];e;e=e.nextSibling)1===e.nodeType&&e!==t&&n.push(e);return n},k=S.expr.match.needsContext;function A(e,t){return e.nodeName&&e.nodeName.toLowerCase()===t.toLowerCase()}var N=/^<([a-z][^\/\0>:\x20\t\r\n\f]*)[\x20\t\r\n\f]*\/?>(?:<\/\1>|)$/i;function j(e,n,r){return m(n)?S.grep(e,function(e,t){return!!n.call(e,t,e)!==r}):n.nodeType?S.grep(e,function(e){return e===n!==r}):"string"!=typeof n?S.grep(e,function(e){return-1<i.call(n,e)!==r}):S.filter(n,e,r)}S.filter=function(e,t,n){var r=t[0];return n&&(e=":not("+e+")"),1===t.length&&1===r.nodeType?S.find.matchesSelector(r,e)?[r]:[]:S.find.matches(e,S.grep(t,function(e){return 1===e.nodeType}))},S.fn.extend({find:function(e){var t,n,r=this.length,i=this;if("string"!=typeof e)return this.pushStack(S(e).filter(function(){for(t=0;t<r;t++)if(S.contains(i[t],this))return!0}));for(n=this.pushStack([]),t=0;t<r;t++)S.find(e,i[t],n);return 1<r?S.uniqueSort(n):n},filter:function(e){return this.pushStack(j(this,e||[],!1))},not:function(e){return this.pushStack(j(this,e||[],!0))},is:function(e){return!!j(this,"string"==typeof e&&k.test(e)?S(e):e||[],!1).length}});var D,q=/^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]+))$/;(S.fn.init=function(e,t,n){var r,i;if(!e)return this;if(n=n||D,"string"==typeof e){if(!(r="<"===e[0]&&">"===e[e.length-1]&&3<=e.length?[null,e,null]:q.exec(e))||!r[1]&&t)return!t||t.jquery?(t||n).find(e):this.constructor(t).find(e);if(r[1]){if(t=t instanceof S?t[0]:t,S.merge(this,S.parseHTML(r[1],t&&t.nodeType?t.ownerDocument||t:E,!0)),N.test(r[1])&&S.isPlainObject(t))for(r in t)m(this[r])?this[r](t[r]):this.attr(r,t[r]);return this}return(i=E.getElementById(r[2]))&&(this[0]=i,this.length=1),this}return e.nodeType?(this[0]=e,this.length=1,this):m(e)?void 0!==n.ready?n.ready(e):e(S):S.makeArray(e,this)}).prototype=S.fn,D=S(E);var L=/^(?:parents|prev(?:Until|All))/,H={children:!0,contents:!0,next:!0,prev:!0};function O(e,t){while((e=e[t])&&1!==e.nodeType);return e}S.fn.extend({has:function(e){var t=S(e,this),n=t.length;return this.filter(function(){for(var e=0;e<n;e++)if(S.contains(this,t[e]))return!0})},closest:function(e,t){var n,r=0,i=this.length,o=[],a="string"!=typeof e&&S(e);if(!k.test(e))for(;r<i;r++)for(n=this[r];n&&n!==t;n=n.parentNode)if(n.nodeType<11&&(a?-1<a.index(n):1===n.nodeType&&S.find.matchesSelector(n,e))){o.push(n);break}return this.pushStack(1<o.length?S.uniqueSort(o):o)},index:function(e){return e?"string"==typeof e?i.call(S(e),this[0]):i.call(this,e.jquery?e[0]:e):this[0]&&this[0].parentNode?this.first().prevAll().length:-1},add:function(e,t){return this.pushStack(S.uniqueSort(S.merge(this.get(),S(e,t))))},addBack:function(e){return this.add(null==e?this.prevObject:this.prevObject.filter(e))}}),S.each({parent:function(e){var t=e.parentNode;return t&&11!==t.nodeType?t:null},parents:function(e){return h(e,"parentNode")},parentsUntil:function(e,t,n){return h(e,"parentNode",n)},next:function(e){return O(e,"nextSibling")},prev:function(e){return O(e,"previousSibling")},nextAll:function(e){return h(e,"nextSibling")},prevAll:function(e){return h(e,"previousSibling")},nextUntil:function(e,t,n){return h(e,"nextSibling",n)},prevUntil:function(e,t,n){return h(e,"previousSibling",n)},siblings:function(e){return T((e.parentNode||{}).firstChild,e)},children:function(e){return T(e.firstChild)},contents:function(e){return null!=e.contentDocument&&r(e.contentDocument)?e.contentDocument:(A(e,"template")&&(e=e.content||e),S.merge([],e.childNodes))}},function(r,i){S.fn[r]=function(e,t){var n=S.map(this,i,e);return"Until"!==r.slice(-5)&&(t=e),t&&"string"==typeof t&&(n=S.filter(t,n)),1<this.length&&(H[r]||S.uniqueSort(n),L.test(r)&&n.reverse()),this.pushStack(n)}});var P=/[^\x20\t\r\n\f]+/g;function R(e){return e}function M(e){throw e}function I(e,t,n,r){var i;try{e&&m(i=e.promise)?i.call(e).done(t).fail(n):e&&m(i=e.then)?i.call(e,t,n):t.apply(void 0,[e].slice(r))}catch(e){n.apply(void 0,[e])}}S.Callbacks=function(r){var e,n;r="string"==typeof r?(e=r,n={},S.each(e.match(P)||[],function(e,t){n[t]=!0}),n):S.extend({},r);var i,t,o,a,s=[],u=[],l=-1,c=function(){for(a=a||r.once,o=i=!0;u.length;l=-1){t=u.shift();while(++l<s.length)!1===s[l].apply(t[0],t[1])&&r.stopOnFalse&&(l=s.length,t=!1)}r.memory||(t=!1),i=!1,a&&(s=t?[]:"")},f={add:function(){return s&&(t&&!i&&(l=s.length-1,u.push(t)),function n(e){S.each(e,function(e,t){m(t)?r.unique&&f.has(t)||s.push(t):t&&t.length&&"string"!==w(t)&&n(t)})}(arguments),t&&!i&&c()),this},remove:function(){return S.each(arguments,function(e,t){var n;while(-1<(n=S.inArray(t,s,n)))s.splice(n,1),n<=l&&l--}),this},has:function(e){return e?-1<S.inArray(e,s):0<s.length},empty:function(){return s&&(s=[]),this},disable:function(){return a=u=[],s=t="",this},disabled:function(){return!s},lock:function(){return a=u=[],t||i||(s=t=""),this},locked:function(){return!!a},fireWith:function(e,t){return a||(t=[e,(t=t||[]).slice?t.slice():t],u.push(t),i||c()),this},fire:function(){return f.fireWith(this,arguments),this},fired:function(){return!!o}};return f},S.extend({Deferred:function(e){var o=[["notify","progress",S.Callbacks("memory"),S.Callbacks("memory"),2],["resolve","done",S.Callbacks("once memory"),S.Callbacks("once memory"),0,"resolved"],["reject","fail",S.Callbacks("once memory"),S.Callbacks("once memory"),1,"rejected"]],i="pending",a={state:function(){return i},always:function(){return s.done(arguments).fail(arguments),this},"catch":function(e){return a.then(null,e)},pipe:function(){var i=arguments;return S.Deferred(function(r){S.each(o,function(e,t){var n=m(i[t[4]])&&i[t[4]];s[t[1]](function(){var e=n&&n.apply(this,arguments);e&&m(e.promise)?e.promise().progress(r.notify).done(r.resolve).fail(r.reject):r[t[0]+"With"](this,n?[e]:arguments)})}),i=null}).promise()},then:function(t,n,r){var u=0;function l(i,o,a,s){return function(){var n=this,r=arguments,e=function(){var e,t;if(!(i<u)){if((e=a.apply(n,r))===o.promise())throw new TypeError("Thenable self-resolution");t=e&&("object"==typeof e||"function"==typeof e)&&e.then,m(t)?s?t.call(e,l(u,o,R,s),l(u,o,M,s)):(u++,t.call(e,l(u,o,R,s),l(u,o,M,s),l(u,o,R,o.notifyWith))):(a!==R&&(n=void 0,r=[e]),(s||o.resolveWith)(n,r))}},t=s?e:function(){try{e()}catch(e){S.Deferred.exceptionHook&&S.Deferred.exceptionHook(e,t.stackTrace),u<=i+1&&(a!==M&&(n=void 0,r=[e]),o.rejectWith(n,r))}};i?t():(S.Deferred.getStackHook&&(t.stackTrace=S.Deferred.getStackHook()),C.setTimeout(t))}}return S.Deferred(function(e){o[0][3].add(l(0,e,m(r)?r:R,e.notifyWith)),o[1][3].add(l(0,e,m(t)?t:R)),o[2][3].add(l(0,e,m(n)?n:M))}).promise()},promise:function(e){return null!=e?S.extend(e,a):a}},s={};return S.each(o,function(e,t){var n=t[2],r=t[5];a[t[1]]=n.add,r&&n.add(function(){i=r},o[3-e][2].disable,o[3-e][3].disable,o[0][2].lock,o[0][3].lock),n.add(t[3].fire),s[t[0]]=function(){return s[t[0]+"With"](this===s?void 0:this,arguments),this},s[t[0]+"With"]=n.fireWith}),a.promise(s),e&&e.call(s,s),s},when:function(e){var n=arguments.length,t=n,r=Array(t),i=s.call(arguments),o=S.Deferred(),a=function(t){return function(e){r[t]=this,i[t]=1<arguments.length?s.call(arguments):e,--n||o.resolveWith(r,i)}};if(n<=1&&(I(e,o.done(a(t)).resolve,o.reject,!n),"pending"===o.state()||m(i[t]&&i[t].then)))return o.then();while(t--)I(i[t],a(t),o.reject);return o.promise()}});var W=/^(Eval|Internal|Range|Reference|Syntax|Type|URI)Error$/;S.Deferred.exceptionHook=function(e,t){C.console&&C.console.warn&&e&&W.test(e.name)&&C.console.warn("jQuery.Deferred exception: "+e.message,e.stack,t)},S.readyException=function(e){C.setTimeout(function(){throw e})};var F=S.Deferred();function B(){E.removeEventListener("DOMContentLoaded",B),C.removeEventListener("load",B),S.ready()}S.fn.ready=function(e){return F.then(e)["catch"](function(e){S.readyException(e)}),this},S.extend({isReady:!1,readyWait:1,ready:function(e){(!0===e?--S.readyWait:S.isReady)||(S.isReady=!0)!==e&&0<--S.readyWait||F.resolveWith(E,[S])}}),S.ready.then=F.then,"complete"===E.readyState||"loading"!==E.readyState&&!E.documentElement.doScroll?C.setTimeout(S.ready):(E.addEventListener("DOMContentLoaded",B),C.addEventListener("load",B));var $=function(e,t,n,r,i,o,a){var s=0,u=e.length,l=null==n;if("object"===w(n))for(s in i=!0,n)$(e,t,s,n[s],!0,o,a);else if(void 0!==r&&(i=!0,m(r)||(a=!0),l&&(a?(t.call(e,r),t=null):(l=t,t=function(e,t,n){return l.call(S(e),n)})),t))for(;s<u;s++)t(e[s],n,a?r:r.call(e[s],s,t(e[s],n)));return i?e:l?t.call(e):u?t(e[0],n):o},_=/^-ms-/,z=/-([a-z])/g;function U(e,t){return t.toUpperCase()}function X(e){return e.replace(_,"ms-").replace(z,U)}var V=function(e){return 1===e.nodeType||9===e.nodeType||!+e.nodeType};function G(){this.expando=S.expando+G.uid++}G.uid=1,G.prototype={cache:function(e){var t=e[this.expando];return t||(t={},V(e)&&(e.nodeType?e[this.expando]=t:Object.defineProperty(e,this.expando,{value:t,configurable:!0}))),t},set:function(e,t,n){var r,i=this.cache(e);if("string"==typeof t)i[X(t)]=n;else for(r in t)i[X(r)]=t[r];return i},get:function(e,t){return void 0===t?this.cache(e):e[this.expando]&&e[this.expando][X(t)]},access:function(e,t,n){return void 0===t||t&&"string"==typeof t&&void 0===n?this.get(e,t):(this.set(e,t,n),void 0!==n?n:t)},remove:function(e,t){var n,r=e[this.expando];if(void 0!==r){if(void 0!==t){n=(t=Array.isArray(t)?t.map(X):(t=X(t))in r?[t]:t.match(P)||[]).length;while(n--)delete r[t[n]]}(void 0===t||S.isEmptyObject(r))&&(e.nodeType?e[this.expando]=void 0:delete e[this.expando])}},hasData:function(e){var t=e[this.expando];return void 0!==t&&!S.isEmptyObject(t)}};var Y=new G,Q=new G,J=/^(?:\{[\w\W]*\}|\[[\w\W]*\])$/,K=/[A-Z]/g;function Z(e,t,n){var r,i;if(void 0===n&&1===e.nodeType)if(r="data-"+t.replace(K,"-$&").toLowerCase(),"string"==typeof(n=e.getAttribute(r))){try{n="true"===(i=n)||"false"!==i&&("null"===i?null:i===+i+""?+i:J.test(i)?JSON.parse(i):i)}catch(e){}Q.set(e,t,n)}else n=void 0;return n}S.extend({hasData:function(e){return Q.hasData(e)||Y.hasData(e)},data:function(e,t,n){return Q.access(e,t,n)},removeData:function(e,t){Q.remove(e,t)},_data:function(e,t,n){return Y.access(e,t,n)},_removeData:function(e,t){Y.remove(e,t)}}),S.fn.extend({data:function(n,e){var t,r,i,o=this[0],a=o&&o.attributes;if(void 0===n){if(this.length&&(i=Q.get(o),1===o.nodeType&&!Y.get(o,"hasDataAttrs"))){t=a.length;while(t--)a[t]&&0===(r=a[t].name).indexOf("data-")&&(r=X(r.slice(5)),Z(o,r,i[r]));Y.set(o,"hasDataAttrs",!0)}return i}return"object"==typeof n?this.each(function(){Q.set(this,n)}):$(this,function(e){var t;if(o&&void 0===e)return void 0!==(t=Q.get(o,n))?t:void 0!==(t=Z(o,n))?t:void 0;this.each(function(){Q.set(this,n,e)})},null,e,1<arguments.length,null,!0)},removeData:function(e){return this.each(function(){Q.remove(this,e)})}}),S.extend({queue:function(e,t,n){var r;if(e)return t=(t||"fx")+"queue",r=Y.get(e,t),n&&(!r||Array.isArray(n)?r=Y.access(e,t,S.makeArray(n)):r.push(n)),r||[]},dequeue:function(e,t){t=t||"fx";var n=S.queue(e,t),r=n.length,i=n.shift(),o=S._queueHooks(e,t);"inprogress"===i&&(i=n.shift(),r--),i&&("fx"===t&&n.unshift("inprogress"),delete o.stop,i.call(e,function(){S.dequeue(e,t)},o)),!r&&o&&o.empty.fire()},_queueHooks:function(e,t){var n=t+"queueHooks";return Y.get(e,n)||Y.access(e,n,{empty:S.Callbacks("once memory").add(function(){Y.remove(e,[t+"queue",n])})})}}),S.fn.extend({queue:function(t,n){var e=2;return"string"!=typeof t&&(n=t,t="fx",e--),arguments.length<e?S.queue(this[0],t):void 0===n?this:this.each(function(){var e=S.queue(this,t,n);S._queueHooks(this,t),"fx"===t&&"inprogress"!==e[0]&&S.dequeue(this,t)})},dequeue:function(e){return this.each(function(){S.dequeue(this,e)})},clearQueue:function(e){return this.queue(e||"fx",[])},promise:function(e,t){var n,r=1,i=S.Deferred(),o=this,a=this.length,s=function(){--r||i.resolveWith(o,[o])};"string"!=typeof e&&(t=e,e=void 0),e=e||"fx";while(a--)(n=Y.get(o[a],e+"queueHooks"))&&n.empty&&(r++,n.empty.add(s));return s(),i.promise(t)}});var ee=/[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source,te=new RegExp("^(?:([+-])=|)("+ee+")([a-z%]*)$","i"),ne=["Top","Right","Bottom","Left"],re=E.documentElement,ie=function(e){return S.contains(e.ownerDocument,e)},oe={composed:!0};re.getRootNode&&(ie=function(e){return S.contains(e.ownerDocument,e)||e.getRootNode(oe)===e.ownerDocument});var ae=function(e,t){return"none"===(e=t||e).style.display||""===e.style.display&&ie(e)&&"none"===S.css(e,"display")};function se(e,t,n,r){var i,o,a=20,s=r?function(){return r.cur()}:function(){return S.css(e,t,"")},u=s(),l=n&&n[3]||(S.cssNumber[t]?"":"px"),c=e.nodeType&&(S.cssNumber[t]||"px"!==l&&+u)&&te.exec(S.css(e,t));if(c&&c[3]!==l){u/=2,l=l||c[3],c=+u||1;while(a--)S.style(e,t,c+l),(1-o)*(1-(o=s()/u||.5))<=0&&(a=0),c/=o;c*=2,S.style(e,t,c+l),n=n||[]}return n&&(c=+c||+u||0,i=n[1]?c+(n[1]+1)*n[2]:+n[2],r&&(r.unit=l,r.start=c,r.end=i)),i}var ue={};function le(e,t){for(var n,r,i,o,a,s,u,l=[],c=0,f=e.length;c<f;c++)(r=e[c]).style&&(n=r.style.display,t?("none"===n&&(l[c]=Y.get(r,"display")||null,l[c]||(r.style.display="")),""===r.style.display&&ae(r)&&(l[c]=(u=a=o=void 0,a=(i=r).ownerDocument,s=i.nodeName,(u=ue[s])||(o=a.body.appendChild(a.createElement(s)),u=S.css(o,"display"),o.parentNode.removeChild(o),"none"===u&&(u="block"),ue[s]=u)))):"none"!==n&&(l[c]="none",Y.set(r,"display",n)));for(c=0;c<f;c++)null!=l[c]&&(e[c].style.display=l[c]);return e}S.fn.extend({show:function(){return le(this,!0)},hide:function(){return le(this)},toggle:function(e){return"boolean"==typeof e?e?this.show():this.hide():this.each(function(){ae(this)?S(this).show():S(this).hide()})}});var ce,fe,pe=/^(?:checkbox|radio)$/i,de=/<([a-z][^\/\0>\x20\t\r\n\f]*)/i,he=/^$|^module$|\/(?:java|ecma)script/i;ce=E.createDocumentFragment().appendChild(E.createElement("div")),(fe=E.createElement("input")).setAttribute("type","radio"),fe.setAttribute("checked","checked"),fe.setAttribute("name","t"),ce.appendChild(fe),y.checkClone=ce.cloneNode(!0).cloneNode(!0).lastChild.checked,ce.innerHTML="<textarea>x</textarea>",y.noCloneChecked=!!ce.cloneNode(!0).lastChild.defaultValue,ce.innerHTML="<option></option>",y.option=!!ce.lastChild;var ge={thead:[1,"<table>","</table>"],col:[2,"<table><colgroup>","</colgroup></table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],_default:[0,"",""]};function ve(e,t){var n;return n="undefined"!=typeof e.getElementsByTagName?e.getElementsByTagName(t||"*"):"undefined"!=typeof e.querySelectorAll?e.querySelectorAll(t||"*"):[],void 0===t||t&&A(e,t)?S.merge([e],n):n}function ye(e,t){for(var n=0,r=e.length;n<r;n++)Y.set(e[n],"globalEval",!t||Y.get(t[n],"globalEval"))}ge.tbody=ge.tfoot=ge.colgroup=ge.caption=ge.thead,ge.th=ge.td,y.option||(ge.optgroup=ge.option=[1,"<select multiple='multiple'>","</select>"]);var me=/<|&#?\w+;/;function xe(e,t,n,r,i){for(var o,a,s,u,l,c,f=t.createDocumentFragment(),p=[],d=0,h=e.length;d<h;d++)if((o=e[d])||0===o)if("object"===w(o))S.merge(p,o.nodeType?[o]:o);else if(me.test(o)){a=a||f.appendChild(t.createElement("div")),s=(de.exec(o)||["",""])[1].toLowerCase(),u=ge[s]||ge._default,a.innerHTML=u[1]+S.htmlPrefilter(o)+u[2],c=u[0];while(c--)a=a.lastChild;S.merge(p,a.childNodes),(a=f.firstChild).textContent=""}else p.push(t.createTextNode(o));f.textContent="",d=0;while(o=p[d++])if(r&&-1<S.inArray(o,r))i&&i.push(o);else if(l=ie(o),a=ve(f.appendChild(o),"script"),l&&ye(a),n){c=0;while(o=a[c++])he.test(o.type||"")&&n.push(o)}return f}var be=/^([^.]*)(?:\.(.+)|)/;function we(){return!0}function Te(){return!1}function Ce(e,t){return e===function(){try{return E.activeElement}catch(e){}}()==("focus"===t)}function Ee(e,t,n,r,i,o){var a,s;if("object"==typeof t){for(s in"string"!=typeof n&&(r=r||n,n=void 0),t)Ee(e,s,n,r,t[s],o);return e}if(null==r&&null==i?(i=n,r=n=void 0):null==i&&("string"==typeof n?(i=r,r=void 0):(i=r,r=n,n=void 0)),!1===i)i=Te;else if(!i)return e;return 1===o&&(a=i,(i=function(e){return S().off(e),a.apply(this,arguments)}).guid=a.guid||(a.guid=S.guid++)),e.each(function(){S.event.add(this,t,i,r,n)})}function Se(e,i,o){o?(Y.set(e,i,!1),S.event.add(e,i,{namespace:!1,handler:function(e){var t,n,r=Y.get(this,i);if(1&e.isTrigger&&this[i]){if(r.length)(S.event.special[i]||{}).delegateType&&e.stopPropagation();else if(r=s.call(arguments),Y.set(this,i,r),t=o(this,i),this[i](),r!==(n=Y.get(this,i))||t?Y.set(this,i,!1):n={},r!==n)return e.stopImmediatePropagation(),e.preventDefault(),n&&n.value}else r.length&&(Y.set(this,i,{value:S.event.trigger(S.extend(r[0],S.Event.prototype),r.slice(1),this)}),e.stopImmediatePropagation())}})):void 0===Y.get(e,i)&&S.event.add(e,i,we)}S.event={global:{},add:function(t,e,n,r,i){var o,a,s,u,l,c,f,p,d,h,g,v=Y.get(t);if(V(t)){n.handler&&(n=(o=n).handler,i=o.selector),i&&S.find.matchesSelector(re,i),n.guid||(n.guid=S.guid++),(u=v.events)||(u=v.events=Object.create(null)),(a=v.handle)||(a=v.handle=function(e){return"undefined"!=typeof S&&S.event.triggered!==e.type?S.event.dispatch.apply(t,arguments):void 0}),l=(e=(e||"").match(P)||[""]).length;while(l--)d=g=(s=be.exec(e[l])||[])[1],h=(s[2]||"").split(".").sort(),d&&(f=S.event.special[d]||{},d=(i?f.delegateType:f.bindType)||d,f=S.event.special[d]||{},c=S.extend({type:d,origType:g,data:r,handler:n,guid:n.guid,selector:i,needsContext:i&&S.expr.match.needsContext.test(i),namespace:h.join(".")},o),(p=u[d])||((p=u[d]=[]).delegateCount=0,f.setup&&!1!==f.setup.call(t,r,h,a)||t.addEventListener&&t.addEventListener(d,a)),f.add&&(f.add.call(t,c),c.handler.guid||(c.handler.guid=n.guid)),i?p.splice(p.delegateCount++,0,c):p.push(c),S.event.global[d]=!0)}},remove:function(e,t,n,r,i){var o,a,s,u,l,c,f,p,d,h,g,v=Y.hasData(e)&&Y.get(e);if(v&&(u=v.events)){l=(t=(t||"").match(P)||[""]).length;while(l--)if(d=g=(s=be.exec(t[l])||[])[1],h=(s[2]||"").split(".").sort(),d){f=S.event.special[d]||{},p=u[d=(r?f.delegateType:f.bindType)||d]||[],s=s[2]&&new RegExp("(^|\\.)"+h.join("\\.(?:.*\\.|)")+"(\\.|$)"),a=o=p.length;while(o--)c=p[o],!i&&g!==c.origType||n&&n.guid!==c.guid||s&&!s.test(c.namespace)||r&&r!==c.selector&&("**"!==r||!c.selector)||(p.splice(o,1),c.selector&&p.delegateCount--,f.remove&&f.remove.call(e,c));a&&!p.length&&(f.teardown&&!1!==f.teardown.call(e,h,v.handle)||S.removeEvent(e,d,v.handle),delete u[d])}else for(d in u)S.event.remove(e,d+t[l],n,r,!0);S.isEmptyObject(u)&&Y.remove(e,"handle events")}},dispatch:function(e){var t,n,r,i,o,a,s=new Array(arguments.length),u=S.event.fix(e),l=(Y.get(this,"events")||Object.create(null))[u.type]||[],c=S.event.special[u.type]||{};for(s[0]=u,t=1;t<arguments.length;t++)s[t]=arguments[t];if(u.delegateTarget=this,!c.preDispatch||!1!==c.preDispatch.call(this,u)){a=S.event.handlers.call(this,u,l),t=0;while((i=a[t++])&&!u.isPropagationStopped()){u.currentTarget=i.elem,n=0;while((o=i.handlers[n++])&&!u.isImmediatePropagationStopped())u.rnamespace&&!1!==o.namespace&&!u.rnamespace.test(o.namespace)||(u.handleObj=o,u.data=o.data,void 0!==(r=((S.event.special[o.origType]||{}).handle||o.handler).apply(i.elem,s))&&!1===(u.result=r)&&(u.preventDefault(),u.stopPropagation()))}return c.postDispatch&&c.postDispatch.call(this,u),u.result}},handlers:function(e,t){var n,r,i,o,a,s=[],u=t.delegateCount,l=e.target;if(u&&l.nodeType&&!("click"===e.type&&1<=e.button))for(;l!==this;l=l.parentNode||this)if(1===l.nodeType&&("click"!==e.type||!0!==l.disabled)){for(o=[],a={},n=0;n<u;n++)void 0===a[i=(r=t[n]).selector+" "]&&(a[i]=r.needsContext?-1<S(i,this).index(l):S.find(i,this,null,[l]).length),a[i]&&o.push(r);o.length&&s.push({elem:l,handlers:o})}return l=this,u<t.length&&s.push({elem:l,handlers:t.slice(u)}),s},addProp:function(t,e){Object.defineProperty(S.Event.prototype,t,{enumerable:!0,configurable:!0,get:m(e)?function(){if(this.originalEvent)return e(this.originalEvent)}:function(){if(this.originalEvent)return this.originalEvent[t]},set:function(e){Object.defineProperty(this,t,{enumerable:!0,configurable:!0,writable:!0,value:e})}})},fix:function(e){return e[S.expando]?e:new S.Event(e)},special:{load:{noBubble:!0},click:{setup:function(e){var t=this||e;return pe.test(t.type)&&t.click&&A(t,"input")&&Se(t,"click",we),!1},trigger:function(e){var t=this||e;return pe.test(t.type)&&t.click&&A(t,"input")&&Se(t,"click"),!0},_default:function(e){var t=e.target;return pe.test(t.type)&&t.click&&A(t,"input")&&Y.get(t,"click")||A(t,"a")}},beforeunload:{postDispatch:function(e){void 0!==e.result&&e.originalEvent&&(e.originalEvent.returnValue=e.result)}}}},S.removeEvent=function(e,t,n){e.removeEventListener&&e.removeEventListener(t,n)},S.Event=function(e,t){if(!(this instanceof S.Event))return new S.Event(e,t);e&&e.type?(this.originalEvent=e,this.type=e.type,this.isDefaultPrevented=e.defaultPrevented||void 0===e.defaultPrevented&&!1===e.returnValue?we:Te,this.target=e.target&&3===e.target.nodeType?e.target.parentNode:e.target,this.currentTarget=e.currentTarget,this.relatedTarget=e.relatedTarget):this.type=e,t&&S.extend(this,t),this.timeStamp=e&&e.timeStamp||Date.now(),this[S.expando]=!0},S.Event.prototype={constructor:S.Event,isDefaultPrevented:Te,isPropagationStopped:Te,isImmediatePropagationStopped:Te,isSimulated:!1,preventDefault:function(){var e=this.originalEvent;this.isDefaultPrevented=we,e&&!this.isSimulated&&e.preventDefault()},stopPropagation:function(){var e=this.originalEvent;this.isPropagationStopped=we,e&&!this.isSimulated&&e.stopPropagation()},stopImmediatePropagation:function(){var e=this.originalEvent;this.isImmediatePropagationStopped=we,e&&!this.isSimulated&&e.stopImmediatePropagation(),this.stopPropagation()}},S.each({altKey:!0,bubbles:!0,cancelable:!0,changedTouches:!0,ctrlKey:!0,detail:!0,eventPhase:!0,metaKey:!0,pageX:!0,pageY:!0,shiftKey:!0,view:!0,"char":!0,code:!0,charCode:!0,key:!0,keyCode:!0,button:!0,buttons:!0,clientX:!0,clientY:!0,offsetX:!0,offsetY:!0,pointerId:!0,pointerType:!0,screenX:!0,screenY:!0,targetTouches:!0,toElement:!0,touches:!0,which:!0},S.event.addProp),S.each({focus:"focusin",blur:"focusout"},function(e,t){S.event.special[e]={setup:function(){return Se(this,e,Ce),!1},trigger:function(){return Se(this,e),!0},_default:function(){return!0},delegateType:t}}),S.each({mouseenter:"mouseover",mouseleave:"mouseout",pointerenter:"pointerover",pointerleave:"pointerout"},function(e,i){S.event.special[e]={delegateType:i,bindType:i,handle:function(e){var t,n=e.relatedTarget,r=e.handleObj;return n&&(n===this||S.contains(this,n))||(e.type=r.origType,t=r.handler.apply(this,arguments),e.type=i),t}}}),S.fn.extend({on:function(e,t,n,r){return Ee(this,e,t,n,r)},one:function(e,t,n,r){return Ee(this,e,t,n,r,1)},off:function(e,t,n){var r,i;if(e&&e.preventDefault&&e.handleObj)return r=e.handleObj,S(e.delegateTarget).off(r.namespace?r.origType+"."+r.namespace:r.origType,r.selector,r.handler),this;if("object"==typeof e){for(i in e)this.off(i,t,e[i]);return this}return!1!==t&&"function"!=typeof t||(n=t,t=void 0),!1===n&&(n=Te),this.each(function(){S.event.remove(this,e,n,t)})}});var ke=/<script|<style|<link/i,Ae=/checked\s*(?:[^=]|=\s*.checked.)/i,Ne=/^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g;function je(e,t){return A(e,"table")&&A(11!==t.nodeType?t:t.firstChild,"tr")&&S(e).children("tbody")[0]||e}function De(e){return e.type=(null!==e.getAttribute("type"))+"/"+e.type,e}function qe(e){return"true/"===(e.type||"").slice(0,5)?e.type=e.type.slice(5):e.removeAttribute("type"),e}function Le(e,t){var n,r,i,o,a,s;if(1===t.nodeType){if(Y.hasData(e)&&(s=Y.get(e).events))for(i in Y.remove(t,"handle events"),s)for(n=0,r=s[i].length;n<r;n++)S.event.add(t,i,s[i][n]);Q.hasData(e)&&(o=Q.access(e),a=S.extend({},o),Q.set(t,a))}}function He(n,r,i,o){r=g(r);var e,t,a,s,u,l,c=0,f=n.length,p=f-1,d=r[0],h=m(d);if(h||1<f&&"string"==typeof d&&!y.checkClone&&Ae.test(d))return n.each(function(e){var t=n.eq(e);h&&(r[0]=d.call(this,e,t.html())),He(t,r,i,o)});if(f&&(t=(e=xe(r,n[0].ownerDocument,!1,n,o)).firstChild,1===e.childNodes.length&&(e=t),t||o)){for(s=(a=S.map(ve(e,"script"),De)).length;c<f;c++)u=e,c!==p&&(u=S.clone(u,!0,!0),s&&S.merge(a,ve(u,"script"))),i.call(n[c],u,c);if(s)for(l=a[a.length-1].ownerDocument,S.map(a,qe),c=0;c<s;c++)u=a[c],he.test(u.type||"")&&!Y.access(u,"globalEval")&&S.contains(l,u)&&(u.src&&"module"!==(u.type||"").toLowerCase()?S._evalUrl&&!u.noModule&&S._evalUrl(u.src,{nonce:u.nonce||u.getAttribute("nonce")},l):b(u.textContent.replace(Ne,""),u,l))}return n}function Oe(e,t,n){for(var r,i=t?S.filter(t,e):e,o=0;null!=(r=i[o]);o++)n||1!==r.nodeType||S.cleanData(ve(r)),r.parentNode&&(n&&ie(r)&&ye(ve(r,"script")),r.parentNode.removeChild(r));return e}S.extend({htmlPrefilter:function(e){return e},clone:function(e,t,n){var r,i,o,a,s,u,l,c=e.cloneNode(!0),f=ie(e);if(!(y.noCloneChecked||1!==e.nodeType&&11!==e.nodeType||S.isXMLDoc(e)))for(a=ve(c),r=0,i=(o=ve(e)).length;r<i;r++)s=o[r],u=a[r],void 0,"input"===(l=u.nodeName.toLowerCase())&&pe.test(s.type)?u.checked=s.checked:"input"!==l&&"textarea"!==l||(u.defaultValue=s.defaultValue);if(t)if(n)for(o=o||ve(e),a=a||ve(c),r=0,i=o.length;r<i;r++)Le(o[r],a[r]);else Le(e,c);return 0<(a=ve(c,"script")).length&&ye(a,!f&&ve(e,"script")),c},cleanData:function(e){for(var t,n,r,i=S.event.special,o=0;void 0!==(n=e[o]);o++)if(V(n)){if(t=n[Y.expando]){if(t.events)for(r in t.events)i[r]?S.event.remove(n,r):S.removeEvent(n,r,t.handle);n[Y.expando]=void 0}n[Q.expando]&&(n[Q.expando]=void 0)}}}),S.fn.extend({detach:function(e){return Oe(this,e,!0)},remove:function(e){return Oe(this,e)},text:function(e){return $(this,function(e){return void 0===e?S.text(this):this.empty().each(function(){1!==this.nodeType&&11!==this.nodeType&&9!==this.nodeType||(this.textContent=e)})},null,e,arguments.length)},append:function(){return He(this,arguments,function(e){1!==this.nodeType&&11!==this.nodeType&&9!==this.nodeType||je(this,e).appendChild(e)})},prepend:function(){return He(this,arguments,function(e){if(1===this.nodeType||11===this.nodeType||9===this.nodeType){var t=je(this,e);t.insertBefore(e,t.firstChild)}})},before:function(){return He(this,arguments,function(e){this.parentNode&&this.parentNode.insertBefore(e,this)})},after:function(){return He(this,arguments,function(e){this.parentNode&&this.parentNode.insertBefore(e,this.nextSibling)})},empty:function(){for(var e,t=0;null!=(e=this[t]);t++)1===e.nodeType&&(S.cleanData(ve(e,!1)),e.textContent="");return this},clone:function(e,t){return e=null!=e&&e,t=null==t?e:t,this.map(function(){return S.clone(this,e,t)})},html:function(e){return $(this,function(e){var t=this[0]||{},n=0,r=this.length;if(void 0===e&&1===t.nodeType)return t.innerHTML;if("string"==typeof e&&!ke.test(e)&&!ge[(de.exec(e)||["",""])[1].toLowerCase()]){e=S.htmlPrefilter(e);try{for(;n<r;n++)1===(t=this[n]||{}).nodeType&&(S.cleanData(ve(t,!1)),t.innerHTML=e);t=0}catch(e){}}t&&this.empty().append(e)},null,e,arguments.length)},replaceWith:function(){var n=[];return He(this,arguments,function(e){var t=this.parentNode;S.inArray(this,n)<0&&(S.cleanData(ve(this)),t&&t.replaceChild(e,this))},n)}}),S.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(e,a){S.fn[e]=function(e){for(var t,n=[],r=S(e),i=r.length-1,o=0;o<=i;o++)t=o===i?this:this.clone(!0),S(r[o])[a](t),u.apply(n,t.get());return this.pushStack(n)}});var Pe=new RegExp("^("+ee+")(?!px)[a-z%]+$","i"),Re=function(e){var t=e.ownerDocument.defaultView;return t&&t.opener||(t=C),t.getComputedStyle(e)},Me=function(e,t,n){var r,i,o={};for(i in t)o[i]=e.style[i],e.style[i]=t[i];for(i in r=n.call(e),t)e.style[i]=o[i];return r},Ie=new RegExp(ne.join("|"),"i");function We(e,t,n){var r,i,o,a,s=e.style;return(n=n||Re(e))&&(""!==(a=n.getPropertyValue(t)||n[t])||ie(e)||(a=S.style(e,t)),!y.pixelBoxStyles()&&Pe.test(a)&&Ie.test(t)&&(r=s.width,i=s.minWidth,o=s.maxWidth,s.minWidth=s.maxWidth=s.width=a,a=n.width,s.width=r,s.minWidth=i,s.maxWidth=o)),void 0!==a?a+"":a}function Fe(e,t){return{get:function(){if(!e())return(this.get=t).apply(this,arguments);delete this.get}}}!function(){function e(){if(l){u.style.cssText="position:absolute;left:-11111px;width:60px;margin-top:1px;padding:0;border:0",l.style.cssText="position:relative;display:block;box-sizing:border-box;overflow:scroll;margin:auto;border:1px;padding:1px;width:60%;top:1%",re.appendChild(u).appendChild(l);var e=C.getComputedStyle(l);n="1%"!==e.top,s=12===t(e.marginLeft),l.style.right="60%",o=36===t(e.right),r=36===t(e.width),l.style.position="absolute",i=12===t(l.offsetWidth/3),re.removeChild(u),l=null}}function t(e){return Math.round(parseFloat(e))}var n,r,i,o,a,s,u=E.createElement("div"),l=E.createElement("div");l.style&&(l.style.backgroundClip="content-box",l.cloneNode(!0).style.backgroundClip="",y.clearCloneStyle="content-box"===l.style.backgroundClip,S.extend(y,{boxSizingReliable:function(){return e(),r},pixelBoxStyles:function(){return e(),o},pixelPosition:function(){return e(),n},reliableMarginLeft:function(){return e(),s},scrollboxSize:function(){return e(),i},reliableTrDimensions:function(){var e,t,n,r;return null==a&&(e=E.createElement("table"),t=E.createElement("tr"),n=E.createElement("div"),e.style.cssText="position:absolute;left:-11111px;border-collapse:separate",t.style.cssText="border:1px solid",t.style.height="1px",n.style.height="9px",n.style.display="block",re.appendChild(e).appendChild(t).appendChild(n),r=C.getComputedStyle(t),a=parseInt(r.height,10)+parseInt(r.borderTopWidth,10)+parseInt(r.borderBottomWidth,10)===t.offsetHeight,re.removeChild(e)),a}}))}();var Be=["Webkit","Moz","ms"],$e=E.createElement("div").style,_e={};function ze(e){var t=S.cssProps[e]||_e[e];return t||(e in $e?e:_e[e]=function(e){var t=e[0].toUpperCase()+e.slice(1),n=Be.length;while(n--)if((e=Be[n]+t)in $e)return e}(e)||e)}var Ue=/^(none|table(?!-c[ea]).+)/,Xe=/^--/,Ve={position:"absolute",visibility:"hidden",display:"block"},Ge={letterSpacing:"0",fontWeight:"400"};function Ye(e,t,n){var r=te.exec(t);return r?Math.max(0,r[2]-(n||0))+(r[3]||"px"):t}function Qe(e,t,n,r,i,o){var a="width"===t?1:0,s=0,u=0;if(n===(r?"border":"content"))return 0;for(;a<4;a+=2)"margin"===n&&(u+=S.css(e,n+ne[a],!0,i)),r?("content"===n&&(u-=S.css(e,"padding"+ne[a],!0,i)),"margin"!==n&&(u-=S.css(e,"border"+ne[a]+"Width",!0,i))):(u+=S.css(e,"padding"+ne[a],!0,i),"padding"!==n?u+=S.css(e,"border"+ne[a]+"Width",!0,i):s+=S.css(e,"border"+ne[a]+"Width",!0,i));return!r&&0<=o&&(u+=Math.max(0,Math.ceil(e["offset"+t[0].toUpperCase()+t.slice(1)]-o-u-s-.5))||0),u}function Je(e,t,n){var r=Re(e),i=(!y.boxSizingReliable()||n)&&"border-box"===S.css(e,"boxSizing",!1,r),o=i,a=We(e,t,r),s="offset"+t[0].toUpperCase()+t.slice(1);if(Pe.test(a)){if(!n)return a;a="auto"}return(!y.boxSizingReliable()&&i||!y.reliableTrDimensions()&&A(e,"tr")||"auto"===a||!parseFloat(a)&&"inline"===S.css(e,"display",!1,r))&&e.getClientRects().length&&(i="border-box"===S.css(e,"boxSizing",!1,r),(o=s in e)&&(a=e[s])),(a=parseFloat(a)||0)+Qe(e,t,n||(i?"border":"content"),o,r,a)+"px"}function Ke(e,t,n,r,i){return new Ke.prototype.init(e,t,n,r,i)}S.extend({cssHooks:{opacity:{get:function(e,t){if(t){var n=We(e,"opacity");return""===n?"1":n}}}},cssNumber:{animationIterationCount:!0,columnCount:!0,fillOpacity:!0,flexGrow:!0,flexShrink:!0,fontWeight:!0,gridArea:!0,gridColumn:!0,gridColumnEnd:!0,gridColumnStart:!0,gridRow:!0,gridRowEnd:!0,gridRowStart:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,widows:!0,zIndex:!0,zoom:!0},cssProps:{},style:function(e,t,n,r){if(e&&3!==e.nodeType&&8!==e.nodeType&&e.style){var i,o,a,s=X(t),u=Xe.test(t),l=e.style;if(u||(t=ze(s)),a=S.cssHooks[t]||S.cssHooks[s],void 0===n)return a&&"get"in a&&void 0!==(i=a.get(e,!1,r))?i:l[t];"string"===(o=typeof n)&&(i=te.exec(n))&&i[1]&&(n=se(e,t,i),o="number"),null!=n&&n==n&&("number"!==o||u||(n+=i&&i[3]||(S.cssNumber[s]?"":"px")),y.clearCloneStyle||""!==n||0!==t.indexOf("background")||(l[t]="inherit"),a&&"set"in a&&void 0===(n=a.set(e,n,r))||(u?l.setProperty(t,n):l[t]=n))}},css:function(e,t,n,r){var i,o,a,s=X(t);return Xe.test(t)||(t=ze(s)),(a=S.cssHooks[t]||S.cssHooks[s])&&"get"in a&&(i=a.get(e,!0,n)),void 0===i&&(i=We(e,t,r)),"normal"===i&&t in Ge&&(i=Ge[t]),""===n||n?(o=parseFloat(i),!0===n||isFinite(o)?o||0:i):i}}),S.each(["height","width"],function(e,u){S.cssHooks[u]={get:function(e,t,n){if(t)return!Ue.test(S.css(e,"display"))||e.getClientRects().length&&e.getBoundingClientRect().width?Je(e,u,n):Me(e,Ve,function(){return Je(e,u,n)})},set:function(e,t,n){var r,i=Re(e),o=!y.scrollboxSize()&&"absolute"===i.position,a=(o||n)&&"border-box"===S.css(e,"boxSizing",!1,i),s=n?Qe(e,u,n,a,i):0;return a&&o&&(s-=Math.ceil(e["offset"+u[0].toUpperCase()+u.slice(1)]-parseFloat(i[u])-Qe(e,u,"border",!1,i)-.5)),s&&(r=te.exec(t))&&"px"!==(r[3]||"px")&&(e.style[u]=t,t=S.css(e,u)),Ye(0,t,s)}}}),S.cssHooks.marginLeft=Fe(y.reliableMarginLeft,function(e,t){if(t)return(parseFloat(We(e,"marginLeft"))||e.getBoundingClientRect().left-Me(e,{marginLeft:0},function(){return e.getBoundingClientRect().left}))+"px"}),S.each({margin:"",padding:"",border:"Width"},function(i,o){S.cssHooks[i+o]={expand:function(e){for(var t=0,n={},r="string"==typeof e?e.split(" "):[e];t<4;t++)n[i+ne[t]+o]=r[t]||r[t-2]||r[0];return n}},"margin"!==i&&(S.cssHooks[i+o].set=Ye)}),S.fn.extend({css:function(e,t){return $(this,function(e,t,n){var r,i,o={},a=0;if(Array.isArray(t)){for(r=Re(e),i=t.length;a<i;a++)o[t[a]]=S.css(e,t[a],!1,r);return o}return void 0!==n?S.style(e,t,n):S.css(e,t)},e,t,1<arguments.length)}}),((S.Tween=Ke).prototype={constructor:Ke,init:function(e,t,n,r,i,o){this.elem=e,this.prop=n,this.easing=i||S.easing._default,this.options=t,this.start=this.now=this.cur(),this.end=r,this.unit=o||(S.cssNumber[n]?"":"px")},cur:function(){var e=Ke.propHooks[this.prop];return e&&e.get?e.get(this):Ke.propHooks._default.get(this)},run:function(e){var t,n=Ke.propHooks[this.prop];return this.options.duration?this.pos=t=S.easing[this.easing](e,this.options.duration*e,0,1,this.options.duration):this.pos=t=e,this.now=(this.end-this.start)*t+this.start,this.options.step&&this.options.step.call(this.elem,this.now,this),n&&n.set?n.set(this):Ke.propHooks._default.set(this),this}}).init.prototype=Ke.prototype,(Ke.propHooks={_default:{get:function(e){var t;return 1!==e.elem.nodeType||null!=e.elem[e.prop]&&null==e.elem.style[e.prop]?e.elem[e.prop]:(t=S.css(e.elem,e.prop,""))&&"auto"!==t?t:0},set:function(e){S.fx.step[e.prop]?S.fx.step[e.prop](e):1!==e.elem.nodeType||!S.cssHooks[e.prop]&&null==e.elem.style[ze(e.prop)]?e.elem[e.prop]=e.now:S.style(e.elem,e.prop,e.now+e.unit)}}}).scrollTop=Ke.propHooks.scrollLeft={set:function(e){e.elem.nodeType&&e.elem.parentNode&&(e.elem[e.prop]=e.now)}},S.easing={linear:function(e){return e},swing:function(e){return.5-Math.cos(e*Math.PI)/2},_default:"swing"},S.fx=Ke.prototype.init,S.fx.step={};var Ze,et,tt,nt,rt=/^(?:toggle|show|hide)$/,it=/queueHooks$/;function ot(){et&&(!1===E.hidden&&C.requestAnimationFrame?C.requestAnimationFrame(ot):C.setTimeout(ot,S.fx.interval),S.fx.tick())}function at(){return C.setTimeout(function(){Ze=void 0}),Ze=Date.now()}function st(e,t){var n,r=0,i={height:e};for(t=t?1:0;r<4;r+=2-t)i["margin"+(n=ne[r])]=i["padding"+n]=e;return t&&(i.opacity=i.width=e),i}function ut(e,t,n){for(var r,i=(lt.tweeners[t]||[]).concat(lt.tweeners["*"]),o=0,a=i.length;o<a;o++)if(r=i[o].call(n,t,e))return r}function lt(o,e,t){var n,a,r=0,i=lt.prefilters.length,s=S.Deferred().always(function(){delete u.elem}),u=function(){if(a)return!1;for(var e=Ze||at(),t=Math.max(0,l.startTime+l.duration-e),n=1-(t/l.duration||0),r=0,i=l.tweens.length;r<i;r++)l.tweens[r].run(n);return s.notifyWith(o,[l,n,t]),n<1&&i?t:(i||s.notifyWith(o,[l,1,0]),s.resolveWith(o,[l]),!1)},l=s.promise({elem:o,props:S.extend({},e),opts:S.extend(!0,{specialEasing:{},easing:S.easing._default},t),originalProperties:e,originalOptions:t,startTime:Ze||at(),duration:t.duration,tweens:[],createTween:function(e,t){var n=S.Tween(o,l.opts,e,t,l.opts.specialEasing[e]||l.opts.easing);return l.tweens.push(n),n},stop:function(e){var t=0,n=e?l.tweens.length:0;if(a)return this;for(a=!0;t<n;t++)l.tweens[t].run(1);return e?(s.notifyWith(o,[l,1,0]),s.resolveWith(o,[l,e])):s.rejectWith(o,[l,e]),this}}),c=l.props;for(!function(e,t){var n,r,i,o,a;for(n in e)if(i=t[r=X(n)],o=e[n],Array.isArray(o)&&(i=o[1],o=e[n]=o[0]),n!==r&&(e[r]=o,delete e[n]),(a=S.cssHooks[r])&&"expand"in a)for(n in o=a.expand(o),delete e[r],o)n in e||(e[n]=o[n],t[n]=i);else t[r]=i}(c,l.opts.specialEasing);r<i;r++)if(n=lt.prefilters[r].call(l,o,c,l.opts))return m(n.stop)&&(S._queueHooks(l.elem,l.opts.queue).stop=n.stop.bind(n)),n;return S.map(c,ut,l),m(l.opts.start)&&l.opts.start.call(o,l),l.progress(l.opts.progress).done(l.opts.done,l.opts.complete).fail(l.opts.fail).always(l.opts.always),S.fx.timer(S.extend(u,{elem:o,anim:l,queue:l.opts.queue})),l}S.Animation=S.extend(lt,{tweeners:{"*":[function(e,t){var n=this.createTween(e,t);return se(n.elem,e,te.exec(t),n),n}]},tweener:function(e,t){m(e)?(t=e,e=["*"]):e=e.match(P);for(var n,r=0,i=e.length;r<i;r++)n=e[r],lt.tweeners[n]=lt.tweeners[n]||[],lt.tweeners[n].unshift(t)},prefilters:[function(e,t,n){var r,i,o,a,s,u,l,c,f="width"in t||"height"in t,p=this,d={},h=e.style,g=e.nodeType&&ae(e),v=Y.get(e,"fxshow");for(r in n.queue||(null==(a=S._queueHooks(e,"fx")).unqueued&&(a.unqueued=0,s=a.empty.fire,a.empty.fire=function(){a.unqueued||s()}),a.unqueued++,p.always(function(){p.always(function(){a.unqueued--,S.queue(e,"fx").length||a.empty.fire()})})),t)if(i=t[r],rt.test(i)){if(delete t[r],o=o||"toggle"===i,i===(g?"hide":"show")){if("show"!==i||!v||void 0===v[r])continue;g=!0}d[r]=v&&v[r]||S.style(e,r)}if((u=!S.isEmptyObject(t))||!S.isEmptyObject(d))for(r in f&&1===e.nodeType&&(n.overflow=[h.overflow,h.overflowX,h.overflowY],null==(l=v&&v.display)&&(l=Y.get(e,"display")),"none"===(c=S.css(e,"display"))&&(l?c=l:(le([e],!0),l=e.style.display||l,c=S.css(e,"display"),le([e]))),("inline"===c||"inline-block"===c&&null!=l)&&"none"===S.css(e,"float")&&(u||(p.done(function(){h.display=l}),null==l&&(c=h.display,l="none"===c?"":c)),h.display="inline-block")),n.overflow&&(h.overflow="hidden",p.always(function(){h.overflow=n.overflow[0],h.overflowX=n.overflow[1],h.overflowY=n.overflow[2]})),u=!1,d)u||(v?"hidden"in v&&(g=v.hidden):v=Y.access(e,"fxshow",{display:l}),o&&(v.hidden=!g),g&&le([e],!0),p.done(function(){for(r in g||le([e]),Y.remove(e,"fxshow"),d)S.style(e,r,d[r])})),u=ut(g?v[r]:0,r,p),r in v||(v[r]=u.start,g&&(u.end=u.start,u.start=0))}],prefilter:function(e,t){t?lt.prefilters.unshift(e):lt.prefilters.push(e)}}),S.speed=function(e,t,n){var r=e&&"object"==typeof e?S.extend({},e):{complete:n||!n&&t||m(e)&&e,duration:e,easing:n&&t||t&&!m(t)&&t};return S.fx.off?r.duration=0:"number"!=typeof r.duration&&(r.duration in S.fx.speeds?r.duration=S.fx.speeds[r.duration]:r.duration=S.fx.speeds._default),null!=r.queue&&!0!==r.queue||(r.queue="fx"),r.old=r.complete,r.complete=function(){m(r.old)&&r.old.call(this),r.queue&&S.dequeue(this,r.queue)},r},S.fn.extend({fadeTo:function(e,t,n,r){return this.filter(ae).css("opacity",0).show().end().animate({opacity:t},e,n,r)},animate:function(t,e,n,r){var i=S.isEmptyObject(t),o=S.speed(e,n,r),a=function(){var e=lt(this,S.extend({},t),o);(i||Y.get(this,"finish"))&&e.stop(!0)};return a.finish=a,i||!1===o.queue?this.each(a):this.queue(o.queue,a)},stop:function(i,e,o){var a=function(e){var t=e.stop;delete e.stop,t(o)};return"string"!=typeof i&&(o=e,e=i,i=void 0),e&&this.queue(i||"fx",[]),this.each(function(){var e=!0,t=null!=i&&i+"queueHooks",n=S.timers,r=Y.get(this);if(t)r[t]&&r[t].stop&&a(r[t]);else for(t in r)r[t]&&r[t].stop&&it.test(t)&&a(r[t]);for(t=n.length;t--;)n[t].elem!==this||null!=i&&n[t].queue!==i||(n[t].anim.stop(o),e=!1,n.splice(t,1));!e&&o||S.dequeue(this,i)})},finish:function(a){return!1!==a&&(a=a||"fx"),this.each(function(){var e,t=Y.get(this),n=t[a+"queue"],r=t[a+"queueHooks"],i=S.timers,o=n?n.length:0;for(t.finish=!0,S.queue(this,a,[]),r&&r.stop&&r.stop.call(this,!0),e=i.length;e--;)i[e].elem===this&&i[e].queue===a&&(i[e].anim.stop(!0),i.splice(e,1));for(e=0;e<o;e++)n[e]&&n[e].finish&&n[e].finish.call(this);delete t.finish})}}),S.each(["toggle","show","hide"],function(e,r){var i=S.fn[r];S.fn[r]=function(e,t,n){return null==e||"boolean"==typeof e?i.apply(this,arguments):this.animate(st(r,!0),e,t,n)}}),S.each({slideDown:st("show"),slideUp:st("hide"),slideToggle:st("toggle"),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"},fadeToggle:{opacity:"toggle"}},function(e,r){S.fn[e]=function(e,t,n){return this.animate(r,e,t,n)}}),S.timers=[],S.fx.tick=function(){var e,t=0,n=S.timers;for(Ze=Date.now();t<n.length;t++)(e=n[t])()||n[t]!==e||n.splice(t--,1);n.length||S.fx.stop(),Ze=void 0},S.fx.timer=function(e){S.timers.push(e),S.fx.start()},S.fx.interval=13,S.fx.start=function(){et||(et=!0,ot())},S.fx.stop=function(){et=null},S.fx.speeds={slow:600,fast:200,_default:400},S.fn.delay=function(r,e){return r=S.fx&&S.fx.speeds[r]||r,e=e||"fx",this.queue(e,function(e,t){var n=C.setTimeout(e,r);t.stop=function(){C.clearTimeout(n)}})},tt=E.createElement("input"),nt=E.createElement("select").appendChild(E.createElement("option")),tt.type="checkbox",y.checkOn=""!==tt.value,y.optSelected=nt.selected,(tt=E.createElement("input")).value="t",tt.type="radio",y.radioValue="t"===tt.value;var ct,ft=S.expr.attrHandle;S.fn.extend({attr:function(e,t){return $(this,S.attr,e,t,1<arguments.length)},removeAttr:function(e){return this.each(function(){S.removeAttr(this,e)})}}),S.extend({attr:function(e,t,n){var r,i,o=e.nodeType;if(3!==o&&8!==o&&2!==o)return"undefined"==typeof e.getAttribute?S.prop(e,t,n):(1===o&&S.isXMLDoc(e)||(i=S.attrHooks[t.toLowerCase()]||(S.expr.match.bool.test(t)?ct:void 0)),void 0!==n?null===n?void S.removeAttr(e,t):i&&"set"in i&&void 0!==(r=i.set(e,n,t))?r:(e.setAttribute(t,n+""),n):i&&"get"in i&&null!==(r=i.get(e,t))?r:null==(r=S.find.attr(e,t))?void 0:r)},attrHooks:{type:{set:function(e,t){if(!y.radioValue&&"radio"===t&&A(e,"input")){var n=e.value;return e.setAttribute("type",t),n&&(e.value=n),t}}}},removeAttr:function(e,t){var n,r=0,i=t&&t.match(P);if(i&&1===e.nodeType)while(n=i[r++])e.removeAttribute(n)}}),ct={set:function(e,t,n){return!1===t?S.removeAttr(e,n):e.setAttribute(n,n),n}},S.each(S.expr.match.bool.source.match(/\w+/g),function(e,t){var a=ft[t]||S.find.attr;ft[t]=function(e,t,n){var r,i,o=t.toLowerCase();return n||(i=ft[o],ft[o]=r,r=null!=a(e,t,n)?o:null,ft[o]=i),r}});var pt=/^(?:input|select|textarea|button)$/i,dt=/^(?:a|area)$/i;function ht(e){return(e.match(P)||[]).join(" ")}function gt(e){return e.getAttribute&&e.getAttribute("class")||""}function vt(e){return Array.isArray(e)?e:"string"==typeof e&&e.match(P)||[]}S.fn.extend({prop:function(e,t){return $(this,S.prop,e,t,1<arguments.length)},removeProp:function(e){return this.each(function(){delete this[S.propFix[e]||e]})}}),S.extend({prop:function(e,t,n){var r,i,o=e.nodeType;if(3!==o&&8!==o&&2!==o)return 1===o&&S.isXMLDoc(e)||(t=S.propFix[t]||t,i=S.propHooks[t]),void 0!==n?i&&"set"in i&&void 0!==(r=i.set(e,n,t))?r:e[t]=n:i&&"get"in i&&null!==(r=i.get(e,t))?r:e[t]},propHooks:{tabIndex:{get:function(e){var t=S.find.attr(e,"tabindex");return t?parseInt(t,10):pt.test(e.nodeName)||dt.test(e.nodeName)&&e.href?0:-1}}},propFix:{"for":"htmlFor","class":"className"}}),y.optSelected||(S.propHooks.selected={get:function(e){var t=e.parentNode;return t&&t.parentNode&&t.parentNode.selectedIndex,null},set:function(e){var t=e.parentNode;t&&(t.selectedIndex,t.parentNode&&t.parentNode.selectedIndex)}}),S.each(["tabIndex","readOnly","maxLength","cellSpacing","cellPadding","rowSpan","colSpan","useMap","frameBorder","contentEditable"],function(){S.propFix[this.toLowerCase()]=this}),S.fn.extend({addClass:function(t){var e,n,r,i,o,a,s,u=0;if(m(t))return this.each(function(e){S(this).addClass(t.call(this,e,gt(this)))});if((e=vt(t)).length)while(n=this[u++])if(i=gt(n),r=1===n.nodeType&&" "+ht(i)+" "){a=0;while(o=e[a++])r.indexOf(" "+o+" ")<0&&(r+=o+" ");i!==(s=ht(r))&&n.setAttribute("class",s)}return this},removeClass:function(t){var e,n,r,i,o,a,s,u=0;if(m(t))return this.each(function(e){S(this).removeClass(t.call(this,e,gt(this)))});if(!arguments.length)return this.attr("class","");if((e=vt(t)).length)while(n=this[u++])if(i=gt(n),r=1===n.nodeType&&" "+ht(i)+" "){a=0;while(o=e[a++])while(-1<r.indexOf(" "+o+" "))r=r.replace(" "+o+" "," ");i!==(s=ht(r))&&n.setAttribute("class",s)}return this},toggleClass:function(i,t){var o=typeof i,a="string"===o||Array.isArray(i);return"boolean"==typeof t&&a?t?this.addClass(i):this.removeClass(i):m(i)?this.each(function(e){S(this).toggleClass(i.call(this,e,gt(this),t),t)}):this.each(function(){var e,t,n,r;if(a){t=0,n=S(this),r=vt(i);while(e=r[t++])n.hasClass(e)?n.removeClass(e):n.addClass(e)}else void 0!==i&&"boolean"!==o||((e=gt(this))&&Y.set(this,"__className__",e),this.setAttribute&&this.setAttribute("class",e||!1===i?"":Y.get(this,"__className__")||""))})},hasClass:function(e){var t,n,r=0;t=" "+e+" ";while(n=this[r++])if(1===n.nodeType&&-1<(" "+ht(gt(n))+" ").indexOf(t))return!0;return!1}});var yt=/\r/g;S.fn.extend({val:function(n){var r,e,i,t=this[0];return arguments.length?(i=m(n),this.each(function(e){var t;1===this.nodeType&&(null==(t=i?n.call(this,e,S(this).val()):n)?t="":"number"==typeof t?t+="":Array.isArray(t)&&(t=S.map(t,function(e){return null==e?"":e+""})),(r=S.valHooks[this.type]||S.valHooks[this.nodeName.toLowerCase()])&&"set"in r&&void 0!==r.set(this,t,"value")||(this.value=t))})):t?(r=S.valHooks[t.type]||S.valHooks[t.nodeName.toLowerCase()])&&"get"in r&&void 0!==(e=r.get(t,"value"))?e:"string"==typeof(e=t.value)?e.replace(yt,""):null==e?"":e:void 0}}),S.extend({valHooks:{option:{get:function(e){var t=S.find.attr(e,"value");return null!=t?t:ht(S.text(e))}},select:{get:function(e){var t,n,r,i=e.options,o=e.selectedIndex,a="select-one"===e.type,s=a?null:[],u=a?o+1:i.length;for(r=o<0?u:a?o:0;r<u;r++)if(((n=i[r]).selected||r===o)&&!n.disabled&&(!n.parentNode.disabled||!A(n.parentNode,"optgroup"))){if(t=S(n).val(),a)return t;s.push(t)}return s},set:function(e,t){var n,r,i=e.options,o=S.makeArray(t),a=i.length;while(a--)((r=i[a]).selected=-1<S.inArray(S.valHooks.option.get(r),o))&&(n=!0);return n||(e.selectedIndex=-1),o}}}}),S.each(["radio","checkbox"],function(){S.valHooks[this]={set:function(e,t){if(Array.isArray(t))return e.checked=-1<S.inArray(S(e).val(),t)}},y.checkOn||(S.valHooks[this].get=function(e){return null===e.getAttribute("value")?"on":e.value})}),y.focusin="onfocusin"in C;var mt=/^(?:focusinfocus|focusoutblur)$/,xt=function(e){e.stopPropagation()};S.extend(S.event,{trigger:function(e,t,n,r){var i,o,a,s,u,l,c,f,p=[n||E],d=v.call(e,"type")?e.type:e,h=v.call(e,"namespace")?e.namespace.split("."):[];if(o=f=a=n=n||E,3!==n.nodeType&&8!==n.nodeType&&!mt.test(d+S.event.triggered)&&(-1<d.indexOf(".")&&(d=(h=d.split(".")).shift(),h.sort()),u=d.indexOf(":")<0&&"on"+d,(e=e[S.expando]?e:new S.Event(d,"object"==typeof e&&e)).isTrigger=r?2:3,e.namespace=h.join("."),e.rnamespace=e.namespace?new RegExp("(^|\\.)"+h.join("\\.(?:.*\\.|)")+"(\\.|$)"):null,e.result=void 0,e.target||(e.target=n),t=null==t?[e]:S.makeArray(t,[e]),c=S.event.special[d]||{},r||!c.trigger||!1!==c.trigger.apply(n,t))){if(!r&&!c.noBubble&&!x(n)){for(s=c.delegateType||d,mt.test(s+d)||(o=o.parentNode);o;o=o.parentNode)p.push(o),a=o;a===(n.ownerDocument||E)&&p.push(a.defaultView||a.parentWindow||C)}i=0;while((o=p[i++])&&!e.isPropagationStopped())f=o,e.type=1<i?s:c.bindType||d,(l=(Y.get(o,"events")||Object.create(null))[e.type]&&Y.get(o,"handle"))&&l.apply(o,t),(l=u&&o[u])&&l.apply&&V(o)&&(e.result=l.apply(o,t),!1===e.result&&e.preventDefault());return e.type=d,r||e.isDefaultPrevented()||c._default&&!1!==c._default.apply(p.pop(),t)||!V(n)||u&&m(n[d])&&!x(n)&&((a=n[u])&&(n[u]=null),S.event.triggered=d,e.isPropagationStopped()&&f.addEventListener(d,xt),n[d](),e.isPropagationStopped()&&f.removeEventListener(d,xt),S.event.triggered=void 0,a&&(n[u]=a)),e.result}},simulate:function(e,t,n){var r=S.extend(new S.Event,n,{type:e,isSimulated:!0});S.event.trigger(r,null,t)}}),S.fn.extend({trigger:function(e,t){return this.each(function(){S.event.trigger(e,t,this)})},triggerHandler:function(e,t){var n=this[0];if(n)return S.event.trigger(e,t,n,!0)}}),y.focusin||S.each({focus:"focusin",blur:"focusout"},function(n,r){var i=function(e){S.event.simulate(r,e.target,S.event.fix(e))};S.event.special[r]={setup:function(){var e=this.ownerDocument||this.document||this,t=Y.access(e,r);t||e.addEventListener(n,i,!0),Y.access(e,r,(t||0)+1)},teardown:function(){var e=this.ownerDocument||this.document||this,t=Y.access(e,r)-1;t?Y.access(e,r,t):(e.removeEventListener(n,i,!0),Y.remove(e,r))}}});var bt=C.location,wt={guid:Date.now()},Tt=/\?/;S.parseXML=function(e){var t,n;if(!e||"string"!=typeof e)return null;try{t=(new C.DOMParser).parseFromString(e,"text/xml")}catch(e){}return n=t&&t.getElementsByTagName("parsererror")[0],t&&!n||S.error("Invalid XML: "+(n?S.map(n.childNodes,function(e){return e.textContent}).join("\n"):e)),t};var Ct=/\[\]$/,Et=/\r?\n/g,St=/^(?:submit|button|image|reset|file)$/i,kt=/^(?:input|select|textarea|keygen)/i;function At(n,e,r,i){var t;if(Array.isArray(e))S.each(e,function(e,t){r||Ct.test(n)?i(n,t):At(n+"["+("object"==typeof t&&null!=t?e:"")+"]",t,r,i)});else if(r||"object"!==w(e))i(n,e);else for(t in e)At(n+"["+t+"]",e[t],r,i)}S.param=function(e,t){var n,r=[],i=function(e,t){var n=m(t)?t():t;r[r.length]=encodeURIComponent(e)+"="+encodeURIComponent(null==n?"":n)};if(null==e)return"";if(Array.isArray(e)||e.jquery&&!S.isPlainObject(e))S.each(e,function(){i(this.name,this.value)});else for(n in e)At(n,e[n],t,i);return r.join("&")},S.fn.extend({serialize:function(){return S.param(this.serializeArray())},serializeArray:function(){return this.map(function(){var e=S.prop(this,"elements");return e?S.makeArray(e):this}).filter(function(){var e=this.type;return this.name&&!S(this).is(":disabled")&&kt.test(this.nodeName)&&!St.test(e)&&(this.checked||!pe.test(e))}).map(function(e,t){var n=S(this).val();return null==n?null:Array.isArray(n)?S.map(n,function(e){return{name:t.name,value:e.replace(Et,"\r\n")}}):{name:t.name,value:n.replace(Et,"\r\n")}}).get()}});var Nt=/%20/g,jt=/#.*$/,Dt=/([?&])_=[^&]*/,qt=/^(.*?):[ \t]*([^\r\n]*)$/gm,Lt=/^(?:GET|HEAD)$/,Ht=/^\/\//,Ot={},Pt={},Rt="*/".concat("*"),Mt=E.createElement("a");function It(o){return function(e,t){"string"!=typeof e&&(t=e,e="*");var n,r=0,i=e.toLowerCase().match(P)||[];if(m(t))while(n=i[r++])"+"===n[0]?(n=n.slice(1)||"*",(o[n]=o[n]||[]).unshift(t)):(o[n]=o[n]||[]).push(t)}}function Wt(t,i,o,a){var s={},u=t===Pt;function l(e){var r;return s[e]=!0,S.each(t[e]||[],function(e,t){var n=t(i,o,a);return"string"!=typeof n||u||s[n]?u?!(r=n):void 0:(i.dataTypes.unshift(n),l(n),!1)}),r}return l(i.dataTypes[0])||!s["*"]&&l("*")}function Ft(e,t){var n,r,i=S.ajaxSettings.flatOptions||{};for(n in t)void 0!==t[n]&&((i[n]?e:r||(r={}))[n]=t[n]);return r&&S.extend(!0,e,r),e}Mt.href=bt.href,S.extend({active:0,lastModified:{},etag:{},ajaxSettings:{url:bt.href,type:"GET",isLocal:/^(?:about|app|app-storage|.+-extension|file|res|widget):$/.test(bt.protocol),global:!0,processData:!0,async:!0,contentType:"application/x-www-form-urlencoded; charset=UTF-8",accepts:{"*":Rt,text:"text/plain",html:"text/html",xml:"application/xml, text/xml",json:"application/json, text/javascript"},contents:{xml:/\bxml\b/,html:/\bhtml/,json:/\bjson\b/},responseFields:{xml:"responseXML",text:"responseText",json:"responseJSON"},converters:{"* text":String,"text html":!0,"text json":JSON.parse,"text xml":S.parseXML},flatOptions:{url:!0,context:!0}},ajaxSetup:function(e,t){return t?Ft(Ft(e,S.ajaxSettings),t):Ft(S.ajaxSettings,e)},ajaxPrefilter:It(Ot),ajaxTransport:It(Pt),ajax:function(e,t){"object"==typeof e&&(t=e,e=void 0),t=t||{};var c,f,p,n,d,r,h,g,i,o,v=S.ajaxSetup({},t),y=v.context||v,m=v.context&&(y.nodeType||y.jquery)?S(y):S.event,x=S.Deferred(),b=S.Callbacks("once memory"),w=v.statusCode||{},a={},s={},u="canceled",T={readyState:0,getResponseHeader:function(e){var t;if(h){if(!n){n={};while(t=qt.exec(p))n[t[1].toLowerCase()+" "]=(n[t[1].toLowerCase()+" "]||[]).concat(t[2])}t=n[e.toLowerCase()+" "]}return null==t?null:t.join(", ")},getAllResponseHeaders:function(){return h?p:null},setRequestHeader:function(e,t){return null==h&&(e=s[e.toLowerCase()]=s[e.toLowerCase()]||e,a[e]=t),this},overrideMimeType:function(e){return null==h&&(v.mimeType=e),this},statusCode:function(e){var t;if(e)if(h)T.always(e[T.status]);else for(t in e)w[t]=[w[t],e[t]];return this},abort:function(e){var t=e||u;return c&&c.abort(t),l(0,t),this}};if(x.promise(T),v.url=((e||v.url||bt.href)+"").replace(Ht,bt.protocol+"//"),v.type=t.method||t.type||v.method||v.type,v.dataTypes=(v.dataType||"*").toLowerCase().match(P)||[""],null==v.crossDomain){r=E.createElement("a");try{r.href=v.url,r.href=r.href,v.crossDomain=Mt.protocol+"//"+Mt.host!=r.protocol+"//"+r.host}catch(e){v.crossDomain=!0}}if(v.data&&v.processData&&"string"!=typeof v.data&&(v.data=S.param(v.data,v.traditional)),Wt(Ot,v,t,T),h)return T;for(i in(g=S.event&&v.global)&&0==S.active++&&S.event.trigger("ajaxStart"),v.type=v.type.toUpperCase(),v.hasContent=!Lt.test(v.type),f=v.url.replace(jt,""),v.hasContent?v.data&&v.processData&&0===(v.contentType||"").indexOf("application/x-www-form-urlencoded")&&(v.data=v.data.replace(Nt,"+")):(o=v.url.slice(f.length),v.data&&(v.processData||"string"==typeof v.data)&&(f+=(Tt.test(f)?"&":"?")+v.data,delete v.data),!1===v.cache&&(f=f.replace(Dt,"$1"),o=(Tt.test(f)?"&":"?")+"_="+wt.guid+++o),v.url=f+o),v.ifModified&&(S.lastModified[f]&&T.setRequestHeader("If-Modified-Since",S.lastModified[f]),S.etag[f]&&T.setRequestHeader("If-None-Match",S.etag[f])),(v.data&&v.hasContent&&!1!==v.contentType||t.contentType)&&T.setRequestHeader("Content-Type",v.contentType),T.setRequestHeader("Accept",v.dataTypes[0]&&v.accepts[v.dataTypes[0]]?v.accepts[v.dataTypes[0]]+("*"!==v.dataTypes[0]?", "+Rt+"; q=0.01":""):v.accepts["*"]),v.headers)T.setRequestHeader(i,v.headers[i]);if(v.beforeSend&&(!1===v.beforeSend.call(y,T,v)||h))return T.abort();if(u="abort",b.add(v.complete),T.done(v.success),T.fail(v.error),c=Wt(Pt,v,t,T)){if(T.readyState=1,g&&m.trigger("ajaxSend",[T,v]),h)return T;v.async&&0<v.timeout&&(d=C.setTimeout(function(){T.abort("timeout")},v.timeout));try{h=!1,c.send(a,l)}catch(e){if(h)throw e;l(-1,e)}}else l(-1,"No Transport");function l(e,t,n,r){var i,o,a,s,u,l=t;h||(h=!0,d&&C.clearTimeout(d),c=void 0,p=r||"",T.readyState=0<e?4:0,i=200<=e&&e<300||304===e,n&&(s=function(e,t,n){var r,i,o,a,s=e.contents,u=e.dataTypes;while("*"===u[0])u.shift(),void 0===r&&(r=e.mimeType||t.getResponseHeader("Content-Type"));if(r)for(i in s)if(s[i]&&s[i].test(r)){u.unshift(i);break}if(u[0]in n)o=u[0];else{for(i in n){if(!u[0]||e.converters[i+" "+u[0]]){o=i;break}a||(a=i)}o=o||a}if(o)return o!==u[0]&&u.unshift(o),n[o]}(v,T,n)),!i&&-1<S.inArray("script",v.dataTypes)&&S.inArray("json",v.dataTypes)<0&&(v.converters["text script"]=function(){}),s=function(e,t,n,r){var i,o,a,s,u,l={},c=e.dataTypes.slice();if(c[1])for(a in e.converters)l[a.toLowerCase()]=e.converters[a];o=c.shift();while(o)if(e.responseFields[o]&&(n[e.responseFields[o]]=t),!u&&r&&e.dataFilter&&(t=e.dataFilter(t,e.dataType)),u=o,o=c.shift())if("*"===o)o=u;else if("*"!==u&&u!==o){if(!(a=l[u+" "+o]||l["* "+o]))for(i in l)if((s=i.split(" "))[1]===o&&(a=l[u+" "+s[0]]||l["* "+s[0]])){!0===a?a=l[i]:!0!==l[i]&&(o=s[0],c.unshift(s[1]));break}if(!0!==a)if(a&&e["throws"])t=a(t);else try{t=a(t)}catch(e){return{state:"parsererror",error:a?e:"No conversion from "+u+" to "+o}}}return{state:"success",data:t}}(v,s,T,i),i?(v.ifModified&&((u=T.getResponseHeader("Last-Modified"))&&(S.lastModified[f]=u),(u=T.getResponseHeader("etag"))&&(S.etag[f]=u)),204===e||"HEAD"===v.type?l="nocontent":304===e?l="notmodified":(l=s.state,o=s.data,i=!(a=s.error))):(a=l,!e&&l||(l="error",e<0&&(e=0))),T.status=e,T.statusText=(t||l)+"",i?x.resolveWith(y,[o,l,T]):x.rejectWith(y,[T,l,a]),T.statusCode(w),w=void 0,g&&m.trigger(i?"ajaxSuccess":"ajaxError",[T,v,i?o:a]),b.fireWith(y,[T,l]),g&&(m.trigger("ajaxComplete",[T,v]),--S.active||S.event.trigger("ajaxStop")))}return T},getJSON:function(e,t,n){return S.get(e,t,n,"json")},getScript:function(e,t){return S.get(e,void 0,t,"script")}}),S.each(["get","post"],function(e,i){S[i]=function(e,t,n,r){return m(t)&&(r=r||n,n=t,t=void 0),S.ajax(S.extend({url:e,type:i,dataType:r,data:t,success:n},S.isPlainObject(e)&&e))}}),S.ajaxPrefilter(function(e){var t;for(t in e.headers)"content-type"===t.toLowerCase()&&(e.contentType=e.headers[t]||"")}),S._evalUrl=function(e,t,n){return S.ajax({url:e,type:"GET",dataType:"script",cache:!0,async:!1,global:!1,converters:{"text script":function(){}},dataFilter:function(e){S.globalEval(e,t,n)}})},S.fn.extend({wrapAll:function(e){var t;return this[0]&&(m(e)&&(e=e.call(this[0])),t=S(e,this[0].ownerDocument).eq(0).clone(!0),this[0].parentNode&&t.insertBefore(this[0]),t.map(function(){var e=this;while(e.firstElementChild)e=e.firstElementChild;return e}).append(this)),this},wrapInner:function(n){return m(n)?this.each(function(e){S(this).wrapInner(n.call(this,e))}):this.each(function(){var e=S(this),t=e.contents();t.length?t.wrapAll(n):e.append(n)})},wrap:function(t){var n=m(t);return this.each(function(e){S(this).wrapAll(n?t.call(this,e):t)})},unwrap:function(e){return this.parent(e).not("body").each(function(){S(this).replaceWith(this.childNodes)}),this}}),S.expr.pseudos.hidden=function(e){return!S.expr.pseudos.visible(e)},S.expr.pseudos.visible=function(e){return!!(e.offsetWidth||e.offsetHeight||e.getClientRects().length)},S.ajaxSettings.xhr=function(){try{return new C.XMLHttpRequest}catch(e){}};var Bt={0:200,1223:204},$t=S.ajaxSettings.xhr();y.cors=!!$t&&"withCredentials"in $t,y.ajax=$t=!!$t,S.ajaxTransport(function(i){var o,a;if(y.cors||$t&&!i.crossDomain)return{send:function(e,t){var n,r=i.xhr();if(r.open(i.type,i.url,i.async,i.username,i.password),i.xhrFields)for(n in i.xhrFields)r[n]=i.xhrFields[n];for(n in i.mimeType&&r.overrideMimeType&&r.overrideMimeType(i.mimeType),i.crossDomain||e["X-Requested-With"]||(e["X-Requested-With"]="XMLHttpRequest"),e)r.setRequestHeader(n,e[n]);o=function(e){return function(){o&&(o=a=r.onload=r.onerror=r.onabort=r.ontimeout=r.onreadystatechange=null,"abort"===e?r.abort():"error"===e?"number"!=typeof r.status?t(0,"error"):t(r.status,r.statusText):t(Bt[r.status]||r.status,r.statusText,"text"!==(r.responseType||"text")||"string"!=typeof r.responseText?{binary:r.response}:{text:r.responseText},r.getAllResponseHeaders()))}},r.onload=o(),a=r.onerror=r.ontimeout=o("error"),void 0!==r.onabort?r.onabort=a:r.onreadystatechange=function(){4===r.readyState&&C.setTimeout(function(){o&&a()})},o=o("abort");try{r.send(i.hasContent&&i.data||null)}catch(e){if(o)throw e}},abort:function(){o&&o()}}}),S.ajaxPrefilter(function(e){e.crossDomain&&(e.contents.script=!1)}),S.ajaxSetup({accepts:{script:"text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"},contents:{script:/\b(?:java|ecma)script\b/},converters:{"text script":function(e){return S.globalEval(e),e}}}),S.ajaxPrefilter("script",function(e){void 0===e.cache&&(e.cache=!1),e.crossDomain&&(e.type="GET")}),S.ajaxTransport("script",function(n){var r,i;if(n.crossDomain||n.scriptAttrs)return{send:function(e,t){r=S("<script>").attr(n.scriptAttrs||{}).prop({charset:n.scriptCharset,src:n.url}).on("load error",i=function(e){r.remove(),i=null,e&&t("error"===e.type?404:200,e.type)}),E.head.appendChild(r[0])},abort:function(){i&&i()}}});var _t,zt=[],Ut=/(=)\?(?=&|$)|\?\?/;S.ajaxSetup({jsonp:"callback",jsonpCallback:function(){var e=zt.pop()||S.expando+"_"+wt.guid++;return this[e]=!0,e}}),S.ajaxPrefilter("json jsonp",function(e,t,n){var r,i,o,a=!1!==e.jsonp&&(Ut.test(e.url)?"url":"string"==typeof e.data&&0===(e.contentType||"").indexOf("application/x-www-form-urlencoded")&&Ut.test(e.data)&&"data");if(a||"jsonp"===e.dataTypes[0])return r=e.jsonpCallback=m(e.jsonpCallback)?e.jsonpCallback():e.jsonpCallback,a?e[a]=e[a].replace(Ut,"$1"+r):!1!==e.jsonp&&(e.url+=(Tt.test(e.url)?"&":"?")+e.jsonp+"="+r),e.converters["script json"]=function(){return o||S.error(r+" was not called"),o[0]},e.dataTypes[0]="json",i=C[r],C[r]=function(){o=arguments},n.always(function(){void 0===i?S(C).removeProp(r):C[r]=i,e[r]&&(e.jsonpCallback=t.jsonpCallback,zt.push(r)),o&&m(i)&&i(o[0]),o=i=void 0}),"script"}),y.createHTMLDocument=((_t=E.implementation.createHTMLDocument("").body).innerHTML="<form></form><form></form>",2===_t.childNodes.length),S.parseHTML=function(e,t,n){return"string"!=typeof e?[]:("boolean"==typeof t&&(n=t,t=!1),t||(y.createHTMLDocument?((r=(t=E.implementation.createHTMLDocument("")).createElement("base")).href=E.location.href,t.head.appendChild(r)):t=E),o=!n&&[],(i=N.exec(e))?[t.createElement(i[1])]:(i=xe([e],t,o),o&&o.length&&S(o).remove(),S.merge([],i.childNodes)));var r,i,o},S.fn.load=function(e,t,n){var r,i,o,a=this,s=e.indexOf(" ");return-1<s&&(r=ht(e.slice(s)),e=e.slice(0,s)),m(t)?(n=t,t=void 0):t&&"object"==typeof t&&(i="POST"),0<a.length&&S.ajax({url:e,type:i||"GET",dataType:"html",data:t}).done(function(e){o=arguments,a.html(r?S("<div>").append(S.parseHTML(e)).find(r):e)}).always(n&&function(e,t){a.each(function(){n.apply(this,o||[e.responseText,t,e])})}),this},S.expr.pseudos.animated=function(t){return S.grep(S.timers,function(e){return t===e.elem}).length},S.offset={setOffset:function(e,t,n){var r,i,o,a,s,u,l=S.css(e,"position"),c=S(e),f={};"static"===l&&(e.style.position="relative"),s=c.offset(),o=S.css(e,"top"),u=S.css(e,"left"),("absolute"===l||"fixed"===l)&&-1<(o+u).indexOf("auto")?(a=(r=c.position()).top,i=r.left):(a=parseFloat(o)||0,i=parseFloat(u)||0),m(t)&&(t=t.call(e,n,S.extend({},s))),null!=t.top&&(f.top=t.top-s.top+a),null!=t.left&&(f.left=t.left-s.left+i),"using"in t?t.using.call(e,f):c.css(f)}},S.fn.extend({offset:function(t){if(arguments.length)return void 0===t?this:this.each(function(e){S.offset.setOffset(this,t,e)});var e,n,r=this[0];return r?r.getClientRects().length?(e=r.getBoundingClientRect(),n=r.ownerDocument.defaultView,{top:e.top+n.pageYOffset,left:e.left+n.pageXOffset}):{top:0,left:0}:void 0},position:function(){if(this[0]){var e,t,n,r=this[0],i={top:0,left:0};if("fixed"===S.css(r,"position"))t=r.getBoundingClientRect();else{t=this.offset(),n=r.ownerDocument,e=r.offsetParent||n.documentElement;while(e&&(e===n.body||e===n.documentElement)&&"static"===S.css(e,"position"))e=e.parentNode;e&&e!==r&&1===e.nodeType&&((i=S(e).offset()).top+=S.css(e,"borderTopWidth",!0),i.left+=S.css(e,"borderLeftWidth",!0))}return{top:t.top-i.top-S.css(r,"marginTop",!0),left:t.left-i.left-S.css(r,"marginLeft",!0)}}},offsetParent:function(){return this.map(function(){var e=this.offsetParent;while(e&&"static"===S.css(e,"position"))e=e.offsetParent;return e||re})}}),S.each({scrollLeft:"pageXOffset",scrollTop:"pageYOffset"},function(t,i){var o="pageYOffset"===i;S.fn[t]=function(e){return $(this,function(e,t,n){var r;if(x(e)?r=e:9===e.nodeType&&(r=e.defaultView),void 0===n)return r?r[i]:e[t];r?r.scrollTo(o?r.pageXOffset:n,o?n:r.pageYOffset):e[t]=n},t,e,arguments.length)}}),S.each(["top","left"],function(e,n){S.cssHooks[n]=Fe(y.pixelPosition,function(e,t){if(t)return t=We(e,n),Pe.test(t)?S(e).position()[n]+"px":t})}),S.each({Height:"height",Width:"width"},function(a,s){S.each({padding:"inner"+a,content:s,"":"outer"+a},function(r,o){S.fn[o]=function(e,t){var n=arguments.length&&(r||"boolean"!=typeof e),i=r||(!0===e||!0===t?"margin":"border");return $(this,function(e,t,n){var r;return x(e)?0===o.indexOf("outer")?e["inner"+a]:e.document.documentElement["client"+a]:9===e.nodeType?(r=e.documentElement,Math.max(e.body["scroll"+a],r["scroll"+a],e.body["offset"+a],r["offset"+a],r["client"+a])):void 0===n?S.css(e,t,i):S.style(e,t,n,i)},s,n?e:void 0,n)}})}),S.each(["ajaxStart","ajaxStop","ajaxComplete","ajaxError","ajaxSuccess","ajaxSend"],function(e,t){S.fn[t]=function(e){return this.on(t,e)}}),S.fn.extend({bind:function(e,t,n){return this.on(e,null,t,n)},unbind:function(e,t){return this.off(e,null,t)},delegate:function(e,t,n,r){return this.on(t,e,n,r)},undelegate:function(e,t,n){return 1===arguments.length?this.off(e,"**"):this.off(t,e||"**",n)},hover:function(e,t){return this.mouseenter(e).mouseleave(t||e)}}),S.each("blur focus focusin focusout resize scroll click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup contextmenu".split(" "),function(e,n){S.fn[n]=function(e,t){return 0<arguments.length?this.on(n,null,e,t):this.trigger(n)}});var Xt=/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g;S.proxy=function(e,t){var n,r,i;if("string"==typeof t&&(n=e[t],t=e,e=n),m(e))return r=s.call(arguments,2),(i=function(){return e.apply(t||this,r.concat(s.call(arguments)))}).guid=e.guid=e.guid||S.guid++,i},S.holdReady=function(e){e?S.readyWait++:S.ready(!0)},S.isArray=Array.isArray,S.parseJSON=JSON.parse,S.nodeName=A,S.isFunction=m,S.isWindow=x,S.camelCase=X,S.type=w,S.now=Date.now,S.isNumeric=function(e){var t=S.type(e);return("number"===t||"string"===t)&&!isNaN(e-parseFloat(e))},S.trim=function(e){return null==e?"":(e+"").replace(Xt,"")},"function"==typeof define&&define.amd&&define("jquery",[],function(){return S});var Vt=C.jQuery,Gt=C.$;return S.noConflict=function(e){return C.$===S&&(C.$=Gt),e&&C.jQuery===S&&(C.jQuery=Vt),S},"undefined"==typeof e&&(C.jQuery=C.$=S),S});
+/*! jQuery UI - v1.13.2 - 2022-08-01
+* http://jqueryui.com
+* Includes: widget.js, position.js, data.js, disable-selection.js, focusable.js, form-reset-mixin.js, jquery-patch.js, keycode.js, labels.js, scroll-parent.js, tabbable.js, unique-id.js, widgets/resizable.js, widgets/mouse.js
+* Copyright jQuery Foundation and other contributors; Licensed MIT */
+
+!function(t){"use strict";"function"==typeof define&&define.amd?define(["jquery"],t):t(jQuery)}(function(y){"use strict";y.ui=y.ui||{};y.ui.version="1.13.2";var n,i=0,h=Array.prototype.hasOwnProperty,a=Array.prototype.slice;y.cleanData=(n=y.cleanData,function(t){for(var e,i,s=0;null!=(i=t[s]);s++)(e=y._data(i,"events"))&&e.remove&&y(i).triggerHandler("remove");n(t)}),y.widget=function(t,i,e){var s,n,o,h={},a=t.split(".")[0],r=a+"-"+(t=t.split(".")[1]);return e||(e=i,i=y.Widget),Array.isArray(e)&&(e=y.extend.apply(null,[{}].concat(e))),y.expr.pseudos[r.toLowerCase()]=function(t){return!!y.data(t,r)},y[a]=y[a]||{},s=y[a][t],n=y[a][t]=function(t,e){if(!this||!this._createWidget)return new n(t,e);arguments.length&&this._createWidget(t,e)},y.extend(n,s,{version:e.version,_proto:y.extend({},e),_childConstructors:[]}),(o=new i).options=y.widget.extend({},o.options),y.each(e,function(e,s){function n(){return i.prototype[e].apply(this,arguments)}function o(t){return i.prototype[e].apply(this,t)}h[e]="function"==typeof s?function(){var t,e=this._super,i=this._superApply;return this._super=n,this._superApply=o,t=s.apply(this,arguments),this._super=e,this._superApply=i,t}:s}),n.prototype=y.widget.extend(o,{widgetEventPrefix:s&&o.widgetEventPrefix||t},h,{constructor:n,namespace:a,widgetName:t,widgetFullName:r}),s?(y.each(s._childConstructors,function(t,e){var i=e.prototype;y.widget(i.namespace+"."+i.widgetName,n,e._proto)}),delete s._childConstructors):i._childConstructors.push(n),y.widget.bridge(t,n),n},y.widget.extend=function(t){for(var e,i,s=a.call(arguments,1),n=0,o=s.length;n<o;n++)for(e in s[n])i=s[n][e],h.call(s[n],e)&&void 0!==i&&(y.isPlainObject(i)?t[e]=y.isPlainObject(t[e])?y.widget.extend({},t[e],i):y.widget.extend({},i):t[e]=i);return t},y.widget.bridge=function(o,e){var h=e.prototype.widgetFullName||o;y.fn[o]=function(i){var t="string"==typeof i,s=a.call(arguments,1),n=this;return t?this.length||"instance"!==i?this.each(function(){var t,e=y.data(this,h);return"instance"===i?(n=e,!1):e?"function"!=typeof e[i]||"_"===i.charAt(0)?y.error("no such method '"+i+"' for "+o+" widget instance"):(t=e[i].apply(e,s))!==e&&void 0!==t?(n=t&&t.jquery?n.pushStack(t.get()):t,!1):void 0:y.error("cannot call methods on "+o+" prior to initialization; attempted to call method '"+i+"'")}):n=void 0:(s.length&&(i=y.widget.extend.apply(null,[i].concat(s))),this.each(function(){var t=y.data(this,h);t?(t.option(i||{}),t._init&&t._init()):y.data(this,h,new e(i,this))})),n}},y.Widget=function(){},y.Widget._childConstructors=[],y.Widget.prototype={widgetName:"widget",widgetEventPrefix:"",defaultElement:"<div>",options:{classes:{},disabled:!1,create:null},_createWidget:function(t,e){e=y(e||this.defaultElement||this)[0],this.element=y(e),this.uuid=i++,this.eventNamespace="."+this.widgetName+this.uuid,this.bindings=y(),this.hoverable=y(),this.focusable=y(),this.classesElementLookup={},e!==this&&(y.data(e,this.widgetFullName,this),this._on(!0,this.element,{remove:function(t){t.target===e&&this.destroy()}}),this.document=y(e.style?e.ownerDocument:e.document||e),this.window=y(this.document[0].defaultView||this.document[0].parentWindow)),this.options=y.widget.extend({},this.options,this._getCreateOptions(),t),this._create(),this.options.disabled&&this._setOptionDisabled(this.options.disabled),this._trigger("create",null,this._getCreateEventData()),this._init()},_getCreateOptions:function(){return{}},_getCreateEventData:y.noop,_create:y.noop,_init:y.noop,destroy:function(){var i=this;this._destroy(),y.each(this.classesElementLookup,function(t,e){i._removeClass(e,t)}),this.element.off(this.eventNamespace).removeData(this.widgetFullName),this.widget().off(this.eventNamespace).removeAttr("aria-disabled"),this.bindings.off(this.eventNamespace)},_destroy:y.noop,widget:function(){return this.element},option:function(t,e){var i,s,n,o=t;if(0===arguments.length)return y.widget.extend({},this.options);if("string"==typeof t)if(o={},t=(i=t.split(".")).shift(),i.length){for(s=o[t]=y.widget.extend({},this.options[t]),n=0;n<i.length-1;n++)s[i[n]]=s[i[n]]||{},s=s[i[n]];if(t=i.pop(),1===arguments.length)return void 0===s[t]?null:s[t];s[t]=e}else{if(1===arguments.length)return void 0===this.options[t]?null:this.options[t];o[t]=e}return this._setOptions(o),this},_setOptions:function(t){for(var e in t)this._setOption(e,t[e]);return this},_setOption:function(t,e){return"classes"===t&&this._setOptionClasses(e),this.options[t]=e,"disabled"===t&&this._setOptionDisabled(e),this},_setOptionClasses:function(t){var e,i,s;for(e in t)s=this.classesElementLookup[e],t[e]!==this.options.classes[e]&&s&&s.length&&(i=y(s.get()),this._removeClass(s,e),i.addClass(this._classes({element:i,keys:e,classes:t,add:!0})))},_setOptionDisabled:function(t){this._toggleClass(this.widget(),this.widgetFullName+"-disabled",null,!!t),t&&(this._removeClass(this.hoverable,null,"ui-state-hover"),this._removeClass(this.focusable,null,"ui-state-focus"))},enable:function(){return this._setOptions({disabled:!1})},disable:function(){return this._setOptions({disabled:!0})},_classes:function(n){var o=[],h=this;function t(t,e){for(var i,s=0;s<t.length;s++)i=h.classesElementLookup[t[s]]||y(),i=n.add?(function(){var i=[];n.element.each(function(t,e){y.map(h.classesElementLookup,function(t){return t}).some(function(t){return t.is(e)})||i.push(e)}),h._on(y(i),{remove:"_untrackClassesElement"})}(),y(y.uniqueSort(i.get().concat(n.element.get())))):y(i.not(n.element).get()),h.classesElementLookup[t[s]]=i,o.push(t[s]),e&&n.classes[t[s]]&&o.push(n.classes[t[s]])}return(n=y.extend({element:this.element,classes:this.options.classes||{}},n)).keys&&t(n.keys.match(/\S+/g)||[],!0),n.extra&&t(n.extra.match(/\S+/g)||[]),o.join(" ")},_untrackClassesElement:function(i){var s=this;y.each(s.classesElementLookup,function(t,e){-1!==y.inArray(i.target,e)&&(s.classesElementLookup[t]=y(e.not(i.target).get()))}),this._off(y(i.target))},_removeClass:function(t,e,i){return this._toggleClass(t,e,i,!1)},_addClass:function(t,e,i){return this._toggleClass(t,e,i,!0)},_toggleClass:function(t,e,i,s){var n="string"==typeof t||null===t,i={extra:n?e:i,keys:n?t:e,element:n?this.element:t,add:s="boolean"==typeof s?s:i};return i.element.toggleClass(this._classes(i),s),this},_on:function(n,o,t){var h,a=this;"boolean"!=typeof n&&(t=o,o=n,n=!1),t?(o=h=y(o),this.bindings=this.bindings.add(o)):(t=o,o=this.element,h=this.widget()),y.each(t,function(t,e){function i(){if(n||!0!==a.options.disabled&&!y(this).hasClass("ui-state-disabled"))return("string"==typeof e?a[e]:e).apply(a,arguments)}"string"!=typeof e&&(i.guid=e.guid=e.guid||i.guid||y.guid++);var s=t.match(/^([\w:-]*)\s*(.*)$/),t=s[1]+a.eventNamespace,s=s[2];s?h.on(t,s,i):o.on(t,i)})},_off:function(t,e){e=(e||"").split(" ").join(this.eventNamespace+" ")+this.eventNamespace,t.off(e),this.bindings=y(this.bindings.not(t).get()),this.focusable=y(this.focusable.not(t).get()),this.hoverable=y(this.hoverable.not(t).get())},_delay:function(t,e){var i=this;return setTimeout(function(){return("string"==typeof t?i[t]:t).apply(i,arguments)},e||0)},_hoverable:function(t){this.hoverable=this.hoverable.add(t),this._on(t,{mouseenter:function(t){this._addClass(y(t.currentTarget),null,"ui-state-hover")},mouseleave:function(t){this._removeClass(y(t.currentTarget),null,"ui-state-hover")}})},_focusable:function(t){this.focusable=this.focusable.add(t),this._on(t,{focusin:function(t){this._addClass(y(t.currentTarget),null,"ui-state-focus")},focusout:function(t){this._removeClass(y(t.currentTarget),null,"ui-state-focus")}})},_trigger:function(t,e,i){var s,n,o=this.options[t];if(i=i||{},(e=y.Event(e)).type=(t===this.widgetEventPrefix?t:this.widgetEventPrefix+t).toLowerCase(),e.target=this.element[0],n=e.originalEvent)for(s in n)s in e||(e[s]=n[s]);return this.element.trigger(e,i),!("function"==typeof o&&!1===o.apply(this.element[0],[e].concat(i))||e.isDefaultPrevented())}},y.each({show:"fadeIn",hide:"fadeOut"},function(o,h){y.Widget.prototype["_"+o]=function(e,t,i){var s,n=(t="string"==typeof t?{effect:t}:t)?!0!==t&&"number"!=typeof t&&t.effect||h:o;"number"==typeof(t=t||{})?t={duration:t}:!0===t&&(t={}),s=!y.isEmptyObject(t),t.complete=i,t.delay&&e.delay(t.delay),s&&y.effects&&y.effects.effect[n]?e[o](t):n!==o&&e[n]?e[n](t.duration,t.easing,i):e.queue(function(t){y(this)[o](),i&&i.call(e[0]),t()})}});var s,x,D,o,r,l,u,p,W;y.widget;function E(t,e,i){return[parseFloat(t[0])*(p.test(t[0])?e/100:1),parseFloat(t[1])*(p.test(t[1])?i/100:1)]}function H(t,e){return parseInt(y.css(t,e),10)||0}function S(t){return null!=t&&t===t.window}x=Math.max,D=Math.abs,o=/left|center|right/,r=/top|center|bottom/,l=/[\+\-]\d+(\.[\d]+)?%?/,u=/^\w+/,p=/%$/,W=y.fn.position,y.position={scrollbarWidth:function(){if(void 0!==s)return s;var t,e=y("<div style='display:block;position:absolute;width:200px;height:200px;overflow:hidden;'><div style='height:300px;width:auto;'></div></div>"),i=e.children()[0];return y("body").append(e),t=i.offsetWidth,e.css("overflow","scroll"),t===(i=i.offsetWidth)&&(i=e[0].clientWidth),e.remove(),s=t-i},getScrollInfo:function(t){var e=t.isWindow||t.isDocument?"":t.element.css("overflow-x"),i=t.isWindow||t.isDocument?"":t.element.css("overflow-y"),e="scroll"===e||"auto"===e&&t.width<t.element[0].scrollWidth;return{width:"scroll"===i||"auto"===i&&t.height<t.element[0].scrollHeight?y.position.scrollbarWidth():0,height:e?y.position.scrollbarWidth():0}},getWithinInfo:function(t){var e=y(t||window),i=S(e[0]),s=!!e[0]&&9===e[0].nodeType;return{element:e,isWindow:i,isDocument:s,offset:!i&&!s?y(t).offset():{left:0,top:0},scrollLeft:e.scrollLeft(),scrollTop:e.scrollTop(),width:e.outerWidth(),height:e.outerHeight()}}},y.fn.position=function(p){if(!p||!p.of)return W.apply(this,arguments);var d,c,f,g,m,t,_="string"==typeof(p=y.extend({},p)).of?y(document).find(p.of):y(p.of),w=y.position.getWithinInfo(p.within),v=y.position.getScrollInfo(w),b=(p.collision||"flip").split(" "),z={},e=9===(t=(e=_)[0]).nodeType?{width:e.width(),height:e.height(),offset:{top:0,left:0}}:S(t)?{width:e.width(),height:e.height(),offset:{top:e.scrollTop(),left:e.scrollLeft()}}:t.preventDefault?{width:0,height:0,offset:{top:t.pageY,left:t.pageX}}:{width:e.outerWidth(),height:e.outerHeight(),offset:e.offset()};return _[0].preventDefault&&(p.at="left top"),c=e.width,f=e.height,m=y.extend({},g=e.offset),y.each(["my","at"],function(){var t,e,i=(p[this]||"").split(" ");(i=1===i.length?o.test(i[0])?i.concat(["center"]):r.test(i[0])?["center"].concat(i):["center","center"]:i)[0]=o.test(i[0])?i[0]:"center",i[1]=r.test(i[1])?i[1]:"center",t=l.exec(i[0]),e=l.exec(i[1]),z[this]=[t?t[0]:0,e?e[0]:0],p[this]=[u.exec(i[0])[0],u.exec(i[1])[0]]}),1===b.length&&(b[1]=b[0]),"right"===p.at[0]?m.left+=c:"center"===p.at[0]&&(m.left+=c/2),"bottom"===p.at[1]?m.top+=f:"center"===p.at[1]&&(m.top+=f/2),d=E(z.at,c,f),m.left+=d[0],m.top+=d[1],this.each(function(){var i,t,h=y(this),a=h.outerWidth(),r=h.outerHeight(),e=H(this,"marginLeft"),s=H(this,"marginTop"),n=a+e+H(this,"marginRight")+v.width,o=r+s+H(this,"marginBottom")+v.height,l=y.extend({},m),u=E(z.my,h.outerWidth(),h.outerHeight());"right"===p.my[0]?l.left-=a:"center"===p.my[0]&&(l.left-=a/2),"bottom"===p.my[1]?l.top-=r:"center"===p.my[1]&&(l.top-=r/2),l.left+=u[0],l.top+=u[1],i={marginLeft:e,marginTop:s},y.each(["left","top"],function(t,e){y.ui.position[b[t]]&&y.ui.position[b[t]][e](l,{targetWidth:c,targetHeight:f,elemWidth:a,elemHeight:r,collisionPosition:i,collisionWidth:n,collisionHeight:o,offset:[d[0]+u[0],d[1]+u[1]],my:p.my,at:p.at,within:w,elem:h})}),p.using&&(t=function(t){var e=g.left-l.left,i=e+c-a,s=g.top-l.top,n=s+f-r,o={target:{element:_,left:g.left,top:g.top,width:c,height:f},element:{element:h,left:l.left,top:l.top,width:a,height:r},horizontal:i<0?"left":0<e?"right":"center",vertical:n<0?"top":0<s?"bottom":"middle"};c<a&&D(e+i)<c&&(o.horizontal="center"),f<r&&D(s+n)<f&&(o.vertical="middle"),x(D(e),D(i))>x(D(s),D(n))?o.important="horizontal":o.important="vertical",p.using.call(this,t,o)}),h.offset(y.extend(l,{using:t}))})},y.ui.position={fit:{left:function(t,e){var i=e.within,s=i.isWindow?i.scrollLeft:i.offset.left,n=i.width,o=t.left-e.collisionPosition.marginLeft,h=s-o,a=o+e.collisionWidth-n-s;e.collisionWidth>n?0<h&&a<=0?(i=t.left+h+e.collisionWidth-n-s,t.left+=h-i):t.left=!(0<a&&h<=0)&&a<h?s+n-e.collisionWidth:s:0<h?t.left+=h:0<a?t.left-=a:t.left=x(t.left-o,t.left)},top:function(t,e){var i=e.within,s=i.isWindow?i.scrollTop:i.offset.top,n=e.within.height,o=t.top-e.collisionPosition.marginTop,h=s-o,a=o+e.collisionHeight-n-s;e.collisionHeight>n?0<h&&a<=0?(i=t.top+h+e.collisionHeight-n-s,t.top+=h-i):t.top=!(0<a&&h<=0)&&a<h?s+n-e.collisionHeight:s:0<h?t.top+=h:0<a?t.top-=a:t.top=x(t.top-o,t.top)}},flip:{left:function(t,e){var i=e.within,s=i.offset.left+i.scrollLeft,n=i.width,o=i.isWindow?i.scrollLeft:i.offset.left,h=t.left-e.collisionPosition.marginLeft,a=h-o,r=h+e.collisionWidth-n-o,l="left"===e.my[0]?-e.elemWidth:"right"===e.my[0]?e.elemWidth:0,i="left"===e.at[0]?e.targetWidth:"right"===e.at[0]?-e.targetWidth:0,h=-2*e.offset[0];a<0?((s=t.left+l+i+h+e.collisionWidth-n-s)<0||s<D(a))&&(t.left+=l+i+h):0<r&&(0<(o=t.left-e.collisionPosition.marginLeft+l+i+h-o)||D(o)<r)&&(t.left+=l+i+h)},top:function(t,e){var i=e.within,s=i.offset.top+i.scrollTop,n=i.height,o=i.isWindow?i.scrollTop:i.offset.top,h=t.top-e.collisionPosition.marginTop,a=h-o,r=h+e.collisionHeight-n-o,l="top"===e.my[1]?-e.elemHeight:"bottom"===e.my[1]?e.elemHeight:0,i="top"===e.at[1]?e.targetHeight:"bottom"===e.at[1]?-e.targetHeight:0,h=-2*e.offset[1];a<0?((s=t.top+l+i+h+e.collisionHeight-n-s)<0||s<D(a))&&(t.top+=l+i+h):0<r&&(0<(o=t.top-e.collisionPosition.marginTop+l+i+h-o)||D(o)<r)&&(t.top+=l+i+h)}},flipfit:{left:function(){y.ui.position.flip.left.apply(this,arguments),y.ui.position.fit.left.apply(this,arguments)},top:function(){y.ui.position.flip.top.apply(this,arguments),y.ui.position.fit.top.apply(this,arguments)}}};var t;y.ui.position,y.extend(y.expr.pseudos,{data:y.expr.createPseudo?y.expr.createPseudo(function(e){return function(t){return!!y.data(t,e)}}):function(t,e,i){return!!y.data(t,i[3])}}),y.fn.extend({disableSelection:(t="onselectstart"in document.createElement("div")?"selectstart":"mousedown",function(){return this.on(t+".ui-disableSelection",function(t){t.preventDefault()})}),enableSelection:function(){return this.off(".ui-disableSelection")}});y.ui.focusable=function(t,e){var i,s,n,o,h=t.nodeName.toLowerCase();return"area"===h?(s=(i=t.parentNode).name,!(!t.href||!s||"map"!==i.nodeName.toLowerCase())&&(0<(s=y("img[usemap='#"+s+"']")).length&&s.is(":visible"))):(/^(input|select|textarea|button|object)$/.test(h)?(n=!t.disabled)&&(o=y(t).closest("fieldset")[0])&&(n=!o.disabled):n="a"===h&&t.href||e,n&&y(t).is(":visible")&&function(t){var e=t.css("visibility");for(;"inherit"===e;)t=t.parent(),e=t.css("visibility");return"visible"===e}(y(t)))},y.extend(y.expr.pseudos,{focusable:function(t){return y.ui.focusable(t,null!=y.attr(t,"tabindex"))}});var e,d;y.ui.focusable,y.fn._form=function(){return"string"==typeof this[0].form?this.closest("form"):y(this[0].form)},y.ui.formResetMixin={_formResetHandler:function(){var e=y(this);setTimeout(function(){var t=e.data("ui-form-reset-instances");y.each(t,function(){this.refresh()})})},_bindFormResetHandler:function(){var t;this.form=this.element._form(),this.form.length&&((t=this.form.data("ui-form-reset-instances")||[]).length||this.form.on("reset.ui-form-reset",this._formResetHandler),t.push(this),this.form.data("ui-form-reset-instances",t))},_unbindFormResetHandler:function(){var t;this.form.length&&((t=this.form.data("ui-form-reset-instances")).splice(y.inArray(this,t),1),t.length?this.form.data("ui-form-reset-instances",t):this.form.removeData("ui-form-reset-instances").off("reset.ui-form-reset"))}};y.expr.pseudos||(y.expr.pseudos=y.expr[":"]),y.uniqueSort||(y.uniqueSort=y.unique),y.escapeSelector||(e=/([\0-\x1f\x7f]|^-?\d)|^-$|[^\x80-\uFFFF\w-]/g,d=function(t,e){return e?"\0"===t?"�":t.slice(0,-1)+"\\"+t.charCodeAt(t.length-1).toString(16)+" ":"\\"+t},y.escapeSelector=function(t){return(t+"").replace(e,d)}),y.fn.even&&y.fn.odd||y.fn.extend({even:function(){return this.filter(function(t){return t%2==0})},odd:function(){return this.filter(function(t){return t%2==1})}});y.ui.keyCode={BACKSPACE:8,COMMA:188,DELETE:46,DOWN:40,END:35,ENTER:13,ESCAPE:27,HOME:36,LEFT:37,PAGE_DOWN:34,PAGE_UP:33,PERIOD:190,RIGHT:39,SPACE:32,TAB:9,UP:38},y.fn.labels=function(){var t,e,i;return this.length?this[0].labels&&this[0].labels.length?this.pushStack(this[0].labels):(e=this.eq(0).parents("label"),(t=this.attr("id"))&&(i=(i=this.eq(0).parents().last()).add((i.length?i:this).siblings()),t="label[for='"+y.escapeSelector(t)+"']",e=e.add(i.find(t).addBack(t))),this.pushStack(e)):this.pushStack([])},y.fn.scrollParent=function(t){var e=this.css("position"),i="absolute"===e,s=t?/(auto|scroll|hidden)/:/(auto|scroll)/,t=this.parents().filter(function(){var t=y(this);return(!i||"static"!==t.css("position"))&&s.test(t.css("overflow")+t.css("overflow-y")+t.css("overflow-x"))}).eq(0);return"fixed"!==e&&t.length?t:y(this[0].ownerDocument||document)},y.extend(y.expr.pseudos,{tabbable:function(t){var e=y.attr(t,"tabindex"),i=null!=e;return(!i||0<=e)&&y.ui.focusable(t,i)}}),y.fn.extend({uniqueId:(c=0,function(){return this.each(function(){this.id||(this.id="ui-id-"+ ++c)})}),removeUniqueId:function(){return this.each(function(){/^ui-id-\d+$/.test(this.id)&&y(this).removeAttr("id")})}}),y.ui.ie=!!/msie [\w.]+/.exec(navigator.userAgent.toLowerCase());var c,f=!1;y(document).on("mouseup",function(){f=!1});y.widget("ui.mouse",{version:"1.13.2",options:{cancel:"input, textarea, button, select, option",distance:1,delay:0},_mouseInit:function(){var e=this;this.element.on("mousedown."+this.widgetName,function(t){return e._mouseDown(t)}).on("click."+this.widgetName,function(t){if(!0===y.data(t.target,e.widgetName+".preventClickEvent"))return y.removeData(t.target,e.widgetName+".preventClickEvent"),t.stopImmediatePropagation(),!1}),this.started=!1},_mouseDestroy:function(){this.element.off("."+this.widgetName),this._mouseMoveDelegate&&this.document.off("mousemove."+this.widgetName,this._mouseMoveDelegate).off("mouseup."+this.widgetName,this._mouseUpDelegate)},_mouseDown:function(t){if(!f){this._mouseMoved=!1,this._mouseStarted&&this._mouseUp(t),this._mouseDownEvent=t;var e=this,i=1===t.which,s=!("string"!=typeof this.options.cancel||!t.target.nodeName)&&y(t.target).closest(this.options.cancel).length;return i&&!s&&this._mouseCapture(t)?(this.mouseDelayMet=!this.options.delay,this.mouseDelayMet||(this._mouseDelayTimer=setTimeout(function(){e.mouseDelayMet=!0},this.options.delay)),this._mouseDistanceMet(t)&&this._mouseDelayMet(t)&&(this._mouseStarted=!1!==this._mouseStart(t),!this._mouseStarted)?(t.preventDefault(),!0):(!0===y.data(t.target,this.widgetName+".preventClickEvent")&&y.removeData(t.target,this.widgetName+".preventClickEvent"),this._mouseMoveDelegate=function(t){return e._mouseMove(t)},this._mouseUpDelegate=function(t){return e._mouseUp(t)},this.document.on("mousemove."+this.widgetName,this._mouseMoveDelegate).on("mouseup."+this.widgetName,this._mouseUpDelegate),t.preventDefault(),f=!0)):!0}},_mouseMove:function(t){if(this._mouseMoved){if(y.ui.ie&&(!document.documentMode||document.documentMode<9)&&!t.button)return this._mouseUp(t);if(!t.which)if(t.originalEvent.altKey||t.originalEvent.ctrlKey||t.originalEvent.metaKey||t.originalEvent.shiftKey)this.ignoreMissingWhich=!0;else if(!this.ignoreMissingWhich)return this._mouseUp(t)}return(t.which||t.button)&&(this._mouseMoved=!0),this._mouseStarted?(this._mouseDrag(t),t.preventDefault()):(this._mouseDistanceMet(t)&&this._mouseDelayMet(t)&&(this._mouseStarted=!1!==this._mouseStart(this._mouseDownEvent,t),this._mouseStarted?this._mouseDrag(t):this._mouseUp(t)),!this._mouseStarted)},_mouseUp:function(t){this.document.off("mousemove."+this.widgetName,this._mouseMoveDelegate).off("mouseup."+this.widgetName,this._mouseUpDelegate),this._mouseStarted&&(this._mouseStarted=!1,t.target===this._mouseDownEvent.target&&y.data(t.target,this.widgetName+".preventClickEvent",!0),this._mouseStop(t)),this._mouseDelayTimer&&(clearTimeout(this._mouseDelayTimer),delete this._mouseDelayTimer),this.ignoreMissingWhich=!1,f=!1,t.preventDefault()},_mouseDistanceMet:function(t){return Math.max(Math.abs(this._mouseDownEvent.pageX-t.pageX),Math.abs(this._mouseDownEvent.pageY-t.pageY))>=this.options.distance},_mouseDelayMet:function(){return this.mouseDelayMet},_mouseStart:function(){},_mouseDrag:function(){},_mouseStop:function(){},_mouseCapture:function(){return!0}}),y.ui.plugin={add:function(t,e,i){var s,n=y.ui[t].prototype;for(s in i)n.plugins[s]=n.plugins[s]||[],n.plugins[s].push([e,i[s]])},call:function(t,e,i,s){var n,o=t.plugins[e];if(o&&(s||t.element[0].parentNode&&11!==t.element[0].parentNode.nodeType))for(n=0;n<o.length;n++)t.options[o[n][0]]&&o[n][1].apply(t.element,i)}};y.widget("ui.resizable",y.ui.mouse,{version:"1.13.2",widgetEventPrefix:"resize",options:{alsoResize:!1,animate:!1,animateDuration:"slow",animateEasing:"swing",aspectRatio:!1,autoHide:!1,classes:{"ui-resizable-se":"ui-icon ui-icon-gripsmall-diagonal-se"},containment:!1,ghost:!1,grid:!1,handles:"e,s,se",helper:!1,maxHeight:null,maxWidth:null,minHeight:10,minWidth:10,zIndex:90,resize:null,start:null,stop:null},_num:function(t){return parseFloat(t)||0},_isNumber:function(t){return!isNaN(parseFloat(t))},_hasScroll:function(t,e){if("hidden"===y(t).css("overflow"))return!1;var i=e&&"left"===e?"scrollLeft":"scrollTop",e=!1;if(0<t[i])return!0;try{t[i]=1,e=0<t[i],t[i]=0}catch(t){}return e},_create:function(){var t,e=this.options,i=this;this._addClass("ui-resizable"),y.extend(this,{_aspectRatio:!!e.aspectRatio,aspectRatio:e.aspectRatio,originalElement:this.element,_proportionallyResizeElements:[],_helper:e.helper||e.ghost||e.animate?e.helper||"ui-resizable-helper":null}),this.element[0].nodeName.match(/^(canvas|textarea|input|select|button|img)$/i)&&(this.element.wrap(y("<div class='ui-wrapper'></div>").css({overflow:"hidden",position:this.element.css("position"),width:this.element.outerWidth(),height:this.element.outerHeight(),top:this.element.css("top"),left:this.element.css("left")})),this.element=this.element.parent().data("ui-resizable",this.element.resizable("instance")),this.elementIsWrapper=!0,t={marginTop:this.originalElement.css("marginTop"),marginRight:this.originalElement.css("marginRight"),marginBottom:this.originalElement.css("marginBottom"),marginLeft:this.originalElement.css("marginLeft")},this.element.css(t),this.originalElement.css("margin",0),this.originalResizeStyle=this.originalElement.css("resize"),this.originalElement.css("resize","none"),this._proportionallyResizeElements.push(this.originalElement.css({position:"static",zoom:1,display:"block"})),this.originalElement.css(t),this._proportionallyResize()),this._setupHandles(),e.autoHide&&y(this.element).on("mouseenter",function(){e.disabled||(i._removeClass("ui-resizable-autohide"),i._handles.show())}).on("mouseleave",function(){e.disabled||i.resizing||(i._addClass("ui-resizable-autohide"),i._handles.hide())}),this._mouseInit()},_destroy:function(){this._mouseDestroy(),this._addedHandles.remove();function t(t){y(t).removeData("resizable").removeData("ui-resizable").off(".resizable")}var e;return this.elementIsWrapper&&(t(this.element),e=this.element,this.originalElement.css({position:e.css("position"),width:e.outerWidth(),height:e.outerHeight(),top:e.css("top"),left:e.css("left")}).insertAfter(e),e.remove()),this.originalElement.css("resize",this.originalResizeStyle),t(this.originalElement),this},_setOption:function(t,e){switch(this._super(t,e),t){case"handles":this._removeHandles(),this._setupHandles();break;case"aspectRatio":this._aspectRatio=!!e}},_setupHandles:function(){var t,e,i,s,n,o=this.options,h=this;if(this.handles=o.handles||(y(".ui-resizable-handle",this.element).length?{n:".ui-resizable-n",e:".ui-resizable-e",s:".ui-resizable-s",w:".ui-resizable-w",se:".ui-resizable-se",sw:".ui-resizable-sw",ne:".ui-resizable-ne",nw:".ui-resizable-nw"}:"e,s,se"),this._handles=y(),this._addedHandles=y(),this.handles.constructor===String)for("all"===this.handles&&(this.handles="n,e,s,w,se,sw,ne,nw"),i=this.handles.split(","),this.handles={},e=0;e<i.length;e++)s="ui-resizable-"+(t=String.prototype.trim.call(i[e])),n=y("<div>"),this._addClass(n,"ui-resizable-handle "+s),n.css({zIndex:o.zIndex}),this.handles[t]=".ui-resizable-"+t,this.element.children(this.handles[t]).length||(this.element.append(n),this._addedHandles=this._addedHandles.add(n));this._renderAxis=function(t){var e,i,s;for(e in t=t||this.element,this.handles)this.handles[e].constructor===String?this.handles[e]=this.element.children(this.handles[e]).first().show():(this.handles[e].jquery||this.handles[e].nodeType)&&(this.handles[e]=y(this.handles[e]),this._on(this.handles[e],{mousedown:h._mouseDown})),this.elementIsWrapper&&this.originalElement[0].nodeName.match(/^(textarea|input|select|button)$/i)&&(i=y(this.handles[e],this.element),s=/sw|ne|nw|se|n|s/.test(e)?i.outerHeight():i.outerWidth(),i=["padding",/ne|nw|n/.test(e)?"Top":/se|sw|s/.test(e)?"Bottom":/^e$/.test(e)?"Right":"Left"].join(""),t.css(i,s),this._proportionallyResize()),this._handles=this._handles.add(this.handles[e])},this._renderAxis(this.element),this._handles=this._handles.add(this.element.find(".ui-resizable-handle")),this._handles.disableSelection(),this._handles.on("mouseover",function(){h.resizing||(this.className&&(n=this.className.match(/ui-resizable-(se|sw|ne|nw|n|e|s|w)/i)),h.axis=n&&n[1]?n[1]:"se")}),o.autoHide&&(this._handles.hide(),this._addClass("ui-resizable-autohide"))},_removeHandles:function(){this._addedHandles.remove()},_mouseCapture:function(t){var e,i,s=!1;for(e in this.handles)(i=y(this.handles[e])[0])!==t.target&&!y.contains(i,t.target)||(s=!0);return!this.options.disabled&&s},_mouseStart:function(t){var e,i,s=this.options,n=this.element;return this.resizing=!0,this._renderProxy(),e=this._num(this.helper.css("left")),i=this._num(this.helper.css("top")),s.containment&&(e+=y(s.containment).scrollLeft()||0,i+=y(s.containment).scrollTop()||0),this.offset=this.helper.offset(),this.position={left:e,top:i},this.size=this._helper?{width:this.helper.width(),height:this.helper.height()}:{width:n.width(),height:n.height()},this.originalSize=this._helper?{width:n.outerWidth(),height:n.outerHeight()}:{width:n.width(),height:n.height()},this.sizeDiff={width:n.outerWidth()-n.width(),height:n.outerHeight()-n.height()},this.originalPosition={left:e,top:i},this.originalMousePosition={left:t.pageX,top:t.pageY},this.aspectRatio="number"==typeof s.aspectRatio?s.aspectRatio:this.originalSize.width/this.originalSize.height||1,s=y(".ui-resizable-"+this.axis).css("cursor"),y("body").css("cursor","auto"===s?this.axis+"-resize":s),this._addClass("ui-resizable-resizing"),this._propagate("start",t),!0},_mouseDrag:function(t){var e=this.originalMousePosition,i=this.axis,s=t.pageX-e.left||0,e=t.pageY-e.top||0,i=this._change[i];return this._updatePrevProperties(),i&&(e=i.apply(this,[t,s,e]),this._updateVirtualBoundaries(t.shiftKey),(this._aspectRatio||t.shiftKey)&&(e=this._updateRatio(e,t)),e=this._respectSize(e,t),this._updateCache(e),this._propagate("resize",t),e=this._applyChanges(),!this._helper&&this._proportionallyResizeElements.length&&this._proportionallyResize(),y.isEmptyObject(e)||(this._updatePrevProperties(),this._trigger("resize",t,this.ui()),this._applyChanges())),!1},_mouseStop:function(t){this.resizing=!1;var e,i,s,n=this.options,o=this;return this._helper&&(s=(e=(i=this._proportionallyResizeElements).length&&/textarea/i.test(i[0].nodeName))&&this._hasScroll(i[0],"left")?0:o.sizeDiff.height,i=e?0:o.sizeDiff.width,e={width:o.helper.width()-i,height:o.helper.height()-s},i=parseFloat(o.element.css("left"))+(o.position.left-o.originalPosition.left)||null,s=parseFloat(o.element.css("top"))+(o.position.top-o.originalPosition.top)||null,n.animate||this.element.css(y.extend(e,{top:s,left:i})),o.helper.height(o.size.height),o.helper.width(o.size.width),this._helper&&!n.animate&&this._proportionallyResize()),y("body").css("cursor","auto"),this._removeClass("ui-resizable-resizing"),this._propagate("stop",t),this._helper&&this.helper.remove(),!1},_updatePrevProperties:function(){this.prevPosition={top:this.position.top,left:this.position.left},this.prevSize={width:this.size.width,height:this.size.height}},_applyChanges:function(){var t={};return this.position.top!==this.prevPosition.top&&(t.top=this.position.top+"px"),this.position.left!==this.prevPosition.left&&(t.left=this.position.left+"px"),this.size.width!==this.prevSize.width&&(t.width=this.size.width+"px"),this.size.height!==this.prevSize.height&&(t.height=this.size.height+"px"),this.helper.css(t),t},_updateVirtualBoundaries:function(t){var e,i,s=this.options,n={minWidth:this._isNumber(s.minWidth)?s.minWidth:0,maxWidth:this._isNumber(s.maxWidth)?s.maxWidth:1/0,minHeight:this._isNumber(s.minHeight)?s.minHeight:0,maxHeight:this._isNumber(s.maxHeight)?s.maxHeight:1/0};(this._aspectRatio||t)&&(e=n.minHeight*this.aspectRatio,i=n.minWidth/this.aspectRatio,s=n.maxHeight*this.aspectRatio,t=n.maxWidth/this.aspectRatio,e>n.minWidth&&(n.minWidth=e),i>n.minHeight&&(n.minHeight=i),s<n.maxWidth&&(n.maxWidth=s),t<n.maxHeight&&(n.maxHeight=t)),this._vBoundaries=n},_updateCache:function(t){this.offset=this.helper.offset(),this._isNumber(t.left)&&(this.position.left=t.left),this._isNumber(t.top)&&(this.position.top=t.top),this._isNumber(t.height)&&(this.size.height=t.height),this._isNumber(t.width)&&(this.size.width=t.width)},_updateRatio:function(t){var e=this.position,i=this.size,s=this.axis;return this._isNumber(t.height)?t.width=t.height*this.aspectRatio:this._isNumber(t.width)&&(t.height=t.width/this.aspectRatio),"sw"===s&&(t.left=e.left+(i.width-t.width),t.top=null),"nw"===s&&(t.top=e.top+(i.height-t.height),t.left=e.left+(i.width-t.width)),t},_respectSize:function(t){var e=this._vBoundaries,i=this.axis,s=this._isNumber(t.width)&&e.maxWidth&&e.maxWidth<t.width,n=this._isNumber(t.height)&&e.maxHeight&&e.maxHeight<t.height,o=this._isNumber(t.width)&&e.minWidth&&e.minWidth>t.width,h=this._isNumber(t.height)&&e.minHeight&&e.minHeight>t.height,a=this.originalPosition.left+this.originalSize.width,r=this.originalPosition.top+this.originalSize.height,l=/sw|nw|w/.test(i),i=/nw|ne|n/.test(i);return o&&(t.width=e.minWidth),h&&(t.height=e.minHeight),s&&(t.width=e.maxWidth),n&&(t.height=e.maxHeight),o&&l&&(t.left=a-e.minWidth),s&&l&&(t.left=a-e.maxWidth),h&&i&&(t.top=r-e.minHeight),n&&i&&(t.top=r-e.maxHeight),t.width||t.height||t.left||!t.top?t.width||t.height||t.top||!t.left||(t.left=null):t.top=null,t},_getPaddingPlusBorderDimensions:function(t){for(var e=0,i=[],s=[t.css("borderTopWidth"),t.css("borderRightWidth"),t.css("borderBottomWidth"),t.css("borderLeftWidth")],n=[t.css("paddingTop"),t.css("paddingRight"),t.css("paddingBottom"),t.css("paddingLeft")];e<4;e++)i[e]=parseFloat(s[e])||0,i[e]+=parseFloat(n[e])||0;return{height:i[0]+i[2],width:i[1]+i[3]}},_proportionallyResize:function(){if(this._proportionallyResizeElements.length)for(var t,e=0,i=this.helper||this.element;e<this._proportionallyResizeElements.length;e++)t=this._proportionallyResizeElements[e],this.outerDimensions||(this.outerDimensions=this._getPaddingPlusBorderDimensions(t)),t.css({height:i.height()-this.outerDimensions.height||0,width:i.width()-this.outerDimensions.width||0})},_renderProxy:function(){var t=this.element,e=this.options;this.elementOffset=t.offset(),this._helper?(this.helper=this.helper||y("<div></div>").css({overflow:"hidden"}),this._addClass(this.helper,this._helper),this.helper.css({width:this.element.outerWidth(),height:this.element.outerHeight(),position:"absolute",left:this.elementOffset.left+"px",top:this.elementOffset.top+"px",zIndex:++e.zIndex}),this.helper.appendTo("body").disableSelection()):this.helper=this.element},_change:{e:function(t,e){return{width:this.originalSize.width+e}},w:function(t,e){var i=this.originalSize;return{left:this.originalPosition.left+e,width:i.width-e}},n:function(t,e,i){var s=this.originalSize;return{top:this.originalPosition.top+i,height:s.height-i}},s:function(t,e,i){return{height:this.originalSize.height+i}},se:function(t,e,i){return y.extend(this._change.s.apply(this,arguments),this._change.e.apply(this,[t,e,i]))},sw:function(t,e,i){return y.extend(this._change.s.apply(this,arguments),this._change.w.apply(this,[t,e,i]))},ne:function(t,e,i){return y.extend(this._change.n.apply(this,arguments),this._change.e.apply(this,[t,e,i]))},nw:function(t,e,i){return y.extend(this._change.n.apply(this,arguments),this._change.w.apply(this,[t,e,i]))}},_propagate:function(t,e){y.ui.plugin.call(this,t,[e,this.ui()]),"resize"!==t&&this._trigger(t,e,this.ui())},plugins:{},ui:function(){return{originalElement:this.originalElement,element:this.element,helper:this.helper,position:this.position,size:this.size,originalSize:this.originalSize,originalPosition:this.originalPosition}}}),y.ui.plugin.add("resizable","animate",{stop:function(e){var i=y(this).resizable("instance"),t=i.options,s=i._proportionallyResizeElements,n=s.length&&/textarea/i.test(s[0].nodeName),o=n&&i._hasScroll(s[0],"left")?0:i.sizeDiff.height,h=n?0:i.sizeDiff.width,n={width:i.size.width-h,height:i.size.height-o},h=parseFloat(i.element.css("left"))+(i.position.left-i.originalPosition.left)||null,o=parseFloat(i.element.css("top"))+(i.position.top-i.originalPosition.top)||null;i.element.animate(y.extend(n,o&&h?{top:o,left:h}:{}),{duration:t.animateDuration,easing:t.animateEasing,step:function(){var t={width:parseFloat(i.element.css("width")),height:parseFloat(i.element.css("height")),top:parseFloat(i.element.css("top")),left:parseFloat(i.element.css("left"))};s&&s.length&&y(s[0]).css({width:t.width,height:t.height}),i._updateCache(t),i._propagate("resize",e)}})}}),y.ui.plugin.add("resizable","containment",{start:function(){var i,s,n=y(this).resizable("instance"),t=n.options,e=n.element,o=t.containment,h=o instanceof y?o.get(0):/parent/.test(o)?e.parent().get(0):o;h&&(n.containerElement=y(h),/document/.test(o)||o===document?(n.containerOffset={left:0,top:0},n.containerPosition={left:0,top:0},n.parentData={element:y(document),left:0,top:0,width:y(document).width(),height:y(document).height()||document.body.parentNode.scrollHeight}):(i=y(h),s=[],y(["Top","Right","Left","Bottom"]).each(function(t,e){s[t]=n._num(i.css("padding"+e))}),n.containerOffset=i.offset(),n.containerPosition=i.position(),n.containerSize={height:i.innerHeight()-s[3],width:i.innerWidth()-s[1]},t=n.containerOffset,e=n.containerSize.height,o=n.containerSize.width,o=n._hasScroll(h,"left")?h.scrollWidth:o,e=n._hasScroll(h)?h.scrollHeight:e,n.parentData={element:h,left:t.left,top:t.top,width:o,height:e}))},resize:function(t){var e=y(this).resizable("instance"),i=e.options,s=e.containerOffset,n=e.position,o=e._aspectRatio||t.shiftKey,h={top:0,left:0},a=e.containerElement,t=!0;a[0]!==document&&/static/.test(a.css("position"))&&(h=s),n.left<(e._helper?s.left:0)&&(e.size.width=e.size.width+(e._helper?e.position.left-s.left:e.position.left-h.left),o&&(e.size.height=e.size.width/e.aspectRatio,t=!1),e.position.left=i.helper?s.left:0),n.top<(e._helper?s.top:0)&&(e.size.height=e.size.height+(e._helper?e.position.top-s.top:e.position.top),o&&(e.size.width=e.size.height*e.aspectRatio,t=!1),e.position.top=e._helper?s.top:0),i=e.containerElement.get(0)===e.element.parent().get(0),n=/relative|absolute/.test(e.containerElement.css("position")),i&&n?(e.offset.left=e.parentData.left+e.position.left,e.offset.top=e.parentData.top+e.position.top):(e.offset.left=e.element.offset().left,e.offset.top=e.element.offset().top),n=Math.abs(e.sizeDiff.width+(e._helper?e.offset.left-h.left:e.offset.left-s.left)),s=Math.abs(e.sizeDiff.height+(e._helper?e.offset.top-h.top:e.offset.top-s.top)),n+e.size.width>=e.parentData.width&&(e.size.width=e.parentData.width-n,o&&(e.size.height=e.size.width/e.aspectRatio,t=!1)),s+e.size.height>=e.parentData.height&&(e.size.height=e.parentData.height-s,o&&(e.size.width=e.size.height*e.aspectRatio,t=!1)),t||(e.position.left=e.prevPosition.left,e.position.top=e.prevPosition.top,e.size.width=e.prevSize.width,e.size.height=e.prevSize.height)},stop:function(){var t=y(this).resizable("instance"),e=t.options,i=t.containerOffset,s=t.containerPosition,n=t.containerElement,o=y(t.helper),h=o.offset(),a=o.outerWidth()-t.sizeDiff.width,o=o.outerHeight()-t.sizeDiff.height;t._helper&&!e.animate&&/relative/.test(n.css("position"))&&y(this).css({left:h.left-s.left-i.left,width:a,height:o}),t._helper&&!e.animate&&/static/.test(n.css("position"))&&y(this).css({left:h.left-s.left-i.left,width:a,height:o})}}),y.ui.plugin.add("resizable","alsoResize",{start:function(){var t=y(this).resizable("instance").options;y(t.alsoResize).each(function(){var t=y(this);t.data("ui-resizable-alsoresize",{width:parseFloat(t.width()),height:parseFloat(t.height()),left:parseFloat(t.css("left")),top:parseFloat(t.css("top"))})})},resize:function(t,i){var e=y(this).resizable("instance"),s=e.options,n=e.originalSize,o=e.originalPosition,h={height:e.size.height-n.height||0,width:e.size.width-n.width||0,top:e.position.top-o.top||0,left:e.position.left-o.left||0};y(s.alsoResize).each(function(){var t=y(this),s=y(this).data("ui-resizable-alsoresize"),n={},e=t.parents(i.originalElement[0]).length?["width","height"]:["width","height","top","left"];y.each(e,function(t,e){var i=(s[e]||0)+(h[e]||0);i&&0<=i&&(n[e]=i||null)}),t.css(n)})},stop:function(){y(this).removeData("ui-resizable-alsoresize")}}),y.ui.plugin.add("resizable","ghost",{start:function(){var t=y(this).resizable("instance"),e=t.size;t.ghost=t.originalElement.clone(),t.ghost.css({opacity:.25,display:"block",position:"relative",height:e.height,width:e.width,margin:0,left:0,top:0}),t._addClass(t.ghost,"ui-resizable-ghost"),!1!==y.uiBackCompat&&"string"==typeof t.options.ghost&&t.ghost.addClass(this.options.ghost),t.ghost.appendTo(t.helper)},resize:function(){var t=y(this).resizable("instance");t.ghost&&t.ghost.css({position:"relative",height:t.size.height,width:t.size.width})},stop:function(){var t=y(this).resizable("instance");t.ghost&&t.helper&&t.helper.get(0).removeChild(t.ghost.get(0))}}),y.ui.plugin.add("resizable","grid",{resize:function(){var t,e=y(this).resizable("instance"),i=e.options,s=e.size,n=e.originalSize,o=e.originalPosition,h=e.axis,a="number"==typeof i.grid?[i.grid,i.grid]:i.grid,r=a[0]||1,l=a[1]||1,u=Math.round((s.width-n.width)/r)*r,p=Math.round((s.height-n.height)/l)*l,d=n.width+u,c=n.height+p,f=i.maxWidth&&i.maxWidth<d,g=i.maxHeight&&i.maxHeight<c,m=i.minWidth&&i.minWidth>d,s=i.minHeight&&i.minHeight>c;i.grid=a,m&&(d+=r),s&&(c+=l),f&&(d-=r),g&&(c-=l),/^(se|s|e)$/.test(h)?(e.size.width=d,e.size.height=c):/^(ne)$/.test(h)?(e.size.width=d,e.size.height=c,e.position.top=o.top-p):/^(sw)$/.test(h)?(e.size.width=d,e.size.height=c,e.position.left=o.left-u):((c-l<=0||d-r<=0)&&(t=e._getPaddingPlusBorderDimensions(this)),0<c-l?(e.size.height=c,e.position.top=o.top-p):(c=l-t.height,e.size.height=c,e.position.top=o.top+n.height-c),0<d-r?(e.size.width=d,e.position.left=o.left-u):(d=r-t.width,e.size.width=d,e.position.left=o.left+n.width-d))}});y.ui.resizable});/**
+ * Copyright (c) 2007 Ariel Flesler - aflesler ○ gmail • com | https://github.com/flesler
+ * Licensed under MIT
+ * @author Ariel Flesler
+ * @version 2.1.2
+ */
+;(function(f){"use strict";"function"===typeof define&&define.amd?define(["jquery"],f):"undefined"!==typeof module&&module.exports?module.exports=f(require("jquery")):f(jQuery)})(function($){"use strict";function n(a){return!a.nodeName||-1!==$.inArray(a.nodeName.toLowerCase(),["iframe","#document","html","body"])}function h(a){return $.isFunction(a)||$.isPlainObject(a)?a:{top:a,left:a}}var p=$.scrollTo=function(a,d,b){return $(window).scrollTo(a,d,b)};p.defaults={axis:"xy",duration:0,limit:!0};$.fn.scrollTo=function(a,d,b){"object"=== typeof d&&(b=d,d=0);"function"===typeof b&&(b={onAfter:b});"max"===a&&(a=9E9);b=$.extend({},p.defaults,b);d=d||b.duration;var u=b.queue&&1<b.axis.length;u&&(d/=2);b.offset=h(b.offset);b.over=h(b.over);return this.each(function(){function k(a){var k=$.extend({},b,{queue:!0,duration:d,complete:a&&function(){a.call(q,e,b)}});r.animate(f,k)}if(null!==a){var l=n(this),q=l?this.contentWindow||window:this,r=$(q),e=a,f={},t;switch(typeof e){case "number":case "string":if(/^([+-]=?)?\d+(\.\d+)?(px|%)?$/.test(e)){e= h(e);break}e=l?$(e):$(e,q);case "object":if(e.length===0)return;if(e.is||e.style)t=(e=$(e)).offset()}var v=$.isFunction(b.offset)&&b.offset(q,e)||b.offset;$.each(b.axis.split(""),function(a,c){var d="x"===c?"Left":"Top",m=d.toLowerCase(),g="scroll"+d,h=r[g](),n=p.max(q,c);t?(f[g]=t[m]+(l?0:h-r.offset()[m]),b.margin&&(f[g]-=parseInt(e.css("margin"+d),10)||0,f[g]-=parseInt(e.css("border"+d+"Width"),10)||0),f[g]+=v[m]||0,b.over[m]&&(f[g]+=e["x"===c?"width":"height"]()*b.over[m])):(d=e[m],f[g]=d.slice&& "%"===d.slice(-1)?parseFloat(d)/100*n:d);b.limit&&/^\d+$/.test(f[g])&&(f[g]=0>=f[g]?0:Math.min(f[g],n));!a&&1<b.axis.length&&(h===f[g]?f={}:u&&(k(b.onAfterFirst),f={}))});k(b.onAfter)}})};p.max=function(a,d){var b="x"===d?"Width":"Height",h="scroll"+b;if(!n(a))return a[h]-$(a)[b.toLowerCase()]();var b="client"+b,k=a.ownerDocument||a.document,l=k.documentElement,k=k.body;return Math.max(l[h],k[h])-Math.min(l[b],k[b])};$.Tween.propHooks.scrollLeft=$.Tween.propHooks.scrollTop={get:function(a){return $(a.elem)[a.prop]()}, set:function(a){var d=this.get(a);if(a.options.interrupt&&a._last&&a._last!==d)return $(a.elem).stop();var b=Math.round(a.now);d!==b&&($(a.elem)[a.prop](b),a._last=this.get(a))}};return p});
+/*!
+ PowerTip v1.3.1 (2018-04-15)
+ https://stevenbenner.github.io/jquery-powertip/
+ Copyright (c) 2018 Steven Benner (http://stevenbenner.com/).
+ Released under MIT license.
+ https://raw.github.com/stevenbenner/jquery-powertip/master/LICENSE.txt
+*/
+(function(root,factory){if(typeof define==="function"&&define.amd){define(["jquery"],factory)}else if(typeof module==="object"&&module.exports){module.exports=factory(require("jquery"))}else{factory(root.jQuery)}})(this,function($){var $document=$(document),$window=$(window),$body=$("body");var DATA_DISPLAYCONTROLLER="displayController",DATA_HASACTIVEHOVER="hasActiveHover",DATA_FORCEDOPEN="forcedOpen",DATA_HASMOUSEMOVE="hasMouseMove",DATA_MOUSEONTOTIP="mouseOnToPopup",DATA_ORIGINALTITLE="originalTitle",DATA_POWERTIP="powertip",DATA_POWERTIPJQ="powertipjq",DATA_POWERTIPTARGET="powertiptarget",EVENT_NAMESPACE=".powertip",RAD2DEG=180/Math.PI,MOUSE_EVENTS=["click","dblclick","mousedown","mouseup","mousemove","mouseover","mouseout","mouseenter","mouseleave","contextmenu"];var session={tooltips:null,isTipOpen:false,isFixedTipOpen:false,isClosing:false,tipOpenImminent:false,activeHover:null,currentX:0,currentY:0,previousX:0,previousY:0,desyncTimeout:null,closeDelayTimeout:null,mouseTrackingActive:false,delayInProgress:false,windowWidth:0,windowHeight:0,scrollTop:0,scrollLeft:0};var Collision={none:0,top:1,bottom:2,left:4,right:8};$.fn.powerTip=function(opts,arg){var targetElements=this,options,tipController;if(!targetElements.length){return targetElements}if($.type(opts)==="string"&&$.powerTip[opts]){return $.powerTip[opts].call(targetElements,targetElements,arg)}options=$.extend({},$.fn.powerTip.defaults,opts);tipController=new TooltipController(options);initTracking();targetElements.each(function elementSetup(){var $this=$(this),dataPowertip=$this.data(DATA_POWERTIP),dataElem=$this.data(DATA_POWERTIPJQ),dataTarget=$this.data(DATA_POWERTIPTARGET),title=$this.attr("title");if(!dataPowertip&&!dataTarget&&!dataElem&&title){$this.data(DATA_POWERTIP,title);$this.data(DATA_ORIGINALTITLE,title);$this.removeAttr("title")}$this.data(DATA_DISPLAYCONTROLLER,new DisplayController($this,options,tipController))});if(!options.manual){$.each(options.openEvents,function(idx,evt){if($.inArray(evt,options.closeEvents)>-1){targetElements.on(evt+EVENT_NAMESPACE,function elementToggle(event){$.powerTip.toggle(this,event)})}else{targetElements.on(evt+EVENT_NAMESPACE,function elementOpen(event){$.powerTip.show(this,event)})}});$.each(options.closeEvents,function(idx,evt){if($.inArray(evt,options.openEvents)<0){targetElements.on(evt+EVENT_NAMESPACE,function elementClose(event){$.powerTip.hide(this,!isMouseEvent(event))})}});targetElements.on("keydown"+EVENT_NAMESPACE,function elementKeyDown(event){if(event.keyCode===27){$.powerTip.hide(this,true)}})}return targetElements};$.fn.powerTip.defaults={fadeInTime:200,fadeOutTime:100,followMouse:false,popupId:"powerTip",popupClass:null,intentSensitivity:7,intentPollInterval:100,closeDelay:100,placement:"n",smartPlacement:false,offset:10,mouseOnToPopup:false,manual:false,openEvents:["mouseenter","focus"],closeEvents:["mouseleave","blur"]};$.fn.powerTip.smartPlacementLists={n:["n","ne","nw","s"],e:["e","ne","se","w","nw","sw","n","s","e"],s:["s","se","sw","n"],w:["w","nw","sw","e","ne","se","n","s","w"],nw:["nw","w","sw","n","s","se","nw"],ne:["ne","e","se","n","s","sw","ne"],sw:["sw","w","nw","s","n","ne","sw"],se:["se","e","ne","s","n","nw","se"],"nw-alt":["nw-alt","n","ne-alt","sw-alt","s","se-alt","w","e"],"ne-alt":["ne-alt","n","nw-alt","se-alt","s","sw-alt","e","w"],"sw-alt":["sw-alt","s","se-alt","nw-alt","n","ne-alt","w","e"],"se-alt":["se-alt","s","sw-alt","ne-alt","n","nw-alt","e","w"]};$.powerTip={show:function apiShowTip(element,event){if(isMouseEvent(event)){trackMouse(event);session.previousX=event.pageX;session.previousY=event.pageY;$(element).data(DATA_DISPLAYCONTROLLER).show()}else{$(element).first().data(DATA_DISPLAYCONTROLLER).show(true,true)}return element},reposition:function apiResetPosition(element){$(element).first().data(DATA_DISPLAYCONTROLLER).resetPosition();return element},hide:function apiCloseTip(element,immediate){var displayController;immediate=element?immediate:true;if(element){displayController=$(element).first().data(DATA_DISPLAYCONTROLLER)}else if(session.activeHover){displayController=session.activeHover.data(DATA_DISPLAYCONTROLLER)}if(displayController){displayController.hide(immediate)}return element},toggle:function apiToggle(element,event){if(session.activeHover&&session.activeHover.is(element)){$.powerTip.hide(element,!isMouseEvent(event))}else{$.powerTip.show(element,event)}return element}};$.powerTip.showTip=$.powerTip.show;$.powerTip.closeTip=$.powerTip.hide;function CSSCoordinates(){var me=this;me.top="auto";me.left="auto";me.right="auto";me.bottom="auto";me.set=function(property,value){if($.isNumeric(value)){me[property]=Math.round(value)}}}function DisplayController(element,options,tipController){var hoverTimer=null,myCloseDelay=null;function openTooltip(immediate,forceOpen){cancelTimer();if(!element.data(DATA_HASACTIVEHOVER)){if(!immediate){session.tipOpenImminent=true;hoverTimer=setTimeout(function intentDelay(){hoverTimer=null;checkForIntent()},options.intentPollInterval)}else{if(forceOpen){element.data(DATA_FORCEDOPEN,true)}closeAnyDelayed();tipController.showTip(element)}}else{cancelClose()}}function closeTooltip(disableDelay){if(myCloseDelay){myCloseDelay=session.closeDelayTimeout=clearTimeout(myCloseDelay);session.delayInProgress=false}cancelTimer();session.tipOpenImminent=false;if(element.data(DATA_HASACTIVEHOVER)){element.data(DATA_FORCEDOPEN,false);if(!disableDelay){session.delayInProgress=true;session.closeDelayTimeout=setTimeout(function closeDelay(){session.closeDelayTimeout=null;tipController.hideTip(element);session.delayInProgress=false;myCloseDelay=null},options.closeDelay);myCloseDelay=session.closeDelayTimeout}else{tipController.hideTip(element)}}}function checkForIntent(){var xDifference=Math.abs(session.previousX-session.currentX),yDifference=Math.abs(session.previousY-session.currentY),totalDifference=xDifference+yDifference;if(totalDifference<options.intentSensitivity){cancelClose();closeAnyDelayed();tipController.showTip(element)}else{session.previousX=session.currentX;session.previousY=session.currentY;openTooltip()}}function cancelTimer(stopClose){hoverTimer=clearTimeout(hoverTimer);if(session.closeDelayTimeout&&myCloseDelay===session.closeDelayTimeout||stopClose){cancelClose()}}function cancelClose(){session.closeDelayTimeout=clearTimeout(session.closeDelayTimeout);session.delayInProgress=false}function closeAnyDelayed(){if(session.delayInProgress&&session.activeHover&&!session.activeHover.is(element)){session.activeHover.data(DATA_DISPLAYCONTROLLER).hide(true)}}function repositionTooltip(){tipController.resetPosition(element)}this.show=openTooltip;this.hide=closeTooltip;this.cancel=cancelTimer;this.resetPosition=repositionTooltip}function PlacementCalculator(){function computePlacementCoords(element,placement,tipWidth,tipHeight,offset){var placementBase=placement.split("-")[0],coords=new CSSCoordinates,position;if(isSvgElement(element)){position=getSvgPlacement(element,placementBase)}else{position=getHtmlPlacement(element,placementBase)}switch(placement){case"n":coords.set("left",position.left-tipWidth/2);coords.set("bottom",session.windowHeight-position.top+offset);break;case"e":coords.set("left",position.left+offset);coords.set("top",position.top-tipHeight/2);break;case"s":coords.set("left",position.left-tipWidth/2);coords.set("top",position.top+offset);break;case"w":coords.set("top",position.top-tipHeight/2);coords.set("right",session.windowWidth-position.left+offset);break;case"nw":coords.set("bottom",session.windowHeight-position.top+offset);coords.set("right",session.windowWidth-position.left-20);break;case"nw-alt":coords.set("left",position.left);coords.set("bottom",session.windowHeight-position.top+offset);break;case"ne":coords.set("left",position.left-20);coords.set("bottom",session.windowHeight-position.top+offset);break;case"ne-alt":coords.set("bottom",session.windowHeight-position.top+offset);coords.set("right",session.windowWidth-position.left);break;case"sw":coords.set("top",position.top+offset);coords.set("right",session.windowWidth-position.left-20);break;case"sw-alt":coords.set("left",position.left);coords.set("top",position.top+offset);break;case"se":coords.set("left",position.left-20);coords.set("top",position.top+offset);break;case"se-alt":coords.set("top",position.top+offset);coords.set("right",session.windowWidth-position.left);break}return coords}function getHtmlPlacement(element,placement){var objectOffset=element.offset(),objectWidth=element.outerWidth(),objectHeight=element.outerHeight(),left,top;switch(placement){case"n":left=objectOffset.left+objectWidth/2;top=objectOffset.top;break;case"e":left=objectOffset.left+objectWidth;top=objectOffset.top+objectHeight/2;break;case"s":left=objectOffset.left+objectWidth/2;top=objectOffset.top+objectHeight;break;case"w":left=objectOffset.left;top=objectOffset.top+objectHeight/2;break;case"nw":left=objectOffset.left;top=objectOffset.top;break;case"ne":left=objectOffset.left+objectWidth;top=objectOffset.top;break;case"sw":left=objectOffset.left;top=objectOffset.top+objectHeight;break;case"se":left=objectOffset.left+objectWidth;top=objectOffset.top+objectHeight;break}return{top:top,left:left}}function getSvgPlacement(element,placement){var svgElement=element.closest("svg")[0],domElement=element[0],point=svgElement.createSVGPoint(),boundingBox=domElement.getBBox(),matrix=domElement.getScreenCTM(),halfWidth=boundingBox.width/2,halfHeight=boundingBox.height/2,placements=[],placementKeys=["nw","n","ne","e","se","s","sw","w"],coords,rotation,steps,x;function pushPlacement(){placements.push(point.matrixTransform(matrix))}point.x=boundingBox.x;point.y=boundingBox.y;pushPlacement();point.x+=halfWidth;pushPlacement();point.x+=halfWidth;pushPlacement();point.y+=halfHeight;pushPlacement();point.y+=halfHeight;pushPlacement();point.x-=halfWidth;pushPlacement();point.x-=halfWidth;pushPlacement();point.y-=halfHeight;pushPlacement();if(placements[0].y!==placements[1].y||placements[0].x!==placements[7].x){rotation=Math.atan2(matrix.b,matrix.a)*RAD2DEG;steps=Math.ceil((rotation%360-22.5)/45);if(steps<1){steps+=8}while(steps--){placementKeys.push(placementKeys.shift())}}for(x=0;x<placements.length;x++){if(placementKeys[x]===placement){coords=placements[x];break}}return{top:coords.y+session.scrollTop,left:coords.x+session.scrollLeft}}this.compute=computePlacementCoords}function TooltipController(options){var placementCalculator=new PlacementCalculator,tipElement=$("#"+options.popupId);if(tipElement.length===0){tipElement=$("<div/>",{id:options.popupId});if($body.length===0){$body=$("body")}$body.append(tipElement);session.tooltips=session.tooltips?session.tooltips.add(tipElement):tipElement}if(options.followMouse){if(!tipElement.data(DATA_HASMOUSEMOVE)){$document.on("mousemove"+EVENT_NAMESPACE,positionTipOnCursor);$window.on("scroll"+EVENT_NAMESPACE,positionTipOnCursor);tipElement.data(DATA_HASMOUSEMOVE,true)}}function beginShowTip(element){element.data(DATA_HASACTIVEHOVER,true);tipElement.queue(function queueTipInit(next){showTip(element);next()})}function showTip(element){var tipContent;if(!element.data(DATA_HASACTIVEHOVER)){return}if(session.isTipOpen){if(!session.isClosing){hideTip(session.activeHover)}tipElement.delay(100).queue(function queueTipAgain(next){showTip(element);next()});return}element.trigger("powerTipPreRender");tipContent=getTooltipContent(element);if(tipContent){tipElement.empty().append(tipContent)}else{return}element.trigger("powerTipRender");session.activeHover=element;session.isTipOpen=true;tipElement.data(DATA_MOUSEONTOTIP,options.mouseOnToPopup);tipElement.addClass(options.popupClass);if(!options.followMouse||element.data(DATA_FORCEDOPEN)){positionTipOnElement(element);session.isFixedTipOpen=true}else{positionTipOnCursor()}if(!element.data(DATA_FORCEDOPEN)&&!options.followMouse){$document.on("click"+EVENT_NAMESPACE,function documentClick(event){var target=event.target;if(target!==element[0]){if(options.mouseOnToPopup){if(target!==tipElement[0]&&!$.contains(tipElement[0],target)){$.powerTip.hide()}}else{$.powerTip.hide()}}})}if(options.mouseOnToPopup&&!options.manual){tipElement.on("mouseenter"+EVENT_NAMESPACE,function tipMouseEnter(){if(session.activeHover){session.activeHover.data(DATA_DISPLAYCONTROLLER).cancel()}});tipElement.on("mouseleave"+EVENT_NAMESPACE,function tipMouseLeave(){if(session.activeHover){session.activeHover.data(DATA_DISPLAYCONTROLLER).hide()}})}tipElement.fadeIn(options.fadeInTime,function fadeInCallback(){if(!session.desyncTimeout){session.desyncTimeout=setInterval(closeDesyncedTip,500)}element.trigger("powerTipOpen")})}function hideTip(element){session.isClosing=true;session.isTipOpen=false;session.desyncTimeout=clearInterval(session.desyncTimeout);element.data(DATA_HASACTIVEHOVER,false);element.data(DATA_FORCEDOPEN,false);$document.off("click"+EVENT_NAMESPACE);tipElement.off(EVENT_NAMESPACE);tipElement.fadeOut(options.fadeOutTime,function fadeOutCallback(){var coords=new CSSCoordinates;session.activeHover=null;session.isClosing=false;session.isFixedTipOpen=false;tipElement.removeClass();coords.set("top",session.currentY+options.offset);coords.set("left",session.currentX+options.offset);tipElement.css(coords);element.trigger("powerTipClose")})}function positionTipOnCursor(){var tipWidth,tipHeight,coords,collisions,collisionCount;if(!session.isFixedTipOpen&&(session.isTipOpen||session.tipOpenImminent&&tipElement.data(DATA_HASMOUSEMOVE))){tipWidth=tipElement.outerWidth();tipHeight=tipElement.outerHeight();coords=new CSSCoordinates;coords.set("top",session.currentY+options.offset);coords.set("left",session.currentX+options.offset);collisions=getViewportCollisions(coords,tipWidth,tipHeight);if(collisions!==Collision.none){collisionCount=countFlags(collisions);if(collisionCount===1){if(collisions===Collision.right){coords.set("left",session.scrollLeft+session.windowWidth-tipWidth)}else if(collisions===Collision.bottom){coords.set("top",session.scrollTop+session.windowHeight-tipHeight)}}else{coords.set("left",session.currentX-tipWidth-options.offset);coords.set("top",session.currentY-tipHeight-options.offset)}}tipElement.css(coords)}}function positionTipOnElement(element){var priorityList,finalPlacement;if(options.smartPlacement||options.followMouse&&element.data(DATA_FORCEDOPEN)){priorityList=$.fn.powerTip.smartPlacementLists[options.placement];$.each(priorityList,function(idx,pos){var collisions=getViewportCollisions(placeTooltip(element,pos),tipElement.outerWidth(),tipElement.outerHeight());finalPlacement=pos;return collisions!==Collision.none})}else{placeTooltip(element,options.placement);finalPlacement=options.placement}tipElement.removeClass("w nw sw e ne se n s w se-alt sw-alt ne-alt nw-alt");tipElement.addClass(finalPlacement)}function placeTooltip(element,placement){var iterationCount=0,tipWidth,tipHeight,coords=new CSSCoordinates;coords.set("top",0);coords.set("left",0);tipElement.css(coords);do{tipWidth=tipElement.outerWidth();tipHeight=tipElement.outerHeight();coords=placementCalculator.compute(element,placement,tipWidth,tipHeight,options.offset);tipElement.css(coords)}while(++iterationCount<=5&&(tipWidth!==tipElement.outerWidth()||tipHeight!==tipElement.outerHeight()));return coords}function closeDesyncedTip(){var isDesynced=false,hasDesyncableCloseEvent=$.grep(["mouseleave","mouseout","blur","focusout"],function(eventType){return $.inArray(eventType,options.closeEvents)!==-1}).length>0;if(session.isTipOpen&&!session.isClosing&&!session.delayInProgress&&hasDesyncableCloseEvent){if(session.activeHover.data(DATA_HASACTIVEHOVER)===false||session.activeHover.is(":disabled")){isDesynced=true}else if(!isMouseOver(session.activeHover)&&!session.activeHover.is(":focus")&&!session.activeHover.data(DATA_FORCEDOPEN)){if(tipElement.data(DATA_MOUSEONTOTIP)){if(!isMouseOver(tipElement)){isDesynced=true}}else{isDesynced=true}}if(isDesynced){hideTip(session.activeHover)}}}this.showTip=beginShowTip;this.hideTip=hideTip;this.resetPosition=positionTipOnElement}function isSvgElement(element){return Boolean(window.SVGElement&&element[0]instanceof SVGElement)}function isMouseEvent(event){return Boolean(event&&$.inArray(event.type,MOUSE_EVENTS)>-1&&typeof event.pageX==="number")}function initTracking(){if(!session.mouseTrackingActive){session.mouseTrackingActive=true;getViewportDimensions();$(getViewportDimensions);$document.on("mousemove"+EVENT_NAMESPACE,trackMouse);$window.on("resize"+EVENT_NAMESPACE,trackResize);$window.on("scroll"+EVENT_NAMESPACE,trackScroll)}}function getViewportDimensions(){session.scrollLeft=$window.scrollLeft();session.scrollTop=$window.scrollTop();session.windowWidth=$window.width();session.windowHeight=$window.height()}function trackResize(){session.windowWidth=$window.width();session.windowHeight=$window.height()}function trackScroll(){var x=$window.scrollLeft(),y=$window.scrollTop();if(x!==session.scrollLeft){session.currentX+=x-session.scrollLeft;session.scrollLeft=x}if(y!==session.scrollTop){session.currentY+=y-session.scrollTop;session.scrollTop=y}}function trackMouse(event){session.currentX=event.pageX;session.currentY=event.pageY}function isMouseOver(element){var elementPosition=element.offset(),elementBox=element[0].getBoundingClientRect(),elementWidth=elementBox.right-elementBox.left,elementHeight=elementBox.bottom-elementBox.top;return session.currentX>=elementPosition.left&&session.currentX<=elementPosition.left+elementWidth&&session.currentY>=elementPosition.top&&session.currentY<=elementPosition.top+elementHeight}function getTooltipContent(element){var tipText=element.data(DATA_POWERTIP),tipObject=element.data(DATA_POWERTIPJQ),tipTarget=element.data(DATA_POWERTIPTARGET),targetElement,content;if(tipText){if($.isFunction(tipText)){tipText=tipText.call(element[0])}content=tipText}else if(tipObject){if($.isFunction(tipObject)){tipObject=tipObject.call(element[0])}if(tipObject.length>0){content=tipObject.clone(true,true)}}else if(tipTarget){targetElement=$("#"+tipTarget);if(targetElement.length>0){content=targetElement.html()}}return content}function getViewportCollisions(coords,elementWidth,elementHeight){var viewportTop=session.scrollTop,viewportLeft=session.scrollLeft,viewportBottom=viewportTop+session.windowHeight,viewportRight=viewportLeft+session.windowWidth,collisions=Collision.none;if(coords.top<viewportTop||Math.abs(coords.bottom-session.windowHeight)-elementHeight<viewportTop){collisions|=Collision.top}if(coords.top+elementHeight>viewportBottom||Math.abs(coords.bottom-session.windowHeight)>viewportBottom){collisions|=Collision.bottom}if(coords.left<viewportLeft||coords.right+elementWidth>viewportRight){collisions|=Collision.left}if(coords.left+elementWidth>viewportRight||coords.right<viewportLeft){collisions|=Collision.right}return collisions}function countFlags(value){var count=0;while(value){value&=value-1;count++}return count}return $.powerTip});/*!
+ * jQuery UI Touch Punch 0.2.3
+ *
+ * Copyright 2011–2014, Dave Furfero
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ *
+ * Depends:
+ *  jquery.ui.widget.js
+ *  jquery.ui.mouse.js
+ */
+!function(a){function f(a,b){if(!(a.originalEvent.touches.length>1)){a.preventDefault();var c=a.originalEvent.changedTouches[0],d=document.createEvent("MouseEvents");d.initMouseEvent(b,!0,!0,window,1,c.screenX,c.screenY,c.clientX,c.clientY,!1,!1,!1,!1,0,null),a.target.dispatchEvent(d)}}if(a.support.touch="ontouchend"in document,a.support.touch){var e,b=a.ui.mouse.prototype,c=b._mouseInit,d=b._mouseDestroy;b._touchStart=function(a){var b=this;!e&&b._mouseCapture(a.originalEvent.changedTouches[0])&&(e=!0,b._touchMoved=!1,f(a,"mouseover"),f(a,"mousemove"),f(a,"mousedown"))},b._touchMove=function(a){e&&(this._touchMoved=!0,f(a,"mousemove"))},b._touchEnd=function(a){e&&(f(a,"mouseup"),f(a,"mouseout"),this._touchMoved||f(a,"click"),e=!1)},b._mouseInit=function(){var b=this;b.element.bind({touchstart:a.proxy(b,"_touchStart"),touchmove:a.proxy(b,"_touchMove"),touchend:a.proxy(b,"_touchEnd")}),c.call(b)},b._mouseDestroy=function(){var b=this;b.element.unbind({touchstart:a.proxy(b,"_touchStart"),touchmove:a.proxy(b,"_touchMove"),touchend:a.proxy(b,"_touchEnd")}),d.call(b)}}}(jQuery);/*! SmartMenus jQuery Plugin - v1.1.0 - September 17, 2017
+ * http://www.smartmenus.org/
+ * Copyright Vasil Dinkov, Vadikom Web Ltd. http://vadikom.com; Licensed MIT */(function(t){"function"==typeof define&&define.amd?define(["jquery"],t):"object"==typeof module&&"object"==typeof module.exports?module.exports=t(require("jquery")):t(jQuery)})(function($){function initMouseDetection(t){var e=".smartmenus_mouse";if(mouseDetectionEnabled||t)mouseDetectionEnabled&&t&&($(document).off(e),mouseDetectionEnabled=!1);else{var i=!0,s=null,o={mousemove:function(t){var e={x:t.pageX,y:t.pageY,timeStamp:(new Date).getTime()};if(s){var o=Math.abs(s.x-e.x),a=Math.abs(s.y-e.y);if((o>0||a>0)&&2>=o&&2>=a&&300>=e.timeStamp-s.timeStamp&&(mouse=!0,i)){var n=$(t.target).closest("a");n.is("a")&&$.each(menuTrees,function(){return $.contains(this.$root[0],n[0])?(this.itemEnter({currentTarget:n[0]}),!1):void 0}),i=!1}}s=e}};o[touchEvents?"touchstart":"pointerover pointermove pointerout MSPointerOver MSPointerMove MSPointerOut"]=function(t){isTouchEvent(t.originalEvent)&&(mouse=!1)},$(document).on(getEventsNS(o,e)),mouseDetectionEnabled=!0}}function isTouchEvent(t){return!/^(4|mouse)$/.test(t.pointerType)}function getEventsNS(t,e){e||(e="");var i={};for(var s in t)i[s.split(" ").join(e+" ")+e]=t[s];return i}var menuTrees=[],mouse=!1,touchEvents="ontouchstart"in window,mouseDetectionEnabled=!1,requestAnimationFrame=window.requestAnimationFrame||function(t){return setTimeout(t,1e3/60)},cancelAnimationFrame=window.cancelAnimationFrame||function(t){clearTimeout(t)},canAnimate=!!$.fn.animate;return $.SmartMenus=function(t,e){this.$root=$(t),this.opts=e,this.rootId="",this.accessIdPrefix="",this.$subArrow=null,this.activatedItems=[],this.visibleSubMenus=[],this.showTimeout=0,this.hideTimeout=0,this.scrollTimeout=0,this.clickActivated=!1,this.focusActivated=!1,this.zIndexInc=0,this.idInc=0,this.$firstLink=null,this.$firstSub=null,this.disabled=!1,this.$disableOverlay=null,this.$touchScrollingSub=null,this.cssTransforms3d="perspective"in t.style||"webkitPerspective"in t.style,this.wasCollapsible=!1,this.init()},$.extend($.SmartMenus,{hideAll:function(){$.each(menuTrees,function(){this.menuHideAll()})},destroy:function(){for(;menuTrees.length;)menuTrees[0].destroy();initMouseDetection(!0)},prototype:{init:function(t){var e=this;if(!t){menuTrees.push(this),this.rootId=((new Date).getTime()+Math.random()+"").replace(/\D/g,""),this.accessIdPrefix="sm-"+this.rootId+"-",this.$root.hasClass("sm-rtl")&&(this.opts.rightToLeftSubMenus=!0);var i=".smartmenus";this.$root.data("smartmenus",this).attr("data-smartmenus-id",this.rootId).dataSM("level",1).on(getEventsNS({"mouseover focusin":$.proxy(this.rootOver,this),"mouseout focusout":$.proxy(this.rootOut,this),keydown:$.proxy(this.rootKeyDown,this)},i)).on(getEventsNS({mouseenter:$.proxy(this.itemEnter,this),mouseleave:$.proxy(this.itemLeave,this),mousedown:$.proxy(this.itemDown,this),focus:$.proxy(this.itemFocus,this),blur:$.proxy(this.itemBlur,this),click:$.proxy(this.itemClick,this)},i),"a"),i+=this.rootId,this.opts.hideOnClick&&$(document).on(getEventsNS({touchstart:$.proxy(this.docTouchStart,this),touchmove:$.proxy(this.docTouchMove,this),touchend:$.proxy(this.docTouchEnd,this),click:$.proxy(this.docClick,this)},i)),$(window).on(getEventsNS({"resize orientationchange":$.proxy(this.winResize,this)},i)),this.opts.subIndicators&&(this.$subArrow=$("<span/>").addClass("sub-arrow"),this.opts.subIndicatorsText&&this.$subArrow.html(this.opts.subIndicatorsText)),initMouseDetection()}if(this.$firstSub=this.$root.find("ul").each(function(){e.menuInit($(this))}).eq(0),this.$firstLink=this.$root.find("a").eq(0),this.opts.markCurrentItem){var s=/(index|default)\.[^#\?\/]*/i,o=/#.*/,a=window.location.href.replace(s,""),n=a.replace(o,"");this.$root.find("a").each(function(){var t=this.href.replace(s,""),i=$(this);(t==a||t==n)&&(i.addClass("current"),e.opts.markCurrentTree&&i.parentsUntil("[data-smartmenus-id]","ul").each(function(){$(this).dataSM("parent-a").addClass("current")}))})}this.wasCollapsible=this.isCollapsible()},destroy:function(t){if(!t){var e=".smartmenus";this.$root.removeData("smartmenus").removeAttr("data-smartmenus-id").removeDataSM("level").off(e),e+=this.rootId,$(document).off(e),$(window).off(e),this.opts.subIndicators&&(this.$subArrow=null)}this.menuHideAll();var i=this;this.$root.find("ul").each(function(){var t=$(this);t.dataSM("scroll-arrows")&&t.dataSM("scroll-arrows").remove(),t.dataSM("shown-before")&&((i.opts.subMenusMinWidth||i.opts.subMenusMaxWidth)&&t.css({width:"",minWidth:"",maxWidth:""}).removeClass("sm-nowrap"),t.dataSM("scroll-arrows")&&t.dataSM("scroll-arrows").remove(),t.css({zIndex:"",top:"",left:"",marginLeft:"",marginTop:"",display:""})),0==(t.attr("id")||"").indexOf(i.accessIdPrefix)&&t.removeAttr("id")}).removeDataSM("in-mega").removeDataSM("shown-before").removeDataSM("scroll-arrows").removeDataSM("parent-a").removeDataSM("level").removeDataSM("beforefirstshowfired").removeAttr("role").removeAttr("aria-hidden").removeAttr("aria-labelledby").removeAttr("aria-expanded"),this.$root.find("a.has-submenu").each(function(){var t=$(this);0==t.attr("id").indexOf(i.accessIdPrefix)&&t.removeAttr("id")}).removeClass("has-submenu").removeDataSM("sub").removeAttr("aria-haspopup").removeAttr("aria-controls").removeAttr("aria-expanded").closest("li").removeDataSM("sub"),this.opts.subIndicators&&this.$root.find("span.sub-arrow").remove(),this.opts.markCurrentItem&&this.$root.find("a.current").removeClass("current"),t||(this.$root=null,this.$firstLink=null,this.$firstSub=null,this.$disableOverlay&&(this.$disableOverlay.remove(),this.$disableOverlay=null),menuTrees.splice($.inArray(this,menuTrees),1))},disable:function(t){if(!this.disabled){if(this.menuHideAll(),!t&&!this.opts.isPopup&&this.$root.is(":visible")){var e=this.$root.offset();this.$disableOverlay=$('<div class="sm-jquery-disable-overlay"/>').css({position:"absolute",top:e.top,left:e.left,width:this.$root.outerWidth(),height:this.$root.outerHeight(),zIndex:this.getStartZIndex(!0),opacity:0}).appendTo(document.body)}this.disabled=!0}},docClick:function(t){return this.$touchScrollingSub?(this.$touchScrollingSub=null,void 0):((this.visibleSubMenus.length&&!$.contains(this.$root[0],t.target)||$(t.target).closest("a").length)&&this.menuHideAll(),void 0)},docTouchEnd:function(){if(this.lastTouch){if(!(!this.visibleSubMenus.length||void 0!==this.lastTouch.x2&&this.lastTouch.x1!=this.lastTouch.x2||void 0!==this.lastTouch.y2&&this.lastTouch.y1!=this.lastTouch.y2||this.lastTouch.target&&$.contains(this.$root[0],this.lastTouch.target))){this.hideTimeout&&(clearTimeout(this.hideTimeout),this.hideTimeout=0);var t=this;this.hideTimeout=setTimeout(function(){t.menuHideAll()},350)}this.lastTouch=null}},docTouchMove:function(t){if(this.lastTouch){var e=t.originalEvent.touches[0];this.lastTouch.x2=e.pageX,this.lastTouch.y2=e.pageY}},docTouchStart:function(t){var e=t.originalEvent.touches[0];this.lastTouch={x1:e.pageX,y1:e.pageY,target:e.target}},enable:function(){this.disabled&&(this.$disableOverlay&&(this.$disableOverlay.remove(),this.$disableOverlay=null),this.disabled=!1)},getClosestMenu:function(t){for(var e=$(t).closest("ul");e.dataSM("in-mega");)e=e.parent().closest("ul");return e[0]||null},getHeight:function(t){return this.getOffset(t,!0)},getOffset:function(t,e){var i;"none"==t.css("display")&&(i={position:t[0].style.position,visibility:t[0].style.visibility},t.css({position:"absolute",visibility:"hidden"}).show());var s=t[0].getBoundingClientRect&&t[0].getBoundingClientRect(),o=s&&(e?s.height||s.bottom-s.top:s.width||s.right-s.left);return o||0===o||(o=e?t[0].offsetHeight:t[0].offsetWidth),i&&t.hide().css(i),o},getStartZIndex:function(t){var e=parseInt(this[t?"$root":"$firstSub"].css("z-index"));return!t&&isNaN(e)&&(e=parseInt(this.$root.css("z-index"))),isNaN(e)?1:e},getTouchPoint:function(t){return t.touches&&t.touches[0]||t.changedTouches&&t.changedTouches[0]||t},getViewport:function(t){var e=t?"Height":"Width",i=document.documentElement["client"+e],s=window["inner"+e];return s&&(i=Math.min(i,s)),i},getViewportHeight:function(){return this.getViewport(!0)},getViewportWidth:function(){return this.getViewport()},getWidth:function(t){return this.getOffset(t)},handleEvents:function(){return!this.disabled&&this.isCSSOn()},handleItemEvents:function(t){return this.handleEvents()&&!this.isLinkInMegaMenu(t)},isCollapsible:function(){return"static"==this.$firstSub.css("position")},isCSSOn:function(){return"inline"!=this.$firstLink.css("display")},isFixed:function(){var t="fixed"==this.$root.css("position");return t||this.$root.parentsUntil("body").each(function(){return"fixed"==$(this).css("position")?(t=!0,!1):void 0}),t},isLinkInMegaMenu:function(t){return $(this.getClosestMenu(t[0])).hasClass("mega-menu")},isTouchMode:function(){return!mouse||this.opts.noMouseOver||this.isCollapsible()},itemActivate:function(t,e){var i=t.closest("ul"),s=i.dataSM("level");if(s>1&&(!this.activatedItems[s-2]||this.activatedItems[s-2][0]!=i.dataSM("parent-a")[0])){var o=this;$(i.parentsUntil("[data-smartmenus-id]","ul").get().reverse()).add(i).each(function(){o.itemActivate($(this).dataSM("parent-a"))})}if((!this.isCollapsible()||e)&&this.menuHideSubMenus(this.activatedItems[s-1]&&this.activatedItems[s-1][0]==t[0]?s:s-1),this.activatedItems[s-1]=t,this.$root.triggerHandler("activate.smapi",t[0])!==!1){var a=t.dataSM("sub");a&&(this.isTouchMode()||!this.opts.showOnClick||this.clickActivated)&&this.menuShow(a)}},itemBlur:function(t){var e=$(t.currentTarget);this.handleItemEvents(e)&&this.$root.triggerHandler("blur.smapi",e[0])},itemClick:function(t){var e=$(t.currentTarget);if(this.handleItemEvents(e)){if(this.$touchScrollingSub&&this.$touchScrollingSub[0]==e.closest("ul")[0])return this.$touchScrollingSub=null,t.stopPropagation(),!1;if(this.$root.triggerHandler("click.smapi",e[0])===!1)return!1;var i=$(t.target).is(".sub-arrow"),s=e.dataSM("sub"),o=s?2==s.dataSM("level"):!1,a=this.isCollapsible(),n=/toggle$/.test(this.opts.collapsibleBehavior),r=/link$/.test(this.opts.collapsibleBehavior),h=/^accordion/.test(this.opts.collapsibleBehavior);if(s&&!s.is(":visible")){if((!r||!a||i)&&(this.opts.showOnClick&&o&&(this.clickActivated=!0),this.itemActivate(e,h),s.is(":visible")))return this.focusActivated=!0,!1}else if(a&&(n||i))return this.itemActivate(e,h),this.menuHide(s),n&&(this.focusActivated=!1),!1;return this.opts.showOnClick&&o||e.hasClass("disabled")||this.$root.triggerHandler("select.smapi",e[0])===!1?!1:void 0}},itemDown:function(t){var e=$(t.currentTarget);this.handleItemEvents(e)&&e.dataSM("mousedown",!0)},itemEnter:function(t){var e=$(t.currentTarget);if(this.handleItemEvents(e)){if(!this.isTouchMode()){this.showTimeout&&(clearTimeout(this.showTimeout),this.showTimeout=0);var i=this;this.showTimeout=setTimeout(function(){i.itemActivate(e)},this.opts.showOnClick&&1==e.closest("ul").dataSM("level")?1:this.opts.showTimeout)}this.$root.triggerHandler("mouseenter.smapi",e[0])}},itemFocus:function(t){var e=$(t.currentTarget);this.handleItemEvents(e)&&(!this.focusActivated||this.isTouchMode()&&e.dataSM("mousedown")||this.activatedItems.length&&this.activatedItems[this.activatedItems.length-1][0]==e[0]||this.itemActivate(e,!0),this.$root.triggerHandler("focus.smapi",e[0]))},itemLeave:function(t){var e=$(t.currentTarget);this.handleItemEvents(e)&&(this.isTouchMode()||(e[0].blur(),this.showTimeout&&(clearTimeout(this.showTimeout),this.showTimeout=0)),e.removeDataSM("mousedown"),this.$root.triggerHandler("mouseleave.smapi",e[0]))},menuHide:function(t){if(this.$root.triggerHandler("beforehide.smapi",t[0])!==!1&&(canAnimate&&t.stop(!0,!0),"none"!=t.css("display"))){var e=function(){t.css("z-index","")};this.isCollapsible()?canAnimate&&this.opts.collapsibleHideFunction?this.opts.collapsibleHideFunction.call(this,t,e):t.hide(this.opts.collapsibleHideDuration,e):canAnimate&&this.opts.hideFunction?this.opts.hideFunction.call(this,t,e):t.hide(this.opts.hideDuration,e),t.dataSM("scroll")&&(this.menuScrollStop(t),t.css({"touch-action":"","-ms-touch-action":"","-webkit-transform":"",transform:""}).off(".smartmenus_scroll").removeDataSM("scroll").dataSM("scroll-arrows").hide()),t.dataSM("parent-a").removeClass("highlighted").attr("aria-expanded","false"),t.attr({"aria-expanded":"false","aria-hidden":"true"});var i=t.dataSM("level");this.activatedItems.splice(i-1,1),this.visibleSubMenus.splice($.inArray(t,this.visibleSubMenus),1),this.$root.triggerHandler("hide.smapi",t[0])}},menuHideAll:function(){this.showTimeout&&(clearTimeout(this.showTimeout),this.showTimeout=0);for(var t=this.opts.isPopup?1:0,e=this.visibleSubMenus.length-1;e>=t;e--)this.menuHide(this.visibleSubMenus[e]);this.opts.isPopup&&(canAnimate&&this.$root.stop(!0,!0),this.$root.is(":visible")&&(canAnimate&&this.opts.hideFunction?this.opts.hideFunction.call(this,this.$root):this.$root.hide(this.opts.hideDuration))),this.activatedItems=[],this.visibleSubMenus=[],this.clickActivated=!1,this.focusActivated=!1,this.zIndexInc=0,this.$root.triggerHandler("hideAll.smapi")},menuHideSubMenus:function(t){for(var e=this.activatedItems.length-1;e>=t;e--){var i=this.activatedItems[e].dataSM("sub");i&&this.menuHide(i)}},menuInit:function(t){if(!t.dataSM("in-mega")){t.hasClass("mega-menu")&&t.find("ul").dataSM("in-mega",!0);for(var e=2,i=t[0];(i=i.parentNode.parentNode)!=this.$root[0];)e++;var s=t.prevAll("a").eq(-1);s.length||(s=t.prevAll().find("a").eq(-1)),s.addClass("has-submenu").dataSM("sub",t),t.dataSM("parent-a",s).dataSM("level",e).parent().dataSM("sub",t);var o=s.attr("id")||this.accessIdPrefix+ ++this.idInc,a=t.attr("id")||this.accessIdPrefix+ ++this.idInc;s.attr({id:o,"aria-haspopup":"true","aria-controls":a,"aria-expanded":"false"}),t.attr({id:a,role:"group","aria-hidden":"true","aria-labelledby":o,"aria-expanded":"false"}),this.opts.subIndicators&&s[this.opts.subIndicatorsPos](this.$subArrow.clone())}},menuPosition:function(t){var e,i,s=t.dataSM("parent-a"),o=s.closest("li"),a=o.parent(),n=t.dataSM("level"),r=this.getWidth(t),h=this.getHeight(t),u=s.offset(),l=u.left,c=u.top,d=this.getWidth(s),m=this.getHeight(s),p=$(window),f=p.scrollLeft(),v=p.scrollTop(),b=this.getViewportWidth(),S=this.getViewportHeight(),g=a.parent().is("[data-sm-horizontal-sub]")||2==n&&!a.hasClass("sm-vertical"),M=this.opts.rightToLeftSubMenus&&!o.is("[data-sm-reverse]")||!this.opts.rightToLeftSubMenus&&o.is("[data-sm-reverse]"),w=2==n?this.opts.mainMenuSubOffsetX:this.opts.subMenusSubOffsetX,T=2==n?this.opts.mainMenuSubOffsetY:this.opts.subMenusSubOffsetY;if(g?(e=M?d-r-w:w,i=this.opts.bottomToTopSubMenus?-h-T:m+T):(e=M?w-r:d-w,i=this.opts.bottomToTopSubMenus?m-T-h:T),this.opts.keepInViewport){var y=l+e,I=c+i;if(M&&f>y?e=g?f-y+e:d-w:!M&&y+r>f+b&&(e=g?f+b-r-y+e:w-r),g||(S>h&&I+h>v+S?i+=v+S-h-I:(h>=S||v>I)&&(i+=v-I)),g&&(I+h>v+S+.49||v>I)||!g&&h>S+.49){var x=this;t.dataSM("scroll-arrows")||t.dataSM("scroll-arrows",$([$('<span class="scroll-up"><span class="scroll-up-arrow"></span></span>')[0],$('<span class="scroll-down"><span class="scroll-down-arrow"></span></span>')[0]]).on({mouseenter:function(){t.dataSM("scroll").up=$(this).hasClass("scroll-up"),x.menuScroll(t)},mouseleave:function(e){x.menuScrollStop(t),x.menuScrollOut(t,e)},"mousewheel DOMMouseScroll":function(t){t.preventDefault()}}).insertAfter(t));var A=".smartmenus_scroll";if(t.dataSM("scroll",{y:this.cssTransforms3d?0:i-m,step:1,itemH:m,subH:h,arrowDownH:this.getHeight(t.dataSM("scroll-arrows").eq(1))}).on(getEventsNS({mouseover:function(e){x.menuScrollOver(t,e)},mouseout:function(e){x.menuScrollOut(t,e)},"mousewheel DOMMouseScroll":function(e){x.menuScrollMousewheel(t,e)}},A)).dataSM("scroll-arrows").css({top:"auto",left:"0",marginLeft:e+(parseInt(t.css("border-left-width"))||0),width:r-(parseInt(t.css("border-left-width"))||0)-(parseInt(t.css("border-right-width"))||0),zIndex:t.css("z-index")}).eq(g&&this.opts.bottomToTopSubMenus?0:1).show(),this.isFixed()){var C={};C[touchEvents?"touchstart touchmove touchend":"pointerdown pointermove pointerup MSPointerDown MSPointerMove MSPointerUp"]=function(e){x.menuScrollTouch(t,e)},t.css({"touch-action":"none","-ms-touch-action":"none"}).on(getEventsNS(C,A))}}}t.css({top:"auto",left:"0",marginLeft:e,marginTop:i-m})},menuScroll:function(t,e,i){var s,o=t.dataSM("scroll"),a=t.dataSM("scroll-arrows"),n=o.up?o.upEnd:o.downEnd;if(!e&&o.momentum){if(o.momentum*=.92,s=o.momentum,.5>s)return this.menuScrollStop(t),void 0}else s=i||(e||!this.opts.scrollAccelerate?this.opts.scrollStep:Math.floor(o.step));var r=t.dataSM("level");if(this.activatedItems[r-1]&&this.activatedItems[r-1].dataSM("sub")&&this.activatedItems[r-1].dataSM("sub").is(":visible")&&this.menuHideSubMenus(r-1),o.y=o.up&&o.y>=n||!o.up&&n>=o.y?o.y:Math.abs(n-o.y)>s?o.y+(o.up?s:-s):n,t.css(this.cssTransforms3d?{"-webkit-transform":"translate3d(0, "+o.y+"px, 0)",transform:"translate3d(0, "+o.y+"px, 0)"}:{marginTop:o.y}),mouse&&(o.up&&o.y>o.downEnd||!o.up&&o.y<o.upEnd)&&a.eq(o.up?1:0).show(),o.y==n)mouse&&a.eq(o.up?0:1).hide(),this.menuScrollStop(t);else if(!e){this.opts.scrollAccelerate&&o.step<this.opts.scrollStep&&(o.step+=.2);var h=this;this.scrollTimeout=requestAnimationFrame(function(){h.menuScroll(t)})}},menuScrollMousewheel:function(t,e){if(this.getClosestMenu(e.target)==t[0]){e=e.originalEvent;var i=(e.wheelDelta||-e.detail)>0;t.dataSM("scroll-arrows").eq(i?0:1).is(":visible")&&(t.dataSM("scroll").up=i,this.menuScroll(t,!0))}e.preventDefault()},menuScrollOut:function(t,e){mouse&&(/^scroll-(up|down)/.test((e.relatedTarget||"").className)||(t[0]==e.relatedTarget||$.contains(t[0],e.relatedTarget))&&this.getClosestMenu(e.relatedTarget)==t[0]||t.dataSM("scroll-arrows").css("visibility","hidden"))},menuScrollOver:function(t,e){if(mouse&&!/^scroll-(up|down)/.test(e.target.className)&&this.getClosestMenu(e.target)==t[0]){this.menuScrollRefreshData(t);var i=t.dataSM("scroll"),s=$(window).scrollTop()-t.dataSM("parent-a").offset().top-i.itemH;t.dataSM("scroll-arrows").eq(0).css("margin-top",s).end().eq(1).css("margin-top",s+this.getViewportHeight()-i.arrowDownH).end().css("visibility","visible")}},menuScrollRefreshData:function(t){var e=t.dataSM("scroll"),i=$(window).scrollTop()-t.dataSM("parent-a").offset().top-e.itemH;this.cssTransforms3d&&(i=-(parseFloat(t.css("margin-top"))-i)),$.extend(e,{upEnd:i,downEnd:i+this.getViewportHeight()-e.subH})},menuScrollStop:function(t){return this.scrollTimeout?(cancelAnimationFrame(this.scrollTimeout),this.scrollTimeout=0,t.dataSM("scroll").step=1,!0):void 0},menuScrollTouch:function(t,e){if(e=e.originalEvent,isTouchEvent(e)){var i=this.getTouchPoint(e);if(this.getClosestMenu(i.target)==t[0]){var s=t.dataSM("scroll");if(/(start|down)$/i.test(e.type))this.menuScrollStop(t)?(e.preventDefault(),this.$touchScrollingSub=t):this.$touchScrollingSub=null,this.menuScrollRefreshData(t),$.extend(s,{touchStartY:i.pageY,touchStartTime:e.timeStamp});else if(/move$/i.test(e.type)){var o=void 0!==s.touchY?s.touchY:s.touchStartY;if(void 0!==o&&o!=i.pageY){this.$touchScrollingSub=t;var a=i.pageY>o;void 0!==s.up&&s.up!=a&&$.extend(s,{touchStartY:i.pageY,touchStartTime:e.timeStamp}),$.extend(s,{up:a,touchY:i.pageY}),this.menuScroll(t,!0,Math.abs(i.pageY-o))}e.preventDefault()}else void 0!==s.touchY&&((s.momentum=15*Math.pow(Math.abs(i.pageY-s.touchStartY)/(e.timeStamp-s.touchStartTime),2))&&(this.menuScrollStop(t),this.menuScroll(t),e.preventDefault()),delete s.touchY)}}},menuShow:function(t){if((t.dataSM("beforefirstshowfired")||(t.dataSM("beforefirstshowfired",!0),this.$root.triggerHandler("beforefirstshow.smapi",t[0])!==!1))&&this.$root.triggerHandler("beforeshow.smapi",t[0])!==!1&&(t.dataSM("shown-before",!0),canAnimate&&t.stop(!0,!0),!t.is(":visible"))){var e=t.dataSM("parent-a"),i=this.isCollapsible();if((this.opts.keepHighlighted||i)&&e.addClass("highlighted"),i)t.removeClass("sm-nowrap").css({zIndex:"",width:"auto",minWidth:"",maxWidth:"",top:"",left:"",marginLeft:"",marginTop:""});else{if(t.css("z-index",this.zIndexInc=(this.zIndexInc||this.getStartZIndex())+1),(this.opts.subMenusMinWidth||this.opts.subMenusMaxWidth)&&(t.css({width:"auto",minWidth:"",maxWidth:""}).addClass("sm-nowrap"),this.opts.subMenusMinWidth&&t.css("min-width",this.opts.subMenusMinWidth),this.opts.subMenusMaxWidth)){var s=this.getWidth(t);t.css("max-width",this.opts.subMenusMaxWidth),s>this.getWidth(t)&&t.removeClass("sm-nowrap").css("width",this.opts.subMenusMaxWidth)}this.menuPosition(t)}var o=function(){t.css("overflow","")};i?canAnimate&&this.opts.collapsibleShowFunction?this.opts.collapsibleShowFunction.call(this,t,o):t.show(this.opts.collapsibleShowDuration,o):canAnimate&&this.opts.showFunction?this.opts.showFunction.call(this,t,o):t.show(this.opts.showDuration,o),e.attr("aria-expanded","true"),t.attr({"aria-expanded":"true","aria-hidden":"false"}),this.visibleSubMenus.push(t),this.$root.triggerHandler("show.smapi",t[0])}},popupHide:function(t){this.hideTimeout&&(clearTimeout(this.hideTimeout),this.hideTimeout=0);var e=this;this.hideTimeout=setTimeout(function(){e.menuHideAll()},t?1:this.opts.hideTimeout)},popupShow:function(t,e){if(!this.opts.isPopup)return alert('SmartMenus jQuery Error:\n\nIf you want to show this menu via the "popupShow" method, set the isPopup:true option.'),void 0;if(this.hideTimeout&&(clearTimeout(this.hideTimeout),this.hideTimeout=0),this.$root.dataSM("shown-before",!0),canAnimate&&this.$root.stop(!0,!0),!this.$root.is(":visible")){this.$root.css({left:t,top:e});var i=this,s=function(){i.$root.css("overflow","")};canAnimate&&this.opts.showFunction?this.opts.showFunction.call(this,this.$root,s):this.$root.show(this.opts.showDuration,s),this.visibleSubMenus[0]=this.$root}},refresh:function(){this.destroy(!0),this.init(!0)},rootKeyDown:function(t){if(this.handleEvents())switch(t.keyCode){case 27:var e=this.activatedItems[0];if(e){this.menuHideAll(),e[0].focus();var i=e.dataSM("sub");i&&this.menuHide(i)}break;case 32:var s=$(t.target);if(s.is("a")&&this.handleItemEvents(s)){var i=s.dataSM("sub");i&&!i.is(":visible")&&(this.itemClick({currentTarget:t.target}),t.preventDefault())}}},rootOut:function(t){if(this.handleEvents()&&!this.isTouchMode()&&t.target!=this.$root[0]&&(this.hideTimeout&&(clearTimeout(this.hideTimeout),this.hideTimeout=0),!this.opts.showOnClick||!this.opts.hideOnClick)){var e=this;this.hideTimeout=setTimeout(function(){e.menuHideAll()},this.opts.hideTimeout)}},rootOver:function(t){this.handleEvents()&&!this.isTouchMode()&&t.target!=this.$root[0]&&this.hideTimeout&&(clearTimeout(this.hideTimeout),this.hideTimeout=0)},winResize:function(t){if(this.handleEvents()){if(!("onorientationchange"in window)||"orientationchange"==t.type){var e=this.isCollapsible();this.wasCollapsible&&e||(this.activatedItems.length&&this.activatedItems[this.activatedItems.length-1][0].blur(),this.menuHideAll()),this.wasCollapsible=e}}else if(this.$disableOverlay){var i=this.$root.offset();this.$disableOverlay.css({top:i.top,left:i.left,width:this.$root.outerWidth(),height:this.$root.outerHeight()})}}}}),$.fn.dataSM=function(t,e){return e?this.data(t+"_smartmenus",e):this.data(t+"_smartmenus")},$.fn.removeDataSM=function(t){return this.removeData(t+"_smartmenus")},$.fn.smartmenus=function(options){if("string"==typeof options){var args=arguments,method=options;return Array.prototype.shift.call(args),this.each(function(){var t=$(this).data("smartmenus");t&&t[method]&&t[method].apply(t,args)})}return this.each(function(){var dataOpts=$(this).data("sm-options")||null;if(dataOpts)try{dataOpts=eval("("+dataOpts+")")}catch(e){dataOpts=null,alert('ERROR\n\nSmartMenus jQuery init:\nInvalid "data-sm-options" attribute value syntax.')}new $.SmartMenus(this,$.extend({},$.fn.smartmenus.defaults,options,dataOpts))})},$.fn.smartmenus.defaults={isPopup:!1,mainMenuSubOffsetX:0,mainMenuSubOffsetY:0,subMenusSubOffsetX:0,subMenusSubOffsetY:0,subMenusMinWidth:"10em",subMenusMaxWidth:"20em",subIndicators:!0,subIndicatorsPos:"append",subIndicatorsText:"",scrollStep:30,scrollAccelerate:!0,showTimeout:250,hideTimeout:500,showDuration:0,showFunction:null,hideDuration:0,hideFunction:function(t,e){t.fadeOut(200,e)},collapsibleShowDuration:0,collapsibleShowFunction:function(t,e){t.slideDown(200,e)},collapsibleHideDuration:0,collapsibleHideFunction:function(t,e){t.slideUp(200,e)},showOnClick:!1,hideOnClick:!0,noMouseOver:!1,keepInViewport:!0,keepHighlighted:!0,markCurrentItem:!1,markCurrentTree:!0,rightToLeftSubMenus:!1,bottomToTopSubMenus:!1,collapsibleBehavior:"default"},$});
\ No newline at end of file
diff -pruN 2.10.0-1/doc/doxygen-doc/html/menu.js 2.11.0-1/doc/doxygen-doc/html/menu.js
--- 2.10.0-1/doc/doxygen-doc/html/menu.js	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/menu.js	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,136 @@
+/*
+ @licstart  The following is the entire license notice for the JavaScript code in this file.
+
+ The MIT License (MIT)
+
+ Copyright (C) 1997-2020 by Dimitri van Heesch
+
+ Permission is hereby granted, free of charge, to any person obtaining a copy of this software
+ and associated documentation files (the "Software"), to deal in the Software without restriction,
+ including without limitation the rights to use, copy, modify, merge, publish, distribute,
+ sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
+ furnished to do so, subject to the following conditions:
+
+ The above copyright notice and this permission notice shall be included in all copies or
+ substantial portions of the Software.
+
+ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
+ BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
+ DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+
+ @licend  The above is the entire license notice for the JavaScript code in this file
+ */
+function initMenu(relPath,searchEnabled,serverSide,searchPage,search) {
+  function makeTree(data,relPath) {
+    var result='';
+    if ('children' in data) {
+      result+='<ul>';
+      for (var i in data.children) {
+        var url;
+        var link;
+        link = data.children[i].url;
+        if (link.substring(0,1)=='^') {
+          url = link.substring(1);
+        } else {
+          url = relPath+link;
+        }
+        result+='<li><a href="'+url+'">'+
+                                data.children[i].text+'</a>'+
+                                makeTree(data.children[i],relPath)+'</li>';
+      }
+      result+='</ul>';
+    }
+    return result;
+  }
+  var searchBoxHtml;
+  if (searchEnabled) {
+    if (serverSide) {
+      searchBoxHtml='<div id="MSearchBox" class="MSearchBoxInactive">'+
+                 '<div class="left">'+
+                  '<form id="FSearchBox" action="'+relPath+searchPage+
+                    '" method="get"><span id="MSearchSelectExt">&#160;</span>'+
+                  '<input type="text" id="MSearchField" name="query" value="" placeholder="'+search+
+                    '" size="20" accesskey="S" onfocus="searchBox.OnSearchFieldFocus(true)"'+
+                    ' onblur="searchBox.OnSearchFieldFocus(false)"/>'+
+                  '</form>'+
+                 '</div>'+
+                 '<div class="right"></div>'+
+                '</div>';
+    } else {
+      searchBoxHtml='<div id="MSearchBox" class="MSearchBoxInactive">'+
+                 '<span class="left">'+
+                  '<span id="MSearchSelect" onmouseover="return searchBox.OnSearchSelectShow()"'+
+                     ' onmouseout="return searchBox.OnSearchSelectHide()">&#160;</span>'+
+                  '<input type="text" id="MSearchField" value="" placeholder="'+search+
+                    '" accesskey="S" onfocus="searchBox.OnSearchFieldFocus(true)" '+
+                    'onblur="searchBox.OnSearchFieldFocus(false)" '+
+                    'onkeyup="searchBox.OnSearchFieldChange(event)"/>'+
+                 '</span>'+
+                 '<span class="right"><a id="MSearchClose" '+
+                  'href="javascript:searchBox.CloseResultsWindow()">'+
+                  '<img id="MSearchCloseImg" border="0" src="'+relPath+
+                  'search/close.svg" alt=""/></a>'+
+                 '</span>'+
+                '</div>';
+    }
+  }
+
+  $('#main-nav').before('<div class="sm sm-dox"><input id="main-menu-state" type="checkbox"/>'+
+                        '<label class="main-menu-btn" for="main-menu-state">'+
+                        '<span class="main-menu-btn-icon"></span> '+
+                        'Toggle main menu visibility</label>'+
+                        '<span id="searchBoxPos1" style="position:absolute;right:8px;top:8px;height:36px;"></span>'+
+                        '</div>');
+  $('#main-nav').append(makeTree(menudata,relPath));
+  $('#main-nav').children(':first').addClass('sm sm-dox').attr('id','main-menu');
+  if (searchBoxHtml) {
+    $('#main-menu').append('<li id="searchBoxPos2" style="float:right"></li>');
+  }
+  var $mainMenuState = $('#main-menu-state');
+  var prevWidth = 0;
+  if ($mainMenuState.length) {
+    function initResizableIfExists() {
+      if (typeof initResizable==='function') initResizable();
+    }
+    // animate mobile menu
+    $mainMenuState.change(function(e) {
+      var $menu = $('#main-menu');
+      var options = { duration: 250, step: initResizableIfExists };
+      if (this.checked) {
+        options['complete'] = function() { $menu.css('display', 'block') };
+        $menu.hide().slideDown(options);
+      } else {
+        options['complete'] = function() { $menu.css('display', 'none') };
+        $menu.show().slideUp(options);
+      }
+    });
+    // set default menu visibility
+    function resetState() {
+      var $menu = $('#main-menu');
+      var $mainMenuState = $('#main-menu-state');
+      var newWidth = $(window).outerWidth();
+      if (newWidth!=prevWidth) {
+        if ($(window).outerWidth()<768) {
+          $mainMenuState.prop('checked',false); $menu.hide();
+          $('#searchBoxPos1').html(searchBoxHtml);
+          $('#searchBoxPos2').hide();
+        } else {
+          $menu.show();
+          $('#searchBoxPos1').empty();
+          $('#searchBoxPos2').html(searchBoxHtml);
+          $('#searchBoxPos2').show();
+        }
+        if (typeof searchBox!=='undefined') {
+          searchBox.CloseResultsWindow();
+        }
+        prevWidth = newWidth;
+      }
+    }
+    $(window).ready(function() { resetState(); initResizableIfExists(); });
+    $(window).resize(resetState);
+  }
+  $('#main-menu').smartmenus();
+}
+/* @license-end */
diff -pruN 2.10.0-1/doc/doxygen-doc/html/menudata.js 2.11.0-1/doc/doxygen-doc/html/menudata.js
--- 2.10.0-1/doc/doxygen-doc/html/menudata.js	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/menudata.js	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,73 @@
+/*
+ @licstart  The following is the entire license notice for the JavaScript code in this file.
+
+ The MIT License (MIT)
+
+ Copyright (C) 1997-2020 by Dimitri van Heesch
+
+ Permission is hereby granted, free of charge, to any person obtaining a copy of this software
+ and associated documentation files (the "Software"), to deal in the Software without restriction,
+ including without limitation the rights to use, copy, modify, merge, publish, distribute,
+ sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
+ furnished to do so, subject to the following conditions:
+
+ The above copyright notice and this permission notice shall be included in all copies or
+ substantial portions of the Software.
+
+ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
+ BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
+ DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+
+ @licend  The above is the entire license notice for the JavaScript code in this file
+*/
+var menudata={children:[
+{text:"Main Page",url:"index.html"},
+{text:"Related Pages",url:"pages.html"},
+{text:"Topics",url:"topics.html"},
+{text:"Data Structures",url:"annotated.html",children:[
+{text:"Data Structures",url:"annotated.html"},
+{text:"Data Fields",url:"functions.html",children:[
+{text:"All",url:"functions.html",children:[
+{text:"a",url:"functions.html#index_a"},
+{text:"b",url:"functions.html#index_b"},
+{text:"c",url:"functions.html#index_c"},
+{text:"d",url:"functions.html#index_d"},
+{text:"e",url:"functions.html#index_e"},
+{text:"f",url:"functions.html#index_f"},
+{text:"g",url:"functions.html#index_g"},
+{text:"i",url:"functions.html#index_i"},
+{text:"k",url:"functions.html#index_k"},
+{text:"l",url:"functions.html#index_l"},
+{text:"m",url:"functions.html#index_m"},
+{text:"n",url:"functions.html#index_n"},
+{text:"o",url:"functions.html#index_o"},
+{text:"p",url:"functions.html#index_p"},
+{text:"r",url:"functions.html#index_r"},
+{text:"s",url:"functions.html#index_s"},
+{text:"t",url:"functions.html#index_t"},
+{text:"u",url:"functions.html#index_u"},
+{text:"v",url:"functions.html#index_v"},
+{text:"w",url:"functions.html#index_w"}]},
+{text:"Variables",url:"functions_vars.html",children:[
+{text:"a",url:"functions_vars.html#index_a"},
+{text:"b",url:"functions_vars.html#index_b"},
+{text:"c",url:"functions_vars.html#index_c"},
+{text:"d",url:"functions_vars.html#index_d"},
+{text:"e",url:"functions_vars.html#index_e"},
+{text:"f",url:"functions_vars.html#index_f"},
+{text:"g",url:"functions_vars.html#index_g"},
+{text:"i",url:"functions_vars.html#index_i"},
+{text:"k",url:"functions_vars.html#index_k"},
+{text:"l",url:"functions_vars.html#index_l"},
+{text:"m",url:"functions_vars.html#index_m"},
+{text:"n",url:"functions_vars.html#index_n"},
+{text:"o",url:"functions_vars.html#index_o"},
+{text:"p",url:"functions_vars.html#index_p"},
+{text:"r",url:"functions_vars.html#index_r"},
+{text:"s",url:"functions_vars.html#index_s"},
+{text:"t",url:"functions_vars.html#index_t"},
+{text:"u",url:"functions_vars.html#index_u"},
+{text:"v",url:"functions_vars.html#index_v"},
+{text:"w",url:"functions_vars.html#index_w"}]}]}]}]}
diff -pruN 2.10.0-1/doc/doxygen-doc/html/minus.svg 2.11.0-1/doc/doxygen-doc/html/minus.svg
--- 2.10.0-1/doc/doxygen-doc/html/minus.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/minus.svg	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,8 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg width="12px" height="12px" viewBox="0 0 105.83333 105.83333" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:svg="http://www.w3.org/2000/svg">
+  <g>
+    <rect style="fill:#808080;stroke-width:0" width="105.83333" height="105.83334" x="4.2409692e-08" y="-1.2701158e-06" ry="0" />
+    <rect style="fill:#fcfcfc;stroke-width:0" width="79.375" height="79.375" x="13.229166" y="13.229166" />
+    <rect style="fill:#808080;stroke-width:0" width="52.916668" height="15.874998" x="26.458332" y="44.979168" />
+  </g>
+</svg>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/minusd.svg 2.11.0-1/doc/doxygen-doc/html/minusd.svg
--- 2.10.0-1/doc/doxygen-doc/html/minusd.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/minusd.svg	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,8 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg width="12px" height="12px" viewBox="0 0 105.83333 105.83333" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:svg="http://www.w3.org/2000/svg">
+  <g>
+    <rect style="fill:#808080;stroke-width:0" width="105.83333" height="105.83334" x="4.2409692e-08" y="-1.2701158e-06" ry="0" />
+    <rect style="fill:#000000;stroke-width:0" width="79.375" height="79.375" x="13.229166" y="13.229166" />
+    <rect style="fill:#808080;stroke-width:0" width="52.916668" height="15.874998" x="26.458332" y="44.979168" />
+  </g>
+</svg>
Binary files 2.10.0-1/doc/doxygen-doc/html/nav_f.png and 2.11.0-1/doc/doxygen-doc/html/nav_f.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/nav_fd.png and 2.11.0-1/doc/doxygen-doc/html/nav_fd.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/nav_g.png and 2.11.0-1/doc/doxygen-doc/html/nav_g.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/nav_h.png and 2.11.0-1/doc/doxygen-doc/html/nav_h.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/nav_hd.png and 2.11.0-1/doc/doxygen-doc/html/nav_hd.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/open.png and 2.11.0-1/doc/doxygen-doc/html/open.png differ
diff -pruN 2.10.0-1/doc/doxygen-doc/html/pages.html 2.11.0-1/doc/doxygen-doc/html/pages.html
--- 2.10.0-1/doc/doxygen-doc/html/pages.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/pages.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,74 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Related Pages</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">Related Pages</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock">Here is a list of all related documentation pages:</div><div class="directory">
+<table class="directory">
+<tr id="row_0_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00374.html" target="_self">Installation</a></td><td class="desc"></td></tr>
+<tr id="row_1_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00375.html" target="_self">Compiling software on top of hwloc&#39;s C API</a></td><td class="desc"></td></tr>
+<tr id="row_2_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00376.html" target="_self">Terms and Definitions</a></td><td class="desc"></td></tr>
+<tr id="row_3_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00377.html" target="_self">Command-Line Tools</a></td><td class="desc"></td></tr>
+<tr id="row_4_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00378.html" target="_self">Environment Variables</a></td><td class="desc"></td></tr>
+<tr id="row_5_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00379.html" target="_self">CPU and Memory Binding Overview</a></td><td class="desc"></td></tr>
+<tr id="row_6_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00380.html" target="_self">I/O Devices</a></td><td class="desc"></td></tr>
+<tr id="row_7_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00381.html" target="_self">Miscellaneous objects</a></td><td class="desc"></td></tr>
+<tr id="row_8_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00382.html" target="_self">Object attributes</a></td><td class="desc"></td></tr>
+<tr id="row_9_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00383.html" target="_self">Topology Attributes: Distances, Memory Attributes and CPU Kinds</a></td><td class="desc"></td></tr>
+<tr id="row_10_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00384.html" target="_self">Heterogeneous Memory</a></td><td class="desc"></td></tr>
+<tr id="row_11_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00385.html" target="_self">Importing and exporting topologies from/to XML files</a></td><td class="desc"></td></tr>
+<tr id="row_12_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00386.html" target="_self">Synthetic topologies</a></td><td class="desc"></td></tr>
+<tr id="row_13_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00387.html" target="_self">Interoperability With Other Software</a></td><td class="desc"></td></tr>
+<tr id="row_14_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00388.html" target="_self">Thread Safety</a></td><td class="desc"></td></tr>
+<tr id="row_15_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00389.html" target="_self">Components and plugins</a></td><td class="desc"></td></tr>
+<tr id="row_16_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00390.html" target="_self">Embedding hwloc in Other Software</a></td><td class="desc"></td></tr>
+<tr id="row_17_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00391.html" target="_self">Frequently Asked Questions (FAQ)</a></td><td class="desc"></td></tr>
+<tr id="row_18_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00392.html" target="_self">Upgrading to the hwloc 2.0 API</a></td><td class="desc"></td></tr>
+</table>
+</div><!-- directory -->
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/plus.svg 2.11.0-1/doc/doxygen-doc/html/plus.svg
--- 2.10.0-1/doc/doxygen-doc/html/plus.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/plus.svg	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,9 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg width="12px" height="12px" viewBox="0 0 105.83333 105.83333" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:svg="http://www.w3.org/2000/svg">
+  <g>
+    <rect style="fill:#808080;stroke-width:0" width="105.83333" height="105.83334" x="4.2409692e-08" y="-1.2701158e-06" ry="0" />
+    <rect style="fill:#fcfcfc;stroke-width:0" width="79.375" height="79.375" x="13.229166" y="13.229166" />
+    <rect style="fill:#808080;stroke-width:0" width="52.916668" height="15.874998" x="26.458332" y="44.979168" />
+    <rect style="fill:#808080;stroke-width:0" width="15.874998" height="52.916668" x="44.979168" y="26.458332" />
+  </g>
+</svg>
diff -pruN 2.10.0-1/doc/doxygen-doc/html/plusd.svg 2.11.0-1/doc/doxygen-doc/html/plusd.svg
--- 2.10.0-1/doc/doxygen-doc/html/plusd.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/plusd.svg	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,9 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg width="12px" height="12px" viewBox="0 0 105.83333 105.83333" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:svg="http://www.w3.org/2000/svg">
+  <g>
+    <rect style="fill:#808080;stroke-width:0" width="105.83333" height="105.83334" x="4.2409692e-08" y="-1.2701158e-06" ry="0" />
+    <rect style="fill:#000000;stroke-width:0" width="79.375" height="79.375" x="13.229166" y="13.229166" />
+    <rect style="fill:#808080;stroke-width:0" width="52.916668" height="15.874998" x="26.458332" y="44.979168" />
+    <rect style="fill:#808080;stroke-width:0" width="15.874998" height="52.916668" x="44.979168" y="26.458332" />
+  </g>
+</svg>
Binary files 2.10.0-1/doc/doxygen-doc/html/ppc64-full-with-smt.png and 2.11.0-1/doc/doxygen-doc/html/ppc64-full-with-smt.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/ppc64-with-smt.png and 2.11.0-1/doc/doxygen-doc/html/ppc64-with-smt.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/ppc64-without-smt.png and 2.11.0-1/doc/doxygen-doc/html/ppc64-without-smt.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/splitbar.png and 2.11.0-1/doc/doxygen-doc/html/splitbar.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/splitbard.png and 2.11.0-1/doc/doxygen-doc/html/splitbard.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/sync_off.png and 2.11.0-1/doc/doxygen-doc/html/sync_off.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/sync_on.png and 2.11.0-1/doc/doxygen-doc/html/sync_on.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/tab_a.png and 2.11.0-1/doc/doxygen-doc/html/tab_a.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/tab_ad.png and 2.11.0-1/doc/doxygen-doc/html/tab_ad.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/tab_b.png and 2.11.0-1/doc/doxygen-doc/html/tab_b.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/tab_bd.png and 2.11.0-1/doc/doxygen-doc/html/tab_bd.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/tab_h.png and 2.11.0-1/doc/doxygen-doc/html/tab_h.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/tab_hd.png and 2.11.0-1/doc/doxygen-doc/html/tab_hd.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/tab_s.png and 2.11.0-1/doc/doxygen-doc/html/tab_s.png differ
Binary files 2.10.0-1/doc/doxygen-doc/html/tab_sd.png and 2.11.0-1/doc/doxygen-doc/html/tab_sd.png differ
diff -pruN 2.10.0-1/doc/doxygen-doc/html/tabs.css 2.11.0-1/doc/doxygen-doc/html/tabs.css
--- 2.10.0-1/doc/doxygen-doc/html/tabs.css	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/tabs.css	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.sm{position:relative;z-index:9999}.sm,.sm ul,.sm li{display:block;list-style:none;margin:0;padding:0;line-height:normal;direction:ltr;text-align:left;-webkit-tap-highlight-color:rgba(0,0,0,0)}.sm-rtl,.sm-rtl ul,.sm-rtl li{direction:rtl;text-align:right}.sm>li>h1,.sm>li>h2,.sm>li>h3,.sm>li>h4,.sm>li>h5,.sm>li>h6{margin:0;padding:0}.sm ul{display:none}.sm li,.sm a{position:relative}.sm a{display:block}.sm a.disabled{cursor:not-allowed}.sm:after{content:"\00a0";display:block;height:0;font:0px/0 serif;clear:both;visibility:hidden;overflow:hidden}.sm,.sm *,.sm *:before,.sm *:after{-moz-box-sizing:border-box;-webkit-box-sizing:border-box;box-sizing:border-box}.main-menu-btn{position:relative;display:inline-block;width:36px;height:36px;text-indent:36px;margin-left:8px;white-space:nowrap;overflow:hidden;cursor:pointer;-webkit-tap-highlight-color:rgba(0,0,0,0)}.main-menu-btn-icon,.main-menu-btn-icon:before,.main-menu-btn-icon:after{position:absolute;top:50%;left:2px;height:2px;width:24px;background:var(--nav-menu-button-color);-webkit-transition:all 0.25s;transition:all 0.25s}.main-menu-btn-icon:before{content:'';top:-7px;left:0}.main-menu-btn-icon:after{content:'';top:7px;left:0}#main-menu-state:checked~.main-menu-btn .main-menu-btn-icon{height:0}#main-menu-state:checked~.main-menu-btn .main-menu-btn-icon:before{top:0;-webkit-transform:rotate(-45deg);transform:rotate(-45deg)}#main-menu-state:checked~.main-menu-btn .main-menu-btn-icon:after{top:0;-webkit-transform:rotate(45deg);transform:rotate(45deg)}#main-menu-state{position:absolute;width:1px;height:1px;margin:-1px;border:0;padding:0;overflow:hidden;clip:rect(1px, 1px, 1px, 1px)}#main-menu-state:not(:checked)~#main-menu{display:none}#main-menu-state:checked~#main-menu{display:block}@media (min-width: 768px){.main-menu-btn{position:absolute;top:-99999px}#main-menu-state:not(:checked)~#main-menu{display:block}}.sm-dox{background-image:var(--nav-gradient-image)}.sm-dox a,.sm-dox a:focus,.sm-dox a:hover,.sm-dox a:active{padding:0px 12px;padding-right:43px;font-family:var(--font-family-nav);font-size:13px;font-weight:bold;line-height:36px;text-decoration:none;text-shadow:var(--nav-text-normal-shadow);color:var(--nav-text-normal-color);outline:none}.sm-dox a:hover{background-image:var(--nav-gradient-active-image);background-repeat:repeat-x;color:var(--nav-text-hover-color);text-shadow:var(--nav-text-hover-shadow)}.sm-dox a.current{color:#D23600}.sm-dox a.disabled{color:#bbb}.sm-dox a span.sub-arrow{position:absolute;top:50%;margin-top:-14px;left:auto;right:3px;width:28px;height:28px;overflow:hidden;font:bold 12px/28px monospace !important;text-align:center;text-shadow:none;background:var(--nav-menu-toggle-color);border-radius:5px}.sm-dox a span.sub-arrow:before{display:block;content:'+'}.sm-dox a.highlighted span.sub-arrow:before{display:block;content:'-'}.sm-dox>li:first-child>a,.sm-dox>li:first-child>:not(ul) a{border-radius:5px 5px 0 0}.sm-dox>li:last-child>a,.sm-dox>li:last-child>*:not(ul) a,.sm-dox>li:last-child>ul,.sm-dox>li:last-child>ul>li:last-child>a,.sm-dox>li:last-child>ul>li:last-child>*:not(ul) a,.sm-dox>li:last-child>ul>li:last-child>ul,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>a,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>*:not(ul) a,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>ul,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>a,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>*:not(ul) a,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>ul,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>a,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>*:not(ul) a,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>ul{border-radius:0 0 5px 5px}.sm-dox>li:last-child>a.highlighted,.sm-dox>li:last-child>*:not(ul) a.highlighted,.sm-dox>li:last-child>ul>li:last-child>a.highlighted,.sm-dox>li:last-child>ul>li:last-child>*:not(ul) a.highlighted,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>a.highlighted,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>*:not(ul) a.highlighted,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>a.highlighted,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>*:not(ul) a.highlighted,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>a.highlighted,.sm-dox>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>ul>li:last-child>*:not(ul) a.highlighted{border-radius:0}.sm-dox ul{background:var(--nav-menu-background-color)}.sm-dox ul a,.sm-dox ul a:focus,.sm-dox ul a:hover,.sm-dox ul a:active{font-size:12px;border-left:8px solid transparent;line-height:36px;text-shadow:none;background-color:var(--nav-menu-background-color);background-image:none}.sm-dox ul a:hover{background-image:var(--nav-gradient-active-image);background-repeat:repeat-x;color:var(--nav-text-hover-color);text-shadow:0px 1px 1px #000}.sm-dox ul ul a,.sm-dox ul ul a:hover,.sm-dox ul ul a:focus,.sm-dox ul ul a:active{border-left:16px solid transparent}.sm-dox ul ul ul a,.sm-dox ul ul ul a:hover,.sm-dox ul ul ul a:focus,.sm-dox ul ul ul a:active{border-left:24px solid transparent}.sm-dox ul ul ul ul a,.sm-dox ul ul ul ul a:hover,.sm-dox ul ul ul ul a:focus,.sm-dox ul ul ul ul a:active{border-left:32px solid transparent}.sm-dox ul ul ul ul ul a,.sm-dox ul ul ul ul ul a:hover,.sm-dox ul ul ul ul ul a:focus,.sm-dox ul ul ul ul ul a:active{border-left:40px solid transparent}@media (min-width: 768px){.sm-dox ul{position:absolute;width:12em}.sm-dox li{float:left}.sm-dox.sm-rtl li{float:right}.sm-dox ul li,.sm-dox.sm-rtl ul li,.sm-dox.sm-vertical li{float:none}.sm-dox a{white-space:nowrap}.sm-dox ul a,.sm-dox.sm-vertical a{white-space:normal}.sm-dox .sm-nowrap>li>a,.sm-dox .sm-nowrap>li>:not(ul) a{white-space:nowrap}.sm-dox{padding:0 10px;background-image:var(--nav-gradient-image);line-height:36px}.sm-dox a span.sub-arrow{top:50%;margin-top:-2px;right:12px;width:0;height:0;border-width:4px;border-style:solid dashed dashed dashed;border-color:var(--nav-text-normal-color) transparent transparent transparent;background:transparent;border-radius:0}.sm-dox a,.sm-dox a:focus,.sm-dox a:active,.sm-dox a:hover,.sm-dox a.highlighted{padding:0px 12px;background-image:var(--nav-separator-image);background-repeat:no-repeat;background-position:right;border-radius:0 !important}.sm-dox a:hover{background-image:var(--nav-gradient-active-image);background-repeat:repeat-x;color:var(--nav-text-hover-color);text-shadow:var(--nav-text-hover-shadow)}.sm-dox a:hover span.sub-arrow{border-color:var(--nav-text-hover-color) transparent transparent transparent}.sm-dox a.has-submenu{padding-right:24px}.sm-dox li{border-top:0}.sm-dox>li>ul:before,.sm-dox>li>ul:after{content:'';position:absolute;top:-18px;left:30px;width:0;height:0;overflow:hidden;border-width:9px;border-style:dashed dashed solid dashed;border-color:transparent transparent #bbb transparent}.sm-dox>li>ul:after{top:-16px;left:31px;border-width:8px;border-color:transparent transparent var(--nav-menu-background-color) transparent}.sm-dox ul{border:1px solid #bbb;padding:5px 0;background:var(--nav-menu-background-color);border-radius:5px !important;box-shadow:0 5px 9px rgba(0,0,0,0.2)}.sm-dox ul a span.sub-arrow{right:8px;top:50%;margin-top:-5px;border-width:5px;border-color:transparent transparent transparent var(--nav-menu-foreground-color);border-style:dashed dashed dashed solid}.sm-dox ul a,.sm-dox ul a:hover,.sm-dox ul a:focus,.sm-dox ul a:active,.sm-dox ul a.highlighted{color:var(--nav-menu-foreground-color);background-image:none;border:0 !important;color:var(--nav-menu-foreground-color);background-image:none}.sm-dox ul a:hover{background-image:var(--nav-gradient-active-image);background-repeat:repeat-x;color:var(--nav-text-hover-color);text-shadow:var(--nav-text-hover-shadow)}.sm-dox ul a:hover span.sub-arrow{border-color:transparent transparent transparent var(--nav-text-hover-color)}.sm-dox span.scroll-up,.sm-dox span.scroll-down{position:absolute;display:none;visibility:hidden;overflow:hidden;background:var(--nav-menu-background-color);height:36px}.sm-dox span.scroll-up:hover,.sm-dox span.scroll-down:hover{background:#eee}.sm-dox span.scroll-up:hover span.scroll-up-arrow,.sm-dox span.scroll-up:hover span.scroll-down-arrow{border-color:transparent transparent #D23600 transparent}.sm-dox span.scroll-down:hover span.scroll-down-arrow{border-color:#D23600 transparent transparent transparent}.sm-dox span.scroll-up-arrow,.sm-dox span.scroll-down-arrow{position:absolute;top:0;left:50%;margin-left:-6px;width:0;height:0;overflow:hidden;border-width:6px;border-style:dashed dashed solid dashed;border-color:transparent transparent var(--nav-menu-foreground-color) transparent}.sm-dox span.scroll-down-arrow{top:8px;border-style:solid dashed dashed dashed;border-color:var(--nav-menu-foreground-color) transparent transparent transparent}.sm-dox.sm-rtl a.has-submenu{padding-right:12px;padding-left:24px}.sm-dox.sm-rtl a span.sub-arrow{right:auto;left:12px}.sm-dox.sm-rtl.sm-vertical a.has-submenu{padding:10px 20px}.sm-dox.sm-rtl.sm-vertical a span.sub-arrow{right:auto;left:8px;border-style:dashed solid dashed dashed;border-color:transparent #555 transparent transparent}.sm-dox.sm-rtl>li>ul:before{left:auto;right:30px}.sm-dox.sm-rtl>li>ul:after{left:auto;right:31px}.sm-dox.sm-rtl ul a.has-submenu{padding:10px 20px !important}.sm-dox.sm-rtl ul a span.sub-arrow{right:auto;left:8px;border-style:dashed solid dashed dashed;border-color:transparent #555 transparent transparent}.sm-dox.sm-vertical{padding:10px 0;border-radius:5px}.sm-dox.sm-vertical a{padding:10px 20px}.sm-dox.sm-vertical a:hover,.sm-dox.sm-vertical a:focus,.sm-dox.sm-vertical a:active,.sm-dox.sm-vertical a.highlighted{background:#fff}.sm-dox.sm-vertical a.disabled{background-image:var(--nav-gradient-image)}.sm-dox.sm-vertical a span.sub-arrow{right:8px;top:50%;margin-top:-5px;border-width:5px;border-style:dashed dashed dashed solid;border-color:transparent transparent transparent #555}.sm-dox.sm-vertical>li>ul:before,.sm-dox.sm-vertical>li>ul:after{display:none}.sm-dox.sm-vertical ul a{padding:10px 20px}.sm-dox.sm-vertical ul a:hover,.sm-dox.sm-vertical ul a:focus,.sm-dox.sm-vertical ul a:active,.sm-dox.sm-vertical ul a.highlighted{background:#eee}.sm-dox.sm-vertical ul a.disabled{background:var(--nav-menu-background-color)}}
diff -pruN 2.10.0-1/doc/doxygen-doc/html/topics.html 2.11.0-1/doc/doxygen-doc/html/topics.html
--- 2.10.0-1/doc/doxygen-doc/html/topics.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/html/topics.html	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,111 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
+<head>
+<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<meta http-equiv="X-UA-Compatible" content="IE=11"/>
+<meta name="generator" content="Doxygen 1.9.8"/>
+<meta name="viewport" content="width=device-width, initial-scale=1"/>
+<title>Hardware Locality (hwloc): Topics</title>
+<link href="tabs.css" rel="stylesheet" type="text/css"/>
+<script type="text/javascript" src="jquery.js"></script>
+<script type="text/javascript" src="dynsections.js"></script>
+<link href="doxygen.css" rel="stylesheet" type="text/css" />
+</head>
+<body>
+<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
+<div id="titlearea">
+<table cellspacing="0" cellpadding="0">
+ <tbody>
+ <tr id="projectrow">
+  <td id="projectalign">
+   <div id="projectname">Hardware Locality (hwloc)<span id="projectnumber">&#160;2.11.0</span>
+   </div>
+  </td>
+ </tr>
+ </tbody>
+</table>
+</div>
+<!-- end header part -->
+<!-- Generated by Doxygen 1.9.8 -->
+<script type="text/javascript" src="menudata.js"></script>
+<script type="text/javascript" src="menu.js"></script>
+<script type="text/javascript">
+/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
+$(function() {
+  initMenu('',false,false,'search.php','Search');
+});
+/* @license-end */
+</script>
+<div id="main-nav"></div>
+</div><!-- top -->
+<div class="header">
+  <div class="headertitle"><div class="title">Topics</div></div>
+</div><!--header-->
+<div class="contents">
+<div class="textblock">Here is a list of all topics with brief descriptions:</div><div class="directory">
+<table class="directory">
+<tr id="row_0_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00170.html" target="_self">Error reporting in the API</a></td><td class="desc"></td></tr>
+<tr id="row_1_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00171.html" target="_self">API version</a></td><td class="desc"></td></tr>
+<tr id="row_2_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00172.html" target="_self">Object Sets (hwloc_cpuset_t and hwloc_nodeset_t)</a></td><td class="desc"></td></tr>
+<tr id="row_3_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00173.html" target="_self">Object Types</a></td><td class="desc"></td></tr>
+<tr id="row_4_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00174.html" target="_self">Object Structure and Attributes</a></td><td class="desc"></td></tr>
+<tr id="row_5_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00175.html" target="_self">Topology Creation and Destruction</a></td><td class="desc"></td></tr>
+<tr id="row_6_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00176.html" target="_self">Object levels, depths and types</a></td><td class="desc"></td></tr>
+<tr id="row_7_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00177.html" target="_self">Converting between Object Types and Attributes, and Strings</a></td><td class="desc"></td></tr>
+<tr id="row_8_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00178.html" target="_self">Consulting and Adding Info Attributes</a></td><td class="desc"></td></tr>
+<tr id="row_9_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00179.html" target="_self">CPU binding</a></td><td class="desc"></td></tr>
+<tr id="row_10_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00180.html" target="_self">Memory binding</a></td><td class="desc"></td></tr>
+<tr id="row_11_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00181.html" target="_self">Changing the Source of Topology Discovery</a></td><td class="desc"></td></tr>
+<tr id="row_12_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00182.html" target="_self">Topology Detection Configuration and Query</a></td><td class="desc"></td></tr>
+<tr id="row_13_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00183.html" target="_self">Modifying a loaded Topology</a></td><td class="desc"></td></tr>
+<tr id="row_14_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00184.html" target="_self">Kinds of object Type</a></td><td class="desc"></td></tr>
+<tr id="row_15_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00185.html" target="_self">Finding Objects inside a CPU set</a></td><td class="desc"></td></tr>
+<tr id="row_16_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00186.html" target="_self">Finding Objects covering at least CPU set</a></td><td class="desc"></td></tr>
+<tr id="row_17_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00187.html" target="_self">Looking at Ancestor and Child Objects</a></td><td class="desc"></td></tr>
+<tr id="row_18_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00188.html" target="_self">Looking at Cache Objects</a></td><td class="desc"></td></tr>
+<tr id="row_19_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00189.html" target="_self">Finding objects, miscellaneous helpers</a></td><td class="desc"></td></tr>
+<tr id="row_20_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00190.html" target="_self">Distributing items over a topology</a></td><td class="desc"></td></tr>
+<tr id="row_21_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00191.html" target="_self">CPU and node sets of entire topologies</a></td><td class="desc"></td></tr>
+<tr id="row_22_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00192.html" target="_self">Converting between CPU sets and node sets</a></td><td class="desc"></td></tr>
+<tr id="row_23_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00193.html" target="_self">Finding I/O objects</a></td><td class="desc"></td></tr>
+<tr id="row_24_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00194.html" target="_self">The bitmap API</a></td><td class="desc"></td></tr>
+<tr id="row_25_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00195.html" target="_self">Exporting Topologies to XML</a></td><td class="desc"></td></tr>
+<tr id="row_26_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00196.html" target="_self">Exporting Topologies to Synthetic</a></td><td class="desc"></td></tr>
+<tr id="row_27_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00197.html" target="_self">Retrieve distances between objects</a></td><td class="desc"></td></tr>
+<tr id="row_28_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00198.html" target="_self">Helpers for consulting distance matrices</a></td><td class="desc"></td></tr>
+<tr id="row_29_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00199.html" target="_self">Add distances between objects</a></td><td class="desc"></td></tr>
+<tr id="row_30_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00200.html" target="_self">Remove distances between objects</a></td><td class="desc"></td></tr>
+<tr id="row_31_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00201.html" target="_self">Comparing memory node attributes for finding where to allocate on</a></td><td class="desc"></td></tr>
+<tr id="row_32_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00202.html" target="_self">Managing memory attributes</a></td><td class="desc"></td></tr>
+<tr id="row_33_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00203.html" target="_self">Kinds of CPU cores</a></td><td class="desc"></td></tr>
+<tr id="row_34_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00204.html" target="_self">Linux-specific helpers</a></td><td class="desc"></td></tr>
+<tr id="row_35_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00205.html" target="_self">Interoperability with Linux libnuma unsigned long masks</a></td><td class="desc"></td></tr>
+<tr id="row_36_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00206.html" target="_self">Interoperability with Linux libnuma bitmask</a></td><td class="desc"></td></tr>
+<tr id="row_37_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00207.html" target="_self">Windows-specific helpers</a></td><td class="desc"></td></tr>
+<tr id="row_38_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00208.html" target="_self">Interoperability with glibc sched affinity</a></td><td class="desc"></td></tr>
+<tr id="row_39_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00209.html" target="_self">Interoperability with OpenCL</a></td><td class="desc"></td></tr>
+<tr id="row_40_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00210.html" target="_self">Interoperability with the CUDA Driver API</a></td><td class="desc"></td></tr>
+<tr id="row_41_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00211.html" target="_self">Interoperability with the CUDA Runtime API</a></td><td class="desc"></td></tr>
+<tr id="row_42_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00212.html" target="_self">Interoperability with the NVIDIA Management Library</a></td><td class="desc"></td></tr>
+<tr id="row_43_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00213.html" target="_self">Interoperability with the ROCm SMI Management Library</a></td><td class="desc"></td></tr>
+<tr id="row_44_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00214.html" target="_self">Interoperability with the oneAPI Level Zero interface.</a></td><td class="desc"></td></tr>
+<tr id="row_45_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00215.html" target="_self">Interoperability with OpenGL displays</a></td><td class="desc"></td></tr>
+<tr id="row_46_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00216.html" target="_self">Interoperability with OpenFabrics</a></td><td class="desc"></td></tr>
+<tr id="row_47_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00217.html" target="_self">Topology differences</a></td><td class="desc"></td></tr>
+<tr id="row_48_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00218.html" target="_self">Sharing topologies between processes</a></td><td class="desc"></td></tr>
+<tr id="row_49_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00219.html" target="_self">Components and Plugins: Discovery components</a></td><td class="desc"></td></tr>
+<tr id="row_50_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00220.html" target="_self">Components and Plugins: Discovery backends</a></td><td class="desc"></td></tr>
+<tr id="row_51_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00221.html" target="_self">Components and Plugins: Generic components</a></td><td class="desc"></td></tr>
+<tr id="row_52_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00222.html" target="_self">Components and Plugins: Core functions to be used by components</a></td><td class="desc"></td></tr>
+<tr id="row_53_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00223.html" target="_self">Components and Plugins: Filtering objects</a></td><td class="desc"></td></tr>
+<tr id="row_54_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00224.html" target="_self">Components and Plugins: helpers for PCI discovery</a></td><td class="desc"></td></tr>
+<tr id="row_55_" class="odd"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><a class="el" href="a00225.html" target="_self">Components and Plugins: finding PCI objects during other discoveries</a></td><td class="desc"></td></tr>
+</table>
+</div><!-- directory -->
+</div><!-- contents -->
+<!-- start footer part -->
+<hr class="footer"/><address class="footer"><small>
+Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8
+</small></address>
+</body>
+</html>
Binary files 2.10.0-1/doc/doxygen-doc/hwloc-a4.pdf and 2.11.0-1/doc/doxygen-doc/hwloc-a4.pdf differ
Binary files 2.10.0-1/doc/doxygen-doc/hwloc-letter.pdf and 2.11.0-1/doc/doxygen-doc/hwloc-letter.pdf differ
diff -pruN 2.10.0-1/doc/doxygen-doc/hwloc.tag 2.11.0-1/doc/doxygen-doc/hwloc.tag
--- 2.10.0-1/doc/doxygen-doc/hwloc.tag	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/hwloc.tag	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,5201 @@
+<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>
+<tagfile doxygen_version="1.9.8">
+  <compound kind="struct">
+    <name>hwloc_backend</name>
+    <filename>a00369.html</filename>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>phases</name>
+      <anchorfile>a00369.html</anchorfile>
+      <anchor>aeca769840a6ff03e96462a9533adbccd</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned long</type>
+      <name>flags</name>
+      <anchorfile>a00369.html</anchorfile>
+      <anchor>aaa8eafe495aadd81c2e3c4ec527c10ba</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>int</type>
+      <name>is_thissystem</name>
+      <anchorfile>a00369.html</anchorfile>
+      <anchor>ab8806f6db077f1bb2e9d63ec99223f7a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>void *</type>
+      <name>private_data</name>
+      <anchorfile>a00369.html</anchorfile>
+      <anchor>a2ea5bd36b7f06efdb65b98b32af16c68</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>void(*</type>
+      <name>disable</name>
+      <anchorfile>a00369.html</anchorfile>
+      <anchor>a36c4fa86350525b46340c67b802c69c7</anchor>
+      <arglist>)(struct hwloc_backend *backend)</arglist>
+    </member>
+    <member kind="variable">
+      <type>int(*</type>
+      <name>discover</name>
+      <anchorfile>a00369.html</anchorfile>
+      <anchor>accff2cd8404be43c3b44cec05e6f609b</anchor>
+      <arglist>)(struct hwloc_backend *backend, struct hwloc_disc_status *status)</arglist>
+    </member>
+    <member kind="variable">
+      <type>int(*</type>
+      <name>get_pci_busid_cpuset</name>
+      <anchorfile>a00369.html</anchorfile>
+      <anchor>aaac253491264c20930f44817270bc502</anchor>
+      <arglist>)(struct hwloc_backend *backend, struct hwloc_pcidev_attr_s *busid, hwloc_bitmap_t cpuset)</arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_obj_attr_u::hwloc_bridge_attr_s</name>
+    <filename>a00257.html</filename>
+    <member kind="variable">
+      <type>struct hwloc_pcidev_attr_s</type>
+      <name>pci</name>
+      <anchorfile>a00257.html</anchorfile>
+      <anchor>ab5c564e7c95b747dae9eb84ec0a2c31e</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>union hwloc_obj_attr_u::hwloc_bridge_attr_s::@2</type>
+      <name>upstream</name>
+      <anchorfile>a00257.html</anchorfile>
+      <anchor>a94647ccf58afd32602f584b47a0321ce</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_obj_bridge_type_t</type>
+      <name>upstream_type</name>
+      <anchorfile>a00257.html</anchorfile>
+      <anchor>a265dd2164aa2df4972e25a029da72125</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned short</type>
+      <name>domain</name>
+      <anchorfile>a00257.html</anchorfile>
+      <anchor>a2c31e565a5f0d23d0a0a3dd3ec8f4b17</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>secondary_bus</name>
+      <anchorfile>a00257.html</anchorfile>
+      <anchor>ae2d9dd73ef1d32045c584a8e66d2f83f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>subordinate_bus</name>
+      <anchorfile>a00257.html</anchorfile>
+      <anchor>af3f3f7d76bf03e8d2afa721c2b8d6771</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj_attr_u::hwloc_bridge_attr_s::@3::@4</type>
+      <name>pci</name>
+      <anchorfile>a00257.html</anchorfile>
+      <anchor>ac83cbe90209860113e54d86f90b71307</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>union hwloc_obj_attr_u::hwloc_bridge_attr_s::@3</type>
+      <name>downstream</name>
+      <anchorfile>a00257.html</anchorfile>
+      <anchor>abe1e38eb5ac8dc59829c8dc045f0d747</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_obj_bridge_type_t</type>
+      <name>downstream_type</name>
+      <anchorfile>a00257.html</anchorfile>
+      <anchor>ac6a169b672d0e9f75756fd5665828b93</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>depth</name>
+      <anchorfile>a00257.html</anchorfile>
+      <anchor>a336c8b22893d5d734d8c9dfca4066b46</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_obj_attr_u::hwloc_cache_attr_s</name>
+    <filename>a00245.html</filename>
+    <member kind="variable">
+      <type>hwloc_uint64_t</type>
+      <name>size</name>
+      <anchorfile>a00245.html</anchorfile>
+      <anchor>abe5e788943ed04302976740c829674c0</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>depth</name>
+      <anchorfile>a00245.html</anchorfile>
+      <anchor>a5c8f7f39193736c2187ed626940835d5</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>linesize</name>
+      <anchorfile>a00245.html</anchorfile>
+      <anchor>a801e8a668e28caf06c8b88e9ae5c10db</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>int</type>
+      <name>associativity</name>
+      <anchorfile>a00245.html</anchorfile>
+      <anchor>ad06525e474d1e2d1423ed71bb998592d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_obj_cache_type_t</type>
+      <name>type</name>
+      <anchorfile>a00245.html</anchorfile>
+      <anchor>ad8edc8ded2b7a70d6abbc874801930f4</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_cl_device_pci_bus_info_khr</name>
+    <filename>a00313.html</filename>
+    <member kind="variable">
+      <type>cl_uint</type>
+      <name>pci_domain</name>
+      <anchorfile>a00313.html</anchorfile>
+      <anchor>a5bdfbcb0dee610f9f6f7f95ace89e298</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>cl_uint</type>
+      <name>pci_bus</name>
+      <anchorfile>a00313.html</anchorfile>
+      <anchor>a0e4d316b01eee00c3750d1c853be9c01</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>cl_uint</type>
+      <name>pci_device</name>
+      <anchorfile>a00313.html</anchorfile>
+      <anchor>a328717bdaeb2d117c550927cf41e6f72</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>cl_uint</type>
+      <name>pci_function</name>
+      <anchorfile>a00313.html</anchorfile>
+      <anchor>ab4032f46a44cf9ffc7b2ddc25001e3f0</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="union">
+    <name>hwloc_cl_device_topology_amd</name>
+    <filename>a00317.html</filename>
+    <member kind="variable">
+      <type>cl_uint</type>
+      <name>type</name>
+      <anchorfile>a00317.html</anchorfile>
+      <anchor>a8ec4ea89b862bb271845b48063f332b4</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>cl_uint</type>
+      <name>data</name>
+      <anchorfile>a00317.html</anchorfile>
+      <anchor>afbd6b814607b06fc5b2f36ad14420398</anchor>
+      <arglist>[5]</arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_cl_device_topology_amd::@0</type>
+      <name>raw</name>
+      <anchorfile>a00317.html</anchorfile>
+      <anchor>aeb5e5d12bf653f750dafedae6e225c3a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>cl_char</type>
+      <name>unused</name>
+      <anchorfile>a00317.html</anchorfile>
+      <anchor>ac8650d7eea96eef290481fee980d1d47</anchor>
+      <arglist>[17]</arglist>
+    </member>
+    <member kind="variable">
+      <type>cl_char</type>
+      <name>bus</name>
+      <anchorfile>a00317.html</anchorfile>
+      <anchor>a4a23e3cc034b7ab105cab0e863dcab69</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>cl_char</type>
+      <name>device</name>
+      <anchorfile>a00317.html</anchorfile>
+      <anchor>a017033a953d71455b067007cabb92e9c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>cl_char</type>
+      <name>function</name>
+      <anchorfile>a00317.html</anchorfile>
+      <anchor>a77a67ac73cff98d330ef7258b240bac3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_cl_device_topology_amd::@1</type>
+      <name>pcie</name>
+      <anchorfile>a00317.html</anchorfile>
+      <anchor>aef8560f6c359be0c5bdbd2840580d79c</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_component</name>
+    <filename>a00373.html</filename>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>abi</name>
+      <anchorfile>a00373.html</anchorfile>
+      <anchor>a3250bd6fc9713946991d805e48091b2e</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>int(*</type>
+      <name>init</name>
+      <anchorfile>a00373.html</anchorfile>
+      <anchor>aea613546886d9b8221cadba920fe3ebc</anchor>
+      <arglist>)(unsigned long flags)</arglist>
+    </member>
+    <member kind="variable">
+      <type>void(*</type>
+      <name>finalize</name>
+      <anchorfile>a00373.html</anchorfile>
+      <anchor>a4612015451a1c706e8ba19114cb8baae</anchor>
+      <arglist>)(unsigned long flags)</arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_component_type_t</type>
+      <name>type</name>
+      <anchorfile>a00373.html</anchorfile>
+      <anchor>a789208ada7e17492cfd3a5a88a6bb0ee</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned long</type>
+      <name>flags</name>
+      <anchorfile>a00373.html</anchorfile>
+      <anchor>ab8043c5b4cc0e81aabba586ccb194335</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>void *</type>
+      <name>data</name>
+      <anchorfile>a00373.html</anchorfile>
+      <anchor>a4b8cffd1d943c29fdc102b841b8598d4</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_disc_component</name>
+    <filename>a00361.html</filename>
+    <member kind="variable">
+      <type>const char *</type>
+      <name>name</name>
+      <anchorfile>a00361.html</anchorfile>
+      <anchor>a4064c3b5d9213027e87caebef380a840</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>phases</name>
+      <anchorfile>a00361.html</anchorfile>
+      <anchor>a61ad3151efa02e3dbad5d919758f9c90</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>excluded_phases</name>
+      <anchorfile>a00361.html</anchorfile>
+      <anchor>acbb9957914dbf7b8f504215aa0c8d3fe</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_backend *(*</type>
+      <name>instantiate</name>
+      <anchorfile>a00361.html</anchorfile>
+      <anchor>a12e780d0acf89da7a8c8e37e51a3abcb</anchor>
+      <arglist>)(struct hwloc_topology *topology, struct hwloc_disc_component *component, unsigned excluded_phases, const void *data1, const void *data2, const void *data3)</arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>priority</name>
+      <anchorfile>a00361.html</anchorfile>
+      <anchor>ae86d283c272c5ae24073a235efbf6b59</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>enabled_by_default</name>
+      <anchorfile>a00361.html</anchorfile>
+      <anchor>ace80cafe2b1732b047b3fc3da47e6517</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_disc_status</name>
+    <filename>a00365.html</filename>
+    <member kind="variable">
+      <type>hwloc_disc_phase_t</type>
+      <name>phase</name>
+      <anchorfile>a00365.html</anchorfile>
+      <anchor>abaf7c8c082d43e133171f0723dbf824b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>excluded_phases</name>
+      <anchorfile>a00365.html</anchorfile>
+      <anchor>a0f95fa42d46a6e7cf8dee8af12afee3a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned long</type>
+      <name>flags</name>
+      <anchorfile>a00365.html</anchorfile>
+      <anchor>ad8b123cecb945a9182eb824ccf8ef9d7</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_distances_s</name>
+    <filename>a00301.html</filename>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>nbobjs</name>
+      <anchorfile>a00301.html</anchorfile>
+      <anchor>a4ca2af858cebbce7324ec49903d09474</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_obj_t *</type>
+      <name>objs</name>
+      <anchorfile>a00301.html</anchorfile>
+      <anchor>af1e78b2d628d191fa6cae3fbfe891078</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned long</type>
+      <name>kind</name>
+      <anchorfile>a00301.html</anchorfile>
+      <anchor>aef9c83cf467da1b1fa4c36493febb3b5</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_uint64_t *</type>
+      <name>values</name>
+      <anchorfile>a00301.html</anchorfile>
+      <anchor>ae43e19b2c743de05c93d71a30beaca75</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_obj_attr_u::hwloc_group_attr_s</name>
+    <filename>a00249.html</filename>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>depth</name>
+      <anchorfile>a00249.html</anchorfile>
+      <anchor>ad914eac61c77481e1b7037877bcc5579</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>kind</name>
+      <anchorfile>a00249.html</anchorfile>
+      <anchor>a3229f269c4cc7e63492c168535e4f0c1</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>subkind</name>
+      <anchorfile>a00249.html</anchorfile>
+      <anchor>ad514d943960a4036ed5e44dc187c74ed</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>dont_merge</name>
+      <anchorfile>a00249.html</anchorfile>
+      <anchor>afa253d4b70f92e940c226d61f192054f</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_info_s</name>
+    <filename>a00277.html</filename>
+    <member kind="variable">
+      <type>char *</type>
+      <name>name</name>
+      <anchorfile>a00277.html</anchorfile>
+      <anchor>a12ce1309e4381ae38b5c15d242a47124</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>char *</type>
+      <name>value</name>
+      <anchorfile>a00277.html</anchorfile>
+      <anchor>a788a0073bafe660645e7b69f31a43bbb</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_location</name>
+    <filename>a00305.html</filename>
+    <class kind="union">hwloc_location::hwloc_location_u</class>
+    <member kind="variable">
+      <type>enum hwloc_location_type_e</type>
+      <name>type</name>
+      <anchorfile>a00305.html</anchorfile>
+      <anchor>aeb9c0ab74a7d3506a76d0b82600a28a7</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>union hwloc_location::hwloc_location_u</type>
+      <name>location</name>
+      <anchorfile>a00305.html</anchorfile>
+      <anchor>a707a25a5b65177e4d081be49aa0777a2</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="union">
+    <name>hwloc_location::hwloc_location_u</name>
+    <filename>a00309.html</filename>
+    <member kind="variable">
+      <type>hwloc_cpuset_t</type>
+      <name>cpuset</name>
+      <anchorfile>a00309.html</anchorfile>
+      <anchor>a033bad8f6b891992f0c18b85a88c5561</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_obj_t</type>
+      <name>object</name>
+      <anchorfile>a00309.html</anchorfile>
+      <anchor>acf2ebf75869f0a53a884ac2ab3374122</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s</name>
+    <filename>a00241.html</filename>
+    <member kind="variable">
+      <type>hwloc_uint64_t</type>
+      <name>size</name>
+      <anchorfile>a00241.html</anchorfile>
+      <anchor>a8ea7ebe9d91c7378bba03da57efc25cb</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_uint64_t</type>
+      <name>count</name>
+      <anchorfile>a00241.html</anchorfile>
+      <anchor>a98514e37d57a325b78e21ffd8d7419e0</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_obj_attr_u::hwloc_numanode_attr_s</name>
+    <filename>a00237.html</filename>
+    <class kind="struct">hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s</class>
+    <member kind="variable">
+      <type>hwloc_uint64_t</type>
+      <name>local_memory</name>
+      <anchorfile>a00237.html</anchorfile>
+      <anchor>a6703cbf2afbf63c9d60c5ff4dc0c73aa</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>page_types_len</name>
+      <anchorfile>a00237.html</anchorfile>
+      <anchor>a513078122d403904e16723d30f583cb2</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s *</type>
+      <name>page_types</name>
+      <anchorfile>a00237.html</anchorfile>
+      <anchor>a7e53c5024da2d7741a5cc1e7016bb8d2</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_obj</name>
+    <filename>a00229.html</filename>
+    <member kind="variable">
+      <type>hwloc_obj_type_t</type>
+      <name>type</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>acc4f0803f244867e68fe0036800be5de</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>char *</type>
+      <name>subtype</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a5d4f97e76723a9ec8d38046f19e00d33</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>os_index</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a61a7a80a68eaccbaaa28269e678c81a9</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>char *</type>
+      <name>name</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>abb709ec38f2970677e4e57d1d30be96d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_uint64_t</type>
+      <name>total_memory</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a75603fc36c9284ba48ce814b772a58b6</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>union hwloc_obj_attr_u *</type>
+      <name>attr</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>accd40e29f71f19e88db62ea3df02adc8</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>int</type>
+      <name>depth</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a4876fd165b4fff35521f07ebd85355ed</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>logical_index</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a0d07fb7b8935e137c94d75a3eb492ae9</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>next_cousin</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a85a788017457129589318b6c39451acf</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>prev_cousin</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>ac715989f55ff5a0eb6be2969ee477ec0</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>parent</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>adc494f6aed939992be1c55cca5822900</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>sibling_rank</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>aaa6043eee6f55869933c1d974efd9acd</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>next_sibling</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a7f2343ed476fe4942e6fffd4cade1b40</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>prev_sibling</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a7b89e8c189876c0158a9282aaaf17f50</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>int</type>
+      <name>symmetric_subtree</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a0f41a1d67dc6b661906f2217563637f3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_cpuset_t</type>
+      <name>cpuset</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a67925e0f2c47f50408fbdb9bddd0790f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_cpuset_t</type>
+      <name>complete_cpuset</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a91788a9da687beb7224cc1fd7b75208c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_nodeset_t</type>
+      <name>nodeset</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a08f0d0e16c619a6e653526cbee4ffea3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_nodeset_t</type>
+      <name>complete_nodeset</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>ac38c4012127525ef74c5615c526f4c2e</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_info_s *</type>
+      <name>infos</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a8604654c38b7a720efae5025d3a96ee6</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>infos_count</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a9843acc28cfbba903b63ea14b137ff70</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>void *</type>
+      <name>userdata</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a76fd3ac94401cf32dfccc3a3a8de68a5</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_uint64_t</type>
+      <name>gp_index</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a957984a355fa61c85f46605c336e7551</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>arity</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>aac3f6da35c9b57599909a44ce2b716c1</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj **</type>
+      <name>children</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a04d05403da37bfe17cd63b7c7dd07b1f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>first_child</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>af51d08a0a79dba517c06c5afedc8d2dc</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>last_child</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a84bd65634dbc55f4158b74443a9bd04f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>memory_arity</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a6f834ea4dd26553cdea601d2fae6d3b7</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>memory_first_child</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>ac0e8200dba25b90d5954bd4ec61f97d3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>io_arity</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a7b3b29f0be377c7d2d52262019fc7d11</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>io_first_child</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a8d14c88e1ebc4ae67cc69f9e928558b3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>misc_arity</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a2bb7862ce722d7ceda23cfa153da165a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>misc_first_child</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a57812a313fe9b1a9500489f47c3011cc</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>arity</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>aac3f6da35c9b57599909a44ce2b716c1</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj **</type>
+      <name>children</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a04d05403da37bfe17cd63b7c7dd07b1f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>first_child</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>af51d08a0a79dba517c06c5afedc8d2dc</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>last_child</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a84bd65634dbc55f4158b74443a9bd04f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>memory_arity</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a6f834ea4dd26553cdea601d2fae6d3b7</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>memory_first_child</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>ac0e8200dba25b90d5954bd4ec61f97d3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>io_arity</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a7b3b29f0be377c7d2d52262019fc7d11</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>io_first_child</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a8d14c88e1ebc4ae67cc69f9e928558b3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>misc_arity</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a2bb7862ce722d7ceda23cfa153da165a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj *</type>
+      <name>misc_first_child</name>
+      <anchorfile>a00229.html</anchorfile>
+      <anchor>a57812a313fe9b1a9500489f47c3011cc</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="union">
+    <name>hwloc_obj_attr_u</name>
+    <filename>a00233.html</filename>
+    <class kind="struct">hwloc_obj_attr_u::hwloc_bridge_attr_s</class>
+    <class kind="struct">hwloc_obj_attr_u::hwloc_cache_attr_s</class>
+    <class kind="struct">hwloc_obj_attr_u::hwloc_group_attr_s</class>
+    <class kind="struct">hwloc_obj_attr_u::hwloc_numanode_attr_s</class>
+    <class kind="struct">hwloc_obj_attr_u::hwloc_osdev_attr_s</class>
+    <class kind="struct">hwloc_obj_attr_u::hwloc_pcidev_attr_s</class>
+    <member kind="variable">
+      <type>struct hwloc_obj_attr_u::hwloc_numanode_attr_s</type>
+      <name>numanode</name>
+      <anchorfile>a00233.html</anchorfile>
+      <anchor>ad066b9612802ffa01e132dc3a8e6cc86</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj_attr_u::hwloc_cache_attr_s</type>
+      <name>cache</name>
+      <anchorfile>a00233.html</anchorfile>
+      <anchor>a23f553f3252c9d13f2338231cd354ea9</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj_attr_u::hwloc_group_attr_s</type>
+      <name>group</name>
+      <anchorfile>a00233.html</anchorfile>
+      <anchor>a9eddbd69e34cd2ef6af6d2ac31b6eff3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj_attr_u::hwloc_pcidev_attr_s</type>
+      <name>pcidev</name>
+      <anchorfile>a00233.html</anchorfile>
+      <anchor>a0b66da7ab072f7c016f8ed86701f5a7c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj_attr_u::hwloc_bridge_attr_s</type>
+      <name>bridge</name>
+      <anchorfile>a00233.html</anchorfile>
+      <anchor>a207e6359497b7116d6f4baa9e8bbeb43</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_obj_attr_u::hwloc_osdev_attr_s</type>
+      <name>osdev</name>
+      <anchorfile>a00233.html</anchorfile>
+      <anchor>aaf7a5c38b5185703ff18c46ad2761dcf</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_obj_attr_u::hwloc_osdev_attr_s</name>
+    <filename>a00273.html</filename>
+    <member kind="variable">
+      <type>hwloc_obj_osdev_type_t</type>
+      <name>type</name>
+      <anchorfile>a00273.html</anchorfile>
+      <anchor>a31e019e27e54ac6138d04be639bb96f9</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_obj_attr_u::hwloc_pcidev_attr_s</name>
+    <filename>a00253.html</filename>
+    <member kind="variable">
+      <type>unsigned short</type>
+      <name>domain</name>
+      <anchorfile>a00253.html</anchorfile>
+      <anchor>a8fba44988deb98613c1505a4019a34dc</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>bus</name>
+      <anchorfile>a00253.html</anchorfile>
+      <anchor>aae99e035e8d1387d7b8768aaa8eceb0a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>dev</name>
+      <anchorfile>a00253.html</anchorfile>
+      <anchor>a3d70c84a12f7e93d14c8d47bf4fd9dc5</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>func</name>
+      <anchorfile>a00253.html</anchorfile>
+      <anchor>a695f32df53f4ef728670bfcf31b74e0f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned short</type>
+      <name>class_id</name>
+      <anchorfile>a00253.html</anchorfile>
+      <anchor>aee735352d9f1686fd290fc6d6397c334</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned short</type>
+      <name>vendor_id</name>
+      <anchorfile>a00253.html</anchorfile>
+      <anchor>aad970ad19b62eb2d5df30e4802da4f4c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned short</type>
+      <name>device_id</name>
+      <anchorfile>a00253.html</anchorfile>
+      <anchor>a35b66064ab7d768caf7154e410caf0fa</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned short</type>
+      <name>subvendor_id</name>
+      <anchorfile>a00253.html</anchorfile>
+      <anchor>a499db3d8cc89eaba04fcaef3df1cba97</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned short</type>
+      <name>subdevice_id</name>
+      <anchorfile>a00253.html</anchorfile>
+      <anchor>acac741aecd7a6db64f33409427e3971f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>revision</name>
+      <anchorfile>a00253.html</anchorfile>
+      <anchor>a13ad54c93d08d8ac808e4de9674c5ee7</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>float</type>
+      <name>linkspeed</name>
+      <anchorfile>a00253.html</anchorfile>
+      <anchor>a59b2fce35f7cbde86c4fd305d0ccda5f</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_topology_cpubind_support</name>
+    <filename>a00285.html</filename>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>set_thisproc_cpubind</name>
+      <anchorfile>a00285.html</anchorfile>
+      <anchor>a9403d51657a4d546b3ea9553a2973a27</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_thisproc_cpubind</name>
+      <anchorfile>a00285.html</anchorfile>
+      <anchor>a77a09ddd78ee3e9ff5f532a6ac74f7eb</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>set_proc_cpubind</name>
+      <anchorfile>a00285.html</anchorfile>
+      <anchor>aa166223d1c2a6de7256ab2d8b675a87e</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_proc_cpubind</name>
+      <anchorfile>a00285.html</anchorfile>
+      <anchor>aae705bc447adc163ead377362c4dfe9f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>set_thisthread_cpubind</name>
+      <anchorfile>a00285.html</anchorfile>
+      <anchor>a57a89a4b5f1f74fa6cfe176f1e8b0798</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_thisthread_cpubind</name>
+      <anchorfile>a00285.html</anchorfile>
+      <anchor>a80d762e532d677dff262d83cc7bb1c60</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>set_thread_cpubind</name>
+      <anchorfile>a00285.html</anchorfile>
+      <anchor>a46fba33e307909ce256624687799dd6d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_thread_cpubind</name>
+      <anchorfile>a00285.html</anchorfile>
+      <anchor>a8dd4d8531ed2eebdce1507e7d104154e</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_thisproc_last_cpu_location</name>
+      <anchorfile>a00285.html</anchorfile>
+      <anchor>ad2d5c94b738d92b7d2ede87e4e96321d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_proc_last_cpu_location</name>
+      <anchorfile>a00285.html</anchorfile>
+      <anchor>a2554620148b7992a5093f338f5ae254f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_thisthread_last_cpu_location</name>
+      <anchorfile>a00285.html</anchorfile>
+      <anchor>a6be1f042fdce6bf41b4ea39f6f193808</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_topology_diff_u::hwloc_topology_diff_generic_s</name>
+    <filename>a00349.html</filename>
+    <member kind="variable">
+      <type>hwloc_topology_diff_type_t</type>
+      <name>type</name>
+      <anchorfile>a00349.html</anchorfile>
+      <anchor>a373005489fcddeba6319163e60263ae8</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>union hwloc_topology_diff_u *</type>
+      <name>next</name>
+      <anchorfile>a00349.html</anchorfile>
+      <anchor>a720aa94eb73cddfd8d6bf9fcbbfc035e</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s</name>
+    <filename>a00333.html</filename>
+    <member kind="variable">
+      <type>hwloc_topology_diff_obj_attr_type_t</type>
+      <name>type</name>
+      <anchorfile>a00333.html</anchorfile>
+      <anchor>a43f8133b7c30129b002c2d295e6580fc</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</name>
+    <filename>a00353.html</filename>
+    <member kind="variable">
+      <type>hwloc_topology_diff_type_t</type>
+      <name>type</name>
+      <anchorfile>a00353.html</anchorfile>
+      <anchor>a70a118ad288bd98f18c8ce6dc52e2d10</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>union hwloc_topology_diff_u *</type>
+      <name>next</name>
+      <anchorfile>a00353.html</anchorfile>
+      <anchor>acb9170a8eb3392656d70f7f3ef3e3eed</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>int</type>
+      <name>obj_depth</name>
+      <anchorfile>a00353.html</anchorfile>
+      <anchor>a82c1d4bab80b9e0bf301a9d8291893e0</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>obj_index</name>
+      <anchorfile>a00353.html</anchorfile>
+      <anchor>adb9f4d414470b6670cde8d90759a6c1c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>union hwloc_topology_diff_obj_attr_u</type>
+      <name>diff</name>
+      <anchorfile>a00353.html</anchorfile>
+      <anchor>a91f0645f9062e892652357cd141c8ebb</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</name>
+    <filename>a00341.html</filename>
+    <member kind="variable">
+      <type>hwloc_topology_diff_obj_attr_type_t</type>
+      <name>type</name>
+      <anchorfile>a00341.html</anchorfile>
+      <anchor>a784ab5827c1bf531b86d1f02f199d04d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>char *</type>
+      <name>name</name>
+      <anchorfile>a00341.html</anchorfile>
+      <anchor>a7ef48c66ccddf34d90edb4e4314b41c6</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>char *</type>
+      <name>oldvalue</name>
+      <anchorfile>a00341.html</anchorfile>
+      <anchor>a33cc281d4417129064295a6ae7b79818</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>char *</type>
+      <name>newvalue</name>
+      <anchorfile>a00341.html</anchorfile>
+      <anchor>a75f37f4add21cece50fee2701c3b77db</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="union">
+    <name>hwloc_topology_diff_obj_attr_u</name>
+    <filename>a00329.html</filename>
+    <class kind="struct">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s</class>
+    <class kind="struct">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</class>
+    <class kind="struct">hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</class>
+    <member kind="variable">
+      <type>struct hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s</type>
+      <name>generic</name>
+      <anchorfile>a00329.html</anchorfile>
+      <anchor>aeb449c0e04b14ebf8c3126756b6364f9</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</type>
+      <name>uint64</name>
+      <anchorfile>a00329.html</anchorfile>
+      <anchor>a4608ade88460f5f208887775e5a69a0a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s</type>
+      <name>string</name>
+      <anchorfile>a00329.html</anchorfile>
+      <anchor>a42fa15c37f1f59ef638066c4c62c3154</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s</name>
+    <filename>a00337.html</filename>
+    <member kind="variable">
+      <type>hwloc_topology_diff_obj_attr_type_t</type>
+      <name>type</name>
+      <anchorfile>a00337.html</anchorfile>
+      <anchor>afe262b9aa558fe7bfecbd37a7a129197</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_uint64_t</type>
+      <name>index</name>
+      <anchorfile>a00337.html</anchorfile>
+      <anchor>adb772c3f1761ecadf496c80ae14afce3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_uint64_t</type>
+      <name>oldvalue</name>
+      <anchorfile>a00337.html</anchorfile>
+      <anchor>a44c0894dce563335d347fde6595c49c9</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>hwloc_uint64_t</type>
+      <name>newvalue</name>
+      <anchorfile>a00337.html</anchorfile>
+      <anchor>ae63aa59ad65aa783b730a4f213304eb4</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</name>
+    <filename>a00357.html</filename>
+    <member kind="variable">
+      <type>hwloc_topology_diff_type_t</type>
+      <name>type</name>
+      <anchorfile>a00357.html</anchorfile>
+      <anchor>a92084295a4d6faf17a95a7eea526ddbd</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>union hwloc_topology_diff_u *</type>
+      <name>next</name>
+      <anchorfile>a00357.html</anchorfile>
+      <anchor>a375afbaa043b109be689a7d9a3c7d153</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>int</type>
+      <name>obj_depth</name>
+      <anchorfile>a00357.html</anchorfile>
+      <anchor>a94c6498caeaafbb79927395d918d6cb3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned</type>
+      <name>obj_index</name>
+      <anchorfile>a00357.html</anchorfile>
+      <anchor>a6dc6b3c4adb10db74d993e37afaa0580</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="union">
+    <name>hwloc_topology_diff_u</name>
+    <filename>a00345.html</filename>
+    <class kind="struct">hwloc_topology_diff_u::hwloc_topology_diff_generic_s</class>
+    <class kind="struct">hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</class>
+    <class kind="struct">hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</class>
+    <member kind="variable">
+      <type>struct hwloc_topology_diff_u::hwloc_topology_diff_generic_s</type>
+      <name>generic</name>
+      <anchorfile>a00345.html</anchorfile>
+      <anchor>a0dd2cbfba0eca2fc7a2645668bcae0f8</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s</type>
+      <name>obj_attr</name>
+      <anchorfile>a00345.html</anchorfile>
+      <anchor>a01dca644feea48448b36baa60cf4c07f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s</type>
+      <name>too_complex</name>
+      <anchorfile>a00345.html</anchorfile>
+      <anchor>af7dc1148eb656c56e9678218cafd027b</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_topology_discovery_support</name>
+    <filename>a00281.html</filename>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>pu</name>
+      <anchorfile>a00281.html</anchorfile>
+      <anchor>ad7bb4ecf7a82f5a04fc632e9592ad3ab</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>numa</name>
+      <anchorfile>a00281.html</anchorfile>
+      <anchor>a955f96066cb9e4cd34e2a3710ad43e80</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>numa_memory</name>
+      <anchorfile>a00281.html</anchorfile>
+      <anchor>af193eb858e40e12ef4923f5ed0e1f11a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>disallowed_pu</name>
+      <anchorfile>a00281.html</anchorfile>
+      <anchor>af3c97b28781a2972cf8eaaf94a6617da</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>disallowed_numa</name>
+      <anchorfile>a00281.html</anchorfile>
+      <anchor>a970e65235873bcdb9669a9805161ce03</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>cpukind_efficiency</name>
+      <anchorfile>a00281.html</anchorfile>
+      <anchor>aba80d6f9c15e2395f9ed61db9ff3b75d</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_topology_membind_support</name>
+    <filename>a00289.html</filename>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>set_thisproc_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a36b3e388df9c6a249427cab7e3724749</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_thisproc_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a3fd51e6fa5f0dd800322301b46b08559</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>set_proc_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a756f44912894b176bf979a1b65f12aac</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_proc_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a9880cd2d605e316fc020167c49ca69ad</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>set_thisthread_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a0697af2e41f2e82b8ce71e3cc13f7eac</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_thisthread_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a63b0b2e26157b472f5717ee93cc7c535</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>set_area_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a476c06f96b65c08b287cf2369966123b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_area_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a0a84e24a06f2fa487fe8c9605c6f68b3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>alloc_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>ae551abb27d2aa9ce008583488b845b98</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>firsttouch_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a221098c339dbfab27bd2c9f5d32f123b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>bind_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>ae7cdb1f1b5f0242a69f85b5a5538c764</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>interleave_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a3c44c6012860bbeba8a0f4c19710858d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>nexttouch_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>ab0921af6e0cd6975812a80b8e5c7435c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>migrate_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>aafa7683871a6a760246f9b35209caec5</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>get_area_memlocation</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a30173553a68e0a4dd1672d26f8e892b1</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>weighted_interleave_membind</name>
+      <anchorfile>a00289.html</anchorfile>
+      <anchor>a48e8c0eee48e83e72edde293e2f52464</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_topology_misc_support</name>
+    <filename>a00293.html</filename>
+    <member kind="variable">
+      <type>unsigned char</type>
+      <name>imported_support</name>
+      <anchorfile>a00293.html</anchorfile>
+      <anchor>adf54a6dbe8e9dd5033dfe9c93df726c4</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="struct">
+    <name>hwloc_topology_support</name>
+    <filename>a00297.html</filename>
+    <member kind="variable">
+      <type>struct hwloc_topology_discovery_support *</type>
+      <name>discovery</name>
+      <anchorfile>a00297.html</anchorfile>
+      <anchor>aea3fbd7653d987d81f848636c420504d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_topology_cpubind_support *</type>
+      <name>cpubind</name>
+      <anchorfile>a00297.html</anchorfile>
+      <anchor>adef2bb91f74c3e70a2a071393caf5f56</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_topology_membind_support *</type>
+      <name>membind</name>
+      <anchorfile>a00297.html</anchorfile>
+      <anchor>ac6eb62ae8bc0a68dce679a7107a36194</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="variable">
+      <type>struct hwloc_topology_misc_support *</type>
+      <name>misc</name>
+      <anchorfile>a00297.html</anchorfile>
+      <anchor>ab9d08df4b0b03994f21b893ece826e78</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_api_error_reporting</name>
+    <title>Error reporting in the API</title>
+    <filename>a00170.html</filename>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_api_version</name>
+    <title>API version</title>
+    <filename>a00171.html</filename>
+    <member kind="define">
+      <type>#define</type>
+      <name>HWLOC_API_VERSION</name>
+      <anchorfile>a00171.html</anchorfile>
+      <anchor>ga8f4dfb8eef138af55dd1a0fa802e5476</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="define">
+      <type>#define</type>
+      <name>HWLOC_COMPONENT_ABI</name>
+      <anchorfile>a00171.html</anchorfile>
+      <anchor>gaac5bc1f46f55e10ef0141a68ce70e21f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>unsigned</type>
+      <name>hwloc_get_api_version</name>
+      <anchorfile>a00171.html</anchorfile>
+      <anchor>ga9c0b50c98add1adf57ed1ce85bb5190d</anchor>
+      <arglist>(void)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_object_sets</name>
+    <title>Object Sets (hwloc_cpuset_t and hwloc_nodeset_t)</title>
+    <filename>a00172.html</filename>
+    <member kind="typedef">
+      <type>hwloc_bitmap_t</type>
+      <name>hwloc_cpuset_t</name>
+      <anchorfile>a00172.html</anchorfile>
+      <anchor>ga4bbf39b68b6f568fb92739e7c0ea7801</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="typedef">
+      <type>hwloc_const_bitmap_t</type>
+      <name>hwloc_const_cpuset_t</name>
+      <anchorfile>a00172.html</anchorfile>
+      <anchor>ga1f784433e9b606261f62d1134f6a3b25</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="typedef">
+      <type>hwloc_bitmap_t</type>
+      <name>hwloc_nodeset_t</name>
+      <anchorfile>a00172.html</anchorfile>
+      <anchor>ga37e35730fa7e775b5bb0afe893d6d508</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="typedef">
+      <type>hwloc_const_bitmap_t</type>
+      <name>hwloc_const_nodeset_t</name>
+      <anchorfile>a00172.html</anchorfile>
+      <anchor>ga2f5276235841ad66a79bedad16a5a10c</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_object_types</name>
+    <title>Object Types</title>
+    <filename>a00173.html</filename>
+    <member kind="define">
+      <type>#define</type>
+      <name>HWLOC_TYPE_UNORDERED</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ga3b6e4128e9fe773863b123fa6e4a080b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="typedef">
+      <type>enum hwloc_obj_cache_type_e</type>
+      <name>hwloc_obj_cache_type_t</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ga552ec74296a024237f474acec98694c0</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="typedef">
+      <type>enum hwloc_obj_bridge_type_e</type>
+      <name>hwloc_obj_bridge_type_t</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gab34362c7a23296c3f12c5756747abda3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="typedef">
+      <type>enum hwloc_obj_osdev_type_e</type>
+      <name>hwloc_obj_osdev_type_t</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gaa9a6941ef7b1c169412518d7ef71b3d2</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_obj_type_t</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gacd37bb612667dc437d66bfb175a8dc55</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_MACHINE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a3f4e83ffc4a259354959ae8a9eaa2a80</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_PACKAGE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55ab16ab8c0dbffc234921d86f3dfb63129</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_CORE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55ac793958f330bca371aa1535de8aff45f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_PU</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55abca6887e80cb291353b0a0c1da83f661</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_L1CACHE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a56389b8eb2e2f74f288bb657c4e72140</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_L2CACHE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a18f61d19fe9f4bcea978fcc68bc078fb</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_L3CACHE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a25fae0e0514c90e3973a29866a5a837d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_L4CACHE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a54923bfa13df9d7e6d6dd0d5baff5f72</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_L5CACHE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a67194c9de5e3e581c64c11d2eb1c109d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_L1ICACHE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55afa834a85d9e53836cf0db6d0bd8329b4</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_L2ICACHE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a10713b7e561b8cc32544cd31b1c17f8d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_L3ICACHE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55ac22850c717f07bf7ffb316fadd08d218</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_GROUP</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a5269ef95be72f88465559d35c9b7ad56</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_NUMANODE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a9d917a3e5497950c6d8948b8e183db5a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_BRIDGE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a6825f10895fea60aca7a6ba9fe273db0</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_PCI_DEVICE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a5d8117a54df1fbd3606ab19e42cb0ea9</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_OS_DEVICE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a51e7280240fd9f25589cbbe538bdb075</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_MISC</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a19f8a6953fa91efc76bcbcdf2d22de4d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_MEMCACHE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55a0ed5bd98974729a0c476c39e917dabd6</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_DIE</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ggacd37bb612667dc437d66bfb175a8dc55af78bb6cde53aaaaa162a7dc420c409da</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_obj_cache_type_e</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ga791c9875c8fe20f3e1e5871e0657e59b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_CACHE_UNIFIED</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gga791c9875c8fe20f3e1e5871e0657e59ba3900b3b2db54941aac249e5a638a2d7a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_CACHE_DATA</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gga791c9875c8fe20f3e1e5871e0657e59bacac60ecad4206f85aeb79bef1604b488</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_CACHE_INSTRUCTION</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gga791c9875c8fe20f3e1e5871e0657e59ba6f98b0d422b38ba90c5f5c79a11b0658</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_obj_bridge_type_e</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ga48a4803c72574191d7ead1c62aaf9860</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_BRIDGE_HOST</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gga48a4803c72574191d7ead1c62aaf9860a2c7660f3864ad2810c1e72aad285e574</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_BRIDGE_PCI</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gga48a4803c72574191d7ead1c62aaf9860a8f3b4cecf3dab6073d74696d10863c60</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_obj_osdev_type_e</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ga64f5d539df299c97ae80ce53fc4b56c0</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_OSDEV_BLOCK</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gga64f5d539df299c97ae80ce53fc4b56c0a689b0488c3c0d08d116751c6b9cb8871</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_OSDEV_GPU</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gga64f5d539df299c97ae80ce53fc4b56c0aa3a09798ef2836abb236dc3a645ffc90</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_OSDEV_NETWORK</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gga64f5d539df299c97ae80ce53fc4b56c0ab715d81155f771573c8682dffc65021b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_OSDEV_OPENFABRICS</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gga64f5d539df299c97ae80ce53fc4b56c0a52157d03694fdae82dddd57ca8c973b6</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_OSDEV_DMA</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gga64f5d539df299c97ae80ce53fc4b56c0a827ad1643360711a8b6c6af671366791</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_OBJ_OSDEV_COPROC</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>gga64f5d539df299c97ae80ce53fc4b56c0a46f8927e1c3e137eaa86cc8f6861fb83</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_compare_types</name>
+      <anchorfile>a00173.html</anchorfile>
+      <anchor>ga1820ea0dfd8e9dca28f9ea7624df5ae2</anchor>
+      <arglist>(hwloc_obj_type_t type1, hwloc_obj_type_t type2)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_objects</name>
+    <title>Object Structure and Attributes</title>
+    <filename>a00174.html</filename>
+    <class kind="struct">hwloc_obj</class>
+    <class kind="union">hwloc_obj_attr_u</class>
+    <class kind="struct">hwloc_info_s</class>
+    <member kind="typedef">
+      <type>struct hwloc_obj *</type>
+      <name>hwloc_obj_t</name>
+      <anchorfile>a00174.html</anchorfile>
+      <anchor>ga79b8ab56877ef99ac59b833203391c7d</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_creation</name>
+    <title>Topology Creation and Destruction</title>
+    <filename>a00175.html</filename>
+    <member kind="typedef">
+      <type>struct hwloc_topology *</type>
+      <name>hwloc_topology_t</name>
+      <anchorfile>a00175.html</anchorfile>
+      <anchor>ga9d1e76ee15a7dee158b786c30b6a6e38</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_init</name>
+      <anchorfile>a00175.html</anchorfile>
+      <anchor>ga03fd4a16d8b9ee1ffc32b25fd2f6bdfa</anchor>
+      <arglist>(hwloc_topology_t *topologyp)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_load</name>
+      <anchorfile>a00175.html</anchorfile>
+      <anchor>gabdf58d87ad77f6615fccdfe0535ff826</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_topology_destroy</name>
+      <anchorfile>a00175.html</anchorfile>
+      <anchor>ga9f34a640b6fd28d23699d4d084667b15</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_dup</name>
+      <anchorfile>a00175.html</anchorfile>
+      <anchor>ga62a161fc5e6f120344dc69a7bee4e587</anchor>
+      <arglist>(hwloc_topology_t *newtopology, hwloc_topology_t oldtopology)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_abi_check</name>
+      <anchorfile>a00175.html</anchorfile>
+      <anchor>ga0647ae66458fe68172eb5a320042f870</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_topology_check</name>
+      <anchorfile>a00175.html</anchorfile>
+      <anchor>gaf6746bc3a558ef1ac8348b4491d091b5</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_levels</name>
+    <title>Object levels, depths and types</title>
+    <filename>a00176.html</filename>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_get_type_depth_e</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>gaf4e663cf42bbe20756b849c6293ef575</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_DEPTH_UNKNOWN</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ggaf4e663cf42bbe20756b849c6293ef575a0565ab92ab72cb0cec91e23003294aad</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_DEPTH_MULTIPLE</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ggaf4e663cf42bbe20756b849c6293ef575ae99465995cacde6c210d5fc2e409798c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_DEPTH_NUMANODE</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ggaf4e663cf42bbe20756b849c6293ef575a245c34ec9884c2cf5de5049b2153ed9c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_DEPTH_BRIDGE</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ggaf4e663cf42bbe20756b849c6293ef575af93b50182973e4a718d9d4db9e253a90</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_DEPTH_PCI_DEVICE</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ggaf4e663cf42bbe20756b849c6293ef575ad8b1516e699b57ce1c8d107fbd2f674c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_DEPTH_OS_DEVICE</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ggaf4e663cf42bbe20756b849c6293ef575afe9a2131073eebbe129d4aa2928d3f46</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_DEPTH_MISC</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ggaf4e663cf42bbe20756b849c6293ef575a96436a392b4cdcaa1a29bc65351b373f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_DEPTH_MEMCACHE</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ggaf4e663cf42bbe20756b849c6293ef575a8b8d7d300c018c0eb65e6c9a9f162101</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_get_depth</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>gae54d1782ca9b54bea915f5c18a9158fa</anchor>
+      <arglist>(hwloc_topology_t restrict topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_type_depth</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ga8bec782e21be313750da70cf7428b374</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_memory_parents_depth</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>gae85786340b88e24835f8c403a1e2e54b</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_get_type_or_below_depth</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ga8125328e69eba709c33ea8055c12589b</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_get_type_or_above_depth</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ga8a9ee573b7d2190272095d10712a7cca</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_obj_type_t</type>
+      <name>hwloc_get_depth_type</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ga506b0682b98aa264d53e934d2e9badb0</anchor>
+      <arglist>(hwloc_topology_t topology, int depth)</arglist>
+    </member>
+    <member kind="function">
+      <type>unsigned</type>
+      <name>hwloc_get_nbobjs_by_depth</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ga1d5ceafe8130fe6e8657bf0bc666ba50</anchor>
+      <arglist>(hwloc_topology_t topology, int depth)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_get_nbobjs_by_type</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ga789a3f65aedff644be64a18526a03065</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_root_obj</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ga2d4b12fc187dfc53b35f2fa21d21044d</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_obj_t</type>
+      <name>hwloc_get_obj_by_depth</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ga391f6b2613f0065673eaa4069b93d4e0</anchor>
+      <arglist>(hwloc_topology_t topology, int depth, unsigned idx)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_obj_by_type</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ga6f414dd80a2b943967a0ac92da3181a2</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type, unsigned idx)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_next_obj_by_depth</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>gac140a9b939d9fa0b30c4a910efcb0656</anchor>
+      <arglist>(hwloc_topology_t topology, int depth, hwloc_obj_t prev)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_next_obj_by_type</name>
+      <anchorfile>a00176.html</anchorfile>
+      <anchor>ga759e88eaf5a230ad283e9d4c42486735</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type, hwloc_obj_t prev)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_object_strings</name>
+    <title>Converting between Object Types and Attributes, and Strings</title>
+    <filename>a00177.html</filename>
+    <member kind="function">
+      <type>const char *</type>
+      <name>hwloc_obj_type_string</name>
+      <anchorfile>a00177.html</anchorfile>
+      <anchor>ga6a38b931e5d45e8af4323a169482fe39</anchor>
+      <arglist>(hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_type_snprintf</name>
+      <anchorfile>a00177.html</anchorfile>
+      <anchor>gadb8765c260edea80c52cd06a76639ba4</anchor>
+      <arglist>(char *restrict string, size_t size, hwloc_obj_t obj, int verbose)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_attr_snprintf</name>
+      <anchorfile>a00177.html</anchorfile>
+      <anchor>ga870e876931c282a1c7aee2f031912ce3</anchor>
+      <arglist>(char *restrict string, size_t size, hwloc_obj_t obj, const char *restrict separator, int verbose)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_type_sscanf</name>
+      <anchorfile>a00177.html</anchorfile>
+      <anchor>ga510f21b066fba2dab12b8c9b173b1dfd</anchor>
+      <arglist>(const char *string, hwloc_obj_type_t *typep, union hwloc_obj_attr_u *attrp, size_t attrsize)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_type_sscanf_as_depth</name>
+      <anchorfile>a00177.html</anchorfile>
+      <anchor>ga52c63cd7203e55b804c1314affc9bd12</anchor>
+      <arglist>(const char *string, hwloc_obj_type_t *typep, hwloc_topology_t topology, int *depthp)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_info_attr</name>
+    <title>Consulting and Adding Info Attributes</title>
+    <filename>a00178.html</filename>
+    <member kind="function" static="yes">
+      <type>static const char *</type>
+      <name>hwloc_obj_get_info_by_name</name>
+      <anchorfile>a00178.html</anchorfile>
+      <anchor>ga415c4e44beada7ea34cd4bad9944b170</anchor>
+      <arglist>(hwloc_obj_t obj, const char *name)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_add_info</name>
+      <anchorfile>a00178.html</anchorfile>
+      <anchor>gace7654bb8a9002caae1a4b8a59e7452e</anchor>
+      <arglist>(hwloc_obj_t obj, const char *name, const char *value)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_set_subtype</name>
+      <anchorfile>a00178.html</anchorfile>
+      <anchor>ga6a07031b69bc7466b6fc4d13d610d47a</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t obj, const char *subtype)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_cpubinding</name>
+    <title>CPU binding</title>
+    <filename>a00179.html</filename>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_cpubind_flags_t</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>ga217dc8d373f8958cc93c154ebce1c71c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_CPUBIND_PROCESS</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>gga217dc8d373f8958cc93c154ebce1c71ca2e0dd0128dac6b03408c7dd170477fdc</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_CPUBIND_THREAD</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>gga217dc8d373f8958cc93c154ebce1c71caf1b6bbad00d7b1017b918e3719f4d421</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_CPUBIND_STRICT</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>gga217dc8d373f8958cc93c154ebce1c71ca679a7e0f0c7ee06b123565f90d98e7fa</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_CPUBIND_NOMEMBIND</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>gga217dc8d373f8958cc93c154ebce1c71ca41ce440443cc3087caed95ab60edcad6</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_set_cpubind</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>ga80bc07473a8edf840cae17bd7ec21d48</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_cpubind</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>gacba7ecb979baf824d5240fa2cb2a8be6</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_cpuset_t set, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_set_proc_cpubind</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>ga296db8a3c6d49b51fb83d6f3e45c02a6</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_pid_t pid, hwloc_const_cpuset_t set, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_proc_cpubind</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>gac82de91f788fa82dacf99c6e0d4b7158</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_pid_t pid, hwloc_cpuset_t set, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_set_thread_cpubind</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>gae42c01b2addcfbf6048b9a516dd7a906</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_thread_t thread, hwloc_const_cpuset_t set, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_thread_cpubind</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>gaf13f765642b5d0d9a9813e6bb043671b</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_thread_t thread, hwloc_cpuset_t set, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_last_cpu_location</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>gafdb374627358bf09203b5a4215b13032</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_cpuset_t set, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_proc_last_cpu_location</name>
+      <anchorfile>a00179.html</anchorfile>
+      <anchor>ga910a05c2d47f68a3155bf176b50fa555</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_pid_t pid, hwloc_cpuset_t set, int flags)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_membinding</name>
+    <title>Memory binding</title>
+    <filename>a00180.html</filename>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_membind_policy_t</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>gac9764f79505775d06407b40f5e4661e8</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_DEFAULT</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggac9764f79505775d06407b40f5e4661e8a18675bb80ebc1bce5b652e9de8f3998c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_FIRSTTOUCH</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggac9764f79505775d06407b40f5e4661e8a979c7aa78dd32780858f30f47a72cca0</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_BIND</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggac9764f79505775d06407b40f5e4661e8ad811fa4b2a6002c4d63695a408ffde2c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_INTERLEAVE</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggac9764f79505775d06407b40f5e4661e8ae370075e5af016d42310f87ea5af236b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_WEIGHTED_INTERLEAVE</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggac9764f79505775d06407b40f5e4661e8aa091c40c9557b69a26b69a0e8b84dafe</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_NEXTTOUCH</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggac9764f79505775d06407b40f5e4661e8aecdd4164d647708fbb51a00d98dbb138</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_MIXED</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggac9764f79505775d06407b40f5e4661e8a3185bd869b67817fb2bd5164bf360402</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_membind_flags_t</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>gab00475fd98815bf4fb9aaf752030e7d2</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_PROCESS</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggab00475fd98815bf4fb9aaf752030e7d2a1b1b74aef138f64aff214a8cbdfe8eb4</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_THREAD</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggab00475fd98815bf4fb9aaf752030e7d2a1dc7dd5cdcd5796893a325a524555298</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_STRICT</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggab00475fd98815bf4fb9aaf752030e7d2a0335311a0ee04166df2888d52b4a42c6</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_MIGRATE</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggab00475fd98815bf4fb9aaf752030e7d2aa6e49e54f52827cb143cc869cfd748af</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_NOCPUBIND</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggab00475fd98815bf4fb9aaf752030e7d2aad6b9eaf2ee324ca58dc8f58094b9997</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMBIND_BYNODESET</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ggab00475fd98815bf4fb9aaf752030e7d2a71f19fe4505f1c083dc8e6f7bdea6256</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_set_membind</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ga020951efa0ce3862bd4faec295501a7f</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_membind</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>gae21f0a1a884929c784bebf070252aa56</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_bitmap_t set, hwloc_membind_policy_t *policy, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_set_proc_membind</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>gabc91ff16f7e41047924e3a4ae6d9da7e</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_pid_t pid, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_proc_membind</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ga1730ceb18ec6ee3b7bd3d0db81f07dc8</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_pid_t pid, hwloc_bitmap_t set, hwloc_membind_policy_t *policy, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_set_area_membind</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>gaf881faefe20701229f07dd7dbd0125ed</anchor>
+      <arglist>(hwloc_topology_t topology, const void *addr, size_t len, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_area_membind</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>gaa87e0a6946ff145914fdf0b1c60567f8</anchor>
+      <arglist>(hwloc_topology_t topology, const void *addr, size_t len, hwloc_bitmap_t set, hwloc_membind_policy_t *policy, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_area_memlocation</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ga537c7508a4e2d1db05673ec5be6e805c</anchor>
+      <arglist>(hwloc_topology_t topology, const void *addr, size_t len, hwloc_bitmap_t set, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>void *</type>
+      <name>hwloc_alloc</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ga95856d8f13357f247d5fce142d443ae3</anchor>
+      <arglist>(hwloc_topology_t topology, size_t len)</arglist>
+    </member>
+    <member kind="function">
+      <type>void *</type>
+      <name>hwloc_alloc_membind</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>gadf87089ef533db40460ccc24b5bc0d65</anchor>
+      <arglist>(hwloc_topology_t topology, size_t len, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static void *</type>
+      <name>hwloc_alloc_membind_policy</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ga64e5f75165ea52930f67b17ef4aed2e8</anchor>
+      <arglist>(hwloc_topology_t topology, size_t len, hwloc_const_bitmap_t set, hwloc_membind_policy_t policy, int flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_free</name>
+      <anchorfile>a00180.html</anchorfile>
+      <anchor>ga32dbd4f54e9e4a7179f2dde37ffe6ad7</anchor>
+      <arglist>(hwloc_topology_t topology, void *addr, size_t len)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_setsource</name>
+    <title>Changing the Source of Topology Discovery</title>
+    <filename>a00181.html</filename>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_topology_components_flag_e</name>
+      <anchorfile>a00181.html</anchorfile>
+      <anchor>ga949f656c779208a36790feba24048b7e</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST</name>
+      <anchorfile>a00181.html</anchorfile>
+      <anchor>gga949f656c779208a36790feba24048b7ea33eec25d29253a2aba21dd3c731b416e</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_set_pid</name>
+      <anchorfile>a00181.html</anchorfile>
+      <anchor>ga341fc17b5867a4715570baab131f68cd</anchor>
+      <arglist>(hwloc_topology_t restrict topology, hwloc_pid_t pid)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_set_synthetic</name>
+      <anchorfile>a00181.html</anchorfile>
+      <anchor>ga4fab186bb6181a00bcf585825fddd38d</anchor>
+      <arglist>(hwloc_topology_t restrict topology, const char *restrict description)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_set_xml</name>
+      <anchorfile>a00181.html</anchorfile>
+      <anchor>ga879439b7ee99407ee911b3ac64e9a25e</anchor>
+      <arglist>(hwloc_topology_t restrict topology, const char *restrict xmlpath)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_set_xmlbuffer</name>
+      <anchorfile>a00181.html</anchorfile>
+      <anchor>ga2745616b65595e1c1e579ecc7e461fa8</anchor>
+      <arglist>(hwloc_topology_t restrict topology, const char *restrict buffer, int size)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_set_components</name>
+      <anchorfile>a00181.html</anchorfile>
+      <anchor>ga9ad41adf418cee1c0ee32ba9bd4a3d36</anchor>
+      <arglist>(hwloc_topology_t restrict topology, unsigned long flags, const char *restrict name)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_configuration</name>
+    <title>Topology Detection Configuration and Query</title>
+    <filename>a00182.html</filename>
+    <class kind="struct">hwloc_topology_discovery_support</class>
+    <class kind="struct">hwloc_topology_cpubind_support</class>
+    <class kind="struct">hwloc_topology_membind_support</class>
+    <class kind="struct">hwloc_topology_misc_support</class>
+    <class kind="struct">hwloc_topology_support</class>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_topology_flags_e</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>gada025d3ec20b4b420f8038d23d6e7bde</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ggada025d3ec20b4b420f8038d23d6e7bdea10907044bbb306fd0dc76acf046d9258</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ggada025d3ec20b4b420f8038d23d6e7bdea6ecb6abc6a0bb75e81564f8bca85783b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ggada025d3ec20b4b420f8038d23d6e7bdea1b66bbd66e900e5c837f71defb32ad89</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ggada025d3ec20b4b420f8038d23d6e7bdead93e82b8668ee90e4f9354e201a2ed9c</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ggada025d3ec20b4b420f8038d23d6e7bdeaa595aed197779012acf43e8ca4a2658d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ggada025d3ec20b4b420f8038d23d6e7bdea368d7741135fe309f3782c59644d3caa</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ggada025d3ec20b4b420f8038d23d6e7bdeae7a792e3db4360360a10f9160b10e631</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_FLAG_NO_DISTANCES</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ggada025d3ec20b4b420f8038d23d6e7bdea5796b4909eba80f9727b66d07d3a7a05</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_FLAG_NO_MEMATTRS</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ggada025d3ec20b4b420f8038d23d6e7bdead5636766a6603f24486f79c48899c1c3</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_FLAG_NO_CPUKINDS</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ggada025d3ec20b4b420f8038d23d6e7bdea3497cd4c2f8b1d842dd49b3aaae56a24</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_type_filter_e</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ga9a5a1f0140cd1952544477833733195b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_FILTER_KEEP_ALL</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>gga9a5a1f0140cd1952544477833733195bafda7b59e6810dfe778d8f9a4cc1e350e</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_FILTER_KEEP_NONE</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>gga9a5a1f0140cd1952544477833733195ba4f835955414de92c77d99b8419d4647a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_FILTER_KEEP_STRUCTURE</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>gga9a5a1f0140cd1952544477833733195ba7664716643bf1db83e631eed34f659e4</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TYPE_FILTER_KEEP_IMPORTANT</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>gga9a5a1f0140cd1952544477833733195ba63fd24954e18c83ff7eae9588759adb5</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_set_flags</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>gaaeed4df656979e5f16befea9d29b814b</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>unsigned long</type>
+      <name>hwloc_topology_get_flags</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ga09318f81c1d4713be907d64748a6f93c</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_is_thissystem</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ga68ffdcfd9175cdf40709801092f18017</anchor>
+      <arglist>(hwloc_topology_t restrict topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>const struct hwloc_topology_support *</type>
+      <name>hwloc_topology_get_support</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>gac0927e93a9b962143be08a48bbff2e19</anchor>
+      <arglist>(hwloc_topology_t restrict topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_set_type_filter</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>gad894e70f15f8d4aada7be8d1aba38b7e</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type, enum hwloc_type_filter_e filter)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_get_type_filter</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ga137ad1178f7a79f2383974d983083401</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type, enum hwloc_type_filter_e *filter)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_set_all_types_filter</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ga9eb8dc3b106f84921bf5789101e97e24</anchor>
+      <arglist>(hwloc_topology_t topology, enum hwloc_type_filter_e filter)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_set_cache_types_filter</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ga30bd6d330fe3c8f0cbaad724d114ee20</anchor>
+      <arglist>(hwloc_topology_t topology, enum hwloc_type_filter_e filter)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_set_icache_types_filter</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ga37c7b2e599ed3cd76ad9164630024f30</anchor>
+      <arglist>(hwloc_topology_t topology, enum hwloc_type_filter_e filter)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_set_io_types_filter</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ga0ab38705357bc1203abe829da8a12ad3</anchor>
+      <arglist>(hwloc_topology_t topology, enum hwloc_type_filter_e filter)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_topology_set_userdata</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>ga2cc7b7b155cba58dda203e54f1637b9c</anchor>
+      <arglist>(hwloc_topology_t topology, const void *userdata)</arglist>
+    </member>
+    <member kind="function">
+      <type>void *</type>
+      <name>hwloc_topology_get_userdata</name>
+      <anchorfile>a00182.html</anchorfile>
+      <anchor>gad47dee1a30f4b00486b54872af030b43</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_tinker</name>
+    <title>Modifying a loaded Topology</title>
+    <filename>a00183.html</filename>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_restrict_flags_e</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>ga9d80f08eb25b7ac22f1b998dc8bf521f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_RESTRICT_FLAG_REMOVE_CPULESS</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gga9d80f08eb25b7ac22f1b998dc8bf521fa80eeb9cbba401ab050f8fb4573725891</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_RESTRICT_FLAG_BYNODESET</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gga9d80f08eb25b7ac22f1b998dc8bf521fae4c5b1b87232f2d8a60559e77ac65a68</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_RESTRICT_FLAG_REMOVE_MEMLESS</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gga9d80f08eb25b7ac22f1b998dc8bf521faf5ba49808855704bfe9cb9fe7347f93b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_RESTRICT_FLAG_ADAPT_MISC</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gga9d80f08eb25b7ac22f1b998dc8bf521fa699969227a09bbc1a7de51dc9fb7be4b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_RESTRICT_FLAG_ADAPT_IO</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gga9d80f08eb25b7ac22f1b998dc8bf521faa95d6985e36ec1e55f68b210297a85cb</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_allow_flags_e</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>ga38b1be3922094d880f6e76bf56c973d6</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_ALLOW_FLAG_ALL</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gga38b1be3922094d880f6e76bf56c973d6aca107692455774f9d323d21b8abfce72</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gga38b1be3922094d880f6e76bf56c973d6a88c50088c09dcf1e1a496c0817556fb9</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_ALLOW_FLAG_CUSTOM</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gga38b1be3922094d880f6e76bf56c973d6a489c8c1b67ce7e0b8cf7a665852760e1</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_restrict</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>ga6db81ed13ac0a9d70cc80372ab537815</anchor>
+      <arglist>(hwloc_topology_t restrict topology, hwloc_const_bitmap_t set, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_allow</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gaf955b190c0299dcfb5bc985d777f92a1</anchor>
+      <arglist>(hwloc_topology_t restrict topology, hwloc_const_cpuset_t cpuset, hwloc_const_nodeset_t nodeset, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_obj_t</type>
+      <name>hwloc_topology_insert_misc_object</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gad980782ade737900c5cf208946768c30</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t parent, const char *name)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_obj_t</type>
+      <name>hwloc_topology_alloc_group_object</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>ga4cea4741165faf5323931a9ed8786ef7</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_free_group_object</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gac09117be24a8fc5f5dea6acac34e8843</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t group)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_obj_t</type>
+      <name>hwloc_topology_insert_group_object</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>ga1fc6012b3e1c249b83f48cb7bcacaa5b</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t group)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_add_other_obj_sets</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>gad458715d3335df44849216cc123d1055</anchor>
+      <arglist>(hwloc_obj_t dst, hwloc_obj_t src)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_refresh</name>
+      <anchorfile>a00183.html</anchorfile>
+      <anchor>ga698ecd640d2b76742bba3829a145cd9a</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_helper_types</name>
+    <title>Kinds of object Type</title>
+    <filename>a00184.html</filename>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_type_is_normal</name>
+      <anchorfile>a00184.html</anchorfile>
+      <anchor>ga52ef38431eba383b048b98c669b59a16</anchor>
+      <arglist>(hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_type_is_io</name>
+      <anchorfile>a00184.html</anchorfile>
+      <anchor>gac8a954ed37a4376097234c828068cbef</anchor>
+      <arglist>(hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_type_is_memory</name>
+      <anchorfile>a00184.html</anchorfile>
+      <anchor>ga1d074390c8a3dc3088d84f73fb73f966</anchor>
+      <arglist>(hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_type_is_cache</name>
+      <anchorfile>a00184.html</anchorfile>
+      <anchor>ga2ed589bea28711e80b92066510a5607d</anchor>
+      <arglist>(hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_type_is_dcache</name>
+      <anchorfile>a00184.html</anchorfile>
+      <anchor>ga395e48cd221d107e5891689624e1aec4</anchor>
+      <arglist>(hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_type_is_icache</name>
+      <anchorfile>a00184.html</anchorfile>
+      <anchor>ga8abcee67b9b074332c1866405a3648a9</anchor>
+      <arglist>(hwloc_obj_type_t type)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_helper_find_inside</name>
+    <title>Finding Objects inside a CPU set</title>
+    <filename>a00185.html</filename>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_first_largest_obj_inside_cpuset</name>
+      <anchorfile>a00185.html</anchorfile>
+      <anchor>ga547325a4193dbc215d07c23097519d79</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_largest_objs_inside_cpuset</name>
+      <anchorfile>a00185.html</anchorfile>
+      <anchor>ga34ca563fa3a6a4e05268f36a87668511</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_t *restrict objs, int max)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_next_obj_inside_cpuset_by_depth</name>
+      <anchorfile>a00185.html</anchorfile>
+      <anchor>ga63e3784e7c60fbae5073428cb98ac787</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, int depth, hwloc_obj_t prev)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_next_obj_inside_cpuset_by_type</name>
+      <anchorfile>a00185.html</anchorfile>
+      <anchor>gafe859176cf9233f215fea0e87cef47e7</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_type_t type, hwloc_obj_t prev)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_obj_inside_cpuset_by_depth</name>
+      <anchorfile>a00185.html</anchorfile>
+      <anchor>gaec86f1f88832836e3f9338e246ea5862</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, int depth, unsigned idx)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_obj_inside_cpuset_by_type</name>
+      <anchorfile>a00185.html</anchorfile>
+      <anchor>ga2edf924e5a0cca9cb22f65cc77c6ddb5</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_type_t type, unsigned idx)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static unsigned</type>
+      <name>hwloc_get_nbobjs_inside_cpuset_by_depth</name>
+      <anchorfile>a00185.html</anchorfile>
+      <anchor>gaa43c64512ddb33fd181990c4261cec7d</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, int depth)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_get_nbobjs_inside_cpuset_by_type</name>
+      <anchorfile>a00185.html</anchorfile>
+      <anchor>ga133c40415de008518608f8bff52a5ab9</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_get_obj_index_inside_cpuset</name>
+      <anchorfile>a00185.html</anchorfile>
+      <anchor>ga4c3a20d61e9beb06c667b21688c772c5</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_t obj)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_helper_find_covering</name>
+    <title>Finding Objects covering at least CPU set</title>
+    <filename>a00186.html</filename>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_child_covering_cpuset</name>
+      <anchorfile>a00186.html</anchorfile>
+      <anchor>ga0e66aa2dc6b2527cfd10723af646c9d7</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_t parent)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_obj_covering_cpuset</name>
+      <anchorfile>a00186.html</anchorfile>
+      <anchor>ga41acdcdbb8b95d70ecf6c572a3f67dca</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_next_obj_covering_cpuset_by_depth</name>
+      <anchorfile>a00186.html</anchorfile>
+      <anchor>gaba4b6d86eba1169ced4b0e941d2bb5f0</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, int depth, hwloc_obj_t prev)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_next_obj_covering_cpuset_by_type</name>
+      <anchorfile>a00186.html</anchorfile>
+      <anchor>ga91cfae08b092e7966002e15d1e987213</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_type_t type, hwloc_obj_t prev)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_helper_ancestors</name>
+    <title>Looking at Ancestor and Child Objects</title>
+    <filename>a00187.html</filename>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_ancestor_obj_by_depth</name>
+      <anchorfile>a00187.html</anchorfile>
+      <anchor>ga9f8c93fde236e9642a96957af01a11cb</anchor>
+      <arglist>(hwloc_topology_t topology, int depth, hwloc_obj_t obj)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_ancestor_obj_by_type</name>
+      <anchorfile>a00187.html</anchorfile>
+      <anchor>ga70f0c7583291da707c15ae4daa850f41</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type, hwloc_obj_t obj)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_common_ancestor_obj</name>
+      <anchorfile>a00187.html</anchorfile>
+      <anchor>gab1fa883021928b5c476911c4102e9be3</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t obj1, hwloc_obj_t obj2)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_obj_is_in_subtree</name>
+      <anchorfile>a00187.html</anchorfile>
+      <anchor>ga408cf74f5bf9ed497911a320c7f8cc56</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t obj, hwloc_obj_t subtree_root)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_next_child</name>
+      <anchorfile>a00187.html</anchorfile>
+      <anchor>ga12d8565a3436c565e791ed02a0353621</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t parent, hwloc_obj_t prev)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_helper_find_cache</name>
+    <title>Looking at Cache Objects</title>
+    <filename>a00188.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_get_cache_type_depth</name>
+      <anchorfile>a00188.html</anchorfile>
+      <anchor>gad108a09ce400222fe45545257d575489</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned cachelevel, hwloc_obj_cache_type_t cachetype)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_cache_covering_cpuset</name>
+      <anchorfile>a00188.html</anchorfile>
+      <anchor>gac4cd480a5deaa4ada047fdd11ae4c070</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t set)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_shared_cache_covering_obj</name>
+      <anchorfile>a00188.html</anchorfile>
+      <anchor>ga36f48c32837c7a70b424706e213dcd71</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t obj)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_helper_find_misc</name>
+    <title>Finding objects, miscellaneous helpers</title>
+    <filename>a00189.html</filename>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_singlify_per_core</name>
+      <anchorfile>a00189.html</anchorfile>
+      <anchor>ga050646458efc8ca1120d9f124c5ad861</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_bitmap_t cpuset, unsigned which)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_pu_obj_by_os_index</name>
+      <anchorfile>a00189.html</anchorfile>
+      <anchor>ga751c238a4931db5cc0ca3181b7dd7479</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned os_index)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_numanode_obj_by_os_index</name>
+      <anchorfile>a00189.html</anchorfile>
+      <anchor>gab89d9ed9edfaa3dd526fb6ee1a1618ea</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned os_index)</arglist>
+    </member>
+    <member kind="function">
+      <type>unsigned</type>
+      <name>hwloc_get_closest_objs</name>
+      <anchorfile>a00189.html</anchorfile>
+      <anchor>ga2cd22a34360643f7f5bad09576dec205</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t src, hwloc_obj_t *restrict objs, unsigned max)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_obj_below_by_type</name>
+      <anchorfile>a00189.html</anchorfile>
+      <anchor>ga7a0c1046851f7a88bd52f5a1d4ba0a97</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type1, unsigned idx1, hwloc_obj_type_t type2, unsigned idx2)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_obj_below_array_by_type</name>
+      <anchorfile>a00189.html</anchorfile>
+      <anchor>gacb51295ff3fbd3a96f990f20c6492b1d</anchor>
+      <arglist>(hwloc_topology_t topology, int nr, hwloc_obj_type_t *typev, unsigned *idxv)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_obj_t</type>
+      <name>hwloc_get_obj_with_same_locality</name>
+      <anchorfile>a00189.html</anchorfile>
+      <anchor>gab5df3ad1e8565ea0c2cf06412f6f6233</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t src, hwloc_obj_type_t type, const char *subtype, const char *nameprefix, unsigned long flags)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_helper_distribute</name>
+    <title>Distributing items over a topology</title>
+    <filename>a00190.html</filename>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_distrib_flags_e</name>
+      <anchorfile>a00190.html</anchorfile>
+      <anchor>ga8b835295a52b6768a5e6c8abb1f9c54d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTRIB_FLAG_REVERSE</name>
+      <anchorfile>a00190.html</anchorfile>
+      <anchor>gga8b835295a52b6768a5e6c8abb1f9c54da2ca08404bfbebe9ed5f34c3d7635425a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_distrib</name>
+      <anchorfile>a00190.html</anchorfile>
+      <anchor>ga7b0c28f797c2ff17fa2f244ebbd55b33</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t *roots, unsigned n_roots, hwloc_cpuset_t *set, unsigned n, int until, unsigned long flags)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_helper_topology_sets</name>
+    <title>CPU and node sets of entire topologies</title>
+    <filename>a00191.html</filename>
+    <member kind="function">
+      <type>hwloc_const_cpuset_t</type>
+      <name>hwloc_topology_get_complete_cpuset</name>
+      <anchorfile>a00191.html</anchorfile>
+      <anchor>gaee30e03391c1ed7dfd617fb5c7bbb033</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_const_cpuset_t</type>
+      <name>hwloc_topology_get_topology_cpuset</name>
+      <anchorfile>a00191.html</anchorfile>
+      <anchor>ga79212faa07b70dd26588941b17d9fa82</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_const_cpuset_t</type>
+      <name>hwloc_topology_get_allowed_cpuset</name>
+      <anchorfile>a00191.html</anchorfile>
+      <anchor>ga517d5d68ec9f24583d8933aab713be8e</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_const_nodeset_t</type>
+      <name>hwloc_topology_get_complete_nodeset</name>
+      <anchorfile>a00191.html</anchorfile>
+      <anchor>ga773fd98949461ef4c1e3170bb0c0418f</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_const_nodeset_t</type>
+      <name>hwloc_topology_get_topology_nodeset</name>
+      <anchorfile>a00191.html</anchorfile>
+      <anchor>ga3fd37303e99ace8b0d0ea03f95f8c514</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_const_nodeset_t</type>
+      <name>hwloc_topology_get_allowed_nodeset</name>
+      <anchorfile>a00191.html</anchorfile>
+      <anchor>ga21a4d7237a11e76b912ed4524ab78cbd</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_helper_nodeset_convert</name>
+    <title>Converting between CPU sets and node sets</title>
+    <filename>a00192.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_cpuset_to_nodeset</name>
+      <anchorfile>a00192.html</anchorfile>
+      <anchor>ga185751c1653fedbeb7cc480840f38cde</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t _cpuset, hwloc_nodeset_t nodeset)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_cpuset_from_nodeset</name>
+      <anchorfile>a00192.html</anchorfile>
+      <anchor>gad5ee8691e08a3538ea7633344c00456d</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_cpuset_t _cpuset, hwloc_const_nodeset_t nodeset)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_advanced_io</name>
+    <title>Finding I/O objects</title>
+    <filename>a00193.html</filename>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_non_io_ancestor_obj</name>
+      <anchorfile>a00193.html</anchorfile>
+      <anchor>gaf139bb61375178e90cc3f1835b452ab6</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t ioobj)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_next_pcidev</name>
+      <anchorfile>a00193.html</anchorfile>
+      <anchor>ga66470dabce9db19a57c5940a909d0baa</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t prev)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_pcidev_by_busid</name>
+      <anchorfile>a00193.html</anchorfile>
+      <anchor>gacdbaf0db98872e224b7883a84bfb0455</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_pcidev_by_busidstring</name>
+      <anchorfile>a00193.html</anchorfile>
+      <anchor>ga23a978469353134b3104b846fe2efceb</anchor>
+      <arglist>(hwloc_topology_t topology, const char *busid)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_next_osdev</name>
+      <anchorfile>a00193.html</anchorfile>
+      <anchor>ga8b4584c8949e2c5f1c97ba7fe92b8145</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t prev)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_get_next_bridge</name>
+      <anchorfile>a00193.html</anchorfile>
+      <anchor>ga9dba22a3f4f701f2a46780ba9a0bbbe7</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t prev)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_bridge_covers_pcibus</name>
+      <anchorfile>a00193.html</anchorfile>
+      <anchor>ga0d92a9462a3d317f29ecb4442a307fb1</anchor>
+      <arglist>(hwloc_obj_t bridge, unsigned domain, unsigned bus)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_bitmap</name>
+    <title>The bitmap API</title>
+    <filename>a00194.html</filename>
+    <member kind="define">
+      <type>#define</type>
+      <name>hwloc_bitmap_foreach_begin</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga3f6861045a8029ade373510ffa727d2a</anchor>
+      <arglist>(id, bitmap)</arglist>
+    </member>
+    <member kind="define">
+      <type>#define</type>
+      <name>hwloc_bitmap_foreach_end</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gafcf3246db406218d4e155735b3fa6528</anchor>
+      <arglist>()</arglist>
+    </member>
+    <member kind="typedef">
+      <type>struct hwloc_bitmap_s *</type>
+      <name>hwloc_bitmap_t</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gaa3c2bf4c776d603dcebbb61b0c923d84</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="typedef">
+      <type>const struct hwloc_bitmap_s *</type>
+      <name>hwloc_const_bitmap_t</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gae991a108af01d408be2776c5b2c467b2</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_bitmap_t</type>
+      <name>hwloc_bitmap_alloc</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gadece3d1eb5199fc2fb99bc7dcf1ccc05</anchor>
+      <arglist>(void)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_bitmap_t</type>
+      <name>hwloc_bitmap_alloc_full</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga02853b4a224970587b9d7a0e20d857c0</anchor>
+      <arglist>(void)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_bitmap_free</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga156130d85b3a0674d6e0e6770fe68fbe</anchor>
+      <arglist>(hwloc_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_bitmap_t</type>
+      <name>hwloc_bitmap_dup</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gae679434c1a5f41d3560a8a7e2c1b0dee</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_copy</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga72a29824798b48784b8217471ec8f14c</anchor>
+      <arglist>(hwloc_bitmap_t dst, hwloc_const_bitmap_t src)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_snprintf</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga9511644657030a021dce9941e3cda583</anchor>
+      <arglist>(char *restrict buf, size_t buflen, hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_asprintf</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga0fece972134fdecf2da9bc7a11dd827e</anchor>
+      <arglist>(char **strp, hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_sscanf</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga064a85c643a364b60acbfa0f3663fc18</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, const char *restrict string)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_list_snprintf</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga3d06e6447edeb61e56a9ad83f31f0a37</anchor>
+      <arglist>(char *restrict buf, size_t buflen, hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_list_asprintf</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga39c0f1b02053de66d205c9f8260b3665</anchor>
+      <arglist>(char **strp, hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_list_sscanf</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gaf9314311d482c621e17c6a53a9fe993e</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, const char *restrict string)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_taskset_snprintf</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga5beb68a987fe48e5c5edef06ab260e14</anchor>
+      <arglist>(char *restrict buf, size_t buflen, hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_taskset_asprintf</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga391312513f17c985d871f18367c59512</anchor>
+      <arglist>(char **strp, hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_taskset_sscanf</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga4f23db5041240e03e348752f8bd6ec2d</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, const char *restrict string)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_bitmap_zero</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gaa97c5217613c8cae9862287170ea2132</anchor>
+      <arglist>(hwloc_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_bitmap_fill</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga07b2de8786b3cdb22f21d9dd42588275</anchor>
+      <arglist>(hwloc_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_only</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga10be0840cdeb7ce26d862819dd303baa</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, unsigned id)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_allbut</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga06d505f8a1c0a536614f65f503ee6d93</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, unsigned id)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_from_ulong</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gad59b0ebeb29c1bfabbb2a379e55c1159</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, unsigned long mask)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_from_ith_ulong</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga4947c46d47bcfcd3faf3f59569be3e37</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, unsigned i, unsigned long mask)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_from_ulongs</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gabcfef22f6fc4d4b33f068dd91a1c38f5</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, unsigned nr, const unsigned long *masks)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_set</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga062dbff93baeff3b425a7260c5463646</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, unsigned id)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_set_range</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga9c9a8433732fb9f24899e7aa4c014d7e</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, unsigned begin, int end)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_set_ith_ulong</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga3daeed965c35c6d2fd4820a318219985</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, unsigned i, unsigned long mask)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_clr</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gaf20bb350b6844d08931a064a73f86743</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, unsigned id)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_clr_range</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga833776709df94d727f8c22304b3388cf</anchor>
+      <arglist>(hwloc_bitmap_t bitmap, unsigned begin, int end)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_singlify</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gaa611a77c092e679246afdf9a60d5db8b</anchor>
+      <arglist>(hwloc_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>unsigned long</type>
+      <name>hwloc_bitmap_to_ulong</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gab6a6bae22a33ec6adfc169a953c13e6c</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>unsigned long</type>
+      <name>hwloc_bitmap_to_ith_ulong</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gac92e6404f648d6b99d2c626b05b2ffa4</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap, unsigned i)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_to_ulongs</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gacd215a2348732de25d94a4ecd76d528c</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap, unsigned nr, unsigned long *masks)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_nr_ulongs</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gac0744734d761d65c977aece565364908</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_isset</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga11340dd487f110bb84f0a6e4ae90bd06</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap, unsigned id)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_iszero</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga5b64be28f5a7176ed8ad0d6a90bdf108</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_isfull</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga5fdcb8c19c336511c37076d649e74af4</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_first</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga3ec1ced43afadf8c0a7197320bc016ed</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_next</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gaab7240b4b644693b775dad17b44ffd68</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap, int prev)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_last</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga3d9b08b060a59bbab5a4ea6d0a1ed7a6</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_weight</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga0200466842c0e1f5da75e84dde460b10</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_first_unset</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gae408841487b288e148a478ba0465c99e</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_next_unset</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga9653af34d1460ef106b7df25af4cdca8</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap, int prev)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_last_unset</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga45d49aeb45c7da631b1480a93dc3fc92</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_or</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga120b8aefb9ce7ef349929656359b1859</anchor>
+      <arglist>(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_and</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga674533016ffed922a28b4f0b49b82cd4</anchor>
+      <arglist>(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_andnot</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga7ca5c72db65406b85aca032c8a990f9e</anchor>
+      <arglist>(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_xor</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga205508218e09cb9befd0687f16409f09</anchor>
+      <arglist>(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_not</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga84cfdb4f8ab8c1f7e097728e613a2a3f</anchor>
+      <arglist>(hwloc_bitmap_t res, hwloc_const_bitmap_t bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_intersects</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gaefa070f9232857ba5a57297ea9a08ea2</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_isincluded</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga0526e03db81956fb02acc8260b66d6a4</anchor>
+      <arglist>(hwloc_const_bitmap_t sub_bitmap, hwloc_const_bitmap_t super_bitmap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_isequal</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga32376b1405e57472b73c3aa53bb39663</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_compare_first</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>gaa39cda1510ab721b5c012c76ead72365</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_bitmap_compare</name>
+      <anchorfile>a00194.html</anchorfile>
+      <anchor>ga14cdbc0ef0a705e84999bd48a2e649f3</anchor>
+      <arglist>(hwloc_const_bitmap_t bitmap1, hwloc_const_bitmap_t bitmap2)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_xmlexport</name>
+    <title>Exporting Topologies to XML</title>
+    <filename>a00195.html</filename>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_topology_export_xml_flags_e</name>
+      <anchorfile>a00195.html</anchorfile>
+      <anchor>ga0eb99636aff71fe2704e1fa0ffe8c18d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1</name>
+      <anchorfile>a00195.html</anchorfile>
+      <anchor>gga0eb99636aff71fe2704e1fa0ffe8c18dae7d6d96546131ef0043867b836b02e0f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_export_xml</name>
+      <anchorfile>a00195.html</anchorfile>
+      <anchor>ga333f79975b4eeb28a3d8fad3373583ce</anchor>
+      <arglist>(hwloc_topology_t topology, const char *xmlpath, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_export_xmlbuffer</name>
+      <anchorfile>a00195.html</anchorfile>
+      <anchor>gad33b7f7c11db10459505a3b1634fd3f1</anchor>
+      <arglist>(hwloc_topology_t topology, char **xmlbuffer, int *buflen, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_free_xmlbuffer</name>
+      <anchorfile>a00195.html</anchorfile>
+      <anchor>ga293e4a6489f15fd16ad22a5734561cf1</anchor>
+      <arglist>(hwloc_topology_t topology, char *xmlbuffer)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_topology_set_userdata_export_callback</name>
+      <anchorfile>a00195.html</anchorfile>
+      <anchor>ga9d6ff0f7a8dd45be9aa8575ef31978cc</anchor>
+      <arglist>(hwloc_topology_t topology, void(*export_cb)(void *reserved, hwloc_topology_t topology, hwloc_obj_t obj))</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_export_obj_userdata</name>
+      <anchorfile>a00195.html</anchorfile>
+      <anchor>gaa541bdd628416dbbe97d0df69d3de958</anchor>
+      <arglist>(void *reserved, hwloc_topology_t topology, hwloc_obj_t obj, const char *name, const void *buffer, size_t length)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_export_obj_userdata_base64</name>
+      <anchorfile>a00195.html</anchorfile>
+      <anchor>ga1b7358137cec27bd073f58a606ecbaba</anchor>
+      <arglist>(void *reserved, hwloc_topology_t topology, hwloc_obj_t obj, const char *name, const void *buffer, size_t length)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_topology_set_userdata_import_callback</name>
+      <anchorfile>a00195.html</anchorfile>
+      <anchor>ga5ac6917ea7289955fb1ffda4353af9b0</anchor>
+      <arglist>(hwloc_topology_t topology, void(*import_cb)(hwloc_topology_t topology, hwloc_obj_t obj, const char *name, const void *buffer, size_t length))</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_syntheticexport</name>
+    <title>Exporting Topologies to Synthetic</title>
+    <filename>a00196.html</filename>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_topology_export_synthetic_flags_e</name>
+      <anchorfile>a00196.html</anchorfile>
+      <anchor>ga7ac6f97cc40bd50c40285084f869ba63</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES</name>
+      <anchorfile>a00196.html</anchorfile>
+      <anchor>gga7ac6f97cc40bd50c40285084f869ba63a3b3bd4ba2ef9990810865e561034ccc9</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS</name>
+      <anchorfile>a00196.html</anchorfile>
+      <anchor>gga7ac6f97cc40bd50c40285084f869ba63aaa2702ffba050bab079b3041aec737d4</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1</name>
+      <anchorfile>a00196.html</anchorfile>
+      <anchor>gga7ac6f97cc40bd50c40285084f869ba63a7896bdf4ccfcdcd09a9f76c0f5e3a5b8</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY</name>
+      <anchorfile>a00196.html</anchorfile>
+      <anchor>gga7ac6f97cc40bd50c40285084f869ba63a22c57cf18e1da4a6c584fb783b552f9f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_export_synthetic</name>
+      <anchorfile>a00196.html</anchorfile>
+      <anchor>ga24b7864a1c588309c4749f621f03b4c7</anchor>
+      <arglist>(hwloc_topology_t topology, char *buffer, size_t buflen, unsigned long flags)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_distances_get</name>
+    <title>Retrieve distances between objects</title>
+    <filename>a00197.html</filename>
+    <class kind="struct">hwloc_distances_s</class>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_distances_kind_e</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>gab1bb10d3adb85b52cdc6fe5a7f74f108</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTANCES_KIND_FROM_OS</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>ggab1bb10d3adb85b52cdc6fe5a7f74f108a90dc38248c8d5392d4dd3e88f391e984</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTANCES_KIND_FROM_USER</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>ggab1bb10d3adb85b52cdc6fe5a7f74f108a0148d7f9be833a04f5a55455437c227b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTANCES_KIND_MEANS_LATENCY</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>ggab1bb10d3adb85b52cdc6fe5a7f74f108afd6a3503fbc8f7c1a31235373cefc4c6</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>ggab1bb10d3adb85b52cdc6fe5a7f74f108a41b19f141a3c0ffe85f9affaca4b0293</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>ggab1bb10d3adb85b52cdc6fe5a7f74f108aa6cf2b6dfcf148b65952f811814efbe1</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_distances_transform_e</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>ga42859b651adec5ef0aaacb53ff220b00</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTANCES_TRANSFORM_REMOVE_NULL</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>gga42859b651adec5ef0aaacb53ff220b00a4b7bdb7e3ccca30e03b7ae671e7f6dc1</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTANCES_TRANSFORM_LINKS</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>gga42859b651adec5ef0aaacb53ff220b00a441e6bb393558319af3bb1f89f51f44d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>gga42859b651adec5ef0aaacb53ff220b00a3d2aaf03e17be54eddbb94aab327fded</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>gga42859b651adec5ef0aaacb53ff220b00a1264abf9b9463f252995f37eb1057047</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_distances_get</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>ga613e6b2a5d0f06626ee8d0c12fa46691</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned *nr, struct hwloc_distances_s **distances, unsigned long kind, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_distances_get_by_depth</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>ga5d1d35eccfcc2ebcef71a10972ce9b03</anchor>
+      <arglist>(hwloc_topology_t topology, int depth, unsigned *nr, struct hwloc_distances_s **distances, unsigned long kind, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_distances_get_by_type</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>gaaa6bfbc20072a4f4de132eec859067f6</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type, unsigned *nr, struct hwloc_distances_s **distances, unsigned long kind, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_distances_get_by_name</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>gaa457f35b8745ca41ec17797c0d7b20f0</anchor>
+      <arglist>(hwloc_topology_t topology, const char *name, unsigned *nr, struct hwloc_distances_s **distances, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>const char *</type>
+      <name>hwloc_distances_get_name</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>gaff5366e26178f77d5e8dc3ac8863f2ed</anchor>
+      <arglist>(hwloc_topology_t topology, struct hwloc_distances_s *distances)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_distances_release</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>ga1dd78c1f9acd54f26aba0e284e97e51d</anchor>
+      <arglist>(hwloc_topology_t topology, struct hwloc_distances_s *distances)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_distances_transform</name>
+      <anchorfile>a00197.html</anchorfile>
+      <anchor>gabcadd041f3072999d68f2d94e38670f7</anchor>
+      <arglist>(hwloc_topology_t topology, struct hwloc_distances_s *distances, enum hwloc_distances_transform_e transform, void *transform_attr, unsigned long flags)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_distances_consult</name>
+    <title>Helpers for consulting distance matrices</title>
+    <filename>a00198.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_distances_obj_index</name>
+      <anchorfile>a00198.html</anchorfile>
+      <anchor>gab9e770c7d56c5d6040f26bd1dc8854cd</anchor>
+      <arglist>(struct hwloc_distances_s *distances, hwloc_obj_t obj)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_distances_obj_pair_values</name>
+      <anchorfile>a00198.html</anchorfile>
+      <anchor>ga3c665b23056e3269f777b21a67148c82</anchor>
+      <arglist>(struct hwloc_distances_s *distances, hwloc_obj_t obj1, hwloc_obj_t obj2, hwloc_uint64_t *value1to2, hwloc_uint64_t *value2to1)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_distances_add</name>
+    <title>Add distances between objects</title>
+    <filename>a00199.html</filename>
+    <member kind="typedef">
+      <type>void *</type>
+      <name>hwloc_distances_add_handle_t</name>
+      <anchorfile>a00199.html</anchorfile>
+      <anchor>ga554a4c1e315265f961830e2b616e4989</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_distances_add_flag_e</name>
+      <anchorfile>a00199.html</anchorfile>
+      <anchor>ga22428b6bab271411e3834e6b4ca22e37</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTANCES_ADD_FLAG_GROUP</name>
+      <anchorfile>a00199.html</anchorfile>
+      <anchor>gga22428b6bab271411e3834e6b4ca22e37a7f6baba797d70538d03c9d13052c62ab</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE</name>
+      <anchorfile>a00199.html</anchorfile>
+      <anchor>gga22428b6bab271411e3834e6b4ca22e37a5233ccf631c3bc53dd5c3e7a5d5c9b77</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_distances_add_handle_t</type>
+      <name>hwloc_distances_add_create</name>
+      <anchorfile>a00199.html</anchorfile>
+      <anchor>ga823d38fa8d21dc338497fb0f79c96704</anchor>
+      <arglist>(hwloc_topology_t topology, const char *name, unsigned long kind, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_distances_add_values</name>
+      <anchorfile>a00199.html</anchorfile>
+      <anchor>ga8c9715481b0bce344c8a33c6e6a56469</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_distances_add_handle_t handle, unsigned nbobjs, hwloc_obj_t *objs, hwloc_uint64_t *values, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_distances_add_commit</name>
+      <anchorfile>a00199.html</anchorfile>
+      <anchor>ga1f5a29760ebb8f9af831e645315f553c</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_distances_add_handle_t handle, unsigned long flags)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_distances_remove</name>
+    <title>Remove distances between objects</title>
+    <filename>a00200.html</filename>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_distances_remove</name>
+      <anchorfile>a00200.html</anchorfile>
+      <anchor>gac188d9b64d9560255ce5f6d0a20f9c0a</anchor>
+      <arglist>(hwloc_topology_t topology)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_distances_remove_by_depth</name>
+      <anchorfile>a00200.html</anchorfile>
+      <anchor>gaa642a4c1a21c84f38ae23fca8a27845d</anchor>
+      <arglist>(hwloc_topology_t topology, int depth)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_distances_remove_by_type</name>
+      <anchorfile>a00200.html</anchorfile>
+      <anchor>ga93db53773c96f5b83815e8441e2ebb93</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_distances_release_remove</name>
+      <anchorfile>a00200.html</anchorfile>
+      <anchor>ga80bbf6f0db9af48c61780dd5152664c2</anchor>
+      <arglist>(hwloc_topology_t topology, struct hwloc_distances_s *distances)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_memattrs</name>
+    <title>Comparing memory node attributes for finding where to allocate on</title>
+    <filename>a00201.html</filename>
+    <class kind="struct">hwloc_location</class>
+    <member kind="typedef">
+      <type>unsigned</type>
+      <name>hwloc_memattr_id_t</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>gacc82003a8610be554615995f0996c888</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_memattr_id_e</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>gab4bde745db676fc2ea4b47011cd9a80e</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMATTR_ID_CAPACITY</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ggab4bde745db676fc2ea4b47011cd9a80eaa1cfa3ff3d56ff00ecabf7da4f5642cc</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMATTR_ID_LOCALITY</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ggab4bde745db676fc2ea4b47011cd9a80ea9334e3a4c30a67f491c6523255134efe</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMATTR_ID_BANDWIDTH</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ggab4bde745db676fc2ea4b47011cd9a80ea25fe3c7376ae6f9b584bacdb039f8c0f</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMATTR_ID_READ_BANDWIDTH</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ggab4bde745db676fc2ea4b47011cd9a80eac34dce925d3dadb7e255391d142b4828</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMATTR_ID_WRITE_BANDWIDTH</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ggab4bde745db676fc2ea4b47011cd9a80ea44762e8ebe327cfe665cccf1f58f7530</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMATTR_ID_LATENCY</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ggab4bde745db676fc2ea4b47011cd9a80ead1796413759b8b87b61ad195a9349b19</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMATTR_ID_READ_LATENCY</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ggab4bde745db676fc2ea4b47011cd9a80ea52cab56571c7fafea42a694d80ad3dd0</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMATTR_ID_WRITE_LATENCY</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ggab4bde745db676fc2ea4b47011cd9a80eaaf6cd383da87dc9f5e3a608a535a768e</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_location_type_e</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ga33099ba58f607fc70925da3777688586</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_LOCATION_TYPE_CPUSET</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>gga33099ba58f607fc70925da3777688586a7135318a86361ad75fd1648e6bf6d174</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_LOCATION_TYPE_OBJECT</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>gga33099ba58f607fc70925da3777688586af637c39b23d48cff15ddb008644aaa84</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_local_numanode_flag_e</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>gab9c963ca37255da71b00d94e1b106f9d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ggab9c963ca37255da71b00d94e1b106f9da200c6c133bb2125ba36d77ce9ca268cc</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ggab9c963ca37255da71b00d94e1b106f9daac9c5e3a2cfb1b193e4acfceaf3bad57</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_LOCAL_NUMANODE_FLAG_ALL</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ggab9c963ca37255da71b00d94e1b106f9dab5778b34c961a5d56f98f1549edeaed0</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_memattr_get_by_name</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ga79f44f8e1cfd2f97a19171417a75a137</anchor>
+      <arglist>(hwloc_topology_t topology, const char *name, hwloc_memattr_id_t *id)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_get_local_numanode_objs</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ga569e80c5be7ef27649b0ef5aa52ffcdc</anchor>
+      <arglist>(hwloc_topology_t topology, struct hwloc_location *location, unsigned *nr, hwloc_obj_t *nodes, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_memattr_get_value</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ga297e4a9adc2272446a4c7449dacef0df</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_memattr_id_t attribute, hwloc_obj_t target_node, struct hwloc_location *initiator, unsigned long flags, hwloc_uint64_t *value)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_memattr_get_best_target</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ga884d1f2ad745c2fa69c1583c82d28f10</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_memattr_id_t attribute, struct hwloc_location *initiator, unsigned long flags, hwloc_obj_t *best_target, hwloc_uint64_t *value)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_memattr_get_best_initiator</name>
+      <anchorfile>a00201.html</anchorfile>
+      <anchor>ga9a453879892893cf8a3fcd431ade84cd</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_memattr_id_t attribute, hwloc_obj_t target, unsigned long flags, struct hwloc_location *best_initiator, hwloc_uint64_t *value)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_memattrs_manage</name>
+    <title>Managing memory attributes</title>
+    <filename>a00202.html</filename>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_memattr_flag_e</name>
+      <anchorfile>a00202.html</anchorfile>
+      <anchor>ga78aceb4cac4d614c0f5e82dbfeb779e5</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMATTR_FLAG_HIGHER_FIRST</name>
+      <anchorfile>a00202.html</anchorfile>
+      <anchor>gga78aceb4cac4d614c0f5e82dbfeb779e5af29e65444a6ed00f5cc246df06f65815</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMATTR_FLAG_LOWER_FIRST</name>
+      <anchorfile>a00202.html</anchorfile>
+      <anchor>gga78aceb4cac4d614c0f5e82dbfeb779e5a9601b5b0e1e68635e7e9901f28bd93bf</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_MEMATTR_FLAG_NEED_INITIATOR</name>
+      <anchorfile>a00202.html</anchorfile>
+      <anchor>gga78aceb4cac4d614c0f5e82dbfeb779e5a9d16523e285b2e22cfc78cc84dce8c96</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_memattr_get_name</name>
+      <anchorfile>a00202.html</anchorfile>
+      <anchor>ga5300e9be1abdea2e00c18492148aecd0</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_memattr_id_t attribute, const char **name)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_memattr_get_flags</name>
+      <anchorfile>a00202.html</anchorfile>
+      <anchor>ga4c62b626085adeaffb233e5f2a03a5eb</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_memattr_id_t attribute, unsigned long *flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_memattr_register</name>
+      <anchorfile>a00202.html</anchorfile>
+      <anchor>ga770657d1e44b09e93e09f623936c1e5f</anchor>
+      <arglist>(hwloc_topology_t topology, const char *name, unsigned long flags, hwloc_memattr_id_t *id)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_memattr_set_value</name>
+      <anchorfile>a00202.html</anchorfile>
+      <anchor>ga960529c08b25cf15825e0f72ecceb504</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_memattr_id_t attribute, hwloc_obj_t target_node, struct hwloc_location *initiator, unsigned long flags, hwloc_uint64_t value)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_memattr_get_targets</name>
+      <anchorfile>a00202.html</anchorfile>
+      <anchor>gac8c06c1c89ab352c5db8e04a75033513</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_memattr_id_t attribute, struct hwloc_location *initiator, unsigned long flags, unsigned *nr, hwloc_obj_t *targets, hwloc_uint64_t *values)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_memattr_get_initiators</name>
+      <anchorfile>a00202.html</anchorfile>
+      <anchor>ga049aaa860dcbbf0792f0fd4251a99ec0</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_memattr_id_t attribute, hwloc_obj_t target_node, unsigned long flags, unsigned *nr, struct hwloc_location *initiators, hwloc_uint64_t *values)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_cpukinds</name>
+    <title>Kinds of CPU cores</title>
+    <filename>a00203.html</filename>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_cpukinds_get_nr</name>
+      <anchorfile>a00203.html</anchorfile>
+      <anchor>ga7553f7c6d3920b169f3fc18dfe6a33e3</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_cpukinds_get_by_cpuset</name>
+      <anchorfile>a00203.html</anchorfile>
+      <anchor>gaf979833aab18d2e7f4b17c932cbcf5d8</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_bitmap_t cpuset, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_cpukinds_get_info</name>
+      <anchorfile>a00203.html</anchorfile>
+      <anchor>gae1b38fbe9c645583fc16052ce6fbb275</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned kind_index, hwloc_bitmap_t cpuset, int *efficiency, unsigned *nr_infos, struct hwloc_info_s **infos, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_cpukinds_register</name>
+      <anchorfile>a00203.html</anchorfile>
+      <anchor>ga6164ba92cfd06f530ec2c4a18a0dd5a9</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_bitmap_t cpuset, int forced_efficiency, unsigned nr_infos, struct hwloc_info_s *infos, unsigned long flags)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_linux</name>
+    <title>Linux-specific helpers</title>
+    <filename>a00204.html</filename>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_linux_set_tid_cpubind</name>
+      <anchorfile>a00204.html</anchorfile>
+      <anchor>ga630e699c56b5f3d2e534b475944c216e</anchor>
+      <arglist>(hwloc_topology_t topology, pid_t tid, hwloc_const_cpuset_t set)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_linux_get_tid_cpubind</name>
+      <anchorfile>a00204.html</anchorfile>
+      <anchor>gaddcb985cb56337a4d6693cee72e7bf94</anchor>
+      <arglist>(hwloc_topology_t topology, pid_t tid, hwloc_cpuset_t set)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_linux_get_tid_last_cpu_location</name>
+      <anchorfile>a00204.html</anchorfile>
+      <anchor>gacc7945c2d06c6db1e58f8fd953009134</anchor>
+      <arglist>(hwloc_topology_t topology, pid_t tid, hwloc_bitmap_t set)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_linux_read_path_as_cpumask</name>
+      <anchorfile>a00204.html</anchorfile>
+      <anchor>gaf72d83e273803226ce772973e37b85de</anchor>
+      <arglist>(const char *path, hwloc_bitmap_t set)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_linux_libnuma_ulongs</name>
+    <title>Interoperability with Linux libnuma unsigned long masks</title>
+    <filename>a00205.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_cpuset_to_linux_libnuma_ulongs</name>
+      <anchorfile>a00205.html</anchorfile>
+      <anchor>gae577962390f84b0b12f503314ab0f972</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t cpuset, unsigned long *mask, unsigned long *maxnode)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_nodeset_to_linux_libnuma_ulongs</name>
+      <anchorfile>a00205.html</anchorfile>
+      <anchor>ga585ccf818d2f217f4e53f9c6506c3128</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_nodeset_t nodeset, unsigned long *mask, unsigned long *maxnode)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_cpuset_from_linux_libnuma_ulongs</name>
+      <anchorfile>a00205.html</anchorfile>
+      <anchor>ga0e9d051e068940f722f6fdc61814149d</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_cpuset_t cpuset, const unsigned long *mask, unsigned long maxnode)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_nodeset_from_linux_libnuma_ulongs</name>
+      <anchorfile>a00205.html</anchorfile>
+      <anchor>gad8491c672eb2594cc5e7b0a026867192</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_nodeset_t nodeset, const unsigned long *mask, unsigned long maxnode)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_linux_libnuma_bitmask</name>
+    <title>Interoperability with Linux libnuma bitmask</title>
+    <filename>a00206.html</filename>
+    <member kind="function" static="yes">
+      <type>static struct bitmask *</type>
+      <name>hwloc_cpuset_to_linux_libnuma_bitmask</name>
+      <anchorfile>a00206.html</anchorfile>
+      <anchor>gad8769b4544c0aeef154fc8223144e343</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t cpuset)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static struct bitmask *</type>
+      <name>hwloc_nodeset_to_linux_libnuma_bitmask</name>
+      <anchorfile>a00206.html</anchorfile>
+      <anchor>gadfaa14c1bec76965ac2e05f0c3f3473b</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_nodeset_t nodeset)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_cpuset_from_linux_libnuma_bitmask</name>
+      <anchorfile>a00206.html</anchorfile>
+      <anchor>ga37c8421110b1842414809019098794ef</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_cpuset_t cpuset, const struct bitmask *bitmask)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_nodeset_from_linux_libnuma_bitmask</name>
+      <anchorfile>a00206.html</anchorfile>
+      <anchor>gaaca6bff3086aad5bdbd2f4c5f0ad14cc</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_nodeset_t nodeset, const struct bitmask *bitmask)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_windows</name>
+    <title>Windows-specific helpers</title>
+    <filename>a00207.html</filename>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_windows_get_nr_processor_groups</name>
+      <anchorfile>a00207.html</anchorfile>
+      <anchor>gaa4376a1969660a344911d117f645d3dd</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_windows_get_processor_group_cpuset</name>
+      <anchorfile>a00207.html</anchorfile>
+      <anchor>ga167d1f28d3bd9defe1ffa940c14e8dd1</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned pg_index, hwloc_cpuset_t cpuset, unsigned long flags)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_glibc_sched</name>
+    <title>Interoperability with glibc sched affinity</title>
+    <filename>a00208.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_cpuset_to_glibc_sched_affinity</name>
+      <anchorfile>a00208.html</anchorfile>
+      <anchor>ga88699a0c86c66a9b7baa3468cd9d24c3</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_const_cpuset_t hwlocset, cpu_set_t *schedset, size_t schedsetsize)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_cpuset_from_glibc_sched_affinity</name>
+      <anchorfile>a00208.html</anchorfile>
+      <anchor>ga8ec807ec17de57fa77aa5cfd6c8e4bfb</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_cpuset_t hwlocset, const cpu_set_t *schedset, size_t schedsetsize)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_opencl</name>
+    <title>Interoperability with OpenCL</title>
+    <filename>a00209.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_opencl_get_device_pci_busid</name>
+      <anchorfile>a00209.html</anchorfile>
+      <anchor>gab89e4d20f8a353299351b41849e35ac9</anchor>
+      <arglist>(cl_device_id device, unsigned *domain, unsigned *bus, unsigned *dev, unsigned *func)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_opencl_get_device_cpuset</name>
+      <anchorfile>a00209.html</anchorfile>
+      <anchor>gacc32737d4648d16b0d292438f210ec90</anchor>
+      <arglist>(hwloc_topology_t topology, cl_device_id device, hwloc_cpuset_t set)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_opencl_get_device_osdev_by_index</name>
+      <anchorfile>a00209.html</anchorfile>
+      <anchor>gae39352d124cb330eb37b84b418ed6cc5</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned platform_index, unsigned device_index)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_opencl_get_device_osdev</name>
+      <anchorfile>a00209.html</anchorfile>
+      <anchor>gadabfa6516aa12e5d8f79b9b4dd9f3cf8</anchor>
+      <arglist>(hwloc_topology_t topology, cl_device_id device)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_cuda</name>
+    <title>Interoperability with the CUDA Driver API</title>
+    <filename>a00210.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_cuda_get_device_pci_ids</name>
+      <anchorfile>a00210.html</anchorfile>
+      <anchor>ga1084285e8ff8b7df91c28917637481c6</anchor>
+      <arglist>(hwloc_topology_t topology, CUdevice cudevice, int *domain, int *bus, int *dev)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_cuda_get_device_cpuset</name>
+      <anchorfile>a00210.html</anchorfile>
+      <anchor>gaec41c6b4dc3361156beb7dea2a74f5a3</anchor>
+      <arglist>(hwloc_topology_t topology, CUdevice cudevice, hwloc_cpuset_t set)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_cuda_get_device_pcidev</name>
+      <anchorfile>a00210.html</anchorfile>
+      <anchor>ga11fed607fa404e29e8da010f3ec128e4</anchor>
+      <arglist>(hwloc_topology_t topology, CUdevice cudevice)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_cuda_get_device_osdev</name>
+      <anchorfile>a00210.html</anchorfile>
+      <anchor>ga252cb72175f1a2d682f883a0add80a66</anchor>
+      <arglist>(hwloc_topology_t topology, CUdevice cudevice)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_cuda_get_device_osdev_by_index</name>
+      <anchorfile>a00210.html</anchorfile>
+      <anchor>ga12ee892994ed037e8f64bbffda02cf2e</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned idx)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_cudart</name>
+    <title>Interoperability with the CUDA Runtime API</title>
+    <filename>a00211.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_cudart_get_device_pci_ids</name>
+      <anchorfile>a00211.html</anchorfile>
+      <anchor>gad8b701d9a34923e34bd58defd4c1e704</anchor>
+      <arglist>(hwloc_topology_t topology, int idx, int *domain, int *bus, int *dev)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_cudart_get_device_cpuset</name>
+      <anchorfile>a00211.html</anchorfile>
+      <anchor>ga187ca00c6e12800a25151ce331620980</anchor>
+      <arglist>(hwloc_topology_t topology, int idx, hwloc_cpuset_t set)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_cudart_get_device_pcidev</name>
+      <anchorfile>a00211.html</anchorfile>
+      <anchor>gaeda4e6efbb36b518b2c286434ad23bb2</anchor>
+      <arglist>(hwloc_topology_t topology, int idx)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_cudart_get_device_osdev_by_index</name>
+      <anchorfile>a00211.html</anchorfile>
+      <anchor>gac0f3eeaf7712919f298097b1a21307b0</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned idx)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_nvml</name>
+    <title>Interoperability with the NVIDIA Management Library</title>
+    <filename>a00212.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_nvml_get_device_cpuset</name>
+      <anchorfile>a00212.html</anchorfile>
+      <anchor>ga26cf0036d09ec4d7cb692380fac9659d</anchor>
+      <arglist>(hwloc_topology_t topology, nvmlDevice_t device, hwloc_cpuset_t set)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_nvml_get_device_osdev_by_index</name>
+      <anchorfile>a00212.html</anchorfile>
+      <anchor>gacd50fd0e2766ee05bc13234b46714756</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned idx)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_nvml_get_device_osdev</name>
+      <anchorfile>a00212.html</anchorfile>
+      <anchor>gaf176159b5760a191871eff23f5a69ee9</anchor>
+      <arglist>(hwloc_topology_t topology, nvmlDevice_t device)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_rsmi</name>
+    <title>Interoperability with the ROCm SMI Management Library</title>
+    <filename>a00213.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_rsmi_get_device_cpuset</name>
+      <anchorfile>a00213.html</anchorfile>
+      <anchor>gaf939e697e3769c3524255318262b9c29</anchor>
+      <arglist>(hwloc_topology_t topology, uint32_t dv_ind, hwloc_cpuset_t set)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_rsmi_get_device_osdev_by_index</name>
+      <anchorfile>a00213.html</anchorfile>
+      <anchor>ga507d0acdd5e9ac374a8d120d59604c80</anchor>
+      <arglist>(hwloc_topology_t topology, uint32_t dv_ind)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_rsmi_get_device_osdev</name>
+      <anchorfile>a00213.html</anchorfile>
+      <anchor>gaba05bf9710655bb5b1439bee654340ba</anchor>
+      <arglist>(hwloc_topology_t topology, uint32_t dv_ind)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_levelzero</name>
+    <title>Interoperability with the oneAPI Level Zero interface.</title>
+    <filename>a00214.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_levelzero_get_device_cpuset</name>
+      <anchorfile>a00214.html</anchorfile>
+      <anchor>ga66281a9ba621357b1c7070b4fa19b5b8</anchor>
+      <arglist>(hwloc_topology_t topology, ze_device_handle_t device, hwloc_cpuset_t set)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_levelzero_get_device_osdev</name>
+      <anchorfile>a00214.html</anchorfile>
+      <anchor>gaf06cb737abcd2dc6db894c8914302d85</anchor>
+      <arglist>(hwloc_topology_t topology, ze_device_handle_t device)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_gl</name>
+    <title>Interoperability with OpenGL displays</title>
+    <filename>a00215.html</filename>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_gl_get_display_osdev_by_port_device</name>
+      <anchorfile>a00215.html</anchorfile>
+      <anchor>ga4d66a77e4fe4051d6e5b772c1b8fcec5</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned port, unsigned device)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_gl_get_display_osdev_by_name</name>
+      <anchorfile>a00215.html</anchorfile>
+      <anchor>ga2d36ef441d1dfddf49cfb5c01bd58d8e</anchor>
+      <arglist>(hwloc_topology_t topology, const char *name)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_gl_get_display_by_osdev</name>
+      <anchorfile>a00215.html</anchorfile>
+      <anchor>ga936665ab5f0d29a081c4b78d11f4ad07</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t osdev, unsigned *port, unsigned *device)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_openfabrics</name>
+    <title>Interoperability with OpenFabrics</title>
+    <filename>a00216.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_ibv_get_device_cpuset</name>
+      <anchorfile>a00216.html</anchorfile>
+      <anchor>ga3ea0d838c1e7f1671b35687aae2da6ae</anchor>
+      <arglist>(hwloc_topology_t topology, struct ibv_device *ibdev, hwloc_cpuset_t set)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_ibv_get_device_osdev_by_name</name>
+      <anchorfile>a00216.html</anchorfile>
+      <anchor>ga31d794567f4420bbdc8baa7bf8bf6138</anchor>
+      <arglist>(hwloc_topology_t topology, const char *ibname)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static hwloc_obj_t</type>
+      <name>hwloc_ibv_get_device_osdev</name>
+      <anchorfile>a00216.html</anchorfile>
+      <anchor>ga7324cdfd5db6ed2669c051ef7e1b64e1</anchor>
+      <arglist>(hwloc_topology_t topology, struct ibv_device *ibdev)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_diff</name>
+    <title>Topology differences</title>
+    <filename>a00217.html</filename>
+    <class kind="union">hwloc_topology_diff_obj_attr_u</class>
+    <class kind="union">hwloc_topology_diff_u</class>
+    <member kind="typedef">
+      <type>enum hwloc_topology_diff_obj_attr_type_e</type>
+      <name>hwloc_topology_diff_obj_attr_type_t</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>ga74a3fefbaa17582fea86d76b312d6254</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="typedef">
+      <type>enum hwloc_topology_diff_type_e</type>
+      <name>hwloc_topology_diff_type_t</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>ga8470f631b7365c839d3e40d38c5b6291</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="typedef">
+      <type>union hwloc_topology_diff_u *</type>
+      <name>hwloc_topology_diff_t</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>ga1bd6363f26f7961f83153aaa484a9b85</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_topology_diff_obj_attr_type_e</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>ga86f044210b0a9e9fa83acbdbbf7e05fd</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>gga86f044210b0a9e9fa83acbdbbf7e05fdabc7f0c7ed0b6864e902f4b70f2c7bc94</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>gga86f044210b0a9e9fa83acbdbbf7e05fda94a8f37c51d62d15ac6192665dd49310</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>gga86f044210b0a9e9fa83acbdbbf7e05fda63430bf932434bc456282f636d39c2c2</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_topology_diff_type_e</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>ga38b28b7423b85a3321e6d0062d5f83d0</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_DIFF_OBJ_ATTR</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>gga38b28b7423b85a3321e6d0062d5f83d0accbcaee230f79989debb284c8626f0c0</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>gga38b28b7423b85a3321e6d0062d5f83d0a3dc01fdeff355efe3fb2516bb454a147</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_topology_diff_apply_flags_e</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>gada4c1273ce020afaf02b649496f7edf5</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_TOPOLOGY_DIFF_APPLY_REVERSE</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>ggada4c1273ce020afaf02b649496f7edf5a821a160512d67ea0dd05dab873d2fc54</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_diff_build</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>ga8a1754f69fbb31364ea3ea2c39827c9f</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_topology_t newtopology, unsigned long flags, hwloc_topology_diff_t *diff)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_diff_apply</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>gae7b350d7e7478a4c6047b08aa6544f40</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_topology_diff_t diff, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_diff_destroy</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>ga5dcff18f80583ac6505a94ba2877fd1b</anchor>
+      <arglist>(hwloc_topology_diff_t diff)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_diff_load_xml</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>ga2cd902ce8766e90d4f2523a8e87640e9</anchor>
+      <arglist>(const char *xmlpath, hwloc_topology_diff_t *diff, char **refname)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_diff_export_xml</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>ga8a14dd7d01efbdd97af7fe85e8b84b20</anchor>
+      <arglist>(hwloc_topology_diff_t diff, const char *refname, const char *xmlpath)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_diff_load_xmlbuffer</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>gad693810a5c51628529b9dd56f040fb81</anchor>
+      <arglist>(const char *xmlbuffer, int buflen, hwloc_topology_diff_t *diff, char **refname)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_diff_export_xmlbuffer</name>
+      <anchorfile>a00217.html</anchorfile>
+      <anchor>gaa2f0918df60c1c4a0bef9411f7d92a13</anchor>
+      <arglist>(hwloc_topology_diff_t diff, const char *refname, char **xmlbuffer, int *buflen)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_shmem</name>
+    <title>Sharing topologies between processes</title>
+    <filename>a00218.html</filename>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_shmem_topology_get_length</name>
+      <anchorfile>a00218.html</anchorfile>
+      <anchor>ga772ab52750cdd0eec85128df24888001</anchor>
+      <arglist>(hwloc_topology_t topology, size_t *lengthp, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_shmem_topology_write</name>
+      <anchorfile>a00218.html</anchorfile>
+      <anchor>ga61b20e346fc76f76420e3a88cc80a671</anchor>
+      <arglist>(hwloc_topology_t topology, int fd, hwloc_uint64_t fileoffset, void *mmap_address, size_t length, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_shmem_topology_adopt</name>
+      <anchorfile>a00218.html</anchorfile>
+      <anchor>ga21545bd0f09d9b554c8e60a630e0e629</anchor>
+      <arglist>(hwloc_topology_t *topologyp, int fd, hwloc_uint64_t fileoffset, void *mmap_address, size_t length, unsigned long flags)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_disc_components</name>
+    <title>Components and Plugins: Discovery components</title>
+    <filename>a00219.html</filename>
+    <class kind="struct">hwloc_disc_component</class>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_disc_backends</name>
+    <title>Components and Plugins: Discovery backends</title>
+    <filename>a00220.html</filename>
+    <class kind="struct">hwloc_disc_status</class>
+    <class kind="struct">hwloc_backend</class>
+    <member kind="typedef">
+      <type>enum hwloc_disc_phase_e</type>
+      <name>hwloc_disc_phase_t</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>ga600bba1a62022d5f516800649b1edb61</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_disc_phase_e</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>ga8c314121c2fc478161bcce758688b9a1</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISC_PHASE_GLOBAL</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>gga8c314121c2fc478161bcce758688b9a1ab41c626c79e9ccb1e7d41e7076972283</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISC_PHASE_CPU</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>gga8c314121c2fc478161bcce758688b9a1a6360474df197027761a69bd5fc620250</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISC_PHASE_MEMORY</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>gga8c314121c2fc478161bcce758688b9a1ac4264a243844c5fbbff495cdb1b4d51d</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISC_PHASE_PCI</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>gga8c314121c2fc478161bcce758688b9a1a677c52064dd987af4988346319b3675a</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISC_PHASE_IO</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>gga8c314121c2fc478161bcce758688b9a1aa8e10626cba9af72f5605a1acbdc0015</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISC_PHASE_MISC</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>gga8c314121c2fc478161bcce758688b9a1a8a7cde9bff0ab0d085b102a3e934939b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISC_PHASE_ANNOTATE</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>gga8c314121c2fc478161bcce758688b9a1a68ca5c7ad75a6d9e5355689411621773</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISC_PHASE_TWEAK</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>gga8c314121c2fc478161bcce758688b9a1ada3ed3f00e74909353d6ea4a96cde5ad</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_disc_status_flag_e</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>gaae1b38cf9b12e489884ce2a07275964b</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>ggaae1b38cf9b12e489884ce2a07275964ba205d644d54a0840bd9165fce7d19e6b1</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>struct hwloc_backend *</type>
+      <name>hwloc_backend_alloc</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>ga6118a1009aa390c13255a330ccf253cf</anchor>
+      <arglist>(struct hwloc_topology *topology, struct hwloc_disc_component *component)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_backend_enable</name>
+      <anchorfile>a00220.html</anchorfile>
+      <anchor>ga4715779d7191833e9b1a7490989a7497</anchor>
+      <arglist>(struct hwloc_backend *backend)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_generic_components</name>
+    <title>Components and Plugins: Generic components</title>
+    <filename>a00221.html</filename>
+    <class kind="struct">hwloc_component</class>
+    <member kind="typedef">
+      <type>enum hwloc_component_type_e</type>
+      <name>hwloc_component_type_t</name>
+      <anchorfile>a00221.html</anchorfile>
+      <anchor>ga31a5a455f4e666b936f0a9e8fb9a0f47</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumeration">
+      <type></type>
+      <name>hwloc_component_type_e</name>
+      <anchorfile>a00221.html</anchorfile>
+      <anchor>ga397a1bf7d21dd073320ad0045340f463</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_COMPONENT_TYPE_DISC</name>
+      <anchorfile>a00221.html</anchorfile>
+      <anchor>gga397a1bf7d21dd073320ad0045340f463a5d6e561f467fe9795a29e7368b613900</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="enumvalue">
+      <name>HWLOC_COMPONENT_TYPE_XML</name>
+      <anchorfile>a00221.html</anchorfile>
+      <anchor>gga397a1bf7d21dd073320ad0045340f463adea00cd839c2141c032e1569fd5592bd</anchor>
+      <arglist></arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_components_core_funcs</name>
+    <title>Components and Plugins: Core functions to be used by components</title>
+    <filename>a00222.html</filename>
+    <member kind="define">
+      <type>#define</type>
+      <name>HWLOC_SHOW_CRITICAL_ERRORS</name>
+      <anchorfile>a00222.html</anchorfile>
+      <anchor>gafce07a2a959190a6c7126b321bef202f</anchor>
+      <arglist>()</arglist>
+    </member>
+    <member kind="define">
+      <type>#define</type>
+      <name>HWLOC_SHOW_ALL_ERRORS</name>
+      <anchorfile>a00222.html</anchorfile>
+      <anchor>ga3e48b6ac00ed6a40aea975e23eddcdbb</anchor>
+      <arglist>()</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_hide_errors</name>
+      <anchorfile>a00222.html</anchorfile>
+      <anchor>gab527c1e0f243f057d31a724794ad9f88</anchor>
+      <arglist>(void)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_obj_t</type>
+      <name>hwloc__insert_object_by_cpuset</name>
+      <anchorfile>a00222.html</anchorfile>
+      <anchor>ga1e105cfe3c8e77f34cc6df3841deebbc</anchor>
+      <arglist>(struct hwloc_topology *topology, hwloc_obj_t root, hwloc_obj_t obj, const char *reason)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_insert_object_by_parent</name>
+      <anchorfile>a00222.html</anchorfile>
+      <anchor>ga0ef97debde503b56367689b07bb3e901</anchor>
+      <arglist>(struct hwloc_topology *topology, hwloc_obj_t parent, hwloc_obj_t obj)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_obj_t</type>
+      <name>hwloc_alloc_setup_object</name>
+      <anchorfile>a00222.html</anchorfile>
+      <anchor>ga0b5c75b2dc37cea2e8a29c4812baf4b3</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type, unsigned os_index)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_obj_add_children_sets</name>
+      <anchorfile>a00222.html</anchorfile>
+      <anchor>ga754b61041ceee9685534a2c5d3cd0156</anchor>
+      <arglist>(hwloc_obj_t obj)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_topology_reconnect</name>
+      <anchorfile>a00222.html</anchorfile>
+      <anchor>ga120d8bd74922e1030b621409a6b0be61</anchor>
+      <arglist>(hwloc_topology_t topology, unsigned long flags)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_plugin_check_namespace</name>
+      <anchorfile>a00222.html</anchorfile>
+      <anchor>gac2eaed287bb215cf0bd33014e9e1d374</anchor>
+      <arglist>(const char *pluginname, const char *symbol)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_components_filtering</name>
+    <title>Components and Plugins: Filtering objects</title>
+    <filename>a00223.html</filename>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_filter_check_pcidev_subtype_important</name>
+      <anchorfile>a00223.html</anchorfile>
+      <anchor>ga60203db6459ebf275bf48c40a37661a0</anchor>
+      <arglist>(unsigned classid)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_filter_check_osdev_subtype_important</name>
+      <anchorfile>a00223.html</anchorfile>
+      <anchor>gac7d57a6d669820f360cf2a070a396560</anchor>
+      <arglist>(hwloc_obj_osdev_type_t subtype)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_filter_check_keep_object_type</name>
+      <anchorfile>a00223.html</anchorfile>
+      <anchor>ga2f402a43025a8a91e8513be1a15e4635</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_type_t type)</arglist>
+    </member>
+    <member kind="function" static="yes">
+      <type>static int</type>
+      <name>hwloc_filter_check_keep_object</name>
+      <anchorfile>a00223.html</anchorfile>
+      <anchor>ga4d2fdce071e5646ef147c9ff1539d1c9</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_obj_t obj)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_components_pcidisc</name>
+    <title>Components and Plugins: helpers for PCI discovery</title>
+    <filename>a00224.html</filename>
+    <member kind="function">
+      <type>unsigned</type>
+      <name>hwloc_pcidisc_find_cap</name>
+      <anchorfile>a00224.html</anchorfile>
+      <anchor>ga706f71cfea09d547d2cbafa642d6e03b</anchor>
+      <arglist>(const unsigned char *config, unsigned cap)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_pcidisc_find_linkspeed</name>
+      <anchorfile>a00224.html</anchorfile>
+      <anchor>ga51d1ebcbf9729987c9d17df3aa57d209</anchor>
+      <arglist>(const unsigned char *config, unsigned offset, float *linkspeed)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_obj_type_t</type>
+      <name>hwloc_pcidisc_check_bridge_type</name>
+      <anchorfile>a00224.html</anchorfile>
+      <anchor>ga6c55fb80c3d0c8c8e61078b3f38adde8</anchor>
+      <arglist>(unsigned device_class, const unsigned char *config)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_pcidisc_find_bridge_buses</name>
+      <anchorfile>a00224.html</anchorfile>
+      <anchor>ga95acf6822a49447c11067d0b843965ba</anchor>
+      <arglist>(unsigned domain, unsigned bus, unsigned dev, unsigned func, unsigned *secondary_busp, unsigned *subordinate_busp, const unsigned char *config)</arglist>
+    </member>
+    <member kind="function">
+      <type>void</type>
+      <name>hwloc_pcidisc_tree_insert_by_busid</name>
+      <anchorfile>a00224.html</anchorfile>
+      <anchor>gab76ddc4f55db8101ef0d44317965128c</anchor>
+      <arglist>(struct hwloc_obj **treep, struct hwloc_obj *obj)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_pcidisc_tree_attach</name>
+      <anchorfile>a00224.html</anchorfile>
+      <anchor>gabda1d6c1799e50b9226f8a4da9bd29ea</anchor>
+      <arglist>(struct hwloc_topology *topology, struct hwloc_obj *tree)</arglist>
+    </member>
+  </compound>
+  <compound kind="group">
+    <name>hwlocality_components_pcifind</name>
+    <title>Components and Plugins: finding PCI objects during other discoveries</title>
+    <filename>a00225.html</filename>
+    <member kind="typedef">
+      <type>void *</type>
+      <name>hwloc_backend_distances_add_handle_t</name>
+      <anchorfile>a00225.html</anchorfile>
+      <anchor>gafe5e49d32dd0a28ead94b6e31048e042</anchor>
+      <arglist></arglist>
+    </member>
+    <member kind="function">
+      <type>struct hwloc_obj *</type>
+      <name>hwloc_pci_find_parent_by_busid</name>
+      <anchorfile>a00225.html</anchorfile>
+      <anchor>ga5062f8cb07418b9cb01657d363d0f969</anchor>
+      <arglist>(struct hwloc_topology *topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)</arglist>
+    </member>
+    <member kind="function">
+      <type>struct hwloc_obj *</type>
+      <name>hwloc_pci_find_by_busid</name>
+      <anchorfile>a00225.html</anchorfile>
+      <anchor>ga1779bc839369b3edcea1545a04ea123c</anchor>
+      <arglist>(struct hwloc_topology *topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)</arglist>
+    </member>
+    <member kind="function">
+      <type>hwloc_backend_distances_add_handle_t</type>
+      <name>hwloc_backend_distances_add_create</name>
+      <anchorfile>a00225.html</anchorfile>
+      <anchor>gaa66a0bd519a5b1183a3e9b0c35a7f6cc</anchor>
+      <arglist>(hwloc_topology_t topology, const char *name, unsigned long kind, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_backend_distances_add_values</name>
+      <anchorfile>a00225.html</anchorfile>
+      <anchor>gaa27036bd83102f8e406f1051d560da6c</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_backend_distances_add_handle_t handle, unsigned nbobjs, hwloc_obj_t *objs, hwloc_uint64_t *values, unsigned long flags)</arglist>
+    </member>
+    <member kind="function">
+      <type>int</type>
+      <name>hwloc_backend_distances_add_commit</name>
+      <anchorfile>a00225.html</anchorfile>
+      <anchor>ga1468ac5f0bfb0e18bfc04c9ce5a5a4a3</anchor>
+      <arglist>(hwloc_topology_t topology, hwloc_backend_distances_add_handle_t handle, unsigned long flags)</arglist>
+    </member>
+  </compound>
+  <compound kind="page">
+    <name>installation</name>
+    <title>Installation</title>
+    <filename>a00374.html</filename>
+    <docanchor file="a00374.html" title="Basic Installation">basic_installation</docanchor>
+    <docanchor file="a00374.html" title="Optional Dependencies">optional_dependencies</docanchor>
+    <docanchor file="a00374.html" title="Installing from a Git clone">gitclone_installation</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>useapi</name>
+    <title>Compiling software on top of hwloc&apos;s C API</title>
+    <filename>a00375.html</filename>
+    <docanchor file="a00375.html" title="Compiling on top of hwloc&apos;s C API with GNU Make">useapi_gnumake</docanchor>
+    <docanchor file="a00375.html" title="Compiling on top of hwloc&apos;s C API with CMake">useapi_cmake</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>termsanddefs</name>
+    <title>Terms and Definitions</title>
+    <filename>a00376.html</filename>
+    <docanchor file="a00376.html" title="Objects">termsanddefs_objects</docanchor>
+    <docanchor file="a00376.html" title="Indexes and Sets">termsanddefs_indexes</docanchor>
+    <docanchor file="a00376.html" title="Hierarchy, Tree and Levels">termsanddefs_tree</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>tools</name>
+    <title>Command-Line Tools</title>
+    <filename>a00377.html</filename>
+    <docanchor file="a00377.html" title="lstopo and lstopo-no-graphics">cli_lstopo</docanchor>
+    <docanchor file="a00377.html" title="hwloc-bind">cli_hwloc_bind</docanchor>
+    <docanchor file="a00377.html" title="hwloc-calc">cli_hwloc_calc</docanchor>
+    <docanchor file="a00377.html" title="hwloc-info">cli_hwloc_info</docanchor>
+    <docanchor file="a00377.html" title="hwloc-distrib">cli_hwloc_distrib</docanchor>
+    <docanchor file="a00377.html" title="hwloc-ps">cli_hwloc_ps</docanchor>
+    <docanchor file="a00377.html" title="hwloc-annotate">cli_hwloc_annotate</docanchor>
+    <docanchor file="a00377.html" title="hwloc-diff, hwloc-patch and hwloc-compress-dir">cli_hwloc_diffpatchcompress</docanchor>
+    <docanchor file="a00377.html" title="hwloc-dump-hwdata">cli_hwloc_dump_hwdata</docanchor>
+    <docanchor file="a00377.html" title="hwloc-gather-topology and hwloc-gather-cpuid">cli_hwloc_gather</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>envvar</name>
+    <title>Environment Variables</title>
+    <filename>a00378.html</filename>
+  </compound>
+  <compound kind="page">
+    <name>cpu_mem_bind</name>
+    <title>CPU and Memory Binding Overview</title>
+    <filename>a00379.html</filename>
+    <docanchor file="a00379.html" title="Binding Policies and Portability">cpu_mem_bind_portability</docanchor>
+    <docanchor file="a00379.html" title="Joint CPU and Memory Binding (or not)">cpu_mem_bind_joint</docanchor>
+    <docanchor file="a00379.html" title="Current Memory Binding Policy">cpu_mem_bind_current_membind</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>iodevices</name>
+    <title>I/O Devices</title>
+    <filename>a00380.html</filename>
+    <docanchor file="a00380.html" title="Enabling and requirements">iodevices_enabling</docanchor>
+    <docanchor file="a00380.html" title="I/O objects">iodevices_objects</docanchor>
+    <docanchor file="a00380.html" title="OS devices">iodevices_osdev</docanchor>
+    <docanchor file="a00380.html" title="PCI devices and bridges">iodevices_pci</docanchor>
+    <docanchor file="a00380.html" title="Consulting I/O devices and binding">iodevices_consult</docanchor>
+    <docanchor file="a00380.html" title="Examples">iodevices_examples</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>miscobjs</name>
+    <title>Miscellaneous objects</title>
+    <filename>a00381.html</filename>
+    <docanchor file="a00381.html" title="Misc objects added by hwloc">miscobjs_auto</docanchor>
+    <docanchor file="a00381.html" title="Annotating topologies with Misc objects">miscobjs_annotate</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>attributes</name>
+    <title>Object attributes</title>
+    <filename>a00382.html</filename>
+    <docanchor file="a00382.html" title="Normal attributes">attributes_normal</docanchor>
+    <docanchor file="a00382.html" title="Custom string infos">attributes_info</docanchor>
+    <docanchor file="a00382.html" title="Hardware Platform Information">attributes_info_platform</docanchor>
+    <docanchor file="a00382.html" title="Operating System Information">attributes_info_os</docanchor>
+    <docanchor file="a00382.html" title="hwloc Information">attributes_info_hwloc</docanchor>
+    <docanchor file="a00382.html" title="CPU Information">attributes_info_cpu</docanchor>
+    <docanchor file="a00382.html" title="OS Device Information">attributes_info_osdev</docanchor>
+    <docanchor file="a00382.html" title="Other Object-specific Information">attributes_info_otherobjs</docanchor>
+    <docanchor file="a00382.html" title="User-Given Information">attributes_info_user</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>topoattrs</name>
+    <title>Topology Attributes: Distances, Memory Attributes and CPU Kinds</title>
+    <filename>a00383.html</filename>
+    <docanchor file="a00383.html" title="Distances">topoattrs_distances</docanchor>
+    <docanchor file="a00383.html" title="Memory Attributes">topoattrs_memattrs</docanchor>
+    <docanchor file="a00383.html" title="CPU Kinds">topoattrs_cpukinds</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>heteromem</name>
+    <title>Heterogeneous Memory</title>
+    <filename>a00384.html</filename>
+    <docanchor file="a00384.html" title="Memory Tiers">heteromem_memtiers</docanchor>
+    <docanchor file="a00384.html" title="Using Heterogeneous Memory from the command-line">heteromem_use_cli</docanchor>
+    <docanchor file="a00384.html" title="Using Heterogeneous Memory from the C API">heteromem_use_api</docanchor>
+    <docanchor file="a00384.html" title="Iterating over the list of (heterogeneous) NUMA nodes">heteromem_use_api_iterate</docanchor>
+    <docanchor file="a00384.html" title="Iterating over local (heterogeneous) NUMA nodes">heteromem_use_api_vertical</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>xml</name>
+    <title>Importing and exporting topologies from/to XML files</title>
+    <filename>a00385.html</filename>
+    <docanchor file="a00385.html" title="libxml2 and minimalistic XML backends">xml_backends</docanchor>
+    <docanchor file="a00385.html" title="XML import error management">xml_errors</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>synthetic</name>
+    <title>Synthetic topologies</title>
+    <filename>a00386.html</filename>
+    <docanchor file="a00386.html" title="Synthetic description string">synthetic_string</docanchor>
+    <docanchor file="a00386.html" title="Loading a synthetic topology">synthetic_use</docanchor>
+    <docanchor file="a00386.html" title="Exporting a topology as a synthetic string">synthetic_export</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>interoperability</name>
+    <title>Interoperability With Other Software</title>
+    <filename>a00387.html</filename>
+  </compound>
+  <compound kind="page">
+    <name>threadsafety</name>
+    <title>Thread Safety</title>
+    <filename>a00388.html</filename>
+  </compound>
+  <compound kind="page">
+    <name>plugins</name>
+    <title>Components and plugins</title>
+    <filename>a00389.html</filename>
+    <docanchor file="a00389.html" title="Components enabled by default">plugins_default</docanchor>
+    <docanchor file="a00389.html" title="Selecting which components to use">plugins_select</docanchor>
+    <docanchor file="a00389.html" title="Loading components from plugins">plugins_load</docanchor>
+    <docanchor file="a00389.html" title="Existing components and plugins">plugins_list</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>embed</name>
+    <title>Embedding hwloc in Other Software</title>
+    <filename>a00390.html</filename>
+    <docanchor file="a00390.html" title="Using hwloc&apos;s M4 Embedding Capabilities">embedding_m4</docanchor>
+    <docanchor file="a00390.html" title="Example Embedding hwloc">embedding_example</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>faq</name>
+    <title>Frequently Asked Questions (FAQ)</title>
+    <filename>a00391.html</filename>
+    <docanchor file="a00391.html" title="Concepts">faq1</docanchor>
+    <docanchor file="a00391.html" title="I only need binding, or the number of cores, why should I use hwloc ?">faq_why</docanchor>
+    <docanchor file="a00391.html" title="What may I disable to make hwloc faster?">faq_disable_faster</docanchor>
+    <docanchor file="a00391.html" title="Should I use logical or physical/OS indexes? and how?">faq_indexes</docanchor>
+    <docanchor file="a00391.html" title="hwloc is only a structural model, it ignores performance models, memory bandwidth, etc.?">faq_structural</docanchor>
+    <docanchor file="a00391.html" title="hwloc only has a one-dimensional view of the architecture, it ignores distances?">faq_onedim</docanchor>
+    <docanchor file="a00391.html" title="What are these Group objects in my topology?">faq_groups</docanchor>
+    <docanchor file="a00391.html" title="What happens if my topology is asymmetric?">faq_asymmetric</docanchor>
+    <docanchor file="a00391.html" title="What happens to my topology if I disable symmetric multithreading, hyper-threading, etc. in the system?">faq_nosmt</docanchor>
+    <docanchor file="a00391.html" title="How may I ignore symmetric multithreading, hyper-threading, etc. in hwloc?">faq_smt</docanchor>
+    <docanchor file="a00391.html" title="Advanced">faq2</docanchor>
+    <docanchor file="a00391.html" title="I do not want hwloc to rediscover my enormous machine topology every time I rerun a process">faq_xml</docanchor>
+    <docanchor file="a00391.html" title="How many topologies may I use in my program?">faq_multitopo</docanchor>
+    <docanchor file="a00391.html" title="How to avoid memory waste when manipulating multiple similar topologies?">faq_diff</docanchor>
+    <docanchor file="a00391.html" title="How do I annotate the topology with private notes?">faq_annotate</docanchor>
+    <docanchor file="a00391.html" title="How do I create a custom heterogeneous and asymmetric topology?">faq_create_asymmetric</docanchor>
+    <docanchor file="a00391.html" title="Caveats">faq3</docanchor>
+    <docanchor file="a00391.html" title="Why is lstopo slow?">faq_slow_lstopo</docanchor>
+    <docanchor file="a00391.html" title="Does hwloc require privileged access?">faq_privileged</docanchor>
+    <docanchor file="a00391.html" title="What should I do when hwloc reports &quot;operating system&quot; warnings?">faq_os_error</docanchor>
+    <docanchor file="a00391.html" title="Why does Valgrind complain about hwloc memory leaks?">faq_valgrind</docanchor>
+    <docanchor file="a00391.html" title="Platform-specific">faq4</docanchor>
+    <docanchor file="a00391.html" title="How do I enable ROCm SMI and select which version to use?">faq_rocm_build</docanchor>
+    <docanchor file="a00391.html" title="How do I enable CUDA and select which CUDA version to use?">faq_cuda_build</docanchor>
+    <docanchor file="a00391.html" title="How do I find the local MCDRAM NUMA node on Intel Xeon Phi processor?">faq_knl_numa</docanchor>
+    <docanchor file="a00391.html" title="Why do I need hwloc-dump-hwdata for memory on Intel Xeon Phi processor?">faq_knl_dump</docanchor>
+    <docanchor file="a00391.html" title="How do I build hwloc for BlueGene/Q?">faq_bgq</docanchor>
+    <docanchor file="a00391.html" title="How do I build hwloc for Windows?">faq_windows</docanchor>
+    <docanchor file="a00391.html" title="How to get useful topology information on NetBSD?">faq_netbsd_bind</docanchor>
+    <docanchor file="a00391.html" title="Why does binding fail on AIX?">faq_aix_bind</docanchor>
+    <docanchor file="a00391.html" title="Compatibility between hwloc versions">faq5</docanchor>
+    <docanchor file="a00391.html" title="How do I handle API changes?">faq_version_api</docanchor>
+    <docanchor file="a00391.html" title="What is the difference between API and library version numbers?">faq_version</docanchor>
+    <docanchor file="a00391.html" title="How do I handle ABI breaks?">faq_version_abi</docanchor>
+    <docanchor file="a00391.html" title="Are XML topology files compatible between hwloc releases?">faq_version_xml</docanchor>
+    <docanchor file="a00391.html" title="Are synthetic strings compatible between hwloc releases?">faq_version_synthetic</docanchor>
+    <docanchor file="a00391.html" title="Is it possible to share a shared-memory topology between different hwloc releases?">faq_version_shmem</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>upgrade_to_api_2x</name>
+    <title>Upgrading to the hwloc 2.0 API</title>
+    <filename>a00392.html</filename>
+    <docanchor file="a00392.html" title="New Organization of NUMA nodes and Memory">upgrade_to_api_2x_memory</docanchor>
+    <docanchor file="a00392.html" title="Memory children">upgrade_to_api_2x_memory_children</docanchor>
+    <docanchor file="a00392.html" title="Examples">upgrade_to_api_2x_memory_examples</docanchor>
+    <docanchor file="a00392.html" title="NUMA level and depth">upgrade_to_api_2x_numa_level</docanchor>
+    <docanchor file="a00392.html" title="Finding Local NUMA nodes and looking at Children and Parents">upgrade_to_api_2x_memory_find</docanchor>
+    <docanchor file="a00392.html" title="4 Kinds of Objects and Children">upgrade_to_api_2x_children</docanchor>
+    <docanchor file="a00392.html" title="I/O and Misc children">upgrade_to_api_2x_io_misc_children</docanchor>
+    <docanchor file="a00392.html" title="Kinds of objects">upgrade_to_api_2x_kinds_subsec</docanchor>
+    <docanchor file="a00392.html" title="HWLOC_OBJ_CACHE replaced">upgrade_to_api_2x_cache</docanchor>
+    <docanchor file="a00392.html" title="allowed_cpuset and allowed_nodeset only in the main topology">upgrade_to_api_2x_allowed</docanchor>
+    <docanchor file="a00392.html" title="Object depths are now signed int">upgrade_to_api_2x_depth</docanchor>
+    <docanchor file="a00392.html" title="Memory attributes become NUMANode-specific">upgrade_to_api_2x_memory_attrs</docanchor>
+    <docanchor file="a00392.html" title="Topology configuration changes">upgrade_to_api_2x_config</docanchor>
+    <docanchor file="a00392.html" title="XML changes">upgrade_to_api_2x_xml</docanchor>
+    <docanchor file="a00392.html" title="Distances API totally rewritten">upgrade_to_api_2x_distances</docanchor>
+    <docanchor file="a00392.html" title="Return values of functions">upgrade_to_api_2x_return</docanchor>
+    <docanchor file="a00392.html" title="Misc API changes">upgrade_to_api_2x_misc</docanchor>
+    <docanchor file="a00392.html" title="API removals and deprecations">upgrade_to_api_2x_removals</docanchor>
+  </compound>
+  <compound kind="page">
+    <name>index</name>
+    <title>Hardware Locality</title>
+    <filename>index.html</filename>
+    <docanchor file="index.html" title="Table of Contents">toc</docanchor>
+    <docanchor file="index.html" title="hwloc Overview">overview</docanchor>
+    <docanchor file="index.html" title="Command-line Examples">cli_examples</docanchor>
+    <docanchor file="index.html" title="Programming Interface">interface</docanchor>
+    <docanchor file="index.html" title="Portability">portability</docanchor>
+    <docanchor file="index.html" title="API Example">interface_example</docanchor>
+    <docanchor file="index.html" title="Questions and Bugs">bugs</docanchor>
+    <docanchor file="index.html" title="History / Credits">history</docanchor>
+  </compound>
+</tagfile>
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_ALL.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_ALL.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_ALL.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_ALL.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_CUSTOM.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_CUSTOM.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_CUSTOM.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_CUSTOM.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_API_VERSION.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_API_VERSION.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_API_VERSION.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_API_VERSION.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_api_version.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_ABI.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_ABI.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_ABI.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_ABI.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_api_version.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_TYPE_DISC.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_TYPE_DISC.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_TYPE_DISC.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_TYPE_DISC.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_generic_components.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_TYPE_XML.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_TYPE_XML.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_TYPE_XML.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_COMPONENT_TYPE_XML.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_generic_components.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_NOMEMBIND.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_NOMEMBIND.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_NOMEMBIND.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_NOMEMBIND.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_PROCESS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_PROCESS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_PROCESS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_PROCESS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_STRICT.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_STRICT.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_STRICT.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_STRICT.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_THREAD.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_THREAD.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_THREAD.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_CPUBIND_THREAD.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_ANNOTATE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_ANNOTATE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_ANNOTATE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_ANNOTATE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_CPU.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_CPU.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_CPU.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_CPU.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_GLOBAL.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_GLOBAL.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_GLOBAL.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_GLOBAL.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_IO.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_IO.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_IO.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_IO.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_MEMORY.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_MEMORY.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_MEMORY.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_MEMORY.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_MISC.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_MISC.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_MISC.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_MISC.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_PCI.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_PCI.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_PCI.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_PCI.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_TWEAK.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_TWEAK.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_TWEAK.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_PHASE_TWEAK.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_ADD_FLAG_GROUP.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_ADD_FLAG_GROUP.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_ADD_FLAG_GROUP.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_ADD_FLAG_GROUP.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_add.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_add.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_FROM_OS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_FROM_OS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_FROM_OS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_FROM_OS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_FROM_USER.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_FROM_USER.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_FROM_USER.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_FROM_USER.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_MEANS_LATENCY.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_MEANS_LATENCY.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_MEANS_LATENCY.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_KIND_MEANS_LATENCY.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_LINKS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_LINKS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_LINKS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_LINKS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_REMOVE_NULL.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_REMOVE_NULL.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_REMOVE_NULL.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_REMOVE_NULL.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTRIB_FLAG_REVERSE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTRIB_FLAG_REVERSE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTRIB_FLAG_REVERSE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_DISTRIB_FLAG_REVERSE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_distribute.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_ALL.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_ALL.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_ALL.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_ALL.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCATION_TYPE_CPUSET.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCATION_TYPE_CPUSET.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCATION_TYPE_CPUSET.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCATION_TYPE_CPUSET.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCATION_TYPE_OBJECT.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCATION_TYPE_OBJECT.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCATION_TYPE_OBJECT.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_LOCATION_TYPE_OBJECT.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_HIGHER_FIRST.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_HIGHER_FIRST.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_HIGHER_FIRST.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_HIGHER_FIRST.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs_manage.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_LOWER_FIRST.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_LOWER_FIRST.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_LOWER_FIRST.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_LOWER_FIRST.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs_manage.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_NEED_INITIATOR.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_NEED_INITIATOR.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_NEED_INITIATOR.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_FLAG_NEED_INITIATOR.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs_manage.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_BANDWIDTH.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_BANDWIDTH.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_BANDWIDTH.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_BANDWIDTH.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_CAPACITY.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_CAPACITY.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_CAPACITY.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_CAPACITY.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_LATENCY.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_LATENCY.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_LATENCY.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_LATENCY.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_LOCALITY.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_LOCALITY.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_LOCALITY.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_LOCALITY.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_READ_BANDWIDTH.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_READ_BANDWIDTH.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_READ_BANDWIDTH.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_READ_BANDWIDTH.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_READ_LATENCY.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_READ_LATENCY.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_READ_LATENCY.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_READ_LATENCY.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_WRITE_BANDWIDTH.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_WRITE_BANDWIDTH.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_WRITE_BANDWIDTH.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_WRITE_BANDWIDTH.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_WRITE_LATENCY.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_WRITE_LATENCY.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_WRITE_LATENCY.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMATTR_ID_WRITE_LATENCY.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_BIND.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_BIND.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_BIND.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_BIND.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_BYNODESET.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_BYNODESET.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_BYNODESET.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_BYNODESET.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_DEFAULT.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_DEFAULT.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_DEFAULT.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_DEFAULT.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_FIRSTTOUCH.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_FIRSTTOUCH.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_FIRSTTOUCH.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_FIRSTTOUCH.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_INTERLEAVE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_INTERLEAVE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_INTERLEAVE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_INTERLEAVE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_MIGRATE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_MIGRATE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_MIGRATE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_MIGRATE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_MIXED.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_MIXED.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_MIXED.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_MIXED.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_NEXTTOUCH.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_NEXTTOUCH.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_NEXTTOUCH.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_NEXTTOUCH.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_NOCPUBIND.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_NOCPUBIND.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_NOCPUBIND.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_NOCPUBIND.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_PROCESS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_PROCESS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_PROCESS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_PROCESS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_STRICT.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_STRICT.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_STRICT.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_STRICT.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_THREAD.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_THREAD.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_THREAD.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_THREAD.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_WEIGHTED_INTERLEAVE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_WEIGHTED_INTERLEAVE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_WEIGHTED_INTERLEAVE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_MEMBIND_WEIGHTED_INTERLEAVE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE_HOST.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE_HOST.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE_HOST.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE_HOST.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE_PCI.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE_PCI.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE_PCI.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_BRIDGE_PCI.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_DATA.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_DATA.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_DATA.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_DATA.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_INSTRUCTION.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_INSTRUCTION.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_INSTRUCTION.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_INSTRUCTION.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_UNIFIED.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_UNIFIED.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_UNIFIED.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CACHE_UNIFIED.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CORE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CORE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CORE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_CORE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_DIE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_DIE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_DIE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_DIE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_GROUP.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_GROUP.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_GROUP.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_GROUP.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L1CACHE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L1CACHE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L1CACHE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L1CACHE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L1ICACHE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L1ICACHE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L1ICACHE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L1ICACHE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L2CACHE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L2CACHE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L2CACHE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L2CACHE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L2ICACHE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L2ICACHE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L2ICACHE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L2ICACHE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L3CACHE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L3CACHE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L3CACHE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L3CACHE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L3ICACHE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L3ICACHE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L3ICACHE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L3ICACHE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L4CACHE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L4CACHE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L4CACHE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L4CACHE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L5CACHE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L5CACHE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L5CACHE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_L5CACHE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MACHINE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MACHINE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MACHINE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MACHINE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MEMCACHE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MEMCACHE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MEMCACHE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MEMCACHE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MISC.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MISC.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MISC.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_MISC.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_NUMANODE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_NUMANODE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_NUMANODE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_NUMANODE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_BLOCK.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_BLOCK.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_BLOCK.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_BLOCK.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_COPROC.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_COPROC.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_COPROC.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_COPROC.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_DMA.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_DMA.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_DMA.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_DMA.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_GPU.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_GPU.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_GPU.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_GPU.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_NETWORK.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_NETWORK.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_NETWORK.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_NETWORK.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_OPENFABRICS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_OPENFABRICS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_OPENFABRICS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OSDEV_OPENFABRICS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OS_DEVICE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OS_DEVICE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OS_DEVICE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_OS_DEVICE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PACKAGE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PACKAGE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PACKAGE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PACKAGE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PCI_DEVICE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PCI_DEVICE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PCI_DEVICE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PCI_DEVICE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PU.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PU.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PU.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_OBJ_PU.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_ADAPT_IO.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_ADAPT_IO.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_ADAPT_IO.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_ADAPT_IO.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_ADAPT_MISC.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_ADAPT_MISC.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_ADAPT_MISC.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_ADAPT_MISC.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_BYNODESET.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_BYNODESET.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_BYNODESET.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_BYNODESET.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_REMOVE_CPULESS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_REMOVE_CPULESS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_REMOVE_CPULESS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_REMOVE_CPULESS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_REMOVE_MEMLESS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_REMOVE_MEMLESS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_REMOVE_MEMLESS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_RESTRICT_FLAG_REMOVE_MEMLESS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_SHOW_ALL_ERRORS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_SHOW_ALL_ERRORS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_SHOW_ALL_ERRORS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_SHOW_ALL_ERRORS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_core_funcs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_SHOW_CRITICAL_ERRORS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_SHOW_CRITICAL_ERRORS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_SHOW_CRITICAL_ERRORS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_SHOW_CRITICAL_ERRORS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_core_funcs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_setsource.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_APPLY_REVERSE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_APPLY_REVERSE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_APPLY_REVERSE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_APPLY_REVERSE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_DIFF_TOO_COMPLEX.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_syntheticexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_syntheticexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_syntheticexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_syntheticexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_xmlexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_CPUKINDS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_CPUKINDS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_CPUKINDS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_CPUKINDS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_DISTANCES.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_DISTANCES.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_DISTANCES.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_DISTANCES.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_MEMATTRS.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_MEMATTRS.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_MEMATTRS.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_NO_MEMATTRS.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_BRIDGE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_BRIDGE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_BRIDGE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_BRIDGE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MEMCACHE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MEMCACHE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MEMCACHE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MEMCACHE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MISC.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MISC.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MISC.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MISC.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MULTIPLE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MULTIPLE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MULTIPLE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_MULTIPLE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_NUMANODE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_NUMANODE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_NUMANODE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_NUMANODE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_OS_DEVICE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_OS_DEVICE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_OS_DEVICE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_OS_DEVICE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_PCI_DEVICE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_PCI_DEVICE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_PCI_DEVICE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_PCI_DEVICE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_UNKNOWN.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_UNKNOWN.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_UNKNOWN.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_DEPTH_UNKNOWN.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_ALL.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_ALL.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_ALL.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_ALL.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_IMPORTANT.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_IMPORTANT.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_IMPORTANT.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_IMPORTANT.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_NONE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_NONE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_NONE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_NONE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_STRUCTURE.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_STRUCTURE.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_STRUCTURE.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_FILTER_KEEP_STRUCTURE.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_UNORDERED.3 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_UNORDERED.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_UNORDERED.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/HWLOC_TYPE_UNORDERED.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc__insert_object_by_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc__insert_object_by_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc__insert_object_by_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc__insert_object_by_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_core_funcs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_alloc.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_alloc.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_alloc.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_alloc.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_membind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_membind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_membind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_membind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_membind_policy.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_membind_policy.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_membind_policy.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_membind_policy.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_setup_object.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_setup_object.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_setup_object.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_alloc_setup_object.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_core_funcs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_allow_flags_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_allow_flags_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_allow_flags_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_allow_flags_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,78 @@
+.TH "hwloc_backend" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_backend
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <plugins\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "unsigned \fBphases\fP"
+.br
+.ti -1c
+.RI "unsigned long \fBflags\fP"
+.br
+.ti -1c
+.RI "int \fBis_thissystem\fP"
+.br
+.ti -1c
+.RI "void * \fBprivate_data\fP"
+.br
+.ti -1c
+.RI "void(* \fBdisable\fP )(struct \fBhwloc_backend\fP *backend)"
+.br
+.ti -1c
+.RI "int(* \fBdiscover\fP )(struct \fBhwloc_backend\fP *backend, struct \fBhwloc_disc_status\fP *status)"
+.br
+.ti -1c
+.RI "int(* \fBget_pci_busid_cpuset\fP )(struct \fBhwloc_backend\fP *backend, struct hwloc_pcidev_attr_s *busid, \fBhwloc_bitmap_t\fP cpuset)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Discovery backend structure\&. 
+
+A backend is the instantiation of a discovery component\&. When a component gets enabled for a topology, its instantiate() callback creates a backend\&.
+.PP
+\fBhwloc_backend_alloc()\fP initializes all fields to default values that the component may change (except 'component' and 'next') before enabling the backend with \fBhwloc_backend_enable()\fP\&.
+.PP
+Most backends assume that the topology is_thissystem flag is set because they talk to the underlying operating system\&. However they may still be used in topologies without the is_thissystem flag for debugging reasons\&. In practice, they are usually auto-disabled in such cases (excluded by xml or synthetic backends, or by environment variables when changing the Linux fsroot or the x86 cpuid path)\&. 
+.SH "Field Documentation"
+.PP 
+.SS "void(* hwloc_backend::disable) (struct \fBhwloc_backend\fP *backend)"
+
+.PP
+Callback for freeing the private_data\&. May be NULL\&. 
+.SS "int(* hwloc_backend::discover) (struct \fBhwloc_backend\fP *backend, struct \fBhwloc_disc_status\fP *status)"
+
+.PP
+Main discovery callback\&. returns -1 on error, either because it couldn't add its objects ot the existing topology, or because of an actual discovery/gathering failure\&. May be NULL\&. 
+.SS "unsigned long hwloc_backend::flags"
+
+.PP
+Backend flags, currently always 0\&. 
+.SS "int(* hwloc_backend::get_pci_busid_cpuset) (struct \fBhwloc_backend\fP *backend, struct hwloc_pcidev_attr_s *busid, \fBhwloc_bitmap_t\fP cpuset)"
+
+.PP
+Callback to retrieve the locality of a PCI object\&. Called by the PCI core when attaching PCI hierarchy to CPU objects\&. May be NULL\&. 
+.SS "int hwloc_backend::is_thissystem"
+
+.PP
+Backend-specific 'is_thissystem' property\&. Set to 0 if the backend disables the thissystem flag for this topology (e\&.g\&. loading from xml or synthetic string, or using a different fsroot on Linux, or a x86 CPUID dump)\&. Set to -1 if the backend doesn't care (default)\&. 
+.SS "unsigned hwloc_backend::phases"
+
+.PP
+Discovery phases performed by this component, possibly without some of them if excluded by other components\&. OR'ed set of \fBhwloc_disc_phase_t\fP\&. 
+.SS "void* hwloc_backend::private_data"
+
+.PP
+Backend private data, or NULL if none\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_alloc.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_alloc.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_alloc.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_alloc.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_commit.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_commit.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_commit.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_commit.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcifind.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_create.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_create.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_create.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_create.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcifind.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_handle_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_handle_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_handle_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_handle_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcifind.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_values.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_values.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_values.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_distances_add_values.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcifind.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_enable.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_enable.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_backend_enable.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_backend_enable.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_allbut.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_allbut.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_allbut.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_allbut.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_alloc.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_alloc.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_alloc.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_alloc.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_alloc_full.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_alloc_full.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_alloc_full.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_alloc_full.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_and.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_and.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_and.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_and.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_andnot.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_andnot.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_andnot.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_andnot.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_asprintf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_asprintf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_asprintf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_asprintf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_clr.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_clr.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_clr.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_clr.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_clr_range.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_clr_range.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_clr_range.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_clr_range.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_compare.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_compare.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_compare.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_compare.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_compare_first.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_compare_first.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_compare_first.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_compare_first.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_copy.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_copy.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_copy.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_copy.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_dup.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_dup.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_dup.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_dup.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_fill.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_fill.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_fill.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_fill.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_first.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_first.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_first.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_first.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_first_unset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_first_unset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_first_unset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_first_unset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_foreach_begin.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_foreach_begin.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_foreach_begin.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_foreach_begin.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_foreach_end.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_foreach_end.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_foreach_end.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_foreach_end.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_free.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_free.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_free.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_free.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ith_ulong.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ith_ulong.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ith_ulong.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ith_ulong.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ulong.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ulong.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ulong.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ulong.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ulongs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ulongs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ulongs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_from_ulongs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_intersects.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_intersects.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_intersects.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_intersects.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isequal.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isequal.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isequal.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isequal.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isfull.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isfull.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isfull.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isfull.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isincluded.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isincluded.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isincluded.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isincluded.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_isset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_iszero.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_iszero.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_iszero.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_iszero.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_last.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_last.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_last.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_last.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_last_unset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_last_unset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_last_unset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_last_unset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_asprintf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_asprintf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_asprintf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_asprintf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_snprintf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_snprintf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_snprintf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_snprintf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_sscanf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_sscanf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_sscanf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_list_sscanf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_next.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_next.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_next.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_next.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_next_unset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_next_unset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_next_unset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_next_unset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_not.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_not.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_not.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_not.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_nr_ulongs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_nr_ulongs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_nr_ulongs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_nr_ulongs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_only.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_only.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_only.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_only.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_or.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_or.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_or.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_or.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set_ith_ulong.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set_ith_ulong.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set_ith_ulong.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set_ith_ulong.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set_range.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set_range.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set_range.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_set_range.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_singlify.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_singlify.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_singlify.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_singlify.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_singlify_per_core.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_singlify_per_core.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_singlify_per_core.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_singlify_per_core.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_misc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_snprintf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_snprintf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_snprintf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_snprintf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_sscanf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_sscanf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_sscanf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_sscanf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_asprintf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_asprintf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_asprintf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_asprintf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_snprintf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_snprintf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_snprintf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_snprintf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_sscanf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_sscanf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_sscanf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_taskset_sscanf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ith_ulong.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ith_ulong.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ith_ulong.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ith_ulong.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ulong.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ulong.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ulong.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ulong.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ulongs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ulongs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ulongs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_to_ulongs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_weight.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_weight.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_weight.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_weight.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_xor.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_xor.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_xor.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_xor.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_zero.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_zero.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_zero.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bitmap_zero.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bridge_covers_pcibus.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bridge_covers_pcibus.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_bridge_covers_pcibus.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_bridge_covers_pcibus.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_advanced_io.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cl_device_pci_bus_info_khr.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cl_device_pci_bus_info_khr.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cl_device_pci_bus_info_khr.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cl_device_pci_bus_info_khr.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,40 @@
+.TH "hwloc_cl_device_pci_bus_info_khr" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_cl_device_pci_bus_info_khr
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <opencl\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "cl_uint \fBpci_domain\fP"
+.br
+.ti -1c
+.RI "cl_uint \fBpci_bus\fP"
+.br
+.ti -1c
+.RI "cl_uint \fBpci_device\fP"
+.br
+.ti -1c
+.RI "cl_uint \fBpci_function\fP"
+.br
+.in -1c
+.SH "Field Documentation"
+.PP 
+.SS "cl_uint hwloc_cl_device_pci_bus_info_khr::pci_bus"
+
+.SS "cl_uint hwloc_cl_device_pci_bus_info_khr::pci_device"
+
+.SS "cl_uint hwloc_cl_device_pci_bus_info_khr::pci_domain"
+
+.SS "cl_uint hwloc_cl_device_pci_bus_info_khr::pci_function"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cl_device_topology_amd.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cl_device_topology_amd.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cl_device_topology_amd.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cl_device_topology_amd.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,69 @@
+.TH "hwloc_cl_device_topology_amd" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_cl_device_topology_amd
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <opencl\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "struct {"
+.br
+.ti -1c
+.RI "   cl_uint \fBtype\fP"
+.br
+.ti -1c
+.RI "   cl_uint \fBdata\fP [5]"
+.br
+.ti -1c
+.RI "} \fBraw\fP"
+.br
+.ti -1c
+.RI "struct {"
+.br
+.ti -1c
+.RI "   cl_uint \fBtype\fP"
+.br
+.ti -1c
+.RI "   cl_char \fBunused\fP [17]"
+.br
+.ti -1c
+.RI "   cl_char \fBbus\fP"
+.br
+.ti -1c
+.RI "   cl_char \fBdevice\fP"
+.br
+.ti -1c
+.RI "   cl_char \fBfunction\fP"
+.br
+.ti -1c
+.RI "} \fBpcie\fP"
+.br
+.in -1c
+.SH "Field Documentation"
+.PP 
+.SS "cl_char hwloc_cl_device_topology_amd::bus"
+
+.SS "cl_uint hwloc_cl_device_topology_amd::data[5]"
+
+.SS "cl_char hwloc_cl_device_topology_amd::device"
+
+.SS "cl_char hwloc_cl_device_topology_amd::function"
+
+.SS "struct  { \&.\&.\&. }  hwloc_cl_device_topology_amd::pcie"
+
+.SS "struct  { \&.\&.\&. }  hwloc_cl_device_topology_amd::raw"
+
+.SS "cl_uint hwloc_cl_device_topology_amd::type"
+
+.SS "cl_char hwloc_cl_device_topology_amd::unused[17]"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_compare_types.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_compare_types.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_compare_types.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_compare_types.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_component.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_component.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_component.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_component.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,92 @@
+.TH "hwloc_component" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_component
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <plugins\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "unsigned \fBabi\fP"
+.br
+.ti -1c
+.RI "int(* \fBinit\fP )(unsigned long \fBflags\fP)"
+.br
+.ti -1c
+.RI "void(* \fBfinalize\fP )(unsigned long \fBflags\fP)"
+.br
+.ti -1c
+.RI "\fBhwloc_component_type_t\fP \fBtype\fP"
+.br
+.ti -1c
+.RI "unsigned long \fBflags\fP"
+.br
+.ti -1c
+.RI "void * \fBdata\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Generic component structure\&. 
+
+Generic components structure, either statically listed by configure in static-components\&.h or dynamically loaded as a plugin\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned hwloc_component::abi"
+
+.PP
+Component ABI version, set to \fBHWLOC_COMPONENT_ABI\fP\&. 
+.SS "void* hwloc_component::data"
+
+.PP
+Component data, pointing to a struct \fBhwloc_disc_component\fP or struct hwloc_xml_component\&. 
+.SS "void(* hwloc_component::finalize) (unsigned long \fBflags\fP)"
+
+.PP
+Process-wide component termination callback\&. This optional callback is called after unregistering the component from the hwloc core (before unloading the plugin)\&.
+.PP
+\fCflags\fP is always 0 for now\&.
+.PP
+\fBNote\fP
+.RS 4
+If the component uses ltdl for loading its own plugins, it should load/unload them only in \fBinit()\fP and \fBfinalize()\fP, to avoid race conditions with hwloc's use of ltdl\&. 
+.RE
+.PP
+
+.SS "unsigned long hwloc_component::flags"
+
+.PP
+Component flags, unused for now\&. 
+.SS "int(* hwloc_component::init) (unsigned long \fBflags\fP)"
+
+.PP
+Process-wide component initialization callback\&. This optional callback is called when the component is registered to the hwloc core (after loading the plugin)\&.
+.PP
+When the component is built as a plugin, this callback should call hwloc_check_plugin_namespace() and return an negative error code on error\&.
+.PP
+\fCflags\fP is always 0 for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, or a negative code on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+If the component uses ltdl for loading its own plugins, it should load/unload them only in \fBinit()\fP and \fBfinalize()\fP, to avoid race conditions with hwloc's use of ltdl\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_component_type_t\fP hwloc_component::type"
+
+.PP
+Component type\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_component_type_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_component_type_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_component_type_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_component_type_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_generic_components.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_component_type_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_component_type_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_component_type_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_component_type_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_generic_components.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_const_bitmap_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_const_bitmap_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_const_bitmap_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_const_bitmap_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_bitmap.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_const_cpuset_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_const_cpuset_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_const_cpuset_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_const_cpuset_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_sets.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_const_nodeset_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_const_nodeset_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_const_nodeset_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_const_nodeset_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_sets.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpubind_flags_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpubind_flags_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpubind_flags_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpubind_flags_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_by_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_by_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_by_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_by_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpukinds.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_info.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_info.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_info.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_info.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpukinds.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_nr.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_nr.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_nr.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_get_nr.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpukinds.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_register.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_register.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_register.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpukinds_register.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpukinds.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_glibc_sched_affinity.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_glibc_sched_affinity.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_glibc_sched_affinity.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_glibc_sched_affinity.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_glibc_sched.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_linux_libnuma_bitmask.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_linux_libnuma_bitmask.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_linux_libnuma_bitmask.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_linux_libnuma_bitmask.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux_libnuma_bitmask.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_linux_libnuma_ulongs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_linux_libnuma_ulongs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_linux_libnuma_ulongs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_linux_libnuma_ulongs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux_libnuma_ulongs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_nodeset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_nodeset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_nodeset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_from_nodeset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_nodeset_convert.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_sets.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_glibc_sched_affinity.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_glibc_sched_affinity.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_glibc_sched_affinity.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_glibc_sched_affinity.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_glibc_sched.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_linux_libnuma_bitmask.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_linux_libnuma_bitmask.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_linux_libnuma_bitmask.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_linux_libnuma_bitmask.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux_libnuma_bitmask.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_linux_libnuma_ulongs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_linux_libnuma_ulongs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_linux_libnuma_ulongs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_linux_libnuma_ulongs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux_libnuma_ulongs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_nodeset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_nodeset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_nodeset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cpuset_to_nodeset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_nodeset_convert.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cuda.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_osdev.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_osdev.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_osdev.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_osdev.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cuda.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_osdev_by_index.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_osdev_by_index.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_osdev_by_index.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_osdev_by_index.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cuda.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_pci_ids.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_pci_ids.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_pci_ids.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_pci_ids.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cuda.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_pcidev.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_pcidev.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_pcidev.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cuda_get_device_pcidev.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cuda.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cudart.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_osdev_by_index.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_osdev_by_index.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_osdev_by_index.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_osdev_by_index.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cudart.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_pci_ids.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_pci_ids.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_pci_ids.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_pci_ids.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cudart.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_pcidev.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_pcidev.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_pcidev.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_cudart_get_device_pcidev.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cudart.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_disc_component.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_disc_component.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_disc_component.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_disc_component.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,69 @@
+.TH "hwloc_disc_component" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_disc_component
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <plugins\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "const char * \fBname\fP"
+.br
+.ti -1c
+.RI "unsigned \fBphases\fP"
+.br
+.ti -1c
+.RI "unsigned \fBexcluded_phases\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_backend\fP *(* \fBinstantiate\fP )(struct hwloc_topology *topology, struct \fBhwloc_disc_component\fP *component, unsigned \fBexcluded_phases\fP, const void *data1, const void *data2, const void *data3)"
+.br
+.ti -1c
+.RI "unsigned \fBpriority\fP"
+.br
+.ti -1c
+.RI "unsigned \fBenabled_by_default\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Discovery component structure\&. 
+
+This is the major kind of components, taking care of the discovery\&. They are registered by generic components, either statically-built or as plugins\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned hwloc_disc_component::enabled_by_default"
+
+.PP
+Enabled by default\&. If unset, if will be disabled unless explicitly requested\&. 
+.SS "unsigned hwloc_disc_component::excluded_phases"
+
+.PP
+Component phases to exclude, as an OR'ed set of \fBhwloc_disc_phase_t\fP\&. For a GLOBAL component, this usually includes all other phases (\fC~UL\fP)\&.
+.PP
+Other components only exclude types that may bring conflicting topology information\&. MISC components should likely not be excluded since they usually bring non-primary additional information\&. 
+.SS "struct \fBhwloc_backend\fP *(* hwloc_disc_component::instantiate) (struct hwloc_topology *topology, struct \fBhwloc_disc_component\fP *component, unsigned \fBexcluded_phases\fP, const void *data1, const void *data2, const void *data3)"
+
+.PP
+Instantiate callback to create a backend from the component\&. Parameters data1, data2, data3 are NULL except for components that have special enabling routines such as \fBhwloc_topology_set_xml()\fP\&. 
+.SS "const char* hwloc_disc_component::name"
+
+.PP
+Name\&. If this component is built as a plugin, this name does not have to match the plugin filename\&. 
+.SS "unsigned hwloc_disc_component::phases"
+
+.PP
+Discovery phases performed by this component\&. OR'ed set of \fBhwloc_disc_phase_t\fP\&. 
+.SS "unsigned hwloc_disc_component::priority"
+
+.PP
+Component priority\&. Used to sort topology->components, higher priority first\&. Also used to decide between two components with the same name\&. Usual values are 50 for native OS (or platform) components, 45 for x86, 40 for no-OS fallback, 30 for global components (xml, synthetic), 20 for pci, 10 for other misc components (opencl etc\&.)\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_disc_phase_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_disc_phase_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_disc_phase_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_disc_phase_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_disc_phase_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_disc_phase_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_disc_phase_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_disc_phase_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_disc_status.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_disc_status.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_disc_status.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_disc_status.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,46 @@
+.TH "hwloc_disc_status" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_disc_status
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <plugins\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_disc_phase_t\fP \fBphase\fP"
+.br
+.ti -1c
+.RI "unsigned \fBexcluded_phases\fP"
+.br
+.ti -1c
+.RI "unsigned long \fBflags\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Discovery status structure\&. 
+
+Used by the core and backends to inform about what has been/is being done during the discovery process\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned hwloc_disc_status::excluded_phases"
+
+.PP
+Dynamically excluded phases\&. If a component decides during discovery that some phases are no longer needed\&. 
+.SS "unsigned long hwloc_disc_status::flags"
+
+.PP
+OR'ed set of \fBhwloc_disc_status_flag_e\fP\&. 
+.SS "\fBhwloc_disc_phase_t\fP hwloc_disc_status::phase"
+
+.PP
+The current discovery phase that is performed\&. Must match one of the phases in the component phases field\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_disc_status_flag_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_disc_status_flag_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_disc_status_flag_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_disc_status_flag_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_disc_backends.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_commit.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_commit.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_commit.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_commit.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_add.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_create.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_create.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_create.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_create.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_add.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_flag_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_flag_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_flag_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_flag_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_add.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_handle_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_handle_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_handle_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_handle_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_add.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_values.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_values.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_values.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_add_values.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_add.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_name.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_name.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_name.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_name.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_name.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_name.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_name.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_get_name.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_kind_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_kind_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_kind_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_kind_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_obj_index.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_obj_index.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_obj_index.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_obj_index.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_consult.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_obj_pair_values.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_obj_pair_values.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_obj_pair_values.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_obj_pair_values.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_consult.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_release.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_release.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_release.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_release.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_release_remove.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_release_remove.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_release_remove.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_release_remove.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_remove.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_remove.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove_by_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove_by_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove_by_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove_by_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_remove.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_remove_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_remove.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,57 @@
+.TH "hwloc_distances_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_distances_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <distances\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "unsigned \fBnbobjs\fP"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_t\fP * \fBobjs\fP"
+.br
+.ti -1c
+.RI "unsigned long \fBkind\fP"
+.br
+.ti -1c
+.RI "hwloc_uint64_t * \fBvalues\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Matrix of distances between a set of objects\&. 
+
+The most common matrix contains latencies between NUMA nodes (as reported in the System Locality Distance Information Table (SLIT) in the ACPI specification), which may or may not be physically accurate\&. It corresponds to the latency for accessing the memory of one node from a core in another node\&. The corresponding kind is \fBHWLOC_DISTANCES_KIND_MEANS_LATENCY\fP | \fBHWLOC_DISTANCES_KIND_FROM_USER\fP\&. The name of this distances structure is 'NUMALatency'\&.
+.PP
+The matrix may also contain bandwidths between random sets of objects, possibly provided by the user, as specified in the \fCkind\fP attribute\&. Others common distance structures include and 'XGMIBandwidth', 'XGMIHops', 'XeLinkBandwidth' and 'NVLinkBandwidth'\&.
+.PP
+Pointers \fCobjs\fP and \fCvalues\fP should not be replaced, reallocated, freed, etc\&. However callers are allowed to modify \fCkind\fP as well as the contents of \fCobjs\fP and \fCvalues\fP arrays\&. For instance, if there is a single NUMA node per Package, \fBhwloc_get_obj_with_same_locality()\fP may be used to convert between them and replace NUMA nodes in the \fCobjs\fP array with the corresponding Packages\&. See also \fBhwloc_distances_transform()\fP for applying some transformations to the structure\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned long hwloc_distances_s::kind"
+
+.PP
+OR'ed set of \fBhwloc_distances_kind_e\fP\&. 
+.SS "unsigned hwloc_distances_s::nbobjs"
+
+.PP
+Number of objects described by the distance matrix\&. 
+.SS "\fBhwloc_obj_t\fP* hwloc_distances_s::objs"
+
+.PP
+Array of objects described by the distance matrix\&. These objects are not in any particular order, see \fBhwloc_distances_obj_index()\fP and \fBhwloc_distances_obj_pair_values()\fP for easy ways to find objects in this array and their corresponding values\&. 
+.SS "hwloc_uint64_t* hwloc_distances_s::values"
+
+.PP
+Matrix of distances between objects, stored as a one-dimension array\&. Distance from i-th to j-th object is stored in slot i*nbobjs+j\&. The meaning of the value depends on the \fCkind\fP attribute\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_transform.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_transform.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_transform.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_transform.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_transform_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_transform_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distances_transform_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distances_transform_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_distances_get.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distrib.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distrib.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distrib.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distrib.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_distribute.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distrib_flags_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distrib_flags_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_distrib_flags_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_distrib_flags_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_distribute.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_export_obj_userdata.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_export_obj_userdata.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_export_obj_userdata.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_export_obj_userdata.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_xmlexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_export_obj_userdata_base64.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_export_obj_userdata_base64.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_export_obj_userdata_base64.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_export_obj_userdata_base64.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_xmlexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_keep_object.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_keep_object.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_keep_object.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_keep_object.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_filtering.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_keep_object_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_keep_object_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_keep_object_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_keep_object_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_filtering.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_osdev_subtype_important.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_osdev_subtype_important.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_osdev_subtype_important.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_osdev_subtype_important.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_filtering.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_pcidev_subtype_important.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_pcidev_subtype_important.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_pcidev_subtype_important.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_filter_check_pcidev_subtype_important.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_filtering.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_free.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_free.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_free.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_free.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_free_xmlbuffer.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_free_xmlbuffer.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_free_xmlbuffer.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_free_xmlbuffer.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_xmlexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_ancestor_obj_by_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_ancestor_obj_by_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_ancestor_obj_by_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_ancestor_obj_by_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_ancestors.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_ancestor_obj_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_ancestor_obj_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_ancestor_obj_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_ancestor_obj_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_ancestors.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_api_version.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_api_version.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_api_version.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_api_version.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_api_version.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_area_membind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_area_membind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_area_membind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_area_membind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_area_memlocation.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_area_memlocation.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_area_memlocation.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_area_memlocation.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_cache_covering_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_cache_covering_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_cache_covering_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_cache_covering_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_cache.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_cache_type_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_cache_type_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_cache_type_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_cache_type_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_cache.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_child_covering_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_child_covering_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_child_covering_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_child_covering_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_covering.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_closest_objs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_closest_objs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_closest_objs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_closest_objs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_misc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_common_ancestor_obj.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_common_ancestor_obj.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_common_ancestor_obj.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_common_ancestor_obj.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_ancestors.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_cpubind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_cpubind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_cpubind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_cpubind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_depth_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_depth_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_depth_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_depth_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_first_largest_obj_inside_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_first_largest_obj_inside_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_first_largest_obj_inside_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_first_largest_obj_inside_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_inside.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_largest_objs_inside_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_largest_objs_inside_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_largest_objs_inside_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_largest_objs_inside_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_inside.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_last_cpu_location.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_last_cpu_location.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_last_cpu_location.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_last_cpu_location.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_local_numanode_objs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_local_numanode_objs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_local_numanode_objs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_local_numanode_objs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_membind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_membind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_membind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_membind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_memory_parents_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_memory_parents_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_memory_parents_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_memory_parents_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_by_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_by_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_by_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_by_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_inside_cpuset_by_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_inside_cpuset_by_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_inside_cpuset_by_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_inside_cpuset_by_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_inside.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_inside_cpuset_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_inside_cpuset_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_inside_cpuset_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_nbobjs_inside_cpuset_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_inside.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_bridge.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_bridge.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_bridge.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_bridge.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_advanced_io.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_child.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_child.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_child.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_child.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_ancestors.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_by_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_by_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_by_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_by_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_covering_cpuset_by_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_covering_cpuset_by_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_covering_cpuset_by_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_covering_cpuset_by_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_covering.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_covering_cpuset_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_covering_cpuset_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_covering_cpuset_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_covering_cpuset_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_covering.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_inside_cpuset_by_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_inside_cpuset_by_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_inside_cpuset_by_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_inside_cpuset_by_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_inside.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_inside_cpuset_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_inside_cpuset_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_inside_cpuset_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_obj_inside_cpuset_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_inside.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_osdev.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_osdev.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_osdev.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_osdev.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_advanced_io.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_pcidev.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_pcidev.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_pcidev.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_next_pcidev.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_advanced_io.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_non_io_ancestor_obj.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_non_io_ancestor_obj.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_non_io_ancestor_obj.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_non_io_ancestor_obj.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_advanced_io.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_numanode_obj_by_os_index.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_numanode_obj_by_os_index.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_numanode_obj_by_os_index.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_numanode_obj_by_os_index.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_misc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_below_array_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_below_array_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_below_array_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_below_array_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_misc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_below_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_below_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_below_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_below_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_misc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_by_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_by_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_by_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_by_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_covering_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_covering_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_covering_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_covering_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_covering.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_index_inside_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_index_inside_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_index_inside_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_index_inside_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_inside.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_inside_cpuset_by_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_inside_cpuset_by_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_inside_cpuset_by_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_inside_cpuset_by_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_inside.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_inside_cpuset_by_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_inside_cpuset_by_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_inside_cpuset_by_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_inside_cpuset_by_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_inside.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_with_same_locality.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_with_same_locality.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_with_same_locality.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_obj_with_same_locality.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_misc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_pcidev_by_busid.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_pcidev_by_busid.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_pcidev_by_busid.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_pcidev_by_busid.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_advanced_io.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_pcidev_by_busidstring.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_pcidev_by_busidstring.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_pcidev_by_busidstring.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_pcidev_by_busidstring.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_advanced_io.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_cpubind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_cpubind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_cpubind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_cpubind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_last_cpu_location.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_last_cpu_location.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_last_cpu_location.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_last_cpu_location.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_membind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_membind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_membind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_proc_membind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_pu_obj_by_os_index.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_pu_obj_by_os_index.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_pu_obj_by_os_index.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_pu_obj_by_os_index.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_misc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_root_obj.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_root_obj.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_root_obj.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_root_obj.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_shared_cache_covering_obj.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_shared_cache_covering_obj.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_shared_cache_covering_obj.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_shared_cache_covering_obj.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_find_cache.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_thread_cpubind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_thread_cpubind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_thread_cpubind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_thread_cpubind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_depth_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_depth_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_depth_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_depth_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_or_above_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_or_above_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_or_above_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_or_above_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_or_below_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_or_below_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_or_below_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_get_type_or_below_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_by_osdev.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_by_osdev.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_by_osdev.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_by_osdev.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_gl.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_osdev_by_name.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_osdev_by_name.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_osdev_by_name.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_osdev_by_name.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_gl.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_osdev_by_port_device.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_osdev_by_port_device.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_osdev_by_port_device.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_gl_get_display_osdev_by_port_device.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_gl.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_hide_errors.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_hide_errors.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_hide_errors.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_hide_errors.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_core_funcs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_openfabrics.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_osdev.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_osdev.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_osdev.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_osdev.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_openfabrics.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_osdev_by_name.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_osdev_by_name.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_osdev_by_name.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_ibv_get_device_osdev_by_name.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_openfabrics.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_info_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_info_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_info_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_info_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,46 @@
+.TH "hwloc_info_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_info_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "char * \fBname\fP"
+.br
+.ti -1c
+.RI "char * \fBvalue\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Object info attribute (name and value strings) 
+
+
+.PP
+\fBSee also\fP
+.RS 4
+\fBConsulting and Adding Info Attributes\fP 
+.RE
+.PP
+
+.SH "Field Documentation"
+.PP 
+.SS "char* hwloc_info_s::name"
+
+.PP
+Info name\&. 
+.SS "char* hwloc_info_s::value"
+
+.PP
+Info value\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_insert_object_by_parent.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_insert_object_by_parent.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_insert_object_by_parent.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_insert_object_by_parent.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_core_funcs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_levelzero_get_device_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_levelzero_get_device_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_levelzero_get_device_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_levelzero_get_device_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levelzero.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_levelzero_get_device_osdev.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_levelzero_get_device_osdev.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_levelzero_get_device_osdev.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_levelzero_get_device_osdev.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levelzero.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_linux_get_tid_cpubind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_linux_get_tid_cpubind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_linux_get_tid_cpubind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_linux_get_tid_cpubind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_linux_get_tid_last_cpu_location.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_linux_get_tid_last_cpu_location.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_linux_get_tid_last_cpu_location.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_linux_get_tid_last_cpu_location.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_linux_read_path_as_cpumask.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_linux_read_path_as_cpumask.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_linux_read_path_as_cpumask.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_linux_read_path_as_cpumask.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_linux_set_tid_cpubind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_linux_set_tid_cpubind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_linux_set_tid_cpubind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_linux_set_tid_cpubind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_local_numanode_flag_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_local_numanode_flag_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_local_numanode_flag_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_local_numanode_flag_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_location.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_location.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_location.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_location.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,42 @@
+.TH "hwloc_location" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_location
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <memattrs\&.h>\fP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "union \fBhwloc_location_u\fP"
+.br
+.in -1c
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_location_type_e\fP \fBtype\fP"
+.br
+.ti -1c
+.RI "union \fBhwloc_location::hwloc_location_u\fP \fBlocation\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Where to measure attributes from\&. 
+.SH "Field Documentation"
+.PP 
+.SS "union \fBhwloc_location::hwloc_location_u\fP hwloc_location::location"
+
+.SS "enum \fBhwloc_location_type_e\fP hwloc_location::type"
+
+.PP
+Type of location\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_location_hwloc_location_u.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_location_hwloc_location_u.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_location_hwloc_location_u.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_location_hwloc_location_u.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,37 @@
+.TH "hwloc_location::hwloc_location_u" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_location::hwloc_location_u
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <memattrs\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_cpuset_t\fP \fBcpuset\fP"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_t\fP \fBobject\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Actual location\&. 
+.SH "Field Documentation"
+.PP 
+.SS "\fBhwloc_cpuset_t\fP hwloc_location::hwloc_location_u::cpuset"
+
+.PP
+Location as a cpuset, when the location type is \fBHWLOC_LOCATION_TYPE_CPUSET\fP\&. 
+.SS "\fBhwloc_obj_t\fP hwloc_location::hwloc_location_u::object"
+
+.PP
+Location as an object, when the location type is \fBHWLOC_LOCATION_TYPE_OBJECT\fP\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_location_type_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_location_type_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_location_type_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_location_type_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_flag_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_flag_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_flag_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_flag_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs_manage.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_best_initiator.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_best_initiator.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_best_initiator.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_best_initiator.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_best_target.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_best_target.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_best_target.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_best_target.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_by_name.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_by_name.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_by_name.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_by_name.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_flags.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_flags.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_flags.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_flags.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs_manage.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_initiators.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_initiators.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_initiators.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_initiators.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs_manage.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_name.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_name.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_name.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_name.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs_manage.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_targets.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_targets.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_targets.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_targets.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs_manage.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_value.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_value.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_value.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_get_value.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_id_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_id_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_id_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_id_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_id_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_id_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_id_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_id_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_register.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_register.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_register.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_register.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs_manage.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_set_value.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_set_value.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_set_value.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_memattr_set_value.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_memattrs_manage.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_membind_flags_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_membind_flags_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_membind_flags_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_membind_flags_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_membind_policy_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_membind_policy_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_membind_policy_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_membind_policy_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_from_linux_libnuma_bitmask.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_from_linux_libnuma_bitmask.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_from_linux_libnuma_bitmask.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_from_linux_libnuma_bitmask.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux_libnuma_bitmask.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_from_linux_libnuma_ulongs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_from_linux_libnuma_ulongs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_from_linux_libnuma_ulongs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_from_linux_libnuma_ulongs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux_libnuma_ulongs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_sets.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_to_linux_libnuma_bitmask.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_to_linux_libnuma_bitmask.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_to_linux_libnuma_bitmask.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_to_linux_libnuma_bitmask.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux_libnuma_bitmask.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_to_linux_libnuma_ulongs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_to_linux_libnuma_ulongs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_to_linux_libnuma_ulongs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nodeset_to_linux_libnuma_ulongs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_linux_libnuma_ulongs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_nvml.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_osdev.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_osdev.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_osdev.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_osdev.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_nvml.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_osdev_by_index.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_osdev_by_index.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_osdev_by_index.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_nvml_get_device_osdev_by_index.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_nvml.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,334 @@
+.TH "hwloc_obj" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_obj
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_obj_type_t\fP \fBtype\fP"
+.br
+.ti -1c
+.RI "char * \fBsubtype\fP"
+.br
+.ti -1c
+.RI "unsigned \fBos_index\fP"
+.br
+.ti -1c
+.RI "char * \fBname\fP"
+.br
+.ti -1c
+.RI "hwloc_uint64_t \fBtotal_memory\fP"
+.br
+.ti -1c
+.RI "union \fBhwloc_obj_attr_u\fP * \fBattr\fP"
+.br
+.ti -1c
+.RI "int \fBdepth\fP"
+.br
+.ti -1c
+.RI "unsigned \fBlogical_index\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBnext_cousin\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBprev_cousin\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBparent\fP"
+.br
+.ti -1c
+.RI "unsigned \fBsibling_rank\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBnext_sibling\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBprev_sibling\fP"
+.br
+.ti -1c
+.RI "int \fBsymmetric_subtree\fP"
+.br
+.ti -1c
+.RI "\fBhwloc_cpuset_t\fP \fBcpuset\fP"
+.br
+.ti -1c
+.RI "\fBhwloc_cpuset_t\fP \fBcomplete_cpuset\fP"
+.br
+.ti -1c
+.RI "\fBhwloc_nodeset_t\fP \fBnodeset\fP"
+.br
+.ti -1c
+.RI "\fBhwloc_nodeset_t\fP \fBcomplete_nodeset\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_info_s\fP * \fBinfos\fP"
+.br
+.ti -1c
+.RI "unsigned \fBinfos_count\fP"
+.br
+.ti -1c
+.RI "void * \fBuserdata\fP"
+.br
+.ti -1c
+.RI "hwloc_uint64_t \fBgp_index\fP"
+.br
+.in -1c
+.PP
+.RI "\fBList and array of normal children below this object (except Memory, I/O and Misc children)\&.\fP"
+.br
+
+.in +1c
+.in +1c
+.ti -1c
+.RI "unsigned \fBarity\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP ** \fBchildren\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBfirst_child\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBlast_child\fP"
+.br
+.in -1c
+.in -1c
+.PP
+.RI "\fBList of Memory children below this object\&.\fP"
+.br
+
+.in +1c
+.in +1c
+.ti -1c
+.RI "unsigned \fBmemory_arity\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBmemory_first_child\fP"
+.br
+.in -1c
+.in -1c
+.PP
+.RI "\fBList of I/O children below this object\&.\fP"
+.br
+
+.in +1c
+.in +1c
+.ti -1c
+.RI "unsigned \fBio_arity\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBio_first_child\fP"
+.br
+.in -1c
+.in -1c
+.PP
+.RI "\fBList of Misc children below this object\&.\fP"
+.br
+
+.in +1c
+.in +1c
+.ti -1c
+.RI "unsigned \fBmisc_arity\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBmisc_first_child\fP"
+.br
+.in -1c
+.in -1c
+.SH "Detailed Description"
+.PP 
+Structure of a topology object\&. 
+
+Applications must not modify any field except \fC\fBhwloc_obj\&.userdata\fP\fP\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned hwloc_obj::arity"
+
+.PP
+Number of normal children\&. Memory, Misc and I/O children are not listed here but rather in their dedicated children list\&. 
+.SS "union \fBhwloc_obj_attr_u\fP* hwloc_obj::attr"
+
+.PP
+Object type-specific Attributes, may be \fCNULL\fP if no attribute value was found\&. 
+.SS "struct \fBhwloc_obj\fP** hwloc_obj::children"
+
+.PP
+Normal children, \fCchildren\fP[0 \&.\&. arity -1]\&. 
+.SS "\fBhwloc_cpuset_t\fP hwloc_obj::complete_cpuset"
+
+.PP
+The complete CPU set of processors of this object,\&. This may include not only the same as the cpuset field, but also some CPUs for which topology information is unknown or incomplete, some offlines CPUs, and the CPUs that are ignored when the \fBHWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED\fP flag is not set\&. Thus no corresponding PU object may be found in the topology, because the precise position is undefined\&. It is however known that it would be somewhere under this object\&.
+.PP
+\fBNote\fP
+.RS 4
+Its value must not be changed, \fBhwloc_bitmap_dup()\fP must be used instead\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_nodeset_t\fP hwloc_obj::complete_nodeset"
+
+.PP
+The complete NUMA node set of this object,\&. This may include not only the same as the nodeset field, but also some NUMA nodes for which topology information is unknown or incomplete, some offlines nodes, and the nodes that are ignored when the \fBHWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED\fP flag is not set\&. Thus no corresponding NUMA node object may be found in the topology, because the precise position is undefined\&. It is however known that it would be somewhere under this object\&.
+.PP
+If there are no NUMA nodes in the machine, all the memory is close to this object, so only the first bit is set in \fCcomplete_nodeset\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+Its value must not be changed, \fBhwloc_bitmap_dup()\fP must be used instead\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_cpuset_t\fP hwloc_obj::cpuset"
+
+.PP
+CPUs covered by this object\&. This is the set of CPUs for which there are PU objects in the topology under this object, i\&.e\&. which are known to be physically contained in this object and known how (the children path between this object and the PU objects)\&.
+.PP
+If the \fBHWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED\fP configuration flag is set, some of these CPUs may be online but not allowed for binding, see \fBhwloc_topology_get_allowed_cpuset()\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+All objects have non-NULL CPU and node sets except Misc and I/O objects\&.
+.PP
+Its value must not be changed, \fBhwloc_bitmap_dup()\fP must be used instead\&. 
+.RE
+.PP
+
+.SS "int hwloc_obj::depth"
+
+.PP
+Vertical index in the hierarchy\&. For normal objects, this is the depth of the horizontal level that contains this object and its cousins of the same type\&. If the topology is symmetric, this is equal to the parent depth plus one, and also equal to the number of parent/child links from the root object to here\&.
+.PP
+For special objects (NUMA nodes, I/O and Misc) that are not in the main tree, this is a special negative value that corresponds to their dedicated level, see \fBhwloc_get_type_depth()\fP and \fBhwloc_get_type_depth_e\fP\&. Those special values can be passed to hwloc functions such \fBhwloc_get_nbobjs_by_depth()\fP as usual\&. 
+.SS "struct \fBhwloc_obj\fP* hwloc_obj::first_child"
+
+.PP
+First normal child\&. 
+.SS "hwloc_uint64_t hwloc_obj::gp_index"
+
+.PP
+Global persistent index\&. Generated by hwloc, unique across the topology (contrary to os_index) and persistent across topology changes (contrary to logical_index)\&. Mostly used internally, but could also be used by application to identify objects\&. 
+.SS "struct \fBhwloc_info_s\fP* hwloc_obj::infos"
+
+.PP
+Array of info attributes (name and value strings)\&. 
+.SS "unsigned hwloc_obj::infos_count"
+
+.PP
+Size of infos array\&. 
+.SS "unsigned hwloc_obj::io_arity"
+
+.PP
+Number of I/O children\&. These children are listed in \fCio_first_child\fP\&. 
+.SS "struct \fBhwloc_obj\fP* hwloc_obj::io_first_child"
+
+.PP
+First I/O child\&. Bridges, PCI and OS devices are listed here (\fCio_arity\fP and \fCio_first_child\fP) instead of in the normal children list\&. See also \fBhwloc_obj_type_is_io()\fP\&. 
+.SS "struct \fBhwloc_obj\fP* hwloc_obj::last_child"
+
+.PP
+Last normal child\&. 
+.SS "unsigned hwloc_obj::logical_index"
+
+.PP
+Horizontal index in the whole list of similar objects, hence guaranteed unique across the entire machine\&. Could be a 'cousin_rank' since it's the rank within the 'cousin' list below Note that this index may change when restricting the topology or when inserting a group\&. 
+.SS "unsigned hwloc_obj::memory_arity"
+
+.PP
+Number of Memory children\&. These children are listed in \fCmemory_first_child\fP\&. 
+.SS "struct \fBhwloc_obj\fP* hwloc_obj::memory_first_child"
+
+.PP
+First Memory child\&. NUMA nodes and Memory-side caches are listed here (\fCmemory_arity\fP and \fCmemory_first_child\fP) instead of in the normal children list\&. See also \fBhwloc_obj_type_is_memory()\fP\&. A memory hierarchy starts from a normal CPU-side object (e\&.g\&. Package) and ends with NUMA nodes as leaves\&. There might exist some memory-side caches between them in the middle of the memory subtree\&. 
+.SS "unsigned hwloc_obj::misc_arity"
+
+.PP
+Number of Misc children\&. These children are listed in \fCmisc_first_child\fP\&. 
+.SS "struct \fBhwloc_obj\fP* hwloc_obj::misc_first_child"
+
+.PP
+First Misc child\&. Misc objects are listed here (\fCmisc_arity\fP and \fCmisc_first_child\fP) instead of in the normal children list\&. 
+.SS "char* hwloc_obj::name"
+
+.PP
+Object-specific name if any\&. Mostly used for identifying OS devices and Misc objects where a name string is more useful than numerical indexes\&. 
+.SS "struct \fBhwloc_obj\fP* hwloc_obj::next_cousin"
+
+.PP
+Next object of same type and depth\&. 
+.SS "struct \fBhwloc_obj\fP* hwloc_obj::next_sibling"
+
+.PP
+Next object below the same parent (inside the same list of children)\&. 
+.SS "\fBhwloc_nodeset_t\fP hwloc_obj::nodeset"
+
+.PP
+NUMA nodes covered by this object or containing this object\&. This is the set of NUMA nodes for which there are NUMA node objects in the topology under or above this object, i\&.e\&. which are known to be physically contained in this object or containing it and known how (the children path between this object and the NUMA node objects)\&.
+.PP
+In the end, these nodes are those that are close to the current object\&. Function \fBhwloc_get_local_numanode_objs()\fP may be used to list those NUMA nodes more precisely\&.
+.PP
+If the \fBHWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED\fP configuration flag is set, some of these nodes may be online but not allowed for allocation, see \fBhwloc_topology_get_allowed_nodeset()\fP\&.
+.PP
+If there are no NUMA nodes in the machine, all the memory is close to this object, so only the first bit may be set in \fCnodeset\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+All objects have non-NULL CPU and node sets except Misc and I/O objects\&.
+.PP
+Its value must not be changed, \fBhwloc_bitmap_dup()\fP must be used instead\&. 
+.RE
+.PP
+
+.SS "unsigned hwloc_obj::os_index"
+
+.PP
+OS-provided physical index number\&. It is not guaranteed unique across the entire machine, except for PUs and NUMA nodes\&. Set to HWLOC_UNKNOWN_INDEX if unknown or irrelevant for this object\&. 
+.SS "struct \fBhwloc_obj\fP* hwloc_obj::parent"
+
+.PP
+Parent, \fCNULL\fP if root (Machine object) 
+.SS "struct \fBhwloc_obj\fP* hwloc_obj::prev_cousin"
+
+.PP
+Previous object of same type and depth\&. 
+.SS "struct \fBhwloc_obj\fP* hwloc_obj::prev_sibling"
+
+.PP
+Previous object below the same parent (inside the same list of children)\&. 
+.SS "unsigned hwloc_obj::sibling_rank"
+
+.PP
+Index in parent's \fCchildren\fP[] array\&. Or the index in parent's Memory, I/O or Misc children list\&. 
+.SS "char* hwloc_obj::subtype"
+
+.PP
+Subtype string to better describe the type field\&. 
+.SS "int hwloc_obj::symmetric_subtree"
+
+.PP
+Set if the subtree of normal objects below this object is symmetric, which means all normal children and their children have identical subtrees\&. Memory, I/O and Misc children are ignored\&.
+.PP
+If set in the topology root object, lstopo may export the topology as a synthetic string\&. 
+.SS "hwloc_uint64_t hwloc_obj::total_memory"
+
+.PP
+Total memory (in bytes) in NUMA nodes below this object\&. 
+.SS "\fBhwloc_obj_type_t\fP hwloc_obj::type"
+
+.PP
+Type of object\&. 
+.SS "void* hwloc_obj::userdata"
+
+.PP
+Application-given private data pointer, initialized to \fCNULL\fP, use it as you wish\&. See \fBhwloc_topology_set_userdata_export_callback()\fP in \fBhwloc/export\&.h\fP if you wish to export this field to XML\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_children_sets.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_children_sets.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_children_sets.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_children_sets.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_core_funcs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_info.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_info.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_info.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_info.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_info_attr.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_other_obj_sets.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_other_obj_sets.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_other_obj_sets.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_add_other_obj_sets.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_snprintf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_snprintf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_snprintf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_snprintf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_strings.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,75 @@
+.TH "hwloc_obj_attr_u" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_obj_attr_u
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_bridge_attr_s\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_cache_attr_s\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_group_attr_s\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_numanode_attr_s\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_osdev_attr_s\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_pcidev_attr_s\fP"
+.br
+.in -1c
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_obj_attr_u::hwloc_numanode_attr_s\fP \fBnumanode\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj_attr_u::hwloc_cache_attr_s\fP \fBcache\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj_attr_u::hwloc_group_attr_s\fP \fBgroup\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj_attr_u::hwloc_pcidev_attr_s\fP \fBpcidev\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj_attr_u::hwloc_bridge_attr_s\fP \fBbridge\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj_attr_u::hwloc_osdev_attr_s\fP \fBosdev\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Object type-specific Attributes\&. 
+.SH "Field Documentation"
+.PP 
+.SS "struct \fBhwloc_obj_attr_u::hwloc_bridge_attr_s\fP hwloc_obj_attr_u::bridge"
+
+.SS "struct \fBhwloc_obj_attr_u::hwloc_cache_attr_s\fP hwloc_obj_attr_u::cache"
+
+.SS "struct \fBhwloc_obj_attr_u::hwloc_group_attr_s\fP hwloc_obj_attr_u::group"
+
+.SS "struct \fBhwloc_obj_attr_u::hwloc_numanode_attr_s\fP hwloc_obj_attr_u::numanode"
+
+.SS "struct \fBhwloc_obj_attr_u::hwloc_osdev_attr_s\fP hwloc_obj_attr_u::osdev"
+
+.SS "struct \fBhwloc_obj_attr_u::hwloc_pcidev_attr_s\fP hwloc_obj_attr_u::pcidev"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_bridge_attr_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_bridge_attr_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_bridge_attr_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_bridge_attr_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,94 @@
+.TH "hwloc_obj_attr_u::hwloc_bridge_attr_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_obj_attr_u::hwloc_bridge_attr_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "union {"
+.br
+.ti -1c
+.RI "   struct \fBhwloc_pcidev_attr_s\fP \fBpci\fP"
+.br
+.ti -1c
+.RI "} \fBupstream\fP"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_bridge_type_t\fP \fBupstream_type\fP"
+.br
+.ti -1c
+.RI "union {"
+.br
+.ti -1c
+.RI "   struct {"
+.br
+.ti -1c
+.RI "      unsigned short \fBdomain\fP"
+.br
+.ti -1c
+.RI "      unsigned char \fBsecondary_bus\fP"
+.br
+.ti -1c
+.RI "      unsigned char \fBsubordinate_bus\fP"
+.br
+.ti -1c
+.RI "   } \fBpci\fP"
+.br
+.ti -1c
+.RI "} \fBdownstream\fP"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_bridge_type_t\fP \fBdownstream_type\fP"
+.br
+.ti -1c
+.RI "unsigned \fBdepth\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Bridge specific Object Attributes\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned hwloc_obj_attr_u::hwloc_bridge_attr_s::depth"
+
+.SS "unsigned short hwloc_obj_attr_u::hwloc_bridge_attr_s::domain"
+
+.PP
+Domain number the downstream PCI buses\&. Only 16bits PCI domains are supported by default\&. 
+.SS "union  { \&.\&.\&. }  hwloc_obj_attr_u::hwloc_bridge_attr_s::downstream"
+
+.SS "\fBhwloc_obj_bridge_type_t\fP hwloc_obj_attr_u::hwloc_bridge_attr_s::downstream_type"
+
+.PP
+Downstream Bridge type\&. 
+.SS "struct \fBhwloc_pcidev_attr_s\fP hwloc_obj_attr_u::hwloc_bridge_attr_s::pci"
+
+.PP
+PCI attribute of the upstream part as a PCI device\&. 
+.SS "struct  { \&.\&.\&. }  hwloc_obj_attr_u::hwloc_bridge_attr_s::pci"
+
+.SS "unsigned char hwloc_obj_attr_u::hwloc_bridge_attr_s::secondary_bus"
+
+.PP
+First PCI bus number below the bridge\&. 
+.SS "unsigned char hwloc_obj_attr_u::hwloc_bridge_attr_s::subordinate_bus"
+
+.PP
+Highest PCI bus number below the bridge\&. 
+.SS "union  { \&.\&.\&. }  hwloc_obj_attr_u::hwloc_bridge_attr_s::upstream"
+
+.SS "\fBhwloc_obj_bridge_type_t\fP hwloc_obj_attr_u::hwloc_bridge_attr_s::upstream_type"
+
+.PP
+Upstream Bridge type\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_cache_attr_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_cache_attr_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_cache_attr_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_cache_attr_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,58 @@
+.TH "hwloc_obj_attr_u::hwloc_cache_attr_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_obj_attr_u::hwloc_cache_attr_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "hwloc_uint64_t \fBsize\fP"
+.br
+.ti -1c
+.RI "unsigned \fBdepth\fP"
+.br
+.ti -1c
+.RI "unsigned \fBlinesize\fP"
+.br
+.ti -1c
+.RI "int \fBassociativity\fP"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_cache_type_t\fP \fBtype\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Cache-specific Object Attributes\&. 
+.SH "Field Documentation"
+.PP 
+.SS "int hwloc_obj_attr_u::hwloc_cache_attr_s::associativity"
+
+.PP
+Ways of associativity, -1 if fully associative, 0 if unknown\&. 
+.SS "unsigned hwloc_obj_attr_u::hwloc_cache_attr_s::depth"
+
+.PP
+Depth of cache (e\&.g\&., L1, L2, \&.\&.\&.etc\&.) 
+.SS "unsigned hwloc_obj_attr_u::hwloc_cache_attr_s::linesize"
+
+.PP
+Cache-line size in bytes\&. 0 if unknown\&. 
+.SS "hwloc_uint64_t hwloc_obj_attr_u::hwloc_cache_attr_s::size"
+
+.PP
+Size of cache in bytes\&. 
+.SS "\fBhwloc_obj_cache_type_t\fP hwloc_obj_attr_u::hwloc_cache_attr_s::type"
+
+.PP
+Cache type\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_group_attr_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_group_attr_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_group_attr_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_group_attr_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,51 @@
+.TH "hwloc_obj_attr_u::hwloc_group_attr_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_obj_attr_u::hwloc_group_attr_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "unsigned \fBdepth\fP"
+.br
+.ti -1c
+.RI "unsigned \fBkind\fP"
+.br
+.ti -1c
+.RI "unsigned \fBsubkind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBdont_merge\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Group-specific Object Attributes\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned hwloc_obj_attr_u::hwloc_group_attr_s::depth"
+
+.PP
+Depth of group object\&. It may change if intermediate Group objects are added\&. 
+.SS "unsigned char hwloc_obj_attr_u::hwloc_group_attr_s::dont_merge"
+
+.PP
+Flag preventing groups from being automatically merged with identical parent or children\&. 
+.SS "unsigned hwloc_obj_attr_u::hwloc_group_attr_s::kind"
+
+.PP
+Internally-used kind of group\&. 
+.SS "unsigned hwloc_obj_attr_u::hwloc_group_attr_s::subkind"
+
+.PP
+Internally-used subkind to distinguish different levels of groups with same kind\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_numanode_attr_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_numanode_attr_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_numanode_attr_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_numanode_attr_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,49 @@
+.TH "hwloc_obj_attr_u::hwloc_numanode_attr_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_obj_attr_u::hwloc_numanode_attr_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_memory_page_type_s\fP"
+.br
+.in -1c
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "hwloc_uint64_t \fBlocal_memory\fP"
+.br
+.ti -1c
+.RI "unsigned \fBpage_types_len\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s\fP * \fBpage_types\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+NUMA node-specific Object Attributes\&. 
+.SH "Field Documentation"
+.PP 
+.SS "hwloc_uint64_t hwloc_obj_attr_u::hwloc_numanode_attr_s::local_memory"
+
+.PP
+Local memory (in bytes) 
+.SS "struct \fBhwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s\fP * hwloc_obj_attr_u::hwloc_numanode_attr_s::page_types"
+
+.SS "unsigned hwloc_obj_attr_u::hwloc_numanode_attr_s::page_types_len"
+
+.PP
+Size of array \fCpage_types\fP\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_numanode_attr_s_hwloc_memory_page_type_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_numanode_attr_s_hwloc_memory_page_type_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_numanode_attr_s_hwloc_memory_page_type_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_numanode_attr_s_hwloc_memory_page_type_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,39 @@
+.TH "hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "hwloc_uint64_t \fBsize\fP"
+.br
+.ti -1c
+.RI "hwloc_uint64_t \fBcount\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Array of local memory page types, \fCNULL\fP if no local memory and \fCpage_types\fP is 0\&. 
+
+The array is sorted by increasing \fCsize\fP fields\&. It contains \fCpage_types_len\fP slots\&. 
+.SH "Field Documentation"
+.PP 
+.SS "hwloc_uint64_t hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s::count"
+
+.PP
+Number of pages of this size\&. 
+.SS "hwloc_uint64_t hwloc_obj_attr_u::hwloc_numanode_attr_s::hwloc_memory_page_type_s::size"
+
+.PP
+Size of pages\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_osdev_attr_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_osdev_attr_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_osdev_attr_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_osdev_attr_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,28 @@
+.TH "hwloc_obj_attr_u::hwloc_osdev_attr_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_obj_attr_u::hwloc_osdev_attr_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_obj_osdev_type_t\fP \fBtype\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+OS Device specific Object Attributes\&. 
+.SH "Field Documentation"
+.PP 
+.SS "\fBhwloc_obj_osdev_type_t\fP hwloc_obj_attr_u::hwloc_osdev_attr_s::type"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_pcidev_attr_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_pcidev_attr_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_pcidev_attr_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_attr_u_hwloc_pcidev_attr_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,100 @@
+.TH "hwloc_obj_attr_u::hwloc_pcidev_attr_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_obj_attr_u::hwloc_pcidev_attr_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "unsigned short \fBdomain\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBbus\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBdev\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBfunc\fP"
+.br
+.ti -1c
+.RI "unsigned short \fBclass_id\fP"
+.br
+.ti -1c
+.RI "unsigned short \fBvendor_id\fP"
+.br
+.ti -1c
+.RI "unsigned short \fBdevice_id\fP"
+.br
+.ti -1c
+.RI "unsigned short \fBsubvendor_id\fP"
+.br
+.ti -1c
+.RI "unsigned short \fBsubdevice_id\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBrevision\fP"
+.br
+.ti -1c
+.RI "float \fBlinkspeed\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+PCI Device specific Object Attributes\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned char hwloc_obj_attr_u::hwloc_pcidev_attr_s::bus"
+
+.PP
+Bus number (yy in the PCI BDF notation xxxx:yy:zz\&.t)\&. 
+.SS "unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::class_id"
+
+.PP
+The class number (first two bytes, without the prog_if)\&. 
+.SS "unsigned char hwloc_obj_attr_u::hwloc_pcidev_attr_s::dev"
+
+.PP
+Device number (zz in the PCI BDF notation xxxx:yy:zz\&.t)\&. 
+.SS "unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::device_id"
+
+.PP
+Device ID (yyyy in [xxxx:yyyy])\&. 
+.SS "unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::domain"
+
+.PP
+Domain number (xxxx in the PCI BDF notation xxxx:yy:zz\&.t)\&. Only 16bits PCI domains are supported by default\&. 
+.SS "unsigned char hwloc_obj_attr_u::hwloc_pcidev_attr_s::func"
+
+.PP
+Function number (t in the PCI BDF notation xxxx:yy:zz\&.t)\&. 
+.SS "float hwloc_obj_attr_u::hwloc_pcidev_attr_s::linkspeed"
+
+.PP
+Link speed in GB/s\&. This datarate is the currently configured speed of the entire PCI link (sum of the bandwidth of all PCI lanes in that link)\&. It may change during execution since some devices are able to slow their PCI links down when idle\&. 
+.SS "unsigned char hwloc_obj_attr_u::hwloc_pcidev_attr_s::revision"
+
+.PP
+Revision number\&. 
+.SS "unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::subdevice_id"
+
+.PP
+Sub-Device ID\&. 
+.SS "unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::subvendor_id"
+
+.PP
+Sub-Vendor ID\&. 
+.SS "unsigned short hwloc_obj_attr_u::hwloc_pcidev_attr_s::vendor_id"
+
+.PP
+Vendor ID (xxxx in [xxxx:yyyy])\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_bridge_type_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_bridge_type_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_bridge_type_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_bridge_type_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_bridge_type_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_bridge_type_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_bridge_type_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_bridge_type_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_cache_type_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_cache_type_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_cache_type_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_cache_type_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_cache_type_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_cache_type_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_cache_type_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_cache_type_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_get_info_by_name.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_get_info_by_name.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_get_info_by_name.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_get_info_by_name.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_info_attr.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_is_in_subtree.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_is_in_subtree.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_is_in_subtree.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_is_in_subtree.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_ancestors.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_osdev_type_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_osdev_type_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_osdev_type_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_osdev_type_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_osdev_type_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_osdev_type_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_osdev_type_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_osdev_type_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_set_subtype.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_set_subtype.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_set_subtype.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_set_subtype.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_info_attr.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_objects.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_cache.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_cache.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_cache.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_cache.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_dcache.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_dcache.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_dcache.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_dcache.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_icache.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_icache.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_icache.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_icache.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_io.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_io.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_io.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_io.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_memory.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_memory.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_memory.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_memory.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_normal.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_normal.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_normal.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_is_normal.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_snprintf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_snprintf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_snprintf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_snprintf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_strings.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_string.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_string.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_string.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_string.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_strings.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_obj_type_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_types.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_opencl.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_osdev.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_osdev.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_osdev.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_osdev.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_opencl.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_osdev_by_index.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_osdev_by_index.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_osdev_by_index.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_osdev_by_index.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_opencl.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_pci_busid.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_pci_busid.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_pci_busid.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_opencl_get_device_pci_busid.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_opencl.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pci_find_by_busid.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pci_find_by_busid.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pci_find_by_busid.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pci_find_by_busid.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcifind.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pci_find_parent_by_busid.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pci_find_parent_by_busid.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pci_find_parent_by_busid.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pci_find_parent_by_busid.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcifind.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_check_bridge_type.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_check_bridge_type.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_check_bridge_type.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_check_bridge_type.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcidisc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_bridge_buses.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_bridge_buses.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_bridge_buses.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_bridge_buses.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcidisc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_cap.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_cap.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_cap.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_cap.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcidisc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_linkspeed.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_linkspeed.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_linkspeed.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_find_linkspeed.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcidisc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_tree_attach.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_tree_attach.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_tree_attach.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_tree_attach.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcidisc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_tree_insert_by_busid.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_tree_insert_by_busid.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_tree_insert_by_busid.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_pcidisc_tree_insert_by_busid.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_pcidisc.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_plugin_check_namespace.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_plugin_check_namespace.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_plugin_check_namespace.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_plugin_check_namespace.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_core_funcs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_restrict_flags_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_restrict_flags_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_restrict_flags_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_restrict_flags_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_rsmi.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_osdev.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_osdev.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_osdev.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_osdev.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_rsmi.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_osdev_by_index.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_osdev_by_index.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_osdev_by_index.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_rsmi_get_device_osdev_by_index.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_rsmi.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_area_membind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_area_membind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_area_membind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_area_membind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_cpubind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_cpubind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_cpubind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_cpubind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_membind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_membind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_membind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_membind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_proc_cpubind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_proc_cpubind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_proc_cpubind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_proc_cpubind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_proc_membind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_proc_membind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_proc_membind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_proc_membind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_membinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_thread_cpubind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_thread_cpubind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_set_thread_cpubind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_set_thread_cpubind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_cpubinding.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_adopt.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_adopt.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_adopt.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_adopt.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_shmem.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_get_length.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_get_length.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_get_length.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_get_length.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_shmem.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_write.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_write.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_write.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_shmem_topology_write.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_shmem.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_abi_check.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_abi_check.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_abi_check.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_abi_check.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_creation.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_alloc_group_object.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_alloc_group_object.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_alloc_group_object.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_alloc_group_object.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_allow.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_allow.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_allow.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_allow.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_check.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_check.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_check.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_check.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_creation.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_components_flag_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_components_flag_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_components_flag_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_components_flag_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_setsource.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_cpubind_support.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_cpubind_support.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_cpubind_support.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_cpubind_support.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,80 @@
+.TH "hwloc_topology_cpubind_support" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_cpubind_support
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "unsigned char \fBset_thisproc_cpubind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_thisproc_cpubind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBset_proc_cpubind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_proc_cpubind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBset_thisthread_cpubind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_thisthread_cpubind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBset_thread_cpubind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_thread_cpubind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_thisproc_last_cpu_location\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_proc_last_cpu_location\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_thisthread_last_cpu_location\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Flags describing actual PU binding support for this topology\&. 
+
+A flag may be set even if the feature isn't supported in all cases (e\&.g\&. binding to random sets of non-contiguous objects)\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned char hwloc_topology_cpubind_support::get_proc_cpubind"
+Getting the binding of a whole given process is supported\&. 
+.SS "unsigned char hwloc_topology_cpubind_support::get_proc_last_cpu_location"
+Getting the last processors where a whole process ran is supported 
+.SS "unsigned char hwloc_topology_cpubind_support::get_thisproc_cpubind"
+Getting the binding of the whole current process is supported\&. 
+.SS "unsigned char hwloc_topology_cpubind_support::get_thisproc_last_cpu_location"
+Getting the last processors where the whole current process ran is supported 
+.SS "unsigned char hwloc_topology_cpubind_support::get_thisthread_cpubind"
+Getting the binding of the current thread only is supported\&. 
+.SS "unsigned char hwloc_topology_cpubind_support::get_thisthread_last_cpu_location"
+Getting the last processors where the current thread ran is supported 
+.SS "unsigned char hwloc_topology_cpubind_support::get_thread_cpubind"
+Getting the binding of a given thread only is supported\&. 
+.SS "unsigned char hwloc_topology_cpubind_support::set_proc_cpubind"
+Binding a whole given process is supported\&. 
+.SS "unsigned char hwloc_topology_cpubind_support::set_thisproc_cpubind"
+Binding the whole current process is supported\&. 
+.SS "unsigned char hwloc_topology_cpubind_support::set_thisthread_cpubind"
+Binding the current thread only is supported\&. 
+.SS "unsigned char hwloc_topology_cpubind_support::set_thread_cpubind"
+Binding a given thread only is supported\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_destroy.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_destroy.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_destroy.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_destroy.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_creation.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_apply.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_apply.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_apply.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_apply.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_apply_flags_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_apply_flags_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_apply_flags_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_apply_flags_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_build.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_build.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_build.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_build.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_destroy.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_destroy.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_destroy.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_destroy.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_export_xml.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_export_xml.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_export_xml.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_export_xml.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_export_xmlbuffer.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_export_xmlbuffer.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_export_xmlbuffer.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_export_xmlbuffer.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_load_xml.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_load_xml.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_load_xml.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_load_xml.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_load_xmlbuffer.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_load_xmlbuffer.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_load_xmlbuffer.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_load_xmlbuffer.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_type_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_type_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_type_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_type_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_type_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_type_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_type_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_type_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,51 @@
+.TH "hwloc_topology_diff_obj_attr_u" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_diff_obj_attr_u
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <diff\&.h>\fP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_obj_attr_generic_s\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_obj_attr_string_s\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_obj_attr_uint64_s\fP"
+.br
+.in -1c
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s\fP \fBgeneric\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s\fP \fBuint64\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s\fP \fBstring\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+One object attribute difference\&. 
+.SH "Field Documentation"
+.PP 
+.SS "struct \fBhwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s\fP hwloc_topology_diff_obj_attr_u::generic"
+
+.SS "struct \fBhwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s\fP hwloc_topology_diff_obj_attr_u::string"
+
+.SS "struct \fBhwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s\fP hwloc_topology_diff_obj_attr_u::uint64"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_generic_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_generic_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_generic_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_generic_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,25 @@
+.TH "hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <diff\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_topology_diff_obj_attr_type_t\fP \fBtype\fP"
+.br
+.in -1c
+.SH "Field Documentation"
+.PP 
+.SS "\fBhwloc_topology_diff_obj_attr_type_t\fP hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_generic_s::type"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_string_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_string_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_string_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_string_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,43 @@
+.TH "hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <diff\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_topology_diff_obj_attr_type_t\fP \fBtype\fP"
+.br
+.ti -1c
+.RI "char * \fBname\fP"
+.br
+.ti -1c
+.RI "char * \fBoldvalue\fP"
+.br
+.ti -1c
+.RI "char * \fBnewvalue\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+String attribute modification with an optional name\&. 
+.SH "Field Documentation"
+.PP 
+.SS "char* hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::name"
+
+.SS "char* hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::newvalue"
+
+.SS "char* hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::oldvalue"
+
+.SS "\fBhwloc_topology_diff_obj_attr_type_t\fP hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s::type"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_uint64_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_uint64_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_uint64_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_obj_attr_u_hwloc_topology_diff_obj_attr_uint64_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,43 @@
+.TH "hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <diff\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_topology_diff_obj_attr_type_t\fP \fBtype\fP"
+.br
+.ti -1c
+.RI "hwloc_uint64_t \fBindex\fP"
+.br
+.ti -1c
+.RI "hwloc_uint64_t \fBoldvalue\fP"
+.br
+.ti -1c
+.RI "hwloc_uint64_t \fBnewvalue\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Integer attribute modification with an optional index\&. 
+.SH "Field Documentation"
+.PP 
+.SS "hwloc_uint64_t hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::index"
+
+.SS "hwloc_uint64_t hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::newvalue"
+
+.SS "hwloc_uint64_t hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::oldvalue"
+
+.SS "\fBhwloc_topology_diff_obj_attr_type_t\fP hwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s::type"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_type_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_type_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_type_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_type_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_type_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_type_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_type_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_type_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_diff.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,51 @@
+.TH "hwloc_topology_diff_u" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_diff_u
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <diff\&.h>\fP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_generic_s\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_obj_attr_s\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_too_complex_s\fP"
+.br
+.in -1c
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_u::hwloc_topology_diff_generic_s\fP \fBgeneric\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s\fP \fBobj_attr\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_diff_u::hwloc_topology_diff_too_complex_s\fP \fBtoo_complex\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+One element of a difference list between two topologies\&. 
+.SH "Field Documentation"
+.PP 
+.SS "struct \fBhwloc_topology_diff_u::hwloc_topology_diff_generic_s\fP hwloc_topology_diff_u::generic"
+
+.SS "struct \fBhwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s\fP hwloc_topology_diff_u::obj_attr"
+
+.SS "struct \fBhwloc_topology_diff_u::hwloc_topology_diff_too_complex_s\fP hwloc_topology_diff_u::too_complex"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_generic_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_generic_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_generic_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_generic_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,30 @@
+.TH "hwloc_topology_diff_u::hwloc_topology_diff_generic_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_diff_u::hwloc_topology_diff_generic_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <diff\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_topology_diff_type_t\fP \fBtype\fP"
+.br
+.ti -1c
+.RI "union \fBhwloc_topology_diff_u\fP * \fBnext\fP"
+.br
+.in -1c
+.SH "Field Documentation"
+.PP 
+.SS "union \fBhwloc_topology_diff_u\fP* hwloc_topology_diff_u::hwloc_topology_diff_generic_s::next"
+
+.SS "\fBhwloc_topology_diff_type_t\fP hwloc_topology_diff_u::hwloc_topology_diff_generic_s::type"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_obj_attr_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_obj_attr_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_obj_attr_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_obj_attr_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,45 @@
+.TH "hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <diff\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_topology_diff_type_t\fP \fBtype\fP"
+.br
+.ti -1c
+.RI "union \fBhwloc_topology_diff_u\fP * \fBnext\fP"
+.br
+.ti -1c
+.RI "int \fBobj_depth\fP"
+.br
+.ti -1c
+.RI "unsigned \fBobj_index\fP"
+.br
+.ti -1c
+.RI "union \fBhwloc_topology_diff_obj_attr_u\fP \fBdiff\fP"
+.br
+.in -1c
+.SH "Field Documentation"
+.PP 
+.SS "union \fBhwloc_topology_diff_obj_attr_u\fP hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::diff"
+
+.SS "union \fBhwloc_topology_diff_u\fP* hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::next"
+
+.SS "int hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::obj_depth"
+
+.SS "unsigned hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::obj_index"
+
+.SS "\fBhwloc_topology_diff_type_t\fP hwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s::type"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_too_complex_s.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_too_complex_s.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_too_complex_s.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_diff_u_hwloc_topology_diff_too_complex_s.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,40 @@
+.TH "hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <diff\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_topology_diff_type_t\fP \fBtype\fP"
+.br
+.ti -1c
+.RI "union \fBhwloc_topology_diff_u\fP * \fBnext\fP"
+.br
+.ti -1c
+.RI "int \fBobj_depth\fP"
+.br
+.ti -1c
+.RI "unsigned \fBobj_index\fP"
+.br
+.in -1c
+.SH "Field Documentation"
+.PP 
+.SS "union \fBhwloc_topology_diff_u\fP* hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::next"
+
+.SS "int hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::obj_depth"
+
+.SS "unsigned hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::obj_index"
+
+.SS "\fBhwloc_topology_diff_type_t\fP hwloc_topology_diff_u::hwloc_topology_diff_too_complex_s::type"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_discovery_support.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_discovery_support.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_discovery_support.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_discovery_support.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,65 @@
+.TH "hwloc_topology_discovery_support" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_discovery_support
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "unsigned char \fBpu\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBnuma\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBnuma_memory\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBdisallowed_pu\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBdisallowed_numa\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBcpukind_efficiency\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Flags describing actual discovery support for this topology\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned char hwloc_topology_discovery_support::cpukind_efficiency"
+
+.PP
+Detecting the efficiency of CPU kinds is supported, see \fBKinds of CPU cores\fP\&. 
+.SS "unsigned char hwloc_topology_discovery_support::disallowed_numa"
+
+.PP
+Detecting and identifying NUMA nodes that are not available to the current process is supported\&. 
+.SS "unsigned char hwloc_topology_discovery_support::disallowed_pu"
+
+.PP
+Detecting and identifying PU objects that are not available to the current process is supported\&. 
+.SS "unsigned char hwloc_topology_discovery_support::numa"
+
+.PP
+Detecting the number of NUMA nodes is supported\&. 
+.SS "unsigned char hwloc_topology_discovery_support::numa_memory"
+
+.PP
+Detecting the amount of memory in NUMA nodes is supported\&. 
+.SS "unsigned char hwloc_topology_discovery_support::pu"
+
+.PP
+Detecting the number of PU objects is supported\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_dup.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_dup.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_dup.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_dup.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_creation.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_synthetic.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_synthetic.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_synthetic.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_synthetic.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_syntheticexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_synthetic_flags_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_synthetic_flags_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_synthetic_flags_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_synthetic_flags_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_syntheticexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xml.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xml.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xml.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xml.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_xmlexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xml_flags_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xml_flags_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xml_flags_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xml_flags_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_xmlexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xmlbuffer.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xmlbuffer.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xmlbuffer.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_export_xmlbuffer.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_xmlexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_flags_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_flags_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_flags_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_flags_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_free_group_object.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_free_group_object.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_free_group_object.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_free_group_object.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_allowed_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_allowed_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_allowed_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_allowed_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_topology_sets.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_allowed_nodeset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_allowed_nodeset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_allowed_nodeset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_allowed_nodeset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_topology_sets.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_complete_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_complete_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_complete_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_complete_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_topology_sets.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_complete_nodeset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_complete_nodeset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_complete_nodeset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_complete_nodeset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_topology_sets.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_levels.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_flags.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_flags.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_flags.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_flags.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_support.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_support.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_support.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_support.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_topology_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_topology_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_topology_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_topology_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_topology_sets.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_topology_nodeset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_topology_nodeset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_topology_nodeset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_topology_nodeset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_helper_topology_sets.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_type_filter.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_type_filter.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_type_filter.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_type_filter.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_userdata.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_userdata.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_userdata.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_get_userdata.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_init.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_init.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_init.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_init.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_creation.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_insert_group_object.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_insert_group_object.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_insert_group_object.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_insert_group_object.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_insert_misc_object.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_insert_misc_object.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_insert_misc_object.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_insert_misc_object.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_is_thissystem.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_is_thissystem.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_is_thissystem.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_is_thissystem.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_load.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_load.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_load.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_load.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_creation.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_membind_support.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_membind_support.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_membind_support.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_membind_support.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,105 @@
+.TH "hwloc_topology_membind_support" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_membind_support
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "unsigned char \fBset_thisproc_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_thisproc_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBset_proc_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_proc_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBset_thisthread_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_thisthread_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBset_area_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_area_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBalloc_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBfirsttouch_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBbind_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBinterleave_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBnexttouch_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBmigrate_membind\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBget_area_memlocation\fP"
+.br
+.ti -1c
+.RI "unsigned char \fBweighted_interleave_membind\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Flags describing actual memory binding support for this topology\&. 
+
+A flag may be set even if the feature isn't supported in all cases (e\&.g\&. binding to random sets of non-contiguous objects)\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned char hwloc_topology_membind_support::alloc_membind"
+Allocating a bound memory area is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::bind_membind"
+Bind policy is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::firsttouch_membind"
+First-touch policy is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::get_area_membind"
+Getting the binding of a given memory area is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::get_area_memlocation"
+Getting the last NUMA nodes where a memory area was allocated is supported 
+.SS "unsigned char hwloc_topology_membind_support::get_proc_membind"
+Getting the binding of a whole given process is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::get_thisproc_membind"
+Getting the binding of the whole current process is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::get_thisthread_membind"
+Getting the binding of the current thread only is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::interleave_membind"
+Interleave policy is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::migrate_membind"
+Migration flags is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::nexttouch_membind"
+Next-touch migration policy is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::set_area_membind"
+Binding a given memory area is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::set_proc_membind"
+Binding a whole given process is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::set_thisproc_membind"
+Binding the whole current process is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::set_thisthread_membind"
+Binding the current thread only is supported\&. 
+.SS "unsigned char hwloc_topology_membind_support::weighted_interleave_membind"
+Weighted interleave policy is supported\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_misc_support.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_misc_support.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_misc_support.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_misc_support.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,28 @@
+.TH "hwloc_topology_misc_support" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_misc_support
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "unsigned char \fBimported_support\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Flags describing miscellaneous features\&. 
+.SH "Field Documentation"
+.PP 
+.SS "unsigned char hwloc_topology_misc_support::imported_support"
+Support was imported when importing another topology, see \fBHWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT\fP\&. 
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_reconnect.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_reconnect.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_reconnect.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_reconnect.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_components_core_funcs.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_refresh.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_refresh.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_refresh.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_refresh.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_restrict.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_restrict.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_restrict.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_restrict.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_tinker.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_all_types_filter.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_all_types_filter.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_all_types_filter.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_all_types_filter.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_cache_types_filter.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_cache_types_filter.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_cache_types_filter.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_cache_types_filter.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_components.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_components.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_components.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_components.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_setsource.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_flags.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_flags.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_flags.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_flags.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_icache_types_filter.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_icache_types_filter.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_icache_types_filter.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_icache_types_filter.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_io_types_filter.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_io_types_filter.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_io_types_filter.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_io_types_filter.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_pid.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_pid.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_pid.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_pid.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_setsource.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_synthetic.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_synthetic.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_synthetic.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_synthetic.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_setsource.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_type_filter.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_type_filter.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_type_filter.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_type_filter.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata_export_callback.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata_export_callback.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata_export_callback.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata_export_callback.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_xmlexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata_import_callback.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata_import_callback.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata_import_callback.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_userdata_import_callback.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_xmlexport.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_xml.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_xml.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_xml.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_xml.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_setsource.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_xmlbuffer.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_xmlbuffer.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_xmlbuffer.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_set_xmlbuffer.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_setsource.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_support.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_support.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_support.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_support.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,45 @@
+.TH "hwloc_topology_support" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwloc_topology_support
+.SH SYNOPSIS
+.br
+.PP
+.PP
+\fC#include <hwloc\&.h>\fP
+.SS "Data Fields"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_topology_discovery_support\fP * \fBdiscovery\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_cpubind_support\fP * \fBcpubind\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_membind_support\fP * \fBmembind\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_misc_support\fP * \fBmisc\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Set of flags describing actual support for this topology\&. 
+
+This is retrieved with \fBhwloc_topology_get_support()\fP and will be valid until the topology object is destroyed\&. Note: the values are correct only after discovery\&. 
+.SH "Field Documentation"
+.PP 
+.SS "struct \fBhwloc_topology_cpubind_support\fP* hwloc_topology_support::cpubind"
+
+.SS "struct \fBhwloc_topology_discovery_support\fP* hwloc_topology_support::discovery"
+
+.SS "struct \fBhwloc_topology_membind_support\fP* hwloc_topology_support::membind"
+
+.SS "struct \fBhwloc_topology_misc_support\fP* hwloc_topology_support::misc"
+
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_t.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_t.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_topology_t.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_topology_t.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_creation.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_type_filter_e.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_type_filter_e.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_type_filter_e.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_type_filter_e.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_configuration.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_type_sscanf.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_type_sscanf.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_type_sscanf.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_type_sscanf.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_strings.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_type_sscanf_as_depth.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_type_sscanf_as_depth.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_type_sscanf_as_depth.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_type_sscanf_as_depth.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_object_strings.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_windows_get_nr_processor_groups.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_windows_get_nr_processor_groups.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_windows_get_nr_processor_groups.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_windows_get_nr_processor_groups.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_windows.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_windows_get_processor_group_cpuset.3 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_windows_get_processor_group_cpuset.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwloc_windows_get_processor_group_cpuset.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwloc_windows_get_processor_group_cpuset.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1 @@
+.so man3/hwlocality_windows.3
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_advanced_io.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_advanced_io.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_advanced_io.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_advanced_io.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,128 @@
+.TH "hwlocality_advanced_io" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_advanced_io \- Finding I/O objects
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_non_io_ancestor_obj\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP ioobj)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_next_pcidev\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP prev)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_pcidev_by_busid\fP (\fBhwloc_topology_t\fP topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_pcidev_by_busidstring\fP (\fBhwloc_topology_t\fP topology, const char *busid)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_next_osdev\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP prev)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_next_bridge\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP prev)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_bridge_covers_pcibus\fP (\fBhwloc_obj_t\fP bridge, unsigned domain, unsigned bus)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_bridge_covers_pcibus (\fBhwloc_obj_t\fP bridge, unsigned domain, unsigned bus)\fC [inline]\fP, \fC [static]\fP"
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_next_bridge (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP prev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the next bridge in the system\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the first bridge if \fCprev\fP is \fCNULL\fP\&. 
+.PP
+the next bridge if \fCprev\fP is not \fCNULL\fP\&. 
+.PP
+\fCNULL\fP if there is no next bridge\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_next_osdev (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP prev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the next OS device in the system\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the first OS device if \fCprev\fP is \fCNULL\fP\&. 
+.PP
+the next OS device if \fCprev\fP is not \fCNULL\fP\&. 
+.PP
+\fCNULL\fP if there is no next OS device\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_next_pcidev (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP prev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the next PCI device in the system\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the first PCI device if \fCprev\fP is \fCNULL\fP\&. 
+.PP
+the next PCI device if \fCprev\fP is not \fCNULL\fP\&. 
+.PP
+\fCNULL\fP if there is no next PCI device\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_non_io_ancestor_obj (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP ioobj)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the first non-I/O ancestor object\&. Given the I/O object \fCioobj\fP, find the smallest non-I/O ancestor object\&. This object (normal or memory) may then be used for binding because it has non-NULL CPU and node sets and because its locality is the same as \fCioobj\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+a non-I/O object\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot return \fCNULL\fP\&.
+.PP
+The resulting object is usually a normal object but it could also be a memory object (e\&.g\&. NUMA node) in future platforms if I/O objects ever get attached to memory instead of CPUs\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_pcidev_by_busid (\fBhwloc_topology_t\fP topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Find the PCI device object matching the PCI bus id given domain, bus device and function PCI bus id\&. 
+.PP
+\fBReturns\fP
+.RS 4
+a matching PCI device object if any, \fCNULL\fP otherwise\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_pcidev_by_busidstring (\fBhwloc_topology_t\fP topology, const char * busid)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Find the PCI device object matching the PCI bus id given as a string xxxx:yy:zz\&.t or yy:zz\&.t\&. 
+.PP
+\fBReturns\fP
+.RS 4
+a matching PCI device object if any, \fCNULL\fP otherwise\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_api_error_reporting.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_api_error_reporting.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_api_error_reporting.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_api_error_reporting.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,18 @@
+.TH "hwlocality_api_error_reporting" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_api_error_reporting \- Error reporting in the API
+.SH SYNOPSIS
+.br
+.PP
+.SH "Detailed Description"
+.PP 
+Most functions in the hwloc API return an integer value\&. Unless documentated differently, they return 0 on success and -1 on error\&. Functions that return a pointer type return \fCNULL\fP on error\&.
+.PP
+\fCerrno\fP will be set to a meaningful value whenever possible\&. This includes the usual \fCEINVAL\fP when invalid function parameters are passed or \fCENOMEM\fP when an internal allocation fails\&. Some specific \fCerrno\fP value are also used, for instance for binding errors as documented in \fBCPU binding\fP\&.
+.PP
+Some modules describe return values of their functions in their introduction, for instance in \fBThe bitmap API\fP\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_api_version.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_api_version.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_api_version.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_api_version.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,63 @@
+.TH "hwlocality_api_version" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_api_version \- API version
+.SH SYNOPSIS
+.br
+.PP
+.SS "Macros"
+
+.in +1c
+.ti -1c
+.RI "#define \fBHWLOC_API_VERSION\fP   0x00020b00"
+.br
+.ti -1c
+.RI "#define \fBHWLOC_COMPONENT_ABI\fP   7"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "unsigned \fBhwloc_get_api_version\fP (void)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Macro Definition Documentation"
+.PP 
+.SS "#define HWLOC_API_VERSION   0x00020b00"
+
+.PP
+Indicate at build time which hwloc API version is being used\&. This number is updated to (X<<16)+(Y<<8)+Z when a new release X\&.Y\&.Z actually modifies the API\&.
+.PP
+Users may check for available features at build time using this number (see \fBHow do I handle API changes?\fP)\&.
+.PP
+\fBNote\fP
+.RS 4
+This should not be confused with HWLOC_VERSION, the library version\&. Two stable releases of the same series usually have the same \fBHWLOC_API_VERSION\fP even if their HWLOC_VERSION are different\&. 
+.RE
+.PP
+
+.SS "#define HWLOC_COMPONENT_ABI   7"
+
+.PP
+Current component and plugin ABI version (see \fBhwloc/plugins\&.h\fP) 
+.SH "Function Documentation"
+.PP 
+.SS "unsigned hwloc_get_api_version (void)"
+
+.PP
+Indicate at runtime which hwloc API version was used at build time\&. Should be \fBHWLOC_API_VERSION\fP if running on the same version\&.
+.PP
+\fBReturns\fP
+.RS 4
+the build-time version number\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_bitmap.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_bitmap.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_bitmap.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_bitmap.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,723 @@
+.TH "hwlocality_bitmap" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_bitmap \- The bitmap API
+.SH SYNOPSIS
+.br
+.PP
+.SS "Macros"
+
+.in +1c
+.ti -1c
+.RI "#define \fBhwloc_bitmap_foreach_begin\fP(id,  bitmap)"
+.br
+.ti -1c
+.RI "#define \fBhwloc_bitmap_foreach_end\fP()"
+.br
+.in -1c
+.SS "Typedefs"
+
+.in +1c
+.ti -1c
+.RI "typedef struct hwloc_bitmap_s * \fBhwloc_bitmap_t\fP"
+.br
+.ti -1c
+.RI "typedef const struct hwloc_bitmap_s * \fBhwloc_const_bitmap_t\fP"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_bitmap_t\fP \fBhwloc_bitmap_alloc\fP (void)"
+.br
+.ti -1c
+.RI "\fBhwloc_bitmap_t\fP \fBhwloc_bitmap_alloc_full\fP (void)"
+.br
+.ti -1c
+.RI "void \fBhwloc_bitmap_free\fP (\fBhwloc_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "\fBhwloc_bitmap_t\fP \fBhwloc_bitmap_dup\fP (\fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_copy\fP (\fBhwloc_bitmap_t\fP dst, \fBhwloc_const_bitmap_t\fP src)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_snprintf\fP (char *restrict buf, size_t buflen, \fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_asprintf\fP (char **strp, \fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_sscanf\fP (\fBhwloc_bitmap_t\fP bitmap, const char *restrict string)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_list_snprintf\fP (char *restrict buf, size_t buflen, \fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_list_asprintf\fP (char **strp, \fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_list_sscanf\fP (\fBhwloc_bitmap_t\fP bitmap, const char *restrict string)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_taskset_snprintf\fP (char *restrict buf, size_t buflen, \fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_taskset_asprintf\fP (char **strp, \fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_taskset_sscanf\fP (\fBhwloc_bitmap_t\fP bitmap, const char *restrict string)"
+.br
+.ti -1c
+.RI "void \fBhwloc_bitmap_zero\fP (\fBhwloc_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "void \fBhwloc_bitmap_fill\fP (\fBhwloc_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_only\fP (\fBhwloc_bitmap_t\fP bitmap, unsigned id)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_allbut\fP (\fBhwloc_bitmap_t\fP bitmap, unsigned id)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_from_ulong\fP (\fBhwloc_bitmap_t\fP bitmap, unsigned long mask)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_from_ith_ulong\fP (\fBhwloc_bitmap_t\fP bitmap, unsigned i, unsigned long mask)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_from_ulongs\fP (\fBhwloc_bitmap_t\fP bitmap, unsigned nr, const unsigned long *masks)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_set\fP (\fBhwloc_bitmap_t\fP bitmap, unsigned id)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_set_range\fP (\fBhwloc_bitmap_t\fP bitmap, unsigned begin, int end)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_set_ith_ulong\fP (\fBhwloc_bitmap_t\fP bitmap, unsigned i, unsigned long mask)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_clr\fP (\fBhwloc_bitmap_t\fP bitmap, unsigned id)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_clr_range\fP (\fBhwloc_bitmap_t\fP bitmap, unsigned begin, int end)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_singlify\fP (\fBhwloc_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "unsigned long \fBhwloc_bitmap_to_ulong\fP (\fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "unsigned long \fBhwloc_bitmap_to_ith_ulong\fP (\fBhwloc_const_bitmap_t\fP bitmap, unsigned i)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_to_ulongs\fP (\fBhwloc_const_bitmap_t\fP bitmap, unsigned nr, unsigned long *masks)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_nr_ulongs\fP (\fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_isset\fP (\fBhwloc_const_bitmap_t\fP bitmap, unsigned id)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_iszero\fP (\fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_isfull\fP (\fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_first\fP (\fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_next\fP (\fBhwloc_const_bitmap_t\fP bitmap, int prev)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_last\fP (\fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_weight\fP (\fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_first_unset\fP (\fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_next_unset\fP (\fBhwloc_const_bitmap_t\fP bitmap, int prev)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_last_unset\fP (\fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_or\fP (\fBhwloc_bitmap_t\fP res, \fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_and\fP (\fBhwloc_bitmap_t\fP res, \fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_andnot\fP (\fBhwloc_bitmap_t\fP res, \fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_xor\fP (\fBhwloc_bitmap_t\fP res, \fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_not\fP (\fBhwloc_bitmap_t\fP res, \fBhwloc_const_bitmap_t\fP bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_intersects\fP (\fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_isincluded\fP (\fBhwloc_const_bitmap_t\fP sub_bitmap, \fBhwloc_const_bitmap_t\fP super_bitmap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_isequal\fP (\fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_compare_first\fP (\fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+.br
+.ti -1c
+.RI "int \fBhwloc_bitmap_compare\fP (\fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+The \fBhwloc_bitmap_t\fP type represents a set of integers (positive or null)\&. A bitmap may be of infinite size (all bits are set after some point)\&. A bitmap may even be full if all bits are set\&.
+.PP
+Bitmaps are used by hwloc for sets of OS processors (which may actually be hardware threads) as by \fBhwloc_cpuset_t\fP (a typedef for \fBhwloc_bitmap_t\fP), or sets of NUMA memory nodes as \fBhwloc_nodeset_t\fP (also a typedef for \fBhwloc_bitmap_t\fP)\&. Those are used for cpuset and nodeset fields in the \fBhwloc_obj\fP structure, see \fBObject Sets (hwloc_cpuset_t and hwloc_nodeset_t)\fP\&.
+.PP
+\fIBoth CPU and node sets are always indexed by OS physical number\&.\fP However users should usually not build CPU and node sets manually (e\&.g\&. with \fBhwloc_bitmap_set()\fP)\&. One should rather use existing object sets and combine them with \fBhwloc_bitmap_or()\fP, etc\&. For instance, binding the current thread on a pair of cores may be performed with: 
+.PP
+.nf
+hwloc_obj_t core1 = \&.\&.\&. , core2 = \&.\&.\&. ;
+hwloc_bitmap_t set = hwloc_bitmap_alloc();
+hwloc_bitmap_or(set, core1\->cpuset, core2\->cpuset);
+hwloc_set_cpubind(topology, set, HWLOC_CPUBIND_THREAD);
+hwloc_bitmap_free(set);
+
+.fi
+.PP
+.PP
+\fBNote\fP
+.RS 4
+Most functions below return 0 on success and -1 on error\&. The usual error case would be an internal failure to realloc/extend the storage of the bitmap (\fCerrno\fP would be set to \fCENOMEM\fP)\&. See also \fBError reporting in the API\fP\&.
+.PP
+Several examples of using the bitmap API are available under the doc/examples/ directory in the source tree\&. Regression tests such as tests/hwloc/hwloc_bitmap*\&.c also make intensive use of this API\&. 
+.RE
+.PP
+
+.SH "Macro Definition Documentation"
+.PP 
+.SS "#define hwloc_bitmap_foreach_begin(id, bitmap)"
+
+.PP
+Loop macro iterating on bitmap \fCbitmap\fP\&. The loop must start with \fBhwloc_bitmap_foreach_begin()\fP and end with \fBhwloc_bitmap_foreach_end()\fP followed by a terminating ';'\&.
+.PP
+\fCid\fP is the loop variable; it should be an unsigned int\&. The first iteration will set \fCid\fP to the lowest index in the bitmap\&. Successive iterations will iterate through, in order, all remaining indexes set in the bitmap\&. To be specific: each iteration will return a value for \fCid\fP such that hwloc_bitmap_isset(bitmap, id) is true\&.
+.PP
+The assert prevents the loop from being infinite if the bitmap is infinitely set\&. 
+.SS "#define hwloc_bitmap_foreach_end()"
+
+.PP
+End of loop macro iterating on a bitmap\&. Needs a terminating ';'\&.
+.PP
+\fBSee also\fP
+.RS 4
+\fBhwloc_bitmap_foreach_begin()\fP 
+.RE
+.PP
+
+.SH "Typedef Documentation"
+.PP 
+.SS "typedef struct hwloc_bitmap_s* \fBhwloc_bitmap_t\fP"
+
+.PP
+Set of bits represented as an opaque pointer to an internal bitmap\&. 
+.SS "typedef const struct hwloc_bitmap_s* \fBhwloc_const_bitmap_t\fP"
+
+.PP
+a non-modifiable \fBhwloc_bitmap_t\fP 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_bitmap_allbut (\fBhwloc_bitmap_t\fP bitmap, unsigned id)"
+
+.PP
+Fill the bitmap \fCand\fP clear the index \fCid\fP\&. 
+.SS "\fBhwloc_bitmap_t\fP hwloc_bitmap_alloc (void)"
+
+.PP
+Allocate a new empty bitmap\&. 
+.PP
+\fBReturns\fP
+.RS 4
+A valid bitmap or \fCNULL\fP\&.
+.RE
+.PP
+The bitmap should be freed by a corresponding call to \fBhwloc_bitmap_free()\fP\&. 
+.SS "\fBhwloc_bitmap_t\fP hwloc_bitmap_alloc_full (void)"
+
+.PP
+Allocate a new full bitmap\&. 
+.PP
+\fBReturns\fP
+.RS 4
+A valid bitmap or \fCNULL\fP\&.
+.RE
+.PP
+The bitmap should be freed by a corresponding call to \fBhwloc_bitmap_free()\fP\&. 
+.SS "int hwloc_bitmap_and (\fBhwloc_bitmap_t\fP res, \fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+
+.PP
+And bitmaps \fCbitmap1\fP and \fCbitmap2\fP and store the result in bitmap \fCres\fP\&. \fCres\fP can be the same as \fCbitmap1\fP or \fCbitmap2\fP 
+.SS "int hwloc_bitmap_andnot (\fBhwloc_bitmap_t\fP res, \fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+
+.PP
+And bitmap \fCbitmap1\fP and the negation of \fCbitmap2\fP and store the result in bitmap \fCres\fP\&. \fCres\fP can be the same as \fCbitmap1\fP or \fCbitmap2\fP 
+.SS "int hwloc_bitmap_asprintf (char ** strp, \fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Stringify a bitmap into a newly allocated string\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_clr (\fBhwloc_bitmap_t\fP bitmap, unsigned id)"
+
+.PP
+Remove index \fCid\fP from bitmap \fCbitmap\fP\&. 
+.SS "int hwloc_bitmap_clr_range (\fBhwloc_bitmap_t\fP bitmap, unsigned begin, int end)"
+
+.PP
+Remove indexes from \fCbegin\fP to \fCend\fP in bitmap \fCbitmap\fP\&. If \fCend\fP is \fC-1\fP, the range is infinite\&. 
+.SS "int hwloc_bitmap_compare (\fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+
+.PP
+Compare bitmaps \fCbitmap1\fP and \fCbitmap2\fP in lexicographic order\&. Lexicographic comparison of bitmaps, starting for their highest indexes\&. Compare last indexes first, then second, etc\&. The empty bitmap is considered lower than anything\&.
+.PP
+\fBReturns\fP
+.RS 4
+-1 if \fCbitmap1\fP is considered smaller than \fCbitmap2\fP\&. 
+.PP
+1 if \fCbitmap1\fP is considered larger than \fCbitmap2\fP\&. 
+.PP
+0 if bitmaps are equal (contrary to \fBhwloc_bitmap_compare_first()\fP)\&.
+.RE
+.PP
+For instance comparing binary bitmaps 0011 and 0110 returns -1 (hence 0011 is considered smaller than 0110)\&. Comparing 00101 and 01010 returns -1 too\&.
+.PP
+\fBNote\fP
+.RS 4
+This is different from the non-existing hwloc_bitmap_compare_last() which would only compare the highest index of each bitmap\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_compare_first (\fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+
+.PP
+Compare bitmaps \fCbitmap1\fP and \fCbitmap2\fP using their lowest index\&. A bitmap is considered smaller if its least significant bit is smaller\&. The empty bitmap is considered higher than anything (because its least significant bit does not exist)\&.
+.PP
+\fBReturns\fP
+.RS 4
+-1 if \fCbitmap1\fP is considered smaller than \fCbitmap2\fP\&. 
+.PP
+1 if \fCbitmap1\fP is considered larger than \fCbitmap2\fP\&.
+.RE
+.PP
+For instance comparing binary bitmaps 0011 and 0110 returns -1 (hence 0011 is considered smaller than 0110) because least significant bit of 0011 (0001) is smaller than least significant bit of 0110 (0010)\&. Comparing 01001 and 00110 would also return -1 for the same reason\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 if bitmaps are considered equal, even if they are not strictly equal\&. They just need to have the same least significant bit\&. For instance, comparing binary bitmaps 0010 and 0110 returns 0 because they have the same least significant bit\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_copy (\fBhwloc_bitmap_t\fP dst, \fBhwloc_const_bitmap_t\fP src)"
+
+.PP
+Copy the contents of bitmap \fCsrc\fP into the already allocated bitmap \fCdst\fP\&. 
+.SS "\fBhwloc_bitmap_t\fP hwloc_bitmap_dup (\fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Duplicate bitmap \fCbitmap\fP by allocating a new bitmap and copying \fCbitmap\fP contents\&. If \fCbitmap\fP is \fCNULL\fP, \fCNULL\fP is returned\&. 
+.SS "void hwloc_bitmap_fill (\fBhwloc_bitmap_t\fP bitmap)"
+
+.PP
+Fill bitmap \fCbitmap\fP with all possible indexes (even if those objects don't exist or are otherwise unavailable) 
+.SS "int hwloc_bitmap_first (\fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Compute the first index (least significant bit) in bitmap \fCbitmap\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the first index set in \fCbitmap\fP\&. 
+.PP
+-1 if \fCbitmap\fP is empty\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_first_unset (\fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Compute the first unset index (least significant bit) in bitmap \fCbitmap\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the first unset index in \fCbitmap\fP\&. 
+.PP
+-1 if \fCbitmap\fP is full\&. 
+.RE
+.PP
+
+.SS "void hwloc_bitmap_free (\fBhwloc_bitmap_t\fP bitmap)"
+
+.PP
+Free bitmap \fCbitmap\fP\&. If \fCbitmap\fP is \fCNULL\fP, no operation is performed\&. 
+.SS "int hwloc_bitmap_from_ith_ulong (\fBhwloc_bitmap_t\fP bitmap, unsigned i, unsigned long mask)"
+
+.PP
+Setup bitmap \fCbitmap\fP from unsigned long \fCmask\fP used as \fCi\fP -th subset\&. 
+.SS "int hwloc_bitmap_from_ulong (\fBhwloc_bitmap_t\fP bitmap, unsigned long mask)"
+
+.PP
+Setup bitmap \fCbitmap\fP from unsigned long \fCmask\fP\&. 
+.SS "int hwloc_bitmap_from_ulongs (\fBhwloc_bitmap_t\fP bitmap, unsigned nr, const unsigned long * masks)"
+
+.PP
+Setup bitmap \fCbitmap\fP from unsigned longs \fCmasks\fP used as first \fCnr\fP subsets\&. 
+.SS "int hwloc_bitmap_intersects (\fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+
+.PP
+Test whether bitmaps \fCbitmap1\fP and \fCbitmap2\fP intersects\&. 
+.PP
+\fBReturns\fP
+.RS 4
+1 if bitmaps intersect, 0 otherwise\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+The empty bitmap does not intersect any other bitmap\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_isequal (\fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+
+.PP
+Test whether bitmap \fCbitmap1\fP is equal to bitmap \fCbitmap2\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+1 if bitmaps are equal, 0 otherwise\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_isfull (\fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Test whether bitmap \fCbitmap\fP is completely full\&. 
+.PP
+\fBReturns\fP
+.RS 4
+1 if bitmap is full, 0 otherwise\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+A full bitmap is always infinitely set\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_isincluded (\fBhwloc_const_bitmap_t\fP sub_bitmap, \fBhwloc_const_bitmap_t\fP super_bitmap)"
+
+.PP
+Test whether bitmap \fCsub_bitmap\fP is part of bitmap \fCsuper_bitmap\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+1 if \fCsub_bitmap\fP is included in \fCsuper_bitmap\fP, 0 otherwise\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+The empty bitmap is considered included in any other bitmap\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_isset (\fBhwloc_const_bitmap_t\fP bitmap, unsigned id)"
+
+.PP
+Test whether index \fCid\fP is part of bitmap \fCbitmap\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+1 if the bit at index \fCid\fP is set in bitmap \fCbitmap\fP, 0 otherwise\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_iszero (\fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Test whether bitmap \fCbitmap\fP is empty\&. 
+.PP
+\fBReturns\fP
+.RS 4
+1 if bitmap is empty, 0 otherwise\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_last (\fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Compute the last index (most significant bit) in bitmap \fCbitmap\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the last index set in \fCbitmap\fP\&. 
+.PP
+-1 if \fCbitmap\fP is empty, or if \fCbitmap\fP is infinitely set\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_last_unset (\fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Compute the last unset index (most significant bit) in bitmap \fCbitmap\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the last index unset in \fCbitmap\fP\&. 
+.PP
+-1 if \fCbitmap\fP is full, or if \fCbitmap\fP is not infinitely set\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_list_asprintf (char ** strp, \fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Stringify a bitmap into a newly allocated list string\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_list_snprintf (char *restrict buf, size_t buflen, \fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Stringify a bitmap in the list format\&. Lists are comma-separated indexes or ranges\&. Ranges are dash separated indexes\&. The last range may not have an ending indexes if the bitmap is infinitely set\&.
+.PP
+Up to \fCbuflen\fP characters may be written in buffer \fCbuf\fP\&.
+.PP
+If \fCbuflen\fP is 0, \fCbuf\fP may safely be \fCNULL\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+the number of characters that were actually written if not truncating, or that would have been written (not including the ending \\0)\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_list_sscanf (\fBhwloc_bitmap_t\fP bitmap, const char *restrict string)"
+
+.PP
+Parse a list string and stores it in bitmap \fCbitmap\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_next (\fBhwloc_const_bitmap_t\fP bitmap, int prev)"
+
+.PP
+Compute the next index in bitmap \fCbitmap\fP which is after index \fCprev\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the first index set in \fCbitmap\fP if \fCprev\fP is \fC-1\fP\&. 
+.PP
+the next index set in \fCbitmap\fP if \fCprev\fP is not \fC-1\fP\&. 
+.PP
+-1 if no index with higher index is set in \fCbitmap\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_next_unset (\fBhwloc_const_bitmap_t\fP bitmap, int prev)"
+
+.PP
+Compute the next unset index in bitmap \fCbitmap\fP which is after index \fCprev\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the first index unset in \fCbitmap\fP if \fCprev\fP is \fC-1\fP\&. 
+.PP
+the next index unset in \fCbitmap\fP if \fCprev\fP is not \fC-1\fP\&. 
+.PP
+-1 if no index with higher index is unset in \fCbitmap\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_not (\fBhwloc_bitmap_t\fP res, \fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Negate bitmap \fCbitmap\fP and store the result in bitmap \fCres\fP\&. \fCres\fP can be the same as \fCbitmap\fP 
+.SS "int hwloc_bitmap_nr_ulongs (\fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Return the number of unsigned longs required for storing bitmap \fCbitmap\fP entirely\&. This is the number of contiguous unsigned longs from the very first bit of the bitmap (even if unset) up to the last set bit\&. This is useful for knowing the \fCnr\fP parameter to pass to \fBhwloc_bitmap_to_ulongs()\fP (or which calls to \fBhwloc_bitmap_to_ith_ulong()\fP are needed) to entirely convert a bitmap into multiple unsigned longs\&.
+.PP
+When called on the output of \fBhwloc_topology_get_topology_cpuset()\fP, the returned number is large enough for all cpusets of the topology\&.
+.PP
+\fBReturns\fP
+.RS 4
+the number of unsigned longs required\&. 
+.PP
+-1 if \fCbitmap\fP is infinite\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_only (\fBhwloc_bitmap_t\fP bitmap, unsigned id)"
+
+.PP
+Empty the bitmap \fCbitmap\fP and add bit \fCid\fP\&. 
+.SS "int hwloc_bitmap_or (\fBhwloc_bitmap_t\fP res, \fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+
+.PP
+Or bitmaps \fCbitmap1\fP and \fCbitmap2\fP and store the result in bitmap \fCres\fP\&. \fCres\fP can be the same as \fCbitmap1\fP or \fCbitmap2\fP 
+.SS "int hwloc_bitmap_set (\fBhwloc_bitmap_t\fP bitmap, unsigned id)"
+
+.PP
+Add index \fCid\fP in bitmap \fCbitmap\fP\&. 
+.SS "int hwloc_bitmap_set_ith_ulong (\fBhwloc_bitmap_t\fP bitmap, unsigned i, unsigned long mask)"
+
+.PP
+Replace \fCi\fP -th subset of bitmap \fCbitmap\fP with unsigned long \fCmask\fP\&. 
+.SS "int hwloc_bitmap_set_range (\fBhwloc_bitmap_t\fP bitmap, unsigned begin, int end)"
+
+.PP
+Add indexes from \fCbegin\fP to \fCend\fP in bitmap \fCbitmap\fP\&. If \fCend\fP is \fC-1\fP, the range is infinite\&. 
+.SS "int hwloc_bitmap_singlify (\fBhwloc_bitmap_t\fP bitmap)"
+
+.PP
+Keep a single index among those set in bitmap \fCbitmap\fP\&. May be useful before binding so that the process does not have a chance of migrating between multiple processors in the original mask\&. Instead of running the task on any PU inside the given CPU set, the operating system scheduler will be forced to run it on a single of these PUs\&. It avoids a migration overhead and cache-line ping-pongs between PUs\&.
+.PP
+\fBNote\fP
+.RS 4
+This function is NOT meant to distribute multiple processes within a single CPU set\&. It always return the same single bit when called multiple times on the same input set\&. \fBhwloc_distrib()\fP may be used for generating CPU sets to distribute multiple tasks below a single multi-PU object\&.
+.PP
+This function cannot be applied to an object set directly\&. It should be applied to a copy (which may be obtained with \fBhwloc_bitmap_dup()\fP)\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_snprintf (char *restrict buf, size_t buflen, \fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Stringify a bitmap\&. Up to \fCbuflen\fP characters may be written in buffer \fCbuf\fP\&.
+.PP
+If \fCbuflen\fP is 0, \fCbuf\fP may safely be \fCNULL\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+the number of characters that were actually written if not truncating, or that would have been written (not including the ending \\0)\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_sscanf (\fBhwloc_bitmap_t\fP bitmap, const char *restrict string)"
+
+.PP
+Parse a bitmap string and stores it in bitmap \fCbitmap\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_taskset_asprintf (char ** strp, \fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Stringify a bitmap into a newly allocated taskset-specific string\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_taskset_snprintf (char *restrict buf, size_t buflen, \fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Stringify a bitmap in the taskset-specific format\&. The taskset command manipulates bitmap strings that contain a single (possible very long) hexadecimal number starting with 0x\&.
+.PP
+Up to \fCbuflen\fP characters may be written in buffer \fCbuf\fP\&.
+.PP
+If \fCbuflen\fP is 0, \fCbuf\fP may safely be \fCNULL\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+the number of characters that were actually written if not truncating, or that would have been written (not including the ending \\0)\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_taskset_sscanf (\fBhwloc_bitmap_t\fP bitmap, const char *restrict string)"
+
+.PP
+Parse a taskset-specific bitmap string and stores it in bitmap \fCbitmap\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "unsigned long hwloc_bitmap_to_ith_ulong (\fBhwloc_const_bitmap_t\fP bitmap, unsigned i)"
+
+.PP
+Convert the \fCi\fP -th subset of bitmap \fCbitmap\fP into unsigned long mask\&. 
+.SS "unsigned long hwloc_bitmap_to_ulong (\fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Convert the beginning part of bitmap \fCbitmap\fP into unsigned long \fCmask\fP\&. 
+.SS "int hwloc_bitmap_to_ulongs (\fBhwloc_const_bitmap_t\fP bitmap, unsigned nr, unsigned long * masks)"
+
+.PP
+Convert the first \fCnr\fP subsets of bitmap \fCbitmap\fP into the array of \fCnr\fP unsigned long \fCmasks\fP\&. \fCnr\fP may be determined earlier with \fBhwloc_bitmap_nr_ulongs()\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_weight (\fBhwloc_const_bitmap_t\fP bitmap)"
+
+.PP
+Compute the 'weight' of bitmap \fCbitmap\fP (i\&.e\&., number of indexes that are in the bitmap)\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the number of indexes that are in the bitmap\&. 
+.PP
+-1 if \fCbitmap\fP is infinitely set\&. 
+.RE
+.PP
+
+.SS "int hwloc_bitmap_xor (\fBhwloc_bitmap_t\fP res, \fBhwloc_const_bitmap_t\fP bitmap1, \fBhwloc_const_bitmap_t\fP bitmap2)"
+
+.PP
+Xor bitmaps \fCbitmap1\fP and \fCbitmap2\fP and store the result in bitmap \fCres\fP\&. \fCres\fP can be the same as \fCbitmap1\fP or \fCbitmap2\fP 
+.SS "void hwloc_bitmap_zero (\fBhwloc_bitmap_t\fP bitmap)"
+
+.PP
+Empty the bitmap \fCbitmap\fP\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_components_core_funcs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_components_core_funcs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_components_core_funcs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_components_core_funcs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,147 @@
+.TH "hwlocality_components_core_funcs" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_components_core_funcs \- Components and Plugins: Core functions to be used by components
+.SH SYNOPSIS
+.br
+.PP
+.SS "Macros"
+
+.in +1c
+.ti -1c
+.RI "#define \fBHWLOC_SHOW_CRITICAL_ERRORS\fP()   (\fBhwloc_hide_errors\fP() < 2)"
+.br
+.ti -1c
+.RI "#define \fBHWLOC_SHOW_ALL_ERRORS\fP()   (\fBhwloc_hide_errors\fP() == 0)"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_hide_errors\fP (void)"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_t\fP \fBhwloc__insert_object_by_cpuset\fP (struct hwloc_topology *topology, \fBhwloc_obj_t\fP root, \fBhwloc_obj_t\fP obj, const char *reason)"
+.br
+.ti -1c
+.RI "void \fBhwloc_insert_object_by_parent\fP (struct hwloc_topology *topology, \fBhwloc_obj_t\fP parent, \fBhwloc_obj_t\fP obj)"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_t\fP \fBhwloc_alloc_setup_object\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, unsigned os_index)"
+.br
+.ti -1c
+.RI "int \fBhwloc_obj_add_children_sets\fP (\fBhwloc_obj_t\fP obj)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_reconnect\fP (\fBhwloc_topology_t\fP topology, unsigned long flags)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_plugin_check_namespace\fP (const char *pluginname, const char *symbol)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.PP
+\fBNote\fP
+.RS 4
+These structures and functions may change when \fBHWLOC_COMPONENT_ABI\fP is modified\&. 
+.RE
+.PP
+
+.SH "Macro Definition Documentation"
+.PP 
+.SS "#define HWLOC_SHOW_ALL_ERRORS()   (\fBhwloc_hide_errors\fP() == 0)"
+
+.SS "#define HWLOC_SHOW_CRITICAL_ERRORS()   (\fBhwloc_hide_errors\fP() < 2)"
+
+.SH "Function Documentation"
+.PP 
+.SS "\fBhwloc_obj_t\fP hwloc__insert_object_by_cpuset (struct hwloc_topology * topology, \fBhwloc_obj_t\fP root, \fBhwloc_obj_t\fP obj, const char * reason)"
+
+.PP
+Add an object to the topology\&. Insert new object \fCobj\fP in the topology starting under existing object \fCroot\fP (if \fCNULL\fP, the topology root object is used)\&.
+.PP
+It is sorted along the tree of other objects according to the inclusion of cpusets, to eventually be added as a child of the smallest object including this object\&.
+.PP
+If the cpuset is empty, the type of the object (and maybe some attributes) must be enough to find where to insert the object\&. This is especially true for NUMA nodes with memory and no CPUs\&.
+.PP
+The given object should not have children\&.
+.PP
+This shall only be called before levels are built\&.
+.PP
+The caller should check whether the object type is filtered-out before calling this function\&.
+.PP
+The topology cpuset/nodesets will be enlarged to include the object sets\&.
+.PP
+\fCreason\fP is a unique string identifying where and why this insertion call was performed (it will be displayed in case of internal insertion error)\&.
+.PP
+Returns the object on success\&. Returns NULL and frees obj on error\&. Returns another object and frees obj if it was merged with an identical pre-existing object\&. 
+.SS "\fBhwloc_obj_t\fP hwloc_alloc_setup_object (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, unsigned os_index)"
+
+.PP
+Allocate and initialize an object of the given type and physical index\&. If \fCos_index\fP is unknown or irrelevant, use \fCHWLOC_UNKNOWN_INDEX\fP\&. 
+.SS "int hwloc_hide_errors (void)"
+
+.PP
+Check whether error messages are hidden\&. Callers should print critical error messages (e\&.g\&. invalid hw topo info, invalid config) only if this function returns strictly less than 2\&.
+.PP
+Callers should print non-critical error messages (e\&.g\&. failure to initialize CUDA) if this function returns 0\&.
+.PP
+This function return 1 by default (show critical only), 0 in lstopo (show all), or anything set in HWLOC_HIDE_ERRORS in the environment\&.
+.PP
+Use macros \fBHWLOC_SHOW_CRITICAL_ERRORS()\fP and \fBHWLOC_SHOW_ALL_ERRORS()\fP for clarity\&. 
+.SS "void hwloc_insert_object_by_parent (struct hwloc_topology * topology, \fBhwloc_obj_t\fP parent, \fBhwloc_obj_t\fP obj)"
+
+.PP
+Insert an object somewhere in the topology\&. It is added as the last child of the given parent\&. The cpuset is completely ignored, so strange objects such as I/O devices should preferably be inserted with this\&.
+.PP
+When used for 'normal' children with cpusets (when importing from XML when duplicating a topology), the caller should make sure that:
+.IP "\(bu" 2
+children are inserted in order,
+.IP "\(bu" 2
+children cpusets do not intersect\&.
+.PP
+.PP
+The given object may have normal, I/O or Misc children, as long as they are in order as well\&. These children must have valid parent and next_sibling pointers\&.
+.PP
+The caller should check whether the object type is filtered-out before calling this function\&. 
+.SS "int hwloc_obj_add_children_sets (\fBhwloc_obj_t\fP obj)"
+
+.PP
+Setup object cpusets/nodesets by OR'ing its children\&. Used when adding an object late in the topology\&. Will update the new object by OR'ing all its new children sets\&.
+.PP
+Used when PCI backend adds a hostbridge parent, when distances add a new Group, etc\&. 
+.SS "static int hwloc_plugin_check_namespace (const char * pluginname, const char * symbol)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Make sure that plugins can lookup core symbols\&. This is a sanity check to avoid lazy-lookup failures when libhwloc is loaded within a plugin, and later tries to load its own plugins\&. This may fail (and abort the program) if libhwloc symbols are in a private namespace\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 if the plugin cannot be successfully loaded\&. The caller plugin init() callback should return a negative error code as well\&.
+.RE
+.PP
+Plugins should call this function in their init() callback to avoid later crashes if lazy symbol resolution is used by the upper layer that loaded hwloc (e\&.g\&. OpenCL implementations using dlopen with RTLD_LAZY)\&.
+.PP
+\fBNote\fP
+.RS 4
+The build system must define HWLOC_INSIDE_PLUGIN if and only if building the caller as a plugin\&.
+.PP
+This function should remain inline so plugins can call it even when they cannot find libhwloc symbols\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_reconnect (\fBhwloc_topology_t\fP topology, unsigned long flags)"
+
+.PP
+Request a reconnection of children and levels in the topology\&. May be used by backends during discovery if they need arrays or lists of object within levels or children to be fully connected\&.
+.PP
+\fCflags\fP is currently unused, must 0\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_components_filtering.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_components_filtering.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_components_filtering.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_components_filtering.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,83 @@
+.TH "hwlocality_components_filtering" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_components_filtering \- Components and Plugins: Filtering objects
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_filter_check_pcidev_subtype_important\fP (unsigned classid)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_filter_check_osdev_subtype_important\fP (\fBhwloc_obj_osdev_type_t\fP subtype)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_filter_check_keep_object_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_filter_check_keep_object\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.PP
+\fBNote\fP
+.RS 4
+These structures and functions may change when \fBHWLOC_COMPONENT_ABI\fP is modified\&. 
+.RE
+.PP
+
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_filter_check_keep_object (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Check whether the given object should be filtered-out\&. 
+.PP
+\fBReturns\fP
+.RS 4
+1 if the object type should be kept, 0 otherwise\&. 
+.RE
+.PP
+
+.SS "static int hwloc_filter_check_keep_object_type (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Check whether a non-I/O object type should be filtered-out\&. Cannot be used for I/O objects\&.
+.PP
+\fBReturns\fP
+.RS 4
+1 if the object type should be kept, 0 otherwise\&. 
+.RE
+.PP
+
+.SS "static int hwloc_filter_check_osdev_subtype_important (\fBhwloc_obj_osdev_type_t\fP subtype)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Check whether the given OS device subtype is important\&. 
+.PP
+\fBReturns\fP
+.RS 4
+1 if important, 0 otherwise\&. 
+.RE
+.PP
+
+.SS "static int hwloc_filter_check_pcidev_subtype_important (unsigned classid)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Check whether the given PCI device classid is important\&. 
+.PP
+\fBReturns\fP
+.RS 4
+1 if important, 0 otherwise\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_components_pcidisc.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_components_pcidisc.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_components_pcidisc.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_components_pcidisc.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,71 @@
+.TH "hwlocality_components_pcidisc" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_components_pcidisc \- Components and Plugins: helpers for PCI discovery
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "unsigned \fBhwloc_pcidisc_find_cap\fP (const unsigned char *config, unsigned cap)"
+.br
+.ti -1c
+.RI "int \fBhwloc_pcidisc_find_linkspeed\fP (const unsigned char *config, unsigned offset, float *linkspeed)"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_type_t\fP \fBhwloc_pcidisc_check_bridge_type\fP (unsigned device_class, const unsigned char *config)"
+.br
+.ti -1c
+.RI "int \fBhwloc_pcidisc_find_bridge_buses\fP (unsigned domain, unsigned bus, unsigned dev, unsigned func, unsigned *secondary_busp, unsigned *subordinate_busp, const unsigned char *config)"
+.br
+.ti -1c
+.RI "void \fBhwloc_pcidisc_tree_insert_by_busid\fP (struct \fBhwloc_obj\fP **treep, struct \fBhwloc_obj\fP *obj)"
+.br
+.ti -1c
+.RI "int \fBhwloc_pcidisc_tree_attach\fP (struct hwloc_topology *topology, struct \fBhwloc_obj\fP *tree)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.PP
+\fBNote\fP
+.RS 4
+These structures and functions may change when \fBHWLOC_COMPONENT_ABI\fP is modified\&. 
+.RE
+.PP
+
+.SH "Function Documentation"
+.PP 
+.SS "\fBhwloc_obj_type_t\fP hwloc_pcidisc_check_bridge_type (unsigned device_class, const unsigned char * config)"
+
+.PP
+Return the hwloc object type (PCI device or Bridge) for the given class and configuration space\&. This function requires 16 bytes of common configuration header at the beginning of config\&. 
+.SS "int hwloc_pcidisc_find_bridge_buses (unsigned domain, unsigned bus, unsigned dev, unsigned func, unsigned * secondary_busp, unsigned * subordinate_busp, const unsigned char * config)"
+
+.PP
+Fills the attributes of the given PCI bridge using the given PCI config space\&. This function requires 32 bytes of common configuration header at the beginning of config\&.
+.PP
+Returns -1 and destroys /p obj if bridge fields are invalid\&. 
+.SS "unsigned hwloc_pcidisc_find_cap (const unsigned char * config, unsigned cap)"
+
+.PP
+Return the offset of the given capability in the PCI config space buffer\&. This function requires a 256-bytes config space\&. Unknown/unavailable bytes should be set to 0xff\&. 
+.SS "int hwloc_pcidisc_find_linkspeed (const unsigned char * config, unsigned offset, float * linkspeed)"
+
+.PP
+Fill linkspeed by reading the PCI config space where PCI_CAP_ID_EXP is at position offset\&. Needs 20 bytes of EXP capability block starting at offset in the config space for registers up to link status\&. 
+.SS "int hwloc_pcidisc_tree_attach (struct hwloc_topology * topology, struct \fBhwloc_obj\fP * tree)"
+
+.PP
+Add some hostbridges on top of the given tree of PCI objects and attach them to the topology\&. Other backends may lookup PCI objects or localities (for instance to attach OS devices) by using hwloc_pcidisc_find_by_busid() or hwloc_pcidisc_find_busid_parent()\&. 
+.SS "void hwloc_pcidisc_tree_insert_by_busid (struct \fBhwloc_obj\fP ** treep, struct \fBhwloc_obj\fP * obj)"
+
+.PP
+Insert a PCI object in the given PCI tree by looking at PCI bus IDs\&. If \fCtreep\fP points to \fCNULL\fP, the new object is inserted there\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_components_pcifind.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_components_pcifind.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_components_pcifind.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_components_pcifind.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,79 @@
+.TH "hwlocality_components_pcifind" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_components_pcifind \- Components and Plugins: finding PCI objects during other discoveries
+.SH SYNOPSIS
+.br
+.PP
+.SS "Typedefs"
+
+.in +1c
+.ti -1c
+.RI "typedef void * \fBhwloc_backend_distances_add_handle_t\fP"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBhwloc_pci_find_parent_by_busid\fP (struct hwloc_topology *topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)"
+.br
+.ti -1c
+.RI "struct \fBhwloc_obj\fP * \fBhwloc_pci_find_by_busid\fP (struct hwloc_topology *topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)"
+.br
+.ti -1c
+.RI "\fBhwloc_backend_distances_add_handle_t\fP \fBhwloc_backend_distances_add_create\fP (\fBhwloc_topology_t\fP topology, const char *name, unsigned long kind, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_backend_distances_add_values\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_backend_distances_add_handle_t\fP handle, unsigned nbobjs, \fBhwloc_obj_t\fP *objs, hwloc_uint64_t *values, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_backend_distances_add_commit\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_backend_distances_add_handle_t\fP handle, unsigned long flags)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.PP
+\fBNote\fP
+.RS 4
+These structures and functions may change when \fBHWLOC_COMPONENT_ABI\fP is modified\&. 
+.RE
+.PP
+
+.SH "Typedef Documentation"
+.PP 
+.SS "typedef void* \fBhwloc_backend_distances_add_handle_t\fP"
+
+.PP
+Handle to a new distances structure during its addition to the topology\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_backend_distances_add_commit (\fBhwloc_topology_t\fP topology, \fBhwloc_backend_distances_add_handle_t\fP handle, unsigned long flags)"
+
+.PP
+Commit a new distances structure\&. This is similar to \fBhwloc_distances_add_commit()\fP but this variant is designed for backend inserting distances during topology discovery\&. 
+.SS "\fBhwloc_backend_distances_add_handle_t\fP hwloc_backend_distances_add_create (\fBhwloc_topology_t\fP topology, const char * name, unsigned long kind, unsigned long flags)"
+
+.PP
+Create a new empty distances structure\&. This is identical to \fBhwloc_distances_add_create()\fP but this variant is designed for backend inserting distances during topology discovery\&. 
+.SS "int hwloc_backend_distances_add_values (\fBhwloc_topology_t\fP topology, \fBhwloc_backend_distances_add_handle_t\fP handle, unsigned nbobjs, \fBhwloc_obj_t\fP * objs, hwloc_uint64_t * values, unsigned long flags)"
+
+.PP
+Specify the objects and values in a new empty distances structure\&. This is similar to \fBhwloc_distances_add_values()\fP but this variant is designed for backend inserting distances during topology discovery\&.
+.PP
+The only semantical difference is that \fCobjs\fP and \fCvalues\fP are not duplicated, but directly attached to the topology\&. On success, these arrays are given to the core and should not ever be freed by the caller anymore\&. 
+.SS "struct \fBhwloc_obj\fP * hwloc_pci_find_by_busid (struct hwloc_topology * topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)"
+
+.PP
+Find the PCI device or bridge matching a PCI bus ID exactly\&. This is useful for adding specific information about some objects based on their PCI id\&. When it comes to attaching objects based on PCI locality, \fBhwloc_pci_find_parent_by_busid()\fP should be preferred\&. 
+.SS "struct \fBhwloc_obj\fP * hwloc_pci_find_parent_by_busid (struct hwloc_topology * topology, unsigned domain, unsigned bus, unsigned dev, unsigned func)"
+
+.PP
+Find the object or a parent of a PCI bus ID\&. When attaching a new object (typically an OS device) whose locality is specified by PCI bus ID, this function returns the PCI object to use as a parent for attaching\&.
+.PP
+If the exact PCI device with this bus ID exists, it is returned\&. Otherwise (for instance if it was filtered out), the function returns another object with similar locality (for instance a parent bridge, or the local CPU Package)\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_configuration.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_configuration.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_configuration.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_configuration.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,361 @@
+.TH "hwlocality_configuration" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_configuration \- Topology Detection Configuration and Query
+.SH SYNOPSIS
+.br
+.PP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_topology_discovery_support\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_cpubind_support\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_membind_support\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_misc_support\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_topology_support\fP"
+.br
+.in -1c
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_topology_flags_e\fP { \fBHWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED\fP, \fBHWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM\fP, \fBHWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES\fP, \fBHWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT\fP = (1UL<<3), \fBHWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING\fP = (1UL<<4), \fBHWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING\fP = (1UL<<5), \fBHWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING\fP = (1UL<<6), \fBHWLOC_TOPOLOGY_FLAG_NO_DISTANCES\fP = (1UL<<7), \fBHWLOC_TOPOLOGY_FLAG_NO_MEMATTRS\fP = (1UL<<8), \fBHWLOC_TOPOLOGY_FLAG_NO_CPUKINDS\fP = (1UL<<9) }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_type_filter_e\fP { \fBHWLOC_TYPE_FILTER_KEEP_ALL\fP, \fBHWLOC_TYPE_FILTER_KEEP_NONE\fP, \fBHWLOC_TYPE_FILTER_KEEP_STRUCTURE\fP, \fBHWLOC_TYPE_FILTER_KEEP_IMPORTANT\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_topology_set_flags\fP (\fBhwloc_topology_t\fP topology, unsigned long flags)"
+.br
+.ti -1c
+.RI "unsigned long \fBhwloc_topology_get_flags\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_is_thissystem\fP (\fBhwloc_topology_t\fP restrict topology)"
+.br
+.ti -1c
+.RI "const struct \fBhwloc_topology_support\fP * \fBhwloc_topology_get_support\fP (\fBhwloc_topology_t\fP restrict topology)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_set_type_filter\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, enum \fBhwloc_type_filter_e\fP filter)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_get_type_filter\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, enum \fBhwloc_type_filter_e\fP *filter)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_set_all_types_filter\fP (\fBhwloc_topology_t\fP topology, enum \fBhwloc_type_filter_e\fP filter)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_set_cache_types_filter\fP (\fBhwloc_topology_t\fP topology, enum \fBhwloc_type_filter_e\fP filter)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_set_icache_types_filter\fP (\fBhwloc_topology_t\fP topology, enum \fBhwloc_type_filter_e\fP filter)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_set_io_types_filter\fP (\fBhwloc_topology_t\fP topology, enum \fBhwloc_type_filter_e\fP filter)"
+.br
+.ti -1c
+.RI "void \fBhwloc_topology_set_userdata\fP (\fBhwloc_topology_t\fP topology, const void *userdata)"
+.br
+.ti -1c
+.RI "void * \fBhwloc_topology_get_userdata\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Several functions can optionally be called between \fBhwloc_topology_init()\fP and \fBhwloc_topology_load()\fP to configure how the detection should be performed, e\&.g\&. to ignore some objects types, define a synthetic topology, etc\&. 
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_topology_flags_e\fP"
+
+.PP
+Flags to be set onto a topology context before load\&. Flags should be given to \fBhwloc_topology_set_flags()\fP\&. They may also be returned by \fBhwloc_topology_get_flags()\fP\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED \fP\fP
+Detect the whole system, ignore reservations, include disallowed objects\&. Gather all online resources, even if some were disabled by the administrator\&. For instance, ignore Linux Cgroup/Cpusets and gather all processors and memory nodes\&. However offline PUs and NUMA nodes are still ignored\&.
+.PP
+When this flag is not set, PUs and NUMA nodes that are disallowed are not added to the topology\&. Parent objects (package, core, cache, etc\&.) are added only if some of their children are allowed\&. All existing PUs and NUMA nodes in the topology are allowed\&. \fBhwloc_topology_get_allowed_cpuset()\fP and \fBhwloc_topology_get_allowed_nodeset()\fP are equal to the root object cpuset and nodeset\&.
+.PP
+When this flag is set, the actual sets of allowed PUs and NUMA nodes are given by \fBhwloc_topology_get_allowed_cpuset()\fP and \fBhwloc_topology_get_allowed_nodeset()\fP\&. They may be smaller than the root object cpuset and nodeset\&.
+.PP
+If the current topology is exported to XML and reimported later, this flag should be set again in the reimported topology so that disallowed resources are reimported as well\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM \fP\fP
+Assume that the selected backend provides the topology for the system on which we are running\&. This forces \fBhwloc_topology_is_thissystem()\fP to return 1, i\&.e\&. makes hwloc assume that the selected backend provides the topology for the system on which we are running, even if it is not the OS-specific backend but the XML backend for instance\&. This means making the binding functions actually call the OS-specific system calls and really do binding, while the XML backend would otherwise provide empty hooks just returning success\&.
+.PP
+Setting the environment variable HWLOC_THISSYSTEM may also result in the same behavior\&.
+.PP
+This can be used for efficiency reasons to first detect the topology once, save it to an XML file, and quickly reload it later through the XML backend, but still having binding functions actually do bind\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_FLAG_THISSYSTEM_ALLOWED_RESOURCES \fP\fP
+Get the set of allowed resources from the local operating system even if the topology was loaded from XML or synthetic description\&. If the topology was loaded from XML or from a synthetic string, restrict it by applying the current process restrictions such as Linux Cgroup/Cpuset\&.
+.PP
+This is useful when the topology is not loaded directly from the local machine (e\&.g\&. for performance reason) and it comes with all resources, while the running process is restricted to only parts of the machine\&.
+.PP
+This flag is ignored unless \fBHWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM\fP is also set since the loaded topology must match the underlying machine where restrictions will be gathered from\&.
+.PP
+Setting the environment variable HWLOC_THISSYSTEM_ALLOWED_RESOURCES would result in the same behavior\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT \fP\fP
+Import support from the imported topology\&. When importing a XML topology from a remote machine, binding is disabled by default (see \fBHWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM\fP)\&. This disabling is also marked by putting zeroes in the corresponding supported feature bits reported by \fBhwloc_topology_get_support()\fP\&.
+.PP
+The flag \fBHWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT\fP actually imports support bits from the remote machine\&. It also sets the flag \fCimported_support\fP in the struct \fBhwloc_topology_misc_support\fP array\&. If the imported XML did not contain any support information (exporter hwloc is too old), this flag is not set\&.
+.PP
+Note that these supported features are only relevant for the hwloc installation that actually exported the XML topology (it may vary with the operating system, or with how hwloc was compiled)\&.
+.PP
+Note that setting this flag however does not enable binding for the locally imported hwloc topology, it only reports what the remote hwloc and machine support\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING \fP\fP
+Do not consider resources outside of the process CPU binding\&. If the binding of the process is limited to a subset of cores, ignore the other cores during discovery\&.
+.PP
+The resulting topology is identical to what a call to \fBhwloc_topology_restrict()\fP would generate, but this flag also prevents hwloc from ever touching other resources during the discovery\&.
+.PP
+This flag especially tells the x86 backend to never temporarily rebind a thread on any excluded core\&. This is useful on Windows because such temporary rebinding can change the process binding\&. Another use-case is to avoid cores that would not be able to perform the hwloc discovery anytime soon because they are busy executing some high-priority real-time tasks\&.
+.PP
+If process CPU binding is not supported, the thread CPU binding is considered instead if supported, or the flag is ignored\&.
+.PP
+This flag requires \fBHWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM\fP as well since binding support is required\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_FLAG_RESTRICT_TO_MEMBINDING \fP\fP
+Do not consider resources outside of the process memory binding\&. If the binding of the process is limited to a subset of NUMA nodes, ignore the other NUMA nodes during discovery\&.
+.PP
+The resulting topology is identical to what a call to \fBhwloc_topology_restrict()\fP would generate, but this flag also prevents hwloc from ever touching other resources during the discovery\&.
+.PP
+This flag is meant to be used together with \fBHWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING\fP when both cores and NUMA nodes should be ignored outside of the process binding\&.
+.PP
+If process memory binding is not supported, the thread memory binding is considered instead if supported, or the flag is ignored\&.
+.PP
+This flag requires \fBHWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM\fP as well since binding support is required\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_FLAG_DONT_CHANGE_BINDING \fP\fP
+Do not ever modify the process or thread binding during discovery\&. This flag disables all hwloc discovery steps that require a change of the process or thread binding\&. This currently only affects the x86 backend which gets entirely disabled\&.
+.PP
+This is useful when \fBhwloc_topology_load()\fP is called while the application also creates additional threads or modifies the binding\&.
+.PP
+This flag is also a strict way to make sure the process binding will not change to due thread binding changes on Windows (see \fBHWLOC_TOPOLOGY_FLAG_RESTRICT_TO_CPUBINDING\fP)\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_FLAG_NO_DISTANCES \fP\fP
+Ignore distances\&. Ignore distance information from the operating systems (and from XML) and hence do not use distances for grouping\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_FLAG_NO_MEMATTRS \fP\fP
+Ignore memory attributes and tiers\&. Ignore memory attribues from the operating systems (and from XML) Hence also do not try to build memory tiers\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_FLAG_NO_CPUKINDS \fP\fP
+Ignore CPU Kinds\&. Ignore CPU kind information from the operating systems (and from XML)\&. 
+.SS "enum \fBhwloc_type_filter_e\fP"
+
+.PP
+Type filtering flags\&. By default, most objects are kept (\fBHWLOC_TYPE_FILTER_KEEP_ALL\fP)\&. Instruction caches, memory-side caches, I/O and Misc objects are ignored by default (\fBHWLOC_TYPE_FILTER_KEEP_NONE\fP)\&. Group levels are ignored unless they bring structure (\fBHWLOC_TYPE_FILTER_KEEP_STRUCTURE\fP)\&.
+.PP
+Note that group objects are also ignored individually (without the entire level) when they do not bring structure\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_TYPE_FILTER_KEEP_ALL \fP\fP
+Keep all objects of this type\&. Cannot be set for \fBHWLOC_OBJ_GROUP\fP (groups are designed only to add more structure to the topology)\&. 
+.TP
+\fB\fIHWLOC_TYPE_FILTER_KEEP_NONE \fP\fP
+Ignore all objects of this type\&. The bottom-level type \fBHWLOC_OBJ_PU\fP, the \fBHWLOC_OBJ_NUMANODE\fP type, and the top-level type \fBHWLOC_OBJ_MACHINE\fP may not be ignored\&. 
+.TP
+\fB\fIHWLOC_TYPE_FILTER_KEEP_STRUCTURE \fP\fP
+Only ignore objects if their entire level does not bring any structure\&. Keep the entire level of objects if at least one of these objects adds structure to the topology\&. An object brings structure when it has multiple children and it is not the only child of its parent\&.
+.PP
+If all objects in the level are the only child of their parent, and if none of them has multiple children, the entire level is removed\&.
+.PP
+Cannot be set for I/O and Misc objects since the topology structure does not matter there\&. 
+.TP
+\fB\fIHWLOC_TYPE_FILTER_KEEP_IMPORTANT \fP\fP
+Only keep likely-important objects of the given type\&. It is only useful for I/O object types\&. For \fBHWLOC_OBJ_PCI_DEVICE\fP and \fBHWLOC_OBJ_OS_DEVICE\fP, it means that only objects of major/common kinds are kept (storage, network, OpenFabrics, CUDA, OpenCL, RSMI, NVML, and displays)\&. Also, only OS devices directly attached on PCI (e\&.g\&. no USB) are reported\&. For \fBHWLOC_OBJ_BRIDGE\fP, it means that bridges are kept only if they have children\&.
+.PP
+This flag equivalent to \fBHWLOC_TYPE_FILTER_KEEP_ALL\fP for Normal, Memory and Misc types since they are likely important\&. 
+.SH "Function Documentation"
+.PP 
+.SS "unsigned long hwloc_topology_get_flags (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Get OR'ed flags of a topology\&. Get the OR'ed set of \fBhwloc_topology_flags_e\fP of a topology\&.
+.PP
+If \fBhwloc_topology_set_flags()\fP was not called earlier, no flags are set (\fC0\fP is returned)\&.
+.PP
+\fBReturns\fP
+.RS 4
+the flags previously set with \fBhwloc_topology_set_flags()\fP\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function may also be called after \fBhwloc_topology_load()\fP\&. 
+.RE
+.PP
+
+.SS "const struct \fBhwloc_topology_support\fP * hwloc_topology_get_support (\fBhwloc_topology_t\fP restrict topology)"
+
+.PP
+Retrieve the topology support\&. Each flag indicates whether a feature is supported\&. If set to 0, the feature is not supported\&. If set to 1, the feature is supported, but the corresponding call may still fail in some corner cases\&.
+.PP
+These features are also listed by hwloc-info --support
+.PP
+The reported features are what the current topology supports on the current machine\&. If the topology was exported to XML from another machine and later imported here, support still describes what is supported for this imported topology after import\&. By default, binding will be reported as unsupported in this case (see \fBHWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM\fP)\&.
+.PP
+Topology flag \fBHWLOC_TOPOLOGY_FLAG_IMPORT_SUPPORT\fP may be used to report the supported features of the original remote machine instead\&. If it was successfully imported, \fCimported_support\fP will be set in the struct \fBhwloc_topology_misc_support\fP array\&.
+.PP
+\fBReturns\fP
+.RS 4
+A pointer to a support structure\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+The function cannot return \fCNULL\fP\&. 
+.PP
+The returned pointer should not be freed, it belongs to the hwloc library\&.
+.PP
+This function may be called before or after \fBhwloc_topology_load()\fP but the support structure only contains valid information after\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_get_type_filter (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, enum \fBhwloc_type_filter_e\fP * filter)"
+
+.PP
+Get the current filtering for the given object type\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "void * hwloc_topology_get_userdata (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Retrieve the topology-specific userdata pointer\&. Retrieve the application-given private data pointer that was previously set with \fBhwloc_topology_set_userdata()\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+A pointer to the private-data if any\&. 
+.PP
+\fCNULL\fP if no private-data was previoulsy set\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_is_thissystem (\fBhwloc_topology_t\fP restrict topology)"
+
+.PP
+Does the topology context come from this system? 
+.PP
+\fBReturns\fP
+.RS 4
+1 if this topology context was built using the system running this program\&. 
+.PP
+0 instead (for instance if using another file-system root, a XML topology file, or a synthetic topology)\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function may also be called after \fBhwloc_topology_load()\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_set_all_types_filter (\fBhwloc_topology_t\fP topology, enum \fBhwloc_type_filter_e\fP filter)"
+
+.PP
+Set the filtering for all object types\&. If some types do not support this filtering, they are silently ignored\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_set_cache_types_filter (\fBhwloc_topology_t\fP topology, enum \fBhwloc_type_filter_e\fP filter)"
+
+.PP
+Set the filtering for all CPU cache object types\&. Memory-side caches are not involved since they are not CPU caches\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_set_flags (\fBhwloc_topology_t\fP topology, unsigned long flags)"
+
+.PP
+Set OR'ed flags to non-yet-loaded topology\&. Set a OR'ed set of \fBhwloc_topology_flags_e\fP onto a topology that was not yet loaded\&.
+.PP
+If this function is called multiple times, the last invocation will erase and replace the set of flags that was previously set\&.
+.PP
+By default, no flags are set (\fC0\fP)\&.
+.PP
+The flags set in a topology may be retrieved with \fBhwloc_topology_get_flags()\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if flags are invalid\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_set_icache_types_filter (\fBhwloc_topology_t\fP topology, enum \fBhwloc_type_filter_e\fP filter)"
+
+.PP
+Set the filtering for all CPU instruction cache object types\&. Memory-side caches are not involved since they are not CPU caches\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_set_io_types_filter (\fBhwloc_topology_t\fP topology, enum \fBhwloc_type_filter_e\fP filter)"
+
+.PP
+Set the filtering for all I/O object types\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_set_type_filter (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, enum \fBhwloc_type_filter_e\fP filter)"
+
+.PP
+Set the filtering for the given object type\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "void hwloc_topology_set_userdata (\fBhwloc_topology_t\fP topology, const void * userdata)"
+
+.PP
+Set the topology-specific userdata pointer\&. Each topology may store one application-given private data pointer\&. It is initialized to \fCNULL\fP\&. hwloc will never modify it\&.
+.PP
+Use it as you wish, after \fBhwloc_topology_init()\fP and until hwloc_topolog_destroy()\&.
+.PP
+This pointer is not exported to XML\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_cpubinding.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_cpubinding.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_cpubinding.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_cpubinding.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,274 @@
+.TH "hwlocality_cpubinding" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_cpubinding \- CPU binding
+.SH SYNOPSIS
+.br
+.PP
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_cpubind_flags_t\fP { \fBHWLOC_CPUBIND_PROCESS\fP, \fBHWLOC_CPUBIND_THREAD\fP, \fBHWLOC_CPUBIND_STRICT\fP, \fBHWLOC_CPUBIND_NOMEMBIND\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_set_cpubind\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_cpubind\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP set, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_set_proc_cpubind\fP (\fBhwloc_topology_t\fP topology, hwloc_pid_t pid, \fBhwloc_const_cpuset_t\fP set, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_proc_cpubind\fP (\fBhwloc_topology_t\fP topology, hwloc_pid_t pid, \fBhwloc_cpuset_t\fP set, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_set_thread_cpubind\fP (\fBhwloc_topology_t\fP topology, hwloc_thread_t thread, \fBhwloc_const_cpuset_t\fP set, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_thread_cpubind\fP (\fBhwloc_topology_t\fP topology, hwloc_thread_t thread, \fBhwloc_cpuset_t\fP set, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_last_cpu_location\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP set, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_proc_last_cpu_location\fP (\fBhwloc_topology_t\fP topology, hwloc_pid_t pid, \fBhwloc_cpuset_t\fP set, int flags)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Some operating systems only support binding threads or processes to a single PU\&. Others allow binding to larger sets such as entire Cores or Packages or even random sets of individual PUs\&. In such operating system, the scheduler is free to run the task on one of these PU, then migrate it to another PU, etc\&. It is often useful to call \fBhwloc_bitmap_singlify()\fP on the target CPU set before passing it to the binding function to avoid these expensive migrations\&. See the documentation of \fBhwloc_bitmap_singlify()\fP for details\&.
+.PP
+Some operating systems do not provide all hwloc-supported mechanisms to bind processes, threads, etc\&. \fBhwloc_topology_get_support()\fP may be used to query about the actual CPU binding support in the currently used operating system\&.
+.PP
+When the requested binding operation is not available and the \fBHWLOC_CPUBIND_STRICT\fP flag was passed, the function returns -1\&. \fCerrno\fP is set to \fCENOSYS\fP when it is not possible to bind the requested kind of object processes/threads\&. errno is set to \fCEXDEV\fP when the requested cpuset can not be enforced (e\&.g\&. some systems only allow one CPU, and some other systems only allow one NUMA node)\&.
+.PP
+If \fBHWLOC_CPUBIND_STRICT\fP was not passed, the function may fail as well, or the operating system may use a slightly different operation (with side-effects, smaller binding set, etc\&.) when the requested operation is not exactly supported\&.
+.PP
+The most portable version that should be preferred over the others, whenever possible, is the following one which just binds the current program, assuming it is single-threaded:
+.PP
+.PP
+.nf
+hwloc_set_cpubind(topology, set, 0),
+.fi
+.PP
+.PP
+If the program may be multithreaded, the following one should be preferred to only bind the current thread:
+.PP
+.PP
+.nf
+hwloc_set_cpubind(topology, set, HWLOC_CPUBIND_THREAD),
+.fi
+.PP
+.PP
+\fBSee also\fP
+.RS 4
+Some example codes are available under doc/examples/ in the source tree\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+To unbind, just call the binding function with either a full cpuset or a cpuset equal to the system cpuset\&.
+.PP
+On some operating systems, CPU binding may have effects on memory binding, see \fBHWLOC_CPUBIND_NOMEMBIND\fP
+.PP
+Running lstopo --top or hwloc-ps can be a very convenient tool to check how binding actually happened\&. 
+.RE
+.PP
+
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_cpubind_flags_t\fP"
+
+.PP
+Process/Thread binding flags\&. These bit flags can be used to refine the binding policy\&.
+.PP
+The default (0) is to bind the current process, assumed to be single-threaded, in a non-strict way\&. This is the most portable way to bind as all operating systems usually provide it\&.
+.PP
+\fBNote\fP
+.RS 4
+Not all systems support all kinds of binding\&. See the 'Detailed Description' section of \fBCPU binding\fP for a description of errors that can occur\&. 
+.RE
+.PP
+
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_CPUBIND_PROCESS \fP\fP
+Bind all threads of the current (possibly) multithreaded process\&. 
+.TP
+\fB\fIHWLOC_CPUBIND_THREAD \fP\fP
+Bind current thread of current process\&. 
+.TP
+\fB\fIHWLOC_CPUBIND_STRICT \fP\fP
+Request for strict binding from the OS\&. By default, when the designated CPUs are all busy while other CPUs are idle, operating systems may execute the thread/process on those other CPUs instead of the designated CPUs, to let them progress anyway\&. Strict binding means that the thread/process will _never_ execute on other CPUs than the designated CPUs, even when those are busy with other tasks and other CPUs are idle\&.
+.PP
+\fBNote\fP
+.RS 4
+Depending on the operating system, strict binding may not be possible (e\&.g\&., the OS does not implement it) or not allowed (e\&.g\&., for an administrative reasons), and the function will fail in that case\&.
+.RE
+.PP
+When retrieving the binding of a process, this flag checks whether all its threads actually have the same binding\&. If the flag is not given, the binding of each thread will be accumulated\&.
+.PP
+\fBNote\fP
+.RS 4
+This flag is meaningless when retrieving the binding of a thread\&. 
+.RE
+.PP
+
+.TP
+\fB\fIHWLOC_CPUBIND_NOMEMBIND \fP\fP
+Avoid any effect on memory binding\&. On some operating systems, some CPU binding function would also bind the memory on the corresponding NUMA node\&. It is often not a problem for the application, but if it is, setting this flag will make hwloc avoid using OS functions that would also bind memory\&. This will however reduce the support of CPU bindings, i\&.e\&. potentially return -1 with errno set to \fCENOSYS\fP in some cases\&.
+.PP
+This flag is only meaningful when used with functions that set the CPU binding\&. It is ignored when used with functions that get CPU binding information\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_get_cpubind (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP set, int flags)"
+
+.PP
+Get current process or thread binding\&. The CPU-set \fCset\fP (previously allocated by the caller) is filled with the list of PUs which the process or thread (according to \fIflags\fP) was last bound to\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_get_last_cpu_location (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP set, int flags)"
+
+.PP
+Get the last physical CPU where the current process or thread ran\&. The CPU-set \fCset\fP (previously allocated by the caller) is filled with the list of PUs which the process or thread (according to \fIflags\fP) last ran on\&.
+.PP
+The operating system may move some tasks from one processor to another at any time according to their binding, so this function may return something that is already outdated\&.
+.PP
+\fCflags\fP can include either \fBHWLOC_CPUBIND_PROCESS\fP or \fBHWLOC_CPUBIND_THREAD\fP to specify whether the query should be for the whole process (union of all CPUs on which all threads are running), or only the current thread\&. If the process is single-threaded, flags can be set to zero to let hwloc use whichever method is available on the underlying OS\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_get_proc_cpubind (\fBhwloc_topology_t\fP topology, hwloc_pid_t pid, \fBhwloc_cpuset_t\fP set, int flags)"
+
+.PP
+Get the current physical binding of process \fCpid\fP\&. The CPU-set \fCset\fP (previously allocated by the caller) is filled with the list of PUs which the process was last bound to\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+\fChwloc_pid_t\fP is \fCpid_t\fP on Unix platforms, and \fCHANDLE\fP on native Windows platforms\&.
+.PP
+As a special case on Linux, if a tid (thread ID) is supplied instead of a pid (process ID) and HWLOC_CPUBIND_THREAD is passed in flags, the binding for that specific thread is returned\&.
+.PP
+On non-Linux systems, HWLOC_CPUBIND_THREAD can not be used in \fCflags\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_get_proc_last_cpu_location (\fBhwloc_topology_t\fP topology, hwloc_pid_t pid, \fBhwloc_cpuset_t\fP set, int flags)"
+
+.PP
+Get the last physical CPU where a process ran\&. The CPU-set \fCset\fP (previously allocated by the caller) is filled with the list of PUs which the process last ran on\&.
+.PP
+The operating system may move some tasks from one processor to another at any time according to their binding, so this function may return something that is already outdated\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+\fChwloc_pid_t\fP is \fCpid_t\fP on Unix platforms, and \fCHANDLE\fP on native Windows platforms\&.
+.PP
+As a special case on Linux, if a tid (thread ID) is supplied instead of a pid (process ID) and \fBHWLOC_CPUBIND_THREAD\fP is passed in flags, the last CPU location of that specific thread is returned\&.
+.PP
+On non-Linux systems, \fBHWLOC_CPUBIND_THREAD\fP can not be used in \fCflags\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_get_thread_cpubind (\fBhwloc_topology_t\fP topology, hwloc_thread_t thread, \fBhwloc_cpuset_t\fP set, int flags)"
+
+.PP
+Get the current physical binding of thread \fCtid\fP\&. The CPU-set \fCset\fP (previously allocated by the caller) is filled with the list of PUs which the thread was last bound to\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+\fChwloc_thread_t\fP is \fCpthread_t\fP on Unix platforms, and \fCHANDLE\fP on native Windows platforms\&.
+.PP
+\fBHWLOC_CPUBIND_PROCESS\fP can not be used in \fCflags\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_set_cpubind (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, int flags)"
+
+.PP
+Bind current process or thread on CPUs given in physical bitmap \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOSYS\fP if the action is not supported\&. 
+.PP
+-1 with errno set to \fCEXDEV\fP if the binding cannot be enforced\&. 
+.RE
+.PP
+
+.SS "int hwloc_set_proc_cpubind (\fBhwloc_topology_t\fP topology, hwloc_pid_t pid, \fBhwloc_const_cpuset_t\fP set, int flags)"
+
+.PP
+Bind a process \fCpid\fP on CPUs given in physical bitmap \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+\fChwloc_pid_t\fP is \fCpid_t\fP on Unix platforms, and \fCHANDLE\fP on native Windows platforms\&.
+.PP
+As a special case on Linux, if a tid (thread ID) is supplied instead of a pid (process ID) and \fBHWLOC_CPUBIND_THREAD\fP is passed in flags, the binding is applied to that specific thread\&.
+.PP
+On non-Linux systems, \fBHWLOC_CPUBIND_THREAD\fP can not be used in \fCflags\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_set_thread_cpubind (\fBhwloc_topology_t\fP topology, hwloc_thread_t thread, \fBhwloc_const_cpuset_t\fP set, int flags)"
+
+.PP
+Bind a thread \fCthread\fP on CPUs given in physical bitmap \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+\fChwloc_thread_t\fP is \fCpthread_t\fP on Unix platforms, and \fCHANDLE\fP on native Windows platforms\&.
+.PP
+\fBHWLOC_CPUBIND_PROCESS\fP can not be used in \fCflags\fP\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_cpukinds.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_cpukinds.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_cpukinds.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_cpukinds.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,135 @@
+.TH "hwlocality_cpukinds" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_cpukinds \- Kinds of CPU cores
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_cpukinds_get_nr\fP (\fBhwloc_topology_t\fP topology, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_cpukinds_get_by_cpuset\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_bitmap_t\fP cpuset, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_cpukinds_get_info\fP (\fBhwloc_topology_t\fP topology, unsigned kind_index, \fBhwloc_bitmap_t\fP cpuset, int *efficiency, unsigned *nr_infos, struct \fBhwloc_info_s\fP **infos, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_cpukinds_register\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_bitmap_t\fP cpuset, int forced_efficiency, unsigned nr_infos, struct \fBhwloc_info_s\fP *infos, unsigned long flags)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Platforms with heterogeneous CPUs may have some cores with different features or frequencies\&. This API exposes identical PUs in sets called CPU kinds\&. Each PU of the topology may only be in a single kind\&.
+.PP
+The number of kinds may be obtained with \fBhwloc_cpukinds_get_nr()\fP\&. If the platform is homogeneous, there may be a single kind with all PUs\&. If the platform or operating system does not expose any information about CPU cores, there may be no kind at all\&.
+.PP
+The index of the kind that describes a given CPU set (if any, and not partially) may be obtained with \fBhwloc_cpukinds_get_by_cpuset()\fP\&.
+.PP
+From the index of a kind, it is possible to retrieve information with \fBhwloc_cpukinds_get_info()\fP: an abstracted efficiency value, and an array of info attributes (for instance the 'CoreType' and 'FrequencyMaxMHz', see \fBCPU Kinds\fP)\&.
+.PP
+A higher efficiency value means greater intrinsic performance (and possibly less performance/power efficiency)\&. Kinds with lower efficiency values are ranked first: Passing 0 as \fCkind_index\fP to \fBhwloc_cpukinds_get_info()\fP will return information about the CPU kind with lower performance but higher energy-efficiency\&. Higher \fCkind_index\fP values would rather return information about power-hungry high-performance cores\&.
+.PP
+When available, efficiency values are gathered from the operating system\&. If so, \fCcpukind_efficiency\fP is set in the struct \fBhwloc_topology_discovery_support\fP array\&. This is currently available on Windows 10, Mac OS X (Darwin), and on some Linux platforms where core 'capacity' is exposed in sysfs\&.
+.PP
+If the operating system does not expose core efficiencies natively, hwloc tries to compute efficiencies by comparing CPU kinds using frequencies (on ARM), or core types and frequencies (on other architectures)\&. The environment variable HWLOC_CPUKINDS_RANKING may be used to change this heuristics, see \fBEnvironment Variables\fP\&.
+.PP
+If hwloc fails to rank any kind, for instance because the operating system does not expose efficiencies and core frequencies, all kinds will have an unknown efficiency (\fC-1\fP), and they are not indexed/ordered in any specific way\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_cpukinds_get_by_cpuset (\fBhwloc_topology_t\fP topology, \fBhwloc_const_bitmap_t\fP cpuset, unsigned long flags)"
+
+.PP
+Get the index of the CPU kind that contains CPUs listed in \fCcpuset\fP\&. \fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+The index of the CPU kind (positive integer or 0) on success\&. 
+.PP
+\fC-1\fP with \fCerrno\fP set to \fCEXDEV\fP if \fCcpuset\fP is only partially included in the some kind\&. 
+.PP
+\fC-1\fP with \fCerrno\fP set to \fCENOENT\fP if \fCcpuset\fP is not included in any kind, even partially\&. 
+.PP
+\fC-1\fP with \fCerrno\fP set to \fCEINVAL\fP if parameters are invalid\&. 
+.RE
+.PP
+
+.SS "int hwloc_cpukinds_get_info (\fBhwloc_topology_t\fP topology, unsigned kind_index, \fBhwloc_bitmap_t\fP cpuset, int * efficiency, unsigned * nr_infos, struct \fBhwloc_info_s\fP ** infos, unsigned long flags)"
+
+.PP
+Get the CPU set and infos about a CPU kind in the topology\&. \fCkind_index\fP identifies one kind of CPU between 0 and the number of kinds returned by \fBhwloc_cpukinds_get_nr()\fP minus 1\&.
+.PP
+If not \fCNULL\fP, the bitmap \fCcpuset\fP will be filled with the set of PUs of this kind\&.
+.PP
+The integer pointed by \fCefficiency\fP, if not \fCNULL\fP will, be filled with the ranking of this kind of CPU in term of efficiency (see above)\&. It ranges from \fC0\fP to the number of kinds (as reported by \fBhwloc_cpukinds_get_nr()\fP) minus 1\&.
+.PP
+Kinds with lower efficiency are reported first\&.
+.PP
+If there is a single kind in the topology, its efficiency \fC0\fP\&. If the efficiency of some kinds of cores is unknown, the efficiency of all kinds is set to \fC-1\fP, and kinds are reported in no specific order\&.
+.PP
+The array of info attributes (for instance the 'CoreType', 'FrequencyMaxMHz' or 'FrequencyBaseMHz', see \fBCPU Kinds\fP) and its length are returned in \fCinfos\fP or \fCnr_infos\fP\&. The array belongs to the topology, it should not be freed or modified\&.
+.PP
+If \fCnr_infos\fP or \fCinfos\fP is \fCNULL\fP, no info is returned\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+\fC0\fP on success\&. 
+.PP
+\fC-1\fP with \fCerrno\fP set to \fCENOENT\fP if \fCkind_index\fP does not match any CPU kind\&. 
+.PP
+\fC-1\fP with \fCerrno\fP set to \fCEINVAL\fP if parameters are invalid\&. 
+.RE
+.PP
+
+.SS "int hwloc_cpukinds_get_nr (\fBhwloc_topology_t\fP topology, unsigned long flags)"
+
+.PP
+Get the number of different kinds of CPU cores in the topology\&. \fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+The number of CPU kinds (positive integer) on success\&. 
+.PP
+\fC0\fP if no information about kinds was found\&. 
+.PP
+\fC-1\fP with \fCerrno\fP set to \fCEINVAL\fP if \fCflags\fP is invalid\&. 
+.RE
+.PP
+
+.SS "int hwloc_cpukinds_register (\fBhwloc_topology_t\fP topology, \fBhwloc_bitmap_t\fP cpuset, int forced_efficiency, unsigned nr_infos, struct \fBhwloc_info_s\fP * infos, unsigned long flags)"
+
+.PP
+Register a kind of CPU in the topology\&. Mark the PUs listed in \fCcpuset\fP as being of the same kind with respect to the given attributes\&.
+.PP
+\fCforced_efficiency\fP should be \fC-1\fP if unknown\&. Otherwise it is an abstracted efficiency value to enforce the ranking of all kinds if all of them have valid (and different) efficiencies\&.
+.PP
+The array \fCinfos\fP of size \fCnr_infos\fP may be used to provide info names and values describing this kind of PUs\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+Parameters \fCcpuset\fP and \fCinfos\fP will be duplicated internally, the caller is responsible for freeing them\&.
+.PP
+If \fCcpuset\fP overlaps with some existing kinds, those might get modified or split\&. For instance if existing kind A contains PUs 0 and 1, and one registers another kind for PU 1 and 2, there will be 3 resulting kinds: existing kind A is restricted to only PU 0; new kind B contains only PU 1 and combines information from A and from the newly-registered kind; new kind C contains only PU 2 and only gets information from the newly-registered kind\&.
+.PP
+\fBNote\fP
+.RS 4
+The efficiency \fCforced_efficiency\fP provided to this function may be different from the one reported later by \fBhwloc_cpukinds_get_info()\fP because hwloc will scale efficiency values down to between 0 and the number of kinds minus 1\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+\fC0\fP on success\&. 
+.PP
+\fC-1\fP with \fCerrno\fP set to \fCEINVAL\fP if some parameters are invalid, for instance if \fCcpuset\fP is \fCNULL\fP or empty\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_creation.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_creation.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_creation.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_creation.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,164 @@
+.TH "hwlocality_creation" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_creation \- Topology Creation and Destruction
+.SH SYNOPSIS
+.br
+.PP
+.SS "Typedefs"
+
+.in +1c
+.ti -1c
+.RI "typedef struct hwloc_topology * \fBhwloc_topology_t\fP"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_topology_init\fP (\fBhwloc_topology_t\fP *topologyp)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_load\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "void \fBhwloc_topology_destroy\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_dup\fP (\fBhwloc_topology_t\fP *newtopology, \fBhwloc_topology_t\fP oldtopology)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_abi_check\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "void \fBhwloc_topology_check\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Typedef Documentation"
+.PP 
+.SS "typedef struct hwloc_topology* \fBhwloc_topology_t\fP"
+
+.PP
+Topology context\&. To be initialized with \fBhwloc_topology_init()\fP and built with \fBhwloc_topology_load()\fP\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_topology_abi_check (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Verify that the topology is compatible with the current hwloc library\&. This is useful when using the same topology structure (in memory) in different libraries that may use different hwloc installations (for instance if one library embeds a specific version of hwloc, while another library uses a default system-wide hwloc installation)\&.
+.PP
+If all libraries/programs use the same hwloc installation, this function always returns success\&.
+.PP
+\fBReturns\fP
+.RS 4
+\fC0\fP on success\&.
+.PP
+\fC-1\fP with \fCerrno\fP set to \fCEINVAL\fP if incompatible\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+If sharing between processes with \fBhwloc_shmem_topology_write()\fP, the relevant check is already performed inside \fBhwloc_shmem_topology_adopt()\fP\&. 
+.RE
+.PP
+
+.SS "void hwloc_topology_check (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Run internal checks on a topology structure\&. The program aborts if an inconsistency is detected in the given topology\&.
+.PP
+\fBParameters\fP
+.RS 4
+\fItopology\fP is the topology to be checked
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This routine is only useful to developers\&.
+.PP
+The input topology should have been previously loaded with \fBhwloc_topology_load()\fP\&. 
+.RE
+.PP
+
+.SS "void hwloc_topology_destroy (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Terminate and free a topology context\&. 
+.PP
+\fBParameters\fP
+.RS 4
+\fItopology\fP is the topology to be freed 
+.RE
+.PP
+
+.SS "int hwloc_topology_dup (\fBhwloc_topology_t\fP * newtopology, \fBhwloc_topology_t\fP oldtopology)"
+
+.PP
+Duplicate a topology\&. The entire topology structure as well as its objects are duplicated into a new one\&.
+.PP
+This is useful for keeping a backup while modifying a topology\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Object userdata is not duplicated since hwloc does not know what it point to\&. The objects of both old and new topologies will point to the same userdata\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_init (\fBhwloc_topology_t\fP * topologyp)"
+
+.PP
+Allocate a topology context\&. 
+.PP
+\fBParameters\fP
+.RS 4
+\fItopologyp\fP is assigned a pointer to the new allocated context\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_load (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Build the actual topology\&. Build the actual topology once initialized with \fBhwloc_topology_init()\fP and tuned with \fBTopology Detection Configuration and Query\fP and \fBChanging the Source of Topology Discovery\fP routines\&. No other routine may be called earlier using this topology context\&.
+.PP
+\fBParameters\fP
+.RS 4
+\fItopology\fP is the topology to be loaded with objects\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+On failure, the topology is reinitialized\&. It should be either destroyed with \fBhwloc_topology_destroy()\fP or configured and loaded again\&.
+.PP
+This function may be called only once per topology\&.
+.PP
+The binding of the current thread or process may temporarily change during this call but it will be restored before it returns\&.
+.RE
+.PP
+\fBSee also\fP
+.RS 4
+\fBTopology Detection Configuration and Query\fP and \fBChanging the Source of Topology Discovery\fP 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_cuda.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_cuda.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_cuda.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_cuda.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,124 @@
+.TH "hwlocality_cuda" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_cuda \- Interoperability with the CUDA Driver API
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_cuda_get_device_pci_ids\fP (\fBhwloc_topology_t\fP topology, CUdevice cudevice, int *domain, int *bus, int *dev)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_cuda_get_device_cpuset\fP (\fBhwloc_topology_t\fP topology, CUdevice cudevice, \fBhwloc_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_cuda_get_device_pcidev\fP (\fBhwloc_topology_t\fP topology, CUdevice cudevice)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_cuda_get_device_osdev\fP (\fBhwloc_topology_t\fP topology, CUdevice cudevice)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_cuda_get_device_osdev_by_index\fP (\fBhwloc_topology_t\fP topology, unsigned idx)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This interface offers ways to retrieve topology information about CUDA devices when using the CUDA Driver API\&. 
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_cuda_get_device_cpuset (\fBhwloc_topology_t\fP topology, CUdevice cudevice, \fBhwloc_cpuset_t\fP set)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the CPU set of processors that are physically close to device \fCcudevice\fP\&. Store in \fCset\fP the CPU-set describing the locality of the CUDA device \fCcudevice\fP\&.
+.PP
+Topology \fCtopology\fP and device \fCcudevice\fP must match the local machine\&. I/O devices detection and the CUDA component are not needed in the topology\&.
+.PP
+The function only returns the locality of the device\&. If more information about the device is needed, OS objects should be used instead, see \fBhwloc_cuda_get_device_osdev()\fP and \fBhwloc_cuda_get_device_osdev_by_index()\fP\&.
+.PP
+This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if device information could not be found\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_cuda_get_device_osdev (\fBhwloc_topology_t\fP topology, CUdevice cudevice)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to CUDA device \fCcudevice\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object that describes the given CUDA device \fCcudevice\fP\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+Topology \fCtopology\fP and device \fCcudevice\fP must match the local machine\&. I/O devices detection and the CUDA component must be enabled in the topology\&. If not, the locality of the object may still be found using \fBhwloc_cuda_get_device_cpuset()\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+This function cannot work if PCI devices are filtered out\&.
+.PP
+The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_cuda_get_device_osdev_by_index (\fBhwloc_topology_t\fP topology, unsigned idx)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to the CUDA device whose index is \fCidx\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object describing the CUDA device whose index is \fCidx\fP\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+The topology \fCtopology\fP does not necessarily have to match the current machine\&. For instance the topology may be an XML import of a remote host\&. I/O devices detection and the CUDA component must be enabled in the topology\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out)\&.
+.PP
+This function is identical to \fBhwloc_cudart_get_device_osdev_by_index()\fP\&. 
+.RE
+.PP
+
+.SS "static int hwloc_cuda_get_device_pci_ids (\fBhwloc_topology_t\fP topology, CUdevice cudevice, int * domain, int * bus, int * dev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Return the domain, bus and device IDs of the CUDA device \fCcudevice\fP\&. Device \fCcudevice\fP must match the local machine\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if device information could not be found\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_cuda_get_device_pcidev (\fBhwloc_topology_t\fP topology, CUdevice cudevice)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc PCI device object corresponding to the CUDA device \fCcudevice\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc PCI device object describing the CUDA device \fCcudevice\fP\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+Topology \fCtopology\fP and device \fCcudevice\fP must match the local machine\&. I/O devices detection must be enabled in topology \fCtopology\fP\&. The CUDA component is not needed in the topology\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_cudart.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_cudart.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_cudart.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_cudart.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,99 @@
+.TH "hwlocality_cudart" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_cudart \- Interoperability with the CUDA Runtime API
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_cudart_get_device_pci_ids\fP (\fBhwloc_topology_t\fP topology, int idx, int *domain, int *bus, int *dev)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_cudart_get_device_cpuset\fP (\fBhwloc_topology_t\fP topology, int idx, \fBhwloc_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_cudart_get_device_pcidev\fP (\fBhwloc_topology_t\fP topology, int idx)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_cudart_get_device_osdev_by_index\fP (\fBhwloc_topology_t\fP topology, unsigned idx)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This interface offers ways to retrieve topology information about CUDA devices when using the CUDA Runtime API\&. 
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_cudart_get_device_cpuset (\fBhwloc_topology_t\fP topology, int idx, \fBhwloc_cpuset_t\fP set)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the CPU set of processors that are physically close to device \fCidx\fP\&. Store in \fCset\fP the CPU-set describing the locality of the CUDA device whose index is \fCidx\fP\&.
+.PP
+Topology \fCtopology\fP and device \fCidx\fP must match the local machine\&. I/O devices detection and the CUDA component are not needed in the topology\&.
+.PP
+The function only returns the locality of the device\&. If more information about the device is needed, OS objects should be used instead, see \fBhwloc_cudart_get_device_osdev_by_index()\fP\&.
+.PP
+This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if device information could not be found\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_cudart_get_device_osdev_by_index (\fBhwloc_topology_t\fP topology, unsigned idx)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to the CUDA device whose index is \fCidx\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object describing the CUDA device whose index is \fCidx\fP\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+The topology \fCtopology\fP does not necessarily have to match the current machine\&. For instance the topology may be an XML import of a remote host\&. I/O devices detection and the CUDA component must be enabled in the topology\&. If not, the locality of the object may still be found using \fBhwloc_cudart_get_device_cpuset()\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out)\&.
+.PP
+This function is identical to \fBhwloc_cuda_get_device_osdev_by_index()\fP\&. 
+.RE
+.PP
+
+.SS "static int hwloc_cudart_get_device_pci_ids (\fBhwloc_topology_t\fP topology, int idx, int * domain, int * bus, int * dev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Return the domain, bus and device IDs of the CUDA device whose index is \fCidx\fP\&. Device index \fCidx\fP must match the local machine\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if device information could not be found\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_cudart_get_device_pcidev (\fBhwloc_topology_t\fP topology, int idx)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc PCI device object corresponding to the CUDA device whose index is \fCidx\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc PCI device object describing the CUDA device whose index is \fCidx\fP\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+Topology \fCtopology\fP and device \fCidx\fP must match the local machine\&. I/O devices detection must be enabled in topology \fCtopology\fP\&. The CUDA component is not needed in the topology\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_diff.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_diff.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_diff.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_diff.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,259 @@
+.TH "hwlocality_diff" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_diff \- Topology differences
+.SH SYNOPSIS
+.br
+.PP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "union \fBhwloc_topology_diff_obj_attr_u\fP"
+.br
+.ti -1c
+.RI "union \fBhwloc_topology_diff_u\fP"
+.br
+.in -1c
+.SS "Typedefs"
+
+.in +1c
+.ti -1c
+.RI "typedef enum \fBhwloc_topology_diff_obj_attr_type_e\fP \fBhwloc_topology_diff_obj_attr_type_t\fP"
+.br
+.ti -1c
+.RI "typedef enum \fBhwloc_topology_diff_type_e\fP \fBhwloc_topology_diff_type_t\fP"
+.br
+.ti -1c
+.RI "typedef union \fBhwloc_topology_diff_u\fP * \fBhwloc_topology_diff_t\fP"
+.br
+.in -1c
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_topology_diff_obj_attr_type_e\fP { \fBHWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE\fP, \fBHWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME\fP, \fBHWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO\fP }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_topology_diff_type_e\fP { \fBHWLOC_TOPOLOGY_DIFF_OBJ_ATTR\fP, \fBHWLOC_TOPOLOGY_DIFF_TOO_COMPLEX\fP }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_topology_diff_apply_flags_e\fP { \fBHWLOC_TOPOLOGY_DIFF_APPLY_REVERSE\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_topology_diff_build\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_topology_t\fP newtopology, unsigned long flags, \fBhwloc_topology_diff_t\fP *diff)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_diff_apply\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_topology_diff_t\fP diff, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_diff_destroy\fP (\fBhwloc_topology_diff_t\fP diff)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_diff_load_xml\fP (const char *xmlpath, \fBhwloc_topology_diff_t\fP *diff, char **refname)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_diff_export_xml\fP (\fBhwloc_topology_diff_t\fP diff, const char *refname, const char *xmlpath)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_diff_load_xmlbuffer\fP (const char *xmlbuffer, int buflen, \fBhwloc_topology_diff_t\fP *diff, char **refname)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_diff_export_xmlbuffer\fP (\fBhwloc_topology_diff_t\fP diff, const char *refname, char **xmlbuffer, int *buflen)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Applications that manipulate many similar topologies, for instance one for each node of a homogeneous cluster, may want to compress topologies to reduce the memory footprint\&.
+.PP
+This file offers a way to manipulate the difference between topologies and export/import it to/from XML\&. Compression may therefore be achieved by storing one topology entirely while the others are only described by their differences with the former\&. The actual topology can be reconstructed when actually needed by applying the precomputed difference to the reference topology\&.
+.PP
+This interface targets very similar nodes\&. Only very simple differences between topologies are actually supported, for instance a change in the memory size, the name of the object, or some info attribute\&. More complex differences such as adding or removing objects cannot be represented in the difference structures and therefore return errors\&. Differences between object sets or topology-wide allowed sets, cannot be represented either\&.
+.PP
+It means that there is no need to apply the difference when looking at the tree organization (how many levels, how many objects per level, what kind of objects, CPU and node sets, etc) and when binding to objects\&. However the difference must be applied when looking at object attributes such as the name, the memory size or info attributes\&. 
+.SH "Typedef Documentation"
+.PP 
+.SS "typedef enum \fBhwloc_topology_diff_obj_attr_type_e\fP \fBhwloc_topology_diff_obj_attr_type_t\fP"
+
+.PP
+Type of one object attribute difference\&. 
+.SS "typedef union \fBhwloc_topology_diff_u\fP * \fBhwloc_topology_diff_t\fP"
+
+.PP
+One element of a difference list between two topologies\&. 
+.SS "typedef enum \fBhwloc_topology_diff_type_e\fP \fBhwloc_topology_diff_type_t\fP"
+
+.PP
+Type of one element of a difference list\&. 
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_topology_diff_apply_flags_e\fP"
+
+.PP
+Flags to be given to \fBhwloc_topology_diff_apply()\fP\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_TOPOLOGY_DIFF_APPLY_REVERSE \fP\fP
+Apply topology diff in reverse direction\&. 
+.SS "enum \fBhwloc_topology_diff_obj_attr_type_e\fP"
+
+.PP
+Type of one object attribute difference\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_TOPOLOGY_DIFF_OBJ_ATTR_SIZE \fP\fP
+The object local memory is modified\&. The union is a \fBhwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_uint64_s\fP (and the index field is ignored)\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_DIFF_OBJ_ATTR_NAME \fP\fP
+The object name is modified\&. The union is a \fBhwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s\fP (and the name field is ignored)\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_DIFF_OBJ_ATTR_INFO \fP\fP
+the value of an info attribute is modified\&. The union is a \fBhwloc_topology_diff_obj_attr_u::hwloc_topology_diff_obj_attr_string_s\fP\&. 
+.SS "enum \fBhwloc_topology_diff_type_e\fP"
+
+.PP
+Type of one element of a difference list\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_TOPOLOGY_DIFF_OBJ_ATTR \fP\fP
+An object attribute was changed\&. The union is a \fBhwloc_topology_diff_u::hwloc_topology_diff_obj_attr_s\fP\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_DIFF_TOO_COMPLEX \fP\fP
+The difference is too complex, it cannot be represented\&. The difference below this object has not been checked\&. \fBhwloc_topology_diff_build()\fP will return 1\&. The union is a \fBhwloc_topology_diff_u::hwloc_topology_diff_too_complex_s\fP\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_topology_diff_apply (\fBhwloc_topology_t\fP topology, \fBhwloc_topology_diff_t\fP diff, unsigned long flags)"
+
+.PP
+Apply a topology diff to an existing topology\&. \fCflags\fP is an OR'ed set of \fBhwloc_topology_diff_apply_flags_e\fP\&.
+.PP
+The new topology is modified in place\&. \fBhwloc_topology_dup()\fP may be used to duplicate it before patching\&.
+.PP
+If the difference cannot be applied entirely, all previous applied elements are unapplied before returning\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&.
+.PP
+-N if applying the difference failed while trying to apply the N-th part of the difference\&. For instance -1 is returned if the very first difference element could not be applied\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_diff_build (\fBhwloc_topology_t\fP topology, \fBhwloc_topology_t\fP newtopology, unsigned long flags, \fBhwloc_topology_diff_t\fP * diff)"
+
+.PP
+Compute the difference between 2 topologies\&. The difference is stored as a list of \fBhwloc_topology_diff_t\fP entries starting at \fCdiff\fP\&. It is computed by doing a depth-first traversal of both topology trees simultaneously\&.
+.PP
+If the difference between 2 objects is too complex to be represented (for instance if some objects have different types, or different numbers of children), a special diff entry of type \fBHWLOC_TOPOLOGY_DIFF_TOO_COMPLEX\fP is queued\&. The computation of the diff does not continue below these objects\&. So each such diff entry means that the difference between two subtrees could not be computed\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 if the difference can be represented properly\&.
+.PP
+0 with \fCdiff\fP pointing to NULL if there is no difference between the topologies\&.
+.PP
+1 if the difference is too complex (see above)\&. Some entries in the list will be of type \fBHWLOC_TOPOLOGY_DIFF_TOO_COMPLEX\fP\&.
+.PP
+-1 on any other error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+\fCflags\fP is currently not used\&. It should be 0\&.
+.PP
+The output diff has to be freed with \fBhwloc_topology_diff_destroy()\fP\&.
+.PP
+The output diff can only be exported to XML or passed to \fBhwloc_topology_diff_apply()\fP if 0 was returned, i\&.e\&. if no entry of type \fBHWLOC_TOPOLOGY_DIFF_TOO_COMPLEX\fP is listed\&.
+.PP
+The output diff may be modified by removing some entries from the list\&. The removed entries should be freed by passing them to to \fBhwloc_topology_diff_destroy()\fP (possible as another list)\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_diff_destroy (\fBhwloc_topology_diff_t\fP diff)"
+
+.PP
+Destroy a list of topology differences\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_diff_export_xml (\fBhwloc_topology_diff_t\fP diff, const char * refname, const char * xmlpath)"
+
+.PP
+Export a list of topology differences to a XML file\&. If not \fCNULL\fP, \fCrefname\fP defines an identifier string for the reference topology which was used as a base when computing this difference\&. This identifier is usually the name of the other XML file that contains the reference topology\&. This attribute is given back when reading the diff from XML\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_diff_export_xmlbuffer (\fBhwloc_topology_diff_t\fP diff, const char * refname, char ** xmlbuffer, int * buflen)"
+
+.PP
+Export a list of topology differences to a XML buffer\&. If not \fCNULL\fP, \fCrefname\fP defines an identifier string for the reference topology which was used as a base when computing this difference\&. This identifier is usually the name of the other XML file that contains the reference topology\&. This attribute is given back when reading the diff from XML\&.
+.PP
+The returned buffer ends with a \\0 that is included in the returned length\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+The XML buffer should later be freed with \fBhwloc_free_xmlbuffer()\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_diff_load_xml (const char * xmlpath, \fBhwloc_topology_diff_t\fP * diff, char ** refname)"
+
+.PP
+Load a list of topology differences from a XML file\&. If not \fCNULL\fP, \fCrefname\fP will be filled with the identifier string of the reference topology for the difference file, if any was specified in the XML file\&. This identifier is usually the name of the other XML file that contains the reference topology\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+the pointer returned in refname should later be freed by the caller\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_diff_load_xmlbuffer (const char * xmlbuffer, int buflen, \fBhwloc_topology_diff_t\fP * diff, char ** refname)"
+
+.PP
+Load a list of topology differences from a XML buffer\&. Build a list of differences from the XML memory buffer given at \fCxmlbuffer\fP and of length \fCbuflen\fP (including an ending \\0)\&. This buffer may have been filled earlier with \fBhwloc_topology_diff_export_xmlbuffer()\fP\&.
+.PP
+If not \fCNULL\fP, \fCrefname\fP will be filled with the identifier string of the reference topology for the difference file, if any was specified in the XML file\&. This identifier is usually the name of the other XML file that contains the reference topology\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+the pointer returned in refname should later be freed by the caller\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_disc_backends.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_disc_backends.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_disc_backends.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_disc_backends.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,117 @@
+.TH "hwlocality_disc_backends" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_disc_backends \- Components and Plugins: Discovery backends
+.SH SYNOPSIS
+.br
+.PP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_disc_status\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_backend\fP"
+.br
+.in -1c
+.SS "Typedefs"
+
+.in +1c
+.ti -1c
+.RI "typedef enum \fBhwloc_disc_phase_e\fP \fBhwloc_disc_phase_t\fP"
+.br
+.in -1c
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_disc_phase_e\fP { \fBHWLOC_DISC_PHASE_GLOBAL\fP, \fBHWLOC_DISC_PHASE_CPU\fP, \fBHWLOC_DISC_PHASE_MEMORY\fP, \fBHWLOC_DISC_PHASE_PCI\fP, \fBHWLOC_DISC_PHASE_IO\fP, \fBHWLOC_DISC_PHASE_MISC\fP, \fBHWLOC_DISC_PHASE_ANNOTATE\fP, \fBHWLOC_DISC_PHASE_TWEAK\fP }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_disc_status_flag_e\fP { \fBHWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_backend\fP * \fBhwloc_backend_alloc\fP (struct hwloc_topology *topology, struct \fBhwloc_disc_component\fP *component)"
+.br
+.ti -1c
+.RI "int \fBhwloc_backend_enable\fP (struct \fBhwloc_backend\fP *backend)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.PP
+\fBNote\fP
+.RS 4
+These structures and functions may change when \fBHWLOC_COMPONENT_ABI\fP is modified\&. 
+.RE
+.PP
+
+.SH "Typedef Documentation"
+.PP 
+.SS "typedef enum \fBhwloc_disc_phase_e\fP \fBhwloc_disc_phase_t\fP"
+
+.PP
+Discovery phase\&. 
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_disc_phase_e\fP"
+
+.PP
+Discovery phase\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_DISC_PHASE_GLOBAL \fP\fP
+xml or synthetic, platform-specific components such as bgq\&. Discovers everything including CPU, memory, I/O and everything else\&. A component with a Global phase usually excludes all other phases\&. 
+.TP
+\fB\fIHWLOC_DISC_PHASE_CPU \fP\fP
+CPU discovery\&. 
+.TP
+\fB\fIHWLOC_DISC_PHASE_MEMORY \fP\fP
+Attach memory to existing CPU objects\&. 
+.TP
+\fB\fIHWLOC_DISC_PHASE_PCI \fP\fP
+Attach PCI devices and bridges to existing CPU objects\&. 
+.TP
+\fB\fIHWLOC_DISC_PHASE_IO \fP\fP
+I/O discovery that requires PCI devices (OS devices such as OpenCL, CUDA, etc\&.)\&. 
+.TP
+\fB\fIHWLOC_DISC_PHASE_MISC \fP\fP
+Misc objects that gets added below anything else\&. 
+.TP
+\fB\fIHWLOC_DISC_PHASE_ANNOTATE \fP\fP
+Annotating existing objects, adding distances, etc\&. 
+.TP
+\fB\fIHWLOC_DISC_PHASE_TWEAK \fP\fP
+Final tweaks to a ready-to-use topology\&. This phase runs once the topology is loaded, before it is returned to the topology\&. Hence it may only use the main hwloc API for modifying the topology, for instance by restricting it, adding info attributes, etc\&. 
+.SS "enum \fBhwloc_disc_status_flag_e\fP"
+
+.PP
+Discovery status flags\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_DISC_STATUS_FLAG_GOT_ALLOWED_RESOURCES \fP\fP
+The sets of allowed resources were already retrieved\&. 
+.SH "Function Documentation"
+.PP 
+.SS "struct \fBhwloc_backend\fP * hwloc_backend_alloc (struct hwloc_topology * topology, struct \fBhwloc_disc_component\fP * component)"
+
+.PP
+Allocate a backend structure, set good default values, initialize backend->component and topology, etc\&. The caller will then modify whatever needed, and call \fBhwloc_backend_enable()\fP\&. 
+.SS "int hwloc_backend_enable (struct \fBhwloc_backend\fP * backend)"
+
+.PP
+Enable a previously allocated and setup backend\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_disc_components.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_disc_components.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_disc_components.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_disc_components.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,28 @@
+.TH "hwlocality_disc_components" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_disc_components \- Components and Plugins: Discovery components
+.SH SYNOPSIS
+.br
+.PP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_disc_component\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.PP
+\fBNote\fP
+.RS 4
+These structures and functions may change when \fBHWLOC_COMPONENT_ABI\fP is modified\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_add.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_add.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_add.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_add.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,139 @@
+.TH "hwlocality_distances_add" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_distances_add \- Add distances between objects
+.SH SYNOPSIS
+.br
+.PP
+.SS "Typedefs"
+
+.in +1c
+.ti -1c
+.RI "typedef void * \fBhwloc_distances_add_handle_t\fP"
+.br
+.in -1c
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_distances_add_flag_e\fP { \fBHWLOC_DISTANCES_ADD_FLAG_GROUP\fP, \fBHWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_distances_add_handle_t\fP \fBhwloc_distances_add_create\fP (\fBhwloc_topology_t\fP topology, const char *name, unsigned long kind, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_distances_add_values\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_distances_add_handle_t\fP handle, unsigned nbobjs, \fBhwloc_obj_t\fP *objs, hwloc_uint64_t *values, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_distances_add_commit\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_distances_add_handle_t\fP handle, unsigned long flags)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+The usual way to add distances is: 
+.PP
+.nf
+hwloc_distances_add_handle_t handle;
+int err = \-1;
+handle = hwloc_distances_add_create(topology, "name", kind, 0);
+if (handle) {
+  err = hwloc_distances_add_values(topology, handle, nbobjs, objs, values, 0);
+  if (!err)
+    err = hwloc_distances_add_commit(topology, handle, flags);
+}
+
+.fi
+.PP
+ If \fCerr\fP is \fC0\fP at the end, then addition was successful\&. 
+.SH "Typedef Documentation"
+.PP 
+.SS "typedef void* \fBhwloc_distances_add_handle_t\fP"
+
+.PP
+Handle to a new distances structure during its addition to the topology\&. 
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_distances_add_flag_e\fP"
+
+.PP
+Flags for adding a new distances to a topology\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_DISTANCES_ADD_FLAG_GROUP \fP\fP
+Try to group objects based on the newly provided distance information\&. Grouping is only performed when the distances structure contains latencies, and when all objects are of the same type\&. 
+.TP
+\fB\fIHWLOC_DISTANCES_ADD_FLAG_GROUP_INACCURATE \fP\fP
+If grouping, consider the distance values as inaccurate and relax the comparisons during the grouping algorithms\&. The actual accuracy may be modified through the HWLOC_GROUPING_ACCURACY environment variable (see \fBEnvironment Variables\fP)\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_distances_add_commit (\fBhwloc_topology_t\fP topology, \fBhwloc_distances_add_handle_t\fP handle, unsigned long flags)"
+
+.PP
+Commit a new distances structure\&. This function finalizes the distances structure and inserts in it the topology\&.
+.PP
+Parameter \fChandle\fP was previously returned by \fBhwloc_distances_add_create()\fP\&. Then objects and values were specified with \fBhwloc_distances_add_values()\fP\&.
+.PP
+\fCflags\fP configures the behavior of the function using an optional OR'ed set of \fBhwloc_distances_add_flag_e\fP\&. It may be used to request the grouping of existing objects based on distances\&.
+.PP
+On error, the temporary distances structure and its content are destroyed\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_distances_add_handle_t\fP hwloc_distances_add_create (\fBhwloc_topology_t\fP topology, const char * name, unsigned long kind, unsigned long flags)"
+
+.PP
+Create a new empty distances structure\&. Create an empty distances structure to be filled with \fBhwloc_distances_add_values()\fP and then committed with \fBhwloc_distances_add_commit()\fP\&.
+.PP
+Parameter \fCname\fP is optional, it may be \fCNULL\fP\&. Otherwise, it will be copied internally and may later be freed by the caller\&.
+.PP
+\fCkind\fP specifies the kind of distance as a OR'ed set of \fBhwloc_distances_kind_e\fP\&. Only one kind of meaning and one kind of provenance may be given if appropriate (e\&.g\&. \fBHWLOC_DISTANCES_KIND_MEANS_BANDWIDTH\fP and \fBHWLOC_DISTANCES_KIND_FROM_USER\fP)\&. Kind \fBHWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES\fP will be automatically set according to objects having different types in \fBhwloc_distances_add_values()\fP\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+A hwloc_distances_add_handle_t that should then be passed to \fBhwloc_distances_add_values()\fP and \fBhwloc_distances_add_commit()\fP\&.
+.PP
+\fCNULL\fP on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_distances_add_values (\fBhwloc_topology_t\fP topology, \fBhwloc_distances_add_handle_t\fP handle, unsigned nbobjs, \fBhwloc_obj_t\fP * objs, hwloc_uint64_t * values, unsigned long flags)"
+
+.PP
+Specify the objects and values in a new empty distances structure\&. Specify the objects and values for a new distances structure that was returned as a handle by \fBhwloc_distances_add_create()\fP\&. The structure must then be committed with \fBhwloc_distances_add_commit()\fP\&.
+.PP
+The number of objects is \fCnbobjs\fP and the array of objects is \fCobjs\fP\&. Distance values are stored as a one-dimension array in \fCvalues\fP\&. The distance from object i to object j is in slot i*nbobjs+j\&.
+.PP
+\fCnbobjs\fP must be at least 2\&.
+.PP
+Arrays \fCobjs\fP and \fCvalues\fP will be copied internally, they may later be freed by the caller\&.
+.PP
+On error, the temporary distances structure and its content are destroyed\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_consult.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_consult.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_consult.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_consult.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,52 @@
+.TH "hwlocality_distances_consult" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_distances_consult \- Helpers for consulting distance matrices
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_distances_obj_index\fP (struct \fBhwloc_distances_s\fP *distances, \fBhwloc_obj_t\fP obj)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_distances_obj_pair_values\fP (struct \fBhwloc_distances_s\fP *distances, \fBhwloc_obj_t\fP obj1, \fBhwloc_obj_t\fP obj2, hwloc_uint64_t *value1to2, hwloc_uint64_t *value2to1)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_distances_obj_index (struct \fBhwloc_distances_s\fP * distances, \fBhwloc_obj_t\fP obj)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Find the index of an object in a distances structure\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the index of the object in the distances structure if any\&. 
+.PP
+-1 if object \fCobj\fP is not involved in structure \fCdistances\fP\&. 
+.RE
+.PP
+
+.SS "static int hwloc_distances_obj_pair_values (struct \fBhwloc_distances_s\fP * distances, \fBhwloc_obj_t\fP obj1, \fBhwloc_obj_t\fP obj2, hwloc_uint64_t * value1to2, hwloc_uint64_t * value2to1)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Find the values between two objects in a distance matrices\&. The distance from \fCobj1\fP to \fCobj2\fP is stored in the value pointed by \fCvalue1to2\fP and reciprocally\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 if object \fCobj1\fP or \fCobj2\fP is not involved in structure \fCdistances\fP\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_get.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_get.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_get.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_get.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,218 @@
+.TH "hwlocality_distances_get" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_distances_get \- Retrieve distances between objects
+.SH SYNOPSIS
+.br
+.PP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_distances_s\fP"
+.br
+.in -1c
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_distances_kind_e\fP { \fBHWLOC_DISTANCES_KIND_FROM_OS\fP, \fBHWLOC_DISTANCES_KIND_FROM_USER\fP, \fBHWLOC_DISTANCES_KIND_MEANS_LATENCY\fP, \fBHWLOC_DISTANCES_KIND_MEANS_BANDWIDTH\fP, \fBHWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES\fP }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_distances_transform_e\fP { \fBHWLOC_DISTANCES_TRANSFORM_REMOVE_NULL\fP, \fBHWLOC_DISTANCES_TRANSFORM_LINKS\fP, \fBHWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS\fP, \fBHWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_distances_get\fP (\fBhwloc_topology_t\fP topology, unsigned *nr, struct \fBhwloc_distances_s\fP **distances, unsigned long kind, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_distances_get_by_depth\fP (\fBhwloc_topology_t\fP topology, int depth, unsigned *nr, struct \fBhwloc_distances_s\fP **distances, unsigned long kind, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_distances_get_by_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, unsigned *nr, struct \fBhwloc_distances_s\fP **distances, unsigned long kind, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_distances_get_by_name\fP (\fBhwloc_topology_t\fP topology, const char *name, unsigned *nr, struct \fBhwloc_distances_s\fP **distances, unsigned long flags)"
+.br
+.ti -1c
+.RI "const char * \fBhwloc_distances_get_name\fP (\fBhwloc_topology_t\fP topology, struct \fBhwloc_distances_s\fP *distances)"
+.br
+.ti -1c
+.RI "void \fBhwloc_distances_release\fP (\fBhwloc_topology_t\fP topology, struct \fBhwloc_distances_s\fP *distances)"
+.br
+.ti -1c
+.RI "int \fBhwloc_distances_transform\fP (\fBhwloc_topology_t\fP topology, struct \fBhwloc_distances_s\fP *distances, enum \fBhwloc_distances_transform_e\fP transform, void *transform_attr, unsigned long flags)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_distances_kind_e\fP"
+
+.PP
+Kinds of distance matrices\&. The \fCkind\fP attribute of struct \fBhwloc_distances_s\fP is a OR'ed set of kinds\&.
+.PP
+Each distance matrix may have only one kind among HWLOC_DISTANCES_KIND_FROM_* specifying where distance information comes from, and one kind among HWLOC_DISTANCES_KIND_MEANS_* specifying whether values are latencies or bandwidths\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_DISTANCES_KIND_FROM_OS \fP\fP
+These distances were obtained from the operating system or hardware\&. 
+.TP
+\fB\fIHWLOC_DISTANCES_KIND_FROM_USER \fP\fP
+These distances were provided by the user\&. 
+.TP
+\fB\fIHWLOC_DISTANCES_KIND_MEANS_LATENCY \fP\fP
+Distance values are similar to latencies between objects\&. Values are smaller for closer objects, hence minimal on the diagonal of the matrix (distance between an object and itself)\&. It could also be the number of network hops between objects, etc\&. 
+.TP
+\fB\fIHWLOC_DISTANCES_KIND_MEANS_BANDWIDTH \fP\fP
+Distance values are similar to bandwidths between objects\&. Values are higher for closer objects, hence maximal on the diagonal of the matrix (distance between an object and itself)\&. Such values are currently ignored for distance-based grouping\&. 
+.TP
+\fB\fIHWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES \fP\fP
+This distances structure covers objects of different types\&. This may apply to the 'NVLinkBandwidth' structure in presence of a NVSwitch or POWER processor NVLink port\&. 
+.SS "enum \fBhwloc_distances_transform_e\fP"
+
+.PP
+Transformations of distances structures\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_DISTANCES_TRANSFORM_REMOVE_NULL \fP\fP
+Remove \fCNULL\fP objects from the distances structure\&. Every object that was replaced with \fCNULL\fP in the \fCobjs\fP array is removed and the \fCvalues\fP array is updated accordingly\&.
+.PP
+At least \fC2\fP objects must remain, otherwise \fBhwloc_distances_transform()\fP will return \fC-1\fP with \fCerrno\fP set to \fCEINVAL\fP\&.
+.PP
+\fCkind\fP will be updated with or without \fBHWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES\fP according to the remaining objects\&. 
+.TP
+\fB\fIHWLOC_DISTANCES_TRANSFORM_LINKS \fP\fP
+Replace bandwidth values with a number of links\&. Usually all values will be either \fC0\fP (no link) or \fC1\fP (one link)\&. However some matrices could get larger values if some pairs of peers are connected by different numbers of links\&.
+.PP
+Values on the diagonal are set to \fC0\fP\&.
+.PP
+This transformation only applies to bandwidth matrices\&. 
+.TP
+\fB\fIHWLOC_DISTANCES_TRANSFORM_MERGE_SWITCH_PORTS \fP\fP
+Merge switches with multiple ports into a single object\&. This currently only applies to NVSwitches where GPUs seem connected to different separate switch ports in the NVLinkBandwidth matrix\&. This transformation will replace all of them with the same port connected to all GPUs\&. Other ports are removed by applying \fBHWLOC_DISTANCES_TRANSFORM_REMOVE_NULL\fP internally\&. 
+.TP
+\fB\fIHWLOC_DISTANCES_TRANSFORM_TRANSITIVE_CLOSURE \fP\fP
+Apply a transitive closure to the matrix to connect objects across switches\&. This currently only applies to GPUs and NVSwitches in the NVLinkBandwidth matrix\&. All pairs of GPUs will be reported as directly connected\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_distances_get (\fBhwloc_topology_t\fP topology, unsigned * nr, struct \fBhwloc_distances_s\fP ** distances, unsigned long kind, unsigned long flags)"
+
+.PP
+Retrieve distance matrices\&. Retrieve distance matrices from the topology into the \fCdistances\fP array\&.
+.PP
+\fCflags\fP is currently unused, should be \fC0\fP\&.
+.PP
+\fCkind\fP serves as a filter\&. If \fC0\fP, all distance matrices are returned\&. If it contains some HWLOC_DISTANCES_KIND_FROM_*, only distance matrices whose kind matches one of these are returned\&. If it contains some HWLOC_DISTANCES_KIND_MEANS_*, only distance matrices whose kind matches one of these are returned\&.
+.PP
+On input, \fCnr\fP points to the number of distance matrices that may be stored in \fCdistances\fP\&. On output, \fCnr\fP points to the number of distance matrices that were actually found, even if some of them couldn't be stored in \fCdistances\fP\&. Distance matrices that couldn't be stored are ignored, but the function still returns success (\fC0\fP)\&. The caller may find out by comparing the value pointed by \fCnr\fP before and after the function call\&.
+.PP
+Each distance matrix returned in the \fCdistances\fP array should be released by the caller using \fBhwloc_distances_release()\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_distances_get_by_depth (\fBhwloc_topology_t\fP topology, int depth, unsigned * nr, struct \fBhwloc_distances_s\fP ** distances, unsigned long kind, unsigned long flags)"
+
+.PP
+Retrieve distance matrices for object at a specific depth in the topology\&. Identical to \fBhwloc_distances_get()\fP with the additional \fCdepth\fP filter\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_distances_get_by_name (\fBhwloc_topology_t\fP topology, const char * name, unsigned * nr, struct \fBhwloc_distances_s\fP ** distances, unsigned long flags)"
+
+.PP
+Retrieve a distance matrix with the given name\&. Usually only one distances structure may match a given name\&.
+.PP
+The name of the most common structure is 'NUMALatency'\&. Others include 'XGMIBandwidth', 'XGMIHops', 'XeLinkBandwidth', and 'NVLinkBandwidth'\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_distances_get_by_type (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, unsigned * nr, struct \fBhwloc_distances_s\fP ** distances, unsigned long kind, unsigned long flags)"
+
+.PP
+Retrieve distance matrices for object of a specific type\&. Identical to \fBhwloc_distances_get()\fP with the additional \fCtype\fP filter\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "const char * hwloc_distances_get_name (\fBhwloc_topology_t\fP topology, struct \fBhwloc_distances_s\fP * distances)"
+
+.PP
+Get a description of what a distances structure contains\&. For instance 'NUMALatency' for hardware-provided NUMA distances (ACPI SLIT), or \fCNULL\fP if unknown\&.
+.PP
+\fBReturns\fP
+.RS 4
+the constant string with the name of the distance structure\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+The returned name should not be freed by the caller, it belongs to the hwloc library\&. 
+.RE
+.PP
+
+.SS "void hwloc_distances_release (\fBhwloc_topology_t\fP topology, struct \fBhwloc_distances_s\fP * distances)"
+
+.PP
+Release a distance matrix structure previously returned by \fBhwloc_distances_get()\fP\&. 
+.PP
+\fBNote\fP
+.RS 4
+This function is not required if the structure is removed with \fBhwloc_distances_release_remove()\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_distances_transform (\fBhwloc_topology_t\fP topology, struct \fBhwloc_distances_s\fP * distances, enum \fBhwloc_distances_transform_e\fP transform, void * transform_attr, unsigned long flags)"
+
+.PP
+Apply a transformation to a distances structure\&. Modify a distances structure that was previously obtained with \fBhwloc_distances_get()\fP or one of its variants\&.
+.PP
+This modifies the local copy of the distances structures but does not modify the distances information stored inside the topology (retrieved by another call to \fBhwloc_distances_get()\fP or exported to XML)\&. To do so, one should add a new distances structure with same name, kind, objects and values (see \fBAdd distances between objects\fP) and then remove this old one with \fBhwloc_distances_release_remove()\fP\&.
+.PP
+\fCtransform\fP must be one of the transformations listed in \fBhwloc_distances_transform_e\fP\&.
+.PP
+These transformations may modify the contents of the \fCobjs\fP or \fCvalues\fP arrays\&.
+.PP
+\fCtransform_attr\fP must be \fCNULL\fP for now\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error for instance if flags are invalid\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Objects in distances array \fCobjs\fP may be directly modified in place without using \fBhwloc_distances_transform()\fP\&. One may use \fBhwloc_get_obj_with_same_locality()\fP to easily convert between similar objects of different types\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_remove.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_remove.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_remove.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_distances_remove.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,78 @@
+.TH "hwlocality_distances_remove" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_distances_remove \- Remove distances between objects
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_distances_remove\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "int \fBhwloc_distances_remove_by_depth\fP (\fBhwloc_topology_t\fP topology, int depth)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_distances_remove_by_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "int \fBhwloc_distances_release_remove\fP (\fBhwloc_topology_t\fP topology, struct \fBhwloc_distances_s\fP *distances)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_distances_release_remove (\fBhwloc_topology_t\fP topology, struct \fBhwloc_distances_s\fP * distances)"
+
+.PP
+Release and remove the given distance matrice from the topology\&. This function includes a call to \fBhwloc_distances_release()\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_distances_remove (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Remove all distance matrices from a topology\&. Remove all distance matrices, either provided by the user or gathered through the OS\&.
+.PP
+If these distances were used to group objects, these additional Group objects are not removed from the topology\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_distances_remove_by_depth (\fBhwloc_topology_t\fP topology, int depth)"
+
+.PP
+Remove distance matrices for objects at a specific depth in the topology\&. Identical to \fBhwloc_distances_remove()\fP but only applies to one level of the topology\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "static int hwloc_distances_remove_by_type (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Remove distance matrices for objects of a specific type in the topology\&. Identical to \fBhwloc_distances_remove()\fP but only applies to one level of the topology\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_generic_components.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_generic_components.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_generic_components.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_generic_components.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,63 @@
+.TH "hwlocality_generic_components" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_generic_components \- Components and Plugins: Generic components
+.SH SYNOPSIS
+.br
+.PP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_component\fP"
+.br
+.in -1c
+.SS "Typedefs"
+
+.in +1c
+.ti -1c
+.RI "typedef enum \fBhwloc_component_type_e\fP \fBhwloc_component_type_t\fP"
+.br
+.in -1c
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_component_type_e\fP { \fBHWLOC_COMPONENT_TYPE_DISC\fP, \fBHWLOC_COMPONENT_TYPE_XML\fP }"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.PP
+\fBNote\fP
+.RS 4
+These structures and functions may change when \fBHWLOC_COMPONENT_ABI\fP is modified\&. 
+.RE
+.PP
+
+.SH "Typedef Documentation"
+.PP 
+.SS "typedef enum \fBhwloc_component_type_e\fP \fBhwloc_component_type_t\fP"
+
+.PP
+Generic component type\&. 
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_component_type_e\fP"
+
+.PP
+Generic component type\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_COMPONENT_TYPE_DISC \fP\fP
+The data field must point to a struct \fBhwloc_disc_component\fP\&. 
+.TP
+\fB\fIHWLOC_COMPONENT_TYPE_XML \fP\fP
+The data field must point to a struct hwloc_xml_component\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_gl.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_gl.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_gl.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_gl.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,84 @@
+.TH "hwlocality_gl" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_gl \- Interoperability with OpenGL displays
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_gl_get_display_osdev_by_port_device\fP (\fBhwloc_topology_t\fP topology, unsigned port, unsigned device)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_gl_get_display_osdev_by_name\fP (\fBhwloc_topology_t\fP topology, const char *name)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_gl_get_display_by_osdev\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP osdev, unsigned *port, unsigned *device)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This interface offers ways to retrieve topology information about OpenGL displays\&.
+.PP
+Only the NVIDIA display locality information is currently available, using the NV-CONTROL X11 extension and the NVCtrl library\&. 
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_gl_get_display_by_osdev (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP osdev, unsigned * port, unsigned * device)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the OpenGL display port and device corresponding to the given hwloc OS object\&. Retrieves the OpenGL display port (server) in \fCport\fP and device (screen) in \fCscreen\fP that correspond to the given hwloc OS device object\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 if none could be found\&.
+.RE
+.PP
+The topology \fCtopology\fP does not necessarily have to match the current machine\&. For instance the topology may be an XML import of a remote host\&. I/O devices detection and the GL component must be enabled in the topology\&. 
+.SS "static \fBhwloc_obj_t\fP hwloc_gl_get_display_osdev_by_name (\fBhwloc_topology_t\fP topology, const char * name)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to the OpenGL display given by name\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object describing the OpenGL display whose name is \fCname\fP, built as ':port\&.device' such as ':0\&.0' \&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+The topology \fCtopology\fP does not necessarily have to match the current machine\&. For instance the topology may be an XML import of a remote host\&. I/O devices detection and the GL component must be enabled in the topology\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_gl_get_display_osdev_by_port_device (\fBhwloc_topology_t\fP topology, unsigned port, unsigned device)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to the OpenGL display given by port and device index\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object describing the OpenGL display whose port (server) is \fCport\fP and device (screen) is \fCdevice\fP\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+The topology \fCtopology\fP does not necessarily have to match the current machine\&. For instance the topology may be an XML import of a remote host\&. I/O devices detection and the GL component must be enabled in the topology\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out)\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_glibc_sched.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_glibc_sched.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_glibc_sched.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_glibc_sched.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,61 @@
+.TH "hwlocality_glibc_sched" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_glibc_sched \- Interoperability with glibc sched affinity
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_cpuset_to_glibc_sched_affinity\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP hwlocset, cpu_set_t *schedset, size_t schedsetsize)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_cpuset_from_glibc_sched_affinity\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP hwlocset, const cpu_set_t *schedset, size_t schedsetsize)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This interface offers ways to convert between hwloc cpusets and glibc cpusets such as those manipulated by sched_getaffinity() or pthread_attr_setaffinity_np()\&.
+.PP
+\fBNote\fP
+.RS 4
+Topology \fCtopology\fP must match the current machine\&. 
+.RE
+.PP
+
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_cpuset_from_glibc_sched_affinity (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP hwlocset, const cpu_set_t * schedset, size_t schedsetsize)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert glibc sched affinity CPU set \fCschedset\fP into hwloc CPU set\&. This function may be used before calling sched_setaffinity or any other function that takes a cpu_set_t as input parameter\&.
+.PP
+\fCschedsetsize\fP should be sizeof(cpu_set_t) unless \fCschedset\fP was dynamically allocated with CPU_ALLOC
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOMEM\fP if some internal reallocation failed\&. 
+.RE
+.PP
+
+.SS "static int hwloc_cpuset_to_glibc_sched_affinity (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP hwlocset, cpu_set_t * schedset, size_t schedsetsize)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert hwloc CPU set \fCtoposet\fP into glibc sched affinity CPU set \fCschedset\fP\&. This function may be used before calling sched_setaffinity or any other function that takes a cpu_set_t as input parameter\&.
+.PP
+\fCschedsetsize\fP should be sizeof(cpu_set_t) unless \fCschedset\fP was dynamically allocated with CPU_ALLOC
+.PP
+\fBReturns\fP
+.RS 4
+0\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_ancestors.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_ancestors.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_ancestors.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_ancestors.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,120 @@
+.TH "hwlocality_helper_ancestors" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_helper_ancestors \- Looking at Ancestor and Child Objects
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_ancestor_obj_by_depth\fP (\fBhwloc_topology_t\fP topology, int depth, \fBhwloc_obj_t\fP obj)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_ancestor_obj_by_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, \fBhwloc_obj_t\fP obj)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_common_ancestor_obj\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj1, \fBhwloc_obj_t\fP obj2)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_obj_is_in_subtree\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj, \fBhwloc_obj_t\fP subtree_root)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_next_child\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP parent, \fBhwloc_obj_t\fP prev)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Be sure to see the figure in \fBTerms and Definitions\fP that shows a complete topology tree, including depths, child/sibling/cousin relationships, and an example of an asymmetric topology where one package has fewer caches than its peers\&. 
+.SH "Function Documentation"
+.PP 
+.SS "static \fBhwloc_obj_t\fP hwloc_get_ancestor_obj_by_depth (\fBhwloc_topology_t\fP topology, int depth, \fBhwloc_obj_t\fP obj)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the ancestor object of \fCobj\fP at depth \fCdepth\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the ancestor if any\&. 
+.PP
+\fCNULL\fP if no such ancestor exists\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+\fCdepth\fP should not be the depth of PU or NUMA objects since they are ancestors of no objects (except Misc or I/O)\&. This function rather expects an intermediate level depth, such as the depth of Packages, Cores, or Caches\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_ancestor_obj_by_type (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, \fBhwloc_obj_t\fP obj)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the ancestor object of \fCobj\fP with type \fCtype\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the ancestor if any\&. 
+.PP
+\fCNULL\fP if no such ancestor exists\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+if multiple matching ancestors exist (e\&.g\&. multiple levels of \fBHWLOC_OBJ_GROUP\fP) the lowest one is returned\&.
+.PP
+\fCtype\fP should not be \fBHWLOC_OBJ_PU\fP or \fBHWLOC_OBJ_NUMANODE\fP since these objects are ancestors of no objects (except Misc or I/O)\&. This function rather expects an intermediate object type, such as \fBHWLOC_OBJ_PACKAGE\fP, \fBHWLOC_OBJ_CORE\fP, etc\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_common_ancestor_obj (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj1, \fBhwloc_obj_t\fP obj2)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the common parent object to objects \fCobj1\fP and \fCobj2\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the common ancestor\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot return \fCNULL\fP\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_next_child (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP parent, \fBhwloc_obj_t\fP prev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Return the next child\&. Return the next child among the normal children list, then among the memory children list, then among the I/O children list, then among the Misc children list\&.
+.PP
+\fBReturns\fP
+.RS 4
+the first child if \fCprev\fP is \fCNULL\fP\&. 
+.PP
+the next child if \fCprev\fP is not \fCNULL\fP\&. 
+.PP
+\fCNULL\fP when there is no next child\&. 
+.RE
+.PP
+
+.SS "static int hwloc_obj_is_in_subtree (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj, \fBhwloc_obj_t\fP subtree_root)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns true if \fCobj\fP is inside the subtree beginning with ancestor object \fCsubtree_root\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+1 is the object is in the subtree, 0 otherwise\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot work if \fCobj\fP and \fCsubtree_root\fP objects do not have CPU sets (I/O or Misc objects)\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_distribute.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_distribute.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_distribute.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_distribute.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,68 @@
+.TH "hwlocality_helper_distribute" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_helper_distribute \- Distributing items over a topology
+.SH SYNOPSIS
+.br
+.PP
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_distrib_flags_e\fP { \fBHWLOC_DISTRIB_FLAG_REVERSE\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_distrib\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP *roots, unsigned n_roots, \fBhwloc_cpuset_t\fP *set, unsigned n, int until, unsigned long flags)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_distrib_flags_e\fP"
+
+.PP
+Flags to be given to \fBhwloc_distrib()\fP\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_DISTRIB_FLAG_REVERSE \fP\fP
+Distrib in reverse order, starting from the last objects\&. 
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_distrib (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP * roots, unsigned n_roots, \fBhwloc_cpuset_t\fP * set, unsigned n, int until, unsigned long flags)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Distribute \fCn\fP items over the topology under \fCroots\fP\&. Array \fCset\fP will be filled with \fCn\fP cpusets recursively distributed linearly over the topology under objects \fCroots\fP, down to depth \fCuntil\fP (which can be INT_MAX to distribute down to the finest level)\&.
+.PP
+\fCn_roots\fP is usually 1 and \fCroots\fP only contains the topology root object so as to distribute over the entire topology\&.
+.PP
+This is typically useful when an application wants to distribute \fCn\fP threads over a machine, giving each of them as much private cache as possible and keeping them locally in number order\&.
+.PP
+The caller may typically want to also call \fBhwloc_bitmap_singlify()\fP before binding a thread so that it does not move at all\&.
+.PP
+\fCflags\fP should be 0 or a OR'ed set of \fBhwloc_distrib_flags_e\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+On hybrid CPUs (or asymmetric platforms), distribution may be suboptimal since the number of cores or PUs inside packages or below caches may vary (the top-down recursive partitioning ignores these numbers until reaching their levels)\&. Hence it is recommended to distribute only inside a single homogeneous domain\&. For instance on a CPU with energy-efficient E-cores and high-performance P-cores, one should distribute separately N tasks on E-cores and M tasks on P-cores instead of trying to distribute directly M+N tasks on the entire CPUs\&.
+.PP
+This function requires the \fCroots\fP objects to have a CPU set\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_cache.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_cache.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_cache.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_cache.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,74 @@
+.TH "hwlocality_helper_find_cache" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_helper_find_cache \- Looking at Cache Objects
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_get_cache_type_depth\fP (\fBhwloc_topology_t\fP topology, unsigned cachelevel, \fBhwloc_obj_cache_type_t\fP cachetype)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_cache_covering_cpuset\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_shared_cache_covering_obj\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Function Documentation"
+.PP 
+.SS "static \fBhwloc_obj_t\fP hwloc_get_cache_covering_cpuset (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the first data (or unified) cache covering a cpuset \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+a covering cache, or \fCNULL\fP if no cache matches\&. 
+.RE
+.PP
+
+.SS "static int hwloc_get_cache_type_depth (\fBhwloc_topology_t\fP topology, unsigned cachelevel, \fBhwloc_obj_cache_type_t\fP cachetype)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Find the depth of cache objects matching cache level and type\&. Return the depth of the topology level that contains cache objects whose attributes match \fCcachelevel\fP and \fCcachetype\fP\&.
+.PP
+This function is identical to calling \fBhwloc_get_type_depth()\fP with the corresponding type such as \fBHWLOC_OBJ_L1ICACHE\fP, except that it may also return a Unified cache when looking for an instruction cache\&.
+.PP
+\fBReturns\fP
+.RS 4
+the depth of the unique matching unified cache level is returned if \fCcachetype\fP is \fBHWLOC_OBJ_CACHE_UNIFIED\fP\&.
+.PP
+the depth of either a matching cache level or a unified cache level if \fCcachetype\fP is \fBHWLOC_OBJ_CACHE_DATA\fP or \fBHWLOC_OBJ_CACHE_INSTRUCTION\fP\&.
+.PP
+the depth of the matching level if \fCcachetype\fP is \fC-1\fP but only one level matches\&.
+.PP
+\fBHWLOC_TYPE_DEPTH_MULTIPLE\fP if \fCcachetype\fP is \fC-1\fP but multiple levels match\&.
+.PP
+\fBHWLOC_TYPE_DEPTH_UNKNOWN\fP if no cache level matches\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_shared_cache_covering_obj (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the first data (or unified) cache shared between an object and somebody else\&. 
+.PP
+\fBReturns\fP
+.RS 4
+a shared cache\&. 
+.PP
+\fCNULL\fP if no cache matches or if an invalid object is given (e\&.g\&. I/O object)\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_covering.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_covering.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_covering.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_covering.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,107 @@
+.TH "hwlocality_helper_find_covering" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_helper_find_covering \- Finding Objects covering at least CPU set
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_child_covering_cpuset\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_t\fP parent)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_obj_covering_cpuset\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_next_obj_covering_cpuset_by_depth\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, int depth, \fBhwloc_obj_t\fP prev)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_next_obj_covering_cpuset_by_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_type_t\fP type, \fBhwloc_obj_t\fP prev)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Function Documentation"
+.PP 
+.SS "static \fBhwloc_obj_t\fP hwloc_get_child_covering_cpuset (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_t\fP parent)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the child covering at least CPU set \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the child that covers the set entirely\&. 
+.PP
+\fCNULL\fP if no child matches or if \fCset\fP is empty\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot work if parent does not have a CPU set (I/O or Misc objects)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_next_obj_covering_cpuset_by_depth (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, int depth, \fBhwloc_obj_t\fP prev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Iterate through same-depth objects covering at least CPU set \fCset\fP\&. The next invokation should pass the previous return value in \fCprev\fP so as to obtain the next object covering at least another part of \fCset\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+the first object at depth \fCdepth\fP covering at least part of CPU set \fCset\fP if object \fCprev\fP is \fCNULL\fP\&. 
+.PP
+the next one if \fCprev\fP is not \fCNULL\fP\&. 
+.PP
+\fCNULL\fP if there is no next object\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot work if objects at the given depth do not have CPU sets (I/O or Misc objects)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_next_obj_covering_cpuset_by_type (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_type_t\fP type, \fBhwloc_obj_t\fP prev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Iterate through same-type objects covering at least CPU set \fCset\fP\&. The next invokation should pass the previous return value in \fCprev\fP so as to obtain the next object of type \fCtype\fP covering at least another part of \fCset\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+the first object of type \fCtype\fP covering at least part of CPU set \fCset\fP if object \fCprev\fP is \fCNULL\fP\&. 
+.PP
+the next one if \fCprev\fP is not \fCNULL\fP\&. 
+.PP
+\fCNULL\fP if there is no next object\&. 
+.PP
+\fCNULL\fP if there is no depth for the given type\&. 
+.PP
+\fCNULL\fP if there are multiple depths for the given type, the caller should fallback to \fBhwloc_get_next_obj_covering_cpuset_by_depth()\fP\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot work if objects of the given type do not have CPU sets (I/O or Misc objects)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_obj_covering_cpuset (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the lowest object covering at least CPU set \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the lowest object covering the set entirely\&. 
+.PP
+\fCNULL\fP if no object matches or if \fCset\fP is empty\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_inside.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_inside.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_inside.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_inside.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,225 @@
+.TH "hwlocality_helper_find_inside" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_helper_find_inside \- Finding Objects inside a CPU set
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_first_largest_obj_inside_cpuset\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_largest_objs_inside_cpuset\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_t\fP *restrict objs, int max)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_next_obj_inside_cpuset_by_depth\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, int depth, \fBhwloc_obj_t\fP prev)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_next_obj_inside_cpuset_by_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_type_t\fP type, \fBhwloc_obj_t\fP prev)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_obj_inside_cpuset_by_depth\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, int depth, unsigned idx)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_obj_inside_cpuset_by_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_type_t\fP type, unsigned idx)"
+.br
+.ti -1c
+.RI "static unsigned \fBhwloc_get_nbobjs_inside_cpuset_by_depth\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, int depth)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_get_nbobjs_inside_cpuset_by_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_get_obj_index_inside_cpuset\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_t\fP obj)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Function Documentation"
+.PP 
+.SS "static \fBhwloc_obj_t\fP hwloc_get_first_largest_obj_inside_cpuset (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the first largest object included in the given cpuset \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the first object that is included in \fCset\fP and whose parent is not\&. 
+.PP
+\fCNULL\fP if no such object exists\&.
+.RE
+.PP
+This is convenient for iterating over all largest objects within a CPU set by doing a loop getting the first largest object and clearing its CPU set from the remaining CPU set\&. 
+.SS "int hwloc_get_largest_objs_inside_cpuset (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_t\fP *restrict objs, int max)"
+
+.PP
+Get the set of largest objects covering exactly a given cpuset \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the number of objects returned in \fCobjs\fP\&. 
+.PP
+-1 if no set of objects may cover that cpuset\&. 
+.RE
+.PP
+
+.SS "static unsigned hwloc_get_nbobjs_inside_cpuset_by_depth (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, int depth)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Return the number of objects at depth \fCdepth\fP included in CPU set \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the number of objects\&. 
+.PP
+0 if the depth is invalid\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set)\&.
+.PP
+This function cannot work if objects at the given depth do not have CPU sets (I/O or Misc objects)\&. 
+.RE
+.PP
+
+.SS "static int hwloc_get_nbobjs_inside_cpuset_by_type (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_type_t\fP type)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Return the number of objects of type \fCtype\fP included in CPU set \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the number of objects\&. 
+.PP
+0 if there are no objects of that type in the topology\&. 
+.PP
+-1 if there are multiple levels of objects of that type, the caller should fallback to \fBhwloc_get_nbobjs_inside_cpuset_by_depth()\fP\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set)\&.
+.PP
+This function cannot work if objects of the given type do not have CPU sets (I/O objects)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_next_obj_inside_cpuset_by_depth (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, int depth, \fBhwloc_obj_t\fP prev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Return the next object at depth \fCdepth\fP included in CPU set \fCset\fP\&. The next invokation should pass the previous return value in \fCprev\fP so as to obtain the next object in \fCset\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+the first object at depth \fCdepth\fP included in \fCset\fP if \fCprev\fP is \fCNULL\fP\&. 
+.PP
+the next object at depth \fCdepth\fP included in \fCset\fP if \fCprev\fP is not \fCNULL\fP\&. 
+.PP
+\fCNULL\fP if there is no next object\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set)\&.
+.PP
+This function cannot work if objects at the given depth do not have CPU sets (I/O or Misc objects)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_next_obj_inside_cpuset_by_type (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_type_t\fP type, \fBhwloc_obj_t\fP prev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Return the next object of type \fCtype\fP included in CPU set \fCset\fP\&. The next invokation should pass the previous return value in \fCprev\fP so as to obtain the next object in \fCset\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+the first object of type \fCtype\fP included in \fCset\fP if \fCprev\fP is \fCNULL\fP\&. 
+.PP
+the next object of type \fCtype\fP included in \fCset\fP if \fCprev\fP is not \fCNULL\fP\&. 
+.PP
+\fCNULL\fP if there is no next object\&. 
+.PP
+\fCNULL\fP if there is no depth for the given type\&. 
+.PP
+\fCNULL\fP if there are multiple depths for the given type, the caller should fallback to \fBhwloc_get_next_obj_inside_cpuset_by_depth()\fP\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set)\&.
+.PP
+This function cannot work if objects of the given type do not have CPU sets (I/O or Misc objects)\&. 
+.RE
+.PP
+
+.SS "static int hwloc_get_obj_index_inside_cpuset (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_t\fP obj)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Return the logical index among the objects included in CPU set \fCset\fP\&. Consult all objects in the same level as \fCobj\fP and inside CPU set \fCset\fP in the logical order, and return the index of \fCobj\fP within them\&. If \fCset\fP covers the entire topology, this is the logical index of \fCobj\fP\&. Otherwise, this is similar to a logical index within the part of the topology defined by CPU set \fCset\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+the logical index among the objects included in the set if any\&. 
+.PP
+-1 if the object is not included in the set\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set)\&.
+.PP
+This function cannot work if obj does not have CPU sets (I/O objects)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_obj_inside_cpuset_by_depth (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, int depth, unsigned idx)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Return the (logically) \fCidx\fP -th object at depth \fCdepth\fP included in CPU set \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the object if any, \fCNULL\fP otherwise\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set)\&.
+.PP
+This function cannot work if objects at the given depth do not have CPU sets (I/O or Misc objects)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_obj_inside_cpuset_by_type (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP set, \fBhwloc_obj_type_t\fP type, unsigned idx)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Return the \fCidx\fP -th object of type \fCtype\fP included in CPU set \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the object if any\&. 
+.PP
+\fCNULL\fP if there is no such object\&. 
+.PP
+\fCNULL\fP if there is no depth for given type\&. 
+.PP
+\fCNULL\fP if there are multiple depths for given type, the caller should fallback to \fBhwloc_get_obj_inside_cpuset_by_depth()\fP\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Objects with empty CPU sets are ignored (otherwise they would be considered included in any given set)\&.
+.PP
+This function cannot work if objects of the given type do not have CPU sets (I/O or Misc objects)\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_misc.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_misc.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_misc.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_find_misc.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,166 @@
+.TH "hwlocality_helper_find_misc" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_helper_find_misc \- Finding objects, miscellaneous helpers
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_bitmap_singlify_per_core\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_bitmap_t\fP cpuset, unsigned which)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_pu_obj_by_os_index\fP (\fBhwloc_topology_t\fP topology, unsigned os_index)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_numanode_obj_by_os_index\fP (\fBhwloc_topology_t\fP topology, unsigned os_index)"
+.br
+.ti -1c
+.RI "unsigned \fBhwloc_get_closest_objs\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP src, \fBhwloc_obj_t\fP *restrict objs, unsigned max)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_obj_below_by_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type1, unsigned idx1, \fBhwloc_obj_type_t\fP type2, unsigned idx2)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_obj_below_array_by_type\fP (\fBhwloc_topology_t\fP topology, int nr, \fBhwloc_obj_type_t\fP *typev, unsigned *idxv)"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_t\fP \fBhwloc_get_obj_with_same_locality\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP src, \fBhwloc_obj_type_t\fP type, const char *subtype, const char *nameprefix, unsigned long flags)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Be sure to see the figure in \fBTerms and Definitions\fP that shows a complete topology tree, including depths, child/sibling/cousin relationships, and an example of an asymmetric topology where one package has fewer caches than its peers\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_bitmap_singlify_per_core (\fBhwloc_topology_t\fP topology, \fBhwloc_bitmap_t\fP cpuset, unsigned which)"
+
+.PP
+Remove simultaneous multithreading PUs from a CPU set\&. For each core in \fCtopology\fP, if \fCcpuset\fP contains some PUs of that core, modify \fCcpuset\fP to only keep a single PU for that core\&.
+.PP
+\fCwhich\fP specifies which PU will be kept\&. PU are considered in physical index order\&. If 0, for each core, the function keeps the first PU that was originally set in \fCcpuset\fP\&.
+.PP
+If \fCwhich\fP is larger than the number of PUs in a core there were originally set in \fCcpuset\fP, no PU is kept for that core\&.
+.PP
+\fBReturns\fP
+.RS 4
+0\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+PUs that are not below a Core object are ignored (for instance if the topology does not contain any Core object)\&. None of them is removed from \fCcpuset\fP\&. 
+.RE
+.PP
+
+.SS "unsigned hwloc_get_closest_objs (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP src, \fBhwloc_obj_t\fP *restrict objs, unsigned max)"
+
+.PP
+Do a depth-first traversal of the topology to find and sort\&. all objects that are at the same depth than \fCsrc\fP\&. Report in \fCobjs\fP up to \fCmax\fP physically closest ones to \fCsrc\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+the number of objects returned in \fCobjs\fP\&.
+.PP
+0 if \fCsrc\fP is an I/O object\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function requires the \fCsrc\fP object to have a CPU set\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_numanode_obj_by_os_index (\fBhwloc_topology_t\fP topology, unsigned os_index)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the object of type \fBHWLOC_OBJ_NUMANODE\fP with \fCos_index\fP\&. This function is useful for converting a nodeset into the NUMA node objects it contains\&. When retrieving the current binding (e\&.g\&. with \fBhwloc_get_membind()\fP with HWLOC_MEMBIND_BYNODESET), one may iterate over the bits of the resulting nodeset with \fBhwloc_bitmap_foreach_begin()\fP, and find the corresponding NUMA nodes with this function\&.
+.PP
+\fBReturns\fP
+.RS 4
+the NUMA node object, or \fCNULL\fP if none matches\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_obj_below_array_by_type (\fBhwloc_topology_t\fP topology, int nr, \fBhwloc_obj_type_t\fP * typev, unsigned * idxv)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Find an object below a chain of objects specified by types and indexes\&. This is a generalized version of \fBhwloc_get_obj_below_by_type()\fP\&.
+.PP
+Arrays \fCtypev\fP and \fCidxv\fP must contain \fCnr\fP types and indexes\&.
+.PP
+Start from the top system object and walk the arrays \fCtypev\fP and \fCidxv\fP\&. For each type and logical index couple in the arrays, look under the previously found object to find the index-th object of the given type\&. Indexes are specified within the parent, not withing the entire system\&.
+.PP
+For instance, if nr is 3, typev contains NODE, PACKAGE and CORE, and idxv contains 0, 1 and 2, return the third core object below the second package below the first NUMA node\&.
+.PP
+\fBReturns\fP
+.RS 4
+a matching object if any, \fCNULL\fP otherwise\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function requires all these objects and the root object to have a CPU set\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_obj_below_by_type (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type1, unsigned idx1, \fBhwloc_obj_type_t\fP type2, unsigned idx2)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Find an object below another object, both specified by types and indexes\&. Start from the top system object and find object of type \fCtype1\fP and logical index \fCidx1\fP\&. Then look below this object and find another object of type \fCtype2\fP and logical index \fCidx2\fP\&. Indexes are specified within the parent, not withing the entire system\&.
+.PP
+For instance, if type1 is PACKAGE, idx1 is 2, type2 is CORE and idx2 is 3, return the fourth core object below the third package\&.
+.PP
+\fBReturns\fP
+.RS 4
+a matching object if any, \fCNULL\fP otherwise\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function requires these objects to have a CPU set\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_obj_t\fP hwloc_get_obj_with_same_locality (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP src, \fBhwloc_obj_type_t\fP type, const char * subtype, const char * nameprefix, unsigned long flags)"
+
+.PP
+Return an object of a different type with same locality\&. If the source object \fCsrc\fP is a normal or memory type, this function returns an object of type \fCtype\fP with same CPU and node sets, either below or above in the hierarchy\&.
+.PP
+If the source object \fCsrc\fP is a PCI or an OS device within a PCI device, the function may either return that PCI device, or another OS device in the same PCI parent\&. This may for instance be useful for converting between OS devices such as 'nvml0' or 'rsmi1' used in distance structures into the the PCI device, or the CUDA or OpenCL OS device that correspond to the same physical card\&.
+.PP
+If not \fCNULL\fP, parameter \fCsubtype\fP only select objects whose subtype attribute exists and is \fCsubtype\fP (case-insensitively), for instance 'OpenCL' or 'CUDA'\&.
+.PP
+If not \fCNULL\fP, parameter \fCnameprefix\fP only selects objects whose name attribute exists and starts with \fCnameprefix\fP (case-insensitively), for instance 'rsmi' for matching 'rsmi0'\&.
+.PP
+If multiple objects match, the first one is returned\&.
+.PP
+This function will not walk the hierarchy across bridges since the PCI locality may become different\&. This function cannot also convert between normal/memory objects and I/O or Misc objects\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+An object with identical locality, matching \fCsubtype\fP and \fCnameprefix\fP if any\&.
+.PP
+\fCNULL\fP if no matching object could be found, or if the source object and target type are incompatible, for instance if converting between CPU and I/O objects\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_pu_obj_by_os_index (\fBhwloc_topology_t\fP topology, unsigned os_index)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the object of type \fBHWLOC_OBJ_PU\fP with \fCos_index\fP\&. This function is useful for converting a CPU set into the PU objects it contains\&. When retrieving the current binding (e\&.g\&. with \fBhwloc_get_cpubind()\fP), one may iterate over the bits of the resulting CPU set with \fBhwloc_bitmap_foreach_begin()\fP, and find the corresponding PUs with this function\&.
+.PP
+\fBReturns\fP
+.RS 4
+the PU object, or \fCNULL\fP if none matches\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_nodeset_convert.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_nodeset_convert.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_nodeset_convert.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_nodeset_convert.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,60 @@
+.TH "hwlocality_helper_nodeset_convert" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_helper_nodeset_convert \- Converting between CPU sets and node sets
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_cpuset_to_nodeset\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP _cpuset, \fBhwloc_nodeset_t\fP nodeset)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_cpuset_from_nodeset\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP _cpuset, \fBhwloc_const_nodeset_t\fP nodeset)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_cpuset_from_nodeset (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP _cpuset, \fBhwloc_const_nodeset_t\fP nodeset)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert a NUMA node set into a CPU set\&. For each NUMA node included in the input \fCnodeset\fP, set the corresponding local PUs in the output \fC_cpuset\fP\&.
+.PP
+If some CPUs have no local NUMA nodes, this function never sets their indexes in the output CPU set, even if a full node set is given in input\&.
+.PP
+Hence the entire topology node set is converted into the set of all CPUs that have some local NUMA nodes\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOMEM\fP on internal reallocation failure\&. 
+.RE
+.PP
+
+.SS "static int hwloc_cpuset_to_nodeset (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP _cpuset, \fBhwloc_nodeset_t\fP nodeset)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert a CPU set into a NUMA node set\&. For each PU included in the input \fC_cpuset\fP, set the corresponding local NUMA node(s) in the output \fCnodeset\fP\&.
+.PP
+If some NUMA nodes have no CPUs at all, this function never sets their indexes in the output node set, even if a full CPU set is given in input\&.
+.PP
+Hence the entire topology CPU set is converted into the set of all nodes that have some local CPUs\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOMEM\fP on internal reallocation failure\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_topology_sets.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_topology_sets.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_topology_sets.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_topology_sets.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,162 @@
+.TH "hwlocality_helper_topology_sets" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_helper_topology_sets \- CPU and node sets of entire topologies
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "\fBhwloc_const_cpuset_t\fP \fBhwloc_topology_get_complete_cpuset\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "\fBhwloc_const_cpuset_t\fP \fBhwloc_topology_get_topology_cpuset\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "\fBhwloc_const_cpuset_t\fP \fBhwloc_topology_get_allowed_cpuset\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "\fBhwloc_const_nodeset_t\fP \fBhwloc_topology_get_complete_nodeset\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "\fBhwloc_const_nodeset_t\fP \fBhwloc_topology_get_topology_nodeset\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "\fBhwloc_const_nodeset_t\fP \fBhwloc_topology_get_allowed_nodeset\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Function Documentation"
+.PP 
+.SS "\fBhwloc_const_cpuset_t\fP hwloc_topology_get_allowed_cpuset (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Get allowed CPU set\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the CPU set of allowed processors of the system\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot return \fCNULL\fP\&.
+.PP
+If the topology flag \fBHWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED\fP was not set, this is identical to \fBhwloc_topology_get_topology_cpuset()\fP, which means all PUs are allowed\&.
+.PP
+If \fBHWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED\fP was set, applying \fBhwloc_bitmap_intersects()\fP on the result of this function and on an object cpuset checks whether there are allowed PUs inside that object\&. Applying \fBhwloc_bitmap_and()\fP returns the list of these allowed PUs\&.
+.PP
+The returned cpuset is not newly allocated and should thus not be changed or freed, \fBhwloc_bitmap_dup()\fP must be used to obtain a local copy\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_const_nodeset_t\fP hwloc_topology_get_allowed_nodeset (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Get allowed node set\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the node set of allowed memory of the system\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot return \fCNULL\fP\&.
+.PP
+If the topology flag \fBHWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED\fP was not set, this is identical to \fBhwloc_topology_get_topology_nodeset()\fP, which means all NUMA nodes are allowed\&.
+.PP
+If \fBHWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED\fP was set, applying \fBhwloc_bitmap_intersects()\fP on the result of this function and on an object nodeset checks whether there are allowed NUMA nodes inside that object\&. Applying \fBhwloc_bitmap_and()\fP returns the list of these allowed NUMA nodes\&.
+.PP
+The returned nodeset is not newly allocated and should thus not be changed or freed, \fBhwloc_bitmap_dup()\fP must be used to obtain a local copy\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_const_cpuset_t\fP hwloc_topology_get_complete_cpuset (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Get complete CPU set\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the complete CPU set of processors of the system\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot return \fCNULL\fP\&.
+.PP
+The returned cpuset is not newly allocated and should thus not be changed or freed; \fBhwloc_bitmap_dup()\fP must be used to obtain a local copy\&.
+.PP
+This is equivalent to retrieving the root object complete CPU-set\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_const_nodeset_t\fP hwloc_topology_get_complete_nodeset (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Get complete node set\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the complete node set of memory of the system\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot return \fCNULL\fP\&.
+.PP
+The returned nodeset is not newly allocated and should thus not be changed or freed; \fBhwloc_bitmap_dup()\fP must be used to obtain a local copy\&.
+.PP
+This is equivalent to retrieving the root object complete nodeset\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_const_cpuset_t\fP hwloc_topology_get_topology_cpuset (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Get topology CPU set\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the CPU set of processors of the system for which hwloc provides topology information\&. This is equivalent to the cpuset of the system object\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot return \fCNULL\fP\&.
+.PP
+The returned cpuset is not newly allocated and should thus not be changed or freed; \fBhwloc_bitmap_dup()\fP must be used to obtain a local copy\&.
+.PP
+This is equivalent to retrieving the root object CPU-set\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_const_nodeset_t\fP hwloc_topology_get_topology_nodeset (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Get topology node set\&. 
+.PP
+\fBReturns\fP
+.RS 4
+the node set of memory of the system for which hwloc provides topology information\&. This is equivalent to the nodeset of the system object\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function cannot return \fCNULL\fP\&.
+.PP
+The returned nodeset is not newly allocated and should thus not be changed or freed; \fBhwloc_bitmap_dup()\fP must be used to obtain a local copy\&.
+.PP
+This is equivalent to retrieving the root object nodeset\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_types.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_types.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_types.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_helper_types.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,108 @@
+.TH "hwlocality_helper_types" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_helper_types \- Kinds of object Type
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_obj_type_is_normal\fP (\fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "int \fBhwloc_obj_type_is_io\fP (\fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "int \fBhwloc_obj_type_is_memory\fP (\fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "int \fBhwloc_obj_type_is_cache\fP (\fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "int \fBhwloc_obj_type_is_dcache\fP (\fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "int \fBhwloc_obj_type_is_icache\fP (\fBhwloc_obj_type_t\fP type)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Each object type is either Normal (i\&.e\&. \fBhwloc_obj_type_is_normal()\fP returns 1), or Memory (i\&.e\&. \fBhwloc_obj_type_is_memory()\fP returns 1) or I/O (i\&.e\&. \fBhwloc_obj_type_is_io()\fP returns 1) or Misc (i\&.e\&. equal to \fBHWLOC_OBJ_MISC\fP)\&. It cannot be of more than one of these kinds\&.
+.PP
+See also Object Kind in \fBTerms and Definitions\fP\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_obj_type_is_cache (\fBhwloc_obj_type_t\fP type)"
+
+.PP
+Check whether an object type is a CPU Cache (Data, Unified or Instruction)\&. Memory-side caches are not CPU caches\&.
+.PP
+\fBReturns\fP
+.RS 4
+1 if an object of type \fCtype\fP is a Cache, 0 otherwise\&. 
+.RE
+.PP
+
+.SS "int hwloc_obj_type_is_dcache (\fBhwloc_obj_type_t\fP type)"
+
+.PP
+Check whether an object type is a CPU Data or Unified Cache\&. Memory-side caches are not CPU caches\&.
+.PP
+\fBReturns\fP
+.RS 4
+1 if an object of type \fCtype\fP is a CPU Data or Unified Cache, 0 otherwise\&. 
+.RE
+.PP
+
+.SS "int hwloc_obj_type_is_icache (\fBhwloc_obj_type_t\fP type)"
+
+.PP
+Check whether an object type is a CPU Instruction Cache,\&. Memory-side caches are not CPU caches\&.
+.PP
+\fBReturns\fP
+.RS 4
+1 if an object of type \fCtype\fP is a CPU Instruction Cache, 0 otherwise\&. 
+.RE
+.PP
+
+.SS "int hwloc_obj_type_is_io (\fBhwloc_obj_type_t\fP type)"
+
+.PP
+Check whether an object type is I/O\&. I/O objects are objects attached to their parents in the I/O children list\&. This current includes Bridges, PCI and OS devices\&.
+.PP
+\fBReturns\fP
+.RS 4
+1 if an object of type \fCtype\fP is a I/O object, 0 otherwise\&. 
+.RE
+.PP
+
+.SS "int hwloc_obj_type_is_memory (\fBhwloc_obj_type_t\fP type)"
+
+.PP
+Check whether an object type is Memory\&. Memory objects are objects attached to their parents in the Memory children list\&. This current includes NUMA nodes and Memory-side caches\&.
+.PP
+\fBReturns\fP
+.RS 4
+1 if an object of type \fCtype\fP is a Memory object, 0 otherwise\&. 
+.RE
+.PP
+
+.SS "int hwloc_obj_type_is_normal (\fBhwloc_obj_type_t\fP type)"
+
+.PP
+Check whether an object type is Normal\&. Normal objects are objects of the main CPU hierarchy (Machine, Package, Core, PU, CPU caches, etc\&.), but they are not NUMA nodes, I/O devices or Misc objects\&.
+.PP
+They are attached to parent as Normal children, not as Memory, I/O or Misc children\&.
+.PP
+\fBReturns\fP
+.RS 4
+1 if an object of type \fCtype\fP is a Normal object, 0 otherwise\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_info_attr.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_info_attr.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_info_attr.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_info_attr.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,87 @@
+.TH "hwlocality_info_attr" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_info_attr \- Consulting and Adding Info Attributes
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static const char * \fBhwloc_obj_get_info_by_name\fP (\fBhwloc_obj_t\fP obj, const char *name)"
+.br
+.ti -1c
+.RI "int \fBhwloc_obj_add_info\fP (\fBhwloc_obj_t\fP obj, const char *name, const char *value)"
+.br
+.ti -1c
+.RI "int \fBhwloc_obj_set_subtype\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj, const char *subtype)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_obj_add_info (\fBhwloc_obj_t\fP obj, const char * name, const char * value)"
+
+.PP
+Add the given name and value pair to the given object info attributes\&. The info pair is appended to the existing info array even if another pair with the same name already exists\&.
+.PP
+The input strings are copied before being added in the object infos\&.
+.PP
+\fBReturns\fP
+.RS 4
+\fC0\fP on success, \fC-1\fP on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function may be used to enforce object colors in the lstopo graphical output by adding 'lstopoStyle' as a name and 'Background=#rrggbb' as a value\&. See CUSTOM COLORS in the lstopo(1) manpage for details\&.
+.PP
+If \fCname\fP or \fCvalue\fP contain some non-printable characters, they will be dropped when exporting to XML, see \fBhwloc_topology_export_xml()\fP in \fBhwloc/export\&.h\fP\&. 
+.RE
+.PP
+
+.SS "static const char * hwloc_obj_get_info_by_name (\fBhwloc_obj_t\fP obj, const char * name)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Search the given name in object infos and return the corresponding value\&. If multiple info attributes match the given name, only the first one is returned\&.
+.PP
+\fBReturns\fP
+.RS 4
+A pointer to the value string if it exists\&. 
+.PP
+\fCNULL\fP if no such info attribute exists\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+The string should not be freed by the caller, it belongs to the hwloc library\&. 
+.RE
+.PP
+
+.SS "int hwloc_obj_set_subtype (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj, const char * subtype)"
+
+.PP
+Set (or replace) the subtype of an object\&. The given \fCsubtype\fP is copied internally, the caller is responsible for freeing the original \fCsubtype\fP if needed\&.
+.PP
+If another subtype already exists in \fCobject\fP, it is replaced\&. The given \fCsubtype\fP may be \fCNULL\fP to remove the existing subtype\&.
+.PP
+\fBNote\fP
+.RS 4
+This function is mostly meant to initialize the subtype of user-added objects such as groups with \fBhwloc_topology_alloc_group_object()\fP\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+\fC0\fP on success\&. 
+.PP
+\fC-1\fP with \fCerrno\fP set to \fCENOMEM\fP on failure to allocate memory\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_levels.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_levels.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_levels.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_levels.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,280 @@
+.TH "hwlocality_levels" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_levels \- Object levels, depths and types
+.SH SYNOPSIS
+.br
+.PP
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_get_type_depth_e\fP { \fBHWLOC_TYPE_DEPTH_UNKNOWN\fP, \fBHWLOC_TYPE_DEPTH_MULTIPLE\fP, \fBHWLOC_TYPE_DEPTH_NUMANODE\fP, \fBHWLOC_TYPE_DEPTH_BRIDGE\fP, \fBHWLOC_TYPE_DEPTH_PCI_DEVICE\fP, \fBHWLOC_TYPE_DEPTH_OS_DEVICE\fP, \fBHWLOC_TYPE_DEPTH_MISC\fP, \fBHWLOC_TYPE_DEPTH_MEMCACHE\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_topology_get_depth\fP (\fBhwloc_topology_t\fP restrict topology)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_type_depth\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_memory_parents_depth\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_get_type_or_below_depth\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_get_type_or_above_depth\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_type_t\fP \fBhwloc_get_depth_type\fP (\fBhwloc_topology_t\fP topology, int depth)"
+.br
+.ti -1c
+.RI "unsigned \fBhwloc_get_nbobjs_by_depth\fP (\fBhwloc_topology_t\fP topology, int depth)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_get_nbobjs_by_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_root_obj\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_t\fP \fBhwloc_get_obj_by_depth\fP (\fBhwloc_topology_t\fP topology, int depth, unsigned idx)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_obj_by_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, unsigned idx)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_next_obj_by_depth\fP (\fBhwloc_topology_t\fP topology, int depth, \fBhwloc_obj_t\fP prev)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_get_next_obj_by_type\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, \fBhwloc_obj_t\fP prev)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Be sure to see the figure in \fBTerms and Definitions\fP that shows a complete topology tree, including depths, child/sibling/cousin relationships, and an example of an asymmetric topology where one package has fewer caches than its peers\&. 
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_get_type_depth_e\fP"
+
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_TYPE_DEPTH_UNKNOWN \fP\fP
+No object of given type exists in the topology\&. 
+.TP
+\fB\fIHWLOC_TYPE_DEPTH_MULTIPLE \fP\fP
+Objects of given type exist at different depth in the topology (only for Groups)\&. 
+.TP
+\fB\fIHWLOC_TYPE_DEPTH_NUMANODE \fP\fP
+Virtual depth for NUMA nodes\&. 
+.TP
+\fB\fIHWLOC_TYPE_DEPTH_BRIDGE \fP\fP
+Virtual depth for bridge object level\&. 
+.TP
+\fB\fIHWLOC_TYPE_DEPTH_PCI_DEVICE \fP\fP
+Virtual depth for PCI device object level\&. 
+.TP
+\fB\fIHWLOC_TYPE_DEPTH_OS_DEVICE \fP\fP
+Virtual depth for software device object level\&. 
+.TP
+\fB\fIHWLOC_TYPE_DEPTH_MISC \fP\fP
+Virtual depth for Misc object\&. 
+.TP
+\fB\fIHWLOC_TYPE_DEPTH_MEMCACHE \fP\fP
+Virtual depth for MemCache object\&. 
+.SH "Function Documentation"
+.PP 
+.SS "\fBhwloc_obj_type_t\fP hwloc_get_depth_type (\fBhwloc_topology_t\fP topology, int depth)"
+
+.PP
+Returns the type of objects at depth \fCdepth\fP\&. \fCdepth\fP should between 0 and \fBhwloc_topology_get_depth()\fP-1, or a virtual depth such as \fBHWLOC_TYPE_DEPTH_NUMANODE\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+The type of objects at depth \fCdepth\fP\&. 
+.PP
+(hwloc_obj_type_t)-1 if depth \fCdepth\fP does not exist\&. 
+.RE
+.PP
+
+.SS "int hwloc_get_memory_parents_depth (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Return the depth of parents where memory objects are attached\&. Memory objects have virtual negative depths because they are not part of the main CPU-side hierarchy of objects\&. This depth should not be compared with other level depths\&.
+.PP
+If all Memory objects are attached to Normal parents at the same depth, this parent depth may be compared to other as usual, for instance for knowing whether NUMA nodes is attached above or below Packages\&.
+.PP
+\fBReturns\fP
+.RS 4
+The depth of Normal parents of all memory children if all these parents have the same depth\&. For instance the depth of the Package level if all NUMA nodes are attached to Package objects\&.
+.PP
+\fBHWLOC_TYPE_DEPTH_MULTIPLE\fP if Normal parents of all memory children do not have the same depth\&. For instance if some NUMA nodes are attached to Packages while others are attached to Groups\&. 
+.RE
+.PP
+
+.SS "unsigned hwloc_get_nbobjs_by_depth (\fBhwloc_topology_t\fP topology, int depth)"
+
+.PP
+Returns the width of level at depth \fCdepth\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The number of objects at topology depth \fCdepth\fP\&. 
+.PP
+0 if there are no objects at depth \fCdepth\fP\&. 
+.RE
+.PP
+
+.SS "static int hwloc_get_nbobjs_by_type (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the width of level type \fCtype\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The number of objects of type \fCtype\fP\&. 
+.PP
+-1 if there are multiple levels with objects of that type, e\&.g\&. \fBHWLOC_OBJ_GROUP\fP\&. 
+.PP
+0 if there are no objects at depth \fCdepth\fP\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_next_obj_by_depth (\fBhwloc_topology_t\fP topology, int depth, \fBhwloc_obj_t\fP prev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the next object at depth \fCdepth\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The first object at depth \fCdepth\fP if \fCprev\fP is \fCNULL\fP\&. 
+.PP
+The object after \fCprev\fP at depth \fCdepth\fP if \fCprev\fP is not \fCNULL\fP\&. 
+.PP
+\fCNULL\fP if there is no such object\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_next_obj_by_type (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, \fBhwloc_obj_t\fP prev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the next object of type \fCtype\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The first object of type \fCtype\fP if \fCprev\fP is \fCNULL\fP\&. 
+.PP
+The object after \fCprev\fP of type \fCtype\fP if \fCprev\fP is not \fCNULL\fP\&. 
+.PP
+\fCNULL\fP if there is no such object\&. 
+.PP
+\fCNULL\fP if there are multiple levels with objects of that type (e\&.g\&. \fBHWLOC_OBJ_GROUP\fP), the caller may fallback to \fBhwloc_get_obj_by_depth()\fP\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_obj_t\fP hwloc_get_obj_by_depth (\fBhwloc_topology_t\fP topology, int depth, unsigned idx)"
+
+.PP
+Returns the topology object at logical index \fCidx\fP from depth \fCdepth\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The object if it exists\&. 
+.PP
+\fCNULL\fP if there is no object with this index and depth\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_obj_by_type (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type, unsigned idx)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the topology object at logical index \fCidx\fP with type \fCtype\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The object if it exists\&. 
+.PP
+\fCNULL\fP if there is no object with this index and type\&. 
+.PP
+\fCNULL\fP if there are multiple levels with objects of that type (e\&.g\&. \fBHWLOC_OBJ_GROUP\fP), the caller may fallback to \fBhwloc_get_obj_by_depth()\fP\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_get_root_obj (\fBhwloc_topology_t\fP topology)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the top-object of the topology-tree\&. Its type is \fBHWLOC_OBJ_MACHINE\fP\&.
+.PP
+This function cannot return \fCNULL\fP\&. 
+.SS "int hwloc_get_type_depth (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)"
+
+.PP
+Returns the depth of objects of type \fCtype\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The depth of objects of type \fCtype\fP\&.
+.PP
+A negative virtual depth if a NUMA node, I/O or Misc object type is given\&. These objects are stored in special levels that are not CPU-related\&. This virtual depth may be passed to other hwloc functions such as \fBhwloc_get_obj_by_depth()\fP but it should not be considered as an actual depth by the application\&. In particular, it should not be compared with any other object depth or with the entire topology depth\&.
+.PP
+\fBHWLOC_TYPE_DEPTH_UNKNOWN\fP if no object of this type is present on the underlying architecture, or if the OS doesn't provide this kind of information\&.
+.PP
+\fBHWLOC_TYPE_DEPTH_MULTIPLE\fP if type \fBHWLOC_OBJ_GROUP\fP is given and multiple levels of Groups exist\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+If the type is absent but a similar type is acceptable, see also \fBhwloc_get_type_or_below_depth()\fP and \fBhwloc_get_type_or_above_depth()\fP\&.
+.RE
+.PP
+\fBSee also\fP
+.RS 4
+\fBhwloc_get_memory_parents_depth()\fP for managing the depth of memory objects\&.
+.PP
+\fBhwloc_type_sscanf_as_depth()\fP for returning the depth of objects whose type is given as a string\&. 
+.RE
+.PP
+
+.SS "static int hwloc_get_type_or_above_depth (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the depth of objects of type \fCtype\fP or above\&. If no object of this type is present on the underlying architecture, the function returns the depth of the first 'present' object typically containing \fCtype\fP\&.
+.PP
+This function is only meaningful for normal object types\&. If a memory, I/O or Misc object type is given, the corresponding virtual depth is always returned (see \fBhwloc_get_type_depth()\fP)\&.
+.PP
+May return \fBHWLOC_TYPE_DEPTH_MULTIPLE\fP for \fBHWLOC_OBJ_GROUP\fP just like \fBhwloc_get_type_depth()\fP\&. 
+.SS "static int hwloc_get_type_or_below_depth (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_type_t\fP type)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Returns the depth of objects of type \fCtype\fP or below\&. If no object of this type is present on the underlying architecture, the function returns the depth of the first 'present' object typically found inside \fCtype\fP\&.
+.PP
+This function is only meaningful for normal object types\&. If a memory, I/O or Misc object type is given, the corresponding virtual depth is always returned (see \fBhwloc_get_type_depth()\fP)\&.
+.PP
+May return \fBHWLOC_TYPE_DEPTH_MULTIPLE\fP for \fBHWLOC_OBJ_GROUP\fP just like \fBhwloc_get_type_depth()\fP\&. 
+.SS "int hwloc_topology_get_depth (\fBhwloc_topology_t\fP restrict topology)"
+
+.PP
+Get the depth of the hierarchical tree of objects\&. This is the depth of \fBHWLOC_OBJ_PU\fP objects plus one\&.
+.PP
+\fBReturns\fP
+.RS 4
+the depth of the object tree\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+NUMA nodes, I/O and Misc objects are ignored when computing the depth of the tree (they are placed on special levels)\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_levelzero.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_levelzero.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_levelzero.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_levelzero.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,65 @@
+.TH "hwlocality_levelzero" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_levelzero \- Interoperability with the oneAPI Level Zero interface\&.
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_levelzero_get_device_cpuset\fP (\fBhwloc_topology_t\fP topology, ze_device_handle_t device, \fBhwloc_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_levelzero_get_device_osdev\fP (\fBhwloc_topology_t\fP topology, ze_device_handle_t device)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This interface offers ways to retrieve topology information about devices managed by the Level Zero API\&. 
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_levelzero_get_device_cpuset (\fBhwloc_topology_t\fP topology, ze_device_handle_t device, \fBhwloc_cpuset_t\fP set)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the CPU set of logical processors that are physically close to the Level Zero device \fCdevice\fP\&. Store in \fCset\fP the CPU-set describing the locality of the Level Zero device \fCdevice\fP\&.
+.PP
+Topology \fCtopology\fP and device \fCdevice\fP must match the local machine\&. The Level Zero library must have been initialized with Sysman enabled (by calling zesInit(0) if supported, or by setting ZES_ENABLE_SYSMAN=1 in the environment)\&. I/O devices detection and the Level Zero component are not needed in the topology\&.
+.PP
+The function only returns the locality of the device\&. If more information about the device is needed, OS objects should be used instead, see \fBhwloc_levelzero_get_device_osdev()\fP\&.
+.PP
+This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if device information could not be found\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_levelzero_get_device_osdev (\fBhwloc_topology_t\fP topology, ze_device_handle_t device)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to Level Zero device \fCdevice\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object that describes the given Level Zero device \fCdevice\fP\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+Topology \fCtopology\fP and device \fCdv_ind\fP must match the local machine\&. I/O devices detection and the Level Zero component must be enabled in the topology\&. If not, the locality of the object may still be found using \fBhwloc_levelzero_get_device_cpuset()\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out)\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_linux.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_linux.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_linux.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_linux.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,98 @@
+.TH "hwlocality_linux" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_linux \- Linux-specific helpers
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_linux_set_tid_cpubind\fP (\fBhwloc_topology_t\fP topology, pid_t tid, \fBhwloc_const_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "int \fBhwloc_linux_get_tid_cpubind\fP (\fBhwloc_topology_t\fP topology, pid_t tid, \fBhwloc_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "int \fBhwloc_linux_get_tid_last_cpu_location\fP (\fBhwloc_topology_t\fP topology, pid_t tid, \fBhwloc_bitmap_t\fP set)"
+.br
+.ti -1c
+.RI "int \fBhwloc_linux_read_path_as_cpumask\fP (const char *path, \fBhwloc_bitmap_t\fP set)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This includes helpers for manipulating Linux kernel cpumap files, and hwloc equivalents of the Linux sched_setaffinity and sched_getaffinity system calls\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_linux_get_tid_cpubind (\fBhwloc_topology_t\fP topology, pid_t tid, \fBhwloc_cpuset_t\fP set)"
+
+.PP
+Get the current binding of thread \fCtid\fP\&. The CPU-set \fCset\fP (previously allocated by the caller) is filled with the list of PUs which the thread was last bound to\&.
+.PP
+The behavior is exactly the same as the Linux sched_getaffinity system call, but uses a hwloc cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This is equivalent to calling \fBhwloc_get_proc_cpubind()\fP with \fBHWLOC_CPUBIND_THREAD\fP as flags\&. 
+.RE
+.PP
+
+.SS "int hwloc_linux_get_tid_last_cpu_location (\fBhwloc_topology_t\fP topology, pid_t tid, \fBhwloc_bitmap_t\fP set)"
+
+.PP
+Get the last physical CPU where thread \fCtid\fP ran\&. The CPU-set \fCset\fP (previously allocated by the caller) is filled with the PU which the thread last ran on\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This is equivalent to calling \fBhwloc_get_proc_last_cpu_location()\fP with \fBHWLOC_CPUBIND_THREAD\fP as flags\&. 
+.RE
+.PP
+
+.SS "int hwloc_linux_read_path_as_cpumask (const char * path, \fBhwloc_bitmap_t\fP set)"
+
+.PP
+Convert a linux kernel cpumask file \fCpath\fP into a hwloc bitmap \fCset\fP\&. Might be used when reading CPU set from sysfs attributes such as topology and caches for processors, or local_cpus for devices\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function ignores the HWLOC_FSROOT environment variable\&. 
+.RE
+.PP
+
+.SS "int hwloc_linux_set_tid_cpubind (\fBhwloc_topology_t\fP topology, pid_t tid, \fBhwloc_const_cpuset_t\fP set)"
+
+.PP
+Bind a thread \fCtid\fP on cpus given in cpuset \fCset\fP\&. The behavior is exactly the same as the Linux sched_setaffinity system call, but uses a hwloc cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This is equivalent to calling \fBhwloc_set_proc_cpubind()\fP with HWLOC_CPUBIND_THREAD as flags\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_linux_libnuma_bitmask.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_linux_libnuma_bitmask.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_linux_libnuma_bitmask.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_linux_libnuma_bitmask.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,93 @@
+.TH "hwlocality_linux_libnuma_bitmask" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_linux_libnuma_bitmask \- Interoperability with Linux libnuma bitmask
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static struct bitmask * \fBhwloc_cpuset_to_linux_libnuma_bitmask\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP cpuset)"
+.br
+.ti -1c
+.RI "static struct bitmask * \fBhwloc_nodeset_to_linux_libnuma_bitmask\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_nodeset_t\fP nodeset)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_cpuset_from_linux_libnuma_bitmask\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP cpuset, const struct bitmask *bitmask)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_nodeset_from_linux_libnuma_bitmask\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_nodeset_t\fP nodeset, const struct bitmask *bitmask)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This interface helps converting between Linux libnuma bitmasks and hwloc cpusets and nodesets\&.
+.PP
+\fBNote\fP
+.RS 4
+Topology \fCtopology\fP must match the current machine\&.
+.PP
+The behavior of libnuma is undefined if the kernel is not NUMA-aware\&. (when CONFIG_NUMA is not set in the kernel configuration)\&. This helper and libnuma may thus not be strictly compatible in this case, which may be detected by checking whether numa_available() returns -1\&. 
+.RE
+.PP
+
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_cpuset_from_linux_libnuma_bitmask (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP cpuset, const struct bitmask * bitmask)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert libnuma bitmask \fCbitmask\fP into hwloc CPU set \fCcpuset\fP\&. This function may be used after calling many numa_ functions that use a struct bitmask as an output parameter\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOMEM\fP if some internal reallocation failed\&. 
+.RE
+.PP
+
+.SS "static struct bitmask * hwloc_cpuset_to_linux_libnuma_bitmask (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP cpuset)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert hwloc CPU set \fCcpuset\fP into the returned libnuma bitmask\&. The returned bitmask should later be freed with numa_bitmask_free\&.
+.PP
+This function may be used before calling many numa_ functions that use a struct bitmask as an input parameter\&.
+.PP
+\fBReturns\fP
+.RS 4
+newly allocated struct bitmask, or \fCNULL\fP on error\&. 
+.RE
+.PP
+
+.SS "static int hwloc_nodeset_from_linux_libnuma_bitmask (\fBhwloc_topology_t\fP topology, \fBhwloc_nodeset_t\fP nodeset, const struct bitmask * bitmask)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert libnuma bitmask \fCbitmask\fP into hwloc NUMA node set \fCnodeset\fP\&. This function may be used after calling many numa_ functions that use a struct bitmask as an output parameter\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOMEM\fP if some internal reallocation failed\&. 
+.RE
+.PP
+
+.SS "static struct bitmask * hwloc_nodeset_to_linux_libnuma_bitmask (\fBhwloc_topology_t\fP topology, \fBhwloc_const_nodeset_t\fP nodeset)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert hwloc NUMA node set \fCnodeset\fP into the returned libnuma bitmask\&. The returned bitmask should later be freed with numa_bitmask_free\&.
+.PP
+This function may be used before calling many numa_ functions that use a struct bitmask as an input parameter\&.
+.PP
+\fBReturns\fP
+.RS 4
+newly allocated struct bitmask, or \fCNULL\fP on error\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_linux_libnuma_ulongs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_linux_libnuma_ulongs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_linux_libnuma_ulongs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_linux_libnuma_ulongs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,97 @@
+.TH "hwlocality_linux_libnuma_ulongs" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_linux_libnuma_ulongs \- Interoperability with Linux libnuma unsigned long masks
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_cpuset_to_linux_libnuma_ulongs\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP cpuset, unsigned long *mask, unsigned long *maxnode)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_nodeset_to_linux_libnuma_ulongs\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_nodeset_t\fP nodeset, unsigned long *mask, unsigned long *maxnode)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_cpuset_from_linux_libnuma_ulongs\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP cpuset, const unsigned long *mask, unsigned long maxnode)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_nodeset_from_linux_libnuma_ulongs\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_nodeset_t\fP nodeset, const unsigned long *mask, unsigned long maxnode)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This interface helps converting between Linux libnuma unsigned long masks and hwloc cpusets and nodesets\&.
+.PP
+\fBNote\fP
+.RS 4
+Topology \fCtopology\fP must match the current machine\&.
+.PP
+The behavior of libnuma is undefined if the kernel is not NUMA-aware\&. (when CONFIG_NUMA is not set in the kernel configuration)\&. This helper and libnuma may thus not be strictly compatible in this case, which may be detected by checking whether numa_available() returns -1\&. 
+.RE
+.PP
+
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_cpuset_from_linux_libnuma_ulongs (\fBhwloc_topology_t\fP topology, \fBhwloc_cpuset_t\fP cpuset, const unsigned long * mask, unsigned long maxnode)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert the array of unsigned long \fCmask\fP into hwloc CPU set\&. \fCmask\fP is a array of unsigned long that will be read\&. \fCmaxnode\fP contains the maximal node number that may be read in \fCmask\fP\&.
+.PP
+This function may be used after calling get_mempolicy or any other function that takes an array of unsigned long as output parameter (and possibly a maximal node number as input parameter)\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if failing an internal reallocation\&. 
+.RE
+.PP
+
+.SS "static int hwloc_cpuset_to_linux_libnuma_ulongs (\fBhwloc_topology_t\fP topology, \fBhwloc_const_cpuset_t\fP cpuset, unsigned long * mask, unsigned long * maxnode)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert hwloc CPU set \fCcpuset\fP into the array of unsigned long \fCmask\fP\&. \fCmask\fP is the array of unsigned long that will be filled\&. \fCmaxnode\fP contains the maximal node number that may be stored in \fCmask\fP\&. \fCmaxnode\fP will be set to the maximal node number that was found, plus one\&.
+.PP
+This function may be used before calling set_mempolicy, mbind, migrate_pages or any other function that takes an array of unsigned long and a maximal node number as input parameter\&.
+.PP
+\fBReturns\fP
+.RS 4
+0\&. 
+.RE
+.PP
+
+.SS "static int hwloc_nodeset_from_linux_libnuma_ulongs (\fBhwloc_topology_t\fP topology, \fBhwloc_nodeset_t\fP nodeset, const unsigned long * mask, unsigned long maxnode)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert the array of unsigned long \fCmask\fP into hwloc NUMA node set\&. \fCmask\fP is a array of unsigned long that will be read\&. \fCmaxnode\fP contains the maximal node number that may be read in \fCmask\fP\&.
+.PP
+This function may be used after calling get_mempolicy or any other function that takes an array of unsigned long as output parameter (and possibly a maximal node number as input parameter)\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOMEM\fP if some internal reallocation failed\&. 
+.RE
+.PP
+
+.SS "static int hwloc_nodeset_to_linux_libnuma_ulongs (\fBhwloc_topology_t\fP topology, \fBhwloc_const_nodeset_t\fP nodeset, unsigned long * mask, unsigned long * maxnode)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Convert hwloc NUMA node set \fCnodeset\fP into the array of unsigned long \fCmask\fP\&. \fCmask\fP is the array of unsigned long that will be filled\&. \fCmaxnode\fP contains the maximal node number that may be stored in \fCmask\fP\&. \fCmaxnode\fP will be set to the maximal node number that was found, plus one\&.
+.PP
+This function may be used before calling set_mempolicy, mbind, migrate_pages or any other function that takes an array of unsigned long and a maximal node number as input parameter\&.
+.PP
+\fBReturns\fP
+.RS 4
+0\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_memattrs.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_memattrs.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_memattrs.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_memattrs.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,278 @@
+.TH "hwlocality_memattrs" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_memattrs \- Comparing memory node attributes for finding where to allocate on
+.SH SYNOPSIS
+.br
+.PP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_location\fP"
+.br
+.in -1c
+.SS "Typedefs"
+
+.in +1c
+.ti -1c
+.RI "typedef unsigned \fBhwloc_memattr_id_t\fP"
+.br
+.in -1c
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_memattr_id_e\fP { \fBHWLOC_MEMATTR_ID_CAPACITY\fP, \fBHWLOC_MEMATTR_ID_LOCALITY\fP, \fBHWLOC_MEMATTR_ID_BANDWIDTH\fP, \fBHWLOC_MEMATTR_ID_READ_BANDWIDTH\fP, \fBHWLOC_MEMATTR_ID_WRITE_BANDWIDTH\fP, \fBHWLOC_MEMATTR_ID_LATENCY\fP, \fBHWLOC_MEMATTR_ID_READ_LATENCY\fP, \fBHWLOC_MEMATTR_ID_WRITE_LATENCY\fP, \fBHWLOC_MEMATTR_ID_MAX\fP }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_location_type_e\fP { \fBHWLOC_LOCATION_TYPE_CPUSET\fP, \fBHWLOC_LOCATION_TYPE_OBJECT\fP }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_local_numanode_flag_e\fP { \fBHWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY\fP, \fBHWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY\fP, \fBHWLOC_LOCAL_NUMANODE_FLAG_ALL\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_memattr_get_by_name\fP (\fBhwloc_topology_t\fP topology, const char *name, \fBhwloc_memattr_id_t\fP *id)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_local_numanode_objs\fP (\fBhwloc_topology_t\fP topology, struct \fBhwloc_location\fP *location, unsigned *nr, \fBhwloc_obj_t\fP *nodes, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_memattr_get_value\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, \fBhwloc_obj_t\fP target_node, struct \fBhwloc_location\fP *initiator, unsigned long flags, hwloc_uint64_t *value)"
+.br
+.ti -1c
+.RI "int \fBhwloc_memattr_get_best_target\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, struct \fBhwloc_location\fP *initiator, unsigned long flags, \fBhwloc_obj_t\fP *best_target, hwloc_uint64_t *value)"
+.br
+.ti -1c
+.RI "int \fBhwloc_memattr_get_best_initiator\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, \fBhwloc_obj_t\fP target, unsigned long flags, struct \fBhwloc_location\fP *best_initiator, hwloc_uint64_t *value)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Platforms with heterogeneous memory require ways to decide whether a buffer should be allocated on 'fast' memory (such as HBM), 'normal' memory (DDR) or even 'slow' but large-capacity memory (non-volatile memory)\&. These memory nodes are called 'Targets' while the CPU accessing them is called the 'Initiator'\&. Access performance depends on their locality (NUMA platforms) as well as the intrinsic performance of the targets (heterogeneous platforms)\&.
+.PP
+The following attributes describe the performance of memory accesses from an Initiator to a memory Target, for instance their latency or bandwidth\&. Initiators performing these memory accesses are usually some PUs or Cores (described as a CPU set)\&. Hence a Core may choose where to allocate a memory buffer by comparing the attributes of different target memory nodes nearby\&.
+.PP
+There are also some attributes that are system-wide\&. Their value does not depend on a specific initiator performing an access\&. The memory node Capacity is an example of such attribute without initiator\&.
+.PP
+One way to use this API is to start with a cpuset describing the Cores where a program is bound\&. The best target NUMA node for allocating memory in this program on these Cores may be obtained by passing this cpuset as an initiator to \fBhwloc_memattr_get_best_target()\fP with the relevant memory attribute\&. For instance, if the code is latency limited, use the Latency attribute\&.
+.PP
+A more flexible approach consists in getting the list of local NUMA nodes by passing this cpuset to \fBhwloc_get_local_numanode_objs()\fP\&. Attribute values for these nodes, if any, may then be obtained with \fBhwloc_memattr_get_value()\fP and manually compared with the desired criteria\&.
+.PP
+Memory attributes are also used internally to build Memory Tiers which provide an easy way to distinguish NUMA nodes of different kinds, as explained in \fBHeterogeneous Memory\fP\&.
+.PP
+\fBSee also\fP
+.RS 4
+An example is available in doc/examples/memory-attributes\&.c in the source tree\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+The API also supports specific objects as initiator, but it is currently not used internally by hwloc\&. Users may for instance use it to provide custom performance values for host memory accesses performed by GPUs\&.
+.PP
+The interface actually also accepts targets that are not NUMA nodes\&. 
+.RE
+.PP
+
+.SH "Typedef Documentation"
+.PP 
+.SS "typedef unsigned \fBhwloc_memattr_id_t\fP"
+
+.PP
+A memory attribute identifier\&. May be either one of \fBhwloc_memattr_id_e\fP or a new id returned by \fBhwloc_memattr_register()\fP\&. 
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_local_numanode_flag_e\fP"
+
+.PP
+Flags for selecting target NUMA nodes\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY \fP\fP
+Select NUMA nodes whose locality is larger than the given cpuset\&. For instance, if a single PU (or its cpuset) is given in \fCinitiator\fP, select all nodes close to the package that contains this PU\&. 
+.TP
+\fB\fIHWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY \fP\fP
+Select NUMA nodes whose locality is smaller than the given cpuset\&. For instance, if a package (or its cpuset) is given in \fCinitiator\fP, also select nodes that are attached to only a half of that package\&. 
+.TP
+\fB\fIHWLOC_LOCAL_NUMANODE_FLAG_ALL \fP\fP
+Select all NUMA nodes in the topology\&. The initiator \fCinitiator\fP is ignored\&. 
+.SS "enum \fBhwloc_location_type_e\fP"
+
+.PP
+Type of location\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_LOCATION_TYPE_CPUSET \fP\fP
+Location is given as a cpuset, in the location cpuset union field\&. 
+.TP
+\fB\fIHWLOC_LOCATION_TYPE_OBJECT \fP\fP
+Location is given as an object, in the location object union field\&. 
+.SS "enum \fBhwloc_memattr_id_e\fP"
+
+.PP
+Memory node attributes\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_MEMATTR_ID_CAPACITY \fP\fP
+The "Capacity" is returned in bytes (local_memory attribute in objects)\&. Best capacity nodes are nodes with \fBhigher capacity\fP\&.
+.PP
+No initiator is involved when looking at this attribute\&. The corresponding attribute flags are \fBHWLOC_MEMATTR_FLAG_HIGHER_FIRST\fP\&. 
+.TP
+\fB\fIHWLOC_MEMATTR_ID_LOCALITY \fP\fP
+The "Locality" is returned as the number of PUs in that locality (e\&.g\&. the weight of its cpuset)\&. Best locality nodes are nodes with \fBsmaller locality\fP (nodes that are local to very few PUs)\&. Poor locality nodes are nodes with larger locality (nodes that are local to the entire machine)\&.
+.PP
+No initiator is involved when looking at this attribute\&. The corresponding attribute flags are \fBHWLOC_MEMATTR_FLAG_HIGHER_FIRST\fP\&. 
+.TP
+\fB\fIHWLOC_MEMATTR_ID_BANDWIDTH \fP\fP
+The "Bandwidth" is returned in MiB/s, as seen from the given initiator location\&. Best bandwidth nodes are nodes with \fBhigher bandwidth\fP\&.
+.PP
+The corresponding attribute flags are \fBHWLOC_MEMATTR_FLAG_HIGHER_FIRST\fP and \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP\&.
+.PP
+This is the average bandwidth for read and write accesses\&. If the platform provides individual read and write bandwidths but no explicit average value, hwloc computes and returns the average\&. 
+.TP
+\fB\fIHWLOC_MEMATTR_ID_READ_BANDWIDTH \fP\fP
+The "ReadBandwidth" is returned in MiB/s, as seen from the given initiator location\&. Best bandwidth nodes are nodes with \fBhigher bandwidth\fP\&.
+.PP
+The corresponding attribute flags are \fBHWLOC_MEMATTR_FLAG_HIGHER_FIRST\fP and \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP\&. 
+.TP
+\fB\fIHWLOC_MEMATTR_ID_WRITE_BANDWIDTH \fP\fP
+The "WriteBandwidth" is returned in MiB/s, as seen from the given initiator location\&. Best bandwidth nodes are nodes with \fBhigher bandwidth\fP\&.
+.PP
+The corresponding attribute flags are \fBHWLOC_MEMATTR_FLAG_HIGHER_FIRST\fP and \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP\&. 
+.TP
+\fB\fIHWLOC_MEMATTR_ID_LATENCY \fP\fP
+The "Latency" is returned as nanoseconds, as seen from the given initiator location\&. Best latency nodes are nodes with \fBsmaller latency\fP\&.
+.PP
+The corresponding attribute flags are \fBHWLOC_MEMATTR_FLAG_LOWER_FIRST\fP and \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP\&.
+.PP
+This is the average latency for read and write accesses\&. If the platform provides individual read and write latencies but no explicit average value, hwloc computes and returns the average\&. 
+.TP
+\fB\fIHWLOC_MEMATTR_ID_READ_LATENCY \fP\fP
+The "ReadLatency" is returned as nanoseconds, as seen from the given initiator location\&. Best latency nodes are nodes with \fBsmaller latency\fP\&.
+.PP
+The corresponding attribute flags are \fBHWLOC_MEMATTR_FLAG_LOWER_FIRST\fP and \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP\&. 
+.TP
+\fB\fIHWLOC_MEMATTR_ID_WRITE_LATENCY \fP\fP
+The "WriteLatency" is returned as nanoseconds, as seen from the given initiator location\&. Best latency nodes are nodes with \fBsmaller latency\fP\&.
+.PP
+The corresponding attribute flags are \fBHWLOC_MEMATTR_FLAG_LOWER_FIRST\fP and \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_get_local_numanode_objs (\fBhwloc_topology_t\fP topology, struct \fBhwloc_location\fP * location, unsigned * nr, \fBhwloc_obj_t\fP * nodes, unsigned long flags)"
+
+.PP
+Return an array of local NUMA nodes\&. By default only select the NUMA nodes whose locality is exactly the given \fClocation\fP\&. More nodes may be selected if additional flags are given as a OR'ed set of \fBhwloc_local_numanode_flag_e\fP\&.
+.PP
+If \fClocation\fP is given as an explicit object, its CPU set is used to find NUMA nodes with the corresponding locality\&. If the object does not have a CPU set (e\&.g\&. I/O object), the CPU parent (where the I/O object is attached) is used\&.
+.PP
+On input, \fCnr\fP points to the number of nodes that may be stored in the \fCnodes\fP array\&. On output, \fCnr\fP will be changed to the number of stored nodes, or the number of nodes that would have been stored if there were enough room\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success or -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Some of these NUMA nodes may not have any memory attribute values and hence not be reported as actual targets in other functions\&.
+.PP
+The number of NUMA nodes in the topology (obtained by \fBhwloc_bitmap_weight()\fP on the root object nodeset) may be used to allocate the \fCnodes\fP array\&.
+.PP
+When an object CPU set is given as locality, for instance a Package, and when flags contain both \fBHWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY\fP and \fBHWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY\fP, the returned array corresponds to the nodeset of that object\&. 
+.RE
+.PP
+
+.SS "int hwloc_memattr_get_best_initiator (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, \fBhwloc_obj_t\fP target, unsigned long flags, struct \fBhwloc_location\fP * best_initiator, hwloc_uint64_t * value)"
+
+.PP
+Return the best initiator for the given attribute and target NUMA node\&. If \fCvalue\fP is non \fCNULL\fP, the corresponding value is returned there\&.
+.PP
+If multiple initiators have the same attribute values, only one is returned (and there is no way to clarify how that one is chosen)\&. Applications that want to detect initiators with identical/similar values, or that want to look at values for multiple attributes, should rather get all values using \fBhwloc_memattr_get_value()\fP and manually select the initiator they consider the best\&.
+.PP
+The returned initiator should not be modified or freed, it belongs to the topology\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOENT\fP if there are no matching initiators\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP if the attribute does not relate to a specific initiator (it does not have the flag \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP)\&. 
+.RE
+.PP
+
+.SS "int hwloc_memattr_get_best_target (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, struct \fBhwloc_location\fP * initiator, unsigned long flags, \fBhwloc_obj_t\fP * best_target, hwloc_uint64_t * value)"
+
+.PP
+Return the best target NUMA node for the given attribute and initiator\&. If the attribute does not relate to a specific initiator (it does not have the flag \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP), location \fCinitiator\fP is ignored and may be \fCNULL\fP\&.
+.PP
+If \fCvalue\fP is non \fCNULL\fP, the corresponding value is returned there\&.
+.PP
+If multiple targets have the same attribute values, only one is returned (and there is no way to clarify how that one is chosen)\&. Applications that want to detect targets with identical/similar values, or that want to look at values for multiple attributes, should rather get all values using \fBhwloc_memattr_get_value()\fP and manually select the target they consider the best\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOENT\fP if there are no matching targets\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP if flags are invalid, or no such attribute exists\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+The initiator \fCinitiator\fP should be of type \fBHWLOC_LOCATION_TYPE_CPUSET\fP when refering to accesses performed by CPU cores\&. \fBHWLOC_LOCATION_TYPE_OBJECT\fP is currently unused internally by hwloc, but users may for instance use it to provide custom information about host memory accesses performed by GPUs\&. 
+.RE
+.PP
+
+.SS "int hwloc_memattr_get_by_name (\fBhwloc_topology_t\fP topology, const char * name, \fBhwloc_memattr_id_t\fP * id)"
+
+.PP
+Return the identifier of the memory attribute with the given name\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP if no such attribute exists\&. 
+.RE
+.PP
+
+.SS "int hwloc_memattr_get_value (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, \fBhwloc_obj_t\fP target_node, struct \fBhwloc_location\fP * initiator, unsigned long flags, hwloc_uint64_t * value)"
+
+.PP
+Return an attribute value for a specific target NUMA node\&. If the attribute does not relate to a specific initiator (it does not have the flag \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP), location \fCinitiator\fP is ignored and may be \fCNULL\fP\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance with errno set to \fCEINVAL\fP if flags are invalid or no such attribute exists\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+The initiator \fCinitiator\fP should be of type \fBHWLOC_LOCATION_TYPE_CPUSET\fP when refering to accesses performed by CPU cores\&. \fBHWLOC_LOCATION_TYPE_OBJECT\fP is currently unused internally by hwloc, but users may for instance use it to provide custom information about host memory accesses performed by GPUs\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_memattrs_manage.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_memattrs_manage.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_memattrs_manage.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_memattrs_manage.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,175 @@
+.TH "hwlocality_memattrs_manage" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_memattrs_manage \- Managing memory attributes
+.SH SYNOPSIS
+.br
+.PP
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_memattr_flag_e\fP { \fBHWLOC_MEMATTR_FLAG_HIGHER_FIRST\fP = (1UL<<0), \fBHWLOC_MEMATTR_FLAG_LOWER_FIRST\fP = (1UL<<1), \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP = (1UL<<2) }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_memattr_get_name\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, const char **name)"
+.br
+.ti -1c
+.RI "int \fBhwloc_memattr_get_flags\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, unsigned long *flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_memattr_register\fP (\fBhwloc_topology_t\fP topology, const char *name, unsigned long flags, \fBhwloc_memattr_id_t\fP *id)"
+.br
+.ti -1c
+.RI "int \fBhwloc_memattr_set_value\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, \fBhwloc_obj_t\fP target_node, struct \fBhwloc_location\fP *initiator, unsigned long flags, hwloc_uint64_t value)"
+.br
+.ti -1c
+.RI "int \fBhwloc_memattr_get_targets\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, struct \fBhwloc_location\fP *initiator, unsigned long flags, unsigned *nr, \fBhwloc_obj_t\fP *targets, hwloc_uint64_t *values)"
+.br
+.ti -1c
+.RI "int \fBhwloc_memattr_get_initiators\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, \fBhwloc_obj_t\fP target_node, unsigned long flags, unsigned *nr, struct \fBhwloc_location\fP *initiators, hwloc_uint64_t *values)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_memattr_flag_e\fP"
+
+.PP
+Memory attribute flags\&. Given to \fBhwloc_memattr_register()\fP and returned by \fBhwloc_memattr_get_flags()\fP\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_MEMATTR_FLAG_HIGHER_FIRST \fP\fP
+The best nodes for this memory attribute are those with the higher values\&. For instance Bandwidth\&. 
+.TP
+\fB\fIHWLOC_MEMATTR_FLAG_LOWER_FIRST \fP\fP
+The best nodes for this memory attribute are those with the lower values\&. For instance Latency\&. 
+.TP
+\fB\fIHWLOC_MEMATTR_FLAG_NEED_INITIATOR \fP\fP
+The value returned for this memory attribute depends on the given initiator\&. For instance Bandwidth and Latency, but not Capacity\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_memattr_get_flags (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, unsigned long * flags)"
+
+.PP
+Return the flags of the given attribute\&. Flags are a OR'ed set of \fBhwloc_memattr_flag_e\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP if the attribute does not exist\&. 
+.RE
+.PP
+
+.SS "int hwloc_memattr_get_initiators (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, \fBhwloc_obj_t\fP target_node, unsigned long flags, unsigned * nr, struct \fBhwloc_location\fP * initiators, hwloc_uint64_t * values)"
+
+.PP
+Return the initiators that have values for a given attribute for a specific target NUMA node\&. Return initiators for the given attribute and target node in the \fCinitiators\fP array\&. If \fCvalues\fP is not \fCNULL\fP, the corresponding attribute values are stored in the array it points to\&.
+.PP
+On input, \fCnr\fP points to the number of initiators that may be stored in the array \fCinitiators\fP (and \fCvalues\fP)\&. On output, \fCnr\fP points to the number of initiators (and values) that were actually found, even if some of them couldn't be stored in the array\&. Initiators that couldn't be stored are ignored, but the function still returns success (\fC0\fP)\&. The caller may find out by comparing the value pointed by \fCnr\fP before and after the function call\&.
+.PP
+The returned initiators should not be modified or freed, they belong to the topology\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+If the attribute does not relate to a specific initiator (it does not have the flag \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP), no initiator is returned\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success or -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function is meant for tools and debugging (listing internal information) rather than for application queries\&. Applications should rather select useful NUMA nodes with \fBhwloc_get_local_numanode_objs()\fP and then look at their attribute values for some relevant initiators\&. 
+.RE
+.PP
+
+.SS "int hwloc_memattr_get_name (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, const char ** name)"
+
+.PP
+Return the name of a memory attribute\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP if the attribute does not exist\&. 
+.RE
+.PP
+
+.SS "int hwloc_memattr_get_targets (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, struct \fBhwloc_location\fP * initiator, unsigned long flags, unsigned * nr, \fBhwloc_obj_t\fP * targets, hwloc_uint64_t * values)"
+
+.PP
+Return the target NUMA nodes that have some values for a given attribute\&. Return targets for the given attribute in the \fCtargets\fP array (for the given initiator if any)\&. If \fCvalues\fP is not \fCNULL\fP, the corresponding attribute values are stored in the array it points to\&.
+.PP
+On input, \fCnr\fP points to the number of targets that may be stored in the array \fCtargets\fP (and \fCvalues\fP)\&. On output, \fCnr\fP points to the number of targets (and values) that were actually found, even if some of them couldn't be stored in the array\&. Targets that couldn't be stored are ignored, but the function still returns success (\fC0\fP)\&. The caller may find out by comparing the value pointed by \fCnr\fP before and after the function call\&.
+.PP
+The returned targets should not be modified or freed, they belong to the topology\&.
+.PP
+Argument \fCinitiator\fP is ignored if the attribute does not relate to a specific initiator (it does not have the flag \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP)\&. Otherwise \fCinitiator\fP may be non \fCNULL\fP to report only targets that have a value for that initiator\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBNote\fP
+.RS 4
+This function is meant for tools and debugging (listing internal information) rather than for application queries\&. Applications should rather select useful NUMA nodes with \fBhwloc_get_local_numanode_objs()\fP and then look at their attribute values\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+0 on success or -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+The initiator \fCinitiator\fP should be of type \fBHWLOC_LOCATION_TYPE_CPUSET\fP when referring to accesses performed by CPU cores\&. \fBHWLOC_LOCATION_TYPE_OBJECT\fP is currently unused internally by hwloc, but users may for instance use it to provide custom information about host memory accesses performed by GPUs\&. 
+.RE
+.PP
+
+.SS "int hwloc_memattr_register (\fBhwloc_topology_t\fP topology, const char * name, unsigned long flags, \fBhwloc_memattr_id_t\fP * id)"
+
+.PP
+Register a new memory attribute\&. Add a specific memory attribute that is not defined in \fBhwloc_memattr_id_e\fP\&. Flags are a OR'ed set of \fBhwloc_memattr_flag_e\fP\&. It must contain at least one of \fBHWLOC_MEMATTR_FLAG_HIGHER_FIRST\fP or \fBHWLOC_MEMATTR_FLAG_LOWER_FIRST\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCEBUSY\fP if another attribute already uses this name\&. 
+.RE
+.PP
+
+.SS "int hwloc_memattr_set_value (\fBhwloc_topology_t\fP topology, \fBhwloc_memattr_id_t\fP attribute, \fBhwloc_obj_t\fP target_node, struct \fBhwloc_location\fP * initiator, unsigned long flags, hwloc_uint64_t value)"
+
+.PP
+Set an attribute value for a specific target NUMA node\&. If the attribute does not relate to a specific initiator (it does not have the flag \fBHWLOC_MEMATTR_FLAG_NEED_INITIATOR\fP), location \fCinitiator\fP is ignored and may be \fCNULL\fP\&.
+.PP
+The initiator will be copied into the topology, the caller should free anything allocated to store the initiator, for instance the cpuset\&.
+.PP
+\fCflags\fP must be \fC0\fP for now\&.
+.PP
+\fBNote\fP
+.RS 4
+The initiator \fCinitiator\fP should be of type \fBHWLOC_LOCATION_TYPE_CPUSET\fP when referring to accesses performed by CPU cores\&. \fBHWLOC_LOCATION_TYPE_OBJECT\fP is currently unused internally by hwloc, but users may for instance use it to provide custom information about host memory accesses performed by GPUs\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+0 on success or -1 on error\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_membinding.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_membinding.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_membinding.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_membinding.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,382 @@
+.TH "hwlocality_membinding" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_membinding \- Memory binding
+.SH SYNOPSIS
+.br
+.PP
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_membind_policy_t\fP { \fBHWLOC_MEMBIND_DEFAULT\fP, \fBHWLOC_MEMBIND_FIRSTTOUCH\fP, \fBHWLOC_MEMBIND_BIND\fP, \fBHWLOC_MEMBIND_INTERLEAVE\fP, \fBHWLOC_MEMBIND_WEIGHTED_INTERLEAVE\fP, \fBHWLOC_MEMBIND_NEXTTOUCH\fP, \fBHWLOC_MEMBIND_MIXED\fP }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_membind_flags_t\fP { \fBHWLOC_MEMBIND_PROCESS\fP, \fBHWLOC_MEMBIND_THREAD\fP, \fBHWLOC_MEMBIND_STRICT\fP, \fBHWLOC_MEMBIND_MIGRATE\fP, \fBHWLOC_MEMBIND_NOCPUBIND\fP, \fBHWLOC_MEMBIND_BYNODESET\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_set_membind\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_const_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP policy, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_membind\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP *policy, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_set_proc_membind\fP (\fBhwloc_topology_t\fP topology, hwloc_pid_t pid, \fBhwloc_const_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP policy, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_proc_membind\fP (\fBhwloc_topology_t\fP topology, hwloc_pid_t pid, \fBhwloc_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP *policy, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_set_area_membind\fP (\fBhwloc_topology_t\fP topology, const void *addr, size_t len, \fBhwloc_const_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP policy, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_area_membind\fP (\fBhwloc_topology_t\fP topology, const void *addr, size_t len, \fBhwloc_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP *policy, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_get_area_memlocation\fP (\fBhwloc_topology_t\fP topology, const void *addr, size_t len, \fBhwloc_bitmap_t\fP set, int flags)"
+.br
+.ti -1c
+.RI "void * \fBhwloc_alloc\fP (\fBhwloc_topology_t\fP topology, size_t len)"
+.br
+.ti -1c
+.RI "void * \fBhwloc_alloc_membind\fP (\fBhwloc_topology_t\fP topology, size_t len, \fBhwloc_const_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP policy, int flags)"
+.br
+.ti -1c
+.RI "static void * \fBhwloc_alloc_membind_policy\fP (\fBhwloc_topology_t\fP topology, size_t len, \fBhwloc_const_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP policy, int flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_free\fP (\fBhwloc_topology_t\fP topology, void *addr, size_t len)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Memory binding can be done three ways:
+.PP
+.IP "\(bu" 2
+explicit memory allocation thanks to \fBhwloc_alloc_membind()\fP and friends: the binding will have effect on the memory allocated by these functions\&.
+.IP "\(bu" 2
+implicit memory binding through binding policy: \fBhwloc_set_membind()\fP and friends only define the current policy of the process, which will be applied to the subsequent calls to malloc() and friends\&.
+.IP "\(bu" 2
+migration of existing memory ranges, thanks to \fBhwloc_set_area_membind()\fP and friends, which move already-allocated data\&.
+.PP
+.PP
+Not all operating systems support all three ways\&. \fBhwloc_topology_get_support()\fP may be used to query about the actual memory binding support in the currently used operating system\&.
+.PP
+When the requested binding operation is not available and the \fBHWLOC_MEMBIND_STRICT\fP flag was passed, the function returns -1\&. \fCerrno\fP will be set to \fCENOSYS\fP when the system does support the specified action or policy (e\&.g\&., some systems only allow binding memory on a per-thread basis, whereas other systems only allow binding memory for all threads in a process)\&. \fCerrno\fP will be set to \fCEXDEV\fP when the requested set can not be enforced (e\&.g\&., some systems only allow binding memory to a single NUMA node)\&.
+.PP
+If \fBHWLOC_MEMBIND_STRICT\fP was not passed, the function may fail as well, or the operating system may use a slightly different operation (with side-effects, smaller binding set, etc\&.) when the requested operation is not exactly supported\&.
+.PP
+The most portable form that should be preferred over the others whenever possible is as follows\&. It allocates some memory hopefully bound to the specified set\&. To do so, hwloc will possibly have to change the current memory binding policy in order to actually get the memory bound, if the OS does not provide any other way to simply allocate bound memory without changing the policy for all allocations\&. That is the difference with \fBhwloc_alloc_membind()\fP, which will never change the current memory binding policy\&.
+.PP
+.PP
+.nf
+hwloc_alloc_membind_policy(topology, size, set,
+                           HWLOC_MEMBIND_BIND, 0);
+.fi
+.PP
+.PP
+Each hwloc memory binding function takes a bitmap argument that is a CPU set by default, or a NUMA memory node set if the flag \fBHWLOC_MEMBIND_BYNODESET\fP is specified\&. See \fBObject Sets (hwloc_cpuset_t and hwloc_nodeset_t)\fP and \fBThe bitmap API\fP for a discussion of CPU sets and NUMA memory node sets\&. It is also possible to convert between CPU set and node set using \fBhwloc_cpuset_to_nodeset()\fP or \fBhwloc_cpuset_from_nodeset()\fP\&.
+.PP
+Memory binding by CPU set cannot work for CPU-less NUMA memory nodes\&. Binding by nodeset should therefore be preferred whenever possible\&.
+.PP
+\fBSee also\fP
+.RS 4
+Some example codes are available under doc/examples/ in the source tree\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+On some operating systems, memory binding affects the CPU binding; see \fBHWLOC_MEMBIND_NOCPUBIND\fP 
+.RE
+.PP
+
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_membind_flags_t\fP"
+
+.PP
+Memory binding flags\&. These flags can be used to refine the binding policy\&. All flags can be logically OR'ed together with the exception of \fBHWLOC_MEMBIND_PROCESS\fP and \fBHWLOC_MEMBIND_THREAD\fP; these two flags are mutually exclusive\&.
+.PP
+Not all systems support all kinds of binding\&. \fBhwloc_topology_get_support()\fP may be used to query about the actual memory binding support in the currently used operating system\&. See the 'Detailed Description' section of \fBMemory binding\fP for a description of errors that can occur\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_MEMBIND_PROCESS \fP\fP
+Set policy for all threads of the specified (possibly multithreaded) process\&. This flag is mutually exclusive with \fBHWLOC_MEMBIND_THREAD\fP\&. 
+.TP
+\fB\fIHWLOC_MEMBIND_THREAD \fP\fP
+Set policy for a specific thread of the current process\&. This flag is mutually exclusive with \fBHWLOC_MEMBIND_PROCESS\fP\&. 
+.TP
+\fB\fIHWLOC_MEMBIND_STRICT \fP\fP
+Request strict binding from the OS\&. The function will fail if the binding can not be guaranteed / completely enforced\&.
+.PP
+This flag has slightly different meanings depending on which function it is used with\&. 
+.TP
+\fB\fIHWLOC_MEMBIND_MIGRATE \fP\fP
+Migrate existing allocated memory\&. If the memory cannot be migrated and the \fBHWLOC_MEMBIND_STRICT\fP flag is passed, an error will be returned\&. 
+.TP
+\fB\fIHWLOC_MEMBIND_NOCPUBIND \fP\fP
+Avoid any effect on CPU binding\&. On some operating systems, some underlying memory binding functions also bind the application to the corresponding CPU(s)\&. Using this flag will cause hwloc to avoid using OS functions that could potentially affect CPU bindings\&. Note, however, that using NOCPUBIND may reduce hwloc's overall memory binding support\&. Specifically: some of hwloc's memory binding functions may fail with errno set to \fCENOSYS\fP when used with NOCPUBIND\&. 
+.TP
+\fB\fIHWLOC_MEMBIND_BYNODESET \fP\fP
+Consider the bitmap argument as a nodeset\&. The bitmap argument is considered a nodeset if this flag is given, or a cpuset otherwise by default\&.
+.PP
+Memory binding by CPU set cannot work for CPU-less NUMA memory nodes\&. Binding by nodeset should therefore be preferred whenever possible\&. 
+.SS "enum \fBhwloc_membind_policy_t\fP"
+
+.PP
+Memory binding policy\&. These constants can be used to choose the binding policy\&. Only one policy can be used at a time (i\&.e\&., the values cannot be OR'ed together)\&.
+.PP
+Not all systems support all kinds of binding\&. \fBhwloc_topology_get_support()\fP may be used to query about the actual memory binding policy support in the currently used operating system\&. See the 'Detailed Description' section of \fBMemory binding\fP for a description of errors that can occur\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_MEMBIND_DEFAULT \fP\fP
+Reset the memory allocation policy to the system default\&. Depending on the operating system, this may correspond to \fBHWLOC_MEMBIND_FIRSTTOUCH\fP (Linux, FreeBSD), or \fBHWLOC_MEMBIND_BIND\fP (AIX, HP-UX, Solaris, Windows)\&. This policy is never returned by get membind functions\&. The nodeset argument is ignored\&. 
+.TP
+\fB\fIHWLOC_MEMBIND_FIRSTTOUCH \fP\fP
+Allocate each memory page individually on the local NUMA node of the thread that touches it\&. The given nodeset should usually be \fBhwloc_topology_get_topology_nodeset()\fP so that the touching thread may run and allocate on any node in the system\&.
+.PP
+On AIX, if the nodeset is smaller, pages are allocated locally (if the local node is in the nodeset) or from a random non-local node (otherwise)\&. 
+.TP
+\fB\fIHWLOC_MEMBIND_BIND \fP\fP
+Allocate memory on the specified nodes\&. The actual behavior may slightly vary between operating systems, especially when (some of) the requested nodes are full\&. On Linux, by default, the MPOL_PREFERRED_MANY (or MPOL_PREFERRED) policy is used\&. However, if the hwloc strict flag is also given, the Linux MPOL_BIND policy is rather used\&. 
+.TP
+\fB\fIHWLOC_MEMBIND_INTERLEAVE \fP\fP
+Allocate memory on the given nodes in an interleaved / round-robin manner\&. The precise layout of the memory across multiple NUMA nodes is OS/system specific\&. Interleaving can be useful when threads distributed across the specified NUMA nodes will all be accessing the whole memory range concurrently, since the interleave will then balance the memory references\&. 
+.TP
+\fB\fIHWLOC_MEMBIND_WEIGHTED_INTERLEAVE \fP\fP
+Allocate memory on the given nodes in an interleaved / weighted manner\&. The precise layout of the memory across multiple NUMA nodes is OS/system specific\&. Weighted interleaving can be useful when threads distributed across the specified NUMA nodes with different bandwidth capabilities will all be accessing the whole memory range concurrently, since the interleave will then balance the memory references\&. 
+.TP
+\fB\fIHWLOC_MEMBIND_NEXTTOUCH \fP\fP
+For each page bound with this policy, by next time it is touched (and next time only), it is moved from its current location to the local NUMA node of the thread where the memory reference occurred (if it needs to be moved at all)\&. 
+.TP
+\fB\fIHWLOC_MEMBIND_MIXED \fP\fP
+Returned by get_membind() functions when multiple threads or parts of a memory area have differing memory binding policies\&. Also returned when binding is unknown because binding hooks are empty when the topology is loaded from XML without HWLOC_THISSYSTEM=1, etc\&. 
+.SH "Function Documentation"
+.PP 
+.SS "void * hwloc_alloc (\fBhwloc_topology_t\fP topology, size_t len)"
+
+.PP
+Allocate some memory\&. This is equivalent to malloc(), except that it tries to allocate page-aligned memory from the OS\&.
+.PP
+\fBReturns\fP
+.RS 4
+a pointer to the allocated area, or \fCNULL\fP on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+The allocated memory should be freed with \fBhwloc_free()\fP\&. 
+.RE
+.PP
+
+.SS "void * hwloc_alloc_membind (\fBhwloc_topology_t\fP topology, size_t len, \fBhwloc_const_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP policy, int flags)"
+
+.PP
+Allocate some memory on NUMA memory nodes specified by \fCset\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+a pointer to the allocated area\&. 
+.PP
+NULL with errno set to \fCENOSYS\fP if the action is not supported and \fBHWLOC_MEMBIND_STRICT\fP is given\&. 
+.PP
+NULL with errno set to \fCEXDEV\fP if the binding cannot be enforced and \fBHWLOC_MEMBIND_STRICT\fP is given\&. 
+.PP
+NULL with errno set to \fCENOMEM\fP if the memory allocation failed even before trying to bind\&.
+.RE
+.PP
+If \fBHWLOC_MEMBIND_BYNODESET\fP is specified, set is considered a nodeset\&. Otherwise it's a cpuset\&.
+.PP
+\fBNote\fP
+.RS 4
+The allocated memory should be freed with \fBhwloc_free()\fP\&. 
+.RE
+.PP
+
+.SS "static void * hwloc_alloc_membind_policy (\fBhwloc_topology_t\fP topology, size_t len, \fBhwloc_const_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP policy, int flags)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Allocate some memory on NUMA memory nodes specified by \fCset\fP\&. First, try to allocate properly with \fBhwloc_alloc_membind()\fP\&. On failure, the current process or thread memory binding policy is changed with \fBhwloc_set_membind()\fP before allocating memory\&. Thus this function works in more cases, at the expense of changing the current state (possibly affecting future allocations that would not specify any policy)\&.
+.PP
+If \fBHWLOC_MEMBIND_BYNODESET\fP is specified, set is considered a nodeset\&. Otherwise it's a cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+a pointer to the allocated area, or \fCNULL\fP on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_free (\fBhwloc_topology_t\fP topology, void * addr, size_t len)"
+
+.PP
+Free memory that was previously allocated by \fBhwloc_alloc()\fP or \fBhwloc_alloc_membind()\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_get_area_membind (\fBhwloc_topology_t\fP topology, const void * addr, size_t len, \fBhwloc_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP * policy, int flags)"
+
+.PP
+Query the CPUs near the physical NUMA node(s) and binding policy of the memory identified by (\fCaddr\fP, \fClen\fP )\&. The bitmap \fCset\fP (previously allocated by the caller) is filled with the memory area binding\&.
+.PP
+This function has two output parameters: \fCset\fP and \fCpolicy\fP\&. The values returned in these parameters depend on both the \fCflags\fP passed in and the memory binding policies and nodesets of the pages in the address range\&.
+.PP
+If \fBHWLOC_MEMBIND_STRICT\fP is specified, the target pages are first checked to see if they all have the same memory binding policy and nodeset\&. If they do not, -1 is returned and errno is set to \fCEXDEV\fP\&. If they are identical across all pages, the set and policy are returned in \fCset\fP and \fCpolicy\fP, respectively\&.
+.PP
+If \fBHWLOC_MEMBIND_STRICT\fP is not specified, the union of all NUMA node(s) containing pages in the address range is calculated\&. If all pages in the target have the same policy, it is returned in \fCpolicy\fP\&. Otherwise, \fCpolicy\fP is set to \fBHWLOC_MEMBIND_MIXED\fP\&.
+.PP
+If \fBHWLOC_MEMBIND_BYNODESET\fP is specified, set is considered a nodeset\&. Otherwise it's a cpuset\&.
+.PP
+If any other flags are specified, -1 is returned and errno is set to \fCEINVAL\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP if \fClen\fP is 0\&. 
+.RE
+.PP
+
+.SS "int hwloc_get_area_memlocation (\fBhwloc_topology_t\fP topology, const void * addr, size_t len, \fBhwloc_bitmap_t\fP set, int flags)"
+
+.PP
+Get the NUMA nodes where memory identified by (\fCaddr\fP, \fClen\fP ) is physically allocated\&. The bitmap \fCset\fP (previously allocated by the caller) is filled according to the NUMA nodes where the memory area pages are physically allocated\&. If no page is actually allocated yet, \fCset\fP may be empty\&.
+.PP
+If pages spread to multiple nodes, it is not specified whether they spread equitably, or whether most of them are on a single node, etc\&.
+.PP
+The operating system may move memory pages from one processor to another at any time according to their binding, so this function may return something that is already outdated\&.
+.PP
+If \fBHWLOC_MEMBIND_BYNODESET\fP is specified in \fCflags\fP, set is considered a nodeset\&. Otherwise it's a cpuset\&.
+.PP
+If \fClen\fP is 0, \fCset\fP is emptied\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_get_membind (\fBhwloc_topology_t\fP topology, \fBhwloc_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP * policy, int flags)"
+
+.PP
+Query the default memory binding policy and physical locality of the current process or thread\&. The bitmap \fCset\fP (previously allocated by the caller) is filled with the process or thread memory binding\&.
+.PP
+This function has two output parameters: \fCset\fP and \fCpolicy\fP\&. The values returned in these parameters depend on both the \fCflags\fP passed in and the current memory binding policies and nodesets in the queried target\&.
+.PP
+Passing the \fBHWLOC_MEMBIND_PROCESS\fP flag specifies that the query target is the current policies and nodesets for all the threads in the current process\&. Passing \fBHWLOC_MEMBIND_THREAD\fP specifies that the query target is the current policy and nodeset for only the thread invoking this function\&.
+.PP
+If neither of these flags are passed (which is the most portable method), the process is assumed to be single threaded\&. This allows hwloc to use either process-based OS functions or thread-based OS functions, depending on which are available\&.
+.PP
+\fBHWLOC_MEMBIND_STRICT\fP is only meaningful when \fBHWLOC_MEMBIND_PROCESS\fP is also specified\&. In this case, hwloc will check the default memory policies and nodesets for all threads in the process\&. If they are not identical, -1 is returned and errno is set to \fCEXDEV\fP\&. If they are identical, the values are returned in \fCset\fP and \fCpolicy\fP\&.
+.PP
+Otherwise, if \fBHWLOC_MEMBIND_PROCESS\fP is specified (and \fBHWLOC_MEMBIND_STRICT\fP is \fInot\fP specified), the default set from each thread is logically OR'ed together\&. If all threads' default policies are the same, \fCpolicy\fP is set to that policy\&. If they are different, \fCpolicy\fP is set to \fBHWLOC_MEMBIND_MIXED\fP\&.
+.PP
+In the \fBHWLOC_MEMBIND_THREAD\fP case (or when neither \fBHWLOC_MEMBIND_PROCESS\fP or \fBHWLOC_MEMBIND_THREAD\fP is specified), there is only one set and policy; they are returned in \fCset\fP and \fCpolicy\fP, respectively\&.
+.PP
+If \fBHWLOC_MEMBIND_BYNODESET\fP is specified, set is considered a nodeset\&. Otherwise it's a cpuset\&.
+.PP
+If any other flags are specified, -1 is returned and errno is set to \fCEINVAL\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_get_proc_membind (\fBhwloc_topology_t\fP topology, hwloc_pid_t pid, \fBhwloc_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP * policy, int flags)"
+
+.PP
+Query the default memory binding policy and physical locality of the specified process\&. The bitmap \fCset\fP (previously allocated by the caller) is filled with the process memory binding\&.
+.PP
+This function has two output parameters: \fCset\fP and \fCpolicy\fP\&. The values returned in these parameters depend on both the \fCflags\fP passed in and the current memory binding policies and nodesets in the queried target\&.
+.PP
+Passing the \fBHWLOC_MEMBIND_PROCESS\fP flag specifies that the query target is the current policies and nodesets for all the threads in the specified process\&. If \fBHWLOC_MEMBIND_PROCESS\fP is not specified (which is the most portable method), the process is assumed to be single threaded\&. This allows hwloc to use either process-based OS functions or thread-based OS functions, depending on which are available\&.
+.PP
+Note that it does not make sense to pass \fBHWLOC_MEMBIND_THREAD\fP to this function\&.
+.PP
+If \fBHWLOC_MEMBIND_STRICT\fP is specified, hwloc will check the default memory policies and nodesets for all threads in the specified process\&. If they are not identical, -1 is returned and errno is set to \fCEXDEV\fP\&. If they are identical, the values are returned in \fCset\fP and \fCpolicy\fP\&.
+.PP
+Otherwise, \fCset\fP is set to the logical OR of all threads' default set\&. If all threads' default policies are the same, \fCpolicy\fP is set to that policy\&. If they are different, \fCpolicy\fP is set to \fBHWLOC_MEMBIND_MIXED\fP\&.
+.PP
+If \fBHWLOC_MEMBIND_BYNODESET\fP is specified, set is considered a nodeset\&. Otherwise it's a cpuset\&.
+.PP
+If any other flags are specified, -1 is returned and errno is set to \fCEINVAL\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+\fChwloc_pid_t\fP is \fCpid_t\fP on Unix platforms, and \fCHANDLE\fP on native Windows platforms\&. 
+.RE
+.PP
+
+.SS "int hwloc_set_area_membind (\fBhwloc_topology_t\fP topology, const void * addr, size_t len, \fBhwloc_const_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP policy, int flags)"
+
+.PP
+Bind the already-allocated memory identified by (addr, len) to the NUMA node(s) specified by \fCset\fP\&. If \fBHWLOC_MEMBIND_BYNODESET\fP is specified, set is considered a nodeset\&. Otherwise it's a cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success or if \fClen\fP is 0\&. 
+.PP
+-1 with errno set to \fCENOSYS\fP if the action is not supported\&. 
+.PP
+-1 with errno set to \fCEXDEV\fP if the binding cannot be enforced\&. 
+.RE
+.PP
+
+.SS "int hwloc_set_membind (\fBhwloc_topology_t\fP topology, \fBhwloc_const_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP policy, int flags)"
+
+.PP
+Set the default memory binding policy of the current process or thread to prefer the NUMA node(s) specified by \fCset\fP\&. If neither \fBHWLOC_MEMBIND_PROCESS\fP nor \fBHWLOC_MEMBIND_THREAD\fP is specified, the current process is assumed to be single-threaded\&. This is the most portable form as it permits hwloc to use either process-based OS functions or thread-based OS functions, depending on which are available\&.
+.PP
+If \fBHWLOC_MEMBIND_BYNODESET\fP is specified, set is considered a nodeset\&. Otherwise it's a cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOSYS\fP if the action is not supported\&. 
+.PP
+-1 with errno set to \fCEXDEV\fP if the binding cannot be enforced\&. 
+.RE
+.PP
+
+.SS "int hwloc_set_proc_membind (\fBhwloc_topology_t\fP topology, hwloc_pid_t pid, \fBhwloc_const_bitmap_t\fP set, \fBhwloc_membind_policy_t\fP policy, int flags)"
+
+.PP
+Set the default memory binding policy of the specified process to prefer the NUMA node(s) specified by \fCset\fP\&. If \fBHWLOC_MEMBIND_BYNODESET\fP is specified, set is considered a nodeset\&. Otherwise it's a cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOSYS\fP if the action is not supported\&. 
+.PP
+-1 with errno set to \fCEXDEV\fP if the binding cannot be enforced\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+\fChwloc_pid_t\fP is \fCpid_t\fP on Unix platforms, and \fCHANDLE\fP on native Windows platforms\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_nvml.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_nvml.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_nvml.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_nvml.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,88 @@
+.TH "hwlocality_nvml" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_nvml \- Interoperability with the NVIDIA Management Library
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_nvml_get_device_cpuset\fP (\fBhwloc_topology_t\fP topology, nvmlDevice_t device, \fBhwloc_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_nvml_get_device_osdev_by_index\fP (\fBhwloc_topology_t\fP topology, unsigned idx)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_nvml_get_device_osdev\fP (\fBhwloc_topology_t\fP topology, nvmlDevice_t device)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This interface offers ways to retrieve topology information about devices managed by the NVIDIA Management Library (NVML)\&. 
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_nvml_get_device_cpuset (\fBhwloc_topology_t\fP topology, nvmlDevice_t device, \fBhwloc_cpuset_t\fP set)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the CPU set of processors that are physically close to NVML device \fCdevice\fP\&. Store in \fCset\fP the CPU-set describing the locality of the NVML device \fCdevice\fP\&.
+.PP
+Topology \fCtopology\fP and device \fCdevice\fP must match the local machine\&. I/O devices detection and the NVML component are not needed in the topology\&.
+.PP
+The function only returns the locality of the device\&. If more information about the device is needed, OS objects should be used instead, see \fBhwloc_nvml_get_device_osdev()\fP and \fBhwloc_nvml_get_device_osdev_by_index()\fP\&.
+.PP
+This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if device information could not be found\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_nvml_get_device_osdev (\fBhwloc_topology_t\fP topology, nvmlDevice_t device)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to NVML device \fCdevice\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object that describes the given NVML device \fCdevice\fP\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+Topology \fCtopology\fP and device \fCdevice\fP must match the local machine\&. I/O devices detection and the NVML component must be enabled in the topology\&. If not, the locality of the object may still be found using \fBhwloc_nvml_get_device_cpuset()\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_nvml_get_device_osdev_by_index (\fBhwloc_topology_t\fP topology, unsigned idx)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to the NVML device whose index is \fCidx\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object describing the NVML device whose index is \fCidx\fP\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+The topology \fCtopology\fP does not necessarily have to match the current machine\&. For instance the topology may be an XML import of a remote host\&. I/O devices detection and the NVML component must be enabled in the topology\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out)\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_object_sets.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_object_sets.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_object_sets.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_object_sets.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,56 @@
+.TH "hwlocality_object_sets" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_object_sets \- Object Sets (hwloc_cpuset_t and hwloc_nodeset_t)
+.SH SYNOPSIS
+.br
+.PP
+.SS "Typedefs"
+
+.in +1c
+.ti -1c
+.RI "typedef \fBhwloc_bitmap_t\fP \fBhwloc_cpuset_t\fP"
+.br
+.ti -1c
+.RI "typedef \fBhwloc_const_bitmap_t\fP \fBhwloc_const_cpuset_t\fP"
+.br
+.ti -1c
+.RI "typedef \fBhwloc_bitmap_t\fP \fBhwloc_nodeset_t\fP"
+.br
+.ti -1c
+.RI "typedef \fBhwloc_const_bitmap_t\fP \fBhwloc_const_nodeset_t\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+Hwloc uses bitmaps to represent two distinct kinds of object sets: CPU sets (\fBhwloc_cpuset_t\fP) and NUMA node sets (\fBhwloc_nodeset_t\fP)\&. These types are both typedefs to a common back end type (\fBhwloc_bitmap_t\fP), and therefore all the hwloc bitmap functions are applicable to both \fBhwloc_cpuset_t\fP and \fBhwloc_nodeset_t\fP (see \fBThe bitmap API\fP)\&.
+.PP
+The rationale for having two different types is that even though the actions one wants to perform on these types are the same (e\&.g\&., enable and disable individual items in the set/mask), they're used in very different contexts: one for specifying which processors to use and one for specifying which NUMA nodes to use\&. Hence, the name difference is really just to reflect the intent of where the type is used\&. 
+.SH "Typedef Documentation"
+.PP 
+.SS "typedef \fBhwloc_const_bitmap_t\fP \fBhwloc_const_cpuset_t\fP"
+
+.PP
+A non-modifiable \fBhwloc_cpuset_t\fP\&. 
+.SS "typedef \fBhwloc_const_bitmap_t\fP \fBhwloc_const_nodeset_t\fP"
+
+.PP
+A non-modifiable \fBhwloc_nodeset_t\fP\&. 
+.SS "typedef \fBhwloc_bitmap_t\fP \fBhwloc_cpuset_t\fP"
+
+.PP
+A CPU set is a bitmap whose bits are set according to CPU physical OS indexes\&. It may be consulted and modified with the bitmap API as any \fBhwloc_bitmap_t\fP (see \fBhwloc/bitmap\&.h\fP)\&.
+.PP
+Each bit may be converted into a PU object using \fBhwloc_get_pu_obj_by_os_index()\fP\&. 
+.SS "typedef \fBhwloc_bitmap_t\fP \fBhwloc_nodeset_t\fP"
+
+.PP
+A node set is a bitmap whose bits are set according to NUMA memory node physical OS indexes\&. It may be consulted and modified with the bitmap API as any \fBhwloc_bitmap_t\fP (see \fBhwloc/bitmap\&.h\fP)\&. Each bit may be converted into a NUMA node object using \fBhwloc_get_numanode_obj_by_os_index()\fP\&.
+.PP
+When binding memory on a system without any NUMA node, the single main memory bank is considered as NUMA node #0\&.
+.PP
+See also \fBConverting between CPU sets and node sets\fP\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_object_strings.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_object_strings.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_object_strings.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_object_strings.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,125 @@
+.TH "hwlocality_object_strings" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_object_strings \- Converting between Object Types and Attributes, and Strings
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "const char * \fBhwloc_obj_type_string\fP (\fBhwloc_obj_type_t\fP type)"
+.br
+.ti -1c
+.RI "int \fBhwloc_obj_type_snprintf\fP (char *restrict string, size_t size, \fBhwloc_obj_t\fP obj, int verbose)"
+.br
+.ti -1c
+.RI "int \fBhwloc_obj_attr_snprintf\fP (char *restrict string, size_t size, \fBhwloc_obj_t\fP obj, const char *restrict separator, int verbose)"
+.br
+.ti -1c
+.RI "int \fBhwloc_type_sscanf\fP (const char *string, \fBhwloc_obj_type_t\fP *typep, union \fBhwloc_obj_attr_u\fP *attrp, size_t attrsize)"
+.br
+.ti -1c
+.RI "int \fBhwloc_type_sscanf_as_depth\fP (const char *string, \fBhwloc_obj_type_t\fP *typep, \fBhwloc_topology_t\fP topology, int *depthp)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_obj_attr_snprintf (char *restrict string, size_t size, \fBhwloc_obj_t\fP obj, const char *restrict separator, int verbose)"
+
+.PP
+Stringify the attributes of a given topology object into a human-readable form\&. Attribute values are separated by \fCseparator\fP\&.
+.PP
+Only the major attributes are printed in non-verbose mode\&.
+.PP
+If \fCsize\fP is 0, \fCstring\fP may safely be \fCNULL\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+the number of characters that were actually written if not truncating, or that would have been written (not including the ending \\0)\&. 
+.RE
+.PP
+
+.SS "int hwloc_obj_type_snprintf (char *restrict string, size_t size, \fBhwloc_obj_t\fP obj, int verbose)"
+
+.PP
+Stringify the type of a given topology object into a human-readable form\&. Contrary to \fBhwloc_obj_type_string()\fP, this function includes object-specific attributes (such as the Group depth, the Bridge type, or OS device type) in the output, and it requires the caller to provide the output buffer\&.
+.PP
+The output is guaranteed to be the same for all objects of a same topology level\&.
+.PP
+If \fCverbose\fP is 1, longer type names are used, e\&.g\&. L1Cache instead of L1\&.
+.PP
+The output string may be parsed back by \fBhwloc_type_sscanf()\fP\&.
+.PP
+If \fCsize\fP is 0, \fCstring\fP may safely be \fCNULL\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+the number of characters that were actually written if not truncating, or that would have been written (not including the ending \\0)\&. 
+.RE
+.PP
+
+.SS "const char * hwloc_obj_type_string (\fBhwloc_obj_type_t\fP type)"
+
+.PP
+Return a constant stringified object type\&. This function is the basic way to convert a generic type into a string\&. The output string may be parsed back by \fBhwloc_type_sscanf()\fP\&.
+.PP
+\fBhwloc_obj_type_snprintf()\fP may return a more precise output for a specific object, but it requires the caller to provide the output buffer\&.
+.PP
+\fBReturns\fP
+.RS 4
+A constant string containing the object type name or \fC'Unknown'\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_type_sscanf (const char * string, \fBhwloc_obj_type_t\fP * typep, union \fBhwloc_obj_attr_u\fP * attrp, size_t attrsize)"
+
+.PP
+Return an object type and attributes from a type string\&. Convert strings such as 'Package' or 'L1iCache' into the corresponding types\&. Matching is case-insensitive, and only the first letters are actually required to match\&.
+.PP
+The matched object type is set in \fCtypep\fP (which cannot be \fCNULL\fP)\&.
+.PP
+Type-specific attributes, for instance Cache type, Cache depth, Group depth, Bridge type or OS Device type may be returned in \fCattrp\fP\&. Attributes that are not specified in the string (for instance 'Group' without a depth, or 'L2Cache' without a cache type) are set to -1\&.
+.PP
+\fCattrp\fP is only filled if not \fCNULL\fP and if its size specified in \fCattrsize\fP is large enough\&. It should be at least as large as union \fBhwloc_obj_attr_u\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 if a type was correctly identified, otherwise -1\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+This function is guaranteed to match any string returned by \fBhwloc_obj_type_string()\fP or \fBhwloc_obj_type_snprintf()\fP\&.
+.PP
+This is an extended version of the now deprecated hwloc_obj_type_sscanf()\&. 
+.RE
+.PP
+
+.SS "int hwloc_type_sscanf_as_depth (const char * string, \fBhwloc_obj_type_t\fP * typep, \fBhwloc_topology_t\fP topology, int * depthp)"
+
+.PP
+Return an object type and its level depth from a type string\&. Convert strings such as 'Package' or 'L1iCache' into the corresponding types and return in \fCdepthp\fP the depth of the corresponding level in the topology \fCtopology\fP\&.
+.PP
+If no object of this type is present on the underlying architecture, \fBHWLOC_TYPE_DEPTH_UNKNOWN\fP is returned\&.
+.PP
+If multiple such levels exist (for instance if giving Group without any depth), the function may return \fBHWLOC_TYPE_DEPTH_MULTIPLE\fP instead\&.
+.PP
+The matched object type is set in \fCtypep\fP if \fCtypep\fP is non \fCNULL\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+This function is similar to \fBhwloc_type_sscanf()\fP followed by \fBhwloc_get_type_depth()\fP but it also automatically disambiguates multiple group levels etc\&.
+.PP
+This function is guaranteed to match any string returned by \fBhwloc_obj_type_string()\fP or \fBhwloc_obj_type_snprintf()\fP\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_object_types.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_object_types.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_object_types.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_object_types.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,257 @@
+.TH "hwlocality_object_types" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_object_types \- Object Types
+.SH SYNOPSIS
+.br
+.PP
+.SS "Macros"
+
+.in +1c
+.ti -1c
+.RI "#define \fBHWLOC_TYPE_UNORDERED\fP"
+.br
+.in -1c
+.SS "Typedefs"
+
+.in +1c
+.ti -1c
+.RI "typedef enum \fBhwloc_obj_cache_type_e\fP \fBhwloc_obj_cache_type_t\fP"
+.br
+.ti -1c
+.RI "typedef enum \fBhwloc_obj_bridge_type_e\fP \fBhwloc_obj_bridge_type_t\fP"
+.br
+.ti -1c
+.RI "typedef enum \fBhwloc_obj_osdev_type_e\fP \fBhwloc_obj_osdev_type_t\fP"
+.br
+.in -1c
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_obj_type_t\fP { \fBHWLOC_OBJ_MACHINE\fP, \fBHWLOC_OBJ_PACKAGE\fP, \fBHWLOC_OBJ_CORE\fP, \fBHWLOC_OBJ_PU\fP, \fBHWLOC_OBJ_L1CACHE\fP, \fBHWLOC_OBJ_L2CACHE\fP, \fBHWLOC_OBJ_L3CACHE\fP, \fBHWLOC_OBJ_L4CACHE\fP, \fBHWLOC_OBJ_L5CACHE\fP, \fBHWLOC_OBJ_L1ICACHE\fP, \fBHWLOC_OBJ_L2ICACHE\fP, \fBHWLOC_OBJ_L3ICACHE\fP, \fBHWLOC_OBJ_GROUP\fP, \fBHWLOC_OBJ_NUMANODE\fP, \fBHWLOC_OBJ_BRIDGE\fP, \fBHWLOC_OBJ_PCI_DEVICE\fP, \fBHWLOC_OBJ_OS_DEVICE\fP, \fBHWLOC_OBJ_MISC\fP, \fBHWLOC_OBJ_MEMCACHE\fP, \fBHWLOC_OBJ_DIE\fP, \fBHWLOC_OBJ_TYPE_MAX\fP }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_obj_cache_type_e\fP { \fBHWLOC_OBJ_CACHE_UNIFIED\fP, \fBHWLOC_OBJ_CACHE_DATA\fP, \fBHWLOC_OBJ_CACHE_INSTRUCTION\fP }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_obj_bridge_type_e\fP { \fBHWLOC_OBJ_BRIDGE_HOST\fP, \fBHWLOC_OBJ_BRIDGE_PCI\fP }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_obj_osdev_type_e\fP { \fBHWLOC_OBJ_OSDEV_BLOCK\fP, \fBHWLOC_OBJ_OSDEV_GPU\fP, \fBHWLOC_OBJ_OSDEV_NETWORK\fP, \fBHWLOC_OBJ_OSDEV_OPENFABRICS\fP, \fBHWLOC_OBJ_OSDEV_DMA\fP, \fBHWLOC_OBJ_OSDEV_COPROC\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_compare_types\fP (\fBhwloc_obj_type_t\fP type1, \fBhwloc_obj_type_t\fP type2)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Macro Definition Documentation"
+.PP 
+.SS "#define HWLOC_TYPE_UNORDERED"
+
+.PP
+Value returned by \fBhwloc_compare_types()\fP when types can not be compared\&. 
+.SH "Typedef Documentation"
+.PP 
+.SS "typedef enum \fBhwloc_obj_bridge_type_e\fP \fBhwloc_obj_bridge_type_t\fP"
+
+.PP
+Type of one side (upstream or downstream) of an I/O bridge\&. 
+.SS "typedef enum \fBhwloc_obj_cache_type_e\fP \fBhwloc_obj_cache_type_t\fP"
+
+.PP
+Cache type\&. 
+.SS "typedef enum \fBhwloc_obj_osdev_type_e\fP \fBhwloc_obj_osdev_type_t\fP"
+
+.PP
+Type of a OS device\&. 
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_obj_bridge_type_e\fP"
+
+.PP
+Type of one side (upstream or downstream) of an I/O bridge\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_OBJ_BRIDGE_HOST \fP\fP
+Host-side of a bridge, only possible upstream\&. 
+.TP
+\fB\fIHWLOC_OBJ_BRIDGE_PCI \fP\fP
+PCI-side of a bridge\&. 
+.SS "enum \fBhwloc_obj_cache_type_e\fP"
+
+.PP
+Cache type\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_OBJ_CACHE_UNIFIED \fP\fP
+Unified cache\&. 
+.TP
+\fB\fIHWLOC_OBJ_CACHE_DATA \fP\fP
+Data cache\&. 
+.TP
+\fB\fIHWLOC_OBJ_CACHE_INSTRUCTION \fP\fP
+Instruction cache (filtered out by default)\&. 
+.SS "enum \fBhwloc_obj_osdev_type_e\fP"
+
+.PP
+Type of a OS device\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_OBJ_OSDEV_BLOCK \fP\fP
+Operating system block device, or non-volatile memory device\&. For instance 'sda' or 'dax2\&.0' on Linux\&. 
+.TP
+\fB\fIHWLOC_OBJ_OSDEV_GPU \fP\fP
+Operating system GPU device\&. For instance ':0\&.0' for a GL display, 'card0' for a Linux DRM device\&. 
+.TP
+\fB\fIHWLOC_OBJ_OSDEV_NETWORK \fP\fP
+Operating system network device\&. For instance the 'eth0' interface on Linux\&. 
+.TP
+\fB\fIHWLOC_OBJ_OSDEV_OPENFABRICS \fP\fP
+Operating system openfabrics device\&. For instance the 'mlx4_0' InfiniBand HCA, 'hfi1_0' Omni-Path interface, or 'bxi0' Atos/Bull BXI HCA on Linux\&. 
+.TP
+\fB\fIHWLOC_OBJ_OSDEV_DMA \fP\fP
+Operating system dma engine device\&. For instance the 'dma0chan0' DMA channel on Linux\&. 
+.TP
+\fB\fIHWLOC_OBJ_OSDEV_COPROC \fP\fP
+Operating system co-processor device\&. For instance 'opencl0d0' for a OpenCL device, 'cuda0' for a CUDA device\&. 
+.SS "enum \fBhwloc_obj_type_t\fP"
+
+.PP
+Type of topology object\&. 
+.PP
+\fBNote\fP
+.RS 4
+Do not rely on the ordering or completeness of the values as new ones may be defined in the future! If you need to compare types, use \fBhwloc_compare_types()\fP instead\&. 
+.RE
+.PP
+
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_OBJ_MACHINE \fP\fP
+Machine\&. A set of processors and memory with cache coherency\&. This type is always used for the root object of a topology, and never used anywhere else\&. Hence its parent is always \fCNULL\fP\&. 
+.TP
+\fB\fIHWLOC_OBJ_PACKAGE \fP\fP
+Physical package\&. The physical package that usually gets inserted into a socket on the motherboard\&. A processor package usually contains multiple cores, and possibly some dies\&. 
+.TP
+\fB\fIHWLOC_OBJ_CORE \fP\fP
+Core\&. A computation unit (may be shared by several PUs, aka logical processors)\&. 
+.TP
+\fB\fIHWLOC_OBJ_PU \fP\fP
+Processing Unit, or (Logical) Processor\&. An execution unit (may share a core with some other logical processors, e\&.g\&. in the case of an SMT core)\&. This is the smallest object representing CPU resources, it cannot have any child except Misc objects\&.
+.PP
+Objects of this kind are always reported and can thus be used as fallback when others are not\&. 
+.TP
+\fB\fIHWLOC_OBJ_L1CACHE \fP\fP
+Level 1 Data (or Unified) Cache\&. 
+.TP
+\fB\fIHWLOC_OBJ_L2CACHE \fP\fP
+Level 2 Data (or Unified) Cache\&. 
+.TP
+\fB\fIHWLOC_OBJ_L3CACHE \fP\fP
+Level 3 Data (or Unified) Cache\&. 
+.TP
+\fB\fIHWLOC_OBJ_L4CACHE \fP\fP
+Level 4 Data (or Unified) Cache\&. 
+.TP
+\fB\fIHWLOC_OBJ_L5CACHE \fP\fP
+Level 5 Data (or Unified) Cache\&. 
+.TP
+\fB\fIHWLOC_OBJ_L1ICACHE \fP\fP
+Level 1 instruction Cache (filtered out by default)\&. 
+.TP
+\fB\fIHWLOC_OBJ_L2ICACHE \fP\fP
+Level 2 instruction Cache (filtered out by default)\&. 
+.TP
+\fB\fIHWLOC_OBJ_L3ICACHE \fP\fP
+Level 3 instruction Cache (filtered out by default)\&. 
+.TP
+\fB\fIHWLOC_OBJ_GROUP \fP\fP
+Group objects\&. Objects which do not fit in the above but are detected by hwloc and are useful to take into account for affinity\&. For instance, some operating systems expose their arbitrary processors aggregation this way\&. And hwloc may insert such objects to group NUMA nodes according to their distances\&. See also \fBWhat are these Group objects in my topology?\fP\&. These objects are removed when they do not bring any structure (see \fBHWLOC_TYPE_FILTER_KEEP_STRUCTURE\fP)\&. 
+.TP
+\fB\fIHWLOC_OBJ_NUMANODE \fP\fP
+NUMA node\&. An object that contains memory that is directly and byte-accessible to the host processors\&. It is usually close to some cores (the corresponding objects are descendants of the NUMA node object in the hwloc tree)\&. This is the smallest object representing Memory resources, it cannot have any child except Misc objects\&. However it may have Memory-side cache parents\&.
+.PP
+NUMA nodes may correspond to different kinds of memory (DRAM, HBM, CXL-DRAM, etc\&.)\&. When hwloc is able to guess that kind, it is specified in the subtype field of the object\&. See also \fBNormal attributes\fP in the main documentation\&.
+.PP
+There is always at least one such object in the topology even if the machine is not NUMA\&.
+.PP
+Memory objects are not listed in the main children list, but rather in the dedicated Memory children list\&.
+.PP
+NUMA nodes have a special depth \fBHWLOC_TYPE_DEPTH_NUMANODE\fP instead of a normal depth just like other objects in the main tree\&. 
+.TP
+\fB\fIHWLOC_OBJ_BRIDGE \fP\fP
+Bridge (filtered out by default)\&. Any bridge (or PCI switch) that connects the host or an I/O bus, to another I/O bus\&. Bridges are not added to the topology unless their filtering is changed (see \fBhwloc_topology_set_type_filter()\fP and \fBhwloc_topology_set_io_types_filter()\fP)\&.
+.PP
+I/O objects are not listed in the main children list, but rather in the dedicated io children list\&. I/O objects have NULL CPU and node sets\&. 
+.TP
+\fB\fIHWLOC_OBJ_PCI_DEVICE \fP\fP
+PCI device (filtered out by default)\&. PCI devices are not added to the topology unless their filtering is changed (see \fBhwloc_topology_set_type_filter()\fP and \fBhwloc_topology_set_io_types_filter()\fP)\&.
+.PP
+I/O objects are not listed in the main children list, but rather in the dedicated io children list\&. I/O objects have NULL CPU and node sets\&. 
+.TP
+\fB\fIHWLOC_OBJ_OS_DEVICE \fP\fP
+Operating system device (filtered out by default)\&. OS devices are not added to the topology unless their filtering is changed (see \fBhwloc_topology_set_type_filter()\fP and \fBhwloc_topology_set_io_types_filter()\fP)\&.
+.PP
+I/O objects are not listed in the main children list, but rather in the dedicated io children list\&. I/O objects have NULL CPU and node sets\&. 
+.TP
+\fB\fIHWLOC_OBJ_MISC \fP\fP
+Miscellaneous objects (filtered out by default)\&. Objects without particular meaning, that can e\&.g\&. be added by the application for its own use, or by hwloc for miscellaneous objects such as MemoryModule (DIMMs)\&. They are not added to the topology unless their filtering is changed (see \fBhwloc_topology_set_type_filter()\fP)\&.
+.PP
+These objects are not listed in the main children list, but rather in the dedicated misc children list\&. Misc objects may only have Misc objects as children, and those are in the dedicated misc children list as well\&. Misc objects have NULL CPU and node sets\&. 
+.TP
+\fB\fIHWLOC_OBJ_MEMCACHE \fP\fP
+Memory-side cache (filtered out by default)\&. A cache in front of a specific NUMA node\&. This object always has at least one NUMA node as a memory child\&.
+.PP
+Memory objects are not listed in the main children list, but rather in the dedicated Memory children list\&.
+.PP
+Memory-side cache have a special depth \fBHWLOC_TYPE_DEPTH_MEMCACHE\fP instead of a normal depth just like other objects in the main tree\&. 
+.TP
+\fB\fIHWLOC_OBJ_DIE \fP\fP
+Die within a physical package\&. A subpart of the physical package, that contains multiple cores\&. Some operating systems (e\&.g\&. Linux) may expose a single die per package even if the hardware does not support dies at all\&. To avoid showing such non-existing dies, the corresponding hwloc backend may filter them out\&. This is functionally equivalent to \fBHWLOC_TYPE_FILTER_KEEP_STRUCTURE\fP being enforced\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_compare_types (\fBhwloc_obj_type_t\fP type1, \fBhwloc_obj_type_t\fP type2)"
+
+.PP
+Compare the depth of two object types\&. Types shouldn't be compared as they are, since newer ones may be added in the future\&.
+.PP
+\fBReturns\fP
+.RS 4
+A negative integer if \fCtype1\fP objects usually include \fCtype2\fP objects\&. 
+.PP
+A positive integer if \fCtype1\fP objects are usually included in \fCtype2\fP objects\&. 
+.PP
+0 if \fCtype1\fP and \fCtype2\fP objects are the same\&. 
+.PP
+\fBHWLOC_TYPE_UNORDERED\fP if objects cannot be compared (because neither is usually contained in the other)\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Object types containing CPUs can always be compared (usually, a machine contains packages, which contain caches, which contain cores, which contain PUs)\&.
+.PP
+\fBHWLOC_OBJ_PU\fP will always be the deepest, while \fBHWLOC_OBJ_MACHINE\fP is always the highest\&.
+.PP
+This does not mean that the actual topology will respect that order: e\&.g\&. as of today cores may also contain caches, and packages may also contain nodes\&. This is thus just to be seen as a fallback comparison method\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_objects.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_objects.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_objects.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_objects.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,40 @@
+.TH "hwlocality_objects" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_objects \- Object Structure and Attributes
+.SH SYNOPSIS
+.br
+.PP
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBhwloc_obj\fP"
+.br
+.ti -1c
+.RI "union \fBhwloc_obj_attr_u\fP"
+.br
+.ti -1c
+.RI "struct \fBhwloc_info_s\fP"
+.br
+.in -1c
+.SS "Typedefs"
+
+.in +1c
+.ti -1c
+.RI "typedef struct \fBhwloc_obj\fP * \fBhwloc_obj_t\fP"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Typedef Documentation"
+.PP 
+.SS "typedef struct \fBhwloc_obj\fP* \fBhwloc_obj_t\fP"
+
+.PP
+Convenience typedef; a pointer to a struct \fBhwloc_obj\fP\&. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_opencl.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_opencl.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_opencl.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_opencl.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,110 @@
+.TH "hwlocality_opencl" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_opencl \- Interoperability with OpenCL
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_opencl_get_device_pci_busid\fP (cl_device_id device, unsigned *domain, unsigned *bus, unsigned *dev, unsigned *func)"
+.br
+.ti -1c
+.RI "static int \fBhwloc_opencl_get_device_cpuset\fP (\fBhwloc_topology_t\fP topology, cl_device_id device, \fBhwloc_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_opencl_get_device_osdev_by_index\fP (\fBhwloc_topology_t\fP topology, unsigned platform_index, unsigned device_index)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_opencl_get_device_osdev\fP (\fBhwloc_topology_t\fP topology, cl_device_id device)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This interface offers ways to retrieve topology information about OpenCL devices\&.
+.PP
+Only AMD and NVIDIA OpenCL implementations currently offer useful locality information about their devices\&. 
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_opencl_get_device_cpuset (\fBhwloc_topology_t\fP topology, cl_device_id device, \fBhwloc_cpuset_t\fP set)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the CPU set of processors that are physically close to OpenCL device \fCdevice\fP\&. Store in \fCset\fP the CPU-set describing the locality of the OpenCL device \fCdevice\fP\&.
+.PP
+Topology \fCtopology\fP and device \fCdevice\fP must match the local machine\&. I/O devices detection and the OpenCL component are not needed in the topology\&.
+.PP
+The function only returns the locality of the device\&. If more information about the device is needed, OS objects should be used instead, see \fBhwloc_opencl_get_device_osdev()\fP and \fBhwloc_opencl_get_device_osdev_by_index()\fP\&.
+.PP
+This function is currently only implemented in a meaningful way for Linux with the AMD or NVIDIA OpenCL implementation; other systems will simply get a full cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if the device could not be found\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_opencl_get_device_osdev (\fBhwloc_topology_t\fP topology, cl_device_id device)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to OpenCL device \fCdeviceX\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object corresponding to the given OpenCL device \fCdevice\fP\&. 
+.PP
+\fCNULL\fP if none could be found, for instance if required OpenCL attributes are not available\&.
+.RE
+.PP
+This function currently only works on AMD and NVIDIA OpenCL devices that support relevant OpenCL extensions\&. \fBhwloc_opencl_get_device_osdev_by_index()\fP should be preferred whenever possible, i\&.e\&. when platform and device index are known\&.
+.PP
+Topology \fCtopology\fP and device \fCdevice\fP must match the local machine\&. I/O devices detection and the OpenCL component must be enabled in the topology\&. If not, the locality of the object may still be found using \fBhwloc_opencl_get_device_cpuset()\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+This function cannot work if PCI devices are filtered out\&.
+.PP
+The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_opencl_get_device_osdev_by_index (\fBhwloc_topology_t\fP topology, unsigned platform_index, unsigned device_index)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to the OpenCL device for the given indexes\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object describing the OpenCL device whose platform index is \fCplatform_index\fP, and whose device index within this platform if \fCdevice_index\fP\&. 
+.PP
+\fCNULL\fP if there is none\&.
+.RE
+.PP
+The topology \fCtopology\fP does not necessarily have to match the current machine\&. For instance the topology may be an XML import of a remote host\&. I/O devices detection and the OpenCL component must be enabled in the topology\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out)\&. 
+.RE
+.PP
+
+.SS "static int hwloc_opencl_get_device_pci_busid (cl_device_id device, unsigned * domain, unsigned * bus, unsigned * dev, unsigned * func)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Return the domain, bus and device IDs of the OpenCL device \fCdevice\fP\&. Device \fCdevice\fP must match the local machine\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if device information could not be found\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_openfabrics.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_openfabrics.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_openfabrics.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_openfabrics.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,90 @@
+.TH "hwlocality_openfabrics" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_openfabrics \- Interoperability with OpenFabrics
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_ibv_get_device_cpuset\fP (\fBhwloc_topology_t\fP topology, struct ibv_device *ibdev, \fBhwloc_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_ibv_get_device_osdev_by_name\fP (\fBhwloc_topology_t\fP topology, const char *ibname)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_ibv_get_device_osdev\fP (\fBhwloc_topology_t\fP topology, struct ibv_device *ibdev)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This interface offers ways to retrieve topology information about OpenFabrics devices (InfiniBand, Omni-Path, usNIC, etc)\&. 
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_ibv_get_device_cpuset (\fBhwloc_topology_t\fP topology, struct ibv_device * ibdev, \fBhwloc_cpuset_t\fP set)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the CPU set of processors that are physically close to device \fCibdev\fP\&. Store in \fCset\fP the CPU-set describing the locality of the OpenFabrics device \fCibdev\fP (InfiniBand, etc)\&.
+.PP
+Topology \fCtopology\fP and device \fCibdev\fP must match the local machine\&. I/O devices detection is not needed in the topology\&.
+.PP
+The function only returns the locality of the device\&. If more information about the device is needed, OS objects should be used instead, see \fBhwloc_ibv_get_device_osdev()\fP and \fBhwloc_ibv_get_device_osdev_by_name()\fP\&.
+.PP
+This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if device information could not be found\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_ibv_get_device_osdev (\fBhwloc_topology_t\fP topology, struct ibv_device * ibdev)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to the OpenFabrics device \fCibdev\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object describing the OpenFabrics device \fCibdev\fP (InfiniBand, etc)\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+Topology \fCtopology\fP and device \fCibdev\fP must match the local machine\&. I/O devices detection must be enabled in the topology\&. If not, the locality of the object may still be found using \fBhwloc_ibv_get_device_cpuset()\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding PCI device object can be obtained by looking at the OS device parent object\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_ibv_get_device_osdev_by_name (\fBhwloc_topology_t\fP topology, const char * ibname)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to the OpenFabrics device named \fCibname\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object describing the OpenFabrics device (InfiniBand, Omni-Path, usNIC, etc) whose name is \fCibname\fP (mlx5_0, hfi1_0, usnic_0, qib0, etc)\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+The name \fCibname\fP is usually obtained from ibv_get_device_name()\&.
+.PP
+The topology \fCtopology\fP does not necessarily have to match the current machine\&. For instance the topology may be an XML import of a remote host\&. I/O devices detection must be enabled in the topology\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding PCI device object can be obtained by looking at the OS device parent object\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_rsmi.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_rsmi.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_rsmi.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_rsmi.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,88 @@
+.TH "hwlocality_rsmi" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_rsmi \- Interoperability with the ROCm SMI Management Library
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "static int \fBhwloc_rsmi_get_device_cpuset\fP (\fBhwloc_topology_t\fP topology, uint32_t dv_ind, \fBhwloc_cpuset_t\fP set)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_rsmi_get_device_osdev_by_index\fP (\fBhwloc_topology_t\fP topology, uint32_t dv_ind)"
+.br
+.ti -1c
+.RI "static \fBhwloc_obj_t\fP \fBhwloc_rsmi_get_device_osdev\fP (\fBhwloc_topology_t\fP topology, uint32_t dv_ind)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+This interface offers ways to retrieve topology information about devices managed by the ROCm SMI Management Library\&. 
+.SH "Function Documentation"
+.PP 
+.SS "static int hwloc_rsmi_get_device_cpuset (\fBhwloc_topology_t\fP topology, uint32_t dv_ind, \fBhwloc_cpuset_t\fP set)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the CPU set of logical processors that are physically close to AMD GPU device whose index is \fCdv_ind\fP\&. Store in \fCset\fP the CPU-set describing the locality of the AMD GPU device whose index is \fCdv_ind\fP\&.
+.PP
+Topology \fCtopology\fP and device \fCdv_ind\fP must match the local machine\&. I/O devices detection and the ROCm SMI component are not needed in the topology\&.
+.PP
+The function only returns the locality of the device\&. If more information about the device is needed, OS objects should be used instead, see \fBhwloc_rsmi_get_device_osdev()\fP and \fBhwloc_rsmi_get_device_osdev_by_index()\fP\&.
+.PP
+This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if device information could not be found\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_rsmi_get_device_osdev (\fBhwloc_topology_t\fP topology, uint32_t dv_ind)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to AMD GPU device, whose index is \fCdv_ind\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object that describes the given AMD GPU, whose index is \fCdv_ind\fP\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+Topology \fCtopology\fP and device \fCdv_ind\fP must match the local machine\&. I/O devices detection and the ROCm SMI component must be enabled in the topology\&. If not, the locality of the object may still be found using \fBhwloc_rsmi_get_device_cpuset()\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out)\&. 
+.RE
+.PP
+
+.SS "static \fBhwloc_obj_t\fP hwloc_rsmi_get_device_osdev_by_index (\fBhwloc_topology_t\fP topology, uint32_t dv_ind)\fC [inline]\fP, \fC [static]\fP"
+
+.PP
+Get the hwloc OS device object corresponding to the AMD GPU device whose index is \fCdv_ind\fP\&. 
+.PP
+\fBReturns\fP
+.RS 4
+The hwloc OS device object describing the AMD GPU device whose index is \fCdv_ind\fP\&. 
+.PP
+\fCNULL\fP if none could be found\&.
+.RE
+.PP
+The topology \fCtopology\fP does not necessarily have to match the current machine\&. For instance the topology may be an XML import of a remote host\&. I/O devices detection and the ROCm SMI component must be enabled in the topology\&.
+.PP
+\fBNote\fP
+.RS 4
+The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out)\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_setsource.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_setsource.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_setsource.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_setsource.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,177 @@
+.TH "hwlocality_setsource" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_setsource \- Changing the Source of Topology Discovery
+.SH SYNOPSIS
+.br
+.PP
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_topology_components_flag_e\fP { \fBHWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_topology_set_pid\fP (\fBhwloc_topology_t\fP restrict topology, hwloc_pid_t pid)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_set_synthetic\fP (\fBhwloc_topology_t\fP restrict topology, const char *restrict description)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_set_xml\fP (\fBhwloc_topology_t\fP restrict topology, const char *restrict xmlpath)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_set_xmlbuffer\fP (\fBhwloc_topology_t\fP restrict topology, const char *restrict buffer, int size)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_set_components\fP (\fBhwloc_topology_t\fP restrict topology, unsigned long flags, const char *restrict name)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+These functions must be called between \fBhwloc_topology_init()\fP and \fBhwloc_topology_load()\fP\&. Otherwise, they will return -1 with errno set to \fCEBUSY\fP\&.
+.PP
+If none of the functions below is called, the default is to detect all the objects of the machine that the caller is allowed to access\&.
+.PP
+This default behavior may also be modified through environment variables if the application did not modify it already\&. Setting HWLOC_XMLFILE in the environment enforces the discovery from a XML file as if \fBhwloc_topology_set_xml()\fP had been called\&. Setting HWLOC_SYNTHETIC enforces a synthetic topology as if \fBhwloc_topology_set_synthetic()\fP had been called\&.
+.PP
+Finally, HWLOC_THISSYSTEM enforces the return value of \fBhwloc_topology_is_thissystem()\fP\&. 
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_topology_components_flag_e\fP"
+
+.PP
+Flags to be passed to \fBhwloc_topology_set_components()\fP 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST \fP\fP
+Blacklist the target component from being used\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_topology_set_components (\fBhwloc_topology_t\fP restrict topology, unsigned long flags, const char *restrict name)"
+
+.PP
+Prevent a discovery component from being used for a topology\&. \fCname\fP is the name of the discovery component that should not be used when loading topology \fCtopology\fP\&. The name is a string such as 'cuda'\&.
+.PP
+For components with multiple phases, it may also be suffixed with the name of a phase, for instance 'linux:io'\&.
+.PP
+\fCflags\fP should be \fBHWLOC_TOPOLOGY_COMPONENTS_FLAG_BLACKLIST\fP\&.
+.PP
+This may be used to avoid expensive parts of the discovery process\&. For instance, CUDA-specific discovery may be expensive and unneeded while generic I/O discovery could still be useful\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if flags are invalid\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_set_pid (\fBhwloc_topology_t\fP restrict topology, hwloc_pid_t pid)"
+
+.PP
+Change which process the topology is viewed from\&. On some systems, processes may have different views of the machine, for instance the set of allowed CPUs\&. By default, hwloc exposes the view from the current process\&. Calling \fBhwloc_topology_set_pid()\fP permits to make it expose the topology of the machine from the point of view of another process\&.
+.PP
+\fBNote\fP
+.RS 4
+\fChwloc_pid_t\fP is \fCpid_t\fP on Unix platforms, and \fCHANDLE\fP on native Windows platforms\&.
+.PP
+-1 is returned and errno is set to \fCENOSYS\fP on platforms that do not support this feature\&.
+.PP
+The PID will not actually be used until \fBhwloc_topology_load()\fP\&. If the corresponding process exits in the meantime, hwloc will ignore the PID\&. If another process reuses the PID, the view of that process will be used\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_set_synthetic (\fBhwloc_topology_t\fP restrict topology, const char *restrict description)"
+
+.PP
+Enable synthetic topology\&. Gather topology information from the given \fCdescription\fP, a space-separated string of <type:number> describing the object type and arity at each level\&. All types may be omitted (space-separated string of numbers) so that hwloc chooses all types according to usual topologies\&. See also the \fBSynthetic topologies\fP\&.
+.PP
+Setting the environment variable HWLOC_SYNTHETIC may also result in this behavior\&.
+.PP
+If \fCdescription\fP was properly parsed and describes a valid topology configuration, this function returns 0\&. Otherwise -1 is returned and errno is set to \fCEINVAL\fP\&.
+.PP
+Note that this function does not actually load topology information; it just tells hwloc where to load it from\&. You'll still need to invoke \fBhwloc_topology_load()\fP to actually load the topology information\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP if the description was invalid\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+For convenience, this backend provides empty binding hooks which just return success\&.
+.PP
+On success, the synthetic component replaces the previously enabled component (if any), but the topology is not actually modified until \fBhwloc_topology_load()\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_set_xml (\fBhwloc_topology_t\fP restrict topology, const char *restrict xmlpath)"
+
+.PP
+Enable XML-file based topology\&. Gather topology information from the XML file given at \fCxmlpath\fP\&. Setting the environment variable HWLOC_XMLFILE may also result in this behavior\&. This file may have been generated earlier with \fBhwloc_topology_export_xml()\fP in \fBhwloc/export\&.h\fP, or lstopo file\&.xml\&.
+.PP
+Note that this function does not actually load topology information; it just tells hwloc where to load it from\&. You'll still need to invoke \fBhwloc_topology_load()\fP to actually load the topology information\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP on failure to read the XML file\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+See also \fBhwloc_topology_set_userdata_import_callback()\fP for importing application-specific object userdata\&.
+.PP
+For convenience, this backend provides empty binding hooks which just return success\&. To have hwloc still actually call OS-specific hooks, the \fBHWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM\fP has to be set to assert that the loaded file is really the underlying system\&.
+.PP
+On success, the XML component replaces the previously enabled component (if any), but the topology is not actually modified until \fBhwloc_topology_load()\fP\&.
+.PP
+If an invalid XML input file is given, the error may be reported either here or later by \fBhwloc_topology_load()\fP depending on the XML library used by hwloc\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_set_xmlbuffer (\fBhwloc_topology_t\fP restrict topology, const char *restrict buffer, int size)"
+
+.PP
+Enable XML based topology using a memory buffer (instead of a file, as with \fBhwloc_topology_set_xml()\fP)\&. Gather topology information from the XML memory buffer given at \fCbuffer\fP and of length \fCsize\fP (including an ending \\0)\&. This buffer may have been filled earlier with \fBhwloc_topology_export_xmlbuffer()\fP in \fBhwloc/export\&.h\fP\&.
+.PP
+Note that this function does not actually load topology information; it just tells hwloc where to load it from\&. You'll still need to invoke \fBhwloc_topology_load()\fP to actually load the topology information\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP on failure to read the XML buffer\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+See also \fBhwloc_topology_set_userdata_import_callback()\fP for importing application-specific object userdata\&.
+.PP
+For convenience, this backend provides empty binding hooks which just return success\&. To have hwloc still actually call OS-specific hooks, the \fBHWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM\fP has to be set to assert that the loaded file is really the underlying system\&.
+.PP
+On success, the XML component replaces the previously enabled component (if any), but the topology is not actually modified until \fBhwloc_topology_load()\fP\&.
+.PP
+If an invalid XML input file is given, the error may be reported either here or later by \fBhwloc_topology_load()\fP depending on the XML library used by hwloc\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_shmem.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_shmem.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_shmem.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_shmem.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,113 @@
+.TH "hwlocality_shmem" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_shmem \- Sharing topologies between processes
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_shmem_topology_get_length\fP (\fBhwloc_topology_t\fP topology, size_t *lengthp, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_shmem_topology_write\fP (\fBhwloc_topology_t\fP topology, int fd, hwloc_uint64_t fileoffset, void *mmap_address, size_t length, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_shmem_topology_adopt\fP (\fBhwloc_topology_t\fP *topologyp, int fd, hwloc_uint64_t fileoffset, void *mmap_address, size_t length, unsigned long flags)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+These functions are used to share a topology between processes by duplicating it into a file-backed shared-memory buffer\&.
+.PP
+The master process must first get the required shared-memory size for storing this topology with \fBhwloc_shmem_topology_get_length()\fP\&.
+.PP
+Then it must find a virtual memory area of that size that is available in all processes (identical virtual addresses in all processes)\&. On Linux, this can be done by comparing holes found in /proc/<pid>/maps for each process\&.
+.PP
+Once found, it must open a destination file for storing the buffer, and pass it to \fBhwloc_shmem_topology_write()\fP together with virtual memory address and length obtained above\&.
+.PP
+Other processes may then adopt this shared topology by opening the same file and passing it to \fBhwloc_shmem_topology_adopt()\fP with the exact same virtual memory address and length\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_shmem_topology_adopt (\fBhwloc_topology_t\fP * topologyp, int fd, hwloc_uint64_t fileoffset, void * mmap_address, size_t length, unsigned long flags)"
+
+.PP
+Adopt a shared memory topology stored in a file\&. Map a file in virtual memory and adopt the topology that was previously stored there with \fBhwloc_shmem_topology_write()\fP\&.
+.PP
+The returned adopted topology in \fCtopologyp\fP can be used just like any topology\&. And it must be destroyed with \fBhwloc_topology_destroy()\fP as usual\&.
+.PP
+However the topology is read-only\&. For instance, it cannot be modified with \fBhwloc_topology_restrict()\fP and object userdata pointers cannot be changed\&.
+.PP
+The segment of the file pointed by descriptor \fCfd\fP, starting at offset \fCfileoffset\fP, and of length \fClength\fP (in bytes), will be mapped at virtual address \fCmmap_address\fP\&.
+.PP
+The file pointed by descriptor \fCfd\fP, the offset \fCfileoffset\fP, the requested mapping virtual address \fCmmap_address\fP and the length \fClength\fP must be identical to what was given to \fBhwloc_shmem_topology_write()\fP earlier\&.
+.PP
+\fBNote\fP
+.RS 4
+Flags \fCflags\fP are currently unused, must be 0\&.
+.PP
+The object userdata pointer should not be used unless the process that created the shared topology also placed userdata-pointed buffers in shared memory\&.
+.PP
+This function takes care of calling \fBhwloc_topology_abi_check()\fP\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&.
+.PP
+-1 with errno set to \fCEBUSY\fP if the virtual memory mapping defined by \fCmmap_address\fP and \fClength\fP isn't available in the process\&.
+.PP
+-1 with errno set to \fCEINVAL\fP if \fCfileoffset\fP, \fCmmap_address\fP or \fClength\fP aren't page-aligned, or do not match what was given to \fBhwloc_shmem_topology_write()\fP earlier\&.
+.PP
+-1 with errno set to \fCEINVAL\fP if the layout of the topology structure is different between the writer process and the adopter process\&. 
+.RE
+.PP
+
+.SS "int hwloc_shmem_topology_get_length (\fBhwloc_topology_t\fP topology, size_t * lengthp, unsigned long flags)"
+
+.PP
+Get the required shared memory length for storing a topology\&. This length (in bytes) must be used in \fBhwloc_shmem_topology_write()\fP and \fBhwloc_shmem_topology_adopt()\fP later\&.
+.PP
+\fBReturns\fP
+.RS 4
+the length, or -1 on error, for instance if flags are invalid\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Flags \fCflags\fP are currently unused, must be 0\&. 
+.RE
+.PP
+
+.SS "int hwloc_shmem_topology_write (\fBhwloc_topology_t\fP topology, int fd, hwloc_uint64_t fileoffset, void * mmap_address, size_t length, unsigned long flags)"
+
+.PP
+Duplicate a topology to a shared memory file\&. Temporarily map a file in virtual memory and duplicate the topology \fCtopology\fP by allocating duplicates in there\&.
+.PP
+The segment of the file pointed by descriptor \fCfd\fP, starting at offset \fCfileoffset\fP, and of length \fClength\fP (in bytes), will be temporarily mapped at virtual address \fCmmap_address\fP during the duplication\&.
+.PP
+The mapping length \fClength\fP must have been previously obtained with \fBhwloc_shmem_topology_get_length()\fP and the topology must not have been modified in the meantime\&.
+.PP
+\fBNote\fP
+.RS 4
+Flags \fCflags\fP are currently unused, must be 0\&.
+.PP
+The object userdata pointer is duplicated but the pointed buffer is not\&. However the caller may also allocate it manually in shared memory to share it as well\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCEBUSY\fP if the virtual memory mapping defined by \fCmmap_address\fP and \fClength\fP isn't available in the process\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP if \fCfileoffset\fP, \fCmmap_address\fP or \fClength\fP aren't page-aligned\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_syntheticexport.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_syntheticexport.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_syntheticexport.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_syntheticexport.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,75 @@
+.TH "hwlocality_syntheticexport" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_syntheticexport \- Exporting Topologies to Synthetic
+.SH SYNOPSIS
+.br
+.PP
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_topology_export_synthetic_flags_e\fP { \fBHWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES\fP, \fBHWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS\fP, \fBHWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1\fP, \fBHWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_topology_export_synthetic\fP (\fBhwloc_topology_t\fP topology, char *buffer, size_t buflen, unsigned long flags)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_topology_export_synthetic_flags_e\fP"
+
+.PP
+Flags for exporting synthetic topologies\&. Flags to be given as a OR'ed set to \fBhwloc_topology_export_synthetic()\fP\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_EXTENDED_TYPES \fP\fP
+Export extended types such as L2dcache as basic types such as Cache\&. This is required if loading the synthetic description with hwloc < 1\&.9\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_NO_ATTRS \fP\fP
+Do not export level attributes\&. Ignore level attributes such as memory/cache sizes or PU indexes\&. This is required if loading the synthetic description with hwloc < 1\&.10\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_V1 \fP\fP
+Export the memory hierarchy as expected in hwloc 1\&.x\&. Instead of attaching memory children to levels, export single NUMA node child as normal intermediate levels, when possible\&. This is required if loading the synthetic description with hwloc 1\&.x\&. However this may fail if some objects have multiple local NUMA nodes\&. 
+.TP
+\fB\fIHWLOC_TOPOLOGY_EXPORT_SYNTHETIC_FLAG_IGNORE_MEMORY \fP\fP
+Do not export memory information\&. Only export the actual hierarchy of normal CPU-side objects and ignore where memory is attached\&. This is useful for when the hierarchy of CPUs is what really matters, but it behaves as if there was a single machine-wide NUMA node\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_topology_export_synthetic (\fBhwloc_topology_t\fP topology, char * buffer, size_t buflen, unsigned long flags)"
+
+.PP
+Export the topology as a synthetic string\&. At most \fCbuflen\fP characters will be written in \fCbuffer\fP, including the terminating \\0\&.
+.PP
+This exported string may be given back to \fBhwloc_topology_set_synthetic()\fP\&.
+.PP
+\fCflags\fP is a OR'ed set of \fBhwloc_topology_export_synthetic_flags_e\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+The number of characters that were written, not including the terminating \\0\&.
+.PP
+-1 if the topology could not be exported, for instance if it is not symmetric\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+I/O and Misc children are ignored, the synthetic string only describes normal children\&.
+.PP
+A 1024-byte buffer should be large enough for exporting topologies in the vast majority of cases\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_tinker.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_tinker.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_tinker.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_tinker.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,282 @@
+.TH "hwlocality_tinker" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_tinker \- Modifying a loaded Topology
+.SH SYNOPSIS
+.br
+.PP
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_restrict_flags_e\fP { \fBHWLOC_RESTRICT_FLAG_REMOVE_CPULESS\fP, \fBHWLOC_RESTRICT_FLAG_BYNODESET\fP = (1UL<<3), \fBHWLOC_RESTRICT_FLAG_REMOVE_MEMLESS\fP, \fBHWLOC_RESTRICT_FLAG_ADAPT_MISC\fP, \fBHWLOC_RESTRICT_FLAG_ADAPT_IO\fP }"
+.br
+.ti -1c
+.RI "enum \fBhwloc_allow_flags_e\fP { \fBHWLOC_ALLOW_FLAG_ALL\fP, \fBHWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS\fP, \fBHWLOC_ALLOW_FLAG_CUSTOM\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_topology_restrict\fP (\fBhwloc_topology_t\fP restrict topology, \fBhwloc_const_bitmap_t\fP set, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_allow\fP (\fBhwloc_topology_t\fP restrict topology, \fBhwloc_const_cpuset_t\fP cpuset, \fBhwloc_const_nodeset_t\fP nodeset, unsigned long flags)"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_t\fP \fBhwloc_topology_insert_misc_object\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP parent, const char *name)"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_t\fP \fBhwloc_topology_alloc_group_object\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_free_group_object\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP group)"
+.br
+.ti -1c
+.RI "\fBhwloc_obj_t\fP \fBhwloc_topology_insert_group_object\fP (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP group)"
+.br
+.ti -1c
+.RI "int \fBhwloc_obj_add_other_obj_sets\fP (\fBhwloc_obj_t\fP dst, \fBhwloc_obj_t\fP src)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_refresh\fP (\fBhwloc_topology_t\fP topology)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_allow_flags_e\fP"
+
+.PP
+Flags to be given to \fBhwloc_topology_allow()\fP\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_ALLOW_FLAG_ALL \fP\fP
+Mark all objects as allowed in the topology\&. \fCcpuset\fP and \fCnođeset\fP given to \fBhwloc_topology_allow()\fP must be \fCNULL\fP\&. 
+.TP
+\fB\fIHWLOC_ALLOW_FLAG_LOCAL_RESTRICTIONS \fP\fP
+Only allow objects that are available to the current process\&. The topology must have \fBHWLOC_TOPOLOGY_FLAG_IS_THISSYSTEM\fP so that the set of available resources can actually be retrieved from the operating system\&.
+.PP
+\fCcpuset\fP and \fCnođeset\fP given to \fBhwloc_topology_allow()\fP must be \fCNULL\fP\&. 
+.TP
+\fB\fIHWLOC_ALLOW_FLAG_CUSTOM \fP\fP
+Allow a custom set of objects, given to \fBhwloc_topology_allow()\fP as \fCcpuset\fP and/or \fCnodeset\fP parameters\&. 
+.SS "enum \fBhwloc_restrict_flags_e\fP"
+
+.PP
+Flags to be given to \fBhwloc_topology_restrict()\fP\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_RESTRICT_FLAG_REMOVE_CPULESS \fP\fP
+Remove all objects that became CPU-less\&. By default, only objects that contain no PU and no memory are removed\&. This flag may not be used with \fBHWLOC_RESTRICT_FLAG_BYNODESET\fP\&. 
+.TP
+\fB\fIHWLOC_RESTRICT_FLAG_BYNODESET \fP\fP
+Restrict by nodeset instead of CPU set\&. Only keep objects whose nodeset is included or partially included in the given set\&. This flag may not be used with \fBHWLOC_RESTRICT_FLAG_REMOVE_CPULESS\fP\&. 
+.TP
+\fB\fIHWLOC_RESTRICT_FLAG_REMOVE_MEMLESS \fP\fP
+Remove all objects that became Memory-less\&. By default, only objects that contain no PU and no memory are removed\&. This flag may only be used with \fBHWLOC_RESTRICT_FLAG_BYNODESET\fP\&. 
+.TP
+\fB\fIHWLOC_RESTRICT_FLAG_ADAPT_MISC \fP\fP
+Move Misc objects to ancestors if their parents are removed during restriction\&. If this flag is not set, Misc objects are removed when their parents are removed\&. 
+.TP
+\fB\fIHWLOC_RESTRICT_FLAG_ADAPT_IO \fP\fP
+Move I/O objects to ancestors if their parents are removed during restriction\&. If this flag is not set, I/O devices and bridges are removed when their parents are removed\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_obj_add_other_obj_sets (\fBhwloc_obj_t\fP dst, \fBhwloc_obj_t\fP src)"
+
+.PP
+Setup object cpusets/nodesets by OR'ing another object's sets\&. For each defined cpuset or nodeset in \fCsrc\fP, allocate the corresponding set in \fCdst\fP and add \fCsrc\fP to it by OR'ing sets\&.
+.PP
+This function is convenient between \fBhwloc_topology_alloc_group_object()\fP and \fBhwloc_topology_insert_group_object()\fP\&. It builds the sets of the new Group that will be inserted as a new intermediate parent of several objects\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCENOMEM\fP if some internal reallocation failed\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_obj_t\fP hwloc_topology_alloc_group_object (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Allocate a Group object to insert later with \fBhwloc_topology_insert_group_object()\fP\&. This function returns a new Group object\&.
+.PP
+The caller should (at least) initialize its sets before inserting the object in the topology, see \fBhwloc_topology_insert_group_object()\fP\&. Or it may decide not to insert and just free the group object by calling \fBhwloc_topology_free_group_object()\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+The allocated object on success\&. 
+.PP
+\fCNULL\fP on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+If successfully inserted by \fBhwloc_topology_insert_group_object()\fP, the object will be freed when the entire topology is freed\&. If insertion failed (e\&.g\&. \fCNULL\fP or empty CPU and node-sets), it is freed before returning the error\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_allow (\fBhwloc_topology_t\fP restrict topology, \fBhwloc_const_cpuset_t\fP cpuset, \fBhwloc_const_nodeset_t\fP nodeset, unsigned long flags)"
+
+.PP
+Change the sets of allowed PUs and NUMA nodes in the topology\&. This function only works if the \fBHWLOC_TOPOLOGY_FLAG_INCLUDE_DISALLOWED\fP was set on the topology\&. It does not modify any object, it only changes the sets returned by \fBhwloc_topology_get_allowed_cpuset()\fP and \fBhwloc_topology_get_allowed_nodeset()\fP\&.
+.PP
+It is notably useful when importing a topology from another process running in a different Linux Cgroup\&.
+.PP
+\fCflags\fP must be set to one flag among \fBhwloc_allow_flags_e\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+Removing objects from a topology should rather be performed with \fBhwloc_topology_restrict()\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_free_group_object (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP group)"
+
+.PP
+Free a group object allocated with \fBhwloc_topology_alloc_group_object()\fP\&. This function is only useful if the group object was not given to \fBhwloc_topology_insert_group_object()\fP as planned\&.
+.PP
+\fBNote\fP
+.RS 4
+\fCtopology\fP must be the same as the one previously passed to \fBhwloc_topology_alloc_group_object()\fP\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+\fC0\fP on success\&. 
+.PP
+\fC-1\fP on error, for instance if an invalid topology is given\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_obj_t\fP hwloc_topology_insert_group_object (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP group)"
+
+.PP
+Add more structure to the topology by adding an intermediate Group\&. The caller should first allocate a new Group object with \fBhwloc_topology_alloc_group_object()\fP\&. Then it must setup at least one of its CPU or node sets to specify the final location of the Group in the topology\&. Then the object can be passed to this function for actual insertion in the topology\&.
+.PP
+The main use case for this function is to group a subset of siblings among the list of children below a single parent\&. For instance, if grouping 4 cores out of a 8-core socket, the logical list of cores will be reordered so that the 4 grouped ones are consecutive\&. Then, if needed, a new depth is added between the parent and those children, and the Group is inserted there\&. At the end, the 4 grouped cores are now children of the Group, which replaces them as a child of the original parent\&.
+.PP
+In practice, the grouped objects are specified through cpusets and/or nodesets, for instance using \fBhwloc_obj_add_other_obj_sets()\fP iteratively\&. Hence it is possible to group objects that are not children of the same parent, for instance some PUs below the 4 cores in example above\&. However this general case may fail if the expected Group conflicts with the existing hierarchy\&. For instance if each core has two PUs, it is not possible to insert a Group containing a single PU of each core\&.
+.PP
+To specify the objects to group, either the cpuset or nodeset field (or both, if compatible) must be set to a non-empty bitmap\&. The complete_cpuset or complete_nodeset may be set instead if inserting with respect to the complete topology (including disallowed, offline or unknown objects)\&. These sets cannot be larger than the current topology, or they would get restricted silently\&. The core will setup the other sets after actual insertion\&.
+.PP
+The \fCsubtype\fP object attribute may be defined with \fBhwloc_obj_set_subtype()\fP to display something else than 'Group' as the type name for this object in lstopo\&. Custom name-value info pairs may be added with \fBhwloc_obj_add_info()\fP after insertion\&.
+.PP
+The group \fCdont_merge\fP attribute may be set to \fC1\fP to prevent the hwloc core from ever merging this object with another hierarchically-identical object\&. This is useful when the Group itself describes an important feature that cannot be exposed anywhere else in the hierarchy\&.
+.PP
+The group \fCkind\fP attribute may be set to a high value such as \fC0xffffffff\fP to tell hwloc that this new Group should always be discarded in favor of any existing Group with the same locality\&.
+.PP
+\fBNote\fP
+.RS 4
+Inserting a group adds some locality information to the topology, hence the existing objects may get reordered (including PUs and NUMA nodes), and their logical indexes may change\&.
+.PP
+If the insertion fails, the input group object is freed\&.
+.PP
+If the group object should be discarded instead of inserted, it may be passed to \fBhwloc_topology_free_group_object()\fP instead\&.
+.PP
+\fCtopology\fP must be the same as the one previously passed to \fBhwloc_topology_alloc_group_object()\fP\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+The inserted object if it was properly inserted\&.
+.PP
+An existing object if the Group was merged or discarded because the topology already contained an object at the same location (the Group did not add any hierarchy information)\&.
+.PP
+\fCNULL\fP if the insertion failed because of conflicting sets in topology tree\&.
+.PP
+\fCNULL\fP if Group objects are filtered-out of the topology (\fBHWLOC_TYPE_FILTER_KEEP_NONE\fP)\&.
+.PP
+\fCNULL\fP if the object was discarded because no set was initialized in the Group before insert, or all of them were empty\&. 
+.RE
+.PP
+
+.SS "\fBhwloc_obj_t\fP hwloc_topology_insert_misc_object (\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP parent, const char * name)"
+
+.PP
+Add a MISC object as a leaf of the topology\&. A new MISC object will be created and inserted into the topology at the position given by parent\&. It is appended to the list of existing Misc children, without ever adding any intermediate hierarchy level\&. This is useful for annotating the topology without actually changing the hierarchy\&.
+.PP
+\fCname\fP is supposed to be unique across all Misc objects in the topology\&. It will be duplicated to setup the new object attributes\&.
+.PP
+The new leaf object will not have any \fCcpuset\fP\&.
+.PP
+The \fCsubtype\fP object attribute may be defined with \fBhwloc_obj_set_subtype()\fP after successful insertion\&.
+.PP
+\fBReturns\fP
+.RS 4
+the newly-created object
+.PP
+\fCNULL\fP on error\&.
+.PP
+\fCNULL\fP if Misc objects are filtered-out of the topology (\fBHWLOC_TYPE_FILTER_KEEP_NONE\fP)\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+If \fCname\fP contains some non-printable characters, they will be dropped when exporting to XML, see \fBhwloc_topology_export_xml()\fP in \fBhwloc/export\&.h\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_refresh (\fBhwloc_topology_t\fP topology)"
+
+.PP
+Refresh internal structures after topology modification\&. Modifying the topology (by restricting, adding objects, modifying structures such as distances or memory attributes, etc\&.) may cause some internal caches to become invalid\&. These caches are automatically refreshed when accessed but this refreshing is not thread-safe\&.
+.PP
+This function is not thread-safe either, but it is a good way to end a non-thread-safe phase of topology modification\&. Once this refresh is done, multiple threads may concurrently consult the topology, objects, distances, attributes, etc\&.
+.PP
+See also \fBThread Safety\fP
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 on error, for instance if some internal reallocation failed\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_restrict (\fBhwloc_topology_t\fP restrict topology, \fBhwloc_const_bitmap_t\fP set, unsigned long flags)"
+
+.PP
+Restrict the topology to the given CPU set or nodeset\&. Topology \fCtopology\fP is modified so as to remove all objects that are not included (or partially included) in the CPU set \fCset\fP\&. All objects CPU and node sets are restricted accordingly\&.
+.PP
+By default, \fCset\fP is a CPU set\&. It means that the set of PUs in the topology is restricted\&. Once some PUs got removed, their parents may also get removed recursively if they became child-less\&.
+.PP
+If \fBHWLOC_RESTRICT_FLAG_BYNODESET\fP is passed in \fCflags\fP, \fCset\fP is considered a nodeset instead of a CPU set\&. It means that the set of NUMA nodes in the topology is restricted (instead of PUs)\&. Once some NUMA nodes got removed, their parents may also get removed recursively if they became child-less\&.
+.PP
+\fCflags\fP is a OR'ed set of \fBhwloc_restrict_flags_e\fP\&.
+.PP
+\fBNote\fP
+.RS 4
+Restricting the topology removes some locality information, hence the remaining objects may get reordered (including PUs and NUMA nodes), and their logical indexes may change\&.
+.PP
+This call may not be reverted by restricting back to a larger set\&. Once dropped during restriction, objects may not be brought back, except by loading another topology with \fBhwloc_topology_load()\fP\&.
+.RE
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&.
+.PP
+-1 with errno set to \fCEINVAL\fP if the input set is invalid\&. The topology is not modified in this case\&.
+.PP
+-1 with errno set to \fCENOMEM\fP on failure to allocate internal data\&. The topology is reinitialized in this case\&. It should be either destroyed with \fBhwloc_topology_destroy()\fP or configured and loaded again\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_windows.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_windows.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_windows.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_windows.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,54 @@
+.TH "hwlocality_windows" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_windows \- Windows-specific helpers
+.SH SYNOPSIS
+.br
+.PP
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_windows_get_nr_processor_groups\fP (\fBhwloc_topology_t\fP topology, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_windows_get_processor_group_cpuset\fP (\fBhwloc_topology_t\fP topology, unsigned pg_index, \fBhwloc_cpuset_t\fP cpuset, unsigned long flags)"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+These functions query Windows processor groups\&. These groups partition the operating system into virtual sets of up to 64 neighbor PUs\&. Threads and processes may only be bound inside a single group\&. Although Windows processor groups may be exposed in the hwloc hierarchy as hwloc Groups, they are also often merged into existing hwloc objects such as NUMA nodes or Packages\&. This API provides explicit information about Windows processor groups so that applications know whether binding to a large set of PUs may fail because it spans over multiple Windows processor groups\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_windows_get_nr_processor_groups (\fBhwloc_topology_t\fP topology, unsigned long flags)"
+
+.PP
+Get the number of Windows processor groups\&. \fCflags\fP must be 0 for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+at least \fC1\fP on success\&. 
+.PP
+-1 on error, for instance if the topology does not match the current system (e\&.g\&. loaded from another machine through XML)\&. 
+.RE
+.PP
+
+.SS "int hwloc_windows_get_processor_group_cpuset (\fBhwloc_topology_t\fP topology, unsigned pg_index, \fBhwloc_cpuset_t\fP cpuset, unsigned long flags)"
+
+.PP
+Get the CPU-set of a Windows processor group\&. Get the set of PU included in the processor group specified by \fCpg_index\fP\&. \fCpg_index\fP must be between \fC0\fP and the value returned by \fBhwloc_windows_get_nr_processor_groups()\fP minus 1\&.
+.PP
+\fCflags\fP must be 0 for now\&.
+.PP
+\fBReturns\fP
+.RS 4
+\fC0\fP on success\&. 
+.PP
+\fC-1\fP on error, for instance if \fCpg_index\fP is invalid, or if the topology does not match the current system (e\&.g\&. loaded from another machine through XML)\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_xmlexport.3 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_xmlexport.3
--- 2.10.0-1/doc/doxygen-doc/man/man3/hwlocality_xmlexport.3	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/doc/doxygen-doc/man/man3/hwlocality_xmlexport.3	2024-06-25 12:42:07.000000000 +0000
@@ -0,0 +1,196 @@
+.TH "hwlocality_xmlexport" 3 "Version 2.11.0" "Hardware Locality (hwloc)" \" -*- nroff -*-
+.ad l
+.nh
+.SH NAME
+hwlocality_xmlexport \- Exporting Topologies to XML
+.SH SYNOPSIS
+.br
+.PP
+.SS "Enumerations"
+
+.in +1c
+.ti -1c
+.RI "enum \fBhwloc_topology_export_xml_flags_e\fP { \fBHWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1\fP }"
+.br
+.in -1c
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "int \fBhwloc_topology_export_xml\fP (\fBhwloc_topology_t\fP topology, const char *xmlpath, unsigned long flags)"
+.br
+.ti -1c
+.RI "int \fBhwloc_topology_export_xmlbuffer\fP (\fBhwloc_topology_t\fP topology, char **xmlbuffer, int *buflen, unsigned long flags)"
+.br
+.ti -1c
+.RI "void \fBhwloc_free_xmlbuffer\fP (\fBhwloc_topology_t\fP topology, char *xmlbuffer)"
+.br
+.ti -1c
+.RI "void \fBhwloc_topology_set_userdata_export_callback\fP (\fBhwloc_topology_t\fP topology, void(*export_cb)(void *reserved, \fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj))"
+.br
+.ti -1c
+.RI "int \fBhwloc_export_obj_userdata\fP (void *reserved, \fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj, const char *name, const void *buffer, size_t length)"
+.br
+.ti -1c
+.RI "int \fBhwloc_export_obj_userdata_base64\fP (void *reserved, \fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj, const char *name, const void *buffer, size_t length)"
+.br
+.ti -1c
+.RI "void \fBhwloc_topology_set_userdata_import_callback\fP (\fBhwloc_topology_t\fP topology, void(*import_cb)(\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj, const char *name, const void *buffer, size_t length))"
+.br
+.in -1c
+.SH "Detailed Description"
+.PP 
+
+.SH "Enumeration Type Documentation"
+.PP 
+.SS "enum \fBhwloc_topology_export_xml_flags_e\fP"
+
+.PP
+Flags for exporting XML topologies\&. Flags to be given as a OR'ed set to \fBhwloc_topology_export_xml()\fP\&. 
+.PP
+\fBEnumerator\fP
+.in +1c
+.TP
+\fB\fIHWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1 \fP\fP
+Export XML that is loadable by hwloc v1\&.x\&. However, the export may miss some details about the topology\&. 
+.SH "Function Documentation"
+.PP 
+.SS "int hwloc_export_obj_userdata (void * reserved, \fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj, const char * name, const void * buffer, size_t length)"
+
+.PP
+Export some object userdata to XML\&. This function may only be called from within the export() callback passed to \fBhwloc_topology_set_userdata_export_callback()\fP\&. It may be invoked one of multiple times to export some userdata to XML\&. The \fCbuffer\fP content of length \fClength\fP is stored with optional name \fCname\fP\&.
+.PP
+When importing this XML file, the import() callback (if set) will be called exactly as many times as \fBhwloc_export_obj_userdata()\fP was called during export()\&. It will receive the corresponding \fCname\fP, \fCbuffer\fP and \fClength\fP arguments\&.
+.PP
+\fCreserved\fP, \fCtopology\fP and \fCobj\fP must be the first three parameters that were given to the export callback\&.
+.PP
+Only printable characters may be exported to XML string attributes\&.
+.PP
+If exporting binary data, the application should first encode into printable characters only (or use \fBhwloc_export_obj_userdata_base64()\fP)\&. It should also take care of portability issues if the export may be reimported on a different architecture\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP if a non-printable character is passed in \fCname\fP or \fBbuffer\fP\&. 
+.RE
+.PP
+
+.SS "int hwloc_export_obj_userdata_base64 (void * reserved, \fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj, const char * name, const void * buffer, size_t length)"
+
+.PP
+Encode and export some object userdata to XML\&. This function is similar to \fBhwloc_export_obj_userdata()\fP but it encodes the input buffer into printable characters before exporting\&. On import, decoding is automatically performed before the data is given to the import() callback if any\&.
+.PP
+This function may only be called from within the export() callback passed to \fBhwloc_topology_set_userdata_export_callback()\fP\&.
+.PP
+The name must be made of printable characters for export to XML string attributes\&.
+.PP
+The function does not take care of portability issues if the export may be reimported on a different architecture\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success\&. 
+.PP
+-1 with errno set to \fCEINVAL\fP if a non-printable character is passed in \fCname\fP\&. 
+.RE
+.PP
+
+.SS "void hwloc_free_xmlbuffer (\fBhwloc_topology_t\fP topology, char * xmlbuffer)"
+
+.PP
+Free a buffer allocated by \fBhwloc_topology_export_xmlbuffer()\fP 
+.SS "int hwloc_topology_export_xml (\fBhwloc_topology_t\fP topology, const char * xmlpath, unsigned long flags)"
+
+.PP
+Export the topology into an XML file\&. This file may be loaded later through \fBhwloc_topology_set_xml()\fP\&.
+.PP
+By default, the latest export format is used, which means older hwloc releases (e\&.g\&. v1\&.x) will not be able to import it\&. Exporting to v1\&.x specific XML format is possible using flag \fBHWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1\fP but it may miss some details about the topology\&. If there is any chance that the exported file may ever be imported back by a process using hwloc 1\&.x, one should consider detecting it at runtime and using the corresponding export format\&.
+.PP
+\fCflags\fP is a OR'ed set of \fBhwloc_topology_export_xml_flags_e\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, or -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+See also \fBhwloc_topology_set_userdata_export_callback()\fP for exporting application-specific object userdata\&.
+.PP
+The topology-specific userdata pointer is ignored when exporting to XML\&.
+.PP
+Only printable characters may be exported to XML string attributes\&. Any other character, especially any non-ASCII character, will be silently dropped\&.
+.PP
+If \fCname\fP is '-', the XML output is sent to the standard output\&. 
+.RE
+.PP
+
+.SS "int hwloc_topology_export_xmlbuffer (\fBhwloc_topology_t\fP topology, char ** xmlbuffer, int * buflen, unsigned long flags)"
+
+.PP
+Export the topology into a newly-allocated XML memory buffer\&. \fCxmlbuffer\fP is allocated by the callee and should be freed with \fBhwloc_free_xmlbuffer()\fP later in the caller\&.
+.PP
+This memory buffer may be loaded later through \fBhwloc_topology_set_xmlbuffer()\fP\&.
+.PP
+By default, the latest export format is used, which means older hwloc releases (e\&.g\&. v1\&.x) will not be able to import it\&. Exporting to v1\&.x specific XML format is possible using flag \fBHWLOC_TOPOLOGY_EXPORT_XML_FLAG_V1\fP but it may miss some details about the topology\&. If there is any chance that the exported buffer may ever be imported back by a process using hwloc 1\&.x, one should consider detecting it at runtime and using the corresponding export format\&.
+.PP
+The returned buffer ends with a \\0 that is included in the returned length\&.
+.PP
+\fCflags\fP is a OR'ed set of \fBhwloc_topology_export_xml_flags_e\fP\&.
+.PP
+\fBReturns\fP
+.RS 4
+0 on success, or -1 on error\&.
+.RE
+.PP
+\fBNote\fP
+.RS 4
+See also \fBhwloc_topology_set_userdata_export_callback()\fP for exporting application-specific object userdata\&.
+.PP
+The topology-specific userdata pointer is ignored when exporting to XML\&.
+.PP
+Only printable characters may be exported to XML string attributes\&. Any other character, especially any non-ASCII character, will be silently dropped\&. 
+.RE
+.PP
+
+.SS "void hwloc_topology_set_userdata_export_callback (\fBhwloc_topology_t\fP topology, void(*)(void *reserved, \fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj) export_cb)"
+
+.PP
+Set the application-specific callback for exporting object userdata\&. The object userdata pointer is not exported to XML by default because hwloc does not know what it contains\&.
+.PP
+This function lets applications set \fCexport_cb\fP to a callback function that converts this opaque userdata into an exportable string\&.
+.PP
+\fCexport_cb\fP is invoked during XML export for each object whose \fCuserdata\fP pointer is not \fCNULL\fP\&. The callback should use \fBhwloc_export_obj_userdata()\fP or \fBhwloc_export_obj_userdata_base64()\fP to actually export something to XML (possibly multiple times per object)\&.
+.PP
+\fCexport_cb\fP may be set to \fCNULL\fP if userdata should not be exported to XML\&.
+.PP
+\fBNote\fP
+.RS 4
+The topology-specific userdata pointer is ignored when exporting to XML\&. 
+.RE
+.PP
+
+.SS "void hwloc_topology_set_userdata_import_callback (\fBhwloc_topology_t\fP topology, void(*)(\fBhwloc_topology_t\fP topology, \fBhwloc_obj_t\fP obj, const char *name, const void *buffer, size_t length) import_cb)"
+
+.PP
+Set the application-specific callback for importing userdata\&. On XML import, userdata is ignored by default because hwloc does not know how to store it in memory\&.
+.PP
+This function lets applications set \fCimport_cb\fP to a callback function that will get the XML-stored userdata and store it in the object as expected by the application\&.
+.PP
+\fCimport_cb\fP is called during \fBhwloc_topology_load()\fP as many times as \fBhwloc_export_obj_userdata()\fP was called during export\&. The topology is not entirely setup yet\&. Object attributes are ready to consult, but links between objects are not\&.
+.PP
+\fCimport_cb\fP may be \fCNULL\fP if userdata should be ignored during import\&.
+.PP
+\fBNote\fP
+.RS 4
+\fCbuffer\fP contains \fClength\fP characters followed by a null byte ('\\0')\&.
+.PP
+This function should be called before \fBhwloc_topology_load()\fP\&.
+.PP
+The topology-specific userdata pointer is ignored when importing from XML\&. 
+.RE
+.PP
+
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for Hardware Locality (hwloc) from the source code\&.
diff -pruN 2.10.0-1/doc/hwloc.doxy 2.11.0-1/doc/hwloc.doxy
--- 2.10.0-1/doc/hwloc.doxy	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/doc/hwloc.doxy	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2013 Université Bordeaux
  * Copyright © 2009-2020 Cisco Systems, Inc.  All rights reserved.
  * Copyright © 2020 Hewlett Packard Enterprise.  All rights reserved.
@@ -14,9 +14,6 @@
 <hr>
 <br>
 
-\htmlonly
-<div class="section" id="toc">
-\endhtmlonly
 \section toc Table of Contents
 
 <ul>
@@ -31,6 +28,7 @@
 <li> Chapters
  <ul>
  <li> \ref installation
+ <li> \ref useapi
  <li> \ref termsanddefs
  <li> \ref tools
  <li> \ref envvar
@@ -56,9 +54,6 @@ Chapters are also available from the <i>
 \endhtmlonly
 
 
-\htmlonly
-</div><div class="section" id="overview">
-\endhtmlonly
 \section overview hwloc Overview
 
 The Hardware Locality (hwloc) software project aims at easing the process
@@ -139,10 +134,6 @@ Bindings for several other languages are
 <a href="https://www.open-mpi.org/projects/hwloc/#language_bindings">project website</a>.
 
 
-
-\htmlonly
-</div><div class="section" id="cli_examples">
-\endhtmlonly
 \section cli_examples Command-line Examples
 
 On a 4-package 2-core machine with hyper-threading, the \c lstopo tool
@@ -248,9 +239,6 @@ Machine (total 16GB)
 \endverbatim
 
 
-\htmlonly
-</div><div class="section" id="interface">
-\endhtmlonly
 \section interface Programming Interface
 
 The basic interface is available in hwloc.h.
@@ -286,6 +274,7 @@ process.  The documentation is installed
 $prefix/share/doc/hwloc/ and your systems default man page tree (under
 $prefix, of course).
 
+
 \subsection portability Portability
 
 Operating System have varying support for CPU and memory binding,
@@ -365,16 +354,8 @@ tree.
 \include examples/hwloc-hello.c
 
 hwloc provides a \c pkg-config executable to obtain relevant compiler
-and linker flags.  For example, it can be used thusly to compile
-applications that utilize the hwloc library (assuming GNU Make):
-
-\verbatim
-CFLAGS += $(shell pkg-config --cflags hwloc)
-LDLIBS += $(shell pkg-config --libs hwloc)
-
-hwloc-hello: hwloc-hello.c
-        $(CC) hwloc-hello.c $(CFLAGS) -o hwloc-hello $(LDLIBS)
-\endverbatim
+and linker flags. See \ref useapi for details on building program
+on top of hwloc's API using GNU Make or CMake.
 
 On a machine 2 processor packages -- each package of
 which has two processing cores -- the output from running \c
@@ -415,10 +396,6 @@ shell$
 \endverbatim
 
 
-
-\htmlonly
-</div><div class="section" id="bugs">
-\endhtmlonly
 \section bugs Questions and Bugs
 
 Bugs should be reported in the tracker
@@ -432,10 +409,6 @@ Questions may be sent to the users or de
 There is also a <tt>\#hwloc</tt> IRC channel on Libera Chat (<tt>irc.libera.chat</tt>).
 
 
-
-\htmlonly
-</div><div class="section" id="history">
-\endhtmlonly
 \section history History / Credits
 
 hwloc is the evolution and merger of the libtopology project and the Portable
@@ -450,10 +423,6 @@ the Open MPI development team as a sub-p
 in favor of hwloc, which is distributed as an Open MPI sub-project.
 
 
-\htmlonly
-</div>
-\endhtmlonly
-
 
 
 \page installation Installation
@@ -465,9 +434,7 @@ any functionality from Open MPI -- it is
 smaller!) project and code base.  It just happens to be hosted as part
 of the overall Open MPI project.
 
-\htmlonly
-</div><div class="section" id="basic_installation">
-\endhtmlonly
+
 \section basic_installation Basic Installation
 
 Installation is the fairly common GNU-based process:
@@ -484,9 +451,6 @@ Running the "lstopo" tool is a good way
 whether hwloc properly detected the architecture of your node.
 
 
-\htmlonly
-</div><div class="section" id="optional_dependencies">
-\endhtmlonly
 \section optional_dependencies Optional Dependencies
 
 lstopo may also export graphics to the SVG and "fig" file formats.
@@ -568,9 +532,6 @@ Note that because of the possibility of
 that hwloc is BSD-licensed).
 
 
-\htmlonly
-</div><div class="section" id="gitclone_installation">
-\endhtmlonly
 \section gitclone_installation Installing from a Git clone
 
 Additionally, the code can be directly cloned from Git:
@@ -590,12 +551,78 @@ or GNU Autotools.
 
 
 
-\page termsanddefs Terms and Definitions 
 
+\page useapi Compiling software on top of hwloc's C API
+
+A program using the hwloc C API (for instance with <tt>hwloc-hello.c</tt>
+presented in \ref interface_example) may be built with standard
+development tools.
+<tt>pkg-config</tt> provides easy ways to retrieve the required compiler
+and linker flags as described below, but it is not mandatory.
+
+
+\section useapi_gnumake Compiling on top of hwloc's C API with GNU Make
+
+Here's an example of Makefile for building <tt>hwloc-hello.c</tt>
+with GNU Make:
+
+\verbatim
+CFLAGS += $(shell pkg-config --cflags hwloc)
+LDLIBS += $(shell pkg-config --libs hwloc)
+
+hwloc-hello: hwloc-hello.c
+        $(CC) hwloc-hello.c $(CFLAGS) -o hwloc-hello $(LDLIBS)
+\endverbatim
+
+
+\section useapi_cmake Compiling on top of hwloc's C API with CMake
+
+Here's an example de <tt>CMakeLists.txt</tt> which shows variables
+obtained from <tt>pkg-config</tt> and how to use them:
+
+\verbatim
+cmake_minimum_required(VERSION 3.5)
+project(TEST_HWLOC C)
+include(FindPkgConfig)
+if(PKG_CONFIG_EXECUTABLE)
+  unset(HWLOC_FOUND CACHE)
+  pkg_search_module(HWLOC hwloc)
+  if(HWLOC_FOUND)
+    message(STATUS "HWLOC_LIBRARIES=${HWLOC_LIBRARIES}")
+    message(STATUS "HWLOC_LINK_LIBRARIES=${HWLOC_LINK_LIBRARIES}")
+    message(STATUS "HWLOC_LIBRARY_DIRS=${HWLOC_LIBRARY_DIRS}")
+    message(STATUS "HWLOC_LDFLAGS=${HWLOC_LDFLAGS}")
+    message(STATUS "HWLOC_LDFLAGS_OTHERS=${HWLOC_LDFLAGS_OTHERS}")
+    message(STATUS "HWLOC_INCLUDE_DIRS=${HWLOC_INCLUDE_DIRS}")
+    message(STATUS "HWLOC_CFLAGS=${HWLOC_CFLAGS}")
+    message(STATUS "HWLOC_CFLAGS_OTHER=${HWLOC_CFLAGS_OTHER}")
+  else()
+    message(FATAL_ERROR "HWLOC not found with pkg-config, add the path to hwloc.pc in PKG_CONFIG_PATH.")
+  endif()
+else()
+  message(FATAL_ERROR "PKG_CONFIG_EXECUTABLE: not found.")
+endif()
+
+add_executable(hwloc-hello hwloc-hello.c)
+target_include_directories(hwloc-hello PRIVATE ${HWLOC_INCLUDE_DIRS})
+target_compile_options(hwloc-hello PRIVATE ${HWLOC_CFLAGS})
+target_link_libraries(hwloc-hello PRIVATE ${HWLOC_LINK_LIBRARIES})
+target_link_options(hwloc-hello PRIVATE ${HWLOC_LDFLAGS})
+\endverbatim
+
+The project may be built with:
+\verbatim
+cmake -B build
+cmake --build build --verbose
+\endverbatim
+
+The built binary is then available under <tt>build/hwloc-hello</tt>.
+
+
+
+
+\page termsanddefs Terms and Definitions
  
-\htmlonly
-<div class="section" id="termsanddefs_objects">
-\endhtmlonly
 \section termsanddefs_objects Objects
 
 <dl>
@@ -660,9 +687,6 @@ or GNU Autotools.
 </dl>
 
 
-\htmlonly
-</div><div class="section" id="termsanddefs_indexes">
-\endhtmlonly
 \section termsanddefs_indexes Indexes and Sets
 
 <dl>
@@ -718,9 +742,6 @@ or GNU Autotools.
 </dl>
 
 
-\htmlonly
-</div><div class="section" id="termsanddefs_tree">
-\endhtmlonly
 \section termsanddefs_tree Hierarchy, Tree and Levels
 
 <dl>
@@ -823,11 +844,8 @@ I/O or Misc objects could be attached in
 
 
 
-\page tools Command-Line Tools 
 
-\htmlonly
-<div class="section">
-\endhtmlonly
+\page tools Command-Line Tools
 
 hwloc comes with an extensive C programming interface and several
 command line utilities. Each of them is fully documented in its own
@@ -835,9 +853,6 @@ manual page; the following is a summary
 tools.
 
 
-\htmlonly
-</div><div class="section" id="cli_lstopo">
-\endhtmlonly
 \section cli_lstopo lstopo and lstopo-no-graphics
 
 lstopo (also known as hwloc-ls) displays the
@@ -861,9 +876,6 @@ filesystems and display topological maps
 lstopo to read in that XML file and display it on a different system).
 
 
-\htmlonly
-</div><div class="section" id="cli_hwloc_bind">
-\endhtmlonly
 \section cli_hwloc_bind hwloc-bind
 
 hwloc-bind binds processes to specific hardware objects through a
@@ -879,9 +891,6 @@ Just like hwloc-calc, the input location
 either objects or cpusets (bitmaps as reported by hwloc-calc or hwloc-distrib).
 
 
-\htmlonly
-</div><div class="section" id="cli_hwloc_calc">
-\endhtmlonly
 \section cli_hwloc_calc hwloc-calc
 
 hwloc-calc is hwloc's Swiss Army Knife command-line tool for converting things.
@@ -910,9 +919,6 @@ physical indexes.
 See also \ref faq_indexes.
 
 
-\htmlonly
-</div><div class="section" id="cli_hwloc_info">
-\endhtmlonly
 \section cli_hwloc_info hwloc-info
 
 hwloc-info dumps information about the given objects, as well as all its specific attributes.
@@ -924,9 +930,6 @@ When <tt>\--support</tt> is passed, hwlo
 features for the topology.
 
 
-\htmlonly
-</div><div class="section" id="cli_hwloc_distrib">
-\endhtmlonly
 \section cli_hwloc_distrib hwloc-distrib
 
 hwloc-distrib generates a set of cpuset bitmaps that are uniformly
@@ -936,9 +939,6 @@ their memory bandwidth by properly distr
 machine.
 
 
-\htmlonly
-</div><div class="section" id="cli_hwloc_ps">
-\endhtmlonly
 \section cli_hwloc_ps hwloc-ps
 
 hwloc-ps is a tool to display the bindings of processes that are
@@ -947,9 +947,6 @@ lists processes that are bound; unbound
 threads) are not displayed.
 
 
-\htmlonly
-</div><div class="section" id="cli_hwloc_annotate">
-\endhtmlonly
 \section cli_hwloc_annotate hwloc-annotate
 
 hwloc-annotate may modify object (and topology) attributes such as string information
@@ -959,9 +956,6 @@ It reads an input topology from a XML fi
 the annotated topology as another XML file.
 
 
-\htmlonly
-</div><div class="section" id="cli_hwloc_diffpatchcompress">
-\endhtmlonly
 \section cli_hwloc_diffpatchcompress hwloc-diff, hwloc-patch and hwloc-compress-dir
 
 hwloc-diff computes the difference between two topologies
@@ -975,9 +969,6 @@ files by using hwloc-diff to save the di
 topologies instead of entire topologies.
 
 
-\htmlonly
-</div><div class="section" id="cli_hwloc_dump_hwdata">
-\endhtmlonly
 \section cli_hwloc_dump_hwdata hwloc-dump-hwdata
 
 hwloc-dump-hwdata is a Linux and x86-specific tool that dumps
@@ -992,9 +983,6 @@ See <tt>HWLOC_DUMPED_HWDATA_DIR</tt> in
 about the location of dumped files.
 
 
-\htmlonly
-</div><div class="section" id="cli_hwloc_gather">
-\endhtmlonly
 \section cli_hwloc_gather hwloc-gather-topology and hwloc-gather-cpuid
 
 hwloc-gather-topology is a Linux-specific tool that saves the
@@ -1016,10 +1004,6 @@ or debugging a machine without actually
 
 \page envvar Environment Variables
 
-\htmlonly
-<div class="section">
-\endhtmlonly
-
 The behavior of the hwloc library and tools may be tuned thanks to the
 following environment variables.
 
@@ -1258,10 +1242,13 @@ following environment variables.
 
 <dt>HWLOC_KEEP_NVIDIA_GPU_NUMA_NODES=0</dt>
   <dd>show or hide NUMA nodes that correspond to NVIDIA GPU memory.
-  By default they are ignored to avoid interleaved memory being allocated
-  on GPU by mistake.
-  Setting this environment variable to 1 exposes these NUMA nodes.
-  They may be recognized by the <em>GPUMemory</em> subtype.
+  By default they are ignored on POWER platforms to avoid interleaved
+  memory being allocated on GPU by mistake.
+
+  Setting this environment variable to 0 hides the NUMA nodes (default on POWER).
+  Setting to 1 exposes these NUMA nodes (default on non-POWER platforms such as NVIDIA Grace Hopper).
+
+  These NUMA nodes may be recognized by the <em>GPUMemory</em> subtype.
   They also have a <em>PCIBusID</em> info attribute to identify the
   corresponding GPU.
   </dd>
@@ -1468,10 +1455,6 @@ following environment variables.
 
 \page cpu_mem_bind CPU and Memory Binding Overview
 
-\htmlonly
-<div class="section">
-\endhtmlonly
-
 Binding tasks and data buffers is hwloc's second main goal after
 discovering and exposing the hardware topology.
 hwloc defines APIs to bind threads and processes to cores and
@@ -1481,6 +1464,7 @@ Some examples are available under doc/ex
 
 Sections below provide high-level insights on how these APIs work.
 
+
 \section cpu_mem_bind_portability Binding Policies and Portability
 
 hwloc binding APIs are portable to multiple operating systems.
@@ -1565,10 +1549,6 @@ Again, reading \ref hwlocality_membindin
 
 \page iodevices I/O Devices
 
-\htmlonly
-<div class="section">
-\endhtmlonly
-
 hwloc usually manipulates processing units and memory but it can also
 discover I/O devices and report their locality as well.
 This is useful for placing I/O intensive applications on cores near the
@@ -1576,9 +1556,6 @@ I/O devices they use, or for gathering i
 components.
 
 
-\htmlonly
-</div><div class="section" id="iodevices_enabling">
-\endhtmlonly
 \section iodevices_enabling Enabling and requirements
 
 I/O discovery is disabled by default (except in lstopo) for performance
@@ -1600,9 +1577,6 @@ Other operating system will just report
 to the topology root object.
 
 
-\htmlonly
-</div><div class="section" id="iodevices_objects">
-\endhtmlonly
 \section iodevices_objects I/O objects
 
 When I/O discovery is enabled and supported, some additional objects
@@ -1637,9 +1611,6 @@ However, hwloc offers some dedicated hel
 and hwloc_get_next_osdev() for convenience (see \ref hwlocality_advanced_io).
 
 
-\htmlonly
-</div><div class="section" id="iodevices_osdev">
-\endhtmlonly
 \section iodevices_osdev OS devices
 
 Although each PCI device is uniquely identified by its bus ID
@@ -1738,9 +1709,6 @@ See also \ref interoperability for manag
 considering them as hwloc objects.
 
 
-\htmlonly
-</div><div class="section" id="iodevices_pci">
-\endhtmlonly
 \section iodevices_pci PCI devices and bridges
 
 A PCI hierarchy is usually organized as follows:
@@ -1757,9 +1725,6 @@ The number of bridges between the hostbr
 on the machine.
 
 
-\htmlonly
-</div><div class="section" id="iodevices_consult">
-\endhtmlonly
 \section iodevices_consult Consulting I/O devices and binding
 
 I/O devices may be consulted by traversing the topology manually
@@ -1799,9 +1764,6 @@ This enables easy binding of I/O-intensi
 device they use.
 
 
-\htmlonly
-</div><div class="section" id="iodevices_examples">
-\endhtmlonly
 \section iodevices_examples Examples
 
 The following picture shows a dual-package dual-core host whose
@@ -1810,21 +1772,21 @@ PCI bus is connected to the first packag
 \image html devel09-pci.png
 \image latex devel09-pci.png "" width=\textwidth
 
-Six interesting PCI devices were discovered.
+Six interesting PCI devices were discovered (dark green boxes).
 However, hwloc found some corresponding software devices
 (<em>eth0</em>, <em>eth1</em>, <em>sda</em>, <em>mlx4_0</em>,
-<em>ib0</em>, and <em>ib1</em>) for only four of these physical
-devices.
-The other ones (<em>PCI 102b:0532</em> and <em>PCI 8086:3a20</em>)
+<em>ib0</em>, and <em>ib1</em> light grey boxes)
+for only four of these physical devices.
+The other ones (<em>PCI 04:03.0</em> and <em>PCI 00:1f.2</em>)
 are an unused IDE controller (no disk attached)
 and a graphic card (no corresponding software device reported
 to the user by the operating system).
 
 On the contrary, it should be noted that three different software
-devices were found for the last PCI device (<em>PCI 15b3:634a</em>).
-Indeed this OpenFabrics HCA PCI device object contains one
+devices were found for the last PCI device (<em>PCI 51:00.0</em>).
+Indeed this OpenFabrics HCA PCI device object contains
 one OpenFabrics software device (<em>mlx4_0</em>) and two virtual
-network interface software devices (<em>ib0</em> and <em>ib1</em>).
+network interfaces (<em>ib0</em> and <em>ib1</em>).
 
 
 Here is the corresponding textual output:
@@ -1864,10 +1826,6 @@ Machine (24GB total)
 
 \page miscobjs Miscellaneous objects
 
-\htmlonly
-<div class="section">
-\endhtmlonly
-
 hwloc topologies may be annotated with Misc objects
 (of type <tt>::HWLOC_OBJ_MISC</tt>)
 either automatically or by the user.
@@ -1882,9 +1840,6 @@ to replace <tt>Misc</tt> with something
 output.
 
 
-\htmlonly
-</div><div class="section" id="miscobjs_auto">
-\endhtmlonly
 \section miscobjs_auto Misc objects added by hwloc
 
 hwloc only uses Misc objects when other object types are not sufficient,
@@ -1916,9 +1871,6 @@ The textual <tt>lstopo</tt> displays the
 </ul>
 
 
-\htmlonly
-</div><div class="section" id="miscobjs_annotate">
-\endhtmlonly
 \section miscobjs_annotate Annotating topologies with Misc objects
 
 The user may annotate hwloc topologies with its own Misc objects.
@@ -1930,9 +1882,6 @@ as well as hwloc-annotate command-line t
 
 \page attributes Object attributes
 
-\htmlonly
-<div class="section" id="attributes_normal">
-\endhtmlonly
 \section attributes_normal Normal attributes
 
 hwloc objects have many generic attributes in the ::hwloc_obj structure,
@@ -1998,9 +1947,6 @@ associativity, cache type.
 See ::hwloc_obj_attr_u for details.
 
 
-\htmlonly
-</div><div class="section" id="attributes_info">
-\endhtmlonly
 \section attributes_info Custom string infos
 
 Aside of these generic attribute fields, hwloc annotates
@@ -2017,9 +1963,7 @@ Note that these attributes heavily depen
 operating system to report them.
 Many of them will therefore be missing on some OS.
 
-\htmlonly
-</div><div class="subsection" id="attributes_info_platform">
-\endhtmlonly
+
 \subsection attributes_info_platform Hardware Platform Information
 
 These info attributes are attached to the root object (Machine).
@@ -2058,9 +2002,6 @@ See doc/examples/get-knl-modes.c in the
 </dl>
 
 
-\htmlonly
-</div><div class="subsection" id="attributes_info_os">
-\endhtmlonly
 \subsection attributes_info_os Operating System Information
 
 These info attributes are attached to the root object (Machine).
@@ -2080,9 +2021,6 @@ placed.
 </dl>
 
 
-\htmlonly
-</div><div class="subsection" id="attributes_info_hwloc">
-\endhtmlonly
 \subsection attributes_info_hwloc hwloc Information
 
 Unless specified, these info attributes are attached to the root object (Machine).
@@ -2094,6 +2032,10 @@ If several components were combined, mul
 with different values, for instance <tt>x86</tt> and <tt>Linux</tt> in the root
 object and <tt>CUDA</tt> in CUDA OS device objects.
 </dd>
+<dt>MemoryTiersNr</dt>
+<dd>The number of different memory tiers in the topology, if any.
+See \ref heteromem.
+</dd>
 <dt>SyntheticDescription</dt>
 <dd>The description string that was given to hwloc to build this
 synthetic topology.
@@ -2113,9 +2055,6 @@ the topology to XML earlier.
 </dl>
 
 
-\htmlonly
-</div><div class="subsection" id="attributes_info_cpu">
-\endhtmlonly
 \subsection attributes_info_cpu CPU Information
 
 These info attributes are attached to Package objects,
@@ -2145,9 +2084,6 @@ A Solaris-specific general processor typ
 </dl>
 
 
-\htmlonly
-</div><div class="subsection" id="attributes_info_osdev">
-\endhtmlonly
 \subsection attributes_info_osdev OS Device Information
 
 These info attributes are attached to OS device objects specified in parentheses.
@@ -2284,9 +2220,6 @@ and GID #1 of port #3.
 </dl>
 
 
-\htmlonly
-</div><div class="subsection" id="attributes_info_otherobjs">
-\endhtmlonly
 \subsection attributes_info_otherobjs Other Object-specific Information
 
 These info attributes are attached to objects specified in parentheses.
@@ -2349,9 +2282,6 @@ Size is in KiB.
 </dl>
 
 
-\htmlonly
-</div><div class="subsection" id="attributes_info_user">
-\endhtmlonly
 \subsection attributes_info_user User-Given Information
 
 Here is a non-exhaustive list of user-provided info attributes
@@ -2369,18 +2299,11 @@ that have a special meaning:
 
 \page topoattrs Topology Attributes: Distances, Memory Attributes and CPU Kinds
 
-\htmlonly
-<div class="section">
-\endhtmlonly
-
 Besides the hierarchy of objects and individual object attributes
 (see \ref attributes), hwloc may also expose finer information about
 the hardware organization.
 
 
-\htmlonly
-</div><div class="section" id="topoattrs_distances">
-\endhtmlonly
 \section topoattrs_distances Distances
 
 A machine with 4 CPUs may have identical links between every pairs of CPUs,
@@ -2444,6 +2367,9 @@ or between two subdevices of the same pa
 
 The matrix interconnects all LevelZero devices and subdevices (if any),
 even if some of them may have no link at all.
+
+The bandwidths of links between subdevices are accumulated in the
+bandwidth between their parents.
 </dd>
 <dt>NVLinkBandwidth (NVML)</dt>
 <dd>This is the matrix of unidirectional NVLink bandwidths between
@@ -2484,9 +2410,6 @@ as well as \ref hwlocality_distances_con
 and \ref hwlocality_distances_add.
 
 
-\htmlonly
-</div><div class="section" id="topoattrs_memattrs">
-\endhtmlonly
 \section topoattrs_memattrs Memory Attributes
 
 Machines with heterogeneous memory, for instance high-bandwidth memory (HBM),
@@ -2511,9 +2434,6 @@ an easy way to distinguish NUMA nodes of
 in \ref heteromem.
 
 
-\htmlonly
-</div><div class="section" id="topoattrs_cpukinds">
-\endhtmlonly
 \section topoattrs_cpukinds CPU Kinds
 
 Hybrid CPUs may contain different kinds of cores.
@@ -2571,10 +2491,6 @@ See \ref hwlocality_cpukinds for details
 
 \page heteromem Heterogeneous Memory
 
-\htmlonly
-<div class="section">
-\endhtmlonly
-
 Heterogeneous memory hardware exposes different NUMA nodes for
 different memory technologies.
 On the image below, a dual-socket server has both HBM (high bandwidth
@@ -2591,9 +2507,7 @@ second.
 Hence there is a need to explicit memory technologies and performance
 to help users decide where to allocate.
 
-\htmlonly
-</div><div class="section" id="heteromem_memtiers">
-\endhtmlonly
+
 \section heteromem_memtiers Memory Tiers
 
 hwloc builds <i>Memory Tiers</i> to identify different kinds of
@@ -2631,9 +2545,6 @@ If hwloc fails to build tiers properly,
 and <tt>HWLOC_MEMTIERS_GUESS</tt> in \ref envvar.
 
 
-\htmlonly
-</div><div class="section" id="heteromem_use_cli">
-\endhtmlonly
 \section heteromem_use_cli Using Heterogeneous Memory from the command-line
 
 Tiers may be specified in location filters when using NUMA nodes
@@ -2658,6 +2569,13 @@ $ hwloc-calc -I 'numa[tier=0]' -p all
 2,3
 \endverbatim
 
+The number of tiers may be retrieved by looking at topology attributes
+in the root object:
+\verbatim
+$ hwloc-info --get-attr "info MemoryTiersNr" topology
+2
+\endverbatim
+
 hwloc-calc and hwloc-bind also have options such as
 <tt>\--local-memory</tt> and <tt>\--best-memattr</tt>
 to select the best NUMA node among the local ones.
@@ -2673,9 +2591,6 @@ $ hwloc-calc --best-memattr bandwidth no
 \endverbatim
 
 
-\htmlonly
-</div><div class="section" id="heteromem_use_api">
-\endhtmlonly
 \section heteromem_use_api Using Heterogeneous Memory from the C API
 
 There are two major changes introduced by heterogeneous memory
@@ -2692,6 +2607,7 @@ instead of below a Package.
 
 Hence, one may have to rethink the way it selects NUMA nodes.
 
+
 \subsection heteromem_use_api_iterate Iterating over the list of (heterogeneous) NUMA nodes
 
 A common need consists in iterating over the list of NUMA nodes
@@ -2751,10 +2667,6 @@ See also \ref hwlocality_memattrs.
 
 \page xml Importing and exporting topologies from/to XML files
 
-\htmlonly
-<div class="section">
-\endhtmlonly
-
 hwloc offers the ability to export topologies to XML files and reload
 them later. This is for instance useful for loading topologies faster
 (see \ref faq_xml), manipulating other nodes' topology, or avoiding
@@ -2795,9 +2707,6 @@ If a less precise exporting/importing is
 look at \ref synthetic instead.
 
 
-\htmlonly
-</div><div class="section" id="xml_backends">
-\endhtmlonly
 \section xml_backends libxml2 and minimalistic XML backends
 
 hwloc offers two backends for importing/exporting XML.
@@ -2829,9 +2738,6 @@ Or pass <tt>\--enable-plugins=xml_libxml
 libxml2 support as a plugin.
 
 
-\htmlonly
-</div><div class="section" id="xml_errors">
-\endhtmlonly
 \section xml_errors XML import error management
 
 Importing XML files can fail at least because of file access errors,
@@ -2853,10 +2759,6 @@ and hwloc_topology_load() to handle all
 
 \page synthetic Synthetic topologies
 
-\htmlonly
-<div class="section">
-\endhtmlonly
-
 hwloc may load fake or remote topologies so as to consult them
 without having the underlying hardware available.
 Aside from loading XML topologies, hwloc also enables the building of
@@ -2891,9 +2793,6 @@ precise than XML but may still be enough
 of resources matters.
 
 
-\htmlonly
-</div><div class="section" id="synthetic_string">
-\endhtmlonly
 \section synthetic_string Synthetic description string
 
 Each item in the description string gives the type of the level and
@@ -2970,9 +2869,6 @@ or to remove some objects to make the to
 See many examples in \ref faq_create_asymmetric.
 
 
-\htmlonly
-</div><div class="section" id="synthetic_use">
-\endhtmlonly
 \section synthetic_use Loading a synthetic topology
 
 Aside from lstopo, the hwloc programming interface offers the same
@@ -2991,9 +2887,6 @@ environment or by setting the ::HWLOC_TO
 topology flag.
 
 
-\htmlonly
-</div><div class="section" id="synthetic_export">
-\endhtmlonly
 \section synthetic_export Exporting a topology as a synthetic string
 
 The function hwloc_topology_export_synthetic() may export
@@ -3024,10 +2917,6 @@ symmetry and exporting the string.
 
 \page interoperability Interoperability With Other Software
 
-\htmlonly
-<div class="section">
-\endhtmlonly
-
 Although hwloc offers its own portable interface, it still may have to
 interoperate with specific or non-portable libraries that manipulate
 similar kinds of objects.  hwloc therefore offers several specific
@@ -3161,19 +3050,17 @@ enabled for the current topology.
   See for instance hwloc_bitmap_taskset_snprintf() in
   \ref hwlocality_bitmap().
 
-  Most hwloc command-line tools also support the <tt>\--taskset</tt>
-  option to manipulate taskset-specific strings.
+  Most hwloc command-line tools also support the option
+  <tt>\--cpuset-output-format taskset</tt>
+  to manipulate taskset-specific strings.
  </dd>
 
 </dl>
 
 
 
-\page threadsafety Thread Safety
 
-\htmlonly
-<div class="section">
-\endhtmlonly
+\page threadsafety Thread Safety
 
 Like most libraries that mainly fill data structures, hwloc is not
 thread safe but rather reentrant: all state is held in a
@@ -3280,11 +3167,8 @@ For reference, ::hwloc_topology_t modifi
 
 
 
-\page plugins Components and plugins
 
-\htmlonly
-<div class="section">
-\endhtmlonly
+\page plugins Components and plugins
 
 hwloc is organized in <b>components</b> that are responsible for discovering
 objects.
@@ -3304,9 +3188,6 @@ If a XML topology is loaded, the <tt>xml
 will be used instead of all other components.
 
 
-\htmlonly
-</div><div class="section" id="plugins_default">
-\endhtmlonly
 \section plugins_default Components enabled by default
 
 The hwloc core contains a list of components sorted by priority.
@@ -3357,9 +3238,6 @@ may be set to get verbose messages about
 (including their priority) and enabling as backends.
 
 
-\htmlonly
-</div><div class="section" id="plugins_select">
-\endhtmlonly
 \section plugins_select Selecting which components to use
 
 If no topology configuration functions such as
@@ -3397,9 +3275,6 @@ hwloc_topology_set_components() may also
 to prevent the loading of a specific component (or phases) for the target topology.
 
 
-\htmlonly
-</div><div class="section" id="plugins_load">
-\endhtmlonly
 \section plugins_load Loading components from plugins
 
 Components may optionally be built as <b>plugins</b> so that the hwloc core
@@ -3428,9 +3303,6 @@ Also note that plugins should carefully
 embedding hwloc in another project, see \ref embed for details.
 
 
-\htmlonly
-</div><div class="section" id="plugins_list">
-\endhtmlonly
 \section plugins_list Existing components and plugins
 
 All components distributed within hwloc are listed below.
@@ -3553,10 +3425,6 @@ environment variable (see \ref envvar).
 
 \page embed Embedding hwloc in Other Software
 
-\htmlonly
-<div class="section">
-\endhtmlonly
-
 It can be desirable to include hwloc in a larger software package (be
 sure to check out the LICENSE file) so that users don't have to
 separately download and install it before installing your software.
@@ -3597,9 +3465,6 @@ The embedder project is <b>strongly</b>
 dynamically loading plugins / dlopen / libltdl capability.
 
 
-\htmlonly
-</div><div class="section" id="embedding_m4">
-\endhtmlonly
 \section embedding_m4 Using hwloc's M4 Embedding Capabilities
 
 Every project is different, and there are many different ways of
@@ -3704,9 +3569,6 @@ default).  You may want to examine it fo
 macros are used.
 
 
-\htmlonly
-</div><div class="section" id="embedding_example">
-\endhtmlonly
 \section embedding_example Example Embedding hwloc
 
 Here's an example of integrating with a larger project named sandbox
@@ -3742,17 +3604,10 @@ than any system-provided copy of hwloc.
 
 
 
-
-
 \page faq Frequently Asked Questions (FAQ)
 
-
-\htmlonly
-<div class="section" id="faq1">
-\endhtmlonly
 \section faq1 Concepts
 
-
 \subsection faq_why I only need binding, or the number of cores, why should I use hwloc ?
 
 hwloc is its portable API that works on a variety of operating
@@ -4124,13 +3979,8 @@ hello from a single thread on core #3
 
 
 
-\htmlonly
-</div><div class="section" id="faq2">
-\endhtmlonly
 \section faq2 Advanced
 
-
-
 \subsection faq_xml I do not want hwloc to rediscover my enormous machine topology every time I rerun a process
 
 Although the topology discovery is not expensive on common machines,
@@ -4317,13 +4167,8 @@ an I/O subtree.
 
 
 
-\htmlonly
-</div><div class="section" id="faq3">
-\endhtmlonly
 \section faq3 Caveats
 
-
-
 \subsection faq_slow_lstopo Why is lstopo slow?
 
 lstopo enables most hwloc objects and discovery flags
@@ -4467,12 +4312,8 @@ You should pass the following command-li
 
 
 
-\htmlonly
-</div><div class="section" id="faq4">
-\endhtmlonly
 \section faq4 Platform-specific
 
-
 \subsection faq_rocm_build How do I enable ROCm SMI and select which version to use?
 
 hwloc enables ROCm SMI as soon as it finds its development headers and libraries
@@ -4492,7 +4333,6 @@ Passing <tt>\--enable-rsmi</tt> will als
 if RSMI could not be found and enabled in hwloc.
 
 
-
 \subsection faq_cuda_build How do I enable CUDA and select which CUDA version to use?
 
 hwloc enables CUDA as soon as it finds CUDA development headers and libraries
@@ -4521,7 +4361,6 @@ that are installed by CUDA, i.e. the CUD
 since the given directory does not exist.
 
 
-
 \subsection faq_knl_numa How do I find the local MCDRAM NUMA node on Intel Xeon Phi processor?
 
 Intel Xeon Phi processors introduced a new memory architecture by
@@ -4677,9 +4516,6 @@ chuser "capabilities=CAP_PROPAGATE,CAP_N
 \endverbatim
 
 
-\htmlonly
-</div><div class="section" id="faq5">
-\endhtmlonly
 \section faq5 Compatibility between hwloc versions
 
 \subsection faq_version_api How do I handle API changes?
@@ -4741,7 +4577,6 @@ However their HWLOC_VERSION strings are
 (<tt>\"2.0.3\"</tt> and <tt>\"2.0.4\"</tt> respectively).
 
 
-
 \subsection faq_version_abi How do I handle ABI breaks?
 
 The hwloc interface was deeply modified in release 2.0
@@ -4785,7 +4620,6 @@ Hence running one of the above (cheap) c
 may be useful.
 
 
-
 \subsection faq_version_xml Are XML topology files compatible between hwloc releases?
 
 XML topology files are forward-compatible:
@@ -4805,7 +4639,6 @@ Building all these components on the sam
 hwloc installation is a good way to avoid such incompatibilities.
 
 
-
 \subsection faq_version_synthetic Are synthetic strings compatible between hwloc releases?
 
 Synthetic strings (see \ref synthetic) are forward-compatible:
@@ -4817,7 +4650,6 @@ Some flags may be given to hwloc_topolog
 and stay backward compatible.
 
 
-
 \subsection faq_version_shmem Is it possible to share a shared-memory topology between different hwloc releases?
 
 Shared-memory topologies (see \ref hwlocality_shmem) have strong
@@ -4836,19 +4668,13 @@ is a good way to avoid such incompatibil
 
 
 
-\page upgrade_to_api_2x Upgrading to the hwloc 2.0 API
 
-\htmlonly
-<div class="section">
-\endhtmlonly
+\page upgrade_to_api_2x Upgrading to the hwloc 2.0 API
 
 See \ref faq5 for detecting the hwloc version that you are compiling
 and/or running against.
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_memory">
-\endhtmlonly
 \section upgrade_to_api_2x_memory New Organization of NUMA nodes and Memory
 
 \subsection upgrade_to_api_2x_memory_children Memory children
@@ -4874,6 +4700,7 @@ hwloc_get_next_child() may still be used
 Hence the CPU-side hierarchy is built using normal children,
 while memory is attached to that hierarchy depending on its affinity.
 
+
 \subsection upgrade_to_api_2x_memory_examples Examples
 
 <ul>
@@ -5034,9 +4861,6 @@ Moreover, it is compatible with the hwlo
 
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_children">
-\endhtmlonly
 \section upgrade_to_api_2x_children 4 Kinds of Objects and Children
 
 \subsection upgrade_to_api_2x_io_misc_children I/O and Misc children
@@ -5073,9 +4897,6 @@ Normal and Memory objects have (non-NULL
 while I/O and Misc objects don't have any sets (they are NULL).
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_cache">
-\endhtmlonly
 \section upgrade_to_api_2x_cache HWLOC_OBJ_CACHE replaced
 
 Instead of a single HWLOC_OBJ_CACHE, there are now 8 types
@@ -5092,9 +4913,6 @@ hwloc_obj_type_is_cache(), hwloc_obj_typ
 may be used to check whether a given type is a cache, data/unified cache or instruction cache.
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_allowed">
-\endhtmlonly
 \section upgrade_to_api_2x_allowed allowed_cpuset and allowed_nodeset only in the main topology
 
 Objects do not have <code>allowed_cpuset</code> and <code>allowed_nodeset</code> anymore.
@@ -5111,9 +4929,6 @@ Replace cpusets with nodesets for NUMA n
 To find out which ones, replace intersects() with and() to get the actual intersection.
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_depth">
-\endhtmlonly
 \section upgrade_to_api_2x_depth Object depths are now signed int
 
 <code>obj->depth</code> as well as depths given to functions
@@ -5123,9 +4938,6 @@ such as hwloc_get_obj_by_depth() or retu
 Other depth such as cache-specific depth attribute are still unsigned.
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_memory_attrs">
-\endhtmlonly
 \section upgrade_to_api_2x_memory_attrs Memory attributes become NUMANode-specific
 
 Memory attributes such as <code>obj->memory.local_memory</code>
@@ -5138,9 +4950,6 @@ in all objects as <code>obj->total_memor
 See hwloc_obj_attr_u::hwloc_numanode_attr_s and hwloc_obj for details.
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_config">
-\endhtmlonly
 \section upgrade_to_api_2x_config Topology configuration changes
 
 The old ignoring API as well as several configuration flags
@@ -5186,9 +4995,6 @@ hwloc_topology_set_io_types_filter(topol
 </ul>
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_xml">
-\endhtmlonly
 \section upgrade_to_api_2x_xml XML changes
 
 2.0 XML files are not compatible with 1.x
@@ -5237,9 +5043,6 @@ and hwloc_topology_diff_destroy() lost t
 The first argument (topology) isn't needed anymore.
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_distances">
-\endhtmlonly
 \section upgrade_to_api_2x_distances Distances API totally rewritten
 
 The new distances API is in hwloc/distances.h.
@@ -5255,9 +5058,6 @@ The set of object involved in a distance
 by an array of objects, it may not always cover the entire machine or so.
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_return">
-\endhtmlonly
 \section upgrade_to_api_2x_return Return values of functions
 
 Bitmap functions (and a couple other functions) can return errors (in theory).
@@ -5273,9 +5073,6 @@ hwloc_obj_add_info(), hwloc_cpuset_from_
 also return an int, which would be -1 in case of allocation errors.
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_misc">
-\endhtmlonly
 \section upgrade_to_api_2x_misc Misc API changes
 
 <ul>
@@ -5304,9 +5101,6 @@ with hwloc_topology_insert_misc_object()
 </ul>
 
 
-\htmlonly
-</div><div class="section" id="upgrade_to_api_2x_removals">
-\endhtmlonly
 \section upgrade_to_api_2x_removals API removals and deprecations
 
 <ul>
diff -pruN 2.10.0-1/doc/images/diagram.eps 2.11.0-1/doc/images/diagram.eps
--- 2.10.0-1/doc/images/diagram.eps	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/doc/images/diagram.eps	2024-06-17 10:04:53.000000000 +0000
@@ -1,7 +1,7 @@
 %!PS-Adobe-3.0 EPSF-3.0
 %%Title: images/diagram.fig
-%%Creator: fig2dev Version 3.2.8b
-%%CreationDate: 2023-11-09 11:46:24
+%%Creator: fig2dev Version 3.2.9
+%%CreationDate: 2024-06-17 12:04:53
 %%BoundingBox: 0 0 720 705
 %%Magnification: 1.0000
 %%EndComments
@@ -51,44 +51,6 @@ end
 /shd {dup dup currentrgbcolor 4 -2 roll mul 4 -2 roll mul
   4 -2 roll mul srgb} bind def
 /xfig_image {image Data flushfile} def
-/reencdict 12 dict def /ReEncode { reencdict begin
-/newcodesandnames exch def /newfontname exch def /basefontname exch def
-/basefontdict basefontname findfont def /newfont basefontdict maxlength dict def
-basefontdict { exch dup /FID ne { dup /Encoding eq
-{ exch dup length array copy newfont 3 1 roll put }
-{ exch newfont 3 1 roll put } ifelse } { pop pop } ifelse } forall
-newfont /FontName newfontname put newcodesandnames aload pop
-128 1 255 { newfont /Encoding get exch /.notdef put } for
-newcodesandnames length 2 idiv { newfont /Encoding get 3 1 roll put } repeat
-newfontname newfont definefont pop end } def
-/isovec [
-8#055 /minus 8#200 /grave 8#201 /acute 8#202 /circumflex 8#203 /tilde
-8#204 /macron 8#205 /breve 8#206 /dotaccent 8#207 /dieresis
-8#210 /ring 8#211 /cedilla 8#212 /hungarumlaut 8#213 /ogonek 8#214 /caron
-8#220 /dotlessi 8#230 /oe 8#231 /OE
-8#240 /space 8#241 /exclamdown 8#242 /cent 8#243 /sterling
-8#244 /currency 8#245 /yen 8#246 /brokenbar 8#247 /section 8#250 /dieresis
-8#251 /copyright 8#252 /ordfeminine 8#253 /guillemotleft 8#254 /logicalnot
-8#255 /hyphen 8#256 /registered 8#257 /macron 8#260 /degree 8#261 /plusminus
-8#262 /twosuperior 8#263 /threesuperior 8#264 /acute 8#265 /mu 8#266 /paragraph
-8#267 /periodcentered 8#270 /cedilla 8#271 /onesuperior 8#272 /ordmasculine
-8#273 /guillemotright 8#274 /onequarter 8#275 /onehalf
-8#276 /threequarters 8#277 /questiondown 8#300 /Agrave 8#301 /Aacute
-8#302 /Acircumflex 8#303 /Atilde 8#304 /Adieresis 8#305 /Aring
-8#306 /AE 8#307 /Ccedilla 8#310 /Egrave 8#311 /Eacute
-8#312 /Ecircumflex 8#313 /Edieresis 8#314 /Igrave 8#315 /Iacute
-8#316 /Icircumflex 8#317 /Idieresis 8#320 /Eth 8#321 /Ntilde 8#322 /Ograve
-8#323 /Oacute 8#324 /Ocircumflex 8#325 /Otilde 8#326 /Odieresis 8#327 /multiply
-8#330 /Oslash 8#331 /Ugrave 8#332 /Uacute 8#333 /Ucircumflex
-8#334 /Udieresis 8#335 /Yacute 8#336 /Thorn 8#337 /germandbls 8#340 /agrave
-8#341 /aacute 8#342 /acircumflex 8#343 /atilde 8#344 /adieresis 8#345 /aring
-8#346 /ae 8#347 /ccedilla 8#350 /egrave 8#351 /eacute
-8#352 /ecircumflex 8#353 /edieresis 8#354 /igrave 8#355 /iacute
-8#356 /icircumflex 8#357 /idieresis 8#360 /eth 8#361 /ntilde 8#362 /ograve
-8#363 /oacute 8#364 /ocircumflex 8#365 /otilde 8#366 /odieresis 8#367 /divide
-8#370 /oslash 8#371 /ugrave 8#372 /uacute 8#373 /ucircumflex
-8#374 /udieresis 8#375 /yacute 8#376 /thorn 8#377 /ydieresis] def
-/Times-Roman /Times-Roman-iso isovec ReEncode
 /$F2psBegin {$F2psDict begin /$F2psEnteredState save def} def
 /$F2psEnd {$F2psEnteredState restore end} def
 
@@ -123,22 +85,22 @@ n 3165 3060 m 3060 3060 3060 4395 105 ar
   3060 4500 4395 4500 105 arcto 4 {pop} repeat
   4500 4500 4500 3165 105 arcto 4 {pop} repeat
   4500 3060 3165 3060 105 arcto 4 {pop} repeat
- cp gs col0 s gr /Times-Roman-iso ff 210.00 scf sf
+ cp gs col0 s gr /Times-Roman ff 210.00 scf sf
 3150 3285 m
 gs 1 -1 sc (Package) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3150 3510 m
 gs 1 -1 sc (.depth = 1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3150 3735 m
 gs 1 -1 sc (.logical_index =0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3150 3960 m
 gs 1 -1 sc (.os_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3150 4185 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3150 4410 m
 gs 1 -1 sc (.arity=2) col0 sh gr
 % Polyline
@@ -157,58 +119,58 @@ n 8415 3690 m
  4500 3690 l gs col1 s gr gr
 % arrowhead
 n 4636 3660 m 4516 3690 l 4636 3720 l 4636 3660 l  cp gs col1 1.00 shd ef gr  col1 s
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4545 3510 m
 gs 1 -1 sc (next_sibling) col1 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7470 3870 m
 gs 1 -1 sc (prev_sibling) col1 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8640 2565 m
 gs 1 -1 sc (last_child) dup sw pop neg 0 rm  col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8190 2385 m
 gs 1 -1 sc (children[1]) dup sw pop neg 0 rm  col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 2385 4725 m
 gs 1 -1 sc (children[0]) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 2205 4905 m
 gs 1 -1 sc (first_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4185 4725 m
 gs 1 -1 sc (children[1]) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 4905 m
 gs 1 -1 sc (last_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7785 4725 m
 gs 1 -1 sc (children[0]) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7605 4905 m
 gs 1 -1 sc (first_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4275 2565 m
 gs 1 -1 sc (first_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4725 2385 m
 gs 1 -1 sc (children[0]) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4770 945 m
 gs 1 -1 sc (Machine) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4770 1170 m
 gs 1 -1 sc (level) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4770 1395 m
 gs 1 -1 sc (depth=0) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 2115 3285 m
 gs 1 -1 sc (Package) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 2115 3510 m
 gs 1 -1 sc (level) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 2115 3735 m
 gs 1 -1 sc (depth=1) col4 sh gr
 % Polyline
@@ -227,10 +189,10 @@ n 4365 5940 m
  3105 5940 l gs col1 s gr gr
 % arrowhead
 n 3241 5910 m 3121 5940 l 3241 5970 l 3241 5910 l  cp gs col1 1.00 shd ef gr  col1 s
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3150 5760 m
 gs 1 -1 sc (next_sibling) col1 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3420 6120 m
 gs 1 -1 sc (prev_sibling) col1 sh gr
 % Polyline
@@ -249,10 +211,10 @@ n 4365 6570 m
  3105 6570 l gs col4 s gr gr
 % arrowhead
 n 3241 6540 m 3121 6570 l 3241 6600 l 3241 6540 l  cp gs col4 1.00 shd ef gr  col4 s
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3150 6390 m
 gs 1 -1 sc (next_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3375 6750 m
 gs 1 -1 sc (prev_cousin) col4 sh gr
 % Polyline
@@ -271,46 +233,46 @@ n 7065 6570 m
  5805 6570 l gs col4 s gr gr
 % arrowhead
 n 5941 6540 m 5821 6570 l 5941 6600 l 5941 6540 l  cp gs col4 1.00 shd ef gr  col4 s
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 5850 6390 m
 gs 1 -1 sc (next_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 6075 6750 m
 gs 1 -1 sc (prev_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 765 5625 m
 gs 1 -1 sc (Cache) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 765 5850 m
 gs 1 -1 sc (level) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 765 6075 m
 gs 1 -1 sc (depth=2) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4230 7290 m
 gs 1 -1 sc (first_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4230 7515 m
 gs 1 -1 sc (last_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4230 7065 m
 gs 1 -1 sc (children[0]) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 6930 7290 m
 gs 1 -1 sc (first_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 6930 7515 m
 gs 1 -1 sc (last_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 6930 7065 m
 gs 1 -1 sc (children[0]) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1530 7290 m
 gs 1 -1 sc (first_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1530 7515 m
 gs 1 -1 sc (last_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1530 7065 m
 gs 1 -1 sc (children[0]) col0 sh gr
 % Polyline
@@ -320,22 +282,22 @@ n 9870 7740 m 9765 7740 9765 9075 105 ar
   9765 9180 11100 9180 105 arcto 4 {pop} repeat
   11205 9180 11205 7845 105 arcto 4 {pop} repeat
   11205 7740 9870 7740 105 arcto 4 {pop} repeat
- cp gs col0 s gr /Times-Roman-iso ff 210.00 scf sf
+ cp gs col0 s gr /Times-Roman ff 210.00 scf sf
 9855 7965 m
 gs 1 -1 sc (Core) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9855 9090 m
 gs 1 -1 sc (.arity=1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9855 8190 m
 gs 1 -1 sc (.depth = 3) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9855 8415 m
 gs 1 -1 sc (.logical_index = 3) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9855 8640 m
 gs 1 -1 sc (.os_index = 1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9855 8865 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
 % Polyline
@@ -354,55 +316,55 @@ n 7065 8910 m
  5805 8910 l gs col4 s gr gr
 % arrowhead
 n 5941 8880 m 5821 8910 l 5941 8940 l 5941 8880 l  cp gs col4 1.00 shd ef gr  col4 s
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 5850 8730 m
 gs 1 -1 sc (next_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 6075 9090 m
 gs 1 -1 sc (prev_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 765 7965 m
 gs 1 -1 sc (Core) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 765 8190 m
 gs 1 -1 sc (level) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 765 8415 m
 gs 1 -1 sc (depth=3) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4230 9630 m
 gs 1 -1 sc (first_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4230 9855 m
 gs 1 -1 sc (last_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4230 9405 m
 gs 1 -1 sc (children[0]) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 6930 9630 m
 gs 1 -1 sc (first_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 6930 9855 m
 gs 1 -1 sc (last_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 6930 9405 m
 gs 1 -1 sc (children[0]) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1530 9630 m
 gs 1 -1 sc (first_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1530 9855 m
 gs 1 -1 sc (last_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1530 9405 m
 gs 1 -1 sc (children[0]) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9630 9630 m
 gs 1 -1 sc (first_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9630 9855 m
 gs 1 -1 sc (last_child) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9630 9405 m
 gs 1 -1 sc (children[0]) col0 sh gr
 % Polyline
@@ -421,10 +383,10 @@ n 4365 11250 m
  3105 11250 l gs col4 s gr gr
 % arrowhead
 n 3241 11220 m 3121 11250 l 3241 11280 l 3241 11220 l  cp gs col4 1.00 shd ef gr  col4 s
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3150 11070 m
 gs 1 -1 sc (next_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3375 11430 m
 gs 1 -1 sc (prev_cousin) col4 sh gr
 % Polyline
@@ -443,25 +405,25 @@ n 7065 11250 m
  5805 11250 l gs col4 s gr gr
 % arrowhead
 n 5941 11220 m 5821 11250 l 5941 11280 l 5941 11220 l  cp gs col4 1.00 shd ef gr  col4 s
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 5850 11070 m
 gs 1 -1 sc (next_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 6075 11430 m
 gs 1 -1 sc (prev_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 765 10305 m
 gs 1 -1 sc (PU) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 765 10530 m
 gs 1 -1 sc (level) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 765 10755 m
 gs 1 -1 sc (depth=4) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9540 4725 m
 gs 1 -1 sc (children[1]) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9810 4905 m
 gs 1 -1 sc (last_child) col0 sh gr
 % Polyline
@@ -471,22 +433,22 @@ n 9870 10080 m 9765 10080 9765 11415 105
   9765 11520 11100 11520 105 arcto 4 {pop} repeat
   11205 11520 11205 10185 105 arcto 4 {pop} repeat
   11205 10080 9870 10080 105 arcto 4 {pop} repeat
- cp gs col0 s gr /Times-Roman-iso ff 180.00 scf sf
+ cp gs col0 s gr /Times-Roman ff 180.00 scf sf
 9855 10980 m
 gs 1 -1 sc (.os_index = 3) col0 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 9855 10305 m
 gs 1 -1 sc (PU) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9855 11205 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9855 11430 m
 gs 1 -1 sc (.arity=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9855 10530 m
 gs 1 -1 sc (.depth = 4) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9855 10755 m
 gs 1 -1 sc (.logical_index = 3) col0 sh gr
 % Polyline
@@ -505,10 +467,10 @@ n 9765 11250 m
  8505 11250 l gs col4 s gr gr
 % arrowhead
 n 8641 11220 m 8521 11250 l 8641 11280 l 8641 11220 l  cp gs col4 1.00 shd ef gr  col4 s
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8550 11070 m
 gs 1 -1 sc (next_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8775 11430 m
 gs 1 -1 sc (prev_cousin) col4 sh gr
 % Polyline
@@ -897,289 +859,289 @@ n 7245 1935 m
 % arrowhead
 7.500 slw
 n 10392 2181 m 10514 2159 l 10396 2121 l 10392 2181 l  cp gs col12 1.00 shd ef gr  col12 s
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8415 2970 m
 gs 1 -1 sc (parent) dup sw pop neg 0 rm  col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8145 5310 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8505 4410 m
 gs 1 -1 sc (.arity=2) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8505 3735 m
 gs 1 -1 sc (.logical_index = 1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8505 3510 m
 gs 1 -1 sc (.depth = 1) col0 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 8505 3285 m
 gs 1 -1 sc (Package) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8505 4185 m
 gs 1 -1 sc (.sibling_rank=1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 2970 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4545 3960 m
 gs 1 -1 sc (next_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7470 4320 m
 gs 1 -1 sc (prev_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 2745 5310 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4275 5310 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 6750 m
 gs 1 -1 sc (.arity=1) col0 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 1755 5625 m
 gs 1 -1 sc (Cache) col0 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 4455 5625 m
 gs 1 -1 sc (Cache) col0 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 7155 5625 m
 gs 1 -1 sc (Cache) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 6075 m
 gs 1 -1 sc (.logical_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 6075 m
 gs 1 -1 sc (.logical_index = 1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 6300 m
 gs 1 -1 sc (.os_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 6525 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 6750 m
 gs 1 -1 sc (.arity=1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 6750 m
 gs 1 -1 sc (.arity=1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 5850 m
 gs 1 -1 sc (.depth = 2) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 5850 m
 gs 1 -1 sc (.depth = 2) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 5850 m
 gs 1 -1 sc (.depth = 2) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 6075 m
 gs 1 -1 sc (.logical_index = 2) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 6300 m
 gs 1 -1 sc (.os_index = 1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 6525 m
 gs 1 -1 sc (.sibling_rank=1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 6300 m
 gs 1 -1 sc (.os_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 6525 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 2475 7650 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 5175 7650 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7875 7650 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 9090 m
 gs 1 -1 sc (.arity=1) col0 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 1755 7965 m
 gs 1 -1 sc (Core) col0 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 4455 7965 m
 gs 1 -1 sc (Core) col0 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 7155 7965 m
 gs 1 -1 sc (Core) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 8415 m
 gs 1 -1 sc (.logical_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 8415 m
 gs 1 -1 sc (.logical_index = 1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 8640 m
 gs 1 -1 sc (.os_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 8865 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 9090 m
 gs 1 -1 sc (.arity=1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 9090 m
 gs 1 -1 sc (.arity=1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 8190 m
 gs 1 -1 sc (.depth = 3) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 8190 m
 gs 1 -1 sc (.depth = 3) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 8190 m
 gs 1 -1 sc (.depth = 3) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 8415 m
 gs 1 -1 sc (.logical_index = 2) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 8640 m
 gs 1 -1 sc (.os_index = 1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 8865 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 8640 m
 gs 1 -1 sc (.os_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 8865 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 2475 9990 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 5175 9990 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7875 9990 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 10575 9990 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 10980 m
 gs 1 -1 sc (.os_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 10980 m
 gs 1 -1 sc (.os_index = 2) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 10980 m
 gs 1 -1 sc (.os_index = 1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 11205 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 1755 10305 m
 gs 1 -1 sc (PU) col0 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 4455 10305 m
 gs 1 -1 sc (PU) col0 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 7155 10305 m
 gs 1 -1 sc (PU) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 11205 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 11205 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 11430 m
 gs 1 -1 sc (.arity=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 11430 m
 gs 1 -1 sc (.arity=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 11430 m
 gs 1 -1 sc (.arity=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 10530 m
 gs 1 -1 sc (.depth = 4) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 7155 10755 m
 gs 1 -1 sc (.logical_index = 2) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 10530 m
 gs 1 -1 sc (.depth = 4) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 4455 10755 m
 gs 1 -1 sc (.logical_index = 1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 10530 m
 gs 1 -1 sc (.depth = 4) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 1755 10755 m
 gs 1 -1 sc (.logical_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3150 8730 m
 gs 1 -1 sc (next_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 3375 9090 m
 gs 1 -1 sc (prev_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8550 8730 m
 gs 1 -1 sc (next_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8775 9090 m
 gs 1 -1 sc (prev_cousin) col4 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8820 8280 m
 gs 1 -1 sc (prev_sibling) col1 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8730 6120 m
 gs 1 -1 sc (next_sibling) col1 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9945 7650 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 10620 2160 m
 gs 1 -1 sc (.logical_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8505 3960 m
 gs 1 -1 sc (.os_index = 1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 10620 2610 m
 gs 1 -1 sc (.sibling_rank = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 10620 2385 m
 gs 1 -1 sc (.os_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 10620 1935 m
 gs 1 -1 sc (.depth = -3) col12 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 5805 675 m
 gs 1 -1 sc (Machine) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 5805 900 m
 gs 1 -1 sc (.depth = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 5805 1125 m
 gs 1 -1 sc (.logical_index = 0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 5805 1350 m
 gs 1 -1 sc (.os_index = -1) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 5805 1575 m
 gs 1 -1 sc (.sibling_rank=0) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 5805 1800 m
 gs 1 -1 sc (.arity=2) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 5805 2025 m
 gs 1 -1 sc (.memory_arity=1) col12 sh gr
-/Times-Roman-iso ff 210.00 scf sf
+/Times-Roman ff 210.00 scf sf
 10620 1710 m
 gs 1 -1 sc (NUMA Node) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 9540 2340 m
 gs 1 -1 sc (parent) col0 sh gr
-/Times-Roman-iso ff 180.00 scf sf
+/Times-Roman ff 180.00 scf sf
 8775 2025 m
 gs 1 -1 sc (memory_first_child) col12 sh gr
 % here ends figure;
Binary files 2.10.0-1/doc/images/diagram.png and 2.11.0-1/doc/images/diagram.png differ
Binary files 2.10.0-1/doc/images/heteromem.png and 2.11.0-1/doc/images/heteromem.png differ
diff -pruN 2.10.0-1/hwloc/bind.c 2.11.0-1/hwloc/bind.c
--- 2.10.0-1/hwloc/bind.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/bind.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2020 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2010, 2012 Université Bordeaux
  * Copyright © 2011-2015 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -287,6 +287,7 @@ static __hwloc_inline int hwloc__check_m
       || policy == HWLOC_MEMBIND_FIRSTTOUCH
       || policy == HWLOC_MEMBIND_BIND
       || policy == HWLOC_MEMBIND_INTERLEAVE
+      || policy == HWLOC_MEMBIND_WEIGHTED_INTERLEAVE
       || policy == HWLOC_MEMBIND_NEXTTOUCH)
     return 0;
   return -1;
diff -pruN 2.10.0-1/hwloc/bitmap.c 2.11.0-1/hwloc/bitmap.c
--- 2.10.0-1/hwloc/bitmap.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/bitmap.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2020 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2011 Université Bordeaux
  * Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -245,6 +245,7 @@ int hwloc_bitmap_copy(struct hwloc_bitma
 /* Strings always use 32bit groups */
 #define HWLOC_PRIxSUBBITMAP		"%08lx"
 #define HWLOC_BITMAP_SUBSTRING_SIZE	32
+#define HWLOC_BITMAP_SUBSTRING_FULL_VALUE 0xFFFFFFFFUL
 #define HWLOC_BITMAP_SUBSTRING_LENGTH	(HWLOC_BITMAP_SUBSTRING_SIZE/4)
 #define HWLOC_BITMAP_STRING_PER_LONG	(HWLOC_BITS_PER_LONG/HWLOC_BITMAP_SUBSTRING_SIZE)
 
@@ -261,6 +262,7 @@ int hwloc_bitmap_snprintf(char * __hwloc
   const unsigned long accum_mask = ~0UL;
 #else /* HWLOC_BITS_PER_LONG != HWLOC_BITMAP_SUBSTRING_SIZE */
   const unsigned long accum_mask = ((1UL << HWLOC_BITMAP_SUBSTRING_SIZE) - 1) << (HWLOC_BITS_PER_LONG - HWLOC_BITMAP_SUBSTRING_SIZE);
+  int merge_with_infinite_prefix = 0;
 #endif /* HWLOC_BITS_PER_LONG != HWLOC_BITMAP_SUBSTRING_SIZE */
 
   HWLOC__BITMAP_CHECK(set);
@@ -279,6 +281,9 @@ int hwloc_bitmap_snprintf(char * __hwloc
       res = size>0 ? (int)size - 1 : 0;
     tmp += res;
     size -= res;
+#if HWLOC_BITS_PER_LONG > HWLOC_BITMAP_SUBSTRING_SIZE
+    merge_with_infinite_prefix = 1;
+#endif
   }
 
   i=(int) set->ulongs_count-1;
@@ -294,16 +299,24 @@ int hwloc_bitmap_snprintf(char * __hwloc
   }
 
   while (i>=0 || accumed) {
+    unsigned long value;
+
     /* Refill accumulator */
     if (!accumed) {
       accum = set->ulongs[i--];
       accumed = HWLOC_BITS_PER_LONG;
     }
+    value = (accum & accum_mask) >> (HWLOC_BITS_PER_LONG - HWLOC_BITMAP_SUBSTRING_SIZE);
 
-    if (accum & accum_mask) {
+#if HWLOC_BITS_PER_LONG > HWLOC_BITMAP_SUBSTRING_SIZE
+    if (merge_with_infinite_prefix && value == HWLOC_BITMAP_SUBSTRING_FULL_VALUE) {
+      /* first full subbitmap merged with infinite prefix */
+      res = 0;
+    } else
+#endif
+    if (value) {
       /* print the whole subset if not empty */
-        res = hwloc_snprintf(tmp, size, needcomma ? ",0x" HWLOC_PRIxSUBBITMAP : "0x" HWLOC_PRIxSUBBITMAP,
-		     (accum & accum_mask) >> (HWLOC_BITS_PER_LONG - HWLOC_BITMAP_SUBSTRING_SIZE));
+      res = hwloc_snprintf(tmp, size, needcomma ? ",0x" HWLOC_PRIxSUBBITMAP : "0x" HWLOC_PRIxSUBBITMAP, value);
       needcomma = 1;
     } else if (i == -1 && accumed == HWLOC_BITMAP_SUBSTRING_SIZE) {
       /* print a single 0 to mark the last subset */
@@ -323,6 +336,7 @@ int hwloc_bitmap_snprintf(char * __hwloc
 #else
     accum <<= HWLOC_BITMAP_SUBSTRING_SIZE;
     accumed -= HWLOC_BITMAP_SUBSTRING_SIZE;
+    merge_with_infinite_prefix = 0;
 #endif
 
     if (res >= size)
@@ -362,7 +376,8 @@ int hwloc_bitmap_sscanf(struct hwloc_bit
 {
   const char * current = string;
   unsigned long accum = 0;
-  int count=0;
+  int count = 0;
+  int ulongcount;
   int infinite = 0;
 
   /* count how many substrings there are */
@@ -383,9 +398,20 @@ int hwloc_bitmap_sscanf(struct hwloc_bit
     count--;
   }
 
-  if (hwloc_bitmap_reset_by_ulongs(set, (count + HWLOC_BITMAP_STRING_PER_LONG - 1) / HWLOC_BITMAP_STRING_PER_LONG) < 0)
+  ulongcount = (count + HWLOC_BITMAP_STRING_PER_LONG - 1) / HWLOC_BITMAP_STRING_PER_LONG;
+  if (hwloc_bitmap_reset_by_ulongs(set, ulongcount) < 0)
     return -1;
-  set->infinite = 0;
+
+  set->infinite = 0; /* will be updated later */
+
+#if HWLOC_BITS_PER_LONG != HWLOC_BITMAP_SUBSTRING_SIZE
+  if (infinite && (count % HWLOC_BITMAP_STRING_PER_LONG) != 0) {
+    /* accumulate substrings of the first ulong that are hidden in the infinite prefix */
+    int i;
+    for(i = (count % HWLOC_BITMAP_STRING_PER_LONG); i < HWLOC_BITMAP_STRING_PER_LONG; i++)
+      accum |= (HWLOC_BITMAP_SUBSTRING_FULL_VALUE << (i*HWLOC_BITMAP_SUBSTRING_SIZE));
+  }
+#endif
 
   while (*current != '\0') {
     unsigned long val;
@@ -544,6 +570,9 @@ int hwloc_bitmap_taskset_snprintf(char *
   ssize_t size = buflen;
   char *tmp = buf;
   int res, ret = 0;
+#if HWLOC_BITS_PER_LONG == 64
+  int merge_with_infinite_prefix = 0;
+#endif
   int started = 0;
   int i;
 
@@ -563,6 +592,9 @@ int hwloc_bitmap_taskset_snprintf(char *
       res = size>0 ? (int)size - 1 : 0;
     tmp += res;
     size -= res;
+#if HWLOC_BITS_PER_LONG == 64
+    merge_with_infinite_prefix = 1;
+#endif
   }
 
   i=set->ulongs_count-1;
@@ -582,7 +614,11 @@ int hwloc_bitmap_taskset_snprintf(char *
     if (started) {
       /* print the whole subset */
 #if HWLOC_BITS_PER_LONG == 64
-      res = hwloc_snprintf(tmp, size, "%016lx", val);
+      if (merge_with_infinite_prefix && (val & 0xffffffff00000000UL) == 0xffffffff00000000UL) {
+        res = hwloc_snprintf(tmp, size, "%08lx", val & 0xffffffffUL);
+      } else  {
+        res = hwloc_snprintf(tmp, size, "%016lx", val);
+      }
 #else
       res = hwloc_snprintf(tmp, size, "%08lx", val);
 #endif
@@ -599,6 +635,9 @@ int hwloc_bitmap_taskset_snprintf(char *
       res = size>0 ? (int)size - 1 : 0;
     tmp += res;
     size -= res;
+#if HWLOC_BITS_PER_LONG == 64
+    merge_with_infinite_prefix = 0;
+#endif
   }
 
   /* if didn't display anything, display 0x0 */
@@ -679,6 +718,10 @@ int hwloc_bitmap_taskset_sscanf(struct h
       goto failed;
 
     set->ulongs[count-1] = val;
+    if (infinite && tmpchars != HWLOC_BITS_PER_LONG/4) {
+      /* infinite prefix with partial substring, fill remaining bits */
+      set->ulongs[count-1] |= (~0ULL)<<(4*tmpchars);
+    }
 
     current += tmpchars;
     chars -= tmpchars;
diff -pruN 2.10.0-1/hwloc/distances.c 2.11.0-1/hwloc/distances.c
--- 2.10.0-1/hwloc/distances.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/distances.c	2024-06-25 12:36:50.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * Copyright © 2010-2022 Inria.  All rights reserved.
+ * Copyright © 2010-2024 Inria.  All rights reserved.
  * Copyright © 2011-2012 Université Bordeaux
  * Copyright © 2011 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -624,8 +624,8 @@ void * hwloc_distances_add_create(hwloc_
     return NULL;
   }
   if ((kind & ~HWLOC_DISTANCES_KIND_ALL)
-      || hwloc_weight_long(kind & HWLOC_DISTANCES_KIND_FROM_ALL) != 1
-      || hwloc_weight_long(kind & HWLOC_DISTANCES_KIND_MEANS_ALL) != 1) {
+      || hwloc_weight_long(kind & HWLOC_DISTANCES_KIND_FROM_ALL) > 1
+      || hwloc_weight_long(kind & HWLOC_DISTANCES_KIND_MEANS_ALL) > 1) {
     errno = EINVAL;
     return NULL;
   }
diff -pruN 2.10.0-1/hwloc/memattrs.c 2.11.0-1/hwloc/memattrs.c
--- 2.10.0-1/hwloc/memattrs.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/memattrs.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * Copyright © 2020-2023 Inria.  All rights reserved.
+ * Copyright © 2020-2024 Inria.  All rights reserved.
  * See COPYING in top-level directory.
  */
 
@@ -1806,6 +1806,12 @@ hwloc__apply_memory_tiers_subtypes(hwloc
       }
     }
   }
+  if (nr_tiers > 1) {
+    hwloc_obj_t root = hwloc_get_root_obj(topology);
+    char tmp[20];
+    snprintf(tmp, sizeof(tmp), "%u", nr_tiers);
+    hwloc__add_info_nodup(&root->infos, &root->infos_count, "MemoryTiersNr", tmp, 1);
+  }
 }
 
 int
diff -pruN 2.10.0-1/hwloc/pci-common.c 2.11.0-1/hwloc/pci-common.c
--- 2.10.0-1/hwloc/pci-common.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/pci-common.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * Copyright © 2009-2022 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * See COPYING in top-level directory.
  */
 
@@ -886,36 +886,12 @@ hwloc_pcidisc_find_linkspeed(const unsig
 			     unsigned offset, float *linkspeed)
 {
   unsigned linksta, speed, width;
-  float lanespeed;
 
   memcpy(&linksta, &config[offset + HWLOC_PCI_EXP_LNKSTA], 4);
   speed = linksta & HWLOC_PCI_EXP_LNKSTA_SPEED; /* PCIe generation */
   width = (linksta & HWLOC_PCI_EXP_LNKSTA_WIDTH) >> 4; /* how many lanes */
-  /*
-   * These are single-direction bandwidths only.
-   *
-   * Gen1 used NRZ with 8/10 encoding.
-   * PCIe Gen1 = 2.5GT/s signal-rate per lane x 8/10    =  0.25GB/s data-rate per lane
-   * PCIe Gen2 = 5  GT/s signal-rate per lane x 8/10    =  0.5 GB/s data-rate per lane
-   * Gen3 switched to NRZ with 128/130 encoding.
-   * PCIe Gen3 = 8  GT/s signal-rate per lane x 128/130 =  1   GB/s data-rate per lane
-   * PCIe Gen4 = 16 GT/s signal-rate per lane x 128/130 =  2   GB/s data-rate per lane
-   * PCIe Gen5 = 32 GT/s signal-rate per lane x 128/130 =  4   GB/s data-rate per lane
-   * Gen6 switched to PAM with with 242/256 FLIT (242B payload protected by 8B CRC + 6B FEC).
-   * PCIe Gen6 = 64 GT/s signal-rate per lane x 242/256 =  8   GB/s data-rate per lane
-   * PCIe Gen7 = 128GT/s signal-rate per lane x 242/256 = 16   GB/s data-rate per lane
-   */
-
-  /* lanespeed in Gbit/s */
-  if (speed <= 2)
-    lanespeed = 2.5f * speed * 0.8f;
-  else if (speed <= 5)
-    lanespeed = 8.0f * (1<<(speed-3)) * 128/130;
-  else
-    lanespeed = 8.0f * (1<<(speed-3)) * 242/256; /* assume Gen8 will be 256 GT/s and so on */
 
-  /* linkspeed in GB/s */
-  *linkspeed = lanespeed * width / 8;
+  *linkspeed = hwloc__pci_link_speed(speed, width);
   return 0;
 }
 
diff -pruN 2.10.0-1/hwloc/topology-levelzero.c 2.11.0-1/hwloc/topology-levelzero.c
--- 2.10.0-1/hwloc/topology-levelzero.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/topology-levelzero.c	2024-06-17 10:01:23.000000000 +0000
@@ -382,6 +382,7 @@ struct hwloc_levelzero_ports {
   unsigned nr;
   struct hwloc_levelzero_port {
     hwloc_obj_t osdev;
+    hwloc_obj_t parent_osdev;
     zes_fabric_port_properties_t props;
     zes_fabric_port_state_t state;
   } *ports;
@@ -443,11 +444,14 @@ hwloc__levelzero_ports_get(zes_device_ha
                   i, hports->ports[id].props.subdeviceId);
       if (hports->ports[id].props.subdeviceId < nr_sub_osdevs) {
         hports->ports[id].osdev = sub_osdevs[hports->ports[id].props.subdeviceId];
+        hports->ports[id].parent_osdev = root_osdev;
       } else {
         hwloc_debug("    no such subdevice exists, ignoring\n");
         continue;
       }
+    } else {
       hports->ports[id].osdev = root_osdev;
+      hports->ports[id].parent_osdev = NULL;
     }
 
     res = zesFabricPortGetState(ports[i], &hports->ports[id].state);
@@ -548,7 +552,14 @@ hwloc__levelzero_ports_connect(struct hw
           if (iindex<0 || jindex<0)
             continue;
           bws[iindex*oarray->nr+jindex] += hports->ports[i].state.rxSpeed.bitRate >> 20; /* MB/s */
-          /* TODO: way to accumulate subdevs bw into rootdevs? tranformation? different matrix? */
+          if (hports->ports[i].parent_osdev && hports->ports[j].parent_osdev) {
+            /* also accumulate in root devices */
+            iindex = hwloc__levelzero_osdev_array_find(oarray, hports->ports[i].parent_osdev);
+            jindex = hwloc__levelzero_osdev_array_find(oarray, hports->ports[j].parent_osdev);
+            if (iindex<0 || jindex<0)
+              continue;
+            bws[iindex*oarray->nr+jindex] += hports->ports[i].state.rxSpeed.bitRate >> 20; /* MB/s */
+          }
           gotbw++;
         }
       }
diff -pruN 2.10.0-1/hwloc/topology-linux.c 2.11.0-1/hwloc/topology-linux.c
--- 2.10.0-1/hwloc/topology-linux.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/topology-linux.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2013, 2015, 2020 Université Bordeaux
  * Copyright © 2009-2018 Cisco Systems, Inc.  All rights reserved.
  * Copyright © 2015 Intel, Inc.  All rights reserved.
@@ -177,6 +177,9 @@ struct hwloc_linux_backend_data_s {
 #ifndef MPOL_PREFERRED_MANY
 # define MPOL_PREFERRED_MANY 5
 #endif
+#ifndef MPOL_WEIGHTED_INTERLEAVE
+# define MPOL_WEIGHTED_INTERLEAVE 6
+#endif
 #ifndef MPOL_F_ADDR
 # define  MPOL_F_ADDR (1<<1)
 #endif
@@ -1673,6 +1676,9 @@ hwloc_linux_membind_policy_from_hwloc(in
   case HWLOC_MEMBIND_INTERLEAVE:
     *linuxpolicy = MPOL_INTERLEAVE;
     break;
+  case HWLOC_MEMBIND_WEIGHTED_INTERLEAVE:
+    *linuxpolicy = MPOL_WEIGHTED_INTERLEAVE;
+    break;
   /* TODO: next-touch when (if?) patch applied upstream */
   default:
     errno = ENOSYS;
@@ -1739,6 +1745,18 @@ hwloc_linux_membind_mask_to_nodeset(hwlo
     hwloc_bitmap_set_ith_ulong(nodeset, i, linuxmask[i]);
 }
 
+static __hwloc_inline void
+warn_preferred_many_fallback(hwloc_const_bitmap_t nodeset)
+{
+  static int warned = 0;
+  if (!warned && HWLOC_SHOW_ALL_ERRORS() && hwloc_bitmap_weight(nodeset) > 1) {
+    fprintf(stderr, "[hwloc/membind] MPOL_PREFERRED_MANY not supported by the kernel.\n");
+    fprintf(stderr, "If *all* given nodes must be used, use strict binding or the interleave policy.\n");
+    fprintf(stderr, "Otherwise the old MPOL_PREFERRED will only use the first given node.\n");
+    warned = 1;
+  }
+}
+
 static int
 hwloc_linux_set_area_membind(hwloc_topology_t topology, const void *addr, size_t len, hwloc_const_nodeset_t nodeset, hwloc_membind_policy_t policy, int flags)
 {
@@ -1795,7 +1813,7 @@ hwloc_linux_set_area_membind(hwloc_topol
       err = hwloc_mbind((void *) addr, len, MPOL_PREFERRED, linuxmask, max_os_index+1, linuxflags);
       if (!err) {
         /* worked fine, MPOL_PREFERRED_MANY isn't supported */
-        hwloc_debug("MPOL_PREFERRED_MANY not supported, reverting to MPOL_PREFERRED (with a single node)\n");
+        warn_preferred_many_fallback(nodeset);
         preferred_many_notsupported = 1;
       }
     }
@@ -1888,7 +1906,7 @@ hwloc_linux_set_thisthread_membind(hwloc
       err = hwloc_set_mempolicy(MPOL_PREFERRED, linuxmask, max_os_index+1);
       if (!err) {
         /* worked fine, MPOL_PREFERRED_MANY isn't supported */
-        hwloc_debug("MPOL_PREFERRED_MANY not supported, reverting to MPOL_PREFERRED (with a single node)\n");
+        warn_preferred_many_fallback(nodeset);
         preferred_many_notsupported = 1;
       }
     }
@@ -1972,6 +1990,9 @@ hwloc_linux_membind_policy_to_hwloc(int
   case MPOL_INTERLEAVE:
     *policy = HWLOC_MEMBIND_INTERLEAVE;
     return 0;
+  case MPOL_WEIGHTED_INTERLEAVE:
+    *policy = HWLOC_MEMBIND_WEIGHTED_INTERLEAVE;
+    return 0;
   default:
     errno = EINVAL;
     return -1;
@@ -2221,6 +2242,9 @@ hwloc_set_linuxfs_hooks(struct hwloc_bin
   support->membind->bind_membind = 1;
   support->membind->interleave_membind = 1;
   support->membind->migrate_membind = 1;
+  /* if weighted interleave is supported, weights are exposed in sysfs */
+  if (access("/sys/kernel/mm/mempolicy/weighted_interleave", F_OK) == 0)
+    support->membind->weighted_interleave_membind = 1;
 #endif
   hooks->get_allowed_resources = hwloc_linux_get_allowed_resources_hook;
 
@@ -2262,6 +2286,26 @@ hwloc_find_linux_cgroup_mntpnt(enum hwlo
   int err;
   size_t bufsize;
 
+  /* try standard mount points */
+  if (!hwloc_accessat("/sys/fs/cgroup/cpuset.cpus.effective", R_OK, fsroot_fd)) {
+    hwloc_debug("Found standard cgroup2/cpuset mount point at /sys/fs/cgroup/\n");
+    *cgtype = HWLOC_LINUX_CGROUP2;
+    *mntpnt = strdup("/sys/fs/cgroup");
+    return;
+  } else if (!hwloc_accessat("/sys/fs/cgroup/cpuset/cpuset.cpus", R_OK, fsroot_fd)) {
+    hwloc_debug("Found standard cgroup1/cpuset mount point at /sys/fs/cgroup/cpuset/\n");
+    *cgtype = HWLOC_LINUX_CGROUP1;
+    *mntpnt = strdup("/sys/fs/cgroup/cpuset");
+    return;
+  } else if (!hwloc_accessat("/dev/cpuset/cpus", R_OK, fsroot_fd)) {
+    hwloc_debug("Found standard cpuset mount point at /dev/cpuset/\n");
+    *cgtype = HWLOC_LINUX_CPUSET;
+    *mntpnt = strdup("/dev/cpuset");
+    return;
+  }
+  hwloc_debug("Couldn't find any standard cgroup or cpuset mount point, looking in /proc/mounts...\n");
+
+  /* try to manually find the mount point */
   *mntpnt = NULL;
 
   if (root_path) {
@@ -4242,7 +4286,10 @@ look_sysfsnode(struct hwloc_topology *to
 	struct dirent *dirent;
 	int keep;
 	env = getenv("HWLOC_KEEP_NVIDIA_GPU_NUMA_NODES");
-        keep = env && atoi(env);
+        /* NVIDIA GPU NUMA nodes hidden by default on POWER */
+        keep = (data->arch != HWLOC_LINUX_ARCH_POWER);
+        if (env)
+          keep = atoi(env);
 	while ((dirent = readdir(dir)) != NULL) {
 	  char nvgpunumapath[300], line[256];
           int err;
diff -pruN 2.10.0-1/hwloc/topology-nvml.c 2.11.0-1/hwloc/topology-nvml.c
--- 2.10.0-1/hwloc/topology-nvml.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/topology-nvml.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * Copyright © 2012-2023 Inria.  All rights reserved.
+ * Copyright © 2012-2024 Inria.  All rights reserved.
  * See COPYING in top-level directory.
  */
 
@@ -26,8 +26,15 @@ hwloc__nvml_get_peer_gpu_by_pci(nvmlPciI
   return (unsigned)-1;
 }
 
+#if !HAVE_DECL_NVMLDEVICEGETNVLINKREMOTEDEVICETYPE
+typedef unsigned nvmlIntNvLinkDeviceType_t;
+#define NVML_NVLINK_DEVICE_TYPE_IBMNPU  0x01
+#define NVML_NVLINK_DEVICE_TYPE_SWITCH  0x02
+#define NVML_NVLINK_DEVICE_TYPE_UNKNOWN 0xFF
+#endif
+
 static hwloc_obj_t
-hwloc__nvml_get_peer_obj_by_pci(struct hwloc_topology *topology, hwloc_obj_t gpu, nvmlPciInfo_t peer_bdf)
+hwloc__nvml_get_peer_obj_by_pci(struct hwloc_topology *topology, hwloc_obj_t gpu, nvmlPciInfo_t peer_bdf, nvmlIntNvLinkDeviceType_t dtype)
 {
   hwloc_obj_t obj;
 
@@ -55,17 +62,26 @@ hwloc__nvml_get_peer_obj_by_pci(struct h
     return NULL;
   }
 
-  /* We want a non-PCI bridge.
-   * On POWER8/9, it's class 0680 vendor 1014 (IBM) model 04ea prog-if 00.
-   * For NVSwitch, it's class 0680 with prog-if 01 vendor 10de (NVIDIA).
-   * Baseclass 0x06 is enough to avoid GPUs (baseclass 0x03),
-   * and that's needed because some GPUs may be hidden from us because of cgroups.
-   */
-  if (obj->type != HWLOC_OBJ_PCI_DEVICE || (obj->attr->pcidev.class_id >> 8 != 0x06))
-    return NULL;
+  if (dtype == NVML_NVLINK_DEVICE_TYPE_UNKNOWN) {
+    /* We want a non-PCI bridge.
+     * On POWER8/9, it's class 0680 vendor 1014 (IBM) model 04ea prog-if 00.
+     * For NVSwitch, it's class 0680 with prog-if 01 vendor 10de (NVIDIA).
+     * Baseclass 0x06 is enough to avoid GPUs (baseclass 0x03),
+     * and that's needed because some GPUs may be hidden from us because of cgroups.
+     */
+    if (obj->type != HWLOC_OBJ_PCI_DEVICE || (obj->attr->pcidev.class_id >> 8 != 0x06))
+      return NULL;
 
-  switch (obj->attr->pcidev.vendor_id) {
-  case 0x1014: {
+    /* try to guess from the PCI info */
+    switch (obj->attr->pcidev.vendor_id) {
+    case 0x1014: dtype = NVML_NVLINK_DEVICE_TYPE_IBMNPU; break;
+    case 0x10de: dtype = NVML_NVLINK_DEVICE_TYPE_SWITCH; break;
+    default: break;
+    }
+  }
+
+  switch (dtype) {
+  case NVML_NVLINK_DEVICE_TYPE_IBMNPU: {
     /* IBM OpenCAPI port, return the CPU object. */
     if (!getenv("HWLOC_NVML_USE_OPENCAPI_LOCALITY")) {
       /* OpenCAPI Bridge PCI locality is wrong on POWER8 (equal to the entire machine).
@@ -79,7 +95,7 @@ hwloc__nvml_get_peer_obj_by_pci(struct h
       obj = obj->parent;
     return obj;
   }
-  case 0x10de: {
+  case NVML_NVLINK_DEVICE_TYPE_SWITCH: {
     /* NVIDIA NVSwitch, return the PCI object, we don't have anything better.
      * Mark it as subtype NVSwitch so that the core doesn't remove it.
      */
@@ -248,20 +264,12 @@ hwloc_nvml_discover(struct hwloc_backend
       gpu_bdfs[i] = pci;
 #endif
       parent = hwloc_pci_find_parent_by_busid(topology, pci.domain, pci.bus, pci.device, 0);
-#if HAVE_DECL_NVMLDEVICEGETMAXPCIELINKGENERATION
+#if HAVE_DECL_NVMLDEVICEGETCURRPCIELINKGENERATION
       if (parent && parent->type == HWLOC_OBJ_PCI_DEVICE) {
 	unsigned maxwidth = 0, maxgen = 0;
-	float lanespeed;
-	nvmlDeviceGetMaxPcieLinkWidth(device, &maxwidth);
-	nvmlDeviceGetMaxPcieLinkGeneration(device, &maxgen);
-	/* PCIe Gen1 = 2.5GT/s signal-rate per lane with 8/10 encoding    = 0.25GB/s data-rate per lane
-	 * PCIe Gen2 = 5  GT/s signal-rate per lane with 8/10 encoding    = 0.5 GB/s data-rate per lane
-	 * PCIe Gen3 = 8  GT/s signal-rate per lane with 128/130 encoding = 1   GB/s data-rate per lane
-	 */
-	lanespeed = maxgen <= 2 ? 2.5 * maxgen * 0.8 : 8.0 * 128/130; /* Gbit/s per lane */
-	if (lanespeed * maxwidth != 0.)
-	  /* we found the max link speed, replace the current link speed found by pci (or none) */
-	  parent->attr->pcidev.linkspeed = lanespeed * maxwidth / 8; /* GB/s */
+	nvmlDeviceGetCurrPcieLinkWidth(device, &maxwidth);
+	nvmlDeviceGetCurrPcieLinkGeneration(device, &maxgen);
+        parent->attr->pcidev.linkspeed = hwloc__pci_link_speed(maxgen, maxwidth);
       }
 #endif
     }
@@ -289,6 +297,7 @@ hwloc_nvml_discover(struct hwloc_backend
     hwloc_debug("looking at NVLinks for NVML GPU #%u...\n", i);
     for(j=0; j<NVML_NVLINK_MAX_LINKS; j++) {
       nvmlEnableState_t isActive;
+      nvmlIntNvLinkDeviceType_t dtype;
 
       /* mark the peer as unknown for now */
       peer_indexes[i*NVML_NVLINK_MAX_LINKS+j] = (unsigned) -1;
@@ -301,13 +310,21 @@ hwloc_nvml_discover(struct hwloc_backend
       found_nvlinks++;
       hwloc_debug("  NVLink #%u is active\n", j);
 
+#if HAVE_DECL_NVMLDEVICEGETNVLINKREMOTEDEVICETYPE
+      ret = nvmlDeviceGetNvLinkRemoteDeviceType(device, j, &dtype);
+      if (ret != NVML_SUCCESS)
+        dtype = NVML_NVLINK_DEVICE_TYPE_UNKNOWN;
+#else
+      dtype = NVML_NVLINK_DEVICE_TYPE_UNKNOWN;
+#endif
+
       ret = nvmlDeviceGetNvLinkRemotePciInfo(device, j, &pci);
       if (ret == NVML_SUCCESS) {
         unsigned peer_index;
         hwloc_debug("    goes to PCI %04x:%02x:%02x\n", pci.domain, pci.bus, pci.device);
         peer_index = hwloc__nvml_get_peer_gpu_by_pci(pci, nb, gpu_bdfs);
         if (peer_index == (unsigned)-1) {
-          hwloc_obj_t peer_obj = hwloc__nvml_get_peer_obj_by_pci(topology, objs[i], pci);
+          hwloc_obj_t peer_obj = hwloc__nvml_get_peer_obj_by_pci(topology, objs[i], pci, dtype);
           if (!peer_obj)
             continue;
 
diff -pruN 2.10.0-1/hwloc/topology-windows.c 2.11.0-1/hwloc/topology-windows.c
--- 2.10.0-1/hwloc/topology-windows.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/topology-windows.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2012, 2020 Université Bordeaux
  * Copyright © 2011 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -220,7 +220,7 @@ static void hwloc_win_get_function_ptrs(
 #pragma GCC diagnostic ignored "-Wcast-function-type"
 #endif
 
-    kernel32 = LoadLibrary("kernel32.dll");
+    kernel32 = LoadLibrary(TEXT("kernel32.dll"));
     if (kernel32) {
       GetActiveProcessorGroupCountProc =
 	(PFN_GETACTIVEPROCESSORGROUPCOUNT) GetProcAddress(kernel32, "GetActiveProcessorGroupCount");
@@ -249,12 +249,12 @@ static void hwloc_win_get_function_ptrs(
     }
 
     if (!QueryWorkingSetExProc) {
-      HMODULE psapi = LoadLibrary("psapi.dll");
+      HMODULE psapi = LoadLibrary(TEXT("psapi.dll"));
       if (psapi)
         QueryWorkingSetExProc = (PFN_QUERYWORKINGSETEX) GetProcAddress(psapi, "QueryWorkingSetEx");
     }
 
-    ntdll = GetModuleHandle("ntdll");
+    ntdll = GetModuleHandle(TEXT("ntdll"));
     RtlGetVersionProc = (PFN_RTLGETVERSION) GetProcAddress(ntdll, "RtlGetVersion");
 
 #if HWLOC_HAVE_GCC_W_CAST_FUNCTION_TYPE
diff -pruN 2.10.0-1/hwloc/topology-x86.c 2.11.0-1/hwloc/topology-x86.c
--- 2.10.0-1/hwloc/topology-x86.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/topology-x86.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,11 +1,11 @@
 /*
- * Copyright © 2010-2023 Inria.  All rights reserved.
+ * Copyright © 2010-2024 Inria.  All rights reserved.
  * Copyright © 2010-2013 Université Bordeaux
  * Copyright © 2010-2011 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
  *
  *
- * This backend is only used when the operating system does not export
+ * This backend is mostly used when the operating system does not export
  * the necessary hardware topology information to user-space applications.
  * Currently, FreeBSD and NetBSD only add PUs and then fallback to this
  * backend for CPU/Cache discovery.
@@ -15,6 +15,7 @@
  * on various architectures, without having to use this x86-specific code.
  * But this backend is still used after them to annotate some objects with
  * additional details (CPU info in Package, Inclusiveness in Caches).
+ * It may also be enabled manually to work-around bugs in native OS discovery.
  */
 
 #include "private/autogen/config.h"
@@ -533,9 +534,9 @@ static void read_amd_cores_topoext(struc
 }
 
 /* Intel core/thread or even die/module/tile from CPUID 0x0b or 0x1f leaves (v1 and v2 extended topology enumeration)
- * or AMD complex/ccd from CPUID 0x80000026 (extended CPU topology)
+ * or AMD core/thread or even complex/ccd from CPUID 0x0b or 0x80000026 (extended CPU topology)
  */
-static void read_extended_topo(struct hwloc_x86_backend_data_s *data, struct procinfo *infos, unsigned leaf, enum cpuid_type cpuid_type, struct cpuiddump *src_cpuiddump)
+static void read_extended_topo(struct hwloc_x86_backend_data_s *data, struct procinfo *infos, unsigned leaf, enum cpuid_type cpuid_type __hwloc_attribute_unused, struct cpuiddump *src_cpuiddump)
 {
   unsigned level, apic_nextshift, apic_type, apic_id = 0, apic_shift = 0, id;
   unsigned threadid __hwloc_attribute_unused = 0; /* shut-up compiler */
@@ -547,20 +548,15 @@ static void read_extended_topo(struct hw
     eax = leaf;
     cpuid_or_from_dump(&eax, &ebx, &ecx, &edx, src_cpuiddump);
     /* Intel specifies that the 0x0b/0x1f loop should stop when we get "invalid domain" (0 in ecx[8:15])
-     * (if so, we also get 0 in eax/ebx for invalid subleaves).
+     * (if so, we also get 0 in eax/ebx for invalid subleaves). Zhaoxin implements this too.
      * However AMD rather says that the 0x80000026/0x0b loop should stop when we get "no thread at this level" (0 in ebx[0:15]).
-     * Zhaoxin follows the Intel specs but also returns "no thread at this level" for the last *valid* level (at least on KH-4000).
-     * From the Linux kernel code, it's very likely that AMD also returns "invalid domain"
-     * (because detect_extended_topology() uses that for all x86 CPUs)
-     * but keep with the official doc until AMD can clarify that (see #593).
+     *
+     * Linux kernel <= 6.8 used "invalid domain" for both Intel and AMD (in detect_extended_topology())
+     * but x86 discovery revamp in 6.9 now properly checks both Intel and AMD conditions (in topo_subleaf()).
+     * So let's assume we are allowed to break-out once one of the Intel+AMD conditions is met.
      */
-    if (cpuid_type == amd) {
-      if (!(ebx & 0xffff))
-        break;
-    } else {
-      if (!(ecx & 0xff00))
-        break;
-    }
+    if (!(ebx & 0xffff) || !(ecx & 0xff00))
+      break;
     apic_packageshift = eax & 0x1f;
   }
 
@@ -572,13 +568,8 @@ static void read_extended_topo(struct hw
 	ecx = level;
 	eax = leaf;
 	cpuid_or_from_dump(&eax, &ebx, &ecx, &edx, src_cpuiddump);
-        if (cpuid_type == amd) {
-          if (!(ebx & 0xffff))
-            break;
-        } else {
-          if (!(ecx & 0xff00))
-            break;
-        }
+        if (!(ebx & 0xffff) || !(ecx & 0xff00))
+          break;
 	apic_nextshift = eax & 0x1f;
 	apic_type = (ecx & 0xff00) >> 8;
 	apic_id = edx;
diff -pruN 2.10.0-1/hwloc/topology-xml.c 2.11.0-1/hwloc/topology-xml.c
--- 2.10.0-1/hwloc/topology-xml.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/topology-xml.c	2024-06-25 12:36:50.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2011, 2020 Université Bordeaux
  * Copyright © 2009-2018 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -1344,7 +1344,7 @@ hwloc__xml_v2import_support(hwloc_topolo
     HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_support) == 4*sizeof(void*));
     HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_discovery_support) == 6);
     HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_cpubind_support) == 11);
-    HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_membind_support) == 15);
+    HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_membind_support) == 16);
     HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_misc_support) == 1);
 #endif
 
@@ -1378,6 +1378,7 @@ hwloc__xml_v2import_support(hwloc_topolo
     else DO(membind,firsttouch_membind);
     else DO(membind,bind_membind);
     else DO(membind,interleave_membind);
+    else DO(membind,weighted_interleave_membind);
     else DO(membind,nexttouch_membind);
     else DO(membind,migrate_membind);
     else DO(membind,get_area_memlocation);
@@ -1436,6 +1437,10 @@ hwloc__xml_v2import_distances(hwloc_topo
     }
     else if (!strcmp(attrname, "kind")) {
       kind = strtoul(attrvalue, NULL, 10);
+      /* forward compat with "HOPS" kind in v3 */
+      if (kind & (1UL<<5))
+        /* hops becomes latency */
+        kind = (kind & ~(1UL<<5)) | HWLOC_DISTANCES_KIND_MEANS_LATENCY;
     }
     else if (!strcmp(attrname, "name")) {
       name = attrvalue;
@@ -3087,7 +3092,7 @@ hwloc__xml_v2export_support(hwloc__xml_e
   HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_support) == 4*sizeof(void*));
   HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_discovery_support) == 6);
   HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_cpubind_support) == 11);
-  HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_membind_support) == 15);
+  HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_membind_support) == 16);
   HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_misc_support) == 1);
 #endif
 
@@ -3132,6 +3137,7 @@ hwloc__xml_v2export_support(hwloc__xml_e
   DO(membind,firsttouch_membind);
   DO(membind,bind_membind);
   DO(membind,interleave_membind);
+  DO(membind,weighted_interleave_membind);
   DO(membind,nexttouch_membind);
   DO(membind,migrate_membind);
   DO(membind,get_area_memlocation);
diff -pruN 2.10.0-1/hwloc/topology.c 2.11.0-1/hwloc/topology.c
--- 2.10.0-1/hwloc/topology.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/hwloc/topology.c	2024-06-17 10:01:23.000000000 +0000
@@ -465,6 +465,20 @@ hwloc_debug_print_objects(int indent __h
 #define hwloc_debug_print_objects(indent, obj) do { /* nothing */ } while (0)
 #endif /* !HWLOC_DEBUG */
 
+int hwloc_obj_set_subtype(hwloc_topology_t topology __hwloc_attribute_unused, hwloc_obj_t obj, const char *subtype)
+{
+  char *new = NULL;
+  if (subtype) {
+    new = strdup(subtype);
+    if (!new)
+      return -1;
+  }
+  if (obj->subtype)
+    free(obj->subtype);
+  obj->subtype = new;
+  return 0;
+}
+
 void hwloc__free_infos(struct hwloc_info_s *infos, unsigned count)
 {
   unsigned i;
diff -pruN 2.10.0-1/include/hwloc/distances.h 2.11.0-1/include/hwloc/distances.h
--- 2.10.0-1/include/hwloc/distances.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/include/hwloc/distances.h	2024-06-25 12:36:50.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * Copyright © 2010-2023 Inria.  All rights reserved.
+ * Copyright © 2010-2024 Inria.  All rights reserved.
  * See COPYING in top-level directory.
  */
 
@@ -28,18 +28,18 @@ extern "C" {
 
 /** \brief Matrix of distances between a set of objects.
  *
- * This matrix often contains latencies between NUMA nodes
+ * The most common matrix contains latencies between NUMA nodes
  * (as reported in the System Locality Distance Information Table (SLIT)
  * in the ACPI specification), which may or may not be physically accurate.
  * It corresponds to the latency for accessing the memory of one node
  * from a core in another node.
- * The corresponding kind is ::HWLOC_DISTANCES_KIND_FROM_OS | ::HWLOC_DISTANCES_KIND_FROM_USER.
+ * The corresponding kind is ::HWLOC_DISTANCES_KIND_MEANS_LATENCY | ::HWLOC_DISTANCES_KIND_FROM_USER.
  * The name of this distances structure is "NUMALatency".
- * Others distance structures include and "XGMIBandwidth", "XGMIHops",
- * "XeLinkBandwidth" and "NVLinkBandwidth".
  *
  * The matrix may also contain bandwidths between random sets of objects,
  * possibly provided by the user, as specified in the \p kind attribute.
+ * Others common distance structures include and "XGMIBandwidth", "XGMIHops",
+ * "XeLinkBandwidth" and "NVLinkBandwidth".
  *
  * Pointers \p objs and \p values should not be replaced, reallocated, freed, etc.
  * However callers are allowed to modify \p kind as well as the contents
@@ -70,11 +70,10 @@ struct hwloc_distances_s {
  * The \p kind attribute of struct hwloc_distances_s is a OR'ed set
  * of kinds.
  *
- * A kind of format HWLOC_DISTANCES_KIND_FROM_* specifies where the
- * distance information comes from, if known.
- *
- * A kind of format HWLOC_DISTANCES_KIND_MEANS_* specifies whether
- * values are latencies or bandwidths, if applicable.
+ * Each distance matrix may have only one kind among HWLOC_DISTANCES_KIND_FROM_*
+ * specifying where distance information comes from,
+ * and one kind among HWLOC_DISTANCES_KIND_MEANS_* specifying
+ * whether values are latencies or bandwidths.
  */
 enum hwloc_distances_kind_e {
   /** \brief These distances were obtained from the operating system or hardware.
@@ -357,6 +356,8 @@ typedef void * hwloc_distances_add_handl
  * Otherwise, it will be copied internally and may later be freed by the caller.
  *
  * \p kind specifies the kind of distance as a OR'ed set of ::hwloc_distances_kind_e.
+ * Only one kind of meaning and one kind of provenance may be given if appropriate
+ * (e.g. ::HWLOC_DISTANCES_KIND_MEANS_BANDWIDTH and ::HWLOC_DISTANCES_KIND_FROM_USER).
  * Kind ::HWLOC_DISTANCES_KIND_HETEROGENEOUS_TYPES will be automatically set
  * according to objects having different types in hwloc_distances_add_values().
  *
@@ -403,7 +404,8 @@ HWLOC_DECLSPEC int hwloc_distances_add_v
 /** \brief Flags for adding a new distances to a topology. */
 enum hwloc_distances_add_flag_e {
   /** \brief Try to group objects based on the newly provided distance information.
-   * This is ignored for distances between objects of different types.
+   * Grouping is only performed when the distances structure contains latencies,
+   * and when all objects are of the same type.
    * \hideinitializer
    */
   HWLOC_DISTANCES_ADD_FLAG_GROUP = (1UL<<0),
diff -pruN 2.10.0-1/include/hwloc/helper.h 2.11.0-1/include/hwloc/helper.h
--- 2.10.0-1/include/hwloc/helper.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/include/hwloc/helper.h	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2012 Université Bordeaux
  * Copyright © 2009-2010 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -946,6 +946,14 @@ enum hwloc_distrib_flags_e {
  *
  * \return 0 on success, -1 on error.
  *
+ * \note On hybrid CPUs (or asymmetric platforms), distribution may be suboptimal
+ * since the number of cores or PUs inside packages or below caches may vary
+ * (the top-down recursive partitioning ignores these numbers until reaching their levels).
+ * Hence it is recommended to distribute only inside a single homogeneous domain.
+ * For instance on a CPU with energy-efficient E-cores and high-performance P-cores,
+ * one should distribute separately N tasks on E-cores and M tasks on P-cores
+ * instead of trying to distribute directly M+N tasks on the entire CPUs.
+ *
  * \note This function requires the \p roots objects to have a CPU set.
  */
 static __hwloc_inline int
diff -pruN 2.10.0-1/include/hwloc/opencl.h 2.11.0-1/include/hwloc/opencl.h
--- 2.10.0-1/include/hwloc/opencl.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/include/hwloc/opencl.h	2024-06-17 10:01:23.000000000 +0000
@@ -41,6 +41,15 @@ extern "C" {
  */
 /* Copyright (c) 2008-2018 The Khronos Group Inc. */
 
+/* needs "cl_khr_pci_bus_info" device extension, but not strictly required for clGetDeviceInfo() */
+typedef struct {
+    cl_uint pci_domain;
+    cl_uint pci_bus;
+    cl_uint pci_device;
+    cl_uint pci_function;
+} hwloc_cl_device_pci_bus_info_khr;
+#define HWLOC_CL_DEVICE_PCI_BUS_INFO_KHR 0x410F
+
 /* needs "cl_amd_device_attribute_query" device extension, but not strictly required for clGetDeviceInfo() */
 #define HWLOC_CL_DEVICE_TOPOLOGY_AMD 0x4037
 typedef union {
@@ -78,9 +87,19 @@ hwloc_opencl_get_device_pci_busid(cl_dev
                                unsigned *domain, unsigned *bus, unsigned *dev, unsigned *func)
 {
 	hwloc_cl_device_topology_amd amdtopo;
+	hwloc_cl_device_pci_bus_info_khr khrbusinfo;
 	cl_uint nvbus, nvslot, nvdomain;
 	cl_int clret;
 
+	clret = clGetDeviceInfo(device, HWLOC_CL_DEVICE_PCI_BUS_INFO_KHR, sizeof(khrbusinfo), &khrbusinfo, NULL);
+	if (CL_SUCCESS == clret) {
+		*domain = (unsigned) khrbusinfo.pci_domain;
+		*bus = (unsigned) khrbusinfo.pci_bus;
+		*dev = (unsigned) khrbusinfo.pci_device;
+		*func = (unsigned) khrbusinfo.pci_function;
+		return 0;
+	}
+
 	clret = clGetDeviceInfo(device, HWLOC_CL_DEVICE_TOPOLOGY_AMD, sizeof(amdtopo), &amdtopo, NULL);
 	if (CL_SUCCESS == clret
 	    && HWLOC_CL_DEVICE_TOPOLOGY_TYPE_PCIE_AMD == amdtopo.raw.type) {
diff -pruN 2.10.0-1/include/hwloc/rename.h 2.11.0-1/include/hwloc/rename.h
--- 2.10.0-1/include/hwloc/rename.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/include/hwloc/rename.h	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.
- * Copyright © 2010-2022 Inria.  All rights reserved.
+ * Copyright © 2010-2024 Inria.  All rights reserved.
  * See COPYING in top-level directory.
  */
 
@@ -210,6 +210,7 @@ extern "C" {
 
 #define hwloc_obj_get_info_by_name HWLOC_NAME(obj_get_info_by_name)
 #define hwloc_obj_add_info HWLOC_NAME(obj_add_info)
+#define hwloc_obj_set_subtype HWLOC_NAME(obj_set_subtype)
 
 #define HWLOC_CPUBIND_PROCESS HWLOC_NAME_CAPS(CPUBIND_PROCESS)
 #define HWLOC_CPUBIND_THREAD HWLOC_NAME_CAPS(CPUBIND_THREAD)
@@ -232,6 +233,7 @@ extern "C" {
 #define HWLOC_MEMBIND_FIRSTTOUCH HWLOC_NAME_CAPS(MEMBIND_FIRSTTOUCH)
 #define HWLOC_MEMBIND_BIND HWLOC_NAME_CAPS(MEMBIND_BIND)
 #define HWLOC_MEMBIND_INTERLEAVE HWLOC_NAME_CAPS(MEMBIND_INTERLEAVE)
+#define HWLOC_MEMBIND_WEIGHTED_INTERLEAVE HWLOC_NAME_CAPS(MEMBIND_WEIGHTED_INTERLEAVE)
 #define HWLOC_MEMBIND_NEXTTOUCH HWLOC_NAME_CAPS(MEMBIND_NEXTTOUCH)
 #define HWLOC_MEMBIND_MIXED HWLOC_NAME_CAPS(MEMBIND_MIXED)
 
@@ -560,6 +562,7 @@ extern "C" {
 
 /* opencl.h */
 
+#define hwloc_cl_device_pci_bus_info_khr HWLOC_NAME(cl_device_pci_bus_info_khr)
 #define hwloc_cl_device_topology_amd HWLOC_NAME(cl_device_topology_amd)
 #define hwloc_opencl_get_device_pci_busid HWLOC_NAME(opencl_get_device_pci_ids)
 #define hwloc_opencl_get_device_cpuset HWLOC_NAME(opencl_get_device_cpuset)
@@ -715,6 +718,8 @@ extern "C" {
 #define hwloc__obj_type_is_dcache HWLOC_NAME(_obj_type_is_dcache)
 #define hwloc__obj_type_is_icache HWLOC_NAME(_obj_type_is_icache)
 
+#define hwloc__pci_link_speed HWLOC_NAME(_pci_link_speed)
+
 /* private/cpuid-x86.h */
 
 #define hwloc_have_x86_cpuid HWLOC_NAME(have_x86_cpuid)
diff -pruN 2.10.0-1/include/hwloc.h 2.11.0-1/include/hwloc.h
--- 2.10.0-1/include/hwloc.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/include/hwloc.h	2024-06-25 12:36:50.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2012 Université Bordeaux
  * Copyright © 2009-2020 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -112,7 +112,7 @@ extern "C" {
  * Two stable releases of the same series usually have the same ::HWLOC_API_VERSION
  * even if their HWLOC_VERSION are different.
  */
-#define HWLOC_API_VERSION 0x00020800
+#define HWLOC_API_VERSION 0x00020b00
 
 /** \brief Indicate at runtime which hwloc API version was used at build time.
  *
@@ -1159,6 +1159,22 @@ hwloc_obj_get_info_by_name(hwloc_obj_t o
  */
 HWLOC_DECLSPEC int hwloc_obj_add_info(hwloc_obj_t obj, const char *name, const char *value);
 
+/** \brief Set (or replace) the subtype of an object.
+ *
+ * The given \p subtype is copied internally, the caller is responsible
+ * for freeing the original \p subtype if needed.
+ *
+ * If another subtype already exists in \p object, it is replaced.
+ * The given \p subtype may be \c NULL to remove the existing subtype.
+ *
+ * \note This function is mostly meant to initialize the subtype of user-added
+ * objects such as groups with hwloc_topology_alloc_group_object().
+ *
+ * \return \c 0 on success.
+ * \return \c -1 with \p errno set to \c ENOMEM on failure to allocate memory.
+ */
+HWLOC_DECLSPEC int hwloc_obj_set_subtype(hwloc_topology_t topology, hwloc_obj_t obj, const char *subtype);
+
 /** @} */
 
 
@@ -1528,6 +1544,16 @@ typedef enum {
    * \hideinitializer */
   HWLOC_MEMBIND_INTERLEAVE =	3,
 
+  /** \brief Allocate memory on the given nodes in an interleaved
+   * / weighted manner.  The precise layout of the memory across
+   * multiple NUMA nodes is OS/system specific. Weighted interleaving
+   * can be useful when threads distributed across the specified NUMA
+   * nodes with different bandwidth capabilities will all be accessing
+   * the whole memory range concurrently, since the interleave will then
+   * balance the memory references.
+   * \hideinitializer */
+  HWLOC_MEMBIND_WEIGHTED_INTERLEAVE = 5,
+
   /** \brief For each page bound with this policy, by next time
    * it is touched (and next time only), it is moved from its current
    * location to the local NUMA node of the thread where the memory
@@ -2346,6 +2372,8 @@ struct hwloc_topology_membind_support {
   unsigned char migrate_membind;
   /** Getting the last NUMA nodes where a memory area was allocated is supported */
   unsigned char get_area_memlocation;
+  /** Weighted interleave policy is supported. */
+  unsigned char weighted_interleave_membind;
 };
 
 /** \brief Flags describing miscellaneous features.
@@ -2651,6 +2679,9 @@ HWLOC_DECLSPEC int hwloc_topology_allow(
  *
  * The new leaf object will not have any \p cpuset.
  *
+ * The \p subtype object attribute may be defined with hwloc_obj_set_subtype()
+ * after successful insertion.
+ *
  * \return the newly-created object
  *
  * \return \c NULL on error.
@@ -2701,19 +2732,37 @@ HWLOC_DECLSPEC int hwloc_topology_free_g
  * the final location of the Group in the topology.
  * Then the object can be passed to this function for actual insertion in the topology.
  *
- * Either the cpuset or nodeset field (or both, if compatible) must be set
- * to a non-empty bitmap. The complete_cpuset or complete_nodeset may be set
- * instead if inserting with respect to the complete topology
+ * The main use case for this function is to group a subset of
+ * siblings among the list of children below a single parent.
+ * For instance, if grouping 4 cores out of a 8-core socket,
+ * the logical list of cores will be reordered so that the 4 grouped
+ * ones are consecutive.
+ * Then, if needed, a new depth is added between the parent and those
+ * children, and the Group is inserted there.
+ * At the end, the 4 grouped cores are now children of the Group,
+ * which replaces them as a child of the original parent.
+ *
+ * In practice, the grouped objects are specified through cpusets
+ * and/or nodesets, for instance using hwloc_obj_add_other_obj_sets()
+ * iteratively.
+ * Hence it is possible to group objects that are not children of the
+ * same parent, for instance some PUs below the 4 cores in example above.
+ * However this general case may fail if the expected Group conflicts
+ * with the existing hierarchy.
+ * For instance if each core has two PUs, it is not possible to insert
+ * a Group containing a single PU of each core.
+ *
+ * To specify the objects to group, either the cpuset or nodeset field
+ * (or both, if compatible) must be set to a non-empty bitmap.
+ * The complete_cpuset or complete_nodeset may be set instead if
+ * inserting with respect to the complete topology
  * (including disallowed, offline or unknown objects).
- * If grouping several objects, hwloc_obj_add_other_obj_sets() is an easy way
- * to build the Group sets iteratively.
  * These sets cannot be larger than the current topology, or they would get
  * restricted silently.
  * The core will setup the other sets after actual insertion.
  *
- * The \p subtype object attribute may be defined (to a dynamically
- * allocated string) to display something else than "Group" as the
- * type name for this object in lstopo.
+ * The \p subtype object attribute may be defined with hwloc_obj_set_subtype()
+ * to display something else than "Group" as the type name for this object in lstopo.
  * Custom name-value info pairs may be added with hwloc_obj_add_info() after
  * insertion.
  *
diff -pruN 2.10.0-1/include/private/autogen/config.h.in 2.11.0-1/include/private/autogen/config.h.in
--- 2.10.0-1/include/private/autogen/config.h.in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/include/private/autogen/config.h.in	2024-06-25 12:41:54.000000000 +0000
@@ -19,28 +19,28 @@
 #define HWLOC_CONFIGURE_H
 
 
-/* Define to 1 if the system has the type `CACHE_DESCRIPTOR'. */
+/* Define to 1 if the system has the type 'CACHE_DESCRIPTOR'. */
 #undef HAVE_CACHE_DESCRIPTOR
 
-/* Define to 1 if the system has the type `CACHE_RELATIONSHIP'. */
+/* Define to 1 if the system has the type 'CACHE_RELATIONSHIP'. */
 #undef HAVE_CACHE_RELATIONSHIP
 
-/* Define to 1 if you have the `clock_gettime' function. */
+/* Define to 1 if you have the 'clock_gettime' function. */
 #undef HAVE_CLOCK_GETTIME
 
-/* Define to 1 if you have the `clz' function. */
+/* Define to 1 if you have the 'clz' function. */
 #undef HAVE_CLZ
 
-/* Define to 1 if you have the `clzl' function. */
+/* Define to 1 if you have the 'clzl' function. */
 #undef HAVE_CLZL
 
 /* Define to 1 if you have the <CL/cl_ext.h> header file. */
 #undef HAVE_CL_CL_EXT_H
 
-/* Define to 1 if you have the `cpuset_setaffinity' function. */
+/* Define to 1 if you have the 'cpuset_setaffinity' function. */
 #undef HAVE_CPUSET_SETAFFINITY
 
-/* Define to 1 if you have the `cpuset_setid' function. */
+/* Define to 1 if you have the 'cpuset_setid' function. */
 #undef HAVE_CPUSET_SETID
 
 /* Define to 1 if you have the <ctype.h> header file. */
@@ -55,134 +55,138 @@
 /* Define to 1 if you have the <cuda_runtime_api.h> header file. */
 #undef HAVE_CUDA_RUNTIME_API_H
 
-/* Define to 1 if you have the declaration of `bind', and to 0 if you don't.
+/* Define to 1 if you have the declaration of 'bind', and to 0 if you don't.
    */
 #undef HAVE_DECL_BIND
 
-/* Define to 1 if you have the declaration of `CTL_HW', and to 0 if you don't.
+/* Define to 1 if you have the declaration of 'CTL_HW', and to 0 if you don't.
    */
 #undef HAVE_DECL_CTL_HW
 
-/* Define to 1 if you have the declaration of `fabsf', and to 0 if you don't.
+/* Define to 1 if you have the declaration of 'fabsf', and to 0 if you don't.
    */
 #undef HAVE_DECL_FABSF
 
-/* Define to 1 if you have the declaration of `getexecname', and to 0 if you
+/* Define to 1 if you have the declaration of 'getexecname', and to 0 if you
    don't. */
 #undef HAVE_DECL_GETEXECNAME
 
-/* Define to 1 if you have the declaration of `GetModuleFileName', and to 0 if
+/* Define to 1 if you have the declaration of 'GetModuleFileName', and to 0 if
    you don't. */
 #undef HAVE_DECL_GETMODULEFILENAME
 
-/* Define to 1 if you have the declaration of `getprogname', and to 0 if you
+/* Define to 1 if you have the declaration of 'getprogname', and to 0 if you
    don't. */
 #undef HAVE_DECL_GETPROGNAME
 
-/* Define to 1 if you have the declaration of `HW_MEMSIZE', and to 0 if you
+/* Define to 1 if you have the declaration of 'HW_MEMSIZE', and to 0 if you
    don't. */
 #undef HAVE_DECL_HW_MEMSIZE
 
-/* Define to 1 if you have the declaration of `HW_MEMSIZE64', and to 0 if you
+/* Define to 1 if you have the declaration of 'HW_MEMSIZE64', and to 0 if you
    don't. */
 #undef HAVE_DECL_HW_MEMSIZE64
 
-/* Define to 1 if you have the declaration of `HW_NCPU', and to 0 if you
+/* Define to 1 if you have the declaration of 'HW_NCPU', and to 0 if you
    don't. */
 #undef HAVE_DECL_HW_NCPU
 
-/* Define to 1 if you have the declaration of `HW_PHYSMEM', and to 0 if you
+/* Define to 1 if you have the declaration of 'HW_PHYSMEM', and to 0 if you
    don't. */
 #undef HAVE_DECL_HW_PHYSMEM
 
-/* Define to 1 if you have the declaration of `HW_PHYSMEM64', and to 0 if you
+/* Define to 1 if you have the declaration of 'HW_PHYSMEM64', and to 0 if you
    don't. */
 #undef HAVE_DECL_HW_PHYSMEM64
 
-/* Define to 1 if you have the declaration of `HW_REALMEM', and to 0 if you
+/* Define to 1 if you have the declaration of 'HW_REALMEM', and to 0 if you
    don't. */
 #undef HAVE_DECL_HW_REALMEM
 
-/* Define to 1 if you have the declaration of `HW_REALMEM64', and to 0 if you
+/* Define to 1 if you have the declaration of 'HW_REALMEM64', and to 0 if you
    don't. */
 #undef HAVE_DECL_HW_REALMEM64
 
-/* Define to 1 if you have the declaration of `HW_USERMEM', and to 0 if you
+/* Define to 1 if you have the declaration of 'HW_USERMEM', and to 0 if you
    don't. */
 #undef HAVE_DECL_HW_USERMEM
 
-/* Define to 1 if you have the declaration of `HW_USERMEM64', and to 0 if you
+/* Define to 1 if you have the declaration of 'HW_USERMEM64', and to 0 if you
    don't. */
 #undef HAVE_DECL_HW_USERMEM64
 
-/* Define to 1 if you have the declaration of `lgrp_latency_cookie', and to 0
+/* Define to 1 if you have the declaration of 'lgrp_latency_cookie', and to 0
    if you don't. */
 #undef HAVE_DECL_LGRP_LATENCY_COOKIE
 
-/* Define to 1 if you have the declaration of `modff', and to 0 if you don't.
+/* Define to 1 if you have the declaration of 'modff', and to 0 if you don't.
    */
 #undef HAVE_DECL_MODFF
 
 /* Define to 1 if you have the declaration of
-   `nvmlDeviceGetMaxPcieLinkGeneration', and to 0 if you don't. */
-#undef HAVE_DECL_NVMLDEVICEGETMAXPCIELINKGENERATION
+   'nvmlDeviceGetCurrPcieLinkGeneration', and to 0 if you don't. */
+#undef HAVE_DECL_NVMLDEVICEGETCURRPCIELINKGENERATION
 
-/* Define to 1 if you have the declaration of `pthread_getaffinity_np', and to
+/* Define to 1 if you have the declaration of
+   'nvmlDeviceGetNvLinkRemoteDeviceType', and to 0 if you don't. */
+#undef HAVE_DECL_NVMLDEVICEGETNVLINKREMOTEDEVICETYPE
+
+/* Define to 1 if you have the declaration of 'pthread_getaffinity_np', and to
    0 if you don't. */
 #undef HAVE_DECL_PTHREAD_GETAFFINITY_NP
 
-/* Define to 1 if you have the declaration of `pthread_setaffinity_np', and to
+/* Define to 1 if you have the declaration of 'pthread_setaffinity_np', and to
    0 if you don't. */
 #undef HAVE_DECL_PTHREAD_SETAFFINITY_NP
 
 /* Embedded mode; just assume we do not have Valgrind support */
 #undef HAVE_DECL_RUNNING_ON_VALGRIND
 
-/* Define to 1 if you have the declaration of `sched_getcpu', and to 0 if you
+/* Define to 1 if you have the declaration of 'sched_getcpu', and to 0 if you
    don't. */
 #undef HAVE_DECL_SCHED_GETCPU
 
-/* Define to 1 if you have the declaration of `snprintf', and to 0 if you
+/* Define to 1 if you have the declaration of 'snprintf', and to 0 if you
    don't. */
 #undef HAVE_DECL_SNPRINTF
 
-/* Define to 1 if you have the declaration of `strtoull', and to 0 if you
+/* Define to 1 if you have the declaration of 'strtoull', and to 0 if you
    don't. */
 #undef HAVE_DECL_STRTOULL
 
-/* Define to 1 if you have the declaration of `_putenv', and to 0 if you
+/* Define to 1 if you have the declaration of '_putenv', and to 0 if you
    don't. */
 #undef HAVE_DECL__PUTENV
 
-/* Define to 1 if you have the declaration of `_SC_LARGE_PAGESIZE', and to 0
+/* Define to 1 if you have the declaration of '_SC_LARGE_PAGESIZE', and to 0
    if you don't. */
 #undef HAVE_DECL__SC_LARGE_PAGESIZE
 
-/* Define to 1 if you have the declaration of `_SC_NPROCESSORS_CONF', and to 0
+/* Define to 1 if you have the declaration of '_SC_NPROCESSORS_CONF', and to 0
    if you don't. */
 #undef HAVE_DECL__SC_NPROCESSORS_CONF
 
-/* Define to 1 if you have the declaration of `_SC_NPROCESSORS_ONLN', and to 0
+/* Define to 1 if you have the declaration of '_SC_NPROCESSORS_ONLN', and to 0
    if you don't. */
 #undef HAVE_DECL__SC_NPROCESSORS_ONLN
 
-/* Define to 1 if you have the declaration of `_SC_NPROC_CONF', and to 0 if
+/* Define to 1 if you have the declaration of '_SC_NPROC_CONF', and to 0 if
    you don't. */
 #undef HAVE_DECL__SC_NPROC_CONF
 
-/* Define to 1 if you have the declaration of `_SC_NPROC_ONLN', and to 0 if
+/* Define to 1 if you have the declaration of '_SC_NPROC_ONLN', and to 0 if
    you don't. */
 #undef HAVE_DECL__SC_NPROC_ONLN
 
-/* Define to 1 if you have the declaration of `_SC_PAGESIZE', and to 0 if you
+/* Define to 1 if you have the declaration of '_SC_PAGESIZE', and to 0 if you
    don't. */
 #undef HAVE_DECL__SC_PAGESIZE
 
-/* Define to 1 if you have the declaration of `_SC_PAGE_SIZE', and to 0 if you
+/* Define to 1 if you have the declaration of '_SC_PAGE_SIZE', and to 0 if you
    don't. */
 #undef HAVE_DECL__SC_PAGE_SIZE
 
-/* Define to 1 if you have the declaration of `_strdup', and to 0 if you
+/* Define to 1 if you have the declaration of '_strdup', and to 0 if you
    don't. */
 #undef HAVE_DECL__STRDUP
 
@@ -192,28 +196,28 @@
 /* Define to 1 if you have the <dlfcn.h> header file. */
 #undef HAVE_DLFCN_H
 
-/* Define to 1 if you have the `ffs' function. */
+/* Define to 1 if you have the 'ffs' function. */
 #undef HAVE_FFS
 
-/* Define to 1 if you have the `ffsl' function. */
+/* Define to 1 if you have the 'ffsl' function. */
 #undef HAVE_FFSL
 
-/* Define to 1 if you have the `fls' function. */
+/* Define to 1 if you have the 'fls' function. */
 #undef HAVE_FLS
 
-/* Define to 1 if you have the `flsl' function. */
+/* Define to 1 if you have the 'flsl' function. */
 #undef HAVE_FLSL
 
-/* Define to 1 if you have the `getpagesize' function. */
+/* Define to 1 if you have the 'getpagesize' function. */
 #undef HAVE_GETPAGESIZE
 
-/* Define to 1 if the system has the type `GROUP_AFFINITY'. */
+/* Define to 1 if the system has the type 'GROUP_AFFINITY'. */
 #undef HAVE_GROUP_AFFINITY
 
-/* Define to 1 if the system has the type `GROUP_RELATIONSHIP'. */
+/* Define to 1 if the system has the type 'GROUP_RELATIONSHIP'. */
 #undef HAVE_GROUP_RELATIONSHIP
 
-/* Define to 1 if you have the `host_info' function. */
+/* Define to 1 if you have the 'host_info' function. */
 #undef HAVE_HOST_INFO
 
 /* Define to 1 if you have the <infiniband/verbs.h> header file. */
@@ -222,10 +226,10 @@
 /* Define to 1 if you have the <inttypes.h> header file. */
 #undef HAVE_INTTYPES_H
 
-/* Define to 1 if you have the `isatty' function. */
+/* Define to 1 if you have the 'isatty' function. */
 #undef HAVE_ISATTY
 
-/* Define to 1 if the system has the type `KAFFINITY'. */
+/* Define to 1 if the system has the type 'KAFFINITY'. */
 #undef HAVE_KAFFINITY
 
 /* Define to 1 if you have the <kstat.h> header file. */
@@ -258,7 +262,7 @@
 /* Define to 1 if you have the <locale.h> header file. */
 #undef HAVE_LOCALE_H
 
-/* Define to 1 if the system has the type `LOGICAL_PROCESSOR_RELATIONSHIP'. */
+/* Define to 1 if the system has the type 'LOGICAL_PROCESSOR_RELATIONSHIP'. */
 #undef HAVE_LOGICAL_PROCESSOR_RELATIONSHIP
 
 /* Define to 1 if you have the <mach_init.h> header file. */
@@ -273,19 +277,19 @@
 /* Define to 1 if you have the <malloc.h> header file. */
 #undef HAVE_MALLOC_H
 
-/* Define to 1 if you have the `memalign' function. */
+/* Define to 1 if you have the 'memalign' function. */
 #undef HAVE_MEMALIGN
 
 /* Define to 1 if you have the <minix/config.h> header file. */
 #undef HAVE_MINIX_CONFIG_H
 
-/* Define to 1 if you have the `mkstemp' function. */
+/* Define to 1 if you have the 'mkstemp' function. */
 #undef HAVE_MKSTEMP
 
-/* Define to 1 if you have the `nl_langinfo' function. */
+/* Define to 1 if you have the 'nl_langinfo' function. */
 #undef HAVE_NL_LANGINFO
 
-/* Define to 1 if the system has the type `NUMA_NODE_RELATIONSHIP'. */
+/* Define to 1 if the system has the type 'NUMA_NODE_RELATIONSHIP'. */
 #undef HAVE_NUMA_NODE_RELATIONSHIP
 
 /* Define to 1 if you have the <NVCtrl/NVCtrl.h> header file. */
@@ -294,7 +298,7 @@
 /* Define to 1 if you have the <nvml.h> header file. */
 #undef HAVE_NVML_H
 
-/* Define to 1 if you have the `openat' function. */
+/* Define to 1 if you have the 'openat' function. */
 #undef HAVE_OPENAT
 
 /* Define to 1 if you have the <OpenCL/cl_ext.h> header file. */
@@ -303,50 +307,50 @@
 /* Define to 1 if you have the <picl.h> header file. */
 #undef HAVE_PICL_H
 
-/* Define to 1 if you have the `posix_memalign' function. */
+/* Define to 1 if you have the 'posix_memalign' function. */
 #undef HAVE_POSIX_MEMALIGN
 
-/* Define to 1 if the system has the type `PROCESSOR_CACHE_TYPE'. */
+/* Define to 1 if the system has the type 'PROCESSOR_CACHE_TYPE'. */
 #undef HAVE_PROCESSOR_CACHE_TYPE
 
-/* Define to 1 if the system has the type `PROCESSOR_GROUP_INFO'. */
+/* Define to 1 if the system has the type 'PROCESSOR_GROUP_INFO'. */
 #undef HAVE_PROCESSOR_GROUP_INFO
 
-/* Define to 1 if the system has the type `PROCESSOR_NUMBER'. */
+/* Define to 1 if the system has the type 'PROCESSOR_NUMBER'. */
 #undef HAVE_PROCESSOR_NUMBER
 
-/* Define to 1 if the system has the type `PROCESSOR_RELATIONSHIP'. */
+/* Define to 1 if the system has the type 'PROCESSOR_RELATIONSHIP'. */
 #undef HAVE_PROCESSOR_RELATIONSHIP
 
 /* Define to '1' if program_invocation_name is present and usable */
 #undef HAVE_PROGRAM_INVOCATION_NAME
 
-/* Define to 1 if the system has the type `PSAPI_WORKING_SET_EX_BLOCK'. */
+/* Define to 1 if the system has the type 'PSAPI_WORKING_SET_EX_BLOCK'. */
 #undef HAVE_PSAPI_WORKING_SET_EX_BLOCK
 
-/* Define to 1 if the system has the type `PSAPI_WORKING_SET_EX_INFORMATION'.
+/* Define to 1 if the system has the type 'PSAPI_WORKING_SET_EX_INFORMATION'.
    */
 #undef HAVE_PSAPI_WORKING_SET_EX_INFORMATION
 
 /* Define to 1 if you have the <pthread_np.h> header file. */
 #undef HAVE_PTHREAD_NP_H
 
-/* Define to 1 if the system has the type `pthread_t'. */
+/* Define to 1 if the system has the type 'pthread_t'. */
 #undef HAVE_PTHREAD_T
 
-/* Define to 1 if you have the `putwc' function. */
+/* Define to 1 if you have the 'putwc' function. */
 #undef HAVE_PUTWC
 
-/* Define to 1 if the system has the type `RelationProcessorPackage'. */
+/* Define to 1 if the system has the type 'RelationProcessorPackage'. */
 #undef HAVE_RELATIONPROCESSORPACKAGE
 
 /* Define to 1 if you have the <rocm_smi/rocm_smi.h> header file. */
 #undef HAVE_ROCM_SMI_ROCM_SMI_H
 
-/* Define to 1 if you have the `setlocale' function. */
+/* Define to 1 if you have the 'setlocale' function. */
 #undef HAVE_SETLOCALE
 
-/* Define to 1 if the system has the type `ssize_t'. */
+/* Define to 1 if the system has the type 'ssize_t'. */
 #undef HAVE_SSIZE_T
 
 /* Define to 1 if you have the <stdint.h> header file. */
@@ -358,10 +362,10 @@
 /* Define to 1 if you have the <stdlib.h> header file. */
 #undef HAVE_STDLIB_H
 
-/* Define to 1 if you have the `strcasecmp' function. */
+/* Define to 1 if you have the 'strcasecmp' function. */
 #undef HAVE_STRCASECMP
 
-/* Define to 1 if you have the `strftime' function. */
+/* Define to 1 if you have the 'strftime' function. */
 #undef HAVE_STRFTIME
 
 /* Define to 1 if you have the <strings.h> header file. */
@@ -370,10 +374,10 @@
 /* Define to 1 if you have the <string.h> header file. */
 #undef HAVE_STRING_H
 
-/* Define to 1 if you have the `strncasecmp' function. */
+/* Define to 1 if you have the 'strncasecmp' function. */
 #undef HAVE_STRNCASECMP
 
-/* Define to 1 if you have the `strtoull' function. */
+/* Define to 1 if you have the 'strtoull' function. */
 #undef HAVE_STRTOULL
 
 /* Define to '1' if sysctl is present and usable */
@@ -383,7 +387,7 @@
 #undef HAVE_SYSCTLBYNAME
 
 /* Define to 1 if the system has the type
-   `SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX'. */
+   'SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX'. */
 #undef HAVE_SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX
 
 /* Define to 1 if you have the <sys/cpuset.h> header file. */
@@ -416,19 +420,19 @@
 /* Define to 1 if you have the <sys/utsname.h> header file. */
 #undef HAVE_SYS_UTSNAME_H
 
-/* Define to 1 if you have the `tcgetpgrp' function. */
+/* Define to 1 if you have the 'tcgetpgrp' function. */
 #undef HAVE_TCGETPGRP
 
 /* Define to 1 if you have the <time.h> header file. */
 #undef HAVE_TIME_H
 
-/* Define to 1 if you have the `uname' function. */
+/* Define to 1 if you have the 'uname' function. */
 #undef HAVE_UNAME
 
 /* Define to 1 if you have the <unistd.h> header file. */
 #undef HAVE_UNISTD_H
 
-/* Define to 1 if you have the `uselocale' function. */
+/* Define to 1 if you have the 'uselocale' function. */
 #undef HAVE_USELOCALE
 
 /* Define to 1 if you have the <valgrind/valgrind.h> header file. */
@@ -437,7 +441,7 @@
 /* Define to 1 if you have the <wchar.h> header file. */
 #undef HAVE_WCHAR_H
 
-/* Define to 1 if the system has the type `wchar_t'. */
+/* Define to 1 if the system has the type 'wchar_t'. */
 #undef HAVE_WCHAR_T
 
 /* Define to 1 if you have the <X11/keysym.h> header file. */
@@ -793,16 +797,16 @@
 /* Define to the version of this package. */
 #undef PACKAGE_VERSION
 
-/* The size of `unsigned int', as computed by sizeof. */
+/* The size of 'unsigned int', as computed by sizeof. */
 #undef SIZEOF_UNSIGNED_INT
 
-/* The size of `unsigned long', as computed by sizeof. */
+/* The size of 'unsigned long', as computed by sizeof. */
 #undef SIZEOF_UNSIGNED_LONG
 
-/* The size of `void *', as computed by sizeof. */
+/* The size of 'void *', as computed by sizeof. */
 #undef SIZEOF_VOID_P
 
-/* Define to 1 if all of the C90 standard headers exist (not just the ones
+/* Define to 1 if all of the C89 standard headers exist (not just the ones
    required in a freestanding environment). This macro is provided for
    backward compatibility; new code need not use it. */
 #undef STDC_HEADERS
@@ -813,7 +817,7 @@
 #endif
 
 
-/* Enable extensions on AIX 3, Interix.  */
+/* Enable extensions on AIX, Interix, z/OS.  */
 #ifndef _ALL_SOURCE
 # undef _ALL_SOURCE
 #endif
@@ -874,11 +878,15 @@
 #ifndef __STDC_WANT_IEC_60559_DFP_EXT__
 # undef __STDC_WANT_IEC_60559_DFP_EXT__
 #endif
+/* Enable extensions specified by C23 Annex F.  */
+#ifndef __STDC_WANT_IEC_60559_EXT__
+# undef __STDC_WANT_IEC_60559_EXT__
+#endif
 /* Enable extensions specified by ISO/IEC TS 18661-4:2015.  */
 #ifndef __STDC_WANT_IEC_60559_FUNCS_EXT__
 # undef __STDC_WANT_IEC_60559_FUNCS_EXT__
 #endif
-/* Enable extensions specified by ISO/IEC TS 18661-3:2015.  */
+/* Enable extensions specified by C23 Annex H and ISO/IEC TS 18661-3:2015.  */
 #ifndef __STDC_WANT_IEC_60559_TYPES_EXT__
 # undef __STDC_WANT_IEC_60559_TYPES_EXT__
 #endif
diff -pruN 2.10.0-1/include/private/cpuid-x86.h 2.11.0-1/include/private/cpuid-x86.h
--- 2.10.0-1/include/private/cpuid-x86.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/include/private/cpuid-x86.h	2024-06-17 10:01:23.000000000 +0000
@@ -11,6 +11,22 @@
 #ifndef HWLOC_PRIVATE_CPUID_X86_H
 #define HWLOC_PRIVATE_CPUID_X86_H
 
+/* A macro for annotating memory as uninitialized when building with MSAN
+ * (and otherwise having no effect). See below for why this is used with
+ * our custom assembly.
+ */
+#ifdef __has_feature
+#define HWLOC_HAS_FEATURE(name) __has_feature(name)
+#else
+#define HWLOC_HAS_FEATURE(name) 0
+#endif
+#if HWLOC_HAS_FEATURE(memory_sanitizer) || defined(MEMORY_SANITIZER)
+#include <sanitizer/msan_interface.h>
+#define HWLOC_ANNOTATE_MEMORY_IS_INITIALIZED(ptr, len) __msan_unpoison(ptr, len)
+#else
+#define HWLOC_ANNOTATE_MEMORY_IS_INITIALIZED(ptr, len)
+#endif
+
 #if (defined HWLOC_X86_32_ARCH) && (!defined HWLOC_HAVE_MSVC_CPUIDEX)
 static __hwloc_inline int hwloc_have_x86_cpuid(void)
 {
@@ -71,12 +87,18 @@ static __hwloc_inline void hwloc_x86_cpu
   "movl %k2,%1\n\t"
   : "+a" (*eax), "=m" (*ebx), "=&r"(sav_rbx),
     "+c" (*ecx), "=&d" (*edx));
+  /* MSAN does not recognize the effect of the above assembly on the memory operand
+   * (`"=m"(*ebx)`). This may get improved in MSAN at some point in the future, e.g.
+   * see https://github.com/llvm/llvm-project/pull/77393. */
+  HWLOC_ANNOTATE_MEMORY_IS_INITIALIZED(ebx, sizeof *ebx);
 #elif defined(HWLOC_X86_32_ARCH)
   __asm__(
   "mov %%ebx,%1\n\t"
   "cpuid\n\t"
   "xchg %%ebx,%1\n\t"
   : "+a" (*eax), "=&SD" (*ebx), "+c" (*ecx), "=&d" (*edx));
+  /* See above. */
+  HWLOC_ANNOTATE_MEMORY_IS_INITIALIZED(ebx, sizeof *ebx);
 #else
 #error unknown architecture
 #endif
diff -pruN 2.10.0-1/include/private/misc.h 2.11.0-1/include/private/misc.h
--- 2.10.0-1/include/private/misc.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/include/private/misc.h	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2019 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2012 Université Bordeaux
  * Copyright © 2011 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -573,4 +573,35 @@ typedef SSIZE_T ssize_t;
 #  endif
 #endif
 
+static __inline float
+hwloc__pci_link_speed(unsigned generation, unsigned lanes)
+{
+  float lanespeed;
+  /*
+   * These are single-direction bandwidths only.
+   *
+   * Gen1 used NRZ with 8/10 encoding.
+   * PCIe Gen1 = 2.5GT/s signal-rate per lane x 8/10    =  0.25GB/s data-rate per lane
+   * PCIe Gen2 = 5  GT/s signal-rate per lane x 8/10    =  0.5 GB/s data-rate per lane
+   * Gen3 switched to NRZ with 128/130 encoding.
+   * PCIe Gen3 = 8  GT/s signal-rate per lane x 128/130 =  1   GB/s data-rate per lane
+   * PCIe Gen4 = 16 GT/s signal-rate per lane x 128/130 =  2   GB/s data-rate per lane
+   * PCIe Gen5 = 32 GT/s signal-rate per lane x 128/130 =  4   GB/s data-rate per lane
+   * Gen6 switched to PAM with with 242/256 FLIT (242B payload protected by 8B CRC + 6B FEC).
+   * PCIe Gen6 = 64 GT/s signal-rate per lane x 242/256 =  8   GB/s data-rate per lane
+   * PCIe Gen7 = 128GT/s signal-rate per lane x 242/256 = 16   GB/s data-rate per lane
+   */
+
+  /* lanespeed in Gbit/s */
+  if (generation <= 2)
+    lanespeed = 2.5f * generation * 0.8f;
+  else if (generation <= 5)
+    lanespeed = 8.0f * (1<<(generation-3)) * 128/130;
+  else
+    lanespeed = 8.0f * (1<<(generation-3)) * 242/256; /* assume Gen8 will be 256 GT/s and so on */
+
+  /* linkspeed in GB/s */
+  return lanespeed * lanes / 8;
+}
+
 #endif /* HWLOC_PRIVATE_MISC_H */
diff -pruN 2.10.0-1/tests/hwloc/hwloc_bind.c 2.11.0-1/tests/hwloc/hwloc_bind.c
--- 2.10.0-1/tests/hwloc/hwloc_bind.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/hwloc_bind.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2015 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2011 Université Bordeaux
  * Copyright © 2011 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -128,6 +128,8 @@ static void testmem2(hwloc_const_bitmap_
   testmem(set, HWLOC_MEMBIND_BIND, flags, support->membind->bind_membind);
   printf("  interleave\n");
   testmem(set, HWLOC_MEMBIND_INTERLEAVE, flags, support->membind->interleave_membind);
+  printf("  weighted interleave\n");
+  testmem(set, HWLOC_MEMBIND_WEIGHTED_INTERLEAVE, flags, support->membind->weighted_interleave_membind);
   printf("  nexttouch\n");
   testmem(set, HWLOC_MEMBIND_NEXTTOUCH, flags, support->membind->nexttouch_membind);
 }
diff -pruN 2.10.0-1/tests/hwloc/hwloc_bitmap_string.c 2.11.0-1/tests/hwloc/hwloc_bitmap_string.c
--- 2.10.0-1/tests/hwloc/hwloc_bitmap_string.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/hwloc_bitmap_string.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,7 +1,7 @@
 
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2017 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009 Université Bordeaux
  * Copyright © 2011 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -103,6 +103,22 @@ int main(void)
   hwloc_bitmap_free(set);
   printf("infinite/nonfull cpuset converted back and forth, ok\n");
 
+  /* check an infinite (but non full) cpuset with even number of substrings */
+  set = hwloc_bitmap_alloc_full();
+  hwloc_bitmap_clr_range(set, 0, 127);
+  hwloc_bitmap_set_range(set, 4, 7);
+  check_cpuset(set, "0xf...f,,,,0x000000f0", "4-7,128-", "0xf...f000000000000000000000000000000f0");
+  hwloc_bitmap_free(set);
+  printf("infinite/nonfull cpuset with even number of substrings converted back and forth, ok\n");
+
+  /* check an infinite (but non full) cpuset with odd number of substrings */
+  set = hwloc_bitmap_alloc_full();
+  hwloc_bitmap_clr_range(set, 0, 159);
+  hwloc_bitmap_set_range(set, 4, 7);
+  check_cpuset(set, "0xf...f,,,,,0x000000f0", "4-7,160-", "0xf...f00000000000000000000000000000000000000f0");
+  hwloc_bitmap_free(set);
+  printf("infinite/nonfull cpuset with odd number of substrings converted back and forth, ok\n");
+
   /* check an finite cpuset */
   set = hwloc_bitmap_alloc();
   hwloc_bitmap_set(set, 2);
diff -pruN 2.10.0-1/tests/hwloc/hwloc_groups.c 2.11.0-1/tests/hwloc/hwloc_groups.c
--- 2.10.0-1/tests/hwloc/hwloc_groups.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/hwloc_groups.c	2024-06-17 10:01:23.000000000 +0000
@@ -46,6 +46,8 @@ int main(void)
   group = hwloc_topology_alloc_group_object(topology);
   assert(group);
   group->cpuset = hwloc_bitmap_dup(root->cpuset);
+  err = hwloc_obj_set_subtype(topology, group, "will be merged");
+  assert(!err);
   res = hwloc_topology_insert_group_object(topology, group);
   assert(res);
   assert(res == root);
@@ -56,6 +58,13 @@ int main(void)
   obj = hwloc_get_obj_by_type(topology, HWLOC_OBJ_PACKAGE, 1);
   assert(obj);
   group->cpuset = hwloc_bitmap_dup(obj->cpuset);
+  /* play with its subtype first */
+  err = hwloc_obj_set_subtype(topology, group, NULL);
+  assert(!err);
+  err = hwloc_obj_set_subtype(topology, group, "will be merged");
+  assert(!err);
+  err = hwloc_obj_set_subtype(topology, group, NULL);
+  assert(!err);
   res = hwloc_topology_insert_group_object(topology, group);
   assert(res);
   assert(res == obj);
@@ -69,6 +78,8 @@ int main(void)
   obj = hwloc_get_obj_by_type(topology, HWLOC_OBJ_PU, 12);
   assert(obj);
   hwloc_bitmap_or(group->cpuset, group->cpuset, obj->cpuset);
+  err = hwloc_obj_set_subtype(topology, group, "will fail");
+  assert(!err);
   res = hwloc_topology_insert_group_object(topology, group);
   assert(!res);
   assert(hwloc_topology_get_depth(topology) == 3);
@@ -82,6 +93,8 @@ int main(void)
   assert(obj);
   hwloc_bitmap_or(group->cpuset, group->cpuset, obj->cpuset);
   group->attr->group.kind = (unsigned)-1;
+  err = hwloc_obj_set_subtype(topology, group, "will be merged later");
+  assert(!err);
   res = hwloc_topology_insert_group_object(topology, group);
   assert(res == group);
   saved = group;
@@ -96,9 +109,13 @@ int main(void)
   assert(obj);
   hwloc_bitmap_or(group->cpuset, group->cpuset, obj->cpuset);
   group->attr->group.kind = 0;
+  err = hwloc_obj_set_subtype(topology, group, "will replace previous one");
+  assert(!err);
   res = hwloc_topology_insert_group_object(topology, group);
   assert(res == saved); /* the core should move the contents of this new group into a previous one */
   assert(res != group);
+  assert(res->subtype);
+  assert(!strcmp(res->subtype, "will replace previous one"));
   assert(hwloc_topology_get_depth(topology) == 4);
   /* insert yet another same group with higher kind, it will be dropped in favor of the previous-previous one */
   group = hwloc_topology_alloc_group_object(topology);
@@ -110,9 +127,13 @@ int main(void)
   assert(obj);
   hwloc_bitmap_or(group->cpuset, group->cpuset, obj->cpuset);
   group->attr->group.kind = (unsigned)-1;
+  err = hwloc_obj_set_subtype(topology, group, "will be merged in previous one");
+  assert(!err);
   res = hwloc_topology_insert_group_object(topology, group);
   assert(res == saved);
   assert(res != group);
+  assert(res->subtype);
+  assert(!strcmp(res->subtype, "will replace previous one"));
   assert(hwloc_topology_get_depth(topology) == 4);
   /* insert a conflict group of two packages by nodeset, will fail */
   group = hwloc_topology_alloc_group_object(topology);
diff -pruN 2.10.0-1/tests/hwloc/hwloc_topology_abi.c 2.11.0-1/tests/hwloc/hwloc_topology_abi.c
--- 2.10.0-1/tests/hwloc/hwloc_topology_abi.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/hwloc_topology_abi.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * Copyright © 2017-2023 Inria.  All rights reserved.
+ * Copyright © 2017-2024 Inria.  All rights reserved.
  * See COPYING in top-level directory.
  */
 
@@ -164,7 +164,7 @@ int main(void)
     size = sizeof(struct hwloc_topology_cpubind_support);
     assert(size == 11);
     size = sizeof(struct hwloc_topology_membind_support);
-    assert(size == 15);
+    assert(size == 16);
     size = sizeof(struct hwloc_topology_misc_support);
     assert(size == 1);
 
diff -pruN 2.10.0-1/tests/hwloc/linux/64intel64-fakeKNL-SNC4-hybrid-msc.output 2.11.0-1/tests/hwloc/linux/64intel64-fakeKNL-SNC4-hybrid-msc.output
--- 2.10.0-1/tests/hwloc/linux/64intel64-fakeKNL-SNC4-hybrid-msc.output	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/linux/64intel64-fakeKNL-SNC4-hybrid-msc.output	2024-06-17 10:01:23.000000000 +0000
@@ -1,4 +1,4 @@
-Machine (P#0 total=12582912KB ClusterMode=SNC4 MemoryMode=Hybrid50 Backend=Linux OSName=Linux OSRelease=3.10.0-327.el7.x86_64 OSVersion="#1 SMP Thu Oct 29 17:29:29 EDT 2015" HostName=localhost.localdomain Architecture=x86_64)
+Machine (P#0 total=12582912KB ClusterMode=SNC4 MemoryMode=Hybrid50 Backend=Linux OSName=Linux OSRelease=3.10.0-327.el7.x86_64 OSVersion="#1 SMP Thu Oct 29 17:29:29 EDT 2015" HostName=localhost.localdomain Architecture=x86_64 MemoryTiersNr=2)
   Package L#0 (P#0 total=12582912KB CPUVendor=GenuineIntel CPUFamilyNumber=6 CPUModelNumber=87 CPUModel=06/57 CPUStepping=0)
     Group0(Cluster) L#0 (total=3145728KB)
       MemCache L#0 (total=1048576KB size=2097152KB linesize=64 ways=1 Inclusive=1)
diff -pruN 2.10.0-1/tests/hwloc/linux/64intel64-fakeKNL-SNC4-hybrid.output 2.11.0-1/tests/hwloc/linux/64intel64-fakeKNL-SNC4-hybrid.output
--- 2.10.0-1/tests/hwloc/linux/64intel64-fakeKNL-SNC4-hybrid.output	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/linux/64intel64-fakeKNL-SNC4-hybrid.output	2024-06-17 10:01:23.000000000 +0000
@@ -1,4 +1,4 @@
-Machine (P#0 total=12582912KB ClusterMode=SNC4 MemoryMode=Hybrid50 Backend=Linux OSName=Linux OSRelease=3.10.0-327.el7.x86_64 OSVersion="#1 SMP Thu Oct 29 17:29:29 EDT 2015" HostName=localhost.localdomain Architecture=x86_64)
+Machine (P#0 total=12582912KB ClusterMode=SNC4 MemoryMode=Hybrid50 Backend=Linux OSName=Linux OSRelease=3.10.0-327.el7.x86_64 OSVersion="#1 SMP Thu Oct 29 17:29:29 EDT 2015" HostName=localhost.localdomain Architecture=x86_64 MemoryTiersNr=2)
   Package L#0 (P#0 total=12582912KB CPUVendor=GenuineIntel CPUFamilyNumber=6 CPUModelNumber=87 CPUModel=06/57 CPUStepping=0)
     L3Cache(MemorySideCache) L#0 (total=3145728KB size=2097152KB linesize=64 ways=1 Inclusive=1)
       NUMANode(DRAM) L#0 (P#0 local=1048576KB total=1048576KB MemoryTier=1)
diff -pruN 2.10.0-1/tests/hwloc/linux/fakeheteromemtiers.output 2.11.0-1/tests/hwloc/linux/fakeheteromemtiers.output
--- 2.10.0-1/tests/hwloc/linux/fakeheteromemtiers.output	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/linux/fakeheteromemtiers.output	2024-06-17 10:01:23.000000000 +0000
@@ -1,4 +1,4 @@
-Machine (P#0 total=6236076KB DMIProductName="Standard PC (i440FX + PIIX, 1996)" DMIProductVersion=pc-i440fx-7.0 DMIProductSerial= DMIChassisVendor=QEMU DMIChassisType=1 DMIChassisVersion=pc-i440fx-7.0 DMIChassisSerial= DMIChassisAssetTag= DMIBIOSVendor="EFI Development Kit II / OVMF" DMIBIOSVersion=0.0.0 DMIBIOSDate=02/06/2015 DMISysVendor=QEMU Backend=Linux LinuxCgroup=/ OSName=Linux OSRelease=5.18.0-rc4 OSVersion="#1 SMP PREEMPT_DYNAMIC Tue Apr 26 11:49:51 CEST 2022" HostName=efi Architecture=x86_64)
+Machine (P#0 total=6236076KB DMIProductName="Standard PC (i440FX + PIIX, 1996)" DMIProductVersion=pc-i440fx-7.0 DMIProductSerial= DMIChassisVendor=QEMU DMIChassisType=1 DMIChassisVersion=pc-i440fx-7.0 DMIChassisSerial= DMIChassisAssetTag= DMIBIOSVendor="EFI Development Kit II / OVMF" DMIBIOSVersion=0.0.0 DMIBIOSDate=02/06/2015 DMISysVendor=QEMU Backend=Linux LinuxCgroup=/ OSName=Linux OSRelease=5.18.0-rc4 OSVersion="#1 SMP PREEMPT_DYNAMIC Tue Apr 26 11:49:51 CEST 2022" HostName=efi Architecture=x86_64 MemoryTiersNr=3)
   Package L#0 (P#0 total=6236076KB CPUVendor=GenuineIntel CPUFamilyNumber=15 CPUModelNumber=107 CPUModel="QEMU Virtual CPU version 2.5+" CPUStepping=1)
     L3Cache L#0 (P#0 total=6236076KB size=16384KB linesize=64 ways=16)
       Group0 L#0 (total=3398608KB)
diff -pruN 2.10.0-1/tests/hwloc/linux/fakememinitiators-1np2c+1npp+gi.output 2.11.0-1/tests/hwloc/linux/fakememinitiators-1np2c+1npp+gi.output
--- 2.10.0-1/tests/hwloc/linux/fakememinitiators-1np2c+1npp+gi.output	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/linux/fakememinitiators-1np2c+1npp+gi.output	2024-06-17 10:01:23.000000000 +0000
@@ -1,4 +1,4 @@
-Machine (P#0 total=1951314696KB Backend=Linux LinuxCgroup=/)
+Machine (P#0 total=1951314696KB Backend=Linux LinuxCgroup=/ MemoryTiersNr=2)
   Package L#0 (P#0 total=974581080KB CPUModel="Intel(R) Xeon(R) Gold 6230 CPU @ 2.10GHz")
     NUMANode(NVM) L#2 (P#7 local=778043392KB total=778043392KB DAXDevice=dax0.0 DAXType=NVM DAXParent=LNXSYSTM:00/LNXSYBUS:00/ACPI0012:00/ndbus0/region0/dax0.1 MemoryTier=1)
     Group0 L#0 (total=97447340KB)
diff -pruN 2.10.0-1/tests/hwloc/linux/nvidiagpunumanodes.kept.output 2.11.0-1/tests/hwloc/linux/nvidiagpunumanodes.kept.output
--- 2.10.0-1/tests/hwloc/linux/nvidiagpunumanodes.kept.output	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/linux/nvidiagpunumanodes.kept.output	2024-06-17 10:01:23.000000000 +0000
@@ -1,4 +1,4 @@
-Machine (P#0 total=358162944KB PlatformName=PowerNV PlatformModel="PowerNV 8335-GTW" Backend=Linux LinuxCgroup=/jjh OSName=Linux OSRelease=4.14.0-49.el7a.bz1553205.page_fault_hang.ppc64le OSVersion="#1 SMP Fri Mar 30 12:06:11 CDT 2018" HostName=c685f8n02 Architecture=ppc64le)
+Machine (P#0 total=358162944KB PlatformName=PowerNV PlatformModel="PowerNV 8335-GTW" Backend=Linux LinuxCgroup=/jjh OSName=Linux OSRelease=4.14.0-49.el7a.bz1553205.page_fault_hang.ppc64le OSVersion="#1 SMP Fri Mar 30 12:06:11 CDT 2018" HostName=c685f8n02 Architecture=ppc64le MemoryTiersNr=2)
   Package L#0 (P#0 total=177025024KB CPUModel="POWER9, altivec supported" CPURevision="2.1 (pvr 004e 1201)")
     NUMANode L#0 (P#0 local=129839104KB total=129839104KB MemoryTier=0)
     NUMANode(GPUMemory) L#1 (P#253 local=15728640KB total=15728640KB PCIBusID=0006:00:00.0 MemoryTier=1)
diff -pruN 2.10.0-1/tests/hwloc/ports/include/nvml/nvml.h 2.11.0-1/tests/hwloc/ports/include/nvml/nvml.h
--- 2.10.0-1/tests/hwloc/ports/include/nvml/nvml.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/ports/include/nvml/nvml.h	2024-06-17 10:01:23.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * Copyright © 2013-2020 Inria.  All rights reserved.
+ * Copyright © 2013-2024 Inria.  All rights reserved.
  * See COPYING in top-level directory.
  */
 
@@ -10,8 +10,10 @@
 #ifndef HWLOC_CONFIGURE_H
 #error nvml.h must be included after private/autogen/config.h
 #endif
-#undef HAVE_DECL_NVMLDEVICEGETMAXPCIELINKGENERATION
-#define HAVE_DECL_NVMLDEVICEGETMAXPCIELINKGENERATION 1
+#undef HAVE_DECL_NVMLDEVICEGETCURRPCIELINKGENERATION
+#define HAVE_DECL_NVMLDEVICEGETCURRPCIELINKGENERATION 1
+#undef HAVE_DECL_NVMLDEVICEGETNVLINKREMOTEDEVICETYPE
+#define HAVE_DECL_NVMLDEVICEGETNVLINKREMOTEDEVICETYPE 1
 
 
 typedef int nvmlReturn_t;
@@ -23,6 +25,13 @@ typedef struct nvmlPciInfo_st {
   unsigned int device;
 } nvmlPciInfo_t;
 
+typedef enum nvmlIntNvLinkDeviceType_enum {
+  NVML_NVLINK_DEVICE_TYPE_GPU     = 0x00,
+  NVML_NVLINK_DEVICE_TYPE_IBMNPU  = 0x01,
+  NVML_NVLINK_DEVICE_TYPE_SWITCH  = 0x02,
+  NVML_NVLINK_DEVICE_TYPE_UNKNOWN = 0xFF
+} nvmlIntNvLinkDeviceType_t;
+
 struct nvmlDevice_st;
 typedef struct nvmlDevice_st* nvmlDevice_t;
 
@@ -35,8 +44,8 @@ nvmlReturn_t nvmlDeviceGetPciInfo(nvmlDe
 nvmlReturn_t nvmlDeviceGetName(nvmlDevice_t device, char *name, unsigned int length);
 nvmlReturn_t nvmlDeviceGetSerial(nvmlDevice_t device, char *serial, unsigned int length);
 nvmlReturn_t nvmlDeviceGetUUID(nvmlDevice_t device, char *uuid, unsigned int length);
-nvmlReturn_t nvmlDeviceGetMaxPcieLinkGeneration(nvmlDevice_t device, unsigned int *maxLinkGen);
-nvmlReturn_t nvmlDeviceGetMaxPcieLinkWidth(nvmlDevice_t device, unsigned int *maxLinkGen);
+nvmlReturn_t nvmlDeviceGetCurrPcieLinkGeneration(nvmlDevice_t device, unsigned int *maxLinkGen);
+nvmlReturn_t nvmlDeviceGetCurrPcieLinkWidth(nvmlDevice_t device, unsigned int *maxLinkGen);
 
 #define NVML_NVLINK_MAX_LINKS 6
 typedef unsigned nvmlEnableState_t;
@@ -44,5 +53,6 @@ typedef unsigned nvmlEnableState_t;
 nvmlReturn_t nvmlDeviceGetNvLinkState(nvmlDevice_t device, unsigned int link, nvmlEnableState_t * isActive);
 nvmlReturn_t nvmlDeviceGetNvLinkVersion(nvmlDevice_t device, unsigned int  link, unsigned int* version);
 nvmlReturn_t nvmlDeviceGetNvLinkRemotePciInfo(nvmlDevice_t device, unsigned int link, nvmlPciInfo_t * pci);
+nvmlReturn_t nvmlDeviceGetNvLinkRemoteDeviceType(nvmlDevice_t device, unsigned int link, nvmlIntNvLinkDeviceType_t *pNvLinkDeviceType);
 
 #endif /* HWLOC_PORT_NVML_NVML_H */
diff -pruN 2.10.0-1/tests/hwloc/ports/include/windows/windows.h 2.11.0-1/tests/hwloc/ports/include/windows/windows.h
--- 2.10.0-1/tests/hwloc/ports/include/windows/windows.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/ports/include/windows/windows.h	2024-06-17 10:01:23.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * Copyright © 2009-2020 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2012 Université Bordeaux
  * See COPYING in top-level directory.
  */
@@ -286,6 +286,8 @@ int WINAPI GetSystemMetrics(int nIndex);
 
 ATOM WINAPI RegisterClass(const WNDCLASS *lpWndClass);
 
+#define TEXT(str) (str)
+
 /* hide Linux' host disabling _SC_LARGE_PAGESIZE */
 #undef HAVE_DECL__SC_LARGE_PAGESIZE
 #define HAVE_DECL__SC_LARGE_PAGESIZE 1
diff -pruN 2.10.0-1/tests/hwloc/x86/Makefile.am 2.11.0-1/tests/hwloc/x86/Makefile.am
--- 2.10.0-1/tests/hwloc/x86/Makefile.am	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/x86/Makefile.am	2024-06-17 10:01:23.000000000 +0000
@@ -1,4 +1,4 @@
-# Copyright © 2015-2022 Inria.  All rights reserved.
+# Copyright © 2015-2024 Inria.  All rights reserved.
 # See COPYING in top-level directory.
 
 AM_CFLAGS = $(HWLOC_CFLAGS)
@@ -38,6 +38,7 @@ cpuid_outputs = \
 	AMD-K8-SledgeHammer-2xOpteron-250.output \
 	Hygon-Dhyana-32cores.output \
 	Zhaoxin-CentaurHauls-ZXD-4600.output \
+	Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.output \
 	Zhaoxin-Shanghai-KaiSheng-ZXC+-FC1081.output
 
 # FIXME add AMD-K10-Shanghai/Barcelona-[248]3xx
@@ -72,6 +73,7 @@ cpuid_tarballs = \
 	AMD-K8-SledgeHammer-2xOpteron-250.tar.bz2 \
 	Hygon-Dhyana-32cores.tar.bz2 \
 	Zhaoxin-CentaurHauls-ZXD-4600.tar.bz2 \
+	Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.tar.bz2 \
 	Zhaoxin-Shanghai-KaiSheng-ZXC+-FC1081.tar.bz2
 
 # Each output `xyz.output' may have a corresponding `xyz.options'
diff -pruN 2.10.0-1/tests/hwloc/x86/Makefile.in 2.11.0-1/tests/hwloc/x86/Makefile.in
--- 2.10.0-1/tests/hwloc/x86/Makefile.in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/tests/hwloc/x86/Makefile.in	2024-06-25 12:41:55.000000000 +0000
@@ -14,7 +14,7 @@
 
 @SET_MAKE@
 
-# Copyright © 2015-2022 Inria.  All rights reserved.
+# Copyright © 2015-2024 Inria.  All rights reserved.
 # See COPYING in top-level directory.
 VPATH = @srcdir@
 am__is_gnu_make = { \
@@ -598,6 +598,7 @@ cpuid_outputs = \
 	AMD-K8-SledgeHammer-2xOpteron-250.output \
 	Hygon-Dhyana-32cores.output \
 	Zhaoxin-CentaurHauls-ZXD-4600.output \
+	Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.output \
 	Zhaoxin-Shanghai-KaiSheng-ZXC+-FC1081.output
 
 
@@ -633,6 +634,7 @@ cpuid_tarballs = \
 	AMD-K8-SledgeHammer-2xOpteron-250.tar.bz2 \
 	Hygon-Dhyana-32cores.tar.bz2 \
 	Zhaoxin-CentaurHauls-ZXD-4600.tar.bz2 \
+	Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.tar.bz2 \
 	Zhaoxin-Shanghai-KaiSheng-ZXC+-FC1081.tar.bz2
 
 
@@ -1023,6 +1025,13 @@ Zhaoxin-CentaurHauls-ZXD-4600.output.log
 	$(am__check_pre) $(LOG_DRIVER) --test-name "$$f" \
 	--log-file $$b.log --trs-file $$b.trs \
 	$(am__common_driver_flags) $(AM_LOG_DRIVER_FLAGS) $(LOG_DRIVER_FLAGS) -- $(LOG_COMPILE) \
+	"$$tst" $(AM_TESTS_FD_REDIRECT)
+Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.output.log: Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.output
+	@p='Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.output'; \
+	b='Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.output'; \
+	$(am__check_pre) $(LOG_DRIVER) --test-name "$$f" \
+	--log-file $$b.log --trs-file $$b.trs \
+	$(am__common_driver_flags) $(AM_LOG_DRIVER_FLAGS) $(LOG_DRIVER_FLAGS) -- $(LOG_COMPILE) \
 	"$$tst" $(AM_TESTS_FD_REDIRECT)
 Zhaoxin-Shanghai-KaiSheng-ZXC+-FC1081.output.log: Zhaoxin-Shanghai-KaiSheng-ZXC+-FC1081.output
 	@p='Zhaoxin-Shanghai-KaiSheng-ZXC+-FC1081.output'; \
diff -pruN 2.10.0-1/tests/hwloc/x86/Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.output 2.11.0-1/tests/hwloc/x86/Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.output
--- 2.10.0-1/tests/hwloc/x86/Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.output	1970-01-01 00:00:00.000000000 +0000
+++ 2.11.0-1/tests/hwloc/x86/Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.output	2024-06-17 10:01:23.000000000 +0000
@@ -0,0 +1,846 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE topology SYSTEM "hwloc2.dtd">
+<topology version="2.0">
+  <object type="Machine" os_index="0" cpuset="0xffffffff,0xffffffff" complete_cpuset="0xffffffff,0xffffffff" allowed_cpuset="0xffffffff,0xffffffff" nodeset="0x00000001" complete_nodeset="0x00000001" allowed_nodeset="0x00000001">
+    <info name="Backend" value="x86"/>
+    <object type="NUMANode" os_index="0" cpuset="0xffffffff,0xffffffff" complete_cpuset="0xffffffff,0xffffffff" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+    <object type="Package" os_index="0" cpuset="0xffffffff" complete_cpuset="0xffffffff" nodeset="0x00000001" complete_nodeset="0x00000001">
+      <info name="CPUVendor" value="CentaurHauls"/>
+      <info name="CPUFamilyNumber" value="7"/>
+      <info name="CPUModelNumber" value="91"/>
+      <info name="CPUModel" value="ZHAOXIN KaiSheng KH-40000/32@2GHz"/>
+      <info name="CPUStepping" value="11"/>
+      <object type="Die" os_index="0" cpuset="0x0000ffff" complete_cpuset="0x0000ffff" nodeset="0x00000001" complete_nodeset="0x00000001">
+        <object type="L3Cache" cpuset="0x0000000f" complete_cpuset="0x0000000f" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00000001" complete_cpuset="0x00000001" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000001" complete_cpuset="0x00000001" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000001" complete_cpuset="0x00000001" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="0" cpuset="0x00000001" complete_cpuset="0x00000001" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="0" cpuset="0x00000001" complete_cpuset="0x00000001" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000002" complete_cpuset="0x00000002" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000002" complete_cpuset="0x00000002" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000002" complete_cpuset="0x00000002" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="1" cpuset="0x00000002" complete_cpuset="0x00000002" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="1" cpuset="0x00000002" complete_cpuset="0x00000002" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000004" complete_cpuset="0x00000004" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000004" complete_cpuset="0x00000004" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000004" complete_cpuset="0x00000004" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="2" cpuset="0x00000004" complete_cpuset="0x00000004" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="2" cpuset="0x00000004" complete_cpuset="0x00000004" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000008" complete_cpuset="0x00000008" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000008" complete_cpuset="0x00000008" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000008" complete_cpuset="0x00000008" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="3" cpuset="0x00000008" complete_cpuset="0x00000008" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="3" cpuset="0x00000008" complete_cpuset="0x00000008" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0x000000f0" complete_cpuset="0x000000f0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00000010" complete_cpuset="0x00000010" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000010" complete_cpuset="0x00000010" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000010" complete_cpuset="0x00000010" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="4" cpuset="0x00000010" complete_cpuset="0x00000010" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="4" cpuset="0x00000010" complete_cpuset="0x00000010" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000020" complete_cpuset="0x00000020" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000020" complete_cpuset="0x00000020" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000020" complete_cpuset="0x00000020" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="5" cpuset="0x00000020" complete_cpuset="0x00000020" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="5" cpuset="0x00000020" complete_cpuset="0x00000020" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000040" complete_cpuset="0x00000040" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000040" complete_cpuset="0x00000040" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000040" complete_cpuset="0x00000040" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="6" cpuset="0x00000040" complete_cpuset="0x00000040" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="6" cpuset="0x00000040" complete_cpuset="0x00000040" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000080" complete_cpuset="0x00000080" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000080" complete_cpuset="0x00000080" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000080" complete_cpuset="0x00000080" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="7" cpuset="0x00000080" complete_cpuset="0x00000080" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="7" cpuset="0x00000080" complete_cpuset="0x00000080" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0x00000f00" complete_cpuset="0x00000f00" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00000100" complete_cpuset="0x00000100" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000100" complete_cpuset="0x00000100" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000100" complete_cpuset="0x00000100" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="8" cpuset="0x00000100" complete_cpuset="0x00000100" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="8" cpuset="0x00000100" complete_cpuset="0x00000100" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000200" complete_cpuset="0x00000200" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000200" complete_cpuset="0x00000200" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000200" complete_cpuset="0x00000200" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="9" cpuset="0x00000200" complete_cpuset="0x00000200" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="9" cpuset="0x00000200" complete_cpuset="0x00000200" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000400" complete_cpuset="0x00000400" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000400" complete_cpuset="0x00000400" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000400" complete_cpuset="0x00000400" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="10" cpuset="0x00000400" complete_cpuset="0x00000400" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="10" cpuset="0x00000400" complete_cpuset="0x00000400" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000800" complete_cpuset="0x00000800" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000800" complete_cpuset="0x00000800" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000800" complete_cpuset="0x00000800" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="11" cpuset="0x00000800" complete_cpuset="0x00000800" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="11" cpuset="0x00000800" complete_cpuset="0x00000800" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0x0000f000" complete_cpuset="0x0000f000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00001000" complete_cpuset="0x00001000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00001000" complete_cpuset="0x00001000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00001000" complete_cpuset="0x00001000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="12" cpuset="0x00001000" complete_cpuset="0x00001000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="12" cpuset="0x00001000" complete_cpuset="0x00001000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00002000" complete_cpuset="0x00002000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00002000" complete_cpuset="0x00002000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00002000" complete_cpuset="0x00002000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="13" cpuset="0x00002000" complete_cpuset="0x00002000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="13" cpuset="0x00002000" complete_cpuset="0x00002000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00004000" complete_cpuset="0x00004000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00004000" complete_cpuset="0x00004000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00004000" complete_cpuset="0x00004000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="14" cpuset="0x00004000" complete_cpuset="0x00004000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="14" cpuset="0x00004000" complete_cpuset="0x00004000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00008000" complete_cpuset="0x00008000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00008000" complete_cpuset="0x00008000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00008000" complete_cpuset="0x00008000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="15" cpuset="0x00008000" complete_cpuset="0x00008000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="15" cpuset="0x00008000" complete_cpuset="0x00008000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+      </object>
+      <object type="Die" os_index="1" cpuset="0xffff0000" complete_cpuset="0xffff0000" nodeset="0x00000001" complete_nodeset="0x00000001">
+        <object type="L3Cache" cpuset="0x000f0000" complete_cpuset="0x000f0000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00010000" complete_cpuset="0x00010000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00010000" complete_cpuset="0x00010000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00010000" complete_cpuset="0x00010000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="16" cpuset="0x00010000" complete_cpuset="0x00010000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="16" cpuset="0x00010000" complete_cpuset="0x00010000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00020000" complete_cpuset="0x00020000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00020000" complete_cpuset="0x00020000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00020000" complete_cpuset="0x00020000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="17" cpuset="0x00020000" complete_cpuset="0x00020000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="17" cpuset="0x00020000" complete_cpuset="0x00020000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00040000" complete_cpuset="0x00040000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00040000" complete_cpuset="0x00040000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00040000" complete_cpuset="0x00040000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="18" cpuset="0x00040000" complete_cpuset="0x00040000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="18" cpuset="0x00040000" complete_cpuset="0x00040000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00080000" complete_cpuset="0x00080000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00080000" complete_cpuset="0x00080000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00080000" complete_cpuset="0x00080000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="19" cpuset="0x00080000" complete_cpuset="0x00080000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="19" cpuset="0x00080000" complete_cpuset="0x00080000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0x00f00000" complete_cpuset="0x00f00000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00100000" complete_cpuset="0x00100000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00100000" complete_cpuset="0x00100000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00100000" complete_cpuset="0x00100000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="20" cpuset="0x00100000" complete_cpuset="0x00100000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="20" cpuset="0x00100000" complete_cpuset="0x00100000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00200000" complete_cpuset="0x00200000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00200000" complete_cpuset="0x00200000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00200000" complete_cpuset="0x00200000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="21" cpuset="0x00200000" complete_cpuset="0x00200000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="21" cpuset="0x00200000" complete_cpuset="0x00200000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00400000" complete_cpuset="0x00400000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00400000" complete_cpuset="0x00400000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00400000" complete_cpuset="0x00400000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="22" cpuset="0x00400000" complete_cpuset="0x00400000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="22" cpuset="0x00400000" complete_cpuset="0x00400000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00800000" complete_cpuset="0x00800000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00800000" complete_cpuset="0x00800000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00800000" complete_cpuset="0x00800000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="23" cpuset="0x00800000" complete_cpuset="0x00800000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="23" cpuset="0x00800000" complete_cpuset="0x00800000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0x0f000000" complete_cpuset="0x0f000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x01000000" complete_cpuset="0x01000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x01000000" complete_cpuset="0x01000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x01000000" complete_cpuset="0x01000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="24" cpuset="0x01000000" complete_cpuset="0x01000000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="24" cpuset="0x01000000" complete_cpuset="0x01000000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x02000000" complete_cpuset="0x02000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x02000000" complete_cpuset="0x02000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x02000000" complete_cpuset="0x02000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="25" cpuset="0x02000000" complete_cpuset="0x02000000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="25" cpuset="0x02000000" complete_cpuset="0x02000000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x04000000" complete_cpuset="0x04000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x04000000" complete_cpuset="0x04000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x04000000" complete_cpuset="0x04000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="26" cpuset="0x04000000" complete_cpuset="0x04000000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="26" cpuset="0x04000000" complete_cpuset="0x04000000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x08000000" complete_cpuset="0x08000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x08000000" complete_cpuset="0x08000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x08000000" complete_cpuset="0x08000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="27" cpuset="0x08000000" complete_cpuset="0x08000000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="27" cpuset="0x08000000" complete_cpuset="0x08000000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0xf0000000" complete_cpuset="0xf0000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x10000000" complete_cpuset="0x10000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x10000000" complete_cpuset="0x10000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x10000000" complete_cpuset="0x10000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="28" cpuset="0x10000000" complete_cpuset="0x10000000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="28" cpuset="0x10000000" complete_cpuset="0x10000000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x20000000" complete_cpuset="0x20000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x20000000" complete_cpuset="0x20000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x20000000" complete_cpuset="0x20000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="29" cpuset="0x20000000" complete_cpuset="0x20000000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="29" cpuset="0x20000000" complete_cpuset="0x20000000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x40000000" complete_cpuset="0x40000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x40000000" complete_cpuset="0x40000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x40000000" complete_cpuset="0x40000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="30" cpuset="0x40000000" complete_cpuset="0x40000000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="30" cpuset="0x40000000" complete_cpuset="0x40000000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x80000000" complete_cpuset="0x80000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x80000000" complete_cpuset="0x80000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x80000000" complete_cpuset="0x80000000" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="31" cpuset="0x80000000" complete_cpuset="0x80000000" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="31" cpuset="0x80000000" complete_cpuset="0x80000000" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+      </object>
+    </object>
+    <object type="Package" os_index="1" cpuset="0xffffffff,0x0" complete_cpuset="0xffffffff,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+      <info name="CPUVendor" value="CentaurHauls"/>
+      <info name="CPUFamilyNumber" value="7"/>
+      <info name="CPUModelNumber" value="91"/>
+      <info name="CPUModel" value="ZHAOXIN KaiSheng KH-40000/32@2GHz"/>
+      <info name="CPUStepping" value="11"/>
+      <object type="Die" os_index="0" cpuset="0x0000ffff,0x0" complete_cpuset="0x0000ffff,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+        <object type="L3Cache" cpuset="0x0000000f,0x0" complete_cpuset="0x0000000f,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00000001,0x0" complete_cpuset="0x00000001,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000001,0x0" complete_cpuset="0x00000001,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000001,0x0" complete_cpuset="0x00000001,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="0" cpuset="0x00000001,0x0" complete_cpuset="0x00000001,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="32" cpuset="0x00000001,0x0" complete_cpuset="0x00000001,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000002,0x0" complete_cpuset="0x00000002,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000002,0x0" complete_cpuset="0x00000002,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000002,0x0" complete_cpuset="0x00000002,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="1" cpuset="0x00000002,0x0" complete_cpuset="0x00000002,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="33" cpuset="0x00000002,0x0" complete_cpuset="0x00000002,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000004,0x0" complete_cpuset="0x00000004,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000004,0x0" complete_cpuset="0x00000004,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000004,0x0" complete_cpuset="0x00000004,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="2" cpuset="0x00000004,0x0" complete_cpuset="0x00000004,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="34" cpuset="0x00000004,0x0" complete_cpuset="0x00000004,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000008,0x0" complete_cpuset="0x00000008,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000008,0x0" complete_cpuset="0x00000008,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000008,0x0" complete_cpuset="0x00000008,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="3" cpuset="0x00000008,0x0" complete_cpuset="0x00000008,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="35" cpuset="0x00000008,0x0" complete_cpuset="0x00000008,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0x000000f0,0x0" complete_cpuset="0x000000f0,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00000010,0x0" complete_cpuset="0x00000010,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000010,0x0" complete_cpuset="0x00000010,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000010,0x0" complete_cpuset="0x00000010,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="4" cpuset="0x00000010,0x0" complete_cpuset="0x00000010,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="36" cpuset="0x00000010,0x0" complete_cpuset="0x00000010,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000020,0x0" complete_cpuset="0x00000020,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000020,0x0" complete_cpuset="0x00000020,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000020,0x0" complete_cpuset="0x00000020,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="5" cpuset="0x00000020,0x0" complete_cpuset="0x00000020,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="37" cpuset="0x00000020,0x0" complete_cpuset="0x00000020,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000040,0x0" complete_cpuset="0x00000040,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000040,0x0" complete_cpuset="0x00000040,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000040,0x0" complete_cpuset="0x00000040,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="6" cpuset="0x00000040,0x0" complete_cpuset="0x00000040,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="38" cpuset="0x00000040,0x0" complete_cpuset="0x00000040,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000080,0x0" complete_cpuset="0x00000080,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000080,0x0" complete_cpuset="0x00000080,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000080,0x0" complete_cpuset="0x00000080,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="7" cpuset="0x00000080,0x0" complete_cpuset="0x00000080,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="39" cpuset="0x00000080,0x0" complete_cpuset="0x00000080,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0x00000f00,0x0" complete_cpuset="0x00000f00,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00000100,0x0" complete_cpuset="0x00000100,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000100,0x0" complete_cpuset="0x00000100,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000100,0x0" complete_cpuset="0x00000100,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="8" cpuset="0x00000100,0x0" complete_cpuset="0x00000100,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="40" cpuset="0x00000100,0x0" complete_cpuset="0x00000100,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000200,0x0" complete_cpuset="0x00000200,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000200,0x0" complete_cpuset="0x00000200,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000200,0x0" complete_cpuset="0x00000200,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="9" cpuset="0x00000200,0x0" complete_cpuset="0x00000200,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="41" cpuset="0x00000200,0x0" complete_cpuset="0x00000200,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000400,0x0" complete_cpuset="0x00000400,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000400,0x0" complete_cpuset="0x00000400,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000400,0x0" complete_cpuset="0x00000400,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="10" cpuset="0x00000400,0x0" complete_cpuset="0x00000400,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="42" cpuset="0x00000400,0x0" complete_cpuset="0x00000400,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00000800,0x0" complete_cpuset="0x00000800,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00000800,0x0" complete_cpuset="0x00000800,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00000800,0x0" complete_cpuset="0x00000800,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="11" cpuset="0x00000800,0x0" complete_cpuset="0x00000800,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="43" cpuset="0x00000800,0x0" complete_cpuset="0x00000800,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0x0000f000,0x0" complete_cpuset="0x0000f000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00001000,0x0" complete_cpuset="0x00001000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00001000,0x0" complete_cpuset="0x00001000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00001000,0x0" complete_cpuset="0x00001000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="12" cpuset="0x00001000,0x0" complete_cpuset="0x00001000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="44" cpuset="0x00001000,0x0" complete_cpuset="0x00001000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00002000,0x0" complete_cpuset="0x00002000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00002000,0x0" complete_cpuset="0x00002000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00002000,0x0" complete_cpuset="0x00002000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="13" cpuset="0x00002000,0x0" complete_cpuset="0x00002000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="45" cpuset="0x00002000,0x0" complete_cpuset="0x00002000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00004000,0x0" complete_cpuset="0x00004000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00004000,0x0" complete_cpuset="0x00004000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00004000,0x0" complete_cpuset="0x00004000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="14" cpuset="0x00004000,0x0" complete_cpuset="0x00004000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="46" cpuset="0x00004000,0x0" complete_cpuset="0x00004000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00008000,0x0" complete_cpuset="0x00008000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00008000,0x0" complete_cpuset="0x00008000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00008000,0x0" complete_cpuset="0x00008000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="15" cpuset="0x00008000,0x0" complete_cpuset="0x00008000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="47" cpuset="0x00008000,0x0" complete_cpuset="0x00008000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+      </object>
+      <object type="Die" os_index="1" cpuset="0xffff0000,0x0" complete_cpuset="0xffff0000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+        <object type="L3Cache" cpuset="0x000f0000,0x0" complete_cpuset="0x000f0000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00010000,0x0" complete_cpuset="0x00010000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00010000,0x0" complete_cpuset="0x00010000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00010000,0x0" complete_cpuset="0x00010000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="16" cpuset="0x00010000,0x0" complete_cpuset="0x00010000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="48" cpuset="0x00010000,0x0" complete_cpuset="0x00010000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00020000,0x0" complete_cpuset="0x00020000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00020000,0x0" complete_cpuset="0x00020000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00020000,0x0" complete_cpuset="0x00020000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="17" cpuset="0x00020000,0x0" complete_cpuset="0x00020000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="49" cpuset="0x00020000,0x0" complete_cpuset="0x00020000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00040000,0x0" complete_cpuset="0x00040000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00040000,0x0" complete_cpuset="0x00040000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00040000,0x0" complete_cpuset="0x00040000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="18" cpuset="0x00040000,0x0" complete_cpuset="0x00040000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="50" cpuset="0x00040000,0x0" complete_cpuset="0x00040000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00080000,0x0" complete_cpuset="0x00080000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00080000,0x0" complete_cpuset="0x00080000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00080000,0x0" complete_cpuset="0x00080000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="19" cpuset="0x00080000,0x0" complete_cpuset="0x00080000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="51" cpuset="0x00080000,0x0" complete_cpuset="0x00080000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0x00f00000,0x0" complete_cpuset="0x00f00000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x00100000,0x0" complete_cpuset="0x00100000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00100000,0x0" complete_cpuset="0x00100000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00100000,0x0" complete_cpuset="0x00100000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="20" cpuset="0x00100000,0x0" complete_cpuset="0x00100000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="52" cpuset="0x00100000,0x0" complete_cpuset="0x00100000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00200000,0x0" complete_cpuset="0x00200000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00200000,0x0" complete_cpuset="0x00200000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00200000,0x0" complete_cpuset="0x00200000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="21" cpuset="0x00200000,0x0" complete_cpuset="0x00200000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="53" cpuset="0x00200000,0x0" complete_cpuset="0x00200000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00400000,0x0" complete_cpuset="0x00400000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00400000,0x0" complete_cpuset="0x00400000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00400000,0x0" complete_cpuset="0x00400000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="22" cpuset="0x00400000,0x0" complete_cpuset="0x00400000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="54" cpuset="0x00400000,0x0" complete_cpuset="0x00400000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x00800000,0x0" complete_cpuset="0x00800000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x00800000,0x0" complete_cpuset="0x00800000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x00800000,0x0" complete_cpuset="0x00800000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="23" cpuset="0x00800000,0x0" complete_cpuset="0x00800000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="55" cpuset="0x00800000,0x0" complete_cpuset="0x00800000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0x0f000000,0x0" complete_cpuset="0x0f000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x01000000,0x0" complete_cpuset="0x01000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x01000000,0x0" complete_cpuset="0x01000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x01000000,0x0" complete_cpuset="0x01000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="24" cpuset="0x01000000,0x0" complete_cpuset="0x01000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="56" cpuset="0x01000000,0x0" complete_cpuset="0x01000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x02000000,0x0" complete_cpuset="0x02000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x02000000,0x0" complete_cpuset="0x02000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x02000000,0x0" complete_cpuset="0x02000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="25" cpuset="0x02000000,0x0" complete_cpuset="0x02000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="57" cpuset="0x02000000,0x0" complete_cpuset="0x02000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x04000000,0x0" complete_cpuset="0x04000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x04000000,0x0" complete_cpuset="0x04000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x04000000,0x0" complete_cpuset="0x04000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="26" cpuset="0x04000000,0x0" complete_cpuset="0x04000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="58" cpuset="0x04000000,0x0" complete_cpuset="0x04000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x08000000,0x0" complete_cpuset="0x08000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x08000000,0x0" complete_cpuset="0x08000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x08000000,0x0" complete_cpuset="0x08000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="27" cpuset="0x08000000,0x0" complete_cpuset="0x08000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="59" cpuset="0x08000000,0x0" complete_cpuset="0x08000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+        <object type="L3Cache" cpuset="0xf0000000,0x0" complete_cpuset="0xf0000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="8388608" depth="3" cache_linesize="64" cache_associativity="16" cache_type="0">
+          <info name="Inclusive" value="1"/>
+          <object type="L2Cache" cpuset="0x10000000,0x0" complete_cpuset="0x10000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x10000000,0x0" complete_cpuset="0x10000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x10000000,0x0" complete_cpuset="0x10000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="28" cpuset="0x10000000,0x0" complete_cpuset="0x10000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="60" cpuset="0x10000000,0x0" complete_cpuset="0x10000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x20000000,0x0" complete_cpuset="0x20000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x20000000,0x0" complete_cpuset="0x20000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x20000000,0x0" complete_cpuset="0x20000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="29" cpuset="0x20000000,0x0" complete_cpuset="0x20000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="61" cpuset="0x20000000,0x0" complete_cpuset="0x20000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x40000000,0x0" complete_cpuset="0x40000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x40000000,0x0" complete_cpuset="0x40000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x40000000,0x0" complete_cpuset="0x40000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="30" cpuset="0x40000000,0x0" complete_cpuset="0x40000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="62" cpuset="0x40000000,0x0" complete_cpuset="0x40000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object type="L2Cache" cpuset="0x80000000,0x0" complete_cpuset="0x80000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="262144" depth="2" cache_linesize="64" cache_associativity="8" cache_type="0">
+            <info name="Inclusive" value="1"/>
+            <object type="L1Cache" cpuset="0x80000000,0x0" complete_cpuset="0x80000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="32768" depth="1" cache_linesize="64" cache_associativity="8" cache_type="1">
+              <info name="Inclusive" value="0"/>
+              <object type="L1iCache" cpuset="0x80000000,0x0" complete_cpuset="0x80000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001" cache_size="65536" depth="1" cache_linesize="64" cache_associativity="16" cache_type="2">
+                <info name="Inclusive" value="0"/>
+                <object type="Core" os_index="31" cpuset="0x80000000,0x0" complete_cpuset="0x80000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001">
+                  <object type="PU" os_index="63" cpuset="0x80000000,0x0" complete_cpuset="0x80000000,0x0" nodeset="0x00000001" complete_nodeset="0x00000001"/>
+                </object>
+              </object>
+            </object>
+          </object>
+        </object>
+      </object>
+    </object>
+  </object>
+</topology>
Binary files 2.10.0-1/tests/hwloc/x86/Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.tar.bz2 and 2.11.0-1/tests/hwloc/x86/Zhaoxin-2xCentaurHauls-KaiSheng-KH-40000.tar.bz2 differ
diff -pruN 2.10.0-1/utils/hwloc/hwloc-bind.1in 2.11.0-1/utils/hwloc/hwloc-bind.1in
--- 2.10.0-1/utils/hwloc/hwloc-bind.1in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/hwloc-bind.1in	2024-06-17 10:01:23.000000000 +0000
@@ -1,5 +1,5 @@
 .\" -*- nroff -*-
-.\" Copyright © 2009-2023 Inria.  All rights reserved.
+.\" Copyright © 2009-2024 Inria.  All rights reserved.
 .\" Copyright © 2010 Université of Bordeaux
 .\" Copyright © 2009-2020 Cisco Systems, Inc.  All rights reserved.
 .\" See COPYING in top-level directory.
@@ -69,7 +69,7 @@ The default is \fB0\fR (or \fBnone\fR).
 Include objects disallowed by administrative limitations.
 .TP
 \fB\-\-best\-memattr\fR <name>
-Select the best NUMA node among the given memory binding set by looking
+Select the best NUMA node(s) among the given memory binding set by looking
 at the memory attribute given by \fI<name>\fR (or as an index).
 
 If the memory attribute values depend on the initiator, the CPU binding
@@ -81,6 +81,15 @@ All existing attributes in the current t
 
     $ lstopo --memattrs
 
+\fI<name>\fR may be suffixed with flags to tune the selection of best nodes,
+for instance as \fBbandwidth,strict,default\fR.
+\fBdefault\fR means that all local nodes are reported if no best could be found.
+\fBstrict\fR means that nodes are selected only if their performance is the best
+for all the input CPUs. On a dual-socket machine with HBM in each socket,
+both HBMs are the best for their local socket, but not for the remote socket.
+Hence both HBM are also considered best for the entire machine by default,
+but none if \fBstrict\fR.
+
 .TP
 \fB\-\-hbm\fR
 Only take high bandwidth memory nodes
@@ -118,7 +127,7 @@ If \fB\-\-membind\fR is given without \f
 the default policy is bind.
 
 The available policies are \fBdefault\fR, \fBfirsttouch\fR,
-\fBbind\fR, \fBinterleave\fR and \fBnexttouch\fR.
+\fBbind\fR, \fBinterleave\fR, \fBweighted\fR (interleave) and \fBnexttouch\fR.
 See hwloc.h for details about these policies.
 
 Note that hwloc's memory binding policies may be slightly different
@@ -204,11 +213,17 @@ This option does not apply to the output
 Interpret input locations with logical indexes instead of physical/OS indexes (default).
 This option does not apply to the output, see \fB\-\-get\fR above.
 .TP
-\fB\-\-taskset\fR
-Display CPU set strings in the format recognized by the taskset command-line
-program instead of hwloc-specific CPU set string format.
+\fB\-\-cpuset\-output\-format\fR <hwloc|list|taskset> \fB\-\-cof\fR <hwloc|list|taskset>
+Change the format of CPUset or nodeset strings displayed by \fB\-\-get\fR, \fB\-e\fR, etc.
+By default, the hwloc-specific format is used.
+If \fIlist\fR is given, the output is a comma-separated of numbers or ranges,
+e.g. 2,4-5,8 .
+If \fItaskset\fR is given, the output is compatible with the taskset program
+(replaces the former \fB--taskset\fR option).
+
 This option has no impact on the format of input CPU set strings,
-both formats are always accepted.
+hwloc, list and taskset formats are always accepted.
+In case of ambiguity, use \fBhwloc-calc --cpuset-input-format\fR.
 .TP
 \fB\-f\fR \fB\-\-force\fR
 Launch the executable even if binding failed.
@@ -293,7 +308,7 @@ To bind on the first PU of all cores of
     $ hwloc-bind package:0.core:all.pu:0 -- echo hello
     $ hwloc-bind --no-smt package:0 -- echo hello
 
-To bind on the memory node local to a PU with largest capacity:
+To bind on the memory node(s) local to a PU with largest capacity:
 
     $ hwloc-bind --best-memattr capacity --cpubind pu:23 --membind pu:23 -- echo hello
 
@@ -374,7 +389,7 @@ the process was actually bound, and then
 the resulting cpu mask in space-delimited list of human-readable
 locations:
 
-    $ hwloc-bind package:1.core:2 -- hwloc-bind --get | hwloc-calc -H package.core.pu
+    $ hwloc-bind package:1.core:2 -- hwloc-bind --get | hwloc-calc -q -H package.core.pu
     Package:1.Core:2.PU:0 Package:1.Core:2.PU:1
 
 hwloc-calc may convert this output into actual objects, either with logical or physical indexes:
diff -pruN 2.10.0-1/utils/hwloc/hwloc-bind.c 2.11.0-1/utils/hwloc/hwloc-bind.c
--- 2.10.0-1/utils/hwloc/hwloc-bind.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/hwloc-bind.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2010, 2012 Université Bordeaux
  * Copyright © 2009-2018 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -42,7 +42,7 @@ void usage(const char *name, FILE *where
   fprintf(where, "Options:\n");
   fprintf(where, "  --cpubind      Use following arguments for cpu binding (default)\n");
   fprintf(where, "  --membind      Use following arguments for memory binding\n");
-  fprintf(where, "  --mempolicy <default|firsttouch|bind|interleave|nexttouch>\n"
+  fprintf(where, "  --mempolicy <default|firsttouch|bind|interleave|weighted|nexttouch>\n"
 		 "                 Change policy that --membind applies (default is bind)\n");
   fprintf(where, "  --best-memattr <attr>\n");
   fprintf(where, "                 Select the best target node in the given memory binding\n");
@@ -58,7 +58,9 @@ void usage(const char *name, FILE *where
 #ifdef HWLOC_LINUX_SYS
   fprintf(where, "  --tid <tid>    Operate on thread <tid>\n");
 #endif
-  fprintf(where, "  --taskset      Use taskset-specific format when displaying cpuset strings\n");
+  fprintf(where, "  --cpuset-output-format <hwloc|list|taskset>\n"
+                 "  --cof <hwloc|list|taskset>\n"
+                 "                 Change the format of cpuset outputs\n");
   fprintf(where, "Miscellaneous options:\n");
   fprintf(where, "  -f --force     Launch the command even if binding failed\n");
   fprintf(where, "  -q --quiet     Hide non-fatal error messages\n");
@@ -85,7 +87,7 @@ int main(int argc, char *argv[])
   int no_smt = -1;
   int only_hbm = -1;
   int logical = 1;
-  int taskset = 0;
+  enum hwloc_utils_cpuset_format_e cpuset_output_format = HWLOC_UTILS_CPUSET_FORMAT_HWLOC;
   unsigned cpubind_flags = 0;
   hwloc_membind_policy_t membind_policy = HWLOC_MEMBIND_BIND;
   int got_mempolicy = 0;
@@ -96,7 +98,7 @@ int main(int argc, char *argv[])
   int tid_number = -1;
   hwloc_pid_t pid = 0; /* only valid when pid_number > 0, but gcc-4.8 still reports uninitialized warnings */
   hwloc_memattr_id_t best_memattr_id = (hwloc_memattr_id_t) -1;
-  const char *best_memattr_str = NULL;
+  char *best_memattr_str = NULL;
   char *callname;
   char *restrictstring = NULL;
   struct hwloc_calc_location_context_s lcontext;
@@ -180,6 +182,10 @@ int main(int argc, char *argv[])
     argv += opt+1;
   }
 
+  /* show all error messages, e.g. PREFERRED_MANY not supported by Linux kernel */
+  if (!getenv("HWLOC_HIDE_ERRORS"))
+    putenv((char *) "HWLOC_HIDE_ERRORS=0");
+
   hwloc_topology_init(&topology);
   hwloc_topology_set_all_types_filter(topology, HWLOC_TYPE_FILTER_KEEP_ALL);
   hwloc_topology_set_flags(topology, flags);
@@ -270,8 +276,21 @@ int main(int argc, char *argv[])
         logical = 0;
         goto next;
       }
+      if (!strcmp(argv[0], "--cpuset-output-format") || !strcmp(argv[0], "--cof")) {
+        if (argc < 2) {
+          usage (callname, stderr);
+          exit(EXIT_FAILURE);
+        }
+        cpuset_output_format = hwloc_utils_parse_cpuset_format(argv[1]);
+        if (HWLOC_UTILS_CPUSET_FORMAT_UNKNOWN == cpuset_output_format) {
+          fprintf(stderr, "Unrecognized %s argument %s\n", argv[0], argv[1]);
+          exit(EXIT_FAILURE);
+        }
+        opt = 1;
+        goto next;
+      }
       if (!strcmp(argv[0], "--taskset")) {
-        taskset = 1;
+        cpuset_output_format = HWLOC_UTILS_CPUSET_FORMAT_TASKSET;
         goto next;
       }
       if (!strcmp (argv[0], "-e") || !strncmp (argv[0], "--get-last-cpu-location", 10)) {
@@ -303,6 +322,8 @@ int main(int argc, char *argv[])
 	  membind_policy = HWLOC_MEMBIND_BIND;
 	else if (!strncmp(argv[1], "interleave", 2))
 	  membind_policy = HWLOC_MEMBIND_INTERLEAVE;
+	else if (!strncmp(argv[1], "weighted", 2))
+	  membind_policy = HWLOC_MEMBIND_WEIGHTED_INTERLEAVE;
 	else if (!strncmp(argv[1], "nexttouch", 2))
 	  membind_policy = HWLOC_MEMBIND_NEXTTOUCH;
 	else {
@@ -334,6 +355,7 @@ int main(int argc, char *argv[])
     lcontext.verbose = verbose;
     scontext.nodeset_input = use_nodeset || nodeset_location;
     scontext.nodeset_output = working_on_cpubind ? 0 : 1;
+    scontext.cpuset_input_format = HWLOC_UTILS_CPUSET_FORMAT_UNKNOWN;
     scontext.output_set = working_on_cpubind ? cpubind_set : membind_set;
     ret = hwloc_calc_process_location_as_set(&lcontext, &scontext, location);
     if (ret < 0) {
@@ -417,16 +439,10 @@ int main(int argc, char *argv[])
       if (use_nodeset) {
 	hwloc_bitmap_t nset = hwloc_bitmap_alloc();
 	hwloc_cpuset_to_nodeset(topology, cpubind_set, nset);
-	if (taskset)
-	  hwloc_bitmap_taskset_asprintf(&s, nset);
-	else
-	  hwloc_bitmap_asprintf(&s, nset);
+        hwloc_utils_cpuset_format_asprintf(&s, nset, cpuset_output_format);
 	hwloc_bitmap_free(nset);
       } else {
-	if (taskset)
-	  hwloc_bitmap_taskset_asprintf(&s, cpubind_set);
-	else
-	  hwloc_bitmap_asprintf(&s, cpubind_set);
+        hwloc_utils_cpuset_format_asprintf(&s, cpubind_set, cpuset_output_format);
       }
 
       } else {
@@ -446,14 +462,12 @@ int main(int argc, char *argv[])
 	  fprintf(stderr, "hwloc_get_membind failed (errno %d %s)\n", errno, errmsg);
 	return EXIT_FAILURE;
       }
-      if (taskset)
-	hwloc_bitmap_taskset_asprintf(&s, membind_set);
-      else
-	hwloc_bitmap_asprintf(&s, membind_set);
+      hwloc_utils_cpuset_format_asprintf(&s, membind_set, cpuset_output_format);
       switch (policy) {
       case HWLOC_MEMBIND_FIRSTTOUCH: policystr = "firsttouch"; break;
       case HWLOC_MEMBIND_BIND: policystr = "bind"; break;
       case HWLOC_MEMBIND_INTERLEAVE: policystr = "interleave"; break;
+      case HWLOC_MEMBIND_WEIGHTED_INTERLEAVE: policystr = "weighted interleave"; break;
       case HWLOC_MEMBIND_NEXTTOUCH: policystr = "nexttouch"; break;
       default: fprintf(stderr, "unknown memory policy %d\n", policy); assert(0); break;
       }
@@ -473,9 +487,17 @@ int main(int argc, char *argv[])
 	goto failed_binding;
     }
 
-    if (best_memattr_str) {
+    if (best_memattr_str && !hwloc_bitmap_iszero(membind_set)) {
+      unsigned nrnodes = hwloc_bitmap_weight(membind_set);
+      hwloc_obj_t *nodes;
+      unsigned i;
+      int j;
+      unsigned long best_node_flags;
       struct hwloc_location loc;
       char *s;
+
+      best_node_flags = hwloc_utils_parse_best_node_flags(best_memattr_str);
+
       best_memattr_id = hwloc_utils_parse_memattr_name(topology, best_memattr_str);
       if (best_memattr_id == (hwloc_memattr_id_t) -1) {
         fprintf(stderr, "unrecognized memattr %s\n", best_memattr_str);
@@ -489,17 +511,33 @@ int main(int argc, char *argv[])
         fprintf(stderr, "memory binding set was %s before filtering by best memattr\n", s);
         free(s);
       }
-      hwloc_utils_get_best_node_in_nodeset_by_memattr(topology, best_memattr_id, membind_set, &loc);
+
+      nodes = malloc(nrnodes *sizeof(*nodes));
+      if (!nodes) {
+        fprintf(stderr, "failed to allocate nodes array for finding best node(s).\n");
+        return EXIT_FAILURE;
+      }
+
+      for(i=0, j=hwloc_bitmap_first(membind_set);
+          i<nrnodes;
+          i++, j=hwloc_bitmap_next(membind_set, j))
+        nodes[i] = hwloc_get_numanode_obj_by_os_index(topology, j);
+
+      ret = hwloc_utils_get_best_node_in_array_by_memattr(topology, best_memattr_id, nrnodes, nodes, &loc, best_node_flags, membind_set);
+
+      free(nodes);
+
+      if (ret < 0 || hwloc_bitmap_iszero(membind_set)) {
+        fprintf(stderr, "failed to find best memory node(s) for memory attribute `%s' among the given membind set.\n", best_memattr_str);
+        return EXIT_FAILURE;
+      }
+
       if (verbose > 0) {
         hwloc_bitmap_asprintf(&s, membind_set);
         /* double-space before %s for alignment with previous verbose message */
         fprintf(stderr, "memory binding is now  %s after filtering by best memattr\n", s);
         free(s);
       }
-      if (hwloc_bitmap_iszero(membind_set)) {
-        fprintf(stderr, "failed to find a best memory node for memory attribute `%s' among the given membind set.\n", best_memattr_str);
-        return EXIT_FAILURE;
-      }
     }
 
     if (verbose > 0) {
diff -pruN 2.10.0-1/utils/hwloc/hwloc-calc.1in 2.11.0-1/utils/hwloc/hwloc-calc.1in
--- 2.10.0-1/utils/hwloc/hwloc-calc.1in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/hwloc-calc.1in	2024-06-17 10:01:23.000000000 +0000
@@ -1,5 +1,5 @@
 .\" -*- nroff -*-
-.\" Copyright © 2010-2023 Inria.  All rights reserved.
+.\" Copyright © 2010-2024 Inria.  All rights reserved.
 .\" Copyright © 2009-2020 Cisco Systems, Inc.  All rights reserved.
 .\" See COPYING in top-level directory.
 .TH HWLOC-CALC "1" "%HWLOC_DATE%" "%PACKAGE_VERSION%" "%PACKAGE_NAME%"
@@ -248,7 +248,7 @@ This option enables \fB\-\-local\-memory
 .TP
 \fB\-\-best\-memattr\fR <name>
 Enable the listing of local memory nodes with \fB\-\-local\-memory\fR,
-but only display the local node that has the best value for the memory
+but only display the local nodes that have the best value for the memory
 attribute given by \fI<name>\fR (or as an index).
 
 If the memory attribute values depend on the initiator, the hwloc-calc
@@ -262,6 +262,15 @@ All existing attributes in the current t
 
 If combined with \fB\-\-object\-output\fR, the object index is prefixed
 with its type (e.g. \fINUMANode:0\fR instead of \fI0\fR).
+
+\fI<name>\fR may be suffixed with flags to tune the selection of best nodes,
+for instance as \fBbandwidth,strict,default\fR.
+\fBdefault\fR means that all local nodes are reported if no best could be found.
+\fBstrict\fR means that nodes are selected only if their performance is the best
+for all the input CPUs. On a dual-socket machine with HBM in each socket,
+both HBMs are the best for their local socket, but not for the remote socket.
+Hence both HBM are also considered best for the entire machine by default,
+but none if \fBstrict\fR.
 .TP
 \fB\-\-sep <sep>\fR
 Change the field separator in the output.
@@ -273,11 +282,26 @@ while a comma is used to separate indexe
 \fB\-\-single\fR
 Singlify the output to a single CPU.
 .TP
-\fB\-\-taskset\fR
-Display CPU set strings in the format recognized by the taskset command-line
-program instead of hwloc-specific CPU set string format.
+\fB\-\-cpuset\-output\-format\fR <hwloc|list|taskset> \fB\-\-cof\fR <hwloc|list|taskset>
+Change the format of displayed CPU set strings.
+By default, the hwloc-specific format is used.
+If \fIlist\fR is given, the output is a comma-separated of numbers or ranges,
+e.g. 2,4-5,8 .
+If \fItaskset\fR is given, the output is compatible with the taskset program
+(replaces the former \fB--taskset\fR option).
+
 This option has no impact on the format of input CPU set strings,
-both formats are always accepted.
+see \fB\-\-cpuset\-input\-format\fR.
+.TP
+\fB\-\-cpuset\-input\-format\fR <hwloc|list|taskset> \fB\-\-cif\fR <hwloc|list|taskset>
+Change the format of input CPU set strings.
+By default, the tool tries to guess the type automatically between hwloc, list or taskset
+formats.
+This option forces the parsing format to avoid ambiguity for instance when "1,3,5" may
+be parsed as a hwloc cpuset "0x1,0x00000003,0x00000005" or as list "1-1,3-3,5-5".
+
+This option has no impact on the format of output CPU set strings,
+see \fB\-\-cpuset\-output\-format\fR.
 .TP
 \fB\-q\fR \fB\-\-quiet\fR
 Hide non-fatal error messages.
@@ -349,13 +373,13 @@ its even numbered logical processors:
 To convert a cpu mask to human-readable output, the -H option can be
 used to emit a space-delimited list of locations:
 
-    $ echo 0x000000f0 | hwloc-calc -H package.core
+    $ echo 0x000000f0 | hwloc-calc -q -H package.core
     Package:1.Core1 Package:1.Core:1 Package:1.Core:2 Package:1.Core:3
 
 To use some other character (e.g., a comma) instead of spaces in
 output, use the --sep option:
 
-    $ echo 0x000000f0 | hwloc-calc -H package.core --sep ,
+    $ echo 0x000000f0 | hwloc-calc -q -H package.core --sep ,
     Package:1.Core1,Package:1.Core:1,Package:1.Core:2,Package:1.Core:3
 
 To combine two (physical) CPU masks:
@@ -393,7 +417,7 @@ whose locality is exactly equal to a Pac
     $ hwloc-calc --local-memory-flags 0 --physical-output pack:1
     4,7
 
-To display the best-capacity NUMA node, by physical indexes,
+To display the best-capacity NUMA node(s), by physical indexes,
 whose locality is exactly equal to a Package:
 
     $ hwloc-calc --local-memory-flags 0 --best-memattr capacity --physical-output pack:1
diff -pruN 2.10.0-1/utils/hwloc/hwloc-calc.c 2.11.0-1/utils/hwloc/hwloc-calc.c
--- 2.10.0-1/utils/hwloc/hwloc-calc.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/hwloc-calc.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2022 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2011 Université Bordeaux
  * Copyright © 2009-2010 Cisco Systems, Inc.  All rights reserved.
  * Copyright © 2023 Université de Reims Champagne-Ardenne.  All rights reserved.
@@ -57,7 +57,12 @@ void usage(const char *callname __hwloc_
   fprintf(where, "  --no --nodeset-output     Manipulate nodesets instead of cpusets for outputs\n");
   fprintf(where, "  --oo --object-output      Report objects instead of object indexes\n");
   fprintf(where, "  --sep <sep>               Use separator <sep> in the output\n");
-  fprintf(where, "  --taskset                 Use taskset-specific format when displaying cpuset strings\n");
+  fprintf(where, "  --cpuset-input-format <hwloc|list|taskset>\n"
+                 "  --cif <hwloc|list|taskset>\n"
+                 "                            Change the format of cpuset inputs\n");
+  fprintf(where, "  --cpuset-output-format <hwloc|list|taskset>\n"
+                 "  --cof <hwloc|list|taskset>\n"
+                 "                            Change the format of cpuset outputs\n");
   fprintf(where, "  --single                  Singlify the output to a single CPU\n");
   fprintf(where, "Miscellaneous options:\n");
   fprintf(where, "  -q --quiet                Hide non-fatal error messages\n");
@@ -79,10 +84,11 @@ static struct hwloc_calc_level *hierleve
 static int local_numanodes = 0;
 static unsigned long local_numanode_flags = HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY | HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY;
 static hwloc_memattr_id_t best_memattr_id = (hwloc_memattr_id_t) -1;
+static unsigned long best_node_flags = 0;
 static int showobjs = 0;
 static int no_smt = -1;
 static int singlify = 0;
-static int taskset = 0;
+static enum hwloc_utils_cpuset_format_e cpuset_output_format = HWLOC_UTILS_CPUSET_FORMAT_HWLOC;
 static hwloc_bitmap_t cpukind_cpuset = NULL;
 
 static int
@@ -232,35 +238,33 @@ hwloc_calc_output(hwloc_topology_t topol
   } else if (local_numanodes) {
     unsigned nrnodes;
     hwloc_obj_t *nodes;
+    hwloc_nodeset_t nodeset = hwloc_bitmap_alloc_full(); /* show all nodes by default */
     nrnodes = hwloc_bitmap_weight(hwloc_topology_get_topology_nodeset(topology));
     nodes = malloc(nrnodes * sizeof(*nodes));
-    if (nodes) {
+    if (nodeset && nodes) {
       int err;
       struct hwloc_location loc;
       loc.type = HWLOC_LOCATION_TYPE_CPUSET;
       loc.location.cpuset = set;
       err = hwloc_get_local_numanode_objs(topology, &loc, &nrnodes, nodes, local_numanode_flags);
       if (!err) {
-        unsigned i;
+        unsigned i, first = 1;
         if (best_memattr_id != (hwloc_memattr_id_t) -1) {
-          int best = hwloc_utils_get_best_node_in_array_by_memattr(topology, best_memattr_id, nrnodes, nodes, &loc);
-          if (best == -1) {
-            /* no perf info found, report nothing */
-            nrnodes = 0;
-          } else {
-            /* only report the best nodes */
-            nodes[0] = nodes[best];
-            nrnodes = 1;
-          }
+          err = hwloc_utils_get_best_node_in_array_by_memattr(topology, best_memattr_id, nrnodes, nodes, &loc, best_node_flags, nodeset);
+          /* on error, nodeset is zeroed, and we report nothing below (except if default flag is set) */
         }
         if (!sep)
           sep = ",";
         for(i=0; i<nrnodes; i++) {
           char type[64];
           unsigned idx;
+          if (!hwloc_bitmap_isset(nodeset, nodes[i]->os_index))
+            continue;
           hwloc_obj_type_snprintf(type, sizeof(type), nodes[i], 1);
           idx = logicalo ? nodes[i]->logical_index : nodes[i]->os_index;
-          if (i>0)
+          if (first)
+            first = 0;
+          else
             printf("%s", sep);
           if (objecto) {
             char types[64];
@@ -270,16 +274,14 @@ hwloc_calc_output(hwloc_topology_t topol
           printf("%u", idx);
         }
       }
-      free(nodes);
     }
+    free(nodes);
+    hwloc_bitmap_free(nodeset);
     printf("\n");
 
   } else {
     char *string = NULL;
-    if (taskset)
-      hwloc_bitmap_taskset_asprintf(&string, set);
-    else
-      hwloc_bitmap_asprintf(&string, set);
+    hwloc_utils_cpuset_format_asprintf(&string, set, cpuset_output_format);
     printf("%s\n", string);
     free(string);
   }
@@ -306,6 +308,7 @@ int main(int argc, char *argv[])
   int cpukind_index = -1;
   char *cpukind_infoname = NULL;
   char *cpukind_infovalue = NULL;
+  enum hwloc_utils_cpuset_format_e cpuset_input_format = HWLOC_UTILS_CPUSET_FORMAT_UNKNOWN;
   int opt;
   int i;
   int err;
@@ -603,10 +606,36 @@ int main(int argc, char *argv[])
 	singlify = 1;
 	goto next;
       }
-      if (!strcmp(argv[0], "--taskset")) {
-	taskset = 1;
+      if (!strcmp(argv[0], "--cpuset-output-format") || !strcmp(argv[0], "--cof")) {
+	if (argc < 2) {
+	  usage (callname, stderr);
+	  exit(EXIT_FAILURE);
+	}
+        cpuset_output_format = hwloc_utils_parse_cpuset_format(argv[1]);
+        if (HWLOC_UTILS_CPUSET_FORMAT_UNKNOWN == cpuset_output_format) {
+          fprintf(stderr, "Unrecognized %s argument %s\n", argv[0], argv[1]);
+          exit(EXIT_FAILURE);
+        }
+	opt = 1;
 	goto next;
       }
+      if (!strcmp(argv[0], "--cpuset-input-format") || !strcmp(argv[0], "--cif")) {
+	if (argc < 2) {
+	  usage (callname, stderr);
+	  exit(EXIT_FAILURE);
+	}
+        cpuset_input_format = hwloc_utils_parse_cpuset_format(argv[1]);
+        if (HWLOC_UTILS_CPUSET_FORMAT_UNKNOWN == cpuset_input_format) {
+          fprintf(stderr, "Unrecognized %s argument %s\n", argv[0], argv[1]);
+          exit(EXIT_FAILURE);
+        }
+	opt = 1;
+	goto next;
+      }
+      if (!strcmp(argv[0], "--taskset")) {
+        cpuset_output_format = HWLOC_UTILS_CPUSET_FORMAT_TASKSET;
+        goto next;
+      }
 
       fprintf (stderr, "Unrecognized option: %s\n", argv[0]);
       usage(callname, stderr);
@@ -622,6 +651,7 @@ int main(int argc, char *argv[])
     scontext.output_set = set;
     scontext.nodeset_input = nodeseti;
     scontext.nodeset_output = nodeseto;
+    scontext.cpuset_input_format = cpuset_input_format;
     if (hwloc_calc_process_location_as_set(&lcontext, &scontext, argv[0]) < 0)
       fprintf(stderr, "ignored unrecognized argument %s\n", argv[0]);
 
@@ -695,6 +725,8 @@ int main(int argc, char *argv[])
   }
 
   if (best_memattr_str) {
+    best_node_flags = hwloc_utils_parse_best_node_flags(best_memattr_str);
+
     best_memattr_id = hwloc_utils_parse_memattr_name(topology, best_memattr_str);
     if (best_memattr_id == (hwloc_memattr_id_t) -1) {
       fprintf(stderr, "unrecognized memattr %s\n", best_memattr_str);
@@ -711,7 +743,8 @@ int main(int argc, char *argv[])
 #define HWLOC_CALC_LINE_LEN 64
     size_t len = HWLOC_CALC_LINE_LEN;
     char * line = malloc(len);
-    printf("Waiting for locations to process on stdin...\n");
+    if (verbose >= 0)
+      printf("Waiting for locations to process on stdin...\n");
     while (1) {
       char *current, *tmpline;
 
@@ -752,6 +785,7 @@ int main(int argc, char *argv[])
 	scontext.output_set = set;
 	scontext.nodeset_input = nodeseti;
 	scontext.nodeset_output = nodeseto;
+        scontext.cpuset_input_format = cpuset_input_format;
 	if (hwloc_calc_process_location_as_set(&lcontext, &scontext, token) < 0)
 	  fprintf(stderr, "ignored unrecognized argument %s\n", token);
       }
diff -pruN 2.10.0-1/utils/hwloc/hwloc-calc.h 2.11.0-1/utils/hwloc/hwloc-calc.h
--- 2.10.0-1/utils/hwloc/hwloc-calc.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/hwloc-calc.h	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2012 Université Bordeaux
  * Copyright © 2011 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -10,7 +10,8 @@
 #define HWLOC_CALC_H
 
 #include "hwloc.h"
-#include "private/misc.h" /* for HWLOC_OBJ_TYPE_NONE */
+#include "private/misc.h" /* for HWLOC_OBJ_TYPE_NONE and for hwloc_strncasecmp() */
+#include "misc.h"
 
 #include <stdlib.h>
 #include <stdio.h>
@@ -702,6 +703,7 @@ hwloc_calc_process_location(struct hwloc
 struct hwloc_calc_set_context_s {
   int nodeset_input;
   int nodeset_output;
+  enum hwloc_utils_cpuset_format_e cpuset_input_format;
   hwloc_bitmap_t output_set;
 };
 
@@ -773,63 +775,39 @@ hwloc_calc_process_location_as_set(struc
 
   } else {
     /* try to match a cpuset */
-    char *tmp = (char*) arg;
     hwloc_bitmap_t newset;
-    int taskset = ( strchr(tmp, ',') == NULL );
+    enum hwloc_utils_cpuset_format_e cpuset_format = scontext->cpuset_input_format;
 
-    /* check the infinite prefix */
-    if (hwloc_strncasecmp(tmp, "0xf...f,", 7+!taskset) == 0) {
-      tmp += 7+!taskset;
-      if (0 == *tmp) {
-        err = -1;
-        goto out;
-      }
+    if (cpuset_format == HWLOC_UTILS_CPUSET_FORMAT_UNKNOWN) {
+      /* ambiguity list and hwloc if list of singleton like 1,3,5 which can be parsed as 0x1,0x3,0x5 or 1-1,3-3,5-5 */
+      if (hwloc_strncasecmp(arg, "0x", 2) && strchr(arg, '-'))
+        cpuset_format = HWLOC_UTILS_CPUSET_FORMAT_LIST;
+      else if (strchr(arg, ','))
+        cpuset_format = HWLOC_UTILS_CPUSET_FORMAT_HWLOC;
+      else
+        cpuset_format = HWLOC_UTILS_CPUSET_FORMAT_TASKSET;
     }
 
-    if (taskset) {
-      /* check that the remaining is 0x followed by a huge hexadecimal number */
-      if (hwloc_strncasecmp(tmp, "0x", 2) != 0) {
-        err = -1;
-        goto out;
-      }
-      tmp += 2;
-      if (0 == *tmp) {
-        err = -1;
-        goto out;
-      }
-      if (strlen(tmp) != strspn(tmp, "0123456789abcdefABCDEF")) {
-        err = -1;
-        goto out;
-      }
+    newset = hwloc_bitmap_alloc();
 
-    } else {
-      /* check that the remaining is a comma-separated list of hexadecimal integer with 0x as an optional prefix */
-      while (1) {
-	char *next = strchr(tmp, ',');
-	size_t len;
-        if (hwloc_strncasecmp(tmp, "0x", 2) == 0) {
-	  tmp += 2;
-	  if (',' == *tmp || 0 == *tmp) {
-	    err = -1;
-	    goto out;
-	  }
-	}
-	len = next ? (size_t) (next-tmp) : strlen(tmp);
-	if (len != strspn(tmp, "0123456789abcdefABCDEF")) {
-	  err = -1;
-	  goto out;
-	}
-	if (!next)
-	  break;
-	tmp = next+1;
-      }
+    switch (cpuset_format) {
+    case HWLOC_UTILS_CPUSET_FORMAT_HWLOC:
+      err = hwloc_bitmap_sscanf(newset, arg);
+      break;
+    case HWLOC_UTILS_CPUSET_FORMAT_LIST:
+      err = hwloc_bitmap_list_sscanf(newset, arg);
+      break;
+    case HWLOC_UTILS_CPUSET_FORMAT_TASKSET:
+      err = hwloc_bitmap_taskset_sscanf(newset, arg);
+      break;
+    default:
+      abort();
+    }
+    if (err < 0) {
+      hwloc_bitmap_free(newset);
+      goto out;
     }
 
-    newset = hwloc_bitmap_alloc();
-    if (taskset)
-      hwloc_bitmap_taskset_sscanf(newset, arg);
-    else
-      hwloc_bitmap_sscanf(newset, arg);
     if (nodeset_output && !nodeset_input) {
       hwloc_bitmap_t newnset = hwloc_bitmap_alloc();
       hwloc_cpuset_to_nodeset(topology, newset, newnset);
diff -pruN 2.10.0-1/utils/hwloc/hwloc-distrib.1in 2.11.0-1/utils/hwloc/hwloc-distrib.1in
--- 2.10.0-1/utils/hwloc/hwloc-distrib.1in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/hwloc-distrib.1in	2024-06-17 10:01:23.000000000 +0000
@@ -1,5 +1,5 @@
 .\" -*- nroff -*-
-.\" Copyright © 2010-2022 Inria.  All rights reserved.
+.\" Copyright © 2010-2024 Inria.  All rights reserved.
 .\" Copyright © 2009-2010 Cisco Systems, Inc.  All rights reserved.
 .\" See COPYING in top-level directory.
 .TH HWLOC-DISTRIB "1" "%HWLOC_DATE%" "%PACKAGE_VERSION%" "%PACKAGE_NAME%"
@@ -21,9 +21,13 @@ hwloc-distrib \- Build a number of cpu m
 \fB\-\-single\fR
 Singlify each output to a single CPU.
 .TP
-\fB\-\-taskset\fR
-Show CPU set strings in the format recognized by the taskset command-line
-program instead of hwloc-specific CPU set string format.
+\fB\-\-cpuset\-output\-format\fR <hwloc|list|taskset> \fB\-\-cof\fR <hwloc|list|taskset>
+Change the format of displayed CPU set strings.
+By default, the hwloc-specific format is used.
+If \fIlist\fR is given, the output is a comma-separated of numbers or ranges,
+e.g. 2,4-5,8 .
+If \fItaskset\fR is given, the output is compatible with the taskset program
+(replaces the former \fB--taskset\fR option).
 .TP
 \fB\-v\fR \fB\-\-verbose\fR
 Verbose messages.
@@ -131,6 +135,15 @@ This can e.g. be used to distribute a se
 to the topology of a machine. These masks can be used with hwloc-bind(1).
 .
 .PP
+On hybrid CPUs (or asymmetric platforms), distribution may be suboptimal
+since the number of cores or PUs inside packages or below caches may vary
+(the top-down recursive partitioning ignores these numbers until reaching their levels).
+Hence it is recommended to distribute only inside a single homogeneous domain.
+For instance on a CPU with energy-efficient E-cores and high-performance P-cores,
+one should distribute separately N tasks on E-cores and M tasks on P-cores
+instead of trying to distribute directly M+N tasks on the entire CPUs.
+.
+.PP
 .B NOTE:
 It is highly recommended that you read the hwloc(7) overview page
 before reading this man page.  Most of the concepts described in
@@ -172,16 +185,16 @@ of binding)
 
 Each output line may be converted independently with hwloc-calc:
 
-    $ hwloc-distrib 4 --single | hwloc-calc --taskset
-    0x1
-    0x100
-    0x10
-    0x1000
+    $ hwloc-distrib 4 --single | hwloc-calc --oo -q -I pu
+    PU:0
+    PU:8
+    PU:4
+    PU:12
 
 To convert the output into a list of processors that may be passed to
 dplace -c inside a mpirun command line:
 
-    $ hwloc-distrib 4 --single | xargs hwloc-calc --pulist
+    $ hwloc-distrib 4 --single | xargs hwloc-calc -I pu
     0,8,4,16
 .
 .
diff -pruN 2.10.0-1/utils/hwloc/hwloc-distrib.c 2.11.0-1/utils/hwloc/hwloc-distrib.c
--- 2.10.0-1/utils/hwloc/hwloc-distrib.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/hwloc-distrib.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2021 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2010 Université Bordeaux
  * Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.
  * Copyright © 2023 Université de Reims Champagne-Ardenne.  All rights reserved.
@@ -33,6 +33,9 @@ void usage(const char *callname __hwloc_
   fprintf(where, "Formatting options:\n");
   fprintf(where, "  --single         Singlify each output to a single CPU\n");
   fprintf(where, "  --taskset        Show taskset-specific cpuset strings\n");
+  fprintf(where, "  --cpuset-output-format <hwloc|list|taskset>\n"
+                 "  --cof <hwloc|list|taskset>\n"
+                 "                   Change the format of cpuset outputs\n");
   fprintf(where, "Miscellaneous options:\n");
   fprintf(where, "  -v --verbose     Show verbose messages\n");
   fprintf(where, "  --version        Report version and exit\n");
@@ -45,7 +48,7 @@ int main(int argc, char *argv[])
   char *callname;
   char *input = NULL;
   struct hwloc_utils_input_format_s input_format = HWLOC_UTILS_INPUT_FORMAT_DEFAULT;
-  int taskset = 0;
+  enum hwloc_utils_cpuset_format_e cpuset_output_format = HWLOC_UTILS_CPUSET_FORMAT_HWLOC;
   int singlify = 0;
   int verbose = 0;
   char *restrictstring = NULL;
@@ -91,8 +94,21 @@ int main(int argc, char *argv[])
 	singlify = 1;
 	goto next;
       }
+      if (!strcmp(argv[0], "--cpuset-output-format") || !strcmp(argv[0], "--cof")) {
+        if (argc < 2) {
+          usage (callname, stderr);
+          exit(EXIT_FAILURE);
+        }
+        cpuset_output_format = hwloc_utils_parse_cpuset_format(argv[1]);
+        if (HWLOC_UTILS_CPUSET_FORMAT_UNKNOWN == cpuset_output_format) {
+          fprintf(stderr, "Unrecognized %s argument %s\n", argv[0], argv[1]);
+          exit(EXIT_FAILURE);
+        }
+        opt = 1;
+        goto next;
+      }
       if (!strcmp(argv[0], "--taskset")) {
-	taskset = 1;
+	cpuset_output_format = HWLOC_UTILS_CPUSET_FORMAT_TASKSET;
 	goto next;
       }
       if (!strcmp(argv[0], "-v") || !strcmp(argv[0], "--verbose")) {
@@ -286,10 +302,7 @@ int main(int argc, char *argv[])
 	    hwloc_bitmap_singlify(cpuset[i]);
 	  }
 	}
-	if (taskset)
-	  hwloc_bitmap_taskset_asprintf(&str, cpuset[i]);
-	else
-	  hwloc_bitmap_asprintf(&str, cpuset[i]);
+        hwloc_utils_cpuset_format_asprintf(&str, cpuset[i], cpuset_output_format);
 	printf("%s\n", str);
 	free(str);
 	hwloc_bitmap_free(cpuset[i]);
diff -pruN 2.10.0-1/utils/hwloc/hwloc-gather-topology.in 2.11.0-1/utils/hwloc/hwloc-gather-topology.in
--- 2.10.0-1/utils/hwloc/hwloc-gather-topology.in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/hwloc-gather-topology.in	2024-06-17 10:01:23.000000000 +0000
@@ -3,7 +3,7 @@
 
 #
 # Copyright © 2009 CNRS
-# Copyright © 2009-2023 Inria.  All rights reserved.
+# Copyright © 2009-2024 Inria.  All rights reserved.
 # Copyright © 2009-2012 Université Bordeaux
 # Copyright © 2014 Cisco Systems, Inc.  All rights reserved.
 # See COPYING in top-level directory.
@@ -26,7 +26,9 @@ LC_ALL=C
 export LANG LC_ALL
 
 # don't let ls append special chars after symlinks etc
-unalias ls
+if alias ls 1>/dev/null 2>&1; then
+  unalias ls
+fi
 
 gathercpuid=1
 gatherio=0
@@ -236,7 +238,7 @@ savefile "$destdir/$basename" /proc/stat
 savefile "$destdir/$basename" /proc/version
 savefile "$destdir/$basename" /proc/self/cpuset
 savefile "$destdir/$basename" /proc/self/cgroup
-savefile "$destdir/$basename" /proc/driver/nvidia
+savedir "$destdir/$basename" /proc/driver/nvidia
 
 # Gather cpu and node information
 # (no need for savebusdir since we already gather the target /sys/devices/system/{cpu,node} explicitly)
diff -pruN 2.10.0-1/utils/hwloc/hwloc-info.1in 2.11.0-1/utils/hwloc/hwloc-info.1in
--- 2.10.0-1/utils/hwloc/hwloc-info.1in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/hwloc-info.1in	2024-06-17 10:01:23.000000000 +0000
@@ -1,11 +1,11 @@
 .\" -*- nroff -*-
-.\" Copyright © 2009-2023 Inria.  All rights reserved.
+.\" Copyright © 2009-2024 Inria.  All rights reserved.
 .\" Copyright © 2009-2010 Université of Bordeaux
 .\" Copyright © 2009-2010 Cisco Systems, Inc.  All rights reserved.
 .\" See COPYING in top-level directory.
 .TH HWLOC-INFO "1" "%HWLOC_DATE%" "%PACKAGE_VERSION%" "%PACKAGE_NAME%"
 .SH NAME
-hwloc-info \- Show some information about some objects or about a topology or about support features
+hwloc-info \- Show some information about some objects, a topology or supported features
 .
 .\" **************************
 .\"    Synopsis Section
@@ -18,9 +18,41 @@ hwloc-info \- Show some information abou
 \fI<object>\fR...
 .PP
 .B hwloc-info
-[ \fIoptions \fR]...
+[ \fIoptions \fR] root
+.
+.B hwloc-info
+[ \fIoptions \fR] [ topology | levels | support ]
 .
 .PP
+\fI<object>\fR... may be a space-separated list of target objects to query.
+The program reports all information about one object before looking at the next one:
+
+    $ hwloc-info core:2 package:1 pu:all
+    Core L#2
+     type = Core
+     ...
+    Package L#1
+     ...
+    PU L#0
+     ...
+    PU L#1
+     ...
+
+The list may also contain special keywords such as:
+
+    \fBroot\fR for the topology root object.
+
+    \fBlevels\fR for information about topology levels (default if no target object is given, identical to \fB\-\-topology\fR).
+
+    \fBtopology\fR for topology info attributes stored in the root object (for forward compatibility with topology info attrs in hwloc 3.0).
+
+    \fBsupport\fR for information about supported features (identical to \fB\-\-support\fR).
+
+Real targets and special keywords may be combined:
+
+    $ hwloc-info core:2 topology pu:3 levels
+
+.PP
 Note that hwloc(7) provides a detailed explanation of the hwloc system
 and of valid <object> formats;
 it should be read before reading this man page.
@@ -36,6 +68,7 @@ This is the default if some objects are
 .TP
 \fB\-\-topology\fR
 Report a summary of the topology instead of about some specific objects.
+This is equivalent to passing \fIlevels\fR as a target object on the command-line.
 This is the default if no object is given on the command-line.
 .TP
 \fB\-\-support\fR
@@ -43,6 +76,7 @@ Report the features that are supported b
 The features are those available through the \fBhwloc_topology_get_support()\fR function.
 This is useful for verifying which CPU or memory binding options are supported
 by the current hwloc installation.
+This is equivalent to passing \fIsupport\fR as a target object on the command-line.
 .TP
 \fB\-i\fR <path>, \fB\-\-input\fR <path>
 Read the topology from <path> instead of discovering the topology of the local machine.
@@ -77,6 +111,17 @@ Include additional detail.
 Reduce the amount of details to show.
 A single summary line per object is displayed.
 .TP
+\fB\-\-get\-attr\fR <name>
+Only report the attribute of name <name> for each object (instead of all attributes).
+The name must exactly match what is usually reported by the program,
+for instance "complete cpuset" in "0.1: complete cpuset = %0x00ffff00".
+
+Only the value is reported, any other prefix or object name is ignored,
+so that the output may easily be used by other tools.
+
+This option also works on topology information but it is ignored for
+\fBlevels\fR and \fBsupport\fR keywords.
+.TP
 \fB\-\-ancestors\fR
 Display information about the object as well as
 about all its ancestors up to the root of the topology.
@@ -135,11 +180,20 @@ in the locality of the given object.
 This option enables \fB\-\-local\-memory\fR.
 .TP
 \fB\-\-best\-memattr\fR <name>
-Enable the listing local memory nodes with \fB\-\-local\-memory\fR,
-but only display the local node that has the best value for the memory
+Enable the listing of local memory nodes with \fB\-\-local\-memory\fR,
+but only display the local nodes that have the best value for the memory
 attribute given by \fI<name>\fR (or as an index).
 If the memory attribute values depend on the initiator, the object given
 to hwloc-info is used as the initiator.
+
+\fI<name>\fR may be suffixed with flags to tune the selection of best nodes,
+for instance as \fBbandwidth,strict,default\fR.
+\fBdefault\fR means that all local nodes are reported if no best could be found.
+\fBstrict\fR means that nodes are selected only if their performance is the best
+for all the input CPUs. On a dual-socket machine with HBM in each socket,
+both HBMs are the best for their local socket, but not for the remote socket.
+Hence both HBM are also considered best for the entire machine by default,
+but none if \fBstrict\fR.
 .TP
 \fB\-\-first\fR
 For each input object, only report the first matching output object
@@ -255,7 +309,7 @@ Display help message and exit.
 .\" **************************
 .SH DESCRIPTION
 .
-hwloc-info displays information about the specified object.
+hwloc-info displays information about the specified objects.
 It is intended to be used with tools such as grep for filtering
 certain attribute lines.
 When no object is specified, or when \fB\-\-topology\fR is passed,
@@ -300,6 +354,12 @@ To list the OS devices that are of subty
     CoProc:6
     CoProc:8
 
+To find the PCI bus ID of PCI devices containing OpenCL devices:
+
+    $ hwloc-info --ancestor PCI --get-attr "attr PCI bus id" 'os[opencl]:all'
+    0000:05:00.0
+    0000:42:00.0
+
 To list the NUMA nodes that are local a PU:
 
     $ hwloc-info --local-memory pu:25
@@ -310,7 +370,7 @@ To list the NUMA nodes that are local a
      type = NUMANode
     ...
 
-To show the best-bandwidth node among NUMA nodes local to a PU:
+To show the best-bandwidth node(s) among NUMA nodes local to a PU:
 
     $ hwloc-info --local-memory --best-memattr bandwidth pu:25
     NUMANode L#7 = local memory #1 of PU L#25
@@ -322,6 +382,19 @@ to find where a NUMA node is attached in
     $ hwloc-info --ancestor kind=normal --first -s numa:1
     Package:0
 
+To see levels and topology info attributes stored in the root object:
+
+    $ hwloc-info levels topology
+    depth 0:           1 Machine (type #0)
+     depth 1:          1 Package (type #1)
+      depth 2:         2 Core (type #2)
+       depth 3:        4 PU (type #3)
+    Special depth -3:  1 NUMANode (type #13)
+    info Backend = Linux
+    info LinuxCgroup = /user/622
+    info Architecture = x86_64
+    info hwlocVersion = 3.0.0a1-git
+
 .
 .\" **************************
 .\"    See also section
diff -pruN 2.10.0-1/utils/hwloc/hwloc-info.c 2.11.0-1/utils/hwloc/hwloc-info.c
--- 2.10.0-1/utils/hwloc/hwloc-info.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/hwloc-info.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2012 Université Bordeaux
  * Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.
  * Copyright © 2023 Université de Reims Champagne-Ardenne.  All rights reserved.
@@ -13,6 +13,7 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <stdarg.h>
 #include <fcntl.h>
 #include <assert.h>
 
@@ -83,17 +84,20 @@ static int show_first_only = 0;
 static int show_local_memory = 0;
 static int show_local_memory_flags = HWLOC_LOCAL_NUMANODE_FLAG_SMALLER_LOCALITY | HWLOC_LOCAL_NUMANODE_FLAG_LARGER_LOCALITY;
 static hwloc_memattr_id_t best_memattr_id = (hwloc_memattr_id_t) -1;
+static unsigned long best_node_flags = 0;
 static unsigned current_obj;
+static const char *only_attr_name = NULL;
 
 void usage(const char *name, FILE *where)
 {
-  fprintf (where, "Usage: %s [ options ] [ locations ]\n", name);
+  fprintf (where, "Usage: %s [ options ] [ object | root | levels | topology | support ... ]\n", name);
   fprintf (where, "\nOutput options:\n");
   fprintf (where, "  --objects             Report information about specific objects\n");
   fprintf (where, "  --topology            Report information the topology\n");
   fprintf (where, "  --support             Report information about supported features\n");
   fprintf (where, "  -v --verbose          Include additional details\n");
   fprintf (where, "  -q --quiet -s         Reduce the amount of details to show\n");
+  fprintf (where, "  --get-attr <name>     Only show the attribute line with name <name>\n");
   fprintf (where, "  --ancestors           Display the chain of ancestor objects up to the root\n");
   fprintf (where, "  --ancestor <type>     Only display the ancestor of the given type\n");
   fprintf (where, "  --children            Display all children\n");
@@ -128,62 +132,90 @@ void usage(const char *name, FILE *where
 }
 
 static void
+hwloc_info_show_attr(const char *prefix, const char *name, const char *value)
+{
+  if (only_attr_name) {
+    if (!strcmp(only_attr_name, name))
+      printf("%s\n", value);
+  } else {
+    printf("%s %s = %s\n", prefix, name, value);
+  }
+}
+
+static void
 hwloc_info_show_obj(hwloc_topology_t topology, hwloc_obj_t obj, const char *type, const char *prefix, int verbose)
 {
-  char s[128];
+  char name[512], value[512];
   unsigned i;
   if (verbose < 0)
     return;
-  printf("%s type = %s\n", prefix, hwloc_obj_type_string(obj->type));
-  printf("%s full type = %s\n", prefix, type);
+
+  hwloc_info_show_attr(prefix, "type", hwloc_obj_type_string(obj->type));
+  hwloc_info_show_attr(prefix, "full type", type);
   if (obj->subtype)
-    printf("%s subtype = %s\n", prefix, obj->subtype);
-  printf("%s logical index = %u\n", prefix, obj->logical_index);
-  if (obj->os_index != (unsigned) -1)
-    printf("%s os index = %u\n", prefix, obj->os_index);
-  printf("%s gp index = %llu\n", prefix, (unsigned long long) obj->gp_index);
+    hwloc_info_show_attr(prefix, "subtype", obj->subtype);
+
+  snprintf(value, sizeof(value), "%u", obj->logical_index);
+  hwloc_info_show_attr(prefix, "logical index", value);
+  if (obj->os_index != (unsigned) -1) {
+    snprintf(value, sizeof(value), "%u", obj->os_index);
+    hwloc_info_show_attr(prefix, "os index", value);
+  }
+  snprintf(value, sizeof(value), "%llu", (unsigned long long) obj->gp_index);
+  hwloc_info_show_attr(prefix, "gp index", value);
+
   if (obj->name)
-    printf("%s name = %s\n", prefix, obj->name);
-  printf("%s depth = %d\n", prefix, obj->depth);
-  printf("%s sibling rank = %u\n", prefix, obj->sibling_rank);
-  printf("%s children = %u\n", prefix, obj->arity);
-  printf("%s memory children = %u\n", prefix, obj->memory_arity);
-  printf("%s i/o children = %u\n", prefix, obj->io_arity);
-  printf("%s misc children = %u\n", prefix, obj->misc_arity);
+    hwloc_info_show_attr(prefix, "name", obj->name);
+
+  snprintf(value, sizeof(value), "%d", obj->depth);
+  hwloc_info_show_attr(prefix, "depth", value);
+  snprintf(value, sizeof(value), "%u", obj->sibling_rank);
+  hwloc_info_show_attr(prefix, "sibling rank", value);
+  snprintf(value, sizeof(value), "%u", obj->arity);
+  hwloc_info_show_attr(prefix, "children", value);
+  snprintf(value, sizeof(value), "%u", obj->memory_arity);
+  hwloc_info_show_attr(prefix, "memory children", value);
+  snprintf(value, sizeof(value), "%u", obj->io_arity);
+  hwloc_info_show_attr(prefix, "i/o children", value);
+  snprintf(value, sizeof(value), "%u", obj->misc_arity);
+  hwloc_info_show_attr(prefix, "misc children", value);
 
   if (obj->type == HWLOC_OBJ_NUMANODE) {
-    printf("%s local memory = %llu\n", prefix, (unsigned long long) obj->attr->numanode.local_memory);
+    snprintf(value, sizeof(value), "%llu", (unsigned long long) obj->attr->numanode.local_memory);
+    hwloc_info_show_attr(prefix, "local memory", value);
+  }
+  if (obj->total_memory) {
+    snprintf(value, sizeof(value), "%llu", (unsigned long long) obj->total_memory);
+    hwloc_info_show_attr(prefix, "total memory", value);
   }
-  if (obj->total_memory)
-    printf("%s total memory = %llu\n", prefix, (unsigned long long) obj->total_memory);
 
   if (obj->cpuset) {
-    hwloc_bitmap_snprintf(s, sizeof(s), obj->cpuset);
-    printf("%s cpuset = %s\n", prefix, s);
+    hwloc_bitmap_snprintf(value, sizeof(value), obj->cpuset);
+    hwloc_info_show_attr(prefix, "cpuset", value);
 
-    hwloc_bitmap_snprintf(s, sizeof(s), obj->complete_cpuset);
-    printf("%s complete cpuset = %s\n", prefix, s);
+    hwloc_bitmap_snprintf(value, sizeof(value), obj->complete_cpuset);
+    hwloc_info_show_attr(prefix, "complete cpuset", value);
 
     {
       hwloc_bitmap_t allowed_cpuset = hwloc_bitmap_dup(obj->cpuset);
       hwloc_bitmap_and(allowed_cpuset, allowed_cpuset, hwloc_topology_get_allowed_cpuset(topology));
-      hwloc_bitmap_snprintf(s, sizeof(s), allowed_cpuset);
+      hwloc_bitmap_snprintf(value, sizeof(value), allowed_cpuset);
       hwloc_bitmap_free(allowed_cpuset);
-      printf("%s allowed cpuset = %s\n", prefix, s);
+      hwloc_info_show_attr(prefix, "allowed cpuset", value);
     }
 
-    hwloc_bitmap_snprintf(s, sizeof(s), obj->nodeset);
-    printf("%s nodeset = %s\n", prefix, s);
+    hwloc_bitmap_snprintf(value, sizeof(value), obj->nodeset);
+    hwloc_info_show_attr(prefix, "nodeset", value);
 
-    hwloc_bitmap_snprintf(s, sizeof(s), obj->complete_nodeset);
-    printf("%s complete nodeset = %s\n", prefix, s);
+    hwloc_bitmap_snprintf(value, sizeof(value), obj->complete_nodeset);
+    hwloc_info_show_attr(prefix, "complete nodeset", value);
 
     {
       hwloc_bitmap_t allowed_nodeset = hwloc_bitmap_dup(obj->nodeset);
       hwloc_bitmap_and(allowed_nodeset, allowed_nodeset, hwloc_topology_get_allowed_nodeset(topology));
-      hwloc_bitmap_snprintf(s, sizeof(s), allowed_nodeset);
+      hwloc_bitmap_snprintf(value, sizeof(value), allowed_nodeset);
       hwloc_bitmap_free(allowed_nodeset);
-      printf("%s allowed nodeset = %s\n", prefix, s);
+      hwloc_info_show_attr(prefix, "allowed nodeset", value);
     }
   }
 
@@ -197,74 +229,88 @@ hwloc_info_show_obj(hwloc_topology_t top
   case HWLOC_OBJ_L2ICACHE:
   case HWLOC_OBJ_L3ICACHE:
   case HWLOC_OBJ_MEMCACHE:
-    printf("%s attr cache depth = %u\n", prefix, obj->attr->cache.depth);
+    snprintf(value, sizeof(value), "%u", obj->attr->cache.depth);
+    hwloc_info_show_attr(prefix, "attr cache depth", value);
     switch (obj->attr->cache.type) {
-    case HWLOC_OBJ_CACHE_UNIFIED: printf("%s attr cache type = Unified\n", prefix); break;
-    case HWLOC_OBJ_CACHE_DATA: printf("%s attr cache type = Data\n", prefix); break;
-    case HWLOC_OBJ_CACHE_INSTRUCTION: printf("%s attr cache type = Instruction\n", prefix); break;
-    }
-    printf("%s attr cache size = %llu\n", prefix, (unsigned long long) obj->attr->cache.size);
-    printf("%s attr cache line size = %u\n", prefix, obj->attr->cache.linesize);
-    if (obj->attr->cache.associativity == -1)
-      printf("%s attr cache ways = Fully-associative\n", prefix);
-    else if (obj->attr->cache.associativity != 0)
-      printf("%s attr cache ways = %d\n", prefix, obj->attr->cache.associativity);
+    case HWLOC_OBJ_CACHE_UNIFIED: hwloc_info_show_attr(prefix, "attr cache type", "Unified"); break;
+    case HWLOC_OBJ_CACHE_DATA: hwloc_info_show_attr(prefix, "attr cache type", "Data"); break;
+    case HWLOC_OBJ_CACHE_INSTRUCTION: hwloc_info_show_attr(prefix, "attr cache type", "Instruction"); break;
+    }
+    snprintf(value, sizeof(value), "%llu", (unsigned long long) obj->attr->cache.size);
+    hwloc_info_show_attr(prefix, "attr cache size", value);
+    snprintf(value, sizeof(value), "%u", obj->attr->cache.linesize);
+    hwloc_info_show_attr(prefix, "attr cache line size", value);
+    if (obj->attr->cache.associativity == -1) {
+      hwloc_info_show_attr(prefix, "attr cache line ways", "Fully-associative");
+    } else if (obj->attr->cache.associativity != 0) {
+      snprintf(value, sizeof(value), "%d", obj->attr->cache.associativity);
+      hwloc_info_show_attr(prefix, "attr cache line ways", value);
+    }
     break;
   case HWLOC_OBJ_GROUP:
-    printf("%s attr group depth = %u\n", prefix, obj->attr->group.depth);
+    snprintf(value, sizeof(value), "%u", obj->attr->group.depth);
+    hwloc_info_show_attr(prefix, "attr group depth", value);
     break;
   case HWLOC_OBJ_BRIDGE:
     switch (obj->attr->bridge.upstream_type) {
     case HWLOC_OBJ_BRIDGE_HOST:
-      printf("%s attr bridge upstream type = Host\n", prefix);
+      hwloc_info_show_attr(prefix, "attr bridge upstream type", "Host");
       break;
     case HWLOC_OBJ_BRIDGE_PCI:
-      printf("%s attr bridge upstream type = PCI\n", prefix);
-      printf("%s attr PCI bus id = %04x:%02x:%02x.%01x\n",
-	     prefix, obj->attr->pcidev.domain, obj->attr->pcidev.bus, obj->attr->pcidev.dev, obj->attr->pcidev.func);
-      printf("%s attr PCI class = %04x\n",
-	     prefix, obj->attr->pcidev.class_id);
-      printf("%s attr PCI id = %04x:%04x\n",
-	     prefix, obj->attr->pcidev.vendor_id, obj->attr->pcidev.device_id);
-      if (obj->attr->pcidev.linkspeed)
-	printf("%s attr PCI linkspeed = %f GB/s\n", prefix, obj->attr->pcidev.linkspeed);
+      hwloc_info_show_attr(prefix, "attr bridge upstream type", "PCI");
+      snprintf(value, sizeof(value), "%04x:%02x:%02x.%01x",
+               obj->attr->pcidev.domain, obj->attr->pcidev.bus, obj->attr->pcidev.dev, obj->attr->pcidev.func);
+      hwloc_info_show_attr(prefix, "attr PCI bus id", value);
+      snprintf(value, sizeof(value), "%04x", obj->attr->pcidev.class_id);
+      hwloc_info_show_attr(prefix, "attr PCI class", value);
+      snprintf(value, sizeof(value), "%04x:%04x", obj->attr->pcidev.vendor_id, obj->attr->pcidev.device_id);
+      hwloc_info_show_attr(prefix, "attr PCI id", value);
+      if (obj->attr->pcidev.linkspeed) {
+	snprintf(value, sizeof(value), "%f GB/s\n", obj->attr->pcidev.linkspeed);
+        hwloc_info_show_attr(prefix, "attr PCI linkspeed", value);
+      }
       break;
     }
     switch (obj->attr->bridge.downstream_type) {
     case HWLOC_OBJ_BRIDGE_HOST:
       assert(0);
     case HWLOC_OBJ_BRIDGE_PCI:
-      printf("%s attr bridge downstream type = PCI\n", prefix);
-      printf("%s attr PCI secondary bus = %02x\n",
-	     prefix, obj->attr->bridge.downstream.pci.secondary_bus);
-      printf("%s attr PCI subordinate bus = %02x\n",
-	     prefix, obj->attr->bridge.downstream.pci.subordinate_bus);
+      hwloc_info_show_attr(prefix, "attr bridge downstream type", "PCI");
+      snprintf(value, sizeof(value), "%02x", obj->attr->bridge.downstream.pci.secondary_bus);
+      hwloc_info_show_attr(prefix, "attr PCI secondary bus bus", value);
+      snprintf(value, sizeof(value), "%02x", obj->attr->bridge.downstream.pci.subordinate_bus);
+      hwloc_info_show_attr(prefix, "attr PCI subordinate bus bus", value);
       break;
     }
     break;
   case HWLOC_OBJ_PCI_DEVICE:
-    printf("%s attr PCI bus id = %04x:%02x:%02x.%01x\n",
-	   prefix, obj->attr->pcidev.domain, obj->attr->pcidev.bus, obj->attr->pcidev.dev, obj->attr->pcidev.func);
-    printf("%s attr PCI class = %04x\n",
-	   prefix, obj->attr->pcidev.class_id);
-    printf("%s attr PCI id = %04x:%04x\n",
-	   prefix, obj->attr->pcidev.vendor_id, obj->attr->pcidev.device_id);
-    if (obj->attr->pcidev.linkspeed)
-      printf("%s attr PCI linkspeed = %f GB/s\n", prefix, obj->attr->pcidev.linkspeed);
+    snprintf(value, sizeof(value), "%04x:%02x:%02x.%01x",
+             obj->attr->pcidev.domain, obj->attr->pcidev.bus, obj->attr->pcidev.dev, obj->attr->pcidev.func);
+    hwloc_info_show_attr(prefix, "attr PCI bus id", value);
+    snprintf(value, sizeof(value), "%04x", obj->attr->pcidev.class_id);
+    hwloc_info_show_attr(prefix, "attr PCI class", value);
+    snprintf(value, sizeof(value), "%04x:%04x", obj->attr->pcidev.vendor_id, obj->attr->pcidev.device_id);
+    hwloc_info_show_attr(prefix, "attr PCI id", value);
+    if (obj->attr->pcidev.linkspeed) {
+      snprintf(value, sizeof(value), "%f GB/s\n", obj->attr->pcidev.linkspeed);
+      hwloc_info_show_attr(prefix, "attr PCI linkspeed", value);
+    }
     break;
   case HWLOC_OBJ_OS_DEVICE:
-    printf("%s attr osdev type = %s\n", prefix, type);
+    hwloc_info_show_attr(prefix, "attr osdev type", type);
     break;
   default:
     /* nothing to show */
     break;
   }
 
-  printf("%s symmetric subtree = %d\n", prefix, obj->symmetric_subtree);
+  snprintf(value, sizeof(value), "%d", obj->symmetric_subtree);
+  hwloc_info_show_attr(prefix, "symmetric subtree", value);
 
   for(i=0; i<obj->infos_count; i++) {
     struct hwloc_info_s *info = &obj->infos[i];
-    printf("%s info %s = %s\n", prefix, info->name, info->value);
+    snprintf(name, sizeof(name), "info %s", info->name);
+    hwloc_info_show_attr(prefix, name, info->value);
   }
 
   if (hwloc_obj_type_is_normal(obj->type)) {
@@ -282,14 +328,16 @@ hwloc_info_show_obj(hwloc_topology_t top
         partial = 1;
       else
         continue;
-      printf("%s cpukind = %u%s\n",
-             prefix, i, partial ? " (partially)" : "");
-      if (efficiency != -1)
-        printf("%s cpukind efficiency = %d\n",
-               prefix, efficiency);
-      for(j=0; j<nr_infos; j++)
-        printf("%s cpukind info %s = %s\n",
-               prefix, infos[j].name, infos[j].value);
+      snprintf(value, sizeof(value), "%u%s", i, partial ? " (partially)" : "");
+      hwloc_info_show_attr(prefix, "cpukind", value);
+      if (efficiency != -1) {
+        snprintf(value, sizeof(value), "%d", efficiency);
+        hwloc_info_show_attr(prefix, "cpukind efficiency", value);
+      }
+      for(j=0; j<nr_infos; j++) {
+        snprintf(name, sizeof(name), "cpukind info %s", infos[j].name);
+        hwloc_info_show_attr(prefix, name, infos[j].value);
+      }
     }
     hwloc_bitmap_free(cpuset);
   }
@@ -300,22 +348,24 @@ hwloc_info_show_obj(hwloc_topology_t top
      */
     unsigned id;
     for(id=0; ; id++) {
-      const char *name;
+      const char *mname;
       unsigned long flags;
       int err;
 
-      err = hwloc_memattr_get_name(topology, id, &name);
+      err = hwloc_memattr_get_name(topology, id, &mname);
       if (err < 0)
         break;
       err = hwloc_memattr_get_flags(topology, id, &flags);
       assert(!err);
 
       if (!(flags & HWLOC_MEMATTR_FLAG_NEED_INITIATOR)) {
-        hwloc_uint64_t value;
-        err = hwloc_memattr_get_value(topology, id, obj, NULL, 0, &value);
-        if (!err)
-          printf("%s memory attribute %s = %llu\n",
-                 prefix, name, (unsigned long long) value);
+        hwloc_uint64_t mvalue;
+        err = hwloc_memattr_get_value(topology, id, obj, NULL, 0, &mvalue);
+        if (!err) {
+          snprintf(name, sizeof(name), "memory attribute %s", mname);
+          snprintf(value, sizeof(value), "%llu", (unsigned long long) mvalue);
+          hwloc_info_show_attr(prefix, name, value);
+        }
       } else {
         unsigned nr_initiators = 0;
         err = hwloc_memattr_get_initiators(topology, id, obj, 0, &nr_initiators, NULL, NULL);
@@ -341,8 +391,9 @@ hwloc_info_show_obj(hwloc_topology_t top
                 } else {
                   assert(0);
                 }
-                printf("%s memory attribute %s from initiator %s = %llu\n",
-                       prefix, name, inits, (unsigned long long) values[j]);
+                snprintf(name, sizeof(name), "memory attribute %s from initiator %s", mname, inits);
+                snprintf(value, sizeof(value), "%llu", (unsigned long long) values[j]);
+                hwloc_info_show_attr(prefix, name, value);
                 if (inits != _inits)
                   free(inits);
               }
@@ -363,17 +414,19 @@ hwloc_info_show_ancestor(hwloc_topology_
 {
   char ancestors[128];
   hwloc_obj_type_snprintf(ancestors, sizeof(ancestors), ancestor, 1);
-  if (verbose < 0)
-    printf("%s%s:%u\n", prefix, ancestors, ancestor->logical_index);
-  else if (level > 0)
-    printf("%s%s L#%u = parent #%u of %s L#%u\n",
-           prefix, ancestors, ancestor->logical_index, level, objs, obj->logical_index);
-  else if (level == 0) /* the object itself, don't show it twice */
-    printf("%s%s L#%u\n",
-           prefix, ancestors, ancestor->logical_index);
-  else /* single ancestor */
-    printf("%s%s L#%u = parent of %s L#%u\n",
-           prefix, ancestors, ancestor->logical_index, objs, obj->logical_index);
+  if (!only_attr_name) {
+    if (verbose < 0)
+      printf("%s%s:%u\n", prefix, ancestors, ancestor->logical_index);
+    else if (level > 0)
+      printf("%s%s L#%u = parent #%u of %s L#%u\n",
+             prefix, ancestors, ancestor->logical_index, level, objs, obj->logical_index);
+    else if (level == 0) /* the object itself, don't show it twice */
+      printf("%s%s L#%u\n",
+             prefix, ancestors, ancestor->logical_index);
+    else /* single ancestor */
+      printf("%s%s L#%u = parent of %s L#%u\n",
+             prefix, ancestors, ancestor->logical_index, objs, obj->logical_index);
+  }
   hwloc_info_show_obj(topology, ancestor, ancestors, prefix, verbose);
 }
 
@@ -384,11 +437,13 @@ hwloc_info_show_descendant(hwloc_topolog
 {
   char descendants[128];
   hwloc_obj_type_snprintf(descendants, sizeof(descendants), descendant, 1);
-  if (verbose < 0)
-    printf("%s%s:%u\n", prefix, descendants, descendant->logical_index);
-  else
-    printf("%s%s L#%u = descendant #%u of %s L#%u\n",
-           prefix, descendants, descendant->logical_index, number, objs, obj->logical_index);
+  if (!only_attr_name) {
+    if (verbose < 0)
+      printf("%s%s:%u\n", prefix, descendants, descendant->logical_index);
+    else
+      printf("%s%s L#%u = descendant #%u of %s L#%u\n",
+             prefix, descendants, descendant->logical_index, number, objs, obj->logical_index);
+  }
   hwloc_info_show_obj(topology, descendant, descendants, prefix, verbose);
 }
 
@@ -399,11 +454,13 @@ hwloc_info_show_child(hwloc_topology_t t
 {
   char childs[128];
   hwloc_obj_type_snprintf(childs, sizeof(childs), child, 1);
-  if (verbose < 0)
-    printf("%s%s:%u\n", prefix, childs, child->logical_index);
-  else
-    printf("%s%s L#%u = child #%u of %s L#%u\n",
-           prefix, childs, child->logical_index, number, objs, obj->logical_index);
+  if (!only_attr_name) {
+    if (verbose < 0)
+      printf("%s%s:%u\n", prefix, childs, child->logical_index);
+    else
+      printf("%s%s L#%u = child #%u of %s L#%u\n",
+             prefix, childs, child->logical_index, number, objs, obj->logical_index);
+  }
   hwloc_info_show_obj(topology, child, childs, prefix, verbose);
 }
 
@@ -414,11 +471,13 @@ hwloc_info_show_local_memory(hwloc_topol
 {
   char nodes[128];
   hwloc_obj_type_snprintf(nodes, sizeof(nodes), node, 1);
-  if (verbose < 0)
-    printf("%s%s:%u\n", prefix, nodes, node->logical_index);
-  else
-    printf("%s%s L#%u = local memory #%u of %s L#%u\n",
-           prefix, nodes, node->logical_index, number, objs, obj->logical_index);
+  if (!only_attr_name) {
+    if (verbose < 0)
+      printf("%s%s:%u\n", prefix, nodes, node->logical_index);
+    else
+      printf("%s%s L#%u = local memory #%u of %s L#%u\n",
+             prefix, nodes, node->logical_index, number, objs, obj->logical_index);
+  }
   hwloc_info_show_obj(topology, node, nodes, prefix, verbose);
 }
 
@@ -427,10 +486,12 @@ hwloc_info_show_single_obj(hwloc_topolog
                            hwloc_obj_t obj, const char *objs,
                            const char *prefix, int verbose)
 {
-  if (verbose < 0)
-    printf("%s%s:%u\n", prefix, objs, obj->logical_index);
-  else
-    printf("%s%s L#%u\n", prefix, objs, obj->logical_index);
+  if (!only_attr_name) {
+    if (verbose < 0)
+      printf("%s%s:%u\n", prefix, objs, obj->logical_index);
+    else
+      printf("%s%s L#%u\n", prefix, objs, obj->logical_index);
+  }
   hwloc_info_show_obj(topology, obj, objs, prefix, verbose);
 }
 
@@ -582,9 +643,10 @@ hwloc_calc_process_location_info_cb(stru
   } else if (show_local_memory) {
     unsigned nrnodes;
     hwloc_obj_t *nodes;
+    hwloc_nodeset_t nodeset = hwloc_bitmap_alloc_full(); /* show all nodes by default */
     nrnodes = hwloc_bitmap_weight(hwloc_topology_get_topology_nodeset(topology));
     nodes = malloc(nrnodes * sizeof(*nodes));
-    if (nodes) {
+    if (nodeset && nodes) {
       struct hwloc_location loc;
       int err;
       loc.type = HWLOC_LOCATION_TYPE_OBJECT;
@@ -593,28 +655,21 @@ hwloc_calc_process_location_info_cb(stru
       if (!err) {
         unsigned i;
         if (best_memattr_id != (hwloc_memattr_id_t) -1) {
-          /* only keep the best one for that memattr */
-          int best;
+          /* only keep the best ones for that memattr */
 
           /* won't work if obj is CPU-less: perf from I/O is likely different from perf from CPU objects */
           loc.type = HWLOC_LOCATION_TYPE_CPUSET;
           loc.location.cpuset = obj->cpuset;
-          best = hwloc_utils_get_best_node_in_array_by_memattr(topology, best_memattr_id,
-                                                               nrnodes, nodes, &loc);
-          if (best == -1) {
-            /* no perf info found, report nothing */
+          err = hwloc_utils_get_best_node_in_array_by_memattr(topology, best_memattr_id,
+                                                               nrnodes, nodes, &loc, best_node_flags, nodeset);
+          if (err < -1) {
             if (verbose > 0)
               fprintf(stderr, "Failed to find a best local node for memory attribute.\n");
-            nrnodes = 0;
-          } else {
-            /* only report the best node, but keep the index intact */
-            for(i=0; i<nrnodes; i++)
-              if (i != (unsigned) best)
-                nodes[i] = NULL;
+            /* on error, nodeset is zeroed, and we report nothing below (except if default flag is set) */
           }
         }
         for(i=0; i<nrnodes; i++) {
-          if (!nodes[i])
+          if (!hwloc_bitmap_isset(nodeset, nodes[i]->os_index))
             continue;
           if (show_index_prefix)
 	    snprintf(prefix, sizeof(prefix), "%u.%u: ", current_obj, i);
@@ -626,6 +681,7 @@ hwloc_calc_process_location_info_cb(stru
     } else {
       fprintf(stderr, "Failed to allocate array of local NUMA nodes\n");
     }
+    hwloc_bitmap_free(nodeset);
     free(nodes);
   } else {
     hwloc_info_show_single_obj(topology, obj, objs, prefix, verbose);
@@ -634,6 +690,97 @@ hwloc_calc_process_location_info_cb(stru
   current_obj++;
 }
 
+static void
+hwloc_info_show_levels(FILE *output, hwloc_topology_t topology)
+{
+  hwloc_lstopo_show_summary(output, topology);
+}
+
+static void
+hwloc_info_show_topology_infos(hwloc_topology_t topology)
+{
+  hwloc_obj_t root = hwloc_get_root_obj(topology);
+  unsigned i;
+  for(i=0; i<root->infos_count; i++) {
+    const char *infoname = root->infos[i].name;
+    if (!strcmp(infoname, "Backend")
+        || !strcmp(infoname, "SyntheticDescription")
+        || !strcmp(infoname, "MemoryTiersNr")
+        || !strcmp(infoname, "LinuxCgroup")
+        || !strcmp(infoname, "WindowsBuildEnvironment")
+        || !strcmp(infoname, "OSName")
+        || !strcmp(infoname, "OSRelease")
+        || !strcmp(infoname, "OSVersion")
+        || !strcmp(infoname, "HostName")
+        || !strcmp(infoname, "Architecture")
+        || !strcmp(infoname, "hwlocVersion")
+        || !strcmp(infoname, "ProcessName")) {
+      if (!only_attr_name)
+        printf("info %s = %s\n", infoname, root->infos[i].value);
+      else {
+        char name[256];
+        snprintf(name, sizeof(name), "info %s", infoname);
+        if (!strcmp(only_attr_name, name))
+          printf("%s\n", root->infos[i].value);
+      }
+    }
+  }
+}
+
+static void
+hwloc_info_show_support(hwloc_topology_t topology)
+{
+  const struct hwloc_topology_support *support = hwloc_topology_get_support(topology);
+
+#ifdef HWLOC_DEBUG
+  HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_support) == 4*sizeof(void*));
+  HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_discovery_support) == 6);
+  HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_cpubind_support) == 11);
+  HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_membind_support) == 16);
+  HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_misc_support) == 1);
+#endif
+
+#define DO(x,y) printf(#x ":" #y " = %u\n", (unsigned char) support->x->y);
+  DO(discovery, pu);
+  DO(discovery, disallowed_pu);
+  DO(discovery, numa);
+  DO(discovery, numa_memory);
+  DO(discovery, disallowed_numa);
+  DO(discovery, cpukind_efficiency);
+
+  DO(cpubind, set_thisproc_cpubind);
+  DO(cpubind, get_thisproc_cpubind);
+  DO(cpubind, set_proc_cpubind);
+  DO(cpubind, get_proc_cpubind);
+  DO(cpubind, set_thisthread_cpubind);
+  DO(cpubind, get_thisthread_cpubind);
+  DO(cpubind, set_thread_cpubind);
+  DO(cpubind, get_thread_cpubind);
+  DO(cpubind, get_thisproc_last_cpu_location);
+  DO(cpubind, get_proc_last_cpu_location);
+  DO(cpubind, get_thisthread_last_cpu_location);
+
+  DO(membind, set_thisproc_membind);
+  DO(membind, get_thisproc_membind);
+  DO(membind, set_proc_membind);
+  DO(membind, get_proc_membind);
+  DO(membind, set_thisthread_membind);
+  DO(membind, get_thisthread_membind);
+  DO(membind, set_area_membind);
+  DO(membind, get_area_membind);
+  DO(membind, alloc_membind);
+  DO(membind, firsttouch_membind);
+  DO(membind, bind_membind);
+  DO(membind, interleave_membind);
+  DO(membind, weighted_interleave_membind);
+  DO(membind, nexttouch_membind);
+  DO(membind, migrate_membind);
+  DO(membind, get_area_memlocation);
+
+  DO(misc, imported_support);
+#undef DO
+}
+
 int
 main (int argc, char *argv[])
 {
@@ -647,7 +794,7 @@ main (int argc, char *argv[])
   struct hwloc_utils_input_format_s input_format = HWLOC_UTILS_INPUT_FORMAT_DEFAULT;
   const char *show_ancestor_type = NULL;
   const char *show_descendants_type = NULL;
-  const char *best_memattr_str = NULL;
+  char *best_memattr_str = NULL;
   char *restrictstring = NULL;
   size_t typelen;
   int opt;
@@ -695,6 +842,14 @@ main (int argc, char *argv[])
 	usage(callname, stdout);
         exit(EXIT_SUCCESS);
       }
+      else if (!strcmp (argv[0], "--get-attr")) {
+	if (argc < 2) {
+	  usage (callname, stderr);
+	  exit(EXIT_FAILURE);
+	}
+	only_attr_name = argv[1];
+	opt = 1;
+      }
       else if (!strcmp (argv[0], "-n"))
 	show_index_prefix = 1;
       else if (!strcmp (argv[0], "--ancestors"))
@@ -957,8 +1112,8 @@ main (int argc, char *argv[])
   }
 
   if (best_memattr_str) {
-    if (!show_local_memory)
-      fprintf(stderr, "--best-memattr is ignored without --local-memory.\n");
+    best_node_flags = hwloc_utils_parse_best_node_flags(best_memattr_str);
+
     best_memattr_id = hwloc_utils_parse_memattr_name(topology, best_memattr_str);
     if (best_memattr_id == (hwloc_memattr_id_t) -1) {
       fprintf(stderr, "unrecognized memattr %s\n", best_memattr_str);
@@ -974,57 +1129,10 @@ main (int argc, char *argv[])
   }
 
   if (mode == HWLOC_INFO_MODE_TOPOLOGY) {
-    hwloc_lstopo_show_summary(stdout, topology);
+    hwloc_info_show_levels(stdout, topology);
 
   } else if (mode == HWLOC_INFO_MODE_SUPPORT) {
-    const struct hwloc_topology_support *support = hwloc_topology_get_support(topology);
-
-#ifdef HWLOC_DEBUG
-    HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_support) == 4*sizeof(void*));
-    HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_discovery_support) == 6);
-    HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_cpubind_support) == 11);
-    HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_membind_support) == 15);
-    HWLOC_BUILD_ASSERT(sizeof(struct hwloc_topology_misc_support) == 1);
-#endif
-
-#define DO(x,y) printf(#x ":" #y " = %u\n", (unsigned char) support->x->y);
-    DO(discovery, pu);
-    DO(discovery, disallowed_pu);
-    DO(discovery, numa);
-    DO(discovery, numa_memory);
-    DO(discovery, disallowed_numa);
-    DO(discovery, cpukind_efficiency);
-
-    DO(cpubind, set_thisproc_cpubind);
-    DO(cpubind, get_thisproc_cpubind);
-    DO(cpubind, set_proc_cpubind);
-    DO(cpubind, get_proc_cpubind);
-    DO(cpubind, set_thisthread_cpubind);
-    DO(cpubind, get_thisthread_cpubind);
-    DO(cpubind, set_thread_cpubind);
-    DO(cpubind, get_thread_cpubind);
-    DO(cpubind, get_thisproc_last_cpu_location);
-    DO(cpubind, get_proc_last_cpu_location);
-    DO(cpubind, get_thisthread_last_cpu_location);
-
-    DO(membind, set_thisproc_membind);
-    DO(membind, get_thisproc_membind);
-    DO(membind, set_proc_membind);
-    DO(membind, get_proc_membind);
-    DO(membind, set_thisthread_membind);
-    DO(membind, get_thisthread_membind);
-    DO(membind, set_area_membind);
-    DO(membind, get_area_membind);
-    DO(membind, alloc_membind);
-    DO(membind, firsttouch_membind);
-    DO(membind, bind_membind);
-    DO(membind, interleave_membind);
-    DO(membind, nexttouch_membind);
-    DO(membind, migrate_membind);
-    DO(membind, get_area_memlocation);
-
-    DO(misc, imported_support);
-#undef DO
+    hwloc_info_show_support(topology);
 
   } else if (mode == HWLOC_INFO_MODE_OBJECTS) {
     struct hwloc_calc_location_context_s lcontext;
@@ -1035,7 +1143,13 @@ main (int argc, char *argv[])
     lcontext.verbose = verbose_mode;
     current_obj = 0;
     while (argc >= 1) {
-      if (!strcmp(argv[0], "all") || !strcmp(argv[0], "root")) {
+      if (!strcmp(argv[0], "levels")) {
+        hwloc_info_show_levels(stdout, topology);
+      } else if (!strcmp(argv[0], "topology")) {
+        hwloc_info_show_topology_infos(topology);
+      } else if (!strcmp(argv[0], "support")) {
+        hwloc_info_show_support(topology);
+      } else if (!strcmp(argv[0], "all") || !strcmp(argv[0], "root")) {
 	hwloc_calc_process_location_info_cb(&lcontext, NULL, hwloc_get_root_obj(topology));
       } else if (*argv[0] == '-') {
         fprintf(stderr, "Cannot handle command-line option %s after some locations.\n", argv[0]);
diff -pruN 2.10.0-1/utils/hwloc/misc.h 2.11.0-1/utils/hwloc/misc.h
--- 2.10.0-1/utils/hwloc/misc.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/misc.h	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2022 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2012 Université Bordeaux
  * Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.
  * Copyright © 2023 Université de Reims Champagne-Ardenne.  All rights reserved.
@@ -803,145 +803,200 @@ hwloc_utils_parse_memattr_name(hwloc_top
     return id;
 }
 
-static __hwloc_inline int
-hwloc_utils_get_best_node_in_array_by_memattr(hwloc_topology_t topology, hwloc_memattr_id_t id,
-                                              unsigned nbnodes, hwloc_obj_t *nodes,
-                                              struct hwloc_location *initiator)
+#define HWLOC_UTILS_BEST_NODE_FLAG_DEFAULT (1UL<<0) /* report all nodes if no best found */
+#define HWLOC_UTILS_BEST_NODE_FLAG_STRICT (1UL<<1) /* report only best with same initiator */
+
+static __hwloc_inline unsigned long
+hwloc_utils_parse_best_node_flags(char *str)
 {
-  unsigned nbtgs, i, j;
-  hwloc_obj_t *tgs;
-  int best;
-  hwloc_uint64_t *values, bestvalue;
-  unsigned long mflags;
-  int err;
+  unsigned long best_memattr_flags = 0;
+  char *tmp;
 
-  err = hwloc_memattr_get_flags(topology, id, &mflags);
-  if (err < 0)
-    goto out;
+  tmp = strstr(str, ",default");
+  if (tmp) {
+    memmove(tmp, tmp+8, strlen(tmp+8)+1);
+    best_memattr_flags |= HWLOC_UTILS_BEST_NODE_FLAG_DEFAULT;
+  }
 
-  nbtgs = 0;
-  err = hwloc_memattr_get_targets(topology, id, initiator, 0, &nbtgs, NULL, NULL);
-  if (err < 0)
-    goto out;
+  tmp = strstr(str, ",strict");
+  if (tmp) {
+    memmove(tmp, tmp+7, strlen(tmp+7)+1);
+    best_memattr_flags |= HWLOC_UTILS_BEST_NODE_FLAG_STRICT;
+  }
 
-  tgs = malloc(nbtgs * sizeof(*tgs));
-  values = malloc(nbtgs * sizeof(*values));
-  if (!tgs || !values)
-    goto out_with_arrays;
+  return best_memattr_flags;
+}
 
-  err = hwloc_memattr_get_targets(topology, id, initiator, 0, &nbtgs, tgs, values);
-  if (err < 0)
-    goto out_with_arrays;
+static __hwloc_inline void
+hwloc_utils__update_best_node(hwloc_obj_t newnode, uint64_t newvalue,
+                              uint64_t *bestvalue, hwloc_bitmap_t bestnodeset,
+                              unsigned long mflags)
+{
+  if (hwloc_bitmap_iszero(bestnodeset)) {
+    /* first */
+    *bestvalue = newvalue;
+    hwloc_bitmap_only(bestnodeset, newnode->os_index);
 
-  best = -1;
-  bestvalue = 0;
-  for(i=0; i<nbnodes; i++) {
-    for(j=0; j<nbtgs; j++)
-      if (tgs[j] == nodes[i])
-        break;
-    if (j==nbtgs)
-      /* no target info for this node */
-      continue;
-    if (best == -1) {
-      best = i;
-      bestvalue = values[j];
-    } else if (mflags & HWLOC_MEMATTR_FLAG_HIGHER_FIRST) {
-      if (values[j] > bestvalue) {
-        best = i;
-        bestvalue = values[j];
-      }
-    } else {
-      assert(mflags & HWLOC_MEMATTR_FLAG_LOWER_FIRST);
-      if (values[j] < bestvalue) {
-        best = i;
-        bestvalue = values[j];
-      }
+  } else if (mflags & HWLOC_MEMATTR_FLAG_HIGHER_FIRST) {
+    if (newvalue > *bestvalue) {
+      /* higher */
+      *bestvalue = newvalue;
+      hwloc_bitmap_only(bestnodeset, newnode->os_index);
+    } else if (newvalue == *bestvalue) {
+      /* as high */
+      hwloc_bitmap_set(bestnodeset, newnode->os_index);
     }
-  }
-
-  free(tgs);
-  free(values);
-  return best;
 
- out_with_arrays:
-  free(tgs);
-  free(values);
- out:
-  return -1;
+  } else {
+    assert(mflags & HWLOC_MEMATTR_FLAG_LOWER_FIRST);
+    if (newvalue < *bestvalue) {
+      /* lower */
+      *bestvalue = newvalue;
+      hwloc_bitmap_only(bestnodeset, newnode->os_index);
+    } else if (newvalue == *bestvalue) {
+      /* as low */
+      hwloc_bitmap_set(bestnodeset, newnode->os_index);
+    }
+  }
 }
 
+/* fill best_nodeset with best nodes.
+ * if STRICT flag, only the really local ones are returned.
+ * if none is best (they don't have values), return empty.
+ * if none is best and DEFAULT flag, return all nodes.
+ * on error, return empty.
+ */
 static __hwloc_inline int
-hwloc_utils_get_best_node_in_nodeset_by_memattr(hwloc_topology_t topology, hwloc_memattr_id_t id,
-                                                hwloc_nodeset_t nodeset,
-                                                struct hwloc_location *initiator)
-{
-  unsigned nbtgs, i, j;
-  hwloc_obj_t *tgs;
-  int best;
-  hwloc_uint64_t *values, bestvalue;
+hwloc_utils_get_best_node_in_array_by_memattr(hwloc_topology_t topology, hwloc_memattr_id_t id,
+                                              unsigned nbnodes, hwloc_obj_t *nodes,
+                                              struct hwloc_location *initiator,
+                                              unsigned long flags,
+                                              hwloc_nodeset_t best_nodeset)
+{
+  unsigned i, j;
+  hwloc_uint64_t *values, bestvalue = 0;
   unsigned long mflags;
   int err;
 
+  hwloc_bitmap_zero(best_nodeset);
+
   err = hwloc_memattr_get_flags(topology, id, &mflags);
   if (err < 0)
     goto out;
 
-  nbtgs = 0;
-  err = hwloc_memattr_get_targets(topology, id, initiator, 0, &nbtgs, NULL, NULL);
-  if (err < 0)
-    goto out;
+  if (mflags & HWLOC_MEMATTR_FLAG_NEED_INITIATOR) {
+    /* iterate over targets, and then on their initiators */
+    for(i=0; i<nbnodes; i++) {
+      unsigned nbi;
+      struct hwloc_location *initiators;
+
+      nbi = 0;
+      err = hwloc_memattr_get_initiators(topology, id, nodes[i], 0, &nbi, NULL, NULL);
+      if (err < 0)
+        goto out;
+
+      initiators = malloc(nbi * sizeof(*initiators));
+      values = malloc(nbi * sizeof(*values));
+      if (!initiators || !values) {
+        free(initiators);
+        free(values);
+        goto out;
+      }
 
-  tgs = malloc(nbtgs * sizeof(*tgs));
-  values = malloc(nbtgs * sizeof(*values));
-  if (!tgs || !values)
-    goto out_with_arrays;
+      err = hwloc_memattr_get_initiators(topology, id, nodes[i], 0, &nbi, initiators, values);
+      if (err < 0) {
+        free(initiators);
+        free(values);
+        goto out;
+      }
 
-  err = hwloc_memattr_get_targets(topology, id, initiator, 0, &nbtgs, tgs, values);
-  if (err < 0)
-    goto out_with_arrays;
+      for(j=0; j<nbi; j++) {
+        /* does this initiator match the user location? */
+        if (initiator->type != initiators[j].type)
+          continue;
+        switch (initiator->type) {
+        case HWLOC_LOCATION_TYPE_OBJECT:
+          if (initiator->location.object->type != initiators[j].location.object->type
+              || initiator->location.object->gp_index != initiators[j].location.object->gp_index)
+            continue;
+          break;
+        case HWLOC_LOCATION_TYPE_CPUSET:
+          if (flags & HWLOC_UTILS_BEST_NODE_FLAG_STRICT) {
+            if (!hwloc_bitmap_isincluded(initiator->location.cpuset, initiators[j].location.cpuset))
+              continue;
+          } else {
+            if (!hwloc_bitmap_intersects(initiator->location.cpuset, initiators[j].location.cpuset))
+              continue;
+          }
+          break;
+        default:
+          abort();
+        }
 
-  best = -1;
-  bestvalue = 0;
-  hwloc_bitmap_foreach_begin(i, nodeset) {
-    for(j=0; j<nbtgs; j++)
-      if (tgs[j]->os_index == i)
-        break;
-    if (j==nbtgs)
-      /* no target info for this node */
-      continue;
-    if (best == -1) {
-      best = i;
-      bestvalue = values[j];
-    } else if (mflags & HWLOC_MEMATTR_FLAG_HIGHER_FIRST) {
-      if (values[j] > bestvalue) {
-        best = i;
-        bestvalue = values[j];
-      }
-    } else {
-      assert(mflags & HWLOC_MEMATTR_FLAG_LOWER_FIRST);
-      if (values[j] < bestvalue) {
-        best = i;
-        bestvalue = values[j];
+        hwloc_utils__update_best_node(nodes[i], values[j],
+                                      &bestvalue, best_nodeset,
+                                      mflags);
       }
+
+      free(initiators);
+      free(values);
     }
-  } hwloc_bitmap_foreach_end();
 
-  if (best == -1)
-    hwloc_bitmap_zero(nodeset);
-  else
-    hwloc_bitmap_only(nodeset, best);
+  } else {
+    /* no initiator, just iterate over targets */
+    for(i=0; i<nbnodes; i++) {
+      uint64_t value;
+      if (!hwloc_memattr_get_value(topology, id, nodes[i], NULL, 0, &value))
+        hwloc_utils__update_best_node(nodes[i], value,
+                                      &bestvalue, best_nodeset,
+                                      mflags);
+    }
+  }
 
-  free(tgs);
-  free(values);
+  if ((flags & HWLOC_UTILS_BEST_NODE_FLAG_DEFAULT)
+      && hwloc_bitmap_iszero(best_nodeset)) {
+    for(i=0; i<nbnodes; i++)
+      hwloc_bitmap_set(best_nodeset, nodes[i]->os_index);
+  }
   return 0;
 
- out_with_arrays:
-  free(tgs);
-  free(values);
  out:
+  hwloc_bitmap_zero(best_nodeset);
   return -1;
 }
 
+enum hwloc_utils_cpuset_format_e {
+  HWLOC_UTILS_CPUSET_FORMAT_UNKNOWN,
+  HWLOC_UTILS_CPUSET_FORMAT_HWLOC,
+  HWLOC_UTILS_CPUSET_FORMAT_TASKSET,
+  HWLOC_UTILS_CPUSET_FORMAT_LIST
+};
+
+static __hwloc_inline enum hwloc_utils_cpuset_format_e
+hwloc_utils_parse_cpuset_format(const char *string)
+{
+  if (!strcmp(string, "hwloc"))
+    return HWLOC_UTILS_CPUSET_FORMAT_HWLOC;
+  else if (!strcmp(string, "list"))
+    return HWLOC_UTILS_CPUSET_FORMAT_LIST;
+  else if (!strcmp(string, "taskset"))
+    return HWLOC_UTILS_CPUSET_FORMAT_TASKSET;
+  else
+    return HWLOC_UTILS_CPUSET_FORMAT_UNKNOWN;
+}
+
+static __hwloc_inline int
+hwloc_utils_cpuset_format_asprintf(char **string, hwloc_const_bitmap_t set,
+                                   enum hwloc_utils_cpuset_format_e cpuset_output_format)
+{
+  switch (cpuset_output_format) {
+  case HWLOC_UTILS_CPUSET_FORMAT_HWLOC: return hwloc_bitmap_asprintf(string, set);
+  case HWLOC_UTILS_CPUSET_FORMAT_TASKSET: return hwloc_bitmap_taskset_asprintf(string, set);
+  case HWLOC_UTILS_CPUSET_FORMAT_LIST: return hwloc_bitmap_list_asprintf(string, set);
+  default: abort();
+  }
+}
+
 static __hwloc_inline unsigned long
 hwloc_utils_parse_restrict_flags(char * str){
   struct hwloc_utils_parsing_flag possible_flags[] = {
diff -pruN 2.10.0-1/utils/hwloc/test-hwloc-calc.output 2.11.0-1/utils/hwloc/test-hwloc-calc.output
--- 2.10.0-1/utils/hwloc/test-hwloc-calc.output	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/test-hwloc-calc.output	2024-06-17 10:01:23.000000000 +0000
@@ -1,7 +1,10 @@
-# root
+# root --cpuset-output-format hwloc
 0xffffffff,0xffffffff
 
-# all --taskset
+# all --cof list
+0-63
+
+# all --cpuset-output-format taskset
 0xffffffffffffffff
 
 # hex
@@ -218,6 +221,24 @@ NUMANode:1
 8
 1,2
 
+# Converting from hwloc cpusets to taskset
+0xf000000f00000f00f
+0x10000000300000005
+0x10000000300000005
+0xf...f
+0xf...f00000001
+
+# Converting from list cpusets to hwloc
+0xf...f,0xfffffff8
+0x00000004,0x40000007,0xffffff98
+0x00000080
+0x0000002a
+
+# Converting from taskset cpusets to list
+0-3,12-15,36-39,64-67
+0-2,5-6,8,10,14,16-17,21,24
+8-
+
 # Reading from stdin
 Waiting for locations to process on stdin...
 0x00000001
@@ -228,3 +249,18 @@ Waiting for locations to process on stdi
 0x00000001,,0x0
 0xffffffff,0xffffffff
 
+# Reading infinite cpusets from stdin
+0xf...f
+0xf...f,0x00abcd00
+0xf...f,0x0000abcd,0x0000ef00
+0xf...f,0xffffff00
+0xf...f,0xffff0000,0xffff0000
+
+# Reading infinite cpusets from stdin and exporting to taskset
+Waiting for locations to process on stdin...
+0xf...f
+0xf...f00abcd00
+0xf...f0000abcd0000ef00
+0xf...fffffff00
+0xf...fffff0000ffff0000
+
diff -pruN 2.10.0-1/utils/hwloc/test-hwloc-calc.sh.in 2.11.0-1/utils/hwloc/test-hwloc-calc.sh.in
--- 2.10.0-1/utils/hwloc/test-hwloc-calc.sh.in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/test-hwloc-calc.sh.in	2024-06-17 10:01:23.000000000 +0000
@@ -3,7 +3,7 @@
 
 #
 # Copyright © 2009 CNRS
-# Copyright © 2009-2022 Inria.  All rights reserved.
+# Copyright © 2009-2024 Inria.  All rights reserved.
 # Copyright © 2009, 2011 Université Bordeaux
 # Copyright © 2014 Cisco Systems, Inc.  All rights reserved.
 # See COPYING in top-level directory.
@@ -37,11 +37,14 @@ file="$tmp/test-hwloc-calc.output"
 
 set -e
 (
-  echo "# root"
-  $calc --if synthetic --input "node:4 core:4 pu:4" root
+  echo "# root --cpuset-output-format hwloc"
+  $calc --if synthetic --input "node:4 core:4 pu:4" root --cpuset-output-format hwloc
   echo
-  echo "# all --taskset"
-  $calc --if synthetic --input "node:4 core:4 pu:4" all --taskset
+  echo "# all --cof list"
+  $calc --if synthetic --input "node:4 core:4 pu:4" all --cof list
+  echo
+  echo "# all --cpuset-output-format taskset"
+  $calc --if synthetic --input "node:4 core:4 pu:4" all --cpuset-output-format taskset
   echo
 
   echo "# hex"
@@ -275,6 +278,25 @@ set -e
   $calc -i "node:4 pu:4" --restrict-flags cpuless --restrict 0xff0 all -I numa --po
   echo
 
+  echo "# Converting from hwloc cpusets to taskset"
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cpuset-output-format taskset 0xf,0xf0,f00f
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cpuset-output-format taskset --cpuset-input-format hwloc 1,3,5
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cpuset-output-format taskset 1,3,5
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cpuset-output-format taskset --cif hwloc 0xf...f
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cof taskset 0xf...f,0x1
+  echo
+  echo "# Converting from list cpusets to hwloc"
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cpuset-output-format hwloc 3-
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cpuset-output-format hwloc 3-4,7-34,62,66
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cpuset-output-format hwloc --cpuset-input-format list 7
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cof hwloc --cif list 1,3,5
+  echo
+  echo "# Converting from taskset cpusets to list"
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cpuset-output-format list 0xf000000f00000f00f
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cpuset-output-format list --cif taskset 0x1234567
+  $calc --if synthetic --input "node:4 core:4 pu:4"  --cof list 0xf...f00
+  echo
+
   echo "# Reading from stdin"
   cat << EOF | $calc --if synthetic --input "node:4 core:4 pu:4"
 pu:0
@@ -286,6 +308,24 @@ node:0 node:3
 root
 EOF
   echo
+  echo "# Reading infinite cpusets from stdin"
+  cat << EOF | $calc --if synthetic --input "node:4 core:4 pu:4" -q
+  0xf...f
+0xf...f,abcd00
+0xf...f,abcd,ef00
+0xf...ff00
+0xf...fff0000ffff0000
+EOF
+  echo
+  echo "# Reading infinite cpusets from stdin and exporting to taskset"
+  cat << EOF | $calc --if synthetic --input "node:4 core:4 pu:4" --cpuset-output-format taskset
+  0xf...f
+0xf...f,abcd00
+0xf...f,abcd,ef00
+0xf...ff00
+0xf...fff0000ffff0000
+EOF
+  echo
 ) > "$file"
 @DIFF@ @HWLOC_DIFF_U@ @HWLOC_DIFF_W@ $srcdir/test-hwloc-calc.output "$file"
 rm -rf "$tmp"
diff -pruN 2.10.0-1/utils/hwloc/test-hwloc-distrib.output 2.11.0-1/utils/hwloc/test-hwloc-distrib.output
--- 2.10.0-1/utils/hwloc/test-hwloc-distrib.output	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/test-hwloc-distrib.output	2024-06-17 10:01:23.000000000 +0000
@@ -2,11 +2,11 @@
 0x0000000f
 0x000000f0
 
-# 4 sets out of 2 2 2
-0x00000003
-0x0000000c
-0x00000030
-0x000000c0
+# 4 sets out of 2 2 2, as lists
+0-1
+2-3
+4-5
+6-7
 
 # 8 sets out of 2 2 2
 0x00000001
diff -pruN 2.10.0-1/utils/hwloc/test-hwloc-distrib.sh.in 2.11.0-1/utils/hwloc/test-hwloc-distrib.sh.in
--- 2.10.0-1/utils/hwloc/test-hwloc-distrib.sh.in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/test-hwloc-distrib.sh.in	2024-06-17 10:01:23.000000000 +0000
@@ -3,7 +3,7 @@
 
 #
 # Copyright © 2009 CNRS
-# Copyright © 2009-2020 Inria.  All rights reserved.
+# Copyright © 2009-2024 Inria.  All rights reserved.
 # Copyright © 2009 Université Bordeaux
 # Copyright © 2014 Cisco Systems, Inc.  All rights reserved.
 # See COPYING in top-level directory.
@@ -38,8 +38,8 @@ set -e
   echo "# 2 sets out of 2 2 2"
   $distrib --if synthetic --input "2 2 2" 2
   echo
-  echo "# 4 sets out of 2 2 2"
-  $distrib --if synthetic --input "2 2 2" 4
+  echo "# 4 sets out of 2 2 2, as lists"
+  $distrib --if synthetic --input "2 2 2" --cof list 4
   echo
   echo "# 8 sets out of 2 2 2"
   $distrib --if synthetic --input "2 2 2" 8
diff -pruN 2.10.0-1/utils/hwloc/test-hwloc-info.output 2.11.0-1/utils/hwloc/test-hwloc-info.output
--- 2.10.0-1/utils/hwloc/test-hwloc-info.output	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/test-hwloc-info.output	2024-06-17 10:01:23.000000000 +0000
@@ -5,14 +5,19 @@ depth 0:           1 Machine (type #0)
    depth 3:        24 PU (type #3)
 Special depth -3:  2 NUMANode (type #13)
 
-# --topology
+# topology infos
+info Backend = Synthetic
+info SyntheticDescription = node:2 core:3 pu:4
+
+# topology infos --get-attr
+node:2 core:3 pu:4
+
+# levels support
 depth 0:           1 Machine (type #0)
  depth 1:          2 Group0 (type #12)
   depth 2:         6 Core (type #2)
    depth 3:        24 PU (type #3)
 Special depth -3:  2 NUMANode (type #13)
-
-# --support
 discovery:pu = 1
 discovery:disallowed_pu = 0
 discovery:numa = 1
@@ -42,13 +47,12 @@ membind:alloc_membind = 0
 membind:firsttouch_membind = 0
 membind:bind_membind = 0
 membind:interleave_membind = 0
+membind:weighted_interleave_membind = 0
 membind:nexttouch_membind = 0
 membind:migrate_membind = 0
 membind:get_area_memlocation = 0
 misc:imported_support = 0
 
-# --objects
-
 # Core range
 Core L#2
  type = Core
@@ -403,6 +407,10 @@ L1dCache:5
 L3Cache:1
 Package:2
 
+# Allowed cpuset of where NUMA is attached
+0x0000ff00
+0x0000ffff,0x0
+
 # Children of L2 and Core of Node, silent
 L1dCache:2
 L1dCache:3
diff -pruN 2.10.0-1/utils/hwloc/test-hwloc-info.sh.in 2.11.0-1/utils/hwloc/test-hwloc-info.sh.in
--- 2.10.0-1/utils/hwloc/test-hwloc-info.sh.in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/hwloc/test-hwloc-info.sh.in	2024-06-17 10:01:23.000000000 +0000
@@ -3,7 +3,7 @@
 
 #
 # Copyright © 2009 CNRS
-# Copyright © 2009-2023 Inria.  All rights reserved.
+# Copyright © 2009-2024 Inria.  All rights reserved.
 # Copyright © 2009 Université Bordeaux
 # Copyright © 2014 Cisco Systems, Inc.  All rights reserved.
 # See COPYING in top-level directory.
@@ -43,14 +43,14 @@ set -e
   echo "# (default)"
   $info --if synthetic --input "node:2 core:3 pu:4"
   echo
-  echo "# --topology"
-  $info --if synthetic --input "node:2 core:3 pu:4" --topology
+  echo "# topology infos"
+  $info --if synthetic --input "node:2 core:3 pu:4" topology | grep -v hwlocVersion | grep -v ProcessName
   echo
-  echo "# --support"
-  $info --if synthetic --input "node:2 core:3 pu:4" --support
+  echo "# topology infos --get-attr"
+  $info --if synthetic --input "node:2 core:3 pu:4" --get-attr "info SyntheticDescription" topology
   echo
-  echo "# --objects"
-  $info --if synthetic --input "node:2 core:3 pu:4" --objects
+  echo "# levels support"
+  $info --if synthetic --input "node:2 core:3 pu:4" levels support
   echo
 
   echo "# Core range"
@@ -81,6 +81,9 @@ set -e
   echo "# Where a NUMA is attached"
   $info --if synthetic --input "pack:4 [numa] l3:2 [numa] [numa] core:4 pu:2" --ancestor kind=normal --first -s numa:3 numa:14
   echo
+  echo "# Allowed cpuset of where NUMA is attached"
+  $info --if synthetic --input "pack:4 [numa] l3:2 [numa] [numa] core:4 pu:2" --ancestor kind=normal --first --get-attr "allowed cpuset" numa:3 numa:14
+  echo
 
   echo "# Children of L2 and Core of Node, silent"
   $info --if synthetic --input "node:2 core:2 l2:2 l1d:2 pu:2" --children -s l2:1 node:1.core:1
diff -pruN 2.10.0-1/utils/lstopo/lstopo-cairo.c 2.11.0-1/utils/lstopo/lstopo-cairo.c
--- 2.10.0-1/utils/lstopo/lstopo-cairo.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/lstopo/lstopo-cairo.c	2024-06-17 10:01:23.000000000 +0000
@@ -317,6 +317,7 @@ output_x11(struct lstopo_output *loutput
   struct lstopo_cairo_output *coutput;
   Display *dpy;
   Window root, top;
+  XClassHint *class_hint;
   int scr;
   Screen *screen;
   int screen_width, screen_height;
@@ -387,6 +388,12 @@ output_x11(struct lstopo_output *loutput
   disp->top = top = XCreateSimpleWindow(dpy, root, 0, 0, screen_width, screen_height, 0, WhitePixel(dpy, scr), WhitePixel(dpy, scr));
   XStoreName(dpy, top, loutput->title);
   XSetIconName(dpy, top, "lstopo");
+  class_hint = XAllocClassHint();
+  if (class_hint) {
+    class_hint->res_name = class_hint->res_class = (char *) "lstopo";
+    XSetClassHint(dpy, top, class_hint);
+    XFree(class_hint);
+  }
   XSelectInput(dpy,top, StructureNotifyMask | KeyPressMask);
 
   if (screen_width >= screen->width)
diff -pruN 2.10.0-1/utils/lstopo/lstopo-no-graphics.1in 2.11.0-1/utils/lstopo/lstopo-no-graphics.1in
--- 2.10.0-1/utils/lstopo/lstopo-no-graphics.1in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/lstopo/lstopo-no-graphics.1in	2024-06-17 10:01:23.000000000 +0000
@@ -1,5 +1,5 @@
 .\" -*- nroff -*-
-.\" Copyright © 2009-2023 Inria.  All rights reserved.
+.\" Copyright © 2009-2024 Inria.  All rights reserved.
 .\" Copyright © 2009-2010 Université of Bordeaux
 .\" Copyright © 2009-2010 Cisco Systems, Inc.  All rights reserved.
 .\" Copyright © 2020 Hewlett Packard Enterprise.  All rights reserved.
@@ -141,9 +141,14 @@ Display the cpuset of each object.
 Only display the cpuset of each object; do not display anything else
 about the object.
 .TP
-\fB\-\-taskset\fR
-Show CPU set strings in the format recognized by the taskset command-line
-program instead of hwloc-specific CPU set string format.
+\fB\-\-cpuset\-output\-format\fR <hwloc|list|taskset> \fB\-\-cof\fR <hwloc|list|taskset>
+Change the format of displayed CPU set strings.
+By default, the hwloc-specific format is used.
+If \fIlist\fR is given, the output is a comma-separated of numbers or ranges,
+e.g. 2,4-5,8 .
+If \fItaskset\fR is given, output cpusets are compatible with the taskset program
+(replaces the former \fB--taskset\fR option).
+
 This option should be combined with \fB\-\-cpuset\fR or \fB\-\-cpuset\-only\fR,
 otherwise it will imply \fB\-\-cpuset\fR.
 .TP
diff -pruN 2.10.0-1/utils/lstopo/lstopo-text.c 2.11.0-1/utils/lstopo/lstopo-text.c
--- 2.10.0-1/utils/lstopo/lstopo-text.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/lstopo/lstopo-text.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2022 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2012 Université Bordeaux
  * Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.
  * See COPYING in top-level directory.
@@ -116,10 +116,7 @@ output_console_obj (struct lstopo_output
     fprintf(output, " cpuset=");
   if (loutput->show_cpuset) {
     char *cpusetstr;
-    if (loutput->show_taskset)
-      hwloc_bitmap_taskset_asprintf(&cpusetstr, l->cpuset);
-    else
-      hwloc_bitmap_asprintf(&cpusetstr, l->cpuset);
+    hwloc_utils_cpuset_format_asprintf(&cpusetstr, l->cpuset, loutput->cpuset_output_format);
     fprintf(output, "%s", cpusetstr);
     free(cpusetstr);
   }
diff -pruN 2.10.0-1/utils/lstopo/lstopo.c 2.11.0-1/utils/lstopo/lstopo.c
--- 2.10.0-1/utils/lstopo/lstopo.c	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/lstopo/lstopo.c	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2012, 2015, 2017 Université Bordeaux
  * Copyright © 2009-2011 Cisco Systems, Inc.  All rights reserved.
  * Copyright © 2020 Hewlett Packard Enterprise.  All rights reserved.
@@ -573,7 +573,9 @@ void usage(const char *name, FILE *where
 #endif
   fprintf (where, "  -c --cpuset           Show the cpuset of each object\n");
   fprintf (where, "  -C --cpuset-only      Only show the cpuset of each object\n");
-  fprintf (where, "  --taskset             Show taskset-specific cpuset strings\n");
+  fprintf (where, "  --cpuset-output-format <hwloc|list|taskset>\n"
+                  "  --cof <hwloc|list|taskset>\n"
+                  "                        Change the format of cpuset outputs\n");
   fprintf (where, "Object filtering options:\n");
   fprintf (where, "  --filter <type>:<knd> Filter objects of the given type, or all.\n");
   fprintf (where, "     <knd> may be `all' (keep all), `none' (remove all), `structure' or `important'\n");
@@ -952,7 +954,7 @@ main (int argc, char *argv[])
   loutput.show_cpukinds_only = 0;
   loutput.show_windows_processor_groups_only = 0;
   loutput.show_cpuset = 0;
-  loutput.show_taskset = 0;
+  loutput.cpuset_output_format = HWLOC_UTILS_CPUSET_FORMAT_HWLOC;
   loutput.transform_distances = -1;
 
   loutput.nr_cpukind_styles = 0;
@@ -1063,8 +1065,22 @@ main (int argc, char *argv[])
 	loutput.show_cpuset = 1;
       else if (!strcmp (argv[0], "-C") || !strcmp (argv[0], "--cpuset-only"))
 	loutput.show_cpuset = 2;
+      else if (!strcmp(argv[0], "--cpuset-output-format") || !strcmp(argv[0], "--cof")) {
+        if (argc < 2) {
+          usage (callname, stderr);
+          exit(EXIT_FAILURE);
+        }
+        loutput.cpuset_output_format = hwloc_utils_parse_cpuset_format(argv[1]);
+        if (HWLOC_UTILS_CPUSET_FORMAT_UNKNOWN == loutput.cpuset_output_format) {
+          fprintf(stderr, "Unrecognized %s argument %s\n", argv[0], argv[1]);
+          goto out_usagefailure;
+        }
+        if (!loutput.show_cpuset)
+	  loutput.show_cpuset = 1;
+        opt = 1;
+      }
       else if (!strcmp (argv[0], "--taskset")) {
-	loutput.show_taskset = 1;
+	loutput.cpuset_output_format = HWLOC_UTILS_CPUSET_FORMAT_TASKSET;
 	if (!loutput.show_cpuset)
 	  loutput.show_cpuset = 1;
       } else if (!strcmp (argv[0], "--only")) {
diff -pruN 2.10.0-1/utils/lstopo/lstopo.h 2.11.0-1/utils/lstopo/lstopo.h
--- 2.10.0-1/utils/lstopo/lstopo.h	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/lstopo/lstopo.h	2024-06-17 10:01:23.000000000 +0000
@@ -1,6 +1,6 @@
 /*
  * Copyright © 2009 CNRS
- * Copyright © 2009-2023 Inria.  All rights reserved.
+ * Copyright © 2009-2024 Inria.  All rights reserved.
  * Copyright © 2009-2010, 2012, 2015 Université Bordeaux
  * Copyright © 2011 Cisco Systems, Inc.  All rights reserved.
  * Copyright © 2020 Hewlett Packard Enterprise.  All rights reserved.
@@ -103,7 +103,7 @@ struct lstopo_output {
   int show_windows_processor_groups_only;
   struct hwloc_calc_level show_only;
   int show_cpuset;
-  int show_taskset;
+  enum hwloc_utils_cpuset_format_e cpuset_output_format;
   int transform_distances;
 
   /* draw config */
diff -pruN 2.10.0-1/utils/lstopo/test-lstopo.sh.in 2.11.0-1/utils/lstopo/test-lstopo.sh.in
--- 2.10.0-1/utils/lstopo/test-lstopo.sh.in	2023-12-05 12:32:19.000000000 +0000
+++ 2.11.0-1/utils/lstopo/test-lstopo.sh.in	2024-06-17 10:01:23.000000000 +0000
@@ -3,7 +3,7 @@
 
 #
 # Copyright © 2009 CNRS
-# Copyright © 2009-2022 Inria.  All rights reserved.
+# Copyright © 2009-2024 Inria.  All rights reserved.
 # Copyright © 2009, 2011 Université Bordeaux
 # Copyright © 2020 Hewlett Packard Enterprise.  All rights reserved.
 # See COPYING in top-level directory.
@@ -51,7 +51,7 @@ $ls -v > $tmp/test.console_verbose
 echo "** Verbose with cpusets in $tmp/test.cpuset_verbose ..."
 $ls -c -v > $tmp/test.cpuset_verbose
 echo "** Verbose with taskset sets in $tmp/test.taskset ..."
-$ls --taskset -v > $tmp/test.taskset
+$ls --cpuset-output-format taskset -v > $tmp/test.taskset
 
 echo "** Merged topology in $tmp/test.merge ..."
 $ls --merge > $tmp/test.merge
